# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class ACSE_1:

    _name_  = 'ACSE-1'
    _oid_   = [2, 2, 0, 0, 1]
    
    _obj_ = [
        'acse-as-id',
        'aCSE-id',
        'ACSE-apdu',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-diagnostic',
        'ABRT-source',
        'ACSE-requirements',
        'Application-context-name-list',
        'Application-context-name',
        'AP-title',
        'AE-qualifier',
        'AP-title-form1',
        'AE-qualifier-form1',
        'AP-title-form2',
        'AE-qualifier-form2',
        'AE-title',
        'AE-title-form1',
        'AE-title-form2',
        'AE-invocation-identifier',
        'AP-invocation-identifier',
        'Associate-result',
        'Associate-source-diagnostic',
        'Association-information',
        'Authentication-value',
        'Implementation-data',
        'Mechanism-name',
        'MECHANISM-NAME',
        'ObjectSet',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _type_ = [
        'ACSE-apdu',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-diagnostic',
        'ABRT-source',
        'ACSE-requirements',
        'Application-context-name-list',
        'Application-context-name',
        'AP-title',
        'AE-qualifier',
        'AP-title-form1',
        'AE-qualifier-form1',
        'AP-title-form2',
        'AE-qualifier-form2',
        'AE-title',
        'AE-title-form1',
        'AE-title-form2',
        'AE-invocation-identifier',
        'AP-invocation-identifier',
        'Associate-result',
        'Associate-source-diagnostic',
        'Association-information',
        'Authentication-value',
        'Implementation-data',
        'Mechanism-name',
        'MECHANISM-NAME',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _set_ = [
        'ObjectSet',
        ]
    _val_ = [
        'acse-as-id',
        'aCSE-id',
        ]
    _class_ = [
        'MECHANISM-NAME',
        'ObjectSet',
        ]
    _param_ = [
        ]
    
    #-----< acse-as-id >-----#
    acse_as_id = OID(name='acse-as-id', mode=MODE_VALUE)
    acse_as_id._val = (2, 2, 1, 0, 1)
    
    #-----< aCSE-id >-----#
    aCSE_id = OID(name='aCSE-id', mode=MODE_VALUE)
    aCSE_id._val = (2, 2, 3, 1, 1)
    
    #-----< ACSE-apdu >-----#
    ACSE_apdu = CHOICE(name='ACSE-apdu', mode=MODE_TYPE)
    _ACSE_apdu_aarq = SEQ(name='aarq', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AARQ-apdu')))
    _ACSE_apdu_aare = SEQ(name='aare', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AARE-apdu')))
    _ACSE_apdu_rlrq = SEQ(name='rlrq', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'RLRQ-apdu')))
    _ACSE_apdu_rlre = SEQ(name='rlre', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'RLRE-apdu')))
    _ACSE_apdu_abrt = SEQ(name='abrt', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'ABRT-apdu')))
    ACSE_apdu._cont = ASN1Dict([
        ('aarq', _ACSE_apdu_aarq),
        ('aare', _ACSE_apdu_aare),
        ('rlrq', _ACSE_apdu_rlrq),
        ('rlre', _ACSE_apdu_rlre),
        ('abrt', _ACSE_apdu_abrt),
        ])
    ACSE_apdu._ext = []
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name='AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AARQ_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARQ_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARQ_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name')))
    _AARQ_apdu_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-title')), opt=True)
    _AARQ_apdu_called_AE_qualifier = CHOICE(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-qualifier')), opt=True)
    _AARQ_apdu_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-invocation-identifier')), opt=True)
    _AARQ_apdu_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-invocation-identifier')), opt=True)
    _AARQ_apdu_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-title')), opt=True)
    _AARQ_apdu_calling_AE_qualifier = CHOICE(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-qualifier')), opt=True)
    _AARQ_apdu_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-invocation-identifier')), opt=True)
    _AARQ_apdu_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-invocation-identifier')), opt=True)
    _AARQ_apdu_sender_acse_requirements = BIT_STR(name='sender-acse-requirements', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ACSE-requirements')), opt=True)
    _AARQ_apdu_mechanism_name = OID(name='mechanism-name', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Mechanism-name')), opt=True)
    _AARQ_apdu_calling_authentication_value = CHOICE(name='calling-authentication-value', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Authentication-value')), opt=True)
    _AARQ_apdu_application_context_name_list = SEQ_OF(name='application-context-name-list', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name-list')), opt=True)
    _AARQ_apdu_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Implementation-data')), opt=True)
    _AARQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    AARQ_apdu._cont = ASN1Dict([
        ('protocol-version', _AARQ_apdu_protocol_version),
        ('application-context-name', _AARQ_apdu_application_context_name),
        ('called-AP-title', _AARQ_apdu_called_AP_title),
        ('called-AE-qualifier', _AARQ_apdu_called_AE_qualifier),
        ('called-AP-invocation-identifier', _AARQ_apdu_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _AARQ_apdu_called_AE_invocation_identifier),
        ('calling-AP-title', _AARQ_apdu_calling_AP_title),
        ('calling-AE-qualifier', _AARQ_apdu_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _AARQ_apdu_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _AARQ_apdu_calling_AE_invocation_identifier),
        ('sender-acse-requirements', _AARQ_apdu_sender_acse_requirements),
        ('mechanism-name', _AARQ_apdu_mechanism_name),
        ('calling-authentication-value', _AARQ_apdu_calling_authentication_value),
        ('application-context-name-list', _AARQ_apdu_application_context_name_list),
        ('implementation-information', _AARQ_apdu_implementation_information),
        ('user-information', _AARQ_apdu_user_information),
        ])
    AARQ_apdu._ext = ['user-information']
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name='AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _AARE_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARE_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARE_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name')))
    _AARE_apdu_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Associate-result')))
    _AARE_apdu_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Associate-source-diagnostic')))
    _AARE_apdu_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-title')), opt=True)
    _AARE_apdu_responding_AE_qualifier = CHOICE(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-qualifier')), opt=True)
    _AARE_apdu_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-invocation-identifier')), opt=True)
    _AARE_apdu_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-invocation-identifier')), opt=True)
    _AARE_apdu_responder_acse_requirements = BIT_STR(name='responder-acse-requirements', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ACSE-requirements')), opt=True)
    _AARE_apdu_mechanism_name = OID(name='mechanism-name', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Mechanism-name')), opt=True)
    _AARE_apdu_responding_authentication_value = CHOICE(name='responding-authentication-value', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Authentication-value')), opt=True)
    _AARE_apdu_application_context_name_list = SEQ_OF(name='application-context-name-list', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name-list')), opt=True)
    _AARE_apdu_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Implementation-data')), opt=True)
    _AARE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    AARE_apdu._cont = ASN1Dict([
        ('protocol-version', _AARE_apdu_protocol_version),
        ('application-context-name', _AARE_apdu_application_context_name),
        ('result', _AARE_apdu_result),
        ('result-source-diagnostic', _AARE_apdu_result_source_diagnostic),
        ('responding-AP-title', _AARE_apdu_responding_AP_title),
        ('responding-AE-qualifier', _AARE_apdu_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _AARE_apdu_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _AARE_apdu_responding_AE_invocation_identifier),
        ('responder-acse-requirements', _AARE_apdu_responder_acse_requirements),
        ('mechanism-name', _AARE_apdu_mechanism_name),
        ('responding-authentication-value', _AARE_apdu_responding_authentication_value),
        ('application-context-name-list', _AARE_apdu_application_context_name_list),
        ('implementation-information', _AARE_apdu_implementation_information),
        ('user-information', _AARE_apdu_user_information),
        ])
    AARE_apdu._ext = ['user-information']
    
    #-----< RLRQ-apdu >-----#
    RLRQ_apdu = SEQ(name='RLRQ-apdu', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRQ_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Release-request-reason')), opt=True)
    _RLRQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    RLRQ_apdu._cont = ASN1Dict([
        ('reason', _RLRQ_apdu_reason),
        ('user-information', _RLRQ_apdu_user_information),
        ])
    RLRQ_apdu._ext = ['user-information']
    
    #-----< RLRE-apdu >-----#
    RLRE_apdu = SEQ(name='RLRE-apdu', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRE_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Release-response-reason')), opt=True)
    _RLRE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    RLRE_apdu._cont = ASN1Dict([
        ('reason', _RLRE_apdu_reason),
        ('user-information', _RLRE_apdu_user_information),
        ])
    RLRE_apdu._ext = ['user-information']
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name='ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name='abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ABRT-source')))
    _ABRT_apdu_abort_diagnostic = ENUM(name='abort-diagnostic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ABRT-diagnostic')), opt=True)
    _ABRT_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    ABRT_apdu._cont = ASN1Dict([
        ('abort-source', _ABRT_apdu_abort_source),
        ('abort-diagnostic', _ABRT_apdu_abort_diagnostic),
        ('user-information', _ABRT_apdu_user_information),
        ])
    ABRT_apdu._ext = ['user-information']
    
    #-----< ABRT-diagnostic >-----#
    ABRT_diagnostic = ENUM(name='ABRT-diagnostic', mode=MODE_TYPE)
    ABRT_diagnostic._cont = ASN1Dict([('no-reason-given', 1), ('protocol-error', 2), ('authentication-mechanism-name-not-recognized', 3), ('authentication-mechanism-name-required', 4), ('authentication-failure', 5), ('authentication-required', 6)])
    ABRT_diagnostic._ext = []
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name='ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([('acse-service-user', 0), ('acse-service-provider', 1)])
    ABRT_source._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=[], er=[])
    
    #-----< ACSE-requirements >-----#
    ACSE_requirements = BIT_STR(name='ACSE-requirements', mode=MODE_TYPE)
    ACSE_requirements._cont = ASN1Dict([('authentication', 0), ('application-context-negotiation', 1)])
    
    #-----< Application-context-name-list >-----#
    Application_context_name_list = SEQ_OF(name='Application-context-name-list', mode=MODE_TYPE)
    _Application_context_name_list__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'Application-context-name')))
    Application_context_name_list._cont = _Application_context_name_list__item_
    
    #-----< Application-context-name >-----#
    Application_context_name = OID(name='Application-context-name', mode=MODE_TYPE)
    
    #-----< AP-title >-----#
    AP_title = CHOICE(name='AP-title', mode=MODE_TYPE)
    _AP_title_ap_title_form1 = CHOICE(name='ap-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AP-title-form1')))
    _AP_title_ap_title_form2 = OID(name='ap-title-form2', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AP-title-form2')))
    AP_title._cont = ASN1Dict([
        ('ap-title-form1', _AP_title_ap_title_form1),
        ('ap-title-form2', _AP_title_ap_title_form2),
        ])
    AP_title._ext = []
    
    #-----< AE-qualifier >-----#
    AE_qualifier = CHOICE(name='AE-qualifier', mode=MODE_TYPE)
    _AE_qualifier_ae_qualifier_form1 = SET_OF(name='ae-qualifier-form1', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-qualifier-form1')))
    _AE_qualifier_ae_qualifier_form2 = INT(name='ae-qualifier-form2', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-qualifier-form2')))
    AE_qualifier._cont = ASN1Dict([
        ('ae-qualifier-form1', _AE_qualifier_ae_qualifier_form1),
        ('ae-qualifier-form2', _AE_qualifier_ae_qualifier_form2),
        ])
    AE_qualifier._ext = []
    
    #-----< AP-title-form1 >-----#
    AP_title_form1 = CHOICE(name='AP-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    
    #-----< AE-qualifier-form1 >-----#
    AE_qualifier_form1 = SET_OF(name='AE-qualifier-form1', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    
    #-----< AP-title-form2 >-----#
    AP_title_form2 = OID(name='AP-title-form2', mode=MODE_TYPE)
    
    #-----< AE-qualifier-form2 >-----#
    AE_qualifier_form2 = INT(name='AE-qualifier-form2', mode=MODE_TYPE)
    
    #-----< AE-title >-----#
    AE_title = CHOICE(name='AE-title', mode=MODE_TYPE)
    _AE_title_ae_title_form1 = CHOICE(name='ae-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title-form1')))
    _AE_title_ae_title_form2 = OID(name='ae-title-form2', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title-form2')))
    AE_title._cont = ASN1Dict([
        ('ae-title-form1', _AE_title_ae_title_form1),
        ('ae-title-form2', _AE_title_ae_title_form2),
        ])
    AE_title._ext = []
    
    #-----< AE-title-form1 >-----#
    AE_title_form1 = CHOICE(name='AE-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    
    #-----< AE-title-form2 >-----#
    AE_title_form2 = OID(name='AE-title-form2', mode=MODE_TYPE)
    
    #-----< AE-invocation-identifier >-----#
    AE_invocation_identifier = INT(name='AE-invocation-identifier', mode=MODE_TYPE)
    
    #-----< AP-invocation-identifier >-----#
    AP_invocation_identifier = INT(name='AP-invocation-identifier', mode=MODE_TYPE)
    
    #-----< Associate-result >-----#
    Associate_result = INT(name='Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([('accepted', 0), ('rejected-permanent', 1), ('rejected-transient', 2)])
    Associate_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name='Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_acse_service_user = INT(name='acse-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_user._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('application-context-name-not-supported', 2), ('calling-AP-title-not-recognized', 3), ('calling-AP-invocation-identifier-not-recognized', 4), ('calling-AE-qualifier-not-recognized', 5), ('calling-AE-invocation-identifier-not-recognized', 6), ('called-AP-title-not-recognized', 7), ('called-AP-invocation-identifier-not-recognized', 8), ('called-AE-qualifier-not-recognized', 9), ('called-AE-invocation-identifier-not-recognized', 10), ('authentication-mechanism-name-not-recognized', 11), ('authentication-mechanism-name-required', 12), ('authentication-failure', 13), ('authentication-required', 14)])
    _Associate_source_diagnostic_acse_service_user._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=[], er=[])
    _Associate_source_diagnostic_acse_service_provider = INT(name='acse-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_provider._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('no-common-acse-version', 2)])
    _Associate_source_diagnostic_acse_service_provider._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    Associate_source_diagnostic._cont = ASN1Dict([
        ('acse-service-user', _Associate_source_diagnostic_acse_service_user),
        ('acse-service-provider', _Associate_source_diagnostic_acse_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< Association-information >-----#
    Association_information = SEQ_OF(name='Association-information', mode=MODE_TYPE)
    _Association_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    Association_information._cont = _Association_information__item_
    Association_information._const_sz = ASN1Set(rv=[1], rr=[], ev=[0], er=[ASN1RangeInt(lb=2, ub=None)])
    
    #-----< Authentication-value >-----#
    Authentication_value = CHOICE(name='Authentication-value', mode=MODE_TYPE)
    _Authentication_value_charstring = STR_GRAPH(name='charstring', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Authentication_value_bitstring = BIT_STR(name='bitstring', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Authentication_value_external = EXT(name='external', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _Authentication_value_other = SEQ(name='other', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Authentication_value_other_other_mechanism_name = OID(name='other-mechanism-name', mode=MODE_TYPE, typeref=ASN1RefClassField(('ACSE-1', 'MECHANISM-NAME'), ['id']))
    ___Authentication_value_other_other_mechanism_name_tab = CLASS(name='_tab_MECHANISM-NAME', mode=MODE_SET, typeref=ASN1RefType(('ACSE-1', 'MECHANISM-NAME')))
    ___Authentication_value_other_other_mechanism_name_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Authentication_value_other_other_mechanism_name._const_tab = ___Authentication_value_other_other_mechanism_name_tab
    __Authentication_value_other_other_mechanism_name._const_tab_at = None
    __Authentication_value_other_other_mechanism_name._const_tab_id = 'id'
    __Authentication_value_other_other_mechanism_value = OPEN(name='other-mechanism-value', mode=MODE_TYPE, typeref=ASN1RefClassField(('ACSE-1', 'MECHANISM-NAME'), ['Type']))
    ___Authentication_value_other_other_mechanism_value_tab = CLASS(name='_tab_MECHANISM-NAME', mode=MODE_SET, typeref=ASN1RefType(('ACSE-1', 'MECHANISM-NAME')))
    ___Authentication_value_other_other_mechanism_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Authentication_value_other_other_mechanism_value._const_tab = ___Authentication_value_other_other_mechanism_value_tab
    __Authentication_value_other_other_mechanism_value._const_tab_at = ('..', 'other-mechanism-name')
    __Authentication_value_other_other_mechanism_value._const_tab_id = 'Type'
    _Authentication_value_other._cont = ASN1Dict([
        ('other-mechanism-name', __Authentication_value_other_other_mechanism_name),
        ('other-mechanism-value', __Authentication_value_other_other_mechanism_value),
        ])
    _Authentication_value_other._ext = None
    Authentication_value._cont = ASN1Dict([
        ('charstring', _Authentication_value_charstring),
        ('bitstring', _Authentication_value_bitstring),
        ('external', _Authentication_value_external),
        ('other', _Authentication_value_other),
        ])
    Authentication_value._ext = None
    
    #-----< Implementation-data >-----#
    Implementation_data = STR_GRAPH(name='Implementation-data', mode=MODE_TYPE)
    
    #-----< Mechanism-name >-----#
    Mechanism_name = OID(name='Mechanism-name', mode=MODE_TYPE)
    
    #-----< MECHANISM-NAME >-----#
    MECHANISM_NAME = CLASS(name='MECHANISM-NAME', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< ObjectSet >-----#
    ObjectSet = CLASS(name='ObjectSet', mode=MODE_SET, typeref=ASN1RefType(('ACSE-1', 'MECHANISM-NAME')))
    ObjectSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name='Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([('normal', 0), ('urgent', 1), ('user-defined', 30)])
    Release_request_reason._const_val = ASN1Set(rv=[0, 1, 30], rr=[], ev=[], er=[])
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name='Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([('normal', 0), ('not-finished', 1), ('user-defined', 30)])
    Release_response_reason._const_val = ASN1Set(rv=[0, 1, 30], rr=[], ev=[], er=[])
    
    _all_ = [
        acse_as_id,
        aCSE_id,
        _ACSE_apdu_aarq,
        _ACSE_apdu_aare,
        _ACSE_apdu_rlrq,
        _ACSE_apdu_rlre,
        _ACSE_apdu_abrt,
        ACSE_apdu,
        _AARQ_apdu_protocol_version,
        _AARQ_apdu_application_context_name,
        _AARQ_apdu_called_AP_title,
        _AARQ_apdu_called_AE_qualifier,
        _AARQ_apdu_called_AP_invocation_identifier,
        _AARQ_apdu_called_AE_invocation_identifier,
        _AARQ_apdu_calling_AP_title,
        _AARQ_apdu_calling_AE_qualifier,
        _AARQ_apdu_calling_AP_invocation_identifier,
        _AARQ_apdu_calling_AE_invocation_identifier,
        _AARQ_apdu_sender_acse_requirements,
        _AARQ_apdu_mechanism_name,
        _AARQ_apdu_calling_authentication_value,
        _AARQ_apdu_application_context_name_list,
        _AARQ_apdu_implementation_information,
        _AARQ_apdu_user_information,
        AARQ_apdu,
        _AARE_apdu_protocol_version,
        _AARE_apdu_application_context_name,
        _AARE_apdu_result,
        _AARE_apdu_result_source_diagnostic,
        _AARE_apdu_responding_AP_title,
        _AARE_apdu_responding_AE_qualifier,
        _AARE_apdu_responding_AP_invocation_identifier,
        _AARE_apdu_responding_AE_invocation_identifier,
        _AARE_apdu_responder_acse_requirements,
        _AARE_apdu_mechanism_name,
        _AARE_apdu_responding_authentication_value,
        _AARE_apdu_application_context_name_list,
        _AARE_apdu_implementation_information,
        _AARE_apdu_user_information,
        AARE_apdu,
        _RLRQ_apdu_reason,
        _RLRQ_apdu_user_information,
        RLRQ_apdu,
        _RLRE_apdu_reason,
        _RLRE_apdu_user_information,
        RLRE_apdu,
        _ABRT_apdu_abort_source,
        _ABRT_apdu_abort_diagnostic,
        _ABRT_apdu_user_information,
        ABRT_apdu,
        ABRT_diagnostic,
        ABRT_source,
        ACSE_requirements,
        _Application_context_name_list__item_,
        Application_context_name_list,
        Application_context_name,
        _AP_title_ap_title_form1,
        _AP_title_ap_title_form2,
        AP_title,
        _AE_qualifier_ae_qualifier_form1,
        _AE_qualifier_ae_qualifier_form2,
        AE_qualifier,
        AP_title_form1,
        AE_qualifier_form1,
        AP_title_form2,
        AE_qualifier_form2,
        _AE_title_ae_title_form1,
        _AE_title_ae_title_form2,
        AE_title,
        AE_title_form1,
        AE_title_form2,
        AE_invocation_identifier,
        AP_invocation_identifier,
        Associate_result,
        _Associate_source_diagnostic_acse_service_user,
        _Associate_source_diagnostic_acse_service_provider,
        Associate_source_diagnostic,
        _Association_information__item_,
        Association_information,
        _Authentication_value_charstring,
        _Authentication_value_bitstring,
        _Authentication_value_external,
        ___Authentication_value_other_other_mechanism_name_tab,
        __Authentication_value_other_other_mechanism_name,
        ___Authentication_value_other_other_mechanism_value_tab,
        __Authentication_value_other_other_mechanism_value,
        _Authentication_value_other,
        Authentication_value,
        Implementation_data,
        Mechanism_name,
        MECHANISM_NAME,
        ObjectSet,
        Release_request_reason,
        Release_response_reason,
    ]

class Attribute_ASN1Module:

    _name_  = 'Attribute-ASN1Module'
    _oid_   = [2, 9, 3, 2, 2, 1]
    
    _obj_ = [
        'smi2AttributeID',
        'smi2AttributeGroup',
        'DMI-TYPE-IDENTIFIER',
        'arfProbableCause',
        'adapterError',
        'applicationSubsystemFailure',
        'bandwidthReduced',
        'callEstablishmentError',
        'communicationsProtocolError',
        'communicationsSubsystemFailure',
        'configurationOrCustomizationError',
        'congestion',
        'corruptData',
        'cpuCyclesLimitExceeded',
        'dataSetOrModemError',
        'degradedSignal',
        'dTE-DCEInterfaceError',
        'enclosureDoorOpen',
        'equipmentMalfunction',
        'excessiveVibration',
        'fileError',
        'fireDetected',
        'floodDetected',
        'framingError',
        'heatingOrVentilationOrCoolingSystemProblem',
        'humidityUnacceptable',
        'inputOutputDeviceError',
        'inputDeviceError',
        'lANError',
        'leakDetected',
        'localNodeTransmissionError',
        'lossOfFrame',
        'lossOfSignal',
        'materialSupplyExhausted',
        'multiplexerProblem',
        'outOfMemory',
        'ouputDeviceError',
        'performanceDegraded',
        'powerProblem',
        'pressureUnacceptable',
        'processorProblem',
        'pumpFailure',
        'queueSizeExceeded',
        'receiveFailure',
        'receiverFailure',
        'remoteNodeTransmissionError',
        'resourceAtOrNearingCapacity',
        'responseTimeExcessive',
        'retransmissionRateExcessive',
        'softwareError',
        'softwareProgramAbnormallyTerminated',
        'softwareProgramError',
        'storageCapacityProblem',
        'temperatureUnacceptable',
        'thresholdCrossed',
        'timingProblem',
        'toxicLeakDetected',
        'transmitFailure',
        'transmitterFailure',
        'underlyingResourceUnavailable',
        'versionMismatch',
        'arfProposedRepairAction',
        'noActionRequired',
        'repairActionRequired',
        'securityAlarmCause',
        'authenticationFailure',
        'breachOfConfidentiality',
        'cableTamper',
        'delayedInformation',
        'denialOfService',
        'duplicateInformation',
        'informationMissing',
        'informationModificationDetected',
        'informationOutOfSequence',
        'intrusionDetection',
        'keyExpired',
        'nonRepudiationFailure',
        'outOfHoursActivity',
        'outOfService',
        'proceduralError',
        'unauthorizedAccessAttempt',
        'unexpectedInformation',
        'unspecifiedReason',
        'defaultIntervalsOfDay',
        'defaultStopTime',
        'defaultWeekMask',
        'defaultDiscriminatorConstruct',
        'ActiveDestination',
        'AdditionalText',
        'AdditionalInformation',
        'Allomorphs',
        'AdministrativeState',
        'AttributeIdentifierList',
        'AttributeList',
        'AttributeValueChangeDefinition',
        'AlarmStatus',
        'AvailabilityStatus',
        'BackedUpStatus',
        'BackUpDestinationList',
        'BackUpRelationshipObject',
        'CapacityAlarmThreshold',
        'ConfirmedMode',
        'ControlStatus',
        'Count',
        'CounterThreshold',
        'CorrelatedNotifications',
        'CurrentLogSize',
        'Destination',
        'DiscriminatorConstruct',
        'EventTime',
        'GaugeThreshold',
        'GaugeThresholdValue',
        'GroupObjects',
        'IntervalsOfDay',
        'LifecycleState',
        'LogAvailability',
        'LogFullAction',
        'LoggingTime',
        'LogRecordId',
        'MaxLogSize',
        'DMI-EXTENSION',
        'ManagementExtension',
        'ManagementExtensionSet',
        'MonitoredAttributes',
        'NameBinding',
        'NotificationIdentifier',
        'NotifyThreshold',
        'NumberOfRecords',
        'ObservedValue',
        'OperationalState',
        'Packages',
        'PerceivedSeverity',
        'PrioritisedObject',
        'ProbableCause',
        'ProceduralStatus',
        'ProposedRepairActions',
        'SchedulingAvailability',
        'SecurityAlarmCause',
        'SecurityAlarmSeverity',
        'SecurityAlarmDetector',
        'ServiceProvider',
        'DMI-SERVICEUSER',
        'ServiceUser',
        'ServiceUserSet',
        'SimpleNameType',
        'SpecificIdentifier',
        'SourceIndicator',
        'SpecificProblems',
        'StandbyStatus',
        'StartTime',
        'StopTime',
        'DMI-SUPPORTEDFEATURES',
        'SupportedFeatures',
        'SupportedFeaturesSet',
        'SystemId',
        'SystemTitle',
        'TideMarkInfo',
        'TideMark',
        'Time24',
        'ThresholdInfo',
        'ThresholdLevelInd',
        'TrendIndication',
        'UnknownStatus',
        'UnscheduledLogAvailability',
        'UsageState',
        'WeekMask',
        ]
    _type_ = [
        'DMI-TYPE-IDENTIFIER',
        'ActiveDestination',
        'AdditionalText',
        'AdditionalInformation',
        'Allomorphs',
        'AdministrativeState',
        'AttributeIdentifierList',
        'AttributeList',
        'AttributeValueChangeDefinition',
        'AlarmStatus',
        'AvailabilityStatus',
        'BackedUpStatus',
        'BackUpDestinationList',
        'BackUpRelationshipObject',
        'CapacityAlarmThreshold',
        'ConfirmedMode',
        'ControlStatus',
        'Count',
        'CounterThreshold',
        'CorrelatedNotifications',
        'CurrentLogSize',
        'Destination',
        'DiscriminatorConstruct',
        'EventTime',
        'GaugeThreshold',
        'GaugeThresholdValue',
        'GroupObjects',
        'IntervalsOfDay',
        'LifecycleState',
        'LogAvailability',
        'LogFullAction',
        'LoggingTime',
        'LogRecordId',
        'MaxLogSize',
        'DMI-EXTENSION',
        'ManagementExtension',
        'MonitoredAttributes',
        'NameBinding',
        'NotificationIdentifier',
        'NotifyThreshold',
        'NumberOfRecords',
        'ObservedValue',
        'OperationalState',
        'Packages',
        'PerceivedSeverity',
        'PrioritisedObject',
        'ProbableCause',
        'ProceduralStatus',
        'ProposedRepairActions',
        'SchedulingAvailability',
        'SecurityAlarmCause',
        'SecurityAlarmSeverity',
        'SecurityAlarmDetector',
        'ServiceProvider',
        'DMI-SERVICEUSER',
        'ServiceUser',
        'SimpleNameType',
        'SpecificIdentifier',
        'SourceIndicator',
        'SpecificProblems',
        'StandbyStatus',
        'StartTime',
        'StopTime',
        'DMI-SUPPORTEDFEATURES',
        'SupportedFeatures',
        'SystemId',
        'SystemTitle',
        'TideMarkInfo',
        'TideMark',
        'Time24',
        'ThresholdInfo',
        'ThresholdLevelInd',
        'TrendIndication',
        'UnknownStatus',
        'UnscheduledLogAvailability',
        'UsageState',
        'WeekMask',
        ]
    _set_ = [
        'ManagementExtensionSet',
        'ServiceUserSet',
        'SupportedFeaturesSet',
        ]
    _val_ = [
        'smi2AttributeID',
        'smi2AttributeGroup',
        'arfProbableCause',
        'adapterError',
        'applicationSubsystemFailure',
        'bandwidthReduced',
        'callEstablishmentError',
        'communicationsProtocolError',
        'communicationsSubsystemFailure',
        'configurationOrCustomizationError',
        'congestion',
        'corruptData',
        'cpuCyclesLimitExceeded',
        'dataSetOrModemError',
        'degradedSignal',
        'dTE-DCEInterfaceError',
        'enclosureDoorOpen',
        'equipmentMalfunction',
        'excessiveVibration',
        'fileError',
        'fireDetected',
        'floodDetected',
        'framingError',
        'heatingOrVentilationOrCoolingSystemProblem',
        'humidityUnacceptable',
        'inputOutputDeviceError',
        'inputDeviceError',
        'lANError',
        'leakDetected',
        'localNodeTransmissionError',
        'lossOfFrame',
        'lossOfSignal',
        'materialSupplyExhausted',
        'multiplexerProblem',
        'outOfMemory',
        'ouputDeviceError',
        'performanceDegraded',
        'powerProblem',
        'pressureUnacceptable',
        'processorProblem',
        'pumpFailure',
        'queueSizeExceeded',
        'receiveFailure',
        'receiverFailure',
        'remoteNodeTransmissionError',
        'resourceAtOrNearingCapacity',
        'responseTimeExcessive',
        'retransmissionRateExcessive',
        'softwareError',
        'softwareProgramAbnormallyTerminated',
        'softwareProgramError',
        'storageCapacityProblem',
        'temperatureUnacceptable',
        'thresholdCrossed',
        'timingProblem',
        'toxicLeakDetected',
        'transmitFailure',
        'transmitterFailure',
        'underlyingResourceUnavailable',
        'versionMismatch',
        'arfProposedRepairAction',
        'noActionRequired',
        'repairActionRequired',
        'securityAlarmCause',
        'authenticationFailure',
        'breachOfConfidentiality',
        'cableTamper',
        'delayedInformation',
        'denialOfService',
        'duplicateInformation',
        'informationMissing',
        'informationModificationDetected',
        'informationOutOfSequence',
        'intrusionDetection',
        'keyExpired',
        'nonRepudiationFailure',
        'outOfHoursActivity',
        'outOfService',
        'proceduralError',
        'unauthorizedAccessAttempt',
        'unexpectedInformation',
        'unspecifiedReason',
        'defaultIntervalsOfDay',
        'defaultStopTime',
        'defaultWeekMask',
        'defaultDiscriminatorConstruct',
        ]
    _class_ = [
        'DMI-TYPE-IDENTIFIER',
        'DMI-EXTENSION',
        'ManagementExtensionSet',
        'DMI-SERVICEUSER',
        'ServiceUserSet',
        'DMI-SUPPORTEDFEATURES',
        'SupportedFeaturesSet',
        ]
    _param_ = [
        ]
    
    #-----< smi2AttributeID >-----#
    smi2AttributeID = OID(name='smi2AttributeID', mode=MODE_VALUE)
    smi2AttributeID._val = (2, 9, 3, 2, 7)
    
    #-----< smi2AttributeGroup >-----#
    smi2AttributeGroup = OID(name='smi2AttributeGroup', mode=MODE_VALUE)
    smi2AttributeGroup._val = (2, 9, 3, 2, 8)
    
    #-----< DMI-TYPE-IDENTIFIER >-----#
    DMI_TYPE_IDENTIFIER = CLASS(name='DMI-TYPE-IDENTIFIER', mode=MODE_TYPE)
    _DMI_TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _DMI_TYPE_IDENTIFIER_Value = OPEN(name='Value', mode=MODE_TYPE)
    DMI_TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _DMI_TYPE_IDENTIFIER_id),
        ('Value', _DMI_TYPE_IDENTIFIER_Value),
        ])
    
    #-----< arfProbableCause >-----#
    arfProbableCause = OID(name='arfProbableCause', mode=MODE_VALUE)
    arfProbableCause._val = (2, 9, 3, 2, 0, 0)
    
    #-----< adapterError >-----#
    adapterError = CHOICE(name='adapterError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    adapterError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 1))
    
    #-----< applicationSubsystemFailure >-----#
    applicationSubsystemFailure = CHOICE(name='applicationSubsystemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    applicationSubsystemFailure._val = ('globalValue', (2, 9, 3, 2, 0, 0, 2))
    
    #-----< bandwidthReduced >-----#
    bandwidthReduced = CHOICE(name='bandwidthReduced', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    bandwidthReduced._val = ('globalValue', (2, 9, 3, 2, 0, 0, 3))
    
    #-----< callEstablishmentError >-----#
    callEstablishmentError = CHOICE(name='callEstablishmentError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    callEstablishmentError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 4))
    
    #-----< communicationsProtocolError >-----#
    communicationsProtocolError = CHOICE(name='communicationsProtocolError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    communicationsProtocolError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 5))
    
    #-----< communicationsSubsystemFailure >-----#
    communicationsSubsystemFailure = CHOICE(name='communicationsSubsystemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    communicationsSubsystemFailure._val = ('globalValue', (2, 9, 3, 2, 0, 0, 6))
    
    #-----< configurationOrCustomizationError >-----#
    configurationOrCustomizationError = CHOICE(name='configurationOrCustomizationError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    configurationOrCustomizationError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 7))
    
    #-----< congestion >-----#
    congestion = CHOICE(name='congestion', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    congestion._val = ('globalValue', (2, 9, 3, 2, 0, 0, 8))
    
    #-----< corruptData >-----#
    corruptData = CHOICE(name='corruptData', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    corruptData._val = ('globalValue', (2, 9, 3, 2, 0, 0, 9))
    
    #-----< cpuCyclesLimitExceeded >-----#
    cpuCyclesLimitExceeded = CHOICE(name='cpuCyclesLimitExceeded', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    cpuCyclesLimitExceeded._val = ('globalValue', (2, 9, 3, 2, 0, 0, 10))
    
    #-----< dataSetOrModemError >-----#
    dataSetOrModemError = CHOICE(name='dataSetOrModemError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    dataSetOrModemError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 11))
    
    #-----< degradedSignal >-----#
    degradedSignal = CHOICE(name='degradedSignal', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    degradedSignal._val = ('globalValue', (2, 9, 3, 2, 0, 0, 12))
    
    #-----< dTE-DCEInterfaceError >-----#
    dTE_DCEInterfaceError = CHOICE(name='dTE-DCEInterfaceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    dTE_DCEInterfaceError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 13))
    
    #-----< enclosureDoorOpen >-----#
    enclosureDoorOpen = CHOICE(name='enclosureDoorOpen', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    enclosureDoorOpen._val = ('globalValue', (2, 9, 3, 2, 0, 0, 14))
    
    #-----< equipmentMalfunction >-----#
    equipmentMalfunction = CHOICE(name='equipmentMalfunction', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    equipmentMalfunction._val = ('globalValue', (2, 9, 3, 2, 0, 0, 15))
    
    #-----< excessiveVibration >-----#
    excessiveVibration = CHOICE(name='excessiveVibration', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    excessiveVibration._val = ('globalValue', (2, 9, 3, 2, 0, 0, 16))
    
    #-----< fileError >-----#
    fileError = CHOICE(name='fileError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    fileError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 17))
    
    #-----< fireDetected >-----#
    fireDetected = CHOICE(name='fireDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    fireDetected._val = ('globalValue', (2, 9, 3, 2, 0, 0, 18))
    
    #-----< floodDetected >-----#
    floodDetected = CHOICE(name='floodDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    floodDetected._val = ('globalValue', (2, 9, 3, 2, 0, 0, 19))
    
    #-----< framingError >-----#
    framingError = CHOICE(name='framingError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    framingError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 20))
    
    #-----< heatingOrVentilationOrCoolingSystemProblem >-----#
    heatingOrVentilationOrCoolingSystemProblem = CHOICE(name='heatingOrVentilationOrCoolingSystemProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    heatingOrVentilationOrCoolingSystemProblem._val = ('globalValue', (2, 9, 3, 2, 0, 0, 21))
    
    #-----< humidityUnacceptable >-----#
    humidityUnacceptable = CHOICE(name='humidityUnacceptable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    humidityUnacceptable._val = ('globalValue', (2, 9, 3, 2, 0, 0, 22))
    
    #-----< inputOutputDeviceError >-----#
    inputOutputDeviceError = CHOICE(name='inputOutputDeviceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    inputOutputDeviceError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 23))
    
    #-----< inputDeviceError >-----#
    inputDeviceError = CHOICE(name='inputDeviceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    inputDeviceError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 24))
    
    #-----< lANError >-----#
    lANError = CHOICE(name='lANError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    lANError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 25))
    
    #-----< leakDetected >-----#
    leakDetected = CHOICE(name='leakDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    leakDetected._val = ('globalValue', (2, 9, 3, 2, 0, 0, 26))
    
    #-----< localNodeTransmissionError >-----#
    localNodeTransmissionError = CHOICE(name='localNodeTransmissionError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    localNodeTransmissionError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 27))
    
    #-----< lossOfFrame >-----#
    lossOfFrame = CHOICE(name='lossOfFrame', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    lossOfFrame._val = ('globalValue', (2, 9, 3, 2, 0, 0, 28))
    
    #-----< lossOfSignal >-----#
    lossOfSignal = CHOICE(name='lossOfSignal', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    lossOfSignal._val = ('globalValue', (2, 9, 3, 2, 0, 0, 29))
    
    #-----< materialSupplyExhausted >-----#
    materialSupplyExhausted = CHOICE(name='materialSupplyExhausted', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    materialSupplyExhausted._val = ('globalValue', (2, 9, 3, 2, 0, 0, 30))
    
    #-----< multiplexerProblem >-----#
    multiplexerProblem = CHOICE(name='multiplexerProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    multiplexerProblem._val = ('globalValue', (2, 9, 3, 2, 0, 0, 31))
    
    #-----< outOfMemory >-----#
    outOfMemory = CHOICE(name='outOfMemory', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    outOfMemory._val = ('globalValue', (2, 9, 3, 2, 0, 0, 32))
    
    #-----< ouputDeviceError >-----#
    ouputDeviceError = CHOICE(name='ouputDeviceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    ouputDeviceError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 33))
    
    #-----< performanceDegraded >-----#
    performanceDegraded = CHOICE(name='performanceDegraded', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    performanceDegraded._val = ('globalValue', (2, 9, 3, 2, 0, 0, 34))
    
    #-----< powerProblem >-----#
    powerProblem = CHOICE(name='powerProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    powerProblem._val = ('globalValue', (2, 9, 3, 2, 0, 0, 35))
    
    #-----< pressureUnacceptable >-----#
    pressureUnacceptable = CHOICE(name='pressureUnacceptable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    pressureUnacceptable._val = ('globalValue', (2, 9, 3, 2, 0, 0, 36))
    
    #-----< processorProblem >-----#
    processorProblem = CHOICE(name='processorProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    processorProblem._val = ('globalValue', (2, 9, 3, 2, 0, 0, 37))
    
    #-----< pumpFailure >-----#
    pumpFailure = CHOICE(name='pumpFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    pumpFailure._val = ('globalValue', (2, 9, 3, 2, 0, 0, 38))
    
    #-----< queueSizeExceeded >-----#
    queueSizeExceeded = CHOICE(name='queueSizeExceeded', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    queueSizeExceeded._val = ('globalValue', (2, 9, 3, 2, 0, 0, 39))
    
    #-----< receiveFailure >-----#
    receiveFailure = CHOICE(name='receiveFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    receiveFailure._val = ('globalValue', (2, 9, 3, 2, 0, 0, 40))
    
    #-----< receiverFailure >-----#
    receiverFailure = CHOICE(name='receiverFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    receiverFailure._val = ('globalValue', (2, 9, 3, 2, 0, 0, 41))
    
    #-----< remoteNodeTransmissionError >-----#
    remoteNodeTransmissionError = CHOICE(name='remoteNodeTransmissionError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    remoteNodeTransmissionError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 42))
    
    #-----< resourceAtOrNearingCapacity >-----#
    resourceAtOrNearingCapacity = CHOICE(name='resourceAtOrNearingCapacity', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    resourceAtOrNearingCapacity._val = ('globalValue', (2, 9, 3, 2, 0, 0, 43))
    
    #-----< responseTimeExcessive >-----#
    responseTimeExcessive = CHOICE(name='responseTimeExcessive', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    responseTimeExcessive._val = ('globalValue', (2, 9, 3, 2, 0, 0, 44))
    
    #-----< retransmissionRateExcessive >-----#
    retransmissionRateExcessive = CHOICE(name='retransmissionRateExcessive', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    retransmissionRateExcessive._val = ('globalValue', (2, 9, 3, 2, 0, 0, 45))
    
    #-----< softwareError >-----#
    softwareError = CHOICE(name='softwareError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    softwareError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 46))
    
    #-----< softwareProgramAbnormallyTerminated >-----#
    softwareProgramAbnormallyTerminated = CHOICE(name='softwareProgramAbnormallyTerminated', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    softwareProgramAbnormallyTerminated._val = ('globalValue', (2, 9, 3, 2, 0, 0, 47))
    
    #-----< softwareProgramError >-----#
    softwareProgramError = CHOICE(name='softwareProgramError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    softwareProgramError._val = ('globalValue', (2, 9, 3, 2, 0, 0, 48))
    
    #-----< storageCapacityProblem >-----#
    storageCapacityProblem = CHOICE(name='storageCapacityProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    storageCapacityProblem._val = ('globalValue', (2, 9, 3, 2, 0, 0, 49))
    
    #-----< temperatureUnacceptable >-----#
    temperatureUnacceptable = CHOICE(name='temperatureUnacceptable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    temperatureUnacceptable._val = ('globalValue', (2, 9, 3, 2, 0, 0, 50))
    
    #-----< thresholdCrossed >-----#
    thresholdCrossed = CHOICE(name='thresholdCrossed', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    thresholdCrossed._val = ('globalValue', (2, 9, 3, 2, 0, 0, 51))
    
    #-----< timingProblem >-----#
    timingProblem = CHOICE(name='timingProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    timingProblem._val = ('globalValue', (2, 9, 3, 2, 0, 0, 52))
    
    #-----< toxicLeakDetected >-----#
    toxicLeakDetected = CHOICE(name='toxicLeakDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    toxicLeakDetected._val = ('globalValue', (2, 9, 3, 2, 0, 0, 53))
    
    #-----< transmitFailure >-----#
    transmitFailure = CHOICE(name='transmitFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    transmitFailure._val = ('globalValue', (2, 9, 3, 2, 0, 0, 54))
    
    #-----< transmitterFailure >-----#
    transmitterFailure = CHOICE(name='transmitterFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    transmitterFailure._val = ('globalValue', (2, 9, 3, 2, 0, 0, 55))
    
    #-----< underlyingResourceUnavailable >-----#
    underlyingResourceUnavailable = CHOICE(name='underlyingResourceUnavailable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    underlyingResourceUnavailable._val = ('globalValue', (2, 9, 3, 2, 0, 0, 56))
    
    #-----< versionMismatch >-----#
    versionMismatch = CHOICE(name='versionMismatch', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    versionMismatch._val = ('globalValue', (2, 9, 3, 2, 0, 0, 57))
    
    #-----< arfProposedRepairAction >-----#
    arfProposedRepairAction = OID(name='arfProposedRepairAction', mode=MODE_VALUE)
    arfProposedRepairAction._val = (2, 9, 3, 2, 0, 2)
    
    #-----< noActionRequired >-----#
    noActionRequired = OID(name='noActionRequired', mode=MODE_VALUE)
    noActionRequired._val = (2, 9, 3, 2, 0, 2, 1)
    
    #-----< repairActionRequired >-----#
    repairActionRequired = OID(name='repairActionRequired', mode=MODE_VALUE)
    repairActionRequired._val = (2, 9, 3, 2, 0, 2, 2)
    
    #-----< securityAlarmCause >-----#
    securityAlarmCause = OID(name='securityAlarmCause', mode=MODE_VALUE)
    securityAlarmCause._val = (2, 9, 3, 2, 0, 1)
    
    #-----< authenticationFailure >-----#
    authenticationFailure = OID(name='authenticationFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    authenticationFailure._val = (2, 9, 3, 2, 0, 1, 1)
    
    #-----< breachOfConfidentiality >-----#
    breachOfConfidentiality = OID(name='breachOfConfidentiality', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    breachOfConfidentiality._val = (2, 9, 3, 2, 0, 1, 2)
    
    #-----< cableTamper >-----#
    cableTamper = OID(name='cableTamper', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    cableTamper._val = (2, 9, 3, 2, 0, 1, 3)
    
    #-----< delayedInformation >-----#
    delayedInformation = OID(name='delayedInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    delayedInformation._val = (2, 9, 3, 2, 0, 1, 4)
    
    #-----< denialOfService >-----#
    denialOfService = OID(name='denialOfService', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    denialOfService._val = (2, 9, 3, 2, 0, 1, 5)
    
    #-----< duplicateInformation >-----#
    duplicateInformation = OID(name='duplicateInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    duplicateInformation._val = (2, 9, 3, 2, 0, 1, 6)
    
    #-----< informationMissing >-----#
    informationMissing = OID(name='informationMissing', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    informationMissing._val = (2, 9, 3, 2, 0, 1, 7)
    
    #-----< informationModificationDetected >-----#
    informationModificationDetected = OID(name='informationModificationDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    informationModificationDetected._val = (2, 9, 3, 2, 0, 1, 8)
    
    #-----< informationOutOfSequence >-----#
    informationOutOfSequence = OID(name='informationOutOfSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    informationOutOfSequence._val = (2, 9, 3, 2, 0, 1, 9)
    
    #-----< intrusionDetection >-----#
    intrusionDetection = OID(name='intrusionDetection', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    intrusionDetection._val = (2, 9, 3, 2, 0, 1, 10)
    
    #-----< keyExpired >-----#
    keyExpired = OID(name='keyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    keyExpired._val = (2, 9, 3, 2, 0, 1, 11)
    
    #-----< nonRepudiationFailure >-----#
    nonRepudiationFailure = OID(name='nonRepudiationFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    nonRepudiationFailure._val = (2, 9, 3, 2, 0, 1, 12)
    
    #-----< outOfHoursActivity >-----#
    outOfHoursActivity = OID(name='outOfHoursActivity', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    outOfHoursActivity._val = (2, 9, 3, 2, 0, 1, 13)
    
    #-----< outOfService >-----#
    outOfService = OID(name='outOfService', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    outOfService._val = (2, 9, 3, 2, 0, 1, 14)
    
    #-----< proceduralError >-----#
    proceduralError = OID(name='proceduralError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    proceduralError._val = (2, 9, 3, 2, 0, 1, 15)
    
    #-----< unauthorizedAccessAttempt >-----#
    unauthorizedAccessAttempt = OID(name='unauthorizedAccessAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    unauthorizedAccessAttempt._val = (2, 9, 3, 2, 0, 1, 16)
    
    #-----< unexpectedInformation >-----#
    unexpectedInformation = OID(name='unexpectedInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    unexpectedInformation._val = (2, 9, 3, 2, 0, 1, 17)
    
    #-----< unspecifiedReason >-----#
    unspecifiedReason = OID(name='unspecifiedReason', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    unspecifiedReason._val = (2, 9, 3, 2, 0, 1, 18)
    
    #-----< defaultIntervalsOfDay >-----#
    defaultIntervalsOfDay = SET_OF(name='defaultIntervalsOfDay', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'IntervalsOfDay')))
    defaultIntervalsOfDay._val = [dict([('intervalStart', dict([('hour', 0), ('minute', 0)])), ('intervalEnd', dict([('hour', 23), ('minute', 59)]))])]
    
    #-----< defaultStopTime >-----#
    defaultStopTime = CHOICE(name='defaultStopTime', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'StopTime')))
    defaultStopTime._val = ('continual', 0)
    
    #-----< defaultWeekMask >-----#
    defaultWeekMask = SET_OF(name='defaultWeekMask', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'WeekMask')))
    defaultWeekMask._val = [dict([('daysOfWeek', (127, 7)), ('intervalsOfDay', [dict([('intervalStart', dict([('hour', 0), ('minute', 0)])), ('intervalEnd', dict([('hour', 23), ('minute', 59)]))])])])]
    
    #-----< defaultDiscriminatorConstruct >-----#
    defaultDiscriminatorConstruct = CHOICE(name='defaultDiscriminatorConstruct', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DiscriminatorConstruct')))
    defaultDiscriminatorConstruct._val = ('and', [])
    
    #-----< ActiveDestination >-----#
    ActiveDestination = CHOICE(name='ActiveDestination', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'Destination')))
    
    #-----< AdditionalText >-----#
    AdditionalText = STR_GRAPH(name='AdditionalText', mode=MODE_TYPE)
    
    #-----< AdditionalInformation >-----#
    AdditionalInformation = SET_OF(name='AdditionalInformation', mode=MODE_TYPE)
    _AdditionalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    AdditionalInformation._cont = _AdditionalInformation__item_
    
    #-----< Allomorphs >-----#
    Allomorphs = SET_OF(name='Allomorphs', mode=MODE_TYPE)
    _Allomorphs__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    Allomorphs._cont = _Allomorphs__item_
    
    #-----< AdministrativeState >-----#
    AdministrativeState = ENUM(name='AdministrativeState', mode=MODE_TYPE)
    AdministrativeState._cont = ASN1Dict([('locked', 0), ('unlocked', 1), ('shuttingDown', 2)])
    AdministrativeState._ext = None
    
    #-----< AttributeIdentifierList >-----#
    AttributeIdentifierList = SET_OF(name='AttributeIdentifierList', mode=MODE_TYPE)
    _AttributeIdentifierList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    AttributeIdentifierList._cont = _AttributeIdentifierList__item_
    
    #-----< AttributeList >-----#
    AttributeList = SET_OF(name='AttributeList', mode=MODE_TYPE)
    _AttributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    AttributeList._cont = _AttributeList__item_
    
    #-----< AttributeValueChangeDefinition >-----#
    AttributeValueChangeDefinition = SET_OF(name='AttributeValueChangeDefinition', mode=MODE_TYPE)
    _AttributeValueChangeDefinition__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AttributeValueChangeDefinition__item__attributeId = CHOICE(name='attributeId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['id']))
    ___AttributeValueChangeDefinition__item__attributeId_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ___AttributeValueChangeDefinition__item__attributeId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueChangeDefinition__item__attributeId._const_tab = ___AttributeValueChangeDefinition__item__attributeId_tab
    __AttributeValueChangeDefinition__item__attributeId._const_tab_at = None
    __AttributeValueChangeDefinition__item__attributeId._const_tab_id = 'id'
    __AttributeValueChangeDefinition__item__oldAttributeValue = OPEN(name='oldAttributeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['Value']), opt=True)
    ___AttributeValueChangeDefinition__item__oldAttributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ___AttributeValueChangeDefinition__item__oldAttributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueChangeDefinition__item__oldAttributeValue._const_tab = ___AttributeValueChangeDefinition__item__oldAttributeValue_tab
    __AttributeValueChangeDefinition__item__oldAttributeValue._const_tab_at = ('..', 'attributeId')
    __AttributeValueChangeDefinition__item__oldAttributeValue._const_tab_id = 'Value'
    __AttributeValueChangeDefinition__item__newAttributeValue = OPEN(name='newAttributeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['Value']))
    ___AttributeValueChangeDefinition__item__newAttributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ___AttributeValueChangeDefinition__item__newAttributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueChangeDefinition__item__newAttributeValue._const_tab = ___AttributeValueChangeDefinition__item__newAttributeValue_tab
    __AttributeValueChangeDefinition__item__newAttributeValue._const_tab_at = ('..', 'attributeId')
    __AttributeValueChangeDefinition__item__newAttributeValue._const_tab_id = 'Value'
    _AttributeValueChangeDefinition__item_._cont = ASN1Dict([
        ('attributeId', __AttributeValueChangeDefinition__item__attributeId),
        ('oldAttributeValue', __AttributeValueChangeDefinition__item__oldAttributeValue),
        ('newAttributeValue', __AttributeValueChangeDefinition__item__newAttributeValue),
        ])
    _AttributeValueChangeDefinition__item_._ext = None
    AttributeValueChangeDefinition._cont = _AttributeValueChangeDefinition__item_
    
    #-----< AlarmStatus >-----#
    AlarmStatus = SET_OF(name='AlarmStatus', mode=MODE_TYPE)
    _AlarmStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _AlarmStatus__item_._cont = ASN1Dict([('underRepair', 0), ('critical', 1), ('major', 2), ('minor', 3), ('alarmOutstanding', 4)])
    AlarmStatus._cont = _AlarmStatus__item_
    
    #-----< AvailabilityStatus >-----#
    AvailabilityStatus = SET_OF(name='AvailabilityStatus', mode=MODE_TYPE)
    _AvailabilityStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _AvailabilityStatus__item_._cont = ASN1Dict([('inTest', 0), ('failed', 1), ('powerOff', 2), ('offLine', 3), ('offDuty', 4), ('dependency', 5), ('degraded', 6), ('notInstalled', 7), ('logFull', 8)])
    AvailabilityStatus._cont = _AvailabilityStatus__item_
    
    #-----< BackedUpStatus >-----#
    BackedUpStatus = BOOL(name='BackedUpStatus', mode=MODE_TYPE)
    
    #-----< BackUpDestinationList >-----#
    BackUpDestinationList = SEQ_OF(name='BackUpDestinationList', mode=MODE_TYPE)
    _BackUpDestinationList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    BackUpDestinationList._cont = _BackUpDestinationList__item_
    
    #-----< BackUpRelationshipObject >-----#
    BackUpRelationshipObject = CHOICE(name='BackUpRelationshipObject', mode=MODE_TYPE)
    _BackUpRelationshipObject_objectName = CHOICE(name='objectName', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _BackUpRelationshipObject_noObject = NULL(name='noObject', mode=MODE_TYPE)
    BackUpRelationshipObject._cont = ASN1Dict([
        ('objectName', _BackUpRelationshipObject_objectName),
        ('noObject', _BackUpRelationshipObject_noObject),
        ])
    BackUpRelationshipObject._ext = None
    
    #-----< CapacityAlarmThreshold >-----#
    CapacityAlarmThreshold = SET_OF(name='CapacityAlarmThreshold', mode=MODE_TYPE)
    _CapacityAlarmThreshold__item_ = INT(name='_item_', mode=MODE_TYPE)
    _CapacityAlarmThreshold__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    CapacityAlarmThreshold._cont = _CapacityAlarmThreshold__item_
    
    #-----< ConfirmedMode >-----#
    ConfirmedMode = BOOL(name='ConfirmedMode', mode=MODE_TYPE)
    
    #-----< ControlStatus >-----#
    ControlStatus = SET_OF(name='ControlStatus', mode=MODE_TYPE)
    _ControlStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _ControlStatus__item_._cont = ASN1Dict([('subjectToTest', 0), ('partOfServicesLocked', 1), ('reservedForTest', 2), ('suspended', 3)])
    ControlStatus._cont = _ControlStatus__item_
    
    #-----< Count >-----#
    Count = INT(name='Count', mode=MODE_TYPE)
    
    #-----< CounterThreshold >-----#
    CounterThreshold = SET_OF(name='CounterThreshold', mode=MODE_TYPE)
    _CounterThreshold__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CounterThreshold__item__comparisonLevel = INT(name='comparisonLevel', mode=MODE_TYPE)
    __CounterThreshold__item__offsetValue = INT(name='offsetValue', mode=MODE_TYPE)
    __CounterThreshold__item__notificationOnOff = BOOL(name='notificationOnOff', mode=MODE_TYPE)
    _CounterThreshold__item_._cont = ASN1Dict([
        ('comparisonLevel', __CounterThreshold__item__comparisonLevel),
        ('offsetValue', __CounterThreshold__item__offsetValue),
        ('notificationOnOff', __CounterThreshold__item__notificationOnOff),
        ])
    _CounterThreshold__item_._ext = None
    CounterThreshold._cont = _CounterThreshold__item_
    
    #-----< CorrelatedNotifications >-----#
    CorrelatedNotifications = SET_OF(name='CorrelatedNotifications', mode=MODE_TYPE)
    _CorrelatedNotifications__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CorrelatedNotifications__item__correlatedNotifications = SET_OF(name='correlatedNotifications', mode=MODE_TYPE)
    ___CorrelatedNotifications__item__correlatedNotifications__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'NotificationIdentifier')))
    __CorrelatedNotifications__item__correlatedNotifications._cont = ___CorrelatedNotifications__item__correlatedNotifications__item_
    __CorrelatedNotifications__item__sourceObjectInst = CHOICE(name='sourceObjectInst', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _CorrelatedNotifications__item_._cont = ASN1Dict([
        ('correlatedNotifications', __CorrelatedNotifications__item__correlatedNotifications),
        ('sourceObjectInst', __CorrelatedNotifications__item__sourceObjectInst),
        ])
    _CorrelatedNotifications__item_._ext = None
    CorrelatedNotifications._cont = _CorrelatedNotifications__item_
    
    #-----< CurrentLogSize >-----#
    CurrentLogSize = INT(name='CurrentLogSize', mode=MODE_TYPE)
    
    #-----< Destination >-----#
    Destination = CHOICE(name='Destination', mode=MODE_TYPE)
    _Destination_single = CHOICE(name='single', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    _Destination_multiple = SET_OF(name='multiple', mode=MODE_TYPE)
    __Destination_multiple__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    _Destination_multiple._cont = __Destination_multiple__item_
    Destination._cont = ASN1Dict([
        ('single', _Destination_single),
        ('multiple', _Destination_multiple),
        ])
    Destination._ext = None
    
    #-----< DiscriminatorConstruct >-----#
    DiscriminatorConstruct = CHOICE(name='DiscriminatorConstruct', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    
    #-----< EventTime >-----#
    EventTime = TIME_GEN(name='EventTime', mode=MODE_TYPE)
    
    #-----< GaugeThreshold >-----#
    GaugeThreshold = SET_OF(name='GaugeThreshold', mode=MODE_TYPE)
    _GaugeThreshold__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GaugeThreshold__item__notifyLow = SEQ(name='notifyLow', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'NotifyThreshold')))
    __GaugeThreshold__item__notifyHigh = SEQ(name='notifyHigh', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'NotifyThreshold')))
    _GaugeThreshold__item_._cont = ASN1Dict([
        ('notifyLow', __GaugeThreshold__item__notifyLow),
        ('notifyHigh', __GaugeThreshold__item__notifyHigh),
        ])
    _GaugeThreshold__item_._ext = None
    GaugeThreshold._cont = _GaugeThreshold__item_
    
    #-----< GaugeThresholdValue >-----#
    GaugeThresholdValue = CHOICE(name='GaugeThresholdValue', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    
    #-----< GroupObjects >-----#
    GroupObjects = SET_OF(name='GroupObjects', mode=MODE_TYPE)
    _GroupObjects__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    GroupObjects._cont = _GroupObjects__item_
    
    #-----< IntervalsOfDay >-----#
    IntervalsOfDay = SET_OF(name='IntervalsOfDay', mode=MODE_TYPE)
    _IntervalsOfDay__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __IntervalsOfDay__item__intervalStart = SEQ(name='intervalStart', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'Time24')))
    __IntervalsOfDay__item__intervalEnd = SEQ(name='intervalEnd', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'Time24')))
    _IntervalsOfDay__item_._cont = ASN1Dict([
        ('intervalStart', __IntervalsOfDay__item__intervalStart),
        ('intervalEnd', __IntervalsOfDay__item__intervalEnd),
        ])
    _IntervalsOfDay__item_._ext = None
    IntervalsOfDay._cont = _IntervalsOfDay__item_
    
    #-----< LifecycleState >-----#
    LifecycleState = ENUM(name='LifecycleState', mode=MODE_TYPE)
    LifecycleState._cont = ASN1Dict([('planned', 0), ('installed', 1), ('pendingRemoval', 2)])
    LifecycleState._ext = None
    
    #-----< LogAvailability >-----#
    LogAvailability = SET_OF(name='LogAvailability', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'AvailabilityStatus')))
    
    #-----< LogFullAction >-----#
    LogFullAction = ENUM(name='LogFullAction', mode=MODE_TYPE)
    LogFullAction._cont = ASN1Dict([('wrap', 0), ('halt', 1)])
    LogFullAction._ext = None
    
    #-----< LoggingTime >-----#
    LoggingTime = TIME_GEN(name='LoggingTime', mode=MODE_TYPE)
    
    #-----< LogRecordId >-----#
    LogRecordId = CHOICE(name='LogRecordId', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SimpleNameType')))
    
    #-----< MaxLogSize >-----#
    MaxLogSize = INT(name='MaxLogSize', mode=MODE_TYPE)
    MaxLogSize._cont = ASN1Dict([('unlimited', 0)])
    
    #-----< DMI-EXTENSION >-----#
    DMI_EXTENSION = CLASS(name='DMI-EXTENSION', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-TYPE-IDENTIFIER')))
    
    #-----< ManagementExtension >-----#
    ManagementExtension = SEQ(name='ManagementExtension', mode=MODE_TYPE)
    _ManagementExtension_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-EXTENSION'), ['id']))
    __ManagementExtension_identifier_tab = CLASS(name='_tab_DMI-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-EXTENSION')))
    __ManagementExtension_identifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ManagementExtension_identifier._const_tab = __ManagementExtension_identifier_tab
    _ManagementExtension_identifier._const_tab_at = None
    _ManagementExtension_identifier._const_tab_id = 'id'
    _ManagementExtension_significance = BOOL(name='significance', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ManagementExtension_information = OPEN(name='information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-EXTENSION'), ['Value']))
    __ManagementExtension_information_tab = CLASS(name='_tab_DMI-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-EXTENSION')))
    __ManagementExtension_information_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ManagementExtension_information._const_tab = __ManagementExtension_information_tab
    _ManagementExtension_information._const_tab_at = ('..', 'identifier')
    _ManagementExtension_information._const_tab_id = 'Value'
    ManagementExtension._cont = ASN1Dict([
        ('identifier', _ManagementExtension_identifier),
        ('significance', _ManagementExtension_significance),
        ('information', _ManagementExtension_information),
        ])
    ManagementExtension._ext = None
    
    #-----< ManagementExtensionSet >-----#
    ManagementExtensionSet = CLASS(name='ManagementExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-EXTENSION')))
    ManagementExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MonitoredAttributes >-----#
    MonitoredAttributes = SET_OF(name='MonitoredAttributes', mode=MODE_TYPE)
    _MonitoredAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    MonitoredAttributes._cont = _MonitoredAttributes__item_
    
    #-----< NameBinding >-----#
    NameBinding = OID(name='NameBinding', mode=MODE_TYPE)
    
    #-----< NotificationIdentifier >-----#
    NotificationIdentifier = INT(name='NotificationIdentifier', mode=MODE_TYPE)
    
    #-----< NotifyThreshold >-----#
    NotifyThreshold = SEQ(name='NotifyThreshold', mode=MODE_TYPE)
    _NotifyThreshold_threshold = CHOICE(name='threshold', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _NotifyThreshold_notifyOnOff = BOOL(name='notifyOnOff', mode=MODE_TYPE)
    NotifyThreshold._cont = ASN1Dict([
        ('threshold', _NotifyThreshold_threshold),
        ('notifyOnOff', _NotifyThreshold_notifyOnOff),
        ])
    NotifyThreshold._ext = None
    
    #-----< NumberOfRecords >-----#
    NumberOfRecords = INT(name='NumberOfRecords', mode=MODE_TYPE)
    
    #-----< ObservedValue >-----#
    ObservedValue = CHOICE(name='ObservedValue', mode=MODE_TYPE)
    _ObservedValue_integer = INT(name='integer', mode=MODE_TYPE)
    _ObservedValue_real = REAL(name='real', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'REAL')))
    ObservedValue._cont = ASN1Dict([
        ('integer', _ObservedValue_integer),
        ('real', _ObservedValue_real),
        ])
    ObservedValue._ext = None
    
    #-----< OperationalState >-----#
    OperationalState = ENUM(name='OperationalState', mode=MODE_TYPE)
    OperationalState._cont = ASN1Dict([('disabled', 0), ('enabled', 1)])
    OperationalState._ext = None
    
    #-----< Packages >-----#
    Packages = SET_OF(name='Packages', mode=MODE_TYPE)
    _Packages__item_ = OID(name='_item_', mode=MODE_TYPE)
    Packages._cont = _Packages__item_
    
    #-----< PerceivedSeverity >-----#
    PerceivedSeverity = ENUM(name='PerceivedSeverity', mode=MODE_TYPE)
    PerceivedSeverity._cont = ASN1Dict([('indeterminate', 0), ('critical', 1), ('major', 2), ('minor', 3), ('warning', 4), ('cleared', 5)])
    PerceivedSeverity._ext = None
    
    #-----< PrioritisedObject >-----#
    PrioritisedObject = SET_OF(name='PrioritisedObject', mode=MODE_TYPE)
    _PrioritisedObject__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PrioritisedObject__item__object = CHOICE(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    __PrioritisedObject__item__priority = INT(name='priority', mode=MODE_TYPE)
    __PrioritisedObject__item__priority._cont = ASN1Dict([('highest', 0), ('lowest', 127)])
    _PrioritisedObject__item_._cont = ASN1Dict([
        ('object', __PrioritisedObject__item__object),
        ('priority', __PrioritisedObject__item__priority),
        ])
    _PrioritisedObject__item_._ext = None
    PrioritisedObject._cont = _PrioritisedObject__item_
    
    #-----< ProbableCause >-----#
    ProbableCause = CHOICE(name='ProbableCause', mode=MODE_TYPE)
    _ProbableCause_globalValue = OID(name='globalValue', mode=MODE_TYPE)
    _ProbableCause_localValue = INT(name='localValue', mode=MODE_TYPE)
    ProbableCause._cont = ASN1Dict([
        ('globalValue', _ProbableCause_globalValue),
        ('localValue', _ProbableCause_localValue),
        ])
    ProbableCause._ext = None
    
    #-----< ProceduralStatus >-----#
    ProceduralStatus = SET_OF(name='ProceduralStatus', mode=MODE_TYPE)
    _ProceduralStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _ProceduralStatus__item_._cont = ASN1Dict([('initializationRequired', 0), ('notInitialized', 1), ('initializing', 2), ('reporting', 3), ('terminating', 4)])
    ProceduralStatus._cont = _ProceduralStatus__item_
    
    #-----< ProposedRepairActions >-----#
    ProposedRepairActions = SET_OF(name='ProposedRepairActions', mode=MODE_TYPE)
    _ProposedRepairActions__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SpecificIdentifier')))
    ProposedRepairActions._cont = _ProposedRepairActions__item_
    
    #-----< SchedulingAvailability >-----#
    SchedulingAvailability = SET_OF(name='SchedulingAvailability', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'AvailabilityStatus')))
    
    #-----< SecurityAlarmCause >-----#
    SecurityAlarmCause = OID(name='SecurityAlarmCause', mode=MODE_TYPE)
    
    #-----< SecurityAlarmSeverity >-----#
    SecurityAlarmSeverity = ENUM(name='SecurityAlarmSeverity', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'PerceivedSeverity')))
    SecurityAlarmSeverity._const_val = ASN1Set(rv=['indeterminate', 'critical', 'major', 'minor', 'warning'], rr=[], ev=None, er=[])
    
    #-----< SecurityAlarmDetector >-----#
    SecurityAlarmDetector = CHOICE(name='SecurityAlarmDetector', mode=MODE_TYPE)
    _SecurityAlarmDetector_mechanism = OID(name='mechanism', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SecurityAlarmDetector_object = CHOICE(name='object', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _SecurityAlarmDetector_application = CHOICE(name='application', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    SecurityAlarmDetector._cont = ASN1Dict([
        ('mechanism', _SecurityAlarmDetector_mechanism),
        ('object', _SecurityAlarmDetector_object),
        ('application', _SecurityAlarmDetector_application),
        ])
    SecurityAlarmDetector._ext = None
    
    #-----< ServiceProvider >-----#
    ServiceProvider = SEQ(name='ServiceProvider', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ServiceUser')))
    
    #-----< DMI-SERVICEUSER >-----#
    DMI_SERVICEUSER = CLASS(name='DMI-SERVICEUSER', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-TYPE-IDENTIFIER')))
    
    #-----< ServiceUser >-----#
    ServiceUser = SEQ(name='ServiceUser', mode=MODE_TYPE)
    _ServiceUser_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SERVICEUSER'), ['id']))
    __ServiceUser_identifier_tab = CLASS(name='_tab_DMI-SERVICEUSER', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SERVICEUSER')))
    __ServiceUser_identifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ServiceUser_identifier._const_tab = __ServiceUser_identifier_tab
    _ServiceUser_identifier._const_tab_at = None
    _ServiceUser_identifier._const_tab_id = 'id'
    _ServiceUser_details = OPEN(name='details', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SERVICEUSER'), ['Value']))
    __ServiceUser_details_tab = CLASS(name='_tab_DMI-SERVICEUSER', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SERVICEUSER')))
    __ServiceUser_details_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ServiceUser_details._const_tab = __ServiceUser_details_tab
    _ServiceUser_details._const_tab_at = ('..', 'identifier')
    _ServiceUser_details._const_tab_id = 'Value'
    ServiceUser._cont = ASN1Dict([
        ('identifier', _ServiceUser_identifier),
        ('details', _ServiceUser_details),
        ])
    ServiceUser._ext = None
    
    #-----< ServiceUserSet >-----#
    ServiceUserSet = CLASS(name='ServiceUserSet', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SERVICEUSER')))
    ServiceUserSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SimpleNameType >-----#
    SimpleNameType = CHOICE(name='SimpleNameType', mode=MODE_TYPE)
    _SimpleNameType_number = INT(name='number', mode=MODE_TYPE)
    _SimpleNameType_string = STR_GRAPH(name='string', mode=MODE_TYPE)
    SimpleNameType._cont = ASN1Dict([
        ('number', _SimpleNameType_number),
        ('string', _SimpleNameType_string),
        ])
    SimpleNameType._ext = None
    
    #-----< SpecificIdentifier >-----#
    SpecificIdentifier = CHOICE(name='SpecificIdentifier', mode=MODE_TYPE)
    _SpecificIdentifier_oi = OID(name='oi', mode=MODE_TYPE)
    _SpecificIdentifier_int = INT(name='int', mode=MODE_TYPE)
    SpecificIdentifier._cont = ASN1Dict([
        ('oi', _SpecificIdentifier_oi),
        ('int', _SpecificIdentifier_int),
        ])
    SpecificIdentifier._ext = None
    
    #-----< SourceIndicator >-----#
    SourceIndicator = ENUM(name='SourceIndicator', mode=MODE_TYPE)
    SourceIndicator._cont = ASN1Dict([('resourceOperation', 0), ('managementOperation', 1), ('unknown', 2)])
    SourceIndicator._ext = None
    
    #-----< SpecificProblems >-----#
    SpecificProblems = SET_OF(name='SpecificProblems', mode=MODE_TYPE)
    _SpecificProblems__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SpecificIdentifier')))
    SpecificProblems._cont = _SpecificProblems__item_
    
    #-----< StandbyStatus >-----#
    StandbyStatus = INT(name='StandbyStatus', mode=MODE_TYPE)
    StandbyStatus._cont = ASN1Dict([('hotStandby', 0), ('coldStandby', 1), ('providingService', 2)])
    
    #-----< StartTime >-----#
    StartTime = TIME_GEN(name='StartTime', mode=MODE_TYPE)
    
    #-----< StopTime >-----#
    StopTime = CHOICE(name='StopTime', mode=MODE_TYPE)
    _StopTime_specific = TIME_GEN(name='specific', mode=MODE_TYPE)
    _StopTime_continual = NULL(name='continual', mode=MODE_TYPE)
    StopTime._cont = ASN1Dict([
        ('specific', _StopTime_specific),
        ('continual', _StopTime_continual),
        ])
    StopTime._ext = None
    
    #-----< DMI-SUPPORTEDFEATURES >-----#
    DMI_SUPPORTEDFEATURES = CLASS(name='DMI-SUPPORTEDFEATURES', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-TYPE-IDENTIFIER')))
    
    #-----< SupportedFeatures >-----#
    SupportedFeatures = SET_OF(name='SupportedFeatures', mode=MODE_TYPE)
    _SupportedFeatures__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SupportedFeatures__item__featureIdentifier = OID(name='featureIdentifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES'), ['id']))
    ___SupportedFeatures__item__featureIdentifier_tab = CLASS(name='_tab_DMI-SUPPORTEDFEATURES', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES')))
    ___SupportedFeatures__item__featureIdentifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedFeatures__item__featureIdentifier._const_tab = ___SupportedFeatures__item__featureIdentifier_tab
    __SupportedFeatures__item__featureIdentifier._const_tab_at = None
    __SupportedFeatures__item__featureIdentifier._const_tab_id = 'id'
    __SupportedFeatures__item__featureInfo = OPEN(name='featureInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES'), ['Value']))
    ___SupportedFeatures__item__featureInfo_tab = CLASS(name='_tab_DMI-SUPPORTEDFEATURES', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES')))
    ___SupportedFeatures__item__featureInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedFeatures__item__featureInfo._const_tab = ___SupportedFeatures__item__featureInfo_tab
    __SupportedFeatures__item__featureInfo._const_tab_at = ('..', 'featureIdentifier')
    __SupportedFeatures__item__featureInfo._const_tab_id = 'Value'
    _SupportedFeatures__item_._cont = ASN1Dict([
        ('featureIdentifier', __SupportedFeatures__item__featureIdentifier),
        ('featureInfo', __SupportedFeatures__item__featureInfo),
        ])
    _SupportedFeatures__item_._ext = None
    SupportedFeatures._cont = _SupportedFeatures__item_
    
    #-----< SupportedFeaturesSet >-----#
    SupportedFeaturesSet = CLASS(name='SupportedFeaturesSet', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES')))
    SupportedFeaturesSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemId >-----#
    SystemId = CHOICE(name='SystemId', mode=MODE_TYPE)
    _SystemId_name = STR_GRAPH(name='name', mode=MODE_TYPE)
    _SystemId_number = INT(name='number', mode=MODE_TYPE)
    _SystemId_nothing = NULL(name='nothing', mode=MODE_TYPE)
    SystemId._cont = ASN1Dict([
        ('name', _SystemId_name),
        ('number', _SystemId_number),
        ('nothing', _SystemId_nothing),
        ])
    SystemId._ext = None
    
    #-----< SystemTitle >-----#
    SystemTitle = CHOICE(name='SystemTitle', mode=MODE_TYPE)
    _SystemTitle_distinguishedName = SEQ_OF(name='distinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DistinguishedName')))
    _SystemTitle_oid = OID(name='oid', mode=MODE_TYPE)
    _SystemTitle_nothing = NULL(name='nothing', mode=MODE_TYPE)
    SystemTitle._cont = ASN1Dict([
        ('distinguishedName', _SystemTitle_distinguishedName),
        ('oid', _SystemTitle_oid),
        ('nothing', _SystemTitle_nothing),
        ])
    SystemTitle._ext = None
    
    #-----< TideMarkInfo >-----#
    TideMarkInfo = SEQ(name='TideMarkInfo', mode=MODE_TYPE)
    _TideMarkInfo_currentTideMark = CHOICE(name='currentTideMark', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'TideMark')))
    _TideMarkInfo_previousTideMark = CHOICE(name='previousTideMark', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'TideMark')))
    _TideMarkInfo_resetTime = TIME_GEN(name='resetTime', mode=MODE_TYPE)
    TideMarkInfo._cont = ASN1Dict([
        ('currentTideMark', _TideMarkInfo_currentTideMark),
        ('previousTideMark', _TideMarkInfo_previousTideMark),
        ('resetTime', _TideMarkInfo_resetTime),
        ])
    TideMarkInfo._ext = None
    
    #-----< TideMark >-----#
    TideMark = CHOICE(name='TideMark', mode=MODE_TYPE)
    _TideMark_maxTideMar = CHOICE(name='maxTideMar', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _TideMark_minTideMark = CHOICE(name='minTideMark', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    TideMark._cont = ASN1Dict([
        ('maxTideMar', _TideMark_maxTideMar),
        ('minTideMark', _TideMark_minTideMark),
        ])
    TideMark._ext = None
    
    #-----< Time24 >-----#
    Time24 = SEQ(name='Time24', mode=MODE_TYPE)
    _Time24_hour = INT(name='hour', mode=MODE_TYPE)
    _Time24_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    _Time24_minute = INT(name='minute', mode=MODE_TYPE)
    _Time24_minute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    Time24._cont = ASN1Dict([
        ('hour', _Time24_hour),
        ('minute', _Time24_minute),
        ])
    Time24._ext = None
    
    #-----< ThresholdInfo >-----#
    ThresholdInfo = SEQ(name='ThresholdInfo', mode=MODE_TYPE)
    _ThresholdInfo_triggeredThreshold = CHOICE(name='triggeredThreshold', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _ThresholdInfo_observedValue = CHOICE(name='observedValue', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _ThresholdInfo_thresholdLevel = CHOICE(name='thresholdLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ThresholdLevelInd')), opt=True)
    _ThresholdInfo_armTime = TIME_GEN(name='armTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ThresholdInfo._cont = ASN1Dict([
        ('triggeredThreshold', _ThresholdInfo_triggeredThreshold),
        ('observedValue', _ThresholdInfo_observedValue),
        ('thresholdLevel', _ThresholdInfo_thresholdLevel),
        ('armTime', _ThresholdInfo_armTime),
        ])
    ThresholdInfo._ext = None
    
    #-----< ThresholdLevelInd >-----#
    ThresholdLevelInd = CHOICE(name='ThresholdLevelInd', mode=MODE_TYPE)
    _ThresholdLevelInd_up = SEQ(name='up', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ThresholdLevelInd_up_high = CHOICE(name='high', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    __ThresholdLevelInd_up_low = CHOICE(name='low', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')), opt=True)
    _ThresholdLevelInd_up._cont = ASN1Dict([
        ('high', __ThresholdLevelInd_up_high),
        ('low', __ThresholdLevelInd_up_low),
        ])
    _ThresholdLevelInd_up._ext = None
    _ThresholdLevelInd_down = SEQ(name='down', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ThresholdLevelInd_down_high = CHOICE(name='high', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    __ThresholdLevelInd_down_low = CHOICE(name='low', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _ThresholdLevelInd_down._cont = ASN1Dict([
        ('high', __ThresholdLevelInd_down_high),
        ('low', __ThresholdLevelInd_down_low),
        ])
    _ThresholdLevelInd_down._ext = None
    ThresholdLevelInd._cont = ASN1Dict([
        ('up', _ThresholdLevelInd_up),
        ('down', _ThresholdLevelInd_down),
        ])
    ThresholdLevelInd._ext = None
    
    #-----< TrendIndication >-----#
    TrendIndication = ENUM(name='TrendIndication', mode=MODE_TYPE)
    TrendIndication._cont = ASN1Dict([('lessSevere', 0), ('noChange', 1), ('moreSevere', 2)])
    TrendIndication._ext = None
    
    #-----< UnknownStatus >-----#
    UnknownStatus = BOOL(name='UnknownStatus', mode=MODE_TYPE)
    
    #-----< UnscheduledLogAvailability >-----#
    UnscheduledLogAvailability = SET_OF(name='UnscheduledLogAvailability', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'AvailabilityStatus')))
    
    #-----< UsageState >-----#
    UsageState = ENUM(name='UsageState', mode=MODE_TYPE)
    UsageState._cont = ASN1Dict([('idle', 0), ('active', 1), ('busy', 2)])
    UsageState._ext = None
    
    #-----< WeekMask >-----#
    WeekMask = SET_OF(name='WeekMask', mode=MODE_TYPE)
    _WeekMask__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __WeekMask__item__daysOfWeek = BIT_STR(name='daysOfWeek', mode=MODE_TYPE)
    __WeekMask__item__daysOfWeek._cont = ASN1Dict([('sunday', 0), ('monday', 1), ('tuesday', 2), ('wednesday', 3), ('thursday', 4), ('friday', 5), ('saturday', 6)])
    __WeekMask__item__daysOfWeek._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __WeekMask__item__intervalsOfDay = SET_OF(name='intervalsOfDay', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'IntervalsOfDay')))
    _WeekMask__item_._cont = ASN1Dict([
        ('daysOfWeek', __WeekMask__item__daysOfWeek),
        ('intervalsOfDay', __WeekMask__item__intervalsOfDay),
        ])
    _WeekMask__item_._ext = None
    WeekMask._cont = _WeekMask__item_
    
    _all_ = [
        smi2AttributeID,
        smi2AttributeGroup,
        _DMI_TYPE_IDENTIFIER_id,
        _DMI_TYPE_IDENTIFIER_Value,
        DMI_TYPE_IDENTIFIER,
        arfProbableCause,
        adapterError,
        applicationSubsystemFailure,
        bandwidthReduced,
        callEstablishmentError,
        communicationsProtocolError,
        communicationsSubsystemFailure,
        configurationOrCustomizationError,
        congestion,
        corruptData,
        cpuCyclesLimitExceeded,
        dataSetOrModemError,
        degradedSignal,
        dTE_DCEInterfaceError,
        enclosureDoorOpen,
        equipmentMalfunction,
        excessiveVibration,
        fileError,
        fireDetected,
        floodDetected,
        framingError,
        heatingOrVentilationOrCoolingSystemProblem,
        humidityUnacceptable,
        inputOutputDeviceError,
        inputDeviceError,
        lANError,
        leakDetected,
        localNodeTransmissionError,
        lossOfFrame,
        lossOfSignal,
        materialSupplyExhausted,
        multiplexerProblem,
        outOfMemory,
        ouputDeviceError,
        performanceDegraded,
        powerProblem,
        pressureUnacceptable,
        processorProblem,
        pumpFailure,
        queueSizeExceeded,
        receiveFailure,
        receiverFailure,
        remoteNodeTransmissionError,
        resourceAtOrNearingCapacity,
        responseTimeExcessive,
        retransmissionRateExcessive,
        softwareError,
        softwareProgramAbnormallyTerminated,
        softwareProgramError,
        storageCapacityProblem,
        temperatureUnacceptable,
        thresholdCrossed,
        timingProblem,
        toxicLeakDetected,
        transmitFailure,
        transmitterFailure,
        underlyingResourceUnavailable,
        versionMismatch,
        arfProposedRepairAction,
        noActionRequired,
        repairActionRequired,
        securityAlarmCause,
        authenticationFailure,
        breachOfConfidentiality,
        cableTamper,
        delayedInformation,
        denialOfService,
        duplicateInformation,
        informationMissing,
        informationModificationDetected,
        informationOutOfSequence,
        intrusionDetection,
        keyExpired,
        nonRepudiationFailure,
        outOfHoursActivity,
        outOfService,
        proceduralError,
        unauthorizedAccessAttempt,
        unexpectedInformation,
        unspecifiedReason,
        defaultIntervalsOfDay,
        defaultStopTime,
        defaultWeekMask,
        defaultDiscriminatorConstruct,
        ActiveDestination,
        AdditionalText,
        _AdditionalInformation__item_,
        AdditionalInformation,
        _Allomorphs__item_,
        Allomorphs,
        AdministrativeState,
        _AttributeIdentifierList__item_,
        AttributeIdentifierList,
        _AttributeList__item_,
        AttributeList,
        ___AttributeValueChangeDefinition__item__attributeId_tab,
        __AttributeValueChangeDefinition__item__attributeId,
        ___AttributeValueChangeDefinition__item__oldAttributeValue_tab,
        __AttributeValueChangeDefinition__item__oldAttributeValue,
        ___AttributeValueChangeDefinition__item__newAttributeValue_tab,
        __AttributeValueChangeDefinition__item__newAttributeValue,
        _AttributeValueChangeDefinition__item_,
        AttributeValueChangeDefinition,
        _AlarmStatus__item_,
        AlarmStatus,
        _AvailabilityStatus__item_,
        AvailabilityStatus,
        BackedUpStatus,
        _BackUpDestinationList__item_,
        BackUpDestinationList,
        _BackUpRelationshipObject_objectName,
        _BackUpRelationshipObject_noObject,
        BackUpRelationshipObject,
        _CapacityAlarmThreshold__item_,
        CapacityAlarmThreshold,
        ConfirmedMode,
        _ControlStatus__item_,
        ControlStatus,
        Count,
        __CounterThreshold__item__comparisonLevel,
        __CounterThreshold__item__offsetValue,
        __CounterThreshold__item__notificationOnOff,
        _CounterThreshold__item_,
        CounterThreshold,
        ___CorrelatedNotifications__item__correlatedNotifications__item_,
        __CorrelatedNotifications__item__correlatedNotifications,
        __CorrelatedNotifications__item__sourceObjectInst,
        _CorrelatedNotifications__item_,
        CorrelatedNotifications,
        CurrentLogSize,
        _Destination_single,
        __Destination_multiple__item_,
        _Destination_multiple,
        Destination,
        DiscriminatorConstruct,
        EventTime,
        __GaugeThreshold__item__notifyLow,
        __GaugeThreshold__item__notifyHigh,
        _GaugeThreshold__item_,
        GaugeThreshold,
        GaugeThresholdValue,
        _GroupObjects__item_,
        GroupObjects,
        __IntervalsOfDay__item__intervalStart,
        __IntervalsOfDay__item__intervalEnd,
        _IntervalsOfDay__item_,
        IntervalsOfDay,
        LifecycleState,
        LogAvailability,
        LogFullAction,
        LoggingTime,
        LogRecordId,
        MaxLogSize,
        DMI_EXTENSION,
        __ManagementExtension_identifier_tab,
        _ManagementExtension_identifier,
        _ManagementExtension_significance,
        __ManagementExtension_information_tab,
        _ManagementExtension_information,
        ManagementExtension,
        ManagementExtensionSet,
        _MonitoredAttributes__item_,
        MonitoredAttributes,
        NameBinding,
        NotificationIdentifier,
        _NotifyThreshold_threshold,
        _NotifyThreshold_notifyOnOff,
        NotifyThreshold,
        NumberOfRecords,
        _ObservedValue_integer,
        _ObservedValue_real,
        ObservedValue,
        OperationalState,
        _Packages__item_,
        Packages,
        PerceivedSeverity,
        __PrioritisedObject__item__object,
        __PrioritisedObject__item__priority,
        _PrioritisedObject__item_,
        PrioritisedObject,
        _ProbableCause_globalValue,
        _ProbableCause_localValue,
        ProbableCause,
        _ProceduralStatus__item_,
        ProceduralStatus,
        _ProposedRepairActions__item_,
        ProposedRepairActions,
        SchedulingAvailability,
        SecurityAlarmCause,
        SecurityAlarmSeverity,
        _SecurityAlarmDetector_mechanism,
        _SecurityAlarmDetector_object,
        _SecurityAlarmDetector_application,
        SecurityAlarmDetector,
        ServiceProvider,
        DMI_SERVICEUSER,
        __ServiceUser_identifier_tab,
        _ServiceUser_identifier,
        __ServiceUser_details_tab,
        _ServiceUser_details,
        ServiceUser,
        ServiceUserSet,
        _SimpleNameType_number,
        _SimpleNameType_string,
        SimpleNameType,
        _SpecificIdentifier_oi,
        _SpecificIdentifier_int,
        SpecificIdentifier,
        SourceIndicator,
        _SpecificProblems__item_,
        SpecificProblems,
        StandbyStatus,
        StartTime,
        _StopTime_specific,
        _StopTime_continual,
        StopTime,
        DMI_SUPPORTEDFEATURES,
        ___SupportedFeatures__item__featureIdentifier_tab,
        __SupportedFeatures__item__featureIdentifier,
        ___SupportedFeatures__item__featureInfo_tab,
        __SupportedFeatures__item__featureInfo,
        _SupportedFeatures__item_,
        SupportedFeatures,
        SupportedFeaturesSet,
        _SystemId_name,
        _SystemId_number,
        _SystemId_nothing,
        SystemId,
        _SystemTitle_distinguishedName,
        _SystemTitle_oid,
        _SystemTitle_nothing,
        SystemTitle,
        _TideMarkInfo_currentTideMark,
        _TideMarkInfo_previousTideMark,
        _TideMarkInfo_resetTime,
        TideMarkInfo,
        _TideMark_maxTideMar,
        _TideMark_minTideMark,
        TideMark,
        _Time24_hour,
        _Time24_minute,
        Time24,
        _ThresholdInfo_triggeredThreshold,
        _ThresholdInfo_observedValue,
        _ThresholdInfo_thresholdLevel,
        _ThresholdInfo_armTime,
        ThresholdInfo,
        __ThresholdLevelInd_up_high,
        __ThresholdLevelInd_up_low,
        _ThresholdLevelInd_up,
        __ThresholdLevelInd_down_high,
        __ThresholdLevelInd_down_low,
        _ThresholdLevelInd_down,
        ThresholdLevelInd,
        TrendIndication,
        UnknownStatus,
        UnscheduledLogAvailability,
        UsageState,
        __WeekMask__item__daysOfWeek,
        __WeekMask__item__intervalsOfDay,
        _WeekMask__item_,
        WeekMask,
    ]

class AttributeCertificateDefinitions:

    _name_  = 'AttributeCertificateDefinitions'
    _oid_   = [2, 5, 1, 32, 8]
    
    _obj_ = [
        'AttributeCertificate',
        'TBSAttributeCertificate',
        'AttCertVersion',
        'Holder',
        'IssuerSerial',
        'ObjectDigestInfo',
        'AttCertIssuer',
        'AttCertValidityPeriod',
        'AttributeCertificationPath',
        'ACPathData',
        'PrivilegePolicy',
        'role',
        'RoleSyntax',
        'xmlPrivilegeInfo',
        'permission',
        'DualStringSyntax',
        'dualStringMatch',
        'timeSpecification',
        'timeSpecificationMatch',
        'targetingInformation',
        'Targets',
        'Target',
        'TargetCert',
        'userNotice',
        'acceptablePrivilegePolicies',
        'AcceptablePrivilegePoliciesSyntax',
        'singleUse',
        'groupAC',
        'noRevAvail',
        'sOAIdentifier',
        'sOAIdentifierMatch',
        'attributeDescriptor',
        'AttributeDescriptorSyntax',
        'AttributeIdentifier',
        'AttributeIDs',
        'AttributeName',
        'AttributeDescription',
        'PrivilegePolicyIdentifier',
        'attDescriptor',
        'roleSpecCertIdentifier',
        'RoleSpecCertIdentifierSyntax',
        'RoleSpecCertIdentifier',
        'roleSpecCertIdMatch',
        'basicAttConstraints',
        'BasicAttConstraintsSyntax',
        'basicAttConstraintsMatch',
        'delegatedNameConstraints',
        'delegatedNameConstraintsMatch',
        'acceptableCertPolicies',
        'AcceptableCertPoliciesSyntax',
        'CertPolicyId',
        'acceptableCertPoliciesMatch',
        'authorityAttributeIdentifier',
        'AuthorityAttributeIdentifierSyntax',
        'AuthAttId',
        'authAttIdMatch',
        'indirectIssuer',
        'issuedOnBehalfOf',
        'noAssertion',
        'allowedAttributeAssignments',
        'AllowedAttributeAssignments',
        'attributeMappings',
        'AttributeMappings',
        'holderNameConstraints',
        'HolderNameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'pmiUser',
        'pmiAA',
        'pmiSOA',
        'attCertCRLDistributionPt',
        'pmiDelegationPath',
        'privilegePolicy',
        'protectedPrivilegePolicy',
        'attributeCertificateAttribute',
        'aACertificate',
        'attributeDescriptorCertificate',
        'attributeCertificateRevocationList',
        'eeAttrCertificateRevocationList',
        'attributeAuthorityRevocationList',
        'delegationPath',
        'AttCertPath',
        'privPolicy',
        'protPrivPolicy',
        'xmlPrivPolicy',
        'attributeCertificateExactMatch',
        'AttributeCertificateExactAssertion',
        'attributeCertificateMatch',
        'AttributeCertificateAssertion',
        'holderIssuerMatch',
        'HolderIssuerAssertion',
        'delegationPathMatch',
        'DelMatchSyntax',
        'extensionPresenceMatch',
        'id-oc-pmiUser',
        'id-oc-pmiAA',
        'id-oc-pmiSOA',
        'id-oc-attCertCRLDistributionPts',
        'id-oc-privilegePolicy',
        'id-oc-pmiDelegationPath',
        'id-oc-protectedPrivilegePolicy',
        'id-at-attributeCertificate',
        'id-at-attributeCertificateRevocationList',
        'id-at-aACertificate',
        'id-at-attributeDescriptorCertificate',
        'id-at-attributeAuthorityRevocationList',
        'id-at-privPolicy',
        'id-at-role',
        'id-at-delegationPath',
        'id-at-protPrivPolicy',
        'id-at-xMLPrivilegeInfo',
        'id-at-xmlPrivPolicy',
        'id-at-permission',
        'id-at-eeAttrCertificateRevocationList',
        'id-ce-authorityAttributeIdentifier',
        'id-ce-roleSpecCertIdentifier',
        'id-ce-basicAttConstraints',
        'id-ce-delegatedNameConstraints',
        'id-ce-timeSpecification',
        'id-ce-attributeDescriptor',
        'id-ce-userNotice',
        'id-ce-sOAIdentifier',
        'id-ce-acceptableCertPolicies',
        'id-ce-targetingInformation',
        'id-ce-noRevAvail',
        'id-ce-acceptablePrivilegePolicies',
        'id-ce-indirectIssuer',
        'id-ce-noAssertion',
        'id-ce-issuedOnBehalfOf',
        'id-ce-singleUse',
        'id-ce-groupAC',
        'id-ce-allowedAttributeAssignments',
        'id-ce-attributeMappings',
        'id-ce-holderNameConstraints',
        'id-mr-attributeCertificateMatch',
        'id-mr-attributeCertificateExactMatch',
        'id-mr-holderIssuerMatch',
        'id-mr-authAttIdMatch',
        'id-mr-roleSpecCertIdMatch',
        'id-mr-basicAttConstraintsMatch',
        'id-mr-delegatedNameConstraintsMatch',
        'id-mr-timeSpecMatch',
        'id-mr-attDescriptorMatch',
        'id-mr-acceptableCertPoliciesMatch',
        'id-mr-delegationPathMatch',
        'id-mr-sOAIdentifierMatch',
        'id-mr-extensionPresenceMatch',
        'id-mr-dualStringMatch',
        ]
    _type_ = [
        'AttributeCertificate',
        'TBSAttributeCertificate',
        'AttCertVersion',
        'Holder',
        'IssuerSerial',
        'ObjectDigestInfo',
        'AttCertIssuer',
        'AttCertValidityPeriod',
        'AttributeCertificationPath',
        'ACPathData',
        'PrivilegePolicy',
        'RoleSyntax',
        'DualStringSyntax',
        'Targets',
        'Target',
        'TargetCert',
        'AcceptablePrivilegePoliciesSyntax',
        'AttributeDescriptorSyntax',
        'AttributeIdentifier',
        'AttributeName',
        'AttributeDescription',
        'PrivilegePolicyIdentifier',
        'RoleSpecCertIdentifierSyntax',
        'RoleSpecCertIdentifier',
        'BasicAttConstraintsSyntax',
        'AcceptableCertPoliciesSyntax',
        'CertPolicyId',
        'AuthorityAttributeIdentifierSyntax',
        'AuthAttId',
        'AllowedAttributeAssignments',
        'AttributeMappings',
        'HolderNameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'AttCertPath',
        'AttributeCertificateExactAssertion',
        'AttributeCertificateAssertion',
        'HolderIssuerAssertion',
        'DelMatchSyntax',
        ]
    _set_ = [
        'AttributeIDs',
        ]
    _val_ = [
        'role',
        'xmlPrivilegeInfo',
        'permission',
        'dualStringMatch',
        'timeSpecification',
        'timeSpecificationMatch',
        'targetingInformation',
        'userNotice',
        'acceptablePrivilegePolicies',
        'singleUse',
        'groupAC',
        'noRevAvail',
        'sOAIdentifier',
        'sOAIdentifierMatch',
        'attributeDescriptor',
        'attDescriptor',
        'roleSpecCertIdentifier',
        'roleSpecCertIdMatch',
        'basicAttConstraints',
        'basicAttConstraintsMatch',
        'delegatedNameConstraints',
        'delegatedNameConstraintsMatch',
        'acceptableCertPolicies',
        'acceptableCertPoliciesMatch',
        'authorityAttributeIdentifier',
        'authAttIdMatch',
        'indirectIssuer',
        'issuedOnBehalfOf',
        'noAssertion',
        'allowedAttributeAssignments',
        'attributeMappings',
        'holderNameConstraints',
        'pmiUser',
        'pmiAA',
        'pmiSOA',
        'attCertCRLDistributionPt',
        'pmiDelegationPath',
        'privilegePolicy',
        'protectedPrivilegePolicy',
        'attributeCertificateAttribute',
        'aACertificate',
        'attributeDescriptorCertificate',
        'attributeCertificateRevocationList',
        'eeAttrCertificateRevocationList',
        'attributeAuthorityRevocationList',
        'delegationPath',
        'privPolicy',
        'protPrivPolicy',
        'xmlPrivPolicy',
        'attributeCertificateExactMatch',
        'attributeCertificateMatch',
        'holderIssuerMatch',
        'delegationPathMatch',
        'extensionPresenceMatch',
        'id-oc-pmiUser',
        'id-oc-pmiAA',
        'id-oc-pmiSOA',
        'id-oc-attCertCRLDistributionPts',
        'id-oc-privilegePolicy',
        'id-oc-pmiDelegationPath',
        'id-oc-protectedPrivilegePolicy',
        'id-at-attributeCertificate',
        'id-at-attributeCertificateRevocationList',
        'id-at-aACertificate',
        'id-at-attributeDescriptorCertificate',
        'id-at-attributeAuthorityRevocationList',
        'id-at-privPolicy',
        'id-at-role',
        'id-at-delegationPath',
        'id-at-protPrivPolicy',
        'id-at-xMLPrivilegeInfo',
        'id-at-xmlPrivPolicy',
        'id-at-permission',
        'id-at-eeAttrCertificateRevocationList',
        'id-ce-authorityAttributeIdentifier',
        'id-ce-roleSpecCertIdentifier',
        'id-ce-basicAttConstraints',
        'id-ce-delegatedNameConstraints',
        'id-ce-timeSpecification',
        'id-ce-attributeDescriptor',
        'id-ce-userNotice',
        'id-ce-sOAIdentifier',
        'id-ce-acceptableCertPolicies',
        'id-ce-targetingInformation',
        'id-ce-noRevAvail',
        'id-ce-acceptablePrivilegePolicies',
        'id-ce-indirectIssuer',
        'id-ce-noAssertion',
        'id-ce-issuedOnBehalfOf',
        'id-ce-singleUse',
        'id-ce-groupAC',
        'id-ce-allowedAttributeAssignments',
        'id-ce-attributeMappings',
        'id-ce-holderNameConstraints',
        'id-mr-attributeCertificateMatch',
        'id-mr-attributeCertificateExactMatch',
        'id-mr-holderIssuerMatch',
        'id-mr-authAttIdMatch',
        'id-mr-roleSpecCertIdMatch',
        'id-mr-basicAttConstraintsMatch',
        'id-mr-delegatedNameConstraintsMatch',
        'id-mr-timeSpecMatch',
        'id-mr-attDescriptorMatch',
        'id-mr-acceptableCertPoliciesMatch',
        'id-mr-delegationPathMatch',
        'id-mr-sOAIdentifierMatch',
        'id-mr-extensionPresenceMatch',
        'id-mr-dualStringMatch',
        ]
    _class_ = [
        'role',
        'xmlPrivilegeInfo',
        'permission',
        'dualStringMatch',
        'timeSpecification',
        'timeSpecificationMatch',
        'targetingInformation',
        'userNotice',
        'acceptablePrivilegePolicies',
        'singleUse',
        'groupAC',
        'noRevAvail',
        'sOAIdentifier',
        'sOAIdentifierMatch',
        'attributeDescriptor',
        'AttributeIDs',
        'attDescriptor',
        'roleSpecCertIdentifier',
        'roleSpecCertIdMatch',
        'basicAttConstraints',
        'basicAttConstraintsMatch',
        'delegatedNameConstraints',
        'delegatedNameConstraintsMatch',
        'acceptableCertPolicies',
        'acceptableCertPoliciesMatch',
        'authorityAttributeIdentifier',
        'authAttIdMatch',
        'indirectIssuer',
        'issuedOnBehalfOf',
        'noAssertion',
        'allowedAttributeAssignments',
        'attributeMappings',
        'holderNameConstraints',
        'pmiUser',
        'pmiAA',
        'pmiSOA',
        'attCertCRLDistributionPt',
        'pmiDelegationPath',
        'privilegePolicy',
        'protectedPrivilegePolicy',
        'attributeCertificateAttribute',
        'aACertificate',
        'attributeDescriptorCertificate',
        'attributeCertificateRevocationList',
        'eeAttrCertificateRevocationList',
        'attributeAuthorityRevocationList',
        'delegationPath',
        'privPolicy',
        'protPrivPolicy',
        'xmlPrivPolicy',
        'attributeCertificateExactMatch',
        'attributeCertificateMatch',
        'holderIssuerMatch',
        'delegationPathMatch',
        'extensionPresenceMatch',
        ]
    _param_ = [
        ]
    
    #-----< AttributeCertificate >-----#
    AttributeCertificate = SEQ(name='AttributeCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeCertificate_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'TBSAttributeCertificate')))
    _AttributeCertificate_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeCertificate_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab = ___AttributeCertificate_algorithmIdentifier_algorithm_tab
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeCertificate_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttributeCertificate_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificate_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab = ___AttributeCertificate_algorithmIdentifier_parameters_tab
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttributeCertificate_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeCertificate_algorithmIdentifier_algorithm),
        ('parameters', __AttributeCertificate_algorithmIdentifier_parameters),
        ])
    _AttributeCertificate_algorithmIdentifier._ext = []
    _AttributeCertificate_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    AttributeCertificate._cont = ASN1Dict([
        ('toBeSigned', _AttributeCertificate_toBeSigned),
        ('algorithmIdentifier', _AttributeCertificate_algorithmIdentifier),
        ('signature', _AttributeCertificate_signature),
        ])
    AttributeCertificate._ext = []
    
    #-----< TBSAttributeCertificate >-----#
    TBSAttributeCertificate = SEQ(name='TBSAttributeCertificate', mode=MODE_TYPE)
    _TBSAttributeCertificate_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertVersion')))
    _TBSAttributeCertificate_holder = SEQ(name='holder', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')))
    _TBSAttributeCertificate_issuer = SEQ(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    _TBSAttributeCertificate_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TBSAttributeCertificate_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___TBSAttributeCertificate_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSAttributeCertificate_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSAttributeCertificate_signature_algorithm._const_tab = ___TBSAttributeCertificate_signature_algorithm_tab
    __TBSAttributeCertificate_signature_algorithm._const_tab_at = None
    __TBSAttributeCertificate_signature_algorithm._const_tab_id = 'id'
    __TBSAttributeCertificate_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___TBSAttributeCertificate_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSAttributeCertificate_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSAttributeCertificate_signature_parameters._const_tab = ___TBSAttributeCertificate_signature_parameters_tab
    __TBSAttributeCertificate_signature_parameters._const_tab_at = ('..', 'algorithm')
    __TBSAttributeCertificate_signature_parameters._const_tab_id = 'Type'
    _TBSAttributeCertificate_signature._cont = ASN1Dict([
        ('algorithm', __TBSAttributeCertificate_signature_algorithm),
        ('parameters', __TBSAttributeCertificate_signature_parameters),
        ])
    _TBSAttributeCertificate_signature._ext = []
    _TBSAttributeCertificate_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _TBSAttributeCertificate_attrCertValidityPeriod = SEQ(name='attrCertValidityPeriod', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertValidityPeriod')))
    _TBSAttributeCertificate_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE)
    __TBSAttributeCertificate_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___TBSAttributeCertificate_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____TBSAttributeCertificate_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____TBSAttributeCertificate_attributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___TBSAttributeCertificate_attributes__item__type._const_tab = ____TBSAttributeCertificate_attributes__item__type_tab
    ___TBSAttributeCertificate_attributes__item__type._const_tab_at = None
    ___TBSAttributeCertificate_attributes__item__type._const_tab_id = 'id'
    ___TBSAttributeCertificate_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____TBSAttributeCertificate_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____TBSAttributeCertificate_attributes__item__values__item_._const_tab = ____TBSAttributeCertificate_attributes__item__type_tab
    ____TBSAttributeCertificate_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____TBSAttributeCertificate_attributes__item__values__item_._const_tab_id = 'Type'
    ___TBSAttributeCertificate_attributes__item__values._cont = ____TBSAttributeCertificate_attributes__item__values__item_
    ___TBSAttributeCertificate_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___TBSAttributeCertificate_attributes__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value._const_tab = ____TBSAttributeCertificate_attributes__item__type_tab
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList._cont = ______TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList__item_
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value),
        ('contextList', _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList),
        ])
    ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_._ext = []
    ___TBSAttributeCertificate_attributes__item__valuesWithContext._cont = ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_
    ___TBSAttributeCertificate_attributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __TBSAttributeCertificate_attributes__item_._cont = ASN1Dict([
        ('type', ___TBSAttributeCertificate_attributes__item__type),
        ('values', ___TBSAttributeCertificate_attributes__item__values),
        ('valuesWithContext', ___TBSAttributeCertificate_attributes__item__valuesWithContext),
        ])
    __TBSAttributeCertificate_attributes__item_._ext = []
    _TBSAttributeCertificate_attributes._cont = __TBSAttributeCertificate_attributes__item_
    _TBSAttributeCertificate_issuerUniqueID = BIT_STR(name='issuerUniqueID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _TBSAttributeCertificate_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    TBSAttributeCertificate._cont = ASN1Dict([
        ('version', _TBSAttributeCertificate_version),
        ('holder', _TBSAttributeCertificate_holder),
        ('issuer', _TBSAttributeCertificate_issuer),
        ('signature', _TBSAttributeCertificate_signature),
        ('serialNumber', _TBSAttributeCertificate_serialNumber),
        ('attrCertValidityPeriod', _TBSAttributeCertificate_attrCertValidityPeriod),
        ('attributes', _TBSAttributeCertificate_attributes),
        ('issuerUniqueID', _TBSAttributeCertificate_issuerUniqueID),
        ('extensions', _TBSAttributeCertificate_extensions),
        ])
    TBSAttributeCertificate._ext = ['extensions']
    
    #-----< AttCertVersion >-----#
    AttCertVersion = INT(name='AttCertVersion', mode=MODE_TYPE)
    AttCertVersion._cont = ASN1Dict([('v2', 1)])
    
    #-----< Holder >-----#
    Holder = SEQ(name='Holder', mode=MODE_TYPE)
    _Holder_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')), opt=True)
    _Holder_entityName = SEQ_OF(name='entityName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _Holder_objectDigestInfo = SEQ(name='objectDigestInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    Holder._cont = ASN1Dict([
        ('baseCertificateID', _Holder_baseCertificateID),
        ('entityName', _Holder_entityName),
        ('objectDigestInfo', _Holder_objectDigestInfo),
        ])
    Holder._ext = None
    
    #-----< IssuerSerial >-----#
    IssuerSerial = SEQ(name='IssuerSerial', mode=MODE_TYPE)
    _IssuerSerial_issuer = SEQ_OF(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _IssuerSerial_serial = INT(name='serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _IssuerSerial_issuerUID = BIT_STR(name='issuerUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    IssuerSerial._cont = ASN1Dict([
        ('issuer', _IssuerSerial_issuer),
        ('serial', _IssuerSerial_serial),
        ('issuerUID', _IssuerSerial_issuerUID),
        ])
    IssuerSerial._ext = []
    
    #-----< ObjectDigestInfo >-----#
    ObjectDigestInfo = SEQ(name='ObjectDigestInfo', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType = ENUM(name='digestedObjectType', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType._cont = ASN1Dict([('publicKey', 0), ('publicKeyCert', 1), ('otherObjectTypes', 2)])
    _ObjectDigestInfo_digestedObjectType._ext = None
    _ObjectDigestInfo_otherObjectTypeID = OID(name='otherObjectTypeID', mode=MODE_TYPE, opt=True)
    _ObjectDigestInfo_digestAlgorithm = SEQ(name='digestAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __ObjectDigestInfo_digestAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab = ___ObjectDigestInfo_digestAlgorithm_algorithm_tab
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_at = None
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_id = 'id'
    __ObjectDigestInfo_digestAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab = ___ObjectDigestInfo_digestAlgorithm_parameters_tab
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_id = 'Type'
    _ObjectDigestInfo_digestAlgorithm._cont = ASN1Dict([
        ('algorithm', __ObjectDigestInfo_digestAlgorithm_algorithm),
        ('parameters', __ObjectDigestInfo_digestAlgorithm_parameters),
        ])
    _ObjectDigestInfo_digestAlgorithm._ext = []
    _ObjectDigestInfo_objectDigest = BIT_STR(name='objectDigest', mode=MODE_TYPE)
    ObjectDigestInfo._cont = ASN1Dict([
        ('digestedObjectType', _ObjectDigestInfo_digestedObjectType),
        ('otherObjectTypeID', _ObjectDigestInfo_otherObjectTypeID),
        ('digestAlgorithm', _ObjectDigestInfo_digestAlgorithm),
        ('objectDigest', _ObjectDigestInfo_objectDigest),
        ])
    ObjectDigestInfo._ext = []
    
    #-----< AttCertIssuer >-----#
    AttCertIssuer = SEQ(name='AttCertIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttCertIssuer_issuerName = SEQ_OF(name='issuerName', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AttCertIssuer_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')), opt=True)
    _AttCertIssuer_objectDigestInfo = SEQ(name='objectDigestInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    AttCertIssuer._cont = ASN1Dict([
        ('issuerName', _AttCertIssuer_issuerName),
        ('baseCertificateID', _AttCertIssuer_baseCertificateID),
        ('objectDigestInfo', _AttCertIssuer_objectDigestInfo),
        ])
    AttCertIssuer._ext = []
    
    #-----< AttCertValidityPeriod >-----#
    AttCertValidityPeriod = SEQ(name='AttCertValidityPeriod', mode=MODE_TYPE)
    _AttCertValidityPeriod_notBeforeTime = TIME_GEN(name='notBeforeTime', mode=MODE_TYPE)
    _AttCertValidityPeriod_notAfterTime = TIME_GEN(name='notAfterTime', mode=MODE_TYPE)
    AttCertValidityPeriod._cont = ASN1Dict([
        ('notBeforeTime', _AttCertValidityPeriod_notBeforeTime),
        ('notAfterTime', _AttCertValidityPeriod_notAfterTime),
        ])
    AttCertValidityPeriod._ext = []
    
    #-----< AttributeCertificationPath >-----#
    AttributeCertificationPath = SEQ(name='AttributeCertificationPath', mode=MODE_TYPE)
    _AttributeCertificationPath_attributeCertificate = SEQ(name='attributeCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    _AttributeCertificationPath_acPath = SEQ_OF(name='acPath', mode=MODE_TYPE, opt=True)
    __AttributeCertificationPath_acPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ACPathData')))
    _AttributeCertificationPath_acPath._cont = __AttributeCertificationPath_acPath__item_
    AttributeCertificationPath._cont = ASN1Dict([
        ('attributeCertificate', _AttributeCertificationPath_attributeCertificate),
        ('acPath', _AttributeCertificationPath_acPath),
        ])
    AttributeCertificationPath._ext = []
    
    #-----< ACPathData >-----#
    ACPathData = SEQ(name='ACPathData', mode=MODE_TYPE)
    _ACPathData_certificate = SEQ(name='certificate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _ACPathData_attributeCertificate = SEQ(name='attributeCertificate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')), opt=True)
    ACPathData._cont = ASN1Dict([
        ('certificate', _ACPathData_certificate),
        ('attributeCertificate', _ACPathData_attributeCertificate),
        ])
    ACPathData._ext = []
    
    #-----< PrivilegePolicy >-----#
    PrivilegePolicy = OID(name='PrivilegePolicy', mode=MODE_TYPE)
    
    #-----< role >-----#
    role = CLASS(name='role', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _role_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSyntax')))
    role._val = dict([('Type', _role_val_Type), ('id', (2, 5, 4, 72))])
    
    #-----< RoleSyntax >-----#
    RoleSyntax = SEQ(name='RoleSyntax', mode=MODE_TYPE)
    _RoleSyntax_roleAuthority = SEQ_OF(name='roleAuthority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _RoleSyntax_roleName = CHOICE(name='roleName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    RoleSyntax._cont = ASN1Dict([
        ('roleAuthority', _RoleSyntax_roleAuthority),
        ('roleName', _RoleSyntax_roleName),
        ])
    RoleSyntax._ext = []
    
    #-----< xmlPrivilegeInfo >-----#
    xmlPrivilegeInfo = CLASS(name='xmlPrivilegeInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _xmlPrivilegeInfo_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    xmlPrivilegeInfo._val = dict([('Type', _xmlPrivilegeInfo_val_Type), ('id', (2, 5, 4, 75))])
    
    #-----< permission >-----#
    permission = CLASS(name='permission', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _permission_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    permission._val = dict([('Type', _permission_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('id', (2, 5, 13, 69))])), ('id', (2, 5, 4, 82))])
    
    #-----< DualStringSyntax >-----#
    DualStringSyntax = SEQ(name='DualStringSyntax', mode=MODE_TYPE)
    _DualStringSyntax_operation = CHOICE(name='operation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DualStringSyntax_object = CHOICE(name='object', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    DualStringSyntax._cont = ASN1Dict([
        ('operation', _DualStringSyntax_operation),
        ('object', _DualStringSyntax_object),
        ])
    DualStringSyntax._ext = []
    
    #-----< dualStringMatch >-----#
    dualStringMatch = CLASS(name='dualStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _dualStringMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    dualStringMatch._val = dict([('AssertionType', _dualStringMatch_val_AssertionType), ('id', (2, 5, 13, 69))])
    
    #-----< timeSpecification >-----#
    timeSpecification = CLASS(name='timeSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _timeSpecification_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    timeSpecification._val = dict([('ExtnType', _timeSpecification_val_ExtnType), ('id', (2, 5, 29, 43))])
    
    #-----< timeSpecificationMatch >-----#
    timeSpecificationMatch = CLASS(name='timeSpecificationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _timeSpecificationMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    timeSpecificationMatch._val = dict([('AssertionType', _timeSpecificationMatch_val_AssertionType), ('id', (2, 5, 13, 57))])
    
    #-----< targetingInformation >-----#
    targetingInformation = CLASS(name='targetingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _targetingInformation_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE)
    __targetingInformation_val_ExtnType__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Targets')))
    _targetingInformation_val_ExtnType._cont = __targetingInformation_val_ExtnType__item_
    _targetingInformation_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    targetingInformation._val = dict([('ExtnType', _targetingInformation_val_ExtnType), ('id', (2, 5, 29, 55))])
    
    #-----< Targets >-----#
    Targets = SEQ_OF(name='Targets', mode=MODE_TYPE)
    _Targets__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Target')))
    Targets._cont = _Targets__item_
    Targets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< Target >-----#
    Target = CHOICE(name='Target', mode=MODE_TYPE)
    _Target_targetName = CHOICE(name='targetName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _Target_targetGroup = CHOICE(name='targetGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _Target_targetCert = SEQ(name='targetCert', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'TargetCert')))
    Target._cont = ASN1Dict([
        ('targetName', _Target_targetName),
        ('targetGroup', _Target_targetGroup),
        ('targetCert', _Target_targetCert),
        ])
    Target._ext = []
    
    #-----< TargetCert >-----#
    TargetCert = SEQ(name='TargetCert', mode=MODE_TYPE)
    _TargetCert_targetCertificate = SEQ(name='targetCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    _TargetCert_targetName = CHOICE(name='targetName', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _TargetCert_certDigestInfo = SEQ(name='certDigestInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    TargetCert._cont = ASN1Dict([
        ('targetCertificate', _TargetCert_targetCertificate),
        ('targetName', _TargetCert_targetName),
        ('certDigestInfo', _TargetCert_certDigestInfo),
        ])
    TargetCert._ext = None
    
    #-----< userNotice >-----#
    userNotice = CLASS(name='userNotice', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _userNotice_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE)
    __userNotice_val_ExtnType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UserNotice')))
    _userNotice_val_ExtnType._cont = __userNotice_val_ExtnType__item_
    _userNotice_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    userNotice._val = dict([('ExtnType', _userNotice_val_ExtnType), ('id', (2, 5, 29, 49))])
    
    #-----< acceptablePrivilegePolicies >-----#
    acceptablePrivilegePolicies = CLASS(name='acceptablePrivilegePolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _acceptablePrivilegePolicies_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptablePrivilegePoliciesSyntax')))
    acceptablePrivilegePolicies._val = dict([('ExtnType', _acceptablePrivilegePolicies_val_ExtnType), ('id', (2, 5, 29, 57))])
    
    #-----< AcceptablePrivilegePoliciesSyntax >-----#
    AcceptablePrivilegePoliciesSyntax = SEQ_OF(name='AcceptablePrivilegePoliciesSyntax', mode=MODE_TYPE)
    _AcceptablePrivilegePoliciesSyntax__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicy')))
    AcceptablePrivilegePoliciesSyntax._cont = _AcceptablePrivilegePoliciesSyntax__item_
    AcceptablePrivilegePoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< singleUse >-----#
    singleUse = CLASS(name='singleUse', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _singleUse_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    singleUse._val = dict([('ExtnType', _singleUse_val_ExtnType), ('id', (2, 5, 29, 65))])
    
    #-----< groupAC >-----#
    groupAC = CLASS(name='groupAC', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _groupAC_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    groupAC._val = dict([('ExtnType', _groupAC_val_ExtnType), ('id', (2, 5, 29, 66))])
    
    #-----< noRevAvail >-----#
    noRevAvail = CLASS(name='noRevAvail', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _noRevAvail_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    noRevAvail._val = dict([('ExtnType', _noRevAvail_val_ExtnType), ('id', (2, 5, 29, 56))])
    
    #-----< sOAIdentifier >-----#
    sOAIdentifier = CLASS(name='sOAIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _sOAIdentifier_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    sOAIdentifier._val = dict([('ExtnType', _sOAIdentifier_val_ExtnType), ('id', (2, 5, 29, 50))])
    
    #-----< sOAIdentifierMatch >-----#
    sOAIdentifierMatch = CLASS(name='sOAIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _sOAIdentifierMatch_val_AssertionType = NULL(name='AssertionType', mode=MODE_TYPE)
    sOAIdentifierMatch._val = dict([('AssertionType', _sOAIdentifierMatch_val_AssertionType), ('id', (2, 5, 13, 66))])
    
    #-----< attributeDescriptor >-----#
    attributeDescriptor = CLASS(name='attributeDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _attributeDescriptor_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescriptorSyntax')))
    attributeDescriptor._val = dict([('ExtnType', _attributeDescriptor_val_ExtnType), ('id', (2, 5, 29, 48))])
    
    #-----< AttributeDescriptorSyntax >-----#
    AttributeDescriptorSyntax = SEQ(name='AttributeDescriptorSyntax', mode=MODE_TYPE)
    _AttributeDescriptorSyntax_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeIdentifier')))
    _AttributeDescriptorSyntax_attributeSyntax = OCT_STR(name='attributeSyntax', mode=MODE_TYPE)
    _AttributeDescriptorSyntax_attributeSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeDescriptorSyntax_name = STR_UTF8(name='name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeName')), opt=True)
    _AttributeDescriptorSyntax_description = STR_UTF8(name='description', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescription')), opt=True)
    _AttributeDescriptorSyntax_dominationRule = SEQ(name='dominationRule', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicyIdentifier')))
    AttributeDescriptorSyntax._cont = ASN1Dict([
        ('identifier', _AttributeDescriptorSyntax_identifier),
        ('attributeSyntax', _AttributeDescriptorSyntax_attributeSyntax),
        ('name', _AttributeDescriptorSyntax_name),
        ('description', _AttributeDescriptorSyntax_description),
        ('dominationRule', _AttributeDescriptorSyntax_dominationRule),
        ])
    AttributeDescriptorSyntax._ext = []
    
    #-----< AttributeIdentifier >-----#
    AttributeIdentifier = OID(name='AttributeIdentifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _AttributeIdentifier_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _AttributeIdentifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    AttributeIdentifier._const_tab = _AttributeIdentifier_tab
    AttributeIdentifier._const_tab_at = None
    AttributeIdentifier._const_tab_id = 'id'
    
    #-----< AttributeIDs >-----#
    AttributeIDs = CLASS(name='AttributeIDs', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    AttributeIDs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeName >-----#
    AttributeName = STR_UTF8(name='AttributeName', mode=MODE_TYPE)
    AttributeName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttributeDescription >-----#
    AttributeDescription = STR_UTF8(name='AttributeDescription', mode=MODE_TYPE)
    AttributeDescription._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PrivilegePolicyIdentifier >-----#
    PrivilegePolicyIdentifier = SEQ(name='PrivilegePolicyIdentifier', mode=MODE_TYPE)
    _PrivilegePolicyIdentifier_privilegePolicy = OID(name='privilegePolicy', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicy')))
    _PrivilegePolicyIdentifier_privPolSyntax = CHOICE(name='privPolSyntax', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    PrivilegePolicyIdentifier._cont = ASN1Dict([
        ('privilegePolicy', _PrivilegePolicyIdentifier_privilegePolicy),
        ('privPolSyntax', _PrivilegePolicyIdentifier_privPolSyntax),
        ])
    PrivilegePolicyIdentifier._ext = []
    
    #-----< attDescriptor >-----#
    attDescriptor = CLASS(name='attDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attDescriptor_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescriptorSyntax')))
    attDescriptor._val = dict([('AssertionType', _attDescriptor_val_AssertionType), ('id', (2, 5, 13, 58))])
    
    #-----< roleSpecCertIdentifier >-----#
    roleSpecCertIdentifier = CLASS(name='roleSpecCertIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _roleSpecCertIdentifier_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifierSyntax')))
    roleSpecCertIdentifier._val = dict([('ExtnType', _roleSpecCertIdentifier_val_ExtnType), ('id', (2, 5, 29, 39))])
    
    #-----< RoleSpecCertIdentifierSyntax >-----#
    RoleSpecCertIdentifierSyntax = SEQ_OF(name='RoleSpecCertIdentifierSyntax', mode=MODE_TYPE)
    _RoleSpecCertIdentifierSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifier')))
    RoleSpecCertIdentifierSyntax._cont = _RoleSpecCertIdentifierSyntax__item_
    RoleSpecCertIdentifierSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RoleSpecCertIdentifier >-----#
    RoleSpecCertIdentifier = SEQ(name='RoleSpecCertIdentifier', mode=MODE_TYPE)
    _RoleSpecCertIdentifier_roleName = CHOICE(name='roleName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _RoleSpecCertIdentifier_roleCertIssuer = CHOICE(name='roleCertIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _RoleSpecCertIdentifier_roleCertSerialNumber = INT(name='roleCertSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _RoleSpecCertIdentifier_roleCertLocator = SEQ_OF(name='roleCertLocator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    RoleSpecCertIdentifier._cont = ASN1Dict([
        ('roleName', _RoleSpecCertIdentifier_roleName),
        ('roleCertIssuer', _RoleSpecCertIdentifier_roleCertIssuer),
        ('roleCertSerialNumber', _RoleSpecCertIdentifier_roleCertSerialNumber),
        ('roleCertLocator', _RoleSpecCertIdentifier_roleCertLocator),
        ])
    RoleSpecCertIdentifier._ext = []
    
    #-----< roleSpecCertIdMatch >-----#
    roleSpecCertIdMatch = CLASS(name='roleSpecCertIdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _roleSpecCertIdMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifierSyntax')))
    roleSpecCertIdMatch._val = dict([('AssertionType', _roleSpecCertIdMatch_val_AssertionType), ('id', (2, 5, 13, 54))])
    
    #-----< basicAttConstraints >-----#
    basicAttConstraints = CLASS(name='basicAttConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _basicAttConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BasicAttConstraintsSyntax')))
    basicAttConstraints._val = dict([('ExtnType', _basicAttConstraints_val_ExtnType), ('id', (2, 5, 29, 41))])
    
    #-----< BasicAttConstraintsSyntax >-----#
    BasicAttConstraintsSyntax = SEQ(name='BasicAttConstraintsSyntax', mode=MODE_TYPE)
    _BasicAttConstraintsSyntax_authority = BOOL(name='authority', mode=MODE_TYPE, default=False)
    _BasicAttConstraintsSyntax_pathLenConstraint = INT(name='pathLenConstraint', mode=MODE_TYPE, opt=True)
    _BasicAttConstraintsSyntax_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    BasicAttConstraintsSyntax._cont = ASN1Dict([
        ('authority', _BasicAttConstraintsSyntax_authority),
        ('pathLenConstraint', _BasicAttConstraintsSyntax_pathLenConstraint),
        ])
    BasicAttConstraintsSyntax._ext = []
    
    #-----< basicAttConstraintsMatch >-----#
    basicAttConstraintsMatch = CLASS(name='basicAttConstraintsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _basicAttConstraintsMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BasicAttConstraintsSyntax')))
    basicAttConstraintsMatch._val = dict([('AssertionType', _basicAttConstraintsMatch_val_AssertionType), ('id', (2, 5, 13, 55))])
    
    #-----< delegatedNameConstraints >-----#
    delegatedNameConstraints = CLASS(name='delegatedNameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _delegatedNameConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    delegatedNameConstraints._val = dict([('ExtnType', _delegatedNameConstraints_val_ExtnType), ('id', (2, 5, 29, 42))])
    
    #-----< delegatedNameConstraintsMatch >-----#
    delegatedNameConstraintsMatch = CLASS(name='delegatedNameConstraintsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _delegatedNameConstraintsMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    delegatedNameConstraintsMatch._val = dict([('AssertionType', _delegatedNameConstraintsMatch_val_AssertionType), ('id', (2, 5, 13, 56))])
    
    #-----< acceptableCertPolicies >-----#
    acceptableCertPolicies = CLASS(name='acceptableCertPolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _acceptableCertPolicies_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptableCertPoliciesSyntax')))
    acceptableCertPolicies._val = dict([('ExtnType', _acceptableCertPolicies_val_ExtnType), ('id', (2, 5, 29, 52))])
    
    #-----< AcceptableCertPoliciesSyntax >-----#
    AcceptableCertPoliciesSyntax = SEQ_OF(name='AcceptableCertPoliciesSyntax', mode=MODE_TYPE)
    _AcceptableCertPoliciesSyntax__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'CertPolicyId')))
    AcceptableCertPoliciesSyntax._cont = _AcceptableCertPoliciesSyntax__item_
    AcceptableCertPoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertPolicyId >-----#
    CertPolicyId = OID(name='CertPolicyId', mode=MODE_TYPE)
    
    #-----< acceptableCertPoliciesMatch >-----#
    acceptableCertPoliciesMatch = CLASS(name='acceptableCertPoliciesMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _acceptableCertPoliciesMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptableCertPoliciesSyntax')))
    acceptableCertPoliciesMatch._val = dict([('AssertionType', _acceptableCertPoliciesMatch_val_AssertionType), ('id', (2, 5, 13, 59))])
    
    #-----< authorityAttributeIdentifier >-----#
    authorityAttributeIdentifier = CLASS(name='authorityAttributeIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityAttributeIdentifier_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthorityAttributeIdentifierSyntax')))
    authorityAttributeIdentifier._val = dict([('ExtnType', _authorityAttributeIdentifier_val_ExtnType), ('id', (2, 5, 29, 38))])
    
    #-----< AuthorityAttributeIdentifierSyntax >-----#
    AuthorityAttributeIdentifierSyntax = SEQ_OF(name='AuthorityAttributeIdentifierSyntax', mode=MODE_TYPE)
    _AuthorityAttributeIdentifierSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthAttId')))
    AuthorityAttributeIdentifierSyntax._cont = _AuthorityAttributeIdentifierSyntax__item_
    AuthorityAttributeIdentifierSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AuthAttId >-----#
    AuthAttId = SEQ(name='AuthAttId', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    
    #-----< authAttIdMatch >-----#
    authAttIdMatch = CLASS(name='authAttIdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _authAttIdMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthorityAttributeIdentifierSyntax')))
    authAttIdMatch._val = dict([('AssertionType', _authAttIdMatch_val_AssertionType), ('id', (2, 5, 13, 53))])
    
    #-----< indirectIssuer >-----#
    indirectIssuer = CLASS(name='indirectIssuer', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _indirectIssuer_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    indirectIssuer._val = dict([('ExtnType', _indirectIssuer_val_ExtnType), ('id', (2, 5, 29, 61))])
    
    #-----< issuedOnBehalfOf >-----#
    issuedOnBehalfOf = CLASS(name='issuedOnBehalfOf', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuedOnBehalfOf_val_ExtnType = CHOICE(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    issuedOnBehalfOf._val = dict([('ExtnType', _issuedOnBehalfOf_val_ExtnType), ('id', (2, 5, 29, 64))])
    
    #-----< noAssertion >-----#
    noAssertion = CLASS(name='noAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _noAssertion_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    noAssertion._val = dict([('ExtnType', _noAssertion_val_ExtnType), ('id', (2, 5, 29, 62))])
    
    #-----< allowedAttributeAssignments >-----#
    allowedAttributeAssignments = CLASS(name='allowedAttributeAssignments', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _allowedAttributeAssignments_val_ExtnType = SET_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AllowedAttributeAssignments')))
    allowedAttributeAssignments._val = dict([('ExtnType', _allowedAttributeAssignments_val_ExtnType), ('id', (2, 5, 29, 67))])
    
    #-----< AllowedAttributeAssignments >-----#
    AllowedAttributeAssignments = SET_OF(name='AllowedAttributeAssignments', mode=MODE_TYPE)
    _AllowedAttributeAssignments__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AllowedAttributeAssignments__item__attributes = SET_OF(name='attributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllowedAttributeAssignments__item__attributes__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ____AllowedAttributeAssignments__item__attributes__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues = SEQ(name='attributeTypeandValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab._val = ASN1Set(rv=[dict([('Type', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab_at = None
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab_id = 'id'
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab_at = ('..', '..', 'type')
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab_id = 'Type'
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values._cont = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab_id = 'Type'
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList._cont = ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value),
        ('contextList', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList),
        ])
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_._ext = []
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext._cont = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues._cont = ASN1Dict([
        ('type', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type),
        ('values', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values),
        ('valuesWithContext', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext),
        ])
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues._ext = []
    ___AllowedAttributeAssignments__item__attributes__item_._cont = ASN1Dict([
        ('attributeType', ____AllowedAttributeAssignments__item__attributes__item__attributeType),
        ('attributeTypeandValues', ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues),
        ])
    ___AllowedAttributeAssignments__item__attributes__item_._ext = []
    __AllowedAttributeAssignments__item__attributes._cont = ___AllowedAttributeAssignments__item__attributes__item_
    __AllowedAttributeAssignments__item__holderDomain = CHOICE(name='holderDomain', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _AllowedAttributeAssignments__item_._cont = ASN1Dict([
        ('attributes', __AllowedAttributeAssignments__item__attributes),
        ('holderDomain', __AllowedAttributeAssignments__item__holderDomain),
        ])
    _AllowedAttributeAssignments__item_._ext = []
    AllowedAttributeAssignments._cont = _AllowedAttributeAssignments__item_
    
    #-----< attributeMappings >-----#
    attributeMappings = CLASS(name='attributeMappings', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _attributeMappings_val_ExtnType = SET_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeMappings')))
    attributeMappings._val = dict([('ExtnType', _attributeMappings_val_ExtnType), ('id', (2, 5, 29, 68))])
    
    #-----< AttributeMappings >-----#
    AttributeMappings = SET_OF(name='AttributeMappings', mode=MODE_TYPE)
    _AttributeMappings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __AttributeMappings__item__typeMappings = SEQ(name='typeMappings', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AttributeMappings__item__typeMappings_local = OID(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___AttributeMappings__item__typeMappings_remote = OID(name='remote', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __AttributeMappings__item__typeMappings._cont = ASN1Dict([
        ('local', ___AttributeMappings__item__typeMappings_local),
        ('remote', ___AttributeMappings__item__typeMappings_remote),
        ])
    __AttributeMappings__item__typeMappings._ext = []
    __AttributeMappings__item__typeValueMappings = SEQ(name='typeValueMappings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AttributeMappings__item__typeValueMappings_local = SEQ(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    ___AttributeMappings__item__typeValueMappings_remote = SEQ(name='remote', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    __AttributeMappings__item__typeValueMappings._cont = ASN1Dict([
        ('local', ___AttributeMappings__item__typeValueMappings_local),
        ('remote', ___AttributeMappings__item__typeValueMappings_remote),
        ])
    __AttributeMappings__item__typeValueMappings._ext = []
    _AttributeMappings__item_._cont = ASN1Dict([
        ('typeMappings', __AttributeMappings__item__typeMappings),
        ('typeValueMappings', __AttributeMappings__item__typeValueMappings),
        ])
    _AttributeMappings__item_._ext = None
    AttributeMappings._cont = _AttributeMappings__item_
    
    #-----< holderNameConstraints >-----#
    holderNameConstraints = CLASS(name='holderNameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _holderNameConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'HolderNameConstraintsSyntax')))
    holderNameConstraints._val = dict([('ExtnType', _holderNameConstraints_val_ExtnType), ('id', (2, 5, 29, 69))])
    
    #-----< HolderNameConstraintsSyntax >-----#
    HolderNameConstraintsSyntax = SEQ(name='HolderNameConstraintsSyntax', mode=MODE_TYPE)
    _HolderNameConstraintsSyntax_permittedSubtrees = SEQ_OF(name='permittedSubtrees', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtrees')))
    _HolderNameConstraintsSyntax_excludedSubtrees = SEQ_OF(name='excludedSubtrees', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtrees')), opt=True)
    HolderNameConstraintsSyntax._cont = ASN1Dict([
        ('permittedSubtrees', _HolderNameConstraintsSyntax_permittedSubtrees),
        ('excludedSubtrees', _HolderNameConstraintsSyntax_excludedSubtrees),
        ])
    HolderNameConstraintsSyntax._ext = []
    
    #-----< GeneralSubtrees >-----#
    GeneralSubtrees = SEQ_OF(name='GeneralSubtrees', mode=MODE_TYPE)
    _GeneralSubtrees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtree')))
    GeneralSubtrees._cont = _GeneralSubtrees__item_
    GeneralSubtrees._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralSubtree >-----#
    GeneralSubtree = SEQ(name='GeneralSubtree', mode=MODE_TYPE)
    _GeneralSubtree_base = CHOICE(name='base', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _GeneralSubtree_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BaseDistance')), default=0)
    _GeneralSubtree_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BaseDistance')), opt=True)
    GeneralSubtree._cont = ASN1Dict([
        ('base', _GeneralSubtree_base),
        ('minimum', _GeneralSubtree_minimum),
        ('maximum', _GeneralSubtree_maximum),
        ])
    GeneralSubtree._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name='BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< pmiUser >-----#
    pmiUser = CLASS(name='pmiUser', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    __pmiUser_OptionalAttributes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateExactAssertion')))
    pmiUser._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 58))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 24))])
    
    #-----< pmiAA >-----#
    pmiAA = CLASS(name='pmiAA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    __pmiUser_OptionalAttributes_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    pmiAA._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 61))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AttrCertificateRevocationList']), ('ldapDesc', 'X.509 Attr certificate revocation list'), ('id', (2, 5, 4, 59))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AACertificateRevocationList']), ('ldapDesc', 'X.509 AA certificate revocation list'), ('id', (2, 5, 4, 63))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 25))])
    
    #-----< pmiSOA >-----#
    pmiSOA = CLASS(name='pmiSOA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_2_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    pmiSOA._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AttrCertificateRevocationList']), ('ldapDesc', 'X.509 Attr certificate revocation list'), ('id', (2, 5, 4, 59))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AACertificateRevocationList']), ('ldapDesc', 'X.509 AA certificate revocation list'), ('id', (2, 5, 4, 63))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 62))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 26))])
    
    #-----< attCertCRLDistributionPt >-----#
    attCertCRLDistributionPt = CLASS(name='attCertCRLDistributionPt', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    attCertCRLDistributionPt._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AttrCertificateRevocationList']), ('ldapDesc', 'X.509 Attr certificate revocation list'), ('id', (2, 5, 4, 59))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AACertificateRevocationList']), ('ldapDesc', 'X.509 AA certificate revocation list'), ('id', (2, 5, 4, 63))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 27))])
    
    #-----< pmiDelegationPath >-----#
    pmiDelegationPath = CLASS(name='pmiDelegationPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertPath')))
    pmiDelegationPath._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_1), ('id', (2, 5, 4, 73))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 33))])
    
    #-----< privilegePolicy >-----#
    privilegePolicy = CLASS(name='privilegePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    privilegePolicy._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_2), ('id', (2, 5, 4, 71))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 32))])
    
    #-----< protectedPrivilegePolicy >-----#
    protectedPrivilegePolicy = CLASS(name='protectedPrivilegePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    protectedPrivilegePolicy._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 74))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 34))])
    
    #-----< attributeCertificateAttribute >-----#
    attributeCertificateAttribute = CLASS(name='attributeCertificateAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCertificateAttribute_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    attributeCertificateAttribute._val = dict([('Type', _attributeCertificateAttribute_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 58))])
    
    #-----< aACertificate >-----#
    aACertificate = CLASS(name='aACertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _aACertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    aACertificate._val = dict([('Type', _aACertificate_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 61))])
    
    #-----< attributeDescriptorCertificate >-----#
    attributeDescriptorCertificate = CLASS(name='attributeDescriptorCertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeDescriptorCertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    attributeDescriptorCertificate._val = dict([('Type', _attributeDescriptorCertificate_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 62))])
    
    #-----< attributeCertificateRevocationList >-----#
    attributeCertificateRevocationList = CLASS(name='attributeCertificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCertificateRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    attributeCertificateRevocationList._val = dict([('Type', _attributeCertificateRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AttrCertificateRevocationList']), ('ldapDesc', 'X.509 Attr certificate revocation list'), ('id', (2, 5, 4, 59))])
    
    #-----< eeAttrCertificateRevocationList >-----#
    eeAttrCertificateRevocationList = CLASS(name='eeAttrCertificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _eeAttrCertificateRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    eeAttrCertificateRevocationList._val = dict([('Type', _eeAttrCertificateRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['EEAttrCertificateRevocationList']), ('ldapDesc', 'X.509 EEAttr certificate revocation list'), ('id', (2, 5, 4, 102))])
    
    #-----< attributeAuthorityRevocationList >-----#
    attributeAuthorityRevocationList = CLASS(name='attributeAuthorityRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeAuthorityRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    attributeAuthorityRevocationList._val = dict([('Type', _attributeAuthorityRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['AACertificateRevocationList']), ('ldapDesc', 'X.509 AA certificate revocation list'), ('id', (2, 5, 4, 63))])
    
    #-----< delegationPath >-----#
    delegationPath = CLASS(name='delegationPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _delegationPath_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertPath')))
    delegationPath._val = dict([('Type', _delegationPath_val_Type), ('id', (2, 5, 4, 73))])
    
    #-----< AttCertPath >-----#
    AttCertPath = SEQ_OF(name='AttCertPath', mode=MODE_TYPE)
    _AttCertPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    AttCertPath._cont = _AttCertPath__item_
    
    #-----< privPolicy >-----#
    privPolicy = CLASS(name='privPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _privPolicy_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    privPolicy._val = dict([('Type', _privPolicy_val_Type), ('id', (2, 5, 4, 71))])
    
    #-----< protPrivPolicy >-----#
    protPrivPolicy = CLASS(name='protPrivPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _protPrivPolicy_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    protPrivPolicy._val = dict([('Type', _protPrivPolicy_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 74))])
    
    #-----< xmlPrivPolicy >-----#
    xmlPrivPolicy = CLASS(name='xmlPrivPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _xmlPrivPolicy_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    xmlPrivPolicy._val = dict([('Type', _xmlPrivPolicy_val_Type), ('id', (2, 5, 4, 76))])
    
    #-----< attributeCertificateExactMatch >-----#
    attributeCertificateExactMatch = CLASS(name='attributeCertificateExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attributeCertificateExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateExactAssertion')))
    attributeCertificateExactMatch._val = dict([('AssertionType', _attributeCertificateExactMatch_val_AssertionType), ('id', (2, 5, 13, 45))])
    
    #-----< AttributeCertificateExactAssertion >-----#
    AttributeCertificateExactAssertion = SEQ(name='AttributeCertificateExactAssertion', mode=MODE_TYPE)
    _AttributeCertificateExactAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _AttributeCertificateExactAssertion_issuer = SEQ(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    AttributeCertificateExactAssertion._cont = ASN1Dict([
        ('serialNumber', _AttributeCertificateExactAssertion_serialNumber),
        ('issuer', _AttributeCertificateExactAssertion_issuer),
        ])
    AttributeCertificateExactAssertion._ext = []
    
    #-----< attributeCertificateMatch >-----#
    attributeCertificateMatch = CLASS(name='attributeCertificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attributeCertificateMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateAssertion')))
    attributeCertificateMatch._val = dict([('AssertionType', _attributeCertificateMatch_val_AssertionType), ('id', (2, 5, 13, 42))])
    
    #-----< AttributeCertificateAssertion >-----#
    AttributeCertificateAssertion = SEQ(name='AttributeCertificateAssertion', mode=MODE_TYPE)
    _AttributeCertificateAssertion_holder = CHOICE(name='holder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AttributeCertificateAssertion_holder_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    __AttributeCertificateAssertion_holder_holderName = SEQ_OF(name='holderName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _AttributeCertificateAssertion_holder._cont = ASN1Dict([
        ('baseCertificateID', __AttributeCertificateAssertion_holder_baseCertificateID),
        ('holderName', __AttributeCertificateAssertion_holder_holderName),
        ])
    _AttributeCertificateAssertion_holder._ext = []
    _AttributeCertificateAssertion_issuer = SEQ_OF(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AttributeCertificateAssertion_attCertValidity = TIME_GEN(name='attCertValidity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AttributeCertificateAssertion_attType = SET_OF(name='attType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AttributeCertificateAssertion_attType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _AttributeCertificateAssertion_attType._cont = __AttributeCertificateAssertion_attType__item_
    AttributeCertificateAssertion._cont = ASN1Dict([
        ('holder', _AttributeCertificateAssertion_holder),
        ('issuer', _AttributeCertificateAssertion_issuer),
        ('attCertValidity', _AttributeCertificateAssertion_attCertValidity),
        ('attType', _AttributeCertificateAssertion_attType),
        ])
    AttributeCertificateAssertion._ext = []
    
    #-----< holderIssuerMatch >-----#
    holderIssuerMatch = CLASS(name='holderIssuerMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _holderIssuerMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'HolderIssuerAssertion')))
    holderIssuerMatch._val = dict([('AssertionType', _holderIssuerMatch_val_AssertionType), ('id', (2, 5, 13, 46))])
    
    #-----< HolderIssuerAssertion >-----#
    HolderIssuerAssertion = SEQ(name='HolderIssuerAssertion', mode=MODE_TYPE)
    _HolderIssuerAssertion_holder = SEQ(name='holder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')), opt=True)
    _HolderIssuerAssertion_issuer = SEQ(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')), opt=True)
    HolderIssuerAssertion._cont = ASN1Dict([
        ('holder', _HolderIssuerAssertion_holder),
        ('issuer', _HolderIssuerAssertion_issuer),
        ])
    HolderIssuerAssertion._ext = []
    
    #-----< delegationPathMatch >-----#
    delegationPathMatch = CLASS(name='delegationPathMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _delegationPathMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DelMatchSyntax')))
    delegationPathMatch._val = dict([('AssertionType', _delegationPathMatch_val_AssertionType), ('id', (2, 5, 13, 61))])
    
    #-----< DelMatchSyntax >-----#
    DelMatchSyntax = SEQ(name='DelMatchSyntax', mode=MODE_TYPE)
    _DelMatchSyntax_firstIssuer = SEQ(name='firstIssuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    _DelMatchSyntax_lastHolder = SEQ(name='lastHolder', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')))
    DelMatchSyntax._cont = ASN1Dict([
        ('firstIssuer', _DelMatchSyntax_firstIssuer),
        ('lastHolder', _DelMatchSyntax_lastHolder),
        ])
    DelMatchSyntax._ext = []
    
    #-----< extensionPresenceMatch >-----#
    extensionPresenceMatch = CLASS(name='extensionPresenceMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _extensionPresenceMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'EXTENSION'), ['id']))
    extensionPresenceMatch._val = dict([('AssertionType', _extensionPresenceMatch_val_AssertionType), ('id', (2, 5, 13, 67))])
    
    #-----< id-oc-pmiUser >-----#
    id_oc_pmiUser = OID(name='id-oc-pmiUser', mode=MODE_VALUE)
    id_oc_pmiUser._val = (2, 5, 6, 24)
    
    #-----< id-oc-pmiAA >-----#
    id_oc_pmiAA = OID(name='id-oc-pmiAA', mode=MODE_VALUE)
    id_oc_pmiAA._val = (2, 5, 6, 25)
    
    #-----< id-oc-pmiSOA >-----#
    id_oc_pmiSOA = OID(name='id-oc-pmiSOA', mode=MODE_VALUE)
    id_oc_pmiSOA._val = (2, 5, 6, 26)
    
    #-----< id-oc-attCertCRLDistributionPts >-----#
    id_oc_attCertCRLDistributionPts = OID(name='id-oc-attCertCRLDistributionPts', mode=MODE_VALUE)
    id_oc_attCertCRLDistributionPts._val = (2, 5, 6, 27)
    
    #-----< id-oc-privilegePolicy >-----#
    id_oc_privilegePolicy = OID(name='id-oc-privilegePolicy', mode=MODE_VALUE)
    id_oc_privilegePolicy._val = (2, 5, 6, 32)
    
    #-----< id-oc-pmiDelegationPath >-----#
    id_oc_pmiDelegationPath = OID(name='id-oc-pmiDelegationPath', mode=MODE_VALUE)
    id_oc_pmiDelegationPath._val = (2, 5, 6, 33)
    
    #-----< id-oc-protectedPrivilegePolicy >-----#
    id_oc_protectedPrivilegePolicy = OID(name='id-oc-protectedPrivilegePolicy', mode=MODE_VALUE)
    id_oc_protectedPrivilegePolicy._val = (2, 5, 6, 34)
    
    #-----< id-at-attributeCertificate >-----#
    id_at_attributeCertificate = OID(name='id-at-attributeCertificate', mode=MODE_VALUE)
    id_at_attributeCertificate._val = (2, 5, 4, 58)
    
    #-----< id-at-attributeCertificateRevocationList >-----#
    id_at_attributeCertificateRevocationList = OID(name='id-at-attributeCertificateRevocationList', mode=MODE_VALUE)
    id_at_attributeCertificateRevocationList._val = (2, 5, 4, 59)
    
    #-----< id-at-aACertificate >-----#
    id_at_aACertificate = OID(name='id-at-aACertificate', mode=MODE_VALUE)
    id_at_aACertificate._val = (2, 5, 4, 61)
    
    #-----< id-at-attributeDescriptorCertificate >-----#
    id_at_attributeDescriptorCertificate = OID(name='id-at-attributeDescriptorCertificate', mode=MODE_VALUE)
    id_at_attributeDescriptorCertificate._val = (2, 5, 4, 62)
    
    #-----< id-at-attributeAuthorityRevocationList >-----#
    id_at_attributeAuthorityRevocationList = OID(name='id-at-attributeAuthorityRevocationList', mode=MODE_VALUE)
    id_at_attributeAuthorityRevocationList._val = (2, 5, 4, 63)
    
    #-----< id-at-privPolicy >-----#
    id_at_privPolicy = OID(name='id-at-privPolicy', mode=MODE_VALUE)
    id_at_privPolicy._val = (2, 5, 4, 71)
    
    #-----< id-at-role >-----#
    id_at_role = OID(name='id-at-role', mode=MODE_VALUE)
    id_at_role._val = (2, 5, 4, 72)
    
    #-----< id-at-delegationPath >-----#
    id_at_delegationPath = OID(name='id-at-delegationPath', mode=MODE_VALUE)
    id_at_delegationPath._val = (2, 5, 4, 73)
    
    #-----< id-at-protPrivPolicy >-----#
    id_at_protPrivPolicy = OID(name='id-at-protPrivPolicy', mode=MODE_VALUE)
    id_at_protPrivPolicy._val = (2, 5, 4, 74)
    
    #-----< id-at-xMLPrivilegeInfo >-----#
    id_at_xMLPrivilegeInfo = OID(name='id-at-xMLPrivilegeInfo', mode=MODE_VALUE)
    id_at_xMLPrivilegeInfo._val = (2, 5, 4, 75)
    
    #-----< id-at-xmlPrivPolicy >-----#
    id_at_xmlPrivPolicy = OID(name='id-at-xmlPrivPolicy', mode=MODE_VALUE)
    id_at_xmlPrivPolicy._val = (2, 5, 4, 76)
    
    #-----< id-at-permission >-----#
    id_at_permission = OID(name='id-at-permission', mode=MODE_VALUE)
    id_at_permission._val = (2, 5, 4, 82)
    
    #-----< id-at-eeAttrCertificateRevocationList >-----#
    id_at_eeAttrCertificateRevocationList = OID(name='id-at-eeAttrCertificateRevocationList', mode=MODE_VALUE)
    id_at_eeAttrCertificateRevocationList._val = (2, 5, 4, 102)
    
    #-----< id-ce-authorityAttributeIdentifier >-----#
    id_ce_authorityAttributeIdentifier = OID(name='id-ce-authorityAttributeIdentifier', mode=MODE_VALUE)
    id_ce_authorityAttributeIdentifier._val = (2, 5, 29, 38)
    
    #-----< id-ce-roleSpecCertIdentifier >-----#
    id_ce_roleSpecCertIdentifier = OID(name='id-ce-roleSpecCertIdentifier', mode=MODE_VALUE)
    id_ce_roleSpecCertIdentifier._val = (2, 5, 29, 39)
    
    #-----< id-ce-basicAttConstraints >-----#
    id_ce_basicAttConstraints = OID(name='id-ce-basicAttConstraints', mode=MODE_VALUE)
    id_ce_basicAttConstraints._val = (2, 5, 29, 41)
    
    #-----< id-ce-delegatedNameConstraints >-----#
    id_ce_delegatedNameConstraints = OID(name='id-ce-delegatedNameConstraints', mode=MODE_VALUE)
    id_ce_delegatedNameConstraints._val = (2, 5, 29, 42)
    
    #-----< id-ce-timeSpecification >-----#
    id_ce_timeSpecification = OID(name='id-ce-timeSpecification', mode=MODE_VALUE)
    id_ce_timeSpecification._val = (2, 5, 29, 43)
    
    #-----< id-ce-attributeDescriptor >-----#
    id_ce_attributeDescriptor = OID(name='id-ce-attributeDescriptor', mode=MODE_VALUE)
    id_ce_attributeDescriptor._val = (2, 5, 29, 48)
    
    #-----< id-ce-userNotice >-----#
    id_ce_userNotice = OID(name='id-ce-userNotice', mode=MODE_VALUE)
    id_ce_userNotice._val = (2, 5, 29, 49)
    
    #-----< id-ce-sOAIdentifier >-----#
    id_ce_sOAIdentifier = OID(name='id-ce-sOAIdentifier', mode=MODE_VALUE)
    id_ce_sOAIdentifier._val = (2, 5, 29, 50)
    
    #-----< id-ce-acceptableCertPolicies >-----#
    id_ce_acceptableCertPolicies = OID(name='id-ce-acceptableCertPolicies', mode=MODE_VALUE)
    id_ce_acceptableCertPolicies._val = (2, 5, 29, 52)
    
    #-----< id-ce-targetingInformation >-----#
    id_ce_targetingInformation = OID(name='id-ce-targetingInformation', mode=MODE_VALUE)
    id_ce_targetingInformation._val = (2, 5, 29, 55)
    
    #-----< id-ce-noRevAvail >-----#
    id_ce_noRevAvail = OID(name='id-ce-noRevAvail', mode=MODE_VALUE)
    id_ce_noRevAvail._val = (2, 5, 29, 56)
    
    #-----< id-ce-acceptablePrivilegePolicies >-----#
    id_ce_acceptablePrivilegePolicies = OID(name='id-ce-acceptablePrivilegePolicies', mode=MODE_VALUE)
    id_ce_acceptablePrivilegePolicies._val = (2, 5, 29, 57)
    
    #-----< id-ce-indirectIssuer >-----#
    id_ce_indirectIssuer = OID(name='id-ce-indirectIssuer', mode=MODE_VALUE)
    id_ce_indirectIssuer._val = (2, 5, 29, 61)
    
    #-----< id-ce-noAssertion >-----#
    id_ce_noAssertion = OID(name='id-ce-noAssertion', mode=MODE_VALUE)
    id_ce_noAssertion._val = (2, 5, 29, 62)
    
    #-----< id-ce-issuedOnBehalfOf >-----#
    id_ce_issuedOnBehalfOf = OID(name='id-ce-issuedOnBehalfOf', mode=MODE_VALUE)
    id_ce_issuedOnBehalfOf._val = (2, 5, 29, 64)
    
    #-----< id-ce-singleUse >-----#
    id_ce_singleUse = OID(name='id-ce-singleUse', mode=MODE_VALUE)
    id_ce_singleUse._val = (2, 5, 29, 65)
    
    #-----< id-ce-groupAC >-----#
    id_ce_groupAC = OID(name='id-ce-groupAC', mode=MODE_VALUE)
    id_ce_groupAC._val = (2, 5, 29, 66)
    
    #-----< id-ce-allowedAttributeAssignments >-----#
    id_ce_allowedAttributeAssignments = OID(name='id-ce-allowedAttributeAssignments', mode=MODE_VALUE)
    id_ce_allowedAttributeAssignments._val = (2, 5, 29, 67)
    
    #-----< id-ce-attributeMappings >-----#
    id_ce_attributeMappings = OID(name='id-ce-attributeMappings', mode=MODE_VALUE)
    id_ce_attributeMappings._val = (2, 5, 29, 68)
    
    #-----< id-ce-holderNameConstraints >-----#
    id_ce_holderNameConstraints = OID(name='id-ce-holderNameConstraints', mode=MODE_VALUE)
    id_ce_holderNameConstraints._val = (2, 5, 29, 69)
    
    #-----< id-mr-attributeCertificateMatch >-----#
    id_mr_attributeCertificateMatch = OID(name='id-mr-attributeCertificateMatch', mode=MODE_VALUE)
    id_mr_attributeCertificateMatch._val = (2, 5, 13, 42)
    
    #-----< id-mr-attributeCertificateExactMatch >-----#
    id_mr_attributeCertificateExactMatch = OID(name='id-mr-attributeCertificateExactMatch', mode=MODE_VALUE)
    id_mr_attributeCertificateExactMatch._val = (2, 5, 13, 45)
    
    #-----< id-mr-holderIssuerMatch >-----#
    id_mr_holderIssuerMatch = OID(name='id-mr-holderIssuerMatch', mode=MODE_VALUE)
    id_mr_holderIssuerMatch._val = (2, 5, 13, 46)
    
    #-----< id-mr-authAttIdMatch >-----#
    id_mr_authAttIdMatch = OID(name='id-mr-authAttIdMatch', mode=MODE_VALUE)
    id_mr_authAttIdMatch._val = (2, 5, 13, 53)
    
    #-----< id-mr-roleSpecCertIdMatch >-----#
    id_mr_roleSpecCertIdMatch = OID(name='id-mr-roleSpecCertIdMatch', mode=MODE_VALUE)
    id_mr_roleSpecCertIdMatch._val = (2, 5, 13, 54)
    
    #-----< id-mr-basicAttConstraintsMatch >-----#
    id_mr_basicAttConstraintsMatch = OID(name='id-mr-basicAttConstraintsMatch', mode=MODE_VALUE)
    id_mr_basicAttConstraintsMatch._val = (2, 5, 13, 55)
    
    #-----< id-mr-delegatedNameConstraintsMatch >-----#
    id_mr_delegatedNameConstraintsMatch = OID(name='id-mr-delegatedNameConstraintsMatch', mode=MODE_VALUE)
    id_mr_delegatedNameConstraintsMatch._val = (2, 5, 13, 56)
    
    #-----< id-mr-timeSpecMatch >-----#
    id_mr_timeSpecMatch = OID(name='id-mr-timeSpecMatch', mode=MODE_VALUE)
    id_mr_timeSpecMatch._val = (2, 5, 13, 57)
    
    #-----< id-mr-attDescriptorMatch >-----#
    id_mr_attDescriptorMatch = OID(name='id-mr-attDescriptorMatch', mode=MODE_VALUE)
    id_mr_attDescriptorMatch._val = (2, 5, 13, 58)
    
    #-----< id-mr-acceptableCertPoliciesMatch >-----#
    id_mr_acceptableCertPoliciesMatch = OID(name='id-mr-acceptableCertPoliciesMatch', mode=MODE_VALUE)
    id_mr_acceptableCertPoliciesMatch._val = (2, 5, 13, 59)
    
    #-----< id-mr-delegationPathMatch >-----#
    id_mr_delegationPathMatch = OID(name='id-mr-delegationPathMatch', mode=MODE_VALUE)
    id_mr_delegationPathMatch._val = (2, 5, 13, 61)
    
    #-----< id-mr-sOAIdentifierMatch >-----#
    id_mr_sOAIdentifierMatch = OID(name='id-mr-sOAIdentifierMatch', mode=MODE_VALUE)
    id_mr_sOAIdentifierMatch._val = (2, 5, 13, 66)
    
    #-----< id-mr-extensionPresenceMatch >-----#
    id_mr_extensionPresenceMatch = OID(name='id-mr-extensionPresenceMatch', mode=MODE_VALUE)
    id_mr_extensionPresenceMatch._val = (2, 5, 13, 67)
    
    #-----< id-mr-dualStringMatch >-----#
    id_mr_dualStringMatch = OID(name='id-mr-dualStringMatch', mode=MODE_VALUE)
    id_mr_dualStringMatch._val = (2, 5, 13, 69)
    
    _all_ = [
        _AttributeCertificate_toBeSigned,
        ___AttributeCertificate_algorithmIdentifier_algorithm_tab,
        __AttributeCertificate_algorithmIdentifier_algorithm,
        ___AttributeCertificate_algorithmIdentifier_parameters_tab,
        __AttributeCertificate_algorithmIdentifier_parameters,
        _AttributeCertificate_algorithmIdentifier,
        _AttributeCertificate_signature,
        AttributeCertificate,
        _TBSAttributeCertificate_version,
        _TBSAttributeCertificate_holder,
        _TBSAttributeCertificate_issuer,
        ___TBSAttributeCertificate_signature_algorithm_tab,
        __TBSAttributeCertificate_signature_algorithm,
        ___TBSAttributeCertificate_signature_parameters_tab,
        __TBSAttributeCertificate_signature_parameters,
        _TBSAttributeCertificate_signature,
        _TBSAttributeCertificate_serialNumber,
        _TBSAttributeCertificate_attrCertValidityPeriod,
        ____TBSAttributeCertificate_attributes__item__type_tab,
        _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___TBSAttributeCertificate_attributes__item__type,
        ____TBSAttributeCertificate_attributes__item__values__item_,
        ___TBSAttributeCertificate_attributes__item__values,
        _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value,
        ______TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList__item_,
        _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList,
        ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_,
        ___TBSAttributeCertificate_attributes__item__valuesWithContext,
        __TBSAttributeCertificate_attributes__item_,
        _TBSAttributeCertificate_attributes,
        _TBSAttributeCertificate_issuerUniqueID,
        _TBSAttributeCertificate_extensions,
        TBSAttributeCertificate,
        AttCertVersion,
        _Holder_baseCertificateID,
        _Holder_entityName,
        _Holder_objectDigestInfo,
        Holder,
        _IssuerSerial_issuer,
        _IssuerSerial_serial,
        _IssuerSerial_issuerUID,
        IssuerSerial,
        _ObjectDigestInfo_digestedObjectType,
        _ObjectDigestInfo_otherObjectTypeID,
        ___ObjectDigestInfo_digestAlgorithm_algorithm_tab,
        __ObjectDigestInfo_digestAlgorithm_algorithm,
        ___ObjectDigestInfo_digestAlgorithm_parameters_tab,
        __ObjectDigestInfo_digestAlgorithm_parameters,
        _ObjectDigestInfo_digestAlgorithm,
        _ObjectDigestInfo_objectDigest,
        ObjectDigestInfo,
        _AttCertIssuer_issuerName,
        _AttCertIssuer_baseCertificateID,
        _AttCertIssuer_objectDigestInfo,
        AttCertIssuer,
        _AttCertValidityPeriod_notBeforeTime,
        _AttCertValidityPeriod_notAfterTime,
        AttCertValidityPeriod,
        _AttributeCertificationPath_attributeCertificate,
        __AttributeCertificationPath_acPath__item_,
        _AttributeCertificationPath_acPath,
        AttributeCertificationPath,
        _ACPathData_certificate,
        _ACPathData_attributeCertificate,
        ACPathData,
        PrivilegePolicy,
        role,
        _role_val_Type,
        _RoleSyntax_roleAuthority,
        _RoleSyntax_roleName,
        RoleSyntax,
        xmlPrivilegeInfo,
        _xmlPrivilegeInfo_val_Type,
        permission,
        _permission_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1,
        _DualStringSyntax_operation,
        _DualStringSyntax_object,
        DualStringSyntax,
        dualStringMatch,
        _dualStringMatch_val_AssertionType,
        timeSpecification,
        _timeSpecification_val_ExtnType,
        timeSpecificationMatch,
        _timeSpecificationMatch_val_AssertionType,
        targetingInformation,
        __targetingInformation_val_ExtnType__item_,
        _targetingInformation_val_ExtnType,
        _Targets__item_,
        Targets,
        _Target_targetName,
        _Target_targetGroup,
        _Target_targetCert,
        Target,
        _TargetCert_targetCertificate,
        _TargetCert_targetName,
        _TargetCert_certDigestInfo,
        TargetCert,
        userNotice,
        __userNotice_val_ExtnType__item_,
        _userNotice_val_ExtnType,
        acceptablePrivilegePolicies,
        _acceptablePrivilegePolicies_val_ExtnType,
        _AcceptablePrivilegePoliciesSyntax__item_,
        AcceptablePrivilegePoliciesSyntax,
        singleUse,
        _singleUse_val_ExtnType,
        groupAC,
        _groupAC_val_ExtnType,
        noRevAvail,
        _noRevAvail_val_ExtnType,
        sOAIdentifier,
        _sOAIdentifier_val_ExtnType,
        sOAIdentifierMatch,
        _sOAIdentifierMatch_val_AssertionType,
        attributeDescriptor,
        _attributeDescriptor_val_ExtnType,
        _AttributeDescriptorSyntax_identifier,
        _AttributeDescriptorSyntax_attributeSyntax,
        _AttributeDescriptorSyntax_name,
        _AttributeDescriptorSyntax_description,
        _AttributeDescriptorSyntax_dominationRule,
        AttributeDescriptorSyntax,
        _AttributeIdentifier_tab,
        AttributeIdentifier,
        AttributeIDs,
        AttributeName,
        AttributeDescription,
        _PrivilegePolicyIdentifier_privilegePolicy,
        _PrivilegePolicyIdentifier_privPolSyntax,
        PrivilegePolicyIdentifier,
        attDescriptor,
        _attDescriptor_val_AssertionType,
        roleSpecCertIdentifier,
        _roleSpecCertIdentifier_val_ExtnType,
        _RoleSpecCertIdentifierSyntax__item_,
        RoleSpecCertIdentifierSyntax,
        _RoleSpecCertIdentifier_roleName,
        _RoleSpecCertIdentifier_roleCertIssuer,
        _RoleSpecCertIdentifier_roleCertSerialNumber,
        _RoleSpecCertIdentifier_roleCertLocator,
        RoleSpecCertIdentifier,
        roleSpecCertIdMatch,
        _roleSpecCertIdMatch_val_AssertionType,
        basicAttConstraints,
        _basicAttConstraints_val_ExtnType,
        _BasicAttConstraintsSyntax_authority,
        _BasicAttConstraintsSyntax_pathLenConstraint,
        BasicAttConstraintsSyntax,
        basicAttConstraintsMatch,
        _basicAttConstraintsMatch_val_AssertionType,
        delegatedNameConstraints,
        _delegatedNameConstraints_val_ExtnType,
        delegatedNameConstraintsMatch,
        _delegatedNameConstraintsMatch_val_AssertionType,
        acceptableCertPolicies,
        _acceptableCertPolicies_val_ExtnType,
        _AcceptableCertPoliciesSyntax__item_,
        AcceptableCertPoliciesSyntax,
        CertPolicyId,
        acceptableCertPoliciesMatch,
        _acceptableCertPoliciesMatch_val_AssertionType,
        authorityAttributeIdentifier,
        _authorityAttributeIdentifier_val_ExtnType,
        _AuthorityAttributeIdentifierSyntax__item_,
        AuthorityAttributeIdentifierSyntax,
        AuthAttId,
        authAttIdMatch,
        _authAttIdMatch_val_AssertionType,
        indirectIssuer,
        _indirectIssuer_val_ExtnType,
        issuedOnBehalfOf,
        _issuedOnBehalfOf_val_ExtnType,
        noAssertion,
        _noAssertion_val_ExtnType,
        allowedAttributeAssignments,
        _allowedAttributeAssignments_val_ExtnType,
        ____AllowedAttributeAssignments__item__attributes__item__attributeType,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value,
        ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext,
        ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues,
        ___AllowedAttributeAssignments__item__attributes__item_,
        __AllowedAttributeAssignments__item__attributes,
        __AllowedAttributeAssignments__item__holderDomain,
        _AllowedAttributeAssignments__item_,
        AllowedAttributeAssignments,
        attributeMappings,
        _attributeMappings_val_ExtnType,
        ___AttributeMappings__item__typeMappings_local,
        ___AttributeMappings__item__typeMappings_remote,
        __AttributeMappings__item__typeMappings,
        ___AttributeMappings__item__typeValueMappings_local,
        ___AttributeMappings__item__typeValueMappings_remote,
        __AttributeMappings__item__typeValueMappings,
        _AttributeMappings__item_,
        AttributeMappings,
        holderNameConstraints,
        _holderNameConstraints_val_ExtnType,
        _HolderNameConstraintsSyntax_permittedSubtrees,
        _HolderNameConstraintsSyntax_excludedSubtrees,
        HolderNameConstraintsSyntax,
        _GeneralSubtrees__item_,
        GeneralSubtrees,
        _GeneralSubtree_base,
        _GeneralSubtree_minimum,
        _GeneralSubtree_maximum,
        GeneralSubtree,
        BaseDistance,
        pmiUser,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        __pmiUser_OptionalAttributes_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2,
        pmiAA,
        __pmiUser_OptionalAttributes_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3,
        __pmiUser_OptionalAttributes_val_Type_2,
        pmiSOA,
        __pmiUser_OptionalAttributes_val_Type_0_0,
        __pmiUser_OptionalAttributes_val_Type_2_0,
        attCertCRLDistributionPt,
        pmiDelegationPath,
        __pmiUser_OptionalAttributes_val_Type_0_1,
        privilegePolicy,
        __pmiUser_OptionalAttributes_val_Type_0_2,
        protectedPrivilegePolicy,
        attributeCertificateAttribute,
        _attributeCertificateAttribute_val_Type,
        aACertificate,
        _aACertificate_val_Type,
        attributeDescriptorCertificate,
        _attributeDescriptorCertificate_val_Type,
        attributeCertificateRevocationList,
        _attributeCertificateRevocationList_val_Type,
        eeAttrCertificateRevocationList,
        _eeAttrCertificateRevocationList_val_Type,
        attributeAuthorityRevocationList,
        _attributeAuthorityRevocationList_val_Type,
        delegationPath,
        _delegationPath_val_Type,
        _AttCertPath__item_,
        AttCertPath,
        privPolicy,
        _privPolicy_val_Type,
        protPrivPolicy,
        _protPrivPolicy_val_Type,
        xmlPrivPolicy,
        _xmlPrivPolicy_val_Type,
        attributeCertificateExactMatch,
        _attributeCertificateExactMatch_val_AssertionType,
        _AttributeCertificateExactAssertion_serialNumber,
        _AttributeCertificateExactAssertion_issuer,
        AttributeCertificateExactAssertion,
        attributeCertificateMatch,
        _attributeCertificateMatch_val_AssertionType,
        __AttributeCertificateAssertion_holder_baseCertificateID,
        __AttributeCertificateAssertion_holder_holderName,
        _AttributeCertificateAssertion_holder,
        _AttributeCertificateAssertion_issuer,
        _AttributeCertificateAssertion_attCertValidity,
        __AttributeCertificateAssertion_attType__item_,
        _AttributeCertificateAssertion_attType,
        AttributeCertificateAssertion,
        holderIssuerMatch,
        _holderIssuerMatch_val_AssertionType,
        _HolderIssuerAssertion_holder,
        _HolderIssuerAssertion_issuer,
        HolderIssuerAssertion,
        delegationPathMatch,
        _delegationPathMatch_val_AssertionType,
        _DelMatchSyntax_firstIssuer,
        _DelMatchSyntax_lastHolder,
        DelMatchSyntax,
        extensionPresenceMatch,
        _extensionPresenceMatch_val_AssertionType,
        id_oc_pmiUser,
        id_oc_pmiAA,
        id_oc_pmiSOA,
        id_oc_attCertCRLDistributionPts,
        id_oc_privilegePolicy,
        id_oc_pmiDelegationPath,
        id_oc_protectedPrivilegePolicy,
        id_at_attributeCertificate,
        id_at_attributeCertificateRevocationList,
        id_at_aACertificate,
        id_at_attributeDescriptorCertificate,
        id_at_attributeAuthorityRevocationList,
        id_at_privPolicy,
        id_at_role,
        id_at_delegationPath,
        id_at_protPrivPolicy,
        id_at_xMLPrivilegeInfo,
        id_at_xmlPrivPolicy,
        id_at_permission,
        id_at_eeAttrCertificateRevocationList,
        id_ce_authorityAttributeIdentifier,
        id_ce_roleSpecCertIdentifier,
        id_ce_basicAttConstraints,
        id_ce_delegatedNameConstraints,
        id_ce_timeSpecification,
        id_ce_attributeDescriptor,
        id_ce_userNotice,
        id_ce_sOAIdentifier,
        id_ce_acceptableCertPolicies,
        id_ce_targetingInformation,
        id_ce_noRevAvail,
        id_ce_acceptablePrivilegePolicies,
        id_ce_indirectIssuer,
        id_ce_noAssertion,
        id_ce_issuedOnBehalfOf,
        id_ce_singleUse,
        id_ce_groupAC,
        id_ce_allowedAttributeAssignments,
        id_ce_attributeMappings,
        id_ce_holderNameConstraints,
        id_mr_attributeCertificateMatch,
        id_mr_attributeCertificateExactMatch,
        id_mr_holderIssuerMatch,
        id_mr_authAttIdMatch,
        id_mr_roleSpecCertIdMatch,
        id_mr_basicAttConstraintsMatch,
        id_mr_delegatedNameConstraintsMatch,
        id_mr_timeSpecMatch,
        id_mr_attDescriptorMatch,
        id_mr_acceptableCertPoliciesMatch,
        id_mr_delegationPathMatch,
        id_mr_sOAIdentifierMatch,
        id_mr_extensionPresenceMatch,
        id_mr_dualStringMatch,
    ]

class AuthenticationFramework:

    _name_  = 'AuthenticationFramework'
    _oid_   = [2, 5, 1, 7, 8]
    
    _obj_ = [
        'SIGNATURE',
        'SIGNED',
        'HASH',
        'ENCRYPTED',
        'ENCRYPTED-HASH',
        'FINGERPRINT',
        'ALGORITHM',
        'AlgorithmIdentifier',
        'SupportedAlgorithms',
        'SupportedCurves',
        'dummyCurv',
        'Certificate',
        'TBSCertificate',
        'Version',
        'CertificateSerialNumber',
        'Validity',
        'SubjectPublicKeyInfo',
        'PublicKey',
        'Time',
        'Extensions',
        'Extension',
        'der',
        'ExtensionSet',
        'EXTENSION',
        'Certificates',
        'ForwardCertificationPath',
        'CrossCertificates',
        'CertificationPath',
        'PkiPath',
        'CertificateList',
        'CertificateListContent',
        'CertAVL',
        'TBSCertAVL',
        'AvlSerialNumber',
        'PKCertIdentifier',
        'IssuerSerialNumber',
        'ScopeRestrictions',
        'SCOPE-RESTRICTION',
        'ScopeRestriction',
        'protRestrict',
        'ProtRestriction',
        'pkiUser',
        'pkiCA',
        'cRLDistributionPoint',
        'cRLDistPtNameForm',
        'deltaCRL',
        'cpCps',
        'pkiCertPath',
        'userCertificate',
        'cACertificate',
        'crossCertificatePair',
        'CertificatePair',
        'certificateRevocationList',
        'eepkCertificateRevocationList',
        'authorityRevocationList',
        'deltaRevocationList',
        'supportedAlgorithms',
        'SupportedAlgorithm',
        'certificationPracticeStmt',
        'InfoSyntax',
        'POLICY',
        'HashedPolicyInfo',
        'Policies',
        'certificatePolicy',
        'PolicySyntax',
        'PolicyID',
        'pkiPath',
        'userPassword',
        'x509Certificate',
        'x509CertificateList',
        'x509CertificatePair',
        'x509SupportedAlgorithm',
        'id-oc-cRLDistributionPoint',
        'id-oc-pkiUser',
        'id-oc-pkiCA',
        'id-oc-deltaCRL',
        'id-oc-cpCps',
        'id-oc-pkiCertPath',
        'id-nf-cRLDistPtNameForm',
        'id-at-userPassword',
        'id-at-userCertificate',
        'id-at-cAcertificate',
        'id-at-authorityRevocationList',
        'id-at-certificateRevocationList',
        'id-at-crossCertificatePair',
        'id-at-supportedAlgorithms',
        'id-at-deltaRevocationList',
        'id-at-certificationPracticeStmt',
        'id-at-certificatePolicy',
        'id-at-pkiPath',
        'id-at-eepkCertificateRevocationList',
        'id-lsx-x509Certificate',
        'id-lsx-x509CertificateList',
        'id-lsx-x509CertificatePair',
        'id-lsx-x509SupportedAlgorithm',
        'id-protRestrict',
        ]
    _type_ = [
        'SIGNATURE',
        'SIGNED',
        'HASH',
        'ENCRYPTED',
        'ENCRYPTED-HASH',
        'FINGERPRINT',
        'ALGORITHM',
        'AlgorithmIdentifier',
        'Certificate',
        'TBSCertificate',
        'Version',
        'CertificateSerialNumber',
        'Validity',
        'SubjectPublicKeyInfo',
        'PublicKey',
        'Time',
        'Extensions',
        'Extension',
        'EXTENSION',
        'Certificates',
        'ForwardCertificationPath',
        'CrossCertificates',
        'CertificationPath',
        'PkiPath',
        'CertificateList',
        'CertificateListContent',
        'CertAVL',
        'TBSCertAVL',
        'AvlSerialNumber',
        'PKCertIdentifier',
        'IssuerSerialNumber',
        'ScopeRestrictions',
        'SCOPE-RESTRICTION',
        'ScopeRestriction',
        'ProtRestriction',
        'CertificatePair',
        'SupportedAlgorithm',
        'InfoSyntax',
        'POLICY',
        'HashedPolicyInfo',
        'PolicySyntax',
        'PolicyID',
        ]
    _set_ = [
        'SupportedAlgorithms',
        'SupportedCurves',
        'ExtensionSet',
        'Policies',
        ]
    _val_ = [
        'dummyCurv',
        'der',
        'protRestrict',
        'pkiUser',
        'pkiCA',
        'cRLDistributionPoint',
        'cRLDistPtNameForm',
        'deltaCRL',
        'cpCps',
        'pkiCertPath',
        'userCertificate',
        'cACertificate',
        'crossCertificatePair',
        'certificateRevocationList',
        'eepkCertificateRevocationList',
        'authorityRevocationList',
        'deltaRevocationList',
        'supportedAlgorithms',
        'certificationPracticeStmt',
        'certificatePolicy',
        'pkiPath',
        'userPassword',
        'x509Certificate',
        'x509CertificateList',
        'x509CertificatePair',
        'x509SupportedAlgorithm',
        'id-oc-cRLDistributionPoint',
        'id-oc-pkiUser',
        'id-oc-pkiCA',
        'id-oc-deltaCRL',
        'id-oc-cpCps',
        'id-oc-pkiCertPath',
        'id-nf-cRLDistPtNameForm',
        'id-at-userPassword',
        'id-at-userCertificate',
        'id-at-cAcertificate',
        'id-at-authorityRevocationList',
        'id-at-certificateRevocationList',
        'id-at-crossCertificatePair',
        'id-at-supportedAlgorithms',
        'id-at-deltaRevocationList',
        'id-at-certificationPracticeStmt',
        'id-at-certificatePolicy',
        'id-at-pkiPath',
        'id-at-eepkCertificateRevocationList',
        'id-lsx-x509Certificate',
        'id-lsx-x509CertificateList',
        'id-lsx-x509CertificatePair',
        'id-lsx-x509SupportedAlgorithm',
        'id-protRestrict',
        ]
    _class_ = [
        'ALGORITHM',
        'SupportedAlgorithms',
        'ExtensionSet',
        'EXTENSION',
        'SCOPE-RESTRICTION',
        'protRestrict',
        'pkiUser',
        'pkiCA',
        'cRLDistributionPoint',
        'cRLDistPtNameForm',
        'deltaCRL',
        'cpCps',
        'pkiCertPath',
        'userCertificate',
        'cACertificate',
        'crossCertificatePair',
        'certificateRevocationList',
        'eepkCertificateRevocationList',
        'authorityRevocationList',
        'deltaRevocationList',
        'supportedAlgorithms',
        'certificationPracticeStmt',
        'POLICY',
        'Policies',
        'certificatePolicy',
        'pkiPath',
        'userPassword',
        'x509Certificate',
        'x509CertificateList',
        'x509CertificatePair',
        'x509SupportedAlgorithm',
        ]
    _param_ = [
        'SIGNED',
        'HASH',
        'ENCRYPTED',
        'ENCRYPTED-HASH',
        'FINGERPRINT',
        'AlgorithmIdentifier',
        ]
    
    #-----< SIGNATURE >-----#
    SIGNATURE = SEQ(name='SIGNATURE', mode=MODE_TYPE)
    _SIGNATURE_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SIGNATURE_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SIGNATURE_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SIGNATURE_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab = ___SIGNATURE_algorithmIdentifier_algorithm_tab
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab_at = None
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __SIGNATURE_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SIGNATURE_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SIGNATURE_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SIGNATURE_algorithmIdentifier_parameters._const_tab = ___SIGNATURE_algorithmIdentifier_parameters_tab
    __SIGNATURE_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __SIGNATURE_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _SIGNATURE_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __SIGNATURE_algorithmIdentifier_algorithm),
        ('parameters', __SIGNATURE_algorithmIdentifier_parameters),
        ])
    _SIGNATURE_algorithmIdentifier._ext = []
    _SIGNATURE_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    SIGNATURE._cont = ASN1Dict([
        ('algorithmIdentifier', _SIGNATURE_algorithmIdentifier),
        ('signature', _SIGNATURE_signature),
        ])
    SIGNATURE._ext = []
    
    #-----< SIGNED >-----#
    SIGNED = SEQ(name='SIGNED', mode=MODE_TYPE, param=True)
    
    #-----< HASH >-----#
    HASH = SEQ(name='HASH', mode=MODE_TYPE)
    _HASH_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __HASH_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___HASH_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___HASH_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __HASH_algorithmIdentifier_algorithm._const_tab = ___HASH_algorithmIdentifier_algorithm_tab
    __HASH_algorithmIdentifier_algorithm._const_tab_at = None
    __HASH_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __HASH_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___HASH_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___HASH_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __HASH_algorithmIdentifier_parameters._const_tab = ___HASH_algorithmIdentifier_parameters_tab
    __HASH_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __HASH_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _HASH_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __HASH_algorithmIdentifier_algorithm),
        ('parameters', __HASH_algorithmIdentifier_parameters),
        ])
    _HASH_algorithmIdentifier._ext = []
    _HASH_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    HASH._cont = ASN1Dict([
        ('algorithmIdentifier', _HASH_algorithmIdentifier),
        ('hashValue', _HASH_hashValue),
        ])
    HASH._ext = []
    
    #-----< ENCRYPTED >-----#
    ENCRYPTED = BIT_STR(name='ENCRYPTED', mode=MODE_TYPE)
    
    #-----< ENCRYPTED-HASH >-----#
    ENCRYPTED_HASH = BIT_STR(name='ENCRYPTED-HASH', mode=MODE_TYPE)
    
    #-----< FINGERPRINT >-----#
    FINGERPRINT = SEQ(name='FINGERPRINT', mode=MODE_TYPE)
    _FINGERPRINT_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __FINGERPRINT_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___FINGERPRINT_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___FINGERPRINT_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __FINGERPRINT_algorithmIdentifier_algorithm._const_tab = ___FINGERPRINT_algorithmIdentifier_algorithm_tab
    __FINGERPRINT_algorithmIdentifier_algorithm._const_tab_at = None
    __FINGERPRINT_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __FINGERPRINT_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___FINGERPRINT_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___FINGERPRINT_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __FINGERPRINT_algorithmIdentifier_parameters._const_tab = ___FINGERPRINT_algorithmIdentifier_parameters_tab
    __FINGERPRINT_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __FINGERPRINT_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _FINGERPRINT_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __FINGERPRINT_algorithmIdentifier_algorithm),
        ('parameters', __FINGERPRINT_algorithmIdentifier_parameters),
        ])
    _FINGERPRINT_algorithmIdentifier._ext = []
    _FINGERPRINT_fingerprint = BIT_STR(name='fingerprint', mode=MODE_TYPE)
    FINGERPRINT._cont = ASN1Dict([
        ('algorithmIdentifier', _FINGERPRINT_algorithmIdentifier),
        ('fingerprint', _FINGERPRINT_fingerprint),
        ])
    FINGERPRINT._ext = []
    
    #-----< ALGORITHM >-----#
    ALGORITHM = CLASS(name='ALGORITHM', mode=MODE_TYPE)
    _ALGORITHM_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    _ALGORITHM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ALGORITHM._cont = ASN1Dict([
        ('Type', _ALGORITHM_Type),
        ('id', _ALGORITHM_id),
        ])
    
    #-----< AlgorithmIdentifier >-----#
    AlgorithmIdentifier = SEQ(name='AlgorithmIdentifier', mode=MODE_TYPE, param=True)
    
    #-----< SupportedAlgorithms >-----#
    SupportedAlgorithms = CLASS(name='SupportedAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    SupportedAlgorithms._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SupportedCurves >-----#
    SupportedCurves = OID(name='SupportedCurves', mode=MODE_SET)
    SupportedCurves._val = ASN1Set(rv=[(2, 5, 5)], rr=[], ev=[], er=[])
    
    #-----< dummyCurv >-----#
    dummyCurv = OID(name='dummyCurv', mode=MODE_VALUE)
    dummyCurv._val = (2, 5, 5)
    
    #-----< Certificate >-----#
    Certificate = SEQ(name='Certificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _Certificate_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'TBSCertificate')))
    _Certificate_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Certificate_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Certificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Certificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Certificate_algorithmIdentifier_algorithm._const_tab = ___Certificate_algorithmIdentifier_algorithm_tab
    __Certificate_algorithmIdentifier_algorithm._const_tab_at = None
    __Certificate_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __Certificate_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Certificate_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Certificate_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Certificate_algorithmIdentifier_parameters._const_tab = ___Certificate_algorithmIdentifier_parameters_tab
    __Certificate_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __Certificate_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _Certificate_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __Certificate_algorithmIdentifier_algorithm),
        ('parameters', __Certificate_algorithmIdentifier_parameters),
        ])
    _Certificate_algorithmIdentifier._ext = []
    _Certificate_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    Certificate._cont = ASN1Dict([
        ('toBeSigned', _Certificate_toBeSigned),
        ('algorithmIdentifier', _Certificate_algorithmIdentifier),
        ('signature', _Certificate_signature),
        ])
    Certificate._ext = []
    
    #-----< TBSCertificate >-----#
    TBSCertificate = SEQ(name='TBSCertificate', mode=MODE_TYPE)
    _TBSCertificate_version = INT(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Version')), default=0)
    _TBSCertificate_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _TBSCertificate_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TBSCertificate_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___TBSCertificate_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertificate_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertificate_signature_algorithm._const_tab = ___TBSCertificate_signature_algorithm_tab
    __TBSCertificate_signature_algorithm._const_tab_at = None
    __TBSCertificate_signature_algorithm._const_tab_id = 'id'
    __TBSCertificate_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___TBSCertificate_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertificate_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertificate_signature_parameters._const_tab = ___TBSCertificate_signature_parameters_tab
    __TBSCertificate_signature_parameters._const_tab_at = ('..', 'algorithm')
    __TBSCertificate_signature_parameters._const_tab_id = 'Type'
    _TBSCertificate_signature._cont = ASN1Dict([
        ('algorithm', __TBSCertificate_signature_algorithm),
        ('parameters', __TBSCertificate_signature_parameters),
        ])
    _TBSCertificate_signature._ext = []
    _TBSCertificate_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertificate_validity = SEQ(name='validity', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Validity')))
    _TBSCertificate_subject = CHOICE(name='subject', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertificate_subjectPublicKeyInfo = SEQ(name='subjectPublicKeyInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SubjectPublicKeyInfo')))
    _TBSCertificate_issuerUniqueIdentifier = BIT_STR(name='issuerUniqueIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _TBSCertificate_subjectUniqueIdentifier = BIT_STR(name='subjectUniqueIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True, group=0)
    _TBSCertificate_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True, group=1)
    TBSCertificate._cont = ASN1Dict([
        ('version', _TBSCertificate_version),
        ('serialNumber', _TBSCertificate_serialNumber),
        ('signature', _TBSCertificate_signature),
        ('issuer', _TBSCertificate_issuer),
        ('validity', _TBSCertificate_validity),
        ('subject', _TBSCertificate_subject),
        ('subjectPublicKeyInfo', _TBSCertificate_subjectPublicKeyInfo),
        ('issuerUniqueIdentifier', _TBSCertificate_issuerUniqueIdentifier),
        ('subjectUniqueIdentifier', _TBSCertificate_subjectUniqueIdentifier),
        ('extensions', _TBSCertificate_extensions),
        ])
    TBSCertificate._ext = ['subjectUniqueIdentifier', 'extensions']
    
    #-----< Version >-----#
    Version = INT(name='Version', mode=MODE_TYPE)
    Version._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v3', 2)])
    
    #-----< CertificateSerialNumber >-----#
    CertificateSerialNumber = INT(name='CertificateSerialNumber', mode=MODE_TYPE)
    
    #-----< Validity >-----#
    Validity = SEQ(name='Validity', mode=MODE_TYPE)
    _Validity_notBefore = CHOICE(name='notBefore', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _Validity_notAfter = CHOICE(name='notAfter', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    Validity._cont = ASN1Dict([
        ('notBefore', _Validity_notBefore),
        ('notAfter', _Validity_notAfter),
        ])
    Validity._ext = []
    
    #-----< SubjectPublicKeyInfo >-----#
    SubjectPublicKeyInfo = SEQ(name='SubjectPublicKeyInfo', mode=MODE_TYPE)
    _SubjectPublicKeyInfo_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SubjectPublicKeyInfo_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab = ___SubjectPublicKeyInfo_algorithm_algorithm_tab
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_at = None
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_id = 'id'
    __SubjectPublicKeyInfo_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SubjectPublicKeyInfo_algorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SubjectPublicKeyInfo_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab = ___SubjectPublicKeyInfo_algorithm_parameters_tab
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_id = 'Type'
    _SubjectPublicKeyInfo_algorithm._cont = ASN1Dict([
        ('algorithm', __SubjectPublicKeyInfo_algorithm_algorithm),
        ('parameters', __SubjectPublicKeyInfo_algorithm_parameters),
        ])
    _SubjectPublicKeyInfo_algorithm._ext = []
    _SubjectPublicKeyInfo_subjectPublicKey = BIT_STR(name='subjectPublicKey', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PublicKey')))
    SubjectPublicKeyInfo._cont = ASN1Dict([
        ('algorithm', _SubjectPublicKeyInfo_algorithm),
        ('subjectPublicKey', _SubjectPublicKeyInfo_subjectPublicKey),
        ])
    SubjectPublicKeyInfo._ext = []
    
    #-----< PublicKey >-----#
    PublicKey = BIT_STR(name='PublicKey', mode=MODE_TYPE)
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = None
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name='Extensions', mode=MODE_TYPE)
    _Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extension')))
    Extensions._cont = _Extensions__item_
    Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< Extension >-----#
    Extension = SEQ(name='Extension', mode=MODE_TYPE)
    _Extension_extnId = OID(name='extnId', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'EXTENSION'), ['id']))
    __Extension_extnId_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    __Extension_extnId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_extnId._const_tab = __Extension_extnId_tab
    _Extension_extnId._const_tab_at = None
    _Extension_extnId._const_tab_id = 'id'
    _Extension_critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    _Extension_extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    _Extension_extnValue._const_cont_enc = (2, 1, 2, 1)
    Extension._cont = ASN1Dict([
        ('extnId', _Extension_extnId),
        ('critical', _Extension_critical),
        ('extnValue', _Extension_extnValue),
        ])
    Extension._ext = []
    
    #-----< der >-----#
    der = OID(name='der', mode=MODE_VALUE)
    der._val = (2, 1, 2, 1)
    
    #-----< ExtensionSet >-----#
    ExtensionSet = CLASS(name='ExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    ExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name='EXTENSION', mode=MODE_TYPE)
    _EXTENSION_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ExtnType = OPEN(name='ExtnType', mode=MODE_TYPE)
    EXTENSION._cont = ASN1Dict([
        ('id', _EXTENSION_id),
        ('ExtnType', _EXTENSION_ExtnType),
        ])
    
    #-----< Certificates >-----#
    Certificates = SEQ(name='Certificates', mode=MODE_TYPE)
    _Certificates_userCertificate = SEQ(name='userCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    _Certificates_certificationPath = SEQ_OF(name='certificationPath', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ForwardCertificationPath')), opt=True)
    Certificates._cont = ASN1Dict([
        ('userCertificate', _Certificates_userCertificate),
        ('certificationPath', _Certificates_certificationPath),
        ])
    Certificates._ext = []
    
    #-----< ForwardCertificationPath >-----#
    ForwardCertificationPath = SEQ_OF(name='ForwardCertificationPath', mode=MODE_TYPE)
    _ForwardCertificationPath__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CrossCertificates')))
    ForwardCertificationPath._cont = _ForwardCertificationPath__item_
    ForwardCertificationPath._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CrossCertificates >-----#
    CrossCertificates = SET_OF(name='CrossCertificates', mode=MODE_TYPE)
    _CrossCertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    CrossCertificates._cont = _CrossCertificates__item_
    CrossCertificates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertificationPath >-----#
    CertificationPath = SEQ(name='CertificationPath', mode=MODE_TYPE)
    _CertificationPath_userCertificate = SEQ(name='userCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    _CertificationPath_theCACertificates = SEQ_OF(name='theCACertificates', mode=MODE_TYPE, opt=True)
    __CertificationPath_theCACertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    _CertificationPath_theCACertificates._cont = __CertificationPath_theCACertificates__item_
    _CertificationPath_theCACertificates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CertificationPath._cont = ASN1Dict([
        ('userCertificate', _CertificationPath_userCertificate),
        ('theCACertificates', _CertificationPath_theCACertificates),
        ])
    CertificationPath._ext = []
    
    #-----< PkiPath >-----#
    PkiPath = SEQ_OF(name='PkiPath', mode=MODE_TYPE)
    _PkiPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    PkiPath._cont = _PkiPath__item_
    PkiPath._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertificateList >-----#
    CertificateList = SEQ(name='CertificateList', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _CertificateList_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateListContent')))
    _CertificateList_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertificateList_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___CertificateList_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateList_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateList_algorithmIdentifier_algorithm._const_tab = ___CertificateList_algorithmIdentifier_algorithm_tab
    __CertificateList_algorithmIdentifier_algorithm._const_tab_at = None
    __CertificateList_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __CertificateList_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___CertificateList_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateList_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateList_algorithmIdentifier_parameters._const_tab = ___CertificateList_algorithmIdentifier_parameters_tab
    __CertificateList_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __CertificateList_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _CertificateList_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __CertificateList_algorithmIdentifier_algorithm),
        ('parameters', __CertificateList_algorithmIdentifier_parameters),
        ])
    _CertificateList_algorithmIdentifier._ext = []
    _CertificateList_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    CertificateList._cont = ASN1Dict([
        ('toBeSigned', _CertificateList_toBeSigned),
        ('algorithmIdentifier', _CertificateList_algorithmIdentifier),
        ('signature', _CertificateList_signature),
        ])
    CertificateList._ext = []
    
    #-----< CertificateListContent >-----#
    CertificateListContent = SEQ(name='CertificateListContent', mode=MODE_TYPE)
    _CertificateListContent_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Version')), opt=True)
    _CertificateListContent_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertificateListContent_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___CertificateListContent_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateListContent_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateListContent_signature_algorithm._const_tab = ___CertificateListContent_signature_algorithm_tab
    __CertificateListContent_signature_algorithm._const_tab_at = None
    __CertificateListContent_signature_algorithm._const_tab_id = 'id'
    __CertificateListContent_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___CertificateListContent_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateListContent_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateListContent_signature_parameters._const_tab = ___CertificateListContent_signature_parameters_tab
    __CertificateListContent_signature_parameters._const_tab_at = ('..', 'algorithm')
    __CertificateListContent_signature_parameters._const_tab_id = 'Type'
    _CertificateListContent_signature._cont = ASN1Dict([
        ('algorithm', __CertificateListContent_signature_algorithm),
        ('parameters', __CertificateListContent_signature_parameters),
        ])
    _CertificateListContent_signature._ext = []
    _CertificateListContent_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CertificateListContent_thisUpdate = CHOICE(name='thisUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _CertificateListContent_nextUpdate = CHOICE(name='nextUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateListContent_revokedCertificates = SEQ_OF(name='revokedCertificates', mode=MODE_TYPE, opt=True)
    __CertificateListContent_revokedCertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___CertificateListContent_revokedCertificates__item__serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    ___CertificateListContent_revokedCertificates__item__revocationDate = CHOICE(name='revocationDate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    ___CertificateListContent_revokedCertificates__item__crlEntryExtensions = SEQ_OF(name='crlEntryExtensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    __CertificateListContent_revokedCertificates__item_._cont = ASN1Dict([
        ('serialNumber', ___CertificateListContent_revokedCertificates__item__serialNumber),
        ('revocationDate', ___CertificateListContent_revokedCertificates__item__revocationDate),
        ('crlEntryExtensions', ___CertificateListContent_revokedCertificates__item__crlEntryExtensions),
        ])
    __CertificateListContent_revokedCertificates__item_._ext = []
    _CertificateListContent_revokedCertificates._cont = __CertificateListContent_revokedCertificates__item_
    _CertificateListContent_crlExtensions = SEQ_OF(name='crlExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    CertificateListContent._cont = ASN1Dict([
        ('version', _CertificateListContent_version),
        ('signature', _CertificateListContent_signature),
        ('issuer', _CertificateListContent_issuer),
        ('thisUpdate', _CertificateListContent_thisUpdate),
        ('nextUpdate', _CertificateListContent_nextUpdate),
        ('revokedCertificates', _CertificateListContent_revokedCertificates),
        ('crlExtensions', _CertificateListContent_crlExtensions),
        ])
    CertificateListContent._ext = ['crlExtensions']
    
    #-----< CertAVL >-----#
    CertAVL = SEQ(name='CertAVL', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _CertAVL_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'TBSCertAVL')))
    _CertAVL_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertAVL_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___CertAVL_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertAVL_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertAVL_algorithmIdentifier_algorithm._const_tab = ___CertAVL_algorithmIdentifier_algorithm_tab
    __CertAVL_algorithmIdentifier_algorithm._const_tab_at = None
    __CertAVL_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __CertAVL_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___CertAVL_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertAVL_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertAVL_algorithmIdentifier_parameters._const_tab = ___CertAVL_algorithmIdentifier_parameters_tab
    __CertAVL_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __CertAVL_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _CertAVL_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __CertAVL_algorithmIdentifier_algorithm),
        ('parameters', __CertAVL_algorithmIdentifier_parameters),
        ])
    _CertAVL_algorithmIdentifier._ext = []
    _CertAVL_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    CertAVL._cont = ASN1Dict([
        ('toBeSigned', _CertAVL_toBeSigned),
        ('algorithmIdentifier', _CertAVL_algorithmIdentifier),
        ('signature', _CertAVL_signature),
        ])
    CertAVL._ext = []
    
    #-----< TBSCertAVL >-----#
    TBSCertAVL = SEQ(name='TBSCertAVL', mode=MODE_TYPE)
    _TBSCertAVL_version = INT(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Version')), default=0)
    _TBSCertAVL_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AvlSerialNumber')), opt=True)
    _TBSCertAVL_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TBSCertAVL_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___TBSCertAVL_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertAVL_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertAVL_signature_algorithm._const_tab = ___TBSCertAVL_signature_algorithm_tab
    __TBSCertAVL_signature_algorithm._const_tab_at = None
    __TBSCertAVL_signature_algorithm._const_tab_id = 'id'
    __TBSCertAVL_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___TBSCertAVL_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertAVL_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertAVL_signature_parameters._const_tab = ___TBSCertAVL_signature_parameters_tab
    __TBSCertAVL_signature_parameters._const_tab_at = ('..', 'algorithm')
    __TBSCertAVL_signature_parameters._const_tab_id = 'Type'
    _TBSCertAVL_signature._cont = ASN1Dict([
        ('algorithm', __TBSCertAVL_signature_algorithm),
        ('parameters', __TBSCertAVL_signature_parameters),
        ])
    _TBSCertAVL_signature._ext = []
    _TBSCertAVL_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertAVL_constrained = BOOL(name='constrained', mode=MODE_TYPE)
    _TBSCertAVL_entries = SEQ_OF(name='entries', mode=MODE_TYPE)
    __TBSCertAVL_entries__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___TBSCertAVL_entries__item__idType = CHOICE(name='idType', mode=MODE_TYPE)
    ____TBSCertAVL_entries__item__idType_certIdentifier = CHOICE(name='certIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'PKCertIdentifier')))
    ____TBSCertAVL_entries__item__idType_entityGroup = SEQ_OF(name='entityGroup', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___TBSCertAVL_entries__item__idType._cont = ASN1Dict([
        ('certIdentifier', ____TBSCertAVL_entries__item__idType_certIdentifier),
        ('entityGroup', ____TBSCertAVL_entries__item__idType_entityGroup),
        ])
    ___TBSCertAVL_entries__item__idType._ext = []
    ___TBSCertAVL_entries__item__scope = SEQ_OF(name='scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'ScopeRestrictions')), opt=True)
    ___TBSCertAVL_entries__item__entryExtensions = SEQ_OF(name='entryExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    __TBSCertAVL_entries__item_._cont = ASN1Dict([
        ('idType', ___TBSCertAVL_entries__item__idType),
        ('scope', ___TBSCertAVL_entries__item__scope),
        ('entryExtensions', ___TBSCertAVL_entries__item__entryExtensions),
        ])
    __TBSCertAVL_entries__item_._ext = []
    _TBSCertAVL_entries._cont = __TBSCertAVL_entries__item_
    _TBSCertAVL_entries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TBSCertAVL_avlExtensions = SEQ_OF(name='avlExtensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    TBSCertAVL._cont = ASN1Dict([
        ('version', _TBSCertAVL_version),
        ('serialNumber', _TBSCertAVL_serialNumber),
        ('signature', _TBSCertAVL_signature),
        ('issuer', _TBSCertAVL_issuer),
        ('constrained', _TBSCertAVL_constrained),
        ('entries', _TBSCertAVL_entries),
        ('avlExtensions', _TBSCertAVL_avlExtensions),
        ])
    TBSCertAVL._ext = ['avlExtensions']
    
    #-----< AvlSerialNumber >-----#
    AvlSerialNumber = INT(name='AvlSerialNumber', mode=MODE_TYPE)
    AvlSerialNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< PKCertIdentifier >-----#
    PKCertIdentifier = CHOICE(name='PKCertIdentifier', mode=MODE_TYPE)
    _PKCertIdentifier_issuerSerialNumber = SEQ(name='issuerSerialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'IssuerSerialNumber')))
    _PKCertIdentifier_fingerprintPKC = SEQ(name='fingerprintPKC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'FINGERPRINT')))
    __PKCertIdentifier_fingerprintPKC_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm._const_tab = ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm._const_tab_at = None
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters._const_tab = ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __PKCertIdentifier_fingerprintPKC_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm),
        ('parameters', ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters),
        ])
    __PKCertIdentifier_fingerprintPKC_algorithmIdentifier._ext = []
    __PKCertIdentifier_fingerprintPKC_fingerprint = BIT_STR(name='fingerprint', mode=MODE_TYPE)
    _PKCertIdentifier_fingerprintPKC._cont = ASN1Dict([
        ('algorithmIdentifier', __PKCertIdentifier_fingerprintPKC_algorithmIdentifier),
        ('fingerprint', __PKCertIdentifier_fingerprintPKC_fingerprint),
        ])
    _PKCertIdentifier_fingerprintPKC._ext = []
    _PKCertIdentifier_fingerprintPK = SEQ(name='fingerprintPK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'FINGERPRINT')))
    __PKCertIdentifier_fingerprintPK_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm._const_tab = ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm._const_tab_at = None
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters._const_tab = ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __PKCertIdentifier_fingerprintPK_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm),
        ('parameters', ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters),
        ])
    __PKCertIdentifier_fingerprintPK_algorithmIdentifier._ext = []
    __PKCertIdentifier_fingerprintPK_fingerprint = BIT_STR(name='fingerprint', mode=MODE_TYPE)
    _PKCertIdentifier_fingerprintPK._cont = ASN1Dict([
        ('algorithmIdentifier', __PKCertIdentifier_fingerprintPK_algorithmIdentifier),
        ('fingerprint', __PKCertIdentifier_fingerprintPK_fingerprint),
        ])
    _PKCertIdentifier_fingerprintPK._ext = []
    PKCertIdentifier._cont = ASN1Dict([
        ('issuerSerialNumber', _PKCertIdentifier_issuerSerialNumber),
        ('fingerprintPKC', _PKCertIdentifier_fingerprintPKC),
        ('fingerprintPK', _PKCertIdentifier_fingerprintPK),
        ])
    PKCertIdentifier._ext = []
    
    #-----< IssuerSerialNumber >-----#
    IssuerSerialNumber = SEQ(name='IssuerSerialNumber', mode=MODE_TYPE)
    _IssuerSerialNumber_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _IssuerSerialNumber_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    IssuerSerialNumber._cont = ASN1Dict([
        ('issuer', _IssuerSerialNumber_issuer),
        ('serialNumber', _IssuerSerialNumber_serialNumber),
        ])
    IssuerSerialNumber._ext = []
    
    #-----< ScopeRestrictions >-----#
    ScopeRestrictions = SEQ_OF(name='ScopeRestrictions', mode=MODE_TYPE)
    _ScopeRestrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ScopeRestriction')))
    ScopeRestrictions._cont = _ScopeRestrictions__item_
    
    #-----< SCOPE-RESTRICTION >-----#
    SCOPE_RESTRICTION = CLASS(name='SCOPE-RESTRICTION', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< ScopeRestriction >-----#
    ScopeRestriction = SEQ(name='ScopeRestriction', mode=MODE_TYPE)
    _ScopeRestriction_id = OID(name='id', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'SCOPE-RESTRICTION'), ['id']))
    _ScopeRestriction_restriction = OPEN(name='restriction', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'SCOPE-RESTRICTION'), ['Type']))
    ScopeRestriction._cont = ASN1Dict([
        ('id', _ScopeRestriction_id),
        ('restriction', _ScopeRestriction_restriction),
        ])
    ScopeRestriction._ext = []
    
    #-----< protRestrict >-----#
    protRestrict = CLASS(name='protRestrict', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _protRestrict_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ProtRestriction')))
    protRestrict._val = dict([('ExtnType', _protRestrict_val_ExtnType), ('id', (2, 5, 41, 1))])
    
    #-----< ProtRestriction >-----#
    ProtRestriction = SEQ_OF(name='ProtRestriction', mode=MODE_TYPE)
    _ProtRestriction__item_ = OID(name='_item_', mode=MODE_TYPE)
    ProtRestriction._cont = _ProtRestriction__item_
    ProtRestriction._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< pkiUser >-----#
    pkiUser = CLASS(name='pkiUser', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    __pmiUser_OptionalAttributes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    pkiUser._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['userCertificate']), ('ldapDesc', 'X.509 user certificate'), ('id', (2, 5, 4, 36))])], rr=[], ev=None, er=[])), ('ldapName', ['pkiUser']), ('ldapDesc', 'X.509 PKI User'), ('id', (2, 5, 6, 21))])
    
    #-----< pkiCA >-----#
    pkiCA = CLASS(name='pkiCA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    __pmiUser_OptionalAttributes_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    pkiCA._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['cACertificate']), ('ldapDesc', 'X.509 CA certificate'), ('id', (2, 5, 4, 37))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 EEPK certificate revocation list'), ('id', (2, 5, 4, 101))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_3), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_4), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), ('ldapName', ['certificatePairExactMatch']), ('ldapDesc', 'X.509 Certificate Pair Exact Match'), ('id', (2, 5, 13, 36))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)), ('ldapName', ['crossCertificatePair']), ('ldapDesc', 'X.509 cross certificate pair'), ('id', (2, 5, 4, 40))])], rr=[], ev=None, er=[])), ('ldapName', ['pkiCA']), ('ldapDesc', 'X.509 PKI Certificate Authority'), ('id', (2, 5, 6, 22))])
    
    #-----< cRLDistributionPoint >-----#
    cRLDistributionPoint = CLASS(name='cRLDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __pmiUser_OptionalAttributes_val_Type_0_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    cRLDistributionPoint._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 EEPK certificate revocation list'), ('id', (2, 5, 4, 101))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_3), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), ('ldapName', ['cRLDistributionPoint']), ('ldapDesc', 'X.509 CRL distribution point'), ('id', (2, 5, 6, 19))])
    
    #-----< cRLDistPtNameForm >-----#
    cRLDistPtNameForm = CLASS(name='cRLDistPtNameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    __cRLDistPtNameForm_MandatoryAttributes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    cRLDistPtNameForm._val = dict([('namedObjectClass', dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 EEPK certificate revocation list'), ('id', (2, 5, 4, 101))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_3), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), ('ldapName', ['cRLDistributionPoint']), ('ldapDesc', 'X.509 CRL distribution point'), ('id', (2, 5, 6, 19))])), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __cRLDistPtNameForm_MandatoryAttributes_val_Type_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('id', (2, 5, 15, 14))])
    
    #-----< deltaCRL >-----#
    deltaCRL = CLASS(name='deltaCRL', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    deltaCRL._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), ('ldapName', ['deltaCRL']), ('ldapDesc', 'X.509 delta CRL'), ('id', (2, 5, 6, 23))])
    
    #-----< cpCps >-----#
    cpCps = CLASS(name='cpCps', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    __pmiUser_OptionalAttributes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    cpCps._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_1), ('id', (2, 5, 4, 69))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1_0), ('id', (2, 5, 4, 68))])], rr=[], ev=None, er=[])), ('ldapName', ['cpCps']), ('ldapDesc', 'Certificate Policy and Certification Practice Statement'), ('id', (2, 5, 6, 30))])
    
    #-----< pkiCertPath >-----#
    pkiCertPath = CLASS(name='pkiCertPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_2 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PkiPath')))
    pkiCertPath._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_2), ('id', (2, 5, 4, 70))])], rr=[], ev=None, er=[])), ('ldapName', ['pkiCertPath']), ('ldapDesc', 'PKI Certification Path'), ('id', (2, 5, 6, 31))])
    
    #-----< userCertificate >-----#
    userCertificate = CLASS(name='userCertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userCertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    userCertificate._val = dict([('Type', _userCertificate_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['userCertificate']), ('ldapDesc', 'X.509 user certificate'), ('id', (2, 5, 4, 36))])
    
    #-----< cACertificate >-----#
    cACertificate = CLASS(name='cACertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _cACertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    cACertificate._val = dict([('Type', _cACertificate_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['cACertificate']), ('ldapDesc', 'X.509 CA certificate'), ('id', (2, 5, 4, 37))])
    
    #-----< crossCertificatePair >-----#
    crossCertificatePair = CLASS(name='crossCertificatePair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _crossCertificatePair_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    crossCertificatePair._val = dict([('Type', _crossCertificatePair_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), ('ldapName', ['certificatePairExactMatch']), ('ldapDesc', 'X.509 Certificate Pair Exact Match'), ('id', (2, 5, 13, 36))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)), ('ldapName', ['crossCertificatePair']), ('ldapDesc', 'X.509 cross certificate pair'), ('id', (2, 5, 4, 40))])
    
    #-----< CertificatePair >-----#
    CertificatePair = SEQ(name='CertificatePair', mode=MODE_TYPE)
    _CertificatePair_issuedToThisCA = SEQ(name='issuedToThisCA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificatePair_issuedByThisCA = SEQ(name='issuedByThisCA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    CertificatePair._cont = ASN1Dict([
        ('issuedToThisCA', _CertificatePair_issuedToThisCA),
        ('issuedByThisCA', _CertificatePair_issuedByThisCA),
        ])
    CertificatePair._ext = []
    
    #-----< certificateRevocationList >-----#
    certificateRevocationList = CLASS(name='certificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificateRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    certificateRevocationList._val = dict([('Type', _certificateRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))])
    
    #-----< eepkCertificateRevocationList >-----#
    eepkCertificateRevocationList = CLASS(name='eepkCertificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _eepkCertificateRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    eepkCertificateRevocationList._val = dict([('Type', _eepkCertificateRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 EEPK certificate revocation list'), ('id', (2, 5, 4, 101))])
    
    #-----< authorityRevocationList >-----#
    authorityRevocationList = CLASS(name='authorityRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _authorityRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    authorityRevocationList._val = dict([('Type', _authorityRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))])
    
    #-----< deltaRevocationList >-----#
    deltaRevocationList = CLASS(name='deltaRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _deltaRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    deltaRevocationList._val = dict([('Type', _deltaRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])
    
    #-----< supportedAlgorithms >-----#
    supportedAlgorithms = CLASS(name='supportedAlgorithms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedAlgorithms_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SupportedAlgorithm')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab = ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab_at = None
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab_id = 'id'
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab = ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab_at = ('..', 'algorithm')
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab_id = 'Type'
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4._cont = ASN1Dict([
        ('algorithm', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm),
        ('parameters', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters),
        ])
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4._ext = []
    supportedAlgorithms._val = dict([('Type', _supportedAlgorithms_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 7)), ('ldapName', ['algorithmIdentifierMatch']), ('ldapDesc', 'X.509 Algorithm Identifier Match'), ('id', (2, 5, 13, 40))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49)), ('ldapName', ['supportedAlgorithms']), ('ldapDesc', 'X.509 support algorithms'), ('id', (2, 5, 4, 52))])
    
    #-----< SupportedAlgorithm >-----#
    SupportedAlgorithm = SEQ(name='SupportedAlgorithm', mode=MODE_TYPE)
    _SupportedAlgorithm_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SupportedAlgorithm_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab = ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab_at = None
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __SupportedAlgorithm_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SupportedAlgorithm_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SupportedAlgorithm_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab = ___SupportedAlgorithm_algorithmIdentifier_parameters_tab
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _SupportedAlgorithm_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __SupportedAlgorithm_algorithmIdentifier_algorithm),
        ('parameters', __SupportedAlgorithm_algorithmIdentifier_parameters),
        ])
    _SupportedAlgorithm_algorithmIdentifier._ext = []
    _SupportedAlgorithm_intendedUsage = BIT_STR(name='intendedUsage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _SupportedAlgorithm_intendedCertificatePolicies = SEQ_OF(name='intendedCertificatePolicies', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificatePoliciesSyntax')), opt=True)
    SupportedAlgorithm._cont = ASN1Dict([
        ('algorithmIdentifier', _SupportedAlgorithm_algorithmIdentifier),
        ('intendedUsage', _SupportedAlgorithm_intendedUsage),
        ('intendedCertificatePolicies', _SupportedAlgorithm_intendedCertificatePolicies),
        ])
    SupportedAlgorithm._ext = []
    
    #-----< certificationPracticeStmt >-----#
    certificationPracticeStmt = CLASS(name='certificationPracticeStmt', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificationPracticeStmt_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    certificationPracticeStmt._val = dict([('Type', _certificationPracticeStmt_val_Type), ('id', (2, 5, 4, 68))])
    
    #-----< InfoSyntax >-----#
    InfoSyntax = CHOICE(name='InfoSyntax', mode=MODE_TYPE)
    _InfoSyntax_content = CHOICE(name='content', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _InfoSyntax_pointer = SEQ(name='pointer', mode=MODE_TYPE)
    __InfoSyntax_pointer_name = SEQ_OF(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    __InfoSyntax_pointer_hash = SEQ(name='hash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')), opt=True)
    ___InfoSyntax_pointer_hash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab = _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab_at = None
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab = _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___InfoSyntax_pointer_hash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm),
        ('parameters', ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters),
        ])
    ___InfoSyntax_pointer_hash_algorithmIdentifier._ext = []
    ___InfoSyntax_pointer_hash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    __InfoSyntax_pointer_hash._cont = ASN1Dict([
        ('algorithmIdentifier', ___InfoSyntax_pointer_hash_algorithmIdentifier),
        ('hashValue', ___InfoSyntax_pointer_hash_hashValue),
        ])
    __InfoSyntax_pointer_hash._ext = []
    _InfoSyntax_pointer._cont = ASN1Dict([
        ('name', __InfoSyntax_pointer_name),
        ('hash', __InfoSyntax_pointer_hash),
        ])
    _InfoSyntax_pointer._ext = []
    InfoSyntax._cont = ASN1Dict([
        ('content', _InfoSyntax_content),
        ('pointer', _InfoSyntax_pointer),
        ])
    InfoSyntax._ext = []
    
    #-----< POLICY >-----#
    POLICY = CLASS(name='POLICY', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< HashedPolicyInfo >-----#
    HashedPolicyInfo = OPEN(name='HashedPolicyInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'POLICY'), ['Type']))
    _HashedPolicyInfo_tab = CLASS(name='_tab_POLICY', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'POLICY')))
    _HashedPolicyInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    HashedPolicyInfo._const_tab = _HashedPolicyInfo_tab
    HashedPolicyInfo._const_tab_at = None
    HashedPolicyInfo._const_tab_id = 'Type'
    
    #-----< Policies >-----#
    Policies = CLASS(name='Policies', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'POLICY')))
    Policies._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< certificatePolicy >-----#
    certificatePolicy = CLASS(name='certificatePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificatePolicy_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    certificatePolicy._val = dict([('Type', _certificatePolicy_val_Type), ('id', (2, 5, 4, 69))])
    
    #-----< PolicySyntax >-----#
    PolicySyntax = SEQ(name='PolicySyntax', mode=MODE_TYPE)
    _PolicySyntax_policyIdentifier = OID(name='policyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicyID')))
    _PolicySyntax_policySyntax = CHOICE(name='policySyntax', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    PolicySyntax._cont = ASN1Dict([
        ('policyIdentifier', _PolicySyntax_policyIdentifier),
        ('policySyntax', _PolicySyntax_policySyntax),
        ])
    PolicySyntax._ext = []
    
    #-----< PolicyID >-----#
    PolicyID = OID(name='PolicyID', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    
    #-----< pkiPath >-----#
    pkiPath = CLASS(name='pkiPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pkiPath_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PkiPath')))
    pkiPath._val = dict([('Type', _pkiPath_val_Type), ('id', (2, 5, 4, 70))])
    
    #-----< userPassword >-----#
    userPassword = CLASS(name='userPassword', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPassword_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    _userPassword_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_5 = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    userPassword._val = dict([('Type', _userPassword_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_5), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringMatch']), ('id', (2, 5, 13, 17))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['userPassword']), ('id', (2, 5, 4, 35))])
    
    #-----< x509Certificate >-----#
    x509Certificate = CLASS(name='x509Certificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509Certificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    x509Certificate._val = dict([('ldapDesc', 'X.509 Certificate'), ('Type', _x509Certificate_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8))])
    
    #-----< x509CertificateList >-----#
    x509CertificateList = CLASS(name='x509CertificateList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509CertificateList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    x509CertificateList._val = dict([('ldapDesc', 'X.509 Certificate List'), ('Type', _x509CertificateList_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9))])
    
    #-----< x509CertificatePair >-----#
    x509CertificatePair = CLASS(name='x509CertificatePair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509CertificatePair_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    x509CertificatePair._val = dict([('ldapDesc', 'X.509 Certificate Pair'), ('Type', _x509CertificatePair_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10))])
    
    #-----< x509SupportedAlgorithm >-----#
    x509SupportedAlgorithm = CLASS(name='x509SupportedAlgorithm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509SupportedAlgorithm_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SupportedAlgorithm')))
    x509SupportedAlgorithm._val = dict([('ldapDesc', 'X.509 Supported Algorithm'), ('Type', _x509SupportedAlgorithm_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49))])
    
    #-----< id-oc-cRLDistributionPoint >-----#
    id_oc_cRLDistributionPoint = OID(name='id-oc-cRLDistributionPoint', mode=MODE_VALUE)
    id_oc_cRLDistributionPoint._val = (2, 5, 6, 19)
    
    #-----< id-oc-pkiUser >-----#
    id_oc_pkiUser = OID(name='id-oc-pkiUser', mode=MODE_VALUE)
    id_oc_pkiUser._val = (2, 5, 6, 21)
    
    #-----< id-oc-pkiCA >-----#
    id_oc_pkiCA = OID(name='id-oc-pkiCA', mode=MODE_VALUE)
    id_oc_pkiCA._val = (2, 5, 6, 22)
    
    #-----< id-oc-deltaCRL >-----#
    id_oc_deltaCRL = OID(name='id-oc-deltaCRL', mode=MODE_VALUE)
    id_oc_deltaCRL._val = (2, 5, 6, 23)
    
    #-----< id-oc-cpCps >-----#
    id_oc_cpCps = OID(name='id-oc-cpCps', mode=MODE_VALUE)
    id_oc_cpCps._val = (2, 5, 6, 30)
    
    #-----< id-oc-pkiCertPath >-----#
    id_oc_pkiCertPath = OID(name='id-oc-pkiCertPath', mode=MODE_VALUE)
    id_oc_pkiCertPath._val = (2, 5, 6, 31)
    
    #-----< id-nf-cRLDistPtNameForm >-----#
    id_nf_cRLDistPtNameForm = OID(name='id-nf-cRLDistPtNameForm', mode=MODE_VALUE)
    id_nf_cRLDistPtNameForm._val = (2, 5, 15, 14)
    
    #-----< id-at-userPassword >-----#
    id_at_userPassword = OID(name='id-at-userPassword', mode=MODE_VALUE)
    id_at_userPassword._val = (2, 5, 4, 35)
    
    #-----< id-at-userCertificate >-----#
    id_at_userCertificate = OID(name='id-at-userCertificate', mode=MODE_VALUE)
    id_at_userCertificate._val = (2, 5, 4, 36)
    
    #-----< id-at-cAcertificate >-----#
    id_at_cAcertificate = OID(name='id-at-cAcertificate', mode=MODE_VALUE)
    id_at_cAcertificate._val = (2, 5, 4, 37)
    
    #-----< id-at-authorityRevocationList >-----#
    id_at_authorityRevocationList = OID(name='id-at-authorityRevocationList', mode=MODE_VALUE)
    id_at_authorityRevocationList._val = (2, 5, 4, 38)
    
    #-----< id-at-certificateRevocationList >-----#
    id_at_certificateRevocationList = OID(name='id-at-certificateRevocationList', mode=MODE_VALUE)
    id_at_certificateRevocationList._val = (2, 5, 4, 39)
    
    #-----< id-at-crossCertificatePair >-----#
    id_at_crossCertificatePair = OID(name='id-at-crossCertificatePair', mode=MODE_VALUE)
    id_at_crossCertificatePair._val = (2, 5, 4, 40)
    
    #-----< id-at-supportedAlgorithms >-----#
    id_at_supportedAlgorithms = OID(name='id-at-supportedAlgorithms', mode=MODE_VALUE)
    id_at_supportedAlgorithms._val = (2, 5, 4, 52)
    
    #-----< id-at-deltaRevocationList >-----#
    id_at_deltaRevocationList = OID(name='id-at-deltaRevocationList', mode=MODE_VALUE)
    id_at_deltaRevocationList._val = (2, 5, 4, 53)
    
    #-----< id-at-certificationPracticeStmt >-----#
    id_at_certificationPracticeStmt = OID(name='id-at-certificationPracticeStmt', mode=MODE_VALUE)
    id_at_certificationPracticeStmt._val = (2, 5, 4, 68)
    
    #-----< id-at-certificatePolicy >-----#
    id_at_certificatePolicy = OID(name='id-at-certificatePolicy', mode=MODE_VALUE)
    id_at_certificatePolicy._val = (2, 5, 4, 69)
    
    #-----< id-at-pkiPath >-----#
    id_at_pkiPath = OID(name='id-at-pkiPath', mode=MODE_VALUE)
    id_at_pkiPath._val = (2, 5, 4, 70)
    
    #-----< id-at-eepkCertificateRevocationList >-----#
    id_at_eepkCertificateRevocationList = OID(name='id-at-eepkCertificateRevocationList', mode=MODE_VALUE)
    id_at_eepkCertificateRevocationList._val = (2, 5, 4, 101)
    
    #-----< id-lsx-x509Certificate >-----#
    id_lsx_x509Certificate = OID(name='id-lsx-x509Certificate', mode=MODE_VALUE)
    id_lsx_x509Certificate._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)
    
    #-----< id-lsx-x509CertificateList >-----#
    id_lsx_x509CertificateList = OID(name='id-lsx-x509CertificateList', mode=MODE_VALUE)
    id_lsx_x509CertificateList._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)
    
    #-----< id-lsx-x509CertificatePair >-----#
    id_lsx_x509CertificatePair = OID(name='id-lsx-x509CertificatePair', mode=MODE_VALUE)
    id_lsx_x509CertificatePair._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)
    
    #-----< id-lsx-x509SupportedAlgorithm >-----#
    id_lsx_x509SupportedAlgorithm = OID(name='id-lsx-x509SupportedAlgorithm', mode=MODE_VALUE)
    id_lsx_x509SupportedAlgorithm._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49)
    
    #-----< id-protRestrict >-----#
    id_protRestrict = OID(name='id-protRestrict', mode=MODE_VALUE)
    id_protRestrict._val = (2, 5, 41, 1)
    
    _all_ = [
        ___SIGNATURE_algorithmIdentifier_algorithm_tab,
        __SIGNATURE_algorithmIdentifier_algorithm,
        ___SIGNATURE_algorithmIdentifier_parameters_tab,
        __SIGNATURE_algorithmIdentifier_parameters,
        _SIGNATURE_algorithmIdentifier,
        _SIGNATURE_signature,
        SIGNATURE,
        ___HASH_algorithmIdentifier_algorithm_tab,
        __HASH_algorithmIdentifier_algorithm,
        ___HASH_algorithmIdentifier_parameters_tab,
        __HASH_algorithmIdentifier_parameters,
        _HASH_algorithmIdentifier,
        _HASH_hashValue,
        HASH,
        ENCRYPTED,
        ENCRYPTED_HASH,
        ___FINGERPRINT_algorithmIdentifier_algorithm_tab,
        __FINGERPRINT_algorithmIdentifier_algorithm,
        ___FINGERPRINT_algorithmIdentifier_parameters_tab,
        __FINGERPRINT_algorithmIdentifier_parameters,
        _FINGERPRINT_algorithmIdentifier,
        _FINGERPRINT_fingerprint,
        FINGERPRINT,
        _ALGORITHM_Type,
        _ALGORITHM_id,
        ALGORITHM,
        SupportedAlgorithms,
        SupportedCurves,
        dummyCurv,
        _Certificate_toBeSigned,
        ___Certificate_algorithmIdentifier_algorithm_tab,
        __Certificate_algorithmIdentifier_algorithm,
        ___Certificate_algorithmIdentifier_parameters_tab,
        __Certificate_algorithmIdentifier_parameters,
        _Certificate_algorithmIdentifier,
        _Certificate_signature,
        Certificate,
        _TBSCertificate_version,
        _TBSCertificate_serialNumber,
        ___TBSCertificate_signature_algorithm_tab,
        __TBSCertificate_signature_algorithm,
        ___TBSCertificate_signature_parameters_tab,
        __TBSCertificate_signature_parameters,
        _TBSCertificate_signature,
        _TBSCertificate_issuer,
        _TBSCertificate_validity,
        _TBSCertificate_subject,
        _TBSCertificate_subjectPublicKeyInfo,
        _TBSCertificate_issuerUniqueIdentifier,
        _TBSCertificate_subjectUniqueIdentifier,
        _TBSCertificate_extensions,
        TBSCertificate,
        Version,
        CertificateSerialNumber,
        _Validity_notBefore,
        _Validity_notAfter,
        Validity,
        ___SubjectPublicKeyInfo_algorithm_algorithm_tab,
        __SubjectPublicKeyInfo_algorithm_algorithm,
        ___SubjectPublicKeyInfo_algorithm_parameters_tab,
        __SubjectPublicKeyInfo_algorithm_parameters,
        _SubjectPublicKeyInfo_algorithm,
        _SubjectPublicKeyInfo_subjectPublicKey,
        SubjectPublicKeyInfo,
        PublicKey,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        _Extensions__item_,
        Extensions,
        __Extension_extnId_tab,
        _Extension_extnId,
        _Extension_critical,
        _Extension_extnValue,
        Extension,
        der,
        ExtensionSet,
        _EXTENSION_id,
        _EXTENSION_ExtnType,
        EXTENSION,
        _Certificates_userCertificate,
        _Certificates_certificationPath,
        Certificates,
        _ForwardCertificationPath__item_,
        ForwardCertificationPath,
        _CrossCertificates__item_,
        CrossCertificates,
        _CertificationPath_userCertificate,
        __CertificationPath_theCACertificates__item_,
        _CertificationPath_theCACertificates,
        CertificationPath,
        _PkiPath__item_,
        PkiPath,
        _CertificateList_toBeSigned,
        ___CertificateList_algorithmIdentifier_algorithm_tab,
        __CertificateList_algorithmIdentifier_algorithm,
        ___CertificateList_algorithmIdentifier_parameters_tab,
        __CertificateList_algorithmIdentifier_parameters,
        _CertificateList_algorithmIdentifier,
        _CertificateList_signature,
        CertificateList,
        _CertificateListContent_version,
        ___CertificateListContent_signature_algorithm_tab,
        __CertificateListContent_signature_algorithm,
        ___CertificateListContent_signature_parameters_tab,
        __CertificateListContent_signature_parameters,
        _CertificateListContent_signature,
        _CertificateListContent_issuer,
        _CertificateListContent_thisUpdate,
        _CertificateListContent_nextUpdate,
        ___CertificateListContent_revokedCertificates__item__serialNumber,
        ___CertificateListContent_revokedCertificates__item__revocationDate,
        ___CertificateListContent_revokedCertificates__item__crlEntryExtensions,
        __CertificateListContent_revokedCertificates__item_,
        _CertificateListContent_revokedCertificates,
        _CertificateListContent_crlExtensions,
        CertificateListContent,
        _CertAVL_toBeSigned,
        ___CertAVL_algorithmIdentifier_algorithm_tab,
        __CertAVL_algorithmIdentifier_algorithm,
        ___CertAVL_algorithmIdentifier_parameters_tab,
        __CertAVL_algorithmIdentifier_parameters,
        _CertAVL_algorithmIdentifier,
        _CertAVL_signature,
        CertAVL,
        _TBSCertAVL_version,
        _TBSCertAVL_serialNumber,
        ___TBSCertAVL_signature_algorithm_tab,
        __TBSCertAVL_signature_algorithm,
        ___TBSCertAVL_signature_parameters_tab,
        __TBSCertAVL_signature_parameters,
        _TBSCertAVL_signature,
        _TBSCertAVL_issuer,
        _TBSCertAVL_constrained,
        ____TBSCertAVL_entries__item__idType_certIdentifier,
        ____TBSCertAVL_entries__item__idType_entityGroup,
        ___TBSCertAVL_entries__item__idType,
        ___TBSCertAVL_entries__item__scope,
        ___TBSCertAVL_entries__item__entryExtensions,
        __TBSCertAVL_entries__item_,
        _TBSCertAVL_entries,
        _TBSCertAVL_avlExtensions,
        TBSCertAVL,
        AvlSerialNumber,
        _PKCertIdentifier_issuerSerialNumber,
        ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab,
        ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm,
        ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab,
        ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters,
        __PKCertIdentifier_fingerprintPKC_algorithmIdentifier,
        __PKCertIdentifier_fingerprintPKC_fingerprint,
        _PKCertIdentifier_fingerprintPKC,
        ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab,
        ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm,
        ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab,
        ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters,
        __PKCertIdentifier_fingerprintPK_algorithmIdentifier,
        __PKCertIdentifier_fingerprintPK_fingerprint,
        _PKCertIdentifier_fingerprintPK,
        PKCertIdentifier,
        _IssuerSerialNumber_issuer,
        _IssuerSerialNumber_serialNumber,
        IssuerSerialNumber,
        _ScopeRestrictions__item_,
        ScopeRestrictions,
        SCOPE_RESTRICTION,
        _ScopeRestriction_id,
        _ScopeRestriction_restriction,
        ScopeRestriction,
        protRestrict,
        _protRestrict_val_ExtnType,
        _ProtRestriction__item_,
        ProtRestriction,
        pkiUser,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        __pmiUser_OptionalAttributes_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        pkiCA,
        __pmiUser_OptionalAttributes_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1,
        __pmiUser_OptionalAttributes_val_Type_2,
        __pmiUser_OptionalAttributes_val_Type_3,
        __pmiUser_OptionalAttributes_val_Type_4,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2,
        cRLDistributionPoint,
        ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3,
        _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0,
        __pmiUser_OptionalAttributes_val_Type_0_0,
        cRLDistPtNameForm,
        __cRLDistPtNameForm_MandatoryAttributes_val_Type_0,
        deltaCRL,
        cpCps,
        __pmiUser_OptionalAttributes_val_Type_0_1,
        __pmiUser_OptionalAttributes_val_Type_1_0,
        pkiCertPath,
        __pmiUser_OptionalAttributes_val_Type_0_2,
        userCertificate,
        _userCertificate_val_Type,
        cACertificate,
        _cACertificate_val_Type,
        crossCertificatePair,
        _crossCertificatePair_val_Type,
        _CertificatePair_issuedToThisCA,
        _CertificatePair_issuedByThisCA,
        CertificatePair,
        certificateRevocationList,
        _certificateRevocationList_val_Type,
        eepkCertificateRevocationList,
        _eepkCertificateRevocationList_val_Type,
        authorityRevocationList,
        _authorityRevocationList_val_Type,
        deltaRevocationList,
        _deltaRevocationList_val_Type,
        supportedAlgorithms,
        _supportedAlgorithms_val_Type,
        ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm,
        ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4,
        ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab,
        __SupportedAlgorithm_algorithmIdentifier_algorithm,
        ___SupportedAlgorithm_algorithmIdentifier_parameters_tab,
        __SupportedAlgorithm_algorithmIdentifier_parameters,
        _SupportedAlgorithm_algorithmIdentifier,
        _SupportedAlgorithm_intendedUsage,
        _SupportedAlgorithm_intendedCertificatePolicies,
        SupportedAlgorithm,
        certificationPracticeStmt,
        _certificationPracticeStmt_val_Type,
        _InfoSyntax_content,
        __InfoSyntax_pointer_name,
        _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab,
        ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm,
        _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab,
        ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters,
        ___InfoSyntax_pointer_hash_algorithmIdentifier,
        ___InfoSyntax_pointer_hash_hashValue,
        __InfoSyntax_pointer_hash,
        _InfoSyntax_pointer,
        InfoSyntax,
        POLICY,
        _HashedPolicyInfo_tab,
        HashedPolicyInfo,
        Policies,
        certificatePolicy,
        _certificatePolicy_val_Type,
        _PolicySyntax_policyIdentifier,
        _PolicySyntax_policySyntax,
        PolicySyntax,
        PolicyID,
        pkiPath,
        _pkiPath_val_Type,
        userPassword,
        _userPassword_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_5,
        x509Certificate,
        _x509Certificate_val_Type,
        x509CertificateList,
        _x509CertificateList_val_Type,
        x509CertificatePair,
        _x509CertificatePair_val_Type,
        x509SupportedAlgorithm,
        _x509SupportedAlgorithm_val_Type,
        id_oc_cRLDistributionPoint,
        id_oc_pkiUser,
        id_oc_pkiCA,
        id_oc_deltaCRL,
        id_oc_cpCps,
        id_oc_pkiCertPath,
        id_nf_cRLDistPtNameForm,
        id_at_userPassword,
        id_at_userCertificate,
        id_at_cAcertificate,
        id_at_authorityRevocationList,
        id_at_certificateRevocationList,
        id_at_crossCertificatePair,
        id_at_supportedAlgorithms,
        id_at_deltaRevocationList,
        id_at_certificationPracticeStmt,
        id_at_certificatePolicy,
        id_at_pkiPath,
        id_at_eepkCertificateRevocationList,
        id_lsx_x509Certificate,
        id_lsx_x509CertificateList,
        id_lsx_x509CertificatePair,
        id_lsx_x509SupportedAlgorithm,
        id_protRestrict,
    ]

class BasicAccessControl:

    _name_  = 'BasicAccessControl'
    _oid_   = [2, 5, 1, 24, 8]
    
    _obj_ = [
        'accessControlScheme',
        'ACIItem',
        'Precedence',
        'ProtectedItems',
        'MaxValueCount',
        'RestrictedValue',
        'UserClasses',
        'ItemPermission',
        'UserPermission',
        'AuthenticationLevel',
        'GrantsAndDenials',
        'prescriptiveACI',
        'entryACI',
        'subentryACI',
        'id-aca-accessControlScheme',
        'id-aca-prescriptiveACI',
        'id-aca-entryACI',
        'id-aca-subentryACI',
        'basicAccessControlScheme',
        'simplifiedAccessControlScheme',
        'rule-based-access-control',
        'rule-and-basic-access-control',
        'rule-and-simple-access-control',
        ]
    _type_ = [
        'ACIItem',
        'Precedence',
        'ProtectedItems',
        'MaxValueCount',
        'RestrictedValue',
        'UserClasses',
        'ItemPermission',
        'UserPermission',
        'AuthenticationLevel',
        'GrantsAndDenials',
        ]
    _set_ = [
        ]
    _val_ = [
        'accessControlScheme',
        'prescriptiveACI',
        'entryACI',
        'subentryACI',
        'id-aca-accessControlScheme',
        'id-aca-prescriptiveACI',
        'id-aca-entryACI',
        'id-aca-subentryACI',
        'basicAccessControlScheme',
        'simplifiedAccessControlScheme',
        'rule-based-access-control',
        'rule-and-basic-access-control',
        'rule-and-simple-access-control',
        ]
    _class_ = [
        'accessControlScheme',
        'prescriptiveACI',
        'entryACI',
        'subentryACI',
        ]
    _param_ = [
        ]
    
    #-----< accessControlScheme >-----#
    accessControlScheme = CLASS(name='accessControlScheme', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _accessControlScheme_val_Type = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    accessControlScheme._val = dict([('Type', _accessControlScheme_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 1))])
    
    #-----< ACIItem >-----#
    ACIItem = SEQ(name='ACIItem', mode=MODE_TYPE)
    _ACIItem_identificationTag = CHOICE(name='identificationTag', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ACIItem_precedence = INT(name='precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')))
    _ACIItem_authenticationLevel = CHOICE(name='authenticationLevel', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'AuthenticationLevel')))
    _ACIItem_itemOrUserFirst = CHOICE(name='itemOrUserFirst', mode=MODE_TYPE)
    __ACIItem_itemOrUserFirst_itemFirst = SEQ(name='itemFirst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ACIItem_itemOrUserFirst_itemFirst_protectedItems = SEQ(name='protectedItems', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ProtectedItems')))
    ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions = SET_OF(name='itemPermissions', mode=MODE_TYPE)
    ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ItemPermission')))
    ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions._cont = ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_
    __ACIItem_itemOrUserFirst_itemFirst._cont = ASN1Dict([
        ('protectedItems', ___ACIItem_itemOrUserFirst_itemFirst_protectedItems),
        ('itemPermissions', ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions),
        ])
    __ACIItem_itemOrUserFirst_itemFirst._ext = []
    __ACIItem_itemOrUserFirst_userFirst = SEQ(name='userFirst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ACIItem_itemOrUserFirst_userFirst_userClasses = SEQ(name='userClasses', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserClasses')))
    ___ACIItem_itemOrUserFirst_userFirst_userPermissions = SET_OF(name='userPermissions', mode=MODE_TYPE)
    ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserPermission')))
    ___ACIItem_itemOrUserFirst_userFirst_userPermissions._cont = ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_
    __ACIItem_itemOrUserFirst_userFirst._cont = ASN1Dict([
        ('userClasses', ___ACIItem_itemOrUserFirst_userFirst_userClasses),
        ('userPermissions', ___ACIItem_itemOrUserFirst_userFirst_userPermissions),
        ])
    __ACIItem_itemOrUserFirst_userFirst._ext = []
    _ACIItem_itemOrUserFirst._cont = ASN1Dict([
        ('itemFirst', __ACIItem_itemOrUserFirst_itemFirst),
        ('userFirst', __ACIItem_itemOrUserFirst_userFirst),
        ])
    _ACIItem_itemOrUserFirst._ext = []
    ACIItem._cont = ASN1Dict([
        ('identificationTag', _ACIItem_identificationTag),
        ('precedence', _ACIItem_precedence),
        ('authenticationLevel', _ACIItem_authenticationLevel),
        ('itemOrUserFirst', _ACIItem_itemOrUserFirst),
        ])
    ACIItem._ext = []
    
    #-----< Precedence >-----#
    Precedence = INT(name='Precedence', mode=MODE_TYPE)
    Precedence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ProtectedItems >-----#
    ProtectedItems = SEQ(name='ProtectedItems', mode=MODE_TYPE)
    _ProtectedItems_entry = NULL(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_allUserAttributeTypes = NULL(name='allUserAttributeTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_attributeType = SET_OF(name='attributeType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_attributeType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_attributeType._cont = __ProtectedItems_attributeType__item_
    _ProtectedItems_attributeType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_allAttributeValues = SET_OF(name='allAttributeValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_allAttributeValues__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_allAttributeValues._cont = __ProtectedItems_allAttributeValues__item_
    _ProtectedItems_allAttributeValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_allUserAttributeTypesAndValues = NULL(name='allUserAttributeTypesAndValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_attributeValue = SET_OF(name='attributeValue', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_attributeValue__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _ProtectedItems_attributeValue._cont = __ProtectedItems_attributeValue__item_
    _ProtectedItems_attributeValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_selfValue = SET_OF(name='selfValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_selfValue__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_selfValue._cont = __ProtectedItems_selfValue__item_
    _ProtectedItems_selfValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_rangeOfValues = CHOICE(name='rangeOfValues', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _ProtectedItems_maxValueCount = SET_OF(name='maxValueCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_maxValueCount__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'MaxValueCount')))
    _ProtectedItems_maxValueCount._cont = __ProtectedItems_maxValueCount__item_
    _ProtectedItems_maxValueCount._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_maxImmSub = INT(name='maxImmSub', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_restrictedBy = SET_OF(name='restrictedBy', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_restrictedBy__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'RestrictedValue')))
    _ProtectedItems_restrictedBy._cont = __ProtectedItems_restrictedBy__item_
    _ProtectedItems_restrictedBy._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_contexts = SET_OF(name='contexts', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    _ProtectedItems_contexts._cont = __ProtectedItems_contexts__item_
    _ProtectedItems_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_classes = CHOICE(name='classes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')), opt=True)
    ProtectedItems._cont = ASN1Dict([
        ('entry', _ProtectedItems_entry),
        ('allUserAttributeTypes', _ProtectedItems_allUserAttributeTypes),
        ('attributeType', _ProtectedItems_attributeType),
        ('allAttributeValues', _ProtectedItems_allAttributeValues),
        ('allUserAttributeTypesAndValues', _ProtectedItems_allUserAttributeTypesAndValues),
        ('attributeValue', _ProtectedItems_attributeValue),
        ('selfValue', _ProtectedItems_selfValue),
        ('rangeOfValues', _ProtectedItems_rangeOfValues),
        ('maxValueCount', _ProtectedItems_maxValueCount),
        ('maxImmSub', _ProtectedItems_maxImmSub),
        ('restrictedBy', _ProtectedItems_restrictedBy),
        ('contexts', _ProtectedItems_contexts),
        ('classes', _ProtectedItems_classes),
        ])
    ProtectedItems._ext = []
    
    #-----< MaxValueCount >-----#
    MaxValueCount = SEQ(name='MaxValueCount', mode=MODE_TYPE)
    _MaxValueCount_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _MaxValueCount_maxCount = INT(name='maxCount', mode=MODE_TYPE)
    MaxValueCount._cont = ASN1Dict([
        ('type', _MaxValueCount_type),
        ('maxCount', _MaxValueCount_maxCount),
        ])
    MaxValueCount._ext = []
    
    #-----< RestrictedValue >-----#
    RestrictedValue = SEQ(name='RestrictedValue', mode=MODE_TYPE)
    _RestrictedValue_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _RestrictedValue_valuesIn = OID(name='valuesIn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    RestrictedValue._cont = ASN1Dict([
        ('type', _RestrictedValue_type),
        ('valuesIn', _RestrictedValue_valuesIn),
        ])
    RestrictedValue._ext = []
    
    #-----< UserClasses >-----#
    UserClasses = SEQ(name='UserClasses', mode=MODE_TYPE)
    _UserClasses_allUsers = NULL(name='allUsers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _UserClasses_thisEntry = NULL(name='thisEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _UserClasses_name = SET_OF(name='name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_name__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    _UserClasses_name._cont = __UserClasses_name__item_
    _UserClasses_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UserClasses_userGroup = SET_OF(name='userGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_userGroup__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    _UserClasses_userGroup._cont = __UserClasses_userGroup__item_
    _UserClasses_userGroup._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UserClasses_subtree = SET_OF(name='subtree', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    _UserClasses_subtree._cont = __UserClasses_subtree__item_
    _UserClasses_subtree._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    UserClasses._cont = ASN1Dict([
        ('allUsers', _UserClasses_allUsers),
        ('thisEntry', _UserClasses_thisEntry),
        ('name', _UserClasses_name),
        ('userGroup', _UserClasses_userGroup),
        ('subtree', _UserClasses_subtree),
        ])
    UserClasses._ext = []
    
    #-----< ItemPermission >-----#
    ItemPermission = SEQ(name='ItemPermission', mode=MODE_TYPE)
    _ItemPermission_precedence = INT(name='precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')), opt=True)
    _ItemPermission_userClasses = SEQ(name='userClasses', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserClasses')))
    _ItemPermission_grantsAndDenials = BIT_STR(name='grantsAndDenials', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'GrantsAndDenials')))
    ItemPermission._cont = ASN1Dict([
        ('precedence', _ItemPermission_precedence),
        ('userClasses', _ItemPermission_userClasses),
        ('grantsAndDenials', _ItemPermission_grantsAndDenials),
        ])
    ItemPermission._ext = []
    
    #-----< UserPermission >-----#
    UserPermission = SEQ(name='UserPermission', mode=MODE_TYPE)
    _UserPermission_precedence = INT(name='precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')), opt=True)
    _UserPermission_protectedItems = SEQ(name='protectedItems', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ProtectedItems')))
    _UserPermission_grantsAndDenials = BIT_STR(name='grantsAndDenials', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'GrantsAndDenials')))
    UserPermission._cont = ASN1Dict([
        ('precedence', _UserPermission_precedence),
        ('protectedItems', _UserPermission_protectedItems),
        ('grantsAndDenials', _UserPermission_grantsAndDenials),
        ])
    UserPermission._ext = []
    
    #-----< AuthenticationLevel >-----#
    AuthenticationLevel = CHOICE(name='AuthenticationLevel', mode=MODE_TYPE)
    _AuthenticationLevel_basicLevels = SEQ(name='basicLevels', mode=MODE_TYPE)
    __AuthenticationLevel_basicLevels_level = ENUM(name='level', mode=MODE_TYPE)
    __AuthenticationLevel_basicLevels_level._cont = ASN1Dict([('none', 0), ('simple', 1), ('strong', 2)])
    __AuthenticationLevel_basicLevels_level._ext = []
    __AuthenticationLevel_basicLevels_localQualifier = INT(name='localQualifier', mode=MODE_TYPE, opt=True)
    __AuthenticationLevel_basicLevels_signed = BOOL(name='signed', mode=MODE_TYPE, default=False)
    _AuthenticationLevel_basicLevels._cont = ASN1Dict([
        ('level', __AuthenticationLevel_basicLevels_level),
        ('localQualifier', __AuthenticationLevel_basicLevels_localQualifier),
        ('signed', __AuthenticationLevel_basicLevels_signed),
        ])
    _AuthenticationLevel_basicLevels._ext = []
    _AuthenticationLevel_other = EXT(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    AuthenticationLevel._cont = ASN1Dict([
        ('basicLevels', _AuthenticationLevel_basicLevels),
        ('other', _AuthenticationLevel_other),
        ])
    AuthenticationLevel._ext = []
    
    #-----< GrantsAndDenials >-----#
    GrantsAndDenials = BIT_STR(name='GrantsAndDenials', mode=MODE_TYPE)
    GrantsAndDenials._cont = ASN1Dict([('grantAdd', 0), ('denyAdd', 1), ('grantDiscloseOnError', 2), ('denyDiscloseOnError', 3), ('grantRead', 4), ('denyRead', 5), ('grantRemove', 6), ('denyRemove', 7), ('grantBrowse', 8), ('denyBrowse', 9), ('grantExport', 10), ('denyExport', 11), ('grantImport', 12), ('denyImport', 13), ('grantModify', 14), ('denyModify', 15), ('grantRename', 16), ('denyRename', 17), ('grantReturnDN', 18), ('denyReturnDN', 19), ('grantCompare', 20), ('denyCompare', 21), ('grantFilterMatch', 22), ('denyFilterMatch', 23), ('grantInvoke', 24), ('denyInvoke', 25)])
    
    #-----< prescriptiveACI >-----#
    prescriptiveACI = CLASS(name='prescriptiveACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _prescriptiveACI_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    prescriptiveACI._val = dict([('Type', _prescriptiveACI_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 4))])
    
    #-----< entryACI >-----#
    entryACI = CLASS(name='entryACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _entryACI_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    entryACI._val = dict([('Type', _entryACI_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 5))])
    
    #-----< subentryACI >-----#
    subentryACI = CLASS(name='subentryACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subentryACI_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    subentryACI._val = dict([('Type', _subentryACI_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 6))])
    
    #-----< id-aca-accessControlScheme >-----#
    id_aca_accessControlScheme = OID(name='id-aca-accessControlScheme', mode=MODE_VALUE)
    id_aca_accessControlScheme._val = (2, 5, 24, 1)
    
    #-----< id-aca-prescriptiveACI >-----#
    id_aca_prescriptiveACI = OID(name='id-aca-prescriptiveACI', mode=MODE_VALUE)
    id_aca_prescriptiveACI._val = (2, 5, 24, 4)
    
    #-----< id-aca-entryACI >-----#
    id_aca_entryACI = OID(name='id-aca-entryACI', mode=MODE_VALUE)
    id_aca_entryACI._val = (2, 5, 24, 5)
    
    #-----< id-aca-subentryACI >-----#
    id_aca_subentryACI = OID(name='id-aca-subentryACI', mode=MODE_VALUE)
    id_aca_subentryACI._val = (2, 5, 24, 6)
    
    #-----< basicAccessControlScheme >-----#
    basicAccessControlScheme = OID(name='basicAccessControlScheme', mode=MODE_VALUE)
    basicAccessControlScheme._val = (2, 5, 28, 1)
    
    #-----< simplifiedAccessControlScheme >-----#
    simplifiedAccessControlScheme = OID(name='simplifiedAccessControlScheme', mode=MODE_VALUE)
    simplifiedAccessControlScheme._val = (2, 5, 28, 2)
    
    #-----< rule-based-access-control >-----#
    rule_based_access_control = OID(name='rule-based-access-control', mode=MODE_VALUE)
    rule_based_access_control._val = (2, 5, 28, 3)
    
    #-----< rule-and-basic-access-control >-----#
    rule_and_basic_access_control = OID(name='rule-and-basic-access-control', mode=MODE_VALUE)
    rule_and_basic_access_control._val = (2, 5, 28, 4)
    
    #-----< rule-and-simple-access-control >-----#
    rule_and_simple_access_control = OID(name='rule-and-simple-access-control', mode=MODE_VALUE)
    rule_and_simple_access_control._val = (2, 5, 28, 5)
    
    _all_ = [
        accessControlScheme,
        _accessControlScheme_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _ACIItem_identificationTag,
        _ACIItem_precedence,
        _ACIItem_authenticationLevel,
        ___ACIItem_itemOrUserFirst_itemFirst_protectedItems,
        ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_,
        ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions,
        __ACIItem_itemOrUserFirst_itemFirst,
        ___ACIItem_itemOrUserFirst_userFirst_userClasses,
        ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_,
        ___ACIItem_itemOrUserFirst_userFirst_userPermissions,
        __ACIItem_itemOrUserFirst_userFirst,
        _ACIItem_itemOrUserFirst,
        ACIItem,
        Precedence,
        _ProtectedItems_entry,
        _ProtectedItems_allUserAttributeTypes,
        __ProtectedItems_attributeType__item_,
        _ProtectedItems_attributeType,
        __ProtectedItems_allAttributeValues__item_,
        _ProtectedItems_allAttributeValues,
        _ProtectedItems_allUserAttributeTypesAndValues,
        __ProtectedItems_attributeValue__item_,
        _ProtectedItems_attributeValue,
        __ProtectedItems_selfValue__item_,
        _ProtectedItems_selfValue,
        _ProtectedItems_rangeOfValues,
        __ProtectedItems_maxValueCount__item_,
        _ProtectedItems_maxValueCount,
        _ProtectedItems_maxImmSub,
        __ProtectedItems_restrictedBy__item_,
        _ProtectedItems_restrictedBy,
        __ProtectedItems_contexts__item_,
        _ProtectedItems_contexts,
        _ProtectedItems_classes,
        ProtectedItems,
        _MaxValueCount_type,
        _MaxValueCount_maxCount,
        MaxValueCount,
        _RestrictedValue_type,
        _RestrictedValue_valuesIn,
        RestrictedValue,
        _UserClasses_allUsers,
        _UserClasses_thisEntry,
        __UserClasses_name__item_,
        _UserClasses_name,
        __UserClasses_userGroup__item_,
        _UserClasses_userGroup,
        __UserClasses_subtree__item_,
        _UserClasses_subtree,
        UserClasses,
        _ItemPermission_precedence,
        _ItemPermission_userClasses,
        _ItemPermission_grantsAndDenials,
        ItemPermission,
        _UserPermission_precedence,
        _UserPermission_protectedItems,
        _UserPermission_grantsAndDenials,
        UserPermission,
        __AuthenticationLevel_basicLevels_level,
        __AuthenticationLevel_basicLevels_localQualifier,
        __AuthenticationLevel_basicLevels_signed,
        _AuthenticationLevel_basicLevels,
        _AuthenticationLevel_other,
        AuthenticationLevel,
        GrantsAndDenials,
        prescriptiveACI,
        _prescriptiveACI_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        entryACI,
        _entryACI_val_Type,
        subentryACI,
        _subentryACI_val_Type,
        id_aca_accessControlScheme,
        id_aca_prescriptiveACI,
        id_aca_entryACI,
        id_aca_subentryACI,
        basicAccessControlScheme,
        simplifiedAccessControlScheme,
        rule_based_access_control,
        rule_and_basic_access_control,
        rule_and_simple_access_control,
    ]

class Basic_Service_Elements:

    _name_  = 'Basic-Service-Elements'
    _oid_   = [0, 4, 0, 196, 8]
    
    _obj_ = [
        'BasicService',
        ]
    _type_ = [
        'BasicService',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BasicService >-----#
    BasicService = ENUM(name='BasicService', mode=MODE_TYPE)
    BasicService._cont = ASN1Dict([('allServices', 0), ('speech', 1), ('unrestrictedDigitalInformation', 2), ('audio3k1Hz', 3), ('unrestrictedDigitalInformationWithTonesAndAnnouncements', 4), ('multirate', 5), ('telephony3k1Hz', 32), ('teletex', 33), ('telefaxGroup4Class1', 34), ('videotexSyntaxBased', 35), ('videotelephony', 36), ('telefaxGroup2-3', 37), ('telephony7kHz', 38), ('euroFileTransfer', 39), ('fileTransferAndAccessManagement', 40)])
    BasicService._ext = None
    
    _all_ = [
        BasicService,
    ]

class CAP_classes:

    _name_  = 'CAP-classes'
    _oid_   = [0, 4, 0, 0, 1, 3, 54, 7]
    
    _obj_ = [
        'gsmSSF',
        'gsmSRF',
        'smsSSF-V3',
        'smsSSF-V4',
        'gprsSSF',
        'EXTENSION',
        'firstExtension',
        'SupportedExtensions',
        'PARAMETERS-BOUND',
        'cAPSpecificBoundSet',
        ]
    _type_ = [
        'EXTENSION',
        'PARAMETERS-BOUND',
        ]
    _set_ = [
        'SupportedExtensions',
        ]
    _val_ = [
        'gsmSSF',
        'gsmSRF',
        'smsSSF-V3',
        'smsSSF-V4',
        'gprsSSF',
        'firstExtension',
        'cAPSpecificBoundSet',
        ]
    _class_ = [
        'gsmSSF',
        'gsmSRF',
        'smsSSF-V3',
        'smsSSF-V4',
        'gprsSSF',
        'EXTENSION',
        'firstExtension',
        'SupportedExtensions',
        'PARAMETERS-BOUND',
        'cAPSpecificBoundSet',
        ]
    _param_ = [
        ]
    
    #-----< gsmSSF >-----#
    gsmSSF = CLASS(name='gsmSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure),
        ('bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey),
        ('calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        ('cGEncountered', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered),
        ('iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        ('locationNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        ('highLayerCompatibility', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        ('additionalCallingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        ('bearerCapability', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability),
        ('eventTypeBCSM', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        ('redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        ('redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation),
        ('cause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier),
        ('cug-Index', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI),
        ('subscriberState', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState),
        ('locationInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation),
        ('ext-basicServiceCode', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        ('callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        ('mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress),
        ('calledPartyBCDNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        ('timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        ('callForwardingSS-Pending', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        ('initialDPArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID),
        ('scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM),
        ('eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        ('allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments),
        ('allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        ('requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = SEQ(name='ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('problem', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem),
        ('operation', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        ('srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        ('partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions),
        ('aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        ('redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        ('redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber),
        ('legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        ('oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        ('suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._ext = ['suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        ('legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased),
        ('releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        ('legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        ('legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        ('none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        ('resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        ('legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        ('bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        ('partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        ('tone', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        ('releaseCause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        ('gapCriteria', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria),
        ('gapIndicators', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators),
        ('controlType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType),
        ('gapTreatment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions),
        ('legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        ('callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        ('gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        ('suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._cont = ASN1Dict([
        ('supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions),
        ('releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._ext = ['releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID),
        ('iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        ('none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        ('resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID),
        ('scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._ext = ['originalCalledPartyID', 'callingPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        ('bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        ('eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        ('eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        ('allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        ('allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        ('requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        ('requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        ('srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        ('partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions),
        ('aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        ('redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        ('redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        ('legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        ('oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        ('suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._ext = ['suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        ('legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased),
        ('releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        ('legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        ('legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        ('none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        ('resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        ('legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        ('bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions),
        ('legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        ('callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        ('gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        ('suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        ('supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions),
        ('releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._ext = ['releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        ('callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        ('bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._ext = None
    gsmSSF._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 3))]), dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 5))])], rr=[], ev=None, er=[])), ('Responds', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 6))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 5))])
    
    #-----< gsmSRF >-----#
    gsmSRF = CLASS(name='gsmSRF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39._cont = ASN1Dict([
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID),
        ('iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41._ext = None
    gsmSRF._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 13))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 6))])
    
    #-----< smsSSF-V3 >-----#
    smsSSF_V3 = CLASS(name='smsSSF-V3', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_serviceKey),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber),
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMSI),
        ('locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC),
        ('locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress),
        ('timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone),
        ('tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier),
        ('tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme),
        ('tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions),
        ('smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber),
        ('mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_mscAddress),
        ('sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number),
        ('ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2),
        ('gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass),
        ('iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMEI),
        ('calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43._cont = ASN1Dict([
        ('callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45._cont = ASN1Dict([
        ('sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6._cont = ASN1Dict([
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventTypeSMS),
        ('eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V3._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 20, 26, 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 8))])
    
    #-----< smsSSF-V4 >-----#
    smsSSF_V4 = CLASS(name='smsSSF-V4', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_serviceKey),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber),
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMSI),
        ('locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC),
        ('locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress),
        ('timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone),
        ('tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier),
        ('tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme),
        ('tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions),
        ('smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber),
        ('mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_mscAddress),
        ('sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number),
        ('ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2),
        ('gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass),
        ('iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMEI),
        ('calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49._cont = ASN1Dict([
        ('callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50._cont = ASN1Dict([
        ('sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7._cont = ASN1Dict([
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventTypeSMS),
        ('eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V4._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 9))])
    
    #-----< gprsSSF >-----#
    gprsSSF = CLASS(name='gprsSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_serviceKey),
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType),
        ('mSISDN', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_mSISDN),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMSI),
        ('timeAndTimeZone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone),
        ('gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass),
        ('endUserAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress),
        ('qualityOfService', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService),
        ('accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName),
        ('routeingAreaIdentity', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity),
        ('chargingID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_chargingID),
        ('sGSNCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities),
        ('locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS),
        ('pDPInitiationType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions),
        ('gGSNAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress),
        ('secondaryPDP-context', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context),
        ('iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMEI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54._cont = ASN1Dict([
        ('gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8._cont = ASN1Dict([
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventType),
        ('miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation),
        ('pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56._cont = ASN1Dict([
        ('gPRSCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57._cont = ASN1Dict([
        ('accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName),
        ('pdpID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_pdpID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________58 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59._cont = ASN1Dict([
        ('gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60._cont = ASN1Dict([
        ('gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10._cont = ASN1Dict([
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventType),
        ('miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation),
        ('pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________________61 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65._cont = ASN1Dict([
        ('gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66._cont = ASN1Dict([
        ('gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11._cont = ASN1Dict([
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventType),
        ('miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation),
        ('pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68._ext = []
    gprsSSF._val = dict([('Initiates', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________58), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________________61), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 14))])], rr=[], ev=None, er=[])), ('Responds', ASN1Set(rv=[dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 15))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 25, 7))])
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name='EXTENSION', mode=MODE_TYPE)
    _EXTENSION_ExtensionType = OPEN(name='ExtensionType', mode=MODE_TYPE)
    _EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default='ignore')
    _EXTENSION_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    EXTENSION._cont = ASN1Dict([
        ('ExtensionType', _EXTENSION_ExtensionType),
        ('criticality', _EXTENSION_criticality),
        ('id', _EXTENSION_id),
        ])
    
    #-----< firstExtension >-----#
    firstExtension = CLASS(name='firstExtension', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _firstExtension_val_ExtensionType = NULL(name='ExtensionType', mode=MODE_TYPE)
    firstExtension._val = dict([('ExtensionType', _firstExtension_val_ExtensionType), ('criticality', 'ignore'), ('id', ('global', (0, 4, 0, 1, 2)))])
    
    #-----< SupportedExtensions >-----#
    SupportedExtensions = CLASS(name='SupportedExtensions', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _SupportedExtensions_val_ExtensionType_0 = NULL(name='ExtensionType', mode=MODE_TYPE)
    SupportedExtensions._val = ASN1Set(rv=[dict([('ExtensionType', _SupportedExtensions_val_ExtensionType_0), ('criticality', 'ignore'), ('id', ('global', (0, 4, 0, 1, 2)))])], rr=[], ev=[], er=[])
    
    #-----< PARAMETERS-BOUND >-----#
    PARAMETERS_BOUND = CLASS(name='PARAMETERS-BOUND', mode=MODE_TYPE)
    _PARAMETERS_BOUND_minAccessPointNameLength = INT(name='minAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAccessPointNameLength = INT(name='maxAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAChBillingChargingLength = INT(name='minAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAChBillingChargingLength = INT(name='maxAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAttributesLength = INT(name='minAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAttributesLength = INT(name='maxAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxBearerCapabilityLength = INT(name='maxBearerCapabilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyBCDNumberLength = INT(name='minCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength = INT(name='maxCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyNumberLength = INT(name='minCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyNumberLength = INT(name='maxCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallingPartyNumberLength = INT(name='minCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallingPartyNumberLength = INT(name='maxCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallResultLength = INT(name='minCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallResultLength = INT(name='maxCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCarrierLength = INT(name='minCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCarrierLength = INT(name='maxCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCauseLength = INT(name='minCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCauseLength = INT(name='maxCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minDigitsLength = INT(name='minDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxDigitsLength = INT(name='maxDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingDataLength = INT(name='minFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingDataLength = INT(name='maxFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingLength = INT(name='minFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingLength = INT(name='maxFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGenericNumberLength = INT(name='minGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGenericNumberLength = INT(name='maxGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGPRSCauseLength = INT(name='minGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGPRSCauseLength = INT(name='maxGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minIPSSPCapabilitiesLength = INT(name='minIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength = INT(name='maxIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLocationNumberLength = INT(name='minLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLocationNumberLength = INT(name='maxLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLowLayerCompatibilityLength = INT(name='minLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLowLayerCompatibilityLength = INT(name='maxLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minMessageContentLength = INT(name='minMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxMessageContentLength = INT(name='maxMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minOriginalCalledPartyIDLength = INT(name='minOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength = INT(name='maxOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minPDPAddressLength = INT(name='minPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxPDPAddressLength = INT(name='maxPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minRedirectingPartyIDLength = INT(name='minRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxRedirectingPartyIDLength = INT(name='maxRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minScfIDLength = INT(name='minScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxScfIDLength = INT(name='maxScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minSCIBillingChargingLength = INT(name='minSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxSCIBillingChargingLength = INT(name='maxSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minTimeAndTimezoneLength = INT(name='minTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxTimeAndTimezoneLength = INT(name='maxTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfBCSMEvents = INT(name='numOfBCSMEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo = INT(name='numOfChangeOfPositionControlInfo', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfCSs = INT(name='numOfCSs', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfSMSEvents = INT(name='numOfSMSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGPRSEvents = INT(name='numOfGPRSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfExtensions = INT(name='numOfExtensions', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGenericNumbers = INT(name='numOfGenericNumbers', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfMessageIDs = INT(name='numOfMessageIDs', mode=MODE_VALUE)
    PARAMETERS_BOUND._cont = ASN1Dict([
        ('minAccessPointNameLength', _PARAMETERS_BOUND_minAccessPointNameLength),
        ('maxAccessPointNameLength', _PARAMETERS_BOUND_maxAccessPointNameLength),
        ('minAChBillingChargingLength', _PARAMETERS_BOUND_minAChBillingChargingLength),
        ('maxAChBillingChargingLength', _PARAMETERS_BOUND_maxAChBillingChargingLength),
        ('minAttributesLength', _PARAMETERS_BOUND_minAttributesLength),
        ('maxAttributesLength', _PARAMETERS_BOUND_maxAttributesLength),
        ('maxBearerCapabilityLength', _PARAMETERS_BOUND_maxBearerCapabilityLength),
        ('minCalledPartyBCDNumberLength', _PARAMETERS_BOUND_minCalledPartyBCDNumberLength),
        ('maxCalledPartyBCDNumberLength', _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength),
        ('minCalledPartyNumberLength', _PARAMETERS_BOUND_minCalledPartyNumberLength),
        ('maxCalledPartyNumberLength', _PARAMETERS_BOUND_maxCalledPartyNumberLength),
        ('minCallingPartyNumberLength', _PARAMETERS_BOUND_minCallingPartyNumberLength),
        ('maxCallingPartyNumberLength', _PARAMETERS_BOUND_maxCallingPartyNumberLength),
        ('minCallResultLength', _PARAMETERS_BOUND_minCallResultLength),
        ('maxCallResultLength', _PARAMETERS_BOUND_maxCallResultLength),
        ('minCarrierLength', _PARAMETERS_BOUND_minCarrierLength),
        ('maxCarrierLength', _PARAMETERS_BOUND_maxCarrierLength),
        ('minCauseLength', _PARAMETERS_BOUND_minCauseLength),
        ('maxCauseLength', _PARAMETERS_BOUND_maxCauseLength),
        ('minDigitsLength', _PARAMETERS_BOUND_minDigitsLength),
        ('maxDigitsLength', _PARAMETERS_BOUND_maxDigitsLength),
        ('minFCIBillingChargingDataLength', _PARAMETERS_BOUND_minFCIBillingChargingDataLength),
        ('maxFCIBillingChargingDataLength', _PARAMETERS_BOUND_maxFCIBillingChargingDataLength),
        ('minFCIBillingChargingLength', _PARAMETERS_BOUND_minFCIBillingChargingLength),
        ('maxFCIBillingChargingLength', _PARAMETERS_BOUND_maxFCIBillingChargingLength),
        ('minGenericNumberLength', _PARAMETERS_BOUND_minGenericNumberLength),
        ('maxGenericNumberLength', _PARAMETERS_BOUND_maxGenericNumberLength),
        ('minGPRSCauseLength', _PARAMETERS_BOUND_minGPRSCauseLength),
        ('maxGPRSCauseLength', _PARAMETERS_BOUND_maxGPRSCauseLength),
        ('minIPSSPCapabilitiesLength', _PARAMETERS_BOUND_minIPSSPCapabilitiesLength),
        ('maxIPSSPCapabilitiesLength', _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength),
        ('minLocationNumberLength', _PARAMETERS_BOUND_minLocationNumberLength),
        ('maxLocationNumberLength', _PARAMETERS_BOUND_maxLocationNumberLength),
        ('minLowLayerCompatibilityLength', _PARAMETERS_BOUND_minLowLayerCompatibilityLength),
        ('maxLowLayerCompatibilityLength', _PARAMETERS_BOUND_maxLowLayerCompatibilityLength),
        ('minMessageContentLength', _PARAMETERS_BOUND_minMessageContentLength),
        ('maxMessageContentLength', _PARAMETERS_BOUND_maxMessageContentLength),
        ('minOriginalCalledPartyIDLength', _PARAMETERS_BOUND_minOriginalCalledPartyIDLength),
        ('maxOriginalCalledPartyIDLength', _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength),
        ('minPDPAddressLength', _PARAMETERS_BOUND_minPDPAddressLength),
        ('maxPDPAddressLength', _PARAMETERS_BOUND_maxPDPAddressLength),
        ('minRedirectingPartyIDLength', _PARAMETERS_BOUND_minRedirectingPartyIDLength),
        ('maxRedirectingPartyIDLength', _PARAMETERS_BOUND_maxRedirectingPartyIDLength),
        ('minScfIDLength', _PARAMETERS_BOUND_minScfIDLength),
        ('maxScfIDLength', _PARAMETERS_BOUND_maxScfIDLength),
        ('minSCIBillingChargingLength', _PARAMETERS_BOUND_minSCIBillingChargingLength),
        ('maxSCIBillingChargingLength', _PARAMETERS_BOUND_maxSCIBillingChargingLength),
        ('minTimeAndTimezoneLength', _PARAMETERS_BOUND_minTimeAndTimezoneLength),
        ('maxTimeAndTimezoneLength', _PARAMETERS_BOUND_maxTimeAndTimezoneLength),
        ('numOfBCSMEvents', _PARAMETERS_BOUND_numOfBCSMEvents),
        ('numOfChangeOfPositionControlInfo', _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo),
        ('numOfCSs', _PARAMETERS_BOUND_numOfCSs),
        ('numOfSMSEvents', _PARAMETERS_BOUND_numOfSMSEvents),
        ('numOfGPRSEvents', _PARAMETERS_BOUND_numOfGPRSEvents),
        ('numOfExtensions', _PARAMETERS_BOUND_numOfExtensions),
        ('numOfGenericNumbers', _PARAMETERS_BOUND_numOfGenericNumbers),
        ('numOfMessageIDs', _PARAMETERS_BOUND_numOfMessageIDs),
        ])
    
    #-----< cAPSpecificBoundSet >-----#
    cAPSpecificBoundSet = CLASS(name='cAPSpecificBoundSet', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'PARAMETERS-BOUND')))
    cAPSpecificBoundSet._val = dict([('minAccessPointNameLength', 1), ('maxAccessPointNameLength', 100), ('minAChBillingChargingLength', 5), ('maxAChBillingChargingLength', 177), ('minAttributesLength', 2), ('maxAttributesLength', 10), ('maxBearerCapabilityLength', 11), ('minCalledPartyBCDNumberLength', 1), ('maxCalledPartyBCDNumberLength', 41), ('minCalledPartyNumberLength', 2), ('maxCalledPartyNumberLength', 18), ('minCallingPartyNumberLength', 2), ('maxCallingPartyNumberLength', 10), ('minCallResultLength', 12), ('maxCallResultLength', 193), ('minCarrierLength', 4), ('maxCarrierLength', 4), ('minCauseLength', 2), ('maxCauseLength', 32), ('minDigitsLength', 2), ('maxDigitsLength', 16), ('minFCIBillingChargingDataLength', 1), ('maxFCIBillingChargingDataLength', 160), ('minFCIBillingChargingLength', 5), ('maxFCIBillingChargingLength', 225), ('minGenericNumberLength', 3), ('maxGenericNumberLength', 11), ('minGPRSCauseLength', 1), ('maxGPRSCauseLength', 1), ('minIPSSPCapabilitiesLength', 1), ('maxIPSSPCapabilitiesLength', 4), ('minLocationNumberLength', 2), ('maxLocationNumberLength', 10), ('minLowLayerCompatibilityLength', 1), ('maxLowLayerCompatibilityLength', 16), ('minMessageContentLength', 1), ('maxMessageContentLength', 127), ('minOriginalCalledPartyIDLength', 2), ('maxOriginalCalledPartyIDLength', 10), ('minPDPAddressLength', 1), ('maxPDPAddressLength', 63), ('minRedirectingPartyIDLength', 2), ('maxRedirectingPartyIDLength', 10), ('minScfIDLength', 2), ('maxScfIDLength', 25), ('minSCIBillingChargingLength', 4), ('maxSCIBillingChargingLength', 225), ('minTimeAndTimezoneLength', 8), ('maxTimeAndTimezoneLength', 8), ('numOfBCSMEvents', 30), ('numOfChangeOfPositionControlInfo', 10), ('numOfCSs', 127), ('numOfSMSEvents', 10), ('numOfGPRSEvents', 10), ('numOfExtensions', 10), ('numOfGenericNumbers', 5), ('numOfMessageIDs', 16)])
    
    _all_ = [
        gsmSSF,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38,
        gsmSRF,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41,
        smsSSF_V3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47,
        smsSSF_V4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52,
        gprsSSF,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_mSISDN,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_chargingID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMEI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_pdpID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________58,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________________61,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68,
        _EXTENSION_ExtensionType,
        _EXTENSION_criticality,
        _EXTENSION_id,
        EXTENSION,
        firstExtension,
        _firstExtension_val_ExtensionType,
        SupportedExtensions,
        _SupportedExtensions_val_ExtensionType_0,
        _PARAMETERS_BOUND_minAccessPointNameLength,
        _PARAMETERS_BOUND_maxAccessPointNameLength,
        _PARAMETERS_BOUND_minAChBillingChargingLength,
        _PARAMETERS_BOUND_maxAChBillingChargingLength,
        _PARAMETERS_BOUND_minAttributesLength,
        _PARAMETERS_BOUND_maxAttributesLength,
        _PARAMETERS_BOUND_maxBearerCapabilityLength,
        _PARAMETERS_BOUND_minCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_minCalledPartyNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyNumberLength,
        _PARAMETERS_BOUND_minCallingPartyNumberLength,
        _PARAMETERS_BOUND_maxCallingPartyNumberLength,
        _PARAMETERS_BOUND_minCallResultLength,
        _PARAMETERS_BOUND_maxCallResultLength,
        _PARAMETERS_BOUND_minCarrierLength,
        _PARAMETERS_BOUND_maxCarrierLength,
        _PARAMETERS_BOUND_minCauseLength,
        _PARAMETERS_BOUND_maxCauseLength,
        _PARAMETERS_BOUND_minDigitsLength,
        _PARAMETERS_BOUND_maxDigitsLength,
        _PARAMETERS_BOUND_minFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_minFCIBillingChargingLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingLength,
        _PARAMETERS_BOUND_minGenericNumberLength,
        _PARAMETERS_BOUND_maxGenericNumberLength,
        _PARAMETERS_BOUND_minGPRSCauseLength,
        _PARAMETERS_BOUND_maxGPRSCauseLength,
        _PARAMETERS_BOUND_minIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_minLocationNumberLength,
        _PARAMETERS_BOUND_maxLocationNumberLength,
        _PARAMETERS_BOUND_minLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_maxLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_minMessageContentLength,
        _PARAMETERS_BOUND_maxMessageContentLength,
        _PARAMETERS_BOUND_minOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_minPDPAddressLength,
        _PARAMETERS_BOUND_maxPDPAddressLength,
        _PARAMETERS_BOUND_minRedirectingPartyIDLength,
        _PARAMETERS_BOUND_maxRedirectingPartyIDLength,
        _PARAMETERS_BOUND_minScfIDLength,
        _PARAMETERS_BOUND_maxScfIDLength,
        _PARAMETERS_BOUND_minSCIBillingChargingLength,
        _PARAMETERS_BOUND_maxSCIBillingChargingLength,
        _PARAMETERS_BOUND_minTimeAndTimezoneLength,
        _PARAMETERS_BOUND_maxTimeAndTimezoneLength,
        _PARAMETERS_BOUND_numOfBCSMEvents,
        _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo,
        _PARAMETERS_BOUND_numOfCSs,
        _PARAMETERS_BOUND_numOfSMSEvents,
        _PARAMETERS_BOUND_numOfGPRSEvents,
        _PARAMETERS_BOUND_numOfExtensions,
        _PARAMETERS_BOUND_numOfGenericNumbers,
        _PARAMETERS_BOUND_numOfMessageIDs,
        PARAMETERS_BOUND,
        cAPSpecificBoundSet,
    ]

class CAP_datatypes:

    _name_  = 'CAP-datatypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 52, 7]
    
    _obj_ = [
        'AccessPointName',
        'AChBillingChargingCharacteristics',
        'AChChargingAddress',
        'AdditionalCallingPartyNumber',
        'AlertingPattern',
        'AOCBeforeAnswer',
        'AOCGPRS',
        'AOCSubsequent',
        'AppendFreeFormatData',
        'ApplicationTimer',
        'AssistingSSPIPRoutingAddress',
        'AudibleIndicator',
        'BackwardServiceInteractionInd',
        'BasicGapCriteria',
        'BCSMEvent',
        'BCSM-Failure',
        'BearerCapability',
        'Burst',
        'BurstList',
        'CAI-GSM0224',
        'CalledPartyBCDNumber',
        'CalledPartyNumber',
        'CallingPartyNumber',
        'CallResult',
        'CallSegmentFailure',
        'CallSegmentID',
        'CallSegmentToCancel',
        'CAMEL-AChBillingChargingCharacteristics',
        'CAMEL-CallResult',
        'CAMEL-FCIBillingChargingCharacteristics',
        'CAMEL-FCIGPRSBillingChargingCharacteristics',
        'CAMEL-FCISMSBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristicsAlt',
        'CAMEL-SCIGPRSBillingChargingCharacteristics',
        'Carrier',
        'Cause',
        'CGEncountered',
        'ChangeOfPositionControlInfo',
        'ChangeOfLocation',
        'ChangeOfLocationAlt',
        'ChargeIndicator',
        'ChargeNumber',
        'ChargingCharacteristics',
        'ChargingResult',
        'ChargingRollOver',
        'CollectedDigits',
        'CollectedInfo',
        'ConnectedNumberTreatmentInd',
        'ControlType',
        'CompoundCriteria',
        'CorrelationID',
        'DateAndTime',
        'DestinationRoutingAddress',
        'Digits',
        'DpSpecificCriteria',
        'DpSpecificCriteriaAlt',
        'DpSpecificInfoAlt',
        'ElapsedTime',
        'ElapsedTimeRollOver',
        'EndUserAddress',
        'ErrorTreatment',
        'EventSpecificInformationBCSM',
        'EventSpecificInformationSMS',
        'EventTypeBCSM',
        'EventTypeSMS',
        'Extensions',
        'ExtensionField',
        'FCIBillingChargingCharacteristics',
        'FCIGPRSBillingChargingCharacteristics',
        'FCISMSBillingChargingCharacteristics',
        'ForwardServiceInteractionInd',
        'GapCriteria',
        'GapIndicators',
        'GapOnService',
        'GapTreatment',
        'GenericNumber',
        'GenericNumbers',
        'GPRS-QoS',
        'GPRS-QoS-Extension',
        'GPRSCause',
        'GPRSEvent',
        'GPRSEventSpecificInformation',
        'GPRSEventType',
        'InbandInfo',
        'InformationToSend',
        'InitiatingEntity',
        'InitiatorOfServiceChange',
        'InvokeID',
        'IPRoutingAddress',
        'IPSSPCapabilities',
        'LegOrCallSegment',
        'LegType',
        'leg1',
        'leg2',
        'LocationInformationGPRS',
        'LocationNumber',
        'LowLayerCompatibility',
        'MessageID',
        'MetDPCriteriaList',
        'MetDPCriterion',
        'MetDPCriterionAlt',
        'MidCallControlInfo',
        'MonitorMode',
        'MO-SMSCause',
        'MT-SMSCause',
        'NAOliInfo',
        'NatureOfServiceChange',
        'NumberOfDigits',
        'OCSIApplicable',
        'OriginalCalledPartyID',
        'PDPID',
        'PDPInitiationType',
        'QualityOfService',
        'ReceivingSideID',
        'RedirectingPartyID',
        'RequestedInformationList',
        'RequestedInformationTypeList',
        'RequestedInformation',
        'RequestedInformationType',
        'RequestedInformationValue',
        'RPCause',
        'ScfID',
        'SCIBillingChargingCharacteristics',
        'SCIGPRSBillingChargingCharacteristics',
        'SendingSideID',
        'ServiceInteractionIndicatorsTwo',
        'SGSNCapabilities',
        'SMS-AddressString',
        'maxSMS-AddressStringLength',
        'SMSEvent',
        'TariffSwitchInterval',
        'TimeAndTimezone',
        'TimeIfNoTariffSwitch',
        'TimeIfTariffSwitch',
        'TimeInformation',
        'TimerID',
        'TimerValue',
        'Tone',
        'TPDataCodingScheme',
        'TPProtocolIdentifier',
        'TPShortMessageSpecificInfo',
        'TPValidityPeriod',
        'TransferredVolume',
        'TransferredVolumeRollOver',
        'UnavailableNetworkResource',
        'VariablePart',
        'numOfInfoItems',
        ]
    _type_ = [
        'AccessPointName',
        'AChBillingChargingCharacteristics',
        'AChChargingAddress',
        'AdditionalCallingPartyNumber',
        'AlertingPattern',
        'AOCBeforeAnswer',
        'AOCGPRS',
        'AOCSubsequent',
        'AppendFreeFormatData',
        'ApplicationTimer',
        'AssistingSSPIPRoutingAddress',
        'AudibleIndicator',
        'BackwardServiceInteractionInd',
        'BasicGapCriteria',
        'BCSMEvent',
        'BCSM-Failure',
        'BearerCapability',
        'Burst',
        'BurstList',
        'CAI-GSM0224',
        'CalledPartyBCDNumber',
        'CalledPartyNumber',
        'CallingPartyNumber',
        'CallResult',
        'CallSegmentFailure',
        'CallSegmentID',
        'CallSegmentToCancel',
        'CAMEL-AChBillingChargingCharacteristics',
        'CAMEL-CallResult',
        'CAMEL-FCIBillingChargingCharacteristics',
        'CAMEL-FCIGPRSBillingChargingCharacteristics',
        'CAMEL-FCISMSBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristics',
        'CAMEL-SCIBillingChargingCharacteristicsAlt',
        'CAMEL-SCIGPRSBillingChargingCharacteristics',
        'Carrier',
        'Cause',
        'CGEncountered',
        'ChangeOfPositionControlInfo',
        'ChangeOfLocation',
        'ChangeOfLocationAlt',
        'ChargeIndicator',
        'ChargeNumber',
        'ChargingCharacteristics',
        'ChargingResult',
        'ChargingRollOver',
        'CollectedDigits',
        'CollectedInfo',
        'ConnectedNumberTreatmentInd',
        'ControlType',
        'CompoundCriteria',
        'CorrelationID',
        'DateAndTime',
        'DestinationRoutingAddress',
        'Digits',
        'DpSpecificCriteria',
        'DpSpecificCriteriaAlt',
        'DpSpecificInfoAlt',
        'ElapsedTime',
        'ElapsedTimeRollOver',
        'EndUserAddress',
        'ErrorTreatment',
        'EventSpecificInformationBCSM',
        'EventSpecificInformationSMS',
        'EventTypeBCSM',
        'EventTypeSMS',
        'Extensions',
        'ExtensionField',
        'FCIBillingChargingCharacteristics',
        'FCIGPRSBillingChargingCharacteristics',
        'FCISMSBillingChargingCharacteristics',
        'ForwardServiceInteractionInd',
        'GapCriteria',
        'GapIndicators',
        'GapOnService',
        'GapTreatment',
        'GenericNumber',
        'GenericNumbers',
        'GPRS-QoS',
        'GPRS-QoS-Extension',
        'GPRSCause',
        'GPRSEvent',
        'GPRSEventSpecificInformation',
        'GPRSEventType',
        'InbandInfo',
        'InformationToSend',
        'InitiatingEntity',
        'InitiatorOfServiceChange',
        'InvokeID',
        'IPRoutingAddress',
        'IPSSPCapabilities',
        'LegOrCallSegment',
        'LegType',
        'LocationInformationGPRS',
        'LocationNumber',
        'LowLayerCompatibility',
        'MessageID',
        'MetDPCriteriaList',
        'MetDPCriterion',
        'MetDPCriterionAlt',
        'MidCallControlInfo',
        'MonitorMode',
        'MO-SMSCause',
        'MT-SMSCause',
        'NAOliInfo',
        'NatureOfServiceChange',
        'NumberOfDigits',
        'OCSIApplicable',
        'OriginalCalledPartyID',
        'PDPID',
        'PDPInitiationType',
        'QualityOfService',
        'ReceivingSideID',
        'RedirectingPartyID',
        'RequestedInformationList',
        'RequestedInformationTypeList',
        'RequestedInformation',
        'RequestedInformationType',
        'RequestedInformationValue',
        'RPCause',
        'ScfID',
        'SCIBillingChargingCharacteristics',
        'SCIGPRSBillingChargingCharacteristics',
        'SendingSideID',
        'ServiceInteractionIndicatorsTwo',
        'SGSNCapabilities',
        'SMS-AddressString',
        'SMSEvent',
        'TariffSwitchInterval',
        'TimeAndTimezone',
        'TimeIfNoTariffSwitch',
        'TimeIfTariffSwitch',
        'TimeInformation',
        'TimerID',
        'TimerValue',
        'Tone',
        'TPDataCodingScheme',
        'TPProtocolIdentifier',
        'TPShortMessageSpecificInfo',
        'TPValidityPeriod',
        'TransferredVolume',
        'TransferredVolumeRollOver',
        'UnavailableNetworkResource',
        'VariablePart',
        ]
    _set_ = [
        ]
    _val_ = [
        'leg1',
        'leg2',
        'maxSMS-AddressStringLength',
        'numOfInfoItems',
        ]
    _class_ = [
        ]
    _param_ = [
        'AccessPointName',
        'AChBillingChargingCharacteristics',
        'AChChargingAddress',
        'AdditionalCallingPartyNumber',
        'AssistingSSPIPRoutingAddress',
        'BasicGapCriteria',
        'BCSMEvent',
        'BCSM-Failure',
        'BearerCapability',
        'CalledPartyBCDNumber',
        'CalledPartyNumber',
        'CallingPartyNumber',
        'CallResult',
        'CallSegmentFailure',
        'CallSegmentID',
        'CallSegmentToCancel',
        'CAMEL-AChBillingChargingCharacteristics',
        'CAMEL-CallResult',
        'CAMEL-FCIBillingChargingCharacteristics',
        'CAMEL-FCIGPRSBillingChargingCharacteristics',
        'CAMEL-FCISMSBillingChargingCharacteristics',
        'Carrier',
        'Cause',
        'ChangeOfPositionControlInfo',
        'ChangeOfLocation',
        'ChangeOfLocationAlt',
        'ChargeNumber',
        'CompoundCriteria',
        'CorrelationID',
        'DestinationRoutingAddress',
        'Digits',
        'DpSpecificCriteria',
        'DpSpecificCriteriaAlt',
        'DpSpecificInfoAlt',
        'EndUserAddress',
        'EventSpecificInformationBCSM',
        'Extensions',
        'FCIBillingChargingCharacteristics',
        'FCIGPRSBillingChargingCharacteristics',
        'FCISMSBillingChargingCharacteristics',
        'GapCriteria',
        'GapTreatment',
        'GenericNumber',
        'GenericNumbers',
        'GPRSCause',
        'GPRSEventSpecificInformation',
        'InbandInfo',
        'InformationToSend',
        'IPRoutingAddress',
        'IPSSPCapabilities',
        'LegOrCallSegment',
        'LocationNumber',
        'LowLayerCompatibility',
        'MessageID',
        'MetDPCriteriaList',
        'MetDPCriterion',
        'MetDPCriterionAlt',
        'OriginalCalledPartyID',
        'RedirectingPartyID',
        'RequestedInformationList',
        'RequestedInformation',
        'RequestedInformationValue',
        'ScfID',
        'SCIBillingChargingCharacteristics',
        'SCIGPRSBillingChargingCharacteristics',
        'TimeAndTimezone',
        'VariablePart',
        ]
    
    #-----< AccessPointName >-----#
    AccessPointName = OCT_STR(name='AccessPointName', mode=MODE_TYPE, param=True)
    
    #-----< AChBillingChargingCharacteristics >-----#
    AChBillingChargingCharacteristics = OCT_STR(name='AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< AChChargingAddress >-----#
    AChChargingAddress = CHOICE(name='AChChargingAddress', mode=MODE_TYPE, param=True)
    
    #-----< AdditionalCallingPartyNumber >-----#
    AdditionalCallingPartyNumber = OCT_STR(name='AdditionalCallingPartyNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name='AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< AOCBeforeAnswer >-----#
    AOCBeforeAnswer = SEQ(name='AOCBeforeAnswer', mode=MODE_TYPE)
    _AOCBeforeAnswer_aOCInitial = SEQ(name='aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCBeforeAnswer_aOCSubsequent = SEQ(name='aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCBeforeAnswer._cont = ASN1Dict([
        ('aOCInitial', _AOCBeforeAnswer_aOCInitial),
        ('aOCSubsequent', _AOCBeforeAnswer_aOCSubsequent),
        ])
    AOCBeforeAnswer._ext = None
    
    #-----< AOCGPRS >-----#
    AOCGPRS = SEQ(name='AOCGPRS', mode=MODE_TYPE)
    _AOCGPRS_aOCInitial = SEQ(name='aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCGPRS_aOCSubsequent = SEQ(name='aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCGPRS._cont = ASN1Dict([
        ('aOCInitial', _AOCGPRS_aOCInitial),
        ('aOCSubsequent', _AOCGPRS_aOCSubsequent),
        ])
    AOCGPRS._ext = None
    
    #-----< AOCSubsequent >-----#
    AOCSubsequent = SEQ(name='AOCSubsequent', mode=MODE_TYPE)
    _AOCSubsequent_cAI_GSM0224 = SEQ(name='cAI-GSM0224', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCSubsequent_tariffSwitchInterval = INT(name='tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AOCSubsequent_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    AOCSubsequent._cont = ASN1Dict([
        ('cAI-GSM0224', _AOCSubsequent_cAI_GSM0224),
        ('tariffSwitchInterval', _AOCSubsequent_tariffSwitchInterval),
        ])
    AOCSubsequent._ext = None
    
    #-----< AppendFreeFormatData >-----#
    AppendFreeFormatData = ENUM(name='AppendFreeFormatData', mode=MODE_TYPE)
    AppendFreeFormatData._cont = ASN1Dict([('overwrite', 0), ('append', 1)])
    AppendFreeFormatData._ext = None
    
    #-----< ApplicationTimer >-----#
    ApplicationTimer = INT(name='ApplicationTimer', mode=MODE_TYPE)
    ApplicationTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    
    #-----< AssistingSSPIPRoutingAddress >-----#
    AssistingSSPIPRoutingAddress = OCT_STR(name='AssistingSSPIPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AudibleIndicator >-----#
    AudibleIndicator = CHOICE(name='AudibleIndicator', mode=MODE_TYPE)
    _AudibleIndicator_tone = BOOL(name='tone', mode=MODE_TYPE)
    _AudibleIndicator_burstList = SEQ(name='burstList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BurstList')))
    AudibleIndicator._cont = ASN1Dict([
        ('tone', _AudibleIndicator_tone),
        ('burstList', _AudibleIndicator_burstList),
        ])
    AudibleIndicator._ext = None
    
    #-----< BackwardServiceInteractionInd >-----#
    BackwardServiceInteractionInd = SEQ(name='BackwardServiceInteractionInd', mode=MODE_TYPE)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name='conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator = OCT_STR(name='callCompletionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    BackwardServiceInteractionInd._cont = ASN1Dict([
        ('conferenceTreatmentIndicator', _BackwardServiceInteractionInd_conferenceTreatmentIndicator),
        ('callCompletionTreatmentIndicator', _BackwardServiceInteractionInd_callCompletionTreatmentIndicator),
        ])
    BackwardServiceInteractionInd._ext = []
    
    #-----< BasicGapCriteria >-----#
    BasicGapCriteria = CHOICE(name='BasicGapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< BCSMEvent >-----#
    BCSMEvent = SEQ(name='BCSMEvent', mode=MODE_TYPE, param=True)
    
    #-----< BCSM-Failure >-----#
    BCSM_Failure = SEQ(name='BCSM-Failure', mode=MODE_TYPE, param=True)
    
    #-----< BearerCapability >-----#
    BearerCapability = CHOICE(name='BearerCapability', mode=MODE_TYPE, param=True)
    
    #-----< Burst >-----#
    Burst = SEQ(name='Burst', mode=MODE_TYPE)
    _Burst_numberOfBursts = INT(name='numberOfBursts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _Burst_numberOfBursts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_burstInterval = INT(name='burstInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_burstInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _Burst_numberOfTonesInBurst = INT(name='numberOfTonesInBurst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=3)
    _Burst_numberOfTonesInBurst._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_toneDuration = INT(name='toneDuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _Burst_toneInterval = INT(name='toneInterval', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    Burst._cont = ASN1Dict([
        ('numberOfBursts', _Burst_numberOfBursts),
        ('burstInterval', _Burst_burstInterval),
        ('numberOfTonesInBurst', _Burst_numberOfTonesInBurst),
        ('toneDuration', _Burst_toneDuration),
        ('toneInterval', _Burst_toneInterval),
        ])
    Burst._ext = []
    
    #-----< BurstList >-----#
    BurstList = SEQ(name='BurstList', mode=MODE_TYPE)
    _BurstList_warningPeriod = INT(name='warningPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _BurstList_warningPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _BurstList_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    BurstList._cont = ASN1Dict([
        ('warningPeriod', _BurstList_warningPeriod),
        ('bursts', _BurstList_bursts),
        ])
    BurstList._ext = []
    
    #-----< CAI-GSM0224 >-----#
    CAI_GSM0224 = SEQ(name='CAI-GSM0224', mode=MODE_TYPE)
    _CAI_GSM0224_e1 = INT(name='e1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e2 = INT(name='e2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e3 = INT(name='e3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e4 = INT(name='e4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e5 = INT(name='e5', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e6 = INT(name='e6', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e6._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e7 = INT(name='e7', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e7._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    CAI_GSM0224._cont = ASN1Dict([
        ('e1', _CAI_GSM0224_e1),
        ('e2', _CAI_GSM0224_e2),
        ('e3', _CAI_GSM0224_e3),
        ('e4', _CAI_GSM0224_e4),
        ('e5', _CAI_GSM0224_e5),
        ('e6', _CAI_GSM0224_e6),
        ('e7', _CAI_GSM0224_e7),
        ])
    CAI_GSM0224._ext = None
    
    #-----< CalledPartyBCDNumber >-----#
    CalledPartyBCDNumber = OCT_STR(name='CalledPartyBCDNumber', mode=MODE_TYPE, param=True)
    
    #-----< CalledPartyNumber >-----#
    CalledPartyNumber = OCT_STR(name='CalledPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallingPartyNumber >-----#
    CallingPartyNumber = OCT_STR(name='CallingPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallResult >-----#
    CallResult = OCT_STR(name='CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentFailure >-----#
    CallSegmentFailure = SEQ(name='CallSegmentFailure', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentID >-----#
    CallSegmentID = INT(name='CallSegmentID', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentToCancel >-----#
    CallSegmentToCancel = SEQ(name='CallSegmentToCancel', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-AChBillingChargingCharacteristics >-----#
    CAMEL_AChBillingChargingCharacteristics = CHOICE(name='CAMEL-AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-CallResult >-----#
    CAMEL_CallResult = CHOICE(name='CAMEL-CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIBillingChargingCharacteristics >-----#
    CAMEL_FCIBillingChargingCharacteristics = CHOICE(name='CAMEL-FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_FCIGPRSBillingChargingCharacteristics = SEQ(name='CAMEL-FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCISMSBillingChargingCharacteristics >-----#
    CAMEL_FCISMSBillingChargingCharacteristics = CHOICE(name='CAMEL-FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-SCIBillingChargingCharacteristics >-----#
    CAMEL_SCIBillingChargingCharacteristics = CHOICE(name='CAMEL-SCIBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer = SEQ(name='aOCBeforeAnswer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCBeforeAnswer')))
    _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer = SEQ(name='aOCAfterAnswer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')))
    _CAMEL_SCIBillingChargingCharacteristics_aOC_extension = SEQ(name='aOC-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAMEL-SCIBillingChargingCharacteristicsAlt')))
    CAMEL_SCIBillingChargingCharacteristics._cont = ASN1Dict([
        ('aOCBeforeAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer),
        ('aOCAfterAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer),
        ('aOC-extension', _CAMEL_SCIBillingChargingCharacteristics_aOC_extension),
        ])
    CAMEL_SCIBillingChargingCharacteristics._ext = None
    
    #-----< CAMEL-SCIBillingChargingCharacteristicsAlt >-----#
    CAMEL_SCIBillingChargingCharacteristicsAlt = SEQ(name='CAMEL-SCIBillingChargingCharacteristicsAlt', mode=MODE_TYPE)
    CAMEL_SCIBillingChargingCharacteristicsAlt._cont = ASN1Dict([
        ])
    CAMEL_SCIBillingChargingCharacteristicsAlt._ext = []
    
    #-----< CAMEL-SCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_SCIGPRSBillingChargingCharacteristics = SEQ(name='CAMEL-SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS = SEQ(name='aOCGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCGPRS')))
    _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CAMEL_SCIGPRSBillingChargingCharacteristics._cont = ASN1Dict([
        ('aOCGPRS', _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS),
        ('pDPID', _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID),
        ])
    CAMEL_SCIGPRSBillingChargingCharacteristics._ext = []
    
    #-----< Carrier >-----#
    Carrier = OCT_STR(name='Carrier', mode=MODE_TYPE, param=True)
    
    #-----< Cause >-----#
    Cause = OCT_STR(name='Cause', mode=MODE_TYPE, param=True)
    
    #-----< CGEncountered >-----#
    CGEncountered = ENUM(name='CGEncountered', mode=MODE_TYPE)
    CGEncountered._cont = ASN1Dict([('noCGencountered', 0), ('manualCGencountered', 1), ('scpOverload', 2)])
    CGEncountered._ext = None
    
    #-----< ChangeOfPositionControlInfo >-----#
    ChangeOfPositionControlInfo = SEQ_OF(name='ChangeOfPositionControlInfo', mode=MODE_TYPE, param=True)
    
    #-----< ChangeOfLocation >-----#
    ChangeOfLocation = CHOICE(name='ChangeOfLocation', mode=MODE_TYPE)
    _ChangeOfLocation_cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _ChangeOfLocation_inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _ChangeOfLocation_changeOfLocationAlt._cont = ASN1Dict([
        ])
    _ChangeOfLocation_changeOfLocationAlt._ext = []
    ChangeOfLocation._cont = ASN1Dict([
        ('cellGlobalId', _ChangeOfLocation_cellGlobalId),
        ('serviceAreaId', _ChangeOfLocation_serviceAreaId),
        ('locationAreaId', _ChangeOfLocation_locationAreaId),
        ('inter-SystemHandOver', _ChangeOfLocation_inter_SystemHandOver),
        ('inter-PLMNHandOver', _ChangeOfLocation_inter_PLMNHandOver),
        ('inter-MSCHandOver', _ChangeOfLocation_inter_MSCHandOver),
        ('changeOfLocationAlt', _ChangeOfLocation_changeOfLocationAlt),
        ])
    ChangeOfLocation._ext = None
    
    #-----< ChangeOfLocationAlt >-----#
    ChangeOfLocationAlt = SEQ(name='ChangeOfLocationAlt', mode=MODE_TYPE)
    ChangeOfLocationAlt._cont = ASN1Dict([
        ])
    ChangeOfLocationAlt._ext = []
    
    #-----< ChargeIndicator >-----#
    ChargeIndicator = OCT_STR(name='ChargeIndicator', mode=MODE_TYPE)
    ChargeIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargeNumber >-----#
    ChargeNumber = OCT_STR(name='ChargeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), param=True)
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = CHOICE(name='ChargingCharacteristics', mode=MODE_TYPE)
    _ChargingCharacteristics_maxTransferredVolume = INT(name='maxTransferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxTransferredVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _ChargingCharacteristics_maxElapsedTime = INT(name='maxElapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxElapsedTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    ChargingCharacteristics._cont = ASN1Dict([
        ('maxTransferredVolume', _ChargingCharacteristics_maxTransferredVolume),
        ('maxElapsedTime', _ChargingCharacteristics_maxElapsedTime),
        ])
    ChargingCharacteristics._ext = None
    
    #-----< ChargingResult >-----#
    ChargingResult = CHOICE(name='ChargingResult', mode=MODE_TYPE)
    _ChargingResult_transferredVolume = CHOICE(name='transferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolume')))
    _ChargingResult_elapsedTime = CHOICE(name='elapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTime')))
    ChargingResult._cont = ASN1Dict([
        ('transferredVolume', _ChargingResult_transferredVolume),
        ('elapsedTime', _ChargingResult_elapsedTime),
        ])
    ChargingResult._ext = None
    
    #-----< ChargingRollOver >-----#
    ChargingRollOver = CHOICE(name='ChargingRollOver', mode=MODE_TYPE)
    _ChargingRollOver_transferredVolumeRollOver = CHOICE(name='transferredVolumeRollOver', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolumeRollOver')))
    _ChargingRollOver_elapsedTimeRollOver = CHOICE(name='elapsedTimeRollOver', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTimeRollOver')))
    ChargingRollOver._cont = ASN1Dict([
        ('transferredVolumeRollOver', _ChargingRollOver_transferredVolumeRollOver),
        ('elapsedTimeRollOver', _ChargingRollOver_elapsedTimeRollOver),
        ])
    ChargingRollOver._ext = None
    
    #-----< CollectedDigits >-----#
    CollectedDigits = SEQ(name='CollectedDigits', mode=MODE_TYPE)
    _CollectedDigits_minimumNbOfDigits = INT(name='minimumNbOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _CollectedDigits_minimumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_maximumNbOfDigits = INT(name='maximumNbOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CollectedDigits_maximumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_endOfReplyDigit = OCT_STR(name='endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_cancelDigit = OCT_STR(name='cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_startDigit = OCT_STR(name='startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_firstDigitTimeOut = INT(name='firstDigitTimeOut', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_firstDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_interDigitTimeOut = INT(name='interDigitTimeOut', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_interDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_errorTreatment = ENUM(name='errorTreatment', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ErrorTreatment')), default='stdErrorAndInfo')
    _CollectedDigits_interruptableAnnInd = BOOL(name='interruptableAnnInd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _CollectedDigits_voiceInformation = BOOL(name='voiceInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _CollectedDigits_voiceBack = BOOL(name='voiceBack', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    CollectedDigits._cont = ASN1Dict([
        ('minimumNbOfDigits', _CollectedDigits_minimumNbOfDigits),
        ('maximumNbOfDigits', _CollectedDigits_maximumNbOfDigits),
        ('endOfReplyDigit', _CollectedDigits_endOfReplyDigit),
        ('cancelDigit', _CollectedDigits_cancelDigit),
        ('startDigit', _CollectedDigits_startDigit),
        ('firstDigitTimeOut', _CollectedDigits_firstDigitTimeOut),
        ('interDigitTimeOut', _CollectedDigits_interDigitTimeOut),
        ('errorTreatment', _CollectedDigits_errorTreatment),
        ('interruptableAnnInd', _CollectedDigits_interruptableAnnInd),
        ('voiceInformation', _CollectedDigits_voiceInformation),
        ('voiceBack', _CollectedDigits_voiceBack),
        ])
    CollectedDigits._ext = None
    
    #-----< CollectedInfo >-----#
    CollectedInfo = CHOICE(name='CollectedInfo', mode=MODE_TYPE)
    _CollectedInfo_collectedDigits = SEQ(name='collectedDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedDigits')))
    CollectedInfo._cont = ASN1Dict([
        ('collectedDigits', _CollectedInfo_collectedDigits),
        ])
    CollectedInfo._ext = None
    
    #-----< ConnectedNumberTreatmentInd >-----#
    ConnectedNumberTreatmentInd = ENUM(name='ConnectedNumberTreatmentInd', mode=MODE_TYPE)
    ConnectedNumberTreatmentInd._cont = ASN1Dict([('noINImpact', 0), ('presentationRestricted', 1), ('presentCalledINNumber', 2), ('presentCallINNumberRestricted', 3)])
    ConnectedNumberTreatmentInd._ext = None
    
    #-----< ControlType >-----#
    ControlType = ENUM(name='ControlType', mode=MODE_TYPE)
    ControlType._cont = ASN1Dict([('sCPOverloaded', 0), ('manuallyInitiated', 1)])
    ControlType._ext = None
    
    #-----< CompoundCriteria >-----#
    CompoundCriteria = SEQ(name='CompoundCriteria', mode=MODE_TYPE, param=True)
    
    #-----< CorrelationID >-----#
    CorrelationID = OCT_STR(name='CorrelationID', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< DateAndTime >-----#
    DateAndTime = OCT_STR(name='DateAndTime', mode=MODE_TYPE)
    DateAndTime._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< DestinationRoutingAddress >-----#
    DestinationRoutingAddress = SEQ_OF(name='DestinationRoutingAddress', mode=MODE_TYPE, param=True)
    
    #-----< Digits >-----#
    Digits = OCT_STR(name='Digits', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteria >-----#
    DpSpecificCriteria = CHOICE(name='DpSpecificCriteria', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteriaAlt >-----#
    DpSpecificCriteriaAlt = SEQ(name='DpSpecificCriteriaAlt', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificInfoAlt >-----#
    DpSpecificInfoAlt = SEQ(name='DpSpecificInfoAlt', mode=MODE_TYPE, param=True)
    
    #-----< ElapsedTime >-----#
    ElapsedTime = CHOICE(name='ElapsedTime', mode=MODE_TYPE)
    _ElapsedTime_timeGPRSIfNoTariffSwitch = INT(name='timeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTime_timeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch = SEQ(name='timeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch = INT(name='timeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval = INT(name='timeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch._cont = ASN1Dict([
        ('timeGPRSSinceLastTariffSwitch', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch),
        ('timeGPRSTariffSwitchInterval', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval),
        ])
    _ElapsedTime_timeGPRSIfTariffSwitch._ext = None
    ElapsedTime._cont = ASN1Dict([
        ('timeGPRSIfNoTariffSwitch', _ElapsedTime_timeGPRSIfNoTariffSwitch),
        ('timeGPRSIfTariffSwitch', _ElapsedTime_timeGPRSIfTariffSwitch),
        ])
    ElapsedTime._ext = None
    
    #-----< ElapsedTimeRollOver >-----#
    ElapsedTimeRollOver = CHOICE(name='ElapsedTimeRollOver', mode=MODE_TYPE)
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch = INT(name='rO-TimeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch = SEQ(name='rO-TimeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch = INT(name='rO-TimeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval = INT(name='rO-TimeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._cont = ASN1Dict([
        ('rO-TimeGPRSSinceLastTariffSwitch', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch),
        ('rO-TimeGPRSTariffSwitchInterval', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval),
        ])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._ext = None
    ElapsedTimeRollOver._cont = ASN1Dict([
        ('rO-TimeGPRSIfNoTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch),
        ('rO-TimeGPRSIfTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch),
        ])
    ElapsedTimeRollOver._ext = None
    
    #-----< EndUserAddress >-----#
    EndUserAddress = SEQ(name='EndUserAddress', mode=MODE_TYPE, param=True)
    
    #-----< ErrorTreatment >-----#
    ErrorTreatment = ENUM(name='ErrorTreatment', mode=MODE_TYPE)
    ErrorTreatment._cont = ASN1Dict([('stdErrorAndInfo', 0), ('help', 1), ('repeatPrompt', 2)])
    ErrorTreatment._ext = None
    
    #-----< EventSpecificInformationBCSM >-----#
    EventSpecificInformationBCSM = CHOICE(name='EventSpecificInformationBCSM', mode=MODE_TYPE, param=True)
    
    #-----< EventSpecificInformationSMS >-----#
    EventSpecificInformationSMS = CHOICE(name='EventSpecificInformationSMS', mode=MODE_TYPE)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo = SEQ(name='o-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause = ENUM(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MO-SMSCause')), opt=True)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo = SEQ(name='o-smsSubmissionSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo = SEQ(name='t-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MT-SMSCause')), opt=True)
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo = SEQ(name='t-smsDeliverySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._ext = []
    EventSpecificInformationSMS._cont = ASN1Dict([
        ('o-smsFailureSpecificInfo', _EventSpecificInformationSMS_o_smsFailureSpecificInfo),
        ('o-smsSubmissionSpecificInfo', _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo),
        ('t-smsFailureSpecificInfo', _EventSpecificInformationSMS_t_smsFailureSpecificInfo),
        ('t-smsDeliverySpecificInfo', _EventSpecificInformationSMS_t_smsDeliverySpecificInfo),
        ])
    EventSpecificInformationSMS._ext = None
    
    #-----< EventTypeBCSM >-----#
    EventTypeBCSM = ENUM(name='EventTypeBCSM', mode=MODE_TYPE)
    EventTypeBCSM._cont = ASN1Dict([('collectedInfo', 2), ('analyzedInformation', 3), ('routeSelectFailure', 4), ('oCalledPartyBusy', 5), ('oNoAnswer', 6), ('oAnswer', 7), ('oMidCall', 8), ('oDisconnect', 9), ('oAbandon', 10), ('termAttemptAuthorized', 12), ('tBusy', 13), ('tNoAnswer', 14), ('tAnswer', 15), ('tMidCall', 16), ('tDisconnect', 17), ('tAbandon', 18), ('oTermSeized', 19), ('callAccepted', 27), ('oChangeOfPosition', 50), ('tChangeOfPosition', 51), ('oServiceChange', 52), ('tServiceChange', 53)])
    EventTypeBCSM._ext = ['oServiceChange', 'tServiceChange']
    
    #-----< EventTypeSMS >-----#
    EventTypeSMS = ENUM(name='EventTypeSMS', mode=MODE_TYPE)
    EventTypeSMS._cont = ASN1Dict([('sms-CollectedInfo', 1), ('o-smsFailure', 2), ('o-smsSubmission', 3), ('sms-DeliveryRequested', 11), ('t-smsFailure', 12), ('t-smsDelivery', 13)])
    EventTypeSMS._ext = None
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name='Extensions', mode=MODE_TYPE, param=True)
    
    #-----< ExtensionField >-----#
    ExtensionField = SEQ(name='ExtensionField', mode=MODE_TYPE)
    _ExtensionField_type = CHOICE(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), ['id']))
    __ExtensionField_type_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    ___ExtensionField_type_tab_val_ExtensionType_0 = NULL(name='ExtensionType', mode=MODE_TYPE)
    __ExtensionField_type_tab._val = ASN1Set(rv=[dict([('ExtensionType', ___ExtensionField_type_tab_val_ExtensionType_0), ('criticality', 'ignore'), ('id', ('global', (0, 4, 0, 1, 2)))])], rr=[], ev=None, er=[])
    _ExtensionField_type._const_tab = __ExtensionField_type_tab
    _ExtensionField_type._const_tab_at = None
    _ExtensionField_type._const_tab_id = 'id'
    _ExtensionField_criticality = ENUM(name='criticality', mode=MODE_TYPE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default='ignore')
    _ExtensionField_value = OPEN(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), ['ExtensionType']))
    _ExtensionField_value._const_tab = __ExtensionField_type_tab
    _ExtensionField_value._const_tab_at = ('..', 'type')
    _ExtensionField_value._const_tab_id = 'ExtensionType'
    ExtensionField._cont = ASN1Dict([
        ('type', _ExtensionField_type),
        ('criticality', _ExtensionField_criticality),
        ('value', _ExtensionField_value),
        ])
    ExtensionField._ext = []
    
    #-----< FCIBillingChargingCharacteristics >-----#
    FCIBillingChargingCharacteristics = OCT_STR(name='FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCIGPRSBillingChargingCharacteristics >-----#
    FCIGPRSBillingChargingCharacteristics = OCT_STR(name='FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCISMSBillingChargingCharacteristics >-----#
    FCISMSBillingChargingCharacteristics = OCT_STR(name='FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< ForwardServiceInteractionInd >-----#
    ForwardServiceInteractionInd = SEQ(name='ForwardServiceInteractionInd', mode=MODE_TYPE)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name='conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator = OCT_STR(name='callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator = OCT_STR(name='callingPartyRestrictionIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ForwardServiceInteractionInd._cont = ASN1Dict([
        ('conferenceTreatmentIndicator', _ForwardServiceInteractionInd_conferenceTreatmentIndicator),
        ('callDiversionTreatmentIndicator', _ForwardServiceInteractionInd_callDiversionTreatmentIndicator),
        ('callingPartyRestrictionIndicator', _ForwardServiceInteractionInd_callingPartyRestrictionIndicator),
        ])
    ForwardServiceInteractionInd._ext = []
    
    #-----< GapCriteria >-----#
    GapCriteria = CHOICE(name='GapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< GapIndicators >-----#
    GapIndicators = SEQ(name='GapIndicators', mode=MODE_TYPE)
    _GapIndicators_duration = INT(name='duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Duration')))
    _GapIndicators_gapInterval = INT(name='gapInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Interval')))
    GapIndicators._cont = ASN1Dict([
        ('duration', _GapIndicators_duration),
        ('gapInterval', _GapIndicators_gapInterval),
        ])
    GapIndicators._ext = []
    
    #-----< GapOnService >-----#
    GapOnService = SEQ(name='GapOnService', mode=MODE_TYPE)
    _GapOnService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    GapOnService._cont = ASN1Dict([
        ('serviceKey', _GapOnService_serviceKey),
        ])
    GapOnService._ext = []
    
    #-----< GapTreatment >-----#
    GapTreatment = CHOICE(name='GapTreatment', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumber >-----#
    GenericNumber = OCT_STR(name='GenericNumber', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumbers >-----#
    GenericNumbers = SET_OF(name='GenericNumbers', mode=MODE_TYPE, param=True)
    
    #-----< GPRS-QoS >-----#
    GPRS_QoS = CHOICE(name='GPRS-QoS', mode=MODE_TYPE)
    _GPRS_QoS_short_QoS_format = OCT_STR(name='short-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _GPRS_QoS_long_QoS_format = OCT_STR(name='long-QoS-format', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')))
    GPRS_QoS._cont = ASN1Dict([
        ('short-QoS-format', _GPRS_QoS_short_QoS_format),
        ('long-QoS-format', _GPRS_QoS_long_QoS_format),
        ])
    GPRS_QoS._ext = None
    
    #-----< GPRS-QoS-Extension >-----#
    GPRS_QoS_Extension = SEQ(name='GPRS-QoS-Extension', mode=MODE_TYPE)
    _GPRS_QoS_Extension_supplement_to_long_QoS_format = OCT_STR(name='supplement-to-long-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')))
    _GPRS_QoS_Extension_additionalSupplement = OCT_STR(name='additionalSupplement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    GPRS_QoS_Extension._cont = ASN1Dict([
        ('supplement-to-long-QoS-format', _GPRS_QoS_Extension_supplement_to_long_QoS_format),
        ('additionalSupplement', _GPRS_QoS_Extension_additionalSupplement),
        ])
    GPRS_QoS_Extension._ext = ['additionalSupplement']
    
    #-----< GPRSCause >-----#
    GPRSCause = OCT_STR(name='GPRSCause', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEvent >-----#
    GPRSEvent = SEQ(name='GPRSEvent', mode=MODE_TYPE)
    _GPRSEvent_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _GPRSEvent_monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    GPRSEvent._cont = ASN1Dict([
        ('gPRSEventType', _GPRSEvent_gPRSEventType),
        ('monitorMode', _GPRSEvent_monitorMode),
        ])
    GPRSEvent._ext = None
    
    #-----< GPRSEventSpecificInformation >-----#
    GPRSEventSpecificInformation = CHOICE(name='GPRSEventSpecificInformation', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEventType >-----#
    GPRSEventType = ENUM(name='GPRSEventType', mode=MODE_TYPE)
    GPRSEventType._cont = ASN1Dict([('attach', 1), ('attachChangeOfPosition', 2), ('detached', 3), ('pdp-ContextEstablishment', 11), ('pdp-ContextEstablishmentAcknowledgement', 12), ('disonnect', 13), ('pdp-ContextChangeOfPosition', 14)])
    GPRSEventType._ext = None
    
    #-----< InbandInfo >-----#
    InbandInfo = SEQ(name='InbandInfo', mode=MODE_TYPE, param=True)
    
    #-----< InformationToSend >-----#
    InformationToSend = CHOICE(name='InformationToSend', mode=MODE_TYPE, param=True)
    
    #-----< InitiatingEntity >-----#
    InitiatingEntity = ENUM(name='InitiatingEntity', mode=MODE_TYPE)
    InitiatingEntity._cont = ASN1Dict([('mobileStation', 0), ('sgsn', 1), ('hlr', 2), ('ggsn', 3)])
    InitiatingEntity._ext = None
    
    #-----< InitiatorOfServiceChange >-----#
    InitiatorOfServiceChange = ENUM(name='InitiatorOfServiceChange', mode=MODE_TYPE)
    InitiatorOfServiceChange._cont = ASN1Dict([('a-side', 0), ('b-side', 1)])
    InitiatorOfServiceChange._ext = None
    
    #-----< InvokeID >-----#
    InvokeID = INT(name='InvokeID', mode=MODE_TYPE)
    InvokeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    
    #-----< IPRoutingAddress >-----#
    IPRoutingAddress = OCT_STR(name='IPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), param=True)
    
    #-----< IPSSPCapabilities >-----#
    IPSSPCapabilities = OCT_STR(name='IPSSPCapabilities', mode=MODE_TYPE, param=True)
    
    #-----< LegOrCallSegment >-----#
    LegOrCallSegment = CHOICE(name='LegOrCallSegment', mode=MODE_TYPE, param=True)
    
    #-----< LegType >-----#
    LegType = OCT_STR(name='LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< leg1 >-----#
    leg1 = OCT_STR(name='leg1', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg1._val = b'\x01'
    
    #-----< leg2 >-----#
    leg2 = OCT_STR(name='leg2', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg2._val = b'\x02'
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name='LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = OCT_STR(name='cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name='selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        ('cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        ('routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        ('geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        ('sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        ('selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        ('extensionContainer', _LocationInformationGPRS_extensionContainer),
        ('sai-Present', _LocationInformationGPRS_sai_Present),
        ('userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = ['sai-Present', 'userCSGInformation']
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name='LocationNumber', mode=MODE_TYPE, param=True)
    
    #-----< LowLayerCompatibility >-----#
    LowLayerCompatibility = OCT_STR(name='LowLayerCompatibility', mode=MODE_TYPE, param=True)
    
    #-----< MessageID >-----#
    MessageID = CHOICE(name='MessageID', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriteriaList >-----#
    MetDPCriteriaList = SEQ_OF(name='MetDPCriteriaList', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriterion >-----#
    MetDPCriterion = CHOICE(name='MetDPCriterion', mode=MODE_TYPE)
    _MetDPCriterion_enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _MetDPCriterion_metDPCriterionAlt._cont = ASN1Dict([
        ])
    _MetDPCriterion_metDPCriterionAlt._ext = []
    MetDPCriterion._cont = ASN1Dict([
        ('enteringCellGlobalId', _MetDPCriterion_enteringCellGlobalId),
        ('leavingCellGlobalId', _MetDPCriterion_leavingCellGlobalId),
        ('enteringServiceAreaId', _MetDPCriterion_enteringServiceAreaId),
        ('leavingServiceAreaId', _MetDPCriterion_leavingServiceAreaId),
        ('enteringLocationAreaId', _MetDPCriterion_enteringLocationAreaId),
        ('leavingLocationAreaId', _MetDPCriterion_leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _MetDPCriterion_inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _MetDPCriterion_inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _MetDPCriterion_inter_PLMNHandOver),
        ('inter-MSCHandOver', _MetDPCriterion_inter_MSCHandOver),
        ('metDPCriterionAlt', _MetDPCriterion_metDPCriterionAlt),
        ])
    MetDPCriterion._ext = None
    
    #-----< MetDPCriterionAlt >-----#
    MetDPCriterionAlt = SEQ(name='MetDPCriterionAlt', mode=MODE_TYPE)
    MetDPCriterionAlt._cont = ASN1Dict([
        ])
    MetDPCriterionAlt._ext = []
    
    #-----< MidCallControlInfo >-----#
    MidCallControlInfo = SEQ(name='MidCallControlInfo', mode=MODE_TYPE)
    _MidCallControlInfo_minimumNumberOfDigits = INT(name='minimumNumberOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _MidCallControlInfo_minimumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_maximumNumberOfDigits = INT(name='maximumNumberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _MidCallControlInfo_maximumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_endOfReplyDigit = OCT_STR(name='endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_cancelDigit = OCT_STR(name='cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_startDigit = OCT_STR(name='startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=10)
    _MidCallControlInfo_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    MidCallControlInfo._cont = ASN1Dict([
        ('minimumNumberOfDigits', _MidCallControlInfo_minimumNumberOfDigits),
        ('maximumNumberOfDigits', _MidCallControlInfo_maximumNumberOfDigits),
        ('endOfReplyDigit', _MidCallControlInfo_endOfReplyDigit),
        ('cancelDigit', _MidCallControlInfo_cancelDigit),
        ('startDigit', _MidCallControlInfo_startDigit),
        ('interDigitTimeout', _MidCallControlInfo_interDigitTimeout),
        ])
    MidCallControlInfo._ext = []
    
    #-----< MonitorMode >-----#
    MonitorMode = ENUM(name='MonitorMode', mode=MODE_TYPE)
    MonitorMode._cont = ASN1Dict([('interrupted', 0), ('notifyAndContinue', 1), ('transparent', 2)])
    MonitorMode._ext = None
    
    #-----< MO-SMSCause >-----#
    MO_SMSCause = ENUM(name='MO-SMSCause', mode=MODE_TYPE)
    MO_SMSCause._cont = ASN1Dict([('systemFailure', 0), ('unexpectedDataValue', 1), ('facilityNotSupported', 2), ('sM-DeliveryFailure', 3), ('releaseFromRadioInterface', 4)])
    MO_SMSCause._ext = None
    
    #-----< MT-SMSCause >-----#
    MT_SMSCause = OCT_STR(name='MT-SMSCause', mode=MODE_TYPE)
    MT_SMSCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NAOliInfo >-----#
    NAOliInfo = OCT_STR(name='NAOliInfo', mode=MODE_TYPE)
    NAOliInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NatureOfServiceChange >-----#
    NatureOfServiceChange = ENUM(name='NatureOfServiceChange', mode=MODE_TYPE)
    NatureOfServiceChange._cont = ASN1Dict([('userInitiated', 0), ('networkInitiated', 1)])
    NatureOfServiceChange._ext = None
    
    #-----< NumberOfDigits >-----#
    NumberOfDigits = INT(name='NumberOfDigits', mode=MODE_TYPE)
    NumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< OCSIApplicable >-----#
    OCSIApplicable = NULL(name='OCSIApplicable', mode=MODE_TYPE)
    
    #-----< OriginalCalledPartyID >-----#
    OriginalCalledPartyID = OCT_STR(name='OriginalCalledPartyID', mode=MODE_TYPE, param=True)
    
    #-----< PDPID >-----#
    PDPID = OCT_STR(name='PDPID', mode=MODE_TYPE)
    PDPID._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PDPInitiationType >-----#
    PDPInitiationType = ENUM(name='PDPInitiationType', mode=MODE_TYPE)
    PDPInitiationType._cont = ASN1Dict([('mSInitiated', 0), ('networkInitiated', 1)])
    PDPInitiationType._ext = None
    
    #-----< QualityOfService >-----#
    QualityOfService = SEQ(name='QualityOfService', mode=MODE_TYPE)
    _QualityOfService_requested_QoS = CHOICE(name='requested-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_subscribed_QoS = CHOICE(name='subscribed-QoS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_negotiated_QoS = CHOICE(name='negotiated-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_requested_QoS_Extension = SEQ(name='requested-QoS-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_subscribed_QoS_Extension = SEQ(name='subscribed-QoS-Extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_negotiated_QoS_Extension = SEQ(name='negotiated-QoS-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    QualityOfService._cont = ASN1Dict([
        ('requested-QoS', _QualityOfService_requested_QoS),
        ('subscribed-QoS', _QualityOfService_subscribed_QoS),
        ('negotiated-QoS', _QualityOfService_negotiated_QoS),
        ('requested-QoS-Extension', _QualityOfService_requested_QoS_Extension),
        ('subscribed-QoS-Extension', _QualityOfService_subscribed_QoS_Extension),
        ('negotiated-QoS-Extension', _QualityOfService_negotiated_QoS_Extension),
        ])
    QualityOfService._ext = ['requested-QoS-Extension', 'subscribed-QoS-Extension', 'negotiated-QoS-Extension']
    
    #-----< ReceivingSideID >-----#
    ReceivingSideID = CHOICE(name='ReceivingSideID', mode=MODE_TYPE)
    _ReceivingSideID_receivingSideID = OCT_STR(name='receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    ReceivingSideID._cont = ASN1Dict([
        ('receivingSideID', _ReceivingSideID_receivingSideID),
        ])
    ReceivingSideID._ext = None
    
    #-----< RedirectingPartyID >-----#
    RedirectingPartyID = OCT_STR(name='RedirectingPartyID', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationList >-----#
    RequestedInformationList = SEQ_OF(name='RequestedInformationList', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationTypeList >-----#
    RequestedInformationTypeList = SEQ_OF(name='RequestedInformationTypeList', mode=MODE_TYPE)
    _RequestedInformationTypeList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    RequestedInformationTypeList._cont = _RequestedInformationTypeList__item_
    RequestedInformationTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< RequestedInformation >-----#
    RequestedInformation = SEQ(name='RequestedInformation', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationType >-----#
    RequestedInformationType = ENUM(name='RequestedInformationType', mode=MODE_TYPE)
    RequestedInformationType._cont = ASN1Dict([('callAttemptElapsedTime', 0), ('callStopTime', 1), ('callConnectedElapsedTime', 2), ('releaseCause', 30)])
    RequestedInformationType._ext = None
    
    #-----< RequestedInformationValue >-----#
    RequestedInformationValue = CHOICE(name='RequestedInformationValue', mode=MODE_TYPE, param=True)
    
    #-----< RPCause >-----#
    RPCause = OCT_STR(name='RPCause', mode=MODE_TYPE)
    RPCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ScfID >-----#
    ScfID = OCT_STR(name='ScfID', mode=MODE_TYPE, param=True)
    
    #-----< SCIBillingChargingCharacteristics >-----#
    SCIBillingChargingCharacteristics = OCT_STR(name='SCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SCIGPRSBillingChargingCharacteristics >-----#
    SCIGPRSBillingChargingCharacteristics = OCT_STR(name='SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SendingSideID >-----#
    SendingSideID = CHOICE(name='SendingSideID', mode=MODE_TYPE)
    _SendingSideID_sendingSideID = OCT_STR(name='sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    SendingSideID._cont = ASN1Dict([
        ('sendingSideID', _SendingSideID_sendingSideID),
        ])
    SendingSideID._ext = None
    
    #-----< ServiceInteractionIndicatorsTwo >-----#
    ServiceInteractionIndicatorsTwo = SEQ(name='ServiceInteractionIndicatorsTwo', mode=MODE_TYPE)
    _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd = SEQ(name='forwardServiceInteractionInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ForwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd = SEQ(name='backwardServiceInteractionInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BackwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd = ENUM(name='bothwayThroughConnectionInd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'BothwayThroughConnectionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd = ENUM(name='connectedNumberTreatmentInd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ConnectedNumberTreatmentInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_nonCUGCall = NULL(name='nonCUGCall', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator = OCT_STR(name='holdTreatmentIndicator', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator = OCT_STR(name='cwTreatmentIndicator', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator = OCT_STR(name='ectTreatmentIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ServiceInteractionIndicatorsTwo._cont = ASN1Dict([
        ('forwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd),
        ('backwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd),
        ('bothwayThroughConnectionInd', _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd),
        ('connectedNumberTreatmentInd', _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd),
        ('nonCUGCall', _ServiceInteractionIndicatorsTwo_nonCUGCall),
        ('holdTreatmentIndicator', _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator),
        ('cwTreatmentIndicator', _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator),
        ('ectTreatmentIndicator', _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator),
        ])
    ServiceInteractionIndicatorsTwo._ext = []
    
    #-----< SGSNCapabilities >-----#
    SGSNCapabilities = OCT_STR(name='SGSNCapabilities', mode=MODE_TYPE)
    SGSNCapabilities._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SMS-AddressString >-----#
    SMS_AddressString = OCT_STR(name='SMS-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SMS_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< maxSMS-AddressStringLength >-----#
    maxSMS_AddressStringLength = INT(name='maxSMS-AddressStringLength', mode=MODE_VALUE)
    maxSMS_AddressStringLength._val = 11
    
    #-----< SMSEvent >-----#
    SMSEvent = SEQ(name='SMSEvent', mode=MODE_TYPE)
    _SMSEvent_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _SMSEvent_monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    SMSEvent._cont = ASN1Dict([
        ('eventTypeSMS', _SMSEvent_eventTypeSMS),
        ('monitorMode', _SMSEvent_monitorMode),
        ])
    SMSEvent._ext = None
    
    #-----< TariffSwitchInterval >-----#
    TariffSwitchInterval = INT(name='TariffSwitchInterval', mode=MODE_TYPE)
    TariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    
    #-----< TimeAndTimezone >-----#
    TimeAndTimezone = OCT_STR(name='TimeAndTimezone', mode=MODE_TYPE, param=True)
    
    #-----< TimeIfNoTariffSwitch >-----#
    TimeIfNoTariffSwitch = INT(name='TimeIfNoTariffSwitch', mode=MODE_TYPE)
    TimeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    
    #-----< TimeIfTariffSwitch >-----#
    TimeIfTariffSwitch = SEQ(name='TimeIfTariffSwitch', mode=MODE_TYPE)
    _TimeIfTariffSwitch_timeSinceTariffSwitch = INT(name='timeSinceTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeIfTariffSwitch_timeSinceTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    _TimeIfTariffSwitch_tariffSwitchInterval = INT(name='tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TimeIfTariffSwitch_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=864000)], ev=None, er=[])
    TimeIfTariffSwitch._cont = ASN1Dict([
        ('timeSinceTariffSwitch', _TimeIfTariffSwitch_timeSinceTariffSwitch),
        ('tariffSwitchInterval', _TimeIfTariffSwitch_tariffSwitchInterval),
        ])
    TimeIfTariffSwitch._ext = None
    
    #-----< TimeInformation >-----#
    TimeInformation = CHOICE(name='TimeInformation', mode=MODE_TYPE)
    _TimeInformation_timeIfNoTariffSwitch = INT(name='timeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfNoTariffSwitch')))
    _TimeInformation_timeIfTariffSwitch = SEQ(name='timeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfTariffSwitch')))
    TimeInformation._cont = ASN1Dict([
        ('timeIfNoTariffSwitch', _TimeInformation_timeIfNoTariffSwitch),
        ('timeIfTariffSwitch', _TimeInformation_timeIfTariffSwitch),
        ])
    TimeInformation._ext = None
    
    #-----< TimerID >-----#
    TimerID = ENUM(name='TimerID', mode=MODE_TYPE)
    TimerID._cont = ASN1Dict([('tssf', 0)])
    TimerID._ext = None
    
    #-----< TimerValue >-----#
    TimerValue = INT(name='TimerValue', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< Tone >-----#
    Tone = SEQ(name='Tone', mode=MODE_TYPE)
    _Tone_toneID = INT(name='toneID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _Tone_duration = INT(name='duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    Tone._cont = ASN1Dict([
        ('toneID', _Tone_toneID),
        ('duration', _Tone_duration),
        ])
    Tone._ext = []
    
    #-----< TPDataCodingScheme >-----#
    TPDataCodingScheme = OCT_STR(name='TPDataCodingScheme', mode=MODE_TYPE)
    TPDataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPProtocolIdentifier >-----#
    TPProtocolIdentifier = OCT_STR(name='TPProtocolIdentifier', mode=MODE_TYPE)
    TPProtocolIdentifier._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPShortMessageSpecificInfo >-----#
    TPShortMessageSpecificInfo = OCT_STR(name='TPShortMessageSpecificInfo', mode=MODE_TYPE)
    TPShortMessageSpecificInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPValidityPeriod >-----#
    TPValidityPeriod = OCT_STR(name='TPValidityPeriod', mode=MODE_TYPE)
    TPValidityPeriod._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TransferredVolume >-----#
    TransferredVolume = CHOICE(name='TransferredVolume', mode=MODE_TYPE)
    _TransferredVolume_volumeIfNoTariffSwitch = INT(name='volumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolume_volumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch = SEQ(name='volumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch = INT(name='volumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval = INT(name='volumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch._cont = ASN1Dict([
        ('volumeSinceLastTariffSwitch', __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch),
        ('volumeTariffSwitchInterval', __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval),
        ])
    _TransferredVolume_volumeIfTariffSwitch._ext = None
    TransferredVolume._cont = ASN1Dict([
        ('volumeIfNoTariffSwitch', _TransferredVolume_volumeIfNoTariffSwitch),
        ('volumeIfTariffSwitch', _TransferredVolume_volumeIfTariffSwitch),
        ])
    TransferredVolume._ext = None
    
    #-----< TransferredVolumeRollOver >-----#
    TransferredVolumeRollOver = CHOICE(name='TransferredVolumeRollOver', mode=MODE_TYPE)
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch = INT(name='rO-VolumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch = SEQ(name='rO-VolumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch = INT(name='rO-VolumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval = INT(name='rO-VolumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._cont = ASN1Dict([
        ('rO-VolumeSinceLastTariffSwitch', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch),
        ('rO-VolumeTariffSwitchInterval', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval),
        ])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._ext = None
    TransferredVolumeRollOver._cont = ASN1Dict([
        ('rO-VolumeIfNoTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch),
        ('rO-VolumeIfTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch),
        ])
    TransferredVolumeRollOver._ext = None
    
    #-----< UnavailableNetworkResource >-----#
    UnavailableNetworkResource = ENUM(name='UnavailableNetworkResource', mode=MODE_TYPE)
    UnavailableNetworkResource._cont = ASN1Dict([('unavailableResources', 0), ('componentFailure', 1), ('basicCallProcessingException', 2), ('resourceStatusFailure', 3), ('endUserFailure', 4)])
    UnavailableNetworkResource._ext = None
    
    #-----< VariablePart >-----#
    VariablePart = CHOICE(name='VariablePart', mode=MODE_TYPE, param=True)
    
    #-----< numOfInfoItems >-----#
    numOfInfoItems = INT(name='numOfInfoItems', mode=MODE_VALUE)
    numOfInfoItems._val = 4
    
    _all_ = [
        AlertingPattern,
        _AOCBeforeAnswer_aOCInitial,
        _AOCBeforeAnswer_aOCSubsequent,
        AOCBeforeAnswer,
        _AOCGPRS_aOCInitial,
        _AOCGPRS_aOCSubsequent,
        AOCGPRS,
        _AOCSubsequent_cAI_GSM0224,
        _AOCSubsequent_tariffSwitchInterval,
        AOCSubsequent,
        AppendFreeFormatData,
        ApplicationTimer,
        _AudibleIndicator_tone,
        _AudibleIndicator_burstList,
        AudibleIndicator,
        _BackwardServiceInteractionInd_conferenceTreatmentIndicator,
        _BackwardServiceInteractionInd_callCompletionTreatmentIndicator,
        BackwardServiceInteractionInd,
        _Burst_numberOfBursts,
        _Burst_burstInterval,
        _Burst_numberOfTonesInBurst,
        _Burst_toneDuration,
        _Burst_toneInterval,
        Burst,
        _BurstList_warningPeriod,
        _BurstList_bursts,
        BurstList,
        _CAI_GSM0224_e1,
        _CAI_GSM0224_e2,
        _CAI_GSM0224_e3,
        _CAI_GSM0224_e4,
        _CAI_GSM0224_e5,
        _CAI_GSM0224_e6,
        _CAI_GSM0224_e7,
        CAI_GSM0224,
        _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOC_extension,
        CAMEL_SCIBillingChargingCharacteristics,
        CAMEL_SCIBillingChargingCharacteristicsAlt,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID,
        CAMEL_SCIGPRSBillingChargingCharacteristics,
        CGEncountered,
        _ChangeOfLocation_cellGlobalId,
        _ChangeOfLocation_serviceAreaId,
        _ChangeOfLocation_locationAreaId,
        _ChangeOfLocation_inter_SystemHandOver,
        _ChangeOfLocation_inter_PLMNHandOver,
        _ChangeOfLocation_inter_MSCHandOver,
        _ChangeOfLocation_changeOfLocationAlt,
        ChangeOfLocation,
        ChangeOfLocationAlt,
        ChargeIndicator,
        _ChargingCharacteristics_maxTransferredVolume,
        _ChargingCharacteristics_maxElapsedTime,
        ChargingCharacteristics,
        _ChargingResult_transferredVolume,
        _ChargingResult_elapsedTime,
        ChargingResult,
        _ChargingRollOver_transferredVolumeRollOver,
        _ChargingRollOver_elapsedTimeRollOver,
        ChargingRollOver,
        _CollectedDigits_minimumNbOfDigits,
        _CollectedDigits_maximumNbOfDigits,
        _CollectedDigits_endOfReplyDigit,
        _CollectedDigits_cancelDigit,
        _CollectedDigits_startDigit,
        _CollectedDigits_firstDigitTimeOut,
        _CollectedDigits_interDigitTimeOut,
        _CollectedDigits_errorTreatment,
        _CollectedDigits_interruptableAnnInd,
        _CollectedDigits_voiceInformation,
        _CollectedDigits_voiceBack,
        CollectedDigits,
        _CollectedInfo_collectedDigits,
        CollectedInfo,
        ConnectedNumberTreatmentInd,
        ControlType,
        DateAndTime,
        _ElapsedTime_timeGPRSIfNoTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval,
        _ElapsedTime_timeGPRSIfTariffSwitch,
        ElapsedTime,
        _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval,
        _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch,
        ElapsedTimeRollOver,
        ErrorTreatment,
        __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_o_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo,
        __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_t_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_t_smsDeliverySpecificInfo,
        EventSpecificInformationSMS,
        EventTypeBCSM,
        EventTypeSMS,
        __ExtensionField_type_tab,
        ___ExtensionField_type_tab_val_ExtensionType_0,
        _ExtensionField_type,
        _ExtensionField_criticality,
        _ExtensionField_value,
        ExtensionField,
        _ForwardServiceInteractionInd_conferenceTreatmentIndicator,
        _ForwardServiceInteractionInd_callDiversionTreatmentIndicator,
        _ForwardServiceInteractionInd_callingPartyRestrictionIndicator,
        ForwardServiceInteractionInd,
        _GapIndicators_duration,
        _GapIndicators_gapInterval,
        GapIndicators,
        _GapOnService_serviceKey,
        GapOnService,
        _GPRS_QoS_short_QoS_format,
        _GPRS_QoS_long_QoS_format,
        GPRS_QoS,
        _GPRS_QoS_Extension_supplement_to_long_QoS_format,
        _GPRS_QoS_Extension_additionalSupplement,
        GPRS_QoS_Extension,
        _GPRSEvent_gPRSEventType,
        _GPRSEvent_monitorMode,
        GPRSEvent,
        GPRSEventType,
        InitiatingEntity,
        InitiatorOfServiceChange,
        InvokeID,
        LegType,
        leg1,
        leg2,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _MetDPCriterion_enteringCellGlobalId,
        _MetDPCriterion_leavingCellGlobalId,
        _MetDPCriterion_enteringServiceAreaId,
        _MetDPCriterion_leavingServiceAreaId,
        _MetDPCriterion_enteringLocationAreaId,
        _MetDPCriterion_leavingLocationAreaId,
        _MetDPCriterion_inter_SystemHandOverToUMTS,
        _MetDPCriterion_inter_SystemHandOverToGSM,
        _MetDPCriterion_inter_PLMNHandOver,
        _MetDPCriterion_inter_MSCHandOver,
        _MetDPCriterion_metDPCriterionAlt,
        MetDPCriterion,
        MetDPCriterionAlt,
        _MidCallControlInfo_minimumNumberOfDigits,
        _MidCallControlInfo_maximumNumberOfDigits,
        _MidCallControlInfo_endOfReplyDigit,
        _MidCallControlInfo_cancelDigit,
        _MidCallControlInfo_startDigit,
        _MidCallControlInfo_interDigitTimeout,
        MidCallControlInfo,
        MonitorMode,
        MO_SMSCause,
        MT_SMSCause,
        NAOliInfo,
        NatureOfServiceChange,
        NumberOfDigits,
        OCSIApplicable,
        PDPID,
        PDPInitiationType,
        _QualityOfService_requested_QoS,
        _QualityOfService_subscribed_QoS,
        _QualityOfService_negotiated_QoS,
        _QualityOfService_requested_QoS_Extension,
        _QualityOfService_subscribed_QoS_Extension,
        _QualityOfService_negotiated_QoS_Extension,
        QualityOfService,
        _ReceivingSideID_receivingSideID,
        ReceivingSideID,
        _RequestedInformationTypeList__item_,
        RequestedInformationTypeList,
        RequestedInformationType,
        RPCause,
        _SendingSideID_sendingSideID,
        SendingSideID,
        _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd,
        _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd,
        _ServiceInteractionIndicatorsTwo_nonCUGCall,
        _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator,
        ServiceInteractionIndicatorsTwo,
        SGSNCapabilities,
        SMS_AddressString,
        maxSMS_AddressStringLength,
        _SMSEvent_eventTypeSMS,
        _SMSEvent_monitorMode,
        SMSEvent,
        TariffSwitchInterval,
        TimeIfNoTariffSwitch,
        _TimeIfTariffSwitch_timeSinceTariffSwitch,
        _TimeIfTariffSwitch_tariffSwitchInterval,
        TimeIfTariffSwitch,
        _TimeInformation_timeIfNoTariffSwitch,
        _TimeInformation_timeIfTariffSwitch,
        TimeInformation,
        TimerID,
        TimerValue,
        _Tone_toneID,
        _Tone_duration,
        Tone,
        TPDataCodingScheme,
        TPProtocolIdentifier,
        TPShortMessageSpecificInfo,
        TPValidityPeriod,
        _TransferredVolume_volumeIfNoTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval,
        _TransferredVolume_volumeIfTariffSwitch,
        TransferredVolume,
        _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval,
        _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch,
        TransferredVolumeRollOver,
        UnavailableNetworkResource,
        numOfInfoItems,
    ]

class CAP_errorcodes:

    _name_  = 'CAP-errorcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 57, 7]
    
    _obj_ = [
        'errcode-canceled',
        'errcode-cancelFailed',
        'errcode-eTCFailed',
        'errcode-improperCallerResponse',
        'errcode-missingCustomerRecord',
        'errcode-missingParameter',
        'errcode-parameterOutOfRange',
        'errcode-requestedInfoError',
        'errcode-systemFailure',
        'errcode-taskRefused',
        'errcode-unavailableResource',
        'errcode-unexpectedComponentSequence',
        'errcode-unexpectedDataValue',
        'errcode-unexpectedParameter',
        'errcode-unknownLegID',
        'errcode-unknownPDPID',
        'errcode-unknownCSID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'errcode-canceled',
        'errcode-cancelFailed',
        'errcode-eTCFailed',
        'errcode-improperCallerResponse',
        'errcode-missingCustomerRecord',
        'errcode-missingParameter',
        'errcode-parameterOutOfRange',
        'errcode-requestedInfoError',
        'errcode-systemFailure',
        'errcode-taskRefused',
        'errcode-unavailableResource',
        'errcode-unexpectedComponentSequence',
        'errcode-unexpectedDataValue',
        'errcode-unexpectedParameter',
        'errcode-unknownLegID',
        'errcode-unknownPDPID',
        'errcode-unknownCSID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< errcode-canceled >-----#
    errcode_canceled = CHOICE(name='errcode-canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_canceled._val = ('local', 0)
    
    #-----< errcode-cancelFailed >-----#
    errcode_cancelFailed = CHOICE(name='errcode-cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_cancelFailed._val = ('local', 1)
    
    #-----< errcode-eTCFailed >-----#
    errcode_eTCFailed = CHOICE(name='errcode-eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_eTCFailed._val = ('local', 3)
    
    #-----< errcode-improperCallerResponse >-----#
    errcode_improperCallerResponse = CHOICE(name='errcode-improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_improperCallerResponse._val = ('local', 4)
    
    #-----< errcode-missingCustomerRecord >-----#
    errcode_missingCustomerRecord = CHOICE(name='errcode-missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingCustomerRecord._val = ('local', 6)
    
    #-----< errcode-missingParameter >-----#
    errcode_missingParameter = CHOICE(name='errcode-missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingParameter._val = ('local', 7)
    
    #-----< errcode-parameterOutOfRange >-----#
    errcode_parameterOutOfRange = CHOICE(name='errcode-parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_parameterOutOfRange._val = ('local', 8)
    
    #-----< errcode-requestedInfoError >-----#
    errcode_requestedInfoError = CHOICE(name='errcode-requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_requestedInfoError._val = ('local', 10)
    
    #-----< errcode-systemFailure >-----#
    errcode_systemFailure = CHOICE(name='errcode-systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_systemFailure._val = ('local', 11)
    
    #-----< errcode-taskRefused >-----#
    errcode_taskRefused = CHOICE(name='errcode-taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_taskRefused._val = ('local', 12)
    
    #-----< errcode-unavailableResource >-----#
    errcode_unavailableResource = CHOICE(name='errcode-unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unavailableResource._val = ('local', 13)
    
    #-----< errcode-unexpectedComponentSequence >-----#
    errcode_unexpectedComponentSequence = CHOICE(name='errcode-unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedComponentSequence._val = ('local', 14)
    
    #-----< errcode-unexpectedDataValue >-----#
    errcode_unexpectedDataValue = CHOICE(name='errcode-unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedDataValue._val = ('local', 15)
    
    #-----< errcode-unexpectedParameter >-----#
    errcode_unexpectedParameter = CHOICE(name='errcode-unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedParameter._val = ('local', 16)
    
    #-----< errcode-unknownLegID >-----#
    errcode_unknownLegID = CHOICE(name='errcode-unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownLegID._val = ('local', 17)
    
    #-----< errcode-unknownPDPID >-----#
    errcode_unknownPDPID = CHOICE(name='errcode-unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownPDPID._val = ('local', 50)
    
    #-----< errcode-unknownCSID >-----#
    errcode_unknownCSID = CHOICE(name='errcode-unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownCSID._val = ('local', 51)
    
    _all_ = [
        errcode_canceled,
        errcode_cancelFailed,
        errcode_eTCFailed,
        errcode_improperCallerResponse,
        errcode_missingCustomerRecord,
        errcode_missingParameter,
        errcode_parameterOutOfRange,
        errcode_requestedInfoError,
        errcode_systemFailure,
        errcode_taskRefused,
        errcode_unavailableResource,
        errcode_unexpectedComponentSequence,
        errcode_unexpectedDataValue,
        errcode_unexpectedParameter,
        errcode_unknownLegID,
        errcode_unknownPDPID,
        errcode_unknownCSID,
    ]

class CAP_errortypes:

    _name_  = 'CAP-errortypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 51, 7]
    
    _obj_ = [
        'canceled',
        'cancelFailed',
        'eTCFailed',
        'improperCallerResponse',
        'missingCustomerRecord',
        'missingParameter',
        'parameterOutOfRange',
        'requestedInfoError',
        'systemFailure',
        'taskRefused',
        'unavailableResource',
        'unexpectedComponentSequence',
        'unexpectedDataValue',
        'unexpectedParameter',
        'unknownLegID',
        'unknownCSID',
        'unknownPDPID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'canceled',
        'cancelFailed',
        'eTCFailed',
        'improperCallerResponse',
        'missingCustomerRecord',
        'missingParameter',
        'parameterOutOfRange',
        'requestedInfoError',
        'systemFailure',
        'taskRefused',
        'unavailableResource',
        'unexpectedComponentSequence',
        'unexpectedDataValue',
        'unexpectedParameter',
        'unknownLegID',
        'unknownCSID',
        'unknownPDPID',
        ]
    _class_ = [
        'canceled',
        'cancelFailed',
        'eTCFailed',
        'improperCallerResponse',
        'missingCustomerRecord',
        'missingParameter',
        'parameterOutOfRange',
        'requestedInfoError',
        'systemFailure',
        'taskRefused',
        'unavailableResource',
        'unexpectedComponentSequence',
        'unexpectedDataValue',
        'unexpectedParameter',
        'unknownLegID',
        'unknownCSID',
        'unknownPDPID',
        ]
    _param_ = [
        ]
    
    #-----< canceled >-----#
    canceled = CLASS(name='canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    canceled._val = dict([('errorCode', ('local', 0))])
    
    #-----< cancelFailed >-----#
    cancelFailed = CLASS(name='cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _cancelFailed_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE)
    __cancelFailed_val_ParameterType_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __cancelFailed_val_ParameterType_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    __cancelFailed_val_ParameterType_problem._ext = None
    __cancelFailed_val_ParameterType_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _cancelFailed_val_ParameterType._cont = ASN1Dict([
        ('problem', __cancelFailed_val_ParameterType_problem),
        ('operation', __cancelFailed_val_ParameterType_operation),
        ])
    _cancelFailed_val_ParameterType._ext = []
    cancelFailed._val = dict([('ParameterType', _cancelFailed_val_ParameterType), ('errorCode', ('local', 1))])
    
    #-----< eTCFailed >-----#
    eTCFailed = CLASS(name='eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    eTCFailed._val = dict([('errorCode', ('local', 3))])
    
    #-----< improperCallerResponse >-----#
    improperCallerResponse = CLASS(name='improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    improperCallerResponse._val = dict([('errorCode', ('local', 4))])
    
    #-----< missingCustomerRecord >-----#
    missingCustomerRecord = CLASS(name='missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingCustomerRecord._val = dict([('errorCode', ('local', 6))])
    
    #-----< missingParameter >-----#
    missingParameter = CLASS(name='missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingParameter._val = dict([('errorCode', ('local', 7))])
    
    #-----< parameterOutOfRange >-----#
    parameterOutOfRange = CLASS(name='parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    parameterOutOfRange._val = dict([('errorCode', ('local', 8))])
    
    #-----< requestedInfoError >-----#
    requestedInfoError = CLASS(name='requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _requestedInfoError_val_ParameterType = ENUM(name='ParameterType', mode=MODE_TYPE)
    _requestedInfoError_val_ParameterType._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    _requestedInfoError_val_ParameterType._ext = None
    requestedInfoError._val = dict([('ParameterType', _requestedInfoError_val_ParameterType), ('errorCode', ('local', 10))])
    
    #-----< systemFailure >-----#
    systemFailure = CLASS(name='systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _systemFailure_val_ParameterType = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    systemFailure._val = dict([('ParameterType', _systemFailure_val_ParameterType), ('errorCode', ('local', 11))])
    
    #-----< taskRefused >-----#
    taskRefused = CLASS(name='taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _taskRefused_val_ParameterType = ENUM(name='ParameterType', mode=MODE_TYPE)
    _taskRefused_val_ParameterType._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _taskRefused_val_ParameterType._ext = None
    taskRefused._val = dict([('ParameterType', _taskRefused_val_ParameterType), ('errorCode', ('local', 12))])
    
    #-----< unavailableResource >-----#
    unavailableResource = CLASS(name='unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unavailableResource._val = dict([('errorCode', ('local', 13))])
    
    #-----< unexpectedComponentSequence >-----#
    unexpectedComponentSequence = CLASS(name='unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedComponentSequence._val = dict([('errorCode', ('local', 14))])
    
    #-----< unexpectedDataValue >-----#
    unexpectedDataValue = CLASS(name='unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedDataValue._val = dict([('errorCode', ('local', 15))])
    
    #-----< unexpectedParameter >-----#
    unexpectedParameter = CLASS(name='unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedParameter._val = dict([('errorCode', ('local', 16))])
    
    #-----< unknownLegID >-----#
    unknownLegID = CLASS(name='unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownLegID._val = dict([('errorCode', ('local', 17))])
    
    #-----< unknownCSID >-----#
    unknownCSID = CLASS(name='unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownCSID._val = dict([('errorCode', ('local', 51))])
    
    #-----< unknownPDPID >-----#
    unknownPDPID = CLASS(name='unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownPDPID._val = dict([('errorCode', ('local', 50))])
    
    _all_ = [
        canceled,
        cancelFailed,
        __cancelFailed_val_ParameterType_problem,
        __cancelFailed_val_ParameterType_operation,
        _cancelFailed_val_ParameterType,
        eTCFailed,
        improperCallerResponse,
        missingCustomerRecord,
        missingParameter,
        parameterOutOfRange,
        requestedInfoError,
        _requestedInfoError_val_ParameterType,
        systemFailure,
        _systemFailure_val_ParameterType,
        taskRefused,
        _taskRefused_val_ParameterType,
        unavailableResource,
        unexpectedComponentSequence,
        unexpectedDataValue,
        unexpectedParameter,
        unknownLegID,
        unknownCSID,
        unknownPDPID,
    ]

class CAP_gprsSSF_gsmSCF_ops_args:

    _name_  = 'CAP-gprsSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 107, 7]
    
    _obj_ = [
        'activityTestGPRS',
        'applyChargingGPRS',
        'ApplyChargingGPRSArg',
        'applyChargingReportGPRS',
        'ApplyChargingReportGPRSArg',
        'cancelGPRS',
        'CancelGPRSArg',
        'connectGPRS',
        'ConnectGPRSArg',
        'continueGPRS',
        'ContinueGPRSArg',
        'entityReleasedGPRS',
        'EntityReleasedGPRSArg',
        'eventReportGPRS',
        'EventReportGPRSArg',
        'furnishChargingInformationGPRS',
        'FurnishChargingInformationGPRSArg',
        'initialDPGPRS',
        'InitialDPGPRSArg',
        'releaseGPRS',
        'ReleaseGPRSArg',
        'requestReportGPRSEvent',
        'RequestReportGPRSEventArg',
        'resetTimerGPRS',
        'ResetTimerGPRSArg',
        'sendChargingInformationGPRS',
        'SendChargingInformationGPRSArg',
        ]
    _type_ = [
        'ApplyChargingGPRSArg',
        'ApplyChargingReportGPRSArg',
        'CancelGPRSArg',
        'ConnectGPRSArg',
        'ContinueGPRSArg',
        'EntityReleasedGPRSArg',
        'EventReportGPRSArg',
        'FurnishChargingInformationGPRSArg',
        'InitialDPGPRSArg',
        'ReleaseGPRSArg',
        'RequestReportGPRSEventArg',
        'ResetTimerGPRSArg',
        'SendChargingInformationGPRSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'activityTestGPRS',
        'applyChargingGPRS',
        'applyChargingReportGPRS',
        'cancelGPRS',
        'connectGPRS',
        'continueGPRS',
        'entityReleasedGPRS',
        'eventReportGPRS',
        'furnishChargingInformationGPRS',
        'initialDPGPRS',
        'releaseGPRS',
        'requestReportGPRSEvent',
        'resetTimerGPRS',
        'sendChargingInformationGPRS',
        ]
    _class_ = [
        'activityTestGPRS',
        'applyChargingGPRS',
        'applyChargingReportGPRS',
        'cancelGPRS',
        'connectGPRS',
        'continueGPRS',
        'entityReleasedGPRS',
        'eventReportGPRS',
        'furnishChargingInformationGPRS',
        'initialDPGPRS',
        'releaseGPRS',
        'requestReportGPRSEvent',
        'resetTimerGPRS',
        'sendChargingInformationGPRS',
        ]
    _param_ = [
        'connectGPRS',
        'ConnectGPRSArg',
        'entityReleasedGPRS',
        'EntityReleasedGPRSArg',
        'eventReportGPRS',
        'EventReportGPRSArg',
        'furnishChargingInformationGPRS',
        'FurnishChargingInformationGPRSArg',
        'initialDPGPRS',
        'InitialDPGPRSArg',
        'releaseGPRS',
        'ReleaseGPRSArg',
        'requestReportGPRSEvent',
        'RequestReportGPRSEventArg',
        'sendChargingInformationGPRS',
        'SendChargingInformationGPRSArg',
        ]
    
    #-----< activityTestGPRS >-----#
    activityTestGPRS = CLASS(name='activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTestGPRS._val = dict([('returnResult', True), ('operationCode', ('local', 70))])
    
    #-----< applyChargingGPRS >-----#
    applyChargingGPRS = CLASS(name='applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    applyChargingGPRS._val = dict([('ArgumentType', _applyChargingGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])
    
    #-----< ApplyChargingGPRSArg >-----#
    ApplyChargingGPRSArg = SEQ(name='ApplyChargingGPRSArg', mode=MODE_TYPE)
    _ApplyChargingGPRSArg_chargingCharacteristics = CHOICE(name='chargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingCharacteristics')))
    _ApplyChargingGPRSArg_tariffSwitchInterval = INT(name='tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ApplyChargingGPRSArg_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    _ApplyChargingGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ApplyChargingGPRSArg._cont = ASN1Dict([
        ('chargingCharacteristics', _ApplyChargingGPRSArg_chargingCharacteristics),
        ('tariffSwitchInterval', _ApplyChargingGPRSArg_tariffSwitchInterval),
        ('pDPID', _ApplyChargingGPRSArg_pDPID),
        ])
    ApplyChargingGPRSArg._ext = []
    
    #-----< applyChargingReportGPRS >-----#
    applyChargingReportGPRS = CLASS(name='applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingReportGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    applyChargingReportGPRS._val = dict([('ArgumentType', _applyChargingReportGPRS_val_ArgumentType), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])
    
    #-----< ApplyChargingReportGPRSArg >-----#
    ApplyChargingReportGPRSArg = SEQ(name='ApplyChargingReportGPRSArg', mode=MODE_TYPE)
    _ApplyChargingReportGPRSArg_chargingResult = CHOICE(name='chargingResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingResult')))
    _ApplyChargingReportGPRSArg_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _ApplyChargingReportGPRSArg_active = BOOL(name='active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _ApplyChargingReportGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _ApplyChargingReportGPRSArg_chargingRollOver = CHOICE(name='chargingRollOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingRollOver')), opt=True)
    ApplyChargingReportGPRSArg._cont = ASN1Dict([
        ('chargingResult', _ApplyChargingReportGPRSArg_chargingResult),
        ('qualityOfService', _ApplyChargingReportGPRSArg_qualityOfService),
        ('active', _ApplyChargingReportGPRSArg_active),
        ('pDPID', _ApplyChargingReportGPRSArg_pDPID),
        ('chargingRollOver', _ApplyChargingReportGPRSArg_chargingRollOver),
        ])
    ApplyChargingReportGPRSArg._ext = ['chargingRollOver']
    
    #-----< cancelGPRS >-----#
    cancelGPRS = CLASS(name='cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _cancelGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    cancelGPRS._val = dict([('ArgumentType', _cancelGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])
    
    #-----< CancelGPRSArg >-----#
    CancelGPRSArg = SEQ(name='CancelGPRSArg', mode=MODE_TYPE)
    _CancelGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CancelGPRSArg._cont = ASN1Dict([
        ('pDPID', _CancelGPRSArg_pDPID),
        ])
    CancelGPRSArg._ext = []
    
    #-----< connectGPRS >-----#
    connectGPRS = CLASS(name='connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectGPRSArg >-----#
    ConnectGPRSArg = SEQ(name='ConnectGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueGPRS >-----#
    continueGPRS = CLASS(name='continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _continueGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    continueGPRS._val = dict([('ArgumentType', _continueGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])
    
    #-----< ContinueGPRSArg >-----#
    ContinueGPRSArg = SEQ(name='ContinueGPRSArg', mode=MODE_TYPE)
    _ContinueGPRSArg_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ContinueGPRSArg._cont = ASN1Dict([
        ('pDPID', _ContinueGPRSArg_pDPID),
        ])
    ContinueGPRSArg._ext = []
    
    #-----< entityReleasedGPRS >-----#
    entityReleasedGPRS = CLASS(name='entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedGPRSArg >-----#
    EntityReleasedGPRSArg = SEQ(name='EntityReleasedGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportGPRS >-----#
    eventReportGPRS = CLASS(name='eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportGPRSArg >-----#
    EventReportGPRSArg = SEQ(name='EventReportGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationGPRS >-----#
    furnishChargingInformationGPRS = CLASS(name='furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationGPRSArg >-----#
    FurnishChargingInformationGPRSArg = OCT_STR(name='FurnishChargingInformationGPRSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIGPRSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPGPRS >-----#
    initialDPGPRS = CLASS(name='initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPGPRSArg >-----#
    InitialDPGPRSArg = SEQ(name='InitialDPGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseGPRS >-----#
    releaseGPRS = CLASS(name='releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseGPRSArg >-----#
    ReleaseGPRSArg = SEQ(name='ReleaseGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< requestReportGPRSEvent >-----#
    requestReportGPRSEvent = CLASS(name='requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportGPRSEventArg >-----#
    RequestReportGPRSEventArg = SEQ(name='RequestReportGPRSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerGPRS >-----#
    resetTimerGPRS = CLASS(name='resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _resetTimerGPRS_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2._ext = None
    resetTimerGPRS._val = dict([('ArgumentType', _resetTimerGPRS_val_ArgumentType), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])
    
    #-----< ResetTimerGPRSArg >-----#
    ResetTimerGPRSArg = SEQ(name='ResetTimerGPRSArg', mode=MODE_TYPE)
    _ResetTimerGPRSArg_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _ResetTimerGPRSArg_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ResetTimerGPRSArg._cont = ASN1Dict([
        ('timerID', _ResetTimerGPRSArg_timerID),
        ('timervalue', _ResetTimerGPRSArg_timervalue),
        ])
    ResetTimerGPRSArg._ext = []
    
    #-----< sendChargingInformationGPRS >-----#
    sendChargingInformationGPRS = CLASS(name='sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationGPRSArg >-----#
    SendChargingInformationGPRSArg = SEQ(name='SendChargingInformationGPRSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTestGPRS,
        applyChargingGPRS,
        _applyChargingGPRS_val_ArgumentType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        _ApplyChargingGPRSArg_chargingCharacteristics,
        _ApplyChargingGPRSArg_tariffSwitchInterval,
        _ApplyChargingGPRSArg_pDPID,
        ApplyChargingGPRSArg,
        applyChargingReportGPRS,
        _applyChargingReportGPRS_val_ArgumentType,
        _ApplyChargingReportGPRSArg_chargingResult,
        _ApplyChargingReportGPRSArg_qualityOfService,
        _ApplyChargingReportGPRSArg_active,
        _ApplyChargingReportGPRSArg_pDPID,
        _ApplyChargingReportGPRSArg_chargingRollOver,
        ApplyChargingReportGPRSArg,
        cancelGPRS,
        _cancelGPRS_val_ArgumentType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _CancelGPRSArg_pDPID,
        CancelGPRSArg,
        continueGPRS,
        _continueGPRS_val_ArgumentType,
        _ContinueGPRSArg_pDPID,
        ContinueGPRSArg,
        resetTimerGPRS,
        _resetTimerGPRS_val_ArgumentType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _ResetTimerGPRSArg_timerID,
        _ResetTimerGPRSArg_timervalue,
        ResetTimerGPRSArg,
    ]

class CAP_gprsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = 'CAP-gprsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 108, 7]
    
    _obj_ = [
        'cap-gprssf-scfAC',
        'cap-gsmscf-gprsssfAC',
        'capGprsSsfToScf',
        'capGsmScfToGprsSsf',
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsProcessingPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsTimerPackage',
        'gprsBillingPackage',
        'gprsChargingPackage',
        'gprsChargeAdvicePackage',
        'gprsActivityTestPackage',
        'gprsCancelPackage',
        'gprsSSF-gsmSCFAbstractSyntax',
        'GenericGprsSSF-gsmSCF-PDUs',
        'GprsSsfToGsmScfInvokable',
        'GprsSsfToGsmScfReturnable',
        'gsmSCF-gprsSSFAbstractSyntax',
        'GenericGsmSCF-gprsSSF-PDUs',
        'GsmScfToGprsSsfInvokable',
        'GsmScfToGprsSsfReturnable',
        ]
    _type_ = [
        'GenericGprsSSF-gsmSCF-PDUs',
        'GenericGsmSCF-gprsSSF-PDUs',
        ]
    _set_ = [
        'GprsSsfToGsmScfInvokable',
        'GprsSsfToGsmScfReturnable',
        'GsmScfToGprsSsfInvokable',
        'GsmScfToGprsSsfReturnable',
        ]
    _val_ = [
        'cap-gprssf-scfAC',
        'cap-gsmscf-gprsssfAC',
        'capGprsSsfToScf',
        'capGsmScfToGprsSsf',
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsProcessingPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsTimerPackage',
        'gprsBillingPackage',
        'gprsChargingPackage',
        'gprsChargeAdvicePackage',
        'gprsActivityTestPackage',
        'gprsCancelPackage',
        'gprsSSF-gsmSCFAbstractSyntax',
        'gsmSCF-gprsSSFAbstractSyntax',
        ]
    _class_ = [
        'cap-gprssf-scfAC',
        'cap-gsmscf-gprsssfAC',
        'capGprsSsfToScf',
        'capGsmScfToGprsSsf',
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsProcessingPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsTimerPackage',
        'gprsBillingPackage',
        'gprsChargingPackage',
        'gprsChargeAdvicePackage',
        'gprsActivityTestPackage',
        'gprsCancelPackage',
        'gprsSSF-gsmSCFAbstractSyntax',
        'GprsSsfToGsmScfInvokable',
        'GprsSsfToGsmScfReturnable',
        'gsmSCF-gprsSSFAbstractSyntax',
        'GsmScfToGprsSsfInvokable',
        'GsmScfToGprsSsfReturnable',
        ]
    _param_ = [
        'gprsScfActivationPackage',
        'gprsConnectPackage',
        'gprsReleasePackage',
        'gprsEventHandlingPackage',
        'gprsExceptionInformationPackage',
        'gprsBillingPackage',
        'gprsChargeAdvicePackage',
        ]
    
    #-----< cap-gprssf-scfAC >-----#
    cap_gprssf_scfAC = CLASS(name='cap-gprssf-scfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey),
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSEventType),
        ('mSISDN', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mSISDN),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI),
        ('timeAndTimeZone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone),
        ('gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass),
        ('endUserAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress),
        ('qualityOfService', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_qualityOfService),
        ('accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName),
        ('routeingAreaIdentity', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_routeingAreaIdentity),
        ('chargingID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_chargingID),
        ('sGSNCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sGSNCapabilities),
        ('locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS),
        ('pDPInitiationType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_pDPInitiationType),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions),
        ('gGSNAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gGSNAddress),
        ('secondaryPDP-context', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_secondaryPDP_context),
        ('iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventType),
        ('miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation),
        ('pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('gPRSCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        ('accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName),
        ('pdpID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_pdpID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._cont = ASN1Dict([
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventType),
        ('miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation),
        ('pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    cap_gprssf_scfAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 14))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 21, 3, 50))])
    
    #-----< cap-gsmscf-gprsssfAC >-----#
    cap_gsmscf_gprsssfAC = CLASS(name='cap-gsmscf-gprsssfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        ('gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        ('gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent),
        ('pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2._cont = ASN1Dict([
        ('gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventType),
        ('miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation),
        ('pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._ext = []
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    cap_gsmscf_gprsssfAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 15))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 21, 3, 51))])
    
    #-----< capGprsSsfToScf >-----#
    capGprsSsfToScf = CLASS(name='capGprsSsfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGprsSsfToScf._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 14))])
    
    #-----< capGsmScfToGprsSsf >-----#
    capGsmScfToGprsSsf = CLASS(name='capGsmScfToGprsSsf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGsmScfToGprsSsf._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 15))])
    
    #-----< gprsScfActivationPackage >-----#
    gprsScfActivationPackage = CLASS(name='gprsScfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsConnectPackage >-----#
    gprsConnectPackage = CLASS(name='gprsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsProcessingPackage >-----#
    gprsProcessingPackage = CLASS(name='gprsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsProcessingPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 49))])
    
    #-----< gprsReleasePackage >-----#
    gprsReleasePackage = CLASS(name='gprsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsEventHandlingPackage >-----#
    gprsEventHandlingPackage = CLASS(name='gprsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsExceptionInformationPackage >-----#
    gprsExceptionInformationPackage = CLASS(name='gprsExceptionInformationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsTimerPackage >-----#
    gprsTimerPackage = CLASS(name='gprsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsTimerPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 55))])
    
    #-----< gprsBillingPackage >-----#
    gprsBillingPackage = CLASS(name='gprsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsChargingPackage >-----#
    gprsChargingPackage = CLASS(name='gprsChargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsChargingPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 57))])
    
    #-----< gprsChargeAdvicePackage >-----#
    gprsChargeAdvicePackage = CLASS(name='gprsChargeAdvicePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsActivityTestPackage >-----#
    gprsActivityTestPackage = CLASS(name='gprsActivityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsActivityTestPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 58))])
    
    #-----< gprsCancelPackage >-----#
    gprsCancelPackage = CLASS(name='gprsCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsCancelPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 59))])
    
    #-----< gprsSSF-gsmSCFAbstractSyntax >-----#
    gprsSSF_gsmSCFAbstractSyntax = CLASS(name='gprsSSF-gsmSCFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gprsSSF_gsmSCFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    gprsSSF_gsmSCFAbstractSyntax._val = dict([('Type', _gprsSSF_gsmSCFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])
    
    #-----< GenericGprsSSF-gsmSCF-PDUs >-----#
    GenericGprsSSF_gsmSCF_PDUs = CHOICE(name='GenericGprsSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName),
        ('pdpID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType),
        ('miscGPRSInfo', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo),
        ('gPRSEventSpecificInformation', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN),
        ('iMSI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService),
        ('accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        ('extensions', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        ('gGSNAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent),
        ('pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName),
        ('pdpID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause),
        ('pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN),
        ('iMSI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService),
        ('accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        ('extensions', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        ('gGSNAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause),
        ('pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent),
        ('pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 6))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericGprsSSF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_begin._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_end_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericGprsSSF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_end._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._cont = ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericGprsSSF_gsmSCF_PDUs_continue__otid),
        ('dtid', __GenericGprsSSF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __GenericGprsSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGprsSSF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericGprsSSF_gsmSCF_PDUs_unidirectional),
        ('begin', _GenericGprsSSF_gsmSCF_PDUs_begin),
        ('end', _GenericGprsSSF_gsmSCF_PDUs_end),
        ('continue', _GenericGprsSSF_gsmSCF_PDUs_continue_),
        ('abort', _GenericGprsSSF_gsmSCF_PDUs_abort),
        ])
    GenericGprsSSF_gsmSCF_PDUs._ext = None
    
    #-----< GprsSsfToGsmScfInvokable >-----#
    GprsSsfToGsmScfInvokable = CLASS(name='GprsSsfToGsmScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName),
        ('pdpID', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo = SEQ(name='miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name='gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name='attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name='pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        ('chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        ('endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        ('qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        ('timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = ['gGSNAddress']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name='detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = ['routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name='disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name='initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name='routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        ('initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        ('routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = ['routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name='pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        ('endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        ('qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        ('pDPInitiationType', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        ('secondaryPDP-context', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = ['secondaryPDP-context']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name='pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        ('pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        ('accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        ('chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        ('endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        ('qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        ('locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        ('timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        ('gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = ['gGSNAddress']
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        ('attachChangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        ('pdp-ContextchangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        ('detachSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        ('disconnectSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        ('pDPContextEstablishmentSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        ('pDPContextEstablishmentAcknowledgementSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType),
        ('miscGPRSInfo', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo),
        ('gPRSEventSpecificInformation', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN),
        ('iMSI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService),
        ('accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType),
        ('extensions', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions),
        ('gGSNAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent),
        ('pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 80))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GprsSsfToGsmScfReturnable >-----#
    GprsSsfToGsmScfReturnable = CLASS(name='GprsSsfToGsmScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID = OCT_STR(name='pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName),
        ('pdpID', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause = OCT_STR(name='gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('gPRSCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause),
        ('pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType = ENUM(name='gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name='timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress = SEQ(name='endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name='pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name='pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name='pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        ('pDPTypeOrganization', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        ('pDPTypeNumber', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        ('pDPAddress', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService = SEQ(name='qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID = OCT_STR(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name='sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType = ENUM(name='pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress = OCT_STR(name='gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context = NULL(name='secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._cont = ASN1Dict([
        ('serviceKey', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey),
        ('gPRSEventType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType),
        ('mSISDN', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN),
        ('iMSI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI),
        ('timeAndTimeZone', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone),
        ('gPRSMSClass', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass),
        ('endUserAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress),
        ('qualityOfService', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService),
        ('accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName),
        ('routeingAreaIdentity', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity),
        ('chargingID', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID),
        ('sGSNCapabilities', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities),
        ('locationInformationGPRS', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS),
        ('pDPInitiationType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType),
        ('extensions', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions),
        ('gGSNAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress),
        ('secondaryPDP-context', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context),
        ('iMEI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._ext = ['gGSNAddress', 'secondaryPDP-context', 'iMEI']
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._cont = ASN1Dict([
        ('gprsCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause),
        ('pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._cont = ASN1Dict([
        ('gPRSEvent', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent),
        ('pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 72))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 50))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 74))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 50))]), dict([('errorCode', ('local', 15))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 75))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_6), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 76))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 78))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 82))]), dict([('ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    #-----< gsmSCF-gprsSSFAbstractSyntax >-----#
    gsmSCF_gprsSSFAbstractSyntax = CLASS(name='gsmSCF-gprsSSFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gsmSCF_gprsSSFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    gsmSCF_gprsSSFAbstractSyntax._val = dict([('Type', _gsmSCF_gprsSSFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])
    
    #-----< GenericGsmSCF-gprsSSF-PDUs >-----#
    GenericGsmSCF_gprsSSF_PDUs = CHOICE(name='GenericGsmSCF-gprsSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause),
        ('pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent),
        ('pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause),
        ('pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent),
        ('pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericGsmSCF_gprsSSF_PDUs_begin_otid),
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_begin_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_begin._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_end_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericGsmSCF_gprsSSF_PDUs_end_dtid),
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_end_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_end._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._cont = ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericGsmSCF_gprsSSF_PDUs_continue__otid),
        ('dtid', __GenericGsmSCF_gprsSSF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion),
        ('components', __GenericGsmSCF_gprsSSF_PDUs_continue__components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGsmSCF_gprsSSF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericGsmSCF_gprsSSF_PDUs_unidirectional),
        ('begin', _GenericGsmSCF_gprsSSF_PDUs_begin),
        ('end', _GenericGsmSCF_gprsSSF_PDUs_end),
        ('continue', _GenericGsmSCF_gprsSSF_PDUs_continue_),
        ('abort', _GenericGsmSCF_gprsSSF_PDUs_abort),
        ])
    GenericGsmSCF_gprsSSF_PDUs._ext = None
    
    #-----< GsmScfToGprsSsfInvokable >-----#
    GsmScfToGprsSsfInvokable = CLASS(name='GsmScfToGprsSsfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause),
        ('pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent),
        ('pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GsmScfToGprsSsfReturnable >-----#
    GsmScfToGprsSsfReturnable = CLASS(name='GsmScfToGprsSsfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause = OCT_STR(name='gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('gprsCause', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause),
        ('pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name='gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID = OCT_STR(name='pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('gPRSEvent', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent),
        ('pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name='sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 70))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 71))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 73))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 77))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 79))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 81))]), dict([('ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 50))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 83))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap_gprssf_scfAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mSISDN,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_qualityOfService,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_routeingAreaIdentity,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_chargingID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sGSNCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_pDPInitiationType,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gGSNAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_secondaryPDP_context,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_pdpID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        cap_gsmscf_gprsssfAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0,
        capGprsSsfToScf,
        capGsmScfToGprsSsf,
        gprsProcessingPackage,
        gprsTimerPackage,
        gprsChargingPackage,
        gprsActivityTestPackage,
        gprsCancelPackage,
        gprsSSF_gsmSCFAbstractSyntax,
        _gprsSSF_gsmSCFAbstractSyntax_val_Type,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericGprsSSF_gsmSCF_PDUs_unidirectional,
        __GenericGprsSSF_gsmSCF_PDUs_begin_otid,
        __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_begin_components,
        _GenericGprsSSF_gsmSCF_PDUs_begin,
        __GenericGprsSSF_gsmSCF_PDUs_end_dtid,
        __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_end_components,
        _GenericGprsSSF_gsmSCF_PDUs_end,
        __GenericGprsSSF_gsmSCF_PDUs_continue__otid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dtid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_continue__components,
        _GenericGprsSSF_gsmSCF_PDUs_continue_,
        _GenericGprsSSF_gsmSCF_PDUs_abort,
        GenericGprsSSF_gsmSCF_PDUs,
        GprsSsfToGsmScfInvokable,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_1,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_2,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_3,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_4,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_5,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_6,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_7,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_8,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_9,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_10,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_11,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_12,
        GprsSsfToGsmScfReturnable,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_1,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_2,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_3,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_4,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_5,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_6,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_7,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_8,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_9,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_10,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_11,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_12,
        gsmSCF_gprsSSFAbstractSyntax,
        _gsmSCF_gprsSSFAbstractSyntax_val_Type,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components,
        _GenericGsmSCF_gprsSSF_PDUs_unidirectional,
        __GenericGsmSCF_gprsSSF_PDUs_begin_otid,
        __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_begin_components,
        _GenericGsmSCF_gprsSSF_PDUs_begin,
        __GenericGsmSCF_gprsSSF_PDUs_end_dtid,
        __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_end_components,
        _GenericGsmSCF_gprsSSF_PDUs_end,
        __GenericGsmSCF_gprsSSF_PDUs_continue__otid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dtid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_continue__components,
        _GenericGsmSCF_gprsSSF_PDUs_continue_,
        _GenericGsmSCF_gprsSSF_PDUs_abort,
        GenericGsmSCF_gprsSSF_PDUs,
        GsmScfToGprsSsfInvokable,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_1,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_2,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_3,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_4,
        ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_5,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_6,
        GsmScfToGprsSsfReturnable,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_1,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_2,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_3,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_4,
        ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_5,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_6,
    ]

class CAP_gsmSCF_gsmSRF_ops_args:

    _name_  = 'CAP-gsmSCF-gsmSRF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 103, 7]
    
    _obj_ = [
        'playAnnouncement',
        'PlayAnnouncementArg',
        'promptAndCollectUserInformation',
        'PromptAndCollectUserInformationArg',
        'ReceivedInformationArg',
        'specializedResourceReport',
        'SpecializedResourceReportArg',
        ]
    _type_ = [
        'PlayAnnouncementArg',
        'PromptAndCollectUserInformationArg',
        'ReceivedInformationArg',
        'SpecializedResourceReportArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'playAnnouncement',
        'promptAndCollectUserInformation',
        'specializedResourceReport',
        ]
    _class_ = [
        'playAnnouncement',
        'promptAndCollectUserInformation',
        'specializedResourceReport',
        ]
    _param_ = [
        'playAnnouncement',
        'PlayAnnouncementArg',
        'promptAndCollectUserInformation',
        'PromptAndCollectUserInformationArg',
        'ReceivedInformationArg',
        ]
    
    #-----< playAnnouncement >-----#
    playAnnouncement = CLASS(name='playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayAnnouncementArg >-----#
    PlayAnnouncementArg = SEQ(name='PlayAnnouncementArg', mode=MODE_TYPE, param=True)
    
    #-----< promptAndCollectUserInformation >-----#
    promptAndCollectUserInformation = CLASS(name='promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PromptAndCollectUserInformationArg >-----#
    PromptAndCollectUserInformationArg = SEQ(name='PromptAndCollectUserInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< ReceivedInformationArg >-----#
    ReceivedInformationArg = CHOICE(name='ReceivedInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< specializedResourceReport >-----#
    specializedResourceReport = CLASS(name='specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _specializedResourceReport_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    specializedResourceReport._val = dict([('ArgumentType', _specializedResourceReport_val_ArgumentType), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])
    
    #-----< SpecializedResourceReportArg >-----#
    SpecializedResourceReportArg = CHOICE(name='SpecializedResourceReportArg', mode=MODE_TYPE)
    _SpecializedResourceReportArg_allAnnouncementsComplete = NULL(name='allAnnouncementsComplete', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SpecializedResourceReportArg_firstAnnouncementStarted = NULL(name='firstAnnouncementStarted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SpecializedResourceReportArg._cont = ASN1Dict([
        ('allAnnouncementsComplete', _SpecializedResourceReportArg_allAnnouncementsComplete),
        ('firstAnnouncementStarted', _SpecializedResourceReportArg_firstAnnouncementStarted),
        ])
    SpecializedResourceReportArg._ext = None
    
    _all_ = [
        specializedResourceReport,
        _specializedResourceReport_val_ArgumentType,
        _SpecializedResourceReportArg_allAnnouncementsComplete,
        _SpecializedResourceReportArg_firstAnnouncementStarted,
        SpecializedResourceReportArg,
    ]

class CAP_gsmSCF_gsmSRF_pkgs_contracts_acs:

    _name_  = 'CAP-gsmSCF-gsmSRF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 104, 7]
    
    _obj_ = [
        'gsmSRF-gsmSCF-ac',
        'gsmSRF-gsmSCF-contract',
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        'activityTestPackage',
        'gsmSRF-gsmSCF-abstract-syntax',
        'BASIC-gsmSRF-gsmSCF-PDUs',
        'GsmSRFgsmSCFInvokable',
        'GsmSRFgsmSCFReturnable',
        ]
    _type_ = [
        'BASIC-gsmSRF-gsmSCF-PDUs',
        ]
    _set_ = [
        'GsmSRFgsmSCFInvokable',
        'GsmSRFgsmSCFReturnable',
        ]
    _val_ = [
        'gsmSRF-gsmSCF-ac',
        'gsmSRF-gsmSCF-contract',
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        'activityTestPackage',
        'gsmSRF-gsmSCF-abstract-syntax',
        ]
    _class_ = [
        'gsmSRF-gsmSCF-ac',
        'gsmSRF-gsmSCF-contract',
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        'activityTestPackage',
        'gsmSRF-gsmSCF-abstract-syntax',
        'GsmSRFgsmSCFInvokable',
        'GsmSRFgsmSCFReturnable',
        ]
    _param_ = [
        'specializedResourceControlPackage',
        'gsmSRF-scfCancelPackage',
        ]
    
    #-----< gsmSRF-gsmSCF-ac >-----#
    gsmSRF_gsmSCF_ac = CLASS(name='gsmSRF-gsmSCF-ac', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID),
        ('iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = SEQ(name='ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('problem', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem),
        ('operation', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_ac._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 13))])), ('dialogueMode', 'structured'), ('termination', 'basic'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 22, 3, 14))])
    
    #-----< gsmSRF-gsmSCF-contract >-----#
    gsmSRF_gsmSCF_contract = CLASS(name='gsmSRF-gsmSCF-contract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    gsmSRF_gsmSCF_contract._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 13))])
    
    #-----< specializedResourceControlPackage >-----#
    specializedResourceControlPackage = CLASS(name='specializedResourceControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfCancelPackage >-----#
    gsmSRF_scfCancelPackage = CLASS(name='gsmSRF-scfCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name='activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< gsmSRF-gsmSCF-abstract-syntax >-----#
    gsmSRF_gsmSCF_abstract_syntax = CLASS(name='gsmSRF-gsmSCF-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gsmSRF_gsmSCF_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_abstract_syntax._val = dict([('Type', _gsmSRF_gsmSCF_abstract_syntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])
    
    #-----< BASIC-gsmSRF-gsmSCF-PDUs >-----#
    BASIC_gsmSRF_gsmSCF_PDUs = CHOICE(name='BASIC-gsmSRF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend),
        ('extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ('callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('ResultType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend),
        ('extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        ('callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('ResultType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        ('problem', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        ('operation', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_begin_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_end_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid),
        ('dtid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __BASIC_gsmSRF_gsmSCF_PDUs_continue__components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    BASIC_gsmSRF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional),
        ('begin', _BASIC_gsmSRF_gsmSCF_PDUs_begin),
        ('end', _BASIC_gsmSRF_gsmSCF_PDUs_end),
        ('continue', _BASIC_gsmSRF_gsmSCF_PDUs_continue_),
        ('abort', _BASIC_gsmSRF_gsmSCF_PDUs_abort),
        ])
    BASIC_gsmSRF_gsmSCF_PDUs._ext = None
    
    #-----< GsmSRFgsmSCFInvokable >-----#
    GsmSRFgsmSCFInvokable = CLASS(name='GsmSRFgsmSCFInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID),
        ('allRequests', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions),
        ('callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend),
        ('extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions),
        ('callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFInvokable_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    GsmSRFgsmSCFInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_4), ('ResultType', _GsmSRFgsmSCFInvokable_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_5), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    #-----< GsmSRFgsmSCFReturnable >-----#
    GsmSRFgsmSCFReturnable = CLASS(name='GsmSRFgsmSCFReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID),
        ('allRequests', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        ('extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions),
        ('callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        ('interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo),
        ('tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('collectedInfo', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo),
        ('disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden),
        ('informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend),
        ('extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions),
        ('callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID),
        ('requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFReturnable_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._cont = ASN1Dict([
        ('digitsResponse', __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._ext = None
    GsmSRFgsmSCFReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_4), ('ResultType', _GsmSRFgsmSCFReturnable_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    
    _all_ = [
        gsmSRF_gsmSCF_ac,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        gsmSRF_gsmSCF_contract,
        activityTestPackage,
        gsmSRF_gsmSCF_abstract_syntax,
        _gsmSRF_gsmSCF_abstract_syntax_val_Type,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_begin,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_end,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__components,
        _BASIC_gsmSRF_gsmSCF_PDUs_continue_,
        _BASIC_gsmSRF_gsmSCF_PDUs_abort,
        BASIC_gsmSRF_gsmSCF_PDUs,
        GsmSRFgsmSCFInvokable,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_1,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_2,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_3,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_4,
        __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFInvokable_val_ResultType_4,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_5,
        GsmSRFgsmSCFReturnable,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_1,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_2,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_3,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_4,
        __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFReturnable_val_ResultType_4,
    ]

class CAP_gsmSSF_gsmSCF_ops_args:

    _name_  = 'CAP-gsmSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 101, 7]
    
    _obj_ = [
        'activityTest',
        'applyCharging',
        'ApplyChargingArg',
        'applyChargingReport',
        'ApplyChargingReportArg',
        'assistRequestInstructions',
        'AssistRequestInstructionsArg',
        'callGap',
        'CallGapArg',
        'callInformationReport',
        'CallInformationReportArg',
        'callInformationRequest',
        'CallInformationRequestArg',
        'cancel',
        'CancelArg',
        'collectInformation',
        'CollectInformationArg',
        'connect',
        'ConnectArg',
        'connectToResource',
        'ConnectToResourceArg',
        'continue',
        'continueWithArgument',
        'ContinueWithArgumentArg',
        'ContinueWithArgumentArgExtension',
        'disconnectForwardConnection',
        'disconnectForwardConnectionWithArgument',
        'DisconnectForwardConnectionWithArgumentArg',
        'disconnectLeg',
        'DisconnectLegArg',
        'entityReleased',
        'EntityReleasedArg',
        'establishTemporaryConnection',
        'EstablishTemporaryConnectionArg',
        'eventReportBCSM',
        'EventReportBCSMArg',
        'furnishChargingInformation',
        'FurnishChargingInformationArg',
        'initialDP',
        'InitialDPArg',
        'InitialDPArgExtension',
        'initiateCallAttempt',
        'InitiateCallAttemptArg',
        'InitiateCallAttemptRes',
        'moveLeg',
        'MoveLegArg',
        'playTone',
        'PlayToneArg',
        'releaseCall',
        'ReleaseCallArg',
        'AllCallSegments',
        'AllCallSegmentsWithExtension',
        'requestReportBCSMEvent',
        'RequestReportBCSMEventArg',
        'resetTimer',
        'ResetTimerArg',
        'sendChargingInformation',
        'SendChargingInformationArg',
        'splitLeg',
        'SplitLegArg',
        ]
    _type_ = [
        'ApplyChargingArg',
        'ApplyChargingReportArg',
        'AssistRequestInstructionsArg',
        'CallGapArg',
        'CallInformationReportArg',
        'CallInformationRequestArg',
        'CancelArg',
        'CollectInformationArg',
        'ConnectArg',
        'ConnectToResourceArg',
        'ContinueWithArgumentArg',
        'ContinueWithArgumentArgExtension',
        'DisconnectForwardConnectionWithArgumentArg',
        'DisconnectLegArg',
        'EntityReleasedArg',
        'EstablishTemporaryConnectionArg',
        'EventReportBCSMArg',
        'FurnishChargingInformationArg',
        'InitialDPArg',
        'InitialDPArgExtension',
        'InitiateCallAttemptArg',
        'InitiateCallAttemptRes',
        'MoveLegArg',
        'PlayToneArg',
        'ReleaseCallArg',
        'AllCallSegments',
        'AllCallSegmentsWithExtension',
        'RequestReportBCSMEventArg',
        'ResetTimerArg',
        'SendChargingInformationArg',
        'SplitLegArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'activityTest',
        'applyCharging',
        'applyChargingReport',
        'assistRequestInstructions',
        'callGap',
        'callInformationReport',
        'callInformationRequest',
        'cancel',
        'collectInformation',
        'connect',
        'connectToResource',
        'continue',
        'continueWithArgument',
        'disconnectForwardConnection',
        'disconnectForwardConnectionWithArgument',
        'disconnectLeg',
        'entityReleased',
        'establishTemporaryConnection',
        'eventReportBCSM',
        'furnishChargingInformation',
        'initialDP',
        'initiateCallAttempt',
        'moveLeg',
        'playTone',
        'releaseCall',
        'requestReportBCSMEvent',
        'resetTimer',
        'sendChargingInformation',
        'splitLeg',
        ]
    _class_ = [
        'activityTest',
        'applyCharging',
        'applyChargingReport',
        'assistRequestInstructions',
        'callGap',
        'callInformationReport',
        'callInformationRequest',
        'cancel',
        'collectInformation',
        'connect',
        'connectToResource',
        'continue',
        'continueWithArgument',
        'disconnectForwardConnection',
        'disconnectForwardConnectionWithArgument',
        'disconnectLeg',
        'entityReleased',
        'establishTemporaryConnection',
        'eventReportBCSM',
        'furnishChargingInformation',
        'initialDP',
        'initiateCallAttempt',
        'moveLeg',
        'playTone',
        'releaseCall',
        'requestReportBCSMEvent',
        'resetTimer',
        'sendChargingInformation',
        'splitLeg',
        ]
    _param_ = [
        'applyCharging',
        'ApplyChargingArg',
        'applyChargingReport',
        'ApplyChargingReportArg',
        'assistRequestInstructions',
        'AssistRequestInstructionsArg',
        'callGap',
        'CallGapArg',
        'callInformationReport',
        'CallInformationReportArg',
        'callInformationRequest',
        'CallInformationRequestArg',
        'cancel',
        'CancelArg',
        'collectInformation',
        'CollectInformationArg',
        'connect',
        'ConnectArg',
        'connectToResource',
        'ConnectToResourceArg',
        'continueWithArgument',
        'ContinueWithArgumentArg',
        'ContinueWithArgumentArgExtension',
        'disconnectForwardConnectionWithArgument',
        'DisconnectForwardConnectionWithArgumentArg',
        'disconnectLeg',
        'DisconnectLegArg',
        'entityReleased',
        'EntityReleasedArg',
        'establishTemporaryConnection',
        'EstablishTemporaryConnectionArg',
        'eventReportBCSM',
        'EventReportBCSMArg',
        'furnishChargingInformation',
        'FurnishChargingInformationArg',
        'initialDP',
        'InitialDPArg',
        'InitialDPArgExtension',
        'initiateCallAttempt',
        'InitiateCallAttemptArg',
        'InitiateCallAttemptRes',
        'moveLeg',
        'MoveLegArg',
        'playTone',
        'PlayToneArg',
        'releaseCall',
        'ReleaseCallArg',
        'AllCallSegments',
        'AllCallSegmentsWithExtension',
        'requestReportBCSMEvent',
        'RequestReportBCSMEventArg',
        'resetTimer',
        'ResetTimerArg',
        'sendChargingInformation',
        'SendChargingInformationArg',
        'splitLeg',
        'SplitLegArg',
        ]
    
    #-----< activityTest >-----#
    activityTest = CLASS(name='activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTest._val = dict([('returnResult', True), ('operationCode', ('local', 55))])
    
    #-----< applyCharging >-----#
    applyCharging = CLASS(name='applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingArg >-----#
    ApplyChargingArg = SEQ(name='ApplyChargingArg', mode=MODE_TYPE, param=True)
    
    #-----< applyChargingReport >-----#
    applyChargingReport = CLASS(name='applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingReportArg >-----#
    ApplyChargingReportArg = OCT_STR(name='ApplyChargingReportArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CallResult')), param=True)
    
    #-----< assistRequestInstructions >-----#
    assistRequestInstructions = CLASS(name='assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AssistRequestInstructionsArg >-----#
    AssistRequestInstructionsArg = SEQ(name='AssistRequestInstructionsArg', mode=MODE_TYPE, param=True)
    
    #-----< callGap >-----#
    callGap = CLASS(name='callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallGapArg >-----#
    CallGapArg = SEQ(name='CallGapArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationReport >-----#
    callInformationReport = CLASS(name='callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationReportArg >-----#
    CallInformationReportArg = SEQ(name='CallInformationReportArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationRequest >-----#
    callInformationRequest = CLASS(name='callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationRequestArg >-----#
    CallInformationRequestArg = SEQ(name='CallInformationRequestArg', mode=MODE_TYPE, param=True)
    
    #-----< cancel >-----#
    cancel = CLASS(name='cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CancelArg >-----#
    CancelArg = CHOICE(name='CancelArg', mode=MODE_TYPE, param=True)
    
    #-----< collectInformation >-----#
    collectInformation = CLASS(name='collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CollectInformationArg >-----#
    CollectInformationArg = SEQ(name='CollectInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< connect >-----#
    connect = CLASS(name='connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectArg >-----#
    ConnectArg = SEQ(name='ConnectArg', mode=MODE_TYPE, param=True)
    
    #-----< connectToResource >-----#
    connectToResource = CLASS(name='connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectToResourceArg >-----#
    ConnectToResourceArg = SEQ(name='ConnectToResourceArg', mode=MODE_TYPE, param=True)
    
    #-----< continue >-----#
    continue_ = CLASS(name='continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continue_._val = dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])
    
    #-----< continueWithArgument >-----#
    continueWithArgument = CLASS(name='continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ContinueWithArgumentArg >-----#
    ContinueWithArgumentArg = SEQ(name='ContinueWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< ContinueWithArgumentArgExtension >-----#
    ContinueWithArgumentArgExtension = SEQ(name='ContinueWithArgumentArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< disconnectForwardConnection >-----#
    disconnectForwardConnection = CLASS(name='disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    disconnectForwardConnection._val = dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))])
    
    #-----< disconnectForwardConnectionWithArgument >-----#
    disconnectForwardConnectionWithArgument = CLASS(name='disconnectForwardConnectionWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectForwardConnectionWithArgumentArg >-----#
    DisconnectForwardConnectionWithArgumentArg = SEQ(name='DisconnectForwardConnectionWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< disconnectLeg >-----#
    disconnectLeg = CLASS(name='disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectLegArg >-----#
    DisconnectLegArg = SEQ(name='DisconnectLegArg', mode=MODE_TYPE, param=True)
    
    #-----< entityReleased >-----#
    entityReleased = CLASS(name='entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedArg >-----#
    EntityReleasedArg = CHOICE(name='EntityReleasedArg', mode=MODE_TYPE, param=True)
    
    #-----< establishTemporaryConnection >-----#
    establishTemporaryConnection = CLASS(name='establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EstablishTemporaryConnectionArg >-----#
    EstablishTemporaryConnectionArg = SEQ(name='EstablishTemporaryConnectionArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportBCSM >-----#
    eventReportBCSM = CLASS(name='eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportBCSMArg >-----#
    EventReportBCSMArg = SEQ(name='EventReportBCSMArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformation >-----#
    furnishChargingInformation = CLASS(name='furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationArg >-----#
    FurnishChargingInformationArg = OCT_STR(name='FurnishChargingInformationArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIBillingChargingCharacteristics')), param=True)
    
    #-----< initialDP >-----#
    initialDP = CLASS(name='initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPArg >-----#
    InitialDPArg = SEQ(name='InitialDPArg', mode=MODE_TYPE, param=True)
    
    #-----< InitialDPArgExtension >-----#
    InitialDPArgExtension = SEQ(name='InitialDPArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< initiateCallAttempt >-----#
    initiateCallAttempt = CLASS(name='initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitiateCallAttemptArg >-----#
    InitiateCallAttemptArg = SEQ(name='InitiateCallAttemptArg', mode=MODE_TYPE, param=True)
    
    #-----< InitiateCallAttemptRes >-----#
    InitiateCallAttemptRes = SEQ(name='InitiateCallAttemptRes', mode=MODE_TYPE, param=True)
    
    #-----< moveLeg >-----#
    moveLeg = CLASS(name='moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< MoveLegArg >-----#
    MoveLegArg = SEQ(name='MoveLegArg', mode=MODE_TYPE, param=True)
    
    #-----< playTone >-----#
    playTone = CLASS(name='playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayToneArg >-----#
    PlayToneArg = SEQ(name='PlayToneArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseCall >-----#
    releaseCall = CLASS(name='releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseCallArg >-----#
    ReleaseCallArg = CHOICE(name='ReleaseCallArg', mode=MODE_TYPE, param=True)
    
    #-----< AllCallSegments >-----#
    AllCallSegments = OCT_STR(name='AllCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Cause')), param=True)
    
    #-----< AllCallSegmentsWithExtension >-----#
    AllCallSegmentsWithExtension = SEQ(name='AllCallSegmentsWithExtension', mode=MODE_TYPE, param=True)
    
    #-----< requestReportBCSMEvent >-----#
    requestReportBCSMEvent = CLASS(name='requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportBCSMEventArg >-----#
    RequestReportBCSMEventArg = SEQ(name='RequestReportBCSMEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimer >-----#
    resetTimer = CLASS(name='resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerArg >-----#
    ResetTimerArg = SEQ(name='ResetTimerArg', mode=MODE_TYPE, param=True)
    
    #-----< sendChargingInformation >-----#
    sendChargingInformation = CLASS(name='sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationArg >-----#
    SendChargingInformationArg = SEQ(name='SendChargingInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< splitLeg >-----#
    splitLeg = CLASS(name='splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SplitLegArg >-----#
    SplitLegArg = SEQ(name='SplitLegArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTest,
        continue_,
        disconnectForwardConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
    ]

class CAP_gsmSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = 'CAP-gsmSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 102, 7]
    
    _obj_ = [
        'capssf-scfGenericAC',
        'capssf-scfAssistHandoffAC',
        'capscf-ssfGenericAC',
        'capSsfToScfGeneric',
        'capAssistHandoffssfToScf',
        'capScfToSsfGeneric',
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'activityTestPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        'gsmSSF-scfGenericAbstractSyntax',
        'GenericSSF-gsmSCF-PDUs',
        'SsfToScfGenericInvokable',
        'SsfToScfGenericReturnable',
        'assistHandoff-gsmSSF-scfAbstractSyntax',
        'AssistHandoffsSF-gsmSCF-PDUs',
        'AssistHandoffssfToScfInvokable',
        'AssistHandoffssfToScfReturnable',
        'scf-gsmSSFGenericAbstractSyntax',
        'GenericSCF-gsmSSF-PDUs',
        'ScfToSsfGenericInvokable',
        'ScfToSsfGenericReturnable',
        ]
    _type_ = [
        'GenericSSF-gsmSCF-PDUs',
        'AssistHandoffsSF-gsmSCF-PDUs',
        'GenericSCF-gsmSSF-PDUs',
        ]
    _set_ = [
        'SsfToScfGenericInvokable',
        'SsfToScfGenericReturnable',
        'AssistHandoffssfToScfInvokable',
        'AssistHandoffssfToScfReturnable',
        'ScfToSsfGenericInvokable',
        'ScfToSsfGenericReturnable',
        ]
    _val_ = [
        'capssf-scfGenericAC',
        'capssf-scfAssistHandoffAC',
        'capscf-ssfGenericAC',
        'capSsfToScfGeneric',
        'capAssistHandoffssfToScf',
        'capScfToSsfGeneric',
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'activityTestPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        'gsmSSF-scfGenericAbstractSyntax',
        'assistHandoff-gsmSSF-scfAbstractSyntax',
        'scf-gsmSSFGenericAbstractSyntax',
        ]
    _class_ = [
        'capssf-scfGenericAC',
        'capssf-scfAssistHandoffAC',
        'capscf-ssfGenericAC',
        'capSsfToScfGeneric',
        'capAssistHandoffssfToScf',
        'capScfToSsfGeneric',
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'activityTestPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        'gsmSSF-scfGenericAbstractSyntax',
        'SsfToScfGenericInvokable',
        'SsfToScfGenericReturnable',
        'assistHandoff-gsmSSF-scfAbstractSyntax',
        'AssistHandoffssfToScfInvokable',
        'AssistHandoffssfToScfReturnable',
        'scf-gsmSSFGenericAbstractSyntax',
        'ScfToSsfGenericInvokable',
        'ScfToSsfGenericReturnable',
        ]
    _param_ = [
        'scfActivationPackage',
        'gsmSRF-scfActivationOfAssistPackage',
        'assistConnectionEstablishmentPackage',
        'genericDisconnectResourcePackage',
        'nonAssistedConnectionEstablishmentPackage',
        'connectPackage',
        'callHandlingPackage',
        'bcsmEventHandlingPackage',
        'ssfCallProcessingPackage',
        'scfCallInitiationPackage',
        'timerPackage',
        'billingPackage',
        'chargingPackage',
        'trafficManagementPackage',
        'callReportPackage',
        'signallingControlPackage',
        'cancelPackage',
        'cphResponsePackage',
        'exceptionInformPackage',
        'playTonePackage',
        ]
    
    #-----< capssf-scfGenericAC >-----#
    capssf_scfGenericAC = CLASS(name='capssf-scfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure),
        ('bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey),
        ('calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        ('cGEncountered', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered),
        ('iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        ('locationNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        ('highLayerCompatibility', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        ('additionalCallingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        ('bearerCapability', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability),
        ('eventTypeBCSM', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        ('redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        ('redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation),
        ('cause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier),
        ('cug-Index', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI),
        ('subscriberState', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState),
        ('locationInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation),
        ('ext-basicServiceCode', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        ('callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        ('mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress),
        ('calledPartyBCDNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        ('timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        ('callForwardingSS-Pending', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        ('initialDPArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID),
        ('scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM),
        ('eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        ('allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments),
        ('allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        ('requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = SEQ(name='ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('problem', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem),
        ('operation', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        ('srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        ('partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions),
        ('aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        ('redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        ('redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber),
        ('legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        ('oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        ('suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._ext = ['suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        ('legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased),
        ('releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        ('legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        ('legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        ('none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        ('resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        ('legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        ('bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        ('partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        ('tone', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        ('releaseCause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        ('gapCriteria', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria),
        ('gapIndicators', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators),
        ('controlType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType),
        ('gapTreatment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions),
        ('legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        ('callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        ('gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        ('suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._cont = ASN1Dict([
        ('supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions),
        ('releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._ext = ['releaseCallArgExtensionAllowed']
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    capssf_scfGenericAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 3))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 4))])
    
    #-----< capssf-scfAssistHandoffAC >-----#
    capssf_scfAssistHandoffAC = CLASS(name='capssf-scfAssistHandoffAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID),
        ('iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        ('none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        ('resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._ext = []
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    capssf_scfAssistHandoffAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 5))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 6))])
    
    #-----< capscf-ssfGenericAC >-----#
    capscf_ssfGenericAC = CLASS(name='capscf-ssfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        ('correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID),
        ('scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._ext = ['originalCalledPartyID', 'callingPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        ('dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        ('bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        ('eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        ('eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        ('allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        ('allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        ('requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        ('requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions),
        ('legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        ('invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID),
        ('allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests),
        ('callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        ('srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        ('partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions),
        ('aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        ('originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        ('redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        ('redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        ('legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        ('oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        ('suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._ext = ['suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        ('legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased),
        ('releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        ('legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        ('legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        ('none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        ('resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        ('legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        ('bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        ('destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions),
        ('legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        ('newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        ('callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        ('gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        ('suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        ('supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases),
        ('offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions),
        ('releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._ext = ['releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        ('interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        ('tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        ('collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo),
        ('disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        ('informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID),
        ('requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        ('digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        ('alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions),
        ('serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        ('genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers),
        ('cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock),
        ('cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        ('chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber),
        ('carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier),
        ('suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        ('naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo),
        ('bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        ('suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions),
        ('callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        ('legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        ('cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        ('callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        ('bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    capscf_ssfGenericAC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 6))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 8))])
    
    #-----< capSsfToScfGeneric >-----#
    capSsfToScfGeneric = CLASS(name='capSsfToScfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capSsfToScfGeneric._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 3))])
    
    #-----< capAssistHandoffssfToScf >-----#
    capAssistHandoffssfToScf = CLASS(name='capAssistHandoffssfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capAssistHandoffssfToScf._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 5))])
    
    #-----< capScfToSsfGeneric >-----#
    capScfToSsfGeneric = CLASS(name='capScfToSsfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capScfToSsfGeneric._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7), ('ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 23, 26, 6))])
    
    #-----< scfActivationPackage >-----#
    scfActivationPackage = CLASS(name='scfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfActivationOfAssistPackage >-----#
    gsmSRF_scfActivationOfAssistPackage = CLASS(name='gsmSRF-scfActivationOfAssistPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< assistConnectionEstablishmentPackage >-----#
    assistConnectionEstablishmentPackage = CLASS(name='assistConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< genericDisconnectResourcePackage >-----#
    genericDisconnectResourcePackage = CLASS(name='genericDisconnectResourcePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< nonAssistedConnectionEstablishmentPackage >-----#
    nonAssistedConnectionEstablishmentPackage = CLASS(name='nonAssistedConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< connectPackage >-----#
    connectPackage = CLASS(name='connectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callHandlingPackage >-----#
    callHandlingPackage = CLASS(name='callHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< bcsmEventHandlingPackage >-----#
    bcsmEventHandlingPackage = CLASS(name='bcsmEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ssfCallProcessingPackage >-----#
    ssfCallProcessingPackage = CLASS(name='ssfCallProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< scfCallInitiationPackage >-----#
    scfCallInitiationPackage = CLASS(name='scfCallInitiationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< timerPackage >-----#
    timerPackage = CLASS(name='timerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< billingPackage >-----#
    billingPackage = CLASS(name='billingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< chargingPackage >-----#
    chargingPackage = CLASS(name='chargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< trafficManagementPackage >-----#
    trafficManagementPackage = CLASS(name='trafficManagementPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callReportPackage >-----#
    callReportPackage = CLASS(name='callReportPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< signallingControlPackage >-----#
    signallingControlPackage = CLASS(name='signallingControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name='activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< cancelPackage >-----#
    cancelPackage = CLASS(name='cancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< cphResponsePackage >-----#
    cphResponsePackage = CLASS(name='cphResponsePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< exceptionInformPackage >-----#
    exceptionInformPackage = CLASS(name='exceptionInformPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< playTonePackage >-----#
    playTonePackage = CLASS(name='playTonePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSSF-scfGenericAbstractSyntax >-----#
    gsmSSF_scfGenericAbstractSyntax = CLASS(name='gsmSSF-scfGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _gsmSSF_scfGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    gsmSSF_scfGenericAbstractSyntax._val = dict([('Type', _gsmSSF_scfGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])
    
    #-----< GenericSSF-gsmSCF-PDUs >-----#
    GenericSSF_gsmSCF_PDUs = CHOICE(name='GenericSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSSF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ('legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID),
        ('allRequests', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory),
        ('genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers),
        ('cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess),
        ('chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier),
        ('suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement),
        ('naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested),
        ('suppress-O-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        ('none', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('resourceAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        ('cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID),
        ('cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('callSegmentFailure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure),
        ('bCSM-Failure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        ('correlationID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID),
        ('scfID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID),
        ('naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo),
        ('chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber),
        ('originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID),
        ('callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._ext = ['originalCalledPartyID', 'callingPartyNumber']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM),
        ('eventSpecificInformationBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM),
        ('legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID),
        ('miscCallInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation),
        ('cause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier),
        ('cug-Index', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI),
        ('subscriberState', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState),
        ('locationInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions),
        ('legToBeCreated', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID),
        ('timervalue', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        ('bursts', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend),
        ('extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions),
        ('callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), ('ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27), ('ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        ('tone', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend),
        ('releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('gapCriteria', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria),
        ('gapIndicators', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators),
        ('controlType', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType),
        ('gapTreatment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        ('legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        ('allRequests', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory),
        ('genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers),
        ('cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess),
        ('chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier),
        ('suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement),
        ('naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo),
        ('bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested),
        ('suppress-O-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('legToBeReleased', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased),
        ('releaseCause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        ('cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID),
        ('cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        ('callSegmentFailure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure),
        ('bCSM-Failure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        ('correlationID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID),
        ('scfID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID),
        ('naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo),
        ('chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber),
        ('originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID),
        ('callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation),
        ('cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier),
        ('cug-Index', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI),
        ('subscriberState', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState),
        ('locationInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        ('legToBeCreated', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID),
        ('timervalue', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        ('bursts', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend),
        ('extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions),
        ('callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), ('ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27), ('ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        ('problem', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        ('operation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), ('errorCode', ('local', 10))]), dict([('ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericSSF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_begin_components._cont = ___GenericSSF_gsmSCF_PDUs_begin_components__item_
    __GenericSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericSSF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericSSF_gsmSCF_PDUs_begin._ext = None
    _GenericSSF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_end_components._cont = ___GenericSSF_gsmSCF_PDUs_end_components__item_
    __GenericSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericSSF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericSSF_gsmSCF_PDUs_end._ext = None
    _GenericSSF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_continue__components._cont = ___GenericSSF_gsmSCF_PDUs_continue__components__item_
    __GenericSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericSSF_gsmSCF_PDUs_continue__otid),
        ('dtid', __GenericSSF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __GenericSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericSSF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSSF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericSSF_gsmSCF_PDUs_unidirectional),
        ('begin', _GenericSSF_gsmSCF_PDUs_begin),
        ('end', _GenericSSF_gsmSCF_PDUs_end),
        ('continue', _GenericSSF_gsmSCF_PDUs_continue_),
        ('abort', _GenericSSF_gsmSCF_PDUs_abort),
        ])
    GenericSSF_gsmSCF_PDUs._ext = None
    
    #-----< SsfToScfGenericInvokable >-----#
    SsfToScfGenericInvokable = CLASS(name='SsfToScfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_1._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_3_extensions),
        ('legID', __SsfToScfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_3._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_4_extensions),
        ('legID', __SsfToScfGenericInvokable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_4._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID),
        ('allRequests', __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_5._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_6_extensions),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _SsfToScfGenericInvokable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        ('alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory),
        ('genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers),
        ('cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess),
        ('chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_7_carrier),
        ('suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement),
        ('naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested),
        ('suppress-O-CSI', __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_7._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        ('none', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_8._cont = ASN1Dict([
        ('resourceAddress', __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_8_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_8._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_9_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_9._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_11._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_12._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        ('cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID),
        ('cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        ('callSegmentFailure', __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure),
        ('bCSM-Failure', __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_13._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_14 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_14._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        ('correlationID', __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID),
        ('scfID', __SsfToScfGenericInvokable_val_ArgumentType_14_scfID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_14_extensions),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_14_carrier),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID),
        ('naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo),
        ('chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber),
        ('originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID),
        ('callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_14._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _SsfToScfGenericInvokable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_15_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        ('eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM),
        ('eventSpecificInformationBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM),
        ('legID', __SsfToScfGenericInvokable_val_ArgumentType_15_legID),
        ('miscCallInfo', __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_15_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_15._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation),
        ('cause', __SsfToScfGenericInvokable_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', __SsfToScfGenericInvokable_val_ArgumentType_17_carrier),
        ('cug-Index', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI),
        ('subscriberState', __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState),
        ('locationInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_17._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_18_extensions),
        ('legToBeCreated', __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_18._ext = []
    _SsfToScfGenericInvokable_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', __SsfToScfGenericInvokable_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericInvokable_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_19._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_20._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_21._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', __SsfToScfGenericInvokable_val_ArgumentType_22_timerID),
        ('timervalue', __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_22_extensions),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_22._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_23._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_24._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_25_extensions),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_25._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment),
        ('bursts', __SsfToScfGenericInvokable_val_ArgumentType_26_bursts),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_26._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend),
        ('extensions', __SsfToScfGenericInvokable_val_ArgumentType_27_extensions),
        ('callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_27._ext = []
    _SsfToScfGenericInvokable_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericInvokable_val_ResultType_27._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_28 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    SsfToScfGenericInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_15), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_18), ('ResultType', _SsfToScfGenericInvokable_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_27), ('ResultType', _SsfToScfGenericInvokable_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_28), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    #-----< SsfToScfGenericReturnable >-----#
    SsfToScfGenericReturnable = CLASS(name='SsfToScfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_1._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria = CHOICE(name='gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name='compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name='basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name='gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name='calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name='calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        ('calledAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        ('serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name='callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name='callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        ('callingAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        ('serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        ('calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        ('gapOnService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        ('calledAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        ('callingAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        ('scfID', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        ('basicGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        ('compoundGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators = SEQ(name='gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_controlType = ENUM(name='controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment = CHOICE(name='gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        ('interval', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        ('tone', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        ('informationToSend', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend),
        ('releaseCause', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('gapCriteria', __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria),
        ('gapIndicators', __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators),
        ('controlType', __SsfToScfGenericReturnable_val_ArgumentType_3_controlType),
        ('gapTreatment', __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_3_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_3._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _SsfToScfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_4_extensions),
        ('legID', __SsfToScfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_4._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID),
        ('allRequests', __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_5._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_6_extensions),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _SsfToScfGenericReturnable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_7._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_8._cont = ASN1Dict([
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_8_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_8._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        ('alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_10_extensions),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory),
        ('genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers),
        ('cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess),
        ('chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_10_carrier),
        ('suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement),
        ('naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo),
        ('bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested),
        ('suppress-O-CSI', __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_10._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_12._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        ('legToBeReleased', __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased),
        ('releaseCause', __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_13._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        ('cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID),
        ('cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14._cont = ASN1Dict([
        ('callSegmentFailure', __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure),
        ('bCSM-Failure', __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_14._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        ('correlationID', __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID),
        ('scfID', __SsfToScfGenericReturnable_val_ArgumentType_15_scfID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_15_extensions),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_15_carrier),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID),
        ('naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo),
        ('chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber),
        ('originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID),
        ('callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_15._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _SsfToScfGenericReturnable_val_ArgumentType_16 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered = ENUM(name='cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name='highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name='additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability = CHOICE(name='bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        ('bearerCap', ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name='calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name='callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension = SEQ(name='initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name='gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name='bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name='bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        ('bearerCap', ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name='highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name='lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name='lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name='enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name='collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        ('gmscAddress', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        ('forwardingDestinationNumber', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        ('ms-Classmark2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        ('iMEI', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        ('supportedCamelPhases', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        ('offeredCamel4Functionalities', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        ('bearerCapability2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        ('ext-basicServiceCode2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        ('highLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        ('lowLayerCompatibility', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        ('lowLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        ('enhancedDialledServicesAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        ('uu-Data', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        ('collectInformationAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        ('releaseCallArgExtensionAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._ext = ['enhancedDialledServicesAllowed', 'uu-Data', 'collectInformationAllowed', 'releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        ('serviceKey', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey),
        ('calledPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber),
        ('callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber),
        ('callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory),
        ('cGEncountered', __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered),
        ('iPSSPCapabilities', __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities),
        ('locationNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber),
        ('originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_17_extensions),
        ('highLayerCompatibility', __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility),
        ('additionalCallingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber),
        ('bearerCapability', __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability),
        ('eventTypeBCSM', __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM),
        ('redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID),
        ('redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation),
        ('cause', __SsfToScfGenericReturnable_val_ArgumentType_17_cause),
        ('serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        ('carrier', __SsfToScfGenericReturnable_val_ArgumentType_17_carrier),
        ('cug-Index', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index),
        ('cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock),
        ('cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess),
        ('iMSI', __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI),
        ('subscriberState', __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState),
        ('locationInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation),
        ('ext-basicServiceCode', __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode),
        ('callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber),
        ('mscAddress', __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress),
        ('calledPartyBCDNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber),
        ('timeAndTimezone', __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone),
        ('callForwardingSS-Pending', __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending),
        ('initialDPArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_17._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        ('destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_18_extensions),
        ('legToBeCreated', __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated),
        ('newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment),
        ('callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber),
        ('callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber),
        ('gsmSCFAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress),
        ('suppress-T-CSI', __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_18._ext = []
    _SsfToScfGenericReturnable_val_ResultType_18 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ResultType_18._cont = ASN1Dict([
        ('supportedCamelPhases', __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases),
        ('offeredCamel4Functionalities', __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities),
        ('extensions', __SsfToScfGenericReturnable_val_ResultType_18_extensions),
        ('releaseCallArgExtensionAllowed', __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericReturnable_val_ResultType_18._ext = ['releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        ('legIDToMove', __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_19._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_20 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        ('allCallSegments', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments),
        ('allCallSegmentsWithExtension', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_20._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        ('legID', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        ('bcsmEvents', __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_21._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        ('timerID', __SsfToScfGenericReturnable_val_ArgumentType_22_timerID),
        ('timervalue', __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_22_extensions),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_22._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        ('partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_23._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_24._cont = ASN1Dict([
        ('legToBeSplit', __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit),
        ('newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_24._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_25 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_25._cont = ASN1Dict([
        ('informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend),
        ('disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_25_extensions),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_25._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_26 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        ('legID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_26_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_26._cont = ASN1Dict([
        ('legOrCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment),
        ('bursts', __SsfToScfGenericReturnable_val_ArgumentType_26_bursts),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_26._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_27 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        ('interval', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo),
        ('tone', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_27._cont = ASN1Dict([
        ('collectedInfo', __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo),
        ('disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden),
        ('informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend),
        ('extensions', __SsfToScfGenericReturnable_val_ArgumentType_27_extensions),
        ('callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID),
        ('requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_27._ext = []
    _SsfToScfGenericReturnable_val_ResultType_27 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ResultType_27._cont = ASN1Dict([
        ('digitsResponse', __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericReturnable_val_ResultType_27._ext = None
    SsfToScfGenericReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 41))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_10), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_13), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_14), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_15), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_16), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 0))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_18), ('ResultType', _SsfToScfGenericReturnable_val_ResultType_18), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_19), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_20), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_24), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_25), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_26), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_27), ('ResultType', _SsfToScfGenericReturnable_val_ResultType_27), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    
    #-----< assistHandoff-gsmSSF-scfAbstractSyntax >-----#
    assistHandoff_gsmSSF_scfAbstractSyntax = CLASS(name='assistHandoff-gsmSSF-scfAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    assistHandoff_gsmSSF_scfAbstractSyntax._val = dict([('Type', _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])
    
    #-----< AssistHandoffsSF-gsmSCF-PDUs >-----#
    AssistHandoffsSF_gsmSCF_PDUs = CHOICE(name='AssistHandoffsSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID),
        ('timervalue', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue),
        ('extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        ('callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('ResultType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        ('allRequests', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID),
        ('timervalue', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue),
        ('extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        ('callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('ResultType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        ('problem', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        ('operation', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        ('otid', __AssistHandoffsSF_gsmSCF_PDUs_begin_otid),
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_begin_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        ('dtid', __AssistHandoffsSF_gsmSCF_PDUs_end_dtid),
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_end_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_end._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __AssistHandoffsSF_gsmSCF_PDUs_continue__otid),
        ('dtid', __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid),
        ('dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion),
        ('components', __AssistHandoffsSF_gsmSCF_PDUs_continue__components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    AssistHandoffsSF_gsmSCF_PDUs._cont = ASN1Dict([
        ('unidirectional', _AssistHandoffsSF_gsmSCF_PDUs_unidirectional),
        ('begin', _AssistHandoffsSF_gsmSCF_PDUs_begin),
        ('end', _AssistHandoffsSF_gsmSCF_PDUs_end),
        ('continue', _AssistHandoffsSF_gsmSCF_PDUs_continue_),
        ('abort', _AssistHandoffsSF_gsmSCF_PDUs_abort),
        ])
    AssistHandoffsSF_gsmSCF_PDUs._ext = None
    
    #-----< AssistHandoffssfToScfInvokable >-----#
    AssistHandoffssfToScfInvokable = CLASS(name='AssistHandoffssfToScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID),
        ('allRequests', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfInvokable_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID),
        ('timervalue', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue),
        ('extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions),
        ('callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    AssistHandoffssfToScfInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_6), ('ResultType', _AssistHandoffssfToScfInvokable_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_8), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    #-----< AssistHandoffssfToScfReturnable >-----#
    AssistHandoffssfToScfReturnable = CLASS(name='AssistHandoffssfToScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name='iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('correlationID', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID),
        ('iPSSPCapabilities', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        ('callSegmentID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._cont = ASN1Dict([
        ('invokeID', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID),
        ('allRequests', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests),
        ('callSegmentToCancel', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        ('none', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('resourceAddress', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions),
        ('serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        ('interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo),
        ('tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('collectedInfo', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo),
        ('disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden),
        ('informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID),
        ('requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfReturnable_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._cont = ASN1Dict([
        ('digitsResponse', __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._cont = ASN1Dict([
        ('timerID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID),
        ('timervalue', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue),
        ('extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions),
        ('callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._ext = []
    AssistHandoffssfToScfReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 16))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_6), ('ResultType', _AssistHandoffssfToScfReturnable_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))])], rr=[], ev=None, er=[])
    
    #-----< scf-gsmSSFGenericAbstractSyntax >-----#
    scf_gsmSSFGenericAbstractSyntax = CLASS(name='scf-gsmSSFGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _scf_gsmSSFGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    scf_gsmSSFGenericAbstractSyntax._val = dict([('Type', _scf_gsmSSFGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])
    
    #-----< GenericSCF-gsmSSF-PDUs >-----#
    GenericSCF_gsmSSF_PDUs = CHOICE(name='GenericSCF-gsmSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSCF_gsmSSF_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationTypeList', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('legID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('invokeID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID),
        ('allRequests', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests),
        ('callSegmentToCancel', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory),
        ('genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers),
        ('cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock),
        ('cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess),
        ('chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber),
        ('carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier),
        ('suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement),
        ('naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo),
        ('bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested),
        ('suppress-O-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        ('correlationID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID),
        ('scfID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions),
        ('carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier),
        ('serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID),
        ('naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo),
        ('chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber),
        ('originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID),
        ('callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = ['originalCalledPartyID', 'callingPartyNumber']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        ('legToBeCreated', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('legOrCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment),
        ('bursts', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('allCallSegments', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments),
        ('allCallSegmentsWithExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('bcsmEvents', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('timerID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID),
        ('timervalue', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        ('partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('legToBeSplit', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit),
        ('newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend),
        ('disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        ('interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        ('inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo),
        ('tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        ('collectedInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo),
        ('disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden),
        ('informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend),
        ('extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        ('callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID),
        ('requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._cont = ASN1Dict([
        ('digitsResponse', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._ext = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), ('ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), ('ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        ('allRequests', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ('carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('legToBeReleased', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased),
        ('releaseCause', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        ('cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID),
        ('cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentFailure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure),
        ('bCSM-Failure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        ('correlationID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID),
        ('scfID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        ('carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier),
        ('serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        ('naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo),
        ('chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber),
        ('originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID),
        ('callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        ('eventTypeBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM),
        ('eventSpecificInformationBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM),
        ('legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID),
        ('miscCallInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        ('legToBeCreated', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        ('legID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        ('bcsmEvents', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        ('timerID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID),
        ('timervalue', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        ('partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        ('legToBeSplit', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit),
        ('newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo),
        ('tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        ('informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend),
        ('disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        ('legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        ('legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment),
        ('bursts', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        ('collectedInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo),
        ('disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        ('informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend),
        ('extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        ('callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._cont = ASN1Dict([
        ('digitsResponse', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), ('ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), ('ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([('unknownRequestedInfo', 1), ('requestedInfoNotAvailable', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name='ParameterType', mode=MODE_TYPE)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([('unknownOperation', 0), ('tooLate', 1), ('operationNotCancellable', 2)])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        ('problem', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        ('operation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), ('errorCode', ('local', 10))]), dict([('ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 4))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._cont = ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_unidirectional_components),
        ])
    _GenericSCF_gsmSSF_PDUs_unidirectional._ext = None
    _GenericSCF_gsmSSF_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSCF_gsmSSF_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_begin_components._cont = ___GenericSCF_gsmSSF_PDUs_begin_components__item_
    __GenericSCF_gsmSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_begin._cont = ASN1Dict([
        ('otid', __GenericSCF_gsmSSF_PDUs_begin_otid),
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_begin_components),
        ])
    _GenericSCF_gsmSSF_PDUs_begin._ext = None
    _GenericSCF_gsmSSF_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSCF_gsmSSF_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_end_components._cont = ___GenericSCF_gsmSSF_PDUs_end_components__item_
    __GenericSCF_gsmSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_end._cont = ASN1Dict([
        ('dtid', __GenericSCF_gsmSSF_PDUs_end_dtid),
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_end_dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_end_components),
        ])
    _GenericSCF_gsmSSF_PDUs_end._ext = None
    _GenericSCF_gsmSSF_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSCF_gsmSSF_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_continue__components._cont = ___GenericSCF_gsmSSF_PDUs_continue__components__item_
    __GenericSCF_gsmSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_continue_._cont = ASN1Dict([
        ('otid', __GenericSCF_gsmSSF_PDUs_continue__otid),
        ('dtid', __GenericSCF_gsmSSF_PDUs_continue__dtid),
        ('dialoguePortion', __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion),
        ('components', __GenericSCF_gsmSSF_PDUs_continue__components),
        ])
    _GenericSCF_gsmSSF_PDUs_continue_._ext = None
    _GenericSCF_gsmSSF_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSCF_gsmSSF_PDUs._cont = ASN1Dict([
        ('unidirectional', _GenericSCF_gsmSSF_PDUs_unidirectional),
        ('begin', _GenericSCF_gsmSSF_PDUs_begin),
        ('end', _GenericSCF_gsmSSF_PDUs_end),
        ('continue', _GenericSCF_gsmSSF_PDUs_continue_),
        ('abort', _GenericSCF_gsmSSF_PDUs_abort),
        ])
    GenericSCF_gsmSSF_PDUs._ext = None
    
    #-----< ScfToSsfGenericInvokable >-----#
    ScfToSsfGenericInvokable = CLASS(name='ScfToSsfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _ScfToSsfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationTypeList', __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions),
        ('legID', __ScfToSsfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID),
        ('callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('invokeID', __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID),
        ('allRequests', __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests),
        ('callSegmentToCancel', __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_4._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions),
        ('carrier', __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _ScfToSsfGenericInvokable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI = NULL(name='suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name='continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name='suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name='suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        ('legID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        ('suppress-D-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        ('suppress-N-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        ('suppressOutgoingCallBarring', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        ('legOrCallSegment', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        ('alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        ('callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory),
        ('genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers),
        ('cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock),
        ('cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess),
        ('chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber),
        ('carrier', __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier),
        ('suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement),
        ('naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo),
        ('bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested),
        ('suppress-O-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI),
        ('continueWithArgumentArgExtension', __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_11 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        ('legToBeReleased', __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        ('releaseCause', __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        ('correlationID', __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID),
        ('scfID', __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions),
        ('carrier', __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID),
        ('naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo),
        ('chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber),
        ('originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID),
        ('callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _ScfToSsfGenericInvokable_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions),
        ('legToBeCreated', __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', __ScfToSsfGenericInvokable_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    _ScfToSsfGenericInvokable_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        ('legID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        ('legOrCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment),
        ('bursts', __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_18 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name='allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name='allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        ('allCallSegments', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        ('extensions', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        ('allCallSegments', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments),
        ('allCallSegmentsWithExtension', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_18._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        ('legID', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._ext = []
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        ('bcsmEvents', __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        ('timerID', __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID),
        ('timervalue', __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        ('legToBeSplit', __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit),
        ('newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        ('informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend),
        ('disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_24 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        ('collectedInfo', __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo),
        ('disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden),
        ('informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend),
        ('extensions', __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions),
        ('callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_24._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_24 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ResultType_24._cont = ASN1Dict([
        ('digitsResponse', __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_24._ext = None
    ScfToSsfGenericInvokable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 27))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 31))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 88))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_11), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_12), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_13), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_15), ('ResultType', _ScfToSsfGenericInvokable_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_18), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 22))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_20), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_22), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_23), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_24), ('ResultType', _ScfToSsfGenericInvokable_val_ResultType_24), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))])], rr=[], ev=None, er=[])
    
    #-----< ScfToSsfGenericReturnable >-----#
    ScfToSsfGenericReturnable = CLASS(name='ScfToSsfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericReturnable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name='aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x01'))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name='aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=('legID', ('sendingSideID', b'\x01')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name='srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        ('legID', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        ('srfConnection', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        ('aChBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions),
        ('aChChargingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name='requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name='requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name='requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name='callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name='callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name='callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name='releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        ('callAttemptElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        ('callStopTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        ('callConnectedElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        ('releaseCauseValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        ('requestedInformationType', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        ('requestedInformationValue', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=('receivingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('requestedInformationList', __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions),
        ('legID', __ScfToSsfGenericReturnable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name='requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=('sendingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        ('requestedInformationTypeList', __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions),
        ('legID', __ScfToSsfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_4._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name='allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name='callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        ('invokeID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        ('callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('invokeID', __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID),
        ('allRequests', __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests),
        ('callSegmentToCancel', __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_5._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name='callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name='redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name='redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name='legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name='oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name='bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name='suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        ('alertingPattern', __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern),
        ('originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions),
        ('carrier', __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier),
        ('callingPartysCategory', __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        ('redirectingPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        ('redirectionInformation', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        ('genericNumbers', __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        ('chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber),
        ('legToBeConnected', __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        ('cug-Interlock', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        ('cug-OutgoingAccess', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        ('suppressionOfAnnouncement', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        ('oCSIApplicable', __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        ('naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo),
        ('bor-InterrogationRequested', __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        ('suppress-N-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_6._ext = ['suppress-N-CSI']
    _ScfToSsfGenericReturnable_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name='resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name='ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name='none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        ('ipRoutingAddress', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        ('none', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        ('resourceAddress', __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._cont = ASN1Dict([
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased = CHOICE(name='legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        ('legToBeReleased', __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased),
        ('releaseCause', __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure = SEQ(name='callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        ('callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        ('cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure = SEQ(name='bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        ('legID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID),
        ('cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11._cont = ASN1Dict([
        ('callSegmentFailure', __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure),
        ('bCSM-Failure', __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_11._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_12 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name='assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID = OCT_STR(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID = OCT_STR(name='scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier = OCT_STR(name='carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name='serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo = OCT_STR(name='naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber = OCT_STR(name='chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name='originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        ('assistingSSPIPRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        ('correlationID', __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID),
        ('scfID', __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions),
        ('carrier', __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier),
        ('serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID),
        ('naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo),
        ('chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber),
        ('originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID),
        ('callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._ext = ['originalCalledPartyID', 'callingPartyNumber']
    _ScfToSsfGenericReturnable_val_ArgumentType_13 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name='eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name='routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name='failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        ('failureCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name='oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name='oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name='oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name='oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name='oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name='tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name='busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        ('busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        ('callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        ('routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        ('forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name='tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name='callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name='forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        ('callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        ('forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name='tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name='destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name='or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name='forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name='chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name='ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        ('destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        ('or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        ('forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        ('chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        ('ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        ('ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name='tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name='midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name='dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name='dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        ('dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        ('dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        ('midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name='tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name='releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        ('releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name='oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name='callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name='oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name='routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        ('routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name='oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name='tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name='metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name='enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name='leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name='enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name='leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name='enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name='leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name='inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name='inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name='metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        ('enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        ('leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        ('enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        ('leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        ('enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        ('leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        ('inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        ('inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        ('inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        ('metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        ('locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        ('metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = ['metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name='dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name='oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name='tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name='ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name='initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name='natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        ('ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        ('initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        ('natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = ['initiatorOfServiceChange', 'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name='collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        ('calledPartyNumber', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        ('oServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        ('tServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        ('collectedInfoSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = ['oServiceChangeSpecificInfo', 'tServiceChangeSpecificInfo', 'collectedInfoSpecificInfo']
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        ('routeSelectFailureSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        ('oCalledPartyBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        ('oNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        ('oAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        ('oMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        ('oDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        ('tBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        ('tNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        ('tAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        ('tMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        ('tDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        ('oTermSeizedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        ('callAcceptedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        ('oAbandonSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        ('oChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        ('tChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        ('dpSpecificInfoAlt', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_13_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        ('eventTypeBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM),
        ('eventSpecificInformationBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM),
        ('legID', __ScfToSsfGenericReturnable_val_ArgumentType_13_legID),
        ('miscCallInfo', __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_14 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_15 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated = CHOICE(name='legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name='gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        ('destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions),
        ('legToBeCreated', __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated),
        ('newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment),
        ('callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        ('callReferenceNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber),
        ('gsmSCFAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress),
        ('suppress-T-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_15 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name='releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ResultType_15._cont = ASN1Dict([
        ('supportedCamelPhases', __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases),
        ('offeredCamel4Functionalities', __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities),
        ('extensions', __ScfToSsfGenericReturnable_val_ResultType_15_extensions),
        ('releaseCallArgExtensionAllowed', __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_15._ext = ['releaseCallArgExtensionAllowed']
    _ScfToSsfGenericReturnable_val_ArgumentType_16 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove = CHOICE(name='legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._cont = ASN1Dict([
        ('legIDToMove', __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_17 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents = SEQ_OF(name='bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name='eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name='monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name='dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name='applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name='midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name='dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name='changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name='serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name='locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name='inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name='inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name='inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name='changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        ('cellGlobalId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        ('serviceAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        ('locationAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        ('inter-SystemHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        ('inter-PLMNHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        ('inter-MSCHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        ('changeOfLocationAlt', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name='numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name='interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        ('changeOfPositionControlInfo', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        ('numberOfDigits', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        ('interDigitTimeout', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = ['changeOfPositionControlInfo', 'numberOfDigits', 'interDigitTimeout']
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        ('applicationTimer', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        ('midCallControlInfo', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        ('dpSpecificCriteriaAlt', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name='automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        ('eventTypeBCSM', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        ('monitorMode', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        ('legID', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID),
        ('dpSpecificCriteria', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        ('automaticRearm', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        ('bcsmEvents', __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_18 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        ('timerID', __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID),
        ('timervalue', __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_19 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name='sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge = CHOICE(name='partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        ('sCIBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        ('partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_20 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit = CHOICE(name='legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment = INT(name='newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        ('legToBeSplit', __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit),
        ('newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_21 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name='requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        ('informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend),
        ('disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden),
        ('requestAnnouncementCompleteNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_22 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment = CHOICE(name='legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name='legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        ('callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        ('legID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts = SEQ(name='bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        ('legOrCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment),
        ('bursts', __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_23 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo = CHOICE(name='collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name='disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend = CHOICE(name='informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name='inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name='text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name='messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name='attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        ('messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        ('attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name='elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name='variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name='elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name='variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name='integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name='number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name='date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name='price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        ('integer', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        ('number', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        ('time', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        ('date', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        ('price', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        ('elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        ('variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        ('elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        ('text', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        ('elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        ('variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name='numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name='duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name='interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        ('messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        ('numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        ('duration', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        ('interval', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone = SEQ(name='tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        ('inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo),
        ('tone', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID = INT(name='callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name='requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        ('collectedInfo', __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo),
        ('disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden),
        ('informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend),
        ('extensions', __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions),
        ('callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID),
        ('requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_23 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse = OCT_STR(name='digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ResultType_23._cont = ASN1Dict([
        ('digitsResponse', __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_23._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_24 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ScfToSsfGenericReturnable._val = ASN1Set(rv=[dict([('returnResult', True), ('operationCode', ('local', 55))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_1), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 35))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 51))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('errorCode', ('local', 12))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 36))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_3), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 44))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 45))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 53))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 20))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 19))]), dict([('returnResult', False), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 18))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 86))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_10), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 90))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_11), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 96))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_12), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 3))]), dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 17))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_13), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 24))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_14), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 34))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_15), ('ResultType', _ScfToSsfGenericReturnable_val_ResultType_15), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 32))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_16), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 93))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_17), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 23))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_18), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 33))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_19), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 46))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_20), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 17))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 95))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_21), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 47))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_22), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 17))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 97))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_23), ('ResultType', _ScfToSsfGenericReturnable_val_ResultType_23), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 0))]), dict([('errorCode', ('local', 4))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 13))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 51))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 48))]), dict([('ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_24), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 49))])], rr=[], ev=None, er=[])
    
    _all_ = [
        capssf_scfGenericAC,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        capssf_scfAssistHandoffAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0,
        capscf_ssfGenericAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1,
        capSsfToScfGeneric,
        capAssistHandoffssfToScf,
        capScfToSsfGeneric,
        activityTestPackage,
        gsmSSF_scfGenericAbstractSyntax,
        _gsmSSF_scfGenericAbstractSyntax_val_Type,
        __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericSSF_gsmSCF_PDUs_unidirectional,
        __GenericSSF_gsmSCF_PDUs_begin_otid,
        __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericSSF_gsmSCF_PDUs_begin_components,
        _GenericSSF_gsmSCF_PDUs_begin,
        __GenericSSF_gsmSCF_PDUs_end_dtid,
        __GenericSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_end_components__item_,
        __GenericSSF_gsmSCF_PDUs_end_components,
        _GenericSSF_gsmSCF_PDUs_end,
        __GenericSSF_gsmSCF_PDUs_continue__otid,
        __GenericSSF_gsmSCF_PDUs_continue__dtid,
        __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericSSF_gsmSCF_PDUs_continue__components,
        _GenericSSF_gsmSCF_PDUs_continue_,
        _GenericSSF_gsmSCF_PDUs_abort,
        GenericSSF_gsmSCF_PDUs,
        SsfToScfGenericInvokable,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericInvokable_val_ArgumentType_1,
        _SsfToScfGenericInvokable_val_ArgumentType_2,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_3_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_3,
        __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_4_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_4_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_4,
        __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericInvokable_val_ArgumentType_5,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_6_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_6,
        __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_7_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_7,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none,
        __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_8_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_8,
        ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_9_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_9,
        __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_11_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_11,
        __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_12_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_12,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure,
        _SsfToScfGenericInvokable_val_ArgumentType_13,
        __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_scfID,
        ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_14_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_14_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber,
        _SsfToScfGenericInvokable_val_ArgumentType_14,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_15_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_15_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_15,
        _SsfToScfGenericInvokable_val_ArgumentType_16,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_17_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_17_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_17,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_18,
        __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ResultType_18_extensions,
        __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericInvokable_val_ResultType_18,
        __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_19_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_19,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_20,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_21,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timerID,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_22_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_22,
        __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_23_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_23,
        __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_24_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_24,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_25_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_25,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_26_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_26,
        __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_27_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_27,
        __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericInvokable_val_ResultType_27,
        _SsfToScfGenericInvokable_val_ArgumentType_28,
        SsfToScfGenericReturnable,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericReturnable_val_ArgumentType_1,
        _SsfToScfGenericReturnable_val_ArgumentType_2,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators,
        __SsfToScfGenericReturnable_val_ArgumentType_3_controlType,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_3_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_3,
        __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_4_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_4_legID,
        _SsfToScfGenericReturnable_val_ArgumentType_4,
        __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericReturnable_val_ArgumentType_5,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_6_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_6,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_7_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_7,
        ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_8_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_8,
        __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_10_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_10,
        __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_12_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_12,
        __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased,
        __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause,
        ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_13_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_13,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure,
        _SsfToScfGenericReturnable_val_ArgumentType_14,
        __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_15_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_15_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        _SsfToScfGenericReturnable_val_ArgumentType_15,
        _SsfToScfGenericReturnable_val_ArgumentType_16,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_17_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_17_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_17,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_18,
        __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ResultType_18_extensions,
        __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericReturnable_val_ResultType_18,
        __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_19_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_19,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_20,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_21,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timerID,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_22_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_22,
        __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_23_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_23,
        __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_24_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_24,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_25_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_25,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_26_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_26,
        __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_27_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_27,
        __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericReturnable_val_ResultType_27,
        assistHandoff_gsmSSF_scfAbstractSyntax,
        _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components,
        _AssistHandoffsSF_gsmSCF_PDUs_unidirectional,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_otid,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_components,
        _AssistHandoffsSF_gsmSCF_PDUs_begin,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_end_components,
        _AssistHandoffsSF_gsmSCF_PDUs_end,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__otid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__components,
        _AssistHandoffsSF_gsmSCF_PDUs_continue_,
        _AssistHandoffsSF_gsmSCF_PDUs_abort,
        AssistHandoffsSF_gsmSCF_PDUs,
        AssistHandoffssfToScfInvokable,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_1,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_2,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_3,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_5,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_6,
        __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfInvokable_val_ResultType_6,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_7,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_8,
        AssistHandoffssfToScfReturnable,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_1,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_2,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_3,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_5,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_6,
        __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfReturnable_val_ResultType_6,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_7,
        scf_gsmSSFGenericAbstractSyntax,
        _scf_gsmSSFGenericAbstractSyntax_val_Type,
        __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_,
        __GenericSCF_gsmSSF_PDUs_unidirectional_components,
        _GenericSCF_gsmSSF_PDUs_unidirectional,
        __GenericSCF_gsmSSF_PDUs_begin_otid,
        __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_begin_components__item_,
        __GenericSCF_gsmSSF_PDUs_begin_components,
        _GenericSCF_gsmSSF_PDUs_begin,
        __GenericSCF_gsmSSF_PDUs_end_dtid,
        __GenericSCF_gsmSSF_PDUs_end_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_end_components__item_,
        __GenericSCF_gsmSSF_PDUs_end_components,
        _GenericSCF_gsmSSF_PDUs_end,
        __GenericSCF_gsmSSF_PDUs_continue__otid,
        __GenericSCF_gsmSSF_PDUs_continue__dtid,
        __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_continue__components__item_,
        __GenericSCF_gsmSSF_PDUs_continue__components,
        _GenericSCF_gsmSSF_PDUs_continue_,
        _GenericSCF_gsmSSF_PDUs_abort,
        GenericSCF_gsmSSF_PDUs,
        ScfToSsfGenericInvokable,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericInvokable_val_ArgumentType_1,
        _ScfToSsfGenericInvokable_val_ArgumentType_2,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList,
        ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_legID,
        _ScfToSsfGenericInvokable_val_ArgumentType_3,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel,
        _ScfToSsfGenericInvokable_val_ArgumentType_4,
        ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_5,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_6,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_7,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_9,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_11,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_12,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber,
        _ScfToSsfGenericInvokable_val_ArgumentType_13,
        _ScfToSsfGenericInvokable_val_ArgumentType_14,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_15,
        __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ResultType_15_extensions,
        __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericInvokable_val_ResultType_15,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_16,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_17,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_18,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_19,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue,
        ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_20,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_21,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment,
        ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_22,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_23,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_24,
        __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse,
        _ScfToSsfGenericInvokable_val_ResultType_24,
        ScfToSsfGenericReturnable,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericReturnable_val_ArgumentType_1,
        _ScfToSsfGenericReturnable_val_ArgumentType_2,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_3,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_4,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _ScfToSsfGenericReturnable_val_ArgumentType_5,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_6,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_7,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_9,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_10,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure,
        _ScfToSsfGenericReturnable_val_ArgumentType_11,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber,
        _ScfToSsfGenericReturnable_val_ArgumentType_12,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_13,
        _ScfToSsfGenericReturnable_val_ArgumentType_14,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_15,
        __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ResultType_15_extensions,
        __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericReturnable_val_ResultType_15,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_16,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_17,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_18,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_19,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment,
        ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_20,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_21,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_22,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_23,
        __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse,
        _ScfToSsfGenericReturnable_val_ResultType_23,
        _ScfToSsfGenericReturnable_val_ArgumentType_24,
    ]

class CAP_object_identifiers:

    _name_  = 'CAP-object-identifiers'
    _oid_   = [0, 4, 0, 0, 1, 3, 100, 7]
    
    _obj_ = [
        'tc-Messages',
        'tc-NotationExtensions',
        'ros-InformationObjects',
        'datatypes',
        'errortypes',
        'operationcodes',
        'errorcodes',
        'classes',
        'gsmSSF-gsmSCF-Operations',
        'gsmSSF-gsmSCF-Protocol',
        'gsmSCF-gsmSRF-Operations',
        'gsmSCF-gsmSRF-Protocol',
        'sms-Operations',
        'smsSSF-gsmSCF-Protocol',
        'gprsSSF-gsmSCF-Operations',
        'gprsSSF-gsmSCF-Protocol',
        'id-CAP',
        'id-CAP3',
        'id-CAPOE',
        'id-CAP3OE',
        'id-ac',
        'id-acE',
        'id-ac3E',
        'id-as',
        'id-asE',
        'id-rosObject',
        'id-contract',
        'id-contract3',
        'id-contractE',
        'id-package',
        'id-packageE',
        'id-rosObject-gsmSCF',
        'id-rosObject-gsmSSF',
        'id-rosObject-gsmSRF',
        'id-rosObject-gprsSSF',
        'id-rosObject-smsSSF-V3',
        'id-rosObject-smsSSF-V4',
        'id-ac-CAP-gsmSSF-scfGenericAC',
        'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        'id-ac-CAP-scf-gsmSSFGenericAC',
        'id-ac-gsmSRF-gsmSCF',
        'id-ac-CAP-gprsSSF-gsmSCF-AC',
        'id-ac-CAP-gsmSCF-gprsSSF-AC',
        'id-ac-cap3-sms-AC',
        'id-ac-cap4-sms-AC',
        'id-CAPSsfToScfGeneric',
        'id-CAPAssistHandoffssfToScf',
        'id-CAPScfToSsfGeneric',
        'id-contract-gsmSRF-gsmSCF',
        'id-capGprsSsfTogsmScf',
        'id-capGsmScfToGprsSsf',
        'id-cap3SmsSsfTogsmScf',
        'id-cap4SmsSsfTogsmScf',
        'id-package-scfActivation',
        'id-package-gsmSRF-scfActivationOfAssist',
        'id-package-assistConnectionEstablishment',
        'id-package-genericDisconnectResource',
        'id-package-nonAssistedConnectionEstablishment',
        'id-package-connect',
        'id-package-callHandling',
        'id-package-bcsmEventHandling',
        'id-package-ssfCallProcessing',
        'id-package-scfCallInitiation',
        'id-package-timer',
        'id-package-billing',
        'id-package-charging',
        'id-package-trafficManagement',
        'id-package-callReport',
        'id-package-signallingControl',
        'id-package-activityTest',
        'id-package-cancel',
        'id-package-cphResponse',
        'id-package-exceptionInform',
        'id-package-playTone',
        'id-package-specializedResourceControl',
        'id-package-gsmSRF-scfCancel',
        'id-package-gprsContinue',
        'id-package-gprsExceptionInformation',
        'id-package-gprsScfActivation',
        'id-package-gprsConnect',
        'id-package-gprsRelease',
        'id-package-gprsEventHandling',
        'id-package-gprsTimer',
        'id-package-gprsBilling',
        'id-package-gprsCharging',
        'id-package-gprsActivityTest',
        'id-package-gprsCancel',
        'id-package-gprsChargeAdvice',
        'id-package-smsActivation',
        'id-package-smsConnect',
        'id-package-smsContinue',
        'id-package-smsRelease',
        'id-package-smsEventHandling',
        'id-package-smsBilling',
        'id-package-smsTimer',
        'id-as-gsmSSF-scfGenericAS',
        'id-as-assistHandoff-gsmSSF-scfAS',
        'id-as-scf-gsmSSFGenericAS',
        'id-as-basic-gsmSRF-gsmSCF',
        'id-as-gprsSSF-gsmSCF-AS',
        'id-as-gsmSCF-gprsSSF-AS',
        'id-as-smsSSF-gsmSCF-AS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'tc-Messages',
        'tc-NotationExtensions',
        'ros-InformationObjects',
        'datatypes',
        'errortypes',
        'operationcodes',
        'errorcodes',
        'classes',
        'gsmSSF-gsmSCF-Operations',
        'gsmSSF-gsmSCF-Protocol',
        'gsmSCF-gsmSRF-Operations',
        'gsmSCF-gsmSRF-Protocol',
        'sms-Operations',
        'smsSSF-gsmSCF-Protocol',
        'gprsSSF-gsmSCF-Operations',
        'gprsSSF-gsmSCF-Protocol',
        'id-CAP',
        'id-CAP3',
        'id-CAPOE',
        'id-CAP3OE',
        'id-ac',
        'id-acE',
        'id-ac3E',
        'id-as',
        'id-asE',
        'id-rosObject',
        'id-contract',
        'id-contract3',
        'id-contractE',
        'id-package',
        'id-packageE',
        'id-rosObject-gsmSCF',
        'id-rosObject-gsmSSF',
        'id-rosObject-gsmSRF',
        'id-rosObject-gprsSSF',
        'id-rosObject-smsSSF-V3',
        'id-rosObject-smsSSF-V4',
        'id-ac-CAP-gsmSSF-scfGenericAC',
        'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        'id-ac-CAP-scf-gsmSSFGenericAC',
        'id-ac-gsmSRF-gsmSCF',
        'id-ac-CAP-gprsSSF-gsmSCF-AC',
        'id-ac-CAP-gsmSCF-gprsSSF-AC',
        'id-ac-cap3-sms-AC',
        'id-ac-cap4-sms-AC',
        'id-CAPSsfToScfGeneric',
        'id-CAPAssistHandoffssfToScf',
        'id-CAPScfToSsfGeneric',
        'id-contract-gsmSRF-gsmSCF',
        'id-capGprsSsfTogsmScf',
        'id-capGsmScfToGprsSsf',
        'id-cap3SmsSsfTogsmScf',
        'id-cap4SmsSsfTogsmScf',
        'id-package-scfActivation',
        'id-package-gsmSRF-scfActivationOfAssist',
        'id-package-assistConnectionEstablishment',
        'id-package-genericDisconnectResource',
        'id-package-nonAssistedConnectionEstablishment',
        'id-package-connect',
        'id-package-callHandling',
        'id-package-bcsmEventHandling',
        'id-package-ssfCallProcessing',
        'id-package-scfCallInitiation',
        'id-package-timer',
        'id-package-billing',
        'id-package-charging',
        'id-package-trafficManagement',
        'id-package-callReport',
        'id-package-signallingControl',
        'id-package-activityTest',
        'id-package-cancel',
        'id-package-cphResponse',
        'id-package-exceptionInform',
        'id-package-playTone',
        'id-package-specializedResourceControl',
        'id-package-gsmSRF-scfCancel',
        'id-package-gprsContinue',
        'id-package-gprsExceptionInformation',
        'id-package-gprsScfActivation',
        'id-package-gprsConnect',
        'id-package-gprsRelease',
        'id-package-gprsEventHandling',
        'id-package-gprsTimer',
        'id-package-gprsBilling',
        'id-package-gprsCharging',
        'id-package-gprsActivityTest',
        'id-package-gprsCancel',
        'id-package-gprsChargeAdvice',
        'id-package-smsActivation',
        'id-package-smsConnect',
        'id-package-smsContinue',
        'id-package-smsRelease',
        'id-package-smsEventHandling',
        'id-package-smsBilling',
        'id-package-smsTimer',
        'id-as-gsmSSF-scfGenericAS',
        'id-as-assistHandoff-gsmSSF-scfAS',
        'id-as-scf-gsmSSFGenericAS',
        'id-as-basic-gsmSRF-gsmSCF',
        'id-as-gprsSSF-gsmSCF-AS',
        'id-as-gsmSCF-gprsSSF-AS',
        'id-as-smsSSF-gsmSCF-AS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< tc-Messages >-----#
    tc_Messages = OID(name='tc-Messages', mode=MODE_VALUE)
    tc_Messages._val = (0, 0, 17, 773, 2, 1, 3)
    
    #-----< tc-NotationExtensions >-----#
    tc_NotationExtensions = OID(name='tc-NotationExtensions', mode=MODE_VALUE)
    tc_NotationExtensions._val = (0, 0, 17, 775, 2, 4, 1)
    
    #-----< ros-InformationObjects >-----#
    ros_InformationObjects = OID(name='ros-InformationObjects', mode=MODE_VALUE)
    ros_InformationObjects._val = (2, 4, 5, 0)
    
    #-----< datatypes >-----#
    datatypes = OID(name='datatypes', mode=MODE_VALUE)
    datatypes._val = (0, 4, 0, 0, 1, 3, 52, 7)
    
    #-----< errortypes >-----#
    errortypes = OID(name='errortypes', mode=MODE_VALUE)
    errortypes._val = (0, 4, 0, 0, 1, 3, 51, 7)
    
    #-----< operationcodes >-----#
    operationcodes = OID(name='operationcodes', mode=MODE_VALUE)
    operationcodes._val = (0, 4, 0, 0, 1, 3, 53, 7)
    
    #-----< errorcodes >-----#
    errorcodes = OID(name='errorcodes', mode=MODE_VALUE)
    errorcodes._val = (0, 4, 0, 0, 1, 3, 57, 7)
    
    #-----< classes >-----#
    classes = OID(name='classes', mode=MODE_VALUE)
    classes._val = (0, 4, 0, 0, 1, 3, 54, 7)
    
    #-----< gsmSSF-gsmSCF-Operations >-----#
    gsmSSF_gsmSCF_Operations = OID(name='gsmSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 101, 7)
    
    #-----< gsmSSF-gsmSCF-Protocol >-----#
    gsmSSF_gsmSCF_Protocol = OID(name='gsmSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 102, 7)
    
    #-----< gsmSCF-gsmSRF-Operations >-----#
    gsmSCF_gsmSRF_Operations = OID(name='gsmSCF-gsmSRF-Operations', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Operations._val = (0, 4, 0, 0, 1, 3, 103, 7)
    
    #-----< gsmSCF-gsmSRF-Protocol >-----#
    gsmSCF_gsmSRF_Protocol = OID(name='gsmSCF-gsmSRF-Protocol', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Protocol._val = (0, 4, 0, 0, 1, 3, 104, 7)
    
    #-----< sms-Operations >-----#
    sms_Operations = OID(name='sms-Operations', mode=MODE_VALUE)
    sms_Operations._val = (0, 4, 0, 0, 1, 3, 105, 7)
    
    #-----< smsSSF-gsmSCF-Protocol >-----#
    smsSSF_gsmSCF_Protocol = OID(name='smsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    smsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 106, 7)
    
    #-----< gprsSSF-gsmSCF-Operations >-----#
    gprsSSF_gsmSCF_Operations = OID(name='gprsSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 107, 7)
    
    #-----< gprsSSF-gsmSCF-Protocol >-----#
    gprsSSF_gsmSCF_Protocol = OID(name='gprsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 108, 7)
    
    #-----< id-CAP >-----#
    id_CAP = OID(name='id-CAP', mode=MODE_VALUE)
    id_CAP._val = (0, 4, 0, 0, 1, 22)
    
    #-----< id-CAP3 >-----#
    id_CAP3 = OID(name='id-CAP3', mode=MODE_VALUE)
    id_CAP3._val = (0, 4, 0, 0, 1, 20)
    
    #-----< id-CAPOE >-----#
    id_CAPOE = OID(name='id-CAPOE', mode=MODE_VALUE)
    id_CAPOE._val = (0, 4, 0, 0, 1, 23)
    
    #-----< id-CAP3OE >-----#
    id_CAP3OE = OID(name='id-CAP3OE', mode=MODE_VALUE)
    id_CAP3OE._val = (0, 4, 0, 0, 1, 21)
    
    #-----< id-ac >-----#
    id_ac = OID(name='id-ac', mode=MODE_VALUE)
    id_ac._val = (0, 4, 0, 0, 1, 22, 3)
    
    #-----< id-acE >-----#
    id_acE = OID(name='id-acE', mode=MODE_VALUE)
    id_acE._val = (0, 4, 0, 0, 1, 23, 3)
    
    #-----< id-ac3E >-----#
    id_ac3E = OID(name='id-ac3E', mode=MODE_VALUE)
    id_ac3E._val = (0, 4, 0, 0, 1, 21, 3)
    
    #-----< id-as >-----#
    id_as = OID(name='id-as', mode=MODE_VALUE)
    id_as._val = (0, 4, 0, 0, 1, 22, 5)
    
    #-----< id-asE >-----#
    id_asE = OID(name='id-asE', mode=MODE_VALUE)
    id_asE._val = (0, 4, 0, 0, 1, 23, 5)
    
    #-----< id-rosObject >-----#
    id_rosObject = OID(name='id-rosObject', mode=MODE_VALUE)
    id_rosObject._val = (0, 4, 0, 0, 1, 22, 25)
    
    #-----< id-contract >-----#
    id_contract = OID(name='id-contract', mode=MODE_VALUE)
    id_contract._val = (0, 4, 0, 0, 1, 22, 26)
    
    #-----< id-contract3 >-----#
    id_contract3 = OID(name='id-contract3', mode=MODE_VALUE)
    id_contract3._val = (0, 4, 0, 0, 1, 20, 26)
    
    #-----< id-contractE >-----#
    id_contractE = OID(name='id-contractE', mode=MODE_VALUE)
    id_contractE._val = (0, 4, 0, 0, 1, 23, 26)
    
    #-----< id-package >-----#
    id_package = OID(name='id-package', mode=MODE_VALUE)
    id_package._val = (0, 4, 0, 0, 1, 22, 27)
    
    #-----< id-packageE >-----#
    id_packageE = OID(name='id-packageE', mode=MODE_VALUE)
    id_packageE._val = (0, 4, 0, 0, 1, 23, 27)
    
    #-----< id-rosObject-gsmSCF >-----#
    id_rosObject_gsmSCF = OID(name='id-rosObject-gsmSCF', mode=MODE_VALUE)
    id_rosObject_gsmSCF._val = (0, 4, 0, 0, 1, 22, 25, 4)
    
    #-----< id-rosObject-gsmSSF >-----#
    id_rosObject_gsmSSF = OID(name='id-rosObject-gsmSSF', mode=MODE_VALUE)
    id_rosObject_gsmSSF._val = (0, 4, 0, 0, 1, 22, 25, 5)
    
    #-----< id-rosObject-gsmSRF >-----#
    id_rosObject_gsmSRF = OID(name='id-rosObject-gsmSRF', mode=MODE_VALUE)
    id_rosObject_gsmSRF._val = (0, 4, 0, 0, 1, 22, 25, 6)
    
    #-----< id-rosObject-gprsSSF >-----#
    id_rosObject_gprsSSF = OID(name='id-rosObject-gprsSSF', mode=MODE_VALUE)
    id_rosObject_gprsSSF._val = (0, 4, 0, 0, 1, 22, 25, 7)
    
    #-----< id-rosObject-smsSSF-V3 >-----#
    id_rosObject_smsSSF_V3 = OID(name='id-rosObject-smsSSF-V3', mode=MODE_VALUE)
    id_rosObject_smsSSF_V3._val = (0, 4, 0, 0, 1, 22, 25, 8)
    
    #-----< id-rosObject-smsSSF-V4 >-----#
    id_rosObject_smsSSF_V4 = OID(name='id-rosObject-smsSSF-V4', mode=MODE_VALUE)
    id_rosObject_smsSSF_V4._val = (0, 4, 0, 0, 1, 22, 25, 9)
    
    #-----< id-ac-CAP-gsmSSF-scfGenericAC >-----#
    id_ac_CAP_gsmSSF_scfGenericAC = OID(name='id-ac-CAP-gsmSSF-scfGenericAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 4)
    
    #-----< id-ac-CAP-gsmSSF-scfAssistHandoffAC >-----#
    id_ac_CAP_gsmSSF_scfAssistHandoffAC = OID(name='id-ac-CAP-gsmSSF-scfAssistHandoffAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfAssistHandoffAC._val = (0, 4, 0, 0, 1, 23, 3, 6)
    
    #-----< id-ac-CAP-scf-gsmSSFGenericAC >-----#
    id_ac_CAP_scf_gsmSSFGenericAC = OID(name='id-ac-CAP-scf-gsmSSFGenericAC', mode=MODE_VALUE)
    id_ac_CAP_scf_gsmSSFGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 8)
    
    #-----< id-ac-gsmSRF-gsmSCF >-----#
    id_ac_gsmSRF_gsmSCF = OID(name='id-ac-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_ac_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 3, 14)
    
    #-----< id-ac-CAP-gprsSSF-gsmSCF-AC >-----#
    id_ac_CAP_gprsSSF_gsmSCF_AC = OID(name='id-ac-CAP-gprsSSF-gsmSCF-AC', mode=MODE_VALUE)
    id_ac_CAP_gprsSSF_gsmSCF_AC._val = (0, 4, 0, 0, 1, 21, 3, 50)
    
    #-----< id-ac-CAP-gsmSCF-gprsSSF-AC >-----#
    id_ac_CAP_gsmSCF_gprsSSF_AC = OID(name='id-ac-CAP-gsmSCF-gprsSSF-AC', mode=MODE_VALUE)
    id_ac_CAP_gsmSCF_gprsSSF_AC._val = (0, 4, 0, 0, 1, 21, 3, 51)
    
    #-----< id-ac-cap3-sms-AC >-----#
    id_ac_cap3_sms_AC = OID(name='id-ac-cap3-sms-AC', mode=MODE_VALUE)
    id_ac_cap3_sms_AC._val = (0, 4, 0, 0, 1, 21, 3, 61)
    
    #-----< id-ac-cap4-sms-AC >-----#
    id_ac_cap4_sms_AC = OID(name='id-ac-cap4-sms-AC', mode=MODE_VALUE)
    id_ac_cap4_sms_AC._val = (0, 4, 0, 0, 1, 23, 3, 61)
    
    #-----< id-CAPSsfToScfGeneric >-----#
    id_CAPSsfToScfGeneric = OID(name='id-CAPSsfToScfGeneric', mode=MODE_VALUE)
    id_CAPSsfToScfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 3)
    
    #-----< id-CAPAssistHandoffssfToScf >-----#
    id_CAPAssistHandoffssfToScf = OID(name='id-CAPAssistHandoffssfToScf', mode=MODE_VALUE)
    id_CAPAssistHandoffssfToScf._val = (0, 4, 0, 0, 1, 23, 26, 5)
    
    #-----< id-CAPScfToSsfGeneric >-----#
    id_CAPScfToSsfGeneric = OID(name='id-CAPScfToSsfGeneric', mode=MODE_VALUE)
    id_CAPScfToSsfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 6)
    
    #-----< id-contract-gsmSRF-gsmSCF >-----#
    id_contract_gsmSRF_gsmSCF = OID(name='id-contract-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_contract_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 26, 13)
    
    #-----< id-capGprsSsfTogsmScf >-----#
    id_capGprsSsfTogsmScf = OID(name='id-capGprsSsfTogsmScf', mode=MODE_VALUE)
    id_capGprsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 14)
    
    #-----< id-capGsmScfToGprsSsf >-----#
    id_capGsmScfToGprsSsf = OID(name='id-capGsmScfToGprsSsf', mode=MODE_VALUE)
    id_capGsmScfToGprsSsf._val = (0, 4, 0, 0, 1, 22, 26, 15)
    
    #-----< id-cap3SmsSsfTogsmScf >-----#
    id_cap3SmsSsfTogsmScf = OID(name='id-cap3SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap3SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 20, 26, 16)
    
    #-----< id-cap4SmsSsfTogsmScf >-----#
    id_cap4SmsSsfTogsmScf = OID(name='id-cap4SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap4SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 16)
    
    #-----< id-package-scfActivation >-----#
    id_package_scfActivation = OID(name='id-package-scfActivation', mode=MODE_VALUE)
    id_package_scfActivation._val = (0, 4, 0, 0, 1, 22, 27, 11)
    
    #-----< id-package-gsmSRF-scfActivationOfAssist >-----#
    id_package_gsmSRF_scfActivationOfAssist = OID(name='id-package-gsmSRF-scfActivationOfAssist', mode=MODE_VALUE)
    id_package_gsmSRF_scfActivationOfAssist._val = (0, 4, 0, 0, 1, 22, 27, 15)
    
    #-----< id-package-assistConnectionEstablishment >-----#
    id_package_assistConnectionEstablishment = OID(name='id-package-assistConnectionEstablishment', mode=MODE_VALUE)
    id_package_assistConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 16)
    
    #-----< id-package-genericDisconnectResource >-----#
    id_package_genericDisconnectResource = OID(name='id-package-genericDisconnectResource', mode=MODE_VALUE)
    id_package_genericDisconnectResource._val = (0, 4, 0, 0, 1, 22, 27, 17)
    
    #-----< id-package-nonAssistedConnectionEstablishment >-----#
    id_package_nonAssistedConnectionEstablishment = OID(name='id-package-nonAssistedConnectionEstablishment', mode=MODE_VALUE)
    id_package_nonAssistedConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 18)
    
    #-----< id-package-connect >-----#
    id_package_connect = OID(name='id-package-connect', mode=MODE_VALUE)
    id_package_connect._val = (0, 4, 0, 0, 1, 22, 27, 19)
    
    #-----< id-package-callHandling >-----#
    id_package_callHandling = OID(name='id-package-callHandling', mode=MODE_VALUE)
    id_package_callHandling._val = (0, 4, 0, 0, 1, 23, 27, 20)
    
    #-----< id-package-bcsmEventHandling >-----#
    id_package_bcsmEventHandling = OID(name='id-package-bcsmEventHandling', mode=MODE_VALUE)
    id_package_bcsmEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 21)
    
    #-----< id-package-ssfCallProcessing >-----#
    id_package_ssfCallProcessing = OID(name='id-package-ssfCallProcessing', mode=MODE_VALUE)
    id_package_ssfCallProcessing._val = (0, 4, 0, 0, 1, 23, 27, 24)
    
    #-----< id-package-scfCallInitiation >-----#
    id_package_scfCallInitiation = OID(name='id-package-scfCallInitiation', mode=MODE_VALUE)
    id_package_scfCallInitiation._val = (0, 4, 0, 0, 1, 22, 27, 25)
    
    #-----< id-package-timer >-----#
    id_package_timer = OID(name='id-package-timer', mode=MODE_VALUE)
    id_package_timer._val = (0, 4, 0, 0, 1, 22, 27, 26)
    
    #-----< id-package-billing >-----#
    id_package_billing = OID(name='id-package-billing', mode=MODE_VALUE)
    id_package_billing._val = (0, 4, 0, 0, 1, 22, 27, 27)
    
    #-----< id-package-charging >-----#
    id_package_charging = OID(name='id-package-charging', mode=MODE_VALUE)
    id_package_charging._val = (0, 4, 0, 0, 1, 22, 27, 28)
    
    #-----< id-package-trafficManagement >-----#
    id_package_trafficManagement = OID(name='id-package-trafficManagement', mode=MODE_VALUE)
    id_package_trafficManagement._val = (0, 4, 0, 0, 1, 22, 27, 29)
    
    #-----< id-package-callReport >-----#
    id_package_callReport = OID(name='id-package-callReport', mode=MODE_VALUE)
    id_package_callReport._val = (0, 4, 0, 0, 1, 22, 27, 32)
    
    #-----< id-package-signallingControl >-----#
    id_package_signallingControl = OID(name='id-package-signallingControl', mode=MODE_VALUE)
    id_package_signallingControl._val = (0, 4, 0, 0, 1, 22, 27, 33)
    
    #-----< id-package-activityTest >-----#
    id_package_activityTest = OID(name='id-package-activityTest', mode=MODE_VALUE)
    id_package_activityTest._val = (0, 4, 0, 0, 1, 22, 27, 34)
    
    #-----< id-package-cancel >-----#
    id_package_cancel = OID(name='id-package-cancel', mode=MODE_VALUE)
    id_package_cancel._val = (0, 4, 0, 0, 1, 23, 27, 36)
    
    #-----< id-package-cphResponse >-----#
    id_package_cphResponse = OID(name='id-package-cphResponse', mode=MODE_VALUE)
    id_package_cphResponse._val = (0, 4, 0, 0, 1, 22, 27, 37)
    
    #-----< id-package-exceptionInform >-----#
    id_package_exceptionInform = OID(name='id-package-exceptionInform', mode=MODE_VALUE)
    id_package_exceptionInform._val = (0, 4, 0, 0, 1, 22, 27, 38)
    
    #-----< id-package-playTone >-----#
    id_package_playTone = OID(name='id-package-playTone', mode=MODE_VALUE)
    id_package_playTone._val = (0, 4, 0, 0, 1, 22, 27, 39)
    
    #-----< id-package-specializedResourceControl >-----#
    id_package_specializedResourceControl = OID(name='id-package-specializedResourceControl', mode=MODE_VALUE)
    id_package_specializedResourceControl._val = (0, 4, 0, 0, 1, 22, 27, 42)
    
    #-----< id-package-gsmSRF-scfCancel >-----#
    id_package_gsmSRF_scfCancel = OID(name='id-package-gsmSRF-scfCancel', mode=MODE_VALUE)
    id_package_gsmSRF_scfCancel._val = (0, 4, 0, 0, 1, 22, 27, 43)
    
    #-----< id-package-gprsContinue >-----#
    id_package_gprsContinue = OID(name='id-package-gprsContinue', mode=MODE_VALUE)
    id_package_gprsContinue._val = (0, 4, 0, 0, 1, 22, 27, 49)
    
    #-----< id-package-gprsExceptionInformation >-----#
    id_package_gprsExceptionInformation = OID(name='id-package-gprsExceptionInformation', mode=MODE_VALUE)
    id_package_gprsExceptionInformation._val = (0, 4, 0, 0, 1, 22, 27, 50)
    
    #-----< id-package-gprsScfActivation >-----#
    id_package_gprsScfActivation = OID(name='id-package-gprsScfActivation', mode=MODE_VALUE)
    id_package_gprsScfActivation._val = (0, 4, 0, 0, 1, 22, 27, 51)
    
    #-----< id-package-gprsConnect >-----#
    id_package_gprsConnect = OID(name='id-package-gprsConnect', mode=MODE_VALUE)
    id_package_gprsConnect._val = (0, 4, 0, 0, 1, 22, 27, 52)
    
    #-----< id-package-gprsRelease >-----#
    id_package_gprsRelease = OID(name='id-package-gprsRelease', mode=MODE_VALUE)
    id_package_gprsRelease._val = (0, 4, 0, 0, 1, 22, 27, 53)
    
    #-----< id-package-gprsEventHandling >-----#
    id_package_gprsEventHandling = OID(name='id-package-gprsEventHandling', mode=MODE_VALUE)
    id_package_gprsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 54)
    
    #-----< id-package-gprsTimer >-----#
    id_package_gprsTimer = OID(name='id-package-gprsTimer', mode=MODE_VALUE)
    id_package_gprsTimer._val = (0, 4, 0, 0, 1, 22, 27, 55)
    
    #-----< id-package-gprsBilling >-----#
    id_package_gprsBilling = OID(name='id-package-gprsBilling', mode=MODE_VALUE)
    id_package_gprsBilling._val = (0, 4, 0, 0, 1, 22, 27, 56)
    
    #-----< id-package-gprsCharging >-----#
    id_package_gprsCharging = OID(name='id-package-gprsCharging', mode=MODE_VALUE)
    id_package_gprsCharging._val = (0, 4, 0, 0, 1, 22, 27, 57)
    
    #-----< id-package-gprsActivityTest >-----#
    id_package_gprsActivityTest = OID(name='id-package-gprsActivityTest', mode=MODE_VALUE)
    id_package_gprsActivityTest._val = (0, 4, 0, 0, 1, 22, 27, 58)
    
    #-----< id-package-gprsCancel >-----#
    id_package_gprsCancel = OID(name='id-package-gprsCancel', mode=MODE_VALUE)
    id_package_gprsCancel._val = (0, 4, 0, 0, 1, 22, 27, 59)
    
    #-----< id-package-gprsChargeAdvice >-----#
    id_package_gprsChargeAdvice = OID(name='id-package-gprsChargeAdvice', mode=MODE_VALUE)
    id_package_gprsChargeAdvice._val = (0, 4, 0, 0, 1, 22, 27, 60)
    
    #-----< id-package-smsActivation >-----#
    id_package_smsActivation = OID(name='id-package-smsActivation', mode=MODE_VALUE)
    id_package_smsActivation._val = (0, 4, 0, 0, 1, 22, 27, 61)
    
    #-----< id-package-smsConnect >-----#
    id_package_smsConnect = OID(name='id-package-smsConnect', mode=MODE_VALUE)
    id_package_smsConnect._val = (0, 4, 0, 0, 1, 22, 27, 62)
    
    #-----< id-package-smsContinue >-----#
    id_package_smsContinue = OID(name='id-package-smsContinue', mode=MODE_VALUE)
    id_package_smsContinue._val = (0, 4, 0, 0, 1, 22, 27, 63)
    
    #-----< id-package-smsRelease >-----#
    id_package_smsRelease = OID(name='id-package-smsRelease', mode=MODE_VALUE)
    id_package_smsRelease._val = (0, 4, 0, 0, 1, 22, 27, 64)
    
    #-----< id-package-smsEventHandling >-----#
    id_package_smsEventHandling = OID(name='id-package-smsEventHandling', mode=MODE_VALUE)
    id_package_smsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 65)
    
    #-----< id-package-smsBilling >-----#
    id_package_smsBilling = OID(name='id-package-smsBilling', mode=MODE_VALUE)
    id_package_smsBilling._val = (0, 4, 0, 0, 1, 22, 27, 66)
    
    #-----< id-package-smsTimer >-----#
    id_package_smsTimer = OID(name='id-package-smsTimer', mode=MODE_VALUE)
    id_package_smsTimer._val = (0, 4, 0, 0, 1, 22, 27, 67)
    
    #-----< id-as-gsmSSF-scfGenericAS >-----#
    id_as_gsmSSF_scfGenericAS = OID(name='id-as-gsmSSF-scfGenericAS', mode=MODE_VALUE)
    id_as_gsmSSF_scfGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 4)
    
    #-----< id-as-assistHandoff-gsmSSF-scfAS >-----#
    id_as_assistHandoff_gsmSSF_scfAS = OID(name='id-as-assistHandoff-gsmSSF-scfAS', mode=MODE_VALUE)
    id_as_assistHandoff_gsmSSF_scfAS._val = (0, 4, 0, 0, 1, 23, 5, 6)
    
    #-----< id-as-scf-gsmSSFGenericAS >-----#
    id_as_scf_gsmSSFGenericAS = OID(name='id-as-scf-gsmSSFGenericAS', mode=MODE_VALUE)
    id_as_scf_gsmSSFGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 7)
    
    #-----< id-as-basic-gsmSRF-gsmSCF >-----#
    id_as_basic_gsmSRF_gsmSCF = OID(name='id-as-basic-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_as_basic_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 5, 14)
    
    #-----< id-as-gprsSSF-gsmSCF-AS >-----#
    id_as_gprsSSF_gsmSCF_AS = OID(name='id-as-gprsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_gprsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 50)
    
    #-----< id-as-gsmSCF-gprsSSF-AS >-----#
    id_as_gsmSCF_gprsSSF_AS = OID(name='id-as-gsmSCF-gprsSSF-AS', mode=MODE_VALUE)
    id_as_gsmSCF_gprsSSF_AS._val = (0, 4, 0, 0, 1, 22, 5, 51)
    
    #-----< id-as-smsSSF-gsmSCF-AS >-----#
    id_as_smsSSF_gsmSCF_AS = OID(name='id-as-smsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_smsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 61)
    
    _all_ = [
        tc_Messages,
        tc_NotationExtensions,
        ros_InformationObjects,
        datatypes,
        errortypes,
        operationcodes,
        errorcodes,
        classes,
        gsmSSF_gsmSCF_Operations,
        gsmSSF_gsmSCF_Protocol,
        gsmSCF_gsmSRF_Operations,
        gsmSCF_gsmSRF_Protocol,
        sms_Operations,
        smsSSF_gsmSCF_Protocol,
        gprsSSF_gsmSCF_Operations,
        gprsSSF_gsmSCF_Protocol,
        id_CAP,
        id_CAP3,
        id_CAPOE,
        id_CAP3OE,
        id_ac,
        id_acE,
        id_ac3E,
        id_as,
        id_asE,
        id_rosObject,
        id_contract,
        id_contract3,
        id_contractE,
        id_package,
        id_packageE,
        id_rosObject_gsmSCF,
        id_rosObject_gsmSSF,
        id_rosObject_gsmSRF,
        id_rosObject_gprsSSF,
        id_rosObject_smsSSF_V3,
        id_rosObject_smsSSF_V4,
        id_ac_CAP_gsmSSF_scfGenericAC,
        id_ac_CAP_gsmSSF_scfAssistHandoffAC,
        id_ac_CAP_scf_gsmSSFGenericAC,
        id_ac_gsmSRF_gsmSCF,
        id_ac_CAP_gprsSSF_gsmSCF_AC,
        id_ac_CAP_gsmSCF_gprsSSF_AC,
        id_ac_cap3_sms_AC,
        id_ac_cap4_sms_AC,
        id_CAPSsfToScfGeneric,
        id_CAPAssistHandoffssfToScf,
        id_CAPScfToSsfGeneric,
        id_contract_gsmSRF_gsmSCF,
        id_capGprsSsfTogsmScf,
        id_capGsmScfToGprsSsf,
        id_cap3SmsSsfTogsmScf,
        id_cap4SmsSsfTogsmScf,
        id_package_scfActivation,
        id_package_gsmSRF_scfActivationOfAssist,
        id_package_assistConnectionEstablishment,
        id_package_genericDisconnectResource,
        id_package_nonAssistedConnectionEstablishment,
        id_package_connect,
        id_package_callHandling,
        id_package_bcsmEventHandling,
        id_package_ssfCallProcessing,
        id_package_scfCallInitiation,
        id_package_timer,
        id_package_billing,
        id_package_charging,
        id_package_trafficManagement,
        id_package_callReport,
        id_package_signallingControl,
        id_package_activityTest,
        id_package_cancel,
        id_package_cphResponse,
        id_package_exceptionInform,
        id_package_playTone,
        id_package_specializedResourceControl,
        id_package_gsmSRF_scfCancel,
        id_package_gprsContinue,
        id_package_gprsExceptionInformation,
        id_package_gprsScfActivation,
        id_package_gprsConnect,
        id_package_gprsRelease,
        id_package_gprsEventHandling,
        id_package_gprsTimer,
        id_package_gprsBilling,
        id_package_gprsCharging,
        id_package_gprsActivityTest,
        id_package_gprsCancel,
        id_package_gprsChargeAdvice,
        id_package_smsActivation,
        id_package_smsConnect,
        id_package_smsContinue,
        id_package_smsRelease,
        id_package_smsEventHandling,
        id_package_smsBilling,
        id_package_smsTimer,
        id_as_gsmSSF_scfGenericAS,
        id_as_assistHandoff_gsmSSF_scfAS,
        id_as_scf_gsmSSFGenericAS,
        id_as_basic_gsmSRF_gsmSCF,
        id_as_gprsSSF_gsmSCF_AS,
        id_as_gsmSCF_gprsSSF_AS,
        id_as_smsSSF_gsmSCF_AS,
    ]

class CAP_operationcodes:

    _name_  = 'CAP-operationcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 53, 7]
    
    _obj_ = [
        'opcode-initialDP',
        'opcode-assistRequestInstructions',
        'opcode-establishTemporaryConnection',
        'opcode-disconnectForwardConnection',
        'opcode-dFCWithArgument',
        'opcode-connectToResource',
        'opcode-connect',
        'opcode-releaseCall',
        'opcode-requestReportBCSMEvent',
        'opcode-eventReportBCSM',
        'opcode-collectInformation',
        'opcode-continue',
        'opcode-initiateCallAttempt',
        'opcode-resetTimer',
        'opcode-furnishChargingInformation',
        'opcode-applyCharging',
        'opcode-applyChargingReport',
        'opcode-callGap',
        'opcode-callInformationReport',
        'opcode-callInformationRequest',
        'opcode-sendChargingInformation',
        'opcode-playAnnouncement',
        'opcode-promptAndCollectUserInformation',
        'opcode-specializedResourceReport',
        'opcode-cancel',
        'opcode-activityTest',
        'opcode-continueWithArgument',
        'opcode-disconnectLeg',
        'opcode-moveLeg',
        'opcode-splitLeg',
        'opcode-entityReleased',
        'opcode-playTone',
        'opcode-initialDPSMS',
        'opcode-furnishChargingInformationSMS',
        'opcode-connectSMS',
        'opcode-requestReportSMSEvent',
        'opcode-eventReportSMS',
        'opcode-continueSMS',
        'opcode-releaseSMS',
        'opcode-resetTimerSMS',
        'opcode-activityTestGPRS',
        'opcode-applyChargingGPRS',
        'opcode-applyChargingReportGPRS',
        'opcode-cancelGPRS',
        'opcode-connectGPRS',
        'opcode-continueGPRS',
        'opcode-entityReleasedGPRS',
        'opcode-furnishChargingInformationGPRS',
        'opcode-initialDPGPRS',
        'opcode-releaseGPRS',
        'opcode-eventReportGPRS',
        'opcode-requestReportGPRSEvent',
        'opcode-resetTimerGPRS',
        'opcode-sendChargingInformationGPRS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'opcode-initialDP',
        'opcode-assistRequestInstructions',
        'opcode-establishTemporaryConnection',
        'opcode-disconnectForwardConnection',
        'opcode-dFCWithArgument',
        'opcode-connectToResource',
        'opcode-connect',
        'opcode-releaseCall',
        'opcode-requestReportBCSMEvent',
        'opcode-eventReportBCSM',
        'opcode-collectInformation',
        'opcode-continue',
        'opcode-initiateCallAttempt',
        'opcode-resetTimer',
        'opcode-furnishChargingInformation',
        'opcode-applyCharging',
        'opcode-applyChargingReport',
        'opcode-callGap',
        'opcode-callInformationReport',
        'opcode-callInformationRequest',
        'opcode-sendChargingInformation',
        'opcode-playAnnouncement',
        'opcode-promptAndCollectUserInformation',
        'opcode-specializedResourceReport',
        'opcode-cancel',
        'opcode-activityTest',
        'opcode-continueWithArgument',
        'opcode-disconnectLeg',
        'opcode-moveLeg',
        'opcode-splitLeg',
        'opcode-entityReleased',
        'opcode-playTone',
        'opcode-initialDPSMS',
        'opcode-furnishChargingInformationSMS',
        'opcode-connectSMS',
        'opcode-requestReportSMSEvent',
        'opcode-eventReportSMS',
        'opcode-continueSMS',
        'opcode-releaseSMS',
        'opcode-resetTimerSMS',
        'opcode-activityTestGPRS',
        'opcode-applyChargingGPRS',
        'opcode-applyChargingReportGPRS',
        'opcode-cancelGPRS',
        'opcode-connectGPRS',
        'opcode-continueGPRS',
        'opcode-entityReleasedGPRS',
        'opcode-furnishChargingInformationGPRS',
        'opcode-initialDPGPRS',
        'opcode-releaseGPRS',
        'opcode-eventReportGPRS',
        'opcode-requestReportGPRSEvent',
        'opcode-resetTimerGPRS',
        'opcode-sendChargingInformationGPRS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< opcode-initialDP >-----#
    opcode_initialDP = CHOICE(name='opcode-initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDP._val = ('local', 0)
    
    #-----< opcode-assistRequestInstructions >-----#
    opcode_assistRequestInstructions = CHOICE(name='opcode-assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_assistRequestInstructions._val = ('local', 16)
    
    #-----< opcode-establishTemporaryConnection >-----#
    opcode_establishTemporaryConnection = CHOICE(name='opcode-establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_establishTemporaryConnection._val = ('local', 17)
    
    #-----< opcode-disconnectForwardConnection >-----#
    opcode_disconnectForwardConnection = CHOICE(name='opcode-disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectForwardConnection._val = ('local', 18)
    
    #-----< opcode-dFCWithArgument >-----#
    opcode_dFCWithArgument = CHOICE(name='opcode-dFCWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_dFCWithArgument._val = ('local', 86)
    
    #-----< opcode-connectToResource >-----#
    opcode_connectToResource = CHOICE(name='opcode-connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectToResource._val = ('local', 19)
    
    #-----< opcode-connect >-----#
    opcode_connect = CHOICE(name='opcode-connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connect._val = ('local', 20)
    
    #-----< opcode-releaseCall >-----#
    opcode_releaseCall = CHOICE(name='opcode-releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseCall._val = ('local', 22)
    
    #-----< opcode-requestReportBCSMEvent >-----#
    opcode_requestReportBCSMEvent = CHOICE(name='opcode-requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportBCSMEvent._val = ('local', 23)
    
    #-----< opcode-eventReportBCSM >-----#
    opcode_eventReportBCSM = CHOICE(name='opcode-eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportBCSM._val = ('local', 24)
    
    #-----< opcode-collectInformation >-----#
    opcode_collectInformation = CHOICE(name='opcode-collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_collectInformation._val = ('local', 27)
    
    #-----< opcode-continue >-----#
    opcode_continue = CHOICE(name='opcode-continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continue._val = ('local', 31)
    
    #-----< opcode-initiateCallAttempt >-----#
    opcode_initiateCallAttempt = CHOICE(name='opcode-initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initiateCallAttempt._val = ('local', 32)
    
    #-----< opcode-resetTimer >-----#
    opcode_resetTimer = CHOICE(name='opcode-resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimer._val = ('local', 33)
    
    #-----< opcode-furnishChargingInformation >-----#
    opcode_furnishChargingInformation = CHOICE(name='opcode-furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformation._val = ('local', 34)
    
    #-----< opcode-applyCharging >-----#
    opcode_applyCharging = CHOICE(name='opcode-applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyCharging._val = ('local', 35)
    
    #-----< opcode-applyChargingReport >-----#
    opcode_applyChargingReport = CHOICE(name='opcode-applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReport._val = ('local', 36)
    
    #-----< opcode-callGap >-----#
    opcode_callGap = CHOICE(name='opcode-callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callGap._val = ('local', 41)
    
    #-----< opcode-callInformationReport >-----#
    opcode_callInformationReport = CHOICE(name='opcode-callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationReport._val = ('local', 44)
    
    #-----< opcode-callInformationRequest >-----#
    opcode_callInformationRequest = CHOICE(name='opcode-callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationRequest._val = ('local', 45)
    
    #-----< opcode-sendChargingInformation >-----#
    opcode_sendChargingInformation = CHOICE(name='opcode-sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformation._val = ('local', 46)
    
    #-----< opcode-playAnnouncement >-----#
    opcode_playAnnouncement = CHOICE(name='opcode-playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playAnnouncement._val = ('local', 47)
    
    #-----< opcode-promptAndCollectUserInformation >-----#
    opcode_promptAndCollectUserInformation = CHOICE(name='opcode-promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_promptAndCollectUserInformation._val = ('local', 48)
    
    #-----< opcode-specializedResourceReport >-----#
    opcode_specializedResourceReport = CHOICE(name='opcode-specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_specializedResourceReport._val = ('local', 49)
    
    #-----< opcode-cancel >-----#
    opcode_cancel = CHOICE(name='opcode-cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancel._val = ('local', 53)
    
    #-----< opcode-activityTest >-----#
    opcode_activityTest = CHOICE(name='opcode-activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTest._val = ('local', 55)
    
    #-----< opcode-continueWithArgument >-----#
    opcode_continueWithArgument = CHOICE(name='opcode-continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueWithArgument._val = ('local', 88)
    
    #-----< opcode-disconnectLeg >-----#
    opcode_disconnectLeg = CHOICE(name='opcode-disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectLeg._val = ('local', 90)
    
    #-----< opcode-moveLeg >-----#
    opcode_moveLeg = CHOICE(name='opcode-moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_moveLeg._val = ('local', 93)
    
    #-----< opcode-splitLeg >-----#
    opcode_splitLeg = CHOICE(name='opcode-splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_splitLeg._val = ('local', 95)
    
    #-----< opcode-entityReleased >-----#
    opcode_entityReleased = CHOICE(name='opcode-entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleased._val = ('local', 96)
    
    #-----< opcode-playTone >-----#
    opcode_playTone = CHOICE(name='opcode-playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playTone._val = ('local', 97)
    
    #-----< opcode-initialDPSMS >-----#
    opcode_initialDPSMS = CHOICE(name='opcode-initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPSMS._val = ('local', 60)
    
    #-----< opcode-furnishChargingInformationSMS >-----#
    opcode_furnishChargingInformationSMS = CHOICE(name='opcode-furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationSMS._val = ('local', 61)
    
    #-----< opcode-connectSMS >-----#
    opcode_connectSMS = CHOICE(name='opcode-connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectSMS._val = ('local', 62)
    
    #-----< opcode-requestReportSMSEvent >-----#
    opcode_requestReportSMSEvent = CHOICE(name='opcode-requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportSMSEvent._val = ('local', 63)
    
    #-----< opcode-eventReportSMS >-----#
    opcode_eventReportSMS = CHOICE(name='opcode-eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportSMS._val = ('local', 64)
    
    #-----< opcode-continueSMS >-----#
    opcode_continueSMS = CHOICE(name='opcode-continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueSMS._val = ('local', 65)
    
    #-----< opcode-releaseSMS >-----#
    opcode_releaseSMS = CHOICE(name='opcode-releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseSMS._val = ('local', 66)
    
    #-----< opcode-resetTimerSMS >-----#
    opcode_resetTimerSMS = CHOICE(name='opcode-resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerSMS._val = ('local', 67)
    
    #-----< opcode-activityTestGPRS >-----#
    opcode_activityTestGPRS = CHOICE(name='opcode-activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTestGPRS._val = ('local', 70)
    
    #-----< opcode-applyChargingGPRS >-----#
    opcode_applyChargingGPRS = CHOICE(name='opcode-applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingGPRS._val = ('local', 71)
    
    #-----< opcode-applyChargingReportGPRS >-----#
    opcode_applyChargingReportGPRS = CHOICE(name='opcode-applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReportGPRS._val = ('local', 72)
    
    #-----< opcode-cancelGPRS >-----#
    opcode_cancelGPRS = CHOICE(name='opcode-cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancelGPRS._val = ('local', 73)
    
    #-----< opcode-connectGPRS >-----#
    opcode_connectGPRS = CHOICE(name='opcode-connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectGPRS._val = ('local', 74)
    
    #-----< opcode-continueGPRS >-----#
    opcode_continueGPRS = CHOICE(name='opcode-continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueGPRS._val = ('local', 75)
    
    #-----< opcode-entityReleasedGPRS >-----#
    opcode_entityReleasedGPRS = CHOICE(name='opcode-entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleasedGPRS._val = ('local', 76)
    
    #-----< opcode-furnishChargingInformationGPRS >-----#
    opcode_furnishChargingInformationGPRS = CHOICE(name='opcode-furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationGPRS._val = ('local', 77)
    
    #-----< opcode-initialDPGPRS >-----#
    opcode_initialDPGPRS = CHOICE(name='opcode-initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPGPRS._val = ('local', 78)
    
    #-----< opcode-releaseGPRS >-----#
    opcode_releaseGPRS = CHOICE(name='opcode-releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseGPRS._val = ('local', 79)
    
    #-----< opcode-eventReportGPRS >-----#
    opcode_eventReportGPRS = CHOICE(name='opcode-eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportGPRS._val = ('local', 80)
    
    #-----< opcode-requestReportGPRSEvent >-----#
    opcode_requestReportGPRSEvent = CHOICE(name='opcode-requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportGPRSEvent._val = ('local', 81)
    
    #-----< opcode-resetTimerGPRS >-----#
    opcode_resetTimerGPRS = CHOICE(name='opcode-resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerGPRS._val = ('local', 82)
    
    #-----< opcode-sendChargingInformationGPRS >-----#
    opcode_sendChargingInformationGPRS = CHOICE(name='opcode-sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformationGPRS._val = ('local', 83)
    
    _all_ = [
        opcode_initialDP,
        opcode_assistRequestInstructions,
        opcode_establishTemporaryConnection,
        opcode_disconnectForwardConnection,
        opcode_dFCWithArgument,
        opcode_connectToResource,
        opcode_connect,
        opcode_releaseCall,
        opcode_requestReportBCSMEvent,
        opcode_eventReportBCSM,
        opcode_collectInformation,
        opcode_continue,
        opcode_initiateCallAttempt,
        opcode_resetTimer,
        opcode_furnishChargingInformation,
        opcode_applyCharging,
        opcode_applyChargingReport,
        opcode_callGap,
        opcode_callInformationReport,
        opcode_callInformationRequest,
        opcode_sendChargingInformation,
        opcode_playAnnouncement,
        opcode_promptAndCollectUserInformation,
        opcode_specializedResourceReport,
        opcode_cancel,
        opcode_activityTest,
        opcode_continueWithArgument,
        opcode_disconnectLeg,
        opcode_moveLeg,
        opcode_splitLeg,
        opcode_entityReleased,
        opcode_playTone,
        opcode_initialDPSMS,
        opcode_furnishChargingInformationSMS,
        opcode_connectSMS,
        opcode_requestReportSMSEvent,
        opcode_eventReportSMS,
        opcode_continueSMS,
        opcode_releaseSMS,
        opcode_resetTimerSMS,
        opcode_activityTestGPRS,
        opcode_applyChargingGPRS,
        opcode_applyChargingReportGPRS,
        opcode_cancelGPRS,
        opcode_connectGPRS,
        opcode_continueGPRS,
        opcode_entityReleasedGPRS,
        opcode_furnishChargingInformationGPRS,
        opcode_initialDPGPRS,
        opcode_releaseGPRS,
        opcode_eventReportGPRS,
        opcode_requestReportGPRSEvent,
        opcode_resetTimerGPRS,
        opcode_sendChargingInformationGPRS,
    ]

class CAP_SMS_ops_args:

    _name_  = 'CAP-SMS-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 105, 7]
    
    _obj_ = [
        'connectSMS',
        'ConnectSMSArg',
        'continueSMS',
        'eventReportSMS',
        'EventReportSMSArg',
        'furnishChargingInformationSMS',
        'FurnishChargingInformationSMSArg',
        'initialDPSMS',
        'InitialDPSMSArg',
        'releaseSMS',
        'ReleaseSMSArg',
        'requestReportSMSEvent',
        'RequestReportSMSEventArg',
        'resetTimerSMS',
        'ResetTimerSMSArg',
        ]
    _type_ = [
        'ConnectSMSArg',
        'EventReportSMSArg',
        'FurnishChargingInformationSMSArg',
        'InitialDPSMSArg',
        'ReleaseSMSArg',
        'RequestReportSMSEventArg',
        'ResetTimerSMSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'connectSMS',
        'continueSMS',
        'eventReportSMS',
        'furnishChargingInformationSMS',
        'initialDPSMS',
        'releaseSMS',
        'requestReportSMSEvent',
        'resetTimerSMS',
        ]
    _class_ = [
        'connectSMS',
        'continueSMS',
        'eventReportSMS',
        'furnishChargingInformationSMS',
        'initialDPSMS',
        'releaseSMS',
        'requestReportSMSEvent',
        'resetTimerSMS',
        ]
    _param_ = [
        'connectSMS',
        'ConnectSMSArg',
        'eventReportSMS',
        'EventReportSMSArg',
        'furnishChargingInformationSMS',
        'FurnishChargingInformationSMSArg',
        'initialDPSMS',
        'InitialDPSMSArg',
        'requestReportSMSEvent',
        'RequestReportSMSEventArg',
        'resetTimerSMS',
        'ResetTimerSMSArg',
        ]
    
    #-----< connectSMS >-----#
    connectSMS = CLASS(name='connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectSMSArg >-----#
    ConnectSMSArg = SEQ(name='ConnectSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueSMS >-----#
    continueSMS = CLASS(name='continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continueSMS._val = dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])
    
    #-----< eventReportSMS >-----#
    eventReportSMS = CLASS(name='eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportSMSArg >-----#
    EventReportSMSArg = SEQ(name='EventReportSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationSMS >-----#
    furnishChargingInformationSMS = CLASS(name='furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationSMSArg >-----#
    FurnishChargingInformationSMSArg = OCT_STR(name='FurnishChargingInformationSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCISMSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPSMS >-----#
    initialDPSMS = CLASS(name='initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPSMSArg >-----#
    InitialDPSMSArg = SEQ(name='InitialDPSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseSMS >-----#
    releaseSMS = CLASS(name='releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _releaseSMS_val_ArgumentType = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    releaseSMS._val = dict([('ArgumentType', _releaseSMS_val_ArgumentType), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])
    
    #-----< ReleaseSMSArg >-----#
    ReleaseSMSArg = OCT_STR(name='ReleaseSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RPCause')))
    
    #-----< requestReportSMSEvent >-----#
    requestReportSMSEvent = CLASS(name='requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportSMSEventArg >-----#
    RequestReportSMSEventArg = SEQ(name='RequestReportSMSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerSMS >-----#
    resetTimerSMS = CLASS(name='resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerSMSArg >-----#
    ResetTimerSMSArg = SEQ(name='ResetTimerSMSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        continueSMS,
        releaseSMS,
        _releaseSMS_val_ArgumentType,
        ReleaseSMSArg,
    ]

class CAP_smsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = 'CAP-smsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 106, 7]
    
    _obj_ = [
        'cap3-sms-AC',
        'cap4-sms-AC',
        'cap3SMS',
        'cap4SMS',
        'smsActivationPackage',
        'smsConnectPackage',
        'smsProcessingPackage',
        'smsReleasePackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        'sms-AbstractSyntax',
        'Generic-sms-PDUs',
        'SmsInvokable',
        'SmsReturnable',
        ]
    _type_ = [
        'Generic-sms-PDUs',
        ]
    _set_ = [
        'SmsInvokable',
        'SmsReturnable',
        ]
    _val_ = [
        'cap3-sms-AC',
        'cap4-sms-AC',
        'cap3SMS',
        'cap4SMS',
        'smsActivationPackage',
        'smsConnectPackage',
        'smsProcessingPackage',
        'smsReleasePackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        'sms-AbstractSyntax',
        ]
    _class_ = [
        'cap3-sms-AC',
        'cap4-sms-AC',
        'cap3SMS',
        'cap4SMS',
        'smsActivationPackage',
        'smsConnectPackage',
        'smsProcessingPackage',
        'smsReleasePackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        'sms-AbstractSyntax',
        'SmsInvokable',
        'SmsReturnable',
        ]
    _param_ = [
        'smsActivationPackage',
        'smsConnectPackage',
        'smsEventHandlingPackage',
        'smsBillingPackage',
        'smsTimerPackage',
        ]
    
    #-----< cap3-sms-AC >-----#
    cap3_sms_AC = CLASS(name='cap3-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callingPartyNumber),
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_eventTypeSMS),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI),
        ('locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationMSC),
        ('locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sMSCAddress),
        ('timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone),
        ('tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPProtocolIdentifier),
        ('tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPDataCodingScheme),
        ('tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPValidityPeriod),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions),
        ('smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_smsReferenceNumber),
        ('mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mscAddress),
        ('sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sgsn_Number),
        ('ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_ms_Classmark2),
        ('gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass),
        ('iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI),
        ('calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        ('callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysNumber),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_sMSCAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        ('sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeSMS),
        ('eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationSMS),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name='ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    cap3_sms_AC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 20, 26, 16))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 21, 3, 61))])
    
    #-----< cap4-sms-AC >-----#
    cap4_sms_AC = CLASS(name='cap4-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        ('serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_serviceKey),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber),
        ('callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_callingPartyNumber),
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_eventTypeSMS),
        ('iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMSI),
        ('locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationMSC),
        ('locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationGPRS),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sMSCAddress),
        ('timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone),
        ('tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier),
        ('tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPDataCodingScheme),
        ('tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPValidityPeriod),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions),
        ('smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_smsReferenceNumber),
        ('mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_mscAddress),
        ('sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sgsn_Number),
        ('ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_ms_Classmark2),
        ('gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gPRSMSClass),
        ('iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMEI),
        ('calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        ('callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callingPartysNumber),
        ('destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber),
        ('sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_sMSCAddress),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        ('sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        ('eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventTypeSMS),
        ('eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS),
        ('miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_miscCallInfo),
        ('extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        ('timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timerID),
        ('timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timervalue),
        ('extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    cap4_sms_AC._val = dict([('associationContract', dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 16))])), ('dialogueMode', 'structured'), ('AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), ('applicationContextName', (0, 4, 0, 0, 1, 23, 3, 61))])
    
    #-----< cap3SMS >-----#
    cap3SMS = CLASS(name='cap3SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap3SMS._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 20, 26, 16))])
    
    #-----< cap4SMS >-----#
    cap4SMS = CLASS(name='cap4SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap4SMS._val = dict([('InitiatorConsumerOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), ('InitiatorSupplierOf', ASN1Set(rv=[dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))])], rr=[], ev=None, er=[])), ('Consumer', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 26, 16))])
    
    #-----< smsActivationPackage >-----#
    smsActivationPackage = CLASS(name='smsActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsConnectPackage >-----#
    smsConnectPackage = CLASS(name='smsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsProcessingPackage >-----#
    smsProcessingPackage = CLASS(name='smsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsProcessingPackage._val = dict([('Supplier', ASN1Set(rv=[dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 63))])
    
    #-----< smsReleasePackage >-----#
    smsReleasePackage = CLASS(name='smsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsReleasePackage._val = dict([('Supplier', ASN1Set(rv=[dict([('ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))])], rr=[], ev=None, er=[])), ('id', (0, 4, 0, 0, 1, 22, 27, 64))])
    
    #-----< smsEventHandlingPackage >-----#
    smsEventHandlingPackage = CLASS(name='smsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsBillingPackage >-----#
    smsBillingPackage = CLASS(name='smsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsTimerPackage >-----#
    smsTimerPackage = CLASS(name='smsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< sms-AbstractSyntax >-----#
    sms_AbstractSyntax = CLASS(name='sms-AbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _sms_AbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    sms_AbstractSyntax._val = dict([('Type', _sms_AbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])
    
    #-----< Generic-sms-PDUs >-----#
    Generic_sms_PDUs = CHOICE(name='Generic-sms-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _Generic_sms_PDUs_unidirectional = SEQ(name='unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __Generic_sms_PDUs_unidirectional_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_unidirectional_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___Generic_sms_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS),
        ('eventSpecificInformationSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS),
        ('miscCallInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('sMSEvents', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('timerID', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID),
        ('timervalue', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue),
        ('extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('sMSEvents', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('timerID', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID),
        ('timervalue', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue),
        ('extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name='ParameterType', mode=MODE_TYPE)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([('generic', 0), ('unobtainable', 1), ('congestion', 2)])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))]), dict([('errorCode', ('local', 6))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_unidirectional_components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_unidirectional_components__item_._ext = None
    __Generic_sms_PDUs_unidirectional_components._cont = ___Generic_sms_PDUs_unidirectional_components__item_
    __Generic_sms_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_unidirectional._cont = ASN1Dict([
        ('dialoguePortion', __Generic_sms_PDUs_unidirectional_dialoguePortion),
        ('components', __Generic_sms_PDUs_unidirectional_components),
        ])
    _Generic_sms_PDUs_unidirectional._ext = None
    _Generic_sms_PDUs_begin = SEQ(name='begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __Generic_sms_PDUs_begin_otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_begin_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_begin_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_begin_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_begin_components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_begin_components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_begin_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_begin_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_begin_components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_begin_components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_begin_components__item_._ext = None
    __Generic_sms_PDUs_begin_components._cont = ___Generic_sms_PDUs_begin_components__item_
    __Generic_sms_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_begin._cont = ASN1Dict([
        ('otid', __Generic_sms_PDUs_begin_otid),
        ('dialoguePortion', __Generic_sms_PDUs_begin_dialoguePortion),
        ('components', __Generic_sms_PDUs_begin_components),
        ])
    _Generic_sms_PDUs_begin._ext = None
    _Generic_sms_PDUs_end = SEQ(name='end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __Generic_sms_PDUs_end_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_end_dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_end_components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_end_components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_end_components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_end_components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_end_components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_end_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_end_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_end_components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_end_components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_end_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_end_components__item_._ext = None
    __Generic_sms_PDUs_end_components._cont = ___Generic_sms_PDUs_end_components__item_
    __Generic_sms_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_end._cont = ASN1Dict([
        ('dtid', __Generic_sms_PDUs_end_dtid),
        ('dialoguePortion', __Generic_sms_PDUs_end_dialoguePortion),
        ('components', __Generic_sms_PDUs_end_components),
        ])
    _Generic_sms_PDUs_end._ext = None
    _Generic_sms_PDUs_continue_ = SEQ(name='continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __Generic_sms_PDUs_continue__otid = OCT_STR(name='otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_continue__dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_continue__dialoguePortion = EXT(name='dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_continue__components = SEQ_OF(name='components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_continue__components__item__basicROS = CHOICE(name='basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        ('present', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        ('absent', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = 'ArgumentType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId),
        ('linkedId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId),
        ('opcode', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode),
        ('argument', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = 'operationCode'
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', 'opcode')
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = 'ResultType'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        ('opcode', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        ('result', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        ('result', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = 'errorCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', 'errcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = 'ParameterType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        ('invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId),
        ('errcode', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode),
        ('parameter', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        ('invoke', _____Generic_sms_PDUs_continue__components__item__basicROS_invoke),
        ('returnResult', _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult),
        ('returnError', _____Generic_sms_PDUs_continue__components__item__basicROS_returnError),
        ('reject', _____Generic_sms_PDUs_continue__components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_continue__components__item__basicROS._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast = SEQ(name='returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), ['returnResult']))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = 'operationCode'
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', 'opcode')
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = 'ResultType'
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        ('opcode', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        ('result', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        ('invokeId', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId),
        ('result', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_continue__components__item_._cont = ASN1Dict([
        ('basicROS', ____Generic_sms_PDUs_continue__components__item__basicROS),
        ('returnResultNotLast', ____Generic_sms_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_continue__components__item_._ext = None
    __Generic_sms_PDUs_continue__components._cont = ___Generic_sms_PDUs_continue__components__item_
    __Generic_sms_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_continue_._cont = ASN1Dict([
        ('otid', __Generic_sms_PDUs_continue__otid),
        ('dtid', __Generic_sms_PDUs_continue__dtid),
        ('dialoguePortion', __Generic_sms_PDUs_continue__dialoguePortion),
        ('components', __Generic_sms_PDUs_continue__components),
        ])
    _Generic_sms_PDUs_continue_._ext = None
    _Generic_sms_PDUs_abort = SEQ(name='abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    Generic_sms_PDUs._cont = ASN1Dict([
        ('unidirectional', _Generic_sms_PDUs_unidirectional),
        ('begin', _Generic_sms_PDUs_begin),
        ('end', _Generic_sms_PDUs_end),
        ('continue', _Generic_sms_PDUs_continue_),
        ('abort', _Generic_sms_PDUs_abort),
        ])
    Generic_sms_PDUs._ext = None
    
    #-----< SmsInvokable >-----#
    SmsInvokable = CLASS(name='SmsInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsInvokable_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsInvokable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_0_extensions._cont = ___SmsInvokable_val_ArgumentType_0_extensions__item_
    __SmsInvokable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', __SmsInvokable_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', __SmsInvokable_val_ArgumentType_0_sMSCAddress),
        ('extensions', __SmsInvokable_val_ArgumentType_0_extensions),
        ])
    _SmsInvokable_val_ArgumentType_0._ext = []
    _SmsInvokable_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    __SmsInvokable_val_ArgumentType_1_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name='eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_1_miscCallInfo = SEQ(name='miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([('messageType', 'request')]))
    __SmsInvokable_val_ArgumentType_1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_1_extensions._cont = ___SmsInvokable_val_ArgumentType_1_extensions__item_
    __SmsInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_1._cont = ASN1Dict([
        ('eventTypeSMS', __SmsInvokable_val_ArgumentType_1_eventTypeSMS),
        ('eventSpecificInformationSMS', __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS),
        ('miscCallInfo', __SmsInvokable_val_ArgumentType_1_miscCallInfo),
        ('extensions', __SmsInvokable_val_ArgumentType_1_extensions),
        ])
    _SmsInvokable_val_ArgumentType_1._ext = []
    _SmsInvokable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsInvokable_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsInvokable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_3_extensions._cont = ___SmsInvokable_val_ArgumentType_3_extensions__item_
    __SmsInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsInvokable_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsInvokable_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', __SmsInvokable_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', __SmsInvokable_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', __SmsInvokable_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', __SmsInvokable_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', __SmsInvokable_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', __SmsInvokable_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', __SmsInvokable_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', __SmsInvokable_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', __SmsInvokable_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', __SmsInvokable_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', __SmsInvokable_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', __SmsInvokable_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', __SmsInvokable_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', __SmsInvokable_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', __SmsInvokable_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', __SmsInvokable_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', __SmsInvokable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsInvokable_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    _SmsInvokable_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents._cont = ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_
    __SmsInvokable_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_4_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_4_extensions._cont = ___SmsInvokable_val_ArgumentType_4_extensions__item_
    __SmsInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_4._cont = ASN1Dict([
        ('sMSEvents', __SmsInvokable_val_ArgumentType_4_sMSEvents),
        ('extensions', __SmsInvokable_val_ArgumentType_4_extensions),
        ])
    _SmsInvokable_val_ArgumentType_4._ext = []
    _SmsInvokable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsInvokable_val_ArgumentType_5_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SmsInvokable_val_ArgumentType_5_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsInvokable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_5_extensions._cont = ___SmsInvokable_val_ArgumentType_5_extensions__item_
    __SmsInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_5._cont = ASN1Dict([
        ('timerID', __SmsInvokable_val_ArgumentType_5_timerID),
        ('timervalue', __SmsInvokable_val_ArgumentType_5_timervalue),
        ('extensions', __SmsInvokable_val_ArgumentType_5_extensions),
        ])
    _SmsInvokable_val_ArgumentType_5._ext = []
    SmsInvokable._val = ASN1Set(rv=[dict([('ArgumentType', _SmsInvokable_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_1), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 64))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_4), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', _SmsInvokable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    
    #-----< SmsReturnable >-----#
    SmsReturnable = CLASS(name='SmsReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsReturnable_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsReturnable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name='callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_0_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_0_extensions._cont = ___SmsReturnable_val_ArgumentType_0_extensions__item_
    __SmsReturnable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_0._cont = ASN1Dict([
        ('callingPartysNumber', __SmsReturnable_val_ArgumentType_0_callingPartysNumber),
        ('destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber),
        ('sMSCAddress', __SmsReturnable_val_ArgumentType_0_sMSCAddress),
        ('extensions', __SmsReturnable_val_ArgumentType_0_extensions),
        ])
    _SmsReturnable_val_ArgumentType_0._ext = []
    _SmsReturnable_val_ArgumentType_2 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsReturnable_val_ArgumentType_3_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_eventTypeSMS = ENUM(name='eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationMSC = SEQ(name='locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sMSCAddress = OCT_STR(name='sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name='timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name='tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name='tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name='tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name='tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsReturnable_val_ArgumentType_3_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_3_extensions._cont = ___SmsReturnable_val_ArgumentType_3_extensions__item_
    __SmsReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_mscAddress = OCT_STR(name='mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsReturnable_val_ArgumentType_3_gPRSMSClass = SEQ(name='gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name='calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsReturnable_val_ArgumentType_3._cont = ASN1Dict([
        ('serviceKey', __SmsReturnable_val_ArgumentType_3_serviceKey),
        ('destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber),
        ('callingPartyNumber', __SmsReturnable_val_ArgumentType_3_callingPartyNumber),
        ('eventTypeSMS', __SmsReturnable_val_ArgumentType_3_eventTypeSMS),
        ('iMSI', __SmsReturnable_val_ArgumentType_3_iMSI),
        ('locationInformationMSC', __SmsReturnable_val_ArgumentType_3_locationInformationMSC),
        ('locationInformationGPRS', __SmsReturnable_val_ArgumentType_3_locationInformationGPRS),
        ('sMSCAddress', __SmsReturnable_val_ArgumentType_3_sMSCAddress),
        ('timeAndTimezone', __SmsReturnable_val_ArgumentType_3_timeAndTimezone),
        ('tPShortMessageSpecificInfo', __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        ('tPProtocolIdentifier', __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier),
        ('tPDataCodingScheme', __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme),
        ('tPValidityPeriod', __SmsReturnable_val_ArgumentType_3_tPValidityPeriod),
        ('extensions', __SmsReturnable_val_ArgumentType_3_extensions),
        ('smsReferenceNumber', __SmsReturnable_val_ArgumentType_3_smsReferenceNumber),
        ('mscAddress', __SmsReturnable_val_ArgumentType_3_mscAddress),
        ('sgsn-Number', __SmsReturnable_val_ArgumentType_3_sgsn_Number),
        ('ms-Classmark2', __SmsReturnable_val_ArgumentType_3_ms_Classmark2),
        ('gPRSMSClass', __SmsReturnable_val_ArgumentType_3_gPRSMSClass),
        ('iMEI', __SmsReturnable_val_ArgumentType_3_iMEI),
        ('calledPartyNumber', __SmsReturnable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsReturnable_val_ArgumentType_3._ext = ['smsReferenceNumber', 'mscAddress', 'sgsn-Number', 'ms-Classmark2', 'gPRSMSClass', 'iMEI', 'calledPartyNumber']
    _SmsReturnable_val_ArgumentType_4 = OCT_STR(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _SmsReturnable_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents = SEQ_OF(name='sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents._cont = ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_
    __SmsReturnable_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_5_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_5_extensions._cont = ___SmsReturnable_val_ArgumentType_5_extensions__item_
    __SmsReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_5._cont = ASN1Dict([
        ('sMSEvents', __SmsReturnable_val_ArgumentType_5_sMSEvents),
        ('extensions', __SmsReturnable_val_ArgumentType_5_extensions),
        ])
    _SmsReturnable_val_ArgumentType_5._ext = []
    _SmsReturnable_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsReturnable_val_ArgumentType_6_timerID = ENUM(name='timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default='tssf')
    __SmsReturnable_val_ArgumentType_6_timervalue = INT(name='timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsReturnable_val_ArgumentType_6_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_6_extensions._cont = ___SmsReturnable_val_ArgumentType_6_extensions__item_
    __SmsReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_6._cont = ASN1Dict([
        ('timerID', __SmsReturnable_val_ArgumentType_6_timerID),
        ('timervalue', __SmsReturnable_val_ArgumentType_6_timervalue),
        ('extensions', __SmsReturnable_val_ArgumentType_6_extensions),
        ])
    _SmsReturnable_val_ArgumentType_6._ext = []
    SmsReturnable._val = ASN1Set(rv=[dict([('ArgumentType', _SmsReturnable_val_ArgumentType_0), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 62))]), dict([('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 65))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_2), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 61))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_3), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 6))]), dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 60))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_4), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 66))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_5), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 63))]), dict([('ArgumentType', _SmsReturnable_val_ArgumentType_6), ('returnResult', False), ('Errors', ASN1Set(rv=[dict([('errorCode', ('local', 7))]), dict([('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('errorCode', ('local', 12))]), dict([('errorCode', ('local', 14))]), dict([('errorCode', ('local', 15))]), dict([('errorCode', ('local', 16))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 67))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap3_sms_AC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        cap4_sms_AC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        cap3SMS,
        cap4SMS,
        smsProcessingPackage,
        smsReleasePackage,
        sms_AbstractSyntax,
        _sms_AbstractSyntax_val_Type,
        __Generic_sms_PDUs_unidirectional_dialoguePortion,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject,
        ____Generic_sms_PDUs_unidirectional_components__item__basicROS,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_unidirectional_components__item_,
        __Generic_sms_PDUs_unidirectional_components,
        _Generic_sms_PDUs_unidirectional,
        __Generic_sms_PDUs_begin_otid,
        __Generic_sms_PDUs_begin_dialoguePortion,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_begin_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_begin_components__item__basicROS_reject,
        ____Generic_sms_PDUs_begin_components__item__basicROS,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_begin_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_begin_components__item_,
        __Generic_sms_PDUs_begin_components,
        _Generic_sms_PDUs_begin,
        __Generic_sms_PDUs_end_dtid,
        __Generic_sms_PDUs_end_dialoguePortion,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_end_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_end_components__item__basicROS_reject,
        ____Generic_sms_PDUs_end_components__item__basicROS,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_end_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_end_components__item_,
        __Generic_sms_PDUs_end_components,
        _Generic_sms_PDUs_end,
        __Generic_sms_PDUs_continue__otid,
        __Generic_sms_PDUs_continue__dtid,
        __Generic_sms_PDUs_continue__dialoguePortion,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_continue__components__item__basicROS_invoke,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnError,
        _____Generic_sms_PDUs_continue__components__item__basicROS_reject,
        ____Generic_sms_PDUs_continue__components__item__basicROS,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_continue__components__item__returnResultNotLast,
        ___Generic_sms_PDUs_continue__components__item_,
        __Generic_sms_PDUs_continue__components,
        _Generic_sms_PDUs_continue_,
        _Generic_sms_PDUs_abort,
        Generic_sms_PDUs,
        SmsInvokable,
        __SmsInvokable_val_ArgumentType_0_callingPartysNumber,
        __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_0_sMSCAddress,
        ___SmsInvokable_val_ArgumentType_0_extensions__item_,
        __SmsInvokable_val_ArgumentType_0_extensions,
        _SmsInvokable_val_ArgumentType_0,
        __SmsInvokable_val_ArgumentType_1_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS,
        __SmsInvokable_val_ArgumentType_1_miscCallInfo,
        ___SmsInvokable_val_ArgumentType_1_extensions__item_,
        __SmsInvokable_val_ArgumentType_1_extensions,
        _SmsInvokable_val_ArgumentType_1,
        _SmsInvokable_val_ArgumentType_2,
        __SmsInvokable_val_ArgumentType_3_serviceKey,
        __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_3_callingPartyNumber,
        __SmsInvokable_val_ArgumentType_3_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_3_iMSI,
        __SmsInvokable_val_ArgumentType_3_locationInformationMSC,
        __SmsInvokable_val_ArgumentType_3_locationInformationGPRS,
        __SmsInvokable_val_ArgumentType_3_sMSCAddress,
        __SmsInvokable_val_ArgumentType_3_timeAndTimezone,
        __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsInvokable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsInvokable_val_ArgumentType_3_extensions__item_,
        __SmsInvokable_val_ArgumentType_3_extensions,
        __SmsInvokable_val_ArgumentType_3_smsReferenceNumber,
        __SmsInvokable_val_ArgumentType_3_mscAddress,
        __SmsInvokable_val_ArgumentType_3_sgsn_Number,
        __SmsInvokable_val_ArgumentType_3_ms_Classmark2,
        __SmsInvokable_val_ArgumentType_3_gPRSMSClass,
        __SmsInvokable_val_ArgumentType_3_iMEI,
        __SmsInvokable_val_ArgumentType_3_calledPartyNumber,
        _SmsInvokable_val_ArgumentType_3,
        ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_,
        __SmsInvokable_val_ArgumentType_4_sMSEvents,
        ___SmsInvokable_val_ArgumentType_4_extensions__item_,
        __SmsInvokable_val_ArgumentType_4_extensions,
        _SmsInvokable_val_ArgumentType_4,
        __SmsInvokable_val_ArgumentType_5_timerID,
        __SmsInvokable_val_ArgumentType_5_timervalue,
        ___SmsInvokable_val_ArgumentType_5_extensions__item_,
        __SmsInvokable_val_ArgumentType_5_extensions,
        _SmsInvokable_val_ArgumentType_5,
        SmsReturnable,
        __SmsReturnable_val_ArgumentType_0_callingPartysNumber,
        __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_0_sMSCAddress,
        ___SmsReturnable_val_ArgumentType_0_extensions__item_,
        __SmsReturnable_val_ArgumentType_0_extensions,
        _SmsReturnable_val_ArgumentType_0,
        _SmsReturnable_val_ArgumentType_2,
        __SmsReturnable_val_ArgumentType_3_serviceKey,
        __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_3_callingPartyNumber,
        __SmsReturnable_val_ArgumentType_3_eventTypeSMS,
        __SmsReturnable_val_ArgumentType_3_iMSI,
        __SmsReturnable_val_ArgumentType_3_locationInformationMSC,
        __SmsReturnable_val_ArgumentType_3_locationInformationGPRS,
        __SmsReturnable_val_ArgumentType_3_sMSCAddress,
        __SmsReturnable_val_ArgumentType_3_timeAndTimezone,
        __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsReturnable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsReturnable_val_ArgumentType_3_extensions__item_,
        __SmsReturnable_val_ArgumentType_3_extensions,
        __SmsReturnable_val_ArgumentType_3_smsReferenceNumber,
        __SmsReturnable_val_ArgumentType_3_mscAddress,
        __SmsReturnable_val_ArgumentType_3_sgsn_Number,
        __SmsReturnable_val_ArgumentType_3_ms_Classmark2,
        __SmsReturnable_val_ArgumentType_3_gPRSMSClass,
        __SmsReturnable_val_ArgumentType_3_iMEI,
        __SmsReturnable_val_ArgumentType_3_calledPartyNumber,
        _SmsReturnable_val_ArgumentType_3,
        _SmsReturnable_val_ArgumentType_4,
        ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_,
        __SmsReturnable_val_ArgumentType_5_sMSEvents,
        ___SmsReturnable_val_ArgumentType_5_extensions__item_,
        __SmsReturnable_val_ArgumentType_5_extensions,
        _SmsReturnable_val_ArgumentType_5,
        __SmsReturnable_val_ArgumentType_6_timerID,
        __SmsReturnable_val_ArgumentType_6_timervalue,
        ___SmsReturnable_val_ArgumentType_6_extensions__item_,
        __SmsReturnable_val_ArgumentType_6_extensions,
        _SmsReturnable_val_ArgumentType_6,
    ]

class CertificateExtensions:

    _name_  = 'CertificateExtensions'
    _oid_   = [2, 5, 1, 26, 8]
    
    _obj_ = [
        'authorityKeyIdentifier',
        'AuthorityKeyIdentifier',
        'KeyIdentifier',
        'subjectKeyIdentifier',
        'SubjectKeyIdentifier',
        'keyUsage',
        'KeyUsage',
        'extKeyUsage',
        'KeyPurposeId',
        'privateKeyUsagePeriod',
        'PrivateKeyUsagePeriod',
        'certificatePolicies',
        'CertificatePoliciesSyntax',
        'PolicyInformation',
        'CertPolicyId',
        'PolicyQualifierInfo',
        'SupportedPolicyQualifiers',
        'anyPolicy',
        'CERT-POLICY-QUALIFIER',
        'policyMappings',
        'PolicyMappingsSyntax',
        'authorizationValidation',
        'AvlId',
        'subjectAltName',
        'GeneralNames',
        'GeneralName',
        'OTHER-NAME',
        'EDIPartyName',
        'issuerAltName',
        'subjectDirectoryAttributes',
        'AttributesSyntax',
        'basicConstraints',
        'BasicConstraintsSyntax',
        'nameConstraints',
        'NameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'policyConstraints',
        'PolicyConstraintsSyntax',
        'SkipCerts',
        'inhibitAnyPolicy',
        'cRLNumber',
        'CRLNumber',
        'crlScope',
        'CRLScopeSyntax',
        'PerAuthorityScope',
        'OnlyCertificateTypes',
        'NumberRange',
        'BaseRevocationInfo',
        'statusReferrals',
        'StatusReferrals',
        'StatusReferral',
        'CRLReferral',
        'DeltaRefInfo',
        'OTHER-REFERRAL',
        'cRLStreamIdentifier',
        'CRLStreamIdentifier',
        'orderedList',
        'OrderedListSyntax',
        'deltaInfo',
        'DeltaInformation',
        'toBeRevoked',
        'ToBeRevokedSyntax',
        'ToBeRevokedGroup',
        'ReasonInfo',
        'CertificateGroup',
        'CertificateGroupNumberRange',
        'CertificateSerialNumbers',
        'revokedGroups',
        'RevokedGroupsSyntax',
        'RevokedGroup',
        'RevokedCertificateGroup',
        'expiredCertsOnCRL',
        'ExpiredCertsOnCRL',
        'reasonCode',
        'CRLReason',
        'holdInstructionCode',
        'HoldInstruction',
        'invalidityDate',
        'cRLDistributionPoints',
        'CRLDistPointsSyntax',
        'DistributionPoint',
        'DistributionPointName',
        'ReasonFlags',
        'issuingDistributionPoint',
        'IssuingDistPointSyntax',
        'certificateIssuer',
        'deltaCRLIndicator',
        'BaseCRLNumber',
        'baseUpdateTime',
        'freshestCRL',
        'aAissuingDistributionPoint',
        'AAIssuingDistPointSyntax',
        'certificateExactMatch',
        'CertificateExactAssertion',
        'certificateMatch',
        'CertificateAssertion',
        'AltNameType',
        'CertPolicySet',
        'certificatePairExactMatch',
        'CertificatePairExactAssertion',
        'certificatePairMatch',
        'CertificatePairAssertion',
        'certificateListExactMatch',
        'CertificateListExactAssertion',
        'certificateListMatch',
        'CertificateListAssertion',
        'algorithmIdentifierMatch',
        'policyMatch',
        'pkiPathMatch',
        'PkiPathMatchSyntax',
        'enhancedCertificateMatch',
        'EnhancedCertificateAssertion',
        'AltName',
        'certExactAssertion',
        'certAssertion',
        'certPairExactAssertion',
        'certPairAssertion',
        'certListExactAssertion',
        'certListAssertion',
        'algorithmIdentifier',
        'id-ce-subjectDirectoryAttributes',
        'id-ce-subjectKeyIdentifier',
        'id-ce-keyUsage',
        'id-ce-privateKeyUsagePeriod',
        'id-ce-subjectAltName',
        'id-ce-issuerAltName',
        'id-ce-basicConstraints',
        'id-ce-cRLNumber',
        'id-ce-reasonCode',
        'id-ce-holdInstructionCode',
        'id-ce-invalidityDate',
        'id-ce-deltaCRLIndicator',
        'id-ce-issuingDistributionPoint',
        'id-ce-certificateIssuer',
        'id-ce-nameConstraints',
        'id-ce-cRLDistributionPoints',
        'id-ce-certificatePolicies',
        'id-ce-policyMappings',
        'id-ce-authorityKeyIdentifier',
        'id-ce-policyConstraints',
        'id-ce-extKeyUsage',
        'id-ce-cRLStreamIdentifier',
        'id-ce-cRLScope',
        'id-ce-statusReferrals',
        'id-ce-freshestCRL',
        'id-ce-orderedList',
        'id-ce-baseUpdateTime',
        'id-ce-deltaInfo',
        'id-ce-inhibitAnyPolicy',
        'id-ce-toBeRevoked',
        'id-ce-revokedGroups',
        'id-ce-expiredCertsOnCRL',
        'id-ce-aAissuingDistributionPoint',
        'id-ce-authorizationValidation',
        'id-mr-certificateExactMatch',
        'id-mr-certificateMatch',
        'id-mr-certificatePairExactMatch',
        'id-mr-certificatePairMatch',
        'id-mr-certificateListExactMatch',
        'id-mr-certificateListMatch',
        'id-mr-algorithmIdentifierMatch',
        'id-mr-policyMatch',
        'id-mr-pkiPathMatch',
        'id-mr-enhancedCertificateMatch',
        'id-ldx-certExactAssertion',
        'id-ldx-certAssertion',
        'id-ldx-certPairExactAssertion',
        'id-ldx-certPairAssertion',
        'id-ldx-certListExactAssertion',
        'id-ldx-certListAssertion',
        'id-ldx-algorithmIdentifier',
        ]
    _type_ = [
        'AuthorityKeyIdentifier',
        'KeyIdentifier',
        'SubjectKeyIdentifier',
        'KeyUsage',
        'KeyPurposeId',
        'PrivateKeyUsagePeriod',
        'CertificatePoliciesSyntax',
        'PolicyInformation',
        'CertPolicyId',
        'PolicyQualifierInfo',
        'CERT-POLICY-QUALIFIER',
        'PolicyMappingsSyntax',
        'AvlId',
        'GeneralNames',
        'GeneralName',
        'OTHER-NAME',
        'EDIPartyName',
        'AttributesSyntax',
        'BasicConstraintsSyntax',
        'NameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'PolicyConstraintsSyntax',
        'SkipCerts',
        'CRLNumber',
        'CRLScopeSyntax',
        'PerAuthorityScope',
        'OnlyCertificateTypes',
        'NumberRange',
        'BaseRevocationInfo',
        'StatusReferrals',
        'StatusReferral',
        'CRLReferral',
        'DeltaRefInfo',
        'OTHER-REFERRAL',
        'CRLStreamIdentifier',
        'OrderedListSyntax',
        'DeltaInformation',
        'ToBeRevokedSyntax',
        'ToBeRevokedGroup',
        'ReasonInfo',
        'CertificateGroup',
        'CertificateGroupNumberRange',
        'CertificateSerialNumbers',
        'RevokedGroupsSyntax',
        'RevokedGroup',
        'RevokedCertificateGroup',
        'ExpiredCertsOnCRL',
        'CRLReason',
        'HoldInstruction',
        'CRLDistPointsSyntax',
        'DistributionPoint',
        'DistributionPointName',
        'ReasonFlags',
        'IssuingDistPointSyntax',
        'BaseCRLNumber',
        'AAIssuingDistPointSyntax',
        'CertificateExactAssertion',
        'CertificateAssertion',
        'AltNameType',
        'CertPolicySet',
        'CertificatePairExactAssertion',
        'CertificatePairAssertion',
        'CertificateListExactAssertion',
        'CertificateListAssertion',
        'PkiPathMatchSyntax',
        'EnhancedCertificateAssertion',
        'AltName',
        ]
    _set_ = [
        'SupportedPolicyQualifiers',
        ]
    _val_ = [
        'authorityKeyIdentifier',
        'subjectKeyIdentifier',
        'keyUsage',
        'extKeyUsage',
        'privateKeyUsagePeriod',
        'certificatePolicies',
        'anyPolicy',
        'policyMappings',
        'authorizationValidation',
        'subjectAltName',
        'issuerAltName',
        'subjectDirectoryAttributes',
        'basicConstraints',
        'nameConstraints',
        'policyConstraints',
        'inhibitAnyPolicy',
        'cRLNumber',
        'crlScope',
        'statusReferrals',
        'cRLStreamIdentifier',
        'orderedList',
        'deltaInfo',
        'toBeRevoked',
        'revokedGroups',
        'expiredCertsOnCRL',
        'reasonCode',
        'holdInstructionCode',
        'invalidityDate',
        'cRLDistributionPoints',
        'issuingDistributionPoint',
        'certificateIssuer',
        'deltaCRLIndicator',
        'baseUpdateTime',
        'freshestCRL',
        'aAissuingDistributionPoint',
        'certificateExactMatch',
        'certificateMatch',
        'certificatePairExactMatch',
        'certificatePairMatch',
        'certificateListExactMatch',
        'certificateListMatch',
        'algorithmIdentifierMatch',
        'policyMatch',
        'pkiPathMatch',
        'enhancedCertificateMatch',
        'certExactAssertion',
        'certAssertion',
        'certPairExactAssertion',
        'certPairAssertion',
        'certListExactAssertion',
        'certListAssertion',
        'algorithmIdentifier',
        'id-ce-subjectDirectoryAttributes',
        'id-ce-subjectKeyIdentifier',
        'id-ce-keyUsage',
        'id-ce-privateKeyUsagePeriod',
        'id-ce-subjectAltName',
        'id-ce-issuerAltName',
        'id-ce-basicConstraints',
        'id-ce-cRLNumber',
        'id-ce-reasonCode',
        'id-ce-holdInstructionCode',
        'id-ce-invalidityDate',
        'id-ce-deltaCRLIndicator',
        'id-ce-issuingDistributionPoint',
        'id-ce-certificateIssuer',
        'id-ce-nameConstraints',
        'id-ce-cRLDistributionPoints',
        'id-ce-certificatePolicies',
        'id-ce-policyMappings',
        'id-ce-authorityKeyIdentifier',
        'id-ce-policyConstraints',
        'id-ce-extKeyUsage',
        'id-ce-cRLStreamIdentifier',
        'id-ce-cRLScope',
        'id-ce-statusReferrals',
        'id-ce-freshestCRL',
        'id-ce-orderedList',
        'id-ce-baseUpdateTime',
        'id-ce-deltaInfo',
        'id-ce-inhibitAnyPolicy',
        'id-ce-toBeRevoked',
        'id-ce-revokedGroups',
        'id-ce-expiredCertsOnCRL',
        'id-ce-aAissuingDistributionPoint',
        'id-ce-authorizationValidation',
        'id-mr-certificateExactMatch',
        'id-mr-certificateMatch',
        'id-mr-certificatePairExactMatch',
        'id-mr-certificatePairMatch',
        'id-mr-certificateListExactMatch',
        'id-mr-certificateListMatch',
        'id-mr-algorithmIdentifierMatch',
        'id-mr-policyMatch',
        'id-mr-pkiPathMatch',
        'id-mr-enhancedCertificateMatch',
        'id-ldx-certExactAssertion',
        'id-ldx-certAssertion',
        'id-ldx-certPairExactAssertion',
        'id-ldx-certPairAssertion',
        'id-ldx-certListExactAssertion',
        'id-ldx-certListAssertion',
        'id-ldx-algorithmIdentifier',
        ]
    _class_ = [
        'authorityKeyIdentifier',
        'subjectKeyIdentifier',
        'keyUsage',
        'extKeyUsage',
        'privateKeyUsagePeriod',
        'certificatePolicies',
        'SupportedPolicyQualifiers',
        'CERT-POLICY-QUALIFIER',
        'policyMappings',
        'authorizationValidation',
        'subjectAltName',
        'OTHER-NAME',
        'issuerAltName',
        'subjectDirectoryAttributes',
        'basicConstraints',
        'nameConstraints',
        'policyConstraints',
        'inhibitAnyPolicy',
        'cRLNumber',
        'crlScope',
        'statusReferrals',
        'OTHER-REFERRAL',
        'cRLStreamIdentifier',
        'orderedList',
        'deltaInfo',
        'toBeRevoked',
        'revokedGroups',
        'expiredCertsOnCRL',
        'reasonCode',
        'holdInstructionCode',
        'invalidityDate',
        'cRLDistributionPoints',
        'issuingDistributionPoint',
        'certificateIssuer',
        'deltaCRLIndicator',
        'baseUpdateTime',
        'freshestCRL',
        'aAissuingDistributionPoint',
        'certificateExactMatch',
        'certificateMatch',
        'certificatePairExactMatch',
        'certificatePairMatch',
        'certificateListExactMatch',
        'certificateListMatch',
        'algorithmIdentifierMatch',
        'policyMatch',
        'pkiPathMatch',
        'enhancedCertificateMatch',
        'certExactAssertion',
        'certAssertion',
        'certPairExactAssertion',
        'certPairAssertion',
        'certListExactAssertion',
        'certListAssertion',
        'algorithmIdentifier',
        ]
    _param_ = [
        ]
    
    #-----< authorityKeyIdentifier >-----#
    authorityKeyIdentifier = CLASS(name='authorityKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityKeyIdentifier_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')))
    authorityKeyIdentifier._val = dict([('ExtnType', _authorityKeyIdentifier_val_ExtnType), ('id', (2, 5, 29, 35))])
    
    #-----< AuthorityKeyIdentifier >-----#
    AuthorityKeyIdentifier = SEQ(name='AuthorityKeyIdentifier', mode=MODE_TYPE)
    _AuthorityKeyIdentifier_keyIdentifier = OCT_STR(name='keyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')), opt=True)
    _AuthorityKeyIdentifier_authorityCertIssuer = SEQ_OF(name='authorityCertIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AuthorityKeyIdentifier_authorityCertSerialNumber = INT(name='authorityCertSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    AuthorityKeyIdentifier._cont = ASN1Dict([
        ('keyIdentifier', _AuthorityKeyIdentifier_keyIdentifier),
        ('authorityCertIssuer', _AuthorityKeyIdentifier_authorityCertIssuer),
        ('authorityCertSerialNumber', _AuthorityKeyIdentifier_authorityCertSerialNumber),
        ])
    AuthorityKeyIdentifier._ext = []
    
    #-----< KeyIdentifier >-----#
    KeyIdentifier = OCT_STR(name='KeyIdentifier', mode=MODE_TYPE)
    
    #-----< subjectKeyIdentifier >-----#
    subjectKeyIdentifier = CLASS(name='subjectKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectKeyIdentifier_val_ExtnType = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')))
    subjectKeyIdentifier._val = dict([('ExtnType', _subjectKeyIdentifier_val_ExtnType), ('id', (2, 5, 29, 14))])
    
    #-----< SubjectKeyIdentifier >-----#
    SubjectKeyIdentifier = OCT_STR(name='SubjectKeyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')))
    
    #-----< keyUsage >-----#
    keyUsage = CLASS(name='keyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _keyUsage_val_ExtnType = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')))
    keyUsage._val = dict([('ExtnType', _keyUsage_val_ExtnType), ('id', (2, 5, 29, 15))])
    
    #-----< KeyUsage >-----#
    KeyUsage = BIT_STR(name='KeyUsage', mode=MODE_TYPE)
    KeyUsage._cont = ASN1Dict([('digitalSignature', 0), ('contentCommitment', 1), ('keyEncipherment', 2), ('dataEncipherment', 3), ('keyAgreement', 4), ('keyCertSign', 5), ('cRLSign', 6), ('encipherOnly', 7), ('decipherOnly', 8)])
    
    #-----< extKeyUsage >-----#
    extKeyUsage = CLASS(name='extKeyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _extKeyUsage_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE)
    __extKeyUsage_val_ExtnType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyPurposeId')))
    _extKeyUsage_val_ExtnType._cont = __extKeyUsage_val_ExtnType__item_
    _extKeyUsage_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    extKeyUsage._val = dict([('ExtnType', _extKeyUsage_val_ExtnType), ('id', (2, 5, 29, 37))])
    
    #-----< KeyPurposeId >-----#
    KeyPurposeId = OID(name='KeyPurposeId', mode=MODE_TYPE)
    
    #-----< privateKeyUsagePeriod >-----#
    privateKeyUsagePeriod = CLASS(name='privateKeyUsagePeriod', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _privateKeyUsagePeriod_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PrivateKeyUsagePeriod')))
    privateKeyUsagePeriod._val = dict([('ExtnType', _privateKeyUsagePeriod_val_ExtnType), ('id', (2, 5, 29, 16))])
    
    #-----< PrivateKeyUsagePeriod >-----#
    PrivateKeyUsagePeriod = SEQ(name='PrivateKeyUsagePeriod', mode=MODE_TYPE)
    _PrivateKeyUsagePeriod_notBefore = TIME_GEN(name='notBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrivateKeyUsagePeriod_notAfter = TIME_GEN(name='notAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrivateKeyUsagePeriod._cont = ASN1Dict([
        ('notBefore', _PrivateKeyUsagePeriod_notBefore),
        ('notAfter', _PrivateKeyUsagePeriod_notAfter),
        ])
    PrivateKeyUsagePeriod._ext = []
    
    #-----< certificatePolicies >-----#
    certificatePolicies = CLASS(name='certificatePolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _certificatePolicies_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePoliciesSyntax')))
    certificatePolicies._val = dict([('ExtnType', _certificatePolicies_val_ExtnType), ('id', (2, 5, 29, 32))])
    
    #-----< CertificatePoliciesSyntax >-----#
    CertificatePoliciesSyntax = SEQ_OF(name='CertificatePoliciesSyntax', mode=MODE_TYPE)
    _CertificatePoliciesSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyInformation')))
    CertificatePoliciesSyntax._cont = _CertificatePoliciesSyntax__item_
    CertificatePoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PolicyInformation >-----#
    PolicyInformation = SEQ(name='PolicyInformation', mode=MODE_TYPE)
    _PolicyInformation_policyIdentifier = OID(name='policyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    _PolicyInformation_policyQualifiers = SEQ_OF(name='policyQualifiers', mode=MODE_TYPE, opt=True)
    __PolicyInformation_policyQualifiers__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyQualifierInfo')))
    _PolicyInformation_policyQualifiers._cont = __PolicyInformation_policyQualifiers__item_
    _PolicyInformation_policyQualifiers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PolicyInformation._cont = ASN1Dict([
        ('policyIdentifier', _PolicyInformation_policyIdentifier),
        ('policyQualifiers', _PolicyInformation_policyQualifiers),
        ])
    PolicyInformation._ext = []
    
    #-----< CertPolicyId >-----#
    CertPolicyId = OID(name='CertPolicyId', mode=MODE_TYPE)
    
    #-----< PolicyQualifierInfo >-----#
    PolicyQualifierInfo = SEQ(name='PolicyQualifierInfo', mode=MODE_TYPE)
    _PolicyQualifierInfo_policyQualifierId = OID(name='policyQualifierId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'CERT-POLICY-QUALIFIER'), ['id']))
    __PolicyQualifierInfo_policyQualifierId_tab = CLASS(name='_tab_CERT-POLICY-QUALIFIER', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    __PolicyQualifierInfo_policyQualifierId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PolicyQualifierInfo_policyQualifierId._const_tab = __PolicyQualifierInfo_policyQualifierId_tab
    _PolicyQualifierInfo_policyQualifierId._const_tab_at = None
    _PolicyQualifierInfo_policyQualifierId._const_tab_id = 'id'
    _PolicyQualifierInfo_qualifier = OPEN(name='qualifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'CERT-POLICY-QUALIFIER'), ['Qualifier']), opt=True)
    __PolicyQualifierInfo_qualifier_tab = CLASS(name='_tab_CERT-POLICY-QUALIFIER', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    __PolicyQualifierInfo_qualifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PolicyQualifierInfo_qualifier._const_tab = __PolicyQualifierInfo_qualifier_tab
    _PolicyQualifierInfo_qualifier._const_tab_at = ('..', 'policyQualifierId')
    _PolicyQualifierInfo_qualifier._const_tab_id = 'Qualifier'
    PolicyQualifierInfo._cont = ASN1Dict([
        ('policyQualifierId', _PolicyQualifierInfo_policyQualifierId),
        ('qualifier', _PolicyQualifierInfo_qualifier),
        ])
    PolicyQualifierInfo._ext = []
    
    #-----< SupportedPolicyQualifiers >-----#
    SupportedPolicyQualifiers = CLASS(name='SupportedPolicyQualifiers', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    SupportedPolicyQualifiers._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< anyPolicy >-----#
    anyPolicy = OID(name='anyPolicy', mode=MODE_VALUE)
    anyPolicy._val = (2, 5, 29, 32, 0)
    
    #-----< CERT-POLICY-QUALIFIER >-----#
    CERT_POLICY_QUALIFIER = CLASS(name='CERT-POLICY-QUALIFIER', mode=MODE_TYPE)
    _CERT_POLICY_QUALIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _CERT_POLICY_QUALIFIER_Qualifier = OPEN(name='Qualifier', mode=MODE_TYPE, opt=True)
    CERT_POLICY_QUALIFIER._cont = ASN1Dict([
        ('id', _CERT_POLICY_QUALIFIER_id),
        ('Qualifier', _CERT_POLICY_QUALIFIER_Qualifier),
        ])
    
    #-----< policyMappings >-----#
    policyMappings = CLASS(name='policyMappings', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _policyMappings_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyMappingsSyntax')))
    policyMappings._val = dict([('ExtnType', _policyMappings_val_ExtnType), ('id', (2, 5, 29, 33))])
    
    #-----< PolicyMappingsSyntax >-----#
    PolicyMappingsSyntax = SEQ_OF(name='PolicyMappingsSyntax', mode=MODE_TYPE)
    _PolicyMappingsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PolicyMappingsSyntax__item__issuerDomainPolicy = OID(name='issuerDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    __PolicyMappingsSyntax__item__subjectDomainPolicy = OID(name='subjectDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    _PolicyMappingsSyntax__item_._cont = ASN1Dict([
        ('issuerDomainPolicy', __PolicyMappingsSyntax__item__issuerDomainPolicy),
        ('subjectDomainPolicy', __PolicyMappingsSyntax__item__subjectDomainPolicy),
        ])
    _PolicyMappingsSyntax__item_._ext = []
    PolicyMappingsSyntax._cont = _PolicyMappingsSyntax__item_
    PolicyMappingsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< authorizationValidation >-----#
    authorizationValidation = CLASS(name='authorizationValidation', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorizationValidation_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AvlId')))
    authorizationValidation._val = dict([('ExtnType', _authorizationValidation_val_ExtnType), ('id', (2, 5, 29, 70))])
    
    #-----< AvlId >-----#
    AvlId = SEQ(name='AvlId', mode=MODE_TYPE)
    _AvlId_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AvlId_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AvlSerialNumber')), opt=True)
    AvlId._cont = ASN1Dict([
        ('issuer', _AvlId_issuer),
        ('serialNumber', _AvlId_serialNumber),
        ])
    AvlId._ext = []
    
    #-----< subjectAltName >-----#
    subjectAltName = CLASS(name='subjectAltName', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectAltName_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    subjectAltName._val = dict([('ExtnType', _subjectAltName_val_ExtnType), ('id', (2, 5, 29, 17))])
    
    #-----< GeneralNames >-----#
    GeneralNames = SEQ_OF(name='GeneralNames', mode=MODE_TYPE)
    _GeneralNames__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    GeneralNames._cont = _GeneralNames__item_
    GeneralNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralName >-----#
    GeneralName = CHOICE(name='GeneralName', mode=MODE_TYPE)
    _GeneralName_otherName = SEQ(name='otherName', mode=MODE_TYPE)
    __GeneralName_otherName_type_id = OID(name='type-id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-NAME'), ['id']))
    __GeneralName_otherName_value = OPEN(name='value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-NAME'), ['Type']))
    _GeneralName_otherName._cont = ASN1Dict([
        ('type-id', __GeneralName_otherName_type_id),
        ('value', __GeneralName_otherName_value),
        ])
    _GeneralName_otherName._ext = None
    _GeneralName_otherName.TAG = 8
    _GeneralName_rfc822Name = STR_IA5(name='rfc822Name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_dNSName = STR_IA5(name='dNSName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_x400Address = SEQ(name='x400Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ORAddress')))
    _GeneralName_directoryName = CHOICE(name='directoryName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _GeneralName_ediPartyName = SEQ(name='ediPartyName', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'EDIPartyName')))
    _GeneralName_uniformResourceIdentifier = STR_IA5(name='uniformResourceIdentifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_iPAddress = OCT_STR(name='iPAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_registeredID = OID(name='registeredID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GeneralName._cont = ASN1Dict([
        ('otherName', _GeneralName_otherName),
        ('rfc822Name', _GeneralName_rfc822Name),
        ('dNSName', _GeneralName_dNSName),
        ('x400Address', _GeneralName_x400Address),
        ('directoryName', _GeneralName_directoryName),
        ('ediPartyName', _GeneralName_ediPartyName),
        ('uniformResourceIdentifier', _GeneralName_uniformResourceIdentifier),
        ('iPAddress', _GeneralName_iPAddress),
        ('registeredID', _GeneralName_registeredID),
        ])
    GeneralName._ext = []
    
    #-----< OTHER-NAME >-----#
    OTHER_NAME = CLASS(name='OTHER-NAME', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< EDIPartyName >-----#
    EDIPartyName = SEQ(name='EDIPartyName', mode=MODE_TYPE)
    _EDIPartyName_nameAssigner = CHOICE(name='nameAssigner', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _EDIPartyName_partyName = CHOICE(name='partyName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    EDIPartyName._cont = ASN1Dict([
        ('nameAssigner', _EDIPartyName_nameAssigner),
        ('partyName', _EDIPartyName_partyName),
        ])
    EDIPartyName._ext = []
    
    #-----< issuerAltName >-----#
    issuerAltName = CLASS(name='issuerAltName', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuerAltName_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    issuerAltName._val = dict([('ExtnType', _issuerAltName_val_ExtnType), ('id', (2, 5, 29, 18))])
    
    #-----< subjectDirectoryAttributes >-----#
    subjectDirectoryAttributes = CLASS(name='subjectDirectoryAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectDirectoryAttributes_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AttributesSyntax')))
    subjectDirectoryAttributes._val = dict([('ExtnType', _subjectDirectoryAttributes_val_ExtnType), ('id', (2, 5, 29, 9))])
    
    #-----< AttributesSyntax >-----#
    AttributesSyntax = SEQ_OF(name='AttributesSyntax', mode=MODE_TYPE)
    _AttributesSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __AttributesSyntax__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___AttributesSyntax__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____AttributesSyntax__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ____AttributesSyntax__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___AttributesSyntax__item__type_tab._val = ASN1Set(rv=[dict([('Type', ____AttributesSyntax__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____AttributesSyntax__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __AttributesSyntax__item__type._const_tab = ___AttributesSyntax__item__type_tab
    __AttributesSyntax__item__type._const_tab_at = None
    __AttributesSyntax__item__type._const_tab_id = 'id'
    __AttributesSyntax__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ___AttributesSyntax__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___AttributesSyntax__item__values__item_._const_tab = ___AttributesSyntax__item__type_tab
    ___AttributesSyntax__item__values__item_._const_tab_at = ('..', '..', 'type')
    ___AttributesSyntax__item__values__item_._const_tab_id = 'Type'
    __AttributesSyntax__item__values._cont = ___AttributesSyntax__item__values__item_
    __AttributesSyntax__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __AttributesSyntax__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___AttributesSyntax__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____AttributesSyntax__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab = ___AttributesSyntax__item__type_tab
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ____AttributesSyntax__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____AttributesSyntax__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____AttributesSyntax__item__valuesWithContext__item__contextList._cont = _____AttributesSyntax__item__valuesWithContext__item__contextList__item_
    ____AttributesSyntax__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___AttributesSyntax__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____AttributesSyntax__item__valuesWithContext__item__value),
        ('contextList', ____AttributesSyntax__item__valuesWithContext__item__contextList),
        ])
    ___AttributesSyntax__item__valuesWithContext__item_._ext = []
    __AttributesSyntax__item__valuesWithContext._cont = ___AttributesSyntax__item__valuesWithContext__item_
    __AttributesSyntax__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributesSyntax__item_._cont = ASN1Dict([
        ('type', __AttributesSyntax__item__type),
        ('values', __AttributesSyntax__item__values),
        ('valuesWithContext', __AttributesSyntax__item__valuesWithContext),
        ])
    _AttributesSyntax__item_._ext = []
    AttributesSyntax._cont = _AttributesSyntax__item_
    AttributesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< basicConstraints >-----#
    basicConstraints = CLASS(name='basicConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _basicConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'BasicConstraintsSyntax')))
    basicConstraints._val = dict([('ExtnType', _basicConstraints_val_ExtnType), ('id', (2, 5, 29, 19))])
    
    #-----< BasicConstraintsSyntax >-----#
    BasicConstraintsSyntax = SEQ(name='BasicConstraintsSyntax', mode=MODE_TYPE)
    _BasicConstraintsSyntax_cA = BOOL(name='cA', mode=MODE_TYPE, default=False)
    _BasicConstraintsSyntax_pathLenConstraint = INT(name='pathLenConstraint', mode=MODE_TYPE, opt=True)
    _BasicConstraintsSyntax_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    BasicConstraintsSyntax._cont = ASN1Dict([
        ('cA', _BasicConstraintsSyntax_cA),
        ('pathLenConstraint', _BasicConstraintsSyntax_pathLenConstraint),
        ])
    BasicConstraintsSyntax._ext = []
    
    #-----< nameConstraints >-----#
    nameConstraints = CLASS(name='nameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _nameConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    nameConstraints._val = dict([('ExtnType', _nameConstraints_val_ExtnType), ('id', (2, 5, 29, 30))])
    
    #-----< NameConstraintsSyntax >-----#
    NameConstraintsSyntax = SEQ(name='NameConstraintsSyntax', mode=MODE_TYPE)
    _NameConstraintsSyntax_permittedSubtrees = SEQ_OF(name='permittedSubtrees', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtrees')), opt=True)
    _NameConstraintsSyntax_excludedSubtrees = SEQ_OF(name='excludedSubtrees', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtrees')), opt=True)
    NameConstraintsSyntax._cont = ASN1Dict([
        ('permittedSubtrees', _NameConstraintsSyntax_permittedSubtrees),
        ('excludedSubtrees', _NameConstraintsSyntax_excludedSubtrees),
        ])
    NameConstraintsSyntax._ext = []
    
    #-----< GeneralSubtrees >-----#
    GeneralSubtrees = SEQ_OF(name='GeneralSubtrees', mode=MODE_TYPE)
    _GeneralSubtrees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtree')))
    GeneralSubtrees._cont = _GeneralSubtrees__item_
    GeneralSubtrees._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralSubtree >-----#
    GeneralSubtree = SEQ(name='GeneralSubtree', mode=MODE_TYPE)
    _GeneralSubtree_base = CHOICE(name='base', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _GeneralSubtree_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseDistance')), default=0)
    _GeneralSubtree_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseDistance')), opt=True)
    GeneralSubtree._cont = ASN1Dict([
        ('base', _GeneralSubtree_base),
        ('minimum', _GeneralSubtree_minimum),
        ('maximum', _GeneralSubtree_maximum),
        ])
    GeneralSubtree._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name='BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< policyConstraints >-----#
    policyConstraints = CLASS(name='policyConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _policyConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyConstraintsSyntax')))
    policyConstraints._val = dict([('ExtnType', _policyConstraints_val_ExtnType), ('id', (2, 5, 29, 36))])
    
    #-----< PolicyConstraintsSyntax >-----#
    PolicyConstraintsSyntax = SEQ(name='PolicyConstraintsSyntax', mode=MODE_TYPE)
    _PolicyConstraintsSyntax_requireExplicitPolicy = INT(name='requireExplicitPolicy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')), opt=True)
    _PolicyConstraintsSyntax_inhibitPolicyMapping = INT(name='inhibitPolicyMapping', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')), opt=True)
    PolicyConstraintsSyntax._cont = ASN1Dict([
        ('requireExplicitPolicy', _PolicyConstraintsSyntax_requireExplicitPolicy),
        ('inhibitPolicyMapping', _PolicyConstraintsSyntax_inhibitPolicyMapping),
        ])
    PolicyConstraintsSyntax._ext = []
    
    #-----< SkipCerts >-----#
    SkipCerts = INT(name='SkipCerts', mode=MODE_TYPE)
    SkipCerts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< inhibitAnyPolicy >-----#
    inhibitAnyPolicy = CLASS(name='inhibitAnyPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _inhibitAnyPolicy_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')))
    inhibitAnyPolicy._val = dict([('ExtnType', _inhibitAnyPolicy_val_ExtnType), ('id', (2, 5, 29, 54))])
    
    #-----< cRLNumber >-----#
    cRLNumber = CLASS(name='cRLNumber', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLNumber_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    cRLNumber._val = dict([('ExtnType', _cRLNumber_val_ExtnType), ('id', (2, 5, 29, 20))])
    
    #-----< CRLNumber >-----#
    CRLNumber = INT(name='CRLNumber', mode=MODE_TYPE)
    CRLNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< crlScope >-----#
    crlScope = CLASS(name='crlScope', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _crlScope_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLScopeSyntax')))
    crlScope._val = dict([('ExtnType', _crlScope_val_ExtnType), ('id', (2, 5, 29, 44))])
    
    #-----< CRLScopeSyntax >-----#
    CRLScopeSyntax = SEQ_OF(name='CRLScopeSyntax', mode=MODE_TYPE)
    _CRLScopeSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PerAuthorityScope')))
    CRLScopeSyntax._cont = _CRLScopeSyntax__item_
    CRLScopeSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PerAuthorityScope >-----#
    PerAuthorityScope = SEQ(name='PerAuthorityScope', mode=MODE_TYPE)
    _PerAuthorityScope_authorityName = CHOICE(name='authorityName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _PerAuthorityScope_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _PerAuthorityScope_onlyContains = BIT_STR(name='onlyContains', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'OnlyCertificateTypes')), opt=True)
    _PerAuthorityScope_onlySomeReasons = BIT_STR(name='onlySomeReasons', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _PerAuthorityScope_serialNumberRange = SEQ(name='serialNumberRange', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')), opt=True)
    _PerAuthorityScope_subjectKeyIdRange = SEQ(name='subjectKeyIdRange', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')), opt=True)
    _PerAuthorityScope_nameSubtrees = SEQ_OF(name='nameSubtrees', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _PerAuthorityScope_baseRevocationInfo = SEQ(name='baseRevocationInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseRevocationInfo')), opt=True)
    PerAuthorityScope._cont = ASN1Dict([
        ('authorityName', _PerAuthorityScope_authorityName),
        ('distributionPoint', _PerAuthorityScope_distributionPoint),
        ('onlyContains', _PerAuthorityScope_onlyContains),
        ('onlySomeReasons', _PerAuthorityScope_onlySomeReasons),
        ('serialNumberRange', _PerAuthorityScope_serialNumberRange),
        ('subjectKeyIdRange', _PerAuthorityScope_subjectKeyIdRange),
        ('nameSubtrees', _PerAuthorityScope_nameSubtrees),
        ('baseRevocationInfo', _PerAuthorityScope_baseRevocationInfo),
        ])
    PerAuthorityScope._ext = []
    
    #-----< OnlyCertificateTypes >-----#
    OnlyCertificateTypes = BIT_STR(name='OnlyCertificateTypes', mode=MODE_TYPE)
    OnlyCertificateTypes._cont = ASN1Dict([('user', 0), ('authority', 1), ('attribute', 2)])
    
    #-----< NumberRange >-----#
    NumberRange = SEQ(name='NumberRange', mode=MODE_TYPE)
    _NumberRange_startingNumber = INT(name='startingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NumberRange_endingNumber = INT(name='endingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NumberRange_modulus = INT(name='modulus', mode=MODE_TYPE, opt=True)
    NumberRange._cont = ASN1Dict([
        ('startingNumber', _NumberRange_startingNumber),
        ('endingNumber', _NumberRange_endingNumber),
        ('modulus', _NumberRange_modulus),
        ])
    NumberRange._ext = []
    
    #-----< BaseRevocationInfo >-----#
    BaseRevocationInfo = SEQ(name='BaseRevocationInfo', mode=MODE_TYPE)
    _BaseRevocationInfo_cRLStreamIdentifier = INT(name='cRLStreamIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLStreamIdentifier')), opt=True)
    _BaseRevocationInfo_cRLNumber = INT(name='cRLNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    _BaseRevocationInfo_baseThisUpdate = TIME_GEN(name='baseThisUpdate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    BaseRevocationInfo._cont = ASN1Dict([
        ('cRLStreamIdentifier', _BaseRevocationInfo_cRLStreamIdentifier),
        ('cRLNumber', _BaseRevocationInfo_cRLNumber),
        ('baseThisUpdate', _BaseRevocationInfo_baseThisUpdate),
        ])
    BaseRevocationInfo._ext = []
    
    #-----< statusReferrals >-----#
    statusReferrals = CLASS(name='statusReferrals', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _statusReferrals_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'StatusReferrals')))
    statusReferrals._val = dict([('ExtnType', _statusReferrals_val_ExtnType), ('id', (2, 5, 29, 45))])
    
    #-----< StatusReferrals >-----#
    StatusReferrals = SEQ_OF(name='StatusReferrals', mode=MODE_TYPE)
    _StatusReferrals__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'StatusReferral')))
    StatusReferrals._cont = _StatusReferrals__item_
    StatusReferrals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< StatusReferral >-----#
    StatusReferral = CHOICE(name='StatusReferral', mode=MODE_TYPE)
    _StatusReferral_cRLReferral = SEQ(name='cRLReferral', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLReferral')))
    _StatusReferral_otherReferral = SEQ(name='otherReferral', mode=MODE_TYPE)
    __StatusReferral_otherReferral_type_id = OID(name='type-id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-REFERRAL'), ['id']))
    __StatusReferral_otherReferral_value = OPEN(name='value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-REFERRAL'), ['Type']))
    _StatusReferral_otherReferral._cont = ASN1Dict([
        ('type-id', __StatusReferral_otherReferral_type_id),
        ('value', __StatusReferral_otherReferral_value),
        ])
    _StatusReferral_otherReferral._ext = None
    _StatusReferral_otherReferral.TAG = 8
    StatusReferral._cont = ASN1Dict([
        ('cRLReferral', _StatusReferral_cRLReferral),
        ('otherReferral', _StatusReferral_otherReferral),
        ])
    StatusReferral._ext = []
    
    #-----< CRLReferral >-----#
    CRLReferral = SEQ(name='CRLReferral', mode=MODE_TYPE)
    _CRLReferral_issuer = CHOICE(name='issuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _CRLReferral_location = CHOICE(name='location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _CRLReferral_deltaRefInfo = SEQ(name='deltaRefInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DeltaRefInfo')), opt=True)
    _CRLReferral_cRLScope = SEQ_OF(name='cRLScope', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLScopeSyntax')))
    _CRLReferral_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CRLReferral_lastChangedCRL = TIME_GEN(name='lastChangedCRL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CRLReferral._cont = ASN1Dict([
        ('issuer', _CRLReferral_issuer),
        ('location', _CRLReferral_location),
        ('deltaRefInfo', _CRLReferral_deltaRefInfo),
        ('cRLScope', _CRLReferral_cRLScope),
        ('lastUpdate', _CRLReferral_lastUpdate),
        ('lastChangedCRL', _CRLReferral_lastChangedCRL),
        ])
    CRLReferral._ext = []
    
    #-----< DeltaRefInfo >-----#
    DeltaRefInfo = SEQ(name='DeltaRefInfo', mode=MODE_TYPE)
    _DeltaRefInfo_deltaLocation = CHOICE(name='deltaLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _DeltaRefInfo_lastDelta = TIME_GEN(name='lastDelta', mode=MODE_TYPE, opt=True)
    DeltaRefInfo._cont = ASN1Dict([
        ('deltaLocation', _DeltaRefInfo_deltaLocation),
        ('lastDelta', _DeltaRefInfo_lastDelta),
        ])
    DeltaRefInfo._ext = []
    
    #-----< OTHER-REFERRAL >-----#
    OTHER_REFERRAL = CLASS(name='OTHER-REFERRAL', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< cRLStreamIdentifier >-----#
    cRLStreamIdentifier = CLASS(name='cRLStreamIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLStreamIdentifier_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLStreamIdentifier')))
    cRLStreamIdentifier._val = dict([('ExtnType', _cRLStreamIdentifier_val_ExtnType), ('id', (2, 5, 29, 40))])
    
    #-----< CRLStreamIdentifier >-----#
    CRLStreamIdentifier = INT(name='CRLStreamIdentifier', mode=MODE_TYPE)
    CRLStreamIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< orderedList >-----#
    orderedList = CLASS(name='orderedList', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _orderedList_val_ExtnType = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'OrderedListSyntax')))
    orderedList._val = dict([('ExtnType', _orderedList_val_ExtnType), ('id', (2, 5, 29, 47))])
    
    #-----< OrderedListSyntax >-----#
    OrderedListSyntax = ENUM(name='OrderedListSyntax', mode=MODE_TYPE)
    OrderedListSyntax._cont = ASN1Dict([('ascSerialNum', 0), ('ascRevDate', 1)])
    OrderedListSyntax._ext = []
    
    #-----< deltaInfo >-----#
    deltaInfo = CLASS(name='deltaInfo', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _deltaInfo_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DeltaInformation')))
    deltaInfo._val = dict([('ExtnType', _deltaInfo_val_ExtnType), ('id', (2, 5, 29, 53))])
    
    #-----< DeltaInformation >-----#
    DeltaInformation = SEQ(name='DeltaInformation', mode=MODE_TYPE)
    _DeltaInformation_deltaLocation = CHOICE(name='deltaLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _DeltaInformation_nextDelta = TIME_GEN(name='nextDelta', mode=MODE_TYPE, opt=True)
    DeltaInformation._cont = ASN1Dict([
        ('deltaLocation', _DeltaInformation_deltaLocation),
        ('nextDelta', _DeltaInformation_nextDelta),
        ])
    DeltaInformation._ext = []
    
    #-----< toBeRevoked >-----#
    toBeRevoked = CLASS(name='toBeRevoked', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _toBeRevoked_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ToBeRevokedSyntax')))
    toBeRevoked._val = dict([('ExtnType', _toBeRevoked_val_ExtnType), ('id', (2, 5, 29, 58))])
    
    #-----< ToBeRevokedSyntax >-----#
    ToBeRevokedSyntax = SEQ_OF(name='ToBeRevokedSyntax', mode=MODE_TYPE)
    _ToBeRevokedSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ToBeRevokedGroup')))
    ToBeRevokedSyntax._cont = _ToBeRevokedSyntax__item_
    ToBeRevokedSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ToBeRevokedGroup >-----#
    ToBeRevokedGroup = SEQ(name='ToBeRevokedGroup', mode=MODE_TYPE)
    _ToBeRevokedGroup_certificateIssuer = CHOICE(name='certificateIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _ToBeRevokedGroup_reasonInfo = SEQ(name='reasonInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonInfo')), opt=True)
    _ToBeRevokedGroup_revocationTime = TIME_GEN(name='revocationTime', mode=MODE_TYPE)
    _ToBeRevokedGroup_certificateGroup = CHOICE(name='certificateGroup', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateGroup')))
    ToBeRevokedGroup._cont = ASN1Dict([
        ('certificateIssuer', _ToBeRevokedGroup_certificateIssuer),
        ('reasonInfo', _ToBeRevokedGroup_reasonInfo),
        ('revocationTime', _ToBeRevokedGroup_revocationTime),
        ('certificateGroup', _ToBeRevokedGroup_certificateGroup),
        ])
    ToBeRevokedGroup._ext = []
    
    #-----< ReasonInfo >-----#
    ReasonInfo = SEQ(name='ReasonInfo', mode=MODE_TYPE)
    _ReasonInfo_reasonCode = ENUM(name='reasonCode', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLReason')))
    _ReasonInfo_holdInstructionCode = OID(name='holdInstructionCode', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'HoldInstruction')), opt=True)
    ReasonInfo._cont = ASN1Dict([
        ('reasonCode', _ReasonInfo_reasonCode),
        ('holdInstructionCode', _ReasonInfo_holdInstructionCode),
        ])
    ReasonInfo._ext = []
    
    #-----< CertificateGroup >-----#
    CertificateGroup = CHOICE(name='CertificateGroup', mode=MODE_TYPE)
    _CertificateGroup_serialNumbers = SEQ_OF(name='serialNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateSerialNumbers')))
    _CertificateGroup_serialNumberRange = SEQ(name='serialNumberRange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateGroupNumberRange')))
    _CertificateGroup_nameSubtree = CHOICE(name='nameSubtree', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    CertificateGroup._cont = ASN1Dict([
        ('serialNumbers', _CertificateGroup_serialNumbers),
        ('serialNumberRange', _CertificateGroup_serialNumberRange),
        ('nameSubtree', _CertificateGroup_nameSubtree),
        ])
    CertificateGroup._ext = []
    
    #-----< CertificateGroupNumberRange >-----#
    CertificateGroupNumberRange = SEQ(name='CertificateGroupNumberRange', mode=MODE_TYPE)
    _CertificateGroupNumberRange_startingNumber = INT(name='startingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CertificateGroupNumberRange_endingNumber = INT(name='endingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CertificateGroupNumberRange._cont = ASN1Dict([
        ('startingNumber', _CertificateGroupNumberRange_startingNumber),
        ('endingNumber', _CertificateGroupNumberRange_endingNumber),
        ])
    CertificateGroupNumberRange._ext = []
    
    #-----< CertificateSerialNumbers >-----#
    CertificateSerialNumbers = SEQ_OF(name='CertificateSerialNumbers', mode=MODE_TYPE)
    _CertificateSerialNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    CertificateSerialNumbers._cont = _CertificateSerialNumbers__item_
    CertificateSerialNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< revokedGroups >-----#
    revokedGroups = CLASS(name='revokedGroups', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _revokedGroups_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'RevokedGroupsSyntax')))
    revokedGroups._val = dict([('ExtnType', _revokedGroups_val_ExtnType), ('id', (2, 5, 29, 59))])
    
    #-----< RevokedGroupsSyntax >-----#
    RevokedGroupsSyntax = SEQ_OF(name='RevokedGroupsSyntax', mode=MODE_TYPE)
    _RevokedGroupsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'RevokedGroup')))
    RevokedGroupsSyntax._cont = _RevokedGroupsSyntax__item_
    RevokedGroupsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RevokedGroup >-----#
    RevokedGroup = SEQ(name='RevokedGroup', mode=MODE_TYPE)
    _RevokedGroup_certificateIssuer = CHOICE(name='certificateIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _RevokedGroup_reasonInfo = SEQ(name='reasonInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonInfo')), opt=True)
    _RevokedGroup_invalidityDate = TIME_GEN(name='invalidityDate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RevokedGroup_revokedcertificateGroup = CHOICE(name='revokedcertificateGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'RevokedCertificateGroup')))
    RevokedGroup._cont = ASN1Dict([
        ('certificateIssuer', _RevokedGroup_certificateIssuer),
        ('reasonInfo', _RevokedGroup_reasonInfo),
        ('invalidityDate', _RevokedGroup_invalidityDate),
        ('revokedcertificateGroup', _RevokedGroup_revokedcertificateGroup),
        ])
    RevokedGroup._ext = []
    
    #-----< RevokedCertificateGroup >-----#
    RevokedCertificateGroup = CHOICE(name='RevokedCertificateGroup', mode=MODE_TYPE)
    _RevokedCertificateGroup_serialNumberRange = SEQ(name='serialNumberRange', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')))
    _RevokedCertificateGroup_nameSubtree = CHOICE(name='nameSubtree', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    RevokedCertificateGroup._cont = ASN1Dict([
        ('serialNumberRange', _RevokedCertificateGroup_serialNumberRange),
        ('nameSubtree', _RevokedCertificateGroup_nameSubtree),
        ])
    RevokedCertificateGroup._ext = None
    
    #-----< expiredCertsOnCRL >-----#
    expiredCertsOnCRL = CLASS(name='expiredCertsOnCRL', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _expiredCertsOnCRL_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ExpiredCertsOnCRL')))
    expiredCertsOnCRL._val = dict([('ExtnType', _expiredCertsOnCRL_val_ExtnType), ('id', (2, 5, 29, 60))])
    
    #-----< ExpiredCertsOnCRL >-----#
    ExpiredCertsOnCRL = TIME_GEN(name='ExpiredCertsOnCRL', mode=MODE_TYPE)
    
    #-----< reasonCode >-----#
    reasonCode = CLASS(name='reasonCode', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _reasonCode_val_ExtnType = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLReason')))
    reasonCode._val = dict([('ExtnType', _reasonCode_val_ExtnType), ('id', (2, 5, 29, 21))])
    
    #-----< CRLReason >-----#
    CRLReason = ENUM(name='CRLReason', mode=MODE_TYPE)
    CRLReason._cont = ASN1Dict([('unspecified', 0), ('keyCompromise', 1), ('cACompromise', 2), ('affiliationChanged', 3), ('superseded', 4), ('cessationOfOperation', 5), ('certificateHold', 6), ('removeFromCRL', 8), ('privilegeWithdrawn', 9), ('aACompromise', 10), ('weakAlgorithmOrKey', 11)])
    CRLReason._ext = ['weakAlgorithmOrKey']
    
    #-----< holdInstructionCode >-----#
    holdInstructionCode = CLASS(name='holdInstructionCode', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _holdInstructionCode_val_ExtnType = OID(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'HoldInstruction')))
    holdInstructionCode._val = dict([('ExtnType', _holdInstructionCode_val_ExtnType), ('id', (2, 5, 29, 23))])
    
    #-----< HoldInstruction >-----#
    HoldInstruction = OID(name='HoldInstruction', mode=MODE_TYPE)
    
    #-----< invalidityDate >-----#
    invalidityDate = CLASS(name='invalidityDate', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _invalidityDate_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    invalidityDate._val = dict([('ExtnType', _invalidityDate_val_ExtnType), ('id', (2, 5, 29, 24))])
    
    #-----< cRLDistributionPoints >-----#
    cRLDistributionPoints = CLASS(name='cRLDistributionPoints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLDistributionPoints_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLDistPointsSyntax')))
    cRLDistributionPoints._val = dict([('ExtnType', _cRLDistributionPoints_val_ExtnType), ('id', (2, 5, 29, 31))])
    
    #-----< CRLDistPointsSyntax >-----#
    CRLDistPointsSyntax = SEQ_OF(name='CRLDistPointsSyntax', mode=MODE_TYPE)
    _CRLDistPointsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DistributionPoint')))
    CRLDistPointsSyntax._cont = _CRLDistPointsSyntax__item_
    CRLDistPointsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< DistributionPoint >-----#
    DistributionPoint = SEQ(name='DistributionPoint', mode=MODE_TYPE)
    _DistributionPoint_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _DistributionPoint_reasons = BIT_STR(name='reasons', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _DistributionPoint_cRLIssuer = SEQ_OF(name='cRLIssuer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    DistributionPoint._cont = ASN1Dict([
        ('distributionPoint', _DistributionPoint_distributionPoint),
        ('reasons', _DistributionPoint_reasons),
        ('cRLIssuer', _DistributionPoint_cRLIssuer),
        ])
    DistributionPoint._ext = []
    
    #-----< DistributionPointName >-----#
    DistributionPointName = CHOICE(name='DistributionPointName', mode=MODE_TYPE)
    _DistributionPointName_fullName = SEQ_OF(name='fullName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _DistributionPointName_nameRelativeToCRLIssuer = SET_OF(name='nameRelativeToCRLIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    DistributionPointName._cont = ASN1Dict([
        ('fullName', _DistributionPointName_fullName),
        ('nameRelativeToCRLIssuer', _DistributionPointName_nameRelativeToCRLIssuer),
        ])
    DistributionPointName._ext = []
    
    #-----< ReasonFlags >-----#
    ReasonFlags = BIT_STR(name='ReasonFlags', mode=MODE_TYPE)
    ReasonFlags._cont = ASN1Dict([('unused', 0), ('keyCompromise', 1), ('cACompromise', 2), ('affiliationChanged', 3), ('superseded', 4), ('cessationOfOperation', 5), ('certificateHold', 6), ('privilegeWithdrawn', 7), ('aACompromise', 8), ('weakAlgorithmOrKey', 9)])
    
    #-----< issuingDistributionPoint >-----#
    issuingDistributionPoint = CLASS(name='issuingDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuingDistributionPoint_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'IssuingDistPointSyntax')))
    issuingDistributionPoint._val = dict([('ExtnType', _issuingDistributionPoint_val_ExtnType), ('id', (2, 5, 29, 28))])
    
    #-----< IssuingDistPointSyntax >-----#
    IssuingDistPointSyntax = SEQ(name='IssuingDistPointSyntax', mode=MODE_TYPE)
    _IssuingDistPointSyntax_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts = BOOL(name='onlyContainsUserPublicKeyCerts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlyContainsCACerts = BOOL(name='onlyContainsCACerts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlySomeReasons = BIT_STR(name='onlySomeReasons', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _IssuingDistPointSyntax_indirectCRL = BOOL(name='indirectCRL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlyContainsAttributeCerts = BOOL(name='onlyContainsAttributeCerts', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IssuingDistPointSyntax._cont = ASN1Dict([
        ('distributionPoint', _IssuingDistPointSyntax_distributionPoint),
        ('onlyContainsUserPublicKeyCerts', _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts),
        ('onlyContainsCACerts', _IssuingDistPointSyntax_onlyContainsCACerts),
        ('onlySomeReasons', _IssuingDistPointSyntax_onlySomeReasons),
        ('indirectCRL', _IssuingDistPointSyntax_indirectCRL),
        ('onlyContainsAttributeCerts', _IssuingDistPointSyntax_onlyContainsAttributeCerts),
        ])
    IssuingDistPointSyntax._ext = []
    
    #-----< certificateIssuer >-----#
    certificateIssuer = CLASS(name='certificateIssuer', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _certificateIssuer_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    certificateIssuer._val = dict([('ExtnType', _certificateIssuer_val_ExtnType), ('id', (2, 5, 29, 29))])
    
    #-----< deltaCRLIndicator >-----#
    deltaCRLIndicator = CLASS(name='deltaCRLIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _deltaCRLIndicator_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'BaseCRLNumber')))
    deltaCRLIndicator._val = dict([('ExtnType', _deltaCRLIndicator_val_ExtnType), ('id', (2, 5, 29, 27))])
    
    #-----< BaseCRLNumber >-----#
    BaseCRLNumber = INT(name='BaseCRLNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    
    #-----< baseUpdateTime >-----#
    baseUpdateTime = CLASS(name='baseUpdateTime', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _baseUpdateTime_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    baseUpdateTime._val = dict([('ExtnType', _baseUpdateTime_val_ExtnType), ('id', (2, 5, 29, 51))])
    
    #-----< freshestCRL >-----#
    freshestCRL = CLASS(name='freshestCRL', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _freshestCRL_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLDistPointsSyntax')))
    freshestCRL._val = dict([('ExtnType', _freshestCRL_val_ExtnType), ('id', (2, 5, 29, 46))])
    
    #-----< aAissuingDistributionPoint >-----#
    aAissuingDistributionPoint = CLASS(name='aAissuingDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _aAissuingDistributionPoint_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AAIssuingDistPointSyntax')))
    aAissuingDistributionPoint._val = dict([('ExtnType', _aAissuingDistributionPoint_val_ExtnType), ('id', (2, 5, 29, 63))])
    
    #-----< AAIssuingDistPointSyntax >-----#
    AAIssuingDistPointSyntax = SEQ(name='AAIssuingDistPointSyntax', mode=MODE_TYPE)
    _AAIssuingDistPointSyntax_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _AAIssuingDistPointSyntax_onlySomeReasons = BIT_STR(name='onlySomeReasons', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _AAIssuingDistPointSyntax_indirectCRL = BOOL(name='indirectCRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AAIssuingDistPointSyntax_containsUserAttributeCerts = BOOL(name='containsUserAttributeCerts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _AAIssuingDistPointSyntax_containsAACerts = BOOL(name='containsAACerts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts = BOOL(name='containsSOAPublicKeyCerts', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    AAIssuingDistPointSyntax._cont = ASN1Dict([
        ('distributionPoint', _AAIssuingDistPointSyntax_distributionPoint),
        ('onlySomeReasons', _AAIssuingDistPointSyntax_onlySomeReasons),
        ('indirectCRL', _AAIssuingDistPointSyntax_indirectCRL),
        ('containsUserAttributeCerts', _AAIssuingDistPointSyntax_containsUserAttributeCerts),
        ('containsAACerts', _AAIssuingDistPointSyntax_containsAACerts),
        ('containsSOAPublicKeyCerts', _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts),
        ])
    AAIssuingDistPointSyntax._ext = []
    
    #-----< certificateExactMatch >-----#
    certificateExactMatch = CLASS(name='certificateExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    certificateExactMatch._val = dict([('AssertionType', _certificateExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])
    
    #-----< CertificateExactAssertion >-----#
    CertificateExactAssertion = SEQ(name='CertificateExactAssertion', mode=MODE_TYPE)
    _CertificateExactAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _CertificateExactAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    CertificateExactAssertion._cont = ASN1Dict([
        ('serialNumber', _CertificateExactAssertion_serialNumber),
        ('issuer', _CertificateExactAssertion_issuer),
        ])
    CertificateExactAssertion._ext = []
    
    #-----< certificateMatch >-----#
    certificateMatch = CLASS(name='certificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')))
    certificateMatch._val = dict([('AssertionType', _certificateMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 2)), ('ldapName', ['certificateMatch']), ('ldapDesc', 'X.509 Certificate Match'), ('id', (2, 5, 13, 35))])
    
    #-----< CertificateAssertion >-----#
    CertificateAssertion = SEQ(name='CertificateAssertion', mode=MODE_TYPE)
    _CertificateAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _CertificateAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')), opt=True)
    _CertificateAssertion_authorityKeyIdentifier = SEQ(name='authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    _CertificateAssertion_certificateValid = CHOICE(name='certificateValid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateAssertion_privateKeyValid = TIME_GEN(name='privateKeyValid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificateAssertion_subjectPublicKeyAlgID = OID(name='subjectPublicKeyAlgID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificateAssertion_keyUsage = BIT_STR(name='keyUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _CertificateAssertion_subjectAltName = CHOICE(name='subjectAltName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AltNameType')), opt=True)
    _CertificateAssertion_policy = SEQ_OF(name='policy', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertPolicySet')), opt=True)
    _CertificateAssertion_pathToName = CHOICE(name='pathToName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_subject = CHOICE(name='subject', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_nameConstraints = SEQ(name='nameConstraints', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')), opt=True)
    CertificateAssertion._cont = ASN1Dict([
        ('serialNumber', _CertificateAssertion_serialNumber),
        ('issuer', _CertificateAssertion_issuer),
        ('subjectKeyIdentifier', _CertificateAssertion_subjectKeyIdentifier),
        ('authorityKeyIdentifier', _CertificateAssertion_authorityKeyIdentifier),
        ('certificateValid', _CertificateAssertion_certificateValid),
        ('privateKeyValid', _CertificateAssertion_privateKeyValid),
        ('subjectPublicKeyAlgID', _CertificateAssertion_subjectPublicKeyAlgID),
        ('keyUsage', _CertificateAssertion_keyUsage),
        ('subjectAltName', _CertificateAssertion_subjectAltName),
        ('policy', _CertificateAssertion_policy),
        ('pathToName', _CertificateAssertion_pathToName),
        ('subject', _CertificateAssertion_subject),
        ('nameConstraints', _CertificateAssertion_nameConstraints),
        ])
    CertificateAssertion._ext = []
    
    #-----< AltNameType >-----#
    AltNameType = CHOICE(name='AltNameType', mode=MODE_TYPE)
    _AltNameType_builtinNameForm = ENUM(name='builtinNameForm', mode=MODE_TYPE)
    _AltNameType_builtinNameForm._cont = ASN1Dict([('rfc822Name', 1), ('dNSName', 2), ('x400Address', 3), ('directoryName', 4), ('ediPartyName', 5), ('uniformResourceIdentifier', 6), ('iPAddress', 7), ('registeredId', 8)])
    _AltNameType_builtinNameForm._ext = []
    _AltNameType_otherNameForm = OID(name='otherNameForm', mode=MODE_TYPE)
    AltNameType._cont = ASN1Dict([
        ('builtinNameForm', _AltNameType_builtinNameForm),
        ('otherNameForm', _AltNameType_otherNameForm),
        ])
    AltNameType._ext = []
    
    #-----< CertPolicySet >-----#
    CertPolicySet = SEQ_OF(name='CertPolicySet', mode=MODE_TYPE)
    _CertPolicySet__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    CertPolicySet._cont = _CertPolicySet__item_
    CertPolicySet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< certificatePairExactMatch >-----#
    certificatePairExactMatch = CLASS(name='certificatePairExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificatePairExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    certificatePairExactMatch._val = dict([('AssertionType', _certificatePairExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), ('ldapName', ['certificatePairExactMatch']), ('ldapDesc', 'X.509 Certificate Pair Exact Match'), ('id', (2, 5, 13, 36))])
    
    #-----< CertificatePairExactAssertion >-----#
    CertificatePairExactAssertion = SEQ(name='CertificatePairExactAssertion', mode=MODE_TYPE)
    _CertificatePairExactAssertion_issuedToThisCAAssertion = SEQ(name='issuedToThisCAAssertion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')), opt=True)
    _CertificatePairExactAssertion_issuedByThisCAAssertion = SEQ(name='issuedByThisCAAssertion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')), opt=True)
    CertificatePairExactAssertion._cont = ASN1Dict([
        ('issuedToThisCAAssertion', _CertificatePairExactAssertion_issuedToThisCAAssertion),
        ('issuedByThisCAAssertion', _CertificatePairExactAssertion_issuedByThisCAAssertion),
        ])
    CertificatePairExactAssertion._ext = []
    
    #-----< certificatePairMatch >-----#
    certificatePairMatch = CLASS(name='certificatePairMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificatePairMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairAssertion')))
    certificatePairMatch._val = dict([('AssertionType', _certificatePairMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 4)), ('ldapName', ['certificatePairMatch']), ('ldapDesc', 'X.509 Certificate Pair Match'), ('id', (2, 5, 13, 37))])
    
    #-----< CertificatePairAssertion >-----#
    CertificatePairAssertion = SEQ(name='CertificatePairAssertion', mode=MODE_TYPE)
    _CertificatePairAssertion_issuedToThisCAAssertion = SEQ(name='issuedToThisCAAssertion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')), opt=True)
    _CertificatePairAssertion_issuedByThisCAAssertion = SEQ(name='issuedByThisCAAssertion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')), opt=True)
    CertificatePairAssertion._cont = ASN1Dict([
        ('issuedToThisCAAssertion', _CertificatePairAssertion_issuedToThisCAAssertion),
        ('issuedByThisCAAssertion', _CertificatePairAssertion_issuedByThisCAAssertion),
        ])
    CertificatePairAssertion._ext = []
    
    #-----< certificateListExactMatch >-----#
    certificateListExactMatch = CLASS(name='certificateListExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateListExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    certificateListExactMatch._val = dict([('AssertionType', _certificateListExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])
    
    #-----< CertificateListExactAssertion >-----#
    CertificateListExactAssertion = SEQ(name='CertificateListExactAssertion', mode=MODE_TYPE)
    _CertificateListExactAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CertificateListExactAssertion_thisUpdate = CHOICE(name='thisUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _CertificateListExactAssertion_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    CertificateListExactAssertion._cont = ASN1Dict([
        ('issuer', _CertificateListExactAssertion_issuer),
        ('thisUpdate', _CertificateListExactAssertion_thisUpdate),
        ('distributionPoint', _CertificateListExactAssertion_distributionPoint),
        ])
    CertificateListExactAssertion._ext = None
    
    #-----< certificateListMatch >-----#
    certificateListMatch = CLASS(name='certificateListMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateListMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListAssertion')))
    certificateListMatch._val = dict([('AssertionType', _certificateListMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 6)), ('ldapName', ['certificateListMatch']), ('ldapDesc', 'X.509 Certificate List Match'), ('id', (2, 5, 13, 39))])
    
    #-----< CertificateListAssertion >-----#
    CertificateListAssertion = SEQ(name='CertificateListAssertion', mode=MODE_TYPE)
    _CertificateListAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateListAssertion_minCRLNumber = INT(name='minCRLNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')), opt=True)
    _CertificateListAssertion_maxCRLNumber = INT(name='maxCRLNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')), opt=True)
    _CertificateListAssertion_reasonFlags = BIT_STR(name='reasonFlags', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _CertificateListAssertion_dateAndTime = CHOICE(name='dateAndTime', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateListAssertion_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _CertificateListAssertion_authorityKeyIdentifier = SEQ(name='authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    CertificateListAssertion._cont = ASN1Dict([
        ('issuer', _CertificateListAssertion_issuer),
        ('minCRLNumber', _CertificateListAssertion_minCRLNumber),
        ('maxCRLNumber', _CertificateListAssertion_maxCRLNumber),
        ('reasonFlags', _CertificateListAssertion_reasonFlags),
        ('dateAndTime', _CertificateListAssertion_dateAndTime),
        ('distributionPoint', _CertificateListAssertion_distributionPoint),
        ('authorityKeyIdentifier', _CertificateListAssertion_authorityKeyIdentifier),
        ])
    CertificateListAssertion._ext = []
    
    #-----< algorithmIdentifierMatch >-----#
    algorithmIdentifierMatch = CLASS(name='algorithmIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _algorithmIdentifierMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __algorithmIdentifierMatch_val_AssertionType_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab = ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab_at = None
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab_id = 'id'
    __algorithmIdentifierMatch_val_AssertionType_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___algorithmIdentifierMatch_val_AssertionType_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifierMatch_val_AssertionType_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab = ___algorithmIdentifierMatch_val_AssertionType_parameters_tab
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab_at = ('..', 'algorithm')
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab_id = 'Type'
    _algorithmIdentifierMatch_val_AssertionType._cont = ASN1Dict([
        ('algorithm', __algorithmIdentifierMatch_val_AssertionType_algorithm),
        ('parameters', __algorithmIdentifierMatch_val_AssertionType_parameters),
        ])
    _algorithmIdentifierMatch_val_AssertionType._ext = []
    algorithmIdentifierMatch._val = dict([('AssertionType', _algorithmIdentifierMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 7)), ('ldapName', ['algorithmIdentifierMatch']), ('ldapDesc', 'X.509 Algorithm Identifier Match'), ('id', (2, 5, 13, 40))])
    
    #-----< policyMatch >-----#
    policyMatch = CLASS(name='policyMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _policyMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicyID')))
    policyMatch._val = dict([('AssertionType', _policyMatch_val_AssertionType), ('id', (2, 5, 13, 60))])
    
    #-----< pkiPathMatch >-----#
    pkiPathMatch = CLASS(name='pkiPathMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _pkiPathMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PkiPathMatchSyntax')))
    pkiPathMatch._val = dict([('AssertionType', _pkiPathMatch_val_AssertionType), ('id', (2, 5, 13, 62))])
    
    #-----< PkiPathMatchSyntax >-----#
    PkiPathMatchSyntax = SEQ(name='PkiPathMatchSyntax', mode=MODE_TYPE)
    _PkiPathMatchSyntax_firstIssuer = CHOICE(name='firstIssuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _PkiPathMatchSyntax_lastSubject = CHOICE(name='lastSubject', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    PkiPathMatchSyntax._cont = ASN1Dict([
        ('firstIssuer', _PkiPathMatchSyntax_firstIssuer),
        ('lastSubject', _PkiPathMatchSyntax_lastSubject),
        ])
    PkiPathMatchSyntax._ext = []
    
    #-----< enhancedCertificateMatch >-----#
    enhancedCertificateMatch = CLASS(name='enhancedCertificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _enhancedCertificateMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'EnhancedCertificateAssertion')))
    enhancedCertificateMatch._val = dict([('AssertionType', _enhancedCertificateMatch_val_AssertionType), ('id', (2, 5, 13, 65))])
    
    #-----< EnhancedCertificateAssertion >-----#
    EnhancedCertificateAssertion = SEQ(name='EnhancedCertificateAssertion', mode=MODE_TYPE)
    _EnhancedCertificateAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _EnhancedCertificateAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _EnhancedCertificateAssertion_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')), opt=True)
    _EnhancedCertificateAssertion_authorityKeyIdentifier = SEQ(name='authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    _EnhancedCertificateAssertion_certificateValid = CHOICE(name='certificateValid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _EnhancedCertificateAssertion_privateKeyValid = TIME_GEN(name='privateKeyValid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancedCertificateAssertion_subjectPublicKeyAlgID = OID(name='subjectPublicKeyAlgID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancedCertificateAssertion_keyUsage = BIT_STR(name='keyUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _EnhancedCertificateAssertion_subjectAltName = SEQ(name='subjectAltName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AltName')), opt=True)
    _EnhancedCertificateAssertion_policy = SEQ_OF(name='policy', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertPolicySet')), opt=True)
    _EnhancedCertificateAssertion_pathToName = SEQ_OF(name='pathToName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _EnhancedCertificateAssertion_subject = CHOICE(name='subject', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _EnhancedCertificateAssertion_nameConstraints = SEQ(name='nameConstraints', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')), opt=True)
    EnhancedCertificateAssertion._cont = ASN1Dict([
        ('serialNumber', _EnhancedCertificateAssertion_serialNumber),
        ('issuer', _EnhancedCertificateAssertion_issuer),
        ('subjectKeyIdentifier', _EnhancedCertificateAssertion_subjectKeyIdentifier),
        ('authorityKeyIdentifier', _EnhancedCertificateAssertion_authorityKeyIdentifier),
        ('certificateValid', _EnhancedCertificateAssertion_certificateValid),
        ('privateKeyValid', _EnhancedCertificateAssertion_privateKeyValid),
        ('subjectPublicKeyAlgID', _EnhancedCertificateAssertion_subjectPublicKeyAlgID),
        ('keyUsage', _EnhancedCertificateAssertion_keyUsage),
        ('subjectAltName', _EnhancedCertificateAssertion_subjectAltName),
        ('policy', _EnhancedCertificateAssertion_policy),
        ('pathToName', _EnhancedCertificateAssertion_pathToName),
        ('subject', _EnhancedCertificateAssertion_subject),
        ('nameConstraints', _EnhancedCertificateAssertion_nameConstraints),
        ])
    EnhancedCertificateAssertion._ext = []
    
    #-----< AltName >-----#
    AltName = SEQ(name='AltName', mode=MODE_TYPE)
    _AltName_altnameType = CHOICE(name='altnameType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AltNameType')))
    _AltName_altNameValue = CHOICE(name='altNameValue', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    AltName._cont = ASN1Dict([
        ('altnameType', _AltName_altnameType),
        ('altNameValue', _AltName_altNameValue),
        ])
    AltName._ext = None
    
    #-----< certExactAssertion >-----#
    certExactAssertion = CLASS(name='certExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certExactAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    certExactAssertion._val = dict([('ldapDesc', 'X.509 Certificate Exact Assertion'), ('Type', _certExactAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 1))])
    
    #-----< certAssertion >-----#
    certAssertion = CLASS(name='certAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')))
    certAssertion._val = dict([('ldapDesc', 'X.509 Certificate Assertion'), ('Type', _certAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 2))])
    
    #-----< certPairExactAssertion >-----#
    certPairExactAssertion = CLASS(name='certPairExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certPairExactAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    certPairExactAssertion._val = dict([('ldapDesc', 'X.509 Certificate Pair Exact Assertion'), ('Type', _certPairExactAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 3))])
    
    #-----< certPairAssertion >-----#
    certPairAssertion = CLASS(name='certPairAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certPairAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairAssertion')))
    certPairAssertion._val = dict([('ldapDesc', 'X.509 Certificate Pair Assertion'), ('Type', _certPairAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 4))])
    
    #-----< certListExactAssertion >-----#
    certListExactAssertion = CLASS(name='certListExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certListExactAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    certListExactAssertion._val = dict([('ldapDesc', 'X.509 Certificate List Exact Assertion'), ('Type', _certListExactAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 5))])
    
    #-----< certListAssertion >-----#
    certListAssertion = CLASS(name='certListAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certListAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListAssertion')))
    certListAssertion._val = dict([('ldapDesc', 'X.509 Certificate List Assertion'), ('Type', _certListAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 6))])
    
    #-----< algorithmIdentifier >-----#
    algorithmIdentifier = CLASS(name='algorithmIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _algorithmIdentifier_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __algorithmIdentifier_val_Type_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___algorithmIdentifier_val_Type_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifier_val_Type_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifier_val_Type_algorithm._const_tab = ___algorithmIdentifier_val_Type_algorithm_tab
    __algorithmIdentifier_val_Type_algorithm._const_tab_at = None
    __algorithmIdentifier_val_Type_algorithm._const_tab_id = 'id'
    __algorithmIdentifier_val_Type_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___algorithmIdentifier_val_Type_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifier_val_Type_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifier_val_Type_parameters._const_tab = ___algorithmIdentifier_val_Type_parameters_tab
    __algorithmIdentifier_val_Type_parameters._const_tab_at = ('..', 'algorithm')
    __algorithmIdentifier_val_Type_parameters._const_tab_id = 'Type'
    _algorithmIdentifier_val_Type._cont = ASN1Dict([
        ('algorithm', __algorithmIdentifier_val_Type_algorithm),
        ('parameters', __algorithmIdentifier_val_Type_parameters),
        ])
    _algorithmIdentifier_val_Type._ext = []
    algorithmIdentifier._val = dict([('ldapDesc', 'X.509 Algorithm Identifier'), ('Type', _algorithmIdentifier_val_Type), ('id', (1, 3, 6, 1, 1, 15, 7))])
    
    #-----< id-ce-subjectDirectoryAttributes >-----#
    id_ce_subjectDirectoryAttributes = OID(name='id-ce-subjectDirectoryAttributes', mode=MODE_VALUE)
    id_ce_subjectDirectoryAttributes._val = (2, 5, 29, 9)
    
    #-----< id-ce-subjectKeyIdentifier >-----#
    id_ce_subjectKeyIdentifier = OID(name='id-ce-subjectKeyIdentifier', mode=MODE_VALUE)
    id_ce_subjectKeyIdentifier._val = (2, 5, 29, 14)
    
    #-----< id-ce-keyUsage >-----#
    id_ce_keyUsage = OID(name='id-ce-keyUsage', mode=MODE_VALUE)
    id_ce_keyUsage._val = (2, 5, 29, 15)
    
    #-----< id-ce-privateKeyUsagePeriod >-----#
    id_ce_privateKeyUsagePeriod = OID(name='id-ce-privateKeyUsagePeriod', mode=MODE_VALUE)
    id_ce_privateKeyUsagePeriod._val = (2, 5, 29, 16)
    
    #-----< id-ce-subjectAltName >-----#
    id_ce_subjectAltName = OID(name='id-ce-subjectAltName', mode=MODE_VALUE)
    id_ce_subjectAltName._val = (2, 5, 29, 17)
    
    #-----< id-ce-issuerAltName >-----#
    id_ce_issuerAltName = OID(name='id-ce-issuerAltName', mode=MODE_VALUE)
    id_ce_issuerAltName._val = (2, 5, 29, 18)
    
    #-----< id-ce-basicConstraints >-----#
    id_ce_basicConstraints = OID(name='id-ce-basicConstraints', mode=MODE_VALUE)
    id_ce_basicConstraints._val = (2, 5, 29, 19)
    
    #-----< id-ce-cRLNumber >-----#
    id_ce_cRLNumber = OID(name='id-ce-cRLNumber', mode=MODE_VALUE)
    id_ce_cRLNumber._val = (2, 5, 29, 20)
    
    #-----< id-ce-reasonCode >-----#
    id_ce_reasonCode = OID(name='id-ce-reasonCode', mode=MODE_VALUE)
    id_ce_reasonCode._val = (2, 5, 29, 21)
    
    #-----< id-ce-holdInstructionCode >-----#
    id_ce_holdInstructionCode = OID(name='id-ce-holdInstructionCode', mode=MODE_VALUE)
    id_ce_holdInstructionCode._val = (2, 5, 29, 23)
    
    #-----< id-ce-invalidityDate >-----#
    id_ce_invalidityDate = OID(name='id-ce-invalidityDate', mode=MODE_VALUE)
    id_ce_invalidityDate._val = (2, 5, 29, 24)
    
    #-----< id-ce-deltaCRLIndicator >-----#
    id_ce_deltaCRLIndicator = OID(name='id-ce-deltaCRLIndicator', mode=MODE_VALUE)
    id_ce_deltaCRLIndicator._val = (2, 5, 29, 27)
    
    #-----< id-ce-issuingDistributionPoint >-----#
    id_ce_issuingDistributionPoint = OID(name='id-ce-issuingDistributionPoint', mode=MODE_VALUE)
    id_ce_issuingDistributionPoint._val = (2, 5, 29, 28)
    
    #-----< id-ce-certificateIssuer >-----#
    id_ce_certificateIssuer = OID(name='id-ce-certificateIssuer', mode=MODE_VALUE)
    id_ce_certificateIssuer._val = (2, 5, 29, 29)
    
    #-----< id-ce-nameConstraints >-----#
    id_ce_nameConstraints = OID(name='id-ce-nameConstraints', mode=MODE_VALUE)
    id_ce_nameConstraints._val = (2, 5, 29, 30)
    
    #-----< id-ce-cRLDistributionPoints >-----#
    id_ce_cRLDistributionPoints = OID(name='id-ce-cRLDistributionPoints', mode=MODE_VALUE)
    id_ce_cRLDistributionPoints._val = (2, 5, 29, 31)
    
    #-----< id-ce-certificatePolicies >-----#
    id_ce_certificatePolicies = OID(name='id-ce-certificatePolicies', mode=MODE_VALUE)
    id_ce_certificatePolicies._val = (2, 5, 29, 32)
    
    #-----< id-ce-policyMappings >-----#
    id_ce_policyMappings = OID(name='id-ce-policyMappings', mode=MODE_VALUE)
    id_ce_policyMappings._val = (2, 5, 29, 33)
    
    #-----< id-ce-authorityKeyIdentifier >-----#
    id_ce_authorityKeyIdentifier = OID(name='id-ce-authorityKeyIdentifier', mode=MODE_VALUE)
    id_ce_authorityKeyIdentifier._val = (2, 5, 29, 35)
    
    #-----< id-ce-policyConstraints >-----#
    id_ce_policyConstraints = OID(name='id-ce-policyConstraints', mode=MODE_VALUE)
    id_ce_policyConstraints._val = (2, 5, 29, 36)
    
    #-----< id-ce-extKeyUsage >-----#
    id_ce_extKeyUsage = OID(name='id-ce-extKeyUsage', mode=MODE_VALUE)
    id_ce_extKeyUsage._val = (2, 5, 29, 37)
    
    #-----< id-ce-cRLStreamIdentifier >-----#
    id_ce_cRLStreamIdentifier = OID(name='id-ce-cRLStreamIdentifier', mode=MODE_VALUE)
    id_ce_cRLStreamIdentifier._val = (2, 5, 29, 40)
    
    #-----< id-ce-cRLScope >-----#
    id_ce_cRLScope = OID(name='id-ce-cRLScope', mode=MODE_VALUE)
    id_ce_cRLScope._val = (2, 5, 29, 44)
    
    #-----< id-ce-statusReferrals >-----#
    id_ce_statusReferrals = OID(name='id-ce-statusReferrals', mode=MODE_VALUE)
    id_ce_statusReferrals._val = (2, 5, 29, 45)
    
    #-----< id-ce-freshestCRL >-----#
    id_ce_freshestCRL = OID(name='id-ce-freshestCRL', mode=MODE_VALUE)
    id_ce_freshestCRL._val = (2, 5, 29, 46)
    
    #-----< id-ce-orderedList >-----#
    id_ce_orderedList = OID(name='id-ce-orderedList', mode=MODE_VALUE)
    id_ce_orderedList._val = (2, 5, 29, 47)
    
    #-----< id-ce-baseUpdateTime >-----#
    id_ce_baseUpdateTime = OID(name='id-ce-baseUpdateTime', mode=MODE_VALUE)
    id_ce_baseUpdateTime._val = (2, 5, 29, 51)
    
    #-----< id-ce-deltaInfo >-----#
    id_ce_deltaInfo = OID(name='id-ce-deltaInfo', mode=MODE_VALUE)
    id_ce_deltaInfo._val = (2, 5, 29, 53)
    
    #-----< id-ce-inhibitAnyPolicy >-----#
    id_ce_inhibitAnyPolicy = OID(name='id-ce-inhibitAnyPolicy', mode=MODE_VALUE)
    id_ce_inhibitAnyPolicy._val = (2, 5, 29, 54)
    
    #-----< id-ce-toBeRevoked >-----#
    id_ce_toBeRevoked = OID(name='id-ce-toBeRevoked', mode=MODE_VALUE)
    id_ce_toBeRevoked._val = (2, 5, 29, 58)
    
    #-----< id-ce-revokedGroups >-----#
    id_ce_revokedGroups = OID(name='id-ce-revokedGroups', mode=MODE_VALUE)
    id_ce_revokedGroups._val = (2, 5, 29, 59)
    
    #-----< id-ce-expiredCertsOnCRL >-----#
    id_ce_expiredCertsOnCRL = OID(name='id-ce-expiredCertsOnCRL', mode=MODE_VALUE)
    id_ce_expiredCertsOnCRL._val = (2, 5, 29, 60)
    
    #-----< id-ce-aAissuingDistributionPoint >-----#
    id_ce_aAissuingDistributionPoint = OID(name='id-ce-aAissuingDistributionPoint', mode=MODE_VALUE)
    id_ce_aAissuingDistributionPoint._val = (2, 5, 29, 63)
    
    #-----< id-ce-authorizationValidation >-----#
    id_ce_authorizationValidation = OID(name='id-ce-authorizationValidation', mode=MODE_VALUE)
    id_ce_authorizationValidation._val = (2, 5, 29, 70)
    
    #-----< id-mr-certificateExactMatch >-----#
    id_mr_certificateExactMatch = OID(name='id-mr-certificateExactMatch', mode=MODE_VALUE)
    id_mr_certificateExactMatch._val = (2, 5, 13, 34)
    
    #-----< id-mr-certificateMatch >-----#
    id_mr_certificateMatch = OID(name='id-mr-certificateMatch', mode=MODE_VALUE)
    id_mr_certificateMatch._val = (2, 5, 13, 35)
    
    #-----< id-mr-certificatePairExactMatch >-----#
    id_mr_certificatePairExactMatch = OID(name='id-mr-certificatePairExactMatch', mode=MODE_VALUE)
    id_mr_certificatePairExactMatch._val = (2, 5, 13, 36)
    
    #-----< id-mr-certificatePairMatch >-----#
    id_mr_certificatePairMatch = OID(name='id-mr-certificatePairMatch', mode=MODE_VALUE)
    id_mr_certificatePairMatch._val = (2, 5, 13, 37)
    
    #-----< id-mr-certificateListExactMatch >-----#
    id_mr_certificateListExactMatch = OID(name='id-mr-certificateListExactMatch', mode=MODE_VALUE)
    id_mr_certificateListExactMatch._val = (2, 5, 13, 38)
    
    #-----< id-mr-certificateListMatch >-----#
    id_mr_certificateListMatch = OID(name='id-mr-certificateListMatch', mode=MODE_VALUE)
    id_mr_certificateListMatch._val = (2, 5, 13, 39)
    
    #-----< id-mr-algorithmIdentifierMatch >-----#
    id_mr_algorithmIdentifierMatch = OID(name='id-mr-algorithmIdentifierMatch', mode=MODE_VALUE)
    id_mr_algorithmIdentifierMatch._val = (2, 5, 13, 40)
    
    #-----< id-mr-policyMatch >-----#
    id_mr_policyMatch = OID(name='id-mr-policyMatch', mode=MODE_VALUE)
    id_mr_policyMatch._val = (2, 5, 13, 60)
    
    #-----< id-mr-pkiPathMatch >-----#
    id_mr_pkiPathMatch = OID(name='id-mr-pkiPathMatch', mode=MODE_VALUE)
    id_mr_pkiPathMatch._val = (2, 5, 13, 62)
    
    #-----< id-mr-enhancedCertificateMatch >-----#
    id_mr_enhancedCertificateMatch = OID(name='id-mr-enhancedCertificateMatch', mode=MODE_VALUE)
    id_mr_enhancedCertificateMatch._val = (2, 5, 13, 65)
    
    #-----< id-ldx-certExactAssertion >-----#
    id_ldx_certExactAssertion = OID(name='id-ldx-certExactAssertion', mode=MODE_VALUE)
    id_ldx_certExactAssertion._val = (1, 3, 6, 1, 1, 15, 1)
    
    #-----< id-ldx-certAssertion >-----#
    id_ldx_certAssertion = OID(name='id-ldx-certAssertion', mode=MODE_VALUE)
    id_ldx_certAssertion._val = (1, 3, 6, 1, 1, 15, 2)
    
    #-----< id-ldx-certPairExactAssertion >-----#
    id_ldx_certPairExactAssertion = OID(name='id-ldx-certPairExactAssertion', mode=MODE_VALUE)
    id_ldx_certPairExactAssertion._val = (1, 3, 6, 1, 1, 15, 3)
    
    #-----< id-ldx-certPairAssertion >-----#
    id_ldx_certPairAssertion = OID(name='id-ldx-certPairAssertion', mode=MODE_VALUE)
    id_ldx_certPairAssertion._val = (1, 3, 6, 1, 1, 15, 4)
    
    #-----< id-ldx-certListExactAssertion >-----#
    id_ldx_certListExactAssertion = OID(name='id-ldx-certListExactAssertion', mode=MODE_VALUE)
    id_ldx_certListExactAssertion._val = (1, 3, 6, 1, 1, 15, 5)
    
    #-----< id-ldx-certListAssertion >-----#
    id_ldx_certListAssertion = OID(name='id-ldx-certListAssertion', mode=MODE_VALUE)
    id_ldx_certListAssertion._val = (1, 3, 6, 1, 1, 15, 6)
    
    #-----< id-ldx-algorithmIdentifier >-----#
    id_ldx_algorithmIdentifier = OID(name='id-ldx-algorithmIdentifier', mode=MODE_VALUE)
    id_ldx_algorithmIdentifier._val = (1, 3, 6, 1, 1, 15, 7)
    
    _all_ = [
        authorityKeyIdentifier,
        _authorityKeyIdentifier_val_ExtnType,
        _AuthorityKeyIdentifier_keyIdentifier,
        _AuthorityKeyIdentifier_authorityCertIssuer,
        _AuthorityKeyIdentifier_authorityCertSerialNumber,
        AuthorityKeyIdentifier,
        KeyIdentifier,
        subjectKeyIdentifier,
        _subjectKeyIdentifier_val_ExtnType,
        SubjectKeyIdentifier,
        keyUsage,
        _keyUsage_val_ExtnType,
        KeyUsage,
        extKeyUsage,
        __extKeyUsage_val_ExtnType__item_,
        _extKeyUsage_val_ExtnType,
        KeyPurposeId,
        privateKeyUsagePeriod,
        _privateKeyUsagePeriod_val_ExtnType,
        _PrivateKeyUsagePeriod_notBefore,
        _PrivateKeyUsagePeriod_notAfter,
        PrivateKeyUsagePeriod,
        certificatePolicies,
        _certificatePolicies_val_ExtnType,
        _CertificatePoliciesSyntax__item_,
        CertificatePoliciesSyntax,
        _PolicyInformation_policyIdentifier,
        __PolicyInformation_policyQualifiers__item_,
        _PolicyInformation_policyQualifiers,
        PolicyInformation,
        CertPolicyId,
        __PolicyQualifierInfo_policyQualifierId_tab,
        _PolicyQualifierInfo_policyQualifierId,
        __PolicyQualifierInfo_qualifier_tab,
        _PolicyQualifierInfo_qualifier,
        PolicyQualifierInfo,
        SupportedPolicyQualifiers,
        anyPolicy,
        _CERT_POLICY_QUALIFIER_id,
        _CERT_POLICY_QUALIFIER_Qualifier,
        CERT_POLICY_QUALIFIER,
        policyMappings,
        _policyMappings_val_ExtnType,
        __PolicyMappingsSyntax__item__issuerDomainPolicy,
        __PolicyMappingsSyntax__item__subjectDomainPolicy,
        _PolicyMappingsSyntax__item_,
        PolicyMappingsSyntax,
        authorizationValidation,
        _authorizationValidation_val_ExtnType,
        _AvlId_issuer,
        _AvlId_serialNumber,
        AvlId,
        subjectAltName,
        _subjectAltName_val_ExtnType,
        _GeneralNames__item_,
        GeneralNames,
        __GeneralName_otherName_type_id,
        __GeneralName_otherName_value,
        _GeneralName_otherName,
        _GeneralName_otherName,
        _GeneralName_rfc822Name,
        _GeneralName_dNSName,
        _GeneralName_x400Address,
        _GeneralName_directoryName,
        _GeneralName_ediPartyName,
        _GeneralName_uniformResourceIdentifier,
        _GeneralName_iPAddress,
        _GeneralName_registeredID,
        GeneralName,
        OTHER_NAME,
        _EDIPartyName_nameAssigner,
        _EDIPartyName_partyName,
        EDIPartyName,
        issuerAltName,
        _issuerAltName_val_ExtnType,
        subjectDirectoryAttributes,
        _subjectDirectoryAttributes_val_ExtnType,
        ___AttributesSyntax__item__type_tab,
        ____AttributesSyntax__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        ____AttributesSyntax__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        __AttributesSyntax__item__type,
        ___AttributesSyntax__item__values__item_,
        __AttributesSyntax__item__values,
        ____AttributesSyntax__item__valuesWithContext__item__value,
        _____AttributesSyntax__item__valuesWithContext__item__contextList__item_,
        ____AttributesSyntax__item__valuesWithContext__item__contextList,
        ___AttributesSyntax__item__valuesWithContext__item_,
        __AttributesSyntax__item__valuesWithContext,
        _AttributesSyntax__item_,
        AttributesSyntax,
        basicConstraints,
        _basicConstraints_val_ExtnType,
        _BasicConstraintsSyntax_cA,
        _BasicConstraintsSyntax_pathLenConstraint,
        BasicConstraintsSyntax,
        nameConstraints,
        _nameConstraints_val_ExtnType,
        _NameConstraintsSyntax_permittedSubtrees,
        _NameConstraintsSyntax_excludedSubtrees,
        NameConstraintsSyntax,
        _GeneralSubtrees__item_,
        GeneralSubtrees,
        _GeneralSubtree_base,
        _GeneralSubtree_minimum,
        _GeneralSubtree_maximum,
        GeneralSubtree,
        BaseDistance,
        policyConstraints,
        _policyConstraints_val_ExtnType,
        _PolicyConstraintsSyntax_requireExplicitPolicy,
        _PolicyConstraintsSyntax_inhibitPolicyMapping,
        PolicyConstraintsSyntax,
        SkipCerts,
        inhibitAnyPolicy,
        _inhibitAnyPolicy_val_ExtnType,
        cRLNumber,
        _cRLNumber_val_ExtnType,
        CRLNumber,
        crlScope,
        _crlScope_val_ExtnType,
        _CRLScopeSyntax__item_,
        CRLScopeSyntax,
        _PerAuthorityScope_authorityName,
        _PerAuthorityScope_distributionPoint,
        _PerAuthorityScope_onlyContains,
        _PerAuthorityScope_onlySomeReasons,
        _PerAuthorityScope_serialNumberRange,
        _PerAuthorityScope_subjectKeyIdRange,
        _PerAuthorityScope_nameSubtrees,
        _PerAuthorityScope_baseRevocationInfo,
        PerAuthorityScope,
        OnlyCertificateTypes,
        _NumberRange_startingNumber,
        _NumberRange_endingNumber,
        _NumberRange_modulus,
        NumberRange,
        _BaseRevocationInfo_cRLStreamIdentifier,
        _BaseRevocationInfo_cRLNumber,
        _BaseRevocationInfo_baseThisUpdate,
        BaseRevocationInfo,
        statusReferrals,
        _statusReferrals_val_ExtnType,
        _StatusReferrals__item_,
        StatusReferrals,
        _StatusReferral_cRLReferral,
        __StatusReferral_otherReferral_type_id,
        __StatusReferral_otherReferral_value,
        _StatusReferral_otherReferral,
        _StatusReferral_otherReferral,
        StatusReferral,
        _CRLReferral_issuer,
        _CRLReferral_location,
        _CRLReferral_deltaRefInfo,
        _CRLReferral_cRLScope,
        _CRLReferral_lastUpdate,
        _CRLReferral_lastChangedCRL,
        CRLReferral,
        _DeltaRefInfo_deltaLocation,
        _DeltaRefInfo_lastDelta,
        DeltaRefInfo,
        OTHER_REFERRAL,
        cRLStreamIdentifier,
        _cRLStreamIdentifier_val_ExtnType,
        CRLStreamIdentifier,
        orderedList,
        _orderedList_val_ExtnType,
        OrderedListSyntax,
        deltaInfo,
        _deltaInfo_val_ExtnType,
        _DeltaInformation_deltaLocation,
        _DeltaInformation_nextDelta,
        DeltaInformation,
        toBeRevoked,
        _toBeRevoked_val_ExtnType,
        _ToBeRevokedSyntax__item_,
        ToBeRevokedSyntax,
        _ToBeRevokedGroup_certificateIssuer,
        _ToBeRevokedGroup_reasonInfo,
        _ToBeRevokedGroup_revocationTime,
        _ToBeRevokedGroup_certificateGroup,
        ToBeRevokedGroup,
        _ReasonInfo_reasonCode,
        _ReasonInfo_holdInstructionCode,
        ReasonInfo,
        _CertificateGroup_serialNumbers,
        _CertificateGroup_serialNumberRange,
        _CertificateGroup_nameSubtree,
        CertificateGroup,
        _CertificateGroupNumberRange_startingNumber,
        _CertificateGroupNumberRange_endingNumber,
        CertificateGroupNumberRange,
        _CertificateSerialNumbers__item_,
        CertificateSerialNumbers,
        revokedGroups,
        _revokedGroups_val_ExtnType,
        _RevokedGroupsSyntax__item_,
        RevokedGroupsSyntax,
        _RevokedGroup_certificateIssuer,
        _RevokedGroup_reasonInfo,
        _RevokedGroup_invalidityDate,
        _RevokedGroup_revokedcertificateGroup,
        RevokedGroup,
        _RevokedCertificateGroup_serialNumberRange,
        _RevokedCertificateGroup_nameSubtree,
        RevokedCertificateGroup,
        expiredCertsOnCRL,
        _expiredCertsOnCRL_val_ExtnType,
        ExpiredCertsOnCRL,
        reasonCode,
        _reasonCode_val_ExtnType,
        CRLReason,
        holdInstructionCode,
        _holdInstructionCode_val_ExtnType,
        HoldInstruction,
        invalidityDate,
        _invalidityDate_val_ExtnType,
        cRLDistributionPoints,
        _cRLDistributionPoints_val_ExtnType,
        _CRLDistPointsSyntax__item_,
        CRLDistPointsSyntax,
        _DistributionPoint_distributionPoint,
        _DistributionPoint_reasons,
        _DistributionPoint_cRLIssuer,
        DistributionPoint,
        _DistributionPointName_fullName,
        _DistributionPointName_nameRelativeToCRLIssuer,
        DistributionPointName,
        ReasonFlags,
        issuingDistributionPoint,
        _issuingDistributionPoint_val_ExtnType,
        _IssuingDistPointSyntax_distributionPoint,
        _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts,
        _IssuingDistPointSyntax_onlyContainsCACerts,
        _IssuingDistPointSyntax_onlySomeReasons,
        _IssuingDistPointSyntax_indirectCRL,
        _IssuingDistPointSyntax_onlyContainsAttributeCerts,
        IssuingDistPointSyntax,
        certificateIssuer,
        _certificateIssuer_val_ExtnType,
        deltaCRLIndicator,
        _deltaCRLIndicator_val_ExtnType,
        BaseCRLNumber,
        baseUpdateTime,
        _baseUpdateTime_val_ExtnType,
        freshestCRL,
        _freshestCRL_val_ExtnType,
        aAissuingDistributionPoint,
        _aAissuingDistributionPoint_val_ExtnType,
        _AAIssuingDistPointSyntax_distributionPoint,
        _AAIssuingDistPointSyntax_onlySomeReasons,
        _AAIssuingDistPointSyntax_indirectCRL,
        _AAIssuingDistPointSyntax_containsUserAttributeCerts,
        _AAIssuingDistPointSyntax_containsAACerts,
        _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts,
        AAIssuingDistPointSyntax,
        certificateExactMatch,
        _certificateExactMatch_val_AssertionType,
        _CertificateExactAssertion_serialNumber,
        _CertificateExactAssertion_issuer,
        CertificateExactAssertion,
        certificateMatch,
        _certificateMatch_val_AssertionType,
        _CertificateAssertion_serialNumber,
        _CertificateAssertion_issuer,
        _CertificateAssertion_subjectKeyIdentifier,
        _CertificateAssertion_authorityKeyIdentifier,
        _CertificateAssertion_certificateValid,
        _CertificateAssertion_privateKeyValid,
        _CertificateAssertion_subjectPublicKeyAlgID,
        _CertificateAssertion_keyUsage,
        _CertificateAssertion_subjectAltName,
        _CertificateAssertion_policy,
        _CertificateAssertion_pathToName,
        _CertificateAssertion_subject,
        _CertificateAssertion_nameConstraints,
        CertificateAssertion,
        _AltNameType_builtinNameForm,
        _AltNameType_otherNameForm,
        AltNameType,
        _CertPolicySet__item_,
        CertPolicySet,
        certificatePairExactMatch,
        _certificatePairExactMatch_val_AssertionType,
        _CertificatePairExactAssertion_issuedToThisCAAssertion,
        _CertificatePairExactAssertion_issuedByThisCAAssertion,
        CertificatePairExactAssertion,
        certificatePairMatch,
        _certificatePairMatch_val_AssertionType,
        _CertificatePairAssertion_issuedToThisCAAssertion,
        _CertificatePairAssertion_issuedByThisCAAssertion,
        CertificatePairAssertion,
        certificateListExactMatch,
        _certificateListExactMatch_val_AssertionType,
        _CertificateListExactAssertion_issuer,
        _CertificateListExactAssertion_thisUpdate,
        _CertificateListExactAssertion_distributionPoint,
        CertificateListExactAssertion,
        certificateListMatch,
        _certificateListMatch_val_AssertionType,
        _CertificateListAssertion_issuer,
        _CertificateListAssertion_minCRLNumber,
        _CertificateListAssertion_maxCRLNumber,
        _CertificateListAssertion_reasonFlags,
        _CertificateListAssertion_dateAndTime,
        _CertificateListAssertion_distributionPoint,
        _CertificateListAssertion_authorityKeyIdentifier,
        CertificateListAssertion,
        algorithmIdentifierMatch,
        ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab,
        __algorithmIdentifierMatch_val_AssertionType_algorithm,
        ___algorithmIdentifierMatch_val_AssertionType_parameters_tab,
        __algorithmIdentifierMatch_val_AssertionType_parameters,
        _algorithmIdentifierMatch_val_AssertionType,
        policyMatch,
        _policyMatch_val_AssertionType,
        pkiPathMatch,
        _pkiPathMatch_val_AssertionType,
        _PkiPathMatchSyntax_firstIssuer,
        _PkiPathMatchSyntax_lastSubject,
        PkiPathMatchSyntax,
        enhancedCertificateMatch,
        _enhancedCertificateMatch_val_AssertionType,
        _EnhancedCertificateAssertion_serialNumber,
        _EnhancedCertificateAssertion_issuer,
        _EnhancedCertificateAssertion_subjectKeyIdentifier,
        _EnhancedCertificateAssertion_authorityKeyIdentifier,
        _EnhancedCertificateAssertion_certificateValid,
        _EnhancedCertificateAssertion_privateKeyValid,
        _EnhancedCertificateAssertion_subjectPublicKeyAlgID,
        _EnhancedCertificateAssertion_keyUsage,
        _EnhancedCertificateAssertion_subjectAltName,
        _EnhancedCertificateAssertion_policy,
        _EnhancedCertificateAssertion_pathToName,
        _EnhancedCertificateAssertion_subject,
        _EnhancedCertificateAssertion_nameConstraints,
        EnhancedCertificateAssertion,
        _AltName_altnameType,
        _AltName_altNameValue,
        AltName,
        certExactAssertion,
        _certExactAssertion_val_Type,
        certAssertion,
        _certAssertion_val_Type,
        certPairExactAssertion,
        _certPairExactAssertion_val_Type,
        certPairAssertion,
        _certPairAssertion_val_Type,
        certListExactAssertion,
        _certListExactAssertion_val_Type,
        certListAssertion,
        _certListAssertion_val_Type,
        algorithmIdentifier,
        ___algorithmIdentifier_val_Type_algorithm_tab,
        __algorithmIdentifier_val_Type_algorithm,
        ___algorithmIdentifier_val_Type_parameters_tab,
        __algorithmIdentifier_val_Type_parameters,
        _algorithmIdentifier_val_Type,
        id_ce_subjectDirectoryAttributes,
        id_ce_subjectKeyIdentifier,
        id_ce_keyUsage,
        id_ce_privateKeyUsagePeriod,
        id_ce_subjectAltName,
        id_ce_issuerAltName,
        id_ce_basicConstraints,
        id_ce_cRLNumber,
        id_ce_reasonCode,
        id_ce_holdInstructionCode,
        id_ce_invalidityDate,
        id_ce_deltaCRLIndicator,
        id_ce_issuingDistributionPoint,
        id_ce_certificateIssuer,
        id_ce_nameConstraints,
        id_ce_cRLDistributionPoints,
        id_ce_certificatePolicies,
        id_ce_policyMappings,
        id_ce_authorityKeyIdentifier,
        id_ce_policyConstraints,
        id_ce_extKeyUsage,
        id_ce_cRLStreamIdentifier,
        id_ce_cRLScope,
        id_ce_statusReferrals,
        id_ce_freshestCRL,
        id_ce_orderedList,
        id_ce_baseUpdateTime,
        id_ce_deltaInfo,
        id_ce_inhibitAnyPolicy,
        id_ce_toBeRevoked,
        id_ce_revokedGroups,
        id_ce_expiredCertsOnCRL,
        id_ce_aAissuingDistributionPoint,
        id_ce_authorizationValidation,
        id_mr_certificateExactMatch,
        id_mr_certificateMatch,
        id_mr_certificatePairExactMatch,
        id_mr_certificatePairMatch,
        id_mr_certificateListExactMatch,
        id_mr_certificateListMatch,
        id_mr_algorithmIdentifierMatch,
        id_mr_policyMatch,
        id_mr_pkiPathMatch,
        id_mr_enhancedCertificateMatch,
        id_ldx_certExactAssertion,
        id_ldx_certAssertion,
        id_ldx_certPairExactAssertion,
        id_ldx_certPairAssertion,
        id_ldx_certListExactAssertion,
        id_ldx_certListAssertion,
        id_ldx_algorithmIdentifier,
    ]

class CMIP_1:

    _name_  = 'CMIP-1'
    _oid_   = [2, 9, 1, 0, 3]
    
    _obj_ = [
        'CMIP-Operations',
        'CMIP-Confirmed-Operations',
        'accessDenied',
        'classInstanceConflict',
        'complexityLimitation',
        'duplicateManagedObjectInstance',
        'getListError',
        'invalidArgumentValue',
        'invalidAttributeValue',
        'invalidFilter',
        'invalidObjectInstance',
        'invalidScope',
        'missingAttributeValue',
        'mistypedOperation',
        'noSuchAction',
        'noSuchArgument',
        'noSuchAttribute',
        'noSuchEventType',
        'noSuchInvokeId',
        'noSuchObjectClass',
        'noSuchObjectInstance',
        'noSuchReferenceObject',
        'operationCancelled',
        'processingFailure',
        'setListError',
        'syncNotSupported',
        'm-Action',
        'm-Action-Confirmed',
        'm-CancelGet',
        'm-Create',
        'm-Delete',
        'm-EventReport',
        'm-EventReport-Confirmed',
        'm-Get',
        'm-Linked-Reply',
        'm-Set',
        'm-Set-Confirmed',
        'CMIP-ACTION',
        'CMIP-ATTRIBUTE',
        'CMIP-AVA',
        'CMIP-EVENT',
        'CMIP-SPECIFICERROR',
        'AccessControl',
        'ActionArgument',
        'ActionError',
        'ActionErrorInfo',
        'ActionInfo',
        'ActionReply',
        'ActionResult',
        'ActionSet',
        'ActionTypeId',
        'Attribute',
        'AttributeError',
        'AttributeId',
        'AttributeIdError',
        'AttributeSet',
        'AttributeValueAssertion',
        'AvaSet',
        'BaseManagedObjectId',
        'CMISFilter',
        'CMISSync',
        'ComplexityLimitation',
        'CreateArgument',
        'CreateResult',
        'DeleteArgument',
        'DeleteError',
        'DeleteResult',
        'DistinguishedName',
        'EventReply',
        'EventReportArgument',
        'EventReportResult',
        'EventSet',
        'EventTypeId',
        'FilterItem',
        'GetArgument',
        'GetInfoStatus',
        'GetListError',
        'GetResult',
        'InvalidArgumentValue',
        'InvokeIDType',
        'LinkedReplyArgument',
        'ModifyOperator',
        'NoSuchAction',
        'NoSuchArgument',
        'NoSuchEventType',
        'ObjectClass',
        'ObjectInstance',
        'ProcessingFailure',
        'RDNSequence',
        'RelativeDistinguishedName',
        'Scope',
        'SetArgument',
        'SetInfoStatus',
        'SetListError',
        'SetResult',
        'SpecificErrorInfo',
        'SpecificErrorSet',
        'ROSEapdus',
        ]
    _type_ = [
        'CMIP-ACTION',
        'CMIP-ATTRIBUTE',
        'CMIP-AVA',
        'CMIP-EVENT',
        'CMIP-SPECIFICERROR',
        'AccessControl',
        'ActionArgument',
        'ActionError',
        'ActionErrorInfo',
        'ActionInfo',
        'ActionReply',
        'ActionResult',
        'ActionTypeId',
        'Attribute',
        'AttributeError',
        'AttributeId',
        'AttributeIdError',
        'AttributeValueAssertion',
        'BaseManagedObjectId',
        'CMISFilter',
        'CMISSync',
        'ComplexityLimitation',
        'CreateArgument',
        'CreateResult',
        'DeleteArgument',
        'DeleteError',
        'DeleteResult',
        'DistinguishedName',
        'EventReply',
        'EventReportArgument',
        'EventReportResult',
        'EventTypeId',
        'FilterItem',
        'GetArgument',
        'GetInfoStatus',
        'GetListError',
        'GetResult',
        'InvalidArgumentValue',
        'InvokeIDType',
        'LinkedReplyArgument',
        'ModifyOperator',
        'NoSuchAction',
        'NoSuchArgument',
        'NoSuchEventType',
        'ObjectClass',
        'ObjectInstance',
        'ProcessingFailure',
        'RDNSequence',
        'RelativeDistinguishedName',
        'Scope',
        'SetArgument',
        'SetInfoStatus',
        'SetListError',
        'SetResult',
        'SpecificErrorInfo',
        'ROSEapdus',
        ]
    _set_ = [
        'CMIP-Operations',
        'CMIP-Confirmed-Operations',
        'ActionSet',
        'AttributeSet',
        'AvaSet',
        'EventSet',
        'SpecificErrorSet',
        ]
    _val_ = [
        'accessDenied',
        'classInstanceConflict',
        'complexityLimitation',
        'duplicateManagedObjectInstance',
        'getListError',
        'invalidArgumentValue',
        'invalidAttributeValue',
        'invalidFilter',
        'invalidObjectInstance',
        'invalidScope',
        'missingAttributeValue',
        'mistypedOperation',
        'noSuchAction',
        'noSuchArgument',
        'noSuchAttribute',
        'noSuchEventType',
        'noSuchInvokeId',
        'noSuchObjectClass',
        'noSuchObjectInstance',
        'noSuchReferenceObject',
        'operationCancelled',
        'processingFailure',
        'setListError',
        'syncNotSupported',
        'm-Action',
        'm-Action-Confirmed',
        'm-CancelGet',
        'm-Create',
        'm-Delete',
        'm-EventReport',
        'm-EventReport-Confirmed',
        'm-Get',
        'm-Linked-Reply',
        'm-Set',
        'm-Set-Confirmed',
        ]
    _class_ = [
        'CMIP-Operations',
        'CMIP-Confirmed-Operations',
        'accessDenied',
        'classInstanceConflict',
        'complexityLimitation',
        'duplicateManagedObjectInstance',
        'getListError',
        'invalidArgumentValue',
        'invalidAttributeValue',
        'invalidFilter',
        'invalidObjectInstance',
        'invalidScope',
        'missingAttributeValue',
        'mistypedOperation',
        'noSuchAction',
        'noSuchArgument',
        'noSuchAttribute',
        'noSuchEventType',
        'noSuchInvokeId',
        'noSuchObjectClass',
        'noSuchObjectInstance',
        'noSuchReferenceObject',
        'operationCancelled',
        'processingFailure',
        'setListError',
        'syncNotSupported',
        'm-Action',
        'm-Action-Confirmed',
        'm-CancelGet',
        'm-Create',
        'm-Delete',
        'm-EventReport',
        'm-EventReport-Confirmed',
        'm-Get',
        'm-Linked-Reply',
        'm-Set',
        'm-Set-Confirmed',
        'CMIP-ACTION',
        'CMIP-ATTRIBUTE',
        'CMIP-AVA',
        'CMIP-EVENT',
        'CMIP-SPECIFICERROR',
        'ActionSet',
        'AttributeSet',
        'AvaSet',
        'EventSet',
        'SpecificErrorSet',
        ]
    _param_ = [
        ]
    
    #-----< CMIP-Operations >-----#
    CMIP_Operations = CLASS(name='CMIP-Operations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _CMIP_Operations_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _CMIP_Operations_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _CMIP_Operations_val_ResultType_1 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'BaseManagedObjectId')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = SET(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ComplexityLimitation')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchAction')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    _CMIP_Operations_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _CMIP_Operations_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _CMIP_Operations_val_ResultType_3 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = SET_OF(name='ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _CMIP_Operations_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _CMIP_Operations_val_ResultType_4 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    _CMIP_Operations_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _CMIP_Operations_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _CMIP_Operations_val_ResultType_6 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchEventType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _CMIP_Operations_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _CMIP_Operations_val_ResultType_7 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    _CMIP_Operations_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    _CMIP_Operations_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _CMIP_Operations_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _CMIP_Operations_val_ResultType_10 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    CMIP_Operations._val = ASN1Set(rv=[dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 6))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_1), ('ResultType', _CMIP_Operations_val_ResultType_1), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 9))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 21))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 22))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_3), ('ResultType', _CMIP_Operations_val_ResultType_3), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 6))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 17))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 18))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 5))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 12))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_4), ('ResultType', _CMIP_Operations_val_ResultType_4), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_5), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 0))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_6), ('ResultType', _CMIP_Operations_val_ResultType_6), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 13))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_7), ('ResultType', _CMIP_Operations_val_ResultType_7), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 23))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_8), ('operationCode', ('local', 2))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_9), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 4))]), dict([('ArgumentType', _CMIP_Operations_val_ArgumentType_10), ('ResultType', _CMIP_Operations_val_ResultType_10), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])], rr=[], ev=None, er=[])
    
    #-----< CMIP-Confirmed-Operations >-----#
    CMIP_Confirmed_Operations = CLASS(name='CMIP-Confirmed-Operations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _CMIP_Confirmed_Operations_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _CMIP_Confirmed_Operations_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_2 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_3 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_4 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_5 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_6 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    CMIP_Confirmed_Operations._val = ASN1Set(rv=[dict([('ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_0), ('ResultType', _CMIP_Confirmed_Operations_val_ResultType_0), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 9))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 21))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 22))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_2), ('ResultType', _CMIP_Confirmed_Operations_val_ResultType_2), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 6))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 17))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 18))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 5))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 12))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_3), ('ResultType', _CMIP_Confirmed_Operations_val_ResultType_3), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_4), ('ResultType', _CMIP_Confirmed_Operations_val_ResultType_4), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 13))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_5), ('ResultType', _CMIP_Confirmed_Operations_val_ResultType_5), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 23))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_6), ('ResultType', _CMIP_Confirmed_Operations_val_ResultType_6), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])], rr=[], ev=None, er=[])
    
    #-----< accessDenied >-----#
    accessDenied = CLASS(name='accessDenied', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    accessDenied._val = dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))])
    
    #-----< classInstanceConflict >-----#
    classInstanceConflict = CLASS(name='classInstanceConflict', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _classInstanceConflict_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'BaseManagedObjectId')))
    classInstanceConflict._val = dict([('ParameterType', _classInstanceConflict_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))])
    
    #-----< complexityLimitation >-----#
    complexityLimitation = CLASS(name='complexityLimitation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _complexityLimitation_val_ParameterType = SET(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ComplexityLimitation')))
    complexityLimitation._val = dict([('ParameterType', _complexityLimitation_val_ParameterType), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))])
    
    #-----< duplicateManagedObjectInstance >-----#
    duplicateManagedObjectInstance = CLASS(name='duplicateManagedObjectInstance', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _duplicateManagedObjectInstance_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    duplicateManagedObjectInstance._val = dict([('ParameterType', _duplicateManagedObjectInstance_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 11))])
    
    #-----< getListError >-----#
    getListError = CLASS(name='getListError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _getListError_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    getListError._val = dict([('ParameterType', _getListError_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 7))])
    
    #-----< invalidArgumentValue >-----#
    invalidArgumentValue = CLASS(name='invalidArgumentValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidArgumentValue_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    invalidArgumentValue._val = dict([('ParameterType', _invalidArgumentValue_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))])
    
    #-----< invalidAttributeValue >-----#
    invalidAttributeValue = CLASS(name='invalidAttributeValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidAttributeValue_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    invalidAttributeValue._val = dict([('ParameterType', _invalidAttributeValue_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 6))])
    
    #-----< invalidFilter >-----#
    invalidFilter = CLASS(name='invalidFilter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidFilter_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    invalidFilter._val = dict([('ParameterType', _invalidFilter_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))])
    
    #-----< invalidObjectInstance >-----#
    invalidObjectInstance = CLASS(name='invalidObjectInstance', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidObjectInstance_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    invalidObjectInstance._val = dict([('ParameterType', _invalidObjectInstance_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 17))])
    
    #-----< invalidScope >-----#
    invalidScope = CLASS(name='invalidScope', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidScope_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    invalidScope._val = dict([('ParameterType', _invalidScope_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))])
    
    #-----< missingAttributeValue >-----#
    missingAttributeValue = CLASS(name='missingAttributeValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _missingAttributeValue_val_ParameterType = SET_OF(name='ParameterType', mode=MODE_TYPE)
    __missingAttributeValue_val_ParameterType__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _missingAttributeValue_val_ParameterType._cont = __missingAttributeValue_val_ParameterType__item_
    missingAttributeValue._val = dict([('ParameterType', _missingAttributeValue_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 18))])
    
    #-----< mistypedOperation >-----#
    mistypedOperation = CLASS(name='mistypedOperation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    mistypedOperation._val = dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 21))])
    
    #-----< noSuchAction >-----#
    noSuchAction = CLASS(name='noSuchAction', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchAction_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchAction')))
    noSuchAction._val = dict([('ParameterType', _noSuchAction_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 9))])
    
    #-----< noSuchArgument >-----#
    noSuchArgument = CLASS(name='noSuchArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchArgument_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    noSuchArgument._val = dict([('ParameterType', _noSuchArgument_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))])
    
    #-----< noSuchAttribute >-----#
    noSuchAttribute = CLASS(name='noSuchAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchAttribute_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    noSuchAttribute._val = dict([('ParameterType', _noSuchAttribute_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 5))])
    
    #-----< noSuchEventType >-----#
    noSuchEventType = CLASS(name='noSuchEventType', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchEventType_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchEventType')))
    noSuchEventType._val = dict([('ParameterType', _noSuchEventType_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 13))])
    
    #-----< noSuchInvokeId >-----#
    noSuchInvokeId = CLASS(name='noSuchInvokeId', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchInvokeId_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    noSuchInvokeId._val = dict([('ParameterType', _noSuchInvokeId_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 22))])
    
    #-----< noSuchObjectClass >-----#
    noSuchObjectClass = CLASS(name='noSuchObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchObjectClass_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    noSuchObjectClass._val = dict([('ParameterType', _noSuchObjectClass_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))])
    
    #-----< noSuchObjectInstance >-----#
    noSuchObjectInstance = CLASS(name='noSuchObjectInstance', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchObjectInstance_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    noSuchObjectInstance._val = dict([('ParameterType', _noSuchObjectInstance_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))])
    
    #-----< noSuchReferenceObject >-----#
    noSuchReferenceObject = CLASS(name='noSuchReferenceObject', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchReferenceObject_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    noSuchReferenceObject._val = dict([('ParameterType', _noSuchReferenceObject_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 12))])
    
    #-----< operationCancelled >-----#
    operationCancelled = CLASS(name='operationCancelled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    operationCancelled._val = dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 23))])
    
    #-----< processingFailure >-----#
    processingFailure = CLASS(name='processingFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _processingFailure_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    processingFailure._val = dict([('ParameterType', _processingFailure_val_ParameterType), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])
    
    #-----< setListError >-----#
    setListError = CLASS(name='setListError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _setListError_val_ParameterType = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    setListError._val = dict([('ParameterType', _setListError_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 8))])
    
    #-----< syncNotSupported >-----#
    syncNotSupported = CLASS(name='syncNotSupported', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _syncNotSupported_val_ParameterType = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    syncNotSupported._val = dict([('ParameterType', _syncNotSupported_val_ParameterType), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])
    
    #-----< m-Action >-----#
    m_Action = CLASS(name='m-Action', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Action_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    m_Action._val = dict([('ArgumentType', _m_Action_val_ArgumentType), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 6))])
    
    #-----< m-Action-Confirmed >-----#
    m_Action_Confirmed = CLASS(name='m-Action-Confirmed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Action_Confirmed_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _m_Action_Confirmed_val_ResultType = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    m_Action_Confirmed._val = dict([('ArgumentType', _m_Action_Confirmed_val_ArgumentType), ('ResultType', _m_Action_Confirmed_val_ResultType), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 9))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))])
    
    #-----< m-CancelGet >-----#
    m_CancelGet = CLASS(name='m-CancelGet', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_CancelGet_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    m_CancelGet._val = dict([('ArgumentType', _m_CancelGet_val_ArgumentType), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 21))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 22))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])
    
    #-----< m-Create >-----#
    m_Create = CLASS(name='m-Create', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Create_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _m_Create_val_ResultType = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    m_Create._val = dict([('ArgumentType', _m_Create_val_ArgumentType), ('ResultType', _m_Create_val_ResultType), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 6))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 17))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 18))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 5))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 12))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))])
    
    #-----< m-Delete >-----#
    m_Delete = CLASS(name='m-Delete', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Delete_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _m_Delete_val_ResultType = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    m_Delete._val = dict([('ArgumentType', _m_Delete_val_ArgumentType), ('ResultType', _m_Delete_val_ResultType), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))])
    
    #-----< m-EventReport >-----#
    m_EventReport = CLASS(name='m-EventReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_EventReport_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    m_EventReport._val = dict([('ArgumentType', _m_EventReport_val_ArgumentType), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 0))])
    
    #-----< m-EventReport-Confirmed >-----#
    m_EventReport_Confirmed = CLASS(name='m-EventReport-Confirmed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_EventReport_Confirmed_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _m_EventReport_Confirmed_val_ResultType = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    m_EventReport_Confirmed._val = dict([('ArgumentType', _m_EventReport_Confirmed_val_ArgumentType), ('ResultType', _m_EventReport_Confirmed_val_ResultType), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 13))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))])
    
    #-----< m-Get >-----#
    m_Get = CLASS(name='m-Get', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Get_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _m_Get_val_ResultType = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    m_Get._val = dict([('ArgumentType', _m_Get_val_ArgumentType), ('ResultType', _m_Get_val_ResultType), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 23))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])
    
    #-----< m-Linked-Reply >-----#
    m_Linked_Reply = CLASS(name='m-Linked-Reply', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Linked_Reply_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    m_Linked_Reply._val = dict([('ArgumentType', _m_Linked_Reply_val_ArgumentType), ('operationCode', ('local', 2))])
    
    #-----< m-Set >-----#
    m_Set = CLASS(name='m-Set', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Set_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    m_Set._val = dict([('ArgumentType', _m_Set_val_ArgumentType), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 4))])
    
    #-----< m-Set-Confirmed >-----#
    m_Set_Confirmed = CLASS(name='m-Set-Confirmed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Set_Confirmed_val_ArgumentType = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _m_Set_Confirmed_val_ResultType = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    m_Set_Confirmed._val = dict([('ArgumentType', _m_Set_Confirmed_val_ArgumentType), ('ResultType', _m_Set_Confirmed_val_ResultType), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])
    
    #-----< CMIP-ACTION >-----#
    CMIP_ACTION = CLASS(name='CMIP-ACTION', mode=MODE_TYPE)
    _CMIP_ACTION_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('CMIP-1', 'ActionTypeId')), uniq=True)
    _CMIP_ACTION_Value = OPEN(name='Value', mode=MODE_TYPE)
    CMIP_ACTION._cont = ASN1Dict([
        ('id', _CMIP_ACTION_id),
        ('Value', _CMIP_ACTION_Value),
        ])
    
    #-----< CMIP-ATTRIBUTE >-----#
    CMIP_ATTRIBUTE = CLASS(name='CMIP-ATTRIBUTE', mode=MODE_TYPE)
    _CMIP_ATTRIBUTE_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')), uniq=True)
    _CMIP_ATTRIBUTE_Value = OPEN(name='Value', mode=MODE_TYPE)
    CMIP_ATTRIBUTE._cont = ASN1Dict([
        ('id', _CMIP_ATTRIBUTE_id),
        ('Value', _CMIP_ATTRIBUTE_Value),
        ])
    
    #-----< CMIP-AVA >-----#
    CMIP_AVA = CLASS(name='CMIP-AVA', mode=MODE_TYPE)
    _CMIP_AVA_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _CMIP_AVA_Value = OPEN(name='Value', mode=MODE_TYPE)
    CMIP_AVA._cont = ASN1Dict([
        ('id', _CMIP_AVA_id),
        ('Value', _CMIP_AVA_Value),
        ])
    
    #-----< CMIP-EVENT >-----#
    CMIP_EVENT = CLASS(name='CMIP-EVENT', mode=MODE_TYPE)
    _CMIP_EVENT_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('CMIP-1', 'EventTypeId')), uniq=True)
    _CMIP_EVENT_Value = OPEN(name='Value', mode=MODE_TYPE)
    CMIP_EVENT._cont = ASN1Dict([
        ('id', _CMIP_EVENT_id),
        ('Value', _CMIP_EVENT_Value),
        ])
    
    #-----< CMIP-SPECIFICERROR >-----#
    CMIP_SPECIFICERROR = CLASS(name='CMIP-SPECIFICERROR', mode=MODE_TYPE)
    _CMIP_SPECIFICERROR_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _CMIP_SPECIFICERROR_Value = OPEN(name='Value', mode=MODE_TYPE)
    CMIP_SPECIFICERROR._cont = ASN1Dict([
        ('id', _CMIP_SPECIFICERROR_id),
        ('Value', _CMIP_SPECIFICERROR_Value),
        ])
    
    #-----< AccessControl >-----#
    AccessControl = EXT(name='AccessControl', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    
    #-----< ActionArgument >-----#
    ActionArgument = SEQ(name='ActionArgument', mode=MODE_TYPE)
    _ActionArgument_baseManagedObjectClass = CHOICE(name='baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _ActionArgument_baseManagedObjectInstance = CHOICE(name='baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _ActionArgument_accessControl = EXT(name='accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _ActionArgument_synchronization = ENUM(name='synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default='bestEffort')
    _ActionArgument_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=('namedNumbers', 0))
    _ActionArgument_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=('and', []))
    _ActionArgument_actionInfo = SEQ(name='actionInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionInfo')))
    ActionArgument._cont = ASN1Dict([
        ('baseManagedObjectClass', _ActionArgument_baseManagedObjectClass),
        ('baseManagedObjectInstance', _ActionArgument_baseManagedObjectInstance),
        ('accessControl', _ActionArgument_accessControl),
        ('synchronization', _ActionArgument_synchronization),
        ('scope', _ActionArgument_scope),
        ('filter', _ActionArgument_filter),
        ('actionInfo', _ActionArgument_actionInfo),
        ])
    ActionArgument._ext = []
    
    #-----< ActionError >-----#
    ActionError = SEQ(name='ActionError', mode=MODE_TYPE)
    _ActionError_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _ActionError_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _ActionError_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActionError_actionErrorInfo = SEQ(name='actionErrorInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionErrorInfo')))
    ActionError._cont = ASN1Dict([
        ('managedObjectClass', _ActionError_managedObjectClass),
        ('managedObjectInstance', _ActionError_managedObjectInstance),
        ('currentTime', _ActionError_currentTime),
        ('actionErrorInfo', _ActionError_actionErrorInfo),
        ])
    ActionError._ext = []
    
    #-----< ActionErrorInfo >-----#
    ActionErrorInfo = SEQ(name='ActionErrorInfo', mode=MODE_TYPE)
    _ActionErrorInfo_errorStatus = ENUM(name='errorStatus', mode=MODE_TYPE)
    _ActionErrorInfo_errorStatus._cont = ASN1Dict([('accessDenied', 2), ('noSuchAction', 9), ('noSuchArgument', 14), ('invalidArgumentValue', 15)])
    _ActionErrorInfo_errorStatus._ext = []
    _ActionErrorInfo_errorInfo = CHOICE(name='errorInfo', mode=MODE_TYPE)
    __ActionErrorInfo_errorInfo_actionType = CHOICE(name='actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), ['id']))
    ___ActionErrorInfo_errorInfo_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    ___ActionErrorInfo_errorInfo_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ActionErrorInfo_errorInfo_actionType._const_tab = ___ActionErrorInfo_errorInfo_actionType_tab
    __ActionErrorInfo_errorInfo_actionType._const_tab_at = None
    __ActionErrorInfo_errorInfo_actionType._const_tab_id = 'id'
    __ActionErrorInfo_errorInfo_actionArgument = CHOICE(name='actionArgument', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    __ActionErrorInfo_errorInfo_argumentValue = CHOICE(name='argumentValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    _ActionErrorInfo_errorInfo._cont = ASN1Dict([
        ('actionType', __ActionErrorInfo_errorInfo_actionType),
        ('actionArgument', __ActionErrorInfo_errorInfo_actionArgument),
        ('argumentValue', __ActionErrorInfo_errorInfo_argumentValue),
        ])
    _ActionErrorInfo_errorInfo._ext = None
    ActionErrorInfo._cont = ASN1Dict([
        ('errorStatus', _ActionErrorInfo_errorStatus),
        ('errorInfo', _ActionErrorInfo_errorInfo),
        ])
    ActionErrorInfo._ext = []
    
    #-----< ActionInfo >-----#
    ActionInfo = SEQ(name='ActionInfo', mode=MODE_TYPE)
    _ActionInfo_actionType = CHOICE(name='actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), ['id']))
    __ActionInfo_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionInfo_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionInfo_actionType._const_tab = __ActionInfo_actionType_tab
    _ActionInfo_actionType._const_tab_at = None
    _ActionInfo_actionType._const_tab_id = 'id'
    _ActionInfo_actionInfoArg = OPEN(name='actionInfoArg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), ['Value']), opt=True)
    __ActionInfo_actionInfoArg_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionInfo_actionInfoArg_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionInfo_actionInfoArg._const_tab = __ActionInfo_actionInfoArg_tab
    _ActionInfo_actionInfoArg._const_tab_at = ('..', 'actionType')
    _ActionInfo_actionInfoArg._const_tab_id = 'Value'
    ActionInfo._cont = ASN1Dict([
        ('actionType', _ActionInfo_actionType),
        ('actionInfoArg', _ActionInfo_actionInfoArg),
        ])
    ActionInfo._ext = None
    
    #-----< ActionReply >-----#
    ActionReply = SEQ(name='ActionReply', mode=MODE_TYPE)
    _ActionReply_actionType = CHOICE(name='actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), ['id']))
    __ActionReply_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionReply_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionReply_actionType._const_tab = __ActionReply_actionType_tab
    _ActionReply_actionType._const_tab_at = None
    _ActionReply_actionType._const_tab_id = 'id'
    _ActionReply_actionReplyInfo = OPEN(name='actionReplyInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), ['Value']))
    __ActionReply_actionReplyInfo_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionReply_actionReplyInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionReply_actionReplyInfo._const_tab = __ActionReply_actionReplyInfo_tab
    _ActionReply_actionReplyInfo._const_tab_at = ('..', 'actionType')
    _ActionReply_actionReplyInfo._const_tab_id = 'Value'
    ActionReply._cont = ASN1Dict([
        ('actionType', _ActionReply_actionType),
        ('actionReplyInfo', _ActionReply_actionReplyInfo),
        ])
    ActionReply._ext = None
    
    #-----< ActionResult >-----#
    ActionResult = SEQ(name='ActionResult', mode=MODE_TYPE)
    _ActionResult_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _ActionResult_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _ActionResult_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActionResult_actionReply = SEQ(name='actionReply', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionReply')), opt=True)
    ActionResult._cont = ASN1Dict([
        ('managedObjectClass', _ActionResult_managedObjectClass),
        ('managedObjectInstance', _ActionResult_managedObjectInstance),
        ('currentTime', _ActionResult_currentTime),
        ('actionReply', _ActionResult_actionReply),
        ])
    ActionResult._ext = []
    
    #-----< ActionSet >-----#
    ActionSet = CLASS(name='ActionSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    ActionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActionTypeId >-----#
    ActionTypeId = CHOICE(name='ActionTypeId', mode=MODE_TYPE)
    _ActionTypeId_globalForm = OID(name='globalForm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActionTypeId_localForm = INT(name='localForm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ActionTypeId._cont = ASN1Dict([
        ('globalForm', _ActionTypeId_globalForm),
        ('localForm', _ActionTypeId_localForm),
        ])
    ActionTypeId._ext = None
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE)
    _Attribute_id = CHOICE(name='id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['id']))
    __Attribute_id_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __Attribute_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Attribute_id._const_tab = __Attribute_id_tab
    _Attribute_id._const_tab_at = None
    _Attribute_id._const_tab_id = 'id'
    _Attribute_value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['Value']))
    __Attribute_value_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __Attribute_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Attribute_value._const_tab = __Attribute_value_tab
    _Attribute_value._const_tab_at = ('..', 'id')
    _Attribute_value._const_tab_id = 'Value'
    Attribute._cont = ASN1Dict([
        ('id', _Attribute_id),
        ('value', _Attribute_value),
        ])
    Attribute._ext = None
    
    #-----< AttributeError >-----#
    AttributeError = SEQ(name='AttributeError', mode=MODE_TYPE)
    _AttributeError_errorStatus = ENUM(name='errorStatus', mode=MODE_TYPE)
    _AttributeError_errorStatus._cont = ASN1Dict([('accessDenied', 2), ('noSuchAttribute', 5), ('invalidAttributeValue', 6), ('invalidOperation', 24), ('invalidOperator', 25)])
    _AttributeError_errorStatus._ext = []
    _AttributeError_modifyOperator = INT(name='modifyOperator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ModifyOperator')), opt=True)
    _AttributeError_attributeId = CHOICE(name='attributeId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['id']))
    __AttributeError_attributeId_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __AttributeError_attributeId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeError_attributeId._const_tab = __AttributeError_attributeId_tab
    _AttributeError_attributeId._const_tab_at = None
    _AttributeError_attributeId._const_tab_id = 'id'
    _AttributeError_attributeValue = OPEN(name='attributeValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['Value']), opt=True)
    __AttributeError_attributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __AttributeError_attributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeError_attributeValue._const_tab = __AttributeError_attributeValue_tab
    _AttributeError_attributeValue._const_tab_at = ('..', 'attributeId')
    _AttributeError_attributeValue._const_tab_id = 'Value'
    AttributeError._cont = ASN1Dict([
        ('errorStatus', _AttributeError_errorStatus),
        ('modifyOperator', _AttributeError_modifyOperator),
        ('attributeId', _AttributeError_attributeId),
        ('attributeValue', _AttributeError_attributeValue),
        ])
    AttributeError._ext = None
    
    #-----< AttributeId >-----#
    AttributeId = CHOICE(name='AttributeId', mode=MODE_TYPE)
    _AttributeId_globalForm = OID(name='globalForm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributeId_localForm = INT(name='localForm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AttributeId._cont = ASN1Dict([
        ('globalForm', _AttributeId_globalForm),
        ('localForm', _AttributeId_localForm),
        ])
    AttributeId._ext = None
    
    #-----< AttributeIdError >-----#
    AttributeIdError = SEQ(name='AttributeIdError', mode=MODE_TYPE)
    _AttributeIdError_errorStatus = ENUM(name='errorStatus', mode=MODE_TYPE)
    _AttributeIdError_errorStatus._cont = ASN1Dict([('accessDenied', 2), ('noSuchAttribute', 5)])
    _AttributeIdError_errorStatus._ext = []
    _AttributeIdError_attributeId = CHOICE(name='attributeId', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    AttributeIdError._cont = ASN1Dict([
        ('errorStatus', _AttributeIdError_errorStatus),
        ('attributeId', _AttributeIdError_attributeId),
        ])
    AttributeIdError._ext = []
    
    #-----< AttributeSet >-----#
    AttributeSet = CLASS(name='AttributeSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    AttributeSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name='AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_id = OID(name='id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-AVA'), ['id']))
    __AttributeValueAssertion_id_tab = CLASS(name='_tab_CMIP-AVA', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-AVA')))
    __AttributeValueAssertion_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeValueAssertion_id._const_tab = __AttributeValueAssertion_id_tab
    _AttributeValueAssertion_id._const_tab_at = None
    _AttributeValueAssertion_id._const_tab_id = 'id'
    _AttributeValueAssertion_value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-AVA'), ['Value']))
    __AttributeValueAssertion_value_tab = CLASS(name='_tab_CMIP-AVA', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-AVA')))
    __AttributeValueAssertion_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeValueAssertion_value._const_tab = __AttributeValueAssertion_value_tab
    _AttributeValueAssertion_value._const_tab_at = ('..', 'id')
    _AttributeValueAssertion_value._const_tab_id = 'Value'
    AttributeValueAssertion._cont = ASN1Dict([
        ('id', _AttributeValueAssertion_id),
        ('value', _AttributeValueAssertion_value),
        ])
    AttributeValueAssertion._ext = None
    
    #-----< AvaSet >-----#
    AvaSet = CLASS(name='AvaSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-AVA')))
    AvaSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BaseManagedObjectId >-----#
    BaseManagedObjectId = SEQ(name='BaseManagedObjectId', mode=MODE_TYPE)
    _BaseManagedObjectId_baseManagedObjectClass = CHOICE(name='baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _BaseManagedObjectId_baseManagedObjectInstance = CHOICE(name='baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    BaseManagedObjectId._cont = ASN1Dict([
        ('baseManagedObjectClass', _BaseManagedObjectId_baseManagedObjectClass),
        ('baseManagedObjectInstance', _BaseManagedObjectId_baseManagedObjectInstance),
        ])
    BaseManagedObjectId._ext = None
    
    #-----< CMISFilter >-----#
    CMISFilter = CHOICE(name='CMISFilter', mode=MODE_TYPE)
    _CMISFilter_item = CHOICE(name='item', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'FilterItem')))
    _CMISFilter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CMISFilter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _CMISFilter_and_._cont = __CMISFilter_and___item_
    _CMISFilter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CMISFilter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _CMISFilter_or_._cont = __CMISFilter_or___item_
    _CMISFilter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    CMISFilter._cont = ASN1Dict([
        ('item', _CMISFilter_item),
        ('and', _CMISFilter_and_),
        ('or', _CMISFilter_or_),
        ('not', _CMISFilter_not_),
        ])
    CMISFilter._ext = None
    
    #-----< CMISSync >-----#
    CMISSync = ENUM(name='CMISSync', mode=MODE_TYPE)
    CMISSync._cont = ASN1Dict([('bestEffort', 0), ('atomic', 1)])
    CMISSync._ext = None
    
    #-----< ComplexityLimitation >-----#
    ComplexityLimitation = SET(name='ComplexityLimitation', mode=MODE_TYPE)
    _ComplexityLimitation_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), opt=True)
    _ComplexityLimitation_filter = CHOICE(name='filter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), opt=True)
    _ComplexityLimitation_sync = ENUM(name='sync', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), opt=True)
    ComplexityLimitation._cont = ASN1Dict([
        ('scope', _ComplexityLimitation_scope),
        ('filter', _ComplexityLimitation_filter),
        ('sync', _ComplexityLimitation_sync),
        ])
    ComplexityLimitation._ext = []
    
    #-----< CreateArgument >-----#
    CreateArgument = SEQ(name='CreateArgument', mode=MODE_TYPE)
    _CreateArgument_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _CreateArgument_managedOrSuperiorObjectInstance = CHOICE(name='managedOrSuperiorObjectInstance', mode=MODE_TYPE, opt=True)
    __CreateArgument_managedOrSuperiorObjectInstance_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    __CreateArgument_managedOrSuperiorObjectInstance_superiorObjectInstance = CHOICE(name='superiorObjectInstance', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _CreateArgument_managedOrSuperiorObjectInstance._cont = ASN1Dict([
        ('managedObjectInstance', __CreateArgument_managedOrSuperiorObjectInstance_managedObjectInstance),
        ('superiorObjectInstance', __CreateArgument_managedOrSuperiorObjectInstance_superiorObjectInstance),
        ])
    _CreateArgument_managedOrSuperiorObjectInstance._ext = None
    _CreateArgument_accessControl = EXT(name='accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _CreateArgument_referenceObjectInstance = CHOICE(name='referenceObjectInstance', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _CreateArgument_attributeList = SET_OF(name='attributeList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CreateArgument_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _CreateArgument_attributeList._cont = __CreateArgument_attributeList__item_
    CreateArgument._cont = ASN1Dict([
        ('managedObjectClass', _CreateArgument_managedObjectClass),
        ('managedOrSuperiorObjectInstance', _CreateArgument_managedOrSuperiorObjectInstance),
        ('accessControl', _CreateArgument_accessControl),
        ('referenceObjectInstance', _CreateArgument_referenceObjectInstance),
        ('attributeList', _CreateArgument_attributeList),
        ])
    CreateArgument._ext = []
    
    #-----< CreateResult >-----#
    CreateResult = SEQ(name='CreateResult', mode=MODE_TYPE)
    _CreateResult_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _CreateResult_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _CreateResult_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CreateResult_attributeList = SET_OF(name='attributeList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CreateResult_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _CreateResult_attributeList._cont = __CreateResult_attributeList__item_
    CreateResult._cont = ASN1Dict([
        ('managedObjectClass', _CreateResult_managedObjectClass),
        ('managedObjectInstance', _CreateResult_managedObjectInstance),
        ('currentTime', _CreateResult_currentTime),
        ('attributeList', _CreateResult_attributeList),
        ])
    CreateResult._ext = []
    
    #-----< DeleteArgument >-----#
    DeleteArgument = SEQ(name='DeleteArgument', mode=MODE_TYPE)
    _DeleteArgument_baseManagedObjectClass = CHOICE(name='baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _DeleteArgument_baseManagedObjectInstance = CHOICE(name='baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _DeleteArgument_accessControl = EXT(name='accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _DeleteArgument_synchronization = ENUM(name='synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default='bestEffort')
    _DeleteArgument_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=('namedNumbers', 0))
    _DeleteArgument_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=('and', []))
    DeleteArgument._cont = ASN1Dict([
        ('baseManagedObjectClass', _DeleteArgument_baseManagedObjectClass),
        ('baseManagedObjectInstance', _DeleteArgument_baseManagedObjectInstance),
        ('accessControl', _DeleteArgument_accessControl),
        ('synchronization', _DeleteArgument_synchronization),
        ('scope', _DeleteArgument_scope),
        ('filter', _DeleteArgument_filter),
        ])
    DeleteArgument._ext = []
    
    #-----< DeleteError >-----#
    DeleteError = SEQ(name='DeleteError', mode=MODE_TYPE)
    _DeleteError_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _DeleteError_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _DeleteError_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteError_deleteErrorInfo = ENUM(name='deleteErrorInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _DeleteError_deleteErrorInfo._cont = ASN1Dict([('accessDenied', 2)])
    _DeleteError_deleteErrorInfo._ext = []
    DeleteError._cont = ASN1Dict([
        ('managedObjectClass', _DeleteError_managedObjectClass),
        ('managedObjectInstance', _DeleteError_managedObjectInstance),
        ('currentTime', _DeleteError_currentTime),
        ('deleteErrorInfo', _DeleteError_deleteErrorInfo),
        ])
    DeleteError._ext = []
    
    #-----< DeleteResult >-----#
    DeleteResult = SEQ(name='DeleteResult', mode=MODE_TYPE)
    _DeleteResult_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _DeleteResult_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _DeleteResult_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    DeleteResult._cont = ASN1Dict([
        ('managedObjectClass', _DeleteResult_managedObjectClass),
        ('managedObjectInstance', _DeleteResult_managedObjectInstance),
        ('currentTime', _DeleteResult_currentTime),
        ])
    DeleteResult._ext = []
    
    #-----< DistinguishedName >-----#
    DistinguishedName = SEQ_OF(name='DistinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'RDNSequence')))
    
    #-----< EventReply >-----#
    EventReply = SEQ(name='EventReply', mode=MODE_TYPE)
    _EventReply_eventType = CHOICE(name='eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['id']))
    __EventReply_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReply_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReply_eventType._const_tab = __EventReply_eventType_tab
    _EventReply_eventType._const_tab_at = None
    _EventReply_eventType._const_tab_id = 'id'
    _EventReply_eventReplyInfo = OPEN(name='eventReplyInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['Value']), opt=True)
    __EventReply_eventReplyInfo_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReply_eventReplyInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReply_eventReplyInfo._const_tab = __EventReply_eventReplyInfo_tab
    _EventReply_eventReplyInfo._const_tab_at = ('..', 'eventType')
    _EventReply_eventReplyInfo._const_tab_id = 'Value'
    EventReply._cont = ASN1Dict([
        ('eventType', _EventReply_eventType),
        ('eventReplyInfo', _EventReply_eventReplyInfo),
        ])
    EventReply._ext = None
    
    #-----< EventReportArgument >-----#
    EventReportArgument = SEQ(name='EventReportArgument', mode=MODE_TYPE)
    _EventReportArgument_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _EventReportArgument_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _EventReportArgument_eventTime = TIME_GEN(name='eventTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventReportArgument_eventType = CHOICE(name='eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['id']))
    __EventReportArgument_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReportArgument_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReportArgument_eventType._const_tab = __EventReportArgument_eventType_tab
    _EventReportArgument_eventType._const_tab_at = None
    _EventReportArgument_eventType._const_tab_id = 'id'
    _EventReportArgument_eventInfo = OPEN(name='eventInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['Value']), opt=True)
    __EventReportArgument_eventInfo_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReportArgument_eventInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReportArgument_eventInfo._const_tab = __EventReportArgument_eventInfo_tab
    _EventReportArgument_eventInfo._const_tab_at = ('..', 'eventType')
    _EventReportArgument_eventInfo._const_tab_id = 'Value'
    EventReportArgument._cont = ASN1Dict([
        ('managedObjectClass', _EventReportArgument_managedObjectClass),
        ('managedObjectInstance', _EventReportArgument_managedObjectInstance),
        ('eventTime', _EventReportArgument_eventTime),
        ('eventType', _EventReportArgument_eventType),
        ('eventInfo', _EventReportArgument_eventInfo),
        ])
    EventReportArgument._ext = []
    
    #-----< EventReportResult >-----#
    EventReportResult = SEQ(name='EventReportResult', mode=MODE_TYPE)
    _EventReportResult_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _EventReportResult_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _EventReportResult_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventReportResult_eventReply = SEQ(name='eventReply', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReply')), opt=True)
    EventReportResult._cont = ASN1Dict([
        ('managedObjectClass', _EventReportResult_managedObjectClass),
        ('managedObjectInstance', _EventReportResult_managedObjectInstance),
        ('currentTime', _EventReportResult_currentTime),
        ('eventReply', _EventReportResult_eventReply),
        ])
    EventReportResult._ext = []
    
    #-----< EventSet >-----#
    EventSet = CLASS(name='EventSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    EventSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventTypeId >-----#
    EventTypeId = CHOICE(name='EventTypeId', mode=MODE_TYPE)
    _EventTypeId_globalForm = OID(name='globalForm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventTypeId_localForm = INT(name='localForm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    EventTypeId._cont = ASN1Dict([
        ('globalForm', _EventTypeId_globalForm),
        ('localForm', _EventTypeId_localForm),
        ])
    EventTypeId._ext = None
    
    #-----< FilterItem >-----#
    FilterItem = CHOICE(name='FilterItem', mode=MODE_TYPE)
    _FilterItem_equality = SEQ(name='equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_substrings = SEQ_OF(name='substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FilterItem_substrings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___FilterItem_substrings__item__initialString = SEQ(name='initialString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    ___FilterItem_substrings__item__anyString = SEQ(name='anyString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    ___FilterItem_substrings__item__finalString = SEQ(name='finalString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    __FilterItem_substrings__item_._cont = ASN1Dict([
        ('initialString', ___FilterItem_substrings__item__initialString),
        ('anyString', ___FilterItem_substrings__item__anyString),
        ('finalString', ___FilterItem_substrings__item__finalString),
        ])
    __FilterItem_substrings__item_._ext = None
    _FilterItem_substrings._cont = __FilterItem_substrings__item_
    _FilterItem_greaterOrEqual = SEQ(name='greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_lessOrEqual = SEQ(name='lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_present = CHOICE(name='present', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _FilterItem_subsetOf = SEQ(name='subsetOf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_supersetOf = SEQ(name='supersetOf', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_nonNullSetIntersection = SEQ(name='nonNullSetIntersection', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    FilterItem._cont = ASN1Dict([
        ('equality', _FilterItem_equality),
        ('substrings', _FilterItem_substrings),
        ('greaterOrEqual', _FilterItem_greaterOrEqual),
        ('lessOrEqual', _FilterItem_lessOrEqual),
        ('present', _FilterItem_present),
        ('subsetOf', _FilterItem_subsetOf),
        ('supersetOf', _FilterItem_supersetOf),
        ('nonNullSetIntersection', _FilterItem_nonNullSetIntersection),
        ])
    FilterItem._ext = None
    
    #-----< GetArgument >-----#
    GetArgument = SEQ(name='GetArgument', mode=MODE_TYPE)
    _GetArgument_baseManagedObjectClass = CHOICE(name='baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _GetArgument_baseManagedObjectInstance = CHOICE(name='baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _GetArgument_accessControl = EXT(name='accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _GetArgument_synchronization = ENUM(name='synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default='bestEffort')
    _GetArgument_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=('namedNumbers', 0))
    _GetArgument_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=('and', []))
    _GetArgument_attributeIdList = SET_OF(name='attributeIdList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GetArgument_attributeIdList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _GetArgument_attributeIdList._cont = __GetArgument_attributeIdList__item_
    GetArgument._cont = ASN1Dict([
        ('baseManagedObjectClass', _GetArgument_baseManagedObjectClass),
        ('baseManagedObjectInstance', _GetArgument_baseManagedObjectInstance),
        ('accessControl', _GetArgument_accessControl),
        ('synchronization', _GetArgument_synchronization),
        ('scope', _GetArgument_scope),
        ('filter', _GetArgument_filter),
        ('attributeIdList', _GetArgument_attributeIdList),
        ])
    GetArgument._ext = []
    
    #-----< GetInfoStatus >-----#
    GetInfoStatus = CHOICE(name='GetInfoStatus', mode=MODE_TYPE)
    _GetInfoStatus_attributeIdError = SEQ(name='attributeIdError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'AttributeIdError')))
    _GetInfoStatus_attribute = SEQ(name='attribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    GetInfoStatus._cont = ASN1Dict([
        ('attributeIdError', _GetInfoStatus_attributeIdError),
        ('attribute', _GetInfoStatus_attribute),
        ])
    GetInfoStatus._ext = None
    
    #-----< GetListError >-----#
    GetListError = SEQ(name='GetListError', mode=MODE_TYPE)
    _GetListError_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _GetListError_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _GetListError_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GetListError_getInfoList = SET_OF(name='getInfoList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GetListError_getInfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetInfoStatus')))
    _GetListError_getInfoList._cont = __GetListError_getInfoList__item_
    GetListError._cont = ASN1Dict([
        ('managedObjectClass', _GetListError_managedObjectClass),
        ('managedObjectInstance', _GetListError_managedObjectInstance),
        ('currentTime', _GetListError_currentTime),
        ('getInfoList', _GetListError_getInfoList),
        ])
    GetListError._ext = []
    
    #-----< GetResult >-----#
    GetResult = SEQ(name='GetResult', mode=MODE_TYPE)
    _GetResult_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _GetResult_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _GetResult_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GetResult_attributeList = SET_OF(name='attributeList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GetResult_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _GetResult_attributeList._cont = __GetResult_attributeList__item_
    GetResult._cont = ASN1Dict([
        ('managedObjectClass', _GetResult_managedObjectClass),
        ('managedObjectInstance', _GetResult_managedObjectInstance),
        ('currentTime', _GetResult_currentTime),
        ('attributeList', _GetResult_attributeList),
        ])
    GetResult._ext = []
    
    #-----< InvalidArgumentValue >-----#
    InvalidArgumentValue = CHOICE(name='InvalidArgumentValue', mode=MODE_TYPE)
    _InvalidArgumentValue_actionValue = SEQ(name='actionValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionInfo')))
    _InvalidArgumentValue_eventValue = SEQ(name='eventValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __InvalidArgumentValue_eventValue_eventType = CHOICE(name='eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['id']))
    ___InvalidArgumentValue_eventValue_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    ___InvalidArgumentValue_eventValue_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InvalidArgumentValue_eventValue_eventType._const_tab = ___InvalidArgumentValue_eventValue_eventType_tab
    __InvalidArgumentValue_eventValue_eventType._const_tab_at = None
    __InvalidArgumentValue_eventValue_eventType._const_tab_id = 'id'
    __InvalidArgumentValue_eventValue_eventInfo = OPEN(name='eventInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['Value']), opt=True)
    ___InvalidArgumentValue_eventValue_eventInfo_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    ___InvalidArgumentValue_eventValue_eventInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InvalidArgumentValue_eventValue_eventInfo._const_tab = ___InvalidArgumentValue_eventValue_eventInfo_tab
    __InvalidArgumentValue_eventValue_eventInfo._const_tab_at = ('..', 'eventType')
    __InvalidArgumentValue_eventValue_eventInfo._const_tab_id = 'Value'
    _InvalidArgumentValue_eventValue._cont = ASN1Dict([
        ('eventType', __InvalidArgumentValue_eventValue_eventType),
        ('eventInfo', __InvalidArgumentValue_eventValue_eventInfo),
        ])
    _InvalidArgumentValue_eventValue._ext = None
    InvalidArgumentValue._cont = ASN1Dict([
        ('actionValue', _InvalidArgumentValue_actionValue),
        ('eventValue', _InvalidArgumentValue_eventValue),
        ])
    InvalidArgumentValue._ext = None
    
    #-----< InvokeIDType >-----#
    InvokeIDType = CHOICE(name='InvokeIDType', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    
    #-----< LinkedReplyArgument >-----#
    LinkedReplyArgument = CHOICE(name='LinkedReplyArgument', mode=MODE_TYPE)
    _LinkedReplyArgument_getResult = SEQ(name='getResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _LinkedReplyArgument_getListError = SEQ(name='getListError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    _LinkedReplyArgument_setResult = SEQ(name='setResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    _LinkedReplyArgument_setListError = SEQ(name='setListError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    _LinkedReplyArgument_actionResult = SEQ(name='actionResult', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _LinkedReplyArgument_processingFailure = SEQ(name='processingFailure', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _LinkedReplyArgument_deleteResult = SEQ(name='deleteResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _LinkedReplyArgument_actionError = SEQ(name='actionError', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionError')))
    _LinkedReplyArgument_deleteError = SEQ(name='deleteError', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'DeleteError')))
    LinkedReplyArgument._cont = ASN1Dict([
        ('getResult', _LinkedReplyArgument_getResult),
        ('getListError', _LinkedReplyArgument_getListError),
        ('setResult', _LinkedReplyArgument_setResult),
        ('setListError', _LinkedReplyArgument_setListError),
        ('actionResult', _LinkedReplyArgument_actionResult),
        ('processingFailure', _LinkedReplyArgument_processingFailure),
        ('deleteResult', _LinkedReplyArgument_deleteResult),
        ('actionError', _LinkedReplyArgument_actionError),
        ('deleteError', _LinkedReplyArgument_deleteError),
        ])
    LinkedReplyArgument._ext = None
    
    #-----< ModifyOperator >-----#
    ModifyOperator = INT(name='ModifyOperator', mode=MODE_TYPE)
    ModifyOperator._cont = ASN1Dict([('replace', 0), ('addValues', 1), ('removeValues', 2), ('setToDefault', 3)])
    
    #-----< NoSuchAction >-----#
    NoSuchAction = SEQ(name='NoSuchAction', mode=MODE_TYPE)
    _NoSuchAction_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _NoSuchAction_actionType = CHOICE(name='actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), ['id']))
    __NoSuchAction_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __NoSuchAction_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _NoSuchAction_actionType._const_tab = __NoSuchAction_actionType_tab
    _NoSuchAction_actionType._const_tab_at = None
    _NoSuchAction_actionType._const_tab_id = 'id'
    NoSuchAction._cont = ASN1Dict([
        ('managedObjectClass', _NoSuchAction_managedObjectClass),
        ('actionType', _NoSuchAction_actionType),
        ])
    NoSuchAction._ext = []
    
    #-----< NoSuchArgument >-----#
    NoSuchArgument = CHOICE(name='NoSuchArgument', mode=MODE_TYPE)
    _NoSuchArgument_actionId = SEQ(name='actionId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NoSuchArgument_actionId_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    __NoSuchArgument_actionId_actionType = CHOICE(name='actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), ['id']))
    ___NoSuchArgument_actionId_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    ___NoSuchArgument_actionId_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NoSuchArgument_actionId_actionType._const_tab = ___NoSuchArgument_actionId_actionType_tab
    __NoSuchArgument_actionId_actionType._const_tab_at = None
    __NoSuchArgument_actionId_actionType._const_tab_id = 'id'
    _NoSuchArgument_actionId._cont = ASN1Dict([
        ('managedObjectClass', __NoSuchArgument_actionId_managedObjectClass),
        ('actionType', __NoSuchArgument_actionId_actionType),
        ])
    _NoSuchArgument_actionId._ext = None
    _NoSuchArgument_eventId = SEQ(name='eventId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NoSuchArgument_eventId_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    __NoSuchArgument_eventId_eventType = CHOICE(name='eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['id']))
    ___NoSuchArgument_eventId_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    ___NoSuchArgument_eventId_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NoSuchArgument_eventId_eventType._const_tab = ___NoSuchArgument_eventId_eventType_tab
    __NoSuchArgument_eventId_eventType._const_tab_at = None
    __NoSuchArgument_eventId_eventType._const_tab_id = 'id'
    _NoSuchArgument_eventId._cont = ASN1Dict([
        ('managedObjectClass', __NoSuchArgument_eventId_managedObjectClass),
        ('eventType', __NoSuchArgument_eventId_eventType),
        ])
    _NoSuchArgument_eventId._ext = None
    NoSuchArgument._cont = ASN1Dict([
        ('actionId', _NoSuchArgument_actionId),
        ('eventId', _NoSuchArgument_eventId),
        ])
    NoSuchArgument._ext = None
    
    #-----< NoSuchEventType >-----#
    NoSuchEventType = SEQ(name='NoSuchEventType', mode=MODE_TYPE)
    _NoSuchEventType_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _NoSuchEventType_eventType = CHOICE(name='eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), ['id']))
    __NoSuchEventType_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __NoSuchEventType_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _NoSuchEventType_eventType._const_tab = __NoSuchEventType_eventType_tab
    _NoSuchEventType_eventType._const_tab_at = None
    _NoSuchEventType_eventType._const_tab_id = 'id'
    NoSuchEventType._cont = ASN1Dict([
        ('managedObjectClass', _NoSuchEventType_managedObjectClass),
        ('eventType', _NoSuchEventType_eventType),
        ])
    NoSuchEventType._ext = []
    
    #-----< ObjectClass >-----#
    ObjectClass = CHOICE(name='ObjectClass', mode=MODE_TYPE)
    _ObjectClass_globalForm = OID(name='globalForm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ObjectClass_localForm = INT(name='localForm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ObjectClass._cont = ASN1Dict([
        ('globalForm', _ObjectClass_globalForm),
        ('localForm', _ObjectClass_localForm),
        ])
    ObjectClass._ext = None
    
    #-----< ObjectInstance >-----#
    ObjectInstance = CHOICE(name='ObjectInstance', mode=MODE_TYPE)
    _ObjectInstance_distinguishedName = SEQ_OF(name='distinguishedName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'DistinguishedName')))
    _ObjectInstance_nonSpecificForm = OCT_STR(name='nonSpecificForm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ObjectInstance_localDistinguishedName = SEQ_OF(name='localDistinguishedName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'RDNSequence')))
    ObjectInstance._cont = ASN1Dict([
        ('distinguishedName', _ObjectInstance_distinguishedName),
        ('nonSpecificForm', _ObjectInstance_nonSpecificForm),
        ('localDistinguishedName', _ObjectInstance_localDistinguishedName),
        ])
    ObjectInstance._ext = None
    
    #-----< ProcessingFailure >-----#
    ProcessingFailure = SEQ(name='ProcessingFailure', mode=MODE_TYPE)
    _ProcessingFailure_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _ProcessingFailure_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _ProcessingFailure_specificErrorInfo = SEQ(name='specificErrorInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'SpecificErrorInfo')))
    ProcessingFailure._cont = ASN1Dict([
        ('managedObjectClass', _ProcessingFailure_managedObjectClass),
        ('managedObjectInstance', _ProcessingFailure_managedObjectInstance),
        ('specificErrorInfo', _ProcessingFailure_specificErrorInfo),
        ])
    ProcessingFailure._ext = []
    
    #-----< RDNSequence >-----#
    RDNSequence = SEQ_OF(name='RDNSequence', mode=MODE_TYPE)
    _RDNSequence__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'RelativeDistinguishedName')))
    RDNSequence._cont = _RDNSequence__item_
    
    #-----< RelativeDistinguishedName >-----#
    RelativeDistinguishedName = SET_OF(name='RelativeDistinguishedName', mode=MODE_TYPE)
    _RelativeDistinguishedName__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeValueAssertion')))
    RelativeDistinguishedName._cont = _RelativeDistinguishedName__item_
    
    #-----< Scope >-----#
    Scope = CHOICE(name='Scope', mode=MODE_TYPE)
    _Scope_namedNumbers = INT(name='namedNumbers', mode=MODE_TYPE)
    _Scope_namedNumbers._cont = ASN1Dict([('baseObject', 0), ('firstLevelOnly', 1), ('wholeSubtree', 2)])
    _Scope_individualLevels = INT(name='individualLevels', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Scope_baseToNthLevel = INT(name='baseToNthLevel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Scope._cont = ASN1Dict([
        ('namedNumbers', _Scope_namedNumbers),
        ('individualLevels', _Scope_individualLevels),
        ('baseToNthLevel', _Scope_baseToNthLevel),
        ])
    Scope._ext = None
    
    #-----< SetArgument >-----#
    SetArgument = SEQ(name='SetArgument', mode=MODE_TYPE)
    _SetArgument_baseManagedObjectClass = CHOICE(name='baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _SetArgument_baseManagedObjectInstance = CHOICE(name='baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _SetArgument_accessControl = EXT(name='accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _SetArgument_synchronization = ENUM(name='synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default='bestEffort')
    _SetArgument_scope = CHOICE(name='scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=('namedNumbers', 0))
    _SetArgument_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=('and', []))
    _SetArgument_modificationList = SET_OF(name='modificationList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SetArgument_modificationList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___SetArgument_modificationList__item__modifyOperator = INT(name='modifyOperator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ModifyOperator')), default=0)
    ___SetArgument_modificationList__item__attributeId = CHOICE(name='attributeId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['id']))
    ____SetArgument_modificationList__item__attributeId_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ____SetArgument_modificationList__item__attributeId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SetArgument_modificationList__item__attributeId._const_tab = ____SetArgument_modificationList__item__attributeId_tab
    ___SetArgument_modificationList__item__attributeId._const_tab_at = None
    ___SetArgument_modificationList__item__attributeId._const_tab_id = 'id'
    ___SetArgument_modificationList__item__attributeValue = OPEN(name='attributeValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), ['Value']), opt=True)
    ____SetArgument_modificationList__item__attributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ____SetArgument_modificationList__item__attributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SetArgument_modificationList__item__attributeValue._const_tab = ____SetArgument_modificationList__item__attributeValue_tab
    ___SetArgument_modificationList__item__attributeValue._const_tab_at = ('..', 'attributeId')
    ___SetArgument_modificationList__item__attributeValue._const_tab_id = 'Value'
    __SetArgument_modificationList__item_._cont = ASN1Dict([
        ('modifyOperator', ___SetArgument_modificationList__item__modifyOperator),
        ('attributeId', ___SetArgument_modificationList__item__attributeId),
        ('attributeValue', ___SetArgument_modificationList__item__attributeValue),
        ])
    __SetArgument_modificationList__item_._ext = None
    _SetArgument_modificationList._cont = __SetArgument_modificationList__item_
    SetArgument._cont = ASN1Dict([
        ('baseManagedObjectClass', _SetArgument_baseManagedObjectClass),
        ('baseManagedObjectInstance', _SetArgument_baseManagedObjectInstance),
        ('accessControl', _SetArgument_accessControl),
        ('synchronization', _SetArgument_synchronization),
        ('scope', _SetArgument_scope),
        ('filter', _SetArgument_filter),
        ('modificationList', _SetArgument_modificationList),
        ])
    SetArgument._ext = []
    
    #-----< SetInfoStatus >-----#
    SetInfoStatus = CHOICE(name='SetInfoStatus', mode=MODE_TYPE)
    _SetInfoStatus_attributeError = SEQ(name='attributeError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'AttributeError')))
    _SetInfoStatus_attribute = SEQ(name='attribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    SetInfoStatus._cont = ASN1Dict([
        ('attributeError', _SetInfoStatus_attributeError),
        ('attribute', _SetInfoStatus_attribute),
        ])
    SetInfoStatus._ext = None
    
    #-----< SetListError >-----#
    SetListError = SEQ(name='SetListError', mode=MODE_TYPE)
    _SetListError_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _SetListError_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _SetListError_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SetListError_setInfoList = SET_OF(name='setInfoList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SetListError_setInfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetInfoStatus')))
    _SetListError_setInfoList._cont = __SetListError_setInfoList__item_
    SetListError._cont = ASN1Dict([
        ('managedObjectClass', _SetListError_managedObjectClass),
        ('managedObjectInstance', _SetListError_managedObjectInstance),
        ('currentTime', _SetListError_currentTime),
        ('setInfoList', _SetListError_setInfoList),
        ])
    SetListError._ext = []
    
    #-----< SetResult >-----#
    SetResult = SEQ(name='SetResult', mode=MODE_TYPE)
    _SetResult_managedObjectClass = CHOICE(name='managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _SetResult_managedObjectInstance = CHOICE(name='managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _SetResult_currentTime = TIME_GEN(name='currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SetResult_attributeList = SET_OF(name='attributeList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SetResult_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _SetResult_attributeList._cont = __SetResult_attributeList__item_
    SetResult._cont = ASN1Dict([
        ('managedObjectClass', _SetResult_managedObjectClass),
        ('managedObjectInstance', _SetResult_managedObjectInstance),
        ('currentTime', _SetResult_currentTime),
        ('attributeList', _SetResult_attributeList),
        ])
    SetResult._ext = []
    
    #-----< SpecificErrorInfo >-----#
    SpecificErrorInfo = SEQ(name='SpecificErrorInfo', mode=MODE_TYPE)
    _SpecificErrorInfo_errorId = OID(name='errorId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-SPECIFICERROR'), ['id']))
    __SpecificErrorInfo_errorId_tab = CLASS(name='_tab_CMIP-SPECIFICERROR', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-SPECIFICERROR')))
    __SpecificErrorInfo_errorId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SpecificErrorInfo_errorId._const_tab = __SpecificErrorInfo_errorId_tab
    _SpecificErrorInfo_errorId._const_tab_at = None
    _SpecificErrorInfo_errorId._const_tab_id = 'id'
    _SpecificErrorInfo_errorInfo = OPEN(name='errorInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-SPECIFICERROR'), ['Value']))
    __SpecificErrorInfo_errorInfo_tab = CLASS(name='_tab_CMIP-SPECIFICERROR', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-SPECIFICERROR')))
    __SpecificErrorInfo_errorInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SpecificErrorInfo_errorInfo._const_tab = __SpecificErrorInfo_errorInfo_tab
    _SpecificErrorInfo_errorInfo._const_tab_at = ('..', 'errorId')
    _SpecificErrorInfo_errorInfo._const_tab_id = 'Value'
    SpecificErrorInfo._cont = ASN1Dict([
        ('errorId', _SpecificErrorInfo_errorId),
        ('errorInfo', _SpecificErrorInfo_errorInfo),
        ])
    SpecificErrorInfo._ext = None
    
    #-----< SpecificErrorSet >-----#
    SpecificErrorSet = CLASS(name='SpecificErrorSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-SPECIFICERROR')))
    SpecificErrorSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ROSEapdus >-----#
    ROSEapdus = CHOICE(name='ROSEapdus', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _ROSEapdus_invoke = SEQ(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    __ROSEapdus_invoke_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    __ROSEapdus_invoke_invokeId._const_val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ROSEapdus_invoke_linkedId = CHOICE(name='linkedId', mode=MODE_TYPE, opt=True)
    ___ROSEapdus_invoke_linkedId_present = INT(name='present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), ['present']))
    ___ROSEapdus_invoke_linkedId_absent = NULL(name='absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ROSEapdus_invoke_linkedId._cont = ASN1Dict([
        ('present', ___ROSEapdus_invoke_linkedId_present),
        ('absent', ___ROSEapdus_invoke_linkedId_absent),
        ])
    __ROSEapdus_invoke_linkedId._ext = None
    __ROSEapdus_invoke_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ___ROSEapdus_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_1 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_3 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_4 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_6 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_7 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_10 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_10 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    ___ROSEapdus_invoke_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_0), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 6))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_1), ('ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_1), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 9))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_2), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 21))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 22))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_3), ('ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_3), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 6))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 17))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 18))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 5))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 12))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_4), ('ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_4), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_5), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 0))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_6), ('ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_6), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 13))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_7), ('ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_7), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 23))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_8), ('operationCode', ('local', 2))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_9), ('returnResult', False), ('alwaysReturns', False), ('operationCode', ('local', 4))]), dict([('ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_10), ('ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_10), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])], rr=[], ev=None, er=[])
    __ROSEapdus_invoke_opcode._const_tab = ___ROSEapdus_invoke_opcode_tab
    __ROSEapdus_invoke_opcode._const_tab_at = None
    __ROSEapdus_invoke_opcode._const_tab_id = 'operationCode'
    __ROSEapdus_invoke_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ArgumentType']), opt=True)
    __ROSEapdus_invoke_argument._const_tab = ___ROSEapdus_invoke_opcode_tab
    __ROSEapdus_invoke_argument._const_tab_at = ('..', 'opcode')
    __ROSEapdus_invoke_argument._const_tab_id = 'ArgumentType'
    _ROSEapdus_invoke._cont = ASN1Dict([
        ('invokeId', __ROSEapdus_invoke_invokeId),
        ('linkedId', __ROSEapdus_invoke_linkedId),
        ('opcode', __ROSEapdus_invoke_opcode),
        ('argument', __ROSEapdus_invoke_argument),
        ])
    _ROSEapdus_invoke._ext = None
    _ROSEapdus_returnResult = SEQ(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    __ROSEapdus_returnResult_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    __ROSEapdus_returnResult_result = SEQ(name='result', mode=MODE_TYPE, opt=True)
    ___ROSEapdus_returnResult_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['operationCode']))
    ____ROSEapdus_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_0 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_0 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_2 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_3 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_4 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_5 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_6 = SEQ(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    ____ROSEapdus_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_0), ('ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_0), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 9))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_1), ('returnResult', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 21))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 22))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_2), ('ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_2), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 11))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 6))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 17))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 18))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 5))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 12))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_3), ('ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_3), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_4), ('ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_4), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 13))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_5), ('ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_5), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 7))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 23))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_6), ('ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_6), ('resultTypeOptional', True), ('Errors', ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 8))]), dict([('ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))])], rr=[], ev=None, er=[])), ('Linked', ASN1Set(rv=[dict([('ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])], rr=[], ev=None, er=[])
    ___ROSEapdus_returnResult_result_opcode._const_tab = ____ROSEapdus_returnResult_result_opcode_tab
    ___ROSEapdus_returnResult_result_opcode._const_tab_at = None
    ___ROSEapdus_returnResult_result_opcode._const_tab_id = 'operationCode'
    ___ROSEapdus_returnResult_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), ['ResultType']))
    ___ROSEapdus_returnResult_result_result._const_tab = ____ROSEapdus_returnResult_result_opcode_tab
    ___ROSEapdus_returnResult_result_result._const_tab_at = ('..', 'opcode')
    ___ROSEapdus_returnResult_result_result._const_tab_id = 'ResultType'
    __ROSEapdus_returnResult_result._cont = ASN1Dict([
        ('opcode', ___ROSEapdus_returnResult_result_opcode),
        ('result', ___ROSEapdus_returnResult_result_result),
        ])
    __ROSEapdus_returnResult_result._ext = None
    _ROSEapdus_returnResult._cont = ASN1Dict([
        ('invokeId', __ROSEapdus_returnResult_invokeId),
        ('result', __ROSEapdus_returnResult_result),
        ])
    _ROSEapdus_returnResult._ext = None
    _ROSEapdus_returnError = SEQ(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    __ROSEapdus_returnError_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    __ROSEapdus_returnError_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['errorCode']))
    ___ROSEapdus_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_1 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'BaseManagedObjectId')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_2 = SET(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ComplexityLimitation')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_6 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchAction')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_7 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_8 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_9 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_10 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_11 = ENUM(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_13 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_14 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_15 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_16 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17 = SET_OF(name='ParameterType', mode=MODE_TYPE)
    _____ROSEapdus_returnError_errcode_tab_val_ParameterType_17__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17._cont = _____ROSEapdus_returnError_errcode_tab_val_ParameterType_17__item_
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_18 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_19 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_20 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchEventType')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_21 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_23 = SEQ(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    ___ROSEapdus_returnError_errcode_tab._val = ASN1Set(rv=[dict([('ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), ('errorCode', ('local', 2))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_1), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 19))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_2), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 20))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_3), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 16))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_4), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 15))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_5), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 4))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_6), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 9))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_7), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 14))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_8), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 0))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_9), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 1))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_10), ('parameterTypeOptional', True), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 10))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_11), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 3))]), dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 21))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_13), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 22))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_14), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 11))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_15), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 6))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_16), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 17))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 18))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_18), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 5))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_19), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 12))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_20), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 13))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_21), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 7))]), dict([('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 23))]), dict([('ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_23), ('ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])
    __ROSEapdus_returnError_errcode._const_tab = ___ROSEapdus_returnError_errcode_tab
    __ROSEapdus_returnError_errcode._const_tab_at = None
    __ROSEapdus_returnError_errcode._const_tab_id = 'errorCode'
    __ROSEapdus_returnError_parameter = OPEN(name='parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), ['ParameterType']), opt=True)
    __ROSEapdus_returnError_parameter._const_tab = ___ROSEapdus_returnError_errcode_tab
    __ROSEapdus_returnError_parameter._const_tab_at = ('..', 'errcode')
    __ROSEapdus_returnError_parameter._const_tab_id = 'ParameterType'
    _ROSEapdus_returnError._cont = ASN1Dict([
        ('invokeId', __ROSEapdus_returnError_invokeId),
        ('errcode', __ROSEapdus_returnError_errcode),
        ('parameter', __ROSEapdus_returnError_parameter),
        ])
    _ROSEapdus_returnError._ext = None
    _ROSEapdus_reject = SEQ(name='reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ROSEapdus._cont = ASN1Dict([
        ('invoke', _ROSEapdus_invoke),
        ('returnResult', _ROSEapdus_returnResult),
        ('returnError', _ROSEapdus_returnError),
        ('reject', _ROSEapdus_reject),
        ])
    ROSEapdus._ext = None
    
    _all_ = [
        CMIP_Operations,
        _CMIP_Operations_val_ArgumentType_0,
        _CMIP_Operations_val_ArgumentType_1,
        _CMIP_Operations_val_ResultType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _CMIP_Operations_val_ArgumentType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        _CMIP_Operations_val_ArgumentType_3,
        _CMIP_Operations_val_ResultType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0,
        _CMIP_Operations_val_ArgumentType_4,
        _CMIP_Operations_val_ResultType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1,
        _CMIP_Operations_val_ArgumentType_5,
        _CMIP_Operations_val_ArgumentType_6,
        _CMIP_Operations_val_ResultType_6,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2,
        _CMIP_Operations_val_ArgumentType_7,
        _CMIP_Operations_val_ResultType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0,
        _CMIP_Operations_val_ArgumentType_8,
        _CMIP_Operations_val_ArgumentType_9,
        _CMIP_Operations_val_ArgumentType_10,
        _CMIP_Operations_val_ResultType_10,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1,
        CMIP_Confirmed_Operations,
        _CMIP_Confirmed_Operations_val_ArgumentType_0,
        _CMIP_Confirmed_Operations_val_ResultType_0,
        _CMIP_Confirmed_Operations_val_ArgumentType_1,
        _CMIP_Confirmed_Operations_val_ArgumentType_2,
        _CMIP_Confirmed_Operations_val_ResultType_2,
        _CMIP_Confirmed_Operations_val_ArgumentType_3,
        _CMIP_Confirmed_Operations_val_ResultType_3,
        _CMIP_Confirmed_Operations_val_ArgumentType_4,
        _CMIP_Confirmed_Operations_val_ResultType_4,
        _CMIP_Confirmed_Operations_val_ArgumentType_5,
        _CMIP_Confirmed_Operations_val_ResultType_5,
        _CMIP_Confirmed_Operations_val_ArgumentType_6,
        _CMIP_Confirmed_Operations_val_ResultType_6,
        accessDenied,
        classInstanceConflict,
        _classInstanceConflict_val_ParameterType,
        complexityLimitation,
        _complexityLimitation_val_ParameterType,
        duplicateManagedObjectInstance,
        _duplicateManagedObjectInstance_val_ParameterType,
        getListError,
        _getListError_val_ParameterType,
        invalidArgumentValue,
        _invalidArgumentValue_val_ParameterType,
        invalidAttributeValue,
        _invalidAttributeValue_val_ParameterType,
        invalidFilter,
        _invalidFilter_val_ParameterType,
        invalidObjectInstance,
        _invalidObjectInstance_val_ParameterType,
        invalidScope,
        _invalidScope_val_ParameterType,
        missingAttributeValue,
        __missingAttributeValue_val_ParameterType__item_,
        _missingAttributeValue_val_ParameterType,
        mistypedOperation,
        noSuchAction,
        _noSuchAction_val_ParameterType,
        noSuchArgument,
        _noSuchArgument_val_ParameterType,
        noSuchAttribute,
        _noSuchAttribute_val_ParameterType,
        noSuchEventType,
        _noSuchEventType_val_ParameterType,
        noSuchInvokeId,
        _noSuchInvokeId_val_ParameterType,
        noSuchObjectClass,
        _noSuchObjectClass_val_ParameterType,
        noSuchObjectInstance,
        _noSuchObjectInstance_val_ParameterType,
        noSuchReferenceObject,
        _noSuchReferenceObject_val_ParameterType,
        operationCancelled,
        processingFailure,
        _processingFailure_val_ParameterType,
        setListError,
        _setListError_val_ParameterType,
        syncNotSupported,
        _syncNotSupported_val_ParameterType,
        m_Action,
        _m_Action_val_ArgumentType,
        m_Action_Confirmed,
        _m_Action_Confirmed_val_ArgumentType,
        _m_Action_Confirmed_val_ResultType,
        m_CancelGet,
        _m_CancelGet_val_ArgumentType,
        m_Create,
        _m_Create_val_ArgumentType,
        _m_Create_val_ResultType,
        m_Delete,
        _m_Delete_val_ArgumentType,
        _m_Delete_val_ResultType,
        m_EventReport,
        _m_EventReport_val_ArgumentType,
        m_EventReport_Confirmed,
        _m_EventReport_Confirmed_val_ArgumentType,
        _m_EventReport_Confirmed_val_ResultType,
        m_Get,
        _m_Get_val_ArgumentType,
        _m_Get_val_ResultType,
        m_Linked_Reply,
        _m_Linked_Reply_val_ArgumentType,
        m_Set,
        _m_Set_val_ArgumentType,
        m_Set_Confirmed,
        _m_Set_Confirmed_val_ArgumentType,
        _m_Set_Confirmed_val_ResultType,
        _CMIP_ACTION_id,
        _CMIP_ACTION_Value,
        CMIP_ACTION,
        _CMIP_ATTRIBUTE_id,
        _CMIP_ATTRIBUTE_Value,
        CMIP_ATTRIBUTE,
        _CMIP_AVA_id,
        _CMIP_AVA_Value,
        CMIP_AVA,
        _CMIP_EVENT_id,
        _CMIP_EVENT_Value,
        CMIP_EVENT,
        _CMIP_SPECIFICERROR_id,
        _CMIP_SPECIFICERROR_Value,
        CMIP_SPECIFICERROR,
        AccessControl,
        _ActionArgument_baseManagedObjectClass,
        _ActionArgument_baseManagedObjectInstance,
        _ActionArgument_accessControl,
        _ActionArgument_synchronization,
        _ActionArgument_scope,
        _ActionArgument_filter,
        _ActionArgument_actionInfo,
        ActionArgument,
        _ActionError_managedObjectClass,
        _ActionError_managedObjectInstance,
        _ActionError_currentTime,
        _ActionError_actionErrorInfo,
        ActionError,
        _ActionErrorInfo_errorStatus,
        ___ActionErrorInfo_errorInfo_actionType_tab,
        __ActionErrorInfo_errorInfo_actionType,
        __ActionErrorInfo_errorInfo_actionArgument,
        __ActionErrorInfo_errorInfo_argumentValue,
        _ActionErrorInfo_errorInfo,
        ActionErrorInfo,
        __ActionInfo_actionType_tab,
        _ActionInfo_actionType,
        __ActionInfo_actionInfoArg_tab,
        _ActionInfo_actionInfoArg,
        ActionInfo,
        __ActionReply_actionType_tab,
        _ActionReply_actionType,
        __ActionReply_actionReplyInfo_tab,
        _ActionReply_actionReplyInfo,
        ActionReply,
        _ActionResult_managedObjectClass,
        _ActionResult_managedObjectInstance,
        _ActionResult_currentTime,
        _ActionResult_actionReply,
        ActionResult,
        ActionSet,
        _ActionTypeId_globalForm,
        _ActionTypeId_localForm,
        ActionTypeId,
        __Attribute_id_tab,
        _Attribute_id,
        __Attribute_value_tab,
        _Attribute_value,
        Attribute,
        _AttributeError_errorStatus,
        _AttributeError_modifyOperator,
        __AttributeError_attributeId_tab,
        _AttributeError_attributeId,
        __AttributeError_attributeValue_tab,
        _AttributeError_attributeValue,
        AttributeError,
        _AttributeId_globalForm,
        _AttributeId_localForm,
        AttributeId,
        _AttributeIdError_errorStatus,
        _AttributeIdError_attributeId,
        AttributeIdError,
        AttributeSet,
        __AttributeValueAssertion_id_tab,
        _AttributeValueAssertion_id,
        __AttributeValueAssertion_value_tab,
        _AttributeValueAssertion_value,
        AttributeValueAssertion,
        AvaSet,
        _BaseManagedObjectId_baseManagedObjectClass,
        _BaseManagedObjectId_baseManagedObjectInstance,
        BaseManagedObjectId,
        _CMISFilter_item,
        __CMISFilter_and___item_,
        _CMISFilter_and_,
        __CMISFilter_or___item_,
        _CMISFilter_or_,
        _CMISFilter_not_,
        CMISFilter,
        CMISSync,
        _ComplexityLimitation_scope,
        _ComplexityLimitation_filter,
        _ComplexityLimitation_sync,
        ComplexityLimitation,
        _CreateArgument_managedObjectClass,
        __CreateArgument_managedOrSuperiorObjectInstance_managedObjectInstance,
        __CreateArgument_managedOrSuperiorObjectInstance_superiorObjectInstance,
        _CreateArgument_managedOrSuperiorObjectInstance,
        _CreateArgument_accessControl,
        _CreateArgument_referenceObjectInstance,
        __CreateArgument_attributeList__item_,
        _CreateArgument_attributeList,
        CreateArgument,
        _CreateResult_managedObjectClass,
        _CreateResult_managedObjectInstance,
        _CreateResult_currentTime,
        __CreateResult_attributeList__item_,
        _CreateResult_attributeList,
        CreateResult,
        _DeleteArgument_baseManagedObjectClass,
        _DeleteArgument_baseManagedObjectInstance,
        _DeleteArgument_accessControl,
        _DeleteArgument_synchronization,
        _DeleteArgument_scope,
        _DeleteArgument_filter,
        DeleteArgument,
        _DeleteError_managedObjectClass,
        _DeleteError_managedObjectInstance,
        _DeleteError_currentTime,
        _DeleteError_deleteErrorInfo,
        DeleteError,
        _DeleteResult_managedObjectClass,
        _DeleteResult_managedObjectInstance,
        _DeleteResult_currentTime,
        DeleteResult,
        DistinguishedName,
        __EventReply_eventType_tab,
        _EventReply_eventType,
        __EventReply_eventReplyInfo_tab,
        _EventReply_eventReplyInfo,
        EventReply,
        _EventReportArgument_managedObjectClass,
        _EventReportArgument_managedObjectInstance,
        _EventReportArgument_eventTime,
        __EventReportArgument_eventType_tab,
        _EventReportArgument_eventType,
        __EventReportArgument_eventInfo_tab,
        _EventReportArgument_eventInfo,
        EventReportArgument,
        _EventReportResult_managedObjectClass,
        _EventReportResult_managedObjectInstance,
        _EventReportResult_currentTime,
        _EventReportResult_eventReply,
        EventReportResult,
        EventSet,
        _EventTypeId_globalForm,
        _EventTypeId_localForm,
        EventTypeId,
        _FilterItem_equality,
        ___FilterItem_substrings__item__initialString,
        ___FilterItem_substrings__item__anyString,
        ___FilterItem_substrings__item__finalString,
        __FilterItem_substrings__item_,
        _FilterItem_substrings,
        _FilterItem_greaterOrEqual,
        _FilterItem_lessOrEqual,
        _FilterItem_present,
        _FilterItem_subsetOf,
        _FilterItem_supersetOf,
        _FilterItem_nonNullSetIntersection,
        FilterItem,
        _GetArgument_baseManagedObjectClass,
        _GetArgument_baseManagedObjectInstance,
        _GetArgument_accessControl,
        _GetArgument_synchronization,
        _GetArgument_scope,
        _GetArgument_filter,
        __GetArgument_attributeIdList__item_,
        _GetArgument_attributeIdList,
        GetArgument,
        _GetInfoStatus_attributeIdError,
        _GetInfoStatus_attribute,
        GetInfoStatus,
        _GetListError_managedObjectClass,
        _GetListError_managedObjectInstance,
        _GetListError_currentTime,
        __GetListError_getInfoList__item_,
        _GetListError_getInfoList,
        GetListError,
        _GetResult_managedObjectClass,
        _GetResult_managedObjectInstance,
        _GetResult_currentTime,
        __GetResult_attributeList__item_,
        _GetResult_attributeList,
        GetResult,
        _InvalidArgumentValue_actionValue,
        ___InvalidArgumentValue_eventValue_eventType_tab,
        __InvalidArgumentValue_eventValue_eventType,
        ___InvalidArgumentValue_eventValue_eventInfo_tab,
        __InvalidArgumentValue_eventValue_eventInfo,
        _InvalidArgumentValue_eventValue,
        InvalidArgumentValue,
        InvokeIDType,
        _LinkedReplyArgument_getResult,
        _LinkedReplyArgument_getListError,
        _LinkedReplyArgument_setResult,
        _LinkedReplyArgument_setListError,
        _LinkedReplyArgument_actionResult,
        _LinkedReplyArgument_processingFailure,
        _LinkedReplyArgument_deleteResult,
        _LinkedReplyArgument_actionError,
        _LinkedReplyArgument_deleteError,
        LinkedReplyArgument,
        ModifyOperator,
        _NoSuchAction_managedObjectClass,
        __NoSuchAction_actionType_tab,
        _NoSuchAction_actionType,
        NoSuchAction,
        __NoSuchArgument_actionId_managedObjectClass,
        ___NoSuchArgument_actionId_actionType_tab,
        __NoSuchArgument_actionId_actionType,
        _NoSuchArgument_actionId,
        __NoSuchArgument_eventId_managedObjectClass,
        ___NoSuchArgument_eventId_eventType_tab,
        __NoSuchArgument_eventId_eventType,
        _NoSuchArgument_eventId,
        NoSuchArgument,
        _NoSuchEventType_managedObjectClass,
        __NoSuchEventType_eventType_tab,
        _NoSuchEventType_eventType,
        NoSuchEventType,
        _ObjectClass_globalForm,
        _ObjectClass_localForm,
        ObjectClass,
        _ObjectInstance_distinguishedName,
        _ObjectInstance_nonSpecificForm,
        _ObjectInstance_localDistinguishedName,
        ObjectInstance,
        _ProcessingFailure_managedObjectClass,
        _ProcessingFailure_managedObjectInstance,
        _ProcessingFailure_specificErrorInfo,
        ProcessingFailure,
        _RDNSequence__item_,
        RDNSequence,
        _RelativeDistinguishedName__item_,
        RelativeDistinguishedName,
        _Scope_namedNumbers,
        _Scope_individualLevels,
        _Scope_baseToNthLevel,
        Scope,
        _SetArgument_baseManagedObjectClass,
        _SetArgument_baseManagedObjectInstance,
        _SetArgument_accessControl,
        _SetArgument_synchronization,
        _SetArgument_scope,
        _SetArgument_filter,
        ___SetArgument_modificationList__item__modifyOperator,
        ____SetArgument_modificationList__item__attributeId_tab,
        ___SetArgument_modificationList__item__attributeId,
        ____SetArgument_modificationList__item__attributeValue_tab,
        ___SetArgument_modificationList__item__attributeValue,
        __SetArgument_modificationList__item_,
        _SetArgument_modificationList,
        SetArgument,
        _SetInfoStatus_attributeError,
        _SetInfoStatus_attribute,
        SetInfoStatus,
        _SetListError_managedObjectClass,
        _SetListError_managedObjectInstance,
        _SetListError_currentTime,
        __SetListError_setInfoList__item_,
        _SetListError_setInfoList,
        SetListError,
        _SetResult_managedObjectClass,
        _SetResult_managedObjectInstance,
        _SetResult_currentTime,
        __SetResult_attributeList__item_,
        _SetResult_attributeList,
        SetResult,
        __SpecificErrorInfo_errorId_tab,
        _SpecificErrorInfo_errorId,
        __SpecificErrorInfo_errorInfo_tab,
        _SpecificErrorInfo_errorInfo,
        SpecificErrorInfo,
        SpecificErrorSet,
        __ROSEapdus_invoke_invokeId,
        ___ROSEapdus_invoke_linkedId_present,
        ___ROSEapdus_invoke_linkedId_absent,
        __ROSEapdus_invoke_linkedId,
        ___ROSEapdus_invoke_opcode_tab,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_0,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_1,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_1,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_2,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_3,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_3,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_4,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_4,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_5,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_6,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_6,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_7,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_7,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_8,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_9,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_10,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_10,
        __ROSEapdus_invoke_opcode,
        __ROSEapdus_invoke_argument,
        _ROSEapdus_invoke,
        __ROSEapdus_returnResult_invokeId,
        ____ROSEapdus_returnResult_result_opcode_tab,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_0,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_0,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_1,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_2,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_2,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_3,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_3,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_4,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_4,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_5,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_5,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_6,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_6,
        ___ROSEapdus_returnResult_result_opcode,
        ___ROSEapdus_returnResult_result_result,
        __ROSEapdus_returnResult_result,
        _ROSEapdus_returnResult,
        __ROSEapdus_returnError_invokeId,
        ___ROSEapdus_returnError_errcode_tab,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_1,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_2,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_3,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_4,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_5,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_6,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_7,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_8,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_9,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_10,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_11,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_13,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_14,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_15,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_16,
        _____ROSEapdus_returnError_errcode_tab_val_ParameterType_17__item_,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_18,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_19,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_20,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_21,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_23,
        __ROSEapdus_returnError_errcode,
        __ROSEapdus_returnError_parameter,
        _ROSEapdus_returnError,
        _ROSEapdus_reject,
        ROSEapdus,
    ]

class CommonProtocolSpecification:

    _name_  = 'CommonProtocolSpecification'
    _oid_   = [2, 5, 1, 35, 8]
    
    _obj_ = [
        'OPERATION',
        'ERROR',
        'Code',
        'InvokeId',
        'id-opcode-read',
        'id-opcode-compare',
        'id-opcode-abandon',
        'id-opcode-list',
        'id-opcode-search',
        'id-opcode-addEntry',
        'id-opcode-removeEntry',
        'id-opcode-modifyEntry',
        'id-opcode-modifyDN',
        'id-opcode-changePassword',
        'id-opcode-administerPassword',
        'id-opcode-ldapTransport',
        'id-opcode-linkedLDAP',
        'id-opcode-requestShadowUpdate',
        'id-opcode-updateShadow',
        'id-opcode-coordinateShadowUpdate',
        'id-op-establishOperationalBinding',
        'id-op-modifyOperationalBinding',
        'id-op-terminateOperationalBinding',
        'id-errcode-attributeError',
        'id-errcode-nameError',
        'id-errcode-serviceError',
        'id-errcode-referral',
        'id-errcode-abandoned',
        'id-errcode-securityError',
        'id-errcode-abandonFailed',
        'id-errcode-updateError',
        'id-errcode-dsaReferral',
        'id-errcode-shadowError',
        'id-err-operationalBindingError',
        'DOP-Invokable',
        'DOP-Returnable',
        ]
    _type_ = [
        'OPERATION',
        'ERROR',
        'Code',
        'InvokeId',
        ]
    _set_ = [
        'DOP-Invokable',
        'DOP-Returnable',
        ]
    _val_ = [
        'id-opcode-read',
        'id-opcode-compare',
        'id-opcode-abandon',
        'id-opcode-list',
        'id-opcode-search',
        'id-opcode-addEntry',
        'id-opcode-removeEntry',
        'id-opcode-modifyEntry',
        'id-opcode-modifyDN',
        'id-opcode-changePassword',
        'id-opcode-administerPassword',
        'id-opcode-ldapTransport',
        'id-opcode-linkedLDAP',
        'id-opcode-requestShadowUpdate',
        'id-opcode-updateShadow',
        'id-opcode-coordinateShadowUpdate',
        'id-op-establishOperationalBinding',
        'id-op-modifyOperationalBinding',
        'id-op-terminateOperationalBinding',
        'id-errcode-attributeError',
        'id-errcode-nameError',
        'id-errcode-serviceError',
        'id-errcode-referral',
        'id-errcode-abandoned',
        'id-errcode-securityError',
        'id-errcode-abandonFailed',
        'id-errcode-updateError',
        'id-errcode-dsaReferral',
        'id-errcode-shadowError',
        'id-err-operationalBindingError',
        ]
    _class_ = [
        'OPERATION',
        'ERROR',
        'DOP-Invokable',
        'DOP-Returnable',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name='OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name='ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_ResultType = OPEN(name='ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')), opt=True)
    _OPERATION_operationCode = CHOICE(name='operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        ('ArgumentType', _OPERATION_ArgumentType),
        ('ResultType', _OPERATION_ResultType),
        ('Errors', _OPERATION_Errors),
        ('operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name='ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name='ParameterType', mode=MODE_TYPE)
    _ERROR_errorCode = CHOICE(name='errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        ('ParameterType', _ERROR_ParameterType),
        ('errorCode', _ERROR_errorCode),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name='Code', mode=MODE_TYPE)
    _Code_local = INT(name='local', mode=MODE_TYPE)
    _Code_global_ = OID(name='global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        ('local', _Code_local),
        ('global', _Code_global_),
        ])
    Code._ext = []
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name='InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name='present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name='absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        ('present', _InvokeId_present),
        ('absent', _InvokeId_absent),
        ])
    InvokeId._ext = []
    
    #-----< id-opcode-read >-----#
    id_opcode_read = CHOICE(name='id-opcode-read', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_read._val = ('local', 1)
    
    #-----< id-opcode-compare >-----#
    id_opcode_compare = CHOICE(name='id-opcode-compare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_compare._val = ('local', 2)
    
    #-----< id-opcode-abandon >-----#
    id_opcode_abandon = CHOICE(name='id-opcode-abandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_abandon._val = ('local', 3)
    
    #-----< id-opcode-list >-----#
    id_opcode_list = CHOICE(name='id-opcode-list', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_list._val = ('local', 4)
    
    #-----< id-opcode-search >-----#
    id_opcode_search = CHOICE(name='id-opcode-search', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_search._val = ('local', 5)
    
    #-----< id-opcode-addEntry >-----#
    id_opcode_addEntry = CHOICE(name='id-opcode-addEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_addEntry._val = ('local', 6)
    
    #-----< id-opcode-removeEntry >-----#
    id_opcode_removeEntry = CHOICE(name='id-opcode-removeEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_removeEntry._val = ('local', 7)
    
    #-----< id-opcode-modifyEntry >-----#
    id_opcode_modifyEntry = CHOICE(name='id-opcode-modifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_modifyEntry._val = ('local', 8)
    
    #-----< id-opcode-modifyDN >-----#
    id_opcode_modifyDN = CHOICE(name='id-opcode-modifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_modifyDN._val = ('local', 9)
    
    #-----< id-opcode-changePassword >-----#
    id_opcode_changePassword = CHOICE(name='id-opcode-changePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_changePassword._val = ('local', 10)
    
    #-----< id-opcode-administerPassword >-----#
    id_opcode_administerPassword = CHOICE(name='id-opcode-administerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_administerPassword._val = ('local', 11)
    
    #-----< id-opcode-ldapTransport >-----#
    id_opcode_ldapTransport = CHOICE(name='id-opcode-ldapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_ldapTransport._val = ('local', 12)
    
    #-----< id-opcode-linkedLDAP >-----#
    id_opcode_linkedLDAP = CHOICE(name='id-opcode-linkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_linkedLDAP._val = ('local', 13)
    
    #-----< id-opcode-requestShadowUpdate >-----#
    id_opcode_requestShadowUpdate = CHOICE(name='id-opcode-requestShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_requestShadowUpdate._val = ('local', 1)
    
    #-----< id-opcode-updateShadow >-----#
    id_opcode_updateShadow = CHOICE(name='id-opcode-updateShadow', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_updateShadow._val = ('local', 2)
    
    #-----< id-opcode-coordinateShadowUpdate >-----#
    id_opcode_coordinateShadowUpdate = CHOICE(name='id-opcode-coordinateShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_coordinateShadowUpdate._val = ('local', 3)
    
    #-----< id-op-establishOperationalBinding >-----#
    id_op_establishOperationalBinding = CHOICE(name='id-op-establishOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_establishOperationalBinding._val = ('local', 100)
    
    #-----< id-op-modifyOperationalBinding >-----#
    id_op_modifyOperationalBinding = CHOICE(name='id-op-modifyOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_modifyOperationalBinding._val = ('local', 102)
    
    #-----< id-op-terminateOperationalBinding >-----#
    id_op_terminateOperationalBinding = CHOICE(name='id-op-terminateOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_terminateOperationalBinding._val = ('local', 101)
    
    #-----< id-errcode-attributeError >-----#
    id_errcode_attributeError = CHOICE(name='id-errcode-attributeError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_attributeError._val = ('local', 1)
    
    #-----< id-errcode-nameError >-----#
    id_errcode_nameError = CHOICE(name='id-errcode-nameError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_nameError._val = ('local', 2)
    
    #-----< id-errcode-serviceError >-----#
    id_errcode_serviceError = CHOICE(name='id-errcode-serviceError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_serviceError._val = ('local', 3)
    
    #-----< id-errcode-referral >-----#
    id_errcode_referral = CHOICE(name='id-errcode-referral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_referral._val = ('local', 4)
    
    #-----< id-errcode-abandoned >-----#
    id_errcode_abandoned = CHOICE(name='id-errcode-abandoned', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_abandoned._val = ('local', 5)
    
    #-----< id-errcode-securityError >-----#
    id_errcode_securityError = CHOICE(name='id-errcode-securityError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_securityError._val = ('local', 6)
    
    #-----< id-errcode-abandonFailed >-----#
    id_errcode_abandonFailed = CHOICE(name='id-errcode-abandonFailed', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_abandonFailed._val = ('local', 7)
    
    #-----< id-errcode-updateError >-----#
    id_errcode_updateError = CHOICE(name='id-errcode-updateError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_updateError._val = ('local', 8)
    
    #-----< id-errcode-dsaReferral >-----#
    id_errcode_dsaReferral = CHOICE(name='id-errcode-dsaReferral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_dsaReferral._val = ('local', 9)
    
    #-----< id-errcode-shadowError >-----#
    id_errcode_shadowError = CHOICE(name='id-errcode-shadowError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_shadowError._val = ('local', 1)
    
    #-----< id-err-operationalBindingError >-----#
    id_err_operationalBindingError = CHOICE(name='id-err-operationalBindingError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_err_operationalBindingError._val = ('local', 100)
    
    #-----< DOP-Invokable >-----#
    DOP_Invokable = CLASS(name='DOP-Invokable', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _DOP_Invokable_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    _DOP_Invokable_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    _DOP_Invokable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    DOP_Invokable._val = ASN1Set(rv=[dict([('ArgumentType', _DOP_Invokable_val_ArgumentType_0), ('ResultType', _DOP_Invokable_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', _DOP_Invokable_val_ArgumentType_1), ('ResultType', _DOP_Invokable_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', _DOP_Invokable_val_ArgumentType_2), ('ResultType', _DOP_Invokable_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])
    
    #-----< DOP-Returnable >-----#
    DOP_Returnable = CLASS(name='DOP-Returnable', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _DOP_Returnable_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    _DOP_Returnable_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    _DOP_Returnable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    DOP_Returnable._val = ASN1Set(rv=[dict([('ArgumentType', _DOP_Returnable_val_ArgumentType_0), ('ResultType', _DOP_Returnable_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', _DOP_Returnable_val_ArgumentType_1), ('ResultType', _DOP_Returnable_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', _DOP_Returnable_val_ArgumentType_2), ('ResultType', _DOP_Returnable_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_ResultType,
        _OPERATION_Errors,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_errorCode,
        ERROR,
        _Code_local,
        _Code_global_,
        Code,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        id_opcode_read,
        id_opcode_compare,
        id_opcode_abandon,
        id_opcode_list,
        id_opcode_search,
        id_opcode_addEntry,
        id_opcode_removeEntry,
        id_opcode_modifyEntry,
        id_opcode_modifyDN,
        id_opcode_changePassword,
        id_opcode_administerPassword,
        id_opcode_ldapTransport,
        id_opcode_linkedLDAP,
        id_opcode_requestShadowUpdate,
        id_opcode_updateShadow,
        id_opcode_coordinateShadowUpdate,
        id_op_establishOperationalBinding,
        id_op_modifyOperationalBinding,
        id_op_terminateOperationalBinding,
        id_errcode_attributeError,
        id_errcode_nameError,
        id_errcode_serviceError,
        id_errcode_referral,
        id_errcode_abandoned,
        id_errcode_securityError,
        id_errcode_abandonFailed,
        id_errcode_updateError,
        id_errcode_dsaReferral,
        id_errcode_shadowError,
        id_err_operationalBindingError,
        DOP_Invokable,
        _DOP_Invokable_val_ArgumentType_0,
        _DOP_Invokable_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        _DOP_Invokable_val_ArgumentType_1,
        _DOP_Invokable_val_ResultType_1,
        _DOP_Invokable_val_ArgumentType_2,
        _DOP_Invokable_val_ResultType_2,
        DOP_Returnable,
        _DOP_Returnable_val_ArgumentType_0,
        _DOP_Returnable_val_ResultType_0,
        _DOP_Returnable_val_ArgumentType_1,
        _DOP_Returnable_val_ResultType_1,
        _DOP_Returnable_val_ArgumentType_2,
        _DOP_Returnable_val_ResultType_2,
    ]

class CPDTChargingDataTypes:

    _name_  = 'CPDTChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 13, 0, 1]
    
    _obj_ = [
        'CPDTRecord',
        'CPDTSCERecord',
        'CPDTSNNRecord',
        'CPCauseForRecClosing',
        'NIDDsubmission',
        'ServiceChangeCondition',
        'SubmissionResultCode',
        ]
    _type_ = [
        'CPDTRecord',
        'CPDTSCERecord',
        'CPDTSNNRecord',
        'CPCauseForRecClosing',
        'NIDDsubmission',
        'ServiceChangeCondition',
        'SubmissionResultCode',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CPDTRecord >-----#
    CPDTRecord = CHOICE(name='CPDTRecord', mode=MODE_TYPE)
    _CPDTRecord_cPDTSCERecord = SET(name='cPDTSCERecord', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPDTSCERecord')))
    _CPDTRecord_cPDTSNNRecord = SET(name='cPDTSNNRecord', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPDTSNNRecord')))
    CPDTRecord._cont = ASN1Dict([
        ('cPDTSCERecord', _CPDTRecord_cPDTSCERecord),
        ('cPDTSNNRecord', _CPDTRecord_cPDTSNNRecord),
        ])
    CPDTRecord._ext = None
    
    #-----< CPDTSCERecord >-----#
    CPDTSCERecord = SET(name='CPDTSCERecord', mode=MODE_TYPE)
    _CPDTSCERecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CPDTSCERecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSCERecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _CPDTSCERecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _CPDTSCERecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _CPDTSCERecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _CPDTSCERecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _CPDTSCERecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CPDTSCERecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CPDTSCERecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _CPDTSCERecord_sCEFID = OCT_STR(name='sCEFID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSCERecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _CPDTSCERecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _CPDTSCERecord_servingNodeIdentity = OCT_STR(name='servingNodeIdentity', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSCERecord_servingPLMNRateControl = SEQ(name='servingPLMNRateControl', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _CPDTSCERecord_listOfNIDDsubmission = SEQ_OF(name='listOfNIDDsubmission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPDTSCERecord_listOfNIDDsubmission__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CPDTChargingDataTypes', 'NIDDsubmission')))
    _CPDTSCERecord_listOfNIDDsubmission._cont = __CPDTSCERecord_listOfNIDDsubmission__item_
    _CPDTSCERecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPCauseForRecClosing')))
    _CPDTSCERecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CPDTSCERecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CPDTSCERecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSCERecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CPDTSCERecord_externalIdentifier = SET(name='externalIdentifier', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _CPDTSCERecord_aPNRateControl = SEQ(name='aPNRateControl', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _CPDTSCERecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _CPDTSCERecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _CPDTSCERecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    CPDTSCERecord._cont = ASN1Dict([
        ('recordType', _CPDTSCERecord_recordType),
        ('retransmission', _CPDTSCERecord_retransmission),
        ('servedIMSI', _CPDTSCERecord_servedIMSI),
        ('servedMSISDN', _CPDTSCERecord_servedMSISDN),
        ('chargingID', _CPDTSCERecord_chargingID),
        ('serviceContextID', _CPDTSCERecord_serviceContextID),
        ('nodeID', _CPDTSCERecord_nodeID),
        ('recordOpeningTime', _CPDTSCERecord_recordOpeningTime),
        ('duration', _CPDTSCERecord_duration),
        ('accessPointNameNI', _CPDTSCERecord_accessPointNameNI),
        ('sCEFID', _CPDTSCERecord_sCEFID),
        ('chargingCharacteristics', _CPDTSCERecord_chargingCharacteristics),
        ('chChSelectionMode', _CPDTSCERecord_chChSelectionMode),
        ('servingNodeIdentity', _CPDTSCERecord_servingNodeIdentity),
        ('servingPLMNRateControl', _CPDTSCERecord_servingPLMNRateControl),
        ('listOfNIDDsubmission', _CPDTSCERecord_listOfNIDDsubmission),
        ('causeForRecClosing', _CPDTSCERecord_causeForRecClosing),
        ('diagnostics', _CPDTSCERecord_diagnostics),
        ('localSequenceNumber', _CPDTSCERecord_localSequenceNumber),
        ('recordSequenceNumber', _CPDTSCERecord_recordSequenceNumber),
        ('recordExtensions', _CPDTSCERecord_recordExtensions),
        ('externalIdentifier', _CPDTSCERecord_externalIdentifier),
        ('aPNRateControl', _CPDTSCERecord_aPNRateControl),
        ('rATType', _CPDTSCERecord_rATType),
        ('servingNodePLMNIdentifier', _CPDTSCERecord_servingNodePLMNIdentifier),
        ('servedIMEI', _CPDTSCERecord_servedIMEI),
        ])
    CPDTSCERecord._ext = None
    
    #-----< CPDTSNNRecord >-----#
    CPDTSNNRecord = SET(name='CPDTSNNRecord', mode=MODE_TYPE)
    _CPDTSNNRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CPDTSNNRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSNNRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _CPDTSNNRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _CPDTSNNRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _CPDTSNNRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _CPDTSNNRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _CPDTSNNRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CPDTSNNRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CPDTSNNRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _CPDTSNNRecord_sCEFID = OCT_STR(name='sCEFID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSNNRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _CPDTSNNRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _CPDTSNNRecord_servingNodeIdentity = OCT_STR(name='servingNodeIdentity', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSNNRecord_servingPLMNRateControl = SEQ(name='servingPLMNRateControl', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _CPDTSNNRecord_listOfNIDDsubmission = SEQ_OF(name='listOfNIDDsubmission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPDTSNNRecord_listOfNIDDsubmission__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CPDTChargingDataTypes', 'NIDDsubmission')))
    _CPDTSNNRecord_listOfNIDDsubmission._cont = __CPDTSNNRecord_listOfNIDDsubmission__item_
    _CPDTSNNRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPCauseForRecClosing')))
    _CPDTSNNRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CPDTSNNRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CPDTSNNRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSNNRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CPDTSNNRecord_externalIdentifier = SET(name='externalIdentifier', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _CPDTSNNRecord_aPNRateControl = SEQ(name='aPNRateControl', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _CPDTSNNRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _CPDTSNNRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _CPDTSNNRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    CPDTSNNRecord._cont = ASN1Dict([
        ('recordType', _CPDTSNNRecord_recordType),
        ('retransmission', _CPDTSNNRecord_retransmission),
        ('servedIMSI', _CPDTSNNRecord_servedIMSI),
        ('servedMSISDN', _CPDTSNNRecord_servedMSISDN),
        ('chargingID', _CPDTSNNRecord_chargingID),
        ('serviceContextID', _CPDTSNNRecord_serviceContextID),
        ('nodeID', _CPDTSNNRecord_nodeID),
        ('recordOpeningTime', _CPDTSNNRecord_recordOpeningTime),
        ('duration', _CPDTSNNRecord_duration),
        ('accessPointNameNI', _CPDTSNNRecord_accessPointNameNI),
        ('sCEFID', _CPDTSNNRecord_sCEFID),
        ('chargingCharacteristics', _CPDTSNNRecord_chargingCharacteristics),
        ('chChSelectionMode', _CPDTSNNRecord_chChSelectionMode),
        ('servingNodeIdentity', _CPDTSNNRecord_servingNodeIdentity),
        ('servingPLMNRateControl', _CPDTSNNRecord_servingPLMNRateControl),
        ('listOfNIDDsubmission', _CPDTSNNRecord_listOfNIDDsubmission),
        ('causeForRecClosing', _CPDTSNNRecord_causeForRecClosing),
        ('diagnostics', _CPDTSNNRecord_diagnostics),
        ('localSequenceNumber', _CPDTSNNRecord_localSequenceNumber),
        ('recordSequenceNumber', _CPDTSNNRecord_recordSequenceNumber),
        ('recordExtensions', _CPDTSNNRecord_recordExtensions),
        ('externalIdentifier', _CPDTSNNRecord_externalIdentifier),
        ('aPNRateControl', _CPDTSNNRecord_aPNRateControl),
        ('rATType', _CPDTSNNRecord_rATType),
        ('servingNodePLMNIdentifier', _CPDTSNNRecord_servingNodePLMNIdentifier),
        ('servedIMEI', _CPDTSNNRecord_servedIMEI),
        ])
    CPDTSNNRecord._ext = None
    
    #-----< CPCauseForRecClosing >-----#
    CPCauseForRecClosing = INT(name='CPCauseForRecClosing', mode=MODE_TYPE)
    CPCauseForRecClosing._cont = ASN1Dict([('normalRelease', 0), ('abnormalRelease', 1), ('volumeLimit', 2), ('timeLimit', 3), ('maxNIDDsubmissions', 4), ('servingNodeChange', 5), ('pLMNChange', 6), ('servingPLMNRateControlChange', 7), ('aPNRateControlChange', 8), ('rATTypeChange', 9), ('managementIntervention', 10)])
    
    #-----< NIDDsubmission >-----#
    NIDDsubmission = SEQ(name='NIDDsubmission', mode=MODE_TYPE)
    _NIDDsubmission_submissionTimestamp = OCT_STR(name='submissionTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _NIDDsubmission_eventTimestamp = OCT_STR(name='eventTimestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _NIDDsubmission_dataVolumeGPRSUplink = INT(name='dataVolumeGPRSUplink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _NIDDsubmission_dataVolumeGPRSDownlink = INT(name='dataVolumeGPRSDownlink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _NIDDsubmission_submissionResultCode = INT(name='submissionResultCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'SubmissionResultCode')), opt=True)
    _NIDDsubmission_serviceChangeCondition = BIT_STR(name='serviceChangeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'ServiceChangeCondition')), opt=True)
    NIDDsubmission._cont = ASN1Dict([
        ('submissionTimestamp', _NIDDsubmission_submissionTimestamp),
        ('eventTimestamp', _NIDDsubmission_eventTimestamp),
        ('dataVolumeGPRSUplink', _NIDDsubmission_dataVolumeGPRSUplink),
        ('dataVolumeGPRSDownlink', _NIDDsubmission_dataVolumeGPRSDownlink),
        ('submissionResultCode', _NIDDsubmission_submissionResultCode),
        ('serviceChangeCondition', _NIDDsubmission_serviceChangeCondition),
        ])
    NIDDsubmission._ext = None
    
    #-----< ServiceChangeCondition >-----#
    ServiceChangeCondition = BIT_STR(name='ServiceChangeCondition', mode=MODE_TYPE)
    ServiceChangeCondition._cont = ASN1Dict([('nIDDsubmissionResponseReceipt', 0), ('nIDDsubmissionResponseSending', 1), ('nIDDdeliveryToUE', 2), ('nIDDdeliveryFromUEerror', 3), ('nIDDsubmissionTimeout', 4)])
    
    #-----< SubmissionResultCode >-----#
    SubmissionResultCode = INT(name='SubmissionResultCode', mode=MODE_TYPE)
    
    _all_ = [
        _CPDTRecord_cPDTSCERecord,
        _CPDTRecord_cPDTSNNRecord,
        CPDTRecord,
        _CPDTSCERecord_recordType,
        _CPDTSCERecord_retransmission,
        _CPDTSCERecord_servedIMSI,
        _CPDTSCERecord_servedMSISDN,
        _CPDTSCERecord_chargingID,
        _CPDTSCERecord_serviceContextID,
        _CPDTSCERecord_nodeID,
        _CPDTSCERecord_recordOpeningTime,
        _CPDTSCERecord_duration,
        _CPDTSCERecord_accessPointNameNI,
        _CPDTSCERecord_sCEFID,
        _CPDTSCERecord_chargingCharacteristics,
        _CPDTSCERecord_chChSelectionMode,
        _CPDTSCERecord_servingNodeIdentity,
        _CPDTSCERecord_servingPLMNRateControl,
        __CPDTSCERecord_listOfNIDDsubmission__item_,
        _CPDTSCERecord_listOfNIDDsubmission,
        _CPDTSCERecord_causeForRecClosing,
        _CPDTSCERecord_diagnostics,
        _CPDTSCERecord_localSequenceNumber,
        _CPDTSCERecord_recordSequenceNumber,
        _CPDTSCERecord_recordExtensions,
        _CPDTSCERecord_externalIdentifier,
        _CPDTSCERecord_aPNRateControl,
        _CPDTSCERecord_rATType,
        _CPDTSCERecord_servingNodePLMNIdentifier,
        _CPDTSCERecord_servedIMEI,
        CPDTSCERecord,
        _CPDTSNNRecord_recordType,
        _CPDTSNNRecord_retransmission,
        _CPDTSNNRecord_servedIMSI,
        _CPDTSNNRecord_servedMSISDN,
        _CPDTSNNRecord_chargingID,
        _CPDTSNNRecord_serviceContextID,
        _CPDTSNNRecord_nodeID,
        _CPDTSNNRecord_recordOpeningTime,
        _CPDTSNNRecord_duration,
        _CPDTSNNRecord_accessPointNameNI,
        _CPDTSNNRecord_sCEFID,
        _CPDTSNNRecord_chargingCharacteristics,
        _CPDTSNNRecord_chChSelectionMode,
        _CPDTSNNRecord_servingNodeIdentity,
        _CPDTSNNRecord_servingPLMNRateControl,
        __CPDTSNNRecord_listOfNIDDsubmission__item_,
        _CPDTSNNRecord_listOfNIDDsubmission,
        _CPDTSNNRecord_causeForRecClosing,
        _CPDTSNNRecord_diagnostics,
        _CPDTSNNRecord_localSequenceNumber,
        _CPDTSNNRecord_recordSequenceNumber,
        _CPDTSNNRecord_recordExtensions,
        _CPDTSNNRecord_externalIdentifier,
        _CPDTSNNRecord_aPNRateControl,
        _CPDTSNNRecord_rATType,
        _CPDTSNNRecord_servingNodePLMNIdentifier,
        _CPDTSNNRecord_servedIMEI,
        CPDTSNNRecord,
        CPCauseForRecClosing,
        _NIDDsubmission_submissionTimestamp,
        _NIDDsubmission_eventTimestamp,
        _NIDDsubmission_dataVolumeGPRSUplink,
        _NIDDsubmission_dataVolumeGPRSDownlink,
        _NIDDsubmission_submissionResultCode,
        _NIDDsubmission_serviceChangeCondition,
        NIDDsubmission,
        ServiceChangeCondition,
        SubmissionResultCode,
    ]

class CS1_DataTypes:

    _name_  = 'CS1-DataTypes'
    _oid_   = []
    
    _obj_ = [
        'Duration',
        'Integer4',
        'Interval',
        'LegID',
        'LegType',
        'ServiceKey',
        'CallingPartysCategory',
        'HighLayerCompatibility',
        'highLayerCompatibilityLength',
        'RedirectionInformation',
        ]
    _type_ = [
        'Duration',
        'Integer4',
        'Interval',
        'LegID',
        'LegType',
        'ServiceKey',
        'CallingPartysCategory',
        'HighLayerCompatibility',
        'RedirectionInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        'highLayerCompatibilityLength',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Duration >-----#
    Duration = INT(name='Duration', mode=MODE_TYPE)
    Duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2, ub=86400)], ev=None, er=[])
    
    #-----< Integer4 >-----#
    Integer4 = INT(name='Integer4', mode=MODE_TYPE)
    Integer4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< Interval >-----#
    Interval = INT(name='Interval', mode=MODE_TYPE)
    Interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=60000)], ev=None, er=[])
    
    #-----< LegID >-----#
    LegID = CHOICE(name='LegID', mode=MODE_TYPE)
    _LegID_sendingSideID = OCT_STR(name='sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    _LegID_receivingSideID = OCT_STR(name='receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    LegID._cont = ASN1Dict([
        ('sendingSideID', _LegID_sendingSideID),
        ('receivingSideID', _LegID_receivingSideID),
        ])
    LegID._ext = None
    
    #-----< LegType >-----#
    LegType = OCT_STR(name='LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name='ServiceKey', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< CallingPartysCategory >-----#
    CallingPartysCategory = OCT_STR(name='CallingPartysCategory', mode=MODE_TYPE)
    CallingPartysCategory._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< HighLayerCompatibility >-----#
    HighLayerCompatibility = OCT_STR(name='HighLayerCompatibility', mode=MODE_TYPE)
    HighLayerCompatibility._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< highLayerCompatibilityLength >-----#
    highLayerCompatibilityLength = INT(name='highLayerCompatibilityLength', mode=MODE_VALUE)
    highLayerCompatibilityLength._val = 2
    
    #-----< RedirectionInformation >-----#
    RedirectionInformation = OCT_STR(name='RedirectionInformation', mode=MODE_TYPE)
    RedirectionInformation._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    _all_ = [
        Duration,
        Integer4,
        Interval,
        _LegID_sendingSideID,
        _LegID_receivingSideID,
        LegID,
        LegType,
        ServiceKey,
        CallingPartysCategory,
        HighLayerCompatibility,
        highLayerCompatibilityLength,
        RedirectionInformation,
    ]

class CS2_datatypes:

    _name_  = 'CS2-datatypes'
    _oid_   = []
    
    _obj_ = [
        'CriticalityType',
        'BothwayThroughConnectionInd',
        'MiscCallInfo',
        ]
    _type_ = [
        'CriticalityType',
        'BothwayThroughConnectionInd',
        'MiscCallInfo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CriticalityType >-----#
    CriticalityType = ENUM(name='CriticalityType', mode=MODE_TYPE)
    CriticalityType._cont = ASN1Dict([('ignore', 0), ('abort', 1)])
    CriticalityType._ext = None
    
    #-----< BothwayThroughConnectionInd >-----#
    BothwayThroughConnectionInd = ENUM(name='BothwayThroughConnectionInd', mode=MODE_TYPE)
    BothwayThroughConnectionInd._cont = ASN1Dict([('bothwayPathRequired', 0), ('bothwayPathNotRequired', 1)])
    BothwayThroughConnectionInd._ext = None
    
    #-----< MiscCallInfo >-----#
    MiscCallInfo = SEQ(name='MiscCallInfo', mode=MODE_TYPE)
    _MiscCallInfo_messageType = ENUM(name='messageType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MiscCallInfo_messageType._cont = ASN1Dict([('request', 0), ('notification', 1)])
    _MiscCallInfo_messageType._ext = None
    _MiscCallInfo_dpAssignment = ENUM(name='dpAssignment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MiscCallInfo_dpAssignment._cont = ASN1Dict([('individualLine', 0), ('groupBased', 1), ('officeBased', 2)])
    _MiscCallInfo_dpAssignment._ext = None
    MiscCallInfo._cont = ASN1Dict([
        ('messageType', _MiscCallInfo_messageType),
        ('dpAssignment', _MiscCallInfo_dpAssignment),
        ])
    MiscCallInfo._ext = None
    
    _all_ = [
        CriticalityType,
        BothwayThroughConnectionInd,
        _MiscCallInfo_messageType,
        _MiscCallInfo_dpAssignment,
        MiscCallInfo,
    ]

class CSChargingDataTypes:

    _name_  = 'CSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 1, 0, 1]
    
    _obj_ = [
        'CSRecord',
        'MOCallRecord',
        'MTCallRecord',
        'RoamingRecord',
        'TermCAMELRecord',
        'IncGatewayRecord',
        'OutGatewayRecord',
        'TransitCallRecord',
        'MOSMSRecord',
        'MTSMSRecord',
        'MOSMSIWRecord',
        'MTSMSGWRecord',
        'SSActionRecord',
        'HLRIntRecord',
        'LocUpdateHLRRecord',
        'LocUpdateVLRRecord',
        'CommonEquipRecord',
        'ObservedIMEITicket',
        'MTLCSRecord',
        'MOLCSRecord',
        'NILCSRecord',
        'MSCsRVCCRecord',
        'MTRFRecord',
        'ICSregisterRecord',
        'LocationRoutingNumber',
        'LocationRoutingNumberSourceIndicator',
        'LocationRoutingNumberQueryStatus',
        'JurisdictionInformationParameter',
        'JurisdictionInformationParameterSourceIndicator',
        'JurisdictionInformationParameterQueryStatus',
        'AdditionalChgInfo',
        'AiurRequested',
        'AOCParameters',
        'AOCParmChange',
        'BasicServices',
        'CallingPartyCategory',
        'CallType',
        'CallTypes',
        'CAMELDestinationNumber',
        'CAMELInformation',
        'CAMELInitCFIndicator',
        'CAMELModificationParameters',
        'CAMELSMSInformation',
        'Category',
        'ChangedParameters',
        'ChangeFlags',
        'ChangeOfClassmark',
        'ChangeOfRadioChannel',
        'ChangeOfService',
        'ChannelCoding',
        'Classmark',
        'ConnectedNumber',
        'DataVolume',
        'Day',
        'DayClass',
        'DayClasses',
        'DayDefinition',
        'DayDefinitions',
        'DateDefinition',
        'DateDefinitions',
        'DayOfTheWeek',
        'Destinations',
        'EmergencyCallIndEnable',
        'EmergencyCallIndication',
        'EParameter',
        'EquipmentId',
        'EquipmentType',
        'FileType',
        'Fnur',
        'ForwardToNumber',
        'FreeFormatData',
        'GenericNumber',
        'GenericNumbers',
        'Gsm-SCFAddress',
        'GuaranteedBitRate',
        'HLRIntResult',
        'HSCSDParmsChange',
        'IMEICheckEvent',
        'IMEIStatus',
        'IMSIorIMEI',
        'InitiatingParty',
        'LocationCellExtension',
        'LocationChange',
        'Location-info',
        'LocUpdResult',
        'MaximumBitRate',
        'Month',
        'MSPowerClasses',
        'NetworkCallReference',
        'NetworkSpecificCode',
        'NetworkSpecificServices',
        'NumOfHSCSDChanRequested',
        'NumOfHSCSDChanAllocated',
        'ObservedIMEITicketEnable',
        'OriginalCalledNumber',
        'OriginDestCombinations',
        'OriginDestCombination',
        'PartialRecordTimer',
        'PartialRecordType',
        'PartialRecordTypes',
        'RadioChannelsRequested',
        'RadioChanRequested',
        'RateIndication',
        'ReasonForServiceChange',
        'RecordClassDestination',
        'RecordClassDestinations',
        'RecordingMethod',
        'RedirectingNumber',
        'RFPowerCapability',
        'RoamingNumber',
        'RoutingNumber',
        'Service',
        'ServiceDistanceDependencies',
        'ServiceDistanceDependency',
        'SimpleIntegerName',
        'SimpleStringName',
        'SpeechVersionIdentifier',
        'SSActionResult',
        'SSActionType',
        'SSParameters',
        'SupplServices',
        'SuppServiceUsed',
        'SwitchoverTime',
        'TariffId',
        'TariffPeriod',
        'TariffPeriods',
        'TariffSystemStatus',
        'TrafficChannel',
        'TranslatedNumber',
        'TransparencyInd',
        'TrunkGroup',
        'TSChangeover',
        'TSCheckError',
        'TSCheckErrorId',
        'TSCheckResult',
        'TSCopyTariffSystem',
        'TSNextChange',
        'TypeOfSubscribers',
        'TypeOfTransaction',
        'Visited-Location-info',
        'VlrNo',
        ]
    _type_ = [
        'CSRecord',
        'MOCallRecord',
        'MTCallRecord',
        'RoamingRecord',
        'TermCAMELRecord',
        'IncGatewayRecord',
        'OutGatewayRecord',
        'TransitCallRecord',
        'MOSMSRecord',
        'MTSMSRecord',
        'MOSMSIWRecord',
        'MTSMSGWRecord',
        'SSActionRecord',
        'HLRIntRecord',
        'LocUpdateHLRRecord',
        'LocUpdateVLRRecord',
        'CommonEquipRecord',
        'ObservedIMEITicket',
        'MTLCSRecord',
        'MOLCSRecord',
        'NILCSRecord',
        'MSCsRVCCRecord',
        'MTRFRecord',
        'ICSregisterRecord',
        'LocationRoutingNumber',
        'LocationRoutingNumberSourceIndicator',
        'LocationRoutingNumberQueryStatus',
        'JurisdictionInformationParameter',
        'JurisdictionInformationParameterSourceIndicator',
        'JurisdictionInformationParameterQueryStatus',
        'AdditionalChgInfo',
        'AiurRequested',
        'AOCParameters',
        'AOCParmChange',
        'BasicServices',
        'CallingPartyCategory',
        'CallType',
        'CallTypes',
        'CAMELDestinationNumber',
        'CAMELInformation',
        'CAMELInitCFIndicator',
        'CAMELModificationParameters',
        'CAMELSMSInformation',
        'Category',
        'ChangedParameters',
        'ChangeFlags',
        'ChangeOfClassmark',
        'ChangeOfRadioChannel',
        'ChangeOfService',
        'ChannelCoding',
        'Classmark',
        'ConnectedNumber',
        'DataVolume',
        'Day',
        'DayClass',
        'DayClasses',
        'DayDefinition',
        'DayDefinitions',
        'DateDefinition',
        'DateDefinitions',
        'DayOfTheWeek',
        'Destinations',
        'EmergencyCallIndEnable',
        'EmergencyCallIndication',
        'EParameter',
        'EquipmentId',
        'EquipmentType',
        'FileType',
        'Fnur',
        'ForwardToNumber',
        'FreeFormatData',
        'GenericNumber',
        'GenericNumbers',
        'Gsm-SCFAddress',
        'GuaranteedBitRate',
        'HLRIntResult',
        'HSCSDParmsChange',
        'IMEICheckEvent',
        'IMEIStatus',
        'IMSIorIMEI',
        'InitiatingParty',
        'LocationCellExtension',
        'LocationChange',
        'Location-info',
        'LocUpdResult',
        'MaximumBitRate',
        'Month',
        'MSPowerClasses',
        'NetworkCallReference',
        'NetworkSpecificCode',
        'NetworkSpecificServices',
        'NumOfHSCSDChanRequested',
        'NumOfHSCSDChanAllocated',
        'ObservedIMEITicketEnable',
        'OriginalCalledNumber',
        'OriginDestCombinations',
        'OriginDestCombination',
        'PartialRecordTimer',
        'PartialRecordType',
        'PartialRecordTypes',
        'RadioChannelsRequested',
        'RadioChanRequested',
        'RateIndication',
        'ReasonForServiceChange',
        'RecordClassDestination',
        'RecordClassDestinations',
        'RecordingMethod',
        'RedirectingNumber',
        'RFPowerCapability',
        'RoamingNumber',
        'RoutingNumber',
        'Service',
        'ServiceDistanceDependencies',
        'ServiceDistanceDependency',
        'SimpleIntegerName',
        'SimpleStringName',
        'SpeechVersionIdentifier',
        'SSActionResult',
        'SSActionType',
        'SSParameters',
        'SupplServices',
        'SuppServiceUsed',
        'SwitchoverTime',
        'TariffId',
        'TariffPeriod',
        'TariffPeriods',
        'TariffSystemStatus',
        'TrafficChannel',
        'TranslatedNumber',
        'TransparencyInd',
        'TrunkGroup',
        'TSChangeover',
        'TSCheckError',
        'TSCheckErrorId',
        'TSCheckResult',
        'TSCopyTariffSystem',
        'TSNextChange',
        'TypeOfSubscribers',
        'TypeOfTransaction',
        'Visited-Location-info',
        'VlrNo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CSRecord >-----#
    CSRecord = CHOICE(name='CSRecord', mode=MODE_TYPE)
    _CSRecord_moCallRecord = SET(name='moCallRecord', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOCallRecord')))
    _CSRecord_mtCallRecord = SET(name='mtCallRecord', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTCallRecord')))
    _CSRecord_roamingRecord = SET(name='roamingRecord', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingRecord')))
    _CSRecord_incGatewayRecord = SET(name='incGatewayRecord', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IncGatewayRecord')))
    _CSRecord_outGatewayRecord = SET(name='outGatewayRecord', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'OutGatewayRecord')))
    _CSRecord_transitRecord = SET(name='transitRecord', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransitCallRecord')))
    _CSRecord_moSMSRecord = SET(name='moSMSRecord', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOSMSRecord')))
    _CSRecord_mtSMSRecord = SET(name='mtSMSRecord', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTSMSRecord')))
    _CSRecord_moSMSIWRecord = SET(name='moSMSIWRecord', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOSMSIWRecord')))
    _CSRecord_mtSMSGWRecord = SET(name='mtSMSGWRecord', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTSMSGWRecord')))
    _CSRecord_ssActionRecord = SET(name='ssActionRecord', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSActionRecord')))
    _CSRecord_hlrIntRecord = SET(name='hlrIntRecord', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'HLRIntRecord')))
    _CSRecord_locUpdateHLRRecord = SET(name='locUpdateHLRRecord', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdateHLRRecord')))
    _CSRecord_locUpdateVLRRecord = SET(name='locUpdateVLRRecord', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdateVLRRecord')))
    _CSRecord_commonEquipRecord = SET(name='commonEquipRecord', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CommonEquipRecord')))
    _CSRecord_recTypeExtensions = SET_OF(name='recTypeExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')))
    _CSRecord_termCAMELRecord = SET(name='termCAMELRecord', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TermCAMELRecord')))
    _CSRecord_mtLCSRecord = SET(name='mtLCSRecord', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTLCSRecord')))
    _CSRecord_moLCSRecord = SET(name='moLCSRecord', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOLCSRecord')))
    _CSRecord_niLCSRecord = SET(name='niLCSRecord', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NILCSRecord')))
    _CSRecord_mSCsRVCCRecord = SET(name='mSCsRVCCRecord', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MSCsRVCCRecord')))
    _CSRecord_mMTRFRecord = SET(name='mMTRFRecord', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTRFRecord')))
    _CSRecord_iCSRegisterRecord = SET(name='iCSRegisterRecord', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ICSregisterRecord')))
    CSRecord._cont = ASN1Dict([
        ('moCallRecord', _CSRecord_moCallRecord),
        ('mtCallRecord', _CSRecord_mtCallRecord),
        ('roamingRecord', _CSRecord_roamingRecord),
        ('incGatewayRecord', _CSRecord_incGatewayRecord),
        ('outGatewayRecord', _CSRecord_outGatewayRecord),
        ('transitRecord', _CSRecord_transitRecord),
        ('moSMSRecord', _CSRecord_moSMSRecord),
        ('mtSMSRecord', _CSRecord_mtSMSRecord),
        ('moSMSIWRecord', _CSRecord_moSMSIWRecord),
        ('mtSMSGWRecord', _CSRecord_mtSMSGWRecord),
        ('ssActionRecord', _CSRecord_ssActionRecord),
        ('hlrIntRecord', _CSRecord_hlrIntRecord),
        ('locUpdateHLRRecord', _CSRecord_locUpdateHLRRecord),
        ('locUpdateVLRRecord', _CSRecord_locUpdateVLRRecord),
        ('commonEquipRecord', _CSRecord_commonEquipRecord),
        ('recTypeExtensions', _CSRecord_recTypeExtensions),
        ('termCAMELRecord', _CSRecord_termCAMELRecord),
        ('mtLCSRecord', _CSRecord_mtLCSRecord),
        ('moLCSRecord', _CSRecord_moLCSRecord),
        ('niLCSRecord', _CSRecord_niLCSRecord),
        ('mSCsRVCCRecord', _CSRecord_mSCsRVCCRecord),
        ('mMTRFRecord', _CSRecord_mMTRFRecord),
        ('iCSRegisterRecord', _CSRecord_iCSRegisterRecord),
        ])
    CSRecord._ext = None
    
    #-----< MOCallRecord >-----#
    MOCallRecord = SET(name='MOCallRecord', mode=MODE_TYPE)
    _MOCallRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOCallRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MOCallRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MOCallRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MOCallRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _MOCallRecord_calledNumber = OCT_STR(name='calledNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')), opt=True)
    _MOCallRecord_translatedNumber = OCT_STR(name='translatedNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TranslatedNumber')), opt=True)
    _MOCallRecord_connectedNumber = OCT_STR(name='connectedNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ConnectedNumber')), opt=True)
    _MOCallRecord_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _MOCallRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOCallRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MOCallRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MOCallRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MOCallRecord_changeOfLocation = SEQ_OF(name='changeOfLocation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'LocationChange')))
    _MOCallRecord_changeOfLocation._cont = __MOCallRecord_changeOfLocation__item_
    _MOCallRecord_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _MOCallRecord_transparencyIndicator = ENUM(name='transparencyIndicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _MOCallRecord_changeOfService = SEQ_OF(name='changeOfService', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _MOCallRecord_changeOfService._cont = __MOCallRecord_changeOfService__item_
    _MOCallRecord_supplServicesUsed = SEQ_OF(name='supplServicesUsed', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _MOCallRecord_supplServicesUsed._cont = __MOCallRecord_supplServicesUsed__item_
    _MOCallRecord_aocParameters = SEQ(name='aocParameters', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParameters')), opt=True)
    _MOCallRecord_changeOfAOCParms = SEQ_OF(name='changeOfAOCParms', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfAOCParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParmChange')))
    _MOCallRecord_changeOfAOCParms._cont = __MOCallRecord_changeOfAOCParms__item_
    _MOCallRecord_msClassmark = OCT_STR(name='msClassmark', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')), opt=True)
    _MOCallRecord_changeOfClassmark = SEQ(name='changeOfClassmark', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfClassmark')), opt=True)
    _MOCallRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MOCallRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MOCallRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MOCallRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MOCallRecord_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _MOCallRecord_radioChanRequested = ENUM(name='radioChanRequested', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RadioChanRequested')), opt=True)
    _MOCallRecord_radioChanUsed = ENUM(name='radioChanUsed', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrafficChannel')), opt=True)
    _MOCallRecord_changeOfRadioChan = SEQ(name='changeOfRadioChan', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfRadioChannel')), opt=True)
    _MOCallRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MOCallRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MOCallRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MOCallRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_additionalChgInfo = SEQ(name='additionalChgInfo', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AdditionalChgInfo')), opt=True)
    _MOCallRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MOCallRecord_gsm_SCFAddress = OCT_STR(name='gsm-SCFAddress', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _MOCallRecord_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _MOCallRecord_networkCallReference = OCT_STR(name='networkCallReference', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _MOCallRecord_mSCAddress = OCT_STR(name='mSCAddress', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _MOCallRecord_cAMELInitCFIndicator = ENUM(name='cAMELInitCFIndicator', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInitCFIndicator')), opt=True)
    _MOCallRecord_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _MOCallRecord_hSCSDChanRequested = INT(name='hSCSDChanRequested', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanRequested')), opt=True)
    _MOCallRecord_hSCSDChanAllocated = INT(name='hSCSDChanAllocated', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanAllocated')), opt=True)
    _MOCallRecord_changeOfHSCSDParms = SEQ_OF(name='changeOfHSCSDParms', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfHSCSDParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'HSCSDParmsChange')))
    _MOCallRecord_changeOfHSCSDParms._cont = __MOCallRecord_changeOfHSCSDParms__item_
    _MOCallRecord_fnur = ENUM(name='fnur', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    _MOCallRecord_aiurRequested = ENUM(name='aiurRequested', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AiurRequested')), opt=True)
    _MOCallRecord_chanCodingsAcceptable = SEQ_OF(name='chanCodingsAcceptable', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_chanCodingsAcceptable__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')))
    _MOCallRecord_chanCodingsAcceptable._cont = __MOCallRecord_chanCodingsAcceptable__item_
    _MOCallRecord_chanCodingUsed = ENUM(name='chanCodingUsed', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')), opt=True)
    _MOCallRecord_speechVersionSupported = OCT_STR(name='speechVersionSupported', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MOCallRecord_speechVersionUsed = OCT_STR(name='speechVersionUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MOCallRecord_numberOfDPEncountered = INT(name='numberOfDPEncountered', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_levelOfCAMELService = BIT_STR(name='levelOfCAMELService', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _MOCallRecord_freeFormatData = OCT_STR(name='freeFormatData', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _MOCallRecord_cAMELCallLegInformation = SEQ_OF(name='cAMELCallLegInformation', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_cAMELCallLegInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInformation')))
    _MOCallRecord_cAMELCallLegInformation._cont = __MOCallRecord_cAMELCallLegInformation__item_
    _MOCallRecord_freeFormatDataAppend = BOOL(name='freeFormatDataAppend', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_defaultCallHandling_2 = ENUM(name='defaultCallHandling-2', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _MOCallRecord_gsm_SCFAddress_2 = OCT_STR(name='gsm-SCFAddress-2', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _MOCallRecord_serviceKey_2 = INT(name='serviceKey-2', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _MOCallRecord_freeFormatData_2 = OCT_STR(name='freeFormatData-2', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _MOCallRecord_freeFormatDataAppend_2 = BOOL(name='freeFormatDataAppend-2', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MOCallRecord_rateIndication = OCT_STR(name='rateIndication', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _MOCallRecord_locationRoutNum = OCT_STR(name='locationRoutNum', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _MOCallRecord_lrnSoInd = INT(name='lrnSoInd', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _MOCallRecord_lrnQuryStatus = INT(name='lrnQuryStatus', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _MOCallRecord_jIPPara = OCT_STR(name='jIPPara', mode=MODE_TYPE, tag=(66, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _MOCallRecord_jIPSoInd = INT(name='jIPSoInd', mode=MODE_TYPE, tag=(67, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _MOCallRecord_jIPQuryStatus = INT(name='jIPQuryStatus', mode=MODE_TYPE, tag=(68, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _MOCallRecord_partialRecordType = ENUM(name='partialRecordType', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    _MOCallRecord_guaranteedBitRate = ENUM(name='guaranteedBitRate', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'GuaranteedBitRate')), opt=True)
    _MOCallRecord_maximumBitRate = ENUM(name='maximumBitRate', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MaximumBitRate')), opt=True)
    _MOCallRecord_redial = BOOL(name='redial', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_reasonForServiceChange = ENUM(name='reasonForServiceChange', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _MOCallRecord_serviceChangeInitiator = BOOL(name='serviceChangeInitiator', mode=MODE_TYPE, tag=(74, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_iCSI2ActiveFlag = NULL(name='iCSI2ActiveFlag', mode=MODE_TYPE, tag=(75, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(76, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MOCallRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(77, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MOCallRecord._cont = ASN1Dict([
        ('recordType', _MOCallRecord_recordType),
        ('servedIMSI', _MOCallRecord_servedIMSI),
        ('servedIMEI', _MOCallRecord_servedIMEI),
        ('servedMSISDN', _MOCallRecord_servedMSISDN),
        ('callingNumber', _MOCallRecord_callingNumber),
        ('calledNumber', _MOCallRecord_calledNumber),
        ('translatedNumber', _MOCallRecord_translatedNumber),
        ('connectedNumber', _MOCallRecord_connectedNumber),
        ('roamingNumber', _MOCallRecord_roamingNumber),
        ('recordingEntity', _MOCallRecord_recordingEntity),
        ('mscIncomingTKGP', _MOCallRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _MOCallRecord_mscOutgoingTKGP),
        ('location', _MOCallRecord_location),
        ('changeOfLocation', _MOCallRecord_changeOfLocation),
        ('basicService', _MOCallRecord_basicService),
        ('transparencyIndicator', _MOCallRecord_transparencyIndicator),
        ('changeOfService', _MOCallRecord_changeOfService),
        ('supplServicesUsed', _MOCallRecord_supplServicesUsed),
        ('aocParameters', _MOCallRecord_aocParameters),
        ('changeOfAOCParms', _MOCallRecord_changeOfAOCParms),
        ('msClassmark', _MOCallRecord_msClassmark),
        ('changeOfClassmark', _MOCallRecord_changeOfClassmark),
        ('seizureTime', _MOCallRecord_seizureTime),
        ('answerTime', _MOCallRecord_answerTime),
        ('releaseTime', _MOCallRecord_releaseTime),
        ('callDuration', _MOCallRecord_callDuration),
        ('dataVolume', _MOCallRecord_dataVolume),
        ('radioChanRequested', _MOCallRecord_radioChanRequested),
        ('radioChanUsed', _MOCallRecord_radioChanUsed),
        ('changeOfRadioChan', _MOCallRecord_changeOfRadioChan),
        ('causeForTerm', _MOCallRecord_causeForTerm),
        ('diagnostics', _MOCallRecord_diagnostics),
        ('callReference', _MOCallRecord_callReference),
        ('sequenceNumber', _MOCallRecord_sequenceNumber),
        ('additionalChgInfo', _MOCallRecord_additionalChgInfo),
        ('recordExtensions', _MOCallRecord_recordExtensions),
        ('gsm-SCFAddress', _MOCallRecord_gsm_SCFAddress),
        ('serviceKey', _MOCallRecord_serviceKey),
        ('networkCallReference', _MOCallRecord_networkCallReference),
        ('mSCAddress', _MOCallRecord_mSCAddress),
        ('cAMELInitCFIndicator', _MOCallRecord_cAMELInitCFIndicator),
        ('defaultCallHandling', _MOCallRecord_defaultCallHandling),
        ('hSCSDChanRequested', _MOCallRecord_hSCSDChanRequested),
        ('hSCSDChanAllocated', _MOCallRecord_hSCSDChanAllocated),
        ('changeOfHSCSDParms', _MOCallRecord_changeOfHSCSDParms),
        ('fnur', _MOCallRecord_fnur),
        ('aiurRequested', _MOCallRecord_aiurRequested),
        ('chanCodingsAcceptable', _MOCallRecord_chanCodingsAcceptable),
        ('chanCodingUsed', _MOCallRecord_chanCodingUsed),
        ('speechVersionSupported', _MOCallRecord_speechVersionSupported),
        ('speechVersionUsed', _MOCallRecord_speechVersionUsed),
        ('numberOfDPEncountered', _MOCallRecord_numberOfDPEncountered),
        ('levelOfCAMELService', _MOCallRecord_levelOfCAMELService),
        ('freeFormatData', _MOCallRecord_freeFormatData),
        ('cAMELCallLegInformation', _MOCallRecord_cAMELCallLegInformation),
        ('freeFormatDataAppend', _MOCallRecord_freeFormatDataAppend),
        ('defaultCallHandling-2', _MOCallRecord_defaultCallHandling_2),
        ('gsm-SCFAddress-2', _MOCallRecord_gsm_SCFAddress_2),
        ('serviceKey-2', _MOCallRecord_serviceKey_2),
        ('freeFormatData-2', _MOCallRecord_freeFormatData_2),
        ('freeFormatDataAppend-2', _MOCallRecord_freeFormatDataAppend_2),
        ('systemType', _MOCallRecord_systemType),
        ('rateIndication', _MOCallRecord_rateIndication),
        ('locationRoutNum', _MOCallRecord_locationRoutNum),
        ('lrnSoInd', _MOCallRecord_lrnSoInd),
        ('lrnQuryStatus', _MOCallRecord_lrnQuryStatus),
        ('jIPPara', _MOCallRecord_jIPPara),
        ('jIPSoInd', _MOCallRecord_jIPSoInd),
        ('jIPQuryStatus', _MOCallRecord_jIPQuryStatus),
        ('partialRecordType', _MOCallRecord_partialRecordType),
        ('guaranteedBitRate', _MOCallRecord_guaranteedBitRate),
        ('maximumBitRate', _MOCallRecord_maximumBitRate),
        ('redial', _MOCallRecord_redial),
        ('reasonForServiceChange', _MOCallRecord_reasonForServiceChange),
        ('serviceChangeInitiator', _MOCallRecord_serviceChangeInitiator),
        ('iCSI2ActiveFlag', _MOCallRecord_iCSI2ActiveFlag),
        ('iMS-Charging-Identifier', _MOCallRecord_iMS_Charging_Identifier),
        ('privateUserID', _MOCallRecord_privateUserID),
        ])
    MOCallRecord._ext = None
    
    #-----< MTCallRecord >-----#
    MTCallRecord = SET(name='MTCallRecord', mode=MODE_TYPE)
    _MTCallRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTCallRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTCallRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MTCallRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')), opt=True)
    _MTCallRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _MTCallRecord_connectedNumber = OCT_STR(name='connectedNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ConnectedNumber')), opt=True)
    _MTCallRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTCallRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTCallRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTCallRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MTCallRecord_changeOfLocation = SEQ_OF(name='changeOfLocation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'LocationChange')))
    _MTCallRecord_changeOfLocation._cont = __MTCallRecord_changeOfLocation__item_
    _MTCallRecord_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _MTCallRecord_transparencyIndicator = ENUM(name='transparencyIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _MTCallRecord_changeOfService = SEQ_OF(name='changeOfService', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _MTCallRecord_changeOfService._cont = __MTCallRecord_changeOfService__item_
    _MTCallRecord_supplServicesUsed = SEQ_OF(name='supplServicesUsed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _MTCallRecord_supplServicesUsed._cont = __MTCallRecord_supplServicesUsed__item_
    _MTCallRecord_aocParameters = SEQ(name='aocParameters', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParameters')), opt=True)
    _MTCallRecord_changeOfAOCParms = SEQ_OF(name='changeOfAOCParms', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfAOCParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParmChange')))
    _MTCallRecord_changeOfAOCParms._cont = __MTCallRecord_changeOfAOCParms__item_
    _MTCallRecord_msClassmark = OCT_STR(name='msClassmark', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')), opt=True)
    _MTCallRecord_changeOfClassmark = SEQ(name='changeOfClassmark', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfClassmark')), opt=True)
    _MTCallRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTCallRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTCallRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTCallRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MTCallRecord_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _MTCallRecord_radioChanRequested = ENUM(name='radioChanRequested', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RadioChanRequested')), opt=True)
    _MTCallRecord_radioChanUsed = ENUM(name='radioChanUsed', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrafficChannel')), opt=True)
    _MTCallRecord_changeOfRadioChan = SEQ(name='changeOfRadioChan', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfRadioChannel')), opt=True)
    _MTCallRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MTCallRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MTCallRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MTCallRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTCallRecord_additionalChgInfo = SEQ(name='additionalChgInfo', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AdditionalChgInfo')), opt=True)
    _MTCallRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTCallRecord_networkCallReference = OCT_STR(name='networkCallReference', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _MTCallRecord_mSCAddress = OCT_STR(name='mSCAddress', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _MTCallRecord_hSCSDChanRequested = INT(name='hSCSDChanRequested', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanRequested')), opt=True)
    _MTCallRecord_hSCSDChanAllocated = INT(name='hSCSDChanAllocated', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanAllocated')), opt=True)
    _MTCallRecord_changeOfHSCSDParms = SEQ_OF(name='changeOfHSCSDParms', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfHSCSDParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'HSCSDParmsChange')))
    _MTCallRecord_changeOfHSCSDParms._cont = __MTCallRecord_changeOfHSCSDParms__item_
    _MTCallRecord_fnur = ENUM(name='fnur', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    _MTCallRecord_aiurRequested = ENUM(name='aiurRequested', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AiurRequested')), opt=True)
    _MTCallRecord_chanCodingsAcceptable = SEQ_OF(name='chanCodingsAcceptable', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_chanCodingsAcceptable__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')))
    _MTCallRecord_chanCodingsAcceptable._cont = __MTCallRecord_chanCodingsAcceptable__item_
    _MTCallRecord_chanCodingUsed = ENUM(name='chanCodingUsed', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')), opt=True)
    _MTCallRecord_speechVersionSupported = OCT_STR(name='speechVersionSupported', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MTCallRecord_speechVersionUsed = OCT_STR(name='speechVersionUsed', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MTCallRecord_gsm_SCFAddress = OCT_STR(name='gsm-SCFAddress', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _MTCallRecord_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _MTCallRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MTCallRecord_rateIndication = OCT_STR(name='rateIndication', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _MTCallRecord_locationRoutNum = OCT_STR(name='locationRoutNum', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _MTCallRecord_lrnSoInd = INT(name='lrnSoInd', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _MTCallRecord_lrnQuryStatus = INT(name='lrnQuryStatus', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _MTCallRecord_jIPPara = OCT_STR(name='jIPPara', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _MTCallRecord_jIPSoInd = INT(name='jIPSoInd', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _MTCallRecord_jIPQuryStatus = INT(name='jIPQuryStatus', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _MTCallRecord_partialRecordType = ENUM(name='partialRecordType', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    _MTCallRecord_guaranteedBitRate = ENUM(name='guaranteedBitRate', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'GuaranteedBitRate')), opt=True)
    _MTCallRecord_maximumBitRate = ENUM(name='maximumBitRate', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MaximumBitRate')), opt=True)
    _MTCallRecord_reasonForServiceChange = ENUM(name='reasonForServiceChange', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _MTCallRecord_serviceChangeInitiator = BOOL(name='serviceChangeInitiator', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTCallRecord_iCSI2ActiveFlag = NULL(name='iCSI2ActiveFlag', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTCallRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MTCallRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MTCallRecord._cont = ASN1Dict([
        ('recordType', _MTCallRecord_recordType),
        ('servedIMSI', _MTCallRecord_servedIMSI),
        ('servedIMEI', _MTCallRecord_servedIMEI),
        ('servedMSISDN', _MTCallRecord_servedMSISDN),
        ('callingNumber', _MTCallRecord_callingNumber),
        ('connectedNumber', _MTCallRecord_connectedNumber),
        ('recordingEntity', _MTCallRecord_recordingEntity),
        ('mscIncomingTKGP', _MTCallRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _MTCallRecord_mscOutgoingTKGP),
        ('location', _MTCallRecord_location),
        ('changeOfLocation', _MTCallRecord_changeOfLocation),
        ('basicService', _MTCallRecord_basicService),
        ('transparencyIndicator', _MTCallRecord_transparencyIndicator),
        ('changeOfService', _MTCallRecord_changeOfService),
        ('supplServicesUsed', _MTCallRecord_supplServicesUsed),
        ('aocParameters', _MTCallRecord_aocParameters),
        ('changeOfAOCParms', _MTCallRecord_changeOfAOCParms),
        ('msClassmark', _MTCallRecord_msClassmark),
        ('changeOfClassmark', _MTCallRecord_changeOfClassmark),
        ('seizureTime', _MTCallRecord_seizureTime),
        ('answerTime', _MTCallRecord_answerTime),
        ('releaseTime', _MTCallRecord_releaseTime),
        ('callDuration', _MTCallRecord_callDuration),
        ('dataVolume', _MTCallRecord_dataVolume),
        ('radioChanRequested', _MTCallRecord_radioChanRequested),
        ('radioChanUsed', _MTCallRecord_radioChanUsed),
        ('changeOfRadioChan', _MTCallRecord_changeOfRadioChan),
        ('causeForTerm', _MTCallRecord_causeForTerm),
        ('diagnostics', _MTCallRecord_diagnostics),
        ('callReference', _MTCallRecord_callReference),
        ('sequenceNumber', _MTCallRecord_sequenceNumber),
        ('additionalChgInfo', _MTCallRecord_additionalChgInfo),
        ('recordExtensions', _MTCallRecord_recordExtensions),
        ('networkCallReference', _MTCallRecord_networkCallReference),
        ('mSCAddress', _MTCallRecord_mSCAddress),
        ('hSCSDChanRequested', _MTCallRecord_hSCSDChanRequested),
        ('hSCSDChanAllocated', _MTCallRecord_hSCSDChanAllocated),
        ('changeOfHSCSDParms', _MTCallRecord_changeOfHSCSDParms),
        ('fnur', _MTCallRecord_fnur),
        ('aiurRequested', _MTCallRecord_aiurRequested),
        ('chanCodingsAcceptable', _MTCallRecord_chanCodingsAcceptable),
        ('chanCodingUsed', _MTCallRecord_chanCodingUsed),
        ('speechVersionSupported', _MTCallRecord_speechVersionSupported),
        ('speechVersionUsed', _MTCallRecord_speechVersionUsed),
        ('gsm-SCFAddress', _MTCallRecord_gsm_SCFAddress),
        ('serviceKey', _MTCallRecord_serviceKey),
        ('systemType', _MTCallRecord_systemType),
        ('rateIndication', _MTCallRecord_rateIndication),
        ('locationRoutNum', _MTCallRecord_locationRoutNum),
        ('lrnSoInd', _MTCallRecord_lrnSoInd),
        ('lrnQuryStatus', _MTCallRecord_lrnQuryStatus),
        ('jIPPara', _MTCallRecord_jIPPara),
        ('jIPSoInd', _MTCallRecord_jIPSoInd),
        ('jIPQuryStatus', _MTCallRecord_jIPQuryStatus),
        ('partialRecordType', _MTCallRecord_partialRecordType),
        ('guaranteedBitRate', _MTCallRecord_guaranteedBitRate),
        ('maximumBitRate', _MTCallRecord_maximumBitRate),
        ('reasonForServiceChange', _MTCallRecord_reasonForServiceChange),
        ('serviceChangeInitiator', _MTCallRecord_serviceChangeInitiator),
        ('iCSI2ActiveFlag', _MTCallRecord_iCSI2ActiveFlag),
        ('iMS-Charging-Identifier', _MTCallRecord_iMS_Charging_Identifier),
        ('privateUserID', _MTCallRecord_privateUserID),
        ])
    MTCallRecord._ext = None
    
    #-----< RoamingRecord >-----#
    RoamingRecord = SET(name='RoamingRecord', mode=MODE_TYPE)
    _RoamingRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _RoamingRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RoamingRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _RoamingRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _RoamingRecord_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _RoamingRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _RoamingRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _RoamingRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _RoamingRecord_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _RoamingRecord_transparencyIndicator = ENUM(name='transparencyIndicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _RoamingRecord_changeOfService = SEQ_OF(name='changeOfService', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RoamingRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _RoamingRecord_changeOfService._cont = __RoamingRecord_changeOfService__item_
    _RoamingRecord_supplServicesUsed = SEQ_OF(name='supplServicesUsed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RoamingRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _RoamingRecord_supplServicesUsed._cont = __RoamingRecord_supplServicesUsed__item_
    _RoamingRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RoamingRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RoamingRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RoamingRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _RoamingRecord_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _RoamingRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _RoamingRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _RoamingRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _RoamingRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoamingRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _RoamingRecord_networkCallReference = OCT_STR(name='networkCallReference', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _RoamingRecord_mSCAddress = OCT_STR(name='mSCAddress', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _RoamingRecord_locationRoutNum = OCT_STR(name='locationRoutNum', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _RoamingRecord_lrnSoInd = INT(name='lrnSoInd', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _RoamingRecord_lrnQuryStatus = INT(name='lrnQuryStatus', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _RoamingRecord_jIPPara = OCT_STR(name='jIPPara', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _RoamingRecord_jIPSoInd = INT(name='jIPSoInd', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _RoamingRecord_jIPQuryStatus = INT(name='jIPQuryStatus', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _RoamingRecord_partialRecordType = ENUM(name='partialRecordType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    RoamingRecord._cont = ASN1Dict([
        ('recordType', _RoamingRecord_recordType),
        ('servedIMSI', _RoamingRecord_servedIMSI),
        ('servedMSISDN', _RoamingRecord_servedMSISDN),
        ('callingNumber', _RoamingRecord_callingNumber),
        ('roamingNumber', _RoamingRecord_roamingNumber),
        ('recordingEntity', _RoamingRecord_recordingEntity),
        ('mscIncomingTKGP', _RoamingRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _RoamingRecord_mscOutgoingTKGP),
        ('basicService', _RoamingRecord_basicService),
        ('transparencyIndicator', _RoamingRecord_transparencyIndicator),
        ('changeOfService', _RoamingRecord_changeOfService),
        ('supplServicesUsed', _RoamingRecord_supplServicesUsed),
        ('seizureTime', _RoamingRecord_seizureTime),
        ('answerTime', _RoamingRecord_answerTime),
        ('releaseTime', _RoamingRecord_releaseTime),
        ('callDuration', _RoamingRecord_callDuration),
        ('dataVolume', _RoamingRecord_dataVolume),
        ('causeForTerm', _RoamingRecord_causeForTerm),
        ('diagnostics', _RoamingRecord_diagnostics),
        ('callReference', _RoamingRecord_callReference),
        ('sequenceNumber', _RoamingRecord_sequenceNumber),
        ('recordExtensions', _RoamingRecord_recordExtensions),
        ('networkCallReference', _RoamingRecord_networkCallReference),
        ('mSCAddress', _RoamingRecord_mSCAddress),
        ('locationRoutNum', _RoamingRecord_locationRoutNum),
        ('lrnSoInd', _RoamingRecord_lrnSoInd),
        ('lrnQuryStatus', _RoamingRecord_lrnQuryStatus),
        ('jIPPara', _RoamingRecord_jIPPara),
        ('jIPSoInd', _RoamingRecord_jIPSoInd),
        ('jIPQuryStatus', _RoamingRecord_jIPQuryStatus),
        ('partialRecordType', _RoamingRecord_partialRecordType),
        ])
    RoamingRecord._ext = None
    
    #-----< TermCAMELRecord >-----#
    TermCAMELRecord = SET(name='TermCAMELRecord', mode=MODE_TYPE)
    _TermCAMELRecord_recordtype = INT(name='recordtype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TermCAMELRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _TermCAMELRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _TermCAMELRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _TermCAMELRecord_interrogationTime = OCT_STR(name='interrogationTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _TermCAMELRecord_destinationRoutingAddress = SEQ_OF(name='destinationRoutingAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    _TermCAMELRecord_gsm_SCFAddress = OCT_STR(name='gsm-SCFAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')))
    _TermCAMELRecord_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _TermCAMELRecord_networkCallReference = OCT_STR(name='networkCallReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _TermCAMELRecord_mSCAddress = OCT_STR(name='mSCAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _TermCAMELRecord_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _TermCAMELRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TermCAMELRecord_calledNumber = OCT_STR(name='calledNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _TermCAMELRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _TermCAMELRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TermCAMELRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TermCAMELRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TermCAMELRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TermCAMELRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TermCAMELRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TermCAMELRecord_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _TermCAMELRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _TermCAMELRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TermCAMELRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _TermCAMELRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_numberOfDPEncountered = INT(name='numberOfDPEncountered', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_levelOfCAMELService = BIT_STR(name='levelOfCAMELService', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _TermCAMELRecord_freeFormatData = OCT_STR(name='freeFormatData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _TermCAMELRecord_cAMELCallLegInformation = SEQ_OF(name='cAMELCallLegInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TermCAMELRecord_cAMELCallLegInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInformation')))
    _TermCAMELRecord_cAMELCallLegInformation._cont = __TermCAMELRecord_cAMELCallLegInformation__item_
    _TermCAMELRecord_freeFormatDataAppend = BOOL(name='freeFormatDataAppend', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_defaultCallHandling_2 = ENUM(name='defaultCallHandling-2', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _TermCAMELRecord_gsm_SCFAddress_2 = OCT_STR(name='gsm-SCFAddress-2', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _TermCAMELRecord_serviceKey_2 = INT(name='serviceKey-2', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _TermCAMELRecord_freeFormatData_2 = OCT_STR(name='freeFormatData-2', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _TermCAMELRecord_freeFormatDataAppend_2 = BOOL(name='freeFormatDataAppend-2', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_mscServerIndication = BOOL(name='mscServerIndication', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_locationRoutNum = OCT_STR(name='locationRoutNum', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _TermCAMELRecord_lrnSoInd = INT(name='lrnSoInd', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _TermCAMELRecord_lrnQuryStatus = INT(name='lrnQuryStatus', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _TermCAMELRecord_jIPPara = OCT_STR(name='jIPPara', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _TermCAMELRecord_jIPSoInd = INT(name='jIPSoInd', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _TermCAMELRecord_jIPQuryStatus = INT(name='jIPQuryStatus', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _TermCAMELRecord_partialRecordType = ENUM(name='partialRecordType', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    TermCAMELRecord._cont = ASN1Dict([
        ('recordtype', _TermCAMELRecord_recordtype),
        ('servedIMSI', _TermCAMELRecord_servedIMSI),
        ('servedMSISDN', _TermCAMELRecord_servedMSISDN),
        ('recordingEntity', _TermCAMELRecord_recordingEntity),
        ('interrogationTime', _TermCAMELRecord_interrogationTime),
        ('destinationRoutingAddress', _TermCAMELRecord_destinationRoutingAddress),
        ('gsm-SCFAddress', _TermCAMELRecord_gsm_SCFAddress),
        ('serviceKey', _TermCAMELRecord_serviceKey),
        ('networkCallReference', _TermCAMELRecord_networkCallReference),
        ('mSCAddress', _TermCAMELRecord_mSCAddress),
        ('defaultCallHandling', _TermCAMELRecord_defaultCallHandling),
        ('recordExtensions', _TermCAMELRecord_recordExtensions),
        ('calledNumber', _TermCAMELRecord_calledNumber),
        ('callingNumber', _TermCAMELRecord_callingNumber),
        ('mscIncomingTKGP', _TermCAMELRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _TermCAMELRecord_mscOutgoingTKGP),
        ('seizureTime', _TermCAMELRecord_seizureTime),
        ('answerTime', _TermCAMELRecord_answerTime),
        ('releaseTime', _TermCAMELRecord_releaseTime),
        ('callDuration', _TermCAMELRecord_callDuration),
        ('dataVolume', _TermCAMELRecord_dataVolume),
        ('causeForTerm', _TermCAMELRecord_causeForTerm),
        ('diagnostics', _TermCAMELRecord_diagnostics),
        ('callReference', _TermCAMELRecord_callReference),
        ('sequenceNumber', _TermCAMELRecord_sequenceNumber),
        ('numberOfDPEncountered', _TermCAMELRecord_numberOfDPEncountered),
        ('levelOfCAMELService', _TermCAMELRecord_levelOfCAMELService),
        ('freeFormatData', _TermCAMELRecord_freeFormatData),
        ('cAMELCallLegInformation', _TermCAMELRecord_cAMELCallLegInformation),
        ('freeFormatDataAppend', _TermCAMELRecord_freeFormatDataAppend),
        ('defaultCallHandling-2', _TermCAMELRecord_defaultCallHandling_2),
        ('gsm-SCFAddress-2', _TermCAMELRecord_gsm_SCFAddress_2),
        ('serviceKey-2', _TermCAMELRecord_serviceKey_2),
        ('freeFormatData-2', _TermCAMELRecord_freeFormatData_2),
        ('freeFormatDataAppend-2', _TermCAMELRecord_freeFormatDataAppend_2),
        ('mscServerIndication', _TermCAMELRecord_mscServerIndication),
        ('locationRoutNum', _TermCAMELRecord_locationRoutNum),
        ('lrnSoInd', _TermCAMELRecord_lrnSoInd),
        ('lrnQuryStatus', _TermCAMELRecord_lrnQuryStatus),
        ('jIPPara', _TermCAMELRecord_jIPPara),
        ('jIPSoInd', _TermCAMELRecord_jIPSoInd),
        ('jIPQuryStatus', _TermCAMELRecord_jIPQuryStatus),
        ('partialRecordType', _TermCAMELRecord_partialRecordType),
        ])
    TermCAMELRecord._ext = None
    
    #-----< IncGatewayRecord >-----#
    IncGatewayRecord = SET(name='IncGatewayRecord', mode=MODE_TYPE)
    _IncGatewayRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _IncGatewayRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _IncGatewayRecord_calledNumber = OCT_STR(name='calledNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _IncGatewayRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _IncGatewayRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _IncGatewayRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _IncGatewayRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IncGatewayRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IncGatewayRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IncGatewayRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _IncGatewayRecord_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _IncGatewayRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _IncGatewayRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _IncGatewayRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _IncGatewayRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IncGatewayRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _IncGatewayRecord_locationRoutNum = OCT_STR(name='locationRoutNum', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _IncGatewayRecord_lrnSoInd = INT(name='lrnSoInd', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _IncGatewayRecord_lrnQuryStatus = INT(name='lrnQuryStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _IncGatewayRecord_jIPPara = OCT_STR(name='jIPPara', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _IncGatewayRecord_jIPSoInd = INT(name='jIPSoInd', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _IncGatewayRecord_jIPQuryStatus = INT(name='jIPQuryStatus', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _IncGatewayRecord_reasonForServiceChange = ENUM(name='reasonForServiceChange', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _IncGatewayRecord_serviceChangeInitiator = BOOL(name='serviceChangeInitiator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IncGatewayRecord._cont = ASN1Dict([
        ('recordType', _IncGatewayRecord_recordType),
        ('callingNumber', _IncGatewayRecord_callingNumber),
        ('calledNumber', _IncGatewayRecord_calledNumber),
        ('recordingEntity', _IncGatewayRecord_recordingEntity),
        ('mscIncomingTKGP', _IncGatewayRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _IncGatewayRecord_mscOutgoingTKGP),
        ('seizureTime', _IncGatewayRecord_seizureTime),
        ('answerTime', _IncGatewayRecord_answerTime),
        ('releaseTime', _IncGatewayRecord_releaseTime),
        ('callDuration', _IncGatewayRecord_callDuration),
        ('dataVolume', _IncGatewayRecord_dataVolume),
        ('causeForTerm', _IncGatewayRecord_causeForTerm),
        ('diagnostics', _IncGatewayRecord_diagnostics),
        ('callReference', _IncGatewayRecord_callReference),
        ('sequenceNumber', _IncGatewayRecord_sequenceNumber),
        ('recordExtensions', _IncGatewayRecord_recordExtensions),
        ('locationRoutNum', _IncGatewayRecord_locationRoutNum),
        ('lrnSoInd', _IncGatewayRecord_lrnSoInd),
        ('lrnQuryStatus', _IncGatewayRecord_lrnQuryStatus),
        ('jIPPara', _IncGatewayRecord_jIPPara),
        ('jIPSoInd', _IncGatewayRecord_jIPSoInd),
        ('jIPQuryStatus', _IncGatewayRecord_jIPQuryStatus),
        ('reasonForServiceChange', _IncGatewayRecord_reasonForServiceChange),
        ('serviceChangeInitiator', _IncGatewayRecord_serviceChangeInitiator),
        ])
    IncGatewayRecord._ext = None
    
    #-----< OutGatewayRecord >-----#
    OutGatewayRecord = SET(name='OutGatewayRecord', mode=MODE_TYPE)
    _OutGatewayRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _OutGatewayRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _OutGatewayRecord_calledNumber = OCT_STR(name='calledNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _OutGatewayRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _OutGatewayRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _OutGatewayRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _OutGatewayRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _OutGatewayRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _OutGatewayRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _OutGatewayRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _OutGatewayRecord_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _OutGatewayRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _OutGatewayRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _OutGatewayRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _OutGatewayRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OutGatewayRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _OutGatewayRecord_locationRoutNum = OCT_STR(name='locationRoutNum', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _OutGatewayRecord_lrnSoInd = INT(name='lrnSoInd', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _OutGatewayRecord_lrnQuryStatus = INT(name='lrnQuryStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _OutGatewayRecord_jIPPara = OCT_STR(name='jIPPara', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _OutGatewayRecord_jIPSoInd = INT(name='jIPSoInd', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _OutGatewayRecord_jIPQuryStatus = INT(name='jIPQuryStatus', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _OutGatewayRecord_reasonForServiceChange = ENUM(name='reasonForServiceChange', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _OutGatewayRecord_serviceChangeInitiator = BOOL(name='serviceChangeInitiator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OutGatewayRecord._cont = ASN1Dict([
        ('recordType', _OutGatewayRecord_recordType),
        ('callingNumber', _OutGatewayRecord_callingNumber),
        ('calledNumber', _OutGatewayRecord_calledNumber),
        ('recordingEntity', _OutGatewayRecord_recordingEntity),
        ('mscIncomingTKGP', _OutGatewayRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _OutGatewayRecord_mscOutgoingTKGP),
        ('seizureTime', _OutGatewayRecord_seizureTime),
        ('answerTime', _OutGatewayRecord_answerTime),
        ('releaseTime', _OutGatewayRecord_releaseTime),
        ('callDuration', _OutGatewayRecord_callDuration),
        ('dataVolume', _OutGatewayRecord_dataVolume),
        ('causeForTerm', _OutGatewayRecord_causeForTerm),
        ('diagnostics', _OutGatewayRecord_diagnostics),
        ('callReference', _OutGatewayRecord_callReference),
        ('sequenceNumber', _OutGatewayRecord_sequenceNumber),
        ('recordExtensions', _OutGatewayRecord_recordExtensions),
        ('locationRoutNum', _OutGatewayRecord_locationRoutNum),
        ('lrnSoInd', _OutGatewayRecord_lrnSoInd),
        ('lrnQuryStatus', _OutGatewayRecord_lrnQuryStatus),
        ('jIPPara', _OutGatewayRecord_jIPPara),
        ('jIPSoInd', _OutGatewayRecord_jIPSoInd),
        ('jIPQuryStatus', _OutGatewayRecord_jIPQuryStatus),
        ('reasonForServiceChange', _OutGatewayRecord_reasonForServiceChange),
        ('serviceChangeInitiator', _OutGatewayRecord_serviceChangeInitiator),
        ])
    OutGatewayRecord._ext = None
    
    #-----< TransitCallRecord >-----#
    TransitCallRecord = SET(name='TransitCallRecord', mode=MODE_TYPE)
    _TransitCallRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TransitCallRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _TransitCallRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TransitCallRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TransitCallRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _TransitCallRecord_calledNumber = OCT_STR(name='calledNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _TransitCallRecord_isdnBasicService = ENUM(name='isdnBasicService', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Basic-Service-Elements', 'BasicService')), opt=True)
    _TransitCallRecord_seizureTimestamp = OCT_STR(name='seizureTimestamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TransitCallRecord_answerTimestamp = OCT_STR(name='answerTimestamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TransitCallRecord_releaseTimestamp = OCT_STR(name='releaseTimestamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TransitCallRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TransitCallRecord_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _TransitCallRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _TransitCallRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TransitCallRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _TransitCallRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TransitCallRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TransitCallRecord_locationRoutNum = OCT_STR(name='locationRoutNum', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _TransitCallRecord_lrnSoInd = INT(name='lrnSoInd', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _TransitCallRecord_lrnQuryStatus = INT(name='lrnQuryStatus', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _TransitCallRecord_jIPPara = OCT_STR(name='jIPPara', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _TransitCallRecord_jIPSoInd = INT(name='jIPSoInd', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _TransitCallRecord_jIPQuryStatus = INT(name='jIPQuryStatus', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    TransitCallRecord._cont = ASN1Dict([
        ('recordType', _TransitCallRecord_recordType),
        ('recordingEntity', _TransitCallRecord_recordingEntity),
        ('mscIncomingTKGP', _TransitCallRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _TransitCallRecord_mscOutgoingTKGP),
        ('callingNumber', _TransitCallRecord_callingNumber),
        ('calledNumber', _TransitCallRecord_calledNumber),
        ('isdnBasicService', _TransitCallRecord_isdnBasicService),
        ('seizureTimestamp', _TransitCallRecord_seizureTimestamp),
        ('answerTimestamp', _TransitCallRecord_answerTimestamp),
        ('releaseTimestamp', _TransitCallRecord_releaseTimestamp),
        ('callDuration', _TransitCallRecord_callDuration),
        ('dataVolume', _TransitCallRecord_dataVolume),
        ('causeForTerm', _TransitCallRecord_causeForTerm),
        ('diagnostics', _TransitCallRecord_diagnostics),
        ('callReference', _TransitCallRecord_callReference),
        ('sequenceNumber', _TransitCallRecord_sequenceNumber),
        ('recordExtensions', _TransitCallRecord_recordExtensions),
        ('locationRoutNum', _TransitCallRecord_locationRoutNum),
        ('lrnSoInd', _TransitCallRecord_lrnSoInd),
        ('lrnQuryStatus', _TransitCallRecord_lrnQuryStatus),
        ('jIPPara', _TransitCallRecord_jIPPara),
        ('jIPSoInd', _TransitCallRecord_jIPSoInd),
        ('jIPQuryStatus', _TransitCallRecord_jIPQuryStatus),
        ])
    TransitCallRecord._ext = None
    
    #-----< MOSMSRecord >-----#
    MOSMSRecord = SET(name='MOSMSRecord', mode=MODE_TYPE)
    _MOSMSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOSMSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MOSMSRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MOSMSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MOSMSRecord_msClassmark = OCT_STR(name='msClassmark', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _MOSMSRecord_serviceCentre = OCT_STR(name='serviceCentre', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MOSMSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOSMSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MOSMSRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _MOSMSRecord_originationTime = OCT_STR(name='originationTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MOSMSRecord_smsResult = CHOICE(name='smsResult', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MOSMSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MOSMSRecord_destinationNumber = OCT_STR(name='destinationNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _MOSMSRecord_cAMELSMSInformation = SET(name='cAMELSMSInformation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELSMSInformation')), opt=True)
    _MOSMSRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MOSMSRecord_locationExtension = BIT_STR(name='locationExtension', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    MOSMSRecord._cont = ASN1Dict([
        ('recordType', _MOSMSRecord_recordType),
        ('servedIMSI', _MOSMSRecord_servedIMSI),
        ('servedIMEI', _MOSMSRecord_servedIMEI),
        ('servedMSISDN', _MOSMSRecord_servedMSISDN),
        ('msClassmark', _MOSMSRecord_msClassmark),
        ('serviceCentre', _MOSMSRecord_serviceCentre),
        ('recordingEntity', _MOSMSRecord_recordingEntity),
        ('location', _MOSMSRecord_location),
        ('messageReference', _MOSMSRecord_messageReference),
        ('originationTime', _MOSMSRecord_originationTime),
        ('smsResult', _MOSMSRecord_smsResult),
        ('recordExtensions', _MOSMSRecord_recordExtensions),
        ('destinationNumber', _MOSMSRecord_destinationNumber),
        ('cAMELSMSInformation', _MOSMSRecord_cAMELSMSInformation),
        ('systemType', _MOSMSRecord_systemType),
        ('locationExtension', _MOSMSRecord_locationExtension),
        ])
    MOSMSRecord._ext = None
    
    #-----< MTSMSRecord >-----#
    MTSMSRecord = SET(name='MTSMSRecord', mode=MODE_TYPE)
    _MTSMSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTSMSRecord_serviceCentre = OCT_STR(name='serviceCentre', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MTSMSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTSMSRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MTSMSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MTSMSRecord_msClassmark = OCT_STR(name='msClassmark', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _MTSMSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTSMSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MTSMSRecord_deliveryTime = OCT_STR(name='deliveryTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MTSMSRecord_smsResult = CHOICE(name='smsResult', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MTSMSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTSMSRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MTSMSRecord_cAMELSMSInformation = SET(name='cAMELSMSInformation', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELSMSInformation')), opt=True)
    _MTSMSRecord_locationExtension = BIT_STR(name='locationExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    MTSMSRecord._cont = ASN1Dict([
        ('recordType', _MTSMSRecord_recordType),
        ('serviceCentre', _MTSMSRecord_serviceCentre),
        ('servedIMSI', _MTSMSRecord_servedIMSI),
        ('servedIMEI', _MTSMSRecord_servedIMEI),
        ('servedMSISDN', _MTSMSRecord_servedMSISDN),
        ('msClassmark', _MTSMSRecord_msClassmark),
        ('recordingEntity', _MTSMSRecord_recordingEntity),
        ('location', _MTSMSRecord_location),
        ('deliveryTime', _MTSMSRecord_deliveryTime),
        ('smsResult', _MTSMSRecord_smsResult),
        ('recordExtensions', _MTSMSRecord_recordExtensions),
        ('systemType', _MTSMSRecord_systemType),
        ('cAMELSMSInformation', _MTSMSRecord_cAMELSMSInformation),
        ('locationExtension', _MTSMSRecord_locationExtension),
        ])
    MTSMSRecord._ext = None
    
    #-----< MOSMSIWRecord >-----#
    MOSMSIWRecord = SET(name='MOSMSIWRecord', mode=MODE_TYPE)
    _MOSMSIWRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOSMSIWRecord_serviceCentre = OCT_STR(name='serviceCentre', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MOSMSIWRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MOSMSIWRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOSMSIWRecord_eventTime = OCT_STR(name='eventTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MOSMSIWRecord_smsResult = CHOICE(name='smsResult', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MOSMSIWRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MOSMSIWRecord._cont = ASN1Dict([
        ('recordType', _MOSMSIWRecord_recordType),
        ('serviceCentre', _MOSMSIWRecord_serviceCentre),
        ('servedIMSI', _MOSMSIWRecord_servedIMSI),
        ('recordingEntity', _MOSMSIWRecord_recordingEntity),
        ('eventTime', _MOSMSIWRecord_eventTime),
        ('smsResult', _MOSMSIWRecord_smsResult),
        ('recordExtensions', _MOSMSIWRecord_recordExtensions),
        ])
    MOSMSIWRecord._ext = None
    
    #-----< MTSMSGWRecord >-----#
    MTSMSGWRecord = SET(name='MTSMSGWRecord', mode=MODE_TYPE)
    _MTSMSGWRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTSMSGWRecord_serviceCentre = OCT_STR(name='serviceCentre', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MTSMSGWRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTSMSGWRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MTSMSGWRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTSMSGWRecord_eventTime = OCT_STR(name='eventTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MTSMSGWRecord_smsResult = CHOICE(name='smsResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MTSMSGWRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MTSMSGWRecord._cont = ASN1Dict([
        ('recordType', _MTSMSGWRecord_recordType),
        ('serviceCentre', _MTSMSGWRecord_serviceCentre),
        ('servedIMSI', _MTSMSGWRecord_servedIMSI),
        ('servedMSISDN', _MTSMSGWRecord_servedMSISDN),
        ('recordingEntity', _MTSMSGWRecord_recordingEntity),
        ('eventTime', _MTSMSGWRecord_eventTime),
        ('smsResult', _MTSMSGWRecord_smsResult),
        ('recordExtensions', _MTSMSGWRecord_recordExtensions),
        ])
    MTSMSGWRecord._ext = None
    
    #-----< SSActionRecord >-----#
    SSActionRecord = SET(name='SSActionRecord', mode=MODE_TYPE)
    _SSActionRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SSActionRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SSActionRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SSActionRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SSActionRecord_msClassmark = OCT_STR(name='msClassmark', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _SSActionRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SSActionRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SSActionRecord_basicServices = SET_OF(name='basicServices', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'BasicServices')), opt=True)
    _SSActionRecord_supplService = OCT_STR(name='supplService', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SSActionRecord_ssAction = ENUM(name='ssAction', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSActionType')), opt=True)
    _SSActionRecord_ssActionTime = OCT_STR(name='ssActionTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SSActionRecord_ssParameters = CHOICE(name='ssParameters', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSParameters')), opt=True)
    _SSActionRecord_ssActionResult = CHOICE(name='ssActionResult', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSActionResult')), opt=True)
    _SSActionRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _SSActionRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SSActionRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    SSActionRecord._cont = ASN1Dict([
        ('recordType', _SSActionRecord_recordType),
        ('servedIMSI', _SSActionRecord_servedIMSI),
        ('servedIMEI', _SSActionRecord_servedIMEI),
        ('servedMSISDN', _SSActionRecord_servedMSISDN),
        ('msClassmark', _SSActionRecord_msClassmark),
        ('recordingEntity', _SSActionRecord_recordingEntity),
        ('location', _SSActionRecord_location),
        ('basicServices', _SSActionRecord_basicServices),
        ('supplService', _SSActionRecord_supplService),
        ('ssAction', _SSActionRecord_ssAction),
        ('ssActionTime', _SSActionRecord_ssActionTime),
        ('ssParameters', _SSActionRecord_ssParameters),
        ('ssActionResult', _SSActionRecord_ssActionResult),
        ('callReference', _SSActionRecord_callReference),
        ('recordExtensions', _SSActionRecord_recordExtensions),
        ('systemType', _SSActionRecord_systemType),
        ])
    SSActionRecord._ext = None
    
    #-----< HLRIntRecord >-----#
    HLRIntRecord = SET(name='HLRIntRecord', mode=MODE_TYPE)
    _HLRIntRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _HLRIntRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _HLRIntRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _HLRIntRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _HLRIntRecord_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _HLRIntRecord_routingNumber = CHOICE(name='routingNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoutingNumber')))
    _HLRIntRecord_interrogationTime = OCT_STR(name='interrogationTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _HLRIntRecord_numberOfForwarding = INT(name='numberOfForwarding', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    _HLRIntRecord_interrogationResult = CHOICE(name='interrogationResult', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'HLRIntResult')), opt=True)
    _HLRIntRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    HLRIntRecord._cont = ASN1Dict([
        ('recordType', _HLRIntRecord_recordType),
        ('servedIMSI', _HLRIntRecord_servedIMSI),
        ('servedMSISDN', _HLRIntRecord_servedMSISDN),
        ('recordingEntity', _HLRIntRecord_recordingEntity),
        ('basicService', _HLRIntRecord_basicService),
        ('routingNumber', _HLRIntRecord_routingNumber),
        ('interrogationTime', _HLRIntRecord_interrogationTime),
        ('numberOfForwarding', _HLRIntRecord_numberOfForwarding),
        ('interrogationResult', _HLRIntRecord_interrogationResult),
        ('recordExtensions', _HLRIntRecord_recordExtensions),
        ])
    HLRIntRecord._ext = None
    
    #-----< LocUpdateHLRRecord >-----#
    LocUpdateHLRRecord = SET(name='LocUpdateHLRRecord', mode=MODE_TYPE)
    _LocUpdateHLRRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LocUpdateHLRRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LocUpdateHLRRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LocUpdateHLRRecord_oldLocation = SEQ(name='oldLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Visited-Location-info')), opt=True)
    _LocUpdateHLRRecord_newLocation = SEQ(name='newLocation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Visited-Location-info')))
    _LocUpdateHLRRecord_updateTime = OCT_STR(name='updateTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LocUpdateHLRRecord_updateResult = CHOICE(name='updateResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdResult')), opt=True)
    _LocUpdateHLRRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    LocUpdateHLRRecord._cont = ASN1Dict([
        ('recordType', _LocUpdateHLRRecord_recordType),
        ('servedIMSI', _LocUpdateHLRRecord_servedIMSI),
        ('recordingEntity', _LocUpdateHLRRecord_recordingEntity),
        ('oldLocation', _LocUpdateHLRRecord_oldLocation),
        ('newLocation', _LocUpdateHLRRecord_newLocation),
        ('updateTime', _LocUpdateHLRRecord_updateTime),
        ('updateResult', _LocUpdateHLRRecord_updateResult),
        ('recordExtensions', _LocUpdateHLRRecord_recordExtensions),
        ])
    LocUpdateHLRRecord._ext = None
    
    #-----< LocUpdateVLRRecord >-----#
    LocUpdateVLRRecord = SET(name='LocUpdateVLRRecord', mode=MODE_TYPE)
    _LocUpdateVLRRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LocUpdateVLRRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LocUpdateVLRRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LocUpdateVLRRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LocUpdateVLRRecord_oldLocation = SEQ(name='oldLocation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Location-info')), opt=True)
    _LocUpdateVLRRecord_newLocation = SEQ(name='newLocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Location-info')))
    _LocUpdateVLRRecord_msClassmark = OCT_STR(name='msClassmark', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _LocUpdateVLRRecord_updateTime = OCT_STR(name='updateTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LocUpdateVLRRecord_updateResult = CHOICE(name='updateResult', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdResult')), opt=True)
    _LocUpdateVLRRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LocUpdateVLRRecord_locationExtension = BIT_STR(name='locationExtension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    LocUpdateVLRRecord._cont = ASN1Dict([
        ('recordType', _LocUpdateVLRRecord_recordType),
        ('servedIMSI', _LocUpdateVLRRecord_servedIMSI),
        ('servedMSISDN', _LocUpdateVLRRecord_servedMSISDN),
        ('recordingEntity', _LocUpdateVLRRecord_recordingEntity),
        ('oldLocation', _LocUpdateVLRRecord_oldLocation),
        ('newLocation', _LocUpdateVLRRecord_newLocation),
        ('msClassmark', _LocUpdateVLRRecord_msClassmark),
        ('updateTime', _LocUpdateVLRRecord_updateTime),
        ('updateResult', _LocUpdateVLRRecord_updateResult),
        ('recordExtensions', _LocUpdateVLRRecord_recordExtensions),
        ('locationExtension', _LocUpdateVLRRecord_locationExtension),
        ])
    LocUpdateVLRRecord._ext = None
    
    #-----< CommonEquipRecord >-----#
    CommonEquipRecord = SET(name='CommonEquipRecord', mode=MODE_TYPE)
    _CommonEquipRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CommonEquipRecord_equipmentType = INT(name='equipmentType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EquipmentType')))
    _CommonEquipRecord_equipmentId = INT(name='equipmentId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EquipmentId')))
    _CommonEquipRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _CommonEquipRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _CommonEquipRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _CommonEquipRecord_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _CommonEquipRecord_changeOfService = SEQ_OF(name='changeOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CommonEquipRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _CommonEquipRecord_changeOfService._cont = __CommonEquipRecord_changeOfService__item_
    _CommonEquipRecord_supplServicesUsed = SEQ_OF(name='supplServicesUsed', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CommonEquipRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _CommonEquipRecord_supplServicesUsed._cont = __CommonEquipRecord_supplServicesUsed__item_
    _CommonEquipRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CommonEquipRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CommonEquipRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CommonEquipRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _CommonEquipRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommonEquipRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CommonEquipRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _CommonEquipRecord_rateIndication = OCT_STR(name='rateIndication', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _CommonEquipRecord_fnur = ENUM(name='fnur', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    CommonEquipRecord._cont = ASN1Dict([
        ('recordType', _CommonEquipRecord_recordType),
        ('equipmentType', _CommonEquipRecord_equipmentType),
        ('equipmentId', _CommonEquipRecord_equipmentId),
        ('servedIMSI', _CommonEquipRecord_servedIMSI),
        ('servedMSISDN', _CommonEquipRecord_servedMSISDN),
        ('recordingEntity', _CommonEquipRecord_recordingEntity),
        ('basicService', _CommonEquipRecord_basicService),
        ('changeOfService', _CommonEquipRecord_changeOfService),
        ('supplServicesUsed', _CommonEquipRecord_supplServicesUsed),
        ('seizureTime', _CommonEquipRecord_seizureTime),
        ('releaseTime', _CommonEquipRecord_releaseTime),
        ('callDuration', _CommonEquipRecord_callDuration),
        ('callReference', _CommonEquipRecord_callReference),
        ('sequenceNumber', _CommonEquipRecord_sequenceNumber),
        ('recordExtensions', _CommonEquipRecord_recordExtensions),
        ('systemType', _CommonEquipRecord_systemType),
        ('rateIndication', _CommonEquipRecord_rateIndication),
        ('fnur', _CommonEquipRecord_fnur),
        ])
    CommonEquipRecord._ext = None
    
    #-----< ObservedIMEITicket >-----#
    ObservedIMEITicket = SET(name='ObservedIMEITicket', mode=MODE_TYPE)
    _ObservedIMEITicket_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _ObservedIMEITicket_imeiStatus = ENUM(name='imeiStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IMEIStatus')))
    _ObservedIMEITicket_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ObservedIMEITicket_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _ObservedIMEITicket_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _ObservedIMEITicket_eventTime = OCT_STR(name='eventTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ObservedIMEITicket_location = SEQ(name='location', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')))
    _ObservedIMEITicket_imeiCheckEvent = INT(name='imeiCheckEvent', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IMEICheckEvent')), opt=True)
    _ObservedIMEITicket_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ObservedIMEITicket_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ObservedIMEITicket._cont = ASN1Dict([
        ('servedIMEI', _ObservedIMEITicket_servedIMEI),
        ('imeiStatus', _ObservedIMEITicket_imeiStatus),
        ('servedIMSI', _ObservedIMEITicket_servedIMSI),
        ('servedMSISDN', _ObservedIMEITicket_servedMSISDN),
        ('recordingEntity', _ObservedIMEITicket_recordingEntity),
        ('eventTime', _ObservedIMEITicket_eventTime),
        ('location', _ObservedIMEITicket_location),
        ('imeiCheckEvent', _ObservedIMEITicket_imeiCheckEvent),
        ('callReference', _ObservedIMEITicket_callReference),
        ('recordExtensions', _ObservedIMEITicket_recordExtensions),
        ])
    ObservedIMEITicket._ext = None
    
    #-----< MTLCSRecord >-----#
    MTLCSRecord = SET(name='MTLCSRecord', mode=MODE_TYPE)
    _MTLCSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTLCSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTLCSRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')))
    _MTLCSRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')))
    _MTLCSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MTLCSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MTLCSRecord_locationType = SEQ(name='locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _MTLCSRecord_lcsQos = OCT_STR(name='lcsQos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _MTLCSRecord_lcsPriority = OCT_STR(name='lcsPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _MTLCSRecord_mlc_Number = OCT_STR(name='mlc-Number', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MTLCSRecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MTLCSRecord_measureDuration = INT(name='measureDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _MTLCSRecord_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _MTLCSRecord_privacyOverride = NULL(name='privacyOverride', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTLCSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MTLCSRecord_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _MTLCSRecord_positioningData = OCT_STR(name='positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _MTLCSRecord_lcsCause = OCT_STR(name='lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _MTLCSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MTLCSRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MTLCSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTLCSRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MTLCSRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    MTLCSRecord._cont = ASN1Dict([
        ('recordType', _MTLCSRecord_recordType),
        ('recordingEntity', _MTLCSRecord_recordingEntity),
        ('lcsClientType', _MTLCSRecord_lcsClientType),
        ('lcsClientIdentity', _MTLCSRecord_lcsClientIdentity),
        ('servedIMSI', _MTLCSRecord_servedIMSI),
        ('servedMSISDN', _MTLCSRecord_servedMSISDN),
        ('locationType', _MTLCSRecord_locationType),
        ('lcsQos', _MTLCSRecord_lcsQos),
        ('lcsPriority', _MTLCSRecord_lcsPriority),
        ('mlc-Number', _MTLCSRecord_mlc_Number),
        ('eventTimeStamp', _MTLCSRecord_eventTimeStamp),
        ('measureDuration', _MTLCSRecord_measureDuration),
        ('notificationToMSUser', _MTLCSRecord_notificationToMSUser),
        ('privacyOverride', _MTLCSRecord_privacyOverride),
        ('location', _MTLCSRecord_location),
        ('locationEstimate', _MTLCSRecord_locationEstimate),
        ('positioningData', _MTLCSRecord_positioningData),
        ('lcsCause', _MTLCSRecord_lcsCause),
        ('diagnostics', _MTLCSRecord_diagnostics),
        ('systemType', _MTLCSRecord_systemType),
        ('recordExtensions', _MTLCSRecord_recordExtensions),
        ('causeForTerm', _MTLCSRecord_causeForTerm),
        ('servedIMEI', _MTLCSRecord_servedIMEI),
        ])
    MTLCSRecord._ext = None
    
    #-----< MOLCSRecord >-----#
    MOLCSRecord = SET(name='MOLCSRecord', mode=MODE_TYPE)
    _MOLCSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOLCSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOLCSRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _MOLCSRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _MOLCSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MOLCSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MOLCSRecord_molr_Type = ENUM(name='molr-Type', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'MOLR-Type')))
    _MOLCSRecord_lcsQos = OCT_STR(name='lcsQos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _MOLCSRecord_lcsPriority = OCT_STR(name='lcsPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _MOLCSRecord_mlc_Number = OCT_STR(name='mlc-Number', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MOLCSRecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MOLCSRecord_measureDuration = INT(name='measureDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _MOLCSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MOLCSRecord_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _MOLCSRecord_positioningData = OCT_STR(name='positioningData', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _MOLCSRecord_lcsCause = OCT_STR(name='lcsCause', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _MOLCSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MOLCSRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MOLCSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MOLCSRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    MOLCSRecord._cont = ASN1Dict([
        ('recordType', _MOLCSRecord_recordType),
        ('recordingEntity', _MOLCSRecord_recordingEntity),
        ('lcsClientType', _MOLCSRecord_lcsClientType),
        ('lcsClientIdentity', _MOLCSRecord_lcsClientIdentity),
        ('servedIMSI', _MOLCSRecord_servedIMSI),
        ('servedMSISDN', _MOLCSRecord_servedMSISDN),
        ('molr-Type', _MOLCSRecord_molr_Type),
        ('lcsQos', _MOLCSRecord_lcsQos),
        ('lcsPriority', _MOLCSRecord_lcsPriority),
        ('mlc-Number', _MOLCSRecord_mlc_Number),
        ('eventTimeStamp', _MOLCSRecord_eventTimeStamp),
        ('measureDuration', _MOLCSRecord_measureDuration),
        ('location', _MOLCSRecord_location),
        ('locationEstimate', _MOLCSRecord_locationEstimate),
        ('positioningData', _MOLCSRecord_positioningData),
        ('lcsCause', _MOLCSRecord_lcsCause),
        ('diagnostics', _MOLCSRecord_diagnostics),
        ('systemType', _MOLCSRecord_systemType),
        ('recordExtensions', _MOLCSRecord_recordExtensions),
        ('causeForTerm', _MOLCSRecord_causeForTerm),
        ])
    MOLCSRecord._ext = None
    
    #-----< NILCSRecord >-----#
    NILCSRecord = SET(name='NILCSRecord', mode=MODE_TYPE)
    _NILCSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _NILCSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _NILCSRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _NILCSRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _NILCSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _NILCSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _NILCSRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _NILCSRecord_emsDigits = OCT_STR(name='emsDigits', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _NILCSRecord_emsKey = OCT_STR(name='emsKey', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _NILCSRecord_lcsQos = OCT_STR(name='lcsQos', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _NILCSRecord_lcsPriority = OCT_STR(name='lcsPriority', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _NILCSRecord_mlc_Number = OCT_STR(name='mlc-Number', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _NILCSRecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _NILCSRecord_measureDuration = INT(name='measureDuration', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _NILCSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _NILCSRecord_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _NILCSRecord_positioningData = OCT_STR(name='positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _NILCSRecord_lcsCause = OCT_STR(name='lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _NILCSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _NILCSRecord_systemType = ENUM(name='systemType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _NILCSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _NILCSRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    NILCSRecord._cont = ASN1Dict([
        ('recordType', _NILCSRecord_recordType),
        ('recordingEntity', _NILCSRecord_recordingEntity),
        ('lcsClientType', _NILCSRecord_lcsClientType),
        ('lcsClientIdentity', _NILCSRecord_lcsClientIdentity),
        ('servedIMSI', _NILCSRecord_servedIMSI),
        ('servedMSISDN', _NILCSRecord_servedMSISDN),
        ('servedIMEI', _NILCSRecord_servedIMEI),
        ('emsDigits', _NILCSRecord_emsDigits),
        ('emsKey', _NILCSRecord_emsKey),
        ('lcsQos', _NILCSRecord_lcsQos),
        ('lcsPriority', _NILCSRecord_lcsPriority),
        ('mlc-Number', _NILCSRecord_mlc_Number),
        ('eventTimeStamp', _NILCSRecord_eventTimeStamp),
        ('measureDuration', _NILCSRecord_measureDuration),
        ('location', _NILCSRecord_location),
        ('locationEstimate', _NILCSRecord_locationEstimate),
        ('positioningData', _NILCSRecord_positioningData),
        ('lcsCause', _NILCSRecord_lcsCause),
        ('diagnostics', _NILCSRecord_diagnostics),
        ('systemType', _NILCSRecord_systemType),
        ('recordExtensions', _NILCSRecord_recordExtensions),
        ('causeForTerm', _NILCSRecord_causeForTerm),
        ])
    NILCSRecord._ext = None
    
    #-----< MSCsRVCCRecord >-----#
    MSCsRVCCRecord = SET(name='MSCsRVCCRecord', mode=MODE_TYPE)
    _MSCsRVCCRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MSCsRVCCRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MSCsRVCCRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MSCsRVCCRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MSCsRVCCRecord_calledNumber = OCT_STR(name='calledNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _MSCsRVCCRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MSCsRVCCRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MSCsRVCCRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')))
    _MSCsRVCCRecord_changeOfLocation = SEQ_OF(name='changeOfLocation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MSCsRVCCRecord_changeOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'LocationChange')))
    _MSCsRVCCRecord_changeOfLocation._cont = __MSCsRVCCRecord_changeOfLocation__item_
    _MSCsRVCCRecord_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    _MSCsRVCCRecord_supplServicesUsed = SEQ_OF(name='supplServicesUsed', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MSCsRVCCRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _MSCsRVCCRecord_supplServicesUsed._cont = __MSCsRVCCRecord_supplServicesUsed__item_
    _MSCsRVCCRecord_msClassmark = OCT_STR(name='msClassmark', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')), opt=True)
    _MSCsRVCCRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MSCsRVCCRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MSCsRVCCRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MSCsRVCCRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MSCsRVCCRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MSCsRVCCRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MSCsRVCCRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MSCsRVCCRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MSCsRVCCRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MSCsRVCCRecord_partialRecordType = ENUM(name='partialRecordType', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    _MSCsRVCCRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(75, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MSCsRVCCRecord_iCSI2ActiveFlag = NULL(name='iCSI2ActiveFlag', mode=MODE_TYPE, tag=(76, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MSCsRVCCRecord_relatedICID = OCT_STR(name='relatedICID', mode=MODE_TYPE, tag=(77, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MSCsRVCCRecord_relatedICIDGenerationNode = CHOICE(name='relatedICIDGenerationNode', mode=MODE_TYPE, tag=(78, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    MSCsRVCCRecord._cont = ASN1Dict([
        ('recordType', _MSCsRVCCRecord_recordType),
        ('servedIMSI', _MSCsRVCCRecord_servedIMSI),
        ('servedIMEI', _MSCsRVCCRecord_servedIMEI),
        ('servedMSISDN', _MSCsRVCCRecord_servedMSISDN),
        ('calledNumber', _MSCsRVCCRecord_calledNumber),
        ('recordingEntity', _MSCsRVCCRecord_recordingEntity),
        ('mscOutgoingTKGP', _MSCsRVCCRecord_mscOutgoingTKGP),
        ('location', _MSCsRVCCRecord_location),
        ('changeOfLocation', _MSCsRVCCRecord_changeOfLocation),
        ('basicService', _MSCsRVCCRecord_basicService),
        ('supplServicesUsed', _MSCsRVCCRecord_supplServicesUsed),
        ('msClassmark', _MSCsRVCCRecord_msClassmark),
        ('seizureTime', _MSCsRVCCRecord_seizureTime),
        ('answerTime', _MSCsRVCCRecord_answerTime),
        ('releaseTime', _MSCsRVCCRecord_releaseTime),
        ('callDuration', _MSCsRVCCRecord_callDuration),
        ('causeForTerm', _MSCsRVCCRecord_causeForTerm),
        ('diagnostics', _MSCsRVCCRecord_diagnostics),
        ('callReference', _MSCsRVCCRecord_callReference),
        ('sequenceNumber', _MSCsRVCCRecord_sequenceNumber),
        ('recordExtensions', _MSCsRVCCRecord_recordExtensions),
        ('partialRecordType', _MSCsRVCCRecord_partialRecordType),
        ('iMS-Charging-Identifier', _MSCsRVCCRecord_iMS_Charging_Identifier),
        ('iCSI2ActiveFlag', _MSCsRVCCRecord_iCSI2ActiveFlag),
        ('relatedICID', _MSCsRVCCRecord_relatedICID),
        ('relatedICIDGenerationNode', _MSCsRVCCRecord_relatedICIDGenerationNode),
        ])
    MSCsRVCCRecord._ext = None
    
    #-----< MTRFRecord >-----#
    MTRFRecord = SET(name='MTRFRecord', mode=MODE_TYPE)
    _MTRFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTRFRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTRFRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MTRFRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')), opt=True)
    _MTRFRecord_callingNumber = OCT_STR(name='callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _MTRFRecord_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _MTRFRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTRFRecord_mscIncomingTKGP = CHOICE(name='mscIncomingTKGP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTRFRecord_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTRFRecord_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _MTRFRecord_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTRFRecord_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTRFRecord_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTRFRecord_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MTRFRecord_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MTRFRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MTRFRecord_callReference = OCT_STR(name='callReference', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MTRFRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTRFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTRFRecord_partialRecordType = ENUM(name='partialRecordType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    MTRFRecord._cont = ASN1Dict([
        ('recordType', _MTRFRecord_recordType),
        ('servedIMSI', _MTRFRecord_servedIMSI),
        ('servedIMEI', _MTRFRecord_servedIMEI),
        ('servedMSISDN', _MTRFRecord_servedMSISDN),
        ('callingNumber', _MTRFRecord_callingNumber),
        ('roamingNumber', _MTRFRecord_roamingNumber),
        ('recordingEntity', _MTRFRecord_recordingEntity),
        ('mscIncomingTKGP', _MTRFRecord_mscIncomingTKGP),
        ('mscOutgoingTKGP', _MTRFRecord_mscOutgoingTKGP),
        ('basicService', _MTRFRecord_basicService),
        ('seizureTime', _MTRFRecord_seizureTime),
        ('answerTime', _MTRFRecord_answerTime),
        ('releaseTime', _MTRFRecord_releaseTime),
        ('callDuration', _MTRFRecord_callDuration),
        ('causeForTerm', _MTRFRecord_causeForTerm),
        ('diagnostics', _MTRFRecord_diagnostics),
        ('callReference', _MTRFRecord_callReference),
        ('sequenceNumber', _MTRFRecord_sequenceNumber),
        ('recordExtensions', _MTRFRecord_recordExtensions),
        ('partialRecordType', _MTRFRecord_partialRecordType),
        ])
    MTRFRecord._ext = None
    
    #-----< ICSregisterRecord >-----#
    ICSregisterRecord = SET(name='ICSregisterRecord', mode=MODE_TYPE)
    _ICSregisterRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ICSregisterRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ICSregisterRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _ICSregisterRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSregisterRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _ICSregisterRecord_newLocation = SEQ(name='newLocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Location-info')))
    _ICSregisterRecord_locationExtension = BIT_STR(name='locationExtension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    _ICSregisterRecord_updateTime = OCT_STR(name='updateTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ICSregisterRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ICSregisterRecord_interOperatorIdentifiers = SEQ_OF(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _ICSregisterRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _ICSregisterRecord_updateResult = CHOICE(name='updateResult', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdResult')), opt=True)
    _ICSregisterRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ICSregisterRecord._cont = ASN1Dict([
        ('recordType', _ICSregisterRecord_recordType),
        ('servedIMSI', _ICSregisterRecord_servedIMSI),
        ('servedMSISDN', _ICSregisterRecord_servedMSISDN),
        ('privateUserID', _ICSregisterRecord_privateUserID),
        ('recordingEntity', _ICSregisterRecord_recordingEntity),
        ('newLocation', _ICSregisterRecord_newLocation),
        ('locationExtension', _ICSregisterRecord_locationExtension),
        ('updateTime', _ICSregisterRecord_updateTime),
        ('iMS-Charging-Identifier', _ICSregisterRecord_iMS_Charging_Identifier),
        ('interOperatorIdentifiers', _ICSregisterRecord_interOperatorIdentifiers),
        ('transit-IOI-Lists', _ICSregisterRecord_transit_IOI_Lists),
        ('updateResult', _ICSregisterRecord_updateResult),
        ('recordExtensions', _ICSregisterRecord_recordExtensions),
        ])
    ICSregisterRecord._ext = None
    
    #-----< LocationRoutingNumber >-----#
    LocationRoutingNumber = OCT_STR(name='LocationRoutingNumber', mode=MODE_TYPE)
    LocationRoutingNumber._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< LocationRoutingNumberSourceIndicator >-----#
    LocationRoutingNumberSourceIndicator = INT(name='LocationRoutingNumberSourceIndicator', mode=MODE_TYPE)
    LocationRoutingNumberSourceIndicator._cont = ASN1Dict([('lRN-NP-Database', 1), ('switchingSystemData', 2), ('incomingsignaling', 3), ('unknown', 9)])
    
    #-----< LocationRoutingNumberQueryStatus >-----#
    LocationRoutingNumberQueryStatus = INT(name='LocationRoutingNumberQueryStatus', mode=MODE_TYPE)
    LocationRoutingNumberQueryStatus._cont = ASN1Dict([('successfulQuery', 1), ('noQueryResponseMsg', 2), ('queryProtocolErr', 4), ('queryResponseDataErr', 5), ('queryRejected', 6), ('queryNotPerformed', 9), ('queryUnsuccessful', 99)])
    
    #-----< JurisdictionInformationParameter >-----#
    JurisdictionInformationParameter = OCT_STR(name='JurisdictionInformationParameter', mode=MODE_TYPE)
    JurisdictionInformationParameter._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< JurisdictionInformationParameterSourceIndicator >-----#
    JurisdictionInformationParameterSourceIndicator = INT(name='JurisdictionInformationParameterSourceIndicator', mode=MODE_TYPE)
    JurisdictionInformationParameterSourceIndicator._cont = ASN1Dict([('lRN-NP-Database', 1), ('switchingSystemData', 2), ('incomingsignaling', 3), ('unknown', 9)])
    
    #-----< JurisdictionInformationParameterQueryStatus >-----#
    JurisdictionInformationParameterQueryStatus = INT(name='JurisdictionInformationParameterQueryStatus', mode=MODE_TYPE)
    JurisdictionInformationParameterQueryStatus._cont = ASN1Dict([('successfulQuery', 1), ('noQueryResponseMsg', 2), ('queryProtocolErr', 4), ('queryResponseDataErr', 5), ('queryRejected', 6), ('queryNotPerformed', 9), ('queryUnsuccessful', 99)])
    
    #-----< AdditionalChgInfo >-----#
    AdditionalChgInfo = SEQ(name='AdditionalChgInfo', mode=MODE_TYPE)
    _AdditionalChgInfo_chargeIndicator = INT(name='chargeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargeIndicator')), opt=True)
    _AdditionalChgInfo_chargeParameters = OCT_STR(name='chargeParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AdditionalChgInfo._cont = ASN1Dict([
        ('chargeIndicator', _AdditionalChgInfo_chargeIndicator),
        ('chargeParameters', _AdditionalChgInfo_chargeParameters),
        ])
    AdditionalChgInfo._ext = None
    
    #-----< AiurRequested >-----#
    AiurRequested = ENUM(name='AiurRequested', mode=MODE_TYPE)
    AiurRequested._cont = ASN1Dict([('aiur09600BitsPerSecond', 1), ('aiur14400BitsPerSecond', 2), ('aiur19200BitsPerSecond', 3), ('aiur28800BitsPerSecond', 5), ('aiur38400BitsPerSecond', 6), ('aiur43200BitsPerSecond', 7), ('aiur57600BitsPerSecond', 8), ('aiur38400BitsPerSecond1', 9), ('aiur38400BitsPerSecond2', 10), ('aiur38400BitsPerSecond3', 11), ('aiur38400BitsPerSecond4', 12)])
    AiurRequested._ext = None
    
    #-----< AOCParameters >-----#
    AOCParameters = SEQ(name='AOCParameters', mode=MODE_TYPE)
    _AOCParameters_e1 = INT(name='e1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e2 = INT(name='e2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e3 = INT(name='e3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e4 = INT(name='e4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e5 = INT(name='e5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e6 = INT(name='e6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e7 = INT(name='e7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    AOCParameters._cont = ASN1Dict([
        ('e1', _AOCParameters_e1),
        ('e2', _AOCParameters_e2),
        ('e3', _AOCParameters_e3),
        ('e4', _AOCParameters_e4),
        ('e5', _AOCParameters_e5),
        ('e6', _AOCParameters_e6),
        ('e7', _AOCParameters_e7),
        ])
    AOCParameters._ext = None
    
    #-----< AOCParmChange >-----#
    AOCParmChange = SEQ(name='AOCParmChange', mode=MODE_TYPE)
    _AOCParmChange_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _AOCParmChange_newParameters = SEQ(name='newParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParameters')))
    AOCParmChange._cont = ASN1Dict([
        ('changeTime', _AOCParmChange_changeTime),
        ('newParameters', _AOCParmChange_newParameters),
        ])
    AOCParmChange._ext = None
    
    #-----< BasicServices >-----#
    BasicServices = SET_OF(name='BasicServices', mode=MODE_TYPE)
    _BasicServices__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    BasicServices._cont = _BasicServices__item_
    
    #-----< CallingPartyCategory >-----#
    CallingPartyCategory = OCT_STR(name='CallingPartyCategory', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'Category')))
    
    #-----< CallType >-----#
    CallType = INT(name='CallType', mode=MODE_TYPE)
    CallType._cont = ASN1Dict([('mobileOriginated', 0), ('mobileTerminated', 1)])
    
    #-----< CallTypes >-----#
    CallTypes = SET_OF(name='CallTypes', mode=MODE_TYPE)
    _CallTypes__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'CallType')))
    CallTypes._cont = _CallTypes__item_
    
    #-----< CAMELDestinationNumber >-----#
    CAMELDestinationNumber = SEQ_OF(name='CAMELDestinationNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    
    #-----< CAMELInformation >-----#
    CAMELInformation = SET(name='CAMELInformation', mode=MODE_TYPE)
    _CAMELInformation_cAMELDestinationNumber = SEQ_OF(name='cAMELDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELDestinationNumber')), opt=True)
    _CAMELInformation_connectedNumber = OCT_STR(name='connectedNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ConnectedNumber')), opt=True)
    _CAMELInformation_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _CAMELInformation_mscOutgoingTKGP = CHOICE(name='mscOutgoingTKGP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _CAMELInformation_seizureTime = OCT_STR(name='seizureTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CAMELInformation_answerTime = OCT_STR(name='answerTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CAMELInformation_releaseTime = OCT_STR(name='releaseTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CAMELInformation_callDuration = INT(name='callDuration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _CAMELInformation_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _CAMELInformation_cAMELInitCFIndicator = ENUM(name='cAMELInitCFIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInitCFIndicator')), opt=True)
    _CAMELInformation_causeForTerm = INT(name='causeForTerm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')), opt=True)
    _CAMELInformation_cAMELModification = SET(name='cAMELModification', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangedParameters')), opt=True)
    _CAMELInformation_freeFormatData = OCT_STR(name='freeFormatData', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformation_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CAMELInformation_freeFormatDataAppend = BOOL(name='freeFormatDataAppend', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMELInformation_freeFormatData_2 = OCT_STR(name='freeFormatData-2', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformation_freeFormatDataAppend_2 = BOOL(name='freeFormatDataAppend-2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CAMELInformation._cont = ASN1Dict([
        ('cAMELDestinationNumber', _CAMELInformation_cAMELDestinationNumber),
        ('connectedNumber', _CAMELInformation_connectedNumber),
        ('roamingNumber', _CAMELInformation_roamingNumber),
        ('mscOutgoingTKGP', _CAMELInformation_mscOutgoingTKGP),
        ('seizureTime', _CAMELInformation_seizureTime),
        ('answerTime', _CAMELInformation_answerTime),
        ('releaseTime', _CAMELInformation_releaseTime),
        ('callDuration', _CAMELInformation_callDuration),
        ('dataVolume', _CAMELInformation_dataVolume),
        ('cAMELInitCFIndicator', _CAMELInformation_cAMELInitCFIndicator),
        ('causeForTerm', _CAMELInformation_causeForTerm),
        ('cAMELModification', _CAMELInformation_cAMELModification),
        ('freeFormatData', _CAMELInformation_freeFormatData),
        ('diagnostics', _CAMELInformation_diagnostics),
        ('freeFormatDataAppend', _CAMELInformation_freeFormatDataAppend),
        ('freeFormatData-2', _CAMELInformation_freeFormatData_2),
        ('freeFormatDataAppend-2', _CAMELInformation_freeFormatDataAppend_2),
        ])
    CAMELInformation._ext = None
    
    #-----< CAMELInitCFIndicator >-----#
    CAMELInitCFIndicator = ENUM(name='CAMELInitCFIndicator', mode=MODE_TYPE)
    CAMELInitCFIndicator._cont = ASN1Dict([('noCAMELCallForwarding', 0), ('cAMELCallForwarding', 1)])
    CAMELInitCFIndicator._ext = None
    
    #-----< CAMELModificationParameters >-----#
    CAMELModificationParameters = SET(name='CAMELModificationParameters', mode=MODE_TYPE)
    _CAMELModificationParameters_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _CAMELModificationParameters_callingPartyCategory = OCT_STR(name='callingPartyCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CallingPartyCategory')), opt=True)
    _CAMELModificationParameters_originalCalledPartyNumber = OCT_STR(name='originalCalledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'OriginalCalledNumber')), opt=True)
    _CAMELModificationParameters_genericNumbers = SET_OF(name='genericNumbers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'GenericNumbers')), opt=True)
    _CAMELModificationParameters_redirectingPartyNumber = OCT_STR(name='redirectingPartyNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RedirectingNumber')), opt=True)
    _CAMELModificationParameters_redirectionCounter = INT(name='redirectionCounter', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    CAMELModificationParameters._cont = ASN1Dict([
        ('callingPartyNumber', _CAMELModificationParameters_callingPartyNumber),
        ('callingPartyCategory', _CAMELModificationParameters_callingPartyCategory),
        ('originalCalledPartyNumber', _CAMELModificationParameters_originalCalledPartyNumber),
        ('genericNumbers', _CAMELModificationParameters_genericNumbers),
        ('redirectingPartyNumber', _CAMELModificationParameters_redirectingPartyNumber),
        ('redirectionCounter', _CAMELModificationParameters_redirectionCounter),
        ])
    CAMELModificationParameters._ext = None
    
    #-----< CAMELSMSInformation >-----#
    CAMELSMSInformation = SET(name='CAMELSMSInformation', mode=MODE_TYPE)
    _CAMELSMSInformation_gsm_SCFAddress = OCT_STR(name='gsm-SCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _CAMELSMSInformation_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELSMSInformation_defaultSMSHandling = ENUM(name='defaultSMSHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')), opt=True)
    _CAMELSMSInformation_freeFormatData = OCT_STR(name='freeFormatData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELSMSInformation_callingPartyNumber = OCT_STR(name='callingPartyNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _CAMELSMSInformation_destinationSubscriberNumber = OCT_STR(name='destinationSubscriberNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _CAMELSMSInformation_cAMELSMSCAddress = OCT_STR(name='cAMELSMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _CAMELSMSInformation_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    CAMELSMSInformation._cont = ASN1Dict([
        ('gsm-SCFAddress', _CAMELSMSInformation_gsm_SCFAddress),
        ('serviceKey', _CAMELSMSInformation_serviceKey),
        ('defaultSMSHandling', _CAMELSMSInformation_defaultSMSHandling),
        ('freeFormatData', _CAMELSMSInformation_freeFormatData),
        ('callingPartyNumber', _CAMELSMSInformation_callingPartyNumber),
        ('destinationSubscriberNumber', _CAMELSMSInformation_destinationSubscriberNumber),
        ('cAMELSMSCAddress', _CAMELSMSInformation_cAMELSMSCAddress),
        ('smsReferenceNumber', _CAMELSMSInformation_smsReferenceNumber),
        ])
    CAMELSMSInformation._ext = None
    
    #-----< Category >-----#
    Category = OCT_STR(name='Category', mode=MODE_TYPE)
    Category._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChangedParameters >-----#
    ChangedParameters = SET(name='ChangedParameters', mode=MODE_TYPE)
    _ChangedParameters_changeFlags = BIT_STR(name='changeFlags', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeFlags')))
    _ChangedParameters_changeList = SET(name='changeList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELModificationParameters')), opt=True)
    ChangedParameters._cont = ASN1Dict([
        ('changeFlags', _ChangedParameters_changeFlags),
        ('changeList', _ChangedParameters_changeList),
        ])
    ChangedParameters._ext = None
    
    #-----< ChangeFlags >-----#
    ChangeFlags = BIT_STR(name='ChangeFlags', mode=MODE_TYPE)
    ChangeFlags._cont = ASN1Dict([('callingPartyNumberModified', 0), ('callingPartyCategoryModified', 1), ('originalCalledPartyNumberModified', 2), ('genericNumbersModified', 3), ('redirectingPartyNumberModified', 4), ('redirectionCounterModified', 5)])
    
    #-----< ChangeOfClassmark >-----#
    ChangeOfClassmark = SEQ(name='ChangeOfClassmark', mode=MODE_TYPE)
    _ChangeOfClassmark_classmark = OCT_STR(name='classmark', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _ChangeOfClassmark_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    ChangeOfClassmark._cont = ASN1Dict([
        ('classmark', _ChangeOfClassmark_classmark),
        ('changeTime', _ChangeOfClassmark_changeTime),
        ])
    ChangeOfClassmark._ext = None
    
    #-----< ChangeOfRadioChannel >-----#
    ChangeOfRadioChannel = SEQ(name='ChangeOfRadioChannel', mode=MODE_TYPE)
    _ChangeOfRadioChannel_radioChannel = ENUM(name='radioChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrafficChannel')))
    _ChangeOfRadioChannel_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfRadioChannel_speechVersionUsed = OCT_STR(name='speechVersionUsed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    ChangeOfRadioChannel._cont = ASN1Dict([
        ('radioChannel', _ChangeOfRadioChannel_radioChannel),
        ('changeTime', _ChangeOfRadioChannel_changeTime),
        ('speechVersionUsed', _ChangeOfRadioChannel_speechVersionUsed),
        ])
    ChangeOfRadioChannel._ext = None
    
    #-----< ChangeOfService >-----#
    ChangeOfService = SEQ(name='ChangeOfService', mode=MODE_TYPE)
    _ChangeOfService_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    _ChangeOfService_transparencyInd = ENUM(name='transparencyInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _ChangeOfService_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfService_rateIndication = OCT_STR(name='rateIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _ChangeOfService_fnur = ENUM(name='fnur', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    ChangeOfService._cont = ASN1Dict([
        ('basicService', _ChangeOfService_basicService),
        ('transparencyInd', _ChangeOfService_transparencyInd),
        ('changeTime', _ChangeOfService_changeTime),
        ('rateIndication', _ChangeOfService_rateIndication),
        ('fnur', _ChangeOfService_fnur),
        ])
    ChangeOfService._ext = None
    
    #-----< ChannelCoding >-----#
    ChannelCoding = ENUM(name='ChannelCoding', mode=MODE_TYPE)
    ChannelCoding._cont = ASN1Dict([('tchF4800', 1), ('tchF9600', 2), ('tchF14400', 3)])
    ChannelCoding._ext = None
    
    #-----< Classmark >-----#
    Classmark = OCT_STR(name='Classmark', mode=MODE_TYPE)
    
    #-----< ConnectedNumber >-----#
    ConnectedNumber = OCT_STR(name='ConnectedNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< DataVolume >-----#
    DataVolume = INT(name='DataVolume', mode=MODE_TYPE)
    
    #-----< Day >-----#
    Day = INT(name='Day', mode=MODE_TYPE)
    Day._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=None, er=[])
    
    #-----< DayClass >-----#
    DayClass = CHOICE(name='DayClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    
    #-----< DayClasses >-----#
    DayClasses = SET_OF(name='DayClasses', mode=MODE_TYPE)
    _DayClasses__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'DayClass')))
    DayClasses._cont = _DayClasses__item_
    
    #-----< DayDefinition >-----#
    DayDefinition = SEQ(name='DayDefinition', mode=MODE_TYPE)
    _DayDefinition_day = ENUM(name='day', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DayOfTheWeek')))
    _DayDefinition_dayClass = CHOICE(name='dayClass', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    DayDefinition._cont = ASN1Dict([
        ('day', _DayDefinition_day),
        ('dayClass', _DayDefinition_dayClass),
        ])
    DayDefinition._ext = None
    
    #-----< DayDefinitions >-----#
    DayDefinitions = SET_OF(name='DayDefinitions', mode=MODE_TYPE)
    _DayDefinitions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'DayDefinition')))
    DayDefinitions._cont = _DayDefinitions__item_
    
    #-----< DateDefinition >-----#
    DateDefinition = SEQ(name='DateDefinition', mode=MODE_TYPE)
    _DateDefinition_month = INT(name='month', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Month')))
    _DateDefinition_day = INT(name='day', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Day')))
    _DateDefinition_dayClass = CHOICE(name='dayClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    DateDefinition._cont = ASN1Dict([
        ('month', _DateDefinition_month),
        ('day', _DateDefinition_day),
        ('dayClass', _DateDefinition_dayClass),
        ])
    DateDefinition._ext = None
    
    #-----< DateDefinitions >-----#
    DateDefinitions = SET_OF(name='DateDefinitions', mode=MODE_TYPE)
    _DateDefinitions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'DateDefinition')))
    DateDefinitions._cont = _DateDefinitions__item_
    
    #-----< DayOfTheWeek >-----#
    DayOfTheWeek = ENUM(name='DayOfTheWeek', mode=MODE_TYPE)
    DayOfTheWeek._cont = ASN1Dict([('allDays', 0), ('sunday', 1), ('monday', 2), ('tuesday', 3), ('wednesday', 4), ('thursday', 5), ('friday', 6), ('saturday', 7)])
    DayOfTheWeek._ext = None
    
    #-----< Destinations >-----#
    Destinations = SET_OF(name='Destinations', mode=MODE_TYPE)
    _Destinations__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    Destinations._cont = _Destinations__item_
    
    #-----< EmergencyCallIndEnable >-----#
    EmergencyCallIndEnable = BOOL(name='EmergencyCallIndEnable', mode=MODE_TYPE)
    
    #-----< EmergencyCallIndication >-----#
    EmergencyCallIndication = SEQ(name='EmergencyCallIndication', mode=MODE_TYPE)
    _EmergencyCallIndication_cellId = OCT_STR(name='cellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')))
    _EmergencyCallIndication_callerId = CHOICE(name='callerId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IMSIorIMEI')))
    EmergencyCallIndication._cont = ASN1Dict([
        ('cellId', _EmergencyCallIndication_cellId),
        ('callerId', _EmergencyCallIndication_callerId),
        ])
    EmergencyCallIndication._ext = None
    
    #-----< EParameter >-----#
    EParameter = INT(name='EParameter', mode=MODE_TYPE)
    
    #-----< EquipmentId >-----#
    EquipmentId = INT(name='EquipmentId', mode=MODE_TYPE)
    
    #-----< EquipmentType >-----#
    EquipmentType = INT(name='EquipmentType', mode=MODE_TYPE)
    EquipmentType._cont = ASN1Dict([('conferenceBridge', 0)])
    
    #-----< FileType >-----#
    FileType = INT(name='FileType', mode=MODE_TYPE)
    FileType._cont = ASN1Dict([('callRecords', 1), ('traceRecords', 9), ('observedIMEITicket', 14)])
    
    #-----< Fnur >-----#
    Fnur = ENUM(name='Fnur', mode=MODE_TYPE)
    Fnur._cont = ASN1Dict([('fnurNotApplicable', 0), ('fnur9600-BitsPerSecond', 1), ('fnur14400BitsPerSecond', 2), ('fnur19200BitsPerSecond', 3), ('fnur28800BitsPerSecond', 4), ('fnur38400BitsPerSecond', 5), ('fnur48000BitsPerSecond', 6), ('fnur56000BitsPerSecond', 7), ('fnur64000BitsPerSecond', 8), ('fnur33600BitsPerSecond', 9), ('fnur32000BitsPerSecond', 10), ('fnur31200BitsPerSecond', 11)])
    Fnur._ext = None
    
    #-----< ForwardToNumber >-----#
    ForwardToNumber = OCT_STR(name='ForwardToNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< FreeFormatData >-----#
    FreeFormatData = OCT_STR(name='FreeFormatData', mode=MODE_TYPE)
    FreeFormatData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< GenericNumber >-----#
    GenericNumber = OCT_STR(name='GenericNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< GenericNumbers >-----#
    GenericNumbers = SET_OF(name='GenericNumbers', mode=MODE_TYPE)
    _GenericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'GenericNumber')))
    GenericNumbers._cont = _GenericNumbers__item_
    
    #-----< Gsm-SCFAddress >-----#
    Gsm_SCFAddress = OCT_STR(name='Gsm-SCFAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< GuaranteedBitRate >-----#
    GuaranteedBitRate = ENUM(name='GuaranteedBitRate', mode=MODE_TYPE)
    GuaranteedBitRate._cont = ASN1Dict([('gbr14400BitsPerSecond', 1), ('gbr28800BitsPerSecond', 2), ('gbr32000BitsPerSecond', 3), ('gbr33600BitsPerSecond', 4), ('gbr56000BitsPerSecond', 5), ('gbr57600BitsPerSecond', 6), ('gbr64000BitsPerSecond', 7)])
    GuaranteedBitRate._ext = None
    
    #-----< HLRIntResult >-----#
    HLRIntResult = CHOICE(name='HLRIntResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< HSCSDParmsChange >-----#
    HSCSDParmsChange = SEQ(name='HSCSDParmsChange', mode=MODE_TYPE)
    _HSCSDParmsChange_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _HSCSDParmsChange_hSCSDChanAllocated = INT(name='hSCSDChanAllocated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanAllocated')))
    _HSCSDParmsChange_initiatingParty = ENUM(name='initiatingParty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'InitiatingParty')), opt=True)
    _HSCSDParmsChange_aiurRequested = ENUM(name='aiurRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AiurRequested')), opt=True)
    _HSCSDParmsChange_chanCodingUsed = ENUM(name='chanCodingUsed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')))
    _HSCSDParmsChange_hSCSDChanRequested = INT(name='hSCSDChanRequested', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanRequested')), opt=True)
    HSCSDParmsChange._cont = ASN1Dict([
        ('changeTime', _HSCSDParmsChange_changeTime),
        ('hSCSDChanAllocated', _HSCSDParmsChange_hSCSDChanAllocated),
        ('initiatingParty', _HSCSDParmsChange_initiatingParty),
        ('aiurRequested', _HSCSDParmsChange_aiurRequested),
        ('chanCodingUsed', _HSCSDParmsChange_chanCodingUsed),
        ('hSCSDChanRequested', _HSCSDParmsChange_hSCSDChanRequested),
        ])
    HSCSDParmsChange._ext = None
    
    #-----< IMEICheckEvent >-----#
    IMEICheckEvent = INT(name='IMEICheckEvent', mode=MODE_TYPE)
    IMEICheckEvent._cont = ASN1Dict([('mobileOriginatedCall', 0), ('mobileTerminatedCall', 1), ('smsMobileOriginating', 2), ('smsMobileTerminating', 3), ('ssAction', 4), ('locationUpdate', 5)])
    
    #-----< IMEIStatus >-----#
    IMEIStatus = ENUM(name='IMEIStatus', mode=MODE_TYPE)
    IMEIStatus._cont = ASN1Dict([('greyListedMobileEquipment', 0), ('blackListedMobileEquipment', 1), ('nonWhiteListedMobileEquipment', 2)])
    IMEIStatus._ext = None
    
    #-----< IMSIorIMEI >-----#
    IMSIorIMEI = CHOICE(name='IMSIorIMEI', mode=MODE_TYPE)
    _IMSIorIMEI_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IMSIorIMEI_imei = OCT_STR(name='imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    IMSIorIMEI._cont = ASN1Dict([
        ('imsi', _IMSIorIMEI_imsi),
        ('imei', _IMSIorIMEI_imei),
        ])
    IMSIorIMEI._ext = None
    
    #-----< InitiatingParty >-----#
    InitiatingParty = ENUM(name='InitiatingParty', mode=MODE_TYPE)
    InitiatingParty._cont = ASN1Dict([('network', 0), ('subscriber', 1)])
    InitiatingParty._ext = None
    
    #-----< LocationCellExtension >-----#
    LocationCellExtension = BIT_STR(name='LocationCellExtension', mode=MODE_TYPE)
    LocationCellExtension._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    
    #-----< LocationChange >-----#
    LocationChange = SEQ(name='LocationChange', mode=MODE_TYPE)
    _LocationChange_location = SEQ(name='location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')))
    _LocationChange_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    LocationChange._cont = ASN1Dict([
        ('location', _LocationChange_location),
        ('changeTime', _LocationChange_changeTime),
        ])
    LocationChange._ext = None
    
    #-----< Location-info >-----#
    Location_info = SEQ(name='Location-info', mode=MODE_TYPE)
    _Location_info_mscNumber = OCT_STR(name='mscNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MscNo')), opt=True)
    _Location_info_location_area = OCT_STR(name='location-area', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')))
    _Location_info_cell_identification = OCT_STR(name='cell-identification', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _Location_info_mCC_MNC = OCT_STR(name='mCC-MNC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MCC-MNC')), opt=True)
    Location_info._cont = ASN1Dict([
        ('mscNumber', _Location_info_mscNumber),
        ('location-area', _Location_info_location_area),
        ('cell-identification', _Location_info_cell_identification),
        ('mCC-MNC', _Location_info_mCC_MNC),
        ])
    Location_info._ext = None
    
    #-----< LocUpdResult >-----#
    LocUpdResult = CHOICE(name='LocUpdResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< MaximumBitRate >-----#
    MaximumBitRate = ENUM(name='MaximumBitRate', mode=MODE_TYPE)
    MaximumBitRate._cont = ASN1Dict([('mbr14400BitsPerSecond', 1), ('mbr28800BitsPerSecond', 2), ('mbr32000BitsPerSecond', 3), ('mbr33600BitsPerSecond', 4), ('mbr56000BitsPerSecond', 5), ('mbr57600BitsPerSecond', 6)])
    MaximumBitRate._ext = None
    
    #-----< Month >-----#
    Month = INT(name='Month', mode=MODE_TYPE)
    Month._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< MSPowerClasses >-----#
    MSPowerClasses = SET_OF(name='MSPowerClasses', mode=MODE_TYPE)
    _MSPowerClasses__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'RFPowerCapability')))
    MSPowerClasses._cont = _MSPowerClasses__item_
    
    #-----< NetworkCallReference >-----#
    NetworkCallReference = OCT_STR(name='NetworkCallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    
    #-----< NetworkSpecificCode >-----#
    NetworkSpecificCode = INT(name='NetworkSpecificCode', mode=MODE_TYPE)
    
    #-----< NetworkSpecificServices >-----#
    NetworkSpecificServices = SET_OF(name='NetworkSpecificServices', mode=MODE_TYPE)
    _NetworkSpecificServices__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkSpecificCode')))
    NetworkSpecificServices._cont = _NetworkSpecificServices__item_
    
    #-----< NumOfHSCSDChanRequested >-----#
    NumOfHSCSDChanRequested = INT(name='NumOfHSCSDChanRequested', mode=MODE_TYPE)
    
    #-----< NumOfHSCSDChanAllocated >-----#
    NumOfHSCSDChanAllocated = INT(name='NumOfHSCSDChanAllocated', mode=MODE_TYPE)
    
    #-----< ObservedIMEITicketEnable >-----#
    ObservedIMEITicketEnable = BOOL(name='ObservedIMEITicketEnable', mode=MODE_TYPE)
    
    #-----< OriginalCalledNumber >-----#
    OriginalCalledNumber = OCT_STR(name='OriginalCalledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< OriginDestCombinations >-----#
    OriginDestCombinations = SET_OF(name='OriginDestCombinations', mode=MODE_TYPE)
    _OriginDestCombinations__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'OriginDestCombination')))
    OriginDestCombinations._cont = _OriginDestCombinations__item_
    
    #-----< OriginDestCombination >-----#
    OriginDestCombination = SEQ(name='OriginDestCombination', mode=MODE_TYPE)
    _OriginDestCombination_origin = INT(name='origin', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OriginDestCombination_destination = INT(name='destination', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OriginDestCombination._cont = ASN1Dict([
        ('origin', _OriginDestCombination_origin),
        ('destination', _OriginDestCombination_destination),
        ])
    OriginDestCombination._ext = None
    
    #-----< PartialRecordTimer >-----#
    PartialRecordTimer = INT(name='PartialRecordTimer', mode=MODE_TYPE)
    
    #-----< PartialRecordType >-----#
    PartialRecordType = ENUM(name='PartialRecordType', mode=MODE_TYPE)
    PartialRecordType._cont = ASN1Dict([('timeLimit', 0), ('serviceChange', 1), ('locationChange', 2), ('classmarkChange', 3), ('aocParmChange', 4), ('radioChannelChange', 5), ('hSCSDParmChange', 6), ('changeOfCAMELDestination', 7)])
    PartialRecordType._ext = None
    
    #-----< PartialRecordTypes >-----#
    PartialRecordTypes = SET_OF(name='PartialRecordTypes', mode=MODE_TYPE)
    _PartialRecordTypes__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')))
    PartialRecordTypes._cont = _PartialRecordTypes__item_
    
    #-----< RadioChannelsRequested >-----#
    RadioChannelsRequested = SET_OF(name='RadioChannelsRequested', mode=MODE_TYPE)
    _RadioChannelsRequested__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'RadioChanRequested')))
    RadioChannelsRequested._cont = _RadioChannelsRequested__item_
    
    #-----< RadioChanRequested >-----#
    RadioChanRequested = ENUM(name='RadioChanRequested', mode=MODE_TYPE)
    RadioChanRequested._cont = ASN1Dict([('halfRateChannel', 0), ('fullRateChannel', 1), ('dualHalfRatePreferred', 2), ('dualFullRatePreferred', 3)])
    RadioChanRequested._ext = None
    
    #-----< RateIndication >-----#
    RateIndication = OCT_STR(name='RateIndication', mode=MODE_TYPE)
    RateIndication._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ReasonForServiceChange >-----#
    ReasonForServiceChange = ENUM(name='ReasonForServiceChange', mode=MODE_TYPE)
    ReasonForServiceChange._cont = ASN1Dict([('msubInitiated', 0), ('mscInitiated', 1), ('callSetupFallBack', 2), ('callSetupChangeOrder', 3)])
    ReasonForServiceChange._ext = None
    
    #-----< RecordClassDestination >-----#
    RecordClassDestination = CHOICE(name='RecordClassDestination', mode=MODE_TYPE)
    _RecordClassDestination_osApplication = CHOICE(name='osApplication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    _RecordClassDestination_fileType = INT(name='fileType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FileType')))
    RecordClassDestination._cont = ASN1Dict([
        ('osApplication', _RecordClassDestination_osApplication),
        ('fileType', _RecordClassDestination_fileType),
        ])
    RecordClassDestination._ext = None
    
    #-----< RecordClassDestinations >-----#
    RecordClassDestinations = SET_OF(name='RecordClassDestinations', mode=MODE_TYPE)
    _RecordClassDestinations__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'RecordClassDestination')))
    RecordClassDestinations._cont = _RecordClassDestinations__item_
    
    #-----< RecordingMethod >-----#
    RecordingMethod = ENUM(name='RecordingMethod', mode=MODE_TYPE)
    RecordingMethod._cont = ASN1Dict([('inCallRecord', 0), ('inSSRecord', 1)])
    RecordingMethod._ext = None
    
    #-----< RedirectingNumber >-----#
    RedirectingNumber = OCT_STR(name='RedirectingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< RFPowerCapability >-----#
    RFPowerCapability = INT(name='RFPowerCapability', mode=MODE_TYPE)
    
    #-----< RoamingNumber >-----#
    RoamingNumber = OCT_STR(name='RoamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< RoutingNumber >-----#
    RoutingNumber = CHOICE(name='RoutingNumber', mode=MODE_TYPE)
    _RoutingNumber_roaming = OCT_STR(name='roaming', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')))
    _RoutingNumber_forwarded = OCT_STR(name='forwarded', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ForwardToNumber')))
    RoutingNumber._cont = ASN1Dict([
        ('roaming', _RoutingNumber_roaming),
        ('forwarded', _RoutingNumber_forwarded),
        ])
    RoutingNumber._ext = None
    
    #-----< Service >-----#
    Service = CHOICE(name='Service', mode=MODE_TYPE)
    _Service_teleservice = OCT_STR(name='teleservice', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    _Service_bearerService = OCT_STR(name='bearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    _Service_supplementaryService = OCT_STR(name='supplementaryService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Service_networkSpecificService = INT(name='networkSpecificService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkSpecificCode')))
    Service._cont = ASN1Dict([
        ('teleservice', _Service_teleservice),
        ('bearerService', _Service_bearerService),
        ('supplementaryService', _Service_supplementaryService),
        ('networkSpecificService', _Service_networkSpecificService),
        ])
    Service._ext = None
    
    #-----< ServiceDistanceDependencies >-----#
    ServiceDistanceDependencies = SET_OF(name='ServiceDistanceDependencies', mode=MODE_TYPE)
    _ServiceDistanceDependencies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ServiceDistanceDependency')))
    ServiceDistanceDependencies._cont = _ServiceDistanceDependencies__item_
    
    #-----< ServiceDistanceDependency >-----#
    ServiceDistanceDependency = SEQ(name='ServiceDistanceDependency', mode=MODE_TYPE)
    _ServiceDistanceDependency_aocService = INT(name='aocService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServiceDistanceDependency_chargingZone = INT(name='chargingZone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ServiceDistanceDependency._cont = ASN1Dict([
        ('aocService', _ServiceDistanceDependency_aocService),
        ('chargingZone', _ServiceDistanceDependency_chargingZone),
        ])
    ServiceDistanceDependency._ext = None
    
    #-----< SimpleIntegerName >-----#
    SimpleIntegerName = INT(name='SimpleIntegerName', mode=MODE_TYPE)
    
    #-----< SimpleStringName >-----#
    SimpleStringName = STR_GRAPH(name='SimpleStringName', mode=MODE_TYPE)
    
    #-----< SpeechVersionIdentifier >-----#
    SpeechVersionIdentifier = OCT_STR(name='SpeechVersionIdentifier', mode=MODE_TYPE)
    SpeechVersionIdentifier._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SSActionResult >-----#
    SSActionResult = CHOICE(name='SSActionResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< SSActionType >-----#
    SSActionType = ENUM(name='SSActionType', mode=MODE_TYPE)
    SSActionType._cont = ASN1Dict([('registration', 0), ('erasure', 1), ('activation', 2), ('deactivation', 3), ('interrogation', 4), ('invocation', 5), ('passwordRegistration', 6)])
    SSActionType._ext = None
    
    #-----< SSParameters >-----#
    SSParameters = CHOICE(name='SSParameters', mode=MODE_TYPE)
    _SSParameters_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ForwardToNumber')))
    _SSParameters_unstructuredData = OCT_STR(name='unstructuredData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SSParameters._cont = ASN1Dict([
        ('forwardedToNumber', _SSParameters_forwardedToNumber),
        ('unstructuredData', _SSParameters_unstructuredData),
        ])
    SSParameters._ext = None
    
    #-----< SupplServices >-----#
    SupplServices = SET_OF(name='SupplServices', mode=MODE_TYPE)
    _SupplServices__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SupplServices._cont = _SupplServices__item_
    
    #-----< SuppServiceUsed >-----#
    SuppServiceUsed = SEQ(name='SuppServiceUsed', mode=MODE_TYPE)
    _SuppServiceUsed_ssCode = OCT_STR(name='ssCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SuppServiceUsed_ssTime = OCT_STR(name='ssTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    SuppServiceUsed._cont = ASN1Dict([
        ('ssCode', _SuppServiceUsed_ssCode),
        ('ssTime', _SuppServiceUsed_ssTime),
        ])
    SuppServiceUsed._ext = None
    
    #-----< SwitchoverTime >-----#
    SwitchoverTime = SEQ(name='SwitchoverTime', mode=MODE_TYPE)
    _SwitchoverTime_hour = INT(name='hour', mode=MODE_TYPE)
    _SwitchoverTime_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    _SwitchoverTime_minute = INT(name='minute', mode=MODE_TYPE)
    _SwitchoverTime_minute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    _SwitchoverTime_second = INT(name='second', mode=MODE_TYPE)
    _SwitchoverTime_second._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    SwitchoverTime._cont = ASN1Dict([
        ('hour', _SwitchoverTime_hour),
        ('minute', _SwitchoverTime_minute),
        ('second', _SwitchoverTime_second),
        ])
    SwitchoverTime._ext = None
    
    #-----< TariffId >-----#
    TariffId = INT(name='TariffId', mode=MODE_TYPE)
    
    #-----< TariffPeriod >-----#
    TariffPeriod = SEQ(name='TariffPeriod', mode=MODE_TYPE)
    _TariffPeriod_switchoverTime = SEQ(name='switchoverTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SwitchoverTime')))
    _TariffPeriod_tariffId = INT(name='tariffId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TariffPeriod._cont = ASN1Dict([
        ('switchoverTime', _TariffPeriod_switchoverTime),
        ('tariffId', _TariffPeriod_tariffId),
        ])
    TariffPeriod._ext = None
    
    #-----< TariffPeriods >-----#
    TariffPeriods = SET_OF(name='TariffPeriods', mode=MODE_TYPE)
    _TariffPeriods__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'TariffPeriod')))
    TariffPeriods._cont = _TariffPeriods__item_
    
    #-----< TariffSystemStatus >-----#
    TariffSystemStatus = ENUM(name='TariffSystemStatus', mode=MODE_TYPE)
    TariffSystemStatus._cont = ASN1Dict([('available', 0), ('checked', 1), ('standby', 2), ('active', 3)])
    TariffSystemStatus._ext = None
    
    #-----< TrafficChannel >-----#
    TrafficChannel = ENUM(name='TrafficChannel', mode=MODE_TYPE)
    TrafficChannel._cont = ASN1Dict([('fullRate', 0), ('halfRate', 1)])
    TrafficChannel._ext = None
    
    #-----< TranslatedNumber >-----#
    TranslatedNumber = OCT_STR(name='TranslatedNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< TransparencyInd >-----#
    TransparencyInd = ENUM(name='TransparencyInd', mode=MODE_TYPE)
    TransparencyInd._cont = ASN1Dict([('transparent', 0), ('nonTransparent', 1)])
    TransparencyInd._ext = None
    
    #-----< TrunkGroup >-----#
    TrunkGroup = CHOICE(name='TrunkGroup', mode=MODE_TYPE)
    _TrunkGroup_tkgpNumber = INT(name='tkgpNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrunkGroup_tkgpName = STR_GRAPH(name='tkgpName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TrunkGroup._cont = ASN1Dict([
        ('tkgpNumber', _TrunkGroup_tkgpNumber),
        ('tkgpName', _TrunkGroup_tkgpName),
        ])
    TrunkGroup._ext = None
    
    #-----< TSChangeover >-----#
    TSChangeover = SEQ(name='TSChangeover', mode=MODE_TYPE)
    _TSChangeover_newActiveTS = INT(name='newActiveTS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSChangeover_newStandbyTS = INT(name='newStandbyTS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSChangeover_changeoverTime = TIME_GEN(name='changeoverTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TSChangeover_authkey = OCT_STR(name='authkey', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TSChangeover_checksum = OCT_STR(name='checksum', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TSChangeover_versionNumber = OCT_STR(name='versionNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TSChangeover._cont = ASN1Dict([
        ('newActiveTS', _TSChangeover_newActiveTS),
        ('newStandbyTS', _TSChangeover_newStandbyTS),
        ('changeoverTime', _TSChangeover_changeoverTime),
        ('authkey', _TSChangeover_authkey),
        ('checksum', _TSChangeover_checksum),
        ('versionNumber', _TSChangeover_versionNumber),
        ])
    TSChangeover._ext = None
    
    #-----< TSCheckError >-----#
    TSCheckError = SEQ(name='TSCheckError', mode=MODE_TYPE)
    _TSCheckError_errorId = CHOICE(name='errorId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TSCheckErrorId')))
    _TSCheckError_fail = ANY(name='fail', mode=MODE_TYPE, opt=True, defby='errorId')
    TSCheckError._cont = ASN1Dict([
        ('errorId', _TSCheckError_errorId),
        ('fail', _TSCheckError_fail),
        ])
    TSCheckError._ext = None
    
    #-----< TSCheckErrorId >-----#
    TSCheckErrorId = CHOICE(name='TSCheckErrorId', mode=MODE_TYPE)
    _TSCheckErrorId_globalForm = OID(name='globalForm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSCheckErrorId_localForm = INT(name='localForm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TSCheckErrorId._cont = ASN1Dict([
        ('globalForm', _TSCheckErrorId_globalForm),
        ('localForm', _TSCheckErrorId_localForm),
        ])
    TSCheckErrorId._ext = None
    
    #-----< TSCheckResult >-----#
    TSCheckResult = CHOICE(name='TSCheckResult', mode=MODE_TYPE)
    _TSCheckResult_success = NULL(name='success', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSCheckResult_fail = SET_OF(name='fail', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TSCheckResult_fail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'TSCheckError')))
    _TSCheckResult_fail._cont = __TSCheckResult_fail__item_
    TSCheckResult._cont = ASN1Dict([
        ('success', _TSCheckResult_success),
        ('fail', _TSCheckResult_fail),
        ])
    TSCheckResult._ext = None
    
    #-----< TSCopyTariffSystem >-----#
    TSCopyTariffSystem = SEQ(name='TSCopyTariffSystem', mode=MODE_TYPE)
    _TSCopyTariffSystem_oldTS = INT(name='oldTS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSCopyTariffSystem_newTS = INT(name='newTS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TSCopyTariffSystem._cont = ASN1Dict([
        ('oldTS', _TSCopyTariffSystem_oldTS),
        ('newTS', _TSCopyTariffSystem_newTS),
        ])
    TSCopyTariffSystem._ext = None
    
    #-----< TSNextChange >-----#
    TSNextChange = CHOICE(name='TSNextChange', mode=MODE_TYPE)
    _TSNextChange_noChangeover = NULL(name='noChangeover', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSNextChange_tsChangeover = SEQ(name='tsChangeover', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TSChangeover')))
    TSNextChange._cont = ASN1Dict([
        ('noChangeover', _TSNextChange_noChangeover),
        ('tsChangeover', _TSNextChange_tsChangeover),
        ])
    TSNextChange._ext = None
    
    #-----< TypeOfSubscribers >-----#
    TypeOfSubscribers = ENUM(name='TypeOfSubscribers', mode=MODE_TYPE)
    TypeOfSubscribers._cont = ASN1Dict([('home', 0), ('visiting', 1), ('all', 2)])
    TypeOfSubscribers._ext = None
    
    #-----< TypeOfTransaction >-----#
    TypeOfTransaction = ENUM(name='TypeOfTransaction', mode=MODE_TYPE)
    TypeOfTransaction._cont = ASN1Dict([('successful', 0), ('unsuccessful', 1), ('all', 2)])
    TypeOfTransaction._ext = None
    
    #-----< Visited-Location-info >-----#
    Visited_Location_info = SEQ(name='Visited-Location-info', mode=MODE_TYPE)
    _Visited_Location_info_mscNumber = OCT_STR(name='mscNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MscNo')))
    _Visited_Location_info_vlrNumber = OCT_STR(name='vlrNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'VlrNo')))
    Visited_Location_info._cont = ASN1Dict([
        ('mscNumber', _Visited_Location_info_mscNumber),
        ('vlrNumber', _Visited_Location_info_vlrNumber),
        ])
    Visited_Location_info._ext = None
    
    #-----< VlrNo >-----#
    VlrNo = OCT_STR(name='VlrNo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    _all_ = [
        _CSRecord_moCallRecord,
        _CSRecord_mtCallRecord,
        _CSRecord_roamingRecord,
        _CSRecord_incGatewayRecord,
        _CSRecord_outGatewayRecord,
        _CSRecord_transitRecord,
        _CSRecord_moSMSRecord,
        _CSRecord_mtSMSRecord,
        _CSRecord_moSMSIWRecord,
        _CSRecord_mtSMSGWRecord,
        _CSRecord_ssActionRecord,
        _CSRecord_hlrIntRecord,
        _CSRecord_locUpdateHLRRecord,
        _CSRecord_locUpdateVLRRecord,
        _CSRecord_commonEquipRecord,
        _CSRecord_recTypeExtensions,
        _CSRecord_termCAMELRecord,
        _CSRecord_mtLCSRecord,
        _CSRecord_moLCSRecord,
        _CSRecord_niLCSRecord,
        _CSRecord_mSCsRVCCRecord,
        _CSRecord_mMTRFRecord,
        _CSRecord_iCSRegisterRecord,
        CSRecord,
        _MOCallRecord_recordType,
        _MOCallRecord_servedIMSI,
        _MOCallRecord_servedIMEI,
        _MOCallRecord_servedMSISDN,
        _MOCallRecord_callingNumber,
        _MOCallRecord_calledNumber,
        _MOCallRecord_translatedNumber,
        _MOCallRecord_connectedNumber,
        _MOCallRecord_roamingNumber,
        _MOCallRecord_recordingEntity,
        _MOCallRecord_mscIncomingTKGP,
        _MOCallRecord_mscOutgoingTKGP,
        _MOCallRecord_location,
        __MOCallRecord_changeOfLocation__item_,
        _MOCallRecord_changeOfLocation,
        _MOCallRecord_basicService,
        _MOCallRecord_transparencyIndicator,
        __MOCallRecord_changeOfService__item_,
        _MOCallRecord_changeOfService,
        __MOCallRecord_supplServicesUsed__item_,
        _MOCallRecord_supplServicesUsed,
        _MOCallRecord_aocParameters,
        __MOCallRecord_changeOfAOCParms__item_,
        _MOCallRecord_changeOfAOCParms,
        _MOCallRecord_msClassmark,
        _MOCallRecord_changeOfClassmark,
        _MOCallRecord_seizureTime,
        _MOCallRecord_answerTime,
        _MOCallRecord_releaseTime,
        _MOCallRecord_callDuration,
        _MOCallRecord_dataVolume,
        _MOCallRecord_radioChanRequested,
        _MOCallRecord_radioChanUsed,
        _MOCallRecord_changeOfRadioChan,
        _MOCallRecord_causeForTerm,
        _MOCallRecord_diagnostics,
        _MOCallRecord_callReference,
        _MOCallRecord_sequenceNumber,
        _MOCallRecord_additionalChgInfo,
        _MOCallRecord_recordExtensions,
        _MOCallRecord_gsm_SCFAddress,
        _MOCallRecord_serviceKey,
        _MOCallRecord_networkCallReference,
        _MOCallRecord_mSCAddress,
        _MOCallRecord_cAMELInitCFIndicator,
        _MOCallRecord_defaultCallHandling,
        _MOCallRecord_hSCSDChanRequested,
        _MOCallRecord_hSCSDChanAllocated,
        __MOCallRecord_changeOfHSCSDParms__item_,
        _MOCallRecord_changeOfHSCSDParms,
        _MOCallRecord_fnur,
        _MOCallRecord_aiurRequested,
        __MOCallRecord_chanCodingsAcceptable__item_,
        _MOCallRecord_chanCodingsAcceptable,
        _MOCallRecord_chanCodingUsed,
        _MOCallRecord_speechVersionSupported,
        _MOCallRecord_speechVersionUsed,
        _MOCallRecord_numberOfDPEncountered,
        _MOCallRecord_levelOfCAMELService,
        _MOCallRecord_freeFormatData,
        __MOCallRecord_cAMELCallLegInformation__item_,
        _MOCallRecord_cAMELCallLegInformation,
        _MOCallRecord_freeFormatDataAppend,
        _MOCallRecord_defaultCallHandling_2,
        _MOCallRecord_gsm_SCFAddress_2,
        _MOCallRecord_serviceKey_2,
        _MOCallRecord_freeFormatData_2,
        _MOCallRecord_freeFormatDataAppend_2,
        _MOCallRecord_systemType,
        _MOCallRecord_rateIndication,
        _MOCallRecord_locationRoutNum,
        _MOCallRecord_lrnSoInd,
        _MOCallRecord_lrnQuryStatus,
        _MOCallRecord_jIPPara,
        _MOCallRecord_jIPSoInd,
        _MOCallRecord_jIPQuryStatus,
        _MOCallRecord_partialRecordType,
        _MOCallRecord_guaranteedBitRate,
        _MOCallRecord_maximumBitRate,
        _MOCallRecord_redial,
        _MOCallRecord_reasonForServiceChange,
        _MOCallRecord_serviceChangeInitiator,
        _MOCallRecord_iCSI2ActiveFlag,
        _MOCallRecord_iMS_Charging_Identifier,
        _MOCallRecord_privateUserID,
        MOCallRecord,
        _MTCallRecord_recordType,
        _MTCallRecord_servedIMSI,
        _MTCallRecord_servedIMEI,
        _MTCallRecord_servedMSISDN,
        _MTCallRecord_callingNumber,
        _MTCallRecord_connectedNumber,
        _MTCallRecord_recordingEntity,
        _MTCallRecord_mscIncomingTKGP,
        _MTCallRecord_mscOutgoingTKGP,
        _MTCallRecord_location,
        __MTCallRecord_changeOfLocation__item_,
        _MTCallRecord_changeOfLocation,
        _MTCallRecord_basicService,
        _MTCallRecord_transparencyIndicator,
        __MTCallRecord_changeOfService__item_,
        _MTCallRecord_changeOfService,
        __MTCallRecord_supplServicesUsed__item_,
        _MTCallRecord_supplServicesUsed,
        _MTCallRecord_aocParameters,
        __MTCallRecord_changeOfAOCParms__item_,
        _MTCallRecord_changeOfAOCParms,
        _MTCallRecord_msClassmark,
        _MTCallRecord_changeOfClassmark,
        _MTCallRecord_seizureTime,
        _MTCallRecord_answerTime,
        _MTCallRecord_releaseTime,
        _MTCallRecord_callDuration,
        _MTCallRecord_dataVolume,
        _MTCallRecord_radioChanRequested,
        _MTCallRecord_radioChanUsed,
        _MTCallRecord_changeOfRadioChan,
        _MTCallRecord_causeForTerm,
        _MTCallRecord_diagnostics,
        _MTCallRecord_callReference,
        _MTCallRecord_sequenceNumber,
        _MTCallRecord_additionalChgInfo,
        _MTCallRecord_recordExtensions,
        _MTCallRecord_networkCallReference,
        _MTCallRecord_mSCAddress,
        _MTCallRecord_hSCSDChanRequested,
        _MTCallRecord_hSCSDChanAllocated,
        __MTCallRecord_changeOfHSCSDParms__item_,
        _MTCallRecord_changeOfHSCSDParms,
        _MTCallRecord_fnur,
        _MTCallRecord_aiurRequested,
        __MTCallRecord_chanCodingsAcceptable__item_,
        _MTCallRecord_chanCodingsAcceptable,
        _MTCallRecord_chanCodingUsed,
        _MTCallRecord_speechVersionSupported,
        _MTCallRecord_speechVersionUsed,
        _MTCallRecord_gsm_SCFAddress,
        _MTCallRecord_serviceKey,
        _MTCallRecord_systemType,
        _MTCallRecord_rateIndication,
        _MTCallRecord_locationRoutNum,
        _MTCallRecord_lrnSoInd,
        _MTCallRecord_lrnQuryStatus,
        _MTCallRecord_jIPPara,
        _MTCallRecord_jIPSoInd,
        _MTCallRecord_jIPQuryStatus,
        _MTCallRecord_partialRecordType,
        _MTCallRecord_guaranteedBitRate,
        _MTCallRecord_maximumBitRate,
        _MTCallRecord_reasonForServiceChange,
        _MTCallRecord_serviceChangeInitiator,
        _MTCallRecord_iCSI2ActiveFlag,
        _MTCallRecord_iMS_Charging_Identifier,
        _MTCallRecord_privateUserID,
        MTCallRecord,
        _RoamingRecord_recordType,
        _RoamingRecord_servedIMSI,
        _RoamingRecord_servedMSISDN,
        _RoamingRecord_callingNumber,
        _RoamingRecord_roamingNumber,
        _RoamingRecord_recordingEntity,
        _RoamingRecord_mscIncomingTKGP,
        _RoamingRecord_mscOutgoingTKGP,
        _RoamingRecord_basicService,
        _RoamingRecord_transparencyIndicator,
        __RoamingRecord_changeOfService__item_,
        _RoamingRecord_changeOfService,
        __RoamingRecord_supplServicesUsed__item_,
        _RoamingRecord_supplServicesUsed,
        _RoamingRecord_seizureTime,
        _RoamingRecord_answerTime,
        _RoamingRecord_releaseTime,
        _RoamingRecord_callDuration,
        _RoamingRecord_dataVolume,
        _RoamingRecord_causeForTerm,
        _RoamingRecord_diagnostics,
        _RoamingRecord_callReference,
        _RoamingRecord_sequenceNumber,
        _RoamingRecord_recordExtensions,
        _RoamingRecord_networkCallReference,
        _RoamingRecord_mSCAddress,
        _RoamingRecord_locationRoutNum,
        _RoamingRecord_lrnSoInd,
        _RoamingRecord_lrnQuryStatus,
        _RoamingRecord_jIPPara,
        _RoamingRecord_jIPSoInd,
        _RoamingRecord_jIPQuryStatus,
        _RoamingRecord_partialRecordType,
        RoamingRecord,
        _TermCAMELRecord_recordtype,
        _TermCAMELRecord_servedIMSI,
        _TermCAMELRecord_servedMSISDN,
        _TermCAMELRecord_recordingEntity,
        _TermCAMELRecord_interrogationTime,
        _TermCAMELRecord_destinationRoutingAddress,
        _TermCAMELRecord_gsm_SCFAddress,
        _TermCAMELRecord_serviceKey,
        _TermCAMELRecord_networkCallReference,
        _TermCAMELRecord_mSCAddress,
        _TermCAMELRecord_defaultCallHandling,
        _TermCAMELRecord_recordExtensions,
        _TermCAMELRecord_calledNumber,
        _TermCAMELRecord_callingNumber,
        _TermCAMELRecord_mscIncomingTKGP,
        _TermCAMELRecord_mscOutgoingTKGP,
        _TermCAMELRecord_seizureTime,
        _TermCAMELRecord_answerTime,
        _TermCAMELRecord_releaseTime,
        _TermCAMELRecord_callDuration,
        _TermCAMELRecord_dataVolume,
        _TermCAMELRecord_causeForTerm,
        _TermCAMELRecord_diagnostics,
        _TermCAMELRecord_callReference,
        _TermCAMELRecord_sequenceNumber,
        _TermCAMELRecord_numberOfDPEncountered,
        _TermCAMELRecord_levelOfCAMELService,
        _TermCAMELRecord_freeFormatData,
        __TermCAMELRecord_cAMELCallLegInformation__item_,
        _TermCAMELRecord_cAMELCallLegInformation,
        _TermCAMELRecord_freeFormatDataAppend,
        _TermCAMELRecord_defaultCallHandling_2,
        _TermCAMELRecord_gsm_SCFAddress_2,
        _TermCAMELRecord_serviceKey_2,
        _TermCAMELRecord_freeFormatData_2,
        _TermCAMELRecord_freeFormatDataAppend_2,
        _TermCAMELRecord_mscServerIndication,
        _TermCAMELRecord_locationRoutNum,
        _TermCAMELRecord_lrnSoInd,
        _TermCAMELRecord_lrnQuryStatus,
        _TermCAMELRecord_jIPPara,
        _TermCAMELRecord_jIPSoInd,
        _TermCAMELRecord_jIPQuryStatus,
        _TermCAMELRecord_partialRecordType,
        TermCAMELRecord,
        _IncGatewayRecord_recordType,
        _IncGatewayRecord_callingNumber,
        _IncGatewayRecord_calledNumber,
        _IncGatewayRecord_recordingEntity,
        _IncGatewayRecord_mscIncomingTKGP,
        _IncGatewayRecord_mscOutgoingTKGP,
        _IncGatewayRecord_seizureTime,
        _IncGatewayRecord_answerTime,
        _IncGatewayRecord_releaseTime,
        _IncGatewayRecord_callDuration,
        _IncGatewayRecord_dataVolume,
        _IncGatewayRecord_causeForTerm,
        _IncGatewayRecord_diagnostics,
        _IncGatewayRecord_callReference,
        _IncGatewayRecord_sequenceNumber,
        _IncGatewayRecord_recordExtensions,
        _IncGatewayRecord_locationRoutNum,
        _IncGatewayRecord_lrnSoInd,
        _IncGatewayRecord_lrnQuryStatus,
        _IncGatewayRecord_jIPPara,
        _IncGatewayRecord_jIPSoInd,
        _IncGatewayRecord_jIPQuryStatus,
        _IncGatewayRecord_reasonForServiceChange,
        _IncGatewayRecord_serviceChangeInitiator,
        IncGatewayRecord,
        _OutGatewayRecord_recordType,
        _OutGatewayRecord_callingNumber,
        _OutGatewayRecord_calledNumber,
        _OutGatewayRecord_recordingEntity,
        _OutGatewayRecord_mscIncomingTKGP,
        _OutGatewayRecord_mscOutgoingTKGP,
        _OutGatewayRecord_seizureTime,
        _OutGatewayRecord_answerTime,
        _OutGatewayRecord_releaseTime,
        _OutGatewayRecord_callDuration,
        _OutGatewayRecord_dataVolume,
        _OutGatewayRecord_causeForTerm,
        _OutGatewayRecord_diagnostics,
        _OutGatewayRecord_callReference,
        _OutGatewayRecord_sequenceNumber,
        _OutGatewayRecord_recordExtensions,
        _OutGatewayRecord_locationRoutNum,
        _OutGatewayRecord_lrnSoInd,
        _OutGatewayRecord_lrnQuryStatus,
        _OutGatewayRecord_jIPPara,
        _OutGatewayRecord_jIPSoInd,
        _OutGatewayRecord_jIPQuryStatus,
        _OutGatewayRecord_reasonForServiceChange,
        _OutGatewayRecord_serviceChangeInitiator,
        OutGatewayRecord,
        _TransitCallRecord_recordType,
        _TransitCallRecord_recordingEntity,
        _TransitCallRecord_mscIncomingTKGP,
        _TransitCallRecord_mscOutgoingTKGP,
        _TransitCallRecord_callingNumber,
        _TransitCallRecord_calledNumber,
        _TransitCallRecord_isdnBasicService,
        _TransitCallRecord_seizureTimestamp,
        _TransitCallRecord_answerTimestamp,
        _TransitCallRecord_releaseTimestamp,
        _TransitCallRecord_callDuration,
        _TransitCallRecord_dataVolume,
        _TransitCallRecord_causeForTerm,
        _TransitCallRecord_diagnostics,
        _TransitCallRecord_callReference,
        _TransitCallRecord_sequenceNumber,
        _TransitCallRecord_recordExtensions,
        _TransitCallRecord_locationRoutNum,
        _TransitCallRecord_lrnSoInd,
        _TransitCallRecord_lrnQuryStatus,
        _TransitCallRecord_jIPPara,
        _TransitCallRecord_jIPSoInd,
        _TransitCallRecord_jIPQuryStatus,
        TransitCallRecord,
        _MOSMSRecord_recordType,
        _MOSMSRecord_servedIMSI,
        _MOSMSRecord_servedIMEI,
        _MOSMSRecord_servedMSISDN,
        _MOSMSRecord_msClassmark,
        _MOSMSRecord_serviceCentre,
        _MOSMSRecord_recordingEntity,
        _MOSMSRecord_location,
        _MOSMSRecord_messageReference,
        _MOSMSRecord_originationTime,
        _MOSMSRecord_smsResult,
        _MOSMSRecord_recordExtensions,
        _MOSMSRecord_destinationNumber,
        _MOSMSRecord_cAMELSMSInformation,
        _MOSMSRecord_systemType,
        _MOSMSRecord_locationExtension,
        MOSMSRecord,
        _MTSMSRecord_recordType,
        _MTSMSRecord_serviceCentre,
        _MTSMSRecord_servedIMSI,
        _MTSMSRecord_servedIMEI,
        _MTSMSRecord_servedMSISDN,
        _MTSMSRecord_msClassmark,
        _MTSMSRecord_recordingEntity,
        _MTSMSRecord_location,
        _MTSMSRecord_deliveryTime,
        _MTSMSRecord_smsResult,
        _MTSMSRecord_recordExtensions,
        _MTSMSRecord_systemType,
        _MTSMSRecord_cAMELSMSInformation,
        _MTSMSRecord_locationExtension,
        MTSMSRecord,
        _MOSMSIWRecord_recordType,
        _MOSMSIWRecord_serviceCentre,
        _MOSMSIWRecord_servedIMSI,
        _MOSMSIWRecord_recordingEntity,
        _MOSMSIWRecord_eventTime,
        _MOSMSIWRecord_smsResult,
        _MOSMSIWRecord_recordExtensions,
        MOSMSIWRecord,
        _MTSMSGWRecord_recordType,
        _MTSMSGWRecord_serviceCentre,
        _MTSMSGWRecord_servedIMSI,
        _MTSMSGWRecord_servedMSISDN,
        _MTSMSGWRecord_recordingEntity,
        _MTSMSGWRecord_eventTime,
        _MTSMSGWRecord_smsResult,
        _MTSMSGWRecord_recordExtensions,
        MTSMSGWRecord,
        _SSActionRecord_recordType,
        _SSActionRecord_servedIMSI,
        _SSActionRecord_servedIMEI,
        _SSActionRecord_servedMSISDN,
        _SSActionRecord_msClassmark,
        _SSActionRecord_recordingEntity,
        _SSActionRecord_location,
        _SSActionRecord_basicServices,
        _SSActionRecord_supplService,
        _SSActionRecord_ssAction,
        _SSActionRecord_ssActionTime,
        _SSActionRecord_ssParameters,
        _SSActionRecord_ssActionResult,
        _SSActionRecord_callReference,
        _SSActionRecord_recordExtensions,
        _SSActionRecord_systemType,
        SSActionRecord,
        _HLRIntRecord_recordType,
        _HLRIntRecord_servedIMSI,
        _HLRIntRecord_servedMSISDN,
        _HLRIntRecord_recordingEntity,
        _HLRIntRecord_basicService,
        _HLRIntRecord_routingNumber,
        _HLRIntRecord_interrogationTime,
        _HLRIntRecord_numberOfForwarding,
        _HLRIntRecord_interrogationResult,
        _HLRIntRecord_recordExtensions,
        HLRIntRecord,
        _LocUpdateHLRRecord_recordType,
        _LocUpdateHLRRecord_servedIMSI,
        _LocUpdateHLRRecord_recordingEntity,
        _LocUpdateHLRRecord_oldLocation,
        _LocUpdateHLRRecord_newLocation,
        _LocUpdateHLRRecord_updateTime,
        _LocUpdateHLRRecord_updateResult,
        _LocUpdateHLRRecord_recordExtensions,
        LocUpdateHLRRecord,
        _LocUpdateVLRRecord_recordType,
        _LocUpdateVLRRecord_servedIMSI,
        _LocUpdateVLRRecord_servedMSISDN,
        _LocUpdateVLRRecord_recordingEntity,
        _LocUpdateVLRRecord_oldLocation,
        _LocUpdateVLRRecord_newLocation,
        _LocUpdateVLRRecord_msClassmark,
        _LocUpdateVLRRecord_updateTime,
        _LocUpdateVLRRecord_updateResult,
        _LocUpdateVLRRecord_recordExtensions,
        _LocUpdateVLRRecord_locationExtension,
        LocUpdateVLRRecord,
        _CommonEquipRecord_recordType,
        _CommonEquipRecord_equipmentType,
        _CommonEquipRecord_equipmentId,
        _CommonEquipRecord_servedIMSI,
        _CommonEquipRecord_servedMSISDN,
        _CommonEquipRecord_recordingEntity,
        _CommonEquipRecord_basicService,
        __CommonEquipRecord_changeOfService__item_,
        _CommonEquipRecord_changeOfService,
        __CommonEquipRecord_supplServicesUsed__item_,
        _CommonEquipRecord_supplServicesUsed,
        _CommonEquipRecord_seizureTime,
        _CommonEquipRecord_releaseTime,
        _CommonEquipRecord_callDuration,
        _CommonEquipRecord_callReference,
        _CommonEquipRecord_sequenceNumber,
        _CommonEquipRecord_recordExtensions,
        _CommonEquipRecord_systemType,
        _CommonEquipRecord_rateIndication,
        _CommonEquipRecord_fnur,
        CommonEquipRecord,
        _ObservedIMEITicket_servedIMEI,
        _ObservedIMEITicket_imeiStatus,
        _ObservedIMEITicket_servedIMSI,
        _ObservedIMEITicket_servedMSISDN,
        _ObservedIMEITicket_recordingEntity,
        _ObservedIMEITicket_eventTime,
        _ObservedIMEITicket_location,
        _ObservedIMEITicket_imeiCheckEvent,
        _ObservedIMEITicket_callReference,
        _ObservedIMEITicket_recordExtensions,
        ObservedIMEITicket,
        _MTLCSRecord_recordType,
        _MTLCSRecord_recordingEntity,
        _MTLCSRecord_lcsClientType,
        _MTLCSRecord_lcsClientIdentity,
        _MTLCSRecord_servedIMSI,
        _MTLCSRecord_servedMSISDN,
        _MTLCSRecord_locationType,
        _MTLCSRecord_lcsQos,
        _MTLCSRecord_lcsPriority,
        _MTLCSRecord_mlc_Number,
        _MTLCSRecord_eventTimeStamp,
        _MTLCSRecord_measureDuration,
        _MTLCSRecord_notificationToMSUser,
        _MTLCSRecord_privacyOverride,
        _MTLCSRecord_location,
        _MTLCSRecord_locationEstimate,
        _MTLCSRecord_positioningData,
        _MTLCSRecord_lcsCause,
        _MTLCSRecord_diagnostics,
        _MTLCSRecord_systemType,
        _MTLCSRecord_recordExtensions,
        _MTLCSRecord_causeForTerm,
        _MTLCSRecord_servedIMEI,
        MTLCSRecord,
        _MOLCSRecord_recordType,
        _MOLCSRecord_recordingEntity,
        _MOLCSRecord_lcsClientType,
        _MOLCSRecord_lcsClientIdentity,
        _MOLCSRecord_servedIMSI,
        _MOLCSRecord_servedMSISDN,
        _MOLCSRecord_molr_Type,
        _MOLCSRecord_lcsQos,
        _MOLCSRecord_lcsPriority,
        _MOLCSRecord_mlc_Number,
        _MOLCSRecord_eventTimeStamp,
        _MOLCSRecord_measureDuration,
        _MOLCSRecord_location,
        _MOLCSRecord_locationEstimate,
        _MOLCSRecord_positioningData,
        _MOLCSRecord_lcsCause,
        _MOLCSRecord_diagnostics,
        _MOLCSRecord_systemType,
        _MOLCSRecord_recordExtensions,
        _MOLCSRecord_causeForTerm,
        MOLCSRecord,
        _NILCSRecord_recordType,
        _NILCSRecord_recordingEntity,
        _NILCSRecord_lcsClientType,
        _NILCSRecord_lcsClientIdentity,
        _NILCSRecord_servedIMSI,
        _NILCSRecord_servedMSISDN,
        _NILCSRecord_servedIMEI,
        _NILCSRecord_emsDigits,
        _NILCSRecord_emsKey,
        _NILCSRecord_lcsQos,
        _NILCSRecord_lcsPriority,
        _NILCSRecord_mlc_Number,
        _NILCSRecord_eventTimeStamp,
        _NILCSRecord_measureDuration,
        _NILCSRecord_location,
        _NILCSRecord_locationEstimate,
        _NILCSRecord_positioningData,
        _NILCSRecord_lcsCause,
        _NILCSRecord_diagnostics,
        _NILCSRecord_systemType,
        _NILCSRecord_recordExtensions,
        _NILCSRecord_causeForTerm,
        NILCSRecord,
        _MSCsRVCCRecord_recordType,
        _MSCsRVCCRecord_servedIMSI,
        _MSCsRVCCRecord_servedIMEI,
        _MSCsRVCCRecord_servedMSISDN,
        _MSCsRVCCRecord_calledNumber,
        _MSCsRVCCRecord_recordingEntity,
        _MSCsRVCCRecord_mscOutgoingTKGP,
        _MSCsRVCCRecord_location,
        __MSCsRVCCRecord_changeOfLocation__item_,
        _MSCsRVCCRecord_changeOfLocation,
        _MSCsRVCCRecord_basicService,
        __MSCsRVCCRecord_supplServicesUsed__item_,
        _MSCsRVCCRecord_supplServicesUsed,
        _MSCsRVCCRecord_msClassmark,
        _MSCsRVCCRecord_seizureTime,
        _MSCsRVCCRecord_answerTime,
        _MSCsRVCCRecord_releaseTime,
        _MSCsRVCCRecord_callDuration,
        _MSCsRVCCRecord_causeForTerm,
        _MSCsRVCCRecord_diagnostics,
        _MSCsRVCCRecord_callReference,
        _MSCsRVCCRecord_sequenceNumber,
        _MSCsRVCCRecord_recordExtensions,
        _MSCsRVCCRecord_partialRecordType,
        _MSCsRVCCRecord_iMS_Charging_Identifier,
        _MSCsRVCCRecord_iCSI2ActiveFlag,
        _MSCsRVCCRecord_relatedICID,
        _MSCsRVCCRecord_relatedICIDGenerationNode,
        MSCsRVCCRecord,
        _MTRFRecord_recordType,
        _MTRFRecord_servedIMSI,
        _MTRFRecord_servedIMEI,
        _MTRFRecord_servedMSISDN,
        _MTRFRecord_callingNumber,
        _MTRFRecord_roamingNumber,
        _MTRFRecord_recordingEntity,
        _MTRFRecord_mscIncomingTKGP,
        _MTRFRecord_mscOutgoingTKGP,
        _MTRFRecord_basicService,
        _MTRFRecord_seizureTime,
        _MTRFRecord_answerTime,
        _MTRFRecord_releaseTime,
        _MTRFRecord_callDuration,
        _MTRFRecord_causeForTerm,
        _MTRFRecord_diagnostics,
        _MTRFRecord_callReference,
        _MTRFRecord_sequenceNumber,
        _MTRFRecord_recordExtensions,
        _MTRFRecord_partialRecordType,
        MTRFRecord,
        _ICSregisterRecord_recordType,
        _ICSregisterRecord_servedIMSI,
        _ICSregisterRecord_servedMSISDN,
        _ICSregisterRecord_privateUserID,
        _ICSregisterRecord_recordingEntity,
        _ICSregisterRecord_newLocation,
        _ICSregisterRecord_locationExtension,
        _ICSregisterRecord_updateTime,
        _ICSregisterRecord_iMS_Charging_Identifier,
        _ICSregisterRecord_interOperatorIdentifiers,
        _ICSregisterRecord_transit_IOI_Lists,
        _ICSregisterRecord_updateResult,
        _ICSregisterRecord_recordExtensions,
        ICSregisterRecord,
        LocationRoutingNumber,
        LocationRoutingNumberSourceIndicator,
        LocationRoutingNumberQueryStatus,
        JurisdictionInformationParameter,
        JurisdictionInformationParameterSourceIndicator,
        JurisdictionInformationParameterQueryStatus,
        _AdditionalChgInfo_chargeIndicator,
        _AdditionalChgInfo_chargeParameters,
        AdditionalChgInfo,
        AiurRequested,
        _AOCParameters_e1,
        _AOCParameters_e2,
        _AOCParameters_e3,
        _AOCParameters_e4,
        _AOCParameters_e5,
        _AOCParameters_e6,
        _AOCParameters_e7,
        AOCParameters,
        _AOCParmChange_changeTime,
        _AOCParmChange_newParameters,
        AOCParmChange,
        _BasicServices__item_,
        BasicServices,
        CallingPartyCategory,
        CallType,
        _CallTypes__item_,
        CallTypes,
        CAMELDestinationNumber,
        _CAMELInformation_cAMELDestinationNumber,
        _CAMELInformation_connectedNumber,
        _CAMELInformation_roamingNumber,
        _CAMELInformation_mscOutgoingTKGP,
        _CAMELInformation_seizureTime,
        _CAMELInformation_answerTime,
        _CAMELInformation_releaseTime,
        _CAMELInformation_callDuration,
        _CAMELInformation_dataVolume,
        _CAMELInformation_cAMELInitCFIndicator,
        _CAMELInformation_causeForTerm,
        _CAMELInformation_cAMELModification,
        _CAMELInformation_freeFormatData,
        _CAMELInformation_diagnostics,
        _CAMELInformation_freeFormatDataAppend,
        _CAMELInformation_freeFormatData_2,
        _CAMELInformation_freeFormatDataAppend_2,
        CAMELInformation,
        CAMELInitCFIndicator,
        _CAMELModificationParameters_callingPartyNumber,
        _CAMELModificationParameters_callingPartyCategory,
        _CAMELModificationParameters_originalCalledPartyNumber,
        _CAMELModificationParameters_genericNumbers,
        _CAMELModificationParameters_redirectingPartyNumber,
        _CAMELModificationParameters_redirectionCounter,
        CAMELModificationParameters,
        _CAMELSMSInformation_gsm_SCFAddress,
        _CAMELSMSInformation_serviceKey,
        _CAMELSMSInformation_defaultSMSHandling,
        _CAMELSMSInformation_freeFormatData,
        _CAMELSMSInformation_callingPartyNumber,
        _CAMELSMSInformation_destinationSubscriberNumber,
        _CAMELSMSInformation_cAMELSMSCAddress,
        _CAMELSMSInformation_smsReferenceNumber,
        CAMELSMSInformation,
        Category,
        _ChangedParameters_changeFlags,
        _ChangedParameters_changeList,
        ChangedParameters,
        ChangeFlags,
        _ChangeOfClassmark_classmark,
        _ChangeOfClassmark_changeTime,
        ChangeOfClassmark,
        _ChangeOfRadioChannel_radioChannel,
        _ChangeOfRadioChannel_changeTime,
        _ChangeOfRadioChannel_speechVersionUsed,
        ChangeOfRadioChannel,
        _ChangeOfService_basicService,
        _ChangeOfService_transparencyInd,
        _ChangeOfService_changeTime,
        _ChangeOfService_rateIndication,
        _ChangeOfService_fnur,
        ChangeOfService,
        ChannelCoding,
        Classmark,
        ConnectedNumber,
        DataVolume,
        Day,
        DayClass,
        _DayClasses__item_,
        DayClasses,
        _DayDefinition_day,
        _DayDefinition_dayClass,
        DayDefinition,
        _DayDefinitions__item_,
        DayDefinitions,
        _DateDefinition_month,
        _DateDefinition_day,
        _DateDefinition_dayClass,
        DateDefinition,
        _DateDefinitions__item_,
        DateDefinitions,
        DayOfTheWeek,
        _Destinations__item_,
        Destinations,
        EmergencyCallIndEnable,
        _EmergencyCallIndication_cellId,
        _EmergencyCallIndication_callerId,
        EmergencyCallIndication,
        EParameter,
        EquipmentId,
        EquipmentType,
        FileType,
        Fnur,
        ForwardToNumber,
        FreeFormatData,
        GenericNumber,
        _GenericNumbers__item_,
        GenericNumbers,
        Gsm_SCFAddress,
        GuaranteedBitRate,
        HLRIntResult,
        _HSCSDParmsChange_changeTime,
        _HSCSDParmsChange_hSCSDChanAllocated,
        _HSCSDParmsChange_initiatingParty,
        _HSCSDParmsChange_aiurRequested,
        _HSCSDParmsChange_chanCodingUsed,
        _HSCSDParmsChange_hSCSDChanRequested,
        HSCSDParmsChange,
        IMEICheckEvent,
        IMEIStatus,
        _IMSIorIMEI_imsi,
        _IMSIorIMEI_imei,
        IMSIorIMEI,
        InitiatingParty,
        LocationCellExtension,
        _LocationChange_location,
        _LocationChange_changeTime,
        LocationChange,
        _Location_info_mscNumber,
        _Location_info_location_area,
        _Location_info_cell_identification,
        _Location_info_mCC_MNC,
        Location_info,
        LocUpdResult,
        MaximumBitRate,
        Month,
        _MSPowerClasses__item_,
        MSPowerClasses,
        NetworkCallReference,
        NetworkSpecificCode,
        _NetworkSpecificServices__item_,
        NetworkSpecificServices,
        NumOfHSCSDChanRequested,
        NumOfHSCSDChanAllocated,
        ObservedIMEITicketEnable,
        OriginalCalledNumber,
        _OriginDestCombinations__item_,
        OriginDestCombinations,
        _OriginDestCombination_origin,
        _OriginDestCombination_destination,
        OriginDestCombination,
        PartialRecordTimer,
        PartialRecordType,
        _PartialRecordTypes__item_,
        PartialRecordTypes,
        _RadioChannelsRequested__item_,
        RadioChannelsRequested,
        RadioChanRequested,
        RateIndication,
        ReasonForServiceChange,
        _RecordClassDestination_osApplication,
        _RecordClassDestination_fileType,
        RecordClassDestination,
        _RecordClassDestinations__item_,
        RecordClassDestinations,
        RecordingMethod,
        RedirectingNumber,
        RFPowerCapability,
        RoamingNumber,
        _RoutingNumber_roaming,
        _RoutingNumber_forwarded,
        RoutingNumber,
        _Service_teleservice,
        _Service_bearerService,
        _Service_supplementaryService,
        _Service_networkSpecificService,
        Service,
        _ServiceDistanceDependencies__item_,
        ServiceDistanceDependencies,
        _ServiceDistanceDependency_aocService,
        _ServiceDistanceDependency_chargingZone,
        ServiceDistanceDependency,
        SimpleIntegerName,
        SimpleStringName,
        SpeechVersionIdentifier,
        SSActionResult,
        SSActionType,
        _SSParameters_forwardedToNumber,
        _SSParameters_unstructuredData,
        SSParameters,
        _SupplServices__item_,
        SupplServices,
        _SuppServiceUsed_ssCode,
        _SuppServiceUsed_ssTime,
        SuppServiceUsed,
        _SwitchoverTime_hour,
        _SwitchoverTime_minute,
        _SwitchoverTime_second,
        SwitchoverTime,
        TariffId,
        _TariffPeriod_switchoverTime,
        _TariffPeriod_tariffId,
        TariffPeriod,
        _TariffPeriods__item_,
        TariffPeriods,
        TariffSystemStatus,
        TrafficChannel,
        TranslatedNumber,
        TransparencyInd,
        _TrunkGroup_tkgpNumber,
        _TrunkGroup_tkgpName,
        TrunkGroup,
        _TSChangeover_newActiveTS,
        _TSChangeover_newStandbyTS,
        _TSChangeover_changeoverTime,
        _TSChangeover_authkey,
        _TSChangeover_checksum,
        _TSChangeover_versionNumber,
        TSChangeover,
        _TSCheckError_errorId,
        _TSCheckError_fail,
        TSCheckError,
        _TSCheckErrorId_globalForm,
        _TSCheckErrorId_localForm,
        TSCheckErrorId,
        _TSCheckResult_success,
        __TSCheckResult_fail__item_,
        _TSCheckResult_fail,
        TSCheckResult,
        _TSCopyTariffSystem_oldTS,
        _TSCopyTariffSystem_newTS,
        TSCopyTariffSystem,
        _TSNextChange_noChangeover,
        _TSNextChange_tsChangeover,
        TSNextChange,
        TypeOfSubscribers,
        TypeOfTransaction,
        _Visited_Location_info_mscNumber,
        _Visited_Location_info_vlrNumber,
        Visited_Location_info,
        VlrNo,
    ]

class DialoguePDUs:

    _name_  = 'DialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 2, 1]
    
    _obj_ = [
        'dialogue-as-id',
        'DialoguePDU',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-source',
        'Associate-result',
        'Associate-source-diagnostic',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _type_ = [
        'DialoguePDU',
        'AARQ-apdu',
        'AARE-apdu',
        'RLRQ-apdu',
        'RLRE-apdu',
        'ABRT-apdu',
        'ABRT-source',
        'Associate-result',
        'Associate-source-diagnostic',
        'Release-request-reason',
        'Release-response-reason',
        ]
    _set_ = [
        ]
    _val_ = [
        'dialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< dialogue-as-id >-----#
    dialogue_as_id = OID(name='dialogue-as-id', mode=MODE_VALUE)
    dialogue_as_id._val = (0, 0, 17, 773, 1, 1, 1)
    
    #-----< DialoguePDU >-----#
    DialoguePDU = CHOICE(name='DialoguePDU', mode=MODE_TYPE)
    _DialoguePDU_dialogueRequest = SEQ(name='dialogueRequest', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARQ-apdu')))
    _DialoguePDU_dialogueResponse = SEQ(name='dialogueResponse', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARE-apdu')))
    _DialoguePDU_dialogueAbort = SEQ(name='dialogueAbort', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'ABRT-apdu')))
    DialoguePDU._cont = ASN1Dict([
        ('dialogueRequest', _DialoguePDU_dialogueRequest),
        ('dialogueResponse', _DialoguePDU_dialogueResponse),
        ('dialogueAbort', _DialoguePDU_dialogueAbort),
        ])
    DialoguePDU._ext = None
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name='AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AARQ_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARQ_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARQ_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARQ_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AARQ_apdu_user_information._cont = __AARQ_apdu_user_information__item_
    AARQ_apdu._cont = ASN1Dict([
        ('protocol-version', _AARQ_apdu_protocol_version),
        ('application-context-name', _AARQ_apdu_application_context_name),
        ('user-information', _AARQ_apdu_user_information),
        ])
    AARQ_apdu._ext = None
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name='AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _AARE_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARE_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AARE_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARE_apdu_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-result')))
    _AARE_apdu_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-source-diagnostic')))
    _AARE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARE_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AARE_apdu_user_information._cont = __AARE_apdu_user_information__item_
    AARE_apdu._cont = ASN1Dict([
        ('protocol-version', _AARE_apdu_protocol_version),
        ('application-context-name', _AARE_apdu_application_context_name),
        ('result', _AARE_apdu_result),
        ('result-source-diagnostic', _AARE_apdu_result_source_diagnostic),
        ('user-information', _AARE_apdu_user_information),
        ])
    AARE_apdu._ext = None
    
    #-----< RLRQ-apdu >-----#
    RLRQ_apdu = SEQ(name='RLRQ-apdu', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRQ_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-request-reason')), opt=True)
    _RLRQ_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRQ_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RLRQ_apdu_user_information._cont = __RLRQ_apdu_user_information__item_
    RLRQ_apdu._cont = ASN1Dict([
        ('reason', _RLRQ_apdu_reason),
        ('user-information', _RLRQ_apdu_user_information),
        ])
    RLRQ_apdu._ext = None
    
    #-----< RLRE-apdu >-----#
    RLRE_apdu = SEQ(name='RLRE-apdu', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRE_apdu_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-response-reason')), opt=True)
    _RLRE_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRE_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RLRE_apdu_user_information._cont = __RLRE_apdu_user_information__item_
    RLRE_apdu._cont = ASN1Dict([
        ('reason', _RLRE_apdu_reason),
        ('user-information', _RLRE_apdu_user_information),
        ])
    RLRE_apdu._ext = None
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name='ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name='abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'ABRT-source')))
    _ABRT_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ABRT_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _ABRT_apdu_user_information._cont = __ABRT_apdu_user_information__item_
    ABRT_apdu._cont = ASN1Dict([
        ('abort-source', _ABRT_apdu_abort_source),
        ('user-information', _ABRT_apdu_user_information),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name='ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([('dialogue-service-user', 0), ('dialogue-service-provider', 1)])
    
    #-----< Associate-result >-----#
    Associate_result = INT(name='Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([('accepted', 0), ('reject-permanent', 1)])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name='Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_dialogue_service_user = INT(name='dialogue-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_user._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('application-context-name-not-supported', 2)])
    _Associate_source_diagnostic_dialogue_service_provider = INT(name='dialogue-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_provider._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('no-common-dialogue-portion', 2)])
    Associate_source_diagnostic._cont = ASN1Dict([
        ('dialogue-service-user', _Associate_source_diagnostic_dialogue_service_user),
        ('dialogue-service-provider', _Associate_source_diagnostic_dialogue_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name='Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([('normal', 0), ('urgent', 1), ('user-defined', 30)])
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name='Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([('normal', 0), ('not-finished', 1), ('user-defined', 30)])
    
    _all_ = [
        dialogue_as_id,
        _DialoguePDU_dialogueRequest,
        _DialoguePDU_dialogueResponse,
        _DialoguePDU_dialogueAbort,
        DialoguePDU,
        _AARQ_apdu_protocol_version,
        _AARQ_apdu_application_context_name,
        __AARQ_apdu_user_information__item_,
        _AARQ_apdu_user_information,
        AARQ_apdu,
        _AARE_apdu_protocol_version,
        _AARE_apdu_application_context_name,
        _AARE_apdu_result,
        _AARE_apdu_result_source_diagnostic,
        __AARE_apdu_user_information__item_,
        _AARE_apdu_user_information,
        AARE_apdu,
        _RLRQ_apdu_reason,
        __RLRQ_apdu_user_information__item_,
        _RLRQ_apdu_user_information,
        RLRQ_apdu,
        _RLRE_apdu_reason,
        __RLRE_apdu_user_information__item_,
        _RLRE_apdu_user_information,
        RLRE_apdu,
        _ABRT_apdu_abort_source,
        __ABRT_apdu_user_information__item_,
        _ABRT_apdu_user_information,
        ABRT_apdu,
        ABRT_source,
        Associate_result,
        _Associate_source_diagnostic_dialogue_service_user,
        _Associate_source_diagnostic_dialogue_service_provider,
        Associate_source_diagnostic,
        Release_request_reason,
        Release_response_reason,
    ]

class DirectoryAbstractService:

    _name_  = 'DirectoryAbstractService'
    _oid_   = [2, 5, 1, 2, 8]
    
    _obj_ = [
        'CommonArguments',
        'CommonArgumentsSeq',
        'FamilyGrouping',
        'CommonResults',
        'CommonResultsSeq',
        'ServiceControls',
        'ServiceControlOptions',
        'EntryInformationSelection',
        'ContextSelection',
        'TypeAndContextAssertion',
        'FamilyReturn',
        'EntryInformation',
        'family-information',
        'FamilyEntries',
        'FamilyEntry',
        'Filter',
        'FilterItem',
        'MatchingRuleAssertion',
        'PagedResultsRequest',
        'SortKey',
        'SecurityParameters',
        'ProtectionRequest',
        'Time',
        'ErrorProtectionRequest',
        'directoryBind',
        'DirectoryBindArgument',
        'Credentials',
        'SimpleCredentials',
        'StrongCredentials',
        'SpkmCredentials',
        'SaslCredentials',
        'ub-saslMechanism',
        'Token',
        'TokenContent',
        'Versions',
        'DirectoryBindResult',
        'PwdResponseValue',
        'directoryBindError',
        'BindKeyInfo',
        'read',
        'ReadArgument',
        'ReadArgumentData',
        'ReadResult',
        'ReadResultData',
        'ModifyRights',
        'compare',
        'CompareArgument',
        'CompareArgumentData',
        'CompareResult',
        'CompareResultData',
        'abandon',
        'AbandonArgument',
        'AbandonArgumentData',
        'AbandonResult',
        'AbandonResultData',
        'list',
        'ListArgument',
        'ListArgumentData',
        'ListResult',
        'ListResultData',
        'PartialOutcomeQualifier',
        'LimitProblem',
        'search',
        'SearchArgument',
        'SearchArgumentData',
        'HierarchySelections',
        'SearchControlOptions',
        'JoinArgument',
        'DomainLocalID',
        'JoinAttPair',
        'JoinContextType',
        'SearchResult',
        'SearchResultData',
        'addEntry',
        'AddEntryArgument',
        'AddEntryArgumentData',
        'AddEntryResult',
        'AddEntryResultData',
        'removeEntry',
        'RemoveEntryArgument',
        'RemoveEntryArgumentData',
        'RemoveEntryResult',
        'RemoveEntryResultData',
        'modifyEntry',
        'ModifyEntryArgument',
        'ModifyEntryArgumentData',
        'ModifyEntryResult',
        'ModifyEntryResultData',
        'EntryModification',
        'modifyDN',
        'ModifyDNArgument',
        'ModifyDNArgumentData',
        'ModifyDNResult',
        'ModifyDNResultData',
        'changePassword',
        'ChangePasswordArgument',
        'ChangePasswordArgumentData',
        'ChangePasswordResult',
        'ChangePasswordResultData',
        'administerPassword',
        'AdministerPasswordArgument',
        'AdministerPasswordArgumentData',
        'AdministerPasswordResult',
        'AdministerPasswordResultData',
        'ldapTransport',
        'LdapArgument',
        'LdapArgumentData',
        'LinkId',
        'LdapResult',
        'LdapResultData',
        'linkedLDAP',
        'LinkedArgument',
        'LinkedArgumentData',
        'LinkedResult',
        'abandoned',
        'AbandonedData',
        'AbandonedProblem',
        'abandonFailed',
        'AbandonFailedData',
        'AbandonProblem',
        'attributeError',
        'AttributeErrorData',
        'AttributeProblem',
        'nameError',
        'NameErrorData',
        'NameProblem',
        'referral',
        'ReferralData',
        'securityError',
        'SecurityErrorData',
        'SecurityProblem',
        'EncPwdInfo',
        'serviceError',
        'ServiceErrorData',
        'ServiceProblem',
        'updateError',
        'UpdateErrorData',
        'UpdateProblem',
        'id-at-family-information',
        ]
    _type_ = [
        'CommonArguments',
        'CommonArgumentsSeq',
        'FamilyGrouping',
        'CommonResults',
        'CommonResultsSeq',
        'ServiceControls',
        'ServiceControlOptions',
        'EntryInformationSelection',
        'ContextSelection',
        'TypeAndContextAssertion',
        'FamilyReturn',
        'EntryInformation',
        'FamilyEntries',
        'FamilyEntry',
        'Filter',
        'FilterItem',
        'MatchingRuleAssertion',
        'PagedResultsRequest',
        'SortKey',
        'SecurityParameters',
        'ProtectionRequest',
        'Time',
        'ErrorProtectionRequest',
        'DirectoryBindArgument',
        'Credentials',
        'SimpleCredentials',
        'StrongCredentials',
        'SpkmCredentials',
        'SaslCredentials',
        'Token',
        'TokenContent',
        'Versions',
        'DirectoryBindResult',
        'PwdResponseValue',
        'BindKeyInfo',
        'ReadArgument',
        'ReadArgumentData',
        'ReadResult',
        'ReadResultData',
        'ModifyRights',
        'CompareArgument',
        'CompareArgumentData',
        'CompareResult',
        'CompareResultData',
        'AbandonArgument',
        'AbandonArgumentData',
        'AbandonResult',
        'AbandonResultData',
        'ListArgument',
        'ListArgumentData',
        'ListResult',
        'ListResultData',
        'PartialOutcomeQualifier',
        'LimitProblem',
        'SearchArgument',
        'SearchArgumentData',
        'HierarchySelections',
        'SearchControlOptions',
        'JoinArgument',
        'DomainLocalID',
        'JoinAttPair',
        'JoinContextType',
        'SearchResult',
        'SearchResultData',
        'AddEntryArgument',
        'AddEntryArgumentData',
        'AddEntryResult',
        'AddEntryResultData',
        'RemoveEntryArgument',
        'RemoveEntryArgumentData',
        'RemoveEntryResult',
        'RemoveEntryResultData',
        'ModifyEntryArgument',
        'ModifyEntryArgumentData',
        'ModifyEntryResult',
        'ModifyEntryResultData',
        'EntryModification',
        'ModifyDNArgument',
        'ModifyDNArgumentData',
        'ModifyDNResult',
        'ModifyDNResultData',
        'ChangePasswordArgument',
        'ChangePasswordArgumentData',
        'ChangePasswordResult',
        'ChangePasswordResultData',
        'AdministerPasswordArgument',
        'AdministerPasswordArgumentData',
        'AdministerPasswordResult',
        'AdministerPasswordResultData',
        'LdapArgument',
        'LdapArgumentData',
        'LinkId',
        'LdapResult',
        'LdapResultData',
        'LinkedArgument',
        'LinkedArgumentData',
        'LinkedResult',
        'AbandonedData',
        'AbandonedProblem',
        'AbandonFailedData',
        'AbandonProblem',
        'AttributeErrorData',
        'AttributeProblem',
        'NameErrorData',
        'NameProblem',
        'ReferralData',
        'SecurityErrorData',
        'SecurityProblem',
        'EncPwdInfo',
        'ServiceErrorData',
        'ServiceProblem',
        'UpdateErrorData',
        'UpdateProblem',
        ]
    _set_ = [
        ]
    _val_ = [
        'family-information',
        'directoryBind',
        'ub-saslMechanism',
        'directoryBindError',
        'read',
        'compare',
        'abandon',
        'list',
        'search',
        'addEntry',
        'removeEntry',
        'modifyEntry',
        'modifyDN',
        'changePassword',
        'administerPassword',
        'ldapTransport',
        'linkedLDAP',
        'abandoned',
        'abandonFailed',
        'attributeError',
        'nameError',
        'referral',
        'securityError',
        'serviceError',
        'updateError',
        'id-at-family-information',
        ]
    _class_ = [
        'family-information',
        'directoryBind',
        'directoryBindError',
        'read',
        'compare',
        'abandon',
        'list',
        'search',
        'addEntry',
        'removeEntry',
        'modifyEntry',
        'modifyDN',
        'changePassword',
        'administerPassword',
        'ldapTransport',
        'linkedLDAP',
        'abandoned',
        'abandonFailed',
        'attributeError',
        'nameError',
        'referral',
        'securityError',
        'serviceError',
        'updateError',
        ]
    _param_ = [
        ]
    
    #-----< CommonArguments >-----#
    CommonArguments = SET(name='CommonArguments', mode=MODE_TYPE)
    _CommonArguments_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CommonArguments_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonArguments_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonArguments_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _CommonArguments_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArguments_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArguments_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CommonArguments_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CommonArguments_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CommonArguments_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonArguments_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CommonArguments_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    CommonArguments._cont = ASN1Dict([
        ('serviceControls', _CommonArguments_serviceControls),
        ('securityParameters', _CommonArguments_securityParameters),
        ('requestor', _CommonArguments_requestor),
        ('operationProgress', _CommonArguments_operationProgress),
        ('aliasedRDNs', _CommonArguments_aliasedRDNs),
        ('criticalExtensions', _CommonArguments_criticalExtensions),
        ('referenceType', _CommonArguments_referenceType),
        ('entryOnly', _CommonArguments_entryOnly),
        ('exclusions', _CommonArguments_exclusions),
        ('nameResolveOnMaster', _CommonArguments_nameResolveOnMaster),
        ('operationContexts', _CommonArguments_operationContexts),
        ('familyGrouping', _CommonArguments_familyGrouping),
        ])
    CommonArguments._ext = []
    
    #-----< CommonArgumentsSeq >-----#
    CommonArgumentsSeq = SEQ(name='CommonArgumentsSeq', mode=MODE_TYPE)
    _CommonArgumentsSeq_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CommonArgumentsSeq_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonArgumentsSeq_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonArgumentsSeq_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _CommonArgumentsSeq_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArgumentsSeq_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArgumentsSeq_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CommonArgumentsSeq_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CommonArgumentsSeq_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CommonArgumentsSeq_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonArgumentsSeq_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CommonArgumentsSeq_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    CommonArgumentsSeq._cont = ASN1Dict([
        ('serviceControls', _CommonArgumentsSeq_serviceControls),
        ('securityParameters', _CommonArgumentsSeq_securityParameters),
        ('requestor', _CommonArgumentsSeq_requestor),
        ('operationProgress', _CommonArgumentsSeq_operationProgress),
        ('aliasedRDNs', _CommonArgumentsSeq_aliasedRDNs),
        ('criticalExtensions', _CommonArgumentsSeq_criticalExtensions),
        ('referenceType', _CommonArgumentsSeq_referenceType),
        ('entryOnly', _CommonArgumentsSeq_entryOnly),
        ('exclusions', _CommonArgumentsSeq_exclusions),
        ('nameResolveOnMaster', _CommonArgumentsSeq_nameResolveOnMaster),
        ('operationContexts', _CommonArgumentsSeq_operationContexts),
        ('familyGrouping', _CommonArgumentsSeq_familyGrouping),
        ])
    CommonArgumentsSeq._ext = []
    
    #-----< FamilyGrouping >-----#
    FamilyGrouping = ENUM(name='FamilyGrouping', mode=MODE_TYPE)
    FamilyGrouping._cont = ASN1Dict([('entryOnly', 1), ('compoundEntry', 2), ('strands', 3), ('multiStrand', 4)])
    FamilyGrouping._ext = []
    
    #-----< CommonResults >-----#
    CommonResults = SET(name='CommonResults', mode=MODE_TYPE)
    _CommonResults_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonResults_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonResults_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonResults_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CommonResults_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CommonResults_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CommonResults_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CommonResults_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____CommonResults_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CommonResults_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CommonResults_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CommonResults_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CommonResults_notification__item__type._const_tab = ____CommonResults_notification__item__type_tab
    ___CommonResults_notification__item__type._const_tab_at = None
    ___CommonResults_notification__item__type._const_tab_id = 'id'
    ___CommonResults_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CommonResults_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CommonResults_notification__item__values__item_._const_tab = ____CommonResults_notification__item__type_tab
    ____CommonResults_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CommonResults_notification__item__values__item_._const_tab_id = 'Type'
    ___CommonResults_notification__item__values._cont = ____CommonResults_notification__item__values__item_
    ___CommonResults_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CommonResults_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CommonResults_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CommonResults_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab = ____CommonResults_notification__item__type_tab
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CommonResults_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CommonResults_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CommonResults_notification__item__valuesWithContext__item__contextList._cont = ______CommonResults_notification__item__valuesWithContext__item__contextList__item_
    _____CommonResults_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CommonResults_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CommonResults_notification__item__valuesWithContext__item__value),
        ('contextList', _____CommonResults_notification__item__valuesWithContext__item__contextList),
        ])
    ____CommonResults_notification__item__valuesWithContext__item_._ext = []
    ___CommonResults_notification__item__valuesWithContext._cont = ____CommonResults_notification__item__valuesWithContext__item_
    ___CommonResults_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CommonResults_notification__item_._cont = ASN1Dict([
        ('type', ___CommonResults_notification__item__type),
        ('values', ___CommonResults_notification__item__values),
        ('valuesWithContext', ___CommonResults_notification__item__valuesWithContext),
        ])
    __CommonResults_notification__item_._ext = []
    _CommonResults_notification._cont = __CommonResults_notification__item_
    _CommonResults_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CommonResults._cont = ASN1Dict([
        ('securityParameters', _CommonResults_securityParameters),
        ('performer', _CommonResults_performer),
        ('aliasDereferenced', _CommonResults_aliasDereferenced),
        ('notification', _CommonResults_notification),
        ])
    CommonResults._ext = []
    
    #-----< CommonResultsSeq >-----#
    CommonResultsSeq = SEQ(name='CommonResultsSeq', mode=MODE_TYPE)
    _CommonResultsSeq_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonResultsSeq_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonResultsSeq_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonResultsSeq_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CommonResultsSeq_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CommonResultsSeq_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CommonResultsSeq_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CommonResultsSeq_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____CommonResultsSeq_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CommonResultsSeq_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CommonResultsSeq_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CommonResultsSeq_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CommonResultsSeq_notification__item__type._const_tab = ____CommonResultsSeq_notification__item__type_tab
    ___CommonResultsSeq_notification__item__type._const_tab_at = None
    ___CommonResultsSeq_notification__item__type._const_tab_id = 'id'
    ___CommonResultsSeq_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CommonResultsSeq_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CommonResultsSeq_notification__item__values__item_._const_tab = ____CommonResultsSeq_notification__item__type_tab
    ____CommonResultsSeq_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CommonResultsSeq_notification__item__values__item_._const_tab_id = 'Type'
    ___CommonResultsSeq_notification__item__values._cont = ____CommonResultsSeq_notification__item__values__item_
    ___CommonResultsSeq_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CommonResultsSeq_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CommonResultsSeq_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab = ____CommonResultsSeq_notification__item__type_tab
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList._cont = ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CommonResultsSeq_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CommonResultsSeq_notification__item__valuesWithContext__item__value),
        ('contextList', _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList),
        ])
    ____CommonResultsSeq_notification__item__valuesWithContext__item_._ext = []
    ___CommonResultsSeq_notification__item__valuesWithContext._cont = ____CommonResultsSeq_notification__item__valuesWithContext__item_
    ___CommonResultsSeq_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CommonResultsSeq_notification__item_._cont = ASN1Dict([
        ('type', ___CommonResultsSeq_notification__item__type),
        ('values', ___CommonResultsSeq_notification__item__values),
        ('valuesWithContext', ___CommonResultsSeq_notification__item__valuesWithContext),
        ])
    __CommonResultsSeq_notification__item_._ext = []
    _CommonResultsSeq_notification._cont = __CommonResultsSeq_notification__item_
    _CommonResultsSeq_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CommonResultsSeq._cont = ASN1Dict([
        ('securityParameters', _CommonResultsSeq_securityParameters),
        ('performer', _CommonResultsSeq_performer),
        ('aliasDereferenced', _CommonResultsSeq_aliasDereferenced),
        ('notification', _CommonResultsSeq_notification),
        ])
    CommonResultsSeq._ext = []
    
    #-----< ServiceControls >-----#
    ServiceControls = SET(name='ServiceControls', mode=MODE_TYPE)
    _ServiceControls_options = BIT_STR(name='options', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')), default=(0, 0))
    _ServiceControls_priority = INT(name='priority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _ServiceControls_priority._cont = ASN1Dict([('low', 0), ('medium', 1), ('high', 2)])
    _ServiceControls_timeLimit = INT(name='timeLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_sizeLimit = INT(name='sizeLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_scopeOfReferral = INT(name='scopeOfReferral', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_scopeOfReferral._cont = ASN1Dict([('dmd', 0), ('country', 1)])
    _ServiceControls_attributeSizeLimit = INT(name='attributeSizeLimit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_manageDSAITPlaneRef = SEQ(name='manageDSAITPlaneRef', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ServiceControls_manageDSAITPlaneRef_dsaName = CHOICE(name='dsaName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    __ServiceControls_manageDSAITPlaneRef_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _ServiceControls_manageDSAITPlaneRef._cont = ASN1Dict([
        ('dsaName', __ServiceControls_manageDSAITPlaneRef_dsaName),
        ('agreementID', __ServiceControls_manageDSAITPlaneRef_agreementID),
        ])
    _ServiceControls_manageDSAITPlaneRef._ext = []
    _ServiceControls_serviceType = OID(name='serviceType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_userClass = INT(name='userClass', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ServiceControls._cont = ASN1Dict([
        ('options', _ServiceControls_options),
        ('priority', _ServiceControls_priority),
        ('timeLimit', _ServiceControls_timeLimit),
        ('sizeLimit', _ServiceControls_sizeLimit),
        ('scopeOfReferral', _ServiceControls_scopeOfReferral),
        ('attributeSizeLimit', _ServiceControls_attributeSizeLimit),
        ('manageDSAITPlaneRef', _ServiceControls_manageDSAITPlaneRef),
        ('serviceType', _ServiceControls_serviceType),
        ('userClass', _ServiceControls_userClass),
        ])
    ServiceControls._ext = []
    
    #-----< ServiceControlOptions >-----#
    ServiceControlOptions = BIT_STR(name='ServiceControlOptions', mode=MODE_TYPE)
    ServiceControlOptions._cont = ASN1Dict([('preferChaining', 0), ('chainingProhibited', 1), ('localScope', 2), ('dontUseCopy', 3), ('dontDereferenceAliases', 4), ('subentries', 5), ('copyShallDo', 6), ('partialNameResolution', 7), ('manageDSAIT', 8), ('noSubtypeMatch', 9), ('noSubtypeSelection', 10), ('countFamily', 11), ('dontSelectFriends', 12), ('dontMatchFriends', 13), ('allowWriteableCopy', 14)])
    
    #-----< EntryInformationSelection >-----#
    EntryInformationSelection = SET(name='EntryInformationSelection', mode=MODE_TYPE)
    _EntryInformationSelection_attributes = CHOICE(name='attributes', mode=MODE_TYPE, default=('allUserAttributes', 0))
    __EntryInformationSelection_attributes_allUserAttributes = NULL(name='allUserAttributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EntryInformationSelection_attributes_select = SET_OF(name='select', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EntryInformationSelection_attributes_select__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __EntryInformationSelection_attributes_select._cont = ___EntryInformationSelection_attributes_select__item_
    _EntryInformationSelection_attributes._cont = ASN1Dict([
        ('allUserAttributes', __EntryInformationSelection_attributes_allUserAttributes),
        ('select', __EntryInformationSelection_attributes_select),
        ])
    _EntryInformationSelection_attributes._ext = None
    _EntryInformationSelection_infoTypes = INT(name='infoTypes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _EntryInformationSelection_infoTypes._cont = ASN1Dict([('attributeTypesOnly', 0), ('attributeTypesAndValues', 1)])
    _EntryInformationSelection_extraAttributes = CHOICE(name='extraAttributes', mode=MODE_TYPE, opt=True)
    __EntryInformationSelection_extraAttributes_allOperationalAttributes = NULL(name='allOperationalAttributes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EntryInformationSelection_extraAttributes_select = SET_OF(name='select', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EntryInformationSelection_extraAttributes_select__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __EntryInformationSelection_extraAttributes_select._cont = ___EntryInformationSelection_extraAttributes_select__item_
    __EntryInformationSelection_extraAttributes_select._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryInformationSelection_extraAttributes._cont = ASN1Dict([
        ('allOperationalAttributes', __EntryInformationSelection_extraAttributes_allOperationalAttributes),
        ('select', __EntryInformationSelection_extraAttributes_select),
        ])
    _EntryInformationSelection_extraAttributes._ext = None
    _EntryInformationSelection_contextSelection = CHOICE(name='contextSelection', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _EntryInformationSelection_returnContexts = BOOL(name='returnContexts', mode=MODE_TYPE, default=False)
    _EntryInformationSelection_familyReturn = SEQ(name='familyReturn', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), default=dict([('memberSelect', 'contributingEntriesOnly')]))
    EntryInformationSelection._cont = ASN1Dict([
        ('attributes', _EntryInformationSelection_attributes),
        ('infoTypes', _EntryInformationSelection_infoTypes),
        ('extraAttributes', _EntryInformationSelection_extraAttributes),
        ('contextSelection', _EntryInformationSelection_contextSelection),
        ('returnContexts', _EntryInformationSelection_returnContexts),
        ('familyReturn', _EntryInformationSelection_familyReturn),
        ])
    EntryInformationSelection._ext = None
    
    #-----< ContextSelection >-----#
    ContextSelection = CHOICE(name='ContextSelection', mode=MODE_TYPE)
    _ContextSelection_allContexts = NULL(name='allContexts', mode=MODE_TYPE)
    _ContextSelection_selectedContexts = SET_OF(name='selectedContexts', mode=MODE_TYPE)
    __ContextSelection_selectedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    _ContextSelection_selectedContexts._cont = __ContextSelection_selectedContexts__item_
    _ContextSelection_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextSelection._cont = ASN1Dict([
        ('allContexts', _ContextSelection_allContexts),
        ('selectedContexts', _ContextSelection_selectedContexts),
        ])
    ContextSelection._ext = []
    
    #-----< TypeAndContextAssertion >-----#
    TypeAndContextAssertion = SEQ(name='TypeAndContextAssertion', mode=MODE_TYPE)
    _TypeAndContextAssertion_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _TypeAndContextAssertion_contextAssertions = CHOICE(name='contextAssertions', mode=MODE_TYPE)
    __TypeAndContextAssertion_contextAssertions_preference = SEQ_OF(name='preference', mode=MODE_TYPE)
    ___TypeAndContextAssertion_contextAssertions_preference__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __TypeAndContextAssertion_contextAssertions_preference._cont = ___TypeAndContextAssertion_contextAssertions_preference__item_
    __TypeAndContextAssertion_contextAssertions_all = SET_OF(name='all', mode=MODE_TYPE)
    ___TypeAndContextAssertion_contextAssertions_all__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __TypeAndContextAssertion_contextAssertions_all._cont = ___TypeAndContextAssertion_contextAssertions_all__item_
    _TypeAndContextAssertion_contextAssertions._cont = ASN1Dict([
        ('preference', __TypeAndContextAssertion_contextAssertions_preference),
        ('all', __TypeAndContextAssertion_contextAssertions_all),
        ])
    _TypeAndContextAssertion_contextAssertions._ext = []
    TypeAndContextAssertion._cont = ASN1Dict([
        ('type', _TypeAndContextAssertion_type),
        ('contextAssertions', _TypeAndContextAssertion_contextAssertions),
        ])
    TypeAndContextAssertion._ext = []
    
    #-----< FamilyReturn >-----#
    FamilyReturn = SEQ(name='FamilyReturn', mode=MODE_TYPE)
    _FamilyReturn_memberSelect = ENUM(name='memberSelect', mode=MODE_TYPE)
    _FamilyReturn_memberSelect._cont = ASN1Dict([('contributingEntriesOnly', 1), ('participatingEntriesOnly', 2), ('compoundEntry', 3)])
    _FamilyReturn_memberSelect._ext = []
    _FamilyReturn_familySelect = SEQ_OF(name='familySelect', mode=MODE_TYPE, opt=True)
    __FamilyReturn_familySelect__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _FamilyReturn_familySelect._cont = __FamilyReturn_familySelect__item_
    _FamilyReturn_familySelect._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FamilyReturn._cont = ASN1Dict([
        ('memberSelect', _FamilyReturn_memberSelect),
        ('familySelect', _FamilyReturn_familySelect),
        ])
    FamilyReturn._ext = []
    
    #-----< EntryInformation >-----#
    EntryInformation = SEQ(name='EntryInformation', mode=MODE_TYPE)
    _EntryInformation_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _EntryInformation_fromEntry = BOOL(name='fromEntry', mode=MODE_TYPE, default=True)
    _EntryInformation_information = SET_OF(name='information', mode=MODE_TYPE, opt=True)
    __EntryInformation_information__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___EntryInformation_information__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___EntryInformation_information__item__attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____EntryInformation_information__item__attribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____EntryInformation_information__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______EntryInformation_information__item__attribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______EntryInformation_information__item__attribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____EntryInformation_information__item__attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ______EntryInformation_information__item__attribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______EntryInformation_information__item__attribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____EntryInformation_information__item__attribute_type._const_tab = _____EntryInformation_information__item__attribute_type_tab
    ____EntryInformation_information__item__attribute_type._const_tab_at = None
    ____EntryInformation_information__item__attribute_type._const_tab_id = 'id'
    ____EntryInformation_information__item__attribute_values = SET_OF(name='values', mode=MODE_TYPE)
    _____EntryInformation_information__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____EntryInformation_information__item__attribute_values__item_._const_tab = _____EntryInformation_information__item__attribute_type_tab
    _____EntryInformation_information__item__attribute_values__item_._const_tab_at = ('..', '..', 'type')
    _____EntryInformation_information__item__attribute_values__item_._const_tab_id = 'Type'
    ____EntryInformation_information__item__attribute_values._cont = _____EntryInformation_information__item__attribute_values__item_
    ____EntryInformation_information__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____EntryInformation_information__item__attribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____EntryInformation_information__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab = _____EntryInformation_information__item__attribute_type_tab
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList._cont = _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____EntryInformation_information__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______EntryInformation_information__item__attribute_valuesWithContext__item__value),
        ('contextList', ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList),
        ])
    _____EntryInformation_information__item__attribute_valuesWithContext__item_._ext = []
    ____EntryInformation_information__item__attribute_valuesWithContext._cont = _____EntryInformation_information__item__attribute_valuesWithContext__item_
    ____EntryInformation_information__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryInformation_information__item__attribute._cont = ASN1Dict([
        ('type', ____EntryInformation_information__item__attribute_type),
        ('values', ____EntryInformation_information__item__attribute_values),
        ('valuesWithContext', ____EntryInformation_information__item__attribute_valuesWithContext),
        ])
    ___EntryInformation_information__item__attribute._ext = []
    __EntryInformation_information__item_._cont = ASN1Dict([
        ('attributeType', ___EntryInformation_information__item__attributeType),
        ('attribute', ___EntryInformation_information__item__attribute),
        ])
    __EntryInformation_information__item_._ext = []
    _EntryInformation_information._cont = __EntryInformation_information__item_
    _EntryInformation_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryInformation_incompleteEntry = BOOL(name='incompleteEntry', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EntryInformation_partialName = BOOL(name='partialName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EntryInformation_derivedEntry = BOOL(name='derivedEntry', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    EntryInformation._cont = ASN1Dict([
        ('name', _EntryInformation_name),
        ('fromEntry', _EntryInformation_fromEntry),
        ('information', _EntryInformation_information),
        ('incompleteEntry', _EntryInformation_incompleteEntry),
        ('partialName', _EntryInformation_partialName),
        ('derivedEntry', _EntryInformation_derivedEntry),
        ])
    EntryInformation._ext = []
    
    #-----< family-information >-----#
    family_information = CLASS(name='family-information', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _family_information_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntries')))
    family_information._val = dict([('Type', _family_information_val_Type), ('usage', 'directoryOperation'), ('id', (2, 5, 4, 64))])
    
    #-----< FamilyEntries >-----#
    FamilyEntries = SEQ(name='FamilyEntries', mode=MODE_TYPE)
    _FamilyEntries_family_class = OID(name='family-class', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _FamilyEntries_familyEntries = SEQ_OF(name='familyEntries', mode=MODE_TYPE)
    __FamilyEntries_familyEntries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntry')))
    _FamilyEntries_familyEntries._cont = __FamilyEntries_familyEntries__item_
    FamilyEntries._cont = ASN1Dict([
        ('family-class', _FamilyEntries_family_class),
        ('familyEntries', _FamilyEntries_familyEntries),
        ])
    FamilyEntries._ext = []
    
    #-----< FamilyEntry >-----#
    FamilyEntry = SEQ(name='FamilyEntry', mode=MODE_TYPE)
    _FamilyEntry_rdn = SET_OF(name='rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _FamilyEntry_information = SEQ_OF(name='information', mode=MODE_TYPE)
    __FamilyEntry_information__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___FamilyEntry_information__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___FamilyEntry_information__item__attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____FamilyEntry_information__item__attribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____FamilyEntry_information__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______FamilyEntry_information__item__attribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______FamilyEntry_information__item__attribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____FamilyEntry_information__item__attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ______FamilyEntry_information__item__attribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______FamilyEntry_information__item__attribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____FamilyEntry_information__item__attribute_type._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    ____FamilyEntry_information__item__attribute_type._const_tab_at = None
    ____FamilyEntry_information__item__attribute_type._const_tab_id = 'id'
    ____FamilyEntry_information__item__attribute_values = SET_OF(name='values', mode=MODE_TYPE)
    _____FamilyEntry_information__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____FamilyEntry_information__item__attribute_values__item_._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    _____FamilyEntry_information__item__attribute_values__item_._const_tab_at = ('..', '..', 'type')
    _____FamilyEntry_information__item__attribute_values__item_._const_tab_id = 'Type'
    ____FamilyEntry_information__item__attribute_values._cont = _____FamilyEntry_information__item__attribute_values__item_
    ____FamilyEntry_information__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____FamilyEntry_information__item__attribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList._cont = _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______FamilyEntry_information__item__attribute_valuesWithContext__item__value),
        ('contextList', ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList),
        ])
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_._ext = []
    ____FamilyEntry_information__item__attribute_valuesWithContext._cont = _____FamilyEntry_information__item__attribute_valuesWithContext__item_
    ____FamilyEntry_information__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___FamilyEntry_information__item__attribute._cont = ASN1Dict([
        ('type', ____FamilyEntry_information__item__attribute_type),
        ('values', ____FamilyEntry_information__item__attribute_values),
        ('valuesWithContext', ____FamilyEntry_information__item__attribute_valuesWithContext),
        ])
    ___FamilyEntry_information__item__attribute._ext = []
    __FamilyEntry_information__item_._cont = ASN1Dict([
        ('attributeType', ___FamilyEntry_information__item__attributeType),
        ('attribute', ___FamilyEntry_information__item__attribute),
        ])
    __FamilyEntry_information__item_._ext = []
    _FamilyEntry_information._cont = __FamilyEntry_information__item_
    _FamilyEntry_family_info = SEQ_OF(name='family-info', mode=MODE_TYPE, opt=True)
    __FamilyEntry_family_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntries')))
    _FamilyEntry_family_info._cont = __FamilyEntry_family_info__item_
    _FamilyEntry_family_info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FamilyEntry._cont = ASN1Dict([
        ('rdn', _FamilyEntry_rdn),
        ('information', _FamilyEntry_information),
        ('family-info', _FamilyEntry_family_info),
        ])
    FamilyEntry._ext = []
    
    #-----< Filter >-----#
    Filter = CHOICE(name='Filter', mode=MODE_TYPE)
    _Filter_item = CHOICE(name='item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FilterItem')))
    _Filter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Filter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    _Filter_and_._cont = __Filter_and___item_
    _Filter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Filter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    _Filter_or_._cont = __Filter_or___item_
    _Filter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    Filter._cont = ASN1Dict([
        ('item', _Filter_item),
        ('and', _Filter_and_),
        ('or', _Filter_or_),
        ('not', _Filter_not_),
        ])
    Filter._ext = []
    
    #-----< FilterItem >-----#
    FilterItem = CHOICE(name='FilterItem', mode=MODE_TYPE)
    _FilterItem_equality = SEQ(name='equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_substrings = SEQ(name='substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FilterItem_substrings_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___FilterItem_substrings_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____FilterItem_substrings_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ____FilterItem_substrings_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___FilterItem_substrings_type_tab._val = ASN1Set(rv=[dict([('Type', ____FilterItem_substrings_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____FilterItem_substrings_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __FilterItem_substrings_type._const_tab = ___FilterItem_substrings_type_tab
    __FilterItem_substrings_type._const_tab_at = None
    __FilterItem_substrings_type._const_tab_id = 'id'
    __FilterItem_substrings_strings = SEQ_OF(name='strings', mode=MODE_TYPE)
    ___FilterItem_substrings_strings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ____FilterItem_substrings_strings__item__initial = OPEN(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____FilterItem_substrings_strings__item__initial._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__initial._const_tab_at = ('..', '..', '..', '..', 'substrings', 'type')
    ____FilterItem_substrings_strings__item__initial._const_tab_id = 'Type'
    ____FilterItem_substrings_strings__item__any = OPEN(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____FilterItem_substrings_strings__item__any._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__any._const_tab_at = ('..', '..', '..', '..', 'substrings', 'type')
    ____FilterItem_substrings_strings__item__any._const_tab_id = 'Type'
    ____FilterItem_substrings_strings__item__final = OPEN(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____FilterItem_substrings_strings__item__final._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__final._const_tab_at = ('..', '..', '..', '..', 'substrings', 'type')
    ____FilterItem_substrings_strings__item__final._const_tab_id = 'Type'
    ____FilterItem_substrings_strings__item__control = SEQ(name='control', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    _____FilterItem_substrings_strings__item__control_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____FilterItem_substrings_strings__item__control_type._const_tab = ___FilterItem_substrings_type_tab
    _____FilterItem_substrings_strings__item__control_type._const_tab_at = None
    _____FilterItem_substrings_strings__item__control_type._const_tab_id = 'id'
    _____FilterItem_substrings_strings__item__control_values = SET_OF(name='values', mode=MODE_TYPE)
    ______FilterItem_substrings_strings__item__control_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab = ___FilterItem_substrings_type_tab
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab_at = ('..', '..', 'type')
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab_id = 'Type'
    _____FilterItem_substrings_strings__item__control_values._cont = ______FilterItem_substrings_strings__item__control_values__item_
    _____FilterItem_substrings_strings__item__control_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _____FilterItem_substrings_strings__item__control_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab = ___FilterItem_substrings_type_tab
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab_id = 'Type'
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList._cont = ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_._cont = ASN1Dict([
        ('value', _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value),
        ('contextList', _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList),
        ])
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_._ext = []
    _____FilterItem_substrings_strings__item__control_valuesWithContext._cont = ______FilterItem_substrings_strings__item__control_valuesWithContext__item_
    _____FilterItem_substrings_strings__item__control_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____FilterItem_substrings_strings__item__control._cont = ASN1Dict([
        ('type', _____FilterItem_substrings_strings__item__control_type),
        ('values', _____FilterItem_substrings_strings__item__control_values),
        ('valuesWithContext', _____FilterItem_substrings_strings__item__control_valuesWithContext),
        ])
    ____FilterItem_substrings_strings__item__control._ext = []
    ___FilterItem_substrings_strings__item_._cont = ASN1Dict([
        ('initial', ____FilterItem_substrings_strings__item__initial),
        ('any', ____FilterItem_substrings_strings__item__any),
        ('final', ____FilterItem_substrings_strings__item__final),
        ('control', ____FilterItem_substrings_strings__item__control),
        ])
    ___FilterItem_substrings_strings__item_._ext = []
    __FilterItem_substrings_strings._cont = ___FilterItem_substrings_strings__item_
    _FilterItem_substrings._cont = ASN1Dict([
        ('type', __FilterItem_substrings_type),
        ('strings', __FilterItem_substrings_strings),
        ])
    _FilterItem_substrings._ext = []
    _FilterItem_greaterOrEqual = SEQ(name='greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_lessOrEqual = SEQ(name='lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_present = OID(name='present', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _FilterItem_approximateMatch = SEQ(name='approximateMatch', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_extensibleMatch = SEQ(name='extensibleMatch', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'MatchingRuleAssertion')))
    _FilterItem_contextPresent = SEQ(name='contextPresent', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAssertion')))
    FilterItem._cont = ASN1Dict([
        ('equality', _FilterItem_equality),
        ('substrings', _FilterItem_substrings),
        ('greaterOrEqual', _FilterItem_greaterOrEqual),
        ('lessOrEqual', _FilterItem_lessOrEqual),
        ('present', _FilterItem_present),
        ('approximateMatch', _FilterItem_approximateMatch),
        ('extensibleMatch', _FilterItem_extensibleMatch),
        ('contextPresent', _FilterItem_contextPresent),
        ])
    FilterItem._ext = []
    
    #-----< MatchingRuleAssertion >-----#
    MatchingRuleAssertion = SEQ(name='MatchingRuleAssertion', mode=MODE_TYPE)
    _MatchingRuleAssertion_matchingRule = SET_OF(name='matchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MatchingRuleAssertion_matchingRule__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MatchingRuleAssertion_matchingRule._cont = __MatchingRuleAssertion_matchingRule__item_
    _MatchingRuleAssertion_matchingRule._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleAssertion_type = OID(name='type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _MatchingRuleAssertion_matchValue = OPEN(name='matchValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['AssertionType']))
    _MatchingRuleAssertion_dnAttributes = BOOL(name='dnAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    MatchingRuleAssertion._cont = ASN1Dict([
        ('matchingRule', _MatchingRuleAssertion_matchingRule),
        ('type', _MatchingRuleAssertion_type),
        ('matchValue', _MatchingRuleAssertion_matchValue),
        ('dnAttributes', _MatchingRuleAssertion_dnAttributes),
        ])
    MatchingRuleAssertion._ext = []
    
    #-----< PagedResultsRequest >-----#
    PagedResultsRequest = CHOICE(name='PagedResultsRequest', mode=MODE_TYPE)
    _PagedResultsRequest_newRequest = SEQ(name='newRequest', mode=MODE_TYPE)
    __PagedResultsRequest_newRequest_pageSize = INT(name='pageSize', mode=MODE_TYPE)
    __PagedResultsRequest_newRequest_sortKeys = SEQ_OF(name='sortKeys', mode=MODE_TYPE, opt=True)
    ___PagedResultsRequest_newRequest_sortKeys__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SortKey')))
    __PagedResultsRequest_newRequest_sortKeys._cont = ___PagedResultsRequest_newRequest_sortKeys__item_
    __PagedResultsRequest_newRequest_sortKeys._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __PagedResultsRequest_newRequest_reverse = BOOL(name='reverse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __PagedResultsRequest_newRequest_unmerged = BOOL(name='unmerged', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __PagedResultsRequest_newRequest_pageNumber = INT(name='pageNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PagedResultsRequest_newRequest._cont = ASN1Dict([
        ('pageSize', __PagedResultsRequest_newRequest_pageSize),
        ('sortKeys', __PagedResultsRequest_newRequest_sortKeys),
        ('reverse', __PagedResultsRequest_newRequest_reverse),
        ('unmerged', __PagedResultsRequest_newRequest_unmerged),
        ('pageNumber', __PagedResultsRequest_newRequest_pageNumber),
        ])
    _PagedResultsRequest_newRequest._ext = []
    _PagedResultsRequest_queryReference = OCT_STR(name='queryReference', mode=MODE_TYPE)
    _PagedResultsRequest_abandonQuery = OCT_STR(name='abandonQuery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    PagedResultsRequest._cont = ASN1Dict([
        ('newRequest', _PagedResultsRequest_newRequest),
        ('queryReference', _PagedResultsRequest_queryReference),
        ('abandonQuery', _PagedResultsRequest_abandonQuery),
        ])
    PagedResultsRequest._ext = []
    
    #-----< SortKey >-----#
    SortKey = SEQ(name='SortKey', mode=MODE_TYPE)
    _SortKey_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SortKey_orderingRule = OID(name='orderingRule', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    SortKey._cont = ASN1Dict([
        ('type', _SortKey_type),
        ('orderingRule', _SortKey_orderingRule),
        ])
    SortKey._ext = []
    
    #-----< SecurityParameters >-----#
    SecurityParameters = SET(name='SecurityParameters', mode=MODE_TYPE)
    _SecurityParameters_certification_path = SEQ(name='certification-path', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificationPath')), opt=True)
    _SecurityParameters_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SecurityParameters_time = CHOICE(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Time')), opt=True)
    _SecurityParameters_random = BIT_STR(name='random', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SecurityParameters_target = INT(name='target', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ProtectionRequest')), opt=True)
    _SecurityParameters_operationCode = CHOICE(name='operationCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True)
    _SecurityParameters_errorProtection = INT(name='errorProtection', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ErrorProtectionRequest')), opt=True)
    _SecurityParameters_errorCode = CHOICE(name='errorCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True)
    SecurityParameters._cont = ASN1Dict([
        ('certification-path', _SecurityParameters_certification_path),
        ('name', _SecurityParameters_name),
        ('time', _SecurityParameters_time),
        ('random', _SecurityParameters_random),
        ('target', _SecurityParameters_target),
        ('operationCode', _SecurityParameters_operationCode),
        ('errorProtection', _SecurityParameters_errorProtection),
        ('errorCode', _SecurityParameters_errorCode),
        ])
    SecurityParameters._ext = []
    
    #-----< ProtectionRequest >-----#
    ProtectionRequest = INT(name='ProtectionRequest', mode=MODE_TYPE)
    ProtectionRequest._cont = ASN1Dict([('none', 0), ('signed', 1)])
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< ErrorProtectionRequest >-----#
    ErrorProtectionRequest = INT(name='ErrorProtectionRequest', mode=MODE_TYPE)
    ErrorProtectionRequest._cont = ASN1Dict([('none', 0), ('signed', 1)])
    
    #-----< directoryBind >-----#
    directoryBind = CLASS(name='directoryBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _directoryBind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindArgument')))
    _directoryBind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    directoryBind._val = dict([('ArgumentType', _directoryBind_val_ArgumentType), ('ResultType', _directoryBind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< DirectoryBindArgument >-----#
    DirectoryBindArgument = SET(name='DirectoryBindArgument', mode=MODE_TYPE)
    _DirectoryBindArgument_credentials = CHOICE(name='credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Credentials')), opt=True)
    _DirectoryBindArgument_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    DirectoryBindArgument._cont = ASN1Dict([
        ('credentials', _DirectoryBindArgument_credentials),
        ('versions', _DirectoryBindArgument_versions),
        ])
    DirectoryBindArgument._ext = []
    
    #-----< Credentials >-----#
    Credentials = CHOICE(name='Credentials', mode=MODE_TYPE)
    _Credentials_simple = SEQ(name='simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SimpleCredentials')))
    _Credentials_strong = SET(name='strong', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'StrongCredentials')))
    _Credentials_externalProcedure = EXT(name='externalProcedure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _Credentials_spkm = CHOICE(name='spkm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SpkmCredentials')))
    _Credentials_sasl = SEQ(name='sasl', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SaslCredentials')))
    Credentials._cont = ASN1Dict([
        ('simple', _Credentials_simple),
        ('strong', _Credentials_strong),
        ('externalProcedure', _Credentials_externalProcedure),
        ('spkm', _Credentials_spkm),
        ('sasl', _Credentials_sasl),
        ])
    Credentials._ext = []
    
    #-----< SimpleCredentials >-----#
    SimpleCredentials = SEQ(name='SimpleCredentials', mode=MODE_TYPE)
    _SimpleCredentials_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _SimpleCredentials_validity = SET(name='validity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_validity_time1 = CHOICE(name='time1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SimpleCredentials_validity_time1_utc = TIME_UTC(name='utc', mode=MODE_TYPE)
    ___SimpleCredentials_validity_time1_gt = TIME_GEN(name='gt', mode=MODE_TYPE)
    __SimpleCredentials_validity_time1._cont = ASN1Dict([
        ('utc', ___SimpleCredentials_validity_time1_utc),
        ('gt', ___SimpleCredentials_validity_time1_gt),
        ])
    __SimpleCredentials_validity_time1._ext = None
    __SimpleCredentials_validity_time2 = CHOICE(name='time2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SimpleCredentials_validity_time2_utc = TIME_UTC(name='utc', mode=MODE_TYPE)
    ___SimpleCredentials_validity_time2_gt = TIME_GEN(name='gt', mode=MODE_TYPE)
    __SimpleCredentials_validity_time2._cont = ASN1Dict([
        ('utc', ___SimpleCredentials_validity_time2_utc),
        ('gt', ___SimpleCredentials_validity_time2_gt),
        ])
    __SimpleCredentials_validity_time2._ext = None
    __SimpleCredentials_validity_random1 = BIT_STR(name='random1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_validity_random2 = BIT_STR(name='random2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SimpleCredentials_validity._cont = ASN1Dict([
        ('time1', __SimpleCredentials_validity_time1),
        ('time2', __SimpleCredentials_validity_time2),
        ('random1', __SimpleCredentials_validity_random1),
        ('random2', __SimpleCredentials_validity_random2),
        ])
    _SimpleCredentials_validity._ext = None
    _SimpleCredentials_password = CHOICE(name='password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_password_unprotected = OCT_STR(name='unprotected', mode=MODE_TYPE)
    __SimpleCredentials_password_protected = SEQ(name='protected', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    ___SimpleCredentials_password_protected_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab = _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab_at = None
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab = _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___SimpleCredentials_password_protected_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm),
        ('parameters', ____SimpleCredentials_password_protected_algorithmIdentifier_parameters),
        ])
    ___SimpleCredentials_password_protected_algorithmIdentifier._ext = []
    ___SimpleCredentials_password_protected_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    __SimpleCredentials_password_protected._cont = ASN1Dict([
        ('algorithmIdentifier', ___SimpleCredentials_password_protected_algorithmIdentifier),
        ('hashValue', ___SimpleCredentials_password_protected_hashValue),
        ])
    __SimpleCredentials_password_protected._ext = []
    __SimpleCredentials_password_userPwd = CHOICE(name='userPwd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    _SimpleCredentials_password._cont = ASN1Dict([
        ('unprotected', __SimpleCredentials_password_unprotected),
        ('protected', __SimpleCredentials_password_protected),
        ('userPwd', __SimpleCredentials_password_userPwd),
        ])
    _SimpleCredentials_password._ext = ['userPwd']
    SimpleCredentials._cont = ASN1Dict([
        ('name', _SimpleCredentials_name),
        ('validity', _SimpleCredentials_validity),
        ('password', _SimpleCredentials_password),
        ])
    SimpleCredentials._ext = None
    
    #-----< StrongCredentials >-----#
    StrongCredentials = SET(name='StrongCredentials', mode=MODE_TYPE)
    _StrongCredentials_certification_path = SEQ(name='certification-path', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificationPath')), opt=True)
    _StrongCredentials_bind_token = SEQ(name='bind-token', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Token')))
    _StrongCredentials_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _StrongCredentials_attributeCertificationPath = SEQ(name='attributeCertificationPath', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificationPath')), opt=True)
    StrongCredentials._cont = ASN1Dict([
        ('certification-path', _StrongCredentials_certification_path),
        ('bind-token', _StrongCredentials_bind_token),
        ('name', _StrongCredentials_name),
        ('attributeCertificationPath', _StrongCredentials_attributeCertificationPath),
        ])
    StrongCredentials._ext = []
    
    #-----< SpkmCredentials >-----#
    SpkmCredentials = CHOICE(name='SpkmCredentials', mode=MODE_TYPE)
    _SpkmCredentials_req = SEQ(name='req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REQ')))
    _SpkmCredentials_rep = SEQ(name='rep', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-TI')))
    SpkmCredentials._cont = ASN1Dict([
        ('req', _SpkmCredentials_req),
        ('rep', _SpkmCredentials_rep),
        ])
    SpkmCredentials._ext = []
    
    #-----< SaslCredentials >-----#
    SaslCredentials = SEQ(name='SaslCredentials', mode=MODE_TYPE)
    _SaslCredentials_mechanism = CHOICE(name='mechanism', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DirectoryString')))
    __SaslCredentials_mechanism_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __SaslCredentials_mechanism_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _SaslCredentials_mechanism._cont = ASN1Dict([
        ('teletexString', __SaslCredentials_mechanism_teletexString),
        ('printableString', __SaslCredentials_mechanism_printableString),
        ('bmpString', __SaslCredentials_mechanism_bmpString),
        ('universalString', __SaslCredentials_mechanism_universalString),
        ('uTF8String', __SaslCredentials_mechanism_uTF8String),
        ])
    _SaslCredentials_mechanism._ext = None
    _SaslCredentials_credentials = OCT_STR(name='credentials', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SaslCredentials_saslAbort = BOOL(name='saslAbort', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    SaslCredentials._cont = ASN1Dict([
        ('mechanism', _SaslCredentials_mechanism),
        ('credentials', _SaslCredentials_credentials),
        ('saslAbort', _SaslCredentials_saslAbort),
        ])
    SaslCredentials._ext = []
    
    #-----< ub-saslMechanism >-----#
    ub_saslMechanism = INT(name='ub-saslMechanism', mode=MODE_VALUE)
    ub_saslMechanism._val = 20
    
    #-----< Token >-----#
    Token = SEQ(name='Token', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _Token_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TokenContent')))
    _Token_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Token_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Token_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Token_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Token_algorithmIdentifier_algorithm._const_tab = ___Token_algorithmIdentifier_algorithm_tab
    __Token_algorithmIdentifier_algorithm._const_tab_at = None
    __Token_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __Token_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Token_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Token_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Token_algorithmIdentifier_parameters._const_tab = ___Token_algorithmIdentifier_parameters_tab
    __Token_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __Token_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _Token_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __Token_algorithmIdentifier_algorithm),
        ('parameters', __Token_algorithmIdentifier_parameters),
        ])
    _Token_algorithmIdentifier._ext = []
    _Token_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    Token._cont = ASN1Dict([
        ('toBeSigned', _Token_toBeSigned),
        ('algorithmIdentifier', _Token_algorithmIdentifier),
        ('signature', _Token_signature),
        ])
    Token._ext = []
    
    #-----< TokenContent >-----#
    TokenContent = SEQ(name='TokenContent', mode=MODE_TYPE)
    _TokenContent_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TokenContent_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___TokenContent_algorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TokenContent_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TokenContent_algorithm_algorithm._const_tab = ___TokenContent_algorithm_algorithm_tab
    __TokenContent_algorithm_algorithm._const_tab_at = None
    __TokenContent_algorithm_algorithm._const_tab_id = 'id'
    __TokenContent_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___TokenContent_algorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TokenContent_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TokenContent_algorithm_parameters._const_tab = ___TokenContent_algorithm_parameters_tab
    __TokenContent_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    __TokenContent_algorithm_parameters._const_tab_id = 'Type'
    _TokenContent_algorithm._cont = ASN1Dict([
        ('algorithm', __TokenContent_algorithm_algorithm),
        ('parameters', __TokenContent_algorithm_parameters),
        ])
    _TokenContent_algorithm._ext = []
    _TokenContent_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _TokenContent_time = CHOICE(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Time')))
    _TokenContent_random = BIT_STR(name='random', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _TokenContent_response = BIT_STR(name='response', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    TokenContent._cont = ASN1Dict([
        ('algorithm', _TokenContent_algorithm),
        ('name', _TokenContent_name),
        ('time', _TokenContent_time),
        ('random', _TokenContent_random),
        ('response', _TokenContent_response),
        ])
    TokenContent._ext = []
    
    #-----< Versions >-----#
    Versions = BIT_STR(name='Versions', mode=MODE_TYPE)
    Versions._cont = ASN1Dict([('v1', 0), ('v2', 1)])
    
    #-----< DirectoryBindResult >-----#
    DirectoryBindResult = SET(name='DirectoryBindResult', mode=MODE_TYPE)
    _DirectoryBindResult_credentials = CHOICE(name='credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Credentials')), opt=True)
    _DirectoryBindResult_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _DirectoryBindResult_pwdResponseValue = SEQ(name='pwdResponseValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PwdResponseValue')), opt=True)
    DirectoryBindResult._cont = ASN1Dict([
        ('credentials', _DirectoryBindResult_credentials),
        ('versions', _DirectoryBindResult_versions),
        ('pwdResponseValue', _DirectoryBindResult_pwdResponseValue),
        ])
    DirectoryBindResult._ext = ['pwdResponseValue']
    
    #-----< PwdResponseValue >-----#
    PwdResponseValue = SEQ(name='PwdResponseValue', mode=MODE_TYPE)
    _PwdResponseValue_warning = CHOICE(name='warning', mode=MODE_TYPE, opt=True)
    __PwdResponseValue_warning_timeLeft = INT(name='timeLeft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponseValue_warning_timeLeft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __PwdResponseValue_warning_graceRemaining = INT(name='graceRemaining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponseValue_warning_graceRemaining._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PwdResponseValue_warning._cont = ASN1Dict([
        ('timeLeft', __PwdResponseValue_warning_timeLeft),
        ('graceRemaining', __PwdResponseValue_warning_graceRemaining),
        ])
    _PwdResponseValue_warning._ext = []
    _PwdResponseValue_error = ENUM(name='error', mode=MODE_TYPE, opt=True)
    _PwdResponseValue_error._cont = ASN1Dict([('passwordExpired', 0), ('changeAfterReset', 1)])
    _PwdResponseValue_error._ext = []
    PwdResponseValue._cont = ASN1Dict([
        ('warning', _PwdResponseValue_warning),
        ('error', _PwdResponseValue_error),
        ])
    PwdResponseValue._ext = None
    
    #-----< directoryBindError >-----#
    directoryBindError = CLASS(name='directoryBindError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _directoryBindError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __directoryBindError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___directoryBindError_val_ParameterType_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ___directoryBindError_val_ParameterType_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ____directoryBindError_val_ParameterType_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ____directoryBindError_val_ParameterType_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ___directoryBindError_val_ParameterType_unsigned_error._cont = ASN1Dict([
        ('serviceError', ____directoryBindError_val_ParameterType_unsigned_error_serviceError),
        ('securityError', ____directoryBindError_val_ParameterType_unsigned_error_securityError),
        ])
    ___directoryBindError_val_ParameterType_unsigned_error._ext = []
    ___directoryBindError_val_ParameterType_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __directoryBindError_val_ParameterType_unsigned._cont = ASN1Dict([
        ('versions', ___directoryBindError_val_ParameterType_unsigned_versions),
        ('error', ___directoryBindError_val_ParameterType_unsigned_error),
        ('securityParameters', ___directoryBindError_val_ParameterType_unsigned_securityParameters),
        ])
    __directoryBindError_val_ParameterType_unsigned._ext = None
    __directoryBindError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___directoryBindError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____directoryBindError_val_ParameterType_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError),
        ('securityError', _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError),
        ])
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error._ext = []
    ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___directoryBindError_val_ParameterType_signed_toBeSigned._cont = ASN1Dict([
        ('versions', ____directoryBindError_val_ParameterType_signed_toBeSigned_versions),
        ('error', ____directoryBindError_val_ParameterType_signed_toBeSigned_error),
        ('securityParameters', ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters),
        ])
    ___directoryBindError_val_ParameterType_signed_toBeSigned._ext = None
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___directoryBindError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __directoryBindError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___directoryBindError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___directoryBindError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___directoryBindError_val_ParameterType_signed_signature),
        ])
    __directoryBindError_val_ParameterType_signed._ext = []
    _directoryBindError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __directoryBindError_val_ParameterType_unsigned),
        ('signed', __directoryBindError_val_ParameterType_signed),
        ])
    _directoryBindError_val_ParameterType._ext = None
    directoryBindError._val = dict([('ParameterType', _directoryBindError_val_ParameterType)])
    
    #-----< BindKeyInfo >-----#
    BindKeyInfo = BIT_STR(name='BindKeyInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED')))
    
    #-----< read >-----#
    read = CLASS(name='read', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _read_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    _read_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    read._val = dict([('ArgumentType', _read_val_ArgumentType), ('ResultType', _read_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))])
    
    #-----< ReadArgument >-----#
    ReadArgument = CHOICE(name='ReadArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ReadArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgumentData')))
    _ReadArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ReadArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgumentData')))
    __ReadArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ReadArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ReadArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ReadArgument_signed_algorithmIdentifier_algorithm_tab
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ReadArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ReadArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab = ____ReadArgument_signed_algorithmIdentifier_parameters_tab
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ReadArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ReadArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ReadArgument_signed_algorithmIdentifier_parameters),
        ])
    __ReadArgument_signed_algorithmIdentifier._ext = []
    __ReadArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ReadArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ReadArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ReadArgument_signed_algorithmIdentifier),
        ('signature', __ReadArgument_signed_signature),
        ])
    _ReadArgument_signed._ext = []
    ReadArgument._cont = ASN1Dict([
        ('unsigned', _ReadArgument_unsigned),
        ('signed', _ReadArgument_signed),
        ])
    ReadArgument._ext = None
    
    #-----< ReadArgumentData >-----#
    ReadArgumentData = SET(name='ReadArgumentData', mode=MODE_TYPE)
    _ReadArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ReadArgumentData_selection = SET(name='selection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), default=dict([]))
    _ReadArgumentData_modifyRightsRequest = BOOL(name='modifyRightsRequest', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ReadArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReadArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReadArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ReadArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ReadArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ReadArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ReadArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ReadArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ReadArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ReadArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ReadArgumentData._cont = ASN1Dict([
        ('object', _ReadArgumentData_object),
        ('selection', _ReadArgumentData_selection),
        ('modifyRightsRequest', _ReadArgumentData_modifyRightsRequest),
        ('serviceControls', _ReadArgumentData_serviceControls),
        ('securityParameters', _ReadArgumentData_securityParameters),
        ('requestor', _ReadArgumentData_requestor),
        ('operationProgress', _ReadArgumentData_operationProgress),
        ('aliasedRDNs', _ReadArgumentData_aliasedRDNs),
        ('criticalExtensions', _ReadArgumentData_criticalExtensions),
        ('referenceType', _ReadArgumentData_referenceType),
        ('entryOnly', _ReadArgumentData_entryOnly),
        ('exclusions', _ReadArgumentData_exclusions),
        ('nameResolveOnMaster', _ReadArgumentData_nameResolveOnMaster),
        ('operationContexts', _ReadArgumentData_operationContexts),
        ('familyGrouping', _ReadArgumentData_familyGrouping),
        ])
    ReadArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ReadResult >-----#
    ReadResult = CHOICE(name='ReadResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ReadResult_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResultData')))
    _ReadResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ReadResult_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResultData')))
    __ReadResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ReadResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ReadResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab = ____ReadResult_signed_algorithmIdentifier_algorithm_tab
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ReadResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ReadResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab = ____ReadResult_signed_algorithmIdentifier_parameters_tab
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ReadResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ReadResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ReadResult_signed_algorithmIdentifier_parameters),
        ])
    __ReadResult_signed_algorithmIdentifier._ext = []
    __ReadResult_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ReadResult_signed._cont = ASN1Dict([
        ('toBeSigned', __ReadResult_signed_toBeSigned),
        ('algorithmIdentifier', __ReadResult_signed_algorithmIdentifier),
        ('signature', __ReadResult_signed_signature),
        ])
    _ReadResult_signed._ext = []
    ReadResult._cont = ASN1Dict([
        ('unsigned', _ReadResult_unsigned),
        ('signed', _ReadResult_signed),
        ])
    ReadResult._ext = None
    
    #-----< ReadResultData >-----#
    ReadResultData = SET(name='ReadResultData', mode=MODE_TYPE)
    _ReadResultData_entry = SEQ(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')))
    _ReadResultData_modifyRights = SET_OF(name='modifyRights', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyRights')), opt=True)
    _ReadResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReadResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReadResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ReadResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ReadResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ReadResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ReadResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ReadResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ReadResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ReadResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ReadResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ReadResultData_notification__item__type._const_tab = ____ReadResultData_notification__item__type_tab
    ___ReadResultData_notification__item__type._const_tab_at = None
    ___ReadResultData_notification__item__type._const_tab_id = 'id'
    ___ReadResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ReadResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ReadResultData_notification__item__values__item_._const_tab = ____ReadResultData_notification__item__type_tab
    ____ReadResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ReadResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ReadResultData_notification__item__values._cont = ____ReadResultData_notification__item__values__item_
    ___ReadResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ReadResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ReadResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ReadResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab = ____ReadResultData_notification__item__type_tab
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ReadResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ReadResultData_notification__item__valuesWithContext__item__contextList._cont = ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ReadResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ReadResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ReadResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ReadResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ReadResultData_notification__item__valuesWithContext__item_._ext = []
    ___ReadResultData_notification__item__valuesWithContext._cont = ____ReadResultData_notification__item__valuesWithContext__item_
    ___ReadResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ReadResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ReadResultData_notification__item__type),
        ('values', ___ReadResultData_notification__item__values),
        ('valuesWithContext', ___ReadResultData_notification__item__valuesWithContext),
        ])
    __ReadResultData_notification__item_._ext = []
    _ReadResultData_notification._cont = __ReadResultData_notification__item_
    ReadResultData._cont = ASN1Dict([
        ('entry', _ReadResultData_entry),
        ('modifyRights', _ReadResultData_modifyRights),
        ('securityParameters', _ReadResultData_securityParameters),
        ('performer', _ReadResultData_performer),
        ('aliasDereferenced', _ReadResultData_aliasDereferenced),
        ('notification', _ReadResultData_notification),
        ])
    ReadResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ModifyRights >-----#
    ModifyRights = SET_OF(name='ModifyRights', mode=MODE_TYPE)
    _ModifyRights__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ModifyRights__item__item = CHOICE(name='item', mode=MODE_TYPE)
    ___ModifyRights__item__item_entry = NULL(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ModifyRights__item__item_attribute = OID(name='attribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___ModifyRights__item__item_value = SEQ(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    __ModifyRights__item__item._cont = ASN1Dict([
        ('entry', ___ModifyRights__item__item_entry),
        ('attribute', ___ModifyRights__item__item_attribute),
        ('value', ___ModifyRights__item__item_value),
        ])
    __ModifyRights__item__item._ext = []
    __ModifyRights__item__permission = BIT_STR(name='permission', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifyRights__item__permission._cont = ASN1Dict([('add', 0), ('remove', 1), ('rename', 2), ('move', 3)])
    _ModifyRights__item_._cont = ASN1Dict([
        ('item', __ModifyRights__item__item),
        ('permission', __ModifyRights__item__permission),
        ])
    _ModifyRights__item_._ext = []
    ModifyRights._cont = _ModifyRights__item_
    
    #-----< compare >-----#
    compare = CLASS(name='compare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _compare_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    _compare_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    compare._val = dict([('ArgumentType', _compare_val_ArgumentType), ('ResultType', _compare_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])
    
    #-----< CompareArgument >-----#
    CompareArgument = CHOICE(name='CompareArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CompareArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgumentData')))
    _CompareArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CompareArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgumentData')))
    __CompareArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CompareArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____CompareArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab = ____CompareArgument_signed_algorithmIdentifier_algorithm_tab
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___CompareArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____CompareArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab = ____CompareArgument_signed_algorithmIdentifier_parameters_tab
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __CompareArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___CompareArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___CompareArgument_signed_algorithmIdentifier_parameters),
        ])
    __CompareArgument_signed_algorithmIdentifier._ext = []
    __CompareArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _CompareArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __CompareArgument_signed_toBeSigned),
        ('algorithmIdentifier', __CompareArgument_signed_algorithmIdentifier),
        ('signature', __CompareArgument_signed_signature),
        ])
    _CompareArgument_signed._ext = []
    CompareArgument._cont = ASN1Dict([
        ('unsigned', _CompareArgument_unsigned),
        ('signed', _CompareArgument_signed),
        ])
    CompareArgument._ext = None
    
    #-----< CompareArgumentData >-----#
    CompareArgumentData = SET(name='CompareArgumentData', mode=MODE_TYPE)
    _CompareArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CompareArgumentData_purported = SEQ(name='purported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _CompareArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CompareArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CompareArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CompareArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _CompareArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CompareArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CompareArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CompareArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CompareArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CompareArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CompareArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CompareArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    CompareArgumentData._cont = ASN1Dict([
        ('object', _CompareArgumentData_object),
        ('purported', _CompareArgumentData_purported),
        ('serviceControls', _CompareArgumentData_serviceControls),
        ('securityParameters', _CompareArgumentData_securityParameters),
        ('requestor', _CompareArgumentData_requestor),
        ('operationProgress', _CompareArgumentData_operationProgress),
        ('aliasedRDNs', _CompareArgumentData_aliasedRDNs),
        ('criticalExtensions', _CompareArgumentData_criticalExtensions),
        ('referenceType', _CompareArgumentData_referenceType),
        ('entryOnly', _CompareArgumentData_entryOnly),
        ('exclusions', _CompareArgumentData_exclusions),
        ('nameResolveOnMaster', _CompareArgumentData_nameResolveOnMaster),
        ('operationContexts', _CompareArgumentData_operationContexts),
        ('familyGrouping', _CompareArgumentData_familyGrouping),
        ])
    CompareArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< CompareResult >-----#
    CompareResult = CHOICE(name='CompareResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CompareResult_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResultData')))
    _CompareResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CompareResult_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResultData')))
    __CompareResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CompareResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____CompareResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab = ____CompareResult_signed_algorithmIdentifier_algorithm_tab
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___CompareResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____CompareResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab = ____CompareResult_signed_algorithmIdentifier_parameters_tab
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __CompareResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___CompareResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___CompareResult_signed_algorithmIdentifier_parameters),
        ])
    __CompareResult_signed_algorithmIdentifier._ext = []
    __CompareResult_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _CompareResult_signed._cont = ASN1Dict([
        ('toBeSigned', __CompareResult_signed_toBeSigned),
        ('algorithmIdentifier', __CompareResult_signed_algorithmIdentifier),
        ('signature', __CompareResult_signed_signature),
        ])
    _CompareResult_signed._ext = []
    CompareResult._cont = ASN1Dict([
        ('unsigned', _CompareResult_unsigned),
        ('signed', _CompareResult_signed),
        ])
    CompareResult._ext = None
    
    #-----< CompareResultData >-----#
    CompareResultData = SET(name='CompareResultData', mode=MODE_TYPE)
    _CompareResultData_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CompareResultData_matched = BOOL(name='matched', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CompareResultData_fromEntry = BOOL(name='fromEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CompareResultData_matchedSubtype = OID(name='matchedSubtype', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _CompareResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CompareResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CompareResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CompareResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CompareResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CompareResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CompareResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CompareResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____CompareResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CompareResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CompareResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CompareResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CompareResultData_notification__item__type._const_tab = ____CompareResultData_notification__item__type_tab
    ___CompareResultData_notification__item__type._const_tab_at = None
    ___CompareResultData_notification__item__type._const_tab_id = 'id'
    ___CompareResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CompareResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CompareResultData_notification__item__values__item_._const_tab = ____CompareResultData_notification__item__type_tab
    ____CompareResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CompareResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___CompareResultData_notification__item__values._cont = ____CompareResultData_notification__item__values__item_
    ___CompareResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CompareResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CompareResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CompareResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab = ____CompareResultData_notification__item__type_tab
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CompareResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CompareResultData_notification__item__valuesWithContext__item__contextList._cont = ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_
    _____CompareResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CompareResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CompareResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____CompareResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____CompareResultData_notification__item__valuesWithContext__item_._ext = []
    ___CompareResultData_notification__item__valuesWithContext._cont = ____CompareResultData_notification__item__valuesWithContext__item_
    ___CompareResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CompareResultData_notification__item_._cont = ASN1Dict([
        ('type', ___CompareResultData_notification__item__type),
        ('values', ___CompareResultData_notification__item__values),
        ('valuesWithContext', ___CompareResultData_notification__item__valuesWithContext),
        ])
    __CompareResultData_notification__item_._ext = []
    _CompareResultData_notification._cont = __CompareResultData_notification__item_
    CompareResultData._cont = ASN1Dict([
        ('name', _CompareResultData_name),
        ('matched', _CompareResultData_matched),
        ('fromEntry', _CompareResultData_fromEntry),
        ('matchedSubtype', _CompareResultData_matchedSubtype),
        ('securityParameters', _CompareResultData_securityParameters),
        ('performer', _CompareResultData_performer),
        ('aliasDereferenced', _CompareResultData_aliasDereferenced),
        ('notification', _CompareResultData_notification),
        ])
    CompareResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< abandon >-----#
    abandon = CLASS(name='abandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _abandon_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    _abandon_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    abandon._val = dict([('ArgumentType', _abandon_val_ArgumentType), ('ResultType', _abandon_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])
    
    #-----< AbandonArgument >-----#
    AbandonArgument = CHOICE(name='AbandonArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _AbandonArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgumentData')))
    _AbandonArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AbandonArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgumentData')))
    __AbandonArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AbandonArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___AbandonArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____AbandonArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AbandonArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab = ____AbandonArgument_signed_algorithmIdentifier_parameters_tab
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __AbandonArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___AbandonArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___AbandonArgument_signed_algorithmIdentifier_parameters),
        ])
    __AbandonArgument_signed_algorithmIdentifier._ext = []
    __AbandonArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _AbandonArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __AbandonArgument_signed_toBeSigned),
        ('algorithmIdentifier', __AbandonArgument_signed_algorithmIdentifier),
        ('signature', __AbandonArgument_signed_signature),
        ])
    _AbandonArgument_signed._ext = []
    AbandonArgument._cont = ASN1Dict([
        ('unsigned', _AbandonArgument_unsigned),
        ('signed', _AbandonArgument_signed),
        ])
    AbandonArgument._ext = None
    
    #-----< AbandonArgumentData >-----#
    AbandonArgumentData = SEQ(name='AbandonArgumentData', mode=MODE_TYPE)
    _AbandonArgumentData_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    AbandonArgumentData._cont = ASN1Dict([
        ('invokeID', _AbandonArgumentData_invokeID),
        ])
    AbandonArgumentData._ext = []
    
    #-----< AbandonResult >-----#
    AbandonResult = CHOICE(name='AbandonResult', mode=MODE_TYPE)
    _AbandonResult_null = NULL(name='null', mode=MODE_TYPE)
    _AbandonResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AbandonResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResultData')))
    __AbandonResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AbandonResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResultData')))
    ___AbandonResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____AbandonResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___AbandonResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____AbandonResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____AbandonResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AbandonResult_information_signed_algorithmIdentifier._ext = []
    ___AbandonResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __AbandonResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___AbandonResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___AbandonResult_information_signed_algorithmIdentifier),
        ('signature', ___AbandonResult_information_signed_signature),
        ])
    __AbandonResult_information_signed._ext = []
    _AbandonResult_information._cont = ASN1Dict([
        ('unsigned', __AbandonResult_information_unsigned),
        ('signed', __AbandonResult_information_signed),
        ])
    _AbandonResult_information._ext = None
    AbandonResult._cont = ASN1Dict([
        ('null', _AbandonResult_null),
        ('information', _AbandonResult_information),
        ])
    AbandonResult._ext = []
    
    #-----< AbandonResultData >-----#
    AbandonResultData = SEQ(name='AbandonResultData', mode=MODE_TYPE)
    _AbandonResultData_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _AbandonResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AbandonResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AbandonResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AbandonResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AbandonResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonResultData_notification__item__type._const_tab = ____AbandonResultData_notification__item__type_tab
    ___AbandonResultData_notification__item__type._const_tab_at = None
    ___AbandonResultData_notification__item__type._const_tab_id = 'id'
    ___AbandonResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AbandonResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AbandonResultData_notification__item__values__item_._const_tab = ____AbandonResultData_notification__item__type_tab
    ____AbandonResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AbandonResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___AbandonResultData_notification__item__values._cont = ____AbandonResultData_notification__item__values__item_
    ___AbandonResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonResultData_notification__item__type_tab
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AbandonResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AbandonResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonResultData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonResultData_notification__item__valuesWithContext._cont = ____AbandonResultData_notification__item__valuesWithContext__item_
    ___AbandonResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonResultData_notification__item_._cont = ASN1Dict([
        ('type', ___AbandonResultData_notification__item__type),
        ('values', ___AbandonResultData_notification__item__values),
        ('valuesWithContext', ___AbandonResultData_notification__item__valuesWithContext),
        ])
    __AbandonResultData_notification__item_._ext = []
    _AbandonResultData_notification._cont = __AbandonResultData_notification__item_
    AbandonResultData._cont = ASN1Dict([
        ('invokeID', _AbandonResultData_invokeID),
        ('securityParameters', _AbandonResultData_securityParameters),
        ('performer', _AbandonResultData_performer),
        ('aliasDereferenced', _AbandonResultData_aliasDereferenced),
        ('notification', _AbandonResultData_notification),
        ])
    AbandonResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< list >-----#
    list = CLASS(name='list', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _list_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    _list_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    list._val = dict([('ArgumentType', _list_val_ArgumentType), ('ResultType', _list_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))])
    
    #-----< ListArgument >-----#
    ListArgument = CHOICE(name='ListArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ListArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgumentData')))
    _ListArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ListArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgumentData')))
    __ListArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ListArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ListArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ListArgument_signed_algorithmIdentifier_algorithm_tab
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ListArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ListArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab = ____ListArgument_signed_algorithmIdentifier_parameters_tab
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ListArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ListArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ListArgument_signed_algorithmIdentifier_parameters),
        ])
    __ListArgument_signed_algorithmIdentifier._ext = []
    __ListArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ListArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ListArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ListArgument_signed_algorithmIdentifier),
        ('signature', __ListArgument_signed_signature),
        ])
    _ListArgument_signed._ext = []
    ListArgument._cont = ASN1Dict([
        ('unsigned', _ListArgument_unsigned),
        ('signed', _ListArgument_signed),
        ])
    ListArgument._ext = None
    
    #-----< ListArgumentData >-----#
    ListArgumentData = SET(name='ListArgumentData', mode=MODE_TYPE)
    _ListArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ListArgumentData_pagedResults = CHOICE(name='pagedResults', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PagedResultsRequest')), opt=True)
    _ListArgumentData_listFamily = BOOL(name='listFamily', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ListArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ListArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ListArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ListArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ListArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ListArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ListArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ListArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ListArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ListArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ListArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ListArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ListArgumentData._cont = ASN1Dict([
        ('object', _ListArgumentData_object),
        ('pagedResults', _ListArgumentData_pagedResults),
        ('listFamily', _ListArgumentData_listFamily),
        ('serviceControls', _ListArgumentData_serviceControls),
        ('securityParameters', _ListArgumentData_securityParameters),
        ('requestor', _ListArgumentData_requestor),
        ('operationProgress', _ListArgumentData_operationProgress),
        ('aliasedRDNs', _ListArgumentData_aliasedRDNs),
        ('criticalExtensions', _ListArgumentData_criticalExtensions),
        ('referenceType', _ListArgumentData_referenceType),
        ('entryOnly', _ListArgumentData_entryOnly),
        ('exclusions', _ListArgumentData_exclusions),
        ('nameResolveOnMaster', _ListArgumentData_nameResolveOnMaster),
        ('operationContexts', _ListArgumentData_operationContexts),
        ('familyGrouping', _ListArgumentData_familyGrouping),
        ])
    ListArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ListResult >-----#
    ListResult = CHOICE(name='ListResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ListResult_unsigned = CHOICE(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResultData')))
    _ListResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ListResult_signed_toBeSigned = CHOICE(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResultData')))
    __ListResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ListResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ListResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab = ____ListResult_signed_algorithmIdentifier_algorithm_tab
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ListResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ListResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab = ____ListResult_signed_algorithmIdentifier_parameters_tab
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ListResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ListResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ListResult_signed_algorithmIdentifier_parameters),
        ])
    __ListResult_signed_algorithmIdentifier._ext = []
    __ListResult_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ListResult_signed._cont = ASN1Dict([
        ('toBeSigned', __ListResult_signed_toBeSigned),
        ('algorithmIdentifier', __ListResult_signed_algorithmIdentifier),
        ('signature', __ListResult_signed_signature),
        ])
    _ListResult_signed._ext = []
    ListResult._cont = ASN1Dict([
        ('unsigned', _ListResult_unsigned),
        ('signed', _ListResult_signed),
        ])
    ListResult._ext = None
    
    #-----< ListResultData >-----#
    ListResultData = CHOICE(name='ListResultData', mode=MODE_TYPE)
    _ListResultData_listInfo = SET(name='listInfo', mode=MODE_TYPE)
    __ListResultData_listInfo_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    __ListResultData_listInfo_subordinates = SET_OF(name='subordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ListResultData_listInfo_subordinates__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ListResultData_listInfo_subordinates__item__rdn = SET_OF(name='rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    ____ListResultData_listInfo_subordinates__item__aliasEntry = BOOL(name='aliasEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ____ListResultData_listInfo_subordinates__item__fromEntry = BOOL(name='fromEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    ___ListResultData_listInfo_subordinates__item_._cont = ASN1Dict([
        ('rdn', ____ListResultData_listInfo_subordinates__item__rdn),
        ('aliasEntry', ____ListResultData_listInfo_subordinates__item__aliasEntry),
        ('fromEntry', ____ListResultData_listInfo_subordinates__item__fromEntry),
        ])
    ___ListResultData_listInfo_subordinates__item_._ext = []
    __ListResultData_listInfo_subordinates._cont = ___ListResultData_listInfo_subordinates__item_
    __ListResultData_listInfo_partialOutcomeQualifier = SET(name='partialOutcomeQualifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PartialOutcomeQualifier')), opt=True)
    __ListResultData_listInfo_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __ListResultData_listInfo_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    __ListResultData_listInfo_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __ListResultData_listInfo_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___ListResultData_listInfo_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____ListResultData_listInfo_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____ListResultData_listInfo_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______ListResultData_listInfo_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______ListResultData_listInfo_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____ListResultData_listInfo_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', ______ListResultData_listInfo_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______ListResultData_listInfo_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____ListResultData_listInfo_notification__item__type._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    ____ListResultData_listInfo_notification__item__type._const_tab_at = None
    ____ListResultData_listInfo_notification__item__type._const_tab_id = 'id'
    ____ListResultData_listInfo_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    _____ListResultData_listInfo_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ListResultData_listInfo_notification__item__values__item_._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    _____ListResultData_listInfo_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    _____ListResultData_listInfo_notification__item__values__item_._const_tab_id = 'Type'
    ____ListResultData_listInfo_notification__item__values._cont = _____ListResultData_listInfo_notification__item__values__item_
    ____ListResultData_listInfo_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____ListResultData_listInfo_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList._cont = _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______ListResultData_listInfo_notification__item__valuesWithContext__item__value),
        ('contextList', ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList),
        ])
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_._ext = []
    ____ListResultData_listInfo_notification__item__valuesWithContext._cont = _____ListResultData_listInfo_notification__item__valuesWithContext__item_
    ____ListResultData_listInfo_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___ListResultData_listInfo_notification__item_._cont = ASN1Dict([
        ('type', ____ListResultData_listInfo_notification__item__type),
        ('values', ____ListResultData_listInfo_notification__item__values),
        ('valuesWithContext', ____ListResultData_listInfo_notification__item__valuesWithContext),
        ])
    ___ListResultData_listInfo_notification__item_._ext = []
    __ListResultData_listInfo_notification._cont = ___ListResultData_listInfo_notification__item_
    _ListResultData_listInfo._cont = ASN1Dict([
        ('name', __ListResultData_listInfo_name),
        ('subordinates', __ListResultData_listInfo_subordinates),
        ('partialOutcomeQualifier', __ListResultData_listInfo_partialOutcomeQualifier),
        ('securityParameters', __ListResultData_listInfo_securityParameters),
        ('performer', __ListResultData_listInfo_performer),
        ('aliasDereferenced', __ListResultData_listInfo_aliasDereferenced),
        ('notification', __ListResultData_listInfo_notification),
        ])
    _ListResultData_listInfo._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    _ListResultData_uncorrelatedListInfo = SET_OF(name='uncorrelatedListInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ListResultData_uncorrelatedListInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    _ListResultData_uncorrelatedListInfo._cont = __ListResultData_uncorrelatedListInfo__item_
    ListResultData._cont = ASN1Dict([
        ('listInfo', _ListResultData_listInfo),
        ('uncorrelatedListInfo', _ListResultData_uncorrelatedListInfo),
        ])
    ListResultData._ext = []
    
    #-----< PartialOutcomeQualifier >-----#
    PartialOutcomeQualifier = SET(name='PartialOutcomeQualifier', mode=MODE_TYPE)
    _PartialOutcomeQualifier_limitProblem = INT(name='limitProblem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LimitProblem')), opt=True)
    _PartialOutcomeQualifier_unexplored = SET_OF(name='unexplored', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_unexplored__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _PartialOutcomeQualifier_unexplored._cont = __PartialOutcomeQualifier_unexplored__item_
    _PartialOutcomeQualifier_unexplored._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_unavailableCriticalExtensions = BOOL(name='unavailableCriticalExtensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _PartialOutcomeQualifier_unknownErrors = SET_OF(name='unknownErrors', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_unknownErrors__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _PartialOutcomeQualifier_unknownErrors._cont = __PartialOutcomeQualifier_unknownErrors__item_
    _PartialOutcomeQualifier_unknownErrors._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_queryReference = OCT_STR(name='queryReference', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PartialOutcomeQualifier_overspecFilter = CHOICE(name='overspecFilter', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _PartialOutcomeQualifier_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___PartialOutcomeQualifier_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____PartialOutcomeQualifier_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____PartialOutcomeQualifier_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___PartialOutcomeQualifier_notification__item__type._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    ___PartialOutcomeQualifier_notification__item__type._const_tab_at = None
    ___PartialOutcomeQualifier_notification__item__type._const_tab_id = 'id'
    ___PartialOutcomeQualifier_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____PartialOutcomeQualifier_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab_id = 'Type'
    ___PartialOutcomeQualifier_notification__item__values._cont = ____PartialOutcomeQualifier_notification__item__values__item_
    ___PartialOutcomeQualifier_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___PartialOutcomeQualifier_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList._cont = ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value),
        ('contextList', _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList),
        ])
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_._ext = []
    ___PartialOutcomeQualifier_notification__item__valuesWithContext._cont = ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_
    ___PartialOutcomeQualifier_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __PartialOutcomeQualifier_notification__item_._cont = ASN1Dict([
        ('type', ___PartialOutcomeQualifier_notification__item__type),
        ('values', ___PartialOutcomeQualifier_notification__item__values),
        ('valuesWithContext', ___PartialOutcomeQualifier_notification__item__valuesWithContext),
        ])
    __PartialOutcomeQualifier_notification__item_._ext = []
    _PartialOutcomeQualifier_notification._cont = __PartialOutcomeQualifier_notification__item_
    _PartialOutcomeQualifier_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_entryCount = CHOICE(name='entryCount', mode=MODE_TYPE, opt=True)
    __PartialOutcomeQualifier_entryCount_bestEstimate = INT(name='bestEstimate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PartialOutcomeQualifier_entryCount_lowEstimate = INT(name='lowEstimate', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PartialOutcomeQualifier_entryCount_exact = INT(name='exact', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _PartialOutcomeQualifier_entryCount._cont = ASN1Dict([
        ('bestEstimate', __PartialOutcomeQualifier_entryCount_bestEstimate),
        ('lowEstimate', __PartialOutcomeQualifier_entryCount_lowEstimate),
        ('exact', __PartialOutcomeQualifier_entryCount_exact),
        ])
    _PartialOutcomeQualifier_entryCount._ext = []
    PartialOutcomeQualifier._cont = ASN1Dict([
        ('limitProblem', _PartialOutcomeQualifier_limitProblem),
        ('unexplored', _PartialOutcomeQualifier_unexplored),
        ('unavailableCriticalExtensions', _PartialOutcomeQualifier_unavailableCriticalExtensions),
        ('unknownErrors', _PartialOutcomeQualifier_unknownErrors),
        ('queryReference', _PartialOutcomeQualifier_queryReference),
        ('overspecFilter', _PartialOutcomeQualifier_overspecFilter),
        ('notification', _PartialOutcomeQualifier_notification),
        ('entryCount', _PartialOutcomeQualifier_entryCount),
        ])
    PartialOutcomeQualifier._ext = None
    
    #-----< LimitProblem >-----#
    LimitProblem = INT(name='LimitProblem', mode=MODE_TYPE)
    LimitProblem._cont = ASN1Dict([('timeLimitExceeded', 0), ('sizeLimitExceeded', 1), ('administrativeLimitExceeded', 2)])
    
    #-----< search >-----#
    search = CLASS(name='search', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _search_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    _search_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    search._val = dict([('ArgumentType', _search_val_ArgumentType), ('ResultType', _search_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])
    
    #-----< SearchArgument >-----#
    SearchArgument = CHOICE(name='SearchArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _SearchArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgumentData')))
    _SearchArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __SearchArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgumentData')))
    __SearchArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SearchArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____SearchArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab = ____SearchArgument_signed_algorithmIdentifier_algorithm_tab
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___SearchArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____SearchArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab = ____SearchArgument_signed_algorithmIdentifier_parameters_tab
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __SearchArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___SearchArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___SearchArgument_signed_algorithmIdentifier_parameters),
        ])
    __SearchArgument_signed_algorithmIdentifier._ext = []
    __SearchArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _SearchArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __SearchArgument_signed_toBeSigned),
        ('algorithmIdentifier', __SearchArgument_signed_algorithmIdentifier),
        ('signature', __SearchArgument_signed_signature),
        ])
    _SearchArgument_signed._ext = []
    SearchArgument._cont = ASN1Dict([
        ('unsigned', _SearchArgument_unsigned),
        ('signed', _SearchArgument_signed),
        ])
    SearchArgument._ext = None
    
    #-----< SearchArgumentData >-----#
    SearchArgumentData = SET(name='SearchArgumentData', mode=MODE_TYPE)
    _SearchArgumentData_baseObject = CHOICE(name='baseObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SearchArgumentData_subset = INT(name='subset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _SearchArgumentData_subset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    _SearchArgumentData_filter = CHOICE(name='filter', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), default=('and', []))
    _SearchArgumentData_searchAliases = BOOL(name='searchAliases', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SearchArgumentData_selection = SET(name='selection', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), default=dict([]))
    _SearchArgumentData_pagedResults = CHOICE(name='pagedResults', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PagedResultsRequest')), opt=True)
    _SearchArgumentData_matchedValuesOnly = BOOL(name='matchedValuesOnly', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_extendedFilter = CHOICE(name='extendedFilter', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _SearchArgumentData_checkOverspecified = BOOL(name='checkOverspecified', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_relaxation = SEQ(name='relaxation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchArgumentData_extendedArea = INT(name='extendedArea', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_hierarchySelections = BIT_STR(name='hierarchySelections', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')), default=(1, 1))
    _SearchArgumentData_searchControlOptions = BIT_STR(name='searchControlOptions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')), default=(1, 1))
    _SearchArgumentData_joinArguments = SEQ_OF(name='joinArguments', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchArgumentData_joinArguments__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinArgument')))
    _SearchArgumentData_joinArguments._cont = __SearchArgumentData_joinArguments__item_
    _SearchArgumentData_joinArguments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchArgumentData_joinType = ENUM(name='joinType', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='leftOuterJoin')
    _SearchArgumentData_joinType._cont = ASN1Dict([('innerJoin', 0), ('leftOuterJoin', 1), ('fullOuterJoin', 2)])
    _SearchArgumentData_joinType._ext = None
    _SearchArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _SearchArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _SearchArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SearchArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _SearchArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _SearchArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SearchArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _SearchArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _SearchArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    SearchArgumentData._cont = ASN1Dict([
        ('baseObject', _SearchArgumentData_baseObject),
        ('subset', _SearchArgumentData_subset),
        ('filter', _SearchArgumentData_filter),
        ('searchAliases', _SearchArgumentData_searchAliases),
        ('selection', _SearchArgumentData_selection),
        ('pagedResults', _SearchArgumentData_pagedResults),
        ('matchedValuesOnly', _SearchArgumentData_matchedValuesOnly),
        ('extendedFilter', _SearchArgumentData_extendedFilter),
        ('checkOverspecified', _SearchArgumentData_checkOverspecified),
        ('relaxation', _SearchArgumentData_relaxation),
        ('extendedArea', _SearchArgumentData_extendedArea),
        ('hierarchySelections', _SearchArgumentData_hierarchySelections),
        ('searchControlOptions', _SearchArgumentData_searchControlOptions),
        ('joinArguments', _SearchArgumentData_joinArguments),
        ('joinType', _SearchArgumentData_joinType),
        ('serviceControls', _SearchArgumentData_serviceControls),
        ('securityParameters', _SearchArgumentData_securityParameters),
        ('requestor', _SearchArgumentData_requestor),
        ('operationProgress', _SearchArgumentData_operationProgress),
        ('aliasedRDNs', _SearchArgumentData_aliasedRDNs),
        ('criticalExtensions', _SearchArgumentData_criticalExtensions),
        ('referenceType', _SearchArgumentData_referenceType),
        ('entryOnly', _SearchArgumentData_entryOnly),
        ('exclusions', _SearchArgumentData_exclusions),
        ('nameResolveOnMaster', _SearchArgumentData_nameResolveOnMaster),
        ('operationContexts', _SearchArgumentData_operationContexts),
        ('familyGrouping', _SearchArgumentData_familyGrouping),
        ])
    SearchArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< HierarchySelections >-----#
    HierarchySelections = BIT_STR(name='HierarchySelections', mode=MODE_TYPE)
    HierarchySelections._cont = ASN1Dict([('self', 0), ('children', 1), ('parent', 2), ('hierarchy', 3), ('top', 4), ('subtree', 5), ('siblings', 6), ('siblingChildren', 7), ('siblingSubtree', 8), ('all', 9)])
    
    #-----< SearchControlOptions >-----#
    SearchControlOptions = BIT_STR(name='SearchControlOptions', mode=MODE_TYPE)
    SearchControlOptions._cont = ASN1Dict([('searchAliases', 0), ('matchedValuesOnly', 1), ('checkOverspecified', 2), ('performExactly', 3), ('includeAllAreas', 4), ('noSystemRelaxation', 5), ('dnAttribute', 6), ('matchOnResidualName', 7), ('entryCount', 8), ('useSubset', 9), ('separateFamilyMembers', 10), ('searchFamily', 11)])
    
    #-----< JoinArgument >-----#
    JoinArgument = SEQ(name='JoinArgument', mode=MODE_TYPE)
    _JoinArgument_joinBaseObject = CHOICE(name='joinBaseObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _JoinArgument_domainLocalID = CHOICE(name='domainLocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'DomainLocalID')), opt=True)
    _JoinArgument_joinSubset = ENUM(name='joinSubset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='baseObject')
    _JoinArgument_joinSubset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    _JoinArgument_joinSubset._ext = []
    _JoinArgument_joinFilter = CHOICE(name='joinFilter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _JoinArgument_joinAttributes = SEQ_OF(name='joinAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __JoinArgument_joinAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinAttPair')))
    _JoinArgument_joinAttributes._cont = __JoinArgument_joinAttributes__item_
    _JoinArgument_joinAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _JoinArgument_joinSelection = SET(name='joinSelection', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')))
    JoinArgument._cont = ASN1Dict([
        ('joinBaseObject', _JoinArgument_joinBaseObject),
        ('domainLocalID', _JoinArgument_domainLocalID),
        ('joinSubset', _JoinArgument_joinSubset),
        ('joinFilter', _JoinArgument_joinFilter),
        ('joinAttributes', _JoinArgument_joinAttributes),
        ('joinSelection', _JoinArgument_joinSelection),
        ])
    JoinArgument._ext = []
    
    #-----< DomainLocalID >-----#
    DomainLocalID = CHOICE(name='DomainLocalID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    
    #-----< JoinAttPair >-----#
    JoinAttPair = SEQ(name='JoinAttPair', mode=MODE_TYPE)
    _JoinAttPair_baseAtt = OID(name='baseAtt', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _JoinAttPair_joinAtt = OID(name='joinAtt', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _JoinAttPair_joinContext = SEQ_OF(name='joinContext', mode=MODE_TYPE, opt=True)
    __JoinAttPair_joinContext__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinContextType')))
    _JoinAttPair_joinContext._cont = __JoinAttPair_joinContext__item_
    _JoinAttPair_joinContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    JoinAttPair._cont = ASN1Dict([
        ('baseAtt', _JoinAttPair_baseAtt),
        ('joinAtt', _JoinAttPair_joinAtt),
        ('joinContext', _JoinAttPair_joinContext),
        ])
    JoinAttPair._ext = []
    
    #-----< JoinContextType >-----#
    JoinContextType = OID(name='JoinContextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _JoinContextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _JoinContextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    JoinContextType._const_tab = _JoinContextType_tab
    JoinContextType._const_tab_at = None
    JoinContextType._const_tab_id = 'id'
    
    #-----< SearchResult >-----#
    SearchResult = CHOICE(name='SearchResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _SearchResult_unsigned = CHOICE(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResultData')))
    _SearchResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __SearchResult_signed_toBeSigned = CHOICE(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResultData')))
    __SearchResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SearchResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____SearchResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab = ____SearchResult_signed_algorithmIdentifier_algorithm_tab
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___SearchResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____SearchResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab = ____SearchResult_signed_algorithmIdentifier_parameters_tab
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __SearchResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___SearchResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___SearchResult_signed_algorithmIdentifier_parameters),
        ])
    __SearchResult_signed_algorithmIdentifier._ext = []
    __SearchResult_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _SearchResult_signed._cont = ASN1Dict([
        ('toBeSigned', __SearchResult_signed_toBeSigned),
        ('algorithmIdentifier', __SearchResult_signed_algorithmIdentifier),
        ('signature', __SearchResult_signed_signature),
        ])
    _SearchResult_signed._ext = []
    SearchResult._cont = ASN1Dict([
        ('unsigned', _SearchResult_unsigned),
        ('signed', _SearchResult_signed),
        ])
    SearchResult._ext = None
    
    #-----< SearchResultData >-----#
    SearchResultData = CHOICE(name='SearchResultData', mode=MODE_TYPE)
    _SearchResultData_searchInfo = SET(name='searchInfo', mode=MODE_TYPE)
    __SearchResultData_searchInfo_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    __SearchResultData_searchInfo_entries = SET_OF(name='entries', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___SearchResultData_searchInfo_entries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')))
    __SearchResultData_searchInfo_entries._cont = ___SearchResultData_searchInfo_entries__item_
    __SearchResultData_searchInfo_partialOutcomeQualifier = SET(name='partialOutcomeQualifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PartialOutcomeQualifier')), opt=True)
    __SearchResultData_searchInfo_altMatching = BOOL(name='altMatching', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __SearchResultData_searchInfo_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __SearchResultData_searchInfo_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    __SearchResultData_searchInfo_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __SearchResultData_searchInfo_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SearchResultData_searchInfo_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____SearchResultData_searchInfo_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____SearchResultData_searchInfo_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____SearchResultData_searchInfo_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____SearchResultData_searchInfo_notification__item__type._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    ____SearchResultData_searchInfo_notification__item__type._const_tab_at = None
    ____SearchResultData_searchInfo_notification__item__type._const_tab_id = 'id'
    ____SearchResultData_searchInfo_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    _____SearchResultData_searchInfo_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab_id = 'Type'
    ____SearchResultData_searchInfo_notification__item__values._cont = _____SearchResultData_searchInfo_notification__item__values__item_
    ____SearchResultData_searchInfo_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____SearchResultData_searchInfo_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList._cont = _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value),
        ('contextList', ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList),
        ])
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_._ext = []
    ____SearchResultData_searchInfo_notification__item__valuesWithContext._cont = _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_
    ____SearchResultData_searchInfo_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___SearchResultData_searchInfo_notification__item_._cont = ASN1Dict([
        ('type', ____SearchResultData_searchInfo_notification__item__type),
        ('values', ____SearchResultData_searchInfo_notification__item__values),
        ('valuesWithContext', ____SearchResultData_searchInfo_notification__item__valuesWithContext),
        ])
    ___SearchResultData_searchInfo_notification__item_._ext = []
    __SearchResultData_searchInfo_notification._cont = ___SearchResultData_searchInfo_notification__item_
    _SearchResultData_searchInfo._cont = ASN1Dict([
        ('name', __SearchResultData_searchInfo_name),
        ('entries', __SearchResultData_searchInfo_entries),
        ('partialOutcomeQualifier', __SearchResultData_searchInfo_partialOutcomeQualifier),
        ('altMatching', __SearchResultData_searchInfo_altMatching),
        ('securityParameters', __SearchResultData_searchInfo_securityParameters),
        ('performer', __SearchResultData_searchInfo_performer),
        ('aliasDereferenced', __SearchResultData_searchInfo_aliasDereferenced),
        ('notification', __SearchResultData_searchInfo_notification),
        ])
    _SearchResultData_searchInfo._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    _SearchResultData_uncorrelatedSearchInfo = SET_OF(name='uncorrelatedSearchInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SearchResultData_uncorrelatedSearchInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    _SearchResultData_uncorrelatedSearchInfo._cont = __SearchResultData_uncorrelatedSearchInfo__item_
    SearchResultData._cont = ASN1Dict([
        ('searchInfo', _SearchResultData_searchInfo),
        ('uncorrelatedSearchInfo', _SearchResultData_uncorrelatedSearchInfo),
        ])
    SearchResultData._ext = []
    
    #-----< addEntry >-----#
    addEntry = CLASS(name='addEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _addEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    _addEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    addEntry._val = dict([('ArgumentType', _addEntry_val_ArgumentType), ('ResultType', _addEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))])
    
    #-----< AddEntryArgument >-----#
    AddEntryArgument = CHOICE(name='AddEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _AddEntryArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgumentData')))
    _AddEntryArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AddEntryArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgumentData')))
    __AddEntryArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___AddEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __AddEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___AddEntryArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___AddEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __AddEntryArgument_signed_algorithmIdentifier._ext = []
    __AddEntryArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _AddEntryArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __AddEntryArgument_signed_toBeSigned),
        ('algorithmIdentifier', __AddEntryArgument_signed_algorithmIdentifier),
        ('signature', __AddEntryArgument_signed_signature),
        ])
    _AddEntryArgument_signed._ext = []
    AddEntryArgument._cont = ASN1Dict([
        ('unsigned', _AddEntryArgument_unsigned),
        ('signed', _AddEntryArgument_signed),
        ])
    AddEntryArgument._ext = None
    
    #-----< AddEntryArgumentData >-----#
    AddEntryArgumentData = SET(name='AddEntryArgumentData', mode=MODE_TYPE)
    _AddEntryArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AddEntryArgumentData_entry = SET_OF(name='entry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AddEntryArgumentData_entry__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AddEntryArgumentData_entry__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AddEntryArgumentData_entry__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AddEntryArgumentData_entry__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AddEntryArgumentData_entry__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AddEntryArgumentData_entry__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AddEntryArgumentData_entry__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AddEntryArgumentData_entry__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AddEntryArgumentData_entry__item__type._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    ___AddEntryArgumentData_entry__item__type._const_tab_at = None
    ___AddEntryArgumentData_entry__item__type._const_tab_id = 'id'
    ___AddEntryArgumentData_entry__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AddEntryArgumentData_entry__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AddEntryArgumentData_entry__item__values__item_._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    ____AddEntryArgumentData_entry__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AddEntryArgumentData_entry__item__values__item_._const_tab_id = 'Type'
    ___AddEntryArgumentData_entry__item__values._cont = ____AddEntryArgumentData_entry__item__values__item_
    ___AddEntryArgumentData_entry__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AddEntryArgumentData_entry__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList._cont = ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AddEntryArgumentData_entry__item__valuesWithContext__item__value),
        ('contextList', _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList),
        ])
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_._ext = []
    ___AddEntryArgumentData_entry__item__valuesWithContext._cont = ____AddEntryArgumentData_entry__item__valuesWithContext__item_
    ___AddEntryArgumentData_entry__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AddEntryArgumentData_entry__item_._cont = ASN1Dict([
        ('type', ___AddEntryArgumentData_entry__item__type),
        ('values', ___AddEntryArgumentData_entry__item__values),
        ('valuesWithContext', ___AddEntryArgumentData_entry__item__valuesWithContext),
        ])
    __AddEntryArgumentData_entry__item_._ext = []
    _AddEntryArgumentData_entry._cont = __AddEntryArgumentData_entry__item_
    _AddEntryArgumentData_targetSystem = SET(name='targetSystem', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _AddEntryArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _AddEntryArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AddEntryArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AddEntryArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _AddEntryArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _AddEntryArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _AddEntryArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _AddEntryArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AddEntryArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _AddEntryArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AddEntryArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _AddEntryArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    AddEntryArgumentData._cont = ASN1Dict([
        ('object', _AddEntryArgumentData_object),
        ('entry', _AddEntryArgumentData_entry),
        ('targetSystem', _AddEntryArgumentData_targetSystem),
        ('serviceControls', _AddEntryArgumentData_serviceControls),
        ('securityParameters', _AddEntryArgumentData_securityParameters),
        ('requestor', _AddEntryArgumentData_requestor),
        ('operationProgress', _AddEntryArgumentData_operationProgress),
        ('aliasedRDNs', _AddEntryArgumentData_aliasedRDNs),
        ('criticalExtensions', _AddEntryArgumentData_criticalExtensions),
        ('referenceType', _AddEntryArgumentData_referenceType),
        ('entryOnly', _AddEntryArgumentData_entryOnly),
        ('exclusions', _AddEntryArgumentData_exclusions),
        ('nameResolveOnMaster', _AddEntryArgumentData_nameResolveOnMaster),
        ('operationContexts', _AddEntryArgumentData_operationContexts),
        ('familyGrouping', _AddEntryArgumentData_familyGrouping),
        ])
    AddEntryArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< AddEntryResult >-----#
    AddEntryResult = CHOICE(name='AddEntryResult', mode=MODE_TYPE)
    _AddEntryResult_null = NULL(name='null', mode=MODE_TYPE)
    _AddEntryResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AddEntryResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResultData')))
    __AddEntryResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AddEntryResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResultData')))
    ___AddEntryResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___AddEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____AddEntryResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____AddEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AddEntryResult_information_signed_algorithmIdentifier._ext = []
    ___AddEntryResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __AddEntryResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___AddEntryResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___AddEntryResult_information_signed_algorithmIdentifier),
        ('signature', ___AddEntryResult_information_signed_signature),
        ])
    __AddEntryResult_information_signed._ext = []
    _AddEntryResult_information._cont = ASN1Dict([
        ('unsigned', __AddEntryResult_information_unsigned),
        ('signed', __AddEntryResult_information_signed),
        ])
    _AddEntryResult_information._ext = None
    AddEntryResult._cont = ASN1Dict([
        ('null', _AddEntryResult_null),
        ('information', _AddEntryResult_information),
        ])
    AddEntryResult._ext = []
    
    #-----< AddEntryResultData >-----#
    AddEntryResultData = SEQ(name='AddEntryResultData', mode=MODE_TYPE)
    _AddEntryResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AddEntryResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AddEntryResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AddEntryResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AddEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AddEntryResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AddEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AddEntryResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AddEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AddEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AddEntryResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AddEntryResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AddEntryResultData_notification__item__type._const_tab = ____AddEntryResultData_notification__item__type_tab
    ___AddEntryResultData_notification__item__type._const_tab_at = None
    ___AddEntryResultData_notification__item__type._const_tab_id = 'id'
    ___AddEntryResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AddEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AddEntryResultData_notification__item__values__item_._const_tab = ____AddEntryResultData_notification__item__type_tab
    ____AddEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AddEntryResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___AddEntryResultData_notification__item__values._cont = ____AddEntryResultData_notification__item__values__item_
    ___AddEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AddEntryResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AddEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AddEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____AddEntryResultData_notification__item__type_tab
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AddEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AddEntryResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AddEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AddEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___AddEntryResultData_notification__item__valuesWithContext._cont = ____AddEntryResultData_notification__item__valuesWithContext__item_
    ___AddEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AddEntryResultData_notification__item_._cont = ASN1Dict([
        ('type', ___AddEntryResultData_notification__item__type),
        ('values', ___AddEntryResultData_notification__item__values),
        ('valuesWithContext', ___AddEntryResultData_notification__item__valuesWithContext),
        ])
    __AddEntryResultData_notification__item_._ext = []
    _AddEntryResultData_notification._cont = __AddEntryResultData_notification__item_
    AddEntryResultData._cont = ASN1Dict([
        ('securityParameters', _AddEntryResultData_securityParameters),
        ('performer', _AddEntryResultData_performer),
        ('aliasDereferenced', _AddEntryResultData_aliasDereferenced),
        ('notification', _AddEntryResultData_notification),
        ])
    AddEntryResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< removeEntry >-----#
    removeEntry = CLASS(name='removeEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _removeEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    _removeEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __OPERATION_Errors_val_ParameterType_3_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    removeEntry._val = dict([('ArgumentType', _removeEntry_val_ArgumentType), ('ResultType', _removeEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))])
    
    #-----< RemoveEntryArgument >-----#
    RemoveEntryArgument = CHOICE(name='RemoveEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _RemoveEntryArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgumentData')))
    _RemoveEntryArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __RemoveEntryArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgumentData')))
    __RemoveEntryArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __RemoveEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___RemoveEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __RemoveEntryArgument_signed_algorithmIdentifier._ext = []
    __RemoveEntryArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _RemoveEntryArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __RemoveEntryArgument_signed_toBeSigned),
        ('algorithmIdentifier', __RemoveEntryArgument_signed_algorithmIdentifier),
        ('signature', __RemoveEntryArgument_signed_signature),
        ])
    _RemoveEntryArgument_signed._ext = []
    RemoveEntryArgument._cont = ASN1Dict([
        ('unsigned', _RemoveEntryArgument_unsigned),
        ('signed', _RemoveEntryArgument_signed),
        ])
    RemoveEntryArgument._ext = None
    
    #-----< RemoveEntryArgumentData >-----#
    RemoveEntryArgumentData = SET(name='RemoveEntryArgumentData', mode=MODE_TYPE)
    _RemoveEntryArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _RemoveEntryArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _RemoveEntryArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RemoveEntryArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RemoveEntryArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _RemoveEntryArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RemoveEntryArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RemoveEntryArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _RemoveEntryArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _RemoveEntryArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _RemoveEntryArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RemoveEntryArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _RemoveEntryArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    RemoveEntryArgumentData._cont = ASN1Dict([
        ('object', _RemoveEntryArgumentData_object),
        ('serviceControls', _RemoveEntryArgumentData_serviceControls),
        ('securityParameters', _RemoveEntryArgumentData_securityParameters),
        ('requestor', _RemoveEntryArgumentData_requestor),
        ('operationProgress', _RemoveEntryArgumentData_operationProgress),
        ('aliasedRDNs', _RemoveEntryArgumentData_aliasedRDNs),
        ('criticalExtensions', _RemoveEntryArgumentData_criticalExtensions),
        ('referenceType', _RemoveEntryArgumentData_referenceType),
        ('entryOnly', _RemoveEntryArgumentData_entryOnly),
        ('exclusions', _RemoveEntryArgumentData_exclusions),
        ('nameResolveOnMaster', _RemoveEntryArgumentData_nameResolveOnMaster),
        ('operationContexts', _RemoveEntryArgumentData_operationContexts),
        ('familyGrouping', _RemoveEntryArgumentData_familyGrouping),
        ])
    RemoveEntryArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< RemoveEntryResult >-----#
    RemoveEntryResult = CHOICE(name='RemoveEntryResult', mode=MODE_TYPE)
    _RemoveEntryResult_null = NULL(name='null', mode=MODE_TYPE)
    _RemoveEntryResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __RemoveEntryResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResultData')))
    __RemoveEntryResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___RemoveEntryResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResultData')))
    ___RemoveEntryResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___RemoveEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___RemoveEntryResult_information_signed_algorithmIdentifier._ext = []
    ___RemoveEntryResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __RemoveEntryResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___RemoveEntryResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___RemoveEntryResult_information_signed_algorithmIdentifier),
        ('signature', ___RemoveEntryResult_information_signed_signature),
        ])
    __RemoveEntryResult_information_signed._ext = []
    _RemoveEntryResult_information._cont = ASN1Dict([
        ('unsigned', __RemoveEntryResult_information_unsigned),
        ('signed', __RemoveEntryResult_information_signed),
        ])
    _RemoveEntryResult_information._ext = None
    RemoveEntryResult._cont = ASN1Dict([
        ('null', _RemoveEntryResult_null),
        ('information', _RemoveEntryResult_information),
        ])
    RemoveEntryResult._ext = []
    
    #-----< RemoveEntryResultData >-----#
    RemoveEntryResultData = SEQ(name='RemoveEntryResultData', mode=MODE_TYPE)
    _RemoveEntryResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RemoveEntryResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RemoveEntryResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RemoveEntryResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RemoveEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___RemoveEntryResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____RemoveEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____RemoveEntryResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____RemoveEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____RemoveEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____RemoveEntryResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____RemoveEntryResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___RemoveEntryResultData_notification__item__type._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    ___RemoveEntryResultData_notification__item__type._const_tab_at = None
    ___RemoveEntryResultData_notification__item__type._const_tab_id = 'id'
    ___RemoveEntryResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____RemoveEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____RemoveEntryResultData_notification__item__values__item_._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    ____RemoveEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____RemoveEntryResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___RemoveEntryResultData_notification__item__values._cont = ____RemoveEntryResultData_notification__item__values__item_
    ___RemoveEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___RemoveEntryResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____RemoveEntryResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___RemoveEntryResultData_notification__item__valuesWithContext._cont = ____RemoveEntryResultData_notification__item__valuesWithContext__item_
    ___RemoveEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __RemoveEntryResultData_notification__item_._cont = ASN1Dict([
        ('type', ___RemoveEntryResultData_notification__item__type),
        ('values', ___RemoveEntryResultData_notification__item__values),
        ('valuesWithContext', ___RemoveEntryResultData_notification__item__valuesWithContext),
        ])
    __RemoveEntryResultData_notification__item_._ext = []
    _RemoveEntryResultData_notification._cont = __RemoveEntryResultData_notification__item_
    RemoveEntryResultData._cont = ASN1Dict([
        ('securityParameters', _RemoveEntryResultData_securityParameters),
        ('performer', _RemoveEntryResultData_performer),
        ('aliasDereferenced', _RemoveEntryResultData_aliasDereferenced),
        ('notification', _RemoveEntryResultData_notification),
        ])
    RemoveEntryResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< modifyEntry >-----#
    modifyEntry = CLASS(name='modifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    _modifyEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    modifyEntry._val = dict([('ArgumentType', _modifyEntry_val_ArgumentType), ('ResultType', _modifyEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))])
    
    #-----< ModifyEntryArgument >-----#
    ModifyEntryArgument = CHOICE(name='ModifyEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ModifyEntryArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgumentData')))
    _ModifyEntryArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyEntryArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgumentData')))
    __ModifyEntryArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ModifyEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ModifyEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyEntryArgument_signed_algorithmIdentifier._ext = []
    __ModifyEntryArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ModifyEntryArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ModifyEntryArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ModifyEntryArgument_signed_algorithmIdentifier),
        ('signature', __ModifyEntryArgument_signed_signature),
        ])
    _ModifyEntryArgument_signed._ext = []
    ModifyEntryArgument._cont = ASN1Dict([
        ('unsigned', _ModifyEntryArgument_unsigned),
        ('signed', _ModifyEntryArgument_signed),
        ])
    ModifyEntryArgument._ext = None
    
    #-----< ModifyEntryArgumentData >-----#
    ModifyEntryArgumentData = SET(name='ModifyEntryArgumentData', mode=MODE_TYPE)
    _ModifyEntryArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ModifyEntryArgumentData_changes = SEQ_OF(name='changes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifyEntryArgumentData_changes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryModification')))
    _ModifyEntryArgumentData_changes._cont = __ModifyEntryArgumentData_changes__item_
    _ModifyEntryArgumentData_selection = SET(name='selection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), opt=True)
    _ModifyEntryArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ModifyEntryArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyEntryArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyEntryArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ModifyEntryArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyEntryArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyEntryArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ModifyEntryArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ModifyEntryArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ModifyEntryArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyEntryArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ModifyEntryArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ModifyEntryArgumentData._cont = ASN1Dict([
        ('object', _ModifyEntryArgumentData_object),
        ('changes', _ModifyEntryArgumentData_changes),
        ('selection', _ModifyEntryArgumentData_selection),
        ('serviceControls', _ModifyEntryArgumentData_serviceControls),
        ('securityParameters', _ModifyEntryArgumentData_securityParameters),
        ('requestor', _ModifyEntryArgumentData_requestor),
        ('operationProgress', _ModifyEntryArgumentData_operationProgress),
        ('aliasedRDNs', _ModifyEntryArgumentData_aliasedRDNs),
        ('criticalExtensions', _ModifyEntryArgumentData_criticalExtensions),
        ('referenceType', _ModifyEntryArgumentData_referenceType),
        ('entryOnly', _ModifyEntryArgumentData_entryOnly),
        ('exclusions', _ModifyEntryArgumentData_exclusions),
        ('nameResolveOnMaster', _ModifyEntryArgumentData_nameResolveOnMaster),
        ('operationContexts', _ModifyEntryArgumentData_operationContexts),
        ('familyGrouping', _ModifyEntryArgumentData_familyGrouping),
        ])
    ModifyEntryArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ModifyEntryResult >-----#
    ModifyEntryResult = CHOICE(name='ModifyEntryResult', mode=MODE_TYPE)
    _ModifyEntryResult_null = NULL(name='null', mode=MODE_TYPE)
    _ModifyEntryResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyEntryResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResultData')))
    __ModifyEntryResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyEntryResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResultData')))
    ___ModifyEntryResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ModifyEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyEntryResult_information_signed_algorithmIdentifier._ext = []
    ___ModifyEntryResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __ModifyEntryResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___ModifyEntryResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___ModifyEntryResult_information_signed_algorithmIdentifier),
        ('signature', ___ModifyEntryResult_information_signed_signature),
        ])
    __ModifyEntryResult_information_signed._ext = []
    _ModifyEntryResult_information._cont = ASN1Dict([
        ('unsigned', __ModifyEntryResult_information_unsigned),
        ('signed', __ModifyEntryResult_information_signed),
        ])
    _ModifyEntryResult_information._ext = None
    ModifyEntryResult._cont = ASN1Dict([
        ('null', _ModifyEntryResult_null),
        ('information', _ModifyEntryResult_information),
        ])
    ModifyEntryResult._ext = []
    
    #-----< ModifyEntryResultData >-----#
    ModifyEntryResultData = SEQ(name='ModifyEntryResultData', mode=MODE_TYPE)
    _ModifyEntryResultData_entry = SEQ(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')), opt=True)
    _ModifyEntryResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyEntryResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyEntryResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyEntryResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyEntryResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ModifyEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyEntryResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ModifyEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ModifyEntryResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ModifyEntryResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyEntryResultData_notification__item__type._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    ___ModifyEntryResultData_notification__item__type._const_tab_at = None
    ___ModifyEntryResultData_notification__item__type._const_tab_id = 'id'
    ___ModifyEntryResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ModifyEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ModifyEntryResultData_notification__item__values__item_._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    ____ModifyEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ModifyEntryResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ModifyEntryResultData_notification__item__values._cont = ____ModifyEntryResultData_notification__item__values__item_
    ___ModifyEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyEntryResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ModifyEntryResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyEntryResultData_notification__item__valuesWithContext._cont = ____ModifyEntryResultData_notification__item__valuesWithContext__item_
    ___ModifyEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyEntryResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ModifyEntryResultData_notification__item__type),
        ('values', ___ModifyEntryResultData_notification__item__values),
        ('valuesWithContext', ___ModifyEntryResultData_notification__item__valuesWithContext),
        ])
    __ModifyEntryResultData_notification__item_._ext = []
    _ModifyEntryResultData_notification._cont = __ModifyEntryResultData_notification__item_
    ModifyEntryResultData._cont = ASN1Dict([
        ('entry', _ModifyEntryResultData_entry),
        ('securityParameters', _ModifyEntryResultData_securityParameters),
        ('performer', _ModifyEntryResultData_performer),
        ('aliasDereferenced', _ModifyEntryResultData_aliasDereferenced),
        ('notification', _ModifyEntryResultData_notification),
        ])
    ModifyEntryResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< EntryModification >-----#
    EntryModification = CHOICE(name='EntryModification', mode=MODE_TYPE)
    _EntryModification_addAttribute = SEQ(name='addAttribute', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_addAttribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___EntryModification_addAttribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____EntryModification_addAttribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ____EntryModification_addAttribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___EntryModification_addAttribute_type_tab._val = ASN1Set(rv=[dict([('Type', ____EntryModification_addAttribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____EntryModification_addAttribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __EntryModification_addAttribute_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_addAttribute_type._const_tab_at = None
    __EntryModification_addAttribute_type._const_tab_id = 'id'
    __EntryModification_addAttribute_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_addAttribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_addAttribute_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_addAttribute_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_addAttribute_values__item_._const_tab_id = 'Type'
    __EntryModification_addAttribute_values._cont = ___EntryModification_addAttribute_values__item_
    __EntryModification_addAttribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_addAttribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_addAttribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_addAttribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_addAttribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_addAttribute_valuesWithContext__item__contextList._cont = _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_
    ____EntryModification_addAttribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_addAttribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_addAttribute_valuesWithContext__item__value),
        ('contextList', ____EntryModification_addAttribute_valuesWithContext__item__contextList),
        ])
    ___EntryModification_addAttribute_valuesWithContext__item_._ext = []
    __EntryModification_addAttribute_valuesWithContext._cont = ___EntryModification_addAttribute_valuesWithContext__item_
    __EntryModification_addAttribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_addAttribute._cont = ASN1Dict([
        ('type', __EntryModification_addAttribute_type),
        ('values', __EntryModification_addAttribute_values),
        ('valuesWithContext', __EntryModification_addAttribute_valuesWithContext),
        ])
    _EntryModification_addAttribute._ext = []
    _EntryModification_removeAttribute = OID(name='removeAttribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _EntryModification_addValues = SEQ(name='addValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_addValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __EntryModification_addValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_addValues_type._const_tab_at = None
    __EntryModification_addValues_type._const_tab_id = 'id'
    __EntryModification_addValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_addValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_addValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_addValues_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_addValues_values__item_._const_tab_id = 'Type'
    __EntryModification_addValues_values._cont = ___EntryModification_addValues_values__item_
    __EntryModification_addValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_addValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_addValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_addValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_addValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_addValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_addValues_valuesWithContext__item__contextList._cont = _____EntryModification_addValues_valuesWithContext__item__contextList__item_
    ____EntryModification_addValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_addValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_addValues_valuesWithContext__item__value),
        ('contextList', ____EntryModification_addValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_addValues_valuesWithContext__item_._ext = []
    __EntryModification_addValues_valuesWithContext._cont = ___EntryModification_addValues_valuesWithContext__item_
    __EntryModification_addValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_addValues._cont = ASN1Dict([
        ('type', __EntryModification_addValues_type),
        ('values', __EntryModification_addValues_values),
        ('valuesWithContext', __EntryModification_addValues_valuesWithContext),
        ])
    _EntryModification_addValues._ext = []
    _EntryModification_removeValues = SEQ(name='removeValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_removeValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __EntryModification_removeValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_removeValues_type._const_tab_at = None
    __EntryModification_removeValues_type._const_tab_id = 'id'
    __EntryModification_removeValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_removeValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_removeValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_removeValues_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_removeValues_values__item_._const_tab_id = 'Type'
    __EntryModification_removeValues_values._cont = ___EntryModification_removeValues_values__item_
    __EntryModification_removeValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_removeValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_removeValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_removeValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_removeValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_removeValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_removeValues_valuesWithContext__item__contextList._cont = _____EntryModification_removeValues_valuesWithContext__item__contextList__item_
    ____EntryModification_removeValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_removeValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_removeValues_valuesWithContext__item__value),
        ('contextList', ____EntryModification_removeValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_removeValues_valuesWithContext__item_._ext = []
    __EntryModification_removeValues_valuesWithContext._cont = ___EntryModification_removeValues_valuesWithContext__item_
    __EntryModification_removeValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_removeValues._cont = ASN1Dict([
        ('type', __EntryModification_removeValues_type),
        ('values', __EntryModification_removeValues_values),
        ('valuesWithContext', __EntryModification_removeValues_valuesWithContext),
        ])
    _EntryModification_removeValues._ext = []
    _EntryModification_alterValues = SEQ(name='alterValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _EntryModification_resetValue = OID(name='resetValue', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _EntryModification_replaceValues = SEQ(name='replaceValues', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_replaceValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __EntryModification_replaceValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_replaceValues_type._const_tab_at = None
    __EntryModification_replaceValues_type._const_tab_id = 'id'
    __EntryModification_replaceValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_replaceValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_replaceValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_replaceValues_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_replaceValues_values__item_._const_tab_id = 'Type'
    __EntryModification_replaceValues_values._cont = ___EntryModification_replaceValues_values__item_
    __EntryModification_replaceValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_replaceValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_replaceValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_replaceValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_replaceValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_replaceValues_valuesWithContext__item__contextList._cont = _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_
    ____EntryModification_replaceValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_replaceValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_replaceValues_valuesWithContext__item__value),
        ('contextList', ____EntryModification_replaceValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_replaceValues_valuesWithContext__item_._ext = []
    __EntryModification_replaceValues_valuesWithContext._cont = ___EntryModification_replaceValues_valuesWithContext__item_
    __EntryModification_replaceValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_replaceValues._cont = ASN1Dict([
        ('type', __EntryModification_replaceValues_type),
        ('values', __EntryModification_replaceValues_values),
        ('valuesWithContext', __EntryModification_replaceValues_valuesWithContext),
        ])
    _EntryModification_replaceValues._ext = []
    EntryModification._cont = ASN1Dict([
        ('addAttribute', _EntryModification_addAttribute),
        ('removeAttribute', _EntryModification_removeAttribute),
        ('addValues', _EntryModification_addValues),
        ('removeValues', _EntryModification_removeValues),
        ('alterValues', _EntryModification_alterValues),
        ('resetValue', _EntryModification_resetValue),
        ('replaceValues', _EntryModification_replaceValues),
        ])
    EntryModification._ext = []
    
    #-----< modifyDN >-----#
    modifyDN = CLASS(name='modifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyDN_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    _modifyDN_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    modifyDN._val = dict([('ArgumentType', _modifyDN_val_ArgumentType), ('ResultType', _modifyDN_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))])
    
    #-----< ModifyDNArgument >-----#
    ModifyDNArgument = CHOICE(name='ModifyDNArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ModifyDNArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgumentData')))
    _ModifyDNArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyDNArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgumentData')))
    __ModifyDNArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ModifyDNArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ModifyDNArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ModifyDNArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyDNArgument_signed_algorithmIdentifier._ext = []
    __ModifyDNArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ModifyDNArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ModifyDNArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ModifyDNArgument_signed_algorithmIdentifier),
        ('signature', __ModifyDNArgument_signed_signature),
        ])
    _ModifyDNArgument_signed._ext = []
    ModifyDNArgument._cont = ASN1Dict([
        ('unsigned', _ModifyDNArgument_unsigned),
        ('signed', _ModifyDNArgument_signed),
        ])
    ModifyDNArgument._ext = None
    
    #-----< ModifyDNArgumentData >-----#
    ModifyDNArgumentData = SET(name='ModifyDNArgumentData', mode=MODE_TYPE)
    _ModifyDNArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ModifyDNArgumentData_newRDN = SET_OF(name='newRDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _ModifyDNArgumentData_deleteOldRDN = BOOL(name='deleteOldRDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNArgumentData_newSuperior = SEQ_OF(name='newSuperior', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ModifyDNArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyDNArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ModifyDNArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyDNArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyDNArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ModifyDNArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ModifyDNArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ModifyDNArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ModifyDNArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ModifyDNArgumentData._cont = ASN1Dict([
        ('object', _ModifyDNArgumentData_object),
        ('newRDN', _ModifyDNArgumentData_newRDN),
        ('deleteOldRDN', _ModifyDNArgumentData_deleteOldRDN),
        ('newSuperior', _ModifyDNArgumentData_newSuperior),
        ('serviceControls', _ModifyDNArgumentData_serviceControls),
        ('securityParameters', _ModifyDNArgumentData_securityParameters),
        ('requestor', _ModifyDNArgumentData_requestor),
        ('operationProgress', _ModifyDNArgumentData_operationProgress),
        ('aliasedRDNs', _ModifyDNArgumentData_aliasedRDNs),
        ('criticalExtensions', _ModifyDNArgumentData_criticalExtensions),
        ('referenceType', _ModifyDNArgumentData_referenceType),
        ('entryOnly', _ModifyDNArgumentData_entryOnly),
        ('exclusions', _ModifyDNArgumentData_exclusions),
        ('nameResolveOnMaster', _ModifyDNArgumentData_nameResolveOnMaster),
        ('operationContexts', _ModifyDNArgumentData_operationContexts),
        ('familyGrouping', _ModifyDNArgumentData_familyGrouping),
        ])
    ModifyDNArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ModifyDNResult >-----#
    ModifyDNResult = CHOICE(name='ModifyDNResult', mode=MODE_TYPE)
    _ModifyDNResult_null = NULL(name='null', mode=MODE_TYPE)
    _ModifyDNResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyDNResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResultData')))
    __ModifyDNResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyDNResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResultData')))
    ___ModifyDNResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ModifyDNResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ModifyDNResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyDNResult_information_signed_algorithmIdentifier._ext = []
    ___ModifyDNResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __ModifyDNResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___ModifyDNResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___ModifyDNResult_information_signed_algorithmIdentifier),
        ('signature', ___ModifyDNResult_information_signed_signature),
        ])
    __ModifyDNResult_information_signed._ext = []
    _ModifyDNResult_information._cont = ASN1Dict([
        ('unsigned', __ModifyDNResult_information_unsigned),
        ('signed', __ModifyDNResult_information_signed),
        ])
    _ModifyDNResult_information._ext = None
    ModifyDNResult._cont = ASN1Dict([
        ('null', _ModifyDNResult_null),
        ('information', _ModifyDNResult_information),
        ])
    ModifyDNResult._ext = []
    
    #-----< ModifyDNResultData >-----#
    ModifyDNResultData = SEQ(name='ModifyDNResultData', mode=MODE_TYPE)
    _ModifyDNResultData_newRDN = SET_OF(name='newRDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _ModifyDNResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyDNResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyDNResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyDNResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ModifyDNResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyDNResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ModifyDNResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyDNResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ModifyDNResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ModifyDNResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyDNResultData_notification__item__type._const_tab = ____ModifyDNResultData_notification__item__type_tab
    ___ModifyDNResultData_notification__item__type._const_tab_at = None
    ___ModifyDNResultData_notification__item__type._const_tab_id = 'id'
    ___ModifyDNResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ModifyDNResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ModifyDNResultData_notification__item__values__item_._const_tab = ____ModifyDNResultData_notification__item__type_tab
    ____ModifyDNResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ModifyDNResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ModifyDNResultData_notification__item__values._cont = ____ModifyDNResultData_notification__item__values__item_
    ___ModifyDNResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyDNResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyDNResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyDNResultData_notification__item__type_tab
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyDNResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ModifyDNResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyDNResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyDNResultData_notification__item__valuesWithContext._cont = ____ModifyDNResultData_notification__item__valuesWithContext__item_
    ___ModifyDNResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyDNResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ModifyDNResultData_notification__item__type),
        ('values', ___ModifyDNResultData_notification__item__values),
        ('valuesWithContext', ___ModifyDNResultData_notification__item__valuesWithContext),
        ])
    __ModifyDNResultData_notification__item_._ext = []
    _ModifyDNResultData_notification._cont = __ModifyDNResultData_notification__item_
    ModifyDNResultData._cont = ASN1Dict([
        ('newRDN', _ModifyDNResultData_newRDN),
        ('securityParameters', _ModifyDNResultData_securityParameters),
        ('performer', _ModifyDNResultData_performer),
        ('aliasDereferenced', _ModifyDNResultData_aliasDereferenced),
        ('notification', _ModifyDNResultData_notification),
        ])
    ModifyDNResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< changePassword >-----#
    changePassword = CLASS(name='changePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _changePassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    _changePassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    changePassword._val = dict([('ArgumentType', _changePassword_val_ArgumentType), ('ResultType', _changePassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])
    
    #-----< ChangePasswordArgument >-----#
    ChangePasswordArgument = CHOICE(name='ChangePasswordArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _ChangePasswordArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgumentData')))
    _ChangePasswordArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ChangePasswordArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgumentData')))
    __ChangePasswordArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab = ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ChangePasswordArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ChangePasswordArgument_signed_algorithmIdentifier_parameters),
        ])
    __ChangePasswordArgument_signed_algorithmIdentifier._ext = []
    __ChangePasswordArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ChangePasswordArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ChangePasswordArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ChangePasswordArgument_signed_algorithmIdentifier),
        ('signature', __ChangePasswordArgument_signed_signature),
        ])
    _ChangePasswordArgument_signed._ext = []
    ChangePasswordArgument._cont = ASN1Dict([
        ('unsigned', _ChangePasswordArgument_unsigned),
        ('signed', _ChangePasswordArgument_signed),
        ])
    ChangePasswordArgument._ext = None
    
    #-----< ChangePasswordArgumentData >-----#
    ChangePasswordArgumentData = SEQ(name='ChangePasswordArgumentData', mode=MODE_TYPE)
    _ChangePasswordArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ChangePasswordArgumentData_oldPwd = CHOICE(name='oldPwd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    _ChangePasswordArgumentData_newPwd = CHOICE(name='newPwd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    ChangePasswordArgumentData._cont = ASN1Dict([
        ('object', _ChangePasswordArgumentData_object),
        ('oldPwd', _ChangePasswordArgumentData_oldPwd),
        ('newPwd', _ChangePasswordArgumentData_newPwd),
        ])
    ChangePasswordArgumentData._ext = []
    
    #-----< ChangePasswordResult >-----#
    ChangePasswordResult = CHOICE(name='ChangePasswordResult', mode=MODE_TYPE)
    _ChangePasswordResult_null = NULL(name='null', mode=MODE_TYPE)
    _ChangePasswordResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ChangePasswordResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResultData')))
    __ChangePasswordResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ChangePasswordResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResultData')))
    ___ChangePasswordResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ChangePasswordResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ChangePasswordResult_information_signed_algorithmIdentifier._ext = []
    ___ChangePasswordResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __ChangePasswordResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___ChangePasswordResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___ChangePasswordResult_information_signed_algorithmIdentifier),
        ('signature', ___ChangePasswordResult_information_signed_signature),
        ])
    __ChangePasswordResult_information_signed._ext = []
    _ChangePasswordResult_information._cont = ASN1Dict([
        ('unsigned', __ChangePasswordResult_information_unsigned),
        ('signed', __ChangePasswordResult_information_signed),
        ])
    _ChangePasswordResult_information._ext = None
    ChangePasswordResult._cont = ASN1Dict([
        ('null', _ChangePasswordResult_null),
        ('information', _ChangePasswordResult_information),
        ])
    ChangePasswordResult._ext = []
    
    #-----< ChangePasswordResultData >-----#
    ChangePasswordResultData = SEQ(name='ChangePasswordResultData', mode=MODE_TYPE)
    _ChangePasswordResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ChangePasswordResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChangePasswordResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChangePasswordResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChangePasswordResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ChangePasswordResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ChangePasswordResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ChangePasswordResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ChangePasswordResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ChangePasswordResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ChangePasswordResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ChangePasswordResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ChangePasswordResultData_notification__item__type._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    ___ChangePasswordResultData_notification__item__type._const_tab_at = None
    ___ChangePasswordResultData_notification__item__type._const_tab_id = 'id'
    ___ChangePasswordResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ChangePasswordResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ChangePasswordResultData_notification__item__values__item_._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    ____ChangePasswordResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ChangePasswordResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ChangePasswordResultData_notification__item__values._cont = ____ChangePasswordResultData_notification__item__values__item_
    ___ChangePasswordResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ChangePasswordResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList._cont = ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ChangePasswordResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_._ext = []
    ___ChangePasswordResultData_notification__item__valuesWithContext._cont = ____ChangePasswordResultData_notification__item__valuesWithContext__item_
    ___ChangePasswordResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ChangePasswordResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ChangePasswordResultData_notification__item__type),
        ('values', ___ChangePasswordResultData_notification__item__values),
        ('valuesWithContext', ___ChangePasswordResultData_notification__item__valuesWithContext),
        ])
    __ChangePasswordResultData_notification__item_._ext = []
    _ChangePasswordResultData_notification._cont = __ChangePasswordResultData_notification__item_
    ChangePasswordResultData._cont = ASN1Dict([
        ('securityParameters', _ChangePasswordResultData_securityParameters),
        ('performer', _ChangePasswordResultData_performer),
        ('aliasDereferenced', _ChangePasswordResultData_aliasDereferenced),
        ('notification', _ChangePasswordResultData_notification),
        ])
    ChangePasswordResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< administerPassword >-----#
    administerPassword = CLASS(name='administerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _administerPassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    _administerPassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    administerPassword._val = dict([('ArgumentType', _administerPassword_val_ArgumentType), ('ResultType', _administerPassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))])
    
    #-----< AdministerPasswordArgument >-----#
    AdministerPasswordArgument = CHOICE(name='AdministerPasswordArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _AdministerPasswordArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgumentData')))
    _AdministerPasswordArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AdministerPasswordArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgumentData')))
    __AdministerPasswordArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab = ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __AdministerPasswordArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters),
        ])
    __AdministerPasswordArgument_signed_algorithmIdentifier._ext = []
    __AdministerPasswordArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _AdministerPasswordArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __AdministerPasswordArgument_signed_toBeSigned),
        ('algorithmIdentifier', __AdministerPasswordArgument_signed_algorithmIdentifier),
        ('signature', __AdministerPasswordArgument_signed_signature),
        ])
    _AdministerPasswordArgument_signed._ext = []
    AdministerPasswordArgument._cont = ASN1Dict([
        ('unsigned', _AdministerPasswordArgument_unsigned),
        ('signed', _AdministerPasswordArgument_signed),
        ])
    AdministerPasswordArgument._ext = None
    
    #-----< AdministerPasswordArgumentData >-----#
    AdministerPasswordArgumentData = SEQ(name='AdministerPasswordArgumentData', mode=MODE_TYPE)
    _AdministerPasswordArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _AdministerPasswordArgumentData_newPwd = CHOICE(name='newPwd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    AdministerPasswordArgumentData._cont = ASN1Dict([
        ('object', _AdministerPasswordArgumentData_object),
        ('newPwd', _AdministerPasswordArgumentData_newPwd),
        ])
    AdministerPasswordArgumentData._ext = []
    
    #-----< AdministerPasswordResult >-----#
    AdministerPasswordResult = CHOICE(name='AdministerPasswordResult', mode=MODE_TYPE)
    _AdministerPasswordResult_null = NULL(name='null', mode=MODE_TYPE)
    _AdministerPasswordResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AdministerPasswordResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResultData')))
    __AdministerPasswordResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AdministerPasswordResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResultData')))
    ___AdministerPasswordResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___AdministerPasswordResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AdministerPasswordResult_information_signed_algorithmIdentifier._ext = []
    ___AdministerPasswordResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __AdministerPasswordResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___AdministerPasswordResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___AdministerPasswordResult_information_signed_algorithmIdentifier),
        ('signature', ___AdministerPasswordResult_information_signed_signature),
        ])
    __AdministerPasswordResult_information_signed._ext = []
    _AdministerPasswordResult_information._cont = ASN1Dict([
        ('unsigned', __AdministerPasswordResult_information_unsigned),
        ('signed', __AdministerPasswordResult_information_signed),
        ])
    _AdministerPasswordResult_information._ext = None
    AdministerPasswordResult._cont = ASN1Dict([
        ('null', _AdministerPasswordResult_null),
        ('information', _AdministerPasswordResult_information),
        ])
    AdministerPasswordResult._ext = []
    
    #-----< AdministerPasswordResultData >-----#
    AdministerPasswordResultData = SEQ(name='AdministerPasswordResultData', mode=MODE_TYPE)
    _AdministerPasswordResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AdministerPasswordResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AdministerPasswordResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AdministerPasswordResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AdministerPasswordResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AdministerPasswordResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AdministerPasswordResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AdministerPasswordResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AdministerPasswordResultData_notification__item__type._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    ___AdministerPasswordResultData_notification__item__type._const_tab_at = None
    ___AdministerPasswordResultData_notification__item__type._const_tab_id = 'id'
    ___AdministerPasswordResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AdministerPasswordResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___AdministerPasswordResultData_notification__item__values._cont = ____AdministerPasswordResultData_notification__item__values__item_
    ___AdministerPasswordResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AdministerPasswordResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList._cont = ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_._ext = []
    ___AdministerPasswordResultData_notification__item__valuesWithContext._cont = ____AdministerPasswordResultData_notification__item__valuesWithContext__item_
    ___AdministerPasswordResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AdministerPasswordResultData_notification__item_._cont = ASN1Dict([
        ('type', ___AdministerPasswordResultData_notification__item__type),
        ('values', ___AdministerPasswordResultData_notification__item__values),
        ('valuesWithContext', ___AdministerPasswordResultData_notification__item__valuesWithContext),
        ])
    __AdministerPasswordResultData_notification__item_._ext = []
    _AdministerPasswordResultData_notification._cont = __AdministerPasswordResultData_notification__item_
    AdministerPasswordResultData._cont = ASN1Dict([
        ('securityParameters', _AdministerPasswordResultData_securityParameters),
        ('performer', _AdministerPasswordResultData_performer),
        ('aliasDereferenced', _AdministerPasswordResultData_aliasDereferenced),
        ('notification', _AdministerPasswordResultData_notification),
        ])
    AdministerPasswordResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ldapTransport >-----#
    ldapTransport = CLASS(name='ldapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _ldapTransport_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    _ldapTransport_val_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE)
    __ldapTransport_val_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _ldapTransport_val_ResultType._cont = __ldapTransport_val_ResultType__item_
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    ldapTransport._val = dict([('ArgumentType', _ldapTransport_val_ArgumentType), ('ResultType', _ldapTransport_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))])
    
    #-----< LdapArgument >-----#
    LdapArgument = CHOICE(name='LdapArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LdapArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgumentData')))
    _LdapArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LdapArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgumentData')))
    __LdapArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LdapArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____LdapArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab = ____LdapArgument_signed_algorithmIdentifier_algorithm_tab
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___LdapArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____LdapArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab = ____LdapArgument_signed_algorithmIdentifier_parameters_tab
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __LdapArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___LdapArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___LdapArgument_signed_algorithmIdentifier_parameters),
        ])
    __LdapArgument_signed_algorithmIdentifier._ext = []
    __LdapArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _LdapArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __LdapArgument_signed_toBeSigned),
        ('algorithmIdentifier', __LdapArgument_signed_algorithmIdentifier),
        ('signature', __LdapArgument_signed_signature),
        ])
    _LdapArgument_signed._ext = []
    LdapArgument._cont = ASN1Dict([
        ('unsigned', _LdapArgument_unsigned),
        ('signed', _LdapArgument_signed),
        ])
    LdapArgument._ext = None
    
    #-----< LdapArgumentData >-----#
    LdapArgumentData = SEQ(name='LdapArgumentData', mode=MODE_TYPE)
    _LdapArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _LdapArgumentData_ldapMessage = SEQ(name='ldapMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LdapArgumentData_linkId = INT(name='linkId', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkId')), opt=True)
    _LdapArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _LdapArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LdapArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LdapArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _LdapArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LdapArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LdapArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _LdapArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _LdapArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _LdapArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LdapArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _LdapArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    LdapArgumentData._cont = ASN1Dict([
        ('object', _LdapArgumentData_object),
        ('ldapMessage', _LdapArgumentData_ldapMessage),
        ('linkId', _LdapArgumentData_linkId),
        ('serviceControls', _LdapArgumentData_serviceControls),
        ('securityParameters', _LdapArgumentData_securityParameters),
        ('requestor', _LdapArgumentData_requestor),
        ('operationProgress', _LdapArgumentData_operationProgress),
        ('aliasedRDNs', _LdapArgumentData_aliasedRDNs),
        ('criticalExtensions', _LdapArgumentData_criticalExtensions),
        ('referenceType', _LdapArgumentData_referenceType),
        ('entryOnly', _LdapArgumentData_entryOnly),
        ('exclusions', _LdapArgumentData_exclusions),
        ('nameResolveOnMaster', _LdapArgumentData_nameResolveOnMaster),
        ('operationContexts', _LdapArgumentData_operationContexts),
        ('familyGrouping', _LdapArgumentData_familyGrouping),
        ])
    LdapArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< LinkId >-----#
    LinkId = INT(name='LinkId', mode=MODE_TYPE)
    
    #-----< LdapResult >-----#
    LdapResult = CHOICE(name='LdapResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LdapResult_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapResultData')))
    _LdapResult_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LdapResult_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapResultData')))
    __LdapResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LdapResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____LdapResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab = ____LdapResult_signed_algorithmIdentifier_algorithm_tab
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___LdapResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____LdapResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab = ____LdapResult_signed_algorithmIdentifier_parameters_tab
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __LdapResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___LdapResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___LdapResult_signed_algorithmIdentifier_parameters),
        ])
    __LdapResult_signed_algorithmIdentifier._ext = []
    __LdapResult_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _LdapResult_signed._cont = ASN1Dict([
        ('toBeSigned', __LdapResult_signed_toBeSigned),
        ('algorithmIdentifier', __LdapResult_signed_algorithmIdentifier),
        ('signature', __LdapResult_signed_signature),
        ])
    _LdapResult_signed._ext = []
    LdapResult._cont = ASN1Dict([
        ('unsigned', _LdapResult_unsigned),
        ('signed', _LdapResult_signed),
        ])
    LdapResult._ext = None
    
    #-----< LdapResultData >-----#
    LdapResultData = SEQ(name='LdapResultData', mode=MODE_TYPE)
    _LdapResultData_ldapMessages = SEQ_OF(name='ldapMessages', mode=MODE_TYPE, opt=True)
    __LdapResultData_ldapMessages__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LdapResultData_ldapMessages._cont = __LdapResultData_ldapMessages__item_
    _LdapResultData_ldapMessages._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _LdapResultData_returnToClient = BOOL(name='returnToClient', mode=MODE_TYPE, default=False)
    _LdapResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LdapResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LdapResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LdapResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __LdapResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___LdapResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____LdapResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____LdapResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____LdapResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____LdapResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____LdapResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____LdapResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___LdapResultData_notification__item__type._const_tab = ____LdapResultData_notification__item__type_tab
    ___LdapResultData_notification__item__type._const_tab_at = None
    ___LdapResultData_notification__item__type._const_tab_id = 'id'
    ___LdapResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____LdapResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____LdapResultData_notification__item__values__item_._const_tab = ____LdapResultData_notification__item__type_tab
    ____LdapResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____LdapResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___LdapResultData_notification__item__values._cont = ____LdapResultData_notification__item__values__item_
    ___LdapResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___LdapResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____LdapResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____LdapResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab = ____LdapResultData_notification__item__type_tab
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____LdapResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____LdapResultData_notification__item__valuesWithContext__item__contextList._cont = ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_
    _____LdapResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____LdapResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____LdapResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____LdapResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____LdapResultData_notification__item__valuesWithContext__item_._ext = []
    ___LdapResultData_notification__item__valuesWithContext._cont = ____LdapResultData_notification__item__valuesWithContext__item_
    ___LdapResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __LdapResultData_notification__item_._cont = ASN1Dict([
        ('type', ___LdapResultData_notification__item__type),
        ('values', ___LdapResultData_notification__item__values),
        ('valuesWithContext', ___LdapResultData_notification__item__valuesWithContext),
        ])
    __LdapResultData_notification__item_._ext = []
    _LdapResultData_notification._cont = __LdapResultData_notification__item_
    LdapResultData._cont = ASN1Dict([
        ('ldapMessages', _LdapResultData_ldapMessages),
        ('returnToClient', _LdapResultData_returnToClient),
        ('securityParameters', _LdapResultData_securityParameters),
        ('performer', _LdapResultData_performer),
        ('aliasDereferenced', _LdapResultData_aliasDereferenced),
        ('notification', _LdapResultData_notification),
        ])
    LdapResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< linkedLDAP >-----#
    linkedLDAP = CLASS(name='linkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _linkedLDAP_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    _linkedLDAP_val_ResultType = NULL(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    linkedLDAP._val = dict([('ArgumentType', _linkedLDAP_val_ArgumentType), ('ResultType', _linkedLDAP_val_ResultType), ('operationCode', ('local', 13))])
    
    #-----< LinkedArgument >-----#
    LinkedArgument = CHOICE(name='LinkedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LinkedArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgumentData')))
    _LinkedArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LinkedArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgumentData')))
    __LinkedArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LinkedArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab = ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___LinkedArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____LinkedArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LinkedArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab = ____LinkedArgument_signed_algorithmIdentifier_parameters_tab
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __LinkedArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___LinkedArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___LinkedArgument_signed_algorithmIdentifier_parameters),
        ])
    __LinkedArgument_signed_algorithmIdentifier._ext = []
    __LinkedArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _LinkedArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __LinkedArgument_signed_toBeSigned),
        ('algorithmIdentifier', __LinkedArgument_signed_algorithmIdentifier),
        ('signature', __LinkedArgument_signed_signature),
        ])
    _LinkedArgument_signed._ext = []
    LinkedArgument._cont = ASN1Dict([
        ('unsigned', _LinkedArgument_unsigned),
        ('signed', _LinkedArgument_signed),
        ])
    LinkedArgument._ext = None
    
    #-----< LinkedArgumentData >-----#
    LinkedArgumentData = SEQ(name='LinkedArgumentData', mode=MODE_TYPE)
    _LinkedArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _LinkedArgumentData_ldapMessage = SEQ(name='ldapMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LinkedArgumentData_linkId = INT(name='linkId', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkId')))
    _LinkedArgumentData_returnToClient = BOOL(name='returnToClient', mode=MODE_TYPE, default=False)
    _LinkedArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _LinkedArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LinkedArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LinkedArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _LinkedArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LinkedArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LinkedArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _LinkedArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _LinkedArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _LinkedArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LinkedArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _LinkedArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    LinkedArgumentData._cont = ASN1Dict([
        ('object', _LinkedArgumentData_object),
        ('ldapMessage', _LinkedArgumentData_ldapMessage),
        ('linkId', _LinkedArgumentData_linkId),
        ('returnToClient', _LinkedArgumentData_returnToClient),
        ('serviceControls', _LinkedArgumentData_serviceControls),
        ('securityParameters', _LinkedArgumentData_securityParameters),
        ('requestor', _LinkedArgumentData_requestor),
        ('operationProgress', _LinkedArgumentData_operationProgress),
        ('aliasedRDNs', _LinkedArgumentData_aliasedRDNs),
        ('criticalExtensions', _LinkedArgumentData_criticalExtensions),
        ('referenceType', _LinkedArgumentData_referenceType),
        ('entryOnly', _LinkedArgumentData_entryOnly),
        ('exclusions', _LinkedArgumentData_exclusions),
        ('nameResolveOnMaster', _LinkedArgumentData_nameResolveOnMaster),
        ('operationContexts', _LinkedArgumentData_operationContexts),
        ('familyGrouping', _LinkedArgumentData_familyGrouping),
        ])
    LinkedArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< LinkedResult >-----#
    LinkedResult = NULL(name='LinkedResult', mode=MODE_TYPE)
    
    #-----< abandoned >-----#
    abandoned = CLASS(name='abandoned', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _abandoned_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __abandoned_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    __abandoned_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___abandoned_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___abandoned_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___abandoned_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___abandoned_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___abandoned_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __abandoned_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___abandoned_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___abandoned_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___abandoned_val_ParameterType_signed_signature),
        ])
    __abandoned_val_ParameterType_signed._ext = []
    _abandoned_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __abandoned_val_ParameterType_unsigned),
        ('signed', __abandoned_val_ParameterType_signed),
        ])
    _abandoned_val_ParameterType._ext = None
    abandoned._val = dict([('ParameterType', _abandoned_val_ParameterType), ('errorCode', ('local', 5))])
    
    #-----< AbandonedData >-----#
    AbandonedData = SET(name='AbandonedData', mode=MODE_TYPE)
    _AbandonedData_problem = ENUM(name='problem', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedProblem')), opt=True)
    _AbandonedData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonedData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonedData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonedData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonedData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonedData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AbandonedData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonedData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AbandonedData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonedData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AbandonedData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AbandonedData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonedData_notification__item__type._const_tab = ____AbandonedData_notification__item__type_tab
    ___AbandonedData_notification__item__type._const_tab_at = None
    ___AbandonedData_notification__item__type._const_tab_id = 'id'
    ___AbandonedData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AbandonedData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AbandonedData_notification__item__values__item_._const_tab = ____AbandonedData_notification__item__type_tab
    ____AbandonedData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AbandonedData_notification__item__values__item_._const_tab_id = 'Type'
    ___AbandonedData_notification__item__values._cont = ____AbandonedData_notification__item__values__item_
    ___AbandonedData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonedData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonedData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonedData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonedData_notification__item__type_tab
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AbandonedData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonedData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonedData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonedData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AbandonedData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AbandonedData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonedData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonedData_notification__item__valuesWithContext._cont = ____AbandonedData_notification__item__valuesWithContext__item_
    ___AbandonedData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonedData_notification__item_._cont = ASN1Dict([
        ('type', ___AbandonedData_notification__item__type),
        ('values', ___AbandonedData_notification__item__values),
        ('valuesWithContext', ___AbandonedData_notification__item__valuesWithContext),
        ])
    __AbandonedData_notification__item_._ext = []
    _AbandonedData_notification._cont = __AbandonedData_notification__item_
    AbandonedData._cont = ASN1Dict([
        ('problem', _AbandonedData_problem),
        ('securityParameters', _AbandonedData_securityParameters),
        ('performer', _AbandonedData_performer),
        ('aliasDereferenced', _AbandonedData_aliasDereferenced),
        ('notification', _AbandonedData_notification),
        ])
    AbandonedData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< AbandonedProblem >-----#
    AbandonedProblem = ENUM(name='AbandonedProblem', mode=MODE_TYPE)
    AbandonedProblem._cont = ASN1Dict([('pagingAbandoned', 0)])
    AbandonedProblem._ext = None
    
    #-----< abandonFailed >-----#
    abandonFailed = CLASS(name='abandonFailed', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _abandonFailed_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __abandonFailed_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    __abandonFailed_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___abandonFailed_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___abandonFailed_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __abandonFailed_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___abandonFailed_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___abandonFailed_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___abandonFailed_val_ParameterType_signed_signature),
        ])
    __abandonFailed_val_ParameterType_signed._ext = []
    _abandonFailed_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __abandonFailed_val_ParameterType_unsigned),
        ('signed', __abandonFailed_val_ParameterType_signed),
        ])
    _abandonFailed_val_ParameterType._ext = None
    abandonFailed._val = dict([('ParameterType', _abandonFailed_val_ParameterType), ('errorCode', ('local', 7))])
    
    #-----< AbandonFailedData >-----#
    AbandonFailedData = SET(name='AbandonFailedData', mode=MODE_TYPE)
    _AbandonFailedData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonProblem')))
    _AbandonFailedData_operation = CHOICE(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _AbandonFailedData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonFailedData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonFailedData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonFailedData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonFailedData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonFailedData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AbandonFailedData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonFailedData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AbandonFailedData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonFailedData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AbandonFailedData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AbandonFailedData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonFailedData_notification__item__type._const_tab = ____AbandonFailedData_notification__item__type_tab
    ___AbandonFailedData_notification__item__type._const_tab_at = None
    ___AbandonFailedData_notification__item__type._const_tab_id = 'id'
    ___AbandonFailedData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AbandonFailedData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AbandonFailedData_notification__item__values__item_._const_tab = ____AbandonFailedData_notification__item__type_tab
    ____AbandonFailedData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AbandonFailedData_notification__item__values__item_._const_tab_id = 'Type'
    ___AbandonFailedData_notification__item__values._cont = ____AbandonFailedData_notification__item__values__item_
    ___AbandonFailedData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonFailedData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonFailedData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonFailedData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonFailedData_notification__item__type_tab
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonFailedData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AbandonFailedData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AbandonFailedData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonFailedData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonFailedData_notification__item__valuesWithContext._cont = ____AbandonFailedData_notification__item__valuesWithContext__item_
    ___AbandonFailedData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonFailedData_notification__item_._cont = ASN1Dict([
        ('type', ___AbandonFailedData_notification__item__type),
        ('values', ___AbandonFailedData_notification__item__values),
        ('valuesWithContext', ___AbandonFailedData_notification__item__valuesWithContext),
        ])
    __AbandonFailedData_notification__item_._ext = []
    _AbandonFailedData_notification._cont = __AbandonFailedData_notification__item_
    AbandonFailedData._cont = ASN1Dict([
        ('problem', _AbandonFailedData_problem),
        ('operation', _AbandonFailedData_operation),
        ('securityParameters', _AbandonFailedData_securityParameters),
        ('performer', _AbandonFailedData_performer),
        ('aliasDereferenced', _AbandonFailedData_aliasDereferenced),
        ('notification', _AbandonFailedData_notification),
        ])
    AbandonFailedData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< AbandonProblem >-----#
    AbandonProblem = INT(name='AbandonProblem', mode=MODE_TYPE)
    AbandonProblem._cont = ASN1Dict([('noSuchOperation', 1), ('tooLate', 2), ('cannotAbandon', 3)])
    
    #-----< attributeError >-----#
    attributeError = CLASS(name='attributeError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _attributeError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __attributeError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    __attributeError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___attributeError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___attributeError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___attributeError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___attributeError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___attributeError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __attributeError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___attributeError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___attributeError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___attributeError_val_ParameterType_signed_signature),
        ])
    __attributeError_val_ParameterType_signed._ext = []
    _attributeError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __attributeError_val_ParameterType_unsigned),
        ('signed', __attributeError_val_ParameterType_signed),
        ])
    _attributeError_val_ParameterType._ext = None
    attributeError._val = dict([('ParameterType', _attributeError_val_ParameterType), ('errorCode', ('local', 1))])
    
    #-----< AttributeErrorData >-----#
    AttributeErrorData = SET(name='AttributeErrorData', mode=MODE_TYPE)
    _AttributeErrorData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AttributeErrorData_problems = SET_OF(name='problems', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeErrorData_problems__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___AttributeErrorData_problems__item__problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeProblem')))
    ___AttributeErrorData_problems__item__type = OID(name='type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___AttributeErrorData_problems__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValue')), opt=True)
    __AttributeErrorData_problems__item_._cont = ASN1Dict([
        ('problem', ___AttributeErrorData_problems__item__problem),
        ('type', ___AttributeErrorData_problems__item__type),
        ('value', ___AttributeErrorData_problems__item__value),
        ])
    __AttributeErrorData_problems__item_._ext = []
    _AttributeErrorData_problems._cont = __AttributeErrorData_problems__item_
    _AttributeErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AttributeErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AttributeErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AttributeErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AttributeErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AttributeErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AttributeErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AttributeErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AttributeErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AttributeErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AttributeErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AttributeErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AttributeErrorData_notification__item__type._const_tab = ____AttributeErrorData_notification__item__type_tab
    ___AttributeErrorData_notification__item__type._const_tab_at = None
    ___AttributeErrorData_notification__item__type._const_tab_id = 'id'
    ___AttributeErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AttributeErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AttributeErrorData_notification__item__values__item_._const_tab = ____AttributeErrorData_notification__item__type_tab
    ____AttributeErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AttributeErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___AttributeErrorData_notification__item__values._cont = ____AttributeErrorData_notification__item__values__item_
    ___AttributeErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AttributeErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AttributeErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AttributeErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab = ____AttributeErrorData_notification__item__type_tab
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList._cont = ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AttributeErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AttributeErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AttributeErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AttributeErrorData_notification__item__valuesWithContext__item_._ext = []
    ___AttributeErrorData_notification__item__valuesWithContext._cont = ____AttributeErrorData_notification__item__valuesWithContext__item_
    ___AttributeErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AttributeErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___AttributeErrorData_notification__item__type),
        ('values', ___AttributeErrorData_notification__item__values),
        ('valuesWithContext', ___AttributeErrorData_notification__item__valuesWithContext),
        ])
    __AttributeErrorData_notification__item_._ext = []
    _AttributeErrorData_notification._cont = __AttributeErrorData_notification__item_
    AttributeErrorData._cont = ASN1Dict([
        ('object', _AttributeErrorData_object),
        ('problems', _AttributeErrorData_problems),
        ('securityParameters', _AttributeErrorData_securityParameters),
        ('performer', _AttributeErrorData_performer),
        ('aliasDereferenced', _AttributeErrorData_aliasDereferenced),
        ('notification', _AttributeErrorData_notification),
        ])
    AttributeErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< AttributeProblem >-----#
    AttributeProblem = INT(name='AttributeProblem', mode=MODE_TYPE)
    AttributeProblem._cont = ASN1Dict([('noSuchAttributeOrValue', 1), ('invalidAttributeSyntax', 2), ('undefinedAttributeType', 3), ('inappropriateMatching', 4), ('constraintViolation', 5), ('attributeOrValueAlreadyExists', 6), ('contextViolation', 7)])
    
    #-----< nameError >-----#
    nameError = CLASS(name='nameError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _nameError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __nameError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    __nameError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___nameError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___nameError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___nameError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___nameError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___nameError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __nameError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___nameError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___nameError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___nameError_val_ParameterType_signed_signature),
        ])
    __nameError_val_ParameterType_signed._ext = []
    _nameError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __nameError_val_ParameterType_unsigned),
        ('signed', __nameError_val_ParameterType_signed),
        ])
    _nameError_val_ParameterType._ext = None
    nameError._val = dict([('ParameterType', _nameError_val_ParameterType), ('errorCode', ('local', 2))])
    
    #-----< NameErrorData >-----#
    NameErrorData = SET(name='NameErrorData', mode=MODE_TYPE)
    _NameErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'NameProblem')))
    _NameErrorData_matched = CHOICE(name='matched', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _NameErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _NameErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _NameErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _NameErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NameErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___NameErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____NameErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____NameErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____NameErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____NameErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____NameErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____NameErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___NameErrorData_notification__item__type._const_tab = ____NameErrorData_notification__item__type_tab
    ___NameErrorData_notification__item__type._const_tab_at = None
    ___NameErrorData_notification__item__type._const_tab_id = 'id'
    ___NameErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____NameErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____NameErrorData_notification__item__values__item_._const_tab = ____NameErrorData_notification__item__type_tab
    ____NameErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____NameErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___NameErrorData_notification__item__values._cont = ____NameErrorData_notification__item__values__item_
    ___NameErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___NameErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____NameErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____NameErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab = ____NameErrorData_notification__item__type_tab
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____NameErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____NameErrorData_notification__item__valuesWithContext__item__contextList._cont = ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____NameErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____NameErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____NameErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____NameErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____NameErrorData_notification__item__valuesWithContext__item_._ext = []
    ___NameErrorData_notification__item__valuesWithContext._cont = ____NameErrorData_notification__item__valuesWithContext__item_
    ___NameErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __NameErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___NameErrorData_notification__item__type),
        ('values', ___NameErrorData_notification__item__values),
        ('valuesWithContext', ___NameErrorData_notification__item__valuesWithContext),
        ])
    __NameErrorData_notification__item_._ext = []
    _NameErrorData_notification._cont = __NameErrorData_notification__item_
    NameErrorData._cont = ASN1Dict([
        ('problem', _NameErrorData_problem),
        ('matched', _NameErrorData_matched),
        ('securityParameters', _NameErrorData_securityParameters),
        ('performer', _NameErrorData_performer),
        ('aliasDereferenced', _NameErrorData_aliasDereferenced),
        ('notification', _NameErrorData_notification),
        ])
    NameErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< NameProblem >-----#
    NameProblem = INT(name='NameProblem', mode=MODE_TYPE)
    NameProblem._cont = ASN1Dict([('noSuchObject', 1), ('aliasProblem', 2), ('invalidAttributeSyntax', 3), ('aliasDereferencingProblem', 4)])
    
    #-----< referral >-----#
    referral = CLASS(name='referral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _referral_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __referral_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    __referral_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___referral_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___referral_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___referral_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____referral_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___referral_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___referral_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __referral_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___referral_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___referral_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___referral_val_ParameterType_signed_signature),
        ])
    __referral_val_ParameterType_signed._ext = []
    _referral_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __referral_val_ParameterType_unsigned),
        ('signed', __referral_val_ParameterType_signed),
        ])
    _referral_val_ParameterType._ext = None
    referral._val = dict([('ParameterType', _referral_val_ParameterType), ('errorCode', ('local', 4))])
    
    #-----< ReferralData >-----#
    ReferralData = SET(name='ReferralData', mode=MODE_TYPE)
    _ReferralData_candidate = SET(name='candidate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _ReferralData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReferralData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReferralData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReferralData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ReferralData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ReferralData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ReferralData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ReferralData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ReferralData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ReferralData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ReferralData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ReferralData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ReferralData_notification__item__type._const_tab = ____ReferralData_notification__item__type_tab
    ___ReferralData_notification__item__type._const_tab_at = None
    ___ReferralData_notification__item__type._const_tab_id = 'id'
    ___ReferralData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ReferralData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ReferralData_notification__item__values__item_._const_tab = ____ReferralData_notification__item__type_tab
    ____ReferralData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ReferralData_notification__item__values__item_._const_tab_id = 'Type'
    ___ReferralData_notification__item__values._cont = ____ReferralData_notification__item__values__item_
    ___ReferralData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ReferralData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ReferralData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ReferralData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab = ____ReferralData_notification__item__type_tab
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ReferralData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ReferralData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ReferralData_notification__item__valuesWithContext__item__contextList._cont = ______ReferralData_notification__item__valuesWithContext__item__contextList__item_
    _____ReferralData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ReferralData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ReferralData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ReferralData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ReferralData_notification__item__valuesWithContext__item_._ext = []
    ___ReferralData_notification__item__valuesWithContext._cont = ____ReferralData_notification__item__valuesWithContext__item_
    ___ReferralData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ReferralData_notification__item_._cont = ASN1Dict([
        ('type', ___ReferralData_notification__item__type),
        ('values', ___ReferralData_notification__item__values),
        ('valuesWithContext', ___ReferralData_notification__item__valuesWithContext),
        ])
    __ReferralData_notification__item_._ext = []
    _ReferralData_notification._cont = __ReferralData_notification__item_
    ReferralData._cont = ASN1Dict([
        ('candidate', _ReferralData_candidate),
        ('securityParameters', _ReferralData_securityParameters),
        ('performer', _ReferralData_performer),
        ('aliasDereferenced', _ReferralData_aliasDereferenced),
        ('notification', _ReferralData_notification),
        ])
    ReferralData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< securityError >-----#
    securityError = CLASS(name='securityError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _securityError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __securityError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    __securityError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___securityError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___securityError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___securityError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___securityError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___securityError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __securityError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___securityError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___securityError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___securityError_val_ParameterType_signed_signature),
        ])
    __securityError_val_ParameterType_signed._ext = []
    _securityError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __securityError_val_ParameterType_unsigned),
        ('signed', __securityError_val_ParameterType_signed),
        ])
    _securityError_val_ParameterType._ext = None
    securityError._val = dict([('ParameterType', _securityError_val_ParameterType), ('errorCode', ('local', 6))])
    
    #-----< SecurityErrorData >-----#
    SecurityErrorData = SET(name='SecurityErrorData', mode=MODE_TYPE)
    _SecurityErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _SecurityErrorData_spkmInfo = SEQ(name='spkmInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-ERROR')), opt=True)
    _SecurityErrorData_encPwdInfo = SEQ(name='encPwdInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EncPwdInfo')), opt=True)
    _SecurityErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _SecurityErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SecurityErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SecurityErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SecurityErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SecurityErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SecurityErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SecurityErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SecurityErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SecurityErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SecurityErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SecurityErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SecurityErrorData_notification__item__type._const_tab = ____SecurityErrorData_notification__item__type_tab
    ___SecurityErrorData_notification__item__type._const_tab_at = None
    ___SecurityErrorData_notification__item__type._const_tab_id = 'id'
    ___SecurityErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SecurityErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SecurityErrorData_notification__item__values__item_._const_tab = ____SecurityErrorData_notification__item__type_tab
    ____SecurityErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SecurityErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___SecurityErrorData_notification__item__values._cont = ____SecurityErrorData_notification__item__values__item_
    ___SecurityErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SecurityErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SecurityErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SecurityErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab = ____SecurityErrorData_notification__item__type_tab
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList._cont = ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SecurityErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SecurityErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____SecurityErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____SecurityErrorData_notification__item__valuesWithContext__item_._ext = []
    ___SecurityErrorData_notification__item__valuesWithContext._cont = ____SecurityErrorData_notification__item__valuesWithContext__item_
    ___SecurityErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SecurityErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___SecurityErrorData_notification__item__type),
        ('values', ___SecurityErrorData_notification__item__values),
        ('valuesWithContext', ___SecurityErrorData_notification__item__valuesWithContext),
        ])
    __SecurityErrorData_notification__item_._ext = []
    _SecurityErrorData_notification._cont = __SecurityErrorData_notification__item_
    SecurityErrorData._cont = ASN1Dict([
        ('problem', _SecurityErrorData_problem),
        ('spkmInfo', _SecurityErrorData_spkmInfo),
        ('encPwdInfo', _SecurityErrorData_encPwdInfo),
        ('securityParameters', _SecurityErrorData_securityParameters),
        ('performer', _SecurityErrorData_performer),
        ('aliasDereferenced', _SecurityErrorData_aliasDereferenced),
        ('notification', _SecurityErrorData_notification),
        ])
    SecurityErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< SecurityProblem >-----#
    SecurityProblem = INT(name='SecurityProblem', mode=MODE_TYPE)
    SecurityProblem._cont = ASN1Dict([('inappropriateAuthentication', 1), ('invalidCredentials', 2), ('insufficientAccessRights', 3), ('invalidSignature', 4), ('protectionRequired', 5), ('noInformation', 6), ('blockedCredentials', 7), ('spkmError', 9), ('unsupportedAuthenticationMethod', 10), ('passwordExpired', 11), ('inappropriateAlgorithms', 12)])
    
    #-----< EncPwdInfo >-----#
    EncPwdInfo = SEQ(name='EncPwdInfo', mode=MODE_TYPE)
    _EncPwdInfo_algorithms = SEQ_OF(name='algorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EncPwdInfo_algorithms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EncPwdInfo_algorithms__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____EncPwdInfo_algorithms__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EncPwdInfo_algorithms__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncPwdInfo_algorithms__item__algorithm._const_tab = ____EncPwdInfo_algorithms__item__algorithm_tab
    ___EncPwdInfo_algorithms__item__algorithm._const_tab_at = None
    ___EncPwdInfo_algorithms__item__algorithm._const_tab_id = 'id'
    ___EncPwdInfo_algorithms__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____EncPwdInfo_algorithms__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EncPwdInfo_algorithms__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncPwdInfo_algorithms__item__parameters._const_tab = ____EncPwdInfo_algorithms__item__parameters_tab
    ___EncPwdInfo_algorithms__item__parameters._const_tab_at = ('..', 'algorithm')
    ___EncPwdInfo_algorithms__item__parameters._const_tab_id = 'Type'
    __EncPwdInfo_algorithms__item_._cont = ASN1Dict([
        ('algorithm', ___EncPwdInfo_algorithms__item__algorithm),
        ('parameters', ___EncPwdInfo_algorithms__item__parameters),
        ])
    __EncPwdInfo_algorithms__item_._ext = []
    _EncPwdInfo_algorithms._cont = __EncPwdInfo_algorithms__item_
    _EncPwdInfo_pwdQualityRule = SEQ_OF(name='pwdQualityRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EncPwdInfo_pwdQualityRule__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _EncPwdInfo_pwdQualityRule._cont = __EncPwdInfo_pwdQualityRule__item_
    EncPwdInfo._cont = ASN1Dict([
        ('algorithms', _EncPwdInfo_algorithms),
        ('pwdQualityRule', _EncPwdInfo_pwdQualityRule),
        ])
    EncPwdInfo._ext = []
    
    #-----< serviceError >-----#
    serviceError = CLASS(name='serviceError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _serviceError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __serviceError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    __serviceError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___serviceError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___serviceError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___serviceError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___serviceError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___serviceError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __serviceError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___serviceError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___serviceError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___serviceError_val_ParameterType_signed_signature),
        ])
    __serviceError_val_ParameterType_signed._ext = []
    _serviceError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __serviceError_val_ParameterType_unsigned),
        ('signed', __serviceError_val_ParameterType_signed),
        ])
    _serviceError_val_ParameterType._ext = None
    serviceError._val = dict([('ParameterType', _serviceError_val_ParameterType), ('errorCode', ('local', 3))])
    
    #-----< ServiceErrorData >-----#
    ServiceErrorData = SET(name='ServiceErrorData', mode=MODE_TYPE)
    _ServiceErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _ServiceErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ServiceErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ServiceErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ServiceErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ServiceErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ServiceErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ServiceErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ServiceErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ServiceErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ServiceErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ServiceErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ServiceErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ServiceErrorData_notification__item__type._const_tab = ____ServiceErrorData_notification__item__type_tab
    ___ServiceErrorData_notification__item__type._const_tab_at = None
    ___ServiceErrorData_notification__item__type._const_tab_id = 'id'
    ___ServiceErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ServiceErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ServiceErrorData_notification__item__values__item_._const_tab = ____ServiceErrorData_notification__item__type_tab
    ____ServiceErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ServiceErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___ServiceErrorData_notification__item__values._cont = ____ServiceErrorData_notification__item__values__item_
    ___ServiceErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ServiceErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ServiceErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ServiceErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab = ____ServiceErrorData_notification__item__type_tab
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList._cont = ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ServiceErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ServiceErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ServiceErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ServiceErrorData_notification__item__valuesWithContext__item_._ext = []
    ___ServiceErrorData_notification__item__valuesWithContext._cont = ____ServiceErrorData_notification__item__valuesWithContext__item_
    ___ServiceErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ServiceErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___ServiceErrorData_notification__item__type),
        ('values', ___ServiceErrorData_notification__item__values),
        ('valuesWithContext', ___ServiceErrorData_notification__item__valuesWithContext),
        ])
    __ServiceErrorData_notification__item_._ext = []
    _ServiceErrorData_notification._cont = __ServiceErrorData_notification__item_
    ServiceErrorData._cont = ASN1Dict([
        ('problem', _ServiceErrorData_problem),
        ('securityParameters', _ServiceErrorData_securityParameters),
        ('performer', _ServiceErrorData_performer),
        ('aliasDereferenced', _ServiceErrorData_aliasDereferenced),
        ('notification', _ServiceErrorData_notification),
        ])
    ServiceErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ServiceProblem >-----#
    ServiceProblem = INT(name='ServiceProblem', mode=MODE_TYPE)
    ServiceProblem._cont = ASN1Dict([('busy', 1), ('unavailable', 2), ('unwillingToPerform', 3), ('chainingRequired', 4), ('unableToProceed', 5), ('invalidReference', 6), ('timeLimitExceeded', 7), ('administrativeLimitExceeded', 8), ('loopDetected', 9), ('unavailableCriticalExtension', 10), ('outOfScope', 11), ('ditError', 12), ('invalidQueryReference', 13), ('requestedServiceNotAvailable', 14), ('unsupportedMatchingUse', 15), ('ambiguousKeyAttributes', 16), ('saslBindInProgress', 17), ('notSupportedByLDAP', 18)])
    
    #-----< updateError >-----#
    updateError = CLASS(name='updateError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _updateError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __updateError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    __updateError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___updateError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___updateError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___updateError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___updateError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___updateError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __updateError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___updateError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___updateError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___updateError_val_ParameterType_signed_signature),
        ])
    __updateError_val_ParameterType_signed._ext = []
    _updateError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __updateError_val_ParameterType_unsigned),
        ('signed', __updateError_val_ParameterType_signed),
        ])
    _updateError_val_ParameterType._ext = None
    updateError._val = dict([('ParameterType', _updateError_val_ParameterType), ('errorCode', ('local', 8))])
    
    #-----< UpdateErrorData >-----#
    UpdateErrorData = SET(name='UpdateErrorData', mode=MODE_TYPE)
    _UpdateErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateProblem')))
    _UpdateErrorData_attributeInfo = SET_OF(name='attributeInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateErrorData_attributeInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___UpdateErrorData_attributeInfo__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___UpdateErrorData_attributeInfo__item__attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____UpdateErrorData_attributeInfo__item__attribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____UpdateErrorData_attributeInfo__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____UpdateErrorData_attributeInfo__item__attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab_at = None
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab_id = 'id'
    ____UpdateErrorData_attributeInfo__item__attribute_values = SET_OF(name='values', mode=MODE_TYPE)
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab_at = ('..', '..', 'type')
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab_id = 'Type'
    ____UpdateErrorData_attributeInfo__item__attribute_values._cont = _____UpdateErrorData_attributeInfo__item__attribute_values__item_
    ____UpdateErrorData_attributeInfo__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList._cont = _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value),
        ('contextList', ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList),
        ])
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_._ext = []
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext._cont = _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___UpdateErrorData_attributeInfo__item__attribute._cont = ASN1Dict([
        ('type', ____UpdateErrorData_attributeInfo__item__attribute_type),
        ('values', ____UpdateErrorData_attributeInfo__item__attribute_values),
        ('valuesWithContext', ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext),
        ])
    ___UpdateErrorData_attributeInfo__item__attribute._ext = []
    __UpdateErrorData_attributeInfo__item_._cont = ASN1Dict([
        ('attributeType', ___UpdateErrorData_attributeInfo__item__attributeType),
        ('attribute', ___UpdateErrorData_attributeInfo__item__attribute),
        ])
    __UpdateErrorData_attributeInfo__item_._ext = []
    _UpdateErrorData_attributeInfo._cont = __UpdateErrorData_attributeInfo__item_
    _UpdateErrorData_attributeInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UpdateErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _UpdateErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _UpdateErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _UpdateErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___UpdateErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___UpdateErrorData_notification__item__type._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ___UpdateErrorData_notification__item__type._const_tab_at = None
    ___UpdateErrorData_notification__item__type._const_tab_id = 'id'
    ___UpdateErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____UpdateErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____UpdateErrorData_notification__item__values__item_._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ____UpdateErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____UpdateErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___UpdateErrorData_notification__item__values._cont = ____UpdateErrorData_notification__item__values__item_
    ___UpdateErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___UpdateErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____UpdateErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____UpdateErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList._cont = ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____UpdateErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____UpdateErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____UpdateErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____UpdateErrorData_notification__item__valuesWithContext__item_._ext = []
    ___UpdateErrorData_notification__item__valuesWithContext._cont = ____UpdateErrorData_notification__item__valuesWithContext__item_
    ___UpdateErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __UpdateErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___UpdateErrorData_notification__item__type),
        ('values', ___UpdateErrorData_notification__item__values),
        ('valuesWithContext', ___UpdateErrorData_notification__item__valuesWithContext),
        ])
    __UpdateErrorData_notification__item_._ext = []
    _UpdateErrorData_notification._cont = __UpdateErrorData_notification__item_
    UpdateErrorData._cont = ASN1Dict([
        ('problem', _UpdateErrorData_problem),
        ('attributeInfo', _UpdateErrorData_attributeInfo),
        ('securityParameters', _UpdateErrorData_securityParameters),
        ('performer', _UpdateErrorData_performer),
        ('aliasDereferenced', _UpdateErrorData_aliasDereferenced),
        ('notification', _UpdateErrorData_notification),
        ])
    UpdateErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< UpdateProblem >-----#
    UpdateProblem = INT(name='UpdateProblem', mode=MODE_TYPE)
    UpdateProblem._cont = ASN1Dict([('namingViolation', 1), ('objectClassViolation', 2), ('notAllowedOnNonLeaf', 3), ('notAllowedOnRDN', 4), ('entryAlreadyExists', 5), ('affectsMultipleDSAs', 6), ('objectClassModificationProhibited', 7), ('noSuchSuperior', 8), ('notAncestor', 9), ('parentNotAncestor', 10), ('hierarchyRuleViolation', 11), ('familyRuleViolation', 12), ('insufficientPasswordQuality', 13), ('passwordInHistory', 14), ('noPasswordSlot', 15)])
    
    #-----< id-at-family-information >-----#
    id_at_family_information = OID(name='id-at-family-information', mode=MODE_VALUE)
    id_at_family_information._val = (2, 5, 4, 64)
    
    _all_ = [
        _CommonArguments_serviceControls,
        _CommonArguments_securityParameters,
        _CommonArguments_requestor,
        _CommonArguments_operationProgress,
        _CommonArguments_aliasedRDNs,
        _CommonArguments_criticalExtensions,
        _CommonArguments_referenceType,
        _CommonArguments_entryOnly,
        _CommonArguments_exclusions,
        _CommonArguments_nameResolveOnMaster,
        _CommonArguments_operationContexts,
        _CommonArguments_familyGrouping,
        CommonArguments,
        _CommonArgumentsSeq_serviceControls,
        _CommonArgumentsSeq_securityParameters,
        _CommonArgumentsSeq_requestor,
        _CommonArgumentsSeq_operationProgress,
        _CommonArgumentsSeq_aliasedRDNs,
        _CommonArgumentsSeq_criticalExtensions,
        _CommonArgumentsSeq_referenceType,
        _CommonArgumentsSeq_entryOnly,
        _CommonArgumentsSeq_exclusions,
        _CommonArgumentsSeq_nameResolveOnMaster,
        _CommonArgumentsSeq_operationContexts,
        _CommonArgumentsSeq_familyGrouping,
        CommonArgumentsSeq,
        FamilyGrouping,
        _CommonResults_securityParameters,
        _CommonResults_performer,
        _CommonResults_aliasDereferenced,
        ____CommonResults_notification__item__type_tab,
        _____CommonResults_notification__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____CommonResults_notification__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___CommonResults_notification__item__type,
        ____CommonResults_notification__item__values__item_,
        ___CommonResults_notification__item__values,
        _____CommonResults_notification__item__valuesWithContext__item__value,
        ______CommonResults_notification__item__valuesWithContext__item__contextList__item_,
        _____CommonResults_notification__item__valuesWithContext__item__contextList,
        ____CommonResults_notification__item__valuesWithContext__item_,
        ___CommonResults_notification__item__valuesWithContext,
        __CommonResults_notification__item_,
        _CommonResults_notification,
        CommonResults,
        _CommonResultsSeq_securityParameters,
        _CommonResultsSeq_performer,
        _CommonResultsSeq_aliasDereferenced,
        ____CommonResultsSeq_notification__item__type_tab,
        _____CommonResultsSeq_notification__item__type_tab_val_Type_0,
        _____CommonResultsSeq_notification__item__type_tab_val_Type_1,
        ___CommonResultsSeq_notification__item__type,
        ____CommonResultsSeq_notification__item__values__item_,
        ___CommonResultsSeq_notification__item__values,
        _____CommonResultsSeq_notification__item__valuesWithContext__item__value,
        ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_,
        _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList,
        ____CommonResultsSeq_notification__item__valuesWithContext__item_,
        ___CommonResultsSeq_notification__item__valuesWithContext,
        __CommonResultsSeq_notification__item_,
        _CommonResultsSeq_notification,
        CommonResultsSeq,
        _ServiceControls_options,
        _ServiceControls_priority,
        _ServiceControls_timeLimit,
        _ServiceControls_sizeLimit,
        _ServiceControls_scopeOfReferral,
        _ServiceControls_attributeSizeLimit,
        __ServiceControls_manageDSAITPlaneRef_dsaName,
        __ServiceControls_manageDSAITPlaneRef_agreementID,
        _ServiceControls_manageDSAITPlaneRef,
        _ServiceControls_serviceType,
        _ServiceControls_userClass,
        ServiceControls,
        ServiceControlOptions,
        __EntryInformationSelection_attributes_allUserAttributes,
        ___EntryInformationSelection_attributes_select__item_,
        __EntryInformationSelection_attributes_select,
        _EntryInformationSelection_attributes,
        _EntryInformationSelection_infoTypes,
        __EntryInformationSelection_extraAttributes_allOperationalAttributes,
        ___EntryInformationSelection_extraAttributes_select__item_,
        __EntryInformationSelection_extraAttributes_select,
        _EntryInformationSelection_extraAttributes,
        _EntryInformationSelection_contextSelection,
        _EntryInformationSelection_returnContexts,
        _EntryInformationSelection_familyReturn,
        EntryInformationSelection,
        _ContextSelection_allContexts,
        __ContextSelection_selectedContexts__item_,
        _ContextSelection_selectedContexts,
        ContextSelection,
        _TypeAndContextAssertion_type,
        ___TypeAndContextAssertion_contextAssertions_preference__item_,
        __TypeAndContextAssertion_contextAssertions_preference,
        ___TypeAndContextAssertion_contextAssertions_all__item_,
        __TypeAndContextAssertion_contextAssertions_all,
        _TypeAndContextAssertion_contextAssertions,
        TypeAndContextAssertion,
        _FamilyReturn_memberSelect,
        __FamilyReturn_familySelect__item_,
        _FamilyReturn_familySelect,
        FamilyReturn,
        _EntryInformation_name,
        _EntryInformation_fromEntry,
        ___EntryInformation_information__item__attributeType,
        _____EntryInformation_information__item__attribute_type_tab,
        ______EntryInformation_information__item__attribute_type_tab_val_Type_0,
        ______EntryInformation_information__item__attribute_type_tab_val_Type_1,
        ____EntryInformation_information__item__attribute_type,
        _____EntryInformation_information__item__attribute_values__item_,
        ____EntryInformation_information__item__attribute_values,
        ______EntryInformation_information__item__attribute_valuesWithContext__item__value,
        _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_,
        ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList,
        _____EntryInformation_information__item__attribute_valuesWithContext__item_,
        ____EntryInformation_information__item__attribute_valuesWithContext,
        ___EntryInformation_information__item__attribute,
        __EntryInformation_information__item_,
        _EntryInformation_information,
        _EntryInformation_incompleteEntry,
        _EntryInformation_partialName,
        _EntryInformation_derivedEntry,
        EntryInformation,
        family_information,
        _family_information_val_Type,
        _FamilyEntries_family_class,
        __FamilyEntries_familyEntries__item_,
        _FamilyEntries_familyEntries,
        FamilyEntries,
        _FamilyEntry_rdn,
        ___FamilyEntry_information__item__attributeType,
        _____FamilyEntry_information__item__attribute_type_tab,
        ______FamilyEntry_information__item__attribute_type_tab_val_Type_0,
        ______FamilyEntry_information__item__attribute_type_tab_val_Type_1,
        ____FamilyEntry_information__item__attribute_type,
        _____FamilyEntry_information__item__attribute_values__item_,
        ____FamilyEntry_information__item__attribute_values,
        ______FamilyEntry_information__item__attribute_valuesWithContext__item__value,
        _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_,
        ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList,
        _____FamilyEntry_information__item__attribute_valuesWithContext__item_,
        ____FamilyEntry_information__item__attribute_valuesWithContext,
        ___FamilyEntry_information__item__attribute,
        __FamilyEntry_information__item_,
        _FamilyEntry_information,
        __FamilyEntry_family_info__item_,
        _FamilyEntry_family_info,
        FamilyEntry,
        _Filter_item,
        __Filter_and___item_,
        _Filter_and_,
        __Filter_or___item_,
        _Filter_or_,
        _Filter_not_,
        Filter,
        _FilterItem_equality,
        ___FilterItem_substrings_type_tab,
        ____FilterItem_substrings_type_tab_val_Type_0,
        ____FilterItem_substrings_type_tab_val_Type_1,
        __FilterItem_substrings_type,
        ____FilterItem_substrings_strings__item__initial,
        ____FilterItem_substrings_strings__item__any,
        ____FilterItem_substrings_strings__item__final,
        _____FilterItem_substrings_strings__item__control_type,
        ______FilterItem_substrings_strings__item__control_values__item_,
        _____FilterItem_substrings_strings__item__control_values,
        _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value,
        ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_,
        _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList,
        ______FilterItem_substrings_strings__item__control_valuesWithContext__item_,
        _____FilterItem_substrings_strings__item__control_valuesWithContext,
        ____FilterItem_substrings_strings__item__control,
        ___FilterItem_substrings_strings__item_,
        __FilterItem_substrings_strings,
        _FilterItem_substrings,
        _FilterItem_greaterOrEqual,
        _FilterItem_lessOrEqual,
        _FilterItem_present,
        _FilterItem_approximateMatch,
        _FilterItem_extensibleMatch,
        _FilterItem_contextPresent,
        FilterItem,
        __MatchingRuleAssertion_matchingRule__item_,
        _MatchingRuleAssertion_matchingRule,
        _MatchingRuleAssertion_type,
        _MatchingRuleAssertion_matchValue,
        _MatchingRuleAssertion_dnAttributes,
        MatchingRuleAssertion,
        __PagedResultsRequest_newRequest_pageSize,
        ___PagedResultsRequest_newRequest_sortKeys__item_,
        __PagedResultsRequest_newRequest_sortKeys,
        __PagedResultsRequest_newRequest_reverse,
        __PagedResultsRequest_newRequest_unmerged,
        __PagedResultsRequest_newRequest_pageNumber,
        _PagedResultsRequest_newRequest,
        _PagedResultsRequest_queryReference,
        _PagedResultsRequest_abandonQuery,
        PagedResultsRequest,
        _SortKey_type,
        _SortKey_orderingRule,
        SortKey,
        _SecurityParameters_certification_path,
        _SecurityParameters_name,
        _SecurityParameters_time,
        _SecurityParameters_random,
        _SecurityParameters_target,
        _SecurityParameters_operationCode,
        _SecurityParameters_errorProtection,
        _SecurityParameters_errorCode,
        SecurityParameters,
        ProtectionRequest,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        ErrorProtectionRequest,
        directoryBind,
        _directoryBind_val_ArgumentType,
        _directoryBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _DirectoryBindArgument_credentials,
        _DirectoryBindArgument_versions,
        DirectoryBindArgument,
        _Credentials_simple,
        _Credentials_strong,
        _Credentials_externalProcedure,
        _Credentials_spkm,
        _Credentials_sasl,
        Credentials,
        _SimpleCredentials_name,
        ___SimpleCredentials_validity_time1_utc,
        ___SimpleCredentials_validity_time1_gt,
        __SimpleCredentials_validity_time1,
        ___SimpleCredentials_validity_time2_utc,
        ___SimpleCredentials_validity_time2_gt,
        __SimpleCredentials_validity_time2,
        __SimpleCredentials_validity_random1,
        __SimpleCredentials_validity_random2,
        _SimpleCredentials_validity,
        __SimpleCredentials_password_unprotected,
        _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab,
        ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm,
        _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab,
        ____SimpleCredentials_password_protected_algorithmIdentifier_parameters,
        ___SimpleCredentials_password_protected_algorithmIdentifier,
        ___SimpleCredentials_password_protected_hashValue,
        __SimpleCredentials_password_protected,
        __SimpleCredentials_password_userPwd,
        _SimpleCredentials_password,
        SimpleCredentials,
        _StrongCredentials_certification_path,
        _StrongCredentials_bind_token,
        _StrongCredentials_name,
        _StrongCredentials_attributeCertificationPath,
        StrongCredentials,
        _SpkmCredentials_req,
        _SpkmCredentials_rep,
        SpkmCredentials,
        __SaslCredentials_mechanism_teletexString,
        __SaslCredentials_mechanism_printableString,
        __SaslCredentials_mechanism_bmpString,
        __SaslCredentials_mechanism_universalString,
        __SaslCredentials_mechanism_uTF8String,
        _SaslCredentials_mechanism,
        _SaslCredentials_credentials,
        _SaslCredentials_saslAbort,
        SaslCredentials,
        ub_saslMechanism,
        _Token_toBeSigned,
        ___Token_algorithmIdentifier_algorithm_tab,
        __Token_algorithmIdentifier_algorithm,
        ___Token_algorithmIdentifier_parameters_tab,
        __Token_algorithmIdentifier_parameters,
        _Token_algorithmIdentifier,
        _Token_signature,
        Token,
        ___TokenContent_algorithm_algorithm_tab,
        __TokenContent_algorithm_algorithm,
        ___TokenContent_algorithm_parameters_tab,
        __TokenContent_algorithm_parameters,
        _TokenContent_algorithm,
        _TokenContent_name,
        _TokenContent_time,
        _TokenContent_random,
        _TokenContent_response,
        TokenContent,
        Versions,
        _DirectoryBindResult_credentials,
        _DirectoryBindResult_versions,
        _DirectoryBindResult_pwdResponseValue,
        DirectoryBindResult,
        __PwdResponseValue_warning_timeLeft,
        __PwdResponseValue_warning_graceRemaining,
        _PwdResponseValue_warning,
        _PwdResponseValue_error,
        PwdResponseValue,
        directoryBindError,
        ___directoryBindError_val_ParameterType_unsigned_versions,
        ____directoryBindError_val_ParameterType_unsigned_error_serviceError,
        ____directoryBindError_val_ParameterType_unsigned_error_securityError,
        ___directoryBindError_val_ParameterType_unsigned_error,
        ___directoryBindError_val_ParameterType_unsigned_securityParameters,
        __directoryBindError_val_ParameterType_unsigned,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_versions,
        _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError,
        _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_error,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters,
        ___directoryBindError_val_ParameterType_signed_toBeSigned,
        _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___directoryBindError_val_ParameterType_signed_algorithmIdentifier,
        ___directoryBindError_val_ParameterType_signed_signature,
        __directoryBindError_val_ParameterType_signed,
        _directoryBindError_val_ParameterType,
        BindKeyInfo,
        read,
        _read_val_ArgumentType,
        _read_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        _ReadArgument_unsigned,
        __ReadArgument_signed_toBeSigned,
        ____ReadArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ReadArgument_signed_algorithmIdentifier_algorithm,
        ____ReadArgument_signed_algorithmIdentifier_parameters_tab,
        ___ReadArgument_signed_algorithmIdentifier_parameters,
        __ReadArgument_signed_algorithmIdentifier,
        __ReadArgument_signed_signature,
        _ReadArgument_signed,
        ReadArgument,
        _ReadArgumentData_object,
        _ReadArgumentData_selection,
        _ReadArgumentData_modifyRightsRequest,
        _ReadArgumentData_serviceControls,
        _ReadArgumentData_securityParameters,
        _ReadArgumentData_requestor,
        _ReadArgumentData_operationProgress,
        _ReadArgumentData_aliasedRDNs,
        _ReadArgumentData_criticalExtensions,
        _ReadArgumentData_referenceType,
        _ReadArgumentData_entryOnly,
        _ReadArgumentData_exclusions,
        _ReadArgumentData_nameResolveOnMaster,
        _ReadArgumentData_operationContexts,
        _ReadArgumentData_familyGrouping,
        ReadArgumentData,
        _ReadResult_unsigned,
        __ReadResult_signed_toBeSigned,
        ____ReadResult_signed_algorithmIdentifier_algorithm_tab,
        ___ReadResult_signed_algorithmIdentifier_algorithm,
        ____ReadResult_signed_algorithmIdentifier_parameters_tab,
        ___ReadResult_signed_algorithmIdentifier_parameters,
        __ReadResult_signed_algorithmIdentifier,
        __ReadResult_signed_signature,
        _ReadResult_signed,
        ReadResult,
        _ReadResultData_entry,
        _ReadResultData_modifyRights,
        _ReadResultData_securityParameters,
        _ReadResultData_performer,
        _ReadResultData_aliasDereferenced,
        ____ReadResultData_notification__item__type_tab,
        _____ReadResultData_notification__item__type_tab_val_Type_0,
        _____ReadResultData_notification__item__type_tab_val_Type_1,
        ___ReadResultData_notification__item__type,
        ____ReadResultData_notification__item__values__item_,
        ___ReadResultData_notification__item__values,
        _____ReadResultData_notification__item__valuesWithContext__item__value,
        ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ReadResultData_notification__item__valuesWithContext__item__contextList,
        ____ReadResultData_notification__item__valuesWithContext__item_,
        ___ReadResultData_notification__item__valuesWithContext,
        __ReadResultData_notification__item_,
        _ReadResultData_notification,
        ReadResultData,
        ___ModifyRights__item__item_entry,
        ___ModifyRights__item__item_attribute,
        ___ModifyRights__item__item_value,
        __ModifyRights__item__item,
        __ModifyRights__item__permission,
        _ModifyRights__item_,
        ModifyRights,
        compare,
        _compare_val_ArgumentType,
        _compare_val_ResultType,
        _CompareArgument_unsigned,
        __CompareArgument_signed_toBeSigned,
        ____CompareArgument_signed_algorithmIdentifier_algorithm_tab,
        ___CompareArgument_signed_algorithmIdentifier_algorithm,
        ____CompareArgument_signed_algorithmIdentifier_parameters_tab,
        ___CompareArgument_signed_algorithmIdentifier_parameters,
        __CompareArgument_signed_algorithmIdentifier,
        __CompareArgument_signed_signature,
        _CompareArgument_signed,
        CompareArgument,
        _CompareArgumentData_object,
        _CompareArgumentData_purported,
        _CompareArgumentData_serviceControls,
        _CompareArgumentData_securityParameters,
        _CompareArgumentData_requestor,
        _CompareArgumentData_operationProgress,
        _CompareArgumentData_aliasedRDNs,
        _CompareArgumentData_criticalExtensions,
        _CompareArgumentData_referenceType,
        _CompareArgumentData_entryOnly,
        _CompareArgumentData_exclusions,
        _CompareArgumentData_nameResolveOnMaster,
        _CompareArgumentData_operationContexts,
        _CompareArgumentData_familyGrouping,
        CompareArgumentData,
        _CompareResult_unsigned,
        __CompareResult_signed_toBeSigned,
        ____CompareResult_signed_algorithmIdentifier_algorithm_tab,
        ___CompareResult_signed_algorithmIdentifier_algorithm,
        ____CompareResult_signed_algorithmIdentifier_parameters_tab,
        ___CompareResult_signed_algorithmIdentifier_parameters,
        __CompareResult_signed_algorithmIdentifier,
        __CompareResult_signed_signature,
        _CompareResult_signed,
        CompareResult,
        _CompareResultData_name,
        _CompareResultData_matched,
        _CompareResultData_fromEntry,
        _CompareResultData_matchedSubtype,
        _CompareResultData_securityParameters,
        _CompareResultData_performer,
        _CompareResultData_aliasDereferenced,
        ____CompareResultData_notification__item__type_tab,
        _____CompareResultData_notification__item__type_tab_val_Type_0,
        _____CompareResultData_notification__item__type_tab_val_Type_1,
        ___CompareResultData_notification__item__type,
        ____CompareResultData_notification__item__values__item_,
        ___CompareResultData_notification__item__values,
        _____CompareResultData_notification__item__valuesWithContext__item__value,
        ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____CompareResultData_notification__item__valuesWithContext__item__contextList,
        ____CompareResultData_notification__item__valuesWithContext__item_,
        ___CompareResultData_notification__item__valuesWithContext,
        __CompareResultData_notification__item_,
        _CompareResultData_notification,
        CompareResultData,
        abandon,
        _abandon_val_ArgumentType,
        _abandon_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        _AbandonArgument_unsigned,
        __AbandonArgument_signed_toBeSigned,
        ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AbandonArgument_signed_algorithmIdentifier_algorithm,
        ____AbandonArgument_signed_algorithmIdentifier_parameters_tab,
        ___AbandonArgument_signed_algorithmIdentifier_parameters,
        __AbandonArgument_signed_algorithmIdentifier,
        __AbandonArgument_signed_signature,
        _AbandonArgument_signed,
        AbandonArgument,
        _AbandonArgumentData_invokeID,
        AbandonArgumentData,
        _AbandonResult_null,
        __AbandonResult_information_unsigned,
        ___AbandonResult_information_signed_toBeSigned,
        _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AbandonResult_information_signed_algorithmIdentifier_algorithm,
        _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AbandonResult_information_signed_algorithmIdentifier_parameters,
        ___AbandonResult_information_signed_algorithmIdentifier,
        ___AbandonResult_information_signed_signature,
        __AbandonResult_information_signed,
        _AbandonResult_information,
        AbandonResult,
        _AbandonResultData_invokeID,
        _AbandonResultData_securityParameters,
        _AbandonResultData_performer,
        _AbandonResultData_aliasDereferenced,
        ____AbandonResultData_notification__item__type_tab,
        _____AbandonResultData_notification__item__type_tab_val_Type_0,
        _____AbandonResultData_notification__item__type_tab_val_Type_1,
        ___AbandonResultData_notification__item__type,
        ____AbandonResultData_notification__item__values__item_,
        ___AbandonResultData_notification__item__values,
        _____AbandonResultData_notification__item__valuesWithContext__item__value,
        ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonResultData_notification__item__valuesWithContext__item__contextList,
        ____AbandonResultData_notification__item__valuesWithContext__item_,
        ___AbandonResultData_notification__item__valuesWithContext,
        __AbandonResultData_notification__item_,
        _AbandonResultData_notification,
        AbandonResultData,
        list,
        _list_val_ArgumentType,
        _list_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        _ListArgument_unsigned,
        __ListArgument_signed_toBeSigned,
        ____ListArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ListArgument_signed_algorithmIdentifier_algorithm,
        ____ListArgument_signed_algorithmIdentifier_parameters_tab,
        ___ListArgument_signed_algorithmIdentifier_parameters,
        __ListArgument_signed_algorithmIdentifier,
        __ListArgument_signed_signature,
        _ListArgument_signed,
        ListArgument,
        _ListArgumentData_object,
        _ListArgumentData_pagedResults,
        _ListArgumentData_listFamily,
        _ListArgumentData_serviceControls,
        _ListArgumentData_securityParameters,
        _ListArgumentData_requestor,
        _ListArgumentData_operationProgress,
        _ListArgumentData_aliasedRDNs,
        _ListArgumentData_criticalExtensions,
        _ListArgumentData_referenceType,
        _ListArgumentData_entryOnly,
        _ListArgumentData_exclusions,
        _ListArgumentData_nameResolveOnMaster,
        _ListArgumentData_operationContexts,
        _ListArgumentData_familyGrouping,
        ListArgumentData,
        _ListResult_unsigned,
        __ListResult_signed_toBeSigned,
        ____ListResult_signed_algorithmIdentifier_algorithm_tab,
        ___ListResult_signed_algorithmIdentifier_algorithm,
        ____ListResult_signed_algorithmIdentifier_parameters_tab,
        ___ListResult_signed_algorithmIdentifier_parameters,
        __ListResult_signed_algorithmIdentifier,
        __ListResult_signed_signature,
        _ListResult_signed,
        ListResult,
        __ListResultData_listInfo_name,
        ____ListResultData_listInfo_subordinates__item__rdn,
        ____ListResultData_listInfo_subordinates__item__aliasEntry,
        ____ListResultData_listInfo_subordinates__item__fromEntry,
        ___ListResultData_listInfo_subordinates__item_,
        __ListResultData_listInfo_subordinates,
        __ListResultData_listInfo_partialOutcomeQualifier,
        __ListResultData_listInfo_securityParameters,
        __ListResultData_listInfo_performer,
        __ListResultData_listInfo_aliasDereferenced,
        _____ListResultData_listInfo_notification__item__type_tab,
        ______ListResultData_listInfo_notification__item__type_tab_val_Type_0,
        ______ListResultData_listInfo_notification__item__type_tab_val_Type_1,
        ____ListResultData_listInfo_notification__item__type,
        _____ListResultData_listInfo_notification__item__values__item_,
        ____ListResultData_listInfo_notification__item__values,
        ______ListResultData_listInfo_notification__item__valuesWithContext__item__value,
        _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_,
        ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList,
        _____ListResultData_listInfo_notification__item__valuesWithContext__item_,
        ____ListResultData_listInfo_notification__item__valuesWithContext,
        ___ListResultData_listInfo_notification__item_,
        __ListResultData_listInfo_notification,
        _ListResultData_listInfo,
        __ListResultData_uncorrelatedListInfo__item_,
        _ListResultData_uncorrelatedListInfo,
        ListResultData,
        _PartialOutcomeQualifier_limitProblem,
        __PartialOutcomeQualifier_unexplored__item_,
        _PartialOutcomeQualifier_unexplored,
        _PartialOutcomeQualifier_unavailableCriticalExtensions,
        __PartialOutcomeQualifier_unknownErrors__item_,
        _PartialOutcomeQualifier_unknownErrors,
        _PartialOutcomeQualifier_queryReference,
        _PartialOutcomeQualifier_overspecFilter,
        ____PartialOutcomeQualifier_notification__item__type_tab,
        _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0,
        _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1,
        ___PartialOutcomeQualifier_notification__item__type,
        ____PartialOutcomeQualifier_notification__item__values__item_,
        ___PartialOutcomeQualifier_notification__item__values,
        _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value,
        ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_,
        _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList,
        ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_,
        ___PartialOutcomeQualifier_notification__item__valuesWithContext,
        __PartialOutcomeQualifier_notification__item_,
        _PartialOutcomeQualifier_notification,
        __PartialOutcomeQualifier_entryCount_bestEstimate,
        __PartialOutcomeQualifier_entryCount_lowEstimate,
        __PartialOutcomeQualifier_entryCount_exact,
        _PartialOutcomeQualifier_entryCount,
        PartialOutcomeQualifier,
        LimitProblem,
        search,
        _search_val_ArgumentType,
        _search_val_ResultType,
        _SearchArgument_unsigned,
        __SearchArgument_signed_toBeSigned,
        ____SearchArgument_signed_algorithmIdentifier_algorithm_tab,
        ___SearchArgument_signed_algorithmIdentifier_algorithm,
        ____SearchArgument_signed_algorithmIdentifier_parameters_tab,
        ___SearchArgument_signed_algorithmIdentifier_parameters,
        __SearchArgument_signed_algorithmIdentifier,
        __SearchArgument_signed_signature,
        _SearchArgument_signed,
        SearchArgument,
        _SearchArgumentData_baseObject,
        _SearchArgumentData_subset,
        _SearchArgumentData_filter,
        _SearchArgumentData_searchAliases,
        _SearchArgumentData_selection,
        _SearchArgumentData_pagedResults,
        _SearchArgumentData_matchedValuesOnly,
        _SearchArgumentData_extendedFilter,
        _SearchArgumentData_checkOverspecified,
        _SearchArgumentData_relaxation,
        _SearchArgumentData_extendedArea,
        _SearchArgumentData_hierarchySelections,
        _SearchArgumentData_searchControlOptions,
        __SearchArgumentData_joinArguments__item_,
        _SearchArgumentData_joinArguments,
        _SearchArgumentData_joinType,
        _SearchArgumentData_serviceControls,
        _SearchArgumentData_securityParameters,
        _SearchArgumentData_requestor,
        _SearchArgumentData_operationProgress,
        _SearchArgumentData_aliasedRDNs,
        _SearchArgumentData_criticalExtensions,
        _SearchArgumentData_referenceType,
        _SearchArgumentData_entryOnly,
        _SearchArgumentData_exclusions,
        _SearchArgumentData_nameResolveOnMaster,
        _SearchArgumentData_operationContexts,
        _SearchArgumentData_familyGrouping,
        SearchArgumentData,
        HierarchySelections,
        SearchControlOptions,
        _JoinArgument_joinBaseObject,
        _JoinArgument_domainLocalID,
        _JoinArgument_joinSubset,
        _JoinArgument_joinFilter,
        __JoinArgument_joinAttributes__item_,
        _JoinArgument_joinAttributes,
        _JoinArgument_joinSelection,
        JoinArgument,
        DomainLocalID,
        _JoinAttPair_baseAtt,
        _JoinAttPair_joinAtt,
        __JoinAttPair_joinContext__item_,
        _JoinAttPair_joinContext,
        JoinAttPair,
        _JoinContextType_tab,
        JoinContextType,
        _SearchResult_unsigned,
        __SearchResult_signed_toBeSigned,
        ____SearchResult_signed_algorithmIdentifier_algorithm_tab,
        ___SearchResult_signed_algorithmIdentifier_algorithm,
        ____SearchResult_signed_algorithmIdentifier_parameters_tab,
        ___SearchResult_signed_algorithmIdentifier_parameters,
        __SearchResult_signed_algorithmIdentifier,
        __SearchResult_signed_signature,
        _SearchResult_signed,
        SearchResult,
        __SearchResultData_searchInfo_name,
        ___SearchResultData_searchInfo_entries__item_,
        __SearchResultData_searchInfo_entries,
        __SearchResultData_searchInfo_partialOutcomeQualifier,
        __SearchResultData_searchInfo_altMatching,
        __SearchResultData_searchInfo_securityParameters,
        __SearchResultData_searchInfo_performer,
        __SearchResultData_searchInfo_aliasDereferenced,
        _____SearchResultData_searchInfo_notification__item__type_tab,
        ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0,
        ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1,
        ____SearchResultData_searchInfo_notification__item__type,
        _____SearchResultData_searchInfo_notification__item__values__item_,
        ____SearchResultData_searchInfo_notification__item__values,
        ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value,
        _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_,
        ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList,
        _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_,
        ____SearchResultData_searchInfo_notification__item__valuesWithContext,
        ___SearchResultData_searchInfo_notification__item_,
        __SearchResultData_searchInfo_notification,
        _SearchResultData_searchInfo,
        __SearchResultData_uncorrelatedSearchInfo__item_,
        _SearchResultData_uncorrelatedSearchInfo,
        SearchResultData,
        addEntry,
        _addEntry_val_ArgumentType,
        _addEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        _AddEntryArgument_unsigned,
        __AddEntryArgument_signed_toBeSigned,
        ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AddEntryArgument_signed_algorithmIdentifier_algorithm,
        ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___AddEntryArgument_signed_algorithmIdentifier_parameters,
        __AddEntryArgument_signed_algorithmIdentifier,
        __AddEntryArgument_signed_signature,
        _AddEntryArgument_signed,
        AddEntryArgument,
        _AddEntryArgumentData_object,
        ____AddEntryArgumentData_entry__item__type_tab,
        _____AddEntryArgumentData_entry__item__type_tab_val_Type_0,
        _____AddEntryArgumentData_entry__item__type_tab_val_Type_1,
        ___AddEntryArgumentData_entry__item__type,
        ____AddEntryArgumentData_entry__item__values__item_,
        ___AddEntryArgumentData_entry__item__values,
        _____AddEntryArgumentData_entry__item__valuesWithContext__item__value,
        ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_,
        _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList,
        ____AddEntryArgumentData_entry__item__valuesWithContext__item_,
        ___AddEntryArgumentData_entry__item__valuesWithContext,
        __AddEntryArgumentData_entry__item_,
        _AddEntryArgumentData_entry,
        _AddEntryArgumentData_targetSystem,
        _AddEntryArgumentData_serviceControls,
        _AddEntryArgumentData_securityParameters,
        _AddEntryArgumentData_requestor,
        _AddEntryArgumentData_operationProgress,
        _AddEntryArgumentData_aliasedRDNs,
        _AddEntryArgumentData_criticalExtensions,
        _AddEntryArgumentData_referenceType,
        _AddEntryArgumentData_entryOnly,
        _AddEntryArgumentData_exclusions,
        _AddEntryArgumentData_nameResolveOnMaster,
        _AddEntryArgumentData_operationContexts,
        _AddEntryArgumentData_familyGrouping,
        AddEntryArgumentData,
        _AddEntryResult_null,
        __AddEntryResult_information_unsigned,
        ___AddEntryResult_information_signed_toBeSigned,
        _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AddEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AddEntryResult_information_signed_algorithmIdentifier_parameters,
        ___AddEntryResult_information_signed_algorithmIdentifier,
        ___AddEntryResult_information_signed_signature,
        __AddEntryResult_information_signed,
        _AddEntryResult_information,
        AddEntryResult,
        _AddEntryResultData_securityParameters,
        _AddEntryResultData_performer,
        _AddEntryResultData_aliasDereferenced,
        ____AddEntryResultData_notification__item__type_tab,
        _____AddEntryResultData_notification__item__type_tab_val_Type_0,
        _____AddEntryResultData_notification__item__type_tab_val_Type_1,
        ___AddEntryResultData_notification__item__type,
        ____AddEntryResultData_notification__item__values__item_,
        ___AddEntryResultData_notification__item__values,
        _____AddEntryResultData_notification__item__valuesWithContext__item__value,
        ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AddEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____AddEntryResultData_notification__item__valuesWithContext__item_,
        ___AddEntryResultData_notification__item__valuesWithContext,
        __AddEntryResultData_notification__item_,
        _AddEntryResultData_notification,
        AddEntryResultData,
        removeEntry,
        _removeEntry_val_ArgumentType,
        _removeEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_3_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_1_signed,
        __OPERATION_Errors_val_ParameterType_3_1,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        _RemoveEntryArgument_unsigned,
        __RemoveEntryArgument_signed_toBeSigned,
        ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm,
        ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___RemoveEntryArgument_signed_algorithmIdentifier_parameters,
        __RemoveEntryArgument_signed_algorithmIdentifier,
        __RemoveEntryArgument_signed_signature,
        _RemoveEntryArgument_signed,
        RemoveEntryArgument,
        _RemoveEntryArgumentData_object,
        _RemoveEntryArgumentData_serviceControls,
        _RemoveEntryArgumentData_securityParameters,
        _RemoveEntryArgumentData_requestor,
        _RemoveEntryArgumentData_operationProgress,
        _RemoveEntryArgumentData_aliasedRDNs,
        _RemoveEntryArgumentData_criticalExtensions,
        _RemoveEntryArgumentData_referenceType,
        _RemoveEntryArgumentData_entryOnly,
        _RemoveEntryArgumentData_exclusions,
        _RemoveEntryArgumentData_nameResolveOnMaster,
        _RemoveEntryArgumentData_operationContexts,
        _RemoveEntryArgumentData_familyGrouping,
        RemoveEntryArgumentData,
        _RemoveEntryResult_null,
        __RemoveEntryResult_information_unsigned,
        ___RemoveEntryResult_information_signed_toBeSigned,
        _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters,
        ___RemoveEntryResult_information_signed_algorithmIdentifier,
        ___RemoveEntryResult_information_signed_signature,
        __RemoveEntryResult_information_signed,
        _RemoveEntryResult_information,
        RemoveEntryResult,
        _RemoveEntryResultData_securityParameters,
        _RemoveEntryResultData_performer,
        _RemoveEntryResultData_aliasDereferenced,
        ____RemoveEntryResultData_notification__item__type_tab,
        _____RemoveEntryResultData_notification__item__type_tab_val_Type_0,
        _____RemoveEntryResultData_notification__item__type_tab_val_Type_1,
        ___RemoveEntryResultData_notification__item__type,
        ____RemoveEntryResultData_notification__item__values__item_,
        ___RemoveEntryResultData_notification__item__values,
        _____RemoveEntryResultData_notification__item__valuesWithContext__item__value,
        ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____RemoveEntryResultData_notification__item__valuesWithContext__item_,
        ___RemoveEntryResultData_notification__item__valuesWithContext,
        __RemoveEntryResultData_notification__item_,
        _RemoveEntryResultData_notification,
        RemoveEntryResultData,
        modifyEntry,
        _modifyEntry_val_ArgumentType,
        _modifyEntry_val_ResultType,
        _ModifyEntryArgument_unsigned,
        __ModifyEntryArgument_signed_toBeSigned,
        ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyEntryArgument_signed_algorithmIdentifier_parameters,
        __ModifyEntryArgument_signed_algorithmIdentifier,
        __ModifyEntryArgument_signed_signature,
        _ModifyEntryArgument_signed,
        ModifyEntryArgument,
        _ModifyEntryArgumentData_object,
        __ModifyEntryArgumentData_changes__item_,
        _ModifyEntryArgumentData_changes,
        _ModifyEntryArgumentData_selection,
        _ModifyEntryArgumentData_serviceControls,
        _ModifyEntryArgumentData_securityParameters,
        _ModifyEntryArgumentData_requestor,
        _ModifyEntryArgumentData_operationProgress,
        _ModifyEntryArgumentData_aliasedRDNs,
        _ModifyEntryArgumentData_criticalExtensions,
        _ModifyEntryArgumentData_referenceType,
        _ModifyEntryArgumentData_entryOnly,
        _ModifyEntryArgumentData_exclusions,
        _ModifyEntryArgumentData_nameResolveOnMaster,
        _ModifyEntryArgumentData_operationContexts,
        _ModifyEntryArgumentData_familyGrouping,
        ModifyEntryArgumentData,
        _ModifyEntryResult_null,
        __ModifyEntryResult_information_unsigned,
        ___ModifyEntryResult_information_signed_toBeSigned,
        _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters,
        ___ModifyEntryResult_information_signed_algorithmIdentifier,
        ___ModifyEntryResult_information_signed_signature,
        __ModifyEntryResult_information_signed,
        _ModifyEntryResult_information,
        ModifyEntryResult,
        _ModifyEntryResultData_entry,
        _ModifyEntryResultData_securityParameters,
        _ModifyEntryResultData_performer,
        _ModifyEntryResultData_aliasDereferenced,
        ____ModifyEntryResultData_notification__item__type_tab,
        _____ModifyEntryResultData_notification__item__type_tab_val_Type_0,
        _____ModifyEntryResultData_notification__item__type_tab_val_Type_1,
        ___ModifyEntryResultData_notification__item__type,
        ____ModifyEntryResultData_notification__item__values__item_,
        ___ModifyEntryResultData_notification__item__values,
        _____ModifyEntryResultData_notification__item__valuesWithContext__item__value,
        ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyEntryResultData_notification__item__valuesWithContext__item_,
        ___ModifyEntryResultData_notification__item__valuesWithContext,
        __ModifyEntryResultData_notification__item_,
        _ModifyEntryResultData_notification,
        ModifyEntryResultData,
        ___EntryModification_addAttribute_type_tab,
        ____EntryModification_addAttribute_type_tab_val_Type_0,
        ____EntryModification_addAttribute_type_tab_val_Type_1,
        __EntryModification_addAttribute_type,
        ___EntryModification_addAttribute_values__item_,
        __EntryModification_addAttribute_values,
        ____EntryModification_addAttribute_valuesWithContext__item__value,
        _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_,
        ____EntryModification_addAttribute_valuesWithContext__item__contextList,
        ___EntryModification_addAttribute_valuesWithContext__item_,
        __EntryModification_addAttribute_valuesWithContext,
        _EntryModification_addAttribute,
        _EntryModification_removeAttribute,
        __EntryModification_addValues_type,
        ___EntryModification_addValues_values__item_,
        __EntryModification_addValues_values,
        ____EntryModification_addValues_valuesWithContext__item__value,
        _____EntryModification_addValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_addValues_valuesWithContext__item__contextList,
        ___EntryModification_addValues_valuesWithContext__item_,
        __EntryModification_addValues_valuesWithContext,
        _EntryModification_addValues,
        __EntryModification_removeValues_type,
        ___EntryModification_removeValues_values__item_,
        __EntryModification_removeValues_values,
        ____EntryModification_removeValues_valuesWithContext__item__value,
        _____EntryModification_removeValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_removeValues_valuesWithContext__item__contextList,
        ___EntryModification_removeValues_valuesWithContext__item_,
        __EntryModification_removeValues_valuesWithContext,
        _EntryModification_removeValues,
        _EntryModification_alterValues,
        _EntryModification_resetValue,
        __EntryModification_replaceValues_type,
        ___EntryModification_replaceValues_values__item_,
        __EntryModification_replaceValues_values,
        ____EntryModification_replaceValues_valuesWithContext__item__value,
        _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_replaceValues_valuesWithContext__item__contextList,
        ___EntryModification_replaceValues_valuesWithContext__item_,
        __EntryModification_replaceValues_valuesWithContext,
        _EntryModification_replaceValues,
        EntryModification,
        modifyDN,
        _modifyDN_val_ArgumentType,
        _modifyDN_val_ResultType,
        _ModifyDNArgument_unsigned,
        __ModifyDNArgument_signed_toBeSigned,
        ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyDNArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyDNArgument_signed_algorithmIdentifier_parameters,
        __ModifyDNArgument_signed_algorithmIdentifier,
        __ModifyDNArgument_signed_signature,
        _ModifyDNArgument_signed,
        ModifyDNArgument,
        _ModifyDNArgumentData_object,
        _ModifyDNArgumentData_newRDN,
        _ModifyDNArgumentData_deleteOldRDN,
        _ModifyDNArgumentData_newSuperior,
        _ModifyDNArgumentData_serviceControls,
        _ModifyDNArgumentData_securityParameters,
        _ModifyDNArgumentData_requestor,
        _ModifyDNArgumentData_operationProgress,
        _ModifyDNArgumentData_aliasedRDNs,
        _ModifyDNArgumentData_criticalExtensions,
        _ModifyDNArgumentData_referenceType,
        _ModifyDNArgumentData_entryOnly,
        _ModifyDNArgumentData_exclusions,
        _ModifyDNArgumentData_nameResolveOnMaster,
        _ModifyDNArgumentData_operationContexts,
        _ModifyDNArgumentData_familyGrouping,
        ModifyDNArgumentData,
        _ModifyDNResult_null,
        __ModifyDNResult_information_unsigned,
        ___ModifyDNResult_information_signed_toBeSigned,
        _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm,
        _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ModifyDNResult_information_signed_algorithmIdentifier_parameters,
        ___ModifyDNResult_information_signed_algorithmIdentifier,
        ___ModifyDNResult_information_signed_signature,
        __ModifyDNResult_information_signed,
        _ModifyDNResult_information,
        ModifyDNResult,
        _ModifyDNResultData_newRDN,
        _ModifyDNResultData_securityParameters,
        _ModifyDNResultData_performer,
        _ModifyDNResultData_aliasDereferenced,
        ____ModifyDNResultData_notification__item__type_tab,
        _____ModifyDNResultData_notification__item__type_tab_val_Type_0,
        _____ModifyDNResultData_notification__item__type_tab_val_Type_1,
        ___ModifyDNResultData_notification__item__type,
        ____ModifyDNResultData_notification__item__values__item_,
        ___ModifyDNResultData_notification__item__values,
        _____ModifyDNResultData_notification__item__valuesWithContext__item__value,
        ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyDNResultData_notification__item__valuesWithContext__item_,
        ___ModifyDNResultData_notification__item__valuesWithContext,
        __ModifyDNResultData_notification__item_,
        _ModifyDNResultData_notification,
        ModifyDNResultData,
        changePassword,
        _changePassword_val_ArgumentType,
        _changePassword_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        _ChangePasswordArgument_unsigned,
        __ChangePasswordArgument_signed_toBeSigned,
        ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm,
        ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab,
        ___ChangePasswordArgument_signed_algorithmIdentifier_parameters,
        __ChangePasswordArgument_signed_algorithmIdentifier,
        __ChangePasswordArgument_signed_signature,
        _ChangePasswordArgument_signed,
        ChangePasswordArgument,
        _ChangePasswordArgumentData_object,
        _ChangePasswordArgumentData_oldPwd,
        _ChangePasswordArgumentData_newPwd,
        ChangePasswordArgumentData,
        _ChangePasswordResult_null,
        __ChangePasswordResult_information_unsigned,
        ___ChangePasswordResult_information_signed_toBeSigned,
        _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm,
        _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters,
        ___ChangePasswordResult_information_signed_algorithmIdentifier,
        ___ChangePasswordResult_information_signed_signature,
        __ChangePasswordResult_information_signed,
        _ChangePasswordResult_information,
        ChangePasswordResult,
        _ChangePasswordResultData_securityParameters,
        _ChangePasswordResultData_performer,
        _ChangePasswordResultData_aliasDereferenced,
        ____ChangePasswordResultData_notification__item__type_tab,
        _____ChangePasswordResultData_notification__item__type_tab_val_Type_0,
        _____ChangePasswordResultData_notification__item__type_tab_val_Type_1,
        ___ChangePasswordResultData_notification__item__type,
        ____ChangePasswordResultData_notification__item__values__item_,
        ___ChangePasswordResultData_notification__item__values,
        _____ChangePasswordResultData_notification__item__valuesWithContext__item__value,
        ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList,
        ____ChangePasswordResultData_notification__item__valuesWithContext__item_,
        ___ChangePasswordResultData_notification__item__valuesWithContext,
        __ChangePasswordResultData_notification__item_,
        _ChangePasswordResultData_notification,
        ChangePasswordResultData,
        administerPassword,
        _administerPassword_val_ArgumentType,
        _administerPassword_val_ResultType,
        _AdministerPasswordArgument_unsigned,
        __AdministerPasswordArgument_signed_toBeSigned,
        ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm,
        ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab,
        ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters,
        __AdministerPasswordArgument_signed_algorithmIdentifier,
        __AdministerPasswordArgument_signed_signature,
        _AdministerPasswordArgument_signed,
        AdministerPasswordArgument,
        _AdministerPasswordArgumentData_object,
        _AdministerPasswordArgumentData_newPwd,
        AdministerPasswordArgumentData,
        _AdministerPasswordResult_null,
        __AdministerPasswordResult_information_unsigned,
        ___AdministerPasswordResult_information_signed_toBeSigned,
        _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm,
        _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters,
        ___AdministerPasswordResult_information_signed_algorithmIdentifier,
        ___AdministerPasswordResult_information_signed_signature,
        __AdministerPasswordResult_information_signed,
        _AdministerPasswordResult_information,
        AdministerPasswordResult,
        _AdministerPasswordResultData_securityParameters,
        _AdministerPasswordResultData_performer,
        _AdministerPasswordResultData_aliasDereferenced,
        ____AdministerPasswordResultData_notification__item__type_tab,
        _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0,
        _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1,
        ___AdministerPasswordResultData_notification__item__type,
        ____AdministerPasswordResultData_notification__item__values__item_,
        ___AdministerPasswordResultData_notification__item__values,
        _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value,
        ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList,
        ____AdministerPasswordResultData_notification__item__valuesWithContext__item_,
        ___AdministerPasswordResultData_notification__item__valuesWithContext,
        __AdministerPasswordResultData_notification__item_,
        _AdministerPasswordResultData_notification,
        AdministerPasswordResultData,
        ldapTransport,
        _ldapTransport_val_ArgumentType,
        __ldapTransport_val_ResultType__item_,
        _ldapTransport_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        _LdapArgument_unsigned,
        __LdapArgument_signed_toBeSigned,
        ____LdapArgument_signed_algorithmIdentifier_algorithm_tab,
        ___LdapArgument_signed_algorithmIdentifier_algorithm,
        ____LdapArgument_signed_algorithmIdentifier_parameters_tab,
        ___LdapArgument_signed_algorithmIdentifier_parameters,
        __LdapArgument_signed_algorithmIdentifier,
        __LdapArgument_signed_signature,
        _LdapArgument_signed,
        LdapArgument,
        _LdapArgumentData_object,
        _LdapArgumentData_ldapMessage,
        _LdapArgumentData_linkId,
        _LdapArgumentData_serviceControls,
        _LdapArgumentData_securityParameters,
        _LdapArgumentData_requestor,
        _LdapArgumentData_operationProgress,
        _LdapArgumentData_aliasedRDNs,
        _LdapArgumentData_criticalExtensions,
        _LdapArgumentData_referenceType,
        _LdapArgumentData_entryOnly,
        _LdapArgumentData_exclusions,
        _LdapArgumentData_nameResolveOnMaster,
        _LdapArgumentData_operationContexts,
        _LdapArgumentData_familyGrouping,
        LdapArgumentData,
        LinkId,
        _LdapResult_unsigned,
        __LdapResult_signed_toBeSigned,
        ____LdapResult_signed_algorithmIdentifier_algorithm_tab,
        ___LdapResult_signed_algorithmIdentifier_algorithm,
        ____LdapResult_signed_algorithmIdentifier_parameters_tab,
        ___LdapResult_signed_algorithmIdentifier_parameters,
        __LdapResult_signed_algorithmIdentifier,
        __LdapResult_signed_signature,
        _LdapResult_signed,
        LdapResult,
        __LdapResultData_ldapMessages__item_,
        _LdapResultData_ldapMessages,
        _LdapResultData_returnToClient,
        _LdapResultData_securityParameters,
        _LdapResultData_performer,
        _LdapResultData_aliasDereferenced,
        ____LdapResultData_notification__item__type_tab,
        _____LdapResultData_notification__item__type_tab_val_Type_0,
        _____LdapResultData_notification__item__type_tab_val_Type_1,
        ___LdapResultData_notification__item__type,
        ____LdapResultData_notification__item__values__item_,
        ___LdapResultData_notification__item__values,
        _____LdapResultData_notification__item__valuesWithContext__item__value,
        ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____LdapResultData_notification__item__valuesWithContext__item__contextList,
        ____LdapResultData_notification__item__valuesWithContext__item_,
        ___LdapResultData_notification__item__valuesWithContext,
        __LdapResultData_notification__item_,
        _LdapResultData_notification,
        LdapResultData,
        linkedLDAP,
        _linkedLDAP_val_ArgumentType,
        _linkedLDAP_val_ResultType,
        _LinkedArgument_unsigned,
        __LinkedArgument_signed_toBeSigned,
        ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab,
        ___LinkedArgument_signed_algorithmIdentifier_algorithm,
        ____LinkedArgument_signed_algorithmIdentifier_parameters_tab,
        ___LinkedArgument_signed_algorithmIdentifier_parameters,
        __LinkedArgument_signed_algorithmIdentifier,
        __LinkedArgument_signed_signature,
        _LinkedArgument_signed,
        LinkedArgument,
        _LinkedArgumentData_object,
        _LinkedArgumentData_ldapMessage,
        _LinkedArgumentData_linkId,
        _LinkedArgumentData_returnToClient,
        _LinkedArgumentData_serviceControls,
        _LinkedArgumentData_securityParameters,
        _LinkedArgumentData_requestor,
        _LinkedArgumentData_operationProgress,
        _LinkedArgumentData_aliasedRDNs,
        _LinkedArgumentData_criticalExtensions,
        _LinkedArgumentData_referenceType,
        _LinkedArgumentData_entryOnly,
        _LinkedArgumentData_exclusions,
        _LinkedArgumentData_nameResolveOnMaster,
        _LinkedArgumentData_operationContexts,
        _LinkedArgumentData_familyGrouping,
        LinkedArgumentData,
        LinkedResult,
        abandoned,
        __abandoned_val_ParameterType_unsigned,
        ___abandoned_val_ParameterType_signed_toBeSigned,
        _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___abandoned_val_ParameterType_signed_algorithmIdentifier,
        ___abandoned_val_ParameterType_signed_signature,
        __abandoned_val_ParameterType_signed,
        _abandoned_val_ParameterType,
        _AbandonedData_problem,
        _AbandonedData_securityParameters,
        _AbandonedData_performer,
        _AbandonedData_aliasDereferenced,
        ____AbandonedData_notification__item__type_tab,
        _____AbandonedData_notification__item__type_tab_val_Type_0,
        _____AbandonedData_notification__item__type_tab_val_Type_1,
        ___AbandonedData_notification__item__type,
        ____AbandonedData_notification__item__values__item_,
        ___AbandonedData_notification__item__values,
        _____AbandonedData_notification__item__valuesWithContext__item__value,
        ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonedData_notification__item__valuesWithContext__item__contextList,
        ____AbandonedData_notification__item__valuesWithContext__item_,
        ___AbandonedData_notification__item__valuesWithContext,
        __AbandonedData_notification__item_,
        _AbandonedData_notification,
        AbandonedData,
        AbandonedProblem,
        abandonFailed,
        __abandonFailed_val_ParameterType_unsigned,
        ___abandonFailed_val_ParameterType_signed_toBeSigned,
        _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___abandonFailed_val_ParameterType_signed_algorithmIdentifier,
        ___abandonFailed_val_ParameterType_signed_signature,
        __abandonFailed_val_ParameterType_signed,
        _abandonFailed_val_ParameterType,
        _AbandonFailedData_problem,
        _AbandonFailedData_operation,
        _AbandonFailedData_securityParameters,
        _AbandonFailedData_performer,
        _AbandonFailedData_aliasDereferenced,
        ____AbandonFailedData_notification__item__type_tab,
        _____AbandonFailedData_notification__item__type_tab_val_Type_0,
        _____AbandonFailedData_notification__item__type_tab_val_Type_1,
        ___AbandonFailedData_notification__item__type,
        ____AbandonFailedData_notification__item__values__item_,
        ___AbandonFailedData_notification__item__values,
        _____AbandonFailedData_notification__item__valuesWithContext__item__value,
        ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonFailedData_notification__item__valuesWithContext__item__contextList,
        ____AbandonFailedData_notification__item__valuesWithContext__item_,
        ___AbandonFailedData_notification__item__valuesWithContext,
        __AbandonFailedData_notification__item_,
        _AbandonFailedData_notification,
        AbandonFailedData,
        AbandonProblem,
        attributeError,
        __attributeError_val_ParameterType_unsigned,
        ___attributeError_val_ParameterType_signed_toBeSigned,
        _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___attributeError_val_ParameterType_signed_algorithmIdentifier,
        ___attributeError_val_ParameterType_signed_signature,
        __attributeError_val_ParameterType_signed,
        _attributeError_val_ParameterType,
        _AttributeErrorData_object,
        ___AttributeErrorData_problems__item__problem,
        ___AttributeErrorData_problems__item__type,
        ___AttributeErrorData_problems__item__value,
        __AttributeErrorData_problems__item_,
        _AttributeErrorData_problems,
        _AttributeErrorData_securityParameters,
        _AttributeErrorData_performer,
        _AttributeErrorData_aliasDereferenced,
        ____AttributeErrorData_notification__item__type_tab,
        _____AttributeErrorData_notification__item__type_tab_val_Type_0,
        _____AttributeErrorData_notification__item__type_tab_val_Type_1,
        ___AttributeErrorData_notification__item__type,
        ____AttributeErrorData_notification__item__values__item_,
        ___AttributeErrorData_notification__item__values,
        _____AttributeErrorData_notification__item__valuesWithContext__item__value,
        ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____AttributeErrorData_notification__item__valuesWithContext__item__contextList,
        ____AttributeErrorData_notification__item__valuesWithContext__item_,
        ___AttributeErrorData_notification__item__valuesWithContext,
        __AttributeErrorData_notification__item_,
        _AttributeErrorData_notification,
        AttributeErrorData,
        AttributeProblem,
        nameError,
        __nameError_val_ParameterType_unsigned,
        ___nameError_val_ParameterType_signed_toBeSigned,
        _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___nameError_val_ParameterType_signed_algorithmIdentifier,
        ___nameError_val_ParameterType_signed_signature,
        __nameError_val_ParameterType_signed,
        _nameError_val_ParameterType,
        _NameErrorData_problem,
        _NameErrorData_matched,
        _NameErrorData_securityParameters,
        _NameErrorData_performer,
        _NameErrorData_aliasDereferenced,
        ____NameErrorData_notification__item__type_tab,
        _____NameErrorData_notification__item__type_tab_val_Type_0,
        _____NameErrorData_notification__item__type_tab_val_Type_1,
        ___NameErrorData_notification__item__type,
        ____NameErrorData_notification__item__values__item_,
        ___NameErrorData_notification__item__values,
        _____NameErrorData_notification__item__valuesWithContext__item__value,
        ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____NameErrorData_notification__item__valuesWithContext__item__contextList,
        ____NameErrorData_notification__item__valuesWithContext__item_,
        ___NameErrorData_notification__item__valuesWithContext,
        __NameErrorData_notification__item_,
        _NameErrorData_notification,
        NameErrorData,
        NameProblem,
        referral,
        __referral_val_ParameterType_unsigned,
        ___referral_val_ParameterType_signed_toBeSigned,
        _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____referral_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___referral_val_ParameterType_signed_algorithmIdentifier,
        ___referral_val_ParameterType_signed_signature,
        __referral_val_ParameterType_signed,
        _referral_val_ParameterType,
        _ReferralData_candidate,
        _ReferralData_securityParameters,
        _ReferralData_performer,
        _ReferralData_aliasDereferenced,
        ____ReferralData_notification__item__type_tab,
        _____ReferralData_notification__item__type_tab_val_Type_0,
        _____ReferralData_notification__item__type_tab_val_Type_1,
        ___ReferralData_notification__item__type,
        ____ReferralData_notification__item__values__item_,
        ___ReferralData_notification__item__values,
        _____ReferralData_notification__item__valuesWithContext__item__value,
        ______ReferralData_notification__item__valuesWithContext__item__contextList__item_,
        _____ReferralData_notification__item__valuesWithContext__item__contextList,
        ____ReferralData_notification__item__valuesWithContext__item_,
        ___ReferralData_notification__item__valuesWithContext,
        __ReferralData_notification__item_,
        _ReferralData_notification,
        ReferralData,
        securityError,
        __securityError_val_ParameterType_unsigned,
        ___securityError_val_ParameterType_signed_toBeSigned,
        _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___securityError_val_ParameterType_signed_algorithmIdentifier,
        ___securityError_val_ParameterType_signed_signature,
        __securityError_val_ParameterType_signed,
        _securityError_val_ParameterType,
        _SecurityErrorData_problem,
        _SecurityErrorData_spkmInfo,
        _SecurityErrorData_encPwdInfo,
        _SecurityErrorData_securityParameters,
        _SecurityErrorData_performer,
        _SecurityErrorData_aliasDereferenced,
        ____SecurityErrorData_notification__item__type_tab,
        _____SecurityErrorData_notification__item__type_tab_val_Type_0,
        _____SecurityErrorData_notification__item__type_tab_val_Type_1,
        ___SecurityErrorData_notification__item__type,
        ____SecurityErrorData_notification__item__values__item_,
        ___SecurityErrorData_notification__item__values,
        _____SecurityErrorData_notification__item__valuesWithContext__item__value,
        ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____SecurityErrorData_notification__item__valuesWithContext__item__contextList,
        ____SecurityErrorData_notification__item__valuesWithContext__item_,
        ___SecurityErrorData_notification__item__valuesWithContext,
        __SecurityErrorData_notification__item_,
        _SecurityErrorData_notification,
        SecurityErrorData,
        SecurityProblem,
        ____EncPwdInfo_algorithms__item__algorithm_tab,
        ___EncPwdInfo_algorithms__item__algorithm,
        ____EncPwdInfo_algorithms__item__parameters_tab,
        ___EncPwdInfo_algorithms__item__parameters,
        __EncPwdInfo_algorithms__item_,
        _EncPwdInfo_algorithms,
        __EncPwdInfo_pwdQualityRule__item_,
        _EncPwdInfo_pwdQualityRule,
        EncPwdInfo,
        serviceError,
        __serviceError_val_ParameterType_unsigned,
        ___serviceError_val_ParameterType_signed_toBeSigned,
        _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___serviceError_val_ParameterType_signed_algorithmIdentifier,
        ___serviceError_val_ParameterType_signed_signature,
        __serviceError_val_ParameterType_signed,
        _serviceError_val_ParameterType,
        _ServiceErrorData_problem,
        _ServiceErrorData_securityParameters,
        _ServiceErrorData_performer,
        _ServiceErrorData_aliasDereferenced,
        ____ServiceErrorData_notification__item__type_tab,
        _____ServiceErrorData_notification__item__type_tab_val_Type_0,
        _____ServiceErrorData_notification__item__type_tab_val_Type_1,
        ___ServiceErrorData_notification__item__type,
        ____ServiceErrorData_notification__item__values__item_,
        ___ServiceErrorData_notification__item__values,
        _____ServiceErrorData_notification__item__valuesWithContext__item__value,
        ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____ServiceErrorData_notification__item__valuesWithContext__item__contextList,
        ____ServiceErrorData_notification__item__valuesWithContext__item_,
        ___ServiceErrorData_notification__item__valuesWithContext,
        __ServiceErrorData_notification__item_,
        _ServiceErrorData_notification,
        ServiceErrorData,
        ServiceProblem,
        updateError,
        __updateError_val_ParameterType_unsigned,
        ___updateError_val_ParameterType_signed_toBeSigned,
        _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___updateError_val_ParameterType_signed_algorithmIdentifier,
        ___updateError_val_ParameterType_signed_signature,
        __updateError_val_ParameterType_signed,
        _updateError_val_ParameterType,
        _UpdateErrorData_problem,
        ___UpdateErrorData_attributeInfo__item__attributeType,
        _____UpdateErrorData_attributeInfo__item__attribute_type_tab,
        ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0,
        ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1,
        ____UpdateErrorData_attributeInfo__item__attribute_type,
        _____UpdateErrorData_attributeInfo__item__attribute_values__item_,
        ____UpdateErrorData_attributeInfo__item__attribute_values,
        ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value,
        _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_,
        ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList,
        _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_,
        ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext,
        ___UpdateErrorData_attributeInfo__item__attribute,
        __UpdateErrorData_attributeInfo__item_,
        _UpdateErrorData_attributeInfo,
        _UpdateErrorData_securityParameters,
        _UpdateErrorData_performer,
        _UpdateErrorData_aliasDereferenced,
        ___UpdateErrorData_notification__item__type,
        ____UpdateErrorData_notification__item__values__item_,
        ___UpdateErrorData_notification__item__values,
        _____UpdateErrorData_notification__item__valuesWithContext__item__value,
        ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____UpdateErrorData_notification__item__valuesWithContext__item__contextList,
        ____UpdateErrorData_notification__item__valuesWithContext__item_,
        ___UpdateErrorData_notification__item__valuesWithContext,
        __UpdateErrorData_notification__item_,
        _UpdateErrorData_notification,
        UpdateErrorData,
        UpdateProblem,
        id_at_family_information,
    ]

class DirectoryOperationalBindingTypes:

    _name_  = 'DirectoryOperationalBindingTypes'
    _oid_   = [2, 5, 1, 25, 8]
    
    _obj_ = [
        'id-op-binding-shadow',
        'id-op-binding-hierarchical',
        'id-op-binding-non-specific-hierarchical',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-op-binding-shadow',
        'id-op-binding-hierarchical',
        'id-op-binding-non-specific-hierarchical',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-op-binding-shadow >-----#
    id_op_binding_shadow = OID(name='id-op-binding-shadow', mode=MODE_VALUE)
    id_op_binding_shadow._val = (2, 5, 19, 1)
    
    #-----< id-op-binding-hierarchical >-----#
    id_op_binding_hierarchical = OID(name='id-op-binding-hierarchical', mode=MODE_VALUE)
    id_op_binding_hierarchical._val = (2, 5, 19, 2)
    
    #-----< id-op-binding-non-specific-hierarchical >-----#
    id_op_binding_non_specific_hierarchical = OID(name='id-op-binding-non-specific-hierarchical', mode=MODE_VALUE)
    id_op_binding_non_specific_hierarchical._val = (2, 5, 19, 3)
    
    _all_ = [
        id_op_binding_shadow,
        id_op_binding_hierarchical,
        id_op_binding_non_specific_hierarchical,
    ]

class DirectoryOSIProtocols:

    _name_  = 'DirectoryOSIProtocols'
    _oid_   = [2, 5, 1, 37, 8]
    
    _obj_ = [
        'DAP-OSI-PDUs',
        'DSP-OSI-PDUs',
        'DOP-OSI-PDUs',
        'ShadowSupplierInitiatedDISP-OSI-PDUs',
        'ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs',
        'ShadowConsumerInitiatedDISP-OSI-PDUs',
        'ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs',
        'APPLICATION-CONTEXT',
        'directoryAccessAC',
        'directorySystemAC',
        'shadowSupplierInitiatedAC',
        'shadowConsumerInitiatedAC',
        'shadowSupplierInitiatedAsynchronousAC',
        'shadowConsumerInitiatedAsynchronousAC',
        'directoryOperationalBindingManagementAC',
        'id-as-directoryAccessAS',
        'id-as-directorySystemAS',
        'id-as-directoryShadowAS',
        'id-as-directoryOperationalBindingManagementAS',
        'id-acseAS',
        'id-ac-directoryAccessAC',
        'id-ac-directorySystemAC',
        'id-ac-directoryOperationalBindingManagementAC',
        'id-ac-shadowConsumerInitiatedAC',
        'id-ac-shadowSupplierInitiatedAC',
        'id-ac-shadowSupplierInitiatedAsynchronousAC',
        'id-ac-shadowConsumerInitiatedAsynchronousAC',
        ]
    _type_ = [
        'DAP-OSI-PDUs',
        'DSP-OSI-PDUs',
        'DOP-OSI-PDUs',
        'ShadowSupplierInitiatedDISP-OSI-PDUs',
        'ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs',
        'ShadowConsumerInitiatedDISP-OSI-PDUs',
        'ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs',
        'APPLICATION-CONTEXT',
        ]
    _set_ = [
        ]
    _val_ = [
        'directoryAccessAC',
        'directorySystemAC',
        'shadowSupplierInitiatedAC',
        'shadowConsumerInitiatedAC',
        'shadowSupplierInitiatedAsynchronousAC',
        'shadowConsumerInitiatedAsynchronousAC',
        'directoryOperationalBindingManagementAC',
        'id-as-directoryAccessAS',
        'id-as-directorySystemAS',
        'id-as-directoryShadowAS',
        'id-as-directoryOperationalBindingManagementAS',
        'id-acseAS',
        'id-ac-directoryAccessAC',
        'id-ac-directorySystemAC',
        'id-ac-directoryOperationalBindingManagementAC',
        'id-ac-shadowConsumerInitiatedAC',
        'id-ac-shadowSupplierInitiatedAC',
        'id-ac-shadowSupplierInitiatedAsynchronousAC',
        'id-ac-shadowConsumerInitiatedAsynchronousAC',
        ]
    _class_ = [
        'APPLICATION-CONTEXT',
        'directoryAccessAC',
        'directorySystemAC',
        'shadowSupplierInitiatedAC',
        'shadowConsumerInitiatedAC',
        'shadowSupplierInitiatedAsynchronousAC',
        'shadowConsumerInitiatedAsynchronousAC',
        'directoryOperationalBindingManagementAC',
        ]
    _param_ = [
        ]
    
    #-----< DAP-OSI-PDUs >-----#
    DAP_OSI_PDUs = OPEN(name='DAP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DAP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DAP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DAP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DAP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DAP_OSI_PDUs_val_0_mode_selector._ext = None
    __DAP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __DAP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __DAP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_0._ext = None
    _DAP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DAP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DAP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DAP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DAP_OSI_PDUs_val_1_mode_selector._ext = None
    __DAP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __DAP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __DAP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_1._ext = None
    _DAP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DAP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __DAP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_2._ext = None
    _DAP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DAP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __OPERATION_Errors_val_ParameterType_3_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DAP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DAP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DAP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __DAP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DAP_OSI_PDUs_val_3._ext = None
    _DAP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DAP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DAP_OSI_PDUs._const_val = ASN1Set(rv=[_DAP_OSI_PDUs_val_0, _DAP_OSI_PDUs_val_1, _DAP_OSI_PDUs_val_2, _DAP_OSI_PDUs_val_3, _DAP_OSI_PDUs_val_4, _DAP_OSI_PDUs_val_5], ev=None)
    
    #-----< DSP-OSI-PDUs >-----#
    DSP_OSI_PDUs = OPEN(name='DSP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DSP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DSP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DSP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DSP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DSP_OSI_PDUs_val_0_mode_selector._ext = None
    __DSP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __DSP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __DSP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_0._ext = None
    _DSP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DSP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DSP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DSP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DSP_OSI_PDUs_val_1_mode_selector._ext = None
    __DSP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __DSP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __DSP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_1._ext = None
    _DSP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DSP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __DSP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_2._ext = None
    _DSP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DSP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __OPERATION_Errors_val_ParameterType_3_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_2._ext = None
    __OPERATION_Errors_val_ParameterType_4_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_2._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_1_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_3._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType._cont = _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_4._ext = None
    __OPERATION_Errors_val_ParameterType_2_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier),
        ('signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12._ext = None
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_4), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_3), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DSP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DSP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DSP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __DSP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DSP_OSI_PDUs_val_3._ext = None
    _DSP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DSP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DSP_OSI_PDUs._const_val = ASN1Set(rv=[_DSP_OSI_PDUs_val_0, _DSP_OSI_PDUs_val_1, _DSP_OSI_PDUs_val_2, _DSP_OSI_PDUs_val_3, _DSP_OSI_PDUs_val_4, _DSP_OSI_PDUs_val_5], ev=None)
    
    #-----< DOP-OSI-PDUs >-----#
    DOP_OSI_PDUs = OPEN(name='DOP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DOP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DOP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DOP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DOP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DOP_OSI_PDUs_val_0_mode_selector._ext = None
    __DOP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __DOP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __DOP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_0._ext = None
    _DOP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DOP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DOP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DOP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DOP_OSI_PDUs_val_1_mode_selector._ext = None
    __DOP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __DOP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __DOP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_1._ext = None
    _DOP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DOP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __DOP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_2._ext = None
    _DOP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DOP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_4_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_4_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_4._ext = None
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), ('ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DOP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DOP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DOP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __DOP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DOP_OSI_PDUs_val_3._ext = None
    _DOP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DOP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DOP_OSI_PDUs._const_val = ASN1Set(rv=[_DOP_OSI_PDUs_val_0, _DOP_OSI_PDUs_val_1, _DOP_OSI_PDUs_val_2, _DOP_OSI_PDUs_val_3, _DOP_OSI_PDUs_val_4, _DOP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowSupplierInitiatedDISP-OSI-PDUs >-----#
    ShadowSupplierInitiatedDISP_OSI_PDUs = OPEN(name='ShadowSupplierInitiatedDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_5_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_5_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_5._ext = None
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowSupplierInitiatedDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowSupplierInitiatedDISP_OSI_PDUs_val_0, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs >-----#
    ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs = OPEN(name='ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowConsumerInitiatedDISP-OSI-PDUs >-----#
    ShadowConsumerInitiatedDISP_OSI_PDUs = OPEN(name='ShadowConsumerInitiatedDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowConsumerInitiatedDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowConsumerInitiatedDISP_OSI_PDUs_val_0, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs >-----#
    ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs = OPEN(name='ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< APPLICATION-CONTEXT >-----#
    APPLICATION_CONTEXT = CLASS(name='APPLICATION-CONTEXT', mode=MODE_TYPE)
    _APPLICATION_CONTEXT_bind_operation = CLASS(name='bind-operation', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _APPLICATION_CONTEXT_Operations = CLASS(name='Operations', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _APPLICATION_CONTEXT_applicationContextName = OID(name='applicationContextName', mode=MODE_VALUE, uniq=True)
    APPLICATION_CONTEXT._cont = ASN1Dict([
        ('bind-operation', _APPLICATION_CONTEXT_bind_operation),
        ('Operations', _APPLICATION_CONTEXT_Operations),
        ('applicationContextName', _APPLICATION_CONTEXT_applicationContextName),
        ])
    
    #-----< directoryAccessAC >-----#
    directoryAccessAC = CLASS(name='directoryAccessAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindResult')))
    __OPERATION_Errors_val_ParameterType_0_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    directoryAccessAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 1))])
    
    #-----< directorySystemAC >-----#
    directorySystemAC = CLASS(name='directorySystemAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0 = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType_0 = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    directorySystemAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_4), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_3), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))])
    
    #-----< shadowSupplierInitiatedAC >-----#
    shadowSupplierInitiatedAC = CLASS(name='shadowSupplierInitiatedAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    shadowSupplierInitiatedAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])
    
    #-----< shadowConsumerInitiatedAC >-----#
    shadowConsumerInitiatedAC = CLASS(name='shadowConsumerInitiatedAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    shadowConsumerInitiatedAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])
    
    #-----< shadowSupplierInitiatedAsynchronousAC >-----#
    shadowSupplierInitiatedAsynchronousAC = CLASS(name='shadowSupplierInitiatedAsynchronousAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    shadowSupplierInitiatedAsynchronousAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 8))])
    
    #-----< shadowConsumerInitiatedAsynchronousAC >-----#
    shadowConsumerInitiatedAsynchronousAC = CLASS(name='shadowConsumerInitiatedAsynchronousAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    shadowConsumerInitiatedAsynchronousAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 9))])
    
    #-----< directoryOperationalBindingManagementAC >-----#
    directoryOperationalBindingManagementAC = CLASS(name='directoryOperationalBindingManagementAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    directoryOperationalBindingManagementAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 3))])
    
    #-----< id-as-directoryAccessAS >-----#
    id_as_directoryAccessAS = OID(name='id-as-directoryAccessAS', mode=MODE_VALUE)
    id_as_directoryAccessAS._val = (2, 5, 9, 1)
    
    #-----< id-as-directorySystemAS >-----#
    id_as_directorySystemAS = OID(name='id-as-directorySystemAS', mode=MODE_VALUE)
    id_as_directorySystemAS._val = (2, 5, 9, 2)
    
    #-----< id-as-directoryShadowAS >-----#
    id_as_directoryShadowAS = OID(name='id-as-directoryShadowAS', mode=MODE_VALUE)
    id_as_directoryShadowAS._val = (2, 5, 9, 3)
    
    #-----< id-as-directoryOperationalBindingManagementAS >-----#
    id_as_directoryOperationalBindingManagementAS = OID(name='id-as-directoryOperationalBindingManagementAS', mode=MODE_VALUE)
    id_as_directoryOperationalBindingManagementAS._val = (2, 5, 9, 4)
    
    #-----< id-acseAS >-----#
    id_acseAS = OID(name='id-acseAS', mode=MODE_VALUE)
    id_acseAS._val = (2, 2, 1, 0, 1)
    
    #-----< id-ac-directoryAccessAC >-----#
    id_ac_directoryAccessAC = OID(name='id-ac-directoryAccessAC', mode=MODE_VALUE)
    id_ac_directoryAccessAC._val = (2, 5, 3, 1)
    
    #-----< id-ac-directorySystemAC >-----#
    id_ac_directorySystemAC = OID(name='id-ac-directorySystemAC', mode=MODE_VALUE)
    id_ac_directorySystemAC._val = (2, 5, 3, 2)
    
    #-----< id-ac-directoryOperationalBindingManagementAC >-----#
    id_ac_directoryOperationalBindingManagementAC = OID(name='id-ac-directoryOperationalBindingManagementAC', mode=MODE_VALUE)
    id_ac_directoryOperationalBindingManagementAC._val = (2, 5, 3, 3)
    
    #-----< id-ac-shadowConsumerInitiatedAC >-----#
    id_ac_shadowConsumerInitiatedAC = OID(name='id-ac-shadowConsumerInitiatedAC', mode=MODE_VALUE)
    id_ac_shadowConsumerInitiatedAC._val = (2, 5, 3, 4)
    
    #-----< id-ac-shadowSupplierInitiatedAC >-----#
    id_ac_shadowSupplierInitiatedAC = OID(name='id-ac-shadowSupplierInitiatedAC', mode=MODE_VALUE)
    id_ac_shadowSupplierInitiatedAC._val = (2, 5, 3, 5)
    
    #-----< id-ac-shadowSupplierInitiatedAsynchronousAC >-----#
    id_ac_shadowSupplierInitiatedAsynchronousAC = OID(name='id-ac-shadowSupplierInitiatedAsynchronousAC', mode=MODE_VALUE)
    id_ac_shadowSupplierInitiatedAsynchronousAC._val = (2, 5, 3, 8)
    
    #-----< id-ac-shadowConsumerInitiatedAsynchronousAC >-----#
    id_ac_shadowConsumerInitiatedAsynchronousAC = OID(name='id-ac-shadowConsumerInitiatedAsynchronousAC', mode=MODE_VALUE)
    id_ac_shadowConsumerInitiatedAsynchronousAC._val = (2, 5, 3, 9)
    
    _all_ = [
        ___DAP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DAP_OSI_PDUs_val_0_mode_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_0_normal_mode_parameters,
        _DAP_OSI_PDUs_val_0,
        ___DAP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DAP_OSI_PDUs_val_1_mode_selector,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_1_normal_mode_parameters,
        _DAP_OSI_PDUs_val_1,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_2_normal_mode_parameters,
        _DAP_OSI_PDUs_val_2,
        ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_3_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_1_signed,
        __OPERATION_Errors_val_ParameterType_3_1,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DAP_OSI_PDUs_val_3_fully_encoded_data,
        _DAP_OSI_PDUs_val_3,
        _DAP_OSI_PDUs_val_4,
        _DAP_OSI_PDUs_val_5,
        DAP_OSI_PDUs,
        ___DSP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DSP_OSI_PDUs_val_0_mode_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_0_normal_mode_parameters,
        _DSP_OSI_PDUs_val_0,
        ___DSP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DSP_OSI_PDUs_val_1_mode_selector,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_1_normal_mode_parameters,
        _DSP_OSI_PDUs_val_1,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_2_normal_mode_parameters,
        _DSP_OSI_PDUs_val_2,
        ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ___OPERATION_Errors_val_ParameterType_3_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_2_signed,
        __OPERATION_Errors_val_ParameterType_3_2,
        ___OPERATION_Errors_val_ParameterType_4_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_2_signed,
        __OPERATION_Errors_val_ParameterType_4_2,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_1_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_3_signed,
        __OPERATION_Errors_val_ParameterType_1_3,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_4_signed,
        __OPERATION_Errors_val_ParameterType_1_4,
        ___OPERATION_Errors_val_ParameterType_2_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_3_signed,
        __OPERATION_Errors_val_ParameterType_2_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DSP_OSI_PDUs_val_3_fully_encoded_data,
        _DSP_OSI_PDUs_val_3,
        _DSP_OSI_PDUs_val_4,
        _DSP_OSI_PDUs_val_5,
        DSP_OSI_PDUs,
        ___DOP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DOP_OSI_PDUs_val_0_mode_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_0_normal_mode_parameters,
        _DOP_OSI_PDUs_val_0,
        ___DOP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DOP_OSI_PDUs_val_1_mode_selector,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_1_normal_mode_parameters,
        _DOP_OSI_PDUs_val_1,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_2_normal_mode_parameters,
        _DOP_OSI_PDUs_val_2,
        ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_4_signed,
        __OPERATION_Errors_val_ParameterType_0_4,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DOP_OSI_PDUs_val_3_fully_encoded_data,
        _DOP_OSI_PDUs_val_3,
        _DOP_OSI_PDUs_val_4,
        _DOP_OSI_PDUs_val_5,
        DOP_OSI_PDUs,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_5_signed,
        __OPERATION_Errors_val_ParameterType_0_5,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5,
        ShadowSupplierInitiatedDISP_OSI_PDUs,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5,
        ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5,
        ShadowConsumerInitiatedDISP_OSI_PDUs,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5,
        ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs,
        _APPLICATION_CONTEXT_bind_operation,
        _APPLICATION_CONTEXT_Operations,
        _APPLICATION_CONTEXT_applicationContextName,
        APPLICATION_CONTEXT,
        directoryAccessAC,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_6_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_6_signed,
        __OPERATION_Errors_val_ParameterType_0_6,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        directorySystemAC,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        shadowSupplierInitiatedAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_1,
        shadowConsumerInitiatedAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_2,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_2,
        shadowSupplierInitiatedAsynchronousAC,
        shadowConsumerInitiatedAsynchronousAC,
        directoryOperationalBindingManagementAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2_0,
        id_as_directoryAccessAS,
        id_as_directorySystemAS,
        id_as_directoryShadowAS,
        id_as_directoryOperationalBindingManagementAS,
        id_acseAS,
        id_ac_directoryAccessAC,
        id_ac_directorySystemAC,
        id_ac_directoryOperationalBindingManagementAC,
        id_ac_shadowConsumerInitiatedAC,
        id_ac_shadowSupplierInitiatedAC,
        id_ac_shadowSupplierInitiatedAsynchronousAC,
        id_ac_shadowConsumerInitiatedAsynchronousAC,
    ]

class DirectoryShadowAbstractService:

    _name_  = 'DirectoryShadowAbstractService'
    _oid_   = [2, 5, 1, 15, 8]
    
    _obj_ = [
        'dSAShadowBind',
        'shadowOperationalBinding',
        'ModificationParameter',
        'AgreementID',
        'ShadowingAgreementInfo',
        'UnitOfReplication',
        'AreaSpecification',
        'Knowledge',
        'AttributeSelection',
        'ClassAttributeSelection',
        'ClassAttributes',
        'AttributeTypes',
        'UpdateMode',
        'SupplierUpdateMode',
        'ConsumerUpdateMode',
        'SchedulingParameters',
        'PeriodicStrategy',
        'Time',
        'All-operations-consumer-initiated',
        'All-operations-supplier-initiated',
        'coordinateShadowUpdate',
        'CoordinateShadowUpdateArgument',
        'CoordinateShadowUpdateArgumentData',
        'CoordinateShadowUpdateResult',
        'CoordinateShadowUpdateResultData',
        'requestShadowUpdate',
        'RequestShadowUpdateArgument',
        'RequestShadowUpdateArgumentData',
        'RequestShadowUpdateResult',
        'RequestShadowUpdateResultData',
        'updateShadow',
        'UpdateShadowArgument',
        'UpdateShadowArgumentData',
        'UpdateShadowResult',
        'UpdateShadowResultData',
        'UpdateWindow',
        'RefreshInformation',
        'TotalRefresh',
        'SDSEContent',
        'SDSEType',
        'Subtree',
        'IncrementalRefresh',
        'IncrementalStepRefresh',
        'ContentChange',
        'SubordinateChanges',
        'shadowError',
        'ShadowErrorData',
        'ShadowProblem',
        ]
    _type_ = [
        'ModificationParameter',
        'AgreementID',
        'ShadowingAgreementInfo',
        'UnitOfReplication',
        'AreaSpecification',
        'Knowledge',
        'AttributeSelection',
        'ClassAttributeSelection',
        'ClassAttributes',
        'AttributeTypes',
        'UpdateMode',
        'SupplierUpdateMode',
        'ConsumerUpdateMode',
        'SchedulingParameters',
        'PeriodicStrategy',
        'Time',
        'CoordinateShadowUpdateArgument',
        'CoordinateShadowUpdateArgumentData',
        'CoordinateShadowUpdateResult',
        'CoordinateShadowUpdateResultData',
        'RequestShadowUpdateArgument',
        'RequestShadowUpdateArgumentData',
        'RequestShadowUpdateResult',
        'RequestShadowUpdateResultData',
        'UpdateShadowArgument',
        'UpdateShadowArgumentData',
        'UpdateShadowResult',
        'UpdateShadowResultData',
        'UpdateWindow',
        'RefreshInformation',
        'TotalRefresh',
        'SDSEContent',
        'SDSEType',
        'Subtree',
        'IncrementalRefresh',
        'IncrementalStepRefresh',
        'ContentChange',
        'SubordinateChanges',
        'ShadowErrorData',
        'ShadowProblem',
        ]
    _set_ = [
        'All-operations-consumer-initiated',
        'All-operations-supplier-initiated',
        ]
    _val_ = [
        'dSAShadowBind',
        'shadowOperationalBinding',
        'coordinateShadowUpdate',
        'requestShadowUpdate',
        'updateShadow',
        'shadowError',
        ]
    _class_ = [
        'dSAShadowBind',
        'shadowOperationalBinding',
        'All-operations-consumer-initiated',
        'All-operations-supplier-initiated',
        'coordinateShadowUpdate',
        'requestShadowUpdate',
        'updateShadow',
        'shadowError',
        ]
    _param_ = [
        ]
    
    #-----< dSAShadowBind >-----#
    dSAShadowBind = CLASS(name='dSAShadowBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSAShadowBind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSAShadowBind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSAShadowBind._val = dict([('ArgumentType', _dSAShadowBind_val_ArgumentType), ('ResultType', _dSAShadowBind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< shadowOperationalBinding >-----#
    shadowOperationalBinding = CLASS(name='shadowOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _shadowOperationalBinding_val_Agreement = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __shadowOperationalBinding_roleA_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __shadowOperationalBinding_roleB_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __shadowOperationalBinding_roleB_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ModificationParameter')))
    shadowOperationalBinding._val = dict([('Agreement', _shadowOperationalBinding_val_Agreement), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))])
    
    #-----< ModificationParameter >-----#
    ModificationParameter = SEQ(name='ModificationParameter', mode=MODE_TYPE)
    _ModificationParameter_secondaryShadows = SET_OF(name='secondaryShadows', mode=MODE_TYPE)
    __ModificationParameter_secondaryShadows__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierAndConsumers')))
    _ModificationParameter_secondaryShadows._cont = __ModificationParameter_secondaryShadows__item_
    ModificationParameter._cont = ASN1Dict([
        ('secondaryShadows', _ModificationParameter_secondaryShadows),
        ])
    ModificationParameter._ext = []
    
    #-----< AgreementID >-----#
    AgreementID = SEQ(name='AgreementID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    
    #-----< ShadowingAgreementInfo >-----#
    ShadowingAgreementInfo = SEQ(name='ShadowingAgreementInfo', mode=MODE_TYPE)
    _ShadowingAgreementInfo_shadowSubject = SEQ(name='shadowSubject', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UnitOfReplication')))
    _ShadowingAgreementInfo_updateMode = CHOICE(name='updateMode', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateMode')), default=('supplierInitiated', ('onChange', True)))
    _ShadowingAgreementInfo_master = SET(name='master', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _ShadowingAgreementInfo_secondaryShadows = BOOL(name='secondaryShadows', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ShadowingAgreementInfo._cont = ASN1Dict([
        ('shadowSubject', _ShadowingAgreementInfo_shadowSubject),
        ('updateMode', _ShadowingAgreementInfo_updateMode),
        ('master', _ShadowingAgreementInfo_master),
        ('secondaryShadows', _ShadowingAgreementInfo_secondaryShadows),
        ])
    ShadowingAgreementInfo._ext = None
    
    #-----< UnitOfReplication >-----#
    UnitOfReplication = SEQ(name='UnitOfReplication', mode=MODE_TYPE)
    _UnitOfReplication_area = SEQ(name='area', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AreaSpecification')))
    _UnitOfReplication_attributes = SET_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeSelection')))
    _UnitOfReplication_knowledge = SEQ(name='knowledge', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Knowledge')), opt=True)
    _UnitOfReplication_subordinates = BOOL(name='subordinates', mode=MODE_TYPE, default=False)
    _UnitOfReplication_contextSelection = CHOICE(name='contextSelection', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _UnitOfReplication_supplyContexts = CHOICE(name='supplyContexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __UnitOfReplication_supplyContexts_allContexts = NULL(name='allContexts', mode=MODE_TYPE)
    __UnitOfReplication_supplyContexts_selectedContexts = SET_OF(name='selectedContexts', mode=MODE_TYPE)
    ___UnitOfReplication_supplyContexts_selectedContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __UnitOfReplication_supplyContexts_selectedContexts._cont = ___UnitOfReplication_supplyContexts_selectedContexts__item_
    __UnitOfReplication_supplyContexts_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnitOfReplication_supplyContexts._cont = ASN1Dict([
        ('allContexts', __UnitOfReplication_supplyContexts_allContexts),
        ('selectedContexts', __UnitOfReplication_supplyContexts_selectedContexts),
        ])
    _UnitOfReplication_supplyContexts._ext = []
    UnitOfReplication._cont = ASN1Dict([
        ('area', _UnitOfReplication_area),
        ('attributes', _UnitOfReplication_attributes),
        ('knowledge', _UnitOfReplication_knowledge),
        ('subordinates', _UnitOfReplication_subordinates),
        ('contextSelection', _UnitOfReplication_contextSelection),
        ('supplyContexts', _UnitOfReplication_supplyContexts),
        ])
    UnitOfReplication._ext = None
    
    #-----< AreaSpecification >-----#
    AreaSpecification = SEQ(name='AreaSpecification', mode=MODE_TYPE)
    _AreaSpecification_contextPrefix = SEQ_OF(name='contextPrefix', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _AreaSpecification_replicationArea = SEQ(name='replicationArea', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    AreaSpecification._cont = ASN1Dict([
        ('contextPrefix', _AreaSpecification_contextPrefix),
        ('replicationArea', _AreaSpecification_replicationArea),
        ])
    AreaSpecification._ext = []
    
    #-----< Knowledge >-----#
    Knowledge = SEQ(name='Knowledge', mode=MODE_TYPE)
    _Knowledge_knowledgeType = ENUM(name='knowledgeType', mode=MODE_TYPE)
    _Knowledge_knowledgeType._cont = ASN1Dict([('master', 0), ('shadow', 1), ('both', 2)])
    _Knowledge_knowledgeType._ext = None
    _Knowledge_extendedKnowledge = BOOL(name='extendedKnowledge', mode=MODE_TYPE, default=False)
    Knowledge._cont = ASN1Dict([
        ('knowledgeType', _Knowledge_knowledgeType),
        ('extendedKnowledge', _Knowledge_extendedKnowledge),
        ])
    Knowledge._ext = []
    
    #-----< AttributeSelection >-----#
    AttributeSelection = SET_OF(name='AttributeSelection', mode=MODE_TYPE)
    _AttributeSelection__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ClassAttributeSelection')))
    AttributeSelection._cont = _AttributeSelection__item_
    
    #-----< ClassAttributeSelection >-----#
    ClassAttributeSelection = SEQ(name='ClassAttributeSelection', mode=MODE_TYPE)
    _ClassAttributeSelection_class_ = OID(name='class', mode=MODE_TYPE, opt=True)
    _ClassAttributeSelection_classAttributes = CHOICE(name='classAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ClassAttributes')), default=('allAttributes', 0))
    ClassAttributeSelection._cont = ASN1Dict([
        ('class', _ClassAttributeSelection_class_),
        ('classAttributes', _ClassAttributeSelection_classAttributes),
        ])
    ClassAttributeSelection._ext = None
    
    #-----< ClassAttributes >-----#
    ClassAttributes = CHOICE(name='ClassAttributes', mode=MODE_TYPE)
    _ClassAttributes_allAttributes = NULL(name='allAttributes', mode=MODE_TYPE)
    _ClassAttributes_include = SET_OF(name='include', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeTypes')))
    _ClassAttributes_exclude = SET_OF(name='exclude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeTypes')))
    ClassAttributes._cont = ASN1Dict([
        ('allAttributes', _ClassAttributes_allAttributes),
        ('include', _ClassAttributes_include),
        ('exclude', _ClassAttributes_exclude),
        ])
    ClassAttributes._ext = []
    
    #-----< AttributeTypes >-----#
    AttributeTypes = SET_OF(name='AttributeTypes', mode=MODE_TYPE)
    _AttributeTypes__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    AttributeTypes._cont = _AttributeTypes__item_
    
    #-----< UpdateMode >-----#
    UpdateMode = CHOICE(name='UpdateMode', mode=MODE_TYPE)
    _UpdateMode_supplierInitiated = CHOICE(name='supplierInitiated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SupplierUpdateMode')))
    _UpdateMode_consumerInitiated = SEQ(name='consumerInitiated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ConsumerUpdateMode')))
    UpdateMode._cont = ASN1Dict([
        ('supplierInitiated', _UpdateMode_supplierInitiated),
        ('consumerInitiated', _UpdateMode_consumerInitiated),
        ])
    UpdateMode._ext = []
    
    #-----< SupplierUpdateMode >-----#
    SupplierUpdateMode = CHOICE(name='SupplierUpdateMode', mode=MODE_TYPE)
    _SupplierUpdateMode_onChange = BOOL(name='onChange', mode=MODE_TYPE)
    _SupplierUpdateMode_scheduled = SEQ(name='scheduled', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SchedulingParameters')))
    SupplierUpdateMode._cont = ASN1Dict([
        ('onChange', _SupplierUpdateMode_onChange),
        ('scheduled', _SupplierUpdateMode_scheduled),
        ])
    SupplierUpdateMode._ext = []
    
    #-----< ConsumerUpdateMode >-----#
    ConsumerUpdateMode = SEQ(name='ConsumerUpdateMode', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SchedulingParameters')))
    
    #-----< SchedulingParameters >-----#
    SchedulingParameters = SEQ(name='SchedulingParameters', mode=MODE_TYPE)
    _SchedulingParameters_periodic = SEQ(name='periodic', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'PeriodicStrategy')), opt=True)
    _SchedulingParameters_othertimes = BOOL(name='othertimes', mode=MODE_TYPE, default=False)
    SchedulingParameters._cont = ASN1Dict([
        ('periodic', _SchedulingParameters_periodic),
        ('othertimes', _SchedulingParameters_othertimes),
        ])
    SchedulingParameters._ext = []
    
    #-----< PeriodicStrategy >-----#
    PeriodicStrategy = SEQ(name='PeriodicStrategy', mode=MODE_TYPE)
    _PeriodicStrategy_beginTime = TIME_GEN(name='beginTime', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _PeriodicStrategy_windowSize = INT(name='windowSize', mode=MODE_TYPE)
    _PeriodicStrategy_updateInterval = INT(name='updateInterval', mode=MODE_TYPE)
    PeriodicStrategy._cont = ASN1Dict([
        ('beginTime', _PeriodicStrategy_beginTime),
        ('windowSize', _PeriodicStrategy_windowSize),
        ('updateInterval', _PeriodicStrategy_updateInterval),
        ])
    PeriodicStrategy._ext = []
    
    #-----< Time >-----#
    Time = TIME_GEN(name='Time', mode=MODE_TYPE)
    
    #-----< All-operations-consumer-initiated >-----#
    All_operations_consumer_initiated = CLASS(name='All-operations-consumer-initiated', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _All_operations_consumer_initiated_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    _All_operations_consumer_initiated_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    _All_operations_consumer_initiated_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _All_operations_consumer_initiated_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    All_operations_consumer_initiated._val = ASN1Set(rv=[dict([('ArgumentType', _All_operations_consumer_initiated_val_ArgumentType_0), ('ResultType', _All_operations_consumer_initiated_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', _All_operations_consumer_initiated_val_ArgumentType_1), ('ResultType', _All_operations_consumer_initiated_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    
    #-----< All-operations-supplier-initiated >-----#
    All_operations_supplier_initiated = CLASS(name='All-operations-supplier-initiated', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _All_operations_supplier_initiated_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    _All_operations_supplier_initiated_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _All_operations_supplier_initiated_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _All_operations_supplier_initiated_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    All_operations_supplier_initiated._val = ASN1Set(rv=[dict([('ArgumentType', _All_operations_supplier_initiated_val_ArgumentType_0), ('ResultType', _All_operations_supplier_initiated_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', _All_operations_supplier_initiated_val_ArgumentType_1), ('ResultType', _All_operations_supplier_initiated_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    
    #-----< coordinateShadowUpdate >-----#
    coordinateShadowUpdate = CLASS(name='coordinateShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _coordinateShadowUpdate_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    _coordinateShadowUpdate_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    coordinateShadowUpdate._val = dict([('ArgumentType', _coordinateShadowUpdate_val_ArgumentType), ('ResultType', _coordinateShadowUpdate_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])
    
    #-----< CoordinateShadowUpdateArgument >-----#
    CoordinateShadowUpdateArgument = CHOICE(name='CoordinateShadowUpdateArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CoordinateShadowUpdateArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgumentData')))
    _CoordinateShadowUpdateArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CoordinateShadowUpdateArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgumentData')))
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab = ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab = ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters),
        ])
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier._ext = []
    __CoordinateShadowUpdateArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _CoordinateShadowUpdateArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __CoordinateShadowUpdateArgument_signed_toBeSigned),
        ('algorithmIdentifier', __CoordinateShadowUpdateArgument_signed_algorithmIdentifier),
        ('signature', __CoordinateShadowUpdateArgument_signed_signature),
        ])
    _CoordinateShadowUpdateArgument_signed._ext = []
    CoordinateShadowUpdateArgument._cont = ASN1Dict([
        ('unsigned', _CoordinateShadowUpdateArgument_unsigned),
        ('signed', _CoordinateShadowUpdateArgument_signed),
        ])
    CoordinateShadowUpdateArgument._ext = None
    
    #-----< CoordinateShadowUpdateArgumentData >-----#
    CoordinateShadowUpdateArgumentData = SEQ(name='CoordinateShadowUpdateArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoordinateShadowUpdateArgumentData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _CoordinateShadowUpdateArgumentData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _CoordinateShadowUpdateArgumentData_updateStrategy = CHOICE(name='updateStrategy', mode=MODE_TYPE)
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard = ENUM(name='standard', mode=MODE_TYPE)
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard._cont = ASN1Dict([('noChanges', 0), ('incremental', 1), ('total', 2)])
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard._ext = []
    __CoordinateShadowUpdateArgumentData_updateStrategy_other = EXT(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _CoordinateShadowUpdateArgumentData_updateStrategy._cont = ASN1Dict([
        ('standard', __CoordinateShadowUpdateArgumentData_updateStrategy_standard),
        ('other', __CoordinateShadowUpdateArgumentData_updateStrategy_other),
        ])
    _CoordinateShadowUpdateArgumentData_updateStrategy._ext = []
    _CoordinateShadowUpdateArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    CoordinateShadowUpdateArgumentData._cont = ASN1Dict([
        ('agreementID', _CoordinateShadowUpdateArgumentData_agreementID),
        ('lastUpdate', _CoordinateShadowUpdateArgumentData_lastUpdate),
        ('updateStrategy', _CoordinateShadowUpdateArgumentData_updateStrategy),
        ('securityParameters', _CoordinateShadowUpdateArgumentData_securityParameters),
        ])
    CoordinateShadowUpdateArgumentData._ext = []
    
    #-----< CoordinateShadowUpdateResult >-----#
    CoordinateShadowUpdateResult = CHOICE(name='CoordinateShadowUpdateResult', mode=MODE_TYPE)
    _CoordinateShadowUpdateResult_null = NULL(name='null', mode=MODE_TYPE)
    _CoordinateShadowUpdateResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __CoordinateShadowUpdateResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResultData')))
    __CoordinateShadowUpdateResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___CoordinateShadowUpdateResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResultData')))
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab = _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier._ext = []
    ___CoordinateShadowUpdateResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __CoordinateShadowUpdateResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___CoordinateShadowUpdateResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier),
        ('signature', ___CoordinateShadowUpdateResult_information_signed_signature),
        ])
    __CoordinateShadowUpdateResult_information_signed._ext = []
    _CoordinateShadowUpdateResult_information._cont = ASN1Dict([
        ('unsigned', __CoordinateShadowUpdateResult_information_unsigned),
        ('signed', __CoordinateShadowUpdateResult_information_signed),
        ])
    _CoordinateShadowUpdateResult_information._ext = None
    CoordinateShadowUpdateResult._cont = ASN1Dict([
        ('null', _CoordinateShadowUpdateResult_null),
        ('information', _CoordinateShadowUpdateResult_information),
        ])
    CoordinateShadowUpdateResult._ext = []
    
    #-----< CoordinateShadowUpdateResultData >-----#
    CoordinateShadowUpdateResultData = SEQ(name='CoordinateShadowUpdateResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoordinateShadowUpdateResultData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _CoordinateShadowUpdateResultData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _CoordinateShadowUpdateResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CoordinateShadowUpdateResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CoordinateShadowUpdateResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CoordinateShadowUpdateResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CoordinateShadowUpdateResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CoordinateShadowUpdateResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CoordinateShadowUpdateResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CoordinateShadowUpdateResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab_at = None
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab_id = 'id'
    ___CoordinateShadowUpdateResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CoordinateShadowUpdateResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___CoordinateShadowUpdateResultData_notification__item__values._cont = ____CoordinateShadowUpdateResultData_notification__item__values__item_
    ___CoordinateShadowUpdateResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._cont = ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_._ext = []
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext._cont = ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CoordinateShadowUpdateResultData_notification__item_._cont = ASN1Dict([
        ('type', ___CoordinateShadowUpdateResultData_notification__item__type),
        ('values', ___CoordinateShadowUpdateResultData_notification__item__values),
        ('valuesWithContext', ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext),
        ])
    __CoordinateShadowUpdateResultData_notification__item_._ext = []
    _CoordinateShadowUpdateResultData_notification._cont = __CoordinateShadowUpdateResultData_notification__item_
    CoordinateShadowUpdateResultData._cont = ASN1Dict([
        ('agreementID', _CoordinateShadowUpdateResultData_agreementID),
        ('lastUpdate', _CoordinateShadowUpdateResultData_lastUpdate),
        ('securityParameters', _CoordinateShadowUpdateResultData_securityParameters),
        ('performer', _CoordinateShadowUpdateResultData_performer),
        ('aliasDereferenced', _CoordinateShadowUpdateResultData_aliasDereferenced),
        ('notification', _CoordinateShadowUpdateResultData_notification),
        ])
    CoordinateShadowUpdateResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< requestShadowUpdate >-----#
    requestShadowUpdate = CLASS(name='requestShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _requestShadowUpdate_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    _requestShadowUpdate_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    requestShadowUpdate._val = dict([('ArgumentType', _requestShadowUpdate_val_ArgumentType), ('ResultType', _requestShadowUpdate_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))])
    
    #-----< RequestShadowUpdateArgument >-----#
    RequestShadowUpdateArgument = CHOICE(name='RequestShadowUpdateArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _RequestShadowUpdateArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgumentData')))
    _RequestShadowUpdateArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __RequestShadowUpdateArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgumentData')))
    __RequestShadowUpdateArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab = ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab = ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __RequestShadowUpdateArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters),
        ])
    __RequestShadowUpdateArgument_signed_algorithmIdentifier._ext = []
    __RequestShadowUpdateArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _RequestShadowUpdateArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __RequestShadowUpdateArgument_signed_toBeSigned),
        ('algorithmIdentifier', __RequestShadowUpdateArgument_signed_algorithmIdentifier),
        ('signature', __RequestShadowUpdateArgument_signed_signature),
        ])
    _RequestShadowUpdateArgument_signed._ext = []
    RequestShadowUpdateArgument._cont = ASN1Dict([
        ('unsigned', _RequestShadowUpdateArgument_unsigned),
        ('signed', _RequestShadowUpdateArgument_signed),
        ])
    RequestShadowUpdateArgument._ext = None
    
    #-----< RequestShadowUpdateArgumentData >-----#
    RequestShadowUpdateArgumentData = SEQ(name='RequestShadowUpdateArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestShadowUpdateArgumentData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _RequestShadowUpdateArgumentData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _RequestShadowUpdateArgumentData_requestedStrategy = CHOICE(name='requestedStrategy', mode=MODE_TYPE)
    __RequestShadowUpdateArgumentData_requestedStrategy_standard = ENUM(name='standard', mode=MODE_TYPE)
    __RequestShadowUpdateArgumentData_requestedStrategy_standard._cont = ASN1Dict([('incremental', 1), ('total', 2)])
    __RequestShadowUpdateArgumentData_requestedStrategy_standard._ext = []
    __RequestShadowUpdateArgumentData_requestedStrategy_other = EXT(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RequestShadowUpdateArgumentData_requestedStrategy._cont = ASN1Dict([
        ('standard', __RequestShadowUpdateArgumentData_requestedStrategy_standard),
        ('other', __RequestShadowUpdateArgumentData_requestedStrategy_other),
        ])
    _RequestShadowUpdateArgumentData_requestedStrategy._ext = []
    _RequestShadowUpdateArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    RequestShadowUpdateArgumentData._cont = ASN1Dict([
        ('agreementID', _RequestShadowUpdateArgumentData_agreementID),
        ('lastUpdate', _RequestShadowUpdateArgumentData_lastUpdate),
        ('requestedStrategy', _RequestShadowUpdateArgumentData_requestedStrategy),
        ('securityParameters', _RequestShadowUpdateArgumentData_securityParameters),
        ])
    RequestShadowUpdateArgumentData._ext = []
    
    #-----< RequestShadowUpdateResult >-----#
    RequestShadowUpdateResult = CHOICE(name='RequestShadowUpdateResult', mode=MODE_TYPE)
    _RequestShadowUpdateResult_null = NULL(name='null', mode=MODE_TYPE)
    _RequestShadowUpdateResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __RequestShadowUpdateResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResultData')))
    __RequestShadowUpdateResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___RequestShadowUpdateResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResultData')))
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab = _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier._ext = []
    ___RequestShadowUpdateResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __RequestShadowUpdateResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___RequestShadowUpdateResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___RequestShadowUpdateResult_information_signed_algorithmIdentifier),
        ('signature', ___RequestShadowUpdateResult_information_signed_signature),
        ])
    __RequestShadowUpdateResult_information_signed._ext = []
    _RequestShadowUpdateResult_information._cont = ASN1Dict([
        ('unsigned', __RequestShadowUpdateResult_information_unsigned),
        ('signed', __RequestShadowUpdateResult_information_signed),
        ])
    _RequestShadowUpdateResult_information._ext = None
    RequestShadowUpdateResult._cont = ASN1Dict([
        ('null', _RequestShadowUpdateResult_null),
        ('information', _RequestShadowUpdateResult_information),
        ])
    RequestShadowUpdateResult._ext = []
    
    #-----< RequestShadowUpdateResultData >-----#
    RequestShadowUpdateResultData = SEQ(name='RequestShadowUpdateResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestShadowUpdateResultData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _RequestShadowUpdateResultData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _RequestShadowUpdateResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RequestShadowUpdateResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RequestShadowUpdateResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RequestShadowUpdateResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestShadowUpdateResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___RequestShadowUpdateResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____RequestShadowUpdateResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____RequestShadowUpdateResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___RequestShadowUpdateResultData_notification__item__type._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    ___RequestShadowUpdateResultData_notification__item__type._const_tab_at = None
    ___RequestShadowUpdateResultData_notification__item__type._const_tab_id = 'id'
    ___RequestShadowUpdateResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____RequestShadowUpdateResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___RequestShadowUpdateResultData_notification__item__values._cont = ____RequestShadowUpdateResultData_notification__item__values__item_
    ___RequestShadowUpdateResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._cont = ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_._ext = []
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext._cont = ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __RequestShadowUpdateResultData_notification__item_._cont = ASN1Dict([
        ('type', ___RequestShadowUpdateResultData_notification__item__type),
        ('values', ___RequestShadowUpdateResultData_notification__item__values),
        ('valuesWithContext', ___RequestShadowUpdateResultData_notification__item__valuesWithContext),
        ])
    __RequestShadowUpdateResultData_notification__item_._ext = []
    _RequestShadowUpdateResultData_notification._cont = __RequestShadowUpdateResultData_notification__item_
    RequestShadowUpdateResultData._cont = ASN1Dict([
        ('agreementID', _RequestShadowUpdateResultData_agreementID),
        ('lastUpdate', _RequestShadowUpdateResultData_lastUpdate),
        ('securityParameters', _RequestShadowUpdateResultData_securityParameters),
        ('performer', _RequestShadowUpdateResultData_performer),
        ('aliasDereferenced', _RequestShadowUpdateResultData_aliasDereferenced),
        ('notification', _RequestShadowUpdateResultData_notification),
        ])
    RequestShadowUpdateResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< updateShadow >-----#
    updateShadow = CLASS(name='updateShadow', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _updateShadow_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _updateShadow_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    updateShadow._val = dict([('ArgumentType', _updateShadow_val_ArgumentType), ('ResultType', _updateShadow_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])
    
    #-----< UpdateShadowArgument >-----#
    UpdateShadowArgument = CHOICE(name='UpdateShadowArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _UpdateShadowArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgumentData')))
    _UpdateShadowArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __UpdateShadowArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgumentData')))
    __UpdateShadowArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab = ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab = ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __UpdateShadowArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___UpdateShadowArgument_signed_algorithmIdentifier_parameters),
        ])
    __UpdateShadowArgument_signed_algorithmIdentifier._ext = []
    __UpdateShadowArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _UpdateShadowArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __UpdateShadowArgument_signed_toBeSigned),
        ('algorithmIdentifier', __UpdateShadowArgument_signed_algorithmIdentifier),
        ('signature', __UpdateShadowArgument_signed_signature),
        ])
    _UpdateShadowArgument_signed._ext = []
    UpdateShadowArgument._cont = ASN1Dict([
        ('unsigned', _UpdateShadowArgument_unsigned),
        ('signed', _UpdateShadowArgument_signed),
        ])
    UpdateShadowArgument._ext = None
    
    #-----< UpdateShadowArgumentData >-----#
    UpdateShadowArgumentData = SEQ(name='UpdateShadowArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UpdateShadowArgumentData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _UpdateShadowArgumentData_updateTime = TIME_GEN(name='updateTime', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    _UpdateShadowArgumentData_updateWindow = SEQ(name='updateWindow', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateWindow')), opt=True)
    _UpdateShadowArgumentData_updatedInfo = CHOICE(name='updatedInfo', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RefreshInformation')))
    _UpdateShadowArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    UpdateShadowArgumentData._cont = ASN1Dict([
        ('agreementID', _UpdateShadowArgumentData_agreementID),
        ('updateTime', _UpdateShadowArgumentData_updateTime),
        ('updateWindow', _UpdateShadowArgumentData_updateWindow),
        ('updatedInfo', _UpdateShadowArgumentData_updatedInfo),
        ('securityParameters', _UpdateShadowArgumentData_securityParameters),
        ])
    UpdateShadowArgumentData._ext = []
    
    #-----< UpdateShadowResult >-----#
    UpdateShadowResult = CHOICE(name='UpdateShadowResult', mode=MODE_TYPE)
    _UpdateShadowResult_null = NULL(name='null', mode=MODE_TYPE)
    _UpdateShadowResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __UpdateShadowResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResultData')))
    __UpdateShadowResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___UpdateShadowResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResultData')))
    ___UpdateShadowResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab = _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___UpdateShadowResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___UpdateShadowResult_information_signed_algorithmIdentifier._ext = []
    ___UpdateShadowResult_information_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __UpdateShadowResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___UpdateShadowResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___UpdateShadowResult_information_signed_algorithmIdentifier),
        ('signature', ___UpdateShadowResult_information_signed_signature),
        ])
    __UpdateShadowResult_information_signed._ext = []
    _UpdateShadowResult_information._cont = ASN1Dict([
        ('unsigned', __UpdateShadowResult_information_unsigned),
        ('signed', __UpdateShadowResult_information_signed),
        ])
    _UpdateShadowResult_information._ext = None
    UpdateShadowResult._cont = ASN1Dict([
        ('null', _UpdateShadowResult_null),
        ('information', _UpdateShadowResult_information),
        ])
    UpdateShadowResult._ext = []
    
    #-----< UpdateShadowResultData >-----#
    UpdateShadowResultData = SEQ(name='UpdateShadowResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UpdateShadowResultData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _UpdateShadowResultData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _UpdateShadowResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _UpdateShadowResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _UpdateShadowResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _UpdateShadowResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateShadowResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___UpdateShadowResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____UpdateShadowResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____UpdateShadowResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____UpdateShadowResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____UpdateShadowResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____UpdateShadowResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____UpdateShadowResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___UpdateShadowResultData_notification__item__type._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    ___UpdateShadowResultData_notification__item__type._const_tab_at = None
    ___UpdateShadowResultData_notification__item__type._const_tab_id = 'id'
    ___UpdateShadowResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____UpdateShadowResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____UpdateShadowResultData_notification__item__values__item_._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    ____UpdateShadowResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____UpdateShadowResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___UpdateShadowResultData_notification__item__values._cont = ____UpdateShadowResultData_notification__item__values__item_
    ___UpdateShadowResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___UpdateShadowResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList._cont = ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____UpdateShadowResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_._ext = []
    ___UpdateShadowResultData_notification__item__valuesWithContext._cont = ____UpdateShadowResultData_notification__item__valuesWithContext__item_
    ___UpdateShadowResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __UpdateShadowResultData_notification__item_._cont = ASN1Dict([
        ('type', ___UpdateShadowResultData_notification__item__type),
        ('values', ___UpdateShadowResultData_notification__item__values),
        ('valuesWithContext', ___UpdateShadowResultData_notification__item__valuesWithContext),
        ])
    __UpdateShadowResultData_notification__item_._ext = []
    _UpdateShadowResultData_notification._cont = __UpdateShadowResultData_notification__item_
    UpdateShadowResultData._cont = ASN1Dict([
        ('agreementID', _UpdateShadowResultData_agreementID),
        ('lastUpdate', _UpdateShadowResultData_lastUpdate),
        ('securityParameters', _UpdateShadowResultData_securityParameters),
        ('performer', _UpdateShadowResultData_performer),
        ('aliasDereferenced', _UpdateShadowResultData_aliasDereferenced),
        ('notification', _UpdateShadowResultData_notification),
        ])
    UpdateShadowResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< UpdateWindow >-----#
    UpdateWindow = SEQ(name='UpdateWindow', mode=MODE_TYPE)
    _UpdateWindow_start = TIME_GEN(name='start', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    _UpdateWindow_stop = TIME_GEN(name='stop', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    UpdateWindow._cont = ASN1Dict([
        ('start', _UpdateWindow_start),
        ('stop', _UpdateWindow_stop),
        ])
    UpdateWindow._ext = []
    
    #-----< RefreshInformation >-----#
    RefreshInformation = CHOICE(name='RefreshInformation', mode=MODE_TYPE)
    _RefreshInformation_noRefresh = NULL(name='noRefresh', mode=MODE_TYPE)
    _RefreshInformation_total = SEQ(name='total', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'TotalRefresh')))
    _RefreshInformation_incremental = SEQ_OF(name='incremental', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalRefresh')))
    _RefreshInformation_otherStrategy = EXT(name='otherStrategy', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    RefreshInformation._cont = ASN1Dict([
        ('noRefresh', _RefreshInformation_noRefresh),
        ('total', _RefreshInformation_total),
        ('incremental', _RefreshInformation_incremental),
        ('otherStrategy', _RefreshInformation_otherStrategy),
        ])
    RefreshInformation._ext = []
    
    #-----< TotalRefresh >-----#
    TotalRefresh = SEQ(name='TotalRefresh', mode=MODE_TYPE)
    _TotalRefresh_sDSE = SEQ(name='sDSE', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')), opt=True)
    _TotalRefresh_subtree = SET_OF(name='subtree', mode=MODE_TYPE, opt=True)
    __TotalRefresh_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Subtree')))
    _TotalRefresh_subtree._cont = __TotalRefresh_subtree__item_
    _TotalRefresh_subtree._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    TotalRefresh._cont = ASN1Dict([
        ('sDSE', _TotalRefresh_sDSE),
        ('subtree', _TotalRefresh_subtree),
        ])
    TotalRefresh._ext = []
    
    #-----< SDSEContent >-----#
    SDSEContent = SEQ(name='SDSEContent', mode=MODE_TYPE)
    _SDSEContent_sDSEType = BIT_STR(name='sDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEType')))
    _SDSEContent_subComplete = BOOL(name='subComplete', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SDSEContent_attComplete = BOOL(name='attComplete', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDSEContent_attributes = SET_OF(name='attributes', mode=MODE_TYPE)
    __SDSEContent_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SDSEContent_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SDSEContent_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SDSEContent_attributes__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SDSEContent_attributes__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SDSEContent_attributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SDSEContent_attributes__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SDSEContent_attributes__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SDSEContent_attributes__item__type._const_tab = ____SDSEContent_attributes__item__type_tab
    ___SDSEContent_attributes__item__type._const_tab_at = None
    ___SDSEContent_attributes__item__type._const_tab_id = 'id'
    ___SDSEContent_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SDSEContent_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SDSEContent_attributes__item__values__item_._const_tab = ____SDSEContent_attributes__item__type_tab
    ____SDSEContent_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SDSEContent_attributes__item__values__item_._const_tab_id = 'Type'
    ___SDSEContent_attributes__item__values._cont = ____SDSEContent_attributes__item__values__item_
    ___SDSEContent_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SDSEContent_attributes__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SDSEContent_attributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SDSEContent_attributes__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab = ____SDSEContent_attributes__item__type_tab
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList._cont = ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SDSEContent_attributes__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SDSEContent_attributes__item__valuesWithContext__item__value),
        ('contextList', _____SDSEContent_attributes__item__valuesWithContext__item__contextList),
        ])
    ____SDSEContent_attributes__item__valuesWithContext__item_._ext = []
    ___SDSEContent_attributes__item__valuesWithContext._cont = ____SDSEContent_attributes__item__valuesWithContext__item_
    ___SDSEContent_attributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SDSEContent_attributes__item_._cont = ASN1Dict([
        ('type', ___SDSEContent_attributes__item__type),
        ('values', ___SDSEContent_attributes__item__values),
        ('valuesWithContext', ___SDSEContent_attributes__item__valuesWithContext),
        ])
    __SDSEContent_attributes__item_._ext = []
    _SDSEContent_attributes._cont = __SDSEContent_attributes__item_
    _SDSEContent_attValIncomplete = SET_OF(name='attValIncomplete', mode=MODE_TYPE, default=[])
    __SDSEContent_attValIncomplete__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SDSEContent_attValIncomplete._cont = __SDSEContent_attValIncomplete__item_
    SDSEContent._cont = ASN1Dict([
        ('sDSEType', _SDSEContent_sDSEType),
        ('subComplete', _SDSEContent_subComplete),
        ('attComplete', _SDSEContent_attComplete),
        ('attributes', _SDSEContent_attributes),
        ('attValIncomplete', _SDSEContent_attValIncomplete),
        ])
    SDSEContent._ext = []
    
    #-----< SDSEType >-----#
    SDSEType = BIT_STR(name='SDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'DSEType')))
    
    #-----< Subtree >-----#
    Subtree = SEQ(name='Subtree', mode=MODE_TYPE)
    _Subtree_rdn = SET_OF(name='rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _Subtree_sDSE = SEQ(name='sDSE', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')), opt=True)
    _Subtree_subtree = SET_OF(name='subtree', mode=MODE_TYPE, opt=True)
    __Subtree_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Subtree')))
    _Subtree_subtree._cont = __Subtree_subtree__item_
    Subtree._cont = ASN1Dict([
        ('rdn', _Subtree_rdn),
        ('sDSE', _Subtree_sDSE),
        ('subtree', _Subtree_subtree),
        ])
    Subtree._ext = []
    
    #-----< IncrementalRefresh >-----#
    IncrementalRefresh = SEQ_OF(name='IncrementalRefresh', mode=MODE_TYPE)
    _IncrementalRefresh__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalStepRefresh')))
    IncrementalRefresh._cont = _IncrementalRefresh__item_
    
    #-----< IncrementalStepRefresh >-----#
    IncrementalStepRefresh = SEQ(name='IncrementalStepRefresh', mode=MODE_TYPE)
    _IncrementalStepRefresh_sDSEChanges = CHOICE(name='sDSEChanges', mode=MODE_TYPE, opt=True)
    __IncrementalStepRefresh_sDSEChanges_add = SEQ(name='add', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')))
    __IncrementalStepRefresh_sDSEChanges_remove = NULL(name='remove', mode=MODE_TYPE)
    __IncrementalStepRefresh_sDSEChanges_modify = SEQ(name='modify', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ContentChange')))
    _IncrementalStepRefresh_sDSEChanges._cont = ASN1Dict([
        ('add', __IncrementalStepRefresh_sDSEChanges_add),
        ('remove', __IncrementalStepRefresh_sDSEChanges_remove),
        ('modify', __IncrementalStepRefresh_sDSEChanges_modify),
        ])
    _IncrementalStepRefresh_sDSEChanges._ext = []
    _IncrementalStepRefresh_subordinateUpdates = SEQ_OF(name='subordinateUpdates', mode=MODE_TYPE, opt=True)
    __IncrementalStepRefresh_subordinateUpdates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SubordinateChanges')))
    _IncrementalStepRefresh_subordinateUpdates._cont = __IncrementalStepRefresh_subordinateUpdates__item_
    _IncrementalStepRefresh_subordinateUpdates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    IncrementalStepRefresh._cont = ASN1Dict([
        ('sDSEChanges', _IncrementalStepRefresh_sDSEChanges),
        ('subordinateUpdates', _IncrementalStepRefresh_subordinateUpdates),
        ])
    IncrementalStepRefresh._ext = None
    
    #-----< ContentChange >-----#
    ContentChange = SEQ(name='ContentChange', mode=MODE_TYPE)
    _ContentChange_rename = CHOICE(name='rename', mode=MODE_TYPE, opt=True)
    __ContentChange_rename_newRDN = SET_OF(name='newRDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    __ContentChange_rename_newDN = SEQ_OF(name='newDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ContentChange_rename._cont = ASN1Dict([
        ('newRDN', __ContentChange_rename_newRDN),
        ('newDN', __ContentChange_rename_newDN),
        ])
    _ContentChange_rename._ext = None
    _ContentChange_attributeChanges = CHOICE(name='attributeChanges', mode=MODE_TYPE, opt=True)
    __ContentChange_attributeChanges_replace = SET_OF(name='replace', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ContentChange_attributeChanges_replace__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____ContentChange_attributeChanges_replace__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____ContentChange_attributeChanges_replace__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____ContentChange_attributeChanges_replace__item__type_tab._val = ASN1Set(rv=[dict([('Type', ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____ContentChange_attributeChanges_replace__item__type._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    ____ContentChange_attributeChanges_replace__item__type._const_tab_at = None
    ____ContentChange_attributeChanges_replace__item__type._const_tab_id = 'id'
    ____ContentChange_attributeChanges_replace__item__values = SET_OF(name='values', mode=MODE_TYPE)
    _____ContentChange_attributeChanges_replace__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab_at = ('..', '..', 'type')
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab_id = 'Type'
    ____ContentChange_attributeChanges_replace__item__values._cont = _____ContentChange_attributeChanges_replace__item__values__item_
    ____ContentChange_attributeChanges_replace__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____ContentChange_attributeChanges_replace__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList._cont = _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value),
        ('contextList', ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList),
        ])
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_._ext = []
    ____ContentChange_attributeChanges_replace__item__valuesWithContext._cont = _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_
    ____ContentChange_attributeChanges_replace__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___ContentChange_attributeChanges_replace__item_._cont = ASN1Dict([
        ('type', ____ContentChange_attributeChanges_replace__item__type),
        ('values', ____ContentChange_attributeChanges_replace__item__values),
        ('valuesWithContext', ____ContentChange_attributeChanges_replace__item__valuesWithContext),
        ])
    ___ContentChange_attributeChanges_replace__item_._ext = []
    __ContentChange_attributeChanges_replace._cont = ___ContentChange_attributeChanges_replace__item_
    __ContentChange_attributeChanges_replace._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ContentChange_attributeChanges_changes = SEQ_OF(name='changes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ContentChange_attributeChanges_changes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryModification')))
    __ContentChange_attributeChanges_changes._cont = ___ContentChange_attributeChanges_changes__item_
    __ContentChange_attributeChanges_changes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ContentChange_attributeChanges._cont = ASN1Dict([
        ('replace', __ContentChange_attributeChanges_replace),
        ('changes', __ContentChange_attributeChanges_changes),
        ])
    _ContentChange_attributeChanges._ext = None
    _ContentChange_sDSEType = BIT_STR(name='sDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEType')))
    _ContentChange_subComplete = BOOL(name='subComplete', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ContentChange_attComplete = BOOL(name='attComplete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ContentChange_attValIncomplete = SET_OF(name='attValIncomplete', mode=MODE_TYPE, default=[])
    __ContentChange_attValIncomplete__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ContentChange_attValIncomplete._cont = __ContentChange_attValIncomplete__item_
    ContentChange._cont = ASN1Dict([
        ('rename', _ContentChange_rename),
        ('attributeChanges', _ContentChange_attributeChanges),
        ('sDSEType', _ContentChange_sDSEType),
        ('subComplete', _ContentChange_subComplete),
        ('attComplete', _ContentChange_attComplete),
        ('attValIncomplete', _ContentChange_attValIncomplete),
        ])
    ContentChange._ext = []
    
    #-----< SubordinateChanges >-----#
    SubordinateChanges = SEQ(name='SubordinateChanges', mode=MODE_TYPE)
    _SubordinateChanges_subordinate = SET_OF(name='subordinate', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _SubordinateChanges_changes = SEQ(name='changes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalStepRefresh')))
    SubordinateChanges._cont = ASN1Dict([
        ('subordinate', _SubordinateChanges_subordinate),
        ('changes', _SubordinateChanges_changes),
        ])
    SubordinateChanges._ext = []
    
    #-----< shadowError >-----#
    shadowError = CLASS(name='shadowError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _shadowError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __shadowError_val_ParameterType_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    __shadowError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___shadowError_val_ParameterType_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___shadowError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___shadowError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___shadowError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___shadowError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __shadowError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___shadowError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___shadowError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___shadowError_val_ParameterType_signed_signature),
        ])
    __shadowError_val_ParameterType_signed._ext = []
    _shadowError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __shadowError_val_ParameterType_unsigned),
        ('signed', __shadowError_val_ParameterType_signed),
        ])
    _shadowError_val_ParameterType._ext = None
    shadowError._val = dict([('ParameterType', _shadowError_val_ParameterType), ('errorCode', ('local', 1))])
    
    #-----< ShadowErrorData >-----#
    ShadowErrorData = SEQ(name='ShadowErrorData', mode=MODE_TYPE)
    _ShadowErrorData_problem = INT(name='problem', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowProblem')))
    _ShadowErrorData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _ShadowErrorData_updateWindow = SEQ(name='updateWindow', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateWindow')), opt=True)
    _ShadowErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ShadowErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ShadowErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ShadowErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ShadowErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ShadowErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ShadowErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ShadowErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ShadowErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ShadowErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ShadowErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ShadowErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ShadowErrorData_notification__item__type._const_tab = ____ShadowErrorData_notification__item__type_tab
    ___ShadowErrorData_notification__item__type._const_tab_at = None
    ___ShadowErrorData_notification__item__type._const_tab_id = 'id'
    ___ShadowErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ShadowErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ShadowErrorData_notification__item__values__item_._const_tab = ____ShadowErrorData_notification__item__type_tab
    ____ShadowErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ShadowErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___ShadowErrorData_notification__item__values._cont = ____ShadowErrorData_notification__item__values__item_
    ___ShadowErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ShadowErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ShadowErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab = ____ShadowErrorData_notification__item__type_tab
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList._cont = ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ShadowErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ShadowErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ShadowErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ShadowErrorData_notification__item__valuesWithContext__item_._ext = []
    ___ShadowErrorData_notification__item__valuesWithContext._cont = ____ShadowErrorData_notification__item__valuesWithContext__item_
    ___ShadowErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ShadowErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___ShadowErrorData_notification__item__type),
        ('values', ___ShadowErrorData_notification__item__values),
        ('valuesWithContext', ___ShadowErrorData_notification__item__valuesWithContext),
        ])
    __ShadowErrorData_notification__item_._ext = []
    _ShadowErrorData_notification._cont = __ShadowErrorData_notification__item_
    ShadowErrorData._cont = ASN1Dict([
        ('problem', _ShadowErrorData_problem),
        ('lastUpdate', _ShadowErrorData_lastUpdate),
        ('updateWindow', _ShadowErrorData_updateWindow),
        ('securityParameters', _ShadowErrorData_securityParameters),
        ('performer', _ShadowErrorData_performer),
        ('aliasDereferenced', _ShadowErrorData_aliasDereferenced),
        ('notification', _ShadowErrorData_notification),
        ])
    ShadowErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ShadowProblem >-----#
    ShadowProblem = INT(name='ShadowProblem', mode=MODE_TYPE)
    ShadowProblem._cont = ASN1Dict([('invalidAgreementID', 1), ('inactiveAgreement', 2), ('invalidInformationReceived', 3), ('unsupportedStrategy', 4), ('missedPrevious', 5), ('fullUpdateRequired', 6), ('unwillingToPerform', 7), ('unsuitableTiming', 8), ('updateAlreadyReceived', 9), ('invalidSequencing', 10), ('insufficientResources', 11)])
    
    _all_ = [
        dSAShadowBind,
        _dSAShadowBind_val_ArgumentType,
        _dSAShadowBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        shadowOperationalBinding,
        _shadowOperationalBinding_val_Agreement,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0,
        __shadowOperationalBinding_roleA_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_ModifyParam,
        __ModificationParameter_secondaryShadows__item_,
        _ModificationParameter_secondaryShadows,
        ModificationParameter,
        AgreementID,
        _ShadowingAgreementInfo_shadowSubject,
        _ShadowingAgreementInfo_updateMode,
        _ShadowingAgreementInfo_master,
        _ShadowingAgreementInfo_secondaryShadows,
        ShadowingAgreementInfo,
        _UnitOfReplication_area,
        _UnitOfReplication_attributes,
        _UnitOfReplication_knowledge,
        _UnitOfReplication_subordinates,
        _UnitOfReplication_contextSelection,
        __UnitOfReplication_supplyContexts_allContexts,
        ___UnitOfReplication_supplyContexts_selectedContexts__item_,
        __UnitOfReplication_supplyContexts_selectedContexts,
        _UnitOfReplication_supplyContexts,
        UnitOfReplication,
        _AreaSpecification_contextPrefix,
        _AreaSpecification_replicationArea,
        AreaSpecification,
        _Knowledge_knowledgeType,
        _Knowledge_extendedKnowledge,
        Knowledge,
        _AttributeSelection__item_,
        AttributeSelection,
        _ClassAttributeSelection_class_,
        _ClassAttributeSelection_classAttributes,
        ClassAttributeSelection,
        _ClassAttributes_allAttributes,
        _ClassAttributes_include,
        _ClassAttributes_exclude,
        ClassAttributes,
        _AttributeTypes__item_,
        AttributeTypes,
        _UpdateMode_supplierInitiated,
        _UpdateMode_consumerInitiated,
        UpdateMode,
        _SupplierUpdateMode_onChange,
        _SupplierUpdateMode_scheduled,
        SupplierUpdateMode,
        ConsumerUpdateMode,
        _SchedulingParameters_periodic,
        _SchedulingParameters_othertimes,
        SchedulingParameters,
        _PeriodicStrategy_beginTime,
        _PeriodicStrategy_windowSize,
        _PeriodicStrategy_updateInterval,
        PeriodicStrategy,
        Time,
        All_operations_consumer_initiated,
        _All_operations_consumer_initiated_val_ArgumentType_0,
        _All_operations_consumer_initiated_val_ResultType_0,
        _All_operations_consumer_initiated_val_ArgumentType_1,
        _All_operations_consumer_initiated_val_ResultType_1,
        All_operations_supplier_initiated,
        _All_operations_supplier_initiated_val_ArgumentType_0,
        _All_operations_supplier_initiated_val_ResultType_0,
        _All_operations_supplier_initiated_val_ArgumentType_1,
        _All_operations_supplier_initiated_val_ResultType_1,
        coordinateShadowUpdate,
        _coordinateShadowUpdate_val_ArgumentType,
        _coordinateShadowUpdate_val_ResultType,
        _CoordinateShadowUpdateArgument_unsigned,
        __CoordinateShadowUpdateArgument_signed_toBeSigned,
        ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab,
        ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm,
        ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab,
        ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters,
        __CoordinateShadowUpdateArgument_signed_algorithmIdentifier,
        __CoordinateShadowUpdateArgument_signed_signature,
        _CoordinateShadowUpdateArgument_signed,
        CoordinateShadowUpdateArgument,
        _CoordinateShadowUpdateArgumentData_agreementID,
        _CoordinateShadowUpdateArgumentData_lastUpdate,
        __CoordinateShadowUpdateArgumentData_updateStrategy_standard,
        __CoordinateShadowUpdateArgumentData_updateStrategy_other,
        _CoordinateShadowUpdateArgumentData_updateStrategy,
        _CoordinateShadowUpdateArgumentData_securityParameters,
        CoordinateShadowUpdateArgumentData,
        _CoordinateShadowUpdateResult_null,
        __CoordinateShadowUpdateResult_information_unsigned,
        ___CoordinateShadowUpdateResult_information_signed_toBeSigned,
        _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm,
        _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab,
        ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters,
        ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier,
        ___CoordinateShadowUpdateResult_information_signed_signature,
        __CoordinateShadowUpdateResult_information_signed,
        _CoordinateShadowUpdateResult_information,
        CoordinateShadowUpdateResult,
        _CoordinateShadowUpdateResultData_agreementID,
        _CoordinateShadowUpdateResultData_lastUpdate,
        _CoordinateShadowUpdateResultData_securityParameters,
        _CoordinateShadowUpdateResultData_performer,
        _CoordinateShadowUpdateResultData_aliasDereferenced,
        ____CoordinateShadowUpdateResultData_notification__item__type_tab,
        _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___CoordinateShadowUpdateResultData_notification__item__type,
        ____CoordinateShadowUpdateResultData_notification__item__values__item_,
        ___CoordinateShadowUpdateResultData_notification__item__values,
        _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value,
        ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList,
        ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_,
        ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext,
        __CoordinateShadowUpdateResultData_notification__item_,
        _CoordinateShadowUpdateResultData_notification,
        CoordinateShadowUpdateResultData,
        requestShadowUpdate,
        _requestShadowUpdate_val_ArgumentType,
        _requestShadowUpdate_val_ResultType,
        _RequestShadowUpdateArgument_unsigned,
        __RequestShadowUpdateArgument_signed_toBeSigned,
        ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab,
        ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm,
        ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab,
        ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters,
        __RequestShadowUpdateArgument_signed_algorithmIdentifier,
        __RequestShadowUpdateArgument_signed_signature,
        _RequestShadowUpdateArgument_signed,
        RequestShadowUpdateArgument,
        _RequestShadowUpdateArgumentData_agreementID,
        _RequestShadowUpdateArgumentData_lastUpdate,
        __RequestShadowUpdateArgumentData_requestedStrategy_standard,
        __RequestShadowUpdateArgumentData_requestedStrategy_other,
        _RequestShadowUpdateArgumentData_requestedStrategy,
        _RequestShadowUpdateArgumentData_securityParameters,
        RequestShadowUpdateArgumentData,
        _RequestShadowUpdateResult_null,
        __RequestShadowUpdateResult_information_unsigned,
        ___RequestShadowUpdateResult_information_signed_toBeSigned,
        _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm,
        _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab,
        ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters,
        ___RequestShadowUpdateResult_information_signed_algorithmIdentifier,
        ___RequestShadowUpdateResult_information_signed_signature,
        __RequestShadowUpdateResult_information_signed,
        _RequestShadowUpdateResult_information,
        RequestShadowUpdateResult,
        _RequestShadowUpdateResultData_agreementID,
        _RequestShadowUpdateResultData_lastUpdate,
        _RequestShadowUpdateResultData_securityParameters,
        _RequestShadowUpdateResultData_performer,
        _RequestShadowUpdateResultData_aliasDereferenced,
        ____RequestShadowUpdateResultData_notification__item__type_tab,
        _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0,
        _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1,
        ___RequestShadowUpdateResultData_notification__item__type,
        ____RequestShadowUpdateResultData_notification__item__values__item_,
        ___RequestShadowUpdateResultData_notification__item__values,
        _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value,
        ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList,
        ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_,
        ___RequestShadowUpdateResultData_notification__item__valuesWithContext,
        __RequestShadowUpdateResultData_notification__item_,
        _RequestShadowUpdateResultData_notification,
        RequestShadowUpdateResultData,
        updateShadow,
        _updateShadow_val_ArgumentType,
        _updateShadow_val_ResultType,
        _UpdateShadowArgument_unsigned,
        __UpdateShadowArgument_signed_toBeSigned,
        ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab,
        ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm,
        ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab,
        ___UpdateShadowArgument_signed_algorithmIdentifier_parameters,
        __UpdateShadowArgument_signed_algorithmIdentifier,
        __UpdateShadowArgument_signed_signature,
        _UpdateShadowArgument_signed,
        UpdateShadowArgument,
        _UpdateShadowArgumentData_agreementID,
        _UpdateShadowArgumentData_updateTime,
        _UpdateShadowArgumentData_updateWindow,
        _UpdateShadowArgumentData_updatedInfo,
        _UpdateShadowArgumentData_securityParameters,
        UpdateShadowArgumentData,
        _UpdateShadowResult_null,
        __UpdateShadowResult_information_unsigned,
        ___UpdateShadowResult_information_signed_toBeSigned,
        _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm,
        _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab,
        ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters,
        ___UpdateShadowResult_information_signed_algorithmIdentifier,
        ___UpdateShadowResult_information_signed_signature,
        __UpdateShadowResult_information_signed,
        _UpdateShadowResult_information,
        UpdateShadowResult,
        _UpdateShadowResultData_agreementID,
        _UpdateShadowResultData_lastUpdate,
        _UpdateShadowResultData_securityParameters,
        _UpdateShadowResultData_performer,
        _UpdateShadowResultData_aliasDereferenced,
        ____UpdateShadowResultData_notification__item__type_tab,
        _____UpdateShadowResultData_notification__item__type_tab_val_Type_0,
        _____UpdateShadowResultData_notification__item__type_tab_val_Type_1,
        ___UpdateShadowResultData_notification__item__type,
        ____UpdateShadowResultData_notification__item__values__item_,
        ___UpdateShadowResultData_notification__item__values,
        _____UpdateShadowResultData_notification__item__valuesWithContext__item__value,
        ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList,
        ____UpdateShadowResultData_notification__item__valuesWithContext__item_,
        ___UpdateShadowResultData_notification__item__valuesWithContext,
        __UpdateShadowResultData_notification__item_,
        _UpdateShadowResultData_notification,
        UpdateShadowResultData,
        _UpdateWindow_start,
        _UpdateWindow_stop,
        UpdateWindow,
        _RefreshInformation_noRefresh,
        _RefreshInformation_total,
        _RefreshInformation_incremental,
        _RefreshInformation_otherStrategy,
        RefreshInformation,
        _TotalRefresh_sDSE,
        __TotalRefresh_subtree__item_,
        _TotalRefresh_subtree,
        TotalRefresh,
        _SDSEContent_sDSEType,
        _SDSEContent_subComplete,
        _SDSEContent_attComplete,
        ____SDSEContent_attributes__item__type_tab,
        _____SDSEContent_attributes__item__type_tab_val_Type_0,
        _____SDSEContent_attributes__item__type_tab_val_Type_1,
        ___SDSEContent_attributes__item__type,
        ____SDSEContent_attributes__item__values__item_,
        ___SDSEContent_attributes__item__values,
        _____SDSEContent_attributes__item__valuesWithContext__item__value,
        ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_,
        _____SDSEContent_attributes__item__valuesWithContext__item__contextList,
        ____SDSEContent_attributes__item__valuesWithContext__item_,
        ___SDSEContent_attributes__item__valuesWithContext,
        __SDSEContent_attributes__item_,
        _SDSEContent_attributes,
        __SDSEContent_attValIncomplete__item_,
        _SDSEContent_attValIncomplete,
        SDSEContent,
        SDSEType,
        _Subtree_rdn,
        _Subtree_sDSE,
        __Subtree_subtree__item_,
        _Subtree_subtree,
        Subtree,
        _IncrementalRefresh__item_,
        IncrementalRefresh,
        __IncrementalStepRefresh_sDSEChanges_add,
        __IncrementalStepRefresh_sDSEChanges_remove,
        __IncrementalStepRefresh_sDSEChanges_modify,
        _IncrementalStepRefresh_sDSEChanges,
        __IncrementalStepRefresh_subordinateUpdates__item_,
        _IncrementalStepRefresh_subordinateUpdates,
        IncrementalStepRefresh,
        __ContentChange_rename_newRDN,
        __ContentChange_rename_newDN,
        _ContentChange_rename,
        _____ContentChange_attributeChanges_replace__item__type_tab,
        ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0,
        ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1,
        ____ContentChange_attributeChanges_replace__item__type,
        _____ContentChange_attributeChanges_replace__item__values__item_,
        ____ContentChange_attributeChanges_replace__item__values,
        ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value,
        _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_,
        ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList,
        _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_,
        ____ContentChange_attributeChanges_replace__item__valuesWithContext,
        ___ContentChange_attributeChanges_replace__item_,
        __ContentChange_attributeChanges_replace,
        ___ContentChange_attributeChanges_changes__item_,
        __ContentChange_attributeChanges_changes,
        _ContentChange_attributeChanges,
        _ContentChange_sDSEType,
        _ContentChange_subComplete,
        _ContentChange_attComplete,
        __ContentChange_attValIncomplete__item_,
        _ContentChange_attValIncomplete,
        ContentChange,
        _SubordinateChanges_subordinate,
        _SubordinateChanges_changes,
        SubordinateChanges,
        shadowError,
        __shadowError_val_ParameterType_unsigned,
        ___shadowError_val_ParameterType_signed_toBeSigned,
        _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___shadowError_val_ParameterType_signed_algorithmIdentifier,
        ___shadowError_val_ParameterType_signed_signature,
        __shadowError_val_ParameterType_signed,
        _shadowError_val_ParameterType,
        _ShadowErrorData_problem,
        _ShadowErrorData_lastUpdate,
        _ShadowErrorData_updateWindow,
        _ShadowErrorData_securityParameters,
        _ShadowErrorData_performer,
        _ShadowErrorData_aliasDereferenced,
        ____ShadowErrorData_notification__item__type_tab,
        _____ShadowErrorData_notification__item__type_tab_val_Type_0,
        _____ShadowErrorData_notification__item__type_tab_val_Type_1,
        ___ShadowErrorData_notification__item__type,
        ____ShadowErrorData_notification__item__values__item_,
        ___ShadowErrorData_notification__item__values,
        _____ShadowErrorData_notification__item__valuesWithContext__item__value,
        ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____ShadowErrorData_notification__item__valuesWithContext__item__contextList,
        ____ShadowErrorData_notification__item__valuesWithContext__item_,
        ___ShadowErrorData_notification__item__valuesWithContext,
        __ShadowErrorData_notification__item_,
        _ShadowErrorData_notification,
        ShadowErrorData,
        ShadowProblem,
    ]

class DistributedOperations:

    _name_  = 'DistributedOperations'
    _oid_   = [2, 5, 1, 3, 8]
    
    _obj_ = [
        'dsaReferral',
        'DsaReferralData',
        'ChainingArguments',
        'Time',
        'DomainInfo',
        'ChainingResults',
        'CrossReference',
        'OperationProgress',
        'TraceInformation',
        'TraceItem',
        'ReferenceType',
        'AccessPoint',
        'MasterOrShadowAccessPoint',
        'MasterAndShadowAccessPoints',
        'AccessPointInformation',
        'DitBridgeKnowledge',
        'Exclusions',
        'ContinuationReference',
        'dSABind',
        'DSABindArgument',
        'DSACredentials',
        'DSABindResult',
        'chained',
        'chainedRead',
        'chainedCompare',
        'chainedAbandon',
        'chainedList',
        'chainedSearch',
        'chainedAddEntry',
        'chainedRemoveEntry',
        'chainedModifyEntry',
        'chainedModifyDN',
        'chainedChangePassword',
        'chainedAdministerPassword',
        'chainedLdapTransport',
        'chainedLinkedLDAP',
        ]
    _type_ = [
        'DsaReferralData',
        'ChainingArguments',
        'Time',
        'DomainInfo',
        'ChainingResults',
        'CrossReference',
        'OperationProgress',
        'TraceInformation',
        'TraceItem',
        'ReferenceType',
        'AccessPoint',
        'MasterOrShadowAccessPoint',
        'MasterAndShadowAccessPoints',
        'AccessPointInformation',
        'DitBridgeKnowledge',
        'Exclusions',
        'ContinuationReference',
        'DSABindArgument',
        'DSACredentials',
        'DSABindResult',
        ]
    _set_ = [
        ]
    _val_ = [
        'dsaReferral',
        'dSABind',
        'chained',
        'chainedRead',
        'chainedCompare',
        'chainedAbandon',
        'chainedList',
        'chainedSearch',
        'chainedAddEntry',
        'chainedRemoveEntry',
        'chainedModifyEntry',
        'chainedModifyDN',
        'chainedChangePassword',
        'chainedAdministerPassword',
        'chainedLdapTransport',
        'chainedLinkedLDAP',
        ]
    _class_ = [
        'dsaReferral',
        'dSABind',
        'chained',
        'chainedRead',
        'chainedCompare',
        'chainedAbandon',
        'chainedList',
        'chainedSearch',
        'chainedAddEntry',
        'chainedRemoveEntry',
        'chainedModifyEntry',
        'chainedModifyDN',
        'chainedChangePassword',
        'chainedAdministerPassword',
        'chainedLdapTransport',
        'chainedLinkedLDAP',
        ]
    _param_ = [
        'chained',
        ]
    
    #-----< dsaReferral >-----#
    dsaReferral = CLASS(name='dsaReferral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _dsaReferral_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __dsaReferral_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    __dsaReferral_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___dsaReferral_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___dsaReferral_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __dsaReferral_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___dsaReferral_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___dsaReferral_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___dsaReferral_val_ParameterType_signed_signature),
        ])
    __dsaReferral_val_ParameterType_signed._ext = []
    _dsaReferral_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __dsaReferral_val_ParameterType_unsigned),
        ('signed', __dsaReferral_val_ParameterType_signed),
        ])
    _dsaReferral_val_ParameterType._ext = None
    dsaReferral._val = dict([('ParameterType', _dsaReferral_val_ParameterType), ('errorCode', ('local', 9))])
    
    #-----< DsaReferralData >-----#
    DsaReferralData = SET(name='DsaReferralData', mode=MODE_TYPE)
    _DsaReferralData_reference = SET(name='reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _DsaReferralData_contextPrefix = SEQ_OF(name='contextPrefix', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _DsaReferralData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _DsaReferralData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _DsaReferralData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _DsaReferralData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DsaReferralData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___DsaReferralData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____DsaReferralData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____DsaReferralData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____DsaReferralData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____DsaReferralData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____DsaReferralData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____DsaReferralData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___DsaReferralData_notification__item__type._const_tab = ____DsaReferralData_notification__item__type_tab
    ___DsaReferralData_notification__item__type._const_tab_at = None
    ___DsaReferralData_notification__item__type._const_tab_id = 'id'
    ___DsaReferralData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____DsaReferralData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____DsaReferralData_notification__item__values__item_._const_tab = ____DsaReferralData_notification__item__type_tab
    ____DsaReferralData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____DsaReferralData_notification__item__values__item_._const_tab_id = 'Type'
    ___DsaReferralData_notification__item__values._cont = ____DsaReferralData_notification__item__values__item_
    ___DsaReferralData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___DsaReferralData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____DsaReferralData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DsaReferralData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab = ____DsaReferralData_notification__item__type_tab
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList._cont = ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____DsaReferralData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____DsaReferralData_notification__item__valuesWithContext__item__value),
        ('contextList', _____DsaReferralData_notification__item__valuesWithContext__item__contextList),
        ])
    ____DsaReferralData_notification__item__valuesWithContext__item_._ext = []
    ___DsaReferralData_notification__item__valuesWithContext._cont = ____DsaReferralData_notification__item__valuesWithContext__item_
    ___DsaReferralData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __DsaReferralData_notification__item_._cont = ASN1Dict([
        ('type', ___DsaReferralData_notification__item__type),
        ('values', ___DsaReferralData_notification__item__values),
        ('valuesWithContext', ___DsaReferralData_notification__item__valuesWithContext),
        ])
    __DsaReferralData_notification__item_._ext = []
    _DsaReferralData_notification._cont = __DsaReferralData_notification__item_
    DsaReferralData._cont = ASN1Dict([
        ('reference', _DsaReferralData_reference),
        ('contextPrefix', _DsaReferralData_contextPrefix),
        ('securityParameters', _DsaReferralData_securityParameters),
        ('performer', _DsaReferralData_performer),
        ('aliasDereferenced', _DsaReferralData_aliasDereferenced),
        ('notification', _DsaReferralData_notification),
        ])
    DsaReferralData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ChainingArguments >-----#
    ChainingArguments = SET(name='ChainingArguments', mode=MODE_TYPE)
    _ChainingArguments_originator = SEQ_OF(name='originator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChainingArguments_targetObject = SEQ_OF(name='targetObject', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChainingArguments_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ChainingArguments_traceInformation = SEQ_OF(name='traceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'TraceInformation')))
    _ChainingArguments_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_returnCrossRefs = BOOL(name='returnCrossRefs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), default='superior')
    _ChainingArguments_info = OPEN(name='info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DomainInfo')), opt=True)
    _ChainingArguments_timeLimit = CHOICE(name='timeLimit', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Time')), opt=True)
    _ChainingArguments_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), default=dict([]))
    _ChainingArguments_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_uniqueIdentifier = BIT_STR(name='uniqueIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _ChainingArguments_authenticationLevel = CHOICE(name='authenticationLevel', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('BasicAccessControl', 'AuthenticationLevel')), opt=True)
    _ChainingArguments_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ChainingArguments_excludeShadows = BOOL(name='excludeShadows', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_operationIdentifier = INT(name='operationIdentifier', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_searchRuleId = SEQ(name='searchRuleId', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'SearchRuleId')), opt=True)
    _ChainingArguments_chainedRelaxation = SEQ(name='chainedRelaxation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')), opt=True)
    _ChainingArguments_relatedEntry = INT(name='relatedEntry', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_dspPaging = BOOL(name='dspPaging', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_excludeWriteableCopies = BOOL(name='excludeWriteableCopies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ChainingArguments._cont = ASN1Dict([
        ('originator', _ChainingArguments_originator),
        ('targetObject', _ChainingArguments_targetObject),
        ('operationProgress', _ChainingArguments_operationProgress),
        ('traceInformation', _ChainingArguments_traceInformation),
        ('aliasDereferenced', _ChainingArguments_aliasDereferenced),
        ('aliasedRDNs', _ChainingArguments_aliasedRDNs),
        ('returnCrossRefs', _ChainingArguments_returnCrossRefs),
        ('referenceType', _ChainingArguments_referenceType),
        ('info', _ChainingArguments_info),
        ('timeLimit', _ChainingArguments_timeLimit),
        ('securityParameters', _ChainingArguments_securityParameters),
        ('entryOnly', _ChainingArguments_entryOnly),
        ('uniqueIdentifier', _ChainingArguments_uniqueIdentifier),
        ('authenticationLevel', _ChainingArguments_authenticationLevel),
        ('exclusions', _ChainingArguments_exclusions),
        ('excludeShadows', _ChainingArguments_excludeShadows),
        ('nameResolveOnMaster', _ChainingArguments_nameResolveOnMaster),
        ('operationIdentifier', _ChainingArguments_operationIdentifier),
        ('searchRuleId', _ChainingArguments_searchRuleId),
        ('chainedRelaxation', _ChainingArguments_chainedRelaxation),
        ('relatedEntry', _ChainingArguments_relatedEntry),
        ('dspPaging', _ChainingArguments_dspPaging),
        ('excludeWriteableCopies', _ChainingArguments_excludeWriteableCopies),
        ])
    ChainingArguments._ext = []
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< DomainInfo >-----#
    DomainInfo = OPEN(name='DomainInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    
    #-----< ChainingResults >-----#
    ChainingResults = SET(name='ChainingResults', mode=MODE_TYPE)
    _ChainingResults_info = OPEN(name='info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DomainInfo')), opt=True)
    _ChainingResults_crossReferences = SEQ_OF(name='crossReferences', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChainingResults_crossReferences__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'CrossReference')))
    _ChainingResults_crossReferences._cont = __ChainingResults_crossReferences__item_
    _ChainingResults_crossReferences._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ChainingResults_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), default=dict([]))
    _ChainingResults_alreadySearched = SET_OF(name='alreadySearched', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    ChainingResults._cont = ASN1Dict([
        ('info', _ChainingResults_info),
        ('crossReferences', _ChainingResults_crossReferences),
        ('securityParameters', _ChainingResults_securityParameters),
        ('alreadySearched', _ChainingResults_alreadySearched),
        ])
    ChainingResults._ext = []
    
    #-----< CrossReference >-----#
    CrossReference = SET(name='CrossReference', mode=MODE_TYPE)
    _CrossReference_contextPrefix = SEQ_OF(name='contextPrefix', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _CrossReference_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPointInformation')))
    CrossReference._cont = ASN1Dict([
        ('contextPrefix', _CrossReference_contextPrefix),
        ('accessPoint', _CrossReference_accessPoint),
        ])
    CrossReference._ext = []
    
    #-----< OperationProgress >-----#
    OperationProgress = SET(name='OperationProgress', mode=MODE_TYPE)
    _OperationProgress_nameResolutionPhase = ENUM(name='nameResolutionPhase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OperationProgress_nameResolutionPhase._cont = ASN1Dict([('notStarted', 1), ('proceeding', 2), ('completed', 3)])
    _OperationProgress_nameResolutionPhase._ext = []
    _OperationProgress_nextRDNToBeResolved = INT(name='nextRDNToBeResolved', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    OperationProgress._cont = ASN1Dict([
        ('nameResolutionPhase', _OperationProgress_nameResolutionPhase),
        ('nextRDNToBeResolved', _OperationProgress_nextRDNToBeResolved),
        ])
    OperationProgress._ext = []
    
    #-----< TraceInformation >-----#
    TraceInformation = SEQ_OF(name='TraceInformation', mode=MODE_TYPE)
    _TraceInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'TraceItem')))
    TraceInformation._cont = _TraceInformation__item_
    
    #-----< TraceItem >-----#
    TraceItem = SET(name='TraceItem', mode=MODE_TYPE)
    _TraceItem_dsa = CHOICE(name='dsa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TraceItem_targetObject = CHOICE(name='targetObject', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _TraceItem_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')))
    TraceItem._cont = ASN1Dict([
        ('dsa', _TraceItem_dsa),
        ('targetObject', _TraceItem_targetObject),
        ('operationProgress', _TraceItem_operationProgress),
        ])
    TraceItem._ext = []
    
    #-----< ReferenceType >-----#
    ReferenceType = ENUM(name='ReferenceType', mode=MODE_TYPE)
    ReferenceType._cont = ASN1Dict([('superior', 1), ('subordinate', 2), ('cross', 3), ('nonSpecificSubordinate', 4), ('supplier', 5), ('master', 6), ('immediateSuperior', 7), ('self', 8), ('ditBridge', 9)])
    ReferenceType._ext = []
    
    #-----< AccessPoint >-----#
    AccessPoint = SET(name='AccessPoint', mode=MODE_TYPE)
    _AccessPoint_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AccessPoint_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _AccessPoint_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AccessPoint_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _AccessPoint_protocolInformation._cont = __AccessPoint_protocolInformation__item_
    _AccessPoint_protocolInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AccessPoint._cont = ASN1Dict([
        ('ae-title', _AccessPoint_ae_title),
        ('address', _AccessPoint_address),
        ('protocolInformation', _AccessPoint_protocolInformation),
        ])
    AccessPoint._ext = []
    
    #-----< MasterOrShadowAccessPoint >-----#
    MasterOrShadowAccessPoint = SET(name='MasterOrShadowAccessPoint', mode=MODE_TYPE)
    _MasterOrShadowAccessPoint_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _MasterOrShadowAccessPoint_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _MasterOrShadowAccessPoint_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MasterOrShadowAccessPoint_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _MasterOrShadowAccessPoint_protocolInformation._cont = __MasterOrShadowAccessPoint_protocolInformation__item_
    _MasterOrShadowAccessPoint_category = ENUM(name='category', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='master')
    _MasterOrShadowAccessPoint_category._cont = ASN1Dict([('master', 0), ('shadow', 1), ('writeableCopy', 2)])
    _MasterOrShadowAccessPoint_category._ext = []
    _MasterOrShadowAccessPoint_chainingRequired = BOOL(name='chainingRequired', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    MasterOrShadowAccessPoint._cont = ASN1Dict([
        ('ae-title', _MasterOrShadowAccessPoint_ae_title),
        ('address', _MasterOrShadowAccessPoint_address),
        ('protocolInformation', _MasterOrShadowAccessPoint_protocolInformation),
        ('category', _MasterOrShadowAccessPoint_category),
        ('chainingRequired', _MasterOrShadowAccessPoint_chainingRequired),
        ])
    MasterOrShadowAccessPoint._ext = []
    
    #-----< MasterAndShadowAccessPoints >-----#
    MasterAndShadowAccessPoints = SET_OF(name='MasterAndShadowAccessPoints', mode=MODE_TYPE)
    _MasterAndShadowAccessPoints__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterOrShadowAccessPoint')))
    MasterAndShadowAccessPoints._cont = _MasterAndShadowAccessPoints__item_
    MasterAndShadowAccessPoints._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AccessPointInformation >-----#
    AccessPointInformation = SET(name='AccessPointInformation', mode=MODE_TYPE)
    _AccessPointInformation_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AccessPointInformation_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _AccessPointInformation_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AccessPointInformation_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _AccessPointInformation_protocolInformation._cont = __AccessPointInformation_protocolInformation__item_
    _AccessPointInformation_category = ENUM(name='category', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='master')
    _AccessPointInformation_category._cont = ASN1Dict([('master', 0), ('shadow', 1), ('writeableCopy', 2)])
    _AccessPointInformation_category._ext = []
    _AccessPointInformation_chainingRequired = BOOL(name='chainingRequired', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AccessPointInformation_additionalPoints = SET_OF(name='additionalPoints', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    AccessPointInformation._cont = ASN1Dict([
        ('ae-title', _AccessPointInformation_ae_title),
        ('address', _AccessPointInformation_address),
        ('protocolInformation', _AccessPointInformation_protocolInformation),
        ('category', _AccessPointInformation_category),
        ('chainingRequired', _AccessPointInformation_chainingRequired),
        ('additionalPoints', _AccessPointInformation_additionalPoints),
        ])
    AccessPointInformation._ext = []
    
    #-----< DitBridgeKnowledge >-----#
    DitBridgeKnowledge = SEQ(name='DitBridgeKnowledge', mode=MODE_TYPE)
    _DitBridgeKnowledge_domainLocalID = CHOICE(name='domainLocalID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DitBridgeKnowledge_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    DitBridgeKnowledge._cont = ASN1Dict([
        ('domainLocalID', _DitBridgeKnowledge_domainLocalID),
        ('accessPoints', _DitBridgeKnowledge_accessPoints),
        ])
    DitBridgeKnowledge._ext = []
    
    #-----< Exclusions >-----#
    Exclusions = SET_OF(name='Exclusions', mode=MODE_TYPE)
    _Exclusions__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    Exclusions._cont = _Exclusions__item_
    Exclusions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ContinuationReference >-----#
    ContinuationReference = SET(name='ContinuationReference', mode=MODE_TYPE)
    _ContinuationReference_targetObject = CHOICE(name='targetObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ContinuationReference_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ContinuationReference_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')))
    _ContinuationReference_rdnsResolved = INT(name='rdnsResolved', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ContinuationReference_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')))
    _ContinuationReference_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContinuationReference_accessPoints__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPointInformation')))
    _ContinuationReference_accessPoints._cont = __ContinuationReference_accessPoints__item_
    _ContinuationReference_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ContinuationReference_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ContinuationReference_returnToDUA = BOOL(name='returnToDUA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ContinuationReference_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ContinuationReference._cont = ASN1Dict([
        ('targetObject', _ContinuationReference_targetObject),
        ('aliasedRDNs', _ContinuationReference_aliasedRDNs),
        ('operationProgress', _ContinuationReference_operationProgress),
        ('rdnsResolved', _ContinuationReference_rdnsResolved),
        ('referenceType', _ContinuationReference_referenceType),
        ('accessPoints', _ContinuationReference_accessPoints),
        ('entryOnly', _ContinuationReference_entryOnly),
        ('exclusions', _ContinuationReference_exclusions),
        ('returnToDUA', _ContinuationReference_returnToDUA),
        ('nameResolveOnMaster', _ContinuationReference_nameResolveOnMaster),
        ])
    ContinuationReference._ext = []
    
    #-----< dSABind >-----#
    dSABind = CLASS(name='dSABind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSABind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSABind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSABind._val = dict([('ArgumentType', _dSABind_val_ArgumentType), ('ResultType', _dSABind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< DSABindArgument >-----#
    DSABindArgument = SET(name='DSABindArgument', mode=MODE_TYPE)
    _DSABindArgument_credentials = CHOICE(name='credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DSACredentials')), opt=True)
    _DSABindArgument_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    DSABindArgument._cont = ASN1Dict([
        ('credentials', _DSABindArgument_credentials),
        ('versions', _DSABindArgument_versions),
        ])
    DSABindArgument._ext = []
    
    #-----< DSACredentials >-----#
    DSACredentials = CHOICE(name='DSACredentials', mode=MODE_TYPE)
    _DSACredentials_simple = SEQ(name='simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SimpleCredentials')))
    _DSACredentials_strong = SET(name='strong', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'StrongCredentials')))
    _DSACredentials_externalProcedure = EXT(name='externalProcedure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _DSACredentials_spkm = CHOICE(name='spkm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SpkmCredentials')))
    DSACredentials._cont = ASN1Dict([
        ('simple', _DSACredentials_simple),
        ('strong', _DSACredentials_strong),
        ('externalProcedure', _DSACredentials_externalProcedure),
        ('spkm', _DSACredentials_spkm),
        ])
    DSACredentials._ext = []
    
    #-----< DSABindResult >-----#
    DSABindResult = SET(name='DSABindResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    
    #-----< chained >-----#
    chained = CLASS(name='chained', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')), param=True)
    
    #-----< chainedRead >-----#
    chainedRead = CLASS(name='chainedRead', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedRead_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRead_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRead_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedRead_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __chainedRead_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedRead_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedRead_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedRead_val_ArgumentType_unsigned._ext = None
    __chainedRead_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRead_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___chainedRead_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedRead_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedRead_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedRead_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRead_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRead_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedRead_val_ArgumentType_signed_signature),
        ])
    __chainedRead_val_ArgumentType_signed._ext = []
    _chainedRead_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedRead_val_ArgumentType_unsigned),
        ('signed', __chainedRead_val_ArgumentType_signed),
        ])
    _chainedRead_val_ArgumentType._ext = None
    _chainedRead_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRead_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRead_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedRead_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __chainedRead_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedRead_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedRead_val_ResultType_unsigned_ResultType),
        ])
    __chainedRead_val_ResultType_unsigned._ext = None
    __chainedRead_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRead_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedRead_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___chainedRead_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedRead_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedRead_val_ResultType_signed_toBeSigned._ext = None
    ___chainedRead_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRead_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRead_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedRead_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedRead_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRead_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRead_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedRead_val_ResultType_signed_signature),
        ])
    __chainedRead_val_ResultType_signed._ext = []
    _chainedRead_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedRead_val_ResultType_unsigned),
        ('signed', __chainedRead_val_ResultType_signed),
        ])
    _chainedRead_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    chainedRead._val = dict([('ArgumentType', _chainedRead_val_ArgumentType), ('ResultType', _chainedRead_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))])
    
    #-----< chainedCompare >-----#
    chainedCompare = CLASS(name='chainedCompare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedCompare_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedCompare_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedCompare_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedCompare_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __chainedCompare_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedCompare_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedCompare_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedCompare_val_ArgumentType_unsigned._ext = None
    __chainedCompare_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedCompare_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___chainedCompare_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedCompare_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedCompare_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedCompare_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedCompare_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedCompare_val_ArgumentType_signed_signature),
        ])
    __chainedCompare_val_ArgumentType_signed._ext = []
    _chainedCompare_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedCompare_val_ArgumentType_unsigned),
        ('signed', __chainedCompare_val_ArgumentType_signed),
        ])
    _chainedCompare_val_ArgumentType._ext = None
    _chainedCompare_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedCompare_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedCompare_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedCompare_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __chainedCompare_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedCompare_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedCompare_val_ResultType_unsigned_ResultType),
        ])
    __chainedCompare_val_ResultType_unsigned._ext = None
    __chainedCompare_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedCompare_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___chainedCompare_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedCompare_val_ResultType_signed_toBeSigned._ext = None
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedCompare_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedCompare_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedCompare_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedCompare_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedCompare_val_ResultType_signed_signature),
        ])
    __chainedCompare_val_ResultType_signed._ext = []
    _chainedCompare_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedCompare_val_ResultType_unsigned),
        ('signed', __chainedCompare_val_ResultType_signed),
        ])
    _chainedCompare_val_ResultType._ext = None
    chainedCompare._val = dict([('ArgumentType', _chainedCompare_val_ArgumentType), ('ResultType', _chainedCompare_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])
    
    #-----< chainedAbandon >-----#
    chainedAbandon = CLASS(name='chainedAbandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAbandon_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    _chainedAbandon_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    chainedAbandon._val = dict([('ArgumentType', _chainedAbandon_val_ArgumentType), ('ResultType', _chainedAbandon_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])
    
    #-----< chainedList >-----#
    chainedList = CLASS(name='chainedList', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedList_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedList_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedList_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedList_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __chainedList_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedList_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedList_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedList_val_ArgumentType_unsigned._ext = None
    __chainedList_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedList_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___chainedList_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedList_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedList_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedList_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedList_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedList_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedList_val_ArgumentType_signed_signature),
        ])
    __chainedList_val_ArgumentType_signed._ext = []
    _chainedList_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedList_val_ArgumentType_unsigned),
        ('signed', __chainedList_val_ArgumentType_signed),
        ])
    _chainedList_val_ArgumentType._ext = None
    _chainedList_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedList_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedList_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedList_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __chainedList_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedList_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedList_val_ResultType_unsigned_ResultType),
        ])
    __chainedList_val_ResultType_unsigned._ext = None
    __chainedList_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedList_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedList_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedList_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___chainedList_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedList_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedList_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedList_val_ResultType_signed_toBeSigned._ext = None
    ___chainedList_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedList_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedList_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedList_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedList_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedList_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedList_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedList_val_ResultType_signed_signature),
        ])
    __chainedList_val_ResultType_signed._ext = []
    _chainedList_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedList_val_ResultType_unsigned),
        ('signed', __chainedList_val_ResultType_signed),
        ])
    _chainedList_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    chainedList._val = dict([('ArgumentType', _chainedList_val_ArgumentType), ('ResultType', _chainedList_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))])
    
    #-----< chainedSearch >-----#
    chainedSearch = CLASS(name='chainedSearch', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedSearch_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedSearch_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedSearch_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedSearch_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __chainedSearch_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedSearch_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedSearch_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedSearch_val_ArgumentType_unsigned._ext = None
    __chainedSearch_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedSearch_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___chainedSearch_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedSearch_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedSearch_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedSearch_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedSearch_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedSearch_val_ArgumentType_signed_signature),
        ])
    __chainedSearch_val_ArgumentType_signed._ext = []
    _chainedSearch_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedSearch_val_ArgumentType_unsigned),
        ('signed', __chainedSearch_val_ArgumentType_signed),
        ])
    _chainedSearch_val_ArgumentType._ext = None
    _chainedSearch_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedSearch_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedSearch_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedSearch_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __chainedSearch_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedSearch_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedSearch_val_ResultType_unsigned_ResultType),
        ])
    __chainedSearch_val_ResultType_unsigned._ext = None
    __chainedSearch_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedSearch_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___chainedSearch_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedSearch_val_ResultType_signed_toBeSigned._ext = None
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedSearch_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedSearch_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedSearch_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedSearch_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedSearch_val_ResultType_signed_signature),
        ])
    __chainedSearch_val_ResultType_signed._ext = []
    _chainedSearch_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedSearch_val_ResultType_unsigned),
        ('signed', __chainedSearch_val_ResultType_signed),
        ])
    _chainedSearch_val_ResultType._ext = None
    chainedSearch._val = dict([('ArgumentType', _chainedSearch_val_ArgumentType), ('ResultType', _chainedSearch_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])
    
    #-----< chainedAddEntry >-----#
    chainedAddEntry = CLASS(name='chainedAddEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAddEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAddEntry_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __chainedAddEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedAddEntry_val_ArgumentType_unsigned._ext = None
    __chainedAddEntry_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedAddEntry_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedAddEntry_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAddEntry_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedAddEntry_val_ArgumentType_signed_signature),
        ])
    __chainedAddEntry_val_ArgumentType_signed._ext = []
    _chainedAddEntry_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedAddEntry_val_ArgumentType_unsigned),
        ('signed', __chainedAddEntry_val_ArgumentType_signed),
        ])
    _chainedAddEntry_val_ArgumentType._ext = None
    _chainedAddEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAddEntry_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAddEntry_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedAddEntry_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __chainedAddEntry_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedAddEntry_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedAddEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedAddEntry_val_ResultType_unsigned._ext = None
    __chainedAddEntry_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAddEntry_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___chainedAddEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedAddEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedAddEntry_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedAddEntry_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAddEntry_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedAddEntry_val_ResultType_signed_signature),
        ])
    __chainedAddEntry_val_ResultType_signed._ext = []
    _chainedAddEntry_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedAddEntry_val_ResultType_unsigned),
        ('signed', __chainedAddEntry_val_ResultType_signed),
        ])
    _chainedAddEntry_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    chainedAddEntry._val = dict([('ArgumentType', _chainedAddEntry_val_ArgumentType), ('ResultType', _chainedAddEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))])
    
    #-----< chainedRemoveEntry >-----#
    chainedRemoveEntry = CLASS(name='chainedRemoveEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedRemoveEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRemoveEntry_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __chainedRemoveEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedRemoveEntry_val_ArgumentType_unsigned._ext = None
    __chainedRemoveEntry_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedRemoveEntry_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedRemoveEntry_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedRemoveEntry_val_ArgumentType_signed_signature),
        ])
    __chainedRemoveEntry_val_ArgumentType_signed._ext = []
    _chainedRemoveEntry_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedRemoveEntry_val_ArgumentType_unsigned),
        ('signed', __chainedRemoveEntry_val_ArgumentType_signed),
        ])
    _chainedRemoveEntry_val_ArgumentType._ext = None
    _chainedRemoveEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRemoveEntry_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedRemoveEntry_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __chainedRemoveEntry_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedRemoveEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedRemoveEntry_val_ResultType_unsigned._ext = None
    __chainedRemoveEntry_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedRemoveEntry_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedRemoveEntry_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRemoveEntry_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedRemoveEntry_val_ResultType_signed_signature),
        ])
    __chainedRemoveEntry_val_ResultType_signed._ext = []
    _chainedRemoveEntry_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedRemoveEntry_val_ResultType_unsigned),
        ('signed', __chainedRemoveEntry_val_ResultType_signed),
        ])
    _chainedRemoveEntry_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    chainedRemoveEntry._val = dict([('ArgumentType', _chainedRemoveEntry_val_ArgumentType), ('ResultType', _chainedRemoveEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))])
    
    #-----< chainedModifyEntry >-----#
    chainedModifyEntry = CLASS(name='chainedModifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedModifyEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyEntry_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __chainedModifyEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedModifyEntry_val_ArgumentType_unsigned._ext = None
    __chainedModifyEntry_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedModifyEntry_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedModifyEntry_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedModifyEntry_val_ArgumentType_signed_signature),
        ])
    __chainedModifyEntry_val_ArgumentType_signed._ext = []
    _chainedModifyEntry_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedModifyEntry_val_ArgumentType_unsigned),
        ('signed', __chainedModifyEntry_val_ArgumentType_signed),
        ])
    _chainedModifyEntry_val_ArgumentType._ext = None
    _chainedModifyEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyEntry_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyEntry_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedModifyEntry_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __chainedModifyEntry_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedModifyEntry_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedModifyEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedModifyEntry_val_ResultType_unsigned._ext = None
    __chainedModifyEntry_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedModifyEntry_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedModifyEntry_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyEntry_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedModifyEntry_val_ResultType_signed_signature),
        ])
    __chainedModifyEntry_val_ResultType_signed._ext = []
    _chainedModifyEntry_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedModifyEntry_val_ResultType_unsigned),
        ('signed', __chainedModifyEntry_val_ResultType_signed),
        ])
    _chainedModifyEntry_val_ResultType._ext = None
    chainedModifyEntry._val = dict([('ArgumentType', _chainedModifyEntry_val_ArgumentType), ('ResultType', _chainedModifyEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))])
    
    #-----< chainedModifyDN >-----#
    chainedModifyDN = CLASS(name='chainedModifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedModifyDN_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyDN_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __chainedModifyDN_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedModifyDN_val_ArgumentType_unsigned._ext = None
    __chainedModifyDN_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedModifyDN_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedModifyDN_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyDN_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedModifyDN_val_ArgumentType_signed_signature),
        ])
    __chainedModifyDN_val_ArgumentType_signed._ext = []
    _chainedModifyDN_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedModifyDN_val_ArgumentType_unsigned),
        ('signed', __chainedModifyDN_val_ArgumentType_signed),
        ])
    _chainedModifyDN_val_ArgumentType._ext = None
    _chainedModifyDN_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyDN_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyDN_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedModifyDN_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __chainedModifyDN_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedModifyDN_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedModifyDN_val_ResultType_unsigned_ResultType),
        ])
    __chainedModifyDN_val_ResultType_unsigned._ext = None
    __chainedModifyDN_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyDN_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___chainedModifyDN_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedModifyDN_val_ResultType_signed_toBeSigned._ext = None
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedModifyDN_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedModifyDN_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyDN_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedModifyDN_val_ResultType_signed_signature),
        ])
    __chainedModifyDN_val_ResultType_signed._ext = []
    _chainedModifyDN_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedModifyDN_val_ResultType_unsigned),
        ('signed', __chainedModifyDN_val_ResultType_signed),
        ])
    _chainedModifyDN_val_ResultType._ext = None
    chainedModifyDN._val = dict([('ArgumentType', _chainedModifyDN_val_ArgumentType), ('ResultType', _chainedModifyDN_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))])
    
    #-----< chainedChangePassword >-----#
    chainedChangePassword = CLASS(name='chainedChangePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedChangePassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedChangePassword_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __chainedChangePassword_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedChangePassword_val_ArgumentType_unsigned._ext = None
    __chainedChangePassword_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedChangePassword_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedChangePassword_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedChangePassword_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedChangePassword_val_ArgumentType_signed_signature),
        ])
    __chainedChangePassword_val_ArgumentType_signed._ext = []
    _chainedChangePassword_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedChangePassword_val_ArgumentType_unsigned),
        ('signed', __chainedChangePassword_val_ArgumentType_signed),
        ])
    _chainedChangePassword_val_ArgumentType._ext = None
    _chainedChangePassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedChangePassword_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedChangePassword_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedChangePassword_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    __chainedChangePassword_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedChangePassword_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedChangePassword_val_ResultType_unsigned_ResultType),
        ])
    __chainedChangePassword_val_ResultType_unsigned._ext = None
    __chainedChangePassword_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedChangePassword_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___chainedChangePassword_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedChangePassword_val_ResultType_signed_toBeSigned._ext = None
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedChangePassword_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedChangePassword_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedChangePassword_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedChangePassword_val_ResultType_signed_signature),
        ])
    __chainedChangePassword_val_ResultType_signed._ext = []
    _chainedChangePassword_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedChangePassword_val_ResultType_unsigned),
        ('signed', __chainedChangePassword_val_ResultType_signed),
        ])
    _chainedChangePassword_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    chainedChangePassword._val = dict([('ArgumentType', _chainedChangePassword_val_ArgumentType), ('ResultType', _chainedChangePassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])
    
    #-----< chainedAdministerPassword >-----#
    chainedAdministerPassword = CLASS(name='chainedAdministerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAdministerPassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAdministerPassword_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __chainedAdministerPassword_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedAdministerPassword_val_ArgumentType_unsigned._ext = None
    __chainedAdministerPassword_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedAdministerPassword_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedAdministerPassword_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedAdministerPassword_val_ArgumentType_signed_signature),
        ])
    __chainedAdministerPassword_val_ArgumentType_signed._ext = []
    _chainedAdministerPassword_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedAdministerPassword_val_ArgumentType_unsigned),
        ('signed', __chainedAdministerPassword_val_ArgumentType_signed),
        ])
    _chainedAdministerPassword_val_ArgumentType._ext = None
    _chainedAdministerPassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAdministerPassword_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedAdministerPassword_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __chainedAdministerPassword_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedAdministerPassword_val_ResultType_unsigned_ResultType),
        ])
    __chainedAdministerPassword_val_ResultType_unsigned._ext = None
    __chainedAdministerPassword_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned._ext = None
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedAdministerPassword_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedAdministerPassword_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAdministerPassword_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedAdministerPassword_val_ResultType_signed_signature),
        ])
    __chainedAdministerPassword_val_ResultType_signed._ext = []
    _chainedAdministerPassword_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedAdministerPassword_val_ResultType_unsigned),
        ('signed', __chainedAdministerPassword_val_ResultType_signed),
        ])
    _chainedAdministerPassword_val_ResultType._ext = None
    chainedAdministerPassword._val = dict([('ArgumentType', _chainedAdministerPassword_val_ArgumentType), ('ResultType', _chainedAdministerPassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))])
    
    #-----< chainedLdapTransport >-----#
    chainedLdapTransport = CLASS(name='chainedLdapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedLdapTransport_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLdapTransport_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    __chainedLdapTransport_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedLdapTransport_val_ArgumentType_unsigned._ext = None
    __chainedLdapTransport_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedLdapTransport_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedLdapTransport_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedLdapTransport_val_ArgumentType_signed_signature),
        ])
    __chainedLdapTransport_val_ArgumentType_signed._ext = []
    _chainedLdapTransport_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedLdapTransport_val_ArgumentType_unsigned),
        ('signed', __chainedLdapTransport_val_ArgumentType_signed),
        ])
    _chainedLdapTransport_val_ArgumentType._ext = None
    _chainedLdapTransport_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLdapTransport_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLdapTransport_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedLdapTransport_val_ResultType_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ___chainedLdapTransport_val_ResultType_unsigned_ResultType._cont = ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_
    __chainedLdapTransport_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedLdapTransport_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedLdapTransport_val_ResultType_unsigned_ResultType),
        ])
    __chainedLdapTransport_val_ResultType_unsigned._ext = None
    __chainedLdapTransport_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType._cont = _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned._ext = None
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedLdapTransport_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedLdapTransport_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLdapTransport_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedLdapTransport_val_ResultType_signed_signature),
        ])
    __chainedLdapTransport_val_ResultType_signed._ext = []
    _chainedLdapTransport_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedLdapTransport_val_ResultType_unsigned),
        ('signed', __chainedLdapTransport_val_ResultType_signed),
        ])
    _chainedLdapTransport_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    chainedLdapTransport._val = dict([('ArgumentType', _chainedLdapTransport_val_ArgumentType), ('ResultType', _chainedLdapTransport_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))])
    
    #-----< chainedLinkedLDAP >-----#
    chainedLinkedLDAP = CLASS(name='chainedLinkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedLinkedLDAP_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLinkedLDAP_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    __chainedLinkedLDAP_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedLinkedLDAP_val_ArgumentType_unsigned._ext = None
    __chainedLinkedLDAP_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedLinkedLDAP_val_ArgumentType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedLinkedLDAP_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier),
        ('signature', ___chainedLinkedLDAP_val_ArgumentType_signed_signature),
        ])
    __chainedLinkedLDAP_val_ArgumentType_signed._ext = []
    _chainedLinkedLDAP_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedLinkedLDAP_val_ArgumentType_unsigned),
        ('signed', __chainedLinkedLDAP_val_ArgumentType_signed),
        ])
    _chainedLinkedLDAP_val_ArgumentType._ext = None
    _chainedLinkedLDAP_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLinkedLDAP_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    __chainedLinkedLDAP_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType),
        ])
    __chainedLinkedLDAP_val_ResultType_unsigned._ext = None
    __chainedLinkedLDAP_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned._ext = None
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedLinkedLDAP_val_ResultType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __chainedLinkedLDAP_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier),
        ('signature', ___chainedLinkedLDAP_val_ResultType_signed_signature),
        ])
    __chainedLinkedLDAP_val_ResultType_signed._ext = []
    _chainedLinkedLDAP_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedLinkedLDAP_val_ResultType_unsigned),
        ('signed', __chainedLinkedLDAP_val_ResultType_signed),
        ])
    _chainedLinkedLDAP_val_ResultType._ext = None
    chainedLinkedLDAP._val = dict([('ArgumentType', _chainedLinkedLDAP_val_ArgumentType), ('ResultType', _chainedLinkedLDAP_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])
    
    _all_ = [
        dsaReferral,
        __dsaReferral_val_ParameterType_unsigned,
        ___dsaReferral_val_ParameterType_signed_toBeSigned,
        _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___dsaReferral_val_ParameterType_signed_algorithmIdentifier,
        ___dsaReferral_val_ParameterType_signed_signature,
        __dsaReferral_val_ParameterType_signed,
        _dsaReferral_val_ParameterType,
        _DsaReferralData_reference,
        _DsaReferralData_contextPrefix,
        _DsaReferralData_securityParameters,
        _DsaReferralData_performer,
        _DsaReferralData_aliasDereferenced,
        ____DsaReferralData_notification__item__type_tab,
        _____DsaReferralData_notification__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____DsaReferralData_notification__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___DsaReferralData_notification__item__type,
        ____DsaReferralData_notification__item__values__item_,
        ___DsaReferralData_notification__item__values,
        _____DsaReferralData_notification__item__valuesWithContext__item__value,
        ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_,
        _____DsaReferralData_notification__item__valuesWithContext__item__contextList,
        ____DsaReferralData_notification__item__valuesWithContext__item_,
        ___DsaReferralData_notification__item__valuesWithContext,
        __DsaReferralData_notification__item_,
        _DsaReferralData_notification,
        DsaReferralData,
        _ChainingArguments_originator,
        _ChainingArguments_targetObject,
        _ChainingArguments_operationProgress,
        _ChainingArguments_traceInformation,
        _ChainingArguments_aliasDereferenced,
        _ChainingArguments_aliasedRDNs,
        _ChainingArguments_returnCrossRefs,
        _ChainingArguments_referenceType,
        _ChainingArguments_info,
        _ChainingArguments_timeLimit,
        _ChainingArguments_securityParameters,
        _ChainingArguments_entryOnly,
        _ChainingArguments_uniqueIdentifier,
        _ChainingArguments_authenticationLevel,
        _ChainingArguments_exclusions,
        _ChainingArguments_excludeShadows,
        _ChainingArguments_nameResolveOnMaster,
        _ChainingArguments_operationIdentifier,
        _ChainingArguments_searchRuleId,
        _ChainingArguments_chainedRelaxation,
        _ChainingArguments_relatedEntry,
        _ChainingArguments_dspPaging,
        _ChainingArguments_excludeWriteableCopies,
        ChainingArguments,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        DomainInfo,
        _ChainingResults_info,
        __ChainingResults_crossReferences__item_,
        _ChainingResults_crossReferences,
        _ChainingResults_securityParameters,
        _ChainingResults_alreadySearched,
        ChainingResults,
        _CrossReference_contextPrefix,
        _CrossReference_accessPoint,
        CrossReference,
        _OperationProgress_nameResolutionPhase,
        _OperationProgress_nextRDNToBeResolved,
        OperationProgress,
        _TraceInformation__item_,
        TraceInformation,
        _TraceItem_dsa,
        _TraceItem_targetObject,
        _TraceItem_operationProgress,
        TraceItem,
        ReferenceType,
        _AccessPoint_ae_title,
        _AccessPoint_address,
        __AccessPoint_protocolInformation__item_,
        _AccessPoint_protocolInformation,
        AccessPoint,
        _MasterOrShadowAccessPoint_ae_title,
        _MasterOrShadowAccessPoint_address,
        __MasterOrShadowAccessPoint_protocolInformation__item_,
        _MasterOrShadowAccessPoint_protocolInformation,
        _MasterOrShadowAccessPoint_category,
        _MasterOrShadowAccessPoint_chainingRequired,
        MasterOrShadowAccessPoint,
        _MasterAndShadowAccessPoints__item_,
        MasterAndShadowAccessPoints,
        _AccessPointInformation_ae_title,
        _AccessPointInformation_address,
        __AccessPointInformation_protocolInformation__item_,
        _AccessPointInformation_protocolInformation,
        _AccessPointInformation_category,
        _AccessPointInformation_chainingRequired,
        _AccessPointInformation_additionalPoints,
        AccessPointInformation,
        _DitBridgeKnowledge_domainLocalID,
        _DitBridgeKnowledge_accessPoints,
        DitBridgeKnowledge,
        _Exclusions__item_,
        Exclusions,
        _ContinuationReference_targetObject,
        _ContinuationReference_aliasedRDNs,
        _ContinuationReference_operationProgress,
        _ContinuationReference_rdnsResolved,
        _ContinuationReference_referenceType,
        __ContinuationReference_accessPoints__item_,
        _ContinuationReference_accessPoints,
        _ContinuationReference_entryOnly,
        _ContinuationReference_exclusions,
        _ContinuationReference_returnToDUA,
        _ContinuationReference_nameResolveOnMaster,
        ContinuationReference,
        dSABind,
        _dSABind_val_ArgumentType,
        _dSABind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _DSABindArgument_credentials,
        _DSABindArgument_versions,
        DSABindArgument,
        _DSACredentials_simple,
        _DSACredentials_strong,
        _DSACredentials_externalProcedure,
        _DSACredentials_spkm,
        DSACredentials,
        DSABindResult,
        chainedRead,
        ___chainedRead_val_ArgumentType_unsigned_chainedArgument,
        ___chainedRead_val_ArgumentType_unsigned_ArgumentType,
        __chainedRead_val_ArgumentType_unsigned,
        ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedRead_val_ArgumentType_signed_toBeSigned,
        _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedRead_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedRead_val_ArgumentType_signed_signature,
        __chainedRead_val_ArgumentType_signed,
        _chainedRead_val_ArgumentType,
        ___chainedRead_val_ResultType_unsigned_chainedResult,
        ___chainedRead_val_ResultType_unsigned_ResultType,
        __chainedRead_val_ResultType_unsigned,
        ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedRead_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedRead_val_ResultType_signed_toBeSigned,
        _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedRead_val_ResultType_signed_algorithmIdentifier,
        ___chainedRead_val_ResultType_signed_signature,
        __chainedRead_val_ResultType_signed,
        _chainedRead_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        chainedCompare,
        ___chainedCompare_val_ArgumentType_unsigned_chainedArgument,
        ___chainedCompare_val_ArgumentType_unsigned_ArgumentType,
        __chainedCompare_val_ArgumentType_unsigned,
        ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedCompare_val_ArgumentType_signed_toBeSigned,
        _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedCompare_val_ArgumentType_signed_signature,
        __chainedCompare_val_ArgumentType_signed,
        _chainedCompare_val_ArgumentType,
        ___chainedCompare_val_ResultType_unsigned_chainedResult,
        ___chainedCompare_val_ResultType_unsigned_ResultType,
        __chainedCompare_val_ResultType_unsigned,
        ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedCompare_val_ResultType_signed_toBeSigned,
        _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedCompare_val_ResultType_signed_algorithmIdentifier,
        ___chainedCompare_val_ResultType_signed_signature,
        __chainedCompare_val_ResultType_signed,
        _chainedCompare_val_ResultType,
        chainedAbandon,
        _chainedAbandon_val_ArgumentType,
        _chainedAbandon_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        chainedList,
        ___chainedList_val_ArgumentType_unsigned_chainedArgument,
        ___chainedList_val_ArgumentType_unsigned_ArgumentType,
        __chainedList_val_ArgumentType_unsigned,
        ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedList_val_ArgumentType_signed_toBeSigned,
        _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedList_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedList_val_ArgumentType_signed_signature,
        __chainedList_val_ArgumentType_signed,
        _chainedList_val_ArgumentType,
        ___chainedList_val_ResultType_unsigned_chainedResult,
        ___chainedList_val_ResultType_unsigned_ResultType,
        __chainedList_val_ResultType_unsigned,
        ____chainedList_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedList_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedList_val_ResultType_signed_toBeSigned,
        _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedList_val_ResultType_signed_algorithmIdentifier,
        ___chainedList_val_ResultType_signed_signature,
        __chainedList_val_ResultType_signed,
        _chainedList_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        chainedSearch,
        ___chainedSearch_val_ArgumentType_unsigned_chainedArgument,
        ___chainedSearch_val_ArgumentType_unsigned_ArgumentType,
        __chainedSearch_val_ArgumentType_unsigned,
        ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedSearch_val_ArgumentType_signed_toBeSigned,
        _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedSearch_val_ArgumentType_signed_signature,
        __chainedSearch_val_ArgumentType_signed,
        _chainedSearch_val_ArgumentType,
        ___chainedSearch_val_ResultType_unsigned_chainedResult,
        ___chainedSearch_val_ResultType_unsigned_ResultType,
        __chainedSearch_val_ResultType_unsigned,
        ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedSearch_val_ResultType_signed_toBeSigned,
        _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedSearch_val_ResultType_signed_algorithmIdentifier,
        ___chainedSearch_val_ResultType_signed_signature,
        __chainedSearch_val_ResultType_signed,
        _chainedSearch_val_ResultType,
        chainedAddEntry,
        ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedAddEntry_val_ArgumentType_unsigned,
        ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedAddEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedAddEntry_val_ArgumentType_signed_signature,
        __chainedAddEntry_val_ArgumentType_signed,
        _chainedAddEntry_val_ArgumentType,
        ___chainedAddEntry_val_ResultType_unsigned_chainedResult,
        ___chainedAddEntry_val_ResultType_unsigned_ResultType,
        __chainedAddEntry_val_ResultType_unsigned,
        ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedAddEntry_val_ResultType_signed_toBeSigned,
        _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedAddEntry_val_ResultType_signed_signature,
        __chainedAddEntry_val_ResultType_signed,
        _chainedAddEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        chainedRemoveEntry,
        ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedRemoveEntry_val_ArgumentType_unsigned,
        ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedRemoveEntry_val_ArgumentType_signed_signature,
        __chainedRemoveEntry_val_ArgumentType_signed,
        _chainedRemoveEntry_val_ArgumentType,
        ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult,
        ___chainedRemoveEntry_val_ResultType_unsigned_ResultType,
        __chainedRemoveEntry_val_ResultType_unsigned,
        ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedRemoveEntry_val_ResultType_signed_toBeSigned,
        _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedRemoveEntry_val_ResultType_signed_signature,
        __chainedRemoveEntry_val_ResultType_signed,
        _chainedRemoveEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        chainedModifyEntry,
        ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedModifyEntry_val_ArgumentType_unsigned,
        ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedModifyEntry_val_ArgumentType_signed_signature,
        __chainedModifyEntry_val_ArgumentType_signed,
        _chainedModifyEntry_val_ArgumentType,
        ___chainedModifyEntry_val_ResultType_unsigned_chainedResult,
        ___chainedModifyEntry_val_ResultType_unsigned_ResultType,
        __chainedModifyEntry_val_ResultType_unsigned,
        ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedModifyEntry_val_ResultType_signed_toBeSigned,
        _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedModifyEntry_val_ResultType_signed_signature,
        __chainedModifyEntry_val_ResultType_signed,
        _chainedModifyEntry_val_ResultType,
        chainedModifyDN,
        ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument,
        ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType,
        __chainedModifyDN_val_ArgumentType_unsigned,
        ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedModifyDN_val_ArgumentType_signed_toBeSigned,
        _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedModifyDN_val_ArgumentType_signed_signature,
        __chainedModifyDN_val_ArgumentType_signed,
        _chainedModifyDN_val_ArgumentType,
        ___chainedModifyDN_val_ResultType_unsigned_chainedResult,
        ___chainedModifyDN_val_ResultType_unsigned_ResultType,
        __chainedModifyDN_val_ResultType_unsigned,
        ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedModifyDN_val_ResultType_signed_toBeSigned,
        _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier,
        ___chainedModifyDN_val_ResultType_signed_signature,
        __chainedModifyDN_val_ResultType_signed,
        _chainedModifyDN_val_ResultType,
        chainedChangePassword,
        ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument,
        ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType,
        __chainedChangePassword_val_ArgumentType_unsigned,
        ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedChangePassword_val_ArgumentType_signed_toBeSigned,
        _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedChangePassword_val_ArgumentType_signed_signature,
        __chainedChangePassword_val_ArgumentType_signed,
        _chainedChangePassword_val_ArgumentType,
        ___chainedChangePassword_val_ResultType_unsigned_chainedResult,
        ___chainedChangePassword_val_ResultType_unsigned_ResultType,
        __chainedChangePassword_val_ResultType_unsigned,
        ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedChangePassword_val_ResultType_signed_toBeSigned,
        _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier,
        ___chainedChangePassword_val_ResultType_signed_signature,
        __chainedChangePassword_val_ResultType_signed,
        _chainedChangePassword_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        chainedAdministerPassword,
        ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument,
        ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType,
        __chainedAdministerPassword_val_ArgumentType_unsigned,
        ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned,
        _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedAdministerPassword_val_ArgumentType_signed_signature,
        __chainedAdministerPassword_val_ArgumentType_signed,
        _chainedAdministerPassword_val_ArgumentType,
        ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult,
        ___chainedAdministerPassword_val_ResultType_unsigned_ResultType,
        __chainedAdministerPassword_val_ResultType_unsigned,
        ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedAdministerPassword_val_ResultType_signed_toBeSigned,
        _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier,
        ___chainedAdministerPassword_val_ResultType_signed_signature,
        __chainedAdministerPassword_val_ResultType_signed,
        _chainedAdministerPassword_val_ResultType,
        chainedLdapTransport,
        ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument,
        ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType,
        __chainedLdapTransport_val_ArgumentType_unsigned,
        ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned,
        _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedLdapTransport_val_ArgumentType_signed_signature,
        __chainedLdapTransport_val_ArgumentType_signed,
        _chainedLdapTransport_val_ArgumentType,
        ___chainedLdapTransport_val_ResultType_unsigned_chainedResult,
        ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_,
        ___chainedLdapTransport_val_ResultType_unsigned_ResultType,
        __chainedLdapTransport_val_ResultType_unsigned,
        ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult,
        _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_,
        ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedLdapTransport_val_ResultType_signed_toBeSigned,
        _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier,
        ___chainedLdapTransport_val_ResultType_signed_signature,
        __chainedLdapTransport_val_ResultType_signed,
        _chainedLdapTransport_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        chainedLinkedLDAP,
        ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument,
        ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType,
        __chainedLinkedLDAP_val_ArgumentType_unsigned,
        ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned,
        _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedLinkedLDAP_val_ArgumentType_signed_signature,
        __chainedLinkedLDAP_val_ArgumentType_signed,
        _chainedLinkedLDAP_val_ArgumentType,
        ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult,
        ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType,
        __chainedLinkedLDAP_val_ResultType_unsigned,
        ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned,
        _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier,
        ___chainedLinkedLDAP_val_ResultType_signed_signature,
        __chainedLinkedLDAP_val_ResultType_signed,
        _chainedLinkedLDAP_val_ResultType,
    ]

class DSAOperationalAttributeTypes:

    _name_  = 'DSAOperationalAttributeTypes'
    _oid_   = [2, 5, 1, 22, 8]
    
    _obj_ = [
        'dseType',
        'DSEType',
        'myAccessPoint',
        'superiorKnowledge',
        'specificKnowledge',
        'nonSpecificKnowledge',
        'SupplierOrConsumer',
        'SupplierInformation',
        'supplierKnowledge',
        'ConsumerInformation',
        'consumerKnowledge',
        'SupplierAndConsumers',
        'secondaryShadows',
        'ditBridgeKnowledge',
        'accessPointMatch',
        'masterAndShadowAccessPointsMatch',
        'supplierOrConsumerInformationMatch',
        'supplierAndConsumersMatch',
        'id-doa-dseType',
        'id-doa-myAccessPoint',
        'id-doa-superiorKnowledge',
        'id-doa-specificKnowledge',
        'id-doa-nonSpecificKnowledge',
        'id-doa-supplierKnowledge',
        'id-doa-consumerKnowledge',
        'id-doa-secondaryShadows',
        'id-doa-ditBridgeKnowledge',
        'id-kmr-accessPointMatch',
        'id-kmr-masterShadowMatch',
        'id-kmr-supplierConsumerMatch',
        'id-kmr-supplierConsumersMatch',
        ]
    _type_ = [
        'DSEType',
        'SupplierOrConsumer',
        'SupplierInformation',
        'ConsumerInformation',
        'SupplierAndConsumers',
        ]
    _set_ = [
        ]
    _val_ = [
        'dseType',
        'myAccessPoint',
        'superiorKnowledge',
        'specificKnowledge',
        'nonSpecificKnowledge',
        'supplierKnowledge',
        'consumerKnowledge',
        'secondaryShadows',
        'ditBridgeKnowledge',
        'accessPointMatch',
        'masterAndShadowAccessPointsMatch',
        'supplierOrConsumerInformationMatch',
        'supplierAndConsumersMatch',
        'id-doa-dseType',
        'id-doa-myAccessPoint',
        'id-doa-superiorKnowledge',
        'id-doa-specificKnowledge',
        'id-doa-nonSpecificKnowledge',
        'id-doa-supplierKnowledge',
        'id-doa-consumerKnowledge',
        'id-doa-secondaryShadows',
        'id-doa-ditBridgeKnowledge',
        'id-kmr-accessPointMatch',
        'id-kmr-masterShadowMatch',
        'id-kmr-supplierConsumerMatch',
        'id-kmr-supplierConsumersMatch',
        ]
    _class_ = [
        'dseType',
        'myAccessPoint',
        'superiorKnowledge',
        'specificKnowledge',
        'nonSpecificKnowledge',
        'supplierKnowledge',
        'consumerKnowledge',
        'secondaryShadows',
        'ditBridgeKnowledge',
        'accessPointMatch',
        'masterAndShadowAccessPointsMatch',
        'supplierOrConsumerInformationMatch',
        'supplierAndConsumersMatch',
        ]
    _param_ = [
        ]
    
    #-----< dseType >-----#
    dseType = CLASS(name='dseType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dseType_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'DSEType')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    dseType._val = dict([('Type', _dseType_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 0))])
    
    #-----< DSEType >-----#
    DSEType = BIT_STR(name='DSEType', mode=MODE_TYPE)
    DSEType._cont = ASN1Dict([('root', 0), ('glue', 1), ('cp', 2), ('entry', 3), ('alias', 4), ('subr', 5), ('nssr', 6), ('supr', 7), ('xr', 8), ('admPoint', 9), ('subentry', 10), ('shadow', 11), ('immSupr', 13), ('rhob', 14), ('sa', 15), ('dsSubentry', 16), ('familyMember', 17), ('ditBridge', 18)])
    
    #-----< myAccessPoint >-----#
    myAccessPoint = CLASS(name='myAccessPoint', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _myAccessPoint_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    myAccessPoint._val = dict([('Type', _myAccessPoint_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('id', (2, 5, 14, 0))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 1))])
    
    #-----< superiorKnowledge >-----#
    superiorKnowledge = CLASS(name='superiorKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _superiorKnowledge_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    superiorKnowledge._val = dict([('Type', _superiorKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('id', (2, 5, 14, 0))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 2))])
    
    #-----< specificKnowledge >-----#
    specificKnowledge = CLASS(name='specificKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _specificKnowledge_val_Type = SET_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1 = SET_OF(name='AssertionType', mode=MODE_TYPE)
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1._cont = _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1__item_
    specificKnowledge._val = dict([('Type', _specificKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('id', (2, 5, 14, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'distributedOperation'), ('id', (2, 5, 12, 3))])
    
    #-----< nonSpecificKnowledge >-----#
    nonSpecificKnowledge = CLASS(name='nonSpecificKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _nonSpecificKnowledge_val_Type = SET_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    nonSpecificKnowledge._val = dict([('Type', _nonSpecificKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), ('id', (2, 5, 14, 1))])), ('no-user-modification', True), ('usage', 'distributedOperation'), ('id', (2, 5, 12, 4))])
    
    #-----< SupplierOrConsumer >-----#
    SupplierOrConsumer = SET(name='SupplierOrConsumer', mode=MODE_TYPE)
    _SupplierOrConsumer_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierOrConsumer_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierOrConsumer_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierOrConsumer_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierOrConsumer_protocolInformation._cont = __SupplierOrConsumer_protocolInformation__item_
    _SupplierOrConsumer_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    SupplierOrConsumer._cont = ASN1Dict([
        ('ae-title', _SupplierOrConsumer_ae_title),
        ('address', _SupplierOrConsumer_address),
        ('protocolInformation', _SupplierOrConsumer_protocolInformation),
        ('agreementID', _SupplierOrConsumer_agreementID),
        ])
    SupplierOrConsumer._ext = []
    
    #-----< SupplierInformation >-----#
    SupplierInformation = SET(name='SupplierInformation', mode=MODE_TYPE)
    _SupplierInformation_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierInformation_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierInformation_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierInformation_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierInformation_protocolInformation._cont = __SupplierInformation_protocolInformation__item_
    _SupplierInformation_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _SupplierInformation_supplier_is_master = BOOL(name='supplier-is-master', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SupplierInformation_non_supplying_master = SET(name='non-supplying-master', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    SupplierInformation._cont = ASN1Dict([
        ('ae-title', _SupplierInformation_ae_title),
        ('address', _SupplierInformation_address),
        ('protocolInformation', _SupplierInformation_protocolInformation),
        ('agreementID', _SupplierInformation_agreementID),
        ('supplier-is-master', _SupplierInformation_supplier_is_master),
        ('non-supplying-master', _SupplierInformation_non_supplying_master),
        ])
    SupplierInformation._ext = []
    
    #-----< supplierKnowledge >-----#
    supplierKnowledge = CLASS(name='supplierKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supplierKnowledge_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierInformation')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2 = SET(name='AssertionType', mode=MODE_TYPE)
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier = INT(name='agreement-identifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2._cont = ASN1Dict([
        ('ae-title', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title),
        ('agreement-identifier', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier),
        ])
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2._ext = None
    supplierKnowledge._val = dict([('Type', _supplierKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 14, 2))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 5))])
    
    #-----< ConsumerInformation >-----#
    ConsumerInformation = SET(name='ConsumerInformation', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierOrConsumer')))
    
    #-----< consumerKnowledge >-----#
    consumerKnowledge = CLASS(name='consumerKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _consumerKnowledge_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'ConsumerInformation')))
    consumerKnowledge._val = dict([('Type', _consumerKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 14, 2))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 6))])
    
    #-----< SupplierAndConsumers >-----#
    SupplierAndConsumers = SET(name='SupplierAndConsumers', mode=MODE_TYPE)
    _SupplierAndConsumers_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierAndConsumers_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierAndConsumers_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierAndConsumers_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierAndConsumers_protocolInformation._cont = __SupplierAndConsumers_protocolInformation__item_
    _SupplierAndConsumers_consumers = SET_OF(name='consumers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SupplierAndConsumers_consumers__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _SupplierAndConsumers_consumers._cont = __SupplierAndConsumers_consumers__item_
    SupplierAndConsumers._cont = ASN1Dict([
        ('ae-title', _SupplierAndConsumers_ae_title),
        ('address', _SupplierAndConsumers_address),
        ('protocolInformation', _SupplierAndConsumers_protocolInformation),
        ('consumers', _SupplierAndConsumers_consumers),
        ])
    SupplierAndConsumers._ext = []
    
    #-----< secondaryShadows >-----#
    secondaryShadows = CLASS(name='secondaryShadows', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _secondaryShadows_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierAndConsumers')))
    secondaryShadows._val = dict([('Type', _secondaryShadows_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('id', (2, 5, 14, 3))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 7))])
    
    #-----< ditBridgeKnowledge >-----#
    ditBridgeKnowledge = CLASS(name='ditBridgeKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ditBridgeKnowledge_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DitBridgeKnowledge')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    ditBridgeKnowledge._val = dict([('Type', _ditBridgeKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 8))])
    
    #-----< accessPointMatch >-----#
    accessPointMatch = CLASS(name='accessPointMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _accessPointMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    accessPointMatch._val = dict([('AssertionType', _accessPointMatch_val_AssertionType), ('id', (2, 5, 14, 0))])
    
    #-----< masterAndShadowAccessPointsMatch >-----#
    masterAndShadowAccessPointsMatch = CLASS(name='masterAndShadowAccessPointsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _masterAndShadowAccessPointsMatch_val_AssertionType = SET_OF(name='AssertionType', mode=MODE_TYPE)
    __masterAndShadowAccessPointsMatch_val_AssertionType__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _masterAndShadowAccessPointsMatch_val_AssertionType._cont = __masterAndShadowAccessPointsMatch_val_AssertionType__item_
    masterAndShadowAccessPointsMatch._val = dict([('AssertionType', _masterAndShadowAccessPointsMatch_val_AssertionType), ('id', (2, 5, 14, 1))])
    
    #-----< supplierOrConsumerInformationMatch >-----#
    supplierOrConsumerInformationMatch = CLASS(name='supplierOrConsumerInformationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _supplierOrConsumerInformationMatch_val_AssertionType = SET(name='AssertionType', mode=MODE_TYPE)
    __supplierOrConsumerInformationMatch_val_AssertionType_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier = INT(name='agreement-identifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _supplierOrConsumerInformationMatch_val_AssertionType._cont = ASN1Dict([
        ('ae-title', __supplierOrConsumerInformationMatch_val_AssertionType_ae_title),
        ('agreement-identifier', __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier),
        ])
    _supplierOrConsumerInformationMatch_val_AssertionType._ext = None
    supplierOrConsumerInformationMatch._val = dict([('AssertionType', _supplierOrConsumerInformationMatch_val_AssertionType), ('id', (2, 5, 14, 2))])
    
    #-----< supplierAndConsumersMatch >-----#
    supplierAndConsumersMatch = CLASS(name='supplierAndConsumersMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _supplierAndConsumersMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    supplierAndConsumersMatch._val = dict([('AssertionType', _supplierAndConsumersMatch_val_AssertionType), ('id', (2, 5, 14, 3))])
    
    #-----< id-doa-dseType >-----#
    id_doa_dseType = OID(name='id-doa-dseType', mode=MODE_VALUE)
    id_doa_dseType._val = (2, 5, 12, 0)
    
    #-----< id-doa-myAccessPoint >-----#
    id_doa_myAccessPoint = OID(name='id-doa-myAccessPoint', mode=MODE_VALUE)
    id_doa_myAccessPoint._val = (2, 5, 12, 1)
    
    #-----< id-doa-superiorKnowledge >-----#
    id_doa_superiorKnowledge = OID(name='id-doa-superiorKnowledge', mode=MODE_VALUE)
    id_doa_superiorKnowledge._val = (2, 5, 12, 2)
    
    #-----< id-doa-specificKnowledge >-----#
    id_doa_specificKnowledge = OID(name='id-doa-specificKnowledge', mode=MODE_VALUE)
    id_doa_specificKnowledge._val = (2, 5, 12, 3)
    
    #-----< id-doa-nonSpecificKnowledge >-----#
    id_doa_nonSpecificKnowledge = OID(name='id-doa-nonSpecificKnowledge', mode=MODE_VALUE)
    id_doa_nonSpecificKnowledge._val = (2, 5, 12, 4)
    
    #-----< id-doa-supplierKnowledge >-----#
    id_doa_supplierKnowledge = OID(name='id-doa-supplierKnowledge', mode=MODE_VALUE)
    id_doa_supplierKnowledge._val = (2, 5, 12, 5)
    
    #-----< id-doa-consumerKnowledge >-----#
    id_doa_consumerKnowledge = OID(name='id-doa-consumerKnowledge', mode=MODE_VALUE)
    id_doa_consumerKnowledge._val = (2, 5, 12, 6)
    
    #-----< id-doa-secondaryShadows >-----#
    id_doa_secondaryShadows = OID(name='id-doa-secondaryShadows', mode=MODE_VALUE)
    id_doa_secondaryShadows._val = (2, 5, 12, 7)
    
    #-----< id-doa-ditBridgeKnowledge >-----#
    id_doa_ditBridgeKnowledge = OID(name='id-doa-ditBridgeKnowledge', mode=MODE_VALUE)
    id_doa_ditBridgeKnowledge._val = (2, 5, 12, 8)
    
    #-----< id-kmr-accessPointMatch >-----#
    id_kmr_accessPointMatch = OID(name='id-kmr-accessPointMatch', mode=MODE_VALUE)
    id_kmr_accessPointMatch._val = (2, 5, 14, 0)
    
    #-----< id-kmr-masterShadowMatch >-----#
    id_kmr_masterShadowMatch = OID(name='id-kmr-masterShadowMatch', mode=MODE_VALUE)
    id_kmr_masterShadowMatch._val = (2, 5, 14, 1)
    
    #-----< id-kmr-supplierConsumerMatch >-----#
    id_kmr_supplierConsumerMatch = OID(name='id-kmr-supplierConsumerMatch', mode=MODE_VALUE)
    id_kmr_supplierConsumerMatch._val = (2, 5, 14, 2)
    
    #-----< id-kmr-supplierConsumersMatch >-----#
    id_kmr_supplierConsumersMatch = OID(name='id-kmr-supplierConsumersMatch', mode=MODE_VALUE)
    id_kmr_supplierConsumersMatch._val = (2, 5, 14, 3)
    
    _all_ = [
        dseType,
        _dseType_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        DSEType,
        myAccessPoint,
        _myAccessPoint_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        superiorKnowledge,
        _superiorKnowledge_val_Type,
        specificKnowledge,
        _specificKnowledge_val_Type,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1__item_,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1,
        nonSpecificKnowledge,
        _nonSpecificKnowledge_val_Type,
        _SupplierOrConsumer_ae_title,
        _SupplierOrConsumer_address,
        __SupplierOrConsumer_protocolInformation__item_,
        _SupplierOrConsumer_protocolInformation,
        _SupplierOrConsumer_agreementID,
        SupplierOrConsumer,
        _SupplierInformation_ae_title,
        _SupplierInformation_address,
        __SupplierInformation_protocolInformation__item_,
        _SupplierInformation_protocolInformation,
        _SupplierInformation_agreementID,
        _SupplierInformation_supplier_is_master,
        _SupplierInformation_non_supplying_master,
        SupplierInformation,
        supplierKnowledge,
        _supplierKnowledge_val_Type,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2,
        ConsumerInformation,
        consumerKnowledge,
        _consumerKnowledge_val_Type,
        _SupplierAndConsumers_ae_title,
        _SupplierAndConsumers_address,
        __SupplierAndConsumers_protocolInformation__item_,
        _SupplierAndConsumers_protocolInformation,
        __SupplierAndConsumers_consumers__item_,
        _SupplierAndConsumers_consumers,
        SupplierAndConsumers,
        secondaryShadows,
        _secondaryShadows_val_Type,
        ditBridgeKnowledge,
        _ditBridgeKnowledge_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3,
        accessPointMatch,
        _accessPointMatch_val_AssertionType,
        masterAndShadowAccessPointsMatch,
        __masterAndShadowAccessPointsMatch_val_AssertionType__item_,
        _masterAndShadowAccessPointsMatch_val_AssertionType,
        supplierOrConsumerInformationMatch,
        __supplierOrConsumerInformationMatch_val_AssertionType_ae_title,
        __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier,
        _supplierOrConsumerInformationMatch_val_AssertionType,
        supplierAndConsumersMatch,
        _supplierAndConsumersMatch_val_AssertionType,
        id_doa_dseType,
        id_doa_myAccessPoint,
        id_doa_superiorKnowledge,
        id_doa_specificKnowledge,
        id_doa_nonSpecificKnowledge,
        id_doa_supplierKnowledge,
        id_doa_consumerKnowledge,
        id_doa_secondaryShadows,
        id_doa_ditBridgeKnowledge,
        id_kmr_accessPointMatch,
        id_kmr_masterShadowMatch,
        id_kmr_supplierConsumerMatch,
        id_kmr_supplierConsumersMatch,
    ]

class EnhancedSecurity:

    _name_  = 'EnhancedSecurity'
    _oid_   = [2, 5, 1, 28, 8]
    
    _obj_ = [
        'OPTIONALLY-PROTECTED',
        'OPTIONALLY-PROTECTED-SEQ',
        'attributeValueSecurityLabelContext',
        'SignedSecurityLabel',
        'SignedSecurityLabelContent',
        'SecurityLabel',
        'SecurityPolicyIdentifier',
        'SecurityClassification',
        'PrivacyMark',
        'SecurityCategories',
        'clearance',
        'Clearance',
        'ClassList',
        'SecurityCategory',
        'SECURITY-CATEGORY',
        'SecurityCategoriesTable',
        'attributeIntegrityInfo',
        'AttributeIntegrityInfo',
        'AttributeIntegrityInfoContent',
        'Signer',
        'ThisEntry',
        'IssuerAndSerialNumber',
        'SpecificallyIdentified',
        'Scope',
        'SelectedTypes',
        'AttribsHash',
        'HashedAttributes',
        'integrityInfo',
        'attributeValueIntegrityInfoContext',
        'AttributeValueIntegrityInfo',
        'AttributeValueIntegrityInfoContent',
        'AVIHash',
        'AttributeTypeValueContexts',
        'id-oc-integrityInfo',
        'id-at-clearance',
        'id-at-attributeIntegrityInfo',
        'id-avc-attributeValueSecurityLabelContext',
        'id-avc-attributeValueIntegrityInfoContext',
        ]
    _type_ = [
        'OPTIONALLY-PROTECTED',
        'OPTIONALLY-PROTECTED-SEQ',
        'SignedSecurityLabel',
        'SignedSecurityLabelContent',
        'SecurityLabel',
        'SecurityPolicyIdentifier',
        'SecurityClassification',
        'PrivacyMark',
        'SecurityCategories',
        'Clearance',
        'ClassList',
        'SecurityCategory',
        'SECURITY-CATEGORY',
        'AttributeIntegrityInfo',
        'AttributeIntegrityInfoContent',
        'Signer',
        'ThisEntry',
        'IssuerAndSerialNumber',
        'SpecificallyIdentified',
        'Scope',
        'SelectedTypes',
        'AttribsHash',
        'HashedAttributes',
        'AttributeValueIntegrityInfo',
        'AttributeValueIntegrityInfoContent',
        'AVIHash',
        'AttributeTypeValueContexts',
        ]
    _set_ = [
        'SecurityCategoriesTable',
        ]
    _val_ = [
        'attributeValueSecurityLabelContext',
        'clearance',
        'attributeIntegrityInfo',
        'integrityInfo',
        'attributeValueIntegrityInfoContext',
        'id-oc-integrityInfo',
        'id-at-clearance',
        'id-at-attributeIntegrityInfo',
        'id-avc-attributeValueSecurityLabelContext',
        'id-avc-attributeValueIntegrityInfoContext',
        ]
    _class_ = [
        'attributeValueSecurityLabelContext',
        'clearance',
        'SECURITY-CATEGORY',
        'SecurityCategoriesTable',
        'attributeIntegrityInfo',
        'integrityInfo',
        'attributeValueIntegrityInfoContext',
        ]
    _param_ = [
        'OPTIONALLY-PROTECTED',
        'OPTIONALLY-PROTECTED-SEQ',
        ]
    
    #-----< OPTIONALLY-PROTECTED >-----#
    OPTIONALLY_PROTECTED = CHOICE(name='OPTIONALLY-PROTECTED', mode=MODE_TYPE, param=True)
    
    #-----< OPTIONALLY-PROTECTED-SEQ >-----#
    OPTIONALLY_PROTECTED_SEQ = CHOICE(name='OPTIONALLY-PROTECTED-SEQ', mode=MODE_TYPE, param=True)
    
    #-----< attributeValueSecurityLabelContext >-----#
    attributeValueSecurityLabelContext = CLASS(name='attributeValueSecurityLabelContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _attributeValueSecurityLabelContext_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SignedSecurityLabel')))
    attributeValueSecurityLabelContext._val = dict([('Type', _attributeValueSecurityLabelContext_val_Type), ('id', (2, 5, 31, 3))])
    
    #-----< SignedSecurityLabel >-----#
    SignedSecurityLabel = SEQ(name='SignedSecurityLabel', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _SignedSecurityLabel_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SignedSecurityLabelContent')))
    _SignedSecurityLabel_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SignedSecurityLabel_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab = ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab_at = None
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __SignedSecurityLabel_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SignedSecurityLabel_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SignedSecurityLabel_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab = ___SignedSecurityLabel_algorithmIdentifier_parameters_tab
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _SignedSecurityLabel_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __SignedSecurityLabel_algorithmIdentifier_algorithm),
        ('parameters', __SignedSecurityLabel_algorithmIdentifier_parameters),
        ])
    _SignedSecurityLabel_algorithmIdentifier._ext = []
    _SignedSecurityLabel_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    SignedSecurityLabel._cont = ASN1Dict([
        ('toBeSigned', _SignedSecurityLabel_toBeSigned),
        ('algorithmIdentifier', _SignedSecurityLabel_algorithmIdentifier),
        ('signature', _SignedSecurityLabel_signature),
        ])
    SignedSecurityLabel._ext = []
    
    #-----< SignedSecurityLabelContent >-----#
    SignedSecurityLabelContent = SEQ(name='SignedSecurityLabelContent', mode=MODE_TYPE)
    _SignedSecurityLabelContent_attHash = SEQ(name='attHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    __SignedSecurityLabelContent_attHash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab = ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab_at = None
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab = ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __SignedSecurityLabelContent_attHash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm),
        ('parameters', ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters),
        ])
    __SignedSecurityLabelContent_attHash_algorithmIdentifier._ext = []
    __SignedSecurityLabelContent_attHash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    _SignedSecurityLabelContent_attHash._cont = ASN1Dict([
        ('algorithmIdentifier', __SignedSecurityLabelContent_attHash_algorithmIdentifier),
        ('hashValue', __SignedSecurityLabelContent_attHash_hashValue),
        ])
    _SignedSecurityLabelContent_attHash._ext = []
    _SignedSecurityLabelContent_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _SignedSecurityLabelContent_keyIdentifier = OCT_STR(name='keyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')), opt=True)
    _SignedSecurityLabelContent_securityLabel = SET(name='securityLabel', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityLabel')))
    SignedSecurityLabelContent._cont = ASN1Dict([
        ('attHash', _SignedSecurityLabelContent_attHash),
        ('issuer', _SignedSecurityLabelContent_issuer),
        ('keyIdentifier', _SignedSecurityLabelContent_keyIdentifier),
        ('securityLabel', _SignedSecurityLabelContent_securityLabel),
        ])
    SignedSecurityLabelContent._ext = []
    
    #-----< SecurityLabel >-----#
    SecurityLabel = SET(name='SecurityLabel', mode=MODE_TYPE)
    _SecurityLabel_security_policy_identifier = OID(name='security-policy-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityPolicyIdentifier')), opt=True)
    _SecurityLabel_security_classification = INT(name='security-classification', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityClassification')), opt=True)
    _SecurityLabel_privacy_mark = STR_PRINT(name='privacy-mark', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'PrivacyMark')), opt=True)
    _SecurityLabel_security_categories = SET_OF(name='security-categories', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategories')), opt=True)
    SecurityLabel._cont = ASN1Dict([
        ('security-policy-identifier', _SecurityLabel_security_policy_identifier),
        ('security-classification', _SecurityLabel_security_classification),
        ('privacy-mark', _SecurityLabel_privacy_mark),
        ('security-categories', _SecurityLabel_security_categories),
        ])
    SecurityLabel._ext = []
    
    #-----< SecurityPolicyIdentifier >-----#
    SecurityPolicyIdentifier = OID(name='SecurityPolicyIdentifier', mode=MODE_TYPE)
    
    #-----< SecurityClassification >-----#
    SecurityClassification = INT(name='SecurityClassification', mode=MODE_TYPE)
    SecurityClassification._cont = ASN1Dict([('unmarked', 0), ('unclassified', 1), ('restricted', 2), ('confidential', 3), ('secret', 4), ('top-secret', 5)])
    
    #-----< PrivacyMark >-----#
    PrivacyMark = STR_PRINT(name='PrivacyMark', mode=MODE_TYPE)
    PrivacyMark._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SecurityCategories >-----#
    SecurityCategories = SET_OF(name='SecurityCategories', mode=MODE_TYPE)
    _SecurityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategory')))
    SecurityCategories._cont = _SecurityCategories__item_
    SecurityCategories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< clearance >-----#
    clearance = CLASS(name='clearance', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _clearance_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Clearance')))
    clearance._val = dict([('Type', _clearance_val_Type), ('id', (2, 5, 4, 55))])
    
    #-----< Clearance >-----#
    Clearance = SEQ(name='Clearance', mode=MODE_TYPE)
    _Clearance_policyId = OID(name='policyId', mode=MODE_TYPE)
    _Clearance_classList = BIT_STR(name='classList', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'ClassList')), default=(1, 2))
    _Clearance_securityCategories = SET_OF(name='securityCategories', mode=MODE_TYPE, opt=True)
    __Clearance_securityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategory')))
    _Clearance_securityCategories._cont = __Clearance_securityCategories__item_
    _Clearance_securityCategories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    Clearance._cont = ASN1Dict([
        ('policyId', _Clearance_policyId),
        ('classList', _Clearance_classList),
        ('securityCategories', _Clearance_securityCategories),
        ])
    Clearance._ext = []
    
    #-----< ClassList >-----#
    ClassList = BIT_STR(name='ClassList', mode=MODE_TYPE)
    ClassList._cont = ASN1Dict([('unmarked', 0), ('unclassified', 1), ('restricted', 2), ('confidential', 3), ('secret', 4), ('topSecret', 5)])
    
    #-----< SecurityCategory >-----#
    SecurityCategory = SEQ(name='SecurityCategory', mode=MODE_TYPE)
    _SecurityCategory_type = OID(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('EnhancedSecurity', 'SECURITY-CATEGORY'), ['id']))
    __SecurityCategory_type_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    __SecurityCategory_type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SecurityCategory_type._const_tab = __SecurityCategory_type_tab
    _SecurityCategory_type._const_tab_at = None
    _SecurityCategory_type._const_tab_id = 'id'
    _SecurityCategory_value = OPEN(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('EnhancedSecurity', 'SECURITY-CATEGORY'), ['Type']))
    __SecurityCategory_value_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    __SecurityCategory_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SecurityCategory_value._const_tab = __SecurityCategory_value_tab
    _SecurityCategory_value._const_tab_at = ('..', 'type')
    _SecurityCategory_value._const_tab_id = 'Type'
    SecurityCategory._cont = ASN1Dict([
        ('type', _SecurityCategory_type),
        ('value', _SecurityCategory_value),
        ])
    SecurityCategory._ext = []
    
    #-----< SECURITY-CATEGORY >-----#
    SECURITY_CATEGORY = CLASS(name='SECURITY-CATEGORY', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< SecurityCategoriesTable >-----#
    SecurityCategoriesTable = CLASS(name='SecurityCategoriesTable', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    SecurityCategoriesTable._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< attributeIntegrityInfo >-----#
    attributeIntegrityInfo = CLASS(name='attributeIntegrityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeIntegrityInfo_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfo')))
    attributeIntegrityInfo._val = dict([('Type', _attributeIntegrityInfo_val_Type), ('single-valued', True), ('id', (2, 5, 4, 57))])
    
    #-----< AttributeIntegrityInfo >-----#
    AttributeIntegrityInfo = SEQ(name='AttributeIntegrityInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeIntegrityInfo_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfoContent')))
    _AttributeIntegrityInfo_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab = ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeIntegrityInfo_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab = ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttributeIntegrityInfo_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeIntegrityInfo_algorithmIdentifier_algorithm),
        ('parameters', __AttributeIntegrityInfo_algorithmIdentifier_parameters),
        ])
    _AttributeIntegrityInfo_algorithmIdentifier._ext = []
    _AttributeIntegrityInfo_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    AttributeIntegrityInfo._cont = ASN1Dict([
        ('toBeSigned', _AttributeIntegrityInfo_toBeSigned),
        ('algorithmIdentifier', _AttributeIntegrityInfo_algorithmIdentifier),
        ('signature', _AttributeIntegrityInfo_signature),
        ])
    AttributeIntegrityInfo._ext = []
    
    #-----< AttributeIntegrityInfoContent >-----#
    AttributeIntegrityInfoContent = SEQ(name='AttributeIntegrityInfoContent', mode=MODE_TYPE)
    _AttributeIntegrityInfoContent_scope = CHOICE(name='scope', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Scope')))
    _AttributeIntegrityInfoContent_signer = CHOICE(name='signer', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Signer')), opt=True)
    _AttributeIntegrityInfoContent_attribsHash = SEQ(name='attribsHash', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttribsHash')))
    AttributeIntegrityInfoContent._cont = ASN1Dict([
        ('scope', _AttributeIntegrityInfoContent_scope),
        ('signer', _AttributeIntegrityInfoContent_signer),
        ('attribsHash', _AttributeIntegrityInfoContent_attribsHash),
        ])
    AttributeIntegrityInfoContent._ext = []
    
    #-----< Signer >-----#
    Signer = CHOICE(name='Signer', mode=MODE_TYPE)
    _Signer_thisEntry = CHOICE(name='thisEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'ThisEntry')))
    _Signer_thirdParty = SEQ(name='thirdParty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'SpecificallyIdentified')))
    Signer._cont = ASN1Dict([
        ('thisEntry', _Signer_thisEntry),
        ('thirdParty', _Signer_thirdParty),
        ])
    Signer._ext = []
    
    #-----< ThisEntry >-----#
    ThisEntry = CHOICE(name='ThisEntry', mode=MODE_TYPE)
    _ThisEntry_onlyOne = NULL(name='onlyOne', mode=MODE_TYPE)
    _ThisEntry_specific = SEQ(name='specific', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'IssuerAndSerialNumber')))
    ThisEntry._cont = ASN1Dict([
        ('onlyOne', _ThisEntry_onlyOne),
        ('specific', _ThisEntry_specific),
        ])
    ThisEntry._ext = []
    
    #-----< IssuerAndSerialNumber >-----#
    IssuerAndSerialNumber = SEQ(name='IssuerAndSerialNumber', mode=MODE_TYPE)
    _IssuerAndSerialNumber_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _IssuerAndSerialNumber_serial = INT(name='serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    IssuerAndSerialNumber._cont = ASN1Dict([
        ('issuer', _IssuerAndSerialNumber_issuer),
        ('serial', _IssuerAndSerialNumber_serial),
        ])
    IssuerAndSerialNumber._ext = []
    
    #-----< SpecificallyIdentified >-----#
    SpecificallyIdentified = SEQ(name='SpecificallyIdentified', mode=MODE_TYPE)
    _SpecificallyIdentified_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _SpecificallyIdentified_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _SpecificallyIdentified_serial = INT(name='serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    SpecificallyIdentified._cont = ASN1Dict([
        ('name', _SpecificallyIdentified_name),
        ('issuer', _SpecificallyIdentified_issuer),
        ('serial', _SpecificallyIdentified_serial),
        ])
    SpecificallyIdentified._ext = None
    
    #-----< Scope >-----#
    Scope = CHOICE(name='Scope', mode=MODE_TYPE)
    _Scope_wholeEntry = NULL(name='wholeEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Scope_selectedTypes = SEQ_OF(name='selectedTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'SelectedTypes')))
    Scope._cont = ASN1Dict([
        ('wholeEntry', _Scope_wholeEntry),
        ('selectedTypes', _Scope_selectedTypes),
        ])
    Scope._ext = []
    
    #-----< SelectedTypes >-----#
    SelectedTypes = SEQ_OF(name='SelectedTypes', mode=MODE_TYPE)
    _SelectedTypes__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    SelectedTypes._cont = _SelectedTypes__item_
    SelectedTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttribsHash >-----#
    AttribsHash = SEQ(name='AttribsHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    _AttribsHash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttribsHash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttribsHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttribsHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttribsHash_algorithmIdentifier_algorithm._const_tab = ___AttribsHash_algorithmIdentifier_algorithm_tab
    __AttribsHash_algorithmIdentifier_algorithm._const_tab_at = None
    __AttribsHash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttribsHash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttribsHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttribsHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttribsHash_algorithmIdentifier_parameters._const_tab = ___AttribsHash_algorithmIdentifier_parameters_tab
    __AttribsHash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttribsHash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttribsHash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttribsHash_algorithmIdentifier_algorithm),
        ('parameters', __AttribsHash_algorithmIdentifier_parameters),
        ])
    _AttribsHash_algorithmIdentifier._ext = []
    _AttribsHash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    AttribsHash._cont = ASN1Dict([
        ('algorithmIdentifier', _AttribsHash_algorithmIdentifier),
        ('hashValue', _AttribsHash_hashValue),
        ])
    AttribsHash._ext = []
    
    #-----< HashedAttributes >-----#
    HashedAttributes = SEQ_OF(name='HashedAttributes', mode=MODE_TYPE)
    _HashedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __HashedAttributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___HashedAttributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____HashedAttributes__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ____HashedAttributes__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___HashedAttributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', ____HashedAttributes__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____HashedAttributes__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __HashedAttributes__item__type._const_tab = ___HashedAttributes__item__type_tab
    __HashedAttributes__item__type._const_tab_at = None
    __HashedAttributes__item__type._const_tab_id = 'id'
    __HashedAttributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ___HashedAttributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___HashedAttributes__item__values__item_._const_tab = ___HashedAttributes__item__type_tab
    ___HashedAttributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ___HashedAttributes__item__values__item_._const_tab_id = 'Type'
    __HashedAttributes__item__values._cont = ___HashedAttributes__item__values__item_
    __HashedAttributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __HashedAttributes__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___HashedAttributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____HashedAttributes__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab = ___HashedAttributes__item__type_tab
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ____HashedAttributes__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____HashedAttributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____HashedAttributes__item__valuesWithContext__item__contextList._cont = _____HashedAttributes__item__valuesWithContext__item__contextList__item_
    ____HashedAttributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___HashedAttributes__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____HashedAttributes__item__valuesWithContext__item__value),
        ('contextList', ____HashedAttributes__item__valuesWithContext__item__contextList),
        ])
    ___HashedAttributes__item__valuesWithContext__item_._ext = []
    __HashedAttributes__item__valuesWithContext._cont = ___HashedAttributes__item__valuesWithContext__item_
    __HashedAttributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _HashedAttributes__item_._cont = ASN1Dict([
        ('type', __HashedAttributes__item__type),
        ('values', __HashedAttributes__item__values),
        ('valuesWithContext', __HashedAttributes__item__valuesWithContext),
        ])
    _HashedAttributes__item_._ext = []
    HashedAttributes._cont = _HashedAttributes__item_
    HashedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< integrityInfo >-----#
    integrityInfo = CLASS(name='integrityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfo')))
    integrityInfo._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), ('single-valued', True), ('id', (2, 5, 4, 57))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 40))])
    
    #-----< attributeValueIntegrityInfoContext >-----#
    attributeValueIntegrityInfoContext = CLASS(name='attributeValueIntegrityInfoContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _attributeValueIntegrityInfoContext_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeValueIntegrityInfo')))
    attributeValueIntegrityInfoContext._val = dict([('Type', _attributeValueIntegrityInfoContext_val_Type), ('id', (2, 5, 31, 4))])
    
    #-----< AttributeValueIntegrityInfo >-----#
    AttributeValueIntegrityInfo = SEQ(name='AttributeValueIntegrityInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeValueIntegrityInfo_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeValueIntegrityInfoContent')))
    _AttributeValueIntegrityInfo_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab = ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab = ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttributeValueIntegrityInfo_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm),
        ('parameters', __AttributeValueIntegrityInfo_algorithmIdentifier_parameters),
        ])
    _AttributeValueIntegrityInfo_algorithmIdentifier._ext = []
    _AttributeValueIntegrityInfo_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    AttributeValueIntegrityInfo._cont = ASN1Dict([
        ('toBeSigned', _AttributeValueIntegrityInfo_toBeSigned),
        ('algorithmIdentifier', _AttributeValueIntegrityInfo_algorithmIdentifier),
        ('signature', _AttributeValueIntegrityInfo_signature),
        ])
    AttributeValueIntegrityInfo._ext = []
    
    #-----< AttributeValueIntegrityInfoContent >-----#
    AttributeValueIntegrityInfoContent = SEQ(name='AttributeValueIntegrityInfoContent', mode=MODE_TYPE)
    _AttributeValueIntegrityInfoContent_signer = CHOICE(name='signer', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Signer')), opt=True)
    _AttributeValueIntegrityInfoContent_aVIHash = SEQ(name='aVIHash', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AVIHash')))
    AttributeValueIntegrityInfoContent._cont = ASN1Dict([
        ('signer', _AttributeValueIntegrityInfoContent_signer),
        ('aVIHash', _AttributeValueIntegrityInfoContent_aVIHash),
        ])
    AttributeValueIntegrityInfoContent._ext = []
    
    #-----< AVIHash >-----#
    AVIHash = SEQ(name='AVIHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    _AVIHash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AVIHash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AVIHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AVIHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AVIHash_algorithmIdentifier_algorithm._const_tab = ___AVIHash_algorithmIdentifier_algorithm_tab
    __AVIHash_algorithmIdentifier_algorithm._const_tab_at = None
    __AVIHash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AVIHash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AVIHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AVIHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AVIHash_algorithmIdentifier_parameters._const_tab = ___AVIHash_algorithmIdentifier_parameters_tab
    __AVIHash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AVIHash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AVIHash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AVIHash_algorithmIdentifier_algorithm),
        ('parameters', __AVIHash_algorithmIdentifier_parameters),
        ])
    _AVIHash_algorithmIdentifier._ext = []
    _AVIHash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    AVIHash._cont = ASN1Dict([
        ('algorithmIdentifier', _AVIHash_algorithmIdentifier),
        ('hashValue', _AVIHash_hashValue),
        ])
    AVIHash._ext = []
    
    #-----< AttributeTypeValueContexts >-----#
    AttributeTypeValueContexts = SEQ(name='AttributeTypeValueContexts', mode=MODE_TYPE)
    _AttributeTypeValueContexts_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeTypeValueContexts_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeValueContexts_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___AttributeTypeValueContexts_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeValueContexts_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeTypeValueContexts_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeTypeValueContexts_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeValueContexts_type._const_tab = __AttributeTypeValueContexts_type_tab
    _AttributeTypeValueContexts_type._const_tab_at = None
    _AttributeTypeValueContexts_type._const_tab_id = 'id'
    _AttributeTypeValueContexts_value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _AttributeTypeValueContexts_value._const_tab = __AttributeTypeValueContexts_type_tab
    _AttributeTypeValueContexts_value._const_tab_at = ('..', 'type')
    _AttributeTypeValueContexts_value._const_tab_id = 'Type'
    _AttributeTypeValueContexts_contextList = SET_OF(name='contextList', mode=MODE_TYPE, opt=True)
    __AttributeTypeValueContexts_contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _AttributeTypeValueContexts_contextList._cont = __AttributeTypeValueContexts_contextList__item_
    _AttributeTypeValueContexts_contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeTypeValueContexts._cont = ASN1Dict([
        ('type', _AttributeTypeValueContexts_type),
        ('value', _AttributeTypeValueContexts_value),
        ('contextList', _AttributeTypeValueContexts_contextList),
        ])
    AttributeTypeValueContexts._ext = []
    
    #-----< id-oc-integrityInfo >-----#
    id_oc_integrityInfo = OID(name='id-oc-integrityInfo', mode=MODE_VALUE)
    id_oc_integrityInfo._val = (2, 5, 6, 40)
    
    #-----< id-at-clearance >-----#
    id_at_clearance = OID(name='id-at-clearance', mode=MODE_VALUE)
    id_at_clearance._val = (2, 5, 4, 55)
    
    #-----< id-at-attributeIntegrityInfo >-----#
    id_at_attributeIntegrityInfo = OID(name='id-at-attributeIntegrityInfo', mode=MODE_VALUE)
    id_at_attributeIntegrityInfo._val = (2, 5, 4, 57)
    
    #-----< id-avc-attributeValueSecurityLabelContext >-----#
    id_avc_attributeValueSecurityLabelContext = OID(name='id-avc-attributeValueSecurityLabelContext', mode=MODE_VALUE)
    id_avc_attributeValueSecurityLabelContext._val = (2, 5, 31, 3)
    
    #-----< id-avc-attributeValueIntegrityInfoContext >-----#
    id_avc_attributeValueIntegrityInfoContext = OID(name='id-avc-attributeValueIntegrityInfoContext', mode=MODE_VALUE)
    id_avc_attributeValueIntegrityInfoContext._val = (2, 5, 31, 4)
    
    _all_ = [
        attributeValueSecurityLabelContext,
        _attributeValueSecurityLabelContext_val_Type,
        _SignedSecurityLabel_toBeSigned,
        ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab,
        __SignedSecurityLabel_algorithmIdentifier_algorithm,
        ___SignedSecurityLabel_algorithmIdentifier_parameters_tab,
        __SignedSecurityLabel_algorithmIdentifier_parameters,
        _SignedSecurityLabel_algorithmIdentifier,
        _SignedSecurityLabel_signature,
        SignedSecurityLabel,
        ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab,
        ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm,
        ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab,
        ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters,
        __SignedSecurityLabelContent_attHash_algorithmIdentifier,
        __SignedSecurityLabelContent_attHash_hashValue,
        _SignedSecurityLabelContent_attHash,
        _SignedSecurityLabelContent_issuer,
        _SignedSecurityLabelContent_keyIdentifier,
        _SignedSecurityLabelContent_securityLabel,
        SignedSecurityLabelContent,
        _SecurityLabel_security_policy_identifier,
        _SecurityLabel_security_classification,
        _SecurityLabel_privacy_mark,
        _SecurityLabel_security_categories,
        SecurityLabel,
        SecurityPolicyIdentifier,
        SecurityClassification,
        PrivacyMark,
        _SecurityCategories__item_,
        SecurityCategories,
        clearance,
        _clearance_val_Type,
        _Clearance_policyId,
        _Clearance_classList,
        __Clearance_securityCategories__item_,
        _Clearance_securityCategories,
        Clearance,
        ClassList,
        __SecurityCategory_type_tab,
        _SecurityCategory_type,
        __SecurityCategory_value_tab,
        _SecurityCategory_value,
        SecurityCategory,
        SECURITY_CATEGORY,
        SecurityCategoriesTable,
        attributeIntegrityInfo,
        _attributeIntegrityInfo_val_Type,
        _AttributeIntegrityInfo_toBeSigned,
        ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab,
        __AttributeIntegrityInfo_algorithmIdentifier_algorithm,
        ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab,
        __AttributeIntegrityInfo_algorithmIdentifier_parameters,
        _AttributeIntegrityInfo_algorithmIdentifier,
        _AttributeIntegrityInfo_signature,
        AttributeIntegrityInfo,
        _AttributeIntegrityInfoContent_scope,
        _AttributeIntegrityInfoContent_signer,
        _AttributeIntegrityInfoContent_attribsHash,
        AttributeIntegrityInfoContent,
        _Signer_thisEntry,
        _Signer_thirdParty,
        Signer,
        _ThisEntry_onlyOne,
        _ThisEntry_specific,
        ThisEntry,
        _IssuerAndSerialNumber_issuer,
        _IssuerAndSerialNumber_serial,
        IssuerAndSerialNumber,
        _SpecificallyIdentified_name,
        _SpecificallyIdentified_issuer,
        _SpecificallyIdentified_serial,
        SpecificallyIdentified,
        _Scope_wholeEntry,
        _Scope_selectedTypes,
        Scope,
        _SelectedTypes__item_,
        SelectedTypes,
        ___AttribsHash_algorithmIdentifier_algorithm_tab,
        __AttribsHash_algorithmIdentifier_algorithm,
        ___AttribsHash_algorithmIdentifier_parameters_tab,
        __AttribsHash_algorithmIdentifier_parameters,
        _AttribsHash_algorithmIdentifier,
        _AttribsHash_hashValue,
        AttribsHash,
        ___HashedAttributes__item__type_tab,
        ____HashedAttributes__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        ____HashedAttributes__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        __HashedAttributes__item__type,
        ___HashedAttributes__item__values__item_,
        __HashedAttributes__item__values,
        ____HashedAttributes__item__valuesWithContext__item__value,
        _____HashedAttributes__item__valuesWithContext__item__contextList__item_,
        ____HashedAttributes__item__valuesWithContext__item__contextList,
        ___HashedAttributes__item__valuesWithContext__item_,
        __HashedAttributes__item__valuesWithContext,
        _HashedAttributes__item_,
        HashedAttributes,
        integrityInfo,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0,
        attributeValueIntegrityInfoContext,
        _attributeValueIntegrityInfoContext_val_Type,
        _AttributeValueIntegrityInfo_toBeSigned,
        ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab,
        __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm,
        ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab,
        __AttributeValueIntegrityInfo_algorithmIdentifier_parameters,
        _AttributeValueIntegrityInfo_algorithmIdentifier,
        _AttributeValueIntegrityInfo_signature,
        AttributeValueIntegrityInfo,
        _AttributeValueIntegrityInfoContent_signer,
        _AttributeValueIntegrityInfoContent_aVIHash,
        AttributeValueIntegrityInfoContent,
        ___AVIHash_algorithmIdentifier_algorithm_tab,
        __AVIHash_algorithmIdentifier_algorithm,
        ___AVIHash_algorithmIdentifier_parameters_tab,
        __AVIHash_algorithmIdentifier_parameters,
        _AVIHash_algorithmIdentifier,
        _AVIHash_hashValue,
        AVIHash,
        __AttributeTypeValueContexts_type_tab,
        ___AttributeTypeValueContexts_type_tab_val_Type_0,
        ___AttributeTypeValueContexts_type_tab_val_Type_1,
        _AttributeTypeValueContexts_type,
        _AttributeTypeValueContexts_value,
        __AttributeTypeValueContexts_contextList__item_,
        _AttributeTypeValueContexts_contextList,
        AttributeTypeValueContexts,
        id_oc_integrityInfo,
        id_at_clearance,
        id_at_attributeIntegrityInfo,
        id_avc_attributeValueSecurityLabelContext,
        id_avc_attributeValueIntegrityInfoContext,
    ]

class GenericChargingDataTypes:

    _name_  = 'GenericChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 0, 0, 1]
    
    _obj_ = [
        'BCDDirectoryNumber',
        'CallDuration',
        'CalledNumber',
        'CallingNumber',
        'CellId',
        'ChargeIndicator',
        'CauseForRecClosing',
        'CauseForTerm',
        'ChargingID',
        'CivicAddressInformation',
        'CNIPMulticastDistribution',
        'DataVolumeOctets',
        'DynamicAddressFlag',
        'Diagnostics',
        'DiameterIdentity',
        'EnhancedDiagnostics',
        'GSNAddress',
        'InvolvedParty',
        'IPAddress',
        'IPBinaryAddress',
        'IPBinV4Address',
        'IPBinV6Address',
        'IPBinV6AddressWithOrWithoutPrefixLength',
        'IPBinV6AddressWithPrefixLength',
        'IPTextRepresentedAddress',
        'LCSCause',
        'LCSClientIdentity',
        'LCSQoSInfo',
        'LevelOfCAMELService',
        'LocalSequenceNumber',
        'LocationAreaAndCell',
        'LocationAreaCode',
        'ManagementExtensions',
        'MBMS2G3GIndicator',
        'MBMSInformation',
        'MBMSServiceArea',
        'MBMSServiceType',
        'MBMSSessionIdentity',
        'MBMSTime',
        'MBMSUserServiceType',
        'MCC-MNC',
        'MessageClass',
        'MessageReference',
        'MSCAddress',
        'MscNo',
        'MSISDN',
        'MSTimeZone',
        'NodeID',
        'NodeAddress',
        'PDPAddressPrefixLength',
        'PDPAddress',
        'PLMN-Id',
        'PositioningData',
        'PriorityType',
        'RANNASCause',
        'RATType',
        'RecordingEntity',
        'RecordType',
        'RequiredMBMSBearerCapabilities',
        'RoutingAreaCode',
        'SCSASAddress',
        'Session-Id',
        'ServiceContextID',
        'ServiceSpecificInfo',
        'SMSResult',
        'SmsTpDestinationNumber',
        'SubscriberEquipmentNumber',
        'SubscriberEquipmentType',
        'SubscriptionID',
        'SubscriptionIDType',
        'SystemType',
        'ThreeGPPPSDataOffStatus',
        'TimeStamp',
        'TMGI',
        ]
    _type_ = [
        'BCDDirectoryNumber',
        'CallDuration',
        'CalledNumber',
        'CallingNumber',
        'CellId',
        'ChargeIndicator',
        'CauseForRecClosing',
        'CauseForTerm',
        'ChargingID',
        'CivicAddressInformation',
        'CNIPMulticastDistribution',
        'DataVolumeOctets',
        'DynamicAddressFlag',
        'Diagnostics',
        'DiameterIdentity',
        'EnhancedDiagnostics',
        'GSNAddress',
        'InvolvedParty',
        'IPAddress',
        'IPBinaryAddress',
        'IPBinV4Address',
        'IPBinV6Address',
        'IPBinV6AddressWithOrWithoutPrefixLength',
        'IPBinV6AddressWithPrefixLength',
        'IPTextRepresentedAddress',
        'LCSCause',
        'LCSClientIdentity',
        'LCSQoSInfo',
        'LevelOfCAMELService',
        'LocalSequenceNumber',
        'LocationAreaAndCell',
        'LocationAreaCode',
        'ManagementExtensions',
        'MBMS2G3GIndicator',
        'MBMSInformation',
        'MBMSServiceArea',
        'MBMSServiceType',
        'MBMSSessionIdentity',
        'MBMSTime',
        'MBMSUserServiceType',
        'MCC-MNC',
        'MessageClass',
        'MessageReference',
        'MSCAddress',
        'MscNo',
        'MSISDN',
        'MSTimeZone',
        'NodeID',
        'NodeAddress',
        'PDPAddressPrefixLength',
        'PDPAddress',
        'PLMN-Id',
        'PositioningData',
        'PriorityType',
        'RANNASCause',
        'RATType',
        'RecordingEntity',
        'RecordType',
        'RequiredMBMSBearerCapabilities',
        'RoutingAreaCode',
        'SCSASAddress',
        'Session-Id',
        'ServiceContextID',
        'ServiceSpecificInfo',
        'SMSResult',
        'SmsTpDestinationNumber',
        'SubscriberEquipmentNumber',
        'SubscriberEquipmentType',
        'SubscriptionID',
        'SubscriptionIDType',
        'SystemType',
        'ThreeGPPPSDataOffStatus',
        'TimeStamp',
        'TMGI',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BCDDirectoryNumber >-----#
    BCDDirectoryNumber = OCT_STR(name='BCDDirectoryNumber', mode=MODE_TYPE)
    
    #-----< CallDuration >-----#
    CallDuration = INT(name='CallDuration', mode=MODE_TYPE)
    
    #-----< CalledNumber >-----#
    CalledNumber = OCT_STR(name='CalledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< CallingNumber >-----#
    CallingNumber = OCT_STR(name='CallingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< CellId >-----#
    CellId = OCT_STR(name='CellId', mode=MODE_TYPE)
    CellId._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ChargeIndicator >-----#
    ChargeIndicator = INT(name='ChargeIndicator', mode=MODE_TYPE)
    ChargeIndicator._cont = ASN1Dict([('noCharge', 0), ('charge', 1)])
    
    #-----< CauseForRecClosing >-----#
    CauseForRecClosing = INT(name='CauseForRecClosing', mode=MODE_TYPE)
    CauseForRecClosing._cont = ASN1Dict([('normalRelease', 0), ('partialRecord', 1), ('abnormalRelease', 4), ('cAMELInitCallRelease', 5), ('volumeLimit', 16), ('timeLimit', 17), ('servingNodeChange', 18), ('maxChangeCond', 19), ('managementIntervention', 20), ('intraSGSNIntersystemChange', 21), ('rATChange', 22), ('mSTimeZoneChange', 23), ('sGSNPLMNIDChange', 24), ('sGWChange', 25), ('aPNAMBRChange', 26), ('mOExceptionDataCounterReceipt', 27), ('unauthorizedRequestingNetwork', 52), ('unauthorizedLCSClient', 53), ('positionMethodFailure', 54), ('unknownOrUnreachableLCSClient', 58), ('listofDownstreamNodeChange', 59)])
    
    #-----< CauseForTerm >-----#
    CauseForTerm = INT(name='CauseForTerm', mode=MODE_TYPE)
    CauseForTerm._cont = ASN1Dict([('normalRelease', 0), ('partialRecord', 1), ('partialRecordCallReestablishment', 2), ('unsuccessfulCallAttempt', 3), ('abnormalRelease', 4), ('cAMELInitCallRelease', 5), ('unauthorizedRequestingNetwork', 52), ('unauthorizedLCSClient', 53), ('positionMethodFailure', 54), ('unknownOrUnreachableLCSClient', 58)])
    
    #-----< ChargingID >-----#
    ChargingID = INT(name='ChargingID', mode=MODE_TYPE)
    ChargingID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< CivicAddressInformation >-----#
    CivicAddressInformation = OCT_STR(name='CivicAddressInformation', mode=MODE_TYPE)
    
    #-----< CNIPMulticastDistribution >-----#
    CNIPMulticastDistribution = ENUM(name='CNIPMulticastDistribution', mode=MODE_TYPE)
    CNIPMulticastDistribution._cont = ASN1Dict([('nO-IP-MULTICAST', 0), ('iP-MULTICAST', 1)])
    CNIPMulticastDistribution._ext = None
    
    #-----< DataVolumeOctets >-----#
    DataVolumeOctets = INT(name='DataVolumeOctets', mode=MODE_TYPE)
    
    #-----< DynamicAddressFlag >-----#
    DynamicAddressFlag = BOOL(name='DynamicAddressFlag', mode=MODE_TYPE)
    
    #-----< Diagnostics >-----#
    Diagnostics = CHOICE(name='Diagnostics', mode=MODE_TYPE)
    _Diagnostics_gsm0408Cause = INT(name='gsm0408Cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Diagnostics_gsm0902MapErrorValue = INT(name='gsm0902MapErrorValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Diagnostics_itu_tQ767Cause = INT(name='itu-tQ767Cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Diagnostics_networkSpecificCause = SEQ(name='networkSpecificCause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    _Diagnostics_manufacturerSpecificCause = SEQ(name='manufacturerSpecificCause', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    _Diagnostics_positionMethodFailureCause = ENUM(name='positionMethodFailureCause', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'PositionMethodFailure-Diagnostic')))
    _Diagnostics_unauthorizedLCSClientCause = ENUM(name='unauthorizedLCSClientCause', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnauthorizedLCSClient-Diagnostic')))
    _Diagnostics_diameterResultCodeAndExperimentalResult = INT(name='diameterResultCodeAndExperimentalResult', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Diagnostics._cont = ASN1Dict([
        ('gsm0408Cause', _Diagnostics_gsm0408Cause),
        ('gsm0902MapErrorValue', _Diagnostics_gsm0902MapErrorValue),
        ('itu-tQ767Cause', _Diagnostics_itu_tQ767Cause),
        ('networkSpecificCause', _Diagnostics_networkSpecificCause),
        ('manufacturerSpecificCause', _Diagnostics_manufacturerSpecificCause),
        ('positionMethodFailureCause', _Diagnostics_positionMethodFailureCause),
        ('unauthorizedLCSClientCause', _Diagnostics_unauthorizedLCSClientCause),
        ('diameterResultCodeAndExperimentalResult', _Diagnostics_diameterResultCodeAndExperimentalResult),
        ])
    Diagnostics._ext = None
    
    #-----< DiameterIdentity >-----#
    DiameterIdentity = OCT_STR(name='DiameterIdentity', mode=MODE_TYPE)
    
    #-----< EnhancedDiagnostics >-----#
    EnhancedDiagnostics = SEQ(name='EnhancedDiagnostics', mode=MODE_TYPE)
    _EnhancedDiagnostics_rANNASCause = SEQ_OF(name='rANNASCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EnhancedDiagnostics_rANNASCause__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'RANNASCause')))
    _EnhancedDiagnostics_rANNASCause._cont = __EnhancedDiagnostics_rANNASCause__item_
    EnhancedDiagnostics._cont = ASN1Dict([
        ('rANNASCause', _EnhancedDiagnostics_rANNASCause),
        ])
    EnhancedDiagnostics._ext = None
    
    #-----< GSNAddress >-----#
    GSNAddress = CHOICE(name='GSNAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    
    #-----< InvolvedParty >-----#
    InvolvedParty = CHOICE(name='InvolvedParty', mode=MODE_TYPE)
    _InvolvedParty_sIP_URI = STR_GRAPH(name='sIP-URI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_tEL_URI = STR_GRAPH(name='tEL-URI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_uRN = STR_GRAPH(name='uRN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_iSDN_E164 = STR_GRAPH(name='iSDN-E164', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_externalId = STR_UTF8(name='externalId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    InvolvedParty._cont = ASN1Dict([
        ('sIP-URI', _InvolvedParty_sIP_URI),
        ('tEL-URI', _InvolvedParty_tEL_URI),
        ('uRN', _InvolvedParty_uRN),
        ('iSDN-E164', _InvolvedParty_iSDN_E164),
        ('externalId', _InvolvedParty_externalId),
        ])
    InvolvedParty._ext = None
    
    #-----< IPAddress >-----#
    IPAddress = CHOICE(name='IPAddress', mode=MODE_TYPE)
    _IPAddress_iPBinaryAddress = CHOICE(name='iPBinaryAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinaryAddress')))
    _IPAddress_iPTextRepresentedAddress = CHOICE(name='iPTextRepresentedAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPTextRepresentedAddress')))
    IPAddress._cont = ASN1Dict([
        ('iPBinaryAddress', _IPAddress_iPBinaryAddress),
        ('iPTextRepresentedAddress', _IPAddress_iPTextRepresentedAddress),
        ])
    IPAddress._ext = None
    
    #-----< IPBinaryAddress >-----#
    IPBinaryAddress = CHOICE(name='IPBinaryAddress', mode=MODE_TYPE)
    _IPBinaryAddress_iPBinV4Address = OCT_STR(name='iPBinV4Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV4Address')))
    _IPBinaryAddress_iPBinV6Address = CHOICE(name='iPBinV6Address', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6AddressWithOrWithoutPrefixLength')))
    IPBinaryAddress._cont = ASN1Dict([
        ('iPBinV4Address', _IPBinaryAddress_iPBinV4Address),
        ('iPBinV6Address', _IPBinaryAddress_iPBinV6Address),
        ])
    IPBinaryAddress._ext = None
    
    #-----< IPBinV4Address >-----#
    IPBinV4Address = OCT_STR(name='IPBinV4Address', mode=MODE_TYPE)
    IPBinV4Address._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IPBinV6Address >-----#
    IPBinV6Address = OCT_STR(name='IPBinV6Address', mode=MODE_TYPE)
    IPBinV6Address._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IPBinV6AddressWithOrWithoutPrefixLength >-----#
    IPBinV6AddressWithOrWithoutPrefixLength = CHOICE(name='IPBinV6AddressWithOrWithoutPrefixLength', mode=MODE_TYPE)
    _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6Address = OCT_STR(name='iPBinV6Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6Address')))
    _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6AddressWithPrefix = SEQ(name='iPBinV6AddressWithPrefix', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6AddressWithPrefixLength')))
    IPBinV6AddressWithOrWithoutPrefixLength._cont = ASN1Dict([
        ('iPBinV6Address', _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6Address),
        ('iPBinV6AddressWithPrefix', _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6AddressWithPrefix),
        ])
    IPBinV6AddressWithOrWithoutPrefixLength._ext = None
    
    #-----< IPBinV6AddressWithPrefixLength >-----#
    IPBinV6AddressWithPrefixLength = SEQ(name='IPBinV6AddressWithPrefixLength', mode=MODE_TYPE)
    _IPBinV6AddressWithPrefixLength_iPBinV6Address = OCT_STR(name='iPBinV6Address', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6Address')))
    _IPBinV6AddressWithPrefixLength_pDPAddressPrefixLength = INT(name='pDPAddressPrefixLength', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddressPrefixLength')), default=64)
    IPBinV6AddressWithPrefixLength._cont = ASN1Dict([
        ('iPBinV6Address', _IPBinV6AddressWithPrefixLength_iPBinV6Address),
        ('pDPAddressPrefixLength', _IPBinV6AddressWithPrefixLength_pDPAddressPrefixLength),
        ])
    IPBinV6AddressWithPrefixLength._ext = None
    
    #-----< IPTextRepresentedAddress >-----#
    IPTextRepresentedAddress = CHOICE(name='IPTextRepresentedAddress', mode=MODE_TYPE)
    _IPTextRepresentedAddress_iPTextV4Address = STR_IA5(name='iPTextV4Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPTextRepresentedAddress_iPTextV4Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=15)], ev=None, er=[])
    _IPTextRepresentedAddress_iPTextV6Address = STR_IA5(name='iPTextV6Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPTextRepresentedAddress_iPTextV6Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=45)], ev=None, er=[])
    IPTextRepresentedAddress._cont = ASN1Dict([
        ('iPTextV4Address', _IPTextRepresentedAddress_iPTextV4Address),
        ('iPTextV6Address', _IPTextRepresentedAddress_iPTextV6Address),
        ])
    IPTextRepresentedAddress._ext = None
    
    #-----< LCSCause >-----#
    LCSCause = OCT_STR(name='LCSCause', mode=MODE_TYPE)
    LCSCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< LCSClientIdentity >-----#
    LCSClientIdentity = SEQ(name='LCSClientIdentity', mode=MODE_TYPE)
    _LCSClientIdentity_lcsClientExternalID = SEQ(name='lcsClientExternalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LCSClientIdentity_lcsClientDialedByMS = OCT_STR(name='lcsClientDialedByMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _LCSClientIdentity_lcsClientInternalID = ENUM(name='lcsClientInternalID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')), opt=True)
    LCSClientIdentity._cont = ASN1Dict([
        ('lcsClientExternalID', _LCSClientIdentity_lcsClientExternalID),
        ('lcsClientDialedByMS', _LCSClientIdentity_lcsClientDialedByMS),
        ('lcsClientInternalID', _LCSClientIdentity_lcsClientInternalID),
        ])
    LCSClientIdentity._ext = None
    
    #-----< LCSQoSInfo >-----#
    LCSQoSInfo = OCT_STR(name='LCSQoSInfo', mode=MODE_TYPE)
    LCSQoSInfo._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< LevelOfCAMELService >-----#
    LevelOfCAMELService = BIT_STR(name='LevelOfCAMELService', mode=MODE_TYPE)
    LevelOfCAMELService._cont = ASN1Dict([('basic', 0), ('callDurationSupervision', 1), ('onlineCharging', 2)])
    
    #-----< LocalSequenceNumber >-----#
    LocalSequenceNumber = INT(name='LocalSequenceNumber', mode=MODE_TYPE)
    LocalSequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< LocationAreaAndCell >-----#
    LocationAreaAndCell = SEQ(name='LocationAreaAndCell', mode=MODE_TYPE)
    _LocationAreaAndCell_locationAreaCode = OCT_STR(name='locationAreaCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')))
    _LocationAreaAndCell_cellId = OCT_STR(name='cellId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')))
    _LocationAreaAndCell_mCC_MNC = OCT_STR(name='mCC-MNC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MCC-MNC')), opt=True)
    LocationAreaAndCell._cont = ASN1Dict([
        ('locationAreaCode', _LocationAreaAndCell_locationAreaCode),
        ('cellId', _LocationAreaAndCell_cellId),
        ('mCC-MNC', _LocationAreaAndCell_mCC_MNC),
        ])
    LocationAreaAndCell._ext = None
    
    #-----< LocationAreaCode >-----#
    LocationAreaCode = OCT_STR(name='LocationAreaCode', mode=MODE_TYPE)
    LocationAreaCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ManagementExtensions >-----#
    ManagementExtensions = SET_OF(name='ManagementExtensions', mode=MODE_TYPE)
    _ManagementExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    ManagementExtensions._cont = _ManagementExtensions__item_
    
    #-----< MBMS2G3GIndicator >-----#
    MBMS2G3GIndicator = ENUM(name='MBMS2G3GIndicator', mode=MODE_TYPE)
    MBMS2G3GIndicator._cont = ASN1Dict([('twoG', 0), ('threeG', 1), ('twoG-AND-threeG', 2)])
    MBMS2G3GIndicator._ext = None
    
    #-----< MBMSInformation >-----#
    MBMSInformation = SET(name='MBMSInformation', mode=MODE_TYPE)
    _MBMSInformation_tMGI = OCT_STR(name='tMGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TMGI')), opt=True)
    _MBMSInformation_mBMSSessionIdentity = OCT_STR(name='mBMSSessionIdentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSSessionIdentity')), opt=True)
    _MBMSInformation_mBMSServiceType = ENUM(name='mBMSServiceType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSServiceType')), opt=True)
    _MBMSInformation_mBMSUserServiceType = ENUM(name='mBMSUserServiceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSUserServiceType')), opt=True)
    _MBMSInformation_mBMS2G3GIndicator = ENUM(name='mBMS2G3GIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMS2G3GIndicator')), opt=True)
    _MBMSInformation_fileRepairSupported = BOOL(name='fileRepairSupported', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSInformation_rAI = OCT_STR(name='rAI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _MBMSInformation_mBMSServiceArea = OCT_STR(name='mBMSServiceArea', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSServiceArea')), opt=True)
    _MBMSInformation_requiredMBMSBearerCaps = OCT_STR(name='requiredMBMSBearerCaps', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RequiredMBMSBearerCapabilities')), opt=True)
    _MBMSInformation_mBMSGWAddress = CHOICE(name='mBMSGWAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _MBMSInformation_cNIPMulticastDistribution = ENUM(name='cNIPMulticastDistribution', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CNIPMulticastDistribution')), opt=True)
    _MBMSInformation_mBMSDataTransferStart = OCT_STR(name='mBMSDataTransferStart', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSTime')), opt=True)
    _MBMSInformation_mBMSDataTransferStop = OCT_STR(name='mBMSDataTransferStop', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSTime')), opt=True)
    MBMSInformation._cont = ASN1Dict([
        ('tMGI', _MBMSInformation_tMGI),
        ('mBMSSessionIdentity', _MBMSInformation_mBMSSessionIdentity),
        ('mBMSServiceType', _MBMSInformation_mBMSServiceType),
        ('mBMSUserServiceType', _MBMSInformation_mBMSUserServiceType),
        ('mBMS2G3GIndicator', _MBMSInformation_mBMS2G3GIndicator),
        ('fileRepairSupported', _MBMSInformation_fileRepairSupported),
        ('rAI', _MBMSInformation_rAI),
        ('mBMSServiceArea', _MBMSInformation_mBMSServiceArea),
        ('requiredMBMSBearerCaps', _MBMSInformation_requiredMBMSBearerCaps),
        ('mBMSGWAddress', _MBMSInformation_mBMSGWAddress),
        ('cNIPMulticastDistribution', _MBMSInformation_cNIPMulticastDistribution),
        ('mBMSDataTransferStart', _MBMSInformation_mBMSDataTransferStart),
        ('mBMSDataTransferStop', _MBMSInformation_mBMSDataTransferStop),
        ])
    MBMSInformation._ext = None
    
    #-----< MBMSServiceArea >-----#
    MBMSServiceArea = OCT_STR(name='MBMSServiceArea', mode=MODE_TYPE)
    
    #-----< MBMSServiceType >-----#
    MBMSServiceType = ENUM(name='MBMSServiceType', mode=MODE_TYPE)
    MBMSServiceType._cont = ASN1Dict([('mULTICAST', 0), ('bROADCAST', 1)])
    MBMSServiceType._ext = None
    
    #-----< MBMSSessionIdentity >-----#
    MBMSSessionIdentity = OCT_STR(name='MBMSSessionIdentity', mode=MODE_TYPE)
    MBMSSessionIdentity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MBMSTime >-----#
    MBMSTime = OCT_STR(name='MBMSTime', mode=MODE_TYPE)
    MBMSTime._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MBMSUserServiceType >-----#
    MBMSUserServiceType = ENUM(name='MBMSUserServiceType', mode=MODE_TYPE)
    MBMSUserServiceType._cont = ASN1Dict([('dOWNLOAD', 0), ('sTREAMING', 1)])
    MBMSUserServiceType._ext = None
    
    #-----< MCC-MNC >-----#
    MCC_MNC = OCT_STR(name='MCC-MNC', mode=MODE_TYPE)
    MCC_MNC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< MessageClass >-----#
    MessageClass = ENUM(name='MessageClass', mode=MODE_TYPE)
    MessageClass._cont = ASN1Dict([('personal', 0), ('advertisement', 1), ('information-service', 2), ('auto', 3)])
    MessageClass._ext = None
    
    #-----< MessageReference >-----#
    MessageReference = OCT_STR(name='MessageReference', mode=MODE_TYPE)
    
    #-----< MSCAddress >-----#
    MSCAddress = OCT_STR(name='MSCAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< MscNo >-----#
    MscNo = OCT_STR(name='MscNo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< MSISDN >-----#
    MSISDN = OCT_STR(name='MSISDN', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< MSTimeZone >-----#
    MSTimeZone = OCT_STR(name='MSTimeZone', mode=MODE_TYPE)
    MSTimeZone._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< NodeID >-----#
    NodeID = STR_IA5(name='NodeID', mode=MODE_TYPE)
    NodeID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< NodeAddress >-----#
    NodeAddress = CHOICE(name='NodeAddress', mode=MODE_TYPE)
    _NodeAddress_iPAddress = CHOICE(name='iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _NodeAddress_domainName = STR_GRAPH(name='domainName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    NodeAddress._cont = ASN1Dict([
        ('iPAddress', _NodeAddress_iPAddress),
        ('domainName', _NodeAddress_domainName),
        ])
    NodeAddress._ext = None
    
    #-----< PDPAddressPrefixLength >-----#
    PDPAddressPrefixLength = INT(name='PDPAddressPrefixLength', mode=MODE_TYPE)
    PDPAddressPrefixLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PDPAddress >-----#
    PDPAddress = CHOICE(name='PDPAddress', mode=MODE_TYPE)
    _PDPAddress_iPAddress = CHOICE(name='iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    PDPAddress._cont = ASN1Dict([
        ('iPAddress', _PDPAddress_iPAddress),
        ])
    PDPAddress._ext = None
    
    #-----< PLMN-Id >-----#
    PLMN_Id = OCT_STR(name='PLMN-Id', mode=MODE_TYPE)
    PLMN_Id._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PositioningData >-----#
    PositioningData = OCT_STR(name='PositioningData', mode=MODE_TYPE)
    PositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=33)], ev=None, er=[])
    
    #-----< PriorityType >-----#
    PriorityType = ENUM(name='PriorityType', mode=MODE_TYPE)
    PriorityType._cont = ASN1Dict([('low', 0), ('normal', 1), ('high', 2)])
    PriorityType._ext = None
    
    #-----< RANNASCause >-----#
    RANNASCause = OCT_STR(name='RANNASCause', mode=MODE_TYPE)
    
    #-----< RATType >-----#
    RATType = INT(name='RATType', mode=MODE_TYPE)
    RATType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RecordingEntity >-----#
    RecordingEntity = OCT_STR(name='RecordingEntity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< RecordType >-----#
    RecordType = INT(name='RecordType', mode=MODE_TYPE)
    RecordType._cont = ASN1Dict([('moCallRecord', 0), ('mtCallRecord', 1), ('roamingRecord', 2), ('incGatewayRecord', 3), ('outGatewayRecord', 4), ('transitCallRecord', 5), ('moSMSRecord', 6), ('mtSMSRecord', 7), ('moSMSIWRecord', 8), ('mtSMSGWRecord', 9), ('ssActionRecord', 10), ('hlrIntRecord', 11), ('locUpdateHLRRecord', 12), ('locUpdateVLRRecord', 13), ('commonEquipRecord', 14), ('moTraceRecord', 15), ('mtTraceRecord', 16), ('termCAMELRecord', 17), ('sgsnPDPRecord', 18), ('sgsnMMRecord', 20), ('sgsnSMORecord', 21), ('sgsnSMTRecord', 22), ('mtLCSRecord', 23), ('moLCSRecord', 24), ('niLCSRecord', 25), ('sgsnMTLCSRecord', 26), ('sgsnMOLCSRecord', 27), ('sgsnNILCSRecord', 28), ('mMO1SRecord', 30), ('mMO4FRqRecord', 31), ('mMO4FRsRecord', 32), ('mMO4DRecord', 33), ('mMO1DRecord', 34), ('mMO4RRecord', 35), ('mMO1RRecord', 36), ('mMOMDRecord', 37), ('mMR4FRecord', 38), ('mMR1NRqRecord', 39), ('mMR1NRsRecord', 40), ('mMR1RtRecord', 41), ('mMR1AFRecord', 42), ('mMR4DRqRecord', 43), ('mMR4DRsRecord', 44), ('mMR1RRRecord', 45), ('mMR4RRqRecord', 46), ('mMR4RRsRecord', 47), ('mMRMDRecord', 48), ('mMFRecord', 49), ('mMBx1SRecord', 50), ('mMBx1VRecord', 51), ('mMBx1URecord', 52), ('mMBx1DRecord', 53), ('mM7SRecord', 54), ('mM7DRqRecord', 55), ('mM7DRsRecord', 56), ('mM7CRecord', 57), ('mM7RRecord', 58), ('mM7DRRqRecord', 59), ('mM7DRRsRecord', 60), ('mM7RRqRecord', 61), ('mM7RRsRecord', 62), ('sCSCFRecord', 63), ('pCSCFRecord', 64), ('iCSCFRecord', 65), ('mRFCRecord', 66), ('mGCFRecord', 67), ('bGCFRecord', 68), ('aSRecord', 69), ('eCSCFRecord', 70), ('iBCFRecord', 82), ('tRFRecord', 89), ('tFRecord', 90), ('aTCFRecord', 91), ('lCSGMORecord', 71), ('lCSRGMTRecord', 72), ('lCSHGMTRecord', 73), ('lCSVGMTRecord', 74), ('lCSGNIRecord', 75), ('sgsnMBMSRecord', 76), ('ggsnMBMSRecord', 77), ('gwMBMSRecord', 86), ('sUBBMSCRecord', 78), ('cONTENTBMSCRecord', 79), ('pPFRecord', 80), ('cPFRecord', 81), ('sGWRecord', 84), ('pGWRecord', 85), ('tDFRecord', 92), ('iPERecord', 95), ('ePDGRecord', 96), ('tWAGRecord', 97), ('mMTelRecord', 83), ('mSCsRVCCRecord', 87), ('mMTRFRecord', 88), ('iCSRegisterRecord', 99), ('sCSMORecord', 93), ('sCSMTRecord', 94), ('pFDDRecord', 100), ('pFEDRecord', 101), ('pFDCRecord', 102), ('mECORecord', 103), ('mERERecord', 104), ('cPDTSCERecord', 105), ('cPDTSNNRecord', 106), ('sCDVTT4Record', 110), ('sCSMOT4Record', 111), ('iSMSMORecord', 112), ('iSMSMTRecord', 113), ('eASCERecord', 120), ('chargingFunctionRecord', 200)])
    
    #-----< RequiredMBMSBearerCapabilities >-----#
    RequiredMBMSBearerCapabilities = OCT_STR(name='RequiredMBMSBearerCapabilities', mode=MODE_TYPE)
    RequiredMBMSBearerCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=14)], ev=None, er=[])
    
    #-----< RoutingAreaCode >-----#
    RoutingAreaCode = OCT_STR(name='RoutingAreaCode', mode=MODE_TYPE)
    RoutingAreaCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SCSASAddress >-----#
    SCSASAddress = SET(name='SCSASAddress', mode=MODE_TYPE)
    _SCSASAddress_sCSAddress = CHOICE(name='sCSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _SCSASAddress_sCSRealm = OCT_STR(name='sCSRealm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')))
    SCSASAddress._cont = ASN1Dict([
        ('sCSAddress', _SCSASAddress_sCSAddress),
        ('sCSRealm', _SCSASAddress_sCSRealm),
        ])
    SCSASAddress._ext = None
    
    #-----< Session-Id >-----#
    Session_Id = STR_GRAPH(name='Session-Id', mode=MODE_TYPE)
    
    #-----< ServiceContextID >-----#
    ServiceContextID = STR_UTF8(name='ServiceContextID', mode=MODE_TYPE)
    
    #-----< ServiceSpecificInfo >-----#
    ServiceSpecificInfo = SEQ(name='ServiceSpecificInfo', mode=MODE_TYPE)
    _ServiceSpecificInfo_serviceSpecificData = STR_GRAPH(name='serviceSpecificData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceSpecificInfo_serviceSpecificType = INT(name='serviceSpecificType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ServiceSpecificInfo._cont = ASN1Dict([
        ('serviceSpecificData', _ServiceSpecificInfo_serviceSpecificData),
        ('serviceSpecificType', _ServiceSpecificInfo_serviceSpecificType),
        ])
    ServiceSpecificInfo._ext = None
    
    #-----< SMSResult >-----#
    SMSResult = CHOICE(name='SMSResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< SmsTpDestinationNumber >-----#
    SmsTpDestinationNumber = OCT_STR(name='SmsTpDestinationNumber', mode=MODE_TYPE)
    
    #-----< SubscriberEquipmentNumber >-----#
    SubscriberEquipmentNumber = SET(name='SubscriberEquipmentNumber', mode=MODE_TYPE)
    _SubscriberEquipmentNumber_subscriberEquipmentNumberType = ENUM(name='subscriberEquipmentNumberType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentType')))
    _SubscriberEquipmentNumber_subscriberEquipmentNumberData = OCT_STR(name='subscriberEquipmentNumberData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriberEquipmentNumber._cont = ASN1Dict([
        ('subscriberEquipmentNumberType', _SubscriberEquipmentNumber_subscriberEquipmentNumberType),
        ('subscriberEquipmentNumberData', _SubscriberEquipmentNumber_subscriberEquipmentNumberData),
        ])
    SubscriberEquipmentNumber._ext = None
    
    #-----< SubscriberEquipmentType >-----#
    SubscriberEquipmentType = ENUM(name='SubscriberEquipmentType', mode=MODE_TYPE)
    SubscriberEquipmentType._cont = ASN1Dict([('iMEISV', 0), ('mAC', 1), ('eUI64', 2), ('modifiedEUI64', 3)])
    SubscriberEquipmentType._ext = None
    
    #-----< SubscriptionID >-----#
    SubscriptionID = SET(name='SubscriptionID', mode=MODE_TYPE)
    _SubscriptionID_subscriptionIDType = ENUM(name='subscriptionIDType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionIDType')))
    _SubscriptionID_subscriptionIDData = STR_UTF8(name='subscriptionIDData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriptionID._cont = ASN1Dict([
        ('subscriptionIDType', _SubscriptionID_subscriptionIDType),
        ('subscriptionIDData', _SubscriptionID_subscriptionIDData),
        ])
    SubscriptionID._ext = None
    
    #-----< SubscriptionIDType >-----#
    SubscriptionIDType = ENUM(name='SubscriptionIDType', mode=MODE_TYPE)
    SubscriptionIDType._cont = ASN1Dict([('eND-USER-E164', 0), ('eND-USER-IMSI', 1), ('eND-USER-SIP-URI', 2), ('eND-USER-NAI', 3), ('eND-USER-PRIVATE', 4)])
    SubscriptionIDType._ext = None
    
    #-----< SystemType >-----#
    SystemType = ENUM(name='SystemType', mode=MODE_TYPE)
    SystemType._cont = ASN1Dict([('unknown', 0), ('iuUTRAN', 1), ('gERAN', 2)])
    SystemType._ext = None
    
    #-----< ThreeGPPPSDataOffStatus >-----#
    ThreeGPPPSDataOffStatus = ENUM(name='ThreeGPPPSDataOffStatus', mode=MODE_TYPE)
    ThreeGPPPSDataOffStatus._cont = ASN1Dict([('active', 0), ('inactive', 1)])
    ThreeGPPPSDataOffStatus._ext = None
    
    #-----< TimeStamp >-----#
    TimeStamp = OCT_STR(name='TimeStamp', mode=MODE_TYPE)
    TimeStamp._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    
    #-----< TMGI >-----#
    TMGI = OCT_STR(name='TMGI', mode=MODE_TYPE)
    
    _all_ = [
        BCDDirectoryNumber,
        CallDuration,
        CalledNumber,
        CallingNumber,
        CellId,
        ChargeIndicator,
        CauseForRecClosing,
        CauseForTerm,
        ChargingID,
        CivicAddressInformation,
        CNIPMulticastDistribution,
        DataVolumeOctets,
        DynamicAddressFlag,
        _Diagnostics_gsm0408Cause,
        _Diagnostics_gsm0902MapErrorValue,
        _Diagnostics_itu_tQ767Cause,
        _Diagnostics_networkSpecificCause,
        _Diagnostics_manufacturerSpecificCause,
        _Diagnostics_positionMethodFailureCause,
        _Diagnostics_unauthorizedLCSClientCause,
        _Diagnostics_diameterResultCodeAndExperimentalResult,
        Diagnostics,
        DiameterIdentity,
        __EnhancedDiagnostics_rANNASCause__item_,
        _EnhancedDiagnostics_rANNASCause,
        EnhancedDiagnostics,
        GSNAddress,
        _InvolvedParty_sIP_URI,
        _InvolvedParty_tEL_URI,
        _InvolvedParty_uRN,
        _InvolvedParty_iSDN_E164,
        _InvolvedParty_externalId,
        InvolvedParty,
        _IPAddress_iPBinaryAddress,
        _IPAddress_iPTextRepresentedAddress,
        IPAddress,
        _IPBinaryAddress_iPBinV4Address,
        _IPBinaryAddress_iPBinV6Address,
        IPBinaryAddress,
        IPBinV4Address,
        IPBinV6Address,
        _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6Address,
        _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6AddressWithPrefix,
        IPBinV6AddressWithOrWithoutPrefixLength,
        _IPBinV6AddressWithPrefixLength_iPBinV6Address,
        _IPBinV6AddressWithPrefixLength_pDPAddressPrefixLength,
        IPBinV6AddressWithPrefixLength,
        _IPTextRepresentedAddress_iPTextV4Address,
        _IPTextRepresentedAddress_iPTextV6Address,
        IPTextRepresentedAddress,
        LCSCause,
        _LCSClientIdentity_lcsClientExternalID,
        _LCSClientIdentity_lcsClientDialedByMS,
        _LCSClientIdentity_lcsClientInternalID,
        LCSClientIdentity,
        LCSQoSInfo,
        LevelOfCAMELService,
        LocalSequenceNumber,
        _LocationAreaAndCell_locationAreaCode,
        _LocationAreaAndCell_cellId,
        _LocationAreaAndCell_mCC_MNC,
        LocationAreaAndCell,
        LocationAreaCode,
        _ManagementExtensions__item_,
        ManagementExtensions,
        MBMS2G3GIndicator,
        _MBMSInformation_tMGI,
        _MBMSInformation_mBMSSessionIdentity,
        _MBMSInformation_mBMSServiceType,
        _MBMSInformation_mBMSUserServiceType,
        _MBMSInformation_mBMS2G3GIndicator,
        _MBMSInformation_fileRepairSupported,
        _MBMSInformation_rAI,
        _MBMSInformation_mBMSServiceArea,
        _MBMSInformation_requiredMBMSBearerCaps,
        _MBMSInformation_mBMSGWAddress,
        _MBMSInformation_cNIPMulticastDistribution,
        _MBMSInformation_mBMSDataTransferStart,
        _MBMSInformation_mBMSDataTransferStop,
        MBMSInformation,
        MBMSServiceArea,
        MBMSServiceType,
        MBMSSessionIdentity,
        MBMSTime,
        MBMSUserServiceType,
        MCC_MNC,
        MessageClass,
        MessageReference,
        MSCAddress,
        MscNo,
        MSISDN,
        MSTimeZone,
        NodeID,
        _NodeAddress_iPAddress,
        _NodeAddress_domainName,
        NodeAddress,
        PDPAddressPrefixLength,
        _PDPAddress_iPAddress,
        PDPAddress,
        PLMN_Id,
        PositioningData,
        PriorityType,
        RANNASCause,
        RATType,
        RecordingEntity,
        RecordType,
        RequiredMBMSBearerCapabilities,
        RoutingAreaCode,
        _SCSASAddress_sCSAddress,
        _SCSASAddress_sCSRealm,
        SCSASAddress,
        Session_Id,
        ServiceContextID,
        _ServiceSpecificInfo_serviceSpecificData,
        _ServiceSpecificInfo_serviceSpecificType,
        ServiceSpecificInfo,
        SMSResult,
        SmsTpDestinationNumber,
        _SubscriberEquipmentNumber_subscriberEquipmentNumberType,
        _SubscriberEquipmentNumber_subscriberEquipmentNumberData,
        SubscriberEquipmentNumber,
        SubscriberEquipmentType,
        _SubscriptionID_subscriptionIDType,
        _SubscriptionID_subscriptionIDData,
        SubscriptionID,
        SubscriptionIDType,
        SystemType,
        ThreeGPPPSDataOffStatus,
        TimeStamp,
        TMGI,
    ]

class GPRSChargingDataTypes:

    _name_  = 'GPRSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 2, 0, 1]
    
    _obj_ = [
        'GPRSRecord',
        'SGWRecord',
        'PGWRecord',
        'TDFRecord',
        'IPERecord',
        'EPDGRecord',
        'TWAGRecord',
        'SGSNMMRecord',
        'SGSNPDPRecord',
        'SGSNSMORecord',
        'SGSNSMTRecord',
        'SGSNMTLCSRecord',
        'SGSNMOLCSRecord',
        'SGSNNILCSRecord',
        'SGSNMBMSRecord',
        'GGSNMBMSRecord',
        'GWMBMSRecord',
        'AccessAvailabilityChangeReason',
        'AccessLineIdentifier',
        'AccessPointNameNI',
        'AccessPointNameOI',
        'ADCRuleBaseName',
        'AdditionalExceptionReports',
        'AFChargingIdentifier',
        'AFRecordInformation',
        'APNRateControl',
        'APNRateControlParameters',
        'APNSelectionMode',
        'CalleePartyInformation',
        'CAMELAccessPointNameNI',
        'CAMELAccessPointNameOI',
        'CAMELInformationMM',
        'CAMELInformationPDP',
        'CAMELInformationSMS',
        'ChangeCondition',
        'ChangeOfCharCondition',
        'ChangeOfMBMSCondition',
        'ChangeOfServiceCondition',
        'ChangeLocation',
        'ChargingCharacteristics',
        'ChargingPerIPCANSessionIndicator',
        'ChargingRuleBaseName',
        'ChChSelectionMode',
        'CNOperatorSelectionEntity',
        'CPCIoTEPSOptimisationIndicator',
        'CSGAccessMode',
        'CSGId',
        'CTEID',
        'DataVolumeGPRS',
        'DataVolumeMBMS',
        'EPCQoSInformation',
        'EventBasedChargingInformation',
        'FailureHandlingContinue',
        'FFDAppendIndicator',
        'FixedSubsID',
        'FixedUserLocationInformation',
        'Flows',
        'FreeFormatData',
        'MOExceptionDataCounter',
        'MSNetworkCapability',
        'NBIFOMMode',
        'NBIFOMSupport',
        'NetworkInitiatedPDPContext',
        'NumberOfDPEncountered',
        'PDPType',
        'PDPPDNTypeExtension',
        'PresenceReportingAreaElementsList',
        'PresenceReportingAreaInfo',
        'PresenceReportingAreaNode',
        'PresenceReportingAreaStatus',
        'PSFurnishChargingInformation',
        'QoSInformation',
        'RANSecondaryRATUsageReport',
        'RateControlTimeUnit',
        'RatingGroupId',
        'RelatedChangeOfCharCondition',
        'RelatedChangeOfServiceCondition',
        'ResultCode',
        'SecondaryRATType',
        'ServiceConditionChange',
        'SCFAddress',
        'ServiceIdentifier',
        'ServingNodeType',
        'ServingPLMNRateControl',
        'SGiPtPTunnellingMethod',
        'SGSNChange',
        'SGWChange',
        'TimeQuotaMechanism',
        'TimeQuotaType',
        'TrafficSteeringPolicyIDDownlink',
        'TrafficSteeringPolicyIDUplink',
        'TWANUserLocationInfo',
        'UNIPDUCPOnlyFlag',
        'UserCSGInformation',
        'UWANUserLocationInfo',
        'VoLTEInformation',
        'WLANOperatorId',
        ]
    _type_ = [
        'GPRSRecord',
        'SGWRecord',
        'PGWRecord',
        'TDFRecord',
        'IPERecord',
        'EPDGRecord',
        'TWAGRecord',
        'SGSNMMRecord',
        'SGSNPDPRecord',
        'SGSNSMORecord',
        'SGSNSMTRecord',
        'SGSNMTLCSRecord',
        'SGSNMOLCSRecord',
        'SGSNNILCSRecord',
        'SGSNMBMSRecord',
        'GGSNMBMSRecord',
        'GWMBMSRecord',
        'AccessAvailabilityChangeReason',
        'AccessLineIdentifier',
        'AccessPointNameNI',
        'AccessPointNameOI',
        'ADCRuleBaseName',
        'AdditionalExceptionReports',
        'AFChargingIdentifier',
        'AFRecordInformation',
        'APNRateControl',
        'APNRateControlParameters',
        'APNSelectionMode',
        'CalleePartyInformation',
        'CAMELAccessPointNameNI',
        'CAMELAccessPointNameOI',
        'CAMELInformationMM',
        'CAMELInformationPDP',
        'CAMELInformationSMS',
        'ChangeCondition',
        'ChangeOfCharCondition',
        'ChangeOfMBMSCondition',
        'ChangeOfServiceCondition',
        'ChangeLocation',
        'ChargingCharacteristics',
        'ChargingPerIPCANSessionIndicator',
        'ChargingRuleBaseName',
        'ChChSelectionMode',
        'CNOperatorSelectionEntity',
        'CPCIoTEPSOptimisationIndicator',
        'CSGAccessMode',
        'CSGId',
        'CTEID',
        'DataVolumeGPRS',
        'DataVolumeMBMS',
        'EPCQoSInformation',
        'EventBasedChargingInformation',
        'FailureHandlingContinue',
        'FFDAppendIndicator',
        'FixedSubsID',
        'FixedUserLocationInformation',
        'Flows',
        'FreeFormatData',
        'MOExceptionDataCounter',
        'MSNetworkCapability',
        'NBIFOMMode',
        'NBIFOMSupport',
        'NetworkInitiatedPDPContext',
        'NumberOfDPEncountered',
        'PDPType',
        'PDPPDNTypeExtension',
        'PresenceReportingAreaElementsList',
        'PresenceReportingAreaInfo',
        'PresenceReportingAreaNode',
        'PresenceReportingAreaStatus',
        'PSFurnishChargingInformation',
        'QoSInformation',
        'RANSecondaryRATUsageReport',
        'RateControlTimeUnit',
        'RatingGroupId',
        'RelatedChangeOfCharCondition',
        'RelatedChangeOfServiceCondition',
        'ResultCode',
        'SecondaryRATType',
        'ServiceConditionChange',
        'SCFAddress',
        'ServiceIdentifier',
        'ServingNodeType',
        'ServingPLMNRateControl',
        'SGiPtPTunnellingMethod',
        'SGSNChange',
        'SGWChange',
        'TimeQuotaMechanism',
        'TimeQuotaType',
        'TrafficSteeringPolicyIDDownlink',
        'TrafficSteeringPolicyIDUplink',
        'TWANUserLocationInfo',
        'UNIPDUCPOnlyFlag',
        'UserCSGInformation',
        'UWANUserLocationInfo',
        'VoLTEInformation',
        'WLANOperatorId',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< GPRSRecord >-----#
    GPRSRecord = CHOICE(name='GPRSRecord', mode=MODE_TYPE)
    _GPRSRecord_sgsnPDPRecord = SET(name='sgsnPDPRecord', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNPDPRecord')))
    _GPRSRecord_sgsnMMRecord = SET(name='sgsnMMRecord', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMMRecord')))
    _GPRSRecord_sgsnSMORecord = SET(name='sgsnSMORecord', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNSMORecord')))
    _GPRSRecord_sgsnSMTRecord = SET(name='sgsnSMTRecord', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNSMTRecord')))
    _GPRSRecord_sgsnMTLCSRecord = SET(name='sgsnMTLCSRecord', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMTLCSRecord')))
    _GPRSRecord_sgsnMOLCSRecord = SET(name='sgsnMOLCSRecord', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMOLCSRecord')))
    _GPRSRecord_sgsnNILCSRecord = SET(name='sgsnNILCSRecord', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNNILCSRecord')))
    _GPRSRecord_sgsnMBMSRecord = SET(name='sgsnMBMSRecord', mode=MODE_TYPE, tag=(76, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMBMSRecord')))
    _GPRSRecord_ggsnMBMSRecord = SET(name='ggsnMBMSRecord', mode=MODE_TYPE, tag=(77, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'GGSNMBMSRecord')))
    _GPRSRecord_sGWRecord = SET(name='sGWRecord', mode=MODE_TYPE, tag=(78, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWRecord')))
    _GPRSRecord_pGWRecord = SET(name='pGWRecord', mode=MODE_TYPE, tag=(79, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PGWRecord')))
    _GPRSRecord_gwMBMSRecord = SET(name='gwMBMSRecord', mode=MODE_TYPE, tag=(86, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'GWMBMSRecord')))
    _GPRSRecord_tDFRecord = SET(name='tDFRecord', mode=MODE_TYPE, tag=(92, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TDFRecord')))
    _GPRSRecord_iPERecord = SET(name='iPERecord', mode=MODE_TYPE, tag=(95, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'IPERecord')))
    _GPRSRecord_ePDGRecord = SET(name='ePDGRecord', mode=MODE_TYPE, tag=(96, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPDGRecord')))
    _GPRSRecord_tWAGRecord = SET(name='tWAGRecord', mode=MODE_TYPE, tag=(97, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWAGRecord')))
    GPRSRecord._cont = ASN1Dict([
        ('sgsnPDPRecord', _GPRSRecord_sgsnPDPRecord),
        ('sgsnMMRecord', _GPRSRecord_sgsnMMRecord),
        ('sgsnSMORecord', _GPRSRecord_sgsnSMORecord),
        ('sgsnSMTRecord', _GPRSRecord_sgsnSMTRecord),
        ('sgsnMTLCSRecord', _GPRSRecord_sgsnMTLCSRecord),
        ('sgsnMOLCSRecord', _GPRSRecord_sgsnMOLCSRecord),
        ('sgsnNILCSRecord', _GPRSRecord_sgsnNILCSRecord),
        ('sgsnMBMSRecord', _GPRSRecord_sgsnMBMSRecord),
        ('ggsnMBMSRecord', _GPRSRecord_ggsnMBMSRecord),
        ('sGWRecord', _GPRSRecord_sGWRecord),
        ('pGWRecord', _GPRSRecord_pGWRecord),
        ('gwMBMSRecord', _GPRSRecord_gwMBMSRecord),
        ('tDFRecord', _GPRSRecord_tDFRecord),
        ('iPERecord', _GPRSRecord_iPERecord),
        ('ePDGRecord', _GPRSRecord_ePDGRecord),
        ('tWAGRecord', _GPRSRecord_tWAGRecord),
        ])
    GPRSRecord._ext = None
    
    #-----< SGWRecord >-----#
    SGWRecord = SET(name='SGWRecord', mode=MODE_TYPE)
    _SGWRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGWRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SGWRecord_s_GWAddress = CHOICE(name='s-GWAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGWRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _SGWRecord_servingNodeAddress = SEQ_OF(name='servingNodeAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SGWRecord_servingNodeAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGWRecord_servingNodeAddress._cont = __SGWRecord_servingNodeAddress__item_
    _SGWRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SGWRecord_pdpPDNType = OCT_STR(name='pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _SGWRecord_servedPDPPDNAddress = CHOICE(name='servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGWRecord_dynamicAddressFlag = BOOL(name='dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _SGWRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGWRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _SGWRecord_listOfTrafficVolumes._cont = __SGWRecord_listOfTrafficVolumes__item_
    _SGWRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGWRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SGWRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGWRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGWRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGWRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGWRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGWRecord_apnSelectionMode = ENUM(name='apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _SGWRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGWRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGWRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGWRecord_iMSsignalingContext = NULL(name='iMSsignalingContext', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGWRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGWRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGWRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SGWRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_sGWChange = BOOL(name='sGWChange', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWChange')), opt=True)
    _SGWRecord_servingNodeType = SEQ_OF(name='servingNodeType', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SGWRecord_servingNodeType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _SGWRecord_servingNodeType._cont = __SGWRecord_servingNodeType__item_
    _SGWRecord_p_GWAddressUsed = CHOICE(name='p-GWAddressUsed', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGWRecord_p_GWPLMNIdentifier = OCT_STR(name='p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGWRecord_startTime = OCT_STR(name='startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGWRecord_stopTime = OCT_STR(name='stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGWRecord_pDNConnectionChargingID = INT(name='pDNConnectionChargingID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _SGWRecord_iMSIunauthenticatedFlag = NULL(name='iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _SGWRecord_servedPDPPDNAddressExt = CHOICE(name='servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGWRecord_lowPriorityIndicator = NULL(name='lowPriorityIndicator', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_dynamicAddressFlagExt = BOOL(name='dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _SGWRecord_s_GWiPv6Address = CHOICE(name='s-GWiPv6Address', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGWRecord_servingNodeiPv6Address = SEQ_OF(name='servingNodeiPv6Address', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGWRecord_servingNodeiPv6Address__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGWRecord_servingNodeiPv6Address._cont = __SGWRecord_servingNodeiPv6Address__item_
    _SGWRecord_p_GWiPv6AddressUsed = CHOICE(name='p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGWRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_userLocationInfoTime = OCT_STR(name='userLocationInfoTime', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGWRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    _SGWRecord_presenceReportingAreaInfo = SEQ(name='presenceReportingAreaInfo', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')), opt=True)
    _SGWRecord_lastUserLocationInformation = OCT_STR(name='lastUserLocationInformation', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_lastMSTimeZone = OCT_STR(name='lastMSTimeZone', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SGWRecord_enhancedDiagnostics = SEQ(name='enhancedDiagnostics', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _SGWRecord_cPCIoTEPSOptimisationIndicator = BOOL(name='cPCIoTEPSOptimisationIndicator', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CPCIoTEPSOptimisationIndicator')), opt=True)
    _SGWRecord_uNIPDUCPOnlyFlag = BOOL(name='uNIPDUCPOnlyFlag', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UNIPDUCPOnlyFlag')), opt=True)
    _SGWRecord_servingPLMNRateControl = SEQ(name='servingPLMNRateControl', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _SGWRecord_pDPPDNTypeExtension = INT(name='pDPPDNTypeExtension', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPPDNTypeExtension')), opt=True)
    _SGWRecord_mOExceptionDataCounter = SEQ(name='mOExceptionDataCounter', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MOExceptionDataCounter')), opt=True)
    _SGWRecord_listOfRANSecondaryRATUsageReports = SEQ_OF(name='listOfRANSecondaryRATUsageReports', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGWRecord_listOfRANSecondaryRATUsageReports__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'RANSecondaryRATUsageReport')))
    _SGWRecord_listOfRANSecondaryRATUsageReports._cont = __SGWRecord_listOfRANSecondaryRATUsageReports__item_
    SGWRecord._cont = ASN1Dict([
        ('recordType', _SGWRecord_recordType),
        ('servedIMSI', _SGWRecord_servedIMSI),
        ('s-GWAddress', _SGWRecord_s_GWAddress),
        ('chargingID', _SGWRecord_chargingID),
        ('servingNodeAddress', _SGWRecord_servingNodeAddress),
        ('accessPointNameNI', _SGWRecord_accessPointNameNI),
        ('pdpPDNType', _SGWRecord_pdpPDNType),
        ('servedPDPPDNAddress', _SGWRecord_servedPDPPDNAddress),
        ('dynamicAddressFlag', _SGWRecord_dynamicAddressFlag),
        ('listOfTrafficVolumes', _SGWRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _SGWRecord_recordOpeningTime),
        ('duration', _SGWRecord_duration),
        ('causeForRecClosing', _SGWRecord_causeForRecClosing),
        ('diagnostics', _SGWRecord_diagnostics),
        ('recordSequenceNumber', _SGWRecord_recordSequenceNumber),
        ('nodeID', _SGWRecord_nodeID),
        ('recordExtensions', _SGWRecord_recordExtensions),
        ('localSequenceNumber', _SGWRecord_localSequenceNumber),
        ('apnSelectionMode', _SGWRecord_apnSelectionMode),
        ('servedMSISDN', _SGWRecord_servedMSISDN),
        ('chargingCharacteristics', _SGWRecord_chargingCharacteristics),
        ('chChSelectionMode', _SGWRecord_chChSelectionMode),
        ('iMSsignalingContext', _SGWRecord_iMSsignalingContext),
        ('servingNodePLMNIdentifier', _SGWRecord_servingNodePLMNIdentifier),
        ('servedIMEI', _SGWRecord_servedIMEI),
        ('rATType', _SGWRecord_rATType),
        ('mSTimeZone', _SGWRecord_mSTimeZone),
        ('userLocationInformation', _SGWRecord_userLocationInformation),
        ('sGWChange', _SGWRecord_sGWChange),
        ('servingNodeType', _SGWRecord_servingNodeType),
        ('p-GWAddressUsed', _SGWRecord_p_GWAddressUsed),
        ('p-GWPLMNIdentifier', _SGWRecord_p_GWPLMNIdentifier),
        ('startTime', _SGWRecord_startTime),
        ('stopTime', _SGWRecord_stopTime),
        ('pDNConnectionChargingID', _SGWRecord_pDNConnectionChargingID),
        ('iMSIunauthenticatedFlag', _SGWRecord_iMSIunauthenticatedFlag),
        ('userCSGInformation', _SGWRecord_userCSGInformation),
        ('servedPDPPDNAddressExt', _SGWRecord_servedPDPPDNAddressExt),
        ('lowPriorityIndicator', _SGWRecord_lowPriorityIndicator),
        ('dynamicAddressFlagExt', _SGWRecord_dynamicAddressFlagExt),
        ('s-GWiPv6Address', _SGWRecord_s_GWiPv6Address),
        ('servingNodeiPv6Address', _SGWRecord_servingNodeiPv6Address),
        ('p-GWiPv6AddressUsed', _SGWRecord_p_GWiPv6AddressUsed),
        ('retransmission', _SGWRecord_retransmission),
        ('userLocationInfoTime', _SGWRecord_userLocationInfoTime),
        ('cNOperatorSelectionEnt', _SGWRecord_cNOperatorSelectionEnt),
        ('presenceReportingAreaInfo', _SGWRecord_presenceReportingAreaInfo),
        ('lastUserLocationInformation', _SGWRecord_lastUserLocationInformation),
        ('lastMSTimeZone', _SGWRecord_lastMSTimeZone),
        ('enhancedDiagnostics', _SGWRecord_enhancedDiagnostics),
        ('cPCIoTEPSOptimisationIndicator', _SGWRecord_cPCIoTEPSOptimisationIndicator),
        ('uNIPDUCPOnlyFlag', _SGWRecord_uNIPDUCPOnlyFlag),
        ('servingPLMNRateControl', _SGWRecord_servingPLMNRateControl),
        ('pDPPDNTypeExtension', _SGWRecord_pDPPDNTypeExtension),
        ('mOExceptionDataCounter', _SGWRecord_mOExceptionDataCounter),
        ('listOfRANSecondaryRATUsageReports', _SGWRecord_listOfRANSecondaryRATUsageReports),
        ])
    SGWRecord._ext = None
    
    #-----< PGWRecord >-----#
    PGWRecord = SET(name='PGWRecord', mode=MODE_TYPE)
    _PGWRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PGWRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PGWRecord_p_GWAddress = CHOICE(name='p-GWAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PGWRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _PGWRecord_servingNodeAddress = SEQ_OF(name='servingNodeAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PGWRecord_servingNodeAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PGWRecord_servingNodeAddress._cont = __PGWRecord_servingNodeAddress__item_
    _PGWRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _PGWRecord_pdpPDNType = OCT_STR(name='pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _PGWRecord_servedPDPPDNAddress = CHOICE(name='servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _PGWRecord_dynamicAddressFlag = BOOL(name='dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _PGWRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _PGWRecord_listOfTrafficVolumes._cont = __PGWRecord_listOfTrafficVolumes__item_
    _PGWRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _PGWRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _PGWRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _PGWRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _PGWRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _PGWRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PGWRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _PGWRecord_apnSelectionMode = ENUM(name='apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _PGWRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _PGWRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PGWRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PGWRecord_iMSsignalingContext = NULL(name='iMSsignalingContext', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PGWRecord_pSFurnishChargingInformation = SEQ(name='pSFurnishChargingInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _PGWRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _PGWRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _PGWRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _PGWRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_cAMELChargingInformation = OCT_STR(name='cAMELChargingInformation', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_listOfServiceData = SEQ_OF(name='listOfServiceData', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_listOfServiceData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfServiceCondition')))
    _PGWRecord_listOfServiceData._cont = __PGWRecord_listOfServiceData__item_
    _PGWRecord_servingNodeType = SEQ_OF(name='servingNodeType', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PGWRecord_servingNodeType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _PGWRecord_servingNodeType._cont = __PGWRecord_servingNodeType__item_
    _PGWRecord_servedMNNAI = SET(name='servedMNNAI', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _PGWRecord_p_GWPLMNIdentifier = OCT_STR(name='p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PGWRecord_startTime = OCT_STR(name='startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PGWRecord_stopTime = OCT_STR(name='stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PGWRecord_served3gpp2MEID = OCT_STR(name='served3gpp2MEID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_pDNConnectionChargingID = INT(name='pDNConnectionChargingID', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _PGWRecord_iMSIunauthenticatedFlag = NULL(name='iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _PGWRecord_threeGPP2UserLocationInformation = OCT_STR(name='threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_servedPDPPDNAddressExt = CHOICE(name='servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _PGWRecord_lowPriorityIndicator = NULL(name='lowPriorityIndicator', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_dynamicAddressFlagExt = BOOL(name='dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _PGWRecord_servingNodeiPv6Address = SEQ_OF(name='servingNodeiPv6Address', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_servingNodeiPv6Address__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PGWRecord_servingNodeiPv6Address._cont = __PGWRecord_servingNodeiPv6Address__item_
    _PGWRecord_p_GWiPv6AddressUsed = CHOICE(name='p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _PGWRecord_tWANUserLocationInformation = SEQ(name='tWANUserLocationInformation', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _PGWRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_userLocationInfoTime = OCT_STR(name='userLocationInfoTime', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PGWRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    _PGWRecord_ePCQoSInformation = SEQ(name='ePCQoSInformation', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPCQoSInformation')), opt=True)
    _PGWRecord_presenceReportingAreaInfo = SEQ(name='presenceReportingAreaInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')), opt=True)
    _PGWRecord_lastUserLocationInformation = OCT_STR(name='lastUserLocationInformation', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_lastMSTimeZone = OCT_STR(name='lastMSTimeZone', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _PGWRecord_enhancedDiagnostics = SEQ(name='enhancedDiagnostics', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _PGWRecord_nBIFOMMode = ENUM(name='nBIFOMMode', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NBIFOMMode')), opt=True)
    _PGWRecord_nBIFOMSupport = ENUM(name='nBIFOMSupport', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NBIFOMSupport')), opt=True)
    _PGWRecord_uWANUserLocationInformation = SEQ(name='uWANUserLocationInformation', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _PGWRecord_sGiPtPTunnellingMethod = ENUM(name='sGiPtPTunnellingMethod', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGiPtPTunnellingMethod')), opt=True)
    _PGWRecord_uNIPDUCPOnlyFlag = BOOL(name='uNIPDUCPOnlyFlag', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UNIPDUCPOnlyFlag')), opt=True)
    _PGWRecord_servingPLMNRateControl = SEQ(name='servingPLMNRateControl', mode=MODE_TYPE, tag=(66, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _PGWRecord_aPNRateControl = SEQ(name='aPNRateControl', mode=MODE_TYPE, tag=(67, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _PGWRecord_pDPPDNTypeExtension = INT(name='pDPPDNTypeExtension', mode=MODE_TYPE, tag=(68, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPPDNTypeExtension')), opt=True)
    _PGWRecord_mOExceptionDataCounter = SEQ(name='mOExceptionDataCounter', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MOExceptionDataCounter')), opt=True)
    _PGWRecord_chargingPerIPCANSessionIndicator = ENUM(name='chargingPerIPCANSessionIndicator', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingPerIPCANSessionIndicator')), opt=True)
    _PGWRecord_threeGPPPSDataOffStatus = ENUM(name='threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _PGWRecord_sCSASAddress = SET(name='sCSASAddress', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SCSASAddress')), opt=True)
    _PGWRecord_listOfRANSecondaryRATUsageReports = SEQ_OF(name='listOfRANSecondaryRATUsageReports', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_listOfRANSecondaryRATUsageReports__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'RANSecondaryRATUsageReport')))
    _PGWRecord_listOfRANSecondaryRATUsageReports._cont = __PGWRecord_listOfRANSecondaryRATUsageReports__item_
    PGWRecord._cont = ASN1Dict([
        ('recordType', _PGWRecord_recordType),
        ('servedIMSI', _PGWRecord_servedIMSI),
        ('p-GWAddress', _PGWRecord_p_GWAddress),
        ('chargingID', _PGWRecord_chargingID),
        ('servingNodeAddress', _PGWRecord_servingNodeAddress),
        ('accessPointNameNI', _PGWRecord_accessPointNameNI),
        ('pdpPDNType', _PGWRecord_pdpPDNType),
        ('servedPDPPDNAddress', _PGWRecord_servedPDPPDNAddress),
        ('dynamicAddressFlag', _PGWRecord_dynamicAddressFlag),
        ('listOfTrafficVolumes', _PGWRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _PGWRecord_recordOpeningTime),
        ('duration', _PGWRecord_duration),
        ('causeForRecClosing', _PGWRecord_causeForRecClosing),
        ('diagnostics', _PGWRecord_diagnostics),
        ('recordSequenceNumber', _PGWRecord_recordSequenceNumber),
        ('nodeID', _PGWRecord_nodeID),
        ('recordExtensions', _PGWRecord_recordExtensions),
        ('localSequenceNumber', _PGWRecord_localSequenceNumber),
        ('apnSelectionMode', _PGWRecord_apnSelectionMode),
        ('servedMSISDN', _PGWRecord_servedMSISDN),
        ('chargingCharacteristics', _PGWRecord_chargingCharacteristics),
        ('chChSelectionMode', _PGWRecord_chChSelectionMode),
        ('iMSsignalingContext', _PGWRecord_iMSsignalingContext),
        ('servingNodePLMNIdentifier', _PGWRecord_servingNodePLMNIdentifier),
        ('pSFurnishChargingInformation', _PGWRecord_pSFurnishChargingInformation),
        ('servedIMEI', _PGWRecord_servedIMEI),
        ('rATType', _PGWRecord_rATType),
        ('mSTimeZone', _PGWRecord_mSTimeZone),
        ('userLocationInformation', _PGWRecord_userLocationInformation),
        ('cAMELChargingInformation', _PGWRecord_cAMELChargingInformation),
        ('listOfServiceData', _PGWRecord_listOfServiceData),
        ('servingNodeType', _PGWRecord_servingNodeType),
        ('servedMNNAI', _PGWRecord_servedMNNAI),
        ('p-GWPLMNIdentifier', _PGWRecord_p_GWPLMNIdentifier),
        ('startTime', _PGWRecord_startTime),
        ('stopTime', _PGWRecord_stopTime),
        ('served3gpp2MEID', _PGWRecord_served3gpp2MEID),
        ('pDNConnectionChargingID', _PGWRecord_pDNConnectionChargingID),
        ('iMSIunauthenticatedFlag', _PGWRecord_iMSIunauthenticatedFlag),
        ('userCSGInformation', _PGWRecord_userCSGInformation),
        ('threeGPP2UserLocationInformation', _PGWRecord_threeGPP2UserLocationInformation),
        ('servedPDPPDNAddressExt', _PGWRecord_servedPDPPDNAddressExt),
        ('lowPriorityIndicator', _PGWRecord_lowPriorityIndicator),
        ('dynamicAddressFlagExt', _PGWRecord_dynamicAddressFlagExt),
        ('servingNodeiPv6Address', _PGWRecord_servingNodeiPv6Address),
        ('p-GWiPv6AddressUsed', _PGWRecord_p_GWiPv6AddressUsed),
        ('tWANUserLocationInformation', _PGWRecord_tWANUserLocationInformation),
        ('retransmission', _PGWRecord_retransmission),
        ('userLocationInfoTime', _PGWRecord_userLocationInfoTime),
        ('cNOperatorSelectionEnt', _PGWRecord_cNOperatorSelectionEnt),
        ('ePCQoSInformation', _PGWRecord_ePCQoSInformation),
        ('presenceReportingAreaInfo', _PGWRecord_presenceReportingAreaInfo),
        ('lastUserLocationInformation', _PGWRecord_lastUserLocationInformation),
        ('lastMSTimeZone', _PGWRecord_lastMSTimeZone),
        ('enhancedDiagnostics', _PGWRecord_enhancedDiagnostics),
        ('nBIFOMMode', _PGWRecord_nBIFOMMode),
        ('nBIFOMSupport', _PGWRecord_nBIFOMSupport),
        ('uWANUserLocationInformation', _PGWRecord_uWANUserLocationInformation),
        ('sGiPtPTunnellingMethod', _PGWRecord_sGiPtPTunnellingMethod),
        ('uNIPDUCPOnlyFlag', _PGWRecord_uNIPDUCPOnlyFlag),
        ('servingPLMNRateControl', _PGWRecord_servingPLMNRateControl),
        ('aPNRateControl', _PGWRecord_aPNRateControl),
        ('pDPPDNTypeExtension', _PGWRecord_pDPPDNTypeExtension),
        ('mOExceptionDataCounter', _PGWRecord_mOExceptionDataCounter),
        ('chargingPerIPCANSessionIndicator', _PGWRecord_chargingPerIPCANSessionIndicator),
        ('threeGPPPSDataOffStatus', _PGWRecord_threeGPPPSDataOffStatus),
        ('sCSASAddress', _PGWRecord_sCSASAddress),
        ('listOfRANSecondaryRATUsageReports', _PGWRecord_listOfRANSecondaryRATUsageReports),
        ])
    PGWRecord._ext = None
    
    #-----< TDFRecord >-----#
    TDFRecord = SET(name='TDFRecord', mode=MODE_TYPE)
    _TDFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TDFRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _TDFRecord_p_GWAddress = CHOICE(name='p-GWAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_servingNodeAddress = SEQ_OF(name='servingNodeAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TDFRecord_servingNodeAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_servingNodeAddress._cont = __TDFRecord_servingNodeAddress__item_
    _TDFRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _TDFRecord_pdpPDNType = OCT_STR(name='pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _TDFRecord_servedPDPPDNAddress = CHOICE(name='servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TDFRecord_dynamicAddressFlag = BOOL(name='dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TDFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _TDFRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TDFRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _TDFRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TDFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _TDFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TDFRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TDFRecord_apnSelectionMode = ENUM(name='apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _TDFRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _TDFRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _TDFRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _TDFRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TDFRecord_pSFurnishChargingInformation = SEQ(name='pSFurnishChargingInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _TDFRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _TDFRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _TDFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _TDFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_listOfServiceData = SEQ_OF(name='listOfServiceData', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TDFRecord_listOfServiceData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfServiceCondition')))
    _TDFRecord_listOfServiceData._cont = __TDFRecord_listOfServiceData__item_
    _TDFRecord_servingNodeType = SEQ_OF(name='servingNodeType', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TDFRecord_servingNodeType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _TDFRecord_servingNodeType._cont = __TDFRecord_servingNodeType__item_
    _TDFRecord_servedMNNAI = SET(name='servedMNNAI', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _TDFRecord_p_GWPLMNIdentifier = OCT_STR(name='p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TDFRecord_startTime = OCT_STR(name='startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TDFRecord_stopTime = OCT_STR(name='stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TDFRecord_served3gpp2MEID = OCT_STR(name='served3gpp2MEID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_pDNConnectionChargingID = INT(name='pDNConnectionChargingID', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _TDFRecord_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _TDFRecord_threeGPP2UserLocationInformation = OCT_STR(name='threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_servedPDPPDNAddressExt = CHOICE(name='servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TDFRecord_dynamicAddressFlagExt = BOOL(name='dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TDFRecord_servingNodeiPv6Address = SEQ_OF(name='servingNodeiPv6Address', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TDFRecord_servingNodeiPv6Address__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_servingNodeiPv6Address._cont = __TDFRecord_servingNodeiPv6Address__item_
    _TDFRecord_p_GWiPv6AddressUsed = CHOICE(name='p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TDFRecord_tWANUserLocationInformation = SEQ(name='tWANUserLocationInformation', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _TDFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_tDFAddress = CHOICE(name='tDFAddress', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_tDFiPv6AddressUsed = CHOICE(name='tDFiPv6AddressUsed', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TDFRecord_tDFPLMNIdentifier = OCT_STR(name='tDFPLMNIdentifier', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TDFRecord_servedFixedSubsID = OCT_STR(name='servedFixedSubsID', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedSubsID')), opt=True)
    _TDFRecord_accessLineIdentifier = SEQ(name='accessLineIdentifier', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessLineIdentifier')), opt=True)
    _TDFRecord_fixedUserLocationInformation = SEQ(name='fixedUserLocationInformation', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedUserLocationInformation')), opt=True)
    TDFRecord._cont = ASN1Dict([
        ('recordType', _TDFRecord_recordType),
        ('servedIMSI', _TDFRecord_servedIMSI),
        ('p-GWAddress', _TDFRecord_p_GWAddress),
        ('servingNodeAddress', _TDFRecord_servingNodeAddress),
        ('accessPointNameNI', _TDFRecord_accessPointNameNI),
        ('pdpPDNType', _TDFRecord_pdpPDNType),
        ('servedPDPPDNAddress', _TDFRecord_servedPDPPDNAddress),
        ('dynamicAddressFlag', _TDFRecord_dynamicAddressFlag),
        ('recordOpeningTime', _TDFRecord_recordOpeningTime),
        ('duration', _TDFRecord_duration),
        ('causeForRecClosing', _TDFRecord_causeForRecClosing),
        ('diagnostics', _TDFRecord_diagnostics),
        ('recordSequenceNumber', _TDFRecord_recordSequenceNumber),
        ('nodeID', _TDFRecord_nodeID),
        ('recordExtensions', _TDFRecord_recordExtensions),
        ('localSequenceNumber', _TDFRecord_localSequenceNumber),
        ('apnSelectionMode', _TDFRecord_apnSelectionMode),
        ('servedMSISDN', _TDFRecord_servedMSISDN),
        ('chargingCharacteristics', _TDFRecord_chargingCharacteristics),
        ('chChSelectionMode', _TDFRecord_chChSelectionMode),
        ('servingNodePLMNIdentifier', _TDFRecord_servingNodePLMNIdentifier),
        ('pSFurnishChargingInformation', _TDFRecord_pSFurnishChargingInformation),
        ('servedIMEI', _TDFRecord_servedIMEI),
        ('rATType', _TDFRecord_rATType),
        ('mSTimeZone', _TDFRecord_mSTimeZone),
        ('userLocationInformation', _TDFRecord_userLocationInformation),
        ('listOfServiceData', _TDFRecord_listOfServiceData),
        ('servingNodeType', _TDFRecord_servingNodeType),
        ('servedMNNAI', _TDFRecord_servedMNNAI),
        ('p-GWPLMNIdentifier', _TDFRecord_p_GWPLMNIdentifier),
        ('startTime', _TDFRecord_startTime),
        ('stopTime', _TDFRecord_stopTime),
        ('served3gpp2MEID', _TDFRecord_served3gpp2MEID),
        ('pDNConnectionChargingID', _TDFRecord_pDNConnectionChargingID),
        ('userCSGInformation', _TDFRecord_userCSGInformation),
        ('threeGPP2UserLocationInformation', _TDFRecord_threeGPP2UserLocationInformation),
        ('servedPDPPDNAddressExt', _TDFRecord_servedPDPPDNAddressExt),
        ('dynamicAddressFlagExt', _TDFRecord_dynamicAddressFlagExt),
        ('servingNodeiPv6Address', _TDFRecord_servingNodeiPv6Address),
        ('p-GWiPv6AddressUsed', _TDFRecord_p_GWiPv6AddressUsed),
        ('tWANUserLocationInformation', _TDFRecord_tWANUserLocationInformation),
        ('retransmission', _TDFRecord_retransmission),
        ('tDFAddress', _TDFRecord_tDFAddress),
        ('tDFiPv6AddressUsed', _TDFRecord_tDFiPv6AddressUsed),
        ('tDFPLMNIdentifier', _TDFRecord_tDFPLMNIdentifier),
        ('servedFixedSubsID', _TDFRecord_servedFixedSubsID),
        ('accessLineIdentifier', _TDFRecord_accessLineIdentifier),
        ('fixedUserLocationInformation', _TDFRecord_fixedUserLocationInformation),
        ])
    TDFRecord._ext = None
    
    #-----< IPERecord >-----#
    IPERecord = SET(name='IPERecord', mode=MODE_TYPE)
    _IPERecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _IPERecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _IPERecord_iPEdgeAddress = CHOICE(name='iPEdgeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _IPERecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _IPERecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _IPERecord_iPCANsessionType = OCT_STR(name='iPCANsessionType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _IPERecord_servedIPCANsessionAddress = CHOICE(name='servedIPCANsessionAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _IPERecord_dynamicAddressFlag = BOOL(name='dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _IPERecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IPERecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _IPERecord_listOfTrafficVolumes._cont = __IPERecord_listOfTrafficVolumes__item_
    _IPERecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _IPERecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _IPERecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _IPERecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _IPERecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPERecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _IPERecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _IPERecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _IPERecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _IPERecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _IPERecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _IPERecord_pSFurnishChargingInformation = SEQ(name='pSFurnishChargingInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _IPERecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _IPERecord_listOfServiceData = SEQ_OF(name='listOfServiceData', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IPERecord_listOfServiceData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfServiceCondition')))
    _IPERecord_listOfServiceData._cont = __IPERecord_listOfServiceData__item_
    _IPERecord_servedMNNAI = SET(name='servedMNNAI', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _IPERecord_iPEdgeOperatorIdentifier = OCT_STR(name='iPEdgeOperatorIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _IPERecord_startTime = OCT_STR(name='startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IPERecord_stopTime = OCT_STR(name='stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IPERecord_servedIPCANsessionAddressExt = CHOICE(name='servedIPCANsessionAddressExt', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _IPERecord_dynamicAddressFlagExt = BOOL(name='dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _IPERecord_iPEdgeiPv6AddressUsed = CHOICE(name='iPEdgeiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _IPERecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPERecord_servedFixedSubsID = OCT_STR(name='servedFixedSubsID', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedSubsID')), opt=True)
    _IPERecord_accessLineIdentifier = SEQ(name='accessLineIdentifier', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessLineIdentifier')), opt=True)
    _IPERecord_fixedUserLocationInformation = SEQ(name='fixedUserLocationInformation', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedUserLocationInformation')), opt=True)
    IPERecord._cont = ASN1Dict([
        ('recordType', _IPERecord_recordType),
        ('servedIMSI', _IPERecord_servedIMSI),
        ('iPEdgeAddress', _IPERecord_iPEdgeAddress),
        ('chargingID', _IPERecord_chargingID),
        ('accessPointNameNI', _IPERecord_accessPointNameNI),
        ('iPCANsessionType', _IPERecord_iPCANsessionType),
        ('servedIPCANsessionAddress', _IPERecord_servedIPCANsessionAddress),
        ('dynamicAddressFlag', _IPERecord_dynamicAddressFlag),
        ('listOfTrafficVolumes', _IPERecord_listOfTrafficVolumes),
        ('recordOpeningTime', _IPERecord_recordOpeningTime),
        ('duration', _IPERecord_duration),
        ('causeForRecClosing', _IPERecord_causeForRecClosing),
        ('diagnostics', _IPERecord_diagnostics),
        ('recordSequenceNumber', _IPERecord_recordSequenceNumber),
        ('nodeID', _IPERecord_nodeID),
        ('recordExtensions', _IPERecord_recordExtensions),
        ('localSequenceNumber', _IPERecord_localSequenceNumber),
        ('servedMSISDN', _IPERecord_servedMSISDN),
        ('chargingCharacteristics', _IPERecord_chargingCharacteristics),
        ('chChSelectionMode', _IPERecord_chChSelectionMode),
        ('pSFurnishChargingInformation', _IPERecord_pSFurnishChargingInformation),
        ('servedIMEI', _IPERecord_servedIMEI),
        ('listOfServiceData', _IPERecord_listOfServiceData),
        ('servedMNNAI', _IPERecord_servedMNNAI),
        ('iPEdgeOperatorIdentifier', _IPERecord_iPEdgeOperatorIdentifier),
        ('startTime', _IPERecord_startTime),
        ('stopTime', _IPERecord_stopTime),
        ('servedIPCANsessionAddressExt', _IPERecord_servedIPCANsessionAddressExt),
        ('dynamicAddressFlagExt', _IPERecord_dynamicAddressFlagExt),
        ('iPEdgeiPv6AddressUsed', _IPERecord_iPEdgeiPv6AddressUsed),
        ('retransmission', _IPERecord_retransmission),
        ('servedFixedSubsID', _IPERecord_servedFixedSubsID),
        ('accessLineIdentifier', _IPERecord_accessLineIdentifier),
        ('fixedUserLocationInformation', _IPERecord_fixedUserLocationInformation),
        ])
    IPERecord._ext = None
    
    #-----< EPDGRecord >-----#
    EPDGRecord = SET(name='EPDGRecord', mode=MODE_TYPE)
    _EPDGRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _EPDGRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _EPDGRecord_ePDGAddressUsed = CHOICE(name='ePDGAddressUsed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _EPDGRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _EPDGRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _EPDGRecord_pdpPDNType = OCT_STR(name='pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _EPDGRecord_servedPDPPDNAddress = CHOICE(name='servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _EPDGRecord_dynamicAddressFlag = BOOL(name='dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _EPDGRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EPDGRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _EPDGRecord_listOfTrafficVolumes._cont = __EPDGRecord_listOfTrafficVolumes__item_
    _EPDGRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _EPDGRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _EPDGRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _EPDGRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _EPDGRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPDGRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _EPDGRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _EPDGRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _EPDGRecord_apnSelectionMode = ENUM(name='apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _EPDGRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _EPDGRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _EPDGRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _EPDGRecord_iMSsignalingContext = NULL(name='iMSsignalingContext', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPDGRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _EPDGRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _EPDGRecord_sGWChange = BOOL(name='sGWChange', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWChange')), opt=True)
    _EPDGRecord_p_GWAddressUsed = CHOICE(name='p-GWAddressUsed', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _EPDGRecord_p_GWPLMNIdentifier = OCT_STR(name='p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _EPDGRecord_startTime = OCT_STR(name='startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _EPDGRecord_stopTime = OCT_STR(name='stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _EPDGRecord_pDNConnectionChargingID = INT(name='pDNConnectionChargingID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _EPDGRecord_servedPDPPDNAddressExt = CHOICE(name='servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _EPDGRecord_dynamicAddressFlagExt = BOOL(name='dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _EPDGRecord_ePDGiPv6AddressUsed = CHOICE(name='ePDGiPv6AddressUsed', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _EPDGRecord_p_GWiPv6AddressUsed = CHOICE(name='p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _EPDGRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPDGRecord_enhancedDiagnostics = SEQ(name='enhancedDiagnostics', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _EPDGRecord_uWANUserLocationInformation = SEQ(name='uWANUserLocationInformation', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _EPDGRecord_userLocationInfoTime = OCT_STR(name='userLocationInfoTime', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _EPDGRecord_iMSIunauthenticatedFlag = NULL(name='iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPDGRecord._cont = ASN1Dict([
        ('recordType', _EPDGRecord_recordType),
        ('servedIMSI', _EPDGRecord_servedIMSI),
        ('ePDGAddressUsed', _EPDGRecord_ePDGAddressUsed),
        ('chargingID', _EPDGRecord_chargingID),
        ('accessPointNameNI', _EPDGRecord_accessPointNameNI),
        ('pdpPDNType', _EPDGRecord_pdpPDNType),
        ('servedPDPPDNAddress', _EPDGRecord_servedPDPPDNAddress),
        ('dynamicAddressFlag', _EPDGRecord_dynamicAddressFlag),
        ('listOfTrafficVolumes', _EPDGRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _EPDGRecord_recordOpeningTime),
        ('duration', _EPDGRecord_duration),
        ('causeForRecClosing', _EPDGRecord_causeForRecClosing),
        ('diagnostics', _EPDGRecord_diagnostics),
        ('recordSequenceNumber', _EPDGRecord_recordSequenceNumber),
        ('nodeID', _EPDGRecord_nodeID),
        ('recordExtensions', _EPDGRecord_recordExtensions),
        ('localSequenceNumber', _EPDGRecord_localSequenceNumber),
        ('apnSelectionMode', _EPDGRecord_apnSelectionMode),
        ('servedMSISDN', _EPDGRecord_servedMSISDN),
        ('chargingCharacteristics', _EPDGRecord_chargingCharacteristics),
        ('chChSelectionMode', _EPDGRecord_chChSelectionMode),
        ('iMSsignalingContext', _EPDGRecord_iMSsignalingContext),
        ('servedIMEI', _EPDGRecord_servedIMEI),
        ('rATType', _EPDGRecord_rATType),
        ('sGWChange', _EPDGRecord_sGWChange),
        ('p-GWAddressUsed', _EPDGRecord_p_GWAddressUsed),
        ('p-GWPLMNIdentifier', _EPDGRecord_p_GWPLMNIdentifier),
        ('startTime', _EPDGRecord_startTime),
        ('stopTime', _EPDGRecord_stopTime),
        ('pDNConnectionChargingID', _EPDGRecord_pDNConnectionChargingID),
        ('servedPDPPDNAddressExt', _EPDGRecord_servedPDPPDNAddressExt),
        ('dynamicAddressFlagExt', _EPDGRecord_dynamicAddressFlagExt),
        ('ePDGiPv6AddressUsed', _EPDGRecord_ePDGiPv6AddressUsed),
        ('p-GWiPv6AddressUsed', _EPDGRecord_p_GWiPv6AddressUsed),
        ('retransmission', _EPDGRecord_retransmission),
        ('enhancedDiagnostics', _EPDGRecord_enhancedDiagnostics),
        ('uWANUserLocationInformation', _EPDGRecord_uWANUserLocationInformation),
        ('userLocationInfoTime', _EPDGRecord_userLocationInfoTime),
        ('iMSIunauthenticatedFlag', _EPDGRecord_iMSIunauthenticatedFlag),
        ])
    EPDGRecord._ext = None
    
    #-----< TWAGRecord >-----#
    TWAGRecord = SET(name='TWAGRecord', mode=MODE_TYPE)
    _TWAGRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TWAGRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _TWAGRecord_tWAGAddressUsed = CHOICE(name='tWAGAddressUsed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TWAGRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _TWAGRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _TWAGRecord_pdpPDNType = OCT_STR(name='pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _TWAGRecord_servedPDPPDNAddress = CHOICE(name='servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TWAGRecord_dynamicAddressFlag = BOOL(name='dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TWAGRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TWAGRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _TWAGRecord_listOfTrafficVolumes._cont = __TWAGRecord_listOfTrafficVolumes__item_
    _TWAGRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _TWAGRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TWAGRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _TWAGRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TWAGRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TWAGRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _TWAGRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TWAGRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TWAGRecord_apnSelectionMode = ENUM(name='apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _TWAGRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _TWAGRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _TWAGRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _TWAGRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _TWAGRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _TWAGRecord_sGWChange = BOOL(name='sGWChange', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWChange')), opt=True)
    _TWAGRecord_p_GWAddressUsed = CHOICE(name='p-GWAddressUsed', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TWAGRecord_p_GWPLMNIdentifier = OCT_STR(name='p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TWAGRecord_startTime = OCT_STR(name='startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TWAGRecord_stopTime = OCT_STR(name='stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TWAGRecord_pDNConnectionChargingID = INT(name='pDNConnectionChargingID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _TWAGRecord_servedPDPPDNAddressExt = CHOICE(name='servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TWAGRecord_dynamicAddressFlagExt = BOOL(name='dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TWAGRecord_tWAGiPv6AddressUsed = CHOICE(name='tWAGiPv6AddressUsed', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TWAGRecord_p_GWiPv6AddressUsed = CHOICE(name='p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TWAGRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TWAGRecord_enhancedDiagnostics = SEQ(name='enhancedDiagnostics', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _TWAGRecord_tWANUserLocationInformation = SEQ(name='tWANUserLocationInformation', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _TWAGRecord_iMSIunauthenticatedFlag = NULL(name='iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TWAGRecord._cont = ASN1Dict([
        ('recordType', _TWAGRecord_recordType),
        ('servedIMSI', _TWAGRecord_servedIMSI),
        ('tWAGAddressUsed', _TWAGRecord_tWAGAddressUsed),
        ('chargingID', _TWAGRecord_chargingID),
        ('accessPointNameNI', _TWAGRecord_accessPointNameNI),
        ('pdpPDNType', _TWAGRecord_pdpPDNType),
        ('servedPDPPDNAddress', _TWAGRecord_servedPDPPDNAddress),
        ('dynamicAddressFlag', _TWAGRecord_dynamicAddressFlag),
        ('listOfTrafficVolumes', _TWAGRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _TWAGRecord_recordOpeningTime),
        ('duration', _TWAGRecord_duration),
        ('causeForRecClosing', _TWAGRecord_causeForRecClosing),
        ('diagnostics', _TWAGRecord_diagnostics),
        ('recordSequenceNumber', _TWAGRecord_recordSequenceNumber),
        ('nodeID', _TWAGRecord_nodeID),
        ('recordExtensions', _TWAGRecord_recordExtensions),
        ('localSequenceNumber', _TWAGRecord_localSequenceNumber),
        ('apnSelectionMode', _TWAGRecord_apnSelectionMode),
        ('servedMSISDN', _TWAGRecord_servedMSISDN),
        ('chargingCharacteristics', _TWAGRecord_chargingCharacteristics),
        ('chChSelectionMode', _TWAGRecord_chChSelectionMode),
        ('servedIMEI', _TWAGRecord_servedIMEI),
        ('rATType', _TWAGRecord_rATType),
        ('sGWChange', _TWAGRecord_sGWChange),
        ('p-GWAddressUsed', _TWAGRecord_p_GWAddressUsed),
        ('p-GWPLMNIdentifier', _TWAGRecord_p_GWPLMNIdentifier),
        ('startTime', _TWAGRecord_startTime),
        ('stopTime', _TWAGRecord_stopTime),
        ('pDNConnectionChargingID', _TWAGRecord_pDNConnectionChargingID),
        ('servedPDPPDNAddressExt', _TWAGRecord_servedPDPPDNAddressExt),
        ('dynamicAddressFlagExt', _TWAGRecord_dynamicAddressFlagExt),
        ('tWAGiPv6AddressUsed', _TWAGRecord_tWAGiPv6AddressUsed),
        ('p-GWiPv6AddressUsed', _TWAGRecord_p_GWiPv6AddressUsed),
        ('retransmission', _TWAGRecord_retransmission),
        ('enhancedDiagnostics', _TWAGRecord_enhancedDiagnostics),
        ('tWANUserLocationInformation', _TWAGRecord_tWANUserLocationInformation),
        ('iMSIunauthenticatedFlag', _TWAGRecord_iMSIunauthenticatedFlag),
        ])
    TWAGRecord._ext = None
    
    #-----< SGSNMMRecord >-----#
    SGSNMMRecord = SET(name='SGSNMMRecord', mode=MODE_TYPE)
    _SGSNMMRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMMRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNMMRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNMMRecord_sgsnAddress = CHOICE(name='sgsnAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNMMRecord_msNetworkCapability = OCT_STR(name='msNetworkCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNMMRecord_routingArea = OCT_STR(name='routingArea', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNMMRecord_locationAreaCode = OCT_STR(name='locationAreaCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNMMRecord_cellIdentifier = OCT_STR(name='cellIdentifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNMMRecord_changeLocation = SEQ_OF(name='changeLocation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNMMRecord_changeLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeLocation')))
    _SGSNMMRecord_changeLocation._cont = __SGSNMMRecord_changeLocation__item_
    _SGSNMMRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMMRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNMMRecord_sgsnChange = BOOL(name='sgsnChange', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNChange')), opt=True)
    _SGSNMMRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMMRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMMRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMMRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMMRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMMRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMMRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNMMRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNMMRecord_cAMELInformationMM = SET(name='cAMELInformationMM', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationMM')), opt=True)
    _SGSNMMRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNMMRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNMMRecord_cellPLMNId = OCT_STR(name='cellPLMNId', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMMRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMMRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNMMRecord._cont = ASN1Dict([
        ('recordType', _SGSNMMRecord_recordType),
        ('servedIMSI', _SGSNMMRecord_servedIMSI),
        ('servedIMEI', _SGSNMMRecord_servedIMEI),
        ('sgsnAddress', _SGSNMMRecord_sgsnAddress),
        ('msNetworkCapability', _SGSNMMRecord_msNetworkCapability),
        ('routingArea', _SGSNMMRecord_routingArea),
        ('locationAreaCode', _SGSNMMRecord_locationAreaCode),
        ('cellIdentifier', _SGSNMMRecord_cellIdentifier),
        ('changeLocation', _SGSNMMRecord_changeLocation),
        ('recordOpeningTime', _SGSNMMRecord_recordOpeningTime),
        ('duration', _SGSNMMRecord_duration),
        ('sgsnChange', _SGSNMMRecord_sgsnChange),
        ('causeForRecClosing', _SGSNMMRecord_causeForRecClosing),
        ('diagnostics', _SGSNMMRecord_diagnostics),
        ('recordSequenceNumber', _SGSNMMRecord_recordSequenceNumber),
        ('nodeID', _SGSNMMRecord_nodeID),
        ('recordExtensions', _SGSNMMRecord_recordExtensions),
        ('localSequenceNumber', _SGSNMMRecord_localSequenceNumber),
        ('servedMSISDN', _SGSNMMRecord_servedMSISDN),
        ('chargingCharacteristics', _SGSNMMRecord_chargingCharacteristics),
        ('cAMELInformationMM', _SGSNMMRecord_cAMELInformationMM),
        ('rATType', _SGSNMMRecord_rATType),
        ('chChSelectionMode', _SGSNMMRecord_chChSelectionMode),
        ('cellPLMNId', _SGSNMMRecord_cellPLMNId),
        ('servingNodePLMNIdentifier', _SGSNMMRecord_servingNodePLMNIdentifier),
        ('cNOperatorSelectionEnt', _SGSNMMRecord_cNOperatorSelectionEnt),
        ])
    SGSNMMRecord._ext = None
    
    #-----< SGSNPDPRecord >-----#
    SGSNPDPRecord = SET(name='SGSNPDPRecord', mode=MODE_TYPE)
    _SGSNPDPRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNPDPRecord_networkInitiation = BOOL(name='networkInitiation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NetworkInitiatedPDPContext')), opt=True)
    _SGSNPDPRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SGSNPDPRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNPDPRecord_sgsnAddress = CHOICE(name='sgsnAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNPDPRecord_msNetworkCapability = OCT_STR(name='msNetworkCapability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNPDPRecord_routingArea = OCT_STR(name='routingArea', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNPDPRecord_locationAreaCode = OCT_STR(name='locationAreaCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNPDPRecord_cellIdentifier = OCT_STR(name='cellIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNPDPRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _SGSNPDPRecord_ggsnAddressUsed = CHOICE(name='ggsnAddressUsed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGSNPDPRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SGSNPDPRecord_pdpType = OCT_STR(name='pdpType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _SGSNPDPRecord_servedPDPAddress = CHOICE(name='servedPDPAddress', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGSNPDPRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNPDPRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _SGSNPDPRecord_listOfTrafficVolumes._cont = __SGSNPDPRecord_listOfTrafficVolumes__item_
    _SGSNPDPRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNPDPRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SGSNPDPRecord_sgsnChange = BOOL(name='sgsnChange', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNChange')), opt=True)
    _SGSNPDPRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNPDPRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNPDPRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNPDPRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNPDPRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNPDPRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNPDPRecord_apnSelectionMode = ENUM(name='apnSelectionMode', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _SGSNPDPRecord_accessPointNameOI = STR_IA5(name='accessPointNameOI', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameOI')), opt=True)
    _SGSNPDPRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNPDPRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNPDPRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNPDPRecord_cAMELInformationPDP = SET(name='cAMELInformationPDP', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationPDP')), opt=True)
    _SGSNPDPRecord_rNCUnsentDownlinkVolume = INT(name='rNCUnsentDownlinkVolume', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _SGSNPDPRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNPDPRecord_dynamicAddressFlag = BOOL(name='dynamicAddressFlag', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _SGSNPDPRecord_iMSIunauthenticatedFlag = NULL(name='iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNPDPRecord_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _SGSNPDPRecord_servedPDPPDNAddressExt = CHOICE(name='servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGSNPDPRecord_lowPriorityIndicator = NULL(name='lowPriorityIndicator', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNPDPRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNPDPRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNPDPRecord._cont = ASN1Dict([
        ('recordType', _SGSNPDPRecord_recordType),
        ('networkInitiation', _SGSNPDPRecord_networkInitiation),
        ('servedIMSI', _SGSNPDPRecord_servedIMSI),
        ('servedIMEI', _SGSNPDPRecord_servedIMEI),
        ('sgsnAddress', _SGSNPDPRecord_sgsnAddress),
        ('msNetworkCapability', _SGSNPDPRecord_msNetworkCapability),
        ('routingArea', _SGSNPDPRecord_routingArea),
        ('locationAreaCode', _SGSNPDPRecord_locationAreaCode),
        ('cellIdentifier', _SGSNPDPRecord_cellIdentifier),
        ('chargingID', _SGSNPDPRecord_chargingID),
        ('ggsnAddressUsed', _SGSNPDPRecord_ggsnAddressUsed),
        ('accessPointNameNI', _SGSNPDPRecord_accessPointNameNI),
        ('pdpType', _SGSNPDPRecord_pdpType),
        ('servedPDPAddress', _SGSNPDPRecord_servedPDPAddress),
        ('listOfTrafficVolumes', _SGSNPDPRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _SGSNPDPRecord_recordOpeningTime),
        ('duration', _SGSNPDPRecord_duration),
        ('sgsnChange', _SGSNPDPRecord_sgsnChange),
        ('causeForRecClosing', _SGSNPDPRecord_causeForRecClosing),
        ('diagnostics', _SGSNPDPRecord_diagnostics),
        ('recordSequenceNumber', _SGSNPDPRecord_recordSequenceNumber),
        ('nodeID', _SGSNPDPRecord_nodeID),
        ('recordExtensions', _SGSNPDPRecord_recordExtensions),
        ('localSequenceNumber', _SGSNPDPRecord_localSequenceNumber),
        ('apnSelectionMode', _SGSNPDPRecord_apnSelectionMode),
        ('accessPointNameOI', _SGSNPDPRecord_accessPointNameOI),
        ('servedMSISDN', _SGSNPDPRecord_servedMSISDN),
        ('chargingCharacteristics', _SGSNPDPRecord_chargingCharacteristics),
        ('rATType', _SGSNPDPRecord_rATType),
        ('cAMELInformationPDP', _SGSNPDPRecord_cAMELInformationPDP),
        ('rNCUnsentDownlinkVolume', _SGSNPDPRecord_rNCUnsentDownlinkVolume),
        ('chChSelectionMode', _SGSNPDPRecord_chChSelectionMode),
        ('dynamicAddressFlag', _SGSNPDPRecord_dynamicAddressFlag),
        ('iMSIunauthenticatedFlag', _SGSNPDPRecord_iMSIunauthenticatedFlag),
        ('userCSGInformation', _SGSNPDPRecord_userCSGInformation),
        ('servedPDPPDNAddressExt', _SGSNPDPRecord_servedPDPPDNAddressExt),
        ('lowPriorityIndicator', _SGSNPDPRecord_lowPriorityIndicator),
        ('servingNodePLMNIdentifier', _SGSNPDPRecord_servingNodePLMNIdentifier),
        ('cNOperatorSelectionEnt', _SGSNPDPRecord_cNOperatorSelectionEnt),
        ])
    SGSNPDPRecord._ext = None
    
    #-----< SGSNSMORecord >-----#
    SGSNSMORecord = SET(name='SGSNSMORecord', mode=MODE_TYPE)
    _SGSNSMORecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNSMORecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNSMORecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNSMORecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNSMORecord_msNetworkCapability = OCT_STR(name='msNetworkCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNSMORecord_serviceCentre = OCT_STR(name='serviceCentre', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SGSNSMORecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')), opt=True)
    _SGSNSMORecord_locationArea = OCT_STR(name='locationArea', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNSMORecord_routingArea = OCT_STR(name='routingArea', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNSMORecord_cellIdentifier = OCT_STR(name='cellIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNSMORecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _SGSNSMORecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNSMORecord_smsResult = CHOICE(name='smsResult', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SGSNSMORecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNSMORecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNSMORecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNSMORecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNSMORecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNSMORecord_destinationNumber = OCT_STR(name='destinationNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _SGSNSMORecord_cAMELInformationSMS = SET(name='cAMELInformationSMS', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationSMS')), opt=True)
    _SGSNSMORecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNSMORecord_servingNodeType = ENUM(name='servingNodeType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _SGSNSMORecord_servingNodeAddress = CHOICE(name='servingNodeAddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMORecord_servingNodeiPv6Address = CHOICE(name='servingNodeiPv6Address', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMORecord_mMEName = OCT_STR(name='mMEName', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMORecord_mMERealm = OCT_STR(name='mMERealm', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMORecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMORecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMORecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNSMORecord_userLocationInfoTime = OCT_STR(name='userLocationInfoTime', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGSNSMORecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNSMORecord._cont = ASN1Dict([
        ('recordType', _SGSNSMORecord_recordType),
        ('servedIMSI', _SGSNSMORecord_servedIMSI),
        ('servedIMEI', _SGSNSMORecord_servedIMEI),
        ('servedMSISDN', _SGSNSMORecord_servedMSISDN),
        ('msNetworkCapability', _SGSNSMORecord_msNetworkCapability),
        ('serviceCentre', _SGSNSMORecord_serviceCentre),
        ('recordingEntity', _SGSNSMORecord_recordingEntity),
        ('locationArea', _SGSNSMORecord_locationArea),
        ('routingArea', _SGSNSMORecord_routingArea),
        ('cellIdentifier', _SGSNSMORecord_cellIdentifier),
        ('messageReference', _SGSNSMORecord_messageReference),
        ('eventTimeStamp', _SGSNSMORecord_eventTimeStamp),
        ('smsResult', _SGSNSMORecord_smsResult),
        ('recordExtensions', _SGSNSMORecord_recordExtensions),
        ('nodeID', _SGSNSMORecord_nodeID),
        ('localSequenceNumber', _SGSNSMORecord_localSequenceNumber),
        ('chargingCharacteristics', _SGSNSMORecord_chargingCharacteristics),
        ('rATType', _SGSNSMORecord_rATType),
        ('destinationNumber', _SGSNSMORecord_destinationNumber),
        ('cAMELInformationSMS', _SGSNSMORecord_cAMELInformationSMS),
        ('chChSelectionMode', _SGSNSMORecord_chChSelectionMode),
        ('servingNodeType', _SGSNSMORecord_servingNodeType),
        ('servingNodeAddress', _SGSNSMORecord_servingNodeAddress),
        ('servingNodeiPv6Address', _SGSNSMORecord_servingNodeiPv6Address),
        ('mMEName', _SGSNSMORecord_mMEName),
        ('mMERealm', _SGSNSMORecord_mMERealm),
        ('userLocationInformation', _SGSNSMORecord_userLocationInformation),
        ('retransmission', _SGSNSMORecord_retransmission),
        ('servingNodePLMNIdentifier', _SGSNSMORecord_servingNodePLMNIdentifier),
        ('userLocationInfoTime', _SGSNSMORecord_userLocationInfoTime),
        ('cNOperatorSelectionEnt', _SGSNSMORecord_cNOperatorSelectionEnt),
        ])
    SGSNSMORecord._ext = None
    
    #-----< SGSNSMTRecord >-----#
    SGSNSMTRecord = SET(name='SGSNSMTRecord', mode=MODE_TYPE)
    _SGSNSMTRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNSMTRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNSMTRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNSMTRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNSMTRecord_msNetworkCapability = OCT_STR(name='msNetworkCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNSMTRecord_serviceCentre = OCT_STR(name='serviceCentre', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SGSNSMTRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')), opt=True)
    _SGSNSMTRecord_locationArea = OCT_STR(name='locationArea', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNSMTRecord_routingArea = OCT_STR(name='routingArea', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNSMTRecord_cellIdentifier = OCT_STR(name='cellIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNSMTRecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNSMTRecord_smsResult = CHOICE(name='smsResult', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SGSNSMTRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNSMTRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNSMTRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNSMTRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNSMTRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNSMTRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNSMTRecord_cAMELInformationSMS = SET(name='cAMELInformationSMS', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationSMS')), opt=True)
    _SGSNSMTRecord_originatingAddress = OCT_STR(name='originatingAddress', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SGSNSMTRecord_servingNodeType = ENUM(name='servingNodeType', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _SGSNSMTRecord_servingNodeAddress = CHOICE(name='servingNodeAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMTRecord_servingNodeiPv6Address = CHOICE(name='servingNodeiPv6Address', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMTRecord_mMEName = OCT_STR(name='mMEName', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMTRecord_mMERealm = OCT_STR(name='mMERealm', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMTRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMTRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMTRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNSMTRecord_userLocationInfoTime = OCT_STR(name='userLocationInfoTime', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGSNSMTRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNSMTRecord._cont = ASN1Dict([
        ('recordType', _SGSNSMTRecord_recordType),
        ('servedIMSI', _SGSNSMTRecord_servedIMSI),
        ('servedIMEI', _SGSNSMTRecord_servedIMEI),
        ('servedMSISDN', _SGSNSMTRecord_servedMSISDN),
        ('msNetworkCapability', _SGSNSMTRecord_msNetworkCapability),
        ('serviceCentre', _SGSNSMTRecord_serviceCentre),
        ('recordingEntity', _SGSNSMTRecord_recordingEntity),
        ('locationArea', _SGSNSMTRecord_locationArea),
        ('routingArea', _SGSNSMTRecord_routingArea),
        ('cellIdentifier', _SGSNSMTRecord_cellIdentifier),
        ('eventTimeStamp', _SGSNSMTRecord_eventTimeStamp),
        ('smsResult', _SGSNSMTRecord_smsResult),
        ('recordExtensions', _SGSNSMTRecord_recordExtensions),
        ('nodeID', _SGSNSMTRecord_nodeID),
        ('localSequenceNumber', _SGSNSMTRecord_localSequenceNumber),
        ('chargingCharacteristics', _SGSNSMTRecord_chargingCharacteristics),
        ('rATType', _SGSNSMTRecord_rATType),
        ('chChSelectionMode', _SGSNSMTRecord_chChSelectionMode),
        ('cAMELInformationSMS', _SGSNSMTRecord_cAMELInformationSMS),
        ('originatingAddress', _SGSNSMTRecord_originatingAddress),
        ('servingNodeType', _SGSNSMTRecord_servingNodeType),
        ('servingNodeAddress', _SGSNSMTRecord_servingNodeAddress),
        ('servingNodeiPv6Address', _SGSNSMTRecord_servingNodeiPv6Address),
        ('mMEName', _SGSNSMTRecord_mMEName),
        ('mMERealm', _SGSNSMTRecord_mMERealm),
        ('userLocationInformation', _SGSNSMTRecord_userLocationInformation),
        ('retransmission', _SGSNSMTRecord_retransmission),
        ('servingNodePLMNIdentifier', _SGSNSMTRecord_servingNodePLMNIdentifier),
        ('userLocationInfoTime', _SGSNSMTRecord_userLocationInfoTime),
        ('cNOperatorSelectionEnt', _SGSNSMTRecord_cNOperatorSelectionEnt),
        ])
    SGSNSMTRecord._ext = None
    
    #-----< SGSNMTLCSRecord >-----#
    SGSNMTLCSRecord = SET(name='SGSNMTLCSRecord', mode=MODE_TYPE)
    _SGSNMTLCSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMTLCSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SGSNMTLCSRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')))
    _SGSNMTLCSRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')))
    _SGSNMTLCSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNMTLCSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNMTLCSRecord_sgsnAddress = CHOICE(name='sgsnAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNMTLCSRecord_locationType = SEQ(name='locationType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _SGSNMTLCSRecord_lcsQos = OCT_STR(name='lcsQos', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _SGSNMTLCSRecord_lcsPriority = OCT_STR(name='lcsPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _SGSNMTLCSRecord_mlcNumber = OCT_STR(name='mlcNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SGSNMTLCSRecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMTLCSRecord_measurementDuration = INT(name='measurementDuration', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNMTLCSRecord_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _SGSNMTLCSRecord_privacyOverride = NULL(name='privacyOverride', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMTLCSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SGSNMTLCSRecord_routingArea = OCT_STR(name='routingArea', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNMTLCSRecord_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SGSNMTLCSRecord_positioningData = OCT_STR(name='positioningData', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _SGSNMTLCSRecord_lcsCause = OCT_STR(name='lcsCause', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _SGSNMTLCSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMTLCSRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMTLCSRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMTLCSRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNMTLCSRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNMTLCSRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNMTLCSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMTLCSRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMTLCSRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMTLCSRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNMTLCSRecord._cont = ASN1Dict([
        ('recordType', _SGSNMTLCSRecord_recordType),
        ('recordingEntity', _SGSNMTLCSRecord_recordingEntity),
        ('lcsClientType', _SGSNMTLCSRecord_lcsClientType),
        ('lcsClientIdentity', _SGSNMTLCSRecord_lcsClientIdentity),
        ('servedIMSI', _SGSNMTLCSRecord_servedIMSI),
        ('servedMSISDN', _SGSNMTLCSRecord_servedMSISDN),
        ('sgsnAddress', _SGSNMTLCSRecord_sgsnAddress),
        ('locationType', _SGSNMTLCSRecord_locationType),
        ('lcsQos', _SGSNMTLCSRecord_lcsQos),
        ('lcsPriority', _SGSNMTLCSRecord_lcsPriority),
        ('mlcNumber', _SGSNMTLCSRecord_mlcNumber),
        ('eventTimeStamp', _SGSNMTLCSRecord_eventTimeStamp),
        ('measurementDuration', _SGSNMTLCSRecord_measurementDuration),
        ('notificationToMSUser', _SGSNMTLCSRecord_notificationToMSUser),
        ('privacyOverride', _SGSNMTLCSRecord_privacyOverride),
        ('location', _SGSNMTLCSRecord_location),
        ('routingArea', _SGSNMTLCSRecord_routingArea),
        ('locationEstimate', _SGSNMTLCSRecord_locationEstimate),
        ('positioningData', _SGSNMTLCSRecord_positioningData),
        ('lcsCause', _SGSNMTLCSRecord_lcsCause),
        ('diagnostics', _SGSNMTLCSRecord_diagnostics),
        ('nodeID', _SGSNMTLCSRecord_nodeID),
        ('localSequenceNumber', _SGSNMTLCSRecord_localSequenceNumber),
        ('chargingCharacteristics', _SGSNMTLCSRecord_chargingCharacteristics),
        ('chChSelectionMode', _SGSNMTLCSRecord_chChSelectionMode),
        ('rATType', _SGSNMTLCSRecord_rATType),
        ('recordExtensions', _SGSNMTLCSRecord_recordExtensions),
        ('causeForRecClosing', _SGSNMTLCSRecord_causeForRecClosing),
        ('servingNodePLMNIdentifier', _SGSNMTLCSRecord_servingNodePLMNIdentifier),
        ('cNOperatorSelectionEnt', _SGSNMTLCSRecord_cNOperatorSelectionEnt),
        ])
    SGSNMTLCSRecord._ext = None
    
    #-----< SGSNMOLCSRecord >-----#
    SGSNMOLCSRecord = SET(name='SGSNMOLCSRecord', mode=MODE_TYPE)
    _SGSNMOLCSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMOLCSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SGSNMOLCSRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _SGSNMOLCSRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _SGSNMOLCSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNMOLCSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNMOLCSRecord_sgsnAddress = CHOICE(name='sgsnAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNMOLCSRecord_locationMethod = ENUM(name='locationMethod', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'LocationMethod')))
    _SGSNMOLCSRecord_lcsQos = OCT_STR(name='lcsQos', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _SGSNMOLCSRecord_lcsPriority = OCT_STR(name='lcsPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _SGSNMOLCSRecord_mlcNumber = OCT_STR(name='mlcNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SGSNMOLCSRecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMOLCSRecord_measurementDuration = INT(name='measurementDuration', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNMOLCSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SGSNMOLCSRecord_routingArea = OCT_STR(name='routingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNMOLCSRecord_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SGSNMOLCSRecord_positioningData = OCT_STR(name='positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _SGSNMOLCSRecord_lcsCause = OCT_STR(name='lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _SGSNMOLCSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMOLCSRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMOLCSRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMOLCSRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNMOLCSRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNMOLCSRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNMOLCSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMOLCSRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMOLCSRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMOLCSRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNMOLCSRecord._cont = ASN1Dict([
        ('recordType', _SGSNMOLCSRecord_recordType),
        ('recordingEntity', _SGSNMOLCSRecord_recordingEntity),
        ('lcsClientType', _SGSNMOLCSRecord_lcsClientType),
        ('lcsClientIdentity', _SGSNMOLCSRecord_lcsClientIdentity),
        ('servedIMSI', _SGSNMOLCSRecord_servedIMSI),
        ('servedMSISDN', _SGSNMOLCSRecord_servedMSISDN),
        ('sgsnAddress', _SGSNMOLCSRecord_sgsnAddress),
        ('locationMethod', _SGSNMOLCSRecord_locationMethod),
        ('lcsQos', _SGSNMOLCSRecord_lcsQos),
        ('lcsPriority', _SGSNMOLCSRecord_lcsPriority),
        ('mlcNumber', _SGSNMOLCSRecord_mlcNumber),
        ('eventTimeStamp', _SGSNMOLCSRecord_eventTimeStamp),
        ('measurementDuration', _SGSNMOLCSRecord_measurementDuration),
        ('location', _SGSNMOLCSRecord_location),
        ('routingArea', _SGSNMOLCSRecord_routingArea),
        ('locationEstimate', _SGSNMOLCSRecord_locationEstimate),
        ('positioningData', _SGSNMOLCSRecord_positioningData),
        ('lcsCause', _SGSNMOLCSRecord_lcsCause),
        ('diagnostics', _SGSNMOLCSRecord_diagnostics),
        ('nodeID', _SGSNMOLCSRecord_nodeID),
        ('localSequenceNumber', _SGSNMOLCSRecord_localSequenceNumber),
        ('chargingCharacteristics', _SGSNMOLCSRecord_chargingCharacteristics),
        ('chChSelectionMode', _SGSNMOLCSRecord_chChSelectionMode),
        ('rATType', _SGSNMOLCSRecord_rATType),
        ('recordExtensions', _SGSNMOLCSRecord_recordExtensions),
        ('causeForRecClosing', _SGSNMOLCSRecord_causeForRecClosing),
        ('servingNodePLMNIdentifier', _SGSNMOLCSRecord_servingNodePLMNIdentifier),
        ('cNOperatorSelectionEnt', _SGSNMOLCSRecord_cNOperatorSelectionEnt),
        ])
    SGSNMOLCSRecord._ext = None
    
    #-----< SGSNNILCSRecord >-----#
    SGSNNILCSRecord = SET(name='SGSNNILCSRecord', mode=MODE_TYPE)
    _SGSNNILCSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNNILCSRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SGSNNILCSRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _SGSNNILCSRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _SGSNNILCSRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SGSNNILCSRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNNILCSRecord_sgsnAddress = CHOICE(name='sgsnAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNNILCSRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNNILCSRecord_lcsQos = OCT_STR(name='lcsQos', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _SGSNNILCSRecord_lcsPriority = OCT_STR(name='lcsPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _SGSNNILCSRecord_mlcNumber = OCT_STR(name='mlcNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SGSNNILCSRecord_eventTimeStamp = OCT_STR(name='eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNNILCSRecord_measurementDuration = INT(name='measurementDuration', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNNILCSRecord_location = SEQ(name='location', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SGSNNILCSRecord_routingArea = OCT_STR(name='routingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNNILCSRecord_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SGSNNILCSRecord_positioningData = OCT_STR(name='positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _SGSNNILCSRecord_lcsCause = OCT_STR(name='lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _SGSNNILCSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNNILCSRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNNILCSRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNNILCSRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNNILCSRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNNILCSRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNNILCSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNNILCSRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNNILCSRecord_servingNodePLMNIdentifier = OCT_STR(name='servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNNILCSRecord_cNOperatorSelectionEnt = ENUM(name='cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNNILCSRecord._cont = ASN1Dict([
        ('recordType', _SGSNNILCSRecord_recordType),
        ('recordingEntity', _SGSNNILCSRecord_recordingEntity),
        ('lcsClientType', _SGSNNILCSRecord_lcsClientType),
        ('lcsClientIdentity', _SGSNNILCSRecord_lcsClientIdentity),
        ('servedIMSI', _SGSNNILCSRecord_servedIMSI),
        ('servedMSISDN', _SGSNNILCSRecord_servedMSISDN),
        ('sgsnAddress', _SGSNNILCSRecord_sgsnAddress),
        ('servedIMEI', _SGSNNILCSRecord_servedIMEI),
        ('lcsQos', _SGSNNILCSRecord_lcsQos),
        ('lcsPriority', _SGSNNILCSRecord_lcsPriority),
        ('mlcNumber', _SGSNNILCSRecord_mlcNumber),
        ('eventTimeStamp', _SGSNNILCSRecord_eventTimeStamp),
        ('measurementDuration', _SGSNNILCSRecord_measurementDuration),
        ('location', _SGSNNILCSRecord_location),
        ('routingArea', _SGSNNILCSRecord_routingArea),
        ('locationEstimate', _SGSNNILCSRecord_locationEstimate),
        ('positioningData', _SGSNNILCSRecord_positioningData),
        ('lcsCause', _SGSNNILCSRecord_lcsCause),
        ('diagnostics', _SGSNNILCSRecord_diagnostics),
        ('nodeID', _SGSNNILCSRecord_nodeID),
        ('localSequenceNumber', _SGSNNILCSRecord_localSequenceNumber),
        ('chargingCharacteristics', _SGSNNILCSRecord_chargingCharacteristics),
        ('chChSelectionMode', _SGSNNILCSRecord_chChSelectionMode),
        ('rATType', _SGSNNILCSRecord_rATType),
        ('recordExtensions', _SGSNNILCSRecord_recordExtensions),
        ('causeForRecClosing', _SGSNNILCSRecord_causeForRecClosing),
        ('servingNodePLMNIdentifier', _SGSNNILCSRecord_servingNodePLMNIdentifier),
        ('cNOperatorSelectionEnt', _SGSNNILCSRecord_cNOperatorSelectionEnt),
        ])
    SGSNNILCSRecord._ext = None
    
    #-----< SGSNMBMSRecord >-----#
    SGSNMBMSRecord = SET(name='SGSNMBMSRecord', mode=MODE_TYPE)
    _SGSNMBMSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMBMSRecord_ggsnAddress = CHOICE(name='ggsnAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGSNMBMSRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _SGSNMBMSRecord_listofRAs = SEQ_OF(name='listofRAs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNMBMSRecord_listofRAs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')))
    _SGSNMBMSRecord_listofRAs._cont = __SGSNMBMSRecord_listofRAs__item_
    _SGSNMBMSRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SGSNMBMSRecord_servedPDPAddress = CHOICE(name='servedPDPAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGSNMBMSRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNMBMSRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _SGSNMBMSRecord_listOfTrafficVolumes._cont = __SGSNMBMSRecord_listOfTrafficVolumes__item_
    _SGSNMBMSRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMBMSRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SGSNMBMSRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMBMSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMBMSRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMBMSRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMBMSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMBMSRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMBMSRecord_sgsnPLMNIdentifier = OCT_STR(name='sgsnPLMNIdentifier', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMBMSRecord_numberofReceivingUE = INT(name='numberofReceivingUE', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMBMSRecord_mbmsInformation = SET(name='mbmsInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    SGSNMBMSRecord._cont = ASN1Dict([
        ('recordType', _SGSNMBMSRecord_recordType),
        ('ggsnAddress', _SGSNMBMSRecord_ggsnAddress),
        ('chargingID', _SGSNMBMSRecord_chargingID),
        ('listofRAs', _SGSNMBMSRecord_listofRAs),
        ('accessPointNameNI', _SGSNMBMSRecord_accessPointNameNI),
        ('servedPDPAddress', _SGSNMBMSRecord_servedPDPAddress),
        ('listOfTrafficVolumes', _SGSNMBMSRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _SGSNMBMSRecord_recordOpeningTime),
        ('duration', _SGSNMBMSRecord_duration),
        ('causeForRecClosing', _SGSNMBMSRecord_causeForRecClosing),
        ('diagnostics', _SGSNMBMSRecord_diagnostics),
        ('recordSequenceNumber', _SGSNMBMSRecord_recordSequenceNumber),
        ('nodeID', _SGSNMBMSRecord_nodeID),
        ('recordExtensions', _SGSNMBMSRecord_recordExtensions),
        ('localSequenceNumber', _SGSNMBMSRecord_localSequenceNumber),
        ('sgsnPLMNIdentifier', _SGSNMBMSRecord_sgsnPLMNIdentifier),
        ('numberofReceivingUE', _SGSNMBMSRecord_numberofReceivingUE),
        ('mbmsInformation', _SGSNMBMSRecord_mbmsInformation),
        ])
    SGSNMBMSRecord._ext = None
    
    #-----< GGSNMBMSRecord >-----#
    GGSNMBMSRecord = SET(name='GGSNMBMSRecord', mode=MODE_TYPE)
    _GGSNMBMSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _GGSNMBMSRecord_ggsnAddress = CHOICE(name='ggsnAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GGSNMBMSRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _GGSNMBMSRecord_listofDownstreamNodes = SEQ_OF(name='listofDownstreamNodes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GGSNMBMSRecord_listofDownstreamNodes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GGSNMBMSRecord_listofDownstreamNodes._cont = __GGSNMBMSRecord_listofDownstreamNodes__item_
    _GGSNMBMSRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _GGSNMBMSRecord_servedPDPAddress = CHOICE(name='servedPDPAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _GGSNMBMSRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GGSNMBMSRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _GGSNMBMSRecord_listOfTrafficVolumes._cont = __GGSNMBMSRecord_listOfTrafficVolumes__item_
    _GGSNMBMSRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _GGSNMBMSRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _GGSNMBMSRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _GGSNMBMSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _GGSNMBMSRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GGSNMBMSRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _GGSNMBMSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _GGSNMBMSRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _GGSNMBMSRecord_mbmsInformation = SET(name='mbmsInformation', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    GGSNMBMSRecord._cont = ASN1Dict([
        ('recordType', _GGSNMBMSRecord_recordType),
        ('ggsnAddress', _GGSNMBMSRecord_ggsnAddress),
        ('chargingID', _GGSNMBMSRecord_chargingID),
        ('listofDownstreamNodes', _GGSNMBMSRecord_listofDownstreamNodes),
        ('accessPointNameNI', _GGSNMBMSRecord_accessPointNameNI),
        ('servedPDPAddress', _GGSNMBMSRecord_servedPDPAddress),
        ('listOfTrafficVolumes', _GGSNMBMSRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _GGSNMBMSRecord_recordOpeningTime),
        ('duration', _GGSNMBMSRecord_duration),
        ('causeForRecClosing', _GGSNMBMSRecord_causeForRecClosing),
        ('diagnostics', _GGSNMBMSRecord_diagnostics),
        ('recordSequenceNumber', _GGSNMBMSRecord_recordSequenceNumber),
        ('nodeID', _GGSNMBMSRecord_nodeID),
        ('recordExtensions', _GGSNMBMSRecord_recordExtensions),
        ('localSequenceNumber', _GGSNMBMSRecord_localSequenceNumber),
        ('mbmsInformation', _GGSNMBMSRecord_mbmsInformation),
        ])
    GGSNMBMSRecord._ext = None
    
    #-----< GWMBMSRecord >-----#
    GWMBMSRecord = SET(name='GWMBMSRecord', mode=MODE_TYPE)
    _GWMBMSRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _GWMBMSRecord_mbmsGWAddress = CHOICE(name='mbmsGWAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GWMBMSRecord_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _GWMBMSRecord_listofDownstreamNodes = SEQ_OF(name='listofDownstreamNodes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GWMBMSRecord_listofDownstreamNodes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GWMBMSRecord_listofDownstreamNodes._cont = __GWMBMSRecord_listofDownstreamNodes__item_
    _GWMBMSRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _GWMBMSRecord_pdpPDNType = OCT_STR(name='pdpPDNType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _GWMBMSRecord_servedPDPPDNAddress = CHOICE(name='servedPDPPDNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _GWMBMSRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GWMBMSRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _GWMBMSRecord_listOfTrafficVolumes._cont = __GWMBMSRecord_listOfTrafficVolumes__item_
    _GWMBMSRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _GWMBMSRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _GWMBMSRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _GWMBMSRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _GWMBMSRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GWMBMSRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _GWMBMSRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _GWMBMSRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _GWMBMSRecord_mbmsInformation = SET(name='mbmsInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    _GWMBMSRecord_commonTeid = OCT_STR(name='commonTeid', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CTEID')), opt=True)
    _GWMBMSRecord_iPMulticastSourceAddress = CHOICE(name='iPMulticastSourceAddress', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    GWMBMSRecord._cont = ASN1Dict([
        ('recordType', _GWMBMSRecord_recordType),
        ('mbmsGWAddress', _GWMBMSRecord_mbmsGWAddress),
        ('chargingID', _GWMBMSRecord_chargingID),
        ('listofDownstreamNodes', _GWMBMSRecord_listofDownstreamNodes),
        ('accessPointNameNI', _GWMBMSRecord_accessPointNameNI),
        ('pdpPDNType', _GWMBMSRecord_pdpPDNType),
        ('servedPDPPDNAddress', _GWMBMSRecord_servedPDPPDNAddress),
        ('listOfTrafficVolumes', _GWMBMSRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _GWMBMSRecord_recordOpeningTime),
        ('duration', _GWMBMSRecord_duration),
        ('causeForRecClosing', _GWMBMSRecord_causeForRecClosing),
        ('diagnostics', _GWMBMSRecord_diagnostics),
        ('recordSequenceNumber', _GWMBMSRecord_recordSequenceNumber),
        ('nodeID', _GWMBMSRecord_nodeID),
        ('recordExtensions', _GWMBMSRecord_recordExtensions),
        ('localSequenceNumber', _GWMBMSRecord_localSequenceNumber),
        ('mbmsInformation', _GWMBMSRecord_mbmsInformation),
        ('commonTeid', _GWMBMSRecord_commonTeid),
        ('iPMulticastSourceAddress', _GWMBMSRecord_iPMulticastSourceAddress),
        ])
    GWMBMSRecord._ext = None
    
    #-----< AccessAvailabilityChangeReason >-----#
    AccessAvailabilityChangeReason = INT(name='AccessAvailabilityChangeReason', mode=MODE_TYPE)
    AccessAvailabilityChangeReason._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< AccessLineIdentifier >-----#
    AccessLineIdentifier = SEQ(name='AccessLineIdentifier', mode=MODE_TYPE)
    _AccessLineIdentifier_physicalAccessID = STR_UTF8(name='physicalAccessID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessLineIdentifier_logicalAccessID = OCT_STR(name='logicalAccessID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AccessLineIdentifier._cont = ASN1Dict([
        ('physicalAccessID', _AccessLineIdentifier_physicalAccessID),
        ('logicalAccessID', _AccessLineIdentifier_logicalAccessID),
        ])
    AccessLineIdentifier._ext = None
    
    #-----< AccessPointNameNI >-----#
    AccessPointNameNI = STR_IA5(name='AccessPointNameNI', mode=MODE_TYPE)
    AccessPointNameNI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< AccessPointNameOI >-----#
    AccessPointNameOI = STR_IA5(name='AccessPointNameOI', mode=MODE_TYPE)
    AccessPointNameOI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=37)], ev=None, er=[])
    
    #-----< ADCRuleBaseName >-----#
    ADCRuleBaseName = STR_IA5(name='ADCRuleBaseName', mode=MODE_TYPE)
    
    #-----< AdditionalExceptionReports >-----#
    AdditionalExceptionReports = ENUM(name='AdditionalExceptionReports', mode=MODE_TYPE)
    AdditionalExceptionReports._cont = ASN1Dict([('notAllowed', 0), ('allowed', 1)])
    AdditionalExceptionReports._ext = None
    
    #-----< AFChargingIdentifier >-----#
    AFChargingIdentifier = OCT_STR(name='AFChargingIdentifier', mode=MODE_TYPE)
    
    #-----< AFRecordInformation >-----#
    AFRecordInformation = SEQ(name='AFRecordInformation', mode=MODE_TYPE)
    _AFRecordInformation_aFChargingIdentifier = OCT_STR(name='aFChargingIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AFChargingIdentifier')))
    _AFRecordInformation_flows = SEQ(name='flows', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'Flows')), opt=True)
    AFRecordInformation._cont = ASN1Dict([
        ('aFChargingIdentifier', _AFRecordInformation_aFChargingIdentifier),
        ('flows', _AFRecordInformation_flows),
        ])
    AFRecordInformation._ext = None
    
    #-----< APNRateControl >-----#
    APNRateControl = SEQ(name='APNRateControl', mode=MODE_TYPE)
    _APNRateControl_aPNRateControlUplink = SEQ(name='aPNRateControlUplink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControlParameters')), opt=True)
    _APNRateControl_aPNRateControlDownlink = SEQ(name='aPNRateControlDownlink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControlParameters')), opt=True)
    APNRateControl._cont = ASN1Dict([
        ('aPNRateControlUplink', _APNRateControl_aPNRateControlUplink),
        ('aPNRateControlDownlink', _APNRateControl_aPNRateControlDownlink),
        ])
    APNRateControl._ext = None
    
    #-----< APNRateControlParameters >-----#
    APNRateControlParameters = SEQ(name='APNRateControlParameters', mode=MODE_TYPE)
    _APNRateControlParameters_additionalExceptionReports = ENUM(name='additionalExceptionReports', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AdditionalExceptionReports')), opt=True)
    _APNRateControlParameters_rateControlTimeUnit = INT(name='rateControlTimeUnit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RateControlTimeUnit')), opt=True)
    _APNRateControlParameters_rateControlMaxRate = INT(name='rateControlMaxRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APNRateControlParameters_rateControlMaxMessageSize = INT(name='rateControlMaxMessageSize', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    APNRateControlParameters._cont = ASN1Dict([
        ('additionalExceptionReports', _APNRateControlParameters_additionalExceptionReports),
        ('rateControlTimeUnit', _APNRateControlParameters_rateControlTimeUnit),
        ('rateControlMaxRate', _APNRateControlParameters_rateControlMaxRate),
        ('rateControlMaxMessageSize', _APNRateControlParameters_rateControlMaxMessageSize),
        ])
    APNRateControlParameters._ext = None
    
    #-----< APNSelectionMode >-----#
    APNSelectionMode = ENUM(name='APNSelectionMode', mode=MODE_TYPE)
    APNSelectionMode._cont = ASN1Dict([('mSorNetworkProvidedSubscriptionVerified', 0), ('mSProvidedSubscriptionNotVerified', 1), ('networkProvidedSubscriptionNotVerified', 2)])
    APNSelectionMode._ext = None
    
    #-----< CalleePartyInformation >-----#
    CalleePartyInformation = SEQ(name='CalleePartyInformation', mode=MODE_TYPE)
    _CalleePartyInformation_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CalleePartyInformation_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CalleePartyInformation_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CalleePartyInformation_list_Of_Called_Asserted_Identity__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _CalleePartyInformation_list_Of_Called_Asserted_Identity._cont = __CalleePartyInformation_list_Of_Called_Asserted_Identity__item_
    CalleePartyInformation._cont = ASN1Dict([
        ('called-Party-Address', _CalleePartyInformation_called_Party_Address),
        ('requested-Party-Address', _CalleePartyInformation_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _CalleePartyInformation_list_Of_Called_Asserted_Identity),
        ])
    CalleePartyInformation._ext = None
    
    #-----< CAMELAccessPointNameNI >-----#
    CAMELAccessPointNameNI = STR_IA5(name='CAMELAccessPointNameNI', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')))
    
    #-----< CAMELAccessPointNameOI >-----#
    CAMELAccessPointNameOI = STR_IA5(name='CAMELAccessPointNameOI', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameOI')))
    
    #-----< CAMELInformationMM >-----#
    CAMELInformationMM = SET(name='CAMELInformationMM', mode=MODE_TYPE)
    _CAMELInformationMM_sCFAddress = OCT_STR(name='sCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SCFAddress')), opt=True)
    _CAMELInformationMM_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELInformationMM_defaultTransactionHandling = ENUM(name='defaultTransactionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')), opt=True)
    _CAMELInformationMM_numberOfDPEncountered = INT(name='numberOfDPEncountered', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NumberOfDPEncountered')), opt=True)
    _CAMELInformationMM_levelOfCAMELService = BIT_STR(name='levelOfCAMELService', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _CAMELInformationMM_freeFormatData = OCT_STR(name='freeFormatData', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformationMM_fFDAppendIndicator = BOOL(name='fFDAppendIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FFDAppendIndicator')), opt=True)
    CAMELInformationMM._cont = ASN1Dict([
        ('sCFAddress', _CAMELInformationMM_sCFAddress),
        ('serviceKey', _CAMELInformationMM_serviceKey),
        ('defaultTransactionHandling', _CAMELInformationMM_defaultTransactionHandling),
        ('numberOfDPEncountered', _CAMELInformationMM_numberOfDPEncountered),
        ('levelOfCAMELService', _CAMELInformationMM_levelOfCAMELService),
        ('freeFormatData', _CAMELInformationMM_freeFormatData),
        ('fFDAppendIndicator', _CAMELInformationMM_fFDAppendIndicator),
        ])
    CAMELInformationMM._ext = None
    
    #-----< CAMELInformationPDP >-----#
    CAMELInformationPDP = SET(name='CAMELInformationPDP', mode=MODE_TYPE)
    _CAMELInformationPDP_sCFAddress = OCT_STR(name='sCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SCFAddress')), opt=True)
    _CAMELInformationPDP_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELInformationPDP_defaultTransactionHandling = ENUM(name='defaultTransactionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')), opt=True)
    _CAMELInformationPDP_cAMELAccessPointNameNI = STR_IA5(name='cAMELAccessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELAccessPointNameNI')), opt=True)
    _CAMELInformationPDP_cAMELAccessPointNameOI = STR_IA5(name='cAMELAccessPointNameOI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELAccessPointNameOI')), opt=True)
    _CAMELInformationPDP_numberOfDPEncountered = INT(name='numberOfDPEncountered', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NumberOfDPEncountered')), opt=True)
    _CAMELInformationPDP_levelOfCAMELService = BIT_STR(name='levelOfCAMELService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _CAMELInformationPDP_freeFormatData = OCT_STR(name='freeFormatData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformationPDP_fFDAppendIndicator = BOOL(name='fFDAppendIndicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FFDAppendIndicator')), opt=True)
    CAMELInformationPDP._cont = ASN1Dict([
        ('sCFAddress', _CAMELInformationPDP_sCFAddress),
        ('serviceKey', _CAMELInformationPDP_serviceKey),
        ('defaultTransactionHandling', _CAMELInformationPDP_defaultTransactionHandling),
        ('cAMELAccessPointNameNI', _CAMELInformationPDP_cAMELAccessPointNameNI),
        ('cAMELAccessPointNameOI', _CAMELInformationPDP_cAMELAccessPointNameOI),
        ('numberOfDPEncountered', _CAMELInformationPDP_numberOfDPEncountered),
        ('levelOfCAMELService', _CAMELInformationPDP_levelOfCAMELService),
        ('freeFormatData', _CAMELInformationPDP_freeFormatData),
        ('fFDAppendIndicator', _CAMELInformationPDP_fFDAppendIndicator),
        ])
    CAMELInformationPDP._ext = None
    
    #-----< CAMELInformationSMS >-----#
    CAMELInformationSMS = SET(name='CAMELInformationSMS', mode=MODE_TYPE)
    _CAMELInformationSMS_sCFAddress = OCT_STR(name='sCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SCFAddress')), opt=True)
    _CAMELInformationSMS_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELInformationSMS_defaultSMSHandling = ENUM(name='defaultSMSHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')), opt=True)
    _CAMELInformationSMS_cAMELCallingPartyNumber = OCT_STR(name='cAMELCallingPartyNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _CAMELInformationSMS_cAMELDestinationSubscriberNumber = OCT_STR(name='cAMELDestinationSubscriberNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _CAMELInformationSMS_cAMELSMSCAddress = OCT_STR(name='cAMELSMSCAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _CAMELInformationSMS_freeFormatData = OCT_STR(name='freeFormatData', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformationSMS_smsReferenceNumber = OCT_STR(name='smsReferenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    CAMELInformationSMS._cont = ASN1Dict([
        ('sCFAddress', _CAMELInformationSMS_sCFAddress),
        ('serviceKey', _CAMELInformationSMS_serviceKey),
        ('defaultSMSHandling', _CAMELInformationSMS_defaultSMSHandling),
        ('cAMELCallingPartyNumber', _CAMELInformationSMS_cAMELCallingPartyNumber),
        ('cAMELDestinationSubscriberNumber', _CAMELInformationSMS_cAMELDestinationSubscriberNumber),
        ('cAMELSMSCAddress', _CAMELInformationSMS_cAMELSMSCAddress),
        ('freeFormatData', _CAMELInformationSMS_freeFormatData),
        ('smsReferenceNumber', _CAMELInformationSMS_smsReferenceNumber),
        ])
    CAMELInformationSMS._ext = None
    
    #-----< ChangeCondition >-----#
    ChangeCondition = ENUM(name='ChangeCondition', mode=MODE_TYPE)
    ChangeCondition._cont = ASN1Dict([('qoSChange', 0), ('tariffTime', 1), ('recordClosure', 2), ('cGI-SAICHange', 6), ('rAIChange', 7), ('dT-Establishment', 8), ('dT-Removal', 9), ('eCGIChange', 10), ('tAIChange', 11), ('userLocationChange', 12), ('userCSGInformationChange', 13), ('presenceInPRAChange', 14), ('removalOfAccess', 15), ('unusabilityOfAccess', 16), ('indirectChangeCondition', 17), ('userPlaneToUEChange', 18), ('servingPLMNRateControlChange', 19), ('threeGPPPSDataOffStatusChange', 20), ('aPNRateControlChange', 21)])
    ChangeCondition._ext = None
    
    #-----< ChangeOfCharCondition >-----#
    ChangeOfCharCondition = SEQ(name='ChangeOfCharCondition', mode=MODE_TYPE)
    _ChangeOfCharCondition_qosRequested = OCT_STR(name='qosRequested', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfCharCondition_qosNegotiated = OCT_STR(name='qosNegotiated', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfCharCondition_dataVolumeGPRSUplink = INT(name='dataVolumeGPRSUplink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfCharCondition_dataVolumeGPRSDownlink = INT(name='dataVolumeGPRSDownlink', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfCharCondition_changeCondition = ENUM(name='changeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeCondition')))
    _ChangeOfCharCondition_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfCharCondition_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfCharCondition_ePCQoSInformation = SEQ(name='ePCQoSInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPCQoSInformation')), opt=True)
    _ChangeOfCharCondition_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _ChangeOfCharCondition_presenceReportingAreaStatus = ENUM(name='presenceReportingAreaStatus', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _ChangeOfCharCondition_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _ChangeOfCharCondition_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _ChangeOfCharCondition_enhancedDiagnostics = SEQ(name='enhancedDiagnostics', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _ChangeOfCharCondition_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ChangeOfCharCondition_accessAvailabilityChangeReason = INT(name='accessAvailabilityChangeReason', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessAvailabilityChangeReason')), opt=True)
    _ChangeOfCharCondition_uWANUserLocationInformation = SEQ(name='uWANUserLocationInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _ChangeOfCharCondition_relatedChangeOfCharCondition = SEQ(name='relatedChangeOfCharCondition', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RelatedChangeOfCharCondition')), opt=True)
    _ChangeOfCharCondition_cPCIoTEPSOptimisationIndicator = BOOL(name='cPCIoTEPSOptimisationIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CPCIoTEPSOptimisationIndicator')), opt=True)
    _ChangeOfCharCondition_servingPLMNRateControl = SEQ(name='servingPLMNRateControl', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _ChangeOfCharCondition_threeGPPPSDataOffStatus = ENUM(name='threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _ChangeOfCharCondition_listOfPresenceReportingAreaInformation = SEQ_OF(name='listOfPresenceReportingAreaInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfCharCondition_listOfPresenceReportingAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')))
    _ChangeOfCharCondition_listOfPresenceReportingAreaInformation._cont = __ChangeOfCharCondition_listOfPresenceReportingAreaInformation__item_
    _ChangeOfCharCondition_aPNRateControl = SEQ(name='aPNRateControl', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    ChangeOfCharCondition._cont = ASN1Dict([
        ('qosRequested', _ChangeOfCharCondition_qosRequested),
        ('qosNegotiated', _ChangeOfCharCondition_qosNegotiated),
        ('dataVolumeGPRSUplink', _ChangeOfCharCondition_dataVolumeGPRSUplink),
        ('dataVolumeGPRSDownlink', _ChangeOfCharCondition_dataVolumeGPRSDownlink),
        ('changeCondition', _ChangeOfCharCondition_changeCondition),
        ('changeTime', _ChangeOfCharCondition_changeTime),
        ('userLocationInformation', _ChangeOfCharCondition_userLocationInformation),
        ('ePCQoSInformation', _ChangeOfCharCondition_ePCQoSInformation),
        ('chargingID', _ChangeOfCharCondition_chargingID),
        ('presenceReportingAreaStatus', _ChangeOfCharCondition_presenceReportingAreaStatus),
        ('userCSGInformation', _ChangeOfCharCondition_userCSGInformation),
        ('diagnostics', _ChangeOfCharCondition_diagnostics),
        ('enhancedDiagnostics', _ChangeOfCharCondition_enhancedDiagnostics),
        ('rATType', _ChangeOfCharCondition_rATType),
        ('accessAvailabilityChangeReason', _ChangeOfCharCondition_accessAvailabilityChangeReason),
        ('uWANUserLocationInformation', _ChangeOfCharCondition_uWANUserLocationInformation),
        ('relatedChangeOfCharCondition', _ChangeOfCharCondition_relatedChangeOfCharCondition),
        ('cPCIoTEPSOptimisationIndicator', _ChangeOfCharCondition_cPCIoTEPSOptimisationIndicator),
        ('servingPLMNRateControl', _ChangeOfCharCondition_servingPLMNRateControl),
        ('threeGPPPSDataOffStatus', _ChangeOfCharCondition_threeGPPPSDataOffStatus),
        ('listOfPresenceReportingAreaInformation', _ChangeOfCharCondition_listOfPresenceReportingAreaInformation),
        ('aPNRateControl', _ChangeOfCharCondition_aPNRateControl),
        ])
    ChangeOfCharCondition._ext = None
    
    #-----< ChangeOfMBMSCondition >-----#
    ChangeOfMBMSCondition = SEQ(name='ChangeOfMBMSCondition', mode=MODE_TYPE)
    _ChangeOfMBMSCondition_qosRequested = OCT_STR(name='qosRequested', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfMBMSCondition_qosNegotiated = OCT_STR(name='qosNegotiated', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfMBMSCondition_dataVolumeMBMSUplink = INT(name='dataVolumeMBMSUplink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeMBMS')), opt=True)
    _ChangeOfMBMSCondition_dataVolumeMBMSDownlink = INT(name='dataVolumeMBMSDownlink', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeMBMS')))
    _ChangeOfMBMSCondition_changeCondition = ENUM(name='changeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeCondition')))
    _ChangeOfMBMSCondition_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfMBMSCondition_failureHandlingContinue = BOOL(name='failureHandlingContinue', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FailureHandlingContinue')), opt=True)
    ChangeOfMBMSCondition._cont = ASN1Dict([
        ('qosRequested', _ChangeOfMBMSCondition_qosRequested),
        ('qosNegotiated', _ChangeOfMBMSCondition_qosNegotiated),
        ('dataVolumeMBMSUplink', _ChangeOfMBMSCondition_dataVolumeMBMSUplink),
        ('dataVolumeMBMSDownlink', _ChangeOfMBMSCondition_dataVolumeMBMSDownlink),
        ('changeCondition', _ChangeOfMBMSCondition_changeCondition),
        ('changeTime', _ChangeOfMBMSCondition_changeTime),
        ('failureHandlingContinue', _ChangeOfMBMSCondition_failureHandlingContinue),
        ])
    ChangeOfMBMSCondition._ext = None
    
    #-----< ChangeOfServiceCondition >-----#
    ChangeOfServiceCondition = SEQ(name='ChangeOfServiceCondition', mode=MODE_TYPE)
    _ChangeOfServiceCondition_ratingGroup = INT(name='ratingGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RatingGroupId')))
    _ChangeOfServiceCondition_chargingRuleBaseName = STR_IA5(name='chargingRuleBaseName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingRuleBaseName')), opt=True)
    _ChangeOfServiceCondition_resultCode = INT(name='resultCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ResultCode')), opt=True)
    _ChangeOfServiceCondition_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ChangeOfServiceCondition_timeOfFirstUsage = OCT_STR(name='timeOfFirstUsage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ChangeOfServiceCondition_timeOfLastUsage = OCT_STR(name='timeOfLastUsage', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ChangeOfServiceCondition_timeUsage = INT(name='timeUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _ChangeOfServiceCondition_serviceConditionChange = BIT_STR(name='serviceConditionChange', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServiceConditionChange')))
    _ChangeOfServiceCondition_qoSInformationNeg = SEQ(name='qoSInformationNeg', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPCQoSInformation')), opt=True)
    _ChangeOfServiceCondition_servingNodeAddress = CHOICE(name='servingNodeAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _ChangeOfServiceCondition_datavolumeFBCUplink = INT(name='datavolumeFBCUplink', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfServiceCondition_datavolumeFBCDownlink = INT(name='datavolumeFBCDownlink', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfServiceCondition_timeOfReport = OCT_STR(name='timeOfReport', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfServiceCondition_failureHandlingContinue = BOOL(name='failureHandlingContinue', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FailureHandlingContinue')), opt=True)
    _ChangeOfServiceCondition_serviceIdentifier = INT(name='serviceIdentifier', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServiceIdentifier')), opt=True)
    _ChangeOfServiceCondition_pSFurnishChargingInformation = SEQ(name='pSFurnishChargingInformation', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _ChangeOfServiceCondition_aFRecordInformation = SEQ_OF(name='aFRecordInformation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfServiceCondition_aFRecordInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'AFRecordInformation')))
    _ChangeOfServiceCondition_aFRecordInformation._cont = __ChangeOfServiceCondition_aFRecordInformation__item_
    _ChangeOfServiceCondition_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_eventBasedChargingInformation = SEQ(name='eventBasedChargingInformation', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EventBasedChargingInformation')), opt=True)
    _ChangeOfServiceCondition_timeQuotaMechanism = SEQ(name='timeQuotaMechanism', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TimeQuotaMechanism')), opt=True)
    _ChangeOfServiceCondition_serviceSpecificInfo = SEQ_OF(name='serviceSpecificInfo', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfServiceCondition_serviceSpecificInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceSpecificInfo')))
    _ChangeOfServiceCondition_serviceSpecificInfo._cont = __ChangeOfServiceCondition_serviceSpecificInfo__item_
    _ChangeOfServiceCondition_threeGPP2UserLocationInformation = OCT_STR(name='threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_sponsorIdentity = OCT_STR(name='sponsorIdentity', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_applicationServiceProviderIdentity = OCT_STR(name='applicationServiceProviderIdentity', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_aDCRuleBaseName = STR_IA5(name='aDCRuleBaseName', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ADCRuleBaseName')), opt=True)
    _ChangeOfServiceCondition_presenceReportingAreaStatus = ENUM(name='presenceReportingAreaStatus', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _ChangeOfServiceCondition_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _ChangeOfServiceCondition_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ChangeOfServiceCondition_uWANUserLocationInformation = SEQ(name='uWANUserLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _ChangeOfServiceCondition_relatedChangeOfServiceCondition = SEQ(name='relatedChangeOfServiceCondition', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RelatedChangeOfServiceCondition')), opt=True)
    _ChangeOfServiceCondition_servingPLMNRateControl = SEQ(name='servingPLMNRateControl', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _ChangeOfServiceCondition_aPNRateControl = SEQ(name='aPNRateControl', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _ChangeOfServiceCondition_threeGPPPSDataOffStatus = ENUM(name='threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _ChangeOfServiceCondition_trafficSteeringPolicyIDDownlink = OCT_STR(name='trafficSteeringPolicyIDDownlink', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TrafficSteeringPolicyIDDownlink')), opt=True)
    _ChangeOfServiceCondition_trafficSteeringPolicyIDUplink = OCT_STR(name='trafficSteeringPolicyIDUplink', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TrafficSteeringPolicyIDUplink')), opt=True)
    _ChangeOfServiceCondition_tWANUserLocationInformation = SEQ(name='tWANUserLocationInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation = SEQ_OF(name='listOfPresenceReportingAreaInformation', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfServiceCondition_listOfPresenceReportingAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')))
    _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation._cont = __ChangeOfServiceCondition_listOfPresenceReportingAreaInformation__item_
    _ChangeOfServiceCondition_voLTEInformation = SEQ(name='voLTEInformation', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'VoLTEInformation')), opt=True)
    ChangeOfServiceCondition._cont = ASN1Dict([
        ('ratingGroup', _ChangeOfServiceCondition_ratingGroup),
        ('chargingRuleBaseName', _ChangeOfServiceCondition_chargingRuleBaseName),
        ('resultCode', _ChangeOfServiceCondition_resultCode),
        ('localSequenceNumber', _ChangeOfServiceCondition_localSequenceNumber),
        ('timeOfFirstUsage', _ChangeOfServiceCondition_timeOfFirstUsage),
        ('timeOfLastUsage', _ChangeOfServiceCondition_timeOfLastUsage),
        ('timeUsage', _ChangeOfServiceCondition_timeUsage),
        ('serviceConditionChange', _ChangeOfServiceCondition_serviceConditionChange),
        ('qoSInformationNeg', _ChangeOfServiceCondition_qoSInformationNeg),
        ('servingNodeAddress', _ChangeOfServiceCondition_servingNodeAddress),
        ('datavolumeFBCUplink', _ChangeOfServiceCondition_datavolumeFBCUplink),
        ('datavolumeFBCDownlink', _ChangeOfServiceCondition_datavolumeFBCDownlink),
        ('timeOfReport', _ChangeOfServiceCondition_timeOfReport),
        ('failureHandlingContinue', _ChangeOfServiceCondition_failureHandlingContinue),
        ('serviceIdentifier', _ChangeOfServiceCondition_serviceIdentifier),
        ('pSFurnishChargingInformation', _ChangeOfServiceCondition_pSFurnishChargingInformation),
        ('aFRecordInformation', _ChangeOfServiceCondition_aFRecordInformation),
        ('userLocationInformation', _ChangeOfServiceCondition_userLocationInformation),
        ('eventBasedChargingInformation', _ChangeOfServiceCondition_eventBasedChargingInformation),
        ('timeQuotaMechanism', _ChangeOfServiceCondition_timeQuotaMechanism),
        ('serviceSpecificInfo', _ChangeOfServiceCondition_serviceSpecificInfo),
        ('threeGPP2UserLocationInformation', _ChangeOfServiceCondition_threeGPP2UserLocationInformation),
        ('sponsorIdentity', _ChangeOfServiceCondition_sponsorIdentity),
        ('applicationServiceProviderIdentity', _ChangeOfServiceCondition_applicationServiceProviderIdentity),
        ('aDCRuleBaseName', _ChangeOfServiceCondition_aDCRuleBaseName),
        ('presenceReportingAreaStatus', _ChangeOfServiceCondition_presenceReportingAreaStatus),
        ('userCSGInformation', _ChangeOfServiceCondition_userCSGInformation),
        ('rATType', _ChangeOfServiceCondition_rATType),
        ('uWANUserLocationInformation', _ChangeOfServiceCondition_uWANUserLocationInformation),
        ('relatedChangeOfServiceCondition', _ChangeOfServiceCondition_relatedChangeOfServiceCondition),
        ('servingPLMNRateControl', _ChangeOfServiceCondition_servingPLMNRateControl),
        ('aPNRateControl', _ChangeOfServiceCondition_aPNRateControl),
        ('threeGPPPSDataOffStatus', _ChangeOfServiceCondition_threeGPPPSDataOffStatus),
        ('trafficSteeringPolicyIDDownlink', _ChangeOfServiceCondition_trafficSteeringPolicyIDDownlink),
        ('trafficSteeringPolicyIDUplink', _ChangeOfServiceCondition_trafficSteeringPolicyIDUplink),
        ('tWANUserLocationInformation', _ChangeOfServiceCondition_tWANUserLocationInformation),
        ('listOfPresenceReportingAreaInformation', _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation),
        ('voLTEInformation', _ChangeOfServiceCondition_voLTEInformation),
        ])
    ChangeOfServiceCondition._ext = None
    
    #-----< ChangeLocation >-----#
    ChangeLocation = SEQ(name='ChangeLocation', mode=MODE_TYPE)
    _ChangeLocation_locationAreaCode = OCT_STR(name='locationAreaCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')))
    _ChangeLocation_routingAreaCode = OCT_STR(name='routingAreaCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')))
    _ChangeLocation_cellId = OCT_STR(name='cellId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _ChangeLocation_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeLocation_mCC_MNC = OCT_STR(name='mCC-MNC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    ChangeLocation._cont = ASN1Dict([
        ('locationAreaCode', _ChangeLocation_locationAreaCode),
        ('routingAreaCode', _ChangeLocation_routingAreaCode),
        ('cellId', _ChangeLocation_cellId),
        ('changeTime', _ChangeLocation_changeTime),
        ('mCC-MNC', _ChangeLocation_mCC_MNC),
        ])
    ChangeLocation._ext = None
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = OCT_STR(name='ChargingCharacteristics', mode=MODE_TYPE)
    ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ChargingPerIPCANSessionIndicator >-----#
    ChargingPerIPCANSessionIndicator = ENUM(name='ChargingPerIPCANSessionIndicator', mode=MODE_TYPE)
    ChargingPerIPCANSessionIndicator._cont = ASN1Dict([('inactive', 0), ('active', 1)])
    ChargingPerIPCANSessionIndicator._ext = None
    
    #-----< ChargingRuleBaseName >-----#
    ChargingRuleBaseName = STR_IA5(name='ChargingRuleBaseName', mode=MODE_TYPE)
    
    #-----< ChChSelectionMode >-----#
    ChChSelectionMode = ENUM(name='ChChSelectionMode', mode=MODE_TYPE)
    ChChSelectionMode._cont = ASN1Dict([('servingNodeSupplied', 0), ('subscriptionSpecific', 1), ('aPNSpecific', 2), ('homeDefault', 3), ('roamingDefault', 4), ('visitingDefault', 5), ('fixedDefault', 6)])
    ChChSelectionMode._ext = None
    
    #-----< CNOperatorSelectionEntity >-----#
    CNOperatorSelectionEntity = ENUM(name='CNOperatorSelectionEntity', mode=MODE_TYPE)
    CNOperatorSelectionEntity._cont = ASN1Dict([('servCNSelectedbyUE', 0), ('servCNSelectedbyNtw', 1)])
    CNOperatorSelectionEntity._ext = None
    
    #-----< CPCIoTEPSOptimisationIndicator >-----#
    CPCIoTEPSOptimisationIndicator = BOOL(name='CPCIoTEPSOptimisationIndicator', mode=MODE_TYPE)
    
    #-----< CSGAccessMode >-----#
    CSGAccessMode = ENUM(name='CSGAccessMode', mode=MODE_TYPE)
    CSGAccessMode._cont = ASN1Dict([('closedMode', 0), ('hybridMode', 1)])
    CSGAccessMode._ext = None
    
    #-----< CSGId >-----#
    CSGId = OCT_STR(name='CSGId', mode=MODE_TYPE)
    CSGId._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< CTEID >-----#
    CTEID = OCT_STR(name='CTEID', mode=MODE_TYPE)
    CTEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< DataVolumeGPRS >-----#
    DataVolumeGPRS = INT(name='DataVolumeGPRS', mode=MODE_TYPE)
    
    #-----< DataVolumeMBMS >-----#
    DataVolumeMBMS = INT(name='DataVolumeMBMS', mode=MODE_TYPE)
    
    #-----< EPCQoSInformation >-----#
    EPCQoSInformation = SEQ(name='EPCQoSInformation', mode=MODE_TYPE)
    _EPCQoSInformation_qCI = INT(name='qCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EPCQoSInformation_maxRequestedBandwithUL = INT(name='maxRequestedBandwithUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_maxRequestedBandwithDL = INT(name='maxRequestedBandwithDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_guaranteedBitrateUL = INT(name='guaranteedBitrateUL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_guaranteedBitrateDL = INT(name='guaranteedBitrateDL', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_aRP = INT(name='aRP', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_aPNAggregateMaxBitrateUL = INT(name='aPNAggregateMaxBitrateUL', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_aPNAggregateMaxBitrateDL = INT(name='aPNAggregateMaxBitrateDL', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedMaxRequestedBWUL = INT(name='extendedMaxRequestedBWUL', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedMaxRequestedBWDL = INT(name='extendedMaxRequestedBWDL', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedGBRUL = INT(name='extendedGBRUL', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedGBRDL = INT(name='extendedGBRDL', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedAPNAMBRUL = INT(name='extendedAPNAMBRUL', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedAPNAMBRDL = INT(name='extendedAPNAMBRDL', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPCQoSInformation._cont = ASN1Dict([
        ('qCI', _EPCQoSInformation_qCI),
        ('maxRequestedBandwithUL', _EPCQoSInformation_maxRequestedBandwithUL),
        ('maxRequestedBandwithDL', _EPCQoSInformation_maxRequestedBandwithDL),
        ('guaranteedBitrateUL', _EPCQoSInformation_guaranteedBitrateUL),
        ('guaranteedBitrateDL', _EPCQoSInformation_guaranteedBitrateDL),
        ('aRP', _EPCQoSInformation_aRP),
        ('aPNAggregateMaxBitrateUL', _EPCQoSInformation_aPNAggregateMaxBitrateUL),
        ('aPNAggregateMaxBitrateDL', _EPCQoSInformation_aPNAggregateMaxBitrateDL),
        ('extendedMaxRequestedBWUL', _EPCQoSInformation_extendedMaxRequestedBWUL),
        ('extendedMaxRequestedBWDL', _EPCQoSInformation_extendedMaxRequestedBWDL),
        ('extendedGBRUL', _EPCQoSInformation_extendedGBRUL),
        ('extendedGBRDL', _EPCQoSInformation_extendedGBRDL),
        ('extendedAPNAMBRUL', _EPCQoSInformation_extendedAPNAMBRUL),
        ('extendedAPNAMBRDL', _EPCQoSInformation_extendedAPNAMBRDL),
        ])
    EPCQoSInformation._ext = None
    
    #-----< EventBasedChargingInformation >-----#
    EventBasedChargingInformation = SEQ(name='EventBasedChargingInformation', mode=MODE_TYPE)
    _EventBasedChargingInformation_numberOfEvents = INT(name='numberOfEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventBasedChargingInformation_eventTimeStamps = SEQ_OF(name='eventTimeStamps', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EventBasedChargingInformation_eventTimeStamps__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _EventBasedChargingInformation_eventTimeStamps._cont = __EventBasedChargingInformation_eventTimeStamps__item_
    EventBasedChargingInformation._cont = ASN1Dict([
        ('numberOfEvents', _EventBasedChargingInformation_numberOfEvents),
        ('eventTimeStamps', _EventBasedChargingInformation_eventTimeStamps),
        ])
    EventBasedChargingInformation._ext = None
    
    #-----< FailureHandlingContinue >-----#
    FailureHandlingContinue = BOOL(name='FailureHandlingContinue', mode=MODE_TYPE)
    
    #-----< FFDAppendIndicator >-----#
    FFDAppendIndicator = BOOL(name='FFDAppendIndicator', mode=MODE_TYPE)
    
    #-----< FixedSubsID >-----#
    FixedSubsID = OCT_STR(name='FixedSubsID', mode=MODE_TYPE)
    
    #-----< FixedUserLocationInformation >-----#
    FixedUserLocationInformation = SEQ(name='FixedUserLocationInformation', mode=MODE_TYPE)
    _FixedUserLocationInformation_sSID = OCT_STR(name='sSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FixedUserLocationInformation_bSSID = OCT_STR(name='bSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FixedUserLocationInformation_accessLineIdentifier = SEQ(name='accessLineIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessLineIdentifier')), opt=True)
    FixedUserLocationInformation._cont = ASN1Dict([
        ('sSID', _FixedUserLocationInformation_sSID),
        ('bSSID', _FixedUserLocationInformation_bSSID),
        ('accessLineIdentifier', _FixedUserLocationInformation_accessLineIdentifier),
        ])
    FixedUserLocationInformation._ext = None
    
    #-----< Flows >-----#
    Flows = SEQ(name='Flows', mode=MODE_TYPE)
    _Flows_mediaComponentNumber = INT(name='mediaComponentNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Flows_flowNumber = SEQ_OF(name='flowNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Flows_flowNumber__item_ = INT(name='_item_', mode=MODE_TYPE)
    _Flows_flowNumber._cont = __Flows_flowNumber__item_
    Flows._cont = ASN1Dict([
        ('mediaComponentNumber', _Flows_mediaComponentNumber),
        ('flowNumber', _Flows_flowNumber),
        ])
    Flows._ext = None
    
    #-----< FreeFormatData >-----#
    FreeFormatData = OCT_STR(name='FreeFormatData', mode=MODE_TYPE)
    FreeFormatData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< MOExceptionDataCounter >-----#
    MOExceptionDataCounter = SEQ(name='MOExceptionDataCounter', mode=MODE_TYPE)
    _MOExceptionDataCounter_counterValue = INT(name='counterValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MOExceptionDataCounter_counterTimestamp = OCT_STR(name='counterTimestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    MOExceptionDataCounter._cont = ASN1Dict([
        ('counterValue', _MOExceptionDataCounter_counterValue),
        ('counterTimestamp', _MOExceptionDataCounter_counterTimestamp),
        ])
    MOExceptionDataCounter._ext = None
    
    #-----< MSNetworkCapability >-----#
    MSNetworkCapability = OCT_STR(name='MSNetworkCapability', mode=MODE_TYPE)
    MSNetworkCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< NBIFOMMode >-----#
    NBIFOMMode = ENUM(name='NBIFOMMode', mode=MODE_TYPE)
    NBIFOMMode._cont = ASN1Dict([('uEINITIATED', 0), ('nETWORKINITIATED', 1)])
    NBIFOMMode._ext = None
    
    #-----< NBIFOMSupport >-----#
    NBIFOMSupport = ENUM(name='NBIFOMSupport', mode=MODE_TYPE)
    NBIFOMSupport._cont = ASN1Dict([('nBIFOMNotSupported', 0), ('nBIFOMSupported', 1)])
    NBIFOMSupport._ext = None
    
    #-----< NetworkInitiatedPDPContext >-----#
    NetworkInitiatedPDPContext = BOOL(name='NetworkInitiatedPDPContext', mode=MODE_TYPE)
    
    #-----< NumberOfDPEncountered >-----#
    NumberOfDPEncountered = INT(name='NumberOfDPEncountered', mode=MODE_TYPE)
    
    #-----< PDPType >-----#
    PDPType = OCT_STR(name='PDPType', mode=MODE_TYPE)
    PDPType._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PDPPDNTypeExtension >-----#
    PDPPDNTypeExtension = INT(name='PDPPDNTypeExtension', mode=MODE_TYPE)
    
    #-----< PresenceReportingAreaElementsList >-----#
    PresenceReportingAreaElementsList = OCT_STR(name='PresenceReportingAreaElementsList', mode=MODE_TYPE)
    
    #-----< PresenceReportingAreaInfo >-----#
    PresenceReportingAreaInfo = SEQ(name='PresenceReportingAreaInfo', mode=MODE_TYPE)
    _PresenceReportingAreaInfo_presenceReportingAreaIdentifier = OCT_STR(name='presenceReportingAreaIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PresenceReportingAreaInfo_presenceReportingAreaStatus = ENUM(name='presenceReportingAreaStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _PresenceReportingAreaInfo_presenceReportingAreaElementsList = OCT_STR(name='presenceReportingAreaElementsList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaElementsList')), opt=True)
    _PresenceReportingAreaInfo_presenceReportingAreaNode = BIT_STR(name='presenceReportingAreaNode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaNode')), opt=True)
    PresenceReportingAreaInfo._cont = ASN1Dict([
        ('presenceReportingAreaIdentifier', _PresenceReportingAreaInfo_presenceReportingAreaIdentifier),
        ('presenceReportingAreaStatus', _PresenceReportingAreaInfo_presenceReportingAreaStatus),
        ('presenceReportingAreaElementsList', _PresenceReportingAreaInfo_presenceReportingAreaElementsList),
        ('presenceReportingAreaNode', _PresenceReportingAreaInfo_presenceReportingAreaNode),
        ])
    PresenceReportingAreaInfo._ext = None
    
    #-----< PresenceReportingAreaNode >-----#
    PresenceReportingAreaNode = BIT_STR(name='PresenceReportingAreaNode', mode=MODE_TYPE)
    PresenceReportingAreaNode._cont = ASN1Dict([('oCS', 0), ('pCRF', 1)])
    
    #-----< PresenceReportingAreaStatus >-----#
    PresenceReportingAreaStatus = ENUM(name='PresenceReportingAreaStatus', mode=MODE_TYPE)
    PresenceReportingAreaStatus._cont = ASN1Dict([('insideArea', 0), ('outsideArea', 1), ('inactive', 2), ('unknown', 3)])
    PresenceReportingAreaStatus._ext = None
    
    #-----< PSFurnishChargingInformation >-----#
    PSFurnishChargingInformation = SEQ(name='PSFurnishChargingInformation', mode=MODE_TYPE)
    _PSFurnishChargingInformation_pSFreeFormatData = OCT_STR(name='pSFreeFormatData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')))
    _PSFurnishChargingInformation_pSFFDAppendIndicator = BOOL(name='pSFFDAppendIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FFDAppendIndicator')), opt=True)
    PSFurnishChargingInformation._cont = ASN1Dict([
        ('pSFreeFormatData', _PSFurnishChargingInformation_pSFreeFormatData),
        ('pSFFDAppendIndicator', _PSFurnishChargingInformation_pSFFDAppendIndicator),
        ])
    PSFurnishChargingInformation._ext = None
    
    #-----< QoSInformation >-----#
    QoSInformation = OCT_STR(name='QoSInformation', mode=MODE_TYPE)
    QoSInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=255)], ev=None, er=[])
    
    #-----< RANSecondaryRATUsageReport >-----#
    RANSecondaryRATUsageReport = SEQ(name='RANSecondaryRATUsageReport', mode=MODE_TYPE)
    _RANSecondaryRATUsageReport_dataVolumeUplink = INT(name='dataVolumeUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')))
    _RANSecondaryRATUsageReport_dataVolumeDownlink = INT(name='dataVolumeDownlink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')))
    _RANSecondaryRATUsageReport_rANStartTime = OCT_STR(name='rANStartTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _RANSecondaryRATUsageReport_rANEndTime = OCT_STR(name='rANEndTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _RANSecondaryRATUsageReport_secondaryRATType = INT(name='secondaryRATType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SecondaryRATType')), opt=True)
    _RANSecondaryRATUsageReport_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    RANSecondaryRATUsageReport._cont = ASN1Dict([
        ('dataVolumeUplink', _RANSecondaryRATUsageReport_dataVolumeUplink),
        ('dataVolumeDownlink', _RANSecondaryRATUsageReport_dataVolumeDownlink),
        ('rANStartTime', _RANSecondaryRATUsageReport_rANStartTime),
        ('rANEndTime', _RANSecondaryRATUsageReport_rANEndTime),
        ('secondaryRATType', _RANSecondaryRATUsageReport_secondaryRATType),
        ('chargingID', _RANSecondaryRATUsageReport_chargingID),
        ])
    RANSecondaryRATUsageReport._ext = None
    
    #-----< RateControlTimeUnit >-----#
    RateControlTimeUnit = INT(name='RateControlTimeUnit', mode=MODE_TYPE)
    RateControlTimeUnit._cont = ASN1Dict([('unrestricted', 0), ('minute', 1), ('hour', 2), ('day', 3), ('week', 4)])
    
    #-----< RatingGroupId >-----#
    RatingGroupId = INT(name='RatingGroupId', mode=MODE_TYPE)
    
    #-----< RelatedChangeOfCharCondition >-----#
    RelatedChangeOfCharCondition = SEQ(name='RelatedChangeOfCharCondition', mode=MODE_TYPE)
    _RelatedChangeOfCharCondition_changeCondition = ENUM(name='changeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeCondition')))
    _RelatedChangeOfCharCondition_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _RelatedChangeOfCharCondition_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RelatedChangeOfCharCondition_presenceReportingAreaStatus = ENUM(name='presenceReportingAreaStatus', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _RelatedChangeOfCharCondition_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _RelatedChangeOfCharCondition_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _RelatedChangeOfCharCondition_uWANUserLocationInformation = SEQ(name='uWANUserLocationInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    RelatedChangeOfCharCondition._cont = ASN1Dict([
        ('changeCondition', _RelatedChangeOfCharCondition_changeCondition),
        ('changeTime', _RelatedChangeOfCharCondition_changeTime),
        ('userLocationInformation', _RelatedChangeOfCharCondition_userLocationInformation),
        ('presenceReportingAreaStatus', _RelatedChangeOfCharCondition_presenceReportingAreaStatus),
        ('userCSGInformation', _RelatedChangeOfCharCondition_userCSGInformation),
        ('rATType', _RelatedChangeOfCharCondition_rATType),
        ('uWANUserLocationInformation', _RelatedChangeOfCharCondition_uWANUserLocationInformation),
        ])
    RelatedChangeOfCharCondition._ext = None
    
    #-----< RelatedChangeOfServiceCondition >-----#
    RelatedChangeOfServiceCondition = SEQ(name='RelatedChangeOfServiceCondition', mode=MODE_TYPE)
    _RelatedChangeOfServiceCondition_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RelatedChangeOfServiceCondition_threeGPP2UserLocationInformation = OCT_STR(name='threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RelatedChangeOfServiceCondition_presenceReportingAreaStatus = ENUM(name='presenceReportingAreaStatus', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _RelatedChangeOfServiceCondition_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _RelatedChangeOfServiceCondition_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _RelatedChangeOfServiceCondition_uWANUserLocationInformation = SEQ(name='uWANUserLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _RelatedChangeOfServiceCondition_relatedServiceConditionChange = BIT_STR(name='relatedServiceConditionChange', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServiceConditionChange')), opt=True)
    RelatedChangeOfServiceCondition._cont = ASN1Dict([
        ('userLocationInformation', _RelatedChangeOfServiceCondition_userLocationInformation),
        ('threeGPP2UserLocationInformation', _RelatedChangeOfServiceCondition_threeGPP2UserLocationInformation),
        ('presenceReportingAreaStatus', _RelatedChangeOfServiceCondition_presenceReportingAreaStatus),
        ('userCSGInformation', _RelatedChangeOfServiceCondition_userCSGInformation),
        ('rATType', _RelatedChangeOfServiceCondition_rATType),
        ('uWANUserLocationInformation', _RelatedChangeOfServiceCondition_uWANUserLocationInformation),
        ('relatedServiceConditionChange', _RelatedChangeOfServiceCondition_relatedServiceConditionChange),
        ])
    RelatedChangeOfServiceCondition._ext = None
    
    #-----< ResultCode >-----#
    ResultCode = INT(name='ResultCode', mode=MODE_TYPE)
    
    #-----< SecondaryRATType >-----#
    SecondaryRATType = INT(name='SecondaryRATType', mode=MODE_TYPE)
    SecondaryRATType._cont = ASN1Dict([('nR', 0)])
    
    #-----< ServiceConditionChange >-----#
    ServiceConditionChange = BIT_STR(name='ServiceConditionChange', mode=MODE_TYPE)
    ServiceConditionChange._cont = ASN1Dict([('qoSChange', 0), ('sGSNChange', 1), ('sGSNPLMNIDChange', 2), ('tariffTimeSwitch', 3), ('pDPContextRelease', 4), ('rATChange', 5), ('serviceIdledOut', 6), ('reserved', 7), ('configurationChange', 8), ('serviceStop', 9), ('dCCATimeThresholdReached', 10), ('dCCAVolumeThresholdReached', 11), ('dCCAServiceSpecificUnitThresholdReached', 12), ('dCCATimeExhausted', 13), ('dCCAVolumeExhausted', 14), ('dCCAValidityTimeout', 15), ('reserved1', 16), ('dCCAReauthorisationRequest', 17), ('dCCAContinueOngoingSession', 18), ('dCCARetryAndTerminateOngoingSession', 19), ('dCCATerminateOngoingSession', 20), ('cGI-SAIChange', 21), ('rAIChange', 22), ('dCCAServiceSpecificUnitExhausted', 23), ('recordClosure', 24), ('timeLimit', 25), ('volumeLimit', 26), ('serviceSpecificUnitLimit', 27), ('envelopeClosure', 28), ('eCGIChange', 29), ('tAIChange', 30), ('userLocationChange', 31), ('userCSGInformationChange', 32), ('presenceInPRAChange', 33), ('accessChangeOfSDF', 34), ('indirectServiceConditionChange', 35), ('servingPLMNRateControlChange', 36), ('aPNRateControlChange', 37)])
    
    #-----< SCFAddress >-----#
    SCFAddress = OCT_STR(name='SCFAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< ServiceIdentifier >-----#
    ServiceIdentifier = INT(name='ServiceIdentifier', mode=MODE_TYPE)
    ServiceIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< ServingNodeType >-----#
    ServingNodeType = ENUM(name='ServingNodeType', mode=MODE_TYPE)
    ServingNodeType._cont = ASN1Dict([('sGSN', 0), ('pMIPSGW', 1), ('gTPSGW', 2), ('ePDG', 3), ('hSGW', 4), ('mME', 5), ('tWAN', 6)])
    ServingNodeType._ext = None
    
    #-----< ServingPLMNRateControl >-----#
    ServingPLMNRateControl = SEQ(name='ServingPLMNRateControl', mode=MODE_TYPE)
    _ServingPLMNRateControl_sPLMNDLRateControlValue = INT(name='sPLMNDLRateControlValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServingPLMNRateControl_sPLMNULRateControlValue = INT(name='sPLMNULRateControlValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ServingPLMNRateControl._cont = ASN1Dict([
        ('sPLMNDLRateControlValue', _ServingPLMNRateControl_sPLMNDLRateControlValue),
        ('sPLMNULRateControlValue', _ServingPLMNRateControl_sPLMNULRateControlValue),
        ])
    ServingPLMNRateControl._ext = None
    
    #-----< SGiPtPTunnellingMethod >-----#
    SGiPtPTunnellingMethod = ENUM(name='SGiPtPTunnellingMethod', mode=MODE_TYPE)
    SGiPtPTunnellingMethod._cont = ASN1Dict([('uDPIPbased', 0), ('others', 1)])
    SGiPtPTunnellingMethod._ext = None
    
    #-----< SGSNChange >-----#
    SGSNChange = BOOL(name='SGSNChange', mode=MODE_TYPE)
    
    #-----< SGWChange >-----#
    SGWChange = BOOL(name='SGWChange', mode=MODE_TYPE)
    
    #-----< TimeQuotaMechanism >-----#
    TimeQuotaMechanism = SEQ(name='TimeQuotaMechanism', mode=MODE_TYPE)
    _TimeQuotaMechanism_timeQuotaType = ENUM(name='timeQuotaType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TimeQuotaType')))
    _TimeQuotaMechanism_baseTimeInterval = INT(name='baseTimeInterval', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TimeQuotaMechanism._cont = ASN1Dict([
        ('timeQuotaType', _TimeQuotaMechanism_timeQuotaType),
        ('baseTimeInterval', _TimeQuotaMechanism_baseTimeInterval),
        ])
    TimeQuotaMechanism._ext = None
    
    #-----< TimeQuotaType >-----#
    TimeQuotaType = ENUM(name='TimeQuotaType', mode=MODE_TYPE)
    TimeQuotaType._cont = ASN1Dict([('dISCRETETIMEPERIOD', 0), ('cONTINUOUSTIMEPERIOD', 1)])
    TimeQuotaType._ext = None
    
    #-----< TrafficSteeringPolicyIDDownlink >-----#
    TrafficSteeringPolicyIDDownlink = OCT_STR(name='TrafficSteeringPolicyIDDownlink', mode=MODE_TYPE)
    
    #-----< TrafficSteeringPolicyIDUplink >-----#
    TrafficSteeringPolicyIDUplink = OCT_STR(name='TrafficSteeringPolicyIDUplink', mode=MODE_TYPE)
    
    #-----< TWANUserLocationInfo >-----#
    TWANUserLocationInfo = SEQ(name='TWANUserLocationInfo', mode=MODE_TYPE)
    _TWANUserLocationInfo_sSID = OCT_STR(name='sSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TWANUserLocationInfo_bSSID = OCT_STR(name='bSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TWANUserLocationInfo_civicAddressInformation = OCT_STR(name='civicAddressInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CivicAddressInformation')), opt=True)
    _TWANUserLocationInfo_wLANOperatorId = SEQ(name='wLANOperatorId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'WLANOperatorId')), opt=True)
    _TWANUserLocationInfo_logicalAccessID = OCT_STR(name='logicalAccessID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TWANUserLocationInfo._cont = ASN1Dict([
        ('sSID', _TWANUserLocationInfo_sSID),
        ('bSSID', _TWANUserLocationInfo_bSSID),
        ('civicAddressInformation', _TWANUserLocationInfo_civicAddressInformation),
        ('wLANOperatorId', _TWANUserLocationInfo_wLANOperatorId),
        ('logicalAccessID', _TWANUserLocationInfo_logicalAccessID),
        ])
    TWANUserLocationInfo._ext = None
    
    #-----< UNIPDUCPOnlyFlag >-----#
    UNIPDUCPOnlyFlag = BOOL(name='UNIPDUCPOnlyFlag', mode=MODE_TYPE)
    
    #-----< UserCSGInformation >-----#
    UserCSGInformation = SEQ(name='UserCSGInformation', mode=MODE_TYPE)
    _UserCSGInformation_cSGId = OCT_STR(name='cSGId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CSGId')))
    _UserCSGInformation_cSGAccessMode = ENUM(name='cSGAccessMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CSGAccessMode')))
    _UserCSGInformation_cSGMembershipIndication = NULL(name='cSGMembershipIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UserCSGInformation._cont = ASN1Dict([
        ('cSGId', _UserCSGInformation_cSGId),
        ('cSGAccessMode', _UserCSGInformation_cSGAccessMode),
        ('cSGMembershipIndication', _UserCSGInformation_cSGMembershipIndication),
        ])
    UserCSGInformation._ext = None
    
    #-----< UWANUserLocationInfo >-----#
    UWANUserLocationInfo = SEQ(name='UWANUserLocationInfo', mode=MODE_TYPE)
    _UWANUserLocationInfo_uELocalIPAddress = CHOICE(name='uELocalIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _UWANUserLocationInfo_uDPSourcePort = OCT_STR(name='uDPSourcePort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_uDPSourcePort._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _UWANUserLocationInfo_sSID = OCT_STR(name='sSID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_bSSID = OCT_STR(name='bSSID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_tCPSourcePort = OCT_STR(name='tCPSourcePort', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_tCPSourcePort._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _UWANUserLocationInfo_civicAddressInformation = OCT_STR(name='civicAddressInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CivicAddressInformation')), opt=True)
    _UWANUserLocationInfo_wLANOperatorId = SEQ(name='wLANOperatorId', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'WLANOperatorId')), opt=True)
    _UWANUserLocationInfo_logicalAccessID = OCT_STR(name='logicalAccessID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UWANUserLocationInfo._cont = ASN1Dict([
        ('uELocalIPAddress', _UWANUserLocationInfo_uELocalIPAddress),
        ('uDPSourcePort', _UWANUserLocationInfo_uDPSourcePort),
        ('sSID', _UWANUserLocationInfo_sSID),
        ('bSSID', _UWANUserLocationInfo_bSSID),
        ('tCPSourcePort', _UWANUserLocationInfo_tCPSourcePort),
        ('civicAddressInformation', _UWANUserLocationInfo_civicAddressInformation),
        ('wLANOperatorId', _UWANUserLocationInfo_wLANOperatorId),
        ('logicalAccessID', _UWANUserLocationInfo_logicalAccessID),
        ])
    UWANUserLocationInfo._ext = None
    
    #-----< VoLTEInformation >-----#
    VoLTEInformation = SEQ(name='VoLTEInformation', mode=MODE_TYPE)
    _VoLTEInformation_callerInformation = SEQ_OF(name='callerInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __VoLTEInformation_callerInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _VoLTEInformation_callerInformation._cont = __VoLTEInformation_callerInformation__item_
    _VoLTEInformation_calleeInformation = SEQ(name='calleeInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CalleePartyInformation')), opt=True)
    VoLTEInformation._cont = ASN1Dict([
        ('callerInformation', _VoLTEInformation_callerInformation),
        ('calleeInformation', _VoLTEInformation_calleeInformation),
        ])
    VoLTEInformation._ext = None
    
    #-----< WLANOperatorId >-----#
    WLANOperatorId = SEQ(name='WLANOperatorId', mode=MODE_TYPE)
    _WLANOperatorId_wLANOperatorName = OCT_STR(name='wLANOperatorName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLANOperatorId_wLANPLMNId = OCT_STR(name='wLANPLMNId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')))
    WLANOperatorId._cont = ASN1Dict([
        ('wLANOperatorName', _WLANOperatorId_wLANOperatorName),
        ('wLANPLMNId', _WLANOperatorId_wLANPLMNId),
        ])
    WLANOperatorId._ext = None
    
    _all_ = [
        _GPRSRecord_sgsnPDPRecord,
        _GPRSRecord_sgsnMMRecord,
        _GPRSRecord_sgsnSMORecord,
        _GPRSRecord_sgsnSMTRecord,
        _GPRSRecord_sgsnMTLCSRecord,
        _GPRSRecord_sgsnMOLCSRecord,
        _GPRSRecord_sgsnNILCSRecord,
        _GPRSRecord_sgsnMBMSRecord,
        _GPRSRecord_ggsnMBMSRecord,
        _GPRSRecord_sGWRecord,
        _GPRSRecord_pGWRecord,
        _GPRSRecord_gwMBMSRecord,
        _GPRSRecord_tDFRecord,
        _GPRSRecord_iPERecord,
        _GPRSRecord_ePDGRecord,
        _GPRSRecord_tWAGRecord,
        GPRSRecord,
        _SGWRecord_recordType,
        _SGWRecord_servedIMSI,
        _SGWRecord_s_GWAddress,
        _SGWRecord_chargingID,
        __SGWRecord_servingNodeAddress__item_,
        _SGWRecord_servingNodeAddress,
        _SGWRecord_accessPointNameNI,
        _SGWRecord_pdpPDNType,
        _SGWRecord_servedPDPPDNAddress,
        _SGWRecord_dynamicAddressFlag,
        __SGWRecord_listOfTrafficVolumes__item_,
        _SGWRecord_listOfTrafficVolumes,
        _SGWRecord_recordOpeningTime,
        _SGWRecord_duration,
        _SGWRecord_causeForRecClosing,
        _SGWRecord_diagnostics,
        _SGWRecord_recordSequenceNumber,
        _SGWRecord_nodeID,
        _SGWRecord_recordExtensions,
        _SGWRecord_localSequenceNumber,
        _SGWRecord_apnSelectionMode,
        _SGWRecord_servedMSISDN,
        _SGWRecord_chargingCharacteristics,
        _SGWRecord_chChSelectionMode,
        _SGWRecord_iMSsignalingContext,
        _SGWRecord_servingNodePLMNIdentifier,
        _SGWRecord_servedIMEI,
        _SGWRecord_rATType,
        _SGWRecord_mSTimeZone,
        _SGWRecord_userLocationInformation,
        _SGWRecord_sGWChange,
        __SGWRecord_servingNodeType__item_,
        _SGWRecord_servingNodeType,
        _SGWRecord_p_GWAddressUsed,
        _SGWRecord_p_GWPLMNIdentifier,
        _SGWRecord_startTime,
        _SGWRecord_stopTime,
        _SGWRecord_pDNConnectionChargingID,
        _SGWRecord_iMSIunauthenticatedFlag,
        _SGWRecord_userCSGInformation,
        _SGWRecord_servedPDPPDNAddressExt,
        _SGWRecord_lowPriorityIndicator,
        _SGWRecord_dynamicAddressFlagExt,
        _SGWRecord_s_GWiPv6Address,
        __SGWRecord_servingNodeiPv6Address__item_,
        _SGWRecord_servingNodeiPv6Address,
        _SGWRecord_p_GWiPv6AddressUsed,
        _SGWRecord_retransmission,
        _SGWRecord_userLocationInfoTime,
        _SGWRecord_cNOperatorSelectionEnt,
        _SGWRecord_presenceReportingAreaInfo,
        _SGWRecord_lastUserLocationInformation,
        _SGWRecord_lastMSTimeZone,
        _SGWRecord_enhancedDiagnostics,
        _SGWRecord_cPCIoTEPSOptimisationIndicator,
        _SGWRecord_uNIPDUCPOnlyFlag,
        _SGWRecord_servingPLMNRateControl,
        _SGWRecord_pDPPDNTypeExtension,
        _SGWRecord_mOExceptionDataCounter,
        __SGWRecord_listOfRANSecondaryRATUsageReports__item_,
        _SGWRecord_listOfRANSecondaryRATUsageReports,
        SGWRecord,
        _PGWRecord_recordType,
        _PGWRecord_servedIMSI,
        _PGWRecord_p_GWAddress,
        _PGWRecord_chargingID,
        __PGWRecord_servingNodeAddress__item_,
        _PGWRecord_servingNodeAddress,
        _PGWRecord_accessPointNameNI,
        _PGWRecord_pdpPDNType,
        _PGWRecord_servedPDPPDNAddress,
        _PGWRecord_dynamicAddressFlag,
        __PGWRecord_listOfTrafficVolumes__item_,
        _PGWRecord_listOfTrafficVolumes,
        _PGWRecord_recordOpeningTime,
        _PGWRecord_duration,
        _PGWRecord_causeForRecClosing,
        _PGWRecord_diagnostics,
        _PGWRecord_recordSequenceNumber,
        _PGWRecord_nodeID,
        _PGWRecord_recordExtensions,
        _PGWRecord_localSequenceNumber,
        _PGWRecord_apnSelectionMode,
        _PGWRecord_servedMSISDN,
        _PGWRecord_chargingCharacteristics,
        _PGWRecord_chChSelectionMode,
        _PGWRecord_iMSsignalingContext,
        _PGWRecord_servingNodePLMNIdentifier,
        _PGWRecord_pSFurnishChargingInformation,
        _PGWRecord_servedIMEI,
        _PGWRecord_rATType,
        _PGWRecord_mSTimeZone,
        _PGWRecord_userLocationInformation,
        _PGWRecord_cAMELChargingInformation,
        __PGWRecord_listOfServiceData__item_,
        _PGWRecord_listOfServiceData,
        __PGWRecord_servingNodeType__item_,
        _PGWRecord_servingNodeType,
        _PGWRecord_servedMNNAI,
        _PGWRecord_p_GWPLMNIdentifier,
        _PGWRecord_startTime,
        _PGWRecord_stopTime,
        _PGWRecord_served3gpp2MEID,
        _PGWRecord_pDNConnectionChargingID,
        _PGWRecord_iMSIunauthenticatedFlag,
        _PGWRecord_userCSGInformation,
        _PGWRecord_threeGPP2UserLocationInformation,
        _PGWRecord_servedPDPPDNAddressExt,
        _PGWRecord_lowPriorityIndicator,
        _PGWRecord_dynamicAddressFlagExt,
        __PGWRecord_servingNodeiPv6Address__item_,
        _PGWRecord_servingNodeiPv6Address,
        _PGWRecord_p_GWiPv6AddressUsed,
        _PGWRecord_tWANUserLocationInformation,
        _PGWRecord_retransmission,
        _PGWRecord_userLocationInfoTime,
        _PGWRecord_cNOperatorSelectionEnt,
        _PGWRecord_ePCQoSInformation,
        _PGWRecord_presenceReportingAreaInfo,
        _PGWRecord_lastUserLocationInformation,
        _PGWRecord_lastMSTimeZone,
        _PGWRecord_enhancedDiagnostics,
        _PGWRecord_nBIFOMMode,
        _PGWRecord_nBIFOMSupport,
        _PGWRecord_uWANUserLocationInformation,
        _PGWRecord_sGiPtPTunnellingMethod,
        _PGWRecord_uNIPDUCPOnlyFlag,
        _PGWRecord_servingPLMNRateControl,
        _PGWRecord_aPNRateControl,
        _PGWRecord_pDPPDNTypeExtension,
        _PGWRecord_mOExceptionDataCounter,
        _PGWRecord_chargingPerIPCANSessionIndicator,
        _PGWRecord_threeGPPPSDataOffStatus,
        _PGWRecord_sCSASAddress,
        __PGWRecord_listOfRANSecondaryRATUsageReports__item_,
        _PGWRecord_listOfRANSecondaryRATUsageReports,
        PGWRecord,
        _TDFRecord_recordType,
        _TDFRecord_servedIMSI,
        _TDFRecord_p_GWAddress,
        __TDFRecord_servingNodeAddress__item_,
        _TDFRecord_servingNodeAddress,
        _TDFRecord_accessPointNameNI,
        _TDFRecord_pdpPDNType,
        _TDFRecord_servedPDPPDNAddress,
        _TDFRecord_dynamicAddressFlag,
        _TDFRecord_recordOpeningTime,
        _TDFRecord_duration,
        _TDFRecord_causeForRecClosing,
        _TDFRecord_diagnostics,
        _TDFRecord_recordSequenceNumber,
        _TDFRecord_nodeID,
        _TDFRecord_recordExtensions,
        _TDFRecord_localSequenceNumber,
        _TDFRecord_apnSelectionMode,
        _TDFRecord_servedMSISDN,
        _TDFRecord_chargingCharacteristics,
        _TDFRecord_chChSelectionMode,
        _TDFRecord_servingNodePLMNIdentifier,
        _TDFRecord_pSFurnishChargingInformation,
        _TDFRecord_servedIMEI,
        _TDFRecord_rATType,
        _TDFRecord_mSTimeZone,
        _TDFRecord_userLocationInformation,
        __TDFRecord_listOfServiceData__item_,
        _TDFRecord_listOfServiceData,
        __TDFRecord_servingNodeType__item_,
        _TDFRecord_servingNodeType,
        _TDFRecord_servedMNNAI,
        _TDFRecord_p_GWPLMNIdentifier,
        _TDFRecord_startTime,
        _TDFRecord_stopTime,
        _TDFRecord_served3gpp2MEID,
        _TDFRecord_pDNConnectionChargingID,
        _TDFRecord_userCSGInformation,
        _TDFRecord_threeGPP2UserLocationInformation,
        _TDFRecord_servedPDPPDNAddressExt,
        _TDFRecord_dynamicAddressFlagExt,
        __TDFRecord_servingNodeiPv6Address__item_,
        _TDFRecord_servingNodeiPv6Address,
        _TDFRecord_p_GWiPv6AddressUsed,
        _TDFRecord_tWANUserLocationInformation,
        _TDFRecord_retransmission,
        _TDFRecord_tDFAddress,
        _TDFRecord_tDFiPv6AddressUsed,
        _TDFRecord_tDFPLMNIdentifier,
        _TDFRecord_servedFixedSubsID,
        _TDFRecord_accessLineIdentifier,
        _TDFRecord_fixedUserLocationInformation,
        TDFRecord,
        _IPERecord_recordType,
        _IPERecord_servedIMSI,
        _IPERecord_iPEdgeAddress,
        _IPERecord_chargingID,
        _IPERecord_accessPointNameNI,
        _IPERecord_iPCANsessionType,
        _IPERecord_servedIPCANsessionAddress,
        _IPERecord_dynamicAddressFlag,
        __IPERecord_listOfTrafficVolumes__item_,
        _IPERecord_listOfTrafficVolumes,
        _IPERecord_recordOpeningTime,
        _IPERecord_duration,
        _IPERecord_causeForRecClosing,
        _IPERecord_diagnostics,
        _IPERecord_recordSequenceNumber,
        _IPERecord_nodeID,
        _IPERecord_recordExtensions,
        _IPERecord_localSequenceNumber,
        _IPERecord_servedMSISDN,
        _IPERecord_chargingCharacteristics,
        _IPERecord_chChSelectionMode,
        _IPERecord_pSFurnishChargingInformation,
        _IPERecord_servedIMEI,
        __IPERecord_listOfServiceData__item_,
        _IPERecord_listOfServiceData,
        _IPERecord_servedMNNAI,
        _IPERecord_iPEdgeOperatorIdentifier,
        _IPERecord_startTime,
        _IPERecord_stopTime,
        _IPERecord_servedIPCANsessionAddressExt,
        _IPERecord_dynamicAddressFlagExt,
        _IPERecord_iPEdgeiPv6AddressUsed,
        _IPERecord_retransmission,
        _IPERecord_servedFixedSubsID,
        _IPERecord_accessLineIdentifier,
        _IPERecord_fixedUserLocationInformation,
        IPERecord,
        _EPDGRecord_recordType,
        _EPDGRecord_servedIMSI,
        _EPDGRecord_ePDGAddressUsed,
        _EPDGRecord_chargingID,
        _EPDGRecord_accessPointNameNI,
        _EPDGRecord_pdpPDNType,
        _EPDGRecord_servedPDPPDNAddress,
        _EPDGRecord_dynamicAddressFlag,
        __EPDGRecord_listOfTrafficVolumes__item_,
        _EPDGRecord_listOfTrafficVolumes,
        _EPDGRecord_recordOpeningTime,
        _EPDGRecord_duration,
        _EPDGRecord_causeForRecClosing,
        _EPDGRecord_diagnostics,
        _EPDGRecord_recordSequenceNumber,
        _EPDGRecord_nodeID,
        _EPDGRecord_recordExtensions,
        _EPDGRecord_localSequenceNumber,
        _EPDGRecord_apnSelectionMode,
        _EPDGRecord_servedMSISDN,
        _EPDGRecord_chargingCharacteristics,
        _EPDGRecord_chChSelectionMode,
        _EPDGRecord_iMSsignalingContext,
        _EPDGRecord_servedIMEI,
        _EPDGRecord_rATType,
        _EPDGRecord_sGWChange,
        _EPDGRecord_p_GWAddressUsed,
        _EPDGRecord_p_GWPLMNIdentifier,
        _EPDGRecord_startTime,
        _EPDGRecord_stopTime,
        _EPDGRecord_pDNConnectionChargingID,
        _EPDGRecord_servedPDPPDNAddressExt,
        _EPDGRecord_dynamicAddressFlagExt,
        _EPDGRecord_ePDGiPv6AddressUsed,
        _EPDGRecord_p_GWiPv6AddressUsed,
        _EPDGRecord_retransmission,
        _EPDGRecord_enhancedDiagnostics,
        _EPDGRecord_uWANUserLocationInformation,
        _EPDGRecord_userLocationInfoTime,
        _EPDGRecord_iMSIunauthenticatedFlag,
        EPDGRecord,
        _TWAGRecord_recordType,
        _TWAGRecord_servedIMSI,
        _TWAGRecord_tWAGAddressUsed,
        _TWAGRecord_chargingID,
        _TWAGRecord_accessPointNameNI,
        _TWAGRecord_pdpPDNType,
        _TWAGRecord_servedPDPPDNAddress,
        _TWAGRecord_dynamicAddressFlag,
        __TWAGRecord_listOfTrafficVolumes__item_,
        _TWAGRecord_listOfTrafficVolumes,
        _TWAGRecord_recordOpeningTime,
        _TWAGRecord_duration,
        _TWAGRecord_causeForRecClosing,
        _TWAGRecord_diagnostics,
        _TWAGRecord_recordSequenceNumber,
        _TWAGRecord_nodeID,
        _TWAGRecord_recordExtensions,
        _TWAGRecord_localSequenceNumber,
        _TWAGRecord_apnSelectionMode,
        _TWAGRecord_servedMSISDN,
        _TWAGRecord_chargingCharacteristics,
        _TWAGRecord_chChSelectionMode,
        _TWAGRecord_servedIMEI,
        _TWAGRecord_rATType,
        _TWAGRecord_sGWChange,
        _TWAGRecord_p_GWAddressUsed,
        _TWAGRecord_p_GWPLMNIdentifier,
        _TWAGRecord_startTime,
        _TWAGRecord_stopTime,
        _TWAGRecord_pDNConnectionChargingID,
        _TWAGRecord_servedPDPPDNAddressExt,
        _TWAGRecord_dynamicAddressFlagExt,
        _TWAGRecord_tWAGiPv6AddressUsed,
        _TWAGRecord_p_GWiPv6AddressUsed,
        _TWAGRecord_retransmission,
        _TWAGRecord_enhancedDiagnostics,
        _TWAGRecord_tWANUserLocationInformation,
        _TWAGRecord_iMSIunauthenticatedFlag,
        TWAGRecord,
        _SGSNMMRecord_recordType,
        _SGSNMMRecord_servedIMSI,
        _SGSNMMRecord_servedIMEI,
        _SGSNMMRecord_sgsnAddress,
        _SGSNMMRecord_msNetworkCapability,
        _SGSNMMRecord_routingArea,
        _SGSNMMRecord_locationAreaCode,
        _SGSNMMRecord_cellIdentifier,
        __SGSNMMRecord_changeLocation__item_,
        _SGSNMMRecord_changeLocation,
        _SGSNMMRecord_recordOpeningTime,
        _SGSNMMRecord_duration,
        _SGSNMMRecord_sgsnChange,
        _SGSNMMRecord_causeForRecClosing,
        _SGSNMMRecord_diagnostics,
        _SGSNMMRecord_recordSequenceNumber,
        _SGSNMMRecord_nodeID,
        _SGSNMMRecord_recordExtensions,
        _SGSNMMRecord_localSequenceNumber,
        _SGSNMMRecord_servedMSISDN,
        _SGSNMMRecord_chargingCharacteristics,
        _SGSNMMRecord_cAMELInformationMM,
        _SGSNMMRecord_rATType,
        _SGSNMMRecord_chChSelectionMode,
        _SGSNMMRecord_cellPLMNId,
        _SGSNMMRecord_servingNodePLMNIdentifier,
        _SGSNMMRecord_cNOperatorSelectionEnt,
        SGSNMMRecord,
        _SGSNPDPRecord_recordType,
        _SGSNPDPRecord_networkInitiation,
        _SGSNPDPRecord_servedIMSI,
        _SGSNPDPRecord_servedIMEI,
        _SGSNPDPRecord_sgsnAddress,
        _SGSNPDPRecord_msNetworkCapability,
        _SGSNPDPRecord_routingArea,
        _SGSNPDPRecord_locationAreaCode,
        _SGSNPDPRecord_cellIdentifier,
        _SGSNPDPRecord_chargingID,
        _SGSNPDPRecord_ggsnAddressUsed,
        _SGSNPDPRecord_accessPointNameNI,
        _SGSNPDPRecord_pdpType,
        _SGSNPDPRecord_servedPDPAddress,
        __SGSNPDPRecord_listOfTrafficVolumes__item_,
        _SGSNPDPRecord_listOfTrafficVolumes,
        _SGSNPDPRecord_recordOpeningTime,
        _SGSNPDPRecord_duration,
        _SGSNPDPRecord_sgsnChange,
        _SGSNPDPRecord_causeForRecClosing,
        _SGSNPDPRecord_diagnostics,
        _SGSNPDPRecord_recordSequenceNumber,
        _SGSNPDPRecord_nodeID,
        _SGSNPDPRecord_recordExtensions,
        _SGSNPDPRecord_localSequenceNumber,
        _SGSNPDPRecord_apnSelectionMode,
        _SGSNPDPRecord_accessPointNameOI,
        _SGSNPDPRecord_servedMSISDN,
        _SGSNPDPRecord_chargingCharacteristics,
        _SGSNPDPRecord_rATType,
        _SGSNPDPRecord_cAMELInformationPDP,
        _SGSNPDPRecord_rNCUnsentDownlinkVolume,
        _SGSNPDPRecord_chChSelectionMode,
        _SGSNPDPRecord_dynamicAddressFlag,
        _SGSNPDPRecord_iMSIunauthenticatedFlag,
        _SGSNPDPRecord_userCSGInformation,
        _SGSNPDPRecord_servedPDPPDNAddressExt,
        _SGSNPDPRecord_lowPriorityIndicator,
        _SGSNPDPRecord_servingNodePLMNIdentifier,
        _SGSNPDPRecord_cNOperatorSelectionEnt,
        SGSNPDPRecord,
        _SGSNSMORecord_recordType,
        _SGSNSMORecord_servedIMSI,
        _SGSNSMORecord_servedIMEI,
        _SGSNSMORecord_servedMSISDN,
        _SGSNSMORecord_msNetworkCapability,
        _SGSNSMORecord_serviceCentre,
        _SGSNSMORecord_recordingEntity,
        _SGSNSMORecord_locationArea,
        _SGSNSMORecord_routingArea,
        _SGSNSMORecord_cellIdentifier,
        _SGSNSMORecord_messageReference,
        _SGSNSMORecord_eventTimeStamp,
        _SGSNSMORecord_smsResult,
        _SGSNSMORecord_recordExtensions,
        _SGSNSMORecord_nodeID,
        _SGSNSMORecord_localSequenceNumber,
        _SGSNSMORecord_chargingCharacteristics,
        _SGSNSMORecord_rATType,
        _SGSNSMORecord_destinationNumber,
        _SGSNSMORecord_cAMELInformationSMS,
        _SGSNSMORecord_chChSelectionMode,
        _SGSNSMORecord_servingNodeType,
        _SGSNSMORecord_servingNodeAddress,
        _SGSNSMORecord_servingNodeiPv6Address,
        _SGSNSMORecord_mMEName,
        _SGSNSMORecord_mMERealm,
        _SGSNSMORecord_userLocationInformation,
        _SGSNSMORecord_retransmission,
        _SGSNSMORecord_servingNodePLMNIdentifier,
        _SGSNSMORecord_userLocationInfoTime,
        _SGSNSMORecord_cNOperatorSelectionEnt,
        SGSNSMORecord,
        _SGSNSMTRecord_recordType,
        _SGSNSMTRecord_servedIMSI,
        _SGSNSMTRecord_servedIMEI,
        _SGSNSMTRecord_servedMSISDN,
        _SGSNSMTRecord_msNetworkCapability,
        _SGSNSMTRecord_serviceCentre,
        _SGSNSMTRecord_recordingEntity,
        _SGSNSMTRecord_locationArea,
        _SGSNSMTRecord_routingArea,
        _SGSNSMTRecord_cellIdentifier,
        _SGSNSMTRecord_eventTimeStamp,
        _SGSNSMTRecord_smsResult,
        _SGSNSMTRecord_recordExtensions,
        _SGSNSMTRecord_nodeID,
        _SGSNSMTRecord_localSequenceNumber,
        _SGSNSMTRecord_chargingCharacteristics,
        _SGSNSMTRecord_rATType,
        _SGSNSMTRecord_chChSelectionMode,
        _SGSNSMTRecord_cAMELInformationSMS,
        _SGSNSMTRecord_originatingAddress,
        _SGSNSMTRecord_servingNodeType,
        _SGSNSMTRecord_servingNodeAddress,
        _SGSNSMTRecord_servingNodeiPv6Address,
        _SGSNSMTRecord_mMEName,
        _SGSNSMTRecord_mMERealm,
        _SGSNSMTRecord_userLocationInformation,
        _SGSNSMTRecord_retransmission,
        _SGSNSMTRecord_servingNodePLMNIdentifier,
        _SGSNSMTRecord_userLocationInfoTime,
        _SGSNSMTRecord_cNOperatorSelectionEnt,
        SGSNSMTRecord,
        _SGSNMTLCSRecord_recordType,
        _SGSNMTLCSRecord_recordingEntity,
        _SGSNMTLCSRecord_lcsClientType,
        _SGSNMTLCSRecord_lcsClientIdentity,
        _SGSNMTLCSRecord_servedIMSI,
        _SGSNMTLCSRecord_servedMSISDN,
        _SGSNMTLCSRecord_sgsnAddress,
        _SGSNMTLCSRecord_locationType,
        _SGSNMTLCSRecord_lcsQos,
        _SGSNMTLCSRecord_lcsPriority,
        _SGSNMTLCSRecord_mlcNumber,
        _SGSNMTLCSRecord_eventTimeStamp,
        _SGSNMTLCSRecord_measurementDuration,
        _SGSNMTLCSRecord_notificationToMSUser,
        _SGSNMTLCSRecord_privacyOverride,
        _SGSNMTLCSRecord_location,
        _SGSNMTLCSRecord_routingArea,
        _SGSNMTLCSRecord_locationEstimate,
        _SGSNMTLCSRecord_positioningData,
        _SGSNMTLCSRecord_lcsCause,
        _SGSNMTLCSRecord_diagnostics,
        _SGSNMTLCSRecord_nodeID,
        _SGSNMTLCSRecord_localSequenceNumber,
        _SGSNMTLCSRecord_chargingCharacteristics,
        _SGSNMTLCSRecord_chChSelectionMode,
        _SGSNMTLCSRecord_rATType,
        _SGSNMTLCSRecord_recordExtensions,
        _SGSNMTLCSRecord_causeForRecClosing,
        _SGSNMTLCSRecord_servingNodePLMNIdentifier,
        _SGSNMTLCSRecord_cNOperatorSelectionEnt,
        SGSNMTLCSRecord,
        _SGSNMOLCSRecord_recordType,
        _SGSNMOLCSRecord_recordingEntity,
        _SGSNMOLCSRecord_lcsClientType,
        _SGSNMOLCSRecord_lcsClientIdentity,
        _SGSNMOLCSRecord_servedIMSI,
        _SGSNMOLCSRecord_servedMSISDN,
        _SGSNMOLCSRecord_sgsnAddress,
        _SGSNMOLCSRecord_locationMethod,
        _SGSNMOLCSRecord_lcsQos,
        _SGSNMOLCSRecord_lcsPriority,
        _SGSNMOLCSRecord_mlcNumber,
        _SGSNMOLCSRecord_eventTimeStamp,
        _SGSNMOLCSRecord_measurementDuration,
        _SGSNMOLCSRecord_location,
        _SGSNMOLCSRecord_routingArea,
        _SGSNMOLCSRecord_locationEstimate,
        _SGSNMOLCSRecord_positioningData,
        _SGSNMOLCSRecord_lcsCause,
        _SGSNMOLCSRecord_diagnostics,
        _SGSNMOLCSRecord_nodeID,
        _SGSNMOLCSRecord_localSequenceNumber,
        _SGSNMOLCSRecord_chargingCharacteristics,
        _SGSNMOLCSRecord_chChSelectionMode,
        _SGSNMOLCSRecord_rATType,
        _SGSNMOLCSRecord_recordExtensions,
        _SGSNMOLCSRecord_causeForRecClosing,
        _SGSNMOLCSRecord_servingNodePLMNIdentifier,
        _SGSNMOLCSRecord_cNOperatorSelectionEnt,
        SGSNMOLCSRecord,
        _SGSNNILCSRecord_recordType,
        _SGSNNILCSRecord_recordingEntity,
        _SGSNNILCSRecord_lcsClientType,
        _SGSNNILCSRecord_lcsClientIdentity,
        _SGSNNILCSRecord_servedIMSI,
        _SGSNNILCSRecord_servedMSISDN,
        _SGSNNILCSRecord_sgsnAddress,
        _SGSNNILCSRecord_servedIMEI,
        _SGSNNILCSRecord_lcsQos,
        _SGSNNILCSRecord_lcsPriority,
        _SGSNNILCSRecord_mlcNumber,
        _SGSNNILCSRecord_eventTimeStamp,
        _SGSNNILCSRecord_measurementDuration,
        _SGSNNILCSRecord_location,
        _SGSNNILCSRecord_routingArea,
        _SGSNNILCSRecord_locationEstimate,
        _SGSNNILCSRecord_positioningData,
        _SGSNNILCSRecord_lcsCause,
        _SGSNNILCSRecord_diagnostics,
        _SGSNNILCSRecord_nodeID,
        _SGSNNILCSRecord_localSequenceNumber,
        _SGSNNILCSRecord_chargingCharacteristics,
        _SGSNNILCSRecord_chChSelectionMode,
        _SGSNNILCSRecord_rATType,
        _SGSNNILCSRecord_recordExtensions,
        _SGSNNILCSRecord_causeForRecClosing,
        _SGSNNILCSRecord_servingNodePLMNIdentifier,
        _SGSNNILCSRecord_cNOperatorSelectionEnt,
        SGSNNILCSRecord,
        _SGSNMBMSRecord_recordType,
        _SGSNMBMSRecord_ggsnAddress,
        _SGSNMBMSRecord_chargingID,
        __SGSNMBMSRecord_listofRAs__item_,
        _SGSNMBMSRecord_listofRAs,
        _SGSNMBMSRecord_accessPointNameNI,
        _SGSNMBMSRecord_servedPDPAddress,
        __SGSNMBMSRecord_listOfTrafficVolumes__item_,
        _SGSNMBMSRecord_listOfTrafficVolumes,
        _SGSNMBMSRecord_recordOpeningTime,
        _SGSNMBMSRecord_duration,
        _SGSNMBMSRecord_causeForRecClosing,
        _SGSNMBMSRecord_diagnostics,
        _SGSNMBMSRecord_recordSequenceNumber,
        _SGSNMBMSRecord_nodeID,
        _SGSNMBMSRecord_recordExtensions,
        _SGSNMBMSRecord_localSequenceNumber,
        _SGSNMBMSRecord_sgsnPLMNIdentifier,
        _SGSNMBMSRecord_numberofReceivingUE,
        _SGSNMBMSRecord_mbmsInformation,
        SGSNMBMSRecord,
        _GGSNMBMSRecord_recordType,
        _GGSNMBMSRecord_ggsnAddress,
        _GGSNMBMSRecord_chargingID,
        __GGSNMBMSRecord_listofDownstreamNodes__item_,
        _GGSNMBMSRecord_listofDownstreamNodes,
        _GGSNMBMSRecord_accessPointNameNI,
        _GGSNMBMSRecord_servedPDPAddress,
        __GGSNMBMSRecord_listOfTrafficVolumes__item_,
        _GGSNMBMSRecord_listOfTrafficVolumes,
        _GGSNMBMSRecord_recordOpeningTime,
        _GGSNMBMSRecord_duration,
        _GGSNMBMSRecord_causeForRecClosing,
        _GGSNMBMSRecord_diagnostics,
        _GGSNMBMSRecord_recordSequenceNumber,
        _GGSNMBMSRecord_nodeID,
        _GGSNMBMSRecord_recordExtensions,
        _GGSNMBMSRecord_localSequenceNumber,
        _GGSNMBMSRecord_mbmsInformation,
        GGSNMBMSRecord,
        _GWMBMSRecord_recordType,
        _GWMBMSRecord_mbmsGWAddress,
        _GWMBMSRecord_chargingID,
        __GWMBMSRecord_listofDownstreamNodes__item_,
        _GWMBMSRecord_listofDownstreamNodes,
        _GWMBMSRecord_accessPointNameNI,
        _GWMBMSRecord_pdpPDNType,
        _GWMBMSRecord_servedPDPPDNAddress,
        __GWMBMSRecord_listOfTrafficVolumes__item_,
        _GWMBMSRecord_listOfTrafficVolumes,
        _GWMBMSRecord_recordOpeningTime,
        _GWMBMSRecord_duration,
        _GWMBMSRecord_causeForRecClosing,
        _GWMBMSRecord_diagnostics,
        _GWMBMSRecord_recordSequenceNumber,
        _GWMBMSRecord_nodeID,
        _GWMBMSRecord_recordExtensions,
        _GWMBMSRecord_localSequenceNumber,
        _GWMBMSRecord_mbmsInformation,
        _GWMBMSRecord_commonTeid,
        _GWMBMSRecord_iPMulticastSourceAddress,
        GWMBMSRecord,
        AccessAvailabilityChangeReason,
        _AccessLineIdentifier_physicalAccessID,
        _AccessLineIdentifier_logicalAccessID,
        AccessLineIdentifier,
        AccessPointNameNI,
        AccessPointNameOI,
        ADCRuleBaseName,
        AdditionalExceptionReports,
        AFChargingIdentifier,
        _AFRecordInformation_aFChargingIdentifier,
        _AFRecordInformation_flows,
        AFRecordInformation,
        _APNRateControl_aPNRateControlUplink,
        _APNRateControl_aPNRateControlDownlink,
        APNRateControl,
        _APNRateControlParameters_additionalExceptionReports,
        _APNRateControlParameters_rateControlTimeUnit,
        _APNRateControlParameters_rateControlMaxRate,
        _APNRateControlParameters_rateControlMaxMessageSize,
        APNRateControlParameters,
        APNSelectionMode,
        _CalleePartyInformation_called_Party_Address,
        _CalleePartyInformation_requested_Party_Address,
        __CalleePartyInformation_list_Of_Called_Asserted_Identity__item_,
        _CalleePartyInformation_list_Of_Called_Asserted_Identity,
        CalleePartyInformation,
        CAMELAccessPointNameNI,
        CAMELAccessPointNameOI,
        _CAMELInformationMM_sCFAddress,
        _CAMELInformationMM_serviceKey,
        _CAMELInformationMM_defaultTransactionHandling,
        _CAMELInformationMM_numberOfDPEncountered,
        _CAMELInformationMM_levelOfCAMELService,
        _CAMELInformationMM_freeFormatData,
        _CAMELInformationMM_fFDAppendIndicator,
        CAMELInformationMM,
        _CAMELInformationPDP_sCFAddress,
        _CAMELInformationPDP_serviceKey,
        _CAMELInformationPDP_defaultTransactionHandling,
        _CAMELInformationPDP_cAMELAccessPointNameNI,
        _CAMELInformationPDP_cAMELAccessPointNameOI,
        _CAMELInformationPDP_numberOfDPEncountered,
        _CAMELInformationPDP_levelOfCAMELService,
        _CAMELInformationPDP_freeFormatData,
        _CAMELInformationPDP_fFDAppendIndicator,
        CAMELInformationPDP,
        _CAMELInformationSMS_sCFAddress,
        _CAMELInformationSMS_serviceKey,
        _CAMELInformationSMS_defaultSMSHandling,
        _CAMELInformationSMS_cAMELCallingPartyNumber,
        _CAMELInformationSMS_cAMELDestinationSubscriberNumber,
        _CAMELInformationSMS_cAMELSMSCAddress,
        _CAMELInformationSMS_freeFormatData,
        _CAMELInformationSMS_smsReferenceNumber,
        CAMELInformationSMS,
        ChangeCondition,
        _ChangeOfCharCondition_qosRequested,
        _ChangeOfCharCondition_qosNegotiated,
        _ChangeOfCharCondition_dataVolumeGPRSUplink,
        _ChangeOfCharCondition_dataVolumeGPRSDownlink,
        _ChangeOfCharCondition_changeCondition,
        _ChangeOfCharCondition_changeTime,
        _ChangeOfCharCondition_userLocationInformation,
        _ChangeOfCharCondition_ePCQoSInformation,
        _ChangeOfCharCondition_chargingID,
        _ChangeOfCharCondition_presenceReportingAreaStatus,
        _ChangeOfCharCondition_userCSGInformation,
        _ChangeOfCharCondition_diagnostics,
        _ChangeOfCharCondition_enhancedDiagnostics,
        _ChangeOfCharCondition_rATType,
        _ChangeOfCharCondition_accessAvailabilityChangeReason,
        _ChangeOfCharCondition_uWANUserLocationInformation,
        _ChangeOfCharCondition_relatedChangeOfCharCondition,
        _ChangeOfCharCondition_cPCIoTEPSOptimisationIndicator,
        _ChangeOfCharCondition_servingPLMNRateControl,
        _ChangeOfCharCondition_threeGPPPSDataOffStatus,
        __ChangeOfCharCondition_listOfPresenceReportingAreaInformation__item_,
        _ChangeOfCharCondition_listOfPresenceReportingAreaInformation,
        _ChangeOfCharCondition_aPNRateControl,
        ChangeOfCharCondition,
        _ChangeOfMBMSCondition_qosRequested,
        _ChangeOfMBMSCondition_qosNegotiated,
        _ChangeOfMBMSCondition_dataVolumeMBMSUplink,
        _ChangeOfMBMSCondition_dataVolumeMBMSDownlink,
        _ChangeOfMBMSCondition_changeCondition,
        _ChangeOfMBMSCondition_changeTime,
        _ChangeOfMBMSCondition_failureHandlingContinue,
        ChangeOfMBMSCondition,
        _ChangeOfServiceCondition_ratingGroup,
        _ChangeOfServiceCondition_chargingRuleBaseName,
        _ChangeOfServiceCondition_resultCode,
        _ChangeOfServiceCondition_localSequenceNumber,
        _ChangeOfServiceCondition_timeOfFirstUsage,
        _ChangeOfServiceCondition_timeOfLastUsage,
        _ChangeOfServiceCondition_timeUsage,
        _ChangeOfServiceCondition_serviceConditionChange,
        _ChangeOfServiceCondition_qoSInformationNeg,
        _ChangeOfServiceCondition_servingNodeAddress,
        _ChangeOfServiceCondition_datavolumeFBCUplink,
        _ChangeOfServiceCondition_datavolumeFBCDownlink,
        _ChangeOfServiceCondition_timeOfReport,
        _ChangeOfServiceCondition_failureHandlingContinue,
        _ChangeOfServiceCondition_serviceIdentifier,
        _ChangeOfServiceCondition_pSFurnishChargingInformation,
        __ChangeOfServiceCondition_aFRecordInformation__item_,
        _ChangeOfServiceCondition_aFRecordInformation,
        _ChangeOfServiceCondition_userLocationInformation,
        _ChangeOfServiceCondition_eventBasedChargingInformation,
        _ChangeOfServiceCondition_timeQuotaMechanism,
        __ChangeOfServiceCondition_serviceSpecificInfo__item_,
        _ChangeOfServiceCondition_serviceSpecificInfo,
        _ChangeOfServiceCondition_threeGPP2UserLocationInformation,
        _ChangeOfServiceCondition_sponsorIdentity,
        _ChangeOfServiceCondition_applicationServiceProviderIdentity,
        _ChangeOfServiceCondition_aDCRuleBaseName,
        _ChangeOfServiceCondition_presenceReportingAreaStatus,
        _ChangeOfServiceCondition_userCSGInformation,
        _ChangeOfServiceCondition_rATType,
        _ChangeOfServiceCondition_uWANUserLocationInformation,
        _ChangeOfServiceCondition_relatedChangeOfServiceCondition,
        _ChangeOfServiceCondition_servingPLMNRateControl,
        _ChangeOfServiceCondition_aPNRateControl,
        _ChangeOfServiceCondition_threeGPPPSDataOffStatus,
        _ChangeOfServiceCondition_trafficSteeringPolicyIDDownlink,
        _ChangeOfServiceCondition_trafficSteeringPolicyIDUplink,
        _ChangeOfServiceCondition_tWANUserLocationInformation,
        __ChangeOfServiceCondition_listOfPresenceReportingAreaInformation__item_,
        _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation,
        _ChangeOfServiceCondition_voLTEInformation,
        ChangeOfServiceCondition,
        _ChangeLocation_locationAreaCode,
        _ChangeLocation_routingAreaCode,
        _ChangeLocation_cellId,
        _ChangeLocation_changeTime,
        _ChangeLocation_mCC_MNC,
        ChangeLocation,
        ChargingCharacteristics,
        ChargingPerIPCANSessionIndicator,
        ChargingRuleBaseName,
        ChChSelectionMode,
        CNOperatorSelectionEntity,
        CPCIoTEPSOptimisationIndicator,
        CSGAccessMode,
        CSGId,
        CTEID,
        DataVolumeGPRS,
        DataVolumeMBMS,
        _EPCQoSInformation_qCI,
        _EPCQoSInformation_maxRequestedBandwithUL,
        _EPCQoSInformation_maxRequestedBandwithDL,
        _EPCQoSInformation_guaranteedBitrateUL,
        _EPCQoSInformation_guaranteedBitrateDL,
        _EPCQoSInformation_aRP,
        _EPCQoSInformation_aPNAggregateMaxBitrateUL,
        _EPCQoSInformation_aPNAggregateMaxBitrateDL,
        _EPCQoSInformation_extendedMaxRequestedBWUL,
        _EPCQoSInformation_extendedMaxRequestedBWDL,
        _EPCQoSInformation_extendedGBRUL,
        _EPCQoSInformation_extendedGBRDL,
        _EPCQoSInformation_extendedAPNAMBRUL,
        _EPCQoSInformation_extendedAPNAMBRDL,
        EPCQoSInformation,
        _EventBasedChargingInformation_numberOfEvents,
        __EventBasedChargingInformation_eventTimeStamps__item_,
        _EventBasedChargingInformation_eventTimeStamps,
        EventBasedChargingInformation,
        FailureHandlingContinue,
        FFDAppendIndicator,
        FixedSubsID,
        _FixedUserLocationInformation_sSID,
        _FixedUserLocationInformation_bSSID,
        _FixedUserLocationInformation_accessLineIdentifier,
        FixedUserLocationInformation,
        _Flows_mediaComponentNumber,
        __Flows_flowNumber__item_,
        _Flows_flowNumber,
        Flows,
        FreeFormatData,
        _MOExceptionDataCounter_counterValue,
        _MOExceptionDataCounter_counterTimestamp,
        MOExceptionDataCounter,
        MSNetworkCapability,
        NBIFOMMode,
        NBIFOMSupport,
        NetworkInitiatedPDPContext,
        NumberOfDPEncountered,
        PDPType,
        PDPPDNTypeExtension,
        PresenceReportingAreaElementsList,
        _PresenceReportingAreaInfo_presenceReportingAreaIdentifier,
        _PresenceReportingAreaInfo_presenceReportingAreaStatus,
        _PresenceReportingAreaInfo_presenceReportingAreaElementsList,
        _PresenceReportingAreaInfo_presenceReportingAreaNode,
        PresenceReportingAreaInfo,
        PresenceReportingAreaNode,
        PresenceReportingAreaStatus,
        _PSFurnishChargingInformation_pSFreeFormatData,
        _PSFurnishChargingInformation_pSFFDAppendIndicator,
        PSFurnishChargingInformation,
        QoSInformation,
        _RANSecondaryRATUsageReport_dataVolumeUplink,
        _RANSecondaryRATUsageReport_dataVolumeDownlink,
        _RANSecondaryRATUsageReport_rANStartTime,
        _RANSecondaryRATUsageReport_rANEndTime,
        _RANSecondaryRATUsageReport_secondaryRATType,
        _RANSecondaryRATUsageReport_chargingID,
        RANSecondaryRATUsageReport,
        RateControlTimeUnit,
        RatingGroupId,
        _RelatedChangeOfCharCondition_changeCondition,
        _RelatedChangeOfCharCondition_changeTime,
        _RelatedChangeOfCharCondition_userLocationInformation,
        _RelatedChangeOfCharCondition_presenceReportingAreaStatus,
        _RelatedChangeOfCharCondition_userCSGInformation,
        _RelatedChangeOfCharCondition_rATType,
        _RelatedChangeOfCharCondition_uWANUserLocationInformation,
        RelatedChangeOfCharCondition,
        _RelatedChangeOfServiceCondition_userLocationInformation,
        _RelatedChangeOfServiceCondition_threeGPP2UserLocationInformation,
        _RelatedChangeOfServiceCondition_presenceReportingAreaStatus,
        _RelatedChangeOfServiceCondition_userCSGInformation,
        _RelatedChangeOfServiceCondition_rATType,
        _RelatedChangeOfServiceCondition_uWANUserLocationInformation,
        _RelatedChangeOfServiceCondition_relatedServiceConditionChange,
        RelatedChangeOfServiceCondition,
        ResultCode,
        SecondaryRATType,
        ServiceConditionChange,
        SCFAddress,
        ServiceIdentifier,
        ServingNodeType,
        _ServingPLMNRateControl_sPLMNDLRateControlValue,
        _ServingPLMNRateControl_sPLMNULRateControlValue,
        ServingPLMNRateControl,
        SGiPtPTunnellingMethod,
        SGSNChange,
        SGWChange,
        _TimeQuotaMechanism_timeQuotaType,
        _TimeQuotaMechanism_baseTimeInterval,
        TimeQuotaMechanism,
        TimeQuotaType,
        TrafficSteeringPolicyIDDownlink,
        TrafficSteeringPolicyIDUplink,
        _TWANUserLocationInfo_sSID,
        _TWANUserLocationInfo_bSSID,
        _TWANUserLocationInfo_civicAddressInformation,
        _TWANUserLocationInfo_wLANOperatorId,
        _TWANUserLocationInfo_logicalAccessID,
        TWANUserLocationInfo,
        UNIPDUCPOnlyFlag,
        _UserCSGInformation_cSGId,
        _UserCSGInformation_cSGAccessMode,
        _UserCSGInformation_cSGMembershipIndication,
        UserCSGInformation,
        _UWANUserLocationInfo_uELocalIPAddress,
        _UWANUserLocationInfo_uDPSourcePort,
        _UWANUserLocationInfo_sSID,
        _UWANUserLocationInfo_bSSID,
        _UWANUserLocationInfo_tCPSourcePort,
        _UWANUserLocationInfo_civicAddressInformation,
        _UWANUserLocationInfo_wLANOperatorId,
        _UWANUserLocationInfo_logicalAccessID,
        UWANUserLocationInfo,
        __VoLTEInformation_callerInformation__item_,
        _VoLTEInformation_callerInformation,
        _VoLTEInformation_calleeInformation,
        VoLTEInformation,
        _WLANOperatorId_wLANOperatorName,
        _WLANOperatorId_wLANPLMNId,
        WLANOperatorId,
    ]

class HierarchicalOperationalBindings:

    _name_  = 'HierarchicalOperationalBindings'
    _oid_   = [2, 5, 1, 20, 8]
    
    _obj_ = [
        'HierarchicalAgreement',
        'SuperiorToSubordinate',
        'DITcontext',
        'Vertex',
        'SubentryInfo',
        'SubordinateToSuperior',
        'SuperiorToSubordinateModification',
        'NonSpecificHierarchicalAgreement',
        'NHOBSuperiorToSubordinate',
        'NHOBSubordinateToSuperior',
        'hierarchicalOperationalBinding',
        'nonSpecificHierarchicalOperationalBinding',
        ]
    _type_ = [
        'HierarchicalAgreement',
        'SuperiorToSubordinate',
        'DITcontext',
        'Vertex',
        'SubentryInfo',
        'SubordinateToSuperior',
        'SuperiorToSubordinateModification',
        'NonSpecificHierarchicalAgreement',
        'NHOBSuperiorToSubordinate',
        'NHOBSubordinateToSuperior',
        ]
    _set_ = [
        ]
    _val_ = [
        'hierarchicalOperationalBinding',
        'nonSpecificHierarchicalOperationalBinding',
        ]
    _class_ = [
        'hierarchicalOperationalBinding',
        'nonSpecificHierarchicalOperationalBinding',
        ]
    _param_ = [
        ]
    
    #-----< HierarchicalAgreement >-----#
    HierarchicalAgreement = SEQ(name='HierarchicalAgreement', mode=MODE_TYPE)
    _HierarchicalAgreement_rdn = SET_OF(name='rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _HierarchicalAgreement_immediateSuperior = SEQ_OF(name='immediateSuperior', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    HierarchicalAgreement._cont = ASN1Dict([
        ('rdn', _HierarchicalAgreement_rdn),
        ('immediateSuperior', _HierarchicalAgreement_immediateSuperior),
        ])
    HierarchicalAgreement._ext = []
    
    #-----< SuperiorToSubordinate >-----#
    SuperiorToSubordinate = SEQ(name='SuperiorToSubordinate', mode=MODE_TYPE)
    _SuperiorToSubordinate_contextPrefixInfo = SEQ_OF(name='contextPrefixInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HierarchicalOperationalBindings', 'DITcontext')))
    _SuperiorToSubordinate_entryInfo = SET_OF(name='entryInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SuperiorToSubordinate_entryInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SuperiorToSubordinate_entryInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SuperiorToSubordinate_entryInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SuperiorToSubordinate_entryInfo__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab_at = None
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab_id = 'id'
    ___SuperiorToSubordinate_entryInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SuperiorToSubordinate_entryInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab_id = 'Type'
    ___SuperiorToSubordinate_entryInfo__item__values._cont = ____SuperiorToSubordinate_entryInfo__item__values__item_
    ___SuperiorToSubordinate_entryInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList._cont = ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value),
        ('contextList', _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList),
        ])
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_._ext = []
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext._cont = ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SuperiorToSubordinate_entryInfo__item_._cont = ASN1Dict([
        ('type', ___SuperiorToSubordinate_entryInfo__item__type),
        ('values', ___SuperiorToSubordinate_entryInfo__item__values),
        ('valuesWithContext', ___SuperiorToSubordinate_entryInfo__item__valuesWithContext),
        ])
    __SuperiorToSubordinate_entryInfo__item_._ext = []
    _SuperiorToSubordinate_entryInfo._cont = __SuperiorToSubordinate_entryInfo__item_
    _SuperiorToSubordinate_entryInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SuperiorToSubordinate_immediateSuperiorInfo = SET_OF(name='immediateSuperiorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SuperiorToSubordinate_immediateSuperiorInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab_at = None
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab_id = 'id'
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab_id = 'Type'
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values._cont = ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList._cont = ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value),
        ('contextList', _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList),
        ])
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_._ext = []
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext._cont = ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SuperiorToSubordinate_immediateSuperiorInfo__item_._cont = ASN1Dict([
        ('type', ___SuperiorToSubordinate_immediateSuperiorInfo__item__type),
        ('values', ___SuperiorToSubordinate_immediateSuperiorInfo__item__values),
        ('valuesWithContext', ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext),
        ])
    __SuperiorToSubordinate_immediateSuperiorInfo__item_._ext = []
    _SuperiorToSubordinate_immediateSuperiorInfo._cont = __SuperiorToSubordinate_immediateSuperiorInfo__item_
    _SuperiorToSubordinate_immediateSuperiorInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SuperiorToSubordinate._cont = ASN1Dict([
        ('contextPrefixInfo', _SuperiorToSubordinate_contextPrefixInfo),
        ('entryInfo', _SuperiorToSubordinate_entryInfo),
        ('immediateSuperiorInfo', _SuperiorToSubordinate_immediateSuperiorInfo),
        ])
    SuperiorToSubordinate._ext = []
    
    #-----< DITcontext >-----#
    DITcontext = SEQ_OF(name='DITcontext', mode=MODE_TYPE)
    _DITcontext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'Vertex')))
    DITcontext._cont = _DITcontext__item_
    
    #-----< Vertex >-----#
    Vertex = SEQ(name='Vertex', mode=MODE_TYPE)
    _Vertex_rdn = SET_OF(name='rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _Vertex_admPointInfo = SET_OF(name='admPointInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Vertex_admPointInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___Vertex_admPointInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____Vertex_admPointInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____Vertex_admPointInfo__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____Vertex_admPointInfo__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____Vertex_admPointInfo__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____Vertex_admPointInfo__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____Vertex_admPointInfo__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___Vertex_admPointInfo__item__type._const_tab = ____Vertex_admPointInfo__item__type_tab
    ___Vertex_admPointInfo__item__type._const_tab_at = None
    ___Vertex_admPointInfo__item__type._const_tab_id = 'id'
    ___Vertex_admPointInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____Vertex_admPointInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____Vertex_admPointInfo__item__values__item_._const_tab = ____Vertex_admPointInfo__item__type_tab
    ____Vertex_admPointInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____Vertex_admPointInfo__item__values__item_._const_tab_id = 'Type'
    ___Vertex_admPointInfo__item__values._cont = ____Vertex_admPointInfo__item__values__item_
    ___Vertex_admPointInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___Vertex_admPointInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____Vertex_admPointInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____Vertex_admPointInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab = ____Vertex_admPointInfo__item__type_tab
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList._cont = ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____Vertex_admPointInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____Vertex_admPointInfo__item__valuesWithContext__item__value),
        ('contextList', _____Vertex_admPointInfo__item__valuesWithContext__item__contextList),
        ])
    ____Vertex_admPointInfo__item__valuesWithContext__item_._ext = []
    ___Vertex_admPointInfo__item__valuesWithContext._cont = ____Vertex_admPointInfo__item__valuesWithContext__item_
    ___Vertex_admPointInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __Vertex_admPointInfo__item_._cont = ASN1Dict([
        ('type', ___Vertex_admPointInfo__item__type),
        ('values', ___Vertex_admPointInfo__item__values),
        ('valuesWithContext', ___Vertex_admPointInfo__item__valuesWithContext),
        ])
    __Vertex_admPointInfo__item_._ext = []
    _Vertex_admPointInfo._cont = __Vertex_admPointInfo__item_
    _Vertex_admPointInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Vertex_subentries = SET_OF(name='subentries', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Vertex_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _Vertex_subentries._cont = __Vertex_subentries__item_
    _Vertex_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Vertex_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    Vertex._cont = ASN1Dict([
        ('rdn', _Vertex_rdn),
        ('admPointInfo', _Vertex_admPointInfo),
        ('subentries', _Vertex_subentries),
        ('accessPoints', _Vertex_accessPoints),
        ])
    Vertex._ext = []
    
    #-----< SubentryInfo >-----#
    SubentryInfo = SEQ(name='SubentryInfo', mode=MODE_TYPE)
    _SubentryInfo_rdn = SET_OF(name='rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _SubentryInfo_info = SET_OF(name='info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SubentryInfo_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubentryInfo_info__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SubentryInfo_info__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubentryInfo_info__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SubentryInfo_info__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubentryInfo_info__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SubentryInfo_info__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SubentryInfo_info__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubentryInfo_info__item__type._const_tab = ____SubentryInfo_info__item__type_tab
    ___SubentryInfo_info__item__type._const_tab_at = None
    ___SubentryInfo_info__item__type._const_tab_id = 'id'
    ___SubentryInfo_info__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SubentryInfo_info__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SubentryInfo_info__item__values__item_._const_tab = ____SubentryInfo_info__item__type_tab
    ____SubentryInfo_info__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SubentryInfo_info__item__values__item_._const_tab_id = 'Type'
    ___SubentryInfo_info__item__values._cont = ____SubentryInfo_info__item__values__item_
    ___SubentryInfo_info__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubentryInfo_info__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubentryInfo_info__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubentryInfo_info__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab = ____SubentryInfo_info__item__type_tab
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SubentryInfo_info__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubentryInfo_info__item__valuesWithContext__item__contextList._cont = ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_
    _____SubentryInfo_info__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubentryInfo_info__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SubentryInfo_info__item__valuesWithContext__item__value),
        ('contextList', _____SubentryInfo_info__item__valuesWithContext__item__contextList),
        ])
    ____SubentryInfo_info__item__valuesWithContext__item_._ext = []
    ___SubentryInfo_info__item__valuesWithContext._cont = ____SubentryInfo_info__item__valuesWithContext__item_
    ___SubentryInfo_info__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubentryInfo_info__item_._cont = ASN1Dict([
        ('type', ___SubentryInfo_info__item__type),
        ('values', ___SubentryInfo_info__item__values),
        ('valuesWithContext', ___SubentryInfo_info__item__valuesWithContext),
        ])
    __SubentryInfo_info__item_._ext = []
    _SubentryInfo_info._cont = __SubentryInfo_info__item_
    SubentryInfo._cont = ASN1Dict([
        ('rdn', _SubentryInfo_rdn),
        ('info', _SubentryInfo_info),
        ])
    SubentryInfo._ext = []
    
    #-----< SubordinateToSuperior >-----#
    SubordinateToSuperior = SEQ(name='SubordinateToSuperior', mode=MODE_TYPE)
    _SubordinateToSuperior_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    _SubordinateToSuperior_alias = BOOL(name='alias', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SubordinateToSuperior_entryInfo = SET_OF(name='entryInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubordinateToSuperior_entryInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubordinateToSuperior_entryInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SubordinateToSuperior_entryInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubordinateToSuperior_entryInfo__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubordinateToSuperior_entryInfo__item__type._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    ___SubordinateToSuperior_entryInfo__item__type._const_tab_at = None
    ___SubordinateToSuperior_entryInfo__item__type._const_tab_id = 'id'
    ___SubordinateToSuperior_entryInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SubordinateToSuperior_entryInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab_id = 'Type'
    ___SubordinateToSuperior_entryInfo__item__values._cont = ____SubordinateToSuperior_entryInfo__item__values__item_
    ___SubordinateToSuperior_entryInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList._cont = ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value),
        ('contextList', _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList),
        ])
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_._ext = []
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext._cont = ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubordinateToSuperior_entryInfo__item_._cont = ASN1Dict([
        ('type', ___SubordinateToSuperior_entryInfo__item__type),
        ('values', ___SubordinateToSuperior_entryInfo__item__values),
        ('valuesWithContext', ___SubordinateToSuperior_entryInfo__item__valuesWithContext),
        ])
    __SubordinateToSuperior_entryInfo__item_._ext = []
    _SubordinateToSuperior_entryInfo._cont = __SubordinateToSuperior_entryInfo__item_
    _SubordinateToSuperior_entryInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SubordinateToSuperior_subentries = SET_OF(name='subentries', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubordinateToSuperior_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _SubordinateToSuperior_subentries._cont = __SubordinateToSuperior_subentries__item_
    _SubordinateToSuperior_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SubordinateToSuperior._cont = ASN1Dict([
        ('accessPoints', _SubordinateToSuperior_accessPoints),
        ('alias', _SubordinateToSuperior_alias),
        ('entryInfo', _SubordinateToSuperior_entryInfo),
        ('subentries', _SubordinateToSuperior_subentries),
        ])
    SubordinateToSuperior._ext = []
    
    #-----< SuperiorToSubordinateModification >-----#
    SuperiorToSubordinateModification = SEQ(name='SuperiorToSubordinateModification', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    
    #-----< NonSpecificHierarchicalAgreement >-----#
    NonSpecificHierarchicalAgreement = SEQ(name='NonSpecificHierarchicalAgreement', mode=MODE_TYPE)
    _NonSpecificHierarchicalAgreement_immediateSuperior = SEQ_OF(name='immediateSuperior', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    NonSpecificHierarchicalAgreement._cont = ASN1Dict([
        ('immediateSuperior', _NonSpecificHierarchicalAgreement_immediateSuperior),
        ])
    NonSpecificHierarchicalAgreement._ext = []
    
    #-----< NHOBSuperiorToSubordinate >-----#
    NHOBSuperiorToSubordinate = SEQ(name='NHOBSuperiorToSubordinate', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    
    #-----< NHOBSubordinateToSuperior >-----#
    NHOBSubordinateToSuperior = SEQ(name='NHOBSubordinateToSuperior', mode=MODE_TYPE)
    _NHOBSubordinateToSuperior_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    _NHOBSubordinateToSuperior_subentries = SET_OF(name='subentries', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NHOBSubordinateToSuperior_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _NHOBSubordinateToSuperior_subentries._cont = __NHOBSubordinateToSuperior_subentries__item_
    _NHOBSubordinateToSuperior_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    NHOBSubordinateToSuperior._cont = ASN1Dict([
        ('accessPoints', _NHOBSubordinateToSuperior_accessPoints),
        ('subentries', _NHOBSubordinateToSuperior_subentries),
        ])
    NHOBSubordinateToSuperior._ext = []
    
    #-----< hierarchicalOperationalBinding >-----#
    hierarchicalOperationalBinding = CLASS(name='hierarchicalOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _hierarchicalOperationalBinding_val_Agreement = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    __shadowOperationalBinding_roleA_val_EstablishParam = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    __shadowOperationalBinding_roleA_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinateModification')))
    __shadowOperationalBinding_roleB_val_EstablishParam = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    __shadowOperationalBinding_roleB_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    hierarchicalOperationalBinding._val = dict([('Agreement', _hierarchicalOperationalBinding_val_Agreement), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 2))])
    
    #-----< nonSpecificHierarchicalOperationalBinding >-----#
    nonSpecificHierarchicalOperationalBinding = CLASS(name='nonSpecificHierarchicalOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _nonSpecificHierarchicalOperationalBinding_val_Agreement = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __shadowOperationalBinding_roleA_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __shadowOperationalBinding_roleA_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __shadowOperationalBinding_roleB_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __shadowOperationalBinding_roleB_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    nonSpecificHierarchicalOperationalBinding._val = dict([('Agreement', _nonSpecificHierarchicalOperationalBinding_val_Agreement), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 3))])
    
    _all_ = [
        _HierarchicalAgreement_rdn,
        _HierarchicalAgreement_immediateSuperior,
        HierarchicalAgreement,
        _SuperiorToSubordinate_contextPrefixInfo,
        ____SuperiorToSubordinate_entryInfo__item__type_tab,
        _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___SuperiorToSubordinate_entryInfo__item__type,
        ____SuperiorToSubordinate_entryInfo__item__values__item_,
        ___SuperiorToSubordinate_entryInfo__item__values,
        _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value,
        ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_,
        _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList,
        ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_,
        ___SuperiorToSubordinate_entryInfo__item__valuesWithContext,
        __SuperiorToSubordinate_entryInfo__item_,
        _SuperiorToSubordinate_entryInfo,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__type,
        ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__values,
        _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value,
        ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_,
        _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList,
        ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext,
        __SuperiorToSubordinate_immediateSuperiorInfo__item_,
        _SuperiorToSubordinate_immediateSuperiorInfo,
        SuperiorToSubordinate,
        _DITcontext__item_,
        DITcontext,
        _Vertex_rdn,
        ____Vertex_admPointInfo__item__type_tab,
        _____Vertex_admPointInfo__item__type_tab_val_Type_0,
        _____Vertex_admPointInfo__item__type_tab_val_Type_1,
        ___Vertex_admPointInfo__item__type,
        ____Vertex_admPointInfo__item__values__item_,
        ___Vertex_admPointInfo__item__values,
        _____Vertex_admPointInfo__item__valuesWithContext__item__value,
        ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_,
        _____Vertex_admPointInfo__item__valuesWithContext__item__contextList,
        ____Vertex_admPointInfo__item__valuesWithContext__item_,
        ___Vertex_admPointInfo__item__valuesWithContext,
        __Vertex_admPointInfo__item_,
        _Vertex_admPointInfo,
        __Vertex_subentries__item_,
        _Vertex_subentries,
        _Vertex_accessPoints,
        Vertex,
        _SubentryInfo_rdn,
        ____SubentryInfo_info__item__type_tab,
        _____SubentryInfo_info__item__type_tab_val_Type_0,
        _____SubentryInfo_info__item__type_tab_val_Type_1,
        ___SubentryInfo_info__item__type,
        ____SubentryInfo_info__item__values__item_,
        ___SubentryInfo_info__item__values,
        _____SubentryInfo_info__item__valuesWithContext__item__value,
        ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_,
        _____SubentryInfo_info__item__valuesWithContext__item__contextList,
        ____SubentryInfo_info__item__valuesWithContext__item_,
        ___SubentryInfo_info__item__valuesWithContext,
        __SubentryInfo_info__item_,
        _SubentryInfo_info,
        SubentryInfo,
        _SubordinateToSuperior_accessPoints,
        _SubordinateToSuperior_alias,
        ____SubordinateToSuperior_entryInfo__item__type_tab,
        _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0,
        _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1,
        ___SubordinateToSuperior_entryInfo__item__type,
        ____SubordinateToSuperior_entryInfo__item__values__item_,
        ___SubordinateToSuperior_entryInfo__item__values,
        _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value,
        ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_,
        _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList,
        ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_,
        ___SubordinateToSuperior_entryInfo__item__valuesWithContext,
        __SubordinateToSuperior_entryInfo__item_,
        _SubordinateToSuperior_entryInfo,
        __SubordinateToSuperior_subentries__item_,
        _SubordinateToSuperior_subentries,
        SubordinateToSuperior,
        SuperiorToSubordinateModification,
        _NonSpecificHierarchicalAgreement_immediateSuperior,
        NonSpecificHierarchicalAgreement,
        NHOBSuperiorToSubordinate,
        _NHOBSubordinateToSuperior_accessPoints,
        __NHOBSubordinateToSuperior_subentries__item_,
        _NHOBSubordinateToSuperior_subentries,
        NHOBSubordinateToSuperior,
        hierarchicalOperationalBinding,
        _hierarchicalOperationalBinding_val_Agreement,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        __shadowOperationalBinding_roleA_val_EstablishParam,
        __shadowOperationalBinding_roleA_val_ModifyParam,
        __shadowOperationalBinding_roleB_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_ModifyParam,
        nonSpecificHierarchicalOperationalBinding,
        _nonSpecificHierarchicalOperationalBinding_val_Agreement,
        __shadowOperationalBinding_roleA_val_EstablishParam_0,
        __shadowOperationalBinding_roleA_val_ModifyParam_0,
        __shadowOperationalBinding_roleB_val_EstablishParam_0,
        __shadowOperationalBinding_roleB_val_ModifyParam_0,
    ]

class IMSChargingDataTypes:

    _name_  = 'IMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 4, 0, 1]
    
    _obj_ = [
        'IMSRecord',
        'SCSCFRecord',
        'PCSCFRecord',
        'ICSCFRecord',
        'MRFCRecord',
        'MGCFRecord',
        'BGCFRecord',
        'ASRecord',
        'ECSCFRecord',
        'IBCFRecord',
        'TRFRecord',
        'ATCFRecord',
        'TFRecord',
        'AccessCorrelationID',
        'AccessNetworkInfoChange',
        'AccessTransferType',
        'AccessTransferInformation',
        'ACRInterimLost',
        'AoCCostInformation',
        'AoCInformation',
        'ApplicationServersInformation',
        'CalledIdentityChange',
        'CarrierSelectRouting',
        'CauseForRecordClosing',
        'Early-Media-Components-List',
        'FEIdentifierList',
        'IMS-Charging-Identifier',
        'IMSCommunicationServiceIdentifier',
        'Incomplete-CDR-Indication',
        'InterOperatorIdentifierList',
        'InterOperatorIdentifiers',
        'ISUPCause',
        'ListOfInvolvedParties',
        'ListOfReasonHeader',
        'Media-Components-List',
        'MessageBody',
        'Milliseconds',
        'NNI-Information',
        'NNIType',
        'NumberPortabilityRouting',
        'RateElement',
        'RealTimeTariffInformation',
        'ReasonHeaderInformation',
        'RelationshipMode',
        'Role-of-Node',
        'S-CSCF-Information',
        'SDP-Media-Component',
        'SDP-Media-Description',
        'ServedPartyIPAddress',
        'Service-Id',
        'SessionDirection',
        'SessionPriority',
        'SIP-Method',
        'SDP-Type',
        'Status',
        'TADIdentifier',
        'TariffInformation',
        'TransitIOILists',
        'TransmissionMedium',
        'TrunkGroupID',
        ]
    _type_ = [
        'IMSRecord',
        'SCSCFRecord',
        'PCSCFRecord',
        'ICSCFRecord',
        'MRFCRecord',
        'MGCFRecord',
        'BGCFRecord',
        'ASRecord',
        'ECSCFRecord',
        'IBCFRecord',
        'TRFRecord',
        'ATCFRecord',
        'TFRecord',
        'AccessCorrelationID',
        'AccessNetworkInfoChange',
        'AccessTransferType',
        'AccessTransferInformation',
        'ACRInterimLost',
        'AoCCostInformation',
        'AoCInformation',
        'ApplicationServersInformation',
        'CalledIdentityChange',
        'CarrierSelectRouting',
        'CauseForRecordClosing',
        'Early-Media-Components-List',
        'FEIdentifierList',
        'IMS-Charging-Identifier',
        'IMSCommunicationServiceIdentifier',
        'Incomplete-CDR-Indication',
        'InterOperatorIdentifierList',
        'InterOperatorIdentifiers',
        'ISUPCause',
        'ListOfInvolvedParties',
        'ListOfReasonHeader',
        'Media-Components-List',
        'MessageBody',
        'Milliseconds',
        'NNI-Information',
        'NNIType',
        'NumberPortabilityRouting',
        'RateElement',
        'RealTimeTariffInformation',
        'ReasonHeaderInformation',
        'RelationshipMode',
        'Role-of-Node',
        'S-CSCF-Information',
        'SDP-Media-Component',
        'SDP-Media-Description',
        'ServedPartyIPAddress',
        'Service-Id',
        'SessionDirection',
        'SessionPriority',
        'SIP-Method',
        'SDP-Type',
        'Status',
        'TADIdentifier',
        'TariffInformation',
        'TransitIOILists',
        'TransmissionMedium',
        'TrunkGroupID',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< IMSRecord >-----#
    IMSRecord = CHOICE(name='IMSRecord', mode=MODE_TYPE)
    _IMSRecord_sCSCFRecord = SET(name='sCSCFRecord', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SCSCFRecord')))
    _IMSRecord_pCSCFRecord = SET(name='pCSCFRecord', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'PCSCFRecord')))
    _IMSRecord_iCSCFRecord = SET(name='iCSCFRecord', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ICSCFRecord')))
    _IMSRecord_mRFCRecord = SET(name='mRFCRecord', mode=MODE_TYPE, tag=(66, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'MRFCRecord')))
    _IMSRecord_mGCFRecord = SET(name='mGCFRecord', mode=MODE_TYPE, tag=(67, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'MGCFRecord')))
    _IMSRecord_bGCFRecord = SET(name='bGCFRecord', mode=MODE_TYPE, tag=(68, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'BGCFRecord')))
    _IMSRecord_aSRecord = SET(name='aSRecord', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ASRecord')))
    _IMSRecord_eCSCFRecord = SET(name='eCSCFRecord', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ECSCFRecord')))
    _IMSRecord_iBCFRecord = SET(name='iBCFRecord', mode=MODE_TYPE, tag=(82, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IBCFRecord')))
    _IMSRecord_tRFRecord = SET(name='tRFRecord', mode=MODE_TYPE, tag=(89, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TRFRecord')))
    _IMSRecord_tFRecord = SET(name='tFRecord', mode=MODE_TYPE, tag=(90, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TFRecord')))
    _IMSRecord_aTCFRecord = SET(name='aTCFRecord', mode=MODE_TYPE, tag=(91, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ATCFRecord')))
    IMSRecord._cont = ASN1Dict([
        ('sCSCFRecord', _IMSRecord_sCSCFRecord),
        ('pCSCFRecord', _IMSRecord_pCSCFRecord),
        ('iCSCFRecord', _IMSRecord_iCSCFRecord),
        ('mRFCRecord', _IMSRecord_mRFCRecord),
        ('mGCFRecord', _IMSRecord_mGCFRecord),
        ('bGCFRecord', _IMSRecord_bGCFRecord),
        ('aSRecord', _IMSRecord_aSRecord),
        ('eCSCFRecord', _IMSRecord_eCSCFRecord),
        ('iBCFRecord', _IMSRecord_iBCFRecord),
        ('tRFRecord', _IMSRecord_tRFRecord),
        ('tFRecord', _IMSRecord_tFRecord),
        ('aTCFRecord', _IMSRecord_aTCFRecord),
        ])
    IMSRecord._ext = None
    
    #-----< SCSCFRecord >-----#
    SCSCFRecord = SET(name='SCSCFRecord', mode=MODE_TYPE)
    _SCSCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _SCSCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _SCSCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SCSCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _SCSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _SCSCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _SCSCFRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_interOperatorIdentifiers = SEQ_OF(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _SCSCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSCFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _SCSCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _SCSCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _SCSCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _SCSCFRecord_list_Of_SDP_Media_Components._cont = __SCSCFRecord_list_Of_SDP_Media_Components__item_
    _SCSCFRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SCSCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _SCSCFRecord_list_Of_Message_Bodies._cont = __SCSCFRecord_list_Of_Message_Bodies__item_
    _SCSCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SCSCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_list_Of_Associated_URI = SEQ_OF(name='list-Of-Associated-URI', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _SCSCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _SCSCFRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _SCSCFRecord_list_of_subscription_ID._cont = __SCSCFRecord_list_of_subscription_ID__item_
    _SCSCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _SCSCFRecord_list_Of_Early_SDP_Media_Components._cont = __SCSCFRecord_list_Of_Early_SDP_Media_Components__item_
    _SCSCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _SCSCFRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _SCSCFRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _SCSCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _SCSCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _SCSCFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _SCSCFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _SCSCFRecord_applicationServersInformation = SEQ_OF(name='applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _SCSCFRecord_applicationServersInformation._cont = __SCSCFRecord_applicationServersInformation__item_
    _SCSCFRecord_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _SCSCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _SCSCFRecord_online_charging_flag = NULL(name='online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_realTimeTariffInformation = SEQ_OF(name='realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _SCSCFRecord_realTimeTariffInformation._cont = __SCSCFRecord_realTimeTariffInformation__item_
    _SCSCFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSCFRecord_nNI_Information = SEQ(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _SCSCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_iMSEmergencyIndicator = NULL(name='iMSEmergencyIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _SCSCFRecord_iMSVisitedNetworkIdentifier = OCT_STR(name='iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _SCSCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_instanceId = OCT_STR(name='instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_subscriberEquipmentNumber = SET(name='subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _SCSCFRecord_routeHeaderReceived = OCT_STR(name='routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_routeHeaderTransmitted = OCT_STR(name='routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _SCSCFRecord_list_Of_AccessNetworkInfoChange._cont = __SCSCFRecord_list_Of_AccessNetworkInfoChange__item_
    _SCSCFRecord_listOfCalledIdentityChanges = SEQ_OF(name='listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _SCSCFRecord_listOfCalledIdentityChanges._cont = __SCSCFRecord_listOfCalledIdentityChanges__item_
    _SCSCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    SCSCFRecord._cont = ASN1Dict([
        ('recordType', _SCSCFRecord_recordType),
        ('retransmission', _SCSCFRecord_retransmission),
        ('sIP-Method', _SCSCFRecord_sIP_Method),
        ('role-of-Node', _SCSCFRecord_role_of_Node),
        ('nodeAddress', _SCSCFRecord_nodeAddress),
        ('session-Id', _SCSCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _SCSCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _SCSCFRecord_called_Party_Address),
        ('privateUserID', _SCSCFRecord_privateUserID),
        ('serviceRequestTimeStamp', _SCSCFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _SCSCFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _SCSCFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _SCSCFRecord_recordOpeningTime),
        ('recordClosureTime', _SCSCFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _SCSCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _SCSCFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _SCSCFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _SCSCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _SCSCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _SCSCFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _SCSCFRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _SCSCFRecord_gGSNaddress),
        ('serviceReasonReturnCode', _SCSCFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _SCSCFRecord_list_Of_Message_Bodies),
        ('recordExtensions', _SCSCFRecord_recordExtensions),
        ('expiresInformation', _SCSCFRecord_expiresInformation),
        ('list-Of-Associated-URI', _SCSCFRecord_list_Of_Associated_URI),
        ('event', _SCSCFRecord_event),
        ('accessNetworkInformation', _SCSCFRecord_accessNetworkInformation),
        ('serviceContextID', _SCSCFRecord_serviceContextID),
        ('list-of-subscription-ID', _SCSCFRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _SCSCFRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _SCSCFRecord_iMSCommunicationServiceIdentifier),
        ('numberPortabilityRouting', _SCSCFRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _SCSCFRecord_carrierSelectRouting),
        ('sessionPriority', _SCSCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _SCSCFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _SCSCFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _SCSCFRecord_serviceDeliveryEndTimeStampFraction),
        ('applicationServersInformation', _SCSCFRecord_applicationServersInformation),
        ('requested-Party-Address', _SCSCFRecord_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _SCSCFRecord_list_Of_Called_Asserted_Identity),
        ('online-charging-flag', _SCSCFRecord_online_charging_flag),
        ('realTimeTariffInformation', _SCSCFRecord_realTimeTariffInformation),
        ('userLocationInformation', _SCSCFRecord_userLocationInformation),
        ('mSTimeZone', _SCSCFRecord_mSTimeZone),
        ('nNI-Information', _SCSCFRecord_nNI_Information),
        ('fromAddress', _SCSCFRecord_fromAddress),
        ('iMSEmergencyIndicator', _SCSCFRecord_iMSEmergencyIndicator),
        ('transit-IOI-Lists', _SCSCFRecord_transit_IOI_Lists),
        ('iMSVisitedNetworkIdentifier', _SCSCFRecord_iMSVisitedNetworkIdentifier),
        ('listOfReasonHeader', _SCSCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _SCSCFRecord_additionalAccessNetworkInformation),
        ('instanceId', _SCSCFRecord_instanceId),
        ('subscriberEquipmentNumber', _SCSCFRecord_subscriberEquipmentNumber),
        ('routeHeaderReceived', _SCSCFRecord_routeHeaderReceived),
        ('routeHeaderTransmitted', _SCSCFRecord_routeHeaderTransmitted),
        ('list-Of-AccessNetworkInfoChange', _SCSCFRecord_list_Of_AccessNetworkInfoChange),
        ('listOfCalledIdentityChanges', _SCSCFRecord_listOfCalledIdentityChanges),
        ('cellularNetworkInformation', _SCSCFRecord_cellularNetworkInformation),
        ('fEIdentifierList', _SCSCFRecord_fEIdentifierList),
        ])
    SCSCFRecord._ext = None
    
    #-----< PCSCFRecord >-----#
    PCSCFRecord = SET(name='PCSCFRecord', mode=MODE_TYPE)
    _PCSCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PCSCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _PCSCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _PCSCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PCSCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _PCSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _PCSCFRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _PCSCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _PCSCFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _PCSCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _PCSCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PCSCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _PCSCFRecord_list_Of_SDP_Media_Components._cont = __PCSCFRecord_list_Of_SDP_Media_Components__item_
    _PCSCFRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PCSCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _PCSCFRecord_list_Of_Message_Bodies._cont = __PCSCFRecord_list_Of_Message_Bodies__item_
    _PCSCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PCSCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_list_Of_Associated_URI = SEQ_OF(name='list-Of-Associated-URI', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PCSCFRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _PCSCFRecord_list_of_subscription_ID._cont = __PCSCFRecord_list_of_subscription_ID__item_
    _PCSCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _PCSCFRecord_list_Of_Early_SDP_Media_Components._cont = __PCSCFRecord_list_Of_Early_SDP_Media_Components__item_
    _PCSCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _PCSCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _PCSCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _PCSCFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _PCSCFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _PCSCFRecord_list_of_Requested_Party_Address = SEQ_OF(name='list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_nNI_Information = SEQ(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _PCSCFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _PCSCFRecord_servedPartyIPAddress = CHOICE(name='servedPartyIPAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ServedPartyIPAddress')), opt=True)
    _PCSCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_iMSEmergencyIndicator = NULL(name='iMSEmergencyIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _PCSCFRecord_iMSVisitedNetworkIdentifier = OCT_STR(name='iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _PCSCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_instanceId = OCT_STR(name='instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_subscriberEquipmentNumber = SET(name='subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _PCSCFRecord_routeHeaderReceived = OCT_STR(name='routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_routeHeaderTransmitted = OCT_STR(name='routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _PCSCFRecord_list_Of_AccessNetworkInfoChange._cont = __PCSCFRecord_list_Of_AccessNetworkInfoChange__item_
    _PCSCFRecord_listOfCalledIdentityChanges = SEQ_OF(name='listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _PCSCFRecord_listOfCalledIdentityChanges._cont = __PCSCFRecord_listOfCalledIdentityChanges__item_
    _PCSCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_initialIMS_Charging_Identifier = OCT_STR(name='initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PCSCFRecord_list_Of_AccessTransferInformation = SEQ_OF(name='list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _PCSCFRecord_list_Of_AccessTransferInformation._cont = __PCSCFRecord_list_Of_AccessTransferInformation__item_
    _PCSCFRecord_relatedICID = OCT_STR(name='relatedICID', mode=MODE_TYPE, tag=(107, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PCSCFRecord_relatedICIDGenerationNode = CHOICE(name='relatedICIDGenerationNode', mode=MODE_TYPE, tag=(108, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PCSCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(109, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    PCSCFRecord._cont = ASN1Dict([
        ('recordType', _PCSCFRecord_recordType),
        ('retransmission', _PCSCFRecord_retransmission),
        ('sIP-Method', _PCSCFRecord_sIP_Method),
        ('role-of-Node', _PCSCFRecord_role_of_Node),
        ('nodeAddress', _PCSCFRecord_nodeAddress),
        ('session-Id', _PCSCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _PCSCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _PCSCFRecord_called_Party_Address),
        ('privateUserID', _PCSCFRecord_privateUserID),
        ('serviceRequestTimeStamp', _PCSCFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _PCSCFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _PCSCFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _PCSCFRecord_recordOpeningTime),
        ('recordClosureTime', _PCSCFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _PCSCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _PCSCFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _PCSCFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _PCSCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _PCSCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _PCSCFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _PCSCFRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _PCSCFRecord_gGSNaddress),
        ('serviceReasonReturnCode', _PCSCFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _PCSCFRecord_list_Of_Message_Bodies),
        ('recordExtensions', _PCSCFRecord_recordExtensions),
        ('expiresInformation', _PCSCFRecord_expiresInformation),
        ('list-Of-Associated-URI', _PCSCFRecord_list_Of_Associated_URI),
        ('event', _PCSCFRecord_event),
        ('accessNetworkInformation', _PCSCFRecord_accessNetworkInformation),
        ('serviceContextID', _PCSCFRecord_serviceContextID),
        ('list-of-subscription-ID', _PCSCFRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _PCSCFRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _PCSCFRecord_iMSCommunicationServiceIdentifier),
        ('sessionPriority', _PCSCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _PCSCFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _PCSCFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _PCSCFRecord_serviceDeliveryEndTimeStampFraction),
        ('list-of-Requested-Party-Address', _PCSCFRecord_list_of_Requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _PCSCFRecord_list_Of_Called_Asserted_Identity),
        ('nNI-Information', _PCSCFRecord_nNI_Information),
        ('userLocationInformation', _PCSCFRecord_userLocationInformation),
        ('mSTimeZone', _PCSCFRecord_mSTimeZone),
        ('servedPartyIPAddress', _PCSCFRecord_servedPartyIPAddress),
        ('fromAddress', _PCSCFRecord_fromAddress),
        ('iMSEmergencyIndicator', _PCSCFRecord_iMSEmergencyIndicator),
        ('transit-IOI-Lists', _PCSCFRecord_transit_IOI_Lists),
        ('iMSVisitedNetworkIdentifier', _PCSCFRecord_iMSVisitedNetworkIdentifier),
        ('listOfReasonHeader', _PCSCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _PCSCFRecord_additionalAccessNetworkInformation),
        ('instanceId', _PCSCFRecord_instanceId),
        ('subscriberEquipmentNumber', _PCSCFRecord_subscriberEquipmentNumber),
        ('routeHeaderReceived', _PCSCFRecord_routeHeaderReceived),
        ('routeHeaderTransmitted', _PCSCFRecord_routeHeaderTransmitted),
        ('list-Of-AccessNetworkInfoChange', _PCSCFRecord_list_Of_AccessNetworkInfoChange),
        ('listOfCalledIdentityChanges', _PCSCFRecord_listOfCalledIdentityChanges),
        ('cellularNetworkInformation', _PCSCFRecord_cellularNetworkInformation),
        ('initialIMS-Charging-Identifier', _PCSCFRecord_initialIMS_Charging_Identifier),
        ('list-Of-AccessTransferInformation', _PCSCFRecord_list_Of_AccessTransferInformation),
        ('relatedICID', _PCSCFRecord_relatedICID),
        ('relatedICIDGenerationNode', _PCSCFRecord_relatedICIDGenerationNode),
        ('fEIdentifierList', _PCSCFRecord_fEIdentifierList),
        ])
    PCSCFRecord._ext = None
    
    #-----< ICSCFRecord >-----#
    ICSCFRecord = SET(name='ICSCFRecord', mode=MODE_TYPE)
    _ICSCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ICSCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ICSCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ICSCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ICSCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ICSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ICSCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ICSCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ICSCFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _ICSCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ICSCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ICSCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ICSCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ICSCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ICSCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_list_Of_Associated_URI = SEQ_OF(name='list-Of-Associated-URI', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ICSCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ICSCFRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ICSCFRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ICSCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ICSCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ICSCFRecord_transit_IOI_List = STR_GRAPH(name='transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ICSCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_iMSEmergencyIndicator = NULL(name='iMSEmergencyIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ICSCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_routeHeaderTransmitted = OCT_STR(name='routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_s_CSCF_Information = SEQ(name='s-CSCF-Information', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'S-CSCF-Information')), opt=True)
    _ICSCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ICSCFRecord._cont = ASN1Dict([
        ('recordType', _ICSCFRecord_recordType),
        ('retransmission', _ICSCFRecord_retransmission),
        ('sIP-Method', _ICSCFRecord_sIP_Method),
        ('role-of-Node', _ICSCFRecord_role_of_Node),
        ('nodeAddress', _ICSCFRecord_nodeAddress),
        ('session-Id', _ICSCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _ICSCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _ICSCFRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _ICSCFRecord_serviceRequestTimeStamp),
        ('interOperatorIdentifiers', _ICSCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _ICSCFRecord_localRecordSequenceNumber),
        ('causeForRecordClosing', _ICSCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _ICSCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _ICSCFRecord_iMS_Charging_Identifier),
        ('serviceReasonReturnCode', _ICSCFRecord_serviceReasonReturnCode),
        ('recordExtensions', _ICSCFRecord_recordExtensions),
        ('expiresInformation', _ICSCFRecord_expiresInformation),
        ('list-Of-Associated-URI', _ICSCFRecord_list_Of_Associated_URI),
        ('event', _ICSCFRecord_event),
        ('accessNetworkInformation', _ICSCFRecord_accessNetworkInformation),
        ('serviceContextID', _ICSCFRecord_serviceContextID),
        ('numberPortabilityRouting', _ICSCFRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _ICSCFRecord_carrierSelectRouting),
        ('sessionPriority', _ICSCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _ICSCFRecord_serviceRequestTimeStampFraction),
        ('transit-IOI-List', _ICSCFRecord_transit_IOI_List),
        ('userLocationInformation', _ICSCFRecord_userLocationInformation),
        ('mSTimeZone', _ICSCFRecord_mSTimeZone),
        ('fromAddress', _ICSCFRecord_fromAddress),
        ('iMSEmergencyIndicator', _ICSCFRecord_iMSEmergencyIndicator),
        ('listOfReasonHeader', _ICSCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _ICSCFRecord_additionalAccessNetworkInformation),
        ('routeHeaderTransmitted', _ICSCFRecord_routeHeaderTransmitted),
        ('s-CSCF-Information', _ICSCFRecord_s_CSCF_Information),
        ('cellularNetworkInformation', _ICSCFRecord_cellularNetworkInformation),
        ('fEIdentifierList', _ICSCFRecord_fEIdentifierList),
        ])
    ICSCFRecord._ext = None
    
    #-----< MRFCRecord >-----#
    MRFCRecord = SET(name='MRFCRecord', mode=MODE_TYPE)
    _MRFCRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MRFCRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _MRFCRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MRFCRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MRFCRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MRFCRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MRFCRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _MRFCRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MRFCRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _MRFCRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _MRFCRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MRFCRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _MRFCRecord_list_Of_SDP_Media_Components._cont = __MRFCRecord_list_Of_SDP_Media_Components__item_
    _MRFCRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MRFCRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MRFCRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MRFCRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _MRFCRecord_list_of_subscription_ID._cont = __MRFCRecord_list_of_subscription_ID__item_
    _MRFCRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _MRFCRecord_list_Of_Early_SDP_Media_Components._cont = __MRFCRecord_list_Of_Early_SDP_Media_Components__item_
    _MRFCRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _MRFCRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MRFCRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MRFCRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MRFCRecord_applicationServersInformation = SEQ_OF(name='applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _MRFCRecord_applicationServersInformation._cont = __MRFCRecord_applicationServersInformation__item_
    _MRFCRecord_online_charging_flag = NULL(name='online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_transit_IOI_List = STR_GRAPH(name='transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _MRFCRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _MRFCRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _MRFCRecord_list_Of_AccessNetworkInfoChange._cont = __MRFCRecord_list_Of_AccessNetworkInfoChange__item_
    _MRFCRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_service_Id = STR_GRAPH(name='service-Id', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Service-Id')), opt=True)
    _MRFCRecord_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MRFCRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MRFCRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    MRFCRecord._cont = ASN1Dict([
        ('recordType', _MRFCRecord_recordType),
        ('retransmission', _MRFCRecord_retransmission),
        ('sIP-Method', _MRFCRecord_sIP_Method),
        ('nodeAddress', _MRFCRecord_nodeAddress),
        ('session-Id', _MRFCRecord_session_Id),
        ('list-Of-Calling-Party-Address', _MRFCRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _MRFCRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _MRFCRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _MRFCRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _MRFCRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _MRFCRecord_recordOpeningTime),
        ('recordClosureTime', _MRFCRecord_recordClosureTime),
        ('interOperatorIdentifiers', _MRFCRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _MRFCRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _MRFCRecord_recordSequenceNumber),
        ('causeForRecordClosing', _MRFCRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _MRFCRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _MRFCRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _MRFCRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _MRFCRecord_gGSNaddress),
        ('serviceReasonReturnCode', _MRFCRecord_serviceReasonReturnCode),
        ('recordExtensions', _MRFCRecord_recordExtensions),
        ('expiresInformation', _MRFCRecord_expiresInformation),
        ('event', _MRFCRecord_event),
        ('accessNetworkInformation', _MRFCRecord_accessNetworkInformation),
        ('serviceContextID', _MRFCRecord_serviceContextID),
        ('list-of-subscription-ID', _MRFCRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _MRFCRecord_list_Of_Early_SDP_Media_Components),
        ('sessionPriority', _MRFCRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _MRFCRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _MRFCRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _MRFCRecord_serviceDeliveryEndTimeStampFraction),
        ('applicationServersInformation', _MRFCRecord_applicationServersInformation),
        ('online-charging-flag', _MRFCRecord_online_charging_flag),
        ('transit-IOI-List', _MRFCRecord_transit_IOI_List),
        ('userLocationInformation', _MRFCRecord_userLocationInformation),
        ('mSTimeZone', _MRFCRecord_mSTimeZone),
        ('fromAddress', _MRFCRecord_fromAddress),
        ('listOfReasonHeader', _MRFCRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _MRFCRecord_additionalAccessNetworkInformation),
        ('list-Of-AccessNetworkInfoChange', _MRFCRecord_list_Of_AccessNetworkInfoChange),
        ('cellularNetworkInformation', _MRFCRecord_cellularNetworkInformation),
        ('service-Id', _MRFCRecord_service_Id),
        ('requested-Party-Address', _MRFCRecord_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _MRFCRecord_list_Of_Called_Asserted_Identity),
        ('fEIdentifierList', _MRFCRecord_fEIdentifierList),
        ])
    MRFCRecord._ext = None
    
    #-----< MGCFRecord >-----#
    MGCFRecord = SET(name='MGCFRecord', mode=MODE_TYPE)
    _MGCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MGCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _MGCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _MGCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MGCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MGCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MGCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MGCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _MGCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MGCFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _MGCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _MGCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MGCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _MGCFRecord_list_Of_SDP_Media_Components._cont = __MGCFRecord_list_Of_SDP_Media_Components__item_
    _MGCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MGCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MGCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _MGCFRecord_list_Of_Early_SDP_Media_Components._cont = __MGCFRecord_list_Of_Early_SDP_Media_Components__item_
    _MGCFRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _MGCFRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _MGCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _MGCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MGCFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MGCFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MGCFRecord_realTimeTariffInformation = SEQ_OF(name='realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _MGCFRecord_realTimeTariffInformation._cont = __MGCFRecord_realTimeTariffInformation__item_
    _MGCFRecord_transit_IOI_List = STR_GRAPH(name='transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _MGCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _MGCFRecord_list_Of_AccessNetworkInfoChange._cont = __MGCFRecord_list_Of_AccessNetworkInfoChange__item_
    _MGCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_trunkGroupID = CHOICE(name='trunkGroupID', mode=MODE_TYPE, tag=(80, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TrunkGroupID')), opt=True)
    _MGCFRecord_bearerService = SEQ(name='bearerService', mode=MODE_TYPE, tag=(81, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransmissionMedium')), opt=True)
    _MGCFRecord_iSUPCause = SEQ(name='iSUPCause', mode=MODE_TYPE, tag=(82, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ISUPCause')), opt=True)
    _MGCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(83, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    MGCFRecord._cont = ASN1Dict([
        ('recordType', _MGCFRecord_recordType),
        ('retransmission', _MGCFRecord_retransmission),
        ('sIP-Method', _MGCFRecord_sIP_Method),
        ('role-of-Node', _MGCFRecord_role_of_Node),
        ('nodeAddress', _MGCFRecord_nodeAddress),
        ('session-Id', _MGCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _MGCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _MGCFRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _MGCFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _MGCFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _MGCFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _MGCFRecord_recordOpeningTime),
        ('recordClosureTime', _MGCFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _MGCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _MGCFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _MGCFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _MGCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _MGCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _MGCFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _MGCFRecord_list_Of_SDP_Media_Components),
        ('serviceReasonReturnCode', _MGCFRecord_serviceReasonReturnCode),
        ('recordExtensions', _MGCFRecord_recordExtensions),
        ('expiresInformation', _MGCFRecord_expiresInformation),
        ('event', _MGCFRecord_event),
        ('accessNetworkInformation', _MGCFRecord_accessNetworkInformation),
        ('serviceContextID', _MGCFRecord_serviceContextID),
        ('list-Of-Early-SDP-Media-Components', _MGCFRecord_list_Of_Early_SDP_Media_Components),
        ('numberPortabilityRouting', _MGCFRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _MGCFRecord_carrierSelectRouting),
        ('sessionPriority', _MGCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _MGCFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _MGCFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _MGCFRecord_serviceDeliveryEndTimeStampFraction),
        ('realTimeTariffInformation', _MGCFRecord_realTimeTariffInformation),
        ('transit-IOI-List', _MGCFRecord_transit_IOI_List),
        ('fromAddress', _MGCFRecord_fromAddress),
        ('listOfReasonHeader', _MGCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _MGCFRecord_additionalAccessNetworkInformation),
        ('list-Of-AccessNetworkInfoChange', _MGCFRecord_list_Of_AccessNetworkInfoChange),
        ('cellularNetworkInformation', _MGCFRecord_cellularNetworkInformation),
        ('trunkGroupID', _MGCFRecord_trunkGroupID),
        ('bearerService', _MGCFRecord_bearerService),
        ('iSUPCause', _MGCFRecord_iSUPCause),
        ('fEIdentifierList', _MGCFRecord_fEIdentifierList),
        ])
    MGCFRecord._ext = None
    
    #-----< BGCFRecord >-----#
    BGCFRecord = SET(name='BGCFRecord', mode=MODE_TYPE)
    _BGCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _BGCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _BGCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _BGCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _BGCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _BGCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _BGCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _BGCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _BGCFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _BGCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _BGCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _BGCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _BGCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _BGCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _BGCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _BGCFRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _BGCFRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _BGCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _BGCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _BGCFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _BGCFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _BGCFRecord_transit_IOI_List = STR_GRAPH(name='transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_nNI_Information = SEQ(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _BGCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _BGCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    BGCFRecord._cont = ASN1Dict([
        ('recordType', _BGCFRecord_recordType),
        ('retransmission', _BGCFRecord_retransmission),
        ('sIP-Method', _BGCFRecord_sIP_Method),
        ('role-of-Node', _BGCFRecord_role_of_Node),
        ('nodeAddress', _BGCFRecord_nodeAddress),
        ('session-Id', _BGCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _BGCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _BGCFRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _BGCFRecord_serviceRequestTimeStamp),
        ('interOperatorIdentifiers', _BGCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _BGCFRecord_localRecordSequenceNumber),
        ('causeForRecordClosing', _BGCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _BGCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _BGCFRecord_iMS_Charging_Identifier),
        ('serviceReasonReturnCode', _BGCFRecord_serviceReasonReturnCode),
        ('recordExtensions', _BGCFRecord_recordExtensions),
        ('expiresInformation', _BGCFRecord_expiresInformation),
        ('event', _BGCFRecord_event),
        ('accessNetworkInformation', _BGCFRecord_accessNetworkInformation),
        ('serviceContextID', _BGCFRecord_serviceContextID),
        ('numberPortabilityRouting', _BGCFRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _BGCFRecord_carrierSelectRouting),
        ('sessionPriority', _BGCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _BGCFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _BGCFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _BGCFRecord_serviceDeliveryEndTimeStampFraction),
        ('transit-IOI-List', _BGCFRecord_transit_IOI_List),
        ('nNI-Information', _BGCFRecord_nNI_Information),
        ('fromAddress', _BGCFRecord_fromAddress),
        ('listOfReasonHeader', _BGCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _BGCFRecord_additionalAccessNetworkInformation),
        ('cellularNetworkInformation', _BGCFRecord_cellularNetworkInformation),
        ('fEIdentifierList', _BGCFRecord_fEIdentifierList),
        ])
    BGCFRecord._ext = None
    
    #-----< ASRecord >-----#
    ASRecord = SET(name='ASRecord', mode=MODE_TYPE)
    _ASRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ASRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ASRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ASRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ASRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ASRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ASRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ASRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _ASRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ASRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ASRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ASRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ASRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _ASRecord_list_Of_SDP_Media_Components._cont = __ASRecord_list_Of_SDP_Media_Components__item_
    _ASRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ASRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _ASRecord_list_Of_Message_Bodies._cont = __ASRecord_list_Of_Message_Bodies__item_
    _ASRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ASRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ASRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _ASRecord_list_of_subscription_ID._cont = __ASRecord_list_of_subscription_ID__item_
    _ASRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _ASRecord_list_Of_Early_SDP_Media_Components._cont = __ASRecord_list_Of_Early_SDP_Media_Components__item_
    _ASRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _ASRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ASRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ASRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ASRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ASRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ASRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ASRecord_list_of_Requested_Party_Address = SEQ_OF(name='list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ASRecord_online_charging_flag = NULL(name='online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_realTimeTariffInformation = SEQ_OF(name='realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _ASRecord_realTimeTariffInformation._cont = __ASRecord_realTimeTariffInformation__item_
    _ASRecord_nNI_Information = SEQ(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _ASRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ASRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _ASRecord_iMSVisitedNetworkIdentifier = OCT_STR(name='iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ASRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_instanceId = OCT_STR(name='instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_subscriberEquipmentNumber = SET(name='subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _ASRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _ASRecord_list_Of_AccessNetworkInfoChange._cont = __ASRecord_list_Of_AccessNetworkInfoChange__item_
    _ASRecord_listOfCalledIdentityChanges = SEQ_OF(name='listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _ASRecord_listOfCalledIdentityChanges._cont = __ASRecord_listOfCalledIdentityChanges__item_
    _ASRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_serviceSpecificInfo = SEQ_OF(name='serviceSpecificInfo', mode=MODE_TYPE, tag=(100, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_serviceSpecificInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceSpecificInfo')))
    _ASRecord_serviceSpecificInfo._cont = __ASRecord_serviceSpecificInfo__item_
    _ASRecord_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(101, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ASRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(102, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ASRecord_alternateChargedPartyAddress = STR_UTF8(name='alternateChargedPartyAddress', mode=MODE_TYPE, tag=(103, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_outgoingSessionId = STR_GRAPH(name='outgoingSessionId', mode=MODE_TYPE, tag=(104, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ASRecord_initialIMS_Charging_Identifier = OCT_STR(name='initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ASRecord_list_Of_AccessTransferInformation = SEQ_OF(name='list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _ASRecord_list_Of_AccessTransferInformation._cont = __ASRecord_list_Of_AccessTransferInformation__item_
    _ASRecord_tADS_Identifier = ENUM(name='tADS-Identifier', mode=MODE_TYPE, tag=(109, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TADIdentifier')), opt=True)
    _ASRecord_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, tag=(110, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _ASRecord_msc_Address = OCT_STR(name='msc-Address', mode=MODE_TYPE, tag=(111, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _ASRecord_threeGPPPSDataOffStatus = ENUM(name='threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(112, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _ASRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(113, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ASRecord._cont = ASN1Dict([
        ('recordType', _ASRecord_recordType),
        ('retransmission', _ASRecord_retransmission),
        ('sIP-Method', _ASRecord_sIP_Method),
        ('role-of-Node', _ASRecord_role_of_Node),
        ('nodeAddress', _ASRecord_nodeAddress),
        ('session-Id', _ASRecord_session_Id),
        ('list-Of-Calling-Party-Address', _ASRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _ASRecord_called_Party_Address),
        ('privateUserID', _ASRecord_privateUserID),
        ('serviceRequestTimeStamp', _ASRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _ASRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _ASRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _ASRecord_recordOpeningTime),
        ('recordClosureTime', _ASRecord_recordClosureTime),
        ('interOperatorIdentifiers', _ASRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _ASRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _ASRecord_recordSequenceNumber),
        ('causeForRecordClosing', _ASRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _ASRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _ASRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _ASRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _ASRecord_gGSNaddress),
        ('serviceReasonReturnCode', _ASRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _ASRecord_list_Of_Message_Bodies),
        ('recordExtensions', _ASRecord_recordExtensions),
        ('expiresInformation', _ASRecord_expiresInformation),
        ('event', _ASRecord_event),
        ('accessNetworkInformation', _ASRecord_accessNetworkInformation),
        ('serviceContextID', _ASRecord_serviceContextID),
        ('list-of-subscription-ID', _ASRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _ASRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _ASRecord_iMSCommunicationServiceIdentifier),
        ('numberPortabilityRouting', _ASRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _ASRecord_carrierSelectRouting),
        ('sessionPriority', _ASRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _ASRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _ASRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _ASRecord_serviceDeliveryEndTimeStampFraction),
        ('list-of-Requested-Party-Address', _ASRecord_list_of_Requested_Party_Address),
        ('online-charging-flag', _ASRecord_online_charging_flag),
        ('realTimeTariffInformation', _ASRecord_realTimeTariffInformation),
        ('nNI-Information', _ASRecord_nNI_Information),
        ('userLocationInformation', _ASRecord_userLocationInformation),
        ('mSTimeZone', _ASRecord_mSTimeZone),
        ('fromAddress', _ASRecord_fromAddress),
        ('transit-IOI-Lists', _ASRecord_transit_IOI_Lists),
        ('iMSVisitedNetworkIdentifier', _ASRecord_iMSVisitedNetworkIdentifier),
        ('listOfReasonHeader', _ASRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _ASRecord_additionalAccessNetworkInformation),
        ('instanceId', _ASRecord_instanceId),
        ('subscriberEquipmentNumber', _ASRecord_subscriberEquipmentNumber),
        ('list-Of-AccessNetworkInfoChange', _ASRecord_list_Of_AccessNetworkInfoChange),
        ('listOfCalledIdentityChanges', _ASRecord_listOfCalledIdentityChanges),
        ('cellularNetworkInformation', _ASRecord_cellularNetworkInformation),
        ('serviceSpecificInfo', _ASRecord_serviceSpecificInfo),
        ('requested-Party-Address', _ASRecord_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _ASRecord_list_Of_Called_Asserted_Identity),
        ('alternateChargedPartyAddress', _ASRecord_alternateChargedPartyAddress),
        ('outgoingSessionId', _ASRecord_outgoingSessionId),
        ('initialIMS-Charging-Identifier', _ASRecord_initialIMS_Charging_Identifier),
        ('list-Of-AccessTransferInformation', _ASRecord_list_Of_AccessTransferInformation),
        ('tADS-Identifier', _ASRecord_tADS_Identifier),
        ('vlr-Number', _ASRecord_vlr_Number),
        ('msc-Address', _ASRecord_msc_Address),
        ('threeGPPPSDataOffStatus', _ASRecord_threeGPPPSDataOffStatus),
        ('fEIdentifierList', _ASRecord_fEIdentifierList),
        ])
    ASRecord._ext = None
    
    #-----< ECSCFRecord >-----#
    ECSCFRecord = SET(name='ECSCFRecord', mode=MODE_TYPE)
    _ECSCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ECSCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ECSCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ECSCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ECSCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ECSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ECSCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ECSCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_interOperatorIdentifiers = SEQ_OF(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _ECSCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ECSCFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ECSCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ECSCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ECSCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _ECSCFRecord_list_Of_SDP_Media_Components._cont = __ECSCFRecord_list_Of_SDP_Media_Components__item_
    _ECSCFRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ECSCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _ECSCFRecord_list_Of_Message_Bodies._cont = __ECSCFRecord_list_Of_Message_Bodies__item_
    _ECSCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ECSCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ECSCFRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _ECSCFRecord_list_of_subscription_ID._cont = __ECSCFRecord_list_of_subscription_ID__item_
    _ECSCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _ECSCFRecord_list_Of_Early_SDP_Media_Components._cont = __ECSCFRecord_list_Of_Early_SDP_Media_Components__item_
    _ECSCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _ECSCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ECSCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ECSCFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ECSCFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ECSCFRecord_applicationServersInformation = SEQ_OF(name='applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _ECSCFRecord_applicationServersInformation._cont = __ECSCFRecord_applicationServersInformation__item_
    _ECSCFRecord_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ECSCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ECSCFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ECSCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _ECSCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ECSCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _ECSCFRecord_list_Of_AccessNetworkInfoChange._cont = __ECSCFRecord_list_Of_AccessNetworkInfoChange__item_
    _ECSCFRecord_listOfCalledIdentityChanges = SEQ_OF(name='listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _ECSCFRecord_listOfCalledIdentityChanges._cont = __ECSCFRecord_listOfCalledIdentityChanges__item_
    _ECSCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ECSCFRecord._cont = ASN1Dict([
        ('recordType', _ECSCFRecord_recordType),
        ('retransmission', _ECSCFRecord_retransmission),
        ('sIP-Method', _ECSCFRecord_sIP_Method),
        ('role-of-Node', _ECSCFRecord_role_of_Node),
        ('nodeAddress', _ECSCFRecord_nodeAddress),
        ('session-Id', _ECSCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _ECSCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _ECSCFRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _ECSCFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _ECSCFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _ECSCFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _ECSCFRecord_recordOpeningTime),
        ('recordClosureTime', _ECSCFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _ECSCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _ECSCFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _ECSCFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _ECSCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _ECSCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _ECSCFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _ECSCFRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _ECSCFRecord_gGSNaddress),
        ('serviceReasonReturnCode', _ECSCFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _ECSCFRecord_list_Of_Message_Bodies),
        ('recordExtensions', _ECSCFRecord_recordExtensions),
        ('expiresInformation', _ECSCFRecord_expiresInformation),
        ('event', _ECSCFRecord_event),
        ('accessNetworkInformation', _ECSCFRecord_accessNetworkInformation),
        ('serviceContextID', _ECSCFRecord_serviceContextID),
        ('list-of-subscription-ID', _ECSCFRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _ECSCFRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _ECSCFRecord_iMSCommunicationServiceIdentifier),
        ('sessionPriority', _ECSCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _ECSCFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _ECSCFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _ECSCFRecord_serviceDeliveryEndTimeStampFraction),
        ('applicationServersInformation', _ECSCFRecord_applicationServersInformation),
        ('requested-Party-Address', _ECSCFRecord_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _ECSCFRecord_list_Of_Called_Asserted_Identity),
        ('userLocationInformation', _ECSCFRecord_userLocationInformation),
        ('mSTimeZone', _ECSCFRecord_mSTimeZone),
        ('fromAddress', _ECSCFRecord_fromAddress),
        ('transit-IOI-Lists', _ECSCFRecord_transit_IOI_Lists),
        ('listOfReasonHeader', _ECSCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _ECSCFRecord_additionalAccessNetworkInformation),
        ('list-Of-AccessNetworkInfoChange', _ECSCFRecord_list_Of_AccessNetworkInfoChange),
        ('listOfCalledIdentityChanges', _ECSCFRecord_listOfCalledIdentityChanges),
        ('cellularNetworkInformation', _ECSCFRecord_cellularNetworkInformation),
        ('fEIdentifierList', _ECSCFRecord_fEIdentifierList),
        ])
    ECSCFRecord._ext = None
    
    #-----< IBCFRecord >-----#
    IBCFRecord = SET(name='IBCFRecord', mode=MODE_TYPE)
    _IBCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _IBCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _IBCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _IBCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _IBCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _IBCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _IBCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _IBCFRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _IBCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _IBCFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _IBCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _IBCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _IBCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _IBCFRecord_list_Of_SDP_Media_Components._cont = __IBCFRecord_list_Of_SDP_Media_Components__item_
    _IBCFRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _IBCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _IBCFRecord_list_Of_Message_Bodies._cont = __IBCFRecord_list_Of_Message_Bodies__item_
    _IBCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _IBCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _IBCFRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _IBCFRecord_list_of_subscription_ID._cont = __IBCFRecord_list_of_subscription_ID__item_
    _IBCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _IBCFRecord_list_Of_Early_SDP_Media_Components._cont = __IBCFRecord_list_Of_Early_SDP_Media_Components__item_
    _IBCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _IBCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _IBCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _IBCFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _IBCFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _IBCFRecord_list_of_Requested_Party_Address = SEQ_OF(name='list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _IBCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _IBCFRecord_transit_IOI_List = STR_GRAPH(name='transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_nNI_Information = SEQ_OF(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_nNI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')))
    _IBCFRecord_nNI_Information._cont = __IBCFRecord_nNI_Information__item_
    _IBCFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _IBCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _IBCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_routeHeaderReceived = OCT_STR(name='routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _IBCFRecord_list_Of_AccessNetworkInfoChange._cont = __IBCFRecord_list_Of_AccessNetworkInfoChange__item_
    _IBCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_initialIMS_Charging_Identifier = OCT_STR(name='initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _IBCFRecord_list_Of_AccessTransferInformation = SEQ_OF(name='list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _IBCFRecord_list_Of_AccessTransferInformation._cont = __IBCFRecord_list_Of_AccessTransferInformation__item_
    _IBCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(107, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    IBCFRecord._cont = ASN1Dict([
        ('recordType', _IBCFRecord_recordType),
        ('retransmission', _IBCFRecord_retransmission),
        ('sIP-Method', _IBCFRecord_sIP_Method),
        ('role-of-Node', _IBCFRecord_role_of_Node),
        ('nodeAddress', _IBCFRecord_nodeAddress),
        ('session-Id', _IBCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _IBCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _IBCFRecord_called_Party_Address),
        ('privateUserID', _IBCFRecord_privateUserID),
        ('serviceRequestTimeStamp', _IBCFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _IBCFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _IBCFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _IBCFRecord_recordOpeningTime),
        ('recordClosureTime', _IBCFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _IBCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _IBCFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _IBCFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _IBCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _IBCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _IBCFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _IBCFRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _IBCFRecord_gGSNaddress),
        ('serviceReasonReturnCode', _IBCFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _IBCFRecord_list_Of_Message_Bodies),
        ('recordExtensions', _IBCFRecord_recordExtensions),
        ('expiresInformation', _IBCFRecord_expiresInformation),
        ('event', _IBCFRecord_event),
        ('accessNetworkInformation', _IBCFRecord_accessNetworkInformation),
        ('serviceContextID', _IBCFRecord_serviceContextID),
        ('list-of-subscription-ID', _IBCFRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _IBCFRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _IBCFRecord_iMSCommunicationServiceIdentifier),
        ('sessionPriority', _IBCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _IBCFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _IBCFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _IBCFRecord_serviceDeliveryEndTimeStampFraction),
        ('list-of-Requested-Party-Address', _IBCFRecord_list_of_Requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _IBCFRecord_list_Of_Called_Asserted_Identity),
        ('transit-IOI-List', _IBCFRecord_transit_IOI_List),
        ('nNI-Information', _IBCFRecord_nNI_Information),
        ('userLocationInformation', _IBCFRecord_userLocationInformation),
        ('mSTimeZone', _IBCFRecord_mSTimeZone),
        ('fromAddress', _IBCFRecord_fromAddress),
        ('listOfReasonHeader', _IBCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _IBCFRecord_additionalAccessNetworkInformation),
        ('routeHeaderReceived', _IBCFRecord_routeHeaderReceived),
        ('list-Of-AccessNetworkInfoChange', _IBCFRecord_list_Of_AccessNetworkInfoChange),
        ('cellularNetworkInformation', _IBCFRecord_cellularNetworkInformation),
        ('initialIMS-Charging-Identifier', _IBCFRecord_initialIMS_Charging_Identifier),
        ('list-Of-AccessTransferInformation', _IBCFRecord_list_Of_AccessTransferInformation),
        ('fEIdentifierList', _IBCFRecord_fEIdentifierList),
        ])
    IBCFRecord._ext = None
    
    #-----< TRFRecord >-----#
    TRFRecord = SET(name='TRFRecord', mode=MODE_TYPE)
    _TRFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TRFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _TRFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _TRFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _TRFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _TRFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TRFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TRFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_interOperatorIdentifiers = SEQ_OF(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _TRFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TRFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _TRFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _TRFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _TRFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _TRFRecord_list_Of_SDP_Media_Components._cont = __TRFRecord_list_Of_SDP_Media_Components__item_
    _TRFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _TRFRecord_list_Of_Message_Bodies._cont = __TRFRecord_list_Of_Message_Bodies__item_
    _TRFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TRFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _TRFRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _TRFRecord_list_of_subscription_ID._cont = __TRFRecord_list_of_subscription_ID__item_
    _TRFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _TRFRecord_list_Of_Early_SDP_Media_Components._cont = __TRFRecord_list_Of_Early_SDP_Media_Components__item_
    _TRFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _TRFRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _TRFRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _TRFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _TRFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TRFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TRFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TRFRecord_applicationServersInformation = SEQ_OF(name='applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _TRFRecord_applicationServersInformation._cont = __TRFRecord_applicationServersInformation__item_
    _TRFRecord_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TRFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TRFRecord_nNI_Information = SEQ_OF(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_nNI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')))
    _TRFRecord_nNI_Information._cont = __TRFRecord_nNI_Information__item_
    _TRFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _TRFRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _TRFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _TRFRecord_routeHeaderReceived = OCT_STR(name='routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_listOfCalledIdentityChanges = SEQ_OF(name='listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _TRFRecord_listOfCalledIdentityChanges._cont = __TRFRecord_listOfCalledIdentityChanges__item_
    _TRFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    TRFRecord._cont = ASN1Dict([
        ('recordType', _TRFRecord_recordType),
        ('retransmission', _TRFRecord_retransmission),
        ('sIP-Method', _TRFRecord_sIP_Method),
        ('role-of-Node', _TRFRecord_role_of_Node),
        ('nodeAddress', _TRFRecord_nodeAddress),
        ('session-Id', _TRFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _TRFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _TRFRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _TRFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _TRFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _TRFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _TRFRecord_recordOpeningTime),
        ('recordClosureTime', _TRFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _TRFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _TRFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _TRFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _TRFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _TRFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _TRFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _TRFRecord_list_Of_SDP_Media_Components),
        ('serviceReasonReturnCode', _TRFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _TRFRecord_list_Of_Message_Bodies),
        ('recordExtensions', _TRFRecord_recordExtensions),
        ('expiresInformation', _TRFRecord_expiresInformation),
        ('event', _TRFRecord_event),
        ('serviceContextID', _TRFRecord_serviceContextID),
        ('list-of-subscription-ID', _TRFRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _TRFRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _TRFRecord_iMSCommunicationServiceIdentifier),
        ('numberPortabilityRouting', _TRFRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _TRFRecord_carrierSelectRouting),
        ('sessionPriority', _TRFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _TRFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _TRFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _TRFRecord_serviceDeliveryEndTimeStampFraction),
        ('applicationServersInformation', _TRFRecord_applicationServersInformation),
        ('requested-Party-Address', _TRFRecord_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _TRFRecord_list_Of_Called_Asserted_Identity),
        ('nNI-Information', _TRFRecord_nNI_Information),
        ('userLocationInformation', _TRFRecord_userLocationInformation),
        ('mSTimeZone', _TRFRecord_mSTimeZone),
        ('transit-IOI-Lists', _TRFRecord_transit_IOI_Lists),
        ('listOfReasonHeader', _TRFRecord_listOfReasonHeader),
        ('routeHeaderReceived', _TRFRecord_routeHeaderReceived),
        ('listOfCalledIdentityChanges', _TRFRecord_listOfCalledIdentityChanges),
        ('fEIdentifierList', _TRFRecord_fEIdentifierList),
        ])
    TRFRecord._ext = None
    
    #-----< ATCFRecord >-----#
    ATCFRecord = SET(name='ATCFRecord', mode=MODE_TYPE)
    _ATCFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ATCFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ATCFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ATCFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ATCFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ATCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ATCFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ATCFRecord_privateUserID = STR_GRAPH(name='privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _ATCFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ATCFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ATCFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ATCFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ATCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _ATCFRecord_list_Of_SDP_Media_Components._cont = __ATCFRecord_list_Of_SDP_Media_Components__item_
    _ATCFRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ATCFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _ATCFRecord_list_Of_Message_Bodies._cont = __ATCFRecord_list_Of_Message_Bodies__item_
    _ATCFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ATCFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ATCFRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _ATCFRecord_list_of_subscription_ID._cont = __ATCFRecord_list_of_subscription_ID__item_
    _ATCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _ATCFRecord_list_Of_Early_SDP_Media_Components._cont = __ATCFRecord_list_Of_Early_SDP_Media_Components__item_
    _ATCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _ATCFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ATCFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ATCFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ATCFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ATCFRecord_list_of_Requested_Party_Address = SEQ_OF(name='list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ATCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ATCFRecord_nNI_Information = SEQ(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _ATCFRecord_userLocationInformation = OCT_STR(name='userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ATCFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ATCFRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_routeHeaderReceived = OCT_STR(name='routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_routeHeaderTransmitted = OCT_STR(name='routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name='list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _ATCFRecord_list_Of_AccessNetworkInfoChange._cont = __ATCFRecord_list_Of_AccessNetworkInfoChange__item_
    _ATCFRecord_listOfCalledIdentityChanges = SEQ_OF(name='listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _ATCFRecord_listOfCalledIdentityChanges._cont = __ATCFRecord_listOfCalledIdentityChanges__item_
    _ATCFRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_initialIMS_Charging_Identifier = OCT_STR(name='initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ATCFRecord_list_Of_AccessTransferInformation = SEQ_OF(name='list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _ATCFRecord_list_Of_AccessTransferInformation._cont = __ATCFRecord_list_Of_AccessTransferInformation__item_
    _ATCFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(107, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ATCFRecord._cont = ASN1Dict([
        ('recordType', _ATCFRecord_recordType),
        ('retransmission', _ATCFRecord_retransmission),
        ('sIP-Method', _ATCFRecord_sIP_Method),
        ('role-of-Node', _ATCFRecord_role_of_Node),
        ('nodeAddress', _ATCFRecord_nodeAddress),
        ('session-Id', _ATCFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _ATCFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _ATCFRecord_called_Party_Address),
        ('privateUserID', _ATCFRecord_privateUserID),
        ('serviceRequestTimeStamp', _ATCFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _ATCFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _ATCFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _ATCFRecord_recordOpeningTime),
        ('recordClosureTime', _ATCFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _ATCFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _ATCFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _ATCFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _ATCFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _ATCFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _ATCFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _ATCFRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _ATCFRecord_gGSNaddress),
        ('serviceReasonReturnCode', _ATCFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _ATCFRecord_list_Of_Message_Bodies),
        ('recordExtensions', _ATCFRecord_recordExtensions),
        ('expiresInformation', _ATCFRecord_expiresInformation),
        ('event', _ATCFRecord_event),
        ('accessNetworkInformation', _ATCFRecord_accessNetworkInformation),
        ('serviceContextID', _ATCFRecord_serviceContextID),
        ('list-of-subscription-ID', _ATCFRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _ATCFRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _ATCFRecord_iMSCommunicationServiceIdentifier),
        ('sessionPriority', _ATCFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _ATCFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _ATCFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _ATCFRecord_serviceDeliveryEndTimeStampFraction),
        ('list-of-Requested-Party-Address', _ATCFRecord_list_of_Requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _ATCFRecord_list_Of_Called_Asserted_Identity),
        ('nNI-Information', _ATCFRecord_nNI_Information),
        ('userLocationInformation', _ATCFRecord_userLocationInformation),
        ('mSTimeZone', _ATCFRecord_mSTimeZone),
        ('fromAddress', _ATCFRecord_fromAddress),
        ('listOfReasonHeader', _ATCFRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _ATCFRecord_additionalAccessNetworkInformation),
        ('routeHeaderReceived', _ATCFRecord_routeHeaderReceived),
        ('routeHeaderTransmitted', _ATCFRecord_routeHeaderTransmitted),
        ('list-Of-AccessNetworkInfoChange', _ATCFRecord_list_Of_AccessNetworkInfoChange),
        ('listOfCalledIdentityChanges', _ATCFRecord_listOfCalledIdentityChanges),
        ('cellularNetworkInformation', _ATCFRecord_cellularNetworkInformation),
        ('initialIMS-Charging-Identifier', _ATCFRecord_initialIMS_Charging_Identifier),
        ('list-Of-AccessTransferInformation', _ATCFRecord_list_Of_AccessTransferInformation),
        ('fEIdentifierList', _ATCFRecord_fEIdentifierList),
        ])
    ATCFRecord._ext = None
    
    #-----< TFRecord >-----#
    TFRecord = SET(name='TFRecord', mode=MODE_TYPE)
    _TFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _TFRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _TFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _TFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _TFRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_interOperatorIdentifiers = SEQ_OF(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _TFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _TFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _TFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _TFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _TFRecord_list_Of_SDP_Media_Components._cont = __TFRecord_list_Of_SDP_Media_Components__item_
    _TFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _TFRecord_list_Of_Message_Bodies._cont = __TFRecord_list_Of_Message_Bodies__item_
    _TFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TFRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _TFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _TFRecord_list_Of_Early_SDP_Media_Components._cont = __TFRecord_list_Of_Early_SDP_Media_Components__item_
    _TFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _TFRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _TFRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _TFRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _TFRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TFRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TFRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TFRecord_applicationServersInformation = SEQ_OF(name='applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _TFRecord_applicationServersInformation._cont = __TFRecord_applicationServersInformation__item_
    _TFRecord_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TFRecord_nNI_Information = SEQ(name='nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _TFRecord_fromAddress = OCT_STR(name='fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _TFRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _TFRecord_routeHeaderReceived = OCT_STR(name='routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_routeHeaderTransmitted = OCT_STR(name='routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_listOfCalledIdentityChanges = SEQ_OF(name='listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _TFRecord_listOfCalledIdentityChanges._cont = __TFRecord_listOfCalledIdentityChanges__item_
    _TFRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    TFRecord._cont = ASN1Dict([
        ('recordType', _TFRecord_recordType),
        ('retransmission', _TFRecord_retransmission),
        ('sIP-Method', _TFRecord_sIP_Method),
        ('role-of-Node', _TFRecord_role_of_Node),
        ('nodeAddress', _TFRecord_nodeAddress),
        ('session-Id', _TFRecord_session_Id),
        ('list-Of-Calling-Party-Address', _TFRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _TFRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _TFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _TFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _TFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _TFRecord_recordOpeningTime),
        ('recordClosureTime', _TFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _TFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _TFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _TFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _TFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _TFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _TFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _TFRecord_list_Of_SDP_Media_Components),
        ('serviceReasonReturnCode', _TFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _TFRecord_list_Of_Message_Bodies),
        ('recordExtensions', _TFRecord_recordExtensions),
        ('expiresInformation', _TFRecord_expiresInformation),
        ('event', _TFRecord_event),
        ('serviceContextID', _TFRecord_serviceContextID),
        ('list-Of-Early-SDP-Media-Components', _TFRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _TFRecord_iMSCommunicationServiceIdentifier),
        ('numberPortabilityRouting', _TFRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _TFRecord_carrierSelectRouting),
        ('sessionPriority', _TFRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _TFRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _TFRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _TFRecord_serviceDeliveryEndTimeStampFraction),
        ('applicationServersInformation', _TFRecord_applicationServersInformation),
        ('requested-Party-Address', _TFRecord_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _TFRecord_list_Of_Called_Asserted_Identity),
        ('nNI-Information', _TFRecord_nNI_Information),
        ('fromAddress', _TFRecord_fromAddress),
        ('transit-IOI-Lists', _TFRecord_transit_IOI_Lists),
        ('listOfReasonHeader', _TFRecord_listOfReasonHeader),
        ('routeHeaderReceived', _TFRecord_routeHeaderReceived),
        ('routeHeaderTransmitted', _TFRecord_routeHeaderTransmitted),
        ('listOfCalledIdentityChanges', _TFRecord_listOfCalledIdentityChanges),
        ('fEIdentifierList', _TFRecord_fEIdentifierList),
        ])
    TFRecord._ext = None
    
    #-----< AccessCorrelationID >-----#
    AccessCorrelationID = CHOICE(name='AccessCorrelationID', mode=MODE_TYPE)
    _AccessCorrelationID_gPRS_Charging_Id = INT(name='gPRS-Charging-Id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessCorrelationID_gPRS_Charging_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _AccessCorrelationID_accessNetworkChargingIdentifier = STR_GRAPH(name='accessNetworkChargingIdentifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AccessCorrelationID._cont = ASN1Dict([
        ('gPRS-Charging-Id', _AccessCorrelationID_gPRS_Charging_Id),
        ('accessNetworkChargingIdentifier', _AccessCorrelationID_accessNetworkChargingIdentifier),
        ])
    AccessCorrelationID._ext = None
    
    #-----< AccessNetworkInfoChange >-----#
    AccessNetworkInfoChange = SEQ(name='AccessNetworkInfoChange', mode=MODE_TYPE)
    _AccessNetworkInfoChange_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessNetworkInfoChange_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessNetworkInfoChange_accessChangeTime = OCT_STR(name='accessChangeTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _AccessNetworkInfoChange_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AccessNetworkInfoChange._cont = ASN1Dict([
        ('accessNetworkInformation', _AccessNetworkInfoChange_accessNetworkInformation),
        ('additionalAccessNetworkInformation', _AccessNetworkInfoChange_additionalAccessNetworkInformation),
        ('accessChangeTime', _AccessNetworkInfoChange_accessChangeTime),
        ('cellularNetworkInformation', _AccessNetworkInfoChange_cellularNetworkInformation),
        ])
    AccessNetworkInfoChange._ext = None
    
    #-----< AccessTransferType >-----#
    AccessTransferType = ENUM(name='AccessTransferType', mode=MODE_TYPE)
    AccessTransferType._cont = ASN1Dict([('pSToCS', 0), ('cSToPS', 1), ('pSToPS', 2), ('cSToCS', 3)])
    AccessTransferType._ext = None
    
    #-----< AccessTransferInformation >-----#
    AccessTransferInformation = SEQ(name='AccessTransferInformation', mode=MODE_TYPE)
    _AccessTransferInformation_accessTransferType = ENUM(name='accessTransferType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferType')), opt=True)
    _AccessTransferInformation_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_inter_UE_Transfer = NULL(name='inter-UE-Transfer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_relatedICID = OCT_STR(name='relatedICID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _AccessTransferInformation_relatedICIDGenerationNode = CHOICE(name='relatedICIDGenerationNode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _AccessTransferInformation_accessTransferTime = OCT_STR(name='accessTransferTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _AccessTransferInformation_subscriberEquipmentNumber = SET(name='subscriberEquipmentNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _AccessTransferInformation_instanceId = OCT_STR(name='instanceId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AccessTransferInformation._cont = ASN1Dict([
        ('accessTransferType', _AccessTransferInformation_accessTransferType),
        ('accessNetworkInformation', _AccessTransferInformation_accessNetworkInformation),
        ('additionalAccessNetworkInformation', _AccessTransferInformation_additionalAccessNetworkInformation),
        ('inter-UE-Transfer', _AccessTransferInformation_inter_UE_Transfer),
        ('relatedICID', _AccessTransferInformation_relatedICID),
        ('relatedICIDGenerationNode', _AccessTransferInformation_relatedICIDGenerationNode),
        ('accessTransferTime', _AccessTransferInformation_accessTransferTime),
        ('subscriberEquipmentNumber', _AccessTransferInformation_subscriberEquipmentNumber),
        ('instanceId', _AccessTransferInformation_instanceId),
        ('cellularNetworkInformation', _AccessTransferInformation_cellularNetworkInformation),
        ])
    AccessTransferInformation._ext = None
    
    #-----< ACRInterimLost >-----#
    ACRInterimLost = ENUM(name='ACRInterimLost', mode=MODE_TYPE)
    ACRInterimLost._cont = ASN1Dict([('no', 0), ('yes', 1), ('unknown', 2)])
    ACRInterimLost._ext = None
    
    #-----< AoCCostInformation >-----#
    AoCCostInformation = SEQ(name='AoCCostInformation', mode=MODE_TYPE)
    _AoCCostInformation_accumulatedCost = REAL(name='accumulatedCost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _AoCCostInformation_incrementalCost = REAL(name='incrementalCost', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _AoCCostInformation_currencyCode = INT(name='currencyCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AoCCostInformation._cont = ASN1Dict([
        ('accumulatedCost', _AoCCostInformation_accumulatedCost),
        ('incrementalCost', _AoCCostInformation_incrementalCost),
        ('currencyCode', _AoCCostInformation_currencyCode),
        ])
    AoCCostInformation._ext = None
    
    #-----< AoCInformation >-----#
    AoCInformation = SET(name='AoCInformation', mode=MODE_TYPE)
    _AoCInformation_tariffInformation = SEQ(name='tariffInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TariffInformation')), opt=True)
    _AoCInformation_aoCCostInformation = SEQ(name='aoCCostInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'AoCCostInformation')), opt=True)
    AoCInformation._cont = ASN1Dict([
        ('tariffInformation', _AoCInformation_tariffInformation),
        ('aoCCostInformation', _AoCInformation_aoCCostInformation),
        ])
    AoCInformation._ext = None
    
    #-----< ApplicationServersInformation >-----#
    ApplicationServersInformation = SEQ(name='ApplicationServersInformation', mode=MODE_TYPE)
    _ApplicationServersInformation_applicationServersInvolved = CHOICE(name='applicationServersInvolved', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ApplicationServersInformation_applicationProvidedCalledParties = SEQ_OF(name='applicationProvidedCalledParties', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ApplicationServersInformation_applicationProvidedCalledParties__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _ApplicationServersInformation_applicationProvidedCalledParties._cont = __ApplicationServersInformation_applicationProvidedCalledParties__item_
    _ApplicationServersInformation_sTatus = ENUM(name='sTatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Status')), opt=True)
    ApplicationServersInformation._cont = ASN1Dict([
        ('applicationServersInvolved', _ApplicationServersInformation_applicationServersInvolved),
        ('applicationProvidedCalledParties', _ApplicationServersInformation_applicationProvidedCalledParties),
        ('sTatus', _ApplicationServersInformation_sTatus),
        ])
    ApplicationServersInformation._ext = None
    
    #-----< CalledIdentityChange >-----#
    CalledIdentityChange = SEQ(name='CalledIdentityChange', mode=MODE_TYPE)
    _CalledIdentityChange_calledIdentity = CHOICE(name='calledIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CalledIdentityChange_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    CalledIdentityChange._cont = ASN1Dict([
        ('calledIdentity', _CalledIdentityChange_calledIdentity),
        ('changeTime', _CalledIdentityChange_changeTime),
        ])
    CalledIdentityChange._ext = None
    
    #-----< CarrierSelectRouting >-----#
    CarrierSelectRouting = STR_GRAPH(name='CarrierSelectRouting', mode=MODE_TYPE)
    
    #-----< CauseForRecordClosing >-----#
    CauseForRecordClosing = ENUM(name='CauseForRecordClosing', mode=MODE_TYPE)
    CauseForRecordClosing._cont = ASN1Dict([('serviceDeliveryEndSuccessfully', 0), ('unSuccessfulServiceDelivery', 1), ('timeLimit', 3), ('serviceChange', 4), ('managementIntervention', 5)])
    CauseForRecordClosing._ext = None
    
    #-----< Early-Media-Components-List >-----#
    Early_Media_Components_List = SEQ(name='Early-Media-Components-List', mode=MODE_TYPE)
    _Early_Media_Components_List_sDP_Offer_Timestamp = OCT_STR(name='sDP-Offer-Timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Early_Media_Components_List_sDP_Answer_Timestamp = OCT_STR(name='sDP-Answer-Timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Early_Media_Components_List_sDP_Media_Components = SEQ_OF(name='sDP-Media-Components', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Early_Media_Components_List_sDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Media-Component')))
    _Early_Media_Components_List_sDP_Media_Components._cont = __Early_Media_Components_List_sDP_Media_Components__item_
    _Early_Media_Components_List_mediaInitiatorFlag = NULL(name='mediaInitiatorFlag', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Early_Media_Components_List_sDP_Session_Description = SEQ_OF(name='sDP-Session-Description', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Early_Media_Components_List_sDP_Session_Description__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _Early_Media_Components_List_sDP_Session_Description._cont = __Early_Media_Components_List_sDP_Session_Description__item_
    _Early_Media_Components_List_sDP_Type = ENUM(name='sDP-Type', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Type')), opt=True)
    Early_Media_Components_List._cont = ASN1Dict([
        ('sDP-Offer-Timestamp', _Early_Media_Components_List_sDP_Offer_Timestamp),
        ('sDP-Answer-Timestamp', _Early_Media_Components_List_sDP_Answer_Timestamp),
        ('sDP-Media-Components', _Early_Media_Components_List_sDP_Media_Components),
        ('mediaInitiatorFlag', _Early_Media_Components_List_mediaInitiatorFlag),
        ('sDP-Session-Description', _Early_Media_Components_List_sDP_Session_Description),
        ('sDP-Type', _Early_Media_Components_List_sDP_Type),
        ])
    Early_Media_Components_List._ext = None
    
    #-----< FEIdentifierList >-----#
    FEIdentifierList = SEQ_OF(name='FEIdentifierList', mode=MODE_TYPE)
    _FEIdentifierList__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    FEIdentifierList._cont = _FEIdentifierList__item_
    
    #-----< IMS-Charging-Identifier >-----#
    IMS_Charging_Identifier = OCT_STR(name='IMS-Charging-Identifier', mode=MODE_TYPE)
    
    #-----< IMSCommunicationServiceIdentifier >-----#
    IMSCommunicationServiceIdentifier = OCT_STR(name='IMSCommunicationServiceIdentifier', mode=MODE_TYPE)
    
    #-----< Incomplete-CDR-Indication >-----#
    Incomplete_CDR_Indication = SET(name='Incomplete-CDR-Indication', mode=MODE_TYPE)
    _Incomplete_CDR_Indication_aCRStartLost = BOOL(name='aCRStartLost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Incomplete_CDR_Indication_aCRInterimLost = ENUM(name='aCRInterimLost', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ACRInterimLost')))
    _Incomplete_CDR_Indication_aCRStopLost = BOOL(name='aCRStopLost', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Incomplete_CDR_Indication._cont = ASN1Dict([
        ('aCRStartLost', _Incomplete_CDR_Indication_aCRStartLost),
        ('aCRInterimLost', _Incomplete_CDR_Indication_aCRInterimLost),
        ('aCRStopLost', _Incomplete_CDR_Indication_aCRStopLost),
        ])
    Incomplete_CDR_Indication._ext = None
    
    #-----< InterOperatorIdentifierList >-----#
    InterOperatorIdentifierList = SEQ_OF(name='InterOperatorIdentifierList', mode=MODE_TYPE)
    _InterOperatorIdentifierList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')))
    InterOperatorIdentifierList._cont = _InterOperatorIdentifierList__item_
    
    #-----< InterOperatorIdentifiers >-----#
    InterOperatorIdentifiers = SEQ(name='InterOperatorIdentifiers', mode=MODE_TYPE)
    _InterOperatorIdentifiers_originatingIOI = STR_GRAPH(name='originatingIOI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterOperatorIdentifiers_terminatingIOI = STR_GRAPH(name='terminatingIOI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    InterOperatorIdentifiers._cont = ASN1Dict([
        ('originatingIOI', _InterOperatorIdentifiers_originatingIOI),
        ('terminatingIOI', _InterOperatorIdentifiers_terminatingIOI),
        ])
    InterOperatorIdentifiers._ext = None
    
    #-----< ISUPCause >-----#
    ISUPCause = SEQ(name='ISUPCause', mode=MODE_TYPE)
    _ISUPCause_iSUPCauseLocation = INT(name='iSUPCauseLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISUPCause_iSUPCauseValue = INT(name='iSUPCauseValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISUPCause_iSUPCauseDiagnostics = OCT_STR(name='iSUPCauseDiagnostics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ISUPCause._cont = ASN1Dict([
        ('iSUPCauseLocation', _ISUPCause_iSUPCauseLocation),
        ('iSUPCauseValue', _ISUPCause_iSUPCauseValue),
        ('iSUPCauseDiagnostics', _ISUPCause_iSUPCauseDiagnostics),
        ])
    ISUPCause._ext = None
    
    #-----< ListOfInvolvedParties >-----#
    ListOfInvolvedParties = SEQ_OF(name='ListOfInvolvedParties', mode=MODE_TYPE)
    _ListOfInvolvedParties__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    ListOfInvolvedParties._cont = _ListOfInvolvedParties__item_
    
    #-----< ListOfReasonHeader >-----#
    ListOfReasonHeader = SEQ_OF(name='ListOfReasonHeader', mode=MODE_TYPE)
    _ListOfReasonHeader__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ReasonHeaderInformation')))
    ListOfReasonHeader._cont = _ListOfReasonHeader__item_
    
    #-----< Media-Components-List >-----#
    Media_Components_List = SEQ(name='Media-Components-List', mode=MODE_TYPE)
    _Media_Components_List_sIP_Request_Timestamp = OCT_STR(name='sIP-Request-Timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Media_Components_List_sIP_Response_Timestamp = OCT_STR(name='sIP-Response-Timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Media_Components_List_sDP_Media_Components = SEQ_OF(name='sDP-Media-Components', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Media_Components_List_sDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Media-Component')))
    _Media_Components_List_sDP_Media_Components._cont = __Media_Components_List_sDP_Media_Components__item_
    _Media_Components_List_mediaInitiatorFlag = NULL(name='mediaInitiatorFlag', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Media_Components_List_sDP_Session_Description = SEQ_OF(name='sDP-Session-Description', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Media_Components_List_sDP_Session_Description__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _Media_Components_List_sDP_Session_Description._cont = __Media_Components_List_sDP_Session_Description__item_
    _Media_Components_List_mediaInitiatorParty = CHOICE(name='mediaInitiatorParty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _Media_Components_List_sIP_Request_Timestamp_Fraction = INT(name='sIP-Request-Timestamp-Fraction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _Media_Components_List_sIP_Response_Timestamp_Fraction = INT(name='sIP-Response-Timestamp-Fraction', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _Media_Components_List_sDP_Type = ENUM(name='sDP-Type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Type')), opt=True)
    Media_Components_List._cont = ASN1Dict([
        ('sIP-Request-Timestamp', _Media_Components_List_sIP_Request_Timestamp),
        ('sIP-Response-Timestamp', _Media_Components_List_sIP_Response_Timestamp),
        ('sDP-Media-Components', _Media_Components_List_sDP_Media_Components),
        ('mediaInitiatorFlag', _Media_Components_List_mediaInitiatorFlag),
        ('sDP-Session-Description', _Media_Components_List_sDP_Session_Description),
        ('mediaInitiatorParty', _Media_Components_List_mediaInitiatorParty),
        ('sIP-Request-Timestamp-Fraction', _Media_Components_List_sIP_Request_Timestamp_Fraction),
        ('sIP-Response-Timestamp-Fraction', _Media_Components_List_sIP_Response_Timestamp_Fraction),
        ('sDP-Type', _Media_Components_List_sDP_Type),
        ])
    Media_Components_List._ext = None
    
    #-----< MessageBody >-----#
    MessageBody = SEQ(name='MessageBody', mode=MODE_TYPE)
    _MessageBody_content_Type = STR_GRAPH(name='content-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MessageBody_content_Disposition = STR_GRAPH(name='content-Disposition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MessageBody_content_Length = INT(name='content-Length', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MessageBody_originator = CHOICE(name='originator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    MessageBody._cont = ASN1Dict([
        ('content-Type', _MessageBody_content_Type),
        ('content-Disposition', _MessageBody_content_Disposition),
        ('content-Length', _MessageBody_content_Length),
        ('originator', _MessageBody_originator),
        ])
    MessageBody._ext = None
    
    #-----< Milliseconds >-----#
    Milliseconds = INT(name='Milliseconds', mode=MODE_TYPE)
    Milliseconds._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    
    #-----< NNI-Information >-----#
    NNI_Information = SEQ(name='NNI-Information', mode=MODE_TYPE)
    _NNI_Information_sessionDirection = ENUM(name='sessionDirection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionDirection')), opt=True)
    _NNI_Information_nNIType = ENUM(name='nNIType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNIType')), opt=True)
    _NNI_Information_relationshipMode = ENUM(name='relationshipMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'RelationshipMode')), opt=True)
    _NNI_Information_neighbourNodeAddress = CHOICE(name='neighbourNodeAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    NNI_Information._cont = ASN1Dict([
        ('sessionDirection', _NNI_Information_sessionDirection),
        ('nNIType', _NNI_Information_nNIType),
        ('relationshipMode', _NNI_Information_relationshipMode),
        ('neighbourNodeAddress', _NNI_Information_neighbourNodeAddress),
        ])
    NNI_Information._ext = None
    
    #-----< NNIType >-----#
    NNIType = ENUM(name='NNIType', mode=MODE_TYPE)
    NNIType._cont = ASN1Dict([('non-roaming', 0), ('roaming-without-loopback', 1), ('roaming-with-loopback', 2)])
    NNIType._ext = None
    
    #-----< NumberPortabilityRouting >-----#
    NumberPortabilityRouting = STR_GRAPH(name='NumberPortabilityRouting', mode=MODE_TYPE)
    
    #-----< RateElement >-----#
    RateElement = SEQ(name='RateElement', mode=MODE_TYPE)
    _RateElement_unitType = INT(name='unitType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RateElement_unitValue = REAL(name='unitValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _RateElement_unitCost = REAL(name='unitCost', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _RateElement_unitQuotaThreshold = REAL(name='unitQuotaThreshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    RateElement._cont = ASN1Dict([
        ('unitType', _RateElement_unitType),
        ('unitValue', _RateElement_unitValue),
        ('unitCost', _RateElement_unitCost),
        ('unitQuotaThreshold', _RateElement_unitQuotaThreshold),
        ])
    RateElement._ext = None
    
    #-----< RealTimeTariffInformation >-----#
    RealTimeTariffInformation = CHOICE(name='RealTimeTariffInformation', mode=MODE_TYPE)
    _RealTimeTariffInformation_tariffInformation = SEQ(name='tariffInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TariffInformation')))
    _RealTimeTariffInformation_tariffXml = STR_UTF8(name='tariffXml', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RealTimeTariffInformation._cont = ASN1Dict([
        ('tariffInformation', _RealTimeTariffInformation_tariffInformation),
        ('tariffXml', _RealTimeTariffInformation_tariffXml),
        ])
    RealTimeTariffInformation._ext = None
    
    #-----< ReasonHeaderInformation >-----#
    ReasonHeaderInformation = STR_GRAPH(name='ReasonHeaderInformation', mode=MODE_TYPE)
    
    #-----< RelationshipMode >-----#
    RelationshipMode = ENUM(name='RelationshipMode', mode=MODE_TYPE)
    RelationshipMode._cont = ASN1Dict([('trusted', 0), ('non-trusted', 1)])
    RelationshipMode._ext = None
    
    #-----< Role-of-Node >-----#
    Role_of_Node = ENUM(name='Role-of-Node', mode=MODE_TYPE)
    Role_of_Node._cont = ASN1Dict([('originating', 0), ('terminating', 1)])
    Role_of_Node._ext = None
    
    #-----< S-CSCF-Information >-----#
    S_CSCF_Information = SEQ(name='S-CSCF-Information', mode=MODE_TYPE)
    _S_CSCF_Information_mandatoryCapabilities = SEQ_OF(name='mandatoryCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __S_CSCF_Information_mandatoryCapabilities__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _S_CSCF_Information_mandatoryCapabilities._cont = __S_CSCF_Information_mandatoryCapabilities__item_
    _S_CSCF_Information_optionalCapabilities = SEQ_OF(name='optionalCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __S_CSCF_Information_optionalCapabilities__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _S_CSCF_Information_optionalCapabilities._cont = __S_CSCF_Information_optionalCapabilities__item_
    _S_CSCF_Information_serverName = STR_GRAPH(name='serverName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    S_CSCF_Information._cont = ASN1Dict([
        ('mandatoryCapabilities', _S_CSCF_Information_mandatoryCapabilities),
        ('optionalCapabilities', _S_CSCF_Information_optionalCapabilities),
        ('serverName', _S_CSCF_Information_serverName),
        ])
    S_CSCF_Information._ext = None
    
    #-----< SDP-Media-Component >-----#
    SDP_Media_Component = SEQ(name='SDP-Media-Component', mode=MODE_TYPE)
    _SDP_Media_Component_sDP_Media_Name = STR_GRAPH(name='sDP-Media-Name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDP_Media_Component_sDP_Media_Descriptions = SEQ_OF(name='sDP-Media-Descriptions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Media-Description')), opt=True)
    _SDP_Media_Component_accessCorrelationID = CHOICE(name='accessCorrelationID', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessCorrelationID')), opt=True)
    _SDP_Media_Component_localGWInsertedIndication = BOOL(name='localGWInsertedIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDP_Media_Component_iPRealmDefaultIndication = BOOL(name='iPRealmDefaultIndication', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDP_Media_Component_transcoderInsertedIndication = BOOL(name='transcoderInsertedIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SDP_Media_Component._cont = ASN1Dict([
        ('sDP-Media-Name', _SDP_Media_Component_sDP_Media_Name),
        ('sDP-Media-Descriptions', _SDP_Media_Component_sDP_Media_Descriptions),
        ('accessCorrelationID', _SDP_Media_Component_accessCorrelationID),
        ('localGWInsertedIndication', _SDP_Media_Component_localGWInsertedIndication),
        ('iPRealmDefaultIndication', _SDP_Media_Component_iPRealmDefaultIndication),
        ('transcoderInsertedIndication', _SDP_Media_Component_transcoderInsertedIndication),
        ])
    SDP_Media_Component._ext = None
    
    #-----< SDP-Media-Description >-----#
    SDP_Media_Description = SEQ_OF(name='SDP-Media-Description', mode=MODE_TYPE)
    _SDP_Media_Description__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    SDP_Media_Description._cont = _SDP_Media_Description__item_
    
    #-----< ServedPartyIPAddress >-----#
    ServedPartyIPAddress = CHOICE(name='ServedPartyIPAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    
    #-----< Service-Id >-----#
    Service_Id = STR_GRAPH(name='Service-Id', mode=MODE_TYPE)
    
    #-----< SessionDirection >-----#
    SessionDirection = ENUM(name='SessionDirection', mode=MODE_TYPE)
    SessionDirection._cont = ASN1Dict([('inbound', 0), ('outbound', 1)])
    SessionDirection._ext = None
    
    #-----< SessionPriority >-----#
    SessionPriority = ENUM(name='SessionPriority', mode=MODE_TYPE)
    SessionPriority._cont = ASN1Dict([('pRIORITY-0', 0), ('pRIORITY-1', 1), ('pRIORITY-2', 2), ('pRIORITY-3', 3), ('pRIORITY-4', 4)])
    SessionPriority._ext = None
    
    #-----< SIP-Method >-----#
    SIP_Method = STR_GRAPH(name='SIP-Method', mode=MODE_TYPE)
    
    #-----< SDP-Type >-----#
    SDP_Type = ENUM(name='SDP-Type', mode=MODE_TYPE)
    SDP_Type._cont = ASN1Dict([('sDP-offer', 0), ('sDP-answer', 1)])
    SDP_Type._ext = None
    
    #-----< Status >-----#
    Status = ENUM(name='Status', mode=MODE_TYPE)
    Status._cont = ASN1Dict([('fourxx', 0), ('fivexx', 1), ('time-out', 2)])
    Status._ext = None
    
    #-----< TADIdentifier >-----#
    TADIdentifier = ENUM(name='TADIdentifier', mode=MODE_TYPE)
    TADIdentifier._cont = ASN1Dict([('cS', 0), ('pS', 1)])
    TADIdentifier._ext = None
    
    #-----< TariffInformation >-----#
    TariffInformation = SEQ(name='TariffInformation', mode=MODE_TYPE)
    _TariffInformation_currencyCode = INT(name='currencyCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TariffInformation_scaleFactor = REAL(name='scaleFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _TariffInformation_rateElements = SEQ_OF(name='rateElements', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TariffInformation_rateElements__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RateElement')))
    _TariffInformation_rateElements._cont = __TariffInformation_rateElements__item_
    TariffInformation._cont = ASN1Dict([
        ('currencyCode', _TariffInformation_currencyCode),
        ('scaleFactor', _TariffInformation_scaleFactor),
        ('rateElements', _TariffInformation_rateElements),
        ])
    TariffInformation._ext = None
    
    #-----< TransitIOILists >-----#
    TransitIOILists = SEQ_OF(name='TransitIOILists', mode=MODE_TYPE)
    _TransitIOILists__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    TransitIOILists._cont = _TransitIOILists__item_
    
    #-----< TransmissionMedium >-----#
    TransmissionMedium = SEQ(name='TransmissionMedium', mode=MODE_TYPE)
    _TransmissionMedium_tMR = OCT_STR(name='tMR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TransmissionMedium_tMR._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _TransmissionMedium_tMU = OCT_STR(name='tMU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TransmissionMedium_tMU._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    TransmissionMedium._cont = ASN1Dict([
        ('tMR', _TransmissionMedium_tMR),
        ('tMU', _TransmissionMedium_tMU),
        ])
    TransmissionMedium._ext = None
    
    #-----< TrunkGroupID >-----#
    TrunkGroupID = CHOICE(name='TrunkGroupID', mode=MODE_TYPE)
    _TrunkGroupID_incoming = STR_GRAPH(name='incoming', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrunkGroupID_outgoing = STR_GRAPH(name='outgoing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TrunkGroupID._cont = ASN1Dict([
        ('incoming', _TrunkGroupID_incoming),
        ('outgoing', _TrunkGroupID_outgoing),
        ])
    TrunkGroupID._ext = None
    
    _all_ = [
        _IMSRecord_sCSCFRecord,
        _IMSRecord_pCSCFRecord,
        _IMSRecord_iCSCFRecord,
        _IMSRecord_mRFCRecord,
        _IMSRecord_mGCFRecord,
        _IMSRecord_bGCFRecord,
        _IMSRecord_aSRecord,
        _IMSRecord_eCSCFRecord,
        _IMSRecord_iBCFRecord,
        _IMSRecord_tRFRecord,
        _IMSRecord_tFRecord,
        _IMSRecord_aTCFRecord,
        IMSRecord,
        _SCSCFRecord_recordType,
        _SCSCFRecord_retransmission,
        _SCSCFRecord_sIP_Method,
        _SCSCFRecord_role_of_Node,
        _SCSCFRecord_nodeAddress,
        _SCSCFRecord_session_Id,
        _SCSCFRecord_list_Of_Calling_Party_Address,
        _SCSCFRecord_called_Party_Address,
        _SCSCFRecord_privateUserID,
        _SCSCFRecord_serviceRequestTimeStamp,
        _SCSCFRecord_serviceDeliveryStartTimeStamp,
        _SCSCFRecord_serviceDeliveryEndTimeStamp,
        _SCSCFRecord_recordOpeningTime,
        _SCSCFRecord_recordClosureTime,
        _SCSCFRecord_interOperatorIdentifiers,
        _SCSCFRecord_localRecordSequenceNumber,
        _SCSCFRecord_recordSequenceNumber,
        _SCSCFRecord_causeForRecordClosing,
        _SCSCFRecord_incomplete_CDR_Indication,
        _SCSCFRecord_iMS_Charging_Identifier,
        __SCSCFRecord_list_Of_SDP_Media_Components__item_,
        _SCSCFRecord_list_Of_SDP_Media_Components,
        _SCSCFRecord_gGSNaddress,
        _SCSCFRecord_serviceReasonReturnCode,
        __SCSCFRecord_list_Of_Message_Bodies__item_,
        _SCSCFRecord_list_Of_Message_Bodies,
        _SCSCFRecord_recordExtensions,
        _SCSCFRecord_expiresInformation,
        _SCSCFRecord_list_Of_Associated_URI,
        _SCSCFRecord_event,
        _SCSCFRecord_accessNetworkInformation,
        _SCSCFRecord_serviceContextID,
        __SCSCFRecord_list_of_subscription_ID__item_,
        _SCSCFRecord_list_of_subscription_ID,
        __SCSCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _SCSCFRecord_list_Of_Early_SDP_Media_Components,
        _SCSCFRecord_iMSCommunicationServiceIdentifier,
        _SCSCFRecord_numberPortabilityRouting,
        _SCSCFRecord_carrierSelectRouting,
        _SCSCFRecord_sessionPriority,
        _SCSCFRecord_serviceRequestTimeStampFraction,
        _SCSCFRecord_serviceDeliveryStartTimeStampFraction,
        _SCSCFRecord_serviceDeliveryEndTimeStampFraction,
        __SCSCFRecord_applicationServersInformation__item_,
        _SCSCFRecord_applicationServersInformation,
        _SCSCFRecord_requested_Party_Address,
        _SCSCFRecord_list_Of_Called_Asserted_Identity,
        _SCSCFRecord_online_charging_flag,
        __SCSCFRecord_realTimeTariffInformation__item_,
        _SCSCFRecord_realTimeTariffInformation,
        _SCSCFRecord_userLocationInformation,
        _SCSCFRecord_mSTimeZone,
        _SCSCFRecord_nNI_Information,
        _SCSCFRecord_fromAddress,
        _SCSCFRecord_iMSEmergencyIndicator,
        _SCSCFRecord_transit_IOI_Lists,
        _SCSCFRecord_iMSVisitedNetworkIdentifier,
        _SCSCFRecord_listOfReasonHeader,
        _SCSCFRecord_additionalAccessNetworkInformation,
        _SCSCFRecord_instanceId,
        _SCSCFRecord_subscriberEquipmentNumber,
        _SCSCFRecord_routeHeaderReceived,
        _SCSCFRecord_routeHeaderTransmitted,
        __SCSCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _SCSCFRecord_list_Of_AccessNetworkInfoChange,
        __SCSCFRecord_listOfCalledIdentityChanges__item_,
        _SCSCFRecord_listOfCalledIdentityChanges,
        _SCSCFRecord_cellularNetworkInformation,
        _SCSCFRecord_fEIdentifierList,
        SCSCFRecord,
        _PCSCFRecord_recordType,
        _PCSCFRecord_retransmission,
        _PCSCFRecord_sIP_Method,
        _PCSCFRecord_role_of_Node,
        _PCSCFRecord_nodeAddress,
        _PCSCFRecord_session_Id,
        _PCSCFRecord_list_Of_Calling_Party_Address,
        _PCSCFRecord_called_Party_Address,
        _PCSCFRecord_privateUserID,
        _PCSCFRecord_serviceRequestTimeStamp,
        _PCSCFRecord_serviceDeliveryStartTimeStamp,
        _PCSCFRecord_serviceDeliveryEndTimeStamp,
        _PCSCFRecord_recordOpeningTime,
        _PCSCFRecord_recordClosureTime,
        _PCSCFRecord_interOperatorIdentifiers,
        _PCSCFRecord_localRecordSequenceNumber,
        _PCSCFRecord_recordSequenceNumber,
        _PCSCFRecord_causeForRecordClosing,
        _PCSCFRecord_incomplete_CDR_Indication,
        _PCSCFRecord_iMS_Charging_Identifier,
        __PCSCFRecord_list_Of_SDP_Media_Components__item_,
        _PCSCFRecord_list_Of_SDP_Media_Components,
        _PCSCFRecord_gGSNaddress,
        _PCSCFRecord_serviceReasonReturnCode,
        __PCSCFRecord_list_Of_Message_Bodies__item_,
        _PCSCFRecord_list_Of_Message_Bodies,
        _PCSCFRecord_recordExtensions,
        _PCSCFRecord_expiresInformation,
        _PCSCFRecord_list_Of_Associated_URI,
        _PCSCFRecord_event,
        _PCSCFRecord_accessNetworkInformation,
        _PCSCFRecord_serviceContextID,
        __PCSCFRecord_list_of_subscription_ID__item_,
        _PCSCFRecord_list_of_subscription_ID,
        __PCSCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _PCSCFRecord_list_Of_Early_SDP_Media_Components,
        _PCSCFRecord_iMSCommunicationServiceIdentifier,
        _PCSCFRecord_sessionPriority,
        _PCSCFRecord_serviceRequestTimeStampFraction,
        _PCSCFRecord_serviceDeliveryStartTimeStampFraction,
        _PCSCFRecord_serviceDeliveryEndTimeStampFraction,
        _PCSCFRecord_list_of_Requested_Party_Address,
        _PCSCFRecord_list_Of_Called_Asserted_Identity,
        _PCSCFRecord_nNI_Information,
        _PCSCFRecord_userLocationInformation,
        _PCSCFRecord_mSTimeZone,
        _PCSCFRecord_servedPartyIPAddress,
        _PCSCFRecord_fromAddress,
        _PCSCFRecord_iMSEmergencyIndicator,
        _PCSCFRecord_transit_IOI_Lists,
        _PCSCFRecord_iMSVisitedNetworkIdentifier,
        _PCSCFRecord_listOfReasonHeader,
        _PCSCFRecord_additionalAccessNetworkInformation,
        _PCSCFRecord_instanceId,
        _PCSCFRecord_subscriberEquipmentNumber,
        _PCSCFRecord_routeHeaderReceived,
        _PCSCFRecord_routeHeaderTransmitted,
        __PCSCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _PCSCFRecord_list_Of_AccessNetworkInfoChange,
        __PCSCFRecord_listOfCalledIdentityChanges__item_,
        _PCSCFRecord_listOfCalledIdentityChanges,
        _PCSCFRecord_cellularNetworkInformation,
        _PCSCFRecord_initialIMS_Charging_Identifier,
        __PCSCFRecord_list_Of_AccessTransferInformation__item_,
        _PCSCFRecord_list_Of_AccessTransferInformation,
        _PCSCFRecord_relatedICID,
        _PCSCFRecord_relatedICIDGenerationNode,
        _PCSCFRecord_fEIdentifierList,
        PCSCFRecord,
        _ICSCFRecord_recordType,
        _ICSCFRecord_retransmission,
        _ICSCFRecord_sIP_Method,
        _ICSCFRecord_role_of_Node,
        _ICSCFRecord_nodeAddress,
        _ICSCFRecord_session_Id,
        _ICSCFRecord_list_Of_Calling_Party_Address,
        _ICSCFRecord_called_Party_Address,
        _ICSCFRecord_serviceRequestTimeStamp,
        _ICSCFRecord_interOperatorIdentifiers,
        _ICSCFRecord_localRecordSequenceNumber,
        _ICSCFRecord_causeForRecordClosing,
        _ICSCFRecord_incomplete_CDR_Indication,
        _ICSCFRecord_iMS_Charging_Identifier,
        _ICSCFRecord_serviceReasonReturnCode,
        _ICSCFRecord_recordExtensions,
        _ICSCFRecord_expiresInformation,
        _ICSCFRecord_list_Of_Associated_URI,
        _ICSCFRecord_event,
        _ICSCFRecord_accessNetworkInformation,
        _ICSCFRecord_serviceContextID,
        _ICSCFRecord_numberPortabilityRouting,
        _ICSCFRecord_carrierSelectRouting,
        _ICSCFRecord_sessionPriority,
        _ICSCFRecord_serviceRequestTimeStampFraction,
        _ICSCFRecord_transit_IOI_List,
        _ICSCFRecord_userLocationInformation,
        _ICSCFRecord_mSTimeZone,
        _ICSCFRecord_fromAddress,
        _ICSCFRecord_iMSEmergencyIndicator,
        _ICSCFRecord_listOfReasonHeader,
        _ICSCFRecord_additionalAccessNetworkInformation,
        _ICSCFRecord_routeHeaderTransmitted,
        _ICSCFRecord_s_CSCF_Information,
        _ICSCFRecord_cellularNetworkInformation,
        _ICSCFRecord_fEIdentifierList,
        ICSCFRecord,
        _MRFCRecord_recordType,
        _MRFCRecord_retransmission,
        _MRFCRecord_sIP_Method,
        _MRFCRecord_nodeAddress,
        _MRFCRecord_session_Id,
        _MRFCRecord_list_Of_Calling_Party_Address,
        _MRFCRecord_called_Party_Address,
        _MRFCRecord_serviceRequestTimeStamp,
        _MRFCRecord_serviceDeliveryStartTimeStamp,
        _MRFCRecord_serviceDeliveryEndTimeStamp,
        _MRFCRecord_recordOpeningTime,
        _MRFCRecord_recordClosureTime,
        _MRFCRecord_interOperatorIdentifiers,
        _MRFCRecord_localRecordSequenceNumber,
        _MRFCRecord_recordSequenceNumber,
        _MRFCRecord_causeForRecordClosing,
        _MRFCRecord_incomplete_CDR_Indication,
        _MRFCRecord_iMS_Charging_Identifier,
        __MRFCRecord_list_Of_SDP_Media_Components__item_,
        _MRFCRecord_list_Of_SDP_Media_Components,
        _MRFCRecord_gGSNaddress,
        _MRFCRecord_serviceReasonReturnCode,
        _MRFCRecord_recordExtensions,
        _MRFCRecord_expiresInformation,
        _MRFCRecord_event,
        _MRFCRecord_accessNetworkInformation,
        _MRFCRecord_serviceContextID,
        __MRFCRecord_list_of_subscription_ID__item_,
        _MRFCRecord_list_of_subscription_ID,
        __MRFCRecord_list_Of_Early_SDP_Media_Components__item_,
        _MRFCRecord_list_Of_Early_SDP_Media_Components,
        _MRFCRecord_sessionPriority,
        _MRFCRecord_serviceRequestTimeStampFraction,
        _MRFCRecord_serviceDeliveryStartTimeStampFraction,
        _MRFCRecord_serviceDeliveryEndTimeStampFraction,
        __MRFCRecord_applicationServersInformation__item_,
        _MRFCRecord_applicationServersInformation,
        _MRFCRecord_online_charging_flag,
        _MRFCRecord_transit_IOI_List,
        _MRFCRecord_userLocationInformation,
        _MRFCRecord_mSTimeZone,
        _MRFCRecord_fromAddress,
        _MRFCRecord_listOfReasonHeader,
        _MRFCRecord_additionalAccessNetworkInformation,
        __MRFCRecord_list_Of_AccessNetworkInfoChange__item_,
        _MRFCRecord_list_Of_AccessNetworkInfoChange,
        _MRFCRecord_cellularNetworkInformation,
        _MRFCRecord_service_Id,
        _MRFCRecord_requested_Party_Address,
        _MRFCRecord_list_Of_Called_Asserted_Identity,
        _MRFCRecord_fEIdentifierList,
        MRFCRecord,
        _MGCFRecord_recordType,
        _MGCFRecord_retransmission,
        _MGCFRecord_sIP_Method,
        _MGCFRecord_role_of_Node,
        _MGCFRecord_nodeAddress,
        _MGCFRecord_session_Id,
        _MGCFRecord_list_Of_Calling_Party_Address,
        _MGCFRecord_called_Party_Address,
        _MGCFRecord_serviceRequestTimeStamp,
        _MGCFRecord_serviceDeliveryStartTimeStamp,
        _MGCFRecord_serviceDeliveryEndTimeStamp,
        _MGCFRecord_recordOpeningTime,
        _MGCFRecord_recordClosureTime,
        _MGCFRecord_interOperatorIdentifiers,
        _MGCFRecord_localRecordSequenceNumber,
        _MGCFRecord_recordSequenceNumber,
        _MGCFRecord_causeForRecordClosing,
        _MGCFRecord_incomplete_CDR_Indication,
        _MGCFRecord_iMS_Charging_Identifier,
        __MGCFRecord_list_Of_SDP_Media_Components__item_,
        _MGCFRecord_list_Of_SDP_Media_Components,
        _MGCFRecord_serviceReasonReturnCode,
        _MGCFRecord_recordExtensions,
        _MGCFRecord_expiresInformation,
        _MGCFRecord_event,
        _MGCFRecord_accessNetworkInformation,
        _MGCFRecord_serviceContextID,
        __MGCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _MGCFRecord_list_Of_Early_SDP_Media_Components,
        _MGCFRecord_numberPortabilityRouting,
        _MGCFRecord_carrierSelectRouting,
        _MGCFRecord_sessionPriority,
        _MGCFRecord_serviceRequestTimeStampFraction,
        _MGCFRecord_serviceDeliveryStartTimeStampFraction,
        _MGCFRecord_serviceDeliveryEndTimeStampFraction,
        __MGCFRecord_realTimeTariffInformation__item_,
        _MGCFRecord_realTimeTariffInformation,
        _MGCFRecord_transit_IOI_List,
        _MGCFRecord_fromAddress,
        _MGCFRecord_listOfReasonHeader,
        _MGCFRecord_additionalAccessNetworkInformation,
        __MGCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _MGCFRecord_list_Of_AccessNetworkInfoChange,
        _MGCFRecord_cellularNetworkInformation,
        _MGCFRecord_trunkGroupID,
        _MGCFRecord_bearerService,
        _MGCFRecord_iSUPCause,
        _MGCFRecord_fEIdentifierList,
        MGCFRecord,
        _BGCFRecord_recordType,
        _BGCFRecord_retransmission,
        _BGCFRecord_sIP_Method,
        _BGCFRecord_role_of_Node,
        _BGCFRecord_nodeAddress,
        _BGCFRecord_session_Id,
        _BGCFRecord_list_Of_Calling_Party_Address,
        _BGCFRecord_called_Party_Address,
        _BGCFRecord_serviceRequestTimeStamp,
        _BGCFRecord_interOperatorIdentifiers,
        _BGCFRecord_localRecordSequenceNumber,
        _BGCFRecord_causeForRecordClosing,
        _BGCFRecord_incomplete_CDR_Indication,
        _BGCFRecord_iMS_Charging_Identifier,
        _BGCFRecord_serviceReasonReturnCode,
        _BGCFRecord_recordExtensions,
        _BGCFRecord_expiresInformation,
        _BGCFRecord_event,
        _BGCFRecord_accessNetworkInformation,
        _BGCFRecord_serviceContextID,
        _BGCFRecord_numberPortabilityRouting,
        _BGCFRecord_carrierSelectRouting,
        _BGCFRecord_sessionPriority,
        _BGCFRecord_serviceRequestTimeStampFraction,
        _BGCFRecord_serviceDeliveryStartTimeStampFraction,
        _BGCFRecord_serviceDeliveryEndTimeStampFraction,
        _BGCFRecord_transit_IOI_List,
        _BGCFRecord_nNI_Information,
        _BGCFRecord_fromAddress,
        _BGCFRecord_listOfReasonHeader,
        _BGCFRecord_additionalAccessNetworkInformation,
        _BGCFRecord_cellularNetworkInformation,
        _BGCFRecord_fEIdentifierList,
        BGCFRecord,
        _ASRecord_recordType,
        _ASRecord_retransmission,
        _ASRecord_sIP_Method,
        _ASRecord_role_of_Node,
        _ASRecord_nodeAddress,
        _ASRecord_session_Id,
        _ASRecord_list_Of_Calling_Party_Address,
        _ASRecord_called_Party_Address,
        _ASRecord_privateUserID,
        _ASRecord_serviceRequestTimeStamp,
        _ASRecord_serviceDeliveryStartTimeStamp,
        _ASRecord_serviceDeliveryEndTimeStamp,
        _ASRecord_recordOpeningTime,
        _ASRecord_recordClosureTime,
        _ASRecord_interOperatorIdentifiers,
        _ASRecord_localRecordSequenceNumber,
        _ASRecord_recordSequenceNumber,
        _ASRecord_causeForRecordClosing,
        _ASRecord_incomplete_CDR_Indication,
        _ASRecord_iMS_Charging_Identifier,
        __ASRecord_list_Of_SDP_Media_Components__item_,
        _ASRecord_list_Of_SDP_Media_Components,
        _ASRecord_gGSNaddress,
        _ASRecord_serviceReasonReturnCode,
        __ASRecord_list_Of_Message_Bodies__item_,
        _ASRecord_list_Of_Message_Bodies,
        _ASRecord_recordExtensions,
        _ASRecord_expiresInformation,
        _ASRecord_event,
        _ASRecord_accessNetworkInformation,
        _ASRecord_serviceContextID,
        __ASRecord_list_of_subscription_ID__item_,
        _ASRecord_list_of_subscription_ID,
        __ASRecord_list_Of_Early_SDP_Media_Components__item_,
        _ASRecord_list_Of_Early_SDP_Media_Components,
        _ASRecord_iMSCommunicationServiceIdentifier,
        _ASRecord_numberPortabilityRouting,
        _ASRecord_carrierSelectRouting,
        _ASRecord_sessionPriority,
        _ASRecord_serviceRequestTimeStampFraction,
        _ASRecord_serviceDeliveryStartTimeStampFraction,
        _ASRecord_serviceDeliveryEndTimeStampFraction,
        _ASRecord_list_of_Requested_Party_Address,
        _ASRecord_online_charging_flag,
        __ASRecord_realTimeTariffInformation__item_,
        _ASRecord_realTimeTariffInformation,
        _ASRecord_nNI_Information,
        _ASRecord_userLocationInformation,
        _ASRecord_mSTimeZone,
        _ASRecord_fromAddress,
        _ASRecord_transit_IOI_Lists,
        _ASRecord_iMSVisitedNetworkIdentifier,
        _ASRecord_listOfReasonHeader,
        _ASRecord_additionalAccessNetworkInformation,
        _ASRecord_instanceId,
        _ASRecord_subscriberEquipmentNumber,
        __ASRecord_list_Of_AccessNetworkInfoChange__item_,
        _ASRecord_list_Of_AccessNetworkInfoChange,
        __ASRecord_listOfCalledIdentityChanges__item_,
        _ASRecord_listOfCalledIdentityChanges,
        _ASRecord_cellularNetworkInformation,
        __ASRecord_serviceSpecificInfo__item_,
        _ASRecord_serviceSpecificInfo,
        _ASRecord_requested_Party_Address,
        _ASRecord_list_Of_Called_Asserted_Identity,
        _ASRecord_alternateChargedPartyAddress,
        _ASRecord_outgoingSessionId,
        _ASRecord_initialIMS_Charging_Identifier,
        __ASRecord_list_Of_AccessTransferInformation__item_,
        _ASRecord_list_Of_AccessTransferInformation,
        _ASRecord_tADS_Identifier,
        _ASRecord_vlr_Number,
        _ASRecord_msc_Address,
        _ASRecord_threeGPPPSDataOffStatus,
        _ASRecord_fEIdentifierList,
        ASRecord,
        _ECSCFRecord_recordType,
        _ECSCFRecord_retransmission,
        _ECSCFRecord_sIP_Method,
        _ECSCFRecord_role_of_Node,
        _ECSCFRecord_nodeAddress,
        _ECSCFRecord_session_Id,
        _ECSCFRecord_list_Of_Calling_Party_Address,
        _ECSCFRecord_called_Party_Address,
        _ECSCFRecord_serviceRequestTimeStamp,
        _ECSCFRecord_serviceDeliveryStartTimeStamp,
        _ECSCFRecord_serviceDeliveryEndTimeStamp,
        _ECSCFRecord_recordOpeningTime,
        _ECSCFRecord_recordClosureTime,
        _ECSCFRecord_interOperatorIdentifiers,
        _ECSCFRecord_localRecordSequenceNumber,
        _ECSCFRecord_recordSequenceNumber,
        _ECSCFRecord_causeForRecordClosing,
        _ECSCFRecord_incomplete_CDR_Indication,
        _ECSCFRecord_iMS_Charging_Identifier,
        __ECSCFRecord_list_Of_SDP_Media_Components__item_,
        _ECSCFRecord_list_Of_SDP_Media_Components,
        _ECSCFRecord_gGSNaddress,
        _ECSCFRecord_serviceReasonReturnCode,
        __ECSCFRecord_list_Of_Message_Bodies__item_,
        _ECSCFRecord_list_Of_Message_Bodies,
        _ECSCFRecord_recordExtensions,
        _ECSCFRecord_expiresInformation,
        _ECSCFRecord_event,
        _ECSCFRecord_accessNetworkInformation,
        _ECSCFRecord_serviceContextID,
        __ECSCFRecord_list_of_subscription_ID__item_,
        _ECSCFRecord_list_of_subscription_ID,
        __ECSCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _ECSCFRecord_list_Of_Early_SDP_Media_Components,
        _ECSCFRecord_iMSCommunicationServiceIdentifier,
        _ECSCFRecord_sessionPriority,
        _ECSCFRecord_serviceRequestTimeStampFraction,
        _ECSCFRecord_serviceDeliveryStartTimeStampFraction,
        _ECSCFRecord_serviceDeliveryEndTimeStampFraction,
        __ECSCFRecord_applicationServersInformation__item_,
        _ECSCFRecord_applicationServersInformation,
        _ECSCFRecord_requested_Party_Address,
        _ECSCFRecord_list_Of_Called_Asserted_Identity,
        _ECSCFRecord_userLocationInformation,
        _ECSCFRecord_mSTimeZone,
        _ECSCFRecord_fromAddress,
        _ECSCFRecord_transit_IOI_Lists,
        _ECSCFRecord_listOfReasonHeader,
        _ECSCFRecord_additionalAccessNetworkInformation,
        __ECSCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _ECSCFRecord_list_Of_AccessNetworkInfoChange,
        __ECSCFRecord_listOfCalledIdentityChanges__item_,
        _ECSCFRecord_listOfCalledIdentityChanges,
        _ECSCFRecord_cellularNetworkInformation,
        _ECSCFRecord_fEIdentifierList,
        ECSCFRecord,
        _IBCFRecord_recordType,
        _IBCFRecord_retransmission,
        _IBCFRecord_sIP_Method,
        _IBCFRecord_role_of_Node,
        _IBCFRecord_nodeAddress,
        _IBCFRecord_session_Id,
        _IBCFRecord_list_Of_Calling_Party_Address,
        _IBCFRecord_called_Party_Address,
        _IBCFRecord_privateUserID,
        _IBCFRecord_serviceRequestTimeStamp,
        _IBCFRecord_serviceDeliveryStartTimeStamp,
        _IBCFRecord_serviceDeliveryEndTimeStamp,
        _IBCFRecord_recordOpeningTime,
        _IBCFRecord_recordClosureTime,
        _IBCFRecord_interOperatorIdentifiers,
        _IBCFRecord_localRecordSequenceNumber,
        _IBCFRecord_recordSequenceNumber,
        _IBCFRecord_causeForRecordClosing,
        _IBCFRecord_incomplete_CDR_Indication,
        _IBCFRecord_iMS_Charging_Identifier,
        __IBCFRecord_list_Of_SDP_Media_Components__item_,
        _IBCFRecord_list_Of_SDP_Media_Components,
        _IBCFRecord_gGSNaddress,
        _IBCFRecord_serviceReasonReturnCode,
        __IBCFRecord_list_Of_Message_Bodies__item_,
        _IBCFRecord_list_Of_Message_Bodies,
        _IBCFRecord_recordExtensions,
        _IBCFRecord_expiresInformation,
        _IBCFRecord_event,
        _IBCFRecord_accessNetworkInformation,
        _IBCFRecord_serviceContextID,
        __IBCFRecord_list_of_subscription_ID__item_,
        _IBCFRecord_list_of_subscription_ID,
        __IBCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _IBCFRecord_list_Of_Early_SDP_Media_Components,
        _IBCFRecord_iMSCommunicationServiceIdentifier,
        _IBCFRecord_sessionPriority,
        _IBCFRecord_serviceRequestTimeStampFraction,
        _IBCFRecord_serviceDeliveryStartTimeStampFraction,
        _IBCFRecord_serviceDeliveryEndTimeStampFraction,
        _IBCFRecord_list_of_Requested_Party_Address,
        _IBCFRecord_list_Of_Called_Asserted_Identity,
        _IBCFRecord_transit_IOI_List,
        __IBCFRecord_nNI_Information__item_,
        _IBCFRecord_nNI_Information,
        _IBCFRecord_userLocationInformation,
        _IBCFRecord_mSTimeZone,
        _IBCFRecord_fromAddress,
        _IBCFRecord_listOfReasonHeader,
        _IBCFRecord_additionalAccessNetworkInformation,
        _IBCFRecord_routeHeaderReceived,
        __IBCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _IBCFRecord_list_Of_AccessNetworkInfoChange,
        _IBCFRecord_cellularNetworkInformation,
        _IBCFRecord_initialIMS_Charging_Identifier,
        __IBCFRecord_list_Of_AccessTransferInformation__item_,
        _IBCFRecord_list_Of_AccessTransferInformation,
        _IBCFRecord_fEIdentifierList,
        IBCFRecord,
        _TRFRecord_recordType,
        _TRFRecord_retransmission,
        _TRFRecord_sIP_Method,
        _TRFRecord_role_of_Node,
        _TRFRecord_nodeAddress,
        _TRFRecord_session_Id,
        _TRFRecord_list_Of_Calling_Party_Address,
        _TRFRecord_called_Party_Address,
        _TRFRecord_serviceRequestTimeStamp,
        _TRFRecord_serviceDeliveryStartTimeStamp,
        _TRFRecord_serviceDeliveryEndTimeStamp,
        _TRFRecord_recordOpeningTime,
        _TRFRecord_recordClosureTime,
        _TRFRecord_interOperatorIdentifiers,
        _TRFRecord_localRecordSequenceNumber,
        _TRFRecord_recordSequenceNumber,
        _TRFRecord_causeForRecordClosing,
        _TRFRecord_incomplete_CDR_Indication,
        _TRFRecord_iMS_Charging_Identifier,
        __TRFRecord_list_Of_SDP_Media_Components__item_,
        _TRFRecord_list_Of_SDP_Media_Components,
        _TRFRecord_serviceReasonReturnCode,
        __TRFRecord_list_Of_Message_Bodies__item_,
        _TRFRecord_list_Of_Message_Bodies,
        _TRFRecord_recordExtensions,
        _TRFRecord_expiresInformation,
        _TRFRecord_event,
        _TRFRecord_serviceContextID,
        __TRFRecord_list_of_subscription_ID__item_,
        _TRFRecord_list_of_subscription_ID,
        __TRFRecord_list_Of_Early_SDP_Media_Components__item_,
        _TRFRecord_list_Of_Early_SDP_Media_Components,
        _TRFRecord_iMSCommunicationServiceIdentifier,
        _TRFRecord_numberPortabilityRouting,
        _TRFRecord_carrierSelectRouting,
        _TRFRecord_sessionPriority,
        _TRFRecord_serviceRequestTimeStampFraction,
        _TRFRecord_serviceDeliveryStartTimeStampFraction,
        _TRFRecord_serviceDeliveryEndTimeStampFraction,
        __TRFRecord_applicationServersInformation__item_,
        _TRFRecord_applicationServersInformation,
        _TRFRecord_requested_Party_Address,
        _TRFRecord_list_Of_Called_Asserted_Identity,
        __TRFRecord_nNI_Information__item_,
        _TRFRecord_nNI_Information,
        _TRFRecord_userLocationInformation,
        _TRFRecord_mSTimeZone,
        _TRFRecord_transit_IOI_Lists,
        _TRFRecord_listOfReasonHeader,
        _TRFRecord_routeHeaderReceived,
        __TRFRecord_listOfCalledIdentityChanges__item_,
        _TRFRecord_listOfCalledIdentityChanges,
        _TRFRecord_fEIdentifierList,
        TRFRecord,
        _ATCFRecord_recordType,
        _ATCFRecord_retransmission,
        _ATCFRecord_sIP_Method,
        _ATCFRecord_role_of_Node,
        _ATCFRecord_nodeAddress,
        _ATCFRecord_session_Id,
        _ATCFRecord_list_Of_Calling_Party_Address,
        _ATCFRecord_called_Party_Address,
        _ATCFRecord_privateUserID,
        _ATCFRecord_serviceRequestTimeStamp,
        _ATCFRecord_serviceDeliveryStartTimeStamp,
        _ATCFRecord_serviceDeliveryEndTimeStamp,
        _ATCFRecord_recordOpeningTime,
        _ATCFRecord_recordClosureTime,
        _ATCFRecord_interOperatorIdentifiers,
        _ATCFRecord_localRecordSequenceNumber,
        _ATCFRecord_recordSequenceNumber,
        _ATCFRecord_causeForRecordClosing,
        _ATCFRecord_incomplete_CDR_Indication,
        _ATCFRecord_iMS_Charging_Identifier,
        __ATCFRecord_list_Of_SDP_Media_Components__item_,
        _ATCFRecord_list_Of_SDP_Media_Components,
        _ATCFRecord_gGSNaddress,
        _ATCFRecord_serviceReasonReturnCode,
        __ATCFRecord_list_Of_Message_Bodies__item_,
        _ATCFRecord_list_Of_Message_Bodies,
        _ATCFRecord_recordExtensions,
        _ATCFRecord_expiresInformation,
        _ATCFRecord_event,
        _ATCFRecord_accessNetworkInformation,
        _ATCFRecord_serviceContextID,
        __ATCFRecord_list_of_subscription_ID__item_,
        _ATCFRecord_list_of_subscription_ID,
        __ATCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _ATCFRecord_list_Of_Early_SDP_Media_Components,
        _ATCFRecord_iMSCommunicationServiceIdentifier,
        _ATCFRecord_sessionPriority,
        _ATCFRecord_serviceRequestTimeStampFraction,
        _ATCFRecord_serviceDeliveryStartTimeStampFraction,
        _ATCFRecord_serviceDeliveryEndTimeStampFraction,
        _ATCFRecord_list_of_Requested_Party_Address,
        _ATCFRecord_list_Of_Called_Asserted_Identity,
        _ATCFRecord_nNI_Information,
        _ATCFRecord_userLocationInformation,
        _ATCFRecord_mSTimeZone,
        _ATCFRecord_fromAddress,
        _ATCFRecord_listOfReasonHeader,
        _ATCFRecord_additionalAccessNetworkInformation,
        _ATCFRecord_routeHeaderReceived,
        _ATCFRecord_routeHeaderTransmitted,
        __ATCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _ATCFRecord_list_Of_AccessNetworkInfoChange,
        __ATCFRecord_listOfCalledIdentityChanges__item_,
        _ATCFRecord_listOfCalledIdentityChanges,
        _ATCFRecord_cellularNetworkInformation,
        _ATCFRecord_initialIMS_Charging_Identifier,
        __ATCFRecord_list_Of_AccessTransferInformation__item_,
        _ATCFRecord_list_Of_AccessTransferInformation,
        _ATCFRecord_fEIdentifierList,
        ATCFRecord,
        _TFRecord_recordType,
        _TFRecord_retransmission,
        _TFRecord_sIP_Method,
        _TFRecord_role_of_Node,
        _TFRecord_nodeAddress,
        _TFRecord_session_Id,
        _TFRecord_list_Of_Calling_Party_Address,
        _TFRecord_called_Party_Address,
        _TFRecord_serviceRequestTimeStamp,
        _TFRecord_serviceDeliveryStartTimeStamp,
        _TFRecord_serviceDeliveryEndTimeStamp,
        _TFRecord_recordOpeningTime,
        _TFRecord_recordClosureTime,
        _TFRecord_interOperatorIdentifiers,
        _TFRecord_localRecordSequenceNumber,
        _TFRecord_recordSequenceNumber,
        _TFRecord_causeForRecordClosing,
        _TFRecord_incomplete_CDR_Indication,
        _TFRecord_iMS_Charging_Identifier,
        __TFRecord_list_Of_SDP_Media_Components__item_,
        _TFRecord_list_Of_SDP_Media_Components,
        _TFRecord_serviceReasonReturnCode,
        __TFRecord_list_Of_Message_Bodies__item_,
        _TFRecord_list_Of_Message_Bodies,
        _TFRecord_recordExtensions,
        _TFRecord_expiresInformation,
        _TFRecord_event,
        _TFRecord_serviceContextID,
        __TFRecord_list_Of_Early_SDP_Media_Components__item_,
        _TFRecord_list_Of_Early_SDP_Media_Components,
        _TFRecord_iMSCommunicationServiceIdentifier,
        _TFRecord_numberPortabilityRouting,
        _TFRecord_carrierSelectRouting,
        _TFRecord_sessionPriority,
        _TFRecord_serviceRequestTimeStampFraction,
        _TFRecord_serviceDeliveryStartTimeStampFraction,
        _TFRecord_serviceDeliveryEndTimeStampFraction,
        __TFRecord_applicationServersInformation__item_,
        _TFRecord_applicationServersInformation,
        _TFRecord_requested_Party_Address,
        _TFRecord_list_Of_Called_Asserted_Identity,
        _TFRecord_nNI_Information,
        _TFRecord_fromAddress,
        _TFRecord_transit_IOI_Lists,
        _TFRecord_listOfReasonHeader,
        _TFRecord_routeHeaderReceived,
        _TFRecord_routeHeaderTransmitted,
        __TFRecord_listOfCalledIdentityChanges__item_,
        _TFRecord_listOfCalledIdentityChanges,
        _TFRecord_fEIdentifierList,
        TFRecord,
        _AccessCorrelationID_gPRS_Charging_Id,
        _AccessCorrelationID_accessNetworkChargingIdentifier,
        AccessCorrelationID,
        _AccessNetworkInfoChange_accessNetworkInformation,
        _AccessNetworkInfoChange_additionalAccessNetworkInformation,
        _AccessNetworkInfoChange_accessChangeTime,
        _AccessNetworkInfoChange_cellularNetworkInformation,
        AccessNetworkInfoChange,
        AccessTransferType,
        _AccessTransferInformation_accessTransferType,
        _AccessTransferInformation_accessNetworkInformation,
        _AccessTransferInformation_additionalAccessNetworkInformation,
        _AccessTransferInformation_inter_UE_Transfer,
        _AccessTransferInformation_relatedICID,
        _AccessTransferInformation_relatedICIDGenerationNode,
        _AccessTransferInformation_accessTransferTime,
        _AccessTransferInformation_subscriberEquipmentNumber,
        _AccessTransferInformation_instanceId,
        _AccessTransferInformation_cellularNetworkInformation,
        AccessTransferInformation,
        ACRInterimLost,
        _AoCCostInformation_accumulatedCost,
        _AoCCostInformation_incrementalCost,
        _AoCCostInformation_currencyCode,
        AoCCostInformation,
        _AoCInformation_tariffInformation,
        _AoCInformation_aoCCostInformation,
        AoCInformation,
        _ApplicationServersInformation_applicationServersInvolved,
        __ApplicationServersInformation_applicationProvidedCalledParties__item_,
        _ApplicationServersInformation_applicationProvidedCalledParties,
        _ApplicationServersInformation_sTatus,
        ApplicationServersInformation,
        _CalledIdentityChange_calledIdentity,
        _CalledIdentityChange_changeTime,
        CalledIdentityChange,
        CarrierSelectRouting,
        CauseForRecordClosing,
        _Early_Media_Components_List_sDP_Offer_Timestamp,
        _Early_Media_Components_List_sDP_Answer_Timestamp,
        __Early_Media_Components_List_sDP_Media_Components__item_,
        _Early_Media_Components_List_sDP_Media_Components,
        _Early_Media_Components_List_mediaInitiatorFlag,
        __Early_Media_Components_List_sDP_Session_Description__item_,
        _Early_Media_Components_List_sDP_Session_Description,
        _Early_Media_Components_List_sDP_Type,
        Early_Media_Components_List,
        _FEIdentifierList__item_,
        FEIdentifierList,
        IMS_Charging_Identifier,
        IMSCommunicationServiceIdentifier,
        _Incomplete_CDR_Indication_aCRStartLost,
        _Incomplete_CDR_Indication_aCRInterimLost,
        _Incomplete_CDR_Indication_aCRStopLost,
        Incomplete_CDR_Indication,
        _InterOperatorIdentifierList__item_,
        InterOperatorIdentifierList,
        _InterOperatorIdentifiers_originatingIOI,
        _InterOperatorIdentifiers_terminatingIOI,
        InterOperatorIdentifiers,
        _ISUPCause_iSUPCauseLocation,
        _ISUPCause_iSUPCauseValue,
        _ISUPCause_iSUPCauseDiagnostics,
        ISUPCause,
        _ListOfInvolvedParties__item_,
        ListOfInvolvedParties,
        _ListOfReasonHeader__item_,
        ListOfReasonHeader,
        _Media_Components_List_sIP_Request_Timestamp,
        _Media_Components_List_sIP_Response_Timestamp,
        __Media_Components_List_sDP_Media_Components__item_,
        _Media_Components_List_sDP_Media_Components,
        _Media_Components_List_mediaInitiatorFlag,
        __Media_Components_List_sDP_Session_Description__item_,
        _Media_Components_List_sDP_Session_Description,
        _Media_Components_List_mediaInitiatorParty,
        _Media_Components_List_sIP_Request_Timestamp_Fraction,
        _Media_Components_List_sIP_Response_Timestamp_Fraction,
        _Media_Components_List_sDP_Type,
        Media_Components_List,
        _MessageBody_content_Type,
        _MessageBody_content_Disposition,
        _MessageBody_content_Length,
        _MessageBody_originator,
        MessageBody,
        Milliseconds,
        _NNI_Information_sessionDirection,
        _NNI_Information_nNIType,
        _NNI_Information_relationshipMode,
        _NNI_Information_neighbourNodeAddress,
        NNI_Information,
        NNIType,
        NumberPortabilityRouting,
        _RateElement_unitType,
        _RateElement_unitValue,
        _RateElement_unitCost,
        _RateElement_unitQuotaThreshold,
        RateElement,
        _RealTimeTariffInformation_tariffInformation,
        _RealTimeTariffInformation_tariffXml,
        RealTimeTariffInformation,
        ReasonHeaderInformation,
        RelationshipMode,
        Role_of_Node,
        __S_CSCF_Information_mandatoryCapabilities__item_,
        _S_CSCF_Information_mandatoryCapabilities,
        __S_CSCF_Information_optionalCapabilities__item_,
        _S_CSCF_Information_optionalCapabilities,
        _S_CSCF_Information_serverName,
        S_CSCF_Information,
        _SDP_Media_Component_sDP_Media_Name,
        _SDP_Media_Component_sDP_Media_Descriptions,
        _SDP_Media_Component_accessCorrelationID,
        _SDP_Media_Component_localGWInsertedIndication,
        _SDP_Media_Component_iPRealmDefaultIndication,
        _SDP_Media_Component_transcoderInsertedIndication,
        SDP_Media_Component,
        _SDP_Media_Description__item_,
        SDP_Media_Description,
        ServedPartyIPAddress,
        Service_Id,
        SessionDirection,
        SessionPriority,
        SIP_Method,
        SDP_Type,
        Status,
        TADIdentifier,
        _TariffInformation_currencyCode,
        _TariffInformation_scaleFactor,
        __TariffInformation_rateElements__item_,
        _TariffInformation_rateElements,
        TariffInformation,
        _TransitIOILists__item_,
        TransitIOILists,
        _TransmissionMedium_tMR,
        _TransmissionMedium_tMU,
        TransmissionMedium,
        _TrunkGroupID_incoming,
        _TrunkGroupID_outgoing,
        TrunkGroupID,
    ]

class InformationFramework:

    _name_  = 'InformationFramework'
    _oid_   = [2, 5, 1, 1, 8]
    
    _obj_ = [
        'Attribute',
        'AttributeType',
        'AttributeValue',
        'Context',
        'AttributeValueAssertion',
        'ContextAssertion',
        'AttributeTypeAssertion',
        'SupportedAttributes',
        'SupportedContexts',
        'Name',
        'RDNSequence',
        'DistinguishedName',
        'RelativeDistinguishedName',
        'AttributeTypeAndValue',
        'SubtreeSpecification',
        'LocalName',
        'ChopSpecification',
        'BaseDistance',
        'Refinement',
        'OBJECT-CLASS',
        'ObjectClassKind',
        'top',
        'alias',
        'parent',
        'child',
        'ATTRIBUTE',
        'AttributeUsage',
        'objectClass',
        'aliasedEntryName',
        'MATCHING-RULE',
        'objectIdentifierMatch',
        'distinguishedNameMatch',
        'MAPPING-BASED-MATCHING',
        'NAME-FORM',
        'DITStructureRule',
        'RuleIdentifier',
        'STRUCTURE-RULE',
        'DITContentRule',
        'CONTENT-RULE',
        'CONTEXT',
        'DITContextUse',
        'DIT-CONTEXT-USE-RULE',
        'FRIENDS',
        'SYNTAX-NAME',
        'subentry',
        'subentryNameForm',
        'subtreeSpecification',
        'administrativeRole',
        'createTimestamp',
        'modifyTimestamp',
        'subschemaTimestamp',
        'creatorsName',
        'modifiersName',
        'subschemaSubentryList',
        'accessControlSubentryList',
        'collectiveAttributeSubentryList',
        'contextDefaultSubentryList',
        'serviceAdminSubentryList',
        'pwdAdminSubentryList',
        'hasSubordinates',
        'accessControlSubentry',
        'collectiveAttributeSubentry',
        'collectiveExclusions',
        'contextAssertionSubentry',
        'contextAssertionDefaults',
        'serviceAdminSubentry',
        'searchRules',
        'SearchRuleDescription',
        'pwdAdminSubentry',
        'pwdAttribute',
        'pwdHistory',
        'PwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        'hierarchyLevel',
        'HierarchyLevel',
        'hierarchyBelow',
        'HierarchyBelow',
        'hierarchyParent',
        'hierarchyTop',
        'id-oc-top',
        'id-oc-alias',
        'id-oc-parent',
        'id-oc-child',
        'id-at-objectClass',
        'id-at-aliasedEntryName',
        'id-at-pwdAttribute',
        'id-mr-objectIdentifierMatch',
        'id-mr-distinguishedNameMatch',
        'id-oa-excludeAllCollectiveAttributes',
        'id-oa-createTimestamp',
        'id-oa-modifyTimestamp',
        'id-oa-creatorsName',
        'id-oa-modifiersName',
        'id-oa-administrativeRole',
        'id-oa-subtreeSpecification',
        'id-oa-collectiveExclusions',
        'id-oa-subschemaTimestamp',
        'id-oa-hasSubordinates',
        'id-oa-subschemaSubentryList',
        'id-oa-accessControlSubentryList',
        'id-oa-collectiveAttributeSubentryList',
        'id-oa-contextDefaultSubentryList',
        'id-oa-contextAssertionDefault',
        'id-oa-serviceAdminSubentryList',
        'id-oa-searchRules',
        'id-oa-hierarchyLevel',
        'id-oa-hierarchyBelow',
        'id-oa-hierarchyParent',
        'id-oa-hierarchyTop',
        'id-oa-pwdAdminSubentryList',
        'id-oa-allAttributeTypes',
        'id-sc-subentry',
        'id-sc-accessControlSubentry',
        'id-sc-collectiveAttributeSubentry',
        'id-sc-contextAssertionSubentry',
        'id-sc-serviceAdminSubentry',
        'id-sc-pwdAdminSubentry',
        'id-nf-subentryNameForm',
        'id-ar-autonomousArea',
        'id-ar-accessControlSpecificArea',
        'id-ar-accessControlInnerArea',
        'id-ar-subschemaAdminSpecificArea',
        'id-ar-collectiveAttributeSpecificArea',
        'id-ar-collectiveAttributeInnerArea',
        'id-ar-contextDefaultSpecificArea',
        'id-ar-serviceSpecificArea',
        'id-ar-pwdAdminSpecificArea',
        ]
    _type_ = [
        'Attribute',
        'AttributeType',
        'AttributeValue',
        'Context',
        'AttributeValueAssertion',
        'ContextAssertion',
        'AttributeTypeAssertion',
        'Name',
        'RDNSequence',
        'DistinguishedName',
        'RelativeDistinguishedName',
        'AttributeTypeAndValue',
        'SubtreeSpecification',
        'LocalName',
        'ChopSpecification',
        'BaseDistance',
        'Refinement',
        'OBJECT-CLASS',
        'ObjectClassKind',
        'ATTRIBUTE',
        'AttributeUsage',
        'MATCHING-RULE',
        'MAPPING-BASED-MATCHING',
        'NAME-FORM',
        'DITStructureRule',
        'RuleIdentifier',
        'STRUCTURE-RULE',
        'DITContentRule',
        'CONTENT-RULE',
        'CONTEXT',
        'DITContextUse',
        'DIT-CONTEXT-USE-RULE',
        'FRIENDS',
        'SYNTAX-NAME',
        'SearchRuleDescription',
        'PwdHistory',
        'HierarchyLevel',
        'HierarchyBelow',
        ]
    _set_ = [
        'SupportedAttributes',
        'SupportedContexts',
        ]
    _val_ = [
        'top',
        'alias',
        'parent',
        'child',
        'objectClass',
        'aliasedEntryName',
        'objectIdentifierMatch',
        'distinguishedNameMatch',
        'subentry',
        'subentryNameForm',
        'subtreeSpecification',
        'administrativeRole',
        'createTimestamp',
        'modifyTimestamp',
        'subschemaTimestamp',
        'creatorsName',
        'modifiersName',
        'subschemaSubentryList',
        'accessControlSubentryList',
        'collectiveAttributeSubentryList',
        'contextDefaultSubentryList',
        'serviceAdminSubentryList',
        'pwdAdminSubentryList',
        'hasSubordinates',
        'accessControlSubentry',
        'collectiveAttributeSubentry',
        'collectiveExclusions',
        'contextAssertionSubentry',
        'contextAssertionDefaults',
        'serviceAdminSubentry',
        'searchRules',
        'pwdAdminSubentry',
        'pwdAttribute',
        'pwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        'hierarchyLevel',
        'hierarchyBelow',
        'hierarchyParent',
        'hierarchyTop',
        'id-oc-top',
        'id-oc-alias',
        'id-oc-parent',
        'id-oc-child',
        'id-at-objectClass',
        'id-at-aliasedEntryName',
        'id-at-pwdAttribute',
        'id-mr-objectIdentifierMatch',
        'id-mr-distinguishedNameMatch',
        'id-oa-excludeAllCollectiveAttributes',
        'id-oa-createTimestamp',
        'id-oa-modifyTimestamp',
        'id-oa-creatorsName',
        'id-oa-modifiersName',
        'id-oa-administrativeRole',
        'id-oa-subtreeSpecification',
        'id-oa-collectiveExclusions',
        'id-oa-subschemaTimestamp',
        'id-oa-hasSubordinates',
        'id-oa-subschemaSubentryList',
        'id-oa-accessControlSubentryList',
        'id-oa-collectiveAttributeSubentryList',
        'id-oa-contextDefaultSubentryList',
        'id-oa-contextAssertionDefault',
        'id-oa-serviceAdminSubentryList',
        'id-oa-searchRules',
        'id-oa-hierarchyLevel',
        'id-oa-hierarchyBelow',
        'id-oa-hierarchyParent',
        'id-oa-hierarchyTop',
        'id-oa-pwdAdminSubentryList',
        'id-oa-allAttributeTypes',
        'id-sc-subentry',
        'id-sc-accessControlSubentry',
        'id-sc-collectiveAttributeSubentry',
        'id-sc-contextAssertionSubentry',
        'id-sc-serviceAdminSubentry',
        'id-sc-pwdAdminSubentry',
        'id-nf-subentryNameForm',
        'id-ar-autonomousArea',
        'id-ar-accessControlSpecificArea',
        'id-ar-accessControlInnerArea',
        'id-ar-subschemaAdminSpecificArea',
        'id-ar-collectiveAttributeSpecificArea',
        'id-ar-collectiveAttributeInnerArea',
        'id-ar-contextDefaultSpecificArea',
        'id-ar-serviceSpecificArea',
        'id-ar-pwdAdminSpecificArea',
        ]
    _class_ = [
        'SupportedAttributes',
        'SupportedContexts',
        'OBJECT-CLASS',
        'top',
        'alias',
        'parent',
        'child',
        'ATTRIBUTE',
        'objectClass',
        'aliasedEntryName',
        'MATCHING-RULE',
        'objectIdentifierMatch',
        'distinguishedNameMatch',
        'MAPPING-BASED-MATCHING',
        'NAME-FORM',
        'STRUCTURE-RULE',
        'CONTENT-RULE',
        'CONTEXT',
        'DIT-CONTEXT-USE-RULE',
        'FRIENDS',
        'SYNTAX-NAME',
        'subentry',
        'subentryNameForm',
        'subtreeSpecification',
        'administrativeRole',
        'createTimestamp',
        'modifyTimestamp',
        'subschemaTimestamp',
        'creatorsName',
        'modifiersName',
        'subschemaSubentryList',
        'accessControlSubentryList',
        'collectiveAttributeSubentryList',
        'contextDefaultSubentryList',
        'serviceAdminSubentryList',
        'pwdAdminSubentryList',
        'hasSubordinates',
        'accessControlSubentry',
        'collectiveAttributeSubentry',
        'collectiveExclusions',
        'contextAssertionSubentry',
        'contextAssertionDefaults',
        'serviceAdminSubentry',
        'searchRules',
        'pwdAdminSubentry',
        'pwdAttribute',
        'pwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        'hierarchyLevel',
        'hierarchyBelow',
        'hierarchyParent',
        'hierarchyTop',
        ]
    _param_ = [
        'Attribute',
        'MAPPING-BASED-MATCHING',
        'pwdHistory',
        'PwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        ]
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE, param=True)
    
    #-----< AttributeType >-----#
    AttributeType = OID(name='AttributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    
    #-----< AttributeValue >-----#
    AttributeValue = OPEN(name='AttributeValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    
    #-----< Context >-----#
    Context = SEQ(name='Context', mode=MODE_TYPE)
    _Context_contextType = OID(name='contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __Context_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __Context_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Context_contextType._const_tab = __Context_contextType_tab
    _Context_contextType._const_tab_at = None
    _Context_contextType._const_tab_id = 'id'
    _Context_contextValues = SET_OF(name='contextValues', mode=MODE_TYPE)
    __Context_contextValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['Type']))
    ___Context_contextValues__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___Context_contextValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Context_contextValues__item_._const_tab = ___Context_contextValues__item__tab
    __Context_contextValues__item_._const_tab_at = ('..', '..', 'contextType')
    __Context_contextValues__item_._const_tab_id = 'Type'
    _Context_contextValues._cont = __Context_contextValues__item_
    _Context_contextValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Context_fallback = BOOL(name='fallback', mode=MODE_TYPE, default=False)
    Context._cont = ASN1Dict([
        ('contextType', _Context_contextType),
        ('contextValues', _Context_contextValues),
        ('fallback', _Context_fallback),
        ])
    Context._ext = []
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name='AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeValueAssertion_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeValueAssertion_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ___AttributeValueAssertion_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeValueAssertion_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeValueAssertion_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeValueAssertion_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeValueAssertion_type._const_tab = __AttributeValueAssertion_type_tab
    _AttributeValueAssertion_type._const_tab_at = None
    _AttributeValueAssertion_type._const_tab_id = 'id'
    _AttributeValueAssertion_assertion = OPEN(name='assertion', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['equality-match', 'AssertionType']))
    _AttributeValueAssertion_assertion._const_tab = __AttributeValueAssertion_type_tab
    _AttributeValueAssertion_assertion._const_tab_at = ('..', 'type')
    _AttributeValueAssertion_assertion._const_tab_id = 'AssertionType'
    _AttributeValueAssertion_assertedContexts = CHOICE(name='assertedContexts', mode=MODE_TYPE, opt=True)
    __AttributeValueAssertion_assertedContexts_allContexts = NULL(name='allContexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeValueAssertion_assertedContexts_selectedContexts = SET_OF(name='selectedContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___AttributeValueAssertion_assertedContexts_selectedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __AttributeValueAssertion_assertedContexts_selectedContexts._cont = ___AttributeValueAssertion_assertedContexts_selectedContexts__item_
    __AttributeValueAssertion_assertedContexts_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeValueAssertion_assertedContexts._cont = ASN1Dict([
        ('allContexts', __AttributeValueAssertion_assertedContexts_allContexts),
        ('selectedContexts', __AttributeValueAssertion_assertedContexts_selectedContexts),
        ])
    _AttributeValueAssertion_assertedContexts._ext = None
    AttributeValueAssertion._cont = ASN1Dict([
        ('type', _AttributeValueAssertion_type),
        ('assertion', _AttributeValueAssertion_assertion),
        ('assertedContexts', _AttributeValueAssertion_assertedContexts),
        ])
    AttributeValueAssertion._ext = []
    
    #-----< ContextAssertion >-----#
    ContextAssertion = SEQ(name='ContextAssertion', mode=MODE_TYPE)
    _ContextAssertion_contextType = OID(name='contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __ContextAssertion_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextAssertion_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextAssertion_contextType._const_tab = __ContextAssertion_contextType_tab
    _ContextAssertion_contextType._const_tab_at = None
    _ContextAssertion_contextType._const_tab_id = 'id'
    _ContextAssertion_contextValues = SET_OF(name='contextValues', mode=MODE_TYPE)
    __ContextAssertion_contextValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['Assertion']))
    ___ContextAssertion_contextValues__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___ContextAssertion_contextValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ContextAssertion_contextValues__item_._const_tab = ___ContextAssertion_contextValues__item__tab
    __ContextAssertion_contextValues__item_._const_tab_at = ('..', '..', 'contextType')
    __ContextAssertion_contextValues__item_._const_tab_id = 'Assertion'
    _ContextAssertion_contextValues._cont = __ContextAssertion_contextValues__item_
    _ContextAssertion_contextValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextAssertion._cont = ASN1Dict([
        ('contextType', _ContextAssertion_contextType),
        ('contextValues', _ContextAssertion_contextValues),
        ])
    ContextAssertion._ext = []
    
    #-----< AttributeTypeAssertion >-----#
    AttributeTypeAssertion = SEQ(name='AttributeTypeAssertion', mode=MODE_TYPE)
    _AttributeTypeAssertion_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeTypeAssertion_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeAssertion_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___AttributeTypeAssertion_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeAssertion_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeTypeAssertion_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeTypeAssertion_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeAssertion_type._const_tab = __AttributeTypeAssertion_type_tab
    _AttributeTypeAssertion_type._const_tab_at = None
    _AttributeTypeAssertion_type._const_tab_id = 'id'
    _AttributeTypeAssertion_assertedContexts = SEQ_OF(name='assertedContexts', mode=MODE_TYPE, opt=True)
    __AttributeTypeAssertion_assertedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    _AttributeTypeAssertion_assertedContexts._cont = __AttributeTypeAssertion_assertedContexts__item_
    _AttributeTypeAssertion_assertedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeTypeAssertion._cont = ASN1Dict([
        ('type', _AttributeTypeAssertion_type),
        ('assertedContexts', _AttributeTypeAssertion_assertedContexts),
        ])
    AttributeTypeAssertion._ext = []
    
    #-----< SupportedAttributes >-----#
    SupportedAttributes = CLASS(name='SupportedAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _SupportedAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    SupportedAttributes._val = ASN1Set(rv=[dict([('Type', _SupportedAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _SupportedAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=[], er=[])
    
    #-----< SupportedContexts >-----#
    SupportedContexts = CLASS(name='SupportedContexts', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    SupportedContexts._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Name >-----#
    Name = CHOICE(name='Name', mode=MODE_TYPE)
    _Name_rdnSequence = SEQ_OF(name='rdnSequence', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    Name._cont = ASN1Dict([
        ('rdnSequence', _Name_rdnSequence),
        ])
    Name._ext = None
    
    #-----< RDNSequence >-----#
    RDNSequence = SEQ_OF(name='RDNSequence', mode=MODE_TYPE)
    _RDNSequence__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    RDNSequence._cont = _RDNSequence__item_
    
    #-----< DistinguishedName >-----#
    DistinguishedName = SEQ_OF(name='DistinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    
    #-----< RelativeDistinguishedName >-----#
    RelativeDistinguishedName = SET_OF(name='RelativeDistinguishedName', mode=MODE_TYPE)
    _RelativeDistinguishedName__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    RelativeDistinguishedName._cont = _RelativeDistinguishedName__item_
    RelativeDistinguishedName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttributeTypeAndValue >-----#
    AttributeTypeAndValue = SEQ(name='AttributeTypeAndValue', mode=MODE_TYPE)
    _AttributeTypeAndValue_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeTypeAndValue_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeAndValue_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___AttributeTypeAndValue_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeAndValue_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeTypeAndValue_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeTypeAndValue_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeAndValue_type._const_tab = __AttributeTypeAndValue_type_tab
    _AttributeTypeAndValue_type._const_tab_at = None
    _AttributeTypeAndValue_type._const_tab_id = 'id'
    _AttributeTypeAndValue_value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _AttributeTypeAndValue_value._const_tab = __AttributeTypeAndValue_type_tab
    _AttributeTypeAndValue_value._const_tab_at = ('..', 'type')
    _AttributeTypeAndValue_value._const_tab_id = 'Type'
    AttributeTypeAndValue._cont = ASN1Dict([
        ('type', _AttributeTypeAndValue_type),
        ('value', _AttributeTypeAndValue_value),
        ])
    AttributeTypeAndValue._ext = []
    
    #-----< SubtreeSpecification >-----#
    SubtreeSpecification = SEQ(name='SubtreeSpecification', mode=MODE_TYPE)
    _SubtreeSpecification_base = SEQ_OF(name='base', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')), default=[])
    _SubtreeSpecification_specificExclusions = SET_OF(name='specificExclusions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubtreeSpecification_specificExclusions__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___SubtreeSpecification_specificExclusions__item__chopBefore = SEQ_OF(name='chopBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    ___SubtreeSpecification_specificExclusions__item__chopAfter = SEQ_OF(name='chopAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    __SubtreeSpecification_specificExclusions__item_._cont = ASN1Dict([
        ('chopBefore', ___SubtreeSpecification_specificExclusions__item__chopBefore),
        ('chopAfter', ___SubtreeSpecification_specificExclusions__item__chopAfter),
        ])
    __SubtreeSpecification_specificExclusions__item_._ext = []
    _SubtreeSpecification_specificExclusions._cont = __SubtreeSpecification_specificExclusions__item_
    _SubtreeSpecification_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), default=0)
    _SubtreeSpecification_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), opt=True)
    _SubtreeSpecification_specificationFilter = CHOICE(name='specificationFilter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')), opt=True)
    SubtreeSpecification._cont = ASN1Dict([
        ('base', _SubtreeSpecification_base),
        ('specificExclusions', _SubtreeSpecification_specificExclusions),
        ('minimum', _SubtreeSpecification_minimum),
        ('maximum', _SubtreeSpecification_maximum),
        ('specificationFilter', _SubtreeSpecification_specificationFilter),
        ])
    SubtreeSpecification._ext = []
    
    #-----< LocalName >-----#
    LocalName = SEQ_OF(name='LocalName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    
    #-----< ChopSpecification >-----#
    ChopSpecification = SEQ(name='ChopSpecification', mode=MODE_TYPE)
    _ChopSpecification_specificExclusions = SET_OF(name='specificExclusions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChopSpecification_specificExclusions__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___ChopSpecification_specificExclusions__item__chopBefore = SEQ_OF(name='chopBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    ___ChopSpecification_specificExclusions__item__chopAfter = SEQ_OF(name='chopAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    __ChopSpecification_specificExclusions__item_._cont = ASN1Dict([
        ('chopBefore', ___ChopSpecification_specificExclusions__item__chopBefore),
        ('chopAfter', ___ChopSpecification_specificExclusions__item__chopAfter),
        ])
    __ChopSpecification_specificExclusions__item_._ext = []
    _ChopSpecification_specificExclusions._cont = __ChopSpecification_specificExclusions__item_
    _ChopSpecification_specificExclusions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ChopSpecification_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), default=0)
    _ChopSpecification_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), opt=True)
    ChopSpecification._cont = ASN1Dict([
        ('specificExclusions', _ChopSpecification_specificExclusions),
        ('minimum', _ChopSpecification_minimum),
        ('maximum', _ChopSpecification_maximum),
        ])
    ChopSpecification._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name='BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< Refinement >-----#
    Refinement = CHOICE(name='Refinement', mode=MODE_TYPE)
    _Refinement_item = OID(name='item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _Refinement_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Refinement_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    _Refinement_and_._cont = __Refinement_and___item_
    _Refinement_and_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Refinement_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Refinement_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    _Refinement_or_._cont = __Refinement_or___item_
    _Refinement_or_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Refinement_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    Refinement._cont = ASN1Dict([
        ('item', _Refinement_item),
        ('and', _Refinement_and_),
        ('or', _Refinement_or_),
        ('not', _Refinement_not_),
        ])
    Refinement._ext = []
    
    #-----< OBJECT-CLASS >-----#
    OBJECT_CLASS = CLASS(name='OBJECT-CLASS', mode=MODE_TYPE)
    _OBJECT_CLASS_Superclasses = CLASS(name='Superclasses', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')), opt=True)
    _OBJECT_CLASS_kind = ENUM(name='kind', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ObjectClassKind')), default='structural')
    _OBJECT_CLASS_MandatoryAttributes = CLASS(name='MandatoryAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _OBJECT_CLASS_OptionalAttributes = CLASS(name='OptionalAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _OBJECT_CLASS_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __OBJECT_CLASS_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _OBJECT_CLASS_ldapName._cont = __OBJECT_CLASS_ldapName__item_
    _OBJECT_CLASS_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _OBJECT_CLASS_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _OBJECT_CLASS_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    OBJECT_CLASS._cont = ASN1Dict([
        ('Superclasses', _OBJECT_CLASS_Superclasses),
        ('kind', _OBJECT_CLASS_kind),
        ('MandatoryAttributes', _OBJECT_CLASS_MandatoryAttributes),
        ('OptionalAttributes', _OBJECT_CLASS_OptionalAttributes),
        ('ldapName', _OBJECT_CLASS_ldapName),
        ('ldapDesc', _OBJECT_CLASS_ldapDesc),
        ('id', _OBJECT_CLASS_id),
        ])
    
    #-----< ObjectClassKind >-----#
    ObjectClassKind = ENUM(name='ObjectClassKind', mode=MODE_TYPE)
    ObjectClassKind._cont = ASN1Dict([('abstract', 0), ('structural', 1), ('auxiliary', 2)])
    ObjectClassKind._ext = None
    
    #-----< top >-----#
    top = CLASS(name='top', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    top._val = dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])
    
    #-----< alias >-----#
    alias = CLASS(name='alias', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    alias._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])), ('ldapName', ['alias']), ('id', (2, 5, 6, 1))])
    
    #-----< parent >-----#
    parent = CLASS(name='parent', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    parent._val = dict([('kind', 'abstract'), ('id', (2, 5, 6, 28))])
    
    #-----< child >-----#
    child = CLASS(name='child', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    child._val = dict([('kind', 'auxiliary'), ('id', (2, 5, 6, 29))])
    
    #-----< ATTRIBUTE >-----#
    ATTRIBUTE = CLASS(name='ATTRIBUTE', mode=MODE_TYPE)
    _ATTRIBUTE_derivation = CLASS(name='derivation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _ATTRIBUTE_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    _ATTRIBUTE_equality_match = CLASS(name='equality-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_ordering_match = CLASS(name='ordering-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_substrings_match = CLASS(name='substrings-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_single_valued = BOOL(name='single-valued', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_collective = BOOL(name='collective', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_dummy = BOOL(name='dummy', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_no_user_modification = BOOL(name='no-user-modification', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_usage = ENUM(name='usage', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'AttributeUsage')), default='userApplications')
    _ATTRIBUTE_ldapSyntax = OID(name='ldapSyntax', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), ['id']), opt=True)
    _ATTRIBUTE_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __ATTRIBUTE_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _ATTRIBUTE_ldapName._cont = __ATTRIBUTE_ldapName__item_
    _ATTRIBUTE_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ATTRIBUTE_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _ATTRIBUTE_obsolete = BOOL(name='obsolete', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ATTRIBUTE._cont = ASN1Dict([
        ('derivation', _ATTRIBUTE_derivation),
        ('Type', _ATTRIBUTE_Type),
        ('equality-match', _ATTRIBUTE_equality_match),
        ('ordering-match', _ATTRIBUTE_ordering_match),
        ('substrings-match', _ATTRIBUTE_substrings_match),
        ('single-valued', _ATTRIBUTE_single_valued),
        ('collective', _ATTRIBUTE_collective),
        ('dummy', _ATTRIBUTE_dummy),
        ('no-user-modification', _ATTRIBUTE_no_user_modification),
        ('usage', _ATTRIBUTE_usage),
        ('ldapSyntax', _ATTRIBUTE_ldapSyntax),
        ('ldapName', _ATTRIBUTE_ldapName),
        ('ldapDesc', _ATTRIBUTE_ldapDesc),
        ('obsolete', _ATTRIBUTE_obsolete),
        ('id', _ATTRIBUTE_id),
        ])
    
    #-----< AttributeUsage >-----#
    AttributeUsage = ENUM(name='AttributeUsage', mode=MODE_TYPE)
    AttributeUsage._cont = ASN1Dict([('userApplications', 0), ('directoryOperation', 1), ('distributedOperation', 2), ('dSAOperation', 3)])
    AttributeUsage._ext = []
    
    #-----< objectClass >-----#
    objectClass = CLASS(name='objectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _objectClass_val_Type = OID(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    objectClass._val = dict([('Type', _objectClass_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])
    
    #-----< aliasedEntryName >-----#
    aliasedEntryName = CLASS(name='aliasedEntryName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _aliasedEntryName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    aliasedEntryName._val = dict([('Type', _aliasedEntryName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])
    
    #-----< MATCHING-RULE >-----#
    MATCHING_RULE = CLASS(name='MATCHING-RULE', mode=MODE_TYPE)
    _MATCHING_RULE_ParentMatchingRules = CLASS(name='ParentMatchingRules', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _MATCHING_RULE_AssertionType = OPEN(name='AssertionType', mode=MODE_TYPE, opt=True)
    _MATCHING_RULE_uniqueMatchIndicator = CLASS(name='uniqueMatchIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _MATCHING_RULE_ldapSyntax = OID(name='ldapSyntax', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), ['id']), opt=True)
    _MATCHING_RULE_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __MATCHING_RULE_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _MATCHING_RULE_ldapName._cont = __MATCHING_RULE_ldapName__item_
    _MATCHING_RULE_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MATCHING_RULE_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _MATCHING_RULE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    MATCHING_RULE._cont = ASN1Dict([
        ('ParentMatchingRules', _MATCHING_RULE_ParentMatchingRules),
        ('AssertionType', _MATCHING_RULE_AssertionType),
        ('uniqueMatchIndicator', _MATCHING_RULE_uniqueMatchIndicator),
        ('ldapSyntax', _MATCHING_RULE_ldapSyntax),
        ('ldapName', _MATCHING_RULE_ldapName),
        ('ldapDesc', _MATCHING_RULE_ldapDesc),
        ('id', _MATCHING_RULE_id),
        ])
    
    #-----< objectIdentifierMatch >-----#
    objectIdentifierMatch = CLASS(name='objectIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _objectIdentifierMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    objectIdentifierMatch._val = dict([('AssertionType', _objectIdentifierMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])
    
    #-----< distinguishedNameMatch >-----#
    distinguishedNameMatch = CLASS(name='distinguishedNameMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _distinguishedNameMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    distinguishedNameMatch._val = dict([('AssertionType', _distinguishedNameMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])
    
    #-----< MAPPING-BASED-MATCHING >-----#
    MAPPING_BASED_MATCHING = CLASS(name='MAPPING-BASED-MATCHING', mode=MODE_TYPE, param=True)
    
    #-----< NAME-FORM >-----#
    NAME_FORM = CLASS(name='NAME-FORM', mode=MODE_TYPE)
    _NAME_FORM_namedObjectClass = CLASS(name='namedObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    _NAME_FORM_MandatoryAttributes = CLASS(name='MandatoryAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _NAME_FORM_OptionalAttributes = CLASS(name='OptionalAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _NAME_FORM_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __NAME_FORM_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _NAME_FORM_ldapName._cont = __NAME_FORM_ldapName__item_
    _NAME_FORM_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _NAME_FORM_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _NAME_FORM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    NAME_FORM._cont = ASN1Dict([
        ('namedObjectClass', _NAME_FORM_namedObjectClass),
        ('MandatoryAttributes', _NAME_FORM_MandatoryAttributes),
        ('OptionalAttributes', _NAME_FORM_OptionalAttributes),
        ('ldapName', _NAME_FORM_ldapName),
        ('ldapDesc', _NAME_FORM_ldapDesc),
        ('id', _NAME_FORM_id),
        ])
    
    #-----< DITStructureRule >-----#
    DITStructureRule = SEQ(name='DITStructureRule', mode=MODE_TYPE)
    _DITStructureRule_ruleIdentifier = INT(name='ruleIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRule_nameForm = OID(name='nameForm', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), ['id']))
    _DITStructureRule_superiorStructureRules = SET_OF(name='superiorStructureRules', mode=MODE_TYPE, opt=True)
    __DITStructureRule_superiorStructureRules__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRule_superiorStructureRules._cont = __DITStructureRule_superiorStructureRules__item_
    _DITStructureRule_superiorStructureRules._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITStructureRule._cont = ASN1Dict([
        ('ruleIdentifier', _DITStructureRule_ruleIdentifier),
        ('nameForm', _DITStructureRule_nameForm),
        ('superiorStructureRules', _DITStructureRule_superiorStructureRules),
        ])
    DITStructureRule._ext = []
    
    #-----< RuleIdentifier >-----#
    RuleIdentifier = INT(name='RuleIdentifier', mode=MODE_TYPE)
    
    #-----< STRUCTURE-RULE >-----#
    STRUCTURE_RULE = CLASS(name='STRUCTURE-RULE', mode=MODE_TYPE)
    _STRUCTURE_RULE_nameForm = CLASS(name='nameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    _STRUCTURE_RULE_SuperiorStructureRules = INT(name='SuperiorStructureRules', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'STRUCTURE-RULE'), ['id']), opt=True)
    _STRUCTURE_RULE_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    STRUCTURE_RULE._cont = ASN1Dict([
        ('nameForm', _STRUCTURE_RULE_nameForm),
        ('SuperiorStructureRules', _STRUCTURE_RULE_SuperiorStructureRules),
        ('id', _STRUCTURE_RULE_id),
        ])
    
    #-----< DITContentRule >-----#
    DITContentRule = SEQ(name='DITContentRule', mode=MODE_TYPE)
    _DITContentRule_structuralObjectClass = OID(name='structuralObjectClass', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRule_auxiliaries = SET_OF(name='auxiliaries', mode=MODE_TYPE, opt=True)
    __DITContentRule_auxiliaries__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRule_auxiliaries._cont = __DITContentRule_auxiliaries__item_
    _DITContentRule_auxiliaries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_mandatory = SET_OF(name='mandatory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_mandatory__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRule_mandatory._cont = __DITContentRule_mandatory__item_
    _DITContentRule_mandatory._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_optional = SET_OF(name='optional', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_optional__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRule_optional._cont = __DITContentRule_optional__item_
    _DITContentRule_optional._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_precluded = SET_OF(name='precluded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_precluded__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRule_precluded._cont = __DITContentRule_precluded__item_
    _DITContentRule_precluded._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContentRule._cont = ASN1Dict([
        ('structuralObjectClass', _DITContentRule_structuralObjectClass),
        ('auxiliaries', _DITContentRule_auxiliaries),
        ('mandatory', _DITContentRule_mandatory),
        ('optional', _DITContentRule_optional),
        ('precluded', _DITContentRule_precluded),
        ])
    DITContentRule._ext = []
    
    #-----< CONTENT-RULE >-----#
    CONTENT_RULE = CLASS(name='CONTENT-RULE', mode=MODE_TYPE)
    _CONTENT_RULE_structuralClass = OID(name='structuralClass', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), uniq=True)
    _CONTENT_RULE_Auxiliaries = CLASS(name='Auxiliaries', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')), opt=True)
    _CONTENT_RULE_Mandatory = CLASS(name='Mandatory', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _CONTENT_RULE_Optional = CLASS(name='Optional', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _CONTENT_RULE_Precluded = CLASS(name='Precluded', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    CONTENT_RULE._cont = ASN1Dict([
        ('structuralClass', _CONTENT_RULE_structuralClass),
        ('Auxiliaries', _CONTENT_RULE_Auxiliaries),
        ('Mandatory', _CONTENT_RULE_Mandatory),
        ('Optional', _CONTENT_RULE_Optional),
        ('Precluded', _CONTENT_RULE_Precluded),
        ])
    
    #-----< CONTEXT >-----#
    CONTEXT = CLASS(name='CONTEXT', mode=MODE_TYPE)
    _CONTEXT_Type = OPEN(name='Type', mode=MODE_TYPE)
    _CONTEXT_defaultValue = OPEN(name='defaultValue', mode=MODE_VALUE, opt=True)
    _CONTEXT_Assertion = OPEN(name='Assertion', mode=MODE_TYPE, opt=True)
    _CONTEXT_absentMatch = BOOL(name='absentMatch', mode=MODE_VALUE, default=True)
    _CONTEXT_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    CONTEXT._cont = ASN1Dict([
        ('Type', _CONTEXT_Type),
        ('defaultValue', _CONTEXT_defaultValue),
        ('Assertion', _CONTEXT_Assertion),
        ('absentMatch', _CONTEXT_absentMatch),
        ('id', _CONTEXT_id),
        ])
    
    #-----< DITContextUse >-----#
    DITContextUse = SEQ(name='DITContextUse', mode=MODE_TYPE)
    _DITContextUse_attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContextUse_mandatoryContexts = SET_OF(name='mandatoryContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUse_mandatoryContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUse_mandatoryContexts._cont = __DITContextUse_mandatoryContexts__item_
    _DITContextUse_mandatoryContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUse_optionalContexts = SET_OF(name='optionalContexts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUse_optionalContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUse_optionalContexts._cont = __DITContextUse_optionalContexts__item_
    _DITContextUse_optionalContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContextUse._cont = ASN1Dict([
        ('attributeType', _DITContextUse_attributeType),
        ('mandatoryContexts', _DITContextUse_mandatoryContexts),
        ('optionalContexts', _DITContextUse_optionalContexts),
        ])
    DITContextUse._ext = []
    
    #-----< DIT-CONTEXT-USE-RULE >-----#
    DIT_CONTEXT_USE_RULE = CLASS(name='DIT-CONTEXT-USE-RULE', mode=MODE_TYPE)
    _DIT_CONTEXT_USE_RULE_attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']), uniq=True)
    _DIT_CONTEXT_USE_RULE_Mandatory = CLASS(name='Mandatory', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')), opt=True)
    _DIT_CONTEXT_USE_RULE_Optional = CLASS(name='Optional', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')), opt=True)
    DIT_CONTEXT_USE_RULE._cont = ASN1Dict([
        ('attributeType', _DIT_CONTEXT_USE_RULE_attributeType),
        ('Mandatory', _DIT_CONTEXT_USE_RULE_Mandatory),
        ('Optional', _DIT_CONTEXT_USE_RULE_Optional),
        ])
    
    #-----< FRIENDS >-----#
    FRIENDS = CLASS(name='FRIENDS', mode=MODE_TYPE)
    _FRIENDS_anchor = OID(name='anchor', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']), uniq=True)
    _FRIENDS_Friends = CLASS(name='Friends', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    FRIENDS._cont = ASN1Dict([
        ('anchor', _FRIENDS_anchor),
        ('Friends', _FRIENDS_Friends),
        ])
    
    #-----< SYNTAX-NAME >-----#
    SYNTAX_NAME = CLASS(name='SYNTAX-NAME', mode=MODE_TYPE)
    _SYNTAX_NAME_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE)
    _SYNTAX_NAME_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    _SYNTAX_NAME_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    SYNTAX_NAME._cont = ASN1Dict([
        ('ldapDesc', _SYNTAX_NAME_ldapDesc),
        ('Type', _SYNTAX_NAME_Type),
        ('id', _SYNTAX_NAME_id),
        ])
    
    #-----< subentry >-----#
    subentry = CLASS(name='subentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __ATTRIBUTE_derivation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_equality_match_val_AssertionType_1 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_substrings_match_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subentry._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))]), dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_1), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), ('ldapName', ['subtreeSpecification']), ('id', (2, 5, 18, 6))])], rr=[], ev=None, er=[])), ('ldapName', ['subentry']), ('id', (2, 5, 17, 0))])
    
    #-----< subentryNameForm >-----#
    subentryNameForm = CLASS(name='subentryNameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    __NAME_FORM_MandatoryAttributes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    subentryNameForm._val = dict([('namedObjectClass', dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))]), dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_1), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), ('ldapName', ['subtreeSpecification']), ('id', (2, 5, 18, 6))])], rr=[], ev=None, er=[])), ('ldapName', ['subentry']), ('id', (2, 5, 17, 0))])), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __NAME_FORM_MandatoryAttributes_val_Type_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('id', (2, 5, 15, 16))])
    
    #-----< subtreeSpecification >-----#
    subtreeSpecification = CLASS(name='subtreeSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subtreeSpecification_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subtreeSpecification._val = dict([('Type', _subtreeSpecification_val_Type), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), ('ldapName', ['subtreeSpecification']), ('id', (2, 5, 18, 6))])
    
    #-----< administrativeRole >-----#
    administrativeRole = CLASS(name='administrativeRole', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _administrativeRole_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    administrativeRole._val = dict([('Type', _administrativeRole_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['administrativeRole']), ('id', (2, 5, 18, 5))])
    
    #-----< createTimestamp >-----#
    createTimestamp = CLASS(name='createTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _createTimestamp_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_2 = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    createTimestamp._val = dict([('Type', _createTimestamp_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['createTimestamp']), ('id', (2, 5, 18, 1))])
    
    #-----< modifyTimestamp >-----#
    modifyTimestamp = CLASS(name='modifyTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _modifyTimestamp_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    modifyTimestamp._val = dict([('Type', _modifyTimestamp_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['modifyTimestamp']), ('id', (2, 5, 18, 2))])
    
    #-----< subschemaTimestamp >-----#
    subschemaTimestamp = CLASS(name='subschemaTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subschemaTimestamp_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    subschemaTimestamp._val = dict([('Type', _subschemaTimestamp_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 8))])
    
    #-----< creatorsName >-----#
    creatorsName = CLASS(name='creatorsName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _creatorsName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    creatorsName._val = dict([('Type', _creatorsName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['creatorsName']), ('id', (2, 5, 18, 3))])
    
    #-----< modifiersName >-----#
    modifiersName = CLASS(name='modifiersName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _modifiersName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    modifiersName._val = dict([('Type', _modifiersName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['modifiersName']), ('id', (2, 5, 18, 4))])
    
    #-----< subschemaSubentryList >-----#
    subschemaSubentryList = CLASS(name='subschemaSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subschemaSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    subschemaSubentryList._val = dict([('Type', _subschemaSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['subschemaSubentry']), ('id', (2, 5, 18, 10))])
    
    #-----< accessControlSubentryList >-----#
    accessControlSubentryList = CLASS(name='accessControlSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _accessControlSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    accessControlSubentryList._val = dict([('Type', _accessControlSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 11))])
    
    #-----< collectiveAttributeSubentryList >-----#
    collectiveAttributeSubentryList = CLASS(name='collectiveAttributeSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _collectiveAttributeSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    collectiveAttributeSubentryList._val = dict([('Type', _collectiveAttributeSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 12))])
    
    #-----< contextDefaultSubentryList >-----#
    contextDefaultSubentryList = CLASS(name='contextDefaultSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextDefaultSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    contextDefaultSubentryList._val = dict([('Type', _contextDefaultSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 13))])
    
    #-----< serviceAdminSubentryList >-----#
    serviceAdminSubentryList = CLASS(name='serviceAdminSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceAdminSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    serviceAdminSubentryList._val = dict([('Type', _serviceAdminSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 15))])
    
    #-----< pwdAdminSubentryList >-----#
    pwdAdminSubentryList = CLASS(name='pwdAdminSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAdminSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    pwdAdminSubentryList._val = dict([('Type', _pwdAdminSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['pwdAdminSubentryList']), ('id', (2, 5, 18, 21))])
    
    #-----< hasSubordinates >-----#
    hasSubordinates = CLASS(name='hasSubordinates', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hasSubordinates_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_3 = BOOL(name='AssertionType', mode=MODE_TYPE)
    hasSubordinates._val = dict([('Type', _hasSubordinates_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 9))])
    
    #-----< accessControlSubentry >-----#
    accessControlSubentry = CLASS(name='accessControlSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    accessControlSubentry._val = dict([('kind', 'auxiliary'), ('id', (2, 5, 17, 1))])
    
    #-----< collectiveAttributeSubentry >-----#
    collectiveAttributeSubentry = CLASS(name='collectiveAttributeSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    collectiveAttributeSubentry._val = dict([('kind', 'auxiliary'), ('id', (2, 5, 17, 2))])
    
    #-----< collectiveExclusions >-----#
    collectiveExclusions = CLASS(name='collectiveExclusions', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _collectiveExclusions_val_Type = OID(name='Type', mode=MODE_TYPE)
    collectiveExclusions._val = dict([('Type', _collectiveExclusions_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 7))])
    
    #-----< contextAssertionSubentry >-----#
    contextAssertionSubentry = CLASS(name='contextAssertionSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    contextAssertionSubentry._val = dict([('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 14))])], rr=[], ev=None, er=[])), ('id', (2, 5, 17, 3))])
    
    #-----< contextAssertionDefaults >-----#
    contextAssertionDefaults = CLASS(name='contextAssertionDefaults', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextAssertionDefaults_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    contextAssertionDefaults._val = dict([('Type', _contextAssertionDefaults_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 14))])
    
    #-----< serviceAdminSubentry >-----#
    serviceAdminSubentry = CLASS(name='serviceAdminSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SearchRuleDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = INT(name='AssertionType', mode=MODE_TYPE)
    serviceAdminSubentry._val = dict([('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 16))])], rr=[], ev=None, er=[])), ('id', (2, 5, 17, 4))])
    
    #-----< searchRules >-----#
    searchRules = CLASS(name='searchRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SearchRuleDescription')))
    searchRules._val = dict([('Type', _searchRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 16))])
    
    #-----< SearchRuleDescription >-----#
    SearchRuleDescription = SEQ(name='SearchRuleDescription', mode=MODE_TYPE)
    _SearchRuleDescription_id = INT(name='id', mode=MODE_TYPE)
    _SearchRuleDescription_dmdId = OID(name='dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _SearchRuleDescription_serviceType = OID(name='serviceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRuleDescription_userClass = INT(name='userClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRuleDescription_inputAttributeTypes = SEQ_OF(name='inputAttributeTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_inputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'RequestAttribute')))
    _SearchRuleDescription_inputAttributeTypes._cont = __SearchRuleDescription_inputAttributeTypes__item_
    _SearchRuleDescription_attributeCombination = CHOICE(name='attributeCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), default=('and', []))
    _SearchRuleDescription_outputAttributeTypes = SEQ_OF(name='outputAttributeTypes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_outputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ResultAttribute')))
    _SearchRuleDescription_outputAttributeTypes._cont = __SearchRuleDescription_outputAttributeTypes__item_
    _SearchRuleDescription_defaultControls = SEQ(name='defaultControls', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_mandatoryControls = SEQ(name='mandatoryControls', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_searchRuleControls = SEQ(name='searchRuleControls', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SearchRuleDescription_familyReturn = SEQ(name='familyReturn', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SearchRuleDescription_relaxation = SEQ(name='relaxation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchRuleDescription_additionalControl = SEQ_OF(name='additionalControl', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_additionalControl__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SearchRuleDescription_additionalControl._cont = __SearchRuleDescription_additionalControl__item_
    _SearchRuleDescription_allowedSubset = BIT_STR(name='allowedSubset', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SearchRuleDescription_imposedSubset = ENUM(name='imposedSubset', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SearchRuleDescription_entryLimit = SEQ(name='entryLimit', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    _SearchRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _SearchRuleDescription_name._cont = __SearchRuleDescription_name__item_
    _SearchRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    SearchRuleDescription._cont = ASN1Dict([
        ('id', _SearchRuleDescription_id),
        ('dmdId', _SearchRuleDescription_dmdId),
        ('serviceType', _SearchRuleDescription_serviceType),
        ('userClass', _SearchRuleDescription_userClass),
        ('inputAttributeTypes', _SearchRuleDescription_inputAttributeTypes),
        ('attributeCombination', _SearchRuleDescription_attributeCombination),
        ('outputAttributeTypes', _SearchRuleDescription_outputAttributeTypes),
        ('defaultControls', _SearchRuleDescription_defaultControls),
        ('mandatoryControls', _SearchRuleDescription_mandatoryControls),
        ('searchRuleControls', _SearchRuleDescription_searchRuleControls),
        ('familyGrouping', _SearchRuleDescription_familyGrouping),
        ('familyReturn', _SearchRuleDescription_familyReturn),
        ('relaxation', _SearchRuleDescription_relaxation),
        ('additionalControl', _SearchRuleDescription_additionalControl),
        ('allowedSubset', _SearchRuleDescription_allowedSubset),
        ('imposedSubset', _SearchRuleDescription_imposedSubset),
        ('entryLimit', _SearchRuleDescription_entryLimit),
        ('name', _SearchRuleDescription_name),
        ('description', _SearchRuleDescription_description),
        ])
    SearchRuleDescription._ext = []
    
    #-----< pwdAdminSubentry >-----#
    pwdAdminSubentry = CLASS(name='pwdAdminSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4 = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    pwdAdminSubentry._val = dict([('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['pwdAttribute']), ('id', (2, 5, 4, 84))])], rr=[], ev=None, er=[])), ('ldapName', ['pwdAdminSubentry']), ('id', (2, 5, 17, 5))])
    
    #-----< pwdAttribute >-----#
    pwdAttribute = CLASS(name='pwdAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAttribute_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    pwdAttribute._val = dict([('Type', _pwdAttribute_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['pwdAttribute']), ('id', (2, 5, 4, 84))])
    
    #-----< pwdHistory >-----#
    pwdHistory = CLASS(name='pwdHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), param=True)
    
    #-----< PwdHistory >-----#
    PwdHistory = SEQ(name='PwdHistory', mode=MODE_TYPE, param=True)
    
    #-----< pwdRecentlyExpired >-----#
    pwdRecentlyExpired = CLASS(name='pwdRecentlyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), param=True)
    
    #-----< pwdHistoryMatch >-----#
    pwdHistoryMatch = CLASS(name='pwdHistoryMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), param=True)
    
    #-----< hierarchyLevel >-----#
    hierarchyLevel = CLASS(name='hierarchyLevel', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyLevel_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'HierarchyLevel')))
    __ATTRIBUTE_ordering_match_val_AssertionType_0 = INT(name='AssertionType', mode=MODE_TYPE)
    hierarchyLevel._val = dict([('Type', _hierarchyLevel_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 17))])
    
    #-----< HierarchyLevel >-----#
    HierarchyLevel = INT(name='HierarchyLevel', mode=MODE_TYPE)
    
    #-----< hierarchyBelow >-----#
    hierarchyBelow = CLASS(name='hierarchyBelow', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyBelow_val_Type = BOOL(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'HierarchyBelow')))
    hierarchyBelow._val = dict([('Type', _hierarchyBelow_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 18))])
    
    #-----< HierarchyBelow >-----#
    HierarchyBelow = BOOL(name='HierarchyBelow', mode=MODE_TYPE)
    
    #-----< hierarchyParent >-----#
    hierarchyParent = CLASS(name='hierarchyParent', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyParent_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    hierarchyParent._val = dict([('Type', _hierarchyParent_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 19))])
    
    #-----< hierarchyTop >-----#
    hierarchyTop = CLASS(name='hierarchyTop', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyTop_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    hierarchyTop._val = dict([('Type', _hierarchyTop_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 20))])
    
    #-----< id-oc-top >-----#
    id_oc_top = OID(name='id-oc-top', mode=MODE_VALUE)
    id_oc_top._val = (2, 5, 6, 0)
    
    #-----< id-oc-alias >-----#
    id_oc_alias = OID(name='id-oc-alias', mode=MODE_VALUE)
    id_oc_alias._val = (2, 5, 6, 1)
    
    #-----< id-oc-parent >-----#
    id_oc_parent = OID(name='id-oc-parent', mode=MODE_VALUE)
    id_oc_parent._val = (2, 5, 6, 28)
    
    #-----< id-oc-child >-----#
    id_oc_child = OID(name='id-oc-child', mode=MODE_VALUE)
    id_oc_child._val = (2, 5, 6, 29)
    
    #-----< id-at-objectClass >-----#
    id_at_objectClass = OID(name='id-at-objectClass', mode=MODE_VALUE)
    id_at_objectClass._val = (2, 5, 4, 0)
    
    #-----< id-at-aliasedEntryName >-----#
    id_at_aliasedEntryName = OID(name='id-at-aliasedEntryName', mode=MODE_VALUE)
    id_at_aliasedEntryName._val = (2, 5, 4, 1)
    
    #-----< id-at-pwdAttribute >-----#
    id_at_pwdAttribute = OID(name='id-at-pwdAttribute', mode=MODE_VALUE)
    id_at_pwdAttribute._val = (2, 5, 4, 84)
    
    #-----< id-mr-objectIdentifierMatch >-----#
    id_mr_objectIdentifierMatch = OID(name='id-mr-objectIdentifierMatch', mode=MODE_VALUE)
    id_mr_objectIdentifierMatch._val = (2, 5, 13, 0)
    
    #-----< id-mr-distinguishedNameMatch >-----#
    id_mr_distinguishedNameMatch = OID(name='id-mr-distinguishedNameMatch', mode=MODE_VALUE)
    id_mr_distinguishedNameMatch._val = (2, 5, 13, 1)
    
    #-----< id-oa-excludeAllCollectiveAttributes >-----#
    id_oa_excludeAllCollectiveAttributes = OID(name='id-oa-excludeAllCollectiveAttributes', mode=MODE_VALUE)
    id_oa_excludeAllCollectiveAttributes._val = (2, 5, 18, 0)
    
    #-----< id-oa-createTimestamp >-----#
    id_oa_createTimestamp = OID(name='id-oa-createTimestamp', mode=MODE_VALUE)
    id_oa_createTimestamp._val = (2, 5, 18, 1)
    
    #-----< id-oa-modifyTimestamp >-----#
    id_oa_modifyTimestamp = OID(name='id-oa-modifyTimestamp', mode=MODE_VALUE)
    id_oa_modifyTimestamp._val = (2, 5, 18, 2)
    
    #-----< id-oa-creatorsName >-----#
    id_oa_creatorsName = OID(name='id-oa-creatorsName', mode=MODE_VALUE)
    id_oa_creatorsName._val = (2, 5, 18, 3)
    
    #-----< id-oa-modifiersName >-----#
    id_oa_modifiersName = OID(name='id-oa-modifiersName', mode=MODE_VALUE)
    id_oa_modifiersName._val = (2, 5, 18, 4)
    
    #-----< id-oa-administrativeRole >-----#
    id_oa_administrativeRole = OID(name='id-oa-administrativeRole', mode=MODE_VALUE)
    id_oa_administrativeRole._val = (2, 5, 18, 5)
    
    #-----< id-oa-subtreeSpecification >-----#
    id_oa_subtreeSpecification = OID(name='id-oa-subtreeSpecification', mode=MODE_VALUE)
    id_oa_subtreeSpecification._val = (2, 5, 18, 6)
    
    #-----< id-oa-collectiveExclusions >-----#
    id_oa_collectiveExclusions = OID(name='id-oa-collectiveExclusions', mode=MODE_VALUE)
    id_oa_collectiveExclusions._val = (2, 5, 18, 7)
    
    #-----< id-oa-subschemaTimestamp >-----#
    id_oa_subschemaTimestamp = OID(name='id-oa-subschemaTimestamp', mode=MODE_VALUE)
    id_oa_subschemaTimestamp._val = (2, 5, 18, 8)
    
    #-----< id-oa-hasSubordinates >-----#
    id_oa_hasSubordinates = OID(name='id-oa-hasSubordinates', mode=MODE_VALUE)
    id_oa_hasSubordinates._val = (2, 5, 18, 9)
    
    #-----< id-oa-subschemaSubentryList >-----#
    id_oa_subschemaSubentryList = OID(name='id-oa-subschemaSubentryList', mode=MODE_VALUE)
    id_oa_subschemaSubentryList._val = (2, 5, 18, 10)
    
    #-----< id-oa-accessControlSubentryList >-----#
    id_oa_accessControlSubentryList = OID(name='id-oa-accessControlSubentryList', mode=MODE_VALUE)
    id_oa_accessControlSubentryList._val = (2, 5, 18, 11)
    
    #-----< id-oa-collectiveAttributeSubentryList >-----#
    id_oa_collectiveAttributeSubentryList = OID(name='id-oa-collectiveAttributeSubentryList', mode=MODE_VALUE)
    id_oa_collectiveAttributeSubentryList._val = (2, 5, 18, 12)
    
    #-----< id-oa-contextDefaultSubentryList >-----#
    id_oa_contextDefaultSubentryList = OID(name='id-oa-contextDefaultSubentryList', mode=MODE_VALUE)
    id_oa_contextDefaultSubentryList._val = (2, 5, 18, 13)
    
    #-----< id-oa-contextAssertionDefault >-----#
    id_oa_contextAssertionDefault = OID(name='id-oa-contextAssertionDefault', mode=MODE_VALUE)
    id_oa_contextAssertionDefault._val = (2, 5, 18, 14)
    
    #-----< id-oa-serviceAdminSubentryList >-----#
    id_oa_serviceAdminSubentryList = OID(name='id-oa-serviceAdminSubentryList', mode=MODE_VALUE)
    id_oa_serviceAdminSubentryList._val = (2, 5, 18, 15)
    
    #-----< id-oa-searchRules >-----#
    id_oa_searchRules = OID(name='id-oa-searchRules', mode=MODE_VALUE)
    id_oa_searchRules._val = (2, 5, 18, 16)
    
    #-----< id-oa-hierarchyLevel >-----#
    id_oa_hierarchyLevel = OID(name='id-oa-hierarchyLevel', mode=MODE_VALUE)
    id_oa_hierarchyLevel._val = (2, 5, 18, 17)
    
    #-----< id-oa-hierarchyBelow >-----#
    id_oa_hierarchyBelow = OID(name='id-oa-hierarchyBelow', mode=MODE_VALUE)
    id_oa_hierarchyBelow._val = (2, 5, 18, 18)
    
    #-----< id-oa-hierarchyParent >-----#
    id_oa_hierarchyParent = OID(name='id-oa-hierarchyParent', mode=MODE_VALUE)
    id_oa_hierarchyParent._val = (2, 5, 18, 19)
    
    #-----< id-oa-hierarchyTop >-----#
    id_oa_hierarchyTop = OID(name='id-oa-hierarchyTop', mode=MODE_VALUE)
    id_oa_hierarchyTop._val = (2, 5, 18, 20)
    
    #-----< id-oa-pwdAdminSubentryList >-----#
    id_oa_pwdAdminSubentryList = OID(name='id-oa-pwdAdminSubentryList', mode=MODE_VALUE)
    id_oa_pwdAdminSubentryList._val = (2, 5, 18, 21)
    
    #-----< id-oa-allAttributeTypes >-----#
    id_oa_allAttributeTypes = OID(name='id-oa-allAttributeTypes', mode=MODE_VALUE)
    id_oa_allAttributeTypes._val = (2, 5, 18, 48)
    
    #-----< id-sc-subentry >-----#
    id_sc_subentry = OID(name='id-sc-subentry', mode=MODE_VALUE)
    id_sc_subentry._val = (2, 5, 17, 0)
    
    #-----< id-sc-accessControlSubentry >-----#
    id_sc_accessControlSubentry = OID(name='id-sc-accessControlSubentry', mode=MODE_VALUE)
    id_sc_accessControlSubentry._val = (2, 5, 17, 1)
    
    #-----< id-sc-collectiveAttributeSubentry >-----#
    id_sc_collectiveAttributeSubentry = OID(name='id-sc-collectiveAttributeSubentry', mode=MODE_VALUE)
    id_sc_collectiveAttributeSubentry._val = (2, 5, 17, 2)
    
    #-----< id-sc-contextAssertionSubentry >-----#
    id_sc_contextAssertionSubentry = OID(name='id-sc-contextAssertionSubentry', mode=MODE_VALUE)
    id_sc_contextAssertionSubentry._val = (2, 5, 17, 3)
    
    #-----< id-sc-serviceAdminSubentry >-----#
    id_sc_serviceAdminSubentry = OID(name='id-sc-serviceAdminSubentry', mode=MODE_VALUE)
    id_sc_serviceAdminSubentry._val = (2, 5, 17, 4)
    
    #-----< id-sc-pwdAdminSubentry >-----#
    id_sc_pwdAdminSubentry = OID(name='id-sc-pwdAdminSubentry', mode=MODE_VALUE)
    id_sc_pwdAdminSubentry._val = (2, 5, 17, 5)
    
    #-----< id-nf-subentryNameForm >-----#
    id_nf_subentryNameForm = OID(name='id-nf-subentryNameForm', mode=MODE_VALUE)
    id_nf_subentryNameForm._val = (2, 5, 15, 16)
    
    #-----< id-ar-autonomousArea >-----#
    id_ar_autonomousArea = OID(name='id-ar-autonomousArea', mode=MODE_VALUE)
    id_ar_autonomousArea._val = (2, 5, 23, 1)
    
    #-----< id-ar-accessControlSpecificArea >-----#
    id_ar_accessControlSpecificArea = OID(name='id-ar-accessControlSpecificArea', mode=MODE_VALUE)
    id_ar_accessControlSpecificArea._val = (2, 5, 23, 2)
    
    #-----< id-ar-accessControlInnerArea >-----#
    id_ar_accessControlInnerArea = OID(name='id-ar-accessControlInnerArea', mode=MODE_VALUE)
    id_ar_accessControlInnerArea._val = (2, 5, 23, 3)
    
    #-----< id-ar-subschemaAdminSpecificArea >-----#
    id_ar_subschemaAdminSpecificArea = OID(name='id-ar-subschemaAdminSpecificArea', mode=MODE_VALUE)
    id_ar_subschemaAdminSpecificArea._val = (2, 5, 23, 4)
    
    #-----< id-ar-collectiveAttributeSpecificArea >-----#
    id_ar_collectiveAttributeSpecificArea = OID(name='id-ar-collectiveAttributeSpecificArea', mode=MODE_VALUE)
    id_ar_collectiveAttributeSpecificArea._val = (2, 5, 23, 5)
    
    #-----< id-ar-collectiveAttributeInnerArea >-----#
    id_ar_collectiveAttributeInnerArea = OID(name='id-ar-collectiveAttributeInnerArea', mode=MODE_VALUE)
    id_ar_collectiveAttributeInnerArea._val = (2, 5, 23, 6)
    
    #-----< id-ar-contextDefaultSpecificArea >-----#
    id_ar_contextDefaultSpecificArea = OID(name='id-ar-contextDefaultSpecificArea', mode=MODE_VALUE)
    id_ar_contextDefaultSpecificArea._val = (2, 5, 23, 7)
    
    #-----< id-ar-serviceSpecificArea >-----#
    id_ar_serviceSpecificArea = OID(name='id-ar-serviceSpecificArea', mode=MODE_VALUE)
    id_ar_serviceSpecificArea._val = (2, 5, 23, 8)
    
    #-----< id-ar-pwdAdminSpecificArea >-----#
    id_ar_pwdAdminSpecificArea = OID(name='id-ar-pwdAdminSpecificArea', mode=MODE_VALUE)
    id_ar_pwdAdminSpecificArea._val = (2, 5, 23, 9)
    
    _all_ = [
        AttributeType,
        AttributeValue,
        __Context_contextType_tab,
        _Context_contextType,
        ___Context_contextValues__item__tab,
        __Context_contextValues__item_,
        _Context_contextValues,
        _Context_fallback,
        Context,
        __AttributeValueAssertion_type_tab,
        ___AttributeValueAssertion_type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        ___AttributeValueAssertion_type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        _AttributeValueAssertion_type,
        _AttributeValueAssertion_assertion,
        __AttributeValueAssertion_assertedContexts_allContexts,
        ___AttributeValueAssertion_assertedContexts_selectedContexts__item_,
        __AttributeValueAssertion_assertedContexts_selectedContexts,
        _AttributeValueAssertion_assertedContexts,
        AttributeValueAssertion,
        __ContextAssertion_contextType_tab,
        _ContextAssertion_contextType,
        ___ContextAssertion_contextValues__item__tab,
        __ContextAssertion_contextValues__item_,
        _ContextAssertion_contextValues,
        ContextAssertion,
        __AttributeTypeAssertion_type_tab,
        ___AttributeTypeAssertion_type_tab_val_Type_0,
        ___AttributeTypeAssertion_type_tab_val_Type_1,
        _AttributeTypeAssertion_type,
        __AttributeTypeAssertion_assertedContexts__item_,
        _AttributeTypeAssertion_assertedContexts,
        AttributeTypeAssertion,
        SupportedAttributes,
        _SupportedAttributes_val_Type_0,
        _SupportedAttributes_val_Type_1,
        SupportedContexts,
        _Name_rdnSequence,
        Name,
        _RDNSequence__item_,
        RDNSequence,
        DistinguishedName,
        _RelativeDistinguishedName__item_,
        RelativeDistinguishedName,
        __AttributeTypeAndValue_type_tab,
        ___AttributeTypeAndValue_type_tab_val_Type_0,
        ___AttributeTypeAndValue_type_tab_val_Type_1,
        _AttributeTypeAndValue_type,
        _AttributeTypeAndValue_value,
        AttributeTypeAndValue,
        _SubtreeSpecification_base,
        ___SubtreeSpecification_specificExclusions__item__chopBefore,
        ___SubtreeSpecification_specificExclusions__item__chopAfter,
        __SubtreeSpecification_specificExclusions__item_,
        _SubtreeSpecification_specificExclusions,
        _SubtreeSpecification_minimum,
        _SubtreeSpecification_maximum,
        _SubtreeSpecification_specificationFilter,
        SubtreeSpecification,
        LocalName,
        ___ChopSpecification_specificExclusions__item__chopBefore,
        ___ChopSpecification_specificExclusions__item__chopAfter,
        __ChopSpecification_specificExclusions__item_,
        _ChopSpecification_specificExclusions,
        _ChopSpecification_minimum,
        _ChopSpecification_maximum,
        ChopSpecification,
        BaseDistance,
        _Refinement_item,
        __Refinement_and___item_,
        _Refinement_and_,
        __Refinement_or___item_,
        _Refinement_or_,
        _Refinement_not_,
        Refinement,
        _OBJECT_CLASS_Superclasses,
        _OBJECT_CLASS_kind,
        _OBJECT_CLASS_MandatoryAttributes,
        _OBJECT_CLASS_OptionalAttributes,
        __OBJECT_CLASS_ldapName__item_,
        _OBJECT_CLASS_ldapName,
        _OBJECT_CLASS_ldapDesc,
        _OBJECT_CLASS_id,
        OBJECT_CLASS,
        ObjectClassKind,
        top,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0,
        alias,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0,
        parent,
        child,
        _ATTRIBUTE_derivation,
        _ATTRIBUTE_Type,
        _ATTRIBUTE_equality_match,
        _ATTRIBUTE_ordering_match,
        _ATTRIBUTE_substrings_match,
        _ATTRIBUTE_single_valued,
        _ATTRIBUTE_collective,
        _ATTRIBUTE_dummy,
        _ATTRIBUTE_no_user_modification,
        _ATTRIBUTE_usage,
        _ATTRIBUTE_ldapSyntax,
        __ATTRIBUTE_ldapName__item_,
        _ATTRIBUTE_ldapName,
        _ATTRIBUTE_ldapDesc,
        _ATTRIBUTE_obsolete,
        _ATTRIBUTE_id,
        ATTRIBUTE,
        AttributeUsage,
        objectClass,
        _objectClass_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        aliasedEntryName,
        _aliasedEntryName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        _MATCHING_RULE_ParentMatchingRules,
        _MATCHING_RULE_AssertionType,
        _MATCHING_RULE_uniqueMatchIndicator,
        _MATCHING_RULE_ldapSyntax,
        __MATCHING_RULE_ldapName__item_,
        _MATCHING_RULE_ldapName,
        _MATCHING_RULE_ldapDesc,
        _MATCHING_RULE_id,
        MATCHING_RULE,
        objectIdentifierMatch,
        _objectIdentifierMatch_val_AssertionType,
        distinguishedNameMatch,
        _distinguishedNameMatch_val_AssertionType,
        _NAME_FORM_namedObjectClass,
        _NAME_FORM_MandatoryAttributes,
        _NAME_FORM_OptionalAttributes,
        __NAME_FORM_ldapName__item_,
        _NAME_FORM_ldapName,
        _NAME_FORM_ldapDesc,
        _NAME_FORM_id,
        NAME_FORM,
        _DITStructureRule_ruleIdentifier,
        _DITStructureRule_nameForm,
        __DITStructureRule_superiorStructureRules__item_,
        _DITStructureRule_superiorStructureRules,
        DITStructureRule,
        RuleIdentifier,
        _STRUCTURE_RULE_nameForm,
        _STRUCTURE_RULE_SuperiorStructureRules,
        _STRUCTURE_RULE_id,
        STRUCTURE_RULE,
        _DITContentRule_structuralObjectClass,
        __DITContentRule_auxiliaries__item_,
        _DITContentRule_auxiliaries,
        __DITContentRule_mandatory__item_,
        _DITContentRule_mandatory,
        __DITContentRule_optional__item_,
        _DITContentRule_optional,
        __DITContentRule_precluded__item_,
        _DITContentRule_precluded,
        DITContentRule,
        _CONTENT_RULE_structuralClass,
        _CONTENT_RULE_Auxiliaries,
        _CONTENT_RULE_Mandatory,
        _CONTENT_RULE_Optional,
        _CONTENT_RULE_Precluded,
        CONTENT_RULE,
        _CONTEXT_Type,
        _CONTEXT_defaultValue,
        _CONTEXT_Assertion,
        _CONTEXT_absentMatch,
        _CONTEXT_id,
        CONTEXT,
        _DITContextUse_attributeType,
        __DITContextUse_mandatoryContexts__item_,
        _DITContextUse_mandatoryContexts,
        __DITContextUse_optionalContexts__item_,
        _DITContextUse_optionalContexts,
        DITContextUse,
        _DIT_CONTEXT_USE_RULE_attributeType,
        _DIT_CONTEXT_USE_RULE_Mandatory,
        _DIT_CONTEXT_USE_RULE_Optional,
        DIT_CONTEXT_USE_RULE,
        _FRIENDS_anchor,
        _FRIENDS_Friends,
        FRIENDS,
        _SYNTAX_NAME_ldapDesc,
        _SYNTAX_NAME_Type,
        _SYNTAX_NAME_id,
        SYNTAX_NAME,
        subentry,
        __ATTRIBUTE_derivation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        __ATTRIBUTE_substrings_match_val_AssertionType,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_1,
        subentryNameForm,
        __NAME_FORM_MandatoryAttributes_val_Type_0,
        subtreeSpecification,
        _subtreeSpecification_val_Type,
        administrativeRole,
        _administrativeRole_val_Type,
        createTimestamp,
        _createTimestamp_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        modifyTimestamp,
        _modifyTimestamp_val_Type,
        subschemaTimestamp,
        _subschemaTimestamp_val_Type,
        creatorsName,
        _creatorsName_val_Type,
        modifiersName,
        _modifiersName_val_Type,
        subschemaSubentryList,
        _subschemaSubentryList_val_Type,
        accessControlSubentryList,
        _accessControlSubentryList_val_Type,
        collectiveAttributeSubentryList,
        _collectiveAttributeSubentryList_val_Type,
        contextDefaultSubentryList,
        _contextDefaultSubentryList_val_Type,
        serviceAdminSubentryList,
        _serviceAdminSubentryList_val_Type,
        pwdAdminSubentryList,
        _pwdAdminSubentryList_val_Type,
        hasSubordinates,
        _hasSubordinates_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        accessControlSubentry,
        collectiveAttributeSubentry,
        collectiveExclusions,
        _collectiveExclusions_val_Type,
        contextAssertionSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2,
        contextAssertionDefaults,
        _contextAssertionDefaults_val_Type,
        serviceAdminSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        searchRules,
        _searchRules_val_Type,
        _SearchRuleDescription_id,
        _SearchRuleDescription_dmdId,
        _SearchRuleDescription_serviceType,
        _SearchRuleDescription_userClass,
        __SearchRuleDescription_inputAttributeTypes__item_,
        _SearchRuleDescription_inputAttributeTypes,
        _SearchRuleDescription_attributeCombination,
        __SearchRuleDescription_outputAttributeTypes__item_,
        _SearchRuleDescription_outputAttributeTypes,
        _SearchRuleDescription_defaultControls,
        _SearchRuleDescription_mandatoryControls,
        _SearchRuleDescription_searchRuleControls,
        _SearchRuleDescription_familyGrouping,
        _SearchRuleDescription_familyReturn,
        _SearchRuleDescription_relaxation,
        __SearchRuleDescription_additionalControl__item_,
        _SearchRuleDescription_additionalControl,
        _SearchRuleDescription_allowedSubset,
        _SearchRuleDescription_imposedSubset,
        _SearchRuleDescription_entryLimit,
        __SearchRuleDescription_name__item_,
        _SearchRuleDescription_name,
        _SearchRuleDescription_description,
        SearchRuleDescription,
        pwdAdminSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4,
        pwdAttribute,
        _pwdAttribute_val_Type,
        hierarchyLevel,
        _hierarchyLevel_val_Type,
        __ATTRIBUTE_ordering_match_val_AssertionType_0,
        HierarchyLevel,
        hierarchyBelow,
        _hierarchyBelow_val_Type,
        HierarchyBelow,
        hierarchyParent,
        _hierarchyParent_val_Type,
        hierarchyTop,
        _hierarchyTop_val_Type,
        id_oc_top,
        id_oc_alias,
        id_oc_parent,
        id_oc_child,
        id_at_objectClass,
        id_at_aliasedEntryName,
        id_at_pwdAttribute,
        id_mr_objectIdentifierMatch,
        id_mr_distinguishedNameMatch,
        id_oa_excludeAllCollectiveAttributes,
        id_oa_createTimestamp,
        id_oa_modifyTimestamp,
        id_oa_creatorsName,
        id_oa_modifiersName,
        id_oa_administrativeRole,
        id_oa_subtreeSpecification,
        id_oa_collectiveExclusions,
        id_oa_subschemaTimestamp,
        id_oa_hasSubordinates,
        id_oa_subschemaSubentryList,
        id_oa_accessControlSubentryList,
        id_oa_collectiveAttributeSubentryList,
        id_oa_contextDefaultSubentryList,
        id_oa_contextAssertionDefault,
        id_oa_serviceAdminSubentryList,
        id_oa_searchRules,
        id_oa_hierarchyLevel,
        id_oa_hierarchyBelow,
        id_oa_hierarchyParent,
        id_oa_hierarchyTop,
        id_oa_pwdAdminSubentryList,
        id_oa_allAttributeTypes,
        id_sc_subentry,
        id_sc_accessControlSubentry,
        id_sc_collectiveAttributeSubentry,
        id_sc_contextAssertionSubentry,
        id_sc_serviceAdminSubentry,
        id_sc_pwdAdminSubentry,
        id_nf_subentryNameForm,
        id_ar_autonomousArea,
        id_ar_accessControlSpecificArea,
        id_ar_accessControlInnerArea,
        id_ar_subschemaAdminSpecificArea,
        id_ar_collectiveAttributeSpecificArea,
        id_ar_collectiveAttributeInnerArea,
        id_ar_contextDefaultSpecificArea,
        id_ar_serviceSpecificArea,
        id_ar_pwdAdminSpecificArea,
    ]

class LCSChargingDataTypes:

    _name_  = 'LCSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 6, 0, 1]
    
    _obj_ = [
        'LCSRecord',
        'LCSGMORecord',
        'LCSRGMTRecord',
        'LCSHGMTRecord',
        'LCSVGMTRecord',
        'LCSGNIRecord',
        'ProviderError',
        'ResultCodeType',
        'ServingEntity',
        'UserError',
        ]
    _type_ = [
        'LCSRecord',
        'LCSGMORecord',
        'LCSRGMTRecord',
        'LCSHGMTRecord',
        'LCSVGMTRecord',
        'LCSGNIRecord',
        'ProviderError',
        'ResultCodeType',
        'ServingEntity',
        'UserError',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LCSRecord >-----#
    LCSRecord = CHOICE(name='LCSRecord', mode=MODE_TYPE)
    _LCSRecord_lCSGMORecord = SET(name='lCSGMORecord', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSGMORecord')))
    _LCSRecord_lCSRGMTRecord = SET(name='lCSRGMTRecord', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSRGMTRecord')))
    _LCSRecord_lCSHGMTRecord = SET(name='lCSHGMTRecord', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSHGMTRecord')))
    _LCSRecord_lCSVGMTRecord = SET(name='lCSVGMTRecord', mode=MODE_TYPE, tag=(74, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSVGMTRecord')))
    _LCSRecord_lCSGNIRecord = SET(name='lCSGNIRecord', mode=MODE_TYPE, tag=(75, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSGNIRecord')))
    LCSRecord._cont = ASN1Dict([
        ('lCSGMORecord', _LCSRecord_lCSGMORecord),
        ('lCSRGMTRecord', _LCSRecord_lCSRGMTRecord),
        ('lCSHGMTRecord', _LCSRecord_lCSHGMTRecord),
        ('lCSVGMTRecord', _LCSRecord_lCSVGMTRecord),
        ('lCSGNIRecord', _LCSRecord_lCSGNIRecord),
        ])
    LCSRecord._ext = None
    
    #-----< LCSGMORecord >-----#
    LCSGMORecord = SET(name='LCSGMORecord', mode=MODE_TYPE)
    _LCSGMORecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSGMORecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSGMORecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSGMORecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSGMORecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSGMORecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSGMORecord_servingEntity = OCT_STR(name='servingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ServingEntity')), opt=True)
    _LCSGMORecord_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _LCSGMORecord_positioningData = OCT_STR(name='positioningData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _LCSGMORecord_userError = OCT_STR(name='userError', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'UserError')), opt=True)
    _LCSGMORecord_providerError = INT(name='providerError', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ProviderError')), opt=True)
    _LCSGMORecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSGMORecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSGMORecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    LCSGMORecord._cont = ASN1Dict([
        ('recordType', _LCSGMORecord_recordType),
        ('recordingEntity', _LCSGMORecord_recordingEntity),
        ('lcsClientType', _LCSGMORecord_lcsClientType),
        ('lcsClientIdentity', _LCSGMORecord_lcsClientIdentity),
        ('servedIMSI', _LCSGMORecord_servedIMSI),
        ('servedMSISDN', _LCSGMORecord_servedMSISDN),
        ('servingEntity', _LCSGMORecord_servingEntity),
        ('locationEstimate', _LCSGMORecord_locationEstimate),
        ('positioningData', _LCSGMORecord_positioningData),
        ('userError', _LCSGMORecord_userError),
        ('providerError', _LCSGMORecord_providerError),
        ('recordTimeStamp', _LCSGMORecord_recordTimeStamp),
        ('localSequenceNumber', _LCSGMORecord_localSequenceNumber),
        ('recordExtensions', _LCSGMORecord_recordExtensions),
        ])
    LCSGMORecord._ext = None
    
    #-----< LCSRGMTRecord >-----#
    LCSRGMTRecord = SET(name='LCSRGMTRecord', mode=MODE_TYPE)
    _LCSRGMTRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSRGMTRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSRGMTRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSRGMTRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSRGMTRecord_targetIMSI = OCT_STR(name='targetIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSRGMTRecord_targetMSISDN = OCT_STR(name='targetMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSRGMTRecord_locationType = SEQ(name='locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LCSRGMTRecord_lCSPriority = OCT_STR(name='lCSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _LCSRGMTRecord_resultCode = INT(name='resultCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSRGMTRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSRGMTRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSRGMTRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LCSRGMTRecord_homeGMLCIdentity = CHOICE(name='homeGMLCIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    LCSRGMTRecord._cont = ASN1Dict([
        ('recordType', _LCSRGMTRecord_recordType),
        ('recordingEntity', _LCSRGMTRecord_recordingEntity),
        ('lcsClientType', _LCSRGMTRecord_lcsClientType),
        ('lcsClientIdentity', _LCSRGMTRecord_lcsClientIdentity),
        ('targetIMSI', _LCSRGMTRecord_targetIMSI),
        ('targetMSISDN', _LCSRGMTRecord_targetMSISDN),
        ('locationType', _LCSRGMTRecord_locationType),
        ('lCSPriority', _LCSRGMTRecord_lCSPriority),
        ('resultCode', _LCSRGMTRecord_resultCode),
        ('recordTimeStamp', _LCSRGMTRecord_recordTimeStamp),
        ('localSequenceNumber', _LCSRGMTRecord_localSequenceNumber),
        ('recordExtensions', _LCSRGMTRecord_recordExtensions),
        ('homeGMLCIdentity', _LCSRGMTRecord_homeGMLCIdentity),
        ])
    LCSRGMTRecord._ext = None
    
    #-----< LCSHGMTRecord >-----#
    LCSHGMTRecord = SET(name='LCSHGMTRecord', mode=MODE_TYPE)
    _LCSHGMTRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSHGMTRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSHGMTRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSHGMTRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSHGMTRecord_targetIMSI = OCT_STR(name='targetIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSHGMTRecord_targetMSISDN = OCT_STR(name='targetMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSHGMTRecord_locationType = SEQ(name='locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LCSHGMTRecord_lCSPriority = OCT_STR(name='lCSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _LCSHGMTRecord_resultCode = INT(name='resultCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSHGMTRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSHGMTRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSHGMTRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LCSHGMTRecord_requestingGMLCIdentity = CHOICE(name='requestingGMLCIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _LCSHGMTRecord_visitedGMLCIdentity = CHOICE(name='visitedGMLCIdentity', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _LCSHGMTRecord_servingNetworkIdentity = OCT_STR(name='servingNetworkIdentity', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    LCSHGMTRecord._cont = ASN1Dict([
        ('recordType', _LCSHGMTRecord_recordType),
        ('recordingEntity', _LCSHGMTRecord_recordingEntity),
        ('lcsClientType', _LCSHGMTRecord_lcsClientType),
        ('lcsClientIdentity', _LCSHGMTRecord_lcsClientIdentity),
        ('targetIMSI', _LCSHGMTRecord_targetIMSI),
        ('targetMSISDN', _LCSHGMTRecord_targetMSISDN),
        ('locationType', _LCSHGMTRecord_locationType),
        ('lCSPriority', _LCSHGMTRecord_lCSPriority),
        ('resultCode', _LCSHGMTRecord_resultCode),
        ('recordTimeStamp', _LCSHGMTRecord_recordTimeStamp),
        ('localSequenceNumber', _LCSHGMTRecord_localSequenceNumber),
        ('recordExtensions', _LCSHGMTRecord_recordExtensions),
        ('requestingGMLCIdentity', _LCSHGMTRecord_requestingGMLCIdentity),
        ('visitedGMLCIdentity', _LCSHGMTRecord_visitedGMLCIdentity),
        ('servingNetworkIdentity', _LCSHGMTRecord_servingNetworkIdentity),
        ])
    LCSHGMTRecord._ext = None
    
    #-----< LCSVGMTRecord >-----#
    LCSVGMTRecord = SET(name='LCSVGMTRecord', mode=MODE_TYPE)
    _LCSVGMTRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSVGMTRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSVGMTRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSVGMTRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSVGMTRecord_targetIMSI = OCT_STR(name='targetIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSVGMTRecord_targetMSISDN = OCT_STR(name='targetMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSVGMTRecord_locationType = SEQ(name='locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LCSVGMTRecord_lCSPriority = OCT_STR(name='lCSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _LCSVGMTRecord_resultCode = INT(name='resultCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSVGMTRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSVGMTRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSVGMTRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LCSVGMTRecord_homeGMLCIdentity = CHOICE(name='homeGMLCIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    LCSVGMTRecord._cont = ASN1Dict([
        ('recordType', _LCSVGMTRecord_recordType),
        ('recordingEntity', _LCSVGMTRecord_recordingEntity),
        ('lcsClientType', _LCSVGMTRecord_lcsClientType),
        ('lcsClientIdentity', _LCSVGMTRecord_lcsClientIdentity),
        ('targetIMSI', _LCSVGMTRecord_targetIMSI),
        ('targetMSISDN', _LCSVGMTRecord_targetMSISDN),
        ('locationType', _LCSVGMTRecord_locationType),
        ('lCSPriority', _LCSVGMTRecord_lCSPriority),
        ('resultCode', _LCSVGMTRecord_resultCode),
        ('recordTimeStamp', _LCSVGMTRecord_recordTimeStamp),
        ('localSequenceNumber', _LCSVGMTRecord_localSequenceNumber),
        ('recordExtensions', _LCSVGMTRecord_recordExtensions),
        ('homeGMLCIdentity', _LCSVGMTRecord_homeGMLCIdentity),
        ])
    LCSVGMTRecord._ext = None
    
    #-----< LCSGNIRecord >-----#
    LCSGNIRecord = SET(name='LCSGNIRecord', mode=MODE_TYPE)
    _LCSGNIRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSGNIRecord_recordingEntity = OCT_STR(name='recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSGNIRecord_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSGNIRecord_lcsClientIdentity = SEQ(name='lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSGNIRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSGNIRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSGNIRecord_servingEntity = OCT_STR(name='servingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ServingEntity')), opt=True)
    _LCSGNIRecord_resultCode = INT(name='resultCode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSGNIRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSGNIRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSGNIRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    LCSGNIRecord._cont = ASN1Dict([
        ('recordType', _LCSGNIRecord_recordType),
        ('recordingEntity', _LCSGNIRecord_recordingEntity),
        ('lcsClientType', _LCSGNIRecord_lcsClientType),
        ('lcsClientIdentity', _LCSGNIRecord_lcsClientIdentity),
        ('servedIMSI', _LCSGNIRecord_servedIMSI),
        ('servedMSISDN', _LCSGNIRecord_servedMSISDN),
        ('servingEntity', _LCSGNIRecord_servingEntity),
        ('resultCode', _LCSGNIRecord_resultCode),
        ('recordTimeStamp', _LCSGNIRecord_recordTimeStamp),
        ('localSequenceNumber', _LCSGNIRecord_localSequenceNumber),
        ('recordExtensions', _LCSGNIRecord_recordExtensions),
        ])
    LCSGNIRecord._ext = None
    
    #-----< ProviderError >-----#
    ProviderError = INT(name='ProviderError', mode=MODE_TYPE)
    
    #-----< ResultCodeType >-----#
    ResultCodeType = INT(name='ResultCodeType', mode=MODE_TYPE)
    ResultCodeType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< ServingEntity >-----#
    ServingEntity = OCT_STR(name='ServingEntity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< UserError >-----#
    UserError = OCT_STR(name='UserError', mode=MODE_TYPE)
    UserError._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    _all_ = [
        _LCSRecord_lCSGMORecord,
        _LCSRecord_lCSRGMTRecord,
        _LCSRecord_lCSHGMTRecord,
        _LCSRecord_lCSVGMTRecord,
        _LCSRecord_lCSGNIRecord,
        LCSRecord,
        _LCSGMORecord_recordType,
        _LCSGMORecord_recordingEntity,
        _LCSGMORecord_lcsClientType,
        _LCSGMORecord_lcsClientIdentity,
        _LCSGMORecord_servedIMSI,
        _LCSGMORecord_servedMSISDN,
        _LCSGMORecord_servingEntity,
        _LCSGMORecord_locationEstimate,
        _LCSGMORecord_positioningData,
        _LCSGMORecord_userError,
        _LCSGMORecord_providerError,
        _LCSGMORecord_recordTimeStamp,
        _LCSGMORecord_localSequenceNumber,
        _LCSGMORecord_recordExtensions,
        LCSGMORecord,
        _LCSRGMTRecord_recordType,
        _LCSRGMTRecord_recordingEntity,
        _LCSRGMTRecord_lcsClientType,
        _LCSRGMTRecord_lcsClientIdentity,
        _LCSRGMTRecord_targetIMSI,
        _LCSRGMTRecord_targetMSISDN,
        _LCSRGMTRecord_locationType,
        _LCSRGMTRecord_lCSPriority,
        _LCSRGMTRecord_resultCode,
        _LCSRGMTRecord_recordTimeStamp,
        _LCSRGMTRecord_localSequenceNumber,
        _LCSRGMTRecord_recordExtensions,
        _LCSRGMTRecord_homeGMLCIdentity,
        LCSRGMTRecord,
        _LCSHGMTRecord_recordType,
        _LCSHGMTRecord_recordingEntity,
        _LCSHGMTRecord_lcsClientType,
        _LCSHGMTRecord_lcsClientIdentity,
        _LCSHGMTRecord_targetIMSI,
        _LCSHGMTRecord_targetMSISDN,
        _LCSHGMTRecord_locationType,
        _LCSHGMTRecord_lCSPriority,
        _LCSHGMTRecord_resultCode,
        _LCSHGMTRecord_recordTimeStamp,
        _LCSHGMTRecord_localSequenceNumber,
        _LCSHGMTRecord_recordExtensions,
        _LCSHGMTRecord_requestingGMLCIdentity,
        _LCSHGMTRecord_visitedGMLCIdentity,
        _LCSHGMTRecord_servingNetworkIdentity,
        LCSHGMTRecord,
        _LCSVGMTRecord_recordType,
        _LCSVGMTRecord_recordingEntity,
        _LCSVGMTRecord_lcsClientType,
        _LCSVGMTRecord_lcsClientIdentity,
        _LCSVGMTRecord_targetIMSI,
        _LCSVGMTRecord_targetMSISDN,
        _LCSVGMTRecord_locationType,
        _LCSVGMTRecord_lCSPriority,
        _LCSVGMTRecord_resultCode,
        _LCSVGMTRecord_recordTimeStamp,
        _LCSVGMTRecord_localSequenceNumber,
        _LCSVGMTRecord_recordExtensions,
        _LCSVGMTRecord_homeGMLCIdentity,
        LCSVGMTRecord,
        _LCSGNIRecord_recordType,
        _LCSGNIRecord_recordingEntity,
        _LCSGNIRecord_lcsClientType,
        _LCSGNIRecord_lcsClientIdentity,
        _LCSGNIRecord_servedIMSI,
        _LCSGNIRecord_servedMSISDN,
        _LCSGNIRecord_servingEntity,
        _LCSGNIRecord_resultCode,
        _LCSGNIRecord_recordTimeStamp,
        _LCSGNIRecord_localSequenceNumber,
        _LCSGNIRecord_recordExtensions,
        LCSGNIRecord,
        ProviderError,
        ResultCodeType,
        ServingEntity,
        UserError,
    ]

class LdapSystemSchema:

    _name_  = 'LdapSystemSchema'
    _oid_   = [2, 5, 1, 38, 8]
    
    _obj_ = [
        'namingContexts',
        'altServer',
        'supportedExtension',
        'supportedControl',
        'supportedSASLMechanisms',
        'supportedLDAPVersion',
        'supportedFeatures',
        'ldapSyntaxes',
        'LdapSyntaxDescription',
        'id-lat-namingContexts',
        'id-lat-altServer',
        'id-lat-supportedExtension',
        'id-lat-supportedControl',
        'id-lat-supportedSASLMechanisms',
        'id-lat-supportedLDAPVersion',
        'id-soa-ldapSyntaxes',
        'id-oat-supportedFeatures',
        ]
    _type_ = [
        'LdapSyntaxDescription',
        ]
    _set_ = [
        ]
    _val_ = [
        'namingContexts',
        'altServer',
        'supportedExtension',
        'supportedControl',
        'supportedSASLMechanisms',
        'supportedLDAPVersion',
        'supportedFeatures',
        'ldapSyntaxes',
        'id-lat-namingContexts',
        'id-lat-altServer',
        'id-lat-supportedExtension',
        'id-lat-supportedControl',
        'id-lat-supportedSASLMechanisms',
        'id-lat-supportedLDAPVersion',
        'id-soa-ldapSyntaxes',
        'id-oat-supportedFeatures',
        ]
    _class_ = [
        'namingContexts',
        'altServer',
        'supportedExtension',
        'supportedControl',
        'supportedSASLMechanisms',
        'supportedLDAPVersion',
        'supportedFeatures',
        'ldapSyntaxes',
        ]
    _param_ = [
        ]
    
    #-----< namingContexts >-----#
    namingContexts = CLASS(name='namingContexts', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _namingContexts_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    namingContexts._val = dict([('Type', _namingContexts_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['namingContexts']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 5))])
    
    #-----< altServer >-----#
    altServer = CLASS(name='altServer', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _altServer_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    altServer._val = dict([('Type', _altServer_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['altServer']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 6))])
    
    #-----< supportedExtension >-----#
    supportedExtension = CLASS(name='supportedExtension', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedExtension_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedExtension._val = dict([('Type', _supportedExtension_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['supportedExtension']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 7))])
    
    #-----< supportedControl >-----#
    supportedControl = CLASS(name='supportedControl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedControl_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedControl._val = dict([('Type', _supportedControl_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['supportedControl']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 13))])
    
    #-----< supportedSASLMechanisms >-----#
    supportedSASLMechanisms = CLASS(name='supportedSASLMechanisms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedSASLMechanisms_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DirectoryString')))
    __supportedSASLMechanisms_val_Type_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _supportedSASLMechanisms_val_Type._cont = ASN1Dict([
        ('teletexString', __supportedSASLMechanisms_val_Type_teletexString),
        ('printableString', __supportedSASLMechanisms_val_Type_printableString),
        ('bmpString', __supportedSASLMechanisms_val_Type_bmpString),
        ('universalString', __supportedSASLMechanisms_val_Type_universalString),
        ('uTF8String', __supportedSASLMechanisms_val_Type_uTF8String),
        ])
    _supportedSASLMechanisms_val_Type._ext = None
    supportedSASLMechanisms._val = dict([('Type', _supportedSASLMechanisms_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['supportedSASLMechanisms']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 14))])
    
    #-----< supportedLDAPVersion >-----#
    supportedLDAPVersion = CLASS(name='supportedLDAPVersion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedLDAPVersion_val_Type = INT(name='Type', mode=MODE_TYPE)
    supportedLDAPVersion._val = dict([('Type', _supportedLDAPVersion_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['supportedLDAPVersion']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 15))])
    
    #-----< supportedFeatures >-----#
    supportedFeatures = CLASS(name='supportedFeatures', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedFeatures_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedFeatures._val = dict([('Type', _supportedFeatures_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['supportedFeatures']), ('id', (1, 3, 6, 1, 4, 1, 4203, 1, 3, 5))])
    
    #-----< ldapSyntaxes >-----#
    ldapSyntaxes = CLASS(name='ldapSyntaxes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ldapSyntaxes_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('LdapSystemSchema', 'LdapSyntaxDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ldapSyntaxes._val = dict([('Type', _ldapSyntaxes_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)), ('ldapName', ['ldapSyntax']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16))])
    
    #-----< LdapSyntaxDescription >-----#
    LdapSyntaxDescription = SEQ(name='LdapSyntaxDescription', mode=MODE_TYPE)
    _LdapSyntaxDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), ['id']))
    _LdapSyntaxDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    LdapSyntaxDescription._cont = ASN1Dict([
        ('identifier', _LdapSyntaxDescription_identifier),
        ('description', _LdapSyntaxDescription_description),
        ])
    LdapSyntaxDescription._ext = []
    
    #-----< id-lat-namingContexts >-----#
    id_lat_namingContexts = OID(name='id-lat-namingContexts', mode=MODE_VALUE)
    id_lat_namingContexts._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 5)
    
    #-----< id-lat-altServer >-----#
    id_lat_altServer = OID(name='id-lat-altServer', mode=MODE_VALUE)
    id_lat_altServer._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 6)
    
    #-----< id-lat-supportedExtension >-----#
    id_lat_supportedExtension = OID(name='id-lat-supportedExtension', mode=MODE_VALUE)
    id_lat_supportedExtension._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 7)
    
    #-----< id-lat-supportedControl >-----#
    id_lat_supportedControl = OID(name='id-lat-supportedControl', mode=MODE_VALUE)
    id_lat_supportedControl._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 13)
    
    #-----< id-lat-supportedSASLMechanisms >-----#
    id_lat_supportedSASLMechanisms = OID(name='id-lat-supportedSASLMechanisms', mode=MODE_VALUE)
    id_lat_supportedSASLMechanisms._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 14)
    
    #-----< id-lat-supportedLDAPVersion >-----#
    id_lat_supportedLDAPVersion = OID(name='id-lat-supportedLDAPVersion', mode=MODE_VALUE)
    id_lat_supportedLDAPVersion._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 15)
    
    #-----< id-soa-ldapSyntaxes >-----#
    id_soa_ldapSyntaxes = OID(name='id-soa-ldapSyntaxes', mode=MODE_VALUE)
    id_soa_ldapSyntaxes._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16)
    
    #-----< id-oat-supportedFeatures >-----#
    id_oat_supportedFeatures = OID(name='id-oat-supportedFeatures', mode=MODE_VALUE)
    id_oat_supportedFeatures._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3, 5)
    
    _all_ = [
        namingContexts,
        _namingContexts_val_Type,
        altServer,
        _altServer_val_Type,
        supportedExtension,
        _supportedExtension_val_Type,
        supportedControl,
        _supportedControl_val_Type,
        supportedSASLMechanisms,
        __supportedSASLMechanisms_val_Type_teletexString,
        __supportedSASLMechanisms_val_Type_printableString,
        __supportedSASLMechanisms_val_Type_bmpString,
        __supportedSASLMechanisms_val_Type_universalString,
        __supportedSASLMechanisms_val_Type_uTF8String,
        _supportedSASLMechanisms_val_Type,
        supportedLDAPVersion,
        _supportedLDAPVersion_val_Type,
        supportedFeatures,
        _supportedFeatures_val_Type,
        ldapSyntaxes,
        _ldapSyntaxes_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _LdapSyntaxDescription_identifier,
        _LdapSyntaxDescription_description,
        LdapSyntaxDescription,
        id_lat_namingContexts,
        id_lat_altServer,
        id_lat_supportedExtension,
        id_lat_supportedControl,
        id_lat_supportedSASLMechanisms,
        id_lat_supportedLDAPVersion,
        id_soa_ldapSyntaxes,
        id_oat_supportedFeatures,
    ]

class Lightweight_Directory_Access_Protocol_V3:

    _name_  = 'Lightweight-Directory-Access-Protocol-V3'
    _oid_   = [1, 3, 6, 1, 1, 18]
    
    _obj_ = [
        'LDAPMessage',
        'MessageID',
        'maxInt',
        'LDAPString',
        'LDAPOID',
        'LDAPDN',
        'RelativeLDAPDN',
        'AttributeDescription',
        'AttributeValue',
        'AttributeValueAssertion',
        'AssertionValue',
        'PartialAttribute',
        'Attribute',
        'MatchingRuleId',
        'LDAPResult',
        'Referral',
        'URI',
        'Controls',
        'Control',
        'BindRequest',
        'AuthenticationChoice',
        'SaslCredentials',
        'BindResponse',
        'UnbindRequest',
        'SearchRequest',
        'AttributeSelection',
        'Filter',
        'SubstringFilter',
        'MatchingRuleAssertion',
        'SearchResultEntry',
        'PartialAttributeList',
        'SearchResultReference',
        'SearchResultDone',
        'ModifyRequest',
        'ModifyResponse',
        'AddRequest',
        'AttributeList',
        'AddResponse',
        'DelRequest',
        'DelResponse',
        'ModifyDNRequest',
        'ModifyDNResponse',
        'CompareRequest',
        'CompareResponse',
        'AbandonRequest',
        'ExtendedRequest',
        'ExtendedResponse',
        'IntermediateResponse',
        ]
    _type_ = [
        'LDAPMessage',
        'MessageID',
        'LDAPString',
        'LDAPOID',
        'LDAPDN',
        'RelativeLDAPDN',
        'AttributeDescription',
        'AttributeValue',
        'AttributeValueAssertion',
        'AssertionValue',
        'PartialAttribute',
        'Attribute',
        'MatchingRuleId',
        'LDAPResult',
        'Referral',
        'URI',
        'Controls',
        'Control',
        'BindRequest',
        'AuthenticationChoice',
        'SaslCredentials',
        'BindResponse',
        'UnbindRequest',
        'SearchRequest',
        'AttributeSelection',
        'Filter',
        'SubstringFilter',
        'MatchingRuleAssertion',
        'SearchResultEntry',
        'PartialAttributeList',
        'SearchResultReference',
        'SearchResultDone',
        'ModifyRequest',
        'ModifyResponse',
        'AddRequest',
        'AttributeList',
        'AddResponse',
        'DelRequest',
        'DelResponse',
        'ModifyDNRequest',
        'ModifyDNResponse',
        'CompareRequest',
        'CompareResponse',
        'AbandonRequest',
        'ExtendedRequest',
        'ExtendedResponse',
        'IntermediateResponse',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxInt',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LDAPMessage >-----#
    LDAPMessage = SEQ(name='LDAPMessage', mode=MODE_TYPE)
    _LDAPMessage_messageID = INT(name='messageID', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    _LDAPMessage_protocolOp = CHOICE(name='protocolOp', mode=MODE_TYPE)
    __LDAPMessage_protocolOp_bindRequest = SEQ(name='bindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindRequest')))
    __LDAPMessage_protocolOp_bindResponse = SEQ(name='bindResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindResponse')))
    __LDAPMessage_protocolOp_unbindRequest = NULL(name='unbindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'UnbindRequest')))
    __LDAPMessage_protocolOp_searchRequest = SEQ(name='searchRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchRequest')))
    __LDAPMessage_protocolOp_searchResEntry = SEQ(name='searchResEntry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultEntry')))
    __LDAPMessage_protocolOp_searchResDone = SEQ(name='searchResDone', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultDone')))
    __LDAPMessage_protocolOp_searchResRef = SEQ_OF(name='searchResRef', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultReference')))
    __LDAPMessage_protocolOp_modifyRequest = SEQ(name='modifyRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyRequest')))
    __LDAPMessage_protocolOp_modifyResponse = SEQ(name='modifyResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyResponse')))
    __LDAPMessage_protocolOp_addRequest = SEQ(name='addRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddRequest')))
    __LDAPMessage_protocolOp_addResponse = SEQ(name='addResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddResponse')))
    __LDAPMessage_protocolOp_delRequest = OCT_STR(name='delRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelRequest')))
    __LDAPMessage_protocolOp_delResponse = SEQ(name='delResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelResponse')))
    __LDAPMessage_protocolOp_modDNRequest = SEQ(name='modDNRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNRequest')))
    __LDAPMessage_protocolOp_modDNResponse = SEQ(name='modDNResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNResponse')))
    __LDAPMessage_protocolOp_compareRequest = SEQ(name='compareRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareRequest')))
    __LDAPMessage_protocolOp_compareResponse = SEQ(name='compareResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareResponse')))
    __LDAPMessage_protocolOp_abandonRequest = INT(name='abandonRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AbandonRequest')))
    __LDAPMessage_protocolOp_extendedReq = SEQ(name='extendedReq', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedRequest')))
    __LDAPMessage_protocolOp_extendedResp = SEQ(name='extendedResp', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedResponse')))
    __LDAPMessage_protocolOp_intermediateResponse = SEQ(name='intermediateResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'IntermediateResponse')))
    _LDAPMessage_protocolOp._cont = ASN1Dict([
        ('bindRequest', __LDAPMessage_protocolOp_bindRequest),
        ('bindResponse', __LDAPMessage_protocolOp_bindResponse),
        ('unbindRequest', __LDAPMessage_protocolOp_unbindRequest),
        ('searchRequest', __LDAPMessage_protocolOp_searchRequest),
        ('searchResEntry', __LDAPMessage_protocolOp_searchResEntry),
        ('searchResDone', __LDAPMessage_protocolOp_searchResDone),
        ('searchResRef', __LDAPMessage_protocolOp_searchResRef),
        ('modifyRequest', __LDAPMessage_protocolOp_modifyRequest),
        ('modifyResponse', __LDAPMessage_protocolOp_modifyResponse),
        ('addRequest', __LDAPMessage_protocolOp_addRequest),
        ('addResponse', __LDAPMessage_protocolOp_addResponse),
        ('delRequest', __LDAPMessage_protocolOp_delRequest),
        ('delResponse', __LDAPMessage_protocolOp_delResponse),
        ('modDNRequest', __LDAPMessage_protocolOp_modDNRequest),
        ('modDNResponse', __LDAPMessage_protocolOp_modDNResponse),
        ('compareRequest', __LDAPMessage_protocolOp_compareRequest),
        ('compareResponse', __LDAPMessage_protocolOp_compareResponse),
        ('abandonRequest', __LDAPMessage_protocolOp_abandonRequest),
        ('extendedReq', __LDAPMessage_protocolOp_extendedReq),
        ('extendedResp', __LDAPMessage_protocolOp_extendedResp),
        ('intermediateResponse', __LDAPMessage_protocolOp_intermediateResponse),
        ])
    _LDAPMessage_protocolOp._ext = ['intermediateResponse']
    _LDAPMessage_controls = SEQ_OF(name='controls', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Controls')), opt=True)
    LDAPMessage._cont = ASN1Dict([
        ('messageID', _LDAPMessage_messageID),
        ('protocolOp', _LDAPMessage_protocolOp),
        ('controls', _LDAPMessage_controls),
        ])
    LDAPMessage._ext = []
    
    #-----< MessageID >-----#
    MessageID = INT(name='MessageID', mode=MODE_TYPE)
    MessageID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< maxInt >-----#
    maxInt = INT(name='maxInt', mode=MODE_VALUE)
    maxInt._val = 2147483647
    
    #-----< LDAPString >-----#
    LDAPString = OCT_STR(name='LDAPString', mode=MODE_TYPE)
    
    #-----< LDAPOID >-----#
    LDAPOID = OCT_STR(name='LDAPOID', mode=MODE_TYPE)
    
    #-----< LDAPDN >-----#
    LDAPDN = OCT_STR(name='LDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< RelativeLDAPDN >-----#
    RelativeLDAPDN = OCT_STR(name='RelativeLDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeDescription >-----#
    AttributeDescription = OCT_STR(name='AttributeDescription', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeValue >-----#
    AttributeValue = OCT_STR(name='AttributeValue', mode=MODE_TYPE)
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name='AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_attributeDesc = OCT_STR(name='attributeDesc', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _AttributeValueAssertion_assertionValue = OCT_STR(name='assertionValue', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    AttributeValueAssertion._cont = ASN1Dict([
        ('attributeDesc', _AttributeValueAssertion_attributeDesc),
        ('assertionValue', _AttributeValueAssertion_assertionValue),
        ])
    AttributeValueAssertion._ext = []
    
    #-----< AssertionValue >-----#
    AssertionValue = OCT_STR(name='AssertionValue', mode=MODE_TYPE)
    
    #-----< PartialAttribute >-----#
    PartialAttribute = SEQ(name='PartialAttribute', mode=MODE_TYPE)
    _PartialAttribute_type = OCT_STR(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _PartialAttribute_vals = SET_OF(name='vals', mode=MODE_TYPE)
    __PartialAttribute_vals_value = OCT_STR(name='value', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValue')))
    _PartialAttribute_vals._cont = __PartialAttribute_vals_value
    PartialAttribute._cont = ASN1Dict([
        ('type', _PartialAttribute_type),
        ('vals', _PartialAttribute_vals),
        ])
    PartialAttribute._ext = []
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    
    #-----< MatchingRuleId >-----#
    MatchingRuleId = OCT_STR(name='MatchingRuleId', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< LDAPResult >-----#
    LDAPResult = SEQ(name='LDAPResult', mode=MODE_TYPE)
    _LDAPResult_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _LDAPResult_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _LDAPResult_resultCode._ext = []
    _LDAPResult_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _LDAPResult_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _LDAPResult_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    LDAPResult._cont = ASN1Dict([
        ('resultCode', _LDAPResult_resultCode),
        ('matchedDN', _LDAPResult_matchedDN),
        ('diagnosticMessage', _LDAPResult_diagnosticMessage),
        ('referral', _LDAPResult_referral),
        ])
    LDAPResult._ext = []
    
    #-----< Referral >-----#
    Referral = SEQ_OF(name='Referral', mode=MODE_TYPE)
    _Referral_uri = OCT_STR(name='uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    Referral._cont = _Referral_uri
    Referral._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< URI >-----#
    URI = OCT_STR(name='URI', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< Controls >-----#
    Controls = SEQ_OF(name='Controls', mode=MODE_TYPE)
    _Controls_control = SEQ(name='control', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Control')))
    Controls._cont = _Controls_control
    
    #-----< Control >-----#
    Control = SEQ(name='Control', mode=MODE_TYPE)
    _Control_controlType = OCT_STR(name='controlType', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _Control_criticality = BOOL(name='criticality', mode=MODE_TYPE, default=False)
    _Control_controlValue = OCT_STR(name='controlValue', mode=MODE_TYPE, opt=True)
    Control._cont = ASN1Dict([
        ('controlType', _Control_controlType),
        ('criticality', _Control_criticality),
        ('controlValue', _Control_controlValue),
        ])
    Control._ext = []
    
    #-----< BindRequest >-----#
    BindRequest = SEQ(name='BindRequest', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _BindRequest_version = INT(name='version', mode=MODE_TYPE)
    _BindRequest_version._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _BindRequest_name = OCT_STR(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindRequest_authentication = CHOICE(name='authentication', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AuthenticationChoice')))
    BindRequest._cont = ASN1Dict([
        ('version', _BindRequest_version),
        ('name', _BindRequest_name),
        ('authentication', _BindRequest_authentication),
        ])
    BindRequest._ext = []
    
    #-----< AuthenticationChoice >-----#
    AuthenticationChoice = CHOICE(name='AuthenticationChoice', mode=MODE_TYPE)
    _AuthenticationChoice_simple = OCT_STR(name='simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationChoice_sasl = SEQ(name='sasl', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SaslCredentials')))
    AuthenticationChoice._cont = ASN1Dict([
        ('simple', _AuthenticationChoice_simple),
        ('sasl', _AuthenticationChoice_sasl),
        ])
    AuthenticationChoice._ext = []
    
    #-----< SaslCredentials >-----#
    SaslCredentials = SEQ(name='SaslCredentials', mode=MODE_TYPE)
    _SaslCredentials_mechanism = OCT_STR(name='mechanism', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _SaslCredentials_credentials = OCT_STR(name='credentials', mode=MODE_TYPE, opt=True)
    SaslCredentials._cont = ASN1Dict([
        ('mechanism', _SaslCredentials_mechanism),
        ('credentials', _SaslCredentials_credentials),
        ])
    SaslCredentials._ext = []
    
    #-----< BindResponse >-----#
    BindResponse = SEQ(name='BindResponse', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _BindResponse_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _BindResponse_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _BindResponse_resultCode._ext = []
    _BindResponse_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindResponse_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _BindResponse_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _BindResponse_serverSaslCreds = OCT_STR(name='serverSaslCreds', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BindResponse._cont = ASN1Dict([
        ('resultCode', _BindResponse_resultCode),
        ('matchedDN', _BindResponse_matchedDN),
        ('diagnosticMessage', _BindResponse_diagnosticMessage),
        ('referral', _BindResponse_referral),
        ('serverSaslCreds', _BindResponse_serverSaslCreds),
        ])
    BindResponse._ext = []
    
    #-----< UnbindRequest >-----#
    UnbindRequest = NULL(name='UnbindRequest', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    
    #-----< SearchRequest >-----#
    SearchRequest = SEQ(name='SearchRequest', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchRequest_baseObject = OCT_STR(name='baseObject', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchRequest_scope = ENUM(name='scope', mode=MODE_TYPE)
    _SearchRequest_scope._cont = ASN1Dict([('baseObject', 0), ('singleLevel', 1), ('wholeSubtree', 2)])
    _SearchRequest_scope._ext = []
    _SearchRequest_derefAliases = ENUM(name='derefAliases', mode=MODE_TYPE)
    _SearchRequest_derefAliases._cont = ASN1Dict([('neverDerefAliases', 0), ('derefInSearching', 1), ('derefFindingBaseObj', 2), ('derefAlways', 3)])
    _SearchRequest_derefAliases._ext = []
    _SearchRequest_sizeLimit = INT(name='sizeLimit', mode=MODE_TYPE)
    _SearchRequest_sizeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_timeLimit = INT(name='timeLimit', mode=MODE_TYPE)
    _SearchRequest_timeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_typesOnly = BOOL(name='typesOnly', mode=MODE_TYPE)
    _SearchRequest_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _SearchRequest_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeSelection')))
    SearchRequest._cont = ASN1Dict([
        ('baseObject', _SearchRequest_baseObject),
        ('scope', _SearchRequest_scope),
        ('derefAliases', _SearchRequest_derefAliases),
        ('sizeLimit', _SearchRequest_sizeLimit),
        ('timeLimit', _SearchRequest_timeLimit),
        ('typesOnly', _SearchRequest_typesOnly),
        ('filter', _SearchRequest_filter),
        ('attributes', _SearchRequest_attributes),
        ])
    SearchRequest._ext = []
    
    #-----< AttributeSelection >-----#
    AttributeSelection = SEQ_OF(name='AttributeSelection', mode=MODE_TYPE)
    _AttributeSelection_selector = OCT_STR(name='selector', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    AttributeSelection._cont = _AttributeSelection_selector
    
    #-----< Filter >-----#
    Filter = CHOICE(name='Filter', mode=MODE_TYPE)
    _Filter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_and__filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_and_._cont = __Filter_and__filter
    _Filter_and_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_or__filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_or_._cont = __Filter_or__filter
    _Filter_or_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_equalityMatch = SEQ(name='equalityMatch', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_substrings = SEQ(name='substrings', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SubstringFilter')))
    _Filter_greaterOrEqual = SEQ(name='greaterOrEqual', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_lessOrEqual = SEQ(name='lessOrEqual', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_present = OCT_STR(name='present', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _Filter_approxMatch = SEQ(name='approxMatch', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_extensibleMatch = SEQ(name='extensibleMatch', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleAssertion')))
    Filter._cont = ASN1Dict([
        ('and', _Filter_and_),
        ('or', _Filter_or_),
        ('not', _Filter_not_),
        ('equalityMatch', _Filter_equalityMatch),
        ('substrings', _Filter_substrings),
        ('greaterOrEqual', _Filter_greaterOrEqual),
        ('lessOrEqual', _Filter_lessOrEqual),
        ('present', _Filter_present),
        ('approxMatch', _Filter_approxMatch),
        ('extensibleMatch', _Filter_extensibleMatch),
        ])
    Filter._ext = []
    
    #-----< SubstringFilter >-----#
    SubstringFilter = SEQ(name='SubstringFilter', mode=MODE_TYPE)
    _SubstringFilter_type = OCT_STR(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _SubstringFilter_substrings = SEQ_OF(name='substrings', mode=MODE_TYPE)
    __SubstringFilter_substrings_substring = CHOICE(name='substring', mode=MODE_TYPE)
    ___SubstringFilter_substrings_substring_initial = OCT_STR(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_any = OCT_STR(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_final = OCT_STR(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    __SubstringFilter_substrings_substring._cont = ASN1Dict([
        ('initial', ___SubstringFilter_substrings_substring_initial),
        ('any', ___SubstringFilter_substrings_substring_any),
        ('final', ___SubstringFilter_substrings_substring_final),
        ])
    __SubstringFilter_substrings_substring._ext = []
    _SubstringFilter_substrings._cont = __SubstringFilter_substrings_substring
    _SubstringFilter_substrings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SubstringFilter._cont = ASN1Dict([
        ('type', _SubstringFilter_type),
        ('substrings', _SubstringFilter_substrings),
        ])
    SubstringFilter._ext = []
    
    #-----< MatchingRuleAssertion >-----#
    MatchingRuleAssertion = SEQ(name='MatchingRuleAssertion', mode=MODE_TYPE)
    _MatchingRuleAssertion_matchingRule = OCT_STR(name='matchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleId')), opt=True)
    _MatchingRuleAssertion_type = OCT_STR(name='type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')), opt=True)
    _MatchingRuleAssertion_matchValue = OCT_STR(name='matchValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    _MatchingRuleAssertion_dnAttributes = BOOL(name='dnAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    MatchingRuleAssertion._cont = ASN1Dict([
        ('matchingRule', _MatchingRuleAssertion_matchingRule),
        ('type', _MatchingRuleAssertion_type),
        ('matchValue', _MatchingRuleAssertion_matchValue),
        ('dnAttributes', _MatchingRuleAssertion_dnAttributes),
        ])
    MatchingRuleAssertion._ext = []
    
    #-----< SearchResultEntry >-----#
    SearchResultEntry = SEQ(name='SearchResultEntry', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultEntry_objectName = OCT_STR(name='objectName', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchResultEntry_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttributeList')))
    SearchResultEntry._cont = ASN1Dict([
        ('objectName', _SearchResultEntry_objectName),
        ('attributes', _SearchResultEntry_attributes),
        ])
    SearchResultEntry._ext = []
    
    #-----< PartialAttributeList >-----#
    PartialAttributeList = SEQ_OF(name='PartialAttributeList', mode=MODE_TYPE)
    _PartialAttributeList_partialAttribute = SEQ(name='partialAttribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    PartialAttributeList._cont = _PartialAttributeList_partialAttribute
    
    #-----< SearchResultReference >-----#
    SearchResultReference = SEQ_OF(name='SearchResultReference', mode=MODE_TYPE, tag=(19, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultReference_uri = OCT_STR(name='uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    SearchResultReference._cont = _SearchResultReference_uri
    SearchResultReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SearchResultDone >-----#
    SearchResultDone = SEQ(name='SearchResultDone', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyRequest >-----#
    ModifyRequest = SEQ(name='ModifyRequest', mode=MODE_TYPE, tag=(6, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyRequest_object = OCT_STR(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyRequest_changes = SEQ_OF(name='changes', mode=MODE_TYPE)
    __ModifyRequest_changes_change = SEQ(name='change', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation = ENUM(name='operation', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation._cont = ASN1Dict([('add', 0), ('delete', 1), ('replace', 2)])
    ___ModifyRequest_changes_change_operation._ext = []
    ___ModifyRequest_changes_change_modification = SEQ(name='modification', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    __ModifyRequest_changes_change._cont = ASN1Dict([
        ('operation', ___ModifyRequest_changes_change_operation),
        ('modification', ___ModifyRequest_changes_change_modification),
        ])
    __ModifyRequest_changes_change._ext = []
    _ModifyRequest_changes._cont = __ModifyRequest_changes_change
    ModifyRequest._cont = ASN1Dict([
        ('object', _ModifyRequest_object),
        ('changes', _ModifyRequest_changes),
        ])
    ModifyRequest._ext = []
    
    #-----< ModifyResponse >-----#
    ModifyResponse = SEQ(name='ModifyResponse', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AddRequest >-----#
    AddRequest = SEQ(name='AddRequest', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    _AddRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _AddRequest_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeList')))
    AddRequest._cont = ASN1Dict([
        ('entry', _AddRequest_entry),
        ('attributes', _AddRequest_attributes),
        ])
    AddRequest._ext = []
    
    #-----< AttributeList >-----#
    AttributeList = SEQ_OF(name='AttributeList', mode=MODE_TYPE)
    _AttributeList_attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Attribute')))
    AttributeList._cont = _AttributeList_attribute
    
    #-----< AddResponse >-----#
    AddResponse = SEQ(name='AddResponse', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< DelRequest >-----#
    DelRequest = OCT_STR(name='DelRequest', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    
    #-----< DelResponse >-----#
    DelResponse = SEQ(name='DelResponse', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyDNRequest >-----#
    ModifyDNRequest = SEQ(name='ModifyDNRequest', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyDNRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyDNRequest_newrdn = OCT_STR(name='newrdn', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'RelativeLDAPDN')))
    _ModifyDNRequest_deleteoldrdn = BOOL(name='deleteoldrdn', mode=MODE_TYPE)
    _ModifyDNRequest_newSuperior = OCT_STR(name='newSuperior', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')), opt=True)
    ModifyDNRequest._cont = ASN1Dict([
        ('entry', _ModifyDNRequest_entry),
        ('newrdn', _ModifyDNRequest_newrdn),
        ('deleteoldrdn', _ModifyDNRequest_deleteoldrdn),
        ('newSuperior', _ModifyDNRequest_newSuperior),
        ])
    ModifyDNRequest._ext = []
    
    #-----< ModifyDNResponse >-----#
    ModifyDNResponse = SEQ(name='ModifyDNResponse', mode=MODE_TYPE, tag=(13, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< CompareRequest >-----#
    CompareRequest = SEQ(name='CompareRequest', mode=MODE_TYPE, tag=(14, TAG_APPLICATION, TAG_IMPLICIT))
    _CompareRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _CompareRequest_ava = SEQ(name='ava', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    CompareRequest._cont = ASN1Dict([
        ('entry', _CompareRequest_entry),
        ('ava', _CompareRequest_ava),
        ])
    CompareRequest._ext = []
    
    #-----< CompareResponse >-----#
    CompareResponse = SEQ(name='CompareResponse', mode=MODE_TYPE, tag=(15, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AbandonRequest >-----#
    AbandonRequest = INT(name='AbandonRequest', mode=MODE_TYPE, tag=(16, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    
    #-----< ExtendedRequest >-----#
    ExtendedRequest = SEQ(name='ExtendedRequest', mode=MODE_TYPE, tag=(23, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedRequest_requestName = OCT_STR(name='requestName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _ExtendedRequest_requestValue = OCT_STR(name='requestValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedRequest._cont = ASN1Dict([
        ('requestName', _ExtendedRequest_requestName),
        ('requestValue', _ExtendedRequest_requestValue),
        ])
    ExtendedRequest._ext = []
    
    #-----< ExtendedResponse >-----#
    ExtendedResponse = SEQ(name='ExtendedResponse', mode=MODE_TYPE, tag=(24, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedResponse_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _ExtendedResponse_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _ExtendedResponse_resultCode._ext = []
    _ExtendedResponse_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ExtendedResponse_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _ExtendedResponse_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _ExtendedResponse_responseName = OCT_STR(name='responseName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _ExtendedResponse_responseValue = OCT_STR(name='responseValue', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedResponse._cont = ASN1Dict([
        ('resultCode', _ExtendedResponse_resultCode),
        ('matchedDN', _ExtendedResponse_matchedDN),
        ('diagnosticMessage', _ExtendedResponse_diagnosticMessage),
        ('referral', _ExtendedResponse_referral),
        ('responseName', _ExtendedResponse_responseName),
        ('responseValue', _ExtendedResponse_responseValue),
        ])
    ExtendedResponse._ext = []
    
    #-----< IntermediateResponse >-----#
    IntermediateResponse = SEQ(name='IntermediateResponse', mode=MODE_TYPE, tag=(25, TAG_APPLICATION, TAG_IMPLICIT))
    _IntermediateResponse_responseName = OCT_STR(name='responseName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _IntermediateResponse_responseValue = OCT_STR(name='responseValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IntermediateResponse._cont = ASN1Dict([
        ('responseName', _IntermediateResponse_responseName),
        ('responseValue', _IntermediateResponse_responseValue),
        ])
    IntermediateResponse._ext = []
    
    _all_ = [
        _LDAPMessage_messageID,
        __LDAPMessage_protocolOp_bindRequest,
        __LDAPMessage_protocolOp_bindResponse,
        __LDAPMessage_protocolOp_unbindRequest,
        __LDAPMessage_protocolOp_searchRequest,
        __LDAPMessage_protocolOp_searchResEntry,
        __LDAPMessage_protocolOp_searchResDone,
        __LDAPMessage_protocolOp_searchResRef,
        __LDAPMessage_protocolOp_modifyRequest,
        __LDAPMessage_protocolOp_modifyResponse,
        __LDAPMessage_protocolOp_addRequest,
        __LDAPMessage_protocolOp_addResponse,
        __LDAPMessage_protocolOp_delRequest,
        __LDAPMessage_protocolOp_delResponse,
        __LDAPMessage_protocolOp_modDNRequest,
        __LDAPMessage_protocolOp_modDNResponse,
        __LDAPMessage_protocolOp_compareRequest,
        __LDAPMessage_protocolOp_compareResponse,
        __LDAPMessage_protocolOp_abandonRequest,
        __LDAPMessage_protocolOp_extendedReq,
        __LDAPMessage_protocolOp_extendedResp,
        __LDAPMessage_protocolOp_intermediateResponse,
        _LDAPMessage_protocolOp,
        _LDAPMessage_controls,
        LDAPMessage,
        MessageID,
        maxInt,
        LDAPString,
        LDAPOID,
        LDAPDN,
        RelativeLDAPDN,
        AttributeDescription,
        AttributeValue,
        _AttributeValueAssertion_attributeDesc,
        _AttributeValueAssertion_assertionValue,
        AttributeValueAssertion,
        AssertionValue,
        _PartialAttribute_type,
        __PartialAttribute_vals_value,
        _PartialAttribute_vals,
        PartialAttribute,
        Attribute,
        MatchingRuleId,
        _LDAPResult_resultCode,
        _LDAPResult_matchedDN,
        _LDAPResult_diagnosticMessage,
        _LDAPResult_referral,
        LDAPResult,
        _Referral_uri,
        Referral,
        URI,
        _Controls_control,
        Controls,
        _Control_controlType,
        _Control_criticality,
        _Control_controlValue,
        Control,
        _BindRequest_version,
        _BindRequest_name,
        _BindRequest_authentication,
        BindRequest,
        _AuthenticationChoice_simple,
        _AuthenticationChoice_sasl,
        AuthenticationChoice,
        _SaslCredentials_mechanism,
        _SaslCredentials_credentials,
        SaslCredentials,
        _BindResponse_resultCode,
        _BindResponse_matchedDN,
        _BindResponse_diagnosticMessage,
        _BindResponse_referral,
        _BindResponse_serverSaslCreds,
        BindResponse,
        UnbindRequest,
        _SearchRequest_baseObject,
        _SearchRequest_scope,
        _SearchRequest_derefAliases,
        _SearchRequest_sizeLimit,
        _SearchRequest_timeLimit,
        _SearchRequest_typesOnly,
        _SearchRequest_filter,
        _SearchRequest_attributes,
        SearchRequest,
        _AttributeSelection_selector,
        AttributeSelection,
        __Filter_and__filter,
        _Filter_and_,
        __Filter_or__filter,
        _Filter_or_,
        _Filter_not_,
        _Filter_equalityMatch,
        _Filter_substrings,
        _Filter_greaterOrEqual,
        _Filter_lessOrEqual,
        _Filter_present,
        _Filter_approxMatch,
        _Filter_extensibleMatch,
        Filter,
        _SubstringFilter_type,
        ___SubstringFilter_substrings_substring_initial,
        ___SubstringFilter_substrings_substring_any,
        ___SubstringFilter_substrings_substring_final,
        __SubstringFilter_substrings_substring,
        _SubstringFilter_substrings,
        SubstringFilter,
        _MatchingRuleAssertion_matchingRule,
        _MatchingRuleAssertion_type,
        _MatchingRuleAssertion_matchValue,
        _MatchingRuleAssertion_dnAttributes,
        MatchingRuleAssertion,
        _SearchResultEntry_objectName,
        _SearchResultEntry_attributes,
        SearchResultEntry,
        _PartialAttributeList_partialAttribute,
        PartialAttributeList,
        _SearchResultReference_uri,
        SearchResultReference,
        SearchResultDone,
        _ModifyRequest_object,
        ___ModifyRequest_changes_change_operation,
        ___ModifyRequest_changes_change_modification,
        __ModifyRequest_changes_change,
        _ModifyRequest_changes,
        ModifyRequest,
        ModifyResponse,
        _AddRequest_entry,
        _AddRequest_attributes,
        AddRequest,
        _AttributeList_attribute,
        AttributeList,
        AddResponse,
        DelRequest,
        DelResponse,
        _ModifyDNRequest_entry,
        _ModifyDNRequest_newrdn,
        _ModifyDNRequest_deleteoldrdn,
        _ModifyDNRequest_newSuperior,
        ModifyDNRequest,
        ModifyDNResponse,
        _CompareRequest_entry,
        _CompareRequest_ava,
        CompareRequest,
        CompareResponse,
        AbandonRequest,
        _ExtendedRequest_requestName,
        _ExtendedRequest_requestValue,
        ExtendedRequest,
        _ExtendedResponse_resultCode,
        _ExtendedResponse_matchedDN,
        _ExtendedResponse_diagnosticMessage,
        _ExtendedResponse_referral,
        _ExtendedResponse_responseName,
        _ExtendedResponse_responseValue,
        ExtendedResponse,
        _IntermediateResponse_responseName,
        _IntermediateResponse_responseValue,
        IntermediateResponse,
    ]

class MAP_BS_Code:

    _name_  = 'MAP-BS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 20, 19]
    
    _obj_ = [
        'BearerServiceCode',
        'Ext-BearerServiceCode',
        'allBearerServices',
        'allDataCDA-Services',
        'dataCDA-300bps',
        'dataCDA-1200bps',
        'dataCDA-1200-75bps',
        'dataCDA-2400bps',
        'dataCDA-4800bps',
        'dataCDA-9600bps',
        'general-dataCDA',
        'allDataCDS-Services',
        'dataCDS-1200bps',
        'dataCDS-2400bps',
        'dataCDS-4800bps',
        'dataCDS-9600bps',
        'general-dataCDS',
        'allPadAccessCA-Services',
        'padAccessCA-300bps',
        'padAccessCA-1200bps',
        'padAccessCA-1200-75bps',
        'padAccessCA-2400bps',
        'padAccessCA-4800bps',
        'padAccessCA-9600bps',
        'general-padAccessCA',
        'allDataPDS-Services',
        'dataPDS-2400bps',
        'dataPDS-4800bps',
        'dataPDS-9600bps',
        'general-dataPDS',
        'allAlternateSpeech-DataCDA',
        'allAlternateSpeech-DataCDS',
        'allSpeechFollowedByDataCDA',
        'allSpeechFollowedByDataCDS',
        'allDataCircuitAsynchronous',
        'allAsynchronousServices',
        'allDataCircuitSynchronous',
        'allSynchronousServices',
        'allPLMN-specificBS',
        'plmn-specificBS-1',
        'plmn-specificBS-2',
        'plmn-specificBS-3',
        'plmn-specificBS-4',
        'plmn-specificBS-5',
        'plmn-specificBS-6',
        'plmn-specificBS-7',
        'plmn-specificBS-8',
        'plmn-specificBS-9',
        'plmn-specificBS-A',
        'plmn-specificBS-B',
        'plmn-specificBS-C',
        'plmn-specificBS-D',
        'plmn-specificBS-E',
        'plmn-specificBS-F',
        ]
    _type_ = [
        'BearerServiceCode',
        'Ext-BearerServiceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        'allBearerServices',
        'allDataCDA-Services',
        'dataCDA-300bps',
        'dataCDA-1200bps',
        'dataCDA-1200-75bps',
        'dataCDA-2400bps',
        'dataCDA-4800bps',
        'dataCDA-9600bps',
        'general-dataCDA',
        'allDataCDS-Services',
        'dataCDS-1200bps',
        'dataCDS-2400bps',
        'dataCDS-4800bps',
        'dataCDS-9600bps',
        'general-dataCDS',
        'allPadAccessCA-Services',
        'padAccessCA-300bps',
        'padAccessCA-1200bps',
        'padAccessCA-1200-75bps',
        'padAccessCA-2400bps',
        'padAccessCA-4800bps',
        'padAccessCA-9600bps',
        'general-padAccessCA',
        'allDataPDS-Services',
        'dataPDS-2400bps',
        'dataPDS-4800bps',
        'dataPDS-9600bps',
        'general-dataPDS',
        'allAlternateSpeech-DataCDA',
        'allAlternateSpeech-DataCDS',
        'allSpeechFollowedByDataCDA',
        'allSpeechFollowedByDataCDS',
        'allDataCircuitAsynchronous',
        'allAsynchronousServices',
        'allDataCircuitSynchronous',
        'allSynchronousServices',
        'allPLMN-specificBS',
        'plmn-specificBS-1',
        'plmn-specificBS-2',
        'plmn-specificBS-3',
        'plmn-specificBS-4',
        'plmn-specificBS-5',
        'plmn-specificBS-6',
        'plmn-specificBS-7',
        'plmn-specificBS-8',
        'plmn-specificBS-9',
        'plmn-specificBS-A',
        'plmn-specificBS-B',
        'plmn-specificBS-C',
        'plmn-specificBS-D',
        'plmn-specificBS-E',
        'plmn-specificBS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BearerServiceCode >-----#
    BearerServiceCode = OCT_STR(name='BearerServiceCode', mode=MODE_TYPE)
    BearerServiceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-BearerServiceCode >-----#
    Ext_BearerServiceCode = OCT_STR(name='Ext-BearerServiceCode', mode=MODE_TYPE)
    Ext_BearerServiceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allBearerServices >-----#
    allBearerServices = OCT_STR(name='allBearerServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allBearerServices._val = b'\x00'
    
    #-----< allDataCDA-Services >-----#
    allDataCDA_Services = OCT_STR(name='allDataCDA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDA_Services._val = b'\x10'
    
    #-----< dataCDA-300bps >-----#
    dataCDA_300bps = OCT_STR(name='dataCDA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_300bps._val = b'\x11'
    
    #-----< dataCDA-1200bps >-----#
    dataCDA_1200bps = OCT_STR(name='dataCDA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200bps._val = b'\x12'
    
    #-----< dataCDA-1200-75bps >-----#
    dataCDA_1200_75bps = OCT_STR(name='dataCDA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200_75bps._val = b'\x13'
    
    #-----< dataCDA-2400bps >-----#
    dataCDA_2400bps = OCT_STR(name='dataCDA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_2400bps._val = b'\x14'
    
    #-----< dataCDA-4800bps >-----#
    dataCDA_4800bps = OCT_STR(name='dataCDA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_4800bps._val = b'\x15'
    
    #-----< dataCDA-9600bps >-----#
    dataCDA_9600bps = OCT_STR(name='dataCDA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_9600bps._val = b'\x16'
    
    #-----< general-dataCDA >-----#
    general_dataCDA = OCT_STR(name='general-dataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDA._val = b'\x17'
    
    #-----< allDataCDS-Services >-----#
    allDataCDS_Services = OCT_STR(name='allDataCDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDS_Services._val = b'\x18'
    
    #-----< dataCDS-1200bps >-----#
    dataCDS_1200bps = OCT_STR(name='dataCDS-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_1200bps._val = b'\x1a'
    
    #-----< dataCDS-2400bps >-----#
    dataCDS_2400bps = OCT_STR(name='dataCDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_2400bps._val = b'\x1c'
    
    #-----< dataCDS-4800bps >-----#
    dataCDS_4800bps = OCT_STR(name='dataCDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_4800bps._val = b'\x1d'
    
    #-----< dataCDS-9600bps >-----#
    dataCDS_9600bps = OCT_STR(name='dataCDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_9600bps._val = b'\x1e'
    
    #-----< general-dataCDS >-----#
    general_dataCDS = OCT_STR(name='general-dataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDS._val = b'\x1f'
    
    #-----< allPadAccessCA-Services >-----#
    allPadAccessCA_Services = OCT_STR(name='allPadAccessCA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPadAccessCA_Services._val = b' '
    
    #-----< padAccessCA-300bps >-----#
    padAccessCA_300bps = OCT_STR(name='padAccessCA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_300bps._val = b'!'
    
    #-----< padAccessCA-1200bps >-----#
    padAccessCA_1200bps = OCT_STR(name='padAccessCA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200bps._val = b'"'
    
    #-----< padAccessCA-1200-75bps >-----#
    padAccessCA_1200_75bps = OCT_STR(name='padAccessCA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200_75bps._val = b'#'
    
    #-----< padAccessCA-2400bps >-----#
    padAccessCA_2400bps = OCT_STR(name='padAccessCA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_2400bps._val = b'$'
    
    #-----< padAccessCA-4800bps >-----#
    padAccessCA_4800bps = OCT_STR(name='padAccessCA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_4800bps._val = b'%'
    
    #-----< padAccessCA-9600bps >-----#
    padAccessCA_9600bps = OCT_STR(name='padAccessCA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_9600bps._val = b'&'
    
    #-----< general-padAccessCA >-----#
    general_padAccessCA = OCT_STR(name='general-padAccessCA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_padAccessCA._val = b"'"
    
    #-----< allDataPDS-Services >-----#
    allDataPDS_Services = OCT_STR(name='allDataPDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataPDS_Services._val = b'('
    
    #-----< dataPDS-2400bps >-----#
    dataPDS_2400bps = OCT_STR(name='dataPDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_2400bps._val = b','
    
    #-----< dataPDS-4800bps >-----#
    dataPDS_4800bps = OCT_STR(name='dataPDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_4800bps._val = b'-'
    
    #-----< dataPDS-9600bps >-----#
    dataPDS_9600bps = OCT_STR(name='dataPDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_9600bps._val = b'.'
    
    #-----< general-dataPDS >-----#
    general_dataPDS = OCT_STR(name='general-dataPDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataPDS._val = b'/'
    
    #-----< allAlternateSpeech-DataCDA >-----#
    allAlternateSpeech_DataCDA = OCT_STR(name='allAlternateSpeech-DataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDA._val = b'0'
    
    #-----< allAlternateSpeech-DataCDS >-----#
    allAlternateSpeech_DataCDS = OCT_STR(name='allAlternateSpeech-DataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDS._val = b'8'
    
    #-----< allSpeechFollowedByDataCDA >-----#
    allSpeechFollowedByDataCDA = OCT_STR(name='allSpeechFollowedByDataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDA._val = b'@'
    
    #-----< allSpeechFollowedByDataCDS >-----#
    allSpeechFollowedByDataCDS = OCT_STR(name='allSpeechFollowedByDataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDS._val = b'H'
    
    #-----< allDataCircuitAsynchronous >-----#
    allDataCircuitAsynchronous = OCT_STR(name='allDataCircuitAsynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitAsynchronous._val = b'P'
    
    #-----< allAsynchronousServices >-----#
    allAsynchronousServices = OCT_STR(name='allAsynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAsynchronousServices._val = b'`'
    
    #-----< allDataCircuitSynchronous >-----#
    allDataCircuitSynchronous = OCT_STR(name='allDataCircuitSynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitSynchronous._val = b'X'
    
    #-----< allSynchronousServices >-----#
    allSynchronousServices = OCT_STR(name='allSynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSynchronousServices._val = b'h'
    
    #-----< allPLMN-specificBS >-----#
    allPLMN_specificBS = OCT_STR(name='allPLMN-specificBS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPLMN_specificBS._val = b'\xd0'
    
    #-----< plmn-specificBS-1 >-----#
    plmn_specificBS_1 = OCT_STR(name='plmn-specificBS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_1._val = b'\xd1'
    
    #-----< plmn-specificBS-2 >-----#
    plmn_specificBS_2 = OCT_STR(name='plmn-specificBS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_2._val = b'\xd2'
    
    #-----< plmn-specificBS-3 >-----#
    plmn_specificBS_3 = OCT_STR(name='plmn-specificBS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_3._val = b'\xd3'
    
    #-----< plmn-specificBS-4 >-----#
    plmn_specificBS_4 = OCT_STR(name='plmn-specificBS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_4._val = b'\xd4'
    
    #-----< plmn-specificBS-5 >-----#
    plmn_specificBS_5 = OCT_STR(name='plmn-specificBS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_5._val = b'\xd5'
    
    #-----< plmn-specificBS-6 >-----#
    plmn_specificBS_6 = OCT_STR(name='plmn-specificBS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_6._val = b'\xd6'
    
    #-----< plmn-specificBS-7 >-----#
    plmn_specificBS_7 = OCT_STR(name='plmn-specificBS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_7._val = b'\xd7'
    
    #-----< plmn-specificBS-8 >-----#
    plmn_specificBS_8 = OCT_STR(name='plmn-specificBS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_8._val = b'\xd8'
    
    #-----< plmn-specificBS-9 >-----#
    plmn_specificBS_9 = OCT_STR(name='plmn-specificBS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_9._val = b'\xd9'
    
    #-----< plmn-specificBS-A >-----#
    plmn_specificBS_A = OCT_STR(name='plmn-specificBS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_A._val = b'\xda'
    
    #-----< plmn-specificBS-B >-----#
    plmn_specificBS_B = OCT_STR(name='plmn-specificBS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_B._val = b'\xdb'
    
    #-----< plmn-specificBS-C >-----#
    plmn_specificBS_C = OCT_STR(name='plmn-specificBS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_C._val = b'\xdc'
    
    #-----< plmn-specificBS-D >-----#
    plmn_specificBS_D = OCT_STR(name='plmn-specificBS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_D._val = b'\xdd'
    
    #-----< plmn-specificBS-E >-----#
    plmn_specificBS_E = OCT_STR(name='plmn-specificBS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_E._val = b'\xde'
    
    #-----< plmn-specificBS-F >-----#
    plmn_specificBS_F = OCT_STR(name='plmn-specificBS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_F._val = b'\xdf'
    
    _all_ = [
        BearerServiceCode,
        Ext_BearerServiceCode,
        allBearerServices,
        allDataCDA_Services,
        dataCDA_300bps,
        dataCDA_1200bps,
        dataCDA_1200_75bps,
        dataCDA_2400bps,
        dataCDA_4800bps,
        dataCDA_9600bps,
        general_dataCDA,
        allDataCDS_Services,
        dataCDS_1200bps,
        dataCDS_2400bps,
        dataCDS_4800bps,
        dataCDS_9600bps,
        general_dataCDS,
        allPadAccessCA_Services,
        padAccessCA_300bps,
        padAccessCA_1200bps,
        padAccessCA_1200_75bps,
        padAccessCA_2400bps,
        padAccessCA_4800bps,
        padAccessCA_9600bps,
        general_padAccessCA,
        allDataPDS_Services,
        dataPDS_2400bps,
        dataPDS_4800bps,
        dataPDS_9600bps,
        general_dataPDS,
        allAlternateSpeech_DataCDA,
        allAlternateSpeech_DataCDS,
        allSpeechFollowedByDataCDA,
        allSpeechFollowedByDataCDS,
        allDataCircuitAsynchronous,
        allAsynchronousServices,
        allDataCircuitSynchronous,
        allSynchronousServices,
        allPLMN_specificBS,
        plmn_specificBS_1,
        plmn_specificBS_2,
        plmn_specificBS_3,
        plmn_specificBS_4,
        plmn_specificBS_5,
        plmn_specificBS_6,
        plmn_specificBS_7,
        plmn_specificBS_8,
        plmn_specificBS_9,
        plmn_specificBS_A,
        plmn_specificBS_B,
        plmn_specificBS_C,
        plmn_specificBS_D,
        plmn_specificBS_E,
        plmn_specificBS_F,
    ]

class MAP_CH_DataTypes:

    _name_  = 'MAP-CH-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 13, 19]
    
    _obj_ = [
        'CUG-CheckInfo',
        'NumberOfForwarding',
        'SendRoutingInfoArg',
        'SuppressionOfAnnouncement',
        'SuppressMTSS',
        'InterrogationType',
        'OR-Phase',
        'CallReferenceNumber',
        'ForwardingReason',
        'SupportedCCBS-Phase',
        'CallDiversionTreatmentIndicator',
        'SendRoutingInfoRes',
        'AllowedServices',
        'UnavailabilityCause',
        'CCBS-Indicators',
        'RoutingInfo',
        'ForwardingData',
        'ProvideRoamingNumberArg',
        'ProvideRoamingNumberRes',
        'ResumeCallHandlingArg',
        'UU-Data',
        'UUIndicator',
        'UUI',
        'ResumeCallHandlingRes',
        'CamelInfo',
        'ExtendedRoutingInfo',
        'CamelRoutingInfo',
        'GmscCamelSubscriptionInfo',
        'SetReportingStateArg',
        'ReportingState',
        'SetReportingStateRes',
        'CCBS-SubscriberStatus',
        'StatusReportArg',
        'EventReportData',
        'CallReportData',
        'MonitoringMode',
        'CallOutcome',
        'StatusReportRes',
        'RemoteUserFreeArg',
        'RemoteUserFreeRes',
        'RUF-Outcome',
        'IST-AlertArg',
        'IST-AlertRes',
        'IST-CommandArg',
        'IST-CommandRes',
        'CallTerminationIndicator',
        'ReleaseResourcesArg',
        'ReleaseResourcesRes',
        ]
    _type_ = [
        'CUG-CheckInfo',
        'NumberOfForwarding',
        'SendRoutingInfoArg',
        'SuppressionOfAnnouncement',
        'SuppressMTSS',
        'InterrogationType',
        'OR-Phase',
        'CallReferenceNumber',
        'ForwardingReason',
        'SupportedCCBS-Phase',
        'CallDiversionTreatmentIndicator',
        'SendRoutingInfoRes',
        'AllowedServices',
        'UnavailabilityCause',
        'CCBS-Indicators',
        'RoutingInfo',
        'ForwardingData',
        'ProvideRoamingNumberArg',
        'ProvideRoamingNumberRes',
        'ResumeCallHandlingArg',
        'UU-Data',
        'UUIndicator',
        'UUI',
        'ResumeCallHandlingRes',
        'CamelInfo',
        'ExtendedRoutingInfo',
        'CamelRoutingInfo',
        'GmscCamelSubscriptionInfo',
        'SetReportingStateArg',
        'ReportingState',
        'SetReportingStateRes',
        'CCBS-SubscriberStatus',
        'StatusReportArg',
        'EventReportData',
        'CallReportData',
        'MonitoringMode',
        'CallOutcome',
        'StatusReportRes',
        'RemoteUserFreeArg',
        'RemoteUserFreeRes',
        'RUF-Outcome',
        'IST-AlertArg',
        'IST-AlertRes',
        'IST-CommandArg',
        'IST-CommandRes',
        'CallTerminationIndicator',
        'ReleaseResourcesArg',
        'ReleaseResourcesRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CUG-CheckInfo >-----#
    CUG_CheckInfo = SEQ(name='CUG-CheckInfo', mode=MODE_TYPE)
    _CUG_CheckInfo_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_CheckInfo_cug_OutgoingAccess = NULL(name='cug-OutgoingAccess', mode=MODE_TYPE, opt=True)
    _CUG_CheckInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_CheckInfo._cont = ASN1Dict([
        ('cug-Interlock', _CUG_CheckInfo_cug_Interlock),
        ('cug-OutgoingAccess', _CUG_CheckInfo_cug_OutgoingAccess),
        ('extensionContainer', _CUG_CheckInfo_extensionContainer),
        ])
    CUG_CheckInfo._ext = []
    
    #-----< NumberOfForwarding >-----#
    NumberOfForwarding = INT(name='NumberOfForwarding', mode=MODE_TYPE)
    NumberOfForwarding._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< SendRoutingInfoArg >-----#
    SendRoutingInfoArg = SEQ(name='SendRoutingInfoArg', mode=MODE_TYPE)
    _SendRoutingInfoArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_cug_CheckInfo = SEQ(name='cug-CheckInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoArg_numberOfForwarding = INT(name='numberOfForwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    _SendRoutingInfoArg_interrogationType = ENUM(name='interrogationType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'InterrogationType')))
    _SendRoutingInfoArg_or_Interrogation = NULL(name='or-Interrogation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_or_Capability = INT(name='or-Capability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'OR-Phase')), opt=True)
    _SendRoutingInfoArg_gmsc_OrGsmSCF_Address = OCT_STR(name='gmsc-OrGsmSCF-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _SendRoutingInfoArg_forwardingReason = ENUM(name='forwardingReason', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingReason')), opt=True)
    _SendRoutingInfoArg_basicServiceGroup = CHOICE(name='basicServiceGroup', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo = SEQ(name='networkSignalInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_camelInfo = SEQ(name='camelInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelInfo')), opt=True)
    _SendRoutingInfoArg_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _SendRoutingInfoArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoArg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _SendRoutingInfoArg_ccbs_Call = NULL(name='ccbs-Call', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_supportedCCBS_Phase = INT(name='supportedCCBS-Phase', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SupportedCCBS-Phase')), opt=True)
    _SendRoutingInfoArg_additionalSignalInfo = SEQ(name='additionalSignalInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_istSupportIndicator = ENUM(name='istSupportIndicator', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _SendRoutingInfoArg_pre_pagingSupported = NULL(name='pre-pagingSupported', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callDiversionTreatmentIndicator = OCT_STR(name='callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallDiversionTreatmentIndicator')), opt=True)
    _SendRoutingInfoArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppress_VT_CSI = NULL(name='suppress-VT-CSI', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppressIncomingCallBarring = NULL(name='suppressIncomingCallBarring', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_gsmSCF_InitiatedCall = NULL(name='gsmSCF-InitiatedCall', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_basicServiceGroup2 = CHOICE(name='basicServiceGroup2', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo2 = SEQ(name='networkSignalInfo2', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_suppressMTSS = BIT_STR(name='suppressMTSS', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressMTSS')), opt=True)
    _SendRoutingInfoArg_mtRoamingRetrySupported = NULL(name='mtRoamingRetrySupported', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callPriority = INT(name='callPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    SendRoutingInfoArg._cont = ASN1Dict([
        ('msisdn', _SendRoutingInfoArg_msisdn),
        ('cug-CheckInfo', _SendRoutingInfoArg_cug_CheckInfo),
        ('numberOfForwarding', _SendRoutingInfoArg_numberOfForwarding),
        ('interrogationType', _SendRoutingInfoArg_interrogationType),
        ('or-Interrogation', _SendRoutingInfoArg_or_Interrogation),
        ('or-Capability', _SendRoutingInfoArg_or_Capability),
        ('gmsc-OrGsmSCF-Address', _SendRoutingInfoArg_gmsc_OrGsmSCF_Address),
        ('callReferenceNumber', _SendRoutingInfoArg_callReferenceNumber),
        ('forwardingReason', _SendRoutingInfoArg_forwardingReason),
        ('basicServiceGroup', _SendRoutingInfoArg_basicServiceGroup),
        ('networkSignalInfo', _SendRoutingInfoArg_networkSignalInfo),
        ('camelInfo', _SendRoutingInfoArg_camelInfo),
        ('suppressionOfAnnouncement', _SendRoutingInfoArg_suppressionOfAnnouncement),
        ('extensionContainer', _SendRoutingInfoArg_extensionContainer),
        ('alertingPattern', _SendRoutingInfoArg_alertingPattern),
        ('ccbs-Call', _SendRoutingInfoArg_ccbs_Call),
        ('supportedCCBS-Phase', _SendRoutingInfoArg_supportedCCBS_Phase),
        ('additionalSignalInfo', _SendRoutingInfoArg_additionalSignalInfo),
        ('istSupportIndicator', _SendRoutingInfoArg_istSupportIndicator),
        ('pre-pagingSupported', _SendRoutingInfoArg_pre_pagingSupported),
        ('callDiversionTreatmentIndicator', _SendRoutingInfoArg_callDiversionTreatmentIndicator),
        ('longFTN-Supported', _SendRoutingInfoArg_longFTN_Supported),
        ('suppress-VT-CSI', _SendRoutingInfoArg_suppress_VT_CSI),
        ('suppressIncomingCallBarring', _SendRoutingInfoArg_suppressIncomingCallBarring),
        ('gsmSCF-InitiatedCall', _SendRoutingInfoArg_gsmSCF_InitiatedCall),
        ('basicServiceGroup2', _SendRoutingInfoArg_basicServiceGroup2),
        ('networkSignalInfo2', _SendRoutingInfoArg_networkSignalInfo2),
        ('suppressMTSS', _SendRoutingInfoArg_suppressMTSS),
        ('mtRoamingRetrySupported', _SendRoutingInfoArg_mtRoamingRetrySupported),
        ('callPriority', _SendRoutingInfoArg_callPriority),
        ])
    SendRoutingInfoArg._ext = ['alertingPattern', 'ccbs-Call', 'supportedCCBS-Phase', 'additionalSignalInfo', 'istSupportIndicator', 'pre-pagingSupported', 'callDiversionTreatmentIndicator', 'longFTN-Supported', 'suppress-VT-CSI', 'suppressIncomingCallBarring', 'gsmSCF-InitiatedCall', 'basicServiceGroup2', 'networkSignalInfo2', 'suppressMTSS', 'mtRoamingRetrySupported', 'callPriority']
    
    #-----< SuppressionOfAnnouncement >-----#
    SuppressionOfAnnouncement = NULL(name='SuppressionOfAnnouncement', mode=MODE_TYPE)
    
    #-----< SuppressMTSS >-----#
    SuppressMTSS = BIT_STR(name='SuppressMTSS', mode=MODE_TYPE)
    SuppressMTSS._cont = ASN1Dict([('suppressCUG', 0), ('suppressCCBS', 1)])
    SuppressMTSS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< InterrogationType >-----#
    InterrogationType = ENUM(name='InterrogationType', mode=MODE_TYPE)
    InterrogationType._cont = ASN1Dict([('basicCall', 0), ('forwarding', 1)])
    InterrogationType._ext = None
    
    #-----< OR-Phase >-----#
    OR_Phase = INT(name='OR-Phase', mode=MODE_TYPE)
    OR_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallReferenceNumber >-----#
    CallReferenceNumber = OCT_STR(name='CallReferenceNumber', mode=MODE_TYPE)
    CallReferenceNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ForwardingReason >-----#
    ForwardingReason = ENUM(name='ForwardingReason', mode=MODE_TYPE)
    ForwardingReason._cont = ASN1Dict([('notReachable', 0), ('busy', 1), ('noReply', 2)])
    ForwardingReason._ext = None
    
    #-----< SupportedCCBS-Phase >-----#
    SupportedCCBS_Phase = INT(name='SupportedCCBS-Phase', mode=MODE_TYPE)
    SupportedCCBS_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallDiversionTreatmentIndicator >-----#
    CallDiversionTreatmentIndicator = OCT_STR(name='CallDiversionTreatmentIndicator', mode=MODE_TYPE)
    CallDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendRoutingInfoRes >-----#
    SendRoutingInfoRes = SEQ(name='SendRoutingInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendRoutingInfoRes_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendRoutingInfoRes_extendedRoutingInfo = CHOICE(name='extendedRoutingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ExtendedRoutingInfo')), opt=True)
    _SendRoutingInfoRes_cug_CheckInfo = SEQ(name='cug-CheckInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoRes_cugSubscriptionFlag = NULL(name='cugSubscriptionFlag', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_subscriberInfo = SEQ(name='subscriberInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')), opt=True)
    _SendRoutingInfoRes_ss_List = SEQ_OF(name='ss-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_forwardingInterrogationRequired = NULL(name='forwardingInterrogationRequired', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_vmsc_Address = OCT_STR(name='vmsc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoRes_naea_PreferredCI = SEQ(name='naea-PreferredCI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _SendRoutingInfoRes_ccbs_Indicators = SEQ(name='ccbs-Indicators', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-Indicators')), opt=True)
    _SendRoutingInfoRes_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_numberPortabilityStatus = ENUM(name='numberPortabilityStatus', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _SendRoutingInfoRes_istAlertTimer = INT(name='istAlertTimer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _SendRoutingInfoRes_supportedCamelPhasesInVMSC = BIT_STR(name='supportedCamelPhasesInVMSC', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SendRoutingInfoRes_offeredCamel4CSIsInVMSC = BIT_STR(name='offeredCamel4CSIsInVMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SendRoutingInfoRes_routingInfo2 = CHOICE(name='routingInfo2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')), opt=True)
    _SendRoutingInfoRes_ss_List2 = SEQ_OF(name='ss-List2', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService2 = CHOICE(name='basicService2', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_allowedServices = BIT_STR(name='allowedServices', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'AllowedServices')), opt=True)
    _SendRoutingInfoRes_unavailabilityCause = ENUM(name='unavailabilityCause', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UnavailabilityCause')), opt=True)
    _SendRoutingInfoRes_releaseResourcesSupported = NULL(name='releaseResourcesSupported', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_gsm_BearerCapability = SEQ(name='gsm-BearerCapability', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    SendRoutingInfoRes._cont = ASN1Dict([
        ('imsi', _SendRoutingInfoRes_imsi),
        ('extendedRoutingInfo', _SendRoutingInfoRes_extendedRoutingInfo),
        ('cug-CheckInfo', _SendRoutingInfoRes_cug_CheckInfo),
        ('cugSubscriptionFlag', _SendRoutingInfoRes_cugSubscriptionFlag),
        ('subscriberInfo', _SendRoutingInfoRes_subscriberInfo),
        ('ss-List', _SendRoutingInfoRes_ss_List),
        ('basicService', _SendRoutingInfoRes_basicService),
        ('forwardingInterrogationRequired', _SendRoutingInfoRes_forwardingInterrogationRequired),
        ('vmsc-Address', _SendRoutingInfoRes_vmsc_Address),
        ('extensionContainer', _SendRoutingInfoRes_extensionContainer),
        ('naea-PreferredCI', _SendRoutingInfoRes_naea_PreferredCI),
        ('ccbs-Indicators', _SendRoutingInfoRes_ccbs_Indicators),
        ('msisdn', _SendRoutingInfoRes_msisdn),
        ('numberPortabilityStatus', _SendRoutingInfoRes_numberPortabilityStatus),
        ('istAlertTimer', _SendRoutingInfoRes_istAlertTimer),
        ('supportedCamelPhasesInVMSC', _SendRoutingInfoRes_supportedCamelPhasesInVMSC),
        ('offeredCamel4CSIsInVMSC', _SendRoutingInfoRes_offeredCamel4CSIsInVMSC),
        ('routingInfo2', _SendRoutingInfoRes_routingInfo2),
        ('ss-List2', _SendRoutingInfoRes_ss_List2),
        ('basicService2', _SendRoutingInfoRes_basicService2),
        ('allowedServices', _SendRoutingInfoRes_allowedServices),
        ('unavailabilityCause', _SendRoutingInfoRes_unavailabilityCause),
        ('releaseResourcesSupported', _SendRoutingInfoRes_releaseResourcesSupported),
        ('gsm-BearerCapability', _SendRoutingInfoRes_gsm_BearerCapability),
        ])
    SendRoutingInfoRes._ext = ['naea-PreferredCI', 'ccbs-Indicators', 'msisdn', 'numberPortabilityStatus', 'istAlertTimer', 'supportedCamelPhasesInVMSC', 'offeredCamel4CSIsInVMSC', 'routingInfo2', 'ss-List2', 'basicService2', 'allowedServices', 'unavailabilityCause', 'releaseResourcesSupported', 'gsm-BearerCapability']
    
    #-----< AllowedServices >-----#
    AllowedServices = BIT_STR(name='AllowedServices', mode=MODE_TYPE)
    AllowedServices._cont = ASN1Dict([('firstServiceAllowed', 0), ('secondServiceAllowed', 1)])
    AllowedServices._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UnavailabilityCause >-----#
    UnavailabilityCause = ENUM(name='UnavailabilityCause', mode=MODE_TYPE)
    UnavailabilityCause._cont = ASN1Dict([('bearerServiceNotProvisioned', 1), ('teleserviceNotProvisioned', 2), ('absentSubscriber', 3), ('busySubscriber', 4), ('callBarred', 5), ('cug-Reject', 6)])
    UnavailabilityCause._ext = []
    
    #-----< CCBS-Indicators >-----#
    CCBS_Indicators = SEQ(name='CCBS-Indicators', mode=MODE_TYPE)
    _CCBS_Indicators_ccbs_Possible = NULL(name='ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_keepCCBS_CallIndicator = NULL(name='keepCCBS-CallIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CCBS_Indicators._cont = ASN1Dict([
        ('ccbs-Possible', _CCBS_Indicators_ccbs_Possible),
        ('keepCCBS-CallIndicator', _CCBS_Indicators_keepCCBS_CallIndicator),
        ('extensionContainer', _CCBS_Indicators_extensionContainer),
        ])
    CCBS_Indicators._ext = []
    
    #-----< RoutingInfo >-----#
    RoutingInfo = CHOICE(name='RoutingInfo', mode=MODE_TYPE)
    _RoutingInfo_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfo_forwardingData = SEQ(name='forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')))
    RoutingInfo._cont = ASN1Dict([
        ('roamingNumber', _RoutingInfo_roamingNumber),
        ('forwardingData', _RoutingInfo_forwardingData),
        ])
    RoutingInfo._ext = None
    
    #-----< ForwardingData >-----#
    ForwardingData = SEQ(name='ForwardingData', mode=MODE_TYPE)
    _ForwardingData_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingData_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingData_forwardingOptions = OCT_STR(name='forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardingData_longForwardedToNumber = OCT_STR(name='longForwardedToNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingData._cont = ASN1Dict([
        ('forwardedToNumber', _ForwardingData_forwardedToNumber),
        ('forwardedToSubaddress', _ForwardingData_forwardedToSubaddress),
        ('forwardingOptions', _ForwardingData_forwardingOptions),
        ('extensionContainer', _ForwardingData_extensionContainer),
        ('longForwardedToNumber', _ForwardingData_longForwardedToNumber),
        ])
    ForwardingData._ext = ['longForwardedToNumber']
    
    #-----< ProvideRoamingNumberArg >-----#
    ProvideRoamingNumberArg = SEQ(name='ProvideRoamingNumberArg', mode=MODE_TYPE)
    _ProvideRoamingNumberArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideRoamingNumberArg_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideRoamingNumberArg_gsm_BearerCapability = SEQ(name='gsm-BearerCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_networkSignalInfo = SEQ(name='networkSignalInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_suppressionOfAnnouncement = NULL(name='suppressionOfAnnouncement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _ProvideRoamingNumberArg_gmsc_Address = OCT_STR(name='gmsc-Address', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ProvideRoamingNumberArg_or_Interrogation = NULL(name='or-Interrogation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberArg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _ProvideRoamingNumberArg_ccbs_Call = NULL(name='ccbs-Call', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode = BIT_STR(name='supportedCamelPhasesInInterrogatingNode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _ProvideRoamingNumberArg_additionalSignalInfo = SEQ(name='additionalSignalInfo', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_orNotSupportedInGMSC = NULL(name='orNotSupportedInGMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pre_pagingSupported = NULL(name='pre-pagingSupported', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_suppress_VT_CSI = NULL(name='suppress-VT-CSI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode = BIT_STR(name='offeredCamel4CSIsInInterrogatingNode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _ProvideRoamingNumberArg_mtRoamingRetrySupported = NULL(name='mtRoamingRetrySupported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pagingArea = SEQ_OF(name='pagingArea', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _ProvideRoamingNumberArg_callPriority = INT(name='callPriority', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _ProvideRoamingNumberArg_mtrf_Indicator = NULL(name='mtrf-Indicator', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_oldMSC_Number = OCT_STR(name='oldMSC-Number', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lastUsedLtePLMN_Id = OCT_STR(name='lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    ProvideRoamingNumberArg._cont = ASN1Dict([
        ('imsi', _ProvideRoamingNumberArg_imsi),
        ('msc-Number', _ProvideRoamingNumberArg_msc_Number),
        ('msisdn', _ProvideRoamingNumberArg_msisdn),
        ('lmsi', _ProvideRoamingNumberArg_lmsi),
        ('gsm-BearerCapability', _ProvideRoamingNumberArg_gsm_BearerCapability),
        ('networkSignalInfo', _ProvideRoamingNumberArg_networkSignalInfo),
        ('suppressionOfAnnouncement', _ProvideRoamingNumberArg_suppressionOfAnnouncement),
        ('gmsc-Address', _ProvideRoamingNumberArg_gmsc_Address),
        ('callReferenceNumber', _ProvideRoamingNumberArg_callReferenceNumber),
        ('or-Interrogation', _ProvideRoamingNumberArg_or_Interrogation),
        ('extensionContainer', _ProvideRoamingNumberArg_extensionContainer),
        ('alertingPattern', _ProvideRoamingNumberArg_alertingPattern),
        ('ccbs-Call', _ProvideRoamingNumberArg_ccbs_Call),
        ('supportedCamelPhasesInInterrogatingNode', _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode),
        ('additionalSignalInfo', _ProvideRoamingNumberArg_additionalSignalInfo),
        ('orNotSupportedInGMSC', _ProvideRoamingNumberArg_orNotSupportedInGMSC),
        ('pre-pagingSupported', _ProvideRoamingNumberArg_pre_pagingSupported),
        ('longFTN-Supported', _ProvideRoamingNumberArg_longFTN_Supported),
        ('suppress-VT-CSI', _ProvideRoamingNumberArg_suppress_VT_CSI),
        ('offeredCamel4CSIsInInterrogatingNode', _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode),
        ('mtRoamingRetrySupported', _ProvideRoamingNumberArg_mtRoamingRetrySupported),
        ('pagingArea', _ProvideRoamingNumberArg_pagingArea),
        ('callPriority', _ProvideRoamingNumberArg_callPriority),
        ('mtrf-Indicator', _ProvideRoamingNumberArg_mtrf_Indicator),
        ('oldMSC-Number', _ProvideRoamingNumberArg_oldMSC_Number),
        ('lastUsedLtePLMN-Id', _ProvideRoamingNumberArg_lastUsedLtePLMN_Id),
        ])
    ProvideRoamingNumberArg._ext = ['alertingPattern', 'ccbs-Call', 'supportedCamelPhasesInInterrogatingNode', 'additionalSignalInfo', 'orNotSupportedInGMSC', 'pre-pagingSupported', 'longFTN-Supported', 'suppress-VT-CSI', 'offeredCamel4CSIsInInterrogatingNode', 'mtRoamingRetrySupported', 'pagingArea', 'callPriority', 'mtrf-Indicator', 'oldMSC-Number', 'lastUsedLtePLMN-Id']
    
    #-----< ProvideRoamingNumberRes >-----#
    ProvideRoamingNumberRes = SEQ(name='ProvideRoamingNumberRes', mode=MODE_TYPE)
    _ProvideRoamingNumberRes_roamingNumber = OCT_STR(name='roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberRes_releaseResourcesSupported = NULL(name='releaseResourcesSupported', mode=MODE_TYPE, opt=True)
    _ProvideRoamingNumberRes_vmsc_Address = OCT_STR(name='vmsc-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ProvideRoamingNumberRes._cont = ASN1Dict([
        ('roamingNumber', _ProvideRoamingNumberRes_roamingNumber),
        ('extensionContainer', _ProvideRoamingNumberRes_extensionContainer),
        ('releaseResourcesSupported', _ProvideRoamingNumberRes_releaseResourcesSupported),
        ('vmsc-Address', _ProvideRoamingNumberRes_vmsc_Address),
        ])
    ProvideRoamingNumberRes._ext = ['releaseResourcesSupported', 'vmsc-Address']
    
    #-----< ResumeCallHandlingArg >-----#
    ResumeCallHandlingArg = SEQ(name='ResumeCallHandlingArg', mode=MODE_TYPE)
    _ResumeCallHandlingArg_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup = CHOICE(name='basicServiceGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_forwardingData = SEQ(name='forwardingData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _ResumeCallHandlingArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ResumeCallHandlingArg_cug_CheckInfo = SEQ(name='cug-CheckInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _ResumeCallHandlingArg_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _ResumeCallHandlingArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResumeCallHandlingArg_ccbs_Possible = NULL(name='ccbs-Possible', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ResumeCallHandlingArg_uu_Data = SEQ(name='uu-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    _ResumeCallHandlingArg_allInformationSent = NULL(name='allInformationSent', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_d_csi = SEQ(name='d-csi', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList = SEQ_OF(name='o-BcsmCamelTDPCriteriaList', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup2 = CHOICE(name='basicServiceGroup2', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_mtRoamingRetry = NULL(name='mtRoamingRetry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ResumeCallHandlingArg._cont = ASN1Dict([
        ('callReferenceNumber', _ResumeCallHandlingArg_callReferenceNumber),
        ('basicServiceGroup', _ResumeCallHandlingArg_basicServiceGroup),
        ('forwardingData', _ResumeCallHandlingArg_forwardingData),
        ('imsi', _ResumeCallHandlingArg_imsi),
        ('cug-CheckInfo', _ResumeCallHandlingArg_cug_CheckInfo),
        ('o-CSI', _ResumeCallHandlingArg_o_CSI),
        ('extensionContainer', _ResumeCallHandlingArg_extensionContainer),
        ('ccbs-Possible', _ResumeCallHandlingArg_ccbs_Possible),
        ('msisdn', _ResumeCallHandlingArg_msisdn),
        ('uu-Data', _ResumeCallHandlingArg_uu_Data),
        ('allInformationSent', _ResumeCallHandlingArg_allInformationSent),
        ('d-csi', _ResumeCallHandlingArg_d_csi),
        ('o-BcsmCamelTDPCriteriaList', _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList),
        ('basicServiceGroup2', _ResumeCallHandlingArg_basicServiceGroup2),
        ('mtRoamingRetry', _ResumeCallHandlingArg_mtRoamingRetry),
        ])
    ResumeCallHandlingArg._ext = ['d-csi', 'o-BcsmCamelTDPCriteriaList', 'basicServiceGroup2', 'mtRoamingRetry']
    
    #-----< UU-Data >-----#
    UU_Data = SEQ(name='UU-Data', mode=MODE_TYPE)
    _UU_Data_uuIndicator = OCT_STR(name='uuIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUIndicator')), opt=True)
    _UU_Data_uui = OCT_STR(name='uui', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUI')), opt=True)
    _UU_Data_uusCFInteraction = NULL(name='uusCFInteraction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UU_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UU_Data._cont = ASN1Dict([
        ('uuIndicator', _UU_Data_uuIndicator),
        ('uui', _UU_Data_uui),
        ('uusCFInteraction', _UU_Data_uusCFInteraction),
        ('extensionContainer', _UU_Data_extensionContainer),
        ])
    UU_Data._ext = []
    
    #-----< UUIndicator >-----#
    UUIndicator = OCT_STR(name='UUIndicator', mode=MODE_TYPE)
    UUIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< UUI >-----#
    UUI = OCT_STR(name='UUI', mode=MODE_TYPE)
    UUI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131)], ev=None, er=[])
    
    #-----< ResumeCallHandlingRes >-----#
    ResumeCallHandlingRes = SEQ(name='ResumeCallHandlingRes', mode=MODE_TYPE)
    _ResumeCallHandlingRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResumeCallHandlingRes._cont = ASN1Dict([
        ('extensionContainer', _ResumeCallHandlingRes_extensionContainer),
        ])
    ResumeCallHandlingRes._ext = []
    
    #-----< CamelInfo >-----#
    CamelInfo = SEQ(name='CamelInfo', mode=MODE_TYPE)
    _CamelInfo_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')))
    _CamelInfo_suppress_T_CSI = NULL(name='suppress-T-CSI', mode=MODE_TYPE, opt=True)
    _CamelInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CamelInfo_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    CamelInfo._cont = ASN1Dict([
        ('supportedCamelPhases', _CamelInfo_supportedCamelPhases),
        ('suppress-T-CSI', _CamelInfo_suppress_T_CSI),
        ('extensionContainer', _CamelInfo_extensionContainer),
        ('offeredCamel4CSIs', _CamelInfo_offeredCamel4CSIs),
        ])
    CamelInfo._ext = ['offeredCamel4CSIs']
    
    #-----< ExtendedRoutingInfo >-----#
    ExtendedRoutingInfo = CHOICE(name='ExtendedRoutingInfo', mode=MODE_TYPE)
    _ExtendedRoutingInfo_routingInfo = CHOICE(name='routingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')))
    _ExtendedRoutingInfo_camelRoutingInfo = SEQ(name='camelRoutingInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelRoutingInfo')))
    ExtendedRoutingInfo._cont = ASN1Dict([
        ('routingInfo', _ExtendedRoutingInfo_routingInfo),
        ('camelRoutingInfo', _ExtendedRoutingInfo_camelRoutingInfo),
        ])
    ExtendedRoutingInfo._ext = None
    
    #-----< CamelRoutingInfo >-----#
    CamelRoutingInfo = SEQ(name='CamelRoutingInfo', mode=MODE_TYPE)
    _CamelRoutingInfo_forwardingData = SEQ(name='forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _CamelRoutingInfo_gmscCamelSubscriptionInfo = SEQ(name='gmscCamelSubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'GmscCamelSubscriptionInfo')))
    _CamelRoutingInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CamelRoutingInfo._cont = ASN1Dict([
        ('forwardingData', _CamelRoutingInfo_forwardingData),
        ('gmscCamelSubscriptionInfo', _CamelRoutingInfo_gmscCamelSubscriptionInfo),
        ('extensionContainer', _CamelRoutingInfo_extensionContainer),
        ])
    CamelRoutingInfo._ext = []
    
    #-----< GmscCamelSubscriptionInfo >-----#
    GmscCamelSubscriptionInfo = SEQ(name='GmscCamelSubscriptionInfo', mode=MODE_TYPE)
    _GmscCamelSubscriptionInfo_t_CSI = SEQ(name='t-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='t-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_d_csi = SEQ(name='d-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    GmscCamelSubscriptionInfo._cont = ASN1Dict([
        ('t-CSI', _GmscCamelSubscriptionInfo_t_CSI),
        ('o-CSI', _GmscCamelSubscriptionInfo_o_CSI),
        ('extensionContainer', _GmscCamelSubscriptionInfo_extensionContainer),
        ('o-BcsmCamelTDP-CriteriaList', _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        ('t-BCSM-CAMEL-TDP-CriteriaList', _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        ('d-csi', _GmscCamelSubscriptionInfo_d_csi),
        ])
    GmscCamelSubscriptionInfo._ext = ['o-BcsmCamelTDP-CriteriaList', 't-BCSM-CAMEL-TDP-CriteriaList', 'd-csi']
    
    #-----< SetReportingStateArg >-----#
    SetReportingStateArg = SEQ(name='SetReportingStateArg', mode=MODE_TYPE)
    _SetReportingStateArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SetReportingStateArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _SetReportingStateArg_ccbs_Monitoring = ENUM(name='ccbs-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ReportingState')), opt=True)
    _SetReportingStateArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateArg._cont = ASN1Dict([
        ('imsi', _SetReportingStateArg_imsi),
        ('lmsi', _SetReportingStateArg_lmsi),
        ('ccbs-Monitoring', _SetReportingStateArg_ccbs_Monitoring),
        ('extensionContainer', _SetReportingStateArg_extensionContainer),
        ])
    SetReportingStateArg._ext = []
    
    #-----< ReportingState >-----#
    ReportingState = ENUM(name='ReportingState', mode=MODE_TYPE)
    ReportingState._cont = ASN1Dict([('stopMonitoring', 0), ('startMonitoring', 1)])
    ReportingState._ext = []
    
    #-----< SetReportingStateRes >-----#
    SetReportingStateRes = SEQ(name='SetReportingStateRes', mode=MODE_TYPE)
    _SetReportingStateRes_ccbs_SubscriberStatus = ENUM(name='ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _SetReportingStateRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateRes._cont = ASN1Dict([
        ('ccbs-SubscriberStatus', _SetReportingStateRes_ccbs_SubscriberStatus),
        ('extensionContainer', _SetReportingStateRes_extensionContainer),
        ])
    SetReportingStateRes._ext = []
    
    #-----< CCBS-SubscriberStatus >-----#
    CCBS_SubscriberStatus = ENUM(name='CCBS-SubscriberStatus', mode=MODE_TYPE)
    CCBS_SubscriberStatus._cont = ASN1Dict([('ccbsNotIdle', 0), ('ccbsIdle', 1), ('ccbsNotReachable', 2)])
    CCBS_SubscriberStatus._ext = []
    
    #-----< StatusReportArg >-----#
    StatusReportArg = SEQ(name='StatusReportArg', mode=MODE_TYPE)
    _StatusReportArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _StatusReportArg_eventReportData = SEQ(name='eventReportData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'EventReportData')), opt=True)
    _StatusReportArg_callReportdata = SEQ(name='callReportdata', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReportData')), opt=True)
    _StatusReportArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportArg._cont = ASN1Dict([
        ('imsi', _StatusReportArg_imsi),
        ('eventReportData', _StatusReportArg_eventReportData),
        ('callReportdata', _StatusReportArg_callReportdata),
        ('extensionContainer', _StatusReportArg_extensionContainer),
        ])
    StatusReportArg._ext = []
    
    #-----< EventReportData >-----#
    EventReportData = SEQ(name='EventReportData', mode=MODE_TYPE)
    _EventReportData_ccbs_SubscriberStatus = ENUM(name='ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _EventReportData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EventReportData._cont = ASN1Dict([
        ('ccbs-SubscriberStatus', _EventReportData_ccbs_SubscriberStatus),
        ('extensionContainer', _EventReportData_extensionContainer),
        ])
    EventReportData._ext = []
    
    #-----< CallReportData >-----#
    CallReportData = SEQ(name='CallReportData', mode=MODE_TYPE)
    _CallReportData_monitoringMode = ENUM(name='monitoringMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'MonitoringMode')), opt=True)
    _CallReportData_callOutcome = ENUM(name='callOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallOutcome')), opt=True)
    _CallReportData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallReportData._cont = ASN1Dict([
        ('monitoringMode', _CallReportData_monitoringMode),
        ('callOutcome', _CallReportData_callOutcome),
        ('extensionContainer', _CallReportData_extensionContainer),
        ])
    CallReportData._ext = []
    
    #-----< MonitoringMode >-----#
    MonitoringMode = ENUM(name='MonitoringMode', mode=MODE_TYPE)
    MonitoringMode._cont = ASN1Dict([('a-side', 0), ('b-side', 1)])
    MonitoringMode._ext = []
    
    #-----< CallOutcome >-----#
    CallOutcome = ENUM(name='CallOutcome', mode=MODE_TYPE)
    CallOutcome._cont = ASN1Dict([('success', 0), ('failure', 1), ('busy', 2)])
    CallOutcome._ext = []
    
    #-----< StatusReportRes >-----#
    StatusReportRes = SEQ(name='StatusReportRes', mode=MODE_TYPE)
    _StatusReportRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportRes._cont = ASN1Dict([
        ('extensionContainer', _StatusReportRes_extensionContainer),
        ])
    StatusReportRes._ext = []
    
    #-----< RemoteUserFreeArg >-----#
    RemoteUserFreeArg = SEQ(name='RemoteUserFreeArg', mode=MODE_TYPE)
    _RemoteUserFreeArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RemoteUserFreeArg_callInfo = SEQ(name='callInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _RemoteUserFreeArg_ccbs_Feature = SEQ(name='ccbs-Feature', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _RemoteUserFreeArg_translatedB_Number = OCT_STR(name='translatedB-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RemoteUserFreeArg_replaceB_Number = NULL(name='replaceB-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RemoteUserFreeArg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _RemoteUserFreeArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeArg._cont = ASN1Dict([
        ('imsi', _RemoteUserFreeArg_imsi),
        ('callInfo', _RemoteUserFreeArg_callInfo),
        ('ccbs-Feature', _RemoteUserFreeArg_ccbs_Feature),
        ('translatedB-Number', _RemoteUserFreeArg_translatedB_Number),
        ('replaceB-Number', _RemoteUserFreeArg_replaceB_Number),
        ('alertingPattern', _RemoteUserFreeArg_alertingPattern),
        ('extensionContainer', _RemoteUserFreeArg_extensionContainer),
        ])
    RemoteUserFreeArg._ext = []
    
    #-----< RemoteUserFreeRes >-----#
    RemoteUserFreeRes = SEQ(name='RemoteUserFreeRes', mode=MODE_TYPE)
    _RemoteUserFreeRes_ruf_Outcome = ENUM(name='ruf-Outcome', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RUF-Outcome')))
    _RemoteUserFreeRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeRes._cont = ASN1Dict([
        ('ruf-Outcome', _RemoteUserFreeRes_ruf_Outcome),
        ('extensionContainer', _RemoteUserFreeRes_extensionContainer),
        ])
    RemoteUserFreeRes._ext = []
    
    #-----< RUF-Outcome >-----#
    RUF_Outcome = ENUM(name='RUF-Outcome', mode=MODE_TYPE)
    RUF_Outcome._cont = ASN1Dict([('accepted', 0), ('rejected', 1), ('noResponseFromFreeMS', 2), ('noResponseFromBusyMS', 3), ('udubFromFreeMS', 4), ('udubFromBusyMS', 5)])
    RUF_Outcome._ext = []
    
    #-----< IST-AlertArg >-----#
    IST_AlertArg = SEQ(name='IST-AlertArg', mode=MODE_TYPE)
    _IST_AlertArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_AlertArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertArg._cont = ASN1Dict([
        ('imsi', _IST_AlertArg_imsi),
        ('extensionContainer', _IST_AlertArg_extensionContainer),
        ])
    IST_AlertArg._ext = []
    
    #-----< IST-AlertRes >-----#
    IST_AlertRes = SEQ(name='IST-AlertRes', mode=MODE_TYPE)
    _IST_AlertRes_istAlertTimer = INT(name='istAlertTimer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _IST_AlertRes_istInformationWithdraw = NULL(name='istInformationWithdraw', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IST_AlertRes_callTerminationIndicator = ENUM(name='callTerminationIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallTerminationIndicator')), opt=True)
    _IST_AlertRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertRes._cont = ASN1Dict([
        ('istAlertTimer', _IST_AlertRes_istAlertTimer),
        ('istInformationWithdraw', _IST_AlertRes_istInformationWithdraw),
        ('callTerminationIndicator', _IST_AlertRes_callTerminationIndicator),
        ('extensionContainer', _IST_AlertRes_extensionContainer),
        ])
    IST_AlertRes._ext = []
    
    #-----< IST-CommandArg >-----#
    IST_CommandArg = SEQ(name='IST-CommandArg', mode=MODE_TYPE)
    _IST_CommandArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_CommandArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandArg._cont = ASN1Dict([
        ('imsi', _IST_CommandArg_imsi),
        ('extensionContainer', _IST_CommandArg_extensionContainer),
        ])
    IST_CommandArg._ext = []
    
    #-----< IST-CommandRes >-----#
    IST_CommandRes = SEQ(name='IST-CommandRes', mode=MODE_TYPE)
    _IST_CommandRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandRes._cont = ASN1Dict([
        ('extensionContainer', _IST_CommandRes_extensionContainer),
        ])
    IST_CommandRes._ext = []
    
    #-----< CallTerminationIndicator >-----#
    CallTerminationIndicator = ENUM(name='CallTerminationIndicator', mode=MODE_TYPE)
    CallTerminationIndicator._cont = ASN1Dict([('terminateCallActivityReferred', 0), ('terminateAllCallActivities', 1)])
    CallTerminationIndicator._ext = []
    
    #-----< ReleaseResourcesArg >-----#
    ReleaseResourcesArg = SEQ(name='ReleaseResourcesArg', mode=MODE_TYPE)
    _ReleaseResourcesArg_msrn = OCT_STR(name='msrn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ReleaseResourcesArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesArg._cont = ASN1Dict([
        ('msrn', _ReleaseResourcesArg_msrn),
        ('extensionContainer', _ReleaseResourcesArg_extensionContainer),
        ])
    ReleaseResourcesArg._ext = []
    
    #-----< ReleaseResourcesRes >-----#
    ReleaseResourcesRes = SEQ(name='ReleaseResourcesRes', mode=MODE_TYPE)
    _ReleaseResourcesRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesRes._cont = ASN1Dict([
        ('extensionContainer', _ReleaseResourcesRes_extensionContainer),
        ])
    ReleaseResourcesRes._ext = []
    
    _all_ = [
        _CUG_CheckInfo_cug_Interlock,
        _CUG_CheckInfo_cug_OutgoingAccess,
        _CUG_CheckInfo_extensionContainer,
        CUG_CheckInfo,
        NumberOfForwarding,
        _SendRoutingInfoArg_msisdn,
        _SendRoutingInfoArg_cug_CheckInfo,
        _SendRoutingInfoArg_numberOfForwarding,
        _SendRoutingInfoArg_interrogationType,
        _SendRoutingInfoArg_or_Interrogation,
        _SendRoutingInfoArg_or_Capability,
        _SendRoutingInfoArg_gmsc_OrGsmSCF_Address,
        _SendRoutingInfoArg_callReferenceNumber,
        _SendRoutingInfoArg_forwardingReason,
        _SendRoutingInfoArg_basicServiceGroup,
        _SendRoutingInfoArg_networkSignalInfo,
        _SendRoutingInfoArg_camelInfo,
        _SendRoutingInfoArg_suppressionOfAnnouncement,
        _SendRoutingInfoArg_extensionContainer,
        _SendRoutingInfoArg_alertingPattern,
        _SendRoutingInfoArg_ccbs_Call,
        _SendRoutingInfoArg_supportedCCBS_Phase,
        _SendRoutingInfoArg_additionalSignalInfo,
        _SendRoutingInfoArg_istSupportIndicator,
        _SendRoutingInfoArg_pre_pagingSupported,
        _SendRoutingInfoArg_callDiversionTreatmentIndicator,
        _SendRoutingInfoArg_longFTN_Supported,
        _SendRoutingInfoArg_suppress_VT_CSI,
        _SendRoutingInfoArg_suppressIncomingCallBarring,
        _SendRoutingInfoArg_gsmSCF_InitiatedCall,
        _SendRoutingInfoArg_basicServiceGroup2,
        _SendRoutingInfoArg_networkSignalInfo2,
        _SendRoutingInfoArg_suppressMTSS,
        _SendRoutingInfoArg_mtRoamingRetrySupported,
        _SendRoutingInfoArg_callPriority,
        SendRoutingInfoArg,
        SuppressionOfAnnouncement,
        SuppressMTSS,
        InterrogationType,
        OR_Phase,
        CallReferenceNumber,
        ForwardingReason,
        SupportedCCBS_Phase,
        CallDiversionTreatmentIndicator,
        _SendRoutingInfoRes_imsi,
        _SendRoutingInfoRes_extendedRoutingInfo,
        _SendRoutingInfoRes_cug_CheckInfo,
        _SendRoutingInfoRes_cugSubscriptionFlag,
        _SendRoutingInfoRes_subscriberInfo,
        _SendRoutingInfoRes_ss_List,
        _SendRoutingInfoRes_basicService,
        _SendRoutingInfoRes_forwardingInterrogationRequired,
        _SendRoutingInfoRes_vmsc_Address,
        _SendRoutingInfoRes_extensionContainer,
        _SendRoutingInfoRes_naea_PreferredCI,
        _SendRoutingInfoRes_ccbs_Indicators,
        _SendRoutingInfoRes_msisdn,
        _SendRoutingInfoRes_numberPortabilityStatus,
        _SendRoutingInfoRes_istAlertTimer,
        _SendRoutingInfoRes_supportedCamelPhasesInVMSC,
        _SendRoutingInfoRes_offeredCamel4CSIsInVMSC,
        _SendRoutingInfoRes_routingInfo2,
        _SendRoutingInfoRes_ss_List2,
        _SendRoutingInfoRes_basicService2,
        _SendRoutingInfoRes_allowedServices,
        _SendRoutingInfoRes_unavailabilityCause,
        _SendRoutingInfoRes_releaseResourcesSupported,
        _SendRoutingInfoRes_gsm_BearerCapability,
        SendRoutingInfoRes,
        AllowedServices,
        UnavailabilityCause,
        _CCBS_Indicators_ccbs_Possible,
        _CCBS_Indicators_keepCCBS_CallIndicator,
        _CCBS_Indicators_extensionContainer,
        CCBS_Indicators,
        _RoutingInfo_roamingNumber,
        _RoutingInfo_forwardingData,
        RoutingInfo,
        _ForwardingData_forwardedToNumber,
        _ForwardingData_forwardedToSubaddress,
        _ForwardingData_forwardingOptions,
        _ForwardingData_extensionContainer,
        _ForwardingData_longForwardedToNumber,
        ForwardingData,
        _ProvideRoamingNumberArg_imsi,
        _ProvideRoamingNumberArg_msc_Number,
        _ProvideRoamingNumberArg_msisdn,
        _ProvideRoamingNumberArg_lmsi,
        _ProvideRoamingNumberArg_gsm_BearerCapability,
        _ProvideRoamingNumberArg_networkSignalInfo,
        _ProvideRoamingNumberArg_suppressionOfAnnouncement,
        _ProvideRoamingNumberArg_gmsc_Address,
        _ProvideRoamingNumberArg_callReferenceNumber,
        _ProvideRoamingNumberArg_or_Interrogation,
        _ProvideRoamingNumberArg_extensionContainer,
        _ProvideRoamingNumberArg_alertingPattern,
        _ProvideRoamingNumberArg_ccbs_Call,
        _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode,
        _ProvideRoamingNumberArg_additionalSignalInfo,
        _ProvideRoamingNumberArg_orNotSupportedInGMSC,
        _ProvideRoamingNumberArg_pre_pagingSupported,
        _ProvideRoamingNumberArg_longFTN_Supported,
        _ProvideRoamingNumberArg_suppress_VT_CSI,
        _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode,
        _ProvideRoamingNumberArg_mtRoamingRetrySupported,
        _ProvideRoamingNumberArg_pagingArea,
        _ProvideRoamingNumberArg_callPriority,
        _ProvideRoamingNumberArg_mtrf_Indicator,
        _ProvideRoamingNumberArg_oldMSC_Number,
        _ProvideRoamingNumberArg_lastUsedLtePLMN_Id,
        ProvideRoamingNumberArg,
        _ProvideRoamingNumberRes_roamingNumber,
        _ProvideRoamingNumberRes_extensionContainer,
        _ProvideRoamingNumberRes_releaseResourcesSupported,
        _ProvideRoamingNumberRes_vmsc_Address,
        ProvideRoamingNumberRes,
        _ResumeCallHandlingArg_callReferenceNumber,
        _ResumeCallHandlingArg_basicServiceGroup,
        _ResumeCallHandlingArg_forwardingData,
        _ResumeCallHandlingArg_imsi,
        _ResumeCallHandlingArg_cug_CheckInfo,
        _ResumeCallHandlingArg_o_CSI,
        _ResumeCallHandlingArg_extensionContainer,
        _ResumeCallHandlingArg_ccbs_Possible,
        _ResumeCallHandlingArg_msisdn,
        _ResumeCallHandlingArg_uu_Data,
        _ResumeCallHandlingArg_allInformationSent,
        _ResumeCallHandlingArg_d_csi,
        _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList,
        _ResumeCallHandlingArg_basicServiceGroup2,
        _ResumeCallHandlingArg_mtRoamingRetry,
        ResumeCallHandlingArg,
        _UU_Data_uuIndicator,
        _UU_Data_uui,
        _UU_Data_uusCFInteraction,
        _UU_Data_extensionContainer,
        UU_Data,
        UUIndicator,
        UUI,
        _ResumeCallHandlingRes_extensionContainer,
        ResumeCallHandlingRes,
        _CamelInfo_supportedCamelPhases,
        _CamelInfo_suppress_T_CSI,
        _CamelInfo_extensionContainer,
        _CamelInfo_offeredCamel4CSIs,
        CamelInfo,
        _ExtendedRoutingInfo_routingInfo,
        _ExtendedRoutingInfo_camelRoutingInfo,
        ExtendedRoutingInfo,
        _CamelRoutingInfo_forwardingData,
        _CamelRoutingInfo_gmscCamelSubscriptionInfo,
        _CamelRoutingInfo_extensionContainer,
        CamelRoutingInfo,
        _GmscCamelSubscriptionInfo_t_CSI,
        _GmscCamelSubscriptionInfo_o_CSI,
        _GmscCamelSubscriptionInfo_extensionContainer,
        _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _GmscCamelSubscriptionInfo_d_csi,
        GmscCamelSubscriptionInfo,
        _SetReportingStateArg_imsi,
        _SetReportingStateArg_lmsi,
        _SetReportingStateArg_ccbs_Monitoring,
        _SetReportingStateArg_extensionContainer,
        SetReportingStateArg,
        ReportingState,
        _SetReportingStateRes_ccbs_SubscriberStatus,
        _SetReportingStateRes_extensionContainer,
        SetReportingStateRes,
        CCBS_SubscriberStatus,
        _StatusReportArg_imsi,
        _StatusReportArg_eventReportData,
        _StatusReportArg_callReportdata,
        _StatusReportArg_extensionContainer,
        StatusReportArg,
        _EventReportData_ccbs_SubscriberStatus,
        _EventReportData_extensionContainer,
        EventReportData,
        _CallReportData_monitoringMode,
        _CallReportData_callOutcome,
        _CallReportData_extensionContainer,
        CallReportData,
        MonitoringMode,
        CallOutcome,
        _StatusReportRes_extensionContainer,
        StatusReportRes,
        _RemoteUserFreeArg_imsi,
        _RemoteUserFreeArg_callInfo,
        _RemoteUserFreeArg_ccbs_Feature,
        _RemoteUserFreeArg_translatedB_Number,
        _RemoteUserFreeArg_replaceB_Number,
        _RemoteUserFreeArg_alertingPattern,
        _RemoteUserFreeArg_extensionContainer,
        RemoteUserFreeArg,
        _RemoteUserFreeRes_ruf_Outcome,
        _RemoteUserFreeRes_extensionContainer,
        RemoteUserFreeRes,
        RUF_Outcome,
        _IST_AlertArg_imsi,
        _IST_AlertArg_extensionContainer,
        IST_AlertArg,
        _IST_AlertRes_istAlertTimer,
        _IST_AlertRes_istInformationWithdraw,
        _IST_AlertRes_callTerminationIndicator,
        _IST_AlertRes_extensionContainer,
        IST_AlertRes,
        _IST_CommandArg_imsi,
        _IST_CommandArg_extensionContainer,
        IST_CommandArg,
        _IST_CommandRes_extensionContainer,
        IST_CommandRes,
        CallTerminationIndicator,
        _ReleaseResourcesArg_msrn,
        _ReleaseResourcesArg_extensionContainer,
        ReleaseResourcesArg,
        _ReleaseResourcesRes_extensionContainer,
        ReleaseResourcesRes,
    ]

class MAP_CommonDataTypes:

    _name_  = 'MAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 18, 19]
    
    _obj_ = [
        'TBCD-STRING',
        'DiameterIdentity',
        'AddressString',
        'maxAddressLength',
        'ISDN-AddressString',
        'maxISDN-AddressLength',
        'FTN-AddressString',
        'maxFTN-AddressLength',
        'ISDN-SubaddressString',
        'maxISDN-SubaddressLength',
        'ExternalSignalInfo',
        'SignalInfo',
        'maxSignalInfoLength',
        'ProtocolId',
        'Ext-ExternalSignalInfo',
        'Ext-ProtocolId',
        'AccessNetworkSignalInfo',
        'LongSignalInfo',
        'maxLongSignalInfoLength',
        'AccessNetworkProtocolId',
        'AlertingPattern',
        'alertingLevel-0',
        'alertingLevel-1',
        'alertingLevel-2',
        'alertingCategory-1',
        'alertingCategory-2',
        'alertingCategory-3',
        'alertingCategory-4',
        'alertingCategory-5',
        'GSN-Address',
        'Time',
        'IMSI',
        'Identity',
        'IMSI-WithLMSI',
        'ASCI-CallReference',
        'TMSI',
        'SubscriberId',
        'IMEI',
        'HLR-Id',
        'HLR-List',
        'maxNumOfHLR-Id',
        'LMSI',
        'GlobalCellId',
        'NetworkResource',
        'AdditionalNetworkResource',
        'NAEA-PreferredCI',
        'NAEA-CIC',
        'SubscriberIdentity',
        'LCSClientExternalID',
        'LCSClientInternalID',
        'LCSServiceTypeID',
        'emergencyServices',
        'emergencyAlertServices',
        'personTracking',
        'fleetManagement',
        'assetManagement',
        'trafficCongestionReporting',
        'roadsideAssistance',
        'routingToNearestCommercialEnterprise',
        'navigation',
        'citySightseeing',
        'localizedAdvertising',
        'mobileYellowPages',
        'trafficAndPublicTransportationInfo',
        'weather',
        'assetAndServiceFinding',
        'gaming',
        'findYourFriend',
        'dating',
        'chatting',
        'routeFinding',
        'whereAmI',
        'serv64',
        'serv65',
        'serv66',
        'serv67',
        'serv68',
        'serv69',
        'serv70',
        'serv71',
        'serv72',
        'serv73',
        'serv74',
        'serv75',
        'serv76',
        'serv77',
        'serv78',
        'serv79',
        'serv80',
        'serv81',
        'serv82',
        'serv83',
        'serv84',
        'serv85',
        'serv86',
        'serv87',
        'serv88',
        'serv89',
        'serv90',
        'serv91',
        'serv92',
        'serv93',
        'serv94',
        'serv95',
        'serv96',
        'serv97',
        'serv98',
        'serv99',
        'serv100',
        'serv101',
        'serv102',
        'serv103',
        'serv104',
        'serv105',
        'serv106',
        'serv107',
        'serv108',
        'serv109',
        'serv110',
        'serv111',
        'serv112',
        'serv113',
        'serv114',
        'serv115',
        'serv116',
        'serv117',
        'serv118',
        'serv119',
        'serv120',
        'serv121',
        'serv122',
        'serv123',
        'serv124',
        'serv125',
        'serv126',
        'serv127',
        'PLMN-Id',
        'E-UTRAN-CGI',
        'NR-CGI',
        'TA-Id',
        'NR-TA-Id',
        'RAIdentity',
        'NetworkNodeDiameterAddress',
        'CellGlobalIdOrServiceAreaIdOrLAI',
        'CellGlobalIdOrServiceAreaIdFixedLength',
        'LAIFixedLength',
        'BasicServiceCode',
        'Ext-BasicServiceCode',
        'EMLPP-Info',
        'EMLPP-Priority',
        'priorityLevelA',
        'priorityLevelB',
        'priorityLevel0',
        'priorityLevel1',
        'priorityLevel2',
        'priorityLevel3',
        'priorityLevel4',
        'MC-SS-Info',
        'MaxMC-Bearers',
        'MC-Bearers',
        'maxNumOfMC-Bearers',
        'Ext-SS-Status',
        'AgeOfLocationInformation',
        ]
    _type_ = [
        'TBCD-STRING',
        'DiameterIdentity',
        'AddressString',
        'ISDN-AddressString',
        'FTN-AddressString',
        'ISDN-SubaddressString',
        'ExternalSignalInfo',
        'SignalInfo',
        'ProtocolId',
        'Ext-ExternalSignalInfo',
        'Ext-ProtocolId',
        'AccessNetworkSignalInfo',
        'LongSignalInfo',
        'AccessNetworkProtocolId',
        'AlertingPattern',
        'GSN-Address',
        'Time',
        'IMSI',
        'Identity',
        'IMSI-WithLMSI',
        'ASCI-CallReference',
        'TMSI',
        'SubscriberId',
        'IMEI',
        'HLR-Id',
        'HLR-List',
        'LMSI',
        'GlobalCellId',
        'NetworkResource',
        'AdditionalNetworkResource',
        'NAEA-PreferredCI',
        'NAEA-CIC',
        'SubscriberIdentity',
        'LCSClientExternalID',
        'LCSClientInternalID',
        'LCSServiceTypeID',
        'PLMN-Id',
        'E-UTRAN-CGI',
        'NR-CGI',
        'TA-Id',
        'NR-TA-Id',
        'RAIdentity',
        'NetworkNodeDiameterAddress',
        'CellGlobalIdOrServiceAreaIdOrLAI',
        'CellGlobalIdOrServiceAreaIdFixedLength',
        'LAIFixedLength',
        'BasicServiceCode',
        'Ext-BasicServiceCode',
        'EMLPP-Info',
        'EMLPP-Priority',
        'MC-SS-Info',
        'MaxMC-Bearers',
        'MC-Bearers',
        'Ext-SS-Status',
        'AgeOfLocationInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxAddressLength',
        'maxISDN-AddressLength',
        'maxFTN-AddressLength',
        'maxISDN-SubaddressLength',
        'maxSignalInfoLength',
        'maxLongSignalInfoLength',
        'alertingLevel-0',
        'alertingLevel-1',
        'alertingLevel-2',
        'alertingCategory-1',
        'alertingCategory-2',
        'alertingCategory-3',
        'alertingCategory-4',
        'alertingCategory-5',
        'maxNumOfHLR-Id',
        'emergencyServices',
        'emergencyAlertServices',
        'personTracking',
        'fleetManagement',
        'assetManagement',
        'trafficCongestionReporting',
        'roadsideAssistance',
        'routingToNearestCommercialEnterprise',
        'navigation',
        'citySightseeing',
        'localizedAdvertising',
        'mobileYellowPages',
        'trafficAndPublicTransportationInfo',
        'weather',
        'assetAndServiceFinding',
        'gaming',
        'findYourFriend',
        'dating',
        'chatting',
        'routeFinding',
        'whereAmI',
        'serv64',
        'serv65',
        'serv66',
        'serv67',
        'serv68',
        'serv69',
        'serv70',
        'serv71',
        'serv72',
        'serv73',
        'serv74',
        'serv75',
        'serv76',
        'serv77',
        'serv78',
        'serv79',
        'serv80',
        'serv81',
        'serv82',
        'serv83',
        'serv84',
        'serv85',
        'serv86',
        'serv87',
        'serv88',
        'serv89',
        'serv90',
        'serv91',
        'serv92',
        'serv93',
        'serv94',
        'serv95',
        'serv96',
        'serv97',
        'serv98',
        'serv99',
        'serv100',
        'serv101',
        'serv102',
        'serv103',
        'serv104',
        'serv105',
        'serv106',
        'serv107',
        'serv108',
        'serv109',
        'serv110',
        'serv111',
        'serv112',
        'serv113',
        'serv114',
        'serv115',
        'serv116',
        'serv117',
        'serv118',
        'serv119',
        'serv120',
        'serv121',
        'serv122',
        'serv123',
        'serv124',
        'serv125',
        'serv126',
        'serv127',
        'priorityLevelA',
        'priorityLevelB',
        'priorityLevel0',
        'priorityLevel1',
        'priorityLevel2',
        'priorityLevel3',
        'priorityLevel4',
        'maxNumOfMC-Bearers',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name='TBCD-STRING', mode=MODE_TYPE)
    
    #-----< DiameterIdentity >-----#
    DiameterIdentity = OCT_STR(name='DiameterIdentity', mode=MODE_TYPE)
    DiameterIdentity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< AddressString >-----#
    AddressString = OCT_STR(name='AddressString', mode=MODE_TYPE)
    AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxAddressLength >-----#
    maxAddressLength = INT(name='maxAddressLength', mode=MODE_VALUE)
    maxAddressLength._val = 20
    
    #-----< ISDN-AddressString >-----#
    ISDN_AddressString = OCT_STR(name='ISDN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    ISDN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxISDN-AddressLength >-----#
    maxISDN_AddressLength = INT(name='maxISDN-AddressLength', mode=MODE_VALUE)
    maxISDN_AddressLength._val = 9
    
    #-----< FTN-AddressString >-----#
    FTN_AddressString = OCT_STR(name='FTN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    FTN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< maxFTN-AddressLength >-----#
    maxFTN_AddressLength = INT(name='maxFTN-AddressLength', mode=MODE_VALUE)
    maxFTN_AddressLength._val = 15
    
    #-----< ISDN-SubaddressString >-----#
    ISDN_SubaddressString = OCT_STR(name='ISDN-SubaddressString', mode=MODE_TYPE)
    ISDN_SubaddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=21)], ev=None, er=[])
    
    #-----< maxISDN-SubaddressLength >-----#
    maxISDN_SubaddressLength = INT(name='maxISDN-SubaddressLength', mode=MODE_VALUE)
    maxISDN_SubaddressLength._val = 21
    
    #-----< ExternalSignalInfo >-----#
    ExternalSignalInfo = SEQ(name='ExternalSignalInfo', mode=MODE_TYPE)
    _ExternalSignalInfo_protocolId = ENUM(name='protocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ProtocolId')))
    _ExternalSignalInfo_signalInfo = OCT_STR(name='signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _ExternalSignalInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalSignalInfo._cont = ASN1Dict([
        ('protocolId', _ExternalSignalInfo_protocolId),
        ('signalInfo', _ExternalSignalInfo_signalInfo),
        ('extensionContainer', _ExternalSignalInfo_extensionContainer),
        ])
    ExternalSignalInfo._ext = []
    
    #-----< SignalInfo >-----#
    SignalInfo = OCT_STR(name='SignalInfo', mode=MODE_TYPE)
    SignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    
    #-----< maxSignalInfoLength >-----#
    maxSignalInfoLength = INT(name='maxSignalInfoLength', mode=MODE_VALUE)
    maxSignalInfoLength._val = 200
    
    #-----< ProtocolId >-----#
    ProtocolId = ENUM(name='ProtocolId', mode=MODE_TYPE)
    ProtocolId._cont = ASN1Dict([('gsm-0408', 1), ('gsm-0806', 2), ('gsm-BSSMAP', 3), ('ets-300102-1', 4)])
    ProtocolId._ext = None
    
    #-----< Ext-ExternalSignalInfo >-----#
    Ext_ExternalSignalInfo = SEQ(name='Ext-ExternalSignalInfo', mode=MODE_TYPE)
    _Ext_ExternalSignalInfo_ext_ProtocolId = ENUM(name='ext-ProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ProtocolId')))
    _Ext_ExternalSignalInfo_signalInfo = OCT_STR(name='signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _Ext_ExternalSignalInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ExternalSignalInfo._cont = ASN1Dict([
        ('ext-ProtocolId', _Ext_ExternalSignalInfo_ext_ProtocolId),
        ('signalInfo', _Ext_ExternalSignalInfo_signalInfo),
        ('extensionContainer', _Ext_ExternalSignalInfo_extensionContainer),
        ])
    Ext_ExternalSignalInfo._ext = []
    
    #-----< Ext-ProtocolId >-----#
    Ext_ProtocolId = ENUM(name='Ext-ProtocolId', mode=MODE_TYPE)
    Ext_ProtocolId._cont = ASN1Dict([('ets-300356', 1)])
    Ext_ProtocolId._ext = []
    
    #-----< AccessNetworkSignalInfo >-----#
    AccessNetworkSignalInfo = SEQ(name='AccessNetworkSignalInfo', mode=MODE_TYPE)
    _AccessNetworkSignalInfo_accessNetworkProtocolId = ENUM(name='accessNetworkProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkProtocolId')))
    _AccessNetworkSignalInfo_signalInfo = OCT_STR(name='signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LongSignalInfo')))
    _AccessNetworkSignalInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AccessNetworkSignalInfo._cont = ASN1Dict([
        ('accessNetworkProtocolId', _AccessNetworkSignalInfo_accessNetworkProtocolId),
        ('signalInfo', _AccessNetworkSignalInfo_signalInfo),
        ('extensionContainer', _AccessNetworkSignalInfo_extensionContainer),
        ])
    AccessNetworkSignalInfo._ext = []
    
    #-----< LongSignalInfo >-----#
    LongSignalInfo = OCT_STR(name='LongSignalInfo', mode=MODE_TYPE)
    LongSignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2560)], ev=None, er=[])
    
    #-----< maxLongSignalInfoLength >-----#
    maxLongSignalInfoLength = INT(name='maxLongSignalInfoLength', mode=MODE_VALUE)
    maxLongSignalInfoLength._val = 2560
    
    #-----< AccessNetworkProtocolId >-----#
    AccessNetworkProtocolId = ENUM(name='AccessNetworkProtocolId', mode=MODE_TYPE)
    AccessNetworkProtocolId._cont = ASN1Dict([('ts3G-48006', 1), ('ts3G-25413', 2)])
    AccessNetworkProtocolId._ext = []
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name='AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< alertingLevel-0 >-----#
    alertingLevel_0 = OCT_STR(name='alertingLevel-0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_0._val = b'\x00'
    
    #-----< alertingLevel-1 >-----#
    alertingLevel_1 = OCT_STR(name='alertingLevel-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_1._val = b'\x01'
    
    #-----< alertingLevel-2 >-----#
    alertingLevel_2 = OCT_STR(name='alertingLevel-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_2._val = b'\x02'
    
    #-----< alertingCategory-1 >-----#
    alertingCategory_1 = OCT_STR(name='alertingCategory-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_1._val = b'\x04'
    
    #-----< alertingCategory-2 >-----#
    alertingCategory_2 = OCT_STR(name='alertingCategory-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_2._val = b'\x05'
    
    #-----< alertingCategory-3 >-----#
    alertingCategory_3 = OCT_STR(name='alertingCategory-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_3._val = b'\x06'
    
    #-----< alertingCategory-4 >-----#
    alertingCategory_4 = OCT_STR(name='alertingCategory-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_4._val = b'\x07'
    
    #-----< alertingCategory-5 >-----#
    alertingCategory_5 = OCT_STR(name='alertingCategory-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_5._val = b'\x08'
    
    #-----< GSN-Address >-----#
    GSN_Address = OCT_STR(name='GSN-Address', mode=MODE_TYPE)
    GSN_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=17)], ev=None, er=[])
    
    #-----< Time >-----#
    Time = OCT_STR(name='Time', mode=MODE_TYPE)
    Time._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name='IMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< Identity >-----#
    Identity = CHOICE(name='Identity', mode=MODE_TYPE)
    _Identity_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _Identity_imsi_WithLMSI = SEQ(name='imsi-WithLMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI-WithLMSI')))
    Identity._cont = ASN1Dict([
        ('imsi', _Identity_imsi),
        ('imsi-WithLMSI', _Identity_imsi_WithLMSI),
        ])
    Identity._ext = None
    
    #-----< IMSI-WithLMSI >-----#
    IMSI_WithLMSI = SEQ(name='IMSI-WithLMSI', mode=MODE_TYPE)
    _IMSI_WithLMSI_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IMSI_WithLMSI_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')))
    IMSI_WithLMSI._cont = ASN1Dict([
        ('imsi', _IMSI_WithLMSI_imsi),
        ('lmsi', _IMSI_WithLMSI_lmsi),
        ])
    IMSI_WithLMSI._ext = []
    
    #-----< ASCI-CallReference >-----#
    ASCI_CallReference = OCT_STR(name='ASCI-CallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    ASCI_CallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TMSI >-----#
    TMSI = OCT_STR(name='TMSI', mode=MODE_TYPE)
    TMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< SubscriberId >-----#
    SubscriberId = CHOICE(name='SubscriberId', mode=MODE_TYPE)
    _SubscriberId_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberId_tmsi = OCT_STR(name='tmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    SubscriberId._cont = ASN1Dict([
        ('imsi', _SubscriberId_imsi),
        ('tmsi', _SubscriberId_tmsi),
        ])
    SubscriberId._ext = None
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name='IMEI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HLR-Id >-----#
    HLR_Id = OCT_STR(name='HLR-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    
    #-----< HLR-List >-----#
    HLR_List = SEQ_OF(name='HLR-List', mode=MODE_TYPE)
    _HLR_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-Id')))
    HLR_List._cont = _HLR_List__item_
    HLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfHLR-Id >-----#
    maxNumOfHLR_Id = INT(name='maxNumOfHLR-Id', mode=MODE_VALUE)
    maxNumOfHLR_Id._val = 50
    
    #-----< LMSI >-----#
    LMSI = OCT_STR(name='LMSI', mode=MODE_TYPE)
    LMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GlobalCellId >-----#
    GlobalCellId = OCT_STR(name='GlobalCellId', mode=MODE_TYPE)
    GlobalCellId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    
    #-----< NetworkResource >-----#
    NetworkResource = ENUM(name='NetworkResource', mode=MODE_TYPE)
    NetworkResource._cont = ASN1Dict([('plmn', 0), ('hlr', 1), ('vlr', 2), ('pvlr', 3), ('controllingMSC', 4), ('vmsc', 5), ('eir', 6), ('rss', 7)])
    NetworkResource._ext = None
    
    #-----< AdditionalNetworkResource >-----#
    AdditionalNetworkResource = ENUM(name='AdditionalNetworkResource', mode=MODE_TYPE)
    AdditionalNetworkResource._cont = ASN1Dict([('sgsn', 0), ('ggsn', 1), ('gmlc', 2), ('gsmSCF', 3), ('nplr', 4), ('auc', 5), ('ue', 6), ('mme', 7)])
    AdditionalNetworkResource._ext = ['ue', 'mme']
    
    #-----< NAEA-PreferredCI >-----#
    NAEA_PreferredCI = SEQ(name='NAEA-PreferredCI', mode=MODE_TYPE)
    _NAEA_PreferredCI_naea_PreferredCIC = OCT_STR(name='naea-PreferredCIC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-CIC')))
    _NAEA_PreferredCI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NAEA_PreferredCI._cont = ASN1Dict([
        ('naea-PreferredCIC', _NAEA_PreferredCI_naea_PreferredCIC),
        ('extensionContainer', _NAEA_PreferredCI_extensionContainer),
        ])
    NAEA_PreferredCI._ext = []
    
    #-----< NAEA-CIC >-----#
    NAEA_CIC = OCT_STR(name='NAEA-CIC', mode=MODE_TYPE)
    NAEA_CIC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< SubscriberIdentity >-----#
    SubscriberIdentity = CHOICE(name='SubscriberIdentity', mode=MODE_TYPE)
    _SubscriberIdentity_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberIdentity_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SubscriberIdentity._cont = ASN1Dict([
        ('imsi', _SubscriberIdentity_imsi),
        ('msisdn', _SubscriberIdentity_msisdn),
        ])
    SubscriberIdentity._ext = None
    
    #-----< LCSClientExternalID >-----#
    LCSClientExternalID = SEQ(name='LCSClientExternalID', mode=MODE_TYPE)
    _LCSClientExternalID_externalAddress = OCT_STR(name='externalAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LCSClientExternalID_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LCSClientExternalID._cont = ASN1Dict([
        ('externalAddress', _LCSClientExternalID_externalAddress),
        ('extensionContainer', _LCSClientExternalID_extensionContainer),
        ])
    LCSClientExternalID._ext = []
    
    #-----< LCSClientInternalID >-----#
    LCSClientInternalID = ENUM(name='LCSClientInternalID', mode=MODE_TYPE)
    LCSClientInternalID._cont = ASN1Dict([('broadcastService', 0), ('o-andM-HPLMN', 1), ('o-andM-VPLMN', 2), ('anonymousLocation', 3), ('targetMSsubscribedService', 4)])
    LCSClientInternalID._ext = []
    
    #-----< LCSServiceTypeID >-----#
    LCSServiceTypeID = INT(name='LCSServiceTypeID', mode=MODE_TYPE)
    LCSServiceTypeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< emergencyServices >-----#
    emergencyServices = INT(name='emergencyServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyServices._val = 0
    
    #-----< emergencyAlertServices >-----#
    emergencyAlertServices = INT(name='emergencyAlertServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyAlertServices._val = 1
    
    #-----< personTracking >-----#
    personTracking = INT(name='personTracking', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    personTracking._val = 2
    
    #-----< fleetManagement >-----#
    fleetManagement = INT(name='fleetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    fleetManagement._val = 3
    
    #-----< assetManagement >-----#
    assetManagement = INT(name='assetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetManagement._val = 4
    
    #-----< trafficCongestionReporting >-----#
    trafficCongestionReporting = INT(name='trafficCongestionReporting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficCongestionReporting._val = 5
    
    #-----< roadsideAssistance >-----#
    roadsideAssistance = INT(name='roadsideAssistance', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    roadsideAssistance._val = 6
    
    #-----< routingToNearestCommercialEnterprise >-----#
    routingToNearestCommercialEnterprise = INT(name='routingToNearestCommercialEnterprise', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routingToNearestCommercialEnterprise._val = 7
    
    #-----< navigation >-----#
    navigation = INT(name='navigation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    navigation._val = 8
    
    #-----< citySightseeing >-----#
    citySightseeing = INT(name='citySightseeing', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    citySightseeing._val = 9
    
    #-----< localizedAdvertising >-----#
    localizedAdvertising = INT(name='localizedAdvertising', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    localizedAdvertising._val = 10
    
    #-----< mobileYellowPages >-----#
    mobileYellowPages = INT(name='mobileYellowPages', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    mobileYellowPages._val = 11
    
    #-----< trafficAndPublicTransportationInfo >-----#
    trafficAndPublicTransportationInfo = INT(name='trafficAndPublicTransportationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficAndPublicTransportationInfo._val = 12
    
    #-----< weather >-----#
    weather = INT(name='weather', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    weather._val = 13
    
    #-----< assetAndServiceFinding >-----#
    assetAndServiceFinding = INT(name='assetAndServiceFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetAndServiceFinding._val = 14
    
    #-----< gaming >-----#
    gaming = INT(name='gaming', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    gaming._val = 15
    
    #-----< findYourFriend >-----#
    findYourFriend = INT(name='findYourFriend', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    findYourFriend._val = 16
    
    #-----< dating >-----#
    dating = INT(name='dating', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    dating._val = 17
    
    #-----< chatting >-----#
    chatting = INT(name='chatting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    chatting._val = 18
    
    #-----< routeFinding >-----#
    routeFinding = INT(name='routeFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routeFinding._val = 19
    
    #-----< whereAmI >-----#
    whereAmI = INT(name='whereAmI', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    whereAmI._val = 20
    
    #-----< serv64 >-----#
    serv64 = INT(name='serv64', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv64._val = 64
    
    #-----< serv65 >-----#
    serv65 = INT(name='serv65', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv65._val = 65
    
    #-----< serv66 >-----#
    serv66 = INT(name='serv66', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv66._val = 66
    
    #-----< serv67 >-----#
    serv67 = INT(name='serv67', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv67._val = 67
    
    #-----< serv68 >-----#
    serv68 = INT(name='serv68', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv68._val = 68
    
    #-----< serv69 >-----#
    serv69 = INT(name='serv69', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv69._val = 69
    
    #-----< serv70 >-----#
    serv70 = INT(name='serv70', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv70._val = 70
    
    #-----< serv71 >-----#
    serv71 = INT(name='serv71', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv71._val = 71
    
    #-----< serv72 >-----#
    serv72 = INT(name='serv72', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv72._val = 72
    
    #-----< serv73 >-----#
    serv73 = INT(name='serv73', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv73._val = 73
    
    #-----< serv74 >-----#
    serv74 = INT(name='serv74', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv74._val = 74
    
    #-----< serv75 >-----#
    serv75 = INT(name='serv75', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv75._val = 75
    
    #-----< serv76 >-----#
    serv76 = INT(name='serv76', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv76._val = 76
    
    #-----< serv77 >-----#
    serv77 = INT(name='serv77', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv77._val = 77
    
    #-----< serv78 >-----#
    serv78 = INT(name='serv78', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv78._val = 78
    
    #-----< serv79 >-----#
    serv79 = INT(name='serv79', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv79._val = 79
    
    #-----< serv80 >-----#
    serv80 = INT(name='serv80', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv80._val = 80
    
    #-----< serv81 >-----#
    serv81 = INT(name='serv81', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv81._val = 81
    
    #-----< serv82 >-----#
    serv82 = INT(name='serv82', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv82._val = 82
    
    #-----< serv83 >-----#
    serv83 = INT(name='serv83', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv83._val = 83
    
    #-----< serv84 >-----#
    serv84 = INT(name='serv84', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv84._val = 84
    
    #-----< serv85 >-----#
    serv85 = INT(name='serv85', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv85._val = 85
    
    #-----< serv86 >-----#
    serv86 = INT(name='serv86', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv86._val = 86
    
    #-----< serv87 >-----#
    serv87 = INT(name='serv87', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv87._val = 87
    
    #-----< serv88 >-----#
    serv88 = INT(name='serv88', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv88._val = 88
    
    #-----< serv89 >-----#
    serv89 = INT(name='serv89', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv89._val = 89
    
    #-----< serv90 >-----#
    serv90 = INT(name='serv90', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv90._val = 90
    
    #-----< serv91 >-----#
    serv91 = INT(name='serv91', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv91._val = 91
    
    #-----< serv92 >-----#
    serv92 = INT(name='serv92', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv92._val = 92
    
    #-----< serv93 >-----#
    serv93 = INT(name='serv93', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv93._val = 93
    
    #-----< serv94 >-----#
    serv94 = INT(name='serv94', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv94._val = 94
    
    #-----< serv95 >-----#
    serv95 = INT(name='serv95', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv95._val = 95
    
    #-----< serv96 >-----#
    serv96 = INT(name='serv96', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv96._val = 96
    
    #-----< serv97 >-----#
    serv97 = INT(name='serv97', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv97._val = 97
    
    #-----< serv98 >-----#
    serv98 = INT(name='serv98', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv98._val = 98
    
    #-----< serv99 >-----#
    serv99 = INT(name='serv99', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv99._val = 99
    
    #-----< serv100 >-----#
    serv100 = INT(name='serv100', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv100._val = 100
    
    #-----< serv101 >-----#
    serv101 = INT(name='serv101', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv101._val = 101
    
    #-----< serv102 >-----#
    serv102 = INT(name='serv102', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv102._val = 102
    
    #-----< serv103 >-----#
    serv103 = INT(name='serv103', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv103._val = 103
    
    #-----< serv104 >-----#
    serv104 = INT(name='serv104', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv104._val = 104
    
    #-----< serv105 >-----#
    serv105 = INT(name='serv105', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv105._val = 105
    
    #-----< serv106 >-----#
    serv106 = INT(name='serv106', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv106._val = 106
    
    #-----< serv107 >-----#
    serv107 = INT(name='serv107', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv107._val = 107
    
    #-----< serv108 >-----#
    serv108 = INT(name='serv108', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv108._val = 108
    
    #-----< serv109 >-----#
    serv109 = INT(name='serv109', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv109._val = 109
    
    #-----< serv110 >-----#
    serv110 = INT(name='serv110', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv110._val = 110
    
    #-----< serv111 >-----#
    serv111 = INT(name='serv111', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv111._val = 111
    
    #-----< serv112 >-----#
    serv112 = INT(name='serv112', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv112._val = 112
    
    #-----< serv113 >-----#
    serv113 = INT(name='serv113', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv113._val = 113
    
    #-----< serv114 >-----#
    serv114 = INT(name='serv114', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv114._val = 114
    
    #-----< serv115 >-----#
    serv115 = INT(name='serv115', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv115._val = 115
    
    #-----< serv116 >-----#
    serv116 = INT(name='serv116', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv116._val = 116
    
    #-----< serv117 >-----#
    serv117 = INT(name='serv117', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv117._val = 117
    
    #-----< serv118 >-----#
    serv118 = INT(name='serv118', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv118._val = 118
    
    #-----< serv119 >-----#
    serv119 = INT(name='serv119', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv119._val = 119
    
    #-----< serv120 >-----#
    serv120 = INT(name='serv120', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv120._val = 120
    
    #-----< serv121 >-----#
    serv121 = INT(name='serv121', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv121._val = 121
    
    #-----< serv122 >-----#
    serv122 = INT(name='serv122', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv122._val = 122
    
    #-----< serv123 >-----#
    serv123 = INT(name='serv123', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv123._val = 123
    
    #-----< serv124 >-----#
    serv124 = INT(name='serv124', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv124._val = 124
    
    #-----< serv125 >-----#
    serv125 = INT(name='serv125', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv125._val = 125
    
    #-----< serv126 >-----#
    serv126 = INT(name='serv126', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv126._val = 126
    
    #-----< serv127 >-----#
    serv127 = INT(name='serv127', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv127._val = 127
    
    #-----< PLMN-Id >-----#
    PLMN_Id = OCT_STR(name='PLMN-Id', mode=MODE_TYPE)
    PLMN_Id._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< E-UTRAN-CGI >-----#
    E_UTRAN_CGI = OCT_STR(name='E-UTRAN-CGI', mode=MODE_TYPE)
    E_UTRAN_CGI._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = OCT_STR(name='NR-CGI', mode=MODE_TYPE)
    NR_CGI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TA-Id >-----#
    TA_Id = OCT_STR(name='TA-Id', mode=MODE_TYPE)
    TA_Id._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< NR-TA-Id >-----#
    NR_TA_Id = OCT_STR(name='NR-TA-Id', mode=MODE_TYPE)
    NR_TA_Id._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< RAIdentity >-----#
    RAIdentity = OCT_STR(name='RAIdentity', mode=MODE_TYPE)
    RAIdentity._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< NetworkNodeDiameterAddress >-----#
    NetworkNodeDiameterAddress = SEQ(name='NetworkNodeDiameterAddress', mode=MODE_TYPE)
    _NetworkNodeDiameterAddress_diameter_Name = OCT_STR(name='diameter-Name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    _NetworkNodeDiameterAddress_diameter_Realm = OCT_STR(name='diameter-Realm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    NetworkNodeDiameterAddress._cont = ASN1Dict([
        ('diameter-Name', _NetworkNodeDiameterAddress_diameter_Name),
        ('diameter-Realm', _NetworkNodeDiameterAddress_diameter_Realm),
        ])
    NetworkNodeDiameterAddress._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdOrLAI >-----#
    CellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name='CellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE)
    _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name='cellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength = OCT_STR(name='laiFixedLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    CellGlobalIdOrServiceAreaIdOrLAI._cont = ASN1Dict([
        ('cellGlobalIdOrServiceAreaIdFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength),
        ('laiFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength),
        ])
    CellGlobalIdOrServiceAreaIdOrLAI._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdFixedLength >-----#
    CellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name='CellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE)
    CellGlobalIdOrServiceAreaIdFixedLength._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< LAIFixedLength >-----#
    LAIFixedLength = OCT_STR(name='LAIFixedLength', mode=MODE_TYPE)
    LAIFixedLength._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< BasicServiceCode >-----#
    BasicServiceCode = CHOICE(name='BasicServiceCode', mode=MODE_TYPE)
    _BasicServiceCode_bearerService = OCT_STR(name='bearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    _BasicServiceCode_teleservice = OCT_STR(name='teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    BasicServiceCode._cont = ASN1Dict([
        ('bearerService', _BasicServiceCode_bearerService),
        ('teleservice', _BasicServiceCode_teleservice),
        ])
    BasicServiceCode._ext = None
    
    #-----< Ext-BasicServiceCode >-----#
    Ext_BasicServiceCode = CHOICE(name='Ext-BasicServiceCode', mode=MODE_TYPE)
    _Ext_BasicServiceCode_ext_BearerService = OCT_STR(name='ext-BearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    _Ext_BasicServiceCode_ext_Teleservice = OCT_STR(name='ext-Teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    Ext_BasicServiceCode._cont = ASN1Dict([
        ('ext-BearerService', _Ext_BasicServiceCode_ext_BearerService),
        ('ext-Teleservice', _Ext_BasicServiceCode_ext_Teleservice),
        ])
    Ext_BasicServiceCode._ext = None
    
    #-----< EMLPP-Info >-----#
    EMLPP_Info = SEQ(name='EMLPP-Info', mode=MODE_TYPE)
    _EMLPP_Info_maximumentitledPriority = INT(name='maximumentitledPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EMLPP_Info._cont = ASN1Dict([
        ('maximumentitledPriority', _EMLPP_Info_maximumentitledPriority),
        ('defaultPriority', _EMLPP_Info_defaultPriority),
        ('extensionContainer', _EMLPP_Info_extensionContainer),
        ])
    EMLPP_Info._ext = []
    
    #-----< EMLPP-Priority >-----#
    EMLPP_Priority = INT(name='EMLPP-Priority', mode=MODE_TYPE)
    EMLPP_Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< priorityLevelA >-----#
    priorityLevelA = INT(name='priorityLevelA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelA._val = 6
    
    #-----< priorityLevelB >-----#
    priorityLevelB = INT(name='priorityLevelB', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelB._val = 5
    
    #-----< priorityLevel0 >-----#
    priorityLevel0 = INT(name='priorityLevel0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel0._val = 0
    
    #-----< priorityLevel1 >-----#
    priorityLevel1 = INT(name='priorityLevel1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel1._val = 1
    
    #-----< priorityLevel2 >-----#
    priorityLevel2 = INT(name='priorityLevel2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel2._val = 2
    
    #-----< priorityLevel3 >-----#
    priorityLevel3 = INT(name='priorityLevel3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel3._val = 3
    
    #-----< priorityLevel4 >-----#
    priorityLevel4 = INT(name='priorityLevel4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel4._val = 4
    
    #-----< MC-SS-Info >-----#
    MC_SS_Info = SEQ(name='MC-SS-Info', mode=MODE_TYPE)
    _MC_SS_Info_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MC_SS_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MC_SS_Info_nbrSB = INT(name='nbrSB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')))
    _MC_SS_Info_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')))
    _MC_SS_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MC_SS_Info._cont = ASN1Dict([
        ('ss-Code', _MC_SS_Info_ss_Code),
        ('ss-Status', _MC_SS_Info_ss_Status),
        ('nbrSB', _MC_SS_Info_nbrSB),
        ('nbrUser', _MC_SS_Info_nbrUser),
        ('extensionContainer', _MC_SS_Info_extensionContainer),
        ])
    MC_SS_Info._ext = []
    
    #-----< MaxMC-Bearers >-----#
    MaxMC_Bearers = INT(name='MaxMC-Bearers', mode=MODE_TYPE)
    MaxMC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=7)], ev=None, er=[])
    
    #-----< MC-Bearers >-----#
    MC_Bearers = INT(name='MC-Bearers', mode=MODE_TYPE)
    MC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< maxNumOfMC-Bearers >-----#
    maxNumOfMC_Bearers = INT(name='maxNumOfMC-Bearers', mode=MODE_VALUE)
    maxNumOfMC_Bearers._val = 7
    
    #-----< Ext-SS-Status >-----#
    Ext_SS_Status = OCT_STR(name='Ext-SS-Status', mode=MODE_TYPE)
    Ext_SS_Status._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AgeOfLocationInformation >-----#
    AgeOfLocationInformation = INT(name='AgeOfLocationInformation', mode=MODE_TYPE)
    AgeOfLocationInformation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    _all_ = [
        TBCD_STRING,
        DiameterIdentity,
        AddressString,
        maxAddressLength,
        ISDN_AddressString,
        maxISDN_AddressLength,
        FTN_AddressString,
        maxFTN_AddressLength,
        ISDN_SubaddressString,
        maxISDN_SubaddressLength,
        _ExternalSignalInfo_protocolId,
        _ExternalSignalInfo_signalInfo,
        _ExternalSignalInfo_extensionContainer,
        ExternalSignalInfo,
        SignalInfo,
        maxSignalInfoLength,
        ProtocolId,
        _Ext_ExternalSignalInfo_ext_ProtocolId,
        _Ext_ExternalSignalInfo_signalInfo,
        _Ext_ExternalSignalInfo_extensionContainer,
        Ext_ExternalSignalInfo,
        Ext_ProtocolId,
        _AccessNetworkSignalInfo_accessNetworkProtocolId,
        _AccessNetworkSignalInfo_signalInfo,
        _AccessNetworkSignalInfo_extensionContainer,
        AccessNetworkSignalInfo,
        LongSignalInfo,
        maxLongSignalInfoLength,
        AccessNetworkProtocolId,
        AlertingPattern,
        alertingLevel_0,
        alertingLevel_1,
        alertingLevel_2,
        alertingCategory_1,
        alertingCategory_2,
        alertingCategory_3,
        alertingCategory_4,
        alertingCategory_5,
        GSN_Address,
        Time,
        IMSI,
        _Identity_imsi,
        _Identity_imsi_WithLMSI,
        Identity,
        _IMSI_WithLMSI_imsi,
        _IMSI_WithLMSI_lmsi,
        IMSI_WithLMSI,
        ASCI_CallReference,
        TMSI,
        _SubscriberId_imsi,
        _SubscriberId_tmsi,
        SubscriberId,
        IMEI,
        HLR_Id,
        _HLR_List__item_,
        HLR_List,
        maxNumOfHLR_Id,
        LMSI,
        GlobalCellId,
        NetworkResource,
        AdditionalNetworkResource,
        _NAEA_PreferredCI_naea_PreferredCIC,
        _NAEA_PreferredCI_extensionContainer,
        NAEA_PreferredCI,
        NAEA_CIC,
        _SubscriberIdentity_imsi,
        _SubscriberIdentity_msisdn,
        SubscriberIdentity,
        _LCSClientExternalID_externalAddress,
        _LCSClientExternalID_extensionContainer,
        LCSClientExternalID,
        LCSClientInternalID,
        LCSServiceTypeID,
        emergencyServices,
        emergencyAlertServices,
        personTracking,
        fleetManagement,
        assetManagement,
        trafficCongestionReporting,
        roadsideAssistance,
        routingToNearestCommercialEnterprise,
        navigation,
        citySightseeing,
        localizedAdvertising,
        mobileYellowPages,
        trafficAndPublicTransportationInfo,
        weather,
        assetAndServiceFinding,
        gaming,
        findYourFriend,
        dating,
        chatting,
        routeFinding,
        whereAmI,
        serv64,
        serv65,
        serv66,
        serv67,
        serv68,
        serv69,
        serv70,
        serv71,
        serv72,
        serv73,
        serv74,
        serv75,
        serv76,
        serv77,
        serv78,
        serv79,
        serv80,
        serv81,
        serv82,
        serv83,
        serv84,
        serv85,
        serv86,
        serv87,
        serv88,
        serv89,
        serv90,
        serv91,
        serv92,
        serv93,
        serv94,
        serv95,
        serv96,
        serv97,
        serv98,
        serv99,
        serv100,
        serv101,
        serv102,
        serv103,
        serv104,
        serv105,
        serv106,
        serv107,
        serv108,
        serv109,
        serv110,
        serv111,
        serv112,
        serv113,
        serv114,
        serv115,
        serv116,
        serv117,
        serv118,
        serv119,
        serv120,
        serv121,
        serv122,
        serv123,
        serv124,
        serv125,
        serv126,
        serv127,
        PLMN_Id,
        E_UTRAN_CGI,
        NR_CGI,
        TA_Id,
        NR_TA_Id,
        RAIdentity,
        _NetworkNodeDiameterAddress_diameter_Name,
        _NetworkNodeDiameterAddress_diameter_Realm,
        NetworkNodeDiameterAddress,
        _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength,
        _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength,
        CellGlobalIdOrServiceAreaIdOrLAI,
        CellGlobalIdOrServiceAreaIdFixedLength,
        LAIFixedLength,
        _BasicServiceCode_bearerService,
        _BasicServiceCode_teleservice,
        BasicServiceCode,
        _Ext_BasicServiceCode_ext_BearerService,
        _Ext_BasicServiceCode_ext_Teleservice,
        Ext_BasicServiceCode,
        _EMLPP_Info_maximumentitledPriority,
        _EMLPP_Info_defaultPriority,
        _EMLPP_Info_extensionContainer,
        EMLPP_Info,
        EMLPP_Priority,
        priorityLevelA,
        priorityLevelB,
        priorityLevel0,
        priorityLevel1,
        priorityLevel2,
        priorityLevel3,
        priorityLevel4,
        _MC_SS_Info_ss_Code,
        _MC_SS_Info_ss_Status,
        _MC_SS_Info_nbrSB,
        _MC_SS_Info_nbrUser,
        _MC_SS_Info_extensionContainer,
        MC_SS_Info,
        MaxMC_Bearers,
        MC_Bearers,
        maxNumOfMC_Bearers,
        Ext_SS_Status,
        AgeOfLocationInformation,
    ]

class MAP_ER_DataTypes:

    _name_  = 'MAP-ER-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 17, 19]
    
    _obj_ = [
        'RoamingNotAllowedParam',
        'AdditionalRoamingNotAllowedCause',
        'RoamingNotAllowedCause',
        'CallBarredParam',
        'CallBarringCause',
        'ExtensibleCallBarredParam',
        'CUG-RejectParam',
        'CUG-RejectCause',
        'SS-IncompatibilityCause',
        'PW-RegistrationFailureCause',
        'SM-EnumeratedDeliveryFailureCause',
        'SM-DeliveryFailureCause',
        'AbsentSubscriberSM-Param',
        'AbsentSubscriberDiagnosticSM',
        'SystemFailureParam',
        'ExtensibleSystemFailureParam',
        'FailureCauseParam',
        'DataMissingParam',
        'UnexpectedDataParam',
        'FacilityNotSupParam',
        'OR-NotAllowedParam',
        'UnknownSubscriberParam',
        'UnknownSubscriberDiagnostic',
        'NumberChangedParam',
        'UnidentifiedSubParam',
        'IllegalSubscriberParam',
        'IllegalEquipmentParam',
        'BearerServNotProvParam',
        'TeleservNotProvParam',
        'TracingBufferFullParam',
        'NoRoamingNbParam',
        'AbsentSubscriberParam',
        'AbsentSubscriberReason',
        'BusySubscriberParam',
        'NoSubscriberReplyParam',
        'ForwardingViolationParam',
        'ForwardingFailedParam',
        'ATI-NotAllowedParam',
        'ATSI-NotAllowedParam',
        'ATM-NotAllowedParam',
        'IllegalSS-OperationParam',
        'SS-NotAvailableParam',
        'SS-SubscriptionViolationParam',
        'InformationNotAvailableParam',
        'SubBusyForMT-SMS-Param',
        'MessageWaitListFullParam',
        'ResourceLimitationParam',
        'NoGroupCallNbParam',
        'IncompatibleTerminalParam',
        'ShortTermDenialParam',
        'LongTermDenialParam',
        'UnauthorizedRequestingNetwork-Param',
        'UnauthorizedLCSClient-Param',
        'UnauthorizedLCSClient-Diagnostic',
        'PositionMethodFailure-Param',
        'PositionMethodFailure-Diagnostic',
        'UnknownOrUnreachableLCSClient-Param',
        'MM-EventNotSupported-Param',
        'TargetCellOutsideGCA-Param',
        'OngoingGroupCallParam',
        ]
    _type_ = [
        'RoamingNotAllowedParam',
        'AdditionalRoamingNotAllowedCause',
        'RoamingNotAllowedCause',
        'CallBarredParam',
        'CallBarringCause',
        'ExtensibleCallBarredParam',
        'CUG-RejectParam',
        'CUG-RejectCause',
        'SS-IncompatibilityCause',
        'PW-RegistrationFailureCause',
        'SM-EnumeratedDeliveryFailureCause',
        'SM-DeliveryFailureCause',
        'AbsentSubscriberSM-Param',
        'AbsentSubscriberDiagnosticSM',
        'SystemFailureParam',
        'ExtensibleSystemFailureParam',
        'FailureCauseParam',
        'DataMissingParam',
        'UnexpectedDataParam',
        'FacilityNotSupParam',
        'OR-NotAllowedParam',
        'UnknownSubscriberParam',
        'UnknownSubscriberDiagnostic',
        'NumberChangedParam',
        'UnidentifiedSubParam',
        'IllegalSubscriberParam',
        'IllegalEquipmentParam',
        'BearerServNotProvParam',
        'TeleservNotProvParam',
        'TracingBufferFullParam',
        'NoRoamingNbParam',
        'AbsentSubscriberParam',
        'AbsentSubscriberReason',
        'BusySubscriberParam',
        'NoSubscriberReplyParam',
        'ForwardingViolationParam',
        'ForwardingFailedParam',
        'ATI-NotAllowedParam',
        'ATSI-NotAllowedParam',
        'ATM-NotAllowedParam',
        'IllegalSS-OperationParam',
        'SS-NotAvailableParam',
        'SS-SubscriptionViolationParam',
        'InformationNotAvailableParam',
        'SubBusyForMT-SMS-Param',
        'MessageWaitListFullParam',
        'ResourceLimitationParam',
        'NoGroupCallNbParam',
        'IncompatibleTerminalParam',
        'ShortTermDenialParam',
        'LongTermDenialParam',
        'UnauthorizedRequestingNetwork-Param',
        'UnauthorizedLCSClient-Param',
        'UnauthorizedLCSClient-Diagnostic',
        'PositionMethodFailure-Param',
        'PositionMethodFailure-Diagnostic',
        'UnknownOrUnreachableLCSClient-Param',
        'MM-EventNotSupported-Param',
        'TargetCellOutsideGCA-Param',
        'OngoingGroupCallParam',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoamingNotAllowedParam >-----#
    RoamingNotAllowedParam = SEQ(name='RoamingNotAllowedParam', mode=MODE_TYPE)
    _RoamingNotAllowedParam_roamingNotAllowedCause = ENUM(name='roamingNotAllowedCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'RoamingNotAllowedCause')))
    _RoamingNotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoamingNotAllowedParam_additionalRoamingNotAllowedCause = ENUM(name='additionalRoamingNotAllowedCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AdditionalRoamingNotAllowedCause')), opt=True)
    RoamingNotAllowedParam._cont = ASN1Dict([
        ('roamingNotAllowedCause', _RoamingNotAllowedParam_roamingNotAllowedCause),
        ('extensionContainer', _RoamingNotAllowedParam_extensionContainer),
        ('additionalRoamingNotAllowedCause', _RoamingNotAllowedParam_additionalRoamingNotAllowedCause),
        ])
    RoamingNotAllowedParam._ext = ['additionalRoamingNotAllowedCause']
    
    #-----< AdditionalRoamingNotAllowedCause >-----#
    AdditionalRoamingNotAllowedCause = ENUM(name='AdditionalRoamingNotAllowedCause', mode=MODE_TYPE)
    AdditionalRoamingNotAllowedCause._cont = ASN1Dict([('supportedRAT-TypesNotAllowed', 0)])
    AdditionalRoamingNotAllowedCause._ext = []
    
    #-----< RoamingNotAllowedCause >-----#
    RoamingNotAllowedCause = ENUM(name='RoamingNotAllowedCause', mode=MODE_TYPE)
    RoamingNotAllowedCause._cont = ASN1Dict([('plmnRoamingNotAllowed', 0), ('operatorDeterminedBarring', 3)])
    RoamingNotAllowedCause._ext = None
    
    #-----< CallBarredParam >-----#
    CallBarredParam = CHOICE(name='CallBarredParam', mode=MODE_TYPE)
    _CallBarredParam_callBarringCause = ENUM(name='callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')))
    _CallBarredParam_extensibleCallBarredParam = SEQ(name='extensibleCallBarredParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleCallBarredParam')))
    CallBarredParam._cont = ASN1Dict([
        ('callBarringCause', _CallBarredParam_callBarringCause),
        ('extensibleCallBarredParam', _CallBarredParam_extensibleCallBarredParam),
        ])
    CallBarredParam._ext = None
    
    #-----< CallBarringCause >-----#
    CallBarringCause = ENUM(name='CallBarringCause', mode=MODE_TYPE)
    CallBarringCause._cont = ASN1Dict([('barringServiceActive', 0), ('operatorBarring', 1)])
    CallBarringCause._ext = None
    
    #-----< ExtensibleCallBarredParam >-----#
    ExtensibleCallBarredParam = SEQ(name='ExtensibleCallBarredParam', mode=MODE_TYPE)
    _ExtensibleCallBarredParam_callBarringCause = ENUM(name='callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')), opt=True)
    _ExtensibleCallBarredParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleCallBarredParam_unauthorisedMessageOriginator = NULL(name='unauthorisedMessageOriginator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtensibleCallBarredParam_anonymousCallRejection = NULL(name='anonymousCallRejection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtensibleCallBarredParam._cont = ASN1Dict([
        ('callBarringCause', _ExtensibleCallBarredParam_callBarringCause),
        ('extensionContainer', _ExtensibleCallBarredParam_extensionContainer),
        ('unauthorisedMessageOriginator', _ExtensibleCallBarredParam_unauthorisedMessageOriginator),
        ('anonymousCallRejection', _ExtensibleCallBarredParam_anonymousCallRejection),
        ])
    ExtensibleCallBarredParam._ext = ['unauthorisedMessageOriginator', 'anonymousCallRejection']
    
    #-----< CUG-RejectParam >-----#
    CUG_RejectParam = SEQ(name='CUG-RejectParam', mode=MODE_TYPE)
    _CUG_RejectParam_cug_RejectCause = ENUM(name='cug-RejectCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CUG-RejectCause')), opt=True)
    _CUG_RejectParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_RejectParam._cont = ASN1Dict([
        ('cug-RejectCause', _CUG_RejectParam_cug_RejectCause),
        ('extensionContainer', _CUG_RejectParam_extensionContainer),
        ])
    CUG_RejectParam._ext = []
    
    #-----< CUG-RejectCause >-----#
    CUG_RejectCause = ENUM(name='CUG-RejectCause', mode=MODE_TYPE)
    CUG_RejectCause._cont = ASN1Dict([('incomingCallsBarredWithinCUG', 0), ('subscriberNotMemberOfCUG', 1), ('requestedBasicServiceViolatesCUG-Constraints', 5), ('calledPartySS-InteractionViolation', 7)])
    CUG_RejectCause._ext = None
    
    #-----< SS-IncompatibilityCause >-----#
    SS_IncompatibilityCause = SEQ(name='SS-IncompatibilityCause', mode=MODE_TYPE)
    _SS_IncompatibilityCause_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_IncompatibilityCause_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_IncompatibilityCause_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    SS_IncompatibilityCause._cont = ASN1Dict([
        ('ss-Code', _SS_IncompatibilityCause_ss_Code),
        ('basicService', _SS_IncompatibilityCause_basicService),
        ('ss-Status', _SS_IncompatibilityCause_ss_Status),
        ])
    SS_IncompatibilityCause._ext = []
    
    #-----< PW-RegistrationFailureCause >-----#
    PW_RegistrationFailureCause = ENUM(name='PW-RegistrationFailureCause', mode=MODE_TYPE)
    PW_RegistrationFailureCause._cont = ASN1Dict([('undetermined', 0), ('invalidFormat', 1), ('newPasswordsMismatch', 2)])
    PW_RegistrationFailureCause._ext = None
    
    #-----< SM-EnumeratedDeliveryFailureCause >-----#
    SM_EnumeratedDeliveryFailureCause = ENUM(name='SM-EnumeratedDeliveryFailureCause', mode=MODE_TYPE)
    SM_EnumeratedDeliveryFailureCause._cont = ASN1Dict([('memoryCapacityExceeded', 0), ('equipmentProtocolError', 1), ('equipmentNotSM-Equipped', 2), ('unknownServiceCentre', 3), ('sc-Congestion', 4), ('invalidSME-Address', 5), ('subscriberNotSC-Subscriber', 6)])
    SM_EnumeratedDeliveryFailureCause._ext = None
    
    #-----< SM-DeliveryFailureCause >-----#
    SM_DeliveryFailureCause = SEQ(name='SM-DeliveryFailureCause', mode=MODE_TYPE)
    _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause = ENUM(name='sm-EnumeratedDeliveryFailureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'SM-EnumeratedDeliveryFailureCause')))
    _SM_DeliveryFailureCause_diagnosticInfo = OCT_STR(name='diagnosticInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _SM_DeliveryFailureCause_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SM_DeliveryFailureCause._cont = ASN1Dict([
        ('sm-EnumeratedDeliveryFailureCause', _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause),
        ('diagnosticInfo', _SM_DeliveryFailureCause_diagnosticInfo),
        ('extensionContainer', _SM_DeliveryFailureCause_extensionContainer),
        ])
    SM_DeliveryFailureCause._ext = []
    
    #-----< AbsentSubscriberSM-Param >-----#
    AbsentSubscriberSM_Param = SEQ(name='AbsentSubscriberSM-Param', mode=MODE_TYPE)
    _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM = INT(name='absentSubscriberDiagnosticSM', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM = INT(name='additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _AbsentSubscriberSM_Param_requestedRetransmissionTime = OCT_STR(name='requestedRetransmissionTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _AbsentSubscriberSM_Param_userIdentifierAlert = OCT_STR(name='userIdentifierAlert', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    AbsentSubscriberSM_Param._cont = ASN1Dict([
        ('absentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM),
        ('extensionContainer', _AbsentSubscriberSM_Param_extensionContainer),
        ('additionalAbsentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM),
        ('imsi', _AbsentSubscriberSM_Param_imsi),
        ('requestedRetransmissionTime', _AbsentSubscriberSM_Param_requestedRetransmissionTime),
        ('userIdentifierAlert', _AbsentSubscriberSM_Param_userIdentifierAlert),
        ])
    AbsentSubscriberSM_Param._ext = ['additionalAbsentSubscriberDiagnosticSM', 'imsi', 'requestedRetransmissionTime', 'userIdentifierAlert']
    
    #-----< AbsentSubscriberDiagnosticSM >-----#
    AbsentSubscriberDiagnosticSM = INT(name='AbsentSubscriberDiagnosticSM', mode=MODE_TYPE)
    AbsentSubscriberDiagnosticSM._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SystemFailureParam >-----#
    SystemFailureParam = CHOICE(name='SystemFailureParam', mode=MODE_TYPE)
    _SystemFailureParam_networkResource = ENUM(name='networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')))
    _SystemFailureParam_extensibleSystemFailureParam = SEQ(name='extensibleSystemFailureParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleSystemFailureParam')))
    SystemFailureParam._cont = ASN1Dict([
        ('networkResource', _SystemFailureParam_networkResource),
        ('extensibleSystemFailureParam', _SystemFailureParam_extensibleSystemFailureParam),
        ])
    SystemFailureParam._ext = None
    
    #-----< ExtensibleSystemFailureParam >-----#
    ExtensibleSystemFailureParam = SEQ(name='ExtensibleSystemFailureParam', mode=MODE_TYPE)
    _ExtensibleSystemFailureParam_networkResource = ENUM(name='networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleSystemFailureParam_additionalNetworkResource = ENUM(name='additionalNetworkResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AdditionalNetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_failureCauseParam = ENUM(name='failureCauseParam', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'FailureCauseParam')), opt=True)
    ExtensibleSystemFailureParam._cont = ASN1Dict([
        ('networkResource', _ExtensibleSystemFailureParam_networkResource),
        ('extensionContainer', _ExtensibleSystemFailureParam_extensionContainer),
        ('additionalNetworkResource', _ExtensibleSystemFailureParam_additionalNetworkResource),
        ('failureCauseParam', _ExtensibleSystemFailureParam_failureCauseParam),
        ])
    ExtensibleSystemFailureParam._ext = ['additionalNetworkResource', 'failureCauseParam']
    
    #-----< FailureCauseParam >-----#
    FailureCauseParam = ENUM(name='FailureCauseParam', mode=MODE_TYPE)
    FailureCauseParam._cont = ASN1Dict([('limitReachedOnNumberOfConcurrentLocationRequests', 0)])
    FailureCauseParam._ext = []
    
    #-----< DataMissingParam >-----#
    DataMissingParam = SEQ(name='DataMissingParam', mode=MODE_TYPE)
    _DataMissingParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DataMissingParam._cont = ASN1Dict([
        ('extensionContainer', _DataMissingParam_extensionContainer),
        ])
    DataMissingParam._ext = []
    
    #-----< UnexpectedDataParam >-----#
    UnexpectedDataParam = SEQ(name='UnexpectedDataParam', mode=MODE_TYPE)
    _UnexpectedDataParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnexpectedDataParam_unexpectedSubscriber = NULL(name='unexpectedSubscriber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UnexpectedDataParam._cont = ASN1Dict([
        ('extensionContainer', _UnexpectedDataParam_extensionContainer),
        ('unexpectedSubscriber', _UnexpectedDataParam_unexpectedSubscriber),
        ])
    UnexpectedDataParam._ext = ['unexpectedSubscriber']
    
    #-----< FacilityNotSupParam >-----#
    FacilityNotSupParam = SEQ(name='FacilityNotSupParam', mode=MODE_TYPE)
    _FacilityNotSupParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _FacilityNotSupParam_shapeOfLocationEstimateNotSupported = NULL(name='shapeOfLocationEstimateNotSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode = NULL(name='neededLcsCapabilityNotSupportedInServingNode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    FacilityNotSupParam._cont = ASN1Dict([
        ('extensionContainer', _FacilityNotSupParam_extensionContainer),
        ('shapeOfLocationEstimateNotSupported', _FacilityNotSupParam_shapeOfLocationEstimateNotSupported),
        ('neededLcsCapabilityNotSupportedInServingNode', _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode),
        ])
    FacilityNotSupParam._ext = ['shapeOfLocationEstimateNotSupported', 'neededLcsCapabilityNotSupportedInServingNode']
    
    #-----< OR-NotAllowedParam >-----#
    OR_NotAllowedParam = SEQ(name='OR-NotAllowedParam', mode=MODE_TYPE)
    _OR_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OR_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _OR_NotAllowedParam_extensionContainer),
        ])
    OR_NotAllowedParam._ext = []
    
    #-----< UnknownSubscriberParam >-----#
    UnknownSubscriberParam = SEQ(name='UnknownSubscriberParam', mode=MODE_TYPE)
    _UnknownSubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnknownSubscriberParam_unknownSubscriberDiagnostic = ENUM(name='unknownSubscriberDiagnostic', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnknownSubscriberDiagnostic')), opt=True)
    UnknownSubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _UnknownSubscriberParam_extensionContainer),
        ('unknownSubscriberDiagnostic', _UnknownSubscriberParam_unknownSubscriberDiagnostic),
        ])
    UnknownSubscriberParam._ext = ['unknownSubscriberDiagnostic']
    
    #-----< UnknownSubscriberDiagnostic >-----#
    UnknownSubscriberDiagnostic = ENUM(name='UnknownSubscriberDiagnostic', mode=MODE_TYPE)
    UnknownSubscriberDiagnostic._cont = ASN1Dict([('imsiUnknown', 0), ('gprs-eps-SubscriptionUnknown', 1), ('npdbMismatch', 2)])
    UnknownSubscriberDiagnostic._ext = ['npdbMismatch']
    
    #-----< NumberChangedParam >-----#
    NumberChangedParam = SEQ(name='NumberChangedParam', mode=MODE_TYPE)
    _NumberChangedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NumberChangedParam._cont = ASN1Dict([
        ('extensionContainer', _NumberChangedParam_extensionContainer),
        ])
    NumberChangedParam._ext = []
    
    #-----< UnidentifiedSubParam >-----#
    UnidentifiedSubParam = SEQ(name='UnidentifiedSubParam', mode=MODE_TYPE)
    _UnidentifiedSubParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnidentifiedSubParam._cont = ASN1Dict([
        ('extensionContainer', _UnidentifiedSubParam_extensionContainer),
        ])
    UnidentifiedSubParam._ext = []
    
    #-----< IllegalSubscriberParam >-----#
    IllegalSubscriberParam = SEQ(name='IllegalSubscriberParam', mode=MODE_TYPE)
    _IllegalSubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _IllegalSubscriberParam_extensionContainer),
        ])
    IllegalSubscriberParam._ext = []
    
    #-----< IllegalEquipmentParam >-----#
    IllegalEquipmentParam = SEQ(name='IllegalEquipmentParam', mode=MODE_TYPE)
    _IllegalEquipmentParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalEquipmentParam._cont = ASN1Dict([
        ('extensionContainer', _IllegalEquipmentParam_extensionContainer),
        ])
    IllegalEquipmentParam._ext = []
    
    #-----< BearerServNotProvParam >-----#
    BearerServNotProvParam = SEQ(name='BearerServNotProvParam', mode=MODE_TYPE)
    _BearerServNotProvParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    BearerServNotProvParam._cont = ASN1Dict([
        ('extensionContainer', _BearerServNotProvParam_extensionContainer),
        ])
    BearerServNotProvParam._ext = []
    
    #-----< TeleservNotProvParam >-----#
    TeleservNotProvParam = SEQ(name='TeleservNotProvParam', mode=MODE_TYPE)
    _TeleservNotProvParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TeleservNotProvParam._cont = ASN1Dict([
        ('extensionContainer', _TeleservNotProvParam_extensionContainer),
        ])
    TeleservNotProvParam._ext = []
    
    #-----< TracingBufferFullParam >-----#
    TracingBufferFullParam = SEQ(name='TracingBufferFullParam', mode=MODE_TYPE)
    _TracingBufferFullParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TracingBufferFullParam._cont = ASN1Dict([
        ('extensionContainer', _TracingBufferFullParam_extensionContainer),
        ])
    TracingBufferFullParam._ext = []
    
    #-----< NoRoamingNbParam >-----#
    NoRoamingNbParam = SEQ(name='NoRoamingNbParam', mode=MODE_TYPE)
    _NoRoamingNbParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoRoamingNbParam._cont = ASN1Dict([
        ('extensionContainer', _NoRoamingNbParam_extensionContainer),
        ])
    NoRoamingNbParam._ext = []
    
    #-----< AbsentSubscriberParam >-----#
    AbsentSubscriberParam = SEQ(name='AbsentSubscriberParam', mode=MODE_TYPE)
    _AbsentSubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberParam_absentSubscriberReason = ENUM(name='absentSubscriberReason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberReason')), opt=True)
    AbsentSubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _AbsentSubscriberParam_extensionContainer),
        ('absentSubscriberReason', _AbsentSubscriberParam_absentSubscriberReason),
        ])
    AbsentSubscriberParam._ext = ['absentSubscriberReason']
    
    #-----< AbsentSubscriberReason >-----#
    AbsentSubscriberReason = ENUM(name='AbsentSubscriberReason', mode=MODE_TYPE)
    AbsentSubscriberReason._cont = ASN1Dict([('imsiDetach', 0), ('restrictedArea', 1), ('noPageResponse', 2), ('purgedMS', 3), ('mtRoamingRetry', 4), ('busySubscriber', 5)])
    AbsentSubscriberReason._ext = ['purgedMS', 'mtRoamingRetry', 'busySubscriber']
    
    #-----< BusySubscriberParam >-----#
    BusySubscriberParam = SEQ(name='BusySubscriberParam', mode=MODE_TYPE)
    _BusySubscriberParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _BusySubscriberParam_ccbs_Possible = NULL(name='ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BusySubscriberParam_ccbs_Busy = NULL(name='ccbs-Busy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BusySubscriberParam._cont = ASN1Dict([
        ('extensionContainer', _BusySubscriberParam_extensionContainer),
        ('ccbs-Possible', _BusySubscriberParam_ccbs_Possible),
        ('ccbs-Busy', _BusySubscriberParam_ccbs_Busy),
        ])
    BusySubscriberParam._ext = ['ccbs-Possible', 'ccbs-Busy']
    
    #-----< NoSubscriberReplyParam >-----#
    NoSubscriberReplyParam = SEQ(name='NoSubscriberReplyParam', mode=MODE_TYPE)
    _NoSubscriberReplyParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoSubscriberReplyParam._cont = ASN1Dict([
        ('extensionContainer', _NoSubscriberReplyParam_extensionContainer),
        ])
    NoSubscriberReplyParam._ext = []
    
    #-----< ForwardingViolationParam >-----#
    ForwardingViolationParam = SEQ(name='ForwardingViolationParam', mode=MODE_TYPE)
    _ForwardingViolationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingViolationParam._cont = ASN1Dict([
        ('extensionContainer', _ForwardingViolationParam_extensionContainer),
        ])
    ForwardingViolationParam._ext = []
    
    #-----< ForwardingFailedParam >-----#
    ForwardingFailedParam = SEQ(name='ForwardingFailedParam', mode=MODE_TYPE)
    _ForwardingFailedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingFailedParam._cont = ASN1Dict([
        ('extensionContainer', _ForwardingFailedParam_extensionContainer),
        ])
    ForwardingFailedParam._ext = []
    
    #-----< ATI-NotAllowedParam >-----#
    ATI_NotAllowedParam = SEQ(name='ATI-NotAllowedParam', mode=MODE_TYPE)
    _ATI_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATI_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _ATI_NotAllowedParam_extensionContainer),
        ])
    ATI_NotAllowedParam._ext = []
    
    #-----< ATSI-NotAllowedParam >-----#
    ATSI_NotAllowedParam = SEQ(name='ATSI-NotAllowedParam', mode=MODE_TYPE)
    _ATSI_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATSI_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _ATSI_NotAllowedParam_extensionContainer),
        ])
    ATSI_NotAllowedParam._ext = []
    
    #-----< ATM-NotAllowedParam >-----#
    ATM_NotAllowedParam = SEQ(name='ATM-NotAllowedParam', mode=MODE_TYPE)
    _ATM_NotAllowedParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATM_NotAllowedParam._cont = ASN1Dict([
        ('extensionContainer', _ATM_NotAllowedParam_extensionContainer),
        ])
    ATM_NotAllowedParam._ext = []
    
    #-----< IllegalSS-OperationParam >-----#
    IllegalSS_OperationParam = SEQ(name='IllegalSS-OperationParam', mode=MODE_TYPE)
    _IllegalSS_OperationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSS_OperationParam._cont = ASN1Dict([
        ('extensionContainer', _IllegalSS_OperationParam_extensionContainer),
        ])
    IllegalSS_OperationParam._ext = []
    
    #-----< SS-NotAvailableParam >-----#
    SS_NotAvailableParam = SEQ(name='SS-NotAvailableParam', mode=MODE_TYPE)
    _SS_NotAvailableParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_NotAvailableParam._cont = ASN1Dict([
        ('extensionContainer', _SS_NotAvailableParam_extensionContainer),
        ])
    SS_NotAvailableParam._ext = []
    
    #-----< SS-SubscriptionViolationParam >-----#
    SS_SubscriptionViolationParam = SEQ(name='SS-SubscriptionViolationParam', mode=MODE_TYPE)
    _SS_SubscriptionViolationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_SubscriptionViolationParam._cont = ASN1Dict([
        ('extensionContainer', _SS_SubscriptionViolationParam_extensionContainer),
        ])
    SS_SubscriptionViolationParam._ext = []
    
    #-----< InformationNotAvailableParam >-----#
    InformationNotAvailableParam = SEQ(name='InformationNotAvailableParam', mode=MODE_TYPE)
    _InformationNotAvailableParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    InformationNotAvailableParam._cont = ASN1Dict([
        ('extensionContainer', _InformationNotAvailableParam_extensionContainer),
        ])
    InformationNotAvailableParam._ext = []
    
    #-----< SubBusyForMT-SMS-Param >-----#
    SubBusyForMT_SMS_Param = SEQ(name='SubBusyForMT-SMS-Param', mode=MODE_TYPE)
    _SubBusyForMT_SMS_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubBusyForMT_SMS_Param_gprsConnectionSuspended = NULL(name='gprsConnectionSuspended', mode=MODE_TYPE, opt=True)
    SubBusyForMT_SMS_Param._cont = ASN1Dict([
        ('extensionContainer', _SubBusyForMT_SMS_Param_extensionContainer),
        ('gprsConnectionSuspended', _SubBusyForMT_SMS_Param_gprsConnectionSuspended),
        ])
    SubBusyForMT_SMS_Param._ext = ['gprsConnectionSuspended']
    
    #-----< MessageWaitListFullParam >-----#
    MessageWaitListFullParam = SEQ(name='MessageWaitListFullParam', mode=MODE_TYPE)
    _MessageWaitListFullParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MessageWaitListFullParam._cont = ASN1Dict([
        ('extensionContainer', _MessageWaitListFullParam_extensionContainer),
        ])
    MessageWaitListFullParam._ext = []
    
    #-----< ResourceLimitationParam >-----#
    ResourceLimitationParam = SEQ(name='ResourceLimitationParam', mode=MODE_TYPE)
    _ResourceLimitationParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResourceLimitationParam._cont = ASN1Dict([
        ('extensionContainer', _ResourceLimitationParam_extensionContainer),
        ])
    ResourceLimitationParam._ext = []
    
    #-----< NoGroupCallNbParam >-----#
    NoGroupCallNbParam = SEQ(name='NoGroupCallNbParam', mode=MODE_TYPE)
    _NoGroupCallNbParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoGroupCallNbParam._cont = ASN1Dict([
        ('extensionContainer', _NoGroupCallNbParam_extensionContainer),
        ])
    NoGroupCallNbParam._ext = []
    
    #-----< IncompatibleTerminalParam >-----#
    IncompatibleTerminalParam = SEQ(name='IncompatibleTerminalParam', mode=MODE_TYPE)
    _IncompatibleTerminalParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IncompatibleTerminalParam._cont = ASN1Dict([
        ('extensionContainer', _IncompatibleTerminalParam_extensionContainer),
        ])
    IncompatibleTerminalParam._ext = []
    
    #-----< ShortTermDenialParam >-----#
    ShortTermDenialParam = SEQ(name='ShortTermDenialParam', mode=MODE_TYPE)
    ShortTermDenialParam._cont = ASN1Dict([
        ])
    ShortTermDenialParam._ext = []
    
    #-----< LongTermDenialParam >-----#
    LongTermDenialParam = SEQ(name='LongTermDenialParam', mode=MODE_TYPE)
    LongTermDenialParam._cont = ASN1Dict([
        ])
    LongTermDenialParam._ext = []
    
    #-----< UnauthorizedRequestingNetwork-Param >-----#
    UnauthorizedRequestingNetwork_Param = SEQ(name='UnauthorizedRequestingNetwork-Param', mode=MODE_TYPE)
    _UnauthorizedRequestingNetwork_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedRequestingNetwork_Param._cont = ASN1Dict([
        ('extensionContainer', _UnauthorizedRequestingNetwork_Param_extensionContainer),
        ])
    UnauthorizedRequestingNetwork_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Param >-----#
    UnauthorizedLCSClient_Param = SEQ(name='UnauthorizedLCSClient-Param', mode=MODE_TYPE)
    _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic = ENUM(name='unauthorizedLCSClient-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnauthorizedLCSClient-Diagnostic')), opt=True)
    _UnauthorizedLCSClient_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedLCSClient_Param._cont = ASN1Dict([
        ('unauthorizedLCSClient-Diagnostic', _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic),
        ('extensionContainer', _UnauthorizedLCSClient_Param_extensionContainer),
        ])
    UnauthorizedLCSClient_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Diagnostic >-----#
    UnauthorizedLCSClient_Diagnostic = ENUM(name='UnauthorizedLCSClient-Diagnostic', mode=MODE_TYPE)
    UnauthorizedLCSClient_Diagnostic._cont = ASN1Dict([('noAdditionalInformation', 0), ('clientNotInMSPrivacyExceptionList', 1), ('callToClientNotSetup', 2), ('privacyOverrideNotApplicable', 3), ('disallowedByLocalRegulatoryRequirements', 4), ('unauthorizedPrivacyClass', 5), ('unauthorizedCallSessionUnrelatedExternalClient', 6), ('unauthorizedCallSessionRelatedExternalClient', 7)])
    UnauthorizedLCSClient_Diagnostic._ext = ['unauthorizedPrivacyClass', 'unauthorizedCallSessionUnrelatedExternalClient', 'unauthorizedCallSessionRelatedExternalClient']
    
    #-----< PositionMethodFailure-Param >-----#
    PositionMethodFailure_Param = SEQ(name='PositionMethodFailure-Param', mode=MODE_TYPE)
    _PositionMethodFailure_Param_positionMethodFailure_Diagnostic = ENUM(name='positionMethodFailure-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'PositionMethodFailure-Diagnostic')), opt=True)
    _PositionMethodFailure_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PositionMethodFailure_Param._cont = ASN1Dict([
        ('positionMethodFailure-Diagnostic', _PositionMethodFailure_Param_positionMethodFailure_Diagnostic),
        ('extensionContainer', _PositionMethodFailure_Param_extensionContainer),
        ])
    PositionMethodFailure_Param._ext = []
    
    #-----< PositionMethodFailure-Diagnostic >-----#
    PositionMethodFailure_Diagnostic = ENUM(name='PositionMethodFailure-Diagnostic', mode=MODE_TYPE)
    PositionMethodFailure_Diagnostic._cont = ASN1Dict([('congestion', 0), ('insufficientResources', 1), ('insufficientMeasurementData', 2), ('inconsistentMeasurementData', 3), ('locationProcedureNotCompleted', 4), ('locationProcedureNotSupportedByTargetMS', 5), ('qoSNotAttainable', 6), ('positionMethodNotAvailableInNetwork', 7), ('positionMethodNotAvailableInLocationArea', 8)])
    PositionMethodFailure_Diagnostic._ext = []
    
    #-----< UnknownOrUnreachableLCSClient-Param >-----#
    UnknownOrUnreachableLCSClient_Param = SEQ(name='UnknownOrUnreachableLCSClient-Param', mode=MODE_TYPE)
    _UnknownOrUnreachableLCSClient_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnknownOrUnreachableLCSClient_Param._cont = ASN1Dict([
        ('extensionContainer', _UnknownOrUnreachableLCSClient_Param_extensionContainer),
        ])
    UnknownOrUnreachableLCSClient_Param._ext = []
    
    #-----< MM-EventNotSupported-Param >-----#
    MM_EventNotSupported_Param = SEQ(name='MM-EventNotSupported-Param', mode=MODE_TYPE)
    _MM_EventNotSupported_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MM_EventNotSupported_Param._cont = ASN1Dict([
        ('extensionContainer', _MM_EventNotSupported_Param_extensionContainer),
        ])
    MM_EventNotSupported_Param._ext = []
    
    #-----< TargetCellOutsideGCA-Param >-----#
    TargetCellOutsideGCA_Param = SEQ(name='TargetCellOutsideGCA-Param', mode=MODE_TYPE)
    _TargetCellOutsideGCA_Param_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TargetCellOutsideGCA_Param._cont = ASN1Dict([
        ('extensionContainer', _TargetCellOutsideGCA_Param_extensionContainer),
        ])
    TargetCellOutsideGCA_Param._ext = []
    
    #-----< OngoingGroupCallParam >-----#
    OngoingGroupCallParam = SEQ(name='OngoingGroupCallParam', mode=MODE_TYPE)
    _OngoingGroupCallParam_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OngoingGroupCallParam._cont = ASN1Dict([
        ('extensionContainer', _OngoingGroupCallParam_extensionContainer),
        ])
    OngoingGroupCallParam._ext = []
    
    _all_ = [
        _RoamingNotAllowedParam_roamingNotAllowedCause,
        _RoamingNotAllowedParam_extensionContainer,
        _RoamingNotAllowedParam_additionalRoamingNotAllowedCause,
        RoamingNotAllowedParam,
        AdditionalRoamingNotAllowedCause,
        RoamingNotAllowedCause,
        _CallBarredParam_callBarringCause,
        _CallBarredParam_extensibleCallBarredParam,
        CallBarredParam,
        CallBarringCause,
        _ExtensibleCallBarredParam_callBarringCause,
        _ExtensibleCallBarredParam_extensionContainer,
        _ExtensibleCallBarredParam_unauthorisedMessageOriginator,
        _ExtensibleCallBarredParam_anonymousCallRejection,
        ExtensibleCallBarredParam,
        _CUG_RejectParam_cug_RejectCause,
        _CUG_RejectParam_extensionContainer,
        CUG_RejectParam,
        CUG_RejectCause,
        _SS_IncompatibilityCause_ss_Code,
        _SS_IncompatibilityCause_basicService,
        _SS_IncompatibilityCause_ss_Status,
        SS_IncompatibilityCause,
        PW_RegistrationFailureCause,
        SM_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_diagnosticInfo,
        _SM_DeliveryFailureCause_extensionContainer,
        SM_DeliveryFailureCause,
        _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_extensionContainer,
        _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_imsi,
        _AbsentSubscriberSM_Param_requestedRetransmissionTime,
        _AbsentSubscriberSM_Param_userIdentifierAlert,
        AbsentSubscriberSM_Param,
        AbsentSubscriberDiagnosticSM,
        _SystemFailureParam_networkResource,
        _SystemFailureParam_extensibleSystemFailureParam,
        SystemFailureParam,
        _ExtensibleSystemFailureParam_networkResource,
        _ExtensibleSystemFailureParam_extensionContainer,
        _ExtensibleSystemFailureParam_additionalNetworkResource,
        _ExtensibleSystemFailureParam_failureCauseParam,
        ExtensibleSystemFailureParam,
        FailureCauseParam,
        _DataMissingParam_extensionContainer,
        DataMissingParam,
        _UnexpectedDataParam_extensionContainer,
        _UnexpectedDataParam_unexpectedSubscriber,
        UnexpectedDataParam,
        _FacilityNotSupParam_extensionContainer,
        _FacilityNotSupParam_shapeOfLocationEstimateNotSupported,
        _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode,
        FacilityNotSupParam,
        _OR_NotAllowedParam_extensionContainer,
        OR_NotAllowedParam,
        _UnknownSubscriberParam_extensionContainer,
        _UnknownSubscriberParam_unknownSubscriberDiagnostic,
        UnknownSubscriberParam,
        UnknownSubscriberDiagnostic,
        _NumberChangedParam_extensionContainer,
        NumberChangedParam,
        _UnidentifiedSubParam_extensionContainer,
        UnidentifiedSubParam,
        _IllegalSubscriberParam_extensionContainer,
        IllegalSubscriberParam,
        _IllegalEquipmentParam_extensionContainer,
        IllegalEquipmentParam,
        _BearerServNotProvParam_extensionContainer,
        BearerServNotProvParam,
        _TeleservNotProvParam_extensionContainer,
        TeleservNotProvParam,
        _TracingBufferFullParam_extensionContainer,
        TracingBufferFullParam,
        _NoRoamingNbParam_extensionContainer,
        NoRoamingNbParam,
        _AbsentSubscriberParam_extensionContainer,
        _AbsentSubscriberParam_absentSubscriberReason,
        AbsentSubscriberParam,
        AbsentSubscriberReason,
        _BusySubscriberParam_extensionContainer,
        _BusySubscriberParam_ccbs_Possible,
        _BusySubscriberParam_ccbs_Busy,
        BusySubscriberParam,
        _NoSubscriberReplyParam_extensionContainer,
        NoSubscriberReplyParam,
        _ForwardingViolationParam_extensionContainer,
        ForwardingViolationParam,
        _ForwardingFailedParam_extensionContainer,
        ForwardingFailedParam,
        _ATI_NotAllowedParam_extensionContainer,
        ATI_NotAllowedParam,
        _ATSI_NotAllowedParam_extensionContainer,
        ATSI_NotAllowedParam,
        _ATM_NotAllowedParam_extensionContainer,
        ATM_NotAllowedParam,
        _IllegalSS_OperationParam_extensionContainer,
        IllegalSS_OperationParam,
        _SS_NotAvailableParam_extensionContainer,
        SS_NotAvailableParam,
        _SS_SubscriptionViolationParam_extensionContainer,
        SS_SubscriptionViolationParam,
        _InformationNotAvailableParam_extensionContainer,
        InformationNotAvailableParam,
        _SubBusyForMT_SMS_Param_extensionContainer,
        _SubBusyForMT_SMS_Param_gprsConnectionSuspended,
        SubBusyForMT_SMS_Param,
        _MessageWaitListFullParam_extensionContainer,
        MessageWaitListFullParam,
        _ResourceLimitationParam_extensionContainer,
        ResourceLimitationParam,
        _NoGroupCallNbParam_extensionContainer,
        NoGroupCallNbParam,
        _IncompatibleTerminalParam_extensionContainer,
        IncompatibleTerminalParam,
        ShortTermDenialParam,
        LongTermDenialParam,
        _UnauthorizedRequestingNetwork_Param_extensionContainer,
        UnauthorizedRequestingNetwork_Param,
        _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic,
        _UnauthorizedLCSClient_Param_extensionContainer,
        UnauthorizedLCSClient_Param,
        UnauthorizedLCSClient_Diagnostic,
        _PositionMethodFailure_Param_positionMethodFailure_Diagnostic,
        _PositionMethodFailure_Param_extensionContainer,
        PositionMethodFailure_Param,
        PositionMethodFailure_Diagnostic,
        _UnknownOrUnreachableLCSClient_Param_extensionContainer,
        UnknownOrUnreachableLCSClient_Param,
        _MM_EventNotSupported_Param_extensionContainer,
        MM_EventNotSupported_Param,
        _TargetCellOutsideGCA_Param_extensionContainer,
        TargetCellOutsideGCA_Param,
        _OngoingGroupCallParam_extensionContainer,
        OngoingGroupCallParam,
    ]

class MAP_ExtensionDataTypes:

    _name_  = 'MAP-ExtensionDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 21, 19]
    
    _obj_ = [
        'MAP-EXTENSION',
        'ExtensionContainer',
        'SLR-ArgExtensionContainer',
        'PrivateExtensionList',
        'PrivateExtension',
        'maxNumOfPrivateExtensions',
        'ExtensionSet',
        'PCS-Extensions',
        'SLR-Arg-PCS-Extensions',
        ]
    _type_ = [
        'MAP-EXTENSION',
        'ExtensionContainer',
        'SLR-ArgExtensionContainer',
        'PrivateExtensionList',
        'PrivateExtension',
        'PCS-Extensions',
        'SLR-Arg-PCS-Extensions',
        ]
    _set_ = [
        'ExtensionSet',
        ]
    _val_ = [
        'maxNumOfPrivateExtensions',
        ]
    _class_ = [
        'MAP-EXTENSION',
        'ExtensionSet',
        ]
    _param_ = [
        ]
    
    #-----< MAP-EXTENSION >-----#
    MAP_EXTENSION = CLASS(name='MAP-EXTENSION', mode=MODE_TYPE)
    _MAP_EXTENSION_ExtensionType = OPEN(name='ExtensionType', mode=MODE_TYPE, opt=True)
    _MAP_EXTENSION_extensionId = OID(name='extensionId', mode=MODE_VALUE)
    MAP_EXTENSION._cont = ASN1Dict([
        ('ExtensionType', _MAP_EXTENSION_ExtensionType),
        ('extensionId', _MAP_EXTENSION_extensionId),
        ])
    
    #-----< ExtensionContainer >-----#
    ExtensionContainer = SEQ(name='ExtensionContainer', mode=MODE_TYPE)
    _ExtensionContainer_privateExtensionList = SEQ_OF(name='privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _ExtensionContainer_pcs_Extensions = SEQ(name='pcs-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PCS-Extensions')), opt=True)
    ExtensionContainer._cont = ASN1Dict([
        ('privateExtensionList', _ExtensionContainer_privateExtensionList),
        ('pcs-Extensions', _ExtensionContainer_pcs_Extensions),
        ])
    ExtensionContainer._ext = []
    
    #-----< SLR-ArgExtensionContainer >-----#
    SLR_ArgExtensionContainer = SEQ(name='SLR-ArgExtensionContainer', mode=MODE_TYPE)
    _SLR_ArgExtensionContainer_privateExtensionList = SEQ_OF(name='privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions = SEQ(name='slr-Arg-PCS-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'SLR-Arg-PCS-Extensions')), opt=True)
    SLR_ArgExtensionContainer._cont = ASN1Dict([
        ('privateExtensionList', _SLR_ArgExtensionContainer_privateExtensionList),
        ('slr-Arg-PCS-Extensions', _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions),
        ])
    SLR_ArgExtensionContainer._ext = []
    
    #-----< PrivateExtensionList >-----#
    PrivateExtensionList = SEQ_OF(name='PrivateExtensionList', mode=MODE_TYPE)
    _PrivateExtensionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtension')))
    PrivateExtensionList._cont = _PrivateExtensionList__item_
    PrivateExtensionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< PrivateExtension >-----#
    PrivateExtension = SEQ(name='PrivateExtension', mode=MODE_TYPE)
    _PrivateExtension_extId = OID(name='extId', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), ['extensionId']))
    __PrivateExtension_extId_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extId._const_tab = __PrivateExtension_extId_tab
    _PrivateExtension_extId._const_tab_at = None
    _PrivateExtension_extId._const_tab_id = 'extensionId'
    _PrivateExtension_extType = OPEN(name='extType', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), ['ExtensionType']), opt=True)
    __PrivateExtension_extType_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extType._const_tab = __PrivateExtension_extType_tab
    _PrivateExtension_extType._const_tab_at = ('..', 'extId')
    _PrivateExtension_extType._const_tab_id = 'ExtensionType'
    PrivateExtension._cont = ASN1Dict([
        ('extId', _PrivateExtension_extId),
        ('extType', _PrivateExtension_extType),
        ])
    PrivateExtension._ext = None
    
    #-----< maxNumOfPrivateExtensions >-----#
    maxNumOfPrivateExtensions = INT(name='maxNumOfPrivateExtensions', mode=MODE_VALUE)
    maxNumOfPrivateExtensions._val = 10
    
    #-----< ExtensionSet >-----#
    ExtensionSet = CLASS(name='ExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    ExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCS-Extensions >-----#
    PCS_Extensions = SEQ(name='PCS-Extensions', mode=MODE_TYPE)
    PCS_Extensions._cont = ASN1Dict([
        ])
    PCS_Extensions._ext = []
    
    #-----< SLR-Arg-PCS-Extensions >-----#
    SLR_Arg_PCS_Extensions = SEQ(name='SLR-Arg-PCS-Extensions', mode=MODE_TYPE)
    _SLR_Arg_PCS_Extensions_na_ESRK_Request = NULL(name='na-ESRK-Request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SLR_Arg_PCS_Extensions._cont = ASN1Dict([
        ('na-ESRK-Request', _SLR_Arg_PCS_Extensions_na_ESRK_Request),
        ])
    SLR_Arg_PCS_Extensions._ext = ['na-ESRK-Request']
    
    _all_ = [
        _MAP_EXTENSION_ExtensionType,
        _MAP_EXTENSION_extensionId,
        MAP_EXTENSION,
        _ExtensionContainer_privateExtensionList,
        _ExtensionContainer_pcs_Extensions,
        ExtensionContainer,
        _SLR_ArgExtensionContainer_privateExtensionList,
        _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions,
        SLR_ArgExtensionContainer,
        _PrivateExtensionList__item_,
        PrivateExtensionList,
        __PrivateExtension_extId_tab,
        _PrivateExtension_extId,
        __PrivateExtension_extType_tab,
        _PrivateExtension_extType,
        PrivateExtension,
        maxNumOfPrivateExtensions,
        ExtensionSet,
        PCS_Extensions,
        _SLR_Arg_PCS_Extensions_na_ESRK_Request,
        SLR_Arg_PCS_Extensions,
    ]

class MAP_LCS_DataTypes:

    _name_  = 'MAP-LCS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 25, 19]
    
    _obj_ = [
        'RoutingInfoForLCS-Arg',
        'RoutingInfoForLCS-Res',
        'LCSLocationInfo',
        'ProvideSubscriberLocation-Arg',
        'LocationType',
        'LocationEstimateType',
        'DeferredLocationEventType',
        'LCS-ClientID',
        'LCSClientType',
        'LCSClientName',
        'NameString',
        'maxNameStringLength',
        'LCSRequestorID',
        'RequestorIDString',
        'maxRequestorIDStringLength',
        'LCS-FormatIndicator',
        'LCS-Priority',
        'LCS-QoS',
        'Horizontal-Accuracy',
        'Vertical-Accuracy',
        'ResponseTime',
        'ResponseTimeCategory',
        'SupportedGADShapes',
        'LCS-ReferenceNumber',
        'LCSCodeword',
        'LCSCodewordString',
        'maxLCSCodewordStringLength',
        'LCS-PrivacyCheck',
        'PrivacyCheckRelatedAction',
        'AreaEventInfo',
        'AreaDefinition',
        'AreaList',
        'maxNumOfAreas',
        'Area',
        'AreaType',
        'AreaIdentification',
        'OccurrenceInfo',
        'IntervalTime',
        'PeriodicLDRInfo',
        'ReportingAmount',
        'maxReportingAmount',
        'ReportingInterval',
        'maxReportingInterval',
        'ReportingPLMNList',
        'PLMNList',
        'maxNumOfReportingPLMN',
        'ReportingPLMN',
        'RAN-Technology',
        'ProvideSubscriberLocation-Res',
        'AccuracyFulfilmentIndicator',
        'Ext-GeographicalInformation',
        'maxExt-GeographicalInformation',
        'VelocityEstimate',
        'PositioningDataInformation',
        'maxPositioningDataInformation',
        'UtranPositioningDataInfo',
        'maxUtranPositioningDataInfo',
        'GeranGANSSpositioningData',
        'maxGeranGANSSpositioningData',
        'UtranGANSSpositioningData',
        'maxUtranGANSSpositioningData',
        'UtranAdditionalPositioningData',
        'maxUtranAdditionalPositioningData',
        'UtranBaroPressureMeas',
        'UtranCivicAddress',
        'Add-GeographicalInformation',
        'maxAdd-GeographicalInformation',
        'SubscriberLocationReport-Arg',
        'Deferredmt-lrData',
        'LCS-Event',
        'TerminationCause',
        'SequenceNumber',
        'ServingNodeAddress',
        'SubscriberLocationReport-Res',
        ]
    _type_ = [
        'RoutingInfoForLCS-Arg',
        'RoutingInfoForLCS-Res',
        'LCSLocationInfo',
        'ProvideSubscriberLocation-Arg',
        'LocationType',
        'LocationEstimateType',
        'DeferredLocationEventType',
        'LCS-ClientID',
        'LCSClientType',
        'LCSClientName',
        'NameString',
        'LCSRequestorID',
        'RequestorIDString',
        'LCS-FormatIndicator',
        'LCS-Priority',
        'LCS-QoS',
        'Horizontal-Accuracy',
        'Vertical-Accuracy',
        'ResponseTime',
        'ResponseTimeCategory',
        'SupportedGADShapes',
        'LCS-ReferenceNumber',
        'LCSCodeword',
        'LCSCodewordString',
        'LCS-PrivacyCheck',
        'PrivacyCheckRelatedAction',
        'AreaEventInfo',
        'AreaDefinition',
        'AreaList',
        'Area',
        'AreaType',
        'AreaIdentification',
        'OccurrenceInfo',
        'IntervalTime',
        'PeriodicLDRInfo',
        'ReportingAmount',
        'ReportingInterval',
        'ReportingPLMNList',
        'PLMNList',
        'ReportingPLMN',
        'RAN-Technology',
        'ProvideSubscriberLocation-Res',
        'AccuracyFulfilmentIndicator',
        'Ext-GeographicalInformation',
        'VelocityEstimate',
        'PositioningDataInformation',
        'UtranPositioningDataInfo',
        'GeranGANSSpositioningData',
        'UtranGANSSpositioningData',
        'UtranAdditionalPositioningData',
        'UtranBaroPressureMeas',
        'UtranCivicAddress',
        'Add-GeographicalInformation',
        'SubscriberLocationReport-Arg',
        'Deferredmt-lrData',
        'LCS-Event',
        'TerminationCause',
        'SequenceNumber',
        'ServingNodeAddress',
        'SubscriberLocationReport-Res',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxNameStringLength',
        'maxRequestorIDStringLength',
        'maxLCSCodewordStringLength',
        'maxNumOfAreas',
        'maxReportingAmount',
        'maxReportingInterval',
        'maxNumOfReportingPLMN',
        'maxExt-GeographicalInformation',
        'maxPositioningDataInformation',
        'maxUtranPositioningDataInfo',
        'maxGeranGANSSpositioningData',
        'maxUtranGANSSpositioningData',
        'maxUtranAdditionalPositioningData',
        'maxAdd-GeographicalInformation',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoutingInfoForLCS-Arg >-----#
    RoutingInfoForLCS_Arg = SEQ(name='RoutingInfoForLCS-Arg', mode=MODE_TYPE)
    _RoutingInfoForLCS_Arg_mlcNumber = OCT_STR(name='mlcNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfoForLCS_Arg_targetMS = CHOICE(name='targetMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _RoutingInfoForLCS_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RoutingInfoForLCS_Arg._cont = ASN1Dict([
        ('mlcNumber', _RoutingInfoForLCS_Arg_mlcNumber),
        ('targetMS', _RoutingInfoForLCS_Arg_targetMS),
        ('extensionContainer', _RoutingInfoForLCS_Arg_extensionContainer),
        ])
    RoutingInfoForLCS_Arg._ext = []
    
    #-----< RoutingInfoForLCS-Res >-----#
    RoutingInfoForLCS_Res = SEQ(name='RoutingInfoForLCS-Res', mode=MODE_TYPE)
    _RoutingInfoForLCS_Res_targetMS = CHOICE(name='targetMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _RoutingInfoForLCS_Res_lcsLocationInfo = SEQ(name='lcsLocationInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSLocationInfo')))
    _RoutingInfoForLCS_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoutingInfoForLCS_Res_v_gmlc_Address = OCT_STR(name='v-gmlc-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _RoutingInfoForLCS_Res_h_gmlc_Address = OCT_STR(name='h-gmlc-Address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _RoutingInfoForLCS_Res_ppr_Address = OCT_STR(name='ppr-Address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _RoutingInfoForLCS_Res_additional_v_gmlc_Address = OCT_STR(name='additional-v-gmlc-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    RoutingInfoForLCS_Res._cont = ASN1Dict([
        ('targetMS', _RoutingInfoForLCS_Res_targetMS),
        ('lcsLocationInfo', _RoutingInfoForLCS_Res_lcsLocationInfo),
        ('extensionContainer', _RoutingInfoForLCS_Res_extensionContainer),
        ('v-gmlc-Address', _RoutingInfoForLCS_Res_v_gmlc_Address),
        ('h-gmlc-Address', _RoutingInfoForLCS_Res_h_gmlc_Address),
        ('ppr-Address', _RoutingInfoForLCS_Res_ppr_Address),
        ('additional-v-gmlc-Address', _RoutingInfoForLCS_Res_additional_v_gmlc_Address),
        ])
    RoutingInfoForLCS_Res._ext = ['v-gmlc-Address', 'h-gmlc-Address', 'ppr-Address', 'additional-v-gmlc-Address']
    
    #-----< LCSLocationInfo >-----#
    LCSLocationInfo = SEQ(name='LCSLocationInfo', mode=MODE_TYPE)
    _LCSLocationInfo_networkNode_Number = OCT_STR(name='networkNode-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _LCSLocationInfo_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _LCSLocationInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCSLocationInfo_gprsNodeIndicator = NULL(name='gprsNodeIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCSLocationInfo_additional_Number = CHOICE(name='additional-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'Additional-Number')), opt=True)
    _LCSLocationInfo_supportedLCS_CapabilitySets = BIT_STR(name='supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _LCSLocationInfo_additional_LCS_CapabilitySets = BIT_STR(name='additional-LCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _LCSLocationInfo_mme_Name = OCT_STR(name='mme-Name', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _LCSLocationInfo_aaa_Server_Name = OCT_STR(name='aaa-Server-Name', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _LCSLocationInfo_sgsn_Name = OCT_STR(name='sgsn-Name', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _LCSLocationInfo_sgsn_Realm = OCT_STR(name='sgsn-Realm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    LCSLocationInfo._cont = ASN1Dict([
        ('networkNode-Number', _LCSLocationInfo_networkNode_Number),
        ('lmsi', _LCSLocationInfo_lmsi),
        ('extensionContainer', _LCSLocationInfo_extensionContainer),
        ('gprsNodeIndicator', _LCSLocationInfo_gprsNodeIndicator),
        ('additional-Number', _LCSLocationInfo_additional_Number),
        ('supportedLCS-CapabilitySets', _LCSLocationInfo_supportedLCS_CapabilitySets),
        ('additional-LCS-CapabilitySets', _LCSLocationInfo_additional_LCS_CapabilitySets),
        ('mme-Name', _LCSLocationInfo_mme_Name),
        ('aaa-Server-Name', _LCSLocationInfo_aaa_Server_Name),
        ('sgsn-Name', _LCSLocationInfo_sgsn_Name),
        ('sgsn-Realm', _LCSLocationInfo_sgsn_Realm),
        ])
    LCSLocationInfo._ext = ['gprsNodeIndicator', 'additional-Number', 'supportedLCS-CapabilitySets', 'additional-LCS-CapabilitySets', 'mme-Name', 'aaa-Server-Name', 'sgsn-Name', 'sgsn-Realm']
    
    #-----< ProvideSubscriberLocation-Arg >-----#
    ProvideSubscriberLocation_Arg = SEQ(name='ProvideSubscriberLocation-Arg', mode=MODE_TYPE)
    _ProvideSubscriberLocation_Arg_locationType = SEQ(name='locationType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _ProvideSubscriberLocation_Arg_mlc_Number = OCT_STR(name='mlc-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideSubscriberLocation_Arg_lcs_ClientID = SEQ(name='lcs-ClientID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ClientID')), opt=True)
    _ProvideSubscriberLocation_Arg_privacyOverride = NULL(name='privacyOverride', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ProvideSubscriberLocation_Arg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideSubscriberLocation_Arg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideSubscriberLocation_Arg_imei = OCT_STR(name='imei', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_Priority = OCT_STR(name='lcs-Priority', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_QoS = SEQ(name='lcs-QoS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-QoS')), opt=True)
    _ProvideSubscriberLocation_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberLocation_Arg_supportedGADShapes = BIT_STR(name='supportedGADShapes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SupportedGADShapes')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_ReferenceNumber = OCT_STR(name='lcs-ReferenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _ProvideSubscriberLocation_Arg_lcsServiceTypeID = INT(name='lcsServiceTypeID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    _ProvideSubscriberLocation_Arg_lcsCodeword = SEQ(name='lcsCodeword', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSCodeword')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_PrivacyCheck = SEQ(name='lcs-PrivacyCheck', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-PrivacyCheck')), opt=True)
    _ProvideSubscriberLocation_Arg_areaEventInfo = SEQ(name='areaEventInfo', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaEventInfo')), opt=True)
    _ProvideSubscriberLocation_Arg_h_gmlc_Address = OCT_STR(name='h-gmlc-Address', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _ProvideSubscriberLocation_Arg_mo_lrShortCircuitIndicator = NULL(name='mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Arg_periodicLDRInfo = SEQ(name='periodicLDRInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')), opt=True)
    _ProvideSubscriberLocation_Arg_reportingPLMNList = SEQ(name='reportingPLMNList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    ProvideSubscriberLocation_Arg._cont = ASN1Dict([
        ('locationType', _ProvideSubscriberLocation_Arg_locationType),
        ('mlc-Number', _ProvideSubscriberLocation_Arg_mlc_Number),
        ('lcs-ClientID', _ProvideSubscriberLocation_Arg_lcs_ClientID),
        ('privacyOverride', _ProvideSubscriberLocation_Arg_privacyOverride),
        ('imsi', _ProvideSubscriberLocation_Arg_imsi),
        ('msisdn', _ProvideSubscriberLocation_Arg_msisdn),
        ('lmsi', _ProvideSubscriberLocation_Arg_lmsi),
        ('imei', _ProvideSubscriberLocation_Arg_imei),
        ('lcs-Priority', _ProvideSubscriberLocation_Arg_lcs_Priority),
        ('lcs-QoS', _ProvideSubscriberLocation_Arg_lcs_QoS),
        ('extensionContainer', _ProvideSubscriberLocation_Arg_extensionContainer),
        ('supportedGADShapes', _ProvideSubscriberLocation_Arg_supportedGADShapes),
        ('lcs-ReferenceNumber', _ProvideSubscriberLocation_Arg_lcs_ReferenceNumber),
        ('lcsServiceTypeID', _ProvideSubscriberLocation_Arg_lcsServiceTypeID),
        ('lcsCodeword', _ProvideSubscriberLocation_Arg_lcsCodeword),
        ('lcs-PrivacyCheck', _ProvideSubscriberLocation_Arg_lcs_PrivacyCheck),
        ('areaEventInfo', _ProvideSubscriberLocation_Arg_areaEventInfo),
        ('h-gmlc-Address', _ProvideSubscriberLocation_Arg_h_gmlc_Address),
        ('mo-lrShortCircuitIndicator', _ProvideSubscriberLocation_Arg_mo_lrShortCircuitIndicator),
        ('periodicLDRInfo', _ProvideSubscriberLocation_Arg_periodicLDRInfo),
        ('reportingPLMNList', _ProvideSubscriberLocation_Arg_reportingPLMNList),
        ])
    ProvideSubscriberLocation_Arg._ext = ['supportedGADShapes', 'lcs-ReferenceNumber', 'lcsServiceTypeID', 'lcsCodeword', 'lcs-PrivacyCheck', 'areaEventInfo', 'h-gmlc-Address', 'mo-lrShortCircuitIndicator', 'periodicLDRInfo', 'reportingPLMNList']
    
    #-----< LocationType >-----#
    LocationType = SEQ(name='LocationType', mode=MODE_TYPE)
    _LocationType_locationEstimateType = ENUM(name='locationEstimateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationEstimateType')))
    _LocationType_deferredLocationEventType = BIT_STR(name='deferredLocationEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'DeferredLocationEventType')), opt=True)
    LocationType._cont = ASN1Dict([
        ('locationEstimateType', _LocationType_locationEstimateType),
        ('deferredLocationEventType', _LocationType_deferredLocationEventType),
        ])
    LocationType._ext = ['deferredLocationEventType']
    
    #-----< LocationEstimateType >-----#
    LocationEstimateType = ENUM(name='LocationEstimateType', mode=MODE_TYPE)
    LocationEstimateType._cont = ASN1Dict([('currentLocation', 0), ('currentOrLastKnownLocation', 1), ('initialLocation', 2), ('activateDeferredLocation', 3), ('cancelDeferredLocation', 4), ('notificationVerificationOnly', 5)])
    LocationEstimateType._ext = ['activateDeferredLocation', 'cancelDeferredLocation', 'notificationVerificationOnly']
    
    #-----< DeferredLocationEventType >-----#
    DeferredLocationEventType = BIT_STR(name='DeferredLocationEventType', mode=MODE_TYPE)
    DeferredLocationEventType._cont = ASN1Dict([('msAvailable', 0), ('enteringIntoArea', 1), ('leavingFromArea', 2), ('beingInsideArea', 3), ('periodicLDR', 4)])
    DeferredLocationEventType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< LCS-ClientID >-----#
    LCS_ClientID = SEQ(name='LCS-ClientID', mode=MODE_TYPE)
    _LCS_ClientID_lcsClientType = ENUM(name='lcsClientType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')))
    _LCS_ClientID_lcsClientExternalID = SEQ(name='lcsClientExternalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LCS_ClientID_lcsClientDialedByMS = OCT_STR(name='lcsClientDialedByMS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _LCS_ClientID_lcsClientInternalID = ENUM(name='lcsClientInternalID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')), opt=True)
    _LCS_ClientID_lcsClientName = SEQ(name='lcsClientName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientName')), opt=True)
    _LCS_ClientID_lcsAPN = OCT_STR(name='lcsAPN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _LCS_ClientID_lcsRequestorID = SEQ(name='lcsRequestorID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSRequestorID')), opt=True)
    LCS_ClientID._cont = ASN1Dict([
        ('lcsClientType', _LCS_ClientID_lcsClientType),
        ('lcsClientExternalID', _LCS_ClientID_lcsClientExternalID),
        ('lcsClientDialedByMS', _LCS_ClientID_lcsClientDialedByMS),
        ('lcsClientInternalID', _LCS_ClientID_lcsClientInternalID),
        ('lcsClientName', _LCS_ClientID_lcsClientName),
        ('lcsAPN', _LCS_ClientID_lcsAPN),
        ('lcsRequestorID', _LCS_ClientID_lcsRequestorID),
        ])
    LCS_ClientID._ext = ['lcsAPN', 'lcsRequestorID']
    
    #-----< LCSClientType >-----#
    LCSClientType = ENUM(name='LCSClientType', mode=MODE_TYPE)
    LCSClientType._cont = ASN1Dict([('emergencyServices', 0), ('valueAddedServices', 1), ('plmnOperatorServices', 2), ('lawfulInterceptServices', 3)])
    LCSClientType._ext = []
    
    #-----< LCSClientName >-----#
    LCSClientName = SEQ(name='LCSClientName', mode=MODE_TYPE)
    _LCSClientName_dataCodingScheme = OCT_STR(name='dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _LCSClientName_nameString = OCT_STR(name='nameString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'NameString')))
    _LCSClientName_lcs_FormatIndicator = ENUM(name='lcs-FormatIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-FormatIndicator')), opt=True)
    LCSClientName._cont = ASN1Dict([
        ('dataCodingScheme', _LCSClientName_dataCodingScheme),
        ('nameString', _LCSClientName_nameString),
        ('lcs-FormatIndicator', _LCSClientName_lcs_FormatIndicator),
        ])
    LCSClientName._ext = ['lcs-FormatIndicator']
    
    #-----< NameString >-----#
    NameString = OCT_STR(name='NameString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    NameString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< maxNameStringLength >-----#
    maxNameStringLength = INT(name='maxNameStringLength', mode=MODE_VALUE)
    maxNameStringLength._val = 63
    
    #-----< LCSRequestorID >-----#
    LCSRequestorID = SEQ(name='LCSRequestorID', mode=MODE_TYPE)
    _LCSRequestorID_dataCodingScheme = OCT_STR(name='dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _LCSRequestorID_requestorIDString = OCT_STR(name='requestorIDString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'RequestorIDString')))
    _LCSRequestorID_lcs_FormatIndicator = ENUM(name='lcs-FormatIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-FormatIndicator')), opt=True)
    LCSRequestorID._cont = ASN1Dict([
        ('dataCodingScheme', _LCSRequestorID_dataCodingScheme),
        ('requestorIDString', _LCSRequestorID_requestorIDString),
        ('lcs-FormatIndicator', _LCSRequestorID_lcs_FormatIndicator),
        ])
    LCSRequestorID._ext = ['lcs-FormatIndicator']
    
    #-----< RequestorIDString >-----#
    RequestorIDString = OCT_STR(name='RequestorIDString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    RequestorIDString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< maxRequestorIDStringLength >-----#
    maxRequestorIDStringLength = INT(name='maxRequestorIDStringLength', mode=MODE_VALUE)
    maxRequestorIDStringLength._val = 63
    
    #-----< LCS-FormatIndicator >-----#
    LCS_FormatIndicator = ENUM(name='LCS-FormatIndicator', mode=MODE_TYPE)
    LCS_FormatIndicator._cont = ASN1Dict([('logicalName', 0), ('e-mailAddress', 1), ('msisdn', 2), ('url', 3), ('sipUrl', 4)])
    LCS_FormatIndicator._ext = []
    
    #-----< LCS-Priority >-----#
    LCS_Priority = OCT_STR(name='LCS-Priority', mode=MODE_TYPE)
    LCS_Priority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< LCS-QoS >-----#
    LCS_QoS = SEQ(name='LCS-QoS', mode=MODE_TYPE)
    _LCS_QoS_horizontal_accuracy = OCT_STR(name='horizontal-accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Horizontal-Accuracy')), opt=True)
    _LCS_QoS_verticalCoordinateRequest = NULL(name='verticalCoordinateRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_QoS_vertical_accuracy = OCT_STR(name='vertical-accuracy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Vertical-Accuracy')), opt=True)
    _LCS_QoS_responseTime = SEQ(name='responseTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ResponseTime')), opt=True)
    _LCS_QoS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCS_QoS_velocityRequest = NULL(name='velocityRequest', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    LCS_QoS._cont = ASN1Dict([
        ('horizontal-accuracy', _LCS_QoS_horizontal_accuracy),
        ('verticalCoordinateRequest', _LCS_QoS_verticalCoordinateRequest),
        ('vertical-accuracy', _LCS_QoS_vertical_accuracy),
        ('responseTime', _LCS_QoS_responseTime),
        ('extensionContainer', _LCS_QoS_extensionContainer),
        ('velocityRequest', _LCS_QoS_velocityRequest),
        ])
    LCS_QoS._ext = ['velocityRequest']
    
    #-----< Horizontal-Accuracy >-----#
    Horizontal_Accuracy = OCT_STR(name='Horizontal-Accuracy', mode=MODE_TYPE)
    Horizontal_Accuracy._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Vertical-Accuracy >-----#
    Vertical_Accuracy = OCT_STR(name='Vertical-Accuracy', mode=MODE_TYPE)
    Vertical_Accuracy._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ResponseTime >-----#
    ResponseTime = SEQ(name='ResponseTime', mode=MODE_TYPE)
    _ResponseTime_responseTimeCategory = ENUM(name='responseTimeCategory', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ResponseTimeCategory')))
    ResponseTime._cont = ASN1Dict([
        ('responseTimeCategory', _ResponseTime_responseTimeCategory),
        ])
    ResponseTime._ext = []
    
    #-----< ResponseTimeCategory >-----#
    ResponseTimeCategory = ENUM(name='ResponseTimeCategory', mode=MODE_TYPE)
    ResponseTimeCategory._cont = ASN1Dict([('lowdelay', 0), ('delaytolerant', 1)])
    ResponseTimeCategory._ext = []
    
    #-----< SupportedGADShapes >-----#
    SupportedGADShapes = BIT_STR(name='SupportedGADShapes', mode=MODE_TYPE)
    SupportedGADShapes._cont = ASN1Dict([('ellipsoidPoint', 0), ('ellipsoidPointWithUncertaintyCircle', 1), ('ellipsoidPointWithUncertaintyEllipse', 2), ('polygon', 3), ('ellipsoidPointWithAltitude', 4), ('ellipsoidPointWithAltitudeAndUncertaintyElipsoid', 5), ('ellipsoidArc', 6)])
    SupportedGADShapes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=16)], ev=None, er=[])
    
    #-----< LCS-ReferenceNumber >-----#
    LCS_ReferenceNumber = OCT_STR(name='LCS-ReferenceNumber', mode=MODE_TYPE)
    LCS_ReferenceNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< LCSCodeword >-----#
    LCSCodeword = SEQ(name='LCSCodeword', mode=MODE_TYPE)
    _LCSCodeword_dataCodingScheme = OCT_STR(name='dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _LCSCodeword_lcsCodewordString = OCT_STR(name='lcsCodewordString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSCodewordString')))
    LCSCodeword._cont = ASN1Dict([
        ('dataCodingScheme', _LCSCodeword_dataCodingScheme),
        ('lcsCodewordString', _LCSCodeword_lcsCodewordString),
        ])
    LCSCodeword._ext = []
    
    #-----< LCSCodewordString >-----#
    LCSCodewordString = OCT_STR(name='LCSCodewordString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    LCSCodewordString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxLCSCodewordStringLength >-----#
    maxLCSCodewordStringLength = INT(name='maxLCSCodewordStringLength', mode=MODE_VALUE)
    maxLCSCodewordStringLength._val = 20
    
    #-----< LCS-PrivacyCheck >-----#
    LCS_PrivacyCheck = SEQ(name='LCS-PrivacyCheck', mode=MODE_TYPE)
    _LCS_PrivacyCheck_callSessionUnrelated = ENUM(name='callSessionUnrelated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PrivacyCheckRelatedAction')))
    _LCS_PrivacyCheck_callSessionRelated = ENUM(name='callSessionRelated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PrivacyCheckRelatedAction')), opt=True)
    LCS_PrivacyCheck._cont = ASN1Dict([
        ('callSessionUnrelated', _LCS_PrivacyCheck_callSessionUnrelated),
        ('callSessionRelated', _LCS_PrivacyCheck_callSessionRelated),
        ])
    LCS_PrivacyCheck._ext = []
    
    #-----< PrivacyCheckRelatedAction >-----#
    PrivacyCheckRelatedAction = ENUM(name='PrivacyCheckRelatedAction', mode=MODE_TYPE)
    PrivacyCheckRelatedAction._cont = ASN1Dict([('allowedWithoutNotification', 0), ('allowedWithNotification', 1), ('allowedIfNoResponse', 2), ('restrictedIfNoResponse', 3), ('notAllowed', 4)])
    PrivacyCheckRelatedAction._ext = []
    
    #-----< AreaEventInfo >-----#
    AreaEventInfo = SEQ(name='AreaEventInfo', mode=MODE_TYPE)
    _AreaEventInfo_areaDefinition = SEQ(name='areaDefinition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaDefinition')))
    _AreaEventInfo_occurrenceInfo = ENUM(name='occurrenceInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'OccurrenceInfo')), opt=True)
    _AreaEventInfo_intervalTime = INT(name='intervalTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'IntervalTime')), opt=True)
    AreaEventInfo._cont = ASN1Dict([
        ('areaDefinition', _AreaEventInfo_areaDefinition),
        ('occurrenceInfo', _AreaEventInfo_occurrenceInfo),
        ('intervalTime', _AreaEventInfo_intervalTime),
        ])
    AreaEventInfo._ext = []
    
    #-----< AreaDefinition >-----#
    AreaDefinition = SEQ(name='AreaDefinition', mode=MODE_TYPE)
    _AreaDefinition_areaList = SEQ_OF(name='areaList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaList')))
    AreaDefinition._cont = ASN1Dict([
        ('areaList', _AreaDefinition_areaList),
        ])
    AreaDefinition._ext = []
    
    #-----< AreaList >-----#
    AreaList = SEQ_OF(name='AreaList', mode=MODE_TYPE)
    _AreaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Area')))
    AreaList._cont = _AreaList__item_
    AreaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfAreas >-----#
    maxNumOfAreas = INT(name='maxNumOfAreas', mode=MODE_VALUE)
    maxNumOfAreas._val = 10
    
    #-----< Area >-----#
    Area = SEQ(name='Area', mode=MODE_TYPE)
    _Area_areaType = ENUM(name='areaType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaType')))
    _Area_areaIdentification = OCT_STR(name='areaIdentification', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaIdentification')))
    Area._cont = ASN1Dict([
        ('areaType', _Area_areaType),
        ('areaIdentification', _Area_areaIdentification),
        ])
    Area._ext = []
    
    #-----< AreaType >-----#
    AreaType = ENUM(name='AreaType', mode=MODE_TYPE)
    AreaType._cont = ASN1Dict([('countryCode', 0), ('plmnId', 1), ('locationAreaId', 2), ('routingAreaId', 3), ('cellGlobalId', 4), ('utranCellId', 5)])
    AreaType._ext = ['utranCellId']
    
    #-----< AreaIdentification >-----#
    AreaIdentification = OCT_STR(name='AreaIdentification', mode=MODE_TYPE)
    AreaIdentification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=7)], ev=None, er=[])
    
    #-----< OccurrenceInfo >-----#
    OccurrenceInfo = ENUM(name='OccurrenceInfo', mode=MODE_TYPE)
    OccurrenceInfo._cont = ASN1Dict([('oneTimeEvent', 0), ('multipleTimeEvent', 1)])
    OccurrenceInfo._ext = []
    
    #-----< IntervalTime >-----#
    IntervalTime = INT(name='IntervalTime', mode=MODE_TYPE)
    IntervalTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32767)], ev=None, er=[])
    
    #-----< PeriodicLDRInfo >-----#
    PeriodicLDRInfo = SEQ(name='PeriodicLDRInfo', mode=MODE_TYPE)
    _PeriodicLDRInfo_reportingAmount = INT(name='reportingAmount', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingAmount')))
    _PeriodicLDRInfo_reportingInterval = INT(name='reportingInterval', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingInterval')))
    PeriodicLDRInfo._cont = ASN1Dict([
        ('reportingAmount', _PeriodicLDRInfo_reportingAmount),
        ('reportingInterval', _PeriodicLDRInfo_reportingInterval),
        ])
    PeriodicLDRInfo._ext = []
    
    #-----< ReportingAmount >-----#
    ReportingAmount = INT(name='ReportingAmount', mode=MODE_TYPE)
    ReportingAmount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    
    #-----< maxReportingAmount >-----#
    maxReportingAmount = INT(name='maxReportingAmount', mode=MODE_VALUE)
    maxReportingAmount._val = 8639999
    
    #-----< ReportingInterval >-----#
    ReportingInterval = INT(name='ReportingInterval', mode=MODE_TYPE)
    ReportingInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    
    #-----< maxReportingInterval >-----#
    maxReportingInterval = INT(name='maxReportingInterval', mode=MODE_VALUE)
    maxReportingInterval._val = 8639999
    
    #-----< ReportingPLMNList >-----#
    ReportingPLMNList = SEQ(name='ReportingPLMNList', mode=MODE_TYPE)
    _ReportingPLMNList_plmn_ListPrioritized = NULL(name='plmn-ListPrioritized', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportingPLMNList_plmn_List = SEQ_OF(name='plmn-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PLMNList')))
    ReportingPLMNList._cont = ASN1Dict([
        ('plmn-ListPrioritized', _ReportingPLMNList_plmn_ListPrioritized),
        ('plmn-List', _ReportingPLMNList_plmn_List),
        ])
    ReportingPLMNList._ext = []
    
    #-----< PLMNList >-----#
    PLMNList = SEQ_OF(name='PLMNList', mode=MODE_TYPE)
    _PLMNList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMN')))
    PLMNList._cont = _PLMNList__item_
    PLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfReportingPLMN >-----#
    maxNumOfReportingPLMN = INT(name='maxNumOfReportingPLMN', mode=MODE_VALUE)
    maxNumOfReportingPLMN._val = 20
    
    #-----< ReportingPLMN >-----#
    ReportingPLMN = SEQ(name='ReportingPLMN', mode=MODE_TYPE)
    _ReportingPLMN_plmn_Id = OCT_STR(name='plmn-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _ReportingPLMN_ran_Technology = ENUM(name='ran-Technology', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'RAN-Technology')), opt=True)
    _ReportingPLMN_ran_PeriodicLocationSupport = NULL(name='ran-PeriodicLocationSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ReportingPLMN._cont = ASN1Dict([
        ('plmn-Id', _ReportingPLMN_plmn_Id),
        ('ran-Technology', _ReportingPLMN_ran_Technology),
        ('ran-PeriodicLocationSupport', _ReportingPLMN_ran_PeriodicLocationSupport),
        ])
    ReportingPLMN._ext = []
    
    #-----< RAN-Technology >-----#
    RAN_Technology = ENUM(name='RAN-Technology', mode=MODE_TYPE)
    RAN_Technology._cont = ASN1Dict([('gsm', 0), ('umts', 1)])
    RAN_Technology._ext = []
    
    #-----< ProvideSubscriberLocation-Res >-----#
    ProvideSubscriberLocation_Res = SEQ(name='ProvideSubscriberLocation-Res', mode=MODE_TYPE)
    _ProvideSubscriberLocation_Res_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')))
    _ProvideSubscriberLocation_Res_ageOfLocationEstimate = INT(name='ageOfLocationEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _ProvideSubscriberLocation_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberLocation_Res_add_LocationEstimate = OCT_STR(name='add-LocationEstimate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _ProvideSubscriberLocation_Res_deferredmt_lrResponseIndicator = NULL(name='deferredmt-lrResponseIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Res_geranPositioningData = OCT_STR(name='geranPositioningData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PositioningDataInformation')), opt=True)
    _ProvideSubscriberLocation_Res_utranPositioningData = OCT_STR(name='utranPositioningData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranPositioningDataInfo')), opt=True)
    _ProvideSubscriberLocation_Res_cellIdOrSai = CHOICE(name='cellIdOrSai', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _ProvideSubscriberLocation_Res_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Res_accuracyFulfilmentIndicator = ENUM(name='accuracyFulfilmentIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AccuracyFulfilmentIndicator')), opt=True)
    _ProvideSubscriberLocation_Res_velocityEstimate = OCT_STR(name='velocityEstimate', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _ProvideSubscriberLocation_Res_mo_lrShortCircuitIndicator = NULL(name='mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Res_geranGANSSpositioningData = OCT_STR(name='geranGANSSpositioningData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'GeranGANSSpositioningData')), opt=True)
    _ProvideSubscriberLocation_Res_utranGANSSpositioningData = OCT_STR(name='utranGANSSpositioningData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranGANSSpositioningData')), opt=True)
    _ProvideSubscriberLocation_Res_targetServingNodeForHandover = CHOICE(name='targetServingNodeForHandover', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ServingNodeAddress')), opt=True)
    _ProvideSubscriberLocation_Res_utranAdditionalPositioningData = OCT_STR(name='utranAdditionalPositioningData', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranAdditionalPositioningData')), opt=True)
    _ProvideSubscriberLocation_Res_utranBaroPressureMeas = INT(name='utranBaroPressureMeas', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranBaroPressureMeas')), opt=True)
    _ProvideSubscriberLocation_Res_utranCivicAddress = OCT_STR(name='utranCivicAddress', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranCivicAddress')), opt=True)
    ProvideSubscriberLocation_Res._cont = ASN1Dict([
        ('locationEstimate', _ProvideSubscriberLocation_Res_locationEstimate),
        ('ageOfLocationEstimate', _ProvideSubscriberLocation_Res_ageOfLocationEstimate),
        ('extensionContainer', _ProvideSubscriberLocation_Res_extensionContainer),
        ('add-LocationEstimate', _ProvideSubscriberLocation_Res_add_LocationEstimate),
        ('deferredmt-lrResponseIndicator', _ProvideSubscriberLocation_Res_deferredmt_lrResponseIndicator),
        ('geranPositioningData', _ProvideSubscriberLocation_Res_geranPositioningData),
        ('utranPositioningData', _ProvideSubscriberLocation_Res_utranPositioningData),
        ('cellIdOrSai', _ProvideSubscriberLocation_Res_cellIdOrSai),
        ('sai-Present', _ProvideSubscriberLocation_Res_sai_Present),
        ('accuracyFulfilmentIndicator', _ProvideSubscriberLocation_Res_accuracyFulfilmentIndicator),
        ('velocityEstimate', _ProvideSubscriberLocation_Res_velocityEstimate),
        ('mo-lrShortCircuitIndicator', _ProvideSubscriberLocation_Res_mo_lrShortCircuitIndicator),
        ('geranGANSSpositioningData', _ProvideSubscriberLocation_Res_geranGANSSpositioningData),
        ('utranGANSSpositioningData', _ProvideSubscriberLocation_Res_utranGANSSpositioningData),
        ('targetServingNodeForHandover', _ProvideSubscriberLocation_Res_targetServingNodeForHandover),
        ('utranAdditionalPositioningData', _ProvideSubscriberLocation_Res_utranAdditionalPositioningData),
        ('utranBaroPressureMeas', _ProvideSubscriberLocation_Res_utranBaroPressureMeas),
        ('utranCivicAddress', _ProvideSubscriberLocation_Res_utranCivicAddress),
        ])
    ProvideSubscriberLocation_Res._ext = ['add-LocationEstimate', 'deferredmt-lrResponseIndicator', 'geranPositioningData', 'utranPositioningData', 'cellIdOrSai', 'sai-Present', 'accuracyFulfilmentIndicator', 'velocityEstimate', 'mo-lrShortCircuitIndicator', 'geranGANSSpositioningData', 'utranGANSSpositioningData', 'targetServingNodeForHandover', 'utranAdditionalPositioningData', 'utranBaroPressureMeas', 'utranCivicAddress']
    
    #-----< AccuracyFulfilmentIndicator >-----#
    AccuracyFulfilmentIndicator = ENUM(name='AccuracyFulfilmentIndicator', mode=MODE_TYPE)
    AccuracyFulfilmentIndicator._cont = ASN1Dict([('requestedAccuracyFulfilled', 0), ('requestedAccuracyNotFulfilled', 1)])
    AccuracyFulfilmentIndicator._ext = []
    
    #-----< Ext-GeographicalInformation >-----#
    Ext_GeographicalInformation = OCT_STR(name='Ext-GeographicalInformation', mode=MODE_TYPE)
    Ext_GeographicalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxExt-GeographicalInformation >-----#
    maxExt_GeographicalInformation = INT(name='maxExt-GeographicalInformation', mode=MODE_VALUE)
    maxExt_GeographicalInformation._val = 20
    
    #-----< VelocityEstimate >-----#
    VelocityEstimate = OCT_STR(name='VelocityEstimate', mode=MODE_TYPE)
    VelocityEstimate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=7)], ev=None, er=[])
    
    #-----< PositioningDataInformation >-----#
    PositioningDataInformation = OCT_STR(name='PositioningDataInformation', mode=MODE_TYPE)
    PositioningDataInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< maxPositioningDataInformation >-----#
    maxPositioningDataInformation = INT(name='maxPositioningDataInformation', mode=MODE_VALUE)
    maxPositioningDataInformation._val = 10
    
    #-----< UtranPositioningDataInfo >-----#
    UtranPositioningDataInfo = OCT_STR(name='UtranPositioningDataInfo', mode=MODE_TYPE)
    UtranPositioningDataInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    
    #-----< maxUtranPositioningDataInfo >-----#
    maxUtranPositioningDataInfo = INT(name='maxUtranPositioningDataInfo', mode=MODE_VALUE)
    maxUtranPositioningDataInfo._val = 11
    
    #-----< GeranGANSSpositioningData >-----#
    GeranGANSSpositioningData = OCT_STR(name='GeranGANSSpositioningData', mode=MODE_TYPE)
    GeranGANSSpositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< maxGeranGANSSpositioningData >-----#
    maxGeranGANSSpositioningData = INT(name='maxGeranGANSSpositioningData', mode=MODE_VALUE)
    maxGeranGANSSpositioningData._val = 10
    
    #-----< UtranGANSSpositioningData >-----#
    UtranGANSSpositioningData = OCT_STR(name='UtranGANSSpositioningData', mode=MODE_TYPE)
    UtranGANSSpositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxUtranGANSSpositioningData >-----#
    maxUtranGANSSpositioningData = INT(name='maxUtranGANSSpositioningData', mode=MODE_VALUE)
    maxUtranGANSSpositioningData._val = 9
    
    #-----< UtranAdditionalPositioningData >-----#
    UtranAdditionalPositioningData = OCT_STR(name='UtranAdditionalPositioningData', mode=MODE_TYPE)
    UtranAdditionalPositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< maxUtranAdditionalPositioningData >-----#
    maxUtranAdditionalPositioningData = INT(name='maxUtranAdditionalPositioningData', mode=MODE_VALUE)
    maxUtranAdditionalPositioningData._val = 8
    
    #-----< UtranBaroPressureMeas >-----#
    UtranBaroPressureMeas = INT(name='UtranBaroPressureMeas', mode=MODE_TYPE)
    UtranBaroPressureMeas._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30000, ub=115000)], ev=None, er=[])
    
    #-----< UtranCivicAddress >-----#
    UtranCivicAddress = OCT_STR(name='UtranCivicAddress', mode=MODE_TYPE)
    
    #-----< Add-GeographicalInformation >-----#
    Add_GeographicalInformation = OCT_STR(name='Add-GeographicalInformation', mode=MODE_TYPE)
    Add_GeographicalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=91)], ev=None, er=[])
    
    #-----< maxAdd-GeographicalInformation >-----#
    maxAdd_GeographicalInformation = INT(name='maxAdd-GeographicalInformation', mode=MODE_VALUE)
    maxAdd_GeographicalInformation._val = 91
    
    #-----< SubscriberLocationReport-Arg >-----#
    SubscriberLocationReport_Arg = SEQ(name='SubscriberLocationReport-Arg', mode=MODE_TYPE)
    _SubscriberLocationReport_Arg_lcs_Event = ENUM(name='lcs-Event', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Event')))
    _SubscriberLocationReport_Arg_lcs_ClientID = SEQ(name='lcs-ClientID', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ClientID')))
    _SubscriberLocationReport_Arg_lcsLocationInfo = SEQ(name='lcsLocationInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSLocationInfo')))
    _SubscriberLocationReport_Arg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SubscriberLocationReport_Arg_imei = OCT_STR(name='imei', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SubscriberLocationReport_Arg_na_ESRD = OCT_STR(name='na-ESRD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Arg_na_ESRK = OCT_STR(name='na-ESRK', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Arg_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SubscriberLocationReport_Arg_ageOfLocationEstimate = INT(name='ageOfLocationEstimate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _SubscriberLocationReport_Arg_slr_ArgExtensionContainer = SEQ(name='slr-ArgExtensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'SLR-ArgExtensionContainer')), opt=True)
    _SubscriberLocationReport_Arg_add_LocationEstimate = OCT_STR(name='add-LocationEstimate', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _SubscriberLocationReport_Arg_deferredmt_lrData = SEQ(name='deferredmt-lrData', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Deferredmt-lrData')), opt=True)
    _SubscriberLocationReport_Arg_lcs_ReferenceNumber = OCT_STR(name='lcs-ReferenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _SubscriberLocationReport_Arg_geranPositioningData = OCT_STR(name='geranPositioningData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PositioningDataInformation')), opt=True)
    _SubscriberLocationReport_Arg_utranPositioningData = OCT_STR(name='utranPositioningData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranPositioningDataInfo')), opt=True)
    _SubscriberLocationReport_Arg_cellIdOrSai = CHOICE(name='cellIdOrSai', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _SubscriberLocationReport_Arg_h_gmlc_Address = OCT_STR(name='h-gmlc-Address', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SubscriberLocationReport_Arg_lcsServiceTypeID = INT(name='lcsServiceTypeID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    _SubscriberLocationReport_Arg_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Arg_pseudonymIndicator = NULL(name='pseudonymIndicator', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Arg_accuracyFulfilmentIndicator = ENUM(name='accuracyFulfilmentIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AccuracyFulfilmentIndicator')), opt=True)
    _SubscriberLocationReport_Arg_velocityEstimate = OCT_STR(name='velocityEstimate', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _SubscriberLocationReport_Arg_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SequenceNumber')), opt=True)
    _SubscriberLocationReport_Arg_periodicLDRInfo = SEQ(name='periodicLDRInfo', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')), opt=True)
    _SubscriberLocationReport_Arg_mo_lrShortCircuitIndicator = NULL(name='mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Arg_geranGANSSpositioningData = OCT_STR(name='geranGANSSpositioningData', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'GeranGANSSpositioningData')), opt=True)
    _SubscriberLocationReport_Arg_utranGANSSpositioningData = OCT_STR(name='utranGANSSpositioningData', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranGANSSpositioningData')), opt=True)
    _SubscriberLocationReport_Arg_targetServingNodeForHandover = CHOICE(name='targetServingNodeForHandover', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ServingNodeAddress')), opt=True)
    _SubscriberLocationReport_Arg_utranAdditionalPositioningData = OCT_STR(name='utranAdditionalPositioningData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranAdditionalPositioningData')), opt=True)
    _SubscriberLocationReport_Arg_utranBaroPressureMeas = INT(name='utranBaroPressureMeas', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranBaroPressureMeas')), opt=True)
    _SubscriberLocationReport_Arg_utranCivicAddress = OCT_STR(name='utranCivicAddress', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranCivicAddress')), opt=True)
    SubscriberLocationReport_Arg._cont = ASN1Dict([
        ('lcs-Event', _SubscriberLocationReport_Arg_lcs_Event),
        ('lcs-ClientID', _SubscriberLocationReport_Arg_lcs_ClientID),
        ('lcsLocationInfo', _SubscriberLocationReport_Arg_lcsLocationInfo),
        ('msisdn', _SubscriberLocationReport_Arg_msisdn),
        ('imsi', _SubscriberLocationReport_Arg_imsi),
        ('imei', _SubscriberLocationReport_Arg_imei),
        ('na-ESRD', _SubscriberLocationReport_Arg_na_ESRD),
        ('na-ESRK', _SubscriberLocationReport_Arg_na_ESRK),
        ('locationEstimate', _SubscriberLocationReport_Arg_locationEstimate),
        ('ageOfLocationEstimate', _SubscriberLocationReport_Arg_ageOfLocationEstimate),
        ('slr-ArgExtensionContainer', _SubscriberLocationReport_Arg_slr_ArgExtensionContainer),
        ('add-LocationEstimate', _SubscriberLocationReport_Arg_add_LocationEstimate),
        ('deferredmt-lrData', _SubscriberLocationReport_Arg_deferredmt_lrData),
        ('lcs-ReferenceNumber', _SubscriberLocationReport_Arg_lcs_ReferenceNumber),
        ('geranPositioningData', _SubscriberLocationReport_Arg_geranPositioningData),
        ('utranPositioningData', _SubscriberLocationReport_Arg_utranPositioningData),
        ('cellIdOrSai', _SubscriberLocationReport_Arg_cellIdOrSai),
        ('h-gmlc-Address', _SubscriberLocationReport_Arg_h_gmlc_Address),
        ('lcsServiceTypeID', _SubscriberLocationReport_Arg_lcsServiceTypeID),
        ('sai-Present', _SubscriberLocationReport_Arg_sai_Present),
        ('pseudonymIndicator', _SubscriberLocationReport_Arg_pseudonymIndicator),
        ('accuracyFulfilmentIndicator', _SubscriberLocationReport_Arg_accuracyFulfilmentIndicator),
        ('velocityEstimate', _SubscriberLocationReport_Arg_velocityEstimate),
        ('sequenceNumber', _SubscriberLocationReport_Arg_sequenceNumber),
        ('periodicLDRInfo', _SubscriberLocationReport_Arg_periodicLDRInfo),
        ('mo-lrShortCircuitIndicator', _SubscriberLocationReport_Arg_mo_lrShortCircuitIndicator),
        ('geranGANSSpositioningData', _SubscriberLocationReport_Arg_geranGANSSpositioningData),
        ('utranGANSSpositioningData', _SubscriberLocationReport_Arg_utranGANSSpositioningData),
        ('targetServingNodeForHandover', _SubscriberLocationReport_Arg_targetServingNodeForHandover),
        ('utranAdditionalPositioningData', _SubscriberLocationReport_Arg_utranAdditionalPositioningData),
        ('utranBaroPressureMeas', _SubscriberLocationReport_Arg_utranBaroPressureMeas),
        ('utranCivicAddress', _SubscriberLocationReport_Arg_utranCivicAddress),
        ])
    SubscriberLocationReport_Arg._ext = ['add-LocationEstimate', 'deferredmt-lrData', 'lcs-ReferenceNumber', 'geranPositioningData', 'utranPositioningData', 'cellIdOrSai', 'h-gmlc-Address', 'lcsServiceTypeID', 'sai-Present', 'pseudonymIndicator', 'accuracyFulfilmentIndicator', 'velocityEstimate', 'sequenceNumber', 'periodicLDRInfo', 'mo-lrShortCircuitIndicator', 'geranGANSSpositioningData', 'utranGANSSpositioningData', 'targetServingNodeForHandover', 'utranAdditionalPositioningData', 'utranBaroPressureMeas', 'utranCivicAddress']
    
    #-----< Deferredmt-lrData >-----#
    Deferredmt_lrData = SEQ(name='Deferredmt-lrData', mode=MODE_TYPE)
    _Deferredmt_lrData_deferredLocationEventType = BIT_STR(name='deferredLocationEventType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'DeferredLocationEventType')))
    _Deferredmt_lrData_terminationCause = ENUM(name='terminationCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'TerminationCause')), opt=True)
    _Deferredmt_lrData_lcsLocationInfo = SEQ(name='lcsLocationInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSLocationInfo')), opt=True)
    Deferredmt_lrData._cont = ASN1Dict([
        ('deferredLocationEventType', _Deferredmt_lrData_deferredLocationEventType),
        ('terminationCause', _Deferredmt_lrData_terminationCause),
        ('lcsLocationInfo', _Deferredmt_lrData_lcsLocationInfo),
        ])
    Deferredmt_lrData._ext = []
    
    #-----< LCS-Event >-----#
    LCS_Event = ENUM(name='LCS-Event', mode=MODE_TYPE)
    LCS_Event._cont = ASN1Dict([('emergencyCallOrigination', 0), ('emergencyCallRelease', 1), ('mo-lr', 2), ('deferredmt-lrResponse', 3), ('deferredmo-lrTTTPInitiation', 4), ('emergencyCallHandover', 5)])
    LCS_Event._ext = ['deferredmt-lrResponse', 'deferredmo-lrTTTPInitiation', 'emergencyCallHandover']
    
    #-----< TerminationCause >-----#
    TerminationCause = ENUM(name='TerminationCause', mode=MODE_TYPE)
    TerminationCause._cont = ASN1Dict([('normal', 0), ('errorundefined', 1), ('internalTimeout', 2), ('congestion', 3), ('mt-lrRestart', 4), ('privacyViolation', 5), ('shapeOfLocationEstimateNotSupported', 6), ('subscriberTermination', 7), ('uETermination', 8), ('networkTermination', 9)])
    TerminationCause._ext = ['shapeOfLocationEstimateNotSupported', 'subscriberTermination', 'uETermination', 'networkTermination']
    
    #-----< SequenceNumber >-----#
    SequenceNumber = INT(name='SequenceNumber', mode=MODE_TYPE)
    SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    
    #-----< ServingNodeAddress >-----#
    ServingNodeAddress = CHOICE(name='ServingNodeAddress', mode=MODE_TYPE)
    _ServingNodeAddress_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ServingNodeAddress_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ServingNodeAddress_mme_Number = OCT_STR(name='mme-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    ServingNodeAddress._cont = ASN1Dict([
        ('msc-Number', _ServingNodeAddress_msc_Number),
        ('sgsn-Number', _ServingNodeAddress_sgsn_Number),
        ('mme-Number', _ServingNodeAddress_mme_Number),
        ])
    ServingNodeAddress._ext = None
    
    #-----< SubscriberLocationReport-Res >-----#
    SubscriberLocationReport_Res = SEQ(name='SubscriberLocationReport-Res', mode=MODE_TYPE)
    _SubscriberLocationReport_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubscriberLocationReport_Res_na_ESRK = OCT_STR(name='na-ESRK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Res_na_ESRD = OCT_STR(name='na-ESRD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Res_h_gmlc_Address = OCT_STR(name='h-gmlc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SubscriberLocationReport_Res_mo_lrShortCircuitIndicator = NULL(name='mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Res_reportingPLMNList = SEQ(name='reportingPLMNList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    _SubscriberLocationReport_Res_lcs_ReferenceNumber = OCT_STR(name='lcs-ReferenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    SubscriberLocationReport_Res._cont = ASN1Dict([
        ('extensionContainer', _SubscriberLocationReport_Res_extensionContainer),
        ('na-ESRK', _SubscriberLocationReport_Res_na_ESRK),
        ('na-ESRD', _SubscriberLocationReport_Res_na_ESRD),
        ('h-gmlc-Address', _SubscriberLocationReport_Res_h_gmlc_Address),
        ('mo-lrShortCircuitIndicator', _SubscriberLocationReport_Res_mo_lrShortCircuitIndicator),
        ('reportingPLMNList', _SubscriberLocationReport_Res_reportingPLMNList),
        ('lcs-ReferenceNumber', _SubscriberLocationReport_Res_lcs_ReferenceNumber),
        ])
    SubscriberLocationReport_Res._ext = ['na-ESRK', 'na-ESRD', 'h-gmlc-Address', 'mo-lrShortCircuitIndicator', 'reportingPLMNList', 'lcs-ReferenceNumber']
    
    _all_ = [
        _RoutingInfoForLCS_Arg_mlcNumber,
        _RoutingInfoForLCS_Arg_targetMS,
        _RoutingInfoForLCS_Arg_extensionContainer,
        RoutingInfoForLCS_Arg,
        _RoutingInfoForLCS_Res_targetMS,
        _RoutingInfoForLCS_Res_lcsLocationInfo,
        _RoutingInfoForLCS_Res_extensionContainer,
        _RoutingInfoForLCS_Res_v_gmlc_Address,
        _RoutingInfoForLCS_Res_h_gmlc_Address,
        _RoutingInfoForLCS_Res_ppr_Address,
        _RoutingInfoForLCS_Res_additional_v_gmlc_Address,
        RoutingInfoForLCS_Res,
        _LCSLocationInfo_networkNode_Number,
        _LCSLocationInfo_lmsi,
        _LCSLocationInfo_extensionContainer,
        _LCSLocationInfo_gprsNodeIndicator,
        _LCSLocationInfo_additional_Number,
        _LCSLocationInfo_supportedLCS_CapabilitySets,
        _LCSLocationInfo_additional_LCS_CapabilitySets,
        _LCSLocationInfo_mme_Name,
        _LCSLocationInfo_aaa_Server_Name,
        _LCSLocationInfo_sgsn_Name,
        _LCSLocationInfo_sgsn_Realm,
        LCSLocationInfo,
        _ProvideSubscriberLocation_Arg_locationType,
        _ProvideSubscriberLocation_Arg_mlc_Number,
        _ProvideSubscriberLocation_Arg_lcs_ClientID,
        _ProvideSubscriberLocation_Arg_privacyOverride,
        _ProvideSubscriberLocation_Arg_imsi,
        _ProvideSubscriberLocation_Arg_msisdn,
        _ProvideSubscriberLocation_Arg_lmsi,
        _ProvideSubscriberLocation_Arg_imei,
        _ProvideSubscriberLocation_Arg_lcs_Priority,
        _ProvideSubscriberLocation_Arg_lcs_QoS,
        _ProvideSubscriberLocation_Arg_extensionContainer,
        _ProvideSubscriberLocation_Arg_supportedGADShapes,
        _ProvideSubscriberLocation_Arg_lcs_ReferenceNumber,
        _ProvideSubscriberLocation_Arg_lcsServiceTypeID,
        _ProvideSubscriberLocation_Arg_lcsCodeword,
        _ProvideSubscriberLocation_Arg_lcs_PrivacyCheck,
        _ProvideSubscriberLocation_Arg_areaEventInfo,
        _ProvideSubscriberLocation_Arg_h_gmlc_Address,
        _ProvideSubscriberLocation_Arg_mo_lrShortCircuitIndicator,
        _ProvideSubscriberLocation_Arg_periodicLDRInfo,
        _ProvideSubscriberLocation_Arg_reportingPLMNList,
        ProvideSubscriberLocation_Arg,
        _LocationType_locationEstimateType,
        _LocationType_deferredLocationEventType,
        LocationType,
        LocationEstimateType,
        DeferredLocationEventType,
        _LCS_ClientID_lcsClientType,
        _LCS_ClientID_lcsClientExternalID,
        _LCS_ClientID_lcsClientDialedByMS,
        _LCS_ClientID_lcsClientInternalID,
        _LCS_ClientID_lcsClientName,
        _LCS_ClientID_lcsAPN,
        _LCS_ClientID_lcsRequestorID,
        LCS_ClientID,
        LCSClientType,
        _LCSClientName_dataCodingScheme,
        _LCSClientName_nameString,
        _LCSClientName_lcs_FormatIndicator,
        LCSClientName,
        NameString,
        maxNameStringLength,
        _LCSRequestorID_dataCodingScheme,
        _LCSRequestorID_requestorIDString,
        _LCSRequestorID_lcs_FormatIndicator,
        LCSRequestorID,
        RequestorIDString,
        maxRequestorIDStringLength,
        LCS_FormatIndicator,
        LCS_Priority,
        _LCS_QoS_horizontal_accuracy,
        _LCS_QoS_verticalCoordinateRequest,
        _LCS_QoS_vertical_accuracy,
        _LCS_QoS_responseTime,
        _LCS_QoS_extensionContainer,
        _LCS_QoS_velocityRequest,
        LCS_QoS,
        Horizontal_Accuracy,
        Vertical_Accuracy,
        _ResponseTime_responseTimeCategory,
        ResponseTime,
        ResponseTimeCategory,
        SupportedGADShapes,
        LCS_ReferenceNumber,
        _LCSCodeword_dataCodingScheme,
        _LCSCodeword_lcsCodewordString,
        LCSCodeword,
        LCSCodewordString,
        maxLCSCodewordStringLength,
        _LCS_PrivacyCheck_callSessionUnrelated,
        _LCS_PrivacyCheck_callSessionRelated,
        LCS_PrivacyCheck,
        PrivacyCheckRelatedAction,
        _AreaEventInfo_areaDefinition,
        _AreaEventInfo_occurrenceInfo,
        _AreaEventInfo_intervalTime,
        AreaEventInfo,
        _AreaDefinition_areaList,
        AreaDefinition,
        _AreaList__item_,
        AreaList,
        maxNumOfAreas,
        _Area_areaType,
        _Area_areaIdentification,
        Area,
        AreaType,
        AreaIdentification,
        OccurrenceInfo,
        IntervalTime,
        _PeriodicLDRInfo_reportingAmount,
        _PeriodicLDRInfo_reportingInterval,
        PeriodicLDRInfo,
        ReportingAmount,
        maxReportingAmount,
        ReportingInterval,
        maxReportingInterval,
        _ReportingPLMNList_plmn_ListPrioritized,
        _ReportingPLMNList_plmn_List,
        ReportingPLMNList,
        _PLMNList__item_,
        PLMNList,
        maxNumOfReportingPLMN,
        _ReportingPLMN_plmn_Id,
        _ReportingPLMN_ran_Technology,
        _ReportingPLMN_ran_PeriodicLocationSupport,
        ReportingPLMN,
        RAN_Technology,
        _ProvideSubscriberLocation_Res_locationEstimate,
        _ProvideSubscriberLocation_Res_ageOfLocationEstimate,
        _ProvideSubscriberLocation_Res_extensionContainer,
        _ProvideSubscriberLocation_Res_add_LocationEstimate,
        _ProvideSubscriberLocation_Res_deferredmt_lrResponseIndicator,
        _ProvideSubscriberLocation_Res_geranPositioningData,
        _ProvideSubscriberLocation_Res_utranPositioningData,
        _ProvideSubscriberLocation_Res_cellIdOrSai,
        _ProvideSubscriberLocation_Res_sai_Present,
        _ProvideSubscriberLocation_Res_accuracyFulfilmentIndicator,
        _ProvideSubscriberLocation_Res_velocityEstimate,
        _ProvideSubscriberLocation_Res_mo_lrShortCircuitIndicator,
        _ProvideSubscriberLocation_Res_geranGANSSpositioningData,
        _ProvideSubscriberLocation_Res_utranGANSSpositioningData,
        _ProvideSubscriberLocation_Res_targetServingNodeForHandover,
        _ProvideSubscriberLocation_Res_utranAdditionalPositioningData,
        _ProvideSubscriberLocation_Res_utranBaroPressureMeas,
        _ProvideSubscriberLocation_Res_utranCivicAddress,
        ProvideSubscriberLocation_Res,
        AccuracyFulfilmentIndicator,
        Ext_GeographicalInformation,
        maxExt_GeographicalInformation,
        VelocityEstimate,
        PositioningDataInformation,
        maxPositioningDataInformation,
        UtranPositioningDataInfo,
        maxUtranPositioningDataInfo,
        GeranGANSSpositioningData,
        maxGeranGANSSpositioningData,
        UtranGANSSpositioningData,
        maxUtranGANSSpositioningData,
        UtranAdditionalPositioningData,
        maxUtranAdditionalPositioningData,
        UtranBaroPressureMeas,
        UtranCivicAddress,
        Add_GeographicalInformation,
        maxAdd_GeographicalInformation,
        _SubscriberLocationReport_Arg_lcs_Event,
        _SubscriberLocationReport_Arg_lcs_ClientID,
        _SubscriberLocationReport_Arg_lcsLocationInfo,
        _SubscriberLocationReport_Arg_msisdn,
        _SubscriberLocationReport_Arg_imsi,
        _SubscriberLocationReport_Arg_imei,
        _SubscriberLocationReport_Arg_na_ESRD,
        _SubscriberLocationReport_Arg_na_ESRK,
        _SubscriberLocationReport_Arg_locationEstimate,
        _SubscriberLocationReport_Arg_ageOfLocationEstimate,
        _SubscriberLocationReport_Arg_slr_ArgExtensionContainer,
        _SubscriberLocationReport_Arg_add_LocationEstimate,
        _SubscriberLocationReport_Arg_deferredmt_lrData,
        _SubscriberLocationReport_Arg_lcs_ReferenceNumber,
        _SubscriberLocationReport_Arg_geranPositioningData,
        _SubscriberLocationReport_Arg_utranPositioningData,
        _SubscriberLocationReport_Arg_cellIdOrSai,
        _SubscriberLocationReport_Arg_h_gmlc_Address,
        _SubscriberLocationReport_Arg_lcsServiceTypeID,
        _SubscriberLocationReport_Arg_sai_Present,
        _SubscriberLocationReport_Arg_pseudonymIndicator,
        _SubscriberLocationReport_Arg_accuracyFulfilmentIndicator,
        _SubscriberLocationReport_Arg_velocityEstimate,
        _SubscriberLocationReport_Arg_sequenceNumber,
        _SubscriberLocationReport_Arg_periodicLDRInfo,
        _SubscriberLocationReport_Arg_mo_lrShortCircuitIndicator,
        _SubscriberLocationReport_Arg_geranGANSSpositioningData,
        _SubscriberLocationReport_Arg_utranGANSSpositioningData,
        _SubscriberLocationReport_Arg_targetServingNodeForHandover,
        _SubscriberLocationReport_Arg_utranAdditionalPositioningData,
        _SubscriberLocationReport_Arg_utranBaroPressureMeas,
        _SubscriberLocationReport_Arg_utranCivicAddress,
        SubscriberLocationReport_Arg,
        _Deferredmt_lrData_deferredLocationEventType,
        _Deferredmt_lrData_terminationCause,
        _Deferredmt_lrData_lcsLocationInfo,
        Deferredmt_lrData,
        LCS_Event,
        TerminationCause,
        SequenceNumber,
        _ServingNodeAddress_msc_Number,
        _ServingNodeAddress_sgsn_Number,
        _ServingNodeAddress_mme_Number,
        ServingNodeAddress,
        _SubscriberLocationReport_Res_extensionContainer,
        _SubscriberLocationReport_Res_na_ESRK,
        _SubscriberLocationReport_Res_na_ESRD,
        _SubscriberLocationReport_Res_h_gmlc_Address,
        _SubscriberLocationReport_Res_mo_lrShortCircuitIndicator,
        _SubscriberLocationReport_Res_reportingPLMNList,
        _SubscriberLocationReport_Res_lcs_ReferenceNumber,
        SubscriberLocationReport_Res,
    ]

class MAP_MS_DataTypes:

    _name_  = 'MAP-MS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 11, 19]
    
    _obj_ = [
        'UpdateLocationArg',
        'VLR-Capability',
        'SupportedRAT-Types',
        'SuperChargerInfo',
        'AgeIndicator',
        'IST-SupportIndicator',
        'SupportedLCS-CapabilitySets',
        'UpdateLocationRes',
        'ADD-Info',
        'PagingArea',
        'LocationArea',
        'LAC',
        'CancelLocationArg',
        'TypeOfUpdate',
        'CancellationType',
        'CancelLocationRes',
        'PurgeMS-Arg',
        'PurgeMS-Res',
        'SendIdentificationArg',
        'HopCounter',
        'SendIdentificationRes',
        'AuthenticationSetList',
        'TripletList',
        'QuintupletList',
        'AuthenticationTriplet',
        'AuthenticationQuintuplet',
        'CurrentSecurityContext',
        'GSM-SecurityContextData',
        'UMTS-SecurityContextData',
        'RAND',
        'SRES',
        'Kc',
        'XRES',
        'CK',
        'IK',
        'AUTN',
        'AUTS',
        'Cksn',
        'KSI',
        'AuthenticationFailureReportArg',
        'AccessType',
        'AuthenticationFailureReportRes',
        'FailureCause',
        'UpdateGprsLocationArg',
        'SMSRegisterRequest',
        'Used-RAT-Type',
        'EPS-Info',
        'PDN-GW-Update',
        'ISR-Information',
        'SGSN-Capability',
        'SupportedFeatures',
        'Ext-SupportedFeatures',
        'UE-SRVCC-Capability',
        'UpdateGprsLocationRes',
        'EPLMN-List',
        'AdjacentPLMN-List',
        'ForwardAccessSignalling-Arg',
        'AllowedGSM-Algorithms',
        'AllowedUMTS-Algorithms',
        'PermittedIntegrityProtectionAlgorithms',
        'maxPermittedIntegrityProtectionAlgorithmsLength',
        'PermittedEncryptionAlgorithms',
        'maxPermittedEncryptionAlgorithmsLength',
        'KeyStatus',
        'PrepareHO-Arg',
        'LCLS-GlobalCallReference',
        'LCLS-Negotiation',
        'LCLS-ConfigurationPreference',
        'BSSMAP-ServiceHandoverList',
        'BSSMAP-ServiceHandoverInfo',
        'maxNumOfServiceHandovers',
        'BSSMAP-ServiceHandover',
        'RANAP-ServiceHandover',
        'RadioResourceList',
        'RadioResource',
        'maxNumOfRadioResources',
        'PrepareHO-Res',
        'SelectedUMTS-Algorithms',
        'ChosenIntegrityProtectionAlgorithm',
        'ChosenEncryptionAlgorithm',
        'ChosenRadioResourceInformation',
        'ChosenChannelInfo',
        'ChosenSpeechVersion',
        'PrepareSubsequentHO-Arg',
        'PrepareSubsequentHO-Res',
        'ProcessAccessSignalling-Arg',
        'AoIPCodecsList',
        'AoIPCodec',
        'SupportedCodecsList',
        'CodecList',
        'Codec',
        'GERAN-Classmark',
        'SelectedGSM-Algorithm',
        'SendEndSignal-Arg',
        'SendEndSignal-Res',
        'RNCId',
        'RelocationNumberList',
        'MulticallBearerInfo',
        'RelocationNumber',
        'RAB-Id',
        'maxNrOfRABs',
        'maxNumOfRelocationNumber',
        'RadioResourceInformation',
        'IntegrityProtectionInformation',
        'maxNumOfIntegrityInfo',
        'EncryptionInformation',
        'maxNumOfEncryptionInfo',
        'SendAuthenticationInfoArg',
        'NumberOfRequestedVectors',
        'Re-synchronisationInfo',
        'SendAuthenticationInfoRes',
        'EPS-AuthenticationSetList',
        'UE-UsageType',
        'EPC-AV',
        'KASME',
        'RequestingNodeType',
        'CheckIMEI-Arg',
        'CheckIMEI-Res',
        'RequestedEquipmentInfo',
        'UESBI-Iu',
        'UESBI-IuA',
        'UESBI-IuB',
        'EquipmentStatus',
        'InsertSubscriberDataArg',
        'EDRX-Cycle-Length-List',
        'EDRX-Cycle-Length',
        'EDRX-Cycle-Length-Value',
        'Reset-Id-List',
        'Reset-Id',
        'DL-Buffering-Suggested-Packet-Count',
        'Group-Service-ID',
        'Local-GroupID',
        'IMSI-GroupIdList',
        'IMSI-GroupId',
        'SubscribedPeriodicRAUTAUtimer',
        'SubscribedPeriodicLAUtimer',
        'CSG-SubscriptionDataList',
        'CSG-SubscriptionData',
        'VPLMN-CSG-SubscriptionDataList',
        'CSG-Id',
        'LIPA-AllowedAPNList',
        'maxNumOfLIPAAllowedAPN',
        'EPS-SubscriptionData',
        'APN-OI-Replacement',
        'RFSP-ID',
        'APN-ConfigurationProfile',
        'EPS-DataList',
        'maxNumOfAPN-Configurations',
        'APN-Configuration',
        'PDN-ConnectionContinuity',
        'NIDD-Mechanism',
        'PDN-Type',
        'EPS-QoS-Subscribed',
        'AMBR',
        'SpecificAPNInfoList',
        'maxNumOfSpecificAPNInfos',
        'SpecificAPNInfo',
        'Bandwidth',
        'BandwidthExt',
        'QoS-Class-Identifier',
        'Allocation-Retention-Priority',
        'PDN-GW-Identity',
        'FQDN',
        'PDN-GW-AllocationType',
        'WLAN-Offloadability',
        'WLAN-Offloadability-Indication',
        'AccessRestrictionData',
        'Ext-AccessRestrictionData',
        'AdjacentAccessRestrictionDataList',
        'AdjacentAccessRestrictionData',
        'CS-AllocationRetentionPriority',
        'IST-AlertTimerValue',
        'LCSInformation',
        'GMLC-List',
        'maxNumOfGMLC',
        'NetworkAccessMode',
        'GPRSDataList',
        'maxNumOfPDP-Contexts',
        'PDP-Context',
        'Restoration-Priority',
        'SIPTO-Permission',
        'SIPTO-Local-Network-Permission',
        'LIPA-Permission',
        'ContextId',
        'GPRSSubscriptionData',
        'SGSN-CAMEL-SubscriptionInfo',
        'GPRS-CSI',
        'GPRS-CamelTDPDataList',
        'GPRS-CamelTDPData',
        'DefaultGPRS-Handling',
        'GPRS-TriggerDetectionPoint',
        'APN',
        'PDP-Type',
        'Ext-PDP-Type',
        'PDP-Address',
        'QoS-Subscribed',
        'Ext-QoS-Subscribed',
        'Ext2-QoS-Subscribed',
        'Ext3-QoS-Subscribed',
        'Ext4-QoS-Subscribed',
        'ChargingCharacteristics',
        'LSAOnlyAccessIndicator',
        'LSADataList',
        'maxNumOfLSAs',
        'LSAData',
        'LSAInformation',
        'LSAIdentity',
        'LSAAttributes',
        'SubscriberData',
        'Category',
        'SubscriberStatus',
        'BearerServiceList',
        'maxNumOfBearerServices',
        'TeleserviceList',
        'maxNumOfTeleservices',
        'ODB-Data',
        'ODB-GeneralData',
        'ODB-HPLMN-Data',
        'Ext-SS-InfoList',
        'Ext-SS-Info',
        'Ext-ForwInfo',
        'Ext-ForwFeatureList',
        'Ext-ForwFeature',
        'Ext-ForwOptions',
        'Ext-NoRepCondTime',
        'Ext-CallBarInfo',
        'Ext-CallBarFeatureList',
        'Ext-CallBarringFeature',
        'CUG-Info',
        'CUG-SubscriptionList',
        'CUG-Subscription',
        'CUG-Index',
        'CUG-Interlock',
        'IntraCUG-Options',
        'maxNumOfCUG',
        'CUG-FeatureList',
        'Ext-BasicServiceGroupList',
        'maxNumOfExt-BasicServiceGroups',
        'CUG-Feature',
        'InterCUG-Restrictions',
        'Ext-SS-Data',
        'LCS-PrivacyExceptionList',
        'maxNumOfPrivacyClass',
        'LCS-PrivacyClass',
        'ExternalClientList',
        'maxNumOfExternalClient',
        'PLMNClientList',
        'maxNumOfPLMNClient',
        'Ext-ExternalClientList',
        'maxNumOfExt-ExternalClient',
        'ExternalClient',
        'GMLC-Restriction',
        'NotificationToMSUser',
        'ServiceTypeList',
        'maxNumOfServiceType',
        'ServiceType',
        'MOLR-List',
        'maxNumOfMOLR-Class',
        'MOLR-Class',
        'ZoneCodeList',
        'ZoneCode',
        'maxNumOfZoneCodes',
        'InsertSubscriberDataRes',
        'RegionalSubscriptionResponse',
        'DeleteSubscriberDataArg',
        'SpecificCSI-Withdraw',
        'GPRSSubscriptionDataWithdraw',
        'EPS-SubscriptionDataWithdraw',
        'ContextIdList',
        'LSAInformationWithdraw',
        'LSAIdentityList',
        'BasicServiceList',
        'maxNumOfBasicServices',
        'DeleteSubscriberDataRes',
        'VlrCamelSubscriptionInfo',
        'MT-smsCAMELTDP-CriteriaList',
        'MT-smsCAMELTDP-Criteria',
        'TPDU-TypeCriterion',
        'maxNumOfTPDUTypes',
        'MT-SMS-TPDU-Type',
        'D-CSI',
        'DP-AnalysedInfoCriteriaList',
        'maxNumOfDP-AnalysedInfoCriteria',
        'DP-AnalysedInfoCriterium',
        'SS-CSI',
        'SS-CamelData',
        'SS-EventList',
        'maxNumOfCamelSSEvents',
        'O-CSI',
        'O-BcsmCamelTDPDataList',
        'maxNumOfCamelTDPData',
        'O-BcsmCamelTDPData',
        'ServiceKey',
        'O-BcsmTriggerDetectionPoint',
        'O-BcsmCamelTDPCriteriaList',
        'T-BCSM-CAMEL-TDP-CriteriaList',
        'O-BcsmCamelTDP-Criteria',
        'T-BCSM-CAMEL-TDP-Criteria',
        'DestinationNumberCriteria',
        'DestinationNumberList',
        'DestinationNumberLengthList',
        'BasicServiceCriteria',
        'maxNumOfISDN-AddressDigits',
        'maxNumOfCamelDestinationNumbers',
        'maxNumOfCamelDestinationNumberLengths',
        'maxNumOfCamelBasicServiceCriteria',
        'CallTypeCriteria',
        'MatchType',
        'O-CauseValueCriteria',
        'T-CauseValueCriteria',
        'maxNumOfCAMEL-O-CauseValueCriteria',
        'maxNumOfCAMEL-T-CauseValueCriteria',
        'CauseValue',
        'DefaultCallHandling',
        'CamelCapabilityHandling',
        'SupportedCamelPhases',
        'OfferedCamel4CSIs',
        'OfferedCamel4Functionalities',
        'SMS-CSI',
        'SMS-CAMEL-TDP-DataList',
        'SMS-CAMEL-TDP-Data',
        'SMS-TriggerDetectionPoint',
        'DefaultSMS-Handling',
        'M-CSI',
        'MG-CSI',
        'MobilityTriggers',
        'maxNumOfMobilityTriggers',
        'MM-Code',
        'T-CSI',
        'T-BcsmCamelTDPDataList',
        'T-BcsmCamelTDPData',
        'T-BcsmTriggerDetectionPoint',
        'SendRoutingInfoForGprsArg',
        'SendRoutingInfoForGprsRes',
        'FailureReportArg',
        'FailureReportRes',
        'NoteMsPresentForGprsArg',
        'NoteMsPresentForGprsRes',
        'ResetArg',
        'SendingNode-Number',
        'RestoreDataArg',
        'RestoreDataRes',
        'VBSDataList',
        'VGCSDataList',
        'maxNumOfVBSGroupIds',
        'maxNumOfVGCSGroupIds',
        'VoiceGroupCallData',
        'AdditionalInfo',
        'AdditionalSubscriptions',
        'VoiceBroadcastData',
        'GroupId',
        'Long-GroupId',
        'ProvideSubscriberInfoArg',
        'ProvideSubscriberInfoRes',
        'SubscriberInfo',
        'IMS-VoiceOverPS-SessionsInd',
        'TimeZone',
        'DaylightSavingTime',
        'MNPInfoRes',
        'RouteingNumber',
        'NumberPortabilityStatus',
        'MS-Classmark2',
        'GPRSMSClass',
        'MSNetworkCapability',
        'MSRadioAccessCapability',
        'RequestedInfo',
        'DomainType',
        'RequestedNodes',
        'LocationInformation',
        'LocationInformationEPS',
        'LocationInformationGPRS',
        'LocationInformation5GS',
        'UserCSGInformation',
        'GeographicalInformation',
        'GeodeticInformation',
        'LocationNumber',
        'SubscriberState',
        'PS-SubscriberState',
        'PDP-ContextInfoList',
        'PDP-ContextInfo',
        'NSAPI',
        'TransactionId',
        'TEID',
        'GPRSChargingID',
        'NotReachableReason',
        'AnyTimeInterrogationArg',
        'AnyTimeInterrogationRes',
        'AnyTimeSubscriptionInterrogationArg',
        'AnyTimeSubscriptionInterrogationRes',
        'CallWaitingData',
        'Ext-CwFeatureList',
        'Ext-CwFeature',
        'ClipData',
        'ClirData',
        'CallHoldData',
        'EctData',
        'RequestedSubscriptionInfo',
        'MSISDN-BS-List',
        'maxNumOfMSISDN',
        'MSISDN-BS',
        'RequestedCAMEL-SubscriptionInfo',
        'AdditionalRequestedCAMEL-SubscriptionInfo',
        'CallForwardingData',
        'CallBarringData',
        'WrongPasswordAttemptsCounter',
        'ODB-Info',
        'CAMEL-SubscriptionInfo',
        'AnyTimeModificationArg',
        'ModificationRequestFor-CW-Info',
        'ModificationRequestFor-CH-Info',
        'ModificationRequestFor-ECT-Info',
        'ModificationRequestFor-CLIR-Info',
        'ModificationRequestFor-CLIP-Info',
        'ModificationRequestFor-CSG',
        'RequestedServingNode',
        'ServingNode',
        'AnyTimeModificationRes',
        'ModificationRequestFor-CF-Info',
        'ModificationRequestFor-CB-Info',
        'ModificationRequestFor-ODB-data',
        'ModificationRequestFor-CSI',
        'ModificationRequestFor-IP-SM-GW-Data',
        'ModificationInstruction',
        'NoteSubscriberDataModifiedArg',
        'NoteSubscriberDataModifiedRes',
        'NoteMM-EventArg',
        'NoteMM-EventRes',
        'Ext-SS-InfoFor-CSE',
        'Ext-ForwardingInfoFor-CSE',
        'Ext-CallBarringInfoFor-CSE',
        'UpdateVcsgLocationArg',
        'UpdateVcsgLocationRes',
        'CancelVcsgLocationArg',
        'CancelVcsgLocationRes',
        ]
    _type_ = [
        'UpdateLocationArg',
        'VLR-Capability',
        'SupportedRAT-Types',
        'SuperChargerInfo',
        'AgeIndicator',
        'IST-SupportIndicator',
        'SupportedLCS-CapabilitySets',
        'UpdateLocationRes',
        'ADD-Info',
        'PagingArea',
        'LocationArea',
        'LAC',
        'CancelLocationArg',
        'TypeOfUpdate',
        'CancellationType',
        'CancelLocationRes',
        'PurgeMS-Arg',
        'PurgeMS-Res',
        'SendIdentificationArg',
        'HopCounter',
        'SendIdentificationRes',
        'AuthenticationSetList',
        'TripletList',
        'QuintupletList',
        'AuthenticationTriplet',
        'AuthenticationQuintuplet',
        'CurrentSecurityContext',
        'GSM-SecurityContextData',
        'UMTS-SecurityContextData',
        'RAND',
        'SRES',
        'Kc',
        'XRES',
        'CK',
        'IK',
        'AUTN',
        'AUTS',
        'Cksn',
        'KSI',
        'AuthenticationFailureReportArg',
        'AccessType',
        'AuthenticationFailureReportRes',
        'FailureCause',
        'UpdateGprsLocationArg',
        'SMSRegisterRequest',
        'Used-RAT-Type',
        'EPS-Info',
        'PDN-GW-Update',
        'ISR-Information',
        'SGSN-Capability',
        'SupportedFeatures',
        'Ext-SupportedFeatures',
        'UE-SRVCC-Capability',
        'UpdateGprsLocationRes',
        'EPLMN-List',
        'AdjacentPLMN-List',
        'ForwardAccessSignalling-Arg',
        'AllowedGSM-Algorithms',
        'AllowedUMTS-Algorithms',
        'PermittedIntegrityProtectionAlgorithms',
        'PermittedEncryptionAlgorithms',
        'KeyStatus',
        'PrepareHO-Arg',
        'LCLS-GlobalCallReference',
        'LCLS-Negotiation',
        'LCLS-ConfigurationPreference',
        'BSSMAP-ServiceHandoverList',
        'BSSMAP-ServiceHandoverInfo',
        'BSSMAP-ServiceHandover',
        'RANAP-ServiceHandover',
        'RadioResourceList',
        'RadioResource',
        'PrepareHO-Res',
        'SelectedUMTS-Algorithms',
        'ChosenIntegrityProtectionAlgorithm',
        'ChosenEncryptionAlgorithm',
        'ChosenRadioResourceInformation',
        'ChosenChannelInfo',
        'ChosenSpeechVersion',
        'PrepareSubsequentHO-Arg',
        'PrepareSubsequentHO-Res',
        'ProcessAccessSignalling-Arg',
        'AoIPCodecsList',
        'AoIPCodec',
        'SupportedCodecsList',
        'CodecList',
        'Codec',
        'GERAN-Classmark',
        'SelectedGSM-Algorithm',
        'SendEndSignal-Arg',
        'SendEndSignal-Res',
        'RNCId',
        'RelocationNumberList',
        'MulticallBearerInfo',
        'RelocationNumber',
        'RAB-Id',
        'RadioResourceInformation',
        'IntegrityProtectionInformation',
        'EncryptionInformation',
        'SendAuthenticationInfoArg',
        'NumberOfRequestedVectors',
        'Re-synchronisationInfo',
        'SendAuthenticationInfoRes',
        'EPS-AuthenticationSetList',
        'UE-UsageType',
        'EPC-AV',
        'KASME',
        'RequestingNodeType',
        'CheckIMEI-Arg',
        'CheckIMEI-Res',
        'RequestedEquipmentInfo',
        'UESBI-Iu',
        'UESBI-IuA',
        'UESBI-IuB',
        'EquipmentStatus',
        'InsertSubscriberDataArg',
        'EDRX-Cycle-Length-List',
        'EDRX-Cycle-Length',
        'EDRX-Cycle-Length-Value',
        'Reset-Id-List',
        'Reset-Id',
        'DL-Buffering-Suggested-Packet-Count',
        'Group-Service-ID',
        'Local-GroupID',
        'IMSI-GroupIdList',
        'IMSI-GroupId',
        'SubscribedPeriodicRAUTAUtimer',
        'SubscribedPeriodicLAUtimer',
        'CSG-SubscriptionDataList',
        'CSG-SubscriptionData',
        'VPLMN-CSG-SubscriptionDataList',
        'CSG-Id',
        'LIPA-AllowedAPNList',
        'EPS-SubscriptionData',
        'APN-OI-Replacement',
        'RFSP-ID',
        'APN-ConfigurationProfile',
        'EPS-DataList',
        'APN-Configuration',
        'PDN-ConnectionContinuity',
        'NIDD-Mechanism',
        'PDN-Type',
        'EPS-QoS-Subscribed',
        'AMBR',
        'SpecificAPNInfoList',
        'SpecificAPNInfo',
        'Bandwidth',
        'BandwidthExt',
        'QoS-Class-Identifier',
        'Allocation-Retention-Priority',
        'PDN-GW-Identity',
        'FQDN',
        'PDN-GW-AllocationType',
        'WLAN-Offloadability',
        'WLAN-Offloadability-Indication',
        'AccessRestrictionData',
        'Ext-AccessRestrictionData',
        'AdjacentAccessRestrictionDataList',
        'AdjacentAccessRestrictionData',
        'CS-AllocationRetentionPriority',
        'IST-AlertTimerValue',
        'LCSInformation',
        'GMLC-List',
        'NetworkAccessMode',
        'GPRSDataList',
        'PDP-Context',
        'Restoration-Priority',
        'SIPTO-Permission',
        'SIPTO-Local-Network-Permission',
        'LIPA-Permission',
        'ContextId',
        'GPRSSubscriptionData',
        'SGSN-CAMEL-SubscriptionInfo',
        'GPRS-CSI',
        'GPRS-CamelTDPDataList',
        'GPRS-CamelTDPData',
        'DefaultGPRS-Handling',
        'GPRS-TriggerDetectionPoint',
        'APN',
        'PDP-Type',
        'Ext-PDP-Type',
        'PDP-Address',
        'QoS-Subscribed',
        'Ext-QoS-Subscribed',
        'Ext2-QoS-Subscribed',
        'Ext3-QoS-Subscribed',
        'Ext4-QoS-Subscribed',
        'ChargingCharacteristics',
        'LSAOnlyAccessIndicator',
        'LSADataList',
        'LSAData',
        'LSAInformation',
        'LSAIdentity',
        'LSAAttributes',
        'SubscriberData',
        'Category',
        'SubscriberStatus',
        'BearerServiceList',
        'TeleserviceList',
        'ODB-Data',
        'ODB-GeneralData',
        'ODB-HPLMN-Data',
        'Ext-SS-InfoList',
        'Ext-SS-Info',
        'Ext-ForwInfo',
        'Ext-ForwFeatureList',
        'Ext-ForwFeature',
        'Ext-ForwOptions',
        'Ext-NoRepCondTime',
        'Ext-CallBarInfo',
        'Ext-CallBarFeatureList',
        'Ext-CallBarringFeature',
        'CUG-Info',
        'CUG-SubscriptionList',
        'CUG-Subscription',
        'CUG-Index',
        'CUG-Interlock',
        'IntraCUG-Options',
        'CUG-FeatureList',
        'Ext-BasicServiceGroupList',
        'CUG-Feature',
        'InterCUG-Restrictions',
        'Ext-SS-Data',
        'LCS-PrivacyExceptionList',
        'LCS-PrivacyClass',
        'ExternalClientList',
        'PLMNClientList',
        'Ext-ExternalClientList',
        'ExternalClient',
        'GMLC-Restriction',
        'NotificationToMSUser',
        'ServiceTypeList',
        'ServiceType',
        'MOLR-List',
        'MOLR-Class',
        'ZoneCodeList',
        'ZoneCode',
        'InsertSubscriberDataRes',
        'RegionalSubscriptionResponse',
        'DeleteSubscriberDataArg',
        'SpecificCSI-Withdraw',
        'GPRSSubscriptionDataWithdraw',
        'EPS-SubscriptionDataWithdraw',
        'ContextIdList',
        'LSAInformationWithdraw',
        'LSAIdentityList',
        'BasicServiceList',
        'DeleteSubscriberDataRes',
        'VlrCamelSubscriptionInfo',
        'MT-smsCAMELTDP-CriteriaList',
        'MT-smsCAMELTDP-Criteria',
        'TPDU-TypeCriterion',
        'MT-SMS-TPDU-Type',
        'D-CSI',
        'DP-AnalysedInfoCriteriaList',
        'DP-AnalysedInfoCriterium',
        'SS-CSI',
        'SS-CamelData',
        'SS-EventList',
        'O-CSI',
        'O-BcsmCamelTDPDataList',
        'O-BcsmCamelTDPData',
        'ServiceKey',
        'O-BcsmTriggerDetectionPoint',
        'O-BcsmCamelTDPCriteriaList',
        'T-BCSM-CAMEL-TDP-CriteriaList',
        'O-BcsmCamelTDP-Criteria',
        'T-BCSM-CAMEL-TDP-Criteria',
        'DestinationNumberCriteria',
        'DestinationNumberList',
        'DestinationNumberLengthList',
        'BasicServiceCriteria',
        'CallTypeCriteria',
        'MatchType',
        'O-CauseValueCriteria',
        'T-CauseValueCriteria',
        'CauseValue',
        'DefaultCallHandling',
        'CamelCapabilityHandling',
        'SupportedCamelPhases',
        'OfferedCamel4CSIs',
        'OfferedCamel4Functionalities',
        'SMS-CSI',
        'SMS-CAMEL-TDP-DataList',
        'SMS-CAMEL-TDP-Data',
        'SMS-TriggerDetectionPoint',
        'DefaultSMS-Handling',
        'M-CSI',
        'MG-CSI',
        'MobilityTriggers',
        'MM-Code',
        'T-CSI',
        'T-BcsmCamelTDPDataList',
        'T-BcsmCamelTDPData',
        'T-BcsmTriggerDetectionPoint',
        'SendRoutingInfoForGprsArg',
        'SendRoutingInfoForGprsRes',
        'FailureReportArg',
        'FailureReportRes',
        'NoteMsPresentForGprsArg',
        'NoteMsPresentForGprsRes',
        'ResetArg',
        'SendingNode-Number',
        'RestoreDataArg',
        'RestoreDataRes',
        'VBSDataList',
        'VGCSDataList',
        'VoiceGroupCallData',
        'AdditionalInfo',
        'AdditionalSubscriptions',
        'VoiceBroadcastData',
        'GroupId',
        'Long-GroupId',
        'ProvideSubscriberInfoArg',
        'ProvideSubscriberInfoRes',
        'SubscriberInfo',
        'IMS-VoiceOverPS-SessionsInd',
        'TimeZone',
        'DaylightSavingTime',
        'MNPInfoRes',
        'RouteingNumber',
        'NumberPortabilityStatus',
        'MS-Classmark2',
        'GPRSMSClass',
        'MSNetworkCapability',
        'MSRadioAccessCapability',
        'RequestedInfo',
        'DomainType',
        'RequestedNodes',
        'LocationInformation',
        'LocationInformationEPS',
        'LocationInformationGPRS',
        'LocationInformation5GS',
        'UserCSGInformation',
        'GeographicalInformation',
        'GeodeticInformation',
        'LocationNumber',
        'SubscriberState',
        'PS-SubscriberState',
        'PDP-ContextInfoList',
        'PDP-ContextInfo',
        'NSAPI',
        'TransactionId',
        'TEID',
        'GPRSChargingID',
        'NotReachableReason',
        'AnyTimeInterrogationArg',
        'AnyTimeInterrogationRes',
        'AnyTimeSubscriptionInterrogationArg',
        'AnyTimeSubscriptionInterrogationRes',
        'CallWaitingData',
        'Ext-CwFeatureList',
        'Ext-CwFeature',
        'ClipData',
        'ClirData',
        'CallHoldData',
        'EctData',
        'RequestedSubscriptionInfo',
        'MSISDN-BS-List',
        'MSISDN-BS',
        'RequestedCAMEL-SubscriptionInfo',
        'AdditionalRequestedCAMEL-SubscriptionInfo',
        'CallForwardingData',
        'CallBarringData',
        'WrongPasswordAttemptsCounter',
        'ODB-Info',
        'CAMEL-SubscriptionInfo',
        'AnyTimeModificationArg',
        'ModificationRequestFor-CW-Info',
        'ModificationRequestFor-CH-Info',
        'ModificationRequestFor-ECT-Info',
        'ModificationRequestFor-CLIR-Info',
        'ModificationRequestFor-CLIP-Info',
        'ModificationRequestFor-CSG',
        'RequestedServingNode',
        'ServingNode',
        'AnyTimeModificationRes',
        'ModificationRequestFor-CF-Info',
        'ModificationRequestFor-CB-Info',
        'ModificationRequestFor-ODB-data',
        'ModificationRequestFor-CSI',
        'ModificationRequestFor-IP-SM-GW-Data',
        'ModificationInstruction',
        'NoteSubscriberDataModifiedArg',
        'NoteSubscriberDataModifiedRes',
        'NoteMM-EventArg',
        'NoteMM-EventRes',
        'Ext-SS-InfoFor-CSE',
        'Ext-ForwardingInfoFor-CSE',
        'Ext-CallBarringInfoFor-CSE',
        'UpdateVcsgLocationArg',
        'UpdateVcsgLocationRes',
        'CancelVcsgLocationArg',
        'CancelVcsgLocationRes',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPermittedIntegrityProtectionAlgorithmsLength',
        'maxPermittedEncryptionAlgorithmsLength',
        'maxNumOfServiceHandovers',
        'maxNumOfRadioResources',
        'maxNrOfRABs',
        'maxNumOfRelocationNumber',
        'maxNumOfIntegrityInfo',
        'maxNumOfEncryptionInfo',
        'maxNumOfLIPAAllowedAPN',
        'maxNumOfAPN-Configurations',
        'maxNumOfSpecificAPNInfos',
        'maxNumOfGMLC',
        'maxNumOfPDP-Contexts',
        'maxNumOfLSAs',
        'maxNumOfBearerServices',
        'maxNumOfTeleservices',
        'maxNumOfCUG',
        'maxNumOfExt-BasicServiceGroups',
        'maxNumOfPrivacyClass',
        'maxNumOfExternalClient',
        'maxNumOfPLMNClient',
        'maxNumOfExt-ExternalClient',
        'maxNumOfServiceType',
        'maxNumOfMOLR-Class',
        'maxNumOfZoneCodes',
        'maxNumOfBasicServices',
        'maxNumOfTPDUTypes',
        'maxNumOfDP-AnalysedInfoCriteria',
        'maxNumOfCamelSSEvents',
        'maxNumOfCamelTDPData',
        'maxNumOfISDN-AddressDigits',
        'maxNumOfCamelDestinationNumbers',
        'maxNumOfCamelDestinationNumberLengths',
        'maxNumOfCamelBasicServiceCriteria',
        'maxNumOfCAMEL-O-CauseValueCriteria',
        'maxNumOfCAMEL-T-CauseValueCriteria',
        'maxNumOfMobilityTriggers',
        'maxNumOfVBSGroupIds',
        'maxNumOfVGCSGroupIds',
        'maxNumOfMSISDN',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< UpdateLocationArg >-----#
    UpdateLocationArg = SEQ(name='UpdateLocationArg', mode=MODE_TYPE)
    _UpdateLocationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateLocationArg_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _UpdateLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationArg_vlr_Capability = SEQ(name='vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _UpdateLocationArg_informPreviousNetworkEntity = NULL(name='informPreviousNetworkEntity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_cs_LCS_NotSupportedByUE = NULL(name='cs-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_v_gmlc_Address = OCT_STR(name='v-gmlc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateLocationArg_add_info = SEQ(name='add-info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateLocationArg_pagingArea = SEQ_OF(name='pagingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _UpdateLocationArg_skipSubscriberDataUpdate = NULL(name='skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_restorationIndicator = NULL(name='restorationIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_eplmn_List = SEQ_OF(name='eplmn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateLocationArg_mme_DiameterAddress = SEQ(name='mme-DiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    UpdateLocationArg._cont = ASN1Dict([
        ('imsi', _UpdateLocationArg_imsi),
        ('msc-Number', _UpdateLocationArg_msc_Number),
        ('vlr-Number', _UpdateLocationArg_vlr_Number),
        ('lmsi', _UpdateLocationArg_lmsi),
        ('extensionContainer', _UpdateLocationArg_extensionContainer),
        ('vlr-Capability', _UpdateLocationArg_vlr_Capability),
        ('informPreviousNetworkEntity', _UpdateLocationArg_informPreviousNetworkEntity),
        ('cs-LCS-NotSupportedByUE', _UpdateLocationArg_cs_LCS_NotSupportedByUE),
        ('v-gmlc-Address', _UpdateLocationArg_v_gmlc_Address),
        ('add-info', _UpdateLocationArg_add_info),
        ('pagingArea', _UpdateLocationArg_pagingArea),
        ('skipSubscriberDataUpdate', _UpdateLocationArg_skipSubscriberDataUpdate),
        ('restorationIndicator', _UpdateLocationArg_restorationIndicator),
        ('eplmn-List', _UpdateLocationArg_eplmn_List),
        ('mme-DiameterAddress', _UpdateLocationArg_mme_DiameterAddress),
        ])
    UpdateLocationArg._ext = ['vlr-Capability', 'informPreviousNetworkEntity', 'cs-LCS-NotSupportedByUE', 'v-gmlc-Address', 'add-info', 'pagingArea', 'skipSubscriberDataUpdate', 'restorationIndicator', 'eplmn-List', 'mme-DiameterAddress']
    
    #-----< VLR-Capability >-----#
    VLR_Capability = SEQ(name='VLR-Capability', mode=MODE_TYPE)
    _VLR_Capability_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _VLR_Capability_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VLR_Capability_solsaSupportIndicator = NULL(name='solsaSupportIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_istSupportIndicator = ENUM(name='istSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _VLR_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name='superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _VLR_Capability_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_supportedLCS_CapabilitySets = BIT_STR(name='supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _VLR_Capability_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _VLR_Capability_supportedRAT_TypesIndicator = BIT_STR(name='supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _VLR_Capability_longGroupID_Supported = NULL(name='longGroupID-Supported', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_mtRoamingForwardingSupported = NULL(name='mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_msisdn_lessOperation_Supported = NULL(name='msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_reset_ids_Supported = NULL(name='reset-ids-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    VLR_Capability._cont = ASN1Dict([
        ('supportedCamelPhases', _VLR_Capability_supportedCamelPhases),
        ('extensionContainer', _VLR_Capability_extensionContainer),
        ('solsaSupportIndicator', _VLR_Capability_solsaSupportIndicator),
        ('istSupportIndicator', _VLR_Capability_istSupportIndicator),
        ('superChargerSupportedInServingNetworkEntity', _VLR_Capability_superChargerSupportedInServingNetworkEntity),
        ('longFTN-Supported', _VLR_Capability_longFTN_Supported),
        ('supportedLCS-CapabilitySets', _VLR_Capability_supportedLCS_CapabilitySets),
        ('offeredCamel4CSIs', _VLR_Capability_offeredCamel4CSIs),
        ('supportedRAT-TypesIndicator', _VLR_Capability_supportedRAT_TypesIndicator),
        ('longGroupID-Supported', _VLR_Capability_longGroupID_Supported),
        ('mtRoamingForwardingSupported', _VLR_Capability_mtRoamingForwardingSupported),
        ('msisdn-lessOperation-Supported', _VLR_Capability_msisdn_lessOperation_Supported),
        ('reset-ids-Supported', _VLR_Capability_reset_ids_Supported),
        ])
    VLR_Capability._ext = ['solsaSupportIndicator', 'istSupportIndicator', 'superChargerSupportedInServingNetworkEntity', 'longFTN-Supported', 'supportedLCS-CapabilitySets', 'offeredCamel4CSIs', 'supportedRAT-TypesIndicator', 'longGroupID-Supported', 'mtRoamingForwardingSupported', 'msisdn-lessOperation-Supported', 'reset-ids-Supported']
    
    #-----< SupportedRAT-Types >-----#
    SupportedRAT_Types = BIT_STR(name='SupportedRAT-Types', mode=MODE_TYPE)
    SupportedRAT_Types._cont = ASN1Dict([('utran', 0), ('geran', 1), ('gan', 2), ('i-hspa-evolution', 3), ('e-utran', 4), ('nb-iot', 5)])
    SupportedRAT_Types._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< SuperChargerInfo >-----#
    SuperChargerInfo = CHOICE(name='SuperChargerInfo', mode=MODE_TYPE)
    _SuperChargerInfo_sendSubscriberData = NULL(name='sendSubscriberData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SuperChargerInfo_subscriberDataStored = OCT_STR(name='subscriberDataStored', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')))
    SuperChargerInfo._cont = ASN1Dict([
        ('sendSubscriberData', _SuperChargerInfo_sendSubscriberData),
        ('subscriberDataStored', _SuperChargerInfo_subscriberDataStored),
        ])
    SuperChargerInfo._ext = None
    
    #-----< AgeIndicator >-----#
    AgeIndicator = OCT_STR(name='AgeIndicator', mode=MODE_TYPE)
    AgeIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< IST-SupportIndicator >-----#
    IST_SupportIndicator = ENUM(name='IST-SupportIndicator', mode=MODE_TYPE)
    IST_SupportIndicator._cont = ASN1Dict([('basicISTSupported', 0), ('istCommandSupported', 1)])
    IST_SupportIndicator._ext = []
    
    #-----< SupportedLCS-CapabilitySets >-----#
    SupportedLCS_CapabilitySets = BIT_STR(name='SupportedLCS-CapabilitySets', mode=MODE_TYPE)
    SupportedLCS_CapabilitySets._cont = ASN1Dict([('lcsCapabilitySet1', 0), ('lcsCapabilitySet2', 1), ('lcsCapabilitySet3', 2), ('lcsCapabilitySet4', 3), ('lcsCapabilitySet5', 4)])
    SupportedLCS_CapabilitySets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< UpdateLocationRes >-----#
    UpdateLocationRes = SEQ(name='UpdateLocationRes', mode=MODE_TYPE)
    _UpdateLocationRes_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationRes_add_Capability = NULL(name='add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateLocationRes_pagingArea_Capability = NULL(name='pagingArea-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateLocationRes._cont = ASN1Dict([
        ('hlr-Number', _UpdateLocationRes_hlr_Number),
        ('extensionContainer', _UpdateLocationRes_extensionContainer),
        ('add-Capability', _UpdateLocationRes_add_Capability),
        ('pagingArea-Capability', _UpdateLocationRes_pagingArea_Capability),
        ])
    UpdateLocationRes._ext = ['add-Capability', 'pagingArea-Capability']
    
    #-----< ADD-Info >-----#
    ADD_Info = SEQ(name='ADD-Info', mode=MODE_TYPE)
    _ADD_Info_imeisv = OCT_STR(name='imeisv', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _ADD_Info_skipSubscriberDataUpdate = NULL(name='skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ADD_Info._cont = ASN1Dict([
        ('imeisv', _ADD_Info_imeisv),
        ('skipSubscriberDataUpdate', _ADD_Info_skipSubscriberDataUpdate),
        ])
    ADD_Info._ext = []
    
    #-----< PagingArea >-----#
    PagingArea = SEQ_OF(name='PagingArea', mode=MODE_TYPE)
    _PagingArea__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationArea')))
    PagingArea._cont = _PagingArea__item_
    PagingArea._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< LocationArea >-----#
    LocationArea = CHOICE(name='LocationArea', mode=MODE_TYPE)
    _LocationArea_laiFixedLength = OCT_STR(name='laiFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _LocationArea_lac = OCT_STR(name='lac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LAC')))
    LocationArea._cont = ASN1Dict([
        ('laiFixedLength', _LocationArea_laiFixedLength),
        ('lac', _LocationArea_lac),
        ])
    LocationArea._ext = None
    
    #-----< LAC >-----#
    LAC = OCT_STR(name='LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< CancelLocationArg >-----#
    CancelLocationArg = SEQ(name='CancelLocationArg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CancelLocationArg_identity = CHOICE(name='identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelLocationArg_cancellationType = ENUM(name='cancellationType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CancellationType')), opt=True)
    _CancelLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CancelLocationArg_typeOfUpdate = ENUM(name='typeOfUpdate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TypeOfUpdate')), opt=True)
    _CancelLocationArg_mtrf_SupportedAndAuthorized = NULL(name='mtrf-SupportedAndAuthorized', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_mtrf_SupportedAndNotAuthorized = NULL(name='mtrf-SupportedAndNotAuthorized', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_newMSC_Number = OCT_STR(name='newMSC-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_newVLR_Number = OCT_STR(name='newVLR-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_new_lmsi = OCT_STR(name='new-lmsi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _CancelLocationArg_reattach_Required = NULL(name='reattach-Required', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CancelLocationArg._cont = ASN1Dict([
        ('identity', _CancelLocationArg_identity),
        ('cancellationType', _CancelLocationArg_cancellationType),
        ('extensionContainer', _CancelLocationArg_extensionContainer),
        ('typeOfUpdate', _CancelLocationArg_typeOfUpdate),
        ('mtrf-SupportedAndAuthorized', _CancelLocationArg_mtrf_SupportedAndAuthorized),
        ('mtrf-SupportedAndNotAuthorized', _CancelLocationArg_mtrf_SupportedAndNotAuthorized),
        ('newMSC-Number', _CancelLocationArg_newMSC_Number),
        ('newVLR-Number', _CancelLocationArg_newVLR_Number),
        ('new-lmsi', _CancelLocationArg_new_lmsi),
        ('reattach-Required', _CancelLocationArg_reattach_Required),
        ])
    CancelLocationArg._ext = ['typeOfUpdate', 'mtrf-SupportedAndAuthorized', 'mtrf-SupportedAndNotAuthorized', 'newMSC-Number', 'newVLR-Number', 'new-lmsi', 'reattach-Required']
    
    #-----< TypeOfUpdate >-----#
    TypeOfUpdate = ENUM(name='TypeOfUpdate', mode=MODE_TYPE)
    TypeOfUpdate._cont = ASN1Dict([('sgsn-change', 0), ('mme-change', 1)])
    TypeOfUpdate._ext = []
    
    #-----< CancellationType >-----#
    CancellationType = ENUM(name='CancellationType', mode=MODE_TYPE)
    CancellationType._cont = ASN1Dict([('updateProcedure', 0), ('subscriptionWithdraw', 1), ('initialAttachProcedure', 2)])
    CancellationType._ext = ['initialAttachProcedure']
    
    #-----< CancelLocationRes >-----#
    CancelLocationRes = SEQ(name='CancelLocationRes', mode=MODE_TYPE)
    _CancelLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelLocationRes._cont = ASN1Dict([
        ('extensionContainer', _CancelLocationRes_extensionContainer),
        ])
    CancelLocationRes._ext = []
    
    #-----< PurgeMS-Arg >-----#
    PurgeMS_Arg = SEQ(name='PurgeMS-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PurgeMS_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _PurgeMS_Arg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Arg_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _PurgeMS_Arg_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _PurgeMS_Arg_locationInformationEPS = SEQ(name='locationInformationEPS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    PurgeMS_Arg._cont = ASN1Dict([
        ('imsi', _PurgeMS_Arg_imsi),
        ('vlr-Number', _PurgeMS_Arg_vlr_Number),
        ('sgsn-Number', _PurgeMS_Arg_sgsn_Number),
        ('extensionContainer', _PurgeMS_Arg_extensionContainer),
        ('locationInformation', _PurgeMS_Arg_locationInformation),
        ('locationInformationGPRS', _PurgeMS_Arg_locationInformationGPRS),
        ('locationInformationEPS', _PurgeMS_Arg_locationInformationEPS),
        ])
    PurgeMS_Arg._ext = ['locationInformation', 'locationInformationGPRS', 'locationInformationEPS']
    
    #-----< PurgeMS-Res >-----#
    PurgeMS_Res = SEQ(name='PurgeMS-Res', mode=MODE_TYPE)
    _PurgeMS_Res_freezeTMSI = NULL(name='freezeTMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_freezeP_TMSI = NULL(name='freezeP-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Res_freezeM_TMSI = NULL(name='freezeM-TMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PurgeMS_Res._cont = ASN1Dict([
        ('freezeTMSI', _PurgeMS_Res_freezeTMSI),
        ('freezeP-TMSI', _PurgeMS_Res_freezeP_TMSI),
        ('extensionContainer', _PurgeMS_Res_extensionContainer),
        ('freezeM-TMSI', _PurgeMS_Res_freezeM_TMSI),
        ])
    PurgeMS_Res._ext = ['freezeM-TMSI']
    
    #-----< SendIdentificationArg >-----#
    SendIdentificationArg = SEQ(name='SendIdentificationArg', mode=MODE_TYPE)
    _SendIdentificationArg_tmsi = OCT_STR(name='tmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    _SendIdentificationArg_numberOfRequestedVectors = INT(name='numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendIdentificationArg_segmentationProhibited = NULL(name='segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendIdentificationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationArg_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_previous_LAI = OCT_STR(name='previous-LAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')), opt=True)
    _SendIdentificationArg_hopCounter = INT(name='hopCounter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'HopCounter')), opt=True)
    _SendIdentificationArg_mtRoamingForwardingSupported = NULL(name='mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendIdentificationArg_newVLR_Number = OCT_STR(name='newVLR-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_new_lmsi = OCT_STR(name='new-lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    SendIdentificationArg._cont = ASN1Dict([
        ('tmsi', _SendIdentificationArg_tmsi),
        ('numberOfRequestedVectors', _SendIdentificationArg_numberOfRequestedVectors),
        ('segmentationProhibited', _SendIdentificationArg_segmentationProhibited),
        ('extensionContainer', _SendIdentificationArg_extensionContainer),
        ('msc-Number', _SendIdentificationArg_msc_Number),
        ('previous-LAI', _SendIdentificationArg_previous_LAI),
        ('hopCounter', _SendIdentificationArg_hopCounter),
        ('mtRoamingForwardingSupported', _SendIdentificationArg_mtRoamingForwardingSupported),
        ('newVLR-Number', _SendIdentificationArg_newVLR_Number),
        ('new-lmsi', _SendIdentificationArg_new_lmsi),
        ])
    SendIdentificationArg._ext = ['msc-Number', 'previous-LAI', 'hopCounter', 'mtRoamingForwardingSupported', 'newVLR-Number', 'new-lmsi']
    
    #-----< HopCounter >-----#
    HopCounter = INT(name='HopCounter', mode=MODE_TYPE)
    HopCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< SendIdentificationRes >-----#
    SendIdentificationRes = SEQ(name='SendIdentificationRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendIdentificationRes_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendIdentificationRes_authenticationSetList = CHOICE(name='authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendIdentificationRes_currentSecurityContext = CHOICE(name='currentSecurityContext', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CurrentSecurityContext')), opt=True)
    _SendIdentificationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationRes_lastUsedLtePLMN_Id = OCT_STR(name='lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendIdentificationRes_mtCallPendingFlag = NULL(name='mtCallPendingFlag', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendIdentificationRes._cont = ASN1Dict([
        ('imsi', _SendIdentificationRes_imsi),
        ('authenticationSetList', _SendIdentificationRes_authenticationSetList),
        ('currentSecurityContext', _SendIdentificationRes_currentSecurityContext),
        ('extensionContainer', _SendIdentificationRes_extensionContainer),
        ('lastUsedLtePLMN-Id', _SendIdentificationRes_lastUsedLtePLMN_Id),
        ('mtCallPendingFlag', _SendIdentificationRes_mtCallPendingFlag),
        ])
    SendIdentificationRes._ext = ['lastUsedLtePLMN-Id', 'mtCallPendingFlag']
    
    #-----< AuthenticationSetList >-----#
    AuthenticationSetList = CHOICE(name='AuthenticationSetList', mode=MODE_TYPE)
    _AuthenticationSetList_tripletList = SEQ_OF(name='tripletList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TripletList')))
    _AuthenticationSetList_quintupletList = SEQ_OF(name='quintupletList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QuintupletList')))
    AuthenticationSetList._cont = ASN1Dict([
        ('tripletList', _AuthenticationSetList_tripletList),
        ('quintupletList', _AuthenticationSetList_quintupletList),
        ])
    AuthenticationSetList._ext = None
    
    #-----< TripletList >-----#
    TripletList = SEQ_OF(name='TripletList', mode=MODE_TYPE)
    _TripletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationTriplet')))
    TripletList._cont = _TripletList__item_
    TripletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< QuintupletList >-----#
    QuintupletList = SEQ_OF(name='QuintupletList', mode=MODE_TYPE)
    _QuintupletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationQuintuplet')))
    QuintupletList._cont = _QuintupletList__item_
    QuintupletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AuthenticationTriplet >-----#
    AuthenticationTriplet = SEQ(name='AuthenticationTriplet', mode=MODE_TYPE)
    _AuthenticationTriplet_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationTriplet_sres = OCT_STR(name='sres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SRES')))
    _AuthenticationTriplet_kc = OCT_STR(name='kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    AuthenticationTriplet._cont = ASN1Dict([
        ('rand', _AuthenticationTriplet_rand),
        ('sres', _AuthenticationTriplet_sres),
        ('kc', _AuthenticationTriplet_kc),
        ])
    AuthenticationTriplet._ext = []
    
    #-----< AuthenticationQuintuplet >-----#
    AuthenticationQuintuplet = SEQ(name='AuthenticationQuintuplet', mode=MODE_TYPE)
    _AuthenticationQuintuplet_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationQuintuplet_xres = OCT_STR(name='xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _AuthenticationQuintuplet_ck = OCT_STR(name='ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _AuthenticationQuintuplet_ik = OCT_STR(name='ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _AuthenticationQuintuplet_autn = OCT_STR(name='autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    AuthenticationQuintuplet._cont = ASN1Dict([
        ('rand', _AuthenticationQuintuplet_rand),
        ('xres', _AuthenticationQuintuplet_xres),
        ('ck', _AuthenticationQuintuplet_ck),
        ('ik', _AuthenticationQuintuplet_ik),
        ('autn', _AuthenticationQuintuplet_autn),
        ])
    AuthenticationQuintuplet._ext = []
    
    #-----< CurrentSecurityContext >-----#
    CurrentSecurityContext = CHOICE(name='CurrentSecurityContext', mode=MODE_TYPE)
    _CurrentSecurityContext_gsm_SecurityContextData = SEQ(name='gsm-SecurityContextData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GSM-SecurityContextData')))
    _CurrentSecurityContext_umts_SecurityContextData = SEQ(name='umts-SecurityContextData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UMTS-SecurityContextData')))
    CurrentSecurityContext._cont = ASN1Dict([
        ('gsm-SecurityContextData', _CurrentSecurityContext_gsm_SecurityContextData),
        ('umts-SecurityContextData', _CurrentSecurityContext_umts_SecurityContextData),
        ])
    CurrentSecurityContext._ext = None
    
    #-----< GSM-SecurityContextData >-----#
    GSM_SecurityContextData = SEQ(name='GSM-SecurityContextData', mode=MODE_TYPE)
    _GSM_SecurityContextData_kc = OCT_STR(name='kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    _GSM_SecurityContextData_cksn = OCT_STR(name='cksn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Cksn')))
    GSM_SecurityContextData._cont = ASN1Dict([
        ('kc', _GSM_SecurityContextData_kc),
        ('cksn', _GSM_SecurityContextData_cksn),
        ])
    GSM_SecurityContextData._ext = []
    
    #-----< UMTS-SecurityContextData >-----#
    UMTS_SecurityContextData = SEQ(name='UMTS-SecurityContextData', mode=MODE_TYPE)
    _UMTS_SecurityContextData_ck = OCT_STR(name='ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _UMTS_SecurityContextData_ik = OCT_STR(name='ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _UMTS_SecurityContextData_ksi = OCT_STR(name='ksi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KSI')))
    UMTS_SecurityContextData._cont = ASN1Dict([
        ('ck', _UMTS_SecurityContextData_ck),
        ('ik', _UMTS_SecurityContextData_ik),
        ('ksi', _UMTS_SecurityContextData_ksi),
        ])
    UMTS_SecurityContextData._ext = []
    
    #-----< RAND >-----#
    RAND = OCT_STR(name='RAND', mode=MODE_TYPE)
    RAND._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SRES >-----#
    SRES = OCT_STR(name='SRES', mode=MODE_TYPE)
    SRES._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< Kc >-----#
    Kc = OCT_STR(name='Kc', mode=MODE_TYPE)
    Kc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< XRES >-----#
    XRES = OCT_STR(name='XRES', mode=MODE_TYPE)
    XRES._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< CK >-----#
    CK = OCT_STR(name='CK', mode=MODE_TYPE)
    CK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IK >-----#
    IK = OCT_STR(name='IK', mode=MODE_TYPE)
    IK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTN >-----#
    AUTN = OCT_STR(name='AUTN', mode=MODE_TYPE)
    AUTN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTS >-----#
    AUTS = OCT_STR(name='AUTS', mode=MODE_TYPE)
    AUTS._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< Cksn >-----#
    Cksn = OCT_STR(name='Cksn', mode=MODE_TYPE)
    Cksn._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< KSI >-----#
    KSI = OCT_STR(name='KSI', mode=MODE_TYPE)
    KSI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AuthenticationFailureReportArg >-----#
    AuthenticationFailureReportArg = SEQ(name='AuthenticationFailureReportArg', mode=MODE_TYPE)
    _AuthenticationFailureReportArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _AuthenticationFailureReportArg_failureCause = ENUM(name='failureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'FailureCause')))
    _AuthenticationFailureReportArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AuthenticationFailureReportArg_re_attempt = BOOL(name='re-attempt', mode=MODE_TYPE, opt=True)
    _AuthenticationFailureReportArg_accessType = ENUM(name='accessType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessType')), opt=True)
    _AuthenticationFailureReportArg_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')), opt=True)
    _AuthenticationFailureReportArg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AuthenticationFailureReportArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    AuthenticationFailureReportArg._cont = ASN1Dict([
        ('imsi', _AuthenticationFailureReportArg_imsi),
        ('failureCause', _AuthenticationFailureReportArg_failureCause),
        ('extensionContainer', _AuthenticationFailureReportArg_extensionContainer),
        ('re-attempt', _AuthenticationFailureReportArg_re_attempt),
        ('accessType', _AuthenticationFailureReportArg_accessType),
        ('rand', _AuthenticationFailureReportArg_rand),
        ('vlr-Number', _AuthenticationFailureReportArg_vlr_Number),
        ('sgsn-Number', _AuthenticationFailureReportArg_sgsn_Number),
        ])
    AuthenticationFailureReportArg._ext = ['re-attempt', 'accessType', 'rand', 'vlr-Number', 'sgsn-Number']
    
    #-----< AccessType >-----#
    AccessType = ENUM(name='AccessType', mode=MODE_TYPE)
    AccessType._cont = ASN1Dict([('call', 0), ('emergencyCall', 1), ('locationUpdating', 2), ('supplementaryService', 3), ('shortMessage', 4), ('gprsAttach', 5), ('routingAreaUpdating', 6), ('serviceRequest', 7), ('pdpContextActivation', 8), ('pdpContextDeactivation', 9), ('gprsDetach', 10)])
    AccessType._ext = ['gprsDetach']
    
    #-----< AuthenticationFailureReportRes >-----#
    AuthenticationFailureReportRes = SEQ(name='AuthenticationFailureReportRes', mode=MODE_TYPE)
    _AuthenticationFailureReportRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AuthenticationFailureReportRes._cont = ASN1Dict([
        ('extensionContainer', _AuthenticationFailureReportRes_extensionContainer),
        ])
    AuthenticationFailureReportRes._ext = []
    
    #-----< FailureCause >-----#
    FailureCause = ENUM(name='FailureCause', mode=MODE_TYPE)
    FailureCause._cont = ASN1Dict([('wrongUserResponse', 0), ('wrongNetworkSignature', 1)])
    FailureCause._ext = None
    
    #-----< UpdateGprsLocationArg >-----#
    UpdateGprsLocationArg = SEQ(name='UpdateGprsLocationArg', mode=MODE_TYPE)
    _UpdateGprsLocationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateGprsLocationArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationArg_sgsn_Address = OCT_STR(name='sgsn-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _UpdateGprsLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationArg_sgsn_Capability = SEQ(name='sgsn-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-Capability')), opt=True)
    _UpdateGprsLocationArg_informPreviousNetworkEntity = NULL(name='informPreviousNetworkEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE = NULL(name='ps-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_v_gmlc_Address = OCT_STR(name='v-gmlc-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateGprsLocationArg_add_info = SEQ(name='add-info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateGprsLocationArg_eps_info = CHOICE(name='eps-info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-Info')), opt=True)
    _UpdateGprsLocationArg_servingNodeTypeIndicator = NULL(name='servingNodeTypeIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_skipSubscriberDataUpdate = NULL(name='skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_usedRAT_Type = ENUM(name='usedRAT-Type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded = NULL(name='gprsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_nodeTypeIndicator = NULL(name='nodeTypeIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_areaRestricted = NULL(name='areaRestricted', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_reachableIndicator = NULL(name='ue-reachableIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded = NULL(name='epsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_srvcc_Capability = ENUM(name='ue-srvcc-Capability', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-SRVCC-Capability')), opt=True)
    _UpdateGprsLocationArg_eplmn_List = SEQ_OF(name='eplmn-List', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateGprsLocationArg_mmeNumberforMTSMS = OCT_STR(name='mmeNumberforMTSMS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateGprsLocationArg_smsRegisterRequest = ENUM(name='smsRegisterRequest', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMSRegisterRequest')), opt=True)
    _UpdateGprsLocationArg_sms_Only = NULL(name='sms-Only', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_removalofMMERegistrationforSMS = NULL(name='removalofMMERegistrationforSMS', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_sgsn_Name = OCT_STR(name='sgsn-Name', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_sgsn_Realm = OCT_STR(name='sgsn-Realm', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_lgd_supportIndicator = NULL(name='lgd-supportIndicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_adjacentPLMN_List = SEQ_OF(name='adjacentPLMN-List', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentPLMN-List')), opt=True)
    UpdateGprsLocationArg._cont = ASN1Dict([
        ('imsi', _UpdateGprsLocationArg_imsi),
        ('sgsn-Number', _UpdateGprsLocationArg_sgsn_Number),
        ('sgsn-Address', _UpdateGprsLocationArg_sgsn_Address),
        ('extensionContainer', _UpdateGprsLocationArg_extensionContainer),
        ('sgsn-Capability', _UpdateGprsLocationArg_sgsn_Capability),
        ('informPreviousNetworkEntity', _UpdateGprsLocationArg_informPreviousNetworkEntity),
        ('ps-LCS-NotSupportedByUE', _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE),
        ('v-gmlc-Address', _UpdateGprsLocationArg_v_gmlc_Address),
        ('add-info', _UpdateGprsLocationArg_add_info),
        ('eps-info', _UpdateGprsLocationArg_eps_info),
        ('servingNodeTypeIndicator', _UpdateGprsLocationArg_servingNodeTypeIndicator),
        ('skipSubscriberDataUpdate', _UpdateGprsLocationArg_skipSubscriberDataUpdate),
        ('usedRAT-Type', _UpdateGprsLocationArg_usedRAT_Type),
        ('gprsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded),
        ('nodeTypeIndicator', _UpdateGprsLocationArg_nodeTypeIndicator),
        ('areaRestricted', _UpdateGprsLocationArg_areaRestricted),
        ('ue-reachableIndicator', _UpdateGprsLocationArg_ue_reachableIndicator),
        ('epsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded),
        ('ue-srvcc-Capability', _UpdateGprsLocationArg_ue_srvcc_Capability),
        ('eplmn-List', _UpdateGprsLocationArg_eplmn_List),
        ('mmeNumberforMTSMS', _UpdateGprsLocationArg_mmeNumberforMTSMS),
        ('smsRegisterRequest', _UpdateGprsLocationArg_smsRegisterRequest),
        ('sms-Only', _UpdateGprsLocationArg_sms_Only),
        ('removalofMMERegistrationforSMS', _UpdateGprsLocationArg_removalofMMERegistrationforSMS),
        ('sgsn-Name', _UpdateGprsLocationArg_sgsn_Name),
        ('sgsn-Realm', _UpdateGprsLocationArg_sgsn_Realm),
        ('lgd-supportIndicator', _UpdateGprsLocationArg_lgd_supportIndicator),
        ('adjacentPLMN-List', _UpdateGprsLocationArg_adjacentPLMN_List),
        ])
    UpdateGprsLocationArg._ext = ['sgsn-Capability', 'informPreviousNetworkEntity', 'ps-LCS-NotSupportedByUE', 'v-gmlc-Address', 'add-info', 'eps-info', 'servingNodeTypeIndicator', 'skipSubscriberDataUpdate', 'usedRAT-Type', 'gprsSubscriptionDataNotNeeded', 'nodeTypeIndicator', 'areaRestricted', 'ue-reachableIndicator', 'epsSubscriptionDataNotNeeded', 'ue-srvcc-Capability', 'eplmn-List', 'mmeNumberforMTSMS', 'smsRegisterRequest', 'sms-Only', 'removalofMMERegistrationforSMS', 'sgsn-Name', 'sgsn-Realm', 'lgd-supportIndicator', 'adjacentPLMN-List']
    
    #-----< SMSRegisterRequest >-----#
    SMSRegisterRequest = ENUM(name='SMSRegisterRequest', mode=MODE_TYPE)
    SMSRegisterRequest._cont = ASN1Dict([('sms-registration-required', 0), ('sms-registration-not-preferred', 1), ('no-preference', 2)])
    SMSRegisterRequest._ext = []
    
    #-----< Used-RAT-Type >-----#
    Used_RAT_Type = ENUM(name='Used-RAT-Type', mode=MODE_TYPE)
    Used_RAT_Type._cont = ASN1Dict([('utran', 0), ('geran', 1), ('gan', 2), ('i-hspa-evolution', 3), ('e-utran', 4), ('nb-iot', 5)])
    Used_RAT_Type._ext = ['nb-iot']
    
    #-----< EPS-Info >-----#
    EPS_Info = CHOICE(name='EPS-Info', mode=MODE_TYPE)
    _EPS_Info_pdn_gw_update = SEQ(name='pdn-gw-update', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Update')))
    _EPS_Info_isr_Information = BIT_STR(name='isr-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ISR-Information')))
    EPS_Info._cont = ASN1Dict([
        ('pdn-gw-update', _EPS_Info_pdn_gw_update),
        ('isr-Information', _EPS_Info_isr_Information),
        ])
    EPS_Info._ext = None
    
    #-----< PDN-GW-Update >-----#
    PDN_GW_Update = SEQ(name='PDN-GW-Update', mode=MODE_TYPE)
    _PDN_GW_Update_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDN_GW_Update_pdn_gw_Identity = SEQ(name='pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _PDN_GW_Update_contextId = INT(name='contextId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    _PDN_GW_Update_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Update._cont = ASN1Dict([
        ('apn', _PDN_GW_Update_apn),
        ('pdn-gw-Identity', _PDN_GW_Update_pdn_gw_Identity),
        ('contextId', _PDN_GW_Update_contextId),
        ('extensionContainer', _PDN_GW_Update_extensionContainer),
        ])
    PDN_GW_Update._ext = []
    
    #-----< ISR-Information >-----#
    ISR_Information = BIT_STR(name='ISR-Information', mode=MODE_TYPE)
    ISR_Information._cont = ASN1Dict([('updateLocation', 0), ('cancelSGSN', 1), ('initialAttachIndicator', 2)])
    ISR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-Capability >-----#
    SGSN_Capability = SEQ(name='SGSN-Capability', mode=MODE_TYPE)
    _SGSN_Capability_solsaSupportIndicator = NULL(name='solsaSupportIndicator', mode=MODE_TYPE, opt=True)
    _SGSN_Capability_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name='superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _SGSN_Capability_gprsEnhancementsSupportIndicator = NULL(name='gprsEnhancementsSupportIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SGSN_Capability_supportedLCS_CapabilitySets = BIT_STR(name='supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _SGSN_Capability_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SGSN_Capability_smsCallBarringSupportIndicator = NULL(name='smsCallBarringSupportIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedRAT_TypesIndicator = BIT_STR(name='supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _SGSN_Capability_supportedFeatures = BIT_STR(name='supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _SGSN_Capability_t_adsDataRetrieval = NULL(name='t-adsDataRetrieval', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions = BOOL(name='homogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_cancellationTypeInitialAttach = NULL(name='cancellationTypeInitialAttach', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_msisdn_lessOperation_Supported = NULL(name='msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions = NULL(name='updateofHomogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_reset_ids_Supported = NULL(name='reset-ids-Supported', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_ext_SupportedFeatures = BIT_STR(name='ext-SupportedFeatures', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    SGSN_Capability._cont = ASN1Dict([
        ('solsaSupportIndicator', _SGSN_Capability_solsaSupportIndicator),
        ('extensionContainer', _SGSN_Capability_extensionContainer),
        ('superChargerSupportedInServingNetworkEntity', _SGSN_Capability_superChargerSupportedInServingNetworkEntity),
        ('gprsEnhancementsSupportIndicator', _SGSN_Capability_gprsEnhancementsSupportIndicator),
        ('supportedCamelPhases', _SGSN_Capability_supportedCamelPhases),
        ('supportedLCS-CapabilitySets', _SGSN_Capability_supportedLCS_CapabilitySets),
        ('offeredCamel4CSIs', _SGSN_Capability_offeredCamel4CSIs),
        ('smsCallBarringSupportIndicator', _SGSN_Capability_smsCallBarringSupportIndicator),
        ('supportedRAT-TypesIndicator', _SGSN_Capability_supportedRAT_TypesIndicator),
        ('supportedFeatures', _SGSN_Capability_supportedFeatures),
        ('t-adsDataRetrieval', _SGSN_Capability_t_adsDataRetrieval),
        ('homogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions),
        ('cancellationTypeInitialAttach', _SGSN_Capability_cancellationTypeInitialAttach),
        ('msisdn-lessOperation-Supported', _SGSN_Capability_msisdn_lessOperation_Supported),
        ('updateofHomogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions),
        ('reset-ids-Supported', _SGSN_Capability_reset_ids_Supported),
        ('ext-SupportedFeatures', _SGSN_Capability_ext_SupportedFeatures),
        ])
    SGSN_Capability._ext = ['superChargerSupportedInServingNetworkEntity', 'gprsEnhancementsSupportIndicator', 'supportedCamelPhases', 'supportedLCS-CapabilitySets', 'offeredCamel4CSIs', 'smsCallBarringSupportIndicator', 'supportedRAT-TypesIndicator', 'supportedFeatures', 't-adsDataRetrieval', 'homogeneousSupportOfIMSVoiceOverPSSessions', 'cancellationTypeInitialAttach', 'msisdn-lessOperation-Supported', 'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', 'reset-ids-Supported', 'ext-SupportedFeatures']
    
    #-----< SupportedFeatures >-----#
    SupportedFeatures = BIT_STR(name='SupportedFeatures', mode=MODE_TYPE)
    SupportedFeatures._cont = ASN1Dict([('odb-all-apn', 0), ('odb-HPLMN-APN', 1), ('odb-VPLMN-APN', 2), ('odb-all-og', 3), ('odb-all-international-og', 4), ('odb-all-int-og-not-to-HPLMN-country', 5), ('odb-all-interzonal-og', 6), ('odb-all-interzonal-og-not-to-HPLMN-country', 7), ('odb-all-interzonal-og-and-internat-og-not-to-HPLMN-country', 8), ('regSub', 9), ('trace', 10), ('lcs-all-PrivExcep', 11), ('lcs-universal', 12), ('lcs-CallSessionRelated', 13), ('lcs-CallSessionUnrelated', 14), ('lcs-PLMN-operator', 15), ('lcs-ServiceType', 16), ('lcs-all-MOLR-SS', 17), ('lcs-basicSelfLocation', 18), ('lcs-autonomousSelfLocation', 19), ('lcs-transferToThirdParty', 20), ('sm-mo-pp', 21), ('barring-OutgoingCalls', 22), ('baoc', 23), ('boic', 24), ('boicExHC', 25), ('localTimeZoneRetrieval', 26), ('additionalMsisdn', 27), ('smsInMME', 28), ('smsInSGSN', 29), ('ue-Reachability-Notification', 30), ('state-Location-Information-Retrieval', 31), ('partialPurge', 32), ('gddInSGSN', 33), ('sgsnCAMELCapability', 34), ('pcscf-Restoration', 35), ('dedicatedCoreNetworks', 36), ('non-IP-PDN-Type-APNs', 37), ('non-IP-PDP-Type-APNs', 38), ('nrAsSecondaryRAT', 39)])
    SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=26, ub=40)], ev=None, er=[])
    
    #-----< Ext-SupportedFeatures >-----#
    Ext_SupportedFeatures = BIT_STR(name='Ext-SupportedFeatures', mode=MODE_TYPE)
    Ext_SupportedFeatures._cont = ASN1Dict([('unlicensedSpectrumAsSecondaryRAT', 0)])
    Ext_SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    
    #-----< UE-SRVCC-Capability >-----#
    UE_SRVCC_Capability = ENUM(name='UE-SRVCC-Capability', mode=MODE_TYPE)
    UE_SRVCC_Capability._cont = ASN1Dict([('ue-srvcc-not-supported', 0), ('ue-srvcc-supported', 1)])
    UE_SRVCC_Capability._ext = []
    
    #-----< UpdateGprsLocationRes >-----#
    UpdateGprsLocationRes = SEQ(name='UpdateGprsLocationRes', mode=MODE_TYPE)
    _UpdateGprsLocationRes_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationRes_add_Capability = NULL(name='add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateGprsLocationRes_sgsn_mmeSeparationSupported = NULL(name='sgsn-mmeSeparationSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationRes_mmeRegisteredforSMS = NULL(name='mmeRegisteredforSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateGprsLocationRes._cont = ASN1Dict([
        ('hlr-Number', _UpdateGprsLocationRes_hlr_Number),
        ('extensionContainer', _UpdateGprsLocationRes_extensionContainer),
        ('add-Capability', _UpdateGprsLocationRes_add_Capability),
        ('sgsn-mmeSeparationSupported', _UpdateGprsLocationRes_sgsn_mmeSeparationSupported),
        ('mmeRegisteredforSMS', _UpdateGprsLocationRes_mmeRegisteredforSMS),
        ])
    UpdateGprsLocationRes._ext = ['add-Capability', 'sgsn-mmeSeparationSupported', 'mmeRegisteredforSMS']
    
    #-----< EPLMN-List >-----#
    EPLMN_List = SEQ_OF(name='EPLMN-List', mode=MODE_TYPE)
    _EPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    EPLMN_List._cont = _EPLMN_List__item_
    EPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentPLMN-List >-----#
    AdjacentPLMN_List = SEQ_OF(name='AdjacentPLMN-List', mode=MODE_TYPE)
    _AdjacentPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    AdjacentPLMN_List._cont = _AdjacentPLMN_List__item_
    AdjacentPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< ForwardAccessSignalling-Arg >-----#
    ForwardAccessSignalling_Arg = SEQ(name='ForwardAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ForwardAccessSignalling_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ForwardAccessSignalling_Arg_integrityProtectionInfo = OCT_STR(name='integrityProtectionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_encryptionInfo = OCT_STR(name='encryptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_keyStatus = ENUM(name='keyStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'KeyStatus')), opt=True)
    _ForwardAccessSignalling_Arg_allowedGSM_Algorithms = OCT_STR(name='allowedGSM-Algorithms', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms = SEQ(name='allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceInformation = OCT_STR(name='radioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceList = SEQ_OF(name='radioResourceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandover = OCT_STR(name='bssmap-ServiceHandover', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_ranap_ServiceHandover = OCT_STR(name='ranap-ServiceHandover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList = SEQ_OF(name='bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _ForwardAccessSignalling_Arg_currentlyUsedCodec = OCT_STR(name='currentlyUsedCodec', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_iuSupportedCodecsList = SEQ(name='iuSupportedCodecsList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator = NULL(name='rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardAccessSignalling_Arg_iuSelectedCodec = OCT_STR(name='iuSelectedCodec', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_alternativeChannelType = OCT_STR(name='alternativeChannelType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_tracePropagationList = SEQ(name='tracePropagationList', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor = SEQ(name='aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name='aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ForwardAccessSignalling_Arg_uesbi_Iu = SEQ(name='uesbi-Iu', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _ForwardAccessSignalling_Arg_imeisv = OCT_STR(name='imeisv', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ForwardAccessSignalling_Arg._cont = ASN1Dict([
        ('an-APDU', _ForwardAccessSignalling_Arg_an_APDU),
        ('integrityProtectionInfo', _ForwardAccessSignalling_Arg_integrityProtectionInfo),
        ('encryptionInfo', _ForwardAccessSignalling_Arg_encryptionInfo),
        ('keyStatus', _ForwardAccessSignalling_Arg_keyStatus),
        ('allowedGSM-Algorithms', _ForwardAccessSignalling_Arg_allowedGSM_Algorithms),
        ('allowedUMTS-Algorithms', _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms),
        ('radioResourceInformation', _ForwardAccessSignalling_Arg_radioResourceInformation),
        ('extensionContainer', _ForwardAccessSignalling_Arg_extensionContainer),
        ('radioResourceList', _ForwardAccessSignalling_Arg_radioResourceList),
        ('bssmap-ServiceHandover', _ForwardAccessSignalling_Arg_bssmap_ServiceHandover),
        ('ranap-ServiceHandover', _ForwardAccessSignalling_Arg_ranap_ServiceHandover),
        ('bssmap-ServiceHandoverList', _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList),
        ('currentlyUsedCodec', _ForwardAccessSignalling_Arg_currentlyUsedCodec),
        ('iuSupportedCodecsList', _ForwardAccessSignalling_Arg_iuSupportedCodecsList),
        ('rab-ConfigurationIndicator', _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator),
        ('iuSelectedCodec', _ForwardAccessSignalling_Arg_iuSelectedCodec),
        ('alternativeChannelType', _ForwardAccessSignalling_Arg_alternativeChannelType),
        ('tracePropagationList', _ForwardAccessSignalling_Arg_tracePropagationList),
        ('aoipSupportedCodecsListAnchor', _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor),
        ('aoipSelectedCodecTarget', _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget),
        ('uesbi-Iu', _ForwardAccessSignalling_Arg_uesbi_Iu),
        ('imeisv', _ForwardAccessSignalling_Arg_imeisv),
        ])
    ForwardAccessSignalling_Arg._ext = ['radioResourceList', 'bssmap-ServiceHandover', 'ranap-ServiceHandover', 'bssmap-ServiceHandoverList', 'currentlyUsedCodec', 'iuSupportedCodecsList', 'rab-ConfigurationIndicator', 'iuSelectedCodec', 'alternativeChannelType', 'tracePropagationList', 'aoipSupportedCodecsListAnchor', 'aoipSelectedCodecTarget', 'uesbi-Iu', 'imeisv']
    
    #-----< AllowedGSM-Algorithms >-----#
    AllowedGSM_Algorithms = OCT_STR(name='AllowedGSM-Algorithms', mode=MODE_TYPE)
    AllowedGSM_Algorithms._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AllowedUMTS-Algorithms >-----#
    AllowedUMTS_Algorithms = SEQ(name='AllowedUMTS-Algorithms', mode=MODE_TYPE)
    _AllowedUMTS_Algorithms_integrityProtectionAlgorithms = OCT_STR(name='integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedIntegrityProtectionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_encryptionAlgorithms = OCT_STR(name='encryptionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedEncryptionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AllowedUMTS_Algorithms._cont = ASN1Dict([
        ('integrityProtectionAlgorithms', _AllowedUMTS_Algorithms_integrityProtectionAlgorithms),
        ('encryptionAlgorithms', _AllowedUMTS_Algorithms_encryptionAlgorithms),
        ('extensionContainer', _AllowedUMTS_Algorithms_extensionContainer),
        ])
    AllowedUMTS_Algorithms._ext = []
    
    #-----< PermittedIntegrityProtectionAlgorithms >-----#
    PermittedIntegrityProtectionAlgorithms = OCT_STR(name='PermittedIntegrityProtectionAlgorithms', mode=MODE_TYPE)
    PermittedIntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedIntegrityProtectionAlgorithmsLength >-----#
    maxPermittedIntegrityProtectionAlgorithmsLength = INT(name='maxPermittedIntegrityProtectionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedIntegrityProtectionAlgorithmsLength._val = 9
    
    #-----< PermittedEncryptionAlgorithms >-----#
    PermittedEncryptionAlgorithms = OCT_STR(name='PermittedEncryptionAlgorithms', mode=MODE_TYPE)
    PermittedEncryptionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedEncryptionAlgorithmsLength >-----#
    maxPermittedEncryptionAlgorithmsLength = INT(name='maxPermittedEncryptionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedEncryptionAlgorithmsLength._val = 9
    
    #-----< KeyStatus >-----#
    KeyStatus = ENUM(name='KeyStatus', mode=MODE_TYPE)
    KeyStatus._cont = ASN1Dict([('old', 0), ('new', 1)])
    KeyStatus._ext = []
    
    #-----< PrepareHO-Arg >-----#
    PrepareHO_Arg = SEQ(name='PrepareHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Arg_targetCellId = OCT_STR(name='targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareHO_Arg_ho_NumberNotRequired = NULL(name='ho-NumberNotRequired', mode=MODE_TYPE, opt=True)
    _PrepareHO_Arg_targetRNCId = OCT_STR(name='targetRNCId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareHO_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Arg_multipleBearerRequested = NULL(name='multipleBearerRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PrepareHO_Arg_integrityProtectionInfo = OCT_STR(name='integrityProtectionInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _PrepareHO_Arg_encryptionInfo = OCT_STR(name='encryptionInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _PrepareHO_Arg_radioResourceInformation = OCT_STR(name='radioResourceInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_allowedGSM_Algorithms = OCT_STR(name='allowedGSM-Algorithms', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _PrepareHO_Arg_allowedUMTS_Algorithms = SEQ(name='allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _PrepareHO_Arg_radioResourceList = SEQ_OF(name='radioResourceList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _PrepareHO_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Arg_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandover = OCT_STR(name='bssmap-ServiceHandover', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_ranap_ServiceHandover = OCT_STR(name='ranap-ServiceHandover', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandoverList = SEQ_OF(name='bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _PrepareHO_Arg_asciCallReference = OCT_STR(name='asciCallReference', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ASCI-CallReference')), opt=True)
    _PrepareHO_Arg_geran_classmark = OCT_STR(name='geran-classmark', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareHO_Arg_iuCurrentlyUsedCodec = OCT_STR(name='iuCurrentlyUsedCodec', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Arg_iuSupportedCodecsList = SEQ(name='iuSupportedCodecsList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _PrepareHO_Arg_rab_ConfigurationIndicator = NULL(name='rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_uesbi_Iu = SEQ(name='uesbi-Iu', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _PrepareHO_Arg_imeisv = OCT_STR(name='imeisv', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _PrepareHO_Arg_alternativeChannelType = OCT_STR(name='alternativeChannelType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_tracePropagationList = SEQ(name='tracePropagationList', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _PrepareHO_Arg_aoipSupportedCodecsListAnchor = SEQ(name='aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _PrepareHO_Arg_regionalSubscriptionData = SEQ_OF(name='regionalSubscriptionData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _PrepareHO_Arg_lclsGlobalCallReference = OCT_STR(name='lclsGlobalCallReference', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-GlobalCallReference')), opt=True)
    _PrepareHO_Arg_lcls_Negotiation = BIT_STR(name='lcls-Negotiation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-Negotiation')), opt=True)
    _PrepareHO_Arg_lcls_Configuration_Preference = BIT_STR(name='lcls-Configuration-Preference', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-ConfigurationPreference')), opt=True)
    _PrepareHO_Arg_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    PrepareHO_Arg._cont = ASN1Dict([
        ('targetCellId', _PrepareHO_Arg_targetCellId),
        ('ho-NumberNotRequired', _PrepareHO_Arg_ho_NumberNotRequired),
        ('targetRNCId', _PrepareHO_Arg_targetRNCId),
        ('an-APDU', _PrepareHO_Arg_an_APDU),
        ('multipleBearerRequested', _PrepareHO_Arg_multipleBearerRequested),
        ('imsi', _PrepareHO_Arg_imsi),
        ('integrityProtectionInfo', _PrepareHO_Arg_integrityProtectionInfo),
        ('encryptionInfo', _PrepareHO_Arg_encryptionInfo),
        ('radioResourceInformation', _PrepareHO_Arg_radioResourceInformation),
        ('allowedGSM-Algorithms', _PrepareHO_Arg_allowedGSM_Algorithms),
        ('allowedUMTS-Algorithms', _PrepareHO_Arg_allowedUMTS_Algorithms),
        ('radioResourceList', _PrepareHO_Arg_radioResourceList),
        ('extensionContainer', _PrepareHO_Arg_extensionContainer),
        ('rab-Id', _PrepareHO_Arg_rab_Id),
        ('bssmap-ServiceHandover', _PrepareHO_Arg_bssmap_ServiceHandover),
        ('ranap-ServiceHandover', _PrepareHO_Arg_ranap_ServiceHandover),
        ('bssmap-ServiceHandoverList', _PrepareHO_Arg_bssmap_ServiceHandoverList),
        ('asciCallReference', _PrepareHO_Arg_asciCallReference),
        ('geran-classmark', _PrepareHO_Arg_geran_classmark),
        ('iuCurrentlyUsedCodec', _PrepareHO_Arg_iuCurrentlyUsedCodec),
        ('iuSupportedCodecsList', _PrepareHO_Arg_iuSupportedCodecsList),
        ('rab-ConfigurationIndicator', _PrepareHO_Arg_rab_ConfigurationIndicator),
        ('uesbi-Iu', _PrepareHO_Arg_uesbi_Iu),
        ('imeisv', _PrepareHO_Arg_imeisv),
        ('alternativeChannelType', _PrepareHO_Arg_alternativeChannelType),
        ('tracePropagationList', _PrepareHO_Arg_tracePropagationList),
        ('aoipSupportedCodecsListAnchor', _PrepareHO_Arg_aoipSupportedCodecsListAnchor),
        ('regionalSubscriptionData', _PrepareHO_Arg_regionalSubscriptionData),
        ('lclsGlobalCallReference', _PrepareHO_Arg_lclsGlobalCallReference),
        ('lcls-Negotiation', _PrepareHO_Arg_lcls_Negotiation),
        ('lcls-Configuration-Preference', _PrepareHO_Arg_lcls_Configuration_Preference),
        ('csg-SubscriptionDataList', _PrepareHO_Arg_csg_SubscriptionDataList),
        ])
    PrepareHO_Arg._ext = ['rab-Id', 'bssmap-ServiceHandover', 'ranap-ServiceHandover', 'bssmap-ServiceHandoverList', 'asciCallReference', 'geran-classmark', 'iuCurrentlyUsedCodec', 'iuSupportedCodecsList', 'rab-ConfigurationIndicator', 'uesbi-Iu', 'imeisv', 'alternativeChannelType', 'tracePropagationList', 'aoipSupportedCodecsListAnchor', 'regionalSubscriptionData', 'lclsGlobalCallReference', 'lcls-Negotiation', 'lcls-Configuration-Preference', 'csg-SubscriptionDataList']
    
    #-----< LCLS-GlobalCallReference >-----#
    LCLS_GlobalCallReference = OCT_STR(name='LCLS-GlobalCallReference', mode=MODE_TYPE)
    LCLS_GlobalCallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=13, ub=15)], ev=None, er=[])
    
    #-----< LCLS-Negotiation >-----#
    LCLS_Negotiation = BIT_STR(name='LCLS-Negotiation', mode=MODE_TYPE)
    LCLS_Negotiation._cont = ASN1Dict([('permission-indicator-not-allowed-bit', 0), ('permission-indicator-spare-bit', 1)])
    LCLS_Negotiation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< LCLS-ConfigurationPreference >-----#
    LCLS_ConfigurationPreference = BIT_STR(name='LCLS-ConfigurationPreference', mode=MODE_TYPE)
    LCLS_ConfigurationPreference._cont = ASN1Dict([('forward-data-sending-indicator', 0), ('backward-data-sending-indicator', 1), ('forward-data-reception-indicator', 2), ('backward-data-reception-indicator', 3)])
    LCLS_ConfigurationPreference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverList >-----#
    BSSMAP_ServiceHandoverList = SEQ_OF(name='BSSMAP-ServiceHandoverList', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverInfo')))
    BSSMAP_ServiceHandoverList._cont = _BSSMAP_ServiceHandoverList__item_
    BSSMAP_ServiceHandoverList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverInfo >-----#
    BSSMAP_ServiceHandoverInfo = SEQ(name='BSSMAP-ServiceHandoverInfo', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover = OCT_STR(name='bssmap-ServiceHandover', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')))
    _BSSMAP_ServiceHandoverInfo_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    BSSMAP_ServiceHandoverInfo._cont = ASN1Dict([
        ('bssmap-ServiceHandover', _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover),
        ('rab-Id', _BSSMAP_ServiceHandoverInfo_rab_Id),
        ])
    BSSMAP_ServiceHandoverInfo._ext = []
    
    #-----< maxNumOfServiceHandovers >-----#
    maxNumOfServiceHandovers = INT(name='maxNumOfServiceHandovers', mode=MODE_VALUE)
    maxNumOfServiceHandovers._val = 7
    
    #-----< BSSMAP-ServiceHandover >-----#
    BSSMAP_ServiceHandover = OCT_STR(name='BSSMAP-ServiceHandover', mode=MODE_TYPE)
    BSSMAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RANAP-ServiceHandover >-----#
    RANAP_ServiceHandover = OCT_STR(name='RANAP-ServiceHandover', mode=MODE_TYPE)
    RANAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RadioResourceList >-----#
    RadioResourceList = SEQ_OF(name='RadioResourceList', mode=MODE_TYPE)
    _RadioResourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResource')))
    RadioResourceList._cont = _RadioResourceList__item_
    RadioResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RadioResource >-----#
    RadioResource = SEQ(name='RadioResource', mode=MODE_TYPE)
    _RadioResource_radioResourceInformation = OCT_STR(name='radioResourceInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')))
    _RadioResource_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RadioResource._cont = ASN1Dict([
        ('radioResourceInformation', _RadioResource_radioResourceInformation),
        ('rab-Id', _RadioResource_rab_Id),
        ])
    RadioResource._ext = []
    
    #-----< maxNumOfRadioResources >-----#
    maxNumOfRadioResources = INT(name='maxNumOfRadioResources', mode=MODE_VALUE)
    maxNumOfRadioResources._val = 7
    
    #-----< PrepareHO-Res >-----#
    PrepareHO_Res = SEQ(name='PrepareHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Res_handoverNumber = OCT_STR(name='handoverNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PrepareHO_Res_relocationNumberList = SEQ_OF(name='relocationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumberList')), opt=True)
    _PrepareHO_Res_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Res_multicallBearerInfo = INT(name='multicallBearerInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MulticallBearerInfo')), opt=True)
    _PrepareHO_Res_multipleBearerNotSupported = NULL(name='multipleBearerNotSupported', mode=MODE_TYPE, opt=True)
    _PrepareHO_Res_selectedUMTS_Algorithms = SEQ(name='selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _PrepareHO_Res_chosenRadioResourceInformation = SEQ(name='chosenRadioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _PrepareHO_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Res_iuSelectedCodec = OCT_STR(name='iuSelectedCodec', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Res_iuAvailableCodecsList = SEQ(name='iuAvailableCodecsList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _PrepareHO_Res_aoipSelectedCodecTarget = OCT_STR(name='aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _PrepareHO_Res_aoipAvailableCodecsListMap = SEQ(name='aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    PrepareHO_Res._cont = ASN1Dict([
        ('handoverNumber', _PrepareHO_Res_handoverNumber),
        ('relocationNumberList', _PrepareHO_Res_relocationNumberList),
        ('an-APDU', _PrepareHO_Res_an_APDU),
        ('multicallBearerInfo', _PrepareHO_Res_multicallBearerInfo),
        ('multipleBearerNotSupported', _PrepareHO_Res_multipleBearerNotSupported),
        ('selectedUMTS-Algorithms', _PrepareHO_Res_selectedUMTS_Algorithms),
        ('chosenRadioResourceInformation', _PrepareHO_Res_chosenRadioResourceInformation),
        ('extensionContainer', _PrepareHO_Res_extensionContainer),
        ('iuSelectedCodec', _PrepareHO_Res_iuSelectedCodec),
        ('iuAvailableCodecsList', _PrepareHO_Res_iuAvailableCodecsList),
        ('aoipSelectedCodecTarget', _PrepareHO_Res_aoipSelectedCodecTarget),
        ('aoipAvailableCodecsListMap', _PrepareHO_Res_aoipAvailableCodecsListMap),
        ])
    PrepareHO_Res._ext = ['iuSelectedCodec', 'iuAvailableCodecsList', 'aoipSelectedCodecTarget', 'aoipAvailableCodecsListMap']
    
    #-----< SelectedUMTS-Algorithms >-----#
    SelectedUMTS_Algorithms = SEQ(name='SelectedUMTS-Algorithms', mode=MODE_TYPE)
    _SelectedUMTS_Algorithms_integrityProtectionAlgorithm = OCT_STR(name='integrityProtectionAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenIntegrityProtectionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_encryptionAlgorithm = OCT_STR(name='encryptionAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenEncryptionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SelectedUMTS_Algorithms._cont = ASN1Dict([
        ('integrityProtectionAlgorithm', _SelectedUMTS_Algorithms_integrityProtectionAlgorithm),
        ('encryptionAlgorithm', _SelectedUMTS_Algorithms_encryptionAlgorithm),
        ('extensionContainer', _SelectedUMTS_Algorithms_extensionContainer),
        ])
    SelectedUMTS_Algorithms._ext = []
    
    #-----< ChosenIntegrityProtectionAlgorithm >-----#
    ChosenIntegrityProtectionAlgorithm = OCT_STR(name='ChosenIntegrityProtectionAlgorithm', mode=MODE_TYPE)
    ChosenIntegrityProtectionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenEncryptionAlgorithm >-----#
    ChosenEncryptionAlgorithm = OCT_STR(name='ChosenEncryptionAlgorithm', mode=MODE_TYPE)
    ChosenEncryptionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenRadioResourceInformation >-----#
    ChosenRadioResourceInformation = SEQ(name='ChosenRadioResourceInformation', mode=MODE_TYPE)
    _ChosenRadioResourceInformation_chosenChannelInfo = OCT_STR(name='chosenChannelInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenChannelInfo')), opt=True)
    _ChosenRadioResourceInformation_chosenSpeechVersion = OCT_STR(name='chosenSpeechVersion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenSpeechVersion')), opt=True)
    ChosenRadioResourceInformation._cont = ASN1Dict([
        ('chosenChannelInfo', _ChosenRadioResourceInformation_chosenChannelInfo),
        ('chosenSpeechVersion', _ChosenRadioResourceInformation_chosenSpeechVersion),
        ])
    ChosenRadioResourceInformation._ext = []
    
    #-----< ChosenChannelInfo >-----#
    ChosenChannelInfo = OCT_STR(name='ChosenChannelInfo', mode=MODE_TYPE)
    ChosenChannelInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenSpeechVersion >-----#
    ChosenSpeechVersion = OCT_STR(name='ChosenSpeechVersion', mode=MODE_TYPE)
    ChosenSpeechVersion._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PrepareSubsequentHO-Arg >-----#
    PrepareSubsequentHO_Arg = SEQ(name='PrepareSubsequentHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Arg_targetCellId = OCT_STR(name='targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareSubsequentHO_Arg_targetMSC_Number = OCT_STR(name='targetMSC-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _PrepareSubsequentHO_Arg_targetRNCId = OCT_STR(name='targetRNCId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareSubsequentHO_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareSubsequentHO_Arg_selectedRab_Id = INT(name='selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareSubsequentHO_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareSubsequentHO_Arg_geran_classmark = OCT_STR(name='geran-classmark', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator = NULL(name='rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrepareSubsequentHO_Arg._cont = ASN1Dict([
        ('targetCellId', _PrepareSubsequentHO_Arg_targetCellId),
        ('targetMSC-Number', _PrepareSubsequentHO_Arg_targetMSC_Number),
        ('targetRNCId', _PrepareSubsequentHO_Arg_targetRNCId),
        ('an-APDU', _PrepareSubsequentHO_Arg_an_APDU),
        ('selectedRab-Id', _PrepareSubsequentHO_Arg_selectedRab_Id),
        ('extensionContainer', _PrepareSubsequentHO_Arg_extensionContainer),
        ('geran-classmark', _PrepareSubsequentHO_Arg_geran_classmark),
        ('rab-ConfigurationIndicator', _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator),
        ])
    PrepareSubsequentHO_Arg._ext = ['geran-classmark', 'rab-ConfigurationIndicator']
    
    #-----< PrepareSubsequentHO-Res >-----#
    PrepareSubsequentHO_Res = SEQ(name='PrepareSubsequentHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Res_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _PrepareSubsequentHO_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PrepareSubsequentHO_Res._cont = ASN1Dict([
        ('an-APDU', _PrepareSubsequentHO_Res_an_APDU),
        ('extensionContainer', _PrepareSubsequentHO_Res_extensionContainer),
        ])
    PrepareSubsequentHO_Res._ext = []
    
    #-----< ProcessAccessSignalling-Arg >-----#
    ProcessAccessSignalling_Arg = SEQ(name='ProcessAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProcessAccessSignalling_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms = SEQ(name='selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _ProcessAccessSignalling_Arg_selectedGSM_Algorithm = OCT_STR(name='selectedGSM-Algorithm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedGSM-Algorithm')), opt=True)
    _ProcessAccessSignalling_Arg_chosenRadioResourceInformation = SEQ(name='chosenRadioResourceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _ProcessAccessSignalling_Arg_selectedRab_Id = INT(name='selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _ProcessAccessSignalling_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProcessAccessSignalling_Arg_iUSelectedCodec = OCT_STR(name='iUSelectedCodec', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ProcessAccessSignalling_Arg_iuAvailableCodecsList = SEQ(name='iuAvailableCodecsList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name='aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap = SEQ(name='aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    ProcessAccessSignalling_Arg._cont = ASN1Dict([
        ('an-APDU', _ProcessAccessSignalling_Arg_an_APDU),
        ('selectedUMTS-Algorithms', _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms),
        ('selectedGSM-Algorithm', _ProcessAccessSignalling_Arg_selectedGSM_Algorithm),
        ('chosenRadioResourceInformation', _ProcessAccessSignalling_Arg_chosenRadioResourceInformation),
        ('selectedRab-Id', _ProcessAccessSignalling_Arg_selectedRab_Id),
        ('extensionContainer', _ProcessAccessSignalling_Arg_extensionContainer),
        ('iUSelectedCodec', _ProcessAccessSignalling_Arg_iUSelectedCodec),
        ('iuAvailableCodecsList', _ProcessAccessSignalling_Arg_iuAvailableCodecsList),
        ('aoipSelectedCodecTarget', _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget),
        ('aoipAvailableCodecsListMap', _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap),
        ])
    ProcessAccessSignalling_Arg._ext = ['iUSelectedCodec', 'iuAvailableCodecsList', 'aoipSelectedCodecTarget', 'aoipAvailableCodecsListMap']
    
    #-----< AoIPCodecsList >-----#
    AoIPCodecsList = SEQ(name='AoIPCodecsList', mode=MODE_TYPE)
    _AoIPCodecsList_codec1 = OCT_STR(name='codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')))
    _AoIPCodecsList_codec2 = OCT_STR(name='codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec3 = OCT_STR(name='codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec4 = OCT_STR(name='codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec5 = OCT_STR(name='codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec6 = OCT_STR(name='codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec7 = OCT_STR(name='codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec8 = OCT_STR(name='codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AoIPCodecsList._cont = ASN1Dict([
        ('codec1', _AoIPCodecsList_codec1),
        ('codec2', _AoIPCodecsList_codec2),
        ('codec3', _AoIPCodecsList_codec3),
        ('codec4', _AoIPCodecsList_codec4),
        ('codec5', _AoIPCodecsList_codec5),
        ('codec6', _AoIPCodecsList_codec6),
        ('codec7', _AoIPCodecsList_codec7),
        ('codec8', _AoIPCodecsList_codec8),
        ('extensionContainer', _AoIPCodecsList_extensionContainer),
        ])
    AoIPCodecsList._ext = []
    
    #-----< AoIPCodec >-----#
    AoIPCodec = OCT_STR(name='AoIPCodec', mode=MODE_TYPE)
    AoIPCodec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SupportedCodecsList >-----#
    SupportedCodecsList = SEQ(name='SupportedCodecsList', mode=MODE_TYPE)
    _SupportedCodecsList_utranCodecList = SEQ(name='utranCodecList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_geranCodecList = SEQ(name='geranCodecList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SupportedCodecsList._cont = ASN1Dict([
        ('utranCodecList', _SupportedCodecsList_utranCodecList),
        ('geranCodecList', _SupportedCodecsList_geranCodecList),
        ('extensionContainer', _SupportedCodecsList_extensionContainer),
        ])
    SupportedCodecsList._ext = []
    
    #-----< CodecList >-----#
    CodecList = SEQ(name='CodecList', mode=MODE_TYPE)
    _CodecList_codec1 = OCT_STR(name='codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')))
    _CodecList_codec2 = OCT_STR(name='codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec3 = OCT_STR(name='codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec4 = OCT_STR(name='codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec5 = OCT_STR(name='codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec6 = OCT_STR(name='codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec7 = OCT_STR(name='codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec8 = OCT_STR(name='codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CodecList._cont = ASN1Dict([
        ('codec1', _CodecList_codec1),
        ('codec2', _CodecList_codec2),
        ('codec3', _CodecList_codec3),
        ('codec4', _CodecList_codec4),
        ('codec5', _CodecList_codec5),
        ('codec6', _CodecList_codec6),
        ('codec7', _CodecList_codec7),
        ('codec8', _CodecList_codec8),
        ('extensionContainer', _CodecList_extensionContainer),
        ])
    CodecList._ext = []
    
    #-----< Codec >-----#
    Codec = OCT_STR(name='Codec', mode=MODE_TYPE)
    Codec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< GERAN-Classmark >-----#
    GERAN_Classmark = OCT_STR(name='GERAN-Classmark', mode=MODE_TYPE)
    GERAN_Classmark._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=87)], ev=None, er=[])
    
    #-----< SelectedGSM-Algorithm >-----#
    SelectedGSM_Algorithm = OCT_STR(name='SelectedGSM-Algorithm', mode=MODE_TYPE)
    SelectedGSM_Algorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendEndSignal-Arg >-----#
    SendEndSignal_Arg = SEQ(name='SendEndSignal-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendEndSignal_Arg_an_APDU = SEQ(name='an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _SendEndSignal_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Arg._cont = ASN1Dict([
        ('an-APDU', _SendEndSignal_Arg_an_APDU),
        ('extensionContainer', _SendEndSignal_Arg_extensionContainer),
        ])
    SendEndSignal_Arg._ext = []
    
    #-----< SendEndSignal-Res >-----#
    SendEndSignal_Res = SEQ(name='SendEndSignal-Res', mode=MODE_TYPE)
    _SendEndSignal_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Res._cont = ASN1Dict([
        ('extensionContainer', _SendEndSignal_Res_extensionContainer),
        ])
    SendEndSignal_Res._ext = []
    
    #-----< RNCId >-----#
    RNCId = OCT_STR(name='RNCId', mode=MODE_TYPE)
    RNCId._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< RelocationNumberList >-----#
    RelocationNumberList = SEQ_OF(name='RelocationNumberList', mode=MODE_TYPE)
    _RelocationNumberList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumber')))
    RelocationNumberList._cont = _RelocationNumberList__item_
    RelocationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< MulticallBearerInfo >-----#
    MulticallBearerInfo = INT(name='MulticallBearerInfo', mode=MODE_TYPE)
    MulticallBearerInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RelocationNumber >-----#
    RelocationNumber = SEQ(name='RelocationNumber', mode=MODE_TYPE)
    _RelocationNumber_handoverNumber = OCT_STR(name='handoverNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RelocationNumber_rab_Id = INT(name='rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RelocationNumber._cont = ASN1Dict([
        ('handoverNumber', _RelocationNumber_handoverNumber),
        ('rab-Id', _RelocationNumber_rab_Id),
        ])
    RelocationNumber._ext = []
    
    #-----< RAB-Id >-----#
    RAB_Id = INT(name='RAB-Id', mode=MODE_TYPE)
    RAB_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< maxNrOfRABs >-----#
    maxNrOfRABs = INT(name='maxNrOfRABs', mode=MODE_VALUE)
    maxNrOfRABs._val = 255
    
    #-----< maxNumOfRelocationNumber >-----#
    maxNumOfRelocationNumber = INT(name='maxNumOfRelocationNumber', mode=MODE_VALUE)
    maxNumOfRelocationNumber._val = 7
    
    #-----< RadioResourceInformation >-----#
    RadioResourceInformation = OCT_STR(name='RadioResourceInformation', mode=MODE_TYPE)
    RadioResourceInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=13)], ev=None, er=[])
    
    #-----< IntegrityProtectionInformation >-----#
    IntegrityProtectionInformation = OCT_STR(name='IntegrityProtectionInformation', mode=MODE_TYPE)
    IntegrityProtectionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfIntegrityInfo >-----#
    maxNumOfIntegrityInfo = INT(name='maxNumOfIntegrityInfo', mode=MODE_VALUE)
    maxNumOfIntegrityInfo._val = 100
    
    #-----< EncryptionInformation >-----#
    EncryptionInformation = OCT_STR(name='EncryptionInformation', mode=MODE_TYPE)
    EncryptionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfEncryptionInfo >-----#
    maxNumOfEncryptionInfo = INT(name='maxNumOfEncryptionInfo', mode=MODE_VALUE)
    maxNumOfEncryptionInfo._val = 100
    
    #-----< SendAuthenticationInfoArg >-----#
    SendAuthenticationInfoArg = SEQ(name='SendAuthenticationInfoArg', mode=MODE_TYPE)
    _SendAuthenticationInfoArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendAuthenticationInfoArg_numberOfRequestedVectors = INT(name='numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')))
    _SendAuthenticationInfoArg_segmentationProhibited = NULL(name='segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendAuthenticationInfoArg_immediateResponsePreferred = NULL(name='immediateResponsePreferred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_re_synchronisationInfo = SEQ(name='re-synchronisationInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Re-synchronisationInfo')), opt=True)
    _SendAuthenticationInfoArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoArg_requestingNodeType = ENUM(name='requestingNodeType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestingNodeType')), opt=True)
    _SendAuthenticationInfoArg_requestingPLMN_Id = OCT_STR(name='requestingPLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors = INT(name='numberOfRequestedAdditional-Vectors', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendAuthenticationInfoArg_additionalVectorsAreForEPS = NULL(name='additionalVectorsAreForEPS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_ueUsageTypeRequestIndication = NULL(name='ueUsageTypeRequestIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendAuthenticationInfoArg._cont = ASN1Dict([
        ('imsi', _SendAuthenticationInfoArg_imsi),
        ('numberOfRequestedVectors', _SendAuthenticationInfoArg_numberOfRequestedVectors),
        ('segmentationProhibited', _SendAuthenticationInfoArg_segmentationProhibited),
        ('immediateResponsePreferred', _SendAuthenticationInfoArg_immediateResponsePreferred),
        ('re-synchronisationInfo', _SendAuthenticationInfoArg_re_synchronisationInfo),
        ('extensionContainer', _SendAuthenticationInfoArg_extensionContainer),
        ('requestingNodeType', _SendAuthenticationInfoArg_requestingNodeType),
        ('requestingPLMN-Id', _SendAuthenticationInfoArg_requestingPLMN_Id),
        ('numberOfRequestedAdditional-Vectors', _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors),
        ('additionalVectorsAreForEPS', _SendAuthenticationInfoArg_additionalVectorsAreForEPS),
        ('ueUsageTypeRequestIndication', _SendAuthenticationInfoArg_ueUsageTypeRequestIndication),
        ])
    SendAuthenticationInfoArg._ext = ['requestingNodeType', 'requestingPLMN-Id', 'numberOfRequestedAdditional-Vectors', 'additionalVectorsAreForEPS', 'ueUsageTypeRequestIndication']
    
    #-----< NumberOfRequestedVectors >-----#
    NumberOfRequestedVectors = INT(name='NumberOfRequestedVectors', mode=MODE_TYPE)
    NumberOfRequestedVectors._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Re-synchronisationInfo >-----#
    Re_synchronisationInfo = SEQ(name='Re-synchronisationInfo', mode=MODE_TYPE)
    _Re_synchronisationInfo_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _Re_synchronisationInfo_auts = OCT_STR(name='auts', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTS')))
    Re_synchronisationInfo._cont = ASN1Dict([
        ('rand', _Re_synchronisationInfo_rand),
        ('auts', _Re_synchronisationInfo_auts),
        ])
    Re_synchronisationInfo._ext = []
    
    #-----< SendAuthenticationInfoRes >-----#
    SendAuthenticationInfoRes = SEQ(name='SendAuthenticationInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendAuthenticationInfoRes_authenticationSetList = CHOICE(name='authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoRes_eps_AuthenticationSetList = SEQ_OF(name='eps-AuthenticationSetList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_ueUsageType = OCT_STR(name='ueUsageType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    SendAuthenticationInfoRes._cont = ASN1Dict([
        ('authenticationSetList', _SendAuthenticationInfoRes_authenticationSetList),
        ('extensionContainer', _SendAuthenticationInfoRes_extensionContainer),
        ('eps-AuthenticationSetList', _SendAuthenticationInfoRes_eps_AuthenticationSetList),
        ('ueUsageType', _SendAuthenticationInfoRes_ueUsageType),
        ])
    SendAuthenticationInfoRes._ext = ['eps-AuthenticationSetList', 'ueUsageType']
    
    #-----< EPS-AuthenticationSetList >-----#
    EPS_AuthenticationSetList = SEQ_OF(name='EPS-AuthenticationSetList', mode=MODE_TYPE)
    _EPS_AuthenticationSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPC-AV')))
    EPS_AuthenticationSetList._cont = _EPS_AuthenticationSetList__item_
    EPS_AuthenticationSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< UE-UsageType >-----#
    UE_UsageType = OCT_STR(name='UE-UsageType', mode=MODE_TYPE)
    UE_UsageType._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< EPC-AV >-----#
    EPC_AV = SEQ(name='EPC-AV', mode=MODE_TYPE)
    _EPC_AV_rand = OCT_STR(name='rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _EPC_AV_xres = OCT_STR(name='xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _EPC_AV_autn = OCT_STR(name='autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    _EPC_AV_kasme = OCT_STR(name='kasme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KASME')))
    _EPC_AV_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPC_AV._cont = ASN1Dict([
        ('rand', _EPC_AV_rand),
        ('xres', _EPC_AV_xres),
        ('autn', _EPC_AV_autn),
        ('kasme', _EPC_AV_kasme),
        ('extensionContainer', _EPC_AV_extensionContainer),
        ])
    EPC_AV._ext = []
    
    #-----< KASME >-----#
    KASME = OCT_STR(name='KASME', mode=MODE_TYPE)
    KASME._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< RequestingNodeType >-----#
    RequestingNodeType = ENUM(name='RequestingNodeType', mode=MODE_TYPE)
    RequestingNodeType._cont = ASN1Dict([('vlr', 0), ('sgsn', 1), ('s-cscf', 2), ('bsf', 3), ('gan-aaa-server', 4), ('wlan-aaa-server', 5), ('mme', 16), ('mme-sgsn', 17)])
    RequestingNodeType._ext = ['s-cscf', 'bsf', 'gan-aaa-server', 'wlan-aaa-server', 'mme', 'mme-sgsn']
    
    #-----< CheckIMEI-Arg >-----#
    CheckIMEI_Arg = SEQ(name='CheckIMEI-Arg', mode=MODE_TYPE)
    _CheckIMEI_Arg_imei = OCT_STR(name='imei', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _CheckIMEI_Arg_requestedEquipmentInfo = BIT_STR(name='requestedEquipmentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedEquipmentInfo')))
    _CheckIMEI_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Arg._cont = ASN1Dict([
        ('imei', _CheckIMEI_Arg_imei),
        ('requestedEquipmentInfo', _CheckIMEI_Arg_requestedEquipmentInfo),
        ('extensionContainer', _CheckIMEI_Arg_extensionContainer),
        ])
    CheckIMEI_Arg._ext = []
    
    #-----< CheckIMEI-Res >-----#
    CheckIMEI_Res = SEQ(name='CheckIMEI-Res', mode=MODE_TYPE)
    _CheckIMEI_Res_equipmentStatus = ENUM(name='equipmentStatus', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EquipmentStatus')), opt=True)
    _CheckIMEI_Res_bmuef = SEQ(name='bmuef', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _CheckIMEI_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Res._cont = ASN1Dict([
        ('equipmentStatus', _CheckIMEI_Res_equipmentStatus),
        ('bmuef', _CheckIMEI_Res_bmuef),
        ('extensionContainer', _CheckIMEI_Res_extensionContainer),
        ])
    CheckIMEI_Res._ext = []
    
    #-----< RequestedEquipmentInfo >-----#
    RequestedEquipmentInfo = BIT_STR(name='RequestedEquipmentInfo', mode=MODE_TYPE)
    RequestedEquipmentInfo._cont = ASN1Dict([('equipmentStatus', 0), ('bmuef', 1)])
    RequestedEquipmentInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UESBI-Iu >-----#
    UESBI_Iu = SEQ(name='UESBI-Iu', mode=MODE_TYPE)
    _UESBI_Iu_uesbi_IuA = BIT_STR(name='uesbi-IuA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuA')), opt=True)
    _UESBI_Iu_uesbi_IuB = BIT_STR(name='uesbi-IuB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuB')), opt=True)
    UESBI_Iu._cont = ASN1Dict([
        ('uesbi-IuA', _UESBI_Iu_uesbi_IuA),
        ('uesbi-IuB', _UESBI_Iu_uesbi_IuB),
        ])
    UESBI_Iu._ext = []
    
    #-----< UESBI-IuA >-----#
    UESBI_IuA = BIT_STR(name='UESBI-IuA', mode=MODE_TYPE)
    UESBI_IuA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UESBI-IuB >-----#
    UESBI_IuB = BIT_STR(name='UESBI-IuB', mode=MODE_TYPE)
    UESBI_IuB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< EquipmentStatus >-----#
    EquipmentStatus = ENUM(name='EquipmentStatus', mode=MODE_TYPE)
    EquipmentStatus._cont = ASN1Dict([('whiteListed', 0), ('blackListed', 1), ('greyListed', 2)])
    EquipmentStatus._ext = None
    
    #-----< InsertSubscriberDataArg >-----#
    InsertSubscriberDataArg = SEQ(name='InsertSubscriberDataArg', mode=MODE_TYPE)
    _InsertSubscriberDataArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _InsertSubscriberDataArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_category = OCT_STR(name='category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _InsertSubscriberDataArg_subscriberStatus = ENUM(name='subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _InsertSubscriberDataArg_bearerServiceList = SEQ_OF(name='bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataArg_teleserviceList = SEQ_OF(name='teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataArg_provisionedSS = SEQ_OF(name='provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _InsertSubscriberDataArg_odb_Data = SEQ(name='odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name='roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_regionalSubscriptionData = SEQ_OF(name='regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _InsertSubscriberDataArg_vbsSubscriptionData = SEQ_OF(name='vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _InsertSubscriberDataArg_vgcsSubscriptionData = SEQ_OF(name='vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _InsertSubscriberDataArg_vlrCamelSubscriptionInfo = SEQ(name='vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataArg_naea_PreferredCI = SEQ(name='naea-PreferredCI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _InsertSubscriberDataArg_gprsSubscriptionData = SEQ(name='gprsSubscriptionData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionData')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature = NULL(name='roamingRestrictedInSgsnDueToUnsupportedFeature', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_networkAccessMode = ENUM(name='networkAccessMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NetworkAccessMode')), opt=True)
    _InsertSubscriberDataArg_lsaInformation = SEQ(name='lsaInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformation')), opt=True)
    _InsertSubscriberDataArg_lmu_Indicator = NULL(name='lmu-Indicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_lcsInformation = SEQ(name='lcsInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCSInformation')), opt=True)
    _InsertSubscriberDataArg_istAlertTimer = INT(name='istAlertTimer', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _InsertSubscriberDataArg_superChargerSupportedInHLR = OCT_STR(name='superChargerSupportedInHLR', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')), opt=True)
    _InsertSubscriberDataArg_mc_SS_Info = SEQ(name='mc-SS-Info', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-SS-Info')), opt=True)
    _InsertSubscriberDataArg_cs_AllocationRetentionPriority = OCT_STR(name='cs-AllocationRetentionPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CS-AllocationRetentionPriority')), opt=True)
    _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo = SEQ(name='sgsn-CAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-CAMEL-SubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _InsertSubscriberDataArg_accessRestrictionData = BIT_STR(name='accessRestrictionData', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_ics_Indicator = BOOL(name='ics-Indicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_eps_SubscriptionData = SEQ(name='eps-SubscriptionData', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionData')), opt=True)
    _InsertSubscriberDataArg_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator = NULL(name='ue-ReachabilityRequestIndicator', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_mme_Name = OCT_STR(name='mme-Name', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer = INT(name='subscribedPeriodicRAUTAUtimer', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicRAUTAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmnLIPAAllowed = NULL(name='vplmnLIPAAllowed', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_mdtUserConsent = BOOL(name='mdtUserConsent', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicLAUtimer = INT(name='subscribedPeriodicLAUtimer', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicLAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList = SEQ_OF(name='vplmn-Csg-SubscriptionDataList', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VPLMN-CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_additionalMSISDN = OCT_STR(name='additionalMSISDN', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision = NULL(name='psAndSMS-OnlyServiceProvision', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_smsInSGSNAllowed = NULL(name='smsInSGSNAllowed', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator = NULL(name='cs-to-ps-SRVCC-Allowed-Indicator', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_pcscf_Restoration_Request = NULL(name='pcscf-Restoration-Request', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_adjacentAccessRestrictionDataList = SEQ_OF(name='adjacentAccessRestrictionDataList', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionDataList')), opt=True)
    _InsertSubscriberDataArg_imsi_Group_Id_List = SEQ_OF(name='imsi-Group-Id-List', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupIdList')), opt=True)
    _InsertSubscriberDataArg_ueUsageType = OCT_STR(name='ueUsageType', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator = NULL(name='userPlaneIntegrityProtectionIndicator', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count = INT(name='dl-Buffering-Suggested-Packet-Count', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DL-Buffering-Suggested-Packet-Count')), opt=True)
    _InsertSubscriberDataArg_reset_Id_List = SEQ_OF(name='reset-Id-List', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _InsertSubscriberDataArg_eDRX_Cycle_Length_List = SEQ_OF(name='eDRX-Cycle-Length-List', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-List')), opt=True)
    _InsertSubscriberDataArg_ext_AccessRestrictionData = BIT_STR(name='ext-AccessRestrictionData', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator = NULL(name='iab-Operation-Allowed-Indicator', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    InsertSubscriberDataArg._cont = ASN1Dict([
        ('imsi', _InsertSubscriberDataArg_imsi),
        ('msisdn', _InsertSubscriberDataArg_msisdn),
        ('category', _InsertSubscriberDataArg_category),
        ('subscriberStatus', _InsertSubscriberDataArg_subscriberStatus),
        ('bearerServiceList', _InsertSubscriberDataArg_bearerServiceList),
        ('teleserviceList', _InsertSubscriberDataArg_teleserviceList),
        ('provisionedSS', _InsertSubscriberDataArg_provisionedSS),
        ('odb-Data', _InsertSubscriberDataArg_odb_Data),
        ('roamingRestrictionDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        ('regionalSubscriptionData', _InsertSubscriberDataArg_regionalSubscriptionData),
        ('vbsSubscriptionData', _InsertSubscriberDataArg_vbsSubscriptionData),
        ('vgcsSubscriptionData', _InsertSubscriberDataArg_vgcsSubscriptionData),
        ('vlrCamelSubscriptionInfo', _InsertSubscriberDataArg_vlrCamelSubscriptionInfo),
        ('extensionContainer', _InsertSubscriberDataArg_extensionContainer),
        ('naea-PreferredCI', _InsertSubscriberDataArg_naea_PreferredCI),
        ('gprsSubscriptionData', _InsertSubscriberDataArg_gprsSubscriptionData),
        ('roamingRestrictedInSgsnDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature),
        ('networkAccessMode', _InsertSubscriberDataArg_networkAccessMode),
        ('lsaInformation', _InsertSubscriberDataArg_lsaInformation),
        ('lmu-Indicator', _InsertSubscriberDataArg_lmu_Indicator),
        ('lcsInformation', _InsertSubscriberDataArg_lcsInformation),
        ('istAlertTimer', _InsertSubscriberDataArg_istAlertTimer),
        ('superChargerSupportedInHLR', _InsertSubscriberDataArg_superChargerSupportedInHLR),
        ('mc-SS-Info', _InsertSubscriberDataArg_mc_SS_Info),
        ('cs-AllocationRetentionPriority', _InsertSubscriberDataArg_cs_AllocationRetentionPriority),
        ('sgsn-CAMEL-SubscriptionInfo', _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo),
        ('chargingCharacteristics', _InsertSubscriberDataArg_chargingCharacteristics),
        ('accessRestrictionData', _InsertSubscriberDataArg_accessRestrictionData),
        ('ics-Indicator', _InsertSubscriberDataArg_ics_Indicator),
        ('eps-SubscriptionData', _InsertSubscriberDataArg_eps_SubscriptionData),
        ('csg-SubscriptionDataList', _InsertSubscriberDataArg_csg_SubscriptionDataList),
        ('ue-ReachabilityRequestIndicator', _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator),
        ('sgsn-Number', _InsertSubscriberDataArg_sgsn_Number),
        ('mme-Name', _InsertSubscriberDataArg_mme_Name),
        ('subscribedPeriodicRAUTAUtimer', _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer),
        ('vplmnLIPAAllowed', _InsertSubscriberDataArg_vplmnLIPAAllowed),
        ('mdtUserConsent', _InsertSubscriberDataArg_mdtUserConsent),
        ('subscribedPeriodicLAUtimer', _InsertSubscriberDataArg_subscribedPeriodicLAUtimer),
        ('vplmn-Csg-SubscriptionDataList', _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList),
        ('additionalMSISDN', _InsertSubscriberDataArg_additionalMSISDN),
        ('psAndSMS-OnlyServiceProvision', _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision),
        ('smsInSGSNAllowed', _InsertSubscriberDataArg_smsInSGSNAllowed),
        ('cs-to-ps-SRVCC-Allowed-Indicator', _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator),
        ('pcscf-Restoration-Request', _InsertSubscriberDataArg_pcscf_Restoration_Request),
        ('adjacentAccessRestrictionDataList', _InsertSubscriberDataArg_adjacentAccessRestrictionDataList),
        ('imsi-Group-Id-List', _InsertSubscriberDataArg_imsi_Group_Id_List),
        ('ueUsageType', _InsertSubscriberDataArg_ueUsageType),
        ('userPlaneIntegrityProtectionIndicator', _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator),
        ('dl-Buffering-Suggested-Packet-Count', _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count),
        ('reset-Id-List', _InsertSubscriberDataArg_reset_Id_List),
        ('eDRX-Cycle-Length-List', _InsertSubscriberDataArg_eDRX_Cycle_Length_List),
        ('ext-AccessRestrictionData', _InsertSubscriberDataArg_ext_AccessRestrictionData),
        ('iab-Operation-Allowed-Indicator', _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator),
        ])
    InsertSubscriberDataArg._ext = ['naea-PreferredCI', 'gprsSubscriptionData', 'roamingRestrictedInSgsnDueToUnsupportedFeature', 'networkAccessMode', 'lsaInformation', 'lmu-Indicator', 'lcsInformation', 'istAlertTimer', 'superChargerSupportedInHLR', 'mc-SS-Info', 'cs-AllocationRetentionPriority', 'sgsn-CAMEL-SubscriptionInfo', 'chargingCharacteristics', 'accessRestrictionData', 'ics-Indicator', 'eps-SubscriptionData', 'csg-SubscriptionDataList', 'ue-ReachabilityRequestIndicator', 'sgsn-Number', 'mme-Name', 'subscribedPeriodicRAUTAUtimer', 'vplmnLIPAAllowed', 'mdtUserConsent', 'subscribedPeriodicLAUtimer', 'vplmn-Csg-SubscriptionDataList', 'additionalMSISDN', 'psAndSMS-OnlyServiceProvision', 'smsInSGSNAllowed', 'cs-to-ps-SRVCC-Allowed-Indicator', 'pcscf-Restoration-Request', 'adjacentAccessRestrictionDataList', 'imsi-Group-Id-List', 'ueUsageType', 'userPlaneIntegrityProtectionIndicator', 'dl-Buffering-Suggested-Packet-Count', 'reset-Id-List', 'eDRX-Cycle-Length-List', 'ext-AccessRestrictionData', 'iab-Operation-Allowed-Indicator']
    
    #-----< EDRX-Cycle-Length-List >-----#
    EDRX_Cycle_Length_List = SEQ_OF(name='EDRX-Cycle-Length-List', mode=MODE_TYPE)
    _EDRX_Cycle_Length_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length')))
    EDRX_Cycle_Length_List._cont = _EDRX_Cycle_Length_List__item_
    EDRX_Cycle_Length_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDRX-Cycle-Length >-----#
    EDRX_Cycle_Length = SEQ(name='EDRX-Cycle-Length', mode=MODE_TYPE)
    _EDRX_Cycle_Length_rat_Type = ENUM(name='rat-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')))
    _EDRX_Cycle_Length_eDRX_Cycle_Length_Value = OCT_STR(name='eDRX-Cycle-Length-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-Value')))
    EDRX_Cycle_Length._cont = ASN1Dict([
        ('rat-Type', _EDRX_Cycle_Length_rat_Type),
        ('eDRX-Cycle-Length-Value', _EDRX_Cycle_Length_eDRX_Cycle_Length_Value),
        ])
    EDRX_Cycle_Length._ext = []
    
    #-----< EDRX-Cycle-Length-Value >-----#
    EDRX_Cycle_Length_Value = OCT_STR(name='EDRX-Cycle-Length-Value', mode=MODE_TYPE)
    EDRX_Cycle_Length_Value._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Reset-Id-List >-----#
    Reset_Id_List = SEQ_OF(name='Reset-Id-List', mode=MODE_TYPE)
    _Reset_Id_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id')))
    Reset_Id_List._cont = _Reset_Id_List__item_
    Reset_Id_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< Reset-Id >-----#
    Reset_Id = OCT_STR(name='Reset-Id', mode=MODE_TYPE)
    Reset_Id._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DL-Buffering-Suggested-Packet-Count >-----#
    DL_Buffering_Suggested_Packet_Count = INT(name='DL-Buffering-Suggested-Packet-Count', mode=MODE_TYPE)
    DL_Buffering_Suggested_Packet_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=2147483647)], ev=None, er=[])
    
    #-----< Group-Service-ID >-----#
    Group_Service_ID = INT(name='Group-Service-ID', mode=MODE_TYPE)
    Group_Service_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< Local-GroupID >-----#
    Local_GroupID = OCT_STR(name='Local-GroupID', mode=MODE_TYPE)
    Local_GroupID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< IMSI-GroupIdList >-----#
    IMSI_GroupIdList = SEQ_OF(name='IMSI-GroupIdList', mode=MODE_TYPE)
    _IMSI_GroupIdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupId')))
    IMSI_GroupIdList._cont = _IMSI_GroupIdList__item_
    IMSI_GroupIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< IMSI-GroupId >-----#
    IMSI_GroupId = SEQ(name='IMSI-GroupId', mode=MODE_TYPE)
    _IMSI_GroupId_group_Service_Id = INT(name='group-Service-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Group-Service-ID')))
    _IMSI_GroupId_plmnId = OCT_STR(name='plmnId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _IMSI_GroupId_local_Group_ID = OCT_STR(name='local-Group-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Local-GroupID')))
    IMSI_GroupId._cont = ASN1Dict([
        ('group-Service-Id', _IMSI_GroupId_group_Service_Id),
        ('plmnId', _IMSI_GroupId_plmnId),
        ('local-Group-ID', _IMSI_GroupId_local_Group_ID),
        ])
    IMSI_GroupId._ext = []
    
    #-----< SubscribedPeriodicRAUTAUtimer >-----#
    SubscribedPeriodicRAUTAUtimer = INT(name='SubscribedPeriodicRAUTAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicRAUTAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< SubscribedPeriodicLAUtimer >-----#
    SubscribedPeriodicLAUtimer = INT(name='SubscribedPeriodicLAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicLAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< CSG-SubscriptionDataList >-----#
    CSG_SubscriptionDataList = SEQ_OF(name='CSG-SubscriptionDataList', mode=MODE_TYPE)
    _CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    CSG_SubscriptionDataList._cont = _CSG_SubscriptionDataList__item_
    CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-SubscriptionData >-----#
    CSG_SubscriptionData = SEQ(name='CSG-SubscriptionData', mode=MODE_TYPE)
    _CSG_SubscriptionData_csg_Id = BIT_STR(name='csg-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _CSG_SubscriptionData_expirationDate = OCT_STR(name='expirationDate', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _CSG_SubscriptionData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CSG_SubscriptionData_lipa_AllowedAPNList = SEQ_OF(name='lipa-AllowedAPNList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-AllowedAPNList')), opt=True)
    _CSG_SubscriptionData_plmn_Id = OCT_STR(name='plmn-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    CSG_SubscriptionData._cont = ASN1Dict([
        ('csg-Id', _CSG_SubscriptionData_csg_Id),
        ('expirationDate', _CSG_SubscriptionData_expirationDate),
        ('extensionContainer', _CSG_SubscriptionData_extensionContainer),
        ('lipa-AllowedAPNList', _CSG_SubscriptionData_lipa_AllowedAPNList),
        ('plmn-Id', _CSG_SubscriptionData_plmn_Id),
        ])
    CSG_SubscriptionData._ext = ['lipa-AllowedAPNList', 'plmn-Id']
    
    #-----< VPLMN-CSG-SubscriptionDataList >-----#
    VPLMN_CSG_SubscriptionDataList = SEQ_OF(name='VPLMN-CSG-SubscriptionDataList', mode=MODE_TYPE)
    _VPLMN_CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    VPLMN_CSG_SubscriptionDataList._cont = _VPLMN_CSG_SubscriptionDataList__item_
    VPLMN_CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name='CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< LIPA-AllowedAPNList >-----#
    LIPA_AllowedAPNList = SEQ_OF(name='LIPA-AllowedAPNList', mode=MODE_TYPE)
    _LIPA_AllowedAPNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    LIPA_AllowedAPNList._cont = _LIPA_AllowedAPNList__item_
    LIPA_AllowedAPNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfLIPAAllowedAPN >-----#
    maxNumOfLIPAAllowedAPN = INT(name='maxNumOfLIPAAllowedAPN', mode=MODE_VALUE)
    maxNumOfLIPAAllowedAPN._val = 50
    
    #-----< EPS-SubscriptionData >-----#
    EPS_SubscriptionData = SEQ(name='EPS-SubscriptionData', mode=MODE_TYPE)
    _EPS_SubscriptionData_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _EPS_SubscriptionData_rfsp_id = INT(name='rfsp-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RFSP-ID')), opt=True)
    _EPS_SubscriptionData_ambr = SEQ(name='ambr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _EPS_SubscriptionData_apn_ConfigurationProfile = SEQ(name='apn-ConfigurationProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-ConfigurationProfile')), opt=True)
    _EPS_SubscriptionData_stn_sr = OCT_STR(name='stn-sr', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _EPS_SubscriptionData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _EPS_SubscriptionData_mps_CSPriority = NULL(name='mps-CSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_mps_EPSPriority = NULL(name='mps-EPSPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_subscribed_vsrvcc = NULL(name='subscribed-vsrvcc', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPS_SubscriptionData._cont = ASN1Dict([
        ('apn-oi-Replacement', _EPS_SubscriptionData_apn_oi_Replacement),
        ('rfsp-id', _EPS_SubscriptionData_rfsp_id),
        ('ambr', _EPS_SubscriptionData_ambr),
        ('apn-ConfigurationProfile', _EPS_SubscriptionData_apn_ConfigurationProfile),
        ('stn-sr', _EPS_SubscriptionData_stn_sr),
        ('extensionContainer', _EPS_SubscriptionData_extensionContainer),
        ('mps-CSPriority', _EPS_SubscriptionData_mps_CSPriority),
        ('mps-EPSPriority', _EPS_SubscriptionData_mps_EPSPriority),
        ('subscribed-vsrvcc', _EPS_SubscriptionData_subscribed_vsrvcc),
        ])
    EPS_SubscriptionData._ext = ['mps-CSPriority', 'mps-EPSPriority', 'subscribed-vsrvcc']
    
    #-----< APN-OI-Replacement >-----#
    APN_OI_Replacement = OCT_STR(name='APN-OI-Replacement', mode=MODE_TYPE)
    APN_OI_Replacement._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=100)], ev=None, er=[])
    
    #-----< RFSP-ID >-----#
    RFSP_ID = INT(name='RFSP-ID', mode=MODE_TYPE)
    RFSP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< APN-ConfigurationProfile >-----#
    APN_ConfigurationProfile = SEQ(name='APN-ConfigurationProfile', mode=MODE_TYPE)
    _APN_ConfigurationProfile_defaultContext = INT(name='defaultContext', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_ConfigurationProfile_completeDataListIncluded = NULL(name='completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _APN_ConfigurationProfile_epsDataList = SEQ_OF(name='epsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-DataList')))
    _APN_ConfigurationProfile_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_ConfigurationProfile_additionalDefaultContext = INT(name='additionalDefaultContext', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    APN_ConfigurationProfile._cont = ASN1Dict([
        ('defaultContext', _APN_ConfigurationProfile_defaultContext),
        ('completeDataListIncluded', _APN_ConfigurationProfile_completeDataListIncluded),
        ('epsDataList', _APN_ConfigurationProfile_epsDataList),
        ('extensionContainer', _APN_ConfigurationProfile_extensionContainer),
        ('additionalDefaultContext', _APN_ConfigurationProfile_additionalDefaultContext),
        ])
    APN_ConfigurationProfile._ext = ['additionalDefaultContext']
    
    #-----< EPS-DataList >-----#
    EPS_DataList = SEQ_OF(name='EPS-DataList', mode=MODE_TYPE)
    _EPS_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-Configuration')))
    EPS_DataList._cont = _EPS_DataList__item_
    EPS_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfAPN-Configurations >-----#
    maxNumOfAPN_Configurations = INT(name='maxNumOfAPN-Configurations', mode=MODE_VALUE)
    maxNumOfAPN_Configurations._val = 50
    
    #-----< APN-Configuration >-----#
    APN_Configuration = SEQ(name='APN-Configuration', mode=MODE_TYPE)
    _APN_Configuration_contextId = INT(name='contextId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_Configuration_pdn_Type = OCT_STR(name='pdn-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-Type')))
    _APN_Configuration_servedPartyIP_IPv4_Address = OCT_STR(name='servedPartyIP-IPv4-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _APN_Configuration_eps_qos_Subscribed = SEQ(name='eps-qos-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-QoS-Subscribed')))
    _APN_Configuration_pdn_gw_Identity = SEQ(name='pdn-gw-Identity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _APN_Configuration_pdn_gw_AllocationType = ENUM(name='pdn-gw-AllocationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-AllocationType')), opt=True)
    _APN_Configuration_vplmnAddressAllowed = NULL(name='vplmnAddressAllowed', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _APN_Configuration_ambr = SEQ(name='ambr', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _APN_Configuration_specificAPNInfoList = SEQ_OF(name='specificAPNInfoList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfoList')), opt=True)
    _APN_Configuration_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_Configuration_servedPartyIP_IPv6_Address = OCT_STR(name='servedPartyIP-IPv6-Address', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _APN_Configuration_sipto_Permission = ENUM(name='sipto-Permission', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _APN_Configuration_lipa_Permission = ENUM(name='lipa-Permission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _APN_Configuration_restoration_Priority = OCT_STR(name='restoration-Priority', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _APN_Configuration_sipto_local_network_Permission = ENUM(name='sipto-local-network-Permission', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _APN_Configuration_wlan_offloadability = SEQ(name='wlan-offloadability', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability')), opt=True)
    _APN_Configuration_non_IP_PDN_Type_Indicator = NULL(name='non-IP-PDN-Type-Indicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_nIDD_Mechanism = ENUM(name='nIDD-Mechanism', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _APN_Configuration_sCEF_ID = OCT_STR(name='sCEF-ID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _APN_Configuration_pdn_ConnectionContinuity = ENUM(name='pdn-ConnectionContinuity', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-ConnectionContinuity')), opt=True)
    APN_Configuration._cont = ASN1Dict([
        ('contextId', _APN_Configuration_contextId),
        ('pdn-Type', _APN_Configuration_pdn_Type),
        ('servedPartyIP-IPv4-Address', _APN_Configuration_servedPartyIP_IPv4_Address),
        ('apn', _APN_Configuration_apn),
        ('eps-qos-Subscribed', _APN_Configuration_eps_qos_Subscribed),
        ('pdn-gw-Identity', _APN_Configuration_pdn_gw_Identity),
        ('pdn-gw-AllocationType', _APN_Configuration_pdn_gw_AllocationType),
        ('vplmnAddressAllowed', _APN_Configuration_vplmnAddressAllowed),
        ('chargingCharacteristics', _APN_Configuration_chargingCharacteristics),
        ('ambr', _APN_Configuration_ambr),
        ('specificAPNInfoList', _APN_Configuration_specificAPNInfoList),
        ('extensionContainer', _APN_Configuration_extensionContainer),
        ('servedPartyIP-IPv6-Address', _APN_Configuration_servedPartyIP_IPv6_Address),
        ('apn-oi-Replacement', _APN_Configuration_apn_oi_Replacement),
        ('sipto-Permission', _APN_Configuration_sipto_Permission),
        ('lipa-Permission', _APN_Configuration_lipa_Permission),
        ('restoration-Priority', _APN_Configuration_restoration_Priority),
        ('sipto-local-network-Permission', _APN_Configuration_sipto_local_network_Permission),
        ('wlan-offloadability', _APN_Configuration_wlan_offloadability),
        ('non-IP-PDN-Type-Indicator', _APN_Configuration_non_IP_PDN_Type_Indicator),
        ('nIDD-Mechanism', _APN_Configuration_nIDD_Mechanism),
        ('sCEF-ID', _APN_Configuration_sCEF_ID),
        ('pdn-ConnectionContinuity', _APN_Configuration_pdn_ConnectionContinuity),
        ])
    APN_Configuration._ext = ['apn-oi-Replacement', 'sipto-Permission', 'lipa-Permission', 'restoration-Priority', 'sipto-local-network-Permission', 'wlan-offloadability', 'non-IP-PDN-Type-Indicator', 'nIDD-Mechanism', 'sCEF-ID', 'pdn-ConnectionContinuity']
    
    #-----< PDN-ConnectionContinuity >-----#
    PDN_ConnectionContinuity = ENUM(name='PDN-ConnectionContinuity', mode=MODE_TYPE)
    PDN_ConnectionContinuity._cont = ASN1Dict([('maintainPDN-Connection', 0), ('disconnectPDN-ConnectionWithReactivationRequest', 1), ('disconnectPDN-ConnectionWithoutReactivationRequest', 2)])
    PDN_ConnectionContinuity._ext = None
    
    #-----< NIDD-Mechanism >-----#
    NIDD_Mechanism = ENUM(name='NIDD-Mechanism', mode=MODE_TYPE)
    NIDD_Mechanism._cont = ASN1Dict([('sGi-based-data-delivery', 0), ('sCEF-based-data-delivery', 1)])
    NIDD_Mechanism._ext = None
    
    #-----< PDN-Type >-----#
    PDN_Type = OCT_STR(name='PDN-Type', mode=MODE_TYPE)
    PDN_Type._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EPS-QoS-Subscribed >-----#
    EPS_QoS_Subscribed = SEQ(name='EPS-QoS-Subscribed', mode=MODE_TYPE)
    _EPS_QoS_Subscribed_qos_Class_Identifier = INT(name='qos-Class-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Class-Identifier')))
    _EPS_QoS_Subscribed_allocation_Retention_Priority = SEQ(name='allocation-Retention-Priority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Allocation-Retention-Priority')))
    _EPS_QoS_Subscribed_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPS_QoS_Subscribed._cont = ASN1Dict([
        ('qos-Class-Identifier', _EPS_QoS_Subscribed_qos_Class_Identifier),
        ('allocation-Retention-Priority', _EPS_QoS_Subscribed_allocation_Retention_Priority),
        ('extensionContainer', _EPS_QoS_Subscribed_extensionContainer),
        ])
    EPS_QoS_Subscribed._ext = []
    
    #-----< AMBR >-----#
    AMBR = SEQ(name='AMBR', mode=MODE_TYPE)
    _AMBR_max_RequestedBandwidth_UL = INT(name='max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_max_RequestedBandwidth_DL = INT(name='max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_UL = INT(name='extended-Max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_DL = INT(name='extended-Max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    AMBR._cont = ASN1Dict([
        ('max-RequestedBandwidth-UL', _AMBR_max_RequestedBandwidth_UL),
        ('max-RequestedBandwidth-DL', _AMBR_max_RequestedBandwidth_DL),
        ('extensionContainer', _AMBR_extensionContainer),
        ('extended-Max-RequestedBandwidth-UL', _AMBR_extended_Max_RequestedBandwidth_UL),
        ('extended-Max-RequestedBandwidth-DL', _AMBR_extended_Max_RequestedBandwidth_DL),
        ])
    AMBR._ext = ['extended-Max-RequestedBandwidth-UL', 'extended-Max-RequestedBandwidth-DL']
    
    #-----< SpecificAPNInfoList >-----#
    SpecificAPNInfoList = SEQ_OF(name='SpecificAPNInfoList', mode=MODE_TYPE)
    _SpecificAPNInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfo')))
    SpecificAPNInfoList._cont = _SpecificAPNInfoList__item_
    SpecificAPNInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfSpecificAPNInfos >-----#
    maxNumOfSpecificAPNInfos = INT(name='maxNumOfSpecificAPNInfos', mode=MODE_VALUE)
    maxNumOfSpecificAPNInfos._val = 50
    
    #-----< SpecificAPNInfo >-----#
    SpecificAPNInfo = SEQ(name='SpecificAPNInfo', mode=MODE_TYPE)
    _SpecificAPNInfo_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _SpecificAPNInfo_pdn_gw_Identity = SEQ(name='pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')))
    _SpecificAPNInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SpecificAPNInfo._cont = ASN1Dict([
        ('apn', _SpecificAPNInfo_apn),
        ('pdn-gw-Identity', _SpecificAPNInfo_pdn_gw_Identity),
        ('extensionContainer', _SpecificAPNInfo_extensionContainer),
        ])
    SpecificAPNInfo._ext = []
    
    #-----< Bandwidth >-----#
    Bandwidth = INT(name='Bandwidth', mode=MODE_TYPE)
    
    #-----< BandwidthExt >-----#
    BandwidthExt = INT(name='BandwidthExt', mode=MODE_TYPE)
    
    #-----< QoS-Class-Identifier >-----#
    QoS_Class_Identifier = INT(name='QoS-Class-Identifier', mode=MODE_TYPE)
    QoS_Class_Identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Allocation-Retention-Priority >-----#
    Allocation_Retention_Priority = SEQ(name='Allocation-Retention-Priority', mode=MODE_TYPE)
    _Allocation_Retention_Priority_priority_level = INT(name='priority-level', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Allocation_Retention_Priority_pre_emption_capability = BOOL(name='pre-emption-capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_pre_emption_vulnerability = BOOL(name='pre-emption-vulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Allocation_Retention_Priority._cont = ASN1Dict([
        ('priority-level', _Allocation_Retention_Priority_priority_level),
        ('pre-emption-capability', _Allocation_Retention_Priority_pre_emption_capability),
        ('pre-emption-vulnerability', _Allocation_Retention_Priority_pre_emption_vulnerability),
        ('extensionContainer', _Allocation_Retention_Priority_extensionContainer),
        ])
    Allocation_Retention_Priority._ext = []
    
    #-----< PDN-GW-Identity >-----#
    PDN_GW_Identity = SEQ(name='PDN-GW-Identity', mode=MODE_TYPE)
    _PDN_GW_Identity_pdn_gw_ipv4_Address = OCT_STR(name='pdn-gw-ipv4-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_ipv6_Address = OCT_STR(name='pdn-gw-ipv6-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_name = OCT_STR(name='pdn-gw-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _PDN_GW_Identity_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Identity._cont = ASN1Dict([
        ('pdn-gw-ipv4-Address', _PDN_GW_Identity_pdn_gw_ipv4_Address),
        ('pdn-gw-ipv6-Address', _PDN_GW_Identity_pdn_gw_ipv6_Address),
        ('pdn-gw-name', _PDN_GW_Identity_pdn_gw_name),
        ('extensionContainer', _PDN_GW_Identity_extensionContainer),
        ])
    PDN_GW_Identity._ext = []
    
    #-----< FQDN >-----#
    FQDN = OCT_STR(name='FQDN', mode=MODE_TYPE)
    FQDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< PDN-GW-AllocationType >-----#
    PDN_GW_AllocationType = ENUM(name='PDN-GW-AllocationType', mode=MODE_TYPE)
    PDN_GW_AllocationType._cont = ASN1Dict([('static', 0), ('dynamic', 1)])
    PDN_GW_AllocationType._ext = None
    
    #-----< WLAN-Offloadability >-----#
    WLAN_Offloadability = SEQ(name='WLAN-Offloadability', mode=MODE_TYPE)
    _WLAN_Offloadability_wlan_offloadability_EUTRAN = ENUM(name='wlan-offloadability-EUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_wlan_offloadability_UTRAN = ENUM(name='wlan-offloadability-UTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    WLAN_Offloadability._cont = ASN1Dict([
        ('wlan-offloadability-EUTRAN', _WLAN_Offloadability_wlan_offloadability_EUTRAN),
        ('wlan-offloadability-UTRAN', _WLAN_Offloadability_wlan_offloadability_UTRAN),
        ('extensionContainer', _WLAN_Offloadability_extensionContainer),
        ])
    WLAN_Offloadability._ext = []
    
    #-----< WLAN-Offloadability-Indication >-----#
    WLAN_Offloadability_Indication = ENUM(name='WLAN-Offloadability-Indication', mode=MODE_TYPE)
    WLAN_Offloadability_Indication._cont = ASN1Dict([('notAllowed', 0), ('allowed', 1)])
    WLAN_Offloadability_Indication._ext = None
    
    #-----< AccessRestrictionData >-----#
    AccessRestrictionData = BIT_STR(name='AccessRestrictionData', mode=MODE_TYPE)
    AccessRestrictionData._cont = ASN1Dict([('utranNotAllowed', 0), ('geranNotAllowed', 1), ('ganNotAllowed', 2), ('i-hspa-evolutionNotAllowed', 3), ('wb-e-utranNotAllowed', 4), ('ho-toNon3GPP-AccessNotAllowed', 5), ('nb-iotNotAllowed', 6), ('enhancedCoverageNotAllowed', 7)])
    AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< Ext-AccessRestrictionData >-----#
    Ext_AccessRestrictionData = BIT_STR(name='Ext-AccessRestrictionData', mode=MODE_TYPE)
    Ext_AccessRestrictionData._cont = ASN1Dict([('nrAsSecondaryRATNotAllowed', 0), ('unlicensedSpectrumAsSecondaryRATNotAllowed', 1)])
    Ext_AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionDataList >-----#
    AdjacentAccessRestrictionDataList = SEQ_OF(name='AdjacentAccessRestrictionDataList', mode=MODE_TYPE)
    _AdjacentAccessRestrictionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionData')))
    AdjacentAccessRestrictionDataList._cont = _AdjacentAccessRestrictionDataList__item_
    AdjacentAccessRestrictionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionData >-----#
    AdjacentAccessRestrictionData = SEQ(name='AdjacentAccessRestrictionData', mode=MODE_TYPE)
    _AdjacentAccessRestrictionData_plmnId = OCT_STR(name='plmnId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _AdjacentAccessRestrictionData_accessRestrictionData = BIT_STR(name='accessRestrictionData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')))
    _AdjacentAccessRestrictionData_ext_AccessRestrictionData = BIT_STR(name='ext-AccessRestrictionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    AdjacentAccessRestrictionData._cont = ASN1Dict([
        ('plmnId', _AdjacentAccessRestrictionData_plmnId),
        ('accessRestrictionData', _AdjacentAccessRestrictionData_accessRestrictionData),
        ('ext-AccessRestrictionData', _AdjacentAccessRestrictionData_ext_AccessRestrictionData),
        ])
    AdjacentAccessRestrictionData._ext = ['ext-AccessRestrictionData']
    
    #-----< CS-AllocationRetentionPriority >-----#
    CS_AllocationRetentionPriority = OCT_STR(name='CS-AllocationRetentionPriority', mode=MODE_TYPE)
    CS_AllocationRetentionPriority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< IST-AlertTimerValue >-----#
    IST_AlertTimerValue = INT(name='IST-AlertTimerValue', mode=MODE_TYPE)
    IST_AlertTimerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=255)], ev=None, er=[])
    
    #-----< LCSInformation >-----#
    LCSInformation = SEQ(name='LCSInformation', mode=MODE_TYPE)
    _LCSInformation_gmlc_List = SEQ_OF(name='gmlc-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-List')), opt=True)
    _LCSInformation_lcs_PrivacyExceptionList = SEQ_OF(name='lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    _LCSInformation_molr_List = SEQ_OF(name='molr-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-List')), opt=True)
    _LCSInformation_add_lcs_PrivacyExceptionList = SEQ_OF(name='add-lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    LCSInformation._cont = ASN1Dict([
        ('gmlc-List', _LCSInformation_gmlc_List),
        ('lcs-PrivacyExceptionList', _LCSInformation_lcs_PrivacyExceptionList),
        ('molr-List', _LCSInformation_molr_List),
        ('add-lcs-PrivacyExceptionList', _LCSInformation_add_lcs_PrivacyExceptionList),
        ])
    LCSInformation._ext = ['add-lcs-PrivacyExceptionList']
    
    #-----< GMLC-List >-----#
    GMLC_List = SEQ_OF(name='GMLC-List', mode=MODE_TYPE)
    _GMLC_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    GMLC_List._cont = _GMLC_List__item_
    GMLC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfGMLC >-----#
    maxNumOfGMLC = INT(name='maxNumOfGMLC', mode=MODE_VALUE)
    maxNumOfGMLC._val = 5
    
    #-----< NetworkAccessMode >-----#
    NetworkAccessMode = ENUM(name='NetworkAccessMode', mode=MODE_TYPE)
    NetworkAccessMode._cont = ASN1Dict([('packetAndCircuit', 0), ('onlyCircuit', 1), ('onlyPacket', 2)])
    NetworkAccessMode._ext = []
    
    #-----< GPRSDataList >-----#
    GPRSDataList = SEQ_OF(name='GPRSDataList', mode=MODE_TYPE)
    _GPRSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Context')))
    GPRSDataList._cont = _GPRSDataList__item_
    GPRSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfPDP-Contexts >-----#
    maxNumOfPDP_Contexts = INT(name='maxNumOfPDP-Contexts', mode=MODE_VALUE)
    maxNumOfPDP_Contexts._val = 50
    
    #-----< PDP-Context >-----#
    PDP_Context = SEQ(name='PDP-Context', mode=MODE_TYPE)
    _PDP_Context_pdp_ContextId = INT(name='pdp-ContextId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_Context_pdp_Type = OCT_STR(name='pdp-Type', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_Context_pdp_Address = OCT_STR(name='pdp-Address', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_qos_Subscribed = OCT_STR(name='qos-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _PDP_Context_vplmnAddressAllowed = NULL(name='vplmnAddressAllowed', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_Context_apn = OCT_STR(name='apn', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _PDP_Context_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_Context_ext_QoS_Subscribed = OCT_STR(name='ext-QoS-Subscribed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_Context_pdp_ChargingCharacteristics = OCT_STR(name='pdp-ChargingCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_Context_ext2_QoS_Subscribed = OCT_STR(name='ext2-QoS-Subscribed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_Context_ext3_QoS_Subscribed = OCT_STR(name='ext3-QoS-Subscribed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_Context_ext4_QoS_Subscribed = OCT_STR(name='ext4-QoS-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_Context_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _PDP_Context_ext_pdp_Type = OCT_STR(name='ext-pdp-Type', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_Context_ext_pdp_Address = OCT_STR(name='ext-pdp-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_ambr = SEQ(name='ambr', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _PDP_Context_sipto_Permission = ENUM(name='sipto-Permission', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _PDP_Context_lipa_Permission = ENUM(name='lipa-Permission', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _PDP_Context_restoration_Priority = OCT_STR(name='restoration-Priority', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _PDP_Context_sipto_local_network_Permission = ENUM(name='sipto-local-network-Permission', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _PDP_Context_nIDD_Mechanism = ENUM(name='nIDD-Mechanism', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _PDP_Context_sCEF_ID = OCT_STR(name='sCEF-ID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    PDP_Context._cont = ASN1Dict([
        ('pdp-ContextId', _PDP_Context_pdp_ContextId),
        ('pdp-Type', _PDP_Context_pdp_Type),
        ('pdp-Address', _PDP_Context_pdp_Address),
        ('qos-Subscribed', _PDP_Context_qos_Subscribed),
        ('vplmnAddressAllowed', _PDP_Context_vplmnAddressAllowed),
        ('apn', _PDP_Context_apn),
        ('extensionContainer', _PDP_Context_extensionContainer),
        ('ext-QoS-Subscribed', _PDP_Context_ext_QoS_Subscribed),
        ('pdp-ChargingCharacteristics', _PDP_Context_pdp_ChargingCharacteristics),
        ('ext2-QoS-Subscribed', _PDP_Context_ext2_QoS_Subscribed),
        ('ext3-QoS-Subscribed', _PDP_Context_ext3_QoS_Subscribed),
        ('ext4-QoS-Subscribed', _PDP_Context_ext4_QoS_Subscribed),
        ('apn-oi-Replacement', _PDP_Context_apn_oi_Replacement),
        ('ext-pdp-Type', _PDP_Context_ext_pdp_Type),
        ('ext-pdp-Address', _PDP_Context_ext_pdp_Address),
        ('ambr', _PDP_Context_ambr),
        ('sipto-Permission', _PDP_Context_sipto_Permission),
        ('lipa-Permission', _PDP_Context_lipa_Permission),
        ('restoration-Priority', _PDP_Context_restoration_Priority),
        ('sipto-local-network-Permission', _PDP_Context_sipto_local_network_Permission),
        ('nIDD-Mechanism', _PDP_Context_nIDD_Mechanism),
        ('sCEF-ID', _PDP_Context_sCEF_ID),
        ])
    PDP_Context._ext = ['ext-QoS-Subscribed', 'pdp-ChargingCharacteristics', 'ext2-QoS-Subscribed', 'ext3-QoS-Subscribed', 'ext4-QoS-Subscribed', 'apn-oi-Replacement', 'ext-pdp-Type', 'ext-pdp-Address', 'ambr', 'sipto-Permission', 'lipa-Permission', 'restoration-Priority', 'sipto-local-network-Permission', 'nIDD-Mechanism', 'sCEF-ID']
    
    #-----< Restoration-Priority >-----#
    Restoration_Priority = OCT_STR(name='Restoration-Priority', mode=MODE_TYPE)
    Restoration_Priority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SIPTO-Permission >-----#
    SIPTO_Permission = ENUM(name='SIPTO-Permission', mode=MODE_TYPE)
    SIPTO_Permission._cont = ASN1Dict([('siptoAboveRanAllowed', 0), ('siptoAboveRanNotAllowed', 1)])
    SIPTO_Permission._ext = None
    
    #-----< SIPTO-Local-Network-Permission >-----#
    SIPTO_Local_Network_Permission = ENUM(name='SIPTO-Local-Network-Permission', mode=MODE_TYPE)
    SIPTO_Local_Network_Permission._cont = ASN1Dict([('siptoAtLocalNetworkAllowed', 0), ('siptoAtLocalNetworkNotAllowed', 1)])
    SIPTO_Local_Network_Permission._ext = None
    
    #-----< LIPA-Permission >-----#
    LIPA_Permission = ENUM(name='LIPA-Permission', mode=MODE_TYPE)
    LIPA_Permission._cont = ASN1Dict([('lipaProhibited', 0), ('lipaOnly', 1), ('lipaConditional', 2)])
    LIPA_Permission._ext = None
    
    #-----< ContextId >-----#
    ContextId = INT(name='ContextId', mode=MODE_TYPE)
    ContextId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< GPRSSubscriptionData >-----#
    GPRSSubscriptionData = SEQ(name='GPRSSubscriptionData', mode=MODE_TYPE)
    _GPRSSubscriptionData_completeDataListIncluded = NULL(name='completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _GPRSSubscriptionData_gprsDataList = SEQ_OF(name='gprsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSDataList')))
    _GPRSSubscriptionData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRSSubscriptionData_apn_oi_Replacement = OCT_STR(name='apn-oi-Replacement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    GPRSSubscriptionData._cont = ASN1Dict([
        ('completeDataListIncluded', _GPRSSubscriptionData_completeDataListIncluded),
        ('gprsDataList', _GPRSSubscriptionData_gprsDataList),
        ('extensionContainer', _GPRSSubscriptionData_extensionContainer),
        ('apn-oi-Replacement', _GPRSSubscriptionData_apn_oi_Replacement),
        ])
    GPRSSubscriptionData._ext = ['apn-oi-Replacement']
    
    #-----< SGSN-CAMEL-SubscriptionInfo >-----#
    SGSN_CAMEL_SubscriptionInfo = SEQ(name='SGSN-CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _SGSN_CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name='gprs-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name='mo-sms-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name='mt-sms-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name='mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mg_csi = SEQ(name='mg-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    SGSN_CAMEL_SubscriptionInfo._cont = ASN1Dict([
        ('gprs-CSI', _SGSN_CAMEL_SubscriptionInfo_gprs_CSI),
        ('mo-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI),
        ('extensionContainer', _SGSN_CAMEL_SubscriptionInfo_extensionContainer),
        ('mt-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI),
        ('mt-smsCAMELTDP-CriteriaList', _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ('mg-csi', _SGSN_CAMEL_SubscriptionInfo_mg_csi),
        ])
    SGSN_CAMEL_SubscriptionInfo._ext = ['mt-sms-CSI', 'mt-smsCAMELTDP-CriteriaList', 'mg-csi']
    
    #-----< GPRS-CSI >-----#
    GPRS_CSI = SEQ(name='GPRS-CSI', mode=MODE_TYPE)
    _GPRS_CSI_gprs_CamelTDPDataList = SEQ_OF(name='gprs-CamelTDPDataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPDataList')), opt=True)
    _GPRS_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _GPRS_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRS_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GPRS_CSI._cont = ASN1Dict([
        ('gprs-CamelTDPDataList', _GPRS_CSI_gprs_CamelTDPDataList),
        ('camelCapabilityHandling', _GPRS_CSI_camelCapabilityHandling),
        ('extensionContainer', _GPRS_CSI_extensionContainer),
        ('notificationToCSE', _GPRS_CSI_notificationToCSE),
        ('csi-Active', _GPRS_CSI_csi_Active),
        ])
    GPRS_CSI._ext = []
    
    #-----< GPRS-CamelTDPDataList >-----#
    GPRS_CamelTDPDataList = SEQ_OF(name='GPRS-CamelTDPDataList', mode=MODE_TYPE)
    _GPRS_CamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPData')))
    GPRS_CamelTDPDataList._cont = _GPRS_CamelTDPDataList__item_
    GPRS_CamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< GPRS-CamelTDPData >-----#
    GPRS_CamelTDPData = SEQ(name='GPRS-CamelTDPData', mode=MODE_TYPE)
    _GPRS_CamelTDPData_gprs_TriggerDetectionPoint = ENUM(name='gprs-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-TriggerDetectionPoint')))
    _GPRS_CamelTDPData_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _GPRS_CamelTDPData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _GPRS_CamelTDPData_defaultSessionHandling = ENUM(name='defaultSessionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')))
    _GPRS_CamelTDPData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    GPRS_CamelTDPData._cont = ASN1Dict([
        ('gprs-TriggerDetectionPoint', _GPRS_CamelTDPData_gprs_TriggerDetectionPoint),
        ('serviceKey', _GPRS_CamelTDPData_serviceKey),
        ('gsmSCF-Address', _GPRS_CamelTDPData_gsmSCF_Address),
        ('defaultSessionHandling', _GPRS_CamelTDPData_defaultSessionHandling),
        ('extensionContainer', _GPRS_CamelTDPData_extensionContainer),
        ])
    GPRS_CamelTDPData._ext = []
    
    #-----< DefaultGPRS-Handling >-----#
    DefaultGPRS_Handling = ENUM(name='DefaultGPRS-Handling', mode=MODE_TYPE)
    DefaultGPRS_Handling._cont = ASN1Dict([('continueTransaction', 0), ('releaseTransaction', 1)])
    DefaultGPRS_Handling._ext = []
    
    #-----< GPRS-TriggerDetectionPoint >-----#
    GPRS_TriggerDetectionPoint = ENUM(name='GPRS-TriggerDetectionPoint', mode=MODE_TYPE)
    GPRS_TriggerDetectionPoint._cont = ASN1Dict([('attach', 1), ('attachChangeOfPosition', 2), ('pdp-ContextEstablishment', 11), ('pdp-ContextEstablishmentAcknowledgement', 12), ('pdp-ContextChangeOfPosition', 14)])
    GPRS_TriggerDetectionPoint._ext = []
    
    #-----< APN >-----#
    APN = OCT_STR(name='APN', mode=MODE_TYPE)
    APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=63)], ev=None, er=[])
    
    #-----< PDP-Type >-----#
    PDP_Type = OCT_STR(name='PDP-Type', mode=MODE_TYPE)
    PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Ext-PDP-Type >-----#
    Ext_PDP_Type = OCT_STR(name='Ext-PDP-Type', mode=MODE_TYPE)
    Ext_PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PDP-Address >-----#
    PDP_Address = OCT_STR(name='PDP-Address', mode=MODE_TYPE)
    PDP_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< QoS-Subscribed >-----#
    QoS_Subscribed = OCT_STR(name='QoS-Subscribed', mode=MODE_TYPE)
    QoS_Subscribed._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Ext-QoS-Subscribed >-----#
    Ext_QoS_Subscribed = OCT_STR(name='Ext-QoS-Subscribed', mode=MODE_TYPE)
    Ext_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Ext2-QoS-Subscribed >-----#
    Ext2_QoS_Subscribed = OCT_STR(name='Ext2-QoS-Subscribed', mode=MODE_TYPE)
    Ext2_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Ext3-QoS-Subscribed >-----#
    Ext3_QoS_Subscribed = OCT_STR(name='Ext3-QoS-Subscribed', mode=MODE_TYPE)
    Ext3_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ext4-QoS-Subscribed >-----#
    Ext4_QoS_Subscribed = OCT_STR(name='Ext4-QoS-Subscribed', mode=MODE_TYPE)
    Ext4_QoS_Subscribed._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = OCT_STR(name='ChargingCharacteristics', mode=MODE_TYPE)
    ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LSAOnlyAccessIndicator >-----#
    LSAOnlyAccessIndicator = ENUM(name='LSAOnlyAccessIndicator', mode=MODE_TYPE)
    LSAOnlyAccessIndicator._cont = ASN1Dict([('accessOutsideLSAsAllowed', 0), ('accessOutsideLSAsRestricted', 1)])
    LSAOnlyAccessIndicator._ext = None
    
    #-----< LSADataList >-----#
    LSADataList = SEQ_OF(name='LSADataList', mode=MODE_TYPE)
    _LSADataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAData')))
    LSADataList._cont = _LSADataList__item_
    LSADataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfLSAs >-----#
    maxNumOfLSAs = INT(name='maxNumOfLSAs', mode=MODE_VALUE)
    maxNumOfLSAs._val = 20
    
    #-----< LSAData >-----#
    LSAData = SEQ(name='LSAData', mode=MODE_TYPE)
    _LSAData_lsaIdentity = OCT_STR(name='lsaIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    _LSAData_lsaAttributes = OCT_STR(name='lsaAttributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAAttributes')))
    _LSAData_lsaActiveModeIndicator = NULL(name='lsaActiveModeIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LSAData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAData._cont = ASN1Dict([
        ('lsaIdentity', _LSAData_lsaIdentity),
        ('lsaAttributes', _LSAData_lsaAttributes),
        ('lsaActiveModeIndicator', _LSAData_lsaActiveModeIndicator),
        ('extensionContainer', _LSAData_extensionContainer),
        ])
    LSAData._ext = []
    
    #-----< LSAInformation >-----#
    LSAInformation = SEQ(name='LSAInformation', mode=MODE_TYPE)
    _LSAInformation_completeDataListIncluded = NULL(name='completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _LSAInformation_lsaOnlyAccessIndicator = ENUM(name='lsaOnlyAccessIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAOnlyAccessIndicator')), opt=True)
    _LSAInformation_lsaDataList = SEQ_OF(name='lsaDataList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSADataList')), opt=True)
    _LSAInformation_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAInformation._cont = ASN1Dict([
        ('completeDataListIncluded', _LSAInformation_completeDataListIncluded),
        ('lsaOnlyAccessIndicator', _LSAInformation_lsaOnlyAccessIndicator),
        ('lsaDataList', _LSAInformation_lsaDataList),
        ('extensionContainer', _LSAInformation_extensionContainer),
        ])
    LSAInformation._ext = []
    
    #-----< LSAIdentity >-----#
    LSAIdentity = OCT_STR(name='LSAIdentity', mode=MODE_TYPE)
    LSAIdentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< LSAAttributes >-----#
    LSAAttributes = OCT_STR(name='LSAAttributes', mode=MODE_TYPE)
    LSAAttributes._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberData >-----#
    SubscriberData = SEQ(name='SubscriberData', mode=MODE_TYPE)
    _SubscriberData_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberData_category = OCT_STR(name='category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _SubscriberData_subscriberStatus = ENUM(name='subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _SubscriberData_bearerServiceList = SEQ_OF(name='bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _SubscriberData_teleserviceList = SEQ_OF(name='teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _SubscriberData_provisionedSS = SEQ_OF(name='provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _SubscriberData_odb_Data = SEQ(name='odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _SubscriberData_roamingRestrictionDueToUnsupportedFeature = NULL(name='roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberData_regionalSubscriptionData = SEQ_OF(name='regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _SubscriberData_vbsSubscriptionData = SEQ_OF(name='vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _SubscriberData_vgcsSubscriptionData = SEQ_OF(name='vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _SubscriberData_vlrCamelSubscriptionInfo = SEQ(name='vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    SubscriberData._cont = ASN1Dict([
        ('msisdn', _SubscriberData_msisdn),
        ('category', _SubscriberData_category),
        ('subscriberStatus', _SubscriberData_subscriberStatus),
        ('bearerServiceList', _SubscriberData_bearerServiceList),
        ('teleserviceList', _SubscriberData_teleserviceList),
        ('provisionedSS', _SubscriberData_provisionedSS),
        ('odb-Data', _SubscriberData_odb_Data),
        ('roamingRestrictionDueToUnsupportedFeature', _SubscriberData_roamingRestrictionDueToUnsupportedFeature),
        ('regionalSubscriptionData', _SubscriberData_regionalSubscriptionData),
        ('vbsSubscriptionData', _SubscriberData_vbsSubscriptionData),
        ('vgcsSubscriptionData', _SubscriberData_vgcsSubscriptionData),
        ('vlrCamelSubscriptionInfo', _SubscriberData_vlrCamelSubscriptionInfo),
        ])
    SubscriberData._ext = None
    
    #-----< Category >-----#
    Category = OCT_STR(name='Category', mode=MODE_TYPE)
    Category._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberStatus >-----#
    SubscriberStatus = ENUM(name='SubscriberStatus', mode=MODE_TYPE)
    SubscriberStatus._cont = ASN1Dict([('serviceGranted', 0), ('operatorDeterminedBarring', 1)])
    SubscriberStatus._ext = None
    
    #-----< BearerServiceList >-----#
    BearerServiceList = SEQ_OF(name='BearerServiceList', mode=MODE_TYPE)
    _BearerServiceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    BearerServiceList._cont = _BearerServiceList__item_
    BearerServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfBearerServices >-----#
    maxNumOfBearerServices = INT(name='maxNumOfBearerServices', mode=MODE_VALUE)
    maxNumOfBearerServices._val = 50
    
    #-----< TeleserviceList >-----#
    TeleserviceList = SEQ_OF(name='TeleserviceList', mode=MODE_TYPE)
    _TeleserviceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    TeleserviceList._cont = _TeleserviceList__item_
    TeleserviceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfTeleservices >-----#
    maxNumOfTeleservices = INT(name='maxNumOfTeleservices', mode=MODE_VALUE)
    maxNumOfTeleservices._val = 20
    
    #-----< ODB-Data >-----#
    ODB_Data = SEQ(name='ODB-Data', mode=MODE_TYPE)
    _ODB_Data_odb_GeneralData = BIT_STR(name='odb-GeneralData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')))
    _ODB_Data_odb_HPLMN_Data = BIT_STR(name='odb-HPLMN-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-HPLMN-Data')), opt=True)
    _ODB_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Data._cont = ASN1Dict([
        ('odb-GeneralData', _ODB_Data_odb_GeneralData),
        ('odb-HPLMN-Data', _ODB_Data_odb_HPLMN_Data),
        ('extensionContainer', _ODB_Data_extensionContainer),
        ])
    ODB_Data._ext = []
    
    #-----< ODB-GeneralData >-----#
    ODB_GeneralData = BIT_STR(name='ODB-GeneralData', mode=MODE_TYPE)
    ODB_GeneralData._cont = ASN1Dict([('allOG-CallsBarred', 0), ('internationalOGCallsBarred', 1), ('internationalOGCallsNotToHPLMN-CountryBarred', 2), ('interzonalOGCallsBarred', 6), ('interzonalOGCallsNotToHPLMN-CountryBarred', 7), ('interzonalOGCallsAndInternationalOGCallsNotToHPLMN-CountryBarred', 8), ('premiumRateInformationOGCallsBarred', 3), ('premiumRateEntertainementOGCallsBarred', 4), ('ss-AccessBarred', 5), ('allECT-Barred', 9), ('chargeableECT-Barred', 10), ('internationalECT-Barred', 11), ('interzonalECT-Barred', 12), ('doublyChargeableECT-Barred', 13), ('multipleECT-Barred', 14), ('allPacketOrientedServicesBarred', 15), ('roamerAccessToHPLMN-AP-Barred', 16), ('roamerAccessToVPLMN-AP-Barred', 17), ('roamingOutsidePLMNOG-CallsBarred', 18), ('allIC-CallsBarred', 19), ('roamingOutsidePLMNIC-CallsBarred', 20), ('roamingOutsidePLMNICountryIC-CallsBarred', 21), ('roamingOutsidePLMN-Barred', 22), ('roamingOutsidePLMN-CountryBarred', 23), ('registrationAllCF-Barred', 24), ('registrationCFNotToHPLMN-Barred', 25), ('registrationInterzonalCF-Barred', 26), ('registrationInterzonalCFNotToHPLMN-Barred', 27), ('registrationInternationalCF-Barred', 28)])
    ODB_GeneralData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=32)], ev=None, er=[])
    
    #-----< ODB-HPLMN-Data >-----#
    ODB_HPLMN_Data = BIT_STR(name='ODB-HPLMN-Data', mode=MODE_TYPE)
    ODB_HPLMN_Data._cont = ASN1Dict([('plmn-SpecificBarringType1', 0), ('plmn-SpecificBarringType2', 1), ('plmn-SpecificBarringType3', 2), ('plmn-SpecificBarringType4', 3)])
    ODB_HPLMN_Data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=32)], ev=None, er=[])
    
    #-----< Ext-SS-InfoList >-----#
    Ext_SS_InfoList = SEQ_OF(name='Ext-SS-InfoList', mode=MODE_TYPE)
    _Ext_SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Info')))
    Ext_SS_InfoList._cont = _Ext_SS_InfoList__item_
    Ext_SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< Ext-SS-Info >-----#
    Ext_SS_Info = CHOICE(name='Ext-SS-Info', mode=MODE_TYPE)
    _Ext_SS_Info_forwardingInfo = SEQ(name='forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwInfo')))
    _Ext_SS_Info_callBarringInfo = SEQ(name='callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarInfo')))
    _Ext_SS_Info_cug_Info = SEQ(name='cug-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Info')))
    _Ext_SS_Info_ss_Data = SEQ(name='ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Data')))
    _Ext_SS_Info_emlpp_Info = SEQ(name='emlpp-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Info')))
    Ext_SS_Info._cont = ASN1Dict([
        ('forwardingInfo', _Ext_SS_Info_forwardingInfo),
        ('callBarringInfo', _Ext_SS_Info_callBarringInfo),
        ('cug-Info', _Ext_SS_Info_cug_Info),
        ('ss-Data', _Ext_SS_Info_ss_Data),
        ('emlpp-Info', _Ext_SS_Info_emlpp_Info),
        ])
    Ext_SS_Info._ext = None
    
    #-----< Ext-ForwInfo >-----#
    Ext_ForwInfo = SEQ(name='Ext-ForwInfo', mode=MODE_TYPE)
    _Ext_ForwInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwInfo_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwInfo._cont = ASN1Dict([
        ('ss-Code', _Ext_ForwInfo_ss_Code),
        ('forwardingFeatureList', _Ext_ForwInfo_forwardingFeatureList),
        ('extensionContainer', _Ext_ForwInfo_extensionContainer),
        ])
    Ext_ForwInfo._ext = []
    
    #-----< Ext-ForwFeatureList >-----#
    Ext_ForwFeatureList = SEQ_OF(name='Ext-ForwFeatureList', mode=MODE_TYPE)
    _Ext_ForwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeature')))
    Ext_ForwFeatureList._cont = _Ext_ForwFeatureList__item_
    Ext_ForwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-ForwFeature >-----#
    Ext_ForwFeature = SEQ(name='Ext-ForwFeature', mode=MODE_TYPE)
    _Ext_ForwFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_ForwFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_ForwFeature_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _Ext_ForwFeature_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _Ext_ForwFeature_forwardingOptions = OCT_STR(name='forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwOptions')), opt=True)
    _Ext_ForwFeature_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _Ext_ForwFeature_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _Ext_ForwFeature_longForwardedToNumber = OCT_STR(name='longForwardedToNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    Ext_ForwFeature._cont = ASN1Dict([
        ('basicService', _Ext_ForwFeature_basicService),
        ('ss-Status', _Ext_ForwFeature_ss_Status),
        ('forwardedToNumber', _Ext_ForwFeature_forwardedToNumber),
        ('forwardedToSubaddress', _Ext_ForwFeature_forwardedToSubaddress),
        ('forwardingOptions', _Ext_ForwFeature_forwardingOptions),
        ('noReplyConditionTime', _Ext_ForwFeature_noReplyConditionTime),
        ('extensionContainer', _Ext_ForwFeature_extensionContainer),
        ('longForwardedToNumber', _Ext_ForwFeature_longForwardedToNumber),
        ])
    Ext_ForwFeature._ext = ['longForwardedToNumber']
    
    #-----< Ext-ForwOptions >-----#
    Ext_ForwOptions = OCT_STR(name='Ext-ForwOptions', mode=MODE_TYPE)
    Ext_ForwOptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Ext-NoRepCondTime >-----#
    Ext_NoRepCondTime = INT(name='Ext-NoRepCondTime', mode=MODE_TYPE)
    Ext_NoRepCondTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    
    #-----< Ext-CallBarInfo >-----#
    Ext_CallBarInfo = SEQ(name='Ext-CallBarInfo', mode=MODE_TYPE)
    _Ext_CallBarInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarInfo_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarInfo._cont = ASN1Dict([
        ('ss-Code', _Ext_CallBarInfo_ss_Code),
        ('callBarringFeatureList', _Ext_CallBarInfo_callBarringFeatureList),
        ('extensionContainer', _Ext_CallBarInfo_extensionContainer),
        ])
    Ext_CallBarInfo._ext = []
    
    #-----< Ext-CallBarFeatureList >-----#
    Ext_CallBarFeatureList = SEQ_OF(name='Ext-CallBarFeatureList', mode=MODE_TYPE)
    _Ext_CallBarFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringFeature')))
    Ext_CallBarFeatureList._cont = _Ext_CallBarFeatureList__item_
    Ext_CallBarFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CallBarringFeature >-----#
    Ext_CallBarringFeature = SEQ(name='Ext-CallBarringFeature', mode=MODE_TYPE)
    _Ext_CallBarringFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_CallBarringFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_CallBarringFeature_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringFeature._cont = ASN1Dict([
        ('basicService', _Ext_CallBarringFeature_basicService),
        ('ss-Status', _Ext_CallBarringFeature_ss_Status),
        ('extensionContainer', _Ext_CallBarringFeature_extensionContainer),
        ])
    Ext_CallBarringFeature._ext = []
    
    #-----< CUG-Info >-----#
    CUG_Info = SEQ(name='CUG-Info', mode=MODE_TYPE)
    _CUG_Info_cug_SubscriptionList = SEQ_OF(name='cug-SubscriptionList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-SubscriptionList')))
    _CUG_Info_cug_FeatureList = SEQ_OF(name='cug-FeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-FeatureList')), opt=True)
    _CUG_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Info._cont = ASN1Dict([
        ('cug-SubscriptionList', _CUG_Info_cug_SubscriptionList),
        ('cug-FeatureList', _CUG_Info_cug_FeatureList),
        ('extensionContainer', _CUG_Info_extensionContainer),
        ])
    CUG_Info._ext = []
    
    #-----< CUG-SubscriptionList >-----#
    CUG_SubscriptionList = SEQ_OF(name='CUG-SubscriptionList', mode=MODE_TYPE)
    _CUG_SubscriptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Subscription')))
    CUG_SubscriptionList._cont = _CUG_SubscriptionList__item_
    CUG_SubscriptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< CUG-Subscription >-----#
    CUG_Subscription = SEQ(name='CUG-Subscription', mode=MODE_TYPE)
    _CUG_Subscription_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')))
    _CUG_Subscription_cug_Interlock = OCT_STR(name='cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_Subscription_intraCUG_Options = ENUM(name='intraCUG-Options', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntraCUG-Options')))
    _CUG_Subscription_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _CUG_Subscription_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Subscription._cont = ASN1Dict([
        ('cug-Index', _CUG_Subscription_cug_Index),
        ('cug-Interlock', _CUG_Subscription_cug_Interlock),
        ('intraCUG-Options', _CUG_Subscription_intraCUG_Options),
        ('basicServiceGroupList', _CUG_Subscription_basicServiceGroupList),
        ('extensionContainer', _CUG_Subscription_extensionContainer),
        ])
    CUG_Subscription._ext = []
    
    #-----< CUG-Index >-----#
    CUG_Index = INT(name='CUG-Index', mode=MODE_TYPE)
    CUG_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< CUG-Interlock >-----#
    CUG_Interlock = OCT_STR(name='CUG-Interlock', mode=MODE_TYPE)
    CUG_Interlock._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IntraCUG-Options >-----#
    IntraCUG_Options = ENUM(name='IntraCUG-Options', mode=MODE_TYPE)
    IntraCUG_Options._cont = ASN1Dict([('noCUG-Restrictions', 0), ('cugIC-CallBarred', 1), ('cugOG-CallBarred', 2)])
    IntraCUG_Options._ext = None
    
    #-----< maxNumOfCUG >-----#
    maxNumOfCUG = INT(name='maxNumOfCUG', mode=MODE_VALUE)
    maxNumOfCUG._val = 10
    
    #-----< CUG-FeatureList >-----#
    CUG_FeatureList = SEQ_OF(name='CUG-FeatureList', mode=MODE_TYPE)
    _CUG_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Feature')))
    CUG_FeatureList._cont = _CUG_FeatureList__item_
    CUG_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-BasicServiceGroupList >-----#
    Ext_BasicServiceGroupList = SEQ_OF(name='Ext-BasicServiceGroupList', mode=MODE_TYPE)
    _Ext_BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    Ext_BasicServiceGroupList._cont = _Ext_BasicServiceGroupList__item_
    Ext_BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfExt-BasicServiceGroups >-----#
    maxNumOfExt_BasicServiceGroups = INT(name='maxNumOfExt-BasicServiceGroups', mode=MODE_VALUE)
    maxNumOfExt_BasicServiceGroups._val = 32
    
    #-----< CUG-Feature >-----#
    CUG_Feature = SEQ(name='CUG-Feature', mode=MODE_TYPE)
    _CUG_Feature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _CUG_Feature_preferentialCUG_Indicator = INT(name='preferentialCUG-Indicator', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _CUG_Feature_interCUG_Restrictions = OCT_STR(name='interCUG-Restrictions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'InterCUG-Restrictions')))
    _CUG_Feature_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Feature._cont = ASN1Dict([
        ('basicService', _CUG_Feature_basicService),
        ('preferentialCUG-Indicator', _CUG_Feature_preferentialCUG_Indicator),
        ('interCUG-Restrictions', _CUG_Feature_interCUG_Restrictions),
        ('extensionContainer', _CUG_Feature_extensionContainer),
        ])
    CUG_Feature._ext = []
    
    #-----< InterCUG-Restrictions >-----#
    InterCUG_Restrictions = OCT_STR(name='InterCUG-Restrictions', mode=MODE_TYPE)
    InterCUG_Restrictions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-SS-Data >-----#
    Ext_SS_Data = SEQ(name='Ext-SS-Data', mode=MODE_TYPE)
    _Ext_SS_Data_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_SS_Data_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_SS_Data_ss_SubscriptionOption = CHOICE(name='ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _Ext_SS_Data_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _Ext_SS_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_SS_Data._cont = ASN1Dict([
        ('ss-Code', _Ext_SS_Data_ss_Code),
        ('ss-Status', _Ext_SS_Data_ss_Status),
        ('ss-SubscriptionOption', _Ext_SS_Data_ss_SubscriptionOption),
        ('basicServiceGroupList', _Ext_SS_Data_basicServiceGroupList),
        ('extensionContainer', _Ext_SS_Data_extensionContainer),
        ])
    Ext_SS_Data._ext = []
    
    #-----< LCS-PrivacyExceptionList >-----#
    LCS_PrivacyExceptionList = SEQ_OF(name='LCS-PrivacyExceptionList', mode=MODE_TYPE)
    _LCS_PrivacyExceptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyClass')))
    LCS_PrivacyExceptionList._cont = _LCS_PrivacyExceptionList__item_
    LCS_PrivacyExceptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< maxNumOfPrivacyClass >-----#
    maxNumOfPrivacyClass = INT(name='maxNumOfPrivacyClass', mode=MODE_VALUE)
    maxNumOfPrivacyClass._val = 4
    
    #-----< LCS-PrivacyClass >-----#
    LCS_PrivacyClass = SEQ(name='LCS-PrivacyClass', mode=MODE_TYPE)
    _LCS_PrivacyClass_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _LCS_PrivacyClass_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _LCS_PrivacyClass_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _LCS_PrivacyClass_externalClientList = SEQ_OF(name='externalClientList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClientList')), opt=True)
    _LCS_PrivacyClass_plmnClientList = SEQ_OF(name='plmnClientList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PLMNClientList')), opt=True)
    _LCS_PrivacyClass_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCS_PrivacyClass_ext_externalClientList = SEQ_OF(name='ext-externalClientList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ExternalClientList')), opt=True)
    _LCS_PrivacyClass_serviceTypeList = SEQ_OF(name='serviceTypeList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceTypeList')), opt=True)
    LCS_PrivacyClass._cont = ASN1Dict([
        ('ss-Code', _LCS_PrivacyClass_ss_Code),
        ('ss-Status', _LCS_PrivacyClass_ss_Status),
        ('notificationToMSUser', _LCS_PrivacyClass_notificationToMSUser),
        ('externalClientList', _LCS_PrivacyClass_externalClientList),
        ('plmnClientList', _LCS_PrivacyClass_plmnClientList),
        ('extensionContainer', _LCS_PrivacyClass_extensionContainer),
        ('ext-externalClientList', _LCS_PrivacyClass_ext_externalClientList),
        ('serviceTypeList', _LCS_PrivacyClass_serviceTypeList),
        ])
    LCS_PrivacyClass._ext = ['ext-externalClientList', 'serviceTypeList']
    
    #-----< ExternalClientList >-----#
    ExternalClientList = SEQ_OF(name='ExternalClientList', mode=MODE_TYPE)
    _ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    ExternalClientList._cont = _ExternalClientList__item_
    ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfExternalClient >-----#
    maxNumOfExternalClient = INT(name='maxNumOfExternalClient', mode=MODE_VALUE)
    maxNumOfExternalClient._val = 5
    
    #-----< PLMNClientList >-----#
    PLMNClientList = SEQ_OF(name='PLMNClientList', mode=MODE_TYPE)
    _PLMNClientList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')))
    PLMNClientList._cont = _PLMNClientList__item_
    PLMNClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfPLMNClient >-----#
    maxNumOfPLMNClient = INT(name='maxNumOfPLMNClient', mode=MODE_VALUE)
    maxNumOfPLMNClient._val = 5
    
    #-----< Ext-ExternalClientList >-----#
    Ext_ExternalClientList = SEQ_OF(name='Ext-ExternalClientList', mode=MODE_TYPE)
    _Ext_ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    Ext_ExternalClientList._cont = _Ext_ExternalClientList__item_
    Ext_ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=35)], ev=None, er=[])
    
    #-----< maxNumOfExt-ExternalClient >-----#
    maxNumOfExt_ExternalClient = INT(name='maxNumOfExt-ExternalClient', mode=MODE_VALUE)
    maxNumOfExt_ExternalClient._val = 35
    
    #-----< ExternalClient >-----#
    ExternalClient = SEQ(name='ExternalClient', mode=MODE_TYPE)
    _ExternalClient_clientIdentity = SEQ(name='clientIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')))
    _ExternalClient_gmlc_Restriction = ENUM(name='gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ExternalClient_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ExternalClient_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalClient._cont = ASN1Dict([
        ('clientIdentity', _ExternalClient_clientIdentity),
        ('gmlc-Restriction', _ExternalClient_gmlc_Restriction),
        ('notificationToMSUser', _ExternalClient_notificationToMSUser),
        ('extensionContainer', _ExternalClient_extensionContainer),
        ])
    ExternalClient._ext = []
    
    #-----< GMLC-Restriction >-----#
    GMLC_Restriction = ENUM(name='GMLC-Restriction', mode=MODE_TYPE)
    GMLC_Restriction._cont = ASN1Dict([('gmlc-List', 0), ('home-Country', 1)])
    GMLC_Restriction._ext = []
    
    #-----< NotificationToMSUser >-----#
    NotificationToMSUser = ENUM(name='NotificationToMSUser', mode=MODE_TYPE)
    NotificationToMSUser._cont = ASN1Dict([('notifyLocationAllowed', 0), ('notifyAndVerify-LocationAllowedIfNoResponse', 1), ('notifyAndVerify-LocationNotAllowedIfNoResponse', 2), ('locationNotAllowed', 3)])
    NotificationToMSUser._ext = ['locationNotAllowed']
    
    #-----< ServiceTypeList >-----#
    ServiceTypeList = SEQ_OF(name='ServiceTypeList', mode=MODE_TYPE)
    _ServiceTypeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceType')))
    ServiceTypeList._cont = _ServiceTypeList__item_
    ServiceTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfServiceType >-----#
    maxNumOfServiceType = INT(name='maxNumOfServiceType', mode=MODE_VALUE)
    maxNumOfServiceType._val = 32
    
    #-----< ServiceType >-----#
    ServiceType = SEQ(name='ServiceType', mode=MODE_TYPE)
    _ServiceType_serviceTypeIdentity = INT(name='serviceTypeIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    _ServiceType_gmlc_Restriction = ENUM(name='gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ServiceType_notificationToMSUser = ENUM(name='notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ServiceType_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ServiceType._cont = ASN1Dict([
        ('serviceTypeIdentity', _ServiceType_serviceTypeIdentity),
        ('gmlc-Restriction', _ServiceType_gmlc_Restriction),
        ('notificationToMSUser', _ServiceType_notificationToMSUser),
        ('extensionContainer', _ServiceType_extensionContainer),
        ])
    ServiceType._ext = []
    
    #-----< MOLR-List >-----#
    MOLR_List = SEQ_OF(name='MOLR-List', mode=MODE_TYPE)
    _MOLR_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-Class')))
    MOLR_List._cont = _MOLR_List__item_
    MOLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< maxNumOfMOLR-Class >-----#
    maxNumOfMOLR_Class = INT(name='maxNumOfMOLR-Class', mode=MODE_VALUE)
    maxNumOfMOLR_Class._val = 3
    
    #-----< MOLR-Class >-----#
    MOLR_Class = SEQ(name='MOLR-Class', mode=MODE_TYPE)
    _MOLR_Class_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MOLR_Class_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MOLR_Class_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MOLR_Class._cont = ASN1Dict([
        ('ss-Code', _MOLR_Class_ss_Code),
        ('ss-Status', _MOLR_Class_ss_Status),
        ('extensionContainer', _MOLR_Class_extensionContainer),
        ])
    MOLR_Class._ext = []
    
    #-----< ZoneCodeList >-----#
    ZoneCodeList = SEQ_OF(name='ZoneCodeList', mode=MODE_TYPE)
    _ZoneCodeList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')))
    ZoneCodeList._cont = _ZoneCodeList__item_
    ZoneCodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< ZoneCode >-----#
    ZoneCode = OCT_STR(name='ZoneCode', mode=MODE_TYPE)
    ZoneCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< maxNumOfZoneCodes >-----#
    maxNumOfZoneCodes = INT(name='maxNumOfZoneCodes', mode=MODE_VALUE)
    maxNumOfZoneCodes._val = 10
    
    #-----< InsertSubscriberDataRes >-----#
    InsertSubscriberDataRes = SEQ(name='InsertSubscriberDataRes', mode=MODE_TYPE)
    _InsertSubscriberDataRes_teleserviceList = SEQ_OF(name='teleserviceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataRes_bearerServiceList = SEQ_OF(name='bearerServiceList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataRes_ss_List = SEQ_OF(name='ss-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _InsertSubscriberDataRes_odb_GeneralData = BIT_STR(name='odb-GeneralData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')), opt=True)
    _InsertSubscriberDataRes_regionalSubscriptionResponse = ENUM(name='regionalSubscriptionResponse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _InsertSubscriberDataRes_supportedCamelPhases = BIT_STR(name='supportedCamelPhases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _InsertSubscriberDataRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataRes_offeredCamel4CSIs = BIT_STR(name='offeredCamel4CSIs', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _InsertSubscriberDataRes_supportedFeatures = BIT_STR(name='supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _InsertSubscriberDataRes_ext_SupportedFeatures = BIT_STR(name='ext-SupportedFeatures', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    InsertSubscriberDataRes._cont = ASN1Dict([
        ('teleserviceList', _InsertSubscriberDataRes_teleserviceList),
        ('bearerServiceList', _InsertSubscriberDataRes_bearerServiceList),
        ('ss-List', _InsertSubscriberDataRes_ss_List),
        ('odb-GeneralData', _InsertSubscriberDataRes_odb_GeneralData),
        ('regionalSubscriptionResponse', _InsertSubscriberDataRes_regionalSubscriptionResponse),
        ('supportedCamelPhases', _InsertSubscriberDataRes_supportedCamelPhases),
        ('extensionContainer', _InsertSubscriberDataRes_extensionContainer),
        ('offeredCamel4CSIs', _InsertSubscriberDataRes_offeredCamel4CSIs),
        ('supportedFeatures', _InsertSubscriberDataRes_supportedFeatures),
        ('ext-SupportedFeatures', _InsertSubscriberDataRes_ext_SupportedFeatures),
        ])
    InsertSubscriberDataRes._ext = ['offeredCamel4CSIs', 'supportedFeatures', 'ext-SupportedFeatures']
    
    #-----< RegionalSubscriptionResponse >-----#
    RegionalSubscriptionResponse = ENUM(name='RegionalSubscriptionResponse', mode=MODE_TYPE)
    RegionalSubscriptionResponse._cont = ASN1Dict([('networkNode-AreaRestricted', 0), ('tooManyZoneCodes', 1), ('zoneCodesConflict', 2), ('regionalSubscNotSupported', 3)])
    RegionalSubscriptionResponse._ext = None
    
    #-----< DeleteSubscriberDataArg >-----#
    DeleteSubscriberDataArg = SEQ(name='DeleteSubscriberDataArg', mode=MODE_TYPE)
    _DeleteSubscriberDataArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _DeleteSubscriberDataArg_basicServiceList = SEQ_OF(name='basicServiceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _DeleteSubscriberDataArg_ss_List = SEQ_OF(name='ss-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name='roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_regionalSubscriptionIdentifier = OCT_STR(name='regionalSubscriptionIdentifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')), opt=True)
    _DeleteSubscriberDataArg_vbsGroupIndication = NULL(name='vbsGroupIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vgcsGroupIndication = NULL(name='vgcsGroupIndication', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw = NULL(name='camelSubscriptionInfoWithdraw', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw = CHOICE(name='gprsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature = NULL(name='roamingRestrictedInSgsnDueToUnsuppportedFeature', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_lsaInformationWithdraw = CHOICE(name='lsaInformationWithdraw', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformationWithdraw')), opt=True)
    _DeleteSubscriberDataArg_gmlc_ListWithdraw = NULL(name='gmlc-ListWithdraw', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_istInformationWithdraw = NULL(name='istInformationWithdraw', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_specificCSI_Withdraw = BIT_STR(name='specificCSI-Withdraw', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw = NULL(name='chargingCharacteristicsWithdraw', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_stn_srWithdraw = NULL(name='stn-srWithdraw', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw = CHOICE(name='epsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_apn_oi_replacementWithdraw = NULL(name='apn-oi-replacementWithdraw', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_csg_SubscriptionDeleted = NULL(name='csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw = NULL(name='subscribedPeriodicTAU-RAU-TimerWithdraw', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw = NULL(name='subscribedPeriodicLAU-TimerWithdraw', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw = NULL(name='subscribed-vsrvccWithdraw', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted = NULL(name='vplmn-Csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_additionalMSISDN_Withdraw = NULL(name='additionalMSISDN-Withdraw', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw = NULL(name='cs-to-ps-SRVCC-Withdraw', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw = NULL(name='imsiGroupIdList-Withdraw', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw = NULL(name='userPlaneIntegrityProtectionWithdraw', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw = NULL(name='dl-Buffering-Suggested-Packet-Count-Withdraw', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_ue_UsageTypeWithdraw = NULL(name='ue-UsageTypeWithdraw', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_reset_idsWithdraw = NULL(name='reset-idsWithdraw', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_iab_OperationWithdraw = NULL(name='iab-OperationWithdraw', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    DeleteSubscriberDataArg._cont = ASN1Dict([
        ('imsi', _DeleteSubscriberDataArg_imsi),
        ('basicServiceList', _DeleteSubscriberDataArg_basicServiceList),
        ('ss-List', _DeleteSubscriberDataArg_ss_List),
        ('roamingRestrictionDueToUnsupportedFeature', _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        ('regionalSubscriptionIdentifier', _DeleteSubscriberDataArg_regionalSubscriptionIdentifier),
        ('vbsGroupIndication', _DeleteSubscriberDataArg_vbsGroupIndication),
        ('vgcsGroupIndication', _DeleteSubscriberDataArg_vgcsGroupIndication),
        ('camelSubscriptionInfoWithdraw', _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw),
        ('extensionContainer', _DeleteSubscriberDataArg_extensionContainer),
        ('gprsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw),
        ('roamingRestrictedInSgsnDueToUnsuppportedFeature', _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature),
        ('lsaInformationWithdraw', _DeleteSubscriberDataArg_lsaInformationWithdraw),
        ('gmlc-ListWithdraw', _DeleteSubscriberDataArg_gmlc_ListWithdraw),
        ('istInformationWithdraw', _DeleteSubscriberDataArg_istInformationWithdraw),
        ('specificCSI-Withdraw', _DeleteSubscriberDataArg_specificCSI_Withdraw),
        ('chargingCharacteristicsWithdraw', _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw),
        ('stn-srWithdraw', _DeleteSubscriberDataArg_stn_srWithdraw),
        ('epsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw),
        ('apn-oi-replacementWithdraw', _DeleteSubscriberDataArg_apn_oi_replacementWithdraw),
        ('csg-SubscriptionDeleted', _DeleteSubscriberDataArg_csg_SubscriptionDeleted),
        ('subscribedPeriodicTAU-RAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw),
        ('subscribedPeriodicLAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw),
        ('subscribed-vsrvccWithdraw', _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw),
        ('vplmn-Csg-SubscriptionDeleted', _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted),
        ('additionalMSISDN-Withdraw', _DeleteSubscriberDataArg_additionalMSISDN_Withdraw),
        ('cs-to-ps-SRVCC-Withdraw', _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw),
        ('imsiGroupIdList-Withdraw', _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw),
        ('userPlaneIntegrityProtectionWithdraw', _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw),
        ('dl-Buffering-Suggested-Packet-Count-Withdraw', _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw),
        ('ue-UsageTypeWithdraw', _DeleteSubscriberDataArg_ue_UsageTypeWithdraw),
        ('reset-idsWithdraw', _DeleteSubscriberDataArg_reset_idsWithdraw),
        ('iab-OperationWithdraw', _DeleteSubscriberDataArg_iab_OperationWithdraw),
        ])
    DeleteSubscriberDataArg._ext = ['gprsSubscriptionDataWithdraw', 'roamingRestrictedInSgsnDueToUnsuppportedFeature', 'lsaInformationWithdraw', 'gmlc-ListWithdraw', 'istInformationWithdraw', 'specificCSI-Withdraw', 'chargingCharacteristicsWithdraw', 'stn-srWithdraw', 'epsSubscriptionDataWithdraw', 'apn-oi-replacementWithdraw', 'csg-SubscriptionDeleted', 'subscribedPeriodicTAU-RAU-TimerWithdraw', 'subscribedPeriodicLAU-TimerWithdraw', 'subscribed-vsrvccWithdraw', 'vplmn-Csg-SubscriptionDeleted', 'additionalMSISDN-Withdraw', 'cs-to-ps-SRVCC-Withdraw', 'imsiGroupIdList-Withdraw', 'userPlaneIntegrityProtectionWithdraw', 'dl-Buffering-Suggested-Packet-Count-Withdraw', 'ue-UsageTypeWithdraw', 'reset-idsWithdraw', 'iab-OperationWithdraw']
    
    #-----< SpecificCSI-Withdraw >-----#
    SpecificCSI_Withdraw = BIT_STR(name='SpecificCSI-Withdraw', mode=MODE_TYPE)
    SpecificCSI_Withdraw._cont = ASN1Dict([('o-csi', 0), ('ss-csi', 1), ('tif-csi', 2), ('d-csi', 3), ('vt-csi', 4), ('mo-sms-csi', 5), ('m-csi', 6), ('gprs-csi', 7), ('t-csi', 8), ('mt-sms-csi', 9), ('mg-csi', 10), ('o-IM-CSI', 11), ('d-IM-CSI', 12), ('vt-IM-CSI', 13)])
    SpecificCSI_Withdraw._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=32)], ev=None, er=[])
    
    #-----< GPRSSubscriptionDataWithdraw >-----#
    GPRSSubscriptionDataWithdraw = CHOICE(name='GPRSSubscriptionDataWithdraw', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_allGPRSData = NULL(name='allGPRSData', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_contextIdList = SEQ_OF(name='contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    GPRSSubscriptionDataWithdraw._cont = ASN1Dict([
        ('allGPRSData', _GPRSSubscriptionDataWithdraw_allGPRSData),
        ('contextIdList', _GPRSSubscriptionDataWithdraw_contextIdList),
        ])
    GPRSSubscriptionDataWithdraw._ext = None
    
    #-----< EPS-SubscriptionDataWithdraw >-----#
    EPS_SubscriptionDataWithdraw = CHOICE(name='EPS-SubscriptionDataWithdraw', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_allEPS_Data = NULL(name='allEPS-Data', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_contextIdList = SEQ_OF(name='contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    EPS_SubscriptionDataWithdraw._cont = ASN1Dict([
        ('allEPS-Data', _EPS_SubscriptionDataWithdraw_allEPS_Data),
        ('contextIdList', _EPS_SubscriptionDataWithdraw_contextIdList),
        ])
    EPS_SubscriptionDataWithdraw._ext = None
    
    #-----< ContextIdList >-----#
    ContextIdList = SEQ_OF(name='ContextIdList', mode=MODE_TYPE)
    _ContextIdList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    ContextIdList._cont = _ContextIdList__item_
    ContextIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< LSAInformationWithdraw >-----#
    LSAInformationWithdraw = CHOICE(name='LSAInformationWithdraw', mode=MODE_TYPE)
    _LSAInformationWithdraw_allLSAData = NULL(name='allLSAData', mode=MODE_TYPE)
    _LSAInformationWithdraw_lsaIdentityList = SEQ_OF(name='lsaIdentityList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentityList')))
    LSAInformationWithdraw._cont = ASN1Dict([
        ('allLSAData', _LSAInformationWithdraw_allLSAData),
        ('lsaIdentityList', _LSAInformationWithdraw_lsaIdentityList),
        ])
    LSAInformationWithdraw._ext = None
    
    #-----< LSAIdentityList >-----#
    LSAIdentityList = SEQ_OF(name='LSAIdentityList', mode=MODE_TYPE)
    _LSAIdentityList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    LSAIdentityList._cont = _LSAIdentityList__item_
    LSAIdentityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< BasicServiceList >-----#
    BasicServiceList = SEQ_OF(name='BasicServiceList', mode=MODE_TYPE)
    _BasicServiceList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceList._cont = _BasicServiceList__item_
    BasicServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=None, er=[])
    
    #-----< maxNumOfBasicServices >-----#
    maxNumOfBasicServices = INT(name='maxNumOfBasicServices', mode=MODE_VALUE)
    maxNumOfBasicServices._val = 70
    
    #-----< DeleteSubscriberDataRes >-----#
    DeleteSubscriberDataRes = SEQ(name='DeleteSubscriberDataRes', mode=MODE_TYPE)
    _DeleteSubscriberDataRes_regionalSubscriptionResponse = ENUM(name='regionalSubscriptionResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _DeleteSubscriberDataRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeleteSubscriberDataRes._cont = ASN1Dict([
        ('regionalSubscriptionResponse', _DeleteSubscriberDataRes_regionalSubscriptionResponse),
        ('extensionContainer', _DeleteSubscriberDataRes_extensionContainer),
        ])
    DeleteSubscriberDataRes._ext = []
    
    #-----< VlrCamelSubscriptionInfo >-----#
    VlrCamelSubscriptionInfo = SEQ(name='VlrCamelSubscriptionInfo', mode=MODE_TYPE)
    _VlrCamelSubscriptionInfo_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VlrCamelSubscriptionInfo_ss_CSI = SEQ(name='ss-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_tif_CSI = NULL(name='tif-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VlrCamelSubscriptionInfo_m_CSI = SEQ(name='m-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mo_sms_CSI = SEQ(name='mo-sms-CSI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_vt_CSI = SEQ(name='vt-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='t-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_d_CSI = SEQ(name='d-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_sms_CSI = SEQ(name='mt-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name='mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    VlrCamelSubscriptionInfo._cont = ASN1Dict([
        ('o-CSI', _VlrCamelSubscriptionInfo_o_CSI),
        ('extensionContainer', _VlrCamelSubscriptionInfo_extensionContainer),
        ('ss-CSI', _VlrCamelSubscriptionInfo_ss_CSI),
        ('o-BcsmCamelTDP-CriteriaList', _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        ('tif-CSI', _VlrCamelSubscriptionInfo_tif_CSI),
        ('m-CSI', _VlrCamelSubscriptionInfo_m_CSI),
        ('mo-sms-CSI', _VlrCamelSubscriptionInfo_mo_sms_CSI),
        ('vt-CSI', _VlrCamelSubscriptionInfo_vt_CSI),
        ('t-BCSM-CAMEL-TDP-CriteriaList', _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        ('d-CSI', _VlrCamelSubscriptionInfo_d_CSI),
        ('mt-sms-CSI', _VlrCamelSubscriptionInfo_mt_sms_CSI),
        ('mt-smsCAMELTDP-CriteriaList', _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ])
    VlrCamelSubscriptionInfo._ext = ['ss-CSI', 'o-BcsmCamelTDP-CriteriaList', 'tif-CSI', 'm-CSI', 'mo-sms-CSI', 'vt-CSI', 't-BCSM-CAMEL-TDP-CriteriaList', 'd-CSI', 'mt-sms-CSI', 'mt-smsCAMELTDP-CriteriaList']
    
    #-----< MT-smsCAMELTDP-CriteriaList >-----#
    MT_smsCAMELTDP_CriteriaList = SEQ_OF(name='MT-smsCAMELTDP-CriteriaList', mode=MODE_TYPE)
    _MT_smsCAMELTDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-Criteria')))
    MT_smsCAMELTDP_CriteriaList._cont = _MT_smsCAMELTDP_CriteriaList__item_
    MT_smsCAMELTDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< MT-smsCAMELTDP-Criteria >-----#
    MT_smsCAMELTDP_Criteria = SEQ(name='MT-smsCAMELTDP-Criteria', mode=MODE_TYPE)
    _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint = ENUM(name='sms-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion = SEQ_OF(name='tpdu-TypeCriterion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TPDU-TypeCriterion')), opt=True)
    MT_smsCAMELTDP_Criteria._cont = ASN1Dict([
        ('sms-TriggerDetectionPoint', _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint),
        ('tpdu-TypeCriterion', _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion),
        ])
    MT_smsCAMELTDP_Criteria._ext = []
    
    #-----< TPDU-TypeCriterion >-----#
    TPDU_TypeCriterion = SEQ_OF(name='TPDU-TypeCriterion', mode=MODE_TYPE)
    _TPDU_TypeCriterion__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-SMS-TPDU-Type')))
    TPDU_TypeCriterion._cont = _TPDU_TypeCriterion__item_
    TPDU_TypeCriterion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfTPDUTypes >-----#
    maxNumOfTPDUTypes = INT(name='maxNumOfTPDUTypes', mode=MODE_VALUE)
    maxNumOfTPDUTypes._val = 5
    
    #-----< MT-SMS-TPDU-Type >-----#
    MT_SMS_TPDU_Type = ENUM(name='MT-SMS-TPDU-Type', mode=MODE_TYPE)
    MT_SMS_TPDU_Type._cont = ASN1Dict([('sms-DELIVER', 0), ('sms-SUBMIT-REPORT', 1), ('sms-STATUS-REPORT', 2)])
    MT_SMS_TPDU_Type._ext = []
    
    #-----< D-CSI >-----#
    D_CSI = SEQ(name='D-CSI', mode=MODE_TYPE)
    _D_CSI_dp_AnalysedInfoCriteriaList = SEQ_OF(name='dp-AnalysedInfoCriteriaList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriteriaList')), opt=True)
    _D_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _D_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _D_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _D_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    D_CSI._cont = ASN1Dict([
        ('dp-AnalysedInfoCriteriaList', _D_CSI_dp_AnalysedInfoCriteriaList),
        ('camelCapabilityHandling', _D_CSI_camelCapabilityHandling),
        ('extensionContainer', _D_CSI_extensionContainer),
        ('notificationToCSE', _D_CSI_notificationToCSE),
        ('csi-Active', _D_CSI_csi_Active),
        ])
    D_CSI._ext = []
    
    #-----< DP-AnalysedInfoCriteriaList >-----#
    DP_AnalysedInfoCriteriaList = SEQ_OF(name='DP-AnalysedInfoCriteriaList', mode=MODE_TYPE)
    _DP_AnalysedInfoCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriterium')))
    DP_AnalysedInfoCriteriaList._cont = _DP_AnalysedInfoCriteriaList__item_
    DP_AnalysedInfoCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfDP-AnalysedInfoCriteria >-----#
    maxNumOfDP_AnalysedInfoCriteria = INT(name='maxNumOfDP-AnalysedInfoCriteria', mode=MODE_VALUE)
    maxNumOfDP_AnalysedInfoCriteria._val = 10
    
    #-----< DP-AnalysedInfoCriterium >-----#
    DP_AnalysedInfoCriterium = SEQ(name='DP-AnalysedInfoCriterium', mode=MODE_TYPE)
    _DP_AnalysedInfoCriterium_dialledNumber = OCT_STR(name='dialledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _DP_AnalysedInfoCriterium_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _DP_AnalysedInfoCriterium_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DP_AnalysedInfoCriterium._cont = ASN1Dict([
        ('dialledNumber', _DP_AnalysedInfoCriterium_dialledNumber),
        ('serviceKey', _DP_AnalysedInfoCriterium_serviceKey),
        ('gsmSCF-Address', _DP_AnalysedInfoCriterium_gsmSCF_Address),
        ('defaultCallHandling', _DP_AnalysedInfoCriterium_defaultCallHandling),
        ('extensionContainer', _DP_AnalysedInfoCriterium_extensionContainer),
        ])
    DP_AnalysedInfoCriterium._ext = []
    
    #-----< SS-CSI >-----#
    SS_CSI = SEQ(name='SS-CSI', mode=MODE_TYPE)
    _SS_CSI_ss_CamelData = SEQ(name='ss-CamelData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CamelData')))
    _SS_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SS_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_CSI._cont = ASN1Dict([
        ('ss-CamelData', _SS_CSI_ss_CamelData),
        ('extensionContainer', _SS_CSI_extensionContainer),
        ('notificationToCSE', _SS_CSI_notificationToCSE),
        ('csi-Active', _SS_CSI_csi_Active),
        ])
    SS_CSI._ext = ['notificationToCSE', 'csi-Active']
    
    #-----< SS-CamelData >-----#
    SS_CamelData = SEQ(name='SS-CamelData', mode=MODE_TYPE)
    _SS_CamelData_ss_EventList = SEQ_OF(name='ss-EventList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-EventList')))
    _SS_CamelData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_CamelData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_CamelData._cont = ASN1Dict([
        ('ss-EventList', _SS_CamelData_ss_EventList),
        ('gsmSCF-Address', _SS_CamelData_gsmSCF_Address),
        ('extensionContainer', _SS_CamelData_extensionContainer),
        ])
    SS_CamelData._ext = []
    
    #-----< SS-EventList >-----#
    SS_EventList = SEQ_OF(name='SS-EventList', mode=MODE_TYPE)
    _SS_EventList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_EventList._cont = _SS_EventList__item_
    SS_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelSSEvents >-----#
    maxNumOfCamelSSEvents = INT(name='maxNumOfCamelSSEvents', mode=MODE_VALUE)
    maxNumOfCamelSSEvents._val = 10
    
    #-----< O-CSI >-----#
    O_CSI = SEQ(name='O-CSI', mode=MODE_TYPE)
    _O_CSI_o_BcsmCamelTDPDataList = SEQ_OF(name='o-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPDataList')))
    _O_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _O_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _O_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _O_CSI_csiActive = NULL(name='csiActive', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    O_CSI._cont = ASN1Dict([
        ('o-BcsmCamelTDPDataList', _O_CSI_o_BcsmCamelTDPDataList),
        ('extensionContainer', _O_CSI_extensionContainer),
        ('camelCapabilityHandling', _O_CSI_camelCapabilityHandling),
        ('notificationToCSE', _O_CSI_notificationToCSE),
        ('csiActive', _O_CSI_csiActive),
        ])
    O_CSI._ext = ['camelCapabilityHandling', 'notificationToCSE', 'csiActive']
    
    #-----< O-BcsmCamelTDPDataList >-----#
    O_BcsmCamelTDPDataList = SEQ_OF(name='O-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _O_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPData')))
    O_BcsmCamelTDPDataList._cont = _O_BcsmCamelTDPDataList__item_
    O_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelTDPData >-----#
    maxNumOfCamelTDPData = INT(name='maxNumOfCamelTDPData', mode=MODE_VALUE)
    maxNumOfCamelTDPData._val = 10
    
    #-----< O-BcsmCamelTDPData >-----#
    O_BcsmCamelTDPData = SEQ(name='O-BcsmCamelTDPData', mode=MODE_TYPE)
    _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint = ENUM(name='o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDPData_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _O_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _O_BcsmCamelTDPData_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _O_BcsmCamelTDPData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDPData._cont = ASN1Dict([
        ('o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint),
        ('serviceKey', _O_BcsmCamelTDPData_serviceKey),
        ('gsmSCF-Address', _O_BcsmCamelTDPData_gsmSCF_Address),
        ('defaultCallHandling', _O_BcsmCamelTDPData_defaultCallHandling),
        ('extensionContainer', _O_BcsmCamelTDPData_extensionContainer),
        ])
    O_BcsmCamelTDPData._ext = []
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name='ServiceKey', mode=MODE_TYPE)
    ServiceKey._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< O-BcsmTriggerDetectionPoint >-----#
    O_BcsmTriggerDetectionPoint = ENUM(name='O-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    O_BcsmTriggerDetectionPoint._cont = ASN1Dict([('collectedInfo', 2), ('routeSelectFailure', 4)])
    O_BcsmTriggerDetectionPoint._ext = ['routeSelectFailure']
    
    #-----< O-BcsmCamelTDPCriteriaList >-----#
    O_BcsmCamelTDPCriteriaList = SEQ_OF(name='O-BcsmCamelTDPCriteriaList', mode=MODE_TYPE)
    _O_BcsmCamelTDPCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDP-Criteria')))
    O_BcsmCamelTDPCriteriaList._cont = _O_BcsmCamelTDPCriteriaList__item_
    O_BcsmCamelTDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BCSM-CAMEL-TDP-CriteriaList >-----#
    T_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='T-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-Criteria')))
    T_BCSM_CAMEL_TDP_CriteriaList._cont = _T_BCSM_CAMEL_TDP_CriteriaList__item_
    T_BCSM_CAMEL_TDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< O-BcsmCamelTDP-Criteria >-----#
    O_BcsmCamelTDP_Criteria = SEQ(name='O-BcsmCamelTDP-Criteria', mode=MODE_TYPE)
    _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint = ENUM(name='o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDP_Criteria_destinationNumberCriteria = SEQ(name='destinationNumberCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_basicServiceCriteria = SEQ_OF(name='basicServiceCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_callTypeCriteria = ENUM(name='callTypeCriteria', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallTypeCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria = SEQ_OF(name='o-CauseValueCriteria', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CauseValueCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDP_Criteria._cont = ASN1Dict([
        ('o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint),
        ('destinationNumberCriteria', _O_BcsmCamelTDP_Criteria_destinationNumberCriteria),
        ('basicServiceCriteria', _O_BcsmCamelTDP_Criteria_basicServiceCriteria),
        ('callTypeCriteria', _O_BcsmCamelTDP_Criteria_callTypeCriteria),
        ('o-CauseValueCriteria', _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria),
        ('extensionContainer', _O_BcsmCamelTDP_Criteria_extensionContainer),
        ])
    O_BcsmCamelTDP_Criteria._ext = ['o-CauseValueCriteria', 'extensionContainer']
    
    #-----< T-BCSM-CAMEL-TDP-Criteria >-----#
    T_BCSM_CAMEL_TDP_Criteria = SEQ(name='T-BCSM-CAMEL-TDP-Criteria', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint = ENUM(name='t-BCSM-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria = SEQ_OF(name='basicServiceCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria = SEQ_OF(name='t-CauseValueCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CauseValueCriteria')), opt=True)
    T_BCSM_CAMEL_TDP_Criteria._cont = ASN1Dict([
        ('t-BCSM-TriggerDetectionPoint', _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint),
        ('basicServiceCriteria', _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria),
        ('t-CauseValueCriteria', _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria),
        ])
    T_BCSM_CAMEL_TDP_Criteria._ext = []
    
    #-----< DestinationNumberCriteria >-----#
    DestinationNumberCriteria = SEQ(name='DestinationNumberCriteria', mode=MODE_TYPE)
    _DestinationNumberCriteria_matchType = ENUM(name='matchType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MatchType')))
    _DestinationNumberCriteria_destinationNumberList = SEQ_OF(name='destinationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberList')), opt=True)
    _DestinationNumberCriteria_destinationNumberLengthList = SEQ_OF(name='destinationNumberLengthList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberLengthList')), opt=True)
    DestinationNumberCriteria._cont = ASN1Dict([
        ('matchType', _DestinationNumberCriteria_matchType),
        ('destinationNumberList', _DestinationNumberCriteria_destinationNumberList),
        ('destinationNumberLengthList', _DestinationNumberCriteria_destinationNumberLengthList),
        ])
    DestinationNumberCriteria._ext = []
    
    #-----< DestinationNumberList >-----#
    DestinationNumberList = SEQ_OF(name='DestinationNumberList', mode=MODE_TYPE)
    _DestinationNumberList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    DestinationNumberList._cont = _DestinationNumberList__item_
    DestinationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< DestinationNumberLengthList >-----#
    DestinationNumberLengthList = SEQ_OF(name='DestinationNumberLengthList', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_ = INT(name='_item_', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    DestinationNumberLengthList._cont = _DestinationNumberLengthList__item_
    DestinationNumberLengthList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< BasicServiceCriteria >-----#
    BasicServiceCriteria = SEQ_OF(name='BasicServiceCriteria', mode=MODE_TYPE)
    _BasicServiceCriteria__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceCriteria._cont = _BasicServiceCriteria__item_
    BasicServiceCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfISDN-AddressDigits >-----#
    maxNumOfISDN_AddressDigits = INT(name='maxNumOfISDN-AddressDigits', mode=MODE_VALUE)
    maxNumOfISDN_AddressDigits._val = 15
    
    #-----< maxNumOfCamelDestinationNumbers >-----#
    maxNumOfCamelDestinationNumbers = INT(name='maxNumOfCamelDestinationNumbers', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumbers._val = 10
    
    #-----< maxNumOfCamelDestinationNumberLengths >-----#
    maxNumOfCamelDestinationNumberLengths = INT(name='maxNumOfCamelDestinationNumberLengths', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumberLengths._val = 3
    
    #-----< maxNumOfCamelBasicServiceCriteria >-----#
    maxNumOfCamelBasicServiceCriteria = INT(name='maxNumOfCamelBasicServiceCriteria', mode=MODE_VALUE)
    maxNumOfCamelBasicServiceCriteria._val = 5
    
    #-----< CallTypeCriteria >-----#
    CallTypeCriteria = ENUM(name='CallTypeCriteria', mode=MODE_TYPE)
    CallTypeCriteria._cont = ASN1Dict([('forwarded', 0), ('notForwarded', 1)])
    CallTypeCriteria._ext = None
    
    #-----< MatchType >-----#
    MatchType = ENUM(name='MatchType', mode=MODE_TYPE)
    MatchType._cont = ASN1Dict([('inhibiting', 0), ('enabling', 1)])
    MatchType._ext = None
    
    #-----< O-CauseValueCriteria >-----#
    O_CauseValueCriteria = SEQ_OF(name='O-CauseValueCriteria', mode=MODE_TYPE)
    _O_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    O_CauseValueCriteria._cont = _O_CauseValueCriteria__item_
    O_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< T-CauseValueCriteria >-----#
    T_CauseValueCriteria = SEQ_OF(name='T-CauseValueCriteria', mode=MODE_TYPE)
    _T_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    T_CauseValueCriteria._cont = _T_CauseValueCriteria__item_
    T_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCAMEL-O-CauseValueCriteria >-----#
    maxNumOfCAMEL_O_CauseValueCriteria = INT(name='maxNumOfCAMEL-O-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_O_CauseValueCriteria._val = 5
    
    #-----< maxNumOfCAMEL-T-CauseValueCriteria >-----#
    maxNumOfCAMEL_T_CauseValueCriteria = INT(name='maxNumOfCAMEL-T-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_T_CauseValueCriteria._val = 5
    
    #-----< CauseValue >-----#
    CauseValue = OCT_STR(name='CauseValue', mode=MODE_TYPE)
    CauseValue._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< DefaultCallHandling >-----#
    DefaultCallHandling = ENUM(name='DefaultCallHandling', mode=MODE_TYPE)
    DefaultCallHandling._cont = ASN1Dict([('continueCall', 0), ('releaseCall', 1)])
    DefaultCallHandling._ext = []
    
    #-----< CamelCapabilityHandling >-----#
    CamelCapabilityHandling = INT(name='CamelCapabilityHandling', mode=MODE_TYPE)
    CamelCapabilityHandling._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SupportedCamelPhases >-----#
    SupportedCamelPhases = BIT_STR(name='SupportedCamelPhases', mode=MODE_TYPE)
    SupportedCamelPhases._cont = ASN1Dict([('phase1', 0), ('phase2', 1), ('phase3', 2), ('phase4', 3)])
    SupportedCamelPhases._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4CSIs >-----#
    OfferedCamel4CSIs = BIT_STR(name='OfferedCamel4CSIs', mode=MODE_TYPE)
    OfferedCamel4CSIs._cont = ASN1Dict([('o-csi', 0), ('d-csi', 1), ('vt-csi', 2), ('t-csi', 3), ('mt-sms-csi', 4), ('mg-csi', 5), ('psi-enhancements', 6)])
    OfferedCamel4CSIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4Functionalities >-----#
    OfferedCamel4Functionalities = BIT_STR(name='OfferedCamel4Functionalities', mode=MODE_TYPE)
    OfferedCamel4Functionalities._cont = ASN1Dict([('initiateCallAttempt', 0), ('splitLeg', 1), ('moveLeg', 2), ('disconnectLeg', 3), ('entityReleased', 4), ('dfc-WithArgument', 5), ('playTone', 6), ('dtmf-MidCall', 7), ('chargingIndicator', 8), ('alertingDP', 9), ('locationAtAlerting', 10), ('changeOfPositionDP', 11), ('or-Interactions', 12), ('warningToneEnhancements', 13), ('cf-Enhancements', 14), ('subscribedEnhancedDialledServices', 15), ('servingNetworkEnhancedDialledServices', 16), ('criteriaForChangeOfPositionDP', 17), ('serviceChangeDP', 18), ('collectInformation', 19)])
    OfferedCamel4Functionalities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=64)], ev=None, er=[])
    
    #-----< SMS-CSI >-----#
    SMS_CSI = SEQ(name='SMS-CSI', mode=MODE_TYPE)
    _SMS_CSI_sms_CAMEL_TDP_DataList = SEQ_OF(name='sms-CAMEL-TDP-DataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-DataList')), opt=True)
    _SMS_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _SMS_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SMS_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMS_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SMS_CSI._cont = ASN1Dict([
        ('sms-CAMEL-TDP-DataList', _SMS_CSI_sms_CAMEL_TDP_DataList),
        ('camelCapabilityHandling', _SMS_CSI_camelCapabilityHandling),
        ('extensionContainer', _SMS_CSI_extensionContainer),
        ('notificationToCSE', _SMS_CSI_notificationToCSE),
        ('csi-Active', _SMS_CSI_csi_Active),
        ])
    SMS_CSI._ext = []
    
    #-----< SMS-CAMEL-TDP-DataList >-----#
    SMS_CAMEL_TDP_DataList = SEQ_OF(name='SMS-CAMEL-TDP-DataList', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-Data')))
    SMS_CAMEL_TDP_DataList._cont = _SMS_CAMEL_TDP_DataList__item_
    SMS_CAMEL_TDP_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< SMS-CAMEL-TDP-Data >-----#
    SMS_CAMEL_TDP_Data = SEQ(name='SMS-CAMEL-TDP-Data', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint = ENUM(name='sms-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _SMS_CAMEL_TDP_Data_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _SMS_CAMEL_TDP_Data_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SMS_CAMEL_TDP_Data_defaultSMS_Handling = ENUM(name='defaultSMS-Handling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')))
    _SMS_CAMEL_TDP_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SMS_CAMEL_TDP_Data._cont = ASN1Dict([
        ('sms-TriggerDetectionPoint', _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint),
        ('serviceKey', _SMS_CAMEL_TDP_Data_serviceKey),
        ('gsmSCF-Address', _SMS_CAMEL_TDP_Data_gsmSCF_Address),
        ('defaultSMS-Handling', _SMS_CAMEL_TDP_Data_defaultSMS_Handling),
        ('extensionContainer', _SMS_CAMEL_TDP_Data_extensionContainer),
        ])
    SMS_CAMEL_TDP_Data._ext = []
    
    #-----< SMS-TriggerDetectionPoint >-----#
    SMS_TriggerDetectionPoint = ENUM(name='SMS-TriggerDetectionPoint', mode=MODE_TYPE)
    SMS_TriggerDetectionPoint._cont = ASN1Dict([('sms-CollectedInfo', 1), ('sms-DeliveryRequest', 2)])
    SMS_TriggerDetectionPoint._ext = ['sms-DeliveryRequest']
    
    #-----< DefaultSMS-Handling >-----#
    DefaultSMS_Handling = ENUM(name='DefaultSMS-Handling', mode=MODE_TYPE)
    DefaultSMS_Handling._cont = ASN1Dict([('continueTransaction', 0), ('releaseTransaction', 1)])
    DefaultSMS_Handling._ext = []
    
    #-----< M-CSI >-----#
    M_CSI = SEQ(name='M-CSI', mode=MODE_TYPE)
    _M_CSI_mobilityTriggers = SEQ_OF(name='mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _M_CSI_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _M_CSI_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _M_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _M_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _M_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    M_CSI._cont = ASN1Dict([
        ('mobilityTriggers', _M_CSI_mobilityTriggers),
        ('serviceKey', _M_CSI_serviceKey),
        ('gsmSCF-Address', _M_CSI_gsmSCF_Address),
        ('extensionContainer', _M_CSI_extensionContainer),
        ('notificationToCSE', _M_CSI_notificationToCSE),
        ('csi-Active', _M_CSI_csi_Active),
        ])
    M_CSI._ext = []
    
    #-----< MG-CSI >-----#
    MG_CSI = SEQ(name='MG-CSI', mode=MODE_TYPE)
    _MG_CSI_mobilityTriggers = SEQ_OF(name='mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _MG_CSI_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _MG_CSI_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MG_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MG_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MG_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MG_CSI._cont = ASN1Dict([
        ('mobilityTriggers', _MG_CSI_mobilityTriggers),
        ('serviceKey', _MG_CSI_serviceKey),
        ('gsmSCF-Address', _MG_CSI_gsmSCF_Address),
        ('extensionContainer', _MG_CSI_extensionContainer),
        ('notificationToCSE', _MG_CSI_notificationToCSE),
        ('csi-Active', _MG_CSI_csi_Active),
        ])
    MG_CSI._ext = []
    
    #-----< MobilityTriggers >-----#
    MobilityTriggers = SEQ_OF(name='MobilityTriggers', mode=MODE_TYPE)
    _MobilityTriggers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    MobilityTriggers._cont = _MobilityTriggers__item_
    MobilityTriggers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfMobilityTriggers >-----#
    maxNumOfMobilityTriggers = INT(name='maxNumOfMobilityTriggers', mode=MODE_VALUE)
    maxNumOfMobilityTriggers._val = 10
    
    #-----< MM-Code >-----#
    MM_Code = OCT_STR(name='MM-Code', mode=MODE_TYPE)
    MM_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< T-CSI >-----#
    T_CSI = SEQ(name='T-CSI', mode=MODE_TYPE)
    _T_CSI_t_BcsmCamelTDPDataList = SEQ_OF(name='t-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPDataList')))
    _T_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _T_CSI_camelCapabilityHandling = INT(name='camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _T_CSI_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _T_CSI_csi_Active = NULL(name='csi-Active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    T_CSI._cont = ASN1Dict([
        ('t-BcsmCamelTDPDataList', _T_CSI_t_BcsmCamelTDPDataList),
        ('extensionContainer', _T_CSI_extensionContainer),
        ('camelCapabilityHandling', _T_CSI_camelCapabilityHandling),
        ('notificationToCSE', _T_CSI_notificationToCSE),
        ('csi-Active', _T_CSI_csi_Active),
        ])
    T_CSI._ext = ['camelCapabilityHandling', 'notificationToCSE', 'csi-Active']
    
    #-----< T-BcsmCamelTDPDataList >-----#
    T_BcsmCamelTDPDataList = SEQ_OF(name='T-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _T_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPData')))
    T_BcsmCamelTDPDataList._cont = _T_BcsmCamelTDPDataList__item_
    T_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BcsmCamelTDPData >-----#
    T_BcsmCamelTDPData = SEQ(name='T-BcsmCamelTDPData', mode=MODE_TYPE)
    _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint = ENUM(name='t-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BcsmCamelTDPData_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _T_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _T_BcsmCamelTDPData_defaultCallHandling = ENUM(name='defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _T_BcsmCamelTDPData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    T_BcsmCamelTDPData._cont = ASN1Dict([
        ('t-BcsmTriggerDetectionPoint', _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint),
        ('serviceKey', _T_BcsmCamelTDPData_serviceKey),
        ('gsmSCF-Address', _T_BcsmCamelTDPData_gsmSCF_Address),
        ('defaultCallHandling', _T_BcsmCamelTDPData_defaultCallHandling),
        ('extensionContainer', _T_BcsmCamelTDPData_extensionContainer),
        ])
    T_BcsmCamelTDPData._ext = []
    
    #-----< T-BcsmTriggerDetectionPoint >-----#
    T_BcsmTriggerDetectionPoint = ENUM(name='T-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    T_BcsmTriggerDetectionPoint._cont = ASN1Dict([('termAttemptAuthorized', 12), ('tBusy', 13), ('tNoAnswer', 14)])
    T_BcsmTriggerDetectionPoint._ext = ['tBusy', 'tNoAnswer']
    
    #-----< SendRoutingInfoForGprsArg >-----#
    SendRoutingInfoForGprsArg = SEQ(name='SendRoutingInfoForGprsArg', mode=MODE_TYPE)
    _SendRoutingInfoForGprsArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendRoutingInfoForGprsArg_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsArg_ggsn_Number = OCT_STR(name='ggsn-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoForGprsArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsArg._cont = ASN1Dict([
        ('imsi', _SendRoutingInfoForGprsArg_imsi),
        ('ggsn-Address', _SendRoutingInfoForGprsArg_ggsn_Address),
        ('ggsn-Number', _SendRoutingInfoForGprsArg_ggsn_Number),
        ('extensionContainer', _SendRoutingInfoForGprsArg_extensionContainer),
        ])
    SendRoutingInfoForGprsArg._ext = []
    
    #-----< SendRoutingInfoForGprsRes >-----#
    SendRoutingInfoForGprsRes = SEQ(name='SendRoutingInfoForGprsRes', mode=MODE_TYPE)
    _SendRoutingInfoForGprsRes_sgsn_Address = OCT_STR(name='sgsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _SendRoutingInfoForGprsRes_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsRes_mobileNotReachableReason = INT(name='mobileNotReachableReason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _SendRoutingInfoForGprsRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsRes._cont = ASN1Dict([
        ('sgsn-Address', _SendRoutingInfoForGprsRes_sgsn_Address),
        ('ggsn-Address', _SendRoutingInfoForGprsRes_ggsn_Address),
        ('mobileNotReachableReason', _SendRoutingInfoForGprsRes_mobileNotReachableReason),
        ('extensionContainer', _SendRoutingInfoForGprsRes_extensionContainer),
        ])
    SendRoutingInfoForGprsRes._ext = []
    
    #-----< FailureReportArg >-----#
    FailureReportArg = SEQ(name='FailureReportArg', mode=MODE_TYPE)
    _FailureReportArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _FailureReportArg_ggsn_Number = OCT_STR(name='ggsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _FailureReportArg_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportArg._cont = ASN1Dict([
        ('imsi', _FailureReportArg_imsi),
        ('ggsn-Number', _FailureReportArg_ggsn_Number),
        ('ggsn-Address', _FailureReportArg_ggsn_Address),
        ('extensionContainer', _FailureReportArg_extensionContainer),
        ])
    FailureReportArg._ext = []
    
    #-----< FailureReportRes >-----#
    FailureReportRes = SEQ(name='FailureReportRes', mode=MODE_TYPE)
    _FailureReportRes_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportRes._cont = ASN1Dict([
        ('ggsn-Address', _FailureReportRes_ggsn_Address),
        ('extensionContainer', _FailureReportRes_extensionContainer),
        ])
    FailureReportRes._ext = []
    
    #-----< NoteMsPresentForGprsArg >-----#
    NoteMsPresentForGprsArg = SEQ(name='NoteMsPresentForGprsArg', mode=MODE_TYPE)
    _NoteMsPresentForGprsArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMsPresentForGprsArg_sgsn_Address = OCT_STR(name='sgsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _NoteMsPresentForGprsArg_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _NoteMsPresentForGprsArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsArg._cont = ASN1Dict([
        ('imsi', _NoteMsPresentForGprsArg_imsi),
        ('sgsn-Address', _NoteMsPresentForGprsArg_sgsn_Address),
        ('ggsn-Address', _NoteMsPresentForGprsArg_ggsn_Address),
        ('extensionContainer', _NoteMsPresentForGprsArg_extensionContainer),
        ])
    NoteMsPresentForGprsArg._ext = []
    
    #-----< NoteMsPresentForGprsRes >-----#
    NoteMsPresentForGprsRes = SEQ(name='NoteMsPresentForGprsRes', mode=MODE_TYPE)
    _NoteMsPresentForGprsRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsRes._cont = ASN1Dict([
        ('extensionContainer', _NoteMsPresentForGprsRes_extensionContainer),
        ])
    NoteMsPresentForGprsRes._ext = []
    
    #-----< ResetArg >-----#
    ResetArg = SEQ(name='ResetArg', mode=MODE_TYPE)
    _ResetArg_sendingNodenumber = CHOICE(name='sendingNodenumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SendingNode-Number')))
    _ResetArg_hlr_List = SEQ_OF(name='hlr-List', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-List')), opt=True)
    _ResetArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResetArg_reset_Id_List = SEQ_OF(name='reset-Id-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _ResetArg_subscriptionData = SEQ(name='subscriptionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'InsertSubscriberDataArg')), opt=True)
    _ResetArg_subscriptionDataDeletion = SEQ(name='subscriptionDataDeletion', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DeleteSubscriberDataArg')), opt=True)
    ResetArg._cont = ASN1Dict([
        ('sendingNodenumber', _ResetArg_sendingNodenumber),
        ('hlr-List', _ResetArg_hlr_List),
        ('extensionContainer', _ResetArg_extensionContainer),
        ('reset-Id-List', _ResetArg_reset_Id_List),
        ('subscriptionData', _ResetArg_subscriptionData),
        ('subscriptionDataDeletion', _ResetArg_subscriptionDataDeletion),
        ])
    ResetArg._ext = ['reset-Id-List', 'subscriptionData', 'subscriptionDataDeletion']
    
    #-----< SendingNode-Number >-----#
    SendingNode_Number = CHOICE(name='SendingNode-Number', mode=MODE_TYPE)
    _SendingNode_Number_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendingNode_Number_css_Number = OCT_STR(name='css-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SendingNode_Number._cont = ASN1Dict([
        ('hlr-Number', _SendingNode_Number_hlr_Number),
        ('css-Number', _SendingNode_Number_css_Number),
        ])
    SendingNode_Number._ext = None
    
    #-----< RestoreDataArg >-----#
    RestoreDataArg = SEQ(name='RestoreDataArg', mode=MODE_TYPE)
    _RestoreDataArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RestoreDataArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _RestoreDataArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RestoreDataArg_vlr_Capability = SEQ(name='vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _RestoreDataArg_restorationIndicator = NULL(name='restorationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RestoreDataArg._cont = ASN1Dict([
        ('imsi', _RestoreDataArg_imsi),
        ('lmsi', _RestoreDataArg_lmsi),
        ('extensionContainer', _RestoreDataArg_extensionContainer),
        ('vlr-Capability', _RestoreDataArg_vlr_Capability),
        ('restorationIndicator', _RestoreDataArg_restorationIndicator),
        ])
    RestoreDataArg._ext = ['vlr-Capability', 'restorationIndicator']
    
    #-----< RestoreDataRes >-----#
    RestoreDataRes = SEQ(name='RestoreDataRes', mode=MODE_TYPE)
    _RestoreDataRes_hlr_Number = OCT_STR(name='hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RestoreDataRes_msNotReachable = NULL(name='msNotReachable', mode=MODE_TYPE, opt=True)
    _RestoreDataRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RestoreDataRes._cont = ASN1Dict([
        ('hlr-Number', _RestoreDataRes_hlr_Number),
        ('msNotReachable', _RestoreDataRes_msNotReachable),
        ('extensionContainer', _RestoreDataRes_extensionContainer),
        ])
    RestoreDataRes._ext = []
    
    #-----< VBSDataList >-----#
    VBSDataList = SEQ_OF(name='VBSDataList', mode=MODE_TYPE)
    _VBSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceBroadcastData')))
    VBSDataList._cont = _VBSDataList__item_
    VBSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< VGCSDataList >-----#
    VGCSDataList = SEQ_OF(name='VGCSDataList', mode=MODE_TYPE)
    _VGCSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceGroupCallData')))
    VGCSDataList._cont = _VGCSDataList__item_
    VGCSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfVBSGroupIds >-----#
    maxNumOfVBSGroupIds = INT(name='maxNumOfVBSGroupIds', mode=MODE_VALUE)
    maxNumOfVBSGroupIds._val = 50
    
    #-----< maxNumOfVGCSGroupIds >-----#
    maxNumOfVGCSGroupIds = INT(name='maxNumOfVGCSGroupIds', mode=MODE_VALUE)
    maxNumOfVGCSGroupIds._val = 50
    
    #-----< VoiceGroupCallData >-----#
    VoiceGroupCallData = SEQ(name='VoiceGroupCallData', mode=MODE_TYPE)
    _VoiceGroupCallData_groupId = OCT_STR(name='groupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceGroupCallData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceGroupCallData_additionalSubscriptions = BIT_STR(name='additionalSubscriptions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalSubscriptions')), opt=True)
    _VoiceGroupCallData_additionalInfo = BIT_STR(name='additionalInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalInfo')), opt=True)
    _VoiceGroupCallData_longGroupId = OCT_STR(name='longGroupId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceGroupCallData._cont = ASN1Dict([
        ('groupId', _VoiceGroupCallData_groupId),
        ('extensionContainer', _VoiceGroupCallData_extensionContainer),
        ('additionalSubscriptions', _VoiceGroupCallData_additionalSubscriptions),
        ('additionalInfo', _VoiceGroupCallData_additionalInfo),
        ('longGroupId', _VoiceGroupCallData_longGroupId),
        ])
    VoiceGroupCallData._ext = ['additionalSubscriptions', 'additionalInfo', 'longGroupId']
    
    #-----< AdditionalInfo >-----#
    AdditionalInfo = BIT_STR(name='AdditionalInfo', mode=MODE_TYPE)
    AdditionalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=136)], ev=None, er=[])
    
    #-----< AdditionalSubscriptions >-----#
    AdditionalSubscriptions = BIT_STR(name='AdditionalSubscriptions', mode=MODE_TYPE)
    AdditionalSubscriptions._cont = ASN1Dict([('privilegedUplinkRequest', 0), ('emergencyUplinkRequest', 1), ('emergencyReset', 2)])
    AdditionalSubscriptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< VoiceBroadcastData >-----#
    VoiceBroadcastData = SEQ(name='VoiceBroadcastData', mode=MODE_TYPE)
    _VoiceBroadcastData_groupid = OCT_STR(name='groupid', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceBroadcastData_broadcastInitEntitlement = NULL(name='broadcastInitEntitlement', mode=MODE_TYPE, opt=True)
    _VoiceBroadcastData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceBroadcastData_longGroupId = OCT_STR(name='longGroupId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceBroadcastData._cont = ASN1Dict([
        ('groupid', _VoiceBroadcastData_groupid),
        ('broadcastInitEntitlement', _VoiceBroadcastData_broadcastInitEntitlement),
        ('extensionContainer', _VoiceBroadcastData_extensionContainer),
        ('longGroupId', _VoiceBroadcastData_longGroupId),
        ])
    VoiceBroadcastData._ext = ['longGroupId']
    
    #-----< GroupId >-----#
    GroupId = OCT_STR(name='GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    GroupId._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Long-GroupId >-----#
    Long_GroupId = OCT_STR(name='Long-GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    Long_GroupId._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ProvideSubscriberInfoArg >-----#
    ProvideSubscriberInfoArg = SEQ(name='ProvideSubscriberInfoArg', mode=MODE_TYPE)
    _ProvideSubscriberInfoArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideSubscriberInfoArg_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideSubscriberInfoArg_requestedInfo = SEQ(name='requestedInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _ProvideSubscriberInfoArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberInfoArg_callPriority = INT(name='callPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    ProvideSubscriberInfoArg._cont = ASN1Dict([
        ('imsi', _ProvideSubscriberInfoArg_imsi),
        ('lmsi', _ProvideSubscriberInfoArg_lmsi),
        ('requestedInfo', _ProvideSubscriberInfoArg_requestedInfo),
        ('extensionContainer', _ProvideSubscriberInfoArg_extensionContainer),
        ('callPriority', _ProvideSubscriberInfoArg_callPriority),
        ])
    ProvideSubscriberInfoArg._ext = ['callPriority']
    
    #-----< ProvideSubscriberInfoRes >-----#
    ProvideSubscriberInfoRes = SEQ(name='ProvideSubscriberInfoRes', mode=MODE_TYPE)
    _ProvideSubscriberInfoRes_subscriberInfo = SEQ(name='subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _ProvideSubscriberInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ProvideSubscriberInfoRes._cont = ASN1Dict([
        ('subscriberInfo', _ProvideSubscriberInfoRes_subscriberInfo),
        ('extensionContainer', _ProvideSubscriberInfoRes_extensionContainer),
        ])
    ProvideSubscriberInfoRes._ext = []
    
    #-----< SubscriberInfo >-----#
    SubscriberInfo = SEQ(name='SubscriberInfo', mode=MODE_TYPE)
    _SubscriberInfo_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _SubscriberInfo_subscriberState = CHOICE(name='subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _SubscriberInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubscriberInfo_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _SubscriberInfo_ps_SubscriberState = CHOICE(name='ps-SubscriberState', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_imei = OCT_STR(name='imei', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SubscriberInfo_ms_Classmark2 = OCT_STR(name='ms-Classmark2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _SubscriberInfo_gprs_MS_Class = SEQ(name='gprs-MS-Class', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _SubscriberInfo_mnpInfoRes = SEQ(name='mnpInfoRes', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MNPInfoRes')), opt=True)
    _SubscriberInfo_imsVoiceOverPS_SessionsIndication = ENUM(name='imsVoiceOverPS-SessionsIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMS-VoiceOverPS-SessionsInd')), opt=True)
    _SubscriberInfo_lastUE_ActivityTime = OCT_STR(name='lastUE-ActivityTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _SubscriberInfo_lastRAT_Type = ENUM(name='lastRAT-Type', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _SubscriberInfo_eps_SubscriberState = CHOICE(name='eps-SubscriberState', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_locationInformationEPS = SEQ(name='locationInformationEPS', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _SubscriberInfo_timeZone = OCT_STR(name='timeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _SubscriberInfo_daylightSavingTime = ENUM(name='daylightSavingTime', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DaylightSavingTime')), opt=True)
    _SubscriberInfo_locationInformation5GS = SEQ(name='locationInformation5GS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation5GS')), opt=True)
    SubscriberInfo._cont = ASN1Dict([
        ('locationInformation', _SubscriberInfo_locationInformation),
        ('subscriberState', _SubscriberInfo_subscriberState),
        ('extensionContainer', _SubscriberInfo_extensionContainer),
        ('locationInformationGPRS', _SubscriberInfo_locationInformationGPRS),
        ('ps-SubscriberState', _SubscriberInfo_ps_SubscriberState),
        ('imei', _SubscriberInfo_imei),
        ('ms-Classmark2', _SubscriberInfo_ms_Classmark2),
        ('gprs-MS-Class', _SubscriberInfo_gprs_MS_Class),
        ('mnpInfoRes', _SubscriberInfo_mnpInfoRes),
        ('imsVoiceOverPS-SessionsIndication', _SubscriberInfo_imsVoiceOverPS_SessionsIndication),
        ('lastUE-ActivityTime', _SubscriberInfo_lastUE_ActivityTime),
        ('lastRAT-Type', _SubscriberInfo_lastRAT_Type),
        ('eps-SubscriberState', _SubscriberInfo_eps_SubscriberState),
        ('locationInformationEPS', _SubscriberInfo_locationInformationEPS),
        ('timeZone', _SubscriberInfo_timeZone),
        ('daylightSavingTime', _SubscriberInfo_daylightSavingTime),
        ('locationInformation5GS', _SubscriberInfo_locationInformation5GS),
        ])
    SubscriberInfo._ext = ['locationInformationGPRS', 'ps-SubscriberState', 'imei', 'ms-Classmark2', 'gprs-MS-Class', 'mnpInfoRes', 'imsVoiceOverPS-SessionsIndication', 'lastUE-ActivityTime', 'lastRAT-Type', 'eps-SubscriberState', 'locationInformationEPS', 'timeZone', 'daylightSavingTime', 'locationInformation5GS']
    
    #-----< IMS-VoiceOverPS-SessionsInd >-----#
    IMS_VoiceOverPS_SessionsInd = ENUM(name='IMS-VoiceOverPS-SessionsInd', mode=MODE_TYPE)
    IMS_VoiceOverPS_SessionsInd._cont = ASN1Dict([('imsVoiceOverPS-SessionsNotSupported', 0), ('imsVoiceOverPS-SessionsSupported', 1), ('unknown', 2)])
    IMS_VoiceOverPS_SessionsInd._ext = None
    
    #-----< TimeZone >-----#
    TimeZone = OCT_STR(name='TimeZone', mode=MODE_TYPE)
    TimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< DaylightSavingTime >-----#
    DaylightSavingTime = ENUM(name='DaylightSavingTime', mode=MODE_TYPE)
    DaylightSavingTime._cont = ASN1Dict([('noAdjustment', 0), ('plusOneHourAdjustment', 1), ('plusTwoHoursAdjustment', 2)])
    DaylightSavingTime._ext = None
    
    #-----< MNPInfoRes >-----#
    MNPInfoRes = SEQ(name='MNPInfoRes', mode=MODE_TYPE)
    _MNPInfoRes_routeingNumber = OCT_STR(name='routeingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RouteingNumber')), opt=True)
    _MNPInfoRes_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MNPInfoRes_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MNPInfoRes_numberPortabilityStatus = ENUM(name='numberPortabilityStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _MNPInfoRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MNPInfoRes._cont = ASN1Dict([
        ('routeingNumber', _MNPInfoRes_routeingNumber),
        ('imsi', _MNPInfoRes_imsi),
        ('msisdn', _MNPInfoRes_msisdn),
        ('numberPortabilityStatus', _MNPInfoRes_numberPortabilityStatus),
        ('extensionContainer', _MNPInfoRes_extensionContainer),
        ])
    MNPInfoRes._ext = []
    
    #-----< RouteingNumber >-----#
    RouteingNumber = OCT_STR(name='RouteingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    RouteingNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NumberPortabilityStatus >-----#
    NumberPortabilityStatus = ENUM(name='NumberPortabilityStatus', mode=MODE_TYPE)
    NumberPortabilityStatus._cont = ASN1Dict([('notKnownToBePorted', 0), ('ownNumberPortedOut', 1), ('foreignNumberPortedToForeignNetwork', 2), ('ownNumberNotPortedOut', 4), ('foreignNumberPortedIn', 5)])
    NumberPortabilityStatus._ext = ['ownNumberNotPortedOut', 'foreignNumberPortedIn']
    
    #-----< MS-Classmark2 >-----#
    MS_Classmark2 = OCT_STR(name='MS-Classmark2', mode=MODE_TYPE)
    MS_Classmark2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< GPRSMSClass >-----#
    GPRSMSClass = SEQ(name='GPRSMSClass', mode=MODE_TYPE)
    _GPRSMSClass_mSNetworkCapability = OCT_STR(name='mSNetworkCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSNetworkCapability')))
    _GPRSMSClass_mSRadioAccessCapability = OCT_STR(name='mSRadioAccessCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSRadioAccessCapability')), opt=True)
    GPRSMSClass._cont = ASN1Dict([
        ('mSNetworkCapability', _GPRSMSClass_mSNetworkCapability),
        ('mSRadioAccessCapability', _GPRSMSClass_mSRadioAccessCapability),
        ])
    GPRSMSClass._ext = None
    
    #-----< MSNetworkCapability >-----#
    MSNetworkCapability = OCT_STR(name='MSNetworkCapability', mode=MODE_TYPE)
    MSNetworkCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MSRadioAccessCapability >-----#
    MSRadioAccessCapability = OCT_STR(name='MSRadioAccessCapability', mode=MODE_TYPE)
    MSRadioAccessCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< RequestedInfo >-----#
    RequestedInfo = SEQ(name='RequestedInfo', mode=MODE_TYPE)
    _RequestedInfo_locationInformation = NULL(name='locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_subscriberState = NULL(name='subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedInfo_currentLocation = NULL(name='currentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedDomain = ENUM(name='requestedDomain', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DomainType')), opt=True)
    _RequestedInfo_imei = NULL(name='imei', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_ms_classmark = NULL(name='ms-classmark', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_mnpRequestedInfo = NULL(name='mnpRequestedInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_locationInformationEPS_Supported = NULL(name='locationInformationEPS-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_t_adsData = NULL(name='t-adsData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedNodes = BIT_STR(name='requestedNodes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedNodes')), opt=True)
    _RequestedInfo_servingNodeIndication = NULL(name='servingNodeIndication', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_localTimeZoneRequest = NULL(name='localTimeZoneRequest', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedInfo._cont = ASN1Dict([
        ('locationInformation', _RequestedInfo_locationInformation),
        ('subscriberState', _RequestedInfo_subscriberState),
        ('extensionContainer', _RequestedInfo_extensionContainer),
        ('currentLocation', _RequestedInfo_currentLocation),
        ('requestedDomain', _RequestedInfo_requestedDomain),
        ('imei', _RequestedInfo_imei),
        ('ms-classmark', _RequestedInfo_ms_classmark),
        ('mnpRequestedInfo', _RequestedInfo_mnpRequestedInfo),
        ('locationInformationEPS-Supported', _RequestedInfo_locationInformationEPS_Supported),
        ('t-adsData', _RequestedInfo_t_adsData),
        ('requestedNodes', _RequestedInfo_requestedNodes),
        ('servingNodeIndication', _RequestedInfo_servingNodeIndication),
        ('localTimeZoneRequest', _RequestedInfo_localTimeZoneRequest),
        ])
    RequestedInfo._ext = ['currentLocation', 'requestedDomain', 'imei', 'ms-classmark', 'mnpRequestedInfo', 'locationInformationEPS-Supported', 't-adsData', 'requestedNodes', 'servingNodeIndication', 'localTimeZoneRequest']
    
    #-----< DomainType >-----#
    DomainType = ENUM(name='DomainType', mode=MODE_TYPE)
    DomainType._cont = ASN1Dict([('cs-Domain', 0), ('ps-Domain', 1)])
    DomainType._ext = []
    
    #-----< RequestedNodes >-----#
    RequestedNodes = BIT_STR(name='RequestedNodes', mode=MODE_TYPE)
    RequestedNodes._cont = ASN1Dict([('mme', 0), ('sgsn', 1)])
    RequestedNodes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationInformation >-----#
    LocationInformation = SEQ(name='LocationInformation', mode=MODE_TYPE)
    _LocationInformation_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation_vlr_number = OCT_STR(name='vlr-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_locationNumber = OCT_STR(name='locationNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationNumber')), opt=True)
    _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name='cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformation_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation_selectedLSA_Id = OCT_STR(name='selectedLSA-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformation_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_locationInformationEPS = SEQ(name='locationInformationEPS', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _LocationInformation_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformation._cont = ASN1Dict([
        ('ageOfLocationInformation', _LocationInformation_ageOfLocationInformation),
        ('geographicalInformation', _LocationInformation_geographicalInformation),
        ('vlr-number', _LocationInformation_vlr_number),
        ('locationNumber', _LocationInformation_locationNumber),
        ('cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI),
        ('extensionContainer', _LocationInformation_extensionContainer),
        ('selectedLSA-Id', _LocationInformation_selectedLSA_Id),
        ('msc-Number', _LocationInformation_msc_Number),
        ('geodeticInformation', _LocationInformation_geodeticInformation),
        ('currentLocationRetrieved', _LocationInformation_currentLocationRetrieved),
        ('sai-Present', _LocationInformation_sai_Present),
        ('locationInformationEPS', _LocationInformation_locationInformationEPS),
        ('userCSGInformation', _LocationInformation_userCSGInformation),
        ])
    LocationInformation._ext = ['selectedLSA-Id', 'msc-Number', 'geodeticInformation', 'currentLocationRetrieved', 'sai-Present', 'locationInformationEPS', 'userCSGInformation']
    
    #-----< LocationInformationEPS >-----#
    LocationInformationEPS = SEQ(name='LocationInformationEPS', mode=MODE_TYPE)
    _LocationInformationEPS_e_utranCellGlobalIdentity = OCT_STR(name='e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformationEPS_trackingAreaIdentity = OCT_STR(name='trackingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformationEPS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationEPS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationEPS_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationEPS_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationEPS_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationEPS_mme_Name = OCT_STR(name='mme-Name', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    LocationInformationEPS._cont = ASN1Dict([
        ('e-utranCellGlobalIdentity', _LocationInformationEPS_e_utranCellGlobalIdentity),
        ('trackingAreaIdentity', _LocationInformationEPS_trackingAreaIdentity),
        ('extensionContainer', _LocationInformationEPS_extensionContainer),
        ('geographicalInformation', _LocationInformationEPS_geographicalInformation),
        ('geodeticInformation', _LocationInformationEPS_geodeticInformation),
        ('currentLocationRetrieved', _LocationInformationEPS_currentLocationRetrieved),
        ('ageOfLocationInformation', _LocationInformationEPS_ageOfLocationInformation),
        ('mme-Name', _LocationInformationEPS_mme_Name),
        ])
    LocationInformationEPS._ext = ['mme-Name']
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name='LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name='cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name='routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name='selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name='sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationGPRS_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        ('cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        ('routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        ('geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        ('sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        ('selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        ('extensionContainer', _LocationInformationGPRS_extensionContainer),
        ('sai-Present', _LocationInformationGPRS_sai_Present),
        ('geodeticInformation', _LocationInformationGPRS_geodeticInformation),
        ('currentLocationRetrieved', _LocationInformationGPRS_currentLocationRetrieved),
        ('ageOfLocationInformation', _LocationInformationGPRS_ageOfLocationInformation),
        ('userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = ['sai-Present', 'geodeticInformation', 'currentLocationRetrieved', 'ageOfLocationInformation', 'userCSGInformation']
    
    #-----< LocationInformation5GS >-----#
    LocationInformation5GS = SEQ(name='LocationInformation5GS', mode=MODE_TYPE)
    _LocationInformation5GS_nrCellGlobalIdentity = OCT_STR(name='nrCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-CGI')), opt=True)
    _LocationInformation5GS_e_utranCellGlobalIdentity = OCT_STR(name='e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformation5GS_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation5GS_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation5GS_amf_address = OCT_STR(name='amf-address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _LocationInformation5GS_trackingAreaIdentity = OCT_STR(name='trackingAreaIdentity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformation5GS_currentLocationRetrieved = NULL(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation5GS_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation5GS_vplmnId = OCT_STR(name='vplmnId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _LocationInformation5GS_localtimeZone = OCT_STR(name='localtimeZone', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _LocationInformation5GS_rat_Type = ENUM(name='rat-Type', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _LocationInformation5GS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation5GS_nrTrackingAreaIdentity = OCT_STR(name='nrTrackingAreaIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-TA-Id')), opt=True)
    LocationInformation5GS._cont = ASN1Dict([
        ('nrCellGlobalIdentity', _LocationInformation5GS_nrCellGlobalIdentity),
        ('e-utranCellGlobalIdentity', _LocationInformation5GS_e_utranCellGlobalIdentity),
        ('geographicalInformation', _LocationInformation5GS_geographicalInformation),
        ('geodeticInformation', _LocationInformation5GS_geodeticInformation),
        ('amf-address', _LocationInformation5GS_amf_address),
        ('trackingAreaIdentity', _LocationInformation5GS_trackingAreaIdentity),
        ('currentLocationRetrieved', _LocationInformation5GS_currentLocationRetrieved),
        ('ageOfLocationInformation', _LocationInformation5GS_ageOfLocationInformation),
        ('vplmnId', _LocationInformation5GS_vplmnId),
        ('localtimeZone', _LocationInformation5GS_localtimeZone),
        ('rat-Type', _LocationInformation5GS_rat_Type),
        ('extensionContainer', _LocationInformation5GS_extensionContainer),
        ('nrTrackingAreaIdentity', _LocationInformation5GS_nrTrackingAreaIdentity),
        ])
    LocationInformation5GS._ext = ['nrTrackingAreaIdentity']
    
    #-----< UserCSGInformation >-----#
    UserCSGInformation = SEQ(name='UserCSGInformation', mode=MODE_TYPE)
    _UserCSGInformation_csg_Id = BIT_STR(name='csg-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _UserCSGInformation_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UserCSGInformation_accessMode = OCT_STR(name='accessMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_accessMode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _UserCSGInformation_cmi = OCT_STR(name='cmi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_cmi._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    UserCSGInformation._cont = ASN1Dict([
        ('csg-Id', _UserCSGInformation_csg_Id),
        ('extensionContainer', _UserCSGInformation_extensionContainer),
        ('accessMode', _UserCSGInformation_accessMode),
        ('cmi', _UserCSGInformation_cmi),
        ])
    UserCSGInformation._ext = ['accessMode', 'cmi']
    
    #-----< GeographicalInformation >-----#
    GeographicalInformation = OCT_STR(name='GeographicalInformation', mode=MODE_TYPE)
    GeographicalInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GeodeticInformation >-----#
    GeodeticInformation = OCT_STR(name='GeodeticInformation', mode=MODE_TYPE)
    GeodeticInformation._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name='LocationNumber', mode=MODE_TYPE)
    LocationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< SubscriberState >-----#
    SubscriberState = CHOICE(name='SubscriberState', mode=MODE_TYPE)
    _SubscriberState_assumedIdle = NULL(name='assumedIdle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_camelBusy = NULL(name='camelBusy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_netDetNotReachable = ENUM(name='netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    _SubscriberState_notProvidedFromVLR = NULL(name='notProvidedFromVLR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriberState._cont = ASN1Dict([
        ('assumedIdle', _SubscriberState_assumedIdle),
        ('camelBusy', _SubscriberState_camelBusy),
        ('netDetNotReachable', _SubscriberState_netDetNotReachable),
        ('notProvidedFromVLR', _SubscriberState_notProvidedFromVLR),
        ])
    SubscriberState._ext = None
    
    #-----< PS-SubscriberState >-----#
    PS_SubscriberState = CHOICE(name='PS-SubscriberState', mode=MODE_TYPE)
    _PS_SubscriberState_notProvidedFromSGSNorMME = NULL(name='notProvidedFromSGSNorMME', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_Detached = NULL(name='ps-Detached', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedNotReachableForPaging = NULL(name='ps-AttachedNotReachableForPaging', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedReachableForPaging = NULL(name='ps-AttachedReachableForPaging', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging = SEQ_OF(name='ps-PDP-ActiveNotReachableForPaging', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_ps_PDP_ActiveReachableForPaging = SEQ_OF(name='ps-PDP-ActiveReachableForPaging', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_netDetNotReachable = ENUM(name='netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    PS_SubscriberState._cont = ASN1Dict([
        ('notProvidedFromSGSNorMME', _PS_SubscriberState_notProvidedFromSGSNorMME),
        ('ps-Detached', _PS_SubscriberState_ps_Detached),
        ('ps-AttachedNotReachableForPaging', _PS_SubscriberState_ps_AttachedNotReachableForPaging),
        ('ps-AttachedReachableForPaging', _PS_SubscriberState_ps_AttachedReachableForPaging),
        ('ps-PDP-ActiveNotReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging),
        ('ps-PDP-ActiveReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveReachableForPaging),
        ('netDetNotReachable', _PS_SubscriberState_netDetNotReachable),
        ])
    PS_SubscriberState._ext = None
    
    #-----< PDP-ContextInfoList >-----#
    PDP_ContextInfoList = SEQ_OF(name='PDP-ContextInfoList', mode=MODE_TYPE)
    _PDP_ContextInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfo')))
    PDP_ContextInfoList._cont = _PDP_ContextInfoList__item_
    PDP_ContextInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< PDP-ContextInfo >-----#
    PDP_ContextInfo = SEQ(name='PDP-ContextInfo', mode=MODE_TYPE)
    _PDP_ContextInfo_pdp_ContextIdentifier = INT(name='pdp-ContextIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_ContextInfo_pdp_ContextActive = NULL(name='pdp-ContextActive', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_ContextInfo_pdp_Type = OCT_STR(name='pdp-Type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_ContextInfo_pdp_Address = OCT_STR(name='pdp-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_ContextInfo_apn_Subscribed = OCT_STR(name='apn-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_apn_InUse = OCT_STR(name='apn-InUse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_nsapi = INT(name='nsapi', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NSAPI')), opt=True)
    _PDP_ContextInfo_transactionId = OCT_STR(name='transactionId', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TransactionId')), opt=True)
    _PDP_ContextInfo_teid_ForGnAndGp = OCT_STR(name='teid-ForGnAndGp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_teid_ForIu = OCT_STR(name='teid-ForIu', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_ggsn_Address = OCT_STR(name='ggsn-Address', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_qos_Subscribed = OCT_STR(name='qos-Subscribed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Requested = OCT_STR(name='qos-Requested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Negotiated = OCT_STR(name='qos-Negotiated', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_chargingId = OCT_STR(name='chargingId', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _PDP_ContextInfo_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_ContextInfo_rnc_Address = OCT_STR(name='rnc-Address', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_ContextInfo_qos2_Subscribed = OCT_STR(name='qos2-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Requested = OCT_STR(name='qos2-Requested', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Negotiated = OCT_STR(name='qos2-Negotiated', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Subscribed = OCT_STR(name='qos3-Subscribed', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Requested = OCT_STR(name='qos3-Requested', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Negotiated = OCT_STR(name='qos3-Negotiated', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Subscribed = OCT_STR(name='qos4-Subscribed', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Requested = OCT_STR(name='qos4-Requested', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Negotiated = OCT_STR(name='qos4-Negotiated', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_ext_pdp_Type = OCT_STR(name='ext-pdp-Type', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_ContextInfo_ext_pdp_Address = OCT_STR(name='ext-pdp-Address', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    PDP_ContextInfo._cont = ASN1Dict([
        ('pdp-ContextIdentifier', _PDP_ContextInfo_pdp_ContextIdentifier),
        ('pdp-ContextActive', _PDP_ContextInfo_pdp_ContextActive),
        ('pdp-Type', _PDP_ContextInfo_pdp_Type),
        ('pdp-Address', _PDP_ContextInfo_pdp_Address),
        ('apn-Subscribed', _PDP_ContextInfo_apn_Subscribed),
        ('apn-InUse', _PDP_ContextInfo_apn_InUse),
        ('nsapi', _PDP_ContextInfo_nsapi),
        ('transactionId', _PDP_ContextInfo_transactionId),
        ('teid-ForGnAndGp', _PDP_ContextInfo_teid_ForGnAndGp),
        ('teid-ForIu', _PDP_ContextInfo_teid_ForIu),
        ('ggsn-Address', _PDP_ContextInfo_ggsn_Address),
        ('qos-Subscribed', _PDP_ContextInfo_qos_Subscribed),
        ('qos-Requested', _PDP_ContextInfo_qos_Requested),
        ('qos-Negotiated', _PDP_ContextInfo_qos_Negotiated),
        ('chargingId', _PDP_ContextInfo_chargingId),
        ('chargingCharacteristics', _PDP_ContextInfo_chargingCharacteristics),
        ('rnc-Address', _PDP_ContextInfo_rnc_Address),
        ('extensionContainer', _PDP_ContextInfo_extensionContainer),
        ('qos2-Subscribed', _PDP_ContextInfo_qos2_Subscribed),
        ('qos2-Requested', _PDP_ContextInfo_qos2_Requested),
        ('qos2-Negotiated', _PDP_ContextInfo_qos2_Negotiated),
        ('qos3-Subscribed', _PDP_ContextInfo_qos3_Subscribed),
        ('qos3-Requested', _PDP_ContextInfo_qos3_Requested),
        ('qos3-Negotiated', _PDP_ContextInfo_qos3_Negotiated),
        ('qos4-Subscribed', _PDP_ContextInfo_qos4_Subscribed),
        ('qos4-Requested', _PDP_ContextInfo_qos4_Requested),
        ('qos4-Negotiated', _PDP_ContextInfo_qos4_Negotiated),
        ('ext-pdp-Type', _PDP_ContextInfo_ext_pdp_Type),
        ('ext-pdp-Address', _PDP_ContextInfo_ext_pdp_Address),
        ])
    PDP_ContextInfo._ext = ['qos2-Subscribed', 'qos2-Requested', 'qos2-Negotiated', 'qos3-Subscribed', 'qos3-Requested', 'qos3-Negotiated', 'qos4-Subscribed', 'qos4-Requested', 'qos4-Negotiated', 'ext-pdp-Type', 'ext-pdp-Address']
    
    #-----< NSAPI >-----#
    NSAPI = INT(name='NSAPI', mode=MODE_TYPE)
    NSAPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< TransactionId >-----#
    TransactionId = OCT_STR(name='TransactionId', mode=MODE_TYPE)
    TransactionId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TEID >-----#
    TEID = OCT_STR(name='TEID', mode=MODE_TYPE)
    TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GPRSChargingID >-----#
    GPRSChargingID = OCT_STR(name='GPRSChargingID', mode=MODE_TYPE)
    GPRSChargingID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< NotReachableReason >-----#
    NotReachableReason = ENUM(name='NotReachableReason', mode=MODE_TYPE)
    NotReachableReason._cont = ASN1Dict([('msPurged', 0), ('imsiDetached', 1), ('restrictedArea', 2), ('notRegistered', 3)])
    NotReachableReason._ext = None
    
    #-----< AnyTimeInterrogationArg >-----#
    AnyTimeInterrogationArg = SEQ(name='AnyTimeInterrogationArg', mode=MODE_TYPE)
    _AnyTimeInterrogationArg_subscriberIdentity = CHOICE(name='subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeInterrogationArg_requestedInfo = SEQ(name='requestedInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _AnyTimeInterrogationArg_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeInterrogationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationArg._cont = ASN1Dict([
        ('subscriberIdentity', _AnyTimeInterrogationArg_subscriberIdentity),
        ('requestedInfo', _AnyTimeInterrogationArg_requestedInfo),
        ('gsmSCF-Address', _AnyTimeInterrogationArg_gsmSCF_Address),
        ('extensionContainer', _AnyTimeInterrogationArg_extensionContainer),
        ])
    AnyTimeInterrogationArg._ext = []
    
    #-----< AnyTimeInterrogationRes >-----#
    AnyTimeInterrogationRes = SEQ(name='AnyTimeInterrogationRes', mode=MODE_TYPE)
    _AnyTimeInterrogationRes_subscriberInfo = SEQ(name='subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _AnyTimeInterrogationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationRes._cont = ASN1Dict([
        ('subscriberInfo', _AnyTimeInterrogationRes_subscriberInfo),
        ('extensionContainer', _AnyTimeInterrogationRes_extensionContainer),
        ])
    AnyTimeInterrogationRes._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationArg >-----#
    AnyTimeSubscriptionInterrogationArg = SEQ(name='AnyTimeSubscriptionInterrogationArg', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationArg_subscriberIdentity = CHOICE(name='subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo = SEQ(name='requestedSubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedSubscriptionInfo')))
    _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeSubscriptionInterrogationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AnyTimeSubscriptionInterrogationArg._cont = ASN1Dict([
        ('subscriberIdentity', _AnyTimeSubscriptionInterrogationArg_subscriberIdentity),
        ('requestedSubscriptionInfo', _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo),
        ('gsmSCF-Address', _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address),
        ('extensionContainer', _AnyTimeSubscriptionInterrogationArg_extensionContainer),
        ('longFTN-Supported', _AnyTimeSubscriptionInterrogationArg_longFTN_Supported),
        ])
    AnyTimeSubscriptionInterrogationArg._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationRes >-----#
    AnyTimeSubscriptionInterrogationRes = SEQ(name='AnyTimeSubscriptionInterrogationRes', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationRes_callForwardingData = SEQ(name='callForwardingData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallForwardingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_callBarringData = SEQ(name='callBarringData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallBarringData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_odb_Info = SEQ(name='odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo = SEQ(name='camel-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases = BIT_STR(name='supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases = BIT_STR(name='supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR = BIT_STR(name='offeredCamel4CSIsInVLR', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN = BIT_STR(name='offeredCamel4CSIsInSGSN', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List = SEQ_OF(name='msisdn-BS-List', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS-List')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_cw_Data = SEQ(name='cw-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ch_Data = SEQ(name='ch-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clip_Data = SEQ(name='clip-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clir_Data = SEQ(name='clir-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ect_data = SEQ(name='ect-data', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    AnyTimeSubscriptionInterrogationRes._cont = ASN1Dict([
        ('callForwardingData', _AnyTimeSubscriptionInterrogationRes_callForwardingData),
        ('callBarringData', _AnyTimeSubscriptionInterrogationRes_callBarringData),
        ('odb-Info', _AnyTimeSubscriptionInterrogationRes_odb_Info),
        ('camel-SubscriptionInfo', _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo),
        ('supportedVLR-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases),
        ('supportedSGSN-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases),
        ('extensionContainer', _AnyTimeSubscriptionInterrogationRes_extensionContainer),
        ('offeredCamel4CSIsInVLR', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR),
        ('offeredCamel4CSIsInSGSN', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN),
        ('msisdn-BS-List', _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List),
        ('csg-SubscriptionDataList', _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList),
        ('cw-Data', _AnyTimeSubscriptionInterrogationRes_cw_Data),
        ('ch-Data', _AnyTimeSubscriptionInterrogationRes_ch_Data),
        ('clip-Data', _AnyTimeSubscriptionInterrogationRes_clip_Data),
        ('clir-Data', _AnyTimeSubscriptionInterrogationRes_clir_Data),
        ('ect-data', _AnyTimeSubscriptionInterrogationRes_ect_data),
        ])
    AnyTimeSubscriptionInterrogationRes._ext = ['offeredCamel4CSIsInVLR', 'offeredCamel4CSIsInSGSN', 'msisdn-BS-List', 'csg-SubscriptionDataList', 'cw-Data', 'ch-Data', 'clip-Data', 'clir-Data', 'ect-data']
    
    #-----< CallWaitingData >-----#
    CallWaitingData = SEQ(name='CallWaitingData', mode=MODE_TYPE)
    _CallWaitingData_cwFeatureList = SEQ_OF(name='cwFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeatureList')))
    _CallWaitingData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallWaitingData._cont = ASN1Dict([
        ('cwFeatureList', _CallWaitingData_cwFeatureList),
        ('notificationToCSE', _CallWaitingData_notificationToCSE),
        ])
    CallWaitingData._ext = []
    
    #-----< Ext-CwFeatureList >-----#
    Ext_CwFeatureList = SEQ_OF(name='Ext-CwFeatureList', mode=MODE_TYPE)
    _Ext_CwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeature')))
    Ext_CwFeatureList._cont = _Ext_CwFeatureList__item_
    Ext_CwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CwFeature >-----#
    Ext_CwFeature = SEQ(name='Ext-CwFeature', mode=MODE_TYPE)
    _Ext_CwFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    _Ext_CwFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    Ext_CwFeature._cont = ASN1Dict([
        ('basicService', _Ext_CwFeature_basicService),
        ('ss-Status', _Ext_CwFeature_ss_Status),
        ])
    Ext_CwFeature._ext = []
    
    #-----< ClipData >-----#
    ClipData = SEQ(name='ClipData', mode=MODE_TYPE)
    _ClipData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClipData_overrideCategory = ENUM(name='overrideCategory', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    _ClipData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClipData._cont = ASN1Dict([
        ('ss-Status', _ClipData_ss_Status),
        ('overrideCategory', _ClipData_overrideCategory),
        ('notificationToCSE', _ClipData_notificationToCSE),
        ])
    ClipData._ext = []
    
    #-----< ClirData >-----#
    ClirData = SEQ(name='ClirData', mode=MODE_TYPE)
    _ClirData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClirData_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ClirData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClirData._cont = ASN1Dict([
        ('ss-Status', _ClirData_ss_Status),
        ('cliRestrictionOption', _ClirData_cliRestrictionOption),
        ('notificationToCSE', _ClirData_notificationToCSE),
        ])
    ClirData._ext = []
    
    #-----< CallHoldData >-----#
    CallHoldData = SEQ(name='CallHoldData', mode=MODE_TYPE)
    _CallHoldData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _CallHoldData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallHoldData._cont = ASN1Dict([
        ('ss-Status', _CallHoldData_ss_Status),
        ('notificationToCSE', _CallHoldData_notificationToCSE),
        ])
    CallHoldData._ext = []
    
    #-----< EctData >-----#
    EctData = SEQ(name='EctData', mode=MODE_TYPE)
    _EctData_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _EctData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EctData._cont = ASN1Dict([
        ('ss-Status', _EctData_ss_Status),
        ('notificationToCSE', _EctData_notificationToCSE),
        ])
    EctData._ext = []
    
    #-----< RequestedSubscriptionInfo >-----#
    RequestedSubscriptionInfo = SEQ(name='RequestedSubscriptionInfo', mode=MODE_TYPE)
    _RequestedSubscriptionInfo_requestedSS_Info = SEQ(name='requestedSS-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-ForBS-Code')), opt=True)
    _RequestedSubscriptionInfo_odb = NULL(name='odb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo = ENUM(name='requestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases = NULL(name='supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases = NULL(name='supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name='additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_msisdn_BS_List = NULL(name='msisdn-BS-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_csg_SubscriptionDataRequested = NULL(name='csg-SubscriptionDataRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_cw_Info = NULL(name='cw-Info', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clip_Info = NULL(name='clip-Info', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clir_Info = NULL(name='clir-Info', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_hold_Info = NULL(name='hold-Info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_ect_Info = NULL(name='ect-Info', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedSubscriptionInfo._cont = ASN1Dict([
        ('requestedSS-Info', _RequestedSubscriptionInfo_requestedSS_Info),
        ('odb', _RequestedSubscriptionInfo_odb),
        ('requestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo),
        ('supportedVLR-CAMEL-Phases', _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases),
        ('supportedSGSN-CAMEL-Phases', _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases),
        ('extensionContainer', _RequestedSubscriptionInfo_extensionContainer),
        ('additionalRequestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo),
        ('msisdn-BS-List', _RequestedSubscriptionInfo_msisdn_BS_List),
        ('csg-SubscriptionDataRequested', _RequestedSubscriptionInfo_csg_SubscriptionDataRequested),
        ('cw-Info', _RequestedSubscriptionInfo_cw_Info),
        ('clip-Info', _RequestedSubscriptionInfo_clip_Info),
        ('clir-Info', _RequestedSubscriptionInfo_clir_Info),
        ('hold-Info', _RequestedSubscriptionInfo_hold_Info),
        ('ect-Info', _RequestedSubscriptionInfo_ect_Info),
        ])
    RequestedSubscriptionInfo._ext = ['additionalRequestedCAMEL-SubscriptionInfo', 'msisdn-BS-List', 'csg-SubscriptionDataRequested', 'cw-Info', 'clip-Info', 'clir-Info', 'hold-Info', 'ect-Info']
    
    #-----< MSISDN-BS-List >-----#
    MSISDN_BS_List = SEQ_OF(name='MSISDN-BS-List', mode=MODE_TYPE)
    _MSISDN_BS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS')))
    MSISDN_BS_List._cont = _MSISDN_BS_List__item_
    MSISDN_BS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfMSISDN >-----#
    maxNumOfMSISDN = INT(name='maxNumOfMSISDN', mode=MODE_VALUE)
    maxNumOfMSISDN._val = 50
    
    #-----< MSISDN-BS >-----#
    MSISDN_BS = SEQ(name='MSISDN-BS', mode=MODE_TYPE)
    _MSISDN_BS_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MSISDN_BS_basicServiceList = SEQ_OF(name='basicServiceList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _MSISDN_BS_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MSISDN_BS._cont = ASN1Dict([
        ('msisdn', _MSISDN_BS_msisdn),
        ('basicServiceList', _MSISDN_BS_basicServiceList),
        ('extensionContainer', _MSISDN_BS_extensionContainer),
        ])
    MSISDN_BS._ext = []
    
    #-----< RequestedCAMEL-SubscriptionInfo >-----#
    RequestedCAMEL_SubscriptionInfo = ENUM(name='RequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    RequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([('o-CSI', 0), ('t-CSI', 1), ('vt-CSI', 2), ('tif-CSI', 3), ('gprs-CSI', 4), ('mo-sms-CSI', 5), ('ss-CSI', 6), ('m-CSI', 7), ('d-csi', 8)])
    RequestedCAMEL_SubscriptionInfo._ext = None
    
    #-----< AdditionalRequestedCAMEL-SubscriptionInfo >-----#
    AdditionalRequestedCAMEL_SubscriptionInfo = ENUM(name='AdditionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    AdditionalRequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([('mt-sms-CSI', 0), ('mg-csi', 1), ('o-IM-CSI', 2), ('d-IM-CSI', 3), ('vt-IM-CSI', 4)])
    AdditionalRequestedCAMEL_SubscriptionInfo._ext = []
    
    #-----< CallForwardingData >-----#
    CallForwardingData = SEQ(name='CallForwardingData', mode=MODE_TYPE)
    _CallForwardingData_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _CallForwardingData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallForwardingData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallForwardingData._cont = ASN1Dict([
        ('forwardingFeatureList', _CallForwardingData_forwardingFeatureList),
        ('notificationToCSE', _CallForwardingData_notificationToCSE),
        ('extensionContainer', _CallForwardingData_extensionContainer),
        ])
    CallForwardingData._ext = []
    
    #-----< CallBarringData >-----#
    CallBarringData = SEQ(name='CallBarringData', mode=MODE_TYPE)
    _CallBarringData_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _CallBarringData_password = STR_NUM(name='password', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _CallBarringData_password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    _CallBarringData_wrongPasswordAttemptsCounter = INT(name='wrongPasswordAttemptsCounter', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _CallBarringData_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallBarringData_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallBarringData._cont = ASN1Dict([
        ('callBarringFeatureList', _CallBarringData_callBarringFeatureList),
        ('password', _CallBarringData_password),
        ('wrongPasswordAttemptsCounter', _CallBarringData_wrongPasswordAttemptsCounter),
        ('notificationToCSE', _CallBarringData_notificationToCSE),
        ('extensionContainer', _CallBarringData_extensionContainer),
        ])
    CallBarringData._ext = []
    
    #-----< WrongPasswordAttemptsCounter >-----#
    WrongPasswordAttemptsCounter = INT(name='WrongPasswordAttemptsCounter', mode=MODE_TYPE)
    WrongPasswordAttemptsCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< ODB-Info >-----#
    ODB_Info = SEQ(name='ODB-Info', mode=MODE_TYPE)
    _ODB_Info_odb_Data = SEQ(name='odb-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')))
    _ODB_Info_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, opt=True)
    _ODB_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Info._cont = ASN1Dict([
        ('odb-Data', _ODB_Info_odb_Data),
        ('notificationToCSE', _ODB_Info_notificationToCSE),
        ('extensionContainer', _ODB_Info_extensionContainer),
        ])
    ODB_Info._ext = []
    
    #-----< CAMEL-SubscriptionInfo >-----#
    CAMEL_SubscriptionInfo = SEQ(name='CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _CAMEL_SubscriptionInfo_o_CSI = SEQ(name='o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_CSI = SEQ(name='d-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_CSI = SEQ(name='t-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='t-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_vt_CSI = SEQ(name='vt-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='vt-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI = NULL(name='tif-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE = NULL(name='tif-CSI-NotificationToCSE', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name='gprs-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name='mo-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_ss_CSI = SEQ(name='ss-CSI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_m_CSI = SEQ(name='m-CSI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CAMEL_SubscriptionInfo_specificCSIDeletedList = BIT_STR(name='specificCSIDeletedList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name='mt-sms-CSI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name='mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_mg_csi = SEQ(name='mg-csi', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_CSI = SEQ(name='o-IM-CSI', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList = SEQ_OF(name='o-IM-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_IM_CSI = SEQ(name='d-IM-CSI', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_CSI = SEQ(name='vt-IM-CSI', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name='vt-IM-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    CAMEL_SubscriptionInfo._cont = ASN1Dict([
        ('o-CSI', _CAMEL_SubscriptionInfo_o_CSI),
        ('o-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        ('d-CSI', _CAMEL_SubscriptionInfo_d_CSI),
        ('t-CSI', _CAMEL_SubscriptionInfo_t_CSI),
        ('t-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        ('vt-CSI', _CAMEL_SubscriptionInfo_vt_CSI),
        ('vt-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList),
        ('tif-CSI', _CAMEL_SubscriptionInfo_tif_CSI),
        ('tif-CSI-NotificationToCSE', _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE),
        ('gprs-CSI', _CAMEL_SubscriptionInfo_gprs_CSI),
        ('mo-sms-CSI', _CAMEL_SubscriptionInfo_mo_sms_CSI),
        ('ss-CSI', _CAMEL_SubscriptionInfo_ss_CSI),
        ('m-CSI', _CAMEL_SubscriptionInfo_m_CSI),
        ('extensionContainer', _CAMEL_SubscriptionInfo_extensionContainer),
        ('specificCSIDeletedList', _CAMEL_SubscriptionInfo_specificCSIDeletedList),
        ('mt-sms-CSI', _CAMEL_SubscriptionInfo_mt_sms_CSI),
        ('mt-smsCAMELTDP-CriteriaList', _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ('mg-csi', _CAMEL_SubscriptionInfo_mg_csi),
        ('o-IM-CSI', _CAMEL_SubscriptionInfo_o_IM_CSI),
        ('o-IM-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList),
        ('d-IM-CSI', _CAMEL_SubscriptionInfo_d_IM_CSI),
        ('vt-IM-CSI', _CAMEL_SubscriptionInfo_vt_IM_CSI),
        ('vt-IM-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList),
        ])
    CAMEL_SubscriptionInfo._ext = ['specificCSIDeletedList', 'mt-sms-CSI', 'mt-smsCAMELTDP-CriteriaList', 'mg-csi', 'o-IM-CSI', 'o-IM-BcsmCamelTDP-CriteriaList', 'd-IM-CSI', 'vt-IM-CSI', 'vt-IM-BCSM-CAMEL-TDP-CriteriaList']
    
    #-----< AnyTimeModificationArg >-----#
    AnyTimeModificationArg = SEQ(name='AnyTimeModificationArg', mode=MODE_TYPE)
    _AnyTimeModificationArg_subscriberIdentity = CHOICE(name='subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeModificationArg_gsmSCF_Address = OCT_STR(name='gsmSCF-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeModificationArg_modificationRequestFor_CF_Info = SEQ(name='modificationRequestFor-CF-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CF-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CB_Info = SEQ(name='modificationRequestFor-CB-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CB-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSI = SEQ(name='modificationRequestFor-CSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSI')), opt=True)
    _AnyTimeModificationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationArg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ODB_data = SEQ(name='modificationRequestFor-ODB-data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ODB-data')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data = SEQ(name='modificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-IP-SM-GW-Data')), opt=True)
    _AnyTimeModificationArg_activationRequestForUE_reachability = BIT_STR(name='activationRequestForUE-reachability', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedServingNode')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSG = SEQ(name='modificationRequestFor-CSG', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSG')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CW_Data = SEQ(name='modificationRequestFor-CW-Data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CW-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIP_Data = SEQ(name='modificationRequestFor-CLIP-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIP-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIR_Data = SEQ(name='modificationRequestFor-CLIR-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIR-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_HOLD_Data = SEQ(name='modificationRequestFor-HOLD-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CH-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ECT_Data = SEQ(name='modificationRequestFor-ECT-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ECT-Info')), opt=True)
    AnyTimeModificationArg._cont = ASN1Dict([
        ('subscriberIdentity', _AnyTimeModificationArg_subscriberIdentity),
        ('gsmSCF-Address', _AnyTimeModificationArg_gsmSCF_Address),
        ('modificationRequestFor-CF-Info', _AnyTimeModificationArg_modificationRequestFor_CF_Info),
        ('modificationRequestFor-CB-Info', _AnyTimeModificationArg_modificationRequestFor_CB_Info),
        ('modificationRequestFor-CSI', _AnyTimeModificationArg_modificationRequestFor_CSI),
        ('extensionContainer', _AnyTimeModificationArg_extensionContainer),
        ('longFTN-Supported', _AnyTimeModificationArg_longFTN_Supported),
        ('modificationRequestFor-ODB-data', _AnyTimeModificationArg_modificationRequestFor_ODB_data),
        ('modificationRequestFor-IP-SM-GW-Data', _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data),
        ('activationRequestForUE-reachability', _AnyTimeModificationArg_activationRequestForUE_reachability),
        ('modificationRequestFor-CSG', _AnyTimeModificationArg_modificationRequestFor_CSG),
        ('modificationRequestFor-CW-Data', _AnyTimeModificationArg_modificationRequestFor_CW_Data),
        ('modificationRequestFor-CLIP-Data', _AnyTimeModificationArg_modificationRequestFor_CLIP_Data),
        ('modificationRequestFor-CLIR-Data', _AnyTimeModificationArg_modificationRequestFor_CLIR_Data),
        ('modificationRequestFor-HOLD-Data', _AnyTimeModificationArg_modificationRequestFor_HOLD_Data),
        ('modificationRequestFor-ECT-Data', _AnyTimeModificationArg_modificationRequestFor_ECT_Data),
        ])
    AnyTimeModificationArg._ext = ['modificationRequestFor-ODB-data', 'modificationRequestFor-IP-SM-GW-Data', 'activationRequestForUE-reachability', 'modificationRequestFor-CSG', 'modificationRequestFor-CW-Data', 'modificationRequestFor-CLIP-Data', 'modificationRequestFor-CLIR-Data', 'modificationRequestFor-HOLD-Data', 'modificationRequestFor-ECT-Data']
    
    #-----< ModificationRequestFor-CW-Info >-----#
    ModificationRequestFor_CW_Info = SEQ(name='ModificationRequestFor-CW-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CW_Info_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CW_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CW_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CW_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CW_Info._cont = ASN1Dict([
        ('basicService', _ModificationRequestFor_CW_Info_basicService),
        ('ss-Status', _ModificationRequestFor_CW_Info_ss_Status),
        ('modifyNotificationToCSE', _ModificationRequestFor_CW_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CW_Info_extensionContainer),
        ])
    ModificationRequestFor_CW_Info._ext = []
    
    #-----< ModificationRequestFor-CH-Info >-----#
    ModificationRequestFor_CH_Info = SEQ(name='ModificationRequestFor-CH-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CH_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CH_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CH_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CH_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_CH_Info_ss_Status),
        ('modifyNotificationToCSE', _ModificationRequestFor_CH_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CH_Info_extensionContainer),
        ])
    ModificationRequestFor_CH_Info._ext = []
    
    #-----< ModificationRequestFor-ECT-Info >-----#
    ModificationRequestFor_ECT_Info = SEQ(name='ModificationRequestFor-ECT-Info', mode=MODE_TYPE)
    _ModificationRequestFor_ECT_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_ECT_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ECT_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ECT_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_ECT_Info_ss_Status),
        ('modifyNotificationToCSE', _ModificationRequestFor_ECT_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_ECT_Info_extensionContainer),
        ])
    ModificationRequestFor_ECT_Info._ext = []
    
    #-----< ModificationRequestFor-CLIR-Info >-----#
    ModificationRequestFor_CLIR_Info = SEQ(name='ModificationRequestFor-CLIR-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIR_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIR_Info_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIR_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIR_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_CLIR_Info_ss_Status),
        ('cliRestrictionOption', _ModificationRequestFor_CLIR_Info_cliRestrictionOption),
        ('modifyNotificationToCSE', _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CLIR_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIR_Info._ext = []
    
    #-----< ModificationRequestFor-CLIP-Info >-----#
    ModificationRequestFor_CLIP_Info = SEQ(name='ModificationRequestFor-CLIP-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIP_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIP_Info_overrideCategory = ENUM(name='overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')), opt=True)
    _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIP_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIP_Info._cont = ASN1Dict([
        ('ss-Status', _ModificationRequestFor_CLIP_Info_ss_Status),
        ('overrideCategory', _ModificationRequestFor_CLIP_Info_overrideCategory),
        ('modifyNotificationToCSE', _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CLIP_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIP_Info._ext = []
    
    #-----< ModificationRequestFor-CSG >-----#
    ModificationRequestFor_CSG = SEQ(name='ModificationRequestFor-CSG', mode=MODE_TYPE)
    _ModificationRequestFor_CSG_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSG_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CSG._cont = ASN1Dict([
        ('modifyNotificationToCSE', _ModificationRequestFor_CSG_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CSG_extensionContainer),
        ])
    ModificationRequestFor_CSG._ext = []
    
    #-----< RequestedServingNode >-----#
    RequestedServingNode = BIT_STR(name='RequestedServingNode', mode=MODE_TYPE)
    RequestedServingNode._cont = ASN1Dict([('mmeAndSgsn', 0)])
    RequestedServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ServingNode >-----#
    ServingNode = BIT_STR(name='ServingNode', mode=MODE_TYPE)
    ServingNode._cont = ASN1Dict([('mme', 0), ('sgsn', 1)])
    ServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< AnyTimeModificationRes >-----#
    AnyTimeModificationRes = SEQ(name='AnyTimeModificationRes', mode=MODE_TYPE)
    _AnyTimeModificationRes_ss_InfoFor_CSE = CHOICE(name='ss-InfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoFor-CSE')), opt=True)
    _AnyTimeModificationRes_camel_SubscriptionInfo = SEQ(name='camel-SubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeModificationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationRes_odb_Info = SEQ(name='odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeModificationRes_cw_Data = SEQ(name='cw-Data', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeModificationRes_ch_Data = SEQ(name='ch-Data', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeModificationRes_clip_Data = SEQ(name='clip-Data', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeModificationRes_clir_Data = SEQ(name='clir-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeModificationRes_ect_data = SEQ(name='ect-data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    _AnyTimeModificationRes_serviceCentreAddress = OCT_STR(name='serviceCentreAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    AnyTimeModificationRes._cont = ASN1Dict([
        ('ss-InfoFor-CSE', _AnyTimeModificationRes_ss_InfoFor_CSE),
        ('camel-SubscriptionInfo', _AnyTimeModificationRes_camel_SubscriptionInfo),
        ('extensionContainer', _AnyTimeModificationRes_extensionContainer),
        ('odb-Info', _AnyTimeModificationRes_odb_Info),
        ('cw-Data', _AnyTimeModificationRes_cw_Data),
        ('ch-Data', _AnyTimeModificationRes_ch_Data),
        ('clip-Data', _AnyTimeModificationRes_clip_Data),
        ('clir-Data', _AnyTimeModificationRes_clir_Data),
        ('ect-data', _AnyTimeModificationRes_ect_data),
        ('serviceCentreAddress', _AnyTimeModificationRes_serviceCentreAddress),
        ])
    AnyTimeModificationRes._ext = ['odb-Info', 'cw-Data', 'ch-Data', 'clip-Data', 'clir-Data', 'ect-data', 'serviceCentreAddress']
    
    #-----< ModificationRequestFor-CF-Info >-----#
    ModificationRequestFor_CF_Info = SEQ(name='ModificationRequestFor-CF-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CF_Info_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CF_Info_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CF_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ModificationRequestFor_CF_Info_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _ModificationRequestFor_CF_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CF_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CF_Info._cont = ASN1Dict([
        ('ss-Code', _ModificationRequestFor_CF_Info_ss_Code),
        ('basicService', _ModificationRequestFor_CF_Info_basicService),
        ('ss-Status', _ModificationRequestFor_CF_Info_ss_Status),
        ('forwardedToNumber', _ModificationRequestFor_CF_Info_forwardedToNumber),
        ('forwardedToSubaddress', _ModificationRequestFor_CF_Info_forwardedToSubaddress),
        ('noReplyConditionTime', _ModificationRequestFor_CF_Info_noReplyConditionTime),
        ('modifyNotificationToCSE', _ModificationRequestFor_CF_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CF_Info_extensionContainer),
        ])
    ModificationRequestFor_CF_Info._ext = []
    
    #-----< ModificationRequestFor-CB-Info >-----#
    ModificationRequestFor_CB_Info = SEQ(name='ModificationRequestFor-CB-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CB_Info_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CB_Info_basicService = CHOICE(name='basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CB_Info_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CB_Info_password = STR_NUM(name='password', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _ModificationRequestFor_CB_Info_password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter = INT(name='wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _ModificationRequestFor_CB_Info_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CB_Info_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CB_Info._cont = ASN1Dict([
        ('ss-Code', _ModificationRequestFor_CB_Info_ss_Code),
        ('basicService', _ModificationRequestFor_CB_Info_basicService),
        ('ss-Status', _ModificationRequestFor_CB_Info_ss_Status),
        ('password', _ModificationRequestFor_CB_Info_password),
        ('wrongPasswordAttemptsCounter', _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter),
        ('modifyNotificationToCSE', _ModificationRequestFor_CB_Info_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_CB_Info_extensionContainer),
        ])
    ModificationRequestFor_CB_Info._ext = []
    
    #-----< ModificationRequestFor-ODB-data >-----#
    ModificationRequestFor_ODB_data = SEQ(name='ModificationRequestFor-ODB-data', mode=MODE_TYPE)
    _ModificationRequestFor_ODB_data_odb_data = SEQ(name='odb-data', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _ModificationRequestFor_ODB_data_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ODB_data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ODB_data._cont = ASN1Dict([
        ('odb-data', _ModificationRequestFor_ODB_data_odb_data),
        ('modifyNotificationToCSE', _ModificationRequestFor_ODB_data_modifyNotificationToCSE),
        ('extensionContainer', _ModificationRequestFor_ODB_data_extensionContainer),
        ])
    ModificationRequestFor_ODB_data._ext = []
    
    #-----< ModificationRequestFor-CSI >-----#
    ModificationRequestFor_CSI = SEQ(name='ModificationRequestFor-CSI', mode=MODE_TYPE)
    _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo = ENUM(name='requestedCamel-SubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')))
    _ModificationRequestFor_CSI_modifyNotificationToCSE = ENUM(name='modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_modifyCSI_State = ENUM(name='modifyCSI-State', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name='additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    ModificationRequestFor_CSI._cont = ASN1Dict([
        ('requestedCamel-SubscriptionInfo', _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo),
        ('modifyNotificationToCSE', _ModificationRequestFor_CSI_modifyNotificationToCSE),
        ('modifyCSI-State', _ModificationRequestFor_CSI_modifyCSI_State),
        ('extensionContainer', _ModificationRequestFor_CSI_extensionContainer),
        ('additionalRequestedCAMEL-SubscriptionInfo', _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo),
        ])
    ModificationRequestFor_CSI._ext = ['additionalRequestedCAMEL-SubscriptionInfo']
    
    #-----< ModificationRequestFor-IP-SM-GW-Data >-----#
    ModificationRequestFor_IP_SM_GW_Data = SEQ(name='ModificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE)
    _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus = ENUM(name='modifyRegistrationStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress = SEQ(name='ip-sm-gw-DiameterAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    ModificationRequestFor_IP_SM_GW_Data._cont = ASN1Dict([
        ('modifyRegistrationStatus', _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus),
        ('extensionContainer', _ModificationRequestFor_IP_SM_GW_Data_extensionContainer),
        ('ip-sm-gw-DiameterAddress', _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress),
        ])
    ModificationRequestFor_IP_SM_GW_Data._ext = ['ip-sm-gw-DiameterAddress']
    
    #-----< ModificationInstruction >-----#
    ModificationInstruction = ENUM(name='ModificationInstruction', mode=MODE_TYPE)
    ModificationInstruction._cont = ASN1Dict([('deactivate', 0), ('activate', 1)])
    ModificationInstruction._ext = None
    
    #-----< NoteSubscriberDataModifiedArg >-----#
    NoteSubscriberDataModifiedArg = SEQ(name='NoteSubscriberDataModifiedArg', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteSubscriberDataModifiedArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE = SEQ(name='forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE = SEQ(name='callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_odb_Info = SEQ(name='odb-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo = SEQ(name='camel-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _NoteSubscriberDataModifiedArg_allInformationSent = NULL(name='allInformationSent', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NoteSubscriberDataModifiedArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteSubscriberDataModifiedArg_ue_reachable = BIT_STR(name='ue-reachable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServingNode')), opt=True)
    _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList = SEQ_OF(name='csg-SubscriptionDataList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _NoteSubscriberDataModifiedArg_cw_Data = SEQ(name='cw-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _NoteSubscriberDataModifiedArg_ch_Data = SEQ(name='ch-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _NoteSubscriberDataModifiedArg_clip_Data = SEQ(name='clip-Data', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _NoteSubscriberDataModifiedArg_clir_Data = SEQ(name='clir-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _NoteSubscriberDataModifiedArg_ect_data = SEQ(name='ect-data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    NoteSubscriberDataModifiedArg._cont = ASN1Dict([
        ('imsi', _NoteSubscriberDataModifiedArg_imsi),
        ('msisdn', _NoteSubscriberDataModifiedArg_msisdn),
        ('forwardingInfoFor-CSE', _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE),
        ('callBarringInfoFor-CSE', _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE),
        ('odb-Info', _NoteSubscriberDataModifiedArg_odb_Info),
        ('camel-SubscriptionInfo', _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo),
        ('allInformationSent', _NoteSubscriberDataModifiedArg_allInformationSent),
        ('extensionContainer', _NoteSubscriberDataModifiedArg_extensionContainer),
        ('ue-reachable', _NoteSubscriberDataModifiedArg_ue_reachable),
        ('csg-SubscriptionDataList', _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList),
        ('cw-Data', _NoteSubscriberDataModifiedArg_cw_Data),
        ('ch-Data', _NoteSubscriberDataModifiedArg_ch_Data),
        ('clip-Data', _NoteSubscriberDataModifiedArg_clip_Data),
        ('clir-Data', _NoteSubscriberDataModifiedArg_clir_Data),
        ('ect-data', _NoteSubscriberDataModifiedArg_ect_data),
        ])
    NoteSubscriberDataModifiedArg._ext = ['ue-reachable', 'csg-SubscriptionDataList', 'cw-Data', 'ch-Data', 'clip-Data', 'clir-Data', 'ect-data']
    
    #-----< NoteSubscriberDataModifiedRes >-----#
    NoteSubscriberDataModifiedRes = SEQ(name='NoteSubscriberDataModifiedRes', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteSubscriberDataModifiedRes._cont = ASN1Dict([
        ('extensionContainer', _NoteSubscriberDataModifiedRes_extensionContainer),
        ])
    NoteSubscriberDataModifiedRes._ext = []
    
    #-----< NoteMM-EventArg >-----#
    NoteMM_EventArg = SEQ(name='NoteMM-EventArg', mode=MODE_TYPE)
    _NoteMM_EventArg_serviceKey = INT(name='serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _NoteMM_EventArg_eventMet = OCT_STR(name='eventMet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    _NoteMM_EventArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMM_EventArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteMM_EventArg_locationInformation = SEQ(name='locationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _NoteMM_EventArg_supportedCAMELPhases = BIT_STR(name='supportedCAMELPhases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _NoteMM_EventArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteMM_EventArg_locationInformationGPRS = SEQ(name='locationInformationGPRS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _NoteMM_EventArg_offeredCamel4Functionalities = BIT_STR(name='offeredCamel4Functionalities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    NoteMM_EventArg._cont = ASN1Dict([
        ('serviceKey', _NoteMM_EventArg_serviceKey),
        ('eventMet', _NoteMM_EventArg_eventMet),
        ('imsi', _NoteMM_EventArg_imsi),
        ('msisdn', _NoteMM_EventArg_msisdn),
        ('locationInformation', _NoteMM_EventArg_locationInformation),
        ('supportedCAMELPhases', _NoteMM_EventArg_supportedCAMELPhases),
        ('extensionContainer', _NoteMM_EventArg_extensionContainer),
        ('locationInformationGPRS', _NoteMM_EventArg_locationInformationGPRS),
        ('offeredCamel4Functionalities', _NoteMM_EventArg_offeredCamel4Functionalities),
        ])
    NoteMM_EventArg._ext = ['locationInformationGPRS', 'offeredCamel4Functionalities']
    
    #-----< NoteMM-EventRes >-----#
    NoteMM_EventRes = SEQ(name='NoteMM-EventRes', mode=MODE_TYPE)
    _NoteMM_EventRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMM_EventRes._cont = ASN1Dict([
        ('extensionContainer', _NoteMM_EventRes_extensionContainer),
        ])
    NoteMM_EventRes._ext = []
    
    #-----< Ext-SS-InfoFor-CSE >-----#
    Ext_SS_InfoFor_CSE = CHOICE(name='Ext-SS-InfoFor-CSE', mode=MODE_TYPE)
    _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE = SEQ(name='forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')))
    _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE = SEQ(name='callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')))
    Ext_SS_InfoFor_CSE._cont = ASN1Dict([
        ('forwardingInfoFor-CSE', _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE),
        ('callBarringInfoFor-CSE', _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE),
        ])
    Ext_SS_InfoFor_CSE._ext = None
    
    #-----< Ext-ForwardingInfoFor-CSE >-----#
    Ext_ForwardingInfoFor_CSE = SEQ(name='Ext-ForwardingInfoFor-CSE', mode=MODE_TYPE)
    _Ext_ForwardingInfoFor_CSE_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwardingInfoFor_CSE_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwardingInfoFor_CSE_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_ForwardingInfoFor_CSE_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwardingInfoFor_CSE._cont = ASN1Dict([
        ('ss-Code', _Ext_ForwardingInfoFor_CSE_ss_Code),
        ('forwardingFeatureList', _Ext_ForwardingInfoFor_CSE_forwardingFeatureList),
        ('notificationToCSE', _Ext_ForwardingInfoFor_CSE_notificationToCSE),
        ('extensionContainer', _Ext_ForwardingInfoFor_CSE_extensionContainer),
        ])
    Ext_ForwardingInfoFor_CSE._ext = []
    
    #-----< Ext-CallBarringInfoFor-CSE >-----#
    Ext_CallBarringInfoFor_CSE = SEQ(name='Ext-CallBarringInfoFor-CSE', mode=MODE_TYPE)
    _Ext_CallBarringInfoFor_CSE_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarringInfoFor_CSE_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarringInfoFor_CSE_password = STR_NUM(name='password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _Ext_CallBarringInfoFor_CSE_password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter = INT(name='wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _Ext_CallBarringInfoFor_CSE_notificationToCSE = NULL(name='notificationToCSE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_CallBarringInfoFor_CSE_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringInfoFor_CSE._cont = ASN1Dict([
        ('ss-Code', _Ext_CallBarringInfoFor_CSE_ss_Code),
        ('callBarringFeatureList', _Ext_CallBarringInfoFor_CSE_callBarringFeatureList),
        ('password', _Ext_CallBarringInfoFor_CSE_password),
        ('wrongPasswordAttemptsCounter', _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter),
        ('notificationToCSE', _Ext_CallBarringInfoFor_CSE_notificationToCSE),
        ('extensionContainer', _Ext_CallBarringInfoFor_CSE_extensionContainer),
        ])
    Ext_CallBarringInfoFor_CSE._ext = []
    
    #-----< UpdateVcsgLocationArg >-----#
    UpdateVcsgLocationArg = SEQ(name='UpdateVcsgLocationArg', mode=MODE_TYPE)
    _UpdateVcsgLocationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateVcsgLocationArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_vlr_Number = OCT_STR(name='vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationArg._cont = ASN1Dict([
        ('imsi', _UpdateVcsgLocationArg_imsi),
        ('msisdn', _UpdateVcsgLocationArg_msisdn),
        ('vlr-Number', _UpdateVcsgLocationArg_vlr_Number),
        ('sgsn-Number', _UpdateVcsgLocationArg_sgsn_Number),
        ('extensionContainer', _UpdateVcsgLocationArg_extensionContainer),
        ])
    UpdateVcsgLocationArg._ext = []
    
    #-----< UpdateVcsgLocationRes >-----#
    UpdateVcsgLocationRes = SEQ(name='UpdateVcsgLocationRes', mode=MODE_TYPE)
    _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator = NULL(name='temporaryEmptySubscriptiondataIndicator', mode=MODE_TYPE, opt=True)
    _UpdateVcsgLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationRes._cont = ASN1Dict([
        ('temporaryEmptySubscriptiondataIndicator', _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator),
        ('extensionContainer', _UpdateVcsgLocationRes_extensionContainer),
        ])
    UpdateVcsgLocationRes._ext = []
    
    #-----< CancelVcsgLocationArg >-----#
    CancelVcsgLocationArg = SEQ(name='CancelVcsgLocationArg', mode=MODE_TYPE)
    _CancelVcsgLocationArg_identity = CHOICE(name='identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelVcsgLocationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationArg._cont = ASN1Dict([
        ('identity', _CancelVcsgLocationArg_identity),
        ('extensionContainer', _CancelVcsgLocationArg_extensionContainer),
        ])
    CancelVcsgLocationArg._ext = []
    
    #-----< CancelVcsgLocationRes >-----#
    CancelVcsgLocationRes = SEQ(name='CancelVcsgLocationRes', mode=MODE_TYPE)
    _CancelVcsgLocationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationRes._cont = ASN1Dict([
        ('extensionContainer', _CancelVcsgLocationRes_extensionContainer),
        ])
    CancelVcsgLocationRes._ext = []
    
    _all_ = [
        _UpdateLocationArg_imsi,
        _UpdateLocationArg_msc_Number,
        _UpdateLocationArg_vlr_Number,
        _UpdateLocationArg_lmsi,
        _UpdateLocationArg_extensionContainer,
        _UpdateLocationArg_vlr_Capability,
        _UpdateLocationArg_informPreviousNetworkEntity,
        _UpdateLocationArg_cs_LCS_NotSupportedByUE,
        _UpdateLocationArg_v_gmlc_Address,
        _UpdateLocationArg_add_info,
        _UpdateLocationArg_pagingArea,
        _UpdateLocationArg_skipSubscriberDataUpdate,
        _UpdateLocationArg_restorationIndicator,
        _UpdateLocationArg_eplmn_List,
        _UpdateLocationArg_mme_DiameterAddress,
        UpdateLocationArg,
        _VLR_Capability_supportedCamelPhases,
        _VLR_Capability_extensionContainer,
        _VLR_Capability_solsaSupportIndicator,
        _VLR_Capability_istSupportIndicator,
        _VLR_Capability_superChargerSupportedInServingNetworkEntity,
        _VLR_Capability_longFTN_Supported,
        _VLR_Capability_supportedLCS_CapabilitySets,
        _VLR_Capability_offeredCamel4CSIs,
        _VLR_Capability_supportedRAT_TypesIndicator,
        _VLR_Capability_longGroupID_Supported,
        _VLR_Capability_mtRoamingForwardingSupported,
        _VLR_Capability_msisdn_lessOperation_Supported,
        _VLR_Capability_reset_ids_Supported,
        VLR_Capability,
        SupportedRAT_Types,
        _SuperChargerInfo_sendSubscriberData,
        _SuperChargerInfo_subscriberDataStored,
        SuperChargerInfo,
        AgeIndicator,
        IST_SupportIndicator,
        SupportedLCS_CapabilitySets,
        _UpdateLocationRes_hlr_Number,
        _UpdateLocationRes_extensionContainer,
        _UpdateLocationRes_add_Capability,
        _UpdateLocationRes_pagingArea_Capability,
        UpdateLocationRes,
        _ADD_Info_imeisv,
        _ADD_Info_skipSubscriberDataUpdate,
        ADD_Info,
        _PagingArea__item_,
        PagingArea,
        _LocationArea_laiFixedLength,
        _LocationArea_lac,
        LocationArea,
        LAC,
        _CancelLocationArg_identity,
        _CancelLocationArg_cancellationType,
        _CancelLocationArg_extensionContainer,
        _CancelLocationArg_typeOfUpdate,
        _CancelLocationArg_mtrf_SupportedAndAuthorized,
        _CancelLocationArg_mtrf_SupportedAndNotAuthorized,
        _CancelLocationArg_newMSC_Number,
        _CancelLocationArg_newVLR_Number,
        _CancelLocationArg_new_lmsi,
        _CancelLocationArg_reattach_Required,
        CancelLocationArg,
        TypeOfUpdate,
        CancellationType,
        _CancelLocationRes_extensionContainer,
        CancelLocationRes,
        _PurgeMS_Arg_imsi,
        _PurgeMS_Arg_vlr_Number,
        _PurgeMS_Arg_sgsn_Number,
        _PurgeMS_Arg_extensionContainer,
        _PurgeMS_Arg_locationInformation,
        _PurgeMS_Arg_locationInformationGPRS,
        _PurgeMS_Arg_locationInformationEPS,
        PurgeMS_Arg,
        _PurgeMS_Res_freezeTMSI,
        _PurgeMS_Res_freezeP_TMSI,
        _PurgeMS_Res_extensionContainer,
        _PurgeMS_Res_freezeM_TMSI,
        PurgeMS_Res,
        _SendIdentificationArg_tmsi,
        _SendIdentificationArg_numberOfRequestedVectors,
        _SendIdentificationArg_segmentationProhibited,
        _SendIdentificationArg_extensionContainer,
        _SendIdentificationArg_msc_Number,
        _SendIdentificationArg_previous_LAI,
        _SendIdentificationArg_hopCounter,
        _SendIdentificationArg_mtRoamingForwardingSupported,
        _SendIdentificationArg_newVLR_Number,
        _SendIdentificationArg_new_lmsi,
        SendIdentificationArg,
        HopCounter,
        _SendIdentificationRes_imsi,
        _SendIdentificationRes_authenticationSetList,
        _SendIdentificationRes_currentSecurityContext,
        _SendIdentificationRes_extensionContainer,
        _SendIdentificationRes_lastUsedLtePLMN_Id,
        _SendIdentificationRes_mtCallPendingFlag,
        SendIdentificationRes,
        _AuthenticationSetList_tripletList,
        _AuthenticationSetList_quintupletList,
        AuthenticationSetList,
        _TripletList__item_,
        TripletList,
        _QuintupletList__item_,
        QuintupletList,
        _AuthenticationTriplet_rand,
        _AuthenticationTriplet_sres,
        _AuthenticationTriplet_kc,
        AuthenticationTriplet,
        _AuthenticationQuintuplet_rand,
        _AuthenticationQuintuplet_xres,
        _AuthenticationQuintuplet_ck,
        _AuthenticationQuintuplet_ik,
        _AuthenticationQuintuplet_autn,
        AuthenticationQuintuplet,
        _CurrentSecurityContext_gsm_SecurityContextData,
        _CurrentSecurityContext_umts_SecurityContextData,
        CurrentSecurityContext,
        _GSM_SecurityContextData_kc,
        _GSM_SecurityContextData_cksn,
        GSM_SecurityContextData,
        _UMTS_SecurityContextData_ck,
        _UMTS_SecurityContextData_ik,
        _UMTS_SecurityContextData_ksi,
        UMTS_SecurityContextData,
        RAND,
        SRES,
        Kc,
        XRES,
        CK,
        IK,
        AUTN,
        AUTS,
        Cksn,
        KSI,
        _AuthenticationFailureReportArg_imsi,
        _AuthenticationFailureReportArg_failureCause,
        _AuthenticationFailureReportArg_extensionContainer,
        _AuthenticationFailureReportArg_re_attempt,
        _AuthenticationFailureReportArg_accessType,
        _AuthenticationFailureReportArg_rand,
        _AuthenticationFailureReportArg_vlr_Number,
        _AuthenticationFailureReportArg_sgsn_Number,
        AuthenticationFailureReportArg,
        AccessType,
        _AuthenticationFailureReportRes_extensionContainer,
        AuthenticationFailureReportRes,
        FailureCause,
        _UpdateGprsLocationArg_imsi,
        _UpdateGprsLocationArg_sgsn_Number,
        _UpdateGprsLocationArg_sgsn_Address,
        _UpdateGprsLocationArg_extensionContainer,
        _UpdateGprsLocationArg_sgsn_Capability,
        _UpdateGprsLocationArg_informPreviousNetworkEntity,
        _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE,
        _UpdateGprsLocationArg_v_gmlc_Address,
        _UpdateGprsLocationArg_add_info,
        _UpdateGprsLocationArg_eps_info,
        _UpdateGprsLocationArg_servingNodeTypeIndicator,
        _UpdateGprsLocationArg_skipSubscriberDataUpdate,
        _UpdateGprsLocationArg_usedRAT_Type,
        _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_nodeTypeIndicator,
        _UpdateGprsLocationArg_areaRestricted,
        _UpdateGprsLocationArg_ue_reachableIndicator,
        _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_ue_srvcc_Capability,
        _UpdateGprsLocationArg_eplmn_List,
        _UpdateGprsLocationArg_mmeNumberforMTSMS,
        _UpdateGprsLocationArg_smsRegisterRequest,
        _UpdateGprsLocationArg_sms_Only,
        _UpdateGprsLocationArg_removalofMMERegistrationforSMS,
        _UpdateGprsLocationArg_sgsn_Name,
        _UpdateGprsLocationArg_sgsn_Realm,
        _UpdateGprsLocationArg_lgd_supportIndicator,
        _UpdateGprsLocationArg_adjacentPLMN_List,
        UpdateGprsLocationArg,
        SMSRegisterRequest,
        Used_RAT_Type,
        _EPS_Info_pdn_gw_update,
        _EPS_Info_isr_Information,
        EPS_Info,
        _PDN_GW_Update_apn,
        _PDN_GW_Update_pdn_gw_Identity,
        _PDN_GW_Update_contextId,
        _PDN_GW_Update_extensionContainer,
        PDN_GW_Update,
        ISR_Information,
        _SGSN_Capability_solsaSupportIndicator,
        _SGSN_Capability_extensionContainer,
        _SGSN_Capability_superChargerSupportedInServingNetworkEntity,
        _SGSN_Capability_gprsEnhancementsSupportIndicator,
        _SGSN_Capability_supportedCamelPhases,
        _SGSN_Capability_supportedLCS_CapabilitySets,
        _SGSN_Capability_offeredCamel4CSIs,
        _SGSN_Capability_smsCallBarringSupportIndicator,
        _SGSN_Capability_supportedRAT_TypesIndicator,
        _SGSN_Capability_supportedFeatures,
        _SGSN_Capability_t_adsDataRetrieval,
        _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_cancellationTypeInitialAttach,
        _SGSN_Capability_msisdn_lessOperation_Supported,
        _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_reset_ids_Supported,
        _SGSN_Capability_ext_SupportedFeatures,
        SGSN_Capability,
        SupportedFeatures,
        Ext_SupportedFeatures,
        UE_SRVCC_Capability,
        _UpdateGprsLocationRes_hlr_Number,
        _UpdateGprsLocationRes_extensionContainer,
        _UpdateGprsLocationRes_add_Capability,
        _UpdateGprsLocationRes_sgsn_mmeSeparationSupported,
        _UpdateGprsLocationRes_mmeRegisteredforSMS,
        UpdateGprsLocationRes,
        _EPLMN_List__item_,
        EPLMN_List,
        _AdjacentPLMN_List__item_,
        AdjacentPLMN_List,
        _ForwardAccessSignalling_Arg_an_APDU,
        _ForwardAccessSignalling_Arg_integrityProtectionInfo,
        _ForwardAccessSignalling_Arg_encryptionInfo,
        _ForwardAccessSignalling_Arg_keyStatus,
        _ForwardAccessSignalling_Arg_allowedGSM_Algorithms,
        _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms,
        _ForwardAccessSignalling_Arg_radioResourceInformation,
        _ForwardAccessSignalling_Arg_extensionContainer,
        _ForwardAccessSignalling_Arg_radioResourceList,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandover,
        _ForwardAccessSignalling_Arg_ranap_ServiceHandover,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList,
        _ForwardAccessSignalling_Arg_currentlyUsedCodec,
        _ForwardAccessSignalling_Arg_iuSupportedCodecsList,
        _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator,
        _ForwardAccessSignalling_Arg_iuSelectedCodec,
        _ForwardAccessSignalling_Arg_alternativeChannelType,
        _ForwardAccessSignalling_Arg_tracePropagationList,
        _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor,
        _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ForwardAccessSignalling_Arg_uesbi_Iu,
        _ForwardAccessSignalling_Arg_imeisv,
        ForwardAccessSignalling_Arg,
        AllowedGSM_Algorithms,
        _AllowedUMTS_Algorithms_integrityProtectionAlgorithms,
        _AllowedUMTS_Algorithms_encryptionAlgorithms,
        _AllowedUMTS_Algorithms_extensionContainer,
        AllowedUMTS_Algorithms,
        PermittedIntegrityProtectionAlgorithms,
        maxPermittedIntegrityProtectionAlgorithmsLength,
        PermittedEncryptionAlgorithms,
        maxPermittedEncryptionAlgorithmsLength,
        KeyStatus,
        _PrepareHO_Arg_targetCellId,
        _PrepareHO_Arg_ho_NumberNotRequired,
        _PrepareHO_Arg_targetRNCId,
        _PrepareHO_Arg_an_APDU,
        _PrepareHO_Arg_multipleBearerRequested,
        _PrepareHO_Arg_imsi,
        _PrepareHO_Arg_integrityProtectionInfo,
        _PrepareHO_Arg_encryptionInfo,
        _PrepareHO_Arg_radioResourceInformation,
        _PrepareHO_Arg_allowedGSM_Algorithms,
        _PrepareHO_Arg_allowedUMTS_Algorithms,
        _PrepareHO_Arg_radioResourceList,
        _PrepareHO_Arg_extensionContainer,
        _PrepareHO_Arg_rab_Id,
        _PrepareHO_Arg_bssmap_ServiceHandover,
        _PrepareHO_Arg_ranap_ServiceHandover,
        _PrepareHO_Arg_bssmap_ServiceHandoverList,
        _PrepareHO_Arg_asciCallReference,
        _PrepareHO_Arg_geran_classmark,
        _PrepareHO_Arg_iuCurrentlyUsedCodec,
        _PrepareHO_Arg_iuSupportedCodecsList,
        _PrepareHO_Arg_rab_ConfigurationIndicator,
        _PrepareHO_Arg_uesbi_Iu,
        _PrepareHO_Arg_imeisv,
        _PrepareHO_Arg_alternativeChannelType,
        _PrepareHO_Arg_tracePropagationList,
        _PrepareHO_Arg_aoipSupportedCodecsListAnchor,
        _PrepareHO_Arg_regionalSubscriptionData,
        _PrepareHO_Arg_lclsGlobalCallReference,
        _PrepareHO_Arg_lcls_Negotiation,
        _PrepareHO_Arg_lcls_Configuration_Preference,
        _PrepareHO_Arg_csg_SubscriptionDataList,
        PrepareHO_Arg,
        LCLS_GlobalCallReference,
        LCLS_Negotiation,
        LCLS_ConfigurationPreference,
        _BSSMAP_ServiceHandoverList__item_,
        BSSMAP_ServiceHandoverList,
        _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover,
        _BSSMAP_ServiceHandoverInfo_rab_Id,
        BSSMAP_ServiceHandoverInfo,
        maxNumOfServiceHandovers,
        BSSMAP_ServiceHandover,
        RANAP_ServiceHandover,
        _RadioResourceList__item_,
        RadioResourceList,
        _RadioResource_radioResourceInformation,
        _RadioResource_rab_Id,
        RadioResource,
        maxNumOfRadioResources,
        _PrepareHO_Res_handoverNumber,
        _PrepareHO_Res_relocationNumberList,
        _PrepareHO_Res_an_APDU,
        _PrepareHO_Res_multicallBearerInfo,
        _PrepareHO_Res_multipleBearerNotSupported,
        _PrepareHO_Res_selectedUMTS_Algorithms,
        _PrepareHO_Res_chosenRadioResourceInformation,
        _PrepareHO_Res_extensionContainer,
        _PrepareHO_Res_iuSelectedCodec,
        _PrepareHO_Res_iuAvailableCodecsList,
        _PrepareHO_Res_aoipSelectedCodecTarget,
        _PrepareHO_Res_aoipAvailableCodecsListMap,
        PrepareHO_Res,
        _SelectedUMTS_Algorithms_integrityProtectionAlgorithm,
        _SelectedUMTS_Algorithms_encryptionAlgorithm,
        _SelectedUMTS_Algorithms_extensionContainer,
        SelectedUMTS_Algorithms,
        ChosenIntegrityProtectionAlgorithm,
        ChosenEncryptionAlgorithm,
        _ChosenRadioResourceInformation_chosenChannelInfo,
        _ChosenRadioResourceInformation_chosenSpeechVersion,
        ChosenRadioResourceInformation,
        ChosenChannelInfo,
        ChosenSpeechVersion,
        _PrepareSubsequentHO_Arg_targetCellId,
        _PrepareSubsequentHO_Arg_targetMSC_Number,
        _PrepareSubsequentHO_Arg_targetRNCId,
        _PrepareSubsequentHO_Arg_an_APDU,
        _PrepareSubsequentHO_Arg_selectedRab_Id,
        _PrepareSubsequentHO_Arg_extensionContainer,
        _PrepareSubsequentHO_Arg_geran_classmark,
        _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator,
        PrepareSubsequentHO_Arg,
        _PrepareSubsequentHO_Res_an_APDU,
        _PrepareSubsequentHO_Res_extensionContainer,
        PrepareSubsequentHO_Res,
        _ProcessAccessSignalling_Arg_an_APDU,
        _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms,
        _ProcessAccessSignalling_Arg_selectedGSM_Algorithm,
        _ProcessAccessSignalling_Arg_chosenRadioResourceInformation,
        _ProcessAccessSignalling_Arg_selectedRab_Id,
        _ProcessAccessSignalling_Arg_extensionContainer,
        _ProcessAccessSignalling_Arg_iUSelectedCodec,
        _ProcessAccessSignalling_Arg_iuAvailableCodecsList,
        _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap,
        ProcessAccessSignalling_Arg,
        _AoIPCodecsList_codec1,
        _AoIPCodecsList_codec2,
        _AoIPCodecsList_codec3,
        _AoIPCodecsList_codec4,
        _AoIPCodecsList_codec5,
        _AoIPCodecsList_codec6,
        _AoIPCodecsList_codec7,
        _AoIPCodecsList_codec8,
        _AoIPCodecsList_extensionContainer,
        AoIPCodecsList,
        AoIPCodec,
        _SupportedCodecsList_utranCodecList,
        _SupportedCodecsList_geranCodecList,
        _SupportedCodecsList_extensionContainer,
        SupportedCodecsList,
        _CodecList_codec1,
        _CodecList_codec2,
        _CodecList_codec3,
        _CodecList_codec4,
        _CodecList_codec5,
        _CodecList_codec6,
        _CodecList_codec7,
        _CodecList_codec8,
        _CodecList_extensionContainer,
        CodecList,
        Codec,
        GERAN_Classmark,
        SelectedGSM_Algorithm,
        _SendEndSignal_Arg_an_APDU,
        _SendEndSignal_Arg_extensionContainer,
        SendEndSignal_Arg,
        _SendEndSignal_Res_extensionContainer,
        SendEndSignal_Res,
        RNCId,
        _RelocationNumberList__item_,
        RelocationNumberList,
        MulticallBearerInfo,
        _RelocationNumber_handoverNumber,
        _RelocationNumber_rab_Id,
        RelocationNumber,
        RAB_Id,
        maxNrOfRABs,
        maxNumOfRelocationNumber,
        RadioResourceInformation,
        IntegrityProtectionInformation,
        maxNumOfIntegrityInfo,
        EncryptionInformation,
        maxNumOfEncryptionInfo,
        _SendAuthenticationInfoArg_imsi,
        _SendAuthenticationInfoArg_numberOfRequestedVectors,
        _SendAuthenticationInfoArg_segmentationProhibited,
        _SendAuthenticationInfoArg_immediateResponsePreferred,
        _SendAuthenticationInfoArg_re_synchronisationInfo,
        _SendAuthenticationInfoArg_extensionContainer,
        _SendAuthenticationInfoArg_requestingNodeType,
        _SendAuthenticationInfoArg_requestingPLMN_Id,
        _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors,
        _SendAuthenticationInfoArg_additionalVectorsAreForEPS,
        _SendAuthenticationInfoArg_ueUsageTypeRequestIndication,
        SendAuthenticationInfoArg,
        NumberOfRequestedVectors,
        _Re_synchronisationInfo_rand,
        _Re_synchronisationInfo_auts,
        Re_synchronisationInfo,
        _SendAuthenticationInfoRes_authenticationSetList,
        _SendAuthenticationInfoRes_extensionContainer,
        _SendAuthenticationInfoRes_eps_AuthenticationSetList,
        _SendAuthenticationInfoRes_ueUsageType,
        SendAuthenticationInfoRes,
        _EPS_AuthenticationSetList__item_,
        EPS_AuthenticationSetList,
        UE_UsageType,
        _EPC_AV_rand,
        _EPC_AV_xres,
        _EPC_AV_autn,
        _EPC_AV_kasme,
        _EPC_AV_extensionContainer,
        EPC_AV,
        KASME,
        RequestingNodeType,
        _CheckIMEI_Arg_imei,
        _CheckIMEI_Arg_requestedEquipmentInfo,
        _CheckIMEI_Arg_extensionContainer,
        CheckIMEI_Arg,
        _CheckIMEI_Res_equipmentStatus,
        _CheckIMEI_Res_bmuef,
        _CheckIMEI_Res_extensionContainer,
        CheckIMEI_Res,
        RequestedEquipmentInfo,
        _UESBI_Iu_uesbi_IuA,
        _UESBI_Iu_uesbi_IuB,
        UESBI_Iu,
        UESBI_IuA,
        UESBI_IuB,
        EquipmentStatus,
        _InsertSubscriberDataArg_imsi,
        _InsertSubscriberDataArg_msisdn,
        _InsertSubscriberDataArg_category,
        _InsertSubscriberDataArg_subscriberStatus,
        _InsertSubscriberDataArg_bearerServiceList,
        _InsertSubscriberDataArg_teleserviceList,
        _InsertSubscriberDataArg_provisionedSS,
        _InsertSubscriberDataArg_odb_Data,
        _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _InsertSubscriberDataArg_regionalSubscriptionData,
        _InsertSubscriberDataArg_vbsSubscriptionData,
        _InsertSubscriberDataArg_vgcsSubscriptionData,
        _InsertSubscriberDataArg_vlrCamelSubscriptionInfo,
        _InsertSubscriberDataArg_extensionContainer,
        _InsertSubscriberDataArg_naea_PreferredCI,
        _InsertSubscriberDataArg_gprsSubscriptionData,
        _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature,
        _InsertSubscriberDataArg_networkAccessMode,
        _InsertSubscriberDataArg_lsaInformation,
        _InsertSubscriberDataArg_lmu_Indicator,
        _InsertSubscriberDataArg_lcsInformation,
        _InsertSubscriberDataArg_istAlertTimer,
        _InsertSubscriberDataArg_superChargerSupportedInHLR,
        _InsertSubscriberDataArg_mc_SS_Info,
        _InsertSubscriberDataArg_cs_AllocationRetentionPriority,
        _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo,
        _InsertSubscriberDataArg_chargingCharacteristics,
        _InsertSubscriberDataArg_accessRestrictionData,
        _InsertSubscriberDataArg_ics_Indicator,
        _InsertSubscriberDataArg_eps_SubscriptionData,
        _InsertSubscriberDataArg_csg_SubscriptionDataList,
        _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator,
        _InsertSubscriberDataArg_sgsn_Number,
        _InsertSubscriberDataArg_mme_Name,
        _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer,
        _InsertSubscriberDataArg_vplmnLIPAAllowed,
        _InsertSubscriberDataArg_mdtUserConsent,
        _InsertSubscriberDataArg_subscribedPeriodicLAUtimer,
        _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList,
        _InsertSubscriberDataArg_additionalMSISDN,
        _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision,
        _InsertSubscriberDataArg_smsInSGSNAllowed,
        _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator,
        _InsertSubscriberDataArg_pcscf_Restoration_Request,
        _InsertSubscriberDataArg_adjacentAccessRestrictionDataList,
        _InsertSubscriberDataArg_imsi_Group_Id_List,
        _InsertSubscriberDataArg_ueUsageType,
        _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator,
        _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count,
        _InsertSubscriberDataArg_reset_Id_List,
        _InsertSubscriberDataArg_eDRX_Cycle_Length_List,
        _InsertSubscriberDataArg_ext_AccessRestrictionData,
        _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator,
        InsertSubscriberDataArg,
        _EDRX_Cycle_Length_List__item_,
        EDRX_Cycle_Length_List,
        _EDRX_Cycle_Length_rat_Type,
        _EDRX_Cycle_Length_eDRX_Cycle_Length_Value,
        EDRX_Cycle_Length,
        EDRX_Cycle_Length_Value,
        _Reset_Id_List__item_,
        Reset_Id_List,
        Reset_Id,
        DL_Buffering_Suggested_Packet_Count,
        Group_Service_ID,
        Local_GroupID,
        _IMSI_GroupIdList__item_,
        IMSI_GroupIdList,
        _IMSI_GroupId_group_Service_Id,
        _IMSI_GroupId_plmnId,
        _IMSI_GroupId_local_Group_ID,
        IMSI_GroupId,
        SubscribedPeriodicRAUTAUtimer,
        SubscribedPeriodicLAUtimer,
        _CSG_SubscriptionDataList__item_,
        CSG_SubscriptionDataList,
        _CSG_SubscriptionData_csg_Id,
        _CSG_SubscriptionData_expirationDate,
        _CSG_SubscriptionData_extensionContainer,
        _CSG_SubscriptionData_lipa_AllowedAPNList,
        _CSG_SubscriptionData_plmn_Id,
        CSG_SubscriptionData,
        _VPLMN_CSG_SubscriptionDataList__item_,
        VPLMN_CSG_SubscriptionDataList,
        CSG_Id,
        _LIPA_AllowedAPNList__item_,
        LIPA_AllowedAPNList,
        maxNumOfLIPAAllowedAPN,
        _EPS_SubscriptionData_apn_oi_Replacement,
        _EPS_SubscriptionData_rfsp_id,
        _EPS_SubscriptionData_ambr,
        _EPS_SubscriptionData_apn_ConfigurationProfile,
        _EPS_SubscriptionData_stn_sr,
        _EPS_SubscriptionData_extensionContainer,
        _EPS_SubscriptionData_mps_CSPriority,
        _EPS_SubscriptionData_mps_EPSPriority,
        _EPS_SubscriptionData_subscribed_vsrvcc,
        EPS_SubscriptionData,
        APN_OI_Replacement,
        RFSP_ID,
        _APN_ConfigurationProfile_defaultContext,
        _APN_ConfigurationProfile_completeDataListIncluded,
        _APN_ConfigurationProfile_epsDataList,
        _APN_ConfigurationProfile_extensionContainer,
        _APN_ConfigurationProfile_additionalDefaultContext,
        APN_ConfigurationProfile,
        _EPS_DataList__item_,
        EPS_DataList,
        maxNumOfAPN_Configurations,
        _APN_Configuration_contextId,
        _APN_Configuration_pdn_Type,
        _APN_Configuration_servedPartyIP_IPv4_Address,
        _APN_Configuration_apn,
        _APN_Configuration_eps_qos_Subscribed,
        _APN_Configuration_pdn_gw_Identity,
        _APN_Configuration_pdn_gw_AllocationType,
        _APN_Configuration_vplmnAddressAllowed,
        _APN_Configuration_chargingCharacteristics,
        _APN_Configuration_ambr,
        _APN_Configuration_specificAPNInfoList,
        _APN_Configuration_extensionContainer,
        _APN_Configuration_servedPartyIP_IPv6_Address,
        _APN_Configuration_apn_oi_Replacement,
        _APN_Configuration_sipto_Permission,
        _APN_Configuration_lipa_Permission,
        _APN_Configuration_restoration_Priority,
        _APN_Configuration_sipto_local_network_Permission,
        _APN_Configuration_wlan_offloadability,
        _APN_Configuration_non_IP_PDN_Type_Indicator,
        _APN_Configuration_nIDD_Mechanism,
        _APN_Configuration_sCEF_ID,
        _APN_Configuration_pdn_ConnectionContinuity,
        APN_Configuration,
        PDN_ConnectionContinuity,
        NIDD_Mechanism,
        PDN_Type,
        _EPS_QoS_Subscribed_qos_Class_Identifier,
        _EPS_QoS_Subscribed_allocation_Retention_Priority,
        _EPS_QoS_Subscribed_extensionContainer,
        EPS_QoS_Subscribed,
        _AMBR_max_RequestedBandwidth_UL,
        _AMBR_max_RequestedBandwidth_DL,
        _AMBR_extensionContainer,
        _AMBR_extended_Max_RequestedBandwidth_UL,
        _AMBR_extended_Max_RequestedBandwidth_DL,
        AMBR,
        _SpecificAPNInfoList__item_,
        SpecificAPNInfoList,
        maxNumOfSpecificAPNInfos,
        _SpecificAPNInfo_apn,
        _SpecificAPNInfo_pdn_gw_Identity,
        _SpecificAPNInfo_extensionContainer,
        SpecificAPNInfo,
        Bandwidth,
        BandwidthExt,
        QoS_Class_Identifier,
        _Allocation_Retention_Priority_priority_level,
        _Allocation_Retention_Priority_pre_emption_capability,
        _Allocation_Retention_Priority_pre_emption_vulnerability,
        _Allocation_Retention_Priority_extensionContainer,
        Allocation_Retention_Priority,
        _PDN_GW_Identity_pdn_gw_ipv4_Address,
        _PDN_GW_Identity_pdn_gw_ipv6_Address,
        _PDN_GW_Identity_pdn_gw_name,
        _PDN_GW_Identity_extensionContainer,
        PDN_GW_Identity,
        FQDN,
        PDN_GW_AllocationType,
        _WLAN_Offloadability_wlan_offloadability_EUTRAN,
        _WLAN_Offloadability_wlan_offloadability_UTRAN,
        _WLAN_Offloadability_extensionContainer,
        WLAN_Offloadability,
        WLAN_Offloadability_Indication,
        AccessRestrictionData,
        Ext_AccessRestrictionData,
        _AdjacentAccessRestrictionDataList__item_,
        AdjacentAccessRestrictionDataList,
        _AdjacentAccessRestrictionData_plmnId,
        _AdjacentAccessRestrictionData_accessRestrictionData,
        _AdjacentAccessRestrictionData_ext_AccessRestrictionData,
        AdjacentAccessRestrictionData,
        CS_AllocationRetentionPriority,
        IST_AlertTimerValue,
        _LCSInformation_gmlc_List,
        _LCSInformation_lcs_PrivacyExceptionList,
        _LCSInformation_molr_List,
        _LCSInformation_add_lcs_PrivacyExceptionList,
        LCSInformation,
        _GMLC_List__item_,
        GMLC_List,
        maxNumOfGMLC,
        NetworkAccessMode,
        _GPRSDataList__item_,
        GPRSDataList,
        maxNumOfPDP_Contexts,
        _PDP_Context_pdp_ContextId,
        _PDP_Context_pdp_Type,
        _PDP_Context_pdp_Address,
        _PDP_Context_qos_Subscribed,
        _PDP_Context_vplmnAddressAllowed,
        _PDP_Context_apn,
        _PDP_Context_extensionContainer,
        _PDP_Context_ext_QoS_Subscribed,
        _PDP_Context_pdp_ChargingCharacteristics,
        _PDP_Context_ext2_QoS_Subscribed,
        _PDP_Context_ext3_QoS_Subscribed,
        _PDP_Context_ext4_QoS_Subscribed,
        _PDP_Context_apn_oi_Replacement,
        _PDP_Context_ext_pdp_Type,
        _PDP_Context_ext_pdp_Address,
        _PDP_Context_ambr,
        _PDP_Context_sipto_Permission,
        _PDP_Context_lipa_Permission,
        _PDP_Context_restoration_Priority,
        _PDP_Context_sipto_local_network_Permission,
        _PDP_Context_nIDD_Mechanism,
        _PDP_Context_sCEF_ID,
        PDP_Context,
        Restoration_Priority,
        SIPTO_Permission,
        SIPTO_Local_Network_Permission,
        LIPA_Permission,
        ContextId,
        _GPRSSubscriptionData_completeDataListIncluded,
        _GPRSSubscriptionData_gprsDataList,
        _GPRSSubscriptionData_extensionContainer,
        _GPRSSubscriptionData_apn_oi_Replacement,
        GPRSSubscriptionData,
        _SGSN_CAMEL_SubscriptionInfo_gprs_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_extensionContainer,
        _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _SGSN_CAMEL_SubscriptionInfo_mg_csi,
        SGSN_CAMEL_SubscriptionInfo,
        _GPRS_CSI_gprs_CamelTDPDataList,
        _GPRS_CSI_camelCapabilityHandling,
        _GPRS_CSI_extensionContainer,
        _GPRS_CSI_notificationToCSE,
        _GPRS_CSI_csi_Active,
        GPRS_CSI,
        _GPRS_CamelTDPDataList__item_,
        GPRS_CamelTDPDataList,
        _GPRS_CamelTDPData_gprs_TriggerDetectionPoint,
        _GPRS_CamelTDPData_serviceKey,
        _GPRS_CamelTDPData_gsmSCF_Address,
        _GPRS_CamelTDPData_defaultSessionHandling,
        _GPRS_CamelTDPData_extensionContainer,
        GPRS_CamelTDPData,
        DefaultGPRS_Handling,
        GPRS_TriggerDetectionPoint,
        APN,
        PDP_Type,
        Ext_PDP_Type,
        PDP_Address,
        QoS_Subscribed,
        Ext_QoS_Subscribed,
        Ext2_QoS_Subscribed,
        Ext3_QoS_Subscribed,
        Ext4_QoS_Subscribed,
        ChargingCharacteristics,
        LSAOnlyAccessIndicator,
        _LSADataList__item_,
        LSADataList,
        maxNumOfLSAs,
        _LSAData_lsaIdentity,
        _LSAData_lsaAttributes,
        _LSAData_lsaActiveModeIndicator,
        _LSAData_extensionContainer,
        LSAData,
        _LSAInformation_completeDataListIncluded,
        _LSAInformation_lsaOnlyAccessIndicator,
        _LSAInformation_lsaDataList,
        _LSAInformation_extensionContainer,
        LSAInformation,
        LSAIdentity,
        LSAAttributes,
        _SubscriberData_msisdn,
        _SubscriberData_category,
        _SubscriberData_subscriberStatus,
        _SubscriberData_bearerServiceList,
        _SubscriberData_teleserviceList,
        _SubscriberData_provisionedSS,
        _SubscriberData_odb_Data,
        _SubscriberData_roamingRestrictionDueToUnsupportedFeature,
        _SubscriberData_regionalSubscriptionData,
        _SubscriberData_vbsSubscriptionData,
        _SubscriberData_vgcsSubscriptionData,
        _SubscriberData_vlrCamelSubscriptionInfo,
        SubscriberData,
        Category,
        SubscriberStatus,
        _BearerServiceList__item_,
        BearerServiceList,
        maxNumOfBearerServices,
        _TeleserviceList__item_,
        TeleserviceList,
        maxNumOfTeleservices,
        _ODB_Data_odb_GeneralData,
        _ODB_Data_odb_HPLMN_Data,
        _ODB_Data_extensionContainer,
        ODB_Data,
        ODB_GeneralData,
        ODB_HPLMN_Data,
        _Ext_SS_InfoList__item_,
        Ext_SS_InfoList,
        _Ext_SS_Info_forwardingInfo,
        _Ext_SS_Info_callBarringInfo,
        _Ext_SS_Info_cug_Info,
        _Ext_SS_Info_ss_Data,
        _Ext_SS_Info_emlpp_Info,
        Ext_SS_Info,
        _Ext_ForwInfo_ss_Code,
        _Ext_ForwInfo_forwardingFeatureList,
        _Ext_ForwInfo_extensionContainer,
        Ext_ForwInfo,
        _Ext_ForwFeatureList__item_,
        Ext_ForwFeatureList,
        _Ext_ForwFeature_basicService,
        _Ext_ForwFeature_ss_Status,
        _Ext_ForwFeature_forwardedToNumber,
        _Ext_ForwFeature_forwardedToSubaddress,
        _Ext_ForwFeature_forwardingOptions,
        _Ext_ForwFeature_noReplyConditionTime,
        _Ext_ForwFeature_extensionContainer,
        _Ext_ForwFeature_longForwardedToNumber,
        Ext_ForwFeature,
        Ext_ForwOptions,
        Ext_NoRepCondTime,
        _Ext_CallBarInfo_ss_Code,
        _Ext_CallBarInfo_callBarringFeatureList,
        _Ext_CallBarInfo_extensionContainer,
        Ext_CallBarInfo,
        _Ext_CallBarFeatureList__item_,
        Ext_CallBarFeatureList,
        _Ext_CallBarringFeature_basicService,
        _Ext_CallBarringFeature_ss_Status,
        _Ext_CallBarringFeature_extensionContainer,
        Ext_CallBarringFeature,
        _CUG_Info_cug_SubscriptionList,
        _CUG_Info_cug_FeatureList,
        _CUG_Info_extensionContainer,
        CUG_Info,
        _CUG_SubscriptionList__item_,
        CUG_SubscriptionList,
        _CUG_Subscription_cug_Index,
        _CUG_Subscription_cug_Interlock,
        _CUG_Subscription_intraCUG_Options,
        _CUG_Subscription_basicServiceGroupList,
        _CUG_Subscription_extensionContainer,
        CUG_Subscription,
        CUG_Index,
        CUG_Interlock,
        IntraCUG_Options,
        maxNumOfCUG,
        _CUG_FeatureList__item_,
        CUG_FeatureList,
        _Ext_BasicServiceGroupList__item_,
        Ext_BasicServiceGroupList,
        maxNumOfExt_BasicServiceGroups,
        _CUG_Feature_basicService,
        _CUG_Feature_preferentialCUG_Indicator,
        _CUG_Feature_interCUG_Restrictions,
        _CUG_Feature_extensionContainer,
        CUG_Feature,
        InterCUG_Restrictions,
        _Ext_SS_Data_ss_Code,
        _Ext_SS_Data_ss_Status,
        _Ext_SS_Data_ss_SubscriptionOption,
        _Ext_SS_Data_basicServiceGroupList,
        _Ext_SS_Data_extensionContainer,
        Ext_SS_Data,
        _LCS_PrivacyExceptionList__item_,
        LCS_PrivacyExceptionList,
        maxNumOfPrivacyClass,
        _LCS_PrivacyClass_ss_Code,
        _LCS_PrivacyClass_ss_Status,
        _LCS_PrivacyClass_notificationToMSUser,
        _LCS_PrivacyClass_externalClientList,
        _LCS_PrivacyClass_plmnClientList,
        _LCS_PrivacyClass_extensionContainer,
        _LCS_PrivacyClass_ext_externalClientList,
        _LCS_PrivacyClass_serviceTypeList,
        LCS_PrivacyClass,
        _ExternalClientList__item_,
        ExternalClientList,
        maxNumOfExternalClient,
        _PLMNClientList__item_,
        PLMNClientList,
        maxNumOfPLMNClient,
        _Ext_ExternalClientList__item_,
        Ext_ExternalClientList,
        maxNumOfExt_ExternalClient,
        _ExternalClient_clientIdentity,
        _ExternalClient_gmlc_Restriction,
        _ExternalClient_notificationToMSUser,
        _ExternalClient_extensionContainer,
        ExternalClient,
        GMLC_Restriction,
        NotificationToMSUser,
        _ServiceTypeList__item_,
        ServiceTypeList,
        maxNumOfServiceType,
        _ServiceType_serviceTypeIdentity,
        _ServiceType_gmlc_Restriction,
        _ServiceType_notificationToMSUser,
        _ServiceType_extensionContainer,
        ServiceType,
        _MOLR_List__item_,
        MOLR_List,
        maxNumOfMOLR_Class,
        _MOLR_Class_ss_Code,
        _MOLR_Class_ss_Status,
        _MOLR_Class_extensionContainer,
        MOLR_Class,
        _ZoneCodeList__item_,
        ZoneCodeList,
        ZoneCode,
        maxNumOfZoneCodes,
        _InsertSubscriberDataRes_teleserviceList,
        _InsertSubscriberDataRes_bearerServiceList,
        _InsertSubscriberDataRes_ss_List,
        _InsertSubscriberDataRes_odb_GeneralData,
        _InsertSubscriberDataRes_regionalSubscriptionResponse,
        _InsertSubscriberDataRes_supportedCamelPhases,
        _InsertSubscriberDataRes_extensionContainer,
        _InsertSubscriberDataRes_offeredCamel4CSIs,
        _InsertSubscriberDataRes_supportedFeatures,
        _InsertSubscriberDataRes_ext_SupportedFeatures,
        InsertSubscriberDataRes,
        RegionalSubscriptionResponse,
        _DeleteSubscriberDataArg_imsi,
        _DeleteSubscriberDataArg_basicServiceList,
        _DeleteSubscriberDataArg_ss_List,
        _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _DeleteSubscriberDataArg_regionalSubscriptionIdentifier,
        _DeleteSubscriberDataArg_vbsGroupIndication,
        _DeleteSubscriberDataArg_vgcsGroupIndication,
        _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw,
        _DeleteSubscriberDataArg_extensionContainer,
        _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature,
        _DeleteSubscriberDataArg_lsaInformationWithdraw,
        _DeleteSubscriberDataArg_gmlc_ListWithdraw,
        _DeleteSubscriberDataArg_istInformationWithdraw,
        _DeleteSubscriberDataArg_specificCSI_Withdraw,
        _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw,
        _DeleteSubscriberDataArg_stn_srWithdraw,
        _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_apn_oi_replacementWithdraw,
        _DeleteSubscriberDataArg_csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw,
        _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_additionalMSISDN_Withdraw,
        _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw,
        _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw,
        _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw,
        _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw,
        _DeleteSubscriberDataArg_ue_UsageTypeWithdraw,
        _DeleteSubscriberDataArg_reset_idsWithdraw,
        _DeleteSubscriberDataArg_iab_OperationWithdraw,
        DeleteSubscriberDataArg,
        SpecificCSI_Withdraw,
        _GPRSSubscriptionDataWithdraw_allGPRSData,
        _GPRSSubscriptionDataWithdraw_contextIdList,
        GPRSSubscriptionDataWithdraw,
        _EPS_SubscriptionDataWithdraw_allEPS_Data,
        _EPS_SubscriptionDataWithdraw_contextIdList,
        EPS_SubscriptionDataWithdraw,
        _ContextIdList__item_,
        ContextIdList,
        _LSAInformationWithdraw_allLSAData,
        _LSAInformationWithdraw_lsaIdentityList,
        LSAInformationWithdraw,
        _LSAIdentityList__item_,
        LSAIdentityList,
        _BasicServiceList__item_,
        BasicServiceList,
        maxNumOfBasicServices,
        _DeleteSubscriberDataRes_regionalSubscriptionResponse,
        _DeleteSubscriberDataRes_extensionContainer,
        DeleteSubscriberDataRes,
        _VlrCamelSubscriptionInfo_o_CSI,
        _VlrCamelSubscriptionInfo_extensionContainer,
        _VlrCamelSubscriptionInfo_ss_CSI,
        _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _VlrCamelSubscriptionInfo_tif_CSI,
        _VlrCamelSubscriptionInfo_m_CSI,
        _VlrCamelSubscriptionInfo_mo_sms_CSI,
        _VlrCamelSubscriptionInfo_vt_CSI,
        _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _VlrCamelSubscriptionInfo_d_CSI,
        _VlrCamelSubscriptionInfo_mt_sms_CSI,
        _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        VlrCamelSubscriptionInfo,
        _MT_smsCAMELTDP_CriteriaList__item_,
        MT_smsCAMELTDP_CriteriaList,
        _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint,
        _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion,
        MT_smsCAMELTDP_Criteria,
        _TPDU_TypeCriterion__item_,
        TPDU_TypeCriterion,
        maxNumOfTPDUTypes,
        MT_SMS_TPDU_Type,
        _D_CSI_dp_AnalysedInfoCriteriaList,
        _D_CSI_camelCapabilityHandling,
        _D_CSI_extensionContainer,
        _D_CSI_notificationToCSE,
        _D_CSI_csi_Active,
        D_CSI,
        _DP_AnalysedInfoCriteriaList__item_,
        DP_AnalysedInfoCriteriaList,
        maxNumOfDP_AnalysedInfoCriteria,
        _DP_AnalysedInfoCriterium_dialledNumber,
        _DP_AnalysedInfoCriterium_serviceKey,
        _DP_AnalysedInfoCriterium_gsmSCF_Address,
        _DP_AnalysedInfoCriterium_defaultCallHandling,
        _DP_AnalysedInfoCriterium_extensionContainer,
        DP_AnalysedInfoCriterium,
        _SS_CSI_ss_CamelData,
        _SS_CSI_extensionContainer,
        _SS_CSI_notificationToCSE,
        _SS_CSI_csi_Active,
        SS_CSI,
        _SS_CamelData_ss_EventList,
        _SS_CamelData_gsmSCF_Address,
        _SS_CamelData_extensionContainer,
        SS_CamelData,
        _SS_EventList__item_,
        SS_EventList,
        maxNumOfCamelSSEvents,
        _O_CSI_o_BcsmCamelTDPDataList,
        _O_CSI_extensionContainer,
        _O_CSI_camelCapabilityHandling,
        _O_CSI_notificationToCSE,
        _O_CSI_csiActive,
        O_CSI,
        _O_BcsmCamelTDPDataList__item_,
        O_BcsmCamelTDPDataList,
        maxNumOfCamelTDPData,
        _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPData_serviceKey,
        _O_BcsmCamelTDPData_gsmSCF_Address,
        _O_BcsmCamelTDPData_defaultCallHandling,
        _O_BcsmCamelTDPData_extensionContainer,
        O_BcsmCamelTDPData,
        ServiceKey,
        O_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPCriteriaList__item_,
        O_BcsmCamelTDPCriteriaList,
        _T_BCSM_CAMEL_TDP_CriteriaList__item_,
        T_BCSM_CAMEL_TDP_CriteriaList,
        _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDP_Criteria_destinationNumberCriteria,
        _O_BcsmCamelTDP_Criteria_basicServiceCriteria,
        _O_BcsmCamelTDP_Criteria_callTypeCriteria,
        _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria,
        _O_BcsmCamelTDP_Criteria_extensionContainer,
        O_BcsmCamelTDP_Criteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint,
        _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria,
        T_BCSM_CAMEL_TDP_Criteria,
        _DestinationNumberCriteria_matchType,
        _DestinationNumberCriteria_destinationNumberList,
        _DestinationNumberCriteria_destinationNumberLengthList,
        DestinationNumberCriteria,
        _DestinationNumberList__item_,
        DestinationNumberList,
        _DestinationNumberLengthList__item_,
        DestinationNumberLengthList,
        _BasicServiceCriteria__item_,
        BasicServiceCriteria,
        maxNumOfISDN_AddressDigits,
        maxNumOfCamelDestinationNumbers,
        maxNumOfCamelDestinationNumberLengths,
        maxNumOfCamelBasicServiceCriteria,
        CallTypeCriteria,
        MatchType,
        _O_CauseValueCriteria__item_,
        O_CauseValueCriteria,
        _T_CauseValueCriteria__item_,
        T_CauseValueCriteria,
        maxNumOfCAMEL_O_CauseValueCriteria,
        maxNumOfCAMEL_T_CauseValueCriteria,
        CauseValue,
        DefaultCallHandling,
        CamelCapabilityHandling,
        SupportedCamelPhases,
        OfferedCamel4CSIs,
        OfferedCamel4Functionalities,
        _SMS_CSI_sms_CAMEL_TDP_DataList,
        _SMS_CSI_camelCapabilityHandling,
        _SMS_CSI_extensionContainer,
        _SMS_CSI_notificationToCSE,
        _SMS_CSI_csi_Active,
        SMS_CSI,
        _SMS_CAMEL_TDP_DataList__item_,
        SMS_CAMEL_TDP_DataList,
        _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint,
        _SMS_CAMEL_TDP_Data_serviceKey,
        _SMS_CAMEL_TDP_Data_gsmSCF_Address,
        _SMS_CAMEL_TDP_Data_defaultSMS_Handling,
        _SMS_CAMEL_TDP_Data_extensionContainer,
        SMS_CAMEL_TDP_Data,
        SMS_TriggerDetectionPoint,
        DefaultSMS_Handling,
        _M_CSI_mobilityTriggers,
        _M_CSI_serviceKey,
        _M_CSI_gsmSCF_Address,
        _M_CSI_extensionContainer,
        _M_CSI_notificationToCSE,
        _M_CSI_csi_Active,
        M_CSI,
        _MG_CSI_mobilityTriggers,
        _MG_CSI_serviceKey,
        _MG_CSI_gsmSCF_Address,
        _MG_CSI_extensionContainer,
        _MG_CSI_notificationToCSE,
        _MG_CSI_csi_Active,
        MG_CSI,
        _MobilityTriggers__item_,
        MobilityTriggers,
        maxNumOfMobilityTriggers,
        MM_Code,
        _T_CSI_t_BcsmCamelTDPDataList,
        _T_CSI_extensionContainer,
        _T_CSI_camelCapabilityHandling,
        _T_CSI_notificationToCSE,
        _T_CSI_csi_Active,
        T_CSI,
        _T_BcsmCamelTDPDataList__item_,
        T_BcsmCamelTDPDataList,
        _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint,
        _T_BcsmCamelTDPData_serviceKey,
        _T_BcsmCamelTDPData_gsmSCF_Address,
        _T_BcsmCamelTDPData_defaultCallHandling,
        _T_BcsmCamelTDPData_extensionContainer,
        T_BcsmCamelTDPData,
        T_BcsmTriggerDetectionPoint,
        _SendRoutingInfoForGprsArg_imsi,
        _SendRoutingInfoForGprsArg_ggsn_Address,
        _SendRoutingInfoForGprsArg_ggsn_Number,
        _SendRoutingInfoForGprsArg_extensionContainer,
        SendRoutingInfoForGprsArg,
        _SendRoutingInfoForGprsRes_sgsn_Address,
        _SendRoutingInfoForGprsRes_ggsn_Address,
        _SendRoutingInfoForGprsRes_mobileNotReachableReason,
        _SendRoutingInfoForGprsRes_extensionContainer,
        SendRoutingInfoForGprsRes,
        _FailureReportArg_imsi,
        _FailureReportArg_ggsn_Number,
        _FailureReportArg_ggsn_Address,
        _FailureReportArg_extensionContainer,
        FailureReportArg,
        _FailureReportRes_ggsn_Address,
        _FailureReportRes_extensionContainer,
        FailureReportRes,
        _NoteMsPresentForGprsArg_imsi,
        _NoteMsPresentForGprsArg_sgsn_Address,
        _NoteMsPresentForGprsArg_ggsn_Address,
        _NoteMsPresentForGprsArg_extensionContainer,
        NoteMsPresentForGprsArg,
        _NoteMsPresentForGprsRes_extensionContainer,
        NoteMsPresentForGprsRes,
        _ResetArg_sendingNodenumber,
        _ResetArg_hlr_List,
        _ResetArg_extensionContainer,
        _ResetArg_reset_Id_List,
        _ResetArg_subscriptionData,
        _ResetArg_subscriptionDataDeletion,
        ResetArg,
        _SendingNode_Number_hlr_Number,
        _SendingNode_Number_css_Number,
        SendingNode_Number,
        _RestoreDataArg_imsi,
        _RestoreDataArg_lmsi,
        _RestoreDataArg_extensionContainer,
        _RestoreDataArg_vlr_Capability,
        _RestoreDataArg_restorationIndicator,
        RestoreDataArg,
        _RestoreDataRes_hlr_Number,
        _RestoreDataRes_msNotReachable,
        _RestoreDataRes_extensionContainer,
        RestoreDataRes,
        _VBSDataList__item_,
        VBSDataList,
        _VGCSDataList__item_,
        VGCSDataList,
        maxNumOfVBSGroupIds,
        maxNumOfVGCSGroupIds,
        _VoiceGroupCallData_groupId,
        _VoiceGroupCallData_extensionContainer,
        _VoiceGroupCallData_additionalSubscriptions,
        _VoiceGroupCallData_additionalInfo,
        _VoiceGroupCallData_longGroupId,
        VoiceGroupCallData,
        AdditionalInfo,
        AdditionalSubscriptions,
        _VoiceBroadcastData_groupid,
        _VoiceBroadcastData_broadcastInitEntitlement,
        _VoiceBroadcastData_extensionContainer,
        _VoiceBroadcastData_longGroupId,
        VoiceBroadcastData,
        GroupId,
        Long_GroupId,
        _ProvideSubscriberInfoArg_imsi,
        _ProvideSubscriberInfoArg_lmsi,
        _ProvideSubscriberInfoArg_requestedInfo,
        _ProvideSubscriberInfoArg_extensionContainer,
        _ProvideSubscriberInfoArg_callPriority,
        ProvideSubscriberInfoArg,
        _ProvideSubscriberInfoRes_subscriberInfo,
        _ProvideSubscriberInfoRes_extensionContainer,
        ProvideSubscriberInfoRes,
        _SubscriberInfo_locationInformation,
        _SubscriberInfo_subscriberState,
        _SubscriberInfo_extensionContainer,
        _SubscriberInfo_locationInformationGPRS,
        _SubscriberInfo_ps_SubscriberState,
        _SubscriberInfo_imei,
        _SubscriberInfo_ms_Classmark2,
        _SubscriberInfo_gprs_MS_Class,
        _SubscriberInfo_mnpInfoRes,
        _SubscriberInfo_imsVoiceOverPS_SessionsIndication,
        _SubscriberInfo_lastUE_ActivityTime,
        _SubscriberInfo_lastRAT_Type,
        _SubscriberInfo_eps_SubscriberState,
        _SubscriberInfo_locationInformationEPS,
        _SubscriberInfo_timeZone,
        _SubscriberInfo_daylightSavingTime,
        _SubscriberInfo_locationInformation5GS,
        SubscriberInfo,
        IMS_VoiceOverPS_SessionsInd,
        TimeZone,
        DaylightSavingTime,
        _MNPInfoRes_routeingNumber,
        _MNPInfoRes_imsi,
        _MNPInfoRes_msisdn,
        _MNPInfoRes_numberPortabilityStatus,
        _MNPInfoRes_extensionContainer,
        MNPInfoRes,
        RouteingNumber,
        NumberPortabilityStatus,
        MS_Classmark2,
        _GPRSMSClass_mSNetworkCapability,
        _GPRSMSClass_mSRadioAccessCapability,
        GPRSMSClass,
        MSNetworkCapability,
        MSRadioAccessCapability,
        _RequestedInfo_locationInformation,
        _RequestedInfo_subscriberState,
        _RequestedInfo_extensionContainer,
        _RequestedInfo_currentLocation,
        _RequestedInfo_requestedDomain,
        _RequestedInfo_imei,
        _RequestedInfo_ms_classmark,
        _RequestedInfo_mnpRequestedInfo,
        _RequestedInfo_locationInformationEPS_Supported,
        _RequestedInfo_t_adsData,
        _RequestedInfo_requestedNodes,
        _RequestedInfo_servingNodeIndication,
        _RequestedInfo_localTimeZoneRequest,
        RequestedInfo,
        DomainType,
        RequestedNodes,
        _LocationInformation_ageOfLocationInformation,
        _LocationInformation_geographicalInformation,
        _LocationInformation_vlr_number,
        _LocationInformation_locationNumber,
        _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformation_extensionContainer,
        _LocationInformation_selectedLSA_Id,
        _LocationInformation_msc_Number,
        _LocationInformation_geodeticInformation,
        _LocationInformation_currentLocationRetrieved,
        _LocationInformation_sai_Present,
        _LocationInformation_locationInformationEPS,
        _LocationInformation_userCSGInformation,
        LocationInformation,
        _LocationInformationEPS_e_utranCellGlobalIdentity,
        _LocationInformationEPS_trackingAreaIdentity,
        _LocationInformationEPS_extensionContainer,
        _LocationInformationEPS_geographicalInformation,
        _LocationInformationEPS_geodeticInformation,
        _LocationInformationEPS_currentLocationRetrieved,
        _LocationInformationEPS_ageOfLocationInformation,
        _LocationInformationEPS_mme_Name,
        LocationInformationEPS,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_geodeticInformation,
        _LocationInformationGPRS_currentLocationRetrieved,
        _LocationInformationGPRS_ageOfLocationInformation,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _LocationInformation5GS_nrCellGlobalIdentity,
        _LocationInformation5GS_e_utranCellGlobalIdentity,
        _LocationInformation5GS_geographicalInformation,
        _LocationInformation5GS_geodeticInformation,
        _LocationInformation5GS_amf_address,
        _LocationInformation5GS_trackingAreaIdentity,
        _LocationInformation5GS_currentLocationRetrieved,
        _LocationInformation5GS_ageOfLocationInformation,
        _LocationInformation5GS_vplmnId,
        _LocationInformation5GS_localtimeZone,
        _LocationInformation5GS_rat_Type,
        _LocationInformation5GS_extensionContainer,
        _LocationInformation5GS_nrTrackingAreaIdentity,
        LocationInformation5GS,
        _UserCSGInformation_csg_Id,
        _UserCSGInformation_extensionContainer,
        _UserCSGInformation_accessMode,
        _UserCSGInformation_cmi,
        UserCSGInformation,
        GeographicalInformation,
        GeodeticInformation,
        LocationNumber,
        _SubscriberState_assumedIdle,
        _SubscriberState_camelBusy,
        _SubscriberState_netDetNotReachable,
        _SubscriberState_notProvidedFromVLR,
        SubscriberState,
        _PS_SubscriberState_notProvidedFromSGSNorMME,
        _PS_SubscriberState_ps_Detached,
        _PS_SubscriberState_ps_AttachedNotReachableForPaging,
        _PS_SubscriberState_ps_AttachedReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveReachableForPaging,
        _PS_SubscriberState_netDetNotReachable,
        PS_SubscriberState,
        _PDP_ContextInfoList__item_,
        PDP_ContextInfoList,
        _PDP_ContextInfo_pdp_ContextIdentifier,
        _PDP_ContextInfo_pdp_ContextActive,
        _PDP_ContextInfo_pdp_Type,
        _PDP_ContextInfo_pdp_Address,
        _PDP_ContextInfo_apn_Subscribed,
        _PDP_ContextInfo_apn_InUse,
        _PDP_ContextInfo_nsapi,
        _PDP_ContextInfo_transactionId,
        _PDP_ContextInfo_teid_ForGnAndGp,
        _PDP_ContextInfo_teid_ForIu,
        _PDP_ContextInfo_ggsn_Address,
        _PDP_ContextInfo_qos_Subscribed,
        _PDP_ContextInfo_qos_Requested,
        _PDP_ContextInfo_qos_Negotiated,
        _PDP_ContextInfo_chargingId,
        _PDP_ContextInfo_chargingCharacteristics,
        _PDP_ContextInfo_rnc_Address,
        _PDP_ContextInfo_extensionContainer,
        _PDP_ContextInfo_qos2_Subscribed,
        _PDP_ContextInfo_qos2_Requested,
        _PDP_ContextInfo_qos2_Negotiated,
        _PDP_ContextInfo_qos3_Subscribed,
        _PDP_ContextInfo_qos3_Requested,
        _PDP_ContextInfo_qos3_Negotiated,
        _PDP_ContextInfo_qos4_Subscribed,
        _PDP_ContextInfo_qos4_Requested,
        _PDP_ContextInfo_qos4_Negotiated,
        _PDP_ContextInfo_ext_pdp_Type,
        _PDP_ContextInfo_ext_pdp_Address,
        PDP_ContextInfo,
        NSAPI,
        TransactionId,
        TEID,
        GPRSChargingID,
        NotReachableReason,
        _AnyTimeInterrogationArg_subscriberIdentity,
        _AnyTimeInterrogationArg_requestedInfo,
        _AnyTimeInterrogationArg_gsmSCF_Address,
        _AnyTimeInterrogationArg_extensionContainer,
        AnyTimeInterrogationArg,
        _AnyTimeInterrogationRes_subscriberInfo,
        _AnyTimeInterrogationRes_extensionContainer,
        AnyTimeInterrogationRes,
        _AnyTimeSubscriptionInterrogationArg_subscriberIdentity,
        _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo,
        _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address,
        _AnyTimeSubscriptionInterrogationArg_extensionContainer,
        _AnyTimeSubscriptionInterrogationArg_longFTN_Supported,
        AnyTimeSubscriptionInterrogationArg,
        _AnyTimeSubscriptionInterrogationRes_callForwardingData,
        _AnyTimeSubscriptionInterrogationRes_callBarringData,
        _AnyTimeSubscriptionInterrogationRes_odb_Info,
        _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo,
        _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_extensionContainer,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN,
        _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List,
        _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList,
        _AnyTimeSubscriptionInterrogationRes_cw_Data,
        _AnyTimeSubscriptionInterrogationRes_ch_Data,
        _AnyTimeSubscriptionInterrogationRes_clip_Data,
        _AnyTimeSubscriptionInterrogationRes_clir_Data,
        _AnyTimeSubscriptionInterrogationRes_ect_data,
        AnyTimeSubscriptionInterrogationRes,
        _CallWaitingData_cwFeatureList,
        _CallWaitingData_notificationToCSE,
        CallWaitingData,
        _Ext_CwFeatureList__item_,
        Ext_CwFeatureList,
        _Ext_CwFeature_basicService,
        _Ext_CwFeature_ss_Status,
        Ext_CwFeature,
        _ClipData_ss_Status,
        _ClipData_overrideCategory,
        _ClipData_notificationToCSE,
        ClipData,
        _ClirData_ss_Status,
        _ClirData_cliRestrictionOption,
        _ClirData_notificationToCSE,
        ClirData,
        _CallHoldData_ss_Status,
        _CallHoldData_notificationToCSE,
        CallHoldData,
        _EctData_ss_Status,
        _EctData_notificationToCSE,
        EctData,
        _RequestedSubscriptionInfo_requestedSS_Info,
        _RequestedSubscriptionInfo_odb,
        _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases,
        _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases,
        _RequestedSubscriptionInfo_extensionContainer,
        _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_msisdn_BS_List,
        _RequestedSubscriptionInfo_csg_SubscriptionDataRequested,
        _RequestedSubscriptionInfo_cw_Info,
        _RequestedSubscriptionInfo_clip_Info,
        _RequestedSubscriptionInfo_clir_Info,
        _RequestedSubscriptionInfo_hold_Info,
        _RequestedSubscriptionInfo_ect_Info,
        RequestedSubscriptionInfo,
        _MSISDN_BS_List__item_,
        MSISDN_BS_List,
        maxNumOfMSISDN,
        _MSISDN_BS_msisdn,
        _MSISDN_BS_basicServiceList,
        _MSISDN_BS_extensionContainer,
        MSISDN_BS,
        RequestedCAMEL_SubscriptionInfo,
        AdditionalRequestedCAMEL_SubscriptionInfo,
        _CallForwardingData_forwardingFeatureList,
        _CallForwardingData_notificationToCSE,
        _CallForwardingData_extensionContainer,
        CallForwardingData,
        _CallBarringData_callBarringFeatureList,
        _CallBarringData_password,
        _CallBarringData_wrongPasswordAttemptsCounter,
        _CallBarringData_notificationToCSE,
        _CallBarringData_extensionContainer,
        CallBarringData,
        WrongPasswordAttemptsCounter,
        _ODB_Info_odb_Data,
        _ODB_Info_notificationToCSE,
        _ODB_Info_extensionContainer,
        ODB_Info,
        _CAMEL_SubscriptionInfo_o_CSI,
        _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_CSI,
        _CAMEL_SubscriptionInfo_t_CSI,
        _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_vt_CSI,
        _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_tif_CSI,
        _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE,
        _CAMEL_SubscriptionInfo_gprs_CSI,
        _CAMEL_SubscriptionInfo_mo_sms_CSI,
        _CAMEL_SubscriptionInfo_ss_CSI,
        _CAMEL_SubscriptionInfo_m_CSI,
        _CAMEL_SubscriptionInfo_extensionContainer,
        _CAMEL_SubscriptionInfo_specificCSIDeletedList,
        _CAMEL_SubscriptionInfo_mt_sms_CSI,
        _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_mg_csi,
        _CAMEL_SubscriptionInfo_o_IM_CSI,
        _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList,
        CAMEL_SubscriptionInfo,
        _AnyTimeModificationArg_subscriberIdentity,
        _AnyTimeModificationArg_gsmSCF_Address,
        _AnyTimeModificationArg_modificationRequestFor_CF_Info,
        _AnyTimeModificationArg_modificationRequestFor_CB_Info,
        _AnyTimeModificationArg_modificationRequestFor_CSI,
        _AnyTimeModificationArg_extensionContainer,
        _AnyTimeModificationArg_longFTN_Supported,
        _AnyTimeModificationArg_modificationRequestFor_ODB_data,
        _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data,
        _AnyTimeModificationArg_activationRequestForUE_reachability,
        _AnyTimeModificationArg_modificationRequestFor_CSG,
        _AnyTimeModificationArg_modificationRequestFor_CW_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIP_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIR_Data,
        _AnyTimeModificationArg_modificationRequestFor_HOLD_Data,
        _AnyTimeModificationArg_modificationRequestFor_ECT_Data,
        AnyTimeModificationArg,
        _ModificationRequestFor_CW_Info_basicService,
        _ModificationRequestFor_CW_Info_ss_Status,
        _ModificationRequestFor_CW_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CW_Info_extensionContainer,
        ModificationRequestFor_CW_Info,
        _ModificationRequestFor_CH_Info_ss_Status,
        _ModificationRequestFor_CH_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CH_Info_extensionContainer,
        ModificationRequestFor_CH_Info,
        _ModificationRequestFor_ECT_Info_ss_Status,
        _ModificationRequestFor_ECT_Info_modifyNotificationToCSE,
        _ModificationRequestFor_ECT_Info_extensionContainer,
        ModificationRequestFor_ECT_Info,
        _ModificationRequestFor_CLIR_Info_ss_Status,
        _ModificationRequestFor_CLIR_Info_cliRestrictionOption,
        _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIR_Info_extensionContainer,
        ModificationRequestFor_CLIR_Info,
        _ModificationRequestFor_CLIP_Info_ss_Status,
        _ModificationRequestFor_CLIP_Info_overrideCategory,
        _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIP_Info_extensionContainer,
        ModificationRequestFor_CLIP_Info,
        _ModificationRequestFor_CSG_modifyNotificationToCSE,
        _ModificationRequestFor_CSG_extensionContainer,
        ModificationRequestFor_CSG,
        RequestedServingNode,
        ServingNode,
        _AnyTimeModificationRes_ss_InfoFor_CSE,
        _AnyTimeModificationRes_camel_SubscriptionInfo,
        _AnyTimeModificationRes_extensionContainer,
        _AnyTimeModificationRes_odb_Info,
        _AnyTimeModificationRes_cw_Data,
        _AnyTimeModificationRes_ch_Data,
        _AnyTimeModificationRes_clip_Data,
        _AnyTimeModificationRes_clir_Data,
        _AnyTimeModificationRes_ect_data,
        _AnyTimeModificationRes_serviceCentreAddress,
        AnyTimeModificationRes,
        _ModificationRequestFor_CF_Info_ss_Code,
        _ModificationRequestFor_CF_Info_basicService,
        _ModificationRequestFor_CF_Info_ss_Status,
        _ModificationRequestFor_CF_Info_forwardedToNumber,
        _ModificationRequestFor_CF_Info_forwardedToSubaddress,
        _ModificationRequestFor_CF_Info_noReplyConditionTime,
        _ModificationRequestFor_CF_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CF_Info_extensionContainer,
        ModificationRequestFor_CF_Info,
        _ModificationRequestFor_CB_Info_ss_Code,
        _ModificationRequestFor_CB_Info_basicService,
        _ModificationRequestFor_CB_Info_ss_Status,
        _ModificationRequestFor_CB_Info_password,
        _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter,
        _ModificationRequestFor_CB_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CB_Info_extensionContainer,
        ModificationRequestFor_CB_Info,
        _ModificationRequestFor_ODB_data_odb_data,
        _ModificationRequestFor_ODB_data_modifyNotificationToCSE,
        _ModificationRequestFor_ODB_data_extensionContainer,
        ModificationRequestFor_ODB_data,
        _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo,
        _ModificationRequestFor_CSI_modifyNotificationToCSE,
        _ModificationRequestFor_CSI_modifyCSI_State,
        _ModificationRequestFor_CSI_extensionContainer,
        _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo,
        ModificationRequestFor_CSI,
        _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus,
        _ModificationRequestFor_IP_SM_GW_Data_extensionContainer,
        _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress,
        ModificationRequestFor_IP_SM_GW_Data,
        ModificationInstruction,
        _NoteSubscriberDataModifiedArg_imsi,
        _NoteSubscriberDataModifiedArg_msisdn,
        _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_odb_Info,
        _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo,
        _NoteSubscriberDataModifiedArg_allInformationSent,
        _NoteSubscriberDataModifiedArg_extensionContainer,
        _NoteSubscriberDataModifiedArg_ue_reachable,
        _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList,
        _NoteSubscriberDataModifiedArg_cw_Data,
        _NoteSubscriberDataModifiedArg_ch_Data,
        _NoteSubscriberDataModifiedArg_clip_Data,
        _NoteSubscriberDataModifiedArg_clir_Data,
        _NoteSubscriberDataModifiedArg_ect_data,
        NoteSubscriberDataModifiedArg,
        _NoteSubscriberDataModifiedRes_extensionContainer,
        NoteSubscriberDataModifiedRes,
        _NoteMM_EventArg_serviceKey,
        _NoteMM_EventArg_eventMet,
        _NoteMM_EventArg_imsi,
        _NoteMM_EventArg_msisdn,
        _NoteMM_EventArg_locationInformation,
        _NoteMM_EventArg_supportedCAMELPhases,
        _NoteMM_EventArg_extensionContainer,
        _NoteMM_EventArg_locationInformationGPRS,
        _NoteMM_EventArg_offeredCamel4Functionalities,
        NoteMM_EventArg,
        _NoteMM_EventRes_extensionContainer,
        NoteMM_EventRes,
        _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE,
        _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE,
        Ext_SS_InfoFor_CSE,
        _Ext_ForwardingInfoFor_CSE_ss_Code,
        _Ext_ForwardingInfoFor_CSE_forwardingFeatureList,
        _Ext_ForwardingInfoFor_CSE_notificationToCSE,
        _Ext_ForwardingInfoFor_CSE_extensionContainer,
        Ext_ForwardingInfoFor_CSE,
        _Ext_CallBarringInfoFor_CSE_ss_Code,
        _Ext_CallBarringInfoFor_CSE_callBarringFeatureList,
        _Ext_CallBarringInfoFor_CSE_password,
        _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter,
        _Ext_CallBarringInfoFor_CSE_notificationToCSE,
        _Ext_CallBarringInfoFor_CSE_extensionContainer,
        Ext_CallBarringInfoFor_CSE,
        _UpdateVcsgLocationArg_imsi,
        _UpdateVcsgLocationArg_msisdn,
        _UpdateVcsgLocationArg_vlr_Number,
        _UpdateVcsgLocationArg_sgsn_Number,
        _UpdateVcsgLocationArg_extensionContainer,
        UpdateVcsgLocationArg,
        _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator,
        _UpdateVcsgLocationRes_extensionContainer,
        UpdateVcsgLocationRes,
        _CancelVcsgLocationArg_identity,
        _CancelVcsgLocationArg_extensionContainer,
        CancelVcsgLocationArg,
        _CancelVcsgLocationRes_extensionContainer,
        CancelVcsgLocationRes,
    ]

class MAP_OM_DataTypes:

    _name_  = 'MAP-OM-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 12, 19]
    
    _obj_ = [
        'ActivateTraceModeArg',
        'MDT-Configuration',
        'MDT-Allowed-PLMNId-List',
        'PeriodUMTS',
        'PeriodLTE',
        'PositioningMethod',
        'MeasurementQuantity',
        'EventThreshold1F',
        'EventThreshold1I',
        'JobType',
        'AreaScope',
        'CGI-List',
        'E-UTRAN-CGI-List',
        'RoutingAreaId-List',
        'LocationAreaId-List',
        'TrackingAreaId-List',
        'ListOfMeasurements',
        'ReportingTrigger',
        'ReportInterval',
        'ReportAmount',
        'EventThresholdRSRP',
        'EventThresholdRSRQ',
        'LoggingInterval',
        'LoggingDuration',
        'TraceReference',
        'TraceReference2',
        'TraceRecordingSessionReference',
        'TraceType',
        'TraceDepthList',
        'TraceDepth',
        'TraceDepthExtension',
        'TraceNE-TypeList',
        'TraceInterfaceList',
        'MSC-S-InterfaceList',
        'MGW-InterfaceList',
        'SGSN-InterfaceList',
        'GGSN-InterfaceList',
        'RNC-InterfaceList',
        'BMSC-InterfaceList',
        'MME-InterfaceList',
        'SGW-InterfaceList',
        'PGW-InterfaceList',
        'ENB-InterfaceList',
        'TraceEventList',
        'MSC-S-EventList',
        'MGW-EventList',
        'SGSN-EventList',
        'GGSN-EventList',
        'BMSC-EventList',
        'MME-EventList',
        'SGW-EventList',
        'PGW-EventList',
        'TracePropagationList',
        'ActivateTraceModeRes',
        'DeactivateTraceModeArg',
        'DeactivateTraceModeRes',
        ]
    _type_ = [
        'ActivateTraceModeArg',
        'MDT-Configuration',
        'MDT-Allowed-PLMNId-List',
        'PeriodUMTS',
        'PeriodLTE',
        'PositioningMethod',
        'MeasurementQuantity',
        'EventThreshold1F',
        'EventThreshold1I',
        'JobType',
        'AreaScope',
        'CGI-List',
        'E-UTRAN-CGI-List',
        'RoutingAreaId-List',
        'LocationAreaId-List',
        'TrackingAreaId-List',
        'ListOfMeasurements',
        'ReportingTrigger',
        'ReportInterval',
        'ReportAmount',
        'EventThresholdRSRP',
        'EventThresholdRSRQ',
        'LoggingInterval',
        'LoggingDuration',
        'TraceReference',
        'TraceReference2',
        'TraceRecordingSessionReference',
        'TraceType',
        'TraceDepthList',
        'TraceDepth',
        'TraceDepthExtension',
        'TraceNE-TypeList',
        'TraceInterfaceList',
        'MSC-S-InterfaceList',
        'MGW-InterfaceList',
        'SGSN-InterfaceList',
        'GGSN-InterfaceList',
        'RNC-InterfaceList',
        'BMSC-InterfaceList',
        'MME-InterfaceList',
        'SGW-InterfaceList',
        'PGW-InterfaceList',
        'ENB-InterfaceList',
        'TraceEventList',
        'MSC-S-EventList',
        'MGW-EventList',
        'SGSN-EventList',
        'GGSN-EventList',
        'BMSC-EventList',
        'MME-EventList',
        'SGW-EventList',
        'PGW-EventList',
        'TracePropagationList',
        'ActivateTraceModeRes',
        'DeactivateTraceModeArg',
        'DeactivateTraceModeRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ActivateTraceModeArg >-----#
    ActivateTraceModeArg = SEQ(name='ActivateTraceModeArg', mode=MODE_TYPE)
    _ActivateTraceModeArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ActivateTraceModeArg_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _ActivateTraceModeArg_traceType = INT(name='traceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')))
    _ActivateTraceModeArg_omc_Id = OCT_STR(name='omc-Id', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ActivateTraceModeArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeArg_traceReference2 = OCT_STR(name='traceReference2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _ActivateTraceModeArg_traceDepthList = SEQ(name='traceDepthList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthList')), opt=True)
    _ActivateTraceModeArg_traceNE_TypeList = BIT_STR(name='traceNE-TypeList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceNE-TypeList')), opt=True)
    _ActivateTraceModeArg_traceInterfaceList = SEQ(name='traceInterfaceList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceInterfaceList')), opt=True)
    _ActivateTraceModeArg_traceEventList = SEQ(name='traceEventList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceEventList')), opt=True)
    _ActivateTraceModeArg_traceCollectionEntity = OCT_STR(name='traceCollectionEntity', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _ActivateTraceModeArg_mdt_Configuration = SEQ(name='mdt-Configuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Configuration')), opt=True)
    ActivateTraceModeArg._cont = ASN1Dict([
        ('imsi', _ActivateTraceModeArg_imsi),
        ('traceReference', _ActivateTraceModeArg_traceReference),
        ('traceType', _ActivateTraceModeArg_traceType),
        ('omc-Id', _ActivateTraceModeArg_omc_Id),
        ('extensionContainer', _ActivateTraceModeArg_extensionContainer),
        ('traceReference2', _ActivateTraceModeArg_traceReference2),
        ('traceDepthList', _ActivateTraceModeArg_traceDepthList),
        ('traceNE-TypeList', _ActivateTraceModeArg_traceNE_TypeList),
        ('traceInterfaceList', _ActivateTraceModeArg_traceInterfaceList),
        ('traceEventList', _ActivateTraceModeArg_traceEventList),
        ('traceCollectionEntity', _ActivateTraceModeArg_traceCollectionEntity),
        ('mdt-Configuration', _ActivateTraceModeArg_mdt_Configuration),
        ])
    ActivateTraceModeArg._ext = ['traceReference2', 'traceDepthList', 'traceNE-TypeList', 'traceInterfaceList', 'traceEventList', 'traceCollectionEntity', 'mdt-Configuration']
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name='MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_jobType = ENUM(name='jobType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'JobType')))
    _MDT_Configuration_areaScope = SEQ(name='areaScope', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'AreaScope')), opt=True)
    _MDT_Configuration_listOfMeasurements = OCT_STR(name='listOfMeasurements', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ListOfMeasurements')), opt=True)
    _MDT_Configuration_reportingTrigger = OCT_STR(name='reportingTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportingTrigger')), opt=True)
    _MDT_Configuration_reportInterval = ENUM(name='reportInterval', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportInterval')), opt=True)
    _MDT_Configuration_reportAmount = ENUM(name='reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportAmount')), opt=True)
    _MDT_Configuration_eventThresholdRSRP = INT(name='eventThresholdRSRP', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRP')), opt=True)
    _MDT_Configuration_eventThresholdRSRQ = INT(name='eventThresholdRSRQ', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRQ')), opt=True)
    _MDT_Configuration_loggingInterval = ENUM(name='loggingInterval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingInterval')), opt=True)
    _MDT_Configuration_loggingDuration = ENUM(name='loggingDuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingDuration')), opt=True)
    _MDT_Configuration_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MDT_Configuration_measurementPeriodUMTS = ENUM(name='measurementPeriodUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_measurementPeriodLTE = ENUM(name='measurementPeriodLTE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_UMTS = ENUM(name='collectionPeriodRRM-UMTS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_LTE = ENUM(name='collectionPeriodRRM-LTE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_positioningMethod = OCT_STR(name='positioningMethod', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PositioningMethod')), opt=True)
    _MDT_Configuration_measurementQuantity = OCT_STR(name='measurementQuantity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MeasurementQuantity')), opt=True)
    _MDT_Configuration_eventThreshold1F = INT(name='eventThreshold1F', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1F')), opt=True)
    _MDT_Configuration_eventThreshold1I = INT(name='eventThreshold1I', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1I')), opt=True)
    _MDT_Configuration_mdt_Allowed_PLMN_List = SEQ_OF(name='mdt-Allowed-PLMN-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Allowed-PLMNId-List')), opt=True)
    MDT_Configuration._cont = ASN1Dict([
        ('jobType', _MDT_Configuration_jobType),
        ('areaScope', _MDT_Configuration_areaScope),
        ('listOfMeasurements', _MDT_Configuration_listOfMeasurements),
        ('reportingTrigger', _MDT_Configuration_reportingTrigger),
        ('reportInterval', _MDT_Configuration_reportInterval),
        ('reportAmount', _MDT_Configuration_reportAmount),
        ('eventThresholdRSRP', _MDT_Configuration_eventThresholdRSRP),
        ('eventThresholdRSRQ', _MDT_Configuration_eventThresholdRSRQ),
        ('loggingInterval', _MDT_Configuration_loggingInterval),
        ('loggingDuration', _MDT_Configuration_loggingDuration),
        ('extensionContainer', _MDT_Configuration_extensionContainer),
        ('measurementPeriodUMTS', _MDT_Configuration_measurementPeriodUMTS),
        ('measurementPeriodLTE', _MDT_Configuration_measurementPeriodLTE),
        ('collectionPeriodRRM-UMTS', _MDT_Configuration_collectionPeriodRRM_UMTS),
        ('collectionPeriodRRM-LTE', _MDT_Configuration_collectionPeriodRRM_LTE),
        ('positioningMethod', _MDT_Configuration_positioningMethod),
        ('measurementQuantity', _MDT_Configuration_measurementQuantity),
        ('eventThreshold1F', _MDT_Configuration_eventThreshold1F),
        ('eventThreshold1I', _MDT_Configuration_eventThreshold1I),
        ('mdt-Allowed-PLMN-List', _MDT_Configuration_mdt_Allowed_PLMN_List),
        ])
    MDT_Configuration._ext = ['measurementPeriodUMTS', 'measurementPeriodLTE', 'collectionPeriodRRM-UMTS', 'collectionPeriodRRM-LTE', 'positioningMethod', 'measurementQuantity', 'eventThreshold1F', 'eventThreshold1I', 'mdt-Allowed-PLMN-List']
    
    #-----< MDT-Allowed-PLMNId-List >-----#
    MDT_Allowed_PLMNId_List = SEQ_OF(name='MDT-Allowed-PLMNId-List', mode=MODE_TYPE)
    _MDT_Allowed_PLMNId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    MDT_Allowed_PLMNId_List._cont = _MDT_Allowed_PLMNId_List__item_
    MDT_Allowed_PLMNId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodUMTS >-----#
    PeriodUMTS = ENUM(name='PeriodUMTS', mode=MODE_TYPE)
    PeriodUMTS._cont = ASN1Dict([('d250ms', 0), ('d500ms', 1), ('d1000ms', 2), ('d2000ms', 3), ('d3000ms', 4), ('d4000ms', 5), ('d6000ms', 6), ('d8000ms', 7), ('d12000ms', 8), ('d16000ms', 9), ('d20000ms', 10), ('d24000ms', 11), ('d28000ms', 12), ('d32000ms', 13), ('d64000ms', 14)])
    PeriodUMTS._ext = None
    
    #-----< PeriodLTE >-----#
    PeriodLTE = ENUM(name='PeriodLTE', mode=MODE_TYPE)
    PeriodLTE._cont = ASN1Dict([('d1024ms', 0), ('d1280ms', 1), ('d2048ms', 2), ('d2560ms', 3), ('d5120ms', 4), ('d10240ms', 5), ('d1min', 6)])
    PeriodLTE._ext = None
    
    #-----< PositioningMethod >-----#
    PositioningMethod = OCT_STR(name='PositioningMethod', mode=MODE_TYPE)
    PositioningMethod._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MeasurementQuantity >-----#
    MeasurementQuantity = OCT_STR(name='MeasurementQuantity', mode=MODE_TYPE)
    MeasurementQuantity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EventThreshold1F >-----#
    EventThreshold1F = INT(name='EventThreshold1F', mode=MODE_TYPE)
    EventThreshold1F._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=165)], ev=None, er=[])
    
    #-----< EventThreshold1I >-----#
    EventThreshold1I = INT(name='EventThreshold1I', mode=MODE_TYPE)
    EventThreshold1I._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-25)], ev=None, er=[])
    
    #-----< JobType >-----#
    JobType = ENUM(name='JobType', mode=MODE_TYPE)
    JobType._cont = ASN1Dict([('immediate-MDT-only', 0), ('logged-MDT-only', 1), ('trace-only', 2), ('immediate-MDT-and-trace', 3)])
    JobType._ext = None
    
    #-----< AreaScope >-----#
    AreaScope = SEQ(name='AreaScope', mode=MODE_TYPE)
    _AreaScope_cgi_List = SEQ_OF(name='cgi-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'CGI-List')), opt=True)
    _AreaScope_e_utran_cgi_List = SEQ_OF(name='e-utran-cgi-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'E-UTRAN-CGI-List')), opt=True)
    _AreaScope_routingAreaId_List = SEQ_OF(name='routingAreaId-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RoutingAreaId-List')), opt=True)
    _AreaScope_locationAreaId_List = SEQ_OF(name='locationAreaId-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LocationAreaId-List')), opt=True)
    _AreaScope_trackingAreaId_List = SEQ_OF(name='trackingAreaId-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TrackingAreaId-List')), opt=True)
    _AreaScope_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AreaScope._cont = ASN1Dict([
        ('cgi-List', _AreaScope_cgi_List),
        ('e-utran-cgi-List', _AreaScope_e_utran_cgi_List),
        ('routingAreaId-List', _AreaScope_routingAreaId_List),
        ('locationAreaId-List', _AreaScope_locationAreaId_List),
        ('trackingAreaId-List', _AreaScope_trackingAreaId_List),
        ('extensionContainer', _AreaScope_extensionContainer),
        ])
    AreaScope._ext = []
    
    #-----< CGI-List >-----#
    CGI_List = SEQ_OF(name='CGI-List', mode=MODE_TYPE)
    _CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')))
    CGI_List._cont = _CGI_List__item_
    CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-UTRAN-CGI-List >-----#
    E_UTRAN_CGI_List = SEQ_OF(name='E-UTRAN-CGI-List', mode=MODE_TYPE)
    _E_UTRAN_CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')))
    E_UTRAN_CGI_List._cont = _E_UTRAN_CGI_List__item_
    E_UTRAN_CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< RoutingAreaId-List >-----#
    RoutingAreaId_List = SEQ_OF(name='RoutingAreaId-List', mode=MODE_TYPE)
    _RoutingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')))
    RoutingAreaId_List._cont = _RoutingAreaId_List__item_
    RoutingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationAreaId-List >-----#
    LocationAreaId_List = SEQ_OF(name='LocationAreaId-List', mode=MODE_TYPE)
    _LocationAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    LocationAreaId_List._cont = _LocationAreaId_List__item_
    LocationAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TrackingAreaId-List >-----#
    TrackingAreaId_List = SEQ_OF(name='TrackingAreaId-List', mode=MODE_TYPE)
    _TrackingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')))
    TrackingAreaId_List._cont = _TrackingAreaId_List__item_
    TrackingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ListOfMeasurements >-----#
    ListOfMeasurements = OCT_STR(name='ListOfMeasurements', mode=MODE_TYPE)
    ListOfMeasurements._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ReportingTrigger >-----#
    ReportingTrigger = OCT_STR(name='ReportingTrigger', mode=MODE_TYPE)
    ReportingTrigger._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ReportInterval >-----#
    ReportInterval = ENUM(name='ReportInterval', mode=MODE_TYPE)
    ReportInterval._cont = ASN1Dict([('umts250ms', 0), ('umts500ms', 1), ('umts1000ms', 2), ('umts2000ms', 3), ('umts3000ms', 4), ('umts4000ms', 5), ('umts6000ms', 6), ('umts8000ms', 7), ('umts12000ms', 8), ('umts16000ms', 9), ('umts20000ms', 10), ('umts24000ms', 11), ('umts28000ms', 12), ('umts32000ms', 13), ('umts64000ms', 14), ('lte120ms', 15), ('lte240ms', 16), ('lte480ms', 17), ('lte640ms', 18), ('lte1024ms', 19), ('lte2048ms', 20), ('lte5120ms', 21), ('lte10240ms', 22), ('lte1min', 23), ('lte6min', 24), ('lte12min', 25), ('lte30min', 26), ('lte60min', 27)])
    ReportInterval._ext = None
    
    #-----< ReportAmount >-----#
    ReportAmount = ENUM(name='ReportAmount', mode=MODE_TYPE)
    ReportAmount._cont = ASN1Dict([('d1', 0), ('d2', 1), ('d4', 2), ('d8', 3), ('d16', 4), ('d32', 5), ('d64', 6), ('infinity', 7)])
    ReportAmount._ext = None
    
    #-----< EventThresholdRSRP >-----#
    EventThresholdRSRP = INT(name='EventThresholdRSRP', mode=MODE_TYPE)
    EventThresholdRSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< EventThresholdRSRQ >-----#
    EventThresholdRSRQ = INT(name='EventThresholdRSRQ', mode=MODE_TYPE)
    EventThresholdRSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name='LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([('d1dot28', 0), ('d2dot56', 1), ('d5dot12', 2), ('d10dot24', 3), ('d20dot48', 4), ('d30dot72', 5), ('d40dot96', 6), ('d61dot44', 7)])
    LoggingInterval._ext = None
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name='LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([('d600sec', 0), ('d1200sec', 1), ('d2400sec', 2), ('d3600sec', 3), ('d5400sec', 4), ('d7200sec', 5)])
    LoggingDuration._ext = None
    
    #-----< TraceReference >-----#
    TraceReference = OCT_STR(name='TraceReference', mode=MODE_TYPE)
    TraceReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TraceReference2 >-----#
    TraceReference2 = OCT_STR(name='TraceReference2', mode=MODE_TYPE)
    TraceReference2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TraceRecordingSessionReference >-----#
    TraceRecordingSessionReference = OCT_STR(name='TraceRecordingSessionReference', mode=MODE_TYPE)
    TraceRecordingSessionReference._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TraceType >-----#
    TraceType = INT(name='TraceType', mode=MODE_TYPE)
    TraceType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TraceDepthList >-----#
    TraceDepthList = SEQ(name='TraceDepthList', mode=MODE_TYPE)
    _TraceDepthList_msc_s_TraceDepth = ENUM(name='msc-s-TraceDepth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mgw_TraceDepth = ENUM(name='mgw-TraceDepth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgsn_TraceDepth = ENUM(name='sgsn-TraceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_ggsn_TraceDepth = ENUM(name='ggsn-TraceDepth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_rnc_TraceDepth = ENUM(name='rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_bmsc_TraceDepth = ENUM(name='bmsc-TraceDepth', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mme_TraceDepth = ENUM(name='mme-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgw_TraceDepth = ENUM(name='sgw-TraceDepth', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_pgw_TraceDepth = ENUM(name='pgw-TraceDepth', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_eNB_TraceDepth = ENUM(name='eNB-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_msc_s_TraceDepthExtension = ENUM(name='msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mgw_TraceDepthExtension = ENUM(name='mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgsn_TraceDepthExtension = ENUM(name='sgsn-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_ggsn_TraceDepthExtension = ENUM(name='ggsn-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_rnc_TraceDepthExtension = ENUM(name='rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_bmsc_TraceDepthExtension = ENUM(name='bmsc-TraceDepthExtension', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mme_TraceDepthExtension = ENUM(name='mme-TraceDepthExtension', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgw_TraceDepthExtension = ENUM(name='sgw-TraceDepthExtension', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_pgw_TraceDepthExtension = ENUM(name='pgw-TraceDepthExtension', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_eNB_TraceDepthExtension = ENUM(name='eNB-TraceDepthExtension', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TraceDepthList._cont = ASN1Dict([
        ('msc-s-TraceDepth', _TraceDepthList_msc_s_TraceDepth),
        ('mgw-TraceDepth', _TraceDepthList_mgw_TraceDepth),
        ('sgsn-TraceDepth', _TraceDepthList_sgsn_TraceDepth),
        ('ggsn-TraceDepth', _TraceDepthList_ggsn_TraceDepth),
        ('rnc-TraceDepth', _TraceDepthList_rnc_TraceDepth),
        ('bmsc-TraceDepth', _TraceDepthList_bmsc_TraceDepth),
        ('mme-TraceDepth', _TraceDepthList_mme_TraceDepth),
        ('sgw-TraceDepth', _TraceDepthList_sgw_TraceDepth),
        ('pgw-TraceDepth', _TraceDepthList_pgw_TraceDepth),
        ('eNB-TraceDepth', _TraceDepthList_eNB_TraceDepth),
        ('msc-s-TraceDepthExtension', _TraceDepthList_msc_s_TraceDepthExtension),
        ('mgw-TraceDepthExtension', _TraceDepthList_mgw_TraceDepthExtension),
        ('sgsn-TraceDepthExtension', _TraceDepthList_sgsn_TraceDepthExtension),
        ('ggsn-TraceDepthExtension', _TraceDepthList_ggsn_TraceDepthExtension),
        ('rnc-TraceDepthExtension', _TraceDepthList_rnc_TraceDepthExtension),
        ('bmsc-TraceDepthExtension', _TraceDepthList_bmsc_TraceDepthExtension),
        ('mme-TraceDepthExtension', _TraceDepthList_mme_TraceDepthExtension),
        ('sgw-TraceDepthExtension', _TraceDepthList_sgw_TraceDepthExtension),
        ('pgw-TraceDepthExtension', _TraceDepthList_pgw_TraceDepthExtension),
        ('eNB-TraceDepthExtension', _TraceDepthList_eNB_TraceDepthExtension),
        ])
    TraceDepthList._ext = ['mme-TraceDepth', 'sgw-TraceDepth', 'pgw-TraceDepth', 'eNB-TraceDepth', 'msc-s-TraceDepthExtension', 'mgw-TraceDepthExtension', 'sgsn-TraceDepthExtension', 'ggsn-TraceDepthExtension', 'rnc-TraceDepthExtension', 'bmsc-TraceDepthExtension', 'mme-TraceDepthExtension', 'sgw-TraceDepthExtension', 'pgw-TraceDepthExtension', 'eNB-TraceDepthExtension']
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2)])
    TraceDepth._ext = []
    
    #-----< TraceDepthExtension >-----#
    TraceDepthExtension = ENUM(name='TraceDepthExtension', mode=MODE_TYPE)
    TraceDepthExtension._cont = ASN1Dict([('minimumWithoutVendorSpecificExtension', 0), ('mediumWithoutVendorSpecificExtension', 1), ('maximumWithoutVendorSpecificExtension', 2)])
    TraceDepthExtension._ext = []
    
    #-----< TraceNE-TypeList >-----#
    TraceNE_TypeList = BIT_STR(name='TraceNE-TypeList', mode=MODE_TYPE)
    TraceNE_TypeList._cont = ASN1Dict([('msc-s', 0), ('mgw', 1), ('sgsn', 2), ('ggsn', 3), ('rnc', 4), ('bm-sc', 5), ('mme', 6), ('sgw', 7), ('pgw', 8), ('eNB', 9)])
    TraceNE_TypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=16)], ev=None, er=[])
    
    #-----< TraceInterfaceList >-----#
    TraceInterfaceList = SEQ(name='TraceInterfaceList', mode=MODE_TYPE)
    _TraceInterfaceList_msc_s_List = BIT_STR(name='msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TraceInterfaceList_mgw_List = BIT_STR(name='mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TraceInterfaceList_sgsn_List = BIT_STR(name='sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_ggsn_List = BIT_STR(name='ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_rnc_List = BIT_STR(name='rnc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TraceInterfaceList_bmsc_List = BIT_STR(name='bmsc-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-InterfaceList')), opt=True)
    _TraceInterfaceList_mme_List = BIT_STR(name='mme-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-InterfaceList')), opt=True)
    _TraceInterfaceList_sgw_List = BIT_STR(name='sgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-InterfaceList')), opt=True)
    _TraceInterfaceList_pgw_List = BIT_STR(name='pgw-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-InterfaceList')), opt=True)
    _TraceInterfaceList_eNB_List = BIT_STR(name='eNB-List', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ENB-InterfaceList')), opt=True)
    TraceInterfaceList._cont = ASN1Dict([
        ('msc-s-List', _TraceInterfaceList_msc_s_List),
        ('mgw-List', _TraceInterfaceList_mgw_List),
        ('sgsn-List', _TraceInterfaceList_sgsn_List),
        ('ggsn-List', _TraceInterfaceList_ggsn_List),
        ('rnc-List', _TraceInterfaceList_rnc_List),
        ('bmsc-List', _TraceInterfaceList_bmsc_List),
        ('mme-List', _TraceInterfaceList_mme_List),
        ('sgw-List', _TraceInterfaceList_sgw_List),
        ('pgw-List', _TraceInterfaceList_pgw_List),
        ('eNB-List', _TraceInterfaceList_eNB_List),
        ])
    TraceInterfaceList._ext = ['mme-List', 'sgw-List', 'pgw-List', 'eNB-List']
    
    #-----< MSC-S-InterfaceList >-----#
    MSC_S_InterfaceList = BIT_STR(name='MSC-S-InterfaceList', mode=MODE_TYPE)
    MSC_S_InterfaceList._cont = ASN1Dict([('a', 0), ('iu', 1), ('mc', 2), ('map-g', 3), ('map-b', 4), ('map-e', 5), ('map-f', 6), ('cap', 7), ('map-d', 8), ('map-c', 9)])
    MSC_S_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=16)], ev=None, er=[])
    
    #-----< MGW-InterfaceList >-----#
    MGW_InterfaceList = BIT_STR(name='MGW-InterfaceList', mode=MODE_TYPE)
    MGW_InterfaceList._cont = ASN1Dict([('mc', 0), ('nb-up', 1), ('iu-up', 2)])
    MGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-InterfaceList >-----#
    SGSN_InterfaceList = BIT_STR(name='SGSN-InterfaceList', mode=MODE_TYPE)
    SGSN_InterfaceList._cont = ASN1Dict([('gb', 0), ('iu', 1), ('gn', 2), ('map-gr', 3), ('map-gd', 4), ('map-gf', 5), ('gs', 6), ('ge', 7), ('s3', 8), ('s4', 9), ('s6d', 10)])
    SGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< GGSN-InterfaceList >-----#
    GGSN_InterfaceList = BIT_STR(name='GGSN-InterfaceList', mode=MODE_TYPE)
    GGSN_InterfaceList._cont = ASN1Dict([('gn', 0), ('gi', 1), ('gmb', 2)])
    GGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< RNC-InterfaceList >-----#
    RNC_InterfaceList = BIT_STR(name='RNC-InterfaceList', mode=MODE_TYPE)
    RNC_InterfaceList._cont = ASN1Dict([('iu', 0), ('iur', 1), ('iub', 2), ('uu', 3)])
    RNC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BMSC-InterfaceList >-----#
    BMSC_InterfaceList = BIT_STR(name='BMSC-InterfaceList', mode=MODE_TYPE)
    BMSC_InterfaceList._cont = ASN1Dict([('gmb', 0)])
    BMSC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-InterfaceList >-----#
    MME_InterfaceList = BIT_STR(name='MME-InterfaceList', mode=MODE_TYPE)
    MME_InterfaceList._cont = ASN1Dict([('s1-mme', 0), ('s3', 1), ('s6a', 2), ('s10', 3), ('s11', 4)])
    MME_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< SGW-InterfaceList >-----#
    SGW_InterfaceList = BIT_STR(name='SGW-InterfaceList', mode=MODE_TYPE)
    SGW_InterfaceList._cont = ASN1Dict([('s4', 0), ('s5', 1), ('s8b', 2), ('s11', 3), ('gxc', 4)])
    SGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< PGW-InterfaceList >-----#
    PGW_InterfaceList = BIT_STR(name='PGW-InterfaceList', mode=MODE_TYPE)
    PGW_InterfaceList._cont = ASN1Dict([('s2a', 0), ('s2b', 1), ('s2c', 2), ('s5', 3), ('s6b', 4), ('gx', 5), ('s8b', 6), ('sgi', 7)])
    PGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< ENB-InterfaceList >-----#
    ENB_InterfaceList = BIT_STR(name='ENB-InterfaceList', mode=MODE_TYPE)
    ENB_InterfaceList._cont = ASN1Dict([('s1-mme', 0), ('x2', 1), ('uu', 2)])
    ENB_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TraceEventList >-----#
    TraceEventList = SEQ(name='TraceEventList', mode=MODE_TYPE)
    _TraceEventList_msc_s_List = BIT_STR(name='msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TraceEventList_mgw_List = BIT_STR(name='mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TraceEventList_sgsn_List = BIT_STR(name='sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-EventList')), opt=True)
    _TraceEventList_ggsn_List = BIT_STR(name='ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-EventList')), opt=True)
    _TraceEventList_bmsc_List = BIT_STR(name='bmsc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-EventList')), opt=True)
    _TraceEventList_mme_List = BIT_STR(name='mme-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-EventList')), opt=True)
    _TraceEventList_sgw_List = BIT_STR(name='sgw-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-EventList')), opt=True)
    _TraceEventList_pgw_List = BIT_STR(name='pgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-EventList')), opt=True)
    TraceEventList._cont = ASN1Dict([
        ('msc-s-List', _TraceEventList_msc_s_List),
        ('mgw-List', _TraceEventList_mgw_List),
        ('sgsn-List', _TraceEventList_sgsn_List),
        ('ggsn-List', _TraceEventList_ggsn_List),
        ('bmsc-List', _TraceEventList_bmsc_List),
        ('mme-List', _TraceEventList_mme_List),
        ('sgw-List', _TraceEventList_sgw_List),
        ('pgw-List', _TraceEventList_pgw_List),
        ])
    TraceEventList._ext = ['mme-List', 'sgw-List', 'pgw-List']
    
    #-----< MSC-S-EventList >-----#
    MSC_S_EventList = BIT_STR(name='MSC-S-EventList', mode=MODE_TYPE)
    MSC_S_EventList._cont = ASN1Dict([('mo-mtCall', 0), ('mo-mt-sms', 1), ('lu-imsiAttach-imsiDetach', 2), ('handovers', 3), ('ss', 4)])
    MSC_S_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=16)], ev=None, er=[])
    
    #-----< MGW-EventList >-----#
    MGW_EventList = BIT_STR(name='MGW-EventList', mode=MODE_TYPE)
    MGW_EventList._cont = ASN1Dict([('context', 0)])
    MGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SGSN-EventList >-----#
    SGSN_EventList = BIT_STR(name='SGSN-EventList', mode=MODE_TYPE)
    SGSN_EventList._cont = ASN1Dict([('pdpContext', 0), ('mo-mt-sms', 1), ('rau-gprsAttach-gprsDetach', 2), ('mbmsContext', 3)])
    SGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< GGSN-EventList >-----#
    GGSN_EventList = BIT_STR(name='GGSN-EventList', mode=MODE_TYPE)
    GGSN_EventList._cont = ASN1Dict([('pdpContext', 0), ('mbmsContext', 1)])
    GGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< BMSC-EventList >-----#
    BMSC_EventList = BIT_STR(name='BMSC-EventList', mode=MODE_TYPE)
    BMSC_EventList._cont = ASN1Dict([('mbmsMulticastServiceActivation', 0)])
    BMSC_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-EventList >-----#
    MME_EventList = BIT_STR(name='MME-EventList', mode=MODE_TYPE)
    MME_EventList._cont = ASN1Dict([('ue-initiatedPDNconectivityRequest', 0), ('serviceRequestts', 1), ('initialAttachTrackingAreaUpdateDetach', 2), ('ue-initiatedPDNdisconnection', 3), ('bearerActivationModificationDeletion', 4), ('handover', 5)])
    MME_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=8)], ev=None, er=[])
    
    #-----< SGW-EventList >-----#
    SGW_EventList = BIT_STR(name='SGW-EventList', mode=MODE_TYPE)
    SGW_EventList._cont = ASN1Dict([('pdn-connectionCreation', 0), ('pdn-connectionTermination', 1), ('bearerActivationModificationDeletion', 2)])
    SGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< PGW-EventList >-----#
    PGW_EventList = BIT_STR(name='PGW-EventList', mode=MODE_TYPE)
    PGW_EventList._cont = ASN1Dict([('pdn-connectionCreation', 0), ('pdn-connectionTermination', 1), ('bearerActivationModificationDeletion', 2)])
    PGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TracePropagationList >-----#
    TracePropagationList = SEQ(name='TracePropagationList', mode=MODE_TYPE)
    _TracePropagationList_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')), opt=True)
    _TracePropagationList_traceType = INT(name='traceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')), opt=True)
    _TracePropagationList_traceReference2 = OCT_STR(name='traceReference2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _TracePropagationList_traceRecordingSessionReference = OCT_STR(name='traceRecordingSessionReference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceRecordingSessionReference')), opt=True)
    _TracePropagationList_rnc_TraceDepth = ENUM(name='rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_rnc_InterfaceList = BIT_STR(name='rnc-InterfaceList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_TraceDepth = ENUM(name='msc-s-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_msc_s_InterfaceList = BIT_STR(name='msc-s-InterfaceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_EventList = BIT_STR(name='msc-s-EventList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TracePropagationList_mgw_TraceDepth = ENUM(name='mgw-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_mgw_InterfaceList = BIT_STR(name='mgw-InterfaceList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TracePropagationList_mgw_EventList = BIT_STR(name='mgw-EventList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TracePropagationList_rnc_TraceDepthExtension = ENUM(name='rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_msc_s_TraceDepthExtension = ENUM(name='msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_mgw_TraceDepthExtension = ENUM(name='mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TracePropagationList._cont = ASN1Dict([
        ('traceReference', _TracePropagationList_traceReference),
        ('traceType', _TracePropagationList_traceType),
        ('traceReference2', _TracePropagationList_traceReference2),
        ('traceRecordingSessionReference', _TracePropagationList_traceRecordingSessionReference),
        ('rnc-TraceDepth', _TracePropagationList_rnc_TraceDepth),
        ('rnc-InterfaceList', _TracePropagationList_rnc_InterfaceList),
        ('msc-s-TraceDepth', _TracePropagationList_msc_s_TraceDepth),
        ('msc-s-InterfaceList', _TracePropagationList_msc_s_InterfaceList),
        ('msc-s-EventList', _TracePropagationList_msc_s_EventList),
        ('mgw-TraceDepth', _TracePropagationList_mgw_TraceDepth),
        ('mgw-InterfaceList', _TracePropagationList_mgw_InterfaceList),
        ('mgw-EventList', _TracePropagationList_mgw_EventList),
        ('rnc-TraceDepthExtension', _TracePropagationList_rnc_TraceDepthExtension),
        ('msc-s-TraceDepthExtension', _TracePropagationList_msc_s_TraceDepthExtension),
        ('mgw-TraceDepthExtension', _TracePropagationList_mgw_TraceDepthExtension),
        ])
    TracePropagationList._ext = ['rnc-TraceDepthExtension', 'msc-s-TraceDepthExtension', 'mgw-TraceDepthExtension']
    
    #-----< ActivateTraceModeRes >-----#
    ActivateTraceModeRes = SEQ(name='ActivateTraceModeRes', mode=MODE_TYPE)
    _ActivateTraceModeRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeRes_traceSupportIndicator = NULL(name='traceSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ActivateTraceModeRes._cont = ASN1Dict([
        ('extensionContainer', _ActivateTraceModeRes_extensionContainer),
        ('traceSupportIndicator', _ActivateTraceModeRes_traceSupportIndicator),
        ])
    ActivateTraceModeRes._ext = ['traceSupportIndicator']
    
    #-----< DeactivateTraceModeArg >-----#
    DeactivateTraceModeArg = SEQ(name='DeactivateTraceModeArg', mode=MODE_TYPE)
    _DeactivateTraceModeArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _DeactivateTraceModeArg_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _DeactivateTraceModeArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeactivateTraceModeArg_traceReference2 = OCT_STR(name='traceReference2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    DeactivateTraceModeArg._cont = ASN1Dict([
        ('imsi', _DeactivateTraceModeArg_imsi),
        ('traceReference', _DeactivateTraceModeArg_traceReference),
        ('extensionContainer', _DeactivateTraceModeArg_extensionContainer),
        ('traceReference2', _DeactivateTraceModeArg_traceReference2),
        ])
    DeactivateTraceModeArg._ext = ['traceReference2']
    
    #-----< DeactivateTraceModeRes >-----#
    DeactivateTraceModeRes = SEQ(name='DeactivateTraceModeRes', mode=MODE_TYPE)
    _DeactivateTraceModeRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeactivateTraceModeRes._cont = ASN1Dict([
        ('extensionContainer', _DeactivateTraceModeRes_extensionContainer),
        ])
    DeactivateTraceModeRes._ext = []
    
    _all_ = [
        _ActivateTraceModeArg_imsi,
        _ActivateTraceModeArg_traceReference,
        _ActivateTraceModeArg_traceType,
        _ActivateTraceModeArg_omc_Id,
        _ActivateTraceModeArg_extensionContainer,
        _ActivateTraceModeArg_traceReference2,
        _ActivateTraceModeArg_traceDepthList,
        _ActivateTraceModeArg_traceNE_TypeList,
        _ActivateTraceModeArg_traceInterfaceList,
        _ActivateTraceModeArg_traceEventList,
        _ActivateTraceModeArg_traceCollectionEntity,
        _ActivateTraceModeArg_mdt_Configuration,
        ActivateTraceModeArg,
        _MDT_Configuration_jobType,
        _MDT_Configuration_areaScope,
        _MDT_Configuration_listOfMeasurements,
        _MDT_Configuration_reportingTrigger,
        _MDT_Configuration_reportInterval,
        _MDT_Configuration_reportAmount,
        _MDT_Configuration_eventThresholdRSRP,
        _MDT_Configuration_eventThresholdRSRQ,
        _MDT_Configuration_loggingInterval,
        _MDT_Configuration_loggingDuration,
        _MDT_Configuration_extensionContainer,
        _MDT_Configuration_measurementPeriodUMTS,
        _MDT_Configuration_measurementPeriodLTE,
        _MDT_Configuration_collectionPeriodRRM_UMTS,
        _MDT_Configuration_collectionPeriodRRM_LTE,
        _MDT_Configuration_positioningMethod,
        _MDT_Configuration_measurementQuantity,
        _MDT_Configuration_eventThreshold1F,
        _MDT_Configuration_eventThreshold1I,
        _MDT_Configuration_mdt_Allowed_PLMN_List,
        MDT_Configuration,
        _MDT_Allowed_PLMNId_List__item_,
        MDT_Allowed_PLMNId_List,
        PeriodUMTS,
        PeriodLTE,
        PositioningMethod,
        MeasurementQuantity,
        EventThreshold1F,
        EventThreshold1I,
        JobType,
        _AreaScope_cgi_List,
        _AreaScope_e_utran_cgi_List,
        _AreaScope_routingAreaId_List,
        _AreaScope_locationAreaId_List,
        _AreaScope_trackingAreaId_List,
        _AreaScope_extensionContainer,
        AreaScope,
        _CGI_List__item_,
        CGI_List,
        _E_UTRAN_CGI_List__item_,
        E_UTRAN_CGI_List,
        _RoutingAreaId_List__item_,
        RoutingAreaId_List,
        _LocationAreaId_List__item_,
        LocationAreaId_List,
        _TrackingAreaId_List__item_,
        TrackingAreaId_List,
        ListOfMeasurements,
        ReportingTrigger,
        ReportInterval,
        ReportAmount,
        EventThresholdRSRP,
        EventThresholdRSRQ,
        LoggingInterval,
        LoggingDuration,
        TraceReference,
        TraceReference2,
        TraceRecordingSessionReference,
        TraceType,
        _TraceDepthList_msc_s_TraceDepth,
        _TraceDepthList_mgw_TraceDepth,
        _TraceDepthList_sgsn_TraceDepth,
        _TraceDepthList_ggsn_TraceDepth,
        _TraceDepthList_rnc_TraceDepth,
        _TraceDepthList_bmsc_TraceDepth,
        _TraceDepthList_mme_TraceDepth,
        _TraceDepthList_sgw_TraceDepth,
        _TraceDepthList_pgw_TraceDepth,
        _TraceDepthList_eNB_TraceDepth,
        _TraceDepthList_msc_s_TraceDepthExtension,
        _TraceDepthList_mgw_TraceDepthExtension,
        _TraceDepthList_sgsn_TraceDepthExtension,
        _TraceDepthList_ggsn_TraceDepthExtension,
        _TraceDepthList_rnc_TraceDepthExtension,
        _TraceDepthList_bmsc_TraceDepthExtension,
        _TraceDepthList_mme_TraceDepthExtension,
        _TraceDepthList_sgw_TraceDepthExtension,
        _TraceDepthList_pgw_TraceDepthExtension,
        _TraceDepthList_eNB_TraceDepthExtension,
        TraceDepthList,
        TraceDepth,
        TraceDepthExtension,
        TraceNE_TypeList,
        _TraceInterfaceList_msc_s_List,
        _TraceInterfaceList_mgw_List,
        _TraceInterfaceList_sgsn_List,
        _TraceInterfaceList_ggsn_List,
        _TraceInterfaceList_rnc_List,
        _TraceInterfaceList_bmsc_List,
        _TraceInterfaceList_mme_List,
        _TraceInterfaceList_sgw_List,
        _TraceInterfaceList_pgw_List,
        _TraceInterfaceList_eNB_List,
        TraceInterfaceList,
        MSC_S_InterfaceList,
        MGW_InterfaceList,
        SGSN_InterfaceList,
        GGSN_InterfaceList,
        RNC_InterfaceList,
        BMSC_InterfaceList,
        MME_InterfaceList,
        SGW_InterfaceList,
        PGW_InterfaceList,
        ENB_InterfaceList,
        _TraceEventList_msc_s_List,
        _TraceEventList_mgw_List,
        _TraceEventList_sgsn_List,
        _TraceEventList_ggsn_List,
        _TraceEventList_bmsc_List,
        _TraceEventList_mme_List,
        _TraceEventList_sgw_List,
        _TraceEventList_pgw_List,
        TraceEventList,
        MSC_S_EventList,
        MGW_EventList,
        SGSN_EventList,
        GGSN_EventList,
        BMSC_EventList,
        MME_EventList,
        SGW_EventList,
        PGW_EventList,
        _TracePropagationList_traceReference,
        _TracePropagationList_traceType,
        _TracePropagationList_traceReference2,
        _TracePropagationList_traceRecordingSessionReference,
        _TracePropagationList_rnc_TraceDepth,
        _TracePropagationList_rnc_InterfaceList,
        _TracePropagationList_msc_s_TraceDepth,
        _TracePropagationList_msc_s_InterfaceList,
        _TracePropagationList_msc_s_EventList,
        _TracePropagationList_mgw_TraceDepth,
        _TracePropagationList_mgw_InterfaceList,
        _TracePropagationList_mgw_EventList,
        _TracePropagationList_rnc_TraceDepthExtension,
        _TracePropagationList_msc_s_TraceDepthExtension,
        _TracePropagationList_mgw_TraceDepthExtension,
        TracePropagationList,
        _ActivateTraceModeRes_extensionContainer,
        _ActivateTraceModeRes_traceSupportIndicator,
        ActivateTraceModeRes,
        _DeactivateTraceModeArg_imsi,
        _DeactivateTraceModeArg_traceReference,
        _DeactivateTraceModeArg_extensionContainer,
        _DeactivateTraceModeArg_traceReference2,
        DeactivateTraceModeArg,
        _DeactivateTraceModeRes_extensionContainer,
        DeactivateTraceModeRes,
    ]

class MAP_SM_DataTypes:

    _name_  = 'MAP-SM-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 16, 19]
    
    _obj_ = [
        'RoutingInfoForSM-Arg',
        'SM-DeliveryNotIntended',
        'SM-RP-MTI',
        'SM-RP-SMEA',
        'RoutingInfoForSM-Res',
        'IP-SM-GW-Guidance',
        'LocationInfoWithLMSI',
        'Additional-Number',
        'MO-ForwardSM-Arg',
        'MO-ForwardSM-Res',
        'MT-ForwardSM-Arg',
        'CorrelationID',
        'SIP-URI',
        'MT-ForwardSM-Res',
        'SM-RP-DA',
        'SM-RP-OA',
        'SM-DeliveryTimerValue',
        'ReportSM-DeliveryStatusArg',
        'SM-DeliveryOutcome',
        'ReportSM-DeliveryStatusRes',
        'AlertServiceCentreArg',
        'SmsGmsc-Alert-Event',
        'InformServiceCentreArg',
        'MW-Status',
        'ReadyForSM-Arg',
        'ReadyForSM-Res',
        'AlertReason',
        'MT-ForwardSM-VGCS-Arg',
        'MT-ForwardSM-VGCS-Res',
        'DispatcherList',
        'maxNumOfDispatchers',
        'AdditionalDispatcherList',
        'maxNumOfAdditionalDispatchers',
        ]
    _type_ = [
        'RoutingInfoForSM-Arg',
        'SM-DeliveryNotIntended',
        'SM-RP-MTI',
        'SM-RP-SMEA',
        'RoutingInfoForSM-Res',
        'IP-SM-GW-Guidance',
        'LocationInfoWithLMSI',
        'Additional-Number',
        'MO-ForwardSM-Arg',
        'MO-ForwardSM-Res',
        'MT-ForwardSM-Arg',
        'CorrelationID',
        'SIP-URI',
        'MT-ForwardSM-Res',
        'SM-RP-DA',
        'SM-RP-OA',
        'SM-DeliveryTimerValue',
        'ReportSM-DeliveryStatusArg',
        'SM-DeliveryOutcome',
        'ReportSM-DeliveryStatusRes',
        'AlertServiceCentreArg',
        'SmsGmsc-Alert-Event',
        'InformServiceCentreArg',
        'MW-Status',
        'ReadyForSM-Arg',
        'ReadyForSM-Res',
        'AlertReason',
        'MT-ForwardSM-VGCS-Arg',
        'MT-ForwardSM-VGCS-Res',
        'DispatcherList',
        'AdditionalDispatcherList',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxNumOfDispatchers',
        'maxNumOfAdditionalDispatchers',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoutingInfoForSM-Arg >-----#
    RoutingInfoForSM_Arg = SEQ(name='RoutingInfoForSM-Arg', mode=MODE_TYPE)
    _RoutingInfoForSM_Arg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfoForSM_Arg_sm_RP_PRI = BOOL(name='sm-RP-PRI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RoutingInfoForSM_Arg_serviceCentreAddress = OCT_STR(name='serviceCentreAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _RoutingInfoForSM_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoutingInfoForSM_Arg_gprsSupportIndicator = NULL(name='gprsSupportIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_sm_RP_MTI = INT(name='sm-RP-MTI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-MTI')), opt=True)
    _RoutingInfoForSM_Arg_sm_RP_SMEA = OCT_STR(name='sm-RP-SMEA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-SMEA')), opt=True)
    _RoutingInfoForSM_Arg_sm_deliveryNotIntended = ENUM(name='sm-deliveryNotIntended', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryNotIntended')), opt=True)
    _RoutingInfoForSM_Arg_ip_sm_gwGuidanceIndicator = NULL(name='ip-sm-gwGuidanceIndicator', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _RoutingInfoForSM_Arg_t4_Trigger_Indicator = NULL(name='t4-Trigger-Indicator', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_singleAttemptDelivery = NULL(name='singleAttemptDelivery', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_correlationID = SEQ(name='correlationID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _RoutingInfoForSM_Arg_smsf_supportIndicator = NULL(name='smsf-supportIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RoutingInfoForSM_Arg._cont = ASN1Dict([
        ('msisdn', _RoutingInfoForSM_Arg_msisdn),
        ('sm-RP-PRI', _RoutingInfoForSM_Arg_sm_RP_PRI),
        ('serviceCentreAddress', _RoutingInfoForSM_Arg_serviceCentreAddress),
        ('extensionContainer', _RoutingInfoForSM_Arg_extensionContainer),
        ('gprsSupportIndicator', _RoutingInfoForSM_Arg_gprsSupportIndicator),
        ('sm-RP-MTI', _RoutingInfoForSM_Arg_sm_RP_MTI),
        ('sm-RP-SMEA', _RoutingInfoForSM_Arg_sm_RP_SMEA),
        ('sm-deliveryNotIntended', _RoutingInfoForSM_Arg_sm_deliveryNotIntended),
        ('ip-sm-gwGuidanceIndicator', _RoutingInfoForSM_Arg_ip_sm_gwGuidanceIndicator),
        ('imsi', _RoutingInfoForSM_Arg_imsi),
        ('t4-Trigger-Indicator', _RoutingInfoForSM_Arg_t4_Trigger_Indicator),
        ('singleAttemptDelivery', _RoutingInfoForSM_Arg_singleAttemptDelivery),
        ('correlationID', _RoutingInfoForSM_Arg_correlationID),
        ('smsf-supportIndicator', _RoutingInfoForSM_Arg_smsf_supportIndicator),
        ])
    RoutingInfoForSM_Arg._ext = ['gprsSupportIndicator', 'sm-RP-MTI', 'sm-RP-SMEA', 'sm-deliveryNotIntended', 'ip-sm-gwGuidanceIndicator', 'imsi', 't4-Trigger-Indicator', 'singleAttemptDelivery', 'correlationID', 'smsf-supportIndicator']
    
    #-----< SM-DeliveryNotIntended >-----#
    SM_DeliveryNotIntended = ENUM(name='SM-DeliveryNotIntended', mode=MODE_TYPE)
    SM_DeliveryNotIntended._cont = ASN1Dict([('onlyIMSI-requested', 0), ('onlyMCC-MNC-requested', 1)])
    SM_DeliveryNotIntended._ext = []
    
    #-----< SM-RP-MTI >-----#
    SM_RP_MTI = INT(name='SM-RP-MTI', mode=MODE_TYPE)
    SM_RP_MTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< SM-RP-SMEA >-----#
    SM_RP_SMEA = OCT_STR(name='SM-RP-SMEA', mode=MODE_TYPE)
    SM_RP_SMEA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< RoutingInfoForSM-Res >-----#
    RoutingInfoForSM_Res = SEQ(name='RoutingInfoForSM-Res', mode=MODE_TYPE)
    _RoutingInfoForSM_Res_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RoutingInfoForSM_Res_locationInfoWithLMSI = SEQ(name='locationInfoWithLMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'LocationInfoWithLMSI')))
    _RoutingInfoForSM_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoutingInfoForSM_Res_ip_sm_gwGuidance = SEQ(name='ip-sm-gwGuidance', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'IP-SM-GW-Guidance')), opt=True)
    RoutingInfoForSM_Res._cont = ASN1Dict([
        ('imsi', _RoutingInfoForSM_Res_imsi),
        ('locationInfoWithLMSI', _RoutingInfoForSM_Res_locationInfoWithLMSI),
        ('extensionContainer', _RoutingInfoForSM_Res_extensionContainer),
        ('ip-sm-gwGuidance', _RoutingInfoForSM_Res_ip_sm_gwGuidance),
        ])
    RoutingInfoForSM_Res._ext = ['ip-sm-gwGuidance']
    
    #-----< IP-SM-GW-Guidance >-----#
    IP_SM_GW_Guidance = SEQ(name='IP-SM-GW-Guidance', mode=MODE_TYPE)
    _IP_SM_GW_Guidance_minimumDeliveryTimeValue = INT(name='minimumDeliveryTimeValue', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryTimerValue')))
    _IP_SM_GW_Guidance_recommendedDeliveryTimeValue = INT(name='recommendedDeliveryTimeValue', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryTimerValue')))
    _IP_SM_GW_Guidance_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IP_SM_GW_Guidance._cont = ASN1Dict([
        ('minimumDeliveryTimeValue', _IP_SM_GW_Guidance_minimumDeliveryTimeValue),
        ('recommendedDeliveryTimeValue', _IP_SM_GW_Guidance_recommendedDeliveryTimeValue),
        ('extensionContainer', _IP_SM_GW_Guidance_extensionContainer),
        ])
    IP_SM_GW_Guidance._ext = []
    
    #-----< LocationInfoWithLMSI >-----#
    LocationInfoWithLMSI = SEQ(name='LocationInfoWithLMSI', mode=MODE_TYPE)
    _LocationInfoWithLMSI_networkNode_Number = OCT_STR(name='networkNode-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _LocationInfoWithLMSI_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _LocationInfoWithLMSI_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInfoWithLMSI_gprsNodeIndicator = NULL(name='gprsNodeIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfoWithLMSI_additional_Number = CHOICE(name='additional-Number', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'Additional-Number')), opt=True)
    _LocationInfoWithLMSI_networkNodeDiameterAddress = SEQ(name='networkNodeDiameterAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_additionalNetworkNodeDiameterAddress = SEQ(name='additionalNetworkNodeDiameterAddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_thirdNumber = CHOICE(name='thirdNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'Additional-Number')), opt=True)
    _LocationInfoWithLMSI_thirdNetworkNodeDiameterAddress = SEQ(name='thirdNetworkNodeDiameterAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_imsNodeIndicator = NULL(name='imsNodeIndicator', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfoWithLMSI_smsf_3gpp_Number = OCT_STR(name='smsf-3gpp-Number', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInfoWithLMSI_smsf_3gpp_DiameterAddress = SEQ(name='smsf-3gpp-DiameterAddress', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_smsf_non_3gpp_Number = OCT_STR(name='smsf-non-3gpp-Number', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInfoWithLMSI_smsf_non_3gpp_DiameterAddress = SEQ(name='smsf-non-3gpp-DiameterAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_smsf_3gpp_address_indicator = NULL(name='smsf-3gpp-address-indicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfoWithLMSI_smsf_non_3gpp_address_indicator = NULL(name='smsf-non-3gpp-address-indicator', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    LocationInfoWithLMSI._cont = ASN1Dict([
        ('networkNode-Number', _LocationInfoWithLMSI_networkNode_Number),
        ('lmsi', _LocationInfoWithLMSI_lmsi),
        ('extensionContainer', _LocationInfoWithLMSI_extensionContainer),
        ('gprsNodeIndicator', _LocationInfoWithLMSI_gprsNodeIndicator),
        ('additional-Number', _LocationInfoWithLMSI_additional_Number),
        ('networkNodeDiameterAddress', _LocationInfoWithLMSI_networkNodeDiameterAddress),
        ('additionalNetworkNodeDiameterAddress', _LocationInfoWithLMSI_additionalNetworkNodeDiameterAddress),
        ('thirdNumber', _LocationInfoWithLMSI_thirdNumber),
        ('thirdNetworkNodeDiameterAddress', _LocationInfoWithLMSI_thirdNetworkNodeDiameterAddress),
        ('imsNodeIndicator', _LocationInfoWithLMSI_imsNodeIndicator),
        ('smsf-3gpp-Number', _LocationInfoWithLMSI_smsf_3gpp_Number),
        ('smsf-3gpp-DiameterAddress', _LocationInfoWithLMSI_smsf_3gpp_DiameterAddress),
        ('smsf-non-3gpp-Number', _LocationInfoWithLMSI_smsf_non_3gpp_Number),
        ('smsf-non-3gpp-DiameterAddress', _LocationInfoWithLMSI_smsf_non_3gpp_DiameterAddress),
        ('smsf-3gpp-address-indicator', _LocationInfoWithLMSI_smsf_3gpp_address_indicator),
        ('smsf-non-3gpp-address-indicator', _LocationInfoWithLMSI_smsf_non_3gpp_address_indicator),
        ])
    LocationInfoWithLMSI._ext = ['gprsNodeIndicator', 'additional-Number', 'networkNodeDiameterAddress', 'additionalNetworkNodeDiameterAddress', 'thirdNumber', 'thirdNetworkNodeDiameterAddress', 'imsNodeIndicator', 'smsf-3gpp-Number', 'smsf-3gpp-DiameterAddress', 'smsf-non-3gpp-Number', 'smsf-non-3gpp-DiameterAddress', 'smsf-3gpp-address-indicator', 'smsf-non-3gpp-address-indicator']
    
    #-----< Additional-Number >-----#
    Additional_Number = CHOICE(name='Additional-Number', mode=MODE_TYPE)
    _Additional_Number_msc_Number = OCT_STR(name='msc-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _Additional_Number_sgsn_Number = OCT_STR(name='sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    Additional_Number._cont = ASN1Dict([
        ('msc-Number', _Additional_Number_msc_Number),
        ('sgsn-Number', _Additional_Number_sgsn_Number),
        ])
    Additional_Number._ext = None
    
    #-----< MO-ForwardSM-Arg >-----#
    MO_ForwardSM_Arg = SEQ(name='MO-ForwardSM-Arg', mode=MODE_TYPE)
    _MO_ForwardSM_Arg_sm_RP_DA = CHOICE(name='sm-RP-DA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-DA')))
    _MO_ForwardSM_Arg_sm_RP_OA = CHOICE(name='sm-RP-OA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-OA')))
    _MO_ForwardSM_Arg_sm_RP_UI = OCT_STR(name='sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _MO_ForwardSM_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MO_ForwardSM_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MO_ForwardSM_Arg_correlationID = SEQ(name='correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _MO_ForwardSM_Arg_sm_DeliveryOutcome = ENUM(name='sm-DeliveryOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    MO_ForwardSM_Arg._cont = ASN1Dict([
        ('sm-RP-DA', _MO_ForwardSM_Arg_sm_RP_DA),
        ('sm-RP-OA', _MO_ForwardSM_Arg_sm_RP_OA),
        ('sm-RP-UI', _MO_ForwardSM_Arg_sm_RP_UI),
        ('extensionContainer', _MO_ForwardSM_Arg_extensionContainer),
        ('imsi', _MO_ForwardSM_Arg_imsi),
        ('correlationID', _MO_ForwardSM_Arg_correlationID),
        ('sm-DeliveryOutcome', _MO_ForwardSM_Arg_sm_DeliveryOutcome),
        ])
    MO_ForwardSM_Arg._ext = ['imsi', 'correlationID', 'sm-DeliveryOutcome']
    
    #-----< MO-ForwardSM-Res >-----#
    MO_ForwardSM_Res = SEQ(name='MO-ForwardSM-Res', mode=MODE_TYPE)
    _MO_ForwardSM_Res_sm_RP_UI = OCT_STR(name='sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _MO_ForwardSM_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MO_ForwardSM_Res._cont = ASN1Dict([
        ('sm-RP-UI', _MO_ForwardSM_Res_sm_RP_UI),
        ('extensionContainer', _MO_ForwardSM_Res_extensionContainer),
        ])
    MO_ForwardSM_Res._ext = []
    
    #-----< MT-ForwardSM-Arg >-----#
    MT_ForwardSM_Arg = SEQ(name='MT-ForwardSM-Arg', mode=MODE_TYPE)
    _MT_ForwardSM_Arg_sm_RP_DA = CHOICE(name='sm-RP-DA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-DA')))
    _MT_ForwardSM_Arg_sm_RP_OA = CHOICE(name='sm-RP-OA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-OA')))
    _MT_ForwardSM_Arg_sm_RP_UI = OCT_STR(name='sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _MT_ForwardSM_Arg_moreMessagesToSend = NULL(name='moreMessagesToSend', mode=MODE_TYPE, opt=True)
    _MT_ForwardSM_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MT_ForwardSM_Arg_smDeliveryTimer = INT(name='smDeliveryTimer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryTimerValue')), opt=True)
    _MT_ForwardSM_Arg_smDeliveryStartTime = OCT_STR(name='smDeliveryStartTime', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _MT_ForwardSM_Arg_smsOverIP_OnlyIndicator = NULL(name='smsOverIP-OnlyIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MT_ForwardSM_Arg_correlationID = SEQ(name='correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _MT_ForwardSM_Arg_maximumRetransmissionTime = OCT_STR(name='maximumRetransmissionTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _MT_ForwardSM_Arg_smsGmscAddress = OCT_STR(name='smsGmscAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MT_ForwardSM_Arg_smsGmscDiameterAddress = SEQ(name='smsGmscDiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    MT_ForwardSM_Arg._cont = ASN1Dict([
        ('sm-RP-DA', _MT_ForwardSM_Arg_sm_RP_DA),
        ('sm-RP-OA', _MT_ForwardSM_Arg_sm_RP_OA),
        ('sm-RP-UI', _MT_ForwardSM_Arg_sm_RP_UI),
        ('moreMessagesToSend', _MT_ForwardSM_Arg_moreMessagesToSend),
        ('extensionContainer', _MT_ForwardSM_Arg_extensionContainer),
        ('smDeliveryTimer', _MT_ForwardSM_Arg_smDeliveryTimer),
        ('smDeliveryStartTime', _MT_ForwardSM_Arg_smDeliveryStartTime),
        ('smsOverIP-OnlyIndicator', _MT_ForwardSM_Arg_smsOverIP_OnlyIndicator),
        ('correlationID', _MT_ForwardSM_Arg_correlationID),
        ('maximumRetransmissionTime', _MT_ForwardSM_Arg_maximumRetransmissionTime),
        ('smsGmscAddress', _MT_ForwardSM_Arg_smsGmscAddress),
        ('smsGmscDiameterAddress', _MT_ForwardSM_Arg_smsGmscDiameterAddress),
        ])
    MT_ForwardSM_Arg._ext = ['smDeliveryTimer', 'smDeliveryStartTime', 'smsOverIP-OnlyIndicator', 'correlationID', 'maximumRetransmissionTime', 'smsGmscAddress', 'smsGmscDiameterAddress']
    
    #-----< CorrelationID >-----#
    CorrelationID = SEQ(name='CorrelationID', mode=MODE_TYPE)
    _CorrelationID_hlr_id = OCT_STR(name='hlr-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-Id')), opt=True)
    _CorrelationID_sip_uri_A = OCT_STR(name='sip-uri-A', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SIP-URI')), opt=True)
    _CorrelationID_sip_uri_B = OCT_STR(name='sip-uri-B', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SIP-URI')))
    CorrelationID._cont = ASN1Dict([
        ('hlr-id', _CorrelationID_hlr_id),
        ('sip-uri-A', _CorrelationID_sip_uri_A),
        ('sip-uri-B', _CorrelationID_sip_uri_B),
        ])
    CorrelationID._ext = None
    
    #-----< SIP-URI >-----#
    SIP_URI = OCT_STR(name='SIP-URI', mode=MODE_TYPE)
    
    #-----< MT-ForwardSM-Res >-----#
    MT_ForwardSM_Res = SEQ(name='MT-ForwardSM-Res', mode=MODE_TYPE)
    _MT_ForwardSM_Res_sm_RP_UI = OCT_STR(name='sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _MT_ForwardSM_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MT_ForwardSM_Res._cont = ASN1Dict([
        ('sm-RP-UI', _MT_ForwardSM_Res_sm_RP_UI),
        ('extensionContainer', _MT_ForwardSM_Res_extensionContainer),
        ])
    MT_ForwardSM_Res._ext = []
    
    #-----< SM-RP-DA >-----#
    SM_RP_DA = CHOICE(name='SM-RP-DA', mode=MODE_TYPE)
    _SM_RP_DA_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SM_RP_DA_lmsi = OCT_STR(name='lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')))
    _SM_RP_DA_serviceCentreAddressDA = OCT_STR(name='serviceCentreAddressDA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SM_RP_DA_noSM_RP_DA = NULL(name='noSM-RP-DA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SM_RP_DA._cont = ASN1Dict([
        ('imsi', _SM_RP_DA_imsi),
        ('lmsi', _SM_RP_DA_lmsi),
        ('serviceCentreAddressDA', _SM_RP_DA_serviceCentreAddressDA),
        ('noSM-RP-DA', _SM_RP_DA_noSM_RP_DA),
        ])
    SM_RP_DA._ext = None
    
    #-----< SM-RP-OA >-----#
    SM_RP_OA = CHOICE(name='SM-RP-OA', mode=MODE_TYPE)
    _SM_RP_OA_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SM_RP_OA_serviceCentreAddressOA = OCT_STR(name='serviceCentreAddressOA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SM_RP_OA_noSM_RP_OA = NULL(name='noSM-RP-OA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SM_RP_OA._cont = ASN1Dict([
        ('msisdn', _SM_RP_OA_msisdn),
        ('serviceCentreAddressOA', _SM_RP_OA_serviceCentreAddressOA),
        ('noSM-RP-OA', _SM_RP_OA_noSM_RP_OA),
        ])
    SM_RP_OA._ext = None
    
    #-----< SM-DeliveryTimerValue >-----#
    SM_DeliveryTimerValue = INT(name='SM-DeliveryTimerValue', mode=MODE_TYPE)
    SM_DeliveryTimerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30, ub=600)], ev=None, er=[])
    
    #-----< ReportSM-DeliveryStatusArg >-----#
    ReportSM_DeliveryStatusArg = SEQ(name='ReportSM-DeliveryStatusArg', mode=MODE_TYPE)
    _ReportSM_DeliveryStatusArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ReportSM_DeliveryStatusArg_serviceCentreAddress = OCT_STR(name='serviceCentreAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _ReportSM_DeliveryStatusArg_sm_DeliveryOutcome = ENUM(name='sm-DeliveryOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')))
    _ReportSM_DeliveryStatusArg_absentSubscriberDiagnosticSM = INT(name='absentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ReportSM_DeliveryStatusArg_gprsSupportIndicator = NULL(name='gprsSupportIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_deliveryOutcomeIndicator = NULL(name='deliveryOutcomeIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_additionalSM_DeliveryOutcome = ENUM(name='additionalSM-DeliveryOutcome', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_additionalAbsentSubscriberDiagnosticSM = INT(name='additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_ip_sm_gw_Indicator = NULL(name='ip-sm-gw-Indicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_ip_sm_gw_sm_deliveryOutcome = ENUM(name='ip-sm-gw-sm-deliveryOutcome', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_ip_sm_gw_absentSubscriberDiagnosticSM = INT(name='ip-sm-gw-absentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ReportSM_DeliveryStatusArg_singleAttemptDelivery = NULL(name='singleAttemptDelivery', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_correlationID = SEQ(name='correlationID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcomeIndicator = NULL(name='smsf-3gpp-deliveryOutcomeIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcome = ENUM(name='smsf-3gpp-deliveryOutcome', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_3gpp_absentSubscriberDiagSM = INT(name='smsf-3gpp-absentSubscriberDiagSM', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcomeIndicator = NULL(name='smsf-non-3gpp-deliveryOutcomeIndicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcome = ENUM(name='smsf-non-3gpp-deliveryOutcome', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_non_3gpp_absentSubscriberDiagSM = INT(name='smsf-non-3gpp-absentSubscriberDiagSM', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    ReportSM_DeliveryStatusArg._cont = ASN1Dict([
        ('msisdn', _ReportSM_DeliveryStatusArg_msisdn),
        ('serviceCentreAddress', _ReportSM_DeliveryStatusArg_serviceCentreAddress),
        ('sm-DeliveryOutcome', _ReportSM_DeliveryStatusArg_sm_DeliveryOutcome),
        ('absentSubscriberDiagnosticSM', _ReportSM_DeliveryStatusArg_absentSubscriberDiagnosticSM),
        ('extensionContainer', _ReportSM_DeliveryStatusArg_extensionContainer),
        ('gprsSupportIndicator', _ReportSM_DeliveryStatusArg_gprsSupportIndicator),
        ('deliveryOutcomeIndicator', _ReportSM_DeliveryStatusArg_deliveryOutcomeIndicator),
        ('additionalSM-DeliveryOutcome', _ReportSM_DeliveryStatusArg_additionalSM_DeliveryOutcome),
        ('additionalAbsentSubscriberDiagnosticSM', _ReportSM_DeliveryStatusArg_additionalAbsentSubscriberDiagnosticSM),
        ('ip-sm-gw-Indicator', _ReportSM_DeliveryStatusArg_ip_sm_gw_Indicator),
        ('ip-sm-gw-sm-deliveryOutcome', _ReportSM_DeliveryStatusArg_ip_sm_gw_sm_deliveryOutcome),
        ('ip-sm-gw-absentSubscriberDiagnosticSM', _ReportSM_DeliveryStatusArg_ip_sm_gw_absentSubscriberDiagnosticSM),
        ('imsi', _ReportSM_DeliveryStatusArg_imsi),
        ('singleAttemptDelivery', _ReportSM_DeliveryStatusArg_singleAttemptDelivery),
        ('correlationID', _ReportSM_DeliveryStatusArg_correlationID),
        ('smsf-3gpp-deliveryOutcomeIndicator', _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcomeIndicator),
        ('smsf-3gpp-deliveryOutcome', _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcome),
        ('smsf-3gpp-absentSubscriberDiagSM', _ReportSM_DeliveryStatusArg_smsf_3gpp_absentSubscriberDiagSM),
        ('smsf-non-3gpp-deliveryOutcomeIndicator', _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcomeIndicator),
        ('smsf-non-3gpp-deliveryOutcome', _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcome),
        ('smsf-non-3gpp-absentSubscriberDiagSM', _ReportSM_DeliveryStatusArg_smsf_non_3gpp_absentSubscriberDiagSM),
        ])
    ReportSM_DeliveryStatusArg._ext = ['gprsSupportIndicator', 'deliveryOutcomeIndicator', 'additionalSM-DeliveryOutcome', 'additionalAbsentSubscriberDiagnosticSM', 'ip-sm-gw-Indicator', 'ip-sm-gw-sm-deliveryOutcome', 'ip-sm-gw-absentSubscriberDiagnosticSM', 'imsi', 'singleAttemptDelivery', 'correlationID', 'smsf-3gpp-deliveryOutcomeIndicator', 'smsf-3gpp-deliveryOutcome', 'smsf-3gpp-absentSubscriberDiagSM', 'smsf-non-3gpp-deliveryOutcomeIndicator', 'smsf-non-3gpp-deliveryOutcome', 'smsf-non-3gpp-absentSubscriberDiagSM']
    
    #-----< SM-DeliveryOutcome >-----#
    SM_DeliveryOutcome = ENUM(name='SM-DeliveryOutcome', mode=MODE_TYPE)
    SM_DeliveryOutcome._cont = ASN1Dict([('memoryCapacityExceeded', 0), ('absentSubscriber', 1), ('successfulTransfer', 2)])
    SM_DeliveryOutcome._ext = None
    
    #-----< ReportSM-DeliveryStatusRes >-----#
    ReportSM_DeliveryStatusRes = SEQ(name='ReportSM-DeliveryStatusRes', mode=MODE_TYPE)
    _ReportSM_DeliveryStatusRes_storedMSISDN = OCT_STR(name='storedMSISDN', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ReportSM_DeliveryStatusRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReportSM_DeliveryStatusRes._cont = ASN1Dict([
        ('storedMSISDN', _ReportSM_DeliveryStatusRes_storedMSISDN),
        ('extensionContainer', _ReportSM_DeliveryStatusRes_extensionContainer),
        ])
    ReportSM_DeliveryStatusRes._ext = []
    
    #-----< AlertServiceCentreArg >-----#
    AlertServiceCentreArg = SEQ(name='AlertServiceCentreArg', mode=MODE_TYPE)
    _AlertServiceCentreArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AlertServiceCentreArg_serviceCentreAddress = OCT_STR(name='serviceCentreAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _AlertServiceCentreArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _AlertServiceCentreArg_correlationID = SEQ(name='correlationID', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _AlertServiceCentreArg_maximumUeAvailabilityTime = OCT_STR(name='maximumUeAvailabilityTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _AlertServiceCentreArg_smsGmscAlertEvent = ENUM(name='smsGmscAlertEvent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SmsGmsc-Alert-Event')), opt=True)
    _AlertServiceCentreArg_smsGmscDiameterAddress = SEQ(name='smsGmscDiameterAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _AlertServiceCentreArg_newSGSNNumber = OCT_STR(name='newSGSNNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AlertServiceCentreArg_newSGSNDiameterAddress = SEQ(name='newSGSNDiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _AlertServiceCentreArg_newMMENumber = OCT_STR(name='newMMENumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AlertServiceCentreArg_newMMEDiameterAddress = SEQ(name='newMMEDiameterAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _AlertServiceCentreArg_newMSCNumber = OCT_STR(name='newMSCNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    AlertServiceCentreArg._cont = ASN1Dict([
        ('msisdn', _AlertServiceCentreArg_msisdn),
        ('serviceCentreAddress', _AlertServiceCentreArg_serviceCentreAddress),
        ('imsi', _AlertServiceCentreArg_imsi),
        ('correlationID', _AlertServiceCentreArg_correlationID),
        ('maximumUeAvailabilityTime', _AlertServiceCentreArg_maximumUeAvailabilityTime),
        ('smsGmscAlertEvent', _AlertServiceCentreArg_smsGmscAlertEvent),
        ('smsGmscDiameterAddress', _AlertServiceCentreArg_smsGmscDiameterAddress),
        ('newSGSNNumber', _AlertServiceCentreArg_newSGSNNumber),
        ('newSGSNDiameterAddress', _AlertServiceCentreArg_newSGSNDiameterAddress),
        ('newMMENumber', _AlertServiceCentreArg_newMMENumber),
        ('newMMEDiameterAddress', _AlertServiceCentreArg_newMMEDiameterAddress),
        ('newMSCNumber', _AlertServiceCentreArg_newMSCNumber),
        ])
    AlertServiceCentreArg._ext = ['imsi', 'correlationID', 'maximumUeAvailabilityTime', 'smsGmscAlertEvent', 'smsGmscDiameterAddress', 'newSGSNNumber', 'newSGSNDiameterAddress', 'newMMENumber', 'newMMEDiameterAddress', 'newMSCNumber']
    
    #-----< SmsGmsc-Alert-Event >-----#
    SmsGmsc_Alert_Event = ENUM(name='SmsGmsc-Alert-Event', mode=MODE_TYPE)
    SmsGmsc_Alert_Event._cont = ASN1Dict([('msAvailableForMtSms', 0), ('msUnderNewServingNode', 1)])
    SmsGmsc_Alert_Event._ext = None
    
    #-----< InformServiceCentreArg >-----#
    InformServiceCentreArg = SEQ(name='InformServiceCentreArg', mode=MODE_TYPE)
    _InformServiceCentreArg_storedMSISDN = OCT_STR(name='storedMSISDN', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InformServiceCentreArg_mw_Status = BIT_STR(name='mw-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'MW-Status')), opt=True)
    _InformServiceCentreArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InformServiceCentreArg_absentSubscriberDiagnosticSM = INT(name='absentSubscriberDiagnosticSM', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _InformServiceCentreArg_additionalAbsentSubscriberDiagnosticSM = INT(name='additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _InformServiceCentreArg_smsf3gppAbsentSubscriberDiagnosticSM = INT(name='smsf3gppAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _InformServiceCentreArg_smsfNon3gppAbsentSubscriberDiagnosticSM = INT(name='smsfNon3gppAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    InformServiceCentreArg._cont = ASN1Dict([
        ('storedMSISDN', _InformServiceCentreArg_storedMSISDN),
        ('mw-Status', _InformServiceCentreArg_mw_Status),
        ('extensionContainer', _InformServiceCentreArg_extensionContainer),
        ('absentSubscriberDiagnosticSM', _InformServiceCentreArg_absentSubscriberDiagnosticSM),
        ('additionalAbsentSubscriberDiagnosticSM', _InformServiceCentreArg_additionalAbsentSubscriberDiagnosticSM),
        ('smsf3gppAbsentSubscriberDiagnosticSM', _InformServiceCentreArg_smsf3gppAbsentSubscriberDiagnosticSM),
        ('smsfNon3gppAbsentSubscriberDiagnosticSM', _InformServiceCentreArg_smsfNon3gppAbsentSubscriberDiagnosticSM),
        ])
    InformServiceCentreArg._ext = ['absentSubscriberDiagnosticSM', 'additionalAbsentSubscriberDiagnosticSM', 'smsf3gppAbsentSubscriberDiagnosticSM', 'smsfNon3gppAbsentSubscriberDiagnosticSM']
    
    #-----< MW-Status >-----#
    MW_Status = BIT_STR(name='MW-Status', mode=MODE_TYPE)
    MW_Status._cont = ASN1Dict([('sc-AddressNotIncluded', 0), ('mnrf-Set', 1), ('mcef-Set', 2), ('mnrg-Set', 3), ('mnr5g-Set', 4), ('mnr5gn3g-Set', 5)])
    MW_Status._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=16)], ev=None, er=[])
    
    #-----< ReadyForSM-Arg >-----#
    ReadyForSM_Arg = SEQ(name='ReadyForSM-Arg', mode=MODE_TYPE)
    _ReadyForSM_Arg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ReadyForSM_Arg_alertReason = ENUM(name='alertReason', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'AlertReason')))
    _ReadyForSM_Arg_alertReasonIndicator = NULL(name='alertReasonIndicator', mode=MODE_TYPE, opt=True)
    _ReadyForSM_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ReadyForSM_Arg_additionalAlertReasonIndicator = NULL(name='additionalAlertReasonIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReadyForSM_Arg_maximumUeAvailabilityTime = OCT_STR(name='maximumUeAvailabilityTime', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    ReadyForSM_Arg._cont = ASN1Dict([
        ('imsi', _ReadyForSM_Arg_imsi),
        ('alertReason', _ReadyForSM_Arg_alertReason),
        ('alertReasonIndicator', _ReadyForSM_Arg_alertReasonIndicator),
        ('extensionContainer', _ReadyForSM_Arg_extensionContainer),
        ('additionalAlertReasonIndicator', _ReadyForSM_Arg_additionalAlertReasonIndicator),
        ('maximumUeAvailabilityTime', _ReadyForSM_Arg_maximumUeAvailabilityTime),
        ])
    ReadyForSM_Arg._ext = ['additionalAlertReasonIndicator', 'maximumUeAvailabilityTime']
    
    #-----< ReadyForSM-Res >-----#
    ReadyForSM_Res = SEQ(name='ReadyForSM-Res', mode=MODE_TYPE)
    _ReadyForSM_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReadyForSM_Res._cont = ASN1Dict([
        ('extensionContainer', _ReadyForSM_Res_extensionContainer),
        ])
    ReadyForSM_Res._ext = []
    
    #-----< AlertReason >-----#
    AlertReason = ENUM(name='AlertReason', mode=MODE_TYPE)
    AlertReason._cont = ASN1Dict([('ms-Present', 0), ('memoryAvailable', 1)])
    AlertReason._ext = None
    
    #-----< MT-ForwardSM-VGCS-Arg >-----#
    MT_ForwardSM_VGCS_Arg = SEQ(name='MT-ForwardSM-VGCS-Arg', mode=MODE_TYPE)
    _MT_ForwardSM_VGCS_Arg_asciCallReference = OCT_STR(name='asciCallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ASCI-CallReference')))
    _MT_ForwardSM_VGCS_Arg_sm_RP_OA = CHOICE(name='sm-RP-OA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-OA')))
    _MT_ForwardSM_VGCS_Arg_sm_RP_UI = OCT_STR(name='sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _MT_ForwardSM_VGCS_Arg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MT_ForwardSM_VGCS_Arg._cont = ASN1Dict([
        ('asciCallReference', _MT_ForwardSM_VGCS_Arg_asciCallReference),
        ('sm-RP-OA', _MT_ForwardSM_VGCS_Arg_sm_RP_OA),
        ('sm-RP-UI', _MT_ForwardSM_VGCS_Arg_sm_RP_UI),
        ('extensionContainer', _MT_ForwardSM_VGCS_Arg_extensionContainer),
        ])
    MT_ForwardSM_VGCS_Arg._ext = []
    
    #-----< MT-ForwardSM-VGCS-Res >-----#
    MT_ForwardSM_VGCS_Res = SEQ(name='MT-ForwardSM-VGCS-Res', mode=MODE_TYPE)
    _MT_ForwardSM_VGCS_Res_sm_RP_UI = OCT_STR(name='sm-RP-UI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _MT_ForwardSM_VGCS_Res_dispatcherList = SEQ_OF(name='dispatcherList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'DispatcherList')), opt=True)
    _MT_ForwardSM_VGCS_Res_ongoingCall = NULL(name='ongoingCall', mode=MODE_TYPE, opt=True)
    _MT_ForwardSM_VGCS_Res_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MT_ForwardSM_VGCS_Res_additionalDispatcherList = SEQ_OF(name='additionalDispatcherList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'AdditionalDispatcherList')), opt=True)
    MT_ForwardSM_VGCS_Res._cont = ASN1Dict([
        ('sm-RP-UI', _MT_ForwardSM_VGCS_Res_sm_RP_UI),
        ('dispatcherList', _MT_ForwardSM_VGCS_Res_dispatcherList),
        ('ongoingCall', _MT_ForwardSM_VGCS_Res_ongoingCall),
        ('extensionContainer', _MT_ForwardSM_VGCS_Res_extensionContainer),
        ('additionalDispatcherList', _MT_ForwardSM_VGCS_Res_additionalDispatcherList),
        ])
    MT_ForwardSM_VGCS_Res._ext = ['additionalDispatcherList']
    
    #-----< DispatcherList >-----#
    DispatcherList = SEQ_OF(name='DispatcherList', mode=MODE_TYPE)
    _DispatcherList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    DispatcherList._cont = _DispatcherList__item_
    DispatcherList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfDispatchers >-----#
    maxNumOfDispatchers = INT(name='maxNumOfDispatchers', mode=MODE_VALUE)
    maxNumOfDispatchers._val = 5
    
    #-----< AdditionalDispatcherList >-----#
    AdditionalDispatcherList = SEQ_OF(name='AdditionalDispatcherList', mode=MODE_TYPE)
    _AdditionalDispatcherList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    AdditionalDispatcherList._cont = _AdditionalDispatcherList__item_
    AdditionalDispatcherList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< maxNumOfAdditionalDispatchers >-----#
    maxNumOfAdditionalDispatchers = INT(name='maxNumOfAdditionalDispatchers', mode=MODE_VALUE)
    maxNumOfAdditionalDispatchers._val = 15
    
    _all_ = [
        _RoutingInfoForSM_Arg_msisdn,
        _RoutingInfoForSM_Arg_sm_RP_PRI,
        _RoutingInfoForSM_Arg_serviceCentreAddress,
        _RoutingInfoForSM_Arg_extensionContainer,
        _RoutingInfoForSM_Arg_gprsSupportIndicator,
        _RoutingInfoForSM_Arg_sm_RP_MTI,
        _RoutingInfoForSM_Arg_sm_RP_SMEA,
        _RoutingInfoForSM_Arg_sm_deliveryNotIntended,
        _RoutingInfoForSM_Arg_ip_sm_gwGuidanceIndicator,
        _RoutingInfoForSM_Arg_imsi,
        _RoutingInfoForSM_Arg_t4_Trigger_Indicator,
        _RoutingInfoForSM_Arg_singleAttemptDelivery,
        _RoutingInfoForSM_Arg_correlationID,
        _RoutingInfoForSM_Arg_smsf_supportIndicator,
        RoutingInfoForSM_Arg,
        SM_DeliveryNotIntended,
        SM_RP_MTI,
        SM_RP_SMEA,
        _RoutingInfoForSM_Res_imsi,
        _RoutingInfoForSM_Res_locationInfoWithLMSI,
        _RoutingInfoForSM_Res_extensionContainer,
        _RoutingInfoForSM_Res_ip_sm_gwGuidance,
        RoutingInfoForSM_Res,
        _IP_SM_GW_Guidance_minimumDeliveryTimeValue,
        _IP_SM_GW_Guidance_recommendedDeliveryTimeValue,
        _IP_SM_GW_Guidance_extensionContainer,
        IP_SM_GW_Guidance,
        _LocationInfoWithLMSI_networkNode_Number,
        _LocationInfoWithLMSI_lmsi,
        _LocationInfoWithLMSI_extensionContainer,
        _LocationInfoWithLMSI_gprsNodeIndicator,
        _LocationInfoWithLMSI_additional_Number,
        _LocationInfoWithLMSI_networkNodeDiameterAddress,
        _LocationInfoWithLMSI_additionalNetworkNodeDiameterAddress,
        _LocationInfoWithLMSI_thirdNumber,
        _LocationInfoWithLMSI_thirdNetworkNodeDiameterAddress,
        _LocationInfoWithLMSI_imsNodeIndicator,
        _LocationInfoWithLMSI_smsf_3gpp_Number,
        _LocationInfoWithLMSI_smsf_3gpp_DiameterAddress,
        _LocationInfoWithLMSI_smsf_non_3gpp_Number,
        _LocationInfoWithLMSI_smsf_non_3gpp_DiameterAddress,
        _LocationInfoWithLMSI_smsf_3gpp_address_indicator,
        _LocationInfoWithLMSI_smsf_non_3gpp_address_indicator,
        LocationInfoWithLMSI,
        _Additional_Number_msc_Number,
        _Additional_Number_sgsn_Number,
        Additional_Number,
        _MO_ForwardSM_Arg_sm_RP_DA,
        _MO_ForwardSM_Arg_sm_RP_OA,
        _MO_ForwardSM_Arg_sm_RP_UI,
        _MO_ForwardSM_Arg_extensionContainer,
        _MO_ForwardSM_Arg_imsi,
        _MO_ForwardSM_Arg_correlationID,
        _MO_ForwardSM_Arg_sm_DeliveryOutcome,
        MO_ForwardSM_Arg,
        _MO_ForwardSM_Res_sm_RP_UI,
        _MO_ForwardSM_Res_extensionContainer,
        MO_ForwardSM_Res,
        _MT_ForwardSM_Arg_sm_RP_DA,
        _MT_ForwardSM_Arg_sm_RP_OA,
        _MT_ForwardSM_Arg_sm_RP_UI,
        _MT_ForwardSM_Arg_moreMessagesToSend,
        _MT_ForwardSM_Arg_extensionContainer,
        _MT_ForwardSM_Arg_smDeliveryTimer,
        _MT_ForwardSM_Arg_smDeliveryStartTime,
        _MT_ForwardSM_Arg_smsOverIP_OnlyIndicator,
        _MT_ForwardSM_Arg_correlationID,
        _MT_ForwardSM_Arg_maximumRetransmissionTime,
        _MT_ForwardSM_Arg_smsGmscAddress,
        _MT_ForwardSM_Arg_smsGmscDiameterAddress,
        MT_ForwardSM_Arg,
        _CorrelationID_hlr_id,
        _CorrelationID_sip_uri_A,
        _CorrelationID_sip_uri_B,
        CorrelationID,
        SIP_URI,
        _MT_ForwardSM_Res_sm_RP_UI,
        _MT_ForwardSM_Res_extensionContainer,
        MT_ForwardSM_Res,
        _SM_RP_DA_imsi,
        _SM_RP_DA_lmsi,
        _SM_RP_DA_serviceCentreAddressDA,
        _SM_RP_DA_noSM_RP_DA,
        SM_RP_DA,
        _SM_RP_OA_msisdn,
        _SM_RP_OA_serviceCentreAddressOA,
        _SM_RP_OA_noSM_RP_OA,
        SM_RP_OA,
        SM_DeliveryTimerValue,
        _ReportSM_DeliveryStatusArg_msisdn,
        _ReportSM_DeliveryStatusArg_serviceCentreAddress,
        _ReportSM_DeliveryStatusArg_sm_DeliveryOutcome,
        _ReportSM_DeliveryStatusArg_absentSubscriberDiagnosticSM,
        _ReportSM_DeliveryStatusArg_extensionContainer,
        _ReportSM_DeliveryStatusArg_gprsSupportIndicator,
        _ReportSM_DeliveryStatusArg_deliveryOutcomeIndicator,
        _ReportSM_DeliveryStatusArg_additionalSM_DeliveryOutcome,
        _ReportSM_DeliveryStatusArg_additionalAbsentSubscriberDiagnosticSM,
        _ReportSM_DeliveryStatusArg_ip_sm_gw_Indicator,
        _ReportSM_DeliveryStatusArg_ip_sm_gw_sm_deliveryOutcome,
        _ReportSM_DeliveryStatusArg_ip_sm_gw_absentSubscriberDiagnosticSM,
        _ReportSM_DeliveryStatusArg_imsi,
        _ReportSM_DeliveryStatusArg_singleAttemptDelivery,
        _ReportSM_DeliveryStatusArg_correlationID,
        _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcomeIndicator,
        _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcome,
        _ReportSM_DeliveryStatusArg_smsf_3gpp_absentSubscriberDiagSM,
        _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcomeIndicator,
        _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcome,
        _ReportSM_DeliveryStatusArg_smsf_non_3gpp_absentSubscriberDiagSM,
        ReportSM_DeliveryStatusArg,
        SM_DeliveryOutcome,
        _ReportSM_DeliveryStatusRes_storedMSISDN,
        _ReportSM_DeliveryStatusRes_extensionContainer,
        ReportSM_DeliveryStatusRes,
        _AlertServiceCentreArg_msisdn,
        _AlertServiceCentreArg_serviceCentreAddress,
        _AlertServiceCentreArg_imsi,
        _AlertServiceCentreArg_correlationID,
        _AlertServiceCentreArg_maximumUeAvailabilityTime,
        _AlertServiceCentreArg_smsGmscAlertEvent,
        _AlertServiceCentreArg_smsGmscDiameterAddress,
        _AlertServiceCentreArg_newSGSNNumber,
        _AlertServiceCentreArg_newSGSNDiameterAddress,
        _AlertServiceCentreArg_newMMENumber,
        _AlertServiceCentreArg_newMMEDiameterAddress,
        _AlertServiceCentreArg_newMSCNumber,
        AlertServiceCentreArg,
        SmsGmsc_Alert_Event,
        _InformServiceCentreArg_storedMSISDN,
        _InformServiceCentreArg_mw_Status,
        _InformServiceCentreArg_extensionContainer,
        _InformServiceCentreArg_absentSubscriberDiagnosticSM,
        _InformServiceCentreArg_additionalAbsentSubscriberDiagnosticSM,
        _InformServiceCentreArg_smsf3gppAbsentSubscriberDiagnosticSM,
        _InformServiceCentreArg_smsfNon3gppAbsentSubscriberDiagnosticSM,
        InformServiceCentreArg,
        MW_Status,
        _ReadyForSM_Arg_imsi,
        _ReadyForSM_Arg_alertReason,
        _ReadyForSM_Arg_alertReasonIndicator,
        _ReadyForSM_Arg_extensionContainer,
        _ReadyForSM_Arg_additionalAlertReasonIndicator,
        _ReadyForSM_Arg_maximumUeAvailabilityTime,
        ReadyForSM_Arg,
        _ReadyForSM_Res_extensionContainer,
        ReadyForSM_Res,
        AlertReason,
        _MT_ForwardSM_VGCS_Arg_asciCallReference,
        _MT_ForwardSM_VGCS_Arg_sm_RP_OA,
        _MT_ForwardSM_VGCS_Arg_sm_RP_UI,
        _MT_ForwardSM_VGCS_Arg_extensionContainer,
        MT_ForwardSM_VGCS_Arg,
        _MT_ForwardSM_VGCS_Res_sm_RP_UI,
        _MT_ForwardSM_VGCS_Res_dispatcherList,
        _MT_ForwardSM_VGCS_Res_ongoingCall,
        _MT_ForwardSM_VGCS_Res_extensionContainer,
        _MT_ForwardSM_VGCS_Res_additionalDispatcherList,
        MT_ForwardSM_VGCS_Res,
        _DispatcherList__item_,
        DispatcherList,
        maxNumOfDispatchers,
        _AdditionalDispatcherList__item_,
        AdditionalDispatcherList,
        maxNumOfAdditionalDispatchers,
    ]

class MAP_SS_Code:

    _name_  = 'MAP-SS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 15, 19]
    
    _obj_ = [
        'SS-Code',
        'allSS',
        'allLineIdentificationSS',
        'clip',
        'clir',
        'colp',
        'colr',
        'mci',
        'allNameIdentificationSS',
        'cnap',
        'allForwardingSS',
        'cfu',
        'allCondForwardingSS',
        'cfb',
        'cfnry',
        'cfnrc',
        'cd',
        'allCallOfferingSS',
        'ect',
        'mah',
        'allCallCompletionSS',
        'cw',
        'hold',
        'ccbs-A',
        'ccbs-B',
        'mc',
        'allMultiPartySS',
        'multiPTY',
        'allCommunityOfInterest-SS',
        'cug',
        'allChargingSS',
        'aoci',
        'aocc',
        'allAdditionalInfoTransferSS',
        'uus1',
        'uus2',
        'uus3',
        'allBarringSS',
        'barringOfOutgoingCalls',
        'baoc',
        'boic',
        'boicExHC',
        'barringOfIncomingCalls',
        'baic',
        'bicRoam',
        'allPLMN-specificSS',
        'plmn-specificSS-1',
        'plmn-specificSS-2',
        'plmn-specificSS-3',
        'plmn-specificSS-4',
        'plmn-specificSS-5',
        'plmn-specificSS-6',
        'plmn-specificSS-7',
        'plmn-specificSS-8',
        'plmn-specificSS-9',
        'plmn-specificSS-A',
        'plmn-specificSS-B',
        'plmn-specificSS-C',
        'plmn-specificSS-D',
        'plmn-specificSS-E',
        'plmn-specificSS-F',
        'allCallPrioritySS',
        'emlpp',
        'allLCSPrivacyException',
        'universal',
        'callSessionRelated',
        'callSessionUnrelated',
        'plmnoperator',
        'serviceType',
        'allMOLR-SS',
        'basicSelfLocation',
        'autonomousSelfLocation',
        'transferToThirdParty',
        ]
    _type_ = [
        'SS-Code',
        ]
    _set_ = [
        ]
    _val_ = [
        'allSS',
        'allLineIdentificationSS',
        'clip',
        'clir',
        'colp',
        'colr',
        'mci',
        'allNameIdentificationSS',
        'cnap',
        'allForwardingSS',
        'cfu',
        'allCondForwardingSS',
        'cfb',
        'cfnry',
        'cfnrc',
        'cd',
        'allCallOfferingSS',
        'ect',
        'mah',
        'allCallCompletionSS',
        'cw',
        'hold',
        'ccbs-A',
        'ccbs-B',
        'mc',
        'allMultiPartySS',
        'multiPTY',
        'allCommunityOfInterest-SS',
        'cug',
        'allChargingSS',
        'aoci',
        'aocc',
        'allAdditionalInfoTransferSS',
        'uus1',
        'uus2',
        'uus3',
        'allBarringSS',
        'barringOfOutgoingCalls',
        'baoc',
        'boic',
        'boicExHC',
        'barringOfIncomingCalls',
        'baic',
        'bicRoam',
        'allPLMN-specificSS',
        'plmn-specificSS-1',
        'plmn-specificSS-2',
        'plmn-specificSS-3',
        'plmn-specificSS-4',
        'plmn-specificSS-5',
        'plmn-specificSS-6',
        'plmn-specificSS-7',
        'plmn-specificSS-8',
        'plmn-specificSS-9',
        'plmn-specificSS-A',
        'plmn-specificSS-B',
        'plmn-specificSS-C',
        'plmn-specificSS-D',
        'plmn-specificSS-E',
        'plmn-specificSS-F',
        'allCallPrioritySS',
        'emlpp',
        'allLCSPrivacyException',
        'universal',
        'callSessionRelated',
        'callSessionUnrelated',
        'plmnoperator',
        'serviceType',
        'allMOLR-SS',
        'basicSelfLocation',
        'autonomousSelfLocation',
        'transferToThirdParty',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SS-Code >-----#
    SS_Code = OCT_STR(name='SS-Code', mode=MODE_TYPE)
    SS_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< allSS >-----#
    allSS = OCT_STR(name='allSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allSS._val = b'\x00'
    
    #-----< allLineIdentificationSS >-----#
    allLineIdentificationSS = OCT_STR(name='allLineIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLineIdentificationSS._val = b'\x10'
    
    #-----< clip >-----#
    clip = OCT_STR(name='clip', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clip._val = b'\x11'
    
    #-----< clir >-----#
    clir = OCT_STR(name='clir', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clir._val = b'\x12'
    
    #-----< colp >-----#
    colp = OCT_STR(name='colp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colp._val = b'\x13'
    
    #-----< colr >-----#
    colr = OCT_STR(name='colr', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colr._val = b'\x14'
    
    #-----< mci >-----#
    mci = OCT_STR(name='mci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mci._val = b'\x15'
    
    #-----< allNameIdentificationSS >-----#
    allNameIdentificationSS = OCT_STR(name='allNameIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allNameIdentificationSS._val = b'\x18'
    
    #-----< cnap >-----#
    cnap = OCT_STR(name='cnap', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cnap._val = b'\x19'
    
    #-----< allForwardingSS >-----#
    allForwardingSS = OCT_STR(name='allForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allForwardingSS._val = b' '
    
    #-----< cfu >-----#
    cfu = OCT_STR(name='cfu', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfu._val = b'!'
    
    #-----< allCondForwardingSS >-----#
    allCondForwardingSS = OCT_STR(name='allCondForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCondForwardingSS._val = b'('
    
    #-----< cfb >-----#
    cfb = OCT_STR(name='cfb', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfb._val = b')'
    
    #-----< cfnry >-----#
    cfnry = OCT_STR(name='cfnry', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnry._val = b'*'
    
    #-----< cfnrc >-----#
    cfnrc = OCT_STR(name='cfnrc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnrc._val = b'+'
    
    #-----< cd >-----#
    cd = OCT_STR(name='cd', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cd._val = b'$'
    
    #-----< allCallOfferingSS >-----#
    allCallOfferingSS = OCT_STR(name='allCallOfferingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallOfferingSS._val = b'0'
    
    #-----< ect >-----#
    ect = OCT_STR(name='ect', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ect._val = b'1'
    
    #-----< mah >-----#
    mah = OCT_STR(name='mah', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mah._val = b'2'
    
    #-----< allCallCompletionSS >-----#
    allCallCompletionSS = OCT_STR(name='allCallCompletionSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallCompletionSS._val = b'@'
    
    #-----< cw >-----#
    cw = OCT_STR(name='cw', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cw._val = b'A'
    
    #-----< hold >-----#
    hold = OCT_STR(name='hold', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    hold._val = b'B'
    
    #-----< ccbs-A >-----#
    ccbs_A = OCT_STR(name='ccbs-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_A._val = b'C'
    
    #-----< ccbs-B >-----#
    ccbs_B = OCT_STR(name='ccbs-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_B._val = b'D'
    
    #-----< mc >-----#
    mc = OCT_STR(name='mc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mc._val = b'E'
    
    #-----< allMultiPartySS >-----#
    allMultiPartySS = OCT_STR(name='allMultiPartySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMultiPartySS._val = b'P'
    
    #-----< multiPTY >-----#
    multiPTY = OCT_STR(name='multiPTY', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    multiPTY._val = b'Q'
    
    #-----< allCommunityOfInterest-SS >-----#
    allCommunityOfInterest_SS = OCT_STR(name='allCommunityOfInterest-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCommunityOfInterest_SS._val = b'`'
    
    #-----< cug >-----#
    cug = OCT_STR(name='cug', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cug._val = b'a'
    
    #-----< allChargingSS >-----#
    allChargingSS = OCT_STR(name='allChargingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allChargingSS._val = b'p'
    
    #-----< aoci >-----#
    aoci = OCT_STR(name='aoci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aoci._val = b'q'
    
    #-----< aocc >-----#
    aocc = OCT_STR(name='aocc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aocc._val = b'r'
    
    #-----< allAdditionalInfoTransferSS >-----#
    allAdditionalInfoTransferSS = OCT_STR(name='allAdditionalInfoTransferSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allAdditionalInfoTransferSS._val = b'\x80'
    
    #-----< uus1 >-----#
    uus1 = OCT_STR(name='uus1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus1._val = b'\x81'
    
    #-----< uus2 >-----#
    uus2 = OCT_STR(name='uus2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus2._val = b'\x82'
    
    #-----< uus3 >-----#
    uus3 = OCT_STR(name='uus3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus3._val = b'\x83'
    
    #-----< allBarringSS >-----#
    allBarringSS = OCT_STR(name='allBarringSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allBarringSS._val = b'\x90'
    
    #-----< barringOfOutgoingCalls >-----#
    barringOfOutgoingCalls = OCT_STR(name='barringOfOutgoingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfOutgoingCalls._val = b'\x91'
    
    #-----< baoc >-----#
    baoc = OCT_STR(name='baoc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baoc._val = b'\x92'
    
    #-----< boic >-----#
    boic = OCT_STR(name='boic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boic._val = b'\x93'
    
    #-----< boicExHC >-----#
    boicExHC = OCT_STR(name='boicExHC', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boicExHC._val = b'\x94'
    
    #-----< barringOfIncomingCalls >-----#
    barringOfIncomingCalls = OCT_STR(name='barringOfIncomingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfIncomingCalls._val = b'\x99'
    
    #-----< baic >-----#
    baic = OCT_STR(name='baic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baic._val = b'\x9a'
    
    #-----< bicRoam >-----#
    bicRoam = OCT_STR(name='bicRoam', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    bicRoam._val = b'\x9b'
    
    #-----< allPLMN-specificSS >-----#
    allPLMN_specificSS = OCT_STR(name='allPLMN-specificSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allPLMN_specificSS._val = b'\xf0'
    
    #-----< plmn-specificSS-1 >-----#
    plmn_specificSS_1 = OCT_STR(name='plmn-specificSS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_1._val = b'\xf1'
    
    #-----< plmn-specificSS-2 >-----#
    plmn_specificSS_2 = OCT_STR(name='plmn-specificSS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_2._val = b'\xf2'
    
    #-----< plmn-specificSS-3 >-----#
    plmn_specificSS_3 = OCT_STR(name='plmn-specificSS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_3._val = b'\xf3'
    
    #-----< plmn-specificSS-4 >-----#
    plmn_specificSS_4 = OCT_STR(name='plmn-specificSS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_4._val = b'\xf4'
    
    #-----< plmn-specificSS-5 >-----#
    plmn_specificSS_5 = OCT_STR(name='plmn-specificSS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_5._val = b'\xf5'
    
    #-----< plmn-specificSS-6 >-----#
    plmn_specificSS_6 = OCT_STR(name='plmn-specificSS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_6._val = b'\xf6'
    
    #-----< plmn-specificSS-7 >-----#
    plmn_specificSS_7 = OCT_STR(name='plmn-specificSS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_7._val = b'\xf7'
    
    #-----< plmn-specificSS-8 >-----#
    plmn_specificSS_8 = OCT_STR(name='plmn-specificSS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_8._val = b'\xf8'
    
    #-----< plmn-specificSS-9 >-----#
    plmn_specificSS_9 = OCT_STR(name='plmn-specificSS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_9._val = b'\xf9'
    
    #-----< plmn-specificSS-A >-----#
    plmn_specificSS_A = OCT_STR(name='plmn-specificSS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_A._val = b'\xfa'
    
    #-----< plmn-specificSS-B >-----#
    plmn_specificSS_B = OCT_STR(name='plmn-specificSS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_B._val = b'\xfb'
    
    #-----< plmn-specificSS-C >-----#
    plmn_specificSS_C = OCT_STR(name='plmn-specificSS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_C._val = b'\xfc'
    
    #-----< plmn-specificSS-D >-----#
    plmn_specificSS_D = OCT_STR(name='plmn-specificSS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_D._val = b'\xfd'
    
    #-----< plmn-specificSS-E >-----#
    plmn_specificSS_E = OCT_STR(name='plmn-specificSS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_E._val = b'\xfe'
    
    #-----< plmn-specificSS-F >-----#
    plmn_specificSS_F = OCT_STR(name='plmn-specificSS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_F._val = b'\xff'
    
    #-----< allCallPrioritySS >-----#
    allCallPrioritySS = OCT_STR(name='allCallPrioritySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallPrioritySS._val = b'\xa0'
    
    #-----< emlpp >-----#
    emlpp = OCT_STR(name='emlpp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    emlpp._val = b'\xa1'
    
    #-----< allLCSPrivacyException >-----#
    allLCSPrivacyException = OCT_STR(name='allLCSPrivacyException', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLCSPrivacyException._val = b'\xb0'
    
    #-----< universal >-----#
    universal = OCT_STR(name='universal', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    universal._val = b'\xb1'
    
    #-----< callSessionRelated >-----#
    callSessionRelated = OCT_STR(name='callSessionRelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionRelated._val = b'\xb2'
    
    #-----< callSessionUnrelated >-----#
    callSessionUnrelated = OCT_STR(name='callSessionUnrelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionUnrelated._val = b'\xb3'
    
    #-----< plmnoperator >-----#
    plmnoperator = OCT_STR(name='plmnoperator', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmnoperator._val = b'\xb4'
    
    #-----< serviceType >-----#
    serviceType = OCT_STR(name='serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    serviceType._val = b'\xb5'
    
    #-----< allMOLR-SS >-----#
    allMOLR_SS = OCT_STR(name='allMOLR-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMOLR_SS._val = b'\xc0'
    
    #-----< basicSelfLocation >-----#
    basicSelfLocation = OCT_STR(name='basicSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    basicSelfLocation._val = b'\xc1'
    
    #-----< autonomousSelfLocation >-----#
    autonomousSelfLocation = OCT_STR(name='autonomousSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    autonomousSelfLocation._val = b'\xc2'
    
    #-----< transferToThirdParty >-----#
    transferToThirdParty = OCT_STR(name='transferToThirdParty', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    transferToThirdParty._val = b'\xc3'
    
    _all_ = [
        SS_Code,
        allSS,
        allLineIdentificationSS,
        clip,
        clir,
        colp,
        colr,
        mci,
        allNameIdentificationSS,
        cnap,
        allForwardingSS,
        cfu,
        allCondForwardingSS,
        cfb,
        cfnry,
        cfnrc,
        cd,
        allCallOfferingSS,
        ect,
        mah,
        allCallCompletionSS,
        cw,
        hold,
        ccbs_A,
        ccbs_B,
        mc,
        allMultiPartySS,
        multiPTY,
        allCommunityOfInterest_SS,
        cug,
        allChargingSS,
        aoci,
        aocc,
        allAdditionalInfoTransferSS,
        uus1,
        uus2,
        uus3,
        allBarringSS,
        barringOfOutgoingCalls,
        baoc,
        boic,
        boicExHC,
        barringOfIncomingCalls,
        baic,
        bicRoam,
        allPLMN_specificSS,
        plmn_specificSS_1,
        plmn_specificSS_2,
        plmn_specificSS_3,
        plmn_specificSS_4,
        plmn_specificSS_5,
        plmn_specificSS_6,
        plmn_specificSS_7,
        plmn_specificSS_8,
        plmn_specificSS_9,
        plmn_specificSS_A,
        plmn_specificSS_B,
        plmn_specificSS_C,
        plmn_specificSS_D,
        plmn_specificSS_E,
        plmn_specificSS_F,
        allCallPrioritySS,
        emlpp,
        allLCSPrivacyException,
        universal,
        callSessionRelated,
        callSessionUnrelated,
        plmnoperator,
        serviceType,
        allMOLR_SS,
        basicSelfLocation,
        autonomousSelfLocation,
        transferToThirdParty,
    ]

class MAP_SS_DataTypes:

    _name_  = 'MAP-SS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 14, 19]
    
    _obj_ = [
        'RegisterSS-Arg',
        'NoReplyConditionTime',
        'SS-Info',
        'ForwardingInfo',
        'ForwardingFeatureList',
        'ForwardingFeature',
        'SS-Status',
        'ForwardingOptions',
        'CallBarringInfo',
        'CallBarringFeatureList',
        'CallBarringFeature',
        'SS-Data',
        'SS-SubscriptionOption',
        'CliRestrictionOption',
        'OverrideCategory',
        'SS-ForBS-Code',
        'GenericServiceInfo',
        'CCBS-FeatureList',
        'maxNumOfCCBS-Requests',
        'CCBS-Feature',
        'CCBS-Index',
        'InterrogateSS-Res',
        'USSD-Arg',
        'USSD-Res',
        'USSD-DataCodingScheme',
        'USSD-String',
        'maxUSSD-StringLength',
        'Password',
        'GuidanceInfo',
        'SS-List',
        'maxNumOfSS',
        'SS-InfoList',
        'BasicServiceGroupList',
        'maxNumOfBasicServiceGroups',
        'SS-InvocationNotificationArg',
        'CCBS-RequestState',
        'SS-InvocationNotificationRes',
        'SS-EventSpecification',
        'maxEventSpecification',
        'RegisterCC-EntryArg',
        'CCBS-Data',
        'ServiceIndicator',
        'RegisterCC-EntryRes',
        'EraseCC-EntryArg',
        'EraseCC-EntryRes',
        ]
    _type_ = [
        'RegisterSS-Arg',
        'NoReplyConditionTime',
        'SS-Info',
        'ForwardingInfo',
        'ForwardingFeatureList',
        'ForwardingFeature',
        'SS-Status',
        'ForwardingOptions',
        'CallBarringInfo',
        'CallBarringFeatureList',
        'CallBarringFeature',
        'SS-Data',
        'SS-SubscriptionOption',
        'CliRestrictionOption',
        'OverrideCategory',
        'SS-ForBS-Code',
        'GenericServiceInfo',
        'CCBS-FeatureList',
        'CCBS-Feature',
        'CCBS-Index',
        'InterrogateSS-Res',
        'USSD-Arg',
        'USSD-Res',
        'USSD-DataCodingScheme',
        'USSD-String',
        'Password',
        'GuidanceInfo',
        'SS-List',
        'SS-InfoList',
        'BasicServiceGroupList',
        'SS-InvocationNotificationArg',
        'CCBS-RequestState',
        'SS-InvocationNotificationRes',
        'SS-EventSpecification',
        'RegisterCC-EntryArg',
        'CCBS-Data',
        'ServiceIndicator',
        'RegisterCC-EntryRes',
        'EraseCC-EntryArg',
        'EraseCC-EntryRes',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxNumOfCCBS-Requests',
        'maxUSSD-StringLength',
        'maxNumOfSS',
        'maxNumOfBasicServiceGroups',
        'maxEventSpecification',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RegisterSS-Arg >-----#
    RegisterSS_Arg = SEQ(name='RegisterSS-Arg', mode=MODE_TYPE)
    _RegisterSS_Arg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterSS_Arg_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _RegisterSS_Arg_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _RegisterSS_Arg_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _RegisterSS_Arg_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _RegisterSS_Arg_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _RegisterSS_Arg_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _RegisterSS_Arg_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RegisterSS_Arg._cont = ASN1Dict([
        ('ss-Code', _RegisterSS_Arg_ss_Code),
        ('basicService', _RegisterSS_Arg_basicService),
        ('forwardedToNumber', _RegisterSS_Arg_forwardedToNumber),
        ('forwardedToSubaddress', _RegisterSS_Arg_forwardedToSubaddress),
        ('noReplyConditionTime', _RegisterSS_Arg_noReplyConditionTime),
        ('defaultPriority', _RegisterSS_Arg_defaultPriority),
        ('nbrUser', _RegisterSS_Arg_nbrUser),
        ('longFTN-Supported', _RegisterSS_Arg_longFTN_Supported),
        ])
    RegisterSS_Arg._ext = ['defaultPriority', 'nbrUser', 'longFTN-Supported']
    
    #-----< NoReplyConditionTime >-----#
    NoReplyConditionTime = INT(name='NoReplyConditionTime', mode=MODE_TYPE)
    NoReplyConditionTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=30)], ev=None, er=[])
    
    #-----< SS-Info >-----#
    SS_Info = CHOICE(name='SS-Info', mode=MODE_TYPE)
    _SS_Info_forwardingInfo = SEQ(name='forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingInfo')))
    _SS_Info_callBarringInfo = SEQ(name='callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringInfo')))
    _SS_Info_ss_Data = SEQ(name='ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Data')))
    SS_Info._cont = ASN1Dict([
        ('forwardingInfo', _SS_Info_forwardingInfo),
        ('callBarringInfo', _SS_Info_callBarringInfo),
        ('ss-Data', _SS_Info_ss_Data),
        ])
    SS_Info._ext = None
    
    #-----< ForwardingInfo >-----#
    ForwardingInfo = SEQ(name='ForwardingInfo', mode=MODE_TYPE)
    _ForwardingInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _ForwardingInfo_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    ForwardingInfo._cont = ASN1Dict([
        ('ss-Code', _ForwardingInfo_ss_Code),
        ('forwardingFeatureList', _ForwardingInfo_forwardingFeatureList),
        ])
    ForwardingInfo._ext = []
    
    #-----< ForwardingFeatureList >-----#
    ForwardingFeatureList = SEQ_OF(name='ForwardingFeatureList', mode=MODE_TYPE)
    _ForwardingFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeature')))
    ForwardingFeatureList._cont = _ForwardingFeatureList__item_
    ForwardingFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< ForwardingFeature >-----#
    ForwardingFeature = SEQ(name='ForwardingFeature', mode=MODE_TYPE)
    _ForwardingFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _ForwardingFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _ForwardingFeature_forwardedToNumber = OCT_STR(name='forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingFeature_forwardedToSubaddress = OCT_STR(name='forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingFeature_forwardingOptions = OCT_STR(name='forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingFeature_noReplyConditionTime = INT(name='noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _ForwardingFeature_longForwardedToNumber = OCT_STR(name='longForwardedToNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingFeature._cont = ASN1Dict([
        ('basicService', _ForwardingFeature_basicService),
        ('ss-Status', _ForwardingFeature_ss_Status),
        ('forwardedToNumber', _ForwardingFeature_forwardedToNumber),
        ('forwardedToSubaddress', _ForwardingFeature_forwardedToSubaddress),
        ('forwardingOptions', _ForwardingFeature_forwardingOptions),
        ('noReplyConditionTime', _ForwardingFeature_noReplyConditionTime),
        ('longForwardedToNumber', _ForwardingFeature_longForwardedToNumber),
        ])
    ForwardingFeature._ext = ['longForwardedToNumber']
    
    #-----< SS-Status >-----#
    SS_Status = OCT_STR(name='SS-Status', mode=MODE_TYPE)
    SS_Status._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ForwardingOptions >-----#
    ForwardingOptions = OCT_STR(name='ForwardingOptions', mode=MODE_TYPE)
    ForwardingOptions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< CallBarringInfo >-----#
    CallBarringInfo = SEQ(name='CallBarringInfo', mode=MODE_TYPE)
    _CallBarringInfo_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _CallBarringInfo_callBarringFeatureList = SEQ_OF(name='callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeatureList')))
    CallBarringInfo._cont = ASN1Dict([
        ('ss-Code', _CallBarringInfo_ss_Code),
        ('callBarringFeatureList', _CallBarringInfo_callBarringFeatureList),
        ])
    CallBarringInfo._ext = []
    
    #-----< CallBarringFeatureList >-----#
    CallBarringFeatureList = SEQ_OF(name='CallBarringFeatureList', mode=MODE_TYPE)
    _CallBarringFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeature')))
    CallBarringFeatureList._cont = _CallBarringFeatureList__item_
    CallBarringFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< CallBarringFeature >-----#
    CallBarringFeature = SEQ(name='CallBarringFeature', mode=MODE_TYPE)
    _CallBarringFeature_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _CallBarringFeature_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    CallBarringFeature._cont = ASN1Dict([
        ('basicService', _CallBarringFeature_basicService),
        ('ss-Status', _CallBarringFeature_ss_Status),
        ])
    CallBarringFeature._ext = []
    
    #-----< SS-Data >-----#
    SS_Data = SEQ(name='SS-Data', mode=MODE_TYPE)
    _SS_Data_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_Data_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _SS_Data_ss_SubscriptionOption = CHOICE(name='ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _SS_Data_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')), opt=True)
    _SS_Data_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _SS_Data_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    SS_Data._cont = ASN1Dict([
        ('ss-Code', _SS_Data_ss_Code),
        ('ss-Status', _SS_Data_ss_Status),
        ('ss-SubscriptionOption', _SS_Data_ss_SubscriptionOption),
        ('basicServiceGroupList', _SS_Data_basicServiceGroupList),
        ('defaultPriority', _SS_Data_defaultPriority),
        ('nbrUser', _SS_Data_nbrUser),
        ])
    SS_Data._ext = ['defaultPriority', 'nbrUser']
    
    #-----< SS-SubscriptionOption >-----#
    SS_SubscriptionOption = CHOICE(name='SS-SubscriptionOption', mode=MODE_TYPE)
    _SS_SubscriptionOption_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')))
    _SS_SubscriptionOption_overrideCategory = ENUM(name='overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    SS_SubscriptionOption._cont = ASN1Dict([
        ('cliRestrictionOption', _SS_SubscriptionOption_cliRestrictionOption),
        ('overrideCategory', _SS_SubscriptionOption_overrideCategory),
        ])
    SS_SubscriptionOption._ext = None
    
    #-----< CliRestrictionOption >-----#
    CliRestrictionOption = ENUM(name='CliRestrictionOption', mode=MODE_TYPE)
    CliRestrictionOption._cont = ASN1Dict([('permanent', 0), ('temporaryDefaultRestricted', 1), ('temporaryDefaultAllowed', 2)])
    CliRestrictionOption._ext = None
    
    #-----< OverrideCategory >-----#
    OverrideCategory = ENUM(name='OverrideCategory', mode=MODE_TYPE)
    OverrideCategory._cont = ASN1Dict([('overrideEnabled', 0), ('overrideDisabled', 1)])
    OverrideCategory._ext = None
    
    #-----< SS-ForBS-Code >-----#
    SS_ForBS_Code = SEQ(name='SS-ForBS-Code', mode=MODE_TYPE)
    _SS_ForBS_Code_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_ForBS_Code_basicService = CHOICE(name='basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_ForBS_Code_longFTN_Supported = NULL(name='longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_ForBS_Code._cont = ASN1Dict([
        ('ss-Code', _SS_ForBS_Code_ss_Code),
        ('basicService', _SS_ForBS_Code_basicService),
        ('longFTN-Supported', _SS_ForBS_Code_longFTN_Supported),
        ])
    SS_ForBS_Code._ext = ['longFTN-Supported']
    
    #-----< GenericServiceInfo >-----#
    GenericServiceInfo = SEQ(name='GenericServiceInfo', mode=MODE_TYPE)
    _GenericServiceInfo_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _GenericServiceInfo_cliRestrictionOption = ENUM(name='cliRestrictionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _GenericServiceInfo_maximumEntitledPriority = INT(name='maximumEntitledPriority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_defaultPriority = INT(name='defaultPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_ccbs_FeatureList = SEQ_OF(name='ccbs-FeatureList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-FeatureList')), opt=True)
    _GenericServiceInfo_nbrSB = INT(name='nbrSB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')), opt=True)
    _GenericServiceInfo_nbrUser = INT(name='nbrUser', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _GenericServiceInfo_nbrSN = INT(name='nbrSN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    GenericServiceInfo._cont = ASN1Dict([
        ('ss-Status', _GenericServiceInfo_ss_Status),
        ('cliRestrictionOption', _GenericServiceInfo_cliRestrictionOption),
        ('maximumEntitledPriority', _GenericServiceInfo_maximumEntitledPriority),
        ('defaultPriority', _GenericServiceInfo_defaultPriority),
        ('ccbs-FeatureList', _GenericServiceInfo_ccbs_FeatureList),
        ('nbrSB', _GenericServiceInfo_nbrSB),
        ('nbrUser', _GenericServiceInfo_nbrUser),
        ('nbrSN', _GenericServiceInfo_nbrSN),
        ])
    GenericServiceInfo._ext = ['maximumEntitledPriority', 'defaultPriority', 'ccbs-FeatureList', 'nbrSB', 'nbrUser', 'nbrSN']
    
    #-----< CCBS-FeatureList >-----#
    CCBS_FeatureList = SEQ_OF(name='CCBS-FeatureList', mode=MODE_TYPE)
    _CCBS_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    CCBS_FeatureList._cont = _CCBS_FeatureList__item_
    CCBS_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCCBS-Requests >-----#
    maxNumOfCCBS_Requests = INT(name='maxNumOfCCBS-Requests', mode=MODE_VALUE)
    maxNumOfCCBS_Requests._val = 5
    
    #-----< CCBS-Feature >-----#
    CCBS_Feature = SEQ(name='CCBS-Feature', mode=MODE_TYPE)
    _CCBS_Feature_ccbs_Index = INT(name='ccbs-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    _CCBS_Feature_b_subscriberNumber = OCT_STR(name='b-subscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CCBS_Feature_b_subscriberSubaddress = OCT_STR(name='b-subscriberSubaddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _CCBS_Feature_basicServiceGroup = CHOICE(name='basicServiceGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    CCBS_Feature._cont = ASN1Dict([
        ('ccbs-Index', _CCBS_Feature_ccbs_Index),
        ('b-subscriberNumber', _CCBS_Feature_b_subscriberNumber),
        ('b-subscriberSubaddress', _CCBS_Feature_b_subscriberSubaddress),
        ('basicServiceGroup', _CCBS_Feature_basicServiceGroup),
        ])
    CCBS_Feature._ext = []
    
    #-----< CCBS-Index >-----#
    CCBS_Index = INT(name='CCBS-Index', mode=MODE_TYPE)
    CCBS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< InterrogateSS-Res >-----#
    InterrogateSS_Res = CHOICE(name='InterrogateSS-Res', mode=MODE_TYPE)
    _InterrogateSS_Res_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _InterrogateSS_Res_basicServiceGroupList = SEQ_OF(name='basicServiceGroupList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')))
    _InterrogateSS_Res_forwardingFeatureList = SEQ_OF(name='forwardingFeatureList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    _InterrogateSS_Res_genericServiceInfo = SEQ(name='genericServiceInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'GenericServiceInfo')))
    InterrogateSS_Res._cont = ASN1Dict([
        ('ss-Status', _InterrogateSS_Res_ss_Status),
        ('basicServiceGroupList', _InterrogateSS_Res_basicServiceGroupList),
        ('forwardingFeatureList', _InterrogateSS_Res_forwardingFeatureList),
        ('genericServiceInfo', _InterrogateSS_Res_genericServiceInfo),
        ])
    InterrogateSS_Res._ext = None
    
    #-----< USSD-Arg >-----#
    USSD_Arg = SEQ(name='USSD-Arg', mode=MODE_TYPE)
    _USSD_Arg_ussd_DataCodingScheme = OCT_STR(name='ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Arg_ussd_String = OCT_STR(name='ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    _USSD_Arg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _USSD_Arg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    USSD_Arg._cont = ASN1Dict([
        ('ussd-DataCodingScheme', _USSD_Arg_ussd_DataCodingScheme),
        ('ussd-String', _USSD_Arg_ussd_String),
        ('alertingPattern', _USSD_Arg_alertingPattern),
        ('msisdn', _USSD_Arg_msisdn),
        ])
    USSD_Arg._ext = ['alertingPattern', 'msisdn']
    
    #-----< USSD-Res >-----#
    USSD_Res = SEQ(name='USSD-Res', mode=MODE_TYPE)
    _USSD_Res_ussd_DataCodingScheme = OCT_STR(name='ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Res_ussd_String = OCT_STR(name='ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    USSD_Res._cont = ASN1Dict([
        ('ussd-DataCodingScheme', _USSD_Res_ussd_DataCodingScheme),
        ('ussd-String', _USSD_Res_ussd_String),
        ])
    USSD_Res._ext = []
    
    #-----< USSD-DataCodingScheme >-----#
    USSD_DataCodingScheme = OCT_STR(name='USSD-DataCodingScheme', mode=MODE_TYPE)
    USSD_DataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< USSD-String >-----#
    USSD_String = OCT_STR(name='USSD-String', mode=MODE_TYPE)
    USSD_String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< maxUSSD-StringLength >-----#
    maxUSSD_StringLength = INT(name='maxUSSD-StringLength', mode=MODE_VALUE)
    maxUSSD_StringLength._val = 160
    
    #-----< Password >-----#
    Password = STR_NUM(name='Password', mode=MODE_TYPE)
    Password._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    Password._const_alpha = ASN1Set(rv=['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'], rr=[], ev=None, er=[])
    
    #-----< GuidanceInfo >-----#
    GuidanceInfo = ENUM(name='GuidanceInfo', mode=MODE_TYPE)
    GuidanceInfo._cont = ASN1Dict([('enterPW', 0), ('enterNewPW', 1), ('enterNewPW-Again', 2)])
    GuidanceInfo._ext = None
    
    #-----< SS-List >-----#
    SS_List = SEQ_OF(name='SS-List', mode=MODE_TYPE)
    _SS_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_List._cont = _SS_List__item_
    SS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< maxNumOfSS >-----#
    maxNumOfSS = INT(name='maxNumOfSS', mode=MODE_VALUE)
    maxNumOfSS._val = 30
    
    #-----< SS-InfoList >-----#
    SS_InfoList = SEQ_OF(name='SS-InfoList', mode=MODE_TYPE)
    _SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Info')))
    SS_InfoList._cont = _SS_InfoList__item_
    SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< BasicServiceGroupList >-----#
    BasicServiceGroupList = SEQ_OF(name='BasicServiceGroupList', mode=MODE_TYPE)
    _BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    BasicServiceGroupList._cont = _BasicServiceGroupList__item_
    BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< maxNumOfBasicServiceGroups >-----#
    maxNumOfBasicServiceGroups = INT(name='maxNumOfBasicServiceGroups', mode=MODE_VALUE)
    maxNumOfBasicServiceGroups._val = 13
    
    #-----< SS-InvocationNotificationArg >-----#
    SS_InvocationNotificationArg = SEQ(name='SS-InvocationNotificationArg', mode=MODE_TYPE)
    _SS_InvocationNotificationArg_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SS_InvocationNotificationArg_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_InvocationNotificationArg_ss_Event = OCT_STR(name='ss-Event', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_InvocationNotificationArg_ss_EventSpecification = SEQ_OF(name='ss-EventSpecification', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-EventSpecification')), opt=True)
    _SS_InvocationNotificationArg_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_InvocationNotificationArg_b_subscriberNumber = OCT_STR(name='b-subscriberNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SS_InvocationNotificationArg_ccbs_RequestState = ENUM(name='ccbs-RequestState', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-RequestState')), opt=True)
    SS_InvocationNotificationArg._cont = ASN1Dict([
        ('imsi', _SS_InvocationNotificationArg_imsi),
        ('msisdn', _SS_InvocationNotificationArg_msisdn),
        ('ss-Event', _SS_InvocationNotificationArg_ss_Event),
        ('ss-EventSpecification', _SS_InvocationNotificationArg_ss_EventSpecification),
        ('extensionContainer', _SS_InvocationNotificationArg_extensionContainer),
        ('b-subscriberNumber', _SS_InvocationNotificationArg_b_subscriberNumber),
        ('ccbs-RequestState', _SS_InvocationNotificationArg_ccbs_RequestState),
        ])
    SS_InvocationNotificationArg._ext = ['b-subscriberNumber', 'ccbs-RequestState']
    
    #-----< CCBS-RequestState >-----#
    CCBS_RequestState = ENUM(name='CCBS-RequestState', mode=MODE_TYPE)
    CCBS_RequestState._cont = ASN1Dict([('request', 0), ('recall', 1), ('active', 2), ('completed', 3), ('suspended', 4), ('frozen', 5), ('deleted', 6)])
    CCBS_RequestState._ext = None
    
    #-----< SS-InvocationNotificationRes >-----#
    SS_InvocationNotificationRes = SEQ(name='SS-InvocationNotificationRes', mode=MODE_TYPE)
    _SS_InvocationNotificationRes_extensionContainer = SEQ(name='extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_InvocationNotificationRes._cont = ASN1Dict([
        ('extensionContainer', _SS_InvocationNotificationRes_extensionContainer),
        ])
    SS_InvocationNotificationRes._ext = []
    
    #-----< SS-EventSpecification >-----#
    SS_EventSpecification = SEQ_OF(name='SS-EventSpecification', mode=MODE_TYPE)
    _SS_EventSpecification__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SS_EventSpecification._cont = _SS_EventSpecification__item_
    SS_EventSpecification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< maxEventSpecification >-----#
    maxEventSpecification = INT(name='maxEventSpecification', mode=MODE_VALUE)
    maxEventSpecification._val = 2
    
    #-----< RegisterCC-EntryArg >-----#
    RegisterCC_EntryArg = SEQ(name='RegisterCC-EntryArg', mode=MODE_TYPE)
    _RegisterCC_EntryArg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterCC_EntryArg_ccbs_Data = SEQ(name='ccbs-Data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Data')), opt=True)
    RegisterCC_EntryArg._cont = ASN1Dict([
        ('ss-Code', _RegisterCC_EntryArg_ss_Code),
        ('ccbs-Data', _RegisterCC_EntryArg_ccbs_Data),
        ])
    RegisterCC_EntryArg._ext = []
    
    #-----< CCBS-Data >-----#
    CCBS_Data = SEQ(name='CCBS-Data', mode=MODE_TYPE)
    _CCBS_Data_ccbs_Feature = SEQ(name='ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _CCBS_Data_translatedB_Number = OCT_STR(name='translatedB-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _CCBS_Data_serviceIndicator = BIT_STR(name='serviceIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ServiceIndicator')), opt=True)
    _CCBS_Data_callInfo = SEQ(name='callInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _CCBS_Data_networkSignalInfo = SEQ(name='networkSignalInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    CCBS_Data._cont = ASN1Dict([
        ('ccbs-Feature', _CCBS_Data_ccbs_Feature),
        ('translatedB-Number', _CCBS_Data_translatedB_Number),
        ('serviceIndicator', _CCBS_Data_serviceIndicator),
        ('callInfo', _CCBS_Data_callInfo),
        ('networkSignalInfo', _CCBS_Data_networkSignalInfo),
        ])
    CCBS_Data._ext = []
    
    #-----< ServiceIndicator >-----#
    ServiceIndicator = BIT_STR(name='ServiceIndicator', mode=MODE_TYPE)
    ServiceIndicator._cont = ASN1Dict([('clir-invoked', 0), ('camel-invoked', 1)])
    ServiceIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    
    #-----< RegisterCC-EntryRes >-----#
    RegisterCC_EntryRes = SEQ(name='RegisterCC-EntryRes', mode=MODE_TYPE)
    _RegisterCC_EntryRes_ccbs_Feature = SEQ(name='ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')), opt=True)
    RegisterCC_EntryRes._cont = ASN1Dict([
        ('ccbs-Feature', _RegisterCC_EntryRes_ccbs_Feature),
        ])
    RegisterCC_EntryRes._ext = []
    
    #-----< EraseCC-EntryArg >-----#
    EraseCC_EntryArg = SEQ(name='EraseCC-EntryArg', mode=MODE_TYPE)
    _EraseCC_EntryArg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryArg_ccbs_Index = INT(name='ccbs-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    EraseCC_EntryArg._cont = ASN1Dict([
        ('ss-Code', _EraseCC_EntryArg_ss_Code),
        ('ccbs-Index', _EraseCC_EntryArg_ccbs_Index),
        ])
    EraseCC_EntryArg._ext = []
    
    #-----< EraseCC-EntryRes >-----#
    EraseCC_EntryRes = SEQ(name='EraseCC-EntryRes', mode=MODE_TYPE)
    _EraseCC_EntryRes_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryRes_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    EraseCC_EntryRes._cont = ASN1Dict([
        ('ss-Code', _EraseCC_EntryRes_ss_Code),
        ('ss-Status', _EraseCC_EntryRes_ss_Status),
        ])
    EraseCC_EntryRes._ext = []
    
    _all_ = [
        _RegisterSS_Arg_ss_Code,
        _RegisterSS_Arg_basicService,
        _RegisterSS_Arg_forwardedToNumber,
        _RegisterSS_Arg_forwardedToSubaddress,
        _RegisterSS_Arg_noReplyConditionTime,
        _RegisterSS_Arg_defaultPriority,
        _RegisterSS_Arg_nbrUser,
        _RegisterSS_Arg_longFTN_Supported,
        RegisterSS_Arg,
        NoReplyConditionTime,
        _SS_Info_forwardingInfo,
        _SS_Info_callBarringInfo,
        _SS_Info_ss_Data,
        SS_Info,
        _ForwardingInfo_ss_Code,
        _ForwardingInfo_forwardingFeatureList,
        ForwardingInfo,
        _ForwardingFeatureList__item_,
        ForwardingFeatureList,
        _ForwardingFeature_basicService,
        _ForwardingFeature_ss_Status,
        _ForwardingFeature_forwardedToNumber,
        _ForwardingFeature_forwardedToSubaddress,
        _ForwardingFeature_forwardingOptions,
        _ForwardingFeature_noReplyConditionTime,
        _ForwardingFeature_longForwardedToNumber,
        ForwardingFeature,
        SS_Status,
        ForwardingOptions,
        _CallBarringInfo_ss_Code,
        _CallBarringInfo_callBarringFeatureList,
        CallBarringInfo,
        _CallBarringFeatureList__item_,
        CallBarringFeatureList,
        _CallBarringFeature_basicService,
        _CallBarringFeature_ss_Status,
        CallBarringFeature,
        _SS_Data_ss_Code,
        _SS_Data_ss_Status,
        _SS_Data_ss_SubscriptionOption,
        _SS_Data_basicServiceGroupList,
        _SS_Data_defaultPriority,
        _SS_Data_nbrUser,
        SS_Data,
        _SS_SubscriptionOption_cliRestrictionOption,
        _SS_SubscriptionOption_overrideCategory,
        SS_SubscriptionOption,
        CliRestrictionOption,
        OverrideCategory,
        _SS_ForBS_Code_ss_Code,
        _SS_ForBS_Code_basicService,
        _SS_ForBS_Code_longFTN_Supported,
        SS_ForBS_Code,
        _GenericServiceInfo_ss_Status,
        _GenericServiceInfo_cliRestrictionOption,
        _GenericServiceInfo_maximumEntitledPriority,
        _GenericServiceInfo_defaultPriority,
        _GenericServiceInfo_ccbs_FeatureList,
        _GenericServiceInfo_nbrSB,
        _GenericServiceInfo_nbrUser,
        _GenericServiceInfo_nbrSN,
        GenericServiceInfo,
        _CCBS_FeatureList__item_,
        CCBS_FeatureList,
        maxNumOfCCBS_Requests,
        _CCBS_Feature_ccbs_Index,
        _CCBS_Feature_b_subscriberNumber,
        _CCBS_Feature_b_subscriberSubaddress,
        _CCBS_Feature_basicServiceGroup,
        CCBS_Feature,
        CCBS_Index,
        _InterrogateSS_Res_ss_Status,
        _InterrogateSS_Res_basicServiceGroupList,
        _InterrogateSS_Res_forwardingFeatureList,
        _InterrogateSS_Res_genericServiceInfo,
        InterrogateSS_Res,
        _USSD_Arg_ussd_DataCodingScheme,
        _USSD_Arg_ussd_String,
        _USSD_Arg_alertingPattern,
        _USSD_Arg_msisdn,
        USSD_Arg,
        _USSD_Res_ussd_DataCodingScheme,
        _USSD_Res_ussd_String,
        USSD_Res,
        USSD_DataCodingScheme,
        USSD_String,
        maxUSSD_StringLength,
        Password,
        GuidanceInfo,
        _SS_List__item_,
        SS_List,
        maxNumOfSS,
        _SS_InfoList__item_,
        SS_InfoList,
        _BasicServiceGroupList__item_,
        BasicServiceGroupList,
        maxNumOfBasicServiceGroups,
        _SS_InvocationNotificationArg_imsi,
        _SS_InvocationNotificationArg_msisdn,
        _SS_InvocationNotificationArg_ss_Event,
        _SS_InvocationNotificationArg_ss_EventSpecification,
        _SS_InvocationNotificationArg_extensionContainer,
        _SS_InvocationNotificationArg_b_subscriberNumber,
        _SS_InvocationNotificationArg_ccbs_RequestState,
        SS_InvocationNotificationArg,
        CCBS_RequestState,
        _SS_InvocationNotificationRes_extensionContainer,
        SS_InvocationNotificationRes,
        _SS_EventSpecification__item_,
        SS_EventSpecification,
        maxEventSpecification,
        _RegisterCC_EntryArg_ss_Code,
        _RegisterCC_EntryArg_ccbs_Data,
        RegisterCC_EntryArg,
        _CCBS_Data_ccbs_Feature,
        _CCBS_Data_translatedB_Number,
        _CCBS_Data_serviceIndicator,
        _CCBS_Data_callInfo,
        _CCBS_Data_networkSignalInfo,
        CCBS_Data,
        ServiceIndicator,
        _RegisterCC_EntryRes_ccbs_Feature,
        RegisterCC_EntryRes,
        _EraseCC_EntryArg_ss_Code,
        _EraseCC_EntryArg_ccbs_Index,
        EraseCC_EntryArg,
        _EraseCC_EntryRes_ss_Code,
        _EraseCC_EntryRes_ss_Status,
        EraseCC_EntryRes,
    ]

class MAP_TS_Code:

    _name_  = 'MAP-TS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 19, 19]
    
    _obj_ = [
        'TeleserviceCode',
        'Ext-TeleserviceCode',
        'allTeleservices',
        'allSpeechTransmissionServices',
        'telephony',
        'emergencyCalls',
        'allShortMessageServices',
        'shortMessageMT-PP',
        'shortMessageMO-PP',
        'allFacsimileTransmissionServices',
        'facsimileGroup3AndAlterSpeech',
        'automaticFacsimileGroup3',
        'facsimileGroup4',
        'allDataTeleservices',
        'allTeleservices-ExeptSMS',
        'allVoiceGroupCallServices',
        'voiceGroupCall',
        'voiceBroadcastCall',
        'allPLMN-specificTS',
        'plmn-specificTS-1',
        'plmn-specificTS-2',
        'plmn-specificTS-3',
        'plmn-specificTS-4',
        'plmn-specificTS-5',
        'plmn-specificTS-6',
        'plmn-specificTS-7',
        'plmn-specificTS-8',
        'plmn-specificTS-9',
        'plmn-specificTS-A',
        'plmn-specificTS-B',
        'plmn-specificTS-C',
        'plmn-specificTS-D',
        'plmn-specificTS-E',
        'plmn-specificTS-F',
        ]
    _type_ = [
        'TeleserviceCode',
        'Ext-TeleserviceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        'allTeleservices',
        'allSpeechTransmissionServices',
        'telephony',
        'emergencyCalls',
        'allShortMessageServices',
        'shortMessageMT-PP',
        'shortMessageMO-PP',
        'allFacsimileTransmissionServices',
        'facsimileGroup3AndAlterSpeech',
        'automaticFacsimileGroup3',
        'facsimileGroup4',
        'allDataTeleservices',
        'allTeleservices-ExeptSMS',
        'allVoiceGroupCallServices',
        'voiceGroupCall',
        'voiceBroadcastCall',
        'allPLMN-specificTS',
        'plmn-specificTS-1',
        'plmn-specificTS-2',
        'plmn-specificTS-3',
        'plmn-specificTS-4',
        'plmn-specificTS-5',
        'plmn-specificTS-6',
        'plmn-specificTS-7',
        'plmn-specificTS-8',
        'plmn-specificTS-9',
        'plmn-specificTS-A',
        'plmn-specificTS-B',
        'plmn-specificTS-C',
        'plmn-specificTS-D',
        'plmn-specificTS-E',
        'plmn-specificTS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TeleserviceCode >-----#
    TeleserviceCode = OCT_STR(name='TeleserviceCode', mode=MODE_TYPE)
    TeleserviceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-TeleserviceCode >-----#
    Ext_TeleserviceCode = OCT_STR(name='Ext-TeleserviceCode', mode=MODE_TYPE)
    Ext_TeleserviceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allTeleservices >-----#
    allTeleservices = OCT_STR(name='allTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices._val = b'\x00'
    
    #-----< allSpeechTransmissionServices >-----#
    allSpeechTransmissionServices = OCT_STR(name='allSpeechTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allSpeechTransmissionServices._val = b'\x10'
    
    #-----< telephony >-----#
    telephony = OCT_STR(name='telephony', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    telephony._val = b'\x11'
    
    #-----< emergencyCalls >-----#
    emergencyCalls = OCT_STR(name='emergencyCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    emergencyCalls._val = b'\x12'
    
    #-----< allShortMessageServices >-----#
    allShortMessageServices = OCT_STR(name='allShortMessageServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allShortMessageServices._val = b' '
    
    #-----< shortMessageMT-PP >-----#
    shortMessageMT_PP = OCT_STR(name='shortMessageMT-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMT_PP._val = b'!'
    
    #-----< shortMessageMO-PP >-----#
    shortMessageMO_PP = OCT_STR(name='shortMessageMO-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMO_PP._val = b'"'
    
    #-----< allFacsimileTransmissionServices >-----#
    allFacsimileTransmissionServices = OCT_STR(name='allFacsimileTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allFacsimileTransmissionServices._val = b'`'
    
    #-----< facsimileGroup3AndAlterSpeech >-----#
    facsimileGroup3AndAlterSpeech = OCT_STR(name='facsimileGroup3AndAlterSpeech', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup3AndAlterSpeech._val = b'a'
    
    #-----< automaticFacsimileGroup3 >-----#
    automaticFacsimileGroup3 = OCT_STR(name='automaticFacsimileGroup3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    automaticFacsimileGroup3._val = b'b'
    
    #-----< facsimileGroup4 >-----#
    facsimileGroup4 = OCT_STR(name='facsimileGroup4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup4._val = b'c'
    
    #-----< allDataTeleservices >-----#
    allDataTeleservices = OCT_STR(name='allDataTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allDataTeleservices._val = b'p'
    
    #-----< allTeleservices-ExeptSMS >-----#
    allTeleservices_ExeptSMS = OCT_STR(name='allTeleservices-ExeptSMS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices_ExeptSMS._val = b'\x80'
    
    #-----< allVoiceGroupCallServices >-----#
    allVoiceGroupCallServices = OCT_STR(name='allVoiceGroupCallServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allVoiceGroupCallServices._val = b'\x90'
    
    #-----< voiceGroupCall >-----#
    voiceGroupCall = OCT_STR(name='voiceGroupCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceGroupCall._val = b'\x91'
    
    #-----< voiceBroadcastCall >-----#
    voiceBroadcastCall = OCT_STR(name='voiceBroadcastCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceBroadcastCall._val = b'\x92'
    
    #-----< allPLMN-specificTS >-----#
    allPLMN_specificTS = OCT_STR(name='allPLMN-specificTS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allPLMN_specificTS._val = b'\xd0'
    
    #-----< plmn-specificTS-1 >-----#
    plmn_specificTS_1 = OCT_STR(name='plmn-specificTS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_1._val = b'\xd1'
    
    #-----< plmn-specificTS-2 >-----#
    plmn_specificTS_2 = OCT_STR(name='plmn-specificTS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_2._val = b'\xd2'
    
    #-----< plmn-specificTS-3 >-----#
    plmn_specificTS_3 = OCT_STR(name='plmn-specificTS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_3._val = b'\xd3'
    
    #-----< plmn-specificTS-4 >-----#
    plmn_specificTS_4 = OCT_STR(name='plmn-specificTS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_4._val = b'\xd4'
    
    #-----< plmn-specificTS-5 >-----#
    plmn_specificTS_5 = OCT_STR(name='plmn-specificTS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_5._val = b'\xd5'
    
    #-----< plmn-specificTS-6 >-----#
    plmn_specificTS_6 = OCT_STR(name='plmn-specificTS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_6._val = b'\xd6'
    
    #-----< plmn-specificTS-7 >-----#
    plmn_specificTS_7 = OCT_STR(name='plmn-specificTS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_7._val = b'\xd7'
    
    #-----< plmn-specificTS-8 >-----#
    plmn_specificTS_8 = OCT_STR(name='plmn-specificTS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_8._val = b'\xd8'
    
    #-----< plmn-specificTS-9 >-----#
    plmn_specificTS_9 = OCT_STR(name='plmn-specificTS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_9._val = b'\xd9'
    
    #-----< plmn-specificTS-A >-----#
    plmn_specificTS_A = OCT_STR(name='plmn-specificTS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_A._val = b'\xda'
    
    #-----< plmn-specificTS-B >-----#
    plmn_specificTS_B = OCT_STR(name='plmn-specificTS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_B._val = b'\xdb'
    
    #-----< plmn-specificTS-C >-----#
    plmn_specificTS_C = OCT_STR(name='plmn-specificTS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_C._val = b'\xdc'
    
    #-----< plmn-specificTS-D >-----#
    plmn_specificTS_D = OCT_STR(name='plmn-specificTS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_D._val = b'\xdd'
    
    #-----< plmn-specificTS-E >-----#
    plmn_specificTS_E = OCT_STR(name='plmn-specificTS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_E._val = b'\xde'
    
    #-----< plmn-specificTS-F >-----#
    plmn_specificTS_F = OCT_STR(name='plmn-specificTS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_F._val = b'\xdf'
    
    _all_ = [
        TeleserviceCode,
        Ext_TeleserviceCode,
        allTeleservices,
        allSpeechTransmissionServices,
        telephony,
        emergencyCalls,
        allShortMessageServices,
        shortMessageMT_PP,
        shortMessageMO_PP,
        allFacsimileTransmissionServices,
        facsimileGroup3AndAlterSpeech,
        automaticFacsimileGroup3,
        facsimileGroup4,
        allDataTeleservices,
        allTeleservices_ExeptSMS,
        allVoiceGroupCallServices,
        voiceGroupCall,
        voiceBroadcastCall,
        allPLMN_specificTS,
        plmn_specificTS_1,
        plmn_specificTS_2,
        plmn_specificTS_3,
        plmn_specificTS_4,
        plmn_specificTS_5,
        plmn_specificTS_6,
        plmn_specificTS_7,
        plmn_specificTS_8,
        plmn_specificTS_9,
        plmn_specificTS_A,
        plmn_specificTS_B,
        plmn_specificTS_C,
        plmn_specificTS_D,
        plmn_specificTS_E,
        plmn_specificTS_F,
    ]

class MBMSChargingDataTypes:

    _name_  = 'MBMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 8, 0, 1]
    
    _obj_ = [
        'MBMSRecord',
        'SUBBMSCRecord',
        'CONTENTBMSCRecord',
        'MBMSCauseForRecClosing',
        ]
    _type_ = [
        'MBMSRecord',
        'SUBBMSCRecord',
        'CONTENTBMSCRecord',
        'MBMSCauseForRecClosing',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MBMSRecord >-----#
    MBMSRecord = CHOICE(name='MBMSRecord', mode=MODE_TYPE)
    _MBMSRecord_sUBBMSCRecord = SET(name='sUBBMSCRecord', mode=MODE_TYPE, tag=(78, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'SUBBMSCRecord')))
    _MBMSRecord_cONTENTBMSCRecord = SET(name='cONTENTBMSCRecord', mode=MODE_TYPE, tag=(79, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'CONTENTBMSCRecord')))
    MBMSRecord._cont = ASN1Dict([
        ('sUBBMSCRecord', _MBMSRecord_sUBBMSCRecord),
        ('cONTENTBMSCRecord', _MBMSRecord_cONTENTBMSCRecord),
        ])
    MBMSRecord._ext = None
    
    #-----< SUBBMSCRecord >-----#
    SUBBMSCRecord = SET(name='SUBBMSCRecord', mode=MODE_TYPE)
    _SUBBMSCRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SUBBMSCRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SUBBMSCRecord_ggsnAddress = CHOICE(name='ggsnAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SUBBMSCRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SUBBMSCRecord_servedPDPAddress = CHOICE(name='servedPDPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SUBBMSCRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SUBBMSCRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _SUBBMSCRecord_listOfTrafficVolumes._cont = __SUBBMSCRecord_listOfTrafficVolumes__item_
    _SUBBMSCRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SUBBMSCRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SUBBMSCRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'MBMSCauseForRecClosing')))
    _SUBBMSCRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SUBBMSCRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SUBBMSCRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SUBBMSCRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SUBBMSCRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SUBBMSCRecord_servedMSISDN = OCT_STR(name='servedMSISDN', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SUBBMSCRecord_bearerServiceDescription = SEQ(name='bearerServiceDescription', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')), opt=True)
    _SUBBMSCRecord_mbmsInformation = SET(name='mbmsInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    _SUBBMSCRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    SUBBMSCRecord._cont = ASN1Dict([
        ('recordType', _SUBBMSCRecord_recordType),
        ('servedIMSI', _SUBBMSCRecord_servedIMSI),
        ('ggsnAddress', _SUBBMSCRecord_ggsnAddress),
        ('accessPointNameNI', _SUBBMSCRecord_accessPointNameNI),
        ('servedPDPAddress', _SUBBMSCRecord_servedPDPAddress),
        ('listOfTrafficVolumes', _SUBBMSCRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _SUBBMSCRecord_recordOpeningTime),
        ('duration', _SUBBMSCRecord_duration),
        ('causeForRecClosing', _SUBBMSCRecord_causeForRecClosing),
        ('diagnostics', _SUBBMSCRecord_diagnostics),
        ('recordSequenceNumber', _SUBBMSCRecord_recordSequenceNumber),
        ('nodeID', _SUBBMSCRecord_nodeID),
        ('recordExtensions', _SUBBMSCRecord_recordExtensions),
        ('localSequenceNumber', _SUBBMSCRecord_localSequenceNumber),
        ('servedMSISDN', _SUBBMSCRecord_servedMSISDN),
        ('bearerServiceDescription', _SUBBMSCRecord_bearerServiceDescription),
        ('mbmsInformation', _SUBBMSCRecord_mbmsInformation),
        ('serviceContextID', _SUBBMSCRecord_serviceContextID),
        ])
    SUBBMSCRecord._ext = None
    
    #-----< CONTENTBMSCRecord >-----#
    CONTENTBMSCRecord = SET(name='CONTENTBMSCRecord', mode=MODE_TYPE)
    _CONTENTBMSCRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CONTENTBMSCRecord_contentProviderId = STR_GRAPH(name='contentProviderId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CONTENTBMSCRecord_listofDownstreamNodes = SEQ_OF(name='listofDownstreamNodes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CONTENTBMSCRecord_listofDownstreamNodes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _CONTENTBMSCRecord_listofDownstreamNodes._cont = __CONTENTBMSCRecord_listofDownstreamNodes__item_
    _CONTENTBMSCRecord_accessPointNameNI = STR_IA5(name='accessPointNameNI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _CONTENTBMSCRecord_servedPDPAddress = CHOICE(name='servedPDPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _CONTENTBMSCRecord_listOfTrafficVolumes = SEQ_OF(name='listOfTrafficVolumes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CONTENTBMSCRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _CONTENTBMSCRecord_listOfTrafficVolumes._cont = __CONTENTBMSCRecord_listOfTrafficVolumes__item_
    _CONTENTBMSCRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CONTENTBMSCRecord_duration = INT(name='duration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CONTENTBMSCRecord_causeForRecClosing = INT(name='causeForRecClosing', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'MBMSCauseForRecClosing')))
    _CONTENTBMSCRecord_diagnostics = CHOICE(name='diagnostics', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CONTENTBMSCRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CONTENTBMSCRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _CONTENTBMSCRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CONTENTBMSCRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CONTENTBMSCRecord_recipientAddressList = SEQ_OF(name='recipientAddressList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CONTENTBMSCRecord_recipientAddressList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _CONTENTBMSCRecord_recipientAddressList._cont = __CONTENTBMSCRecord_recipientAddressList__item_
    _CONTENTBMSCRecord_bearerServiceDescription = SEQ(name='bearerServiceDescription', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')), opt=True)
    _CONTENTBMSCRecord_mbmsInformation = SET(name='mbmsInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    _CONTENTBMSCRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _CONTENTBMSCRecord_servedpdpPDNType = OCT_STR(name='servedpdpPDNType', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    CONTENTBMSCRecord._cont = ASN1Dict([
        ('recordType', _CONTENTBMSCRecord_recordType),
        ('contentProviderId', _CONTENTBMSCRecord_contentProviderId),
        ('listofDownstreamNodes', _CONTENTBMSCRecord_listofDownstreamNodes),
        ('accessPointNameNI', _CONTENTBMSCRecord_accessPointNameNI),
        ('servedPDPAddress', _CONTENTBMSCRecord_servedPDPAddress),
        ('listOfTrafficVolumes', _CONTENTBMSCRecord_listOfTrafficVolumes),
        ('recordOpeningTime', _CONTENTBMSCRecord_recordOpeningTime),
        ('duration', _CONTENTBMSCRecord_duration),
        ('causeForRecClosing', _CONTENTBMSCRecord_causeForRecClosing),
        ('diagnostics', _CONTENTBMSCRecord_diagnostics),
        ('recordSequenceNumber', _CONTENTBMSCRecord_recordSequenceNumber),
        ('nodeID', _CONTENTBMSCRecord_nodeID),
        ('recordExtensions', _CONTENTBMSCRecord_recordExtensions),
        ('localSequenceNumber', _CONTENTBMSCRecord_localSequenceNumber),
        ('recipientAddressList', _CONTENTBMSCRecord_recipientAddressList),
        ('bearerServiceDescription', _CONTENTBMSCRecord_bearerServiceDescription),
        ('mbmsInformation', _CONTENTBMSCRecord_mbmsInformation),
        ('serviceContextID', _CONTENTBMSCRecord_serviceContextID),
        ('servedpdpPDNType', _CONTENTBMSCRecord_servedpdpPDNType),
        ])
    CONTENTBMSCRecord._ext = None
    
    #-----< MBMSCauseForRecClosing >-----#
    MBMSCauseForRecClosing = INT(name='MBMSCauseForRecClosing', mode=MODE_TYPE)
    MBMSCauseForRecClosing._cont = ASN1Dict([('normalRelease', 0), ('abnormalRelease', 4), ('volumeLimit', 16), ('timeLimit', 17), ('maxChangeCond', 19), ('managementIntervention', 20), ('listofDownstreamNodeChange', 59)])
    
    _all_ = [
        _MBMSRecord_sUBBMSCRecord,
        _MBMSRecord_cONTENTBMSCRecord,
        MBMSRecord,
        _SUBBMSCRecord_recordType,
        _SUBBMSCRecord_servedIMSI,
        _SUBBMSCRecord_ggsnAddress,
        _SUBBMSCRecord_accessPointNameNI,
        _SUBBMSCRecord_servedPDPAddress,
        __SUBBMSCRecord_listOfTrafficVolumes__item_,
        _SUBBMSCRecord_listOfTrafficVolumes,
        _SUBBMSCRecord_recordOpeningTime,
        _SUBBMSCRecord_duration,
        _SUBBMSCRecord_causeForRecClosing,
        _SUBBMSCRecord_diagnostics,
        _SUBBMSCRecord_recordSequenceNumber,
        _SUBBMSCRecord_nodeID,
        _SUBBMSCRecord_recordExtensions,
        _SUBBMSCRecord_localSequenceNumber,
        _SUBBMSCRecord_servedMSISDN,
        _SUBBMSCRecord_bearerServiceDescription,
        _SUBBMSCRecord_mbmsInformation,
        _SUBBMSCRecord_serviceContextID,
        SUBBMSCRecord,
        _CONTENTBMSCRecord_recordType,
        _CONTENTBMSCRecord_contentProviderId,
        __CONTENTBMSCRecord_listofDownstreamNodes__item_,
        _CONTENTBMSCRecord_listofDownstreamNodes,
        _CONTENTBMSCRecord_accessPointNameNI,
        _CONTENTBMSCRecord_servedPDPAddress,
        __CONTENTBMSCRecord_listOfTrafficVolumes__item_,
        _CONTENTBMSCRecord_listOfTrafficVolumes,
        _CONTENTBMSCRecord_recordOpeningTime,
        _CONTENTBMSCRecord_duration,
        _CONTENTBMSCRecord_causeForRecClosing,
        _CONTENTBMSCRecord_diagnostics,
        _CONTENTBMSCRecord_recordSequenceNumber,
        _CONTENTBMSCRecord_nodeID,
        _CONTENTBMSCRecord_recordExtensions,
        _CONTENTBMSCRecord_localSequenceNumber,
        __CONTENTBMSCRecord_recipientAddressList__item_,
        _CONTENTBMSCRecord_recipientAddressList,
        _CONTENTBMSCRecord_bearerServiceDescription,
        _CONTENTBMSCRecord_mbmsInformation,
        _CONTENTBMSCRecord_serviceContextID,
        _CONTENTBMSCRecord_servedpdpPDNType,
        CONTENTBMSCRecord,
        MBMSCauseForRecClosing,
    ]

class MMSChargingDataTypes:

    _name_  = 'MMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 5, 0, 1]
    
    _obj_ = [
        'MMSRecordType',
        'MMO1SRecord',
        'MMO4FRqRecord',
        'MMO4FRsRecord',
        'MMO4DRecord',
        'MMO1DRecord',
        'MMO4RRecord',
        'MMO1RRecord',
        'MMOMDRecord',
        'MMR4FRecord',
        'MMR1NRqRecord',
        'MMR1NRsRecord',
        'MMR1RtRecord',
        'MMR1ARecord',
        'MMR4DRqRecord',
        'MMR4DRsRecord',
        'MMR1RRRecord',
        'MMR4RRqRecord',
        'MMR4RRsRecord',
        'MMRMDRecord',
        'MMFRecord',
        'MMBx1SRecord',
        'MMBx1VRecord',
        'MMBx1URecord',
        'MMBx1DRecord',
        'MM7SRecord',
        'MM7DRqRecord',
        'MM7DRsRecord',
        'MM7CRecord',
        'MM7RRecord',
        'MM7DRRqRecord',
        'MM7DRRsRecord',
        'MM7RRqRecord',
        'MM7RRsRecord',
        'AccessCorrelation',
        'AttributesList',
        'ChargeInformation',
        'ChargedParty',
        'ChargeType',
        'CircuitSwitchedAccess',
        'ContentType',
        'DataVolume',
        'DeltaSeconds',
        'MediaComponent',
        'MediaComponents',
        'MessageSelection',
        'MMBoxStorageInformation',
        'MMComponentType',
        'MMSAgentAddress',
        'MMSAgentAddresses',
        'MMSAgentAddressData',
        'MMSRecipientType',
        'MMSRSAddress',
        'MMState',
        'MMStatusCodeType',
        'MSCFInformation',
        'PacketSwitchedAccess',
        'Quotas',
        'RequestStatusCodeType',
        'RouteingAddress',
        'RouteingAddressList',
        'StatusTextType',
        'StoreStatus',
        'SubjectComponent',
        'Totals',
        'WaitTime',
        ]
    _type_ = [
        'MMSRecordType',
        'MMO1SRecord',
        'MMO4FRqRecord',
        'MMO4FRsRecord',
        'MMO4DRecord',
        'MMO1DRecord',
        'MMO4RRecord',
        'MMO1RRecord',
        'MMOMDRecord',
        'MMR4FRecord',
        'MMR1NRqRecord',
        'MMR1NRsRecord',
        'MMR1RtRecord',
        'MMR1ARecord',
        'MMR4DRqRecord',
        'MMR4DRsRecord',
        'MMR1RRRecord',
        'MMR4RRqRecord',
        'MMR4RRsRecord',
        'MMRMDRecord',
        'MMFRecord',
        'MMBx1SRecord',
        'MMBx1VRecord',
        'MMBx1URecord',
        'MMBx1DRecord',
        'MM7SRecord',
        'MM7DRqRecord',
        'MM7DRsRecord',
        'MM7CRecord',
        'MM7RRecord',
        'MM7DRRqRecord',
        'MM7DRRsRecord',
        'MM7RRqRecord',
        'MM7RRsRecord',
        'AccessCorrelation',
        'AttributesList',
        'ChargeInformation',
        'ChargedParty',
        'ChargeType',
        'CircuitSwitchedAccess',
        'ContentType',
        'DataVolume',
        'DeltaSeconds',
        'MediaComponent',
        'MediaComponents',
        'MessageSelection',
        'MMBoxStorageInformation',
        'MMComponentType',
        'MMSAgentAddress',
        'MMSAgentAddresses',
        'MMSAgentAddressData',
        'MMSRecipientType',
        'MMSRSAddress',
        'MMState',
        'MMStatusCodeType',
        'MSCFInformation',
        'PacketSwitchedAccess',
        'Quotas',
        'RequestStatusCodeType',
        'RouteingAddress',
        'RouteingAddressList',
        'StatusTextType',
        'StoreStatus',
        'SubjectComponent',
        'Totals',
        'WaitTime',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MMSRecordType >-----#
    MMSRecordType = CHOICE(name='MMSRecordType', mode=MODE_TYPE)
    _MMSRecordType_mMO1SRecord = SET(name='mMO1SRecord', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO1SRecord')))
    _MMSRecordType_mMO4FRqRecord = SET(name='mMO4FRqRecord', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4FRqRecord')))
    _MMSRecordType_mMO4FRsRecord = SET(name='mMO4FRsRecord', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4FRsRecord')))
    _MMSRecordType_mMO4DRecord = SET(name='mMO4DRecord', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4DRecord')))
    _MMSRecordType_mMO1DRecord = SET(name='mMO1DRecord', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO1DRecord')))
    _MMSRecordType_mMO4RRecord = SET(name='mMO4RRecord', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4RRecord')))
    _MMSRecordType_mMO1RRecord = SET(name='mMO1RRecord', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO1RRecord')))
    _MMSRecordType_mMOMDRecord = SET(name='mMOMDRecord', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMOMDRecord')))
    _MMSRecordType_mMR4FRecord = SET(name='mMR4FRecord', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4FRecord')))
    _MMSRecordType_mMR1NRqRecord = SET(name='mMR1NRqRecord', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1NRqRecord')))
    _MMSRecordType_mMR1NRsRecord = SET(name='mMR1NRsRecord', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1NRsRecord')))
    _MMSRecordType_mMR1RtRqRecord = SET(name='mMR1RtRqRecord', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1RtRecord')))
    _MMSRecordType_mMR1ARecord = SET(name='mMR1ARecord', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1ARecord')))
    _MMSRecordType_mMR4DRqRecord = SET(name='mMR4DRqRecord', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4DRqRecord')))
    _MMSRecordType_mMR4DRsRecord = SET(name='mMR4DRsRecord', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4DRsRecord')))
    _MMSRecordType_mMR1RRRecord = SET(name='mMR1RRRecord', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1RRRecord')))
    _MMSRecordType_mMR4RRqRecord = SET(name='mMR4RRqRecord', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4RRqRecord')))
    _MMSRecordType_mMR4RRsRecord = SET(name='mMR4RRsRecord', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4RRsRecord')))
    _MMSRecordType_mMRMDRecord = SET(name='mMRMDRecord', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMRMDRecord')))
    _MMSRecordType_mMFRecord = SET(name='mMFRecord', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMFRecord')))
    _MMSRecordType_mMBx1SRecord = SET(name='mMBx1SRecord', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1SRecord')))
    _MMSRecordType_mMBx1VRecord = SET(name='mMBx1VRecord', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1VRecord')))
    _MMSRecordType_mMBx1URecord = SET(name='mMBx1URecord', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1URecord')))
    _MMSRecordType_mMBx1DRecord = SET(name='mMBx1DRecord', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1DRecord')))
    _MMSRecordType_mM7SRecord = SET(name='mM7SRecord', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7SRecord')))
    _MMSRecordType_mM7DRqRecord = SET(name='mM7DRqRecord', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRqRecord')))
    _MMSRecordType_mM7DRsRecord = SET(name='mM7DRsRecord', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRsRecord')))
    _MMSRecordType_mM7CRecord = SET(name='mM7CRecord', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7CRecord')))
    _MMSRecordType_mM7RRecord = SET(name='mM7RRecord', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7RRecord')))
    _MMSRecordType_mM7DRRqRecord = SET(name='mM7DRRqRecord', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRRqRecord')))
    _MMSRecordType_mM7DRRsRecord = SET(name='mM7DRRsRecord', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRRsRecord')))
    _MMSRecordType_mM7RRqRecord = SET(name='mM7RRqRecord', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7RRqRecord')))
    _MMSRecordType_mM7RRsRecord = SET(name='mM7RRsRecord', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7RRsRecord')))
    MMSRecordType._cont = ASN1Dict([
        ('mMO1SRecord', _MMSRecordType_mMO1SRecord),
        ('mMO4FRqRecord', _MMSRecordType_mMO4FRqRecord),
        ('mMO4FRsRecord', _MMSRecordType_mMO4FRsRecord),
        ('mMO4DRecord', _MMSRecordType_mMO4DRecord),
        ('mMO1DRecord', _MMSRecordType_mMO1DRecord),
        ('mMO4RRecord', _MMSRecordType_mMO4RRecord),
        ('mMO1RRecord', _MMSRecordType_mMO1RRecord),
        ('mMOMDRecord', _MMSRecordType_mMOMDRecord),
        ('mMR4FRecord', _MMSRecordType_mMR4FRecord),
        ('mMR1NRqRecord', _MMSRecordType_mMR1NRqRecord),
        ('mMR1NRsRecord', _MMSRecordType_mMR1NRsRecord),
        ('mMR1RtRqRecord', _MMSRecordType_mMR1RtRqRecord),
        ('mMR1ARecord', _MMSRecordType_mMR1ARecord),
        ('mMR4DRqRecord', _MMSRecordType_mMR4DRqRecord),
        ('mMR4DRsRecord', _MMSRecordType_mMR4DRsRecord),
        ('mMR1RRRecord', _MMSRecordType_mMR1RRRecord),
        ('mMR4RRqRecord', _MMSRecordType_mMR4RRqRecord),
        ('mMR4RRsRecord', _MMSRecordType_mMR4RRsRecord),
        ('mMRMDRecord', _MMSRecordType_mMRMDRecord),
        ('mMFRecord', _MMSRecordType_mMFRecord),
        ('mMBx1SRecord', _MMSRecordType_mMBx1SRecord),
        ('mMBx1VRecord', _MMSRecordType_mMBx1VRecord),
        ('mMBx1URecord', _MMSRecordType_mMBx1URecord),
        ('mMBx1DRecord', _MMSRecordType_mMBx1DRecord),
        ('mM7SRecord', _MMSRecordType_mM7SRecord),
        ('mM7DRqRecord', _MMSRecordType_mM7DRqRecord),
        ('mM7DRsRecord', _MMSRecordType_mM7DRsRecord),
        ('mM7CRecord', _MMSRecordType_mM7CRecord),
        ('mM7RRecord', _MMSRecordType_mM7RRecord),
        ('mM7DRRqRecord', _MMSRecordType_mM7DRRqRecord),
        ('mM7DRRsRecord', _MMSRecordType_mM7DRRsRecord),
        ('mM7RRqRecord', _MMSRecordType_mM7RRqRecord),
        ('mM7RRsRecord', _MMSRecordType_mM7RRsRecord),
        ])
    MMSRecordType._ext = None
    
    #-----< MMO1SRecord >-----#
    MMO1SRecord = SET(name='MMO1SRecord', mode=MODE_TYPE)
    _MMO1SRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO1SRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO1SRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO1SRecord_replyChargingID = OCT_STR(name='replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO1SRecord_recipientAddresses = SET_OF(name='recipientAddresses', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMO1SRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMO1SRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMO1SRecord_mmComponentType = SEQ(name='mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMO1SRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMO1SRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMO1SRecord_chargeInformation = SEQ(name='chargeInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeInformation')), opt=True)
    _MMO1SRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO1SRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO1SRecord_earliestTimeOfDelivery = CHOICE(name='earliestTimeOfDelivery', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO1SRecord_durationOfTransmission = INT(name='durationOfTransmission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMO1SRecord_deliveryReportRequested = BOOL(name='deliveryReportRequested', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_replyCharging = BOOL(name='replyCharging', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_replyDeadline = CHOICE(name='replyDeadline', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO1SRecord_replyChargingSize = INT(name='replyChargingSize', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMO1SRecord_priority = ENUM(name='priority', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMO1SRecord_senderVisibility = BOOL(name='senderVisibility', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_readReplyRequested = BOOL(name='readReplyRequested', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')))
    _MMO1SRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO1SRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO1SRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMO1SRecord_mMBoxstorageInformation = SET(name='mMBoxstorageInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBoxStorageInformation')), opt=True)
    _MMO1SRecord_mscfInformation = SET(name='mscfInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MSCFInformation')), opt=True)
    _MMO1SRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMO1SRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMO1SRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMO1SRecord._cont = ASN1Dict([
        ('recordType', _MMO1SRecord_recordType),
        ('originatorMmsRSAddress', _MMO1SRecord_originatorMmsRSAddress),
        ('messageID', _MMO1SRecord_messageID),
        ('replyChargingID', _MMO1SRecord_replyChargingID),
        ('originatorAddress', _MMO1SRecord_originatorAddress),
        ('recipientAddresses', _MMO1SRecord_recipientAddresses),
        ('accessCorrelation', _MMO1SRecord_accessCorrelation),
        ('contentType', _MMO1SRecord_contentType),
        ('mmComponentType', _MMO1SRecord_mmComponentType),
        ('messageSize', _MMO1SRecord_messageSize),
        ('messageClass', _MMO1SRecord_messageClass),
        ('chargeInformation', _MMO1SRecord_chargeInformation),
        ('submissionTime', _MMO1SRecord_submissionTime),
        ('timeOfExpiry', _MMO1SRecord_timeOfExpiry),
        ('earliestTimeOfDelivery', _MMO1SRecord_earliestTimeOfDelivery),
        ('durationOfTransmission', _MMO1SRecord_durationOfTransmission),
        ('requestStatusCode', _MMO1SRecord_requestStatusCode),
        ('deliveryReportRequested', _MMO1SRecord_deliveryReportRequested),
        ('replyCharging', _MMO1SRecord_replyCharging),
        ('replyDeadline', _MMO1SRecord_replyDeadline),
        ('replyChargingSize', _MMO1SRecord_replyChargingSize),
        ('priority', _MMO1SRecord_priority),
        ('senderVisibility', _MMO1SRecord_senderVisibility),
        ('readReplyRequested', _MMO1SRecord_readReplyRequested),
        ('statusText', _MMO1SRecord_statusText),
        ('recordTimeStamp', _MMO1SRecord_recordTimeStamp),
        ('localSequenceNumber', _MMO1SRecord_localSequenceNumber),
        ('recordExtensions', _MMO1SRecord_recordExtensions),
        ('mMBoxstorageInformation', _MMO1SRecord_mMBoxstorageInformation),
        ('mscfInformation', _MMO1SRecord_mscfInformation),
        ('sGSNPLMNIdentifier', _MMO1SRecord_sGSNPLMNIdentifier),
        ('rATType', _MMO1SRecord_rATType),
        ('mSTimeZone', _MMO1SRecord_mSTimeZone),
        ])
    MMO1SRecord._ext = None
    
    #-----< MMO4FRqRecord >-----#
    MMO4FRqRecord = SET(name='MMO4FRqRecord', mode=MODE_TYPE)
    _MMO4FRqRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4FRqRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO4FRqRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO4FRqRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4FRqRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO4FRqRecord_recipientAddresses = SET_OF(name='recipientAddresses', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMO4FRqRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMO4FRqRecord_mmComponentType = SEQ(name='mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMO4FRqRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMO4FRqRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMO4FRqRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO4FRqRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO4FRqRecord_deliveryReportRequested = BOOL(name='deliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_priority = ENUM(name='priority', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMO4FRqRecord_senderVisibility = BOOL(name='senderVisibility', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_readReplyRequested = BOOL(name='readReplyRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_acknowledgementRequest = BOOL(name='acknowledgementRequest', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_forwardCounter = INT(name='forwardCounter', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4FRqRecord_forwardingAddress = SET_OF(name='forwardingAddress', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')), opt=True)
    _MMO4FRqRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO4FRqRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4FRqRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4FRqRecord._cont = ASN1Dict([
        ('recordType', _MMO4FRqRecord_recordType),
        ('originatorMmsRSAddress', _MMO4FRqRecord_originatorMmsRSAddress),
        ('recipientMmsRSAddress', _MMO4FRqRecord_recipientMmsRSAddress),
        ('messageID', _MMO4FRqRecord_messageID),
        ('mms3GPPVersion', _MMO4FRqRecord_mms3GPPVersion),
        ('originatorAddress', _MMO4FRqRecord_originatorAddress),
        ('recipientAddresses', _MMO4FRqRecord_recipientAddresses),
        ('contentType', _MMO4FRqRecord_contentType),
        ('mmComponentType', _MMO4FRqRecord_mmComponentType),
        ('messageSize', _MMO4FRqRecord_messageSize),
        ('messageClass', _MMO4FRqRecord_messageClass),
        ('submissionTime', _MMO4FRqRecord_submissionTime),
        ('timeOfExpiry', _MMO4FRqRecord_timeOfExpiry),
        ('deliveryReportRequested', _MMO4FRqRecord_deliveryReportRequested),
        ('priority', _MMO4FRqRecord_priority),
        ('senderVisibility', _MMO4FRqRecord_senderVisibility),
        ('readReplyRequested', _MMO4FRqRecord_readReplyRequested),
        ('acknowledgementRequest', _MMO4FRqRecord_acknowledgementRequest),
        ('forwardCounter', _MMO4FRqRecord_forwardCounter),
        ('forwardingAddress', _MMO4FRqRecord_forwardingAddress),
        ('recordTimeStamp', _MMO4FRqRecord_recordTimeStamp),
        ('localSequenceNumber', _MMO4FRqRecord_localSequenceNumber),
        ('recordExtensions', _MMO4FRqRecord_recordExtensions),
        ])
    MMO4FRqRecord._ext = None
    
    #-----< MMO4FRsRecord >-----#
    MMO4FRsRecord = SET(name='MMO4FRsRecord', mode=MODE_TYPE)
    _MMO4FRsRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4FRsRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4FRsRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO4FRsRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRsRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4FRsRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMO4FRsRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMO4FRsRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4FRsRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4FRsRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4FRsRecord._cont = ASN1Dict([
        ('recordType', _MMO4FRsRecord_recordType),
        ('originatorMmsRSAddress', _MMO4FRsRecord_originatorMmsRSAddress),
        ('recipientMmsRSAddress', _MMO4FRsRecord_recipientMmsRSAddress),
        ('messageID', _MMO4FRsRecord_messageID),
        ('mms3GPPVersion', _MMO4FRsRecord_mms3GPPVersion),
        ('requestStatusCode', _MMO4FRsRecord_requestStatusCode),
        ('statusText', _MMO4FRsRecord_statusText),
        ('recordTimeStamp', _MMO4FRsRecord_recordTimeStamp),
        ('localSequenceNumber', _MMO4FRsRecord_localSequenceNumber),
        ('recordExtensions', _MMO4FRsRecord_recordExtensions),
        ])
    MMO4FRsRecord._ext = None
    
    #-----< MMO4DRecord >-----#
    MMO4DRecord = SET(name='MMO4DRecord', mode=MODE_TYPE)
    _MMO4DRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4DRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4DRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4DRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4DRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4DRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO4DRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO4DRecord_mmDateAndTime = OCT_STR(name='mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO4DRecord_acknowledgementRequest = BOOL(name='acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4DRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')))
    _MMO4DRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMO4DRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4DRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4DRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4DRecord._cont = ASN1Dict([
        ('recordType', _MMO4DRecord_recordType),
        ('recipientMmsRSAddress', _MMO4DRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMO4DRecord_originatorMmsRSAddress),
        ('messageID', _MMO4DRecord_messageID),
        ('mms3GPPVersion', _MMO4DRecord_mms3GPPVersion),
        ('originatorAddress', _MMO4DRecord_originatorAddress),
        ('recipientAddress', _MMO4DRecord_recipientAddress),
        ('mmDateAndTime', _MMO4DRecord_mmDateAndTime),
        ('acknowledgementRequest', _MMO4DRecord_acknowledgementRequest),
        ('mmStatusCode', _MMO4DRecord_mmStatusCode),
        ('statusText', _MMO4DRecord_statusText),
        ('recordTimeStamp', _MMO4DRecord_recordTimeStamp),
        ('localSequenceNumber', _MMO4DRecord_localSequenceNumber),
        ('recordExtensions', _MMO4DRecord_recordExtensions),
        ])
    MMO4DRecord._ext = None
    
    #-----< MMO1DRecord >-----#
    MMO1DRecord = SET(name='MMO1DRecord', mode=MODE_TYPE)
    _MMO1DRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO1DRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1DRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1DRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMO1DRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO1DRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1DRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO1DRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO1DRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMO1DRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO1DRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO1DRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMO1DRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMO1DRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMO1DRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMO1DRecord._cont = ASN1Dict([
        ('recordType', _MMO1DRecord_recordType),
        ('recipientMmsRSAddress', _MMO1DRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMO1DRecord_originatorMmsRSAddress),
        ('accessCorrelation', _MMO1DRecord_accessCorrelation),
        ('messageID', _MMO1DRecord_messageID),
        ('mms3GPPVersion', _MMO1DRecord_mms3GPPVersion),
        ('originatorAddress', _MMO1DRecord_originatorAddress),
        ('recipientAddress', _MMO1DRecord_recipientAddress),
        ('mmStatusCode', _MMO1DRecord_mmStatusCode),
        ('recordTimeStamp', _MMO1DRecord_recordTimeStamp),
        ('localSequenceNumber', _MMO1DRecord_localSequenceNumber),
        ('recordExtensions', _MMO1DRecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMO1DRecord_sGSNPLMNIdentifier),
        ('rATType', _MMO1DRecord_rATType),
        ('mSTimeZone', _MMO1DRecord_mSTimeZone),
        ])
    MMO1DRecord._ext = None
    
    #-----< MMO4RRecord >-----#
    MMO4RRecord = SET(name='MMO4RRecord', mode=MODE_TYPE)
    _MMO4RRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4RRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4RRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4RRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4RRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4RRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO4RRecord_recipientAddresses = SET_OF(name='recipientAddresses', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')), opt=True)
    _MMO4RRecord_mmDateAndTime = OCT_STR(name='mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4RRecord_acknowledgementRequest = BOOL(name='acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4RRecord_readStatus = ENUM(name='readStatus', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMO4RRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMO4RRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4RRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4RRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4RRecord._cont = ASN1Dict([
        ('recordType', _MMO4RRecord_recordType),
        ('recipientMmsRSAddress', _MMO4RRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMO4RRecord_originatorMmsRSAddress),
        ('messageID', _MMO4RRecord_messageID),
        ('mms3GPPVersion', _MMO4RRecord_mms3GPPVersion),
        ('originatorAddress', _MMO4RRecord_originatorAddress),
        ('recipientAddresses', _MMO4RRecord_recipientAddresses),
        ('mmDateAndTime', _MMO4RRecord_mmDateAndTime),
        ('acknowledgementRequest', _MMO4RRecord_acknowledgementRequest),
        ('readStatus', _MMO4RRecord_readStatus),
        ('statusText', _MMO4RRecord_statusText),
        ('recordTimeStamp', _MMO4RRecord_recordTimeStamp),
        ('localSequenceNumber', _MMO4RRecord_localSequenceNumber),
        ('recordExtensions', _MMO4RRecord_recordExtensions),
        ])
    MMO4RRecord._ext = None
    
    #-----< MMO1RRecord >-----#
    MMO1RRecord = SET(name='MMO1RRecord', mode=MODE_TYPE)
    _MMO1RRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO1RRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1RRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1RRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMO1RRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO1RRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1RRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO1RRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO1RRecord_readStatus = ENUM(name='readStatus', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMO1RRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO1RRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO1RRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMO1RRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMO1RRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMO1RRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMO1RRecord._cont = ASN1Dict([
        ('recordType', _MMO1RRecord_recordType),
        ('recipientMmsRSAddress', _MMO1RRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMO1RRecord_originatorMmsRSAddress),
        ('accessCorrelation', _MMO1RRecord_accessCorrelation),
        ('messageID', _MMO1RRecord_messageID),
        ('mms3GPPVersion', _MMO1RRecord_mms3GPPVersion),
        ('originatorAddress', _MMO1RRecord_originatorAddress),
        ('recipientAddress', _MMO1RRecord_recipientAddress),
        ('readStatus', _MMO1RRecord_readStatus),
        ('recordTimeStamp', _MMO1RRecord_recordTimeStamp),
        ('localSequenceNumber', _MMO1RRecord_localSequenceNumber),
        ('recordExtensions', _MMO1RRecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMO1RRecord_sGSNPLMNIdentifier),
        ('rATType', _MMO1RRecord_rATType),
        ('mSTimeZone', _MMO1RRecord_mSTimeZone),
        ])
    MMO1RRecord._ext = None
    
    #-----< MMOMDRecord >-----#
    MMOMDRecord = SET(name='MMOMDRecord', mode=MODE_TYPE)
    _MMOMDRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMOMDRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMOMDRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMOMDRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMOMDRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMOMDRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMOMDRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMOMDRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMOMDRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMOMDRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMOMDRecord._cont = ASN1Dict([
        ('recordType', _MMOMDRecord_recordType),
        ('originatorMmsRSAddress', _MMOMDRecord_originatorMmsRSAddress),
        ('recipientMmsRSAddress', _MMOMDRecord_recipientMmsRSAddress),
        ('messageID', _MMOMDRecord_messageID),
        ('messageSize', _MMOMDRecord_messageSize),
        ('mmStatusCode', _MMOMDRecord_mmStatusCode),
        ('statusText', _MMOMDRecord_statusText),
        ('recordTimeStamp', _MMOMDRecord_recordTimeStamp),
        ('localSequenceNumber', _MMOMDRecord_localSequenceNumber),
        ('recordExtensions', _MMOMDRecord_recordExtensions),
        ])
    MMOMDRecord._ext = None
    
    #-----< MMR4FRecord >-----#
    MMR4FRecord = SET(name='MMR4FRecord', mode=MODE_TYPE)
    _MMR4FRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4FRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4FRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4FRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4FRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4FRecord_recipientAddresses = SET_OF(name='recipientAddresses', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMR4FRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMR4FRecord_mmComponentType = SEQ(name='mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMR4FRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMR4FRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMR4FRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMR4FRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR4FRecord_deliveryReportRequested = BOOL(name='deliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_priority = ENUM(name='priority', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMR4FRecord_senderVisibility = BOOL(name='senderVisibility', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_readReplyRequested = BOOL(name='readReplyRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')))
    _MMR4FRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')))
    _MMR4FRecord_acknowledgementRequest = BOOL(name='acknowledgementRequest', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_forwardCounter = INT(name='forwardCounter', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4FRecord_forwardingAddress = SET_OF(name='forwardingAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')), opt=True)
    _MMR4FRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMR4FRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4FRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4FRecord._cont = ASN1Dict([
        ('recordType', _MMR4FRecord_recordType),
        ('recipientMmsRSAddress', _MMR4FRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMR4FRecord_originatorMmsRSAddress),
        ('messageID', _MMR4FRecord_messageID),
        ('mms3GPPVersion', _MMR4FRecord_mms3GPPVersion),
        ('originatorAddress', _MMR4FRecord_originatorAddress),
        ('recipientAddresses', _MMR4FRecord_recipientAddresses),
        ('contentType', _MMR4FRecord_contentType),
        ('mmComponentType', _MMR4FRecord_mmComponentType),
        ('messageSize', _MMR4FRecord_messageSize),
        ('messageClass', _MMR4FRecord_messageClass),
        ('submissionTime', _MMR4FRecord_submissionTime),
        ('timeOfExpiry', _MMR4FRecord_timeOfExpiry),
        ('deliveryReportRequested', _MMR4FRecord_deliveryReportRequested),
        ('priority', _MMR4FRecord_priority),
        ('senderVisibility', _MMR4FRecord_senderVisibility),
        ('readReplyRequested', _MMR4FRecord_readReplyRequested),
        ('requestStatusCode', _MMR4FRecord_requestStatusCode),
        ('statusText', _MMR4FRecord_statusText),
        ('acknowledgementRequest', _MMR4FRecord_acknowledgementRequest),
        ('forwardCounter', _MMR4FRecord_forwardCounter),
        ('forwardingAddress', _MMR4FRecord_forwardingAddress),
        ('recordTimeStamp', _MMR4FRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR4FRecord_localSequenceNumber),
        ('recordExtensions', _MMR4FRecord_recordExtensions),
        ])
    MMR4FRecord._ext = None
    
    #-----< MMR1NRqRecord >-----#
    MMR1NRqRecord = SET(name='MMR1NRqRecord', mode=MODE_TYPE)
    _MMR1NRqRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1NRqRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1NRqRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1NRqRecord_replyChargingID = OCT_STR(name='replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_senderAddress = SEQ(name='senderAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1NRqRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1NRqRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1NRqRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMR1NRqRecord_mmComponentType = SEQ(name='mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMR1NRqRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMR1NRqRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1NRqRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1NRqRecord_deliveryReportRequested = BOOL(name='deliveryReportRequested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_replyCharging = BOOL(name='replyCharging', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_replyDeadline = CHOICE(name='replyDeadline', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1NRqRecord_replyChargingSize = INT(name='replyChargingSize', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMR1NRqRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1NRqRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1NRqRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1NRqRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1NRqRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1NRqRecord_mscfInformation = SET(name='mscfInformation', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MSCFInformation')), opt=True)
    _MMR1NRqRecord_vaspID = OCT_STR(name='vaspID', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_vasID = OCT_STR(name='vasID', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1NRqRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1NRqRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1NRqRecord._cont = ASN1Dict([
        ('recordType', _MMR1NRqRecord_recordType),
        ('recipientMmsRSAddress', _MMR1NRqRecord_recipientMmsRSAddress),
        ('messageID', _MMR1NRqRecord_messageID),
        ('replyChargingID', _MMR1NRqRecord_replyChargingID),
        ('senderAddress', _MMR1NRqRecord_senderAddress),
        ('recipientAddress', _MMR1NRqRecord_recipientAddress),
        ('accessCorrelation', _MMR1NRqRecord_accessCorrelation),
        ('messageClass', _MMR1NRqRecord_messageClass),
        ('mmComponentType', _MMR1NRqRecord_mmComponentType),
        ('messageSize', _MMR1NRqRecord_messageSize),
        ('timeOfExpiry', _MMR1NRqRecord_timeOfExpiry),
        ('messageReference', _MMR1NRqRecord_messageReference),
        ('deliveryReportRequested', _MMR1NRqRecord_deliveryReportRequested),
        ('replyCharging', _MMR1NRqRecord_replyCharging),
        ('replyDeadline', _MMR1NRqRecord_replyDeadline),
        ('replyChargingSize', _MMR1NRqRecord_replyChargingSize),
        ('mmStatusCode', _MMR1NRqRecord_mmStatusCode),
        ('statusText', _MMR1NRqRecord_statusText),
        ('recordTimeStamp', _MMR1NRqRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR1NRqRecord_localSequenceNumber),
        ('recordExtensions', _MMR1NRqRecord_recordExtensions),
        ('mscfInformation', _MMR1NRqRecord_mscfInformation),
        ('vaspID', _MMR1NRqRecord_vaspID),
        ('vasID', _MMR1NRqRecord_vasID),
        ('sGSNPLMNIdentifier', _MMR1NRqRecord_sGSNPLMNIdentifier),
        ('rATType', _MMR1NRqRecord_rATType),
        ('mSTimeZone', _MMR1NRqRecord_mSTimeZone),
        ])
    MMR1NRqRecord._ext = None
    
    #-----< MMR1NRsRecord >-----#
    MMR1NRsRecord = SET(name='MMR1NRsRecord', mode=MODE_TYPE)
    _MMR1NRsRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1NRsRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1NRsRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1NRsRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1NRsRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1NRsRecord_reportAllowed = BOOL(name='reportAllowed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRsRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1NRsRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1NRsRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1NRsRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1NRsRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1NRsRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1NRsRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1NRsRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1NRsRecord._cont = ASN1Dict([
        ('recordType', _MMR1NRsRecord_recordType),
        ('recipientMmsRSAddress', _MMR1NRsRecord_recipientMmsRSAddress),
        ('messageID', _MMR1NRsRecord_messageID),
        ('recipientAddress', _MMR1NRsRecord_recipientAddress),
        ('accessCorrelation', _MMR1NRsRecord_accessCorrelation),
        ('reportAllowed', _MMR1NRsRecord_reportAllowed),
        ('mmStatusCode', _MMR1NRsRecord_mmStatusCode),
        ('statusText', _MMR1NRsRecord_statusText),
        ('recordTimeStamp', _MMR1NRsRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR1NRsRecord_localSequenceNumber),
        ('recordExtensions', _MMR1NRsRecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMR1NRsRecord_sGSNPLMNIdentifier),
        ('rATType', _MMR1NRsRecord_rATType),
        ('mSTimeZone', _MMR1NRsRecord_mSTimeZone),
        ])
    MMR1NRsRecord._ext = None
    
    #-----< MMR1RtRecord >-----#
    MMR1RtRecord = SET(name='MMR1RtRecord', mode=MODE_TYPE)
    _MMR1RtRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1RtRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1RtRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1RtRecord_replyChargingID = OCT_STR(name='replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_senderAddress = SEQ(name='senderAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMR1RtRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1RtRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1RtRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMR1RtRecord_mmComponentType = SEQ(name='mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMR1RtRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMR1RtRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMR1RtRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMR1RtRecord_deliveryReportRequested = BOOL(name='deliveryReportRequested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_priority = ENUM(name='priority', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMR1RtRecord_readReplyRequested = BOOL(name='readReplyRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1RtRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1RtRecord_replyDeadline = CHOICE(name='replyDeadline', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1RtRecord_replyChargingSize = INT(name='replyChargingSize', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMR1RtRecord_durationOfTransmission = INT(name='durationOfTransmission', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1RtRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1RtRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1RtRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1RtRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1RtRecord_vaspID = OCT_STR(name='vaspID', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_vasID = OCT_STR(name='vasID', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1RtRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1RtRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1RtRecord._cont = ASN1Dict([
        ('recordType', _MMR1RtRecord_recordType),
        ('recipientMmsRSAddress', _MMR1RtRecord_recipientMmsRSAddress),
        ('messageID', _MMR1RtRecord_messageID),
        ('replyChargingID', _MMR1RtRecord_replyChargingID),
        ('senderAddress', _MMR1RtRecord_senderAddress),
        ('recipientAddress', _MMR1RtRecord_recipientAddress),
        ('accessCorrelation', _MMR1RtRecord_accessCorrelation),
        ('contentType', _MMR1RtRecord_contentType),
        ('mmComponentType', _MMR1RtRecord_mmComponentType),
        ('messageClass', _MMR1RtRecord_messageClass),
        ('submissionTime', _MMR1RtRecord_submissionTime),
        ('messageSize', _MMR1RtRecord_messageSize),
        ('deliveryReportRequested', _MMR1RtRecord_deliveryReportRequested),
        ('priority', _MMR1RtRecord_priority),
        ('readReplyRequested', _MMR1RtRecord_readReplyRequested),
        ('mmStatusCode', _MMR1RtRecord_mmStatusCode),
        ('statusText', _MMR1RtRecord_statusText),
        ('replyDeadline', _MMR1RtRecord_replyDeadline),
        ('replyChargingSize', _MMR1RtRecord_replyChargingSize),
        ('durationOfTransmission', _MMR1RtRecord_durationOfTransmission),
        ('timeOfExpiry', _MMR1RtRecord_timeOfExpiry),
        ('recordTimeStamp', _MMR1RtRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR1RtRecord_localSequenceNumber),
        ('recordExtensions', _MMR1RtRecord_recordExtensions),
        ('messageReference', _MMR1RtRecord_messageReference),
        ('vaspID', _MMR1RtRecord_vaspID),
        ('vasID', _MMR1RtRecord_vasID),
        ('sGSNPLMNIdentifier', _MMR1RtRecord_sGSNPLMNIdentifier),
        ('rATType', _MMR1RtRecord_rATType),
        ('mSTimeZone', _MMR1RtRecord_mSTimeZone),
        ])
    MMR1RtRecord._ext = None
    
    #-----< MMR1ARecord >-----#
    MMR1ARecord = SET(name='MMR1ARecord', mode=MODE_TYPE)
    _MMR1ARecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1ARecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1ARecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1ARecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1ARecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1ARecord_reportAllowed = BOOL(name='reportAllowed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1ARecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1ARecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1ARecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1ARecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1ARecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1ARecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1ARecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1ARecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1ARecord._cont = ASN1Dict([
        ('recordType', _MMR1ARecord_recordType),
        ('recipientMmsRSAddress', _MMR1ARecord_recipientMmsRSAddress),
        ('messageID', _MMR1ARecord_messageID),
        ('recipientAddress', _MMR1ARecord_recipientAddress),
        ('accessCorrelation', _MMR1ARecord_accessCorrelation),
        ('reportAllowed', _MMR1ARecord_reportAllowed),
        ('mmStatusCode', _MMR1ARecord_mmStatusCode),
        ('statusText', _MMR1ARecord_statusText),
        ('recordTimeStamp', _MMR1ARecord_recordTimeStamp),
        ('localSequenceNumber', _MMR1ARecord_localSequenceNumber),
        ('recordExtensions', _MMR1ARecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMR1ARecord_sGSNPLMNIdentifier),
        ('rATType', _MMR1ARecord_rATType),
        ('mSTimeZone', _MMR1ARecord_mSTimeZone),
        ])
    MMR1ARecord._ext = None
    
    #-----< MMR4DRqRecord >-----#
    MMR4DRqRecord = SET(name='MMR4DRqRecord', mode=MODE_TYPE)
    _MMR4DRqRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4DRqRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRqRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRqRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4DRqRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4DRqRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4DRqRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4DRqRecord_mmDateAndTime = OCT_STR(name='mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4DRqRecord_acknowledgementRequest = BOOL(name='acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4DRqRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR4DRqRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4DRqRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4DRqRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4DRqRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4DRqRecord._cont = ASN1Dict([
        ('recordType', _MMR4DRqRecord_recordType),
        ('recipientMmsRSAddress', _MMR4DRqRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMR4DRqRecord_originatorMmsRSAddress),
        ('messageID', _MMR4DRqRecord_messageID),
        ('mms3GPPVersion', _MMR4DRqRecord_mms3GPPVersion),
        ('originatorAddress', _MMR4DRqRecord_originatorAddress),
        ('recipientAddress', _MMR4DRqRecord_recipientAddress),
        ('mmDateAndTime', _MMR4DRqRecord_mmDateAndTime),
        ('acknowledgementRequest', _MMR4DRqRecord_acknowledgementRequest),
        ('mmStatusCode', _MMR4DRqRecord_mmStatusCode),
        ('statusText', _MMR4DRqRecord_statusText),
        ('recordTimeStamp', _MMR4DRqRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR4DRqRecord_localSequenceNumber),
        ('recordExtensions', _MMR4DRqRecord_recordExtensions),
        ])
    MMR4DRqRecord._ext = None
    
    #-----< MMR4DRsRecord >-----#
    MMR4DRsRecord = SET(name='MMR4DRsRecord', mode=MODE_TYPE)
    _MMR4DRsRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4DRsRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRsRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRsRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4DRsRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4DRsRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMR4DRsRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4DRsRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4DRsRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4DRsRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4DRsRecord._cont = ASN1Dict([
        ('recordType', _MMR4DRsRecord_recordType),
        ('recipientMmsRSAddress', _MMR4DRsRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMR4DRsRecord_originatorMmsRSAddress),
        ('messageID', _MMR4DRsRecord_messageID),
        ('mms3GPPVersion', _MMR4DRsRecord_mms3GPPVersion),
        ('requestStatusCode', _MMR4DRsRecord_requestStatusCode),
        ('statusText', _MMR4DRsRecord_statusText),
        ('recordTimeStamp', _MMR4DRsRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR4DRsRecord_localSequenceNumber),
        ('recordExtensions', _MMR4DRsRecord_recordExtensions),
        ])
    MMR4DRsRecord._ext = None
    
    #-----< MMR1RRRecord >-----#
    MMR1RRRecord = SET(name='MMR1RRRecord', mode=MODE_TYPE)
    _MMR1RRRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1RRRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1RRRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1RRRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1RRRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1RRRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1RRRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1RRRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1RRRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1RRRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1RRRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1RRRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1RRRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1RRRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1RRRecord._cont = ASN1Dict([
        ('recordType', _MMR1RRRecord_recordType),
        ('recipientMmsRSAddress', _MMR1RRRecord_recipientMmsRSAddress),
        ('messageID', _MMR1RRRecord_messageID),
        ('recipientAddress', _MMR1RRRecord_recipientAddress),
        ('originatorAddress', _MMR1RRRecord_originatorAddress),
        ('accessCorrelation', _MMR1RRRecord_accessCorrelation),
        ('mmStatusCode', _MMR1RRRecord_mmStatusCode),
        ('statusText', _MMR1RRRecord_statusText),
        ('recordTimeStamp', _MMR1RRRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR1RRRecord_localSequenceNumber),
        ('recordExtensions', _MMR1RRRecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMR1RRRecord_sGSNPLMNIdentifier),
        ('rATType', _MMR1RRRecord_rATType),
        ('mSTimeZone', _MMR1RRRecord_mSTimeZone),
        ])
    MMR1RRRecord._ext = None
    
    #-----< MMR4RRqRecord >-----#
    MMR4RRqRecord = SET(name='MMR4RRqRecord', mode=MODE_TYPE)
    _MMR4RRqRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4RRqRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRqRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRqRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4RRqRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4RRqRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4RRqRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4RRqRecord_mmDateAndTime = OCT_STR(name='mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4RRqRecord_acknowledgementRequest = BOOL(name='acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4RRqRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR4RRqRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4RRqRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4RRqRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4RRqRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4RRqRecord._cont = ASN1Dict([
        ('recordType', _MMR4RRqRecord_recordType),
        ('recipientMmsRSAddress', _MMR4RRqRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMR4RRqRecord_originatorMmsRSAddress),
        ('messageID', _MMR4RRqRecord_messageID),
        ('mms3GPPVersion', _MMR4RRqRecord_mms3GPPVersion),
        ('originatorAddress', _MMR4RRqRecord_originatorAddress),
        ('recipientAddress', _MMR4RRqRecord_recipientAddress),
        ('mmDateAndTime', _MMR4RRqRecord_mmDateAndTime),
        ('acknowledgementRequest', _MMR4RRqRecord_acknowledgementRequest),
        ('mmStatusCode', _MMR4RRqRecord_mmStatusCode),
        ('statusText', _MMR4RRqRecord_statusText),
        ('recordTimeStamp', _MMR4RRqRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR4RRqRecord_localSequenceNumber),
        ('recordExtensions', _MMR4RRqRecord_recordExtensions),
        ])
    MMR4RRqRecord._ext = None
    
    #-----< MMR4RRsRecord >-----#
    MMR4RRsRecord = SET(name='MMR4RRsRecord', mode=MODE_TYPE)
    _MMR4RRsRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4RRsRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRsRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRsRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4RRsRecord_mms3GPPVersion = OCT_STR(name='mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4RRsRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMR4RRsRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4RRsRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4RRsRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4RRsRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4RRsRecord._cont = ASN1Dict([
        ('recordType', _MMR4RRsRecord_recordType),
        ('recipientMmsRSAddress', _MMR4RRsRecord_recipientMmsRSAddress),
        ('originatorMmsRSAddress', _MMR4RRsRecord_originatorMmsRSAddress),
        ('messageID', _MMR4RRsRecord_messageID),
        ('mms3GPPVersion', _MMR4RRsRecord_mms3GPPVersion),
        ('requestStatusCode', _MMR4RRsRecord_requestStatusCode),
        ('statusText', _MMR4RRsRecord_statusText),
        ('recordTimeStamp', _MMR4RRsRecord_recordTimeStamp),
        ('localSequenceNumber', _MMR4RRsRecord_localSequenceNumber),
        ('recordExtensions', _MMR4RRsRecord_recordExtensions),
        ])
    MMR4RRsRecord._ext = None
    
    #-----< MMRMDRecord >-----#
    MMRMDRecord = SET(name='MMRMDRecord', mode=MODE_TYPE)
    _MMRMDRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMRMDRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMRMDRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMRMDRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMRMDRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMRMDRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMRMDRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMRMDRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMRMDRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMRMDRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMRMDRecord._cont = ASN1Dict([
        ('recordType', _MMRMDRecord_recordType),
        ('originatorMmsRSAddress', _MMRMDRecord_originatorMmsRSAddress),
        ('recipientMmsRSAddress', _MMRMDRecord_recipientMmsRSAddress),
        ('messageID', _MMRMDRecord_messageID),
        ('messageSize', _MMRMDRecord_messageSize),
        ('mmStatusCode', _MMRMDRecord_mmStatusCode),
        ('statusText', _MMRMDRecord_statusText),
        ('recordTimeStamp', _MMRMDRecord_recordTimeStamp),
        ('localSequenceNumber', _MMRMDRecord_localSequenceNumber),
        ('recordExtensions', _MMRMDRecord_recordExtensions),
        ])
    MMRMDRecord._ext = None
    
    #-----< MMFRecord >-----#
    MMFRecord = SET(name='MMFRecord', mode=MODE_TYPE)
    _MMFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMFRecord_forwardingMmsRSAddress = SEQ(name='forwardingMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMFRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMFRecord_forwardingAddress = SEQ(name='forwardingAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMFRecord_recipientAddresses = SET_OF(name='recipientAddresses', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMFRecord_chargeInformation = SEQ(name='chargeInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeInformation')), opt=True)
    _MMFRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMFRecord_earliestTimeOfDelivery = CHOICE(name='earliestTimeOfDelivery', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMFRecord_deliveryReportRequested = BOOL(name='deliveryReportRequested', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMFRecord_readReplyRequested = BOOL(name='readReplyRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMFRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMFRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMFRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMFRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMFRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMFRecord_mMBoxstorageInformation = SET(name='mMBoxstorageInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBoxStorageInformation')), opt=True)
    MMFRecord._cont = ASN1Dict([
        ('recordType', _MMFRecord_recordType),
        ('forwardingMmsRSAddress', _MMFRecord_forwardingMmsRSAddress),
        ('messageID', _MMFRecord_messageID),
        ('forwardingAddress', _MMFRecord_forwardingAddress),
        ('recipientAddresses', _MMFRecord_recipientAddresses),
        ('chargeInformation', _MMFRecord_chargeInformation),
        ('timeOfExpiry', _MMFRecord_timeOfExpiry),
        ('earliestTimeOfDelivery', _MMFRecord_earliestTimeOfDelivery),
        ('deliveryReportRequested', _MMFRecord_deliveryReportRequested),
        ('readReplyRequested', _MMFRecord_readReplyRequested),
        ('messageReference', _MMFRecord_messageReference),
        ('mmStatusCode', _MMFRecord_mmStatusCode),
        ('statusText', _MMFRecord_statusText),
        ('recordTimeStamp', _MMFRecord_recordTimeStamp),
        ('localSequenceNumber', _MMFRecord_localSequenceNumber),
        ('recordExtensions', _MMFRecord_recordExtensions),
        ('mMBoxstorageInformation', _MMFRecord_mMBoxstorageInformation),
        ])
    MMFRecord._ext = None
    
    #-----< MMBx1SRecord >-----#
    MMBx1SRecord = SET(name='MMBx1SRecord', mode=MODE_TYPE)
    _MMBx1SRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1SRecord_mmsRelayAddress = CHOICE(name='mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1SRecord_managingAddress = SEQ(name='managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1SRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1SRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')), opt=True)
    _MMBx1SRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMBx1SRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_mmState = OCT_STR(name='mmState', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_mmFlags = OCT_STR(name='mmFlags', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_storeStatus = INT(name='storeStatus', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StoreStatus')), opt=True)
    _MMBx1SRecord_storeStatusText = OCT_STR(name='storeStatusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1SRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1SRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1SRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1SRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1SRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1SRecord._cont = ASN1Dict([
        ('recordType', _MMBx1SRecord_recordType),
        ('mmsRelayAddress', _MMBx1SRecord_mmsRelayAddress),
        ('managingAddress', _MMBx1SRecord_managingAddress),
        ('accessCorrelation', _MMBx1SRecord_accessCorrelation),
        ('contentType', _MMBx1SRecord_contentType),
        ('messageSize', _MMBx1SRecord_messageSize),
        ('messageReference', _MMBx1SRecord_messageReference),
        ('mmState', _MMBx1SRecord_mmState),
        ('mmFlags', _MMBx1SRecord_mmFlags),
        ('storeStatus', _MMBx1SRecord_storeStatus),
        ('storeStatusText', _MMBx1SRecord_storeStatusText),
        ('sequenceNumber', _MMBx1SRecord_sequenceNumber),
        ('timeStamp', _MMBx1SRecord_timeStamp),
        ('recordExtensions', _MMBx1SRecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMBx1SRecord_sGSNPLMNIdentifier),
        ('rATType', _MMBx1SRecord_rATType),
        ('mSTimeZone', _MMBx1SRecord_mSTimeZone),
        ])
    MMBx1SRecord._ext = None
    
    #-----< MMBx1VRecord >-----#
    MMBx1VRecord = SET(name='MMBx1VRecord', mode=MODE_TYPE)
    _MMBx1VRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1VRecord_mmsRelayAddress = CHOICE(name='mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1VRecord_managingAddress = SEQ(name='managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1VRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1VRecord_attributesList = SEQ(name='attributesList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AttributesList')), opt=True)
    _MMBx1VRecord_messageSelection = INT(name='messageSelection', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MessageSelection')), opt=True)
    _MMBx1VRecord_start = INT(name='start', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_limit = INT(name='limit', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_totalsRequested = BOOL(name='totalsRequested', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_quotasRequested = BOOL(name='quotasRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_mmListing = SEQ(name='mmListing', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AttributesList')), opt=True)
    _MMBx1VRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMBx1VRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1VRecord_totals = SEQ(name='totals', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'Totals')), opt=True)
    _MMBx1VRecord_quotas = SEQ(name='quotas', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'Quotas')), opt=True)
    _MMBx1VRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1VRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1VRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1VRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1VRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1VRecord._cont = ASN1Dict([
        ('recordType', _MMBx1VRecord_recordType),
        ('mmsRelayAddress', _MMBx1VRecord_mmsRelayAddress),
        ('managingAddress', _MMBx1VRecord_managingAddress),
        ('accessCorrelation', _MMBx1VRecord_accessCorrelation),
        ('attributesList', _MMBx1VRecord_attributesList),
        ('messageSelection', _MMBx1VRecord_messageSelection),
        ('start', _MMBx1VRecord_start),
        ('limit', _MMBx1VRecord_limit),
        ('totalsRequested', _MMBx1VRecord_totalsRequested),
        ('quotasRequested', _MMBx1VRecord_quotasRequested),
        ('mmListing', _MMBx1VRecord_mmListing),
        ('requestStatusCode', _MMBx1VRecord_requestStatusCode),
        ('statusText', _MMBx1VRecord_statusText),
        ('totals', _MMBx1VRecord_totals),
        ('quotas', _MMBx1VRecord_quotas),
        ('sequenceNumber', _MMBx1VRecord_sequenceNumber),
        ('timeStamp', _MMBx1VRecord_timeStamp),
        ('recordExtensions', _MMBx1VRecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMBx1VRecord_sGSNPLMNIdentifier),
        ('rATType', _MMBx1VRecord_rATType),
        ('mSTimeZone', _MMBx1VRecord_mSTimeZone),
        ])
    MMBx1VRecord._ext = None
    
    #-----< MMBx1URecord >-----#
    MMBx1URecord = SET(name='MMBx1URecord', mode=MODE_TYPE)
    _MMBx1URecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1URecord_mmsRelayAddress = CHOICE(name='mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1URecord_managingAddress = SEQ(name='managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1URecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1URecord_recipientsAddressList = SET_OF(name='recipientsAddressList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMBx1URecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMBx1URecord_uploadTime = OCT_STR(name='uploadTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1URecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMBx1URecord_earliestTimeOfDelivery = CHOICE(name='earliestTimeOfDelivery', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMBx1URecord_priority = ENUM(name='priority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMBx1URecord_mmState = OCT_STR(name='mmState', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_mmFlags = OCT_STR(name='mmFlags', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')), opt=True)
    _MMBx1URecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMBx1URecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMBx1URecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1URecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1URecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1URecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1URecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1URecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1URecord._cont = ASN1Dict([
        ('recordType', _MMBx1URecord_recordType),
        ('mmsRelayAddress', _MMBx1URecord_mmsRelayAddress),
        ('managingAddress', _MMBx1URecord_managingAddress),
        ('accessCorrelation', _MMBx1URecord_accessCorrelation),
        ('recipientsAddressList', _MMBx1URecord_recipientsAddressList),
        ('messageClass', _MMBx1URecord_messageClass),
        ('uploadTime', _MMBx1URecord_uploadTime),
        ('timeOfExpiry', _MMBx1URecord_timeOfExpiry),
        ('earliestTimeOfDelivery', _MMBx1URecord_earliestTimeOfDelivery),
        ('priority', _MMBx1URecord_priority),
        ('mmState', _MMBx1URecord_mmState),
        ('mmFlags', _MMBx1URecord_mmFlags),
        ('contentType', _MMBx1URecord_contentType),
        ('messageSize', _MMBx1URecord_messageSize),
        ('messageReference', _MMBx1URecord_messageReference),
        ('requestStatusCode', _MMBx1URecord_requestStatusCode),
        ('statusText', _MMBx1URecord_statusText),
        ('sequenceNumber', _MMBx1URecord_sequenceNumber),
        ('timeStamp', _MMBx1URecord_timeStamp),
        ('recordExtensions', _MMBx1URecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMBx1URecord_sGSNPLMNIdentifier),
        ('rATType', _MMBx1URecord_rATType),
        ('mSTimeZone', _MMBx1URecord_mSTimeZone),
        ])
    MMBx1URecord._ext = None
    
    #-----< MMBx1DRecord >-----#
    MMBx1DRecord = SET(name='MMBx1DRecord', mode=MODE_TYPE)
    _MMBx1DRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1DRecord_mmsRelayAddress = CHOICE(name='mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1DRecord_managingAddress = SEQ(name='managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1DRecord_accessCorrelation = CHOICE(name='accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1DRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1DRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMBx1DRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1DRecord_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1DRecord_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1DRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1DRecord_sGSNPLMNIdentifier = OCT_STR(name='sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1DRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1DRecord_mSTimeZone = OCT_STR(name='mSTimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1DRecord._cont = ASN1Dict([
        ('recordType', _MMBx1DRecord_recordType),
        ('mmsRelayAddress', _MMBx1DRecord_mmsRelayAddress),
        ('managingAddress', _MMBx1DRecord_managingAddress),
        ('accessCorrelation', _MMBx1DRecord_accessCorrelation),
        ('messageReference', _MMBx1DRecord_messageReference),
        ('requestStatusCode', _MMBx1DRecord_requestStatusCode),
        ('statusText', _MMBx1DRecord_statusText),
        ('sequenceNumber', _MMBx1DRecord_sequenceNumber),
        ('timeStamp', _MMBx1DRecord_timeStamp),
        ('recordExtensions', _MMBx1DRecord_recordExtensions),
        ('sGSNPLMNIdentifier', _MMBx1DRecord_sGSNPLMNIdentifier),
        ('rATType', _MMBx1DRecord_rATType),
        ('mSTimeZone', _MMBx1DRecord_mSTimeZone),
        ])
    MMBx1DRecord._ext = None
    
    #-----< MM7SRecord >-----#
    MM7SRecord = SET(name='MM7SRecord', mode=MODE_TYPE)
    _MM7SRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7SRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7SRecord_linkedID = OCT_STR(name='linkedID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_vaspID = OCT_STR(name='vaspID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7SRecord_vasID = OCT_STR(name='vasID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7SRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7SRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7SRecord_recipientAddresses = SET_OF(name='recipientAddresses', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MM7SRecord_serviceCode = OCT_STR(name='serviceCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MM7SRecord_mmComponentType = SEQ(name='mmComponentType', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MM7SRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MM7SRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MM7SRecord_chargeInformation = SEQ(name='chargeInformation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeInformation')), opt=True)
    _MM7SRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7SRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7SRecord_earliestTimeOfDelivery = CHOICE(name='earliestTimeOfDelivery', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7SRecord_deliveryReportRequested = BOOL(name='deliveryReportRequested', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_readReplyRequested = BOOL(name='readReplyRequested', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_replyCharging = BOOL(name='replyCharging', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_replyDeadline = CHOICE(name='replyDeadline', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7SRecord_replyChargingSize = INT(name='replyChargingSize', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MM7SRecord_priority = ENUM(name='priority', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MM7SRecord_messageDistributionIndicator = BOOL(name='messageDistributionIndicator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7SRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7SRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MM7SRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7SRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MM7SRecord_mscfInformation = SET(name='mscfInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MSCFInformation')), opt=True)
    MM7SRecord._cont = ASN1Dict([
        ('recordType', _MM7SRecord_recordType),
        ('originatorMmsRSAddress', _MM7SRecord_originatorMmsRSAddress),
        ('linkedID', _MM7SRecord_linkedID),
        ('vaspID', _MM7SRecord_vaspID),
        ('vasID', _MM7SRecord_vasID),
        ('messageID', _MM7SRecord_messageID),
        ('originatorAddress', _MM7SRecord_originatorAddress),
        ('recipientAddresses', _MM7SRecord_recipientAddresses),
        ('serviceCode', _MM7SRecord_serviceCode),
        ('contentType', _MM7SRecord_contentType),
        ('mmComponentType', _MM7SRecord_mmComponentType),
        ('messageSize', _MM7SRecord_messageSize),
        ('messageClass', _MM7SRecord_messageClass),
        ('chargeInformation', _MM7SRecord_chargeInformation),
        ('submissionTime', _MM7SRecord_submissionTime),
        ('timeOfExpiry', _MM7SRecord_timeOfExpiry),
        ('earliestTimeOfDelivery', _MM7SRecord_earliestTimeOfDelivery),
        ('deliveryReportRequested', _MM7SRecord_deliveryReportRequested),
        ('readReplyRequested', _MM7SRecord_readReplyRequested),
        ('replyCharging', _MM7SRecord_replyCharging),
        ('replyDeadline', _MM7SRecord_replyDeadline),
        ('replyChargingSize', _MM7SRecord_replyChargingSize),
        ('priority', _MM7SRecord_priority),
        ('messageDistributionIndicator', _MM7SRecord_messageDistributionIndicator),
        ('requestStatusCode', _MM7SRecord_requestStatusCode),
        ('statusText', _MM7SRecord_statusText),
        ('recordTimeStamp', _MM7SRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7SRecord_localSequenceNumber),
        ('recordExtensions', _MM7SRecord_recordExtensions),
        ('mscfInformation', _MM7SRecord_mscfInformation),
        ])
    MM7SRecord._ext = None
    
    #-----< MM7DRqRecord >-----#
    MM7DRqRecord = SET(name='MM7DRqRecord', mode=MODE_TYPE)
    _MM7DRqRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRqRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7DRqRecord_linkedID = OCT_STR(name='linkedID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7DRqRecord_replyChargingID = OCT_STR(name='replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7DRqRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRqRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRqRecord_mmComponentType = SEQ(name='mmComponentType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MM7DRqRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MM7DRqRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MM7DRqRecord_priority = ENUM(name='priority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MM7DRqRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRqRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRqRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRqRecord._cont = ASN1Dict([
        ('recordType', _MM7DRqRecord_recordType),
        ('recipientMmsRSAddress', _MM7DRqRecord_recipientMmsRSAddress),
        ('linkedID', _MM7DRqRecord_linkedID),
        ('replyChargingID', _MM7DRqRecord_replyChargingID),
        ('originatorAddress', _MM7DRqRecord_originatorAddress),
        ('recipientAddress', _MM7DRqRecord_recipientAddress),
        ('mmComponentType', _MM7DRqRecord_mmComponentType),
        ('messageSize', _MM7DRqRecord_messageSize),
        ('contentType', _MM7DRqRecord_contentType),
        ('priority', _MM7DRqRecord_priority),
        ('recordTimeStamp', _MM7DRqRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7DRqRecord_localSequenceNumber),
        ('recordExtensions', _MM7DRqRecord_recordExtensions),
        ])
    MM7DRqRecord._ext = None
    
    #-----< MM7DRsRecord >-----#
    MM7DRsRecord = SET(name='MM7DRsRecord', mode=MODE_TYPE)
    _MM7DRsRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRsRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7DRsRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7DRsRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRsRecord_serviceCode = OCT_STR(name='serviceCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7DRsRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7DRsRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7DRsRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRsRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRsRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRsRecord._cont = ASN1Dict([
        ('recordType', _MM7DRsRecord_recordType),
        ('recipientMmsRSAddress', _MM7DRsRecord_recipientMmsRSAddress),
        ('messageID', _MM7DRsRecord_messageID),
        ('recipientAddress', _MM7DRsRecord_recipientAddress),
        ('serviceCode', _MM7DRsRecord_serviceCode),
        ('requestStatusCode', _MM7DRsRecord_requestStatusCode),
        ('statusText', _MM7DRsRecord_statusText),
        ('recordTimeStamp', _MM7DRsRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7DRsRecord_localSequenceNumber),
        ('recordExtensions', _MM7DRsRecord_recordExtensions),
        ])
    MM7DRsRecord._ext = None
    
    #-----< MM7CRecord >-----#
    MM7CRecord = SET(name='MM7CRecord', mode=MODE_TYPE)
    _MM7CRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7CRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7CRecord_vaspID = OCT_STR(name='vaspID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7CRecord_vasID = OCT_STR(name='vasID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7CRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7CRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7CRecord_serviceCode = OCT_STR(name='serviceCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7CRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7CRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7CRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7CRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7CRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7CRecord._cont = ASN1Dict([
        ('recordType', _MM7CRecord_recordType),
        ('originatorMmsRSAddress', _MM7CRecord_originatorMmsRSAddress),
        ('vaspID', _MM7CRecord_vaspID),
        ('vasID', _MM7CRecord_vasID),
        ('messageID', _MM7CRecord_messageID),
        ('originatorAddress', _MM7CRecord_originatorAddress),
        ('serviceCode', _MM7CRecord_serviceCode),
        ('requestStatusCode', _MM7CRecord_requestStatusCode),
        ('statusText', _MM7CRecord_statusText),
        ('recordTimeStamp', _MM7CRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7CRecord_localSequenceNumber),
        ('recordExtensions', _MM7CRecord_recordExtensions),
        ])
    MM7CRecord._ext = None
    
    #-----< MM7RRecord >-----#
    MM7RRecord = SET(name='MM7RRecord', mode=MODE_TYPE)
    _MM7RRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7RRecord_originatorMmsRSAddress = SEQ(name='originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7RRecord_vaspID = OCT_STR(name='vaspID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRecord_vasID = OCT_STR(name='vasID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7RRecord_serviceCode = OCT_STR(name='serviceCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7RRecord_contentType = OCT_STR(name='contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MM7RRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRecord_timeOfExpiry = CHOICE(name='timeOfExpiry', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7RRecord_earliestTimeOfDelivery = CHOICE(name='earliestTimeOfDelivery', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7RRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7RRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7RRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7RRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7RRecord._cont = ASN1Dict([
        ('recordType', _MM7RRecord_recordType),
        ('originatorMmsRSAddress', _MM7RRecord_originatorMmsRSAddress),
        ('vaspID', _MM7RRecord_vaspID),
        ('vasID', _MM7RRecord_vasID),
        ('messageID', _MM7RRecord_messageID),
        ('originatorAddress', _MM7RRecord_originatorAddress),
        ('serviceCode', _MM7RRecord_serviceCode),
        ('contentType', _MM7RRecord_contentType),
        ('submissionTime', _MM7RRecord_submissionTime),
        ('timeOfExpiry', _MM7RRecord_timeOfExpiry),
        ('earliestTimeOfDelivery', _MM7RRecord_earliestTimeOfDelivery),
        ('requestStatusCode', _MM7RRecord_requestStatusCode),
        ('statusText', _MM7RRecord_statusText),
        ('recordTimeStamp', _MM7RRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7RRecord_localSequenceNumber),
        ('recordExtensions', _MM7RRecord_recordExtensions),
        ])
    MM7RRecord._ext = None
    
    #-----< MM7DRRqRecord >-----#
    MM7DRRqRecord = SET(name='MM7DRRqRecord', mode=MODE_TYPE)
    _MM7DRRqRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRRqRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7DRRqRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7DRRqRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7DRRqRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRRqRecord_mmDateAndTime = OCT_STR(name='mmDateAndTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRRqRecord_mmStatusCode = ENUM(name='mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')))
    _MM7DRRqRecord_mmStatusText = OCT_STR(name='mmStatusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7DRRqRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRRqRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRRqRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRRqRecord._cont = ASN1Dict([
        ('recordType', _MM7DRRqRecord_recordType),
        ('recipientMmsRSAddress', _MM7DRRqRecord_recipientMmsRSAddress),
        ('messageID', _MM7DRRqRecord_messageID),
        ('originatorAddress', _MM7DRRqRecord_originatorAddress),
        ('recipientAddress', _MM7DRRqRecord_recipientAddress),
        ('mmDateAndTime', _MM7DRRqRecord_mmDateAndTime),
        ('mmStatusCode', _MM7DRRqRecord_mmStatusCode),
        ('mmStatusText', _MM7DRRqRecord_mmStatusText),
        ('recordTimeStamp', _MM7DRRqRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7DRRqRecord_localSequenceNumber),
        ('recordExtensions', _MM7DRRqRecord_recordExtensions),
        ])
    MM7DRRqRecord._ext = None
    
    #-----< MM7DRRsRecord >-----#
    MM7DRRsRecord = SET(name='MM7DRRsRecord', mode=MODE_TYPE)
    _MM7DRRsRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRRsRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7DRRsRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7DRRsRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7DRRsRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRRsRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7DRRsRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7DRRsRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRRsRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRRsRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRRsRecord._cont = ASN1Dict([
        ('recordType', _MM7DRRsRecord_recordType),
        ('recipientMmsRSAddress', _MM7DRRsRecord_recipientMmsRSAddress),
        ('messageID', _MM7DRRsRecord_messageID),
        ('originatorAddress', _MM7DRRsRecord_originatorAddress),
        ('recipientAddress', _MM7DRRsRecord_recipientAddress),
        ('requestStatusCode', _MM7DRRsRecord_requestStatusCode),
        ('statusText', _MM7DRRsRecord_statusText),
        ('recordTimeStamp', _MM7DRRsRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7DRRsRecord_localSequenceNumber),
        ('recordExtensions', _MM7DRRsRecord_recordExtensions),
        ])
    MM7DRRsRecord._ext = None
    
    #-----< MM7RRqRecord >-----#
    MM7RRqRecord = SET(name='MM7RRqRecord', mode=MODE_TYPE)
    _MM7RRqRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7RRqRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7RRqRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRqRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7RRqRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7RRqRecord_mmDateAndTime = OCT_STR(name='mmDateAndTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRqRecord_readStatus = ENUM(name='readStatus', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')))
    _MM7RRqRecord_mmStatusText = OCT_STR(name='mmStatusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7RRqRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRqRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7RRqRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7RRqRecord._cont = ASN1Dict([
        ('recordType', _MM7RRqRecord_recordType),
        ('recipientMmsRSAddress', _MM7RRqRecord_recipientMmsRSAddress),
        ('messageID', _MM7RRqRecord_messageID),
        ('originatorAddress', _MM7RRqRecord_originatorAddress),
        ('recipientAddress', _MM7RRqRecord_recipientAddress),
        ('mmDateAndTime', _MM7RRqRecord_mmDateAndTime),
        ('readStatus', _MM7RRqRecord_readStatus),
        ('mmStatusText', _MM7RRqRecord_mmStatusText),
        ('recordTimeStamp', _MM7RRqRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7RRqRecord_localSequenceNumber),
        ('recordExtensions', _MM7RRqRecord_recordExtensions),
        ])
    MM7RRqRecord._ext = None
    
    #-----< MM7RRsRecord >-----#
    MM7RRsRecord = SET(name='MM7RRsRecord', mode=MODE_TYPE)
    _MM7RRsRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7RRsRecord_recipientMmsRSAddress = SEQ(name='recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7RRsRecord_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRsRecord_originatorAddress = SEQ(name='originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7RRsRecord_recipientAddress = SEQ(name='recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7RRsRecord_requestStatusCode = INT(name='requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7RRsRecord_statusText = OCT_STR(name='statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7RRsRecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRsRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7RRsRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7RRsRecord._cont = ASN1Dict([
        ('recordType', _MM7RRsRecord_recordType),
        ('recipientMmsRSAddress', _MM7RRsRecord_recipientMmsRSAddress),
        ('messageID', _MM7RRsRecord_messageID),
        ('originatorAddress', _MM7RRsRecord_originatorAddress),
        ('recipientAddress', _MM7RRsRecord_recipientAddress),
        ('requestStatusCode', _MM7RRsRecord_requestStatusCode),
        ('statusText', _MM7RRsRecord_statusText),
        ('recordTimeStamp', _MM7RRsRecord_recordTimeStamp),
        ('localSequenceNumber', _MM7RRsRecord_localSequenceNumber),
        ('recordExtensions', _MM7RRsRecord_recordExtensions),
        ])
    MM7RRsRecord._ext = None
    
    #-----< AccessCorrelation >-----#
    AccessCorrelation = CHOICE(name='AccessCorrelation', mode=MODE_TYPE)
    _AccessCorrelation_circuitSwitched = SEQ(name='circuitSwitched', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'CircuitSwitchedAccess')))
    _AccessCorrelation_packetSwitched = SEQ(name='packetSwitched', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'PacketSwitchedAccess')))
    AccessCorrelation._cont = ASN1Dict([
        ('circuitSwitched', _AccessCorrelation_circuitSwitched),
        ('packetSwitched', _AccessCorrelation_packetSwitched),
        ])
    AccessCorrelation._ext = None
    
    #-----< AttributesList >-----#
    AttributesList = SEQ(name='AttributesList', mode=MODE_TYPE)
    _AttributesList_messageID = OCT_STR(name='messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributesList_dateAndTime = OCT_STR(name='dateAndTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _AttributesList_senderAddress = SEQ(name='senderAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _AttributesList_subject = OCT_STR(name='subject', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributesList_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _AttributesList_mmFlags = OCT_STR(name='mmFlags', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributesList_mmState = ENUM(name='mmState', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMState')))
    AttributesList._cont = ASN1Dict([
        ('messageID', _AttributesList_messageID),
        ('dateAndTime', _AttributesList_dateAndTime),
        ('senderAddress', _AttributesList_senderAddress),
        ('subject', _AttributesList_subject),
        ('messageSize', _AttributesList_messageSize),
        ('mmFlags', _AttributesList_mmFlags),
        ('mmState', _AttributesList_mmState),
        ])
    AttributesList._ext = None
    
    #-----< ChargeInformation >-----#
    ChargeInformation = SEQ(name='ChargeInformation', mode=MODE_TYPE)
    _ChargeInformation_chargedparty = ENUM(name='chargedparty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargedParty')), opt=True)
    _ChargeInformation_chargetype = ENUM(name='chargetype', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeType')), opt=True)
    ChargeInformation._cont = ASN1Dict([
        ('chargedparty', _ChargeInformation_chargedparty),
        ('chargetype', _ChargeInformation_chargetype),
        ])
    ChargeInformation._ext = None
    
    #-----< ChargedParty >-----#
    ChargedParty = ENUM(name='ChargedParty', mode=MODE_TYPE)
    ChargedParty._cont = ASN1Dict([('sender', 0), ('recipient', 1), ('both', 2), ('neither', 3), ('notspecifiedbyVASP', 99)])
    ChargedParty._ext = None
    
    #-----< ChargeType >-----#
    ChargeType = ENUM(name='ChargeType', mode=MODE_TYPE)
    ChargeType._cont = ASN1Dict([('postpaid', 0), ('pre-paid', 1)])
    ChargeType._ext = None
    
    #-----< CircuitSwitchedAccess >-----#
    CircuitSwitchedAccess = SEQ(name='CircuitSwitchedAccess', mode=MODE_TYPE)
    _CircuitSwitchedAccess_mSCIdentifier = OCT_STR(name='mSCIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MscNo')))
    _CircuitSwitchedAccess_callReferenceNumber = OCT_STR(name='callReferenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    CircuitSwitchedAccess._cont = ASN1Dict([
        ('mSCIdentifier', _CircuitSwitchedAccess_mSCIdentifier),
        ('callReferenceNumber', _CircuitSwitchedAccess_callReferenceNumber),
        ])
    CircuitSwitchedAccess._ext = None
    
    #-----< ContentType >-----#
    ContentType = OCT_STR(name='ContentType', mode=MODE_TYPE)
    
    #-----< DataVolume >-----#
    DataVolume = INT(name='DataVolume', mode=MODE_TYPE)
    
    #-----< DeltaSeconds >-----#
    DeltaSeconds = OCT_STR(name='DeltaSeconds', mode=MODE_TYPE)
    DeltaSeconds._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MediaComponent >-----#
    MediaComponent = SEQ(name='MediaComponent', mode=MODE_TYPE)
    _MediaComponent_mediaType = OCT_STR(name='mediaType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaComponent_mediaSize = INT(name='mediaSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    MediaComponent._cont = ASN1Dict([
        ('mediaType', _MediaComponent_mediaType),
        ('mediaSize', _MediaComponent_mediaSize),
        ])
    MediaComponent._ext = None
    
    #-----< MediaComponents >-----#
    MediaComponents = SET_OF(name='MediaComponents', mode=MODE_TYPE)
    _MediaComponents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MediaComponent')))
    MediaComponents._cont = _MediaComponents__item_
    
    #-----< MessageSelection >-----#
    MessageSelection = INT(name='MessageSelection', mode=MODE_TYPE)
    
    #-----< MMBoxStorageInformation >-----#
    MMBoxStorageInformation = SET(name='MMBoxStorageInformation', mode=MODE_TYPE)
    _MMBoxStorageInformation_mmState = ENUM(name='mmState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMState')))
    _MMBoxStorageInformation_mmFlag = OCT_STR(name='mmFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMBoxStorageInformation_storeStatus = INT(name='storeStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StoreStatus')))
    _MMBoxStorageInformation_storeStatusText = OCT_STR(name='storeStatusText', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')))
    _MMBoxStorageInformation_storedMessageReference = OCT_STR(name='storedMessageReference', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MMBoxStorageInformation._cont = ASN1Dict([
        ('mmState', _MMBoxStorageInformation_mmState),
        ('mmFlag', _MMBoxStorageInformation_mmFlag),
        ('storeStatus', _MMBoxStorageInformation_storeStatus),
        ('storeStatusText', _MMBoxStorageInformation_storeStatusText),
        ('storedMessageReference', _MMBoxStorageInformation_storedMessageReference),
        ])
    MMBoxStorageInformation._ext = None
    
    #-----< MMComponentType >-----#
    MMComponentType = SEQ(name='MMComponentType', mode=MODE_TYPE)
    _MMComponentType_subject = SEQ(name='subject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'SubjectComponent')))
    _MMComponentType_media = SET_OF(name='media', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MediaComponents')))
    MMComponentType._cont = ASN1Dict([
        ('subject', _MMComponentType_subject),
        ('media', _MMComponentType_media),
        ])
    MMComponentType._ext = None
    
    #-----< MMSAgentAddress >-----#
    MMSAgentAddress = SEQ(name='MMSAgentAddress', mode=MODE_TYPE)
    _MMSAgentAddress_mMSAgentAddressData = CHOICE(name='mMSAgentAddressData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddressData')))
    _MMSAgentAddress_mMSRecipientType = SEQ_OF(name='mMSRecipientType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMSAgentAddress_mMSRecipientType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRecipientType')))
    _MMSAgentAddress_mMSRecipientType._cont = __MMSAgentAddress_mMSRecipientType__item_
    MMSAgentAddress._cont = ASN1Dict([
        ('mMSAgentAddressData', _MMSAgentAddress_mMSAgentAddressData),
        ('mMSRecipientType', _MMSAgentAddress_mMSRecipientType),
        ])
    MMSAgentAddress._ext = None
    
    #-----< MMSAgentAddresses >-----#
    MMSAgentAddresses = SET_OF(name='MMSAgentAddresses', mode=MODE_TYPE)
    _MMSAgentAddresses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    MMSAgentAddresses._cont = _MMSAgentAddresses__item_
    
    #-----< MMSAgentAddressData >-----#
    MMSAgentAddressData = CHOICE(name='MMSAgentAddressData', mode=MODE_TYPE)
    _MMSAgentAddressData_eMail_address = OCT_STR(name='eMail-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAgentAddressData_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _MMSAgentAddressData_shortCode = OCT_STR(name='shortCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MMSAgentAddressData._cont = ASN1Dict([
        ('eMail-address', _MMSAgentAddressData_eMail_address),
        ('mSISDN', _MMSAgentAddressData_mSISDN),
        ('shortCode', _MMSAgentAddressData_shortCode),
        ])
    MMSAgentAddressData._ext = None
    
    #-----< MMSRecipientType >-----#
    MMSRecipientType = ENUM(name='MMSRecipientType', mode=MODE_TYPE)
    MMSRecipientType._cont = ASN1Dict([('tO', 0), ('cC', 1), ('bCC', 2)])
    MMSRecipientType._ext = None
    
    #-----< MMSRSAddress >-----#
    MMSRSAddress = SEQ(name='MMSRSAddress', mode=MODE_TYPE)
    _MMSRSAddress_domainName = OCT_STR(name='domainName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMSRSAddress_iPAddress = CHOICE(name='iPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    MMSRSAddress._cont = ASN1Dict([
        ('domainName', _MMSRSAddress_domainName),
        ('iPAddress', _MMSRSAddress_iPAddress),
        ])
    MMSRSAddress._ext = None
    
    #-----< MMState >-----#
    MMState = ENUM(name='MMState', mode=MODE_TYPE)
    MMState._cont = ASN1Dict([('draft', 0), ('sent', 1), ('new', 2), ('retrieved', 3), ('forwarded', 4)])
    MMState._ext = None
    
    #-----< MMStatusCodeType >-----#
    MMStatusCodeType = ENUM(name='MMStatusCodeType', mode=MODE_TYPE)
    MMStatusCodeType._cont = ASN1Dict([('retrieved', 0), ('forwarded', 1), ('expired', 2), ('rejected', 3), ('deferred', 4), ('unrecognised', 5), ('read', 6), ('deletedWithoutBeingRead', 7)])
    MMStatusCodeType._ext = None
    
    #-----< MSCFInformation >-----#
    MSCFInformation = SET(name='MSCFInformation', mode=MODE_TYPE)
    _MSCFInformation_billingInformation = OCT_STR(name='billingInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MSCFInformation_routeingAddressList = SET_OF(name='routeingAddressList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RouteingAddressList')), opt=True)
    MSCFInformation._cont = ASN1Dict([
        ('billingInformation', _MSCFInformation_billingInformation),
        ('routeingAddressList', _MSCFInformation_routeingAddressList),
        ])
    MSCFInformation._ext = None
    
    #-----< PacketSwitchedAccess >-----#
    PacketSwitchedAccess = SEQ(name='PacketSwitchedAccess', mode=MODE_TYPE)
    _PacketSwitchedAccess_gSNAddress = CHOICE(name='gSNAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PacketSwitchedAccess_chargingID = INT(name='chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    PacketSwitchedAccess._cont = ASN1Dict([
        ('gSNAddress', _PacketSwitchedAccess_gSNAddress),
        ('chargingID', _PacketSwitchedAccess_chargingID),
        ])
    PacketSwitchedAccess._ext = None
    
    #-----< Quotas >-----#
    Quotas = SEQ(name='Quotas', mode=MODE_TYPE)
    _Quotas_numberOfMessages = INT(name='numberOfMessages', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Quotas_numberOfOctets = INT(name='numberOfOctets', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Quotas._cont = ASN1Dict([
        ('numberOfMessages', _Quotas_numberOfMessages),
        ('numberOfOctets', _Quotas_numberOfOctets),
        ])
    Quotas._ext = None
    
    #-----< RequestStatusCodeType >-----#
    RequestStatusCodeType = INT(name='RequestStatusCodeType', mode=MODE_TYPE)
    RequestStatusCodeType._cont = ASN1Dict([('normalRelease', 0), ('abnormalRelease', 4), ('serviceDenied', 30), ('messageFormatCorrupt', 31), ('sendingAddressUnresolved', 32), ('messageNotFound', 33), ('networkProblem', 34), ('contentNotAccepted', 35), ('unsupportedMessage', 36)])
    
    #-----< RouteingAddress >-----#
    RouteingAddress = SEQ(name='RouteingAddress', mode=MODE_TYPE)
    _RouteingAddress_eMail_address = OCT_STR(name='eMail-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RouteingAddress_mSISDN = OCT_STR(name='mSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _RouteingAddress_shortCode = OCT_STR(name='shortCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RouteingAddress._cont = ASN1Dict([
        ('eMail-address', _RouteingAddress_eMail_address),
        ('mSISDN', _RouteingAddress_mSISDN),
        ('shortCode', _RouteingAddress_shortCode),
        ])
    RouteingAddress._ext = None
    
    #-----< RouteingAddressList >-----#
    RouteingAddressList = SET_OF(name='RouteingAddressList', mode=MODE_TYPE)
    _RouteingAddressList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    RouteingAddressList._cont = _RouteingAddressList__item_
    
    #-----< StatusTextType >-----#
    StatusTextType = OCT_STR(name='StatusTextType', mode=MODE_TYPE)
    
    #-----< StoreStatus >-----#
    StoreStatus = INT(name='StoreStatus', mode=MODE_TYPE)
    StoreStatus._cont = ASN1Dict([('stored', 0), ('errorTransientFailure', 1), ('errorTransientMailboxFull', 2), ('errorTransientNetworkProblems', 3), ('errorPermanentFailure', 4), ('errorPermanentPermissionDenied', 5), ('errorPermanentMessageFormat', 6), ('errorPermanentMessageNotFound', 7)])
    
    #-----< SubjectComponent >-----#
    SubjectComponent = SEQ(name='SubjectComponent', mode=MODE_TYPE)
    _SubjectComponent_subjectType = OCT_STR(name='subjectType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubjectComponent_subjectSize = INT(name='subjectSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    SubjectComponent._cont = ASN1Dict([
        ('subjectType', _SubjectComponent_subjectType),
        ('subjectSize', _SubjectComponent_subjectSize),
        ])
    SubjectComponent._ext = None
    
    #-----< Totals >-----#
    Totals = SEQ(name='Totals', mode=MODE_TYPE)
    _Totals_numberOfMessages = INT(name='numberOfMessages', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Totals_numberOfOctets = INT(name='numberOfOctets', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Totals._cont = ASN1Dict([
        ('numberOfMessages', _Totals_numberOfMessages),
        ('numberOfOctets', _Totals_numberOfOctets),
        ])
    Totals._ext = None
    
    #-----< WaitTime >-----#
    WaitTime = CHOICE(name='WaitTime', mode=MODE_TYPE)
    _WaitTime_http_date = OCT_STR(name='http-date', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _WaitTime_delta_seconds = OCT_STR(name='delta-seconds', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DeltaSeconds')))
    WaitTime._cont = ASN1Dict([
        ('http-date', _WaitTime_http_date),
        ('delta-seconds', _WaitTime_delta_seconds),
        ])
    WaitTime._ext = None
    
    _all_ = [
        _MMSRecordType_mMO1SRecord,
        _MMSRecordType_mMO4FRqRecord,
        _MMSRecordType_mMO4FRsRecord,
        _MMSRecordType_mMO4DRecord,
        _MMSRecordType_mMO1DRecord,
        _MMSRecordType_mMO4RRecord,
        _MMSRecordType_mMO1RRecord,
        _MMSRecordType_mMOMDRecord,
        _MMSRecordType_mMR4FRecord,
        _MMSRecordType_mMR1NRqRecord,
        _MMSRecordType_mMR1NRsRecord,
        _MMSRecordType_mMR1RtRqRecord,
        _MMSRecordType_mMR1ARecord,
        _MMSRecordType_mMR4DRqRecord,
        _MMSRecordType_mMR4DRsRecord,
        _MMSRecordType_mMR1RRRecord,
        _MMSRecordType_mMR4RRqRecord,
        _MMSRecordType_mMR4RRsRecord,
        _MMSRecordType_mMRMDRecord,
        _MMSRecordType_mMFRecord,
        _MMSRecordType_mMBx1SRecord,
        _MMSRecordType_mMBx1VRecord,
        _MMSRecordType_mMBx1URecord,
        _MMSRecordType_mMBx1DRecord,
        _MMSRecordType_mM7SRecord,
        _MMSRecordType_mM7DRqRecord,
        _MMSRecordType_mM7DRsRecord,
        _MMSRecordType_mM7CRecord,
        _MMSRecordType_mM7RRecord,
        _MMSRecordType_mM7DRRqRecord,
        _MMSRecordType_mM7DRRsRecord,
        _MMSRecordType_mM7RRqRecord,
        _MMSRecordType_mM7RRsRecord,
        MMSRecordType,
        _MMO1SRecord_recordType,
        _MMO1SRecord_originatorMmsRSAddress,
        _MMO1SRecord_messageID,
        _MMO1SRecord_replyChargingID,
        _MMO1SRecord_originatorAddress,
        _MMO1SRecord_recipientAddresses,
        _MMO1SRecord_accessCorrelation,
        _MMO1SRecord_contentType,
        _MMO1SRecord_mmComponentType,
        _MMO1SRecord_messageSize,
        _MMO1SRecord_messageClass,
        _MMO1SRecord_chargeInformation,
        _MMO1SRecord_submissionTime,
        _MMO1SRecord_timeOfExpiry,
        _MMO1SRecord_earliestTimeOfDelivery,
        _MMO1SRecord_durationOfTransmission,
        _MMO1SRecord_requestStatusCode,
        _MMO1SRecord_deliveryReportRequested,
        _MMO1SRecord_replyCharging,
        _MMO1SRecord_replyDeadline,
        _MMO1SRecord_replyChargingSize,
        _MMO1SRecord_priority,
        _MMO1SRecord_senderVisibility,
        _MMO1SRecord_readReplyRequested,
        _MMO1SRecord_statusText,
        _MMO1SRecord_recordTimeStamp,
        _MMO1SRecord_localSequenceNumber,
        _MMO1SRecord_recordExtensions,
        _MMO1SRecord_mMBoxstorageInformation,
        _MMO1SRecord_mscfInformation,
        _MMO1SRecord_sGSNPLMNIdentifier,
        _MMO1SRecord_rATType,
        _MMO1SRecord_mSTimeZone,
        MMO1SRecord,
        _MMO4FRqRecord_recordType,
        _MMO4FRqRecord_originatorMmsRSAddress,
        _MMO4FRqRecord_recipientMmsRSAddress,
        _MMO4FRqRecord_messageID,
        _MMO4FRqRecord_mms3GPPVersion,
        _MMO4FRqRecord_originatorAddress,
        _MMO4FRqRecord_recipientAddresses,
        _MMO4FRqRecord_contentType,
        _MMO4FRqRecord_mmComponentType,
        _MMO4FRqRecord_messageSize,
        _MMO4FRqRecord_messageClass,
        _MMO4FRqRecord_submissionTime,
        _MMO4FRqRecord_timeOfExpiry,
        _MMO4FRqRecord_deliveryReportRequested,
        _MMO4FRqRecord_priority,
        _MMO4FRqRecord_senderVisibility,
        _MMO4FRqRecord_readReplyRequested,
        _MMO4FRqRecord_acknowledgementRequest,
        _MMO4FRqRecord_forwardCounter,
        _MMO4FRqRecord_forwardingAddress,
        _MMO4FRqRecord_recordTimeStamp,
        _MMO4FRqRecord_localSequenceNumber,
        _MMO4FRqRecord_recordExtensions,
        MMO4FRqRecord,
        _MMO4FRsRecord_recordType,
        _MMO4FRsRecord_originatorMmsRSAddress,
        _MMO4FRsRecord_recipientMmsRSAddress,
        _MMO4FRsRecord_messageID,
        _MMO4FRsRecord_mms3GPPVersion,
        _MMO4FRsRecord_requestStatusCode,
        _MMO4FRsRecord_statusText,
        _MMO4FRsRecord_recordTimeStamp,
        _MMO4FRsRecord_localSequenceNumber,
        _MMO4FRsRecord_recordExtensions,
        MMO4FRsRecord,
        _MMO4DRecord_recordType,
        _MMO4DRecord_recipientMmsRSAddress,
        _MMO4DRecord_originatorMmsRSAddress,
        _MMO4DRecord_messageID,
        _MMO4DRecord_mms3GPPVersion,
        _MMO4DRecord_originatorAddress,
        _MMO4DRecord_recipientAddress,
        _MMO4DRecord_mmDateAndTime,
        _MMO4DRecord_acknowledgementRequest,
        _MMO4DRecord_mmStatusCode,
        _MMO4DRecord_statusText,
        _MMO4DRecord_recordTimeStamp,
        _MMO4DRecord_localSequenceNumber,
        _MMO4DRecord_recordExtensions,
        MMO4DRecord,
        _MMO1DRecord_recordType,
        _MMO1DRecord_recipientMmsRSAddress,
        _MMO1DRecord_originatorMmsRSAddress,
        _MMO1DRecord_accessCorrelation,
        _MMO1DRecord_messageID,
        _MMO1DRecord_mms3GPPVersion,
        _MMO1DRecord_originatorAddress,
        _MMO1DRecord_recipientAddress,
        _MMO1DRecord_mmStatusCode,
        _MMO1DRecord_recordTimeStamp,
        _MMO1DRecord_localSequenceNumber,
        _MMO1DRecord_recordExtensions,
        _MMO1DRecord_sGSNPLMNIdentifier,
        _MMO1DRecord_rATType,
        _MMO1DRecord_mSTimeZone,
        MMO1DRecord,
        _MMO4RRecord_recordType,
        _MMO4RRecord_recipientMmsRSAddress,
        _MMO4RRecord_originatorMmsRSAddress,
        _MMO4RRecord_messageID,
        _MMO4RRecord_mms3GPPVersion,
        _MMO4RRecord_originatorAddress,
        _MMO4RRecord_recipientAddresses,
        _MMO4RRecord_mmDateAndTime,
        _MMO4RRecord_acknowledgementRequest,
        _MMO4RRecord_readStatus,
        _MMO4RRecord_statusText,
        _MMO4RRecord_recordTimeStamp,
        _MMO4RRecord_localSequenceNumber,
        _MMO4RRecord_recordExtensions,
        MMO4RRecord,
        _MMO1RRecord_recordType,
        _MMO1RRecord_recipientMmsRSAddress,
        _MMO1RRecord_originatorMmsRSAddress,
        _MMO1RRecord_accessCorrelation,
        _MMO1RRecord_messageID,
        _MMO1RRecord_mms3GPPVersion,
        _MMO1RRecord_originatorAddress,
        _MMO1RRecord_recipientAddress,
        _MMO1RRecord_readStatus,
        _MMO1RRecord_recordTimeStamp,
        _MMO1RRecord_localSequenceNumber,
        _MMO1RRecord_recordExtensions,
        _MMO1RRecord_sGSNPLMNIdentifier,
        _MMO1RRecord_rATType,
        _MMO1RRecord_mSTimeZone,
        MMO1RRecord,
        _MMOMDRecord_recordType,
        _MMOMDRecord_originatorMmsRSAddress,
        _MMOMDRecord_recipientMmsRSAddress,
        _MMOMDRecord_messageID,
        _MMOMDRecord_messageSize,
        _MMOMDRecord_mmStatusCode,
        _MMOMDRecord_statusText,
        _MMOMDRecord_recordTimeStamp,
        _MMOMDRecord_localSequenceNumber,
        _MMOMDRecord_recordExtensions,
        MMOMDRecord,
        _MMR4FRecord_recordType,
        _MMR4FRecord_recipientMmsRSAddress,
        _MMR4FRecord_originatorMmsRSAddress,
        _MMR4FRecord_messageID,
        _MMR4FRecord_mms3GPPVersion,
        _MMR4FRecord_originatorAddress,
        _MMR4FRecord_recipientAddresses,
        _MMR4FRecord_contentType,
        _MMR4FRecord_mmComponentType,
        _MMR4FRecord_messageSize,
        _MMR4FRecord_messageClass,
        _MMR4FRecord_submissionTime,
        _MMR4FRecord_timeOfExpiry,
        _MMR4FRecord_deliveryReportRequested,
        _MMR4FRecord_priority,
        _MMR4FRecord_senderVisibility,
        _MMR4FRecord_readReplyRequested,
        _MMR4FRecord_requestStatusCode,
        _MMR4FRecord_statusText,
        _MMR4FRecord_acknowledgementRequest,
        _MMR4FRecord_forwardCounter,
        _MMR4FRecord_forwardingAddress,
        _MMR4FRecord_recordTimeStamp,
        _MMR4FRecord_localSequenceNumber,
        _MMR4FRecord_recordExtensions,
        MMR4FRecord,
        _MMR1NRqRecord_recordType,
        _MMR1NRqRecord_recipientMmsRSAddress,
        _MMR1NRqRecord_messageID,
        _MMR1NRqRecord_replyChargingID,
        _MMR1NRqRecord_senderAddress,
        _MMR1NRqRecord_recipientAddress,
        _MMR1NRqRecord_accessCorrelation,
        _MMR1NRqRecord_messageClass,
        _MMR1NRqRecord_mmComponentType,
        _MMR1NRqRecord_messageSize,
        _MMR1NRqRecord_timeOfExpiry,
        _MMR1NRqRecord_messageReference,
        _MMR1NRqRecord_deliveryReportRequested,
        _MMR1NRqRecord_replyCharging,
        _MMR1NRqRecord_replyDeadline,
        _MMR1NRqRecord_replyChargingSize,
        _MMR1NRqRecord_mmStatusCode,
        _MMR1NRqRecord_statusText,
        _MMR1NRqRecord_recordTimeStamp,
        _MMR1NRqRecord_localSequenceNumber,
        _MMR1NRqRecord_recordExtensions,
        _MMR1NRqRecord_mscfInformation,
        _MMR1NRqRecord_vaspID,
        _MMR1NRqRecord_vasID,
        _MMR1NRqRecord_sGSNPLMNIdentifier,
        _MMR1NRqRecord_rATType,
        _MMR1NRqRecord_mSTimeZone,
        MMR1NRqRecord,
        _MMR1NRsRecord_recordType,
        _MMR1NRsRecord_recipientMmsRSAddress,
        _MMR1NRsRecord_messageID,
        _MMR1NRsRecord_recipientAddress,
        _MMR1NRsRecord_accessCorrelation,
        _MMR1NRsRecord_reportAllowed,
        _MMR1NRsRecord_mmStatusCode,
        _MMR1NRsRecord_statusText,
        _MMR1NRsRecord_recordTimeStamp,
        _MMR1NRsRecord_localSequenceNumber,
        _MMR1NRsRecord_recordExtensions,
        _MMR1NRsRecord_sGSNPLMNIdentifier,
        _MMR1NRsRecord_rATType,
        _MMR1NRsRecord_mSTimeZone,
        MMR1NRsRecord,
        _MMR1RtRecord_recordType,
        _MMR1RtRecord_recipientMmsRSAddress,
        _MMR1RtRecord_messageID,
        _MMR1RtRecord_replyChargingID,
        _MMR1RtRecord_senderAddress,
        _MMR1RtRecord_recipientAddress,
        _MMR1RtRecord_accessCorrelation,
        _MMR1RtRecord_contentType,
        _MMR1RtRecord_mmComponentType,
        _MMR1RtRecord_messageClass,
        _MMR1RtRecord_submissionTime,
        _MMR1RtRecord_messageSize,
        _MMR1RtRecord_deliveryReportRequested,
        _MMR1RtRecord_priority,
        _MMR1RtRecord_readReplyRequested,
        _MMR1RtRecord_mmStatusCode,
        _MMR1RtRecord_statusText,
        _MMR1RtRecord_replyDeadline,
        _MMR1RtRecord_replyChargingSize,
        _MMR1RtRecord_durationOfTransmission,
        _MMR1RtRecord_timeOfExpiry,
        _MMR1RtRecord_recordTimeStamp,
        _MMR1RtRecord_localSequenceNumber,
        _MMR1RtRecord_recordExtensions,
        _MMR1RtRecord_messageReference,
        _MMR1RtRecord_vaspID,
        _MMR1RtRecord_vasID,
        _MMR1RtRecord_sGSNPLMNIdentifier,
        _MMR1RtRecord_rATType,
        _MMR1RtRecord_mSTimeZone,
        MMR1RtRecord,
        _MMR1ARecord_recordType,
        _MMR1ARecord_recipientMmsRSAddress,
        _MMR1ARecord_messageID,
        _MMR1ARecord_recipientAddress,
        _MMR1ARecord_accessCorrelation,
        _MMR1ARecord_reportAllowed,
        _MMR1ARecord_mmStatusCode,
        _MMR1ARecord_statusText,
        _MMR1ARecord_recordTimeStamp,
        _MMR1ARecord_localSequenceNumber,
        _MMR1ARecord_recordExtensions,
        _MMR1ARecord_sGSNPLMNIdentifier,
        _MMR1ARecord_rATType,
        _MMR1ARecord_mSTimeZone,
        MMR1ARecord,
        _MMR4DRqRecord_recordType,
        _MMR4DRqRecord_recipientMmsRSAddress,
        _MMR4DRqRecord_originatorMmsRSAddress,
        _MMR4DRqRecord_messageID,
        _MMR4DRqRecord_mms3GPPVersion,
        _MMR4DRqRecord_originatorAddress,
        _MMR4DRqRecord_recipientAddress,
        _MMR4DRqRecord_mmDateAndTime,
        _MMR4DRqRecord_acknowledgementRequest,
        _MMR4DRqRecord_mmStatusCode,
        _MMR4DRqRecord_statusText,
        _MMR4DRqRecord_recordTimeStamp,
        _MMR4DRqRecord_localSequenceNumber,
        _MMR4DRqRecord_recordExtensions,
        MMR4DRqRecord,
        _MMR4DRsRecord_recordType,
        _MMR4DRsRecord_recipientMmsRSAddress,
        _MMR4DRsRecord_originatorMmsRSAddress,
        _MMR4DRsRecord_messageID,
        _MMR4DRsRecord_mms3GPPVersion,
        _MMR4DRsRecord_requestStatusCode,
        _MMR4DRsRecord_statusText,
        _MMR4DRsRecord_recordTimeStamp,
        _MMR4DRsRecord_localSequenceNumber,
        _MMR4DRsRecord_recordExtensions,
        MMR4DRsRecord,
        _MMR1RRRecord_recordType,
        _MMR1RRRecord_recipientMmsRSAddress,
        _MMR1RRRecord_messageID,
        _MMR1RRRecord_recipientAddress,
        _MMR1RRRecord_originatorAddress,
        _MMR1RRRecord_accessCorrelation,
        _MMR1RRRecord_mmStatusCode,
        _MMR1RRRecord_statusText,
        _MMR1RRRecord_recordTimeStamp,
        _MMR1RRRecord_localSequenceNumber,
        _MMR1RRRecord_recordExtensions,
        _MMR1RRRecord_sGSNPLMNIdentifier,
        _MMR1RRRecord_rATType,
        _MMR1RRRecord_mSTimeZone,
        MMR1RRRecord,
        _MMR4RRqRecord_recordType,
        _MMR4RRqRecord_recipientMmsRSAddress,
        _MMR4RRqRecord_originatorMmsRSAddress,
        _MMR4RRqRecord_messageID,
        _MMR4RRqRecord_mms3GPPVersion,
        _MMR4RRqRecord_originatorAddress,
        _MMR4RRqRecord_recipientAddress,
        _MMR4RRqRecord_mmDateAndTime,
        _MMR4RRqRecord_acknowledgementRequest,
        _MMR4RRqRecord_mmStatusCode,
        _MMR4RRqRecord_statusText,
        _MMR4RRqRecord_recordTimeStamp,
        _MMR4RRqRecord_localSequenceNumber,
        _MMR4RRqRecord_recordExtensions,
        MMR4RRqRecord,
        _MMR4RRsRecord_recordType,
        _MMR4RRsRecord_recipientMmsRSAddress,
        _MMR4RRsRecord_originatorMmsRSAddress,
        _MMR4RRsRecord_messageID,
        _MMR4RRsRecord_mms3GPPVersion,
        _MMR4RRsRecord_requestStatusCode,
        _MMR4RRsRecord_statusText,
        _MMR4RRsRecord_recordTimeStamp,
        _MMR4RRsRecord_localSequenceNumber,
        _MMR4RRsRecord_recordExtensions,
        MMR4RRsRecord,
        _MMRMDRecord_recordType,
        _MMRMDRecord_originatorMmsRSAddress,
        _MMRMDRecord_recipientMmsRSAddress,
        _MMRMDRecord_messageID,
        _MMRMDRecord_messageSize,
        _MMRMDRecord_mmStatusCode,
        _MMRMDRecord_statusText,
        _MMRMDRecord_recordTimeStamp,
        _MMRMDRecord_localSequenceNumber,
        _MMRMDRecord_recordExtensions,
        MMRMDRecord,
        _MMFRecord_recordType,
        _MMFRecord_forwardingMmsRSAddress,
        _MMFRecord_messageID,
        _MMFRecord_forwardingAddress,
        _MMFRecord_recipientAddresses,
        _MMFRecord_chargeInformation,
        _MMFRecord_timeOfExpiry,
        _MMFRecord_earliestTimeOfDelivery,
        _MMFRecord_deliveryReportRequested,
        _MMFRecord_readReplyRequested,
        _MMFRecord_messageReference,
        _MMFRecord_mmStatusCode,
        _MMFRecord_statusText,
        _MMFRecord_recordTimeStamp,
        _MMFRecord_localSequenceNumber,
        _MMFRecord_recordExtensions,
        _MMFRecord_mMBoxstorageInformation,
        MMFRecord,
        _MMBx1SRecord_recordType,
        _MMBx1SRecord_mmsRelayAddress,
        _MMBx1SRecord_managingAddress,
        _MMBx1SRecord_accessCorrelation,
        _MMBx1SRecord_contentType,
        _MMBx1SRecord_messageSize,
        _MMBx1SRecord_messageReference,
        _MMBx1SRecord_mmState,
        _MMBx1SRecord_mmFlags,
        _MMBx1SRecord_storeStatus,
        _MMBx1SRecord_storeStatusText,
        _MMBx1SRecord_sequenceNumber,
        _MMBx1SRecord_timeStamp,
        _MMBx1SRecord_recordExtensions,
        _MMBx1SRecord_sGSNPLMNIdentifier,
        _MMBx1SRecord_rATType,
        _MMBx1SRecord_mSTimeZone,
        MMBx1SRecord,
        _MMBx1VRecord_recordType,
        _MMBx1VRecord_mmsRelayAddress,
        _MMBx1VRecord_managingAddress,
        _MMBx1VRecord_accessCorrelation,
        _MMBx1VRecord_attributesList,
        _MMBx1VRecord_messageSelection,
        _MMBx1VRecord_start,
        _MMBx1VRecord_limit,
        _MMBx1VRecord_totalsRequested,
        _MMBx1VRecord_quotasRequested,
        _MMBx1VRecord_mmListing,
        _MMBx1VRecord_requestStatusCode,
        _MMBx1VRecord_statusText,
        _MMBx1VRecord_totals,
        _MMBx1VRecord_quotas,
        _MMBx1VRecord_sequenceNumber,
        _MMBx1VRecord_timeStamp,
        _MMBx1VRecord_recordExtensions,
        _MMBx1VRecord_sGSNPLMNIdentifier,
        _MMBx1VRecord_rATType,
        _MMBx1VRecord_mSTimeZone,
        MMBx1VRecord,
        _MMBx1URecord_recordType,
        _MMBx1URecord_mmsRelayAddress,
        _MMBx1URecord_managingAddress,
        _MMBx1URecord_accessCorrelation,
        _MMBx1URecord_recipientsAddressList,
        _MMBx1URecord_messageClass,
        _MMBx1URecord_uploadTime,
        _MMBx1URecord_timeOfExpiry,
        _MMBx1URecord_earliestTimeOfDelivery,
        _MMBx1URecord_priority,
        _MMBx1URecord_mmState,
        _MMBx1URecord_mmFlags,
        _MMBx1URecord_contentType,
        _MMBx1URecord_messageSize,
        _MMBx1URecord_messageReference,
        _MMBx1URecord_requestStatusCode,
        _MMBx1URecord_statusText,
        _MMBx1URecord_sequenceNumber,
        _MMBx1URecord_timeStamp,
        _MMBx1URecord_recordExtensions,
        _MMBx1URecord_sGSNPLMNIdentifier,
        _MMBx1URecord_rATType,
        _MMBx1URecord_mSTimeZone,
        MMBx1URecord,
        _MMBx1DRecord_recordType,
        _MMBx1DRecord_mmsRelayAddress,
        _MMBx1DRecord_managingAddress,
        _MMBx1DRecord_accessCorrelation,
        _MMBx1DRecord_messageReference,
        _MMBx1DRecord_requestStatusCode,
        _MMBx1DRecord_statusText,
        _MMBx1DRecord_sequenceNumber,
        _MMBx1DRecord_timeStamp,
        _MMBx1DRecord_recordExtensions,
        _MMBx1DRecord_sGSNPLMNIdentifier,
        _MMBx1DRecord_rATType,
        _MMBx1DRecord_mSTimeZone,
        MMBx1DRecord,
        _MM7SRecord_recordType,
        _MM7SRecord_originatorMmsRSAddress,
        _MM7SRecord_linkedID,
        _MM7SRecord_vaspID,
        _MM7SRecord_vasID,
        _MM7SRecord_messageID,
        _MM7SRecord_originatorAddress,
        _MM7SRecord_recipientAddresses,
        _MM7SRecord_serviceCode,
        _MM7SRecord_contentType,
        _MM7SRecord_mmComponentType,
        _MM7SRecord_messageSize,
        _MM7SRecord_messageClass,
        _MM7SRecord_chargeInformation,
        _MM7SRecord_submissionTime,
        _MM7SRecord_timeOfExpiry,
        _MM7SRecord_earliestTimeOfDelivery,
        _MM7SRecord_deliveryReportRequested,
        _MM7SRecord_readReplyRequested,
        _MM7SRecord_replyCharging,
        _MM7SRecord_replyDeadline,
        _MM7SRecord_replyChargingSize,
        _MM7SRecord_priority,
        _MM7SRecord_messageDistributionIndicator,
        _MM7SRecord_requestStatusCode,
        _MM7SRecord_statusText,
        _MM7SRecord_recordTimeStamp,
        _MM7SRecord_localSequenceNumber,
        _MM7SRecord_recordExtensions,
        _MM7SRecord_mscfInformation,
        MM7SRecord,
        _MM7DRqRecord_recordType,
        _MM7DRqRecord_recipientMmsRSAddress,
        _MM7DRqRecord_linkedID,
        _MM7DRqRecord_replyChargingID,
        _MM7DRqRecord_originatorAddress,
        _MM7DRqRecord_recipientAddress,
        _MM7DRqRecord_mmComponentType,
        _MM7DRqRecord_messageSize,
        _MM7DRqRecord_contentType,
        _MM7DRqRecord_priority,
        _MM7DRqRecord_recordTimeStamp,
        _MM7DRqRecord_localSequenceNumber,
        _MM7DRqRecord_recordExtensions,
        MM7DRqRecord,
        _MM7DRsRecord_recordType,
        _MM7DRsRecord_recipientMmsRSAddress,
        _MM7DRsRecord_messageID,
        _MM7DRsRecord_recipientAddress,
        _MM7DRsRecord_serviceCode,
        _MM7DRsRecord_requestStatusCode,
        _MM7DRsRecord_statusText,
        _MM7DRsRecord_recordTimeStamp,
        _MM7DRsRecord_localSequenceNumber,
        _MM7DRsRecord_recordExtensions,
        MM7DRsRecord,
        _MM7CRecord_recordType,
        _MM7CRecord_originatorMmsRSAddress,
        _MM7CRecord_vaspID,
        _MM7CRecord_vasID,
        _MM7CRecord_messageID,
        _MM7CRecord_originatorAddress,
        _MM7CRecord_serviceCode,
        _MM7CRecord_requestStatusCode,
        _MM7CRecord_statusText,
        _MM7CRecord_recordTimeStamp,
        _MM7CRecord_localSequenceNumber,
        _MM7CRecord_recordExtensions,
        MM7CRecord,
        _MM7RRecord_recordType,
        _MM7RRecord_originatorMmsRSAddress,
        _MM7RRecord_vaspID,
        _MM7RRecord_vasID,
        _MM7RRecord_messageID,
        _MM7RRecord_originatorAddress,
        _MM7RRecord_serviceCode,
        _MM7RRecord_contentType,
        _MM7RRecord_submissionTime,
        _MM7RRecord_timeOfExpiry,
        _MM7RRecord_earliestTimeOfDelivery,
        _MM7RRecord_requestStatusCode,
        _MM7RRecord_statusText,
        _MM7RRecord_recordTimeStamp,
        _MM7RRecord_localSequenceNumber,
        _MM7RRecord_recordExtensions,
        MM7RRecord,
        _MM7DRRqRecord_recordType,
        _MM7DRRqRecord_recipientMmsRSAddress,
        _MM7DRRqRecord_messageID,
        _MM7DRRqRecord_originatorAddress,
        _MM7DRRqRecord_recipientAddress,
        _MM7DRRqRecord_mmDateAndTime,
        _MM7DRRqRecord_mmStatusCode,
        _MM7DRRqRecord_mmStatusText,
        _MM7DRRqRecord_recordTimeStamp,
        _MM7DRRqRecord_localSequenceNumber,
        _MM7DRRqRecord_recordExtensions,
        MM7DRRqRecord,
        _MM7DRRsRecord_recordType,
        _MM7DRRsRecord_recipientMmsRSAddress,
        _MM7DRRsRecord_messageID,
        _MM7DRRsRecord_originatorAddress,
        _MM7DRRsRecord_recipientAddress,
        _MM7DRRsRecord_requestStatusCode,
        _MM7DRRsRecord_statusText,
        _MM7DRRsRecord_recordTimeStamp,
        _MM7DRRsRecord_localSequenceNumber,
        _MM7DRRsRecord_recordExtensions,
        MM7DRRsRecord,
        _MM7RRqRecord_recordType,
        _MM7RRqRecord_recipientMmsRSAddress,
        _MM7RRqRecord_messageID,
        _MM7RRqRecord_originatorAddress,
        _MM7RRqRecord_recipientAddress,
        _MM7RRqRecord_mmDateAndTime,
        _MM7RRqRecord_readStatus,
        _MM7RRqRecord_mmStatusText,
        _MM7RRqRecord_recordTimeStamp,
        _MM7RRqRecord_localSequenceNumber,
        _MM7RRqRecord_recordExtensions,
        MM7RRqRecord,
        _MM7RRsRecord_recordType,
        _MM7RRsRecord_recipientMmsRSAddress,
        _MM7RRsRecord_messageID,
        _MM7RRsRecord_originatorAddress,
        _MM7RRsRecord_recipientAddress,
        _MM7RRsRecord_requestStatusCode,
        _MM7RRsRecord_statusText,
        _MM7RRsRecord_recordTimeStamp,
        _MM7RRsRecord_localSequenceNumber,
        _MM7RRsRecord_recordExtensions,
        MM7RRsRecord,
        _AccessCorrelation_circuitSwitched,
        _AccessCorrelation_packetSwitched,
        AccessCorrelation,
        _AttributesList_messageID,
        _AttributesList_dateAndTime,
        _AttributesList_senderAddress,
        _AttributesList_subject,
        _AttributesList_messageSize,
        _AttributesList_mmFlags,
        _AttributesList_mmState,
        AttributesList,
        _ChargeInformation_chargedparty,
        _ChargeInformation_chargetype,
        ChargeInformation,
        ChargedParty,
        ChargeType,
        _CircuitSwitchedAccess_mSCIdentifier,
        _CircuitSwitchedAccess_callReferenceNumber,
        CircuitSwitchedAccess,
        ContentType,
        DataVolume,
        DeltaSeconds,
        _MediaComponent_mediaType,
        _MediaComponent_mediaSize,
        MediaComponent,
        _MediaComponents__item_,
        MediaComponents,
        MessageSelection,
        _MMBoxStorageInformation_mmState,
        _MMBoxStorageInformation_mmFlag,
        _MMBoxStorageInformation_storeStatus,
        _MMBoxStorageInformation_storeStatusText,
        _MMBoxStorageInformation_storedMessageReference,
        MMBoxStorageInformation,
        _MMComponentType_subject,
        _MMComponentType_media,
        MMComponentType,
        _MMSAgentAddress_mMSAgentAddressData,
        __MMSAgentAddress_mMSRecipientType__item_,
        _MMSAgentAddress_mMSRecipientType,
        MMSAgentAddress,
        _MMSAgentAddresses__item_,
        MMSAgentAddresses,
        _MMSAgentAddressData_eMail_address,
        _MMSAgentAddressData_mSISDN,
        _MMSAgentAddressData_shortCode,
        MMSAgentAddressData,
        MMSRecipientType,
        _MMSRSAddress_domainName,
        _MMSRSAddress_iPAddress,
        MMSRSAddress,
        MMState,
        MMStatusCodeType,
        _MSCFInformation_billingInformation,
        _MSCFInformation_routeingAddressList,
        MSCFInformation,
        _PacketSwitchedAccess_gSNAddress,
        _PacketSwitchedAccess_chargingID,
        PacketSwitchedAccess,
        _Quotas_numberOfMessages,
        _Quotas_numberOfOctets,
        Quotas,
        RequestStatusCodeType,
        _RouteingAddress_eMail_address,
        _RouteingAddress_mSISDN,
        _RouteingAddress_shortCode,
        RouteingAddress,
        _RouteingAddressList__item_,
        RouteingAddressList,
        StatusTextType,
        StoreStatus,
        _SubjectComponent_subjectType,
        _SubjectComponent_subjectSize,
        SubjectComponent,
        _Totals_numberOfMessages,
        _Totals_numberOfOctets,
        Totals,
        _WaitTime_http_date,
        _WaitTime_delta_seconds,
        WaitTime,
    ]

class MMTelChargingDataTypes:

    _name_  = 'MMTelChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 9, 0, 1]
    
    _obj_ = [
        'MMTelServiceRecord',
        'MMTelRecord',
        'MMTelInformation',
        'ParticipantActionType',
        'SupplService',
        'ServiceType',
        'ServiceMode',
        ]
    _type_ = [
        'MMTelServiceRecord',
        'MMTelRecord',
        'MMTelInformation',
        'ParticipantActionType',
        'SupplService',
        'ServiceType',
        'ServiceMode',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MMTelServiceRecord >-----#
    MMTelServiceRecord = CHOICE(name='MMTelServiceRecord', mode=MODE_TYPE)
    _MMTelServiceRecord_mMTelRecord = SET(name='mMTelRecord', mode=MODE_TYPE, tag=(83, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'MMTelRecord')))
    MMTelServiceRecord._cont = ASN1Dict([
        ('mMTelRecord', _MMTelServiceRecord_mMTelRecord),
        ])
    MMTelServiceRecord._ext = None
    
    #-----< MMTelRecord >-----#
    MMTelRecord = SET(name='MMTelRecord', mode=MODE_TYPE)
    _MMTelRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMTelRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _MMTelRecord_role_of_Node = ENUM(name='role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _MMTelRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MMTelRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MMTelRecord_list_Of_Calling_Party_Address = SEQ_OF(name='list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MMTelRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MMTelRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_interOperatorIdentifiers = SEQ_OF(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _MMTelRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMTelRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _MMTelRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _MMTelRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MMTelRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _MMTelRecord_list_Of_SDP_Media_Components._cont = __MMTelRecord_list_Of_SDP_Media_Components__item_
    _MMTelRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MMTelRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _MMTelRecord_list_Of_Message_Bodies._cont = __MMTelRecord_list_Of_Message_Bodies__item_
    _MMTelRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMTelRecord_expiresInformation = INT(name='expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_event = STR_UTF8(name='event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_accessNetworkInformation = OCT_STR(name='accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MMTelRecord_list_of_subscription_ID = SEQ_OF(name='list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _MMTelRecord_list_of_subscription_ID._cont = __MMTelRecord_list_of_subscription_ID__item_
    _MMTelRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name='list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _MMTelRecord_list_Of_Early_SDP_Media_Components._cont = __MMTelRecord_list_Of_Early_SDP_Media_Components__item_
    _MMTelRecord_iMSCommunicationServiceIdentifier = OCT_STR(name='iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _MMTelRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _MMTelRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _MMTelRecord_sessionPriority = ENUM(name='sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _MMTelRecord_serviceRequestTimeStampFraction = INT(name='serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MMTelRecord_serviceDeliveryStartTimeStampFraction = INT(name='serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MMTelRecord_serviceDeliveryEndTimeStampFraction = INT(name='serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MMTelRecord_online_charging_flag = NULL(name='online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_realTimeTariffInformation = SEQ_OF(name='realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _MMTelRecord_realTimeTariffInformation._cont = __MMTelRecord_realTimeTariffInformation__item_
    _MMTelRecord_transit_IOI_Lists = SEQ_OF(name='transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _MMTelRecord_iMSVisitedNetworkIdentifier = OCT_STR(name='iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_listOfReasonHeader = SEQ_OF(name='listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _MMTelRecord_additionalAccessNetworkInformation = OCT_STR(name='additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_instanceId = OCT_STR(name='instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_subscriberEquipmentNumber = SET(name='subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _MMTelRecord_cellularNetworkInformation = OCT_STR(name='cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_requested_Party_Address = CHOICE(name='requested-Party-Address', mode=MODE_TYPE, tag=(101, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MMTelRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name='list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(102, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MMTelRecord_outgoingSessionId = STR_GRAPH(name='outgoingSessionId', mode=MODE_TYPE, tag=(104, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MMTelRecord_mMTelInformation = SET(name='mMTelInformation', mode=MODE_TYPE, tag=(110, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'MMTelInformation')), opt=True)
    _MMTelRecord_threeGPPPSDataOffStatus = ENUM(name='threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(112, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _MMTelRecord_fEIdentifierList = SEQ_OF(name='fEIdentifierList', mode=MODE_TYPE, tag=(113, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    MMTelRecord._cont = ASN1Dict([
        ('recordType', _MMTelRecord_recordType),
        ('retransmission', _MMTelRecord_retransmission),
        ('sIP-Method', _MMTelRecord_sIP_Method),
        ('role-of-Node', _MMTelRecord_role_of_Node),
        ('nodeAddress', _MMTelRecord_nodeAddress),
        ('session-Id', _MMTelRecord_session_Id),
        ('list-Of-Calling-Party-Address', _MMTelRecord_list_Of_Calling_Party_Address),
        ('called-Party-Address', _MMTelRecord_called_Party_Address),
        ('serviceRequestTimeStamp', _MMTelRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _MMTelRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _MMTelRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _MMTelRecord_recordOpeningTime),
        ('recordClosureTime', _MMTelRecord_recordClosureTime),
        ('interOperatorIdentifiers', _MMTelRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _MMTelRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _MMTelRecord_recordSequenceNumber),
        ('causeForRecordClosing', _MMTelRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _MMTelRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _MMTelRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _MMTelRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _MMTelRecord_gGSNaddress),
        ('serviceReasonReturnCode', _MMTelRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _MMTelRecord_list_Of_Message_Bodies),
        ('recordExtensions', _MMTelRecord_recordExtensions),
        ('expiresInformation', _MMTelRecord_expiresInformation),
        ('event', _MMTelRecord_event),
        ('accessNetworkInformation', _MMTelRecord_accessNetworkInformation),
        ('serviceContextID', _MMTelRecord_serviceContextID),
        ('list-of-subscription-ID', _MMTelRecord_list_of_subscription_ID),
        ('list-Of-Early-SDP-Media-Components', _MMTelRecord_list_Of_Early_SDP_Media_Components),
        ('iMSCommunicationServiceIdentifier', _MMTelRecord_iMSCommunicationServiceIdentifier),
        ('numberPortabilityRouting', _MMTelRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _MMTelRecord_carrierSelectRouting),
        ('sessionPriority', _MMTelRecord_sessionPriority),
        ('serviceRequestTimeStampFraction', _MMTelRecord_serviceRequestTimeStampFraction),
        ('serviceDeliveryStartTimeStampFraction', _MMTelRecord_serviceDeliveryStartTimeStampFraction),
        ('serviceDeliveryEndTimeStampFraction', _MMTelRecord_serviceDeliveryEndTimeStampFraction),
        ('online-charging-flag', _MMTelRecord_online_charging_flag),
        ('realTimeTariffInformation', _MMTelRecord_realTimeTariffInformation),
        ('transit-IOI-Lists', _MMTelRecord_transit_IOI_Lists),
        ('iMSVisitedNetworkIdentifier', _MMTelRecord_iMSVisitedNetworkIdentifier),
        ('listOfReasonHeader', _MMTelRecord_listOfReasonHeader),
        ('additionalAccessNetworkInformation', _MMTelRecord_additionalAccessNetworkInformation),
        ('instanceId', _MMTelRecord_instanceId),
        ('subscriberEquipmentNumber', _MMTelRecord_subscriberEquipmentNumber),
        ('cellularNetworkInformation', _MMTelRecord_cellularNetworkInformation),
        ('requested-Party-Address', _MMTelRecord_requested_Party_Address),
        ('list-Of-Called-Asserted-Identity', _MMTelRecord_list_Of_Called_Asserted_Identity),
        ('outgoingSessionId', _MMTelRecord_outgoingSessionId),
        ('mMTelInformation', _MMTelRecord_mMTelInformation),
        ('threeGPPPSDataOffStatus', _MMTelRecord_threeGPPPSDataOffStatus),
        ('fEIdentifierList', _MMTelRecord_fEIdentifierList),
        ])
    MMTelRecord._ext = None
    
    #-----< MMTelInformation >-----#
    MMTelInformation = SET(name='MMTelInformation', mode=MODE_TYPE)
    _MMTelInformation_listOfSupplServices = SEQ_OF(name='listOfSupplServices', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelInformation_listOfSupplServices__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMTelChargingDataTypes', 'SupplService')))
    _MMTelInformation_listOfSupplServices._cont = __MMTelInformation_listOfSupplServices__item_
    MMTelInformation._cont = ASN1Dict([
        ('listOfSupplServices', _MMTelInformation_listOfSupplServices),
        ])
    MMTelInformation._ext = None
    
    #-----< ParticipantActionType >-----#
    ParticipantActionType = ENUM(name='ParticipantActionType', mode=MODE_TYPE)
    ParticipantActionType._cont = ASN1Dict([('cREATE-CONF', 0), ('jOIN-CONF', 1), ('iNVITED-INTO-CONF', 2), ('qUIT-CONF', 3)])
    ParticipantActionType._ext = None
    
    #-----< SupplService >-----#
    SupplService = SET(name='SupplService', mode=MODE_TYPE)
    _SupplService_serviceType = INT(name='serviceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'ServiceType')))
    _SupplService_serviceMode = INT(name='serviceMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'ServiceMode')), opt=True)
    _SupplService_numberOfDiversions = INT(name='numberOfDiversions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupplService_associated_Party_Address = CHOICE(name='associated-Party-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _SupplService_serviceId = STR_GRAPH(name='serviceId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Service-Id')), opt=True)
    _SupplService_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SupplService_numberOfParticipants = INT(name='numberOfParticipants', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupplService_participantActionType = ENUM(name='participantActionType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'ParticipantActionType')), opt=True)
    _SupplService_cUGInformation = OCT_STR(name='cUGInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupplService_aoCInformation = SEQ_OF(name='aoCInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SupplService_aoCInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AoCInformation')))
    _SupplService_aoCInformation._cont = __SupplService_aoCInformation__item_
    SupplService._cont = ASN1Dict([
        ('serviceType', _SupplService_serviceType),
        ('serviceMode', _SupplService_serviceMode),
        ('numberOfDiversions', _SupplService_numberOfDiversions),
        ('associated-Party-Address', _SupplService_associated_Party_Address),
        ('serviceId', _SupplService_serviceId),
        ('changeTime', _SupplService_changeTime),
        ('numberOfParticipants', _SupplService_numberOfParticipants),
        ('participantActionType', _SupplService_participantActionType),
        ('cUGInformation', _SupplService_cUGInformation),
        ('aoCInformation', _SupplService_aoCInformation),
        ])
    SupplService._ext = None
    
    #-----< ServiceType >-----#
    ServiceType = INT(name='ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([('oIPresentation', 0), ('oIRestriction', 1), ('tIPresentation', 2), ('tIRestriction', 3), ('hOLD', 4), ('cBarring', 5), ('cDIVersion', 6), ('cWaiting', 8), ('mWaitingIndic', 9), ('cONF', 10), ('fLexibleAlerting', 11), ('cCBS', 12), ('cCNR', 13), ('mCID', 14), ('cAT', 15), ('cUG', 16), ('pNM', 17), ('cRS', 18), ('aoC', 19), ('eCT', 20)])
    
    #-----< ServiceMode >-----#
    ServiceMode = INT(name='ServiceMode', mode=MODE_TYPE)
    ServiceMode._cont = ASN1Dict([('cFunCond', 0), ('cFbusy', 1), ('cFnoReply', 2), ('cFnotLogged', 3), ('deflection', 4), ('notReach', 5), ('iCBarring', 6), ('oCBarring', 7), ('aCRejection', 8), ('eCTBlind', 9), ('eCTConsultative', 10), ('threePTY', 11), ('aoC-S', 12), ('aoC-D', 13), ('aoC-E', 14)])
    
    _all_ = [
        _MMTelServiceRecord_mMTelRecord,
        MMTelServiceRecord,
        _MMTelRecord_recordType,
        _MMTelRecord_retransmission,
        _MMTelRecord_sIP_Method,
        _MMTelRecord_role_of_Node,
        _MMTelRecord_nodeAddress,
        _MMTelRecord_session_Id,
        _MMTelRecord_list_Of_Calling_Party_Address,
        _MMTelRecord_called_Party_Address,
        _MMTelRecord_serviceRequestTimeStamp,
        _MMTelRecord_serviceDeliveryStartTimeStamp,
        _MMTelRecord_serviceDeliveryEndTimeStamp,
        _MMTelRecord_recordOpeningTime,
        _MMTelRecord_recordClosureTime,
        _MMTelRecord_interOperatorIdentifiers,
        _MMTelRecord_localRecordSequenceNumber,
        _MMTelRecord_recordSequenceNumber,
        _MMTelRecord_causeForRecordClosing,
        _MMTelRecord_incomplete_CDR_Indication,
        _MMTelRecord_iMS_Charging_Identifier,
        __MMTelRecord_list_Of_SDP_Media_Components__item_,
        _MMTelRecord_list_Of_SDP_Media_Components,
        _MMTelRecord_gGSNaddress,
        _MMTelRecord_serviceReasonReturnCode,
        __MMTelRecord_list_Of_Message_Bodies__item_,
        _MMTelRecord_list_Of_Message_Bodies,
        _MMTelRecord_recordExtensions,
        _MMTelRecord_expiresInformation,
        _MMTelRecord_event,
        _MMTelRecord_accessNetworkInformation,
        _MMTelRecord_serviceContextID,
        __MMTelRecord_list_of_subscription_ID__item_,
        _MMTelRecord_list_of_subscription_ID,
        __MMTelRecord_list_Of_Early_SDP_Media_Components__item_,
        _MMTelRecord_list_Of_Early_SDP_Media_Components,
        _MMTelRecord_iMSCommunicationServiceIdentifier,
        _MMTelRecord_numberPortabilityRouting,
        _MMTelRecord_carrierSelectRouting,
        _MMTelRecord_sessionPriority,
        _MMTelRecord_serviceRequestTimeStampFraction,
        _MMTelRecord_serviceDeliveryStartTimeStampFraction,
        _MMTelRecord_serviceDeliveryEndTimeStampFraction,
        _MMTelRecord_online_charging_flag,
        __MMTelRecord_realTimeTariffInformation__item_,
        _MMTelRecord_realTimeTariffInformation,
        _MMTelRecord_transit_IOI_Lists,
        _MMTelRecord_iMSVisitedNetworkIdentifier,
        _MMTelRecord_listOfReasonHeader,
        _MMTelRecord_additionalAccessNetworkInformation,
        _MMTelRecord_instanceId,
        _MMTelRecord_subscriberEquipmentNumber,
        _MMTelRecord_cellularNetworkInformation,
        _MMTelRecord_requested_Party_Address,
        _MMTelRecord_list_Of_Called_Asserted_Identity,
        _MMTelRecord_outgoingSessionId,
        _MMTelRecord_mMTelInformation,
        _MMTelRecord_threeGPPPSDataOffStatus,
        _MMTelRecord_fEIdentifierList,
        MMTelRecord,
        __MMTelInformation_listOfSupplServices__item_,
        _MMTelInformation_listOfSupplServices,
        MMTelInformation,
        ParticipantActionType,
        _SupplService_serviceType,
        _SupplService_serviceMode,
        _SupplService_numberOfDiversions,
        _SupplService_associated_Party_Address,
        _SupplService_serviceId,
        _SupplService_changeTime,
        _SupplService_numberOfParticipants,
        _SupplService_participantActionType,
        _SupplService_cUGInformation,
        __SupplService_aoCInformation__item_,
        _SupplService_aoCInformation,
        SupplService,
        ServiceType,
        ServiceMode,
    ]

class MONTEChargingDataTypes:

    _name_  = 'MONTEChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 12, 0, 1]
    
    _obj_ = [
        'MERecordType',
        'MECORecord',
        'MERERecord',
        'Accuracy',
        'CauseType',
        'CommunicationFailureInfo',
        'CurrentLocationRetrieved',
        'EPSLocationInfo',
        'LocationType',
        'MMELocationInformation',
        'MonitoringEventConfigStatus',
        'MonitoringEventConfigurationActivity',
        'MonitoringEventReportData',
        'MonitoringType',
        'NumberOfUEPerLocationReport',
        'ReachabilityConfiguration',
        'ReachabilityType',
        'SGSNLocationInformation',
        'SCEFReferenceID',
        'ServiceResult',
        ]
    _type_ = [
        'MERecordType',
        'MECORecord',
        'MERERecord',
        'Accuracy',
        'CauseType',
        'CommunicationFailureInfo',
        'CurrentLocationRetrieved',
        'EPSLocationInfo',
        'LocationType',
        'MMELocationInformation',
        'MonitoringEventConfigStatus',
        'MonitoringEventConfigurationActivity',
        'MonitoringEventReportData',
        'MonitoringType',
        'NumberOfUEPerLocationReport',
        'ReachabilityConfiguration',
        'ReachabilityType',
        'SGSNLocationInformation',
        'SCEFReferenceID',
        'ServiceResult',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MERecordType >-----#
    MERecordType = CHOICE(name='MERecordType', mode=MODE_TYPE)
    _MERecordType_mECORecord = SET(name='mECORecord', mode=MODE_TYPE, tag=(103, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MECORecord')))
    _MERecordType_mERERecord = SET(name='mERERecord', mode=MODE_TYPE, tag=(104, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MERERecord')))
    MERecordType._cont = ASN1Dict([
        ('mECORecord', _MERecordType_mECORecord),
        ('mERERecord', _MERecordType_mERERecord),
        ])
    MERecordType._ext = None
    
    #-----< MECORecord >-----#
    MECORecord = SET(name='MECORecord', mode=MODE_TYPE)
    _MECORecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MECORecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MECORecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _MECORecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MECORecord_eventTimestamp = OCT_STR(name='eventTimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MECORecord_monitoringEventConfigurationActivity = ENUM(name='monitoringEventConfigurationActivity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringEventConfigurationActivity')), opt=True)
    _MECORecord_sCEFReferenceID = INT(name='sCEFReferenceID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SCEFReferenceID')), opt=True)
    _MECORecord_sCEFID = OCT_STR(name='sCEFID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _MECORecord_monitoringType = ENUM(name='monitoringType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringType')), opt=True)
    _MECORecord_maximumNumberofReports = INT(name='maximumNumberofReports', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_monitoringDuration = OCT_STR(name='monitoringDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MECORecord_chargeablePartyIdentifier = STR_UTF8(name='chargeablePartyIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_monitoredUser = OCT_STR(name='monitoredUser', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MECORecord_maximumDetectionTime = INT(name='maximumDetectionTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MECORecord_reachabilityConfiguration = SEQ(name='reachabilityConfiguration', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ReachabilityConfiguration')), opt=True)
    _MECORecord_locationType = ENUM(name='locationType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'LocationType')), opt=True)
    _MECORecord_accuracy = ENUM(name='accuracy', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'Accuracy')), opt=True)
    _MECORecord_listofLocations = SEQ_OF(name='listofLocations', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MECORecord_listofLocations__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'EPSLocationInfo')))
    _MECORecord_listofLocations._cont = __MECORecord_listofLocations__item_
    _MECORecord_monitoringEventConfigStatus = SEQ(name='monitoringEventConfigStatus', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringEventConfigStatus')), opt=True)
    _MECORecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MECORecord._cont = ASN1Dict([
        ('recordType', _MECORecord_recordType),
        ('retransmission', _MECORecord_retransmission),
        ('serviceContextID', _MECORecord_serviceContextID),
        ('nodeID', _MECORecord_nodeID),
        ('recordTimeStamp', _MECORecord_recordTimeStamp),
        ('eventTimestamp', _MECORecord_eventTimestamp),
        ('monitoringEventConfigurationActivity', _MECORecord_monitoringEventConfigurationActivity),
        ('sCEFReferenceID', _MECORecord_sCEFReferenceID),
        ('sCEFID', _MECORecord_sCEFID),
        ('monitoringType', _MECORecord_monitoringType),
        ('maximumNumberofReports', _MECORecord_maximumNumberofReports),
        ('monitoringDuration', _MECORecord_monitoringDuration),
        ('chargeablePartyIdentifier', _MECORecord_chargeablePartyIdentifier),
        ('monitoredUser', _MECORecord_monitoredUser),
        ('maximumDetectionTime', _MECORecord_maximumDetectionTime),
        ('localRecordSequenceNumber', _MECORecord_localRecordSequenceNumber),
        ('reachabilityConfiguration', _MECORecord_reachabilityConfiguration),
        ('locationType', _MECORecord_locationType),
        ('accuracy', _MECORecord_accuracy),
        ('listofLocations', _MECORecord_listofLocations),
        ('monitoringEventConfigStatus', _MECORecord_monitoringEventConfigStatus),
        ('recordExtensions', _MECORecord_recordExtensions),
        ])
    MECORecord._ext = None
    
    #-----< MERERecord >-----#
    MERERecord = SET(name='MERERecord', mode=MODE_TYPE)
    _MERERecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MERERecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MERERecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MERERecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _MERERecord_recordTimeStamp = OCT_STR(name='recordTimeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MERERecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MERERecord_listofMonitoringEventReportData = SEQ_OF(name='listofMonitoringEventReportData', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MERERecord_listofMonitoringEventReportData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringEventReportData')))
    _MERERecord_listofMonitoringEventReportData._cont = __MERERecord_listofMonitoringEventReportData__item_
    _MERERecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MERERecord._cont = ASN1Dict([
        ('recordType', _MERERecord_recordType),
        ('retransmission', _MERERecord_retransmission),
        ('serviceContextID', _MERERecord_serviceContextID),
        ('nodeID', _MERERecord_nodeID),
        ('recordTimeStamp', _MERERecord_recordTimeStamp),
        ('localRecordSequenceNumber', _MERERecord_localRecordSequenceNumber),
        ('listofMonitoringEventReportData', _MERERecord_listofMonitoringEventReportData),
        ('recordExtensions', _MERERecord_recordExtensions),
        ])
    MERERecord._ext = None
    
    #-----< Accuracy >-----#
    Accuracy = ENUM(name='Accuracy', mode=MODE_TYPE)
    Accuracy._cont = ASN1Dict([('cGIECGI', 0), ('eNB', 1), ('lATARA', 2), ('pRA', 3)])
    Accuracy._ext = None
    
    #-----< CauseType >-----#
    CauseType = ENUM(name='CauseType', mode=MODE_TYPE)
    CauseType._cont = ASN1Dict([('radioNetworkLayer', 0), ('transportLayer', 1), ('nAS', 2), ('protocol', 3), ('miscellaneous', 4)])
    CauseType._ext = None
    
    #-----< CommunicationFailureInfo >-----#
    CommunicationFailureInfo = SEQ(name='CommunicationFailureInfo', mode=MODE_TYPE)
    _CommunicationFailureInfo_causeType = ENUM(name='causeType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'CauseType')), opt=True)
    _CommunicationFailureInfo_s1APCause = INT(name='s1APCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_rANAPCause = INT(name='rANAPCause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_bSSGPCause = INT(name='bSSGPCause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_gMMCause = INT(name='gMMCause', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_sMCause = INT(name='sMCause', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CommunicationFailureInfo._cont = ASN1Dict([
        ('causeType', _CommunicationFailureInfo_causeType),
        ('s1APCause', _CommunicationFailureInfo_s1APCause),
        ('rANAPCause', _CommunicationFailureInfo_rANAPCause),
        ('bSSGPCause', _CommunicationFailureInfo_bSSGPCause),
        ('gMMCause', _CommunicationFailureInfo_gMMCause),
        ('sMCause', _CommunicationFailureInfo_sMCause),
        ])
    CommunicationFailureInfo._ext = None
    
    #-----< CurrentLocationRetrieved >-----#
    CurrentLocationRetrieved = ENUM(name='CurrentLocationRetrieved', mode=MODE_TYPE)
    CurrentLocationRetrieved._cont = ASN1Dict([('activeLocationRetrieval', 0)])
    CurrentLocationRetrieved._ext = None
    
    #-----< EPSLocationInfo >-----#
    EPSLocationInfo = SEQ(name='EPSLocationInfo', mode=MODE_TYPE)
    _EPSLocationInfo_mMELocationInformation = SEQ(name='mMELocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MMELocationInformation')), opt=True)
    _EPSLocationInfo_sGSNLocationInformation = SEQ(name='sGSNLocationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SGSNLocationInformation')), opt=True)
    EPSLocationInfo._cont = ASN1Dict([
        ('mMELocationInformation', _EPSLocationInfo_mMELocationInformation),
        ('sGSNLocationInformation', _EPSLocationInfo_sGSNLocationInformation),
        ])
    EPSLocationInfo._ext = None
    
    #-----< LocationType >-----#
    LocationType = ENUM(name='LocationType', mode=MODE_TYPE)
    LocationType._cont = ASN1Dict([('currentLocation', 0), ('lastKnownLocation', 1)])
    LocationType._ext = None
    
    #-----< MMELocationInformation >-----#
    MMELocationInformation = SEQ(name='MMELocationInformation', mode=MODE_TYPE)
    _MMELocationInformation_eUTRANCellGlobalIdentity = OCT_STR(name='eUTRANCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_trackingAreaIdentity = OCT_STR(name='trackingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_currentLocationRetrieved = ENUM(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'CurrentLocationRetrieved')), opt=True)
    _MMELocationInformation_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _MMELocationInformation_eNodeBID = OCT_STR(name='eNodeBID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MMELocationInformation._cont = ASN1Dict([
        ('eUTRANCellGlobalIdentity', _MMELocationInformation_eUTRANCellGlobalIdentity),
        ('trackingAreaIdentity', _MMELocationInformation_trackingAreaIdentity),
        ('geographicalInformation', _MMELocationInformation_geographicalInformation),
        ('geodeticInformation', _MMELocationInformation_geodeticInformation),
        ('currentLocationRetrieved', _MMELocationInformation_currentLocationRetrieved),
        ('ageOfLocationInformation', _MMELocationInformation_ageOfLocationInformation),
        ('userCSGInformation', _MMELocationInformation_userCSGInformation),
        ('eNodeBID', _MMELocationInformation_eNodeBID),
        ])
    MMELocationInformation._ext = None
    
    #-----< MonitoringEventConfigStatus >-----#
    MonitoringEventConfigStatus = SEQ(name='MonitoringEventConfigStatus', mode=MODE_TYPE)
    _MonitoringEventConfigStatus_serviceResult = SEQ(name='serviceResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ServiceResult')), opt=True)
    _MonitoringEventConfigStatus_sCEFReferenceID = INT(name='sCEFReferenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SCEFReferenceID')), opt=True)
    _MonitoringEventConfigStatus_sCEFID = OCT_STR(name='sCEFID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    MonitoringEventConfigStatus._cont = ASN1Dict([
        ('serviceResult', _MonitoringEventConfigStatus_serviceResult),
        ('sCEFReferenceID', _MonitoringEventConfigStatus_sCEFReferenceID),
        ('sCEFID', _MonitoringEventConfigStatus_sCEFID),
        ])
    MonitoringEventConfigStatus._ext = None
    
    #-----< MonitoringEventConfigurationActivity >-----#
    MonitoringEventConfigurationActivity = ENUM(name='MonitoringEventConfigurationActivity', mode=MODE_TYPE)
    MonitoringEventConfigurationActivity._cont = ASN1Dict([('create', 0), ('transfer', 1), ('update', 2), ('delete', 3)])
    MonitoringEventConfigurationActivity._ext = None
    
    #-----< MonitoringEventReportData >-----#
    MonitoringEventReportData = SEQ(name='MonitoringEventReportData', mode=MODE_TYPE)
    _MonitoringEventReportData_eventTimestamp = OCT_STR(name='eventTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MonitoringEventReportData_sCEFReferenceID = INT(name='sCEFReferenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SCEFReferenceID')), opt=True)
    _MonitoringEventReportData_sCEFID = OCT_STR(name='sCEFID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _MonitoringEventReportData_monitoringEventReportNumber = INT(name='monitoringEventReportNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MonitoringEventReportData_chargeablePartyIdentifier = STR_UTF8(name='chargeablePartyIdentifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MonitoringEventReportData_monitoredUser = OCT_STR(name='monitoredUser', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MonitoringEventReportData_monitoringType = ENUM(name='monitoringType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringType')), opt=True)
    _MonitoringEventReportData_reachabilityInformation = ENUM(name='reachabilityInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ReachabilityType')), opt=True)
    _MonitoringEventReportData_reportedLocation = SEQ(name='reportedLocation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'EPSLocationInfo')), opt=True)
    _MonitoringEventReportData_communicationFailureInformation = SEQ_OF(name='communicationFailureInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MonitoringEventReportData_communicationFailureInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'CommunicationFailureInfo')))
    _MonitoringEventReportData_communicationFailureInformation._cont = __MonitoringEventReportData_communicationFailureInformation__item_
    _MonitoringEventReportData_listOfNumberOfUEPerLocationReport = SEQ_OF(name='listOfNumberOfUEPerLocationReport', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MonitoringEventReportData_listOfNumberOfUEPerLocationReport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'NumberOfUEPerLocationReport')))
    _MonitoringEventReportData_listOfNumberOfUEPerLocationReport._cont = __MonitoringEventReportData_listOfNumberOfUEPerLocationReport__item_
    MonitoringEventReportData._cont = ASN1Dict([
        ('eventTimestamp', _MonitoringEventReportData_eventTimestamp),
        ('sCEFReferenceID', _MonitoringEventReportData_sCEFReferenceID),
        ('sCEFID', _MonitoringEventReportData_sCEFID),
        ('monitoringEventReportNumber', _MonitoringEventReportData_monitoringEventReportNumber),
        ('chargeablePartyIdentifier', _MonitoringEventReportData_chargeablePartyIdentifier),
        ('monitoredUser', _MonitoringEventReportData_monitoredUser),
        ('monitoringType', _MonitoringEventReportData_monitoringType),
        ('reachabilityInformation', _MonitoringEventReportData_reachabilityInformation),
        ('reportedLocation', _MonitoringEventReportData_reportedLocation),
        ('communicationFailureInformation', _MonitoringEventReportData_communicationFailureInformation),
        ('listOfNumberOfUEPerLocationReport', _MonitoringEventReportData_listOfNumberOfUEPerLocationReport),
        ])
    MonitoringEventReportData._ext = None
    
    #-----< MonitoringType >-----#
    MonitoringType = ENUM(name='MonitoringType', mode=MODE_TYPE)
    MonitoringType._cont = ASN1Dict([('lossOfConnectivity', 0), ('ueReachability', 1), ('locationReporting', 2), ('changeOfIMSIIMEISVAssociation', 3), ('roamingStatus', 4), ('communicationFailure', 5), ('availabilityAfterDDNFailure', 6), ('numberOfUEPerLocation', 7)])
    MonitoringType._ext = None
    
    #-----< NumberOfUEPerLocationReport >-----#
    NumberOfUEPerLocationReport = SEQ(name='NumberOfUEPerLocationReport', mode=MODE_TYPE)
    _NumberOfUEPerLocationReport_ePSLocationInformation = SEQ(name='ePSLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'EPSLocationInfo')), opt=True)
    _NumberOfUEPerLocationReport_uECount = INT(name='uECount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    NumberOfUEPerLocationReport._cont = ASN1Dict([
        ('ePSLocationInformation', _NumberOfUEPerLocationReport_ePSLocationInformation),
        ('uECount', _NumberOfUEPerLocationReport_uECount),
        ])
    NumberOfUEPerLocationReport._ext = None
    
    #-----< ReachabilityConfiguration >-----#
    ReachabilityConfiguration = SEQ(name='ReachabilityConfiguration', mode=MODE_TYPE)
    _ReachabilityConfiguration_reachabilityType = ENUM(name='reachabilityType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ReachabilityType')), opt=True)
    _ReachabilityConfiguration_maximumLatency = INT(name='maximumLatency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReachabilityConfiguration_maximumResponseTime = INT(name='maximumResponseTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ReachabilityConfiguration._cont = ASN1Dict([
        ('reachabilityType', _ReachabilityConfiguration_reachabilityType),
        ('maximumLatency', _ReachabilityConfiguration_maximumLatency),
        ('maximumResponseTime', _ReachabilityConfiguration_maximumResponseTime),
        ])
    ReachabilityConfiguration._ext = None
    
    #-----< ReachabilityType >-----#
    ReachabilityType = ENUM(name='ReachabilityType', mode=MODE_TYPE)
    ReachabilityType._cont = ASN1Dict([('reachabilityforSMS', 0), ('reachabilityforData', 1)])
    ReachabilityType._ext = None
    
    #-----< SGSNLocationInformation >-----#
    SGSNLocationInformation = SEQ(name='SGSNLocationInformation', mode=MODE_TYPE)
    _SGSNLocationInformation_cellGlobalIdentity = OCT_STR(name='cellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_locationAreaIdentity = OCT_STR(name='locationAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_serviceAreaIdentity = OCT_STR(name='serviceAreaIdentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_routingAreaIdentity = OCT_STR(name='routingAreaIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_geographicalInformation = OCT_STR(name='geographicalInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_geodeticInformation = OCT_STR(name='geodeticInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_currentLocationRetrieved = ENUM(name='currentLocationRetrieved', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'CurrentLocationRetrieved')), opt=True)
    _SGSNLocationInformation_ageOfLocationInformation = INT(name='ageOfLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_userCSGInformation = SEQ(name='userCSGInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    SGSNLocationInformation._cont = ASN1Dict([
        ('cellGlobalIdentity', _SGSNLocationInformation_cellGlobalIdentity),
        ('locationAreaIdentity', _SGSNLocationInformation_locationAreaIdentity),
        ('serviceAreaIdentity', _SGSNLocationInformation_serviceAreaIdentity),
        ('routingAreaIdentity', _SGSNLocationInformation_routingAreaIdentity),
        ('geographicalInformation', _SGSNLocationInformation_geographicalInformation),
        ('geodeticInformation', _SGSNLocationInformation_geodeticInformation),
        ('currentLocationRetrieved', _SGSNLocationInformation_currentLocationRetrieved),
        ('ageOfLocationInformation', _SGSNLocationInformation_ageOfLocationInformation),
        ('userCSGInformation', _SGSNLocationInformation_userCSGInformation),
        ])
    SGSNLocationInformation._ext = None
    
    #-----< SCEFReferenceID >-----#
    SCEFReferenceID = INT(name='SCEFReferenceID', mode=MODE_TYPE)
    SCEFReferenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< ServiceResult >-----#
    ServiceResult = SEQ(name='ServiceResult', mode=MODE_TYPE)
    _ServiceResult_vendorId = INT(name='vendorId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceResult_serviceResultCode = INT(name='serviceResultCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ServiceResult._cont = ASN1Dict([
        ('vendorId', _ServiceResult_vendorId),
        ('serviceResultCode', _ServiceResult_serviceResultCode),
        ])
    ServiceResult._ext = None
    
    _all_ = [
        _MERecordType_mECORecord,
        _MERecordType_mERERecord,
        MERecordType,
        _MECORecord_recordType,
        _MECORecord_retransmission,
        _MECORecord_serviceContextID,
        _MECORecord_nodeID,
        _MECORecord_recordTimeStamp,
        _MECORecord_eventTimestamp,
        _MECORecord_monitoringEventConfigurationActivity,
        _MECORecord_sCEFReferenceID,
        _MECORecord_sCEFID,
        _MECORecord_monitoringType,
        _MECORecord_maximumNumberofReports,
        _MECORecord_monitoringDuration,
        _MECORecord_chargeablePartyIdentifier,
        _MECORecord_monitoredUser,
        _MECORecord_maximumDetectionTime,
        _MECORecord_localRecordSequenceNumber,
        _MECORecord_reachabilityConfiguration,
        _MECORecord_locationType,
        _MECORecord_accuracy,
        __MECORecord_listofLocations__item_,
        _MECORecord_listofLocations,
        _MECORecord_monitoringEventConfigStatus,
        _MECORecord_recordExtensions,
        MECORecord,
        _MERERecord_recordType,
        _MERERecord_retransmission,
        _MERERecord_serviceContextID,
        _MERERecord_nodeID,
        _MERERecord_recordTimeStamp,
        _MERERecord_localRecordSequenceNumber,
        __MERERecord_listofMonitoringEventReportData__item_,
        _MERERecord_listofMonitoringEventReportData,
        _MERERecord_recordExtensions,
        MERERecord,
        Accuracy,
        CauseType,
        _CommunicationFailureInfo_causeType,
        _CommunicationFailureInfo_s1APCause,
        _CommunicationFailureInfo_rANAPCause,
        _CommunicationFailureInfo_bSSGPCause,
        _CommunicationFailureInfo_gMMCause,
        _CommunicationFailureInfo_sMCause,
        CommunicationFailureInfo,
        CurrentLocationRetrieved,
        _EPSLocationInfo_mMELocationInformation,
        _EPSLocationInfo_sGSNLocationInformation,
        EPSLocationInfo,
        LocationType,
        _MMELocationInformation_eUTRANCellGlobalIdentity,
        _MMELocationInformation_trackingAreaIdentity,
        _MMELocationInformation_geographicalInformation,
        _MMELocationInformation_geodeticInformation,
        _MMELocationInformation_currentLocationRetrieved,
        _MMELocationInformation_ageOfLocationInformation,
        _MMELocationInformation_userCSGInformation,
        _MMELocationInformation_eNodeBID,
        MMELocationInformation,
        _MonitoringEventConfigStatus_serviceResult,
        _MonitoringEventConfigStatus_sCEFReferenceID,
        _MonitoringEventConfigStatus_sCEFID,
        MonitoringEventConfigStatus,
        MonitoringEventConfigurationActivity,
        _MonitoringEventReportData_eventTimestamp,
        _MonitoringEventReportData_sCEFReferenceID,
        _MonitoringEventReportData_sCEFID,
        _MonitoringEventReportData_monitoringEventReportNumber,
        _MonitoringEventReportData_chargeablePartyIdentifier,
        _MonitoringEventReportData_monitoredUser,
        _MonitoringEventReportData_monitoringType,
        _MonitoringEventReportData_reachabilityInformation,
        _MonitoringEventReportData_reportedLocation,
        __MonitoringEventReportData_communicationFailureInformation__item_,
        _MonitoringEventReportData_communicationFailureInformation,
        __MonitoringEventReportData_listOfNumberOfUEPerLocationReport__item_,
        _MonitoringEventReportData_listOfNumberOfUEPerLocationReport,
        MonitoringEventReportData,
        MonitoringType,
        _NumberOfUEPerLocationReport_ePSLocationInformation,
        _NumberOfUEPerLocationReport_uECount,
        NumberOfUEPerLocationReport,
        _ReachabilityConfiguration_reachabilityType,
        _ReachabilityConfiguration_maximumLatency,
        _ReachabilityConfiguration_maximumResponseTime,
        ReachabilityConfiguration,
        ReachabilityType,
        _SGSNLocationInformation_cellGlobalIdentity,
        _SGSNLocationInformation_locationAreaIdentity,
        _SGSNLocationInformation_serviceAreaIdentity,
        _SGSNLocationInformation_routingAreaIdentity,
        _SGSNLocationInformation_geographicalInformation,
        _SGSNLocationInformation_geodeticInformation,
        _SGSNLocationInformation_currentLocationRetrieved,
        _SGSNLocationInformation_ageOfLocationInformation,
        _SGSNLocationInformation_userCSGInformation,
        SGSNLocationInformation,
        SCEFReferenceID,
        _ServiceResult_vendorId,
        _ServiceResult_serviceResultCode,
        ServiceResult,
    ]

class OperationalBindingManagement:

    _name_  = 'OperationalBindingManagement'
    _oid_   = [2, 5, 1, 18, 8]
    
    _obj_ = [
        'dSAOperationalBindingManagementBind',
        'OPERATIONAL-BINDING',
        'OP-BINDING-COOP',
        'OP-BIND-ROLE',
        'establishOperationalBinding',
        'EstablishOperationalBindingArgument',
        'EstablishOperationalBindingArgumentData',
        'OpBindingSet',
        'OperationalBindingID',
        'Validity',
        'Time',
        'EstablishOperationalBindingResult',
        'EstablishOperationalBindingResultData',
        'modifyOperationalBinding',
        'ModifyOperationalBindingArgument',
        'ModifyOperationalBindingArgumentData',
        'ModifiedValidity',
        'ModifyOperationalBindingResult',
        'ModifyOperationalBindingResultData',
        'terminateOperationalBinding',
        'TerminateOperationalBindingArgument',
        'TerminateOperationalBindingArgumentData',
        'TerminateOperationalBindingResult',
        'TerminateOperationalBindingResultData',
        'operationalBindingError',
        'OpBindingErrorParam',
        ]
    _type_ = [
        'OPERATIONAL-BINDING',
        'OP-BINDING-COOP',
        'OP-BIND-ROLE',
        'EstablishOperationalBindingArgument',
        'EstablishOperationalBindingArgumentData',
        'OperationalBindingID',
        'Validity',
        'Time',
        'EstablishOperationalBindingResult',
        'EstablishOperationalBindingResultData',
        'ModifyOperationalBindingArgument',
        'ModifyOperationalBindingArgumentData',
        'ModifiedValidity',
        'ModifyOperationalBindingResult',
        'ModifyOperationalBindingResultData',
        'TerminateOperationalBindingArgument',
        'TerminateOperationalBindingArgumentData',
        'TerminateOperationalBindingResult',
        'TerminateOperationalBindingResultData',
        'OpBindingErrorParam',
        ]
    _set_ = [
        'OpBindingSet',
        ]
    _val_ = [
        'dSAOperationalBindingManagementBind',
        'establishOperationalBinding',
        'modifyOperationalBinding',
        'terminateOperationalBinding',
        'operationalBindingError',
        ]
    _class_ = [
        'dSAOperationalBindingManagementBind',
        'OPERATIONAL-BINDING',
        'OP-BINDING-COOP',
        'OP-BIND-ROLE',
        'establishOperationalBinding',
        'OpBindingSet',
        'modifyOperationalBinding',
        'terminateOperationalBinding',
        'operationalBindingError',
        ]
    _param_ = [
        ]
    
    #-----< dSAOperationalBindingManagementBind >-----#
    dSAOperationalBindingManagementBind = CLASS(name='dSAOperationalBindingManagementBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSAOperationalBindingManagementBind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSAOperationalBindingManagementBind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSAOperationalBindingManagementBind._val = dict([('ArgumentType', _dSAOperationalBindingManagementBind_val_ArgumentType), ('ResultType', _dSAOperationalBindingManagementBind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< OPERATIONAL-BINDING >-----#
    OPERATIONAL_BINDING = CLASS(name='OPERATIONAL-BINDING', mode=MODE_TYPE)
    _OPERATIONAL_BINDING_Agreement = OPEN(name='Agreement', mode=MODE_TYPE)
    _OPERATIONAL_BINDING_Cooperation = CLASS(name='Cooperation', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BINDING-COOP')))
    _OPERATIONAL_BINDING_both = CLASS(name='both', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_roleA = CLASS(name='roleA', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_roleB = CLASS(name='roleB', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    OPERATIONAL_BINDING._cont = ASN1Dict([
        ('Agreement', _OPERATIONAL_BINDING_Agreement),
        ('Cooperation', _OPERATIONAL_BINDING_Cooperation),
        ('both', _OPERATIONAL_BINDING_both),
        ('roleA', _OPERATIONAL_BINDING_roleA),
        ('roleB', _OPERATIONAL_BINDING_roleB),
        ('id', _OPERATIONAL_BINDING_id),
        ])
    
    #-----< OP-BINDING-COOP >-----#
    OP_BINDING_COOP = CLASS(name='OP-BINDING-COOP', mode=MODE_TYPE)
    _OP_BINDING_COOP_applContext = CLASS(name='applContext', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    _OP_BINDING_COOP_Operations = CLASS(name='Operations', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')), opt=True)
    OP_BINDING_COOP._cont = ASN1Dict([
        ('applContext', _OP_BINDING_COOP_applContext),
        ('Operations', _OP_BINDING_COOP_Operations),
        ])
    
    #-----< OP-BIND-ROLE >-----#
    OP_BIND_ROLE = CLASS(name='OP-BIND-ROLE', mode=MODE_TYPE)
    _OP_BIND_ROLE_establish = BOOL(name='establish', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_EstablishParam = OPEN(name='EstablishParam', mode=MODE_TYPE)
    _OP_BIND_ROLE_modify = BOOL(name='modify', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_ModifyParam = OPEN(name='ModifyParam', mode=MODE_TYPE, opt=True)
    _OP_BIND_ROLE_terminate = BOOL(name='terminate', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_TerminateParam = OPEN(name='TerminateParam', mode=MODE_TYPE, opt=True)
    OP_BIND_ROLE._cont = ASN1Dict([
        ('establish', _OP_BIND_ROLE_establish),
        ('EstablishParam', _OP_BIND_ROLE_EstablishParam),
        ('modify', _OP_BIND_ROLE_modify),
        ('ModifyParam', _OP_BIND_ROLE_ModifyParam),
        ('terminate', _OP_BIND_ROLE_terminate),
        ('TerminateParam', _OP_BIND_ROLE_TerminateParam),
        ])
    
    #-----< establishOperationalBinding >-----#
    establishOperationalBinding = CLASS(name='establishOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _establishOperationalBinding_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _establishOperationalBinding_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    establishOperationalBinding._val = dict([('ArgumentType', _establishOperationalBinding_val_ArgumentType), ('ResultType', _establishOperationalBinding_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))])
    
    #-----< EstablishOperationalBindingArgument >-----#
    EstablishOperationalBindingArgument = CHOICE(name='EstablishOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _EstablishOperationalBindingArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgumentData')))
    _EstablishOperationalBindingArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __EstablishOperationalBindingArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgumentData')))
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __EstablishOperationalBindingArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _EstablishOperationalBindingArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __EstablishOperationalBindingArgument_signed_toBeSigned),
        ('algorithmIdentifier', __EstablishOperationalBindingArgument_signed_algorithmIdentifier),
        ('signature', __EstablishOperationalBindingArgument_signed_signature),
        ])
    _EstablishOperationalBindingArgument_signed._ext = []
    EstablishOperationalBindingArgument._cont = ASN1Dict([
        ('unsigned', _EstablishOperationalBindingArgument_unsigned),
        ('signed', _EstablishOperationalBindingArgument_signed),
        ])
    EstablishOperationalBindingArgument._ext = None
    
    #-----< EstablishOperationalBindingArgumentData >-----#
    EstablishOperationalBindingArgumentData = SEQ(name='EstablishOperationalBindingArgumentData', mode=MODE_TYPE)
    _EstablishOperationalBindingArgumentData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __EstablishOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __OPERATIONAL_BINDING_roleA_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __OPERATIONAL_BINDING_roleB_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __OPERATIONAL_BINDING_roleB_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ModificationParameter')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_0_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        ('signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    __OPERATIONAL_BINDING_roleA_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleA_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinateModification')))
    __OPERATIONAL_BINDING_roleB_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    __OPERATIONAL_BINDING_roleB_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __OPERATIONAL_BINDING_roleA_val_EstablishParam_1 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleA_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleB_val_EstablishParam_1 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __OPERATIONAL_BINDING_roleB_val_ModifyParam_1 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __EstablishOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _EstablishOperationalBindingArgumentData_bindingType._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    _EstablishOperationalBindingArgumentData_bindingType._const_tab_at = None
    _EstablishOperationalBindingArgumentData_bindingType._const_tab_id = 'id'
    _EstablishOperationalBindingArgumentData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')), opt=True)
    _EstablishOperationalBindingArgumentData_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _EstablishOperationalBindingArgumentData_initiator = CHOICE(name='initiator', mode=MODE_TYPE)
    __EstablishOperationalBindingArgumentData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name='roleA-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name='roleB-initiates', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = 'EstablishParam'
    _EstablishOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        ('symmetric', __EstablishOperationalBindingArgumentData_initiator_symmetric),
        ('roleA-initiates', __EstablishOperationalBindingArgumentData_initiator_roleA_initiates),
        ('roleB-initiates', __EstablishOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _EstablishOperationalBindingArgumentData_initiator._ext = None
    _EstablishOperationalBindingArgumentData_agreement = OPEN(name='agreement', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']))
    _EstablishOperationalBindingArgumentData_agreement._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    _EstablishOperationalBindingArgumentData_agreement._const_tab_at = ('..', 'bindingType')
    _EstablishOperationalBindingArgumentData_agreement._const_tab_id = 'Agreement'
    _EstablishOperationalBindingArgumentData_valid = SEQ(name='valid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Validity')), default=dict([]))
    _EstablishOperationalBindingArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    EstablishOperationalBindingArgumentData._cont = ASN1Dict([
        ('bindingType', _EstablishOperationalBindingArgumentData_bindingType),
        ('bindingID', _EstablishOperationalBindingArgumentData_bindingID),
        ('accessPoint', _EstablishOperationalBindingArgumentData_accessPoint),
        ('initiator', _EstablishOperationalBindingArgumentData_initiator),
        ('agreement', _EstablishOperationalBindingArgumentData_agreement),
        ('valid', _EstablishOperationalBindingArgumentData_valid),
        ('securityParameters', _EstablishOperationalBindingArgumentData_securityParameters),
        ])
    EstablishOperationalBindingArgumentData._ext = []
    
    #-----< OpBindingSet >-----#
    OpBindingSet = CLASS(name='OpBindingSet', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _OpBindingSet_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    _OpBindingSet_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    _OpBindingSet_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    OpBindingSet._val = ASN1Set(rv=[dict([('Agreement', _OpBindingSet_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', _OpBindingSet_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', _OpBindingSet_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    
    #-----< OperationalBindingID >-----#
    OperationalBindingID = SEQ(name='OperationalBindingID', mode=MODE_TYPE)
    _OperationalBindingID_identifier = INT(name='identifier', mode=MODE_TYPE)
    _OperationalBindingID_version = INT(name='version', mode=MODE_TYPE)
    OperationalBindingID._cont = ASN1Dict([
        ('identifier', _OperationalBindingID_identifier),
        ('version', _OperationalBindingID_version),
        ])
    OperationalBindingID._ext = []
    
    #-----< Validity >-----#
    Validity = SEQ(name='Validity', mode=MODE_TYPE)
    _Validity_validFrom = CHOICE(name='validFrom', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('now', 0))
    __Validity_validFrom_now = NULL(name='now', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Validity_validFrom_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _Validity_validFrom._cont = ASN1Dict([
        ('now', __Validity_validFrom_now),
        ('time', __Validity_validFrom_time),
        ])
    _Validity_validFrom._ext = []
    _Validity_validUntil = CHOICE(name='validUntil', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('explicitTermination', 0))
    __Validity_validUntil_explicitTermination = NULL(name='explicitTermination', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Validity_validUntil_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _Validity_validUntil._cont = ASN1Dict([
        ('explicitTermination', __Validity_validUntil_explicitTermination),
        ('time', __Validity_validUntil_time),
        ])
    _Validity_validUntil._ext = []
    Validity._cont = ASN1Dict([
        ('validFrom', _Validity_validFrom),
        ('validUntil', _Validity_validUntil),
        ])
    Validity._ext = []
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< EstablishOperationalBindingResult >-----#
    EstablishOperationalBindingResult = CHOICE(name='EstablishOperationalBindingResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _EstablishOperationalBindingResult_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResultData')))
    _EstablishOperationalBindingResult_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __EstablishOperationalBindingResult_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResultData')))
    __EstablishOperationalBindingResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab = ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab = ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __EstablishOperationalBindingResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters),
        ])
    __EstablishOperationalBindingResult_signed_algorithmIdentifier._ext = []
    __EstablishOperationalBindingResult_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _EstablishOperationalBindingResult_signed._cont = ASN1Dict([
        ('toBeSigned', __EstablishOperationalBindingResult_signed_toBeSigned),
        ('algorithmIdentifier', __EstablishOperationalBindingResult_signed_algorithmIdentifier),
        ('signature', __EstablishOperationalBindingResult_signed_signature),
        ])
    _EstablishOperationalBindingResult_signed._ext = []
    EstablishOperationalBindingResult._cont = ASN1Dict([
        ('unsigned', _EstablishOperationalBindingResult_unsigned),
        ('signed', _EstablishOperationalBindingResult_signed),
        ])
    EstablishOperationalBindingResult._ext = None
    
    #-----< EstablishOperationalBindingResultData >-----#
    EstablishOperationalBindingResultData = SEQ(name='EstablishOperationalBindingResultData', mode=MODE_TYPE)
    _EstablishOperationalBindingResultData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __EstablishOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __EstablishOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _EstablishOperationalBindingResultData_bindingType._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    _EstablishOperationalBindingResultData_bindingType._const_tab_at = None
    _EstablishOperationalBindingResultData_bindingType._const_tab_id = 'id'
    _EstablishOperationalBindingResultData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')), opt=True)
    _EstablishOperationalBindingResultData_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _EstablishOperationalBindingResultData_initiator = CHOICE(name='initiator', mode=MODE_TYPE)
    __EstablishOperationalBindingResultData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingResultData_initiator_roleA_replies = OPEN(name='roleA-replies', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingResultData_initiator_roleB_replies = OPEN(name='roleB-replies', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab_id = 'EstablishParam'
    _EstablishOperationalBindingResultData_initiator._cont = ASN1Dict([
        ('symmetric', __EstablishOperationalBindingResultData_initiator_symmetric),
        ('roleA-replies', __EstablishOperationalBindingResultData_initiator_roleA_replies),
        ('roleB-replies', __EstablishOperationalBindingResultData_initiator_roleB_replies),
        ])
    _EstablishOperationalBindingResultData_initiator._ext = None
    _EstablishOperationalBindingResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _EstablishOperationalBindingResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _EstablishOperationalBindingResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EstablishOperationalBindingResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EstablishOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___EstablishOperationalBindingResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____EstablishOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____EstablishOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab_id = 'id'
    ___EstablishOperationalBindingResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____EstablishOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___EstablishOperationalBindingResultData_notification__item__values._cont = ____EstablishOperationalBindingResultData_notification__item__values__item_
    ___EstablishOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext._cont = ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __EstablishOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        ('type', ___EstablishOperationalBindingResultData_notification__item__type),
        ('values', ___EstablishOperationalBindingResultData_notification__item__values),
        ('valuesWithContext', ___EstablishOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __EstablishOperationalBindingResultData_notification__item_._ext = []
    _EstablishOperationalBindingResultData_notification._cont = __EstablishOperationalBindingResultData_notification__item_
    EstablishOperationalBindingResultData._cont = ASN1Dict([
        ('bindingType', _EstablishOperationalBindingResultData_bindingType),
        ('bindingID', _EstablishOperationalBindingResultData_bindingID),
        ('accessPoint', _EstablishOperationalBindingResultData_accessPoint),
        ('initiator', _EstablishOperationalBindingResultData_initiator),
        ('securityParameters', _EstablishOperationalBindingResultData_securityParameters),
        ('performer', _EstablishOperationalBindingResultData_performer),
        ('aliasDereferenced', _EstablishOperationalBindingResultData_aliasDereferenced),
        ('notification', _EstablishOperationalBindingResultData_notification),
        ])
    EstablishOperationalBindingResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< modifyOperationalBinding >-----#
    modifyOperationalBinding = CLASS(name='modifyOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyOperationalBinding_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _modifyOperationalBinding_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    modifyOperationalBinding._val = dict([('ArgumentType', _modifyOperationalBinding_val_ArgumentType), ('ResultType', _modifyOperationalBinding_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))])
    
    #-----< ModifyOperationalBindingArgument >-----#
    ModifyOperationalBindingArgument = CHOICE(name='ModifyOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _ModifyOperationalBindingArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgumentData')))
    _ModifyOperationalBindingArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyOperationalBindingArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgumentData')))
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __ModifyOperationalBindingArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _ModifyOperationalBindingArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ModifyOperationalBindingArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ModifyOperationalBindingArgument_signed_algorithmIdentifier),
        ('signature', __ModifyOperationalBindingArgument_signed_signature),
        ])
    _ModifyOperationalBindingArgument_signed._ext = []
    ModifyOperationalBindingArgument._cont = ASN1Dict([
        ('unsigned', _ModifyOperationalBindingArgument_unsigned),
        ('signed', _ModifyOperationalBindingArgument_signed),
        ])
    ModifyOperationalBindingArgument._ext = None
    
    #-----< ModifyOperationalBindingArgumentData >-----#
    ModifyOperationalBindingArgumentData = SEQ(name='ModifyOperationalBindingArgumentData', mode=MODE_TYPE)
    _ModifyOperationalBindingArgumentData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __ModifyOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __ModifyOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _ModifyOperationalBindingArgumentData_bindingType._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    _ModifyOperationalBindingArgumentData_bindingType._const_tab_at = None
    _ModifyOperationalBindingArgumentData_bindingType._const_tab_id = 'id'
    _ModifyOperationalBindingArgumentData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingArgumentData_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _ModifyOperationalBindingArgumentData_initiator = CHOICE(name='initiator', mode=MODE_TYPE, opt=True)
    __ModifyOperationalBindingArgumentData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab_id = 'ModifyParam'
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name='roleA-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', 'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = 'ModifyParam'
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name='roleB-initiates', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', 'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = 'ModifyParam'
    _ModifyOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        ('symmetric', __ModifyOperationalBindingArgumentData_initiator_symmetric),
        ('roleA-initiates', __ModifyOperationalBindingArgumentData_initiator_roleA_initiates),
        ('roleB-initiates', __ModifyOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _ModifyOperationalBindingArgumentData_initiator._ext = None
    _ModifyOperationalBindingArgumentData_newBindingID = SEQ(name='newBindingID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingArgumentData_newAgreement = OPEN(name='newAgreement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']), opt=True)
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab_at = ('..', 'bindingType')
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab_id = 'Agreement'
    _ModifyOperationalBindingArgumentData_valid = SEQ(name='valid', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'ModifiedValidity')), opt=True)
    _ModifyOperationalBindingArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ModifyOperationalBindingArgumentData._cont = ASN1Dict([
        ('bindingType', _ModifyOperationalBindingArgumentData_bindingType),
        ('bindingID', _ModifyOperationalBindingArgumentData_bindingID),
        ('accessPoint', _ModifyOperationalBindingArgumentData_accessPoint),
        ('initiator', _ModifyOperationalBindingArgumentData_initiator),
        ('newBindingID', _ModifyOperationalBindingArgumentData_newBindingID),
        ('newAgreement', _ModifyOperationalBindingArgumentData_newAgreement),
        ('valid', _ModifyOperationalBindingArgumentData_valid),
        ('securityParameters', _ModifyOperationalBindingArgumentData_securityParameters),
        ])
    ModifyOperationalBindingArgumentData._ext = []
    
    #-----< ModifiedValidity >-----#
    ModifiedValidity = SEQ(name='ModifiedValidity', mode=MODE_TYPE)
    _ModifiedValidity_validFrom = CHOICE(name='validFrom', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('now', 0))
    __ModifiedValidity_validFrom_now = NULL(name='now', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifiedValidity_validFrom_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _ModifiedValidity_validFrom._cont = ASN1Dict([
        ('now', __ModifiedValidity_validFrom_now),
        ('time', __ModifiedValidity_validFrom_time),
        ])
    _ModifiedValidity_validFrom._ext = []
    _ModifiedValidity_validUntil = CHOICE(name='validUntil', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('unchanged', 0))
    __ModifiedValidity_validUntil_explicitTermination = NULL(name='explicitTermination', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifiedValidity_validUntil_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    __ModifiedValidity_validUntil_unchanged = NULL(name='unchanged', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _ModifiedValidity_validUntil._cont = ASN1Dict([
        ('explicitTermination', __ModifiedValidity_validUntil_explicitTermination),
        ('time', __ModifiedValidity_validUntil_time),
        ('unchanged', __ModifiedValidity_validUntil_unchanged),
        ])
    _ModifiedValidity_validUntil._ext = []
    ModifiedValidity._cont = ASN1Dict([
        ('validFrom', _ModifiedValidity_validFrom),
        ('validUntil', _ModifiedValidity_validUntil),
        ])
    ModifiedValidity._ext = []
    
    #-----< ModifyOperationalBindingResult >-----#
    ModifyOperationalBindingResult = CHOICE(name='ModifyOperationalBindingResult', mode=MODE_TYPE)
    _ModifyOperationalBindingResult_null = NULL(name='null', mode=MODE_TYPE)
    _ModifyOperationalBindingResult_protected = CHOICE(name='protected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyOperationalBindingResult_protected_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResultData')))
    __ModifyOperationalBindingResult_protected_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyOperationalBindingResult_protected_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResultData')))
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab = _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier._ext = []
    ___ModifyOperationalBindingResult_protected_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __ModifyOperationalBindingResult_protected_signed._cont = ASN1Dict([
        ('toBeSigned', ___ModifyOperationalBindingResult_protected_signed_toBeSigned),
        ('algorithmIdentifier', ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier),
        ('signature', ___ModifyOperationalBindingResult_protected_signed_signature),
        ])
    __ModifyOperationalBindingResult_protected_signed._ext = []
    _ModifyOperationalBindingResult_protected._cont = ASN1Dict([
        ('unsigned', __ModifyOperationalBindingResult_protected_unsigned),
        ('signed', __ModifyOperationalBindingResult_protected_signed),
        ])
    _ModifyOperationalBindingResult_protected._ext = None
    ModifyOperationalBindingResult._cont = ASN1Dict([
        ('null', _ModifyOperationalBindingResult_null),
        ('protected', _ModifyOperationalBindingResult_protected),
        ])
    ModifyOperationalBindingResult._ext = []
    
    #-----< ModifyOperationalBindingResultData >-----#
    ModifyOperationalBindingResultData = SEQ(name='ModifyOperationalBindingResultData', mode=MODE_TYPE)
    _ModifyOperationalBindingResultData_newBindingID = SEQ(name='newBindingID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingResultData_bindingType = OID(name='bindingType', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __ModifyOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __ModifyOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _ModifyOperationalBindingResultData_bindingType._const_tab = __ModifyOperationalBindingResultData_bindingType_tab
    _ModifyOperationalBindingResultData_bindingType._const_tab_at = None
    _ModifyOperationalBindingResultData_bindingType._const_tab_id = 'id'
    _ModifyOperationalBindingResultData_newAgreement = OPEN(name='newAgreement', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']))
    _ModifyOperationalBindingResultData_newAgreement._const_tab = __ModifyOperationalBindingResultData_bindingType_tab
    _ModifyOperationalBindingResultData_newAgreement._const_tab_at = ('..', 'bindingType')
    _ModifyOperationalBindingResultData_newAgreement._const_tab_id = 'Agreement'
    _ModifyOperationalBindingResultData_valid = SEQ(name='valid', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'Validity')), opt=True)
    _ModifyOperationalBindingResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyOperationalBindingResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyOperationalBindingResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyOperationalBindingResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyOperationalBindingResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ModifyOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab_id = 'id'
    ___ModifyOperationalBindingResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ModifyOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ModifyOperationalBindingResultData_notification__item__values._cont = ____ModifyOperationalBindingResultData_notification__item__values__item_
    ___ModifyOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext._cont = ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ModifyOperationalBindingResultData_notification__item__type),
        ('values', ___ModifyOperationalBindingResultData_notification__item__values),
        ('valuesWithContext', ___ModifyOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __ModifyOperationalBindingResultData_notification__item_._ext = []
    _ModifyOperationalBindingResultData_notification._cont = __ModifyOperationalBindingResultData_notification__item_
    ModifyOperationalBindingResultData._cont = ASN1Dict([
        ('newBindingID', _ModifyOperationalBindingResultData_newBindingID),
        ('bindingType', _ModifyOperationalBindingResultData_bindingType),
        ('newAgreement', _ModifyOperationalBindingResultData_newAgreement),
        ('valid', _ModifyOperationalBindingResultData_valid),
        ('securityParameters', _ModifyOperationalBindingResultData_securityParameters),
        ('performer', _ModifyOperationalBindingResultData_performer),
        ('aliasDereferenced', _ModifyOperationalBindingResultData_aliasDereferenced),
        ('notification', _ModifyOperationalBindingResultData_notification),
        ])
    ModifyOperationalBindingResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< terminateOperationalBinding >-----#
    terminateOperationalBinding = CLASS(name='terminateOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _terminateOperationalBinding_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _terminateOperationalBinding_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    terminateOperationalBinding._val = dict([('ArgumentType', _terminateOperationalBinding_val_ArgumentType), ('ResultType', _terminateOperationalBinding_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])
    
    #-----< TerminateOperationalBindingArgument >-----#
    TerminateOperationalBindingArgument = CHOICE(name='TerminateOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _TerminateOperationalBindingArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgumentData')))
    _TerminateOperationalBindingArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __TerminateOperationalBindingArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgumentData')))
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __TerminateOperationalBindingArgument_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _TerminateOperationalBindingArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __TerminateOperationalBindingArgument_signed_toBeSigned),
        ('algorithmIdentifier', __TerminateOperationalBindingArgument_signed_algorithmIdentifier),
        ('signature', __TerminateOperationalBindingArgument_signed_signature),
        ])
    _TerminateOperationalBindingArgument_signed._ext = []
    TerminateOperationalBindingArgument._cont = ASN1Dict([
        ('unsigned', _TerminateOperationalBindingArgument_unsigned),
        ('signed', _TerminateOperationalBindingArgument_signed),
        ])
    TerminateOperationalBindingArgument._ext = None
    
    #-----< TerminateOperationalBindingArgumentData >-----#
    TerminateOperationalBindingArgumentData = SEQ(name='TerminateOperationalBindingArgumentData', mode=MODE_TYPE)
    _TerminateOperationalBindingArgumentData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __TerminateOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __TerminateOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _TerminateOperationalBindingArgumentData_bindingType._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    _TerminateOperationalBindingArgumentData_bindingType._const_tab_at = None
    _TerminateOperationalBindingArgumentData_bindingType._const_tab_id = 'id'
    _TerminateOperationalBindingArgumentData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _TerminateOperationalBindingArgumentData_initiator = CHOICE(name='initiator', mode=MODE_TYPE, opt=True)
    __TerminateOperationalBindingArgumentData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab_id = 'TerminateParam'
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name='roleA-initiates', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', 'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = 'TerminateParam'
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name='roleB-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', 'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = 'TerminateParam'
    _TerminateOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        ('symmetric', __TerminateOperationalBindingArgumentData_initiator_symmetric),
        ('roleA-initiates', __TerminateOperationalBindingArgumentData_initiator_roleA_initiates),
        ('roleB-initiates', __TerminateOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _TerminateOperationalBindingArgumentData_initiator._ext = None
    _TerminateOperationalBindingArgumentData_terminateAt = CHOICE(name='terminateAt', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')), opt=True)
    _TerminateOperationalBindingArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    TerminateOperationalBindingArgumentData._cont = ASN1Dict([
        ('bindingType', _TerminateOperationalBindingArgumentData_bindingType),
        ('bindingID', _TerminateOperationalBindingArgumentData_bindingID),
        ('initiator', _TerminateOperationalBindingArgumentData_initiator),
        ('terminateAt', _TerminateOperationalBindingArgumentData_terminateAt),
        ('securityParameters', _TerminateOperationalBindingArgumentData_securityParameters),
        ])
    TerminateOperationalBindingArgumentData._ext = []
    
    #-----< TerminateOperationalBindingResult >-----#
    TerminateOperationalBindingResult = CHOICE(name='TerminateOperationalBindingResult', mode=MODE_TYPE)
    _TerminateOperationalBindingResult_null = NULL(name='null', mode=MODE_TYPE)
    _TerminateOperationalBindingResult_protected = CHOICE(name='protected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __TerminateOperationalBindingResult_protected_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResultData')))
    __TerminateOperationalBindingResult_protected_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___TerminateOperationalBindingResult_protected_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResultData')))
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab = _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab = _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm),
        ('parameters', ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters),
        ])
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier._ext = []
    ___TerminateOperationalBindingResult_protected_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __TerminateOperationalBindingResult_protected_signed._cont = ASN1Dict([
        ('toBeSigned', ___TerminateOperationalBindingResult_protected_signed_toBeSigned),
        ('algorithmIdentifier', ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier),
        ('signature', ___TerminateOperationalBindingResult_protected_signed_signature),
        ])
    __TerminateOperationalBindingResult_protected_signed._ext = []
    _TerminateOperationalBindingResult_protected._cont = ASN1Dict([
        ('unsigned', __TerminateOperationalBindingResult_protected_unsigned),
        ('signed', __TerminateOperationalBindingResult_protected_signed),
        ])
    _TerminateOperationalBindingResult_protected._ext = None
    TerminateOperationalBindingResult._cont = ASN1Dict([
        ('null', _TerminateOperationalBindingResult_null),
        ('protected', _TerminateOperationalBindingResult_protected),
        ])
    TerminateOperationalBindingResult._ext = []
    
    #-----< TerminateOperationalBindingResultData >-----#
    TerminateOperationalBindingResultData = SEQ(name='TerminateOperationalBindingResultData', mode=MODE_TYPE)
    _TerminateOperationalBindingResultData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _TerminateOperationalBindingResultData_bindingType = OID(name='bindingType', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __TerminateOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __TerminateOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _TerminateOperationalBindingResultData_bindingType._const_tab = __TerminateOperationalBindingResultData_bindingType_tab
    _TerminateOperationalBindingResultData_bindingType._const_tab_at = None
    _TerminateOperationalBindingResultData_bindingType._const_tab_id = 'id'
    _TerminateOperationalBindingResultData_terminateAt = TIME_GEN(name='terminateAt', mode=MODE_TYPE, opt=True)
    _TerminateOperationalBindingResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _TerminateOperationalBindingResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _TerminateOperationalBindingResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _TerminateOperationalBindingResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TerminateOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___TerminateOperationalBindingResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____TerminateOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____TerminateOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab_id = 'id'
    ___TerminateOperationalBindingResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____TerminateOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___TerminateOperationalBindingResultData_notification__item__values._cont = ____TerminateOperationalBindingResultData_notification__item__values__item_
    ___TerminateOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext._cont = ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __TerminateOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        ('type', ___TerminateOperationalBindingResultData_notification__item__type),
        ('values', ___TerminateOperationalBindingResultData_notification__item__values),
        ('valuesWithContext', ___TerminateOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __TerminateOperationalBindingResultData_notification__item_._ext = []
    _TerminateOperationalBindingResultData_notification._cont = __TerminateOperationalBindingResultData_notification__item_
    TerminateOperationalBindingResultData._cont = ASN1Dict([
        ('bindingID', _TerminateOperationalBindingResultData_bindingID),
        ('bindingType', _TerminateOperationalBindingResultData_bindingType),
        ('terminateAt', _TerminateOperationalBindingResultData_terminateAt),
        ('securityParameters', _TerminateOperationalBindingResultData_securityParameters),
        ('performer', _TerminateOperationalBindingResultData_performer),
        ('aliasDereferenced', _TerminateOperationalBindingResultData_aliasDereferenced),
        ('notification', _TerminateOperationalBindingResultData_notification),
        ])
    TerminateOperationalBindingResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< operationalBindingError >-----#
    operationalBindingError = CLASS(name='operationalBindingError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _operationalBindingError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __operationalBindingError_val_ParameterType_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    __operationalBindingError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___operationalBindingError_val_ParameterType_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___operationalBindingError_val_ParameterType_signed_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __operationalBindingError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___operationalBindingError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier),
        ('signature', ___operationalBindingError_val_ParameterType_signed_signature),
        ])
    __operationalBindingError_val_ParameterType_signed._ext = []
    _operationalBindingError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __operationalBindingError_val_ParameterType_unsigned),
        ('signed', __operationalBindingError_val_ParameterType_signed),
        ])
    _operationalBindingError_val_ParameterType._ext = None
    operationalBindingError._val = dict([('ParameterType', _operationalBindingError_val_ParameterType), ('errorCode', ('local', 100))])
    
    #-----< OpBindingErrorParam >-----#
    OpBindingErrorParam = SEQ(name='OpBindingErrorParam', mode=MODE_TYPE)
    _OpBindingErrorParam_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OpBindingErrorParam_problem._cont = ASN1Dict([('invalidID', 0), ('duplicateID', 1), ('unsupportedBindingType', 2), ('notAllowedForRole', 3), ('parametersMissing', 4), ('roleAssignment', 5), ('invalidStartTime', 6), ('invalidEndTime', 7), ('invalidAgreement', 8), ('currentlyNotDecidable', 9), ('modificationNotAllowed', 10), ('invalidBindingType', 11), ('invalidNewID', 12)])
    _OpBindingErrorParam_problem._ext = []
    _OpBindingErrorParam_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']), opt=True)
    __OpBindingErrorParam_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __OpBindingErrorParam_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _OpBindingErrorParam_bindingType._const_tab = __OpBindingErrorParam_bindingType_tab
    _OpBindingErrorParam_bindingType._const_tab_at = None
    _OpBindingErrorParam_bindingType._const_tab_id = 'id'
    _OpBindingErrorParam_agreementProposal = OPEN(name='agreementProposal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']), opt=True)
    _OpBindingErrorParam_agreementProposal._const_tab = __OpBindingErrorParam_bindingType_tab
    _OpBindingErrorParam_agreementProposal._const_tab_at = ('..', 'bindingType')
    _OpBindingErrorParam_agreementProposal._const_tab_id = 'Agreement'
    _OpBindingErrorParam_retryAt = CHOICE(name='retryAt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')), opt=True)
    _OpBindingErrorParam_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _OpBindingErrorParam_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _OpBindingErrorParam_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _OpBindingErrorParam_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OpBindingErrorParam_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___OpBindingErrorParam_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____OpBindingErrorParam_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____OpBindingErrorParam_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____OpBindingErrorParam_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____OpBindingErrorParam_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____OpBindingErrorParam_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____OpBindingErrorParam_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___OpBindingErrorParam_notification__item__type._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    ___OpBindingErrorParam_notification__item__type._const_tab_at = None
    ___OpBindingErrorParam_notification__item__type._const_tab_id = 'id'
    ___OpBindingErrorParam_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____OpBindingErrorParam_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____OpBindingErrorParam_notification__item__values__item_._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    ____OpBindingErrorParam_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____OpBindingErrorParam_notification__item__values__item_._const_tab_id = 'Type'
    ___OpBindingErrorParam_notification__item__values._cont = ____OpBindingErrorParam_notification__item__values__item_
    ___OpBindingErrorParam_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___OpBindingErrorParam_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList._cont = ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____OpBindingErrorParam_notification__item__valuesWithContext__item__value),
        ('contextList', _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList),
        ])
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_._ext = []
    ___OpBindingErrorParam_notification__item__valuesWithContext._cont = ____OpBindingErrorParam_notification__item__valuesWithContext__item_
    ___OpBindingErrorParam_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __OpBindingErrorParam_notification__item_._cont = ASN1Dict([
        ('type', ___OpBindingErrorParam_notification__item__type),
        ('values', ___OpBindingErrorParam_notification__item__values),
        ('valuesWithContext', ___OpBindingErrorParam_notification__item__valuesWithContext),
        ])
    __OpBindingErrorParam_notification__item_._ext = []
    _OpBindingErrorParam_notification._cont = __OpBindingErrorParam_notification__item_
    OpBindingErrorParam._cont = ASN1Dict([
        ('problem', _OpBindingErrorParam_problem),
        ('bindingType', _OpBindingErrorParam_bindingType),
        ('agreementProposal', _OpBindingErrorParam_agreementProposal),
        ('retryAt', _OpBindingErrorParam_retryAt),
        ('securityParameters', _OpBindingErrorParam_securityParameters),
        ('performer', _OpBindingErrorParam_performer),
        ('aliasDereferenced', _OpBindingErrorParam_aliasDereferenced),
        ('notification', _OpBindingErrorParam_notification),
        ])
    OpBindingErrorParam._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    _all_ = [
        dSAOperationalBindingManagementBind,
        _dSAOperationalBindingManagementBind_val_ArgumentType,
        _dSAOperationalBindingManagementBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _OPERATIONAL_BINDING_Agreement,
        _OPERATIONAL_BINDING_Cooperation,
        _OPERATIONAL_BINDING_both,
        _OPERATIONAL_BINDING_roleA,
        _OPERATIONAL_BINDING_roleB,
        _OPERATIONAL_BINDING_id,
        OPERATIONAL_BINDING,
        _OP_BINDING_COOP_applContext,
        _OP_BINDING_COOP_Operations,
        OP_BINDING_COOP,
        _OP_BIND_ROLE_establish,
        _OP_BIND_ROLE_EstablishParam,
        _OP_BIND_ROLE_modify,
        _OP_BIND_ROLE_ModifyParam,
        _OP_BIND_ROLE_terminate,
        _OP_BIND_ROLE_TerminateParam,
        OP_BIND_ROLE,
        establishOperationalBinding,
        _establishOperationalBinding_val_ArgumentType,
        _establishOperationalBinding_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        _EstablishOperationalBindingArgument_unsigned,
        __EstablishOperationalBindingArgument_signed_toBeSigned,
        ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __EstablishOperationalBindingArgument_signed_algorithmIdentifier,
        __EstablishOperationalBindingArgument_signed_signature,
        _EstablishOperationalBindingArgument_signed,
        EstablishOperationalBindingArgument,
        __EstablishOperationalBindingArgumentData_bindingType_tab,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __OP_BINDING_COOP_Operations_val_ArgumentType_0,
        __OP_BINDING_COOP_Operations_val_ResultType_0,
        __OP_BINDING_COOP_Operations_val_ArgumentType_1,
        __OP_BINDING_COOP_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        __OP_BINDING_COOP_Operations_val_ArgumentType_0_0,
        __OP_BINDING_COOP_Operations_val_ResultType_0_0,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_1,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam_0,
        __OPERATIONAL_BINDING_roleA_val_ModifyParam,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam_0,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam_0,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam_1,
        __OPERATIONAL_BINDING_roleA_val_ModifyParam_0,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam_1,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam_1,
        _EstablishOperationalBindingArgumentData_bindingType,
        _EstablishOperationalBindingArgumentData_bindingID,
        _EstablishOperationalBindingArgumentData_accessPoint,
        __EstablishOperationalBindingArgumentData_initiator_symmetric,
        __EstablishOperationalBindingArgumentData_initiator_roleA_initiates,
        __EstablishOperationalBindingArgumentData_initiator_roleB_initiates,
        _EstablishOperationalBindingArgumentData_initiator,
        _EstablishOperationalBindingArgumentData_agreement,
        _EstablishOperationalBindingArgumentData_valid,
        _EstablishOperationalBindingArgumentData_securityParameters,
        EstablishOperationalBindingArgumentData,
        OpBindingSet,
        _OpBindingSet_val_Agreement_0,
        _OpBindingSet_val_Agreement_1,
        _OpBindingSet_val_Agreement_2,
        _OperationalBindingID_identifier,
        _OperationalBindingID_version,
        OperationalBindingID,
        __Validity_validFrom_now,
        __Validity_validFrom_time,
        _Validity_validFrom,
        __Validity_validUntil_explicitTermination,
        __Validity_validUntil_time,
        _Validity_validUntil,
        Validity,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        _EstablishOperationalBindingResult_unsigned,
        __EstablishOperationalBindingResult_signed_toBeSigned,
        ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab,
        ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm,
        ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab,
        ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters,
        __EstablishOperationalBindingResult_signed_algorithmIdentifier,
        __EstablishOperationalBindingResult_signed_signature,
        _EstablishOperationalBindingResult_signed,
        EstablishOperationalBindingResult,
        __EstablishOperationalBindingResultData_bindingType_tab,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _EstablishOperationalBindingResultData_bindingType,
        _EstablishOperationalBindingResultData_bindingID,
        _EstablishOperationalBindingResultData_accessPoint,
        __EstablishOperationalBindingResultData_initiator_symmetric,
        __EstablishOperationalBindingResultData_initiator_roleA_replies,
        __EstablishOperationalBindingResultData_initiator_roleB_replies,
        _EstablishOperationalBindingResultData_initiator,
        _EstablishOperationalBindingResultData_securityParameters,
        _EstablishOperationalBindingResultData_performer,
        _EstablishOperationalBindingResultData_aliasDereferenced,
        ____EstablishOperationalBindingResultData_notification__item__type_tab,
        _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        ___EstablishOperationalBindingResultData_notification__item__type,
        ____EstablishOperationalBindingResultData_notification__item__values__item_,
        ___EstablishOperationalBindingResultData_notification__item__values,
        _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___EstablishOperationalBindingResultData_notification__item__valuesWithContext,
        __EstablishOperationalBindingResultData_notification__item_,
        _EstablishOperationalBindingResultData_notification,
        EstablishOperationalBindingResultData,
        modifyOperationalBinding,
        _modifyOperationalBinding_val_ArgumentType,
        _modifyOperationalBinding_val_ResultType,
        _ModifyOperationalBindingArgument_unsigned,
        __ModifyOperationalBindingArgument_signed_toBeSigned,
        ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __ModifyOperationalBindingArgument_signed_algorithmIdentifier,
        __ModifyOperationalBindingArgument_signed_signature,
        _ModifyOperationalBindingArgument_signed,
        ModifyOperationalBindingArgument,
        __ModifyOperationalBindingArgumentData_bindingType_tab,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        _ModifyOperationalBindingArgumentData_bindingType,
        _ModifyOperationalBindingArgumentData_bindingID,
        _ModifyOperationalBindingArgumentData_accessPoint,
        __ModifyOperationalBindingArgumentData_initiator_symmetric,
        __ModifyOperationalBindingArgumentData_initiator_roleA_initiates,
        __ModifyOperationalBindingArgumentData_initiator_roleB_initiates,
        _ModifyOperationalBindingArgumentData_initiator,
        _ModifyOperationalBindingArgumentData_newBindingID,
        _ModifyOperationalBindingArgumentData_newAgreement,
        _ModifyOperationalBindingArgumentData_valid,
        _ModifyOperationalBindingArgumentData_securityParameters,
        ModifyOperationalBindingArgumentData,
        __ModifiedValidity_validFrom_now,
        __ModifiedValidity_validFrom_time,
        _ModifiedValidity_validFrom,
        __ModifiedValidity_validUntil_explicitTermination,
        __ModifiedValidity_validUntil_time,
        __ModifiedValidity_validUntil_unchanged,
        _ModifiedValidity_validUntil,
        ModifiedValidity,
        _ModifyOperationalBindingResult_null,
        __ModifyOperationalBindingResult_protected_unsigned,
        ___ModifyOperationalBindingResult_protected_signed_toBeSigned,
        _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm,
        _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab,
        ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters,
        ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier,
        ___ModifyOperationalBindingResult_protected_signed_signature,
        __ModifyOperationalBindingResult_protected_signed,
        _ModifyOperationalBindingResult_protected,
        ModifyOperationalBindingResult,
        _ModifyOperationalBindingResultData_newBindingID,
        __ModifyOperationalBindingResultData_bindingType_tab,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _ModifyOperationalBindingResultData_bindingType,
        _ModifyOperationalBindingResultData_newAgreement,
        _ModifyOperationalBindingResultData_valid,
        _ModifyOperationalBindingResultData_securityParameters,
        _ModifyOperationalBindingResultData_performer,
        _ModifyOperationalBindingResultData_aliasDereferenced,
        ____ModifyOperationalBindingResultData_notification__item__type_tab,
        _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        ___ModifyOperationalBindingResultData_notification__item__type,
        ____ModifyOperationalBindingResultData_notification__item__values__item_,
        ___ModifyOperationalBindingResultData_notification__item__values,
        _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___ModifyOperationalBindingResultData_notification__item__valuesWithContext,
        __ModifyOperationalBindingResultData_notification__item_,
        _ModifyOperationalBindingResultData_notification,
        ModifyOperationalBindingResultData,
        terminateOperationalBinding,
        _terminateOperationalBinding_val_ArgumentType,
        _terminateOperationalBinding_val_ResultType,
        _TerminateOperationalBindingArgument_unsigned,
        __TerminateOperationalBindingArgument_signed_toBeSigned,
        ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __TerminateOperationalBindingArgument_signed_algorithmIdentifier,
        __TerminateOperationalBindingArgument_signed_signature,
        _TerminateOperationalBindingArgument_signed,
        TerminateOperationalBindingArgument,
        __TerminateOperationalBindingArgumentData_bindingType_tab,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        _TerminateOperationalBindingArgumentData_bindingType,
        _TerminateOperationalBindingArgumentData_bindingID,
        __TerminateOperationalBindingArgumentData_initiator_symmetric,
        __TerminateOperationalBindingArgumentData_initiator_roleA_initiates,
        __TerminateOperationalBindingArgumentData_initiator_roleB_initiates,
        _TerminateOperationalBindingArgumentData_initiator,
        _TerminateOperationalBindingArgumentData_terminateAt,
        _TerminateOperationalBindingArgumentData_securityParameters,
        TerminateOperationalBindingArgumentData,
        _TerminateOperationalBindingResult_null,
        __TerminateOperationalBindingResult_protected_unsigned,
        ___TerminateOperationalBindingResult_protected_signed_toBeSigned,
        _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab,
        ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm,
        _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab,
        ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters,
        ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier,
        ___TerminateOperationalBindingResult_protected_signed_signature,
        __TerminateOperationalBindingResult_protected_signed,
        _TerminateOperationalBindingResult_protected,
        TerminateOperationalBindingResult,
        _TerminateOperationalBindingResultData_bindingID,
        __TerminateOperationalBindingResultData_bindingType_tab,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _TerminateOperationalBindingResultData_bindingType,
        _TerminateOperationalBindingResultData_terminateAt,
        _TerminateOperationalBindingResultData_securityParameters,
        _TerminateOperationalBindingResultData_performer,
        _TerminateOperationalBindingResultData_aliasDereferenced,
        ____TerminateOperationalBindingResultData_notification__item__type_tab,
        _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        ___TerminateOperationalBindingResultData_notification__item__type,
        ____TerminateOperationalBindingResultData_notification__item__values__item_,
        ___TerminateOperationalBindingResultData_notification__item__values,
        _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___TerminateOperationalBindingResultData_notification__item__valuesWithContext,
        __TerminateOperationalBindingResultData_notification__item_,
        _TerminateOperationalBindingResultData_notification,
        TerminateOperationalBindingResultData,
        operationalBindingError,
        __operationalBindingError_val_ParameterType_unsigned,
        ___operationalBindingError_val_ParameterType_signed_toBeSigned,
        _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier,
        ___operationalBindingError_val_ParameterType_signed_signature,
        __operationalBindingError_val_ParameterType_signed,
        _operationalBindingError_val_ParameterType,
        _OpBindingErrorParam_problem,
        __OpBindingErrorParam_bindingType_tab,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_0,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_1,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_2,
        _OpBindingErrorParam_bindingType,
        _OpBindingErrorParam_agreementProposal,
        _OpBindingErrorParam_retryAt,
        _OpBindingErrorParam_securityParameters,
        _OpBindingErrorParam_performer,
        _OpBindingErrorParam_aliasDereferenced,
        ____OpBindingErrorParam_notification__item__type_tab,
        _____OpBindingErrorParam_notification__item__type_tab_val_Type_0,
        _____OpBindingErrorParam_notification__item__type_tab_val_Type_1,
        ___OpBindingErrorParam_notification__item__type,
        ____OpBindingErrorParam_notification__item__values__item_,
        ___OpBindingErrorParam_notification__item__values,
        _____OpBindingErrorParam_notification__item__valuesWithContext__item__value,
        ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_,
        _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList,
        ____OpBindingErrorParam_notification__item__valuesWithContext__item_,
        ___OpBindingErrorParam_notification__item__valuesWithContext,
        __OpBindingErrorParam_notification__item_,
        _OpBindingErrorParam_notification,
        OpBindingErrorParam,
    ]

class OSIProtocolSpecification:

    _name_  = 'OSIProtocolSpecification'
    _oid_   = [2, 5, 1, 36, 8]
    
    _obj_ = [
        'OSI-PDU',
        'OsiBind',
        'Presentation-selector',
        'Context-list',
        'Presentation-context-identifier',
        'Abstract-syntax-name',
        'Transfer-syntax-name',
        'AARQ-apdu',
        'Association-informationBind',
        'Application-context-name',
        'AP-invocation-identifier',
        'AE-invocation-identifier',
        'Implementation-data',
        'TheOsiBind',
        'OsiBindResult',
        'Result',
        'AARE-apdu',
        'Association-informationBindRes',
        'Associate-result',
        'Associate-source-diagnostic',
        'TheOsiBindRes',
        'OsiBindError',
        'Result-list',
        'Provider-reason',
        'AAREerr-apdu',
        'Association-informationBindErr',
        'TheOsiBindErr',
        'OsiUnbind',
        'TheOsiUnbind',
        'Release-request-reason',
        'OsiUnbindResult',
        'TheOsiUnbindRes',
        'Release-response-reason',
        'OsiOperation',
        'OsiDirectoryOperation',
        'OsiReq',
        'OsiRes',
        'OsiErr',
        'OsiRej',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'PresentationAbort',
        'ARU-PPDU',
        'Presentation-context-identifier-list',
        'ABRT-apdu',
        'ABRT-source',
        'ARP-PPDU',
        'Abort-reason',
        'Event-identifier',
        ]
    _type_ = [
        'OSI-PDU',
        'OsiBind',
        'Presentation-selector',
        'Context-list',
        'Presentation-context-identifier',
        'Abstract-syntax-name',
        'Transfer-syntax-name',
        'AARQ-apdu',
        'Association-informationBind',
        'Application-context-name',
        'AP-invocation-identifier',
        'AE-invocation-identifier',
        'Implementation-data',
        'TheOsiBind',
        'OsiBindResult',
        'Result',
        'AARE-apdu',
        'Association-informationBindRes',
        'Associate-result',
        'Associate-source-diagnostic',
        'TheOsiBindRes',
        'OsiBindError',
        'Result-list',
        'Provider-reason',
        'AAREerr-apdu',
        'Association-informationBindErr',
        'TheOsiBindErr',
        'OsiUnbind',
        'TheOsiUnbind',
        'Release-request-reason',
        'OsiUnbindResult',
        'TheOsiUnbindRes',
        'Release-response-reason',
        'OsiOperation',
        'OsiDirectoryOperation',
        'OsiReq',
        'OsiRes',
        'OsiErr',
        'OsiRej',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'PresentationAbort',
        'ARU-PPDU',
        'Presentation-context-identifier-list',
        'ABRT-apdu',
        'ABRT-source',
        'ARP-PPDU',
        'Abort-reason',
        'Event-identifier',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        'OSI-PDU',
        'OsiBind',
        'AARQ-apdu',
        'Association-informationBind',
        'TheOsiBind',
        'OsiBindResult',
        'AARE-apdu',
        'Association-informationBindRes',
        'TheOsiBindRes',
        'OsiBindError',
        'AAREerr-apdu',
        'Association-informationBindErr',
        'TheOsiBindErr',
        'OsiOperation',
        'OsiDirectoryOperation',
        'OsiReq',
        'OsiRes',
        'OsiErr',
        ]
    
    #-----< OSI-PDU >-----#
    OSI_PDU = OPEN(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']), param=True)
    
    #-----< OsiBind >-----#
    OsiBind = SET(name='OsiBind', mode=MODE_TYPE, param=True)
    
    #-----< Presentation-selector >-----#
    Presentation_selector = OCT_STR(name='Presentation-selector', mode=MODE_TYPE)
    Presentation_selector._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[ASN1RangeInt(lb=5, ub=None)])
    
    #-----< Context-list >-----#
    Context_list = SEQ_OF(name='Context-list', mode=MODE_TYPE)
    _Context_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Context_list__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    __Context_list__item__abstract_syntax_name = OID(name='abstract-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Abstract-syntax-name')))
    __Context_list__item__transfer_syntax_name_list = SEQ_OF(name='transfer-syntax-name-list', mode=MODE_TYPE)
    ___Context_list__item__transfer_syntax_name_list__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    __Context_list__item__transfer_syntax_name_list._cont = ___Context_list__item__transfer_syntax_name_list__item_
    _Context_list__item_._cont = ASN1Dict([
        ('presentation-context-identifier', __Context_list__item__presentation_context_identifier),
        ('abstract-syntax-name', __Context_list__item__abstract_syntax_name),
        ('transfer-syntax-name-list', __Context_list__item__transfer_syntax_name_list),
        ])
    _Context_list__item_._ext = None
    Context_list._cont = _Context_list__item_
    Context_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Presentation-context-identifier >-----#
    Presentation_context_identifier = INT(name='Presentation-context-identifier', mode=MODE_TYPE)
    Presentation_context_identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=[], er=[ASN1RangeInt(lb=128, ub=None)])
    
    #-----< Abstract-syntax-name >-----#
    Abstract_syntax_name = OID(name='Abstract-syntax-name', mode=MODE_TYPE)
    
    #-----< Transfer-syntax-name >-----#
    Transfer_syntax_name = OID(name='Transfer-syntax-name', mode=MODE_TYPE)
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name='AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBind >-----#
    Association_informationBind = SEQ_OF(name='Association-informationBind', mode=MODE_TYPE, param=True)
    
    #-----< Application-context-name >-----#
    Application_context_name = OID(name='Application-context-name', mode=MODE_TYPE)
    
    #-----< AP-invocation-identifier >-----#
    AP_invocation_identifier = INT(name='AP-invocation-identifier', mode=MODE_TYPE)
    
    #-----< AE-invocation-identifier >-----#
    AE_invocation_identifier = INT(name='AE-invocation-identifier', mode=MODE_TYPE)
    
    #-----< Implementation-data >-----#
    Implementation_data = STR_GRAPH(name='Implementation-data', mode=MODE_TYPE)
    
    #-----< TheOsiBind >-----#
    TheOsiBind = OPEN(name='TheOsiBind', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), ['bind-operation', 'ArgumentType']), param=True)
    
    #-----< OsiBindResult >-----#
    OsiBindResult = SET(name='OsiBindResult', mode=MODE_TYPE, param=True)
    
    #-----< Result >-----#
    Result = INT(name='Result', mode=MODE_TYPE)
    Result._cont = ASN1Dict([('acceptance', 0), ('user-rejection', 1), ('provider-rejection', 2)])
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name='AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBindRes >-----#
    Association_informationBindRes = SEQ_OF(name='Association-informationBindRes', mode=MODE_TYPE, param=True)
    
    #-----< Associate-result >-----#
    Associate_result = INT(name='Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([('accepted', 0), ('rejected-permanent', 1), ('rejected-transient', 2)])
    Associate_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name='Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_acse_service_user = INT(name='acse-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_user._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('application-context-name-not-supported', 2), ('calling-AP-title-not-recognized', 3), ('calling-AP-invocation-identifier-not-recognized', 4), ('calling-AE-qualifier-not-recognized', 5), ('calling-AE-invocation-identifier-not-recognized', 6), ('called-AP-title-not-recognized', 7), ('called-AP-invocation-identifier-not-recognized', 8), ('called-AE-qualifier-not-recognized', 9), ('called-AE-invocation-identifier-not-recognized', 10)])
    _Associate_source_diagnostic_acse_service_user._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=[], er=[])
    _Associate_source_diagnostic_acse_service_provider = INT(name='acse-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_provider._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('no-common-acse-version', 2)])
    _Associate_source_diagnostic_acse_service_provider._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    Associate_source_diagnostic._cont = ASN1Dict([
        ('acse-service-user', _Associate_source_diagnostic_acse_service_user),
        ('acse-service-provider', _Associate_source_diagnostic_acse_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< TheOsiBindRes >-----#
    TheOsiBindRes = OPEN(name='TheOsiBindRes', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), ['bind-operation', 'ResultType']), param=True)
    
    #-----< OsiBindError >-----#
    OsiBindError = CHOICE(name='OsiBindError', mode=MODE_TYPE, param=True)
    
    #-----< Result-list >-----#
    Result_list = SEQ_OF(name='Result-list', mode=MODE_TYPE)
    _Result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    __Result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    __Result_list__item__provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Result_list__item__provider_reason._cont = ASN1Dict([('reason-not-specified', 0), ('abstract-syntax-not-supported', 1), ('proposed-transfer-syntaxes-not-supported', 2)])
    _Result_list__item_._cont = ASN1Dict([
        ('result', __Result_list__item__result),
        ('transfer-syntax-name', __Result_list__item__transfer_syntax_name),
        ('provider-reason', __Result_list__item__provider_reason),
        ])
    _Result_list__item_._ext = None
    Result_list._cont = _Result_list__item_
    Result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Provider-reason >-----#
    Provider_reason = INT(name='Provider-reason', mode=MODE_TYPE)
    Provider_reason._cont = ASN1Dict([('reason-not-specified', 0), ('temporary-congestion', 1), ('local-limit-exceeded', 2), ('called-presentation-address-unknown', 3), ('protocol-version-not-supported', 4), ('default-context-not-supported', 5), ('user-data-not-readable', 6), ('no-PSAP-available', 7)])
    
    #-----< AAREerr-apdu >-----#
    AAREerr_apdu = SEQ(name='AAREerr-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBindErr >-----#
    Association_informationBindErr = SEQ_OF(name='Association-informationBindErr', mode=MODE_TYPE, param=True)
    
    #-----< TheOsiBindErr >-----#
    TheOsiBindErr = OPEN(name='TheOsiBindErr', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), ['bind-operation', 'Errors', 'ParameterType']), param=True)
    
    #-----< OsiUnbind >-----#
    OsiUnbind = CHOICE(name='OsiUnbind', mode=MODE_TYPE)
    _OsiUnbind_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    __OsiUnbind_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'TheOsiUnbind')))
    ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values._ext = None
    __OsiUnbind_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ___OsiUnbind_fully_encoded_data__item__presentation_data_values),
        ])
    __OsiUnbind_fully_encoded_data__item_._ext = None
    _OsiUnbind_fully_encoded_data._cont = __OsiUnbind_fully_encoded_data__item_
    _OsiUnbind_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    OsiUnbind._cont = ASN1Dict([
        ('fully-encoded-data', _OsiUnbind_fully_encoded_data),
        ])
    OsiUnbind._ext = None
    
    #-----< TheOsiUnbind >-----#
    TheOsiUnbind = SEQ(name='TheOsiUnbind', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _TheOsiUnbind_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Release-request-reason')), opt=True)
    TheOsiUnbind._cont = ASN1Dict([
        ('reason', _TheOsiUnbind_reason),
        ])
    TheOsiUnbind._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name='Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([('normal', 0)])
    
    #-----< OsiUnbindResult >-----#
    OsiUnbindResult = CHOICE(name='OsiUnbindResult', mode=MODE_TYPE)
    _OsiUnbindResult_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    __OsiUnbindResult_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'TheOsiUnbindRes')))
    ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values._ext = None
    __OsiUnbindResult_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values),
        ])
    __OsiUnbindResult_fully_encoded_data__item_._ext = None
    _OsiUnbindResult_fully_encoded_data._cont = __OsiUnbindResult_fully_encoded_data__item_
    _OsiUnbindResult_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    OsiUnbindResult._cont = ASN1Dict([
        ('fully-encoded-data', _OsiUnbindResult_fully_encoded_data),
        ])
    OsiUnbindResult._ext = None
    
    #-----< TheOsiUnbindRes >-----#
    TheOsiUnbindRes = SEQ(name='TheOsiUnbindRes', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _TheOsiUnbindRes_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Release-response-reason')), opt=True)
    TheOsiUnbindRes._cont = ASN1Dict([
        ('reason', _TheOsiUnbindRes_reason),
        ])
    TheOsiUnbindRes._ext = None
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name='Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([('normal', 0)])
    
    #-----< OsiOperation >-----#
    OsiOperation = CHOICE(name='OsiOperation', mode=MODE_TYPE, param=True)
    
    #-----< OsiDirectoryOperation >-----#
    OsiDirectoryOperation = CHOICE(name='OsiDirectoryOperation', mode=MODE_TYPE, param=True)
    
    #-----< OsiReq >-----#
    OsiReq = SEQ(name='OsiReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiRes >-----#
    OsiRes = SEQ(name='OsiRes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiErr >-----#
    OsiErr = SEQ(name='OsiErr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiRej >-----#
    OsiRej = SEQ(name='OsiRej', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OsiRej_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _OsiRej_problem = CHOICE(name='problem', mode=MODE_TYPE)
    __OsiRej_problem_general = INT(name='general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'GeneralProblem')))
    __OsiRej_problem_invoke = INT(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'InvokeProblem')))
    __OsiRej_problem_returnResult = INT(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ReturnResultProblem')))
    __OsiRej_problem_returnError = INT(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ReturnErrorProblem')))
    _OsiRej_problem._cont = ASN1Dict([
        ('general', __OsiRej_problem_general),
        ('invoke', __OsiRej_problem_invoke),
        ('returnResult', __OsiRej_problem_returnResult),
        ('returnError', __OsiRej_problem_returnError),
        ])
    _OsiRej_problem._ext = []
    OsiRej._cont = ASN1Dict([
        ('invokeId', _OsiRej_invokeId),
        ('problem', _OsiRej_problem),
        ])
    OsiRej._ext = []
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name='GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([('unrecognizedPDU', 0), ('mistypedPDU', 1), ('badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name='InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([('duplicateInvocation', 0), ('unrecognizedOperation', 1), ('mistypedArgument', 2), ('resourceLimitation', 3), ('releaseInProgress', 4)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name='ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('resultResponseUnexpected', 1), ('mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name='ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('errorResponseUnexpected', 1), ('unrecognizedError', 2), ('unexpectedError', 3), ('mistypedParameter', 4)])
    
    #-----< PresentationAbort >-----#
    PresentationAbort = CHOICE(name='PresentationAbort', mode=MODE_TYPE)
    _PresentationAbort_aru_ppdu = CHOICE(name='aru-ppdu', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ARU-PPDU')))
    _PresentationAbort_arp_ppdu = SEQ(name='arp-ppdu', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ARP-PPDU')))
    PresentationAbort._cont = ASN1Dict([
        ('aru-ppdu', _PresentationAbort_aru_ppdu),
        ('arp-ppdu', _PresentationAbort_arp_ppdu),
        ])
    PresentationAbort._ext = None
    
    #-----< ARU-PPDU >-----#
    ARU_PPDU = CHOICE(name='ARU-PPDU', mode=MODE_TYPE)
    _ARU_PPDU_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list = SEQ_OF(name='presentation-context-identifier-list', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier-list')))
    __ARU_PPDU_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ABRT-apdu')))
    ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data._cont = ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ARU_PPDU_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    __ARU_PPDU_normal_mode_parameters_user_data._ext = None
    _ARU_PPDU_normal_mode_parameters._cont = ASN1Dict([
        ('presentation-context-identifier-list', __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list),
        ('user-data', __ARU_PPDU_normal_mode_parameters_user_data),
        ])
    _ARU_PPDU_normal_mode_parameters._ext = None
    ARU_PPDU._cont = ASN1Dict([
        ('normal-mode-parameters', _ARU_PPDU_normal_mode_parameters),
        ])
    ARU_PPDU._ext = None
    
    #-----< Presentation-context-identifier-list >-----#
    Presentation_context_identifier_list = SEQ_OF(name='Presentation-context-identifier-list', mode=MODE_TYPE)
    _Presentation_context_identifier_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Presentation_context_identifier_list__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    __Presentation_context_identifier_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    _Presentation_context_identifier_list__item_._cont = ASN1Dict([
        ('presentation-context-identifier', __Presentation_context_identifier_list__item__presentation_context_identifier),
        ('transfer-syntax-name', __Presentation_context_identifier_list__item__transfer_syntax_name),
        ])
    _Presentation_context_identifier_list__item_._ext = None
    Presentation_context_identifier_list._cont = _Presentation_context_identifier_list__item_
    Presentation_context_identifier_list._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name='ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name='abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ABRT-source')))
    ABRT_apdu._cont = ASN1Dict([
        ('abort-source', _ABRT_apdu_abort_source),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name='ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([('acse-service-user', 0), ('acse-service-provider', 1)])
    
    #-----< ARP-PPDU >-----#
    ARP_PPDU = SEQ(name='ARP-PPDU', mode=MODE_TYPE)
    _ARP_PPDU_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Abort-reason')), opt=True)
    _ARP_PPDU_event_identifier = INT(name='event-identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Event-identifier')), opt=True)
    ARP_PPDU._cont = ASN1Dict([
        ('provider-reason', _ARP_PPDU_provider_reason),
        ('event-identifier', _ARP_PPDU_event_identifier),
        ])
    ARP_PPDU._ext = None
    
    #-----< Abort-reason >-----#
    Abort_reason = INT(name='Abort-reason', mode=MODE_TYPE)
    Abort_reason._cont = ASN1Dict([('reason-not-specified', 0), ('unrecognized-ppdu', 1), ('unexpected-ppdu', 2), ('unexpected-session-service-primitive', 3), ('unrecognized-ppdu-parameter', 4), ('unexpected-ppdu-parameter', 5), ('invalid-ppdu-parameter-value', 6)])
    
    #-----< Event-identifier >-----#
    Event_identifier = INT(name='Event-identifier', mode=MODE_TYPE)
    Event_identifier._cont = ASN1Dict([('cp-PPDU', 0), ('cpa-PPDU', 1), ('cpr-PPDU', 2), ('aru-PPDU', 3), ('arp-PPDU', 4), ('td-PPDU', 7), ('s-release-indication', 14), ('s-release-confirm', 15)])
    
    _all_ = [
        Presentation_selector,
        __Context_list__item__presentation_context_identifier,
        __Context_list__item__abstract_syntax_name,
        ___Context_list__item__transfer_syntax_name_list__item_,
        __Context_list__item__transfer_syntax_name_list,
        _Context_list__item_,
        Context_list,
        Presentation_context_identifier,
        Abstract_syntax_name,
        Transfer_syntax_name,
        Application_context_name,
        AP_invocation_identifier,
        AE_invocation_identifier,
        Implementation_data,
        Result,
        Associate_result,
        _Associate_source_diagnostic_acse_service_user,
        _Associate_source_diagnostic_acse_service_provider,
        Associate_source_diagnostic,
        __Result_list__item__result,
        __Result_list__item__transfer_syntax_name,
        __Result_list__item__provider_reason,
        _Result_list__item_,
        Result_list,
        Provider_reason,
        ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier,
        _____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ___OsiUnbind_fully_encoded_data__item__presentation_data_values,
        __OsiUnbind_fully_encoded_data__item_,
        _OsiUnbind_fully_encoded_data,
        OsiUnbind,
        _TheOsiUnbind_reason,
        TheOsiUnbind,
        Release_request_reason,
        ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier,
        _____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values,
        __OsiUnbindResult_fully_encoded_data__item_,
        _OsiUnbindResult_fully_encoded_data,
        OsiUnbindResult,
        _TheOsiUnbindRes_reason,
        TheOsiUnbindRes,
        Release_response_reason,
        _OsiRej_invokeId,
        __OsiRej_problem_general,
        __OsiRej_problem_invoke,
        __OsiRej_problem_returnResult,
        __OsiRej_problem_returnError,
        _OsiRej_problem,
        OsiRej,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        _PresentationAbort_aru_ppdu,
        _PresentationAbort_arp_ppdu,
        PresentationAbort,
        __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list,
        _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data,
        __ARU_PPDU_normal_mode_parameters_user_data,
        _ARU_PPDU_normal_mode_parameters,
        ARU_PPDU,
        __Presentation_context_identifier_list__item__presentation_context_identifier,
        __Presentation_context_identifier_list__item__transfer_syntax_name,
        _Presentation_context_identifier_list__item_,
        Presentation_context_identifier_list,
        _ABRT_apdu_abort_source,
        ABRT_apdu,
        ABRT_source,
        _ARP_PPDU_provider_reason,
        _ARP_PPDU_event_identifier,
        ARP_PPDU,
        Abort_reason,
        Event_identifier,
    ]

class PasswordPolicy:

    _name_  = 'PasswordPolicy'
    _oid_   = [2, 5, 1, 39, 8]
    
    _obj_ = [
        'userPwd',
        'UserPwd',
        'pwdStartTime',
        'pwdExpiryTime',
        'pwdEndTime',
        'pwdFails',
        'pwdFailureTime',
        'pwdGracesUsed',
        'userPwdHistory',
        'userPwdRecentlyExpired',
        'pwdModifyEntryAllowed',
        'pwdChangeAllowed',
        'pwdMaxAge',
        'pwdExpiryAge',
        'pwdMinLength',
        'pwdVocabulary',
        'PwdVocabulary',
        'pwdAlphabet',
        'PwdAlphabet',
        'pwdDictionaries',
        'pwdExpiryWarning',
        'pwdGraces',
        'pwdFailureDuration',
        'pwdLockoutDuration',
        'pwdMaxFailures',
        'pwdMaxTimeInHistory',
        'pwdMinTimeInHistory',
        'pwdHistorySlots',
        'pwdRecentlyExpiredDuration',
        'pwdEncAlg',
        'PwdEncAlg',
        'userPwdMatch',
        'pwdEncAlgMatch',
        'userPwdHistoryMatch',
        'userPwdDescription',
        'pwdVocabularyDescription',
        'pwdAlphabetDescription',
        'pwdEncAlgDescription',
        'id-at-userPwd',
        'id-oa-pwdStartTime',
        'id-oa-pwdExpiryTime',
        'id-oa-pwdEndTime',
        'id-oa-pwdFails',
        'id-oa-pwdFailureTime',
        'id-oa-pwdGracesUsed',
        'id-oa-userPwdHistory',
        'id-oa-userPwdRecentlyExpired',
        'id-oa-pwdModifyEntryAllowed',
        'id-oa-pwdChangeAllowed',
        'id-oa-pwdMaxAge',
        'id-oa-pwdExpiryAge',
        'id-oa-pwdMinLength',
        'id-oa-pwdVocabulary',
        'id-oa-pwdAlphabet',
        'id-oa-pwdDictionaries',
        'id-oa-pwdExpiryWarning',
        'id-oa-pwdGraces',
        'id-oa-pwdFailureDuration',
        'id-oa-pwdLockoutDuration',
        'id-oa-pwdMaxFailures',
        'id-oa-pwdMaxTimeInHistory',
        'id-oa-pwdMinTimeInHistory',
        'id-oa-pwdHistorySlots',
        'id-oa-pwdRecentlyExpiredDuration',
        'id-oa-pwdEncAlg',
        'id-mr-userPwdMatch',
        'id-mr-userPwdHistoryMatch',
        'id-mr-pwdEncAlgMatch',
        'id-asx-userPwdDescription',
        'id-asx-pwdVocabularyDescription',
        'id-asx-pwdAlphabetDescription',
        'id-asx-pwdEncAlgDescription',
        ]
    _type_ = [
        'UserPwd',
        'PwdVocabulary',
        'PwdAlphabet',
        'PwdEncAlg',
        ]
    _set_ = [
        ]
    _val_ = [
        'userPwd',
        'pwdStartTime',
        'pwdExpiryTime',
        'pwdEndTime',
        'pwdFails',
        'pwdFailureTime',
        'pwdGracesUsed',
        'userPwdHistory',
        'userPwdRecentlyExpired',
        'pwdModifyEntryAllowed',
        'pwdChangeAllowed',
        'pwdMaxAge',
        'pwdExpiryAge',
        'pwdMinLength',
        'pwdVocabulary',
        'pwdAlphabet',
        'pwdDictionaries',
        'pwdExpiryWarning',
        'pwdGraces',
        'pwdFailureDuration',
        'pwdLockoutDuration',
        'pwdMaxFailures',
        'pwdMaxTimeInHistory',
        'pwdMinTimeInHistory',
        'pwdHistorySlots',
        'pwdRecentlyExpiredDuration',
        'pwdEncAlg',
        'userPwdMatch',
        'pwdEncAlgMatch',
        'userPwdHistoryMatch',
        'userPwdDescription',
        'pwdVocabularyDescription',
        'pwdAlphabetDescription',
        'pwdEncAlgDescription',
        'id-at-userPwd',
        'id-oa-pwdStartTime',
        'id-oa-pwdExpiryTime',
        'id-oa-pwdEndTime',
        'id-oa-pwdFails',
        'id-oa-pwdFailureTime',
        'id-oa-pwdGracesUsed',
        'id-oa-userPwdHistory',
        'id-oa-userPwdRecentlyExpired',
        'id-oa-pwdModifyEntryAllowed',
        'id-oa-pwdChangeAllowed',
        'id-oa-pwdMaxAge',
        'id-oa-pwdExpiryAge',
        'id-oa-pwdMinLength',
        'id-oa-pwdVocabulary',
        'id-oa-pwdAlphabet',
        'id-oa-pwdDictionaries',
        'id-oa-pwdExpiryWarning',
        'id-oa-pwdGraces',
        'id-oa-pwdFailureDuration',
        'id-oa-pwdLockoutDuration',
        'id-oa-pwdMaxFailures',
        'id-oa-pwdMaxTimeInHistory',
        'id-oa-pwdMinTimeInHistory',
        'id-oa-pwdHistorySlots',
        'id-oa-pwdRecentlyExpiredDuration',
        'id-oa-pwdEncAlg',
        'id-mr-userPwdMatch',
        'id-mr-userPwdHistoryMatch',
        'id-mr-pwdEncAlgMatch',
        'id-asx-userPwdDescription',
        'id-asx-pwdVocabularyDescription',
        'id-asx-pwdAlphabetDescription',
        'id-asx-pwdEncAlgDescription',
        ]
    _class_ = [
        'userPwd',
        'pwdStartTime',
        'pwdExpiryTime',
        'pwdEndTime',
        'pwdFails',
        'pwdFailureTime',
        'pwdGracesUsed',
        'userPwdHistory',
        'userPwdRecentlyExpired',
        'pwdModifyEntryAllowed',
        'pwdChangeAllowed',
        'pwdMaxAge',
        'pwdExpiryAge',
        'pwdMinLength',
        'pwdVocabulary',
        'pwdAlphabet',
        'pwdDictionaries',
        'pwdExpiryWarning',
        'pwdGraces',
        'pwdFailureDuration',
        'pwdLockoutDuration',
        'pwdMaxFailures',
        'pwdMaxTimeInHistory',
        'pwdMinTimeInHistory',
        'pwdHistorySlots',
        'pwdRecentlyExpiredDuration',
        'pwdEncAlg',
        'userPwdMatch',
        'pwdEncAlgMatch',
        'userPwdHistoryMatch',
        'userPwdDescription',
        'pwdVocabularyDescription',
        'pwdAlphabetDescription',
        'pwdEncAlgDescription',
        ]
    _param_ = [
        ]
    
    #-----< userPwd >-----#
    userPwd = CLASS(name='userPwd', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwd_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    __ATTRIBUTE_equality_match_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwd._val = dict([('Type', _userPwd_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwdMatch']), ('id', (2, 5, 13, 71))])), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwd']), ('id', (2, 5, 4, 85))])
    
    #-----< UserPwd >-----#
    UserPwd = CHOICE(name='UserPwd', mode=MODE_TYPE)
    _UserPwd_clear = STR_UTF8(name='clear', mode=MODE_TYPE)
    _UserPwd_encrypted = SEQ(name='encrypted', mode=MODE_TYPE)
    __UserPwd_encrypted_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___UserPwd_encrypted_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab = ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab_at = None
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___UserPwd_encrypted_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____UserPwd_encrypted_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UserPwd_encrypted_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab = ____UserPwd_encrypted_algorithmIdentifier_parameters_tab
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __UserPwd_encrypted_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___UserPwd_encrypted_algorithmIdentifier_algorithm),
        ('parameters', ___UserPwd_encrypted_algorithmIdentifier_parameters),
        ])
    __UserPwd_encrypted_algorithmIdentifier._ext = []
    __UserPwd_encrypted_encryptedString = OCT_STR(name='encryptedString', mode=MODE_TYPE)
    _UserPwd_encrypted._cont = ASN1Dict([
        ('algorithmIdentifier', __UserPwd_encrypted_algorithmIdentifier),
        ('encryptedString', __UserPwd_encrypted_encryptedString),
        ])
    _UserPwd_encrypted._ext = []
    UserPwd._cont = ASN1Dict([
        ('clear', _UserPwd_clear),
        ('encrypted', _UserPwd_encrypted),
        ])
    UserPwd._ext = []
    
    #-----< pwdStartTime >-----#
    pwdStartTime = CLASS(name='pwdStartTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdStartTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_0 = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    pwdStartTime._val = dict([('Type', _pwdStartTime_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdStartTime']), ('id', (2, 5, 18, 22))])
    
    #-----< pwdExpiryTime >-----#
    pwdExpiryTime = CLASS(name='pwdExpiryTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    pwdExpiryTime._val = dict([('Type', _pwdExpiryTime_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdExpiryTime']), ('id', (2, 5, 18, 23))])
    
    #-----< pwdEndTime >-----#
    pwdEndTime = CLASS(name='pwdEndTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdEndTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    pwdEndTime._val = dict([('Type', _pwdEndTime_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdEndTime']), ('id', (2, 5, 18, 24))])
    
    #-----< pwdFails >-----#
    pwdFails = CLASS(name='pwdFails', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFails_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdFails_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __ATTRIBUTE_equality_match_val_AssertionType_1 = INT(name='AssertionType', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType_0 = INT(name='AssertionType', mode=MODE_TYPE)
    pwdFails._val = dict([('Type', _pwdFails_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdFails']), ('id', (2, 5, 18, 25))])
    
    #-----< pwdFailureTime >-----#
    pwdFailureTime = CLASS(name='pwdFailureTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFailureTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    pwdFailureTime._val = dict([('Type', _pwdFailureTime_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdFailureTime']), ('id', (2, 5, 18, 26))])
    
    #-----< pwdGracesUsed >-----#
    pwdGracesUsed = CLASS(name='pwdGracesUsed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdGracesUsed_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdGracesUsed_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdGracesUsed._val = dict([('Type', _pwdGracesUsed_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdGracesUsed']), ('id', (2, 5, 18, 27))])
    
    #-----< userPwdHistory >-----#
    userPwdHistory = CLASS(name='userPwdHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwdHistory_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'PwdHistory')))
    __userPwdHistory_val_Type_time = TIME_GEN(name='time', mode=MODE_TYPE)
    __userPwdHistory_val_Type_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    _userPwdHistory_val_Type._cont = ASN1Dict([
        ('time', __userPwdHistory_val_Type_time),
        ('password', __userPwdHistory_val_Type_Type),
        ])
    _userPwdHistory_val_Type._ext = []
    __ATTRIBUTE_equality_match_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdHistory._val = dict([('Type', _userPwdHistory_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_Type), ('id', (2, 5, 13, 72))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 28))])
    
    #-----< userPwdRecentlyExpired >-----#
    userPwdRecentlyExpired = CLASS(name='userPwdRecentlyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwdRecentlyExpired_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdRecentlyExpired._val = dict([('Type', _userPwdRecentlyExpired_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwdMatch']), ('id', (2, 5, 13, 71))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 29))])
    
    #-----< pwdModifyEntryAllowed >-----#
    pwdModifyEntryAllowed = CLASS(name='pwdModifyEntryAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdModifyEntryAllowed_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_2 = BOOL(name='AssertionType', mode=MODE_TYPE)
    pwdModifyEntryAllowed._val = dict([('Type', _pwdModifyEntryAllowed_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)), ('ldapName', ['pwdModifyEntryAllowed']), ('id', (2, 5, 18, 30))])
    
    #-----< pwdChangeAllowed >-----#
    pwdChangeAllowed = CLASS(name='pwdChangeAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdChangeAllowed_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    pwdChangeAllowed._val = dict([('Type', _pwdChangeAllowed_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)), ('ldapName', ['pwdChangeAllowed']), ('id', (2, 5, 18, 31))])
    
    #-----< pwdMaxAge >-----#
    pwdMaxAge = CLASS(name='pwdMaxAge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxAge_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMaxAge_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxAge._val = dict([('Type', _pwdMaxAge_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMaxAge']), ('id', (2, 5, 18, 32))])
    
    #-----< pwdExpiryAge >-----#
    pwdExpiryAge = CLASS(name='pwdExpiryAge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryAge_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdExpiryAge_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdExpiryAge._val = dict([('Type', _pwdExpiryAge_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdExpiryAge']), ('id', (2, 5, 18, 33))])
    
    #-----< pwdMinLength >-----#
    pwdMinLength = CLASS(name='pwdMinLength', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMinLength_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMinLength_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdMinLength._val = dict([('Type', _pwdMinLength_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMinLength']), ('id', (2, 5, 18, 34))])
    
    #-----< pwdVocabulary >-----#
    pwdVocabulary = CLASS(name='pwdVocabulary', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdVocabulary_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdVocabulary')))
    __ATTRIBUTE_equality_match_val_AssertionType_3 = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    pwdVocabulary._val = dict([('Type', _pwdVocabulary_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (2, 5, 40, 1)), ('ldapName', ['pwdVocabulary']), ('id', (2, 5, 18, 35))])
    
    #-----< PwdVocabulary >-----#
    PwdVocabulary = BIT_STR(name='PwdVocabulary', mode=MODE_TYPE)
    PwdVocabulary._cont = ASN1Dict([('noDictionaryWords', 0), ('noPersonNames', 1), ('noGeographicalNames', 2)])
    
    #-----< pwdAlphabet >-----#
    pwdAlphabet = CLASS(name='pwdAlphabet', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAlphabet_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdAlphabet')))
    pwdAlphabet._val = dict([('Type', _pwdAlphabet_val_Type), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (2, 5, 40, 2)), ('ldapName', ['pwdAlphabet']), ('id', (2, 5, 18, 36))])
    
    #-----< PwdAlphabet >-----#
    PwdAlphabet = SEQ_OF(name='PwdAlphabet', mode=MODE_TYPE)
    _PwdAlphabet__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    PwdAlphabet._cont = _PwdAlphabet__item_
    
    #-----< pwdDictionaries >-----#
    pwdDictionaries = CLASS(name='pwdDictionaries', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = STR_UTF8(name='AssertionType', mode=MODE_TYPE)
    pwdDictionaries._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['pwdDictionaries']), ('id', (2, 5, 18, 37))])
    
    #-----< pwdExpiryWarning >-----#
    pwdExpiryWarning = CLASS(name='pwdExpiryWarning', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryWarning_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdExpiryWarning_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdExpiryWarning._val = dict([('Type', _pwdExpiryWarning_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdExpiryWarning']), ('id', (2, 5, 18, 38))])
    
    #-----< pwdGraces >-----#
    pwdGraces = CLASS(name='pwdGraces', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdGraces_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdGraces_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdGraces._val = dict([('Type', _pwdGraces_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdGraces']), ('id', (2, 5, 18, 39))])
    
    #-----< pwdFailureDuration >-----#
    pwdFailureDuration = CLASS(name='pwdFailureDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFailureDuration_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdFailureDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdFailureDuration._val = dict([('Type', _pwdFailureDuration_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdFailureDuration']), ('id', (2, 5, 18, 40))])
    
    #-----< pwdLockoutDuration >-----#
    pwdLockoutDuration = CLASS(name='pwdLockoutDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdLockoutDuration_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdLockoutDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdLockoutDuration._val = dict([('Type', _pwdLockoutDuration_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdLockoutDuration']), ('id', (2, 5, 18, 41))])
    
    #-----< pwdMaxFailures >-----#
    pwdMaxFailures = CLASS(name='pwdMaxFailures', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxFailures_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMaxFailures_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxFailures._val = dict([('Type', _pwdMaxFailures_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMaxFailures']), ('id', (2, 5, 18, 42))])
    
    #-----< pwdMaxTimeInHistory >-----#
    pwdMaxTimeInHistory = CLASS(name='pwdMaxTimeInHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxTimeInHistory_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMaxTimeInHistory_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxTimeInHistory._val = dict([('Type', _pwdMaxTimeInHistory_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMaxTimeInHistory']), ('id', (2, 5, 18, 43))])
    
    #-----< pwdMinTimeInHistory >-----#
    pwdMinTimeInHistory = CLASS(name='pwdMinTimeInHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMinTimeInHistory_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMinTimeInHistory_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdMinTimeInHistory._val = dict([('Type', _pwdMinTimeInHistory_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMinTimeInHistory']), ('id', (2, 5, 18, 44))])
    
    #-----< pwdHistorySlots >-----#
    pwdHistorySlots = CLASS(name='pwdHistorySlots', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdHistorySlots_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdHistorySlots_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=None)], ev=None, er=[])
    pwdHistorySlots._val = dict([('Type', _pwdHistorySlots_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdHistorySlots']), ('id', (2, 5, 18, 45))])
    
    #-----< pwdRecentlyExpiredDuration >-----#
    pwdRecentlyExpiredDuration = CLASS(name='pwdRecentlyExpiredDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdRecentlyExpiredDuration_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdRecentlyExpiredDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdRecentlyExpiredDuration._val = dict([('Type', _pwdRecentlyExpiredDuration_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdRecentlyExpiredDuration']), ('id', (2, 5, 18, 46))])
    
    #-----< pwdEncAlg >-----#
    pwdEncAlg = CLASS(name='pwdEncAlg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdEncAlg_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    __ATTRIBUTE_equality_match_val_AssertionType_5 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    pwdEncAlg._val = dict([('Type', _pwdEncAlg_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('ldapSyntax', (2, 5, 40, 3)), ('ldapName', ['pwdEncAlgMatch']), ('id', (2, 5, 13, 73))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (2, 5, 40, 3)), ('ldapName', ['pwdEncAlg']), ('id', (2, 5, 18, 47))])
    
    #-----< PwdEncAlg >-----#
    PwdEncAlg = SEQ(name='PwdEncAlg', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _PwdEncAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    __PwdEncAlg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    __PwdEncAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PwdEncAlg_algorithm._const_tab = __PwdEncAlg_algorithm_tab
    _PwdEncAlg_algorithm._const_tab_at = None
    _PwdEncAlg_algorithm._const_tab_id = 'id'
    _PwdEncAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    __PwdEncAlg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    __PwdEncAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PwdEncAlg_parameters._const_tab = __PwdEncAlg_parameters_tab
    _PwdEncAlg_parameters._const_tab_at = ('..', 'algorithm')
    _PwdEncAlg_parameters._const_tab_id = 'Type'
    PwdEncAlg._cont = ASN1Dict([
        ('algorithm', _PwdEncAlg_algorithm),
        ('parameters', _PwdEncAlg_parameters),
        ])
    PwdEncAlg._ext = []
    
    #-----< userPwdMatch >-----#
    userPwdMatch = CLASS(name='userPwdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _userPwdMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdMatch._val = dict([('AssertionType', _userPwdMatch_val_AssertionType), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwdMatch']), ('id', (2, 5, 13, 71))])
    
    #-----< pwdEncAlgMatch >-----#
    pwdEncAlgMatch = CLASS(name='pwdEncAlgMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _pwdEncAlgMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    pwdEncAlgMatch._val = dict([('AssertionType', _pwdEncAlgMatch_val_AssertionType), ('ldapSyntax', (2, 5, 40, 3)), ('ldapName', ['pwdEncAlgMatch']), ('id', (2, 5, 13, 73))])
    
    #-----< userPwdHistoryMatch >-----#
    userPwdHistoryMatch = CLASS(name='userPwdHistoryMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _userPwdHistoryMatch_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdHistoryMatch._val = dict([('AssertionType', _userPwdHistoryMatch_val_Type), ('id', (2, 5, 13, 72))])
    
    #-----< userPwdDescription >-----#
    userPwdDescription = CLASS(name='userPwdDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _userPwdDescription_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdDescription._val = dict([('ldapDesc', 'User Password Description'), ('Type', _userPwdDescription_val_Type), ('id', (2, 5, 40, 0))])
    
    #-----< pwdVocabularyDescription >-----#
    pwdVocabularyDescription = CLASS(name='pwdVocabularyDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdVocabularyDescription_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdVocabulary')))
    pwdVocabularyDescription._val = dict([('ldapDesc', 'Password Vocabulary Description'), ('Type', _pwdVocabularyDescription_val_Type), ('id', (2, 5, 40, 1))])
    
    #-----< pwdAlphabetDescription >-----#
    pwdAlphabetDescription = CLASS(name='pwdAlphabetDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdAlphabetDescription_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdAlphabet')))
    pwdAlphabetDescription._val = dict([('ldapDesc', 'Password Alphabet Description'), ('Type', _pwdAlphabetDescription_val_Type), ('id', (2, 5, 40, 2))])
    
    #-----< pwdEncAlgDescription >-----#
    pwdEncAlgDescription = CLASS(name='pwdEncAlgDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdEncAlgDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    pwdEncAlgDescription._val = dict([('ldapDesc', 'Password Alphabet Description'), ('Type', _pwdEncAlgDescription_val_Type), ('id', (2, 5, 40, 3))])
    
    #-----< id-at-userPwd >-----#
    id_at_userPwd = OID(name='id-at-userPwd', mode=MODE_VALUE)
    id_at_userPwd._val = (2, 5, 4, 85)
    
    #-----< id-oa-pwdStartTime >-----#
    id_oa_pwdStartTime = OID(name='id-oa-pwdStartTime', mode=MODE_VALUE)
    id_oa_pwdStartTime._val = (2, 5, 18, 22)
    
    #-----< id-oa-pwdExpiryTime >-----#
    id_oa_pwdExpiryTime = OID(name='id-oa-pwdExpiryTime', mode=MODE_VALUE)
    id_oa_pwdExpiryTime._val = (2, 5, 18, 23)
    
    #-----< id-oa-pwdEndTime >-----#
    id_oa_pwdEndTime = OID(name='id-oa-pwdEndTime', mode=MODE_VALUE)
    id_oa_pwdEndTime._val = (2, 5, 18, 24)
    
    #-----< id-oa-pwdFails >-----#
    id_oa_pwdFails = OID(name='id-oa-pwdFails', mode=MODE_VALUE)
    id_oa_pwdFails._val = (2, 5, 18, 25)
    
    #-----< id-oa-pwdFailureTime >-----#
    id_oa_pwdFailureTime = OID(name='id-oa-pwdFailureTime', mode=MODE_VALUE)
    id_oa_pwdFailureTime._val = (2, 5, 18, 26)
    
    #-----< id-oa-pwdGracesUsed >-----#
    id_oa_pwdGracesUsed = OID(name='id-oa-pwdGracesUsed', mode=MODE_VALUE)
    id_oa_pwdGracesUsed._val = (2, 5, 18, 27)
    
    #-----< id-oa-userPwdHistory >-----#
    id_oa_userPwdHistory = OID(name='id-oa-userPwdHistory', mode=MODE_VALUE)
    id_oa_userPwdHistory._val = (2, 5, 18, 28)
    
    #-----< id-oa-userPwdRecentlyExpired >-----#
    id_oa_userPwdRecentlyExpired = OID(name='id-oa-userPwdRecentlyExpired', mode=MODE_VALUE)
    id_oa_userPwdRecentlyExpired._val = (2, 5, 18, 29)
    
    #-----< id-oa-pwdModifyEntryAllowed >-----#
    id_oa_pwdModifyEntryAllowed = OID(name='id-oa-pwdModifyEntryAllowed', mode=MODE_VALUE)
    id_oa_pwdModifyEntryAllowed._val = (2, 5, 18, 30)
    
    #-----< id-oa-pwdChangeAllowed >-----#
    id_oa_pwdChangeAllowed = OID(name='id-oa-pwdChangeAllowed', mode=MODE_VALUE)
    id_oa_pwdChangeAllowed._val = (2, 5, 18, 31)
    
    #-----< id-oa-pwdMaxAge >-----#
    id_oa_pwdMaxAge = OID(name='id-oa-pwdMaxAge', mode=MODE_VALUE)
    id_oa_pwdMaxAge._val = (2, 5, 18, 32)
    
    #-----< id-oa-pwdExpiryAge >-----#
    id_oa_pwdExpiryAge = OID(name='id-oa-pwdExpiryAge', mode=MODE_VALUE)
    id_oa_pwdExpiryAge._val = (2, 5, 18, 33)
    
    #-----< id-oa-pwdMinLength >-----#
    id_oa_pwdMinLength = OID(name='id-oa-pwdMinLength', mode=MODE_VALUE)
    id_oa_pwdMinLength._val = (2, 5, 18, 34)
    
    #-----< id-oa-pwdVocabulary >-----#
    id_oa_pwdVocabulary = OID(name='id-oa-pwdVocabulary', mode=MODE_VALUE)
    id_oa_pwdVocabulary._val = (2, 5, 18, 35)
    
    #-----< id-oa-pwdAlphabet >-----#
    id_oa_pwdAlphabet = OID(name='id-oa-pwdAlphabet', mode=MODE_VALUE)
    id_oa_pwdAlphabet._val = (2, 5, 18, 36)
    
    #-----< id-oa-pwdDictionaries >-----#
    id_oa_pwdDictionaries = OID(name='id-oa-pwdDictionaries', mode=MODE_VALUE)
    id_oa_pwdDictionaries._val = (2, 5, 18, 37)
    
    #-----< id-oa-pwdExpiryWarning >-----#
    id_oa_pwdExpiryWarning = OID(name='id-oa-pwdExpiryWarning', mode=MODE_VALUE)
    id_oa_pwdExpiryWarning._val = (2, 5, 18, 38)
    
    #-----< id-oa-pwdGraces >-----#
    id_oa_pwdGraces = OID(name='id-oa-pwdGraces', mode=MODE_VALUE)
    id_oa_pwdGraces._val = (2, 5, 18, 39)
    
    #-----< id-oa-pwdFailureDuration >-----#
    id_oa_pwdFailureDuration = OID(name='id-oa-pwdFailureDuration', mode=MODE_VALUE)
    id_oa_pwdFailureDuration._val = (2, 5, 18, 40)
    
    #-----< id-oa-pwdLockoutDuration >-----#
    id_oa_pwdLockoutDuration = OID(name='id-oa-pwdLockoutDuration', mode=MODE_VALUE)
    id_oa_pwdLockoutDuration._val = (2, 5, 18, 41)
    
    #-----< id-oa-pwdMaxFailures >-----#
    id_oa_pwdMaxFailures = OID(name='id-oa-pwdMaxFailures', mode=MODE_VALUE)
    id_oa_pwdMaxFailures._val = (2, 5, 18, 42)
    
    #-----< id-oa-pwdMaxTimeInHistory >-----#
    id_oa_pwdMaxTimeInHistory = OID(name='id-oa-pwdMaxTimeInHistory', mode=MODE_VALUE)
    id_oa_pwdMaxTimeInHistory._val = (2, 5, 18, 43)
    
    #-----< id-oa-pwdMinTimeInHistory >-----#
    id_oa_pwdMinTimeInHistory = OID(name='id-oa-pwdMinTimeInHistory', mode=MODE_VALUE)
    id_oa_pwdMinTimeInHistory._val = (2, 5, 18, 44)
    
    #-----< id-oa-pwdHistorySlots >-----#
    id_oa_pwdHistorySlots = OID(name='id-oa-pwdHistorySlots', mode=MODE_VALUE)
    id_oa_pwdHistorySlots._val = (2, 5, 18, 45)
    
    #-----< id-oa-pwdRecentlyExpiredDuration >-----#
    id_oa_pwdRecentlyExpiredDuration = OID(name='id-oa-pwdRecentlyExpiredDuration', mode=MODE_VALUE)
    id_oa_pwdRecentlyExpiredDuration._val = (2, 5, 18, 46)
    
    #-----< id-oa-pwdEncAlg >-----#
    id_oa_pwdEncAlg = OID(name='id-oa-pwdEncAlg', mode=MODE_VALUE)
    id_oa_pwdEncAlg._val = (2, 5, 18, 47)
    
    #-----< id-mr-userPwdMatch >-----#
    id_mr_userPwdMatch = OID(name='id-mr-userPwdMatch', mode=MODE_VALUE)
    id_mr_userPwdMatch._val = (2, 5, 13, 71)
    
    #-----< id-mr-userPwdHistoryMatch >-----#
    id_mr_userPwdHistoryMatch = OID(name='id-mr-userPwdHistoryMatch', mode=MODE_VALUE)
    id_mr_userPwdHistoryMatch._val = (2, 5, 13, 72)
    
    #-----< id-mr-pwdEncAlgMatch >-----#
    id_mr_pwdEncAlgMatch = OID(name='id-mr-pwdEncAlgMatch', mode=MODE_VALUE)
    id_mr_pwdEncAlgMatch._val = (2, 5, 13, 73)
    
    #-----< id-asx-userPwdDescription >-----#
    id_asx_userPwdDescription = OID(name='id-asx-userPwdDescription', mode=MODE_VALUE)
    id_asx_userPwdDescription._val = (2, 5, 40, 0)
    
    #-----< id-asx-pwdVocabularyDescription >-----#
    id_asx_pwdVocabularyDescription = OID(name='id-asx-pwdVocabularyDescription', mode=MODE_VALUE)
    id_asx_pwdVocabularyDescription._val = (2, 5, 40, 1)
    
    #-----< id-asx-pwdAlphabetDescription >-----#
    id_asx_pwdAlphabetDescription = OID(name='id-asx-pwdAlphabetDescription', mode=MODE_VALUE)
    id_asx_pwdAlphabetDescription._val = (2, 5, 40, 2)
    
    #-----< id-asx-pwdEncAlgDescription >-----#
    id_asx_pwdEncAlgDescription = OID(name='id-asx-pwdEncAlgDescription', mode=MODE_VALUE)
    id_asx_pwdEncAlgDescription._val = (2, 5, 40, 3)
    
    _all_ = [
        userPwd,
        _userPwd_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _UserPwd_clear,
        ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab,
        ___UserPwd_encrypted_algorithmIdentifier_algorithm,
        ____UserPwd_encrypted_algorithmIdentifier_parameters_tab,
        ___UserPwd_encrypted_algorithmIdentifier_parameters,
        __UserPwd_encrypted_algorithmIdentifier,
        __UserPwd_encrypted_encryptedString,
        _UserPwd_encrypted,
        UserPwd,
        pwdStartTime,
        _pwdStartTime_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        pwdExpiryTime,
        _pwdExpiryTime_val_Type,
        pwdEndTime,
        _pwdEndTime_val_Type,
        pwdFails,
        _pwdFails_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        __ATTRIBUTE_ordering_match_val_AssertionType_0,
        pwdFailureTime,
        _pwdFailureTime_val_Type,
        pwdGracesUsed,
        _pwdGracesUsed_val_Type,
        userPwdHistory,
        __userPwdHistory_val_Type_time,
        __userPwdHistory_val_Type_Type,
        _userPwdHistory_val_Type,
        __ATTRIBUTE_equality_match_val_Type,
        userPwdRecentlyExpired,
        _userPwdRecentlyExpired_val_Type,
        pwdModifyEntryAllowed,
        _pwdModifyEntryAllowed_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        pwdChangeAllowed,
        _pwdChangeAllowed_val_Type,
        pwdMaxAge,
        _pwdMaxAge_val_Type,
        pwdExpiryAge,
        _pwdExpiryAge_val_Type,
        pwdMinLength,
        _pwdMinLength_val_Type,
        pwdVocabulary,
        _pwdVocabulary_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        PwdVocabulary,
        pwdAlphabet,
        _pwdAlphabet_val_Type,
        _PwdAlphabet__item_,
        PwdAlphabet,
        pwdDictionaries,
        __ATTRIBUTE_derivation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        pwdExpiryWarning,
        _pwdExpiryWarning_val_Type,
        pwdGraces,
        _pwdGraces_val_Type,
        pwdFailureDuration,
        _pwdFailureDuration_val_Type,
        pwdLockoutDuration,
        _pwdLockoutDuration_val_Type,
        pwdMaxFailures,
        _pwdMaxFailures_val_Type,
        pwdMaxTimeInHistory,
        _pwdMaxTimeInHistory_val_Type,
        pwdMinTimeInHistory,
        _pwdMinTimeInHistory_val_Type,
        pwdHistorySlots,
        _pwdHistorySlots_val_Type,
        pwdRecentlyExpiredDuration,
        _pwdRecentlyExpiredDuration_val_Type,
        pwdEncAlg,
        _pwdEncAlg_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_5,
        __PwdEncAlg_algorithm_tab,
        _PwdEncAlg_algorithm,
        __PwdEncAlg_parameters_tab,
        _PwdEncAlg_parameters,
        PwdEncAlg,
        userPwdMatch,
        _userPwdMatch_val_AssertionType,
        pwdEncAlgMatch,
        _pwdEncAlgMatch_val_AssertionType,
        userPwdHistoryMatch,
        _userPwdHistoryMatch_val_Type,
        userPwdDescription,
        _userPwdDescription_val_Type,
        pwdVocabularyDescription,
        _pwdVocabularyDescription_val_Type,
        pwdAlphabetDescription,
        _pwdAlphabetDescription_val_Type,
        pwdEncAlgDescription,
        _pwdEncAlgDescription_val_Type,
        id_at_userPwd,
        id_oa_pwdStartTime,
        id_oa_pwdExpiryTime,
        id_oa_pwdEndTime,
        id_oa_pwdFails,
        id_oa_pwdFailureTime,
        id_oa_pwdGracesUsed,
        id_oa_userPwdHistory,
        id_oa_userPwdRecentlyExpired,
        id_oa_pwdModifyEntryAllowed,
        id_oa_pwdChangeAllowed,
        id_oa_pwdMaxAge,
        id_oa_pwdExpiryAge,
        id_oa_pwdMinLength,
        id_oa_pwdVocabulary,
        id_oa_pwdAlphabet,
        id_oa_pwdDictionaries,
        id_oa_pwdExpiryWarning,
        id_oa_pwdGraces,
        id_oa_pwdFailureDuration,
        id_oa_pwdLockoutDuration,
        id_oa_pwdMaxFailures,
        id_oa_pwdMaxTimeInHistory,
        id_oa_pwdMinTimeInHistory,
        id_oa_pwdHistorySlots,
        id_oa_pwdRecentlyExpiredDuration,
        id_oa_pwdEncAlg,
        id_mr_userPwdMatch,
        id_mr_userPwdHistoryMatch,
        id_mr_pwdEncAlgMatch,
        id_asx_userPwdDescription,
        id_asx_pwdVocabularyDescription,
        id_asx_pwdAlphabetDescription,
        id_asx_pwdEncAlgDescription,
    ]

class PkiPmiExternalDataTypes:

    _name_  = 'PkiPmiExternalDataTypes'
    _oid_   = [2, 5, 1, 40, 8]
    
    _obj_ = [
        'UserNotice',
        'NoticeReference',
        'DisplayText',
        'authorityInfoAccess',
        'AuthorityInfoAccessSyntax',
        'AccessDescription',
        'subjectInfoAccess',
        'SubjectInfoAccessSyntax',
        'id-pkix',
        'id-pe',
        'id-ad',
        'id-pe-authorityInfoAccess',
        'id-pe-subjectInfoAccess',
        'id-ad-caIssuers',
        'id-ad-ocsp',
        'G3FacsimileNonBasicParameters',
        'ORAddress',
        'BuiltInStandardAttributes',
        'CountryName',
        'AdministrationDomainName',
        'NetworkAddress',
        'X121Address',
        'TerminalIdentifier',
        'PrivateDomainName',
        'OrganizationName',
        'NumericUserIdentifier',
        'PersonalName',
        'OrganizationalUnitNames',
        'OrganizationalUnitName',
        'BuiltInDomainDefinedAttributes',
        'BuiltInDomainDefinedAttribute',
        'ExtensionAttributes',
        'ExtensionAttribute',
        'EXTENSION-ATTRIBUTE',
        'ExtensionAttributeTable',
        'common-name',
        'CommonName',
        'teletex-common-name',
        'TeletexCommonName',
        'universal-common-name',
        'UniversalCommonName',
        'teletex-organization-name',
        'TeletexOrganizationName',
        'universal-organization-name',
        'UniversalOrganizationName',
        'teletex-personal-name',
        'TeletexPersonalName',
        'universal-personal-name',
        'UniversalPersonalName',
        'teletex-organizational-unit-names',
        'TeletexOrganizationalUnitNames',
        'TeletexOrganizationalUnitName',
        'universal-organizational-unit-names',
        'UniversalOrganizationalUnitNames',
        'UniversalOrganizationalUnitName',
        'UniversalOrBMPString',
        'pds-name',
        'PDSName',
        'physical-delivery-country-name',
        'PhysicalDeliveryCountryName',
        'postal-code',
        'PostalCode',
        'physical-delivery-office-name',
        'PhysicalDeliveryOfficeName',
        'universal-physical-delivery-office-name',
        'UniversalPhysicalDeliveryOfficeName',
        'physical-delivery-office-number',
        'PhysicalDeliveryOfficeNumber',
        'universal-physical-delivery-office-number',
        'UniversalPhysicalDeliveryOfficeNumber',
        'extension-OR-address-components',
        'ExtensionORAddressComponents',
        'universal-extension-OR-address-components',
        'UniversalExtensionORAddressComponents',
        'physical-delivery-personal-name',
        'PhysicalDeliveryPersonalName',
        'universal-physical-delivery-personal-name',
        'UniversalPhysicalDeliveryPersonalName',
        'physical-delivery-organization-name',
        'PhysicalDeliveryOrganizationName',
        'universal-physical-delivery-organization-name',
        'UniversalPhysicalDeliveryOrganizationName',
        'extension-physical-delivery-address-components',
        'ExtensionPhysicalDeliveryAddressComponents',
        'universal-extension-physical-delivery-address-components',
        'UniversalExtensionPhysicalDeliveryAddressComponents',
        'unformatted-postal-address',
        'UnformattedPostalAddress',
        'universal-unformatted-postal-address',
        'UniversalUnformattedPostalAddress',
        'street-address',
        'StreetAddress',
        'universal-street-address',
        'UniversalStreetAddress',
        'post-office-box-address',
        'PostOfficeBoxAddress',
        'universal-post-office-box-address',
        'UniversalPostOfficeBoxAddress',
        'poste-restante-address',
        'PosteRestanteAddress',
        'universal-poste-restante-address',
        'UniversalPosteRestanteAddress',
        'unique-postal-name',
        'UniquePostalName',
        'universal-unique-postal-name',
        'UniversalUniquePostalName',
        'local-postal-attributes',
        'LocalPostalAttributes',
        'universal-local-postal-attributes',
        'UniversalLocalPostalAttributes',
        'PDSParameter',
        'UniversalPDSParameter',
        'extended-network-address',
        'ExtendedNetworkAddress',
        'terminal-type',
        'TerminalType',
        'teletex-domain-defined-attributes',
        'TeletexDomainDefinedAttributes',
        'TeletexDomainDefinedAttribute',
        'universal-domain-defined-attributes',
        'UniversalDomainDefinedAttributes',
        'UniversalDomainDefinedAttribute',
        'ub-integer-options',
        'ub-e163-4-number-length',
        'ub-e163-4-sub-address-length',
        'ub-unformatted-address-length',
        'ub-pds-parameter-length',
        'ub-pds-physical-address-lines',
        'ub-postal-code-length',
        'ub-pds-name-length',
        'ub-universal-surname-length',
        'ub-universal-given-name-length',
        'ub-universal-initials-length',
        'ub-universal-generation-qualifier-length',
        'ub-common-name-length',
        'ub-extension-attributes',
        'ub-domain-defined-attribute-type-length',
        'ub-domain-defined-attribute-value-length',
        'ub-domain-defined-attributes',
        'ub-organizational-unit-name-length',
        'ub-organizational-units',
        'ub-generation-qualifier-length',
        'ub-initials-length',
        'ub-given-name-length',
        'ub-surname-length',
        'ub-numeric-user-id-length',
        'ub-organization-name-length',
        'ub-terminal-id-length',
        'ub-x121-address-length',
        'ub-domain-name-length',
        'ub-country-name-alpha-length',
        'ub-country-name-numeric-length',
        ]
    _type_ = [
        'UserNotice',
        'NoticeReference',
        'DisplayText',
        'AuthorityInfoAccessSyntax',
        'AccessDescription',
        'SubjectInfoAccessSyntax',
        'G3FacsimileNonBasicParameters',
        'ORAddress',
        'BuiltInStandardAttributes',
        'CountryName',
        'AdministrationDomainName',
        'NetworkAddress',
        'X121Address',
        'TerminalIdentifier',
        'PrivateDomainName',
        'OrganizationName',
        'NumericUserIdentifier',
        'PersonalName',
        'OrganizationalUnitNames',
        'OrganizationalUnitName',
        'BuiltInDomainDefinedAttributes',
        'BuiltInDomainDefinedAttribute',
        'ExtensionAttributes',
        'ExtensionAttribute',
        'EXTENSION-ATTRIBUTE',
        'CommonName',
        'TeletexCommonName',
        'UniversalCommonName',
        'TeletexOrganizationName',
        'UniversalOrganizationName',
        'TeletexPersonalName',
        'UniversalPersonalName',
        'TeletexOrganizationalUnitNames',
        'TeletexOrganizationalUnitName',
        'UniversalOrganizationalUnitNames',
        'UniversalOrganizationalUnitName',
        'UniversalOrBMPString',
        'PDSName',
        'PhysicalDeliveryCountryName',
        'PostalCode',
        'PhysicalDeliveryOfficeName',
        'UniversalPhysicalDeliveryOfficeName',
        'PhysicalDeliveryOfficeNumber',
        'UniversalPhysicalDeliveryOfficeNumber',
        'ExtensionORAddressComponents',
        'UniversalExtensionORAddressComponents',
        'PhysicalDeliveryPersonalName',
        'UniversalPhysicalDeliveryPersonalName',
        'PhysicalDeliveryOrganizationName',
        'UniversalPhysicalDeliveryOrganizationName',
        'ExtensionPhysicalDeliveryAddressComponents',
        'UniversalExtensionPhysicalDeliveryAddressComponents',
        'UnformattedPostalAddress',
        'UniversalUnformattedPostalAddress',
        'StreetAddress',
        'UniversalStreetAddress',
        'PostOfficeBoxAddress',
        'UniversalPostOfficeBoxAddress',
        'PosteRestanteAddress',
        'UniversalPosteRestanteAddress',
        'UniquePostalName',
        'UniversalUniquePostalName',
        'LocalPostalAttributes',
        'UniversalLocalPostalAttributes',
        'PDSParameter',
        'UniversalPDSParameter',
        'ExtendedNetworkAddress',
        'TerminalType',
        'TeletexDomainDefinedAttributes',
        'TeletexDomainDefinedAttribute',
        'UniversalDomainDefinedAttributes',
        'UniversalDomainDefinedAttribute',
        ]
    _set_ = [
        'ExtensionAttributeTable',
        ]
    _val_ = [
        'authorityInfoAccess',
        'subjectInfoAccess',
        'id-pkix',
        'id-pe',
        'id-ad',
        'id-pe-authorityInfoAccess',
        'id-pe-subjectInfoAccess',
        'id-ad-caIssuers',
        'id-ad-ocsp',
        'common-name',
        'teletex-common-name',
        'universal-common-name',
        'teletex-organization-name',
        'universal-organization-name',
        'teletex-personal-name',
        'universal-personal-name',
        'teletex-organizational-unit-names',
        'universal-organizational-unit-names',
        'pds-name',
        'physical-delivery-country-name',
        'postal-code',
        'physical-delivery-office-name',
        'universal-physical-delivery-office-name',
        'physical-delivery-office-number',
        'universal-physical-delivery-office-number',
        'extension-OR-address-components',
        'universal-extension-OR-address-components',
        'physical-delivery-personal-name',
        'universal-physical-delivery-personal-name',
        'physical-delivery-organization-name',
        'universal-physical-delivery-organization-name',
        'extension-physical-delivery-address-components',
        'universal-extension-physical-delivery-address-components',
        'unformatted-postal-address',
        'universal-unformatted-postal-address',
        'street-address',
        'universal-street-address',
        'post-office-box-address',
        'universal-post-office-box-address',
        'poste-restante-address',
        'universal-poste-restante-address',
        'unique-postal-name',
        'universal-unique-postal-name',
        'local-postal-attributes',
        'universal-local-postal-attributes',
        'extended-network-address',
        'terminal-type',
        'teletex-domain-defined-attributes',
        'universal-domain-defined-attributes',
        'ub-integer-options',
        'ub-e163-4-number-length',
        'ub-e163-4-sub-address-length',
        'ub-unformatted-address-length',
        'ub-pds-parameter-length',
        'ub-pds-physical-address-lines',
        'ub-postal-code-length',
        'ub-pds-name-length',
        'ub-universal-surname-length',
        'ub-universal-given-name-length',
        'ub-universal-initials-length',
        'ub-universal-generation-qualifier-length',
        'ub-common-name-length',
        'ub-extension-attributes',
        'ub-domain-defined-attribute-type-length',
        'ub-domain-defined-attribute-value-length',
        'ub-domain-defined-attributes',
        'ub-organizational-unit-name-length',
        'ub-organizational-units',
        'ub-generation-qualifier-length',
        'ub-initials-length',
        'ub-given-name-length',
        'ub-surname-length',
        'ub-numeric-user-id-length',
        'ub-organization-name-length',
        'ub-terminal-id-length',
        'ub-x121-address-length',
        'ub-domain-name-length',
        'ub-country-name-alpha-length',
        'ub-country-name-numeric-length',
        ]
    _class_ = [
        'authorityInfoAccess',
        'subjectInfoAccess',
        'EXTENSION-ATTRIBUTE',
        'ExtensionAttributeTable',
        'common-name',
        'teletex-common-name',
        'universal-common-name',
        'teletex-organization-name',
        'universal-organization-name',
        'teletex-personal-name',
        'universal-personal-name',
        'teletex-organizational-unit-names',
        'universal-organizational-unit-names',
        'pds-name',
        'physical-delivery-country-name',
        'postal-code',
        'physical-delivery-office-name',
        'universal-physical-delivery-office-name',
        'physical-delivery-office-number',
        'universal-physical-delivery-office-number',
        'extension-OR-address-components',
        'universal-extension-OR-address-components',
        'physical-delivery-personal-name',
        'universal-physical-delivery-personal-name',
        'physical-delivery-organization-name',
        'universal-physical-delivery-organization-name',
        'extension-physical-delivery-address-components',
        'universal-extension-physical-delivery-address-components',
        'unformatted-postal-address',
        'universal-unformatted-postal-address',
        'street-address',
        'universal-street-address',
        'post-office-box-address',
        'universal-post-office-box-address',
        'poste-restante-address',
        'universal-poste-restante-address',
        'unique-postal-name',
        'universal-unique-postal-name',
        'local-postal-attributes',
        'universal-local-postal-attributes',
        'extended-network-address',
        'terminal-type',
        'teletex-domain-defined-attributes',
        'universal-domain-defined-attributes',
        ]
    _param_ = [
        'UniversalOrBMPString',
        ]
    
    #-----< UserNotice >-----#
    UserNotice = SEQ(name='UserNotice', mode=MODE_TYPE)
    _UserNotice_noticeRef = SEQ(name='noticeRef', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'NoticeReference')), opt=True)
    _UserNotice_explicitText = CHOICE(name='explicitText', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'DisplayText')), opt=True)
    UserNotice._cont = ASN1Dict([
        ('noticeRef', _UserNotice_noticeRef),
        ('explicitText', _UserNotice_explicitText),
        ])
    UserNotice._ext = None
    
    #-----< NoticeReference >-----#
    NoticeReference = SEQ(name='NoticeReference', mode=MODE_TYPE)
    _NoticeReference_organization = CHOICE(name='organization', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'DisplayText')))
    _NoticeReference_noticeNumbers = SEQ_OF(name='noticeNumbers', mode=MODE_TYPE)
    __NoticeReference_noticeNumbers__item_ = INT(name='_item_', mode=MODE_TYPE)
    _NoticeReference_noticeNumbers._cont = __NoticeReference_noticeNumbers__item_
    NoticeReference._cont = ASN1Dict([
        ('organization', _NoticeReference_organization),
        ('noticeNumbers', _NoticeReference_noticeNumbers),
        ])
    NoticeReference._ext = None
    
    #-----< DisplayText >-----#
    DisplayText = CHOICE(name='DisplayText', mode=MODE_TYPE)
    _DisplayText_visibleString = STR_VIS(name='visibleString', mode=MODE_TYPE)
    _DisplayText_visibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _DisplayText_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_utf8String = STR_UTF8(name='utf8String', mode=MODE_TYPE)
    _DisplayText_utf8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    DisplayText._cont = ASN1Dict([
        ('visibleString', _DisplayText_visibleString),
        ('bmpString', _DisplayText_bmpString),
        ('utf8String', _DisplayText_utf8String),
        ])
    DisplayText._ext = None
    
    #-----< authorityInfoAccess >-----#
    authorityInfoAccess = CLASS(name='authorityInfoAccess', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityInfoAccess_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AuthorityInfoAccessSyntax')))
    authorityInfoAccess._val = dict([('ExtnType', _authorityInfoAccess_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))])
    
    #-----< AuthorityInfoAccessSyntax >-----#
    AuthorityInfoAccessSyntax = SEQ_OF(name='AuthorityInfoAccessSyntax', mode=MODE_TYPE)
    _AuthorityInfoAccessSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AccessDescription')))
    AuthorityInfoAccessSyntax._cont = _AuthorityInfoAccessSyntax__item_
    AuthorityInfoAccessSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AccessDescription >-----#
    AccessDescription = SEQ(name='AccessDescription', mode=MODE_TYPE)
    _AccessDescription_accessMethod = OID(name='accessMethod', mode=MODE_TYPE)
    _AccessDescription_accessLocation = CHOICE(name='accessLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    AccessDescription._cont = ASN1Dict([
        ('accessMethod', _AccessDescription_accessMethod),
        ('accessLocation', _AccessDescription_accessLocation),
        ])
    AccessDescription._ext = None
    
    #-----< subjectInfoAccess >-----#
    subjectInfoAccess = CLASS(name='subjectInfoAccess', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectInfoAccess_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'SubjectInfoAccessSyntax')))
    subjectInfoAccess._val = dict([('ExtnType', _subjectInfoAccess_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])
    
    #-----< SubjectInfoAccessSyntax >-----#
    SubjectInfoAccessSyntax = SEQ_OF(name='SubjectInfoAccessSyntax', mode=MODE_TYPE)
    _SubjectInfoAccessSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AccessDescription')))
    SubjectInfoAccessSyntax._cont = _SubjectInfoAccessSyntax__item_
    SubjectInfoAccessSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< id-pkix >-----#
    id_pkix = OID(name='id-pkix', mode=MODE_VALUE)
    id_pkix._val = (1, 3, 6, 1, 5, 5, 7)
    
    #-----< id-pe >-----#
    id_pe = OID(name='id-pe', mode=MODE_VALUE)
    id_pe._val = (1, 3, 6, 1, 5, 5, 7, 1)
    
    #-----< id-ad >-----#
    id_ad = OID(name='id-ad', mode=MODE_VALUE)
    id_ad._val = (1, 3, 6, 1, 5, 5, 7, 48)
    
    #-----< id-pe-authorityInfoAccess >-----#
    id_pe_authorityInfoAccess = OID(name='id-pe-authorityInfoAccess', mode=MODE_VALUE)
    id_pe_authorityInfoAccess._val = (1, 3, 6, 1, 5, 5, 7, 1, 1)
    
    #-----< id-pe-subjectInfoAccess >-----#
    id_pe_subjectInfoAccess = OID(name='id-pe-subjectInfoAccess', mode=MODE_VALUE)
    id_pe_subjectInfoAccess._val = (1, 3, 6, 1, 5, 5, 7, 1, 11)
    
    #-----< id-ad-caIssuers >-----#
    id_ad_caIssuers = OID(name='id-ad-caIssuers', mode=MODE_VALUE)
    id_ad_caIssuers._val = (1, 3, 6, 1, 5, 5, 7, 48, 2)
    
    #-----< id-ad-ocsp >-----#
    id_ad_ocsp = OID(name='id-ad-ocsp', mode=MODE_VALUE)
    id_ad_ocsp._val = (1, 3, 6, 1, 5, 5, 7, 48, 1)
    
    #-----< G3FacsimileNonBasicParameters >-----#
    G3FacsimileNonBasicParameters = BIT_STR(name='G3FacsimileNonBasicParameters', mode=MODE_TYPE)
    G3FacsimileNonBasicParameters._cont = ASN1Dict([('two-dimensional', 8), ('fine-resolution', 9), ('unlimited-length', 20), ('b4-length', 21), ('a3-width', 22), ('b4-width', 23), ('t6-coding', 25), ('uncompressed', 30), ('width-middle-864-of-1728', 37), ('width-middle-1216-of-1728', 38), ('resolution-type', 44), ('resolution-400x400', 45), ('resolution-300x300', 46), ('resolution-8x15', 47), ('edi', 49), ('dtm', 50), ('bft', 51), ('mixed-mode', 58), ('character-mode', 60), ('twelve-bits', 65), ('preferred-huffmann', 66), ('full-colour', 67), ('jpeg', 68), ('processable-mode-26', 71)])
    
    #-----< ORAddress >-----#
    ORAddress = SEQ(name='ORAddress', mode=MODE_TYPE)
    _ORAddress_built_in_standard_attributes = SEQ(name='built-in-standard-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'BuiltInStandardAttributes')))
    _ORAddress_built_in_domain_defined_attributes = SEQ_OF(name='built-in-domain-defined-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'BuiltInDomainDefinedAttributes')), opt=True)
    _ORAddress_extension_attributes = SET_OF(name='extension-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionAttributes')), opt=True)
    ORAddress._cont = ASN1Dict([
        ('built-in-standard-attributes', _ORAddress_built_in_standard_attributes),
        ('built-in-domain-defined-attributes', _ORAddress_built_in_domain_defined_attributes),
        ('extension-attributes', _ORAddress_extension_attributes),
        ])
    ORAddress._ext = None
    
    #-----< BuiltInStandardAttributes >-----#
    BuiltInStandardAttributes = SEQ(name='BuiltInStandardAttributes', mode=MODE_TYPE)
    _BuiltInStandardAttributes_country_name = CHOICE(name='country-name', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CountryName')), opt=True)
    _BuiltInStandardAttributes_administration_domain_name = CHOICE(name='administration-domain-name', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AdministrationDomainName')), opt=True)
    _BuiltInStandardAttributes_network_address = STR_NUM(name='network-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'NetworkAddress')), opt=True)
    _BuiltInStandardAttributes_terminal_identifier = STR_PRINT(name='terminal-identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalIdentifier')), opt=True)
    _BuiltInStandardAttributes_private_domain_name = CHOICE(name='private-domain-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PrivateDomainName')), opt=True)
    _BuiltInStandardAttributes_organization_name = STR_PRINT(name='organization-name', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'OrganizationName')), opt=True)
    _BuiltInStandardAttributes_numeric_user_identifier = STR_NUM(name='numeric-user-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'NumericUserIdentifier')), opt=True)
    _BuiltInStandardAttributes_personal_name = SET(name='personal-name', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PersonalName')), opt=True)
    _BuiltInStandardAttributes_organizational_unit_names = SEQ_OF(name='organizational-unit-names', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'OrganizationalUnitNames')), opt=True)
    BuiltInStandardAttributes._cont = ASN1Dict([
        ('country-name', _BuiltInStandardAttributes_country_name),
        ('administration-domain-name', _BuiltInStandardAttributes_administration_domain_name),
        ('network-address', _BuiltInStandardAttributes_network_address),
        ('terminal-identifier', _BuiltInStandardAttributes_terminal_identifier),
        ('private-domain-name', _BuiltInStandardAttributes_private_domain_name),
        ('organization-name', _BuiltInStandardAttributes_organization_name),
        ('numeric-user-identifier', _BuiltInStandardAttributes_numeric_user_identifier),
        ('personal-name', _BuiltInStandardAttributes_personal_name),
        ('organizational-unit-names', _BuiltInStandardAttributes_organizational_unit_names),
        ])
    BuiltInStandardAttributes._ext = None
    
    #-----< CountryName >-----#
    CountryName = CHOICE(name='CountryName', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_EXPLICIT))
    _CountryName_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    _CountryName_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _CountryName_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    _CountryName_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    CountryName._cont = ASN1Dict([
        ('x121-dcc-code', _CountryName_x121_dcc_code),
        ('iso-3166-alpha2-code', _CountryName_iso_3166_alpha2_code),
        ])
    CountryName._ext = None
    
    #-----< AdministrationDomainName >-----#
    AdministrationDomainName = CHOICE(name='AdministrationDomainName', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_EXPLICIT))
    _AdministrationDomainName_numeric = STR_NUM(name='numeric', mode=MODE_TYPE)
    _AdministrationDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    _AdministrationDomainName_printable = STR_PRINT(name='printable', mode=MODE_TYPE)
    _AdministrationDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    AdministrationDomainName._cont = ASN1Dict([
        ('numeric', _AdministrationDomainName_numeric),
        ('printable', _AdministrationDomainName_printable),
        ])
    AdministrationDomainName._ext = None
    
    #-----< NetworkAddress >-----#
    NetworkAddress = STR_NUM(name='NetworkAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'X121Address')))
    
    #-----< X121Address >-----#
    X121Address = STR_NUM(name='X121Address', mode=MODE_TYPE)
    X121Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TerminalIdentifier >-----#
    TerminalIdentifier = STR_PRINT(name='TerminalIdentifier', mode=MODE_TYPE)
    TerminalIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    
    #-----< PrivateDomainName >-----#
    PrivateDomainName = CHOICE(name='PrivateDomainName', mode=MODE_TYPE)
    _PrivateDomainName_numeric = STR_NUM(name='numeric', mode=MODE_TYPE)
    _PrivateDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PrivateDomainName_printable = STR_PRINT(name='printable', mode=MODE_TYPE)
    _PrivateDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    PrivateDomainName._cont = ASN1Dict([
        ('numeric', _PrivateDomainName_numeric),
        ('printable', _PrivateDomainName_printable),
        ])
    PrivateDomainName._ext = None
    
    #-----< OrganizationName >-----#
    OrganizationName = STR_PRINT(name='OrganizationName', mode=MODE_TYPE)
    OrganizationName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< NumericUserIdentifier >-----#
    NumericUserIdentifier = STR_NUM(name='NumericUserIdentifier', mode=MODE_TYPE)
    NumericUserIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PersonalName >-----#
    PersonalName = SET(name='PersonalName', mode=MODE_TYPE)
    _PersonalName_surname = STR_PRINT(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _PersonalName_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _PersonalName_given_name = STR_PRINT(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PersonalName_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PersonalName_initials = STR_PRINT(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PersonalName_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _PersonalName_generation_qualifier = STR_PRINT(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PersonalName_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    PersonalName._cont = ASN1Dict([
        ('surname', _PersonalName_surname),
        ('given-name', _PersonalName_given_name),
        ('initials', _PersonalName_initials),
        ('generation-qualifier', _PersonalName_generation_qualifier),
        ])
    PersonalName._ext = None
    
    #-----< OrganizationalUnitNames >-----#
    OrganizationalUnitNames = SEQ_OF(name='OrganizationalUnitNames', mode=MODE_TYPE)
    _OrganizationalUnitNames__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'OrganizationalUnitName')))
    OrganizationalUnitNames._cont = _OrganizationalUnitNames__item_
    OrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< OrganizationalUnitName >-----#
    OrganizationalUnitName = STR_PRINT(name='OrganizationalUnitName', mode=MODE_TYPE)
    OrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttributes >-----#
    BuiltInDomainDefinedAttributes = SEQ_OF(name='BuiltInDomainDefinedAttributes', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'BuiltInDomainDefinedAttribute')))
    BuiltInDomainDefinedAttributes._cont = _BuiltInDomainDefinedAttributes__item_
    BuiltInDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttribute >-----#
    BuiltInDomainDefinedAttribute = SEQ(name='BuiltInDomainDefinedAttribute', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type = STR_PRINT(name='type', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _BuiltInDomainDefinedAttribute_value = STR_PRINT(name='value', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    BuiltInDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _BuiltInDomainDefinedAttribute_type),
        ('value', _BuiltInDomainDefinedAttribute_value),
        ])
    BuiltInDomainDefinedAttribute._ext = None
    
    #-----< ExtensionAttributes >-----#
    ExtensionAttributes = SET_OF(name='ExtensionAttributes', mode=MODE_TYPE)
    _ExtensionAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionAttribute')))
    ExtensionAttributes._cont = _ExtensionAttributes__item_
    ExtensionAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ExtensionAttribute >-----#
    ExtensionAttribute = SEQ(name='ExtensionAttribute', mode=MODE_TYPE)
    _ExtensionAttribute_extension_attribute_type = INT(name='extension-attribute-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE'), ['id']))
    __ExtensionAttribute_extension_attribute_type_tab = CLASS(name='_tab_EXTENSION-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexCommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalCommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitNames')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitNames')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryCountryName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostalCode')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeNumber')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeNumber')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionORAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionORAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionPhysicalDeliveryAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UnformattedPostalAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUnformattedPostalAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'StreetAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalStreetAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostOfficeBoxAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPostOfficeBoxAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PosteRestanteAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPosteRestanteAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniquePostalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUniquePostalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'LocalPostalAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalLocalPostalAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtendedNetworkAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalType')))
    __ExtensionAttribute_extension_attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0), ('id', 1)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1), ('id', 2)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2), ('id', 24)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3), ('id', 3)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4), ('id', 25)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5), ('id', 4)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6), ('id', 26)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7), ('id', 5)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8), ('id', 27)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9), ('id', 6)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10), ('id', 28)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11), ('id', 7)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12), ('id', 8)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13), ('id', 9)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14), ('id', 10)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15), ('id', 29)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16), ('id', 11)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17), ('id', 30)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18), ('id', 12)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19), ('id', 31)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20), ('id', 13)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21), ('id', 32)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22), ('id', 14)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23), ('id', 33)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24), ('id', 15)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25), ('id', 34)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26), ('id', 16)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27), ('id', 35)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28), ('id', 17)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29), ('id', 36)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30), ('id', 18)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31), ('id', 37)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32), ('id', 19)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33), ('id', 38)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34), ('id', 20)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35), ('id', 39)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36), ('id', 21)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37), ('id', 40)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38), ('id', 22)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39), ('id', 23)])], rr=[], ev=None, er=[])
    _ExtensionAttribute_extension_attribute_type._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_type._const_tab_at = None
    _ExtensionAttribute_extension_attribute_type._const_tab_id = 'id'
    _ExtensionAttribute_extension_attribute_value = OPEN(name='extension-attribute-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE'), ['Type']))
    _ExtensionAttribute_extension_attribute_value._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_value._const_tab_at = ('..', 'extension-attribute-type')
    _ExtensionAttribute_extension_attribute_value._const_tab_id = 'Type'
    ExtensionAttribute._cont = ASN1Dict([
        ('extension-attribute-type', _ExtensionAttribute_extension_attribute_type),
        ('extension-attribute-value', _ExtensionAttribute_extension_attribute_value),
        ])
    ExtensionAttribute._ext = None
    
    #-----< EXTENSION-ATTRIBUTE >-----#
    EXTENSION_ATTRIBUTE = CLASS(name='EXTENSION-ATTRIBUTE', mode=MODE_TYPE)
    _EXTENSION_ATTRIBUTE_id = INT(name='id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ATTRIBUTE_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _EXTENSION_ATTRIBUTE_Type = OPEN(name='Type', mode=MODE_TYPE)
    EXTENSION_ATTRIBUTE._cont = ASN1Dict([
        ('id', _EXTENSION_ATTRIBUTE_id),
        ('Type', _EXTENSION_ATTRIBUTE_Type),
        ])
    
    #-----< ExtensionAttributeTable >-----#
    ExtensionAttributeTable = CLASS(name='ExtensionAttributeTable', mode=MODE_SET, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _ExtensionAttributeTable_val_Type_0 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CommonName')))
    _ExtensionAttributeTable_val_Type_1 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexCommonName')))
    _ExtensionAttributeTable_val_Type_2 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalCommonName')))
    _ExtensionAttributeTable_val_Type_3 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationName')))
    _ExtensionAttributeTable_val_Type_4 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationName')))
    _ExtensionAttributeTable_val_Type_5 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexPersonalName')))
    _ExtensionAttributeTable_val_Type_6 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPersonalName')))
    _ExtensionAttributeTable_val_Type_7 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitNames')))
    _ExtensionAttributeTable_val_Type_8 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitNames')))
    _ExtensionAttributeTable_val_Type_9 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttributes')))
    _ExtensionAttributeTable_val_Type_10 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttributes')))
    _ExtensionAttributeTable_val_Type_11 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSName')))
    _ExtensionAttributeTable_val_Type_12 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryCountryName')))
    _ExtensionAttributeTable_val_Type_13 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostalCode')))
    _ExtensionAttributeTable_val_Type_14 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeName')))
    _ExtensionAttributeTable_val_Type_15 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeName')))
    _ExtensionAttributeTable_val_Type_16 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeNumber')))
    _ExtensionAttributeTable_val_Type_17 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeNumber')))
    _ExtensionAttributeTable_val_Type_18 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionORAddressComponents')))
    _ExtensionAttributeTable_val_Type_19 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionORAddressComponents')))
    _ExtensionAttributeTable_val_Type_20 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryPersonalName')))
    _ExtensionAttributeTable_val_Type_21 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryPersonalName')))
    _ExtensionAttributeTable_val_Type_22 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOrganizationName')))
    _ExtensionAttributeTable_val_Type_23 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOrganizationName')))
    _ExtensionAttributeTable_val_Type_24 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionPhysicalDeliveryAddressComponents')))
    _ExtensionAttributeTable_val_Type_25 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    _ExtensionAttributeTable_val_Type_26 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UnformattedPostalAddress')))
    _ExtensionAttributeTable_val_Type_27 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUnformattedPostalAddress')))
    _ExtensionAttributeTable_val_Type_28 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'StreetAddress')))
    _ExtensionAttributeTable_val_Type_29 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalStreetAddress')))
    _ExtensionAttributeTable_val_Type_30 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostOfficeBoxAddress')))
    _ExtensionAttributeTable_val_Type_31 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPostOfficeBoxAddress')))
    _ExtensionAttributeTable_val_Type_32 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PosteRestanteAddress')))
    _ExtensionAttributeTable_val_Type_33 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPosteRestanteAddress')))
    _ExtensionAttributeTable_val_Type_34 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniquePostalName')))
    _ExtensionAttributeTable_val_Type_35 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUniquePostalName')))
    _ExtensionAttributeTable_val_Type_36 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'LocalPostalAttributes')))
    _ExtensionAttributeTable_val_Type_37 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalLocalPostalAttributes')))
    _ExtensionAttributeTable_val_Type_38 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtendedNetworkAddress')))
    _ExtensionAttributeTable_val_Type_39 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalType')))
    ExtensionAttributeTable._val = ASN1Set(rv=[dict([('Type', _ExtensionAttributeTable_val_Type_0), ('id', 1)]), dict([('Type', _ExtensionAttributeTable_val_Type_1), ('id', 2)]), dict([('Type', _ExtensionAttributeTable_val_Type_2), ('id', 24)]), dict([('Type', _ExtensionAttributeTable_val_Type_3), ('id', 3)]), dict([('Type', _ExtensionAttributeTable_val_Type_4), ('id', 25)]), dict([('Type', _ExtensionAttributeTable_val_Type_5), ('id', 4)]), dict([('Type', _ExtensionAttributeTable_val_Type_6), ('id', 26)]), dict([('Type', _ExtensionAttributeTable_val_Type_7), ('id', 5)]), dict([('Type', _ExtensionAttributeTable_val_Type_8), ('id', 27)]), dict([('Type', _ExtensionAttributeTable_val_Type_9), ('id', 6)]), dict([('Type', _ExtensionAttributeTable_val_Type_10), ('id', 28)]), dict([('Type', _ExtensionAttributeTable_val_Type_11), ('id', 7)]), dict([('Type', _ExtensionAttributeTable_val_Type_12), ('id', 8)]), dict([('Type', _ExtensionAttributeTable_val_Type_13), ('id', 9)]), dict([('Type', _ExtensionAttributeTable_val_Type_14), ('id', 10)]), dict([('Type', _ExtensionAttributeTable_val_Type_15), ('id', 29)]), dict([('Type', _ExtensionAttributeTable_val_Type_16), ('id', 11)]), dict([('Type', _ExtensionAttributeTable_val_Type_17), ('id', 30)]), dict([('Type', _ExtensionAttributeTable_val_Type_18), ('id', 12)]), dict([('Type', _ExtensionAttributeTable_val_Type_19), ('id', 31)]), dict([('Type', _ExtensionAttributeTable_val_Type_20), ('id', 13)]), dict([('Type', _ExtensionAttributeTable_val_Type_21), ('id', 32)]), dict([('Type', _ExtensionAttributeTable_val_Type_22), ('id', 14)]), dict([('Type', _ExtensionAttributeTable_val_Type_23), ('id', 33)]), dict([('Type', _ExtensionAttributeTable_val_Type_24), ('id', 15)]), dict([('Type', _ExtensionAttributeTable_val_Type_25), ('id', 34)]), dict([('Type', _ExtensionAttributeTable_val_Type_26), ('id', 16)]), dict([('Type', _ExtensionAttributeTable_val_Type_27), ('id', 35)]), dict([('Type', _ExtensionAttributeTable_val_Type_28), ('id', 17)]), dict([('Type', _ExtensionAttributeTable_val_Type_29), ('id', 36)]), dict([('Type', _ExtensionAttributeTable_val_Type_30), ('id', 18)]), dict([('Type', _ExtensionAttributeTable_val_Type_31), ('id', 37)]), dict([('Type', _ExtensionAttributeTable_val_Type_32), ('id', 19)]), dict([('Type', _ExtensionAttributeTable_val_Type_33), ('id', 38)]), dict([('Type', _ExtensionAttributeTable_val_Type_34), ('id', 20)]), dict([('Type', _ExtensionAttributeTable_val_Type_35), ('id', 39)]), dict([('Type', _ExtensionAttributeTable_val_Type_36), ('id', 21)]), dict([('Type', _ExtensionAttributeTable_val_Type_37), ('id', 40)]), dict([('Type', _ExtensionAttributeTable_val_Type_38), ('id', 22)]), dict([('Type', _ExtensionAttributeTable_val_Type_39), ('id', 23)])], rr=[], ev=None, er=[])
    
    #-----< common-name >-----#
    common_name = CLASS(name='common-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _common_name_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CommonName')))
    common_name._val = dict([('Type', _common_name_val_Type), ('id', 1)])
    
    #-----< CommonName >-----#
    CommonName = STR_PRINT(name='CommonName', mode=MODE_TYPE)
    CommonName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< teletex-common-name >-----#
    teletex_common_name = CLASS(name='teletex-common-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_common_name_val_Type = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexCommonName')))
    teletex_common_name._val = dict([('Type', _teletex_common_name_val_Type), ('id', 2)])
    
    #-----< TeletexCommonName >-----#
    TeletexCommonName = STR_TELE(name='TeletexCommonName', mode=MODE_TYPE)
    TeletexCommonName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< universal-common-name >-----#
    universal_common_name = CLASS(name='universal-common-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_common_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalCommonName')))
    universal_common_name._val = dict([('Type', _universal_common_name_val_Type), ('id', 24)])
    
    #-----< UniversalCommonName >-----#
    UniversalCommonName = SET(name='UniversalCommonName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalCommonName_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalCommonName_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _UniversalCommonName_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalCommonName_character_encoding_two_octets),
        ('four-octets', __UniversalCommonName_character_encoding_four_octets),
        ])
    _UniversalCommonName_character_encoding._ext = None
    _UniversalCommonName_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalCommonName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalCommonName._cont = ASN1Dict([
        ('character-encoding', _UniversalCommonName_character_encoding),
        ('iso-639-language-code', _UniversalCommonName_iso_639_language_code),
        ])
    UniversalCommonName._ext = None
    
    #-----< teletex-organization-name >-----#
    teletex_organization_name = CLASS(name='teletex-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_organization_name_val_Type = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationName')))
    teletex_organization_name._val = dict([('Type', _teletex_organization_name_val_Type), ('id', 3)])
    
    #-----< TeletexOrganizationName >-----#
    TeletexOrganizationName = STR_TELE(name='TeletexOrganizationName', mode=MODE_TYPE)
    TeletexOrganizationName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< universal-organization-name >-----#
    universal_organization_name = CLASS(name='universal-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_organization_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationName')))
    universal_organization_name._val = dict([('Type', _universal_organization_name_val_Type), ('id', 25)])
    
    #-----< UniversalOrganizationName >-----#
    UniversalOrganizationName = SET(name='UniversalOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalOrganizationName_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalOrganizationName_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _UniversalOrganizationName_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalOrganizationName_character_encoding_two_octets),
        ('four-octets', __UniversalOrganizationName_character_encoding_four_octets),
        ])
    _UniversalOrganizationName_character_encoding._ext = None
    _UniversalOrganizationName_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalOrganizationName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalOrganizationName._cont = ASN1Dict([
        ('character-encoding', _UniversalOrganizationName_character_encoding),
        ('iso-639-language-code', _UniversalOrganizationName_iso_639_language_code),
        ])
    UniversalOrganizationName._ext = None
    
    #-----< teletex-personal-name >-----#
    teletex_personal_name = CLASS(name='teletex-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexPersonalName')))
    teletex_personal_name._val = dict([('Type', _teletex_personal_name_val_Type), ('id', 4)])
    
    #-----< TeletexPersonalName >-----#
    TeletexPersonalName = SET(name='TeletexPersonalName', mode=MODE_TYPE)
    _TeletexPersonalName_surname = STR_TELE(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _TeletexPersonalName_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _TeletexPersonalName_given_name = STR_TELE(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _TeletexPersonalName_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _TeletexPersonalName_initials = STR_TELE(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _TeletexPersonalName_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _TeletexPersonalName_generation_qualifier = STR_TELE(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _TeletexPersonalName_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    TeletexPersonalName._cont = ASN1Dict([
        ('surname', _TeletexPersonalName_surname),
        ('given-name', _TeletexPersonalName_given_name),
        ('initials', _TeletexPersonalName_initials),
        ('generation-qualifier', _TeletexPersonalName_generation_qualifier),
        ])
    TeletexPersonalName._ext = None
    
    #-----< universal-personal-name >-----#
    universal_personal_name = CLASS(name='universal-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPersonalName')))
    universal_personal_name._val = dict([('Type', _universal_personal_name_val_Type), ('id', 26)])
    
    #-----< UniversalPersonalName >-----#
    UniversalPersonalName = SET(name='UniversalPersonalName', mode=MODE_TYPE)
    _UniversalPersonalName_surname = SET(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    __UniversalPersonalName_surname_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ___UniversalPersonalName_surname_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalPersonalName_surname_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_surname_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_surname_character_encoding_four_octets),
        ])
    __UniversalPersonalName_surname_character_encoding._ext = None
    __UniversalPersonalName_surname_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_surname_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_surname._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_surname_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_surname_iso_639_language_code),
        ])
    _UniversalPersonalName_surname._ext = None
    _UniversalPersonalName_given_name = SET(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_given_name_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    ___UniversalPersonalName_given_name_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    __UniversalPersonalName_given_name_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_given_name_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_given_name_character_encoding_four_octets),
        ])
    __UniversalPersonalName_given_name_character_encoding._ext = None
    __UniversalPersonalName_given_name_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_given_name_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_given_name._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_given_name_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_given_name_iso_639_language_code),
        ])
    _UniversalPersonalName_given_name._ext = None
    _UniversalPersonalName_initials = SET(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_initials_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___UniversalPersonalName_initials_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __UniversalPersonalName_initials_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_initials_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_initials_character_encoding_four_octets),
        ])
    __UniversalPersonalName_initials_character_encoding._ext = None
    __UniversalPersonalName_initials_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_initials_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_initials._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_initials_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_initials_iso_639_language_code),
        ])
    _UniversalPersonalName_initials._ext = None
    _UniversalPersonalName_generation_qualifier = SET(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_generation_qualifier_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __UniversalPersonalName_generation_qualifier_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets),
        ])
    __UniversalPersonalName_generation_qualifier_character_encoding._ext = None
    __UniversalPersonalName_generation_qualifier_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_generation_qualifier_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_generation_qualifier._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_generation_qualifier_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_generation_qualifier_iso_639_language_code),
        ])
    _UniversalPersonalName_generation_qualifier._ext = None
    UniversalPersonalName._cont = ASN1Dict([
        ('surname', _UniversalPersonalName_surname),
        ('given-name', _UniversalPersonalName_given_name),
        ('initials', _UniversalPersonalName_initials),
        ('generation-qualifier', _UniversalPersonalName_generation_qualifier),
        ])
    UniversalPersonalName._ext = None
    
    #-----< teletex-organizational-unit-names >-----#
    teletex_organizational_unit_names = CLASS(name='teletex-organizational-unit-names', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_organizational_unit_names_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitNames')))
    teletex_organizational_unit_names._val = dict([('Type', _teletex_organizational_unit_names_val_Type), ('id', 5)])
    
    #-----< TeletexOrganizationalUnitNames >-----#
    TeletexOrganizationalUnitNames = SEQ_OF(name='TeletexOrganizationalUnitNames', mode=MODE_TYPE)
    _TeletexOrganizationalUnitNames__item_ = STR_TELE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitName')))
    TeletexOrganizationalUnitNames._cont = _TeletexOrganizationalUnitNames__item_
    TeletexOrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TeletexOrganizationalUnitName >-----#
    TeletexOrganizationalUnitName = STR_TELE(name='TeletexOrganizationalUnitName', mode=MODE_TYPE)
    TeletexOrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< universal-organizational-unit-names >-----#
    universal_organizational_unit_names = CLASS(name='universal-organizational-unit-names', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_organizational_unit_names_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitNames')))
    universal_organizational_unit_names._val = dict([('Type', _universal_organizational_unit_names_val_Type), ('id', 27)])
    
    #-----< UniversalOrganizationalUnitNames >-----#
    UniversalOrganizationalUnitNames = SEQ_OF(name='UniversalOrganizationalUnitNames', mode=MODE_TYPE)
    _UniversalOrganizationalUnitNames__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitName')))
    UniversalOrganizationalUnitNames._cont = _UniversalOrganizationalUnitNames__item_
    UniversalOrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UniversalOrganizationalUnitName >-----#
    UniversalOrganizationalUnitName = SET(name='UniversalOrganizationalUnitName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalOrganizationalUnitName_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    __UniversalOrganizationalUnitName_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _UniversalOrganizationalUnitName_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalOrganizationalUnitName_character_encoding_two_octets),
        ('four-octets', __UniversalOrganizationalUnitName_character_encoding_four_octets),
        ])
    _UniversalOrganizationalUnitName_character_encoding._ext = None
    _UniversalOrganizationalUnitName_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalOrganizationalUnitName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalOrganizationalUnitName._cont = ASN1Dict([
        ('character-encoding', _UniversalOrganizationalUnitName_character_encoding),
        ('iso-639-language-code', _UniversalOrganizationalUnitName_iso_639_language_code),
        ])
    UniversalOrganizationalUnitName._ext = None
    
    #-----< UniversalOrBMPString >-----#
    UniversalOrBMPString = SET(name='UniversalOrBMPString', mode=MODE_TYPE, param=True)
    
    #-----< pds-name >-----#
    pds_name = CLASS(name='pds-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _pds_name_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSName')))
    pds_name._val = dict([('Type', _pds_name_val_Type), ('id', 7)])
    
    #-----< PDSName >-----#
    PDSName = STR_PRINT(name='PDSName', mode=MODE_TYPE)
    PDSName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< physical-delivery-country-name >-----#
    physical_delivery_country_name = CLASS(name='physical-delivery-country-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_country_name_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryCountryName')))
    physical_delivery_country_name._val = dict([('Type', _physical_delivery_country_name_val_Type), ('id', 8)])
    
    #-----< PhysicalDeliveryCountryName >-----#
    PhysicalDeliveryCountryName = CHOICE(name='PhysicalDeliveryCountryName', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _PhysicalDeliveryCountryName_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    PhysicalDeliveryCountryName._cont = ASN1Dict([
        ('x121-dcc-code', _PhysicalDeliveryCountryName_x121_dcc_code),
        ('iso-3166-alpha2-code', _PhysicalDeliveryCountryName_iso_3166_alpha2_code),
        ])
    PhysicalDeliveryCountryName._ext = None
    
    #-----< postal-code >-----#
    postal_code = CLASS(name='postal-code', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _postal_code_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostalCode')))
    postal_code._val = dict([('Type', _postal_code_val_Type), ('id', 9)])
    
    #-----< PostalCode >-----#
    PostalCode = CHOICE(name='PostalCode', mode=MODE_TYPE)
    _PostalCode_numeric_code = STR_NUM(name='numeric-code', mode=MODE_TYPE)
    _PostalCode_numeric_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PostalCode_printable_code = STR_PRINT(name='printable-code', mode=MODE_TYPE)
    _PostalCode_printable_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    PostalCode._cont = ASN1Dict([
        ('numeric-code', _PostalCode_numeric_code),
        ('printable-code', _PostalCode_printable_code),
        ])
    PostalCode._ext = None
    
    #-----< physical-delivery-office-name >-----#
    physical_delivery_office_name = CLASS(name='physical-delivery-office-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_office_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeName')))
    physical_delivery_office_name._val = dict([('Type', _physical_delivery_office_name_val_Type), ('id', 10)])
    
    #-----< PhysicalDeliveryOfficeName >-----#
    PhysicalDeliveryOfficeName = SET(name='PhysicalDeliveryOfficeName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-office-name >-----#
    universal_physical_delivery_office_name = CLASS(name='universal-physical-delivery-office-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_office_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeName')))
    universal_physical_delivery_office_name._val = dict([('Type', _universal_physical_delivery_office_name_val_Type), ('id', 29)])
    
    #-----< UniversalPhysicalDeliveryOfficeName >-----#
    UniversalPhysicalDeliveryOfficeName = SET(name='UniversalPhysicalDeliveryOfficeName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-office-number >-----#
    physical_delivery_office_number = CLASS(name='physical-delivery-office-number', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_office_number_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeNumber')))
    physical_delivery_office_number._val = dict([('Type', _physical_delivery_office_number_val_Type), ('id', 11)])
    
    #-----< PhysicalDeliveryOfficeNumber >-----#
    PhysicalDeliveryOfficeNumber = SET(name='PhysicalDeliveryOfficeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-office-number >-----#
    universal_physical_delivery_office_number = CLASS(name='universal-physical-delivery-office-number', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_office_number_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeNumber')))
    universal_physical_delivery_office_number._val = dict([('Type', _universal_physical_delivery_office_number_val_Type), ('id', 30)])
    
    #-----< UniversalPhysicalDeliveryOfficeNumber >-----#
    UniversalPhysicalDeliveryOfficeNumber = SET(name='UniversalPhysicalDeliveryOfficeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< extension-OR-address-components >-----#
    extension_OR_address_components = CLASS(name='extension-OR-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _extension_OR_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionORAddressComponents')))
    extension_OR_address_components._val = dict([('Type', _extension_OR_address_components_val_Type), ('id', 12)])
    
    #-----< ExtensionORAddressComponents >-----#
    ExtensionORAddressComponents = SET(name='ExtensionORAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-extension-OR-address-components >-----#
    universal_extension_OR_address_components = CLASS(name='universal-extension-OR-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_extension_OR_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionORAddressComponents')))
    universal_extension_OR_address_components._val = dict([('Type', _universal_extension_OR_address_components_val_Type), ('id', 31)])
    
    #-----< UniversalExtensionORAddressComponents >-----#
    UniversalExtensionORAddressComponents = SET(name='UniversalExtensionORAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-personal-name >-----#
    physical_delivery_personal_name = CLASS(name='physical-delivery-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryPersonalName')))
    physical_delivery_personal_name._val = dict([('Type', _physical_delivery_personal_name_val_Type), ('id', 13)])
    
    #-----< PhysicalDeliveryPersonalName >-----#
    PhysicalDeliveryPersonalName = SET(name='PhysicalDeliveryPersonalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-personal-name >-----#
    universal_physical_delivery_personal_name = CLASS(name='universal-physical-delivery-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryPersonalName')))
    universal_physical_delivery_personal_name._val = dict([('Type', _universal_physical_delivery_personal_name_val_Type), ('id', 32)])
    
    #-----< UniversalPhysicalDeliveryPersonalName >-----#
    UniversalPhysicalDeliveryPersonalName = SET(name='UniversalPhysicalDeliveryPersonalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-organization-name >-----#
    physical_delivery_organization_name = CLASS(name='physical-delivery-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_organization_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOrganizationName')))
    physical_delivery_organization_name._val = dict([('Type', _physical_delivery_organization_name_val_Type), ('id', 14)])
    
    #-----< PhysicalDeliveryOrganizationName >-----#
    PhysicalDeliveryOrganizationName = SET(name='PhysicalDeliveryOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-organization-name >-----#
    universal_physical_delivery_organization_name = CLASS(name='universal-physical-delivery-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_organization_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOrganizationName')))
    universal_physical_delivery_organization_name._val = dict([('Type', _universal_physical_delivery_organization_name_val_Type), ('id', 33)])
    
    #-----< UniversalPhysicalDeliveryOrganizationName >-----#
    UniversalPhysicalDeliveryOrganizationName = SET(name='UniversalPhysicalDeliveryOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< extension-physical-delivery-address-components >-----#
    extension_physical_delivery_address_components = CLASS(name='extension-physical-delivery-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _extension_physical_delivery_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionPhysicalDeliveryAddressComponents')))
    extension_physical_delivery_address_components._val = dict([('Type', _extension_physical_delivery_address_components_val_Type), ('id', 15)])
    
    #-----< ExtensionPhysicalDeliveryAddressComponents >-----#
    ExtensionPhysicalDeliveryAddressComponents = SET(name='ExtensionPhysicalDeliveryAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-extension-physical-delivery-address-components >-----#
    universal_extension_physical_delivery_address_components = CLASS(name='universal-extension-physical-delivery-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_extension_physical_delivery_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    universal_extension_physical_delivery_address_components._val = dict([('Type', _universal_extension_physical_delivery_address_components_val_Type), ('id', 34)])
    
    #-----< UniversalExtensionPhysicalDeliveryAddressComponents >-----#
    UniversalExtensionPhysicalDeliveryAddressComponents = SET(name='UniversalExtensionPhysicalDeliveryAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< unformatted-postal-address >-----#
    unformatted_postal_address = CLASS(name='unformatted-postal-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _unformatted_postal_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UnformattedPostalAddress')))
    unformatted_postal_address._val = dict([('Type', _unformatted_postal_address_val_Type), ('id', 16)])
    
    #-----< UnformattedPostalAddress >-----#
    UnformattedPostalAddress = SET(name='UnformattedPostalAddress', mode=MODE_TYPE)
    _UnformattedPostalAddress_printable_address = SEQ_OF(name='printable-address', mode=MODE_TYPE, opt=True)
    __UnformattedPostalAddress_printable_address__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE)
    __UnformattedPostalAddress_printable_address__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _UnformattedPostalAddress_printable_address._cont = __UnformattedPostalAddress_printable_address__item_
    _UnformattedPostalAddress_printable_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    _UnformattedPostalAddress_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    _UnformattedPostalAddress_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    UnformattedPostalAddress._cont = ASN1Dict([
        ('printable-address', _UnformattedPostalAddress_printable_address),
        ('teletex-string', _UnformattedPostalAddress_teletex_string),
        ])
    UnformattedPostalAddress._ext = None
    
    #-----< universal-unformatted-postal-address >-----#
    universal_unformatted_postal_address = CLASS(name='universal-unformatted-postal-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_unformatted_postal_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUnformattedPostalAddress')))
    universal_unformatted_postal_address._val = dict([('Type', _universal_unformatted_postal_address_val_Type), ('id', 35)])
    
    #-----< UniversalUnformattedPostalAddress >-----#
    UniversalUnformattedPostalAddress = SET(name='UniversalUnformattedPostalAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalUnformattedPostalAddress_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    __UniversalUnformattedPostalAddress_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    _UniversalUnformattedPostalAddress_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalUnformattedPostalAddress_character_encoding_two_octets),
        ('four-octets', __UniversalUnformattedPostalAddress_character_encoding_four_octets),
        ])
    _UniversalUnformattedPostalAddress_character_encoding._ext = None
    _UniversalUnformattedPostalAddress_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalUnformattedPostalAddress_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalUnformattedPostalAddress._cont = ASN1Dict([
        ('character-encoding', _UniversalUnformattedPostalAddress_character_encoding),
        ('iso-639-language-code', _UniversalUnformattedPostalAddress_iso_639_language_code),
        ])
    UniversalUnformattedPostalAddress._ext = None
    
    #-----< street-address >-----#
    street_address = CLASS(name='street-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _street_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'StreetAddress')))
    street_address._val = dict([('Type', _street_address_val_Type), ('id', 17)])
    
    #-----< StreetAddress >-----#
    StreetAddress = SET(name='StreetAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-street-address >-----#
    universal_street_address = CLASS(name='universal-street-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_street_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalStreetAddress')))
    universal_street_address._val = dict([('Type', _universal_street_address_val_Type), ('id', 36)])
    
    #-----< UniversalStreetAddress >-----#
    UniversalStreetAddress = SET(name='UniversalStreetAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< post-office-box-address >-----#
    post_office_box_address = CLASS(name='post-office-box-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _post_office_box_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostOfficeBoxAddress')))
    post_office_box_address._val = dict([('Type', _post_office_box_address_val_Type), ('id', 18)])
    
    #-----< PostOfficeBoxAddress >-----#
    PostOfficeBoxAddress = SET(name='PostOfficeBoxAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-post-office-box-address >-----#
    universal_post_office_box_address = CLASS(name='universal-post-office-box-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_post_office_box_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPostOfficeBoxAddress')))
    universal_post_office_box_address._val = dict([('Type', _universal_post_office_box_address_val_Type), ('id', 37)])
    
    #-----< UniversalPostOfficeBoxAddress >-----#
    UniversalPostOfficeBoxAddress = SET(name='UniversalPostOfficeBoxAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< poste-restante-address >-----#
    poste_restante_address = CLASS(name='poste-restante-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _poste_restante_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PosteRestanteAddress')))
    poste_restante_address._val = dict([('Type', _poste_restante_address_val_Type), ('id', 19)])
    
    #-----< PosteRestanteAddress >-----#
    PosteRestanteAddress = SET(name='PosteRestanteAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-poste-restante-address >-----#
    universal_poste_restante_address = CLASS(name='universal-poste-restante-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_poste_restante_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPosteRestanteAddress')))
    universal_poste_restante_address._val = dict([('Type', _universal_poste_restante_address_val_Type), ('id', 38)])
    
    #-----< UniversalPosteRestanteAddress >-----#
    UniversalPosteRestanteAddress = SET(name='UniversalPosteRestanteAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< unique-postal-name >-----#
    unique_postal_name = CLASS(name='unique-postal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _unique_postal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniquePostalName')))
    unique_postal_name._val = dict([('Type', _unique_postal_name_val_Type), ('id', 20)])
    
    #-----< UniquePostalName >-----#
    UniquePostalName = SET(name='UniquePostalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-unique-postal-name >-----#
    universal_unique_postal_name = CLASS(name='universal-unique-postal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_unique_postal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUniquePostalName')))
    universal_unique_postal_name._val = dict([('Type', _universal_unique_postal_name_val_Type), ('id', 39)])
    
    #-----< UniversalUniquePostalName >-----#
    UniversalUniquePostalName = SET(name='UniversalUniquePostalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< local-postal-attributes >-----#
    local_postal_attributes = CLASS(name='local-postal-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _local_postal_attributes_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'LocalPostalAttributes')))
    local_postal_attributes._val = dict([('Type', _local_postal_attributes_val_Type), ('id', 21)])
    
    #-----< LocalPostalAttributes >-----#
    LocalPostalAttributes = SET(name='LocalPostalAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-local-postal-attributes >-----#
    universal_local_postal_attributes = CLASS(name='universal-local-postal-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_local_postal_attributes_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalLocalPostalAttributes')))
    universal_local_postal_attributes._val = dict([('Type', _universal_local_postal_attributes_val_Type), ('id', 40)])
    
    #-----< UniversalLocalPostalAttributes >-----#
    UniversalLocalPostalAttributes = SET(name='UniversalLocalPostalAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< PDSParameter >-----#
    PDSParameter = SET(name='PDSParameter', mode=MODE_TYPE)
    _PDSParameter_printable_string = STR_PRINT(name='printable-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_printable_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _PDSParameter_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    PDSParameter._cont = ASN1Dict([
        ('printable-string', _PDSParameter_printable_string),
        ('teletex-string', _PDSParameter_teletex_string),
        ])
    PDSParameter._ext = None
    
    #-----< UniversalPDSParameter >-----#
    UniversalPDSParameter = SET(name='UniversalPDSParameter', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalPDSParameter_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __UniversalPDSParameter_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _UniversalPDSParameter_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalPDSParameter_character_encoding_two_octets),
        ('four-octets', __UniversalPDSParameter_character_encoding_four_octets),
        ])
    _UniversalPDSParameter_character_encoding._ext = None
    _UniversalPDSParameter_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalPDSParameter_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalPDSParameter._cont = ASN1Dict([
        ('character-encoding', _UniversalPDSParameter_character_encoding),
        ('iso-639-language-code', _UniversalPDSParameter_iso_639_language_code),
        ])
    UniversalPDSParameter._ext = None
    
    #-----< extended-network-address >-----#
    extended_network_address = CLASS(name='extended-network-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _extended_network_address_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtendedNetworkAddress')))
    extended_network_address._val = dict([('Type', _extended_network_address_val_Type), ('id', 22)])
    
    #-----< ExtendedNetworkAddress >-----#
    ExtendedNetworkAddress = CHOICE(name='ExtendedNetworkAddress', mode=MODE_TYPE)
    _ExtendedNetworkAddress_e163_4_address = SEQ(name='e163-4-address', mode=MODE_TYPE)
    __ExtendedNetworkAddress_e163_4_address_number = STR_NUM(name='number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ExtendedNetworkAddress_e163_4_address_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    __ExtendedNetworkAddress_e163_4_address_sub_address = STR_NUM(name='sub-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ExtendedNetworkAddress_e163_4_address_sub_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _ExtendedNetworkAddress_e163_4_address._cont = ASN1Dict([
        ('number', __ExtendedNetworkAddress_e163_4_address_number),
        ('sub-address', __ExtendedNetworkAddress_e163_4_address_sub_address),
        ])
    _ExtendedNetworkAddress_e163_4_address._ext = None
    _ExtendedNetworkAddress_psap_address = SEQ(name='psap-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    ExtendedNetworkAddress._cont = ASN1Dict([
        ('e163-4-address', _ExtendedNetworkAddress_e163_4_address),
        ('psap-address', _ExtendedNetworkAddress_psap_address),
        ])
    ExtendedNetworkAddress._ext = None
    
    #-----< terminal-type >-----#
    terminal_type = CLASS(name='terminal-type', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _terminal_type_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalType')))
    terminal_type._val = dict([('Type', _terminal_type_val_Type), ('id', 23)])
    
    #-----< TerminalType >-----#
    TerminalType = INT(name='TerminalType', mode=MODE_TYPE)
    TerminalType._cont = ASN1Dict([('telex', 3), ('teletex', 4), ('g3-facsimile', 5), ('g4-facsimile', 6), ('ia5-terminal', 7), ('videotex', 8)])
    TerminalType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< teletex-domain-defined-attributes >-----#
    teletex_domain_defined_attributes = CLASS(name='teletex-domain-defined-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_domain_defined_attributes_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttributes')))
    teletex_domain_defined_attributes._val = dict([('Type', _teletex_domain_defined_attributes_val_Type), ('id', 6)])
    
    #-----< TeletexDomainDefinedAttributes >-----#
    TeletexDomainDefinedAttributes = SEQ_OF(name='TeletexDomainDefinedAttributes', mode=MODE_TYPE)
    _TeletexDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttribute')))
    TeletexDomainDefinedAttributes._cont = _TeletexDomainDefinedAttributes__item_
    TeletexDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TeletexDomainDefinedAttribute >-----#
    TeletexDomainDefinedAttribute = SEQ(name='TeletexDomainDefinedAttribute', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type = STR_TELE(name='type', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _TeletexDomainDefinedAttribute_value = STR_TELE(name='value', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    TeletexDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _TeletexDomainDefinedAttribute_type),
        ('value', _TeletexDomainDefinedAttribute_value),
        ])
    TeletexDomainDefinedAttribute._ext = None
    
    #-----< universal-domain-defined-attributes >-----#
    universal_domain_defined_attributes = CLASS(name='universal-domain-defined-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_domain_defined_attributes_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttributes')))
    universal_domain_defined_attributes._val = dict([('Type', _universal_domain_defined_attributes_val_Type), ('id', 28)])
    
    #-----< UniversalDomainDefinedAttributes >-----#
    UniversalDomainDefinedAttributes = SEQ_OF(name='UniversalDomainDefinedAttributes', mode=MODE_TYPE)
    _UniversalDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttribute')))
    UniversalDomainDefinedAttributes._cont = _UniversalDomainDefinedAttributes__item_
    UniversalDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UniversalDomainDefinedAttribute >-----#
    UniversalDomainDefinedAttribute = SEQ(name='UniversalDomainDefinedAttribute', mode=MODE_TYPE)
    _UniversalDomainDefinedAttribute_type = SET(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    __UniversalDomainDefinedAttribute_type_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    __UniversalDomainDefinedAttribute_type_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets),
        ('four-octets', ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets),
        ])
    __UniversalDomainDefinedAttribute_type_character_encoding._ext = None
    __UniversalDomainDefinedAttribute_type_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalDomainDefinedAttribute_type_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalDomainDefinedAttribute_type._cont = ASN1Dict([
        ('character-encoding', __UniversalDomainDefinedAttribute_type_character_encoding),
        ('iso-639-language-code', __UniversalDomainDefinedAttribute_type_iso_639_language_code),
        ])
    _UniversalDomainDefinedAttribute_type._ext = None
    _UniversalDomainDefinedAttribute_value = SET(name='value', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    __UniversalDomainDefinedAttribute_value_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __UniversalDomainDefinedAttribute_value_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets),
        ('four-octets', ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets),
        ])
    __UniversalDomainDefinedAttribute_value_character_encoding._ext = None
    __UniversalDomainDefinedAttribute_value_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalDomainDefinedAttribute_value_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalDomainDefinedAttribute_value._cont = ASN1Dict([
        ('character-encoding', __UniversalDomainDefinedAttribute_value_character_encoding),
        ('iso-639-language-code', __UniversalDomainDefinedAttribute_value_iso_639_language_code),
        ])
    _UniversalDomainDefinedAttribute_value._ext = None
    UniversalDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _UniversalDomainDefinedAttribute_type),
        ('value', _UniversalDomainDefinedAttribute_value),
        ])
    UniversalDomainDefinedAttribute._ext = None
    
    #-----< ub-integer-options >-----#
    ub_integer_options = INT(name='ub-integer-options', mode=MODE_VALUE)
    ub_integer_options._val = 256
    
    #-----< ub-e163-4-number-length >-----#
    ub_e163_4_number_length = INT(name='ub-e163-4-number-length', mode=MODE_VALUE)
    ub_e163_4_number_length._val = 15
    
    #-----< ub-e163-4-sub-address-length >-----#
    ub_e163_4_sub_address_length = INT(name='ub-e163-4-sub-address-length', mode=MODE_VALUE)
    ub_e163_4_sub_address_length._val = 40
    
    #-----< ub-unformatted-address-length >-----#
    ub_unformatted_address_length = INT(name='ub-unformatted-address-length', mode=MODE_VALUE)
    ub_unformatted_address_length._val = 180
    
    #-----< ub-pds-parameter-length >-----#
    ub_pds_parameter_length = INT(name='ub-pds-parameter-length', mode=MODE_VALUE)
    ub_pds_parameter_length._val = 30
    
    #-----< ub-pds-physical-address-lines >-----#
    ub_pds_physical_address_lines = INT(name='ub-pds-physical-address-lines', mode=MODE_VALUE)
    ub_pds_physical_address_lines._val = 6
    
    #-----< ub-postal-code-length >-----#
    ub_postal_code_length = INT(name='ub-postal-code-length', mode=MODE_VALUE)
    ub_postal_code_length._val = 16
    
    #-----< ub-pds-name-length >-----#
    ub_pds_name_length = INT(name='ub-pds-name-length', mode=MODE_VALUE)
    ub_pds_name_length._val = 16
    
    #-----< ub-universal-surname-length >-----#
    ub_universal_surname_length = INT(name='ub-universal-surname-length', mode=MODE_VALUE)
    ub_universal_surname_length._val = 64
    
    #-----< ub-universal-given-name-length >-----#
    ub_universal_given_name_length = INT(name='ub-universal-given-name-length', mode=MODE_VALUE)
    ub_universal_given_name_length._val = 40
    
    #-----< ub-universal-initials-length >-----#
    ub_universal_initials_length = INT(name='ub-universal-initials-length', mode=MODE_VALUE)
    ub_universal_initials_length._val = 16
    
    #-----< ub-universal-generation-qualifier-length >-----#
    ub_universal_generation_qualifier_length = INT(name='ub-universal-generation-qualifier-length', mode=MODE_VALUE)
    ub_universal_generation_qualifier_length._val = 16
    
    #-----< ub-common-name-length >-----#
    ub_common_name_length = INT(name='ub-common-name-length', mode=MODE_VALUE)
    ub_common_name_length._val = 64
    
    #-----< ub-extension-attributes >-----#
    ub_extension_attributes = INT(name='ub-extension-attributes', mode=MODE_VALUE)
    ub_extension_attributes._val = 256
    
    #-----< ub-domain-defined-attribute-type-length >-----#
    ub_domain_defined_attribute_type_length = INT(name='ub-domain-defined-attribute-type-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_type_length._val = 8
    
    #-----< ub-domain-defined-attribute-value-length >-----#
    ub_domain_defined_attribute_value_length = INT(name='ub-domain-defined-attribute-value-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_value_length._val = 128
    
    #-----< ub-domain-defined-attributes >-----#
    ub_domain_defined_attributes = INT(name='ub-domain-defined-attributes', mode=MODE_VALUE)
    ub_domain_defined_attributes._val = 4
    
    #-----< ub-organizational-unit-name-length >-----#
    ub_organizational_unit_name_length = INT(name='ub-organizational-unit-name-length', mode=MODE_VALUE)
    ub_organizational_unit_name_length._val = 32
    
    #-----< ub-organizational-units >-----#
    ub_organizational_units = INT(name='ub-organizational-units', mode=MODE_VALUE)
    ub_organizational_units._val = 4
    
    #-----< ub-generation-qualifier-length >-----#
    ub_generation_qualifier_length = INT(name='ub-generation-qualifier-length', mode=MODE_VALUE)
    ub_generation_qualifier_length._val = 3
    
    #-----< ub-initials-length >-----#
    ub_initials_length = INT(name='ub-initials-length', mode=MODE_VALUE)
    ub_initials_length._val = 5
    
    #-----< ub-given-name-length >-----#
    ub_given_name_length = INT(name='ub-given-name-length', mode=MODE_VALUE)
    ub_given_name_length._val = 16
    
    #-----< ub-surname-length >-----#
    ub_surname_length = INT(name='ub-surname-length', mode=MODE_VALUE)
    ub_surname_length._val = 40
    
    #-----< ub-numeric-user-id-length >-----#
    ub_numeric_user_id_length = INT(name='ub-numeric-user-id-length', mode=MODE_VALUE)
    ub_numeric_user_id_length._val = 32
    
    #-----< ub-organization-name-length >-----#
    ub_organization_name_length = INT(name='ub-organization-name-length', mode=MODE_VALUE)
    ub_organization_name_length._val = 64
    
    #-----< ub-terminal-id-length >-----#
    ub_terminal_id_length = INT(name='ub-terminal-id-length', mode=MODE_VALUE)
    ub_terminal_id_length._val = 24
    
    #-----< ub-x121-address-length >-----#
    ub_x121_address_length = INT(name='ub-x121-address-length', mode=MODE_VALUE)
    ub_x121_address_length._val = 16
    
    #-----< ub-domain-name-length >-----#
    ub_domain_name_length = INT(name='ub-domain-name-length', mode=MODE_VALUE)
    ub_domain_name_length._val = 16
    
    #-----< ub-country-name-alpha-length >-----#
    ub_country_name_alpha_length = INT(name='ub-country-name-alpha-length', mode=MODE_VALUE)
    ub_country_name_alpha_length._val = 2
    
    #-----< ub-country-name-numeric-length >-----#
    ub_country_name_numeric_length = INT(name='ub-country-name-numeric-length', mode=MODE_VALUE)
    ub_country_name_numeric_length._val = 3
    
    _all_ = [
        _UserNotice_noticeRef,
        _UserNotice_explicitText,
        UserNotice,
        _NoticeReference_organization,
        __NoticeReference_noticeNumbers__item_,
        _NoticeReference_noticeNumbers,
        NoticeReference,
        _DisplayText_visibleString,
        _DisplayText_bmpString,
        _DisplayText_utf8String,
        DisplayText,
        authorityInfoAccess,
        _authorityInfoAccess_val_ExtnType,
        _AuthorityInfoAccessSyntax__item_,
        AuthorityInfoAccessSyntax,
        _AccessDescription_accessMethod,
        _AccessDescription_accessLocation,
        AccessDescription,
        subjectInfoAccess,
        _subjectInfoAccess_val_ExtnType,
        _SubjectInfoAccessSyntax__item_,
        SubjectInfoAccessSyntax,
        id_pkix,
        id_pe,
        id_ad,
        id_pe_authorityInfoAccess,
        id_pe_subjectInfoAccess,
        id_ad_caIssuers,
        id_ad_ocsp,
        G3FacsimileNonBasicParameters,
        _ORAddress_built_in_standard_attributes,
        _ORAddress_built_in_domain_defined_attributes,
        _ORAddress_extension_attributes,
        ORAddress,
        _BuiltInStandardAttributes_country_name,
        _BuiltInStandardAttributes_administration_domain_name,
        _BuiltInStandardAttributes_network_address,
        _BuiltInStandardAttributes_terminal_identifier,
        _BuiltInStandardAttributes_private_domain_name,
        _BuiltInStandardAttributes_organization_name,
        _BuiltInStandardAttributes_numeric_user_identifier,
        _BuiltInStandardAttributes_personal_name,
        _BuiltInStandardAttributes_organizational_unit_names,
        BuiltInStandardAttributes,
        _CountryName_x121_dcc_code,
        _CountryName_iso_3166_alpha2_code,
        CountryName,
        _AdministrationDomainName_numeric,
        _AdministrationDomainName_printable,
        AdministrationDomainName,
        NetworkAddress,
        X121Address,
        TerminalIdentifier,
        _PrivateDomainName_numeric,
        _PrivateDomainName_printable,
        PrivateDomainName,
        OrganizationName,
        NumericUserIdentifier,
        _PersonalName_surname,
        _PersonalName_given_name,
        _PersonalName_initials,
        _PersonalName_generation_qualifier,
        PersonalName,
        _OrganizationalUnitNames__item_,
        OrganizationalUnitNames,
        OrganizationalUnitName,
        _BuiltInDomainDefinedAttributes__item_,
        BuiltInDomainDefinedAttributes,
        _BuiltInDomainDefinedAttribute_type,
        _BuiltInDomainDefinedAttribute_value,
        BuiltInDomainDefinedAttribute,
        _ExtensionAttributes__item_,
        ExtensionAttributes,
        __ExtensionAttribute_extension_attribute_type_tab,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39,
        _ExtensionAttribute_extension_attribute_type,
        _ExtensionAttribute_extension_attribute_value,
        ExtensionAttribute,
        _EXTENSION_ATTRIBUTE_id,
        _EXTENSION_ATTRIBUTE_Type,
        EXTENSION_ATTRIBUTE,
        ExtensionAttributeTable,
        _ExtensionAttributeTable_val_Type_0,
        _ExtensionAttributeTable_val_Type_1,
        _ExtensionAttributeTable_val_Type_2,
        _ExtensionAttributeTable_val_Type_3,
        _ExtensionAttributeTable_val_Type_4,
        _ExtensionAttributeTable_val_Type_5,
        _ExtensionAttributeTable_val_Type_6,
        _ExtensionAttributeTable_val_Type_7,
        _ExtensionAttributeTable_val_Type_8,
        _ExtensionAttributeTable_val_Type_9,
        _ExtensionAttributeTable_val_Type_10,
        _ExtensionAttributeTable_val_Type_11,
        _ExtensionAttributeTable_val_Type_12,
        _ExtensionAttributeTable_val_Type_13,
        _ExtensionAttributeTable_val_Type_14,
        _ExtensionAttributeTable_val_Type_15,
        _ExtensionAttributeTable_val_Type_16,
        _ExtensionAttributeTable_val_Type_17,
        _ExtensionAttributeTable_val_Type_18,
        _ExtensionAttributeTable_val_Type_19,
        _ExtensionAttributeTable_val_Type_20,
        _ExtensionAttributeTable_val_Type_21,
        _ExtensionAttributeTable_val_Type_22,
        _ExtensionAttributeTable_val_Type_23,
        _ExtensionAttributeTable_val_Type_24,
        _ExtensionAttributeTable_val_Type_25,
        _ExtensionAttributeTable_val_Type_26,
        _ExtensionAttributeTable_val_Type_27,
        _ExtensionAttributeTable_val_Type_28,
        _ExtensionAttributeTable_val_Type_29,
        _ExtensionAttributeTable_val_Type_30,
        _ExtensionAttributeTable_val_Type_31,
        _ExtensionAttributeTable_val_Type_32,
        _ExtensionAttributeTable_val_Type_33,
        _ExtensionAttributeTable_val_Type_34,
        _ExtensionAttributeTable_val_Type_35,
        _ExtensionAttributeTable_val_Type_36,
        _ExtensionAttributeTable_val_Type_37,
        _ExtensionAttributeTable_val_Type_38,
        _ExtensionAttributeTable_val_Type_39,
        common_name,
        _common_name_val_Type,
        CommonName,
        teletex_common_name,
        _teletex_common_name_val_Type,
        TeletexCommonName,
        universal_common_name,
        _universal_common_name_val_Type,
        __UniversalCommonName_character_encoding_two_octets,
        __UniversalCommonName_character_encoding_four_octets,
        _UniversalCommonName_character_encoding,
        _UniversalCommonName_iso_639_language_code,
        UniversalCommonName,
        teletex_organization_name,
        _teletex_organization_name_val_Type,
        TeletexOrganizationName,
        universal_organization_name,
        _universal_organization_name_val_Type,
        __UniversalOrganizationName_character_encoding_two_octets,
        __UniversalOrganizationName_character_encoding_four_octets,
        _UniversalOrganizationName_character_encoding,
        _UniversalOrganizationName_iso_639_language_code,
        UniversalOrganizationName,
        teletex_personal_name,
        _teletex_personal_name_val_Type,
        _TeletexPersonalName_surname,
        _TeletexPersonalName_given_name,
        _TeletexPersonalName_initials,
        _TeletexPersonalName_generation_qualifier,
        TeletexPersonalName,
        universal_personal_name,
        _universal_personal_name_val_Type,
        ___UniversalPersonalName_surname_character_encoding_two_octets,
        ___UniversalPersonalName_surname_character_encoding_four_octets,
        __UniversalPersonalName_surname_character_encoding,
        __UniversalPersonalName_surname_iso_639_language_code,
        _UniversalPersonalName_surname,
        ___UniversalPersonalName_given_name_character_encoding_two_octets,
        ___UniversalPersonalName_given_name_character_encoding_four_octets,
        __UniversalPersonalName_given_name_character_encoding,
        __UniversalPersonalName_given_name_iso_639_language_code,
        _UniversalPersonalName_given_name,
        ___UniversalPersonalName_initials_character_encoding_two_octets,
        ___UniversalPersonalName_initials_character_encoding_four_octets,
        __UniversalPersonalName_initials_character_encoding,
        __UniversalPersonalName_initials_iso_639_language_code,
        _UniversalPersonalName_initials,
        ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets,
        ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets,
        __UniversalPersonalName_generation_qualifier_character_encoding,
        __UniversalPersonalName_generation_qualifier_iso_639_language_code,
        _UniversalPersonalName_generation_qualifier,
        UniversalPersonalName,
        teletex_organizational_unit_names,
        _teletex_organizational_unit_names_val_Type,
        _TeletexOrganizationalUnitNames__item_,
        TeletexOrganizationalUnitNames,
        TeletexOrganizationalUnitName,
        universal_organizational_unit_names,
        _universal_organizational_unit_names_val_Type,
        _UniversalOrganizationalUnitNames__item_,
        UniversalOrganizationalUnitNames,
        __UniversalOrganizationalUnitName_character_encoding_two_octets,
        __UniversalOrganizationalUnitName_character_encoding_four_octets,
        _UniversalOrganizationalUnitName_character_encoding,
        _UniversalOrganizationalUnitName_iso_639_language_code,
        UniversalOrganizationalUnitName,
        pds_name,
        _pds_name_val_Type,
        PDSName,
        physical_delivery_country_name,
        _physical_delivery_country_name_val_Type,
        _PhysicalDeliveryCountryName_x121_dcc_code,
        _PhysicalDeliveryCountryName_iso_3166_alpha2_code,
        PhysicalDeliveryCountryName,
        postal_code,
        _postal_code_val_Type,
        _PostalCode_numeric_code,
        _PostalCode_printable_code,
        PostalCode,
        physical_delivery_office_name,
        _physical_delivery_office_name_val_Type,
        PhysicalDeliveryOfficeName,
        universal_physical_delivery_office_name,
        _universal_physical_delivery_office_name_val_Type,
        UniversalPhysicalDeliveryOfficeName,
        physical_delivery_office_number,
        _physical_delivery_office_number_val_Type,
        PhysicalDeliveryOfficeNumber,
        universal_physical_delivery_office_number,
        _universal_physical_delivery_office_number_val_Type,
        UniversalPhysicalDeliveryOfficeNumber,
        extension_OR_address_components,
        _extension_OR_address_components_val_Type,
        ExtensionORAddressComponents,
        universal_extension_OR_address_components,
        _universal_extension_OR_address_components_val_Type,
        UniversalExtensionORAddressComponents,
        physical_delivery_personal_name,
        _physical_delivery_personal_name_val_Type,
        PhysicalDeliveryPersonalName,
        universal_physical_delivery_personal_name,
        _universal_physical_delivery_personal_name_val_Type,
        UniversalPhysicalDeliveryPersonalName,
        physical_delivery_organization_name,
        _physical_delivery_organization_name_val_Type,
        PhysicalDeliveryOrganizationName,
        universal_physical_delivery_organization_name,
        _universal_physical_delivery_organization_name_val_Type,
        UniversalPhysicalDeliveryOrganizationName,
        extension_physical_delivery_address_components,
        _extension_physical_delivery_address_components_val_Type,
        ExtensionPhysicalDeliveryAddressComponents,
        universal_extension_physical_delivery_address_components,
        _universal_extension_physical_delivery_address_components_val_Type,
        UniversalExtensionPhysicalDeliveryAddressComponents,
        unformatted_postal_address,
        _unformatted_postal_address_val_Type,
        __UnformattedPostalAddress_printable_address__item_,
        _UnformattedPostalAddress_printable_address,
        _UnformattedPostalAddress_teletex_string,
        UnformattedPostalAddress,
        universal_unformatted_postal_address,
        _universal_unformatted_postal_address_val_Type,
        __UniversalUnformattedPostalAddress_character_encoding_two_octets,
        __UniversalUnformattedPostalAddress_character_encoding_four_octets,
        _UniversalUnformattedPostalAddress_character_encoding,
        _UniversalUnformattedPostalAddress_iso_639_language_code,
        UniversalUnformattedPostalAddress,
        street_address,
        _street_address_val_Type,
        StreetAddress,
        universal_street_address,
        _universal_street_address_val_Type,
        UniversalStreetAddress,
        post_office_box_address,
        _post_office_box_address_val_Type,
        PostOfficeBoxAddress,
        universal_post_office_box_address,
        _universal_post_office_box_address_val_Type,
        UniversalPostOfficeBoxAddress,
        poste_restante_address,
        _poste_restante_address_val_Type,
        PosteRestanteAddress,
        universal_poste_restante_address,
        _universal_poste_restante_address_val_Type,
        UniversalPosteRestanteAddress,
        unique_postal_name,
        _unique_postal_name_val_Type,
        UniquePostalName,
        universal_unique_postal_name,
        _universal_unique_postal_name_val_Type,
        UniversalUniquePostalName,
        local_postal_attributes,
        _local_postal_attributes_val_Type,
        LocalPostalAttributes,
        universal_local_postal_attributes,
        _universal_local_postal_attributes_val_Type,
        UniversalLocalPostalAttributes,
        _PDSParameter_printable_string,
        _PDSParameter_teletex_string,
        PDSParameter,
        __UniversalPDSParameter_character_encoding_two_octets,
        __UniversalPDSParameter_character_encoding_four_octets,
        _UniversalPDSParameter_character_encoding,
        _UniversalPDSParameter_iso_639_language_code,
        UniversalPDSParameter,
        extended_network_address,
        _extended_network_address_val_Type,
        __ExtendedNetworkAddress_e163_4_address_number,
        __ExtendedNetworkAddress_e163_4_address_sub_address,
        _ExtendedNetworkAddress_e163_4_address,
        _ExtendedNetworkAddress_psap_address,
        ExtendedNetworkAddress,
        terminal_type,
        _terminal_type_val_Type,
        TerminalType,
        teletex_domain_defined_attributes,
        _teletex_domain_defined_attributes_val_Type,
        _TeletexDomainDefinedAttributes__item_,
        TeletexDomainDefinedAttributes,
        _TeletexDomainDefinedAttribute_type,
        _TeletexDomainDefinedAttribute_value,
        TeletexDomainDefinedAttribute,
        universal_domain_defined_attributes,
        _universal_domain_defined_attributes_val_Type,
        _UniversalDomainDefinedAttributes__item_,
        UniversalDomainDefinedAttributes,
        ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets,
        ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets,
        __UniversalDomainDefinedAttribute_type_character_encoding,
        __UniversalDomainDefinedAttribute_type_iso_639_language_code,
        _UniversalDomainDefinedAttribute_type,
        ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets,
        ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets,
        __UniversalDomainDefinedAttribute_value_character_encoding,
        __UniversalDomainDefinedAttribute_value_iso_639_language_code,
        _UniversalDomainDefinedAttribute_value,
        UniversalDomainDefinedAttribute,
        ub_integer_options,
        ub_e163_4_number_length,
        ub_e163_4_sub_address_length,
        ub_unformatted_address_length,
        ub_pds_parameter_length,
        ub_pds_physical_address_lines,
        ub_postal_code_length,
        ub_pds_name_length,
        ub_universal_surname_length,
        ub_universal_given_name_length,
        ub_universal_initials_length,
        ub_universal_generation_qualifier_length,
        ub_common_name_length,
        ub_extension_attributes,
        ub_domain_defined_attribute_type_length,
        ub_domain_defined_attribute_value_length,
        ub_domain_defined_attributes,
        ub_organizational_unit_name_length,
        ub_organizational_units,
        ub_generation_qualifier_length,
        ub_initials_length,
        ub_given_name_length,
        ub_surname_length,
        ub_numeric_user_id_length,
        ub_organization_name_length,
        ub_terminal_id_length,
        ub_x121_address_length,
        ub_domain_name_length,
        ub_country_name_alpha_length,
        ub_country_name_numeric_length,
    ]

class POCChargingDataTypes:

    _name_  = 'POCChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 7, 0, 1]
    
    _obj_ = [
        'POCRecord',
        'PPFRecord',
        'CPFRecord',
        'AccessPriority',
        'CauseForRecordClosing',
        'ChangeCondition',
        'ListofTalkBurstExchange',
        'ParticipatingType',
        'POCEventType',
        'POCInformation',
        'POCParticipant',
        'POCSessionInitType',
        'POCSessionType',
        ]
    _type_ = [
        'POCRecord',
        'PPFRecord',
        'CPFRecord',
        'AccessPriority',
        'CauseForRecordClosing',
        'ChangeCondition',
        'ListofTalkBurstExchange',
        'ParticipatingType',
        'POCEventType',
        'POCInformation',
        'POCParticipant',
        'POCSessionInitType',
        'POCSessionType',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< POCRecord >-----#
    POCRecord = CHOICE(name='POCRecord', mode=MODE_TYPE)
    _POCRecord_pPFRecord = SET(name='pPFRecord', mode=MODE_TYPE, tag=(80, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'PPFRecord')))
    _POCRecord_cPFRecord = SET(name='cPFRecord', mode=MODE_TYPE, tag=(81, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'CPFRecord')))
    POCRecord._cont = ASN1Dict([
        ('pPFRecord', _POCRecord_pPFRecord),
        ('cPFRecord', _POCRecord_cPFRecord),
        ])
    POCRecord._ext = None
    
    #-----< PPFRecord >-----#
    PPFRecord = SET(name='PPFRecord', mode=MODE_TYPE)
    _PPFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PPFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _PPFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PPFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _PPFRecord_calling_Party_Address = CHOICE(name='calling-Party-Address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _PPFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _PPFRecord_servedParty = STR_GRAPH(name='servedParty', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _PPFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _PPFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _PPFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _PPFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PPFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PPFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _PPFRecord_list_Of_SDP_Media_Components._cont = __PPFRecord_list_Of_SDP_Media_Components__item_
    _PPFRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PPFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PPFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _PPFRecord_list_Of_Message_Bodies._cont = __PPFRecord_list_Of_Message_Bodies__item_
    _PPFRecord_userLocationInfo = OCT_STR(name='userLocationInfo', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_poCInformation = SET(name='poCInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCInformation')), opt=True)
    _PPFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PPFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    PPFRecord._cont = ASN1Dict([
        ('recordType', _PPFRecord_recordType),
        ('retransmission', _PPFRecord_retransmission),
        ('sIP-Method', _PPFRecord_sIP_Method),
        ('nodeAddress', _PPFRecord_nodeAddress),
        ('session-Id', _PPFRecord_session_Id),
        ('calling-Party-Address', _PPFRecord_calling_Party_Address),
        ('called-Party-Address', _PPFRecord_called_Party_Address),
        ('servedParty', _PPFRecord_servedParty),
        ('serviceRequestTimeStamp', _PPFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _PPFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _PPFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _PPFRecord_recordOpeningTime),
        ('recordClosureTime', _PPFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _PPFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _PPFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _PPFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _PPFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _PPFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _PPFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _PPFRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _PPFRecord_gGSNaddress),
        ('serviceReasonReturnCode', _PPFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _PPFRecord_list_Of_Message_Bodies),
        ('userLocationInfo', _PPFRecord_userLocationInfo),
        ('poCInformation', _PPFRecord_poCInformation),
        ('recordExtensions', _PPFRecord_recordExtensions),
        ('serviceContextID', _PPFRecord_serviceContextID),
        ])
    PPFRecord._ext = None
    
    #-----< CPFRecord >-----#
    CPFRecord = SET(name='CPFRecord', mode=MODE_TYPE)
    _CPFRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CPFRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_sIP_Method = STR_GRAPH(name='sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _CPFRecord_nodeAddress = CHOICE(name='nodeAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _CPFRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _CPFRecord_calling_Party_Address = CHOICE(name='calling-Party-Address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CPFRecord_called_Party_Address = CHOICE(name='called-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CPFRecord_servedParty = STR_GRAPH(name='servedParty', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_serviceRequestTimeStamp = OCT_STR(name='serviceRequestTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name='serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name='serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_interOperatorIdentifiers = SEQ(name='interOperatorIdentifiers', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _CPFRecord_localRecordSequenceNumber = INT(name='localRecordSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CPFRecord_recordSequenceNumber = INT(name='recordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_causeForRecordClosing = ENUM(name='causeForRecordClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _CPFRecord_incomplete_CDR_Indication = SET(name='incomplete-CDR-Indication', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _CPFRecord_iMS_Charging_Identifier = OCT_STR(name='iMS-Charging-Identifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _CPFRecord_list_Of_SDP_Media_Components = SEQ_OF(name='list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _CPFRecord_list_Of_SDP_Media_Components._cont = __CPFRecord_list_Of_SDP_Media_Components__item_
    _CPFRecord_gGSNaddress = CHOICE(name='gGSNaddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _CPFRecord_serviceReasonReturnCode = STR_UTF8(name='serviceReasonReturnCode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_list_Of_Message_Bodies = SEQ_OF(name='list-Of-Message-Bodies', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _CPFRecord_list_Of_Message_Bodies._cont = __CPFRecord_list_Of_Message_Bodies__item_
    _CPFRecord_userLocationInfo = OCT_STR(name='userLocationInfo', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_poCInformation = SET(name='poCInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCInformation')), opt=True)
    _CPFRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CPFRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    CPFRecord._cont = ASN1Dict([
        ('recordType', _CPFRecord_recordType),
        ('retransmission', _CPFRecord_retransmission),
        ('sIP-Method', _CPFRecord_sIP_Method),
        ('nodeAddress', _CPFRecord_nodeAddress),
        ('session-Id', _CPFRecord_session_Id),
        ('calling-Party-Address', _CPFRecord_calling_Party_Address),
        ('called-Party-Address', _CPFRecord_called_Party_Address),
        ('servedParty', _CPFRecord_servedParty),
        ('serviceRequestTimeStamp', _CPFRecord_serviceRequestTimeStamp),
        ('serviceDeliveryStartTimeStamp', _CPFRecord_serviceDeliveryStartTimeStamp),
        ('serviceDeliveryEndTimeStamp', _CPFRecord_serviceDeliveryEndTimeStamp),
        ('recordOpeningTime', _CPFRecord_recordOpeningTime),
        ('recordClosureTime', _CPFRecord_recordClosureTime),
        ('interOperatorIdentifiers', _CPFRecord_interOperatorIdentifiers),
        ('localRecordSequenceNumber', _CPFRecord_localRecordSequenceNumber),
        ('recordSequenceNumber', _CPFRecord_recordSequenceNumber),
        ('causeForRecordClosing', _CPFRecord_causeForRecordClosing),
        ('incomplete-CDR-Indication', _CPFRecord_incomplete_CDR_Indication),
        ('iMS-Charging-Identifier', _CPFRecord_iMS_Charging_Identifier),
        ('list-Of-SDP-Media-Components', _CPFRecord_list_Of_SDP_Media_Components),
        ('gGSNaddress', _CPFRecord_gGSNaddress),
        ('serviceReasonReturnCode', _CPFRecord_serviceReasonReturnCode),
        ('list-Of-Message-Bodies', _CPFRecord_list_Of_Message_Bodies),
        ('userLocationInfo', _CPFRecord_userLocationInfo),
        ('poCInformation', _CPFRecord_poCInformation),
        ('recordExtensions', _CPFRecord_recordExtensions),
        ('serviceContextID', _CPFRecord_serviceContextID),
        ])
    CPFRecord._ext = None
    
    #-----< AccessPriority >-----#
    AccessPriority = ENUM(name='AccessPriority', mode=MODE_TYPE)
    AccessPriority._cont = ASN1Dict([('pre-emptive', 0), ('high', 1), ('normal', 2), ('low', 3)])
    AccessPriority._ext = None
    
    #-----< CauseForRecordClosing >-----#
    CauseForRecordClosing = ENUM(name='CauseForRecordClosing', mode=MODE_TYPE)
    CauseForRecordClosing._cont = ASN1Dict([('normalRelease', 0), ('abnormalRelease', 1), ('serviceChange', 2), ('volumeLimit', 3), ('timeLimit', 4), ('numberofTalkBurstLimit', 5), ('maxChangeCond', 6), ('sessionTypeChange', 7), ('managementIntervention', 8)])
    CauseForRecordClosing._ext = None
    
    #-----< ChangeCondition >-----#
    ChangeCondition = ENUM(name='ChangeCondition', mode=MODE_TYPE)
    ChangeCondition._cont = ASN1Dict([('serviceChange', 0), ('volumeLimit', 1), ('timeLimit', 2), ('numberofTalkBurstLimit', 3), ('numberofActiveParticipants', 4), ('tariffTime', 5)])
    ChangeCondition._ext = None
    
    #-----< ListofTalkBurstExchange >-----#
    ListofTalkBurstExchange = SET(name='ListofTalkBurstExchange', mode=MODE_TYPE)
    _ListofTalkBurstExchange_number_Of_Talk_Bursts = INT(name='number-Of-Talk-Bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_talk_Burst_Volume = INT(name='talk-Burst-Volume', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_talk_Bursts_Time = INT(name='talk-Bursts-Time', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _ListofTalkBurstExchange_number_Of_Received_Talk_Bursts = INT(name='number-Of-Received-Talk-Bursts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_received_Talk_Burst_Volume = INT(name='received-Talk-Burst-Volume', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_received_Talk_Burst_Time = INT(name='received-Talk-Burst-Time', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _ListofTalkBurstExchange_changeCondition = ENUM(name='changeCondition', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'ChangeCondition')), opt=True)
    _ListofTalkBurstExchange_changeTime = OCT_STR(name='changeTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ListofTalkBurstExchange_numberofParticipants = INT(name='numberofParticipants', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ListofTalkBurstExchange._cont = ASN1Dict([
        ('number-Of-Talk-Bursts', _ListofTalkBurstExchange_number_Of_Talk_Bursts),
        ('talk-Burst-Volume', _ListofTalkBurstExchange_talk_Burst_Volume),
        ('talk-Bursts-Time', _ListofTalkBurstExchange_talk_Bursts_Time),
        ('number-Of-Received-Talk-Bursts', _ListofTalkBurstExchange_number_Of_Received_Talk_Bursts),
        ('received-Talk-Burst-Volume', _ListofTalkBurstExchange_received_Talk_Burst_Volume),
        ('received-Talk-Burst-Time', _ListofTalkBurstExchange_received_Talk_Burst_Time),
        ('changeCondition', _ListofTalkBurstExchange_changeCondition),
        ('changeTime', _ListofTalkBurstExchange_changeTime),
        ('numberofParticipants', _ListofTalkBurstExchange_numberofParticipants),
        ])
    ListofTalkBurstExchange._ext = None
    
    #-----< ParticipatingType >-----#
    ParticipatingType = ENUM(name='ParticipatingType', mode=MODE_TYPE)
    ParticipatingType._cont = ASN1Dict([('normal', 0), ('nW-PoC-Box', 1), ('uE-PoC-Box', 2)])
    ParticipatingType._ext = None
    
    #-----< POCEventType >-----#
    POCEventType = ENUM(name='POCEventType', mode=MODE_TYPE)
    POCEventType._cont = ASN1Dict([('normal', 0), ('instantPersonalAlert', 1), ('pOCGroupAdvertisement', 2), ('earlySessionSettingup', 3), ('pOCTalkBurst', 4)])
    POCEventType._ext = None
    
    #-----< POCInformation >-----#
    POCInformation = SET(name='POCInformation', mode=MODE_TYPE)
    _POCInformation_pOCSessionType = ENUM(name='pOCSessionType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCSessionType')), opt=True)
    _POCInformation_numberofParticipants = INT(name='numberofParticipants', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_listofParticipants = SEQ_OF(name='listofParticipants', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __POCInformation_listofParticipants__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('POCChargingDataTypes', 'POCParticipant')))
    _POCInformation_listofParticipants._cont = __POCInformation_listofParticipants__item_
    _POCInformation_listofTalkBurstExchange = SEQ_OF(name='listofTalkBurstExchange', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __POCInformation_listofTalkBurstExchange__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('POCChargingDataTypes', 'ListofTalkBurstExchange')))
    _POCInformation_listofTalkBurstExchange._cont = __POCInformation_listofTalkBurstExchange__item_
    _POCInformation_pOCControllingAddress = STR_UTF8(name='pOCControllingAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_pOCGroupName = STR_UTF8(name='pOCGroupName', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_pOCSessionId = STR_UTF8(name='pOCSessionId', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_pOCSessionInitiationType = ENUM(name='pOCSessionInitiationType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCSessionInitType')), opt=True)
    _POCInformation_pOCEventType = ENUM(name='pOCEventType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCEventType')), opt=True)
    POCInformation._cont = ASN1Dict([
        ('pOCSessionType', _POCInformation_pOCSessionType),
        ('numberofParticipants', _POCInformation_numberofParticipants),
        ('listofParticipants', _POCInformation_listofParticipants),
        ('listofTalkBurstExchange', _POCInformation_listofTalkBurstExchange),
        ('pOCControllingAddress', _POCInformation_pOCControllingAddress),
        ('pOCGroupName', _POCInformation_pOCGroupName),
        ('pOCSessionId', _POCInformation_pOCSessionId),
        ('pOCSessionInitiationType', _POCInformation_pOCSessionInitiationType),
        ('pOCEventType', _POCInformation_pOCEventType),
        ])
    POCInformation._ext = None
    
    #-----< POCParticipant >-----#
    POCParticipant = SET(name='POCParticipant', mode=MODE_TYPE)
    _POCParticipant_called_party_address = CHOICE(name='called-party-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _POCParticipant_participant_access_priority = ENUM(name='participant-access-priority', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'AccessPriority')), opt=True)
    _POCParticipant_user_participating_type = ENUM(name='user-participating-type', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'ParticipatingType')), opt=True)
    POCParticipant._cont = ASN1Dict([
        ('called-party-address', _POCParticipant_called_party_address),
        ('participant-access-priority', _POCParticipant_participant_access_priority),
        ('user-participating-type', _POCParticipant_user_participating_type),
        ])
    POCParticipant._ext = None
    
    #-----< POCSessionInitType >-----#
    POCSessionInitType = ENUM(name='POCSessionInitType', mode=MODE_TYPE)
    POCSessionInitType._cont = ASN1Dict([('pre-established', 0), ('on-demand', 1)])
    POCSessionInitType._ext = None
    
    #-----< POCSessionType >-----#
    POCSessionType = ENUM(name='POCSessionType', mode=MODE_TYPE)
    POCSessionType._cont = ASN1Dict([('one-to-one-session', 0), ('chat-group-session', 1), ('pre-arranged-group-session', 2), ('ad-hoc-group-session', 3)])
    POCSessionType._ext = None
    
    _all_ = [
        _POCRecord_pPFRecord,
        _POCRecord_cPFRecord,
        POCRecord,
        _PPFRecord_recordType,
        _PPFRecord_retransmission,
        _PPFRecord_sIP_Method,
        _PPFRecord_nodeAddress,
        _PPFRecord_session_Id,
        _PPFRecord_calling_Party_Address,
        _PPFRecord_called_Party_Address,
        _PPFRecord_servedParty,
        _PPFRecord_serviceRequestTimeStamp,
        _PPFRecord_serviceDeliveryStartTimeStamp,
        _PPFRecord_serviceDeliveryEndTimeStamp,
        _PPFRecord_recordOpeningTime,
        _PPFRecord_recordClosureTime,
        _PPFRecord_interOperatorIdentifiers,
        _PPFRecord_localRecordSequenceNumber,
        _PPFRecord_recordSequenceNumber,
        _PPFRecord_causeForRecordClosing,
        _PPFRecord_incomplete_CDR_Indication,
        _PPFRecord_iMS_Charging_Identifier,
        __PPFRecord_list_Of_SDP_Media_Components__item_,
        _PPFRecord_list_Of_SDP_Media_Components,
        _PPFRecord_gGSNaddress,
        _PPFRecord_serviceReasonReturnCode,
        __PPFRecord_list_Of_Message_Bodies__item_,
        _PPFRecord_list_Of_Message_Bodies,
        _PPFRecord_userLocationInfo,
        _PPFRecord_poCInformation,
        _PPFRecord_recordExtensions,
        _PPFRecord_serviceContextID,
        PPFRecord,
        _CPFRecord_recordType,
        _CPFRecord_retransmission,
        _CPFRecord_sIP_Method,
        _CPFRecord_nodeAddress,
        _CPFRecord_session_Id,
        _CPFRecord_calling_Party_Address,
        _CPFRecord_called_Party_Address,
        _CPFRecord_servedParty,
        _CPFRecord_serviceRequestTimeStamp,
        _CPFRecord_serviceDeliveryStartTimeStamp,
        _CPFRecord_serviceDeliveryEndTimeStamp,
        _CPFRecord_recordOpeningTime,
        _CPFRecord_recordClosureTime,
        _CPFRecord_interOperatorIdentifiers,
        _CPFRecord_localRecordSequenceNumber,
        _CPFRecord_recordSequenceNumber,
        _CPFRecord_causeForRecordClosing,
        _CPFRecord_incomplete_CDR_Indication,
        _CPFRecord_iMS_Charging_Identifier,
        __CPFRecord_list_Of_SDP_Media_Components__item_,
        _CPFRecord_list_Of_SDP_Media_Components,
        _CPFRecord_gGSNaddress,
        _CPFRecord_serviceReasonReturnCode,
        __CPFRecord_list_Of_Message_Bodies__item_,
        _CPFRecord_list_Of_Message_Bodies,
        _CPFRecord_userLocationInfo,
        _CPFRecord_poCInformation,
        _CPFRecord_recordExtensions,
        _CPFRecord_serviceContextID,
        CPFRecord,
        AccessPriority,
        CauseForRecordClosing,
        ChangeCondition,
        _ListofTalkBurstExchange_number_Of_Talk_Bursts,
        _ListofTalkBurstExchange_talk_Burst_Volume,
        _ListofTalkBurstExchange_talk_Bursts_Time,
        _ListofTalkBurstExchange_number_Of_Received_Talk_Bursts,
        _ListofTalkBurstExchange_received_Talk_Burst_Volume,
        _ListofTalkBurstExchange_received_Talk_Burst_Time,
        _ListofTalkBurstExchange_changeCondition,
        _ListofTalkBurstExchange_changeTime,
        _ListofTalkBurstExchange_numberofParticipants,
        ListofTalkBurstExchange,
        ParticipatingType,
        POCEventType,
        _POCInformation_pOCSessionType,
        _POCInformation_numberofParticipants,
        __POCInformation_listofParticipants__item_,
        _POCInformation_listofParticipants,
        __POCInformation_listofTalkBurstExchange__item_,
        _POCInformation_listofTalkBurstExchange,
        _POCInformation_pOCControllingAddress,
        _POCInformation_pOCGroupName,
        _POCInformation_pOCSessionId,
        _POCInformation_pOCSessionInitiationType,
        _POCInformation_pOCEventType,
        POCInformation,
        _POCParticipant_called_party_address,
        _POCParticipant_participant_access_priority,
        _POCParticipant_user_participating_type,
        POCParticipant,
        POCSessionInitType,
        POCSessionType,
    ]

class ProSeChargingDataTypes:

    _name_  = 'ProSeChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 11, 0, 1]
    
    _obj_ = [
        'ProSeRecordType',
        'PFDDRecord',
        'PFEDRecord',
        'PFDCRecord',
        'AppSpecificData',
        'ChangeOfProSeCondition',
        'CoverageInfo',
        'CoverageStatus',
        'LocationInfo',
        'PC5RadioTechnology',
        'ProSeCauseForRecClosing',
        'ProSeEventType',
        'ProSeFunctionRole',
        'ProSeUERole',
        'ProximityAlertIndication',
        'ProximityRequestRenewalInfoBlock',
        'RadioFrequency',
        'RadioParameterSetInfo',
        'RadioResourcesIndicator',
        'RangeClass',
        'ReasonforCancellation',
        'ServiceChangeCondition',
        'TransmitterInfo',
        ]
    _type_ = [
        'ProSeRecordType',
        'PFDDRecord',
        'PFEDRecord',
        'PFDCRecord',
        'AppSpecificData',
        'ChangeOfProSeCondition',
        'CoverageInfo',
        'CoverageStatus',
        'LocationInfo',
        'PC5RadioTechnology',
        'ProSeCauseForRecClosing',
        'ProSeEventType',
        'ProSeFunctionRole',
        'ProSeUERole',
        'ProximityAlertIndication',
        'ProximityRequestRenewalInfoBlock',
        'RadioFrequency',
        'RadioParameterSetInfo',
        'RadioResourcesIndicator',
        'RangeClass',
        'ReasonforCancellation',
        'ServiceChangeCondition',
        'TransmitterInfo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ProSeRecordType >-----#
    ProSeRecordType = CHOICE(name='ProSeRecordType', mode=MODE_TYPE)
    _ProSeRecordType_pFDDRecord = SET(name='pFDDRecord', mode=MODE_TYPE, tag=(100, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PFDDRecord')))
    _ProSeRecordType_pFEDRecord = SET(name='pFEDRecord', mode=MODE_TYPE, tag=(101, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PFEDRecord')))
    _ProSeRecordType_pFDCRecord = SET(name='pFDCRecord', mode=MODE_TYPE, tag=(102, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PFDCRecord')))
    ProSeRecordType._cont = ASN1Dict([
        ('pFDDRecord', _ProSeRecordType_pFDDRecord),
        ('pFEDRecord', _ProSeRecordType_pFEDRecord),
        ('pFDCRecord', _ProSeRecordType_pFDCRecord),
        ])
    ProSeRecordType._ext = None
    
    #-----< PFDDRecord >-----#
    PFDDRecord = SET(name='PFDDRecord', mode=MODE_TYPE)
    _PFDDRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PFDDRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PFDDRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFDDRecord_proSeFunctionIPAddress = CHOICE(name='proSeFunctionIPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDDRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PFDDRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PFDDRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PFDDRecord_proSeRequestTimestamp = OCT_STR(name='proSeRequestTimestamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDDRecord_roleofUE = ENUM(name='roleofUE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeUERole')), opt=True)
    _PFDDRecord_pCThreeControlProtocolCause = INT(name='pCThreeControlProtocolCause', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_roleofProSeFunction = ENUM(name='roleofProSeFunction', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeFunctionRole')), opt=True)
    _PFDDRecord_proSeApplicationID = STR_UTF8(name='proSeApplicationID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_proSeEventType = ENUM(name='proSeEventType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeEventType')), opt=True)
    _PFDDRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _PFDDRecord_proseFunctionId = STR_UTF8(name='proseFunctionId', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_announcingUEHPLMNIdentifier = OCT_STR(name='announcingUEHPLMNIdentifier', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_announcingUEVPLMNIdentifier = OCT_STR(name='announcingUEVPLMNIdentifier', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_monitoringUEHPLMNIdentifier = OCT_STR(name='monitoringUEHPLMNIdentifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_monitoringUEVPLMNIdentifier = OCT_STR(name='monitoringUEVPLMNIdentifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_monitoredPLMNIdentifier = OCT_STR(name='monitoredPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_applicationID = STR_UTF8(name='applicationID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_directDiscoveryModel = STR_UTF8(name='directDiscoveryModel', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_validityPeriod = INT(name='validityPeriod', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_monitoringUEIdentifier = OCT_STR(name='monitoringUEIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFDDRecord_discovererUEHPLMNIdentifier = OCT_STR(name='discovererUEHPLMNIdentifier', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_discovererUEVPLMNIdentifier = OCT_STR(name='discovererUEVPLMNIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_discovereeUEHPLMNIdentifier = OCT_STR(name='discovereeUEHPLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_discovereeUEVPLMNIdentifier = OCT_STR(name='discovereeUEVPLMNIdentifier', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_announcingPLMNID = OCT_STR(name='announcingPLMNID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_pc5RadioTechnology = ENUM(name='pc5RadioTechnology', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PC5RadioTechnology')), opt=True)
    PFDDRecord._cont = ASN1Dict([
        ('recordType', _PFDDRecord_recordType),
        ('retransmission', _PFDDRecord_retransmission),
        ('serviceContextID', _PFDDRecord_serviceContextID),
        ('servedIMSI', _PFDDRecord_servedIMSI),
        ('proSeFunctionIPAddress', _PFDDRecord_proSeFunctionIPAddress),
        ('chargingCharacteristics', _PFDDRecord_chargingCharacteristics),
        ('chChSelectionMode', _PFDDRecord_chChSelectionMode),
        ('recordExtensions', _PFDDRecord_recordExtensions),
        ('proSeRequestTimestamp', _PFDDRecord_proSeRequestTimestamp),
        ('roleofUE', _PFDDRecord_roleofUE),
        ('pCThreeControlProtocolCause', _PFDDRecord_pCThreeControlProtocolCause),
        ('roleofProSeFunction', _PFDDRecord_roleofProSeFunction),
        ('proSeApplicationID', _PFDDRecord_proSeApplicationID),
        ('proSeEventType', _PFDDRecord_proSeEventType),
        ('nodeID', _PFDDRecord_nodeID),
        ('proseFunctionId', _PFDDRecord_proseFunctionId),
        ('announcingUEHPLMNIdentifier', _PFDDRecord_announcingUEHPLMNIdentifier),
        ('announcingUEVPLMNIdentifier', _PFDDRecord_announcingUEVPLMNIdentifier),
        ('monitoringUEHPLMNIdentifier', _PFDDRecord_monitoringUEHPLMNIdentifier),
        ('monitoringUEVPLMNIdentifier', _PFDDRecord_monitoringUEVPLMNIdentifier),
        ('monitoredPLMNIdentifier', _PFDDRecord_monitoredPLMNIdentifier),
        ('applicationID', _PFDDRecord_applicationID),
        ('directDiscoveryModel', _PFDDRecord_directDiscoveryModel),
        ('validityPeriod', _PFDDRecord_validityPeriod),
        ('monitoringUEIdentifier', _PFDDRecord_monitoringUEIdentifier),
        ('discovererUEHPLMNIdentifier', _PFDDRecord_discovererUEHPLMNIdentifier),
        ('discovererUEVPLMNIdentifier', _PFDDRecord_discovererUEVPLMNIdentifier),
        ('discovereeUEHPLMNIdentifier', _PFDDRecord_discovereeUEHPLMNIdentifier),
        ('discovereeUEVPLMNIdentifier', _PFDDRecord_discovereeUEVPLMNIdentifier),
        ('announcingPLMNID', _PFDDRecord_announcingPLMNID),
        ('pc5RadioTechnology', _PFDDRecord_pc5RadioTechnology),
        ])
    PFDDRecord._ext = None
    
    #-----< PFEDRecord >-----#
    PFEDRecord = SET(name='PFEDRecord', mode=MODE_TYPE)
    _PFEDRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PFEDRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PFEDRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFEDRecord_proSeFunctionIPAddress = CHOICE(name='proSeFunctionIPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFEDRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PFEDRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PFEDRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PFEDRecord_proSeRequestTimestamp = OCT_STR(name='proSeRequestTimestamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_roleofUE = ENUM(name='roleofUE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeUERole')), opt=True)
    _PFEDRecord_pCThreeEPCControlProtocolCause = INT(name='pCThreeEPCControlProtocolCause', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_proseFunctionPLMNIdentifier = OCT_STR(name='proseFunctionPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFEDRecord_proseFunctionId = STR_UTF8(name='proseFunctionId', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_applicationID = STR_UTF8(name='applicationID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestorApplicationLayerUserID = STR_UTF8(name='requestorApplicationLayerUserID', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_wLANLinkLayerID = STR_UTF8(name='wLANLinkLayerID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestorEPCProSeUserID = STR_UTF8(name='requestorEPCProSeUserID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestedApplicationLayerUserID = STR_UTF8(name='requestedApplicationLayerUserID', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestedPLMNIdentifier = OCT_STR(name='requestedPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFEDRecord_timeWindow = INT(name='timeWindow', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_rangeClass = ENUM(name='rangeClass', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RangeClass')), opt=True)
    _PFEDRecord_uELocation = OCT_STR(name='uELocation', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_proximityAlertIndication = ENUM(name='proximityAlertIndication', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProximityAlertIndication')), opt=True)
    _PFEDRecord_proximityAlertTimestamp = OCT_STR(name='proximityAlertTimestamp', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_proximityCancellationTimestamp = OCT_STR(name='proximityCancellationTimestamp', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_reasonforCancellation = ENUM(name='reasonforCancellation', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ReasonforCancellation')), opt=True)
    _PFEDRecord_causeForRecClosing = ENUM(name='causeForRecClosing', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeCauseForRecClosing')))
    _PFEDRecord_proximityRequestRenewalInfoBlockList = SEQ_OF(name='proximityRequestRenewalInfoBlockList', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFEDRecord_proximityRequestRenewalInfoBlockList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProximityRequestRenewalInfoBlock')))
    _PFEDRecord_proximityRequestRenewalInfoBlockList._cont = __PFEDRecord_proximityRequestRenewalInfoBlockList__item_
    PFEDRecord._cont = ASN1Dict([
        ('recordType', _PFEDRecord_recordType),
        ('retransmission', _PFEDRecord_retransmission),
        ('serviceContextID', _PFEDRecord_serviceContextID),
        ('servedIMSI', _PFEDRecord_servedIMSI),
        ('proSeFunctionIPAddress', _PFEDRecord_proSeFunctionIPAddress),
        ('chargingCharacteristics', _PFEDRecord_chargingCharacteristics),
        ('chChSelectionMode', _PFEDRecord_chChSelectionMode),
        ('recordExtensions', _PFEDRecord_recordExtensions),
        ('proSeRequestTimestamp', _PFEDRecord_proSeRequestTimestamp),
        ('roleofUE', _PFEDRecord_roleofUE),
        ('pCThreeEPCControlProtocolCause', _PFEDRecord_pCThreeEPCControlProtocolCause),
        ('proseFunctionPLMNIdentifier', _PFEDRecord_proseFunctionPLMNIdentifier),
        ('proseFunctionId', _PFEDRecord_proseFunctionId),
        ('recordOpeningTime', _PFEDRecord_recordOpeningTime),
        ('recordClosureTime', _PFEDRecord_recordClosureTime),
        ('applicationID', _PFEDRecord_applicationID),
        ('requestorApplicationLayerUserID', _PFEDRecord_requestorApplicationLayerUserID),
        ('wLANLinkLayerID', _PFEDRecord_wLANLinkLayerID),
        ('requestorEPCProSeUserID', _PFEDRecord_requestorEPCProSeUserID),
        ('requestedApplicationLayerUserID', _PFEDRecord_requestedApplicationLayerUserID),
        ('requestedPLMNIdentifier', _PFEDRecord_requestedPLMNIdentifier),
        ('timeWindow', _PFEDRecord_timeWindow),
        ('rangeClass', _PFEDRecord_rangeClass),
        ('uELocation', _PFEDRecord_uELocation),
        ('proximityAlertIndication', _PFEDRecord_proximityAlertIndication),
        ('proximityAlertTimestamp', _PFEDRecord_proximityAlertTimestamp),
        ('proximityCancellationTimestamp', _PFEDRecord_proximityCancellationTimestamp),
        ('reasonforCancellation', _PFEDRecord_reasonforCancellation),
        ('causeForRecClosing', _PFEDRecord_causeForRecClosing),
        ('proximityRequestRenewalInfoBlockList', _PFEDRecord_proximityRequestRenewalInfoBlockList),
        ])
    PFEDRecord._ext = None
    
    #-----< PFDCRecord >-----#
    PFDCRecord = SET(name='PFDCRecord', mode=MODE_TYPE)
    _PFDCRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PFDCRecord_retransmission = NULL(name='retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_serviceContextID = STR_UTF8(name='serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PFDCRecord_servedIMSI = OCT_STR(name='servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFDCRecord_proSeFunctionIPAddress = CHOICE(name='proSeFunctionIPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PFDCRecord_chChSelectionMode = ENUM(name='chChSelectionMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PFDCRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PFDCRecord_nodeID = STR_IA5(name='nodeID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _PFDCRecord_proseFunctionPLMNIdentifier = OCT_STR(name='proseFunctionPLMNIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDCRecord_proseFunctionId = STR_UTF8(name='proseFunctionId', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_recordOpeningTime = OCT_STR(name='recordOpeningTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_recordClosureTime = OCT_STR(name='recordClosureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_listOfCoverageInfo = SEQ_OF(name='listOfCoverageInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfCoverageInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'CoverageInfo')))
    _PFDCRecord_listOfCoverageInfo._cont = __PFDCRecord_listOfCoverageInfo__item_
    _PFDCRecord_listOfRadioParameterSet = SEQ_OF(name='listOfRadioParameterSet', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfRadioParameterSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'RadioParameterSetInfo')))
    _PFDCRecord_listOfRadioParameterSet._cont = __PFDCRecord_listOfRadioParameterSet__item_
    _PFDCRecord_proSeUEID = OCT_STR(name='proSeUEID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_sourceIPaddress = CHOICE(name='sourceIPaddress', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_layerTwoGroupID = OCT_STR(name='layerTwoGroupID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_proSeGroupIPmulticastaddress = CHOICE(name='proSeGroupIPmulticastaddress', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_timeOfFirstTransmission = OCT_STR(name='timeOfFirstTransmission', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_timeOfFirstReception = OCT_STR(name='timeOfFirstReception', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_listOfTransmitters = SEQ_OF(name='listOfTransmitters', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfTransmitters__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'TransmitterInfo')))
    _PFDCRecord_listOfTransmitters._cont = __PFDCRecord_listOfTransmitters__item_
    _PFDCRecord_listOfTransmissionData = SEQ_OF(name='listOfTransmissionData', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfTransmissionData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'ChangeOfProSeCondition')))
    _PFDCRecord_listOfTransmissionData._cont = __PFDCRecord_listOfTransmissionData__item_
    _PFDCRecord_listOfReceptionData = SEQ_OF(name='listOfReceptionData', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfReceptionData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'ChangeOfProSeCondition')))
    _PFDCRecord_listOfReceptionData._cont = __PFDCRecord_listOfReceptionData__item_
    _PFDCRecord_causeForRecClosing = ENUM(name='causeForRecClosing', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeCauseForRecClosing')))
    _PFDCRecord_listOfAppSpecificData = SEQ_OF(name='listOfAppSpecificData', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PFDCRecord_listOfAppSpecificData__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'AppSpecificData')))
    _PFDCRecord_listOfAppSpecificData._cont = __PFDCRecord_listOfAppSpecificData__item_
    _PFDCRecord_targetIPaddress = CHOICE(name='targetIPaddress', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_relayIPaddress = CHOICE(name='relayIPaddress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_proSeUEtoNetworkRelayUEID = OCT_STR(name='proSeUEtoNetworkRelayUEID', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_proSeTargetLayerTwoID = OCT_STR(name='proSeTargetLayerTwoID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PFDCRecord._cont = ASN1Dict([
        ('recordType', _PFDCRecord_recordType),
        ('retransmission', _PFDCRecord_retransmission),
        ('serviceContextID', _PFDCRecord_serviceContextID),
        ('servedIMSI', _PFDCRecord_servedIMSI),
        ('proSeFunctionIPAddress', _PFDCRecord_proSeFunctionIPAddress),
        ('chargingCharacteristics', _PFDCRecord_chargingCharacteristics),
        ('chChSelectionMode', _PFDCRecord_chChSelectionMode),
        ('recordExtensions', _PFDCRecord_recordExtensions),
        ('nodeID', _PFDCRecord_nodeID),
        ('proseFunctionPLMNIdentifier', _PFDCRecord_proseFunctionPLMNIdentifier),
        ('proseFunctionId', _PFDCRecord_proseFunctionId),
        ('recordOpeningTime', _PFDCRecord_recordOpeningTime),
        ('recordClosureTime', _PFDCRecord_recordClosureTime),
        ('listOfCoverageInfo', _PFDCRecord_listOfCoverageInfo),
        ('listOfRadioParameterSet', _PFDCRecord_listOfRadioParameterSet),
        ('proSeUEID', _PFDCRecord_proSeUEID),
        ('sourceIPaddress', _PFDCRecord_sourceIPaddress),
        ('layerTwoGroupID', _PFDCRecord_layerTwoGroupID),
        ('proSeGroupIPmulticastaddress', _PFDCRecord_proSeGroupIPmulticastaddress),
        ('timeOfFirstTransmission', _PFDCRecord_timeOfFirstTransmission),
        ('timeOfFirstReception', _PFDCRecord_timeOfFirstReception),
        ('listOfTransmitters', _PFDCRecord_listOfTransmitters),
        ('listOfTransmissionData', _PFDCRecord_listOfTransmissionData),
        ('listOfReceptionData', _PFDCRecord_listOfReceptionData),
        ('causeForRecClosing', _PFDCRecord_causeForRecClosing),
        ('listOfAppSpecificData', _PFDCRecord_listOfAppSpecificData),
        ('targetIPaddress', _PFDCRecord_targetIPaddress),
        ('relayIPaddress', _PFDCRecord_relayIPaddress),
        ('proSeUEtoNetworkRelayUEID', _PFDCRecord_proSeUEtoNetworkRelayUEID),
        ('proSeTargetLayerTwoID', _PFDCRecord_proSeTargetLayerTwoID),
        ])
    PFDCRecord._ext = None
    
    #-----< AppSpecificData >-----#
    AppSpecificData = OCT_STR(name='AppSpecificData', mode=MODE_TYPE)
    
    #-----< ChangeOfProSeCondition >-----#
    ChangeOfProSeCondition = SEQ(name='ChangeOfProSeCondition', mode=MODE_TYPE)
    _ChangeOfProSeCondition_changeConditionTimestamp = OCT_STR(name='changeConditionTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ChangeOfProSeCondition_coverageStatus = ENUM(name='coverageStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'CoverageStatus')), opt=True)
    _ChangeOfProSeCondition_uELocation = OCT_STR(name='uELocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfProSeCondition_dataVolume = INT(name='dataVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfProSeCondition_serviceChangeCondition = BIT_STR(name='serviceChangeCondition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ServiceChangeCondition')), opt=True)
    _ChangeOfProSeCondition_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ChangeOfProSeCondition_usageInformationReportSequenceNumber = INT(name='usageInformationReportSequenceNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfProSeCondition_radioResourcesInd = INT(name='radioResourcesInd', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RadioResourcesIndicator')), opt=True)
    _ChangeOfProSeCondition_radiofrequency = OCT_STR(name='radiofrequency', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RadioFrequency')), opt=True)
    _ChangeOfProSeCondition_vPLMNIdentifier = OCT_STR(name='vPLMNIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    ChangeOfProSeCondition._cont = ASN1Dict([
        ('changeConditionTimestamp', _ChangeOfProSeCondition_changeConditionTimestamp),
        ('coverageStatus', _ChangeOfProSeCondition_coverageStatus),
        ('uELocation', _ChangeOfProSeCondition_uELocation),
        ('dataVolume', _ChangeOfProSeCondition_dataVolume),
        ('serviceChangeCondition', _ChangeOfProSeCondition_serviceChangeCondition),
        ('localSequenceNumber', _ChangeOfProSeCondition_localSequenceNumber),
        ('usageInformationReportSequenceNumber', _ChangeOfProSeCondition_usageInformationReportSequenceNumber),
        ('radioResourcesInd', _ChangeOfProSeCondition_radioResourcesInd),
        ('radiofrequency', _ChangeOfProSeCondition_radiofrequency),
        ('vPLMNIdentifier', _ChangeOfProSeCondition_vPLMNIdentifier),
        ])
    ChangeOfProSeCondition._ext = None
    
    #-----< CoverageInfo >-----#
    CoverageInfo = SEQ(name='CoverageInfo', mode=MODE_TYPE)
    _CoverageInfo_coverageStatus = ENUM(name='coverageStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'CoverageStatus')))
    _CoverageInfo_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CoverageInfo_listOfLocation = SEQ_OF(name='listOfLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CoverageInfo_listOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'LocationInfo')))
    _CoverageInfo_listOfLocation._cont = __CoverageInfo_listOfLocation__item_
    CoverageInfo._cont = ASN1Dict([
        ('coverageStatus', _CoverageInfo_coverageStatus),
        ('timeStamp', _CoverageInfo_timeStamp),
        ('listOfLocation', _CoverageInfo_listOfLocation),
        ])
    CoverageInfo._ext = None
    
    #-----< CoverageStatus >-----#
    CoverageStatus = ENUM(name='CoverageStatus', mode=MODE_TYPE)
    CoverageStatus._cont = ASN1Dict([('outOfCoverage', 0), ('inCoverage', 1)])
    CoverageStatus._ext = None
    
    #-----< LocationInfo >-----#
    LocationInfo = SEQ(name='LocationInfo', mode=MODE_TYPE)
    _LocationInfo_uELocation = OCT_STR(name='uELocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfo_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    LocationInfo._cont = ASN1Dict([
        ('uELocation', _LocationInfo_uELocation),
        ('timeStamp', _LocationInfo_timeStamp),
        ])
    LocationInfo._ext = None
    
    #-----< PC5RadioTechnology >-----#
    PC5RadioTechnology = ENUM(name='PC5RadioTechnology', mode=MODE_TYPE)
    PC5RadioTechnology._cont = ASN1Dict([('eUTRA', 0), ('wLAN', 1), ('bothEUTRAAndWLAN', 2)])
    PC5RadioTechnology._ext = None
    
    #-----< ProSeCauseForRecClosing >-----#
    ProSeCauseForRecClosing = ENUM(name='ProSeCauseForRecClosing', mode=MODE_TYPE)
    ProSeCauseForRecClosing._cont = ASN1Dict([('proximityAlerted', 0), ('timeExpiredWithNoRrenewal', 1), ('requestorCancellation', 2), ('timeLimited', 3), ('maxNumberOfReports', 4), ('abnormalRelease', 5)])
    ProSeCauseForRecClosing._ext = None
    
    #-----< ProSeEventType >-----#
    ProSeEventType = ENUM(name='ProSeEventType', mode=MODE_TYPE)
    ProSeEventType._cont = ASN1Dict([('openAnnouncing', 0), ('openMonitoring', 1), ('openMatchReport', 2), ('restrictedAnnouncing', 3), ('restrictedMonitoring', 4), ('restrictedMatchReport', 5), ('restrictedDiscoveryRequest', 6), ('restrictedDiscoveryReporting', 7)])
    ProSeEventType._ext = None
    
    #-----< ProSeFunctionRole >-----#
    ProSeFunctionRole = ENUM(name='ProSeFunctionRole', mode=MODE_TYPE)
    ProSeFunctionRole._cont = ASN1Dict([('hPLMN', 0), ('vPLMN', 1), ('localPLMN', 2)])
    ProSeFunctionRole._ext = None
    
    #-----< ProSeUERole >-----#
    ProSeUERole = ENUM(name='ProSeUERole', mode=MODE_TYPE)
    ProSeUERole._cont = ASN1Dict([('annoucingUE', 0), ('monitoringUE', 1), ('requestorUE', 2), ('requestedUE', 3), ('discovererUE', 4), ('discovereeUE', 5)])
    ProSeUERole._ext = None
    
    #-----< ProximityAlertIndication >-----#
    ProximityAlertIndication = ENUM(name='ProximityAlertIndication', mode=MODE_TYPE)
    ProximityAlertIndication._cont = ASN1Dict([('alerted', 0), ('noAlert', 1)])
    ProximityAlertIndication._ext = None
    
    #-----< ProximityRequestRenewalInfoBlock >-----#
    ProximityRequestRenewalInfoBlock = SEQ(name='ProximityRequestRenewalInfoBlock', mode=MODE_TYPE)
    _ProximityRequestRenewalInfoBlock_proSeRequestTimestamp = OCT_STR(name='proSeRequestTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ProximityRequestRenewalInfoBlock_timeWindow = INT(name='timeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProximityRequestRenewalInfoBlock_rangeClass = ENUM(name='rangeClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RangeClass')), opt=True)
    _ProximityRequestRenewalInfoBlock_uELocation = OCT_STR(name='uELocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ProximityRequestRenewalInfoBlock._cont = ASN1Dict([
        ('proSeRequestTimestamp', _ProximityRequestRenewalInfoBlock_proSeRequestTimestamp),
        ('timeWindow', _ProximityRequestRenewalInfoBlock_timeWindow),
        ('rangeClass', _ProximityRequestRenewalInfoBlock_rangeClass),
        ('uELocation', _ProximityRequestRenewalInfoBlock_uELocation),
        ])
    ProximityRequestRenewalInfoBlock._ext = None
    
    #-----< RadioFrequency >-----#
    RadioFrequency = OCT_STR(name='RadioFrequency', mode=MODE_TYPE)
    
    #-----< RadioParameterSetInfo >-----#
    RadioParameterSetInfo = SEQ(name='RadioParameterSetInfo', mode=MODE_TYPE)
    _RadioParameterSetInfo_timeStamp = OCT_STR(name='timeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RadioParameterSetInfo_params = OCT_STR(name='params', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RadioParameterSetInfo._cont = ASN1Dict([
        ('timeStamp', _RadioParameterSetInfo_timeStamp),
        ('params', _RadioParameterSetInfo_params),
        ])
    RadioParameterSetInfo._ext = None
    
    #-----< RadioResourcesIndicator >-----#
    RadioResourcesIndicator = INT(name='RadioResourcesIndicator', mode=MODE_TYPE)
    RadioResourcesIndicator._cont = ASN1Dict([('operatorProvided', 1), ('configured', 2)])
    
    #-----< RangeClass >-----#
    RangeClass = ENUM(name='RangeClass', mode=MODE_TYPE)
    RangeClass._cont = ASN1Dict([('reserved', 0), ('fiftyMeter', 1), ('onehundredMeter', 2), ('twohundredMeter', 3), ('fivehundredMeter', 4), ('onethousandMeter', 5)])
    RangeClass._ext = None
    
    #-----< ReasonforCancellation >-----#
    ReasonforCancellation = ENUM(name='ReasonforCancellation', mode=MODE_TYPE)
    ReasonforCancellation._cont = ASN1Dict([('proximityAlerted', 0), ('timeExpiredWithNoRrenewal', 1), ('requestorCancellation', 2)])
    ReasonforCancellation._ext = None
    
    #-----< ServiceChangeCondition >-----#
    ServiceChangeCondition = BIT_STR(name='ServiceChangeCondition', mode=MODE_TYPE)
    ServiceChangeCondition._cont = ASN1Dict([('pLMNchange', 0), ('coverageStatusChange', 1), ('locationChange', 2)])
    
    #-----< TransmitterInfo >-----#
    TransmitterInfo = SEQ(name='TransmitterInfo', mode=MODE_TYPE)
    _TransmitterInfo_sourceIPaddress = CHOICE(name='sourceIPaddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _TransmitterInfo_proSeUEID = OCT_STR(name='proSeUEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TransmitterInfo._cont = ASN1Dict([
        ('sourceIPaddress', _TransmitterInfo_sourceIPaddress),
        ('proSeUEID', _TransmitterInfo_proSeUEID),
        ])
    TransmitterInfo._ext = None
    
    _all_ = [
        _ProSeRecordType_pFDDRecord,
        _ProSeRecordType_pFEDRecord,
        _ProSeRecordType_pFDCRecord,
        ProSeRecordType,
        _PFDDRecord_recordType,
        _PFDDRecord_retransmission,
        _PFDDRecord_serviceContextID,
        _PFDDRecord_servedIMSI,
        _PFDDRecord_proSeFunctionIPAddress,
        _PFDDRecord_chargingCharacteristics,
        _PFDDRecord_chChSelectionMode,
        _PFDDRecord_recordExtensions,
        _PFDDRecord_proSeRequestTimestamp,
        _PFDDRecord_roleofUE,
        _PFDDRecord_pCThreeControlProtocolCause,
        _PFDDRecord_roleofProSeFunction,
        _PFDDRecord_proSeApplicationID,
        _PFDDRecord_proSeEventType,
        _PFDDRecord_nodeID,
        _PFDDRecord_proseFunctionId,
        _PFDDRecord_announcingUEHPLMNIdentifier,
        _PFDDRecord_announcingUEVPLMNIdentifier,
        _PFDDRecord_monitoringUEHPLMNIdentifier,
        _PFDDRecord_monitoringUEVPLMNIdentifier,
        _PFDDRecord_monitoredPLMNIdentifier,
        _PFDDRecord_applicationID,
        _PFDDRecord_directDiscoveryModel,
        _PFDDRecord_validityPeriod,
        _PFDDRecord_monitoringUEIdentifier,
        _PFDDRecord_discovererUEHPLMNIdentifier,
        _PFDDRecord_discovererUEVPLMNIdentifier,
        _PFDDRecord_discovereeUEHPLMNIdentifier,
        _PFDDRecord_discovereeUEVPLMNIdentifier,
        _PFDDRecord_announcingPLMNID,
        _PFDDRecord_pc5RadioTechnology,
        PFDDRecord,
        _PFEDRecord_recordType,
        _PFEDRecord_retransmission,
        _PFEDRecord_serviceContextID,
        _PFEDRecord_servedIMSI,
        _PFEDRecord_proSeFunctionIPAddress,
        _PFEDRecord_chargingCharacteristics,
        _PFEDRecord_chChSelectionMode,
        _PFEDRecord_recordExtensions,
        _PFEDRecord_proSeRequestTimestamp,
        _PFEDRecord_roleofUE,
        _PFEDRecord_pCThreeEPCControlProtocolCause,
        _PFEDRecord_proseFunctionPLMNIdentifier,
        _PFEDRecord_proseFunctionId,
        _PFEDRecord_recordOpeningTime,
        _PFEDRecord_recordClosureTime,
        _PFEDRecord_applicationID,
        _PFEDRecord_requestorApplicationLayerUserID,
        _PFEDRecord_wLANLinkLayerID,
        _PFEDRecord_requestorEPCProSeUserID,
        _PFEDRecord_requestedApplicationLayerUserID,
        _PFEDRecord_requestedPLMNIdentifier,
        _PFEDRecord_timeWindow,
        _PFEDRecord_rangeClass,
        _PFEDRecord_uELocation,
        _PFEDRecord_proximityAlertIndication,
        _PFEDRecord_proximityAlertTimestamp,
        _PFEDRecord_proximityCancellationTimestamp,
        _PFEDRecord_reasonforCancellation,
        _PFEDRecord_causeForRecClosing,
        __PFEDRecord_proximityRequestRenewalInfoBlockList__item_,
        _PFEDRecord_proximityRequestRenewalInfoBlockList,
        PFEDRecord,
        _PFDCRecord_recordType,
        _PFDCRecord_retransmission,
        _PFDCRecord_serviceContextID,
        _PFDCRecord_servedIMSI,
        _PFDCRecord_proSeFunctionIPAddress,
        _PFDCRecord_chargingCharacteristics,
        _PFDCRecord_chChSelectionMode,
        _PFDCRecord_recordExtensions,
        _PFDCRecord_nodeID,
        _PFDCRecord_proseFunctionPLMNIdentifier,
        _PFDCRecord_proseFunctionId,
        _PFDCRecord_recordOpeningTime,
        _PFDCRecord_recordClosureTime,
        __PFDCRecord_listOfCoverageInfo__item_,
        _PFDCRecord_listOfCoverageInfo,
        __PFDCRecord_listOfRadioParameterSet__item_,
        _PFDCRecord_listOfRadioParameterSet,
        _PFDCRecord_proSeUEID,
        _PFDCRecord_sourceIPaddress,
        _PFDCRecord_layerTwoGroupID,
        _PFDCRecord_proSeGroupIPmulticastaddress,
        _PFDCRecord_timeOfFirstTransmission,
        _PFDCRecord_timeOfFirstReception,
        __PFDCRecord_listOfTransmitters__item_,
        _PFDCRecord_listOfTransmitters,
        __PFDCRecord_listOfTransmissionData__item_,
        _PFDCRecord_listOfTransmissionData,
        __PFDCRecord_listOfReceptionData__item_,
        _PFDCRecord_listOfReceptionData,
        _PFDCRecord_causeForRecClosing,
        __PFDCRecord_listOfAppSpecificData__item_,
        _PFDCRecord_listOfAppSpecificData,
        _PFDCRecord_targetIPaddress,
        _PFDCRecord_relayIPaddress,
        _PFDCRecord_proSeUEtoNetworkRelayUEID,
        _PFDCRecord_proSeTargetLayerTwoID,
        PFDCRecord,
        AppSpecificData,
        _ChangeOfProSeCondition_changeConditionTimestamp,
        _ChangeOfProSeCondition_coverageStatus,
        _ChangeOfProSeCondition_uELocation,
        _ChangeOfProSeCondition_dataVolume,
        _ChangeOfProSeCondition_serviceChangeCondition,
        _ChangeOfProSeCondition_localSequenceNumber,
        _ChangeOfProSeCondition_usageInformationReportSequenceNumber,
        _ChangeOfProSeCondition_radioResourcesInd,
        _ChangeOfProSeCondition_radiofrequency,
        _ChangeOfProSeCondition_vPLMNIdentifier,
        ChangeOfProSeCondition,
        _CoverageInfo_coverageStatus,
        _CoverageInfo_timeStamp,
        __CoverageInfo_listOfLocation__item_,
        _CoverageInfo_listOfLocation,
        CoverageInfo,
        CoverageStatus,
        _LocationInfo_uELocation,
        _LocationInfo_timeStamp,
        LocationInfo,
        PC5RadioTechnology,
        ProSeCauseForRecClosing,
        ProSeEventType,
        ProSeFunctionRole,
        ProSeUERole,
        ProximityAlertIndication,
        _ProximityRequestRenewalInfoBlock_proSeRequestTimestamp,
        _ProximityRequestRenewalInfoBlock_timeWindow,
        _ProximityRequestRenewalInfoBlock_rangeClass,
        _ProximityRequestRenewalInfoBlock_uELocation,
        ProximityRequestRenewalInfoBlock,
        RadioFrequency,
        _RadioParameterSetInfo_timeStamp,
        _RadioParameterSetInfo_params,
        RadioParameterSetInfo,
        RadioResourcesIndicator,
        RangeClass,
        ReasonforCancellation,
        ServiceChangeCondition,
        _TransmitterInfo_sourceIPaddress,
        _TransmitterInfo_proSeUEID,
        TransmitterInfo,
    ]

class Remote_Operations_Generic_ROS_PDUs:

    _name_  = 'Remote-Operations-Generic-ROS-PDUs'
    _oid_   = [2, 4, 6, 0]
    
    _obj_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Reject',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'RejectProblem',
        'InvokeId',
        'noInvokeId',
        'NoInvokeId',
        'Errors',
        'Bind',
        'Unbind',
        ]
    _type_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Reject',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'RejectProblem',
        'InvokeId',
        'Bind',
        'Unbind',
        ]
    _set_ = [
        'NoInvokeId',
        'Errors',
        ]
    _val_ = [
        'noInvokeId',
        ]
    _class_ = [
        'Errors',
        ]
    _param_ = [
        'ROS',
        'Invoke',
        'ReturnResult',
        'ReturnError',
        'Errors',
        'Bind',
        'Unbind',
        ]
    
    #-----< ROS >-----#
    ROS = CHOICE(name='ROS', mode=MODE_TYPE, param=True)
    
    #-----< Invoke >-----#
    Invoke = SEQ(name='Invoke', mode=MODE_TYPE, param=True)
    
    #-----< ReturnResult >-----#
    ReturnResult = SEQ(name='ReturnResult', mode=MODE_TYPE, param=True)
    
    #-----< ReturnError >-----#
    ReturnError = SEQ(name='ReturnError', mode=MODE_TYPE, param=True)
    
    #-----< Reject >-----#
    Reject = SEQ(name='Reject', mode=MODE_TYPE)
    _Reject_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _Reject_problem = CHOICE(name='problem', mode=MODE_TYPE)
    __Reject_problem_general = INT(name='general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'GeneralProblem')))
    __Reject_problem_invoke = INT(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeProblem')))
    __Reject_problem_returnResult = INT(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResultProblem')))
    __Reject_problem_returnError = INT(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnErrorProblem')))
    _Reject_problem._cont = ASN1Dict([
        ('general', __Reject_problem_general),
        ('invoke', __Reject_problem_invoke),
        ('returnResult', __Reject_problem_returnResult),
        ('returnError', __Reject_problem_returnError),
        ])
    _Reject_problem._ext = None
    Reject._cont = ASN1Dict([
        ('invokeId', _Reject_invokeId),
        ('problem', _Reject_problem),
        ])
    Reject._ext = None
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name='GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([('unrecognizedPDU', 0), ('mistypedPDU', 1), ('badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name='InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([('duplicateInvocation', 0), ('unrecognizedOperation', 1), ('mistypedArgument', 2), ('resourceLimitation', 3), ('releaseInProgress', 4), ('unrecognizedLinkedId', 5), ('linkedResponseUnexpected', 6), ('unexpectedLinkedOperation', 7)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name='ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('resultResponseUnexpected', 1), ('mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name='ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('errorResponseUnexpected', 1), ('unrecognizedError', 2), ('unexpectedError', 3), ('mistypedParameter', 4)])
    
    #-----< RejectProblem >-----#
    RejectProblem = INT(name='RejectProblem', mode=MODE_TYPE)
    RejectProblem._cont = ASN1Dict([('general-unrecognizedPDU', 0), ('general-mistypedPDU', 1), ('general-badlyStructuredPDU', 2), ('invoke-duplicateInvocation', 10), ('invoke-unrecognizedOperation', 11), ('invoke-mistypedArgument', 12), ('invoke-resourceLimitation', 13), ('invoke-releaseInProgress', 14), ('invoke-unrecognizedLinkedId', 15), ('invoke-linkedResponseUnexpected', 16), ('invoke-unexpectedLinkedOperation', 17), ('returnResult-unrecognizedInvocation', 20), ('returnResult-resultResponseUnexpected', 21), ('returnResult-mistypedResult', 22), ('returnError-unrecognizedInvocation', 30), ('returnError-errorResponseUnexpected', 31), ('returnError-unrecognizedError', 32), ('returnError-unexpectedError', 33), ('returnError-mistypedParameter', 34)])
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name='InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name='present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name='absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        ('present', _InvokeId_present),
        ('absent', _InvokeId_absent),
        ])
    InvokeId._ext = None
    
    #-----< noInvokeId >-----#
    noInvokeId = CHOICE(name='noInvokeId', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    noInvokeId._val = ('absent', 0)
    
    #-----< NoInvokeId >-----#
    NoInvokeId = CHOICE(name='NoInvokeId', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    NoInvokeId._val = ASN1Set(rv=[('absent', 0)], rr=[], ev=None, er=[])
    
    #-----< Errors >-----#
    Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), param=True)
    
    #-----< Bind >-----#
    Bind = CHOICE(name='Bind', mode=MODE_TYPE, param=True)
    
    #-----< Unbind >-----#
    Unbind = CHOICE(name='Unbind', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _Reject_invokeId,
        __Reject_problem_general,
        __Reject_problem_invoke,
        __Reject_problem_returnResult,
        __Reject_problem_returnError,
        _Reject_problem,
        Reject,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        RejectProblem,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        noInvokeId,
        NoInvokeId,
    ]

class Remote_Operations_Information_Objects:

    _name_  = 'Remote-Operations-Information-Objects'
    _oid_   = [2, 4, 5, 0]
    
    _obj_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        'Code',
        'Priority',
        ]
    _type_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        'Code',
        'Priority',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'OPERATION',
        'ERROR',
        'OPERATION-PACKAGE',
        'CONNECTION-PACKAGE',
        'CONTRACT',
        'ROS-OBJECT-CLASS',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name='OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name='ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_argumentTypeOptional = BOOL(name='argumentTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_returnResult = BOOL(name='returnResult', mode=MODE_VALUE, default=True)
    _OPERATION_ResultType = OPEN(name='ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_resultTypeOptional = BOOL(name='resultTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), opt=True)
    _OPERATION_Linked = CLASS(name='Linked', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_synchronous = BOOL(name='synchronous', mode=MODE_VALUE, default=False)
    _OPERATION_alwaysReturns = BOOL(name='alwaysReturns', mode=MODE_VALUE, default=True)
    _OPERATION_InvokePriority = INT(name='InvokePriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_ResultPriority = INT(name='ResultPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_operationCode = CHOICE(name='operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        ('ArgumentType', _OPERATION_ArgumentType),
        ('argumentTypeOptional', _OPERATION_argumentTypeOptional),
        ('returnResult', _OPERATION_returnResult),
        ('ResultType', _OPERATION_ResultType),
        ('resultTypeOptional', _OPERATION_resultTypeOptional),
        ('Errors', _OPERATION_Errors),
        ('Linked', _OPERATION_Linked),
        ('synchronous', _OPERATION_synchronous),
        ('alwaysReturns', _OPERATION_alwaysReturns),
        ('InvokePriority', _OPERATION_InvokePriority),
        ('ResultPriority', _OPERATION_ResultPriority),
        ('operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name='ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name='ParameterType', mode=MODE_TYPE, opt=True)
    _ERROR_parameterTypeOptional = BOOL(name='parameterTypeOptional', mode=MODE_VALUE, opt=True)
    _ERROR_ErrorPriority = INT(name='ErrorPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _ERROR_errorCode = CHOICE(name='errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        ('ParameterType', _ERROR_ParameterType),
        ('parameterTypeOptional', _ERROR_parameterTypeOptional),
        ('ErrorPriority', _ERROR_ErrorPriority),
        ('errorCode', _ERROR_errorCode),
        ])
    
    #-----< OPERATION-PACKAGE >-----#
    OPERATION_PACKAGE = CLASS(name='OPERATION-PACKAGE', mode=MODE_TYPE)
    _OPERATION_PACKAGE_Both = CLASS(name='Both', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Consumer = CLASS(name='Consumer', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Supplier = CLASS(name='Supplier', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    OPERATION_PACKAGE._cont = ASN1Dict([
        ('Both', _OPERATION_PACKAGE_Both),
        ('Consumer', _OPERATION_PACKAGE_Consumer),
        ('Supplier', _OPERATION_PACKAGE_Supplier),
        ('id', _OPERATION_PACKAGE_id),
        ])
    
    #-----< CONNECTION-PACKAGE >-----#
    CONNECTION_PACKAGE = CLASS(name='CONNECTION-PACKAGE', mode=MODE_TYPE)
    _CONNECTION_PACKAGE_bind = CLASS(name='bind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([('Errors', ASN1Set(rv=[dict([('errorCode', ('local', -1))])], rr=[], ev=None, er=[])), ('synchronous', True)]))
    _CONNECTION_PACKAGE_unbind = CLASS(name='unbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([('synchronous', True)]))
    _CONNECTION_PACKAGE_responderCanUnbind = BOOL(name='responderCanUnbind', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_unbindCanFail = BOOL(name='unbindCanFail', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    CONNECTION_PACKAGE._cont = ASN1Dict([
        ('bind', _CONNECTION_PACKAGE_bind),
        ('unbind', _CONNECTION_PACKAGE_unbind),
        ('responderCanUnbind', _CONNECTION_PACKAGE_responderCanUnbind),
        ('unbindCanFail', _CONNECTION_PACKAGE_unbindCanFail),
        ('id', _CONNECTION_PACKAGE_id),
        ])
    
    #-----< CONTRACT >-----#
    CONTRACT = CLASS(name='CONTRACT', mode=MODE_TYPE)
    _CONTRACT_connection = CLASS(name='connection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONNECTION-PACKAGE')), opt=True)
    _CONTRACT_OperationsOf = CLASS(name='OperationsOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorConsumerOf = CLASS(name='InitiatorConsumerOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorSupplierOf = CLASS(name='InitiatorSupplierOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_id = OID(name='id', mode=MODE_VALUE, opt=True, uniq=True)
    CONTRACT._cont = ASN1Dict([
        ('connection', _CONTRACT_connection),
        ('OperationsOf', _CONTRACT_OperationsOf),
        ('InitiatorConsumerOf', _CONTRACT_InitiatorConsumerOf),
        ('InitiatorSupplierOf', _CONTRACT_InitiatorSupplierOf),
        ('id', _CONTRACT_id),
        ])
    
    #-----< ROS-OBJECT-CLASS >-----#
    ROS_OBJECT_CLASS = CLASS(name='ROS-OBJECT-CLASS', mode=MODE_TYPE)
    _ROS_OBJECT_CLASS_Is = CLASS(name='Is', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')), opt=True)
    _ROS_OBJECT_CLASS_Initiates = CLASS(name='Initiates', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_Responds = CLASS(name='Responds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_InitiatesAndResponds = CLASS(name='InitiatesAndResponds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ROS_OBJECT_CLASS._cont = ASN1Dict([
        ('Is', _ROS_OBJECT_CLASS_Is),
        ('Initiates', _ROS_OBJECT_CLASS_Initiates),
        ('Responds', _ROS_OBJECT_CLASS_Responds),
        ('InitiatesAndResponds', _ROS_OBJECT_CLASS_InitiatesAndResponds),
        ('id', _ROS_OBJECT_CLASS_id),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name='Code', mode=MODE_TYPE)
    _Code_local = INT(name='local', mode=MODE_TYPE)
    _Code_global_ = OID(name='global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        ('local', _Code_local),
        ('global', _Code_global_),
        ])
    Code._ext = None
    
    #-----< Priority >-----#
    Priority = INT(name='Priority', mode=MODE_TYPE)
    Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_argumentTypeOptional,
        _OPERATION_returnResult,
        _OPERATION_ResultType,
        _OPERATION_resultTypeOptional,
        _OPERATION_Errors,
        _OPERATION_Linked,
        _OPERATION_synchronous,
        _OPERATION_alwaysReturns,
        _OPERATION_InvokePriority,
        _OPERATION_ResultPriority,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_parameterTypeOptional,
        _ERROR_ErrorPriority,
        _ERROR_errorCode,
        ERROR,
        _OPERATION_PACKAGE_Both,
        _OPERATION_PACKAGE_Consumer,
        _OPERATION_PACKAGE_Supplier,
        _OPERATION_PACKAGE_id,
        OPERATION_PACKAGE,
        _CONNECTION_PACKAGE_bind,
        _CONNECTION_PACKAGE_unbind,
        _CONNECTION_PACKAGE_responderCanUnbind,
        _CONNECTION_PACKAGE_unbindCanFail,
        _CONNECTION_PACKAGE_id,
        CONNECTION_PACKAGE,
        _CONTRACT_connection,
        _CONTRACT_OperationsOf,
        _CONTRACT_InitiatorConsumerOf,
        _CONTRACT_InitiatorSupplierOf,
        _CONTRACT_id,
        CONTRACT,
        _ROS_OBJECT_CLASS_Is,
        _ROS_OBJECT_CLASS_Initiates,
        _ROS_OBJECT_CLASS_Responds,
        _ROS_OBJECT_CLASS_InitiatesAndResponds,
        _ROS_OBJECT_CLASS_id,
        ROS_OBJECT_CLASS,
        _Code_local,
        _Code_global_,
        Code,
        Priority,
    ]

class Remote_Operations_Useful_Definitions:

    _name_  = 'Remote-Operations-Useful-Definitions'
    _oid_   = [2, 4, 7, 0]
    
    _obj_ = [
        'emptyBind',
        'emptyUnbind',
        'refuse',
        'no-op',
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        'recode',
        'switch',
        'combine',
        'ROS-SingleAS',
        'ROS-ConsumerAS',
        'ROS-SupplierAS',
        ]
    _type_ = [
        'ROS-SingleAS',
        'ROS-ConsumerAS',
        'ROS-SupplierAS',
        ]
    _set_ = [
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        ]
    _val_ = [
        'emptyBind',
        'emptyUnbind',
        'refuse',
        'no-op',
        'recode',
        'switch',
        'combine',
        ]
    _class_ = [
        'emptyBind',
        'emptyUnbind',
        'refuse',
        'no-op',
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        'recode',
        'switch',
        'combine',
        ]
    _param_ = [
        'Forward',
        'Reverse',
        'ConsumerPerforms',
        'SupplierPerforms',
        'AllOperations',
        'recode',
        'switch',
        'combine',
        'ROS-SingleAS',
        'ROS-ConsumerAS',
        'ROS-SupplierAS',
        ]
    
    #-----< emptyBind >-----#
    emptyBind = CLASS(name='emptyBind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyBind._val = dict([('Errors', ASN1Set(rv=[dict([('errorCode', ('local', -1))])], rr=[], ev=None, er=[])), ('synchronous', True)])
    
    #-----< emptyUnbind >-----#
    emptyUnbind = CLASS(name='emptyUnbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyUnbind._val = dict([('synchronous', True)])
    
    #-----< refuse >-----#
    refuse = CLASS(name='refuse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    refuse._val = dict([('errorCode', ('local', -1))])
    
    #-----< no-op >-----#
    no_op = CLASS(name='no-op', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    no_op._val = dict([('alwaysReturns', False), ('operationCode', ('local', -1))])
    
    #-----< Forward >-----#
    Forward = CLASS(name='Forward', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< Reverse >-----#
    Reverse = CLASS(name='Reverse', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConsumerPerforms >-----#
    ConsumerPerforms = CLASS(name='ConsumerPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SupplierPerforms >-----#
    SupplierPerforms = CLASS(name='SupplierPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AllOperations >-----#
    AllOperations = CLASS(name='AllOperations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< recode >-----#
    recode = CLASS(name='recode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< switch >-----#
    switch = CLASS(name='switch', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< combine >-----#
    combine = CLASS(name='combine', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ROS-SingleAS >-----#
    ROS_SingleAS = CHOICE(name='ROS-SingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-ConsumerAS >-----#
    ROS_ConsumerAS = CHOICE(name='ROS-ConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-SupplierAS >-----#
    ROS_SupplierAS = CHOICE(name='ROS-SupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    _all_ = [
        emptyBind,
        emptyUnbind,
        refuse,
        no_op,
    ]

class SchemaAdministration:

    _name_  = 'SchemaAdministration'
    _oid_   = [2, 5, 1, 23, 8]
    
    _obj_ = [
        'subschema',
        'dITStructureRules',
        'DITStructureRuleDescription',
        'dITContentRules',
        'DITContentRuleDescription',
        'matchingRules',
        'MatchingRuleDescription',
        'attributeTypes',
        'AttributeTypeDescription',
        'AttributeTypeInformation',
        'objectClasses',
        'ObjectClassDescription',
        'ObjectClassInformation',
        'nameForms',
        'NameFormDescription',
        'NameFormInformation',
        'matchingRuleUse',
        'MatchingRuleUseDescription',
        'structuralObjectClass',
        'governingStructureRule',
        'contextTypes',
        'ContextDescription',
        'ContextInformation',
        'dITContextUse',
        'DITContextUseDescription',
        'DITContextUseInformation',
        'friends',
        'FriendsDescription',
        'id-soc-subschema',
        'id-soa-dITStructureRule',
        'id-soa-dITContentRules',
        'id-soa-matchingRules',
        'id-soa-attributeTypes',
        'id-soa-objectClasses',
        'id-soa-nameForms',
        'id-soa-matchingRuleUse',
        'id-soa-structuralObjectClass',
        'id-soa-governingStructureRule',
        'id-soa-contextTypes',
        'id-soa-dITContextUse',
        'id-soa-friends',
        ]
    _type_ = [
        'DITStructureRuleDescription',
        'DITContentRuleDescription',
        'MatchingRuleDescription',
        'AttributeTypeDescription',
        'AttributeTypeInformation',
        'ObjectClassDescription',
        'ObjectClassInformation',
        'NameFormDescription',
        'NameFormInformation',
        'MatchingRuleUseDescription',
        'ContextDescription',
        'ContextInformation',
        'DITContextUseDescription',
        'DITContextUseInformation',
        'FriendsDescription',
        ]
    _set_ = [
        ]
    _val_ = [
        'subschema',
        'dITStructureRules',
        'dITContentRules',
        'matchingRules',
        'attributeTypes',
        'objectClasses',
        'nameForms',
        'matchingRuleUse',
        'structuralObjectClass',
        'governingStructureRule',
        'contextTypes',
        'dITContextUse',
        'friends',
        'id-soc-subschema',
        'id-soa-dITStructureRule',
        'id-soa-dITContentRules',
        'id-soa-matchingRules',
        'id-soa-attributeTypes',
        'id-soa-objectClasses',
        'id-soa-nameForms',
        'id-soa-matchingRuleUse',
        'id-soa-structuralObjectClass',
        'id-soa-governingStructureRule',
        'id-soa-contextTypes',
        'id-soa-dITContextUse',
        'id-soa-friends',
        ]
    _class_ = [
        'subschema',
        'dITStructureRules',
        'dITContentRules',
        'matchingRules',
        'attributeTypes',
        'objectClasses',
        'nameForms',
        'matchingRuleUse',
        'structuralObjectClass',
        'governingStructureRule',
        'contextTypes',
        'dITContextUse',
        'friends',
        ]
    _param_ = [
        ]
    
    #-----< subschema >-----#
    subschema = CLASS(name='subschema', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    __OBJECT_CLASS_OptionalAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = OID(name='AssertionType', mode=MODE_TYPE)
    __OBJECT_CLASS_OptionalAttributes_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'FriendsDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ContextDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_7 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_8 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_9 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_10 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('LdapSystemSchema', 'LdapSyntaxDescription')))
    subschema._val = dict([('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)), ('ldapName', ['dITStructureRules']), ('id', (2, 5, 21, 1))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)), ('ldapName', ['nameForms']), ('id', (2, 5, 21, 7))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)), ('ldapName', ['dITContentRules']), ('id', (2, 5, 21, 2))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_3), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)), ('ldapName', ['objectClasses']), ('id', (2, 5, 21, 6))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_4), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)), ('ldapName', ['attributeTypes']), ('id', (2, 5, 21, 5))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_5), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 13))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 11))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_7), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 12))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_8), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)), ('ldapName', ['matchingRules']), ('id', (2, 5, 21, 4))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_9), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)), ('ldapName', ['matchingRuleUse']), ('id', (2, 5, 21, 8))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_10), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)), ('ldapName', ['ldapSyntax']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16))])], rr=[], ev=None, er=[])), ('ldapName', ['subschema']), ('id', (2, 5, 20, 1))])
    
    #-----< dITStructureRules >-----#
    dITStructureRules = CLASS(name='dITStructureRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITStructureRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    dITStructureRules._val = dict([('Type', _dITStructureRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)), ('ldapName', ['dITStructureRules']), ('id', (2, 5, 21, 1))])
    
    #-----< DITStructureRuleDescription >-----#
    DITStructureRuleDescription = SEQ(name='DITStructureRuleDescription', mode=MODE_TYPE)
    _DITStructureRuleDescription_ruleIdentifier = INT(name='ruleIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRuleDescription_nameForm = OID(name='nameForm', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), ['id']))
    _DITStructureRuleDescription_superiorStructureRules = SET_OF(name='superiorStructureRules', mode=MODE_TYPE, opt=True)
    __DITStructureRuleDescription_superiorStructureRules__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRuleDescription_superiorStructureRules._cont = __DITStructureRuleDescription_superiorStructureRules__item_
    _DITStructureRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITStructureRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITStructureRuleDescription_name._cont = __DITStructureRuleDescription_name__item_
    _DITStructureRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITStructureRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITStructureRuleDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    DITStructureRuleDescription._cont = ASN1Dict([
        ('ruleIdentifier', _DITStructureRuleDescription_ruleIdentifier),
        ('nameForm', _DITStructureRuleDescription_nameForm),
        ('superiorStructureRules', _DITStructureRuleDescription_superiorStructureRules),
        ('name', _DITStructureRuleDescription_name),
        ('description', _DITStructureRuleDescription_description),
        ('obsolete', _DITStructureRuleDescription_obsolete),
        ])
    DITStructureRuleDescription._ext = []
    
    #-----< dITContentRules >-----#
    dITContentRules = CLASS(name='dITContentRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITContentRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    dITContentRules._val = dict([('Type', _dITContentRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)), ('ldapName', ['dITContentRules']), ('id', (2, 5, 21, 2))])
    
    #-----< DITContentRuleDescription >-----#
    DITContentRuleDescription = SEQ(name='DITContentRuleDescription', mode=MODE_TYPE)
    _DITContentRuleDescription_structuralObjectClass = OID(name='structuralObjectClass', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRuleDescription_auxiliaries = SET_OF(name='auxiliaries', mode=MODE_TYPE, opt=True)
    __DITContentRuleDescription_auxiliaries__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRuleDescription_auxiliaries._cont = __DITContentRuleDescription_auxiliaries__item_
    _DITContentRuleDescription_mandatory = SET_OF(name='mandatory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_mandatory__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRuleDescription_mandatory._cont = __DITContentRuleDescription_mandatory__item_
    _DITContentRuleDescription_optional = SET_OF(name='optional', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_optional__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRuleDescription_optional._cont = __DITContentRuleDescription_optional__item_
    _DITContentRuleDescription_precluded = SET_OF(name='precluded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_precluded__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRuleDescription_precluded._cont = __DITContentRuleDescription_precluded__item_
    _DITContentRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITContentRuleDescription_name._cont = __DITContentRuleDescription_name__item_
    _DITContentRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITContentRuleDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    DITContentRuleDescription._cont = ASN1Dict([
        ('structuralObjectClass', _DITContentRuleDescription_structuralObjectClass),
        ('auxiliaries', _DITContentRuleDescription_auxiliaries),
        ('mandatory', _DITContentRuleDescription_mandatory),
        ('optional', _DITContentRuleDescription_optional),
        ('precluded', _DITContentRuleDescription_precluded),
        ('name', _DITContentRuleDescription_name),
        ('description', _DITContentRuleDescription_description),
        ('obsolete', _DITContentRuleDescription_obsolete),
        ])
    DITContentRuleDescription._ext = []
    
    #-----< matchingRules >-----#
    matchingRules = CLASS(name='matchingRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    matchingRules._val = dict([('Type', _matchingRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)), ('ldapName', ['matchingRules']), ('id', (2, 5, 21, 4))])
    
    #-----< MatchingRuleDescription >-----#
    MatchingRuleDescription = SEQ(name='MatchingRuleDescription', mode=MODE_TYPE)
    _MatchingRuleDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MatchingRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __MatchingRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _MatchingRuleDescription_name._cont = __MatchingRuleDescription_name__item_
    _MatchingRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _MatchingRuleDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _MatchingRuleDescription_information = CHOICE(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    MatchingRuleDescription._cont = ASN1Dict([
        ('identifier', _MatchingRuleDescription_identifier),
        ('name', _MatchingRuleDescription_name),
        ('description', _MatchingRuleDescription_description),
        ('obsolete', _MatchingRuleDescription_obsolete),
        ('information', _MatchingRuleDescription_information),
        ])
    MatchingRuleDescription._ext = []
    
    #-----< attributeTypes >-----#
    attributeTypes = CLASS(name='attributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeTypes_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    attributeTypes._val = dict([('Type', _attributeTypes_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)), ('ldapName', ['attributeTypes']), ('id', (2, 5, 21, 5))])
    
    #-----< AttributeTypeDescription >-----#
    AttributeTypeDescription = SEQ(name='AttributeTypeDescription', mode=MODE_TYPE)
    _AttributeTypeDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _AttributeTypeDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __AttributeTypeDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _AttributeTypeDescription_name._cont = __AttributeTypeDescription_name__item_
    _AttributeTypeDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeTypeDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _AttributeTypeDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _AttributeTypeDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeInformation')))
    AttributeTypeDescription._cont = ASN1Dict([
        ('identifier', _AttributeTypeDescription_identifier),
        ('name', _AttributeTypeDescription_name),
        ('description', _AttributeTypeDescription_description),
        ('obsolete', _AttributeTypeDescription_obsolete),
        ('information', _AttributeTypeDescription_information),
        ])
    AttributeTypeDescription._ext = []
    
    #-----< AttributeTypeInformation >-----#
    AttributeTypeInformation = SEQ(name='AttributeTypeInformation', mode=MODE_TYPE)
    _AttributeTypeInformation_derivation = OID(name='derivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']), opt=True)
    _AttributeTypeInformation_equalityMatch = OID(name='equalityMatch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _AttributeTypeInformation_orderingMatch = OID(name='orderingMatch', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _AttributeTypeInformation_substringsMatch = OID(name='substringsMatch', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _AttributeTypeInformation_attributeSyntax = CHOICE(name='attributeSyntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _AttributeTypeInformation_multi_valued = BOOL(name='multi-valued', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AttributeTypeInformation_collective = BOOL(name='collective', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AttributeTypeInformation_userModifiable = BOOL(name='userModifiable', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AttributeTypeInformation_application = ENUM(name='application', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeUsage')), default='userApplications')
    AttributeTypeInformation._cont = ASN1Dict([
        ('derivation', _AttributeTypeInformation_derivation),
        ('equalityMatch', _AttributeTypeInformation_equalityMatch),
        ('orderingMatch', _AttributeTypeInformation_orderingMatch),
        ('substringsMatch', _AttributeTypeInformation_substringsMatch),
        ('attributeSyntax', _AttributeTypeInformation_attributeSyntax),
        ('multi-valued', _AttributeTypeInformation_multi_valued),
        ('collective', _AttributeTypeInformation_collective),
        ('userModifiable', _AttributeTypeInformation_userModifiable),
        ('application', _AttributeTypeInformation_application),
        ])
    AttributeTypeInformation._ext = []
    
    #-----< objectClasses >-----#
    objectClasses = CLASS(name='objectClasses', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _objectClasses_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    objectClasses._val = dict([('Type', _objectClasses_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)), ('ldapName', ['objectClasses']), ('id', (2, 5, 21, 6))])
    
    #-----< ObjectClassDescription >-----#
    ObjectClassDescription = SEQ(name='ObjectClassDescription', mode=MODE_TYPE)
    _ObjectClassDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _ObjectClassDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __ObjectClassDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ObjectClassDescription_name._cont = __ObjectClassDescription_name__item_
    _ObjectClassDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _ObjectClassDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _ObjectClassDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassInformation')))
    ObjectClassDescription._cont = ASN1Dict([
        ('identifier', _ObjectClassDescription_identifier),
        ('name', _ObjectClassDescription_name),
        ('description', _ObjectClassDescription_description),
        ('obsolete', _ObjectClassDescription_obsolete),
        ('information', _ObjectClassDescription_information),
        ])
    ObjectClassDescription._ext = []
    
    #-----< ObjectClassInformation >-----#
    ObjectClassInformation = SEQ(name='ObjectClassInformation', mode=MODE_TYPE)
    _ObjectClassInformation_subclassOf = SET_OF(name='subclassOf', mode=MODE_TYPE, opt=True)
    __ObjectClassInformation_subclassOf__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _ObjectClassInformation_subclassOf._cont = __ObjectClassInformation_subclassOf__item_
    _ObjectClassInformation_subclassOf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassInformation_kind = ENUM(name='kind', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ObjectClassKind')), default='structural')
    _ObjectClassInformation_mandatories = SET_OF(name='mandatories', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ObjectClassInformation_mandatories__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _ObjectClassInformation_mandatories._cont = __ObjectClassInformation_mandatories__item_
    _ObjectClassInformation_mandatories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassInformation_optionals = SET_OF(name='optionals', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ObjectClassInformation_optionals__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _ObjectClassInformation_optionals._cont = __ObjectClassInformation_optionals__item_
    _ObjectClassInformation_optionals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ObjectClassInformation._cont = ASN1Dict([
        ('subclassOf', _ObjectClassInformation_subclassOf),
        ('kind', _ObjectClassInformation_kind),
        ('mandatories', _ObjectClassInformation_mandatories),
        ('optionals', _ObjectClassInformation_optionals),
        ])
    ObjectClassInformation._ext = []
    
    #-----< nameForms >-----#
    nameForms = CLASS(name='nameForms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _nameForms_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    nameForms._val = dict([('Type', _nameForms_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)), ('ldapName', ['nameForms']), ('id', (2, 5, 21, 7))])
    
    #-----< NameFormDescription >-----#
    NameFormDescription = SEQ(name='NameFormDescription', mode=MODE_TYPE)
    _NameFormDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), ['id']))
    _NameFormDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __NameFormDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _NameFormDescription_name._cont = __NameFormDescription_name__item_
    _NameFormDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _NameFormDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _NameFormDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _NameFormDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'NameFormInformation')))
    NameFormDescription._cont = ASN1Dict([
        ('identifier', _NameFormDescription_identifier),
        ('name', _NameFormDescription_name),
        ('description', _NameFormDescription_description),
        ('obsolete', _NameFormDescription_obsolete),
        ('information', _NameFormDescription_information),
        ])
    NameFormDescription._ext = []
    
    #-----< NameFormInformation >-----#
    NameFormInformation = SEQ(name='NameFormInformation', mode=MODE_TYPE)
    _NameFormInformation_subordinate = OID(name='subordinate', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _NameFormInformation_namingMandatories = SET_OF(name='namingMandatories', mode=MODE_TYPE)
    __NameFormInformation_namingMandatories__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _NameFormInformation_namingMandatories._cont = __NameFormInformation_namingMandatories__item_
    _NameFormInformation_namingOptionals = SET_OF(name='namingOptionals', mode=MODE_TYPE, opt=True)
    __NameFormInformation_namingOptionals__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _NameFormInformation_namingOptionals._cont = __NameFormInformation_namingOptionals__item_
    _NameFormInformation_namingOptionals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    NameFormInformation._cont = ASN1Dict([
        ('subordinate', _NameFormInformation_subordinate),
        ('namingMandatories', _NameFormInformation_namingMandatories),
        ('namingOptionals', _NameFormInformation_namingOptionals),
        ])
    NameFormInformation._ext = []
    
    #-----< matchingRuleUse >-----#
    matchingRuleUse = CLASS(name='matchingRuleUse', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRuleUse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    matchingRuleUse._val = dict([('Type', _matchingRuleUse_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)), ('ldapName', ['matchingRuleUse']), ('id', (2, 5, 21, 8))])
    
    #-----< MatchingRuleUseDescription >-----#
    MatchingRuleUseDescription = SEQ(name='MatchingRuleUseDescription', mode=MODE_TYPE)
    _MatchingRuleUseDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MatchingRuleUseDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __MatchingRuleUseDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _MatchingRuleUseDescription_name._cont = __MatchingRuleUseDescription_name__item_
    _MatchingRuleUseDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleUseDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _MatchingRuleUseDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _MatchingRuleUseDescription_information = SET_OF(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MatchingRuleUseDescription_information__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _MatchingRuleUseDescription_information._cont = __MatchingRuleUseDescription_information__item_
    MatchingRuleUseDescription._cont = ASN1Dict([
        ('identifier', _MatchingRuleUseDescription_identifier),
        ('name', _MatchingRuleUseDescription_name),
        ('description', _MatchingRuleUseDescription_description),
        ('obsolete', _MatchingRuleUseDescription_obsolete),
        ('information', _MatchingRuleUseDescription_information),
        ])
    MatchingRuleUseDescription._ext = []
    
    #-----< structuralObjectClass >-----#
    structuralObjectClass = CLASS(name='structuralObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _structuralObjectClass_val_Type = OID(name='Type', mode=MODE_TYPE)
    structuralObjectClass._val = dict([('Type', _structuralObjectClass_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['structuralObjectClass']), ('id', (2, 5, 21, 9))])
    
    #-----< governingStructureRule >-----#
    governingStructureRule = CLASS(name='governingStructureRule', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _governingStructureRule_val_Type = INT(name='Type', mode=MODE_TYPE)
    governingStructureRule._val = dict([('Type', _governingStructureRule_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['governingStructureRule']), ('id', (2, 5, 21, 10))])
    
    #-----< contextTypes >-----#
    contextTypes = CLASS(name='contextTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextTypes_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ContextDescription')))
    contextTypes._val = dict([('Type', _contextTypes_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 11))])
    
    #-----< ContextDescription >-----#
    ContextDescription = SEQ(name='ContextDescription', mode=MODE_TYPE)
    _ContextDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _ContextDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __ContextDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ContextDescription_name._cont = __ContextDescription_name__item_
    _ContextDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ContextDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _ContextDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _ContextDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'ContextInformation')))
    ContextDescription._cont = ASN1Dict([
        ('identifier', _ContextDescription_identifier),
        ('name', _ContextDescription_name),
        ('description', _ContextDescription_description),
        ('obsolete', _ContextDescription_obsolete),
        ('information', _ContextDescription_information),
        ])
    ContextDescription._ext = []
    
    #-----< ContextInformation >-----#
    ContextInformation = SEQ(name='ContextInformation', mode=MODE_TYPE)
    _ContextInformation_syntax = CHOICE(name='syntax', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ContextInformation_assertionSyntax = CHOICE(name='assertionSyntax', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    ContextInformation._cont = ASN1Dict([
        ('syntax', _ContextInformation_syntax),
        ('assertionSyntax', _ContextInformation_assertionSyntax),
        ])
    ContextInformation._ext = []
    
    #-----< dITContextUse >-----#
    dITContextUse = CLASS(name='dITContextUse', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITContextUse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseDescription')))
    dITContextUse._val = dict([('Type', _dITContextUse_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 12))])
    
    #-----< DITContextUseDescription >-----#
    DITContextUseDescription = SEQ(name='DITContextUseDescription', mode=MODE_TYPE)
    _DITContextUseDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContextUseDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __DITContextUseDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITContextUseDescription_name._cont = __DITContextUseDescription_name__item_
    _DITContextUseDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUseDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITContextUseDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _DITContextUseDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseInformation')))
    DITContextUseDescription._cont = ASN1Dict([
        ('identifier', _DITContextUseDescription_identifier),
        ('name', _DITContextUseDescription_name),
        ('description', _DITContextUseDescription_description),
        ('obsolete', _DITContextUseDescription_obsolete),
        ('information', _DITContextUseDescription_information),
        ])
    DITContextUseDescription._ext = []
    
    #-----< DITContextUseInformation >-----#
    DITContextUseInformation = SEQ(name='DITContextUseInformation', mode=MODE_TYPE)
    _DITContextUseInformation_mandatoryContexts = SET_OF(name='mandatoryContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUseInformation_mandatoryContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUseInformation_mandatoryContexts._cont = __DITContextUseInformation_mandatoryContexts__item_
    _DITContextUseInformation_mandatoryContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUseInformation_optionalContexts = SET_OF(name='optionalContexts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUseInformation_optionalContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUseInformation_optionalContexts._cont = __DITContextUseInformation_optionalContexts__item_
    _DITContextUseInformation_optionalContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContextUseInformation._cont = ASN1Dict([
        ('mandatoryContexts', _DITContextUseInformation_mandatoryContexts),
        ('optionalContexts', _DITContextUseInformation_optionalContexts),
        ])
    DITContextUseInformation._ext = []
    
    #-----< friends >-----#
    friends = CLASS(name='friends', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _friends_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'FriendsDescription')))
    friends._val = dict([('Type', _friends_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 13))])
    
    #-----< FriendsDescription >-----#
    FriendsDescription = SEQ(name='FriendsDescription', mode=MODE_TYPE)
    _FriendsDescription_anchor = OID(name='anchor', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _FriendsDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __FriendsDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _FriendsDescription_name._cont = __FriendsDescription_name__item_
    _FriendsDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _FriendsDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _FriendsDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _FriendsDescription_friends = SET_OF(name='friends', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FriendsDescription_friends__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _FriendsDescription_friends._cont = __FriendsDescription_friends__item_
    _FriendsDescription_friends._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FriendsDescription._cont = ASN1Dict([
        ('anchor', _FriendsDescription_anchor),
        ('name', _FriendsDescription_name),
        ('description', _FriendsDescription_description),
        ('obsolete', _FriendsDescription_obsolete),
        ('friends', _FriendsDescription_friends),
        ])
    FriendsDescription._ext = []
    
    #-----< id-soc-subschema >-----#
    id_soc_subschema = OID(name='id-soc-subschema', mode=MODE_VALUE)
    id_soc_subschema._val = (2, 5, 20, 1)
    
    #-----< id-soa-dITStructureRule >-----#
    id_soa_dITStructureRule = OID(name='id-soa-dITStructureRule', mode=MODE_VALUE)
    id_soa_dITStructureRule._val = (2, 5, 21, 1)
    
    #-----< id-soa-dITContentRules >-----#
    id_soa_dITContentRules = OID(name='id-soa-dITContentRules', mode=MODE_VALUE)
    id_soa_dITContentRules._val = (2, 5, 21, 2)
    
    #-----< id-soa-matchingRules >-----#
    id_soa_matchingRules = OID(name='id-soa-matchingRules', mode=MODE_VALUE)
    id_soa_matchingRules._val = (2, 5, 21, 4)
    
    #-----< id-soa-attributeTypes >-----#
    id_soa_attributeTypes = OID(name='id-soa-attributeTypes', mode=MODE_VALUE)
    id_soa_attributeTypes._val = (2, 5, 21, 5)
    
    #-----< id-soa-objectClasses >-----#
    id_soa_objectClasses = OID(name='id-soa-objectClasses', mode=MODE_VALUE)
    id_soa_objectClasses._val = (2, 5, 21, 6)
    
    #-----< id-soa-nameForms >-----#
    id_soa_nameForms = OID(name='id-soa-nameForms', mode=MODE_VALUE)
    id_soa_nameForms._val = (2, 5, 21, 7)
    
    #-----< id-soa-matchingRuleUse >-----#
    id_soa_matchingRuleUse = OID(name='id-soa-matchingRuleUse', mode=MODE_VALUE)
    id_soa_matchingRuleUse._val = (2, 5, 21, 8)
    
    #-----< id-soa-structuralObjectClass >-----#
    id_soa_structuralObjectClass = OID(name='id-soa-structuralObjectClass', mode=MODE_VALUE)
    id_soa_structuralObjectClass._val = (2, 5, 21, 9)
    
    #-----< id-soa-governingStructureRule >-----#
    id_soa_governingStructureRule = OID(name='id-soa-governingStructureRule', mode=MODE_VALUE)
    id_soa_governingStructureRule._val = (2, 5, 21, 10)
    
    #-----< id-soa-contextTypes >-----#
    id_soa_contextTypes = OID(name='id-soa-contextTypes', mode=MODE_VALUE)
    id_soa_contextTypes._val = (2, 5, 21, 11)
    
    #-----< id-soa-dITContextUse >-----#
    id_soa_dITContextUse = OID(name='id-soa-dITContextUse', mode=MODE_VALUE)
    id_soa_dITContextUse._val = (2, 5, 21, 12)
    
    #-----< id-soa-friends >-----#
    id_soa_friends = OID(name='id-soa-friends', mode=MODE_VALUE)
    id_soa_friends._val = (2, 5, 21, 13)
    
    _all_ = [
        subschema,
        __OBJECT_CLASS_OptionalAttributes_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        __OBJECT_CLASS_OptionalAttributes_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        __OBJECT_CLASS_OptionalAttributes_val_Type_2,
        __OBJECT_CLASS_OptionalAttributes_val_Type_3,
        __OBJECT_CLASS_OptionalAttributes_val_Type_4,
        __OBJECT_CLASS_OptionalAttributes_val_Type_5,
        __OBJECT_CLASS_OptionalAttributes_val_Type_6,
        __OBJECT_CLASS_OptionalAttributes_val_Type_7,
        __OBJECT_CLASS_OptionalAttributes_val_Type_8,
        __OBJECT_CLASS_OptionalAttributes_val_Type_9,
        __OBJECT_CLASS_OptionalAttributes_val_Type_10,
        dITStructureRules,
        _dITStructureRules_val_Type,
        _DITStructureRuleDescription_ruleIdentifier,
        _DITStructureRuleDescription_nameForm,
        __DITStructureRuleDescription_superiorStructureRules__item_,
        _DITStructureRuleDescription_superiorStructureRules,
        __DITStructureRuleDescription_name__item_,
        _DITStructureRuleDescription_name,
        _DITStructureRuleDescription_description,
        _DITStructureRuleDescription_obsolete,
        DITStructureRuleDescription,
        dITContentRules,
        _dITContentRules_val_Type,
        _DITContentRuleDescription_structuralObjectClass,
        __DITContentRuleDescription_auxiliaries__item_,
        _DITContentRuleDescription_auxiliaries,
        __DITContentRuleDescription_mandatory__item_,
        _DITContentRuleDescription_mandatory,
        __DITContentRuleDescription_optional__item_,
        _DITContentRuleDescription_optional,
        __DITContentRuleDescription_precluded__item_,
        _DITContentRuleDescription_precluded,
        __DITContentRuleDescription_name__item_,
        _DITContentRuleDescription_name,
        _DITContentRuleDescription_description,
        _DITContentRuleDescription_obsolete,
        DITContentRuleDescription,
        matchingRules,
        _matchingRules_val_Type,
        _MatchingRuleDescription_identifier,
        __MatchingRuleDescription_name__item_,
        _MatchingRuleDescription_name,
        _MatchingRuleDescription_description,
        _MatchingRuleDescription_obsolete,
        _MatchingRuleDescription_information,
        MatchingRuleDescription,
        attributeTypes,
        _attributeTypes_val_Type,
        _AttributeTypeDescription_identifier,
        __AttributeTypeDescription_name__item_,
        _AttributeTypeDescription_name,
        _AttributeTypeDescription_description,
        _AttributeTypeDescription_obsolete,
        _AttributeTypeDescription_information,
        AttributeTypeDescription,
        _AttributeTypeInformation_derivation,
        _AttributeTypeInformation_equalityMatch,
        _AttributeTypeInformation_orderingMatch,
        _AttributeTypeInformation_substringsMatch,
        _AttributeTypeInformation_attributeSyntax,
        _AttributeTypeInformation_multi_valued,
        _AttributeTypeInformation_collective,
        _AttributeTypeInformation_userModifiable,
        _AttributeTypeInformation_application,
        AttributeTypeInformation,
        objectClasses,
        _objectClasses_val_Type,
        _ObjectClassDescription_identifier,
        __ObjectClassDescription_name__item_,
        _ObjectClassDescription_name,
        _ObjectClassDescription_description,
        _ObjectClassDescription_obsolete,
        _ObjectClassDescription_information,
        ObjectClassDescription,
        __ObjectClassInformation_subclassOf__item_,
        _ObjectClassInformation_subclassOf,
        _ObjectClassInformation_kind,
        __ObjectClassInformation_mandatories__item_,
        _ObjectClassInformation_mandatories,
        __ObjectClassInformation_optionals__item_,
        _ObjectClassInformation_optionals,
        ObjectClassInformation,
        nameForms,
        _nameForms_val_Type,
        _NameFormDescription_identifier,
        __NameFormDescription_name__item_,
        _NameFormDescription_name,
        _NameFormDescription_description,
        _NameFormDescription_obsolete,
        _NameFormDescription_information,
        NameFormDescription,
        _NameFormInformation_subordinate,
        __NameFormInformation_namingMandatories__item_,
        _NameFormInformation_namingMandatories,
        __NameFormInformation_namingOptionals__item_,
        _NameFormInformation_namingOptionals,
        NameFormInformation,
        matchingRuleUse,
        _matchingRuleUse_val_Type,
        _MatchingRuleUseDescription_identifier,
        __MatchingRuleUseDescription_name__item_,
        _MatchingRuleUseDescription_name,
        _MatchingRuleUseDescription_description,
        _MatchingRuleUseDescription_obsolete,
        __MatchingRuleUseDescription_information__item_,
        _MatchingRuleUseDescription_information,
        MatchingRuleUseDescription,
        structuralObjectClass,
        _structuralObjectClass_val_Type,
        governingStructureRule,
        _governingStructureRule_val_Type,
        contextTypes,
        _contextTypes_val_Type,
        _ContextDescription_identifier,
        __ContextDescription_name__item_,
        _ContextDescription_name,
        _ContextDescription_description,
        _ContextDescription_obsolete,
        _ContextDescription_information,
        ContextDescription,
        _ContextInformation_syntax,
        _ContextInformation_assertionSyntax,
        ContextInformation,
        dITContextUse,
        _dITContextUse_val_Type,
        _DITContextUseDescription_identifier,
        __DITContextUseDescription_name__item_,
        _DITContextUseDescription_name,
        _DITContextUseDescription_description,
        _DITContextUseDescription_obsolete,
        _DITContextUseDescription_information,
        DITContextUseDescription,
        __DITContextUseInformation_mandatoryContexts__item_,
        _DITContextUseInformation_mandatoryContexts,
        __DITContextUseInformation_optionalContexts__item_,
        _DITContextUseInformation_optionalContexts,
        DITContextUseInformation,
        friends,
        _friends_val_Type,
        _FriendsDescription_anchor,
        __FriendsDescription_name__item_,
        _FriendsDescription_name,
        _FriendsDescription_description,
        _FriendsDescription_obsolete,
        __FriendsDescription_friends__item_,
        _FriendsDescription_friends,
        FriendsDescription,
        id_soc_subschema,
        id_soa_dITStructureRule,
        id_soa_dITContentRules,
        id_soa_matchingRules,
        id_soa_attributeTypes,
        id_soa_objectClasses,
        id_soa_nameForms,
        id_soa_matchingRuleUse,
        id_soa_structuralObjectClass,
        id_soa_governingStructureRule,
        id_soa_contextTypes,
        id_soa_dITContextUse,
        id_soa_friends,
    ]

class SelectedAttributeTypes:

    _name_  = 'SelectedAttributeTypes'
    _oid_   = [2, 5, 1, 5, 8]
    
    _obj_ = [
        'UnboundedDirectoryString',
        'DirectoryString',
        'knowledgeInformation',
        'name',
        'commonName',
        'surname',
        'givenName',
        'initials',
        'generationQualifier',
        'uniqueIdentifier',
        'UniqueIdentifier',
        'dnQualifier',
        'serialNumber',
        'pseudonym',
        'uUIDPair',
        'UUIDPair',
        'UUID',
        'uri',
        'URI',
        'urn',
        'url',
        'dnsName',
        'DomainName',
        'countryName',
        'CountryName',
        'countryCode3c',
        'CountryCode3c',
        'countryCode3n',
        'CountryCode3n',
        'localityName',
        'collectiveLocalityName',
        'stateOrProvinceName',
        'collectiveStateOrProvinceName',
        'streetAddress',
        'collectiveStreetAddress',
        'houseIdentifier',
        'utmCoordinates',
        'UtmCoordinates',
        'organizationName',
        'collectiveOrganizationName',
        'organizationalUnitName',
        'collectiveOrganizationalUnitName',
        'title',
        'organizationIdentifier',
        'description',
        'searchGuide',
        'Guide',
        'Criteria',
        'CriteriaItem',
        'enhancedSearchGuide',
        'EnhancedGuide',
        'businessCategory',
        'postalAddress',
        'PostalAddress',
        'collectivePostalAddress',
        'postalCode',
        'collectivePostalCode',
        'postOfficeBox',
        'collectivePostOfficeBox',
        'physicalDeliveryOfficeName',
        'collectivePhysicalDeliveryOfficeName',
        'telephoneNumber',
        'TelephoneNumber',
        'ub-telephone-number',
        'collectiveTelephoneNumber',
        'telexNumber',
        'TelexNumber',
        'ub-telex-number',
        'ub-country-code',
        'ub-answerback',
        'collectiveTelexNumber',
        'facsimileTelephoneNumber',
        'FacsimileTelephoneNumber',
        'collectiveFacsimileTelephoneNumber',
        'x121Address',
        'X121Address',
        'ub-x121-address',
        'internationalISDNNumber',
        'InternationalISDNNumber',
        'ub-international-isdn-number',
        'collectiveInternationalISDNNumber',
        'registeredAddress',
        'destinationIndicator',
        'DestinationIndicator',
        'communicationsService',
        'CommunicationsService',
        'communicationsNetwork',
        'CommunicationsNetwork',
        'preferredDeliveryMethod',
        'PreferredDeliveryMethod',
        'presentationAddress',
        'PresentationAddress',
        'supportedApplicationContext',
        'protocolInformation',
        'ProtocolInformation',
        'distinguishedName',
        'member',
        'uniqueMember',
        'NameAndOptionalUID',
        'owner',
        'roleOccupant',
        'seeAlso',
        'dmdName',
        'oidC1',
        'oidC2',
        'oidC',
        'urnC',
        'tagOid',
        'uiiFormat',
        'UiiFormat',
        'UiiFilter',
        'UiiItem',
        'uiiInUrn',
        'contentUrl',
        'uii',
        'epc',
        'tagAfi',
        'epcFormat',
        'EpcFormat',
        'epcInUrn',
        'ldapUrl',
        'tagLocation',
        'dSAProblem',
        'searchServiceProblem',
        'serviceType',
        'attributeTypeList',
        'matchingRuleList',
        'filterItem',
        'attributeCombinations',
        'contextTypeList',
        'contextList',
        'contextCombinations',
        'hierarchySelectList',
        'searchControlOptionsList',
        'serviceControlOptionsList',
        'multipleMatchingLocalities',
        'MultipleMatchingLocalities',
        'proposedRelaxation',
        'MRMappings',
        'appliedRelaxation',
        'pwdResponseValue',
        'PwdResponse',
        'ldapDiagnosticMsg',
        'uid',
        'dc',
        'caseExactMatch',
        'caseIgnoreMatch',
        'caseExactOrderingMatch',
        'caseIgnoreOrderingMatch',
        'caseExactSubstringsMatch',
        'caseIgnoreSubstringsMatch',
        'SubstringAssertion',
        'numericStringMatch',
        'numericStringOrderingMatch',
        'numericStringSubstringsMatch',
        'caseIgnoreListMatch',
        'CaseIgnoreList',
        'caseIgnoreListSubstringsMatch',
        'storedPrefixMatch',
        'booleanMatch',
        'integerMatch',
        'integerOrderingMatch',
        'bitStringMatch',
        'octetStringMatch',
        'octetStringOrderingMatch',
        'octetStringSubstringsMatch',
        'OctetSubstringAssertion',
        'telephoneNumberMatch',
        'telephoneNumberSubstringsMatch',
        'presentationAddressMatch',
        'uniqueMemberMatch',
        'protocolInformationMatch',
        'facsimileNumberMatch',
        'facsimileNumberSubstringsMatch',
        'uUIDPairMatch',
        'uTCTimeMatch',
        'uTCTimeOrderingMatch',
        'generalizedTimeMatch',
        'generalizedTimeOrderingMatch',
        'systemProposedMatch',
        'integerFirstComponentMatch',
        'objectIdentifierFirstComponentMatch',
        'directoryStringFirstComponentMatch',
        'wordMatch',
        'keywordMatch',
        'generalWordMatch',
        'sequenceMatchType',
        'SequenceMatchType',
        'wordMatchTypes',
        'WordMatchTypes',
        'characterMatchTypes',
        'CharacterMatchTypes',
        'selectedContexts',
        'approximateStringMatch',
        'ignoreIfAbsentMatch',
        'nullMatch',
        'ZONAL-MATCHING',
        'ZonalSelect',
        'ZonalResult',
        'zonalMatch',
        'uriMatch',
        'dnsNameMatch',
        'caseExactIA5Match',
        'caseIgnoreIA5Match',
        'caseIgnoreIA5SubstringsMatch',
        'utmCoords',
        'uiiForm',
        'epcForm',
        'countryString3c',
        'countryString3n',
        'dnsString',
        'attributeTypeDescription',
        'bitString',
        'boolean',
        'countryString',
        'dn',
        'deliveryMethod',
        'directoryString',
        'dITContentRuleDescription',
        'dITStructureRuleDescription',
        'enhancedGuide',
        'facsimileTelephoneNr',
        'fax',
        'generalizedTime',
        'guide',
        'ia5String',
        'integer',
        'jpeg',
        'matchingRuleDescription',
        'matchingRuleUseDescription',
        'nameAndOptionalUID',
        'nameFormDescription',
        'numericString',
        'objectClassDescription',
        'oid',
        'otherMailbox',
        'octetString',
        'postalAddr',
        'presentationAddr',
        'printableString',
        'subtreeSpec',
        'telephoneNr',
        'telexNr',
        'utcTime',
        'ldapSyntaxDescription',
        'substringAssertion',
        'languageContext',
        'LanguageContextSyntax',
        'temporalContext',
        'TimeSpecification',
        'Period',
        'XDayOf',
        'NamedDay',
        'DayTimeBand',
        'DayTime',
        'TimeZone',
        'TimeAssertion',
        'localeContext',
        'LocaleContextSyntax',
        'ldapAttributeOptionContext',
        'AttributeOptionList',
        'id-at-knowledgeInformation',
        'id-at-commonName',
        'id-at-surname',
        'id-at-serialNumber',
        'id-at-countryName',
        'id-at-localityName',
        'id-at-collectiveLocalityName',
        'id-at-stateOrProvinceName',
        'id-at-collectiveStateOrProvinceName',
        'id-at-streetAddress',
        'id-at-collectiveStreetAddress',
        'id-at-organizationName',
        'id-at-collectiveOrganizationName',
        'id-at-organizationalUnitName',
        'id-at-collectiveOrganizationalUnitName',
        'id-at-title',
        'id-at-description',
        'id-at-searchGuide',
        'id-at-businessCategory',
        'id-at-postalAddress',
        'id-at-collectivePostalAddress',
        'id-at-postalCode',
        'id-at-collectivePostalCode',
        'id-at-postOfficeBox',
        'id-at-collectivePostOfficeBox',
        'id-at-physicalDeliveryOfficeName',
        'id-at-collectivePhysicalDeliveryOfficeName',
        'id-at-telephoneNumber',
        'id-at-collectiveTelephoneNumber',
        'id-at-telexNumber',
        'id-at-collectiveTelexNumber',
        'id-at-facsimileTelephoneNumber',
        'id-at-collectiveFacsimileTelephoneNumber',
        'id-at-x121Address',
        'id-at-internationalISDNNumber',
        'id-at-collectiveInternationalISDNNumber',
        'id-at-registeredAddress',
        'id-at-destinationIndicator',
        'id-at-preferredDeliveryMethod',
        'id-at-presentationAddress',
        'id-at-supportedApplicationContext',
        'id-at-member',
        'id-at-owner',
        'id-at-roleOccupant',
        'id-at-seeAlso',
        'id-at-name',
        'id-at-givenName',
        'id-at-initials',
        'id-at-generationQualifier',
        'id-at-uniqueIdentifier',
        'id-at-dnQualifier',
        'id-at-enhancedSearchGuide',
        'id-at-protocolInformation',
        'id-at-distinguishedName',
        'id-at-uniqueMember',
        'id-at-houseIdentifier',
        'id-at-dmdName',
        'id-at-pseudonym',
        'id-at-communicationsService',
        'id-at-communicationsNetwork',
        'id-at-uuidpair',
        'id-at-tagOid',
        'id-at-uiiFormat',
        'id-at-uiiInUrn',
        'id-at-contentUrl',
        'id-at-uri',
        'id-at-urn',
        'id-at-url',
        'id-at-utmCoordinates',
        'id-at-urnC',
        'id-at-uii',
        'id-at-epc',
        'id-at-tagAfi',
        'id-at-epcFormat',
        'id-at-epcInUrn',
        'id-at-ldapUrl',
        'id-at-tagLocation',
        'id-at-organizationIdentifier',
        'id-at-countryCode3c',
        'id-at-countryCode3n',
        'id-at-dnsName',
        'id-asx-utmCoords',
        'id-asx-uiiForm',
        'id-asx-epcForm',
        'id-asx-countryString3c',
        'id-asx-countryString3n',
        'id-asx-dnsString',
        'id-lsx-attributeTypeDescription',
        'id-lsx-bitString',
        'id-lsx-boolean',
        'id-lsx-countryString',
        'id-lsx-dn',
        'id-lsx-deliveryMethod',
        'id-lsx-directoryString',
        'id-lsx-dITContentRuleDescription',
        'id-lsx-dITStructureRuleDescription',
        'id-lsx-enhancedGuide',
        'id-lsx-facsimileTelephoneNr',
        'id-lsx-fax',
        'id-lsx-generalizedTime',
        'id-lsx-guide',
        'id-lsx-ia5String',
        'id-lsx-integer',
        'id-lsx-jpeg',
        'id-lsx-matchingRuleDescription',
        'id-lsx-matchingRuleUseDescription',
        'id-lsx-nameAndOptionalUID',
        'id-lsx-nameFormDescription',
        'id-lsx-numericString',
        'id-lsx-objectClassDescription',
        'id-lsx-oid',
        'id-lsx-otherMailbox',
        'id-lsx-octetString',
        'id-lsx-postalAddr',
        'id-lsx-presentationAddr',
        'id-lsx-printableString',
        'id-lsx-subtreeSpec',
        'id-lsx-telephoneNr',
        'id-lsx-telexNr',
        'id-lsx-utcTime',
        'id-lsx-ldapSyntaxDescription',
        'id-lsx-substringAssertion',
        'id-oidC1',
        'id-oidC2',
        'id-oidC',
        'id-cat-sequenceMatchType',
        'id-cat-wordMatchType',
        'id-cat-characterMatchTypes',
        'id-cat-selectedContexts',
        'id-not-dSAProblem',
        'id-not-searchServiceProblem',
        'id-not-serviceType',
        'id-not-attributeTypeList',
        'id-not-matchingRuleList',
        'id-not-filterItem',
        'id-not-attributeCombinations',
        'id-not-contextTypeList',
        'id-not-contextList',
        'id-not-contextCombinations',
        'id-not-hierarchySelectList',
        'id-not-searchControlOptionsList',
        'id-not-serviceControlOptionsList',
        'id-not-multipleMatchingLocalities',
        'id-not-proposedRelaxation',
        'id-not-appliedRelaxation',
        'id-not-pwdResponse',
        'id-not-ldapDiagnosticMsg',
        'id-pr-targetDsaUnavailable',
        'id-pr-dataSourceUnavailable',
        'id-pr-unidentifiedOperation',
        'id-pr-unavailableOperation',
        'id-pr-searchAttributeViolation',
        'id-pr-searchAttributeCombinationViolation',
        'id-pr-searchValueNotAllowed',
        'id-pr-missingSearchAttribute',
        'id-pr-searchValueViolation',
        'id-pr-attributeNegationViolation',
        'id-pr-searchValueRequired',
        'id-pr-invalidSearchValue',
        'id-pr-searchContextViolation',
        'id-pr-searchContextCombinationViolation',
        'id-pr-missingSearchContext',
        'id-pr-searchContextValueViolation',
        'id-pr-searchContextValueRequired',
        'id-pr-invalidContextSearchValue',
        'id-pr-unsupportedMatchingRule',
        'id-pr-attributeMatchingViolation',
        'id-pr-unsupportedMatchingUse',
        'id-pr-matchingUseViolation',
        'id-pr-hierarchySelectForbidden',
        'id-pr-invalidHierarchySelect',
        'id-pr-unavailableHierarchySelect',
        'id-pr-invalidSearchControlOptions',
        'id-pr-invalidServiceControlOptions',
        'id-pr-searchSubsetViolation',
        'id-pr-unmatchedKeyAttributes',
        'id-pr-ambiguousKeyAttributes',
        'id-pr-unavailableRelaxationLevel',
        'id-pr-emptyHierarchySelection',
        'id-pr-administratorImposedLimit',
        'id-pr-permanentRestriction',
        'id-pr-temporaryRestriction',
        'id-pr-relaxationNotSupported',
        'id-coat-uid',
        'id-coat-dc',
        'id-mr-caseIgnoreMatch',
        'id-mr-caseIgnoreOrderingMatch',
        'id-mr-caseIgnoreSubstringsMatch',
        'id-mr-caseExactMatch',
        'id-mr-caseExactOrderingMatch',
        'id-mr-caseExactSubstringsMatch',
        'id-mr-numericStringMatch',
        'id-mr-numericStringOrderingMatch',
        'id-mr-numericStringSubstringsMatch',
        'id-mr-caseIgnoreListMatch',
        'id-mr-caseIgnoreListSubstringsMatch',
        'id-mr-booleanMatch',
        'id-mr-integerMatch',
        'id-mr-integerOrderingMatch',
        'id-mr-bitStringMatch',
        'id-mr-octetStringMatch',
        'id-mr-octetStringOrderingMatch',
        'id-mr-octetStringSubstringsMatch',
        'id-mr-telephoneNumberMatch',
        'id-mr-telephoneNumberSubstringsMatch',
        'id-mr-presentationAddressMatch',
        'id-mr-uniqueMemberMatch',
        'id-mr-protocolInformationMatch',
        'id-mr-uTCTimeMatch',
        'id-mr-uTCTimeOrderingMatch',
        'id-mr-generalizedTimeMatch',
        'id-mr-generalizedTimeOrderingMatch',
        'id-mr-integerFirstComponentMatch',
        'id-mr-objectIdentifierFirstComponentMatch',
        'id-mr-directoryStringFirstComponentMatch',
        'id-mr-wordMatch',
        'id-mr-keywordMatch',
        'id-mr-storedPrefixMatch',
        'id-mr-systemProposedMatch',
        'id-mr-generalWordMatch',
        'id-mr-approximateStringMatch',
        'id-mr-ignoreIfAbsentMatch',
        'id-mr-nullMatch',
        'id-mr-zonalMatch',
        'id-mr-facsimileNumberMatch',
        'id-mr-facsimileNumberSubstringsMatch',
        'id-mr-uuidpairmatch',
        'id-mr-uriMatch',
        'id-mr-dnsNameMatch',
        'id-lmr-caseExactIA5Match',
        'id-lmr-caseIgnoreIA5Match',
        'id-lmr-caseIgnoreIA5SubstringsMatch',
        'id-avc-language',
        'id-avc-temporal',
        'id-avc-locale',
        'id-avc-ldapAttributeOption',
        ]
    _type_ = [
        'UnboundedDirectoryString',
        'DirectoryString',
        'UniqueIdentifier',
        'UUIDPair',
        'UUID',
        'URI',
        'DomainName',
        'CountryName',
        'CountryCode3c',
        'CountryCode3n',
        'UtmCoordinates',
        'Guide',
        'Criteria',
        'CriteriaItem',
        'EnhancedGuide',
        'PostalAddress',
        'TelephoneNumber',
        'TelexNumber',
        'FacsimileTelephoneNumber',
        'X121Address',
        'InternationalISDNNumber',
        'DestinationIndicator',
        'CommunicationsService',
        'CommunicationsNetwork',
        'PreferredDeliveryMethod',
        'PresentationAddress',
        'ProtocolInformation',
        'NameAndOptionalUID',
        'UiiFormat',
        'UiiFilter',
        'UiiItem',
        'EpcFormat',
        'MultipleMatchingLocalities',
        'MRMappings',
        'PwdResponse',
        'SubstringAssertion',
        'CaseIgnoreList',
        'OctetSubstringAssertion',
        'SequenceMatchType',
        'WordMatchTypes',
        'CharacterMatchTypes',
        'ZONAL-MATCHING',
        'ZonalSelect',
        'ZonalResult',
        'LanguageContextSyntax',
        'TimeSpecification',
        'Period',
        'XDayOf',
        'NamedDay',
        'DayTimeBand',
        'DayTime',
        'TimeZone',
        'TimeAssertion',
        'LocaleContextSyntax',
        'AttributeOptionList',
        ]
    _set_ = [
        ]
    _val_ = [
        'knowledgeInformation',
        'name',
        'commonName',
        'surname',
        'givenName',
        'initials',
        'generationQualifier',
        'uniqueIdentifier',
        'dnQualifier',
        'serialNumber',
        'pseudonym',
        'uUIDPair',
        'uri',
        'urn',
        'url',
        'dnsName',
        'countryName',
        'countryCode3c',
        'countryCode3n',
        'localityName',
        'collectiveLocalityName',
        'stateOrProvinceName',
        'collectiveStateOrProvinceName',
        'streetAddress',
        'collectiveStreetAddress',
        'houseIdentifier',
        'utmCoordinates',
        'organizationName',
        'collectiveOrganizationName',
        'organizationalUnitName',
        'collectiveOrganizationalUnitName',
        'title',
        'organizationIdentifier',
        'description',
        'searchGuide',
        'enhancedSearchGuide',
        'businessCategory',
        'postalAddress',
        'collectivePostalAddress',
        'postalCode',
        'collectivePostalCode',
        'postOfficeBox',
        'collectivePostOfficeBox',
        'physicalDeliveryOfficeName',
        'collectivePhysicalDeliveryOfficeName',
        'telephoneNumber',
        'ub-telephone-number',
        'collectiveTelephoneNumber',
        'telexNumber',
        'ub-telex-number',
        'ub-country-code',
        'ub-answerback',
        'collectiveTelexNumber',
        'facsimileTelephoneNumber',
        'collectiveFacsimileTelephoneNumber',
        'x121Address',
        'ub-x121-address',
        'internationalISDNNumber',
        'ub-international-isdn-number',
        'collectiveInternationalISDNNumber',
        'registeredAddress',
        'destinationIndicator',
        'communicationsService',
        'communicationsNetwork',
        'preferredDeliveryMethod',
        'presentationAddress',
        'supportedApplicationContext',
        'protocolInformation',
        'distinguishedName',
        'member',
        'uniqueMember',
        'owner',
        'roleOccupant',
        'seeAlso',
        'dmdName',
        'oidC1',
        'oidC2',
        'oidC',
        'urnC',
        'tagOid',
        'uiiFormat',
        'uiiInUrn',
        'contentUrl',
        'uii',
        'epc',
        'tagAfi',
        'epcFormat',
        'epcInUrn',
        'ldapUrl',
        'tagLocation',
        'dSAProblem',
        'searchServiceProblem',
        'serviceType',
        'attributeTypeList',
        'matchingRuleList',
        'filterItem',
        'attributeCombinations',
        'contextTypeList',
        'contextList',
        'contextCombinations',
        'hierarchySelectList',
        'searchControlOptionsList',
        'serviceControlOptionsList',
        'multipleMatchingLocalities',
        'proposedRelaxation',
        'appliedRelaxation',
        'pwdResponseValue',
        'ldapDiagnosticMsg',
        'uid',
        'dc',
        'caseExactMatch',
        'caseIgnoreMatch',
        'caseExactOrderingMatch',
        'caseIgnoreOrderingMatch',
        'caseExactSubstringsMatch',
        'caseIgnoreSubstringsMatch',
        'numericStringMatch',
        'numericStringOrderingMatch',
        'numericStringSubstringsMatch',
        'caseIgnoreListMatch',
        'caseIgnoreListSubstringsMatch',
        'storedPrefixMatch',
        'booleanMatch',
        'integerMatch',
        'integerOrderingMatch',
        'bitStringMatch',
        'octetStringMatch',
        'octetStringOrderingMatch',
        'octetStringSubstringsMatch',
        'telephoneNumberMatch',
        'telephoneNumberSubstringsMatch',
        'presentationAddressMatch',
        'uniqueMemberMatch',
        'protocolInformationMatch',
        'facsimileNumberMatch',
        'facsimileNumberSubstringsMatch',
        'uUIDPairMatch',
        'uTCTimeMatch',
        'uTCTimeOrderingMatch',
        'generalizedTimeMatch',
        'generalizedTimeOrderingMatch',
        'systemProposedMatch',
        'integerFirstComponentMatch',
        'objectIdentifierFirstComponentMatch',
        'directoryStringFirstComponentMatch',
        'wordMatch',
        'keywordMatch',
        'generalWordMatch',
        'sequenceMatchType',
        'wordMatchTypes',
        'characterMatchTypes',
        'selectedContexts',
        'approximateStringMatch',
        'ignoreIfAbsentMatch',
        'nullMatch',
        'zonalMatch',
        'uriMatch',
        'dnsNameMatch',
        'caseExactIA5Match',
        'caseIgnoreIA5Match',
        'caseIgnoreIA5SubstringsMatch',
        'utmCoords',
        'uiiForm',
        'epcForm',
        'countryString3c',
        'countryString3n',
        'dnsString',
        'attributeTypeDescription',
        'bitString',
        'boolean',
        'countryString',
        'dn',
        'deliveryMethod',
        'directoryString',
        'dITContentRuleDescription',
        'dITStructureRuleDescription',
        'enhancedGuide',
        'facsimileTelephoneNr',
        'fax',
        'generalizedTime',
        'guide',
        'ia5String',
        'integer',
        'jpeg',
        'matchingRuleDescription',
        'matchingRuleUseDescription',
        'nameAndOptionalUID',
        'nameFormDescription',
        'numericString',
        'objectClassDescription',
        'oid',
        'otherMailbox',
        'octetString',
        'postalAddr',
        'presentationAddr',
        'printableString',
        'subtreeSpec',
        'telephoneNr',
        'telexNr',
        'utcTime',
        'ldapSyntaxDescription',
        'substringAssertion',
        'languageContext',
        'temporalContext',
        'localeContext',
        'ldapAttributeOptionContext',
        'id-at-knowledgeInformation',
        'id-at-commonName',
        'id-at-surname',
        'id-at-serialNumber',
        'id-at-countryName',
        'id-at-localityName',
        'id-at-collectiveLocalityName',
        'id-at-stateOrProvinceName',
        'id-at-collectiveStateOrProvinceName',
        'id-at-streetAddress',
        'id-at-collectiveStreetAddress',
        'id-at-organizationName',
        'id-at-collectiveOrganizationName',
        'id-at-organizationalUnitName',
        'id-at-collectiveOrganizationalUnitName',
        'id-at-title',
        'id-at-description',
        'id-at-searchGuide',
        'id-at-businessCategory',
        'id-at-postalAddress',
        'id-at-collectivePostalAddress',
        'id-at-postalCode',
        'id-at-collectivePostalCode',
        'id-at-postOfficeBox',
        'id-at-collectivePostOfficeBox',
        'id-at-physicalDeliveryOfficeName',
        'id-at-collectivePhysicalDeliveryOfficeName',
        'id-at-telephoneNumber',
        'id-at-collectiveTelephoneNumber',
        'id-at-telexNumber',
        'id-at-collectiveTelexNumber',
        'id-at-facsimileTelephoneNumber',
        'id-at-collectiveFacsimileTelephoneNumber',
        'id-at-x121Address',
        'id-at-internationalISDNNumber',
        'id-at-collectiveInternationalISDNNumber',
        'id-at-registeredAddress',
        'id-at-destinationIndicator',
        'id-at-preferredDeliveryMethod',
        'id-at-presentationAddress',
        'id-at-supportedApplicationContext',
        'id-at-member',
        'id-at-owner',
        'id-at-roleOccupant',
        'id-at-seeAlso',
        'id-at-name',
        'id-at-givenName',
        'id-at-initials',
        'id-at-generationQualifier',
        'id-at-uniqueIdentifier',
        'id-at-dnQualifier',
        'id-at-enhancedSearchGuide',
        'id-at-protocolInformation',
        'id-at-distinguishedName',
        'id-at-uniqueMember',
        'id-at-houseIdentifier',
        'id-at-dmdName',
        'id-at-pseudonym',
        'id-at-communicationsService',
        'id-at-communicationsNetwork',
        'id-at-uuidpair',
        'id-at-tagOid',
        'id-at-uiiFormat',
        'id-at-uiiInUrn',
        'id-at-contentUrl',
        'id-at-uri',
        'id-at-urn',
        'id-at-url',
        'id-at-utmCoordinates',
        'id-at-urnC',
        'id-at-uii',
        'id-at-epc',
        'id-at-tagAfi',
        'id-at-epcFormat',
        'id-at-epcInUrn',
        'id-at-ldapUrl',
        'id-at-tagLocation',
        'id-at-organizationIdentifier',
        'id-at-countryCode3c',
        'id-at-countryCode3n',
        'id-at-dnsName',
        'id-asx-utmCoords',
        'id-asx-uiiForm',
        'id-asx-epcForm',
        'id-asx-countryString3c',
        'id-asx-countryString3n',
        'id-asx-dnsString',
        'id-lsx-attributeTypeDescription',
        'id-lsx-bitString',
        'id-lsx-boolean',
        'id-lsx-countryString',
        'id-lsx-dn',
        'id-lsx-deliveryMethod',
        'id-lsx-directoryString',
        'id-lsx-dITContentRuleDescription',
        'id-lsx-dITStructureRuleDescription',
        'id-lsx-enhancedGuide',
        'id-lsx-facsimileTelephoneNr',
        'id-lsx-fax',
        'id-lsx-generalizedTime',
        'id-lsx-guide',
        'id-lsx-ia5String',
        'id-lsx-integer',
        'id-lsx-jpeg',
        'id-lsx-matchingRuleDescription',
        'id-lsx-matchingRuleUseDescription',
        'id-lsx-nameAndOptionalUID',
        'id-lsx-nameFormDescription',
        'id-lsx-numericString',
        'id-lsx-objectClassDescription',
        'id-lsx-oid',
        'id-lsx-otherMailbox',
        'id-lsx-octetString',
        'id-lsx-postalAddr',
        'id-lsx-presentationAddr',
        'id-lsx-printableString',
        'id-lsx-subtreeSpec',
        'id-lsx-telephoneNr',
        'id-lsx-telexNr',
        'id-lsx-utcTime',
        'id-lsx-ldapSyntaxDescription',
        'id-lsx-substringAssertion',
        'id-oidC1',
        'id-oidC2',
        'id-oidC',
        'id-cat-sequenceMatchType',
        'id-cat-wordMatchType',
        'id-cat-characterMatchTypes',
        'id-cat-selectedContexts',
        'id-not-dSAProblem',
        'id-not-searchServiceProblem',
        'id-not-serviceType',
        'id-not-attributeTypeList',
        'id-not-matchingRuleList',
        'id-not-filterItem',
        'id-not-attributeCombinations',
        'id-not-contextTypeList',
        'id-not-contextList',
        'id-not-contextCombinations',
        'id-not-hierarchySelectList',
        'id-not-searchControlOptionsList',
        'id-not-serviceControlOptionsList',
        'id-not-multipleMatchingLocalities',
        'id-not-proposedRelaxation',
        'id-not-appliedRelaxation',
        'id-not-pwdResponse',
        'id-not-ldapDiagnosticMsg',
        'id-pr-targetDsaUnavailable',
        'id-pr-dataSourceUnavailable',
        'id-pr-unidentifiedOperation',
        'id-pr-unavailableOperation',
        'id-pr-searchAttributeViolation',
        'id-pr-searchAttributeCombinationViolation',
        'id-pr-searchValueNotAllowed',
        'id-pr-missingSearchAttribute',
        'id-pr-searchValueViolation',
        'id-pr-attributeNegationViolation',
        'id-pr-searchValueRequired',
        'id-pr-invalidSearchValue',
        'id-pr-searchContextViolation',
        'id-pr-searchContextCombinationViolation',
        'id-pr-missingSearchContext',
        'id-pr-searchContextValueViolation',
        'id-pr-searchContextValueRequired',
        'id-pr-invalidContextSearchValue',
        'id-pr-unsupportedMatchingRule',
        'id-pr-attributeMatchingViolation',
        'id-pr-unsupportedMatchingUse',
        'id-pr-matchingUseViolation',
        'id-pr-hierarchySelectForbidden',
        'id-pr-invalidHierarchySelect',
        'id-pr-unavailableHierarchySelect',
        'id-pr-invalidSearchControlOptions',
        'id-pr-invalidServiceControlOptions',
        'id-pr-searchSubsetViolation',
        'id-pr-unmatchedKeyAttributes',
        'id-pr-ambiguousKeyAttributes',
        'id-pr-unavailableRelaxationLevel',
        'id-pr-emptyHierarchySelection',
        'id-pr-administratorImposedLimit',
        'id-pr-permanentRestriction',
        'id-pr-temporaryRestriction',
        'id-pr-relaxationNotSupported',
        'id-coat-uid',
        'id-coat-dc',
        'id-mr-caseIgnoreMatch',
        'id-mr-caseIgnoreOrderingMatch',
        'id-mr-caseIgnoreSubstringsMatch',
        'id-mr-caseExactMatch',
        'id-mr-caseExactOrderingMatch',
        'id-mr-caseExactSubstringsMatch',
        'id-mr-numericStringMatch',
        'id-mr-numericStringOrderingMatch',
        'id-mr-numericStringSubstringsMatch',
        'id-mr-caseIgnoreListMatch',
        'id-mr-caseIgnoreListSubstringsMatch',
        'id-mr-booleanMatch',
        'id-mr-integerMatch',
        'id-mr-integerOrderingMatch',
        'id-mr-bitStringMatch',
        'id-mr-octetStringMatch',
        'id-mr-octetStringOrderingMatch',
        'id-mr-octetStringSubstringsMatch',
        'id-mr-telephoneNumberMatch',
        'id-mr-telephoneNumberSubstringsMatch',
        'id-mr-presentationAddressMatch',
        'id-mr-uniqueMemberMatch',
        'id-mr-protocolInformationMatch',
        'id-mr-uTCTimeMatch',
        'id-mr-uTCTimeOrderingMatch',
        'id-mr-generalizedTimeMatch',
        'id-mr-generalizedTimeOrderingMatch',
        'id-mr-integerFirstComponentMatch',
        'id-mr-objectIdentifierFirstComponentMatch',
        'id-mr-directoryStringFirstComponentMatch',
        'id-mr-wordMatch',
        'id-mr-keywordMatch',
        'id-mr-storedPrefixMatch',
        'id-mr-systemProposedMatch',
        'id-mr-generalWordMatch',
        'id-mr-approximateStringMatch',
        'id-mr-ignoreIfAbsentMatch',
        'id-mr-nullMatch',
        'id-mr-zonalMatch',
        'id-mr-facsimileNumberMatch',
        'id-mr-facsimileNumberSubstringsMatch',
        'id-mr-uuidpairmatch',
        'id-mr-uriMatch',
        'id-mr-dnsNameMatch',
        'id-lmr-caseExactIA5Match',
        'id-lmr-caseIgnoreIA5Match',
        'id-lmr-caseIgnoreIA5SubstringsMatch',
        'id-avc-language',
        'id-avc-temporal',
        'id-avc-locale',
        'id-avc-ldapAttributeOption',
        ]
    _class_ = [
        'knowledgeInformation',
        'name',
        'commonName',
        'surname',
        'givenName',
        'initials',
        'generationQualifier',
        'uniqueIdentifier',
        'dnQualifier',
        'serialNumber',
        'pseudonym',
        'uUIDPair',
        'uri',
        'urn',
        'url',
        'dnsName',
        'countryName',
        'countryCode3c',
        'countryCode3n',
        'localityName',
        'collectiveLocalityName',
        'stateOrProvinceName',
        'collectiveStateOrProvinceName',
        'streetAddress',
        'collectiveStreetAddress',
        'houseIdentifier',
        'utmCoordinates',
        'organizationName',
        'collectiveOrganizationName',
        'organizationalUnitName',
        'collectiveOrganizationalUnitName',
        'title',
        'organizationIdentifier',
        'description',
        'searchGuide',
        'enhancedSearchGuide',
        'businessCategory',
        'postalAddress',
        'collectivePostalAddress',
        'postalCode',
        'collectivePostalCode',
        'postOfficeBox',
        'collectivePostOfficeBox',
        'physicalDeliveryOfficeName',
        'collectivePhysicalDeliveryOfficeName',
        'telephoneNumber',
        'collectiveTelephoneNumber',
        'telexNumber',
        'collectiveTelexNumber',
        'facsimileTelephoneNumber',
        'collectiveFacsimileTelephoneNumber',
        'x121Address',
        'internationalISDNNumber',
        'collectiveInternationalISDNNumber',
        'registeredAddress',
        'destinationIndicator',
        'communicationsService',
        'communicationsNetwork',
        'preferredDeliveryMethod',
        'presentationAddress',
        'supportedApplicationContext',
        'protocolInformation',
        'distinguishedName',
        'member',
        'uniqueMember',
        'owner',
        'roleOccupant',
        'seeAlso',
        'dmdName',
        'oidC1',
        'oidC2',
        'oidC',
        'urnC',
        'tagOid',
        'uiiFormat',
        'uiiInUrn',
        'contentUrl',
        'uii',
        'epc',
        'tagAfi',
        'epcFormat',
        'epcInUrn',
        'ldapUrl',
        'tagLocation',
        'dSAProblem',
        'searchServiceProblem',
        'serviceType',
        'attributeTypeList',
        'matchingRuleList',
        'filterItem',
        'attributeCombinations',
        'contextTypeList',
        'contextList',
        'contextCombinations',
        'hierarchySelectList',
        'searchControlOptionsList',
        'serviceControlOptionsList',
        'multipleMatchingLocalities',
        'proposedRelaxation',
        'appliedRelaxation',
        'pwdResponseValue',
        'ldapDiagnosticMsg',
        'uid',
        'dc',
        'caseExactMatch',
        'caseIgnoreMatch',
        'caseExactOrderingMatch',
        'caseIgnoreOrderingMatch',
        'caseExactSubstringsMatch',
        'caseIgnoreSubstringsMatch',
        'numericStringMatch',
        'numericStringOrderingMatch',
        'numericStringSubstringsMatch',
        'caseIgnoreListMatch',
        'caseIgnoreListSubstringsMatch',
        'storedPrefixMatch',
        'booleanMatch',
        'integerMatch',
        'integerOrderingMatch',
        'bitStringMatch',
        'octetStringMatch',
        'octetStringOrderingMatch',
        'octetStringSubstringsMatch',
        'telephoneNumberMatch',
        'telephoneNumberSubstringsMatch',
        'presentationAddressMatch',
        'uniqueMemberMatch',
        'protocolInformationMatch',
        'facsimileNumberMatch',
        'facsimileNumberSubstringsMatch',
        'uUIDPairMatch',
        'uTCTimeMatch',
        'uTCTimeOrderingMatch',
        'generalizedTimeMatch',
        'generalizedTimeOrderingMatch',
        'systemProposedMatch',
        'integerFirstComponentMatch',
        'objectIdentifierFirstComponentMatch',
        'directoryStringFirstComponentMatch',
        'wordMatch',
        'keywordMatch',
        'generalWordMatch',
        'sequenceMatchType',
        'wordMatchTypes',
        'characterMatchTypes',
        'selectedContexts',
        'approximateStringMatch',
        'ignoreIfAbsentMatch',
        'nullMatch',
        'ZONAL-MATCHING',
        'zonalMatch',
        'uriMatch',
        'dnsNameMatch',
        'caseExactIA5Match',
        'caseIgnoreIA5Match',
        'caseIgnoreIA5SubstringsMatch',
        'utmCoords',
        'uiiForm',
        'epcForm',
        'countryString3c',
        'countryString3n',
        'dnsString',
        'attributeTypeDescription',
        'bitString',
        'boolean',
        'countryString',
        'dn',
        'deliveryMethod',
        'directoryString',
        'dITContentRuleDescription',
        'dITStructureRuleDescription',
        'enhancedGuide',
        'facsimileTelephoneNr',
        'fax',
        'generalizedTime',
        'guide',
        'ia5String',
        'integer',
        'jpeg',
        'matchingRuleDescription',
        'matchingRuleUseDescription',
        'nameAndOptionalUID',
        'nameFormDescription',
        'numericString',
        'objectClassDescription',
        'oid',
        'otherMailbox',
        'octetString',
        'postalAddr',
        'presentationAddr',
        'printableString',
        'subtreeSpec',
        'telephoneNr',
        'telexNr',
        'utcTime',
        'ldapSyntaxDescription',
        'substringAssertion',
        'languageContext',
        'temporalContext',
        'localeContext',
        'ldapAttributeOptionContext',
        ]
    _param_ = [
        'DirectoryString',
        ]
    
    #-----< UnboundedDirectoryString >-----#
    UnboundedDirectoryString = CHOICE(name='UnboundedDirectoryString', mode=MODE_TYPE)
    _UnboundedDirectoryString_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _UnboundedDirectoryString_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _UnboundedDirectoryString_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _UnboundedDirectoryString_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _UnboundedDirectoryString_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _UnboundedDirectoryString_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    UnboundedDirectoryString._cont = ASN1Dict([
        ('teletexString', _UnboundedDirectoryString_teletexString),
        ('printableString', _UnboundedDirectoryString_printableString),
        ('bmpString', _UnboundedDirectoryString_bmpString),
        ('universalString', _UnboundedDirectoryString_universalString),
        ('uTF8String', _UnboundedDirectoryString_uTF8String),
        ])
    UnboundedDirectoryString._ext = None
    
    #-----< DirectoryString >-----#
    DirectoryString = CHOICE(name='DirectoryString', mode=MODE_TYPE, param=True)
    
    #-----< knowledgeInformation >-----#
    knowledgeInformation = CLASS(name='knowledgeInformation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _knowledgeInformation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_equality_match_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    knowledgeInformation._val = dict([('Type', _knowledgeInformation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('obsolete', True), ('id', (2, 5, 4, 2))])
    
    #-----< name >-----#
    name = CLASS(name='name', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _name_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_substrings_match_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    name._val = dict([('Type', _name_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])
    
    #-----< commonName >-----#
    commonName = CLASS(name='commonName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _commonName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    commonName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _commonName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])
    
    #-----< surname >-----#
    surname = CLASS(name='surname', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _surname_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    surname._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _surname_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['sn']), ('id', (2, 5, 4, 4))])
    
    #-----< givenName >-----#
    givenName = CLASS(name='givenName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _givenName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    givenName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _givenName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['givenName']), ('id', (2, 5, 4, 42))])
    
    #-----< initials >-----#
    initials = CLASS(name='initials', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _initials_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    initials._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _initials_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['initials']), ('id', (2, 5, 4, 43))])
    
    #-----< generationQualifier >-----#
    generationQualifier = CLASS(name='generationQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _generationQualifier_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    generationQualifier._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _generationQualifier_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['generationQualifier']), ('id', (2, 5, 4, 44))])
    
    #-----< uniqueIdentifier >-----#
    uniqueIdentifier = CLASS(name='uniqueIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uniqueIdentifier_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    uniqueIdentifier._val = dict([('Type', _uniqueIdentifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['x500UniqueIdentifier']), ('id', (2, 5, 4, 45))])
    
    #-----< UniqueIdentifier >-----#
    UniqueIdentifier = BIT_STR(name='UniqueIdentifier', mode=MODE_TYPE)
    
    #-----< dnQualifier >-----#
    dnQualifier = CLASS(name='dnQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dnQualifier_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    dnQualifier._val = dict([('Type', _dnQualifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreOrderingMatch']), ('id', (2, 5, 13, 3))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['dnQualifier']), ('id', (2, 5, 4, 46))])
    
    #-----< serialNumber >-----#
    serialNumber = CLASS(name='serialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serialNumber_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    _serialNumber_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    serialNumber._val = dict([('Type', _serialNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['serialNumber']), ('id', (2, 5, 4, 5))])
    
    #-----< pseudonym >-----#
    pseudonym = CLASS(name='pseudonym', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pseudonym_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    pseudonym._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _pseudonym_val_Type), ('id', (2, 5, 4, 65))])
    
    #-----< uUIDPair >-----#
    uUIDPair = CLASS(name='uUIDPair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uUIDPair_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    __ATTRIBUTE_equality_match_val_AssertionType_1 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    uUIDPair._val = dict([('Type', _uUIDPair_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('id', (2, 5, 13, 68))])), ('id', (2, 5, 4, 77))])
    
    #-----< UUIDPair >-----#
    UUIDPair = SEQ(name='UUIDPair', mode=MODE_TYPE)
    _UUIDPair_issuerUUID = OCT_STR(name='issuerUUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUID')))
    _UUIDPair_subjectUUID = OCT_STR(name='subjectUUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUID')))
    UUIDPair._cont = ASN1Dict([
        ('issuerUUID', _UUIDPair_issuerUUID),
        ('subjectUUID', _UUIDPair_subjectUUID),
        ])
    UUIDPair._ext = []
    
    #-----< UUID >-----#
    UUID = OCT_STR(name='UUID', mode=MODE_TYPE)
    UUID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< uri >-----#
    uri = CLASS(name='uri', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uri_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    __ATTRIBUTE_equality_match_val_AssertionType_2 = STR_UTF8(name='AssertionType', mode=MODE_TYPE)
    uri._val = dict([('Type', _uri_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])
    
    #-----< URI >-----#
    URI = STR_UTF8(name='URI', mode=MODE_TYPE)
    
    #-----< urn >-----#
    urn = CLASS(name='urn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_0 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    urn._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['urn']), ('id', (2, 5, 4, 86))])
    
    #-----< url >-----#
    url = CLASS(name='url', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    url._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['url']), ('id', (2, 5, 4, 87))])
    
    #-----< dnsName >-----#
    dnsName = CLASS(name='dnsName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dnsName_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    __ATTRIBUTE_equality_match_val_AssertionType_3 = STR_UTF8(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    dnsName._val = dict([('Type', _dnsName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (2, 5, 40, 9)), ('ldapName', ['dnsNameMatch']), ('id', (2, 5, 13, 74))])), ('ldapSyntax', (2, 5, 40, 9)), ('ldapName', ['DNS name']), ('id', (2, 5, 4, 100))])
    
    #-----< DomainName >-----#
    DomainName = STR_UTF8(name='DomainName', mode=MODE_TYPE)
    
    #-----< countryName >-----#
    countryName = CLASS(name='countryName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _countryName_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryName')))
    countryName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _countryName_val_Type), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11)), ('ldapName', ['c']), ('id', (2, 5, 4, 6))])
    
    #-----< CountryName >-----#
    CountryName = STR_PRINT(name='CountryName', mode=MODE_TYPE)
    CountryName._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< countryCode3c >-----#
    countryCode3c = CLASS(name='countryCode3c', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _countryCode3c_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3c')))
    countryCode3c._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _countryCode3c_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 7)), ('ldapName', ['c3']), ('id', (2, 5, 4, 98))])
    
    #-----< CountryCode3c >-----#
    CountryCode3c = STR_PRINT(name='CountryCode3c', mode=MODE_TYPE)
    CountryCode3c._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< countryCode3n >-----#
    countryCode3n = CLASS(name='countryCode3n', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _countryCode3n_val_Type = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3n')))
    countryCode3n._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _countryCode3n_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 8)), ('ldapName', ['n3']), ('id', (2, 5, 4, 99))])
    
    #-----< CountryCode3n >-----#
    CountryCode3n = STR_NUM(name='CountryCode3n', mode=MODE_TYPE)
    CountryCode3n._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< localityName >-----#
    localityName = CLASS(name='localityName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _localityName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    localityName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _localityName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['l']), ('id', (2, 5, 4, 7))])
    
    #-----< collectiveLocalityName >-----#
    collectiveLocalityName = CLASS(name='collectiveLocalityName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveLocalityName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['l']), ('id', (2, 5, 4, 7))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-l']), ('id', (2, 5, 4, 7, 1))])
    
    #-----< stateOrProvinceName >-----#
    stateOrProvinceName = CLASS(name='stateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _stateOrProvinceName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    stateOrProvinceName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _stateOrProvinceName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['st']), ('id', (2, 5, 4, 8))])
    
    #-----< collectiveStateOrProvinceName >-----#
    collectiveStateOrProvinceName = CLASS(name='collectiveStateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveStateOrProvinceName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['st']), ('id', (2, 5, 4, 8))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-st']), ('id', (2, 5, 4, 8, 1))])
    
    #-----< streetAddress >-----#
    streetAddress = CLASS(name='streetAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _streetAddress_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    streetAddress._val = dict([('Type', _streetAddress_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['street']), ('id', (2, 5, 4, 9))])
    
    #-----< collectiveStreetAddress >-----#
    collectiveStreetAddress = CLASS(name='collectiveStreetAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveStreetAddress._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['street']), ('id', (2, 5, 4, 9))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-street']), ('id', (2, 5, 4, 9, 1))])
    
    #-----< houseIdentifier >-----#
    houseIdentifier = CLASS(name='houseIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _houseIdentifier_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    houseIdentifier._val = dict([('Type', _houseIdentifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['houseIdentifier']), ('id', (2, 5, 4, 51))])
    
    #-----< utmCoordinates >-----#
    utmCoordinates = CLASS(name='utmCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _utmCoordinates_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    utmCoordinates._val = dict([('Type', _utmCoordinates_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 4)), ('ldapName', ['utmCoordinates']), ('id', (2, 5, 4, 88))])
    
    #-----< UtmCoordinates >-----#
    UtmCoordinates = SEQ(name='UtmCoordinates', mode=MODE_TYPE)
    _UtmCoordinates_zone = STR_PRINT(name='zone', mode=MODE_TYPE)
    _UtmCoordinates_easting = STR_NUM(name='easting', mode=MODE_TYPE)
    _UtmCoordinates_northing = STR_NUM(name='northing', mode=MODE_TYPE)
    UtmCoordinates._cont = ASN1Dict([
        ('zone', _UtmCoordinates_zone),
        ('easting', _UtmCoordinates_easting),
        ('northing', _UtmCoordinates_northing),
        ])
    UtmCoordinates._ext = None
    
    #-----< organizationName >-----#
    organizationName = CLASS(name='organizationName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _organizationName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['o']), ('id', (2, 5, 4, 10))])
    
    #-----< collectiveOrganizationName >-----#
    collectiveOrganizationName = CLASS(name='collectiveOrganizationName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveOrganizationName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['o']), ('id', (2, 5, 4, 10))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-o']), ('id', (2, 5, 4, 10, 1))])
    
    #-----< organizationalUnitName >-----#
    organizationalUnitName = CLASS(name='organizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationalUnitName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationalUnitName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _organizationalUnitName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['ou']), ('id', (2, 5, 4, 11))])
    
    #-----< collectiveOrganizationalUnitName >-----#
    collectiveOrganizationalUnitName = CLASS(name='collectiveOrganizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveOrganizationalUnitName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['ou']), ('id', (2, 5, 4, 11))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-ou']), ('id', (2, 5, 4, 11, 1))])
    
    #-----< title >-----#
    title = CLASS(name='title', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _title_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    title._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _title_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['title']), ('id', (2, 5, 4, 12))])
    
    #-----< organizationIdentifier >-----#
    organizationIdentifier = CLASS(name='organizationIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationIdentifier_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationIdentifier._val = dict([('Type', _organizationIdentifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['organizationIdentifier']), ('id', (2, 5, 4, 97))])
    
    #-----< description >-----#
    description = CLASS(name='description', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _description_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    description._val = dict([('Type', _description_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['description']), ('id', (2, 5, 4, 13))])
    
    #-----< searchGuide >-----#
    searchGuide = CLASS(name='searchGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchGuide_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Guide')))
    searchGuide._val = dict([('Type', _searchGuide_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25)), ('ldapName', ['searchGuide']), ('id', (2, 5, 4, 14))])
    
    #-----< Guide >-----#
    Guide = SET(name='Guide', mode=MODE_TYPE)
    _Guide_objectClass = OID(name='objectClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), opt=True)
    _Guide_criteria = CHOICE(name='criteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    Guide._cont = ASN1Dict([
        ('objectClass', _Guide_objectClass),
        ('criteria', _Guide_criteria),
        ])
    Guide._ext = []
    
    #-----< Criteria >-----#
    Criteria = CHOICE(name='Criteria', mode=MODE_TYPE)
    _Criteria_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'CriteriaItem')))
    _Criteria_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Criteria_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _Criteria_and_._cont = __Criteria_and___item_
    _Criteria_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Criteria_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _Criteria_or_._cont = __Criteria_or___item_
    _Criteria_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    Criteria._cont = ASN1Dict([
        ('type', _Criteria_type),
        ('and', _Criteria_and_),
        ('or', _Criteria_or_),
        ('not', _Criteria_not_),
        ])
    Criteria._ext = []
    
    #-----< CriteriaItem >-----#
    CriteriaItem = CHOICE(name='CriteriaItem', mode=MODE_TYPE)
    _CriteriaItem_equality = OID(name='equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_substrings = OID(name='substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_greaterOrEqual = OID(name='greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_lessOrEqual = OID(name='lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_approximateMatch = OID(name='approximateMatch', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    CriteriaItem._cont = ASN1Dict([
        ('equality', _CriteriaItem_equality),
        ('substrings', _CriteriaItem_substrings),
        ('greaterOrEqual', _CriteriaItem_greaterOrEqual),
        ('lessOrEqual', _CriteriaItem_lessOrEqual),
        ('approximateMatch', _CriteriaItem_approximateMatch),
        ])
    CriteriaItem._ext = []
    
    #-----< enhancedSearchGuide >-----#
    enhancedSearchGuide = CLASS(name='enhancedSearchGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _enhancedSearchGuide_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EnhancedGuide')))
    enhancedSearchGuide._val = dict([('Type', _enhancedSearchGuide_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21)), ('ldapName', ['enhancedSearchGuide']), ('id', (2, 5, 4, 47))])
    
    #-----< EnhancedGuide >-----#
    EnhancedGuide = SEQ(name='EnhancedGuide', mode=MODE_TYPE)
    _EnhancedGuide_objectClass = OID(name='objectClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _EnhancedGuide_criteria = CHOICE(name='criteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _EnhancedGuide_subset = INT(name='subset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _EnhancedGuide_subset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    EnhancedGuide._cont = ASN1Dict([
        ('objectClass', _EnhancedGuide_objectClass),
        ('criteria', _EnhancedGuide_criteria),
        ('subset', _EnhancedGuide_subset),
        ])
    EnhancedGuide._ext = []
    
    #-----< businessCategory >-----#
    businessCategory = CLASS(name='businessCategory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _businessCategory_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    businessCategory._val = dict([('Type', _businessCategory_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['businessCategory']), ('id', (2, 5, 4, 15))])
    
    #-----< postalAddress >-----#
    postalAddress = CLASS(name='postalAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postalAddress_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CaseIgnoreList')))
    postalAddress._val = dict([('Type', _postalAddress_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['postalAddress']), ('id', (2, 5, 4, 16))])
    
    #-----< PostalAddress >-----#
    PostalAddress = SEQ_OF(name='PostalAddress', mode=MODE_TYPE)
    _PostalAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    PostalAddress._cont = _PostalAddress__item_
    PostalAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< collectivePostalAddress >-----#
    collectivePostalAddress = CLASS(name='collectivePostalAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    collectivePostalAddress._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['postalAddress']), ('id', (2, 5, 4, 16))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['c-PostalAddress']), ('id', (2, 5, 4, 16, 1))])
    
    #-----< postalCode >-----#
    postalCode = CLASS(name='postalCode', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postalCode_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    postalCode._val = dict([('Type', _postalCode_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postalCode']), ('id', (2, 5, 4, 17))])
    
    #-----< collectivePostalCode >-----#
    collectivePostalCode = CLASS(name='collectivePostalCode', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePostalCode._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postalCode']), ('id', (2, 5, 4, 17))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-PostalCode']), ('id', (2, 5, 4, 17, 1))])
    
    #-----< postOfficeBox >-----#
    postOfficeBox = CLASS(name='postOfficeBox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postOfficeBox_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    postOfficeBox._val = dict([('Type', _postOfficeBox_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postOfficeBox']), ('id', (2, 5, 4, 18))])
    
    #-----< collectivePostOfficeBox >-----#
    collectivePostOfficeBox = CLASS(name='collectivePostOfficeBox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePostOfficeBox._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postOfficeBox']), ('id', (2, 5, 4, 18))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-PostOfficeBox']), ('id', (2, 5, 4, 18, 1))])
    
    #-----< physicalDeliveryOfficeName >-----#
    physicalDeliveryOfficeName = CLASS(name='physicalDeliveryOfficeName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _physicalDeliveryOfficeName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    physicalDeliveryOfficeName._val = dict([('Type', _physicalDeliveryOfficeName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['physicalDeliveryOfficeName']), ('id', (2, 5, 4, 19))])
    
    #-----< collectivePhysicalDeliveryOfficeName >-----#
    collectivePhysicalDeliveryOfficeName = CLASS(name='collectivePhysicalDeliveryOfficeName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePhysicalDeliveryOfficeName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['physicalDeliveryOfficeName']), ('id', (2, 5, 4, 19))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['c-PhysicalDeliveryOfficeName']), ('id', (2, 5, 4, 19, 1))])
    
    #-----< telephoneNumber >-----#
    telephoneNumber = CLASS(name='telephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _telephoneNumber_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    __ATTRIBUTE_equality_match_val_AssertionType_5 = STR_PRINT(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNumber._val = dict([('Type', _telephoneNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), ('ldapName', ['telephoneNumberMatch']), ('id', (2, 5, 13, 20))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['telephoneNumberSubstringsMatch']), ('id', (2, 5, 13, 21))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['telephoneNumber']), ('id', (2, 5, 4, 20))])
    
    #-----< TelephoneNumber >-----#
    TelephoneNumber = STR_PRINT(name='TelephoneNumber', mode=MODE_TYPE)
    TelephoneNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ub-telephone-number >-----#
    ub_telephone_number = INT(name='ub-telephone-number', mode=MODE_VALUE)
    ub_telephone_number._val = 32
    
    #-----< collectiveTelephoneNumber >-----#
    collectiveTelephoneNumber = CLASS(name='collectiveTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_2 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    collectiveTelephoneNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_2), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), ('ldapName', ['telephoneNumberMatch']), ('id', (2, 5, 13, 20))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['telephoneNumberSubstringsMatch']), ('id', (2, 5, 13, 21))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['telephoneNumber']), ('id', (2, 5, 4, 20))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['c-TelephoneNumber']), ('id', (2, 5, 4, 20, 1))])
    
    #-----< telexNumber >-----#
    telexNumber = CLASS(name='telexNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _telexNumber_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    telexNumber._val = dict([('Type', _telexNumber_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), ('ldapName', ['telexNumber']), ('id', (2, 5, 4, 21))])
    
    #-----< TelexNumber >-----#
    TelexNumber = SEQ(name='TelexNumber', mode=MODE_TYPE)
    _TelexNumber_telexNumber = STR_PRINT(name='telexNumber', mode=MODE_TYPE)
    _TelexNumber_telexNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    _TelexNumber_countryCode = STR_PRINT(name='countryCode', mode=MODE_TYPE)
    _TelexNumber_countryCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _TelexNumber_answerback = STR_PRINT(name='answerback', mode=MODE_TYPE)
    _TelexNumber_answerback._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    TelexNumber._cont = ASN1Dict([
        ('telexNumber', _TelexNumber_telexNumber),
        ('countryCode', _TelexNumber_countryCode),
        ('answerback', _TelexNumber_answerback),
        ])
    TelexNumber._ext = []
    
    #-----< ub-telex-number >-----#
    ub_telex_number = INT(name='ub-telex-number', mode=MODE_VALUE)
    ub_telex_number._val = 14
    
    #-----< ub-country-code >-----#
    ub_country_code = INT(name='ub-country-code', mode=MODE_VALUE)
    ub_country_code._val = 4
    
    #-----< ub-answerback >-----#
    ub_answerback = INT(name='ub-answerback', mode=MODE_VALUE)
    ub_answerback._val = 8
    
    #-----< collectiveTelexNumber >-----#
    collectiveTelexNumber = CLASS(name='collectiveTelexNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    collectiveTelexNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), ('ldapName', ['telexNumber']), ('id', (2, 5, 4, 21))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), ('ldapName', ['c-TelexNumber']), ('id', (2, 5, 4, 21, 1))])
    
    #-----< facsimileTelephoneNumber >-----#
    facsimileTelephoneNumber = CLASS(name='facsimileTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _facsimileTelephoneNumber_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    facsimileTelephoneNumber._val = dict([('Type', _facsimileTelephoneNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('id', (2, 5, 13, 63))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('id', (2, 5, 13, 64))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), ('ldapName', ['facsimileTelephoneNumber']), ('id', (2, 5, 4, 23))])
    
    #-----< FacsimileTelephoneNumber >-----#
    FacsimileTelephoneNumber = SEQ(name='FacsimileTelephoneNumber', mode=MODE_TYPE)
    _FacsimileTelephoneNumber_telephoneNumber = STR_PRINT(name='telephoneNumber', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    _FacsimileTelephoneNumber_parameters = BIT_STR(name='parameters', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'G3FacsimileNonBasicParameters')), opt=True)
    FacsimileTelephoneNumber._cont = ASN1Dict([
        ('telephoneNumber', _FacsimileTelephoneNumber_telephoneNumber),
        ('parameters', _FacsimileTelephoneNumber_parameters),
        ])
    FacsimileTelephoneNumber._ext = []
    
    #-----< collectiveFacsimileTelephoneNumber >-----#
    collectiveFacsimileTelephoneNumber = CLASS(name='collectiveFacsimileTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    collectiveFacsimileTelephoneNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_4), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('id', (2, 5, 13, 63))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('id', (2, 5, 13, 64))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), ('ldapName', ['facsimileTelephoneNumber']), ('id', (2, 5, 4, 23))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), ('ldapName', ['c-FacsimileTelephoneNumber']), ('id', (2, 5, 4, 23, 1))])
    
    #-----< x121Address >-----#
    x121Address = CLASS(name='x121Address', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _x121Address_val_Type = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'X121Address')))
    __ATTRIBUTE_equality_match_val_AssertionType_6 = STR_NUM(name='AssertionType', mode=MODE_TYPE)
    x121Address._val = dict([('Type', _x121Address_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['x121Address']), ('id', (2, 5, 4, 24))])
    
    #-----< X121Address >-----#
    X121Address = STR_NUM(name='X121Address', mode=MODE_TYPE)
    X121Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< ub-x121-address >-----#
    ub_x121_address = INT(name='ub-x121-address', mode=MODE_VALUE)
    ub_x121_address._val = 15
    
    #-----< internationalISDNNumber >-----#
    internationalISDNNumber = CLASS(name='internationalISDNNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _internationalISDNNumber_val_Type = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'InternationalISDNNumber')))
    internationalISDNNumber._val = dict([('Type', _internationalISDNNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['internationalISDNNumber']), ('id', (2, 5, 4, 25))])
    
    #-----< InternationalISDNNumber >-----#
    InternationalISDNNumber = STR_NUM(name='InternationalISDNNumber', mode=MODE_TYPE)
    InternationalISDNNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ub-international-isdn-number >-----#
    ub_international_isdn_number = INT(name='ub-international-isdn-number', mode=MODE_VALUE)
    ub_international_isdn_number._val = 16
    
    #-----< collectiveInternationalISDNNumber >-----#
    collectiveInternationalISDNNumber = CLASS(name='collectiveInternationalISDNNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_5 = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'InternationalISDNNumber')))
    collectiveInternationalISDNNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_5), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['internationalISDNNumber']), ('id', (2, 5, 4, 25))])), ('collective', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['c-InternationalISDNNumber']), ('id', (2, 5, 4, 25, 1))])
    
    #-----< registeredAddress >-----#
    registeredAddress = CLASS(name='registeredAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _registeredAddress_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    registeredAddress._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['postalAddress']), ('id', (2, 5, 4, 16))])), ('Type', _registeredAddress_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['registeredAddress']), ('id', (2, 5, 4, 26))])
    
    #-----< destinationIndicator >-----#
    destinationIndicator = CLASS(name='destinationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _destinationIndicator_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DestinationIndicator')))
    destinationIndicator._val = dict([('Type', _destinationIndicator_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['destinationIndicator']), ('id', (2, 5, 4, 27))])
    
    #-----< DestinationIndicator >-----#
    DestinationIndicator = STR_PRINT(name='DestinationIndicator', mode=MODE_TYPE)
    DestinationIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< communicationsService >-----#
    communicationsService = CLASS(name='communicationsService', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _communicationsService_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CommunicationsService')))
    __ATTRIBUTE_equality_match_val_AssertionType_7 = OID(name='AssertionType', mode=MODE_TYPE)
    communicationsService._val = dict([('Type', _communicationsService_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['communicationsService']), ('id', (2, 5, 4, 66))])
    
    #-----< CommunicationsService >-----#
    CommunicationsService = OID(name='CommunicationsService', mode=MODE_TYPE)
    
    #-----< communicationsNetwork >-----#
    communicationsNetwork = CLASS(name='communicationsNetwork', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _communicationsNetwork_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CommunicationsNetwork')))
    communicationsNetwork._val = dict([('Type', _communicationsNetwork_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['communicationsNetwork']), ('id', (2, 5, 4, 67))])
    
    #-----< CommunicationsNetwork >-----#
    CommunicationsNetwork = OID(name='CommunicationsNetwork', mode=MODE_TYPE)
    
    #-----< preferredDeliveryMethod >-----#
    preferredDeliveryMethod = CLASS(name='preferredDeliveryMethod', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _preferredDeliveryMethod_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PreferredDeliveryMethod')))
    preferredDeliveryMethod._val = dict([('Type', _preferredDeliveryMethod_val_Type), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14)), ('ldapName', ['preferredDeliveryMethod']), ('id', (2, 5, 4, 28))])
    
    #-----< PreferredDeliveryMethod >-----#
    PreferredDeliveryMethod = SEQ_OF(name='PreferredDeliveryMethod', mode=MODE_TYPE)
    _PreferredDeliveryMethod__item_ = INT(name='_item_', mode=MODE_TYPE)
    _PreferredDeliveryMethod__item_._cont = ASN1Dict([('any-delivery-method', 0), ('mhs-delivery', 1), ('physical-delivery', 2), ('telex-delivery', 3), ('teletex-delivery', 4), ('g3-facsimile-delivery', 5), ('g4-facsimile-delivery', 6), ('ia5-terminal-delivery', 7), ('videotex-delivery', 8), ('telephone-delivery', 9)])
    PreferredDeliveryMethod._cont = _PreferredDeliveryMethod__item_
    
    #-----< presentationAddress >-----#
    presentationAddress = CLASS(name='presentationAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _presentationAddress_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    __ATTRIBUTE_equality_match_val_AssertionType_8 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddress._val = dict([('Type', _presentationAddress_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_8), ('id', (2, 5, 13, 22))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 43)), ('ldapName', ['presentationAddress']), ('id', (2, 5, 4, 29))])
    
    #-----< PresentationAddress >-----#
    PresentationAddress = SEQ(name='PresentationAddress', mode=MODE_TYPE)
    _PresentationAddress_pSelector = OCT_STR(name='pSelector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_sSelector = OCT_STR(name='sSelector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_tSelector = OCT_STR(name='tSelector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_nAddresses = SET_OF(name='nAddresses', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PresentationAddress_nAddresses__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _PresentationAddress_nAddresses._cont = __PresentationAddress_nAddresses__item_
    _PresentationAddress_nAddresses._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PresentationAddress._cont = ASN1Dict([
        ('pSelector', _PresentationAddress_pSelector),
        ('sSelector', _PresentationAddress_sSelector),
        ('tSelector', _PresentationAddress_tSelector),
        ('nAddresses', _PresentationAddress_nAddresses),
        ])
    PresentationAddress._ext = []
    
    #-----< supportedApplicationContext >-----#
    supportedApplicationContext = CLASS(name='supportedApplicationContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedApplicationContext_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedApplicationContext._val = dict([('Type', _supportedApplicationContext_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['supportedApplicationContext']), ('id', (2, 5, 4, 30))])
    
    #-----< protocolInformation >-----#
    protocolInformation = CLASS(name='protocolInformation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _protocolInformation_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    __ATTRIBUTE_equality_match_val_AssertionType_9 = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    protocolInformation._val = dict([('Type', _protocolInformation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('id', (2, 5, 13, 24))])), ('id', (2, 5, 4, 48))])
    
    #-----< ProtocolInformation >-----#
    ProtocolInformation = SEQ(name='ProtocolInformation', mode=MODE_TYPE)
    _ProtocolInformation_nAddress = OCT_STR(name='nAddress', mode=MODE_TYPE)
    _ProtocolInformation_profiles = SET_OF(name='profiles', mode=MODE_TYPE)
    __ProtocolInformation_profiles__item_ = OID(name='_item_', mode=MODE_TYPE)
    _ProtocolInformation_profiles._cont = __ProtocolInformation_profiles__item_
    ProtocolInformation._cont = ASN1Dict([
        ('nAddress', _ProtocolInformation_nAddress),
        ('profiles', _ProtocolInformation_profiles),
        ])
    ProtocolInformation._ext = None
    
    #-----< distinguishedName >-----#
    distinguishedName = CLASS(name='distinguishedName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _distinguishedName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_10 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    distinguishedName._val = dict([('Type', _distinguishedName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])
    
    #-----< member >-----#
    member = CLASS(name='member', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_6 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    member._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['member']), ('id', (2, 5, 4, 31))])
    
    #-----< uniqueMember >-----#
    uniqueMember = CLASS(name='uniqueMember', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uniqueMember_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    __ATTRIBUTE_equality_match_val_AssertionType__11 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    uniqueMember._val = dict([('Type', _uniqueMember_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType__11), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), ('ldapName', ['uniqueMemberMatch']), ('id', (2, 5, 13, 23))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), ('ldapName', ['uniqueMember']), ('id', (2, 5, 4, 50))])
    
    #-----< NameAndOptionalUID >-----#
    NameAndOptionalUID = SEQ(name='NameAndOptionalUID', mode=MODE_TYPE)
    _NameAndOptionalUID_dn = SEQ_OF(name='dn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _NameAndOptionalUID_uid = BIT_STR(name='uid', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    NameAndOptionalUID._cont = ASN1Dict([
        ('dn', _NameAndOptionalUID_dn),
        ('uid', _NameAndOptionalUID_uid),
        ])
    NameAndOptionalUID._ext = []
    
    #-----< owner >-----#
    owner = CLASS(name='owner', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    owner._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['owner']), ('id', (2, 5, 4, 32))])
    
    #-----< roleOccupant >-----#
    roleOccupant = CLASS(name='roleOccupant', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    roleOccupant._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['roleOccupant']), ('id', (2, 5, 4, 33))])
    
    #-----< seeAlso >-----#
    seeAlso = CLASS(name='seeAlso', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    seeAlso._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['seeAlso']), ('id', (2, 5, 4, 34))])
    
    #-----< dmdName >-----#
    dmdName = CLASS(name='dmdName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dmdName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    dmdName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _dmdName_val_Type), ('id', (2, 5, 4, 54))])
    
    #-----< oidC1 >-----#
    oidC1 = CLASS(name='oidC1', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC1_val_Type = INT(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType___12 = INT(name='AssertionType', mode=MODE_TYPE)
    oidC1._val = dict([('Type', _oidC1_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType___12), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('id', (2, 17, 1, 2, 0))])
    
    #-----< oidC2 >-----#
    oidC2 = CLASS(name='oidC2', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC2_val_Type = INT(name='Type', mode=MODE_TYPE)
    oidC2._val = dict([('Type', _oidC2_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType___12), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('id', (2, 17, 1, 2, 1))])
    
    #-----< oidC >-----#
    oidC = CLASS(name='oidC', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC_val_Type = INT(name='Type', mode=MODE_TYPE)
    oidC._val = dict([('Type', _oidC_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType___12), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('id', (2, 17, 1, 2, 2))])
    
    #-----< urnC >-----#
    urnC = CLASS(name='urnC', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _urnC_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    urnC._val = dict([('Type', _urnC_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactMatch']), ('id', (2, 5, 13, 5))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['urnC']), ('id', (2, 5, 4, 89))])
    
    #-----< tagOid >-----#
    tagOid = CLASS(name='tagOid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _tagOid_val_Type = OID(name='Type', mode=MODE_TYPE)
    tagOid._val = dict([('Type', _tagOid_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['tagOid']), ('id', (2, 5, 4, 78))])
    
    #-----< uiiFormat >-----#
    uiiFormat = CLASS(name='uiiFormat', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uiiFormat_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFormat')))
    uiiFormat._val = dict([('Type', _uiiFormat_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 5)), ('ldapName', ['uiiFormat']), ('id', (2, 5, 4, 79))])
    
    #-----< UiiFormat >-----#
    UiiFormat = SEQ(name='UiiFormat', mode=MODE_TYPE)
    _UiiFormat_baseObject = STR_UTF8(name='baseObject', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')), opt=True)
    _UiiFormat_subset = ENUM(name='subset', mode=MODE_TYPE, default='baseObject')
    _UiiFormat_subset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    _UiiFormat_subset._ext = None
    _UiiFormat_next = CHOICE(name='next', mode=MODE_TYPE)
    __UiiFormat_next_length = INT(name='length', mode=MODE_TYPE)
    __UiiFormat_next_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFormat_next._cont = ASN1Dict([
        ('length', __UiiFormat_next_length),
        ('filter', __UiiFormat_next_filter),
        ])
    _UiiFormat_next._ext = None
    UiiFormat._cont = ASN1Dict([
        ('baseObject', _UiiFormat_baseObject),
        ('subset', _UiiFormat_subset),
        ('next', _UiiFormat_next),
        ])
    UiiFormat._ext = None
    
    #-----< UiiFilter >-----#
    UiiFilter = CHOICE(name='UiiFilter', mode=MODE_TYPE)
    _UiiFilter_item = SEQ(name='item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiItem')))
    _UiiFilter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UiiFilter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFilter_and_._cont = __UiiFilter_and___item_
    _UiiFilter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UiiFilter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFilter_or_._cont = __UiiFilter_or___item_
    _UiiFilter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    UiiFilter._cont = ASN1Dict([
        ('item', _UiiFilter_item),
        ('and', _UiiFilter_and_),
        ('or', _UiiFilter_or_),
        ('not', _UiiFilter_not_),
        ])
    UiiFilter._ext = None
    
    #-----< UiiItem >-----#
    UiiItem = SEQ(name='UiiItem', mode=MODE_TYPE)
    _UiiItem_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _UiiItem_length = INT(name='length', mode=MODE_TYPE, opt=True)
    UiiItem._cont = ASN1Dict([
        ('type', _UiiItem_type),
        ('length', _UiiItem_length),
        ])
    UiiItem._ext = None
    
    #-----< uiiInUrn >-----#
    uiiInUrn = CLASS(name='uiiInUrn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uiiInUrn_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    uiiInUrn._val = dict([('Type', _uiiInUrn_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactMatch']), ('id', (2, 5, 13, 5))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uiiInUrn']), ('id', (2, 5, 4, 80))])
    
    #-----< contentUrl >-----#
    contentUrl = CLASS(name='contentUrl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    contentUrl._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['url']), ('id', (2, 5, 4, 87))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['contentUrl']), ('id', (2, 5, 4, 81))])
    
    #-----< uii >-----#
    uii = CLASS(name='uii', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uii_val_Type = BIT_STR(name='Type', mode=MODE_TYPE)
    uii._val = dict([('Type', _uii_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['uii']), ('id', (2, 5, 4, 90))])
    
    #-----< epc >-----#
    epc = CLASS(name='epc', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _epc_val_Type = BIT_STR(name='Type', mode=MODE_TYPE)
    epc._val = dict([('Type', _epc_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['epc']), ('id', (2, 5, 4, 91))])
    
    #-----< tagAfi >-----#
    tagAfi = CLASS(name='tagAfi', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _tagAfi_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    tagAfi._val = dict([('Type', _tagAfi_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringMatch']), ('id', (2, 5, 13, 17))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['tagAfi']), ('id', (2, 5, 4, 92))])
    
    #-----< epcFormat >-----#
    epcFormat = CLASS(name='epcFormat', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _epcFormat_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EpcFormat')))
    epcFormat._val = dict([('Type', _epcFormat_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 6)), ('ldapName', ['epcFormat']), ('id', (2, 5, 4, 93))])
    
    #-----< EpcFormat >-----#
    EpcFormat = SEQ(name='EpcFormat', mode=MODE_TYPE)
    _EpcFormat_fields = SEQ_OF(name='fields', mode=MODE_TYPE)
    __EpcFormat_fields__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___EpcFormat_fields__item__bits = INT(name='bits', mode=MODE_TYPE)
    ___EpcFormat_fields__item__charField = CHOICE(name='charField', mode=MODE_TYPE)
    ____EpcFormat_fields__item__charField_characters = INT(name='characters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____EpcFormat_fields__item__charField_maxValue = INT(name='maxValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EpcFormat_fields__item__charField._cont = ASN1Dict([
        ('characters', ____EpcFormat_fields__item__charField_characters),
        ('maxValue', ____EpcFormat_fields__item__charField_maxValue),
        ])
    ___EpcFormat_fields__item__charField._ext = None
    ___EpcFormat_fields__item__result = ENUM(name='result', mode=MODE_TYPE, default='numericPad')
    ___EpcFormat_fields__item__result._cont = ASN1Dict([('numericPad', 0), ('numeric', 1), ('alpha7bits', 2)])
    ___EpcFormat_fields__item__result._ext = None
    __EpcFormat_fields__item_._cont = ASN1Dict([
        ('bits', ___EpcFormat_fields__item__bits),
        ('charField', ___EpcFormat_fields__item__charField),
        ('result', ___EpcFormat_fields__item__result),
        ])
    __EpcFormat_fields__item_._ext = None
    _EpcFormat_fields._cont = __EpcFormat_fields__item_
    _EpcFormat_fields._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EpcFormat_digitShift = INT(name='digitShift', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EpcFormat_checkCalc = INT(name='checkCalc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EpcFormat_urnPrefix = STR_UTF8(name='urnPrefix', mode=MODE_TYPE, opt=True)
    EpcFormat._cont = ASN1Dict([
        ('fields', _EpcFormat_fields),
        ('digitShift', _EpcFormat_digitShift),
        ('checkCalc', _EpcFormat_checkCalc),
        ('urnPrefix', _EpcFormat_urnPrefix),
        ])
    EpcFormat._ext = None
    
    #-----< epcInUrn >-----#
    epcInUrn = CLASS(name='epcInUrn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    epcInUrn._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['urn']), ('id', (2, 5, 4, 86))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['epcInUrn']), ('id', (2, 5, 4, 94))])
    
    #-----< ldapUrl >-----#
    ldapUrl = CLASS(name='ldapUrl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ldapUrl._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['url']), ('id', (2, 5, 4, 87))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['ldapUrl']), ('id', (2, 5, 4, 95))])
    
    #-----< tagLocation >-----#
    tagLocation = CLASS(name='tagLocation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_7 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    tagLocation._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_7), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 4)), ('ldapName', ['utmCoordinates']), ('id', (2, 5, 4, 88))])), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 4)), ('ldapName', ['tagLocation']), ('id', (2, 5, 4, 96))])
    
    #-----< dSAProblem >-----#
    dSAProblem = CLASS(name='dSAProblem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dSAProblem_val_Type = OID(name='Type', mode=MODE_TYPE)
    dSAProblem._val = dict([('Type', _dSAProblem_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 0))])
    
    #-----< searchServiceProblem >-----#
    searchServiceProblem = CLASS(name='searchServiceProblem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchServiceProblem_val_Type = OID(name='Type', mode=MODE_TYPE)
    searchServiceProblem._val = dict([('Type', _searchServiceProblem_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('id', (2, 5, 35, 1))])
    
    #-----< serviceType >-----#
    serviceType = CLASS(name='serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceType_val_Type = OID(name='Type', mode=MODE_TYPE)
    serviceType._val = dict([('Type', _serviceType_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('id', (2, 5, 35, 2))])
    
    #-----< attributeTypeList >-----#
    attributeTypeList = CLASS(name='attributeTypeList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeTypeList_val_Type = OID(name='Type', mode=MODE_TYPE)
    attributeTypeList._val = dict([('Type', _attributeTypeList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 3))])
    
    #-----< matchingRuleList >-----#
    matchingRuleList = CLASS(name='matchingRuleList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRuleList_val_Type = OID(name='Type', mode=MODE_TYPE)
    matchingRuleList._val = dict([('Type', _matchingRuleList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 4))])
    
    #-----< filterItem >-----#
    filterItem = CLASS(name='filterItem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _filterItem_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FilterItem')))
    filterItem._val = dict([('Type', _filterItem_val_Type), ('id', (2, 5, 35, 5))])
    
    #-----< attributeCombinations >-----#
    attributeCombinations = CLASS(name='attributeCombinations', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCombinations_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    attributeCombinations._val = dict([('Type', _attributeCombinations_val_Type), ('id', (2, 5, 35, 6))])
    
    #-----< contextTypeList >-----#
    contextTypeList = CLASS(name='contextTypeList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextTypeList_val_Type = OID(name='Type', mode=MODE_TYPE)
    contextTypeList._val = dict([('Type', _contextTypeList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 7))])
    
    #-----< contextList >-----#
    contextList = CLASS(name='contextList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    contextList._val = dict([('Type', _contextList_val_Type), ('id', (2, 5, 35, 8))])
    
    #-----< contextCombinations >-----#
    contextCombinations = CLASS(name='contextCombinations', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextCombinations_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    contextCombinations._val = dict([('Type', _contextCombinations_val_Type), ('id', (2, 5, 35, 9))])
    
    #-----< hierarchySelectList >-----#
    hierarchySelectList = CLASS(name='hierarchySelectList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchySelectList_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')))
    hierarchySelectList._val = dict([('Type', _hierarchySelectList_val_Type), ('single-valued', True), ('id', (2, 5, 35, 10))])
    
    #-----< searchControlOptionsList >-----#
    searchControlOptionsList = CLASS(name='searchControlOptionsList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchControlOptionsList_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')))
    searchControlOptionsList._val = dict([('Type', _searchControlOptionsList_val_Type), ('single-valued', True), ('id', (2, 5, 35, 11))])
    
    #-----< serviceControlOptionsList >-----#
    serviceControlOptionsList = CLASS(name='serviceControlOptionsList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceControlOptionsList_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')))
    serviceControlOptionsList._val = dict([('Type', _serviceControlOptionsList_val_Type), ('single-valued', True), ('id', (2, 5, 35, 12))])
    
    #-----< multipleMatchingLocalities >-----#
    multipleMatchingLocalities = CLASS(name='multipleMatchingLocalities', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _multipleMatchingLocalities_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MultipleMatchingLocalities')))
    multipleMatchingLocalities._val = dict([('Type', _multipleMatchingLocalities_val_Type), ('id', (2, 5, 35, 13))])
    
    #-----< MultipleMatchingLocalities >-----#
    MultipleMatchingLocalities = SEQ(name='MultipleMatchingLocalities', mode=MODE_TYPE)
    _MultipleMatchingLocalities_matchingRuleUsed = OID(name='matchingRuleUsed', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _MultipleMatchingLocalities_attributeList = SEQ_OF(name='attributeList', mode=MODE_TYPE)
    __MultipleMatchingLocalities_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _MultipleMatchingLocalities_attributeList._cont = __MultipleMatchingLocalities_attributeList__item_
    MultipleMatchingLocalities._cont = ASN1Dict([
        ('matchingRuleUsed', _MultipleMatchingLocalities_matchingRuleUsed),
        ('attributeList', _MultipleMatchingLocalities_attributeList),
        ])
    MultipleMatchingLocalities._ext = []
    
    #-----< proposedRelaxation >-----#
    proposedRelaxation = CLASS(name='proposedRelaxation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _proposedRelaxation_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MRMappings')))
    proposedRelaxation._val = dict([('Type', _proposedRelaxation_val_Type), ('id', (2, 5, 35, 14))])
    
    #-----< MRMappings >-----#
    MRMappings = SEQ_OF(name='MRMappings', mode=MODE_TYPE)
    _MRMappings__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    MRMappings._cont = _MRMappings__item_
    
    #-----< appliedRelaxation >-----#
    appliedRelaxation = CLASS(name='appliedRelaxation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _appliedRelaxation_val_Type = OID(name='Type', mode=MODE_TYPE)
    appliedRelaxation._val = dict([('Type', _appliedRelaxation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 15))])
    
    #-----< pwdResponseValue >-----#
    pwdResponseValue = CLASS(name='pwdResponseValue', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdResponseValue_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PwdResponse')))
    pwdResponseValue._val = dict([('Type', _pwdResponseValue_val_Type), ('id', (2, 5, 35, 16))])
    
    #-----< PwdResponse >-----#
    PwdResponse = SEQ(name='PwdResponse', mode=MODE_TYPE)
    _PwdResponse_warning = CHOICE(name='warning', mode=MODE_TYPE, opt=True)
    __PwdResponse_warning_timeleft = INT(name='timeleft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponse_warning_timeleft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __PwdResponse_warning_graceRemaining = INT(name='graceRemaining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponse_warning_graceRemaining._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PwdResponse_warning._cont = ASN1Dict([
        ('timeleft', __PwdResponse_warning_timeleft),
        ('graceRemaining', __PwdResponse_warning_graceRemaining),
        ])
    _PwdResponse_warning._ext = []
    _PwdResponse_error = ENUM(name='error', mode=MODE_TYPE, opt=True)
    _PwdResponse_error._cont = ASN1Dict([('passwordExpired', 0), ('changeAfterReset', 1)])
    _PwdResponse_error._ext = []
    PwdResponse._cont = ASN1Dict([
        ('warning', _PwdResponse_warning),
        ('error', _PwdResponse_error),
        ])
    PwdResponse._ext = None
    
    #-----< ldapDiagnosticMsg >-----#
    ldapDiagnosticMsg = CLASS(name='ldapDiagnosticMsg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ldapDiagnosticMsg_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    ldapDiagnosticMsg._val = dict([('Type', _ldapDiagnosticMsg_val_Type), ('single-valued', True), ('id', (2, 5, 35, 17))])
    
    #-----< uid >-----#
    uid = CLASS(name='uid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uid_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    uid._val = dict([('Type', _uid_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uid']), ('id', (0, 9, 2342, 19200300, 100, 1, 1))])
    
    #-----< dc >-----#
    dc = CLASS(name='dc', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dc_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    dc._val = dict([('Type', _dc_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['dc']), ('id', (0, 9, 2342, 19200300, 100, 1, 25))])
    
    #-----< caseExactMatch >-----#
    caseExactMatch = CLASS(name='caseExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseExactMatch._val = dict([('AssertionType', _caseExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactMatch']), ('id', (2, 5, 13, 5))])
    
    #-----< caseIgnoreMatch >-----#
    caseIgnoreMatch = CLASS(name='caseIgnoreMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseIgnoreMatch._val = dict([('AssertionType', _caseIgnoreMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])
    
    #-----< caseExactOrderingMatch >-----#
    caseExactOrderingMatch = CLASS(name='caseExactOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactOrderingMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseExactOrderingMatch._val = dict([('AssertionType', _caseExactOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactOrderingMatch']), ('id', (2, 5, 13, 6))])
    
    #-----< caseIgnoreOrderingMatch >-----#
    caseIgnoreOrderingMatch = CLASS(name='caseIgnoreOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreOrderingMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseIgnoreOrderingMatch._val = dict([('AssertionType', _caseIgnoreOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreOrderingMatch']), ('id', (2, 5, 13, 3))])
    
    #-----< caseExactSubstringsMatch >-----#
    caseExactSubstringsMatch = CLASS(name='caseExactSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseExactSubstringsMatch._val = dict([('AssertionType', _caseExactSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseExactSubstringsMatch']), ('id', (2, 5, 13, 7))])
    
    #-----< caseIgnoreSubstringsMatch >-----#
    caseIgnoreSubstringsMatch = CLASS(name='caseIgnoreSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreSubstringsMatch._val = dict([('AssertionType', _caseIgnoreSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])
    
    #-----< SubstringAssertion >-----#
    SubstringAssertion = SEQ_OF(name='SubstringAssertion', mode=MODE_TYPE)
    _SubstringAssertion__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __SubstringAssertion__item__initial = CHOICE(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__any = CHOICE(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__final = CHOICE(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__control = SEQ(name='control', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubstringAssertion__item__control_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SubstringAssertion__item__control_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubstringAssertion__item__control_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SubstringAssertion__item__control_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubstringAssertion__item__control_type_tab._val = ASN1Set(rv=[dict([('Type', _____SubstringAssertion__item__control_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SubstringAssertion__item__control_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubstringAssertion__item__control_type._const_tab = ____SubstringAssertion__item__control_type_tab
    ___SubstringAssertion__item__control_type._const_tab_at = None
    ___SubstringAssertion__item__control_type._const_tab_id = 'id'
    ___SubstringAssertion__item__control_values = SET_OF(name='values', mode=MODE_TYPE)
    ____SubstringAssertion__item__control_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SubstringAssertion__item__control_values__item_._const_tab = ____SubstringAssertion__item__control_type_tab
    ____SubstringAssertion__item__control_values__item_._const_tab_at = ('..', '..', 'type')
    ____SubstringAssertion__item__control_values__item_._const_tab_id = 'Type'
    ___SubstringAssertion__item__control_values._cont = ____SubstringAssertion__item__control_values__item_
    ___SubstringAssertion__item__control_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubstringAssertion__item__control_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubstringAssertion__item__control_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubstringAssertion__item__control_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab = ____SubstringAssertion__item__control_type_tab
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab_id = 'Type'
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList._cont = ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubstringAssertion__item__control_valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SubstringAssertion__item__control_valuesWithContext__item__value),
        ('contextList', _____SubstringAssertion__item__control_valuesWithContext__item__contextList),
        ])
    ____SubstringAssertion__item__control_valuesWithContext__item_._ext = []
    ___SubstringAssertion__item__control_valuesWithContext._cont = ____SubstringAssertion__item__control_valuesWithContext__item_
    ___SubstringAssertion__item__control_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubstringAssertion__item__control._cont = ASN1Dict([
        ('type', ___SubstringAssertion__item__control_type),
        ('values', ___SubstringAssertion__item__control_values),
        ('valuesWithContext', ___SubstringAssertion__item__control_valuesWithContext),
        ])
    __SubstringAssertion__item__control._ext = []
    _SubstringAssertion__item_._cont = ASN1Dict([
        ('initial', __SubstringAssertion__item__initial),
        ('any', __SubstringAssertion__item__any),
        ('final', __SubstringAssertion__item__final),
        ('control', __SubstringAssertion__item__control),
        ])
    _SubstringAssertion__item_._ext = []
    SubstringAssertion._cont = _SubstringAssertion__item_
    
    #-----< numericStringMatch >-----#
    numericStringMatch = CLASS(name='numericStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringMatch_val_AssertionType = STR_NUM(name='AssertionType', mode=MODE_TYPE)
    numericStringMatch._val = dict([('AssertionType', _numericStringMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])
    
    #-----< numericStringOrderingMatch >-----#
    numericStringOrderingMatch = CLASS(name='numericStringOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringOrderingMatch_val_AssertionType = STR_NUM(name='AssertionType', mode=MODE_TYPE)
    numericStringOrderingMatch._val = dict([('AssertionType', _numericStringOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringOrderingMatch']), ('id', (2, 5, 13, 9))])
    
    #-----< numericStringSubstringsMatch >-----#
    numericStringSubstringsMatch = CLASS(name='numericStringSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    numericStringSubstringsMatch._val = dict([('AssertionType', _numericStringSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])
    
    #-----< caseIgnoreListMatch >-----#
    caseIgnoreListMatch = CLASS(name='caseIgnoreListMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreListMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CaseIgnoreList')))
    caseIgnoreListMatch._val = dict([('AssertionType', _caseIgnoreListMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])
    
    #-----< CaseIgnoreList >-----#
    CaseIgnoreList = SEQ_OF(name='CaseIgnoreList', mode=MODE_TYPE)
    _CaseIgnoreList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    CaseIgnoreList._cont = _CaseIgnoreList__item_
    
    #-----< caseIgnoreListSubstringsMatch >-----#
    caseIgnoreListSubstringsMatch = CLASS(name='caseIgnoreListSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreListSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreListSubstringsMatch._val = dict([('AssertionType', _caseIgnoreListSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])
    
    #-----< storedPrefixMatch >-----#
    storedPrefixMatch = CLASS(name='storedPrefixMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _storedPrefixMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    storedPrefixMatch._val = dict([('AssertionType', _storedPrefixMatch_val_AssertionType), ('id', (2, 5, 13, 41))])
    
    #-----< booleanMatch >-----#
    booleanMatch = CLASS(name='booleanMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _booleanMatch_val_AssertionType = BOOL(name='AssertionType', mode=MODE_TYPE)
    booleanMatch._val = dict([('AssertionType', _booleanMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])
    
    #-----< integerMatch >-----#
    integerMatch = CLASS(name='integerMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerMatch_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    integerMatch._val = dict([('AssertionType', _integerMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])
    
    #-----< integerOrderingMatch >-----#
    integerOrderingMatch = CLASS(name='integerOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerOrderingMatch_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    integerOrderingMatch._val = dict([('AssertionType', _integerOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])
    
    #-----< bitStringMatch >-----#
    bitStringMatch = CLASS(name='bitStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _bitStringMatch_val_AssertionType = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    bitStringMatch._val = dict([('AssertionType', _bitStringMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])
    
    #-----< octetStringMatch >-----#
    octetStringMatch = CLASS(name='octetStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringMatch_val_AssertionType = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    octetStringMatch._val = dict([('AssertionType', _octetStringMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringMatch']), ('id', (2, 5, 13, 17))])
    
    #-----< octetStringOrderingMatch >-----#
    octetStringOrderingMatch = CLASS(name='octetStringOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringOrderingMatch_val_AssertionType = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    octetStringOrderingMatch._val = dict([('AssertionType', _octetStringOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringOrderingMatch']), ('id', (2, 5, 13, 18))])
    
    #-----< octetStringSubstringsMatch >-----#
    octetStringSubstringsMatch = CLASS(name='octetStringSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'OctetSubstringAssertion')))
    octetStringSubstringsMatch._val = dict([('AssertionType', _octetStringSubstringsMatch_val_AssertionType), ('id', (2, 5, 13, 19))])
    
    #-----< OctetSubstringAssertion >-----#
    OctetSubstringAssertion = SEQ_OF(name='OctetSubstringAssertion', mode=MODE_TYPE)
    _OctetSubstringAssertion__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __OctetSubstringAssertion__item__initial = OCT_STR(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OctetSubstringAssertion__item__any = OCT_STR(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OctetSubstringAssertion__item__final = OCT_STR(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OctetSubstringAssertion__item_._cont = ASN1Dict([
        ('initial', __OctetSubstringAssertion__item__initial),
        ('any', __OctetSubstringAssertion__item__any),
        ('final', __OctetSubstringAssertion__item__final),
        ])
    _OctetSubstringAssertion__item_._ext = []
    OctetSubstringAssertion._cont = _OctetSubstringAssertion__item_
    
    #-----< telephoneNumberMatch >-----#
    telephoneNumberMatch = CLASS(name='telephoneNumberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _telephoneNumberMatch_val_AssertionType = STR_PRINT(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNumberMatch._val = dict([('AssertionType', _telephoneNumberMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), ('ldapName', ['telephoneNumberMatch']), ('id', (2, 5, 13, 20))])
    
    #-----< telephoneNumberSubstringsMatch >-----#
    telephoneNumberSubstringsMatch = CLASS(name='telephoneNumberSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _telephoneNumberSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    telephoneNumberSubstringsMatch._val = dict([('AssertionType', _telephoneNumberSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['telephoneNumberSubstringsMatch']), ('id', (2, 5, 13, 21))])
    
    #-----< presentationAddressMatch >-----#
    presentationAddressMatch = CLASS(name='presentationAddressMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _presentationAddressMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddressMatch._val = dict([('AssertionType', _presentationAddressMatch_val_AssertionType), ('id', (2, 5, 13, 22))])
    
    #-----< uniqueMemberMatch >-----#
    uniqueMemberMatch = CLASS(name='uniqueMemberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uniqueMemberMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    uniqueMemberMatch._val = dict([('AssertionType', _uniqueMemberMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), ('ldapName', ['uniqueMemberMatch']), ('id', (2, 5, 13, 23))])
    
    #-----< protocolInformationMatch >-----#
    protocolInformationMatch = CLASS(name='protocolInformationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _protocolInformationMatch_val_AssertionType = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    protocolInformationMatch._val = dict([('AssertionType', _protocolInformationMatch_val_AssertionType), ('id', (2, 5, 13, 24))])
    
    #-----< facsimileNumberMatch >-----#
    facsimileNumberMatch = CLASS(name='facsimileNumberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _facsimileNumberMatch_val_AssertionType = STR_PRINT(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    facsimileNumberMatch._val = dict([('AssertionType', _facsimileNumberMatch_val_AssertionType), ('id', (2, 5, 13, 63))])
    
    #-----< facsimileNumberSubstringsMatch >-----#
    facsimileNumberSubstringsMatch = CLASS(name='facsimileNumberSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _facsimileNumberSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    facsimileNumberSubstringsMatch._val = dict([('AssertionType', _facsimileNumberSubstringsMatch_val_AssertionType), ('id', (2, 5, 13, 64))])
    
    #-----< uUIDPairMatch >-----#
    uUIDPairMatch = CLASS(name='uUIDPairMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uUIDPairMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    uUIDPairMatch._val = dict([('AssertionType', _uUIDPairMatch_val_AssertionType), ('id', (2, 5, 13, 68))])
    
    #-----< uTCTimeMatch >-----#
    uTCTimeMatch = CLASS(name='uTCTimeMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uTCTimeMatch_val_AssertionType = TIME_UTC(name='AssertionType', mode=MODE_TYPE)
    uTCTimeMatch._val = dict([('AssertionType', _uTCTimeMatch_val_AssertionType), ('id', (2, 5, 13, 25))])
    
    #-----< uTCTimeOrderingMatch >-----#
    uTCTimeOrderingMatch = CLASS(name='uTCTimeOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uTCTimeOrderingMatch_val_AssertionType = TIME_UTC(name='AssertionType', mode=MODE_TYPE)
    uTCTimeOrderingMatch._val = dict([('AssertionType', _uTCTimeOrderingMatch_val_AssertionType), ('id', (2, 5, 13, 26))])
    
    #-----< generalizedTimeMatch >-----#
    generalizedTimeMatch = CLASS(name='generalizedTimeMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalizedTimeMatch_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    generalizedTimeMatch._val = dict([('AssertionType', _generalizedTimeMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])
    
    #-----< generalizedTimeOrderingMatch >-----#
    generalizedTimeOrderingMatch = CLASS(name='generalizedTimeOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalizedTimeOrderingMatch_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    generalizedTimeOrderingMatch._val = dict([('AssertionType', _generalizedTimeOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])
    
    #-----< systemProposedMatch >-----#
    systemProposedMatch = CLASS(name='systemProposedMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    systemProposedMatch._val = dict([('id', (2, 5, 13, 47))])
    
    #-----< integerFirstComponentMatch >-----#
    integerFirstComponentMatch = CLASS(name='integerFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerFirstComponentMatch_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    integerFirstComponentMatch._val = dict([('AssertionType', _integerFirstComponentMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])
    
    #-----< objectIdentifierFirstComponentMatch >-----#
    objectIdentifierFirstComponentMatch = CLASS(name='objectIdentifierFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _objectIdentifierFirstComponentMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    objectIdentifierFirstComponentMatch._val = dict([('AssertionType', _objectIdentifierFirstComponentMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])
    
    #-----< directoryStringFirstComponentMatch >-----#
    directoryStringFirstComponentMatch = CLASS(name='directoryStringFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _directoryStringFirstComponentMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    directoryStringFirstComponentMatch._val = dict([('AssertionType', _directoryStringFirstComponentMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])
    
    #-----< wordMatch >-----#
    wordMatch = CLASS(name='wordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _wordMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    wordMatch._val = dict([('AssertionType', _wordMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['wordMatch']), ('id', (2, 5, 13, 32))])
    
    #-----< keywordMatch >-----#
    keywordMatch = CLASS(name='keywordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _keywordMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    keywordMatch._val = dict([('AssertionType', _keywordMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['keywordMatch']), ('id', (2, 5, 13, 33))])
    
    #-----< generalWordMatch >-----#
    generalWordMatch = CLASS(name='generalWordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalWordMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    generalWordMatch._val = dict([('AssertionType', _generalWordMatch_val_AssertionType), ('id', (2, 5, 13, 48))])
    
    #-----< sequenceMatchType >-----#
    sequenceMatchType = CLASS(name='sequenceMatchType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _sequenceMatchType_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SequenceMatchType')))
    sequenceMatchType._val = dict([('Type', _sequenceMatchType_val_Type), ('single-valued', True), ('id', (2, 5, 37, 1))])
    
    #-----< SequenceMatchType >-----#
    SequenceMatchType = ENUM(name='SequenceMatchType', mode=MODE_TYPE)
    SequenceMatchType._cont = ASN1Dict([('sequenceExact', 0), ('sequenceDeletion', 1), ('sequenceRestrictedDeletion', 2), ('sequencePermutation', 3), ('sequencePermutationAndDeletion', 4), ('sequenceProviderDefined', 5)])
    SequenceMatchType._ext = []
    
    #-----< wordMatchTypes >-----#
    wordMatchTypes = CLASS(name='wordMatchTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _wordMatchTypes_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'WordMatchTypes')))
    wordMatchTypes._val = dict([('Type', _wordMatchTypes_val_Type), ('single-valued', True), ('id', (2, 5, 37, 2))])
    
    #-----< WordMatchTypes >-----#
    WordMatchTypes = ENUM(name='WordMatchTypes', mode=MODE_TYPE)
    WordMatchTypes._cont = ASN1Dict([('wordExact', 0), ('wordTruncated', 1), ('wordPhonetic', 2), ('wordProviderDefined', 3)])
    WordMatchTypes._ext = []
    
    #-----< characterMatchTypes >-----#
    characterMatchTypes = CLASS(name='characterMatchTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _characterMatchTypes_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CharacterMatchTypes')))
    characterMatchTypes._val = dict([('Type', _characterMatchTypes_val_Type), ('single-valued', True), ('id', (2, 5, 37, 3))])
    
    #-----< CharacterMatchTypes >-----#
    CharacterMatchTypes = ENUM(name='CharacterMatchTypes', mode=MODE_TYPE)
    CharacterMatchTypes._cont = ASN1Dict([('characterExact', 0), ('characterCaseIgnore', 1), ('characterMapped', 2)])
    CharacterMatchTypes._ext = []
    
    #-----< selectedContexts >-----#
    selectedContexts = CLASS(name='selectedContexts', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _selectedContexts_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    selectedContexts._val = dict([('Type', _selectedContexts_val_Type), ('id', (2, 5, 37, 4))])
    
    #-----< approximateStringMatch >-----#
    approximateStringMatch = CLASS(name='approximateStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    approximateStringMatch._val = dict([('id', (2, 5, 13, 49))])
    
    #-----< ignoreIfAbsentMatch >-----#
    ignoreIfAbsentMatch = CLASS(name='ignoreIfAbsentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    ignoreIfAbsentMatch._val = dict([('id', (2, 5, 13, 50))])
    
    #-----< nullMatch >-----#
    nullMatch = CLASS(name='nullMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    nullMatch._val = dict([('id', (2, 5, 13, 51))])
    
    #-----< ZONAL-MATCHING >-----#
    ZONAL_MATCHING = CLASS(name='ZONAL-MATCHING', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'MAPPING-BASED-MATCHING')))
    _ZONAL_MATCHING_selectBy = SEQ_OF(name='selectBy', mode=MODE_VALUE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ZonalSelect')), opt=True)
    _ZONAL_MATCHING_ApplicableTo = CLASS(name='ApplicableTo', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ZONAL_MATCHING_subtypesIncluded = BOOL(name='subtypesIncluded', mode=MODE_VALUE, default=True)
    _ZONAL_MATCHING_combinable = BOOL(name='combinable', mode=MODE_VALUE)
    _ZONAL_MATCHING_combinable._const_val = ASN1Set(rv=[True], rr=[], ev=None, er=[])
    _ZONAL_MATCHING_mappingResults = ENUM(name='mappingResults', mode=MODE_VALUE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ZonalResult')), opt=True)
    _ZONAL_MATCHING_userControl = BOOL(name='userControl', mode=MODE_VALUE, default=False)
    _ZONAL_MATCHING_exclusive = BOOL(name='exclusive', mode=MODE_VALUE, default=True)
    _ZONAL_MATCHING_matching_rule = OID(name='matching-rule', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _ZONAL_MATCHING_matching_rule._const_val = ASN1Set(rv=[(2, 5, 13, 52)], rr=[], ev=None, er=[])
    _ZONAL_MATCHING_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ZONAL_MATCHING._cont = ASN1Dict([
        ('selectBy', _ZONAL_MATCHING_selectBy),
        ('ApplicableTo', _ZONAL_MATCHING_ApplicableTo),
        ('subtypesIncluded', _ZONAL_MATCHING_subtypesIncluded),
        ('combinable', _ZONAL_MATCHING_combinable),
        ('mappingResults', _ZONAL_MATCHING_mappingResults),
        ('userControl', _ZONAL_MATCHING_userControl),
        ('exclusive', _ZONAL_MATCHING_exclusive),
        ('matching-rule', _ZONAL_MATCHING_matching_rule),
        ('id', _ZONAL_MATCHING_id),
        ])
    
    #-----< ZonalSelect >-----#
    ZonalSelect = SEQ_OF(name='ZonalSelect', mode=MODE_TYPE)
    _ZonalSelect__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ZonalSelect._cont = _ZonalSelect__item_
    
    #-----< ZonalResult >-----#
    ZonalResult = ENUM(name='ZonalResult', mode=MODE_TYPE)
    ZonalResult._cont = ASN1Dict([('cannot-select-mapping', 0), ('zero-mappings', 2), ('multiple-mappings', 3)])
    ZonalResult._ext = []
    
    #-----< zonalMatch >-----#
    zonalMatch = CLASS(name='zonalMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    __MATCHING_RULE_uniqueMatchIndicator_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MultipleMatchingLocalities')))
    zonalMatch._val = dict([('uniqueMatchIndicator', dict([('Type', __MATCHING_RULE_uniqueMatchIndicator_val_Type), ('id', (2, 5, 35, 13))])), ('id', (2, 5, 13, 52))])
    
    #-----< uriMatch >-----#
    uriMatch = CLASS(name='uriMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uriMatch_val_AssertionType = STR_UTF8(name='AssertionType', mode=MODE_TYPE)
    uriMatch._val = dict([('AssertionType', _uriMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])
    
    #-----< dnsNameMatch >-----#
    dnsNameMatch = CLASS(name='dnsNameMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _dnsNameMatch_val_AssertionType = STR_UTF8(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    dnsNameMatch._val = dict([('AssertionType', _dnsNameMatch_val_AssertionType), ('ldapSyntax', (2, 5, 40, 9)), ('ldapName', ['dnsNameMatch']), ('id', (2, 5, 13, 74))])
    
    #-----< caseExactIA5Match >-----#
    caseExactIA5Match = CLASS(name='caseExactIA5Match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactIA5Match_val_AssertionType = STR_IA5(name='AssertionType', mode=MODE_TYPE)
    caseExactIA5Match._val = dict([('AssertionType', _caseExactIA5Match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['caseExactIA5Match']), ('id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 1))])
    
    #-----< caseIgnoreIA5Match >-----#
    caseIgnoreIA5Match = CLASS(name='caseIgnoreIA5Match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreIA5Match_val_AssertionType = STR_IA5(name='AssertionType', mode=MODE_TYPE)
    caseIgnoreIA5Match._val = dict([('AssertionType', _caseIgnoreIA5Match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['caseIgnoreIA5Match']), ('id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2))])
    
    #-----< caseIgnoreIA5SubstringsMatch >-----#
    caseIgnoreIA5SubstringsMatch = CLASS(name='caseIgnoreIA5SubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreIA5SubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreIA5SubstringsMatch._val = dict([('AssertionType', _caseIgnoreIA5SubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreIA5SubstringsMatch']), ('id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2))])
    
    #-----< utmCoords >-----#
    utmCoords = CLASS(name='utmCoords', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _utmCoords_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    utmCoords._val = dict([('ldapDesc', 'UTM Coordinates'), ('Type', _utmCoords_val_Type), ('id', (2, 5, 40, 4))])
    
    #-----< uiiForm >-----#
    uiiForm = CLASS(name='uiiForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _uiiForm_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFormat')))
    uiiForm._val = dict([('ldapDesc', 'UII Format'), ('Type', _uiiForm_val_Type), ('id', (2, 5, 40, 5))])
    
    #-----< epcForm >-----#
    epcForm = CLASS(name='epcForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _epcForm_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EpcFormat')))
    epcForm._val = dict([('ldapDesc', 'EPC Format'), ('Type', _epcForm_val_Type), ('id', (2, 5, 40, 6))])
    
    #-----< countryString3c >-----#
    countryString3c = CLASS(name='countryString3c', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _countryString3c_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3c')))
    countryString3c._val = dict([('ldapDesc', 'Country String 3 characters'), ('Type', _countryString3c_val_Type), ('id', (2, 5, 40, 7))])
    
    #-----< countryString3n >-----#
    countryString3n = CLASS(name='countryString3n', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _countryString3n_val_Type = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3n')))
    countryString3n._val = dict([('ldapDesc', 'Country String 3 numeric characters'), ('Type', _countryString3n_val_Type), ('id', (2, 5, 40, 8))])
    
    #-----< dnsString >-----#
    dnsString = CLASS(name='dnsString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dnsString_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    dnsString._val = dict([('ldapDesc', 'DNS Name String'), ('Type', _dnsString_val_Type), ('id', (2, 5, 40, 9))])
    
    #-----< attributeTypeDescription >-----#
    attributeTypeDescription = CLASS(name='attributeTypeDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _attributeTypeDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    attributeTypeDescription._val = dict([('ldapDesc', 'Attribute Type Description'), ('Type', _attributeTypeDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3))])
    
    #-----< bitString >-----#
    bitString = CLASS(name='bitString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _bitString_val_Type = BIT_STR(name='Type', mode=MODE_TYPE)
    bitString._val = dict([('ldapDesc', 'Bit String'), ('Type', _bitString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6))])
    
    #-----< boolean >-----#
    boolean = CLASS(name='boolean', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _boolean_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    boolean._val = dict([('ldapDesc', 'Boolean'), ('Type', _boolean_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7))])
    
    #-----< countryString >-----#
    countryString = CLASS(name='countryString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _countryString_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryName')))
    countryString._val = dict([('ldapDesc', 'Country String'), ('Type', _countryString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11))])
    
    #-----< dn >-----#
    dn = CLASS(name='dn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dn_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    dn._val = dict([('ldapDesc', 'DN'), ('Type', _dn_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12))])
    
    #-----< deliveryMethod >-----#
    deliveryMethod = CLASS(name='deliveryMethod', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _deliveryMethod_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PreferredDeliveryMethod')))
    deliveryMethod._val = dict([('ldapDesc', 'Delevery Method'), ('Type', _deliveryMethod_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14))])
    
    #-----< directoryString >-----#
    directoryString = CLASS(name='directoryString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _directoryString_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    directoryString._val = dict([('ldapDesc', 'Directory String'), ('Type', _directoryString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15))])
    
    #-----< dITContentRuleDescription >-----#
    dITContentRuleDescription = CLASS(name='dITContentRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dITContentRuleDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    dITContentRuleDescription._val = dict([('ldapDesc', 'DIT Content Rule Description'), ('Type', _dITContentRuleDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16))])
    
    #-----< dITStructureRuleDescription >-----#
    dITStructureRuleDescription = CLASS(name='dITStructureRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dITStructureRuleDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    dITStructureRuleDescription._val = dict([('ldapDesc', 'DIT StructureRule Description'), ('Type', _dITStructureRuleDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17))])
    
    #-----< enhancedGuide >-----#
    enhancedGuide = CLASS(name='enhancedGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _enhancedGuide_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EnhancedGuide')))
    enhancedGuide._val = dict([('ldapDesc', 'Enhanced Guide'), ('Type', _enhancedGuide_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21))])
    
    #-----< facsimileTelephoneNr >-----#
    facsimileTelephoneNr = CLASS(name='facsimileTelephoneNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _facsimileTelephoneNr_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    facsimileTelephoneNr._val = dict([('ldapDesc', 'Facsimile Telephone Number'), ('Type', _facsimileTelephoneNr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22))])
    
    #-----< fax >-----#
    fax = CLASS(name='fax', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _fax_val_Type = NULL(name='Type', mode=MODE_TYPE)
    fax._val = dict([('ldapDesc', 'Fax'), ('Type', _fax_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 23))])
    
    #-----< generalizedTime >-----#
    generalizedTime = CLASS(name='generalizedTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _generalizedTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    generalizedTime._val = dict([('ldapDesc', 'Generalized Time'), ('Type', _generalizedTime_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24))])
    
    #-----< guide >-----#
    guide = CLASS(name='guide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _guide_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Guide')))
    guide._val = dict([('ldapDesc', 'Guide'), ('Type', _guide_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25))])
    
    #-----< ia5String >-----#
    ia5String = CLASS(name='ia5String', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _ia5String_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    ia5String._val = dict([('ldapDesc', 'IA5 String'), ('Type', _ia5String_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26))])
    
    #-----< integer >-----#
    integer = CLASS(name='integer', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _integer_val_Type = INT(name='Type', mode=MODE_TYPE)
    integer._val = dict([('ldapDesc', 'INTEGER'), ('Type', _integer_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27))])
    
    #-----< jpeg >-----#
    jpeg = CLASS(name='jpeg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _jpeg_val_Type = NULL(name='Type', mode=MODE_TYPE)
    jpeg._val = dict([('ldapDesc', 'JPEG'), ('Type', _jpeg_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 28))])
    
    #-----< matchingRuleDescription >-----#
    matchingRuleDescription = CLASS(name='matchingRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _matchingRuleDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    matchingRuleDescription._val = dict([('ldapDesc', 'Matching Rule Description'), ('Type', _matchingRuleDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30))])
    
    #-----< matchingRuleUseDescription >-----#
    matchingRuleUseDescription = CLASS(name='matchingRuleUseDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _matchingRuleUseDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    matchingRuleUseDescription._val = dict([('ldapDesc', 'Matching Rule Use Description'), ('Type', _matchingRuleUseDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31))])
    
    #-----< nameAndOptionalUID >-----#
    nameAndOptionalUID = CLASS(name='nameAndOptionalUID', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _nameAndOptionalUID_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    nameAndOptionalUID._val = dict([('ldapDesc', 'Name And Optional UID'), ('Type', _nameAndOptionalUID_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34))])
    
    #-----< nameFormDescription >-----#
    nameFormDescription = CLASS(name='nameFormDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _nameFormDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    nameFormDescription._val = dict([('ldapDesc', 'Name Form Description'), ('Type', _nameFormDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35))])
    
    #-----< numericString >-----#
    numericString = CLASS(name='numericString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _numericString_val_Type = STR_NUM(name='Type', mode=MODE_TYPE)
    numericString._val = dict([('ldapDesc', 'Numeric String'), ('Type', _numericString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36))])
    
    #-----< objectClassDescription >-----#
    objectClassDescription = CLASS(name='objectClassDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _objectClassDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    objectClassDescription._val = dict([('ldapDesc', 'Object Class Description'), ('Type', _objectClassDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37))])
    
    #-----< oid >-----#
    oid = CLASS(name='oid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _oid_val_Type = OID(name='Type', mode=MODE_TYPE)
    oid._val = dict([('ldapDesc', 'OID'), ('Type', _oid_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38))])
    
    #-----< otherMailbox >-----#
    otherMailbox = CLASS(name='otherMailbox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _otherMailbox_val_Type = NULL(name='Type', mode=MODE_TYPE)
    otherMailbox._val = dict([('ldapDesc', 'Other Mailbox'), ('Type', _otherMailbox_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 39))])
    
    #-----< octetString >-----#
    octetString = CLASS(name='octetString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _octetString_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    octetString._val = dict([('ldapDesc', 'Octet String'), ('Type', _octetString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40))])
    
    #-----< postalAddr >-----#
    postalAddr = CLASS(name='postalAddr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _postalAddr_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    postalAddr._val = dict([('ldapDesc', 'Postal Address'), ('Type', _postalAddr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41))])
    
    #-----< presentationAddr >-----#
    presentationAddr = CLASS(name='presentationAddr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _presentationAddr_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddr._val = dict([('ldapDesc', 'Presentation Address'), ('Type', _presentationAddr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 43))])
    
    #-----< printableString >-----#
    printableString = CLASS(name='printableString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _printableString_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    printableString._val = dict([('ldapDesc', 'Printable String'), ('Type', _printableString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44))])
    
    #-----< subtreeSpec >-----#
    subtreeSpec = CLASS(name='subtreeSpec', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _subtreeSpec_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subtreeSpec._val = dict([('ldapDesc', 'SubtreeSpecification'), ('Type', _subtreeSpec_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45))])
    
    #-----< telephoneNr >-----#
    telephoneNr = CLASS(name='telephoneNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _telephoneNr_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNr._val = dict([('ldapDesc', 'Telephone Number'), ('Type', _telephoneNr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50))])
    
    #-----< telexNr >-----#
    telexNr = CLASS(name='telexNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _telexNr_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    telexNr._val = dict([('ldapDesc', 'Telex Number'), ('Type', _telexNr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52))])
    
    #-----< utcTime >-----#
    utcTime = CLASS(name='utcTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _utcTime_val_Type = TIME_UTC(name='Type', mode=MODE_TYPE)
    utcTime._val = dict([('ldapDesc', 'UTC Time'), ('Type', _utcTime_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 53))])
    
    #-----< ldapSyntaxDescription >-----#
    ldapSyntaxDescription = CLASS(name='ldapSyntaxDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _ldapSyntaxDescription_val_Type = NULL(name='Type', mode=MODE_TYPE)
    ldapSyntaxDescription._val = dict([('ldapDesc', 'LDAP Syntax Description'), ('Type', _ldapSyntaxDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54))])
    
    #-----< substringAssertion >-----#
    substringAssertion = CLASS(name='substringAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _substringAssertion_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    substringAssertion._val = dict([('ldapDesc', 'Substring Assertion'), ('Type', _substringAssertion_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58))])
    
    #-----< languageContext >-----#
    languageContext = CLASS(name='languageContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _languageContext_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'LanguageContextSyntax')))
    languageContext._val = dict([('Type', _languageContext_val_Type), ('id', (2, 5, 31, 0))])
    
    #-----< LanguageContextSyntax >-----#
    LanguageContextSyntax = STR_PRINT(name='LanguageContextSyntax', mode=MODE_TYPE)
    LanguageContextSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< temporalContext >-----#
    temporalContext = CLASS(name='temporalContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _temporalContext_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    _temporalContext_val_Assertion = CHOICE(name='Assertion', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeAssertion')))
    temporalContext._val = dict([('Type', _temporalContext_val_Type), ('Assertion', _temporalContext_val_Assertion), ('id', (2, 5, 31, 1))])
    
    #-----< TimeSpecification >-----#
    TimeSpecification = SEQ(name='TimeSpecification', mode=MODE_TYPE)
    _TimeSpecification_time = CHOICE(name='time', mode=MODE_TYPE)
    __TimeSpecification_time_absolute = SEQ(name='absolute', mode=MODE_TYPE)
    ___TimeSpecification_time_absolute_startTime = TIME_GEN(name='startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___TimeSpecification_time_absolute_endTime = TIME_GEN(name='endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TimeSpecification_time_absolute._cont = ASN1Dict([
        ('startTime', ___TimeSpecification_time_absolute_startTime),
        ('endTime', ___TimeSpecification_time_absolute_endTime),
        ])
    __TimeSpecification_time_absolute._ext = []
    __TimeSpecification_time_periodic = SET_OF(name='periodic', mode=MODE_TYPE)
    ___TimeSpecification_time_periodic__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Period')))
    __TimeSpecification_time_periodic._cont = ___TimeSpecification_time_periodic__item_
    __TimeSpecification_time_periodic._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TimeSpecification_time._cont = ASN1Dict([
        ('absolute', __TimeSpecification_time_absolute),
        ('periodic', __TimeSpecification_time_periodic),
        ])
    _TimeSpecification_time._ext = None
    _TimeSpecification_notThisTime = BOOL(name='notThisTime', mode=MODE_TYPE, default=False)
    _TimeSpecification_timeZone = INT(name='timeZone', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeZone')), opt=True)
    TimeSpecification._cont = ASN1Dict([
        ('time', _TimeSpecification_time),
        ('notThisTime', _TimeSpecification_notThisTime),
        ('timeZone', _TimeSpecification_timeZone),
        ])
    TimeSpecification._ext = []
    
    #-----< Period >-----#
    Period = SEQ(name='Period', mode=MODE_TYPE)
    _Period_timesOfDay = SET_OF(name='timesOfDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_timesOfDay__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTimeBand')))
    _Period_timesOfDay._cont = __Period_timesOfDay__item_
    _Period_timesOfDay._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Period_days = CHOICE(name='days', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_days_intDay = SET_OF(name='intDay', mode=MODE_TYPE)
    ___Period_days_intDay__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_days_intDay._cont = ___Period_days_intDay__item_
    __Period_days_bitDay = BIT_STR(name='bitDay', mode=MODE_TYPE)
    __Period_days_bitDay._cont = ASN1Dict([('sunday', 0), ('monday', 1), ('tuesday', 2), ('wednesday', 3), ('thursday', 4), ('friday', 5), ('saturday', 6)])
    __Period_days_dayOf = CHOICE(name='dayOf', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'XDayOf')))
    _Period_days._cont = ASN1Dict([
        ('intDay', __Period_days_intDay),
        ('bitDay', __Period_days_bitDay),
        ('dayOf', __Period_days_dayOf),
        ])
    _Period_days._ext = []
    _Period_weeks = CHOICE(name='weeks', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_weeks_allWeeks = NULL(name='allWeeks', mode=MODE_TYPE)
    __Period_weeks_intWeek = SET_OF(name='intWeek', mode=MODE_TYPE)
    ___Period_weeks_intWeek__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_weeks_intWeek._cont = ___Period_weeks_intWeek__item_
    __Period_weeks_bitWeek = BIT_STR(name='bitWeek', mode=MODE_TYPE)
    __Period_weeks_bitWeek._cont = ASN1Dict([('week1', 0), ('week2', 1), ('week3', 2), ('week4', 3), ('week5', 4)])
    _Period_weeks._cont = ASN1Dict([
        ('allWeeks', __Period_weeks_allWeeks),
        ('intWeek', __Period_weeks_intWeek),
        ('bitWeek', __Period_weeks_bitWeek),
        ])
    _Period_weeks._ext = []
    _Period_months = CHOICE(name='months', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_months_allMonths = NULL(name='allMonths', mode=MODE_TYPE)
    __Period_months_intMonth = SET_OF(name='intMonth', mode=MODE_TYPE)
    ___Period_months_intMonth__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_months_intMonth._cont = ___Period_months_intMonth__item_
    __Period_months_bitMonth = BIT_STR(name='bitMonth', mode=MODE_TYPE)
    __Period_months_bitMonth._cont = ASN1Dict([('january', 0), ('february', 1), ('march', 2), ('april', 3), ('may', 4), ('june', 5), ('july', 6), ('august', 7), ('september', 8), ('october', 9), ('november', 10), ('december', 11)])
    _Period_months._cont = ASN1Dict([
        ('allMonths', __Period_months_allMonths),
        ('intMonth', __Period_months_intMonth),
        ('bitMonth', __Period_months_bitMonth),
        ])
    _Period_months._ext = []
    _Period_years = SET_OF(name='years', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_years__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_years__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1000, ub=None)], ev=None, er=[])
    _Period_years._cont = __Period_years__item_
    Period._cont = ASN1Dict([
        ('timesOfDay', _Period_timesOfDay),
        ('days', _Period_days),
        ('weeks', _Period_weeks),
        ('months', _Period_months),
        ('years', _Period_years),
        ])
    Period._ext = []
    
    #-----< XDayOf >-----#
    XDayOf = CHOICE(name='XDayOf', mode=MODE_TYPE)
    _XDayOf_first = CHOICE(name='first', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_second = CHOICE(name='second', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_third = CHOICE(name='third', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_fourth = CHOICE(name='fourth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_fifth = CHOICE(name='fifth', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    XDayOf._cont = ASN1Dict([
        ('first', _XDayOf_first),
        ('second', _XDayOf_second),
        ('third', _XDayOf_third),
        ('fourth', _XDayOf_fourth),
        ('fifth', _XDayOf_fifth),
        ])
    XDayOf._ext = None
    
    #-----< NamedDay >-----#
    NamedDay = CHOICE(name='NamedDay', mode=MODE_TYPE)
    _NamedDay_intNamedDays = ENUM(name='intNamedDays', mode=MODE_TYPE)
    _NamedDay_intNamedDays._cont = ASN1Dict([('sunday', 1), ('monday', 2), ('tuesday', 3), ('wednesday', 4), ('thursday', 5), ('friday', 6), ('saturday', 7)])
    _NamedDay_intNamedDays._ext = None
    _NamedDay_bitNamedDays = BIT_STR(name='bitNamedDays', mode=MODE_TYPE)
    _NamedDay_bitNamedDays._cont = ASN1Dict([('sunday', 0), ('monday', 1), ('tuesday', 2), ('wednesday', 3), ('thursday', 4), ('friday', 5), ('saturday', 6)])
    NamedDay._cont = ASN1Dict([
        ('intNamedDays', _NamedDay_intNamedDays),
        ('bitNamedDays', _NamedDay_bitNamedDays),
        ])
    NamedDay._ext = None
    
    #-----< DayTimeBand >-----#
    DayTimeBand = SEQ(name='DayTimeBand', mode=MODE_TYPE)
    _DayTimeBand_startDayTime = SEQ(name='startDayTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTime')), default=dict([('hour', 0)]))
    _DayTimeBand_endDayTime = SEQ(name='endDayTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTime')), default=dict([('hour', 23), ('minute', 59), ('second', 59)]))
    DayTimeBand._cont = ASN1Dict([
        ('startDayTime', _DayTimeBand_startDayTime),
        ('endDayTime', _DayTimeBand_endDayTime),
        ])
    DayTimeBand._ext = []
    
    #-----< DayTime >-----#
    DayTime = SEQ(name='DayTime', mode=MODE_TYPE)
    _DayTime_hour = INT(name='hour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _DayTime_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    _DayTime_minute = INT(name='minute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _DayTime_minute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    _DayTime_second = INT(name='second', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _DayTime_second._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    DayTime._cont = ASN1Dict([
        ('hour', _DayTime_hour),
        ('minute', _DayTime_minute),
        ('second', _DayTime_second),
        ])
    DayTime._ext = []
    
    #-----< TimeZone >-----#
    TimeZone = INT(name='TimeZone', mode=MODE_TYPE)
    TimeZone._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-12, ub=12)], ev=None, er=[])
    
    #-----< TimeAssertion >-----#
    TimeAssertion = CHOICE(name='TimeAssertion', mode=MODE_TYPE)
    _TimeAssertion_now = NULL(name='now', mode=MODE_TYPE)
    _TimeAssertion_at = TIME_GEN(name='at', mode=MODE_TYPE)
    _TimeAssertion_between = SEQ(name='between', mode=MODE_TYPE)
    __TimeAssertion_between_startTime = TIME_GEN(name='startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __TimeAssertion_between_endTime = TIME_GEN(name='endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TimeAssertion_between_entirely = BOOL(name='entirely', mode=MODE_TYPE, default=False)
    _TimeAssertion_between._cont = ASN1Dict([
        ('startTime', __TimeAssertion_between_startTime),
        ('endTime', __TimeAssertion_between_endTime),
        ('entirely', __TimeAssertion_between_entirely),
        ])
    _TimeAssertion_between._ext = []
    TimeAssertion._cont = ASN1Dict([
        ('now', _TimeAssertion_now),
        ('at', _TimeAssertion_at),
        ('between', _TimeAssertion_between),
        ])
    TimeAssertion._ext = []
    
    #-----< localeContext >-----#
    localeContext = CLASS(name='localeContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _localeContext_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'LocaleContextSyntax')))
    localeContext._val = dict([('Type', _localeContext_val_Type), ('id', (2, 5, 31, 2))])
    
    #-----< LocaleContextSyntax >-----#
    LocaleContextSyntax = CHOICE(name='LocaleContextSyntax', mode=MODE_TYPE)
    _LocaleContextSyntax_localeID1 = OID(name='localeID1', mode=MODE_TYPE)
    _LocaleContextSyntax_localeID2 = CHOICE(name='localeID2', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    LocaleContextSyntax._cont = ASN1Dict([
        ('localeID1', _LocaleContextSyntax_localeID1),
        ('localeID2', _LocaleContextSyntax_localeID2),
        ])
    LocaleContextSyntax._ext = []
    
    #-----< ldapAttributeOptionContext >-----#
    ldapAttributeOptionContext = CLASS(name='ldapAttributeOptionContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _ldapAttributeOptionContext_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'AttributeOptionList')))
    _ldapAttributeOptionContext_val_Assertion = SEQ_OF(name='Assertion', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'AttributeOptionList')))
    ldapAttributeOptionContext._val = dict([('Type', _ldapAttributeOptionContext_val_Type), ('Assertion', _ldapAttributeOptionContext_val_Assertion), ('absentMatch', False), ('id', (2, 5, 31, 5))])
    
    #-----< AttributeOptionList >-----#
    AttributeOptionList = SEQ_OF(name='AttributeOptionList', mode=MODE_TYPE)
    _AttributeOptionList__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    AttributeOptionList._cont = _AttributeOptionList__item_
    
    #-----< id-at-knowledgeInformation >-----#
    id_at_knowledgeInformation = OID(name='id-at-knowledgeInformation', mode=MODE_VALUE)
    id_at_knowledgeInformation._val = (2, 5, 4, 2)
    
    #-----< id-at-commonName >-----#
    id_at_commonName = OID(name='id-at-commonName', mode=MODE_VALUE)
    id_at_commonName._val = (2, 5, 4, 3)
    
    #-----< id-at-surname >-----#
    id_at_surname = OID(name='id-at-surname', mode=MODE_VALUE)
    id_at_surname._val = (2, 5, 4, 4)
    
    #-----< id-at-serialNumber >-----#
    id_at_serialNumber = OID(name='id-at-serialNumber', mode=MODE_VALUE)
    id_at_serialNumber._val = (2, 5, 4, 5)
    
    #-----< id-at-countryName >-----#
    id_at_countryName = OID(name='id-at-countryName', mode=MODE_VALUE)
    id_at_countryName._val = (2, 5, 4, 6)
    
    #-----< id-at-localityName >-----#
    id_at_localityName = OID(name='id-at-localityName', mode=MODE_VALUE)
    id_at_localityName._val = (2, 5, 4, 7)
    
    #-----< id-at-collectiveLocalityName >-----#
    id_at_collectiveLocalityName = OID(name='id-at-collectiveLocalityName', mode=MODE_VALUE)
    id_at_collectiveLocalityName._val = (2, 5, 4, 7, 1)
    
    #-----< id-at-stateOrProvinceName >-----#
    id_at_stateOrProvinceName = OID(name='id-at-stateOrProvinceName', mode=MODE_VALUE)
    id_at_stateOrProvinceName._val = (2, 5, 4, 8)
    
    #-----< id-at-collectiveStateOrProvinceName >-----#
    id_at_collectiveStateOrProvinceName = OID(name='id-at-collectiveStateOrProvinceName', mode=MODE_VALUE)
    id_at_collectiveStateOrProvinceName._val = (2, 5, 4, 8, 1)
    
    #-----< id-at-streetAddress >-----#
    id_at_streetAddress = OID(name='id-at-streetAddress', mode=MODE_VALUE)
    id_at_streetAddress._val = (2, 5, 4, 9)
    
    #-----< id-at-collectiveStreetAddress >-----#
    id_at_collectiveStreetAddress = OID(name='id-at-collectiveStreetAddress', mode=MODE_VALUE)
    id_at_collectiveStreetAddress._val = (2, 5, 4, 9, 1)
    
    #-----< id-at-organizationName >-----#
    id_at_organizationName = OID(name='id-at-organizationName', mode=MODE_VALUE)
    id_at_organizationName._val = (2, 5, 4, 10)
    
    #-----< id-at-collectiveOrganizationName >-----#
    id_at_collectiveOrganizationName = OID(name='id-at-collectiveOrganizationName', mode=MODE_VALUE)
    id_at_collectiveOrganizationName._val = (2, 5, 4, 10, 1)
    
    #-----< id-at-organizationalUnitName >-----#
    id_at_organizationalUnitName = OID(name='id-at-organizationalUnitName', mode=MODE_VALUE)
    id_at_organizationalUnitName._val = (2, 5, 4, 11)
    
    #-----< id-at-collectiveOrganizationalUnitName >-----#
    id_at_collectiveOrganizationalUnitName = OID(name='id-at-collectiveOrganizationalUnitName', mode=MODE_VALUE)
    id_at_collectiveOrganizationalUnitName._val = (2, 5, 4, 11, 1)
    
    #-----< id-at-title >-----#
    id_at_title = OID(name='id-at-title', mode=MODE_VALUE)
    id_at_title._val = (2, 5, 4, 12)
    
    #-----< id-at-description >-----#
    id_at_description = OID(name='id-at-description', mode=MODE_VALUE)
    id_at_description._val = (2, 5, 4, 13)
    
    #-----< id-at-searchGuide >-----#
    id_at_searchGuide = OID(name='id-at-searchGuide', mode=MODE_VALUE)
    id_at_searchGuide._val = (2, 5, 4, 14)
    
    #-----< id-at-businessCategory >-----#
    id_at_businessCategory = OID(name='id-at-businessCategory', mode=MODE_VALUE)
    id_at_businessCategory._val = (2, 5, 4, 15)
    
    #-----< id-at-postalAddress >-----#
    id_at_postalAddress = OID(name='id-at-postalAddress', mode=MODE_VALUE)
    id_at_postalAddress._val = (2, 5, 4, 16)
    
    #-----< id-at-collectivePostalAddress >-----#
    id_at_collectivePostalAddress = OID(name='id-at-collectivePostalAddress', mode=MODE_VALUE)
    id_at_collectivePostalAddress._val = (2, 5, 4, 16, 1)
    
    #-----< id-at-postalCode >-----#
    id_at_postalCode = OID(name='id-at-postalCode', mode=MODE_VALUE)
    id_at_postalCode._val = (2, 5, 4, 17)
    
    #-----< id-at-collectivePostalCode >-----#
    id_at_collectivePostalCode = OID(name='id-at-collectivePostalCode', mode=MODE_VALUE)
    id_at_collectivePostalCode._val = (2, 5, 4, 17, 1)
    
    #-----< id-at-postOfficeBox >-----#
    id_at_postOfficeBox = OID(name='id-at-postOfficeBox', mode=MODE_VALUE)
    id_at_postOfficeBox._val = (2, 5, 4, 18)
    
    #-----< id-at-collectivePostOfficeBox >-----#
    id_at_collectivePostOfficeBox = OID(name='id-at-collectivePostOfficeBox', mode=MODE_VALUE)
    id_at_collectivePostOfficeBox._val = (2, 5, 4, 18, 1)
    
    #-----< id-at-physicalDeliveryOfficeName >-----#
    id_at_physicalDeliveryOfficeName = OID(name='id-at-physicalDeliveryOfficeName', mode=MODE_VALUE)
    id_at_physicalDeliveryOfficeName._val = (2, 5, 4, 19)
    
    #-----< id-at-collectivePhysicalDeliveryOfficeName >-----#
    id_at_collectivePhysicalDeliveryOfficeName = OID(name='id-at-collectivePhysicalDeliveryOfficeName', mode=MODE_VALUE)
    id_at_collectivePhysicalDeliveryOfficeName._val = (2, 5, 4, 19, 1)
    
    #-----< id-at-telephoneNumber >-----#
    id_at_telephoneNumber = OID(name='id-at-telephoneNumber', mode=MODE_VALUE)
    id_at_telephoneNumber._val = (2, 5, 4, 20)
    
    #-----< id-at-collectiveTelephoneNumber >-----#
    id_at_collectiveTelephoneNumber = OID(name='id-at-collectiveTelephoneNumber', mode=MODE_VALUE)
    id_at_collectiveTelephoneNumber._val = (2, 5, 4, 20, 1)
    
    #-----< id-at-telexNumber >-----#
    id_at_telexNumber = OID(name='id-at-telexNumber', mode=MODE_VALUE)
    id_at_telexNumber._val = (2, 5, 4, 21)
    
    #-----< id-at-collectiveTelexNumber >-----#
    id_at_collectiveTelexNumber = OID(name='id-at-collectiveTelexNumber', mode=MODE_VALUE)
    id_at_collectiveTelexNumber._val = (2, 5, 4, 21, 1)
    
    #-----< id-at-facsimileTelephoneNumber >-----#
    id_at_facsimileTelephoneNumber = OID(name='id-at-facsimileTelephoneNumber', mode=MODE_VALUE)
    id_at_facsimileTelephoneNumber._val = (2, 5, 4, 23)
    
    #-----< id-at-collectiveFacsimileTelephoneNumber >-----#
    id_at_collectiveFacsimileTelephoneNumber = OID(name='id-at-collectiveFacsimileTelephoneNumber', mode=MODE_VALUE)
    id_at_collectiveFacsimileTelephoneNumber._val = (2, 5, 4, 23, 1)
    
    #-----< id-at-x121Address >-----#
    id_at_x121Address = OID(name='id-at-x121Address', mode=MODE_VALUE)
    id_at_x121Address._val = (2, 5, 4, 24)
    
    #-----< id-at-internationalISDNNumber >-----#
    id_at_internationalISDNNumber = OID(name='id-at-internationalISDNNumber', mode=MODE_VALUE)
    id_at_internationalISDNNumber._val = (2, 5, 4, 25)
    
    #-----< id-at-collectiveInternationalISDNNumber >-----#
    id_at_collectiveInternationalISDNNumber = OID(name='id-at-collectiveInternationalISDNNumber', mode=MODE_VALUE)
    id_at_collectiveInternationalISDNNumber._val = (2, 5, 4, 25, 1)
    
    #-----< id-at-registeredAddress >-----#
    id_at_registeredAddress = OID(name='id-at-registeredAddress', mode=MODE_VALUE)
    id_at_registeredAddress._val = (2, 5, 4, 26)
    
    #-----< id-at-destinationIndicator >-----#
    id_at_destinationIndicator = OID(name='id-at-destinationIndicator', mode=MODE_VALUE)
    id_at_destinationIndicator._val = (2, 5, 4, 27)
    
    #-----< id-at-preferredDeliveryMethod >-----#
    id_at_preferredDeliveryMethod = OID(name='id-at-preferredDeliveryMethod', mode=MODE_VALUE)
    id_at_preferredDeliveryMethod._val = (2, 5, 4, 28)
    
    #-----< id-at-presentationAddress >-----#
    id_at_presentationAddress = OID(name='id-at-presentationAddress', mode=MODE_VALUE)
    id_at_presentationAddress._val = (2, 5, 4, 29)
    
    #-----< id-at-supportedApplicationContext >-----#
    id_at_supportedApplicationContext = OID(name='id-at-supportedApplicationContext', mode=MODE_VALUE)
    id_at_supportedApplicationContext._val = (2, 5, 4, 30)
    
    #-----< id-at-member >-----#
    id_at_member = OID(name='id-at-member', mode=MODE_VALUE)
    id_at_member._val = (2, 5, 4, 31)
    
    #-----< id-at-owner >-----#
    id_at_owner = OID(name='id-at-owner', mode=MODE_VALUE)
    id_at_owner._val = (2, 5, 4, 32)
    
    #-----< id-at-roleOccupant >-----#
    id_at_roleOccupant = OID(name='id-at-roleOccupant', mode=MODE_VALUE)
    id_at_roleOccupant._val = (2, 5, 4, 33)
    
    #-----< id-at-seeAlso >-----#
    id_at_seeAlso = OID(name='id-at-seeAlso', mode=MODE_VALUE)
    id_at_seeAlso._val = (2, 5, 4, 34)
    
    #-----< id-at-name >-----#
    id_at_name = OID(name='id-at-name', mode=MODE_VALUE)
    id_at_name._val = (2, 5, 4, 41)
    
    #-----< id-at-givenName >-----#
    id_at_givenName = OID(name='id-at-givenName', mode=MODE_VALUE)
    id_at_givenName._val = (2, 5, 4, 42)
    
    #-----< id-at-initials >-----#
    id_at_initials = OID(name='id-at-initials', mode=MODE_VALUE)
    id_at_initials._val = (2, 5, 4, 43)
    
    #-----< id-at-generationQualifier >-----#
    id_at_generationQualifier = OID(name='id-at-generationQualifier', mode=MODE_VALUE)
    id_at_generationQualifier._val = (2, 5, 4, 44)
    
    #-----< id-at-uniqueIdentifier >-----#
    id_at_uniqueIdentifier = OID(name='id-at-uniqueIdentifier', mode=MODE_VALUE)
    id_at_uniqueIdentifier._val = (2, 5, 4, 45)
    
    #-----< id-at-dnQualifier >-----#
    id_at_dnQualifier = OID(name='id-at-dnQualifier', mode=MODE_VALUE)
    id_at_dnQualifier._val = (2, 5, 4, 46)
    
    #-----< id-at-enhancedSearchGuide >-----#
    id_at_enhancedSearchGuide = OID(name='id-at-enhancedSearchGuide', mode=MODE_VALUE)
    id_at_enhancedSearchGuide._val = (2, 5, 4, 47)
    
    #-----< id-at-protocolInformation >-----#
    id_at_protocolInformation = OID(name='id-at-protocolInformation', mode=MODE_VALUE)
    id_at_protocolInformation._val = (2, 5, 4, 48)
    
    #-----< id-at-distinguishedName >-----#
    id_at_distinguishedName = OID(name='id-at-distinguishedName', mode=MODE_VALUE)
    id_at_distinguishedName._val = (2, 5, 4, 49)
    
    #-----< id-at-uniqueMember >-----#
    id_at_uniqueMember = OID(name='id-at-uniqueMember', mode=MODE_VALUE)
    id_at_uniqueMember._val = (2, 5, 4, 50)
    
    #-----< id-at-houseIdentifier >-----#
    id_at_houseIdentifier = OID(name='id-at-houseIdentifier', mode=MODE_VALUE)
    id_at_houseIdentifier._val = (2, 5, 4, 51)
    
    #-----< id-at-dmdName >-----#
    id_at_dmdName = OID(name='id-at-dmdName', mode=MODE_VALUE)
    id_at_dmdName._val = (2, 5, 4, 54)
    
    #-----< id-at-pseudonym >-----#
    id_at_pseudonym = OID(name='id-at-pseudonym', mode=MODE_VALUE)
    id_at_pseudonym._val = (2, 5, 4, 65)
    
    #-----< id-at-communicationsService >-----#
    id_at_communicationsService = OID(name='id-at-communicationsService', mode=MODE_VALUE)
    id_at_communicationsService._val = (2, 5, 4, 66)
    
    #-----< id-at-communicationsNetwork >-----#
    id_at_communicationsNetwork = OID(name='id-at-communicationsNetwork', mode=MODE_VALUE)
    id_at_communicationsNetwork._val = (2, 5, 4, 67)
    
    #-----< id-at-uuidpair >-----#
    id_at_uuidpair = OID(name='id-at-uuidpair', mode=MODE_VALUE)
    id_at_uuidpair._val = (2, 5, 4, 77)
    
    #-----< id-at-tagOid >-----#
    id_at_tagOid = OID(name='id-at-tagOid', mode=MODE_VALUE)
    id_at_tagOid._val = (2, 5, 4, 78)
    
    #-----< id-at-uiiFormat >-----#
    id_at_uiiFormat = OID(name='id-at-uiiFormat', mode=MODE_VALUE)
    id_at_uiiFormat._val = (2, 5, 4, 79)
    
    #-----< id-at-uiiInUrn >-----#
    id_at_uiiInUrn = OID(name='id-at-uiiInUrn', mode=MODE_VALUE)
    id_at_uiiInUrn._val = (2, 5, 4, 80)
    
    #-----< id-at-contentUrl >-----#
    id_at_contentUrl = OID(name='id-at-contentUrl', mode=MODE_VALUE)
    id_at_contentUrl._val = (2, 5, 4, 81)
    
    #-----< id-at-uri >-----#
    id_at_uri = OID(name='id-at-uri', mode=MODE_VALUE)
    id_at_uri._val = (2, 5, 4, 83)
    
    #-----< id-at-urn >-----#
    id_at_urn = OID(name='id-at-urn', mode=MODE_VALUE)
    id_at_urn._val = (2, 5, 4, 86)
    
    #-----< id-at-url >-----#
    id_at_url = OID(name='id-at-url', mode=MODE_VALUE)
    id_at_url._val = (2, 5, 4, 87)
    
    #-----< id-at-utmCoordinates >-----#
    id_at_utmCoordinates = OID(name='id-at-utmCoordinates', mode=MODE_VALUE)
    id_at_utmCoordinates._val = (2, 5, 4, 88)
    
    #-----< id-at-urnC >-----#
    id_at_urnC = OID(name='id-at-urnC', mode=MODE_VALUE)
    id_at_urnC._val = (2, 5, 4, 89)
    
    #-----< id-at-uii >-----#
    id_at_uii = OID(name='id-at-uii', mode=MODE_VALUE)
    id_at_uii._val = (2, 5, 4, 90)
    
    #-----< id-at-epc >-----#
    id_at_epc = OID(name='id-at-epc', mode=MODE_VALUE)
    id_at_epc._val = (2, 5, 4, 91)
    
    #-----< id-at-tagAfi >-----#
    id_at_tagAfi = OID(name='id-at-tagAfi', mode=MODE_VALUE)
    id_at_tagAfi._val = (2, 5, 4, 92)
    
    #-----< id-at-epcFormat >-----#
    id_at_epcFormat = OID(name='id-at-epcFormat', mode=MODE_VALUE)
    id_at_epcFormat._val = (2, 5, 4, 93)
    
    #-----< id-at-epcInUrn >-----#
    id_at_epcInUrn = OID(name='id-at-epcInUrn', mode=MODE_VALUE)
    id_at_epcInUrn._val = (2, 5, 4, 94)
    
    #-----< id-at-ldapUrl >-----#
    id_at_ldapUrl = OID(name='id-at-ldapUrl', mode=MODE_VALUE)
    id_at_ldapUrl._val = (2, 5, 4, 95)
    
    #-----< id-at-tagLocation >-----#
    id_at_tagLocation = OID(name='id-at-tagLocation', mode=MODE_VALUE)
    id_at_tagLocation._val = (2, 5, 4, 96)
    
    #-----< id-at-organizationIdentifier >-----#
    id_at_organizationIdentifier = OID(name='id-at-organizationIdentifier', mode=MODE_VALUE)
    id_at_organizationIdentifier._val = (2, 5, 4, 97)
    
    #-----< id-at-countryCode3c >-----#
    id_at_countryCode3c = OID(name='id-at-countryCode3c', mode=MODE_VALUE)
    id_at_countryCode3c._val = (2, 5, 4, 98)
    
    #-----< id-at-countryCode3n >-----#
    id_at_countryCode3n = OID(name='id-at-countryCode3n', mode=MODE_VALUE)
    id_at_countryCode3n._val = (2, 5, 4, 99)
    
    #-----< id-at-dnsName >-----#
    id_at_dnsName = OID(name='id-at-dnsName', mode=MODE_VALUE)
    id_at_dnsName._val = (2, 5, 4, 100)
    
    #-----< id-asx-utmCoords >-----#
    id_asx_utmCoords = OID(name='id-asx-utmCoords', mode=MODE_VALUE)
    id_asx_utmCoords._val = (2, 5, 40, 4)
    
    #-----< id-asx-uiiForm >-----#
    id_asx_uiiForm = OID(name='id-asx-uiiForm', mode=MODE_VALUE)
    id_asx_uiiForm._val = (2, 5, 40, 5)
    
    #-----< id-asx-epcForm >-----#
    id_asx_epcForm = OID(name='id-asx-epcForm', mode=MODE_VALUE)
    id_asx_epcForm._val = (2, 5, 40, 6)
    
    #-----< id-asx-countryString3c >-----#
    id_asx_countryString3c = OID(name='id-asx-countryString3c', mode=MODE_VALUE)
    id_asx_countryString3c._val = (2, 5, 40, 7)
    
    #-----< id-asx-countryString3n >-----#
    id_asx_countryString3n = OID(name='id-asx-countryString3n', mode=MODE_VALUE)
    id_asx_countryString3n._val = (2, 5, 40, 8)
    
    #-----< id-asx-dnsString >-----#
    id_asx_dnsString = OID(name='id-asx-dnsString', mode=MODE_VALUE)
    id_asx_dnsString._val = (2, 5, 40, 9)
    
    #-----< id-lsx-attributeTypeDescription >-----#
    id_lsx_attributeTypeDescription = OID(name='id-lsx-attributeTypeDescription', mode=MODE_VALUE)
    id_lsx_attributeTypeDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)
    
    #-----< id-lsx-bitString >-----#
    id_lsx_bitString = OID(name='id-lsx-bitString', mode=MODE_VALUE)
    id_lsx_bitString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)
    
    #-----< id-lsx-boolean >-----#
    id_lsx_boolean = OID(name='id-lsx-boolean', mode=MODE_VALUE)
    id_lsx_boolean._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)
    
    #-----< id-lsx-countryString >-----#
    id_lsx_countryString = OID(name='id-lsx-countryString', mode=MODE_VALUE)
    id_lsx_countryString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11)
    
    #-----< id-lsx-dn >-----#
    id_lsx_dn = OID(name='id-lsx-dn', mode=MODE_VALUE)
    id_lsx_dn._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)
    
    #-----< id-lsx-deliveryMethod >-----#
    id_lsx_deliveryMethod = OID(name='id-lsx-deliveryMethod', mode=MODE_VALUE)
    id_lsx_deliveryMethod._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14)
    
    #-----< id-lsx-directoryString >-----#
    id_lsx_directoryString = OID(name='id-lsx-directoryString', mode=MODE_VALUE)
    id_lsx_directoryString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)
    
    #-----< id-lsx-dITContentRuleDescription >-----#
    id_lsx_dITContentRuleDescription = OID(name='id-lsx-dITContentRuleDescription', mode=MODE_VALUE)
    id_lsx_dITContentRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)
    
    #-----< id-lsx-dITStructureRuleDescription >-----#
    id_lsx_dITStructureRuleDescription = OID(name='id-lsx-dITStructureRuleDescription', mode=MODE_VALUE)
    id_lsx_dITStructureRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)
    
    #-----< id-lsx-enhancedGuide >-----#
    id_lsx_enhancedGuide = OID(name='id-lsx-enhancedGuide', mode=MODE_VALUE)
    id_lsx_enhancedGuide._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21)
    
    #-----< id-lsx-facsimileTelephoneNr >-----#
    id_lsx_facsimileTelephoneNr = OID(name='id-lsx-facsimileTelephoneNr', mode=MODE_VALUE)
    id_lsx_facsimileTelephoneNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)
    
    #-----< id-lsx-fax >-----#
    id_lsx_fax = OID(name='id-lsx-fax', mode=MODE_VALUE)
    id_lsx_fax._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 23)
    
    #-----< id-lsx-generalizedTime >-----#
    id_lsx_generalizedTime = OID(name='id-lsx-generalizedTime', mode=MODE_VALUE)
    id_lsx_generalizedTime._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)
    
    #-----< id-lsx-guide >-----#
    id_lsx_guide = OID(name='id-lsx-guide', mode=MODE_VALUE)
    id_lsx_guide._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25)
    
    #-----< id-lsx-ia5String >-----#
    id_lsx_ia5String = OID(name='id-lsx-ia5String', mode=MODE_VALUE)
    id_lsx_ia5String._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)
    
    #-----< id-lsx-integer >-----#
    id_lsx_integer = OID(name='id-lsx-integer', mode=MODE_VALUE)
    id_lsx_integer._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)
    
    #-----< id-lsx-jpeg >-----#
    id_lsx_jpeg = OID(name='id-lsx-jpeg', mode=MODE_VALUE)
    id_lsx_jpeg._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 28)
    
    #-----< id-lsx-matchingRuleDescription >-----#
    id_lsx_matchingRuleDescription = OID(name='id-lsx-matchingRuleDescription', mode=MODE_VALUE)
    id_lsx_matchingRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)
    
    #-----< id-lsx-matchingRuleUseDescription >-----#
    id_lsx_matchingRuleUseDescription = OID(name='id-lsx-matchingRuleUseDescription', mode=MODE_VALUE)
    id_lsx_matchingRuleUseDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)
    
    #-----< id-lsx-nameAndOptionalUID >-----#
    id_lsx_nameAndOptionalUID = OID(name='id-lsx-nameAndOptionalUID', mode=MODE_VALUE)
    id_lsx_nameAndOptionalUID._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)
    
    #-----< id-lsx-nameFormDescription >-----#
    id_lsx_nameFormDescription = OID(name='id-lsx-nameFormDescription', mode=MODE_VALUE)
    id_lsx_nameFormDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)
    
    #-----< id-lsx-numericString >-----#
    id_lsx_numericString = OID(name='id-lsx-numericString', mode=MODE_VALUE)
    id_lsx_numericString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)
    
    #-----< id-lsx-objectClassDescription >-----#
    id_lsx_objectClassDescription = OID(name='id-lsx-objectClassDescription', mode=MODE_VALUE)
    id_lsx_objectClassDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)
    
    #-----< id-lsx-oid >-----#
    id_lsx_oid = OID(name='id-lsx-oid', mode=MODE_VALUE)
    id_lsx_oid._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)
    
    #-----< id-lsx-otherMailbox >-----#
    id_lsx_otherMailbox = OID(name='id-lsx-otherMailbox', mode=MODE_VALUE)
    id_lsx_otherMailbox._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 39)
    
    #-----< id-lsx-octetString >-----#
    id_lsx_octetString = OID(name='id-lsx-octetString', mode=MODE_VALUE)
    id_lsx_octetString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)
    
    #-----< id-lsx-postalAddr >-----#
    id_lsx_postalAddr = OID(name='id-lsx-postalAddr', mode=MODE_VALUE)
    id_lsx_postalAddr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)
    
    #-----< id-lsx-presentationAddr >-----#
    id_lsx_presentationAddr = OID(name='id-lsx-presentationAddr', mode=MODE_VALUE)
    id_lsx_presentationAddr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 43)
    
    #-----< id-lsx-printableString >-----#
    id_lsx_printableString = OID(name='id-lsx-printableString', mode=MODE_VALUE)
    id_lsx_printableString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)
    
    #-----< id-lsx-subtreeSpec >-----#
    id_lsx_subtreeSpec = OID(name='id-lsx-subtreeSpec', mode=MODE_VALUE)
    id_lsx_subtreeSpec._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)
    
    #-----< id-lsx-telephoneNr >-----#
    id_lsx_telephoneNr = OID(name='id-lsx-telephoneNr', mode=MODE_VALUE)
    id_lsx_telephoneNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)
    
    #-----< id-lsx-telexNr >-----#
    id_lsx_telexNr = OID(name='id-lsx-telexNr', mode=MODE_VALUE)
    id_lsx_telexNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)
    
    #-----< id-lsx-utcTime >-----#
    id_lsx_utcTime = OID(name='id-lsx-utcTime', mode=MODE_VALUE)
    id_lsx_utcTime._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 53)
    
    #-----< id-lsx-ldapSyntaxDescription >-----#
    id_lsx_ldapSyntaxDescription = OID(name='id-lsx-ldapSyntaxDescription', mode=MODE_VALUE)
    id_lsx_ldapSyntaxDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)
    
    #-----< id-lsx-substringAssertion >-----#
    id_lsx_substringAssertion = OID(name='id-lsx-substringAssertion', mode=MODE_VALUE)
    id_lsx_substringAssertion._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)
    
    #-----< id-oidC1 >-----#
    id_oidC1 = OID(name='id-oidC1', mode=MODE_VALUE)
    id_oidC1._val = (2, 17, 1, 2, 0)
    
    #-----< id-oidC2 >-----#
    id_oidC2 = OID(name='id-oidC2', mode=MODE_VALUE)
    id_oidC2._val = (2, 17, 1, 2, 1)
    
    #-----< id-oidC >-----#
    id_oidC = OID(name='id-oidC', mode=MODE_VALUE)
    id_oidC._val = (2, 17, 1, 2, 2)
    
    #-----< id-cat-sequenceMatchType >-----#
    id_cat_sequenceMatchType = OID(name='id-cat-sequenceMatchType', mode=MODE_VALUE)
    id_cat_sequenceMatchType._val = (2, 5, 37, 1)
    
    #-----< id-cat-wordMatchType >-----#
    id_cat_wordMatchType = OID(name='id-cat-wordMatchType', mode=MODE_VALUE)
    id_cat_wordMatchType._val = (2, 5, 37, 2)
    
    #-----< id-cat-characterMatchTypes >-----#
    id_cat_characterMatchTypes = OID(name='id-cat-characterMatchTypes', mode=MODE_VALUE)
    id_cat_characterMatchTypes._val = (2, 5, 37, 3)
    
    #-----< id-cat-selectedContexts >-----#
    id_cat_selectedContexts = OID(name='id-cat-selectedContexts', mode=MODE_VALUE)
    id_cat_selectedContexts._val = (2, 5, 37, 4)
    
    #-----< id-not-dSAProblem >-----#
    id_not_dSAProblem = OID(name='id-not-dSAProblem', mode=MODE_VALUE)
    id_not_dSAProblem._val = (2, 5, 35, 0)
    
    #-----< id-not-searchServiceProblem >-----#
    id_not_searchServiceProblem = OID(name='id-not-searchServiceProblem', mode=MODE_VALUE)
    id_not_searchServiceProblem._val = (2, 5, 35, 1)
    
    #-----< id-not-serviceType >-----#
    id_not_serviceType = OID(name='id-not-serviceType', mode=MODE_VALUE)
    id_not_serviceType._val = (2, 5, 35, 2)
    
    #-----< id-not-attributeTypeList >-----#
    id_not_attributeTypeList = OID(name='id-not-attributeTypeList', mode=MODE_VALUE)
    id_not_attributeTypeList._val = (2, 5, 35, 3)
    
    #-----< id-not-matchingRuleList >-----#
    id_not_matchingRuleList = OID(name='id-not-matchingRuleList', mode=MODE_VALUE)
    id_not_matchingRuleList._val = (2, 5, 35, 4)
    
    #-----< id-not-filterItem >-----#
    id_not_filterItem = OID(name='id-not-filterItem', mode=MODE_VALUE)
    id_not_filterItem._val = (2, 5, 35, 5)
    
    #-----< id-not-attributeCombinations >-----#
    id_not_attributeCombinations = OID(name='id-not-attributeCombinations', mode=MODE_VALUE)
    id_not_attributeCombinations._val = (2, 5, 35, 6)
    
    #-----< id-not-contextTypeList >-----#
    id_not_contextTypeList = OID(name='id-not-contextTypeList', mode=MODE_VALUE)
    id_not_contextTypeList._val = (2, 5, 35, 7)
    
    #-----< id-not-contextList >-----#
    id_not_contextList = OID(name='id-not-contextList', mode=MODE_VALUE)
    id_not_contextList._val = (2, 5, 35, 8)
    
    #-----< id-not-contextCombinations >-----#
    id_not_contextCombinations = OID(name='id-not-contextCombinations', mode=MODE_VALUE)
    id_not_contextCombinations._val = (2, 5, 35, 9)
    
    #-----< id-not-hierarchySelectList >-----#
    id_not_hierarchySelectList = OID(name='id-not-hierarchySelectList', mode=MODE_VALUE)
    id_not_hierarchySelectList._val = (2, 5, 35, 10)
    
    #-----< id-not-searchControlOptionsList >-----#
    id_not_searchControlOptionsList = OID(name='id-not-searchControlOptionsList', mode=MODE_VALUE)
    id_not_searchControlOptionsList._val = (2, 5, 35, 11)
    
    #-----< id-not-serviceControlOptionsList >-----#
    id_not_serviceControlOptionsList = OID(name='id-not-serviceControlOptionsList', mode=MODE_VALUE)
    id_not_serviceControlOptionsList._val = (2, 5, 35, 12)
    
    #-----< id-not-multipleMatchingLocalities >-----#
    id_not_multipleMatchingLocalities = OID(name='id-not-multipleMatchingLocalities', mode=MODE_VALUE)
    id_not_multipleMatchingLocalities._val = (2, 5, 35, 13)
    
    #-----< id-not-proposedRelaxation >-----#
    id_not_proposedRelaxation = OID(name='id-not-proposedRelaxation', mode=MODE_VALUE)
    id_not_proposedRelaxation._val = (2, 5, 35, 14)
    
    #-----< id-not-appliedRelaxation >-----#
    id_not_appliedRelaxation = OID(name='id-not-appliedRelaxation', mode=MODE_VALUE)
    id_not_appliedRelaxation._val = (2, 5, 35, 15)
    
    #-----< id-not-pwdResponse >-----#
    id_not_pwdResponse = OID(name='id-not-pwdResponse', mode=MODE_VALUE)
    id_not_pwdResponse._val = (2, 5, 35, 16)
    
    #-----< id-not-ldapDiagnosticMsg >-----#
    id_not_ldapDiagnosticMsg = OID(name='id-not-ldapDiagnosticMsg', mode=MODE_VALUE)
    id_not_ldapDiagnosticMsg._val = (2, 5, 35, 17)
    
    #-----< id-pr-targetDsaUnavailable >-----#
    id_pr_targetDsaUnavailable = OID(name='id-pr-targetDsaUnavailable', mode=MODE_VALUE)
    id_pr_targetDsaUnavailable._val = (2, 5, 34, 1)
    
    #-----< id-pr-dataSourceUnavailable >-----#
    id_pr_dataSourceUnavailable = OID(name='id-pr-dataSourceUnavailable', mode=MODE_VALUE)
    id_pr_dataSourceUnavailable._val = (2, 5, 34, 2)
    
    #-----< id-pr-unidentifiedOperation >-----#
    id_pr_unidentifiedOperation = OID(name='id-pr-unidentifiedOperation', mode=MODE_VALUE)
    id_pr_unidentifiedOperation._val = (2, 5, 34, 3)
    
    #-----< id-pr-unavailableOperation >-----#
    id_pr_unavailableOperation = OID(name='id-pr-unavailableOperation', mode=MODE_VALUE)
    id_pr_unavailableOperation._val = (2, 5, 34, 4)
    
    #-----< id-pr-searchAttributeViolation >-----#
    id_pr_searchAttributeViolation = OID(name='id-pr-searchAttributeViolation', mode=MODE_VALUE)
    id_pr_searchAttributeViolation._val = (2, 5, 34, 5)
    
    #-----< id-pr-searchAttributeCombinationViolation >-----#
    id_pr_searchAttributeCombinationViolation = OID(name='id-pr-searchAttributeCombinationViolation', mode=MODE_VALUE)
    id_pr_searchAttributeCombinationViolation._val = (2, 5, 34, 6)
    
    #-----< id-pr-searchValueNotAllowed >-----#
    id_pr_searchValueNotAllowed = OID(name='id-pr-searchValueNotAllowed', mode=MODE_VALUE)
    id_pr_searchValueNotAllowed._val = (2, 5, 34, 7)
    
    #-----< id-pr-missingSearchAttribute >-----#
    id_pr_missingSearchAttribute = OID(name='id-pr-missingSearchAttribute', mode=MODE_VALUE)
    id_pr_missingSearchAttribute._val = (2, 5, 34, 8)
    
    #-----< id-pr-searchValueViolation >-----#
    id_pr_searchValueViolation = OID(name='id-pr-searchValueViolation', mode=MODE_VALUE)
    id_pr_searchValueViolation._val = (2, 5, 34, 9)
    
    #-----< id-pr-attributeNegationViolation >-----#
    id_pr_attributeNegationViolation = OID(name='id-pr-attributeNegationViolation', mode=MODE_VALUE)
    id_pr_attributeNegationViolation._val = (2, 5, 34, 10)
    
    #-----< id-pr-searchValueRequired >-----#
    id_pr_searchValueRequired = OID(name='id-pr-searchValueRequired', mode=MODE_VALUE)
    id_pr_searchValueRequired._val = (2, 5, 34, 11)
    
    #-----< id-pr-invalidSearchValue >-----#
    id_pr_invalidSearchValue = OID(name='id-pr-invalidSearchValue', mode=MODE_VALUE)
    id_pr_invalidSearchValue._val = (2, 5, 34, 12)
    
    #-----< id-pr-searchContextViolation >-----#
    id_pr_searchContextViolation = OID(name='id-pr-searchContextViolation', mode=MODE_VALUE)
    id_pr_searchContextViolation._val = (2, 5, 34, 13)
    
    #-----< id-pr-searchContextCombinationViolation >-----#
    id_pr_searchContextCombinationViolation = OID(name='id-pr-searchContextCombinationViolation', mode=MODE_VALUE)
    id_pr_searchContextCombinationViolation._val = (2, 5, 34, 14)
    
    #-----< id-pr-missingSearchContext >-----#
    id_pr_missingSearchContext = OID(name='id-pr-missingSearchContext', mode=MODE_VALUE)
    id_pr_missingSearchContext._val = (2, 5, 34, 15)
    
    #-----< id-pr-searchContextValueViolation >-----#
    id_pr_searchContextValueViolation = OID(name='id-pr-searchContextValueViolation', mode=MODE_VALUE)
    id_pr_searchContextValueViolation._val = (2, 5, 34, 16)
    
    #-----< id-pr-searchContextValueRequired >-----#
    id_pr_searchContextValueRequired = OID(name='id-pr-searchContextValueRequired', mode=MODE_VALUE)
    id_pr_searchContextValueRequired._val = (2, 5, 34, 17)
    
    #-----< id-pr-invalidContextSearchValue >-----#
    id_pr_invalidContextSearchValue = OID(name='id-pr-invalidContextSearchValue', mode=MODE_VALUE)
    id_pr_invalidContextSearchValue._val = (2, 5, 34, 18)
    
    #-----< id-pr-unsupportedMatchingRule >-----#
    id_pr_unsupportedMatchingRule = OID(name='id-pr-unsupportedMatchingRule', mode=MODE_VALUE)
    id_pr_unsupportedMatchingRule._val = (2, 5, 34, 19)
    
    #-----< id-pr-attributeMatchingViolation >-----#
    id_pr_attributeMatchingViolation = OID(name='id-pr-attributeMatchingViolation', mode=MODE_VALUE)
    id_pr_attributeMatchingViolation._val = (2, 5, 34, 20)
    
    #-----< id-pr-unsupportedMatchingUse >-----#
    id_pr_unsupportedMatchingUse = OID(name='id-pr-unsupportedMatchingUse', mode=MODE_VALUE)
    id_pr_unsupportedMatchingUse._val = (2, 5, 34, 21)
    
    #-----< id-pr-matchingUseViolation >-----#
    id_pr_matchingUseViolation = OID(name='id-pr-matchingUseViolation', mode=MODE_VALUE)
    id_pr_matchingUseViolation._val = (2, 5, 34, 22)
    
    #-----< id-pr-hierarchySelectForbidden >-----#
    id_pr_hierarchySelectForbidden = OID(name='id-pr-hierarchySelectForbidden', mode=MODE_VALUE)
    id_pr_hierarchySelectForbidden._val = (2, 5, 34, 23)
    
    #-----< id-pr-invalidHierarchySelect >-----#
    id_pr_invalidHierarchySelect = OID(name='id-pr-invalidHierarchySelect', mode=MODE_VALUE)
    id_pr_invalidHierarchySelect._val = (2, 5, 34, 24)
    
    #-----< id-pr-unavailableHierarchySelect >-----#
    id_pr_unavailableHierarchySelect = OID(name='id-pr-unavailableHierarchySelect', mode=MODE_VALUE)
    id_pr_unavailableHierarchySelect._val = (2, 5, 34, 25)
    
    #-----< id-pr-invalidSearchControlOptions >-----#
    id_pr_invalidSearchControlOptions = OID(name='id-pr-invalidSearchControlOptions', mode=MODE_VALUE)
    id_pr_invalidSearchControlOptions._val = (2, 5, 34, 26)
    
    #-----< id-pr-invalidServiceControlOptions >-----#
    id_pr_invalidServiceControlOptions = OID(name='id-pr-invalidServiceControlOptions', mode=MODE_VALUE)
    id_pr_invalidServiceControlOptions._val = (2, 5, 34, 27)
    
    #-----< id-pr-searchSubsetViolation >-----#
    id_pr_searchSubsetViolation = OID(name='id-pr-searchSubsetViolation', mode=MODE_VALUE)
    id_pr_searchSubsetViolation._val = (2, 5, 34, 28)
    
    #-----< id-pr-unmatchedKeyAttributes >-----#
    id_pr_unmatchedKeyAttributes = OID(name='id-pr-unmatchedKeyAttributes', mode=MODE_VALUE)
    id_pr_unmatchedKeyAttributes._val = (2, 5, 34, 29)
    
    #-----< id-pr-ambiguousKeyAttributes >-----#
    id_pr_ambiguousKeyAttributes = OID(name='id-pr-ambiguousKeyAttributes', mode=MODE_VALUE)
    id_pr_ambiguousKeyAttributes._val = (2, 5, 34, 30)
    
    #-----< id-pr-unavailableRelaxationLevel >-----#
    id_pr_unavailableRelaxationLevel = OID(name='id-pr-unavailableRelaxationLevel', mode=MODE_VALUE)
    id_pr_unavailableRelaxationLevel._val = (2, 5, 34, 31)
    
    #-----< id-pr-emptyHierarchySelection >-----#
    id_pr_emptyHierarchySelection = OID(name='id-pr-emptyHierarchySelection', mode=MODE_VALUE)
    id_pr_emptyHierarchySelection._val = (2, 5, 34, 32)
    
    #-----< id-pr-administratorImposedLimit >-----#
    id_pr_administratorImposedLimit = OID(name='id-pr-administratorImposedLimit', mode=MODE_VALUE)
    id_pr_administratorImposedLimit._val = (2, 5, 34, 33)
    
    #-----< id-pr-permanentRestriction >-----#
    id_pr_permanentRestriction = OID(name='id-pr-permanentRestriction', mode=MODE_VALUE)
    id_pr_permanentRestriction._val = (2, 5, 34, 34)
    
    #-----< id-pr-temporaryRestriction >-----#
    id_pr_temporaryRestriction = OID(name='id-pr-temporaryRestriction', mode=MODE_VALUE)
    id_pr_temporaryRestriction._val = (2, 5, 34, 35)
    
    #-----< id-pr-relaxationNotSupported >-----#
    id_pr_relaxationNotSupported = OID(name='id-pr-relaxationNotSupported', mode=MODE_VALUE)
    id_pr_relaxationNotSupported._val = (2, 5, 34, 36)
    
    #-----< id-coat-uid >-----#
    id_coat_uid = OID(name='id-coat-uid', mode=MODE_VALUE)
    id_coat_uid._val = (0, 9, 2342, 19200300, 100, 1, 1)
    
    #-----< id-coat-dc >-----#
    id_coat_dc = OID(name='id-coat-dc', mode=MODE_VALUE)
    id_coat_dc._val = (0, 9, 2342, 19200300, 100, 1, 25)
    
    #-----< id-mr-caseIgnoreMatch >-----#
    id_mr_caseIgnoreMatch = OID(name='id-mr-caseIgnoreMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreMatch._val = (2, 5, 13, 2)
    
    #-----< id-mr-caseIgnoreOrderingMatch >-----#
    id_mr_caseIgnoreOrderingMatch = OID(name='id-mr-caseIgnoreOrderingMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreOrderingMatch._val = (2, 5, 13, 3)
    
    #-----< id-mr-caseIgnoreSubstringsMatch >-----#
    id_mr_caseIgnoreSubstringsMatch = OID(name='id-mr-caseIgnoreSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreSubstringsMatch._val = (2, 5, 13, 4)
    
    #-----< id-mr-caseExactMatch >-----#
    id_mr_caseExactMatch = OID(name='id-mr-caseExactMatch', mode=MODE_VALUE)
    id_mr_caseExactMatch._val = (2, 5, 13, 5)
    
    #-----< id-mr-caseExactOrderingMatch >-----#
    id_mr_caseExactOrderingMatch = OID(name='id-mr-caseExactOrderingMatch', mode=MODE_VALUE)
    id_mr_caseExactOrderingMatch._val = (2, 5, 13, 6)
    
    #-----< id-mr-caseExactSubstringsMatch >-----#
    id_mr_caseExactSubstringsMatch = OID(name='id-mr-caseExactSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseExactSubstringsMatch._val = (2, 5, 13, 7)
    
    #-----< id-mr-numericStringMatch >-----#
    id_mr_numericStringMatch = OID(name='id-mr-numericStringMatch', mode=MODE_VALUE)
    id_mr_numericStringMatch._val = (2, 5, 13, 8)
    
    #-----< id-mr-numericStringOrderingMatch >-----#
    id_mr_numericStringOrderingMatch = OID(name='id-mr-numericStringOrderingMatch', mode=MODE_VALUE)
    id_mr_numericStringOrderingMatch._val = (2, 5, 13, 9)
    
    #-----< id-mr-numericStringSubstringsMatch >-----#
    id_mr_numericStringSubstringsMatch = OID(name='id-mr-numericStringSubstringsMatch', mode=MODE_VALUE)
    id_mr_numericStringSubstringsMatch._val = (2, 5, 13, 10)
    
    #-----< id-mr-caseIgnoreListMatch >-----#
    id_mr_caseIgnoreListMatch = OID(name='id-mr-caseIgnoreListMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreListMatch._val = (2, 5, 13, 11)
    
    #-----< id-mr-caseIgnoreListSubstringsMatch >-----#
    id_mr_caseIgnoreListSubstringsMatch = OID(name='id-mr-caseIgnoreListSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreListSubstringsMatch._val = (2, 5, 13, 12)
    
    #-----< id-mr-booleanMatch >-----#
    id_mr_booleanMatch = OID(name='id-mr-booleanMatch', mode=MODE_VALUE)
    id_mr_booleanMatch._val = (2, 5, 13, 13)
    
    #-----< id-mr-integerMatch >-----#
    id_mr_integerMatch = OID(name='id-mr-integerMatch', mode=MODE_VALUE)
    id_mr_integerMatch._val = (2, 5, 13, 14)
    
    #-----< id-mr-integerOrderingMatch >-----#
    id_mr_integerOrderingMatch = OID(name='id-mr-integerOrderingMatch', mode=MODE_VALUE)
    id_mr_integerOrderingMatch._val = (2, 5, 13, 15)
    
    #-----< id-mr-bitStringMatch >-----#
    id_mr_bitStringMatch = OID(name='id-mr-bitStringMatch', mode=MODE_VALUE)
    id_mr_bitStringMatch._val = (2, 5, 13, 16)
    
    #-----< id-mr-octetStringMatch >-----#
    id_mr_octetStringMatch = OID(name='id-mr-octetStringMatch', mode=MODE_VALUE)
    id_mr_octetStringMatch._val = (2, 5, 13, 17)
    
    #-----< id-mr-octetStringOrderingMatch >-----#
    id_mr_octetStringOrderingMatch = OID(name='id-mr-octetStringOrderingMatch', mode=MODE_VALUE)
    id_mr_octetStringOrderingMatch._val = (2, 5, 13, 18)
    
    #-----< id-mr-octetStringSubstringsMatch >-----#
    id_mr_octetStringSubstringsMatch = OID(name='id-mr-octetStringSubstringsMatch', mode=MODE_VALUE)
    id_mr_octetStringSubstringsMatch._val = (2, 5, 13, 19)
    
    #-----< id-mr-telephoneNumberMatch >-----#
    id_mr_telephoneNumberMatch = OID(name='id-mr-telephoneNumberMatch', mode=MODE_VALUE)
    id_mr_telephoneNumberMatch._val = (2, 5, 13, 20)
    
    #-----< id-mr-telephoneNumberSubstringsMatch >-----#
    id_mr_telephoneNumberSubstringsMatch = OID(name='id-mr-telephoneNumberSubstringsMatch', mode=MODE_VALUE)
    id_mr_telephoneNumberSubstringsMatch._val = (2, 5, 13, 21)
    
    #-----< id-mr-presentationAddressMatch >-----#
    id_mr_presentationAddressMatch = OID(name='id-mr-presentationAddressMatch', mode=MODE_VALUE)
    id_mr_presentationAddressMatch._val = (2, 5, 13, 22)
    
    #-----< id-mr-uniqueMemberMatch >-----#
    id_mr_uniqueMemberMatch = OID(name='id-mr-uniqueMemberMatch', mode=MODE_VALUE)
    id_mr_uniqueMemberMatch._val = (2, 5, 13, 23)
    
    #-----< id-mr-protocolInformationMatch >-----#
    id_mr_protocolInformationMatch = OID(name='id-mr-protocolInformationMatch', mode=MODE_VALUE)
    id_mr_protocolInformationMatch._val = (2, 5, 13, 24)
    
    #-----< id-mr-uTCTimeMatch >-----#
    id_mr_uTCTimeMatch = OID(name='id-mr-uTCTimeMatch', mode=MODE_VALUE)
    id_mr_uTCTimeMatch._val = (2, 5, 13, 25)
    
    #-----< id-mr-uTCTimeOrderingMatch >-----#
    id_mr_uTCTimeOrderingMatch = OID(name='id-mr-uTCTimeOrderingMatch', mode=MODE_VALUE)
    id_mr_uTCTimeOrderingMatch._val = (2, 5, 13, 26)
    
    #-----< id-mr-generalizedTimeMatch >-----#
    id_mr_generalizedTimeMatch = OID(name='id-mr-generalizedTimeMatch', mode=MODE_VALUE)
    id_mr_generalizedTimeMatch._val = (2, 5, 13, 27)
    
    #-----< id-mr-generalizedTimeOrderingMatch >-----#
    id_mr_generalizedTimeOrderingMatch = OID(name='id-mr-generalizedTimeOrderingMatch', mode=MODE_VALUE)
    id_mr_generalizedTimeOrderingMatch._val = (2, 5, 13, 28)
    
    #-----< id-mr-integerFirstComponentMatch >-----#
    id_mr_integerFirstComponentMatch = OID(name='id-mr-integerFirstComponentMatch', mode=MODE_VALUE)
    id_mr_integerFirstComponentMatch._val = (2, 5, 13, 29)
    
    #-----< id-mr-objectIdentifierFirstComponentMatch >-----#
    id_mr_objectIdentifierFirstComponentMatch = OID(name='id-mr-objectIdentifierFirstComponentMatch', mode=MODE_VALUE)
    id_mr_objectIdentifierFirstComponentMatch._val = (2, 5, 13, 30)
    
    #-----< id-mr-directoryStringFirstComponentMatch >-----#
    id_mr_directoryStringFirstComponentMatch = OID(name='id-mr-directoryStringFirstComponentMatch', mode=MODE_VALUE)
    id_mr_directoryStringFirstComponentMatch._val = (2, 5, 13, 31)
    
    #-----< id-mr-wordMatch >-----#
    id_mr_wordMatch = OID(name='id-mr-wordMatch', mode=MODE_VALUE)
    id_mr_wordMatch._val = (2, 5, 13, 32)
    
    #-----< id-mr-keywordMatch >-----#
    id_mr_keywordMatch = OID(name='id-mr-keywordMatch', mode=MODE_VALUE)
    id_mr_keywordMatch._val = (2, 5, 13, 33)
    
    #-----< id-mr-storedPrefixMatch >-----#
    id_mr_storedPrefixMatch = OID(name='id-mr-storedPrefixMatch', mode=MODE_VALUE)
    id_mr_storedPrefixMatch._val = (2, 5, 13, 41)
    
    #-----< id-mr-systemProposedMatch >-----#
    id_mr_systemProposedMatch = OID(name='id-mr-systemProposedMatch', mode=MODE_VALUE)
    id_mr_systemProposedMatch._val = (2, 5, 13, 47)
    
    #-----< id-mr-generalWordMatch >-----#
    id_mr_generalWordMatch = OID(name='id-mr-generalWordMatch', mode=MODE_VALUE)
    id_mr_generalWordMatch._val = (2, 5, 13, 48)
    
    #-----< id-mr-approximateStringMatch >-----#
    id_mr_approximateStringMatch = OID(name='id-mr-approximateStringMatch', mode=MODE_VALUE)
    id_mr_approximateStringMatch._val = (2, 5, 13, 49)
    
    #-----< id-mr-ignoreIfAbsentMatch >-----#
    id_mr_ignoreIfAbsentMatch = OID(name='id-mr-ignoreIfAbsentMatch', mode=MODE_VALUE)
    id_mr_ignoreIfAbsentMatch._val = (2, 5, 13, 50)
    
    #-----< id-mr-nullMatch >-----#
    id_mr_nullMatch = OID(name='id-mr-nullMatch', mode=MODE_VALUE)
    id_mr_nullMatch._val = (2, 5, 13, 51)
    
    #-----< id-mr-zonalMatch >-----#
    id_mr_zonalMatch = OID(name='id-mr-zonalMatch', mode=MODE_VALUE)
    id_mr_zonalMatch._val = (2, 5, 13, 52)
    
    #-----< id-mr-facsimileNumberMatch >-----#
    id_mr_facsimileNumberMatch = OID(name='id-mr-facsimileNumberMatch', mode=MODE_VALUE)
    id_mr_facsimileNumberMatch._val = (2, 5, 13, 63)
    
    #-----< id-mr-facsimileNumberSubstringsMatch >-----#
    id_mr_facsimileNumberSubstringsMatch = OID(name='id-mr-facsimileNumberSubstringsMatch', mode=MODE_VALUE)
    id_mr_facsimileNumberSubstringsMatch._val = (2, 5, 13, 64)
    
    #-----< id-mr-uuidpairmatch >-----#
    id_mr_uuidpairmatch = OID(name='id-mr-uuidpairmatch', mode=MODE_VALUE)
    id_mr_uuidpairmatch._val = (2, 5, 13, 68)
    
    #-----< id-mr-uriMatch >-----#
    id_mr_uriMatch = OID(name='id-mr-uriMatch', mode=MODE_VALUE)
    id_mr_uriMatch._val = (2, 5, 13, 70)
    
    #-----< id-mr-dnsNameMatch >-----#
    id_mr_dnsNameMatch = OID(name='id-mr-dnsNameMatch', mode=MODE_VALUE)
    id_mr_dnsNameMatch._val = (2, 5, 13, 74)
    
    #-----< id-lmr-caseExactIA5Match >-----#
    id_lmr_caseExactIA5Match = OID(name='id-lmr-caseExactIA5Match', mode=MODE_VALUE)
    id_lmr_caseExactIA5Match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 1)
    
    #-----< id-lmr-caseIgnoreIA5Match >-----#
    id_lmr_caseIgnoreIA5Match = OID(name='id-lmr-caseIgnoreIA5Match', mode=MODE_VALUE)
    id_lmr_caseIgnoreIA5Match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2)
    
    #-----< id-lmr-caseIgnoreIA5SubstringsMatch >-----#
    id_lmr_caseIgnoreIA5SubstringsMatch = OID(name='id-lmr-caseIgnoreIA5SubstringsMatch', mode=MODE_VALUE)
    id_lmr_caseIgnoreIA5SubstringsMatch._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 3)
    
    #-----< id-avc-language >-----#
    id_avc_language = OID(name='id-avc-language', mode=MODE_VALUE)
    id_avc_language._val = (2, 5, 31, 0)
    
    #-----< id-avc-temporal >-----#
    id_avc_temporal = OID(name='id-avc-temporal', mode=MODE_VALUE)
    id_avc_temporal._val = (2, 5, 31, 1)
    
    #-----< id-avc-locale >-----#
    id_avc_locale = OID(name='id-avc-locale', mode=MODE_VALUE)
    id_avc_locale._val = (2, 5, 31, 2)
    
    #-----< id-avc-ldapAttributeOption >-----#
    id_avc_ldapAttributeOption = OID(name='id-avc-ldapAttributeOption', mode=MODE_VALUE)
    id_avc_ldapAttributeOption._val = (2, 5, 31, 5)
    
    _all_ = [
        _UnboundedDirectoryString_teletexString,
        _UnboundedDirectoryString_printableString,
        _UnboundedDirectoryString_bmpString,
        _UnboundedDirectoryString_universalString,
        _UnboundedDirectoryString_uTF8String,
        UnboundedDirectoryString,
        knowledgeInformation,
        _knowledgeInformation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        name,
        _name_val_Type,
        __ATTRIBUTE_substrings_match_val_AssertionType,
        commonName,
        __ATTRIBUTE_derivation_val_Type,
        _commonName_val_Type,
        surname,
        _surname_val_Type,
        givenName,
        _givenName_val_Type,
        initials,
        _initials_val_Type,
        generationQualifier,
        _generationQualifier_val_Type,
        uniqueIdentifier,
        _uniqueIdentifier_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        UniqueIdentifier,
        dnQualifier,
        _dnQualifier_val_Type,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        serialNumber,
        _serialNumber_val_Type,
        pseudonym,
        _pseudonym_val_Type,
        uUIDPair,
        _uUIDPair_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        _UUIDPair_issuerUUID,
        _UUIDPair_subjectUUID,
        UUIDPair,
        UUID,
        uri,
        _uri_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        URI,
        urn,
        __ATTRIBUTE_derivation_val_Type_0,
        url,
        dnsName,
        _dnsName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        DomainName,
        countryName,
        _countryName_val_Type,
        CountryName,
        countryCode3c,
        _countryCode3c_val_Type,
        CountryCode3c,
        countryCode3n,
        _countryCode3n_val_Type,
        CountryCode3n,
        localityName,
        _localityName_val_Type,
        collectiveLocalityName,
        stateOrProvinceName,
        _stateOrProvinceName_val_Type,
        collectiveStateOrProvinceName,
        streetAddress,
        _streetAddress_val_Type,
        collectiveStreetAddress,
        houseIdentifier,
        _houseIdentifier_val_Type,
        utmCoordinates,
        _utmCoordinates_val_Type,
        _UtmCoordinates_zone,
        _UtmCoordinates_easting,
        _UtmCoordinates_northing,
        UtmCoordinates,
        organizationName,
        _organizationName_val_Type,
        collectiveOrganizationName,
        organizationalUnitName,
        _organizationalUnitName_val_Type,
        collectiveOrganizationalUnitName,
        title,
        _title_val_Type,
        organizationIdentifier,
        _organizationIdentifier_val_Type,
        description,
        _description_val_Type,
        searchGuide,
        _searchGuide_val_Type,
        _Guide_objectClass,
        _Guide_criteria,
        Guide,
        _Criteria_type,
        __Criteria_and___item_,
        _Criteria_and_,
        __Criteria_or___item_,
        _Criteria_or_,
        _Criteria_not_,
        Criteria,
        _CriteriaItem_equality,
        _CriteriaItem_substrings,
        _CriteriaItem_greaterOrEqual,
        _CriteriaItem_lessOrEqual,
        _CriteriaItem_approximateMatch,
        CriteriaItem,
        enhancedSearchGuide,
        _enhancedSearchGuide_val_Type,
        _EnhancedGuide_objectClass,
        _EnhancedGuide_criteria,
        _EnhancedGuide_subset,
        EnhancedGuide,
        businessCategory,
        _businessCategory_val_Type,
        postalAddress,
        _postalAddress_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        _PostalAddress__item_,
        PostalAddress,
        collectivePostalAddress,
        __ATTRIBUTE_derivation_val_Type_1,
        postalCode,
        _postalCode_val_Type,
        collectivePostalCode,
        postOfficeBox,
        _postOfficeBox_val_Type,
        collectivePostOfficeBox,
        physicalDeliveryOfficeName,
        _physicalDeliveryOfficeName_val_Type,
        collectivePhysicalDeliveryOfficeName,
        telephoneNumber,
        _telephoneNumber_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_5,
        TelephoneNumber,
        ub_telephone_number,
        collectiveTelephoneNumber,
        __ATTRIBUTE_derivation_val_Type_2,
        telexNumber,
        _telexNumber_val_Type,
        _TelexNumber_telexNumber,
        _TelexNumber_countryCode,
        _TelexNumber_answerback,
        TelexNumber,
        ub_telex_number,
        ub_country_code,
        ub_answerback,
        collectiveTelexNumber,
        __ATTRIBUTE_derivation_val_Type_3,
        facsimileTelephoneNumber,
        _facsimileTelephoneNumber_val_Type,
        _FacsimileTelephoneNumber_telephoneNumber,
        _FacsimileTelephoneNumber_parameters,
        FacsimileTelephoneNumber,
        collectiveFacsimileTelephoneNumber,
        __ATTRIBUTE_derivation_val_Type_4,
        x121Address,
        _x121Address_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_6,
        X121Address,
        ub_x121_address,
        internationalISDNNumber,
        _internationalISDNNumber_val_Type,
        InternationalISDNNumber,
        ub_international_isdn_number,
        collectiveInternationalISDNNumber,
        __ATTRIBUTE_derivation_val_Type_5,
        registeredAddress,
        _registeredAddress_val_Type,
        destinationIndicator,
        _destinationIndicator_val_Type,
        DestinationIndicator,
        communicationsService,
        _communicationsService_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_7,
        CommunicationsService,
        communicationsNetwork,
        _communicationsNetwork_val_Type,
        CommunicationsNetwork,
        preferredDeliveryMethod,
        _preferredDeliveryMethod_val_Type,
        _PreferredDeliveryMethod__item_,
        PreferredDeliveryMethod,
        presentationAddress,
        _presentationAddress_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_8,
        _PresentationAddress_pSelector,
        _PresentationAddress_sSelector,
        _PresentationAddress_tSelector,
        __PresentationAddress_nAddresses__item_,
        _PresentationAddress_nAddresses,
        PresentationAddress,
        supportedApplicationContext,
        _supportedApplicationContext_val_Type,
        protocolInformation,
        _protocolInformation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_9,
        _ProtocolInformation_nAddress,
        __ProtocolInformation_profiles__item_,
        _ProtocolInformation_profiles,
        ProtocolInformation,
        distinguishedName,
        _distinguishedName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_10,
        member,
        __ATTRIBUTE_derivation_val_Type_6,
        uniqueMember,
        _uniqueMember_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType__11,
        _NameAndOptionalUID_dn,
        _NameAndOptionalUID_uid,
        NameAndOptionalUID,
        owner,
        roleOccupant,
        seeAlso,
        dmdName,
        _dmdName_val_Type,
        oidC1,
        _oidC1_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType___12,
        oidC2,
        _oidC2_val_Type,
        oidC,
        _oidC_val_Type,
        urnC,
        _urnC_val_Type,
        tagOid,
        _tagOid_val_Type,
        uiiFormat,
        _uiiFormat_val_Type,
        _UiiFormat_baseObject,
        _UiiFormat_subset,
        __UiiFormat_next_length,
        __UiiFormat_next_filter,
        _UiiFormat_next,
        UiiFormat,
        _UiiFilter_item,
        __UiiFilter_and___item_,
        _UiiFilter_and_,
        __UiiFilter_or___item_,
        _UiiFilter_or_,
        _UiiFilter_not_,
        UiiFilter,
        _UiiItem_type,
        _UiiItem_length,
        UiiItem,
        uiiInUrn,
        _uiiInUrn_val_Type,
        contentUrl,
        uii,
        _uii_val_Type,
        epc,
        _epc_val_Type,
        tagAfi,
        _tagAfi_val_Type,
        epcFormat,
        _epcFormat_val_Type,
        ___EpcFormat_fields__item__bits,
        ____EpcFormat_fields__item__charField_characters,
        ____EpcFormat_fields__item__charField_maxValue,
        ___EpcFormat_fields__item__charField,
        ___EpcFormat_fields__item__result,
        __EpcFormat_fields__item_,
        _EpcFormat_fields,
        _EpcFormat_digitShift,
        _EpcFormat_checkCalc,
        _EpcFormat_urnPrefix,
        EpcFormat,
        epcInUrn,
        ldapUrl,
        tagLocation,
        __ATTRIBUTE_derivation_val_Type_7,
        dSAProblem,
        _dSAProblem_val_Type,
        searchServiceProblem,
        _searchServiceProblem_val_Type,
        serviceType,
        _serviceType_val_Type,
        attributeTypeList,
        _attributeTypeList_val_Type,
        matchingRuleList,
        _matchingRuleList_val_Type,
        filterItem,
        _filterItem_val_Type,
        attributeCombinations,
        _attributeCombinations_val_Type,
        contextTypeList,
        _contextTypeList_val_Type,
        contextList,
        _contextList_val_Type,
        contextCombinations,
        _contextCombinations_val_Type,
        hierarchySelectList,
        _hierarchySelectList_val_Type,
        searchControlOptionsList,
        _searchControlOptionsList_val_Type,
        serviceControlOptionsList,
        _serviceControlOptionsList_val_Type,
        multipleMatchingLocalities,
        _multipleMatchingLocalities_val_Type,
        _MultipleMatchingLocalities_matchingRuleUsed,
        __MultipleMatchingLocalities_attributeList__item_,
        _MultipleMatchingLocalities_attributeList,
        MultipleMatchingLocalities,
        proposedRelaxation,
        _proposedRelaxation_val_Type,
        _MRMappings__item_,
        MRMappings,
        appliedRelaxation,
        _appliedRelaxation_val_Type,
        pwdResponseValue,
        _pwdResponseValue_val_Type,
        __PwdResponse_warning_timeleft,
        __PwdResponse_warning_graceRemaining,
        _PwdResponse_warning,
        _PwdResponse_error,
        PwdResponse,
        ldapDiagnosticMsg,
        _ldapDiagnosticMsg_val_Type,
        uid,
        _uid_val_Type,
        dc,
        _dc_val_Type,
        caseExactMatch,
        _caseExactMatch_val_AssertionType,
        caseIgnoreMatch,
        _caseIgnoreMatch_val_AssertionType,
        caseExactOrderingMatch,
        _caseExactOrderingMatch_val_AssertionType,
        caseIgnoreOrderingMatch,
        _caseIgnoreOrderingMatch_val_AssertionType,
        caseExactSubstringsMatch,
        _caseExactSubstringsMatch_val_AssertionType,
        caseIgnoreSubstringsMatch,
        _caseIgnoreSubstringsMatch_val_AssertionType,
        __SubstringAssertion__item__initial,
        __SubstringAssertion__item__any,
        __SubstringAssertion__item__final,
        ____SubstringAssertion__item__control_type_tab,
        _____SubstringAssertion__item__control_type_tab_val_Type_0,
        _____SubstringAssertion__item__control_type_tab_val_Type_1,
        ___SubstringAssertion__item__control_type,
        ____SubstringAssertion__item__control_values__item_,
        ___SubstringAssertion__item__control_values,
        _____SubstringAssertion__item__control_valuesWithContext__item__value,
        ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_,
        _____SubstringAssertion__item__control_valuesWithContext__item__contextList,
        ____SubstringAssertion__item__control_valuesWithContext__item_,
        ___SubstringAssertion__item__control_valuesWithContext,
        __SubstringAssertion__item__control,
        _SubstringAssertion__item_,
        SubstringAssertion,
        numericStringMatch,
        _numericStringMatch_val_AssertionType,
        numericStringOrderingMatch,
        _numericStringOrderingMatch_val_AssertionType,
        numericStringSubstringsMatch,
        _numericStringSubstringsMatch_val_AssertionType,
        caseIgnoreListMatch,
        _caseIgnoreListMatch_val_AssertionType,
        _CaseIgnoreList__item_,
        CaseIgnoreList,
        caseIgnoreListSubstringsMatch,
        _caseIgnoreListSubstringsMatch_val_AssertionType,
        storedPrefixMatch,
        _storedPrefixMatch_val_AssertionType,
        booleanMatch,
        _booleanMatch_val_AssertionType,
        integerMatch,
        _integerMatch_val_AssertionType,
        integerOrderingMatch,
        _integerOrderingMatch_val_AssertionType,
        bitStringMatch,
        _bitStringMatch_val_AssertionType,
        octetStringMatch,
        _octetStringMatch_val_AssertionType,
        octetStringOrderingMatch,
        _octetStringOrderingMatch_val_AssertionType,
        octetStringSubstringsMatch,
        _octetStringSubstringsMatch_val_AssertionType,
        __OctetSubstringAssertion__item__initial,
        __OctetSubstringAssertion__item__any,
        __OctetSubstringAssertion__item__final,
        _OctetSubstringAssertion__item_,
        OctetSubstringAssertion,
        telephoneNumberMatch,
        _telephoneNumberMatch_val_AssertionType,
        telephoneNumberSubstringsMatch,
        _telephoneNumberSubstringsMatch_val_AssertionType,
        presentationAddressMatch,
        _presentationAddressMatch_val_AssertionType,
        uniqueMemberMatch,
        _uniqueMemberMatch_val_AssertionType,
        protocolInformationMatch,
        _protocolInformationMatch_val_AssertionType,
        facsimileNumberMatch,
        _facsimileNumberMatch_val_AssertionType,
        facsimileNumberSubstringsMatch,
        _facsimileNumberSubstringsMatch_val_AssertionType,
        uUIDPairMatch,
        _uUIDPairMatch_val_AssertionType,
        uTCTimeMatch,
        _uTCTimeMatch_val_AssertionType,
        uTCTimeOrderingMatch,
        _uTCTimeOrderingMatch_val_AssertionType,
        generalizedTimeMatch,
        _generalizedTimeMatch_val_AssertionType,
        generalizedTimeOrderingMatch,
        _generalizedTimeOrderingMatch_val_AssertionType,
        systemProposedMatch,
        integerFirstComponentMatch,
        _integerFirstComponentMatch_val_AssertionType,
        objectIdentifierFirstComponentMatch,
        _objectIdentifierFirstComponentMatch_val_AssertionType,
        directoryStringFirstComponentMatch,
        _directoryStringFirstComponentMatch_val_AssertionType,
        wordMatch,
        _wordMatch_val_AssertionType,
        keywordMatch,
        _keywordMatch_val_AssertionType,
        generalWordMatch,
        _generalWordMatch_val_AssertionType,
        sequenceMatchType,
        _sequenceMatchType_val_Type,
        SequenceMatchType,
        wordMatchTypes,
        _wordMatchTypes_val_Type,
        WordMatchTypes,
        characterMatchTypes,
        _characterMatchTypes_val_Type,
        CharacterMatchTypes,
        selectedContexts,
        _selectedContexts_val_Type,
        approximateStringMatch,
        ignoreIfAbsentMatch,
        nullMatch,
        _ZONAL_MATCHING_selectBy,
        _ZONAL_MATCHING_ApplicableTo,
        _ZONAL_MATCHING_subtypesIncluded,
        _ZONAL_MATCHING_combinable,
        _ZONAL_MATCHING_mappingResults,
        _ZONAL_MATCHING_userControl,
        _ZONAL_MATCHING_exclusive,
        _ZONAL_MATCHING_matching_rule,
        _ZONAL_MATCHING_id,
        ZONAL_MATCHING,
        _ZonalSelect__item_,
        ZonalSelect,
        ZonalResult,
        zonalMatch,
        __MATCHING_RULE_uniqueMatchIndicator_val_Type,
        uriMatch,
        _uriMatch_val_AssertionType,
        dnsNameMatch,
        _dnsNameMatch_val_AssertionType,
        caseExactIA5Match,
        _caseExactIA5Match_val_AssertionType,
        caseIgnoreIA5Match,
        _caseIgnoreIA5Match_val_AssertionType,
        caseIgnoreIA5SubstringsMatch,
        _caseIgnoreIA5SubstringsMatch_val_AssertionType,
        utmCoords,
        _utmCoords_val_Type,
        uiiForm,
        _uiiForm_val_Type,
        epcForm,
        _epcForm_val_Type,
        countryString3c,
        _countryString3c_val_Type,
        countryString3n,
        _countryString3n_val_Type,
        dnsString,
        _dnsString_val_Type,
        attributeTypeDescription,
        _attributeTypeDescription_val_Type,
        bitString,
        _bitString_val_Type,
        boolean,
        _boolean_val_Type,
        countryString,
        _countryString_val_Type,
        dn,
        _dn_val_Type,
        deliveryMethod,
        _deliveryMethod_val_Type,
        directoryString,
        _directoryString_val_Type,
        dITContentRuleDescription,
        _dITContentRuleDescription_val_Type,
        dITStructureRuleDescription,
        _dITStructureRuleDescription_val_Type,
        enhancedGuide,
        _enhancedGuide_val_Type,
        facsimileTelephoneNr,
        _facsimileTelephoneNr_val_Type,
        fax,
        _fax_val_Type,
        generalizedTime,
        _generalizedTime_val_Type,
        guide,
        _guide_val_Type,
        ia5String,
        _ia5String_val_Type,
        integer,
        _integer_val_Type,
        jpeg,
        _jpeg_val_Type,
        matchingRuleDescription,
        _matchingRuleDescription_val_Type,
        matchingRuleUseDescription,
        _matchingRuleUseDescription_val_Type,
        nameAndOptionalUID,
        _nameAndOptionalUID_val_Type,
        nameFormDescription,
        _nameFormDescription_val_Type,
        numericString,
        _numericString_val_Type,
        objectClassDescription,
        _objectClassDescription_val_Type,
        oid,
        _oid_val_Type,
        otherMailbox,
        _otherMailbox_val_Type,
        octetString,
        _octetString_val_Type,
        postalAddr,
        _postalAddr_val_Type,
        presentationAddr,
        _presentationAddr_val_Type,
        printableString,
        _printableString_val_Type,
        subtreeSpec,
        _subtreeSpec_val_Type,
        telephoneNr,
        _telephoneNr_val_Type,
        telexNr,
        _telexNr_val_Type,
        utcTime,
        _utcTime_val_Type,
        ldapSyntaxDescription,
        _ldapSyntaxDescription_val_Type,
        substringAssertion,
        _substringAssertion_val_Type,
        languageContext,
        _languageContext_val_Type,
        LanguageContextSyntax,
        temporalContext,
        _temporalContext_val_Type,
        _temporalContext_val_Assertion,
        ___TimeSpecification_time_absolute_startTime,
        ___TimeSpecification_time_absolute_endTime,
        __TimeSpecification_time_absolute,
        ___TimeSpecification_time_periodic__item_,
        __TimeSpecification_time_periodic,
        _TimeSpecification_time,
        _TimeSpecification_notThisTime,
        _TimeSpecification_timeZone,
        TimeSpecification,
        __Period_timesOfDay__item_,
        _Period_timesOfDay,
        ___Period_days_intDay__item_,
        __Period_days_intDay,
        __Period_days_bitDay,
        __Period_days_dayOf,
        _Period_days,
        __Period_weeks_allWeeks,
        ___Period_weeks_intWeek__item_,
        __Period_weeks_intWeek,
        __Period_weeks_bitWeek,
        _Period_weeks,
        __Period_months_allMonths,
        ___Period_months_intMonth__item_,
        __Period_months_intMonth,
        __Period_months_bitMonth,
        _Period_months,
        __Period_years__item_,
        _Period_years,
        Period,
        _XDayOf_first,
        _XDayOf_second,
        _XDayOf_third,
        _XDayOf_fourth,
        _XDayOf_fifth,
        XDayOf,
        _NamedDay_intNamedDays,
        _NamedDay_bitNamedDays,
        NamedDay,
        _DayTimeBand_startDayTime,
        _DayTimeBand_endDayTime,
        DayTimeBand,
        _DayTime_hour,
        _DayTime_minute,
        _DayTime_second,
        DayTime,
        TimeZone,
        _TimeAssertion_now,
        _TimeAssertion_at,
        __TimeAssertion_between_startTime,
        __TimeAssertion_between_endTime,
        __TimeAssertion_between_entirely,
        _TimeAssertion_between,
        TimeAssertion,
        localeContext,
        _localeContext_val_Type,
        _LocaleContextSyntax_localeID1,
        _LocaleContextSyntax_localeID2,
        LocaleContextSyntax,
        ldapAttributeOptionContext,
        _ldapAttributeOptionContext_val_Type,
        _ldapAttributeOptionContext_val_Assertion,
        _AttributeOptionList__item_,
        AttributeOptionList,
        id_at_knowledgeInformation,
        id_at_commonName,
        id_at_surname,
        id_at_serialNumber,
        id_at_countryName,
        id_at_localityName,
        id_at_collectiveLocalityName,
        id_at_stateOrProvinceName,
        id_at_collectiveStateOrProvinceName,
        id_at_streetAddress,
        id_at_collectiveStreetAddress,
        id_at_organizationName,
        id_at_collectiveOrganizationName,
        id_at_organizationalUnitName,
        id_at_collectiveOrganizationalUnitName,
        id_at_title,
        id_at_description,
        id_at_searchGuide,
        id_at_businessCategory,
        id_at_postalAddress,
        id_at_collectivePostalAddress,
        id_at_postalCode,
        id_at_collectivePostalCode,
        id_at_postOfficeBox,
        id_at_collectivePostOfficeBox,
        id_at_physicalDeliveryOfficeName,
        id_at_collectivePhysicalDeliveryOfficeName,
        id_at_telephoneNumber,
        id_at_collectiveTelephoneNumber,
        id_at_telexNumber,
        id_at_collectiveTelexNumber,
        id_at_facsimileTelephoneNumber,
        id_at_collectiveFacsimileTelephoneNumber,
        id_at_x121Address,
        id_at_internationalISDNNumber,
        id_at_collectiveInternationalISDNNumber,
        id_at_registeredAddress,
        id_at_destinationIndicator,
        id_at_preferredDeliveryMethod,
        id_at_presentationAddress,
        id_at_supportedApplicationContext,
        id_at_member,
        id_at_owner,
        id_at_roleOccupant,
        id_at_seeAlso,
        id_at_name,
        id_at_givenName,
        id_at_initials,
        id_at_generationQualifier,
        id_at_uniqueIdentifier,
        id_at_dnQualifier,
        id_at_enhancedSearchGuide,
        id_at_protocolInformation,
        id_at_distinguishedName,
        id_at_uniqueMember,
        id_at_houseIdentifier,
        id_at_dmdName,
        id_at_pseudonym,
        id_at_communicationsService,
        id_at_communicationsNetwork,
        id_at_uuidpair,
        id_at_tagOid,
        id_at_uiiFormat,
        id_at_uiiInUrn,
        id_at_contentUrl,
        id_at_uri,
        id_at_urn,
        id_at_url,
        id_at_utmCoordinates,
        id_at_urnC,
        id_at_uii,
        id_at_epc,
        id_at_tagAfi,
        id_at_epcFormat,
        id_at_epcInUrn,
        id_at_ldapUrl,
        id_at_tagLocation,
        id_at_organizationIdentifier,
        id_at_countryCode3c,
        id_at_countryCode3n,
        id_at_dnsName,
        id_asx_utmCoords,
        id_asx_uiiForm,
        id_asx_epcForm,
        id_asx_countryString3c,
        id_asx_countryString3n,
        id_asx_dnsString,
        id_lsx_attributeTypeDescription,
        id_lsx_bitString,
        id_lsx_boolean,
        id_lsx_countryString,
        id_lsx_dn,
        id_lsx_deliveryMethod,
        id_lsx_directoryString,
        id_lsx_dITContentRuleDescription,
        id_lsx_dITStructureRuleDescription,
        id_lsx_enhancedGuide,
        id_lsx_facsimileTelephoneNr,
        id_lsx_fax,
        id_lsx_generalizedTime,
        id_lsx_guide,
        id_lsx_ia5String,
        id_lsx_integer,
        id_lsx_jpeg,
        id_lsx_matchingRuleDescription,
        id_lsx_matchingRuleUseDescription,
        id_lsx_nameAndOptionalUID,
        id_lsx_nameFormDescription,
        id_lsx_numericString,
        id_lsx_objectClassDescription,
        id_lsx_oid,
        id_lsx_otherMailbox,
        id_lsx_octetString,
        id_lsx_postalAddr,
        id_lsx_presentationAddr,
        id_lsx_printableString,
        id_lsx_subtreeSpec,
        id_lsx_telephoneNr,
        id_lsx_telexNr,
        id_lsx_utcTime,
        id_lsx_ldapSyntaxDescription,
        id_lsx_substringAssertion,
        id_oidC1,
        id_oidC2,
        id_oidC,
        id_cat_sequenceMatchType,
        id_cat_wordMatchType,
        id_cat_characterMatchTypes,
        id_cat_selectedContexts,
        id_not_dSAProblem,
        id_not_searchServiceProblem,
        id_not_serviceType,
        id_not_attributeTypeList,
        id_not_matchingRuleList,
        id_not_filterItem,
        id_not_attributeCombinations,
        id_not_contextTypeList,
        id_not_contextList,
        id_not_contextCombinations,
        id_not_hierarchySelectList,
        id_not_searchControlOptionsList,
        id_not_serviceControlOptionsList,
        id_not_multipleMatchingLocalities,
        id_not_proposedRelaxation,
        id_not_appliedRelaxation,
        id_not_pwdResponse,
        id_not_ldapDiagnosticMsg,
        id_pr_targetDsaUnavailable,
        id_pr_dataSourceUnavailable,
        id_pr_unidentifiedOperation,
        id_pr_unavailableOperation,
        id_pr_searchAttributeViolation,
        id_pr_searchAttributeCombinationViolation,
        id_pr_searchValueNotAllowed,
        id_pr_missingSearchAttribute,
        id_pr_searchValueViolation,
        id_pr_attributeNegationViolation,
        id_pr_searchValueRequired,
        id_pr_invalidSearchValue,
        id_pr_searchContextViolation,
        id_pr_searchContextCombinationViolation,
        id_pr_missingSearchContext,
        id_pr_searchContextValueViolation,
        id_pr_searchContextValueRequired,
        id_pr_invalidContextSearchValue,
        id_pr_unsupportedMatchingRule,
        id_pr_attributeMatchingViolation,
        id_pr_unsupportedMatchingUse,
        id_pr_matchingUseViolation,
        id_pr_hierarchySelectForbidden,
        id_pr_invalidHierarchySelect,
        id_pr_unavailableHierarchySelect,
        id_pr_invalidSearchControlOptions,
        id_pr_invalidServiceControlOptions,
        id_pr_searchSubsetViolation,
        id_pr_unmatchedKeyAttributes,
        id_pr_ambiguousKeyAttributes,
        id_pr_unavailableRelaxationLevel,
        id_pr_emptyHierarchySelection,
        id_pr_administratorImposedLimit,
        id_pr_permanentRestriction,
        id_pr_temporaryRestriction,
        id_pr_relaxationNotSupported,
        id_coat_uid,
        id_coat_dc,
        id_mr_caseIgnoreMatch,
        id_mr_caseIgnoreOrderingMatch,
        id_mr_caseIgnoreSubstringsMatch,
        id_mr_caseExactMatch,
        id_mr_caseExactOrderingMatch,
        id_mr_caseExactSubstringsMatch,
        id_mr_numericStringMatch,
        id_mr_numericStringOrderingMatch,
        id_mr_numericStringSubstringsMatch,
        id_mr_caseIgnoreListMatch,
        id_mr_caseIgnoreListSubstringsMatch,
        id_mr_booleanMatch,
        id_mr_integerMatch,
        id_mr_integerOrderingMatch,
        id_mr_bitStringMatch,
        id_mr_octetStringMatch,
        id_mr_octetStringOrderingMatch,
        id_mr_octetStringSubstringsMatch,
        id_mr_telephoneNumberMatch,
        id_mr_telephoneNumberSubstringsMatch,
        id_mr_presentationAddressMatch,
        id_mr_uniqueMemberMatch,
        id_mr_protocolInformationMatch,
        id_mr_uTCTimeMatch,
        id_mr_uTCTimeOrderingMatch,
        id_mr_generalizedTimeMatch,
        id_mr_generalizedTimeOrderingMatch,
        id_mr_integerFirstComponentMatch,
        id_mr_objectIdentifierFirstComponentMatch,
        id_mr_directoryStringFirstComponentMatch,
        id_mr_wordMatch,
        id_mr_keywordMatch,
        id_mr_storedPrefixMatch,
        id_mr_systemProposedMatch,
        id_mr_generalWordMatch,
        id_mr_approximateStringMatch,
        id_mr_ignoreIfAbsentMatch,
        id_mr_nullMatch,
        id_mr_zonalMatch,
        id_mr_facsimileNumberMatch,
        id_mr_facsimileNumberSubstringsMatch,
        id_mr_uuidpairmatch,
        id_mr_uriMatch,
        id_mr_dnsNameMatch,
        id_lmr_caseExactIA5Match,
        id_lmr_caseIgnoreIA5Match,
        id_lmr_caseIgnoreIA5SubstringsMatch,
        id_avc_language,
        id_avc_temporal,
        id_avc_locale,
        id_avc_ldapAttributeOption,
    ]

class ServiceAdministration:

    _name_  = 'ServiceAdministration'
    _oid_   = [2, 5, 1, 33, 8]
    
    _obj_ = [
        'SearchRule',
        'SearchRuleId',
        'AllowedSubset',
        'ImposedSubset',
        'RequestAttribute',
        'ContextProfile',
        'ContextCombination',
        'MatchingUse',
        'SupportedMatchingRestrictions',
        'AttributeCombination',
        'ResultAttribute',
        'ControlOptions',
        'EntryLimit',
        'RelaxationPolicy',
        'MRMapping',
        'Mapping',
        'MRSubstitution',
        'SEARCH-RULE',
        'REQUEST-ATTRIBUTE',
        'RESULT-ATTRIBUTE',
        'MATCHING-RESTRICTION',
        ]
    _type_ = [
        'SearchRule',
        'SearchRuleId',
        'AllowedSubset',
        'ImposedSubset',
        'RequestAttribute',
        'ContextProfile',
        'ContextCombination',
        'MatchingUse',
        'AttributeCombination',
        'ResultAttribute',
        'ControlOptions',
        'EntryLimit',
        'RelaxationPolicy',
        'MRMapping',
        'Mapping',
        'MRSubstitution',
        'SEARCH-RULE',
        'REQUEST-ATTRIBUTE',
        'RESULT-ATTRIBUTE',
        'MATCHING-RESTRICTION',
        ]
    _set_ = [
        'SupportedMatchingRestrictions',
        ]
    _val_ = [
        ]
    _class_ = [
        'SupportedMatchingRestrictions',
        'SEARCH-RULE',
        'REQUEST-ATTRIBUTE',
        'RESULT-ATTRIBUTE',
        'MATCHING-RESTRICTION',
        ]
    _param_ = [
        ]
    
    #-----< SearchRule >-----#
    SearchRule = SEQ(name='SearchRule', mode=MODE_TYPE)
    _SearchRule_id = INT(name='id', mode=MODE_TYPE)
    _SearchRule_dmdId = OID(name='dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _SearchRule_serviceType = OID(name='serviceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRule_userClass = INT(name='userClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRule_inputAttributeTypes = SEQ_OF(name='inputAttributeTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_inputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'RequestAttribute')))
    _SearchRule_inputAttributeTypes._cont = __SearchRule_inputAttributeTypes__item_
    _SearchRule_inputAttributeTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _SearchRule_attributeCombination = CHOICE(name='attributeCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), default=('and', []))
    _SearchRule_outputAttributeTypes = SEQ_OF(name='outputAttributeTypes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_outputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ResultAttribute')))
    _SearchRule_outputAttributeTypes._cont = __SearchRule_outputAttributeTypes__item_
    _SearchRule_outputAttributeTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRule_defaultControls = SEQ(name='defaultControls', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_mandatoryControls = SEQ(name='mandatoryControls', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_searchRuleControls = SEQ(name='searchRuleControls', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SearchRule_familyReturn = SEQ(name='familyReturn', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SearchRule_relaxation = SEQ(name='relaxation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchRule_additionalControl = SEQ_OF(name='additionalControl', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_additionalControl__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SearchRule_additionalControl._cont = __SearchRule_additionalControl__item_
    _SearchRule_additionalControl._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRule_allowedSubset = BIT_STR(name='allowedSubset', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SearchRule_imposedSubset = ENUM(name='imposedSubset', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SearchRule_entryLimit = SEQ(name='entryLimit', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    SearchRule._cont = ASN1Dict([
        ('id', _SearchRule_id),
        ('dmdId', _SearchRule_dmdId),
        ('serviceType', _SearchRule_serviceType),
        ('userClass', _SearchRule_userClass),
        ('inputAttributeTypes', _SearchRule_inputAttributeTypes),
        ('attributeCombination', _SearchRule_attributeCombination),
        ('outputAttributeTypes', _SearchRule_outputAttributeTypes),
        ('defaultControls', _SearchRule_defaultControls),
        ('mandatoryControls', _SearchRule_mandatoryControls),
        ('searchRuleControls', _SearchRule_searchRuleControls),
        ('familyGrouping', _SearchRule_familyGrouping),
        ('familyReturn', _SearchRule_familyReturn),
        ('relaxation', _SearchRule_relaxation),
        ('additionalControl', _SearchRule_additionalControl),
        ('allowedSubset', _SearchRule_allowedSubset),
        ('imposedSubset', _SearchRule_imposedSubset),
        ('entryLimit', _SearchRule_entryLimit),
        ])
    SearchRule._ext = []
    
    #-----< SearchRuleId >-----#
    SearchRuleId = SEQ(name='SearchRuleId', mode=MODE_TYPE)
    _SearchRuleId_id = INT(name='id', mode=MODE_TYPE)
    _SearchRuleId_dmdId = OID(name='dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    SearchRuleId._cont = ASN1Dict([
        ('id', _SearchRuleId_id),
        ('dmdId', _SearchRuleId_dmdId),
        ])
    SearchRuleId._ext = None
    
    #-----< AllowedSubset >-----#
    AllowedSubset = BIT_STR(name='AllowedSubset', mode=MODE_TYPE)
    AllowedSubset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    
    #-----< ImposedSubset >-----#
    ImposedSubset = ENUM(name='ImposedSubset', mode=MODE_TYPE)
    ImposedSubset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    ImposedSubset._ext = []
    
    #-----< RequestAttribute >-----#
    RequestAttribute = SEQ(name='RequestAttribute', mode=MODE_TYPE)
    _RequestAttribute_attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __RequestAttribute_attributeType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___RequestAttribute_attributeType_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ___RequestAttribute_attributeType_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __RequestAttribute_attributeType_tab._val = ASN1Set(rv=[dict([('Type', ___RequestAttribute_attributeType_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___RequestAttribute_attributeType_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _RequestAttribute_attributeType._const_tab = __RequestAttribute_attributeType_tab
    _RequestAttribute_attributeType._const_tab_at = None
    _RequestAttribute_attributeType._const_tab_id = 'id'
    _RequestAttribute_includeSubtypes = BOOL(name='includeSubtypes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RequestAttribute_selectedValues = SEQ_OF(name='selectedValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    __RequestAttribute_selectedValues__item_._const_tab = __RequestAttribute_attributeType_tab
    __RequestAttribute_selectedValues__item_._const_tab_at = ('..', '..', 'attributeType')
    __RequestAttribute_selectedValues__item_._const_tab_id = 'Type'
    _RequestAttribute_selectedValues._cont = __RequestAttribute_selectedValues__item_
    _RequestAttribute_selectedValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_defaultValues = SEQ_OF(name='defaultValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_defaultValues__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___RequestAttribute_defaultValues__item__entryType = OID(name='entryType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), opt=True)
    ___RequestAttribute_defaultValues__item__values = SEQ_OF(name='values', mode=MODE_TYPE)
    ____RequestAttribute_defaultValues__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____RequestAttribute_defaultValues__item__values__item_._const_tab = __RequestAttribute_attributeType_tab
    ____RequestAttribute_defaultValues__item__values__item_._const_tab_at = ('..', '..', '..', '..', 'attributeType')
    ____RequestAttribute_defaultValues__item__values__item_._const_tab_id = 'Type'
    ___RequestAttribute_defaultValues__item__values._cont = ____RequestAttribute_defaultValues__item__values__item_
    __RequestAttribute_defaultValues__item_._cont = ASN1Dict([
        ('entryType', ___RequestAttribute_defaultValues__item__entryType),
        ('values', ___RequestAttribute_defaultValues__item__values),
        ])
    __RequestAttribute_defaultValues__item_._ext = []
    _RequestAttribute_defaultValues._cont = __RequestAttribute_defaultValues__item_
    _RequestAttribute_defaultValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_contexts = SEQ_OF(name='contexts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _RequestAttribute_contexts._cont = __RequestAttribute_contexts__item_
    _RequestAttribute_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_contextCombination = CHOICE(name='contextCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')), default=('and', []))
    _RequestAttribute_matchingUse = SEQ_OF(name='matchingUse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_matchingUse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MatchingUse')))
    _RequestAttribute_matchingUse._cont = __RequestAttribute_matchingUse__item_
    _RequestAttribute_matchingUse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    RequestAttribute._cont = ASN1Dict([
        ('attributeType', _RequestAttribute_attributeType),
        ('includeSubtypes', _RequestAttribute_includeSubtypes),
        ('selectedValues', _RequestAttribute_selectedValues),
        ('defaultValues', _RequestAttribute_defaultValues),
        ('contexts', _RequestAttribute_contexts),
        ('contextCombination', _RequestAttribute_contextCombination),
        ('matchingUse', _RequestAttribute_matchingUse),
        ])
    RequestAttribute._ext = []
    
    #-----< ContextProfile >-----#
    ContextProfile = SEQ(name='ContextProfile', mode=MODE_TYPE)
    _ContextProfile_contextType = OID(name='contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __ContextProfile_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextProfile_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextProfile_contextType._const_tab = __ContextProfile_contextType_tab
    _ContextProfile_contextType._const_tab_at = None
    _ContextProfile_contextType._const_tab_id = 'id'
    _ContextProfile_contextValue = SEQ_OF(name='contextValue', mode=MODE_TYPE, opt=True)
    __ContextProfile_contextValue__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['Assertion']))
    ___ContextProfile_contextValue__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___ContextProfile_contextValue__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ContextProfile_contextValue__item_._const_tab = ___ContextProfile_contextValue__item__tab
    __ContextProfile_contextValue__item_._const_tab_at = ('..', '..', 'contextType')
    __ContextProfile_contextValue__item_._const_tab_id = 'Assertion'
    _ContextProfile_contextValue._cont = __ContextProfile_contextValue__item_
    _ContextProfile_contextValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextProfile._cont = ASN1Dict([
        ('contextType', _ContextProfile_contextType),
        ('contextValue', _ContextProfile_contextValue),
        ])
    ContextProfile._ext = []
    
    #-----< ContextCombination >-----#
    ContextCombination = CHOICE(name='ContextCombination', mode=MODE_TYPE)
    _ContextCombination_context = OID(name='context', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __ContextCombination_context_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextCombination_context_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextCombination_context._const_tab = __ContextCombination_context_tab
    _ContextCombination_context._const_tab_at = None
    _ContextCombination_context._const_tab_id = 'id'
    _ContextCombination_and_ = SEQ_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContextCombination_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    _ContextCombination_and_._cont = __ContextCombination_and___item_
    _ContextCombination_or_ = SEQ_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContextCombination_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    _ContextCombination_or_._cont = __ContextCombination_or___item_
    _ContextCombination_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    ContextCombination._cont = ASN1Dict([
        ('context', _ContextCombination_context),
        ('and', _ContextCombination_and_),
        ('or', _ContextCombination_or_),
        ('not', _ContextCombination_not_),
        ])
    ContextCombination._ext = []
    
    #-----< MatchingUse >-----#
    MatchingUse = SEQ(name='MatchingUse', mode=MODE_TYPE)
    _MatchingUse_restrictionType = OID(name='restrictionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('ServiceAdministration', 'MATCHING-RESTRICTION'), ['id']))
    __MatchingUse_restrictionType_tab = CLASS(name='_tab_MATCHING-RESTRICTION', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    __MatchingUse_restrictionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _MatchingUse_restrictionType._const_tab = __MatchingUse_restrictionType_tab
    _MatchingUse_restrictionType._const_tab_at = None
    _MatchingUse_restrictionType._const_tab_id = 'id'
    _MatchingUse_restrictionValue = OPEN(name='restrictionValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('ServiceAdministration', 'MATCHING-RESTRICTION'), ['Restriction']))
    __MatchingUse_restrictionValue_tab = CLASS(name='_tab_MATCHING-RESTRICTION', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    __MatchingUse_restrictionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _MatchingUse_restrictionValue._const_tab = __MatchingUse_restrictionValue_tab
    _MatchingUse_restrictionValue._const_tab_at = ('..', 'restrictionType')
    _MatchingUse_restrictionValue._const_tab_id = 'Restriction'
    MatchingUse._cont = ASN1Dict([
        ('restrictionType', _MatchingUse_restrictionType),
        ('restrictionValue', _MatchingUse_restrictionValue),
        ])
    MatchingUse._ext = []
    
    #-----< SupportedMatchingRestrictions >-----#
    SupportedMatchingRestrictions = CLASS(name='SupportedMatchingRestrictions', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    SupportedMatchingRestrictions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeCombination >-----#
    AttributeCombination = CHOICE(name='AttributeCombination', mode=MODE_TYPE)
    _AttributeCombination_attribute = OID(name='attribute', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _AttributeCombination_and_ = SEQ_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeCombination_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    _AttributeCombination_and_._cont = __AttributeCombination_and___item_
    _AttributeCombination_or_ = SEQ_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeCombination_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    _AttributeCombination_or_._cont = __AttributeCombination_or___item_
    _AttributeCombination_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    AttributeCombination._cont = ASN1Dict([
        ('attribute', _AttributeCombination_attribute),
        ('and', _AttributeCombination_and_),
        ('or', _AttributeCombination_or_),
        ('not', _AttributeCombination_not_),
        ])
    AttributeCombination._ext = []
    
    #-----< ResultAttribute >-----#
    ResultAttribute = SEQ(name='ResultAttribute', mode=MODE_TYPE)
    _ResultAttribute_attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __ResultAttribute_attributeType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___ResultAttribute_attributeType_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___ResultAttribute_attributeType_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ResultAttribute_attributeType_tab._val = ASN1Set(rv=[dict([('Type', ___ResultAttribute_attributeType_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___ResultAttribute_attributeType_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _ResultAttribute_attributeType._const_tab = __ResultAttribute_attributeType_tab
    _ResultAttribute_attributeType._const_tab_at = None
    _ResultAttribute_attributeType._const_tab_id = 'id'
    _ResultAttribute_outputValues = CHOICE(name='outputValues', mode=MODE_TYPE, opt=True)
    __ResultAttribute_outputValues_selectedValues = SEQ_OF(name='selectedValues', mode=MODE_TYPE)
    ___ResultAttribute_outputValues_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab = __ResultAttribute_attributeType_tab
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab_at = ('..', '..', '..', 'attributeType')
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab_id = 'Type'
    __ResultAttribute_outputValues_selectedValues._cont = ___ResultAttribute_outputValues_selectedValues__item_
    __ResultAttribute_outputValues_matchedValuesOnly = NULL(name='matchedValuesOnly', mode=MODE_TYPE)
    _ResultAttribute_outputValues._cont = ASN1Dict([
        ('selectedValues', __ResultAttribute_outputValues_selectedValues),
        ('matchedValuesOnly', __ResultAttribute_outputValues_matchedValuesOnly),
        ])
    _ResultAttribute_outputValues._ext = None
    _ResultAttribute_contexts = SEQ_OF(name='contexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ResultAttribute_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _ResultAttribute_contexts._cont = __ResultAttribute_contexts__item_
    _ResultAttribute_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ResultAttribute._cont = ASN1Dict([
        ('attributeType', _ResultAttribute_attributeType),
        ('outputValues', _ResultAttribute_outputValues),
        ('contexts', _ResultAttribute_contexts),
        ])
    ResultAttribute._ext = []
    
    #-----< ControlOptions >-----#
    ControlOptions = SEQ(name='ControlOptions', mode=MODE_TYPE)
    _ControlOptions_serviceControls = BIT_STR(name='serviceControls', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')), default=(0, 0))
    _ControlOptions_searchOptions = BIT_STR(name='searchOptions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')), default=(1, 1))
    _ControlOptions_hierarchyOptions = BIT_STR(name='hierarchyOptions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')), opt=True)
    ControlOptions._cont = ASN1Dict([
        ('serviceControls', _ControlOptions_serviceControls),
        ('searchOptions', _ControlOptions_searchOptions),
        ('hierarchyOptions', _ControlOptions_hierarchyOptions),
        ])
    ControlOptions._ext = []
    
    #-----< EntryLimit >-----#
    EntryLimit = SEQ(name='EntryLimit', mode=MODE_TYPE)
    _EntryLimit_default = INT(name='default', mode=MODE_TYPE)
    _EntryLimit_max = INT(name='max', mode=MODE_TYPE)
    EntryLimit._cont = ASN1Dict([
        ('default', _EntryLimit_default),
        ('max', _EntryLimit_max),
        ])
    EntryLimit._ext = []
    
    #-----< RelaxationPolicy >-----#
    RelaxationPolicy = SEQ(name='RelaxationPolicy', mode=MODE_TYPE)
    _RelaxationPolicy_basic = SEQ(name='basic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')), default=dict([]))
    _RelaxationPolicy_tightenings = SEQ_OF(name='tightenings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RelaxationPolicy_tightenings__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    _RelaxationPolicy_tightenings._cont = __RelaxationPolicy_tightenings__item_
    _RelaxationPolicy_tightenings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RelaxationPolicy_relaxations = SEQ_OF(name='relaxations', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RelaxationPolicy_relaxations__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    _RelaxationPolicy_relaxations._cont = __RelaxationPolicy_relaxations__item_
    _RelaxationPolicy_relaxations._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RelaxationPolicy_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RelaxationPolicy_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    RelaxationPolicy._cont = ASN1Dict([
        ('basic', _RelaxationPolicy_basic),
        ('tightenings', _RelaxationPolicy_tightenings),
        ('relaxations', _RelaxationPolicy_relaxations),
        ('maximum', _RelaxationPolicy_maximum),
        ('minimum', _RelaxationPolicy_minimum),
        ])
    RelaxationPolicy._ext = []
    
    #-----< MRMapping >-----#
    MRMapping = SEQ(name='MRMapping', mode=MODE_TYPE)
    _MRMapping_mapping = SEQ_OF(name='mapping', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MRMapping_mapping__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'Mapping')))
    _MRMapping_mapping._cont = __MRMapping_mapping__item_
    _MRMapping_mapping._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MRMapping_substitution = SEQ_OF(name='substitution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MRMapping_substitution__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRSubstitution')))
    _MRMapping_substitution._cont = __MRMapping_substitution__item_
    _MRMapping_substitution._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    MRMapping._cont = ASN1Dict([
        ('mapping', _MRMapping_mapping),
        ('substitution', _MRMapping_substitution),
        ])
    MRMapping._ext = []
    
    #-----< Mapping >-----#
    Mapping = SEQ(name='Mapping', mode=MODE_TYPE)
    _Mapping_mappingFunction = OID(name='mappingFunction', mode=MODE_TYPE)
    _Mapping_level = INT(name='level', mode=MODE_TYPE, default=0)
    Mapping._cont = ASN1Dict([
        ('mappingFunction', _Mapping_mappingFunction),
        ('level', _Mapping_level),
        ])
    Mapping._ext = []
    
    #-----< MRSubstitution >-----#
    MRSubstitution = SEQ(name='MRSubstitution', mode=MODE_TYPE)
    _MRSubstitution_attribute = OID(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _MRSubstitution_oldMatchingRule = OID(name='oldMatchingRule', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _MRSubstitution_newMatchingRule = OID(name='newMatchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    MRSubstitution._cont = ASN1Dict([
        ('attribute', _MRSubstitution_attribute),
        ('oldMatchingRule', _MRSubstitution_oldMatchingRule),
        ('newMatchingRule', _MRSubstitution_newMatchingRule),
        ])
    MRSubstitution._ext = []
    
    #-----< SEARCH-RULE >-----#
    SEARCH_RULE = CLASS(name='SEARCH-RULE', mode=MODE_TYPE)
    _SEARCH_RULE_dmdId = OID(name='dmdId', mode=MODE_VALUE)
    _SEARCH_RULE_serviceType = OID(name='serviceType', mode=MODE_VALUE, opt=True)
    _SEARCH_RULE_userClass = INT(name='userClass', mode=MODE_VALUE, opt=True)
    _SEARCH_RULE_InputAttributeTypes = CLASS(name='InputAttributeTypes', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'REQUEST-ATTRIBUTE')), opt=True)
    _SEARCH_RULE_combination = CHOICE(name='combination', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), opt=True)
    _SEARCH_RULE_OutputAttributeTypes = CLASS(name='OutputAttributeTypes', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'RESULT-ATTRIBUTE')), opt=True)
    _SEARCH_RULE_defaultControls = SEQ(name='defaultControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_mandatoryControls = SEQ(name='mandatoryControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_searchRuleControls = SEQ(name='searchRuleControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_familyGrouping = ENUM(name='familyGrouping', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SEARCH_RULE_familyReturn = SEQ(name='familyReturn', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SEARCH_RULE_additionalControl = OID(name='additionalControl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _SEARCH_RULE_relaxation = SEQ(name='relaxation', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SEARCH_RULE_allowedSubset = BIT_STR(name='allowedSubset', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SEARCH_RULE_imposedSubset = ENUM(name='imposedSubset', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SEARCH_RULE_entryLimit = SEQ(name='entryLimit', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    _SEARCH_RULE_id = INT(name='id', mode=MODE_VALUE, uniq=True)
    SEARCH_RULE._cont = ASN1Dict([
        ('dmdId', _SEARCH_RULE_dmdId),
        ('serviceType', _SEARCH_RULE_serviceType),
        ('userClass', _SEARCH_RULE_userClass),
        ('InputAttributeTypes', _SEARCH_RULE_InputAttributeTypes),
        ('combination', _SEARCH_RULE_combination),
        ('OutputAttributeTypes', _SEARCH_RULE_OutputAttributeTypes),
        ('defaultControls', _SEARCH_RULE_defaultControls),
        ('mandatoryControls', _SEARCH_RULE_mandatoryControls),
        ('searchRuleControls', _SEARCH_RULE_searchRuleControls),
        ('familyGrouping', _SEARCH_RULE_familyGrouping),
        ('familyReturn', _SEARCH_RULE_familyReturn),
        ('additionalControl', _SEARCH_RULE_additionalControl),
        ('relaxation', _SEARCH_RULE_relaxation),
        ('allowedSubset', _SEARCH_RULE_allowedSubset),
        ('imposedSubset', _SEARCH_RULE_imposedSubset),
        ('entryLimit', _SEARCH_RULE_entryLimit),
        ('id', _SEARCH_RULE_id),
        ])
    
    #-----< REQUEST-ATTRIBUTE >-----#
    REQUEST_ATTRIBUTE = CLASS(name='REQUEST-ATTRIBUTE', mode=MODE_TYPE)
    _REQUEST_ATTRIBUTE_attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _REQUEST_ATTRIBUTE_SelectedValues = OPEN(name='SelectedValues', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']), opt=True)
    _REQUEST_ATTRIBUTE_DefaultValues = SEQ(name='DefaultValues', mode=MODE_SET, opt=True)
    __REQUEST_ATTRIBUTE_DefaultValues_entryType = OID(name='entryType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), opt=True)
    __REQUEST_ATTRIBUTE_DefaultValues_values = SEQ_OF(name='values', mode=MODE_TYPE)
    ___REQUEST_ATTRIBUTE_DefaultValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    __REQUEST_ATTRIBUTE_DefaultValues_values._cont = ___REQUEST_ATTRIBUTE_DefaultValues_values__item_
    _REQUEST_ATTRIBUTE_DefaultValues._cont = ASN1Dict([
        ('entryType', __REQUEST_ATTRIBUTE_DefaultValues_entryType),
        ('values', __REQUEST_ATTRIBUTE_DefaultValues_values),
        ])
    _REQUEST_ATTRIBUTE_DefaultValues._ext = None
    _REQUEST_ATTRIBUTE_contexts = SEQ_OF(name='contexts', mode=MODE_VALUE, opt=True)
    __REQUEST_ATTRIBUTE_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _REQUEST_ATTRIBUTE_contexts._cont = __REQUEST_ATTRIBUTE_contexts__item_
    _REQUEST_ATTRIBUTE_contextCombination = CHOICE(name='contextCombination', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')), opt=True)
    _REQUEST_ATTRIBUTE_MatchingUse = SEQ(name='MatchingUse', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MatchingUse')), opt=True)
    _REQUEST_ATTRIBUTE_includeSubtypes = BOOL(name='includeSubtypes', mode=MODE_VALUE, default=False)
    REQUEST_ATTRIBUTE._cont = ASN1Dict([
        ('attributeType', _REQUEST_ATTRIBUTE_attributeType),
        ('SelectedValues', _REQUEST_ATTRIBUTE_SelectedValues),
        ('DefaultValues', _REQUEST_ATTRIBUTE_DefaultValues),
        ('contexts', _REQUEST_ATTRIBUTE_contexts),
        ('contextCombination', _REQUEST_ATTRIBUTE_contextCombination),
        ('MatchingUse', _REQUEST_ATTRIBUTE_MatchingUse),
        ('includeSubtypes', _REQUEST_ATTRIBUTE_includeSubtypes),
        ])
    
    #-----< RESULT-ATTRIBUTE >-----#
    RESULT_ATTRIBUTE = CLASS(name='RESULT-ATTRIBUTE', mode=MODE_TYPE)
    _RESULT_ATTRIBUTE_attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _RESULT_ATTRIBUTE_outputValues = CHOICE(name='outputValues', mode=MODE_VALUE, opt=True)
    __RESULT_ATTRIBUTE_outputValues_selectedValues = SEQ_OF(name='selectedValues', mode=MODE_TYPE)
    ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    __RESULT_ATTRIBUTE_outputValues_selectedValues._cont = ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_
    __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly = NULL(name='matchedValuesOnly', mode=MODE_TYPE)
    _RESULT_ATTRIBUTE_outputValues._cont = ASN1Dict([
        ('selectedValues', __RESULT_ATTRIBUTE_outputValues_selectedValues),
        ('matchedValuesOnly', __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly),
        ])
    _RESULT_ATTRIBUTE_outputValues._ext = None
    _RESULT_ATTRIBUTE_contexts = SEQ(name='contexts', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')), opt=True)
    RESULT_ATTRIBUTE._cont = ASN1Dict([
        ('attributeType', _RESULT_ATTRIBUTE_attributeType),
        ('outputValues', _RESULT_ATTRIBUTE_outputValues),
        ('contexts', _RESULT_ATTRIBUTE_contexts),
        ])
    
    #-----< MATCHING-RESTRICTION >-----#
    MATCHING_RESTRICTION = CLASS(name='MATCHING-RESTRICTION', mode=MODE_TYPE)
    _MATCHING_RESTRICTION_Restriction = OPEN(name='Restriction', mode=MODE_TYPE)
    _MATCHING_RESTRICTION_Rules = OID(name='Rules', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MATCHING_RESTRICTION_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    MATCHING_RESTRICTION._cont = ASN1Dict([
        ('Restriction', _MATCHING_RESTRICTION_Restriction),
        ('Rules', _MATCHING_RESTRICTION_Rules),
        ('id', _MATCHING_RESTRICTION_id),
        ])
    
    _all_ = [
        _SearchRule_id,
        _SearchRule_dmdId,
        _SearchRule_serviceType,
        _SearchRule_userClass,
        __SearchRule_inputAttributeTypes__item_,
        _SearchRule_inputAttributeTypes,
        _SearchRule_attributeCombination,
        __SearchRule_outputAttributeTypes__item_,
        _SearchRule_outputAttributeTypes,
        _SearchRule_defaultControls,
        _SearchRule_mandatoryControls,
        _SearchRule_searchRuleControls,
        _SearchRule_familyGrouping,
        _SearchRule_familyReturn,
        _SearchRule_relaxation,
        __SearchRule_additionalControl__item_,
        _SearchRule_additionalControl,
        _SearchRule_allowedSubset,
        _SearchRule_imposedSubset,
        _SearchRule_entryLimit,
        SearchRule,
        _SearchRuleId_id,
        _SearchRuleId_dmdId,
        SearchRuleId,
        AllowedSubset,
        ImposedSubset,
        __RequestAttribute_attributeType_tab,
        ___RequestAttribute_attributeType_tab_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        ___RequestAttribute_attributeType_tab_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        _RequestAttribute_attributeType,
        _RequestAttribute_includeSubtypes,
        __RequestAttribute_selectedValues__item_,
        _RequestAttribute_selectedValues,
        ___RequestAttribute_defaultValues__item__entryType,
        ____RequestAttribute_defaultValues__item__values__item_,
        ___RequestAttribute_defaultValues__item__values,
        __RequestAttribute_defaultValues__item_,
        _RequestAttribute_defaultValues,
        __RequestAttribute_contexts__item_,
        _RequestAttribute_contexts,
        _RequestAttribute_contextCombination,
        __RequestAttribute_matchingUse__item_,
        _RequestAttribute_matchingUse,
        RequestAttribute,
        __ContextProfile_contextType_tab,
        _ContextProfile_contextType,
        ___ContextProfile_contextValue__item__tab,
        __ContextProfile_contextValue__item_,
        _ContextProfile_contextValue,
        ContextProfile,
        __ContextCombination_context_tab,
        _ContextCombination_context,
        __ContextCombination_and___item_,
        _ContextCombination_and_,
        __ContextCombination_or___item_,
        _ContextCombination_or_,
        _ContextCombination_not_,
        ContextCombination,
        __MatchingUse_restrictionType_tab,
        _MatchingUse_restrictionType,
        __MatchingUse_restrictionValue_tab,
        _MatchingUse_restrictionValue,
        MatchingUse,
        SupportedMatchingRestrictions,
        _AttributeCombination_attribute,
        __AttributeCombination_and___item_,
        _AttributeCombination_and_,
        __AttributeCombination_or___item_,
        _AttributeCombination_or_,
        _AttributeCombination_not_,
        AttributeCombination,
        __ResultAttribute_attributeType_tab,
        ___ResultAttribute_attributeType_tab_val_Type_0,
        ___ResultAttribute_attributeType_tab_val_Type_1,
        _ResultAttribute_attributeType,
        ___ResultAttribute_outputValues_selectedValues__item_,
        __ResultAttribute_outputValues_selectedValues,
        __ResultAttribute_outputValues_matchedValuesOnly,
        _ResultAttribute_outputValues,
        __ResultAttribute_contexts__item_,
        _ResultAttribute_contexts,
        ResultAttribute,
        _ControlOptions_serviceControls,
        _ControlOptions_searchOptions,
        _ControlOptions_hierarchyOptions,
        ControlOptions,
        _EntryLimit_default,
        _EntryLimit_max,
        EntryLimit,
        _RelaxationPolicy_basic,
        __RelaxationPolicy_tightenings__item_,
        _RelaxationPolicy_tightenings,
        __RelaxationPolicy_relaxations__item_,
        _RelaxationPolicy_relaxations,
        _RelaxationPolicy_maximum,
        _RelaxationPolicy_minimum,
        RelaxationPolicy,
        __MRMapping_mapping__item_,
        _MRMapping_mapping,
        __MRMapping_substitution__item_,
        _MRMapping_substitution,
        MRMapping,
        _Mapping_mappingFunction,
        _Mapping_level,
        Mapping,
        _MRSubstitution_attribute,
        _MRSubstitution_oldMatchingRule,
        _MRSubstitution_newMatchingRule,
        MRSubstitution,
        _SEARCH_RULE_dmdId,
        _SEARCH_RULE_serviceType,
        _SEARCH_RULE_userClass,
        _SEARCH_RULE_InputAttributeTypes,
        _SEARCH_RULE_combination,
        _SEARCH_RULE_OutputAttributeTypes,
        _SEARCH_RULE_defaultControls,
        _SEARCH_RULE_mandatoryControls,
        _SEARCH_RULE_searchRuleControls,
        _SEARCH_RULE_familyGrouping,
        _SEARCH_RULE_familyReturn,
        _SEARCH_RULE_additionalControl,
        _SEARCH_RULE_relaxation,
        _SEARCH_RULE_allowedSubset,
        _SEARCH_RULE_imposedSubset,
        _SEARCH_RULE_entryLimit,
        _SEARCH_RULE_id,
        SEARCH_RULE,
        _REQUEST_ATTRIBUTE_attributeType,
        _REQUEST_ATTRIBUTE_SelectedValues,
        __REQUEST_ATTRIBUTE_DefaultValues_entryType,
        ___REQUEST_ATTRIBUTE_DefaultValues_values__item_,
        __REQUEST_ATTRIBUTE_DefaultValues_values,
        _REQUEST_ATTRIBUTE_DefaultValues,
        __REQUEST_ATTRIBUTE_contexts__item_,
        _REQUEST_ATTRIBUTE_contexts,
        _REQUEST_ATTRIBUTE_contextCombination,
        _REQUEST_ATTRIBUTE_MatchingUse,
        _REQUEST_ATTRIBUTE_includeSubtypes,
        REQUEST_ATTRIBUTE,
        _RESULT_ATTRIBUTE_attributeType,
        ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_,
        __RESULT_ATTRIBUTE_outputValues_selectedValues,
        __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly,
        _RESULT_ATTRIBUTE_outputValues,
        _RESULT_ATTRIBUTE_contexts,
        RESULT_ATTRIBUTE,
        _MATCHING_RESTRICTION_Restriction,
        _MATCHING_RESTRICTION_Rules,
        _MATCHING_RESTRICTION_id,
        MATCHING_RESTRICTION,
    ]

class SMSChargingDataTypes:

    _name_  = 'SMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 10, 0, 1]
    
    _obj_ = [
        'SMSRecordType',
        'SCSMORecord',
        'SCSMOT4Record',
        'SCSMTRecord',
        'SCDVTT4Record',
        'ISMSMORecord',
        'ISMSMTRecord',
        'OriginatorInfo',
        'RecipientInfo',
        'SMAddressDomain',
        'SMAddressInfo',
        'SMAddressType',
        'SMDeviceTriggerIndicator',
        'SMDeviceTriggerInformation',
        'SMDTPriorityIndication',
        'SMInterface',
        'SMInterfaceType',
        'SMMessageType',
        'SMServingNode',
        'SMSStatus',
        ]
    _type_ = [
        'SMSRecordType',
        'SCSMORecord',
        'SCSMOT4Record',
        'SCSMTRecord',
        'SCDVTT4Record',
        'ISMSMORecord',
        'ISMSMTRecord',
        'OriginatorInfo',
        'RecipientInfo',
        'SMAddressDomain',
        'SMAddressInfo',
        'SMAddressType',
        'SMDeviceTriggerIndicator',
        'SMDeviceTriggerInformation',
        'SMDTPriorityIndication',
        'SMInterface',
        'SMInterfaceType',
        'SMMessageType',
        'SMServingNode',
        'SMSStatus',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SMSRecordType >-----#
    SMSRecordType = CHOICE(name='SMSRecordType', mode=MODE_TYPE)
    _SMSRecordType_sCSMORecord = SET(name='sCSMORecord', mode=MODE_TYPE, tag=(93, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCSMORecord')))
    _SMSRecordType_sCSMTRecord = SET(name='sCSMTRecord', mode=MODE_TYPE, tag=(94, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCSMTRecord')))
    _SMSRecordType_sCDVTT4Record = SET(name='sCDVTT4Record', mode=MODE_TYPE, tag=(110, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCDVTT4Record')))
    _SMSRecordType_sCSMOT4Record = SET(name='sCSMOT4Record', mode=MODE_TYPE, tag=(111, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCSMTRecord')))
    _SMSRecordType_iSMSMORecord = SET(name='iSMSMORecord', mode=MODE_TYPE, tag=(112, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'ISMSMORecord')))
    _SMSRecordType_iSMSMTRecord = SET(name='iSMSMTRecord', mode=MODE_TYPE, tag=(113, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'ISMSMTRecord')))
    SMSRecordType._cont = ASN1Dict([
        ('sCSMORecord', _SMSRecordType_sCSMORecord),
        ('sCSMTRecord', _SMSRecordType_sCSMTRecord),
        ('sCDVTT4Record', _SMSRecordType_sCDVTT4Record),
        ('sCSMOT4Record', _SMSRecordType_sCSMOT4Record),
        ('iSMSMORecord', _SMSRecordType_iSMSMORecord),
        ('iSMSMTRecord', _SMSRecordType_iSMSMTRecord),
        ])
    SMSRecordType._ext = None
    
    #-----< SCSMORecord >-----#
    SCSMORecord = SET(name='SCSMORecord', mode=MODE_TYPE)
    _SCSMORecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSMORecord_sMSNodeAddress = OCT_STR(name='sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCSMORecord_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCSMORecord_recipientInfo = SEQ_OF(name='recipientInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSMORecord_recipientInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')))
    _SCSMORecord_recipientInfo._cont = __SCSMORecord_recipientInfo__item_
    _SCSMORecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SCSMORecord_eventtimestamp = OCT_STR(name='eventtimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCSMORecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _SCSMORecord_sMTotalNumber = INT(name='sMTotalNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMSequenceNumber = INT(name='sMSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _SCSMORecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _SCSMORecord_sMdeliveryReportRequested = BOOL(name='sMdeliveryReportRequested', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMDataCodingScheme = INT(name='sMDataCodingScheme', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMMessageType = ENUM(name='sMMessageType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _SCSMORecord_sMReplyPathRequested = NULL(name='sMReplyPathRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMUserDataHeader = OCT_STR(name='sMUserDataHeader', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_userLocationInfo = OCT_STR(name='userLocationInfo', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SCSMORecord_uETimeZone = OCT_STR(name='uETimeZone', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSMORecord_sMSResult = CHOICE(name='sMSResult', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCSMORecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSMORecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCSMORecord._cont = ASN1Dict([
        ('recordType', _SCSMORecord_recordType),
        ('sMSNodeAddress', _SCSMORecord_sMSNodeAddress),
        ('originatorInfo', _SCSMORecord_originatorInfo),
        ('recipientInfo', _SCSMORecord_recipientInfo),
        ('servedIMEI', _SCSMORecord_servedIMEI),
        ('eventtimestamp', _SCSMORecord_eventtimestamp),
        ('messageReference', _SCSMORecord_messageReference),
        ('sMTotalNumber', _SCSMORecord_sMTotalNumber),
        ('sMSequenceNumber', _SCSMORecord_sMSequenceNumber),
        ('messageSize', _SCSMORecord_messageSize),
        ('messageClass', _SCSMORecord_messageClass),
        ('sMdeliveryReportRequested', _SCSMORecord_sMdeliveryReportRequested),
        ('sMDataCodingScheme', _SCSMORecord_sMDataCodingScheme),
        ('sMMessageType', _SCSMORecord_sMMessageType),
        ('sMReplyPathRequested', _SCSMORecord_sMReplyPathRequested),
        ('sMUserDataHeader', _SCSMORecord_sMUserDataHeader),
        ('userLocationInfo', _SCSMORecord_userLocationInfo),
        ('rATType', _SCSMORecord_rATType),
        ('uETimeZone', _SCSMORecord_uETimeZone),
        ('sMSResult', _SCSMORecord_sMSResult),
        ('localSequenceNumber', _SCSMORecord_localSequenceNumber),
        ('recordExtensions', _SCSMORecord_recordExtensions),
        ])
    SCSMORecord._ext = None
    
    #-----< SCSMOT4Record >-----#
    SCSMOT4Record = SET(name='SCSMOT4Record', mode=MODE_TYPE)
    _SCSMOT4Record_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSMOT4Record_sMSNodeAddress = OCT_STR(name='sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCSMOT4Record_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCSMOT4Record_recipientInfo = SEQ(name='recipientInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _SCSMOT4Record_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SCSMOT4Record_eventtimestamp = OCT_STR(name='eventtimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCSMOT4Record_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _SCSMOT4Record_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _SCSMOT4Record_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _SCSMOT4Record_sMdeliveryReportRequested = BOOL(name='sMdeliveryReportRequested', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_sMDataCodingScheme = INT(name='sMDataCodingScheme', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_sMMessageType = ENUM(name='sMMessageType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _SCSMOT4Record_sMReplyPathRequested = NULL(name='sMReplyPathRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_sMUserDataHeader = OCT_STR(name='sMUserDataHeader', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_userLocationInfo = OCT_STR(name='userLocationInfo', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SCSMOT4Record_uETimeZone = OCT_STR(name='uETimeZone', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSMOT4Record_sMSResult = CHOICE(name='sMSResult', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCSMOT4Record_mTCIWFAddress = CHOICE(name='mTCIWFAddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SCSMOT4Record_sMSApplicationPortID = INT(name='sMSApplicationPortID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_externalIdentifier = SET(name='externalIdentifier', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _SCSMOT4Record_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSMOT4Record_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCSMOT4Record._cont = ASN1Dict([
        ('recordType', _SCSMOT4Record_recordType),
        ('sMSNodeAddress', _SCSMOT4Record_sMSNodeAddress),
        ('originatorInfo', _SCSMOT4Record_originatorInfo),
        ('recipientInfo', _SCSMOT4Record_recipientInfo),
        ('servedIMEI', _SCSMOT4Record_servedIMEI),
        ('eventtimestamp', _SCSMOT4Record_eventtimestamp),
        ('messageReference', _SCSMOT4Record_messageReference),
        ('messageSize', _SCSMOT4Record_messageSize),
        ('messageClass', _SCSMOT4Record_messageClass),
        ('sMdeliveryReportRequested', _SCSMOT4Record_sMdeliveryReportRequested),
        ('sMDataCodingScheme', _SCSMOT4Record_sMDataCodingScheme),
        ('sMMessageType', _SCSMOT4Record_sMMessageType),
        ('sMReplyPathRequested', _SCSMOT4Record_sMReplyPathRequested),
        ('sMUserDataHeader', _SCSMOT4Record_sMUserDataHeader),
        ('userLocationInfo', _SCSMOT4Record_userLocationInfo),
        ('rATType', _SCSMOT4Record_rATType),
        ('uETimeZone', _SCSMOT4Record_uETimeZone),
        ('sMSResult', _SCSMOT4Record_sMSResult),
        ('mTCIWFAddress', _SCSMOT4Record_mTCIWFAddress),
        ('sMSApplicationPortID', _SCSMOT4Record_sMSApplicationPortID),
        ('externalIdentifier', _SCSMOT4Record_externalIdentifier),
        ('localSequenceNumber', _SCSMOT4Record_localSequenceNumber),
        ('recordExtensions', _SCSMOT4Record_recordExtensions),
        ])
    SCSMOT4Record._ext = None
    
    #-----< SCSMTRecord >-----#
    SCSMTRecord = SET(name='SCSMTRecord', mode=MODE_TYPE)
    _SCSMTRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSMTRecord_sMSNodeAddress = OCT_STR(name='sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCSMTRecord_recipientInfo = SEQ(name='recipientInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _SCSMTRecord_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCSMTRecord_servedIMEI = OCT_STR(name='servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SCSMTRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSMTRecord_eventtimestamp = OCT_STR(name='eventtimestamp', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCSMTRecord_sMPriority = ENUM(name='sMPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _SCSMTRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')), opt=True)
    _SCSMTRecord_sMTotalNumber = INT(name='sMTotalNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMSequenceNumber = INT(name='sMSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _SCSMTRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _SCSMTRecord_sMdeliveryReportRequested = BOOL(name='sMdeliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMDataCodingScheme = INT(name='sMDataCodingScheme', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMMessageType = ENUM(name='sMMessageType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _SCSMTRecord_sMReplyPathRequested = NULL(name='sMReplyPathRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMUserDataHeader = OCT_STR(name='sMUserDataHeader', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMSStatus = OCT_STR(name='sMSStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMSStatus')), opt=True)
    _SCSMTRecord_sMDischargeTime = OCT_STR(name='sMDischargeTime', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSMTRecord_userLocationInfo = OCT_STR(name='userLocationInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SCSMTRecord_uETimeZone = OCT_STR(name='uETimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSMTRecord_sMSResult = CHOICE(name='sMSResult', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCSMTRecord_sMDeviceTriggerInformation = SEQ(name='sMDeviceTriggerInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDeviceTriggerInformation')), opt=True)
    _SCSMTRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSMTRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCSMTRecord._cont = ASN1Dict([
        ('recordType', _SCSMTRecord_recordType),
        ('sMSNodeAddress', _SCSMTRecord_sMSNodeAddress),
        ('recipientInfo', _SCSMTRecord_recipientInfo),
        ('originatorInfo', _SCSMTRecord_originatorInfo),
        ('servedIMEI', _SCSMTRecord_servedIMEI),
        ('submissionTime', _SCSMTRecord_submissionTime),
        ('eventtimestamp', _SCSMTRecord_eventtimestamp),
        ('sMPriority', _SCSMTRecord_sMPriority),
        ('messageReference', _SCSMTRecord_messageReference),
        ('sMTotalNumber', _SCSMTRecord_sMTotalNumber),
        ('sMSequenceNumber', _SCSMTRecord_sMSequenceNumber),
        ('messageSize', _SCSMTRecord_messageSize),
        ('messageClass', _SCSMTRecord_messageClass),
        ('sMdeliveryReportRequested', _SCSMTRecord_sMdeliveryReportRequested),
        ('sMDataCodingScheme', _SCSMTRecord_sMDataCodingScheme),
        ('sMMessageType', _SCSMTRecord_sMMessageType),
        ('sMReplyPathRequested', _SCSMTRecord_sMReplyPathRequested),
        ('sMUserDataHeader', _SCSMTRecord_sMUserDataHeader),
        ('sMSStatus', _SCSMTRecord_sMSStatus),
        ('sMDischargeTime', _SCSMTRecord_sMDischargeTime),
        ('userLocationInfo', _SCSMTRecord_userLocationInfo),
        ('rATType', _SCSMTRecord_rATType),
        ('uETimeZone', _SCSMTRecord_uETimeZone),
        ('sMSResult', _SCSMTRecord_sMSResult),
        ('sMDeviceTriggerInformation', _SCSMTRecord_sMDeviceTriggerInformation),
        ('localSequenceNumber', _SCSMTRecord_localSequenceNumber),
        ('recordExtensions', _SCSMTRecord_recordExtensions),
        ])
    SCSMTRecord._ext = None
    
    #-----< SCDVTT4Record >-----#
    SCDVTT4Record = SET(name='SCDVTT4Record', mode=MODE_TYPE)
    _SCDVTT4Record_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCDVTT4Record_sMSNodeAddress = OCT_STR(name='sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCDVTT4Record_eventtimestamp = OCT_STR(name='eventtimestamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCDVTT4Record_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCDVTT4Record_recipientInfo = SEQ(name='recipientInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _SCDVTT4Record_sMDeviceTriggerIndicator = ENUM(name='sMDeviceTriggerIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDeviceTriggerIndicator')), opt=True)
    _SCDVTT4Record_sMDeviceTriggerInformation = SEQ(name='sMDeviceTriggerInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDeviceTriggerInformation')), opt=True)
    _SCDVTT4Record_sMSResult = CHOICE(name='sMSResult', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCDVTT4Record_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCDVTT4Record_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCDVTT4Record._cont = ASN1Dict([
        ('recordType', _SCDVTT4Record_recordType),
        ('sMSNodeAddress', _SCDVTT4Record_sMSNodeAddress),
        ('eventtimestamp', _SCDVTT4Record_eventtimestamp),
        ('originatorInfo', _SCDVTT4Record_originatorInfo),
        ('recipientInfo', _SCDVTT4Record_recipientInfo),
        ('sMDeviceTriggerIndicator', _SCDVTT4Record_sMDeviceTriggerIndicator),
        ('sMDeviceTriggerInformation', _SCDVTT4Record_sMDeviceTriggerInformation),
        ('sMSResult', _SCDVTT4Record_sMSResult),
        ('localSequenceNumber', _SCDVTT4Record_localSequenceNumber),
        ('recordExtensions', _SCDVTT4Record_recordExtensions),
        ])
    SCDVTT4Record._ext = None
    
    #-----< ISMSMORecord >-----#
    ISMSMORecord = SET(name='ISMSMORecord', mode=MODE_TYPE)
    _ISMSMORecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ISMSMORecord_sMSNodeAddress = CHOICE(name='sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')))
    _ISMSMORecord_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _ISMSMORecord_recipientInfo = SEQ_OF(name='recipientInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ISMSMORecord_recipientInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')))
    _ISMSMORecord_recipientInfo._cont = __ISMSMORecord_recipientInfo__item_
    _ISMSMORecord_subscriberEquipmentNumber = SET(name='subscriberEquipmentNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _ISMSMORecord_eventtimestamp = OCT_STR(name='eventtimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ISMSMORecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _ISMSMORecord_sMTotalNumber = INT(name='sMTotalNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMSequenceNumber = INT(name='sMSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _ISMSMORecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _ISMSMORecord_sMdeliveryReportRequested = BOOL(name='sMdeliveryReportRequested', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMDataCodingScheme = INT(name='sMDataCodingScheme', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMMessageType = ENUM(name='sMMessageType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _ISMSMORecord_sMReplyPathRequested = NULL(name='sMReplyPathRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMUserDataHeader = OCT_STR(name='sMUserDataHeader', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMSResult = CHOICE(name='sMSResult', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _ISMSMORecord_userLocationInfo = OCT_STR(name='userLocationInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ISMSMORecord_uETimeZone = OCT_STR(name='uETimeZone', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ISMSMORecord_pDPAddress = CHOICE(name='pDPAddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _ISMSMORecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ISMSMORecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ISMSMORecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ISMSMORecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ISMSMORecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ISMSMORecord._cont = ASN1Dict([
        ('recordType', _ISMSMORecord_recordType),
        ('sMSNodeAddress', _ISMSMORecord_sMSNodeAddress),
        ('originatorInfo', _ISMSMORecord_originatorInfo),
        ('recipientInfo', _ISMSMORecord_recipientInfo),
        ('subscriberEquipmentNumber', _ISMSMORecord_subscriberEquipmentNumber),
        ('eventtimestamp', _ISMSMORecord_eventtimestamp),
        ('messageReference', _ISMSMORecord_messageReference),
        ('sMTotalNumber', _ISMSMORecord_sMTotalNumber),
        ('sMSequenceNumber', _ISMSMORecord_sMSequenceNumber),
        ('messageSize', _ISMSMORecord_messageSize),
        ('messageClass', _ISMSMORecord_messageClass),
        ('sMdeliveryReportRequested', _ISMSMORecord_sMdeliveryReportRequested),
        ('sMDataCodingScheme', _ISMSMORecord_sMDataCodingScheme),
        ('sMMessageType', _ISMSMORecord_sMMessageType),
        ('sMReplyPathRequested', _ISMSMORecord_sMReplyPathRequested),
        ('sMUserDataHeader', _ISMSMORecord_sMUserDataHeader),
        ('sMSResult', _ISMSMORecord_sMSResult),
        ('userLocationInfo', _ISMSMORecord_userLocationInfo),
        ('rATType', _ISMSMORecord_rATType),
        ('uETimeZone', _ISMSMORecord_uETimeZone),
        ('pDPAddress', _ISMSMORecord_pDPAddress),
        ('session-Id', _ISMSMORecord_session_Id),
        ('numberPortabilityRouting', _ISMSMORecord_numberPortabilityRouting),
        ('carrierSelectRouting', _ISMSMORecord_carrierSelectRouting),
        ('localSequenceNumber', _ISMSMORecord_localSequenceNumber),
        ('recordExtensions', _ISMSMORecord_recordExtensions),
        ])
    ISMSMORecord._ext = None
    
    #-----< ISMSMTRecord >-----#
    ISMSMTRecord = SET(name='ISMSMTRecord', mode=MODE_TYPE)
    _ISMSMTRecord_recordType = INT(name='recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ISMSMTRecord_sMSNodeAddress = CHOICE(name='sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')))
    _ISMSMTRecord_recipientInfo = SEQ(name='recipientInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _ISMSMTRecord_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _ISMSMTRecord_subscriberEquipmentNumber = SET(name='subscriberEquipmentNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _ISMSMTRecord_submissionTime = OCT_STR(name='submissionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ISMSMTRecord_eventtimestamp = OCT_STR(name='eventtimestamp', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ISMSMTRecord_sMPriority = ENUM(name='sMPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _ISMSMTRecord_messageReference = OCT_STR(name='messageReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _ISMSMTRecord_sMTotalNumber = INT(name='sMTotalNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMSequenceNumber = INT(name='sMSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_messageSize = INT(name='messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _ISMSMTRecord_messageClass = ENUM(name='messageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _ISMSMTRecord_sMdeliveryReportRequested = BOOL(name='sMdeliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMDataCodingScheme = INT(name='sMDataCodingScheme', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMMessageType = ENUM(name='sMMessageType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _ISMSMTRecord_sMReplyPathRequested = NULL(name='sMReplyPathRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMUserDataHeader = OCT_STR(name='sMUserDataHeader', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMSStatus = OCT_STR(name='sMSStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMSStatus')), opt=True)
    _ISMSMTRecord_sMDischargeTime = OCT_STR(name='sMDischargeTime', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ISMSMTRecord_userLocationInfo = OCT_STR(name='userLocationInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_rATType = INT(name='rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ISMSMTRecord_uETimeZone = OCT_STR(name='uETimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ISMSMTRecord_sMSResult = CHOICE(name='sMSResult', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _ISMSMTRecord_pDPAddress = CHOICE(name='pDPAddress', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _ISMSMTRecord_session_Id = STR_GRAPH(name='session-Id', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ISMSMTRecord_numberPortabilityRouting = STR_GRAPH(name='numberPortabilityRouting', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ISMSMTRecord_carrierSelectRouting = STR_GRAPH(name='carrierSelectRouting', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ISMSMTRecord_localSequenceNumber = INT(name='localSequenceNumber', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ISMSMTRecord_recordExtensions = SET_OF(name='recordExtensions', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ISMSMTRecord._cont = ASN1Dict([
        ('recordType', _ISMSMTRecord_recordType),
        ('sMSNodeAddress', _ISMSMTRecord_sMSNodeAddress),
        ('recipientInfo', _ISMSMTRecord_recipientInfo),
        ('originatorInfo', _ISMSMTRecord_originatorInfo),
        ('subscriberEquipmentNumber', _ISMSMTRecord_subscriberEquipmentNumber),
        ('submissionTime', _ISMSMTRecord_submissionTime),
        ('eventtimestamp', _ISMSMTRecord_eventtimestamp),
        ('sMPriority', _ISMSMTRecord_sMPriority),
        ('messageReference', _ISMSMTRecord_messageReference),
        ('sMTotalNumber', _ISMSMTRecord_sMTotalNumber),
        ('sMSequenceNumber', _ISMSMTRecord_sMSequenceNumber),
        ('messageSize', _ISMSMTRecord_messageSize),
        ('messageClass', _ISMSMTRecord_messageClass),
        ('sMdeliveryReportRequested', _ISMSMTRecord_sMdeliveryReportRequested),
        ('sMDataCodingScheme', _ISMSMTRecord_sMDataCodingScheme),
        ('sMMessageType', _ISMSMTRecord_sMMessageType),
        ('sMReplyPathRequested', _ISMSMTRecord_sMReplyPathRequested),
        ('sMUserDataHeader', _ISMSMTRecord_sMUserDataHeader),
        ('sMSStatus', _ISMSMTRecord_sMSStatus),
        ('sMDischargeTime', _ISMSMTRecord_sMDischargeTime),
        ('userLocationInfo', _ISMSMTRecord_userLocationInfo),
        ('rATType', _ISMSMTRecord_rATType),
        ('uETimeZone', _ISMSMTRecord_uETimeZone),
        ('sMSResult', _ISMSMTRecord_sMSResult),
        ('pDPAddress', _ISMSMTRecord_pDPAddress),
        ('session-Id', _ISMSMTRecord_session_Id),
        ('numberPortabilityRouting', _ISMSMTRecord_numberPortabilityRouting),
        ('carrierSelectRouting', _ISMSMTRecord_carrierSelectRouting),
        ('localSequenceNumber', _ISMSMTRecord_localSequenceNumber),
        ('recordExtensions', _ISMSMTRecord_recordExtensions),
        ])
    ISMSMTRecord._ext = None
    
    #-----< OriginatorInfo >-----#
    OriginatorInfo = SEQ(name='OriginatorInfo', mode=MODE_TYPE)
    _OriginatorInfo_originatorIMSI = OCT_STR(name='originatorIMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _OriginatorInfo_originatorMSISDN = OCT_STR(name='originatorMSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _OriginatorInfo_originatorOtherAddress = SEQ(name='originatorOtherAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _OriginatorInfo_originatorSCCPAddress = OCT_STR(name='originatorSCCPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _OriginatorInfo_originatorReceivedAddress = SEQ(name='originatorReceivedAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _OriginatorInfo_sMOriginatorInterface = SEQ(name='sMOriginatorInterface', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMInterface')), opt=True)
    _OriginatorInfo_sMOriginatorProtocolID = OCT_STR(name='sMOriginatorProtocolID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OriginatorInfo_originatorOtherAddresses = SEQ_OF(name='originatorOtherAddresses', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OriginatorInfo_originatorOtherAddresses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')))
    _OriginatorInfo_originatorOtherAddresses._cont = __OriginatorInfo_originatorOtherAddresses__item_
    OriginatorInfo._cont = ASN1Dict([
        ('originatorIMSI', _OriginatorInfo_originatorIMSI),
        ('originatorMSISDN', _OriginatorInfo_originatorMSISDN),
        ('originatorOtherAddress', _OriginatorInfo_originatorOtherAddress),
        ('originatorSCCPAddress', _OriginatorInfo_originatorSCCPAddress),
        ('originatorReceivedAddress', _OriginatorInfo_originatorReceivedAddress),
        ('sMOriginatorInterface', _OriginatorInfo_sMOriginatorInterface),
        ('sMOriginatorProtocolID', _OriginatorInfo_sMOriginatorProtocolID),
        ('originatorOtherAddresses', _OriginatorInfo_originatorOtherAddresses),
        ])
    OriginatorInfo._ext = None
    
    #-----< RecipientInfo >-----#
    RecipientInfo = SEQ(name='RecipientInfo', mode=MODE_TYPE)
    _RecipientInfo_recipientIMSI = OCT_STR(name='recipientIMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _RecipientInfo_recipientMSISDN = OCT_STR(name='recipientMSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _RecipientInfo_recipientOtherAddress = SEQ(name='recipientOtherAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _RecipientInfo_recipientSCCPAddress = OCT_STR(name='recipientSCCPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _RecipientInfo_recipientReceivedAddress = SEQ(name='recipientReceivedAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _RecipientInfo_sMDestinationInterface = SEQ(name='sMDestinationInterface', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMInterface')), opt=True)
    _RecipientInfo_sMRecipientProtocolID = OCT_STR(name='sMRecipientProtocolID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RecipientInfo_recipientOtherAddresses = SEQ_OF(name='recipientOtherAddresses', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RecipientInfo_recipientOtherAddresses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')))
    _RecipientInfo_recipientOtherAddresses._cont = __RecipientInfo_recipientOtherAddresses__item_
    RecipientInfo._cont = ASN1Dict([
        ('recipientIMSI', _RecipientInfo_recipientIMSI),
        ('recipientMSISDN', _RecipientInfo_recipientMSISDN),
        ('recipientOtherAddress', _RecipientInfo_recipientOtherAddress),
        ('recipientSCCPAddress', _RecipientInfo_recipientSCCPAddress),
        ('recipientReceivedAddress', _RecipientInfo_recipientReceivedAddress),
        ('sMDestinationInterface', _RecipientInfo_sMDestinationInterface),
        ('sMRecipientProtocolID', _RecipientInfo_sMRecipientProtocolID),
        ('recipientOtherAddresses', _RecipientInfo_recipientOtherAddresses),
        ])
    RecipientInfo._ext = None
    
    #-----< SMAddressDomain >-----#
    SMAddressDomain = SEQ(name='SMAddressDomain', mode=MODE_TYPE)
    _SMAddressDomain_sMDomainName = STR_GRAPH(name='sMDomainName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMAddressDomain_threeGPPIMSI_MCC_MNC = OCT_STR(name='threeGPPIMSI-MCC-MNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    SMAddressDomain._cont = ASN1Dict([
        ('sMDomainName', _SMAddressDomain_sMDomainName),
        ('threeGPPIMSI-MCC-MNC', _SMAddressDomain_threeGPPIMSI_MCC_MNC),
        ])
    SMAddressDomain._ext = None
    
    #-----< SMAddressInfo >-----#
    SMAddressInfo = SEQ(name='SMAddressInfo', mode=MODE_TYPE)
    _SMAddressInfo_sMAddressType = ENUM(name='sMAddressType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressType')), opt=True)
    _SMAddressInfo_sMAddressData = STR_GRAPH(name='sMAddressData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMAddressInfo_sMAddressDomain = SEQ(name='sMAddressDomain', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressDomain')), opt=True)
    SMAddressInfo._cont = ASN1Dict([
        ('sMAddressType', _SMAddressInfo_sMAddressType),
        ('sMAddressData', _SMAddressInfo_sMAddressData),
        ('sMAddressDomain', _SMAddressInfo_sMAddressDomain),
        ])
    SMAddressInfo._ext = None
    
    #-----< SMAddressType >-----#
    SMAddressType = ENUM(name='SMAddressType', mode=MODE_TYPE)
    SMAddressType._cont = ASN1Dict([('emailAddress', 0), ('mSISDN', 1), ('iPv4Address', 2), ('iPv6Address', 3), ('numericShortCode', 4), ('alphanumericShortCode', 5), ('other', 6), ('iMSI', 7), ('nAI', 8), ('externalId', 9)])
    SMAddressType._ext = None
    
    #-----< SMDeviceTriggerIndicator >-----#
    SMDeviceTriggerIndicator = ENUM(name='SMDeviceTriggerIndicator', mode=MODE_TYPE)
    SMDeviceTriggerIndicator._cont = ASN1Dict([('notDeviceTrigger', 0), ('deviceTriggerRequest', 1), ('deviceTriggerReplace', 2), ('deviceTriggerRecall', 3)])
    SMDeviceTriggerIndicator._ext = None
    
    #-----< SMDeviceTriggerInformation >-----#
    SMDeviceTriggerInformation = SEQ(name='SMDeviceTriggerInformation', mode=MODE_TYPE)
    _SMDeviceTriggerInformation_mTCIWFAddress = CHOICE(name='mTCIWFAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SMDeviceTriggerInformation_sMDTReferenceNumber = INT(name='sMDTReferenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMDeviceTriggerInformation_sMServingNode = SEQ(name='sMServingNode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMServingNode')), opt=True)
    _SMDeviceTriggerInformation_sMDTValidityPeriod = INT(name='sMDTValidityPeriod', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMDeviceTriggerInformation_sMDTPriorityIndication = ENUM(name='sMDTPriorityIndication', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDTPriorityIndication')), opt=True)
    _SMDeviceTriggerInformation_sMSApplicationPortID = INT(name='sMSApplicationPortID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SMDeviceTriggerInformation._cont = ASN1Dict([
        ('mTCIWFAddress', _SMDeviceTriggerInformation_mTCIWFAddress),
        ('sMDTReferenceNumber', _SMDeviceTriggerInformation_sMDTReferenceNumber),
        ('sMServingNode', _SMDeviceTriggerInformation_sMServingNode),
        ('sMDTValidityPeriod', _SMDeviceTriggerInformation_sMDTValidityPeriod),
        ('sMDTPriorityIndication', _SMDeviceTriggerInformation_sMDTPriorityIndication),
        ('sMSApplicationPortID', _SMDeviceTriggerInformation_sMSApplicationPortID),
        ])
    SMDeviceTriggerInformation._ext = None
    
    #-----< SMDTPriorityIndication >-----#
    SMDTPriorityIndication = ENUM(name='SMDTPriorityIndication', mode=MODE_TYPE)
    SMDTPriorityIndication._cont = ASN1Dict([('nonpriority', 0), ('priority', 1)])
    SMDTPriorityIndication._ext = None
    
    #-----< SMInterface >-----#
    SMInterface = SEQ(name='SMInterface', mode=MODE_TYPE)
    _SMInterface_interfaceId = STR_GRAPH(name='interfaceId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMInterface_interfaceText = STR_GRAPH(name='interfaceText', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMInterface_interfacePort = STR_GRAPH(name='interfacePort', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMInterface_interfaceType = ENUM(name='interfaceType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMInterfaceType')), opt=True)
    SMInterface._cont = ASN1Dict([
        ('interfaceId', _SMInterface_interfaceId),
        ('interfaceText', _SMInterface_interfaceText),
        ('interfacePort', _SMInterface_interfacePort),
        ('interfaceType', _SMInterface_interfaceType),
        ])
    SMInterface._ext = None
    
    #-----< SMInterfaceType >-----#
    SMInterfaceType = ENUM(name='SMInterfaceType', mode=MODE_TYPE)
    SMInterfaceType._cont = ASN1Dict([('unkown', 0), ('mobileOriginating', 1), ('mobileTerminating', 2), ('applicationOriginating', 3), ('applicationTerminating', 4), ('deviceTrigger', 5)])
    SMInterfaceType._ext = None
    
    #-----< SMMessageType >-----#
    SMMessageType = ENUM(name='SMMessageType', mode=MODE_TYPE)
    SMMessageType._cont = ASN1Dict([('submission', 0), ('deliveryReport', 1), ('sMServiceRequest', 2), ('delivery', 3), ('t4DeviceTrigger', 4), ('sMDeviceTrigger', 5)])
    SMMessageType._ext = None
    
    #-----< SMServingNode >-----#
    SMServingNode = SEQ(name='SMServingNode', mode=MODE_TYPE)
    _SMServingNode_sGSNName = OCT_STR(name='sGSNName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_sGSNRealm = OCT_STR(name='sGSNRealm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_sGSNNumber = OCT_STR(name='sGSNNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_mMEName = OCT_STR(name='mMEName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_mMERealm = OCT_STR(name='mMERealm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_mMENumberForMTSMS = OCT_STR(name='mMENumberForMTSMS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_mSCNumber = OCT_STR(name='mSCNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_iPSMGWNumber = OCT_STR(name='iPSMGWNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_iPSMGWName = OCT_STR(name='iPSMGWName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    SMServingNode._cont = ASN1Dict([
        ('sGSNName', _SMServingNode_sGSNName),
        ('sGSNRealm', _SMServingNode_sGSNRealm),
        ('sGSNNumber', _SMServingNode_sGSNNumber),
        ('mMEName', _SMServingNode_mMEName),
        ('mMERealm', _SMServingNode_mMERealm),
        ('mMENumberForMTSMS', _SMServingNode_mMENumberForMTSMS),
        ('mSCNumber', _SMServingNode_mSCNumber),
        ('iPSMGWNumber', _SMServingNode_iPSMGWNumber),
        ('iPSMGWName', _SMServingNode_iPSMGWName),
        ])
    SMServingNode._ext = None
    
    #-----< SMSStatus >-----#
    SMSStatus = OCT_STR(name='SMSStatus', mode=MODE_TYPE)
    SMSStatus._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    _all_ = [
        _SMSRecordType_sCSMORecord,
        _SMSRecordType_sCSMTRecord,
        _SMSRecordType_sCDVTT4Record,
        _SMSRecordType_sCSMOT4Record,
        _SMSRecordType_iSMSMORecord,
        _SMSRecordType_iSMSMTRecord,
        SMSRecordType,
        _SCSMORecord_recordType,
        _SCSMORecord_sMSNodeAddress,
        _SCSMORecord_originatorInfo,
        __SCSMORecord_recipientInfo__item_,
        _SCSMORecord_recipientInfo,
        _SCSMORecord_servedIMEI,
        _SCSMORecord_eventtimestamp,
        _SCSMORecord_messageReference,
        _SCSMORecord_sMTotalNumber,
        _SCSMORecord_sMSequenceNumber,
        _SCSMORecord_messageSize,
        _SCSMORecord_messageClass,
        _SCSMORecord_sMdeliveryReportRequested,
        _SCSMORecord_sMDataCodingScheme,
        _SCSMORecord_sMMessageType,
        _SCSMORecord_sMReplyPathRequested,
        _SCSMORecord_sMUserDataHeader,
        _SCSMORecord_userLocationInfo,
        _SCSMORecord_rATType,
        _SCSMORecord_uETimeZone,
        _SCSMORecord_sMSResult,
        _SCSMORecord_localSequenceNumber,
        _SCSMORecord_recordExtensions,
        SCSMORecord,
        _SCSMOT4Record_recordType,
        _SCSMOT4Record_sMSNodeAddress,
        _SCSMOT4Record_originatorInfo,
        _SCSMOT4Record_recipientInfo,
        _SCSMOT4Record_servedIMEI,
        _SCSMOT4Record_eventtimestamp,
        _SCSMOT4Record_messageReference,
        _SCSMOT4Record_messageSize,
        _SCSMOT4Record_messageClass,
        _SCSMOT4Record_sMdeliveryReportRequested,
        _SCSMOT4Record_sMDataCodingScheme,
        _SCSMOT4Record_sMMessageType,
        _SCSMOT4Record_sMReplyPathRequested,
        _SCSMOT4Record_sMUserDataHeader,
        _SCSMOT4Record_userLocationInfo,
        _SCSMOT4Record_rATType,
        _SCSMOT4Record_uETimeZone,
        _SCSMOT4Record_sMSResult,
        _SCSMOT4Record_mTCIWFAddress,
        _SCSMOT4Record_sMSApplicationPortID,
        _SCSMOT4Record_externalIdentifier,
        _SCSMOT4Record_localSequenceNumber,
        _SCSMOT4Record_recordExtensions,
        SCSMOT4Record,
        _SCSMTRecord_recordType,
        _SCSMTRecord_sMSNodeAddress,
        _SCSMTRecord_recipientInfo,
        _SCSMTRecord_originatorInfo,
        _SCSMTRecord_servedIMEI,
        _SCSMTRecord_submissionTime,
        _SCSMTRecord_eventtimestamp,
        _SCSMTRecord_sMPriority,
        _SCSMTRecord_messageReference,
        _SCSMTRecord_sMTotalNumber,
        _SCSMTRecord_sMSequenceNumber,
        _SCSMTRecord_messageSize,
        _SCSMTRecord_messageClass,
        _SCSMTRecord_sMdeliveryReportRequested,
        _SCSMTRecord_sMDataCodingScheme,
        _SCSMTRecord_sMMessageType,
        _SCSMTRecord_sMReplyPathRequested,
        _SCSMTRecord_sMUserDataHeader,
        _SCSMTRecord_sMSStatus,
        _SCSMTRecord_sMDischargeTime,
        _SCSMTRecord_userLocationInfo,
        _SCSMTRecord_rATType,
        _SCSMTRecord_uETimeZone,
        _SCSMTRecord_sMSResult,
        _SCSMTRecord_sMDeviceTriggerInformation,
        _SCSMTRecord_localSequenceNumber,
        _SCSMTRecord_recordExtensions,
        SCSMTRecord,
        _SCDVTT4Record_recordType,
        _SCDVTT4Record_sMSNodeAddress,
        _SCDVTT4Record_eventtimestamp,
        _SCDVTT4Record_originatorInfo,
        _SCDVTT4Record_recipientInfo,
        _SCDVTT4Record_sMDeviceTriggerIndicator,
        _SCDVTT4Record_sMDeviceTriggerInformation,
        _SCDVTT4Record_sMSResult,
        _SCDVTT4Record_localSequenceNumber,
        _SCDVTT4Record_recordExtensions,
        SCDVTT4Record,
        _ISMSMORecord_recordType,
        _ISMSMORecord_sMSNodeAddress,
        _ISMSMORecord_originatorInfo,
        __ISMSMORecord_recipientInfo__item_,
        _ISMSMORecord_recipientInfo,
        _ISMSMORecord_subscriberEquipmentNumber,
        _ISMSMORecord_eventtimestamp,
        _ISMSMORecord_messageReference,
        _ISMSMORecord_sMTotalNumber,
        _ISMSMORecord_sMSequenceNumber,
        _ISMSMORecord_messageSize,
        _ISMSMORecord_messageClass,
        _ISMSMORecord_sMdeliveryReportRequested,
        _ISMSMORecord_sMDataCodingScheme,
        _ISMSMORecord_sMMessageType,
        _ISMSMORecord_sMReplyPathRequested,
        _ISMSMORecord_sMUserDataHeader,
        _ISMSMORecord_sMSResult,
        _ISMSMORecord_userLocationInfo,
        _ISMSMORecord_rATType,
        _ISMSMORecord_uETimeZone,
        _ISMSMORecord_pDPAddress,
        _ISMSMORecord_session_Id,
        _ISMSMORecord_numberPortabilityRouting,
        _ISMSMORecord_carrierSelectRouting,
        _ISMSMORecord_localSequenceNumber,
        _ISMSMORecord_recordExtensions,
        ISMSMORecord,
        _ISMSMTRecord_recordType,
        _ISMSMTRecord_sMSNodeAddress,
        _ISMSMTRecord_recipientInfo,
        _ISMSMTRecord_originatorInfo,
        _ISMSMTRecord_subscriberEquipmentNumber,
        _ISMSMTRecord_submissionTime,
        _ISMSMTRecord_eventtimestamp,
        _ISMSMTRecord_sMPriority,
        _ISMSMTRecord_messageReference,
        _ISMSMTRecord_sMTotalNumber,
        _ISMSMTRecord_sMSequenceNumber,
        _ISMSMTRecord_messageSize,
        _ISMSMTRecord_messageClass,
        _ISMSMTRecord_sMdeliveryReportRequested,
        _ISMSMTRecord_sMDataCodingScheme,
        _ISMSMTRecord_sMMessageType,
        _ISMSMTRecord_sMReplyPathRequested,
        _ISMSMTRecord_sMUserDataHeader,
        _ISMSMTRecord_sMSStatus,
        _ISMSMTRecord_sMDischargeTime,
        _ISMSMTRecord_userLocationInfo,
        _ISMSMTRecord_rATType,
        _ISMSMTRecord_uETimeZone,
        _ISMSMTRecord_sMSResult,
        _ISMSMTRecord_pDPAddress,
        _ISMSMTRecord_session_Id,
        _ISMSMTRecord_numberPortabilityRouting,
        _ISMSMTRecord_carrierSelectRouting,
        _ISMSMTRecord_localSequenceNumber,
        _ISMSMTRecord_recordExtensions,
        ISMSMTRecord,
        _OriginatorInfo_originatorIMSI,
        _OriginatorInfo_originatorMSISDN,
        _OriginatorInfo_originatorOtherAddress,
        _OriginatorInfo_originatorSCCPAddress,
        _OriginatorInfo_originatorReceivedAddress,
        _OriginatorInfo_sMOriginatorInterface,
        _OriginatorInfo_sMOriginatorProtocolID,
        __OriginatorInfo_originatorOtherAddresses__item_,
        _OriginatorInfo_originatorOtherAddresses,
        OriginatorInfo,
        _RecipientInfo_recipientIMSI,
        _RecipientInfo_recipientMSISDN,
        _RecipientInfo_recipientOtherAddress,
        _RecipientInfo_recipientSCCPAddress,
        _RecipientInfo_recipientReceivedAddress,
        _RecipientInfo_sMDestinationInterface,
        _RecipientInfo_sMRecipientProtocolID,
        __RecipientInfo_recipientOtherAddresses__item_,
        _RecipientInfo_recipientOtherAddresses,
        RecipientInfo,
        _SMAddressDomain_sMDomainName,
        _SMAddressDomain_threeGPPIMSI_MCC_MNC,
        SMAddressDomain,
        _SMAddressInfo_sMAddressType,
        _SMAddressInfo_sMAddressData,
        _SMAddressInfo_sMAddressDomain,
        SMAddressInfo,
        SMAddressType,
        SMDeviceTriggerIndicator,
        _SMDeviceTriggerInformation_mTCIWFAddress,
        _SMDeviceTriggerInformation_sMDTReferenceNumber,
        _SMDeviceTriggerInformation_sMServingNode,
        _SMDeviceTriggerInformation_sMDTValidityPeriod,
        _SMDeviceTriggerInformation_sMDTPriorityIndication,
        _SMDeviceTriggerInformation_sMSApplicationPortID,
        SMDeviceTriggerInformation,
        SMDTPriorityIndication,
        _SMInterface_interfaceId,
        _SMInterface_interfaceText,
        _SMInterface_interfacePort,
        _SMInterface_interfaceType,
        SMInterface,
        SMInterfaceType,
        SMMessageType,
        _SMServingNode_sGSNName,
        _SMServingNode_sGSNRealm,
        _SMServingNode_sGSNNumber,
        _SMServingNode_mMEName,
        _SMServingNode_mMERealm,
        _SMServingNode_mMENumberForMTSMS,
        _SMServingNode_mSCNumber,
        _SMServingNode_iPSMGWNumber,
        _SMServingNode_iPSMGWName,
        SMServingNode,
        SMSStatus,
    ]

class SpkmGssTokens:

    _name_  = 'SpkmGssTokens'
    _oid_   = [1, 3, 6, 1, 5, 5, 1, 10]
    
    _obj_ = [
        'SPKM-REQ',
        'CertificationData',
        'CertificationPath',
        'REQ-TOKEN',
        'Integrity',
        'Req-contents',
        'Random-Integer',
        'Context-Data',
        'ChannelId',
        'Options',
        'Conf-Algs',
        'Intg-Algs',
        'OWF-Algs',
        'Key-Estb-Algs',
        'SPKM-REP-TI',
        'REP-TI-TOKEN',
        'Rep-ti-contents',
        'SPKM-REP-IT',
        'REP-IT-TOKEN',
        'SPKM-ERROR',
        'ERROR-TOKEN',
        'SPKM-MIC',
        'Mic-Header',
        'SeqNum',
        'SPKM-WRAP',
        'Wrap-Header',
        'Wrap-Body',
        'Conf-Alg',
        'SPKM-DEL',
        'Del-Header',
        'MechType',
        'InitialContextToken',
        'SPKMInnerContextToken',
        'AuthorizationData',
        'md5-DES-CBC',
        'sum64-DES-CBC',
        'spkm-1',
        'spkm-2',
        ]
    _type_ = [
        'SPKM-REQ',
        'CertificationData',
        'CertificationPath',
        'REQ-TOKEN',
        'Integrity',
        'Req-contents',
        'Random-Integer',
        'Context-Data',
        'ChannelId',
        'Options',
        'Conf-Algs',
        'Intg-Algs',
        'OWF-Algs',
        'Key-Estb-Algs',
        'SPKM-REP-TI',
        'REP-TI-TOKEN',
        'Rep-ti-contents',
        'SPKM-REP-IT',
        'REP-IT-TOKEN',
        'SPKM-ERROR',
        'ERROR-TOKEN',
        'SPKM-MIC',
        'Mic-Header',
        'SeqNum',
        'SPKM-WRAP',
        'Wrap-Header',
        'Wrap-Body',
        'Conf-Alg',
        'SPKM-DEL',
        'Del-Header',
        'MechType',
        'InitialContextToken',
        'SPKMInnerContextToken',
        'AuthorizationData',
        ]
    _set_ = [
        ]
    _val_ = [
        'md5-DES-CBC',
        'sum64-DES-CBC',
        'spkm-1',
        'spkm-2',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SPKM-REQ >-----#
    SPKM_REQ = SEQ(name='SPKM-REQ', mode=MODE_TYPE)
    _SPKM_REQ_requestToken = SEQ(name='requestToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REQ-TOKEN')))
    _SPKM_REQ_certif_data = SEQ(name='certif-data', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'CertificationData')), opt=True)
    _SPKM_REQ_auth_data = SEQ_OF(name='auth-data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'AuthorizationData')), opt=True)
    SPKM_REQ._cont = ASN1Dict([
        ('requestToken', _SPKM_REQ_requestToken),
        ('certif-data', _SPKM_REQ_certif_data),
        ('auth-data', _SPKM_REQ_auth_data),
        ])
    SPKM_REQ._ext = None
    
    #-----< CertificationData >-----#
    CertificationData = SEQ(name='CertificationData', mode=MODE_TYPE)
    _CertificationData_certificationPath = SEQ(name='certificationPath', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'CertificationPath')), opt=True)
    _CertificationData_certificateRevocationList = SEQ(name='certificateRevocationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')), opt=True)
    CertificationData._cont = ASN1Dict([
        ('certificationPath', _CertificationData_certificationPath),
        ('certificateRevocationList', _CertificationData_certificateRevocationList),
        ])
    CertificationData._ext = None
    
    #-----< CertificationPath >-----#
    CertificationPath = SEQ(name='CertificationPath', mode=MODE_TYPE)
    _CertificationPath_userKeyId = OCT_STR(name='userKeyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificationPath_userCertif = SEQ(name='userCertif', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificationPath_verifKeyId = OCT_STR(name='verifKeyId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificationPath_userVerifCertif = SEQ(name='userVerifCertif', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificationPath_theCACertificates = SEQ_OF(name='theCACertificates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CertificationPath_theCACertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    _CertificationPath_theCACertificates._cont = __CertificationPath_theCACertificates__item_
    CertificationPath._cont = ASN1Dict([
        ('userKeyId', _CertificationPath_userKeyId),
        ('userCertif', _CertificationPath_userCertif),
        ('verifKeyId', _CertificationPath_verifKeyId),
        ('userVerifCertif', _CertificationPath_userVerifCertif),
        ('theCACertificates', _CertificationPath_theCACertificates),
        ])
    CertificationPath._ext = None
    
    #-----< REQ-TOKEN >-----#
    REQ_TOKEN = SEQ(name='REQ-TOKEN', mode=MODE_TYPE)
    _REQ_TOKEN_req_contents = SEQ(name='req-contents', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Req-contents')))
    _REQ_TOKEN_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __REQ_TOKEN_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___REQ_TOKEN_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REQ_TOKEN_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REQ_TOKEN_algId_algorithm._const_tab = ___REQ_TOKEN_algId_algorithm_tab
    __REQ_TOKEN_algId_algorithm._const_tab_at = None
    __REQ_TOKEN_algId_algorithm._const_tab_id = 'id'
    __REQ_TOKEN_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___REQ_TOKEN_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REQ_TOKEN_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REQ_TOKEN_algId_parameters._const_tab = ___REQ_TOKEN_algId_parameters_tab
    __REQ_TOKEN_algId_parameters._const_tab_at = ('..', 'algorithm')
    __REQ_TOKEN_algId_parameters._const_tab_id = 'Type'
    _REQ_TOKEN_algId._cont = ASN1Dict([
        ('algorithm', __REQ_TOKEN_algId_algorithm),
        ('parameters', __REQ_TOKEN_algId_parameters),
        ])
    _REQ_TOKEN_algId._ext = []
    _REQ_TOKEN_req_integrity = BIT_STR(name='req-integrity', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    REQ_TOKEN._cont = ASN1Dict([
        ('req-contents', _REQ_TOKEN_req_contents),
        ('algId', _REQ_TOKEN_algId),
        ('req-integrity', _REQ_TOKEN_req_integrity),
        ])
    REQ_TOKEN._ext = None
    
    #-----< Integrity >-----#
    Integrity = BIT_STR(name='Integrity', mode=MODE_TYPE)
    
    #-----< Req-contents >-----#
    Req_contents = SEQ(name='Req-contents', mode=MODE_TYPE)
    _Req_contents_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Req_contents_tok_id._const_val = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    _Req_contents_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Req_contents_pvno = BIT_STR(name='pvno', mode=MODE_TYPE)
    _Req_contents_timestamp = TIME_UTC(name='timestamp', mode=MODE_TYPE, opt=True)
    _Req_contents_randSrc = BIT_STR(name='randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Req_contents_targ_name = CHOICE(name='targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _Req_contents_src_name = CHOICE(name='src-name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _Req_contents_req_data = SEQ(name='req-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Context-Data')))
    _Req_contents_validity = SEQ(name='validity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Validity')), opt=True)
    _Req_contents_key_estb_set = SEQ_OF(name='key-estb-set', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Key-Estb-Algs')))
    _Req_contents_key_estb_req = BIT_STR(name='key-estb-req', mode=MODE_TYPE, opt=True)
    _Req_contents_key_src_bind = OCT_STR(name='key-src-bind', mode=MODE_TYPE, opt=True)
    Req_contents._cont = ASN1Dict([
        ('tok-id', _Req_contents_tok_id),
        ('context-id', _Req_contents_context_id),
        ('pvno', _Req_contents_pvno),
        ('timestamp', _Req_contents_timestamp),
        ('randSrc', _Req_contents_randSrc),
        ('targ-name', _Req_contents_targ_name),
        ('src-name', _Req_contents_src_name),
        ('req-data', _Req_contents_req_data),
        ('validity', _Req_contents_validity),
        ('key-estb-set', _Req_contents_key_estb_set),
        ('key-estb-req', _Req_contents_key_estb_req),
        ('key-src-bind', _Req_contents_key_src_bind),
        ])
    Req_contents._ext = None
    
    #-----< Random-Integer >-----#
    Random_Integer = BIT_STR(name='Random-Integer', mode=MODE_TYPE)
    
    #-----< Context-Data >-----#
    Context_Data = SEQ(name='Context-Data', mode=MODE_TYPE)
    _Context_Data_channelId = OCT_STR(name='channelId', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'ChannelId')), opt=True)
    _Context_Data_seq_number = INT(name='seq-number', mode=MODE_TYPE, opt=True)
    _Context_Data_options = BIT_STR(name='options', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Options')))
    _Context_Data_conf_alg = CHOICE(name='conf-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Conf-Algs')))
    _Context_Data_intg_alg = SEQ_OF(name='intg-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Intg-Algs')))
    _Context_Data_owf_alg = SEQ_OF(name='owf-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'OWF-Algs')))
    Context_Data._cont = ASN1Dict([
        ('channelId', _Context_Data_channelId),
        ('seq-number', _Context_Data_seq_number),
        ('options', _Context_Data_options),
        ('conf-alg', _Context_Data_conf_alg),
        ('intg-alg', _Context_Data_intg_alg),
        ('owf-alg', _Context_Data_owf_alg),
        ])
    Context_Data._ext = None
    
    #-----< ChannelId >-----#
    ChannelId = OCT_STR(name='ChannelId', mode=MODE_TYPE)
    
    #-----< Options >-----#
    Options = BIT_STR(name='Options', mode=MODE_TYPE)
    Options._cont = ASN1Dict([('delegation-state', 0), ('mutual-state', 1), ('replay-det-state', 2), ('sequence-state', 3), ('conf-avail', 4), ('integ-avail', 5), ('target-certif-data-required', 6)])
    
    #-----< Conf-Algs >-----#
    Conf_Algs = CHOICE(name='Conf-Algs', mode=MODE_TYPE)
    _Conf_Algs_algs = SEQ_OF(name='algs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Conf_Algs_algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___Conf_Algs_algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____Conf_Algs_algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____Conf_Algs_algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Conf_Algs_algs__item__algorithm._const_tab = ____Conf_Algs_algs__item__algorithm_tab
    ___Conf_Algs_algs__item__algorithm._const_tab_at = None
    ___Conf_Algs_algs__item__algorithm._const_tab_id = 'id'
    ___Conf_Algs_algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____Conf_Algs_algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____Conf_Algs_algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Conf_Algs_algs__item__parameters._const_tab = ____Conf_Algs_algs__item__parameters_tab
    ___Conf_Algs_algs__item__parameters._const_tab_at = ('..', 'algorithm')
    ___Conf_Algs_algs__item__parameters._const_tab_id = 'Type'
    __Conf_Algs_algs__item_._cont = ASN1Dict([
        ('algorithm', ___Conf_Algs_algs__item__algorithm),
        ('parameters', ___Conf_Algs_algs__item__parameters),
        ])
    __Conf_Algs_algs__item_._ext = []
    _Conf_Algs_algs._cont = __Conf_Algs_algs__item_
    _Conf_Algs_null = NULL(name='null', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Conf_Algs._cont = ASN1Dict([
        ('algs', _Conf_Algs_algs),
        ('null', _Conf_Algs_null),
        ])
    Conf_Algs._ext = None
    
    #-----< Intg-Algs >-----#
    Intg_Algs = SEQ_OF(name='Intg-Algs', mode=MODE_TYPE)
    _Intg_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Intg_Algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Intg_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Intg_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Intg_Algs__item__algorithm._const_tab = ___Intg_Algs__item__algorithm_tab
    __Intg_Algs__item__algorithm._const_tab_at = None
    __Intg_Algs__item__algorithm._const_tab_id = 'id'
    __Intg_Algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Intg_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Intg_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Intg_Algs__item__parameters._const_tab = ___Intg_Algs__item__parameters_tab
    __Intg_Algs__item__parameters._const_tab_at = ('..', 'algorithm')
    __Intg_Algs__item__parameters._const_tab_id = 'Type'
    _Intg_Algs__item_._cont = ASN1Dict([
        ('algorithm', __Intg_Algs__item__algorithm),
        ('parameters', __Intg_Algs__item__parameters),
        ])
    _Intg_Algs__item_._ext = []
    Intg_Algs._cont = _Intg_Algs__item_
    
    #-----< OWF-Algs >-----#
    OWF_Algs = SEQ_OF(name='OWF-Algs', mode=MODE_TYPE)
    _OWF_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __OWF_Algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___OWF_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___OWF_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OWF_Algs__item__algorithm._const_tab = ___OWF_Algs__item__algorithm_tab
    __OWF_Algs__item__algorithm._const_tab_at = None
    __OWF_Algs__item__algorithm._const_tab_id = 'id'
    __OWF_Algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___OWF_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___OWF_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OWF_Algs__item__parameters._const_tab = ___OWF_Algs__item__parameters_tab
    __OWF_Algs__item__parameters._const_tab_at = ('..', 'algorithm')
    __OWF_Algs__item__parameters._const_tab_id = 'Type'
    _OWF_Algs__item_._cont = ASN1Dict([
        ('algorithm', __OWF_Algs__item__algorithm),
        ('parameters', __OWF_Algs__item__parameters),
        ])
    _OWF_Algs__item_._ext = []
    OWF_Algs._cont = _OWF_Algs__item_
    
    #-----< Key-Estb-Algs >-----#
    Key_Estb_Algs = SEQ_OF(name='Key-Estb-Algs', mode=MODE_TYPE)
    _Key_Estb_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Key_Estb_Algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Key_Estb_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Key_Estb_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Key_Estb_Algs__item__algorithm._const_tab = ___Key_Estb_Algs__item__algorithm_tab
    __Key_Estb_Algs__item__algorithm._const_tab_at = None
    __Key_Estb_Algs__item__algorithm._const_tab_id = 'id'
    __Key_Estb_Algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Key_Estb_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Key_Estb_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Key_Estb_Algs__item__parameters._const_tab = ___Key_Estb_Algs__item__parameters_tab
    __Key_Estb_Algs__item__parameters._const_tab_at = ('..', 'algorithm')
    __Key_Estb_Algs__item__parameters._const_tab_id = 'Type'
    _Key_Estb_Algs__item_._cont = ASN1Dict([
        ('algorithm', __Key_Estb_Algs__item__algorithm),
        ('parameters', __Key_Estb_Algs__item__parameters),
        ])
    _Key_Estb_Algs__item_._ext = []
    Key_Estb_Algs._cont = _Key_Estb_Algs__item_
    
    #-----< SPKM-REP-TI >-----#
    SPKM_REP_TI = SEQ(name='SPKM-REP-TI', mode=MODE_TYPE)
    _SPKM_REP_TI_responseToken = SEQ(name='responseToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REP-TI-TOKEN')))
    _SPKM_REP_TI_certif_data = SEQ(name='certif-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'CertificationData')), opt=True)
    SPKM_REP_TI._cont = ASN1Dict([
        ('responseToken', _SPKM_REP_TI_responseToken),
        ('certif-data', _SPKM_REP_TI_certif_data),
        ])
    SPKM_REP_TI._ext = None
    
    #-----< REP-TI-TOKEN >-----#
    REP_TI_TOKEN = SEQ(name='REP-TI-TOKEN', mode=MODE_TYPE)
    _REP_TI_TOKEN_rep_ti_contents = SEQ(name='rep-ti-contents', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Rep-ti-contents')))
    _REP_TI_TOKEN_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __REP_TI_TOKEN_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___REP_TI_TOKEN_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REP_TI_TOKEN_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REP_TI_TOKEN_algId_algorithm._const_tab = ___REP_TI_TOKEN_algId_algorithm_tab
    __REP_TI_TOKEN_algId_algorithm._const_tab_at = None
    __REP_TI_TOKEN_algId_algorithm._const_tab_id = 'id'
    __REP_TI_TOKEN_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___REP_TI_TOKEN_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REP_TI_TOKEN_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REP_TI_TOKEN_algId_parameters._const_tab = ___REP_TI_TOKEN_algId_parameters_tab
    __REP_TI_TOKEN_algId_parameters._const_tab_at = ('..', 'algorithm')
    __REP_TI_TOKEN_algId_parameters._const_tab_id = 'Type'
    _REP_TI_TOKEN_algId._cont = ASN1Dict([
        ('algorithm', __REP_TI_TOKEN_algId_algorithm),
        ('parameters', __REP_TI_TOKEN_algId_parameters),
        ])
    _REP_TI_TOKEN_algId._ext = []
    _REP_TI_TOKEN_rep_ti_integ = BIT_STR(name='rep-ti-integ', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    REP_TI_TOKEN._cont = ASN1Dict([
        ('rep-ti-contents', _REP_TI_TOKEN_rep_ti_contents),
        ('algId', _REP_TI_TOKEN_algId),
        ('rep-ti-integ', _REP_TI_TOKEN_rep_ti_integ),
        ])
    REP_TI_TOKEN._ext = None
    
    #-----< Rep-ti-contents >-----#
    Rep_ti_contents = SEQ(name='Rep-ti-contents', mode=MODE_TYPE)
    _Rep_ti_contents_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Rep_ti_contents_tok_id._const_val = ASN1Set(rv=[512], rr=[], ev=None, er=[])
    _Rep_ti_contents_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_pvno = BIT_STR(name='pvno', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Rep_ti_contents_timestamp = TIME_UTC(name='timestamp', mode=MODE_TYPE, opt=True)
    _Rep_ti_contents_randTarg = BIT_STR(name='randTarg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_src_name = CHOICE(name='src-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _Rep_ti_contents_targ_name = CHOICE(name='targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _Rep_ti_contents_randSrc = BIT_STR(name='randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_rep_data = SEQ(name='rep-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Context-Data')))
    _Rep_ti_contents_validity = SEQ(name='validity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Validity')), opt=True)
    _Rep_ti_contents_key_estb_id = SEQ(name='key-estb-id', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Rep_ti_contents_key_estb_id_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Rep_ti_contents_key_estb_id_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Rep_ti_contents_key_estb_id_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Rep_ti_contents_key_estb_id_algorithm._const_tab = ___Rep_ti_contents_key_estb_id_algorithm_tab
    __Rep_ti_contents_key_estb_id_algorithm._const_tab_at = None
    __Rep_ti_contents_key_estb_id_algorithm._const_tab_id = 'id'
    __Rep_ti_contents_key_estb_id_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Rep_ti_contents_key_estb_id_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Rep_ti_contents_key_estb_id_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Rep_ti_contents_key_estb_id_parameters._const_tab = ___Rep_ti_contents_key_estb_id_parameters_tab
    __Rep_ti_contents_key_estb_id_parameters._const_tab_at = ('..', 'algorithm')
    __Rep_ti_contents_key_estb_id_parameters._const_tab_id = 'Type'
    _Rep_ti_contents_key_estb_id._cont = ASN1Dict([
        ('algorithm', __Rep_ti_contents_key_estb_id_algorithm),
        ('parameters', __Rep_ti_contents_key_estb_id_parameters),
        ])
    _Rep_ti_contents_key_estb_id._ext = []
    _Rep_ti_contents_key_estb_str = BIT_STR(name='key-estb-str', mode=MODE_TYPE, opt=True)
    Rep_ti_contents._cont = ASN1Dict([
        ('tok-id', _Rep_ti_contents_tok_id),
        ('context-id', _Rep_ti_contents_context_id),
        ('pvno', _Rep_ti_contents_pvno),
        ('timestamp', _Rep_ti_contents_timestamp),
        ('randTarg', _Rep_ti_contents_randTarg),
        ('src-name', _Rep_ti_contents_src_name),
        ('targ-name', _Rep_ti_contents_targ_name),
        ('randSrc', _Rep_ti_contents_randSrc),
        ('rep-data', _Rep_ti_contents_rep_data),
        ('validity', _Rep_ti_contents_validity),
        ('key-estb-id', _Rep_ti_contents_key_estb_id),
        ('key-estb-str', _Rep_ti_contents_key_estb_str),
        ])
    Rep_ti_contents._ext = None
    
    #-----< SPKM-REP-IT >-----#
    SPKM_REP_IT = SEQ(name='SPKM-REP-IT', mode=MODE_TYPE)
    _SPKM_REP_IT_responseToken = SEQ(name='responseToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REP-IT-TOKEN')))
    _SPKM_REP_IT_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SPKM_REP_IT_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SPKM_REP_IT_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_REP_IT_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_REP_IT_algId_algorithm._const_tab = ___SPKM_REP_IT_algId_algorithm_tab
    __SPKM_REP_IT_algId_algorithm._const_tab_at = None
    __SPKM_REP_IT_algId_algorithm._const_tab_id = 'id'
    __SPKM_REP_IT_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SPKM_REP_IT_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_REP_IT_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_REP_IT_algId_parameters._const_tab = ___SPKM_REP_IT_algId_parameters_tab
    __SPKM_REP_IT_algId_parameters._const_tab_at = ('..', 'algorithm')
    __SPKM_REP_IT_algId_parameters._const_tab_id = 'Type'
    _SPKM_REP_IT_algId._cont = ASN1Dict([
        ('algorithm', __SPKM_REP_IT_algId_algorithm),
        ('parameters', __SPKM_REP_IT_algId_parameters),
        ])
    _SPKM_REP_IT_algId._ext = []
    _SPKM_REP_IT_rep_it_integ = BIT_STR(name='rep-it-integ', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    SPKM_REP_IT._cont = ASN1Dict([
        ('responseToken', _SPKM_REP_IT_responseToken),
        ('algId', _SPKM_REP_IT_algId),
        ('rep-it-integ', _SPKM_REP_IT_rep_it_integ),
        ])
    SPKM_REP_IT._ext = None
    
    #-----< REP-IT-TOKEN >-----#
    REP_IT_TOKEN = SEQ(name='REP-IT-TOKEN', mode=MODE_TYPE)
    _REP_IT_TOKEN_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _REP_IT_TOKEN_tok_id._const_val = ASN1Set(rv=[768], rr=[], ev=None, er=[])
    _REP_IT_TOKEN_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_randSrc = BIT_STR(name='randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_randTarg = BIT_STR(name='randTarg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_targ_name = CHOICE(name='targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _REP_IT_TOKEN_src_name = CHOICE(name='src-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _REP_IT_TOKEN_key_estb_rep = BIT_STR(name='key-estb-rep', mode=MODE_TYPE, opt=True)
    REP_IT_TOKEN._cont = ASN1Dict([
        ('tok-id', _REP_IT_TOKEN_tok_id),
        ('context-id', _REP_IT_TOKEN_context_id),
        ('randSrc', _REP_IT_TOKEN_randSrc),
        ('randTarg', _REP_IT_TOKEN_randTarg),
        ('targ-name', _REP_IT_TOKEN_targ_name),
        ('src-name', _REP_IT_TOKEN_src_name),
        ('key-estb-rep', _REP_IT_TOKEN_key_estb_rep),
        ])
    REP_IT_TOKEN._ext = None
    
    #-----< SPKM-ERROR >-----#
    SPKM_ERROR = SEQ(name='SPKM-ERROR', mode=MODE_TYPE)
    _SPKM_ERROR_errorToken = SEQ(name='errorToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'ERROR-TOKEN')))
    _SPKM_ERROR_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SPKM_ERROR_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SPKM_ERROR_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_ERROR_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_ERROR_algId_algorithm._const_tab = ___SPKM_ERROR_algId_algorithm_tab
    __SPKM_ERROR_algId_algorithm._const_tab_at = None
    __SPKM_ERROR_algId_algorithm._const_tab_id = 'id'
    __SPKM_ERROR_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SPKM_ERROR_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_ERROR_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_ERROR_algId_parameters._const_tab = ___SPKM_ERROR_algId_parameters_tab
    __SPKM_ERROR_algId_parameters._const_tab_at = ('..', 'algorithm')
    __SPKM_ERROR_algId_parameters._const_tab_id = 'Type'
    _SPKM_ERROR_algId._cont = ASN1Dict([
        ('algorithm', __SPKM_ERROR_algId_algorithm),
        ('parameters', __SPKM_ERROR_algId_parameters),
        ])
    _SPKM_ERROR_algId._ext = []
    _SPKM_ERROR_integrity = BIT_STR(name='integrity', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    SPKM_ERROR._cont = ASN1Dict([
        ('errorToken', _SPKM_ERROR_errorToken),
        ('algId', _SPKM_ERROR_algId),
        ('integrity', _SPKM_ERROR_integrity),
        ])
    SPKM_ERROR._ext = None
    
    #-----< ERROR-TOKEN >-----#
    ERROR_TOKEN = SEQ(name='ERROR-TOKEN', mode=MODE_TYPE)
    _ERROR_TOKEN_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _ERROR_TOKEN_tok_id._const_val = ASN1Set(rv=[1024], rr=[], ev=None, er=[])
    _ERROR_TOKEN_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    ERROR_TOKEN._cont = ASN1Dict([
        ('tok-id', _ERROR_TOKEN_tok_id),
        ('context-id', _ERROR_TOKEN_context_id),
        ])
    ERROR_TOKEN._ext = None
    
    #-----< SPKM-MIC >-----#
    SPKM_MIC = SEQ(name='SPKM-MIC', mode=MODE_TYPE)
    _SPKM_MIC_mic_header = SEQ(name='mic-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Mic-Header')))
    _SPKM_MIC_int_cksum = BIT_STR(name='int-cksum', mode=MODE_TYPE)
    SPKM_MIC._cont = ASN1Dict([
        ('mic-header', _SPKM_MIC_mic_header),
        ('int-cksum', _SPKM_MIC_int_cksum),
        ])
    SPKM_MIC._ext = None
    
    #-----< Mic-Header >-----#
    Mic_Header = SEQ(name='Mic-Header', mode=MODE_TYPE)
    _Mic_Header_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Mic_Header_tok_id._const_val = ASN1Set(rv=[257], rr=[], ev=None, er=[])
    _Mic_Header_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Mic_Header_int_alg = SEQ(name='int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Mic_Header_int_alg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Mic_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Mic_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Mic_Header_int_alg_algorithm._const_tab = ___Mic_Header_int_alg_algorithm_tab
    __Mic_Header_int_alg_algorithm._const_tab_at = None
    __Mic_Header_int_alg_algorithm._const_tab_id = 'id'
    __Mic_Header_int_alg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Mic_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Mic_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Mic_Header_int_alg_parameters._const_tab = ___Mic_Header_int_alg_parameters_tab
    __Mic_Header_int_alg_parameters._const_tab_at = ('..', 'algorithm')
    __Mic_Header_int_alg_parameters._const_tab_id = 'Type'
    _Mic_Header_int_alg._cont = ASN1Dict([
        ('algorithm', __Mic_Header_int_alg_algorithm),
        ('parameters', __Mic_Header_int_alg_parameters),
        ])
    _Mic_Header_int_alg._ext = []
    _Mic_Header_snd_seq = SEQ(name='snd-seq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Mic_Header._cont = ASN1Dict([
        ('tok-id', _Mic_Header_tok_id),
        ('context-id', _Mic_Header_context_id),
        ('int-alg', _Mic_Header_int_alg),
        ('snd-seq', _Mic_Header_snd_seq),
        ])
    Mic_Header._ext = None
    
    #-----< SeqNum >-----#
    SeqNum = SEQ(name='SeqNum', mode=MODE_TYPE)
    _SeqNum_num = INT(name='num', mode=MODE_TYPE)
    _SeqNum_dir_ind = BOOL(name='dir-ind', mode=MODE_TYPE)
    SeqNum._cont = ASN1Dict([
        ('num', _SeqNum_num),
        ('dir-ind', _SeqNum_dir_ind),
        ])
    SeqNum._ext = None
    
    #-----< SPKM-WRAP >-----#
    SPKM_WRAP = SEQ(name='SPKM-WRAP', mode=MODE_TYPE)
    _SPKM_WRAP_wrap_header = SEQ(name='wrap-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Wrap-Header')))
    _SPKM_WRAP_wrap_body = SEQ(name='wrap-body', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Wrap-Body')))
    SPKM_WRAP._cont = ASN1Dict([
        ('wrap-header', _SPKM_WRAP_wrap_header),
        ('wrap-body', _SPKM_WRAP_wrap_body),
        ])
    SPKM_WRAP._ext = None
    
    #-----< Wrap-Header >-----#
    Wrap_Header = SEQ(name='Wrap-Header', mode=MODE_TYPE)
    _Wrap_Header_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Wrap_Header_tok_id._const_val = ASN1Set(rv=[513], rr=[], ev=None, er=[])
    _Wrap_Header_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Wrap_Header_int_alg = SEQ(name='int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Wrap_Header_int_alg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Wrap_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Wrap_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Wrap_Header_int_alg_algorithm._const_tab = ___Wrap_Header_int_alg_algorithm_tab
    __Wrap_Header_int_alg_algorithm._const_tab_at = None
    __Wrap_Header_int_alg_algorithm._const_tab_id = 'id'
    __Wrap_Header_int_alg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Wrap_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Wrap_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Wrap_Header_int_alg_parameters._const_tab = ___Wrap_Header_int_alg_parameters_tab
    __Wrap_Header_int_alg_parameters._const_tab_at = ('..', 'algorithm')
    __Wrap_Header_int_alg_parameters._const_tab_id = 'Type'
    _Wrap_Header_int_alg._cont = ASN1Dict([
        ('algorithm', __Wrap_Header_int_alg_algorithm),
        ('parameters', __Wrap_Header_int_alg_parameters),
        ])
    _Wrap_Header_int_alg._ext = []
    _Wrap_Header_conf_alg = CHOICE(name='conf-alg', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'Conf-Alg')), opt=True)
    _Wrap_Header_snd_seq = SEQ(name='snd-seq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Wrap_Header._cont = ASN1Dict([
        ('tok-id', _Wrap_Header_tok_id),
        ('context-id', _Wrap_Header_context_id),
        ('int-alg', _Wrap_Header_int_alg),
        ('conf-alg', _Wrap_Header_conf_alg),
        ('snd-seq', _Wrap_Header_snd_seq),
        ])
    Wrap_Header._ext = None
    
    #-----< Wrap-Body >-----#
    Wrap_Body = SEQ(name='Wrap-Body', mode=MODE_TYPE)
    _Wrap_Body_int_cksum = BIT_STR(name='int-cksum', mode=MODE_TYPE)
    _Wrap_Body_data = BIT_STR(name='data', mode=MODE_TYPE)
    Wrap_Body._cont = ASN1Dict([
        ('int-cksum', _Wrap_Body_int_cksum),
        ('data', _Wrap_Body_data),
        ])
    Wrap_Body._ext = None
    
    #-----< Conf-Alg >-----#
    Conf_Alg = CHOICE(name='Conf-Alg', mode=MODE_TYPE)
    _Conf_Alg_algId = SEQ(name='algId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Conf_Alg_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Conf_Alg_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Conf_Alg_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Conf_Alg_algId_algorithm._const_tab = ___Conf_Alg_algId_algorithm_tab
    __Conf_Alg_algId_algorithm._const_tab_at = None
    __Conf_Alg_algId_algorithm._const_tab_id = 'id'
    __Conf_Alg_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Conf_Alg_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Conf_Alg_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Conf_Alg_algId_parameters._const_tab = ___Conf_Alg_algId_parameters_tab
    __Conf_Alg_algId_parameters._const_tab_at = ('..', 'algorithm')
    __Conf_Alg_algId_parameters._const_tab_id = 'Type'
    _Conf_Alg_algId._cont = ASN1Dict([
        ('algorithm', __Conf_Alg_algId_algorithm),
        ('parameters', __Conf_Alg_algId_parameters),
        ])
    _Conf_Alg_algId._ext = []
    _Conf_Alg_null = NULL(name='null', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Conf_Alg._cont = ASN1Dict([
        ('algId', _Conf_Alg_algId),
        ('null', _Conf_Alg_null),
        ])
    Conf_Alg._ext = None
    
    #-----< SPKM-DEL >-----#
    SPKM_DEL = SEQ(name='SPKM-DEL', mode=MODE_TYPE)
    _SPKM_DEL_del_header = SEQ(name='del-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Del-Header')))
    _SPKM_DEL_int_cksum = BIT_STR(name='int-cksum', mode=MODE_TYPE)
    SPKM_DEL._cont = ASN1Dict([
        ('del-header', _SPKM_DEL_del_header),
        ('int-cksum', _SPKM_DEL_int_cksum),
        ])
    SPKM_DEL._ext = None
    
    #-----< Del-Header >-----#
    Del_Header = SEQ(name='Del-Header', mode=MODE_TYPE)
    _Del_Header_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Del_Header_tok_id._const_val = ASN1Set(rv=[769], rr=[], ev=None, er=[])
    _Del_Header_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Del_Header_int_alg = SEQ(name='int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Del_Header_int_alg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Del_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Del_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Del_Header_int_alg_algorithm._const_tab = ___Del_Header_int_alg_algorithm_tab
    __Del_Header_int_alg_algorithm._const_tab_at = None
    __Del_Header_int_alg_algorithm._const_tab_id = 'id'
    __Del_Header_int_alg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Del_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Del_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Del_Header_int_alg_parameters._const_tab = ___Del_Header_int_alg_parameters_tab
    __Del_Header_int_alg_parameters._const_tab_at = ('..', 'algorithm')
    __Del_Header_int_alg_parameters._const_tab_id = 'Type'
    _Del_Header_int_alg._cont = ASN1Dict([
        ('algorithm', __Del_Header_int_alg_algorithm),
        ('parameters', __Del_Header_int_alg_parameters),
        ])
    _Del_Header_int_alg._ext = []
    _Del_Header_snd_seq = SEQ(name='snd-seq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Del_Header._cont = ASN1Dict([
        ('tok-id', _Del_Header_tok_id),
        ('context-id', _Del_Header_context_id),
        ('int-alg', _Del_Header_int_alg),
        ('snd-seq', _Del_Header_snd_seq),
        ])
    Del_Header._ext = None
    
    #-----< MechType >-----#
    MechType = OID(name='MechType', mode=MODE_TYPE)
    
    #-----< InitialContextToken >-----#
    InitialContextToken = SEQ(name='InitialContextToken', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _InitialContextToken_thisMech = OID(name='thisMech', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'MechType')))
    _InitialContextToken_innerContextToken = CHOICE(name='innerContextToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'SPKMInnerContextToken')))
    InitialContextToken._cont = ASN1Dict([
        ('thisMech', _InitialContextToken_thisMech),
        ('innerContextToken', _InitialContextToken_innerContextToken),
        ])
    InitialContextToken._ext = None
    
    #-----< SPKMInnerContextToken >-----#
    SPKMInnerContextToken = CHOICE(name='SPKMInnerContextToken', mode=MODE_TYPE)
    _SPKMInnerContextToken_req = SEQ(name='req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REQ')))
    _SPKMInnerContextToken_rep_ti = SEQ(name='rep-ti', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-TI')))
    _SPKMInnerContextToken_rep_it = SEQ(name='rep-it', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-IT')))
    _SPKMInnerContextToken_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-ERROR')))
    _SPKMInnerContextToken_mic = SEQ(name='mic', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-MIC')))
    _SPKMInnerContextToken_wrap = SEQ(name='wrap', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-WRAP')))
    _SPKMInnerContextToken_del_ = SEQ(name='del', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-DEL')))
    SPKMInnerContextToken._cont = ASN1Dict([
        ('req', _SPKMInnerContextToken_req),
        ('rep-ti', _SPKMInnerContextToken_rep_ti),
        ('rep-it', _SPKMInnerContextToken_rep_it),
        ('error', _SPKMInnerContextToken_error),
        ('mic', _SPKMInnerContextToken_mic),
        ('wrap', _SPKMInnerContextToken_wrap),
        ('del', _SPKMInnerContextToken_del_),
        ])
    SPKMInnerContextToken._ext = None
    
    #-----< AuthorizationData >-----#
    AuthorizationData = SEQ_OF(name='AuthorizationData', mode=MODE_TYPE)
    _AuthorizationData__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AuthorizationData__item__ad_type = INT(name='ad-type', mode=MODE_TYPE)
    __AuthorizationData__item__ad_data = OCT_STR(name='ad-data', mode=MODE_TYPE)
    _AuthorizationData__item_._cont = ASN1Dict([
        ('ad-type', __AuthorizationData__item__ad_type),
        ('ad-data', __AuthorizationData__item__ad_data),
        ])
    _AuthorizationData__item_._ext = None
    AuthorizationData._cont = _AuthorizationData__item_
    
    #-----< md5-DES-CBC >-----#
    md5_DES_CBC = OID(name='md5-DES-CBC', mode=MODE_VALUE)
    md5_DES_CBC._val = (1, 3, 6, 1, 5, 3, 1)
    
    #-----< sum64-DES-CBC >-----#
    sum64_DES_CBC = OID(name='sum64-DES-CBC', mode=MODE_VALUE)
    sum64_DES_CBC._val = (1, 3, 6, 1, 5, 3, 2)
    
    #-----< spkm-1 >-----#
    spkm_1 = OID(name='spkm-1', mode=MODE_VALUE)
    spkm_1._val = (1, 3, 6, 1, 5, 5, 1, 1)
    
    #-----< spkm-2 >-----#
    spkm_2 = OID(name='spkm-2', mode=MODE_VALUE)
    spkm_2._val = (1, 3, 6, 1, 5, 5, 1, 2)
    
    _all_ = [
        _SPKM_REQ_requestToken,
        _SPKM_REQ_certif_data,
        _SPKM_REQ_auth_data,
        SPKM_REQ,
        _CertificationData_certificationPath,
        _CertificationData_certificateRevocationList,
        CertificationData,
        _CertificationPath_userKeyId,
        _CertificationPath_userCertif,
        _CertificationPath_verifKeyId,
        _CertificationPath_userVerifCertif,
        __CertificationPath_theCACertificates__item_,
        _CertificationPath_theCACertificates,
        CertificationPath,
        _REQ_TOKEN_req_contents,
        ___REQ_TOKEN_algId_algorithm_tab,
        __REQ_TOKEN_algId_algorithm,
        ___REQ_TOKEN_algId_parameters_tab,
        __REQ_TOKEN_algId_parameters,
        _REQ_TOKEN_algId,
        _REQ_TOKEN_req_integrity,
        REQ_TOKEN,
        Integrity,
        _Req_contents_tok_id,
        _Req_contents_context_id,
        _Req_contents_pvno,
        _Req_contents_timestamp,
        _Req_contents_randSrc,
        _Req_contents_targ_name,
        _Req_contents_src_name,
        _Req_contents_req_data,
        _Req_contents_validity,
        _Req_contents_key_estb_set,
        _Req_contents_key_estb_req,
        _Req_contents_key_src_bind,
        Req_contents,
        Random_Integer,
        _Context_Data_channelId,
        _Context_Data_seq_number,
        _Context_Data_options,
        _Context_Data_conf_alg,
        _Context_Data_intg_alg,
        _Context_Data_owf_alg,
        Context_Data,
        ChannelId,
        Options,
        ____Conf_Algs_algs__item__algorithm_tab,
        ___Conf_Algs_algs__item__algorithm,
        ____Conf_Algs_algs__item__parameters_tab,
        ___Conf_Algs_algs__item__parameters,
        __Conf_Algs_algs__item_,
        _Conf_Algs_algs,
        _Conf_Algs_null,
        Conf_Algs,
        ___Intg_Algs__item__algorithm_tab,
        __Intg_Algs__item__algorithm,
        ___Intg_Algs__item__parameters_tab,
        __Intg_Algs__item__parameters,
        _Intg_Algs__item_,
        Intg_Algs,
        ___OWF_Algs__item__algorithm_tab,
        __OWF_Algs__item__algorithm,
        ___OWF_Algs__item__parameters_tab,
        __OWF_Algs__item__parameters,
        _OWF_Algs__item_,
        OWF_Algs,
        ___Key_Estb_Algs__item__algorithm_tab,
        __Key_Estb_Algs__item__algorithm,
        ___Key_Estb_Algs__item__parameters_tab,
        __Key_Estb_Algs__item__parameters,
        _Key_Estb_Algs__item_,
        Key_Estb_Algs,
        _SPKM_REP_TI_responseToken,
        _SPKM_REP_TI_certif_data,
        SPKM_REP_TI,
        _REP_TI_TOKEN_rep_ti_contents,
        ___REP_TI_TOKEN_algId_algorithm_tab,
        __REP_TI_TOKEN_algId_algorithm,
        ___REP_TI_TOKEN_algId_parameters_tab,
        __REP_TI_TOKEN_algId_parameters,
        _REP_TI_TOKEN_algId,
        _REP_TI_TOKEN_rep_ti_integ,
        REP_TI_TOKEN,
        _Rep_ti_contents_tok_id,
        _Rep_ti_contents_context_id,
        _Rep_ti_contents_pvno,
        _Rep_ti_contents_timestamp,
        _Rep_ti_contents_randTarg,
        _Rep_ti_contents_src_name,
        _Rep_ti_contents_targ_name,
        _Rep_ti_contents_randSrc,
        _Rep_ti_contents_rep_data,
        _Rep_ti_contents_validity,
        ___Rep_ti_contents_key_estb_id_algorithm_tab,
        __Rep_ti_contents_key_estb_id_algorithm,
        ___Rep_ti_contents_key_estb_id_parameters_tab,
        __Rep_ti_contents_key_estb_id_parameters,
        _Rep_ti_contents_key_estb_id,
        _Rep_ti_contents_key_estb_str,
        Rep_ti_contents,
        _SPKM_REP_IT_responseToken,
        ___SPKM_REP_IT_algId_algorithm_tab,
        __SPKM_REP_IT_algId_algorithm,
        ___SPKM_REP_IT_algId_parameters_tab,
        __SPKM_REP_IT_algId_parameters,
        _SPKM_REP_IT_algId,
        _SPKM_REP_IT_rep_it_integ,
        SPKM_REP_IT,
        _REP_IT_TOKEN_tok_id,
        _REP_IT_TOKEN_context_id,
        _REP_IT_TOKEN_randSrc,
        _REP_IT_TOKEN_randTarg,
        _REP_IT_TOKEN_targ_name,
        _REP_IT_TOKEN_src_name,
        _REP_IT_TOKEN_key_estb_rep,
        REP_IT_TOKEN,
        _SPKM_ERROR_errorToken,
        ___SPKM_ERROR_algId_algorithm_tab,
        __SPKM_ERROR_algId_algorithm,
        ___SPKM_ERROR_algId_parameters_tab,
        __SPKM_ERROR_algId_parameters,
        _SPKM_ERROR_algId,
        _SPKM_ERROR_integrity,
        SPKM_ERROR,
        _ERROR_TOKEN_tok_id,
        _ERROR_TOKEN_context_id,
        ERROR_TOKEN,
        _SPKM_MIC_mic_header,
        _SPKM_MIC_int_cksum,
        SPKM_MIC,
        _Mic_Header_tok_id,
        _Mic_Header_context_id,
        ___Mic_Header_int_alg_algorithm_tab,
        __Mic_Header_int_alg_algorithm,
        ___Mic_Header_int_alg_parameters_tab,
        __Mic_Header_int_alg_parameters,
        _Mic_Header_int_alg,
        _Mic_Header_snd_seq,
        Mic_Header,
        _SeqNum_num,
        _SeqNum_dir_ind,
        SeqNum,
        _SPKM_WRAP_wrap_header,
        _SPKM_WRAP_wrap_body,
        SPKM_WRAP,
        _Wrap_Header_tok_id,
        _Wrap_Header_context_id,
        ___Wrap_Header_int_alg_algorithm_tab,
        __Wrap_Header_int_alg_algorithm,
        ___Wrap_Header_int_alg_parameters_tab,
        __Wrap_Header_int_alg_parameters,
        _Wrap_Header_int_alg,
        _Wrap_Header_conf_alg,
        _Wrap_Header_snd_seq,
        Wrap_Header,
        _Wrap_Body_int_cksum,
        _Wrap_Body_data,
        Wrap_Body,
        ___Conf_Alg_algId_algorithm_tab,
        __Conf_Alg_algId_algorithm,
        ___Conf_Alg_algId_parameters_tab,
        __Conf_Alg_algId_parameters,
        _Conf_Alg_algId,
        _Conf_Alg_null,
        Conf_Alg,
        _SPKM_DEL_del_header,
        _SPKM_DEL_int_cksum,
        SPKM_DEL,
        _Del_Header_tok_id,
        _Del_Header_context_id,
        ___Del_Header_int_alg_algorithm_tab,
        __Del_Header_int_alg_algorithm,
        ___Del_Header_int_alg_parameters_tab,
        __Del_Header_int_alg_parameters,
        _Del_Header_int_alg,
        _Del_Header_snd_seq,
        Del_Header,
        MechType,
        _InitialContextToken_thisMech,
        _InitialContextToken_innerContextToken,
        InitialContextToken,
        _SPKMInnerContextToken_req,
        _SPKMInnerContextToken_rep_ti,
        _SPKMInnerContextToken_rep_it,
        _SPKMInnerContextToken_error,
        _SPKMInnerContextToken_mic,
        _SPKMInnerContextToken_wrap,
        _SPKMInnerContextToken_del_,
        SPKMInnerContextToken,
        __AuthorizationData__item__ad_type,
        __AuthorizationData__item__ad_data,
        _AuthorizationData__item_,
        AuthorizationData,
        md5_DES_CBC,
        sum64_DES_CBC,
        spkm_1,
        spkm_2,
    ]

class SS_DataTypes:

    _name_  = 'SS-DataTypes'
    _oid_   = [0, 4, 0, 0, 2, 3, 2, 12]
    
    _obj_ = [
        'SS-UserData',
        'NotifySS-Arg',
        'Multicall-Indicator',
        'ForwardChargeAdviceArg',
        'SS-Notification',
        'ChargingInformation',
        'E1',
        'max10TimesUnitsPerTime',
        'E2',
        'max10TimesTimeInterval',
        'E3',
        'max100TimesScalingFactor',
        'E4',
        'max10TimesIncrement',
        'E5',
        'max10TimesIncrementPerDataInterval',
        'E6',
        'maxNumberOfSegmentsPerDataInterval',
        'E7',
        'max10TimesInitialTime',
        'CallOnHold-Indicator',
        'ForwardCUG-InfoArg',
        'ECT-Indicator',
        'ECT-CallState',
        'NameIndicator',
        'Name',
        'NameSet',
        'RDN',
        'RemotePartyNumber',
        'AccessRegisterCCEntryArg',
        'CallDeflectionArg',
        'UserUserServiceArg',
        'UUS-Service',
        'LocationNotificationArg',
        'LocationNotificationRes',
        'VerificationResponse',
        'LCS-MOLRArg',
        'MOLR-Type',
        'LocationMethod',
        'GPSAssistanceData',
        'GANSSAssistanceData',
        'TerminationCause',
        'MultiplePositioningProtocolPDUs',
        'PositioningProtocolPDU',
        'maxNumLPPMsg',
        'LCS-MOLRRes',
        'DecipheringKeys',
        'LCS-AreaEventRequestArg',
        'LCS-AreaEventReportArg',
        'LCS-AreaEventCancellationArg',
        'LCS-PeriodicLocationRequestArg',
        'LCS-PeriodicLocationRequestRes',
        'LCS-LocationUpdateArg',
        'LCS-LocationUpdateRes',
        'LCS-PeriodicLocationCancellationArg',
        ]
    _type_ = [
        'SS-UserData',
        'NotifySS-Arg',
        'Multicall-Indicator',
        'ForwardChargeAdviceArg',
        'SS-Notification',
        'ChargingInformation',
        'E1',
        'E2',
        'E3',
        'E4',
        'E5',
        'E6',
        'E7',
        'CallOnHold-Indicator',
        'ForwardCUG-InfoArg',
        'ECT-Indicator',
        'ECT-CallState',
        'NameIndicator',
        'Name',
        'NameSet',
        'RDN',
        'RemotePartyNumber',
        'AccessRegisterCCEntryArg',
        'CallDeflectionArg',
        'UserUserServiceArg',
        'UUS-Service',
        'LocationNotificationArg',
        'LocationNotificationRes',
        'VerificationResponse',
        'LCS-MOLRArg',
        'MOLR-Type',
        'LocationMethod',
        'GPSAssistanceData',
        'GANSSAssistanceData',
        'TerminationCause',
        'MultiplePositioningProtocolPDUs',
        'PositioningProtocolPDU',
        'LCS-MOLRRes',
        'DecipheringKeys',
        'LCS-AreaEventRequestArg',
        'LCS-AreaEventReportArg',
        'LCS-AreaEventCancellationArg',
        'LCS-PeriodicLocationRequestArg',
        'LCS-PeriodicLocationRequestRes',
        'LCS-LocationUpdateArg',
        'LCS-LocationUpdateRes',
        'LCS-PeriodicLocationCancellationArg',
        ]
    _set_ = [
        ]
    _val_ = [
        'max10TimesUnitsPerTime',
        'max10TimesTimeInterval',
        'max100TimesScalingFactor',
        'max10TimesIncrement',
        'max10TimesIncrementPerDataInterval',
        'maxNumberOfSegmentsPerDataInterval',
        'max10TimesInitialTime',
        'maxNumLPPMsg',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SS-UserData >-----#
    SS_UserData = STR_IA5(name='SS-UserData', mode=MODE_TYPE)
    SS_UserData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    
    #-----< NotifySS-Arg >-----#
    NotifySS_Arg = SEQ(name='NotifySS-Arg', mode=MODE_TYPE)
    _NotifySS_Arg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _NotifySS_Arg_ss_Status = OCT_STR(name='ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _NotifySS_Arg_ss_Notification = OCT_STR(name='ss-Notification', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'SS-Notification')), opt=True)
    _NotifySS_Arg_callIsWaiting_Indicator = NULL(name='callIsWaiting-Indicator', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NotifySS_Arg_callOnHold_Indicator = ENUM(name='callOnHold-Indicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'CallOnHold-Indicator')), opt=True)
    _NotifySS_Arg_mpty_Indicator = NULL(name='mpty-Indicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NotifySS_Arg_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _NotifySS_Arg_clirSuppressionRejected = NULL(name='clirSuppressionRejected', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NotifySS_Arg_ect_Indicator = SEQ(name='ect-Indicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'ECT-Indicator')), opt=True)
    _NotifySS_Arg_nameIndicator = SEQ(name='nameIndicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'NameIndicator')), opt=True)
    _NotifySS_Arg_ccbs_Feature = SEQ(name='ccbs-Feature', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')), opt=True)
    _NotifySS_Arg_alertingPattern = OCT_STR(name='alertingPattern', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _NotifySS_Arg_multicall_Indicator = ENUM(name='multicall-Indicator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'Multicall-Indicator')), opt=True)
    NotifySS_Arg._cont = ASN1Dict([
        ('ss-Code', _NotifySS_Arg_ss_Code),
        ('ss-Status', _NotifySS_Arg_ss_Status),
        ('ss-Notification', _NotifySS_Arg_ss_Notification),
        ('callIsWaiting-Indicator', _NotifySS_Arg_callIsWaiting_Indicator),
        ('callOnHold-Indicator', _NotifySS_Arg_callOnHold_Indicator),
        ('mpty-Indicator', _NotifySS_Arg_mpty_Indicator),
        ('cug-Index', _NotifySS_Arg_cug_Index),
        ('clirSuppressionRejected', _NotifySS_Arg_clirSuppressionRejected),
        ('ect-Indicator', _NotifySS_Arg_ect_Indicator),
        ('nameIndicator', _NotifySS_Arg_nameIndicator),
        ('ccbs-Feature', _NotifySS_Arg_ccbs_Feature),
        ('alertingPattern', _NotifySS_Arg_alertingPattern),
        ('multicall-Indicator', _NotifySS_Arg_multicall_Indicator),
        ])
    NotifySS_Arg._ext = ['ect-Indicator', 'nameIndicator', 'ccbs-Feature', 'alertingPattern', 'multicall-Indicator']
    
    #-----< Multicall-Indicator >-----#
    Multicall_Indicator = ENUM(name='Multicall-Indicator', mode=MODE_TYPE)
    Multicall_Indicator._cont = ASN1Dict([('nbr-SNexceeded', 0), ('nbr-Userexceeded', 1)])
    Multicall_Indicator._ext = None
    
    #-----< ForwardChargeAdviceArg >-----#
    ForwardChargeAdviceArg = SEQ(name='ForwardChargeAdviceArg', mode=MODE_TYPE)
    _ForwardChargeAdviceArg_ss_Code = OCT_STR(name='ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ForwardChargeAdviceArg_chargingInformation = SEQ(name='chargingInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'ChargingInformation')))
    ForwardChargeAdviceArg._cont = ASN1Dict([
        ('ss-Code', _ForwardChargeAdviceArg_ss_Code),
        ('chargingInformation', _ForwardChargeAdviceArg_chargingInformation),
        ])
    ForwardChargeAdviceArg._ext = []
    
    #-----< SS-Notification >-----#
    SS_Notification = OCT_STR(name='SS-Notification', mode=MODE_TYPE)
    SS_Notification._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargingInformation >-----#
    ChargingInformation = SEQ(name='ChargingInformation', mode=MODE_TYPE)
    _ChargingInformation_e1 = INT(name='e1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E1')), opt=True)
    _ChargingInformation_e2 = INT(name='e2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E2')), opt=True)
    _ChargingInformation_e3 = INT(name='e3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E3')), opt=True)
    _ChargingInformation_e4 = INT(name='e4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E4')), opt=True)
    _ChargingInformation_e5 = INT(name='e5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E5')), opt=True)
    _ChargingInformation_e6 = INT(name='e6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E6')), opt=True)
    _ChargingInformation_e7 = INT(name='e7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E7')), opt=True)
    ChargingInformation._cont = ASN1Dict([
        ('e1', _ChargingInformation_e1),
        ('e2', _ChargingInformation_e2),
        ('e3', _ChargingInformation_e3),
        ('e4', _ChargingInformation_e4),
        ('e5', _ChargingInformation_e5),
        ('e6', _ChargingInformation_e6),
        ('e7', _ChargingInformation_e7),
        ])
    ChargingInformation._ext = []
    
    #-----< E1 >-----#
    E1 = INT(name='E1', mode=MODE_TYPE)
    E1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesUnitsPerTime >-----#
    max10TimesUnitsPerTime = INT(name='max10TimesUnitsPerTime', mode=MODE_VALUE)
    max10TimesUnitsPerTime._val = 8191
    
    #-----< E2 >-----#
    E2 = INT(name='E2', mode=MODE_TYPE)
    E2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesTimeInterval >-----#
    max10TimesTimeInterval = INT(name='max10TimesTimeInterval', mode=MODE_VALUE)
    max10TimesTimeInterval._val = 8191
    
    #-----< E3 >-----#
    E3 = INT(name='E3', mode=MODE_TYPE)
    E3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max100TimesScalingFactor >-----#
    max100TimesScalingFactor = INT(name='max100TimesScalingFactor', mode=MODE_VALUE)
    max100TimesScalingFactor._val = 8191
    
    #-----< E4 >-----#
    E4 = INT(name='E4', mode=MODE_TYPE)
    E4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesIncrement >-----#
    max10TimesIncrement = INT(name='max10TimesIncrement', mode=MODE_VALUE)
    max10TimesIncrement._val = 8191
    
    #-----< E5 >-----#
    E5 = INT(name='E5', mode=MODE_TYPE)
    E5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesIncrementPerDataInterval >-----#
    max10TimesIncrementPerDataInterval = INT(name='max10TimesIncrementPerDataInterval', mode=MODE_VALUE)
    max10TimesIncrementPerDataInterval._val = 8191
    
    #-----< E6 >-----#
    E6 = INT(name='E6', mode=MODE_TYPE)
    E6._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< maxNumberOfSegmentsPerDataInterval >-----#
    maxNumberOfSegmentsPerDataInterval = INT(name='maxNumberOfSegmentsPerDataInterval', mode=MODE_VALUE)
    maxNumberOfSegmentsPerDataInterval._val = 8191
    
    #-----< E7 >-----#
    E7 = INT(name='E7', mode=MODE_TYPE)
    E7._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesInitialTime >-----#
    max10TimesInitialTime = INT(name='max10TimesInitialTime', mode=MODE_VALUE)
    max10TimesInitialTime._val = 8191
    
    #-----< CallOnHold-Indicator >-----#
    CallOnHold_Indicator = ENUM(name='CallOnHold-Indicator', mode=MODE_TYPE)
    CallOnHold_Indicator._cont = ASN1Dict([('callRetrieved', 0), ('callOnHold', 1)])
    CallOnHold_Indicator._ext = None
    
    #-----< ForwardCUG-InfoArg >-----#
    ForwardCUG_InfoArg = SEQ(name='ForwardCUG-InfoArg', mode=MODE_TYPE)
    _ForwardCUG_InfoArg_cug_Index = INT(name='cug-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _ForwardCUG_InfoArg_suppressPrefCUG = NULL(name='suppressPrefCUG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardCUG_InfoArg_suppressOA = NULL(name='suppressOA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ForwardCUG_InfoArg._cont = ASN1Dict([
        ('cug-Index', _ForwardCUG_InfoArg_cug_Index),
        ('suppressPrefCUG', _ForwardCUG_InfoArg_suppressPrefCUG),
        ('suppressOA', _ForwardCUG_InfoArg_suppressOA),
        ])
    ForwardCUG_InfoArg._ext = []
    
    #-----< ECT-Indicator >-----#
    ECT_Indicator = SEQ(name='ECT-Indicator', mode=MODE_TYPE)
    _ECT_Indicator_ect_CallState = ENUM(name='ect-CallState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'ECT-CallState')))
    _ECT_Indicator_rdn = CHOICE(name='rdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'RDN')), opt=True)
    ECT_Indicator._cont = ASN1Dict([
        ('ect-CallState', _ECT_Indicator_ect_CallState),
        ('rdn', _ECT_Indicator_rdn),
        ])
    ECT_Indicator._ext = []
    
    #-----< ECT-CallState >-----#
    ECT_CallState = ENUM(name='ECT-CallState', mode=MODE_TYPE)
    ECT_CallState._cont = ASN1Dict([('alerting', 0), ('active', 1)])
    ECT_CallState._ext = None
    
    #-----< NameIndicator >-----#
    NameIndicator = SEQ(name='NameIndicator', mode=MODE_TYPE)
    _NameIndicator_callingName = CHOICE(name='callingName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'Name')), opt=True)
    NameIndicator._cont = ASN1Dict([
        ('callingName', _NameIndicator_callingName),
        ])
    NameIndicator._ext = []
    
    #-----< Name >-----#
    Name = CHOICE(name='Name', mode=MODE_TYPE)
    _Name_namePresentationAllowed = SEQ(name='namePresentationAllowed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'NameSet')))
    _Name_presentationRestricted = NULL(name='presentationRestricted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Name_nameUnavailable = NULL(name='nameUnavailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Name_namePresentationRestricted = SEQ(name='namePresentationRestricted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'NameSet')))
    Name._cont = ASN1Dict([
        ('namePresentationAllowed', _Name_namePresentationAllowed),
        ('presentationRestricted', _Name_presentationRestricted),
        ('nameUnavailable', _Name_nameUnavailable),
        ('namePresentationRestricted', _Name_namePresentationRestricted),
        ])
    Name._ext = None
    
    #-----< NameSet >-----#
    NameSet = SEQ(name='NameSet', mode=MODE_TYPE)
    _NameSet_dataCodingScheme = OCT_STR(name='dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _NameSet_lengthInCharacters = INT(name='lengthInCharacters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NameSet_nameString = OCT_STR(name='nameString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    NameSet._cont = ASN1Dict([
        ('dataCodingScheme', _NameSet_dataCodingScheme),
        ('lengthInCharacters', _NameSet_lengthInCharacters),
        ('nameString', _NameSet_nameString),
        ])
    NameSet._ext = []
    
    #-----< RDN >-----#
    RDN = CHOICE(name='RDN', mode=MODE_TYPE)
    _RDN_presentationAllowedAddress = SEQ(name='presentationAllowedAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'RemotePartyNumber')))
    _RDN_presentationRestricted = NULL(name='presentationRestricted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RDN_numberNotAvailableDueToInterworking = NULL(name='numberNotAvailableDueToInterworking', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RDN_presentationRestrictedAddress = SEQ(name='presentationRestrictedAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'RemotePartyNumber')))
    RDN._cont = ASN1Dict([
        ('presentationAllowedAddress', _RDN_presentationAllowedAddress),
        ('presentationRestricted', _RDN_presentationRestricted),
        ('numberNotAvailableDueToInterworking', _RDN_numberNotAvailableDueToInterworking),
        ('presentationRestrictedAddress', _RDN_presentationRestrictedAddress),
        ])
    RDN._ext = None
    
    #-----< RemotePartyNumber >-----#
    RemotePartyNumber = SEQ(name='RemotePartyNumber', mode=MODE_TYPE)
    _RemotePartyNumber_partyNumber = OCT_STR(name='partyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RemotePartyNumber_partyNumberSubaddress = OCT_STR(name='partyNumberSubaddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    RemotePartyNumber._cont = ASN1Dict([
        ('partyNumber', _RemotePartyNumber_partyNumber),
        ('partyNumberSubaddress', _RemotePartyNumber_partyNumberSubaddress),
        ])
    RemotePartyNumber._ext = []
    
    #-----< AccessRegisterCCEntryArg >-----#
    AccessRegisterCCEntryArg = SEQ(name='AccessRegisterCCEntryArg', mode=MODE_TYPE)
    AccessRegisterCCEntryArg._cont = ASN1Dict([
        ])
    AccessRegisterCCEntryArg._ext = []
    
    #-----< CallDeflectionArg >-----#
    CallDeflectionArg = SEQ(name='CallDeflectionArg', mode=MODE_TYPE)
    _CallDeflectionArg_deflectedToNumber = OCT_STR(name='deflectedToNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _CallDeflectionArg_deflectedToSubaddress = OCT_STR(name='deflectedToSubaddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    CallDeflectionArg._cont = ASN1Dict([
        ('deflectedToNumber', _CallDeflectionArg_deflectedToNumber),
        ('deflectedToSubaddress', _CallDeflectionArg_deflectedToSubaddress),
        ])
    CallDeflectionArg._ext = []
    
    #-----< UserUserServiceArg >-----#
    UserUserServiceArg = SEQ(name='UserUserServiceArg', mode=MODE_TYPE)
    _UserUserServiceArg_uUS_Service = ENUM(name='uUS-Service', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'UUS-Service')))
    _UserUserServiceArg_uUS_Required = BOOL(name='uUS-Required', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    UserUserServiceArg._cont = ASN1Dict([
        ('uUS-Service', _UserUserServiceArg_uUS_Service),
        ('uUS-Required', _UserUserServiceArg_uUS_Required),
        ])
    UserUserServiceArg._ext = []
    
    #-----< UUS-Service >-----#
    UUS_Service = ENUM(name='UUS-Service', mode=MODE_TYPE)
    UUS_Service._cont = ASN1Dict([('uUS1', 1), ('uUS2', 2), ('uUS3', 3)])
    UUS_Service._ext = []
    
    #-----< LocationNotificationArg >-----#
    LocationNotificationArg = SEQ(name='LocationNotificationArg', mode=MODE_TYPE)
    _LocationNotificationArg_notificationType = ENUM(name='notificationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')))
    _LocationNotificationArg_locationType = SEQ(name='locationType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LocationNotificationArg_lcsClientExternalID = SEQ(name='lcsClientExternalID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LocationNotificationArg_lcsClientName = SEQ(name='lcsClientName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientName')), opt=True)
    _LocationNotificationArg_lcsRequestorID = SEQ(name='lcsRequestorID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSRequestorID')), opt=True)
    _LocationNotificationArg_lcsCodeword = SEQ(name='lcsCodeword', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSCodeword')), opt=True)
    _LocationNotificationArg_lcsServiceTypeID = INT(name='lcsServiceTypeID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    LocationNotificationArg._cont = ASN1Dict([
        ('notificationType', _LocationNotificationArg_notificationType),
        ('locationType', _LocationNotificationArg_locationType),
        ('lcsClientExternalID', _LocationNotificationArg_lcsClientExternalID),
        ('lcsClientName', _LocationNotificationArg_lcsClientName),
        ('lcsRequestorID', _LocationNotificationArg_lcsRequestorID),
        ('lcsCodeword', _LocationNotificationArg_lcsCodeword),
        ('lcsServiceTypeID', _LocationNotificationArg_lcsServiceTypeID),
        ])
    LocationNotificationArg._ext = ['lcsRequestorID', 'lcsCodeword', 'lcsServiceTypeID']
    
    #-----< LocationNotificationRes >-----#
    LocationNotificationRes = SEQ(name='LocationNotificationRes', mode=MODE_TYPE)
    _LocationNotificationRes_verificationResponse = ENUM(name='verificationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'VerificationResponse')), opt=True)
    LocationNotificationRes._cont = ASN1Dict([
        ('verificationResponse', _LocationNotificationRes_verificationResponse),
        ])
    LocationNotificationRes._ext = []
    
    #-----< VerificationResponse >-----#
    VerificationResponse = ENUM(name='VerificationResponse', mode=MODE_TYPE)
    VerificationResponse._cont = ASN1Dict([('permissionDenied', 0), ('permissionGranted', 1)])
    VerificationResponse._ext = []
    
    #-----< LCS-MOLRArg >-----#
    LCS_MOLRArg = SEQ(name='LCS-MOLRArg', mode=MODE_TYPE)
    _LCS_MOLRArg_molr_Type = ENUM(name='molr-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'MOLR-Type')))
    _LCS_MOLRArg_locationMethod = ENUM(name='locationMethod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'LocationMethod')), opt=True)
    _LCS_MOLRArg_lcs_QoS = SEQ(name='lcs-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-QoS')), opt=True)
    _LCS_MOLRArg_lcsClientExternalID = SEQ(name='lcsClientExternalID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LCS_MOLRArg_mlc_Number = OCT_STR(name='mlc-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LCS_MOLRArg_gpsAssistanceData = OCT_STR(name='gpsAssistanceData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'GPSAssistanceData')), opt=True)
    _LCS_MOLRArg_supportedGADShapes = BIT_STR(name='supportedGADShapes', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SupportedGADShapes')), opt=True)
    _LCS_MOLRArg_lcsServiceTypeID = INT(name='lcsServiceTypeID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    _LCS_MOLRArg_ageOfLocationInfo = INT(name='ageOfLocationInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LCS_MOLRArg_locationType = SEQ(name='locationType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')), opt=True)
    _LCS_MOLRArg_pseudonymIndicator = NULL(name='pseudonymIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRArg_h_gmlc_address = OCT_STR(name='h-gmlc-address', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _LCS_MOLRArg_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _LCS_MOLRArg_velocityEstimate = OCT_STR(name='velocityEstimate', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _LCS_MOLRArg_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _LCS_MOLRArg_periodicLDRInfo = SEQ(name='periodicLDRInfo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')), opt=True)
    _LCS_MOLRArg_locationUpdateRequest = NULL(name='locationUpdateRequest', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRArg_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SequenceNumber')), opt=True)
    _LCS_MOLRArg_terminationCause = ENUM(name='terminationCause', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'TerminationCause')), opt=True)
    _LCS_MOLRArg_mo_lrShortCircuit = NULL(name='mo-lrShortCircuit', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRArg_ganssAssistanceData = OCT_STR(name='ganssAssistanceData', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'GANSSAssistanceData')), opt=True)
    _LCS_MOLRArg_multiplePositioningProtocolPDUs = SEQ_OF(name='multiplePositioningProtocolPDUs', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'MultiplePositioningProtocolPDUs')), opt=True)
    LCS_MOLRArg._cont = ASN1Dict([
        ('molr-Type', _LCS_MOLRArg_molr_Type),
        ('locationMethod', _LCS_MOLRArg_locationMethod),
        ('lcs-QoS', _LCS_MOLRArg_lcs_QoS),
        ('lcsClientExternalID', _LCS_MOLRArg_lcsClientExternalID),
        ('mlc-Number', _LCS_MOLRArg_mlc_Number),
        ('gpsAssistanceData', _LCS_MOLRArg_gpsAssistanceData),
        ('supportedGADShapes', _LCS_MOLRArg_supportedGADShapes),
        ('lcsServiceTypeID', _LCS_MOLRArg_lcsServiceTypeID),
        ('ageOfLocationInfo', _LCS_MOLRArg_ageOfLocationInfo),
        ('locationType', _LCS_MOLRArg_locationType),
        ('pseudonymIndicator', _LCS_MOLRArg_pseudonymIndicator),
        ('h-gmlc-address', _LCS_MOLRArg_h_gmlc_address),
        ('locationEstimate', _LCS_MOLRArg_locationEstimate),
        ('velocityEstimate', _LCS_MOLRArg_velocityEstimate),
        ('referenceNumber', _LCS_MOLRArg_referenceNumber),
        ('periodicLDRInfo', _LCS_MOLRArg_periodicLDRInfo),
        ('locationUpdateRequest', _LCS_MOLRArg_locationUpdateRequest),
        ('sequenceNumber', _LCS_MOLRArg_sequenceNumber),
        ('terminationCause', _LCS_MOLRArg_terminationCause),
        ('mo-lrShortCircuit', _LCS_MOLRArg_mo_lrShortCircuit),
        ('ganssAssistanceData', _LCS_MOLRArg_ganssAssistanceData),
        ('multiplePositioningProtocolPDUs', _LCS_MOLRArg_multiplePositioningProtocolPDUs),
        ])
    LCS_MOLRArg._ext = ['supportedGADShapes', 'lcsServiceTypeID', 'ageOfLocationInfo', 'locationType', 'pseudonymIndicator', 'h-gmlc-address', 'locationEstimate', 'velocityEstimate', 'referenceNumber', 'periodicLDRInfo', 'locationUpdateRequest', 'sequenceNumber', 'terminationCause', 'mo-lrShortCircuit', 'ganssAssistanceData', 'multiplePositioningProtocolPDUs']
    
    #-----< MOLR-Type >-----#
    MOLR_Type = ENUM(name='MOLR-Type', mode=MODE_TYPE)
    MOLR_Type._cont = ASN1Dict([('locationEstimate', 0), ('assistanceData', 1), ('deCipheringKeys', 2), ('deferredMo-lrTTTPInitiation', 3), ('deferredMo-lrSelfLocationInitiation', 4), ('deferredMt-lrOrmo-lrTTTPLocationEstimate', 5), ('deferredMt-lrOrmo-lrCancellation', 6)])
    MOLR_Type._ext = ['deferredMo-lrTTTPInitiation', 'deferredMo-lrSelfLocationInitiation', 'deferredMt-lrOrmo-lrTTTPLocationEstimate', 'deferredMt-lrOrmo-lrCancellation']
    
    #-----< LocationMethod >-----#
    LocationMethod = ENUM(name='LocationMethod', mode=MODE_TYPE)
    LocationMethod._cont = ASN1Dict([('msBasedEOTD', 0), ('msAssistedEOTD', 1), ('assistedGPS', 2), ('msBasedOTDOA', 3), ('assistedGANSS', 4), ('assistedGPSandGANSS', 5)])
    LocationMethod._ext = ['msBasedOTDOA', 'assistedGANSS', 'assistedGPSandGANSS']
    
    #-----< GPSAssistanceData >-----#
    GPSAssistanceData = OCT_STR(name='GPSAssistanceData', mode=MODE_TYPE)
    GPSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=38)], ev=None, er=[])
    
    #-----< GANSSAssistanceData >-----#
    GANSSAssistanceData = OCT_STR(name='GANSSAssistanceData', mode=MODE_TYPE)
    GANSSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    
    #-----< TerminationCause >-----#
    TerminationCause = ENUM(name='TerminationCause', mode=MODE_TYPE)
    TerminationCause._cont = ASN1Dict([('subscriberTermination', 0), ('uETermination', 1)])
    TerminationCause._ext = []
    
    #-----< MultiplePositioningProtocolPDUs >-----#
    MultiplePositioningProtocolPDUs = SEQ_OF(name='MultiplePositioningProtocolPDUs', mode=MODE_TYPE)
    _MultiplePositioningProtocolPDUs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SS-DataTypes', 'PositioningProtocolPDU')))
    MultiplePositioningProtocolPDUs._cont = _MultiplePositioningProtocolPDUs__item_
    MultiplePositioningProtocolPDUs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< PositioningProtocolPDU >-----#
    PositioningProtocolPDU = OCT_STR(name='PositioningProtocolPDU', mode=MODE_TYPE)
    
    #-----< maxNumLPPMsg >-----#
    maxNumLPPMsg = INT(name='maxNumLPPMsg', mode=MODE_VALUE)
    maxNumLPPMsg._val = 3
    
    #-----< LCS-MOLRRes >-----#
    LCS_MOLRRes = SEQ(name='LCS-MOLRRes', mode=MODE_TYPE)
    _LCS_MOLRRes_locationEstimate = OCT_STR(name='locationEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _LCS_MOLRRes_decipheringKeys = OCT_STR(name='decipheringKeys', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'DecipheringKeys')), opt=True)
    _LCS_MOLRRes_add_LocationEstimate = OCT_STR(name='add-LocationEstimate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _LCS_MOLRRes_velocityEstimate = OCT_STR(name='velocityEstimate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _LCS_MOLRRes_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _LCS_MOLRRes_h_gmlc_address = OCT_STR(name='h-gmlc-address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _LCS_MOLRRes_mo_lrShortCircuit = NULL(name='mo-lrShortCircuit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRRes_reportingPLMNList = SEQ(name='reportingPLMNList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    LCS_MOLRRes._cont = ASN1Dict([
        ('locationEstimate', _LCS_MOLRRes_locationEstimate),
        ('decipheringKeys', _LCS_MOLRRes_decipheringKeys),
        ('add-LocationEstimate', _LCS_MOLRRes_add_LocationEstimate),
        ('velocityEstimate', _LCS_MOLRRes_velocityEstimate),
        ('referenceNumber', _LCS_MOLRRes_referenceNumber),
        ('h-gmlc-address', _LCS_MOLRRes_h_gmlc_address),
        ('mo-lrShortCircuit', _LCS_MOLRRes_mo_lrShortCircuit),
        ('reportingPLMNList', _LCS_MOLRRes_reportingPLMNList),
        ])
    LCS_MOLRRes._ext = ['add-LocationEstimate', 'velocityEstimate', 'referenceNumber', 'h-gmlc-address', 'mo-lrShortCircuit', 'reportingPLMNList']
    
    #-----< DecipheringKeys >-----#
    DecipheringKeys = OCT_STR(name='DecipheringKeys', mode=MODE_TYPE)
    DecipheringKeys._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    
    #-----< LCS-AreaEventRequestArg >-----#
    LCS_AreaEventRequestArg = SEQ(name='LCS-AreaEventRequestArg', mode=MODE_TYPE)
    _LCS_AreaEventRequestArg_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_AreaEventRequestArg_h_gmlc_address = OCT_STR(name='h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _LCS_AreaEventRequestArg_deferredLocationEventType = BIT_STR(name='deferredLocationEventType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'DeferredLocationEventType')))
    _LCS_AreaEventRequestArg_areaEventInfo = SEQ(name='areaEventInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaEventInfo')))
    LCS_AreaEventRequestArg._cont = ASN1Dict([
        ('referenceNumber', _LCS_AreaEventRequestArg_referenceNumber),
        ('h-gmlc-address', _LCS_AreaEventRequestArg_h_gmlc_address),
        ('deferredLocationEventType', _LCS_AreaEventRequestArg_deferredLocationEventType),
        ('areaEventInfo', _LCS_AreaEventRequestArg_areaEventInfo),
        ])
    LCS_AreaEventRequestArg._ext = []
    
    #-----< LCS-AreaEventReportArg >-----#
    LCS_AreaEventReportArg = SEQ(name='LCS-AreaEventReportArg', mode=MODE_TYPE)
    _LCS_AreaEventReportArg_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_AreaEventReportArg_h_gmlc_address = OCT_STR(name='h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    LCS_AreaEventReportArg._cont = ASN1Dict([
        ('referenceNumber', _LCS_AreaEventReportArg_referenceNumber),
        ('h-gmlc-address', _LCS_AreaEventReportArg_h_gmlc_address),
        ])
    LCS_AreaEventReportArg._ext = []
    
    #-----< LCS-AreaEventCancellationArg >-----#
    LCS_AreaEventCancellationArg = SEQ(name='LCS-AreaEventCancellationArg', mode=MODE_TYPE)
    _LCS_AreaEventCancellationArg_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_AreaEventCancellationArg_h_gmlc_address = OCT_STR(name='h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    LCS_AreaEventCancellationArg._cont = ASN1Dict([
        ('referenceNumber', _LCS_AreaEventCancellationArg_referenceNumber),
        ('h-gmlc-address', _LCS_AreaEventCancellationArg_h_gmlc_address),
        ])
    LCS_AreaEventCancellationArg._ext = []
    
    #-----< LCS-PeriodicLocationRequestArg >-----#
    LCS_PeriodicLocationRequestArg = SEQ(name='LCS-PeriodicLocationRequestArg', mode=MODE_TYPE)
    _LCS_PeriodicLocationRequestArg_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_PeriodicLocationRequestArg_periodicLDRInfo = SEQ(name='periodicLDRInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')))
    _LCS_PeriodicLocationRequestArg_lcsClientExternalID = SEQ(name='lcsClientExternalID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')))
    _LCS_PeriodicLocationRequestArg_qoS = SEQ(name='qoS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-QoS')), opt=True)
    _LCS_PeriodicLocationRequestArg_h_gmlc_address = OCT_STR(name='h-gmlc-address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _LCS_PeriodicLocationRequestArg_mo_lrShortCircuit = NULL(name='mo-lrShortCircuit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_PeriodicLocationRequestArg_reportingPLMNList = SEQ(name='reportingPLMNList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    LCS_PeriodicLocationRequestArg._cont = ASN1Dict([
        ('referenceNumber', _LCS_PeriodicLocationRequestArg_referenceNumber),
        ('periodicLDRInfo', _LCS_PeriodicLocationRequestArg_periodicLDRInfo),
        ('lcsClientExternalID', _LCS_PeriodicLocationRequestArg_lcsClientExternalID),
        ('qoS', _LCS_PeriodicLocationRequestArg_qoS),
        ('h-gmlc-address', _LCS_PeriodicLocationRequestArg_h_gmlc_address),
        ('mo-lrShortCircuit', _LCS_PeriodicLocationRequestArg_mo_lrShortCircuit),
        ('reportingPLMNList', _LCS_PeriodicLocationRequestArg_reportingPLMNList),
        ])
    LCS_PeriodicLocationRequestArg._ext = []
    
    #-----< LCS-PeriodicLocationRequestRes >-----#
    LCS_PeriodicLocationRequestRes = SEQ(name='LCS-PeriodicLocationRequestRes', mode=MODE_TYPE)
    _LCS_PeriodicLocationRequestRes_mo_lrShortCircuit = NULL(name='mo-lrShortCircuit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    LCS_PeriodicLocationRequestRes._cont = ASN1Dict([
        ('mo-lrShortCircuit', _LCS_PeriodicLocationRequestRes_mo_lrShortCircuit),
        ])
    LCS_PeriodicLocationRequestRes._ext = []
    
    #-----< LCS-LocationUpdateArg >-----#
    LCS_LocationUpdateArg = SEQ(name='LCS-LocationUpdateArg', mode=MODE_TYPE)
    _LCS_LocationUpdateArg_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _LCS_LocationUpdateArg_add_LocationEstimate = OCT_STR(name='add-LocationEstimate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _LCS_LocationUpdateArg_velocityEstimate = OCT_STR(name='velocityEstimate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _LCS_LocationUpdateArg_sequenceNumber = INT(name='sequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SequenceNumber')), opt=True)
    LCS_LocationUpdateArg._cont = ASN1Dict([
        ('referenceNumber', _LCS_LocationUpdateArg_referenceNumber),
        ('add-LocationEstimate', _LCS_LocationUpdateArg_add_LocationEstimate),
        ('velocityEstimate', _LCS_LocationUpdateArg_velocityEstimate),
        ('sequenceNumber', _LCS_LocationUpdateArg_sequenceNumber),
        ])
    LCS_LocationUpdateArg._ext = []
    
    #-----< LCS-LocationUpdateRes >-----#
    LCS_LocationUpdateRes = SEQ(name='LCS-LocationUpdateRes', mode=MODE_TYPE)
    _LCS_LocationUpdateRes_terminationCause = ENUM(name='terminationCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'TerminationCause')), opt=True)
    LCS_LocationUpdateRes._cont = ASN1Dict([
        ('terminationCause', _LCS_LocationUpdateRes_terminationCause),
        ])
    LCS_LocationUpdateRes._ext = []
    
    #-----< LCS-PeriodicLocationCancellationArg >-----#
    LCS_PeriodicLocationCancellationArg = SEQ(name='LCS-PeriodicLocationCancellationArg', mode=MODE_TYPE)
    _LCS_PeriodicLocationCancellationArg_referenceNumber = OCT_STR(name='referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_PeriodicLocationCancellationArg_h_gmlc_address = OCT_STR(name='h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    LCS_PeriodicLocationCancellationArg._cont = ASN1Dict([
        ('referenceNumber', _LCS_PeriodicLocationCancellationArg_referenceNumber),
        ('h-gmlc-address', _LCS_PeriodicLocationCancellationArg_h_gmlc_address),
        ])
    LCS_PeriodicLocationCancellationArg._ext = []
    
    _all_ = [
        SS_UserData,
        _NotifySS_Arg_ss_Code,
        _NotifySS_Arg_ss_Status,
        _NotifySS_Arg_ss_Notification,
        _NotifySS_Arg_callIsWaiting_Indicator,
        _NotifySS_Arg_callOnHold_Indicator,
        _NotifySS_Arg_mpty_Indicator,
        _NotifySS_Arg_cug_Index,
        _NotifySS_Arg_clirSuppressionRejected,
        _NotifySS_Arg_ect_Indicator,
        _NotifySS_Arg_nameIndicator,
        _NotifySS_Arg_ccbs_Feature,
        _NotifySS_Arg_alertingPattern,
        _NotifySS_Arg_multicall_Indicator,
        NotifySS_Arg,
        Multicall_Indicator,
        _ForwardChargeAdviceArg_ss_Code,
        _ForwardChargeAdviceArg_chargingInformation,
        ForwardChargeAdviceArg,
        SS_Notification,
        _ChargingInformation_e1,
        _ChargingInformation_e2,
        _ChargingInformation_e3,
        _ChargingInformation_e4,
        _ChargingInformation_e5,
        _ChargingInformation_e6,
        _ChargingInformation_e7,
        ChargingInformation,
        E1,
        max10TimesUnitsPerTime,
        E2,
        max10TimesTimeInterval,
        E3,
        max100TimesScalingFactor,
        E4,
        max10TimesIncrement,
        E5,
        max10TimesIncrementPerDataInterval,
        E6,
        maxNumberOfSegmentsPerDataInterval,
        E7,
        max10TimesInitialTime,
        CallOnHold_Indicator,
        _ForwardCUG_InfoArg_cug_Index,
        _ForwardCUG_InfoArg_suppressPrefCUG,
        _ForwardCUG_InfoArg_suppressOA,
        ForwardCUG_InfoArg,
        _ECT_Indicator_ect_CallState,
        _ECT_Indicator_rdn,
        ECT_Indicator,
        ECT_CallState,
        _NameIndicator_callingName,
        NameIndicator,
        _Name_namePresentationAllowed,
        _Name_presentationRestricted,
        _Name_nameUnavailable,
        _Name_namePresentationRestricted,
        Name,
        _NameSet_dataCodingScheme,
        _NameSet_lengthInCharacters,
        _NameSet_nameString,
        NameSet,
        _RDN_presentationAllowedAddress,
        _RDN_presentationRestricted,
        _RDN_numberNotAvailableDueToInterworking,
        _RDN_presentationRestrictedAddress,
        RDN,
        _RemotePartyNumber_partyNumber,
        _RemotePartyNumber_partyNumberSubaddress,
        RemotePartyNumber,
        AccessRegisterCCEntryArg,
        _CallDeflectionArg_deflectedToNumber,
        _CallDeflectionArg_deflectedToSubaddress,
        CallDeflectionArg,
        _UserUserServiceArg_uUS_Service,
        _UserUserServiceArg_uUS_Required,
        UserUserServiceArg,
        UUS_Service,
        _LocationNotificationArg_notificationType,
        _LocationNotificationArg_locationType,
        _LocationNotificationArg_lcsClientExternalID,
        _LocationNotificationArg_lcsClientName,
        _LocationNotificationArg_lcsRequestorID,
        _LocationNotificationArg_lcsCodeword,
        _LocationNotificationArg_lcsServiceTypeID,
        LocationNotificationArg,
        _LocationNotificationRes_verificationResponse,
        LocationNotificationRes,
        VerificationResponse,
        _LCS_MOLRArg_molr_Type,
        _LCS_MOLRArg_locationMethod,
        _LCS_MOLRArg_lcs_QoS,
        _LCS_MOLRArg_lcsClientExternalID,
        _LCS_MOLRArg_mlc_Number,
        _LCS_MOLRArg_gpsAssistanceData,
        _LCS_MOLRArg_supportedGADShapes,
        _LCS_MOLRArg_lcsServiceTypeID,
        _LCS_MOLRArg_ageOfLocationInfo,
        _LCS_MOLRArg_locationType,
        _LCS_MOLRArg_pseudonymIndicator,
        _LCS_MOLRArg_h_gmlc_address,
        _LCS_MOLRArg_locationEstimate,
        _LCS_MOLRArg_velocityEstimate,
        _LCS_MOLRArg_referenceNumber,
        _LCS_MOLRArg_periodicLDRInfo,
        _LCS_MOLRArg_locationUpdateRequest,
        _LCS_MOLRArg_sequenceNumber,
        _LCS_MOLRArg_terminationCause,
        _LCS_MOLRArg_mo_lrShortCircuit,
        _LCS_MOLRArg_ganssAssistanceData,
        _LCS_MOLRArg_multiplePositioningProtocolPDUs,
        LCS_MOLRArg,
        MOLR_Type,
        LocationMethod,
        GPSAssistanceData,
        GANSSAssistanceData,
        TerminationCause,
        _MultiplePositioningProtocolPDUs__item_,
        MultiplePositioningProtocolPDUs,
        PositioningProtocolPDU,
        maxNumLPPMsg,
        _LCS_MOLRRes_locationEstimate,
        _LCS_MOLRRes_decipheringKeys,
        _LCS_MOLRRes_add_LocationEstimate,
        _LCS_MOLRRes_velocityEstimate,
        _LCS_MOLRRes_referenceNumber,
        _LCS_MOLRRes_h_gmlc_address,
        _LCS_MOLRRes_mo_lrShortCircuit,
        _LCS_MOLRRes_reportingPLMNList,
        LCS_MOLRRes,
        DecipheringKeys,
        _LCS_AreaEventRequestArg_referenceNumber,
        _LCS_AreaEventRequestArg_h_gmlc_address,
        _LCS_AreaEventRequestArg_deferredLocationEventType,
        _LCS_AreaEventRequestArg_areaEventInfo,
        LCS_AreaEventRequestArg,
        _LCS_AreaEventReportArg_referenceNumber,
        _LCS_AreaEventReportArg_h_gmlc_address,
        LCS_AreaEventReportArg,
        _LCS_AreaEventCancellationArg_referenceNumber,
        _LCS_AreaEventCancellationArg_h_gmlc_address,
        LCS_AreaEventCancellationArg,
        _LCS_PeriodicLocationRequestArg_referenceNumber,
        _LCS_PeriodicLocationRequestArg_periodicLDRInfo,
        _LCS_PeriodicLocationRequestArg_lcsClientExternalID,
        _LCS_PeriodicLocationRequestArg_qoS,
        _LCS_PeriodicLocationRequestArg_h_gmlc_address,
        _LCS_PeriodicLocationRequestArg_mo_lrShortCircuit,
        _LCS_PeriodicLocationRequestArg_reportingPLMNList,
        LCS_PeriodicLocationRequestArg,
        _LCS_PeriodicLocationRequestRes_mo_lrShortCircuit,
        LCS_PeriodicLocationRequestRes,
        _LCS_LocationUpdateArg_referenceNumber,
        _LCS_LocationUpdateArg_add_LocationEstimate,
        _LCS_LocationUpdateArg_velocityEstimate,
        _LCS_LocationUpdateArg_sequenceNumber,
        LCS_LocationUpdateArg,
        _LCS_LocationUpdateRes_terminationCause,
        LCS_LocationUpdateRes,
        _LCS_PeriodicLocationCancellationArg_referenceNumber,
        _LCS_PeriodicLocationCancellationArg_h_gmlc_address,
        LCS_PeriodicLocationCancellationArg,
    ]

class TCAPMessages:

    _name_  = 'TCAPMessages'
    _oid_   = [0, 0, 17, 773, 2, 1, 3]
    
    _obj_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'Abort',
        'DialoguePortion',
        'OrigTransactionID',
        'DestTransactionID',
        'P-AbortCause',
        'ComponentPortion',
        'Component',
        'TCInvokeIdSet',
        ]
    _type_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'Abort',
        'DialoguePortion',
        'OrigTransactionID',
        'DestTransactionID',
        'P-AbortCause',
        'ComponentPortion',
        'Component',
        ]
    _set_ = [
        'TCInvokeIdSet',
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        'TCMessage',
        'Unidirectional',
        'Begin',
        'End',
        'Continue',
        'ComponentPortion',
        'Component',
        ]
    
    #-----< TCMessage >-----#
    TCMessage = CHOICE(name='TCMessage', mode=MODE_TYPE, param=True)
    
    #-----< Unidirectional >-----#
    Unidirectional = SEQ(name='Unidirectional', mode=MODE_TYPE, param=True)
    
    #-----< Begin >-----#
    Begin = SEQ(name='Begin', mode=MODE_TYPE, param=True)
    
    #-----< End >-----#
    End = SEQ(name='End', mode=MODE_TYPE, param=True)
    
    #-----< Continue >-----#
    Continue = SEQ(name='Continue', mode=MODE_TYPE, param=True)
    
    #-----< Abort >-----#
    Abort = SEQ(name='Abort', mode=MODE_TYPE)
    _Abort_dtid = OCT_STR(name='dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    _Abort_reason = CHOICE(name='reason', mode=MODE_TYPE, opt=True)
    __Abort_reason_p_abortCause = INT(name='p-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'P-AbortCause')))
    __Abort_reason_u_abortCause = EXT(name='u-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')))
    _Abort_reason._cont = ASN1Dict([
        ('p-abortCause', __Abort_reason_p_abortCause),
        ('u-abortCause', __Abort_reason_u_abortCause),
        ])
    _Abort_reason._ext = None
    Abort._cont = ASN1Dict([
        ('dtid', _Abort_dtid),
        ('reason', _Abort_reason),
        ])
    Abort._ext = None
    
    #-----< DialoguePortion >-----#
    DialoguePortion = EXT(name='DialoguePortion', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    
    #-----< OrigTransactionID >-----#
    OrigTransactionID = OCT_STR(name='OrigTransactionID', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    OrigTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DestTransactionID >-----#
    DestTransactionID = OCT_STR(name='DestTransactionID', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT))
    DestTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< P-AbortCause >-----#
    P_AbortCause = INT(name='P-AbortCause', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT))
    P_AbortCause._cont = ASN1Dict([('unrecognizedMessageType', 0), ('unrecognizedTransactionID', 1), ('badlyFormattedTransactionPortion', 2), ('incorrectTransactionPortion', 3), ('resourceLimitation', 4)])
    P_AbortCause._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ComponentPortion >-----#
    ComponentPortion = SEQ_OF(name='ComponentPortion', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Component >-----#
    Component = CHOICE(name='Component', mode=MODE_TYPE, param=True)
    
    #-----< TCInvokeIdSet >-----#
    TCInvokeIdSet = CHOICE(name='TCInvokeIdSet', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    TCInvokeIdSet._val = ASN1Set(rv=[('present', -128), ('present', -127), ('present', -126), ('present', -125), ('present', -124), ('present', -123), ('present', -122), ('present', -121), ('present', -120), ('present', -119), ('present', -118), ('present', -117), ('present', -116), ('present', -115), ('present', -114), ('present', -113), ('present', -112), ('present', -111), ('present', -110), ('present', -109), ('present', -108), ('present', -107), ('present', -106), ('present', -105), ('present', -104), ('present', -103), ('present', -102), ('present', -101), ('present', -100), ('present', -99), ('present', -98), ('present', -97), ('present', -96), ('present', -95), ('present', -94), ('present', -93), ('present', -92), ('present', -91), ('present', -90), ('present', -89), ('present', -88), ('present', -87), ('present', -86), ('present', -85), ('present', -84), ('present', -83), ('present', -82), ('present', -81), ('present', -80), ('present', -79), ('present', -78), ('present', -77), ('present', -76), ('present', -75), ('present', -74), ('present', -73), ('present', -72), ('present', -71), ('present', -70), ('present', -69), ('present', -68), ('present', -67), ('present', -66), ('present', -65), ('present', -64), ('present', -63), ('present', -62), ('present', -61), ('present', -60), ('present', -59), ('present', -58), ('present', -57), ('present', -56), ('present', -55), ('present', -54), ('present', -53), ('present', -52), ('present', -51), ('present', -50), ('present', -49), ('present', -48), ('present', -47), ('present', -46), ('present', -45), ('present', -44), ('present', -43), ('present', -42), ('present', -41), ('present', -40), ('present', -39), ('present', -38), ('present', -37), ('present', -36), ('present', -35), ('present', -34), ('present', -33), ('present', -32), ('present', -31), ('present', -30), ('present', -29), ('present', -28), ('present', -27), ('present', -26), ('present', -25), ('present', -24), ('present', -23), ('present', -22), ('present', -21), ('present', -20), ('present', -19), ('present', -18), ('present', -17), ('present', -16), ('present', -15), ('present', -14), ('present', -13), ('present', -12), ('present', -11), ('present', -10), ('present', -9), ('present', -8), ('present', -7), ('present', -6), ('present', -5), ('present', -4), ('present', -3), ('present', -2), ('present', -1), ('present', 0), ('present', 1), ('present', 2), ('present', 3), ('present', 4), ('present', 5), ('present', 6), ('present', 7), ('present', 8), ('present', 9), ('present', 10), ('present', 11), ('present', 12), ('present', 13), ('present', 14), ('present', 15), ('present', 16), ('present', 17), ('present', 18), ('present', 19), ('present', 20), ('present', 21), ('present', 22), ('present', 23), ('present', 24), ('present', 25), ('present', 26), ('present', 27), ('present', 28), ('present', 29), ('present', 30), ('present', 31), ('present', 32), ('present', 33), ('present', 34), ('present', 35), ('present', 36), ('present', 37), ('present', 38), ('present', 39), ('present', 40), ('present', 41), ('present', 42), ('present', 43), ('present', 44), ('present', 45), ('present', 46), ('present', 47), ('present', 48), ('present', 49), ('present', 50), ('present', 51), ('present', 52), ('present', 53), ('present', 54), ('present', 55), ('present', 56), ('present', 57), ('present', 58), ('present', 59), ('present', 60), ('present', 61), ('present', 62), ('present', 63), ('present', 64), ('present', 65), ('present', 66), ('present', 67), ('present', 68), ('present', 69), ('present', 70), ('present', 71), ('present', 72), ('present', 73), ('present', 74), ('present', 75), ('present', 76), ('present', 77), ('present', 78), ('present', 79), ('present', 80), ('present', 81), ('present', 82), ('present', 83), ('present', 84), ('present', 85), ('present', 86), ('present', 87), ('present', 88), ('present', 89), ('present', 90), ('present', 91), ('present', 92), ('present', 93), ('present', 94), ('present', 95), ('present', 96), ('present', 97), ('present', 98), ('present', 99), ('present', 100), ('present', 101), ('present', 102), ('present', 103), ('present', 104), ('present', 105), ('present', 106), ('present', 107), ('present', 108), ('present', 109), ('present', 110), ('present', 111), ('present', 112), ('present', 113), ('present', 114), ('present', 115), ('present', 116), ('present', 117), ('present', 118), ('present', 119), ('present', 120), ('present', 121), ('present', 122), ('present', 123), ('present', 124), ('present', 125), ('present', 126), ('present', 127)], rr=[], ev=None, er=[])
    
    _all_ = [
        _Abort_dtid,
        __Abort_reason_p_abortCause,
        __Abort_reason_u_abortCause,
        _Abort_reason,
        Abort,
        DialoguePortion,
        OrigTransactionID,
        DestTransactionID,
        P_AbortCause,
        TCInvokeIdSet,
    ]

class TC_Notation_Extensions:

    _name_  = 'TC-Notation-Extensions'
    _oid_   = [0, 0, 17, 775, 2, 4, 1]
    
    _obj_ = [
        'APPLICATION-CONTEXT',
        'DialogueMode',
        'Termination',
        'dialogue-abstract-syntax',
        'uniDialogue-abstract-syntax',
        'TCSingleAS',
        'TCConsumerAS',
        'TCSupplierAS',
        'ConnectionAS',
        ]
    _type_ = [
        'APPLICATION-CONTEXT',
        'DialogueMode',
        'Termination',
        'TCSingleAS',
        'TCConsumerAS',
        'TCSupplierAS',
        'ConnectionAS',
        ]
    _set_ = [
        ]
    _val_ = [
        'dialogue-abstract-syntax',
        'uniDialogue-abstract-syntax',
        ]
    _class_ = [
        'APPLICATION-CONTEXT',
        'dialogue-abstract-syntax',
        'uniDialogue-abstract-syntax',
        ]
    _param_ = [
        'TCSingleAS',
        'TCConsumerAS',
        'TCSupplierAS',
        'ConnectionAS',
        ]
    
    #-----< APPLICATION-CONTEXT >-----#
    APPLICATION_CONTEXT = CLASS(name='APPLICATION-CONTEXT', mode=MODE_TYPE)
    _APPLICATION_CONTEXT_associationContract = CLASS(name='associationContract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    _APPLICATION_CONTEXT_dialogueMode = ENUM(name='dialogueMode', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'DialogueMode')))
    _APPLICATION_CONTEXT_termination = ENUM(name='termination', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'Termination')), opt=True)
    _APPLICATION_CONTEXT_componentGrouping = BOOL(name='componentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_dialogueAndComponentGrouping = BOOL(name='dialogueAndComponentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_AdditionalASEs = OID(name='AdditionalASEs', mode=MODE_SET, opt=True)
    _APPLICATION_CONTEXT_AbstractSyntaxes = CLASS(name='AbstractSyntaxes', mode=MODE_SET, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _APPLICATION_CONTEXT_applicationContextName = OID(name='applicationContextName', mode=MODE_VALUE, uniq=True)
    APPLICATION_CONTEXT._cont = ASN1Dict([
        ('associationContract', _APPLICATION_CONTEXT_associationContract),
        ('dialogueMode', _APPLICATION_CONTEXT_dialogueMode),
        ('termination', _APPLICATION_CONTEXT_termination),
        ('componentGrouping', _APPLICATION_CONTEXT_componentGrouping),
        ('dialogueAndComponentGrouping', _APPLICATION_CONTEXT_dialogueAndComponentGrouping),
        ('AdditionalASEs', _APPLICATION_CONTEXT_AdditionalASEs),
        ('AbstractSyntaxes', _APPLICATION_CONTEXT_AbstractSyntaxes),
        ('applicationContextName', _APPLICATION_CONTEXT_applicationContextName),
        ])
    
    #-----< DialogueMode >-----#
    DialogueMode = ENUM(name='DialogueMode', mode=MODE_TYPE)
    DialogueMode._cont = ASN1Dict([('structured', 1), ('unstructured', 2)])
    DialogueMode._ext = None
    
    #-----< Termination >-----#
    Termination = ENUM(name='Termination', mode=MODE_TYPE)
    Termination._cont = ASN1Dict([('basic', 1), ('prearranged', 2)])
    Termination._ext = None
    
    #-----< dialogue-abstract-syntax >-----#
    dialogue_abstract_syntax = CLASS(name='dialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _dialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    dialogue_abstract_syntax._val = dict([('Type', _dialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 1, 1))])
    
    #-----< uniDialogue-abstract-syntax >-----#
    uniDialogue_abstract_syntax = CLASS(name='uniDialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', 'ABSTRACT-SYNTAX'), []))
    _uniDialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    uniDialogue_abstract_syntax._val = dict([('Type', _uniDialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 2, 1))])
    
    #-----< TCSingleAS >-----#
    TCSingleAS = CHOICE(name='TCSingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCConsumerAS >-----#
    TCConsumerAS = CHOICE(name='TCConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCSupplierAS >-----#
    TCSupplierAS = CHOICE(name='TCSupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< ConnectionAS >-----#
    ConnectionAS = CHOICE(name='ConnectionAS', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _APPLICATION_CONTEXT_associationContract,
        _APPLICATION_CONTEXT_dialogueMode,
        _APPLICATION_CONTEXT_termination,
        _APPLICATION_CONTEXT_componentGrouping,
        _APPLICATION_CONTEXT_dialogueAndComponentGrouping,
        _APPLICATION_CONTEXT_AdditionalASEs,
        _APPLICATION_CONTEXT_AbstractSyntaxes,
        _APPLICATION_CONTEXT_applicationContextName,
        APPLICATION_CONTEXT,
        DialogueMode,
        Termination,
        dialogue_abstract_syntax,
        _dialogue_abstract_syntax_val_Type,
        uniDialogue_abstract_syntax,
        _uniDialogue_abstract_syntax_val_Type,
    ]

class UnidialoguePDUs:

    _name_  = 'UnidialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 3, 1]
    
    _obj_ = [
        'uniDialogue-as-id',
        'UniDialoguePDU',
        'AUDT-apdu',
        ]
    _type_ = [
        'UniDialoguePDU',
        'AUDT-apdu',
        ]
    _set_ = [
        ]
    _val_ = [
        'uniDialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< uniDialogue-as-id >-----#
    uniDialogue_as_id = OID(name='uniDialogue-as-id', mode=MODE_VALUE)
    uniDialogue_as_id._val = (0, 0, 17, 773, 1, 2, 1)
    
    #-----< UniDialoguePDU >-----#
    UniDialoguePDU = CHOICE(name='UniDialoguePDU', mode=MODE_TYPE)
    _UniDialoguePDU_unidialoguePDU = SEQ(name='unidialoguePDU', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'AUDT-apdu')))
    UniDialoguePDU._cont = ASN1Dict([
        ('unidialoguePDU', _UniDialoguePDU_unidialoguePDU),
        ])
    UniDialoguePDU._ext = None
    
    #-----< AUDT-apdu >-----#
    AUDT_apdu = SEQ(name='AUDT-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AUDT_apdu_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AUDT_apdu_protocol_version._cont = ASN1Dict([('version1', 0)])
    _AUDT_apdu_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AUDT_apdu_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AUDT_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AUDT_apdu_user_information._cont = __AUDT_apdu_user_information__item_
    AUDT_apdu._cont = ASN1Dict([
        ('protocol-version', _AUDT_apdu_protocol_version),
        ('application-context-name', _AUDT_apdu_application_context_name),
        ('user-information', _AUDT_apdu_user_information),
        ])
    AUDT_apdu._ext = None
    
    _all_ = [
        uniDialogue_as_id,
        _UniDialoguePDU_unidialoguePDU,
        UniDialoguePDU,
        _AUDT_apdu_protocol_version,
        _AUDT_apdu_application_context_name,
        __AUDT_apdu_user_information__item_,
        _AUDT_apdu_user_information,
        AUDT_apdu,
    ]

class UsefulDefinitions:

    _name_  = 'UsefulDefinitions'
    _oid_   = [2, 5, 1, 0, 8]
    
    _obj_ = [
        'ID',
        'ds',
        'id',
        'internet',
        'ldap-dir',
        'intSecurity',
        'ldap-enterprise',
        'ldap-x509',
        'ldap-openLDAP',
        'openLDAP-attributes',
        'openLDAP-controls',
        'ldap-wall',
        'ldap-dynExt',
        'ldap-attr',
        'ldap-match',
        'ldap-syntax',
        'cosine',
        'cosineAttr',
        'module',
        'serviceElement',
        'applicationContext',
        'attributeType',
        'attributeSyntaxVendor',
        'objectClass',
        'algorithm',
        'abstractSyntax',
        'dsaOperationalAttribute',
        'matchingRule',
        'knowledgeMatchingRule',
        'nameForm',
        'group',
        'subentry',
        'operationalAttributeType',
        'operationalBinding',
        'schemaObjectClass',
        'schemaOperationalAttribute',
        'administrativeRoles',
        'accessControlAttribute',
        'accessControlSchemes',
        'certificateExtension',
        'managementObject',
        'attributeValueContext',
        'idmProtocol',
        'problem',
        'notification',
        'matchingRestriction',
        'controlAttributeType',
        'keyPurposes',
        'passwordQuality',
        'attributeSyntax',
        'avRestriction',
        'cmsContentType',
        'usefulDefinitions',
        'informationFramework',
        'directoryAbstractService',
        'distributedOperations',
        'selectedAttributeTypes',
        'selectedObjectClasses',
        'authenticationFramework',
        'algorithmObjectIdentifiers',
        'directoryObjectIdentifiers',
        'distributedDirectoryOIDs',
        'directoryShadowOIDs',
        'directoryShadowAbstractService',
        'opBindingManagement',
        'opBindingOIDs',
        'hierarchicalOperationalBindings',
        'dsaOperationalAttributeTypes',
        'schemaAdministration',
        'basicAccessControl',
        'directoryOperationalBindingTypes',
        'certificateExtensions',
        'directoryManagement',
        'enhancedSecurity',
        'iDMProtocolSpecification',
        'directoryIDMProtocols',
        'attributeCertificateDefinitions',
        'serviceAdministration',
        'ldapAttributes',
        'commonProtocolSpecification',
        'oSIProtocolSpecification',
        'directoryOSIProtocols',
        'ldapSystemSchema',
        'passwordPolicy',
        'pkiPmiExternalDataTypes',
        'extensionAttributes',
        'pkiPmiWrapper',
        'avlManagement',
        'trustBrokerProtocol',
        'id-oc',
        'id-at',
        'id-as',
        'id-mr',
        'id-nf',
        'id-sc',
        'id-oa',
        'id-ob',
        'id-doa',
        'id-kmr',
        'id-soc',
        'id-soa',
        'id-ar',
        'id-aca',
        'id-ac',
        'id-acScheme',
        'id-ce',
        'id-mgt',
        'id-avc',
        'id-idm',
        'id-pr',
        'id-not',
        'id-mre',
        'id-cat',
        'id-kp',
        'id-pq',
        'id-ats',
        'id-asx',
        'id-lsx',
        'id-ldx',
        'id-lat',
        'id-lmr',
        'id-oat',
        'id-coat',
        'id-avr',
        'id-cmsct',
        ]
    _type_ = [
        'ID',
        ]
    _set_ = [
        ]
    _val_ = [
        'ds',
        'id',
        'internet',
        'ldap-dir',
        'intSecurity',
        'ldap-enterprise',
        'ldap-x509',
        'ldap-openLDAP',
        'openLDAP-attributes',
        'openLDAP-controls',
        'ldap-wall',
        'ldap-dynExt',
        'ldap-attr',
        'ldap-match',
        'ldap-syntax',
        'cosine',
        'cosineAttr',
        'module',
        'serviceElement',
        'applicationContext',
        'attributeType',
        'attributeSyntaxVendor',
        'objectClass',
        'algorithm',
        'abstractSyntax',
        'dsaOperationalAttribute',
        'matchingRule',
        'knowledgeMatchingRule',
        'nameForm',
        'group',
        'subentry',
        'operationalAttributeType',
        'operationalBinding',
        'schemaObjectClass',
        'schemaOperationalAttribute',
        'administrativeRoles',
        'accessControlAttribute',
        'accessControlSchemes',
        'certificateExtension',
        'managementObject',
        'attributeValueContext',
        'idmProtocol',
        'problem',
        'notification',
        'matchingRestriction',
        'controlAttributeType',
        'keyPurposes',
        'passwordQuality',
        'attributeSyntax',
        'avRestriction',
        'cmsContentType',
        'usefulDefinitions',
        'informationFramework',
        'directoryAbstractService',
        'distributedOperations',
        'selectedAttributeTypes',
        'selectedObjectClasses',
        'authenticationFramework',
        'algorithmObjectIdentifiers',
        'directoryObjectIdentifiers',
        'distributedDirectoryOIDs',
        'directoryShadowOIDs',
        'directoryShadowAbstractService',
        'opBindingManagement',
        'opBindingOIDs',
        'hierarchicalOperationalBindings',
        'dsaOperationalAttributeTypes',
        'schemaAdministration',
        'basicAccessControl',
        'directoryOperationalBindingTypes',
        'certificateExtensions',
        'directoryManagement',
        'enhancedSecurity',
        'iDMProtocolSpecification',
        'directoryIDMProtocols',
        'attributeCertificateDefinitions',
        'serviceAdministration',
        'ldapAttributes',
        'commonProtocolSpecification',
        'oSIProtocolSpecification',
        'directoryOSIProtocols',
        'ldapSystemSchema',
        'passwordPolicy',
        'pkiPmiExternalDataTypes',
        'extensionAttributes',
        'pkiPmiWrapper',
        'avlManagement',
        'trustBrokerProtocol',
        'id-oc',
        'id-at',
        'id-as',
        'id-mr',
        'id-nf',
        'id-sc',
        'id-oa',
        'id-ob',
        'id-doa',
        'id-kmr',
        'id-soc',
        'id-soa',
        'id-ar',
        'id-aca',
        'id-ac',
        'id-acScheme',
        'id-ce',
        'id-mgt',
        'id-avc',
        'id-idm',
        'id-pr',
        'id-not',
        'id-mre',
        'id-cat',
        'id-kp',
        'id-pq',
        'id-ats',
        'id-asx',
        'id-lsx',
        'id-ldx',
        'id-lat',
        'id-lmr',
        'id-oat',
        'id-coat',
        'id-avr',
        'id-cmsct',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ID >-----#
    ID = OID(name='ID', mode=MODE_TYPE)
    
    #-----< ds >-----#
    ds = OID(name='ds', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ds._val = (2, 5)
    
    #-----< id >-----#
    id = OID(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id._val = (2, 17, 1, 2)
    
    #-----< internet >-----#
    internet = OID(name='internet', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    internet._val = (1, 3, 6, 1)
    
    #-----< ldap-dir >-----#
    ldap_dir = OID(name='ldap-dir', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_dir._val = (1, 3, 6, 1, 1)
    
    #-----< intSecurity >-----#
    intSecurity = OID(name='intSecurity', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    intSecurity._val = (1, 3, 6, 1, 5)
    
    #-----< ldap-enterprise >-----#
    ldap_enterprise = OID(name='ldap-enterprise', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_enterprise._val = (1, 3, 6, 1, 4, 1)
    
    #-----< ldap-x509 >-----#
    ldap_x509 = OID(name='ldap-x509', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_x509._val = (1, 3, 6, 1, 1, 15)
    
    #-----< ldap-openLDAP >-----#
    ldap_openLDAP = OID(name='ldap-openLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_openLDAP._val = (1, 3, 6, 1, 4, 1, 4203, 1)
    
    #-----< openLDAP-attributes >-----#
    openLDAP_attributes = OID(name='openLDAP-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    openLDAP_attributes._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3)
    
    #-----< openLDAP-controls >-----#
    openLDAP_controls = OID(name='openLDAP-controls', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    openLDAP_controls._val = (1, 3, 6, 1, 4, 1, 4203, 1, 10)
    
    #-----< ldap-wall >-----#
    ldap_wall = OID(name='ldap-wall', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_wall._val = (1, 3, 6, 1, 4, 1, 1466)
    
    #-----< ldap-dynExt >-----#
    ldap_dynExt = OID(name='ldap-dynExt', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_dynExt._val = (1, 3, 6, 1, 4, 1, 1466, 101, 119)
    
    #-----< ldap-attr >-----#
    ldap_attr = OID(name='ldap-attr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_attr._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120)
    
    #-----< ldap-match >-----#
    ldap_match = OID(name='ldap-match', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114)
    
    #-----< ldap-syntax >-----#
    ldap_syntax = OID(name='ldap-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_syntax._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1)
    
    #-----< cosine >-----#
    cosine = OID(name='cosine', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cosine._val = (0, 9, 2342, 19200300, 100)
    
    #-----< cosineAttr >-----#
    cosineAttr = OID(name='cosineAttr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cosineAttr._val = (0, 9, 2342, 19200300, 100, 1)
    
    #-----< module >-----#
    module = OID(name='module', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    module._val = (2, 5, 1)
    
    #-----< serviceElement >-----#
    serviceElement = OID(name='serviceElement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    serviceElement._val = (2, 5, 2)
    
    #-----< applicationContext >-----#
    applicationContext = OID(name='applicationContext', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    applicationContext._val = (2, 5, 3)
    
    #-----< attributeType >-----#
    attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeType._val = (2, 5, 4)
    
    #-----< attributeSyntaxVendor >-----#
    attributeSyntaxVendor = OID(name='attributeSyntaxVendor', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeSyntaxVendor._val = (2, 5, 5)
    
    #-----< objectClass >-----#
    objectClass = OID(name='objectClass', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    objectClass._val = (2, 5, 6)
    
    #-----< algorithm >-----#
    algorithm = OID(name='algorithm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    algorithm._val = (2, 5, 8)
    
    #-----< abstractSyntax >-----#
    abstractSyntax = OID(name='abstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    abstractSyntax._val = (2, 5, 9)
    
    #-----< dsaOperationalAttribute >-----#
    dsaOperationalAttribute = OID(name='dsaOperationalAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    dsaOperationalAttribute._val = (2, 5, 12)
    
    #-----< matchingRule >-----#
    matchingRule = OID(name='matchingRule', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    matchingRule._val = (2, 5, 13)
    
    #-----< knowledgeMatchingRule >-----#
    knowledgeMatchingRule = OID(name='knowledgeMatchingRule', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    knowledgeMatchingRule._val = (2, 5, 14)
    
    #-----< nameForm >-----#
    nameForm = OID(name='nameForm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    nameForm._val = (2, 5, 15)
    
    #-----< group >-----#
    group = OID(name='group', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    group._val = (2, 5, 16)
    
    #-----< subentry >-----#
    subentry = OID(name='subentry', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    subentry._val = (2, 5, 17)
    
    #-----< operationalAttributeType >-----#
    operationalAttributeType = OID(name='operationalAttributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    operationalAttributeType._val = (2, 5, 18)
    
    #-----< operationalBinding >-----#
    operationalBinding = OID(name='operationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    operationalBinding._val = (2, 5, 19)
    
    #-----< schemaObjectClass >-----#
    schemaObjectClass = OID(name='schemaObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaObjectClass._val = (2, 5, 20)
    
    #-----< schemaOperationalAttribute >-----#
    schemaOperationalAttribute = OID(name='schemaOperationalAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaOperationalAttribute._val = (2, 5, 21)
    
    #-----< administrativeRoles >-----#
    administrativeRoles = OID(name='administrativeRoles', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    administrativeRoles._val = (2, 5, 23)
    
    #-----< accessControlAttribute >-----#
    accessControlAttribute = OID(name='accessControlAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    accessControlAttribute._val = (2, 5, 24)
    
    #-----< accessControlSchemes >-----#
    accessControlSchemes = OID(name='accessControlSchemes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    accessControlSchemes._val = (2, 5, 28)
    
    #-----< certificateExtension >-----#
    certificateExtension = OID(name='certificateExtension', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    certificateExtension._val = (2, 5, 29)
    
    #-----< managementObject >-----#
    managementObject = OID(name='managementObject', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    managementObject._val = (2, 5, 30)
    
    #-----< attributeValueContext >-----#
    attributeValueContext = OID(name='attributeValueContext', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeValueContext._val = (2, 5, 31)
    
    #-----< idmProtocol >-----#
    idmProtocol = OID(name='idmProtocol', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    idmProtocol._val = (2, 5, 33)
    
    #-----< problem >-----#
    problem = OID(name='problem', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    problem._val = (2, 5, 34)
    
    #-----< notification >-----#
    notification = OID(name='notification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    notification._val = (2, 5, 35)
    
    #-----< matchingRestriction >-----#
    matchingRestriction = OID(name='matchingRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    matchingRestriction._val = (2, 5, 36)
    
    #-----< controlAttributeType >-----#
    controlAttributeType = OID(name='controlAttributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    controlAttributeType._val = (2, 5, 37)
    
    #-----< keyPurposes >-----#
    keyPurposes = OID(name='keyPurposes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    keyPurposes._val = (2, 5, 38)
    
    #-----< passwordQuality >-----#
    passwordQuality = OID(name='passwordQuality', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    passwordQuality._val = (2, 5, 39)
    
    #-----< attributeSyntax >-----#
    attributeSyntax = OID(name='attributeSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeSyntax._val = (2, 5, 40)
    
    #-----< avRestriction >-----#
    avRestriction = OID(name='avRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    avRestriction._val = (2, 5, 41)
    
    #-----< cmsContentType >-----#
    cmsContentType = OID(name='cmsContentType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cmsContentType._val = (2, 5, 42)
    
    #-----< usefulDefinitions >-----#
    usefulDefinitions = OID(name='usefulDefinitions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    usefulDefinitions._val = (2, 5, 1, 0, 8)
    
    #-----< informationFramework >-----#
    informationFramework = OID(name='informationFramework', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    informationFramework._val = (2, 5, 1, 1, 8)
    
    #-----< directoryAbstractService >-----#
    directoryAbstractService = OID(name='directoryAbstractService', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryAbstractService._val = (2, 5, 1, 2, 8)
    
    #-----< distributedOperations >-----#
    distributedOperations = OID(name='distributedOperations', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    distributedOperations._val = (2, 5, 1, 3, 8)
    
    #-----< selectedAttributeTypes >-----#
    selectedAttributeTypes = OID(name='selectedAttributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    selectedAttributeTypes._val = (2, 5, 1, 5, 8)
    
    #-----< selectedObjectClasses >-----#
    selectedObjectClasses = OID(name='selectedObjectClasses', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    selectedObjectClasses._val = (2, 5, 1, 6, 8)
    
    #-----< authenticationFramework >-----#
    authenticationFramework = OID(name='authenticationFramework', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    authenticationFramework._val = (2, 5, 1, 7, 8)
    
    #-----< algorithmObjectIdentifiers >-----#
    algorithmObjectIdentifiers = OID(name='algorithmObjectIdentifiers', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    algorithmObjectIdentifiers._val = (2, 5, 1, 8, 8)
    
    #-----< directoryObjectIdentifiers >-----#
    directoryObjectIdentifiers = OID(name='directoryObjectIdentifiers', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryObjectIdentifiers._val = (2, 5, 1, 9, 8)
    
    #-----< distributedDirectoryOIDs >-----#
    distributedDirectoryOIDs = OID(name='distributedDirectoryOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    distributedDirectoryOIDs._val = (2, 5, 1, 13, 8)
    
    #-----< directoryShadowOIDs >-----#
    directoryShadowOIDs = OID(name='directoryShadowOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryShadowOIDs._val = (2, 5, 1, 14, 8)
    
    #-----< directoryShadowAbstractService >-----#
    directoryShadowAbstractService = OID(name='directoryShadowAbstractService', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryShadowAbstractService._val = (2, 5, 1, 15, 8)
    
    #-----< opBindingManagement >-----#
    opBindingManagement = OID(name='opBindingManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    opBindingManagement._val = (2, 5, 1, 18, 8)
    
    #-----< opBindingOIDs >-----#
    opBindingOIDs = OID(name='opBindingOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    opBindingOIDs._val = (2, 5, 1, 19, 8)
    
    #-----< hierarchicalOperationalBindings >-----#
    hierarchicalOperationalBindings = OID(name='hierarchicalOperationalBindings', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    hierarchicalOperationalBindings._val = (2, 5, 1, 20, 8)
    
    #-----< dsaOperationalAttributeTypes >-----#
    dsaOperationalAttributeTypes = OID(name='dsaOperationalAttributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    dsaOperationalAttributeTypes._val = (2, 5, 1, 22, 8)
    
    #-----< schemaAdministration >-----#
    schemaAdministration = OID(name='schemaAdministration', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaAdministration._val = (2, 5, 1, 23, 8)
    
    #-----< basicAccessControl >-----#
    basicAccessControl = OID(name='basicAccessControl', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    basicAccessControl._val = (2, 5, 1, 24, 8)
    
    #-----< directoryOperationalBindingTypes >-----#
    directoryOperationalBindingTypes = OID(name='directoryOperationalBindingTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryOperationalBindingTypes._val = (2, 5, 1, 25, 8)
    
    #-----< certificateExtensions >-----#
    certificateExtensions = OID(name='certificateExtensions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    certificateExtensions._val = (2, 5, 1, 26, 8)
    
    #-----< directoryManagement >-----#
    directoryManagement = OID(name='directoryManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryManagement._val = (2, 5, 1, 27, 8)
    
    #-----< enhancedSecurity >-----#
    enhancedSecurity = OID(name='enhancedSecurity', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    enhancedSecurity._val = (2, 5, 1, 28, 8)
    
    #-----< iDMProtocolSpecification >-----#
    iDMProtocolSpecification = OID(name='iDMProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    iDMProtocolSpecification._val = (2, 5, 1, 30, 8)
    
    #-----< directoryIDMProtocols >-----#
    directoryIDMProtocols = OID(name='directoryIDMProtocols', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryIDMProtocols._val = (2, 5, 1, 31, 8)
    
    #-----< attributeCertificateDefinitions >-----#
    attributeCertificateDefinitions = OID(name='attributeCertificateDefinitions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeCertificateDefinitions._val = (2, 5, 1, 32, 8)
    
    #-----< serviceAdministration >-----#
    serviceAdministration = OID(name='serviceAdministration', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    serviceAdministration._val = (2, 5, 1, 33, 8)
    
    #-----< ldapAttributes >-----#
    ldapAttributes = OID(name='ldapAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldapAttributes._val = (2, 5, 1, 34, 8)
    
    #-----< commonProtocolSpecification >-----#
    commonProtocolSpecification = OID(name='commonProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    commonProtocolSpecification._val = (2, 5, 1, 35, 8)
    
    #-----< oSIProtocolSpecification >-----#
    oSIProtocolSpecification = OID(name='oSIProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    oSIProtocolSpecification._val = (2, 5, 1, 36, 8)
    
    #-----< directoryOSIProtocols >-----#
    directoryOSIProtocols = OID(name='directoryOSIProtocols', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryOSIProtocols._val = (2, 5, 1, 37, 8)
    
    #-----< ldapSystemSchema >-----#
    ldapSystemSchema = OID(name='ldapSystemSchema', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldapSystemSchema._val = (2, 5, 1, 38, 8)
    
    #-----< passwordPolicy >-----#
    passwordPolicy = OID(name='passwordPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    passwordPolicy._val = (2, 5, 1, 39, 8)
    
    #-----< pkiPmiExternalDataTypes >-----#
    pkiPmiExternalDataTypes = OID(name='pkiPmiExternalDataTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    pkiPmiExternalDataTypes._val = (2, 5, 1, 40, 8)
    
    #-----< extensionAttributes >-----#
    extensionAttributes = OID(name='extensionAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    extensionAttributes._val = (2, 5, 1, 41, 8)
    
    #-----< pkiPmiWrapper >-----#
    pkiPmiWrapper = OID(name='pkiPmiWrapper', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    pkiPmiWrapper._val = (2, 5, 1, 42, 8)
    
    #-----< avlManagement >-----#
    avlManagement = OID(name='avlManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    avlManagement._val = (2, 5, 1, 43, 8)
    
    #-----< trustBrokerProtocol >-----#
    trustBrokerProtocol = OID(name='trustBrokerProtocol', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    trustBrokerProtocol._val = (2, 5, 1, 44, 8)
    
    #-----< id-oc >-----#
    id_oc = OID(name='id-oc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oc._val = (2, 5, 6)
    
    #-----< id-at >-----#
    id_at = OID(name='id-at', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_at._val = (2, 5, 4)
    
    #-----< id-as >-----#
    id_as = OID(name='id-as', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_as._val = (2, 5, 9)
    
    #-----< id-mr >-----#
    id_mr = OID(name='id-mr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mr._val = (2, 5, 13)
    
    #-----< id-nf >-----#
    id_nf = OID(name='id-nf', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_nf._val = (2, 5, 15)
    
    #-----< id-sc >-----#
    id_sc = OID(name='id-sc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_sc._val = (2, 5, 17)
    
    #-----< id-oa >-----#
    id_oa = OID(name='id-oa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oa._val = (2, 5, 18)
    
    #-----< id-ob >-----#
    id_ob = OID(name='id-ob', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ob._val = (2, 5, 19)
    
    #-----< id-doa >-----#
    id_doa = OID(name='id-doa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_doa._val = (2, 5, 12)
    
    #-----< id-kmr >-----#
    id_kmr = OID(name='id-kmr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_kmr._val = (2, 5, 14)
    
    #-----< id-soc >-----#
    id_soc = OID(name='id-soc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_soc._val = (2, 5, 20)
    
    #-----< id-soa >-----#
    id_soa = OID(name='id-soa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_soa._val = (2, 5, 21)
    
    #-----< id-ar >-----#
    id_ar = OID(name='id-ar', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ar._val = (2, 5, 23)
    
    #-----< id-aca >-----#
    id_aca = OID(name='id-aca', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_aca._val = (2, 5, 24)
    
    #-----< id-ac >-----#
    id_ac = OID(name='id-ac', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ac._val = (2, 5, 3)
    
    #-----< id-acScheme >-----#
    id_acScheme = OID(name='id-acScheme', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_acScheme._val = (2, 5, 28)
    
    #-----< id-ce >-----#
    id_ce = OID(name='id-ce', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ce._val = (2, 5, 29)
    
    #-----< id-mgt >-----#
    id_mgt = OID(name='id-mgt', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mgt._val = (2, 5, 30)
    
    #-----< id-avc >-----#
    id_avc = OID(name='id-avc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_avc._val = (2, 5, 31)
    
    #-----< id-idm >-----#
    id_idm = OID(name='id-idm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_idm._val = (2, 5, 33)
    
    #-----< id-pr >-----#
    id_pr = OID(name='id-pr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_pr._val = (2, 5, 34)
    
    #-----< id-not >-----#
    id_not = OID(name='id-not', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_not._val = (2, 5, 35)
    
    #-----< id-mre >-----#
    id_mre = OID(name='id-mre', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mre._val = (2, 5, 36)
    
    #-----< id-cat >-----#
    id_cat = OID(name='id-cat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_cat._val = (2, 5, 37)
    
    #-----< id-kp >-----#
    id_kp = OID(name='id-kp', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_kp._val = (2, 5, 38)
    
    #-----< id-pq >-----#
    id_pq = OID(name='id-pq', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_pq._val = (2, 5, 39)
    
    #-----< id-ats >-----#
    id_ats = OID(name='id-ats', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ats._val = (2, 5, 40)
    
    #-----< id-asx >-----#
    id_asx = OID(name='id-asx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_asx._val = (2, 5, 40)
    
    #-----< id-lsx >-----#
    id_lsx = OID(name='id-lsx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lsx._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1)
    
    #-----< id-ldx >-----#
    id_ldx = OID(name='id-ldx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ldx._val = (1, 3, 6, 1, 1, 15)
    
    #-----< id-lat >-----#
    id_lat = OID(name='id-lat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lat._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120)
    
    #-----< id-lmr >-----#
    id_lmr = OID(name='id-lmr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lmr._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114)
    
    #-----< id-oat >-----#
    id_oat = OID(name='id-oat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oat._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3)
    
    #-----< id-coat >-----#
    id_coat = OID(name='id-coat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_coat._val = (0, 9, 2342, 19200300, 100, 1)
    
    #-----< id-avr >-----#
    id_avr = OID(name='id-avr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_avr._val = (2, 5, 41)
    
    #-----< id-cmsct >-----#
    id_cmsct = OID(name='id-cmsct', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_cmsct._val = (2, 5, 42)
    
    _all_ = [
        ID,
        ds,
        id,
        internet,
        ldap_dir,
        intSecurity,
        ldap_enterprise,
        ldap_x509,
        ldap_openLDAP,
        openLDAP_attributes,
        openLDAP_controls,
        ldap_wall,
        ldap_dynExt,
        ldap_attr,
        ldap_match,
        ldap_syntax,
        cosine,
        cosineAttr,
        module,
        serviceElement,
        applicationContext,
        attributeType,
        attributeSyntaxVendor,
        objectClass,
        algorithm,
        abstractSyntax,
        dsaOperationalAttribute,
        matchingRule,
        knowledgeMatchingRule,
        nameForm,
        group,
        subentry,
        operationalAttributeType,
        operationalBinding,
        schemaObjectClass,
        schemaOperationalAttribute,
        administrativeRoles,
        accessControlAttribute,
        accessControlSchemes,
        certificateExtension,
        managementObject,
        attributeValueContext,
        idmProtocol,
        problem,
        notification,
        matchingRestriction,
        controlAttributeType,
        keyPurposes,
        passwordQuality,
        attributeSyntax,
        avRestriction,
        cmsContentType,
        usefulDefinitions,
        informationFramework,
        directoryAbstractService,
        distributedOperations,
        selectedAttributeTypes,
        selectedObjectClasses,
        authenticationFramework,
        algorithmObjectIdentifiers,
        directoryObjectIdentifiers,
        distributedDirectoryOIDs,
        directoryShadowOIDs,
        directoryShadowAbstractService,
        opBindingManagement,
        opBindingOIDs,
        hierarchicalOperationalBindings,
        dsaOperationalAttributeTypes,
        schemaAdministration,
        basicAccessControl,
        directoryOperationalBindingTypes,
        certificateExtensions,
        directoryManagement,
        enhancedSecurity,
        iDMProtocolSpecification,
        directoryIDMProtocols,
        attributeCertificateDefinitions,
        serviceAdministration,
        ldapAttributes,
        commonProtocolSpecification,
        oSIProtocolSpecification,
        directoryOSIProtocols,
        ldapSystemSchema,
        passwordPolicy,
        pkiPmiExternalDataTypes,
        extensionAttributes,
        pkiPmiWrapper,
        avlManagement,
        trustBrokerProtocol,
        id_oc,
        id_at,
        id_as,
        id_mr,
        id_nf,
        id_sc,
        id_oa,
        id_ob,
        id_doa,
        id_kmr,
        id_soc,
        id_soa,
        id_ar,
        id_aca,
        id_ac,
        id_acScheme,
        id_ce,
        id_mgt,
        id_avc,
        id_idm,
        id_pr,
        id_not,
        id_mre,
        id_cat,
        id_kp,
        id_pq,
        id_ats,
        id_asx,
        id_lsx,
        id_ldx,
        id_lat,
        id_lmr,
        id_oat,
        id_coat,
        id_avr,
        id_cmsct,
    ]

class _IMPL_:

    _name_ = '_IMPL_'
    _oid_  = []
    _obj_  = ['REAL', 'EXTERNAL', 'EMBEDDED PDV', 'CHARACTER STRING', 'TYPE-IDENTIFIER', 'ABSTRACT-SYNTAX']
    
    #-----< REAL >-----#
    REAL = SEQ(name='REAL', mode=MODE_TYPE)
    _REAL_mantissa = INT(name='mantissa', mode=MODE_TYPE)
    _REAL_base = INT(name='base', mode=MODE_TYPE)
    _REAL_base._const_val = ASN1Set(rv=[2, 10], rr=[], ev=None, er=[])
    _REAL_exponent = INT(name='exponent', mode=MODE_TYPE)
    REAL._cont = ASN1Dict([
        ('mantissa', _REAL_mantissa),
        ('base', _REAL_base),
        ('exponent', _REAL_exponent),
        ])
    REAL._ext = None
    
    #-----< EXTERNAL >-----#
    EXTERNAL = SEQ(name='EXTERNAL', mode=MODE_TYPE)
    _EXTERNAL_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EXTERNAL_identification_syntaxes_abstract),
        ('transfer', ___EXTERNAL_identification_syntaxes_transfer),
        ])
    __EXTERNAL_identification_syntaxes._ext = None
    __EXTERNAL_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EXTERNAL_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EXTERNAL_identification_context_negotiation_transfer_syntax),
        ])
    __EXTERNAL_identification_context_negotiation._ext = None
    __EXTERNAL_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EXTERNAL_identification._cont = ASN1Dict([
        ('syntaxes', __EXTERNAL_identification_syntaxes),
        ('syntax', __EXTERNAL_identification_syntax),
        ('presentation-context-id', __EXTERNAL_identification_presentation_context_id),
        ('context-negotiation', __EXTERNAL_identification_context_negotiation),
        ('transfer-syntax', __EXTERNAL_identification_transfer_syntax),
        ('fixed', __EXTERNAL_identification_fixed),
        ])
    _EXTERNAL_identification._ext = None
    _EXTERNAL_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EXTERNAL_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EXTERNAL._cont = ASN1Dict([
        ('identification', _EXTERNAL_identification),
        ('data-value-descriptor', _EXTERNAL_data_value_descriptor),
        ('data-value', _EXTERNAL_data_value),
        ])
    EXTERNAL._ext = None
    
    #-----< EMBEDDED PDV >-----#
    EMBEDDED_PDV = SEQ(name='EMBEDDED PDV', mode=MODE_TYPE)
    _EMBEDDED_PDV_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EMBEDDED_PDV_identification_syntaxes_abstract),
        ('transfer', ___EMBEDDED_PDV_identification_syntaxes_transfer),
        ])
    __EMBEDDED_PDV_identification_syntaxes._ext = None
    __EMBEDDED_PDV_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax),
        ])
    __EMBEDDED_PDV_identification_context_negotiation._ext = None
    __EMBEDDED_PDV_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EMBEDDED_PDV_identification._cont = ASN1Dict([
        ('syntaxes', __EMBEDDED_PDV_identification_syntaxes),
        ('syntax', __EMBEDDED_PDV_identification_syntax),
        ('presentation-context-id', __EMBEDDED_PDV_identification_presentation_context_id),
        ('context-negotiation', __EMBEDDED_PDV_identification_context_negotiation),
        ('transfer-syntax', __EMBEDDED_PDV_identification_transfer_syntax),
        ('fixed', __EMBEDDED_PDV_identification_fixed),
        ])
    _EMBEDDED_PDV_identification._ext = None
    _EMBEDDED_PDV_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EMBEDDED_PDV_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EMBEDDED_PDV._cont = ASN1Dict([
        ('identification', _EMBEDDED_PDV_identification),
        ('data-value-descriptor', _EMBEDDED_PDV_data_value_descriptor),
        ('data-value', _EMBEDDED_PDV_data_value),
        ])
    EMBEDDED_PDV._ext = None
    
    #-----< CHARACTER STRING >-----#
    CHARACTER_STRING = SEQ(name='CHARACTER STRING', mode=MODE_TYPE)
    _CHARACTER_STRING_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___CHARACTER_STRING_identification_syntaxes_abstract),
        ('transfer', ___CHARACTER_STRING_identification_syntaxes_transfer),
        ])
    __CHARACTER_STRING_identification_syntaxes._ext = None
    __CHARACTER_STRING_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax),
        ])
    __CHARACTER_STRING_identification_context_negotiation._ext = None
    __CHARACTER_STRING_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CHARACTER_STRING_identification._cont = ASN1Dict([
        ('syntaxes', __CHARACTER_STRING_identification_syntaxes),
        ('syntax', __CHARACTER_STRING_identification_syntax),
        ('presentation-context-id', __CHARACTER_STRING_identification_presentation_context_id),
        ('context-negotiation', __CHARACTER_STRING_identification_context_negotiation),
        ('transfer-syntax', __CHARACTER_STRING_identification_transfer_syntax),
        ('fixed', __CHARACTER_STRING_identification_fixed),
        ])
    _CHARACTER_STRING_identification._ext = None
    _CHARACTER_STRING_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CHARACTER_STRING_string_value = OCT_STR(name='string-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    CHARACTER_STRING._cont = ASN1Dict([
        ('identification', _CHARACTER_STRING_identification),
        ('data-value-descriptor', _CHARACTER_STRING_data_value_descriptor),
        ('string-value', _CHARACTER_STRING_string_value),
        ])
    CHARACTER_STRING._ext = None
    
    #-----< TYPE-IDENTIFIER >-----#
    TYPE_IDENTIFIER = CLASS(name='TYPE-IDENTIFIER', mode=MODE_TYPE)
    _TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _TYPE_IDENTIFIER_Type = OPEN(name='Type', mode=MODE_TYPE)
    TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _TYPE_IDENTIFIER_id),
        ('Type', _TYPE_IDENTIFIER_Type),
        ])
    
    #-----< ABSTRACT-SYNTAX >-----#
    ABSTRACT_SYNTAX = CLASS(name='ABSTRACT-SYNTAX', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_id = OID(name='id', mode=MODE_VALUE)
    _ABSTRACT_SYNTAX_Type = OPEN(name='Type', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_property = BIT_STR(name='property', mode=MODE_VALUE, default=(0, 0))
    _ABSTRACT_SYNTAX_property._cont = ASN1Dict([('handles-invalid-encodings', 0)])
    ABSTRACT_SYNTAX._cont = ASN1Dict([
        ('id', _ABSTRACT_SYNTAX_id),
        ('Type', _ABSTRACT_SYNTAX_Type),
        ('property', _ABSTRACT_SYNTAX_property),
        ])
    
    _all_ = [
        _REAL_mantissa,
        _REAL_base,
        _REAL_exponent,
        REAL,
        ___EXTERNAL_identification_syntaxes_abstract,
        ___EXTERNAL_identification_syntaxes_transfer,
        __EXTERNAL_identification_syntaxes,
        __EXTERNAL_identification_syntax,
        __EXTERNAL_identification_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_transfer_syntax,
        __EXTERNAL_identification_context_negotiation,
        __EXTERNAL_identification_transfer_syntax,
        __EXTERNAL_identification_fixed,
        _EXTERNAL_identification,
        _EXTERNAL_data_value_descriptor,
        _EXTERNAL_data_value,
        EXTERNAL,
        ___EMBEDDED_PDV_identification_syntaxes_abstract,
        ___EMBEDDED_PDV_identification_syntaxes_transfer,
        __EMBEDDED_PDV_identification_syntaxes,
        __EMBEDDED_PDV_identification_syntax,
        __EMBEDDED_PDV_identification_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax,
        __EMBEDDED_PDV_identification_context_negotiation,
        __EMBEDDED_PDV_identification_transfer_syntax,
        __EMBEDDED_PDV_identification_fixed,
        _EMBEDDED_PDV_identification,
        _EMBEDDED_PDV_data_value_descriptor,
        _EMBEDDED_PDV_data_value,
        EMBEDDED_PDV,
        ___CHARACTER_STRING_identification_syntaxes_abstract,
        ___CHARACTER_STRING_identification_syntaxes_transfer,
        __CHARACTER_STRING_identification_syntaxes,
        __CHARACTER_STRING_identification_syntax,
        __CHARACTER_STRING_identification_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax,
        __CHARACTER_STRING_identification_context_negotiation,
        __CHARACTER_STRING_identification_transfer_syntax,
        __CHARACTER_STRING_identification_fixed,
        _CHARACTER_STRING_identification,
        _CHARACTER_STRING_data_value_descriptor,
        _CHARACTER_STRING_string_value,
        CHARACTER_STRING,
        _TYPE_IDENTIFIER_id,
        _TYPE_IDENTIFIER_Type,
        TYPE_IDENTIFIER,
        _ABSTRACT_SYNTAX_id,
        _ABSTRACT_SYNTAX_Type,
        _ABSTRACT_SYNTAX_property,
        ABSTRACT_SYNTAX,
    ]

init_modules(ACSE_1, Attribute_ASN1Module, AttributeCertificateDefinitions, AuthenticationFramework, BasicAccessControl, Basic_Service_Elements, CAP_classes, CAP_datatypes, CAP_errorcodes, CAP_errortypes, CAP_gprsSSF_gsmSCF_ops_args, CAP_gprsSSF_gsmSCF_pkgs_contracts_acs, CAP_gsmSCF_gsmSRF_ops_args, CAP_gsmSCF_gsmSRF_pkgs_contracts_acs, CAP_gsmSSF_gsmSCF_ops_args, CAP_gsmSSF_gsmSCF_pkgs_contracts_acs, CAP_object_identifiers, CAP_operationcodes, CAP_SMS_ops_args, CAP_smsSSF_gsmSCF_pkgs_contracts_acs, CertificateExtensions, CMIP_1, CommonProtocolSpecification, CPDTChargingDataTypes, CS1_DataTypes, CS2_datatypes, CSChargingDataTypes, DialoguePDUs, DirectoryAbstractService, DirectoryOperationalBindingTypes, DirectoryOSIProtocols, DirectoryShadowAbstractService, DistributedOperations, DSAOperationalAttributeTypes, EnhancedSecurity, GenericChargingDataTypes, GPRSChargingDataTypes, HierarchicalOperationalBindings, IMSChargingDataTypes, InformationFramework, LCSChargingDataTypes, LdapSystemSchema, Lightweight_Directory_Access_Protocol_V3, MAP_BS_Code, MAP_CH_DataTypes, MAP_CommonDataTypes, MAP_ER_DataTypes, MAP_ExtensionDataTypes, MAP_LCS_DataTypes, MAP_MS_DataTypes, MAP_OM_DataTypes, MAP_SM_DataTypes, MAP_SS_Code, MAP_SS_DataTypes, MAP_TS_Code, MBMSChargingDataTypes, MMSChargingDataTypes, MMTelChargingDataTypes, MONTEChargingDataTypes, OperationalBindingManagement, OSIProtocolSpecification, PasswordPolicy, PkiPmiExternalDataTypes, POCChargingDataTypes, ProSeChargingDataTypes, Remote_Operations_Generic_ROS_PDUs, Remote_Operations_Information_Objects, Remote_Operations_Useful_Definitions, SchemaAdministration, SelectedAttributeTypes, ServiceAdministration, SMSChargingDataTypes, SpkmGssTokens, SS_DataTypes, TCAPMessages, TC_Notation_Extensions, UnidialoguePDUs, UsefulDefinitions, _IMPL_)
